#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 23432
#define LARGE_STATE_COUNT 2760
#define SYMBOL_COUNT 456
#define ALIAS_COUNT 13
#define TOKEN_COUNT 124
#define EXTERNAL_TOKEN_COUNT 23
#define FIELD_COUNT 24
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 107

enum ts_symbol_identifiers {
  sym__varid = 1,
  anon_sym_SEMI = 2,
  sym_float = 3,
  sym_char = 4,
  sym_string = 5,
  sym__integer_literal = 6,
  sym__binary_literal = 7,
  sym__octal_literal = 8,
  sym__hex_literal = 9,
  anon_sym_LPAREN_POUND = 10,
  anon_sym_LPAREN_POUND_LF = 11,
  anon_sym_u21d2 = 12,
  anon_sym_EQ_GT = 13,
  anon_sym_u2192 = 14,
  anon_sym_DASH_GT = 15,
  anon_sym_u2190 = 16,
  anon_sym_LT_DASH = 17,
  anon_sym_u2237 = 18,
  anon_sym_COLON_COLON = 19,
  sym__immediate_dot = 20,
  sym_pragma = 21,
  sym__immediate_varid = 22,
  sym_label = 23,
  anon_sym_DASH = 24,
  anon_sym_LPAREN = 25,
  anon_sym_RPAREN = 26,
  anon_sym_BQUOTE = 27,
  sym_implicit_parid = 28,
  sym__conid = 29,
  anon_sym_LBRACK = 30,
  anon_sym_RBRACK = 31,
  anon_sym_SQUOTE = 32,
  anon_sym_LBRACE = 33,
  anon_sym_RBRACE = 34,
  anon_sym_forall = 35,
  anon_sym_u2200 = 36,
  anon_sym_DOT = 37,
  anon_sym_PIPE = 38,
  anon_sym_STAR = 39,
  anon_sym_u2605 = 40,
  anon_sym_AT = 41,
  anon_sym_PERCENT = 42,
  anon_sym_type = 43,
  anon_sym_EQ = 44,
  anon_sym_family = 45,
  anon_sym_instance = 46,
  anon_sym_representational = 47,
  anon_sym_nominal = 48,
  anon_sym_phantom = 49,
  anon_sym__ = 50,
  anon_sym_role = 51,
  anon_sym_DOT_DOT = 52,
  anon_sym_thengroupby = 53,
  anon_sym_using = 54,
  anon_sym_thengroupusing = 55,
  anon_sym_then = 56,
  anon_sym_SQUOTE_SQUOTE = 57,
  anon_sym_BSLASH = 58,
  anon_sym_in = 59,
  anon_sym_let = 60,
  anon_sym_if = 61,
  anon_sym_else = 62,
  anon_sym_case = 63,
  anon_sym_of = 64,
  anon_sym_cases = 65,
  anon_sym_rec = 66,
  anon_sym_mdo = 67,
  anon_sym_do = 68,
  anon_sym_AT2 = 69,
  anon_sym_pattern = 70,
  anon_sym_hiding = 71,
  anon_sym_import = 72,
  anon_sym_qualified = 73,
  anon_sym_as = 74,
  anon_sym_module = 75,
  anon_sym_via = 76,
  anon_sym_stock = 77,
  anon_sym_newtype = 78,
  anon_sym_anyclass = 79,
  anon_sym_deriving = 80,
  anon_sym_data = 81,
  anon_sym_default = 82,
  anon_sym_class = 83,
  anon_sym_infixl = 84,
  anon_sym_infixr = 85,
  anon_sym_infix = 86,
  anon_sym_ccall = 87,
  anon_sym_stdcall = 88,
  anon_sym_cplusplus = 89,
  anon_sym_jvm = 90,
  anon_sym_dotnet = 91,
  anon_sym_prim = 92,
  anon_sym_capi = 93,
  anon_sym_unsafe = 94,
  anon_sym_safe = 95,
  anon_sym_interruptible = 96,
  anon_sym_foreign = 97,
  anon_sym_export = 98,
  sym_decl_special_fun_fixity = 99,
  anon_sym_u27e6 = 100,
  anon_sym_PIPE_RBRACK = 101,
  anon_sym_u27e7 = 102,
  aux_sym__token1 = 103,
  sym__layout_semicolon = 104,
  sym__layout_start = 105,
  sym__layout_end = 106,
  sym__dot = 107,
  sym__arith_dotdot = 108,
  sym_where = 109,
  sym__splice_dollar = 110,
  sym__varsym = 111,
  sym__consym = 112,
  sym__tyconsym = 113,
  sym_comment = 114,
  sym_cpp = 115,
  sym_comma = 116,
  sym_quasiquote_start = 117,
  sym_quasiquote_bar = 118,
  sym_quasiquote_body = 119,
  sym__strict = 120,
  sym__lazy = 121,
  sym__unboxed_close = 122,
  sym_empty_file = 123,
  sym_haskell = 124,
  sym__topdecl = 125,
  sym_integer = 126,
  sym__literal = 127,
  sym__unboxed_open = 128,
  sym__carrow = 129,
  sym__arrow = 130,
  sym__larrow = 131,
  sym__colon2 = 132,
  sym_variable = 133,
  sym__immediate_variable = 134,
  sym_qualified_variable = 135,
  sym_operator = 136,
  sym__minus = 137,
  sym_qualified_operator = 138,
  sym_varop = 139,
  sym__qvarop = 140,
  sym__qvarop_nominus = 141,
  sym_constructor = 142,
  sym_qualified_constructor = 143,
  sym_constructor_operator = 144,
  sym_qualified_constructor_operator = 145,
  sym__qcon = 146,
  sym__qop = 147,
  sym_con_unit = 148,
  sym_con_list = 149,
  sym_con_tuple = 150,
  sym_literal = 151,
  sym_qualified_type = 152,
  sym__type_operator = 153,
  sym_qualified_type_operator = 154,
  sym__qualified_type_operator = 155,
  sym__ticked_tycon = 156,
  sym__ticked_qtycon = 157,
  sym__qtyconops = 158,
  sym__promoted_tyconop = 159,
  sym__qtyconop = 160,
  sym_tycon_arrow = 161,
  sym_type_literal = 162,
  sym__promoted_tycon = 163,
  sym__name = 164,
  sym_type_variable = 165,
  sym_annotated_type_variable = 166,
  sym_inferred_type_variable = 167,
  sym__quantifier = 168,
  sym__forall_kw = 169,
  sym__forall_dot = 170,
  sym__forall = 171,
  sym_forall = 172,
  sym_type_parens = 173,
  sym_type_list = 174,
  sym__type_tuple = 175,
  sym_type_tuple = 176,
  sym__type_sum = 177,
  sym__type_promotable_literal = 178,
  sym__type_promoted_literal = 179,
  sym__type_literal = 180,
  sym_strict_type = 181,
  sym_lazy_type = 182,
  sym_type_name = 183,
  sym_type_star = 184,
  sym_type_unboxed_tuple = 185,
  sym_type_unboxed_sum = 186,
  sym__atype = 187,
  sym_type_invisible = 188,
  sym_type_apply = 189,
  sym__btype = 190,
  sym_implicit_param = 191,
  sym_type_infix = 192,
  sym__type_infix = 193,
  sym_constraint = 194,
  sym__quantified_constraint = 195,
  sym__constraint_context = 196,
  sym__constraint = 197,
  sym__context_constraints = 198,
  sym__context = 199,
  sym_context = 200,
  sym__type_quantifiers = 201,
  sym__type_context = 202,
  sym_modifier = 203,
  sym__fun_arrow = 204,
  sym__type_fun = 205,
  sym__type = 206,
  sym__type_or_implicit = 207,
  sym__type_annotation = 208,
  sym_kind = 209,
  sym__type_with_kind = 210,
  sym__simpletype_infix = 211,
  sym__simpletype = 212,
  sym_decl_type = 213,
  sym_tyfam_head = 214,
  sym_tyfam_pat = 215,
  sym_tyfam_eq = 216,
  sym_tyfam_result_type = 217,
  sym_tyfam_injectivity = 218,
  sym__tyfam_inj = 219,
  sym__tyfam = 220,
  sym_decl_tyfam = 221,
  sym__tyinst = 222,
  sym_decl_tyinst = 223,
  sym_type_role = 224,
  sym_decl_role = 225,
  sym_exp_parens = 226,
  sym__exp_tuple = 227,
  sym_exp_tuple = 228,
  sym_exp_unboxed_tuple = 229,
  sym__exp_unboxed_sum = 230,
  sym_exp_unboxed_sum = 231,
  sym_exp_list = 232,
  sym_bind_pattern = 233,
  sym_exp_arithmetic_sequence = 234,
  sym_transform = 235,
  sym_qual = 236,
  sym_exp_list_comprehension = 237,
  sym_exp_section_left = 238,
  sym_exp_section_right = 239,
  sym_exp_th_quoted_name = 240,
  sym_exp_field = 241,
  sym_exp_type_application = 242,
  sym_exp_lambda = 243,
  sym_exp_in = 244,
  sym_let = 245,
  sym__let_decls = 246,
  sym_exp_let = 247,
  sym_exp_let_in = 248,
  sym_exp_cond = 249,
  sym_pattern_guard = 250,
  sym_guard = 251,
  sym_guards = 252,
  sym_gdpat = 253,
  sym_exp_if_guard = 254,
  sym__alt_variants = 255,
  aux_sym__nalt_patterns = 256,
  sym_alt = 257,
  sym_nalt = 258,
  sym_alts = 259,
  sym_nalts = 260,
  sym_exp_case = 261,
  sym_exp_lambda_case = 262,
  sym_exp_lambda_cases = 263,
  sym_rec = 264,
  sym_stmt = 265,
  sym__do_keyword = 266,
  sym_do_module = 267,
  sym_exp_do = 268,
  sym_exp_negation = 269,
  sym_exp_record = 270,
  sym_exp_name = 271,
  sym_exp_projection_selector = 272,
  sym__aexp_projection = 273,
  sym_exp_projection = 274,
  sym__aexp = 275,
  sym__exp_apply = 276,
  sym__fexp = 277,
  sym__lexp = 278,
  sym_exp_infix = 279,
  sym__exp_infix = 280,
  sym__exp = 281,
  sym_pat_field = 282,
  sym_pat_fields = 283,
  sym_pat_name = 284,
  sym_pat_as = 285,
  sym__pat_constructor = 286,
  sym_pat_record = 287,
  sym_pat_wildcard = 288,
  sym_pat_parens = 289,
  sym_pat_tuple = 290,
  sym_pat_unboxed_tuple = 291,
  sym__pat_unboxed_sum = 292,
  sym_pat_unboxed_sum = 293,
  sym_pat_list = 294,
  sym_pat_strict = 295,
  sym_pat_irrefutable = 296,
  sym_pat_type_binder = 297,
  sym__apat = 298,
  sym_pat_negation = 299,
  sym_pat_apply = 300,
  sym__lpat = 301,
  sym_pat_infix = 302,
  sym__pat = 303,
  sym_pat_typed = 304,
  sym__typed_pat = 305,
  sym_pat_view = 306,
  sym__nested_pat = 307,
  sym__import_name = 308,
  sym_namespace = 309,
  sym_import_con_names = 310,
  sym_import_item = 311,
  sym_import_list = 312,
  sym_decl_import = 313,
  sym__modid = 314,
  aux_sym__qualifying_module = 315,
  sym_qualified_module = 316,
  sym__qmodid = 317,
  sym_export_names = 318,
  sym_export = 319,
  sym_exports = 320,
  sym__module = 321,
  sym_field = 322,
  sym_data_constructor = 323,
  sym_data_constructor_infix = 324,
  sym__record_field = 325,
  sym_record_fields = 326,
  sym_data_constructor_record = 327,
  sym_data_constructor_special = 328,
  sym_constructors = 329,
  sym_via = 330,
  sym_deriving_strategy = 331,
  sym_deriving = 332,
  sym__adt_rhs = 333,
  sym__gadt_fun = 334,
  sym__gadt_sig = 335,
  sym__gadt_constr_type = 336,
  sym_gadt_constructor = 337,
  sym__gadt_rhs = 338,
  sym__adt = 339,
  sym_decl_adt = 340,
  sym_newtype_constructor = 341,
  sym__newtype = 342,
  sym__context_newtype = 343,
  sym_decl_newtype = 344,
  sym__datafam = 345,
  sym_decl_datafam = 346,
  sym__datainst = 347,
  sym_decl_datainst = 348,
  sym_default_signature = 349,
  sym_class_datafam = 350,
  sym_class_tyfam = 351,
  sym__cdecl = 352,
  sym_fundep = 353,
  sym_fundeps = 354,
  sym_class_body = 355,
  sym_decl_class = 356,
  sym_inst_datainst = 357,
  sym_inst_tyinst = 358,
  sym__idecl = 359,
  sym__instance = 360,
  sym_decl_instance = 361,
  sym_decl_deriving = 362,
  sym__funpat_infix = 363,
  sym__funpat = 364,
  sym__fun_name = 365,
  sym_guard_equation = 366,
  aux_sym__fun_guards = 367,
  sym__funrhs = 368,
  aux_sym__fun_patterns = 369,
  sym__funvar = 370,
  sym__funlhs = 371,
  sym_function = 372,
  sym_fixity = 373,
  sym_signature = 374,
  sym__gendecl = 375,
  sym__decl_fun = 376,
  sym__decl = 377,
  sym_decls = 378,
  sym_calling_convention = 379,
  sym_safety = 380,
  sym_impent = 381,
  sym_expent = 382,
  sym__foreign_pre = 383,
  sym_decl_foreign_import = 384,
  sym_decl_foreign_export = 385,
  sym__decl_foreign = 386,
  sym_decl_special = 387,
  sym__pattern_type = 388,
  sym__pattern_equals = 389,
  sym__pattern_decl = 390,
  sym__pattern_arrow = 391,
  sym_decl_pattern = 392,
  sym_decl_default = 393,
  sym__splice_exp = 394,
  sym_splice = 395,
  sym_top_splice = 396,
  sym_quasiquote = 397,
  aux_sym_haskell_repeat1 = 398,
  aux_sym_con_tuple_repeat1 = 399,
  aux_sym__forall_repeat1 = 400,
  aux_sym_type_list_repeat1 = 401,
  aux_sym__type_sum_repeat1 = 402,
  aux_sym_type_apply_repeat1 = 403,
  aux_sym_constraint_repeat1 = 404,
  aux_sym__context_constraints_repeat1 = 405,
  aux_sym__simpletype_repeat1 = 406,
  aux_sym_tyfam_injectivity_repeat1 = 407,
  aux_sym_decl_tyfam_repeat1 = 408,
  aux_sym_decl_tyfam_repeat2 = 409,
  aux_sym_decl_tyfam_repeat3 = 410,
  aux_sym_decl_role_repeat1 = 411,
  aux_sym__exp_tuple_repeat1 = 412,
  aux_sym__exp_unboxed_sum_repeat1 = 413,
  aux_sym_exp_list_repeat1 = 414,
  aux_sym_exp_list_comprehension_repeat1 = 415,
  aux_sym_exp_field_repeat1 = 416,
  aux_sym_exp_lambda_repeat1 = 417,
  aux_sym__let_decls_repeat1 = 418,
  aux_sym__let_decls_repeat2 = 419,
  aux_sym_guards_repeat1 = 420,
  aux_sym_exp_if_guard_repeat1 = 421,
  aux_sym_alts_repeat1 = 422,
  aux_sym_alts_repeat2 = 423,
  aux_sym_nalts_repeat1 = 424,
  aux_sym_nalts_repeat2 = 425,
  aux_sym_rec_repeat1 = 426,
  aux_sym_rec_repeat2 = 427,
  aux_sym_exp_record_repeat1 = 428,
  aux_sym_exp_projection_selector_repeat1 = 429,
  aux_sym_pat_fields_repeat1 = 430,
  aux_sym_pat_tuple_repeat1 = 431,
  aux_sym__pat_unboxed_sum_repeat1 = 432,
  aux_sym_import_con_names_repeat1 = 433,
  aux_sym_import_list_repeat1 = 434,
  aux_sym_export_names_repeat1 = 435,
  aux_sym_exports_repeat1 = 436,
  aux_sym__module_repeat1 = 437,
  aux_sym_field_repeat1 = 438,
  aux_sym_data_constructor_repeat1 = 439,
  aux_sym_record_fields_repeat1 = 440,
  aux_sym_constructors_repeat1 = 441,
  aux_sym_deriving_repeat1 = 442,
  aux_sym__adt_rhs_repeat1 = 443,
  aux_sym__gadt_rhs_repeat1 = 444,
  aux_sym__gadt_rhs_repeat2 = 445,
  aux_sym_fundeps_repeat1 = 446,
  aux_sym_class_body_repeat1 = 447,
  aux_sym_class_body_repeat2 = 448,
  aux_sym_decl_instance_repeat1 = 449,
  aux_sym_decl_instance_repeat2 = 450,
  aux_sym_fixity_repeat1 = 451,
  aux_sym_signature_repeat1 = 452,
  aux_sym__pattern_arrow_repeat1 = 453,
  aux_sym__pattern_arrow_repeat2 = 454,
  aux_sym_decl_default_repeat1 = 455,
  alias_sym_all_names = 456,
  alias_sym_class_head = 457,
  alias_sym_class_name = 458,
  alias_sym_exp_apply = 459,
  alias_sym_import_package = 460,
  alias_sym_instance_head = 461,
  alias_sym_module = 462,
  alias_sym_nalt_patterns = 463,
  alias_sym_pat_literal = 464,
  alias_sym_patterns = 465,
  alias_sym_quoter = 466,
  alias_sym_type = 467,
  alias_sym_wildcard = 468,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__varid] = "_varid",
  [anon_sym_SEMI] = ";",
  [sym_float] = "float",
  [sym_char] = "char",
  [sym_string] = "string",
  [sym__integer_literal] = "_integer_literal",
  [sym__binary_literal] = "_binary_literal",
  [sym__octal_literal] = "_octal_literal",
  [sym__hex_literal] = "_hex_literal",
  [anon_sym_LPAREN_POUND] = "(# ",
  [anon_sym_LPAREN_POUND_LF] = "(#\n",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_u2237] = "\u2237",
  [anon_sym_COLON_COLON] = "::",
  [sym__immediate_dot] = "_immediate_dot",
  [sym_pragma] = "pragma",
  [sym__immediate_varid] = "variable",
  [sym_label] = "label",
  [anon_sym_DASH] = "-",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_BQUOTE] = "`",
  [sym_implicit_parid] = "implicit_parid",
  [sym__conid] = "_conid",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_DOT] = ".",
  [anon_sym_PIPE] = "|",
  [anon_sym_STAR] = "*",
  [anon_sym_u2605] = "\u2605",
  [anon_sym_AT] = "@",
  [anon_sym_PERCENT] = "%",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_family] = "family",
  [anon_sym_instance] = "instance",
  [anon_sym_representational] = "representational",
  [anon_sym_nominal] = "nominal",
  [anon_sym_phantom] = "phantom",
  [anon_sym__] = "_",
  [anon_sym_role] = "role",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_thengroupby] = "then group by",
  [anon_sym_using] = "using",
  [anon_sym_thengroupusing] = "then group using",
  [anon_sym_then] = "then",
  [anon_sym_SQUOTE_SQUOTE] = "''",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_in] = "in",
  [anon_sym_let] = "let",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_of] = "of",
  [anon_sym_cases] = "cases",
  [anon_sym_rec] = "rec",
  [anon_sym_mdo] = "mdo",
  [anon_sym_do] = "do",
  [anon_sym_AT2] = "@",
  [anon_sym_pattern] = "pattern",
  [anon_sym_hiding] = "hiding",
  [anon_sym_import] = "import",
  [anon_sym_qualified] = "qualified",
  [anon_sym_as] = "as",
  [anon_sym_module] = "module",
  [anon_sym_via] = "via",
  [anon_sym_stock] = "stock",
  [anon_sym_newtype] = "newtype",
  [anon_sym_anyclass] = "anyclass",
  [anon_sym_deriving] = "deriving",
  [anon_sym_data] = "data",
  [anon_sym_default] = "default",
  [anon_sym_class] = "class",
  [anon_sym_infixl] = "infixl",
  [anon_sym_infixr] = "infixr",
  [anon_sym_infix] = "infix",
  [anon_sym_ccall] = "ccall",
  [anon_sym_stdcall] = "stdcall",
  [anon_sym_cplusplus] = "cplusplus",
  [anon_sym_jvm] = "jvm",
  [anon_sym_dotnet] = "dotnet",
  [anon_sym_prim] = "prim",
  [anon_sym_capi] = "capi",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_safe] = "safe",
  [anon_sym_interruptible] = "interruptible",
  [anon_sym_foreign] = "foreign",
  [anon_sym_export] = "export",
  [sym_decl_special_fun_fixity] = "decl_special_fun_fixity",
  [anon_sym_u27e6] = "\u27e6",
  [anon_sym_PIPE_RBRACK] = "|]",
  [anon_sym_u27e7] = "\u27e7",
  [aux_sym__token1] = "_token1",
  [sym__layout_semicolon] = "_layout_semicolon",
  [sym__layout_start] = "_layout_start",
  [sym__layout_end] = "_layout_end",
  [sym__dot] = "_dot",
  [sym__arith_dotdot] = "_arith_dotdot",
  [sym_where] = "where",
  [sym__splice_dollar] = "_splice_dollar",
  [sym__varsym] = "_varsym",
  [sym__consym] = "_consym",
  [sym__tyconsym] = "type_operator",
  [sym_comment] = "comment",
  [sym_cpp] = "cpp",
  [sym_comma] = "comma",
  [sym_quasiquote_start] = "quasiquote_start",
  [sym_quasiquote_bar] = "quasiquote_bar",
  [sym_quasiquote_body] = "quasiquote_body",
  [sym__strict] = "_strict",
  [sym__lazy] = "_lazy",
  [sym__unboxed_close] = "_unboxed_close",
  [sym_empty_file] = "empty_file",
  [sym_haskell] = "haskell",
  [sym__topdecl] = "_topdecl",
  [sym_integer] = "integer",
  [sym__literal] = "_literal",
  [sym__unboxed_open] = "_unboxed_open",
  [sym__carrow] = "_carrow",
  [sym__arrow] = "_arrow",
  [sym__larrow] = "_larrow",
  [sym__colon2] = "_colon2",
  [sym_variable] = "variable",
  [sym__immediate_variable] = "_immediate_variable",
  [sym_qualified_variable] = "qualified_variable",
  [sym_operator] = "operator",
  [sym__minus] = "_minus",
  [sym_qualified_operator] = "qualified_operator",
  [sym_varop] = "varop",
  [sym__qvarop] = "_qvarop",
  [sym__qvarop_nominus] = "_qvarop_nominus",
  [sym_constructor] = "constructor",
  [sym_qualified_constructor] = "qualified_constructor",
  [sym_constructor_operator] = "constructor_operator",
  [sym_qualified_constructor_operator] = "qualified_constructor_operator",
  [sym__qcon] = "_qcon",
  [sym__qop] = "_qop",
  [sym_con_unit] = "con_unit",
  [sym_con_list] = "con_list",
  [sym_con_tuple] = "con_tuple",
  [sym_literal] = "exp_literal",
  [sym_qualified_type] = "qualified_type",
  [sym__type_operator] = "_type_operator",
  [sym_qualified_type_operator] = "qualified_type_operator",
  [sym__qualified_type_operator] = "_qualified_type_operator",
  [sym__ticked_tycon] = "ticked",
  [sym__ticked_qtycon] = "ticked",
  [sym__qtyconops] = "_qtyconops",
  [sym__promoted_tyconop] = "promoted",
  [sym__qtyconop] = "_qtyconop",
  [sym_tycon_arrow] = "tycon_arrow",
  [sym_type_literal] = "type_literal",
  [sym__promoted_tycon] = "promoted",
  [sym__name] = "_name",
  [sym_type_variable] = "type_variable",
  [sym_annotated_type_variable] = "annotated_type_variable",
  [sym_inferred_type_variable] = "inferred_type_variable",
  [sym__quantifier] = "_quantifier",
  [sym__forall_kw] = "_forall_kw",
  [sym__forall_dot] = "_forall_dot",
  [sym__forall] = "quantifiers",
  [sym_forall] = "forall",
  [sym_type_parens] = "type_parens",
  [sym_type_list] = "type_list",
  [sym__type_tuple] = "_type_tuple",
  [sym_type_tuple] = "type_tuple",
  [sym__type_sum] = "_type_sum",
  [sym__type_promotable_literal] = "_type_promotable_literal",
  [sym__type_promoted_literal] = "promoted",
  [sym__type_literal] = "_type_literal",
  [sym_strict_type] = "strict_type",
  [sym_lazy_type] = "lazy_type",
  [sym_type_name] = "type_name",
  [sym_type_star] = "type_star",
  [sym_type_unboxed_tuple] = "type_unboxed_tuple",
  [sym_type_unboxed_sum] = "type_unboxed_sum",
  [sym__atype] = "_atype",
  [sym_type_invisible] = "type_invisible",
  [sym_type_apply] = "type_apply",
  [sym__btype] = "_btype",
  [sym_implicit_param] = "implicit_param",
  [sym_type_infix] = "type_infix",
  [sym__type_infix] = "_type_infix",
  [sym_constraint] = "constraint",
  [sym__quantified_constraint] = "forall",
  [sym__constraint_context] = "context",
  [sym__constraint] = "_constraint",
  [sym__context_constraints] = "_context_constraints",
  [sym__context] = "_context",
  [sym_context] = "context",
  [sym__type_quantifiers] = "forall",
  [sym__type_context] = "context",
  [sym_modifier] = "modifier",
  [sym__fun_arrow] = "_fun_arrow",
  [sym__type_fun] = "fun",
  [sym__type] = "_type",
  [sym__type_or_implicit] = "_type_or_implicit",
  [sym__type_annotation] = "_type_annotation",
  [sym_kind] = "kind",
  [sym__type_with_kind] = "_type_with_kind",
  [sym__simpletype_infix] = "type_infix",
  [sym__simpletype] = "_simpletype",
  [sym_decl_type] = "type_alias",
  [sym_tyfam_head] = "head",
  [sym_tyfam_pat] = "pattern",
  [sym_tyfam_eq] = "equation",
  [sym_tyfam_result_type] = "tyfam_result_type",
  [sym_tyfam_injectivity] = "tyfam_injectivity",
  [sym__tyfam_inj] = "_tyfam_inj",
  [sym__tyfam] = "_tyfam",
  [sym_decl_tyfam] = "type_family",
  [sym__tyinst] = "_tyinst",
  [sym_decl_tyinst] = "type_instance",
  [sym_type_role] = "type_role",
  [sym_decl_role] = "role_annotation",
  [sym_exp_parens] = "exp_parens",
  [sym__exp_tuple] = "_exp_tuple",
  [sym_exp_tuple] = "exp_tuple",
  [sym_exp_unboxed_tuple] = "exp_unboxed_tuple",
  [sym__exp_unboxed_sum] = "_exp_unboxed_sum",
  [sym_exp_unboxed_sum] = "exp_unboxed_sum",
  [sym_exp_list] = "exp_list",
  [sym_bind_pattern] = "bind_pattern",
  [sym_exp_arithmetic_sequence] = "exp_arithmetic_sequence",
  [sym_transform] = "transform",
  [sym_qual] = "qual",
  [sym_exp_list_comprehension] = "exp_list_comprehension",
  [sym_exp_section_left] = "exp_section_left",
  [sym_exp_section_right] = "exp_section_right",
  [sym_exp_th_quoted_name] = "exp_th_quoted_name",
  [sym_exp_field] = "exp_field",
  [sym_exp_type_application] = "exp_type_application",
  [sym_exp_lambda] = "exp_lambda",
  [sym_exp_in] = "exp_in",
  [sym_let] = "let",
  [sym__let_decls] = "decls",
  [sym_exp_let] = "exp_let",
  [sym_exp_let_in] = "exp_let_in",
  [sym_exp_cond] = "exp_cond",
  [sym_pattern_guard] = "pattern_guard",
  [sym_guard] = "guard",
  [sym_guards] = "guards",
  [sym_gdpat] = "gdpat",
  [sym_exp_if_guard] = "exp_if_guard",
  [sym__alt_variants] = "_alt_variants",
  [aux_sym__nalt_patterns] = "_nalt_patterns",
  [sym_alt] = "alt",
  [sym_nalt] = "nalt",
  [sym_alts] = "alts",
  [sym_nalts] = "nalts",
  [sym_exp_case] = "exp_case",
  [sym_exp_lambda_case] = "exp_lambda_case",
  [sym_exp_lambda_cases] = "exp_lambda_cases",
  [sym_rec] = "rec",
  [sym_stmt] = "stmt",
  [sym__do_keyword] = "_do_keyword",
  [sym_do_module] = "do_module",
  [sym_exp_do] = "exp_do",
  [sym_exp_negation] = "exp_negation",
  [sym_exp_record] = "exp_record",
  [sym_exp_name] = "exp_name",
  [sym_exp_projection_selector] = "exp_projection_selector",
  [sym__aexp_projection] = "_aexp_projection",
  [sym_exp_projection] = "exp_projection",
  [sym__aexp] = "_aexp",
  [sym__exp_apply] = "_exp_apply",
  [sym__fexp] = "_fexp",
  [sym__lexp] = "_lexp",
  [sym_exp_infix] = "exp_infix",
  [sym__exp_infix] = "_exp_infix",
  [sym__exp] = "_exp",
  [sym_pat_field] = "pat_field",
  [sym_pat_fields] = "pat_fields",
  [sym_pat_name] = "pat_name",
  [sym_pat_as] = "pat_as",
  [sym__pat_constructor] = "_pat_constructor",
  [sym_pat_record] = "pat_record",
  [sym_pat_wildcard] = "pat_wildcard",
  [sym_pat_parens] = "pat_parens",
  [sym_pat_tuple] = "pat_tuple",
  [sym_pat_unboxed_tuple] = "pat_unboxed_tuple",
  [sym__pat_unboxed_sum] = "_pat_unboxed_sum",
  [sym_pat_unboxed_sum] = "pat_unboxed_sum",
  [sym_pat_list] = "pat_list",
  [sym_pat_strict] = "pat_strict",
  [sym_pat_irrefutable] = "pat_irrefutable",
  [sym_pat_type_binder] = "pat_type_binder",
  [sym__apat] = "_apat",
  [sym_pat_negation] = "pat_negation",
  [sym_pat_apply] = "pat_apply",
  [sym__lpat] = "_lpat",
  [sym_pat_infix] = "pat_infix",
  [sym__pat] = "_pat",
  [sym_pat_typed] = "pat_typed",
  [sym__typed_pat] = "_typed_pat",
  [sym_pat_view] = "pat_view",
  [sym__nested_pat] = "_nested_pat",
  [sym__import_name] = "_import_name",
  [sym_namespace] = "namespace",
  [sym_import_con_names] = "import_con_names",
  [sym_import_item] = "import_item",
  [sym_import_list] = "import_list",
  [sym_decl_import] = "import",
  [sym__modid] = "_modid",
  [aux_sym__qualifying_module] = "_qualifying_module",
  [sym_qualified_module] = "qualified_module",
  [sym__qmodid] = "_qmodid",
  [sym_export_names] = "export_names",
  [sym_export] = "export",
  [sym_exports] = "exports",
  [sym__module] = "_module",
  [sym_field] = "field",
  [sym_data_constructor] = "data_constructor",
  [sym_data_constructor_infix] = "data_constructor_infix",
  [sym__record_field] = "_record_field",
  [sym_record_fields] = "record_fields",
  [sym_data_constructor_record] = "data_constructor_record",
  [sym_data_constructor_special] = "data_constructor_special",
  [sym_constructors] = "constructors",
  [sym_via] = "via",
  [sym_deriving_strategy] = "deriving_strategy",
  [sym_deriving] = "deriving",
  [sym__adt_rhs] = "_adt_rhs",
  [sym__gadt_fun] = "fun",
  [sym__gadt_sig] = "_gadt_sig",
  [sym__gadt_constr_type] = "_gadt_constr_type",
  [sym_gadt_constructor] = "gadt_constructor",
  [sym__gadt_rhs] = "_gadt_rhs",
  [sym__adt] = "_adt",
  [sym_decl_adt] = "adt",
  [sym_newtype_constructor] = "newtype_constructor",
  [sym__newtype] = "_newtype",
  [sym__context_newtype] = "_context_newtype",
  [sym_decl_newtype] = "newtype",
  [sym__datafam] = "_datafam",
  [sym_decl_datafam] = "data_family",
  [sym__datainst] = "_datainst",
  [sym_decl_datainst] = "data_instance",
  [sym_default_signature] = "default_signature",
  [sym_class_datafam] = "data_family",
  [sym_class_tyfam] = "type_family",
  [sym__cdecl] = "_cdecl",
  [sym_fundep] = "fundep",
  [sym_fundeps] = "fundeps",
  [sym_class_body] = "class_body",
  [sym_decl_class] = "class",
  [sym_inst_datainst] = "data_instance",
  [sym_inst_tyinst] = "type_instance",
  [sym__idecl] = "_idecl",
  [sym__instance] = "_instance",
  [sym_decl_instance] = "instance",
  [sym_decl_deriving] = "deriving_declaration",
  [sym__funpat_infix] = "infix",
  [sym__funpat] = "function",
  [sym__fun_name] = "_fun_name",
  [sym_guard_equation] = "guard_equation",
  [aux_sym__fun_guards] = "_fun_guards",
  [sym__funrhs] = "_funrhs",
  [aux_sym__fun_patterns] = "_fun_patterns",
  [sym__funvar] = "_funvar",
  [sym__funlhs] = "_funlhs",
  [sym_function] = "function",
  [sym_fixity] = "fixity",
  [sym_signature] = "signature",
  [sym__gendecl] = "_gendecl",
  [sym__decl_fun] = "_decl_fun",
  [sym__decl] = "_decl",
  [sym_decls] = "decls",
  [sym_calling_convention] = "calling_convention",
  [sym_safety] = "safety",
  [sym_impent] = "impent",
  [sym_expent] = "expent",
  [sym__foreign_pre] = "_foreign_pre",
  [sym_decl_foreign_import] = "foreign_import",
  [sym_decl_foreign_export] = "foreign_export",
  [sym__decl_foreign] = "_decl_foreign",
  [sym_decl_special] = "decl_special",
  [sym__pattern_type] = "signature",
  [sym__pattern_equals] = "equation",
  [sym__pattern_decl] = "_pattern_decl",
  [sym__pattern_arrow] = "equation",
  [sym_decl_pattern] = "pattern_synonym",
  [sym_decl_default] = "default_declaration",
  [sym__splice_exp] = "_splice_exp",
  [sym_splice] = "splice",
  [sym_top_splice] = "top_splice",
  [sym_quasiquote] = "quasiquote",
  [aux_sym_haskell_repeat1] = "haskell_repeat1",
  [aux_sym_con_tuple_repeat1] = "con_tuple_repeat1",
  [aux_sym__forall_repeat1] = "_forall_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym__type_sum_repeat1] = "_type_sum_repeat1",
  [aux_sym_type_apply_repeat1] = "type_apply_repeat1",
  [aux_sym_constraint_repeat1] = "constraint_repeat1",
  [aux_sym__context_constraints_repeat1] = "_context_constraints_repeat1",
  [aux_sym__simpletype_repeat1] = "_simpletype_repeat1",
  [aux_sym_tyfam_injectivity_repeat1] = "tyfam_injectivity_repeat1",
  [aux_sym_decl_tyfam_repeat1] = "decl_tyfam_repeat1",
  [aux_sym_decl_tyfam_repeat2] = "decl_tyfam_repeat2",
  [aux_sym_decl_tyfam_repeat3] = "decl_tyfam_repeat3",
  [aux_sym_decl_role_repeat1] = "decl_role_repeat1",
  [aux_sym__exp_tuple_repeat1] = "_exp_tuple_repeat1",
  [aux_sym__exp_unboxed_sum_repeat1] = "_exp_unboxed_sum_repeat1",
  [aux_sym_exp_list_repeat1] = "exp_list_repeat1",
  [aux_sym_exp_list_comprehension_repeat1] = "exp_list_comprehension_repeat1",
  [aux_sym_exp_field_repeat1] = "exp_field_repeat1",
  [aux_sym_exp_lambda_repeat1] = "exp_lambda_repeat1",
  [aux_sym__let_decls_repeat1] = "_let_decls_repeat1",
  [aux_sym__let_decls_repeat2] = "_let_decls_repeat2",
  [aux_sym_guards_repeat1] = "guards_repeat1",
  [aux_sym_exp_if_guard_repeat1] = "exp_if_guard_repeat1",
  [aux_sym_alts_repeat1] = "alts_repeat1",
  [aux_sym_alts_repeat2] = "alts_repeat2",
  [aux_sym_nalts_repeat1] = "nalts_repeat1",
  [aux_sym_nalts_repeat2] = "nalts_repeat2",
  [aux_sym_rec_repeat1] = "rec_repeat1",
  [aux_sym_rec_repeat2] = "rec_repeat2",
  [aux_sym_exp_record_repeat1] = "exp_record_repeat1",
  [aux_sym_exp_projection_selector_repeat1] = "exp_projection_selector_repeat1",
  [aux_sym_pat_fields_repeat1] = "pat_fields_repeat1",
  [aux_sym_pat_tuple_repeat1] = "pat_tuple_repeat1",
  [aux_sym__pat_unboxed_sum_repeat1] = "_pat_unboxed_sum_repeat1",
  [aux_sym_import_con_names_repeat1] = "import_con_names_repeat1",
  [aux_sym_import_list_repeat1] = "import_list_repeat1",
  [aux_sym_export_names_repeat1] = "export_names_repeat1",
  [aux_sym_exports_repeat1] = "exports_repeat1",
  [aux_sym__module_repeat1] = "_module_repeat1",
  [aux_sym_field_repeat1] = "field_repeat1",
  [aux_sym_data_constructor_repeat1] = "data_constructor_repeat1",
  [aux_sym_record_fields_repeat1] = "record_fields_repeat1",
  [aux_sym_constructors_repeat1] = "constructors_repeat1",
  [aux_sym_deriving_repeat1] = "deriving_repeat1",
  [aux_sym__adt_rhs_repeat1] = "_adt_rhs_repeat1",
  [aux_sym__gadt_rhs_repeat1] = "_gadt_rhs_repeat1",
  [aux_sym__gadt_rhs_repeat2] = "_gadt_rhs_repeat2",
  [aux_sym_fundeps_repeat1] = "fundeps_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_class_body_repeat2] = "class_body_repeat2",
  [aux_sym_decl_instance_repeat1] = "decl_instance_repeat1",
  [aux_sym_decl_instance_repeat2] = "decl_instance_repeat2",
  [aux_sym_fixity_repeat1] = "fixity_repeat1",
  [aux_sym_signature_repeat1] = "signature_repeat1",
  [aux_sym__pattern_arrow_repeat1] = "_pattern_arrow_repeat1",
  [aux_sym__pattern_arrow_repeat2] = "_pattern_arrow_repeat2",
  [aux_sym_decl_default_repeat1] = "decl_default_repeat1",
  [alias_sym_all_names] = "all_names",
  [alias_sym_class_head] = "class_head",
  [alias_sym_class_name] = "class_name",
  [alias_sym_exp_apply] = "exp_apply",
  [alias_sym_import_package] = "import_package",
  [alias_sym_instance_head] = "instance_head",
  [alias_sym_module] = "module",
  [alias_sym_nalt_patterns] = "nalt_patterns",
  [alias_sym_pat_literal] = "pat_literal",
  [alias_sym_patterns] = "patterns",
  [alias_sym_quoter] = "quoter",
  [alias_sym_type] = "type",
  [alias_sym_wildcard] = "wildcard",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__varid] = sym__varid,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_float] = sym_float,
  [sym_char] = sym_char,
  [sym_string] = sym_string,
  [sym__integer_literal] = sym__integer_literal,
  [sym__binary_literal] = sym__binary_literal,
  [sym__octal_literal] = sym__octal_literal,
  [sym__hex_literal] = sym__hex_literal,
  [anon_sym_LPAREN_POUND] = anon_sym_LPAREN_POUND,
  [anon_sym_LPAREN_POUND_LF] = anon_sym_LPAREN_POUND_LF,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_u2237] = anon_sym_u2237,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [sym__immediate_dot] = sym__immediate_dot,
  [sym_pragma] = sym_pragma,
  [sym__immediate_varid] = sym_variable,
  [sym_label] = sym_label,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [sym_implicit_parid] = sym_implicit_parid,
  [sym__conid] = sym__conid,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_u2605] = anon_sym_u2605,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_family] = anon_sym_family,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_representational] = anon_sym_representational,
  [anon_sym_nominal] = anon_sym_nominal,
  [anon_sym_phantom] = anon_sym_phantom,
  [anon_sym__] = anon_sym__,
  [anon_sym_role] = anon_sym_role,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_thengroupby] = anon_sym_thengroupby,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_thengroupusing] = anon_sym_thengroupusing,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_cases] = anon_sym_cases,
  [anon_sym_rec] = anon_sym_rec,
  [anon_sym_mdo] = anon_sym_mdo,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_AT2] = anon_sym_AT,
  [anon_sym_pattern] = anon_sym_pattern,
  [anon_sym_hiding] = anon_sym_hiding,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_qualified] = anon_sym_qualified,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_via] = anon_sym_via,
  [anon_sym_stock] = anon_sym_stock,
  [anon_sym_newtype] = anon_sym_newtype,
  [anon_sym_anyclass] = anon_sym_anyclass,
  [anon_sym_deriving] = anon_sym_deriving,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_infixl] = anon_sym_infixl,
  [anon_sym_infixr] = anon_sym_infixr,
  [anon_sym_infix] = anon_sym_infix,
  [anon_sym_ccall] = anon_sym_ccall,
  [anon_sym_stdcall] = anon_sym_stdcall,
  [anon_sym_cplusplus] = anon_sym_cplusplus,
  [anon_sym_jvm] = anon_sym_jvm,
  [anon_sym_dotnet] = anon_sym_dotnet,
  [anon_sym_prim] = anon_sym_prim,
  [anon_sym_capi] = anon_sym_capi,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_safe] = anon_sym_safe,
  [anon_sym_interruptible] = anon_sym_interruptible,
  [anon_sym_foreign] = anon_sym_foreign,
  [anon_sym_export] = anon_sym_export,
  [sym_decl_special_fun_fixity] = sym_decl_special_fun_fixity,
  [anon_sym_u27e6] = anon_sym_u27e6,
  [anon_sym_PIPE_RBRACK] = anon_sym_PIPE_RBRACK,
  [anon_sym_u27e7] = anon_sym_u27e7,
  [aux_sym__token1] = aux_sym__token1,
  [sym__layout_semicolon] = sym__layout_semicolon,
  [sym__layout_start] = sym__layout_start,
  [sym__layout_end] = sym__layout_end,
  [sym__dot] = sym__dot,
  [sym__arith_dotdot] = sym__arith_dotdot,
  [sym_where] = sym_where,
  [sym__splice_dollar] = sym__splice_dollar,
  [sym__varsym] = sym__varsym,
  [sym__consym] = sym__consym,
  [sym__tyconsym] = sym__tyconsym,
  [sym_comment] = sym_comment,
  [sym_cpp] = sym_cpp,
  [sym_comma] = sym_comma,
  [sym_quasiquote_start] = sym_quasiquote_start,
  [sym_quasiquote_bar] = sym_quasiquote_bar,
  [sym_quasiquote_body] = sym_quasiquote_body,
  [sym__strict] = sym__strict,
  [sym__lazy] = sym__lazy,
  [sym__unboxed_close] = sym__unboxed_close,
  [sym_empty_file] = sym_empty_file,
  [sym_haskell] = sym_haskell,
  [sym__topdecl] = sym__topdecl,
  [sym_integer] = sym_integer,
  [sym__literal] = sym__literal,
  [sym__unboxed_open] = sym__unboxed_open,
  [sym__carrow] = sym__carrow,
  [sym__arrow] = sym__arrow,
  [sym__larrow] = sym__larrow,
  [sym__colon2] = sym__colon2,
  [sym_variable] = sym_variable,
  [sym__immediate_variable] = sym__immediate_variable,
  [sym_qualified_variable] = sym_qualified_variable,
  [sym_operator] = sym_operator,
  [sym__minus] = sym__minus,
  [sym_qualified_operator] = sym_qualified_operator,
  [sym_varop] = sym_varop,
  [sym__qvarop] = sym__qvarop,
  [sym__qvarop_nominus] = sym__qvarop_nominus,
  [sym_constructor] = sym_constructor,
  [sym_qualified_constructor] = sym_qualified_constructor,
  [sym_constructor_operator] = sym_constructor_operator,
  [sym_qualified_constructor_operator] = sym_qualified_constructor_operator,
  [sym__qcon] = sym__qcon,
  [sym__qop] = sym__qop,
  [sym_con_unit] = sym_con_unit,
  [sym_con_list] = sym_con_list,
  [sym_con_tuple] = sym_con_tuple,
  [sym_literal] = sym_literal,
  [sym_qualified_type] = sym_qualified_type,
  [sym__type_operator] = sym__type_operator,
  [sym_qualified_type_operator] = sym_qualified_type_operator,
  [sym__qualified_type_operator] = sym__qualified_type_operator,
  [sym__ticked_tycon] = sym__ticked_tycon,
  [sym__ticked_qtycon] = sym__ticked_tycon,
  [sym__qtyconops] = sym__qtyconops,
  [sym__promoted_tyconop] = sym__promoted_tyconop,
  [sym__qtyconop] = sym__qtyconop,
  [sym_tycon_arrow] = sym_tycon_arrow,
  [sym_type_literal] = sym_type_literal,
  [sym__promoted_tycon] = sym__promoted_tyconop,
  [sym__name] = sym__name,
  [sym_type_variable] = sym_type_variable,
  [sym_annotated_type_variable] = sym_annotated_type_variable,
  [sym_inferred_type_variable] = sym_inferred_type_variable,
  [sym__quantifier] = sym__quantifier,
  [sym__forall_kw] = sym__forall_kw,
  [sym__forall_dot] = sym__forall_dot,
  [sym__forall] = sym__forall,
  [sym_forall] = sym_forall,
  [sym_type_parens] = sym_type_parens,
  [sym_type_list] = sym_type_list,
  [sym__type_tuple] = sym__type_tuple,
  [sym_type_tuple] = sym_type_tuple,
  [sym__type_sum] = sym__type_sum,
  [sym__type_promotable_literal] = sym__type_promotable_literal,
  [sym__type_promoted_literal] = sym__promoted_tyconop,
  [sym__type_literal] = sym__type_literal,
  [sym_strict_type] = sym_strict_type,
  [sym_lazy_type] = sym_lazy_type,
  [sym_type_name] = sym_type_name,
  [sym_type_star] = sym_type_star,
  [sym_type_unboxed_tuple] = sym_type_unboxed_tuple,
  [sym_type_unboxed_sum] = sym_type_unboxed_sum,
  [sym__atype] = sym__atype,
  [sym_type_invisible] = sym_type_invisible,
  [sym_type_apply] = sym_type_apply,
  [sym__btype] = sym__btype,
  [sym_implicit_param] = sym_implicit_param,
  [sym_type_infix] = sym_type_infix,
  [sym__type_infix] = sym__type_infix,
  [sym_constraint] = sym_constraint,
  [sym__quantified_constraint] = sym_forall,
  [sym__constraint_context] = sym_context,
  [sym__constraint] = sym__constraint,
  [sym__context_constraints] = sym__context_constraints,
  [sym__context] = sym__context,
  [sym_context] = sym_context,
  [sym__type_quantifiers] = sym_forall,
  [sym__type_context] = sym_context,
  [sym_modifier] = sym_modifier,
  [sym__fun_arrow] = sym__fun_arrow,
  [sym__type_fun] = sym__type_fun,
  [sym__type] = sym__type,
  [sym__type_or_implicit] = sym__type_or_implicit,
  [sym__type_annotation] = sym__type_annotation,
  [sym_kind] = sym_kind,
  [sym__type_with_kind] = sym__type_with_kind,
  [sym__simpletype_infix] = sym_type_infix,
  [sym__simpletype] = sym__simpletype,
  [sym_decl_type] = sym_decl_type,
  [sym_tyfam_head] = sym_tyfam_head,
  [sym_tyfam_pat] = sym_tyfam_pat,
  [sym_tyfam_eq] = sym_tyfam_eq,
  [sym_tyfam_result_type] = sym_tyfam_result_type,
  [sym_tyfam_injectivity] = sym_tyfam_injectivity,
  [sym__tyfam_inj] = sym__tyfam_inj,
  [sym__tyfam] = sym__tyfam,
  [sym_decl_tyfam] = sym_decl_tyfam,
  [sym__tyinst] = sym__tyinst,
  [sym_decl_tyinst] = sym_decl_tyinst,
  [sym_type_role] = sym_type_role,
  [sym_decl_role] = sym_decl_role,
  [sym_exp_parens] = sym_exp_parens,
  [sym__exp_tuple] = sym__exp_tuple,
  [sym_exp_tuple] = sym_exp_tuple,
  [sym_exp_unboxed_tuple] = sym_exp_unboxed_tuple,
  [sym__exp_unboxed_sum] = sym__exp_unboxed_sum,
  [sym_exp_unboxed_sum] = sym_exp_unboxed_sum,
  [sym_exp_list] = sym_exp_list,
  [sym_bind_pattern] = sym_bind_pattern,
  [sym_exp_arithmetic_sequence] = sym_exp_arithmetic_sequence,
  [sym_transform] = sym_transform,
  [sym_qual] = sym_qual,
  [sym_exp_list_comprehension] = sym_exp_list_comprehension,
  [sym_exp_section_left] = sym_exp_section_left,
  [sym_exp_section_right] = sym_exp_section_right,
  [sym_exp_th_quoted_name] = sym_exp_th_quoted_name,
  [sym_exp_field] = sym_exp_field,
  [sym_exp_type_application] = sym_exp_type_application,
  [sym_exp_lambda] = sym_exp_lambda,
  [sym_exp_in] = sym_exp_in,
  [sym_let] = sym_let,
  [sym__let_decls] = sym_decls,
  [sym_exp_let] = sym_exp_let,
  [sym_exp_let_in] = sym_exp_let_in,
  [sym_exp_cond] = sym_exp_cond,
  [sym_pattern_guard] = sym_pattern_guard,
  [sym_guard] = sym_guard,
  [sym_guards] = sym_guards,
  [sym_gdpat] = sym_gdpat,
  [sym_exp_if_guard] = sym_exp_if_guard,
  [sym__alt_variants] = sym__alt_variants,
  [aux_sym__nalt_patterns] = aux_sym__nalt_patterns,
  [sym_alt] = sym_alt,
  [sym_nalt] = sym_nalt,
  [sym_alts] = sym_alts,
  [sym_nalts] = sym_nalts,
  [sym_exp_case] = sym_exp_case,
  [sym_exp_lambda_case] = sym_exp_lambda_case,
  [sym_exp_lambda_cases] = sym_exp_lambda_cases,
  [sym_rec] = sym_rec,
  [sym_stmt] = sym_stmt,
  [sym__do_keyword] = sym__do_keyword,
  [sym_do_module] = sym_do_module,
  [sym_exp_do] = sym_exp_do,
  [sym_exp_negation] = sym_exp_negation,
  [sym_exp_record] = sym_exp_record,
  [sym_exp_name] = sym_exp_name,
  [sym_exp_projection_selector] = sym_exp_projection_selector,
  [sym__aexp_projection] = sym__aexp_projection,
  [sym_exp_projection] = sym_exp_projection,
  [sym__aexp] = sym__aexp,
  [sym__exp_apply] = sym__exp_apply,
  [sym__fexp] = sym__fexp,
  [sym__lexp] = sym__lexp,
  [sym_exp_infix] = sym_exp_infix,
  [sym__exp_infix] = sym__exp_infix,
  [sym__exp] = sym__exp,
  [sym_pat_field] = sym_pat_field,
  [sym_pat_fields] = sym_pat_fields,
  [sym_pat_name] = sym_pat_name,
  [sym_pat_as] = sym_pat_as,
  [sym__pat_constructor] = sym__pat_constructor,
  [sym_pat_record] = sym_pat_record,
  [sym_pat_wildcard] = sym_pat_wildcard,
  [sym_pat_parens] = sym_pat_parens,
  [sym_pat_tuple] = sym_pat_tuple,
  [sym_pat_unboxed_tuple] = sym_pat_unboxed_tuple,
  [sym__pat_unboxed_sum] = sym__pat_unboxed_sum,
  [sym_pat_unboxed_sum] = sym_pat_unboxed_sum,
  [sym_pat_list] = sym_pat_list,
  [sym_pat_strict] = sym_pat_strict,
  [sym_pat_irrefutable] = sym_pat_irrefutable,
  [sym_pat_type_binder] = sym_pat_type_binder,
  [sym__apat] = sym__apat,
  [sym_pat_negation] = sym_pat_negation,
  [sym_pat_apply] = sym_pat_apply,
  [sym__lpat] = sym__lpat,
  [sym_pat_infix] = sym_pat_infix,
  [sym__pat] = sym__pat,
  [sym_pat_typed] = sym_pat_typed,
  [sym__typed_pat] = sym__typed_pat,
  [sym_pat_view] = sym_pat_view,
  [sym__nested_pat] = sym__nested_pat,
  [sym__import_name] = sym__import_name,
  [sym_namespace] = sym_namespace,
  [sym_import_con_names] = sym_import_con_names,
  [sym_import_item] = sym_import_item,
  [sym_import_list] = sym_import_list,
  [sym_decl_import] = sym_decl_import,
  [sym__modid] = sym__modid,
  [aux_sym__qualifying_module] = aux_sym__qualifying_module,
  [sym_qualified_module] = sym_qualified_module,
  [sym__qmodid] = sym__qmodid,
  [sym_export_names] = sym_export_names,
  [sym_export] = sym_export,
  [sym_exports] = sym_exports,
  [sym__module] = sym__module,
  [sym_field] = sym_field,
  [sym_data_constructor] = sym_data_constructor,
  [sym_data_constructor_infix] = sym_data_constructor_infix,
  [sym__record_field] = sym__record_field,
  [sym_record_fields] = sym_record_fields,
  [sym_data_constructor_record] = sym_data_constructor_record,
  [sym_data_constructor_special] = sym_data_constructor_special,
  [sym_constructors] = sym_constructors,
  [sym_via] = sym_via,
  [sym_deriving_strategy] = sym_deriving_strategy,
  [sym_deriving] = sym_deriving,
  [sym__adt_rhs] = sym__adt_rhs,
  [sym__gadt_fun] = sym__type_fun,
  [sym__gadt_sig] = sym__gadt_sig,
  [sym__gadt_constr_type] = sym__gadt_constr_type,
  [sym_gadt_constructor] = sym_gadt_constructor,
  [sym__gadt_rhs] = sym__gadt_rhs,
  [sym__adt] = sym__adt,
  [sym_decl_adt] = sym_decl_adt,
  [sym_newtype_constructor] = sym_newtype_constructor,
  [sym__newtype] = sym__newtype,
  [sym__context_newtype] = sym__context_newtype,
  [sym_decl_newtype] = sym_decl_newtype,
  [sym__datafam] = sym__datafam,
  [sym_decl_datafam] = sym_decl_datafam,
  [sym__datainst] = sym__datainst,
  [sym_decl_datainst] = sym_decl_datainst,
  [sym_default_signature] = sym_default_signature,
  [sym_class_datafam] = sym_decl_datafam,
  [sym_class_tyfam] = sym_decl_tyfam,
  [sym__cdecl] = sym__cdecl,
  [sym_fundep] = sym_fundep,
  [sym_fundeps] = sym_fundeps,
  [sym_class_body] = sym_class_body,
  [sym_decl_class] = sym_decl_class,
  [sym_inst_datainst] = sym_decl_datainst,
  [sym_inst_tyinst] = sym_decl_tyinst,
  [sym__idecl] = sym__idecl,
  [sym__instance] = sym__instance,
  [sym_decl_instance] = sym_decl_instance,
  [sym_decl_deriving] = sym_decl_deriving,
  [sym__funpat_infix] = sym__funpat_infix,
  [sym__funpat] = sym_function,
  [sym__fun_name] = sym__fun_name,
  [sym_guard_equation] = sym_guard_equation,
  [aux_sym__fun_guards] = aux_sym__fun_guards,
  [sym__funrhs] = sym__funrhs,
  [aux_sym__fun_patterns] = aux_sym__fun_patterns,
  [sym__funvar] = sym__funvar,
  [sym__funlhs] = sym__funlhs,
  [sym_function] = sym_function,
  [sym_fixity] = sym_fixity,
  [sym_signature] = sym_signature,
  [sym__gendecl] = sym__gendecl,
  [sym__decl_fun] = sym__decl_fun,
  [sym__decl] = sym__decl,
  [sym_decls] = sym_decls,
  [sym_calling_convention] = sym_calling_convention,
  [sym_safety] = sym_safety,
  [sym_impent] = sym_impent,
  [sym_expent] = sym_expent,
  [sym__foreign_pre] = sym__foreign_pre,
  [sym_decl_foreign_import] = sym_decl_foreign_import,
  [sym_decl_foreign_export] = sym_decl_foreign_export,
  [sym__decl_foreign] = sym__decl_foreign,
  [sym_decl_special] = sym_decl_special,
  [sym__pattern_type] = sym_signature,
  [sym__pattern_equals] = sym_tyfam_eq,
  [sym__pattern_decl] = sym__pattern_decl,
  [sym__pattern_arrow] = sym_tyfam_eq,
  [sym_decl_pattern] = sym_decl_pattern,
  [sym_decl_default] = sym_decl_default,
  [sym__splice_exp] = sym__splice_exp,
  [sym_splice] = sym_splice,
  [sym_top_splice] = sym_top_splice,
  [sym_quasiquote] = sym_quasiquote,
  [aux_sym_haskell_repeat1] = aux_sym_haskell_repeat1,
  [aux_sym_con_tuple_repeat1] = aux_sym_con_tuple_repeat1,
  [aux_sym__forall_repeat1] = aux_sym__forall_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym__type_sum_repeat1] = aux_sym__type_sum_repeat1,
  [aux_sym_type_apply_repeat1] = aux_sym_type_apply_repeat1,
  [aux_sym_constraint_repeat1] = aux_sym_constraint_repeat1,
  [aux_sym__context_constraints_repeat1] = aux_sym__context_constraints_repeat1,
  [aux_sym__simpletype_repeat1] = aux_sym__simpletype_repeat1,
  [aux_sym_tyfam_injectivity_repeat1] = aux_sym_tyfam_injectivity_repeat1,
  [aux_sym_decl_tyfam_repeat1] = aux_sym_decl_tyfam_repeat1,
  [aux_sym_decl_tyfam_repeat2] = aux_sym_decl_tyfam_repeat2,
  [aux_sym_decl_tyfam_repeat3] = aux_sym_decl_tyfam_repeat3,
  [aux_sym_decl_role_repeat1] = aux_sym_decl_role_repeat1,
  [aux_sym__exp_tuple_repeat1] = aux_sym__exp_tuple_repeat1,
  [aux_sym__exp_unboxed_sum_repeat1] = aux_sym__exp_unboxed_sum_repeat1,
  [aux_sym_exp_list_repeat1] = aux_sym_exp_list_repeat1,
  [aux_sym_exp_list_comprehension_repeat1] = aux_sym_exp_list_comprehension_repeat1,
  [aux_sym_exp_field_repeat1] = aux_sym_exp_field_repeat1,
  [aux_sym_exp_lambda_repeat1] = aux_sym_exp_lambda_repeat1,
  [aux_sym__let_decls_repeat1] = aux_sym__let_decls_repeat1,
  [aux_sym__let_decls_repeat2] = aux_sym__let_decls_repeat2,
  [aux_sym_guards_repeat1] = aux_sym_guards_repeat1,
  [aux_sym_exp_if_guard_repeat1] = aux_sym_exp_if_guard_repeat1,
  [aux_sym_alts_repeat1] = aux_sym_alts_repeat1,
  [aux_sym_alts_repeat2] = aux_sym_alts_repeat2,
  [aux_sym_nalts_repeat1] = aux_sym_nalts_repeat1,
  [aux_sym_nalts_repeat2] = aux_sym_nalts_repeat2,
  [aux_sym_rec_repeat1] = aux_sym_rec_repeat1,
  [aux_sym_rec_repeat2] = aux_sym_rec_repeat2,
  [aux_sym_exp_record_repeat1] = aux_sym_exp_record_repeat1,
  [aux_sym_exp_projection_selector_repeat1] = aux_sym_exp_projection_selector_repeat1,
  [aux_sym_pat_fields_repeat1] = aux_sym_pat_fields_repeat1,
  [aux_sym_pat_tuple_repeat1] = aux_sym_pat_tuple_repeat1,
  [aux_sym__pat_unboxed_sum_repeat1] = aux_sym__pat_unboxed_sum_repeat1,
  [aux_sym_import_con_names_repeat1] = aux_sym_import_con_names_repeat1,
  [aux_sym_import_list_repeat1] = aux_sym_import_list_repeat1,
  [aux_sym_export_names_repeat1] = aux_sym_export_names_repeat1,
  [aux_sym_exports_repeat1] = aux_sym_exports_repeat1,
  [aux_sym__module_repeat1] = aux_sym__module_repeat1,
  [aux_sym_field_repeat1] = aux_sym_field_repeat1,
  [aux_sym_data_constructor_repeat1] = aux_sym_data_constructor_repeat1,
  [aux_sym_record_fields_repeat1] = aux_sym_record_fields_repeat1,
  [aux_sym_constructors_repeat1] = aux_sym_constructors_repeat1,
  [aux_sym_deriving_repeat1] = aux_sym_deriving_repeat1,
  [aux_sym__adt_rhs_repeat1] = aux_sym__adt_rhs_repeat1,
  [aux_sym__gadt_rhs_repeat1] = aux_sym__gadt_rhs_repeat1,
  [aux_sym__gadt_rhs_repeat2] = aux_sym__gadt_rhs_repeat2,
  [aux_sym_fundeps_repeat1] = aux_sym_fundeps_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_class_body_repeat2] = aux_sym_class_body_repeat2,
  [aux_sym_decl_instance_repeat1] = aux_sym_decl_instance_repeat1,
  [aux_sym_decl_instance_repeat2] = aux_sym_decl_instance_repeat2,
  [aux_sym_fixity_repeat1] = aux_sym_fixity_repeat1,
  [aux_sym_signature_repeat1] = aux_sym_signature_repeat1,
  [aux_sym__pattern_arrow_repeat1] = aux_sym__pattern_arrow_repeat1,
  [aux_sym__pattern_arrow_repeat2] = aux_sym__pattern_arrow_repeat2,
  [aux_sym_decl_default_repeat1] = aux_sym_decl_default_repeat1,
  [alias_sym_all_names] = alias_sym_all_names,
  [alias_sym_class_head] = alias_sym_class_head,
  [alias_sym_class_name] = alias_sym_class_name,
  [alias_sym_exp_apply] = alias_sym_exp_apply,
  [alias_sym_import_package] = alias_sym_import_package,
  [alias_sym_instance_head] = alias_sym_instance_head,
  [alias_sym_module] = alias_sym_module,
  [alias_sym_nalt_patterns] = alias_sym_nalt_patterns,
  [alias_sym_pat_literal] = alias_sym_pat_literal,
  [alias_sym_patterns] = alias_sym_patterns,
  [alias_sym_quoter] = alias_sym_quoter,
  [alias_sym_type] = alias_sym_type,
  [alias_sym_wildcard] = alias_sym_wildcard,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__varid] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__integer_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LPAREN_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_POUND_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2237] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym__immediate_dot] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_varid] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_implicit_parid] = {
    .visible = true,
    .named = true,
  },
  [sym__conid] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2605] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_family] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_representational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nominal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_phantom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_role] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thengroupby] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thengroupusing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cases] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mdo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hiding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qualified] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_via] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyclass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deriving] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ccall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cplusplus] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_jvm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dotnet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prim] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_capi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_safe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interruptible] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreign] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [sym_decl_special_fun_fixity] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u27e6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27e7] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__token1] = {
    .visible = false,
    .named = false,
  },
  [sym__layout_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__dot] = {
    .visible = false,
    .named = true,
  },
  [sym__arith_dotdot] = {
    .visible = false,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym__splice_dollar] = {
    .visible = false,
    .named = true,
  },
  [sym__varsym] = {
    .visible = false,
    .named = true,
  },
  [sym__consym] = {
    .visible = false,
    .named = true,
  },
  [sym__tyconsym] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_cpp] = {
    .visible = true,
    .named = true,
  },
  [sym_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_start] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_bar] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_body] = {
    .visible = true,
    .named = true,
  },
  [sym__strict] = {
    .visible = false,
    .named = true,
  },
  [sym__lazy] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_close] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_file] = {
    .visible = true,
    .named = true,
  },
  [sym_haskell] = {
    .visible = true,
    .named = true,
  },
  [sym__topdecl] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_open] = {
    .visible = false,
    .named = true,
  },
  [sym__carrow] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__larrow] = {
    .visible = false,
    .named = true,
  },
  [sym__colon2] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__minus] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_varop] = {
    .visible = true,
    .named = true,
  },
  [sym__qvarop] = {
    .visible = false,
    .named = true,
  },
  [sym__qvarop_nominus] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__qcon] = {
    .visible = false,
    .named = true,
  },
  [sym__qop] = {
    .visible = false,
    .named = true,
  },
  [sym_con_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_con_list] = {
    .visible = true,
    .named = true,
  },
  [sym_con_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym__type_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_type_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_type_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__ticked_tycon] = {
    .visible = true,
    .named = true,
  },
  [sym__ticked_qtycon] = {
    .visible = true,
    .named = true,
  },
  [sym__qtyconops] = {
    .visible = false,
    .named = true,
  },
  [sym__promoted_tyconop] = {
    .visible = true,
    .named = true,
  },
  [sym__qtyconop] = {
    .visible = false,
    .named = true,
  },
  [sym_tycon_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_type_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__promoted_tycon] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_annotated_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_inferred_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__quantifier] = {
    .visible = false,
    .named = true,
  },
  [sym__forall_kw] = {
    .visible = false,
    .named = true,
  },
  [sym__forall_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__forall] = {
    .visible = true,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym__type_tuple] = {
    .visible = false,
    .named = true,
  },
  [sym_type_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__type_sum] = {
    .visible = false,
    .named = true,
  },
  [sym__type_promotable_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__type_promoted_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__type_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_strict_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lazy_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_star] = {
    .visible = true,
    .named = true,
  },
  [sym_type_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_type_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym__atype] = {
    .visible = false,
    .named = true,
  },
  [sym_type_invisible] = {
    .visible = true,
    .named = true,
  },
  [sym_type_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__btype] = {
    .visible = false,
    .named = true,
  },
  [sym_implicit_param] = {
    .visible = true,
    .named = true,
  },
  [sym_type_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__type_infix] = {
    .visible = false,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__quantified_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__constraint_context] = {
    .visible = true,
    .named = true,
  },
  [sym__constraint] = {
    .visible = false,
    .named = true,
  },
  [sym__context_constraints] = {
    .visible = false,
    .named = true,
  },
  [sym__context] = {
    .visible = false,
    .named = true,
  },
  [sym_context] = {
    .visible = true,
    .named = true,
  },
  [sym__type_quantifiers] = {
    .visible = true,
    .named = true,
  },
  [sym__type_context] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__type_fun] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_or_implicit] = {
    .visible = false,
    .named = true,
  },
  [sym__type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_kind] = {
    .visible = true,
    .named = true,
  },
  [sym__type_with_kind] = {
    .visible = false,
    .named = true,
  },
  [sym__simpletype_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__simpletype] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_head] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_pat] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_result_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_injectivity] = {
    .visible = true,
    .named = true,
  },
  [sym__tyfam_inj] = {
    .visible = false,
    .named = true,
  },
  [sym__tyfam] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_tyfam] = {
    .visible = true,
    .named = true,
  },
  [sym__tyinst] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_tyinst] = {
    .visible = true,
    .named = true,
  },
  [sym_type_role] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_role] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_tuple] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_unboxed_sum] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_list] = {
    .visible = true,
    .named = true,
  },
  [sym_bind_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_arithmetic_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_transform] = {
    .visible = true,
    .named = true,
  },
  [sym_qual] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_section_left] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_section_right] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_th_quoted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_field] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_type_application] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_in] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym__let_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_let] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_let_in] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_cond] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guards] = {
    .visible = true,
    .named = true,
  },
  [sym_gdpat] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_if_guard] = {
    .visible = true,
    .named = true,
  },
  [sym__alt_variants] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__nalt_patterns] = {
    .visible = false,
    .named = false,
  },
  [sym_alt] = {
    .visible = true,
    .named = true,
  },
  [sym_nalt] = {
    .visible = true,
    .named = true,
  },
  [sym_alts] = {
    .visible = true,
    .named = true,
  },
  [sym_nalts] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_case] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_lambda_case] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_lambda_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_rec] = {
    .visible = true,
    .named = true,
  },
  [sym_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__do_keyword] = {
    .visible = false,
    .named = true,
  },
  [sym_do_module] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_do] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_record] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_name] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_projection_selector] = {
    .visible = true,
    .named = true,
  },
  [sym__aexp_projection] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_projection] = {
    .visible = true,
    .named = true,
  },
  [sym__aexp] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_apply] = {
    .visible = false,
    .named = true,
  },
  [sym__fexp] = {
    .visible = false,
    .named = true,
  },
  [sym__lexp] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_infix] = {
    .visible = false,
    .named = true,
  },
  [sym__exp] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_field] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_name] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_as] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_constructor] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_record] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_unboxed_sum] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_list] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_strict] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_irrefutable] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_type_binder] = {
    .visible = true,
    .named = true,
  },
  [sym__apat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__lpat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__pat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_typed] = {
    .visible = true,
    .named = true,
  },
  [sym__typed_pat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_view] = {
    .visible = true,
    .named = true,
  },
  [sym__nested_pat] = {
    .visible = false,
    .named = true,
  },
  [sym__import_name] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym_import_con_names] = {
    .visible = true,
    .named = true,
  },
  [sym_import_item] = {
    .visible = true,
    .named = true,
  },
  [sym_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_import] = {
    .visible = true,
    .named = true,
  },
  [sym__modid] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__qualifying_module] = {
    .visible = false,
    .named = false,
  },
  [sym_qualified_module] = {
    .visible = true,
    .named = true,
  },
  [sym__qmodid] = {
    .visible = false,
    .named = true,
  },
  [sym_export_names] = {
    .visible = true,
    .named = true,
  },
  [sym_export] = {
    .visible = true,
    .named = true,
  },
  [sym_exports] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__record_field] = {
    .visible = false,
    .named = true,
  },
  [sym_record_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_record] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_special] = {
    .visible = true,
    .named = true,
  },
  [sym_constructors] = {
    .visible = true,
    .named = true,
  },
  [sym_via] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving_strategy] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving] = {
    .visible = true,
    .named = true,
  },
  [sym__adt_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym__gadt_fun] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt_sig] = {
    .visible = false,
    .named = true,
  },
  [sym__gadt_constr_type] = {
    .visible = false,
    .named = true,
  },
  [sym_gadt_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym__adt] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_adt] = {
    .visible = true,
    .named = true,
  },
  [sym_newtype_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__newtype] = {
    .visible = false,
    .named = true,
  },
  [sym__context_newtype] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym__datafam] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_datafam] = {
    .visible = true,
    .named = true,
  },
  [sym__datainst] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_datainst] = {
    .visible = true,
    .named = true,
  },
  [sym_default_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_class_datafam] = {
    .visible = true,
    .named = true,
  },
  [sym_class_tyfam] = {
    .visible = true,
    .named = true,
  },
  [sym__cdecl] = {
    .visible = false,
    .named = true,
  },
  [sym_fundep] = {
    .visible = true,
    .named = true,
  },
  [sym_fundeps] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_class] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_datainst] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_tyinst] = {
    .visible = true,
    .named = true,
  },
  [sym__idecl] = {
    .visible = false,
    .named = true,
  },
  [sym__instance] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_deriving] = {
    .visible = true,
    .named = true,
  },
  [sym__funpat_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__funpat] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_name] = {
    .visible = false,
    .named = true,
  },
  [sym_guard_equation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__fun_guards] = {
    .visible = false,
    .named = false,
  },
  [sym__funrhs] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__fun_patterns] = {
    .visible = false,
    .named = false,
  },
  [sym__funvar] = {
    .visible = false,
    .named = true,
  },
  [sym__funlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_fixity] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__gendecl] = {
    .visible = false,
    .named = true,
  },
  [sym__decl_fun] = {
    .visible = false,
    .named = true,
  },
  [sym__decl] = {
    .visible = false,
    .named = true,
  },
  [sym_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_safety] = {
    .visible = true,
    .named = true,
  },
  [sym_impent] = {
    .visible = true,
    .named = true,
  },
  [sym_expent] = {
    .visible = true,
    .named = true,
  },
  [sym__foreign_pre] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_foreign_import] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_foreign_export] = {
    .visible = true,
    .named = true,
  },
  [sym__decl_foreign] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_special] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_type] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_equals] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_decl] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_default] = {
    .visible = true,
    .named = true,
  },
  [sym__splice_exp] = {
    .visible = false,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_top_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_haskell_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_con_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__forall_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_apply_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraint_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__context_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simpletype_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tyfam_injectivity_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_tyfam_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_tyfam_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_tyfam_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_role_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_unboxed_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_list_comprehension_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_lambda_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__let_decls_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__let_decls_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_guards_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_if_guard_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alts_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_nalts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_nalts_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rec_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_record_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_projection_selector_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pat_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pat_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pat_unboxed_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_con_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructor_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_deriving_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__adt_rhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__gadt_rhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__gadt_rhs_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fundeps_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_instance_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_instance_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fixity_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_arrow_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_arrow_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_default_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_all_names] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_class_head] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_class_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_exp_apply] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_package] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_instance_head] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_module] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_nalt_patterns] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pat_literal] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_patterns] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_quoter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_class = 1,
  field_con = 2,
  field_else = 3,
  field_field = 4,
  field_fields = 5,
  field_from = 6,
  field_if = 7,
  field_infix = 8,
  field_left = 9,
  field_lhs = 10,
  field_module = 11,
  field_name = 12,
  field_op = 13,
  field_pat = 14,
  field_pattern = 15,
  field_patterns = 16,
  field_rhs = 17,
  field_right = 18,
  field_step = 19,
  field_subfield = 20,
  field_then = 21,
  field_to = 22,
  field_type = 23,
  field_var = 24,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_class] = "class",
  [field_con] = "con",
  [field_else] = "else",
  [field_field] = "field",
  [field_fields] = "fields",
  [field_from] = "from",
  [field_if] = "if",
  [field_infix] = "infix",
  [field_left] = "left",
  [field_lhs] = "lhs",
  [field_module] = "module",
  [field_name] = "name",
  [field_op] = "op",
  [field_pat] = "pat",
  [field_pattern] = "pattern",
  [field_patterns] = "patterns",
  [field_rhs] = "rhs",
  [field_right] = "right",
  [field_step] = "step",
  [field_subfield] = "subfield",
  [field_then] = "then",
  [field_to] = "to",
  [field_type] = "type",
  [field_var] = "var",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [6] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 4},
  [8] = {.index = 6, .length = 3},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 2},
  [13] = {.index = 0, .length = 1},
  [14] = {.index = 12, .length = 1},
  [16] = {.index = 13, .length = 1},
  [17] = {.index = 14, .length = 2},
  [18] = {.index = 16, .length = 3},
  [19] = {.index = 19, .length = 1},
  [21] = {.index = 20, .length = 1},
  [22] = {.index = 21, .length = 3},
  [23] = {.index = 24, .length = 2},
  [24] = {.index = 26, .length = 2},
  [25] = {.index = 28, .length = 3},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 33, .length = 5},
  [28] = {.index = 38, .length = 3},
  [30] = {.index = 41, .length = 1},
  [31] = {.index = 42, .length = 1},
  [32] = {.index = 43, .length = 2},
  [35] = {.index = 45, .length = 1},
  [36] = {.index = 46, .length = 2},
  [38] = {.index = 48, .length = 2},
  [39] = {.index = 50, .length = 1},
  [40] = {.index = 51, .length = 2},
  [41] = {.index = 53, .length = 1},
  [42] = {.index = 54, .length = 5},
  [43] = {.index = 59, .length = 2},
  [44] = {.index = 61, .length = 1},
  [46] = {.index = 62, .length = 1},
  [47] = {.index = 63, .length = 3},
  [48] = {.index = 66, .length = 2},
  [50] = {.index = 68, .length = 5},
  [51] = {.index = 73, .length = 2},
  [52] = {.index = 75, .length = 2},
  [53] = {.index = 77, .length = 2},
  [55] = {.index = 79, .length = 1},
  [56] = {.index = 80, .length = 2},
  [58] = {.index = 82, .length = 3},
  [59] = {.index = 85, .length = 1},
  [60] = {.index = 86, .length = 2},
  [61] = {.index = 88, .length = 2},
  [63] = {.index = 90, .length = 2},
  [64] = {.index = 92, .length = 1},
  [65] = {.index = 92, .length = 1},
  [66] = {.index = 93, .length = 2},
  [67] = {.index = 95, .length = 1},
  [68] = {.index = 96, .length = 2},
  [69] = {.index = 98, .length = 2},
  [70] = {.index = 100, .length = 7},
  [71] = {.index = 107, .length = 3},
  [72] = {.index = 110, .length = 4},
  [73] = {.index = 114, .length = 2},
  [74] = {.index = 116, .length = 3},
  [75] = {.index = 119, .length = 1},
  [76] = {.index = 119, .length = 1},
  [77] = {.index = 120, .length = 3},
  [78] = {.index = 123, .length = 3},
  [79] = {.index = 126, .length = 1},
  [80] = {.index = 127, .length = 2},
  [81] = {.index = 129, .length = 2},
  [82] = {.index = 131, .length = 4},
  [83] = {.index = 135, .length = 1},
  [84] = {.index = 136, .length = 6},
  [85] = {.index = 142, .length = 2},
  [86] = {.index = 144, .length = 4},
  [87] = {.index = 148, .length = 3},
  [88] = {.index = 151, .length = 6},
  [89] = {.index = 157, .length = 2},
  [90] = {.index = 159, .length = 6},
  [91] = {.index = 165, .length = 6},
  [93] = {.index = 171, .length = 2},
  [94] = {.index = 173, .length = 2},
  [95] = {.index = 175, .length = 1},
  [96] = {.index = 176, .length = 4},
  [97] = {.index = 180, .length = 1},
  [98] = {.index = 181, .length = 6},
  [99] = {.index = 187, .length = 2},
  [100] = {.index = 189, .length = 4},
  [101] = {.index = 193, .length = 2},
  [102] = {.index = 195, .length = 5},
  [103] = {.index = 200, .length = 6},
  [104] = {.index = 206, .length = 4},
  [105] = {.index = 210, .length = 4},
  [106] = {.index = 214, .length = 6},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_module, 0, .inherited = true},
  [2] =
    {field_infix, 0},
    {field_lhs, 0, .inherited = true},
    {field_op, 0, .inherited = true},
    {field_rhs, 0, .inherited = true},
  [6] =
    {field_pattern, 0, .inherited = true},
    {field_rhs, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [9] =
    {field_name, 0, .inherited = true},
  [10] =
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [12] =
    {field_class, 0},
  [13] =
    {field_type, 1, .inherited = true},
  [14] =
    {field_lhs, 1, .inherited = true},
    {field_rhs, 1, .inherited = true},
  [16] =
    {field_lhs, 1, .inherited = true},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [19] =
    {field_name, 1, .inherited = true},
  [20] =
    {field_type, 0, .inherited = true},
  [21] =
    {field_name, 0},
    {field_type, 1},
    {field_type, 1, .inherited = true},
  [24] =
    {field_con, 0},
    {field_fields, 1},
  [26] =
    {field_pattern, 0},
    {field_type, 1, .inherited = true},
  [28] =
    {field_pattern, 0},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [31] =
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [33] =
    {field_infix, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [38] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
  [41] =
    {field_type, 2, .inherited = true},
  [42] =
    {field_name, 2, .inherited = true},
  [43] =
    {field_name, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [45] =
    {field_module, 1},
  [46] =
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [48] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [50] =
    {field_name, 1},
  [51] =
    {field_pat, 2},
    {field_var, 0},
  [53] =
    {field_type, 1},
  [54] =
    {field_lhs, 1},
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_type, 2},
    {field_type, 2, .inherited = true},
  [59] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [61] =
    {field_field, 2},
  [62] =
    {field_field, 0},
  [63] =
    {field_lhs, 0},
    {field_op, 1},
    {field_rhs, 2},
  [66] =
    {field_rhs, 1},
    {field_type, 1, .inherited = true},
  [68] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [73] =
    {field_type, 0, .inherited = true},
    {field_type, 2, .inherited = true},
  [75] =
    {field_type, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [77] =
    {field_from, 1},
    {field_type, 1, .inherited = true},
  [79] =
    {field_name, 3, .inherited = true},
  [80] =
    {field_name, 2, .inherited = true},
    {field_type, 3, .inherited = true},
  [82] =
    {field_left, 0},
    {field_op, 1},
    {field_right, 2},
  [85] =
    {field_type, 3, .inherited = true},
  [86] =
    {field_rhs, 2},
    {field_type, 2, .inherited = true},
  [88] =
    {field_lhs, 0},
    {field_rhs, 2},
  [90] =
    {field_name, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [92] =
    {field_class, 1},
  [93] =
    {field_field, 0},
    {field_subfield, 1, .inherited = true},
  [95] =
    {field_field, 1},
  [96] =
    {field_field, 2},
    {field_field, 3, .inherited = true},
  [98] =
    {field_field, 0, .inherited = true},
    {field_field, 1, .inherited = true},
  [100] =
    {field_lhs, 3},
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
    {field_name, 3, .inherited = true},
    {field_type, 4},
    {field_type, 4, .inherited = true},
  [107] =
    {field_type, 0, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type, 3, .inherited = true},
  [110] =
    {field_from, 1},
    {field_to, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [114] =
    {field_name, 3, .inherited = true},
    {field_type, 4, .inherited = true},
  [116] =
    {field_patterns, 0},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [119] =
    {field_class, 2},
  [120] =
    {field_name, 1},
    {field_name, 2},
    {field_name, 3},
  [123] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
  [126] =
    {field_subfield, 1},
  [127] =
    {field_field, 0},
    {field_type, 2, .inherited = true},
  [129] =
    {field_subfield, 0, .inherited = true},
    {field_subfield, 1, .inherited = true},
  [131] =
    {field_from, 1},
    {field_step, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [135] =
    {field_name, 3},
  [136] =
    {field_else, 5},
    {field_if, 1},
    {field_then, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_type, 5, .inherited = true},
  [142] =
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [144] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
    {field_subfield, 3, .inherited = true},
  [148] =
    {field_field, 0},
    {field_subfield, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [151] =
    {field_from, 1},
    {field_step, 3},
    {field_to, 5},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_type, 5, .inherited = true},
  [157] =
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [159] =
    {field_else, 6},
    {field_if, 1},
    {field_then, 4},
    {field_type, 1, .inherited = true},
    {field_type, 4, .inherited = true},
    {field_type, 6, .inherited = true},
  [165] =
    {field_else, 6},
    {field_if, 1},
    {field_then, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_type, 6, .inherited = true},
  [171] =
    {field_class, 2},
    {field_class, 3, .inherited = true},
  [173] =
    {field_class, 0, .inherited = true},
    {field_class, 1, .inherited = true},
  [175] =
    {field_class, 3},
  [176] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
    {field_type, 4, .inherited = true},
  [180] =
    {field_op, 1},
  [181] =
    {field_else, 7},
    {field_if, 1},
    {field_then, 4},
    {field_type, 1, .inherited = true},
    {field_type, 4, .inherited = true},
    {field_type, 7, .inherited = true},
  [187] =
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [189] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 5, .inherited = true},
    {field_type, 5, .inherited = true},
  [193] =
    {field_class, 3},
    {field_class, 4, .inherited = true},
  [195] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
    {field_subfield, 3, .inherited = true},
    {field_type, 5, .inherited = true},
  [200] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 5, .inherited = true},
    {field_rhs, 6, .inherited = true},
    {field_type, 5, .inherited = true},
    {field_type, 6, .inherited = true},
  [206] =
    {field_rhs, 0, .inherited = true},
    {field_rhs, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [210] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 6, .inherited = true},
    {field_type, 6, .inherited = true},
  [214] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 6, .inherited = true},
    {field_rhs, 7, .inherited = true},
    {field_type, 6, .inherited = true},
    {field_type, 7, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = alias_sym_module,
  },
  [3] = {
    [0] = sym_pat_name,
  },
  [4] = {
    [0] = alias_sym_pat_literal,
  },
  [5] = {
    [0] = alias_sym_exp_apply,
  },
  [11] = {
    [0] = sym_operator,
  },
  [12] = {
    [0] = alias_sym_type,
  },
  [13] = {
    [0] = alias_sym_type,
  },
  [14] = {
    [0] = alias_sym_class_name,
  },
  [15] = {
    [1] = alias_sym_instance_head,
  },
  [20] = {
    [1] = alias_sym_class_head,
  },
  [26] = {
    [1] = alias_sym_patterns,
  },
  [29] = {
    [1] = alias_sym_type,
  },
  [33] = {
    [2] = alias_sym_instance_head,
  },
  [34] = {
    [1] = alias_sym_import_package,
  },
  [37] = {
    [2] = alias_sym_class_head,
  },
  [45] = {
    [0] = alias_sym_wildcard,
  },
  [49] = {
    [1] = alias_sym_quoter,
  },
  [54] = {
    [2] = alias_sym_type,
  },
  [57] = {
    [3] = alias_sym_instance_head,
  },
  [62] = {
    [2] = alias_sym_import_package,
  },
  [64] = {
    [1] = alias_sym_type,
  },
  [74] = {
    [0] = alias_sym_nalt_patterns,
  },
  [75] = {
    [2] = alias_sym_type,
  },
  [92] = {
    [1] = alias_sym_all_names,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_constructor, 3,
    sym_constructor,
    alias_sym_module,
    alias_sym_type,
  sym__qcon, 2,
    sym__qcon,
    sym_pat_name,
  sym_literal, 2,
    sym_literal,
    alias_sym_pat_literal,
  sym_type_name, 2,
    sym_type_name,
    alias_sym_class_name,
  sym_constraint, 3,
    sym_constraint,
    alias_sym_class_head,
    alias_sym_instance_head,
  aux_sym__nalt_patterns, 2,
    aux_sym__nalt_patterns,
    alias_sym_nalt_patterns,
  sym__exp_apply, 2,
    sym__exp_apply,
    alias_sym_exp_apply,
  aux_sym__fun_patterns, 2,
    aux_sym__fun_patterns,
    alias_sym_patterns,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 14,
  [16] = 16,
  [17] = 17,
  [18] = 17,
  [19] = 17,
  [20] = 17,
  [21] = 17,
  [22] = 17,
  [23] = 16,
  [24] = 17,
  [25] = 17,
  [26] = 17,
  [27] = 17,
  [28] = 17,
  [29] = 17,
  [30] = 16,
  [31] = 17,
  [32] = 17,
  [33] = 17,
  [34] = 17,
  [35] = 17,
  [36] = 17,
  [37] = 17,
  [38] = 17,
  [39] = 17,
  [40] = 17,
  [41] = 17,
  [42] = 17,
  [43] = 17,
  [44] = 44,
  [45] = 44,
  [46] = 46,
  [47] = 44,
  [48] = 44,
  [49] = 44,
  [50] = 46,
  [51] = 44,
  [52] = 44,
  [53] = 44,
  [54] = 44,
  [55] = 44,
  [56] = 44,
  [57] = 44,
  [58] = 44,
  [59] = 44,
  [60] = 44,
  [61] = 61,
  [62] = 44,
  [63] = 44,
  [64] = 44,
  [65] = 44,
  [66] = 46,
  [67] = 44,
  [68] = 44,
  [69] = 44,
  [70] = 44,
  [71] = 44,
  [72] = 44,
  [73] = 44,
  [74] = 44,
  [75] = 44,
  [76] = 44,
  [77] = 44,
  [78] = 44,
  [79] = 44,
  [80] = 44,
  [81] = 44,
  [82] = 46,
  [83] = 44,
  [84] = 44,
  [85] = 46,
  [86] = 44,
  [87] = 61,
  [88] = 46,
  [89] = 44,
  [90] = 61,
  [91] = 44,
  [92] = 44,
  [93] = 44,
  [94] = 94,
  [95] = 94,
  [96] = 94,
  [97] = 94,
  [98] = 94,
  [99] = 94,
  [100] = 94,
  [101] = 94,
  [102] = 94,
  [103] = 94,
  [104] = 94,
  [105] = 94,
  [106] = 94,
  [107] = 94,
  [108] = 94,
  [109] = 94,
  [110] = 94,
  [111] = 94,
  [112] = 94,
  [113] = 94,
  [114] = 94,
  [115] = 94,
  [116] = 94,
  [117] = 94,
  [118] = 94,
  [119] = 94,
  [120] = 94,
  [121] = 94,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 124,
  [126] = 122,
  [127] = 122,
  [128] = 124,
  [129] = 124,
  [130] = 122,
  [131] = 124,
  [132] = 122,
  [133] = 122,
  [134] = 122,
  [135] = 124,
  [136] = 124,
  [137] = 122,
  [138] = 124,
  [139] = 122,
  [140] = 124,
  [141] = 122,
  [142] = 124,
  [143] = 124,
  [144] = 122,
  [145] = 124,
  [146] = 122,
  [147] = 124,
  [148] = 122,
  [149] = 124,
  [150] = 122,
  [151] = 124,
  [152] = 152,
  [153] = 122,
  [154] = 124,
  [155] = 155,
  [156] = 122,
  [157] = 124,
  [158] = 122,
  [159] = 124,
  [160] = 124,
  [161] = 122,
  [162] = 162,
  [163] = 122,
  [164] = 124,
  [165] = 122,
  [166] = 122,
  [167] = 122,
  [168] = 124,
  [169] = 122,
  [170] = 124,
  [171] = 122,
  [172] = 122,
  [173] = 124,
  [174] = 124,
  [175] = 124,
  [176] = 122,
  [177] = 124,
  [178] = 124,
  [179] = 124,
  [180] = 122,
  [181] = 124,
  [182] = 122,
  [183] = 122,
  [184] = 124,
  [185] = 124,
  [186] = 122,
  [187] = 124,
  [188] = 152,
  [189] = 122,
  [190] = 124,
  [191] = 122,
  [192] = 192,
  [193] = 122,
  [194] = 155,
  [195] = 124,
  [196] = 124,
  [197] = 122,
  [198] = 122,
  [199] = 162,
  [200] = 124,
  [201] = 122,
  [202] = 124,
  [203] = 124,
  [204] = 122,
  [205] = 122,
  [206] = 122,
  [207] = 122,
  [208] = 124,
  [209] = 124,
  [210] = 122,
  [211] = 124,
  [212] = 124,
  [213] = 122,
  [214] = 124,
  [215] = 124,
  [216] = 122,
  [217] = 162,
  [218] = 122,
  [219] = 162,
  [220] = 162,
  [221] = 122,
  [222] = 162,
  [223] = 162,
  [224] = 162,
  [225] = 162,
  [226] = 162,
  [227] = 162,
  [228] = 124,
  [229] = 162,
  [230] = 162,
  [231] = 162,
  [232] = 162,
  [233] = 124,
  [234] = 162,
  [235] = 162,
  [236] = 162,
  [237] = 162,
  [238] = 162,
  [239] = 162,
  [240] = 162,
  [241] = 162,
  [242] = 162,
  [243] = 162,
  [244] = 162,
  [245] = 122,
  [246] = 162,
  [247] = 162,
  [248] = 162,
  [249] = 162,
  [250] = 162,
  [251] = 162,
  [252] = 162,
  [253] = 162,
  [254] = 162,
  [255] = 162,
  [256] = 162,
  [257] = 162,
  [258] = 162,
  [259] = 162,
  [260] = 162,
  [261] = 162,
  [262] = 162,
  [263] = 162,
  [264] = 162,
  [265] = 162,
  [266] = 266,
  [267] = 266,
  [268] = 266,
  [269] = 266,
  [270] = 270,
  [271] = 270,
  [272] = 272,
  [273] = 270,
  [274] = 272,
  [275] = 272,
  [276] = 276,
  [277] = 266,
  [278] = 270,
  [279] = 272,
  [280] = 280,
  [281] = 272,
  [282] = 280,
  [283] = 272,
  [284] = 272,
  [285] = 285,
  [286] = 266,
  [287] = 266,
  [288] = 270,
  [289] = 266,
  [290] = 266,
  [291] = 266,
  [292] = 266,
  [293] = 272,
  [294] = 270,
  [295] = 266,
  [296] = 270,
  [297] = 266,
  [298] = 270,
  [299] = 266,
  [300] = 272,
  [301] = 272,
  [302] = 280,
  [303] = 270,
  [304] = 270,
  [305] = 305,
  [306] = 270,
  [307] = 266,
  [308] = 266,
  [309] = 272,
  [310] = 272,
  [311] = 280,
  [312] = 280,
  [313] = 270,
  [314] = 280,
  [315] = 270,
  [316] = 272,
  [317] = 266,
  [318] = 270,
  [319] = 272,
  [320] = 280,
  [321] = 266,
  [322] = 266,
  [323] = 270,
  [324] = 305,
  [325] = 266,
  [326] = 270,
  [327] = 272,
  [328] = 266,
  [329] = 270,
  [330] = 266,
  [331] = 272,
  [332] = 270,
  [333] = 272,
  [334] = 280,
  [335] = 272,
  [336] = 280,
  [337] = 270,
  [338] = 266,
  [339] = 266,
  [340] = 280,
  [341] = 272,
  [342] = 270,
  [343] = 272,
  [344] = 272,
  [345] = 272,
  [346] = 266,
  [347] = 270,
  [348] = 270,
  [349] = 270,
  [350] = 270,
  [351] = 270,
  [352] = 266,
  [353] = 280,
  [354] = 272,
  [355] = 280,
  [356] = 266,
  [357] = 280,
  [358] = 272,
  [359] = 266,
  [360] = 270,
  [361] = 266,
  [362] = 272,
  [363] = 272,
  [364] = 270,
  [365] = 266,
  [366] = 266,
  [367] = 280,
  [368] = 266,
  [369] = 266,
  [370] = 270,
  [371] = 272,
  [372] = 280,
  [373] = 272,
  [374] = 266,
  [375] = 272,
  [376] = 270,
  [377] = 270,
  [378] = 272,
  [379] = 285,
  [380] = 266,
  [381] = 270,
  [382] = 280,
  [383] = 266,
  [384] = 280,
  [385] = 266,
  [386] = 272,
  [387] = 280,
  [388] = 270,
  [389] = 280,
  [390] = 270,
  [391] = 266,
  [392] = 272,
  [393] = 270,
  [394] = 270,
  [395] = 272,
  [396] = 270,
  [397] = 280,
  [398] = 272,
  [399] = 272,
  [400] = 266,
  [401] = 266,
  [402] = 280,
  [403] = 280,
  [404] = 272,
  [405] = 270,
  [406] = 272,
  [407] = 280,
  [408] = 272,
  [409] = 270,
  [410] = 266,
  [411] = 270,
  [412] = 272,
  [413] = 270,
  [414] = 266,
  [415] = 272,
  [416] = 280,
  [417] = 280,
  [418] = 280,
  [419] = 266,
  [420] = 272,
  [421] = 270,
  [422] = 270,
  [423] = 272,
  [424] = 272,
  [425] = 270,
  [426] = 272,
  [427] = 270,
  [428] = 270,
  [429] = 266,
  [430] = 276,
  [431] = 280,
  [432] = 266,
  [433] = 270,
  [434] = 272,
  [435] = 280,
  [436] = 266,
  [437] = 272,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 441,
  [444] = 441,
  [445] = 441,
  [446] = 441,
  [447] = 442,
  [448] = 442,
  [449] = 441,
  [450] = 441,
  [451] = 442,
  [452] = 442,
  [453] = 441,
  [454] = 441,
  [455] = 442,
  [456] = 441,
  [457] = 442,
  [458] = 442,
  [459] = 441,
  [460] = 441,
  [461] = 441,
  [462] = 441,
  [463] = 441,
  [464] = 442,
  [465] = 441,
  [466] = 442,
  [467] = 442,
  [468] = 441,
  [469] = 442,
  [470] = 442,
  [471] = 441,
  [472] = 441,
  [473] = 442,
  [474] = 442,
  [475] = 441,
  [476] = 442,
  [477] = 442,
  [478] = 442,
  [479] = 442,
  [480] = 441,
  [481] = 441,
  [482] = 442,
  [483] = 442,
  [484] = 442,
  [485] = 442,
  [486] = 441,
  [487] = 442,
  [488] = 442,
  [489] = 441,
  [490] = 441,
  [491] = 441,
  [492] = 441,
  [493] = 442,
  [494] = 442,
  [495] = 441,
  [496] = 442,
  [497] = 497,
  [498] = 498,
  [499] = 498,
  [500] = 500,
  [501] = 497,
  [502] = 498,
  [503] = 503,
  [504] = 498,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 507,
  [509] = 507,
  [510] = 507,
  [511] = 507,
  [512] = 507,
  [513] = 507,
  [514] = 507,
  [515] = 507,
  [516] = 507,
  [517] = 507,
  [518] = 507,
  [519] = 507,
  [520] = 507,
  [521] = 507,
  [522] = 507,
  [523] = 507,
  [524] = 507,
  [525] = 507,
  [526] = 507,
  [527] = 507,
  [528] = 507,
  [529] = 507,
  [530] = 507,
  [531] = 507,
  [532] = 507,
  [533] = 507,
  [534] = 507,
  [535] = 507,
  [536] = 507,
  [537] = 507,
  [538] = 507,
  [539] = 507,
  [540] = 507,
  [541] = 507,
  [542] = 507,
  [543] = 507,
  [544] = 507,
  [545] = 507,
  [546] = 507,
  [547] = 507,
  [548] = 507,
  [549] = 507,
  [550] = 507,
  [551] = 507,
  [552] = 507,
  [553] = 553,
  [554] = 554,
  [555] = 554,
  [556] = 553,
  [557] = 554,
  [558] = 553,
  [559] = 559,
  [560] = 559,
  [561] = 559,
  [562] = 559,
  [563] = 559,
  [564] = 559,
  [565] = 559,
  [566] = 559,
  [567] = 559,
  [568] = 559,
  [569] = 559,
  [570] = 559,
  [571] = 559,
  [572] = 559,
  [573] = 559,
  [574] = 559,
  [575] = 559,
  [576] = 559,
  [577] = 559,
  [578] = 559,
  [579] = 559,
  [580] = 559,
  [581] = 559,
  [582] = 559,
  [583] = 559,
  [584] = 559,
  [585] = 559,
  [586] = 559,
  [587] = 559,
  [588] = 559,
  [589] = 559,
  [590] = 559,
  [591] = 559,
  [592] = 559,
  [593] = 559,
  [594] = 559,
  [595] = 559,
  [596] = 559,
  [597] = 559,
  [598] = 559,
  [599] = 559,
  [600] = 559,
  [601] = 559,
  [602] = 559,
  [603] = 559,
  [604] = 553,
  [605] = 559,
  [606] = 559,
  [607] = 559,
  [608] = 559,
  [609] = 559,
  [610] = 559,
  [611] = 559,
  [612] = 559,
  [613] = 559,
  [614] = 559,
  [615] = 559,
  [616] = 559,
  [617] = 559,
  [618] = 559,
  [619] = 559,
  [620] = 559,
  [621] = 559,
  [622] = 559,
  [623] = 559,
  [624] = 559,
  [625] = 559,
  [626] = 559,
  [627] = 559,
  [628] = 559,
  [629] = 559,
  [630] = 559,
  [631] = 559,
  [632] = 559,
  [633] = 559,
  [634] = 559,
  [635] = 559,
  [636] = 559,
  [637] = 559,
  [638] = 559,
  [639] = 559,
  [640] = 559,
  [641] = 559,
  [642] = 559,
  [643] = 559,
  [644] = 559,
  [645] = 559,
  [646] = 559,
  [647] = 559,
  [648] = 559,
  [649] = 559,
  [650] = 559,
  [651] = 559,
  [652] = 559,
  [653] = 559,
  [654] = 559,
  [655] = 559,
  [656] = 559,
  [657] = 559,
  [658] = 559,
  [659] = 554,
  [660] = 553,
  [661] = 559,
  [662] = 559,
  [663] = 559,
  [664] = 559,
  [665] = 559,
  [666] = 559,
  [667] = 559,
  [668] = 559,
  [669] = 559,
  [670] = 554,
  [671] = 559,
  [672] = 559,
  [673] = 559,
  [674] = 559,
  [675] = 559,
  [676] = 559,
  [677] = 559,
  [678] = 559,
  [679] = 559,
  [680] = 559,
  [681] = 559,
  [682] = 559,
  [683] = 559,
  [684] = 559,
  [685] = 559,
  [686] = 559,
  [687] = 559,
  [688] = 559,
  [689] = 559,
  [690] = 559,
  [691] = 559,
  [692] = 559,
  [693] = 559,
  [694] = 559,
  [695] = 559,
  [696] = 559,
  [697] = 559,
  [698] = 559,
  [699] = 559,
  [700] = 559,
  [701] = 701,
  [702] = 702,
  [703] = 701,
  [704] = 701,
  [705] = 701,
  [706] = 701,
  [707] = 701,
  [708] = 701,
  [709] = 701,
  [710] = 701,
  [711] = 701,
  [712] = 701,
  [713] = 701,
  [714] = 701,
  [715] = 701,
  [716] = 701,
  [717] = 701,
  [718] = 701,
  [719] = 701,
  [720] = 701,
  [721] = 701,
  [722] = 701,
  [723] = 701,
  [724] = 701,
  [725] = 702,
  [726] = 701,
  [727] = 701,
  [728] = 701,
  [729] = 553,
  [730] = 701,
  [731] = 701,
  [732] = 701,
  [733] = 701,
  [734] = 701,
  [735] = 554,
  [736] = 701,
  [737] = 701,
  [738] = 701,
  [739] = 701,
  [740] = 701,
  [741] = 701,
  [742] = 701,
  [743] = 701,
  [744] = 701,
  [745] = 745,
  [746] = 702,
  [747] = 701,
  [748] = 701,
  [749] = 701,
  [750] = 701,
  [751] = 701,
  [752] = 702,
  [753] = 701,
  [754] = 554,
  [755] = 553,
  [756] = 554,
  [757] = 554,
  [758] = 553,
  [759] = 553,
  [760] = 553,
  [761] = 553,
  [762] = 554,
  [763] = 554,
  [764] = 764,
  [765] = 764,
  [766] = 766,
  [767] = 764,
  [768] = 764,
  [769] = 764,
  [770] = 764,
  [771] = 764,
  [772] = 764,
  [773] = 554,
  [774] = 764,
  [775] = 766,
  [776] = 764,
  [777] = 764,
  [778] = 764,
  [779] = 764,
  [780] = 766,
  [781] = 764,
  [782] = 766,
  [783] = 764,
  [784] = 764,
  [785] = 766,
  [786] = 766,
  [787] = 766,
  [788] = 764,
  [789] = 766,
  [790] = 766,
  [791] = 553,
  [792] = 764,
  [793] = 766,
  [794] = 766,
  [795] = 764,
  [796] = 766,
  [797] = 764,
  [798] = 553,
  [799] = 766,
  [800] = 764,
  [801] = 764,
  [802] = 764,
  [803] = 764,
  [804] = 766,
  [805] = 766,
  [806] = 764,
  [807] = 554,
  [808] = 764,
  [809] = 764,
  [810] = 810,
  [811] = 553,
  [812] = 764,
  [813] = 764,
  [814] = 764,
  [815] = 764,
  [816] = 766,
  [817] = 554,
  [818] = 764,
  [819] = 766,
  [820] = 764,
  [821] = 764,
  [822] = 764,
  [823] = 554,
  [824] = 553,
  [825] = 554,
  [826] = 764,
  [827] = 764,
  [828] = 554,
  [829] = 766,
  [830] = 553,
  [831] = 764,
  [832] = 764,
  [833] = 766,
  [834] = 553,
  [835] = 810,
  [836] = 764,
  [837] = 764,
  [838] = 764,
  [839] = 764,
  [840] = 764,
  [841] = 764,
  [842] = 764,
  [843] = 764,
  [844] = 554,
  [845] = 766,
  [846] = 764,
  [847] = 553,
  [848] = 764,
  [849] = 764,
  [850] = 764,
  [851] = 764,
  [852] = 554,
  [853] = 764,
  [854] = 766,
  [855] = 766,
  [856] = 766,
  [857] = 553,
  [858] = 764,
  [859] = 764,
  [860] = 764,
  [861] = 861,
  [862] = 861,
  [863] = 861,
  [864] = 861,
  [865] = 861,
  [866] = 866,
  [867] = 861,
  [868] = 861,
  [869] = 861,
  [870] = 861,
  [871] = 861,
  [872] = 554,
  [873] = 861,
  [874] = 861,
  [875] = 861,
  [876] = 861,
  [877] = 861,
  [878] = 861,
  [879] = 861,
  [880] = 861,
  [881] = 861,
  [882] = 861,
  [883] = 861,
  [884] = 861,
  [885] = 553,
  [886] = 553,
  [887] = 861,
  [888] = 861,
  [889] = 861,
  [890] = 861,
  [891] = 861,
  [892] = 861,
  [893] = 861,
  [894] = 861,
  [895] = 861,
  [896] = 861,
  [897] = 553,
  [898] = 861,
  [899] = 861,
  [900] = 554,
  [901] = 861,
  [902] = 861,
  [903] = 861,
  [904] = 861,
  [905] = 861,
  [906] = 861,
  [907] = 907,
  [908] = 861,
  [909] = 861,
  [910] = 554,
  [911] = 866,
  [912] = 861,
  [913] = 861,
  [914] = 861,
  [915] = 861,
  [916] = 554,
  [917] = 917,
  [918] = 553,
  [919] = 919,
  [920] = 919,
  [921] = 921,
  [922] = 922,
  [923] = 921,
  [924] = 924,
  [925] = 922,
  [926] = 926,
  [927] = 927,
  [928] = 924,
  [929] = 924,
  [930] = 924,
  [931] = 931,
  [932] = 924,
  [933] = 931,
  [934] = 922,
  [935] = 927,
  [936] = 924,
  [937] = 924,
  [938] = 927,
  [939] = 924,
  [940] = 927,
  [941] = 924,
  [942] = 926,
  [943] = 921,
  [944] = 926,
  [945] = 924,
  [946] = 926,
  [947] = 924,
  [948] = 927,
  [949] = 926,
  [950] = 922,
  [951] = 924,
  [952] = 931,
  [953] = 921,
  [954] = 924,
  [955] = 921,
  [956] = 924,
  [957] = 924,
  [958] = 926,
  [959] = 924,
  [960] = 922,
  [961] = 924,
  [962] = 931,
  [963] = 922,
  [964] = 922,
  [965] = 931,
  [966] = 924,
  [967] = 924,
  [968] = 927,
  [969] = 926,
  [970] = 924,
  [971] = 921,
  [972] = 922,
  [973] = 921,
  [974] = 924,
  [975] = 927,
  [976] = 926,
  [977] = 926,
  [978] = 924,
  [979] = 931,
  [980] = 927,
  [981] = 931,
  [982] = 924,
  [983] = 927,
  [984] = 921,
  [985] = 924,
  [986] = 924,
  [987] = 931,
  [988] = 922,
  [989] = 924,
  [990] = 922,
  [991] = 927,
  [992] = 926,
  [993] = 924,
  [994] = 924,
  [995] = 931,
  [996] = 924,
  [997] = 924,
  [998] = 921,
  [999] = 924,
  [1000] = 922,
  [1001] = 924,
  [1002] = 924,
  [1003] = 924,
  [1004] = 931,
  [1005] = 926,
  [1006] = 927,
  [1007] = 931,
  [1008] = 924,
  [1009] = 924,
  [1010] = 931,
  [1011] = 1011,
  [1012] = 922,
  [1013] = 922,
  [1014] = 931,
  [1015] = 922,
  [1016] = 924,
  [1017] = 921,
  [1018] = 931,
  [1019] = 924,
  [1020] = 924,
  [1021] = 924,
  [1022] = 924,
  [1023] = 922,
  [1024] = 931,
  [1025] = 922,
  [1026] = 922,
  [1027] = 931,
  [1028] = 921,
  [1029] = 924,
  [1030] = 924,
  [1031] = 927,
  [1032] = 926,
  [1033] = 927,
  [1034] = 924,
  [1035] = 927,
  [1036] = 926,
  [1037] = 1037,
  [1038] = 921,
  [1039] = 921,
  [1040] = 926,
  [1041] = 924,
  [1042] = 924,
  [1043] = 922,
  [1044] = 931,
  [1045] = 931,
  [1046] = 922,
  [1047] = 924,
  [1048] = 924,
  [1049] = 921,
  [1050] = 924,
  [1051] = 924,
  [1052] = 927,
  [1053] = 921,
  [1054] = 927,
  [1055] = 924,
  [1056] = 926,
  [1057] = 921,
  [1058] = 924,
  [1059] = 924,
  [1060] = 924,
  [1061] = 921,
  [1062] = 924,
  [1063] = 924,
  [1064] = 926,
  [1065] = 927,
  [1066] = 924,
  [1067] = 924,
  [1068] = 924,
  [1069] = 921,
  [1070] = 931,
  [1071] = 922,
  [1072] = 924,
  [1073] = 922,
  [1074] = 924,
  [1075] = 931,
  [1076] = 924,
  [1077] = 926,
  [1078] = 927,
  [1079] = 924,
  [1080] = 924,
  [1081] = 924,
  [1082] = 924,
  [1083] = 924,
  [1084] = 926,
  [1085] = 924,
  [1086] = 924,
  [1087] = 931,
  [1088] = 924,
  [1089] = 922,
  [1090] = 927,
  [1091] = 924,
  [1092] = 927,
  [1093] = 924,
  [1094] = 927,
  [1095] = 926,
  [1096] = 926,
  [1097] = 924,
  [1098] = 924,
  [1099] = 924,
  [1100] = 921,
  [1101] = 921,
  [1102] = 926,
  [1103] = 924,
  [1104] = 924,
  [1105] = 926,
  [1106] = 922,
  [1107] = 927,
  [1108] = 931,
  [1109] = 924,
  [1110] = 927,
  [1111] = 924,
  [1112] = 924,
  [1113] = 924,
  [1114] = 921,
  [1115] = 924,
  [1116] = 924,
  [1117] = 924,
  [1118] = 931,
  [1119] = 922,
  [1120] = 924,
  [1121] = 924,
  [1122] = 926,
  [1123] = 924,
  [1124] = 927,
  [1125] = 927,
  [1126] = 924,
  [1127] = 926,
  [1128] = 922,
  [1129] = 921,
  [1130] = 924,
  [1131] = 924,
  [1132] = 927,
  [1133] = 924,
  [1134] = 924,
  [1135] = 926,
  [1136] = 927,
  [1137] = 926,
  [1138] = 924,
  [1139] = 922,
  [1140] = 931,
  [1141] = 926,
  [1142] = 921,
  [1143] = 924,
  [1144] = 921,
  [1145] = 924,
  [1146] = 924,
  [1147] = 924,
  [1148] = 924,
  [1149] = 924,
  [1150] = 922,
  [1151] = 924,
  [1152] = 927,
  [1153] = 931,
  [1154] = 926,
  [1155] = 924,
  [1156] = 931,
  [1157] = 924,
  [1158] = 924,
  [1159] = 931,
  [1160] = 924,
  [1161] = 922,
  [1162] = 922,
  [1163] = 924,
  [1164] = 927,
  [1165] = 931,
  [1166] = 922,
  [1167] = 921,
  [1168] = 924,
  [1169] = 926,
  [1170] = 921,
  [1171] = 924,
  [1172] = 922,
  [1173] = 931,
  [1174] = 924,
  [1175] = 926,
  [1176] = 927,
  [1177] = 921,
  [1178] = 926,
  [1179] = 927,
  [1180] = 926,
  [1181] = 921,
  [1182] = 924,
  [1183] = 927,
  [1184] = 931,
  [1185] = 924,
  [1186] = 922,
  [1187] = 927,
  [1188] = 924,
  [1189] = 926,
  [1190] = 924,
  [1191] = 921,
  [1192] = 924,
  [1193] = 924,
  [1194] = 926,
  [1195] = 924,
  [1196] = 931,
  [1197] = 924,
  [1198] = 922,
  [1199] = 931,
  [1200] = 924,
  [1201] = 922,
  [1202] = 922,
  [1203] = 931,
  [1204] = 922,
  [1205] = 931,
  [1206] = 931,
  [1207] = 924,
  [1208] = 922,
  [1209] = 924,
  [1210] = 927,
  [1211] = 924,
  [1212] = 924,
  [1213] = 921,
  [1214] = 927,
  [1215] = 926,
  [1216] = 924,
  [1217] = 926,
  [1218] = 921,
  [1219] = 924,
  [1220] = 927,
  [1221] = 927,
  [1222] = 926,
  [1223] = 927,
  [1224] = 921,
  [1225] = 921,
  [1226] = 924,
  [1227] = 927,
  [1228] = 921,
  [1229] = 926,
  [1230] = 924,
  [1231] = 922,
  [1232] = 924,
  [1233] = 926,
  [1234] = 924,
  [1235] = 921,
  [1236] = 921,
  [1237] = 921,
  [1238] = 926,
  [1239] = 931,
  [1240] = 924,
  [1241] = 921,
  [1242] = 924,
  [1243] = 924,
  [1244] = 926,
  [1245] = 927,
  [1246] = 921,
  [1247] = 927,
  [1248] = 922,
  [1249] = 924,
  [1250] = 924,
  [1251] = 926,
  [1252] = 924,
  [1253] = 922,
  [1254] = 924,
  [1255] = 927,
  [1256] = 931,
  [1257] = 931,
  [1258] = 931,
  [1259] = 922,
  [1260] = 924,
  [1261] = 924,
  [1262] = 921,
  [1263] = 922,
  [1264] = 931,
  [1265] = 924,
  [1266] = 931,
  [1267] = 931,
  [1268] = 922,
  [1269] = 922,
  [1270] = 924,
  [1271] = 924,
  [1272] = 921,
  [1273] = 927,
  [1274] = 926,
  [1275] = 924,
  [1276] = 927,
  [1277] = 926,
  [1278] = 924,
  [1279] = 921,
  [1280] = 926,
  [1281] = 924,
  [1282] = 927,
  [1283] = 921,
  [1284] = 924,
  [1285] = 921,
  [1286] = 921,
  [1287] = 924,
  [1288] = 921,
  [1289] = 924,
  [1290] = 924,
  [1291] = 926,
  [1292] = 924,
  [1293] = 931,
  [1294] = 922,
  [1295] = 931,
  [1296] = 927,
  [1297] = 1011,
  [1298] = 924,
  [1299] = 931,
  [1300] = 931,
  [1301] = 922,
  [1302] = 924,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1304,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1311,
  [1315] = 1303,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1307,
  [1319] = 1311,
  [1320] = 1311,
  [1321] = 1303,
  [1322] = 1308,
  [1323] = 1303,
  [1324] = 1303,
  [1325] = 1303,
  [1326] = 1306,
  [1327] = 1312,
  [1328] = 1328,
  [1329] = 1304,
  [1330] = 1330,
  [1331] = 1311,
  [1332] = 1303,
  [1333] = 1311,
  [1334] = 1307,
  [1335] = 1313,
  [1336] = 1303,
  [1337] = 1310,
  [1338] = 1317,
  [1339] = 1311,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1312,
  [1344] = 1316,
  [1345] = 1303,
  [1346] = 1312,
  [1347] = 1306,
  [1348] = 1316,
  [1349] = 1306,
  [1350] = 1308,
  [1351] = 1328,
  [1352] = 1311,
  [1353] = 1306,
  [1354] = 1303,
  [1355] = 1317,
  [1356] = 1328,
  [1357] = 1305,
  [1358] = 1307,
  [1359] = 1304,
  [1360] = 1303,
  [1361] = 1311,
  [1362] = 1308,
  [1363] = 1342,
  [1364] = 1311,
  [1365] = 1303,
  [1366] = 1340,
  [1367] = 1312,
  [1368] = 1342,
  [1369] = 1316,
  [1370] = 1311,
  [1371] = 1308,
  [1372] = 1308,
  [1373] = 1304,
  [1374] = 1303,
  [1375] = 1316,
  [1376] = 1313,
  [1377] = 1310,
  [1378] = 1311,
  [1379] = 1313,
  [1380] = 1307,
  [1381] = 1328,
  [1382] = 1303,
  [1383] = 1306,
  [1384] = 1384,
  [1385] = 1311,
  [1386] = 1307,
  [1387] = 1317,
  [1388] = 1310,
  [1389] = 1342,
  [1390] = 1316,
  [1391] = 1312,
  [1392] = 1304,
  [1393] = 1342,
  [1394] = 1308,
  [1395] = 1306,
  [1396] = 1396,
  [1397] = 1312,
  [1398] = 1311,
  [1399] = 1317,
  [1400] = 1303,
  [1401] = 1317,
  [1402] = 1311,
  [1403] = 1311,
  [1404] = 1303,
  [1405] = 1312,
  [1406] = 1303,
  [1407] = 1384,
  [1408] = 1303,
  [1409] = 1313,
  [1410] = 1328,
  [1411] = 1307,
  [1412] = 1312,
  [1413] = 1308,
  [1414] = 1304,
  [1415] = 1415,
  [1416] = 1384,
  [1417] = 1311,
  [1418] = 1316,
  [1419] = 1303,
  [1420] = 1304,
  [1421] = 1313,
  [1422] = 1307,
  [1423] = 1306,
  [1424] = 1328,
  [1425] = 1328,
  [1426] = 1307,
  [1427] = 1303,
  [1428] = 1311,
  [1429] = 1306,
  [1430] = 1311,
  [1431] = 1317,
  [1432] = 1303,
  [1433] = 1313,
  [1434] = 1308,
  [1435] = 1308,
  [1436] = 1311,
  [1437] = 1303,
  [1438] = 1316,
  [1439] = 1310,
  [1440] = 1316,
  [1441] = 1311,
  [1442] = 1316,
  [1443] = 1304,
  [1444] = 1303,
  [1445] = 1304,
  [1446] = 1303,
  [1447] = 1313,
  [1448] = 1310,
  [1449] = 1313,
  [1450] = 1316,
  [1451] = 1303,
  [1452] = 1306,
  [1453] = 1303,
  [1454] = 1308,
  [1455] = 1307,
  [1456] = 1308,
  [1457] = 1317,
  [1458] = 1303,
  [1459] = 1312,
  [1460] = 1328,
  [1461] = 1311,
  [1462] = 1384,
  [1463] = 1306,
  [1464] = 1311,
  [1465] = 1303,
  [1466] = 1310,
  [1467] = 1303,
  [1468] = 1310,
  [1469] = 1303,
  [1470] = 1342,
  [1471] = 1471,
  [1472] = 1303,
  [1473] = 1303,
  [1474] = 1308,
  [1475] = 1303,
  [1476] = 1312,
  [1477] = 1313,
  [1478] = 1478,
  [1479] = 1303,
  [1480] = 1307,
  [1481] = 1311,
  [1482] = 1303,
  [1483] = 1317,
  [1484] = 1313,
  [1485] = 1313,
  [1486] = 1328,
  [1487] = 1328,
  [1488] = 1317,
  [1489] = 1342,
  [1490] = 1340,
  [1491] = 1303,
  [1492] = 1342,
  [1493] = 1306,
  [1494] = 1303,
  [1495] = 1317,
  [1496] = 1328,
  [1497] = 1307,
  [1498] = 1306,
  [1499] = 1340,
  [1500] = 1303,
  [1501] = 1328,
  [1502] = 1307,
  [1503] = 1313,
  [1504] = 1316,
  [1505] = 1304,
  [1506] = 1328,
  [1507] = 1303,
  [1508] = 1307,
  [1509] = 1303,
  [1510] = 1312,
  [1511] = 1316,
  [1512] = 1303,
  [1513] = 1308,
  [1514] = 1342,
  [1515] = 1303,
  [1516] = 1306,
  [1517] = 1303,
  [1518] = 1328,
  [1519] = 1307,
  [1520] = 1328,
  [1521] = 1303,
  [1522] = 1317,
  [1523] = 1303,
  [1524] = 1303,
  [1525] = 1307,
  [1526] = 1313,
  [1527] = 1317,
  [1528] = 1310,
  [1529] = 1312,
  [1530] = 1303,
  [1531] = 1303,
  [1532] = 1311,
  [1533] = 1316,
  [1534] = 1311,
  [1535] = 1303,
  [1536] = 1311,
  [1537] = 1308,
  [1538] = 1312,
  [1539] = 1342,
  [1540] = 1303,
  [1541] = 1304,
  [1542] = 1311,
  [1543] = 1317,
  [1544] = 1303,
  [1545] = 1317,
  [1546] = 1304,
  [1547] = 1303,
  [1548] = 1317,
  [1549] = 1303,
  [1550] = 1312,
  [1551] = 1313,
  [1552] = 1303,
  [1553] = 1306,
  [1554] = 1306,
  [1555] = 1303,
  [1556] = 1328,
  [1557] = 1316,
  [1558] = 1310,
  [1559] = 1328,
  [1560] = 1307,
  [1561] = 1313,
  [1562] = 1306,
  [1563] = 1328,
  [1564] = 1307,
  [1565] = 1307,
  [1566] = 1311,
  [1567] = 1313,
  [1568] = 1316,
  [1569] = 1304,
  [1570] = 1313,
  [1571] = 1311,
  [1572] = 1572,
  [1573] = 1304,
  [1574] = 1317,
  [1575] = 1313,
  [1576] = 1304,
  [1577] = 1316,
  [1578] = 1310,
  [1579] = 1304,
  [1580] = 1316,
  [1581] = 1307,
  [1582] = 1303,
  [1583] = 1308,
  [1584] = 1328,
  [1585] = 1304,
  [1586] = 1305,
  [1587] = 1304,
  [1588] = 1306,
  [1589] = 1303,
  [1590] = 1312,
  [1591] = 1306,
  [1592] = 1311,
  [1593] = 1312,
  [1594] = 1317,
  [1595] = 1308,
  [1596] = 1342,
  [1597] = 1311,
  [1598] = 1311,
  [1599] = 1599,
  [1600] = 1308,
  [1601] = 1304,
  [1602] = 1312,
  [1603] = 1303,
  [1604] = 1311,
  [1605] = 1316,
  [1606] = 1342,
  [1607] = 1311,
  [1608] = 1317,
  [1609] = 1306,
  [1610] = 1415,
  [1611] = 1311,
  [1612] = 1303,
  [1613] = 1317,
  [1614] = 1310,
  [1615] = 1313,
  [1616] = 1312,
  [1617] = 1307,
  [1618] = 1311,
  [1619] = 1308,
  [1620] = 1311,
  [1621] = 1303,
  [1622] = 1328,
  [1623] = 1307,
  [1624] = 1306,
  [1625] = 1308,
  [1626] = 1311,
  [1627] = 1328,
  [1628] = 1307,
  [1629] = 1313,
  [1630] = 1316,
  [1631] = 1304,
  [1632] = 1303,
  [1633] = 1316,
  [1634] = 1312,
  [1635] = 1328,
  [1636] = 1303,
  [1637] = 1313,
  [1638] = 1310,
  [1639] = 1316,
  [1640] = 1303,
  [1641] = 1310,
  [1642] = 1311,
  [1643] = 1317,
  [1644] = 1317,
  [1645] = 1306,
  [1646] = 1316,
  [1647] = 1312,
  [1648] = 1342,
  [1649] = 1313,
  [1650] = 1308,
  [1651] = 1311,
  [1652] = 1304,
  [1653] = 1384,
  [1654] = 1303,
  [1655] = 1311,
  [1656] = 1317,
  [1657] = 1308,
  [1658] = 1311,
  [1659] = 1311,
  [1660] = 1340,
  [1661] = 1312,
  [1662] = 1311,
  [1663] = 1311,
  [1664] = 1304,
  [1665] = 1308,
  [1666] = 1303,
  [1667] = 1303,
  [1668] = 1306,
  [1669] = 1312,
  [1670] = 1328,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1672,
  [1674] = 1674,
  [1675] = 1672,
  [1676] = 1672,
  [1677] = 1672,
  [1678] = 1672,
  [1679] = 1674,
  [1680] = 1672,
  [1681] = 1672,
  [1682] = 1674,
  [1683] = 1672,
  [1684] = 1674,
  [1685] = 1672,
  [1686] = 1674,
  [1687] = 1674,
  [1688] = 1672,
  [1689] = 1674,
  [1690] = 1674,
  [1691] = 1672,
  [1692] = 1674,
  [1693] = 1674,
  [1694] = 1672,
  [1695] = 1674,
  [1696] = 1674,
  [1697] = 1697,
  [1698] = 1674,
  [1699] = 1672,
  [1700] = 1672,
  [1701] = 1672,
  [1702] = 1672,
  [1703] = 1674,
  [1704] = 1672,
  [1705] = 1674,
  [1706] = 1672,
  [1707] = 1674,
  [1708] = 1672,
  [1709] = 1674,
  [1710] = 1674,
  [1711] = 1672,
  [1712] = 1674,
  [1713] = 1672,
  [1714] = 1672,
  [1715] = 1672,
  [1716] = 1672,
  [1717] = 1674,
  [1718] = 1674,
  [1719] = 1674,
  [1720] = 1672,
  [1721] = 1672,
  [1722] = 1674,
  [1723] = 1674,
  [1724] = 1674,
  [1725] = 1674,
  [1726] = 1672,
  [1727] = 1674,
  [1728] = 1674,
  [1729] = 1674,
  [1730] = 1674,
  [1731] = 1672,
  [1732] = 1674,
  [1733] = 1672,
  [1734] = 1674,
  [1735] = 1672,
  [1736] = 1672,
  [1737] = 1672,
  [1738] = 1674,
  [1739] = 1672,
  [1740] = 1674,
  [1741] = 1672,
  [1742] = 1674,
  [1743] = 1674,
  [1744] = 1672,
  [1745] = 1672,
  [1746] = 1674,
  [1747] = 1672,
  [1748] = 1672,
  [1749] = 1674,
  [1750] = 1674,
  [1751] = 1672,
  [1752] = 1674,
  [1753] = 1672,
  [1754] = 1674,
  [1755] = 1674,
  [1756] = 1672,
  [1757] = 1672,
  [1758] = 1674,
  [1759] = 1674,
  [1760] = 1672,
  [1761] = 1674,
  [1762] = 1672,
  [1763] = 1674,
  [1764] = 1672,
  [1765] = 1765,
  [1766] = 1765,
  [1767] = 1765,
  [1768] = 1765,
  [1769] = 1765,
  [1770] = 1770,
  [1771] = 1765,
  [1772] = 1765,
  [1773] = 1765,
  [1774] = 1765,
  [1775] = 1765,
  [1776] = 1765,
  [1777] = 1765,
  [1778] = 1765,
  [1779] = 1765,
  [1780] = 1765,
  [1781] = 1781,
  [1782] = 1765,
  [1783] = 1770,
  [1784] = 1765,
  [1785] = 1765,
  [1786] = 1765,
  [1787] = 1765,
  [1788] = 1765,
  [1789] = 1765,
  [1790] = 1765,
  [1791] = 1765,
  [1792] = 1765,
  [1793] = 1765,
  [1794] = 1765,
  [1795] = 1765,
  [1796] = 1765,
  [1797] = 1765,
  [1798] = 1765,
  [1799] = 1765,
  [1800] = 1800,
  [1801] = 1765,
  [1802] = 1765,
  [1803] = 1765,
  [1804] = 1781,
  [1805] = 1765,
  [1806] = 1765,
  [1807] = 1765,
  [1808] = 1765,
  [1809] = 1765,
  [1810] = 1765,
  [1811] = 1781,
  [1812] = 1765,
  [1813] = 1770,
  [1814] = 1765,
  [1815] = 1765,
  [1816] = 1765,
  [1817] = 1765,
  [1818] = 1818,
  [1819] = 1818,
  [1820] = 1820,
  [1821] = 1818,
  [1822] = 1822,
  [1823] = 1818,
  [1824] = 1822,
  [1825] = 1818,
  [1826] = 1818,
  [1827] = 1818,
  [1828] = 1818,
  [1829] = 1820,
  [1830] = 1818,
  [1831] = 1818,
  [1832] = 1818,
  [1833] = 1818,
  [1834] = 1818,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1818,
  [1838] = 1818,
  [1839] = 1818,
  [1840] = 1822,
  [1841] = 1818,
  [1842] = 1822,
  [1843] = 1836,
  [1844] = 1818,
  [1845] = 1818,
  [1846] = 1818,
  [1847] = 1822,
  [1848] = 1818,
  [1849] = 1822,
  [1850] = 1818,
  [1851] = 1818,
  [1852] = 1818,
  [1853] = 1818,
  [1854] = 1822,
  [1855] = 1818,
  [1856] = 1818,
  [1857] = 1818,
  [1858] = 1818,
  [1859] = 1818,
  [1860] = 1818,
  [1861] = 1818,
  [1862] = 1818,
  [1863] = 1818,
  [1864] = 1818,
  [1865] = 1818,
  [1866] = 1818,
  [1867] = 1818,
  [1868] = 1818,
  [1869] = 1818,
  [1870] = 1818,
  [1871] = 1818,
  [1872] = 1818,
  [1873] = 1818,
  [1874] = 1818,
  [1875] = 1818,
  [1876] = 1818,
  [1877] = 1818,
  [1878] = 1818,
  [1879] = 1818,
  [1880] = 1818,
  [1881] = 1822,
  [1882] = 1818,
  [1883] = 1818,
  [1884] = 1818,
  [1885] = 1818,
  [1886] = 1818,
  [1887] = 1818,
  [1888] = 1818,
  [1889] = 1818,
  [1890] = 1818,
  [1891] = 1818,
  [1892] = 1822,
  [1893] = 1818,
  [1894] = 1818,
  [1895] = 1818,
  [1896] = 1818,
  [1897] = 1818,
  [1898] = 1818,
  [1899] = 1818,
  [1900] = 1818,
  [1901] = 1822,
  [1902] = 1818,
  [1903] = 1818,
  [1904] = 1818,
  [1905] = 1818,
  [1906] = 1818,
  [1907] = 1818,
  [1908] = 1818,
  [1909] = 1818,
  [1910] = 1822,
  [1911] = 1818,
  [1912] = 1818,
  [1913] = 1818,
  [1914] = 1822,
  [1915] = 1818,
  [1916] = 1818,
  [1917] = 1818,
  [1918] = 1818,
  [1919] = 1818,
  [1920] = 1818,
  [1921] = 1818,
  [1922] = 1822,
  [1923] = 1818,
  [1924] = 1818,
  [1925] = 1818,
  [1926] = 1818,
  [1927] = 1818,
  [1928] = 1818,
  [1929] = 1818,
  [1930] = 1818,
  [1931] = 1822,
  [1932] = 1818,
  [1933] = 1818,
  [1934] = 1836,
  [1935] = 1835,
  [1936] = 1818,
  [1937] = 1818,
  [1938] = 1818,
  [1939] = 1818,
  [1940] = 1818,
  [1941] = 1818,
  [1942] = 1818,
  [1943] = 1820,
  [1944] = 1818,
  [1945] = 1818,
  [1946] = 1818,
  [1947] = 1818,
  [1948] = 1822,
  [1949] = 1818,
  [1950] = 1818,
  [1951] = 1818,
  [1952] = 1818,
  [1953] = 1818,
  [1954] = 1818,
  [1955] = 1818,
  [1956] = 1818,
  [1957] = 1818,
  [1958] = 1818,
  [1959] = 1822,
  [1960] = 1822,
  [1961] = 1818,
  [1962] = 1822,
  [1963] = 1818,
  [1964] = 1818,
  [1965] = 1818,
  [1966] = 1835,
  [1967] = 1818,
  [1968] = 1818,
  [1969] = 1818,
  [1970] = 1818,
  [1971] = 1818,
  [1972] = 1818,
  [1973] = 1822,
  [1974] = 1818,
  [1975] = 1818,
  [1976] = 1822,
  [1977] = 1818,
  [1978] = 1818,
  [1979] = 1818,
  [1980] = 1818,
  [1981] = 1818,
  [1982] = 1822,
  [1983] = 1818,
  [1984] = 1818,
  [1985] = 1818,
  [1986] = 1822,
  [1987] = 1818,
  [1988] = 1818,
  [1989] = 1818,
  [1990] = 1818,
  [1991] = 1818,
  [1992] = 1818,
  [1993] = 1822,
  [1994] = 1818,
  [1995] = 1818,
  [1996] = 1818,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 1998,
  [2001] = 2001,
  [2002] = 1998,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2003,
  [2007] = 2003,
  [2008] = 2008,
  [2009] = 1999,
  [2010] = 2008,
  [2011] = 2005,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2003,
  [2015] = 2008,
  [2016] = 2001,
  [2017] = 2012,
  [2018] = 2005,
  [2019] = 2008,
  [2020] = 2008,
  [2021] = 2003,
  [2022] = 2022,
  [2023] = 2001,
  [2024] = 2012,
  [2025] = 1999,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2026,
  [2029] = 2027,
  [2030] = 2026,
  [2031] = 2027,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2032,
  [2035] = 2032,
  [2036] = 2027,
  [2037] = 2037,
  [2038] = 2026,
  [2039] = 2032,
  [2040] = 2032,
  [2041] = 2026,
  [2042] = 2027,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2045,
  [2048] = 2045,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2049,
  [2055] = 2052,
  [2056] = 2044,
  [2057] = 2046,
  [2058] = 2051,
  [2059] = 2052,
  [2060] = 2051,
  [2061] = 2061,
  [2062] = 2061,
  [2063] = 2061,
  [2064] = 2061,
  [2065] = 2061,
  [2066] = 2061,
  [2067] = 2061,
  [2068] = 2061,
  [2069] = 2061,
  [2070] = 2070,
  [2071] = 2061,
  [2072] = 2061,
  [2073] = 2061,
  [2074] = 2061,
  [2075] = 2061,
  [2076] = 2061,
  [2077] = 2061,
  [2078] = 2061,
  [2079] = 2061,
  [2080] = 2061,
  [2081] = 2061,
  [2082] = 2061,
  [2083] = 2061,
  [2084] = 2061,
  [2085] = 2061,
  [2086] = 2061,
  [2087] = 2061,
  [2088] = 2061,
  [2089] = 2061,
  [2090] = 2061,
  [2091] = 2061,
  [2092] = 2061,
  [2093] = 2061,
  [2094] = 2061,
  [2095] = 2070,
  [2096] = 2061,
  [2097] = 2061,
  [2098] = 2061,
  [2099] = 2061,
  [2100] = 2061,
  [2101] = 2061,
  [2102] = 2061,
  [2103] = 2061,
  [2104] = 2061,
  [2105] = 2061,
  [2106] = 2061,
  [2107] = 2046,
  [2108] = 2061,
  [2109] = 2061,
  [2110] = 2061,
  [2111] = 2061,
  [2112] = 2061,
  [2113] = 2061,
  [2114] = 2049,
  [2115] = 2061,
  [2116] = 2061,
  [2117] = 2061,
  [2118] = 2061,
  [2119] = 2061,
  [2120] = 2061,
  [2121] = 2061,
  [2122] = 2061,
  [2123] = 2061,
  [2124] = 2061,
  [2125] = 2061,
  [2126] = 2061,
  [2127] = 2127,
  [2128] = 2061,
  [2129] = 2061,
  [2130] = 2127,
  [2131] = 2061,
  [2132] = 2061,
  [2133] = 2061,
  [2134] = 2061,
  [2135] = 2061,
  [2136] = 2061,
  [2137] = 2061,
  [2138] = 2061,
  [2139] = 2061,
  [2140] = 2061,
  [2141] = 2061,
  [2142] = 2061,
  [2143] = 2143,
  [2144] = 2061,
  [2145] = 2061,
  [2146] = 2061,
  [2147] = 2061,
  [2148] = 2061,
  [2149] = 2070,
  [2150] = 2061,
  [2151] = 2143,
  [2152] = 2061,
  [2153] = 2061,
  [2154] = 2061,
  [2155] = 2061,
  [2156] = 2061,
  [2157] = 2061,
  [2158] = 2050,
  [2159] = 2061,
  [2160] = 2061,
  [2161] = 2061,
  [2162] = 2061,
  [2163] = 2061,
  [2164] = 2061,
  [2165] = 2061,
  [2166] = 2061,
  [2167] = 2061,
  [2168] = 2061,
  [2169] = 2061,
  [2170] = 2061,
  [2171] = 2061,
  [2172] = 2061,
  [2173] = 2061,
  [2174] = 2061,
  [2175] = 2061,
  [2176] = 2061,
  [2177] = 2044,
  [2178] = 2061,
  [2179] = 2061,
  [2180] = 2143,
  [2181] = 2061,
  [2182] = 2061,
  [2183] = 2061,
  [2184] = 2061,
  [2185] = 2061,
  [2186] = 2061,
  [2187] = 2061,
  [2188] = 2061,
  [2189] = 2127,
  [2190] = 2061,
  [2191] = 2061,
  [2192] = 2061,
  [2193] = 2061,
  [2194] = 2061,
  [2195] = 2061,
  [2196] = 2061,
  [2197] = 2061,
  [2198] = 2061,
  [2199] = 2061,
  [2200] = 2061,
  [2201] = 2061,
  [2202] = 2061,
  [2203] = 2061,
  [2204] = 2061,
  [2205] = 2061,
  [2206] = 2061,
  [2207] = 2061,
  [2208] = 2061,
  [2209] = 2061,
  [2210] = 2061,
  [2211] = 2061,
  [2212] = 2050,
  [2213] = 2213,
  [2214] = 2213,
  [2215] = 2215,
  [2216] = 2213,
  [2217] = 2046,
  [2218] = 2049,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2219,
  [2222] = 2044,
  [2223] = 2223,
  [2224] = 2220,
  [2225] = 2046,
  [2226] = 2219,
  [2227] = 2049,
  [2228] = 2044,
  [2229] = 2229,
  [2230] = 2229,
  [2231] = 2229,
  [2232] = 2229,
  [2233] = 2229,
  [2234] = 2046,
  [2235] = 2229,
  [2236] = 2229,
  [2237] = 2229,
  [2238] = 2229,
  [2239] = 2229,
  [2240] = 2229,
  [2241] = 2229,
  [2242] = 2229,
  [2243] = 2229,
  [2244] = 2229,
  [2245] = 2229,
  [2246] = 2229,
  [2247] = 2229,
  [2248] = 2229,
  [2249] = 2229,
  [2250] = 2229,
  [2251] = 2229,
  [2252] = 2229,
  [2253] = 2229,
  [2254] = 2229,
  [2255] = 2229,
  [2256] = 2046,
  [2257] = 2044,
  [2258] = 2229,
  [2259] = 2229,
  [2260] = 2229,
  [2261] = 2046,
  [2262] = 2229,
  [2263] = 2229,
  [2264] = 2229,
  [2265] = 2229,
  [2266] = 2229,
  [2267] = 2229,
  [2268] = 2229,
  [2269] = 2229,
  [2270] = 2229,
  [2271] = 2229,
  [2272] = 2229,
  [2273] = 2229,
  [2274] = 2229,
  [2275] = 2229,
  [2276] = 2229,
  [2277] = 2229,
  [2278] = 2229,
  [2279] = 2044,
  [2280] = 2229,
  [2281] = 2049,
  [2282] = 2229,
  [2283] = 2229,
  [2284] = 2229,
  [2285] = 2229,
  [2286] = 2229,
  [2287] = 2229,
  [2288] = 2229,
  [2289] = 2229,
  [2290] = 2229,
  [2291] = 2229,
  [2292] = 2229,
  [2293] = 2229,
  [2294] = 2229,
  [2295] = 2229,
  [2296] = 2229,
  [2297] = 2046,
  [2298] = 2229,
  [2299] = 2229,
  [2300] = 2229,
  [2301] = 2229,
  [2302] = 2229,
  [2303] = 2229,
  [2304] = 2229,
  [2305] = 2044,
  [2306] = 2229,
  [2307] = 2046,
  [2308] = 2229,
  [2309] = 2050,
  [2310] = 2050,
  [2311] = 2229,
  [2312] = 2229,
  [2313] = 2229,
  [2314] = 2229,
  [2315] = 2229,
  [2316] = 2229,
  [2317] = 2229,
  [2318] = 2229,
  [2319] = 2044,
  [2320] = 2229,
  [2321] = 2229,
  [2322] = 2229,
  [2323] = 2229,
  [2324] = 2229,
  [2325] = 2229,
  [2326] = 2229,
  [2327] = 2049,
  [2328] = 2229,
  [2329] = 2229,
  [2330] = 2229,
  [2331] = 2229,
  [2332] = 2229,
  [2333] = 2049,
  [2334] = 2229,
  [2335] = 2229,
  [2336] = 2049,
  [2337] = 2229,
  [2338] = 2229,
  [2339] = 2229,
  [2340] = 2229,
  [2341] = 2229,
  [2342] = 2044,
  [2343] = 2229,
  [2344] = 2229,
  [2345] = 2229,
  [2346] = 2229,
  [2347] = 2229,
  [2348] = 2229,
  [2349] = 2229,
  [2350] = 2229,
  [2351] = 2229,
  [2352] = 2229,
  [2353] = 2229,
  [2354] = 2229,
  [2355] = 2229,
  [2356] = 2046,
  [2357] = 2229,
  [2358] = 2229,
  [2359] = 2229,
  [2360] = 2229,
  [2361] = 2229,
  [2362] = 2229,
  [2363] = 2229,
  [2364] = 2229,
  [2365] = 2229,
  [2366] = 2229,
  [2367] = 2229,
  [2368] = 2229,
  [2369] = 2229,
  [2370] = 2229,
  [2371] = 2229,
  [2372] = 2229,
  [2373] = 2229,
  [2374] = 2229,
  [2375] = 2229,
  [2376] = 2229,
  [2377] = 2229,
  [2378] = 2229,
  [2379] = 2229,
  [2380] = 2229,
  [2381] = 2049,
  [2382] = 2049,
  [2383] = 2229,
  [2384] = 2229,
  [2385] = 2044,
  [2386] = 2229,
  [2387] = 2044,
  [2388] = 2044,
  [2389] = 2046,
  [2390] = 2046,
  [2391] = 2046,
  [2392] = 2044,
  [2393] = 2049,
  [2394] = 2049,
  [2395] = 2046,
  [2396] = 2049,
  [2397] = 2049,
  [2398] = 2044,
  [2399] = 2044,
  [2400] = 2044,
  [2401] = 2046,
  [2402] = 2049,
  [2403] = 2403,
  [2404] = 2046,
  [2405] = 2046,
  [2406] = 2050,
  [2407] = 2403,
  [2408] = 2044,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2049,
  [2413] = 2411,
  [2414] = 2050,
  [2415] = 2044,
  [2416] = 2409,
  [2417] = 2046,
  [2418] = 2050,
  [2419] = 2050,
  [2420] = 2410,
  [2421] = 2049,
  [2422] = 2049,
  [2423] = 2046,
  [2424] = 2050,
  [2425] = 2049,
  [2426] = 2050,
  [2427] = 2044,
  [2428] = 2050,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2050,
  [2433] = 2049,
  [2434] = 2429,
  [2435] = 2429,
  [2436] = 2429,
  [2437] = 2429,
  [2438] = 2431,
  [2439] = 2050,
  [2440] = 2429,
  [2441] = 2044,
  [2442] = 2044,
  [2443] = 2429,
  [2444] = 2049,
  [2445] = 2429,
  [2446] = 2050,
  [2447] = 2429,
  [2448] = 2044,
  [2449] = 2044,
  [2450] = 2450,
  [2451] = 2429,
  [2452] = 2429,
  [2453] = 2429,
  [2454] = 2430,
  [2455] = 2429,
  [2456] = 2049,
  [2457] = 2429,
  [2458] = 2050,
  [2459] = 2429,
  [2460] = 2429,
  [2461] = 2050,
  [2462] = 2431,
  [2463] = 2429,
  [2464] = 2429,
  [2465] = 2430,
  [2466] = 2429,
  [2467] = 2429,
  [2468] = 2429,
  [2469] = 2429,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2429,
  [2473] = 2473,
  [2474] = 2046,
  [2475] = 2429,
  [2476] = 2429,
  [2477] = 2429,
  [2478] = 2046,
  [2479] = 2429,
  [2480] = 2050,
  [2481] = 2411,
  [2482] = 2450,
  [2483] = 2429,
  [2484] = 2429,
  [2485] = 2429,
  [2486] = 2429,
  [2487] = 2429,
  [2488] = 2429,
  [2489] = 2429,
  [2490] = 2049,
  [2491] = 2429,
  [2492] = 2429,
  [2493] = 2450,
  [2494] = 2050,
  [2495] = 2429,
  [2496] = 2046,
  [2497] = 2429,
  [2498] = 2050,
  [2499] = 2429,
  [2500] = 2049,
  [2501] = 2429,
  [2502] = 2429,
  [2503] = 2429,
  [2504] = 2046,
  [2505] = 2429,
  [2506] = 2429,
  [2507] = 2046,
  [2508] = 2429,
  [2509] = 2471,
  [2510] = 2044,
  [2511] = 2050,
  [2512] = 2049,
  [2513] = 2513,
  [2514] = 2044,
  [2515] = 2050,
  [2516] = 2046,
  [2517] = 2050,
  [2518] = 2046,
  [2519] = 2513,
  [2520] = 2050,
  [2521] = 2049,
  [2522] = 2050,
  [2523] = 2046,
  [2524] = 2044,
  [2525] = 2049,
  [2526] = 2044,
  [2527] = 2049,
  [2528] = 2046,
  [2529] = 2044,
  [2530] = 2044,
  [2531] = 2046,
  [2532] = 2049,
  [2533] = 2044,
  [2534] = 2044,
  [2535] = 2535,
  [2536] = 2049,
  [2537] = 2535,
  [2538] = 2535,
  [2539] = 2535,
  [2540] = 2535,
  [2541] = 2050,
  [2542] = 2046,
  [2543] = 2044,
  [2544] = 2046,
  [2545] = 2049,
  [2546] = 2535,
  [2547] = 2046,
  [2548] = 2044,
  [2549] = 2535,
  [2550] = 2535,
  [2551] = 2551,
  [2552] = 2049,
  [2553] = 2553,
  [2554] = 2554,
  [2555] = 2535,
  [2556] = 2049,
  [2557] = 2046,
  [2558] = 2535,
  [2559] = 2535,
  [2560] = 2535,
  [2561] = 2046,
  [2562] = 2044,
  [2563] = 2044,
  [2564] = 2535,
  [2565] = 2049,
  [2566] = 2535,
  [2567] = 2551,
  [2568] = 2554,
  [2569] = 2050,
  [2570] = 2535,
  [2571] = 2535,
  [2572] = 2535,
  [2573] = 2553,
  [2574] = 2554,
  [2575] = 2535,
  [2576] = 2049,
  [2577] = 2535,
  [2578] = 2046,
  [2579] = 2535,
  [2580] = 2050,
  [2581] = 2535,
  [2582] = 2553,
  [2583] = 2535,
  [2584] = 2535,
  [2585] = 2050,
  [2586] = 2044,
  [2587] = 2587,
  [2588] = 2050,
  [2589] = 2046,
  [2590] = 2590,
  [2591] = 2591,
  [2592] = 2591,
  [2593] = 2587,
  [2594] = 2590,
  [2595] = 2590,
  [2596] = 2049,
  [2597] = 2050,
  [2598] = 2044,
  [2599] = 2587,
  [2600] = 2591,
  [2601] = 2046,
  [2602] = 2590,
  [2603] = 2591,
  [2604] = 2046,
  [2605] = 2590,
  [2606] = 2587,
  [2607] = 2591,
  [2608] = 2587,
  [2609] = 2046,
  [2610] = 2049,
  [2611] = 2590,
  [2612] = 2044,
  [2613] = 2587,
  [2614] = 2591,
  [2615] = 2591,
  [2616] = 2587,
  [2617] = 2590,
  [2618] = 2044,
  [2619] = 2590,
  [2620] = 2587,
  [2621] = 2591,
  [2622] = 2590,
  [2623] = 2044,
  [2624] = 2044,
  [2625] = 2591,
  [2626] = 2587,
  [2627] = 2046,
  [2628] = 2049,
  [2629] = 2590,
  [2630] = 2587,
  [2631] = 2591,
  [2632] = 2632,
  [2633] = 2046,
  [2634] = 2591,
  [2635] = 2587,
  [2636] = 2590,
  [2637] = 2637,
  [2638] = 2049,
  [2639] = 2590,
  [2640] = 2587,
  [2641] = 2591,
  [2642] = 2642,
  [2643] = 2591,
  [2644] = 2587,
  [2645] = 2590,
  [2646] = 2591,
  [2647] = 2587,
  [2648] = 2587,
  [2649] = 2591,
  [2650] = 2590,
  [2651] = 2591,
  [2652] = 2049,
  [2653] = 2587,
  [2654] = 2590,
  [2655] = 2590,
  [2656] = 2590,
  [2657] = 2587,
  [2658] = 2591,
  [2659] = 2642,
  [2660] = 2590,
  [2661] = 2591,
  [2662] = 2662,
  [2663] = 2591,
  [2664] = 2587,
  [2665] = 2587,
  [2666] = 2590,
  [2667] = 2590,
  [2668] = 2591,
  [2669] = 2587,
  [2670] = 2587,
  [2671] = 2591,
  [2672] = 2672,
  [2673] = 2591,
  [2674] = 2049,
  [2675] = 2049,
  [2676] = 2587,
  [2677] = 2590,
  [2678] = 2590,
  [2679] = 2637,
  [2680] = 2590,
  [2681] = 2587,
  [2682] = 2591,
  [2683] = 2050,
  [2684] = 2587,
  [2685] = 2591,
  [2686] = 2637,
  [2687] = 2591,
  [2688] = 2587,
  [2689] = 2591,
  [2690] = 2587,
  [2691] = 2044,
  [2692] = 2590,
  [2693] = 2590,
  [2694] = 2590,
  [2695] = 2587,
  [2696] = 2591,
  [2697] = 2591,
  [2698] = 2587,
  [2699] = 2590,
  [2700] = 2590,
  [2701] = 2590,
  [2702] = 2587,
  [2703] = 2591,
  [2704] = 2662,
  [2705] = 2046,
  [2706] = 2044,
  [2707] = 2591,
  [2708] = 2587,
  [2709] = 2590,
  [2710] = 2050,
  [2711] = 2587,
  [2712] = 2591,
  [2713] = 2587,
  [2714] = 2591,
  [2715] = 2590,
  [2716] = 2590,
  [2717] = 2590,
  [2718] = 2587,
  [2719] = 2591,
  [2720] = 2587,
  [2721] = 2591,
  [2722] = 2591,
  [2723] = 2590,
  [2724] = 2591,
  [2725] = 2587,
  [2726] = 2587,
  [2727] = 2049,
  [2728] = 2591,
  [2729] = 2587,
  [2730] = 2591,
  [2731] = 2590,
  [2732] = 2587,
  [2733] = 2046,
  [2734] = 2590,
  [2735] = 2590,
  [2736] = 2587,
  [2737] = 2591,
  [2738] = 2590,
  [2739] = 2050,
  [2740] = 2587,
  [2741] = 2591,
  [2742] = 2587,
  [2743] = 2590,
  [2744] = 2587,
  [2745] = 2591,
  [2746] = 2590,
  [2747] = 2590,
  [2748] = 2590,
  [2749] = 2587,
  [2750] = 2591,
  [2751] = 2050,
  [2752] = 2591,
  [2753] = 2587,
  [2754] = 2590,
  [2755] = 2587,
  [2756] = 2591,
  [2757] = 2590,
  [2758] = 2590,
  [2759] = 2591,
  [2760] = 2050,
  [2761] = 2761,
  [2762] = 2050,
  [2763] = 2672,
  [2764] = 2049,
  [2765] = 2765,
  [2766] = 2050,
  [2767] = 2767,
  [2768] = 2768,
  [2769] = 2765,
  [2770] = 2050,
  [2771] = 2771,
  [2772] = 2046,
  [2773] = 2761,
  [2774] = 2768,
  [2775] = 2775,
  [2776] = 2771,
  [2777] = 2044,
  [2778] = 2050,
  [2779] = 2771,
  [2780] = 2050,
  [2781] = 2672,
  [2782] = 2050,
  [2783] = 2765,
  [2784] = 2768,
  [2785] = 2775,
  [2786] = 2761,
  [2787] = 2767,
  [2788] = 2050,
  [2789] = 2050,
  [2790] = 2790,
  [2791] = 2672,
  [2792] = 2792,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2795,
  [2796] = 2050,
  [2797] = 2797,
  [2798] = 2797,
  [2799] = 2797,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2795,
  [2805] = 2797,
  [2806] = 2800,
  [2807] = 2800,
  [2808] = 2800,
  [2809] = 2800,
  [2810] = 2797,
  [2811] = 2797,
  [2812] = 2797,
  [2813] = 2797,
  [2814] = 2800,
  [2815] = 2672,
  [2816] = 2800,
  [2817] = 2797,
  [2818] = 2818,
  [2819] = 2672,
  [2820] = 2800,
  [2821] = 2803,
  [2822] = 2800,
  [2823] = 2797,
  [2824] = 2800,
  [2825] = 2825,
  [2826] = 2826,
  [2827] = 2800,
  [2828] = 2797,
  [2829] = 2800,
  [2830] = 2797,
  [2831] = 2797,
  [2832] = 2803,
  [2833] = 2797,
  [2834] = 2800,
  [2835] = 2800,
  [2836] = 2797,
  [2837] = 2800,
  [2838] = 2797,
  [2839] = 2797,
  [2840] = 2800,
  [2841] = 2800,
  [2842] = 2842,
  [2843] = 2800,
  [2844] = 2800,
  [2845] = 2797,
  [2846] = 2797,
  [2847] = 2800,
  [2848] = 2800,
  [2849] = 2803,
  [2850] = 2795,
  [2851] = 2800,
  [2852] = 2852,
  [2853] = 2797,
  [2854] = 2797,
  [2855] = 2797,
  [2856] = 2800,
  [2857] = 2826,
  [2858] = 2858,
  [2859] = 2800,
  [2860] = 2842,
  [2861] = 2800,
  [2862] = 2800,
  [2863] = 2800,
  [2864] = 2797,
  [2865] = 2825,
  [2866] = 2800,
  [2867] = 2800,
  [2868] = 2797,
  [2869] = 2800,
  [2870] = 2790,
  [2871] = 2797,
  [2872] = 2050,
  [2873] = 2801,
  [2874] = 2800,
  [2875] = 2875,
  [2876] = 2050,
  [2877] = 2672,
  [2878] = 2797,
  [2879] = 2800,
  [2880] = 2875,
  [2881] = 2797,
  [2882] = 2797,
  [2883] = 2883,
  [2884] = 2797,
  [2885] = 2800,
  [2886] = 2826,
  [2887] = 2802,
  [2888] = 2883,
  [2889] = 2800,
  [2890] = 2890,
  [2891] = 2797,
  [2892] = 2797,
  [2893] = 2797,
  [2894] = 2801,
  [2895] = 2825,
  [2896] = 2797,
  [2897] = 2800,
  [2898] = 2797,
  [2899] = 2800,
  [2900] = 2900,
  [2901] = 2800,
  [2902] = 2797,
  [2903] = 2800,
  [2904] = 2797,
  [2905] = 2803,
  [2906] = 2802,
  [2907] = 2797,
  [2908] = 2900,
  [2909] = 2800,
  [2910] = 2797,
  [2911] = 2890,
  [2912] = 2818,
  [2913] = 2672,
  [2914] = 2797,
  [2915] = 2800,
  [2916] = 2900,
  [2917] = 2800,
  [2918] = 2800,
  [2919] = 2800,
  [2920] = 2890,
  [2921] = 2797,
  [2922] = 2050,
  [2923] = 2672,
  [2924] = 2797,
  [2925] = 2797,
  [2926] = 2875,
  [2927] = 2797,
  [2928] = 2790,
  [2929] = 2800,
  [2930] = 2800,
  [2931] = 2803,
  [2932] = 2797,
  [2933] = 2797,
  [2934] = 2797,
  [2935] = 2800,
  [2936] = 2936,
  [2937] = 2936,
  [2938] = 2936,
  [2939] = 2936,
  [2940] = 2940,
  [2941] = 2941,
  [2942] = 2941,
  [2943] = 2940,
  [2944] = 2941,
  [2945] = 2941,
  [2946] = 2941,
  [2947] = 2940,
  [2948] = 2936,
  [2949] = 2940,
  [2950] = 2950,
  [2951] = 2936,
  [2952] = 2936,
  [2953] = 2941,
  [2954] = 2936,
  [2955] = 2955,
  [2956] = 2956,
  [2957] = 2957,
  [2958] = 2958,
  [2959] = 2936,
  [2960] = 2940,
  [2961] = 2961,
  [2962] = 2940,
  [2963] = 2940,
  [2964] = 2046,
  [2965] = 2940,
  [2966] = 2049,
  [2967] = 2049,
  [2968] = 2941,
  [2969] = 2936,
  [2970] = 2941,
  [2971] = 2940,
  [2972] = 2044,
  [2973] = 2941,
  [2974] = 2936,
  [2975] = 2936,
  [2976] = 2940,
  [2977] = 2941,
  [2978] = 2940,
  [2979] = 2941,
  [2980] = 2941,
  [2981] = 2941,
  [2982] = 2940,
  [2983] = 2941,
  [2984] = 2941,
  [2985] = 2936,
  [2986] = 2940,
  [2987] = 2936,
  [2988] = 2940,
  [2989] = 2941,
  [2990] = 2940,
  [2991] = 2940,
  [2992] = 2050,
  [2993] = 2940,
  [2994] = 2950,
  [2995] = 2940,
  [2996] = 2936,
  [2997] = 2997,
  [2998] = 2050,
  [2999] = 2936,
  [3000] = 2941,
  [3001] = 2940,
  [3002] = 2961,
  [3003] = 2936,
  [3004] = 2940,
  [3005] = 2790,
  [3006] = 2936,
  [3007] = 2936,
  [3008] = 2936,
  [3009] = 2795,
  [3010] = 2672,
  [3011] = 2941,
  [3012] = 2941,
  [3013] = 2941,
  [3014] = 2941,
  [3015] = 2940,
  [3016] = 2997,
  [3017] = 2941,
  [3018] = 2940,
  [3019] = 2958,
  [3020] = 2936,
  [3021] = 2940,
  [3022] = 2936,
  [3023] = 2941,
  [3024] = 2940,
  [3025] = 2936,
  [3026] = 2941,
  [3027] = 2950,
  [3028] = 2941,
  [3029] = 2957,
  [3030] = 2940,
  [3031] = 2941,
  [3032] = 2940,
  [3033] = 2941,
  [3034] = 2940,
  [3035] = 2936,
  [3036] = 2050,
  [3037] = 2941,
  [3038] = 2941,
  [3039] = 3039,
  [3040] = 2941,
  [3041] = 2936,
  [3042] = 2940,
  [3043] = 2936,
  [3044] = 2997,
  [3045] = 2955,
  [3046] = 3039,
  [3047] = 2956,
  [3048] = 2940,
  [3049] = 2940,
  [3050] = 2936,
  [3051] = 2941,
  [3052] = 2941,
  [3053] = 2672,
  [3054] = 2940,
  [3055] = 2940,
  [3056] = 2941,
  [3057] = 2940,
  [3058] = 2936,
  [3059] = 2940,
  [3060] = 2941,
  [3061] = 2940,
  [3062] = 2961,
  [3063] = 2936,
  [3064] = 2940,
  [3065] = 2956,
  [3066] = 2941,
  [3067] = 2936,
  [3068] = 2940,
  [3069] = 2941,
  [3070] = 2941,
  [3071] = 2941,
  [3072] = 2941,
  [3073] = 2940,
  [3074] = 2940,
  [3075] = 2936,
  [3076] = 2936,
  [3077] = 2936,
  [3078] = 2941,
  [3079] = 2936,
  [3080] = 2936,
  [3081] = 2955,
  [3082] = 2940,
  [3083] = 2936,
  [3084] = 2936,
  [3085] = 2936,
  [3086] = 2044,
  [3087] = 2936,
  [3088] = 2936,
  [3089] = 2046,
  [3090] = 2958,
  [3091] = 2957,
  [3092] = 2936,
  [3093] = 2936,
  [3094] = 2936,
  [3095] = 2672,
  [3096] = 2940,
  [3097] = 2936,
  [3098] = 2941,
  [3099] = 2936,
  [3100] = 2936,
  [3101] = 2940,
  [3102] = 2940,
  [3103] = 2940,
  [3104] = 2941,
  [3105] = 2940,
  [3106] = 2940,
  [3107] = 2941,
  [3108] = 2941,
  [3109] = 2941,
  [3110] = 2941,
  [3111] = 3111,
  [3112] = 2790,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 2795,
  [3116] = 2790,
  [3117] = 3117,
  [3118] = 2795,
  [3119] = 3117,
  [3120] = 2672,
  [3121] = 2790,
  [3122] = 2050,
  [3123] = 3123,
  [3124] = 2795,
  [3125] = 3125,
  [3126] = 2795,
  [3127] = 3114,
  [3128] = 2790,
  [3129] = 3129,
  [3130] = 3125,
  [3131] = 3129,
  [3132] = 3132,
  [3133] = 2790,
  [3134] = 3111,
  [3135] = 3132,
  [3136] = 2795,
  [3137] = 2050,
  [3138] = 2050,
  [3139] = 3139,
  [3140] = 2795,
  [3141] = 3141,
  [3142] = 3139,
  [3143] = 3143,
  [3144] = 3144,
  [3145] = 3139,
  [3146] = 3139,
  [3147] = 3143,
  [3148] = 3141,
  [3149] = 2790,
  [3150] = 2050,
  [3151] = 3139,
  [3152] = 3139,
  [3153] = 3143,
  [3154] = 3144,
  [3155] = 3143,
  [3156] = 3156,
  [3157] = 3139,
  [3158] = 2050,
  [3159] = 3159,
  [3160] = 3143,
  [3161] = 3117,
  [3162] = 2795,
  [3163] = 3143,
  [3164] = 2795,
  [3165] = 3139,
  [3166] = 3141,
  [3167] = 3143,
  [3168] = 3114,
  [3169] = 3143,
  [3170] = 3159,
  [3171] = 3143,
  [3172] = 2790,
  [3173] = 3139,
  [3174] = 3139,
  [3175] = 3143,
  [3176] = 3139,
  [3177] = 3159,
  [3178] = 2790,
  [3179] = 3139,
  [3180] = 3143,
  [3181] = 3143,
  [3182] = 3143,
  [3183] = 3144,
  [3184] = 3139,
  [3185] = 3185,
  [3186] = 3186,
  [3187] = 3187,
  [3188] = 3188,
  [3189] = 3187,
  [3190] = 3190,
  [3191] = 3185,
  [3192] = 3188,
  [3193] = 3188,
  [3194] = 3186,
  [3195] = 2795,
  [3196] = 3185,
  [3197] = 3186,
  [3198] = 2790,
  [3199] = 3199,
  [3200] = 3188,
  [3201] = 3190,
  [3202] = 3202,
  [3203] = 3203,
  [3204] = 3202,
  [3205] = 3205,
  [3206] = 3190,
  [3207] = 3203,
  [3208] = 3205,
  [3209] = 3202,
  [3210] = 3205,
  [3211] = 3205,
  [3212] = 3202,
  [3213] = 3202,
  [3214] = 3187,
  [3215] = 3215,
  [3216] = 3203,
  [3217] = 3205,
  [3218] = 3203,
  [3219] = 3205,
  [3220] = 3203,
  [3221] = 3221,
  [3222] = 3203,
  [3223] = 3203,
  [3224] = 3203,
  [3225] = 3190,
  [3226] = 3205,
  [3227] = 3205,
  [3228] = 3203,
  [3229] = 3202,
  [3230] = 3221,
  [3231] = 3205,
  [3232] = 3203,
  [3233] = 3205,
  [3234] = 3203,
  [3235] = 3202,
  [3236] = 3205,
  [3237] = 3205,
  [3238] = 3203,
  [3239] = 3203,
  [3240] = 3203,
  [3241] = 3205,
  [3242] = 3205,
  [3243] = 3221,
  [3244] = 3205,
  [3245] = 3221,
  [3246] = 3187,
  [3247] = 3205,
  [3248] = 3205,
  [3249] = 3205,
  [3250] = 3202,
  [3251] = 3203,
  [3252] = 3203,
  [3253] = 3205,
  [3254] = 3203,
  [3255] = 3203,
  [3256] = 3205,
  [3257] = 3203,
  [3258] = 3203,
  [3259] = 3205,
  [3260] = 3203,
  [3261] = 3202,
  [3262] = 3205,
  [3263] = 3202,
  [3264] = 3205,
  [3265] = 3203,
  [3266] = 3202,
  [3267] = 3205,
  [3268] = 3205,
  [3269] = 3205,
  [3270] = 3205,
  [3271] = 3203,
  [3272] = 3272,
  [3273] = 3202,
  [3274] = 3203,
  [3275] = 3205,
  [3276] = 3203,
  [3277] = 3202,
  [3278] = 3205,
  [3279] = 3203,
  [3280] = 3202,
  [3281] = 3281,
  [3282] = 3205,
  [3283] = 3205,
  [3284] = 3221,
  [3285] = 3203,
  [3286] = 3203,
  [3287] = 3215,
  [3288] = 3202,
  [3289] = 3202,
  [3290] = 3203,
  [3291] = 3202,
  [3292] = 3205,
  [3293] = 3187,
  [3294] = 3215,
  [3295] = 3205,
  [3296] = 3296,
  [3297] = 3203,
  [3298] = 3203,
  [3299] = 3205,
  [3300] = 3203,
  [3301] = 3301,
  [3302] = 3205,
  [3303] = 3203,
  [3304] = 3203,
  [3305] = 3203,
  [3306] = 3205,
  [3307] = 3203,
  [3308] = 3205,
  [3309] = 3205,
  [3310] = 3190,
  [3311] = 3203,
  [3312] = 3202,
  [3313] = 3203,
  [3314] = 3203,
  [3315] = 3203,
  [3316] = 3205,
  [3317] = 3203,
  [3318] = 3221,
  [3319] = 3203,
  [3320] = 3205,
  [3321] = 3205,
  [3322] = 3202,
  [3323] = 3205,
  [3324] = 3203,
  [3325] = 3202,
  [3326] = 3205,
  [3327] = 3202,
  [3328] = 3202,
  [3329] = 3205,
  [3330] = 3203,
  [3331] = 3202,
  [3332] = 3203,
  [3333] = 3203,
  [3334] = 3205,
  [3335] = 3205,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 3336,
  [3341] = 3341,
  [3342] = 3341,
  [3343] = 3339,
  [3344] = 3339,
  [3345] = 3345,
  [3346] = 3339,
  [3347] = 3341,
  [3348] = 3190,
  [3349] = 3341,
  [3350] = 3336,
  [3351] = 3341,
  [3352] = 3187,
  [3353] = 3338,
  [3354] = 3338,
  [3355] = 3341,
  [3356] = 3336,
  [3357] = 3339,
  [3358] = 3358,
  [3359] = 3336,
  [3360] = 3336,
  [3361] = 3338,
  [3362] = 3341,
  [3363] = 3339,
  [3364] = 3336,
  [3365] = 3338,
  [3366] = 2790,
  [3367] = 3336,
  [3368] = 3339,
  [3369] = 3336,
  [3370] = 3370,
  [3371] = 3341,
  [3372] = 3338,
  [3373] = 3338,
  [3374] = 3341,
  [3375] = 3339,
  [3376] = 3336,
  [3377] = 3338,
  [3378] = 3336,
  [3379] = 3339,
  [3380] = 3341,
  [3381] = 3338,
  [3382] = 3341,
  [3383] = 3339,
  [3384] = 3336,
  [3385] = 3338,
  [3386] = 3336,
  [3387] = 3338,
  [3388] = 3341,
  [3389] = 3339,
  [3390] = 3338,
  [3391] = 3339,
  [3392] = 3336,
  [3393] = 3339,
  [3394] = 3338,
  [3395] = 3338,
  [3396] = 3341,
  [3397] = 3341,
  [3398] = 3339,
  [3399] = 3339,
  [3400] = 3339,
  [3401] = 3341,
  [3402] = 3338,
  [3403] = 3339,
  [3404] = 3339,
  [3405] = 3405,
  [3406] = 3341,
  [3407] = 3407,
  [3408] = 3338,
  [3409] = 3338,
  [3410] = 3336,
  [3411] = 3341,
  [3412] = 3339,
  [3413] = 3336,
  [3414] = 3338,
  [3415] = 3338,
  [3416] = 3341,
  [3417] = 3338,
  [3418] = 3339,
  [3419] = 3338,
  [3420] = 3341,
  [3421] = 3338,
  [3422] = 3341,
  [3423] = 3341,
  [3424] = 3341,
  [3425] = 3339,
  [3426] = 3338,
  [3427] = 3338,
  [3428] = 3341,
  [3429] = 3339,
  [3430] = 3338,
  [3431] = 3338,
  [3432] = 3338,
  [3433] = 3341,
  [3434] = 3339,
  [3435] = 3338,
  [3436] = 3336,
  [3437] = 3341,
  [3438] = 3341,
  [3439] = 3339,
  [3440] = 3339,
  [3441] = 3341,
  [3442] = 3339,
  [3443] = 3407,
  [3444] = 3341,
  [3445] = 3339,
  [3446] = 3336,
  [3447] = 3338,
  [3448] = 3338,
  [3449] = 3187,
  [3450] = 3405,
  [3451] = 3341,
  [3452] = 3336,
  [3453] = 3339,
  [3454] = 3339,
  [3455] = 3338,
  [3456] = 3339,
  [3457] = 3341,
  [3458] = 3336,
  [3459] = 3339,
  [3460] = 3338,
  [3461] = 3339,
  [3462] = 3341,
  [3463] = 3338,
  [3464] = 3341,
  [3465] = 3338,
  [3466] = 3339,
  [3467] = 3341,
  [3468] = 3338,
  [3469] = 3339,
  [3470] = 3341,
  [3471] = 3339,
  [3472] = 3338,
  [3473] = 3341,
  [3474] = 3190,
  [3475] = 3341,
  [3476] = 3339,
  [3477] = 3341,
  [3478] = 3338,
  [3479] = 3338,
  [3480] = 3187,
  [3481] = 3341,
  [3482] = 3339,
  [3483] = 3339,
  [3484] = 3339,
  [3485] = 3338,
  [3486] = 3339,
  [3487] = 3338,
  [3488] = 3341,
  [3489] = 3338,
  [3490] = 3405,
  [3491] = 3491,
  [3492] = 3341,
  [3493] = 3190,
  [3494] = 3339,
  [3495] = 3341,
  [3496] = 3339,
  [3497] = 3338,
  [3498] = 3336,
  [3499] = 3339,
  [3500] = 3339,
  [3501] = 3338,
  [3502] = 3341,
  [3503] = 3338,
  [3504] = 3336,
  [3505] = 3341,
  [3506] = 3336,
  [3507] = 3338,
  [3508] = 3407,
  [3509] = 3339,
  [3510] = 3341,
  [3511] = 3341,
  [3512] = 3338,
  [3513] = 3337,
  [3514] = 3341,
  [3515] = 3339,
  [3516] = 3516,
  [3517] = 3187,
  [3518] = 3518,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3523,
  [3525] = 3522,
  [3526] = 3190,
  [3527] = 3527,
  [3528] = 3520,
  [3529] = 3529,
  [3530] = 3519,
  [3531] = 3516,
  [3532] = 3518,
  [3533] = 3529,
  [3534] = 3527,
  [3535] = 3516,
  [3536] = 3523,
  [3537] = 3522,
  [3538] = 3527,
  [3539] = 3520,
  [3540] = 3190,
  [3541] = 3529,
  [3542] = 3518,
  [3543] = 3187,
  [3544] = 3544,
  [3545] = 3545,
  [3546] = 3545,
  [3547] = 3545,
  [3548] = 3545,
  [3549] = 2044,
  [3550] = 2046,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3545,
  [3554] = 3554,
  [3555] = 3545,
  [3556] = 3552,
  [3557] = 3557,
  [3558] = 3558,
  [3559] = 3545,
  [3560] = 3560,
  [3561] = 3554,
  [3562] = 3545,
  [3563] = 3545,
  [3564] = 3544,
  [3565] = 3545,
  [3566] = 3554,
  [3567] = 3545,
  [3568] = 3545,
  [3569] = 3569,
  [3570] = 3544,
  [3571] = 3552,
  [3572] = 3545,
  [3573] = 3569,
  [3574] = 3544,
  [3575] = 3545,
  [3576] = 3554,
  [3577] = 3545,
  [3578] = 3545,
  [3579] = 3554,
  [3580] = 3545,
  [3581] = 3552,
  [3582] = 3551,
  [3583] = 3545,
  [3584] = 3545,
  [3585] = 3545,
  [3586] = 3552,
  [3587] = 3545,
  [3588] = 3545,
  [3589] = 3545,
  [3590] = 3545,
  [3591] = 2049,
  [3592] = 3560,
  [3593] = 3560,
  [3594] = 3545,
  [3595] = 3545,
  [3596] = 3545,
  [3597] = 3569,
  [3598] = 3545,
  [3599] = 3545,
  [3600] = 3545,
  [3601] = 3554,
  [3602] = 3545,
  [3603] = 3545,
  [3604] = 3569,
  [3605] = 3551,
  [3606] = 3606,
  [3607] = 3545,
  [3608] = 3545,
  [3609] = 3552,
  [3610] = 3545,
  [3611] = 3545,
  [3612] = 3545,
  [3613] = 3613,
  [3614] = 3545,
  [3615] = 3545,
  [3616] = 3545,
  [3617] = 3545,
  [3618] = 3618,
  [3619] = 3545,
  [3620] = 3545,
  [3621] = 3545,
  [3622] = 3545,
  [3623] = 3545,
  [3624] = 3545,
  [3625] = 3545,
  [3626] = 3626,
  [3627] = 3626,
  [3628] = 3628,
  [3629] = 3628,
  [3630] = 3630,
  [3631] = 3631,
  [3632] = 3628,
  [3633] = 3626,
  [3634] = 3630,
  [3635] = 3630,
  [3636] = 3631,
  [3637] = 3630,
  [3638] = 3626,
  [3639] = 3628,
  [3640] = 3630,
  [3641] = 3628,
  [3642] = 3628,
  [3643] = 3626,
  [3644] = 3626,
  [3645] = 3630,
  [3646] = 3626,
  [3647] = 3630,
  [3648] = 3628,
  [3649] = 3630,
  [3650] = 3628,
  [3651] = 3630,
  [3652] = 3628,
  [3653] = 3626,
  [3654] = 3626,
  [3655] = 3630,
  [3656] = 3630,
  [3657] = 3626,
  [3658] = 3628,
  [3659] = 3630,
  [3660] = 3630,
  [3661] = 3628,
  [3662] = 3630,
  [3663] = 3631,
  [3664] = 3628,
  [3665] = 3626,
  [3666] = 3626,
  [3667] = 3631,
  [3668] = 3630,
  [3669] = 3630,
  [3670] = 3628,
  [3671] = 3626,
  [3672] = 3630,
  [3673] = 3631,
  [3674] = 3626,
  [3675] = 3628,
  [3676] = 3628,
  [3677] = 3628,
  [3678] = 3630,
  [3679] = 3631,
  [3680] = 3626,
  [3681] = 3626,
  [3682] = 3628,
  [3683] = 3631,
  [3684] = 3628,
  [3685] = 3626,
  [3686] = 3630,
  [3687] = 3631,
  [3688] = 3628,
  [3689] = 3630,
  [3690] = 3630,
  [3691] = 3626,
  [3692] = 3626,
  [3693] = 3630,
  [3694] = 3628,
  [3695] = 3628,
  [3696] = 3626,
  [3697] = 3626,
  [3698] = 3630,
  [3699] = 3631,
  [3700] = 3630,
  [3701] = 3626,
  [3702] = 3628,
  [3703] = 3630,
  [3704] = 3628,
  [3705] = 3628,
  [3706] = 3626,
  [3707] = 3630,
  [3708] = 3631,
  [3709] = 3626,
  [3710] = 3628,
  [3711] = 3626,
  [3712] = 3626,
  [3713] = 3628,
  [3714] = 3628,
  [3715] = 3626,
  [3716] = 3631,
  [3717] = 3626,
  [3718] = 3631,
  [3719] = 3631,
  [3720] = 3630,
  [3721] = 3628,
  [3722] = 3630,
  [3723] = 3723,
  [3724] = 3724,
  [3725] = 3724,
  [3726] = 3726,
  [3727] = 3726,
  [3728] = 3728,
  [3729] = 3729,
  [3730] = 3730,
  [3731] = 3731,
  [3732] = 3728,
  [3733] = 3731,
  [3734] = 3729,
  [3735] = 3726,
  [3736] = 3736,
  [3737] = 3728,
  [3738] = 3738,
  [3739] = 3730,
  [3740] = 3723,
  [3741] = 3723,
  [3742] = 3730,
  [3743] = 3738,
  [3744] = 3744,
  [3745] = 3745,
  [3746] = 3746,
  [3747] = 3747,
  [3748] = 3748,
  [3749] = 3749,
  [3750] = 3750,
  [3751] = 3751,
  [3752] = 3752,
  [3753] = 3753,
  [3754] = 3754,
  [3755] = 3755,
  [3756] = 3746,
  [3757] = 3757,
  [3758] = 3758,
  [3759] = 3744,
  [3760] = 3760,
  [3761] = 3761,
  [3762] = 3762,
  [3763] = 3761,
  [3764] = 3764,
  [3765] = 3765,
  [3766] = 3760,
  [3767] = 3767,
  [3768] = 3754,
  [3769] = 3769,
  [3770] = 3770,
  [3771] = 3770,
  [3772] = 3772,
  [3773] = 3747,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 3776,
  [3777] = 3777,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 3781,
  [3782] = 3782,
  [3783] = 3783,
  [3784] = 3746,
  [3785] = 3774,
  [3786] = 3738,
  [3787] = 3765,
  [3788] = 3778,
  [3789] = 3789,
  [3790] = 3777,
  [3791] = 3791,
  [3792] = 3762,
  [3793] = 3781,
  [3794] = 3794,
  [3795] = 3769,
  [3796] = 3796,
  [3797] = 3789,
  [3798] = 3752,
  [3799] = 3767,
  [3800] = 3749,
  [3801] = 3753,
  [3802] = 3750,
  [3803] = 3775,
  [3804] = 3804,
  [3805] = 3755,
  [3806] = 3806,
  [3807] = 3791,
  [3808] = 3758,
  [3809] = 3809,
  [3810] = 3810,
  [3811] = 3751,
  [3812] = 3806,
  [3813] = 3758,
  [3814] = 3783,
  [3815] = 3815,
  [3816] = 3757,
  [3817] = 3815,
  [3818] = 3779,
  [3819] = 3780,
  [3820] = 3782,
  [3821] = 3772,
  [3822] = 3794,
  [3823] = 3764,
  [3824] = 3796,
  [3825] = 3825,
  [3826] = 3826,
  [3827] = 3723,
  [3828] = 3828,
  [3829] = 3829,
  [3830] = 3830,
  [3831] = 3828,
  [3832] = 3832,
  [3833] = 3833,
  [3834] = 3834,
  [3835] = 3835,
  [3836] = 3836,
  [3837] = 3837,
  [3838] = 3838,
  [3839] = 3839,
  [3840] = 3840,
  [3841] = 3841,
  [3842] = 3842,
  [3843] = 3843,
  [3844] = 3844,
  [3845] = 3845,
  [3846] = 3846,
  [3847] = 3847,
  [3848] = 3840,
  [3849] = 3849,
  [3850] = 3850,
  [3851] = 3851,
  [3852] = 3840,
  [3853] = 3853,
  [3854] = 3837,
  [3855] = 3840,
  [3856] = 3856,
  [3857] = 3857,
  [3858] = 3828,
  [3859] = 3859,
  [3860] = 3860,
  [3861] = 3861,
  [3862] = 3862,
  [3863] = 3863,
  [3864] = 3840,
  [3865] = 3837,
  [3866] = 3845,
  [3867] = 3867,
  [3868] = 3868,
  [3869] = 3863,
  [3870] = 3870,
  [3871] = 3868,
  [3872] = 3840,
  [3873] = 3837,
  [3874] = 3874,
  [3875] = 3875,
  [3876] = 3837,
  [3877] = 3840,
  [3878] = 3730,
  [3879] = 3828,
  [3880] = 3837,
  [3881] = 3863,
  [3882] = 3828,
  [3883] = 3834,
  [3884] = 3834,
  [3885] = 3863,
  [3886] = 3845,
  [3887] = 3863,
  [3888] = 3834,
  [3889] = 3828,
  [3890] = 3834,
  [3891] = 3837,
  [3892] = 3837,
  [3893] = 3863,
  [3894] = 3868,
  [3895] = 3828,
  [3896] = 3837,
  [3897] = 3828,
  [3898] = 3828,
  [3899] = 3834,
  [3900] = 3840,
  [3901] = 3863,
  [3902] = 3834,
  [3903] = 3828,
  [3904] = 3837,
  [3905] = 3845,
  [3906] = 3837,
  [3907] = 3863,
  [3908] = 3834,
  [3909] = 3834,
  [3910] = 3863,
  [3911] = 3834,
  [3912] = 3828,
  [3913] = 3828,
  [3914] = 3837,
  [3915] = 3728,
  [3916] = 3834,
  [3917] = 3837,
  [3918] = 3828,
  [3919] = 3834,
  [3920] = 3834,
  [3921] = 3828,
  [3922] = 3828,
  [3923] = 3834,
  [3924] = 3828,
  [3925] = 3868,
  [3926] = 3837,
  [3927] = 3834,
  [3928] = 3840,
  [3929] = 3828,
  [3930] = 3837,
  [3931] = 3840,
  [3932] = 3837,
  [3933] = 3840,
  [3934] = 3828,
  [3935] = 3834,
  [3936] = 3837,
  [3937] = 3863,
  [3938] = 3845,
  [3939] = 3837,
  [3940] = 3868,
  [3941] = 3863,
  [3942] = 3868,
  [3943] = 3845,
  [3944] = 3834,
  [3945] = 3834,
  [3946] = 3837,
  [3947] = 3828,
  [3948] = 3828,
  [3949] = 3840,
  [3950] = 3834,
  [3951] = 3863,
  [3952] = 3828,
  [3953] = 3834,
  [3954] = 3837,
  [3955] = 3834,
  [3956] = 3828,
  [3957] = 3834,
  [3958] = 3863,
  [3959] = 3840,
  [3960] = 3837,
  [3961] = 3834,
  [3962] = 3828,
  [3963] = 3828,
  [3964] = 3828,
  [3965] = 3837,
  [3966] = 3828,
  [3967] = 3834,
  [3968] = 3863,
  [3969] = 3837,
  [3970] = 3834,
  [3971] = 3863,
  [3972] = 3863,
  [3973] = 3837,
  [3974] = 3840,
  [3975] = 3837,
  [3976] = 3828,
  [3977] = 3834,
  [3978] = 3863,
  [3979] = 3828,
  [3980] = 3837,
  [3981] = 3837,
  [3982] = 3828,
  [3983] = 3834,
  [3984] = 3840,
  [3985] = 3837,
  [3986] = 3840,
  [3987] = 3828,
  [3988] = 3834,
  [3989] = 3837,
  [3990] = 3837,
  [3991] = 3845,
  [3992] = 3868,
  [3993] = 3840,
  [3994] = 3840,
  [3995] = 3828,
  [3996] = 3834,
  [3997] = 3837,
  [3998] = 3834,
  [3999] = 3863,
  [4000] = 3837,
  [4001] = 3863,
  [4002] = 3828,
  [4003] = 3837,
  [4004] = 3845,
  [4005] = 3868,
  [4006] = 3828,
  [4007] = 3834,
  [4008] = 3828,
  [4009] = 3834,
  [4010] = 3840,
  [4011] = 3828,
  [4012] = 3837,
  [4013] = 3863,
  [4014] = 3834,
  [4015] = 3828,
  [4016] = 3834,
  [4017] = 3837,
  [4018] = 3745,
  [4019] = 3828,
  [4020] = 3828,
  [4021] = 3828,
  [4022] = 3834,
  [4023] = 3863,
  [4024] = 3834,
  [4025] = 3837,
  [4026] = 3834,
  [4027] = 3828,
  [4028] = 3840,
  [4029] = 3828,
  [4030] = 3834,
  [4031] = 3834,
  [4032] = 3837,
  [4033] = 3837,
  [4034] = 3828,
  [4035] = 3834,
  [4036] = 3834,
  [4037] = 3828,
  [4038] = 3863,
  [4039] = 3834,
  [4040] = 3863,
  [4041] = 3840,
  [4042] = 3837,
  [4043] = 3840,
  [4044] = 3837,
  [4045] = 3828,
  [4046] = 3840,
  [4047] = 3840,
  [4048] = 3863,
  [4049] = 3863,
  [4050] = 3828,
  [4051] = 3868,
  [4052] = 3837,
  [4053] = 3845,
  [4054] = 3834,
  [4055] = 3863,
  [4056] = 3837,
  [4057] = 3863,
  [4058] = 3837,
  [4059] = 3840,
  [4060] = 3837,
  [4061] = 3752,
  [4062] = 3828,
  [4063] = 3840,
  [4064] = 3837,
  [4065] = 3834,
  [4066] = 3863,
  [4067] = 3837,
  [4068] = 3828,
  [4069] = 3840,
  [4070] = 3840,
  [4071] = 3834,
  [4072] = 3845,
  [4073] = 3868,
  [4074] = 3828,
  [4075] = 3834,
  [4076] = 3833,
  [4077] = 3829,
  [4078] = 4078,
  [4079] = 3874,
  [4080] = 3723,
  [4081] = 4081,
  [4082] = 3870,
  [4083] = 4083,
  [4084] = 3867,
  [4085] = 4085,
  [4086] = 4086,
  [4087] = 4087,
  [4088] = 4088,
  [4089] = 4089,
  [4090] = 3755,
  [4091] = 3729,
  [4092] = 3724,
  [4093] = 4093,
  [4094] = 4094,
  [4095] = 4095,
  [4096] = 3862,
  [4097] = 4097,
  [4098] = 3860,
  [4099] = 4099,
  [4100] = 4100,
  [4101] = 4101,
  [4102] = 3859,
  [4103] = 3832,
  [4104] = 3856,
  [4105] = 3875,
  [4106] = 3853,
  [4107] = 3851,
  [4108] = 3825,
  [4109] = 3850,
  [4110] = 4110,
  [4111] = 4111,
  [4112] = 4112,
  [4113] = 3849,
  [4114] = 3861,
  [4115] = 3730,
  [4116] = 3728,
  [4117] = 3826,
  [4118] = 3839,
  [4119] = 3758,
  [4120] = 3846,
  [4121] = 3731,
  [4122] = 3844,
  [4123] = 3843,
  [4124] = 3842,
  [4125] = 3841,
  [4126] = 3838,
  [4127] = 3746,
  [4128] = 3755,
  [4129] = 3755,
  [4130] = 3836,
  [4131] = 3835,
  [4132] = 3857,
  [4133] = 3830,
  [4134] = 4101,
  [4135] = 4135,
  [4136] = 3749,
  [4137] = 3758,
  [4138] = 4086,
  [4139] = 3815,
  [4140] = 3753,
  [4141] = 4087,
  [4142] = 3783,
  [4143] = 3770,
  [4144] = 3767,
  [4145] = 4094,
  [4146] = 3729,
  [4147] = 3728,
  [4148] = 4083,
  [4149] = 4081,
  [4150] = 3750,
  [4151] = 4088,
  [4152] = 4078,
  [4153] = 3754,
  [4154] = 4093,
  [4155] = 4089,
  [4156] = 4095,
  [4157] = 3731,
  [4158] = 4101,
  [4159] = 3765,
  [4160] = 3723,
  [4161] = 3755,
  [4162] = 3723,
  [4163] = 4097,
  [4164] = 3746,
  [4165] = 3791,
  [4166] = 3728,
  [4167] = 3764,
  [4168] = 3728,
  [4169] = 3723,
  [4170] = 3730,
  [4171] = 3769,
  [4172] = 4135,
  [4173] = 4099,
  [4174] = 4100,
  [4175] = 4085,
  [4176] = 3730,
  [4177] = 3730,
  [4178] = 3762,
  [4179] = 3728,
  [4180] = 3730,
  [4181] = 3757,
  [4182] = 3774,
  [4183] = 3775,
  [4184] = 3781,
  [4185] = 3778,
  [4186] = 3789,
  [4187] = 3728,
  [4188] = 3751,
  [4189] = 3728,
  [4190] = 3761,
  [4191] = 4110,
  [4192] = 3730,
  [4193] = 3723,
  [4194] = 3780,
  [4195] = 3796,
  [4196] = 4111,
  [4197] = 3723,
  [4198] = 3724,
  [4199] = 3760,
  [4200] = 4112,
  [4201] = 3729,
  [4202] = 3744,
  [4203] = 3806,
  [4204] = 3731,
  [4205] = 3747,
  [4206] = 3782,
  [4207] = 3724,
  [4208] = 3779,
  [4209] = 3772,
  [4210] = 3755,
  [4211] = 3794,
  [4212] = 3723,
  [4213] = 3745,
  [4214] = 3777,
  [4215] = 3730,
  [4216] = 3751,
  [4217] = 3730,
  [4218] = 3796,
  [4219] = 3794,
  [4220] = 3791,
  [4221] = 3789,
  [4222] = 3815,
  [4223] = 3774,
  [4224] = 3782,
  [4225] = 3780,
  [4226] = 3779,
  [4227] = 3875,
  [4228] = 3728,
  [4229] = 3772,
  [4230] = 3769,
  [4231] = 3760,
  [4232] = 3806,
  [4233] = 3762,
  [4234] = 3761,
  [4235] = 3744,
  [4236] = 3755,
  [4237] = 4101,
  [4238] = 4101,
  [4239] = 3874,
  [4240] = 3783,
  [4241] = 3760,
  [4242] = 3728,
  [4243] = 3755,
  [4244] = 3758,
  [4245] = 3746,
  [4246] = 3724,
  [4247] = 3747,
  [4248] = 3749,
  [4249] = 3750,
  [4250] = 3747,
  [4251] = 3746,
  [4252] = 3751,
  [4253] = 3757,
  [4254] = 3764,
  [4255] = 3765,
  [4256] = 3754,
  [4257] = 3770,
  [4258] = 3746,
  [4259] = 3806,
  [4260] = 3758,
  [4261] = 3723,
  [4262] = 3775,
  [4263] = 3758,
  [4264] = 3730,
  [4265] = 3746,
  [4266] = 3728,
  [4267] = 3723,
  [4268] = 3870,
  [4269] = 4101,
  [4270] = 3777,
  [4271] = 3867,
  [4272] = 3730,
  [4273] = 3757,
  [4274] = 3723,
  [4275] = 3723,
  [4276] = 3764,
  [4277] = 3745,
  [4278] = 3762,
  [4279] = 3781,
  [4280] = 3729,
  [4281] = 3730,
  [4282] = 3749,
  [4283] = 3730,
  [4284] = 3765,
  [4285] = 3754,
  [4286] = 3767,
  [4287] = 3778,
  [4288] = 3774,
  [4289] = 3728,
  [4290] = 3746,
  [4291] = 3770,
  [4292] = 3767,
  [4293] = 3815,
  [4294] = 4294,
  [4295] = 3826,
  [4296] = 3745,
  [4297] = 3744,
  [4298] = 3761,
  [4299] = 3777,
  [4300] = 3862,
  [4301] = 3775,
  [4302] = 3861,
  [4303] = 3860,
  [4304] = 4101,
  [4305] = 3859,
  [4306] = 3857,
  [4307] = 3856,
  [4308] = 3723,
  [4309] = 3853,
  [4310] = 3851,
  [4311] = 3753,
  [4312] = 3750,
  [4313] = 3825,
  [4314] = 3746,
  [4315] = 4315,
  [4316] = 3755,
  [4317] = 3850,
  [4318] = 3849,
  [4319] = 3769,
  [4320] = 3789,
  [4321] = 4321,
  [4322] = 3778,
  [4323] = 3781,
  [4324] = 3796,
  [4325] = 3779,
  [4326] = 3758,
  [4327] = 3783,
  [4328] = 3846,
  [4329] = 3794,
  [4330] = 3758,
  [4331] = 3844,
  [4332] = 3843,
  [4333] = 3782,
  [4334] = 3842,
  [4335] = 3780,
  [4336] = 3829,
  [4337] = 3772,
  [4338] = 3791,
  [4339] = 3841,
  [4340] = 3839,
  [4341] = 3830,
  [4342] = 3728,
  [4343] = 4315,
  [4344] = 3832,
  [4345] = 3833,
  [4346] = 4101,
  [4347] = 3838,
  [4348] = 3836,
  [4349] = 3835,
  [4350] = 3731,
  [4351] = 3758,
  [4352] = 3861,
  [4353] = 3758,
  [4354] = 4093,
  [4355] = 3875,
  [4356] = 4356,
  [4357] = 3830,
  [4358] = 3758,
  [4359] = 3753,
  [4360] = 4094,
  [4361] = 3835,
  [4362] = 3859,
  [4363] = 3751,
  [4364] = 3765,
  [4365] = 3783,
  [4366] = 4095,
  [4367] = 4315,
  [4368] = 3746,
  [4369] = 3844,
  [4370] = 4089,
  [4371] = 4088,
  [4372] = 4087,
  [4373] = 4101,
  [4374] = 3846,
  [4375] = 3731,
  [4376] = 4097,
  [4377] = 4086,
  [4378] = 3857,
  [4379] = 3844,
  [4380] = 4085,
  [4381] = 4083,
  [4382] = 4099,
  [4383] = 4100,
  [4384] = 3843,
  [4385] = 3860,
  [4386] = 3826,
  [4387] = 4081,
  [4388] = 3843,
  [4389] = 4078,
  [4390] = 3850,
  [4391] = 3861,
  [4392] = 3862,
  [4393] = 3754,
  [4394] = 3838,
  [4395] = 3842,
  [4396] = 3836,
  [4397] = 3835,
  [4398] = 3825,
  [4399] = 4101,
  [4400] = 3867,
  [4401] = 3749,
  [4402] = 3839,
  [4403] = 3750,
  [4404] = 3841,
  [4405] = 3746,
  [4406] = 3856,
  [4407] = 3833,
  [4408] = 3853,
  [4409] = 3874,
  [4410] = 3747,
  [4411] = 3764,
  [4412] = 3832,
  [4413] = 3826,
  [4414] = 3758,
  [4415] = 3851,
  [4416] = 4356,
  [4417] = 3723,
  [4418] = 3853,
  [4419] = 3856,
  [4420] = 3772,
  [4421] = 3779,
  [4422] = 3857,
  [4423] = 3761,
  [4424] = 3839,
  [4425] = 3780,
  [4426] = 3846,
  [4427] = 3746,
  [4428] = 3757,
  [4429] = 4110,
  [4430] = 3724,
  [4431] = 3870,
  [4432] = 3789,
  [4433] = 3842,
  [4434] = 3851,
  [4435] = 4435,
  [4436] = 3729,
  [4437] = 3731,
  [4438] = 3781,
  [4439] = 3862,
  [4440] = 4440,
  [4441] = 3829,
  [4442] = 3758,
  [4443] = 3806,
  [4444] = 3825,
  [4445] = 3723,
  [4446] = 3832,
  [4447] = 3833,
  [4448] = 3755,
  [4449] = 3746,
  [4450] = 3841,
  [4451] = 3778,
  [4452] = 3850,
  [4453] = 3770,
  [4454] = 3775,
  [4455] = 4455,
  [4456] = 4101,
  [4457] = 4135,
  [4458] = 3762,
  [4459] = 3744,
  [4460] = 3745,
  [4461] = 4435,
  [4462] = 3730,
  [4463] = 3777,
  [4464] = 3815,
  [4465] = 3728,
  [4466] = 3860,
  [4467] = 4101,
  [4468] = 3730,
  [4469] = 3728,
  [4470] = 3769,
  [4471] = 3724,
  [4472] = 3791,
  [4473] = 3758,
  [4474] = 3859,
  [4475] = 4101,
  [4476] = 3746,
  [4477] = 3782,
  [4478] = 3794,
  [4479] = 3796,
  [4480] = 4440,
  [4481] = 3875,
  [4482] = 3838,
  [4483] = 3729,
  [4484] = 4455,
  [4485] = 3849,
  [4486] = 3849,
  [4487] = 3870,
  [4488] = 3767,
  [4489] = 3836,
  [4490] = 3774,
  [4491] = 4111,
  [4492] = 3829,
  [4493] = 3830,
  [4494] = 3867,
  [4495] = 4112,
  [4496] = 3874,
  [4497] = 4101,
  [4498] = 3760,
  [4499] = 3777,
  [4500] = 3794,
  [4501] = 3860,
  [4502] = 3861,
  [4503] = 3853,
  [4504] = 3851,
  [4505] = 4315,
  [4506] = 3859,
  [4507] = 3724,
  [4508] = 3825,
  [4509] = 4440,
  [4510] = 3850,
  [4511] = 3849,
  [4512] = 3783,
  [4513] = 4455,
  [4514] = 4085,
  [4515] = 3723,
  [4516] = 3846,
  [4517] = 3815,
  [4518] = 3857,
  [4519] = 4315,
  [4520] = 4086,
  [4521] = 3775,
  [4522] = 3844,
  [4523] = 3843,
  [4524] = 3842,
  [4525] = 3841,
  [4526] = 3839,
  [4527] = 4099,
  [4528] = 4110,
  [4529] = 3729,
  [4530] = 3789,
  [4531] = 3838,
  [4532] = 3836,
  [4533] = 3835,
  [4534] = 3779,
  [4535] = 3833,
  [4536] = 3832,
  [4537] = 4100,
  [4538] = 3724,
  [4539] = 3762,
  [4540] = 3731,
  [4541] = 3830,
  [4542] = 3829,
  [4543] = 3731,
  [4544] = 3731,
  [4545] = 3862,
  [4546] = 3724,
  [4547] = 3826,
  [4548] = 3764,
  [4549] = 3730,
  [4550] = 3791,
  [4551] = 4083,
  [4552] = 3757,
  [4553] = 3751,
  [4554] = 3772,
  [4555] = 3760,
  [4556] = 4093,
  [4557] = 3731,
  [4558] = 3746,
  [4559] = 3750,
  [4560] = 4560,
  [4561] = 4560,
  [4562] = 3758,
  [4563] = 3745,
  [4564] = 3724,
  [4565] = 3745,
  [4566] = 3794,
  [4567] = 3867,
  [4568] = 4112,
  [4569] = 3746,
  [4570] = 4435,
  [4571] = 3730,
  [4572] = 3731,
  [4573] = 4573,
  [4574] = 3870,
  [4575] = 4087,
  [4576] = 4087,
  [4577] = 3723,
  [4578] = 3810,
  [4579] = 3758,
  [4580] = 3729,
  [4581] = 3723,
  [4582] = 3747,
  [4583] = 3775,
  [4584] = 3749,
  [4585] = 3749,
  [4586] = 3747,
  [4587] = 3778,
  [4588] = 3728,
  [4589] = 3723,
  [4590] = 4100,
  [4591] = 3729,
  [4592] = 3729,
  [4593] = 3781,
  [4594] = 3744,
  [4595] = 4081,
  [4596] = 4078,
  [4597] = 3750,
  [4598] = 3761,
  [4599] = 3728,
  [4600] = 3724,
  [4601] = 4294,
  [4602] = 3728,
  [4603] = 3730,
  [4604] = 3856,
  [4605] = 3729,
  [4606] = 3751,
  [4607] = 3769,
  [4608] = 3730,
  [4609] = 3791,
  [4610] = 3757,
  [4611] = 3780,
  [4612] = 4088,
  [4613] = 3874,
  [4614] = 3762,
  [4615] = 4094,
  [4616] = 4095,
  [4617] = 4078,
  [4618] = 3875,
  [4619] = 4089,
  [4620] = 4099,
  [4621] = 3723,
  [4622] = 3783,
  [4623] = 3723,
  [4624] = 3745,
  [4625] = 4081,
  [4626] = 3755,
  [4627] = 3789,
  [4628] = 3760,
  [4629] = 3730,
  [4630] = 4083,
  [4631] = 4111,
  [4632] = 3728,
  [4633] = 3723,
  [4634] = 3729,
  [4635] = 3769,
  [4636] = 4135,
  [4637] = 3728,
  [4638] = 4089,
  [4639] = 3764,
  [4640] = 3730,
  [4641] = 3724,
  [4642] = 3772,
  [4643] = 3730,
  [4644] = 3730,
  [4645] = 3779,
  [4646] = 3753,
  [4647] = 3780,
  [4648] = 3728,
  [4649] = 3728,
  [4650] = 3770,
  [4651] = 3731,
  [4652] = 3730,
  [4653] = 3782,
  [4654] = 4573,
  [4655] = 3774,
  [4656] = 3724,
  [4657] = 3755,
  [4658] = 3723,
  [4659] = 3765,
  [4660] = 3765,
  [4661] = 3815,
  [4662] = 3755,
  [4663] = 3767,
  [4664] = 4088,
  [4665] = 4356,
  [4666] = 3754,
  [4667] = 4315,
  [4668] = 3806,
  [4669] = 3770,
  [4670] = 4112,
  [4671] = 4111,
  [4672] = 3729,
  [4673] = 4135,
  [4674] = 3782,
  [4675] = 4093,
  [4676] = 3729,
  [4677] = 4321,
  [4678] = 3724,
  [4679] = 3724,
  [4680] = 3745,
  [4681] = 4097,
  [4682] = 4094,
  [4683] = 3774,
  [4684] = 3777,
  [4685] = 3781,
  [4686] = 4095,
  [4687] = 4097,
  [4688] = 3723,
  [4689] = 4085,
  [4690] = 3731,
  [4691] = 3778,
  [4692] = 3796,
  [4693] = 3767,
  [4694] = 3728,
  [4695] = 3729,
  [4696] = 4086,
  [4697] = 3796,
  [4698] = 4110,
  [4699] = 3745,
  [4700] = 3731,
  [4701] = 3744,
  [4702] = 3806,
  [4703] = 3731,
  [4704] = 3761,
  [4705] = 3728,
  [4706] = 3755,
  [4707] = 3754,
  [4708] = 4086,
  [4709] = 3783,
  [4710] = 3782,
  [4711] = 3862,
  [4712] = 3770,
  [4713] = 3754,
  [4714] = 3765,
  [4715] = 3806,
  [4716] = 3764,
  [4717] = 3757,
  [4718] = 3751,
  [4719] = 3750,
  [4720] = 4315,
  [4721] = 3749,
  [4722] = 3755,
  [4723] = 3761,
  [4724] = 3796,
  [4725] = 3730,
  [4726] = 3753,
  [4727] = 3767,
  [4728] = 3867,
  [4729] = 3796,
  [4730] = 3794,
  [4731] = 3794,
  [4732] = 3791,
  [4733] = 3745,
  [4734] = 4440,
  [4735] = 3789,
  [4736] = 4455,
  [4737] = 3775,
  [4738] = 3728,
  [4739] = 3815,
  [4740] = 3774,
  [4741] = 3782,
  [4742] = 3747,
  [4743] = 3780,
  [4744] = 3779,
  [4745] = 3772,
  [4746] = 3769,
  [4747] = 3760,
  [4748] = 3762,
  [4749] = 3750,
  [4750] = 3744,
  [4751] = 3755,
  [4752] = 3755,
  [4753] = 3753,
  [4754] = 3780,
  [4755] = 3755,
  [4756] = 3783,
  [4757] = 3791,
  [4758] = 3758,
  [4759] = 3826,
  [4760] = 3779,
  [4761] = 3746,
  [4762] = 3723,
  [4763] = 3772,
  [4764] = 3753,
  [4765] = 3747,
  [4766] = 3749,
  [4767] = 3750,
  [4768] = 3781,
  [4769] = 3751,
  [4770] = 3757,
  [4771] = 3764,
  [4772] = 3778,
  [4773] = 3765,
  [4774] = 3754,
  [4775] = 3770,
  [4776] = 3723,
  [4777] = 3758,
  [4778] = 3775,
  [4779] = 3746,
  [4780] = 3731,
  [4781] = 3723,
  [4782] = 3724,
  [4783] = 3749,
  [4784] = 3729,
  [4785] = 4435,
  [4786] = 3730,
  [4787] = 3777,
  [4788] = 3729,
  [4789] = 3753,
  [4790] = 3729,
  [4791] = 3745,
  [4792] = 3870,
  [4793] = 4078,
  [4794] = 4560,
  [4795] = 3829,
  [4796] = 3830,
  [4797] = 4081,
  [4798] = 4083,
  [4799] = 3832,
  [4800] = 3833,
  [4801] = 3835,
  [4802] = 3874,
  [4803] = 3744,
  [4804] = 3761,
  [4805] = 4085,
  [4806] = 3769,
  [4807] = 3762,
  [4808] = 4087,
  [4809] = 3760,
  [4810] = 3769,
  [4811] = 3836,
  [4812] = 3838,
  [4813] = 3772,
  [4814] = 3779,
  [4815] = 4088,
  [4816] = 3780,
  [4817] = 3782,
  [4818] = 3774,
  [4819] = 3815,
  [4820] = 3783,
  [4821] = 3839,
  [4822] = 4089,
  [4823] = 3841,
  [4824] = 3781,
  [4825] = 3861,
  [4826] = 3778,
  [4827] = 3789,
  [4828] = 4093,
  [4829] = 3791,
  [4830] = 4094,
  [4831] = 3728,
  [4832] = 3794,
  [4833] = 4095,
  [4834] = 3796,
  [4835] = 3767,
  [4836] = 4097,
  [4837] = 3842,
  [4838] = 4099,
  [4839] = 4100,
  [4840] = 3777,
  [4841] = 3806,
  [4842] = 3744,
  [4843] = 3761,
  [4844] = 3875,
  [4845] = 4110,
  [4846] = 4135,
  [4847] = 4111,
  [4848] = 3762,
  [4849] = 4112,
  [4850] = 3760,
  [4851] = 3769,
  [4852] = 3772,
  [4853] = 3779,
  [4854] = 3780,
  [4855] = 3782,
  [4856] = 3774,
  [4857] = 3815,
  [4858] = 3755,
  [4859] = 3775,
  [4860] = 3806,
  [4861] = 3783,
  [4862] = 3789,
  [4863] = 3777,
  [4864] = 4435,
  [4865] = 3781,
  [4866] = 3745,
  [4867] = 3791,
  [4868] = 3794,
  [4869] = 3746,
  [4870] = 3806,
  [4871] = 3796,
  [4872] = 3767,
  [4873] = 4315,
  [4874] = 3728,
  [4875] = 4455,
  [4876] = 4440,
  [4877] = 3767,
  [4878] = 3753,
  [4879] = 3730,
  [4880] = 3723,
  [4881] = 3806,
  [4882] = 3745,
  [4883] = 3860,
  [4884] = 3789,
  [4885] = 3746,
  [4886] = 3843,
  [4887] = 3753,
  [4888] = 3758,
  [4889] = 3770,
  [4890] = 3754,
  [4891] = 3765,
  [4892] = 3764,
  [4893] = 3757,
  [4894] = 3751,
  [4895] = 3750,
  [4896] = 3749,
  [4897] = 3747,
  [4898] = 3728,
  [4899] = 3730,
  [4900] = 3777,
  [4901] = 3781,
  [4902] = 3746,
  [4903] = 3758,
  [4904] = 3758,
  [4905] = 3770,
  [4906] = 3758,
  [4907] = 3754,
  [4908] = 3765,
  [4909] = 3764,
  [4910] = 3757,
  [4911] = 3778,
  [4912] = 3751,
  [4913] = 3750,
  [4914] = 3749,
  [4915] = 3859,
  [4916] = 3747,
  [4917] = 3769,
  [4918] = 3783,
  [4919] = 3781,
  [4920] = 3778,
  [4921] = 3774,
  [4922] = 3746,
  [4923] = 3731,
  [4924] = 3760,
  [4925] = 3724,
  [4926] = 3775,
  [4927] = 3724,
  [4928] = 3745,
  [4929] = 3751,
  [4930] = 3731,
  [4931] = 3778,
  [4932] = 3764,
  [4933] = 3724,
  [4934] = 3778,
  [4935] = 3781,
  [4936] = 3757,
  [4937] = 3731,
  [4938] = 3783,
  [4939] = 3829,
  [4940] = 3830,
  [4941] = 3832,
  [4942] = 3833,
  [4943] = 3835,
  [4944] = 3775,
  [4945] = 3744,
  [4946] = 3836,
  [4947] = 3838,
  [4948] = 4435,
  [4949] = 3826,
  [4950] = 3761,
  [4951] = 3777,
  [4952] = 3839,
  [4953] = 3841,
  [4954] = 3842,
  [4955] = 3769,
  [4956] = 3843,
  [4957] = 3844,
  [4958] = 3846,
  [4959] = 3789,
  [4960] = 3747,
  [4961] = 3791,
  [4962] = 3780,
  [4963] = 3782,
  [4964] = 3794,
  [4965] = 3796,
  [4966] = 4435,
  [4967] = 3774,
  [4968] = 3767,
  [4969] = 3783,
  [4970] = 3796,
  [4971] = 3794,
  [4972] = 3791,
  [4973] = 3849,
  [4974] = 3850,
  [4975] = 3825,
  [4976] = 3851,
  [4977] = 3781,
  [4978] = 3778,
  [4979] = 3729,
  [4980] = 3853,
  [4981] = 3856,
  [4982] = 3857,
  [4983] = 3859,
  [4984] = 3860,
  [4985] = 3783,
  [4986] = 3861,
  [4987] = 3862,
  [4988] = 3767,
  [4989] = 3851,
  [4990] = 3826,
  [4991] = 3762,
  [4992] = 3729,
  [4993] = 3781,
  [4994] = 3778,
  [4995] = 4435,
  [4996] = 3789,
  [4997] = 3760,
  [4998] = 3867,
  [4999] = 3844,
  [5000] = 3772,
  [5001] = 3779,
  [5002] = 3870,
  [5003] = 4315,
  [5004] = 3815,
  [5005] = 3760,
  [5006] = 4455,
  [5007] = 3775,
  [5008] = 4440,
  [5009] = 3777,
  [5010] = 3770,
  [5011] = 3815,
  [5012] = 3874,
  [5013] = 3754,
  [5014] = 3775,
  [5015] = 3765,
  [5016] = 3875,
  [5017] = 3723,
  [5018] = 3815,
  [5019] = 3774,
  [5020] = 3731,
  [5021] = 3764,
  [5022] = 3777,
  [5023] = 3829,
  [5024] = 3830,
  [5025] = 3782,
  [5026] = 3832,
  [5027] = 3833,
  [5028] = 3835,
  [5029] = 4356,
  [5030] = 3744,
  [5031] = 3761,
  [5032] = 3836,
  [5033] = 3757,
  [5034] = 3838,
  [5035] = 3780,
  [5036] = 3857,
  [5037] = 3751,
  [5038] = 3724,
  [5039] = 3779,
  [5040] = 3839,
  [5041] = 3856,
  [5042] = 3841,
  [5043] = 3842,
  [5044] = 3853,
  [5045] = 3772,
  [5046] = 3843,
  [5047] = 3769,
  [5048] = 3745,
  [5049] = 3730,
  [5050] = 3806,
  [5051] = 3844,
  [5052] = 3762,
  [5053] = 4573,
  [5054] = 3750,
  [5055] = 3846,
  [5056] = 3749,
  [5057] = 3761,
  [5058] = 3755,
  [5059] = 3744,
  [5060] = 3875,
  [5061] = 3874,
  [5062] = 4455,
  [5063] = 3762,
  [5064] = 3747,
  [5065] = 3769,
  [5066] = 3789,
  [5067] = 4440,
  [5068] = 3761,
  [5069] = 3825,
  [5070] = 3870,
  [5071] = 3728,
  [5072] = 3867,
  [5073] = 4356,
  [5074] = 3829,
  [5075] = 3830,
  [5076] = 3862,
  [5077] = 3861,
  [5078] = 3860,
  [5079] = 3849,
  [5080] = 3755,
  [5081] = 3850,
  [5082] = 3825,
  [5083] = 3859,
  [5084] = 3857,
  [5085] = 3856,
  [5086] = 3853,
  [5087] = 3851,
  [5088] = 3853,
  [5089] = 3856,
  [5090] = 3857,
  [5091] = 3851,
  [5092] = 3825,
  [5093] = 3859,
  [5094] = 3850,
  [5095] = 3860,
  [5096] = 3849,
  [5097] = 3729,
  [5098] = 3861,
  [5099] = 3862,
  [5100] = 3832,
  [5101] = 3833,
  [5102] = 3835,
  [5103] = 3791,
  [5104] = 3836,
  [5105] = 3780,
  [5106] = 3782,
  [5107] = 3794,
  [5108] = 3796,
  [5109] = 3744,
  [5110] = 3838,
  [5111] = 3846,
  [5112] = 3746,
  [5113] = 3806,
  [5114] = 3844,
  [5115] = 3758,
  [5116] = 3867,
  [5117] = 3723,
  [5118] = 3870,
  [5119] = 3843,
  [5120] = 3842,
  [5121] = 3770,
  [5122] = 3754,
  [5123] = 3765,
  [5124] = 3777,
  [5125] = 3764,
  [5126] = 3757,
  [5127] = 3751,
  [5128] = 3774,
  [5129] = 3750,
  [5130] = 3767,
  [5131] = 3841,
  [5132] = 3846,
  [5133] = 3749,
  [5134] = 3747,
  [5135] = 3836,
  [5136] = 3839,
  [5137] = 3755,
  [5138] = 3838,
  [5139] = 3757,
  [5140] = 3874,
  [5141] = 3746,
  [5142] = 3835,
  [5143] = 3833,
  [5144] = 3770,
  [5145] = 3832,
  [5146] = 3830,
  [5147] = 3758,
  [5148] = 3829,
  [5149] = 3770,
  [5150] = 3839,
  [5151] = 3841,
  [5152] = 3842,
  [5153] = 3746,
  [5154] = 3875,
  [5155] = 3728,
  [5156] = 3783,
  [5157] = 3843,
  [5158] = 3747,
  [5159] = 3754,
  [5160] = 3758,
  [5161] = 3765,
  [5162] = 3844,
  [5163] = 3846,
  [5164] = 3723,
  [5165] = 3775,
  [5166] = 3764,
  [5167] = 3749,
  [5168] = 3750,
  [5169] = 3765,
  [5170] = 3757,
  [5171] = 3751,
  [5172] = 3849,
  [5173] = 3815,
  [5174] = 3751,
  [5175] = 4315,
  [5176] = 4321,
  [5177] = 3724,
  [5178] = 3764,
  [5179] = 3779,
  [5180] = 3772,
  [5181] = 3806,
  [5182] = 3850,
  [5183] = 4356,
  [5184] = 3765,
  [5185] = 3825,
  [5186] = 3744,
  [5187] = 3777,
  [5188] = 4315,
  [5189] = 3761,
  [5190] = 3760,
  [5191] = 3754,
  [5192] = 3769,
  [5193] = 3851,
  [5194] = 3780,
  [5195] = 3782,
  [5196] = 3774,
  [5197] = 3853,
  [5198] = 3856,
  [5199] = 3857,
  [5200] = 3789,
  [5201] = 3775,
  [5202] = 3762,
  [5203] = 3781,
  [5204] = 3859,
  [5205] = 3860,
  [5206] = 3791,
  [5207] = 3778,
  [5208] = 3794,
  [5209] = 3796,
  [5210] = 3767,
  [5211] = 3861,
  [5212] = 3762,
  [5213] = 3862,
  [5214] = 3760,
  [5215] = 3826,
  [5216] = 3750,
  [5217] = 3772,
  [5218] = 3779,
  [5219] = 3755,
  [5220] = 4294,
  [5221] = 3850,
  [5222] = 3815,
  [5223] = 3749,
  [5224] = 3729,
  [5225] = 3826,
  [5226] = 3724,
  [5227] = 3867,
  [5228] = 3870,
  [5229] = 3754,
  [5230] = 4455,
  [5231] = 3731,
  [5232] = 3747,
  [5233] = 3744,
  [5234] = 3761,
  [5235] = 3806,
  [5236] = 3874,
  [5237] = 3755,
  [5238] = 3875,
  [5239] = 3753,
  [5240] = 4440,
  [5241] = 3728,
  [5242] = 3745,
  [5243] = 3730,
  [5244] = 3753,
  [5245] = 3745,
  [5246] = 3755,
  [5247] = 3731,
  [5248] = 3767,
  [5249] = 3815,
  [5250] = 3796,
  [5251] = 3794,
  [5252] = 3791,
  [5253] = 3779,
  [5254] = 3772,
  [5255] = 3849,
  [5256] = 3789,
  [5257] = 3760,
  [5258] = 3770,
  [5259] = 3762,
  [5260] = 3730,
  [5261] = 3755,
  [5262] = 3774,
  [5263] = 3782,
  [5264] = 3780,
  [5265] = 3835,
  [5266] = 3875,
  [5267] = 3769,
  [5268] = 3760,
  [5269] = 3753,
  [5270] = 3772,
  [5271] = 3779,
  [5272] = 3762,
  [5273] = 3761,
  [5274] = 3723,
  [5275] = 3744,
  [5276] = 4356,
  [5277] = 3780,
  [5278] = 3782,
  [5279] = 3770,
  [5280] = 3774,
  [5281] = 3874,
  [5282] = 3815,
  [5283] = 3770,
  [5284] = 3875,
  [5285] = 3754,
  [5286] = 4112,
  [5287] = 3826,
  [5288] = 4111,
  [5289] = 4135,
  [5290] = 3781,
  [5291] = 3829,
  [5292] = 3830,
  [5293] = 3754,
  [5294] = 3870,
  [5295] = 3778,
  [5296] = 3832,
  [5297] = 3833,
  [5298] = 3835,
  [5299] = 3836,
  [5300] = 3838,
  [5301] = 3765,
  [5302] = 3867,
  [5303] = 3777,
  [5304] = 4135,
  [5305] = 3765,
  [5306] = 3874,
  [5307] = 3839,
  [5308] = 3841,
  [5309] = 3842,
  [5310] = 3843,
  [5311] = 3764,
  [5312] = 3844,
  [5313] = 3731,
  [5314] = 3875,
  [5315] = 4440,
  [5316] = 3846,
  [5317] = 3764,
  [5318] = 3757,
  [5319] = 4455,
  [5320] = 3826,
  [5321] = 3757,
  [5322] = 3870,
  [5323] = 3751,
  [5324] = 3867,
  [5325] = 3789,
  [5326] = 3751,
  [5327] = 3778,
  [5328] = 3862,
  [5329] = 3849,
  [5330] = 3850,
  [5331] = 3825,
  [5332] = 3851,
  [5333] = 3853,
  [5334] = 3856,
  [5335] = 3857,
  [5336] = 3861,
  [5337] = 3860,
  [5338] = 3781,
  [5339] = 3730,
  [5340] = 3859,
  [5341] = 3728,
  [5342] = 3862,
  [5343] = 3860,
  [5344] = 4435,
  [5345] = 3861,
  [5346] = 3862,
  [5347] = 3859,
  [5348] = 3861,
  [5349] = 3750,
  [5350] = 3777,
  [5351] = 3783,
  [5352] = 3860,
  [5353] = 3783,
  [5354] = 3749,
  [5355] = 3857,
  [5356] = 3856,
  [5357] = 3853,
  [5358] = 3851,
  [5359] = 3825,
  [5360] = 3850,
  [5361] = 3849,
  [5362] = 3791,
  [5363] = 3867,
  [5364] = 3794,
  [5365] = 3796,
  [5366] = 3870,
  [5367] = 3758,
  [5368] = 3744,
  [5369] = 4078,
  [5370] = 3859,
  [5371] = 3761,
  [5372] = 3846,
  [5373] = 3724,
  [5374] = 3762,
  [5375] = 3844,
  [5376] = 3747,
  [5377] = 3843,
  [5378] = 3874,
  [5379] = 3842,
  [5380] = 3841,
  [5381] = 3839,
  [5382] = 3875,
  [5383] = 3746,
  [5384] = 3767,
  [5385] = 3750,
  [5386] = 3749,
  [5387] = 3760,
  [5388] = 3838,
  [5389] = 3836,
  [5390] = 3835,
  [5391] = 3833,
  [5392] = 3832,
  [5393] = 3769,
  [5394] = 3772,
  [5395] = 3779,
  [5396] = 3830,
  [5397] = 3829,
  [5398] = 3780,
  [5399] = 3782,
  [5400] = 3774,
  [5401] = 3815,
  [5402] = 3730,
  [5403] = 3783,
  [5404] = 4356,
  [5405] = 3829,
  [5406] = 3770,
  [5407] = 3754,
  [5408] = 3765,
  [5409] = 3744,
  [5410] = 3731,
  [5411] = 3728,
  [5412] = 3761,
  [5413] = 3762,
  [5414] = 4081,
  [5415] = 3764,
  [5416] = 3757,
  [5417] = 3751,
  [5418] = 3760,
  [5419] = 3769,
  [5420] = 4112,
  [5421] = 4111,
  [5422] = 4135,
  [5423] = 4110,
  [5424] = 3826,
  [5425] = 3856,
  [5426] = 3750,
  [5427] = 3749,
  [5428] = 3853,
  [5429] = 3772,
  [5430] = 3830,
  [5431] = 3779,
  [5432] = 3780,
  [5433] = 3782,
  [5434] = 3758,
  [5435] = 4100,
  [5436] = 4356,
  [5437] = 4099,
  [5438] = 3781,
  [5439] = 3778,
  [5440] = 4097,
  [5441] = 3724,
  [5442] = 3747,
  [5443] = 3789,
  [5444] = 3775,
  [5445] = 3851,
  [5446] = 3746,
  [5447] = 3791,
  [5448] = 3794,
  [5449] = 3796,
  [5450] = 3825,
  [5451] = 3774,
  [5452] = 3767,
  [5453] = 4078,
  [5454] = 4081,
  [5455] = 4083,
  [5456] = 4085,
  [5457] = 3753,
  [5458] = 4086,
  [5459] = 3728,
  [5460] = 3783,
  [5461] = 3850,
  [5462] = 4087,
  [5463] = 4088,
  [5464] = 3723,
  [5465] = 4089,
  [5466] = 3753,
  [5467] = 4440,
  [5468] = 3875,
  [5469] = 3874,
  [5470] = 4455,
  [5471] = 4093,
  [5472] = 4094,
  [5473] = 4095,
  [5474] = 3815,
  [5475] = 4095,
  [5476] = 4094,
  [5477] = 4435,
  [5478] = 3729,
  [5479] = 3849,
  [5480] = 3832,
  [5481] = 4093,
  [5482] = 3833,
  [5483] = 4097,
  [5484] = 3724,
  [5485] = 4099,
  [5486] = 4100,
  [5487] = 3870,
  [5488] = 3867,
  [5489] = 4435,
  [5490] = 3836,
  [5491] = 3838,
  [5492] = 4085,
  [5493] = 3862,
  [5494] = 3861,
  [5495] = 3860,
  [5496] = 3729,
  [5497] = 4100,
  [5498] = 3747,
  [5499] = 3758,
  [5500] = 4099,
  [5501] = 3806,
  [5502] = 4086,
  [5503] = 4089,
  [5504] = 4088,
  [5505] = 3859,
  [5506] = 4110,
  [5507] = 3781,
  [5508] = 4087,
  [5509] = 3731,
  [5510] = 3839,
  [5511] = 3778,
  [5512] = 3841,
  [5513] = 3746,
  [5514] = 3857,
  [5515] = 4111,
  [5516] = 3729,
  [5517] = 4112,
  [5518] = 3856,
  [5519] = 4086,
  [5520] = 4085,
  [5521] = 4087,
  [5522] = 3755,
  [5523] = 4083,
  [5524] = 4081,
  [5525] = 3781,
  [5526] = 4112,
  [5527] = 4111,
  [5528] = 4078,
  [5529] = 3755,
  [5530] = 3853,
  [5531] = 3851,
  [5532] = 3825,
  [5533] = 3746,
  [5534] = 3850,
  [5535] = 3849,
  [5536] = 4455,
  [5537] = 3758,
  [5538] = 4440,
  [5539] = 4110,
  [5540] = 3789,
  [5541] = 3842,
  [5542] = 3843,
  [5543] = 4088,
  [5544] = 3846,
  [5545] = 4560,
  [5546] = 3791,
  [5547] = 3794,
  [5548] = 4089,
  [5549] = 3796,
  [5550] = 3844,
  [5551] = 3775,
  [5552] = 3844,
  [5553] = 3843,
  [5554] = 3767,
  [5555] = 3806,
  [5556] = 3842,
  [5557] = 3815,
  [5558] = 3841,
  [5559] = 3839,
  [5560] = 3846,
  [5561] = 3777,
  [5562] = 3846,
  [5563] = 3838,
  [5564] = 3745,
  [5565] = 4093,
  [5566] = 3835,
  [5567] = 3779,
  [5568] = 4100,
  [5569] = 4099,
  [5570] = 3772,
  [5571] = 3833,
  [5572] = 3832,
  [5573] = 3778,
  [5574] = 4097,
  [5575] = 3844,
  [5576] = 3843,
  [5577] = 4094,
  [5578] = 4095,
  [5579] = 3777,
  [5580] = 3830,
  [5581] = 3829,
  [5582] = 3842,
  [5583] = 3760,
  [5584] = 3841,
  [5585] = 3778,
  [5586] = 4083,
  [5587] = 4095,
  [5588] = 4094,
  [5589] = 4093,
  [5590] = 3753,
  [5591] = 3758,
  [5592] = 4560,
  [5593] = 3781,
  [5594] = 3755,
  [5595] = 4560,
  [5596] = 4089,
  [5597] = 4088,
  [5598] = 3857,
  [5599] = 4087,
  [5600] = 3745,
  [5601] = 3806,
  [5602] = 4086,
  [5603] = 4085,
  [5604] = 4112,
  [5605] = 4111,
  [5606] = 4083,
  [5607] = 4081,
  [5608] = 4078,
  [5609] = 3762,
  [5610] = 4135,
  [5611] = 4435,
  [5612] = 4110,
  [5613] = 3745,
  [5614] = 3806,
  [5615] = 3753,
  [5616] = 3836,
  [5617] = 3747,
  [5618] = 3749,
  [5619] = 3750,
  [5620] = 3751,
  [5621] = 3826,
  [5622] = 4356,
  [5623] = 3775,
  [5624] = 3757,
  [5625] = 4100,
  [5626] = 4099,
  [5627] = 3775,
  [5628] = 3764,
  [5629] = 4097,
  [5630] = 3765,
  [5631] = 3754,
  [5632] = 3770,
  [5633] = 3838,
  [5634] = 4455,
  [5635] = 4440,
  [5636] = 3746,
  [5637] = 3767,
  [5638] = 3826,
  [5639] = 3774,
  [5640] = 3836,
  [5641] = 3796,
  [5642] = 3794,
  [5643] = 4135,
  [5644] = 3783,
  [5645] = 4095,
  [5646] = 3782,
  [5647] = 3780,
  [5648] = 3791,
  [5649] = 4097,
  [5650] = 3835,
  [5651] = 4094,
  [5652] = 4093,
  [5653] = 3783,
  [5654] = 3833,
  [5655] = 4356,
  [5656] = 3789,
  [5657] = 3769,
  [5658] = 3829,
  [5659] = 4089,
  [5660] = 3830,
  [5661] = 4088,
  [5662] = 4087,
  [5663] = 3832,
  [5664] = 3833,
  [5665] = 3835,
  [5666] = 4086,
  [5667] = 3836,
  [5668] = 3832,
  [5669] = 4085,
  [5670] = 3838,
  [5671] = 3761,
  [5672] = 3744,
  [5673] = 3777,
  [5674] = 3849,
  [5675] = 4083,
  [5676] = 4081,
  [5677] = 4078,
  [5678] = 3839,
  [5679] = 3841,
  [5680] = 3842,
  [5681] = 3826,
  [5682] = 3755,
  [5683] = 3843,
  [5684] = 3850,
  [5685] = 3755,
  [5686] = 3844,
  [5687] = 3775,
  [5688] = 3744,
  [5689] = 3761,
  [5690] = 3762,
  [5691] = 3846,
  [5692] = 3825,
  [5693] = 3775,
  [5694] = 3851,
  [5695] = 3753,
  [5696] = 3853,
  [5697] = 3856,
  [5698] = 3857,
  [5699] = 3829,
  [5700] = 3830,
  [5701] = 3859,
  [5702] = 3849,
  [5703] = 3850,
  [5704] = 3832,
  [5705] = 3833,
  [5706] = 3835,
  [5707] = 3836,
  [5708] = 3838,
  [5709] = 3825,
  [5710] = 3851,
  [5711] = 3853,
  [5712] = 3856,
  [5713] = 3760,
  [5714] = 3769,
  [5715] = 3857,
  [5716] = 3839,
  [5717] = 3729,
  [5718] = 3841,
  [5719] = 3842,
  [5720] = 3843,
  [5721] = 3747,
  [5722] = 3844,
  [5723] = 3860,
  [5724] = 3846,
  [5725] = 3861,
  [5726] = 3830,
  [5727] = 3772,
  [5728] = 3859,
  [5729] = 3779,
  [5730] = 3780,
  [5731] = 3782,
  [5732] = 3829,
  [5733] = 3774,
  [5734] = 3815,
  [5735] = 3849,
  [5736] = 3850,
  [5737] = 3825,
  [5738] = 3851,
  [5739] = 3853,
  [5740] = 3856,
  [5741] = 3857,
  [5742] = 3749,
  [5743] = 3815,
  [5744] = 3750,
  [5745] = 3859,
  [5746] = 3860,
  [5747] = 3860,
  [5748] = 3861,
  [5749] = 3862,
  [5750] = 3779,
  [5751] = 3862,
  [5752] = 3861,
  [5753] = 3806,
  [5754] = 3744,
  [5755] = 3761,
  [5756] = 3772,
  [5757] = 3760,
  [5758] = 3862,
  [5759] = 3762,
  [5760] = 3839,
  [5761] = 3867,
  [5762] = 3762,
  [5763] = 3867,
  [5764] = 3751,
  [5765] = 3753,
  [5766] = 3870,
  [5767] = 3728,
  [5768] = 3777,
  [5769] = 3757,
  [5770] = 3764,
  [5771] = 3870,
  [5772] = 4560,
  [5773] = 3730,
  [5774] = 3724,
  [5775] = 3760,
  [5776] = 3777,
  [5777] = 3769,
  [5778] = 3789,
  [5779] = 3874,
  [5780] = 4455,
  [5781] = 3731,
  [5782] = 3765,
  [5783] = 3754,
  [5784] = 3867,
  [5785] = 4440,
  [5786] = 3767,
  [5787] = 3774,
  [5788] = 3875,
  [5789] = 3796,
  [5790] = 3794,
  [5791] = 3782,
  [5792] = 3780,
  [5793] = 3791,
  [5794] = 4455,
  [5795] = 4560,
  [5796] = 3778,
  [5797] = 3770,
  [5798] = 3789,
  [5799] = 3769,
  [5800] = 3772,
  [5801] = 3779,
  [5802] = 3781,
  [5803] = 3791,
  [5804] = 3874,
  [5805] = 3780,
  [5806] = 3761,
  [5807] = 3744,
  [5808] = 3782,
  [5809] = 3794,
  [5810] = 3796,
  [5811] = 3874,
  [5812] = 3774,
  [5813] = 3815,
  [5814] = 3870,
  [5815] = 3806,
  [5816] = 3747,
  [5817] = 3783,
  [5818] = 3755,
  [5819] = 3746,
  [5820] = 3806,
  [5821] = 3755,
  [5822] = 3749,
  [5823] = 3750,
  [5824] = 3875,
  [5825] = 3723,
  [5826] = 3751,
  [5827] = 3767,
  [5828] = 3861,
  [5829] = 3874,
  [5830] = 3757,
  [5831] = 3875,
  [5832] = 4435,
  [5833] = 3758,
  [5834] = 3789,
  [5835] = 3764,
  [5836] = 3829,
  [5837] = 3830,
  [5838] = 3765,
  [5839] = 3791,
  [5840] = 3754,
  [5841] = 4440,
  [5842] = 3794,
  [5843] = 3796,
  [5844] = 3770,
  [5845] = 3832,
  [5846] = 3758,
  [5847] = 3767,
  [5848] = 3870,
  [5849] = 3867,
  [5850] = 3746,
  [5851] = 3833,
  [5852] = 3835,
  [5853] = 3836,
  [5854] = 3826,
  [5855] = 3862,
  [5856] = 3860,
  [5857] = 3838,
  [5858] = 3775,
  [5859] = 3859,
  [5860] = 3857,
  [5861] = 3856,
  [5862] = 3853,
  [5863] = 3770,
  [5864] = 3851,
  [5865] = 3825,
  [5866] = 3850,
  [5867] = 4110,
  [5868] = 4435,
  [5869] = 3849,
  [5870] = 3723,
  [5871] = 3754,
  [5872] = 3846,
  [5873] = 3765,
  [5874] = 3826,
  [5875] = 3844,
  [5876] = 3747,
  [5877] = 3843,
  [5878] = 3730,
  [5879] = 3749,
  [5880] = 3750,
  [5881] = 3842,
  [5882] = 3841,
  [5883] = 3751,
  [5884] = 3839,
  [5885] = 3764,
  [5886] = 3757,
  [5887] = 4085,
  [5888] = 4112,
  [5889] = 4094,
  [5890] = 3829,
  [5891] = 4560,
  [5892] = 4097,
  [5893] = 4099,
  [5894] = 4100,
  [5895] = 4135,
  [5896] = 3830,
  [5897] = 4110,
  [5898] = 4093,
  [5899] = 3757,
  [5900] = 4135,
  [5901] = 4111,
  [5902] = 4112,
  [5903] = 3758,
  [5904] = 4089,
  [5905] = 4088,
  [5906] = 4087,
  [5907] = 3744,
  [5908] = 3761,
  [5909] = 4086,
  [5910] = 4085,
  [5911] = 4083,
  [5912] = 4081,
  [5913] = 4078,
  [5914] = 3826,
  [5915] = 4560,
  [5916] = 3843,
  [5917] = 3755,
  [5918] = 4294,
  [5919] = 3870,
  [5920] = 3769,
  [5921] = 3723,
  [5922] = 3723,
  [5923] = 3862,
  [5924] = 3789,
  [5925] = 3791,
  [5926] = 3780,
  [5927] = 3861,
  [5928] = 3782,
  [5929] = 3860,
  [5930] = 3794,
  [5931] = 4294,
  [5932] = 3859,
  [5933] = 3796,
  [5934] = 3774,
  [5935] = 3767,
  [5936] = 3842,
  [5937] = 3723,
  [5938] = 3730,
  [5939] = 3841,
  [5940] = 4321,
  [5941] = 3783,
  [5942] = 3839,
  [5943] = 3856,
  [5944] = 3844,
  [5945] = 3781,
  [5946] = 3778,
  [5947] = 3764,
  [5948] = 3724,
  [5949] = 3762,
  [5950] = 3826,
  [5951] = 3806,
  [5952] = 3853,
  [5953] = 3758,
  [5954] = 3728,
  [5955] = 3760,
  [5956] = 3851,
  [5957] = 3867,
  [5958] = 3772,
  [5959] = 3746,
  [5960] = 3779,
  [5961] = 3815,
  [5962] = 3829,
  [5963] = 3825,
  [5964] = 3850,
  [5965] = 3731,
  [5966] = 3777,
  [5967] = 3849,
  [5968] = 4083,
  [5969] = 3778,
  [5970] = 4111,
  [5971] = 3730,
  [5972] = 4078,
  [5973] = 4081,
  [5974] = 4112,
  [5975] = 4111,
  [5976] = 4083,
  [5977] = 3724,
  [5978] = 3830,
  [5979] = 4112,
  [5980] = 4081,
  [5981] = 4085,
  [5982] = 4110,
  [5983] = 4086,
  [5984] = 3832,
  [5985] = 4110,
  [5986] = 3781,
  [5987] = 4100,
  [5988] = 4087,
  [5989] = 4099,
  [5990] = 3728,
  [5991] = 4097,
  [5992] = 3833,
  [5993] = 3835,
  [5994] = 4095,
  [5995] = 3730,
  [5996] = 4094,
  [5997] = 4093,
  [5998] = 4089,
  [5999] = 3728,
  [6000] = 4088,
  [6001] = 4110,
  [6002] = 4087,
  [6003] = 4086,
  [6004] = 4085,
  [6005] = 4083,
  [6006] = 4081,
  [6007] = 4078,
  [6008] = 3836,
  [6009] = 3806,
  [6010] = 4321,
  [6011] = 3846,
  [6012] = 3826,
  [6013] = 4100,
  [6014] = 4099,
  [6015] = 3838,
  [6016] = 3724,
  [6017] = 4097,
  [6018] = 3770,
  [6019] = 3753,
  [6020] = 4088,
  [6021] = 3731,
  [6022] = 4135,
  [6023] = 3839,
  [6024] = 3777,
  [6025] = 3755,
  [6026] = 3754,
  [6027] = 4089,
  [6028] = 3765,
  [6029] = 3723,
  [6030] = 4095,
  [6031] = 4094,
  [6032] = 4093,
  [6033] = 3841,
  [6034] = 3764,
  [6035] = 3842,
  [6036] = 3757,
  [6037] = 3843,
  [6038] = 3844,
  [6039] = 4089,
  [6040] = 4088,
  [6041] = 4087,
  [6042] = 3751,
  [6043] = 3846,
  [6044] = 4086,
  [6045] = 4085,
  [6046] = 4083,
  [6047] = 4081,
  [6048] = 4078,
  [6049] = 3775,
  [6050] = 3750,
  [6051] = 3749,
  [6052] = 3751,
  [6053] = 3730,
  [6054] = 3777,
  [6055] = 3747,
  [6056] = 3849,
  [6057] = 3857,
  [6058] = 3850,
  [6059] = 3875,
  [6060] = 3825,
  [6061] = 3747,
  [6062] = 3728,
  [6063] = 3851,
  [6064] = 3853,
  [6065] = 4093,
  [6066] = 4094,
  [6067] = 3806,
  [6068] = 3730,
  [6069] = 3856,
  [6070] = 3857,
  [6071] = 3874,
  [6072] = 3728,
  [6073] = 4095,
  [6074] = 3859,
  [6075] = 3860,
  [6076] = 3861,
  [6077] = 4560,
  [6078] = 3862,
  [6079] = 3729,
  [6080] = 4135,
  [6081] = 3770,
  [6082] = 3867,
  [6083] = 3728,
  [6084] = 3754,
  [6085] = 3765,
  [6086] = 3870,
  [6087] = 3767,
  [6088] = 3730,
  [6089] = 3874,
  [6090] = 3875,
  [6091] = 4078,
  [6092] = 3870,
  [6093] = 4111,
  [6094] = 3775,
  [6095] = 4094,
  [6096] = 3815,
  [6097] = 3867,
  [6098] = 4086,
  [6099] = 4087,
  [6100] = 4088,
  [6101] = 3729,
  [6102] = 3774,
  [6103] = 3747,
  [6104] = 4089,
  [6105] = 4097,
  [6106] = 4560,
  [6107] = 4100,
  [6108] = 4093,
  [6109] = 3764,
  [6110] = 3757,
  [6111] = 3751,
  [6112] = 4099,
  [6113] = 3862,
  [6114] = 3861,
  [6115] = 4099,
  [6116] = 4094,
  [6117] = 3860,
  [6118] = 4100,
  [6119] = 3796,
  [6120] = 3794,
  [6121] = 3859,
  [6122] = 3750,
  [6123] = 3749,
  [6124] = 4095,
  [6125] = 3782,
  [6126] = 3767,
  [6127] = 3857,
  [6128] = 3856,
  [6129] = 3853,
  [6130] = 4097,
  [6131] = 3851,
  [6132] = 3825,
  [6133] = 3850,
  [6134] = 3723,
  [6135] = 3849,
  [6136] = 3747,
  [6137] = 3796,
  [6138] = 3794,
  [6139] = 3780,
  [6140] = 3791,
  [6141] = 3791,
  [6142] = 4097,
  [6143] = 3723,
  [6144] = 4099,
  [6145] = 4100,
  [6146] = 3783,
  [6147] = 3781,
  [6148] = 3778,
  [6149] = 3744,
  [6150] = 3846,
  [6151] = 3789,
  [6152] = 3761,
  [6153] = 3844,
  [6154] = 3765,
  [6155] = 3779,
  [6156] = 3843,
  [6157] = 3842,
  [6158] = 3841,
  [6159] = 3839,
  [6160] = 3754,
  [6161] = 4110,
  [6162] = 3762,
  [6163] = 3772,
  [6164] = 3777,
  [6165] = 3749,
  [6166] = 3750,
  [6167] = 4560,
  [6168] = 3838,
  [6169] = 3838,
  [6170] = 3836,
  [6171] = 3835,
  [6172] = 3833,
  [6173] = 3832,
  [6174] = 4095,
  [6175] = 4094,
  [6176] = 4093,
  [6177] = 3830,
  [6178] = 3829,
  [6179] = 4111,
  [6180] = 3789,
  [6181] = 4112,
  [6182] = 3760,
  [6183] = 3769,
  [6184] = 3789,
  [6185] = 3755,
  [6186] = 4089,
  [6187] = 3772,
  [6188] = 3779,
  [6189] = 3775,
  [6190] = 3746,
  [6191] = 4088,
  [6192] = 3791,
  [6193] = 3815,
  [6194] = 3780,
  [6195] = 3774,
  [6196] = 3782,
  [6197] = 3794,
  [6198] = 3782,
  [6199] = 3780,
  [6200] = 3796,
  [6201] = 3779,
  [6202] = 3772,
  [6203] = 3753,
  [6204] = 3774,
  [6205] = 3769,
  [6206] = 3769,
  [6207] = 3760,
  [6208] = 3815,
  [6209] = 3767,
  [6210] = 3874,
  [6211] = 4087,
  [6212] = 3745,
  [6213] = 3755,
  [6214] = 3806,
  [6215] = 4135,
  [6216] = 3762,
  [6217] = 3835,
  [6218] = 3746,
  [6219] = 3761,
  [6220] = 3875,
  [6221] = 3744,
  [6222] = 3758,
  [6223] = 4078,
  [6224] = 4081,
  [6225] = 3758,
  [6226] = 4086,
  [6227] = 4083,
  [6228] = 4085,
  [6229] = 4086,
  [6230] = 4087,
  [6231] = 4085,
  [6232] = 4088,
  [6233] = 4089,
  [6234] = 4093,
  [6235] = 3760,
  [6236] = 4095,
  [6237] = 4095,
  [6238] = 4097,
  [6239] = 3833,
  [6240] = 3750,
  [6241] = 4099,
  [6242] = 4100,
  [6243] = 4110,
  [6244] = 4083,
  [6245] = 3729,
  [6246] = 4081,
  [6247] = 4078,
  [6248] = 3751,
  [6249] = 3778,
  [6250] = 4135,
  [6251] = 4112,
  [6252] = 3746,
  [6253] = 4111,
  [6254] = 3836,
  [6255] = 4110,
  [6256] = 3731,
  [6257] = 4110,
  [6258] = 3731,
  [6259] = 4111,
  [6260] = 4112,
  [6261] = 3832,
  [6262] = 4560,
  [6263] = 4111,
  [6264] = 4112,
  [6265] = 3749,
  [6266] = 3724,
  [6267] = 3781,
  [6268] = 3757,
  [6269] = 4100,
  [6270] = 3764,
  [6271] = 4099,
  [6272] = 3731,
  [6273] = 4097,
  [6274] = 3729,
  [6275] = 3761,
  [6276] = 4095,
  [6277] = 3744,
  [6278] = 4094,
  [6279] = 3765,
  [6280] = 3724,
  [6281] = 4093,
  [6282] = 4089,
  [6283] = 3731,
  [6284] = 3775,
  [6285] = 4088,
  [6286] = 3770,
  [6287] = 3754,
  [6288] = 4087,
  [6289] = 4086,
  [6290] = 3729,
  [6291] = 4085,
  [6292] = 4083,
  [6293] = 4135,
  [6294] = 4081,
  [6295] = 4078,
  [6296] = 3724,
  [6297] = 3762,
  [6298] = 3783,
  [6299] = 3770,
  [6300] = 3783,
  [6301] = 4135,
  [6302] = 3729,
  [6303] = 4089,
  [6304] = 3731,
  [6305] = 3794,
  [6306] = 3796,
  [6307] = 3747,
  [6308] = 3772,
  [6309] = 3796,
  [6310] = 3774,
  [6311] = 3794,
  [6312] = 3815,
  [6313] = 3782,
  [6314] = 3780,
  [6315] = 3779,
  [6316] = 3791,
  [6317] = 3861,
  [6318] = 3860,
  [6319] = 3779,
  [6320] = 3772,
  [6321] = 3750,
  [6322] = 3780,
  [6323] = 3728,
  [6324] = 3791,
  [6325] = 3789,
  [6326] = 3769,
  [6327] = 3760,
  [6328] = 3782,
  [6329] = 3791,
  [6330] = 3859,
  [6331] = 3774,
  [6332] = 3815,
  [6333] = 3789,
  [6334] = 3762,
  [6335] = 3767,
  [6336] = 3761,
  [6337] = 3769,
  [6338] = 3744,
  [6339] = 3760,
  [6340] = 3857,
  [6341] = 4100,
  [6342] = 3731,
  [6343] = 3789,
  [6344] = 3815,
  [6345] = 3746,
  [6346] = 3856,
  [6347] = 3774,
  [6348] = 3794,
  [6349] = 3796,
  [6350] = 3777,
  [6351] = 3730,
  [6352] = 3782,
  [6353] = 3780,
  [6354] = 3767,
  [6355] = 3751,
  [6356] = 3779,
  [6357] = 3772,
  [6358] = 3778,
  [6359] = 3853,
  [6360] = 3769,
  [6361] = 3760,
  [6362] = 3781,
  [6363] = 3757,
  [6364] = 3851,
  [6365] = 3724,
  [6366] = 3755,
  [6367] = 3825,
  [6368] = 3777,
  [6369] = 3762,
  [6370] = 4294,
  [6371] = 3761,
  [6372] = 3744,
  [6373] = 3850,
  [6374] = 3764,
  [6375] = 3762,
  [6376] = 3761,
  [6377] = 3744,
  [6378] = 3849,
  [6379] = 3744,
  [6380] = 3761,
  [6381] = 3729,
  [6382] = 4088,
  [6383] = 3806,
  [6384] = 3765,
  [6385] = 3762,
  [6386] = 3806,
  [6387] = 3775,
  [6388] = 3729,
  [6389] = 3760,
  [6390] = 3754,
  [6391] = 3783,
  [6392] = 3769,
  [6393] = 3770,
  [6394] = 3767,
  [6395] = 3815,
  [6396] = 3806,
  [6397] = 3767,
  [6398] = 4099,
  [6399] = 4294,
  [6400] = 3774,
  [6401] = 3755,
  [6402] = 3729,
  [6403] = 3772,
  [6404] = 3747,
  [6405] = 3779,
  [6406] = 3780,
  [6407] = 4078,
  [6408] = 4081,
  [6409] = 4083,
  [6410] = 3782,
  [6411] = 4085,
  [6412] = 4086,
  [6413] = 3729,
  [6414] = 4087,
  [6415] = 3774,
  [6416] = 3815,
  [6417] = 4088,
  [6418] = 4089,
  [6419] = 4093,
  [6420] = 4094,
  [6421] = 4095,
  [6422] = 4089,
  [6423] = 3724,
  [6424] = 3724,
  [6425] = 3789,
  [6426] = 3731,
  [6427] = 3791,
  [6428] = 3796,
  [6429] = 3794,
  [6430] = 3731,
  [6431] = 3846,
  [6432] = 3796,
  [6433] = 3767,
  [6434] = 3862,
  [6435] = 4097,
  [6436] = 4099,
  [6437] = 4100,
  [6438] = 3724,
  [6439] = 3731,
  [6440] = 3794,
  [6441] = 3844,
  [6442] = 3843,
  [6443] = 4321,
  [6444] = 3842,
  [6445] = 3841,
  [6446] = 3839,
  [6447] = 3731,
  [6448] = 3826,
  [6449] = 4110,
  [6450] = 3782,
  [6451] = 3780,
  [6452] = 3791,
  [6453] = 3838,
  [6454] = 4111,
  [6455] = 4112,
  [6456] = 3779,
  [6457] = 3772,
  [6458] = 3749,
  [6459] = 3836,
  [6460] = 3723,
  [6461] = 3835,
  [6462] = 3833,
  [6463] = 3832,
  [6464] = 3750,
  [6465] = 3830,
  [6466] = 3829,
  [6467] = 3731,
  [6468] = 3875,
  [6469] = 3867,
  [6470] = 3724,
  [6471] = 3870,
  [6472] = 3723,
  [6473] = 3874,
  [6474] = 3724,
  [6475] = 3723,
  [6476] = 3723,
  [6477] = 4321,
  [6478] = 3730,
  [6479] = 3789,
  [6480] = 3728,
  [6481] = 3758,
  [6482] = 4093,
  [6483] = 3764,
  [6484] = 3729,
  [6485] = 6485,
  [6486] = 3770,
  [6487] = 3754,
  [6488] = 3765,
  [6489] = 3764,
  [6490] = 3730,
  [6491] = 3757,
  [6492] = 3728,
  [6493] = 3751,
  [6494] = 3750,
  [6495] = 3749,
  [6496] = 3747,
  [6497] = 3783,
  [6498] = 3728,
  [6499] = 3730,
  [6500] = 3781,
  [6501] = 3778,
  [6502] = 3806,
  [6503] = 4094,
  [6504] = 3777,
  [6505] = 3758,
  [6506] = 4112,
  [6507] = 4111,
  [6508] = 3728,
  [6509] = 3775,
  [6510] = 4087,
  [6511] = 3729,
  [6512] = 4110,
  [6513] = 3746,
  [6514] = 3758,
  [6515] = 3731,
  [6516] = 3730,
  [6517] = 3746,
  [6518] = 3723,
  [6519] = 3724,
  [6520] = 3723,
  [6521] = 4095,
  [6522] = 4100,
  [6523] = 4099,
  [6524] = 4097,
  [6525] = 3746,
  [6526] = 3730,
  [6527] = 3728,
  [6528] = 3758,
  [6529] = 3744,
  [6530] = 3761,
  [6531] = 3769,
  [6532] = 3746,
  [6533] = 3760,
  [6534] = 3762,
  [6535] = 3728,
  [6536] = 3758,
  [6537] = 3751,
  [6538] = 3778,
  [6539] = 3757,
  [6540] = 4086,
  [6541] = 4095,
  [6542] = 3760,
  [6543] = 4094,
  [6544] = 3764,
  [6545] = 3762,
  [6546] = 3761,
  [6547] = 3744,
  [6548] = 3781,
  [6549] = 3770,
  [6550] = 3754,
  [6551] = 4093,
  [6552] = 3806,
  [6553] = 3769,
  [6554] = 3765,
  [6555] = 3789,
  [6556] = 3764,
  [6557] = 3757,
  [6558] = 3755,
  [6559] = 3806,
  [6560] = 3751,
  [6561] = 3765,
  [6562] = 3775,
  [6563] = 3754,
  [6564] = 3783,
  [6565] = 4135,
  [6566] = 3794,
  [6567] = 4097,
  [6568] = 6568,
  [6569] = 3750,
  [6570] = 3772,
  [6571] = 3749,
  [6572] = 3723,
  [6573] = 3770,
  [6574] = 3779,
  [6575] = 3791,
  [6576] = 3780,
  [6577] = 3755,
  [6578] = 3782,
  [6579] = 3747,
  [6580] = 3747,
  [6581] = 4321,
  [6582] = 4110,
  [6583] = 3770,
  [6584] = 3796,
  [6585] = 3774,
  [6586] = 3815,
  [6587] = 3754,
  [6588] = 3767,
  [6589] = 3765,
  [6590] = 3723,
  [6591] = 4321,
  [6592] = 3749,
  [6593] = 4294,
  [6594] = 3755,
  [6595] = 3730,
  [6596] = 4085,
  [6597] = 4294,
  [6598] = 3724,
  [6599] = 3755,
  [6600] = 4321,
  [6601] = 3729,
  [6602] = 3728,
  [6603] = 3775,
  [6604] = 3757,
  [6605] = 4083,
  [6606] = 4081,
  [6607] = 4088,
  [6608] = 3730,
  [6609] = 3751,
  [6610] = 4078,
  [6611] = 3729,
  [6612] = 3770,
  [6613] = 3750,
  [6614] = 3749,
  [6615] = 3783,
  [6616] = 3730,
  [6617] = 3723,
  [6618] = 4086,
  [6619] = 4085,
  [6620] = 3747,
  [6621] = 4083,
  [6622] = 4081,
  [6623] = 4111,
  [6624] = 4078,
  [6625] = 3729,
  [6626] = 4135,
  [6627] = 3724,
  [6628] = 3746,
  [6629] = 3754,
  [6630] = 4294,
  [6631] = 3765,
  [6632] = 3764,
  [6633] = 3777,
  [6634] = 3757,
  [6635] = 3781,
  [6636] = 3775,
  [6637] = 3758,
  [6638] = 3728,
  [6639] = 4321,
  [6640] = 3778,
  [6641] = 3751,
  [6642] = 3750,
  [6643] = 3749,
  [6644] = 4135,
  [6645] = 3783,
  [6646] = 3777,
  [6647] = 3775,
  [6648] = 3778,
  [6649] = 3781,
  [6650] = 3781,
  [6651] = 4112,
  [6652] = 4294,
  [6653] = 3778,
  [6654] = 3731,
  [6655] = 4087,
  [6656] = 3783,
  [6657] = 3777,
  [6658] = 3815,
  [6659] = 3750,
  [6660] = 3729,
  [6661] = 3775,
  [6662] = 3775,
  [6663] = 3757,
  [6664] = 3754,
  [6665] = 3781,
  [6666] = 4321,
  [6667] = 3777,
  [6668] = 3783,
  [6669] = 3770,
  [6670] = 3762,
  [6671] = 3778,
  [6672] = 3751,
  [6673] = 6673,
  [6674] = 3781,
  [6675] = 3777,
  [6676] = 3749,
  [6677] = 3761,
  [6678] = 3806,
  [6679] = 3744,
  [6680] = 3747,
  [6681] = 4294,
  [6682] = 4110,
  [6683] = 3729,
  [6684] = 3806,
  [6685] = 3723,
  [6686] = 3724,
  [6687] = 3777,
  [6688] = 3778,
  [6689] = 3746,
  [6690] = 4294,
  [6691] = 3781,
  [6692] = 4294,
  [6693] = 3783,
  [6694] = 3806,
  [6695] = 3770,
  [6696] = 3731,
  [6697] = 3783,
  [6698] = 3754,
  [6699] = 3765,
  [6700] = 3760,
  [6701] = 3758,
  [6702] = 3757,
  [6703] = 3746,
  [6704] = 3761,
  [6705] = 3744,
  [6706] = 3751,
  [6707] = 3777,
  [6708] = 3750,
  [6709] = 3778,
  [6710] = 3781,
  [6711] = 3749,
  [6712] = 3806,
  [6713] = 3783,
  [6714] = 3794,
  [6715] = 3758,
  [6716] = 3769,
  [6717] = 3747,
  [6718] = 3764,
  [6719] = 3775,
  [6720] = 3723,
  [6721] = 3747,
  [6722] = 3749,
  [6723] = 3750,
  [6724] = 3760,
  [6725] = 3769,
  [6726] = 3751,
  [6727] = 4294,
  [6728] = 3779,
  [6729] = 3778,
  [6730] = 3772,
  [6731] = 3747,
  [6732] = 3749,
  [6733] = 3781,
  [6734] = 3757,
  [6735] = 3750,
  [6736] = 3751,
  [6737] = 3764,
  [6738] = 3779,
  [6739] = 3765,
  [6740] = 3754,
  [6741] = 3746,
  [6742] = 3757,
  [6743] = 3783,
  [6744] = 3770,
  [6745] = 3723,
  [6746] = 3728,
  [6747] = 3780,
  [6748] = 3778,
  [6749] = 3764,
  [6750] = 3767,
  [6751] = 3815,
  [6752] = 3774,
  [6753] = 4321,
  [6754] = 3796,
  [6755] = 3794,
  [6756] = 3782,
  [6757] = 3765,
  [6758] = 3780,
  [6759] = 3791,
  [6760] = 3779,
  [6761] = 3772,
  [6762] = 3730,
  [6763] = 3777,
  [6764] = 3754,
  [6765] = 3789,
  [6766] = 3782,
  [6767] = 3769,
  [6768] = 3760,
  [6769] = 3770,
  [6770] = 3762,
  [6771] = 3755,
  [6772] = 3758,
  [6773] = 3761,
  [6774] = 3744,
  [6775] = 3774,
  [6776] = 3789,
  [6777] = 3755,
  [6778] = 3767,
  [6779] = 3728,
  [6780] = 3747,
  [6781] = 3815,
  [6782] = 3728,
  [6783] = 3775,
  [6784] = 3749,
  [6785] = 3750,
  [6786] = 3730,
  [6787] = 3796,
  [6788] = 3755,
  [6789] = 3794,
  [6790] = 3791,
  [6791] = 3769,
  [6792] = 3755,
  [6793] = 3751,
  [6794] = 3758,
  [6795] = 3783,
  [6796] = 3755,
  [6797] = 3806,
  [6798] = 3755,
  [6799] = 3806,
  [6800] = 3755,
  [6801] = 3757,
  [6802] = 4294,
  [6803] = 3764,
  [6804] = 3789,
  [6805] = 3746,
  [6806] = 3765,
  [6807] = 3730,
  [6808] = 4321,
  [6809] = 3754,
  [6810] = 3767,
  [6811] = 3747,
  [6812] = 3775,
  [6813] = 3723,
  [6814] = 3796,
  [6815] = 3746,
  [6816] = 3767,
  [6817] = 3781,
  [6818] = 3815,
  [6819] = 3794,
  [6820] = 3774,
  [6821] = 3778,
  [6822] = 3796,
  [6823] = 3758,
  [6824] = 3794,
  [6825] = 3782,
  [6826] = 3791,
  [6827] = 3780,
  [6828] = 3749,
  [6829] = 3750,
  [6830] = 3791,
  [6831] = 3779,
  [6832] = 3772,
  [6833] = 3775,
  [6834] = 3789,
  [6835] = 3772,
  [6836] = 3769,
  [6837] = 3723,
  [6838] = 3760,
  [6839] = 3770,
  [6840] = 3783,
  [6841] = 3789,
  [6842] = 3758,
  [6843] = 3762,
  [6844] = 3762,
  [6845] = 3765,
  [6846] = 3755,
  [6847] = 3778,
  [6848] = 3761,
  [6849] = 3731,
  [6850] = 3744,
  [6851] = 3774,
  [6852] = 3789,
  [6853] = 3724,
  [6854] = 3782,
  [6855] = 3780,
  [6856] = 3794,
  [6857] = 3796,
  [6858] = 3779,
  [6859] = 3751,
  [6860] = 3772,
  [6861] = 3815,
  [6862] = 4321,
  [6863] = 4135,
  [6864] = 3767,
  [6865] = 3769,
  [6866] = 3777,
  [6867] = 3806,
  [6868] = 3755,
  [6869] = 3815,
  [6870] = 4294,
  [6871] = 3779,
  [6872] = 3772,
  [6873] = 3729,
  [6874] = 3760,
  [6875] = 3760,
  [6876] = 3762,
  [6877] = 4321,
  [6878] = 3769,
  [6879] = 3778,
  [6880] = 3781,
  [6881] = 4100,
  [6882] = 4099,
  [6883] = 3777,
  [6884] = 3762,
  [6885] = 4111,
  [6886] = 3761,
  [6887] = 3783,
  [6888] = 4294,
  [6889] = 3747,
  [6890] = 3749,
  [6891] = 3750,
  [6892] = 3751,
  [6893] = 3744,
  [6894] = 4321,
  [6895] = 3757,
  [6896] = 3777,
  [6897] = 3764,
  [6898] = 3791,
  [6899] = 3765,
  [6900] = 3754,
  [6901] = 3770,
  [6902] = 3747,
  [6903] = 3758,
  [6904] = 3775,
  [6905] = 3757,
  [6906] = 3767,
  [6907] = 3806,
  [6908] = 3746,
  [6909] = 3746,
  [6910] = 3764,
  [6911] = 3815,
  [6912] = 3796,
  [6913] = 3765,
  [6914] = 3775,
  [6915] = 3777,
  [6916] = 3794,
  [6917] = 3754,
  [6918] = 3791,
  [6919] = 3779,
  [6920] = 3770,
  [6921] = 3781,
  [6922] = 3791,
  [6923] = 3778,
  [6924] = 3758,
  [6925] = 3781,
  [6926] = 3815,
  [6927] = 3789,
  [6928] = 3729,
  [6929] = 3760,
  [6930] = 3762,
  [6931] = 3746,
  [6932] = 3774,
  [6933] = 3782,
  [6934] = 3780,
  [6935] = 3772,
  [6936] = 3783,
  [6937] = 4294,
  [6938] = 3769,
  [6939] = 3724,
  [6940] = 3747,
  [6941] = 3780,
  [6942] = 3806,
  [6943] = 4112,
  [6944] = 3782,
  [6945] = 3744,
  [6946] = 3749,
  [6947] = 3750,
  [6948] = 3729,
  [6949] = 3764,
  [6950] = 3751,
  [6951] = 3731,
  [6952] = 3757,
  [6953] = 3730,
  [6954] = 3764,
  [6955] = 3765,
  [6956] = 3775,
  [6957] = 3794,
  [6958] = 3754,
  [6959] = 3796,
  [6960] = 3728,
  [6961] = 3761,
  [6962] = 3770,
  [6963] = 3744,
  [6964] = 3749,
  [6965] = 6673,
  [6966] = 3761,
  [6967] = 4321,
  [6968] = 3767,
  [6969] = 3774,
  [6970] = 3750,
  [6971] = 4095,
  [6972] = 3796,
  [6973] = 3794,
  [6974] = 4321,
  [6975] = 4094,
  [6976] = 3791,
  [6977] = 4093,
  [6978] = 3767,
  [6979] = 3774,
  [6980] = 3789,
  [6981] = 3751,
  [6982] = 3796,
  [6983] = 3757,
  [6984] = 3744,
  [6985] = 3724,
  [6986] = 3731,
  [6987] = 3782,
  [6988] = 3815,
  [6989] = 3774,
  [6990] = 3780,
  [6991] = 3782,
  [6992] = 3746,
  [6993] = 3754,
  [6994] = 3780,
  [6995] = 3758,
  [6996] = 3779,
  [6997] = 3772,
  [6998] = 3779,
  [6999] = 3760,
  [7000] = 3772,
  [7001] = 3770,
  [7002] = 3731,
  [7003] = 3760,
  [7004] = 4321,
  [7005] = 3728,
  [7006] = 3744,
  [7007] = 3761,
  [7008] = 4097,
  [7009] = 3765,
  [7010] = 3724,
  [7011] = 3767,
  [7012] = 3762,
  [7013] = 4078,
  [7014] = 4081,
  [7015] = 3762,
  [7016] = 3730,
  [7017] = 4083,
  [7018] = 3769,
  [7019] = 4085,
  [7020] = 4086,
  [7021] = 3774,
  [7022] = 3764,
  [7023] = 4087,
  [7024] = 4088,
  [7025] = 3789,
  [7026] = 3791,
  [7027] = 3780,
  [7028] = 4089,
  [7029] = 4294,
  [7030] = 3761,
  [7031] = 3782,
  [7032] = 3789,
  [7033] = 3761,
  [7034] = 3729,
  [7035] = 3731,
  [7036] = 3761,
  [7037] = 3744,
  [7038] = 3760,
  [7039] = 3728,
  [7040] = 3724,
  [7041] = 3731,
  [7042] = 3769,
  [7043] = 3789,
  [7044] = 3791,
  [7045] = 3780,
  [7046] = 3758,
  [7047] = 3724,
  [7048] = 3782,
  [7049] = 3779,
  [7050] = 3762,
  [7051] = 7051,
  [7052] = 3794,
  [7053] = 3796,
  [7054] = 3774,
  [7055] = 3767,
  [7056] = 3775,
  [7057] = 3731,
  [7058] = 3724,
  [7059] = 3806,
  [7060] = 3762,
  [7061] = 3730,
  [7062] = 3746,
  [7063] = 3744,
  [7064] = 3772,
  [7065] = 3779,
  [7066] = 4294,
  [7067] = 3767,
  [7068] = 3760,
  [7069] = 3774,
  [7070] = 3769,
  [7071] = 3767,
  [7072] = 3723,
  [7073] = 3772,
  [7074] = 3779,
  [7075] = 3780,
  [7076] = 3755,
  [7077] = 3782,
  [7078] = 3774,
  [7079] = 3815,
  [7080] = 3796,
  [7081] = 3794,
  [7082] = 3782,
  [7083] = 3780,
  [7084] = 3791,
  [7085] = 3746,
  [7086] = 6673,
  [7087] = 3758,
  [7088] = 3815,
  [7089] = 3777,
  [7090] = 3747,
  [7091] = 3791,
  [7092] = 3794,
  [7093] = 3806,
  [7094] = 3728,
  [7095] = 3762,
  [7096] = 3755,
  [7097] = 3796,
  [7098] = 3760,
  [7099] = 3767,
  [7100] = 3729,
  [7101] = 3772,
  [7102] = 3796,
  [7103] = 3789,
  [7104] = 3769,
  [7105] = 3730,
  [7106] = 3815,
  [7107] = 3749,
  [7108] = 3789,
  [7109] = 3750,
  [7110] = 3794,
  [7111] = 3791,
  [7112] = 3729,
  [7113] = 3750,
  [7114] = 3778,
  [7115] = 3781,
  [7116] = 3777,
  [7117] = 4294,
  [7118] = 3783,
  [7119] = 3761,
  [7120] = 3744,
  [7121] = 4321,
  [7122] = 3815,
  [7123] = 3774,
  [7124] = 3782,
  [7125] = 3780,
  [7126] = 3770,
  [7127] = 3754,
  [7128] = 3765,
  [7129] = 3764,
  [7130] = 3779,
  [7131] = 3751,
  [7132] = 3772,
  [7133] = 3757,
  [7134] = 3764,
  [7135] = 3751,
  [7136] = 6673,
  [7137] = 3750,
  [7138] = 3749,
  [7139] = 3775,
  [7140] = 3747,
  [7141] = 3783,
  [7142] = 4294,
  [7143] = 3781,
  [7144] = 3778,
  [7145] = 3723,
  [7146] = 4294,
  [7147] = 3770,
  [7148] = 3754,
  [7149] = 3769,
  [7150] = 3765,
  [7151] = 3760,
  [7152] = 3764,
  [7153] = 3757,
  [7154] = 3751,
  [7155] = 7155,
  [7156] = 3806,
  [7157] = 3777,
  [7158] = 3750,
  [7159] = 7051,
  [7160] = 3723,
  [7161] = 3762,
  [7162] = 3749,
  [7163] = 3761,
  [7164] = 3765,
  [7165] = 3754,
  [7166] = 3747,
  [7167] = 3744,
  [7168] = 3728,
  [7169] = 3770,
  [7170] = 3730,
  [7171] = 4321,
  [7172] = 3778,
  [7173] = 3747,
  [7174] = 3758,
  [7175] = 3781,
  [7176] = 3749,
  [7177] = 4321,
  [7178] = 3783,
  [7179] = 3730,
  [7180] = 3751,
  [7181] = 3755,
  [7182] = 3757,
  [7183] = 3764,
  [7184] = 3758,
  [7185] = 3746,
  [7186] = 3765,
  [7187] = 3723,
  [7188] = 3746,
  [7189] = 3754,
  [7190] = 3783,
  [7191] = 3775,
  [7192] = 3770,
  [7193] = 3755,
  [7194] = 3775,
  [7195] = 6485,
  [7196] = 3744,
  [7197] = 3761,
  [7198] = 3758,
  [7199] = 4321,
  [7200] = 3770,
  [7201] = 3746,
  [7202] = 3791,
  [7203] = 3731,
  [7204] = 3781,
  [7205] = 3778,
  [7206] = 3754,
  [7207] = 3783,
  [7208] = 3765,
  [7209] = 3769,
  [7210] = 3724,
  [7211] = 3781,
  [7212] = 3729,
  [7213] = 3789,
  [7214] = 3764,
  [7215] = 3778,
  [7216] = 3780,
  [7217] = 3757,
  [7218] = 3728,
  [7219] = 3757,
  [7220] = 3782,
  [7221] = 3806,
  [7222] = 3794,
  [7223] = 3796,
  [7224] = 3774,
  [7225] = 3751,
  [7226] = 4294,
  [7227] = 3767,
  [7228] = 3755,
  [7229] = 3762,
  [7230] = 3777,
  [7231] = 3750,
  [7232] = 3749,
  [7233] = 3760,
  [7234] = 3806,
  [7235] = 3772,
  [7236] = 3779,
  [7237] = 3815,
  [7238] = 3775,
  [7239] = 3747,
  [7240] = 4321,
  [7241] = 3777,
  [7242] = 3728,
  [7243] = 7243,
  [7244] = 3729,
  [7245] = 3775,
  [7246] = 3758,
  [7247] = 3729,
  [7248] = 3724,
  [7249] = 3724,
  [7250] = 3731,
  [7251] = 3731,
  [7252] = 3730,
  [7253] = 3783,
  [7254] = 3728,
  [7255] = 3781,
  [7256] = 3778,
  [7257] = 3744,
  [7258] = 7258,
  [7259] = 3761,
  [7260] = 3769,
  [7261] = 3789,
  [7262] = 3791,
  [7263] = 3780,
  [7264] = 3782,
  [7265] = 3794,
  [7266] = 3796,
  [7267] = 3774,
  [7268] = 7051,
  [7269] = 3767,
  [7270] = 3744,
  [7271] = 3761,
  [7272] = 3769,
  [7273] = 7243,
  [7274] = 3789,
  [7275] = 3791,
  [7276] = 3780,
  [7277] = 3782,
  [7278] = 3794,
  [7279] = 3796,
  [7280] = 3774,
  [7281] = 3767,
  [7282] = 3762,
  [7283] = 7283,
  [7284] = 3760,
  [7285] = 4294,
  [7286] = 3772,
  [7287] = 7287,
  [7288] = 7283,
  [7289] = 7243,
  [7290] = 3779,
  [7291] = 7291,
  [7292] = 7287,
  [7293] = 3815,
  [7294] = 7287,
  [7295] = 7283,
  [7296] = 3762,
  [7297] = 7243,
  [7298] = 3760,
  [7299] = 3723,
  [7300] = 3772,
  [7301] = 3779,
  [7302] = 7287,
  [7303] = 7283,
  [7304] = 7243,
  [7305] = 3815,
  [7306] = 7287,
  [7307] = 7283,
  [7308] = 7243,
  [7309] = 3770,
  [7310] = 3754,
  [7311] = 7311,
  [7312] = 7287,
  [7313] = 7283,
  [7314] = 3765,
  [7315] = 7243,
  [7316] = 3764,
  [7317] = 3757,
  [7318] = 3751,
  [7319] = 7287,
  [7320] = 3750,
  [7321] = 7283,
  [7322] = 3749,
  [7323] = 3728,
  [7324] = 3747,
  [7325] = 3746,
  [7326] = 7243,
  [7327] = 3770,
  [7328] = 3754,
  [7329] = 3765,
  [7330] = 3764,
  [7331] = 7331,
  [7332] = 7287,
  [7333] = 3757,
  [7334] = 7283,
  [7335] = 3751,
  [7336] = 6485,
  [7337] = 7243,
  [7338] = 3750,
  [7339] = 7287,
  [7340] = 3749,
  [7341] = 7283,
  [7342] = 3747,
  [7343] = 3723,
  [7344] = 3731,
  [7345] = 7243,
  [7346] = 3730,
  [7347] = 3783,
  [7348] = 3781,
  [7349] = 3728,
  [7350] = 3778,
  [7351] = 3770,
  [7352] = 7287,
  [7353] = 3783,
  [7354] = 7283,
  [7355] = 3806,
  [7356] = 3781,
  [7357] = 3778,
  [7358] = 7243,
  [7359] = 3806,
  [7360] = 3731,
  [7361] = 3777,
  [7362] = 3724,
  [7363] = 3724,
  [7364] = 7287,
  [7365] = 4294,
  [7366] = 7283,
  [7367] = 3777,
  [7368] = 7243,
  [7369] = 3747,
  [7370] = 4294,
  [7371] = 3729,
  [7372] = 3730,
  [7373] = 4321,
  [7374] = 3749,
  [7375] = 3750,
  [7376] = 3775,
  [7377] = 3728,
  [7378] = 7287,
  [7379] = 7283,
  [7380] = 7243,
  [7381] = 3775,
  [7382] = 7287,
  [7383] = 7283,
  [7384] = 7243,
  [7385] = 3751,
  [7386] = 3757,
  [7387] = 3723,
  [7388] = 3764,
  [7389] = 7287,
  [7390] = 7283,
  [7391] = 3746,
  [7392] = 3765,
  [7393] = 3758,
  [7394] = 3754,
  [7395] = 3746,
  [7396] = 3758,
  [7397] = 7243,
  [7398] = 3731,
  [7399] = 3724,
  [7400] = 3723,
  [7401] = 7287,
  [7402] = 3729,
  [7403] = 7283,
  [7404] = 3728,
  [7405] = 3730,
  [7406] = 3723,
  [7407] = 7243,
  [7408] = 3777,
  [7409] = 3730,
  [7410] = 7287,
  [7411] = 7283,
  [7412] = 7243,
  [7413] = 3729,
  [7414] = 4321,
  [7415] = 7287,
  [7416] = 7283,
  [7417] = 3723,
  [7418] = 4321,
  [7419] = 7243,
  [7420] = 3744,
  [7421] = 7287,
  [7422] = 7283,
  [7423] = 3761,
  [7424] = 3762,
  [7425] = 3760,
  [7426] = 7243,
  [7427] = 3769,
  [7428] = 3789,
  [7429] = 3772,
  [7430] = 7287,
  [7431] = 3779,
  [7432] = 7283,
  [7433] = 3791,
  [7434] = 7243,
  [7435] = 3780,
  [7436] = 7287,
  [7437] = 7283,
  [7438] = 7243,
  [7439] = 3782,
  [7440] = 7287,
  [7441] = 7283,
  [7442] = 7243,
  [7443] = 3794,
  [7444] = 3796,
  [7445] = 3730,
  [7446] = 3774,
  [7447] = 3815,
  [7448] = 3767,
  [7449] = 7287,
  [7450] = 7283,
  [7451] = 3755,
  [7452] = 3770,
  [7453] = 4294,
  [7454] = 3755,
  [7455] = 7243,
  [7456] = 3783,
  [7457] = 3723,
  [7458] = 3754,
  [7459] = 3765,
  [7460] = 7287,
  [7461] = 7283,
  [7462] = 3764,
  [7463] = 7243,
  [7464] = 3757,
  [7465] = 3781,
  [7466] = 7287,
  [7467] = 7283,
  [7468] = 3778,
  [7469] = 7243,
  [7470] = 3751,
  [7471] = 3750,
  [7472] = 4321,
  [7473] = 7287,
  [7474] = 3749,
  [7475] = 3747,
  [7476] = 7283,
  [7477] = 7243,
  [7478] = 7051,
  [7479] = 3777,
  [7480] = 3728,
  [7481] = 3775,
  [7482] = 3730,
  [7483] = 3723,
  [7484] = 3806,
  [7485] = 7287,
  [7486] = 7283,
  [7487] = 7243,
  [7488] = 3746,
  [7489] = 3758,
  [7490] = 7287,
  [7491] = 7283,
  [7492] = 7243,
  [7493] = 3723,
  [7494] = 3755,
  [7495] = 3755,
  [7496] = 7287,
  [7497] = 7283,
  [7498] = 7243,
  [7499] = 7243,
  [7500] = 7283,
  [7501] = 7291,
  [7502] = 7287,
  [7503] = 7283,
  [7504] = 7243,
  [7505] = 7287,
  [7506] = 7311,
  [7507] = 7331,
  [7508] = 3729,
  [7509] = 7243,
  [7510] = 3731,
  [7511] = 3724,
  [7512] = 3806,
  [7513] = 7283,
  [7514] = 7287,
  [7515] = 7283,
  [7516] = 7287,
  [7517] = 7243,
  [7518] = 3815,
  [7519] = 3779,
  [7520] = 3772,
  [7521] = 7243,
  [7522] = 7287,
  [7523] = 7283,
  [7524] = 7243,
  [7525] = 7283,
  [7526] = 7287,
  [7527] = 3760,
  [7528] = 3762,
  [7529] = 7287,
  [7530] = 3731,
  [7531] = 7243,
  [7532] = 7283,
  [7533] = 7287,
  [7534] = 7243,
  [7535] = 7283,
  [7536] = 7243,
  [7537] = 3767,
  [7538] = 7283,
  [7539] = 7287,
  [7540] = 3774,
  [7541] = 3796,
  [7542] = 3794,
  [7543] = 3782,
  [7544] = 3780,
  [7545] = 3724,
  [7546] = 3791,
  [7547] = 3729,
  [7548] = 7243,
  [7549] = 7283,
  [7550] = 7287,
  [7551] = 3789,
  [7552] = 3769,
  [7553] = 3761,
  [7554] = 3744,
  [7555] = 7287,
  [7556] = 7283,
  [7557] = 7243,
  [7558] = 7283,
  [7559] = 7287,
  [7560] = 7243,
  [7561] = 7243,
  [7562] = 7283,
  [7563] = 7287,
  [7564] = 7243,
  [7565] = 7283,
  [7566] = 7287,
  [7567] = 7243,
  [7568] = 7283,
  [7569] = 7287,
  [7570] = 7283,
  [7571] = 7243,
  [7572] = 7287,
  [7573] = 7287,
  [7574] = 7243,
  [7575] = 7287,
  [7576] = 7283,
  [7577] = 7283,
  [7578] = 3778,
  [7579] = 3747,
  [7580] = 3765,
  [7581] = 3754,
  [7582] = 3754,
  [7583] = 3806,
  [7584] = 3765,
  [7585] = 3770,
  [7586] = 3729,
  [7587] = 3764,
  [7588] = 3757,
  [7589] = 3761,
  [7590] = 3744,
  [7591] = 3760,
  [7592] = 3806,
  [7593] = 3755,
  [7594] = 4294,
  [7595] = 4294,
  [7596] = 3724,
  [7597] = 3724,
  [7598] = 3751,
  [7599] = 3731,
  [7600] = 3764,
  [7601] = 3757,
  [7602] = 3751,
  [7603] = 3770,
  [7604] = 3724,
  [7605] = 3723,
  [7606] = 3750,
  [7607] = 3749,
  [7608] = 3775,
  [7609] = 3724,
  [7610] = 3747,
  [7611] = 3815,
  [7612] = 4294,
  [7613] = 3731,
  [7614] = 3730,
  [7615] = 3778,
  [7616] = 3758,
  [7617] = 3781,
  [7618] = 3724,
  [7619] = 3789,
  [7620] = 3746,
  [7621] = 7621,
  [7622] = 3758,
  [7623] = 3806,
  [7624] = 3779,
  [7625] = 3772,
  [7626] = 3762,
  [7627] = 3746,
  [7628] = 3770,
  [7629] = 3731,
  [7630] = 3760,
  [7631] = 3750,
  [7632] = 3749,
  [7633] = 3783,
  [7634] = 3770,
  [7635] = 3783,
  [7636] = 3783,
  [7637] = 3755,
  [7638] = 3731,
  [7639] = 3777,
  [7640] = 3729,
  [7641] = 3746,
  [7642] = 3758,
  [7643] = 3730,
  [7644] = 3762,
  [7645] = 3755,
  [7646] = 3778,
  [7647] = 3791,
  [7648] = 3744,
  [7649] = 3761,
  [7650] = 3781,
  [7651] = 3794,
  [7652] = 4294,
  [7653] = 3783,
  [7654] = 3796,
  [7655] = 3728,
  [7656] = 3747,
  [7657] = 3781,
  [7658] = 4321,
  [7659] = 3750,
  [7660] = 3781,
  [7661] = 3778,
  [7662] = 3749,
  [7663] = 3750,
  [7664] = 3751,
  [7665] = 3757,
  [7666] = 3778,
  [7667] = 3764,
  [7668] = 3765,
  [7669] = 3723,
  [7670] = 3754,
  [7671] = 3815,
  [7672] = 3770,
  [7673] = 3731,
  [7674] = 3769,
  [7675] = 3730,
  [7676] = 3789,
  [7677] = 3728,
  [7678] = 4321,
  [7679] = 3775,
  [7680] = 3728,
  [7681] = 3755,
  [7682] = 3758,
  [7683] = 3764,
  [7684] = 3777,
  [7685] = 3723,
  [7686] = 3772,
  [7687] = 3777,
  [7688] = 3746,
  [7689] = 3767,
  [7690] = 3729,
  [7691] = 3729,
  [7692] = 3767,
  [7693] = 3747,
  [7694] = 3796,
  [7695] = 3755,
  [7696] = 3791,
  [7697] = 3794,
  [7698] = 3780,
  [7699] = 3782,
  [7700] = 3794,
  [7701] = 3806,
  [7702] = 3791,
  [7703] = 3754,
  [7704] = 3796,
  [7705] = 3755,
  [7706] = 3789,
  [7707] = 3774,
  [7708] = 3767,
  [7709] = 3729,
  [7710] = 3779,
  [7711] = 3749,
  [7712] = 3815,
  [7713] = 3746,
  [7714] = 3730,
  [7715] = 3774,
  [7716] = 3779,
  [7717] = 3728,
  [7718] = 3782,
  [7719] = 3780,
  [7720] = 3769,
  [7721] = 3730,
  [7722] = 3723,
  [7723] = 3789,
  [7724] = 3772,
  [7725] = 3779,
  [7726] = 3774,
  [7727] = 3747,
  [7728] = 3751,
  [7729] = 3772,
  [7730] = 3758,
  [7731] = 4321,
  [7732] = 3769,
  [7733] = 3728,
  [7734] = 3760,
  [7735] = 3757,
  [7736] = 4294,
  [7737] = 3762,
  [7738] = 3775,
  [7739] = 3761,
  [7740] = 3728,
  [7741] = 3762,
  [7742] = 3730,
  [7743] = 3744,
  [7744] = 3775,
  [7745] = 3724,
  [7746] = 3731,
  [7747] = 3775,
  [7748] = 3777,
  [7749] = 7621,
  [7750] = 3765,
  [7751] = 3744,
  [7752] = 3729,
  [7753] = 3761,
  [7754] = 3781,
  [7755] = 3723,
  [7756] = 3728,
  [7757] = 3783,
  [7758] = 3747,
  [7759] = 3749,
  [7760] = 3777,
  [7761] = 3750,
  [7762] = 3751,
  [7763] = 3729,
  [7764] = 3764,
  [7765] = 3757,
  [7766] = 3765,
  [7767] = 3764,
  [7768] = 3765,
  [7769] = 3723,
  [7770] = 3754,
  [7771] = 3770,
  [7772] = 3815,
  [7773] = 3744,
  [7774] = 4321,
  [7775] = 3761,
  [7776] = 3760,
  [7777] = 4294,
  [7778] = 3757,
  [7779] = 7621,
  [7780] = 3730,
  [7781] = 3806,
  [7782] = 3767,
  [7783] = 3774,
  [7784] = 3796,
  [7785] = 3751,
  [7786] = 3806,
  [7787] = 3729,
  [7788] = 3723,
  [7789] = 3724,
  [7790] = 7621,
  [7791] = 3762,
  [7792] = 3758,
  [7793] = 3746,
  [7794] = 3775,
  [7795] = 3777,
  [7796] = 3731,
  [7797] = 3794,
  [7798] = 3744,
  [7799] = 3761,
  [7800] = 3767,
  [7801] = 3796,
  [7802] = 3777,
  [7803] = 3794,
  [7804] = 3791,
  [7805] = 3746,
  [7806] = 3758,
  [7807] = 4321,
  [7808] = 3754,
  [7809] = 3769,
  [7810] = 3789,
  [7811] = 3769,
  [7812] = 3780,
  [7813] = 3782,
  [7814] = 3789,
  [7815] = 3782,
  [7816] = 3774,
  [7817] = 3791,
  [7818] = 3815,
  [7819] = 3780,
  [7820] = 3782,
  [7821] = 3794,
  [7822] = 3796,
  [7823] = 3782,
  [7824] = 3815,
  [7825] = 3767,
  [7826] = 3780,
  [7827] = 3789,
  [7828] = 3791,
  [7829] = 3794,
  [7830] = 3796,
  [7831] = 3780,
  [7832] = 3774,
  [7833] = 3767,
  [7834] = 3782,
  [7835] = 3780,
  [7836] = 3806,
  [7837] = 3723,
  [7838] = 7621,
  [7839] = 3791,
  [7840] = 3769,
  [7841] = 3779,
  [7842] = 3774,
  [7843] = 4294,
  [7844] = 3762,
  [7845] = 3772,
  [7846] = 3769,
  [7847] = 3760,
  [7848] = 3723,
  [7849] = 3749,
  [7850] = 3772,
  [7851] = 3760,
  [7852] = 3778,
  [7853] = 3781,
  [7854] = 3761,
  [7855] = 3779,
  [7856] = 3760,
  [7857] = 3779,
  [7858] = 3772,
  [7859] = 3744,
  [7860] = 3750,
  [7861] = 3783,
  [7862] = 3815,
  [7863] = 7621,
  [7864] = 3770,
  [7865] = 3778,
  [7866] = 3781,
  [7867] = 3724,
  [7868] = 3754,
  [7869] = 4321,
  [7870] = 3775,
  [7871] = 3765,
  [7872] = 3755,
  [7873] = 4321,
  [7874] = 3764,
  [7875] = 3757,
  [7876] = 3751,
  [7877] = 3783,
  [7878] = 3750,
  [7879] = 3749,
  [7880] = 3747,
  [7881] = 3730,
  [7882] = 3731,
  [7883] = 3728,
  [7884] = 3762,
  [7885] = 3796,
  [7886] = 3757,
  [7887] = 3791,
  [7888] = 3751,
  [7889] = 3791,
  [7890] = 3794,
  [7891] = 3796,
  [7892] = 3767,
  [7893] = 3767,
  [7894] = 3770,
  [7895] = 3728,
  [7896] = 4294,
  [7897] = 3754,
  [7898] = 3765,
  [7899] = 3757,
  [7900] = 3775,
  [7901] = 3764,
  [7902] = 3762,
  [7903] = 3764,
  [7904] = 3757,
  [7905] = 3758,
  [7906] = 3765,
  [7907] = 3751,
  [7908] = 3754,
  [7909] = 3746,
  [7910] = 3750,
  [7911] = 3749,
  [7912] = 4321,
  [7913] = 3796,
  [7914] = 3780,
  [7915] = 3794,
  [7916] = 3782,
  [7917] = 3782,
  [7918] = 3747,
  [7919] = 3770,
  [7920] = 3780,
  [7921] = 3789,
  [7922] = 3761,
  [7923] = 3791,
  [7924] = 7924,
  [7925] = 3775,
  [7926] = 3774,
  [7927] = 3782,
  [7928] = 3780,
  [7929] = 7924,
  [7930] = 3791,
  [7931] = 3794,
  [7932] = 3789,
  [7933] = 3796,
  [7934] = 3780,
  [7935] = 3769,
  [7936] = 3782,
  [7937] = 3778,
  [7938] = 3794,
  [7939] = 3769,
  [7940] = 4294,
  [7941] = 3796,
  [7942] = 3769,
  [7943] = 3760,
  [7944] = 3750,
  [7945] = 3761,
  [7946] = 3774,
  [7947] = 3744,
  [7948] = 3767,
  [7949] = 3775,
  [7950] = 3749,
  [7951] = 4321,
  [7952] = 3744,
  [7953] = 3755,
  [7954] = 3772,
  [7955] = 3783,
  [7956] = 4321,
  [7957] = 3781,
  [7958] = 3779,
  [7959] = 3778,
  [7960] = 3747,
  [7961] = 3815,
  [7962] = 3796,
  [7963] = 3806,
  [7964] = 3723,
  [7965] = 3770,
  [7966] = 3754,
  [7967] = 3794,
  [7968] = 3791,
  [7969] = 3765,
  [7970] = 3781,
  [7971] = 3744,
  [7972] = 3762,
  [7973] = 3761,
  [7974] = 3762,
  [7975] = 3764,
  [7976] = 3757,
  [7977] = 3751,
  [7978] = 3760,
  [7979] = 3769,
  [7980] = 3789,
  [7981] = 3769,
  [7982] = 3777,
  [7983] = 3750,
  [7984] = 3777,
  [7985] = 3789,
  [7986] = 3749,
  [7987] = 3772,
  [7988] = 3779,
  [7989] = 4294,
  [7990] = 3730,
  [7991] = 3767,
  [7992] = 3774,
  [7993] = 3806,
  [7994] = 3783,
  [7995] = 7924,
  [7996] = 3774,
  [7997] = 3796,
  [7998] = 3794,
  [7999] = 3780,
  [8000] = 3774,
  [8001] = 3782,
  [8002] = 3782,
  [8003] = 3767,
  [8004] = 3780,
  [8005] = 3747,
  [8006] = 3791,
  [8007] = 3774,
  [8008] = 3815,
  [8009] = 4294,
  [8010] = 3806,
  [8011] = 3781,
  [8012] = 3778,
  [8013] = 3806,
  [8014] = 3815,
  [8015] = 3758,
  [8016] = 3777,
  [8017] = 3777,
  [8018] = 3777,
  [8019] = 3806,
  [8020] = 3774,
  [8021] = 3746,
  [8022] = 3758,
  [8023] = 3760,
  [8024] = 3815,
  [8025] = 3789,
  [8026] = 3761,
  [8027] = 3744,
  [8028] = 3789,
  [8029] = 3772,
  [8030] = 7924,
  [8031] = 3769,
  [8032] = 3775,
  [8033] = 3770,
  [8034] = 3761,
  [8035] = 3744,
  [8036] = 3779,
  [8037] = 3729,
  [8038] = 4294,
  [8039] = 3779,
  [8040] = 3815,
  [8041] = 3791,
  [8042] = 3794,
  [8043] = 3755,
  [8044] = 6485,
  [8045] = 3772,
  [8046] = 3760,
  [8047] = 3779,
  [8048] = 3767,
  [8049] = 3755,
  [8050] = 3746,
  [8051] = 3782,
  [8052] = 3772,
  [8053] = 3761,
  [8054] = 3744,
  [8055] = 3746,
  [8056] = 4321,
  [8057] = 3758,
  [8058] = 3758,
  [8059] = 3775,
  [8060] = 3746,
  [8061] = 4294,
  [8062] = 3755,
  [8063] = 3780,
  [8064] = 3755,
  [8065] = 3747,
  [8066] = 3789,
  [8067] = 3747,
  [8068] = 3775,
  [8069] = 3755,
  [8070] = 3815,
  [8071] = 3744,
  [8072] = 3747,
  [8073] = 3761,
  [8074] = 3754,
  [8075] = 3765,
  [8076] = 3781,
  [8077] = 3783,
  [8078] = 3762,
  [8079] = 3749,
  [8080] = 3779,
  [8081] = 3750,
  [8082] = 3772,
  [8083] = 4294,
  [8084] = 3760,
  [8085] = 4294,
  [8086] = 3783,
  [8087] = 3781,
  [8088] = 3749,
  [8089] = 3750,
  [8090] = 3778,
  [8091] = 3778,
  [8092] = 3775,
  [8093] = 6485,
  [8094] = 3751,
  [8095] = 3746,
  [8096] = 3757,
  [8097] = 3764,
  [8098] = 3746,
  [8099] = 3770,
  [8100] = 3758,
  [8101] = 3762,
  [8102] = 3778,
  [8103] = 3764,
  [8104] = 3775,
  [8105] = 3757,
  [8106] = 4321,
  [8107] = 3754,
  [8108] = 3806,
  [8109] = 3765,
  [8110] = 3806,
  [8111] = 3754,
  [8112] = 3765,
  [8113] = 3767,
  [8114] = 3769,
  [8115] = 3755,
  [8116] = 4321,
  [8117] = 3751,
  [8118] = 3767,
  [8119] = 3760,
  [8120] = 3764,
  [8121] = 7924,
  [8122] = 3746,
  [8123] = 3769,
  [8124] = 3796,
  [8125] = 3794,
  [8126] = 3777,
  [8127] = 3815,
  [8128] = 3758,
  [8129] = 3791,
  [8130] = 3783,
  [8131] = 3779,
  [8132] = 3772,
  [8133] = 3760,
  [8134] = 3789,
  [8135] = 3765,
  [8136] = 3806,
  [8137] = 3783,
  [8138] = 3724,
  [8139] = 3770,
  [8140] = 3772,
  [8141] = 3758,
  [8142] = 3778,
  [8143] = 3781,
  [8144] = 3749,
  [8145] = 3750,
  [8146] = 3754,
  [8147] = 3779,
  [8148] = 3780,
  [8149] = 3764,
  [8150] = 3782,
  [8151] = 3751,
  [8152] = 3778,
  [8153] = 3723,
  [8154] = 3781,
  [8155] = 3757,
  [8156] = 3730,
  [8157] = 3751,
  [8158] = 3777,
  [8159] = 3770,
  [8160] = 3731,
  [8161] = 3781,
  [8162] = 3770,
  [8163] = 3764,
  [8164] = 3783,
  [8165] = 3762,
  [8166] = 3757,
  [8167] = 3751,
  [8168] = 3783,
  [8169] = 3762,
  [8170] = 4321,
  [8171] = 4321,
  [8172] = 3750,
  [8173] = 3749,
  [8174] = 3750,
  [8175] = 3749,
  [8176] = 7924,
  [8177] = 3777,
  [8178] = 3760,
  [8179] = 3765,
  [8180] = 3747,
  [8181] = 3747,
  [8182] = 3754,
  [8183] = 3755,
  [8184] = 3762,
  [8185] = 3815,
  [8186] = 3774,
  [8187] = 3728,
  [8188] = 3744,
  [8189] = 3761,
  [8190] = 3791,
  [8191] = 3728,
  [8192] = 3761,
  [8193] = 3777,
  [8194] = 6485,
  [8195] = 3758,
  [8196] = 3762,
  [8197] = 8197,
  [8198] = 8198,
  [8199] = 6485,
  [8200] = 3760,
  [8201] = 3769,
  [8202] = 3778,
  [8203] = 3781,
  [8204] = 3772,
  [8205] = 3779,
  [8206] = 3780,
  [8207] = 3782,
  [8208] = 3755,
  [8209] = 3783,
  [8210] = 3774,
  [8211] = 3815,
  [8212] = 6485,
  [8213] = 3724,
  [8214] = 6485,
  [8215] = 6485,
  [8216] = 3744,
  [8217] = 3789,
  [8218] = 3758,
  [8219] = 3794,
  [8220] = 3796,
  [8221] = 3767,
  [8222] = 3731,
  [8223] = 3747,
  [8224] = 8197,
  [8225] = 3749,
  [8226] = 3750,
  [8227] = 3755,
  [8228] = 3751,
  [8229] = 4321,
  [8230] = 3757,
  [8231] = 3764,
  [8232] = 6485,
  [8233] = 3765,
  [8234] = 3754,
  [8235] = 8235,
  [8236] = 3729,
  [8237] = 3770,
  [8238] = 3746,
  [8239] = 3806,
  [8240] = 3730,
  [8241] = 3746,
  [8242] = 3723,
  [8243] = 8197,
  [8244] = 3775,
  [8245] = 4294,
  [8246] = 6485,
  [8247] = 3751,
  [8248] = 3789,
  [8249] = 6485,
  [8250] = 3769,
  [8251] = 3758,
  [8252] = 6485,
  [8253] = 4294,
  [8254] = 8254,
  [8255] = 3723,
  [8256] = 8256,
  [8257] = 3746,
  [8258] = 3806,
  [8259] = 8256,
  [8260] = 8260,
  [8261] = 3779,
  [8262] = 8262,
  [8263] = 8263,
  [8264] = 3772,
  [8265] = 3760,
  [8266] = 6485,
  [8267] = 3744,
  [8268] = 3729,
  [8269] = 6485,
  [8270] = 3728,
  [8271] = 8271,
  [8272] = 3791,
  [8273] = 3767,
  [8274] = 3761,
  [8275] = 3780,
  [8276] = 3782,
  [8277] = 8262,
  [8278] = 3724,
  [8279] = 8254,
  [8280] = 3794,
  [8281] = 3754,
  [8282] = 3775,
  [8283] = 8254,
  [8284] = 3731,
  [8285] = 3770,
  [8286] = 3796,
  [8287] = 8235,
  [8288] = 3747,
  [8289] = 8262,
  [8290] = 3749,
  [8291] = 3765,
  [8292] = 3781,
  [8293] = 3750,
  [8294] = 8256,
  [8295] = 8235,
  [8296] = 6485,
  [8297] = 6485,
  [8298] = 6485,
  [8299] = 3783,
  [8300] = 3762,
  [8301] = 3774,
  [8302] = 8260,
  [8303] = 3764,
  [8304] = 6485,
  [8305] = 3755,
  [8306] = 8306,
  [8307] = 8260,
  [8308] = 3815,
  [8309] = 3777,
  [8310] = 3757,
  [8311] = 3730,
  [8312] = 3778,
  [8313] = 4294,
  [8314] = 8314,
  [8315] = 8314,
  [8316] = 8316,
  [8317] = 8317,
  [8318] = 3729,
  [8319] = 3754,
  [8320] = 8314,
  [8321] = 8314,
  [8322] = 8317,
  [8323] = 8314,
  [8324] = 8324,
  [8325] = 8314,
  [8326] = 8314,
  [8327] = 8314,
  [8328] = 3777,
  [8329] = 3806,
  [8330] = 8314,
  [8331] = 8317,
  [8332] = 8332,
  [8333] = 8333,
  [8334] = 3723,
  [8335] = 8314,
  [8336] = 3769,
  [8337] = 3815,
  [8338] = 3789,
  [8339] = 8271,
  [8340] = 3724,
  [8341] = 8314,
  [8342] = 8342,
  [8343] = 8306,
  [8344] = 3779,
  [8345] = 8345,
  [8346] = 8314,
  [8347] = 8347,
  [8348] = 8314,
  [8349] = 3772,
  [8350] = 8314,
  [8351] = 8263,
  [8352] = 3765,
  [8353] = 8317,
  [8354] = 8314,
  [8355] = 8314,
  [8356] = 8356,
  [8357] = 8314,
  [8358] = 8358,
  [8359] = 3764,
  [8360] = 8317,
  [8361] = 8317,
  [8362] = 8314,
  [8363] = 3757,
  [8364] = 8314,
  [8365] = 3723,
  [8366] = 8314,
  [8367] = 3747,
  [8368] = 3731,
  [8369] = 8369,
  [8370] = 8370,
  [8371] = 8306,
  [8372] = 8317,
  [8373] = 3753,
  [8374] = 3746,
  [8375] = 8375,
  [8376] = 8271,
  [8377] = 8314,
  [8378] = 8378,
  [8379] = 8379,
  [8380] = 8380,
  [8381] = 8381,
  [8382] = 3724,
  [8383] = 8314,
  [8384] = 3767,
  [8385] = 8314,
  [8386] = 8317,
  [8387] = 3760,
  [8388] = 8314,
  [8389] = 8317,
  [8390] = 8314,
  [8391] = 8317,
  [8392] = 3723,
  [8393] = 8314,
  [8394] = 8317,
  [8395] = 8395,
  [8396] = 8317,
  [8397] = 3774,
  [8398] = 8398,
  [8399] = 8317,
  [8400] = 8314,
  [8401] = 3755,
  [8402] = 6485,
  [8403] = 3731,
  [8404] = 8314,
  [8405] = 8314,
  [8406] = 8317,
  [8407] = 8263,
  [8408] = 3731,
  [8409] = 3755,
  [8410] = 3729,
  [8411] = 8317,
  [8412] = 8317,
  [8413] = 3724,
  [8414] = 8414,
  [8415] = 8314,
  [8416] = 8314,
  [8417] = 8380,
  [8418] = 8314,
  [8419] = 8380,
  [8420] = 8314,
  [8421] = 8314,
  [8422] = 6485,
  [8423] = 3744,
  [8424] = 8314,
  [8425] = 8317,
  [8426] = 8426,
  [8427] = 8427,
  [8428] = 3731,
  [8429] = 8314,
  [8430] = 8317,
  [8431] = 8314,
  [8432] = 3724,
  [8433] = 3728,
  [8434] = 8434,
  [8435] = 8314,
  [8436] = 3730,
  [8437] = 3755,
  [8438] = 3761,
  [8439] = 3729,
  [8440] = 8314,
  [8441] = 8317,
  [8442] = 6485,
  [8443] = 8443,
  [8444] = 8314,
  [8445] = 8314,
  [8446] = 3723,
  [8447] = 8447,
  [8448] = 8314,
  [8449] = 8314,
  [8450] = 3770,
  [8451] = 8317,
  [8452] = 8452,
  [8453] = 8453,
  [8454] = 8235,
  [8455] = 3796,
  [8456] = 3783,
  [8457] = 8317,
  [8458] = 3762,
  [8459] = 3794,
  [8460] = 3782,
  [8461] = 8314,
  [8462] = 3751,
  [8463] = 6673,
  [8464] = 3780,
  [8465] = 8314,
  [8466] = 3728,
  [8467] = 3758,
  [8468] = 3750,
  [8469] = 3728,
  [8470] = 3749,
  [8471] = 8317,
  [8472] = 8317,
  [8473] = 3775,
  [8474] = 8314,
  [8475] = 6485,
  [8476] = 8317,
  [8477] = 3730,
  [8478] = 3781,
  [8479] = 3730,
  [8480] = 3791,
  [8481] = 3778,
  [8482] = 8482,
  [8483] = 6485,
  [8484] = 8317,
  [8485] = 3729,
  [8486] = 3746,
  [8487] = 3724,
  [8488] = 8488,
  [8489] = 3723,
  [8490] = 8235,
  [8491] = 3746,
  [8492] = 3806,
  [8493] = 3730,
  [8494] = 8494,
  [8495] = 3779,
  [8496] = 3758,
  [8497] = 8324,
  [8498] = 8235,
  [8499] = 8271,
  [8500] = 3728,
  [8501] = 3731,
  [8502] = 8306,
  [8503] = 3781,
  [8504] = 3777,
  [8505] = 3754,
  [8506] = 3782,
  [8507] = 8324,
  [8508] = 3778,
  [8509] = 8235,
  [8510] = 3775,
  [8511] = 3796,
  [8512] = 3772,
  [8513] = 8494,
  [8514] = 3767,
  [8515] = 8515,
  [8516] = 3758,
  [8517] = 3755,
  [8518] = 7051,
  [8519] = 3774,
  [8520] = 3746,
  [8521] = 3778,
  [8522] = 3744,
  [8523] = 3744,
  [8524] = 8316,
  [8525] = 3761,
  [8526] = 3789,
  [8527] = 3769,
  [8528] = 3723,
  [8529] = 8488,
  [8530] = 3754,
  [8531] = 3730,
  [8532] = 3815,
  [8533] = 3762,
  [8534] = 3761,
  [8535] = 3781,
  [8536] = 3753,
  [8537] = 8378,
  [8538] = 3815,
  [8539] = 3760,
  [8540] = 3769,
  [8541] = 3747,
  [8542] = 8358,
  [8543] = 3772,
  [8544] = 3779,
  [8545] = 3780,
  [8546] = 3782,
  [8547] = 3775,
  [8548] = 3774,
  [8549] = 3815,
  [8550] = 8515,
  [8551] = 3806,
  [8552] = 3765,
  [8553] = 3791,
  [8554] = 7155,
  [8555] = 8235,
  [8556] = 3765,
  [8557] = 3775,
  [8558] = 8378,
  [8559] = 8559,
  [8560] = 8356,
  [8561] = 3760,
  [8562] = 8559,
  [8563] = 3723,
  [8564] = 4321,
  [8565] = 7155,
  [8566] = 3723,
  [8567] = 8559,
  [8568] = 3780,
  [8569] = 3762,
  [8570] = 3769,
  [8571] = 3794,
  [8572] = 3796,
  [8573] = 3770,
  [8574] = 3728,
  [8575] = 3796,
  [8576] = 3794,
  [8577] = 7155,
  [8578] = 8578,
  [8579] = 3782,
  [8580] = 3783,
  [8581] = 4321,
  [8582] = 3749,
  [8583] = 3780,
  [8584] = 3764,
  [8585] = 8381,
  [8586] = 3757,
  [8587] = 8381,
  [8588] = 3806,
  [8589] = 3791,
  [8590] = 3758,
  [8591] = 6485,
  [8592] = 8398,
  [8593] = 8356,
  [8594] = 3774,
  [8595] = 3751,
  [8596] = 3728,
  [8597] = 3755,
  [8598] = 3789,
  [8599] = 3791,
  [8600] = 3794,
  [8601] = 3796,
  [8602] = 3780,
  [8603] = 6485,
  [8604] = 8414,
  [8605] = 3794,
  [8606] = 3750,
  [8607] = 3767,
  [8608] = 3782,
  [8609] = 8398,
  [8610] = 8426,
  [8611] = 3777,
  [8612] = 3751,
  [8613] = 3774,
  [8614] = 8358,
  [8615] = 6485,
  [8616] = 3744,
  [8617] = 3789,
  [8618] = 3767,
  [8619] = 3747,
  [8620] = 3755,
  [8621] = 3779,
  [8622] = 3772,
  [8623] = 3723,
  [8624] = 8235,
  [8625] = 8447,
  [8626] = 3772,
  [8627] = 3755,
  [8628] = 8434,
  [8629] = 3764,
  [8630] = 3728,
  [8631] = 3761,
  [8632] = 8427,
  [8633] = 3730,
  [8634] = 3770,
  [8635] = 3767,
  [8636] = 3783,
  [8637] = 3760,
  [8638] = 3789,
  [8639] = 3769,
  [8640] = 3815,
  [8641] = 8332,
  [8642] = 3757,
  [8643] = 3754,
  [8644] = 8347,
  [8645] = 3765,
  [8646] = 8369,
  [8647] = 8443,
  [8648] = 3730,
  [8649] = 3764,
  [8650] = 8379,
  [8651] = 3729,
  [8652] = 3764,
  [8653] = 3761,
  [8654] = 8375,
  [8655] = 8375,
  [8656] = 3757,
  [8657] = 8379,
  [8658] = 3765,
  [8659] = 3778,
  [8660] = 3781,
  [8661] = 3778,
  [8662] = 3744,
  [8663] = 8427,
  [8664] = 3751,
  [8665] = 8434,
  [8666] = 3777,
  [8667] = 3781,
  [8668] = 3750,
  [8669] = 8447,
  [8670] = 3806,
  [8671] = 3749,
  [8672] = 3747,
  [8673] = 8443,
  [8674] = 3775,
  [8675] = 8369,
  [8676] = 8347,
  [8677] = 8332,
  [8678] = 6485,
  [8679] = 3755,
  [8680] = 3753,
  [8681] = 3728,
  [8682] = 3791,
  [8683] = 3777,
  [8684] = 3723,
  [8685] = 8426,
  [8686] = 3749,
  [8687] = 3730,
  [8688] = 3750,
  [8689] = 3770,
  [8690] = 3754,
  [8691] = 8333,
  [8692] = 3757,
  [8693] = 3747,
  [8694] = 8414,
  [8695] = 3762,
  [8696] = 3762,
  [8697] = 3760,
  [8698] = 3783,
  [8699] = 3783,
  [8700] = 8333,
  [8701] = 3751,
  [8702] = 3770,
  [8703] = 3749,
  [8704] = 3779,
  [8705] = 6673,
  [8706] = 8316,
  [8707] = 3750,
  [8708] = 8708,
  [8709] = 3765,
  [8710] = 3724,
  [8711] = 8263,
  [8712] = 3758,
  [8713] = 3730,
  [8714] = 3724,
  [8715] = 3728,
  [8716] = 3730,
  [8717] = 8717,
  [8718] = 3746,
  [8719] = 3723,
  [8720] = 3731,
  [8721] = 3729,
  [8722] = 3778,
  [8723] = 3724,
  [8724] = 3728,
  [8725] = 3729,
  [8726] = 3731,
  [8727] = 3729,
  [8728] = 3764,
  [8729] = 3757,
  [8730] = 3751,
  [8731] = 8306,
  [8732] = 3723,
  [8733] = 8235,
  [8734] = 3728,
  [8735] = 3781,
  [8736] = 3758,
  [8737] = 3730,
  [8738] = 3754,
  [8739] = 3815,
  [8740] = 3746,
  [8741] = 3774,
  [8742] = 3731,
  [8743] = 3724,
  [8744] = 7155,
  [8745] = 3783,
  [8746] = 3724,
  [8747] = 8559,
  [8748] = 8748,
  [8749] = 3731,
  [8750] = 8750,
  [8751] = 8751,
  [8752] = 3746,
  [8753] = 8717,
  [8754] = 8748,
  [8755] = 8750,
  [8756] = 8751,
  [8757] = 8757,
  [8758] = 3729,
  [8759] = 8759,
  [8760] = 3750,
  [8761] = 3749,
  [8762] = 6485,
  [8763] = 3755,
  [8764] = 8764,
  [8765] = 3731,
  [8766] = 8757,
  [8767] = 8708,
  [8768] = 6485,
  [8769] = 8759,
  [8770] = 3729,
  [8771] = 3782,
  [8772] = 3789,
  [8773] = 3780,
  [8774] = 3779,
  [8775] = 3753,
  [8776] = 8764,
  [8777] = 3730,
  [8778] = 3772,
  [8779] = 8779,
  [8780] = 8271,
  [8781] = 8306,
  [8782] = 3728,
  [8783] = 3731,
  [8784] = 8779,
  [8785] = 8764,
  [8786] = 8786,
  [8787] = 8757,
  [8788] = 3729,
  [8789] = 3770,
  [8790] = 8708,
  [8791] = 8791,
  [8792] = 3769,
  [8793] = 3760,
  [8794] = 3724,
  [8795] = 8759,
  [8796] = 3723,
  [8797] = 3728,
  [8798] = 3758,
  [8799] = 8779,
  [8800] = 8751,
  [8801] = 3731,
  [8802] = 3746,
  [8803] = 3777,
  [8804] = 3723,
  [8805] = 8805,
  [8806] = 3758,
  [8807] = 8750,
  [8808] = 3755,
  [8809] = 8398,
  [8810] = 3755,
  [8811] = 3762,
  [8812] = 8748,
  [8813] = 3761,
  [8814] = 8717,
  [8815] = 8447,
  [8816] = 3791,
  [8817] = 3747,
  [8818] = 8358,
  [8819] = 3744,
  [8820] = 6485,
  [8821] = 8356,
  [8822] = 3794,
  [8823] = 8271,
  [8824] = 8271,
  [8825] = 8235,
  [8826] = 8434,
  [8827] = 8427,
  [8828] = 3796,
  [8829] = 3723,
  [8830] = 8494,
  [8831] = 3758,
  [8832] = 6485,
  [8833] = 8271,
  [8834] = 8379,
  [8835] = 8333,
  [8836] = 8375,
  [8837] = 8443,
  [8838] = 3723,
  [8839] = 3729,
  [8840] = 8369,
  [8841] = 8488,
  [8842] = 8347,
  [8843] = 8332,
  [8844] = 8515,
  [8845] = 7155,
  [8846] = 8764,
  [8847] = 3746,
  [8848] = 3728,
  [8849] = 3755,
  [8850] = 3729,
  [8851] = 3723,
  [8852] = 8751,
  [8853] = 3806,
  [8854] = 8717,
  [8855] = 3724,
  [8856] = 3730,
  [8857] = 3730,
  [8858] = 8235,
  [8859] = 8426,
  [8860] = 8559,
  [8861] = 8414,
  [8862] = 8306,
  [8863] = 7051,
  [8864] = 3755,
  [8865] = 8306,
  [8866] = 8381,
  [8867] = 8378,
  [8868] = 8306,
  [8869] = 3729,
  [8870] = 8316,
  [8871] = 3724,
  [8872] = 6485,
  [8873] = 3775,
  [8874] = 3767,
  [8875] = 6485,
  [8876] = 3730,
  [8877] = 3731,
  [8878] = 3728,
  [8879] = 8764,
  [8880] = 8751,
  [8881] = 3731,
  [8882] = 8717,
  [8883] = 8324,
  [8884] = 3724,
  [8885] = 8271,
  [8886] = 6485,
  [8887] = 3755,
  [8888] = 8358,
  [8889] = 3796,
  [8890] = 3789,
  [8891] = 3746,
  [8892] = 8316,
  [8893] = 3758,
  [8894] = 3791,
  [8895] = 3767,
  [8896] = 3728,
  [8897] = 3794,
  [8898] = 3783,
  [8899] = 3806,
  [8900] = 8379,
  [8901] = 8306,
  [8902] = 3728,
  [8903] = 3767,
  [8904] = 8443,
  [8905] = 3730,
  [8906] = 3774,
  [8907] = 3815,
  [8908] = 3731,
  [8909] = 3777,
  [8910] = 3796,
  [8911] = 3815,
  [8912] = 8356,
  [8913] = 8369,
  [8914] = 3774,
  [8915] = 3781,
  [8916] = 3782,
  [8917] = 3778,
  [8918] = 3780,
  [8919] = 3779,
  [8920] = 3772,
  [8921] = 3769,
  [8922] = 3760,
  [8923] = 8378,
  [8924] = 3746,
  [8925] = 8306,
  [8926] = 3762,
  [8927] = 3761,
  [8928] = 3744,
  [8929] = 3806,
  [8930] = 3724,
  [8931] = 6485,
  [8932] = 3758,
  [8933] = 8375,
  [8934] = 3794,
  [8935] = 3782,
  [8936] = 3780,
  [8937] = 3731,
  [8938] = 3746,
  [8939] = 3783,
  [8940] = 8347,
  [8941] = 6485,
  [8942] = 3779,
  [8943] = 3791,
  [8944] = 3783,
  [8945] = 3730,
  [8946] = 8306,
  [8947] = 3806,
  [8948] = 3744,
  [8949] = 3761,
  [8950] = 3772,
  [8951] = 3762,
  [8952] = 3758,
  [8953] = 3777,
  [8954] = 3789,
  [8955] = 3744,
  [8956] = 3781,
  [8957] = 3769,
  [8958] = 3778,
  [8959] = 3761,
  [8960] = 3762,
  [8961] = 3760,
  [8962] = 3769,
  [8963] = 3772,
  [8964] = 3758,
  [8965] = 3783,
  [8966] = 3781,
  [8967] = 3772,
  [8968] = 3779,
  [8969] = 3778,
  [8970] = 3780,
  [8971] = 3782,
  [8972] = 3760,
  [8973] = 3769,
  [8974] = 3729,
  [8975] = 3774,
  [8976] = 3815,
  [8977] = 3772,
  [8978] = 8333,
  [8979] = 3746,
  [8980] = 3779,
  [8981] = 8332,
  [8982] = 3780,
  [8983] = 3755,
  [8984] = 3782,
  [8985] = 3767,
  [8986] = 3747,
  [8987] = 3806,
  [8988] = 3796,
  [8989] = 3794,
  [8990] = 3746,
  [8991] = 6485,
  [8992] = 3791,
  [8993] = 3731,
  [8994] = 3749,
  [8995] = 3750,
  [8996] = 3789,
  [8997] = 8414,
  [8998] = 3760,
  [8999] = 3751,
  [9000] = 3758,
  [9001] = 3757,
  [9002] = 8426,
  [9003] = 3774,
  [9004] = 3789,
  [9005] = 6485,
  [9006] = 3764,
  [9007] = 3815,
  [9008] = 8356,
  [9009] = 8358,
  [9010] = 3791,
  [9011] = 3765,
  [9012] = 3755,
  [9013] = 3794,
  [9014] = 3796,
  [9015] = 3754,
  [9016] = 8427,
  [9017] = 8434,
  [9018] = 3767,
  [9019] = 3728,
  [9020] = 3777,
  [9021] = 3770,
  [9022] = 3815,
  [9023] = 3774,
  [9024] = 3755,
  [9025] = 3761,
  [9026] = 8271,
  [9027] = 3775,
  [9028] = 8447,
  [9029] = 8263,
  [9030] = 3782,
  [9031] = 3780,
  [9032] = 3744,
  [9033] = 3779,
  [9034] = 8381,
  [9035] = 3777,
  [9036] = 3767,
  [9037] = 3761,
  [9038] = 3762,
  [9039] = 3769,
  [9040] = 8332,
  [9041] = 3753,
  [9042] = 3760,
  [9043] = 8347,
  [9044] = 8369,
  [9045] = 6485,
  [9046] = 3753,
  [9047] = 3730,
  [9048] = 3775,
  [9049] = 3744,
  [9050] = 3760,
  [9051] = 3744,
  [9052] = 3769,
  [9053] = 8443,
  [9054] = 3761,
  [9055] = 3762,
  [9056] = 3761,
  [9057] = 3744,
  [9058] = 3772,
  [9059] = 3779,
  [9060] = 3780,
  [9061] = 3724,
  [9062] = 8324,
  [9063] = 8235,
  [9064] = 3782,
  [9065] = 3774,
  [9066] = 3815,
  [9067] = 8375,
  [9068] = 8447,
  [9069] = 3729,
  [9070] = 3747,
  [9071] = 3778,
  [9072] = 8379,
  [9073] = 3781,
  [9074] = 3762,
  [9075] = 3749,
  [9076] = 3777,
  [9077] = 6485,
  [9078] = 3750,
  [9079] = 3789,
  [9080] = 3751,
  [9081] = 3806,
  [9082] = 3757,
  [9083] = 3791,
  [9084] = 3764,
  [9085] = 3783,
  [9086] = 3794,
  [9087] = 8434,
  [9088] = 3796,
  [9089] = 8427,
  [9090] = 8427,
  [9091] = 8414,
  [9092] = 3765,
  [9093] = 8426,
  [9094] = 3769,
  [9095] = 3754,
  [9096] = 3770,
  [9097] = 3775,
  [9098] = 3789,
  [9099] = 8434,
  [9100] = 8235,
  [9101] = 3789,
  [9102] = 3791,
  [9103] = 8398,
  [9104] = 3724,
  [9105] = 3794,
  [9106] = 8316,
  [9107] = 8263,
  [9108] = 8398,
  [9109] = 8378,
  [9110] = 3791,
  [9111] = 3806,
  [9112] = 8381,
  [9113] = 8379,
  [9114] = 3746,
  [9115] = 8333,
  [9116] = 3780,
  [9117] = 3789,
  [9118] = 3775,
  [9119] = 3782,
  [9120] = 8356,
  [9121] = 8375,
  [9122] = 9122,
  [9123] = 3794,
  [9124] = 3796,
  [9125] = 9125,
  [9126] = 3770,
  [9127] = 8324,
  [9128] = 8443,
  [9129] = 3778,
  [9130] = 3774,
  [9131] = 3753,
  [9132] = 3781,
  [9133] = 3755,
  [9134] = 8369,
  [9135] = 3723,
  [9136] = 8347,
  [9137] = 8332,
  [9138] = 8324,
  [9139] = 3755,
  [9140] = 3767,
  [9141] = 8447,
  [9142] = 3770,
  [9143] = 3754,
  [9144] = 3765,
  [9145] = 3764,
  [9146] = 3757,
  [9147] = 3755,
  [9148] = 3729,
  [9149] = 3754,
  [9150] = 3751,
  [9151] = 3765,
  [9152] = 8271,
  [9153] = 8426,
  [9154] = 6485,
  [9155] = 3750,
  [9156] = 3749,
  [9157] = 3764,
  [9158] = 3755,
  [9159] = 3758,
  [9160] = 3757,
  [9161] = 3747,
  [9162] = 3796,
  [9163] = 8426,
  [9164] = 3751,
  [9165] = 3729,
  [9166] = 8414,
  [9167] = 3783,
  [9168] = 8332,
  [9169] = 8347,
  [9170] = 3750,
  [9171] = 3749,
  [9172] = 3783,
  [9173] = 8369,
  [9174] = 8356,
  [9175] = 8358,
  [9176] = 3755,
  [9177] = 3781,
  [9178] = 8333,
  [9179] = 3747,
  [9180] = 8443,
  [9181] = 3778,
  [9182] = 3755,
  [9183] = 3731,
  [9184] = 3762,
  [9185] = 3781,
  [9186] = 3730,
  [9187] = 3747,
  [9188] = 3767,
  [9189] = 8324,
  [9190] = 3775,
  [9191] = 3775,
  [9192] = 3806,
  [9193] = 8375,
  [9194] = 8379,
  [9195] = 3783,
  [9196] = 3723,
  [9197] = 8381,
  [9198] = 8378,
  [9199] = 3755,
  [9200] = 3749,
  [9201] = 8398,
  [9202] = 3806,
  [9203] = 3750,
  [9204] = 8434,
  [9205] = 8447,
  [9206] = 3777,
  [9207] = 3815,
  [9208] = 8398,
  [9209] = 3751,
  [9210] = 3757,
  [9211] = 3778,
  [9212] = 3764,
  [9213] = 8316,
  [9214] = 8358,
  [9215] = 8356,
  [9216] = 8414,
  [9217] = 8324,
  [9218] = 8316,
  [9219] = 3765,
  [9220] = 3775,
  [9221] = 3754,
  [9222] = 3747,
  [9223] = 3777,
  [9224] = 8316,
  [9225] = 8378,
  [9226] = 3770,
  [9227] = 3781,
  [9228] = 3770,
  [9229] = 3783,
  [9230] = 3724,
  [9231] = 8381,
  [9232] = 3778,
  [9233] = 3754,
  [9234] = 3765,
  [9235] = 3764,
  [9236] = 3757,
  [9237] = 3781,
  [9238] = 3777,
  [9239] = 3729,
  [9240] = 3731,
  [9241] = 3778,
  [9242] = 3751,
  [9243] = 3750,
  [9244] = 3749,
  [9245] = 3747,
  [9246] = 3724,
  [9247] = 3724,
  [9248] = 3755,
  [9249] = 3744,
  [9250] = 9122,
  [9251] = 3806,
  [9252] = 3731,
  [9253] = 3761,
  [9254] = 3731,
  [9255] = 3775,
  [9256] = 3770,
  [9257] = 8447,
  [9258] = 3767,
  [9259] = 3774,
  [9260] = 3767,
  [9261] = 8434,
  [9262] = 3760,
  [9263] = 8398,
  [9264] = 8427,
  [9265] = 3770,
  [9266] = 3777,
  [9267] = 3729,
  [9268] = 9125,
  [9269] = 3754,
  [9270] = 3747,
  [9271] = 8271,
  [9272] = 3754,
  [9273] = 3755,
  [9274] = 3765,
  [9275] = 3796,
  [9276] = 3794,
  [9277] = 3815,
  [9278] = 8427,
  [9279] = 3782,
  [9280] = 3764,
  [9281] = 3723,
  [9282] = 8378,
  [9283] = 3757,
  [9284] = 3749,
  [9285] = 3750,
  [9286] = 3753,
  [9287] = 3751,
  [9288] = 3780,
  [9289] = 3796,
  [9290] = 3791,
  [9291] = 8379,
  [9292] = 8381,
  [9293] = 3750,
  [9294] = 3749,
  [9295] = 3794,
  [9296] = 3782,
  [9297] = 3780,
  [9298] = 3791,
  [9299] = 3779,
  [9300] = 3749,
  [9301] = 3750,
  [9302] = 3747,
  [9303] = 3772,
  [9304] = 3789,
  [9305] = 3769,
  [9306] = 3765,
  [9307] = 8375,
  [9308] = 3760,
  [9309] = 8333,
  [9310] = 8263,
  [9311] = 8358,
  [9312] = 3758,
  [9313] = 8443,
  [9314] = 3775,
  [9315] = 3772,
  [9316] = 3751,
  [9317] = 3728,
  [9318] = 3762,
  [9319] = 3774,
  [9320] = 3815,
  [9321] = 3757,
  [9322] = 3764,
  [9323] = 3764,
  [9324] = 3757,
  [9325] = 3765,
  [9326] = 3769,
  [9327] = 8369,
  [9328] = 3779,
  [9329] = 3761,
  [9330] = 3772,
  [9331] = 3754,
  [9332] = 3779,
  [9333] = 8426,
  [9334] = 3762,
  [9335] = 3760,
  [9336] = 6485,
  [9337] = 8333,
  [9338] = 3724,
  [9339] = 3751,
  [9340] = 3753,
  [9341] = 3729,
  [9342] = 3746,
  [9343] = 3744,
  [9344] = 8414,
  [9345] = 8347,
  [9346] = 8332,
  [9347] = 3770,
  [9348] = 3794,
  [9349] = 3758,
  [9350] = 8414,
  [9351] = 3765,
  [9352] = 3728,
  [9353] = 3731,
  [9354] = 3769,
  [9355] = 3789,
  [9356] = 3791,
  [9357] = 8356,
  [9358] = 8358,
  [9359] = 3780,
  [9360] = 3761,
  [9361] = 8333,
  [9362] = 3782,
  [9363] = 3744,
  [9364] = 3794,
  [9365] = 3796,
  [9366] = 3757,
  [9367] = 3777,
  [9368] = 3774,
  [9369] = 3767,
  [9370] = 8332,
  [9371] = 3775,
  [9372] = 8347,
  [9373] = 8369,
  [9374] = 3724,
  [9375] = 3765,
  [9376] = 3731,
  [9377] = 3770,
  [9378] = 8381,
  [9379] = 8378,
  [9380] = 8443,
  [9381] = 8398,
  [9382] = 8324,
  [9383] = 3724,
  [9384] = 8375,
  [9385] = 8379,
  [9386] = 3764,
  [9387] = 9125,
  [9388] = 3815,
  [9389] = 9122,
  [9390] = 3783,
  [9391] = 8263,
  [9392] = 3758,
  [9393] = 3729,
  [9394] = 3755,
  [9395] = 3746,
  [9396] = 3744,
  [9397] = 3761,
  [9398] = 8306,
  [9399] = 8316,
  [9400] = 3770,
  [9401] = 3789,
  [9402] = 3754,
  [9403] = 8271,
  [9404] = 3779,
  [9405] = 3730,
  [9406] = 3754,
  [9407] = 3781,
  [9408] = 3765,
  [9409] = 3778,
  [9410] = 3772,
  [9411] = 3762,
  [9412] = 3764,
  [9413] = 3757,
  [9414] = 3791,
  [9415] = 3780,
  [9416] = 3760,
  [9417] = 3751,
  [9418] = 3760,
  [9419] = 3750,
  [9420] = 3749,
  [9421] = 3772,
  [9422] = 3779,
  [9423] = 3747,
  [9424] = 3815,
  [9425] = 8427,
  [9426] = 8434,
  [9427] = 8447,
  [9428] = 3762,
  [9429] = 3782,
  [9430] = 3729,
  [9431] = 3794,
  [9432] = 3796,
  [9433] = 3753,
  [9434] = 3774,
  [9435] = 3767,
  [9436] = 3744,
  [9437] = 3761,
  [9438] = 3806,
  [9439] = 3769,
  [9440] = 3789,
  [9441] = 3751,
  [9442] = 3755,
  [9443] = 3777,
  [9444] = 3791,
  [9445] = 3780,
  [9446] = 3782,
  [9447] = 3747,
  [9448] = 3770,
  [9449] = 3783,
  [9450] = 3749,
  [9451] = 3750,
  [9452] = 3754,
  [9453] = 3794,
  [9454] = 3751,
  [9455] = 3757,
  [9456] = 3764,
  [9457] = 3764,
  [9458] = 3757,
  [9459] = 3781,
  [9460] = 3765,
  [9461] = 3778,
  [9462] = 3754,
  [9463] = 3751,
  [9464] = 3770,
  [9465] = 3750,
  [9466] = 3749,
  [9467] = 3747,
  [9468] = 3796,
  [9469] = 3723,
  [9470] = 3765,
  [9471] = 3774,
  [9472] = 3777,
  [9473] = 3767,
  [9474] = 3769,
  [9475] = 3783,
  [9476] = 8316,
  [9477] = 3783,
  [9478] = 3806,
  [9479] = 8381,
  [9480] = 8398,
  [9481] = 8263,
  [9482] = 3781,
  [9483] = 3767,
  [9484] = 3774,
  [9485] = 3796,
  [9486] = 3777,
  [9487] = 3794,
  [9488] = 3782,
  [9489] = 3780,
  [9490] = 3778,
  [9491] = 8378,
  [9492] = 3791,
  [9493] = 8414,
  [9494] = 3747,
  [9495] = 3775,
  [9496] = 6485,
  [9497] = 3789,
  [9498] = 3769,
  [9499] = 3775,
  [9500] = 3777,
  [9501] = 3760,
  [9502] = 8333,
  [9503] = 3750,
  [9504] = 3761,
  [9505] = 3744,
  [9506] = 3772,
  [9507] = 8358,
  [9508] = 3775,
  [9509] = 3749,
  [9510] = 8356,
  [9511] = 3781,
  [9512] = 3729,
  [9513] = 3778,
  [9514] = 3779,
  [9515] = 3753,
  [9516] = 3815,
  [9517] = 8426,
  [9518] = 8447,
  [9519] = 3762,
  [9520] = 3746,
  [9521] = 8332,
  [9522] = 3744,
  [9523] = 3761,
  [9524] = 8347,
  [9525] = 3762,
  [9526] = 3758,
  [9527] = 8369,
  [9528] = 8379,
  [9529] = 3760,
  [9530] = 3806,
  [9531] = 8434,
  [9532] = 3772,
  [9533] = 8324,
  [9534] = 3779,
  [9535] = 3760,
  [9536] = 3769,
  [9537] = 8427,
  [9538] = 8375,
  [9539] = 3815,
  [9540] = 3755,
  [9541] = 3772,
  [9542] = 3779,
  [9543] = 8443,
  [9544] = 3780,
  [9545] = 3782,
  [9546] = 3755,
  [9547] = 3806,
  [9548] = 3806,
  [9549] = 3774,
  [9550] = 3815,
  [9551] = 3762,
  [9552] = 8306,
  [9553] = 8379,
  [9554] = 3731,
  [9555] = 3767,
  [9556] = 3724,
  [9557] = 3815,
  [9558] = 3774,
  [9559] = 3806,
  [9560] = 3782,
  [9561] = 3780,
  [9562] = 3791,
  [9563] = 3779,
  [9564] = 3772,
  [9565] = 3753,
  [9566] = 3789,
  [9567] = 3769,
  [9568] = 3760,
  [9569] = 3762,
  [9570] = 8375,
  [9571] = 3761,
  [9572] = 3724,
  [9573] = 3744,
  [9574] = 3728,
  [9575] = 3767,
  [9576] = 8443,
  [9577] = 3789,
  [9578] = 3730,
  [9579] = 3749,
  [9580] = 3750,
  [9581] = 3815,
  [9582] = 8369,
  [9583] = 3791,
  [9584] = 3729,
  [9585] = 8347,
  [9586] = 3794,
  [9587] = 3796,
  [9588] = 3796,
  [9589] = 8332,
  [9590] = 8427,
  [9591] = 3767,
  [9592] = 8426,
  [9593] = 8414,
  [9594] = 8434,
  [9595] = 3796,
  [9596] = 3747,
  [9597] = 3794,
  [9598] = 8333,
  [9599] = 3746,
  [9600] = 3782,
  [9601] = 3770,
  [9602] = 3780,
  [9603] = 3791,
  [9604] = 3754,
  [9605] = 3779,
  [9606] = 8271,
  [9607] = 3772,
  [9608] = 8426,
  [9609] = 3789,
  [9610] = 3769,
  [9611] = 3783,
  [9612] = 3760,
  [9613] = 3762,
  [9614] = 3761,
  [9615] = 3744,
  [9616] = 3758,
  [9617] = 8447,
  [9618] = 3755,
  [9619] = 3731,
  [9620] = 3746,
  [9621] = 8324,
  [9622] = 3755,
  [9623] = 8381,
  [9624] = 8378,
  [9625] = 3777,
  [9626] = 8316,
  [9627] = 3806,
  [9628] = 3778,
  [9629] = 3775,
  [9630] = 3751,
  [9631] = 8356,
  [9632] = 8358,
  [9633] = 3723,
  [9634] = 3747,
  [9635] = 3775,
  [9636] = 3775,
  [9637] = 3755,
  [9638] = 3749,
  [9639] = 3770,
  [9640] = 3783,
  [9641] = 3754,
  [9642] = 8398,
  [9643] = 3765,
  [9644] = 3764,
  [9645] = 3757,
  [9646] = 3781,
  [9647] = 3778,
  [9648] = 3751,
  [9649] = 3750,
  [9650] = 3749,
  [9651] = 3747,
  [9652] = 3728,
  [9653] = 3750,
  [9654] = 3730,
  [9655] = 3751,
  [9656] = 3770,
  [9657] = 3755,
  [9658] = 3783,
  [9659] = 3781,
  [9660] = 3764,
  [9661] = 3754,
  [9662] = 3765,
  [9663] = 3778,
  [9664] = 3774,
  [9665] = 3764,
  [9666] = 3757,
  [9667] = 3781,
  [9668] = 3777,
  [9669] = 3757,
  [9670] = 8358,
  [9671] = 8333,
  [9672] = 8356,
  [9673] = 3758,
  [9674] = 3746,
  [9675] = 8263,
  [9676] = 8263,
  [9677] = 8414,
  [9678] = 3755,
  [9679] = 8381,
  [9680] = 8426,
  [9681] = 3777,
  [9682] = 3806,
  [9683] = 8378,
  [9684] = 3794,
  [9685] = 8398,
  [9686] = 3762,
  [9687] = 3778,
  [9688] = 3781,
  [9689] = 3783,
  [9690] = 3747,
  [9691] = 3753,
  [9692] = 3750,
  [9693] = 3751,
  [9694] = 3749,
  [9695] = 3764,
  [9696] = 8332,
  [9697] = 8347,
  [9698] = 8316,
  [9699] = 8369,
  [9700] = 3765,
  [9701] = 3754,
  [9702] = 3747,
  [9703] = 3770,
  [9704] = 3774,
  [9705] = 8443,
  [9706] = 3747,
  [9707] = 3758,
  [9708] = 3749,
  [9709] = 3750,
  [9710] = 3746,
  [9711] = 3749,
  [9712] = 3750,
  [9713] = 8324,
  [9714] = 8482,
  [9715] = 8263,
  [9716] = 3751,
  [9717] = 3760,
  [9718] = 3751,
  [9719] = 8375,
  [9720] = 3757,
  [9721] = 3757,
  [9722] = 3764,
  [9723] = 3767,
  [9724] = 3815,
  [9725] = 3765,
  [9726] = 3754,
  [9727] = 3764,
  [9728] = 3796,
  [9729] = 3770,
  [9730] = 3794,
  [9731] = 3791,
  [9732] = 3779,
  [9733] = 3772,
  [9734] = 3765,
  [9735] = 3789,
  [9736] = 3806,
  [9737] = 8379,
  [9738] = 3754,
  [9739] = 3760,
  [9740] = 3757,
  [9741] = 3770,
  [9742] = 3774,
  [9743] = 3782,
  [9744] = 3767,
  [9745] = 3755,
  [9746] = 3731,
  [9747] = 3780,
  [9748] = 3724,
  [9749] = 3769,
  [9750] = 3783,
  [9751] = 3723,
  [9752] = 3761,
  [9753] = 3755,
  [9754] = 3744,
  [9755] = 3781,
  [9756] = 3778,
  [9757] = 3772,
  [9758] = 3775,
  [9759] = 3762,
  [9760] = 8235,
  [9761] = 3777,
  [9762] = 3777,
  [9763] = 8263,
  [9764] = 8427,
  [9765] = 8263,
  [9766] = 8263,
  [9767] = 8434,
  [9768] = 3755,
  [9769] = 8263,
  [9770] = 8263,
  [9771] = 3815,
  [9772] = 3778,
  [9773] = 3781,
  [9774] = 3806,
  [9775] = 3783,
  [9776] = 3730,
  [9777] = 3728,
  [9778] = 3747,
  [9779] = 3749,
  [9780] = 3750,
  [9781] = 3751,
  [9782] = 3729,
  [9783] = 3757,
  [9784] = 3764,
  [9785] = 3775,
  [9786] = 3765,
  [9787] = 8263,
  [9788] = 3753,
  [9789] = 3754,
  [9790] = 3744,
  [9791] = 3761,
  [9792] = 3770,
  [9793] = 3779,
  [9794] = 3783,
  [9795] = 3769,
  [9796] = 3789,
  [9797] = 8447,
  [9798] = 3791,
  [9799] = 3780,
  [9800] = 3791,
  [9801] = 3782,
  [9802] = 3794,
  [9803] = 3775,
  [9804] = 3723,
  [9805] = 8398,
  [9806] = 3796,
  [9807] = 3806,
  [9808] = 3815,
  [9809] = 8358,
  [9810] = 3781,
  [9811] = 3779,
  [9812] = 3778,
  [9813] = 8356,
  [9814] = 3796,
  [9815] = 3772,
  [9816] = 3794,
  [9817] = 3774,
  [9818] = 3782,
  [9819] = 3780,
  [9820] = 3755,
  [9821] = 8324,
  [9822] = 3760,
  [9823] = 3767,
  [9824] = 3730,
  [9825] = 3815,
  [9826] = 3762,
  [9827] = 3789,
  [9828] = 3779,
  [9829] = 3772,
  [9830] = 3728,
  [9831] = 8447,
  [9832] = 8434,
  [9833] = 8427,
  [9834] = 3760,
  [9835] = 8263,
  [9836] = 8443,
  [9837] = 8379,
  [9838] = 3796,
  [9839] = 8375,
  [9840] = 3762,
  [9841] = 3758,
  [9842] = 3744,
  [9843] = 3761,
  [9844] = 8369,
  [9845] = 8347,
  [9846] = 3774,
  [9847] = 8332,
  [9848] = 8426,
  [9849] = 3775,
  [9850] = 3767,
  [9851] = 8414,
  [9852] = 3777,
  [9853] = 8333,
  [9854] = 8381,
  [9855] = 8378,
  [9856] = 3769,
  [9857] = 3789,
  [9858] = 8316,
  [9859] = 3744,
  [9860] = 3746,
  [9861] = 3761,
  [9862] = 3769,
  [9863] = 3791,
  [9864] = 3780,
  [9865] = 3782,
  [9866] = 9866,
  [9867] = 3757,
  [9868] = 9868,
  [9869] = 9866,
  [9870] = 9868,
  [9871] = 9868,
  [9872] = 9868,
  [9873] = 9868,
  [9874] = 9874,
  [9875] = 9866,
  [9876] = 9868,
  [9877] = 9874,
  [9878] = 9868,
  [9879] = 9868,
  [9880] = 9880,
  [9881] = 9880,
  [9882] = 9868,
  [9883] = 9868,
  [9884] = 9880,
  [9885] = 9874,
  [9886] = 9874,
  [9887] = 9866,
  [9888] = 9866,
  [9889] = 8263,
  [9890] = 9874,
  [9891] = 9868,
  [9892] = 9868,
  [9893] = 9868,
  [9894] = 9868,
  [9895] = 9868,
  [9896] = 8263,
  [9897] = 9874,
  [9898] = 9880,
  [9899] = 9868,
  [9900] = 9868,
  [9901] = 9868,
  [9902] = 9866,
  [9903] = 9880,
  [9904] = 9868,
  [9905] = 9868,
  [9906] = 9868,
  [9907] = 9868,
  [9908] = 9868,
  [9909] = 9868,
  [9910] = 9868,
  [9911] = 3777,
  [9912] = 9868,
  [9913] = 9868,
  [9914] = 9868,
  [9915] = 3746,
  [9916] = 9868,
  [9917] = 9868,
  [9918] = 9868,
  [9919] = 9868,
  [9920] = 9866,
  [9921] = 9868,
  [9922] = 9874,
  [9923] = 9868,
  [9924] = 9880,
  [9925] = 9868,
  [9926] = 9880,
  [9927] = 3744,
  [9928] = 9880,
  [9929] = 9868,
  [9930] = 9868,
  [9931] = 9868,
  [9932] = 3806,
  [9933] = 9874,
  [9934] = 3761,
  [9935] = 9866,
  [9936] = 9868,
  [9937] = 9868,
  [9938] = 9868,
  [9939] = 9866,
  [9940] = 9874,
  [9941] = 9874,
  [9942] = 9942,
  [9943] = 9866,
  [9944] = 9868,
  [9945] = 9868,
  [9946] = 9868,
  [9947] = 9868,
  [9948] = 9868,
  [9949] = 9880,
  [9950] = 9868,
  [9951] = 9866,
  [9952] = 9868,
  [9953] = 9880,
  [9954] = 9874,
  [9955] = 9868,
  [9956] = 9868,
  [9957] = 9957,
  [9958] = 9874,
  [9959] = 9866,
  [9960] = 9868,
  [9961] = 9880,
  [9962] = 9868,
  [9963] = 9866,
  [9964] = 9868,
  [9965] = 9868,
  [9966] = 9874,
  [9967] = 3769,
  [9968] = 3758,
  [9969] = 9880,
  [9970] = 9868,
  [9971] = 3729,
  [9972] = 3789,
  [9973] = 9868,
  [9974] = 9880,
  [9975] = 9868,
  [9976] = 9880,
  [9977] = 9868,
  [9978] = 9868,
  [9979] = 9866,
  [9980] = 9874,
  [9981] = 9866,
  [9982] = 9868,
  [9983] = 9880,
  [9984] = 9868,
  [9985] = 9874,
  [9986] = 9880,
  [9987] = 9866,
  [9988] = 3775,
  [9989] = 9868,
  [9990] = 9874,
  [9991] = 9868,
  [9992] = 9874,
  [9993] = 9874,
  [9994] = 8263,
  [9995] = 9866,
  [9996] = 9868,
  [9997] = 9868,
  [9998] = 9866,
  [9999] = 9880,
  [10000] = 9868,
  [10001] = 9866,
  [10002] = 9868,
  [10003] = 9874,
  [10004] = 9868,
  [10005] = 9880,
  [10006] = 9868,
  [10007] = 9942,
  [10008] = 9866,
  [10009] = 9868,
  [10010] = 9880,
  [10011] = 9866,
  [10012] = 9868,
  [10013] = 10013,
  [10014] = 9874,
  [10015] = 10015,
  [10016] = 9874,
  [10017] = 9866,
  [10018] = 9866,
  [10019] = 9880,
  [10020] = 9868,
  [10021] = 9868,
  [10022] = 9868,
  [10023] = 9868,
  [10024] = 10024,
  [10025] = 10025,
  [10026] = 9868,
  [10027] = 9874,
  [10028] = 9866,
  [10029] = 9868,
  [10030] = 9874,
  [10031] = 3762,
  [10032] = 9880,
  [10033] = 3747,
  [10034] = 9868,
  [10035] = 9880,
  [10036] = 9880,
  [10037] = 9868,
  [10038] = 9874,
  [10039] = 9880,
  [10040] = 9866,
  [10041] = 9874,
  [10042] = 9866,
  [10043] = 3724,
  [10044] = 9866,
  [10045] = 9868,
  [10046] = 9868,
  [10047] = 9868,
  [10048] = 9866,
  [10049] = 3760,
  [10050] = 9868,
  [10051] = 9874,
  [10052] = 9868,
  [10053] = 9880,
  [10054] = 9868,
  [10055] = 9942,
  [10056] = 9880,
  [10057] = 9868,
  [10058] = 9874,
  [10059] = 3755,
  [10060] = 3731,
  [10061] = 9880,
  [10062] = 9868,
  [10063] = 9868,
  [10064] = 8263,
  [10065] = 9874,
  [10066] = 9868,
  [10067] = 9866,
  [10068] = 9868,
  [10069] = 9942,
  [10070] = 3758,
  [10071] = 9868,
  [10072] = 9868,
  [10073] = 9868,
  [10074] = 9868,
  [10075] = 3772,
  [10076] = 3779,
  [10077] = 8263,
  [10078] = 9868,
  [10079] = 9868,
  [10080] = 9866,
  [10081] = 9868,
  [10082] = 9866,
  [10083] = 9868,
  [10084] = 9942,
  [10085] = 9874,
  [10086] = 9866,
  [10087] = 9880,
  [10088] = 9868,
  [10089] = 9874,
  [10090] = 9942,
  [10091] = 3746,
  [10092] = 9874,
  [10093] = 9880,
  [10094] = 9942,
  [10095] = 9868,
  [10096] = 9874,
  [10097] = 9868,
  [10098] = 9880,
  [10099] = 9868,
  [10100] = 9880,
  [10101] = 9868,
  [10102] = 9868,
  [10103] = 3770,
  [10104] = 9874,
  [10105] = 3783,
  [10106] = 9868,
  [10107] = 9880,
  [10108] = 9866,
  [10109] = 9866,
  [10110] = 9868,
  [10111] = 9868,
  [10112] = 9868,
  [10113] = 3791,
  [10114] = 9868,
  [10115] = 3780,
  [10116] = 9868,
  [10117] = 9880,
  [10118] = 8306,
  [10119] = 9880,
  [10120] = 8271,
  [10121] = 9868,
  [10122] = 9868,
  [10123] = 8263,
  [10124] = 3782,
  [10125] = 9874,
  [10126] = 3794,
  [10127] = 3796,
  [10128] = 3749,
  [10129] = 9868,
  [10130] = 9868,
  [10131] = 9880,
  [10132] = 9874,
  [10133] = 9868,
  [10134] = 9866,
  [10135] = 9866,
  [10136] = 9868,
  [10137] = 9866,
  [10138] = 3815,
  [10139] = 3750,
  [10140] = 9874,
  [10141] = 9868,
  [10142] = 9868,
  [10143] = 9866,
  [10144] = 9868,
  [10145] = 9868,
  [10146] = 9880,
  [10147] = 9874,
  [10148] = 9868,
  [10149] = 9868,
  [10150] = 8263,
  [10151] = 8263,
  [10152] = 8263,
  [10153] = 9874,
  [10154] = 8263,
  [10155] = 8263,
  [10156] = 9880,
  [10157] = 8263,
  [10158] = 9868,
  [10159] = 3781,
  [10160] = 9880,
  [10161] = 9880,
  [10162] = 8263,
  [10163] = 9868,
  [10164] = 9874,
  [10165] = 9868,
  [10166] = 9868,
  [10167] = 9868,
  [10168] = 8263,
  [10169] = 3778,
  [10170] = 10013,
  [10171] = 9874,
  [10172] = 9942,
  [10173] = 9868,
  [10174] = 9868,
  [10175] = 10025,
  [10176] = 3755,
  [10177] = 3767,
  [10178] = 9942,
  [10179] = 9868,
  [10180] = 9866,
  [10181] = 3754,
  [10182] = 9868,
  [10183] = 9868,
  [10184] = 9868,
  [10185] = 9866,
  [10186] = 9868,
  [10187] = 9942,
  [10188] = 3765,
  [10189] = 10015,
  [10190] = 3774,
  [10191] = 10024,
  [10192] = 9868,
  [10193] = 9868,
  [10194] = 9880,
  [10195] = 9942,
  [10196] = 10013,
  [10197] = 10015,
  [10198] = 9868,
  [10199] = 9874,
  [10200] = 9866,
  [10201] = 9868,
  [10202] = 9942,
  [10203] = 9942,
  [10204] = 9942,
  [10205] = 10024,
  [10206] = 9874,
  [10207] = 9880,
  [10208] = 3751,
  [10209] = 9880,
  [10210] = 9868,
  [10211] = 9880,
  [10212] = 9874,
  [10213] = 9868,
  [10214] = 9874,
  [10215] = 9880,
  [10216] = 9880,
  [10217] = 8263,
  [10218] = 9866,
  [10219] = 9880,
  [10220] = 10025,
  [10221] = 9874,
  [10222] = 9866,
  [10223] = 9868,
  [10224] = 9868,
  [10225] = 9874,
  [10226] = 9868,
  [10227] = 9866,
  [10228] = 9866,
  [10229] = 9868,
  [10230] = 9868,
  [10231] = 3764,
  [10232] = 9868,
  [10233] = 9868,
  [10234] = 9866,
  [10235] = 10235,
  [10236] = 10236,
  [10237] = 10236,
  [10238] = 10238,
  [10239] = 10236,
  [10240] = 10236,
  [10241] = 3723,
  [10242] = 3755,
  [10243] = 10236,
  [10244] = 10236,
  [10245] = 10245,
  [10246] = 10236,
  [10247] = 10238,
  [10248] = 10238,
  [10249] = 10245,
  [10250] = 10238,
  [10251] = 10245,
  [10252] = 3723,
  [10253] = 8426,
  [10254] = 10236,
  [10255] = 10238,
  [10256] = 10245,
  [10257] = 10238,
  [10258] = 10236,
  [10259] = 10238,
  [10260] = 10238,
  [10261] = 10245,
  [10262] = 8414,
  [10263] = 10236,
  [10264] = 10245,
  [10265] = 10245,
  [10266] = 10245,
  [10267] = 10245,
  [10268] = 3789,
  [10269] = 3755,
  [10270] = 10238,
  [10271] = 3791,
  [10272] = 10272,
  [10273] = 3769,
  [10274] = 10245,
  [10275] = 10245,
  [10276] = 3730,
  [10277] = 10238,
  [10278] = 10245,
  [10279] = 3780,
  [10280] = 3770,
  [10281] = 10238,
  [10282] = 10236,
  [10283] = 3782,
  [10284] = 8333,
  [10285] = 3794,
  [10286] = 3796,
  [10287] = 10238,
  [10288] = 10236,
  [10289] = 10289,
  [10290] = 10236,
  [10291] = 10236,
  [10292] = 10236,
  [10293] = 10238,
  [10294] = 3778,
  [10295] = 10238,
  [10296] = 10245,
  [10297] = 3781,
  [10298] = 8332,
  [10299] = 10245,
  [10300] = 10245,
  [10301] = 6485,
  [10302] = 8347,
  [10303] = 8263,
  [10304] = 10238,
  [10305] = 3753,
  [10306] = 10245,
  [10307] = 10236,
  [10308] = 10245,
  [10309] = 3774,
  [10310] = 10238,
  [10311] = 10245,
  [10312] = 3767,
  [10313] = 8369,
  [10314] = 10238,
  [10315] = 8263,
  [10316] = 8381,
  [10317] = 10236,
  [10318] = 8378,
  [10319] = 10236,
  [10320] = 10238,
  [10321] = 10238,
  [10322] = 3754,
  [10323] = 8443,
  [10324] = 10236,
  [10325] = 3728,
  [10326] = 10236,
  [10327] = 10245,
  [10328] = 10238,
  [10329] = 10245,
  [10330] = 10236,
  [10331] = 10238,
  [10332] = 10238,
  [10333] = 10236,
  [10334] = 3761,
  [10335] = 10236,
  [10336] = 3744,
  [10337] = 10245,
  [10338] = 8375,
  [10339] = 10238,
  [10340] = 3728,
  [10341] = 8379,
  [10342] = 3765,
  [10343] = 10238,
  [10344] = 10245,
  [10345] = 10245,
  [10346] = 10238,
  [10347] = 10236,
  [10348] = 8263,
  [10349] = 3731,
  [10350] = 10245,
  [10351] = 8324,
  [10352] = 8398,
  [10353] = 10245,
  [10354] = 10245,
  [10355] = 6485,
  [10356] = 10238,
  [10357] = 10236,
  [10358] = 10236,
  [10359] = 10359,
  [10360] = 10236,
  [10361] = 3783,
  [10362] = 10236,
  [10363] = 10238,
  [10364] = 3730,
  [10365] = 3764,
  [10366] = 10236,
  [10367] = 10245,
  [10368] = 3724,
  [10369] = 3757,
  [10370] = 10238,
  [10371] = 3729,
  [10372] = 10238,
  [10373] = 10245,
  [10374] = 10245,
  [10375] = 10245,
  [10376] = 10245,
  [10377] = 3751,
  [10378] = 10238,
  [10379] = 3747,
  [10380] = 10236,
  [10381] = 10245,
  [10382] = 3806,
  [10383] = 10236,
  [10384] = 10236,
  [10385] = 10238,
  [10386] = 8263,
  [10387] = 10236,
  [10388] = 10236,
  [10389] = 3731,
  [10390] = 3775,
  [10391] = 10238,
  [10392] = 10236,
  [10393] = 10245,
  [10394] = 8447,
  [10395] = 10245,
  [10396] = 3724,
  [10397] = 10238,
  [10398] = 10238,
  [10399] = 8263,
  [10400] = 10238,
  [10401] = 10245,
  [10402] = 8358,
  [10403] = 10245,
  [10404] = 10245,
  [10405] = 8356,
  [10406] = 3729,
  [10407] = 3762,
  [10408] = 10245,
  [10409] = 10238,
  [10410] = 10238,
  [10411] = 10236,
  [10412] = 10245,
  [10413] = 10236,
  [10414] = 3777,
  [10415] = 3815,
  [10416] = 10416,
  [10417] = 10236,
  [10418] = 10238,
  [10419] = 10238,
  [10420] = 10236,
  [10421] = 10245,
  [10422] = 3779,
  [10423] = 10238,
  [10424] = 10236,
  [10425] = 3755,
  [10426] = 3750,
  [10427] = 10236,
  [10428] = 8316,
  [10429] = 10236,
  [10430] = 10245,
  [10431] = 10238,
  [10432] = 10238,
  [10433] = 10238,
  [10434] = 3760,
  [10435] = 10236,
  [10436] = 3772,
  [10437] = 10245,
  [10438] = 10238,
  [10439] = 10439,
  [10440] = 3749,
  [10441] = 10245,
  [10442] = 10245,
  [10443] = 8427,
  [10444] = 8434,
  [10445] = 10236,
  [10446] = 10245,
  [10447] = 10238,
  [10448] = 10238,
  [10449] = 10245,
  [10450] = 10236,
  [10451] = 10236,
  [10452] = 3781,
  [10453] = 3770,
  [10454] = 3744,
  [10455] = 3747,
  [10456] = 9942,
  [10457] = 10457,
  [10458] = 10458,
  [10459] = 10459,
  [10460] = 3772,
  [10461] = 3782,
  [10462] = 3754,
  [10463] = 9942,
  [10464] = 3746,
  [10465] = 10459,
  [10466] = 9942,
  [10467] = 9942,
  [10468] = 10468,
  [10469] = 9942,
  [10470] = 4321,
  [10471] = 3769,
  [10472] = 3751,
  [10473] = 9942,
  [10474] = 3789,
  [10475] = 9942,
  [10476] = 10459,
  [10477] = 3796,
  [10478] = 3794,
  [10479] = 3782,
  [10480] = 3780,
  [10481] = 10481,
  [10482] = 3774,
  [10483] = 3767,
  [10484] = 8453,
  [10485] = 3779,
  [10486] = 3775,
  [10487] = 3810,
  [10488] = 3765,
  [10489] = 3791,
  [10490] = 3757,
  [10491] = 10491,
  [10492] = 10492,
  [10493] = 9942,
  [10494] = 9942,
  [10495] = 3760,
  [10496] = 3758,
  [10497] = 9942,
  [10498] = 3772,
  [10499] = 9942,
  [10500] = 3777,
  [10501] = 3762,
  [10502] = 3747,
  [10503] = 9942,
  [10504] = 10504,
  [10505] = 10505,
  [10506] = 3794,
  [10507] = 3806,
  [10508] = 3764,
  [10509] = 3764,
  [10510] = 10510,
  [10511] = 10272,
  [10512] = 9942,
  [10513] = 9942,
  [10514] = 3806,
  [10515] = 3778,
  [10516] = 3762,
  [10517] = 3780,
  [10518] = 3750,
  [10519] = 9942,
  [10520] = 3781,
  [10521] = 10458,
  [10522] = 3753,
  [10523] = 3760,
  [10524] = 8263,
  [10525] = 10457,
  [10526] = 10526,
  [10527] = 3745,
  [10528] = 9942,
  [10529] = 3765,
  [10530] = 10468,
  [10531] = 3749,
  [10532] = 3757,
  [10533] = 3749,
  [10534] = 9942,
  [10535] = 3761,
  [10536] = 3815,
  [10537] = 3750,
  [10538] = 9942,
  [10539] = 9942,
  [10540] = 9942,
  [10541] = 3754,
  [10542] = 3791,
  [10543] = 10543,
  [10544] = 3789,
  [10545] = 9942,
  [10546] = 10468,
  [10547] = 3769,
  [10548] = 10235,
  [10549] = 3746,
  [10550] = 3779,
  [10551] = 3744,
  [10552] = 10504,
  [10553] = 3767,
  [10554] = 10458,
  [10555] = 3778,
  [10556] = 9942,
  [10557] = 3751,
  [10558] = 3783,
  [10559] = 8342,
  [10560] = 3774,
  [10561] = 9942,
  [10562] = 3796,
  [10563] = 3753,
  [10564] = 9942,
  [10565] = 3777,
  [10566] = 9942,
  [10567] = 10457,
  [10568] = 9942,
  [10569] = 3775,
  [10570] = 9942,
  [10571] = 8395,
  [10572] = 8263,
  [10573] = 9942,
  [10574] = 3761,
  [10575] = 3758,
  [10576] = 9942,
  [10577] = 3815,
  [10578] = 3770,
  [10579] = 9942,
  [10580] = 9942,
  [10581] = 9942,
  [10582] = 3783,
  [10583] = 10481,
  [10584] = 3723,
  [10585] = 3850,
  [10586] = 3875,
  [10587] = 3849,
  [10588] = 3844,
  [10589] = 3862,
  [10590] = 3825,
  [10591] = 3851,
  [10592] = 3861,
  [10593] = 10505,
  [10594] = 3856,
  [10595] = 3857,
  [10596] = 3867,
  [10597] = 3832,
  [10598] = 3860,
  [10599] = 10543,
  [10600] = 10543,
  [10601] = 10505,
  [10602] = 3874,
  [10603] = 3853,
  [10604] = 3843,
  [10605] = 3846,
  [10606] = 3745,
  [10607] = 3841,
  [10608] = 3839,
  [10609] = 3870,
  [10610] = 3829,
  [10611] = 3830,
  [10612] = 10491,
  [10613] = 3842,
  [10614] = 3838,
  [10615] = 3826,
  [10616] = 3833,
  [10617] = 3859,
  [10618] = 3836,
  [10619] = 3835,
  [10620] = 3844,
  [10621] = 3861,
  [10622] = 3833,
  [10623] = 3728,
  [10624] = 4099,
  [10625] = 3832,
  [10626] = 10272,
  [10627] = 4078,
  [10628] = 4081,
  [10629] = 3731,
  [10630] = 3829,
  [10631] = 4085,
  [10632] = 8482,
  [10633] = 4086,
  [10634] = 3724,
  [10635] = 10272,
  [10636] = 3836,
  [10637] = 10637,
  [10638] = 4100,
  [10639] = 3826,
  [10640] = 3838,
  [10641] = 4087,
  [10642] = 3839,
  [10643] = 10643,
  [10644] = 3841,
  [10645] = 3842,
  [10646] = 3843,
  [10647] = 3846,
  [10648] = 10648,
  [10649] = 4088,
  [10650] = 3830,
  [10651] = 4089,
  [10652] = 3849,
  [10653] = 10439,
  [10654] = 4094,
  [10655] = 3850,
  [10656] = 3825,
  [10657] = 10657,
  [10658] = 4110,
  [10659] = 4135,
  [10660] = 8453,
  [10661] = 3835,
  [10662] = 6485,
  [10663] = 3755,
  [10664] = 3851,
  [10665] = 3853,
  [10666] = 3856,
  [10667] = 4111,
  [10668] = 3857,
  [10669] = 3859,
  [10670] = 4093,
  [10671] = 4112,
  [10672] = 10672,
  [10673] = 3860,
  [10674] = 3730,
  [10675] = 3723,
  [10676] = 10289,
  [10677] = 4083,
  [10678] = 3870,
  [10679] = 3867,
  [10680] = 3875,
  [10681] = 4097,
  [10682] = 10682,
  [10683] = 10683,
  [10684] = 3729,
  [10685] = 4095,
  [10686] = 3862,
  [10687] = 10272,
  [10688] = 3874,
  [10689] = 3729,
  [10690] = 4100,
  [10691] = 3761,
  [10692] = 10505,
  [10693] = 3769,
  [10694] = 3789,
  [10695] = 3730,
  [10696] = 4112,
  [10697] = 4111,
  [10698] = 10698,
  [10699] = 3723,
  [10700] = 10491,
  [10701] = 3728,
  [10702] = 3764,
  [10703] = 3758,
  [10704] = 10704,
  [10705] = 10705,
  [10706] = 10706,
  [10707] = 10272,
  [10708] = 3753,
  [10709] = 4110,
  [10710] = 10272,
  [10711] = 3745,
  [10712] = 3791,
  [10713] = 10481,
  [10714] = 10272,
  [10715] = 10715,
  [10716] = 10543,
  [10717] = 3780,
  [10718] = 3782,
  [10719] = 10705,
  [10720] = 3775,
  [10721] = 10272,
  [10722] = 3815,
  [10723] = 10723,
  [10724] = 10272,
  [10725] = 10272,
  [10726] = 3794,
  [10727] = 3779,
  [10728] = 3778,
  [10729] = 3772,
  [10730] = 10730,
  [10731] = 3781,
  [10732] = 3806,
  [10733] = 3796,
  [10734] = 10526,
  [10735] = 10543,
  [10736] = 3744,
  [10737] = 4099,
  [10738] = 3754,
  [10739] = 10505,
  [10740] = 10740,
  [10741] = 10741,
  [10742] = 4097,
  [10743] = 10743,
  [10744] = 3774,
  [10745] = 3724,
  [10746] = 3767,
  [10747] = 3765,
  [10748] = 3746,
  [10749] = 3731,
  [10750] = 4095,
  [10751] = 3751,
  [10752] = 4094,
  [10753] = 4093,
  [10754] = 3770,
  [10755] = 3760,
  [10756] = 10756,
  [10757] = 10757,
  [10758] = 4135,
  [10759] = 10759,
  [10760] = 10643,
  [10761] = 3783,
  [10762] = 10762,
  [10763] = 4078,
  [10764] = 4081,
  [10765] = 3777,
  [10766] = 4083,
  [10767] = 4085,
  [10768] = 10768,
  [10769] = 3762,
  [10770] = 4086,
  [10771] = 3747,
  [10772] = 10772,
  [10773] = 10773,
  [10774] = 4087,
  [10775] = 10775,
  [10776] = 10481,
  [10777] = 3757,
  [10778] = 10778,
  [10779] = 4088,
  [10780] = 4089,
  [10781] = 3749,
  [10782] = 3750,
  [10783] = 10526,
  [10784] = 10784,
  [10785] = 3744,
  [10786] = 3851,
  [10787] = 3761,
  [10788] = 10543,
  [10789] = 3853,
  [10790] = 3724,
  [10791] = 3753,
  [10792] = 3777,
  [10793] = 3850,
  [10794] = 3769,
  [10795] = 3789,
  [10796] = 10768,
  [10797] = 10505,
  [10798] = 3791,
  [10799] = 3825,
  [10800] = 3780,
  [10801] = 3875,
  [10802] = 10505,
  [10803] = 3782,
  [10804] = 3783,
  [10805] = 3841,
  [10806] = 3794,
  [10807] = 3796,
  [10808] = 3774,
  [10809] = 3829,
  [10810] = 3767,
  [10811] = 3830,
  [10812] = 10812,
  [10813] = 10715,
  [10814] = 10272,
  [10815] = 3731,
  [10816] = 3874,
  [10817] = 10784,
  [10818] = 3849,
  [10819] = 3857,
  [10820] = 10706,
  [10821] = 10740,
  [10822] = 3846,
  [10823] = 10505,
  [10824] = 10272,
  [10825] = 10756,
  [10826] = 3778,
  [10827] = 4315,
  [10828] = 3844,
  [10829] = 10757,
  [10830] = 3843,
  [10831] = 10759,
  [10832] = 3745,
  [10833] = 10778,
  [10834] = 10698,
  [10835] = 3762,
  [10836] = 3842,
  [10837] = 10762,
  [10838] = 3839,
  [10839] = 10543,
  [10840] = 3745,
  [10841] = 10505,
  [10842] = 3760,
  [10843] = 3775,
  [10844] = 3772,
  [10845] = 10772,
  [10846] = 3779,
  [10847] = 3781,
  [10848] = 3815,
  [10849] = 10543,
  [10850] = 10784,
  [10851] = 3832,
  [10852] = 10491,
  [10853] = 3833,
  [10854] = 4315,
  [10855] = 3723,
  [10856] = 3730,
  [10857] = 10272,
  [10858] = 3728,
  [10859] = 3859,
  [10860] = 10784,
  [10861] = 3755,
  [10862] = 10505,
  [10863] = 3836,
  [10864] = 3838,
  [10865] = 10272,
  [10866] = 3860,
  [10867] = 10543,
  [10868] = 3765,
  [10869] = 10773,
  [10870] = 3826,
  [10871] = 10775,
  [10872] = 10272,
  [10873] = 3723,
  [10874] = 3746,
  [10875] = 3758,
  [10876] = 10741,
  [10877] = 10743,
  [10878] = 10705,
  [10879] = 10784,
  [10880] = 3754,
  [10881] = 3870,
  [10882] = 3835,
  [10883] = 3861,
  [10884] = 3862,
  [10885] = 10505,
  [10886] = 10784,
  [10887] = 10491,
  [10888] = 10784,
  [10889] = 3755,
  [10890] = 10272,
  [10891] = 3806,
  [10892] = 3729,
  [10893] = 3770,
  [10894] = 10272,
  [10895] = 3764,
  [10896] = 10784,
  [10897] = 3867,
  [10898] = 10543,
  [10899] = 10784,
  [10900] = 10481,
  [10901] = 3757,
  [10902] = 10543,
  [10903] = 3856,
  [10904] = 3751,
  [10905] = 10723,
  [10906] = 10730,
  [10907] = 3750,
  [10908] = 3749,
  [10909] = 3747,
  [10910] = 10784,
  [10911] = 10911,
  [10912] = 3859,
  [10913] = 10911,
  [10914] = 10914,
  [10915] = 10914,
  [10916] = 10914,
  [10917] = 3791,
  [10918] = 10543,
  [10919] = 10911,
  [10920] = 10911,
  [10921] = 4455,
  [10922] = 10914,
  [10923] = 3841,
  [10924] = 4112,
  [10925] = 10914,
  [10926] = 4435,
  [10927] = 10911,
  [10928] = 4440,
  [10929] = 4101,
  [10930] = 10481,
  [10931] = 3777,
  [10932] = 3815,
  [10933] = 10914,
  [10934] = 3782,
  [10935] = 4315,
  [10936] = 10543,
  [10937] = 3747,
  [10938] = 10911,
  [10939] = 10911,
  [10940] = 10914,
  [10941] = 10914,
  [10942] = 10914,
  [10943] = 3829,
  [10944] = 10911,
  [10945] = 3794,
  [10946] = 3830,
  [10947] = 4095,
  [10948] = 10911,
  [10949] = 3779,
  [10950] = 10914,
  [10951] = 10911,
  [10952] = 3826,
  [10953] = 3780,
  [10954] = 10272,
  [10955] = 10914,
  [10956] = 10914,
  [10957] = 4135,
  [10958] = 3749,
  [10959] = 4094,
  [10960] = 10505,
  [10961] = 3750,
  [10962] = 4093,
  [10963] = 10914,
  [10964] = 10543,
  [10965] = 10911,
  [10966] = 10911,
  [10967] = 3832,
  [10968] = 3833,
  [10969] = 3723,
  [10970] = 3789,
  [10971] = 3835,
  [10972] = 3796,
  [10973] = 10914,
  [10974] = 3836,
  [10975] = 10914,
  [10976] = 10911,
  [10977] = 3769,
  [10978] = 3838,
  [10979] = 3839,
  [10980] = 3862,
  [10981] = 4110,
  [10982] = 10914,
  [10983] = 10911,
  [10984] = 10914,
  [10985] = 10914,
  [10986] = 3842,
  [10987] = 10914,
  [10988] = 3843,
  [10989] = 10914,
  [10990] = 10911,
  [10991] = 10526,
  [10992] = 4097,
  [10993] = 3844,
  [10994] = 3846,
  [10995] = 10911,
  [10996] = 3849,
  [10997] = 10911,
  [10998] = 3850,
  [10999] = 3770,
  [11000] = 10911,
  [11001] = 3825,
  [11002] = 3775,
  [11003] = 10543,
  [11004] = 10914,
  [11005] = 10505,
  [11006] = 10914,
  [11007] = 3746,
  [11008] = 10911,
  [11009] = 10911,
  [11010] = 10914,
  [11011] = 3774,
  [11012] = 3724,
  [11013] = 3767,
  [11014] = 10911,
  [11015] = 10911,
  [11016] = 10911,
  [11017] = 3730,
  [11018] = 4089,
  [11019] = 3851,
  [11020] = 10505,
  [11021] = 3853,
  [11022] = 10914,
  [11023] = 3826,
  [11024] = 3772,
  [11025] = 10914,
  [11026] = 3745,
  [11027] = 3856,
  [11028] = 4101,
  [11029] = 3857,
  [11030] = 4356,
  [11031] = 3761,
  [11032] = 3744,
  [11033] = 10914,
  [11034] = 10543,
  [11035] = 3728,
  [11036] = 3875,
  [11037] = 10911,
  [11038] = 3860,
  [11039] = 10914,
  [11040] = 4440,
  [11041] = 10914,
  [11042] = 3861,
  [11043] = 10911,
  [11044] = 10911,
  [11045] = 10914,
  [11046] = 10914,
  [11047] = 10914,
  [11048] = 4455,
  [11049] = 4086,
  [11050] = 3765,
  [11051] = 10911,
  [11052] = 10914,
  [11053] = 10911,
  [11054] = 10911,
  [11055] = 4085,
  [11056] = 3874,
  [11057] = 10481,
  [11058] = 4083,
  [11059] = 3867,
  [11060] = 10914,
  [11061] = 10911,
  [11062] = 3754,
  [11063] = 10914,
  [11064] = 3870,
  [11065] = 10272,
  [11066] = 10911,
  [11067] = 10505,
  [11068] = 3783,
  [11069] = 10914,
  [11070] = 3870,
  [11071] = 3875,
  [11072] = 3867,
  [11073] = 10914,
  [11074] = 10911,
  [11075] = 10505,
  [11076] = 3874,
  [11077] = 4081,
  [11078] = 4087,
  [11079] = 3833,
  [11080] = 11080,
  [11081] = 10911,
  [11082] = 10911,
  [11083] = 3862,
  [11084] = 4111,
  [11085] = 3861,
  [11086] = 10914,
  [11087] = 10911,
  [11088] = 10911,
  [11089] = 10911,
  [11090] = 3762,
  [11091] = 3764,
  [11092] = 3860,
  [11093] = 10543,
  [11094] = 10911,
  [11095] = 4435,
  [11096] = 10911,
  [11097] = 10911,
  [11098] = 4078,
  [11099] = 10491,
  [11100] = 3781,
  [11101] = 10914,
  [11102] = 3859,
  [11103] = 10914,
  [11104] = 10914,
  [11105] = 10911,
  [11106] = 10914,
  [11107] = 10505,
  [11108] = 3857,
  [11109] = 3751,
  [11110] = 4356,
  [11111] = 10505,
  [11112] = 10543,
  [11113] = 3856,
  [11114] = 4099,
  [11115] = 10914,
  [11116] = 3853,
  [11117] = 3851,
  [11118] = 3825,
  [11119] = 3850,
  [11120] = 10914,
  [11121] = 3731,
  [11122] = 3849,
  [11123] = 3778,
  [11124] = 3760,
  [11125] = 3753,
  [11126] = 4100,
  [11127] = 3806,
  [11128] = 10911,
  [11129] = 10643,
  [11130] = 4088,
  [11131] = 3758,
  [11132] = 10911,
  [11133] = 10911,
  [11134] = 10911,
  [11135] = 10914,
  [11136] = 10272,
  [11137] = 11137,
  [11138] = 3757,
  [11139] = 3729,
  [11140] = 10914,
  [11141] = 3829,
  [11142] = 3846,
  [11143] = 10272,
  [11144] = 10914,
  [11145] = 3844,
  [11146] = 3843,
  [11147] = 3830,
  [11148] = 3842,
  [11149] = 3832,
  [11150] = 3841,
  [11151] = 3839,
  [11152] = 10911,
  [11153] = 3838,
  [11154] = 3836,
  [11155] = 3835,
  [11156] = 3746,
  [11157] = 3723,
  [11158] = 3731,
  [11159] = 4093,
  [11160] = 11160,
  [11161] = 11160,
  [11162] = 11160,
  [11163] = 3724,
  [11164] = 10704,
  [11165] = 4095,
  [11166] = 4094,
  [11167] = 4110,
  [11168] = 11160,
  [11169] = 4089,
  [11170] = 4088,
  [11171] = 4087,
  [11172] = 11172,
  [11173] = 11160,
  [11174] = 11160,
  [11175] = 4097,
  [11176] = 11160,
  [11177] = 4086,
  [11178] = 4085,
  [11179] = 3728,
  [11180] = 4099,
  [11181] = 3730,
  [11182] = 3729,
  [11183] = 11160,
  [11184] = 11160,
  [11185] = 4083,
  [11186] = 11160,
  [11187] = 11160,
  [11188] = 11160,
  [11189] = 11160,
  [11190] = 11190,
  [11191] = 3755,
  [11192] = 3728,
  [11193] = 3778,
  [11194] = 4081,
  [11195] = 3723,
  [11196] = 3806,
  [11197] = 3781,
  [11198] = 4078,
  [11199] = 11160,
  [11200] = 11160,
  [11201] = 3731,
  [11202] = 11160,
  [11203] = 11203,
  [11204] = 10543,
  [11205] = 10505,
  [11206] = 3745,
  [11207] = 3777,
  [11208] = 11160,
  [11209] = 4435,
  [11210] = 3783,
  [11211] = 11160,
  [11212] = 11160,
  [11213] = 4315,
  [11214] = 3723,
  [11215] = 11160,
  [11216] = 3730,
  [11217] = 11160,
  [11218] = 11160,
  [11219] = 4455,
  [11220] = 11220,
  [11221] = 4440,
  [11222] = 4101,
  [11223] = 11160,
  [11224] = 3723,
  [11225] = 11160,
  [11226] = 11160,
  [11227] = 4100,
  [11228] = 10505,
  [11229] = 4315,
  [11230] = 4356,
  [11231] = 11231,
  [11232] = 10543,
  [11233] = 10505,
  [11234] = 11220,
  [11235] = 3745,
  [11236] = 11220,
  [11237] = 4111,
  [11238] = 4112,
  [11239] = 11160,
  [11240] = 3729,
  [11241] = 10643,
  [11242] = 10481,
  [11243] = 11160,
  [11244] = 3731,
  [11245] = 10481,
  [11246] = 3724,
  [11247] = 11247,
  [11248] = 3724,
  [11249] = 10756,
  [11250] = 11160,
  [11251] = 10757,
  [11252] = 3745,
  [11253] = 10759,
  [11254] = 3724,
  [11255] = 10762,
  [11256] = 10643,
  [11257] = 3723,
  [11258] = 10491,
  [11259] = 10505,
  [11260] = 4315,
  [11261] = 10773,
  [11262] = 10775,
  [11263] = 11160,
  [11264] = 3723,
  [11265] = 10772,
  [11266] = 11160,
  [11267] = 11160,
  [11268] = 11160,
  [11269] = 11160,
  [11270] = 11160,
  [11271] = 10723,
  [11272] = 10730,
  [11273] = 10741,
  [11274] = 3730,
  [11275] = 10526,
  [11276] = 10715,
  [11277] = 4112,
  [11278] = 10706,
  [11279] = 11160,
  [11280] = 3728,
  [11281] = 11160,
  [11282] = 4111,
  [11283] = 10743,
  [11284] = 11160,
  [11285] = 10526,
  [11286] = 10778,
  [11287] = 10740,
  [11288] = 11160,
  [11289] = 11160,
  [11290] = 10698,
  [11291] = 10491,
  [11292] = 3755,
  [11293] = 3767,
  [11294] = 3815,
  [11295] = 3774,
  [11296] = 3796,
  [11297] = 3794,
  [11298] = 3729,
  [11299] = 3782,
  [11300] = 3780,
  [11301] = 4110,
  [11302] = 3791,
  [11303] = 3779,
  [11304] = 10543,
  [11305] = 3772,
  [11306] = 3789,
  [11307] = 3769,
  [11308] = 11172,
  [11309] = 11160,
  [11310] = 3760,
  [11311] = 10715,
  [11312] = 11160,
  [11313] = 10768,
  [11314] = 11160,
  [11315] = 3731,
  [11316] = 3762,
  [11317] = 11160,
  [11318] = 3761,
  [11319] = 11160,
  [11320] = 3744,
  [11321] = 11160,
  [11322] = 3724,
  [11323] = 10272,
  [11324] = 11160,
  [11325] = 11160,
  [11326] = 11160,
  [11327] = 11231,
  [11328] = 10491,
  [11329] = 3728,
  [11330] = 4100,
  [11331] = 4099,
  [11332] = 3730,
  [11333] = 4097,
  [11334] = 10481,
  [11335] = 11160,
  [11336] = 11160,
  [11337] = 11160,
  [11338] = 11160,
  [11339] = 11160,
  [11340] = 11160,
  [11341] = 11160,
  [11342] = 4095,
  [11343] = 4094,
  [11344] = 4093,
  [11345] = 3753,
  [11346] = 3729,
  [11347] = 3723,
  [11348] = 10741,
  [11349] = 10743,
  [11350] = 11160,
  [11351] = 11160,
  [11352] = 3729,
  [11353] = 10481,
  [11354] = 10272,
  [11355] = 11160,
  [11356] = 4089,
  [11357] = 11160,
  [11358] = 4088,
  [11359] = 11160,
  [11360] = 3731,
  [11361] = 4087,
  [11362] = 10543,
  [11363] = 11160,
  [11364] = 3731,
  [11365] = 11160,
  [11366] = 11160,
  [11367] = 11160,
  [11368] = 11160,
  [11369] = 11160,
  [11370] = 4086,
  [11371] = 11160,
  [11372] = 4085,
  [11373] = 3755,
  [11374] = 3724,
  [11375] = 11160,
  [11376] = 11160,
  [11377] = 4083,
  [11378] = 4081,
  [11379] = 11160,
  [11380] = 4078,
  [11381] = 11160,
  [11382] = 11160,
  [11383] = 11160,
  [11384] = 11384,
  [11385] = 3875,
  [11386] = 11160,
  [11387] = 11160,
  [11388] = 11160,
  [11389] = 3874,
  [11390] = 3728,
  [11391] = 11160,
  [11392] = 11160,
  [11393] = 11160,
  [11394] = 11160,
  [11395] = 11160,
  [11396] = 11160,
  [11397] = 3870,
  [11398] = 11160,
  [11399] = 3731,
  [11400] = 3867,
  [11401] = 11160,
  [11402] = 11160,
  [11403] = 10526,
  [11404] = 3826,
  [11405] = 11160,
  [11406] = 3862,
  [11407] = 3861,
  [11408] = 3860,
  [11409] = 4560,
  [11410] = 3859,
  [11411] = 10481,
  [11412] = 11160,
  [11413] = 4135,
  [11414] = 3857,
  [11415] = 3856,
  [11416] = 3853,
  [11417] = 3851,
  [11418] = 3729,
  [11419] = 3825,
  [11420] = 11160,
  [11421] = 11160,
  [11422] = 3850,
  [11423] = 3849,
  [11424] = 11160,
  [11425] = 11160,
  [11426] = 3728,
  [11427] = 3846,
  [11428] = 11160,
  [11429] = 3844,
  [11430] = 11160,
  [11431] = 3747,
  [11432] = 3724,
  [11433] = 11160,
  [11434] = 4135,
  [11435] = 3724,
  [11436] = 3745,
  [11437] = 11160,
  [11438] = 11160,
  [11439] = 3775,
  [11440] = 3749,
  [11441] = 3731,
  [11442] = 11160,
  [11443] = 3750,
  [11444] = 11160,
  [11445] = 11203,
  [11446] = 3751,
  [11447] = 11160,
  [11448] = 3843,
  [11449] = 3842,
  [11450] = 3757,
  [11451] = 11160,
  [11452] = 3764,
  [11453] = 11160,
  [11454] = 11160,
  [11455] = 3730,
  [11456] = 3765,
  [11457] = 3754,
  [11458] = 11160,
  [11459] = 3841,
  [11460] = 11160,
  [11461] = 11160,
  [11462] = 3839,
  [11463] = 3770,
  [11464] = 10491,
  [11465] = 3730,
  [11466] = 11160,
  [11467] = 11160,
  [11468] = 11160,
  [11469] = 3730,
  [11470] = 11160,
  [11471] = 11160,
  [11472] = 3729,
  [11473] = 11160,
  [11474] = 3729,
  [11475] = 11160,
  [11476] = 11160,
  [11477] = 11160,
  [11478] = 11160,
  [11479] = 11160,
  [11480] = 4315,
  [11481] = 11160,
  [11482] = 3728,
  [11483] = 3755,
  [11484] = 11160,
  [11485] = 3723,
  [11486] = 3728,
  [11487] = 3838,
  [11488] = 3758,
  [11489] = 3836,
  [11490] = 3745,
  [11491] = 11160,
  [11492] = 10491,
  [11493] = 3835,
  [11494] = 3833,
  [11495] = 10526,
  [11496] = 11160,
  [11497] = 11160,
  [11498] = 11160,
  [11499] = 11160,
  [11500] = 3832,
  [11501] = 11160,
  [11502] = 3830,
  [11503] = 11160,
  [11504] = 3730,
  [11505] = 3829,
  [11506] = 11160,
  [11507] = 11160,
  [11508] = 11160,
  [11509] = 11160,
  [11510] = 11160,
  [11511] = 11160,
  [11512] = 11160,
  [11513] = 10481,
  [11514] = 10481,
  [11515] = 11160,
  [11516] = 10481,
  [11517] = 11160,
  [11518] = 3755,
  [11519] = 4315,
  [11520] = 11160,
  [11521] = 11521,
  [11522] = 4560,
  [11523] = 11160,
  [11524] = 11160,
  [11525] = 11160,
  [11526] = 11190,
  [11527] = 11160,
  [11528] = 3746,
  [11529] = 3791,
  [11530] = 3724,
  [11531] = 3761,
  [11532] = 3744,
  [11533] = 3753,
  [11534] = 3806,
  [11535] = 3875,
  [11536] = 4078,
  [11537] = 3745,
  [11538] = 4081,
  [11539] = 4083,
  [11540] = 3783,
  [11541] = 4085,
  [11542] = 3780,
  [11543] = 3729,
  [11544] = 3781,
  [11545] = 3777,
  [11546] = 3874,
  [11547] = 10526,
  [11548] = 3730,
  [11549] = 3731,
  [11550] = 10772,
  [11551] = 3758,
  [11552] = 3744,
  [11553] = 3761,
  [11554] = 3731,
  [11555] = 4087,
  [11556] = 3769,
  [11557] = 10491,
  [11558] = 4088,
  [11559] = 4089,
  [11560] = 3789,
  [11561] = 3806,
  [11562] = 3783,
  [11563] = 3781,
  [11564] = 3724,
  [11565] = 10491,
  [11566] = 3769,
  [11567] = 10481,
  [11568] = 3775,
  [11569] = 3745,
  [11570] = 3746,
  [11571] = 3780,
  [11572] = 4315,
  [11573] = 3730,
  [11574] = 4356,
  [11575] = 3782,
  [11576] = 3778,
  [11577] = 3774,
  [11578] = 3728,
  [11579] = 4093,
  [11580] = 4094,
  [11581] = 4356,
  [11582] = 3746,
  [11583] = 3767,
  [11584] = 3796,
  [11585] = 3794,
  [11586] = 3791,
  [11587] = 3755,
  [11588] = 4095,
  [11589] = 3770,
  [11590] = 3789,
  [11591] = 3758,
  [11592] = 3753,
  [11593] = 3815,
  [11594] = 3789,
  [11595] = 3774,
  [11596] = 11596,
  [11597] = 3774,
  [11598] = 3791,
  [11599] = 4435,
  [11600] = 3789,
  [11601] = 3758,
  [11602] = 3791,
  [11603] = 3794,
  [11604] = 3796,
  [11605] = 3777,
  [11606] = 3782,
  [11607] = 3767,
  [11608] = 4101,
  [11609] = 3779,
  [11610] = 3767,
  [11611] = 4440,
  [11612] = 3772,
  [11613] = 3870,
  [11614] = 3782,
  [11615] = 3783,
  [11616] = 3875,
  [11617] = 4455,
  [11618] = 3794,
  [11619] = 10491,
  [11620] = 3769,
  [11621] = 3874,
  [11622] = 3762,
  [11623] = 3796,
  [11624] = 10481,
  [11625] = 4435,
  [11626] = 3815,
  [11627] = 3760,
  [11628] = 3780,
  [11629] = 3826,
  [11630] = 3870,
  [11631] = 10772,
  [11632] = 3767,
  [11633] = 3867,
  [11634] = 3760,
  [11635] = 3723,
  [11636] = 3753,
  [11637] = 3857,
  [11638] = 4097,
  [11639] = 3829,
  [11640] = 4099,
  [11641] = 3796,
  [11642] = 4100,
  [11643] = 3794,
  [11644] = 3754,
  [11645] = 3833,
  [11646] = 4086,
  [11647] = 3791,
  [11648] = 3729,
  [11649] = 3778,
  [11650] = 3774,
  [11651] = 3777,
  [11652] = 3789,
  [11653] = 3830,
  [11654] = 3781,
  [11655] = 3760,
  [11656] = 3745,
  [11657] = 3758,
  [11658] = 3772,
  [11659] = 4110,
  [11660] = 3779,
  [11661] = 3857,
  [11662] = 3815,
  [11663] = 3775,
  [11664] = 3770,
  [11665] = 4135,
  [11666] = 4356,
  [11667] = 3745,
  [11668] = 4111,
  [11669] = 4112,
  [11670] = 3765,
  [11671] = 10491,
  [11672] = 3753,
  [11673] = 3862,
  [11674] = 3754,
  [11675] = 3775,
  [11676] = 3832,
  [11677] = 3762,
  [11678] = 3861,
  [11679] = 3765,
  [11680] = 3761,
  [11681] = 3806,
  [11682] = 3744,
  [11683] = 4455,
  [11684] = 3764,
  [11685] = 4440,
  [11686] = 10756,
  [11687] = 3860,
  [11688] = 3859,
  [11689] = 4101,
  [11690] = 3867,
  [11691] = 3757,
  [11692] = 3746,
  [11693] = 3751,
  [11694] = 3815,
  [11695] = 3774,
  [11696] = 3806,
  [11697] = 3783,
  [11698] = 3775,
  [11699] = 3857,
  [11700] = 10505,
  [11701] = 3856,
  [11702] = 3777,
  [11703] = 3853,
  [11704] = 3851,
  [11705] = 3825,
  [11706] = 3850,
  [11707] = 3782,
  [11708] = 3780,
  [11709] = 3753,
  [11710] = 3723,
  [11711] = 3779,
  [11712] = 3728,
  [11713] = 10762,
  [11714] = 3772,
  [11715] = 3731,
  [11716] = 3750,
  [11717] = 3764,
  [11718] = 3757,
  [11719] = 10757,
  [11720] = 3724,
  [11721] = 3778,
  [11722] = 4101,
  [11723] = 3781,
  [11724] = 3846,
  [11725] = 3844,
  [11726] = 3751,
  [11727] = 4440,
  [11728] = 10505,
  [11729] = 10759,
  [11730] = 4455,
  [11731] = 3769,
  [11732] = 3843,
  [11733] = 3842,
  [11734] = 3841,
  [11735] = 3839,
  [11736] = 3731,
  [11737] = 3838,
  [11738] = 3749,
  [11739] = 3747,
  [11740] = 3846,
  [11741] = 3836,
  [11742] = 4315,
  [11743] = 3835,
  [11744] = 3780,
  [11745] = 3777,
  [11746] = 3762,
  [11747] = 3833,
  [11748] = 3761,
  [11749] = 3832,
  [11750] = 3830,
  [11751] = 3829,
  [11752] = 3744,
  [11753] = 3730,
  [11754] = 3782,
  [11755] = 3731,
  [11756] = 3755,
  [11757] = 4435,
  [11758] = 3862,
  [11759] = 3860,
  [11760] = 3849,
  [11761] = 10543,
  [11762] = 3730,
  [11763] = 3750,
  [11764] = 3747,
  [11765] = 3775,
  [11766] = 3728,
  [11767] = 3723,
  [11768] = 11768,
  [11769] = 3724,
  [11770] = 3791,
  [11771] = 3755,
  [11772] = 10526,
  [11773] = 3779,
  [11774] = 3859,
  [11775] = 3772,
  [11776] = 3729,
  [11777] = 3778,
  [11778] = 3749,
  [11779] = 3758,
  [11780] = 3781,
  [11781] = 3794,
  [11782] = 10773,
  [11783] = 3746,
  [11784] = 3729,
  [11785] = 3826,
  [11786] = 10526,
  [11787] = 3829,
  [11788] = 3745,
  [11789] = 3783,
  [11790] = 10704,
  [11791] = 3815,
  [11792] = 10775,
  [11793] = 3782,
  [11794] = 3779,
  [11795] = 3772,
  [11796] = 3806,
  [11797] = 3796,
  [11798] = 3830,
  [11799] = 3760,
  [11800] = 3856,
  [11801] = 3770,
  [11802] = 3853,
  [11803] = 3728,
  [11804] = 11172,
  [11805] = 3767,
  [11806] = 3762,
  [11807] = 3745,
  [11808] = 3825,
  [11809] = 3723,
  [11810] = 3754,
  [11811] = 3861,
  [11812] = 3765,
  [11813] = 3850,
  [11814] = 3770,
  [11815] = 3767,
  [11816] = 3755,
  [11817] = 3796,
  [11818] = 3764,
  [11819] = 3747,
  [11820] = 3757,
  [11821] = 3794,
  [11822] = 3832,
  [11823] = 3778,
  [11824] = 3754,
  [11825] = 3833,
  [11826] = 3724,
  [11827] = 3789,
  [11828] = 3751,
  [11829] = 3835,
  [11830] = 3765,
  [11831] = 3835,
  [11832] = 3836,
  [11833] = 4315,
  [11834] = 3836,
  [11835] = 3749,
  [11836] = 3750,
  [11837] = 3750,
  [11838] = 3749,
  [11839] = 3849,
  [11840] = 3751,
  [11841] = 3749,
  [11842] = 3750,
  [11843] = 3757,
  [11844] = 3838,
  [11845] = 3730,
  [11846] = 3777,
  [11847] = 3764,
  [11848] = 3757,
  [11849] = 3764,
  [11850] = 3730,
  [11851] = 3747,
  [11852] = 3765,
  [11853] = 3754,
  [11854] = 3728,
  [11855] = 10723,
  [11856] = 3747,
  [11857] = 10730,
  [11858] = 3770,
  [11859] = 3767,
  [11860] = 3774,
  [11861] = 3796,
  [11862] = 3794,
  [11863] = 3770,
  [11864] = 3780,
  [11865] = 3791,
  [11866] = 4315,
  [11867] = 3746,
  [11868] = 3789,
  [11869] = 3769,
  [11870] = 3751,
  [11871] = 3758,
  [11872] = 3829,
  [11873] = 3761,
  [11874] = 3830,
  [11875] = 3744,
  [11876] = 4356,
  [11877] = 10491,
  [11878] = 3755,
  [11879] = 3729,
  [11880] = 3753,
  [11881] = 3750,
  [11882] = 11190,
  [11883] = 3723,
  [11884] = 3839,
  [11885] = 3832,
  [11886] = 3833,
  [11887] = 3835,
  [11888] = 3749,
  [11889] = 10543,
  [11890] = 3753,
  [11891] = 3778,
  [11892] = 3836,
  [11893] = 3838,
  [11894] = 3762,
  [11895] = 3781,
  [11896] = 3841,
  [11897] = 3769,
  [11898] = 11203,
  [11899] = 3783,
  [11900] = 3815,
  [11901] = 3751,
  [11902] = 3753,
  [11903] = 3839,
  [11904] = 3841,
  [11905] = 3842,
  [11906] = 3843,
  [11907] = 3844,
  [11908] = 3757,
  [11909] = 3846,
  [11910] = 4315,
  [11911] = 3774,
  [11912] = 3778,
  [11913] = 10778,
  [11914] = 3838,
  [11915] = 3782,
  [11916] = 10740,
  [11917] = 3764,
  [11918] = 11231,
  [11919] = 3780,
  [11920] = 3781,
  [11921] = 10481,
  [11922] = 3729,
  [11923] = 10481,
  [11924] = 3779,
  [11925] = 3772,
  [11926] = 3747,
  [11927] = 3765,
  [11928] = 3775,
  [11929] = 3760,
  [11930] = 3875,
  [11931] = 3842,
  [11932] = 3843,
  [11933] = 3769,
  [11934] = 3849,
  [11935] = 3850,
  [11936] = 3825,
  [11937] = 3851,
  [11938] = 3853,
  [11939] = 3760,
  [11940] = 3874,
  [11941] = 3856,
  [11942] = 3857,
  [11943] = 3859,
  [11944] = 3844,
  [11945] = 3851,
  [11946] = 3860,
  [11947] = 3861,
  [11948] = 3862,
  [11949] = 3826,
  [11950] = 4101,
  [11951] = 4440,
  [11952] = 3754,
  [11953] = 10768,
  [11954] = 11247,
  [11955] = 10481,
  [11956] = 3723,
  [11957] = 10768,
  [11958] = 3762,
  [11959] = 3731,
  [11960] = 3777,
  [11961] = 3770,
  [11962] = 3761,
  [11963] = 4455,
  [11964] = 3775,
  [11965] = 3867,
  [11966] = 3870,
  [11967] = 3744,
  [11968] = 3806,
  [11969] = 3870,
  [11970] = 10526,
  [11971] = 3723,
  [11972] = 3728,
  [11973] = 3846,
  [11974] = 3775,
  [11975] = 10491,
  [11976] = 3724,
  [11977] = 3874,
  [11978] = 3875,
  [11979] = 10491,
  [11980] = 3728,
  [11981] = 3745,
  [11982] = 10698,
  [11983] = 3730,
  [11984] = 3867,
  [11985] = 3729,
  [11986] = 10706,
  [11987] = 3829,
  [11988] = 3830,
  [11989] = 10715,
  [11990] = 4435,
  [11991] = 3856,
  [11992] = 11247,
  [11993] = 4315,
  [11994] = 10740,
  [11995] = 10481,
  [11996] = 3832,
  [11997] = 3806,
  [11998] = 10741,
  [11999] = 3833,
  [12000] = 10743,
  [12001] = 3754,
  [12002] = 3765,
  [12003] = 3760,
  [12004] = 3839,
  [12005] = 3764,
  [12006] = 10778,
  [12007] = 3835,
  [12008] = 3761,
  [12009] = 3757,
  [12010] = 3875,
  [12011] = 3841,
  [12012] = 3842,
  [12013] = 10756,
  [12014] = 3806,
  [12015] = 3747,
  [12016] = 3749,
  [12017] = 4560,
  [12018] = 10481,
  [12019] = 3849,
  [12020] = 3843,
  [12021] = 3750,
  [12022] = 3874,
  [12023] = 3751,
  [12024] = 3778,
  [12025] = 3781,
  [12026] = 3757,
  [12027] = 3751,
  [12028] = 3850,
  [12029] = 3870,
  [12030] = 3750,
  [12031] = 3749,
  [12032] = 3764,
  [12033] = 3744,
  [12034] = 3761,
  [12035] = 3836,
  [12036] = 3838,
  [12037] = 3762,
  [12038] = 3867,
  [12039] = 3765,
  [12040] = 3754,
  [12041] = 3783,
  [12042] = 3770,
  [12043] = 10698,
  [12044] = 3826,
  [12045] = 3772,
  [12046] = 3826,
  [12047] = 3862,
  [12048] = 3747,
  [12049] = 3861,
  [12050] = 3860,
  [12051] = 3744,
  [12052] = 3859,
  [12053] = 4356,
  [12054] = 3857,
  [12055] = 3856,
  [12056] = 10706,
  [12057] = 10757,
  [12058] = 3853,
  [12059] = 10759,
  [12060] = 10715,
  [12061] = 3779,
  [12062] = 3862,
  [12063] = 3851,
  [12064] = 3825,
  [12065] = 10741,
  [12066] = 10743,
  [12067] = 3777,
  [12068] = 3849,
  [12069] = 3746,
  [12070] = 3769,
  [12071] = 10643,
  [12072] = 3850,
  [12073] = 3731,
  [12074] = 3789,
  [12075] = 3755,
  [12076] = 3825,
  [12077] = 3745,
  [12078] = 3861,
  [12079] = 10723,
  [12080] = 3839,
  [12081] = 4455,
  [12082] = 3758,
  [12083] = 10762,
  [12084] = 3841,
  [12085] = 3844,
  [12086] = 3842,
  [12087] = 3791,
  [12088] = 3746,
  [12089] = 3843,
  [12090] = 3783,
  [12091] = 3860,
  [12092] = 3780,
  [12093] = 3782,
  [12094] = 3794,
  [12095] = 3796,
  [12096] = 3851,
  [12097] = 3774,
  [12098] = 3767,
  [12099] = 4440,
  [12100] = 3758,
  [12101] = 10730,
  [12102] = 3859,
  [12103] = 10491,
  [12104] = 3815,
  [12105] = 3779,
  [12106] = 3772,
  [12107] = 4101,
  [12108] = 10775,
  [12109] = 3724,
  [12110] = 10773,
  [12111] = 3760,
  [12112] = 3815,
  [12113] = 3844,
  [12114] = 3853,
  [12115] = 3762,
  [12116] = 3846,
  [12117] = 4435,
  [12118] = 3806,
  [12119] = 3870,
  [12120] = 3777,
  [12121] = 4110,
  [12122] = 4099,
  [12123] = 3754,
  [12124] = 3730,
  [12125] = 3770,
  [12126] = 3765,
  [12127] = 3815,
  [12128] = 3774,
  [12129] = 10706,
  [12130] = 3782,
  [12131] = 3744,
  [12132] = 3779,
  [12133] = 3772,
  [12134] = 3760,
  [12135] = 4135,
  [12136] = 4100,
  [12137] = 3764,
  [12138] = 4356,
  [12139] = 4097,
  [12140] = 3757,
  [12141] = 10543,
  [12142] = 4111,
  [12143] = 4112,
  [12144] = 3849,
  [12145] = 3762,
  [12146] = 4097,
  [12147] = 4099,
  [12148] = 3760,
  [12149] = 3745,
  [12150] = 3761,
  [12151] = 3850,
  [12152] = 3747,
  [12153] = 3751,
  [12154] = 4100,
  [12155] = 3789,
  [12156] = 10505,
  [12157] = 3825,
  [12158] = 3806,
  [12159] = 3851,
  [12160] = 3750,
  [12161] = 3749,
  [12162] = 3755,
  [12163] = 4435,
  [12164] = 4560,
  [12165] = 3791,
  [12166] = 4101,
  [12167] = 4440,
  [12168] = 3794,
  [12169] = 3796,
  [12170] = 3747,
  [12171] = 3836,
  [12172] = 3853,
  [12173] = 3731,
  [12174] = 3767,
  [12175] = 3753,
  [12176] = 4455,
  [12177] = 3775,
  [12178] = 3744,
  [12179] = 3761,
  [12180] = 3762,
  [12181] = 3745,
  [12182] = 4100,
  [12183] = 3856,
  [12184] = 4099,
  [12185] = 3774,
  [12186] = 3769,
  [12187] = 3769,
  [12188] = 3780,
  [12189] = 3772,
  [12190] = 3857,
  [12191] = 3779,
  [12192] = 3780,
  [12193] = 3782,
  [12194] = 3806,
  [12195] = 3815,
  [12196] = 3783,
  [12197] = 3746,
  [12198] = 4435,
  [12199] = 4095,
  [12200] = 4094,
  [12201] = 4356,
  [12202] = 4093,
  [12203] = 10543,
  [12204] = 3775,
  [12205] = 3724,
  [12206] = 3729,
  [12207] = 4095,
  [12208] = 4110,
  [12209] = 3781,
  [12210] = 4094,
  [12211] = 10491,
  [12212] = 4093,
  [12213] = 3758,
  [12214] = 3789,
  [12215] = 3778,
  [12216] = 3791,
  [12217] = 3815,
  [12218] = 4135,
  [12219] = 3794,
  [12220] = 3796,
  [12221] = 4111,
  [12222] = 4112,
  [12223] = 4110,
  [12224] = 3767,
  [12225] = 3779,
  [12226] = 3772,
  [12227] = 3770,
  [12228] = 3753,
  [12229] = 3760,
  [12230] = 4455,
  [12231] = 3754,
  [12232] = 10723,
  [12233] = 3765,
  [12234] = 4089,
  [12235] = 3806,
  [12236] = 3762,
  [12237] = 4095,
  [12238] = 3859,
  [12239] = 4440,
  [12240] = 10491,
  [12241] = 4101,
  [12242] = 3764,
  [12243] = 4097,
  [12244] = 4094,
  [12245] = 3757,
  [12246] = 4087,
  [12247] = 3751,
  [12248] = 10481,
  [12249] = 10730,
  [12250] = 3749,
  [12251] = 3755,
  [12252] = 3860,
  [12253] = 4111,
  [12254] = 3750,
  [12255] = 3767,
  [12256] = 4112,
  [12257] = 4086,
  [12258] = 4085,
  [12259] = 4083,
  [12260] = 3750,
  [12261] = 3861,
  [12262] = 3796,
  [12263] = 3829,
  [12264] = 3830,
  [12265] = 3862,
  [12266] = 4081,
  [12267] = 4078,
  [12268] = 3794,
  [12269] = 3832,
  [12270] = 3826,
  [12271] = 3833,
  [12272] = 3835,
  [12273] = 3775,
  [12274] = 3843,
  [12275] = 3749,
  [12276] = 3838,
  [12277] = 3791,
  [12278] = 3747,
  [12279] = 3728,
  [12280] = 3753,
  [12281] = 3789,
  [12282] = 3839,
  [12283] = 4088,
  [12284] = 3841,
  [12285] = 3842,
  [12286] = 3774,
  [12287] = 3782,
  [12288] = 3844,
  [12289] = 3780,
  [12290] = 3867,
  [12291] = 3846,
  [12292] = 3769,
  [12293] = 3751,
  [12294] = 4089,
  [12295] = 3757,
  [12296] = 3761,
  [12297] = 12297,
  [12298] = 3744,
  [12299] = 3777,
  [12300] = 3874,
  [12301] = 3753,
  [12302] = 3849,
  [12303] = 3875,
  [12304] = 3850,
  [12305] = 3825,
  [12306] = 3851,
  [12307] = 3875,
  [12308] = 4088,
  [12309] = 4087,
  [12310] = 3853,
  [12311] = 3806,
  [12312] = 3856,
  [12313] = 3765,
  [12314] = 3754,
  [12315] = 3836,
  [12316] = 4086,
  [12317] = 3857,
  [12318] = 4085,
  [12319] = 4356,
  [12320] = 4083,
  [12321] = 3770,
  [12322] = 3747,
  [12323] = 10698,
  [12324] = 3859,
  [12325] = 3829,
  [12326] = 3753,
  [12327] = 3815,
  [12328] = 3874,
  [12329] = 3746,
  [12330] = 3779,
  [12331] = 3772,
  [12332] = 3758,
  [12333] = 3867,
  [12334] = 3860,
  [12335] = 3760,
  [12336] = 3777,
  [12337] = 4081,
  [12338] = 3744,
  [12339] = 4078,
  [12340] = 10505,
  [12341] = 3761,
  [12342] = 3762,
  [12343] = 3861,
  [12344] = 3862,
  [12345] = 3826,
  [12346] = 3762,
  [12347] = 3767,
  [12348] = 3829,
  [12349] = 3870,
  [12350] = 3796,
  [12351] = 3829,
  [12352] = 3764,
  [12353] = 3830,
  [12354] = 3830,
  [12355] = 3794,
  [12356] = 3791,
  [12357] = 3777,
  [12358] = 3783,
  [12359] = 3870,
  [12360] = 3867,
  [12361] = 12297,
  [12362] = 3760,
  [12363] = 4435,
  [12364] = 3789,
  [12365] = 3772,
  [12366] = 3779,
  [12367] = 3780,
  [12368] = 3782,
  [12369] = 3774,
  [12370] = 10643,
  [12371] = 10778,
  [12372] = 3862,
  [12373] = 10704,
  [12374] = 3815,
  [12375] = 3861,
  [12376] = 3781,
  [12377] = 3789,
  [12378] = 3753,
  [12379] = 3860,
  [12380] = 4455,
  [12381] = 4440,
  [12382] = 4101,
  [12383] = 3723,
  [12384] = 3859,
  [12385] = 4089,
  [12386] = 3769,
  [12387] = 4088,
  [12388] = 3867,
  [12389] = 3862,
  [12390] = 3861,
  [12391] = 4087,
  [12392] = 3774,
  [12393] = 3870,
  [12394] = 3782,
  [12395] = 3778,
  [12396] = 10740,
  [12397] = 3780,
  [12398] = 4435,
  [12399] = 3860,
  [12400] = 4086,
  [12401] = 3835,
  [12402] = 3857,
  [12403] = 3769,
  [12404] = 3859,
  [12405] = 3781,
  [12406] = 3832,
  [12407] = 4085,
  [12408] = 3791,
  [12409] = 3830,
  [12410] = 3794,
  [12411] = 4083,
  [12412] = 3856,
  [12413] = 3761,
  [12414] = 3744,
  [12415] = 3749,
  [12416] = 3874,
  [12417] = 3796,
  [12418] = 3767,
  [12419] = 4081,
  [12420] = 3832,
  [12421] = 3753,
  [12422] = 3833,
  [12423] = 3833,
  [12424] = 3857,
  [12425] = 3836,
  [12426] = 3856,
  [12427] = 4078,
  [12428] = 3875,
  [12429] = 3829,
  [12430] = 3826,
  [12431] = 3851,
  [12432] = 3825,
  [12433] = 3746,
  [12434] = 3835,
  [12435] = 3853,
  [12436] = 3850,
  [12437] = 3729,
  [12438] = 3838,
  [12439] = 3778,
  [12440] = 3849,
  [12441] = 3851,
  [12442] = 3825,
  [12443] = 3750,
  [12444] = 3850,
  [12445] = 3830,
  [12446] = 3874,
  [12447] = 3849,
  [12448] = 3744,
  [12449] = 3839,
  [12450] = 3761,
  [12451] = 3841,
  [12452] = 3842,
  [12453] = 3843,
  [12454] = 10491,
  [12455] = 3838,
  [12456] = 3832,
  [12457] = 3833,
  [12458] = 3835,
  [12459] = 3874,
  [12460] = 3844,
  [12461] = 3846,
  [12462] = 3846,
  [12463] = 3846,
  [12464] = 3844,
  [12465] = 10643,
  [12466] = 3832,
  [12467] = 3833,
  [12468] = 3844,
  [12469] = 3835,
  [12470] = 3843,
  [12471] = 3836,
  [12472] = 3843,
  [12473] = 3838,
  [12474] = 3849,
  [12475] = 3842,
  [12476] = 3842,
  [12477] = 3758,
  [12478] = 3850,
  [12479] = 11247,
  [12480] = 3841,
  [12481] = 3853,
  [12482] = 3839,
  [12483] = 3851,
  [12484] = 3853,
  [12485] = 3839,
  [12486] = 3856,
  [12487] = 3857,
  [12488] = 3859,
  [12489] = 4455,
  [12490] = 3836,
  [12491] = 3838,
  [12492] = 3860,
  [12493] = 3861,
  [12494] = 3862,
  [12495] = 3838,
  [12496] = 3730,
  [12497] = 3843,
  [12498] = 4135,
  [12499] = 3836,
  [12500] = 3835,
  [12501] = 10768,
  [12502] = 3833,
  [12503] = 3832,
  [12504] = 3806,
  [12505] = 3830,
  [12506] = 3769,
  [12507] = 3789,
  [12508] = 3751,
  [12509] = 3825,
  [12510] = 3875,
  [12511] = 4440,
  [12512] = 3829,
  [12513] = 3839,
  [12514] = 3870,
  [12515] = 4560,
  [12516] = 4101,
  [12517] = 3841,
  [12518] = 3755,
  [12519] = 3780,
  [12520] = 3838,
  [12521] = 3874,
  [12522] = 3782,
  [12523] = 3836,
  [12524] = 3841,
  [12525] = 3794,
  [12526] = 3842,
  [12527] = 3796,
  [12528] = 3875,
  [12529] = 3833,
  [12530] = 3832,
  [12531] = 3830,
  [12532] = 3829,
  [12533] = 3723,
  [12534] = 3783,
  [12535] = 12297,
  [12536] = 4560,
  [12537] = 3747,
  [12538] = 3844,
  [12539] = 3744,
  [12540] = 3774,
  [12541] = 3767,
  [12542] = 3783,
  [12543] = 3761,
  [12544] = 3757,
  [12545] = 3762,
  [12546] = 3764,
  [12547] = 3775,
  [12548] = 3781,
  [12549] = 4112,
  [12550] = 3778,
  [12551] = 3775,
  [12552] = 3829,
  [12553] = 3846,
  [12554] = 3760,
  [12555] = 4112,
  [12556] = 3777,
  [12557] = 3769,
  [12558] = 3749,
  [12559] = 4111,
  [12560] = 3772,
  [12561] = 3765,
  [12562] = 3750,
  [12563] = 3867,
  [12564] = 3780,
  [12565] = 3782,
  [12566] = 3723,
  [12567] = 4111,
  [12568] = 3751,
  [12569] = 3875,
  [12570] = 4135,
  [12571] = 3835,
  [12572] = 3758,
  [12573] = 3757,
  [12574] = 3774,
  [12575] = 4110,
  [12576] = 3815,
  [12577] = 4110,
  [12578] = 3754,
  [12579] = 3764,
  [12580] = 3789,
  [12581] = 3779,
  [12582] = 3791,
  [12583] = 3794,
  [12584] = 3839,
  [12585] = 10643,
  [12586] = 3796,
  [12587] = 3765,
  [12588] = 3767,
  [12589] = 10775,
  [12590] = 3754,
  [12591] = 3826,
  [12592] = 3841,
  [12593] = 3777,
  [12594] = 3781,
  [12595] = 10773,
  [12596] = 3842,
  [12597] = 3770,
  [12598] = 3746,
  [12599] = 4560,
  [12600] = 10772,
  [12601] = 3778,
  [12602] = 3846,
  [12603] = 3770,
  [12604] = 3839,
  [12605] = 4093,
  [12606] = 3755,
  [12607] = 3758,
  [12608] = 3844,
  [12609] = 3853,
  [12610] = 3843,
  [12611] = 4100,
  [12612] = 4099,
  [12613] = 4097,
  [12614] = 3783,
  [12615] = 3844,
  [12616] = 3791,
  [12617] = 4435,
  [12618] = 4560,
  [12619] = 3841,
  [12620] = 3843,
  [12621] = 10743,
  [12622] = 3746,
  [12623] = 10741,
  [12624] = 4455,
  [12625] = 4440,
  [12626] = 3843,
  [12627] = 12297,
  [12628] = 3842,
  [12629] = 3842,
  [12630] = 4095,
  [12631] = 4094,
  [12632] = 4093,
  [12633] = 3846,
  [12634] = 4089,
  [12635] = 3841,
  [12636] = 3839,
  [12637] = 4088,
  [12638] = 4087,
  [12639] = 4086,
  [12640] = 4101,
  [12641] = 4085,
  [12642] = 3758,
  [12643] = 4083,
  [12644] = 4081,
  [12645] = 3762,
  [12646] = 3806,
  [12647] = 4078,
  [12648] = 4356,
  [12649] = 3781,
  [12650] = 3846,
  [12651] = 3849,
  [12652] = 3850,
  [12653] = 4100,
  [12654] = 3778,
  [12655] = 3849,
  [12656] = 3825,
  [12657] = 3851,
  [12658] = 3760,
  [12659] = 3749,
  [12660] = 4099,
  [12661] = 4097,
  [12662] = 3747,
  [12663] = 3850,
  [12664] = 3826,
  [12665] = 10643,
  [12666] = 3750,
  [12667] = 3844,
  [12668] = 3751,
  [12669] = 3856,
  [12670] = 3757,
  [12671] = 3764,
  [12672] = 3857,
  [12673] = 3765,
  [12674] = 3825,
  [12675] = 3745,
  [12676] = 3851,
  [12677] = 3853,
  [12678] = 3754,
  [12679] = 3859,
  [12680] = 3856,
  [12681] = 3772,
  [12682] = 3857,
  [12683] = 3779,
  [12684] = 3838,
  [12685] = 3859,
  [12686] = 3770,
  [12687] = 3746,
  [12688] = 3826,
  [12689] = 3836,
  [12690] = 3758,
  [12691] = 3746,
  [12692] = 4095,
  [12693] = 3815,
  [12694] = 3775,
  [12695] = 3860,
  [12696] = 3835,
  [12697] = 3729,
  [12698] = 4356,
  [12699] = 3860,
  [12700] = 4094,
  [12701] = 3806,
  [12702] = 3861,
  [12703] = 4093,
  [12704] = 3861,
  [12705] = 3862,
  [12706] = 3826,
  [12707] = 4455,
  [12708] = 4089,
  [12709] = 3783,
  [12710] = 3862,
  [12711] = 4101,
  [12712] = 4440,
  [12713] = 10715,
  [12714] = 3755,
  [12715] = 4088,
  [12716] = 3833,
  [12717] = 4135,
  [12718] = 4087,
  [12719] = 4356,
  [12720] = 3747,
  [12721] = 3832,
  [12722] = 3849,
  [12723] = 3850,
  [12724] = 3825,
  [12725] = 3749,
  [12726] = 3750,
  [12727] = 3867,
  [12728] = 3724,
  [12729] = 10762,
  [12730] = 3751,
  [12731] = 3851,
  [12732] = 3757,
  [12733] = 3853,
  [12734] = 3870,
  [12735] = 10706,
  [12736] = 3856,
  [12737] = 3764,
  [12738] = 3857,
  [12739] = 4086,
  [12740] = 3830,
  [12741] = 3731,
  [12742] = 3765,
  [12743] = 3875,
  [12744] = 10643,
  [12745] = 4085,
  [12746] = 3859,
  [12747] = 4083,
  [12748] = 3754,
  [12749] = 3770,
  [12750] = 3777,
  [12751] = 3874,
  [12752] = 4435,
  [12753] = 3874,
  [12754] = 3860,
  [12755] = 3861,
  [12756] = 3862,
  [12757] = 3826,
  [12758] = 3870,
  [12759] = 4081,
  [12760] = 4078,
  [12761] = 3783,
  [12762] = 3781,
  [12763] = 3778,
  [12764] = 3867,
  [12765] = 12297,
  [12766] = 3867,
  [12767] = 10759,
  [12768] = 10757,
  [12769] = 3870,
  [12770] = 10756,
  [12771] = 3728,
  [12772] = 3775,
  [12773] = 10698,
  [12774] = 3875,
  [12775] = 4560,
  [12776] = 3825,
  [12777] = 10741,
  [12778] = 4094,
  [12779] = 4094,
  [12780] = 3791,
  [12781] = 12781,
  [12782] = 4110,
  [12783] = 3875,
  [12784] = 10743,
  [12785] = 3861,
  [12786] = 3862,
  [12787] = 10272,
  [12788] = 4111,
  [12789] = 10730,
  [12790] = 4111,
  [12791] = 4094,
  [12792] = 12792,
  [12793] = 3780,
  [12794] = 3782,
  [12795] = 3794,
  [12796] = 3796,
  [12797] = 10543,
  [12798] = 3775,
  [12799] = 4095,
  [12800] = 4095,
  [12801] = 3860,
  [12802] = 4093,
  [12803] = 3774,
  [12804] = 3757,
  [12805] = 10743,
  [12806] = 10698,
  [12807] = 12792,
  [12808] = 3846,
  [12809] = 10741,
  [12810] = 3767,
  [12811] = 3764,
  [12812] = 4112,
  [12813] = 12792,
  [12814] = 3829,
  [12815] = 4095,
  [12816] = 4083,
  [12817] = 3758,
  [12818] = 4112,
  [12819] = 4081,
  [12820] = 3859,
  [12821] = 3830,
  [12822] = 4078,
  [12823] = 4089,
  [12824] = 10741,
  [12825] = 3777,
  [12826] = 4094,
  [12827] = 4088,
  [12828] = 4086,
  [12829] = 3844,
  [12830] = 12792,
  [12831] = 3758,
  [12832] = 3843,
  [12833] = 3836,
  [12834] = 10756,
  [12835] = 4085,
  [12836] = 4087,
  [12837] = 12792,
  [12838] = 4097,
  [12839] = 4100,
  [12840] = 10773,
  [12841] = 3867,
  [12842] = 3842,
  [12843] = 10757,
  [12844] = 4099,
  [12845] = 10759,
  [12846] = 10762,
  [12847] = 3841,
  [12848] = 4086,
  [12849] = 3839,
  [12850] = 3751,
  [12851] = 10772,
  [12852] = 4085,
  [12853] = 3775,
  [12854] = 4093,
  [12855] = 3857,
  [12856] = 4135,
  [12857] = 3870,
  [12858] = 4099,
  [12859] = 3826,
  [12860] = 3853,
  [12861] = 10778,
  [12862] = 4100,
  [12863] = 10740,
  [12864] = 10505,
  [12865] = 3851,
  [12866] = 3825,
  [12867] = 10772,
  [12868] = 10723,
  [12869] = 3850,
  [12870] = 12792,
  [12871] = 4097,
  [12872] = 4095,
  [12873] = 12792,
  [12874] = 3856,
  [12875] = 3849,
  [12876] = 4097,
  [12877] = 4560,
  [12878] = 3770,
  [12879] = 3728,
  [12880] = 4099,
  [12881] = 10715,
  [12882] = 10706,
  [12883] = 3789,
  [12884] = 12792,
  [12885] = 3862,
  [12886] = 3861,
  [12887] = 4100,
  [12888] = 10715,
  [12889] = 4093,
  [12890] = 4089,
  [12891] = 10643,
  [12892] = 4088,
  [12893] = 10706,
  [12894] = 4110,
  [12895] = 12792,
  [12896] = 12792,
  [12897] = 10775,
  [12898] = 12781,
  [12899] = 11247,
  [12900] = 4086,
  [12901] = 12792,
  [12902] = 10643,
  [12903] = 4560,
  [12904] = 3769,
  [12905] = 3762,
  [12906] = 10643,
  [12907] = 4088,
  [12908] = 3833,
  [12909] = 10730,
  [12910] = 4095,
  [12911] = 4078,
  [12912] = 10706,
  [12913] = 12792,
  [12914] = 4087,
  [12915] = 4094,
  [12916] = 3826,
  [12917] = 8235,
  [12918] = 12792,
  [12919] = 4093,
  [12920] = 12792,
  [12921] = 3860,
  [12922] = 12792,
  [12923] = 4083,
  [12924] = 12792,
  [12925] = 10715,
  [12926] = 3754,
  [12927] = 3753,
  [12928] = 3762,
  [12929] = 4560,
  [12930] = 4087,
  [12931] = 4112,
  [12932] = 4081,
  [12933] = 4086,
  [12934] = 4089,
  [12935] = 4112,
  [12936] = 3760,
  [12937] = 3781,
  [12938] = 3767,
  [12939] = 4089,
  [12940] = 3774,
  [12941] = 3875,
  [12942] = 4078,
  [12943] = 10643,
  [12944] = 3846,
  [12945] = 4089,
  [12946] = 3874,
  [12947] = 12947,
  [12948] = 3765,
  [12949] = 3796,
  [12950] = 3764,
  [12951] = 3794,
  [12952] = 4088,
  [12953] = 3778,
  [12954] = 4088,
  [12955] = 3772,
  [12956] = 10743,
  [12957] = 10723,
  [12958] = 3782,
  [12959] = 3780,
  [12960] = 10730,
  [12961] = 4099,
  [12962] = 4087,
  [12963] = 3779,
  [12964] = 4088,
  [12965] = 4089,
  [12966] = 3760,
  [12967] = 4087,
  [12968] = 3791,
  [12969] = 3815,
  [12970] = 4083,
  [12971] = 10698,
  [12972] = 3844,
  [12973] = 4086,
  [12974] = 3874,
  [12975] = 3750,
  [12976] = 3870,
  [12977] = 3754,
  [12978] = 12792,
  [12979] = 3749,
  [12980] = 3757,
  [12981] = 10643,
  [12982] = 3843,
  [12983] = 12792,
  [12984] = 12781,
  [12985] = 3783,
  [12986] = 10768,
  [12987] = 4112,
  [12988] = 3842,
  [12989] = 3838,
  [12990] = 4111,
  [12991] = 4085,
  [12992] = 10491,
  [12993] = 10740,
  [12994] = 3761,
  [12995] = 12995,
  [12996] = 10756,
  [12997] = 10757,
  [12998] = 4135,
  [12999] = 3841,
  [13000] = 3750,
  [13001] = 3744,
  [13002] = 3839,
  [13003] = 3789,
  [13004] = 10741,
  [13005] = 12792,
  [13006] = 3769,
  [13007] = 10759,
  [13008] = 10762,
  [13009] = 3749,
  [13010] = 4099,
  [13011] = 3747,
  [13012] = 10778,
  [13013] = 4086,
  [13014] = 10773,
  [13015] = 4085,
  [13016] = 10775,
  [13017] = 10743,
  [13018] = 4083,
  [13019] = 4083,
  [13020] = 3867,
  [13021] = 4110,
  [13022] = 4081,
  [13023] = 3753,
  [13024] = 4560,
  [13025] = 3746,
  [13026] = 3829,
  [13027] = 4081,
  [13028] = 3875,
  [13029] = 4110,
  [13030] = 4081,
  [13031] = 3723,
  [13032] = 4078,
  [13033] = 3857,
  [13034] = 3859,
  [13035] = 4085,
  [13036] = 4078,
  [13037] = 3755,
  [13038] = 12792,
  [13039] = 12781,
  [13040] = 3745,
  [13041] = 10778,
  [13042] = 4093,
  [13043] = 4094,
  [13044] = 12792,
  [13045] = 4095,
  [13046] = 10740,
  [13047] = 10723,
  [13048] = 4111,
  [13049] = 4089,
  [13050] = 4110,
  [13051] = 3830,
  [13052] = 10756,
  [13053] = 13053,
  [13054] = 3862,
  [13055] = 3765,
  [13056] = 3761,
  [13057] = 3744,
  [13058] = 4088,
  [13059] = 3861,
  [13060] = 4135,
  [13061] = 4110,
  [13062] = 3874,
  [13063] = 4097,
  [13064] = 10715,
  [13065] = 3772,
  [13066] = 3779,
  [13067] = 10772,
  [13068] = 3860,
  [13069] = 10768,
  [13070] = 11247,
  [13071] = 4087,
  [13072] = 3730,
  [13073] = 4110,
  [13074] = 10698,
  [13075] = 13053,
  [13076] = 10704,
  [13077] = 4111,
  [13078] = 4093,
  [13079] = 4094,
  [13080] = 3832,
  [13081] = 4078,
  [13082] = 12792,
  [13083] = 4081,
  [13084] = 4112,
  [13085] = 12792,
  [13086] = 11247,
  [13087] = 4083,
  [13088] = 3839,
  [13089] = 10757,
  [13090] = 10759,
  [13091] = 10775,
  [13092] = 10772,
  [13093] = 10743,
  [13094] = 4085,
  [13095] = 10741,
  [13096] = 12792,
  [13097] = 12792,
  [13098] = 4086,
  [13099] = 13099,
  [13100] = 4135,
  [13101] = 3815,
  [13102] = 10768,
  [13103] = 4135,
  [13104] = 10773,
  [13105] = 13105,
  [13106] = 10756,
  [13107] = 4087,
  [13108] = 10762,
  [13109] = 4088,
  [13110] = 4112,
  [13111] = 4135,
  [13112] = 4089,
  [13113] = 4111,
  [13114] = 3746,
  [13115] = 3826,
  [13116] = 12792,
  [13117] = 3806,
  [13118] = 4100,
  [13119] = 4112,
  [13120] = 3859,
  [13121] = 4093,
  [13122] = 3857,
  [13123] = 3856,
  [13124] = 4094,
  [13125] = 12781,
  [13126] = 12792,
  [13127] = 4095,
  [13128] = 4095,
  [13129] = 3838,
  [13130] = 10757,
  [13131] = 10759,
  [13132] = 10762,
  [13133] = 4087,
  [13134] = 3836,
  [13135] = 11247,
  [13136] = 12792,
  [13137] = 10768,
  [13138] = 3835,
  [13139] = 4100,
  [13140] = 3833,
  [13141] = 3853,
  [13142] = 3832,
  [13143] = 3829,
  [13144] = 10768,
  [13145] = 10698,
  [13146] = 3747,
  [13147] = 3856,
  [13148] = 3841,
  [13149] = 12792,
  [13150] = 4111,
  [13151] = 3853,
  [13152] = 12792,
  [13153] = 12781,
  [13154] = 3777,
  [13155] = 4097,
  [13156] = 13156,
  [13157] = 3851,
  [13158] = 4100,
  [13159] = 4099,
  [13160] = 4135,
  [13161] = 3830,
  [13162] = 3835,
  [13163] = 12792,
  [13164] = 10773,
  [13165] = 10775,
  [13166] = 4100,
  [13167] = 12792,
  [13168] = 4099,
  [13169] = 3842,
  [13170] = 4097,
  [13171] = 4093,
  [13172] = 4100,
  [13173] = 10773,
  [13174] = 12792,
  [13175] = 4078,
  [13176] = 3832,
  [13177] = 3867,
  [13178] = 10704,
  [13179] = 10775,
  [13180] = 3850,
  [13181] = 10740,
  [13182] = 10756,
  [13183] = 10778,
  [13184] = 4099,
  [13185] = 3844,
  [13186] = 12792,
  [13187] = 11247,
  [13188] = 13099,
  [13189] = 10272,
  [13190] = 12792,
  [13191] = 12792,
  [13192] = 10706,
  [13193] = 4097,
  [13194] = 12792,
  [13195] = 3846,
  [13196] = 3870,
  [13197] = 3770,
  [13198] = 10643,
  [13199] = 12792,
  [13200] = 12947,
  [13201] = 3783,
  [13202] = 4111,
  [13203] = 10643,
  [13204] = 3755,
  [13205] = 3833,
  [13206] = 12792,
  [13207] = 10706,
  [13208] = 12792,
  [13209] = 10757,
  [13210] = 10704,
  [13211] = 12995,
  [13212] = 3751,
  [13213] = 4135,
  [13214] = 4560,
  [13215] = 12792,
  [13216] = 3806,
  [13217] = 4078,
  [13218] = 10715,
  [13219] = 10272,
  [13220] = 3849,
  [13221] = 4086,
  [13222] = 10778,
  [13223] = 10759,
  [13224] = 4081,
  [13225] = 3835,
  [13226] = 10704,
  [13227] = 4085,
  [13228] = 10698,
  [13229] = 3843,
  [13230] = 3849,
  [13231] = 12792,
  [13232] = 10730,
  [13233] = 10740,
  [13234] = 3781,
  [13235] = 3778,
  [13236] = 12792,
  [13237] = 3838,
  [13238] = 3850,
  [13239] = 10762,
  [13240] = 3836,
  [13241] = 10723,
  [13242] = 4110,
  [13243] = 4085,
  [13244] = 12792,
  [13245] = 13156,
  [13246] = 10643,
  [13247] = 10272,
  [13248] = 10730,
  [13249] = 4083,
  [13250] = 4081,
  [13251] = 3825,
  [13252] = 3851,
  [13253] = 12792,
  [13254] = 12792,
  [13255] = 4097,
  [13256] = 10772,
  [13257] = 10723,
  [13258] = 4083,
  [13259] = 3806,
  [13260] = 10272,
  [13261] = 10757,
  [13262] = 3830,
  [13263] = 13263,
  [13264] = 4078,
  [13265] = 3829,
  [13266] = 10762,
  [13267] = 13263,
  [13268] = 10772,
  [13269] = 4086,
  [13270] = 10698,
  [13271] = 3832,
  [13272] = 10778,
  [13273] = 10740,
  [13274] = 10715,
  [13275] = 3728,
  [13276] = 10706,
  [13277] = 4093,
  [13278] = 10775,
  [13279] = 13263,
  [13280] = 10698,
  [13281] = 10773,
  [13282] = 10759,
  [13283] = 10757,
  [13284] = 3835,
  [13285] = 10740,
  [13286] = 10756,
  [13287] = 13287,
  [13288] = 4078,
  [13289] = 10778,
  [13290] = 4081,
  [13291] = 3836,
  [13292] = 10775,
  [13293] = 10756,
  [13294] = 10706,
  [13295] = 10730,
  [13296] = 3838,
  [13297] = 10272,
  [13298] = 13263,
  [13299] = 4100,
  [13300] = 4083,
  [13301] = 10768,
  [13302] = 4099,
  [13303] = 10723,
  [13304] = 13263,
  [13305] = 10757,
  [13306] = 10505,
  [13307] = 10759,
  [13308] = 4085,
  [13309] = 10643,
  [13310] = 10756,
  [13311] = 4081,
  [13312] = 4097,
  [13313] = 10723,
  [13314] = 3860,
  [13315] = 10757,
  [13316] = 4086,
  [13317] = 10778,
  [13318] = 3839,
  [13319] = 10740,
  [13320] = 3841,
  [13321] = 3842,
  [13322] = 10706,
  [13323] = 13263,
  [13324] = 10762,
  [13325] = 3870,
  [13326] = 10730,
  [13327] = 10762,
  [13328] = 3843,
  [13329] = 10715,
  [13330] = 10759,
  [13331] = 10757,
  [13332] = 10768,
  [13333] = 4093,
  [13334] = 4087,
  [13335] = 3844,
  [13336] = 10762,
  [13337] = 3846,
  [13338] = 13263,
  [13339] = 10773,
  [13340] = 4088,
  [13341] = 10698,
  [13342] = 13342,
  [13343] = 10706,
  [13344] = 10741,
  [13345] = 10743,
  [13346] = 13346,
  [13347] = 10715,
  [13348] = 13263,
  [13349] = 13263,
  [13350] = 10706,
  [13351] = 10272,
  [13352] = 10543,
  [13353] = 13353,
  [13354] = 10698,
  [13355] = 4095,
  [13356] = 13263,
  [13357] = 10272,
  [13358] = 10775,
  [13359] = 10773,
  [13360] = 13263,
  [13361] = 10773,
  [13362] = 10775,
  [13363] = 3833,
  [13364] = 10698,
  [13365] = 10715,
  [13366] = 3729,
  [13367] = 10759,
  [13368] = 4083,
  [13369] = 4089,
  [13370] = 8235,
  [13371] = 13371,
  [13372] = 4135,
  [13373] = 10772,
  [13374] = 10741,
  [13375] = 12995,
  [13376] = 3867,
  [13377] = 10743,
  [13378] = 4088,
  [13379] = 3723,
  [13380] = 4089,
  [13381] = 4110,
  [13382] = 10698,
  [13383] = 13383,
  [13384] = 4112,
  [13385] = 4111,
  [13386] = 10756,
  [13387] = 4088,
  [13388] = 4087,
  [13389] = 12947,
  [13390] = 10775,
  [13391] = 4093,
  [13392] = 13263,
  [13393] = 4089,
  [13394] = 13394,
  [13395] = 13263,
  [13396] = 10743,
  [13397] = 8235,
  [13398] = 4111,
  [13399] = 13263,
  [13400] = 4112,
  [13401] = 4094,
  [13402] = 10706,
  [13403] = 10643,
  [13404] = 4095,
  [13405] = 10762,
  [13406] = 3826,
  [13407] = 13263,
  [13408] = 13099,
  [13409] = 3724,
  [13410] = 10768,
  [13411] = 10730,
  [13412] = 13371,
  [13413] = 13413,
  [13414] = 4110,
  [13415] = 10723,
  [13416] = 10741,
  [13417] = 10778,
  [13418] = 10740,
  [13419] = 10272,
  [13420] = 10698,
  [13421] = 4100,
  [13422] = 4099,
  [13423] = 10743,
  [13424] = 10768,
  [13425] = 4094,
  [13426] = 13263,
  [13427] = 10759,
  [13428] = 10272,
  [13429] = 13287,
  [13430] = 13263,
  [13431] = 13431,
  [13432] = 10741,
  [13433] = 4095,
  [13434] = 4097,
  [13435] = 10757,
  [13436] = 10723,
  [13437] = 10743,
  [13438] = 10730,
  [13439] = 13413,
  [13440] = 10743,
  [13441] = 10272,
  [13442] = 13263,
  [13443] = 10741,
  [13444] = 10772,
  [13445] = 3862,
  [13446] = 10756,
  [13447] = 13263,
  [13448] = 10704,
  [13449] = 13353,
  [13450] = 10773,
  [13451] = 3861,
  [13452] = 10775,
  [13453] = 4099,
  [13454] = 4100,
  [13455] = 10643,
  [13456] = 13456,
  [13457] = 13263,
  [13458] = 11247,
  [13459] = 10768,
  [13460] = 10773,
  [13461] = 10543,
  [13462] = 4085,
  [13463] = 10768,
  [13464] = 10768,
  [13465] = 11247,
  [13466] = 10772,
  [13467] = 10706,
  [13468] = 13413,
  [13469] = 10715,
  [13470] = 4094,
  [13471] = 3849,
  [13472] = 10715,
  [13473] = 13431,
  [13474] = 13156,
  [13475] = 13263,
  [13476] = 13263,
  [13477] = 13263,
  [13478] = 10704,
  [13479] = 13263,
  [13480] = 10715,
  [13481] = 8306,
  [13482] = 10704,
  [13483] = 10772,
  [13484] = 13287,
  [13485] = 10743,
  [13486] = 10740,
  [13487] = 10778,
  [13488] = 10741,
  [13489] = 10740,
  [13490] = 3758,
  [13491] = 3755,
  [13492] = 10778,
  [13493] = 4083,
  [13494] = 10706,
  [13495] = 13383,
  [13496] = 10741,
  [13497] = 10740,
  [13498] = 10775,
  [13499] = 3730,
  [13500] = 13263,
  [13501] = 10759,
  [13502] = 10756,
  [13503] = 10772,
  [13504] = 10778,
  [13505] = 4081,
  [13506] = 10756,
  [13507] = 4135,
  [13508] = 10757,
  [13509] = 10759,
  [13510] = 10762,
  [13511] = 13263,
  [13512] = 10772,
  [13513] = 10730,
  [13514] = 10757,
  [13515] = 10759,
  [13516] = 10723,
  [13517] = 10730,
  [13518] = 10723,
  [13519] = 4078,
  [13520] = 13053,
  [13521] = 3746,
  [13522] = 3874,
  [13523] = 10762,
  [13524] = 4135,
  [13525] = 10762,
  [13526] = 4087,
  [13527] = 4097,
  [13528] = 13456,
  [13529] = 10723,
  [13530] = 10723,
  [13531] = 10743,
  [13532] = 10772,
  [13533] = 11247,
  [13534] = 4110,
  [13535] = 10756,
  [13536] = 10730,
  [13537] = 3859,
  [13538] = 3875,
  [13539] = 10768,
  [13540] = 10505,
  [13541] = 3731,
  [13542] = 3850,
  [13543] = 3825,
  [13544] = 10740,
  [13545] = 10778,
  [13546] = 4085,
  [13547] = 4112,
  [13548] = 13263,
  [13549] = 10773,
  [13550] = 3851,
  [13551] = 8271,
  [13552] = 10775,
  [13553] = 4111,
  [13554] = 10773,
  [13555] = 13263,
  [13556] = 10730,
  [13557] = 10704,
  [13558] = 3853,
  [13559] = 10715,
  [13560] = 3856,
  [13561] = 4086,
  [13562] = 10698,
  [13563] = 3857,
  [13564] = 10741,
  [13565] = 13565,
  [13566] = 10772,
  [13567] = 13567,
  [13568] = 8381,
  [13569] = 13569,
  [13570] = 3747,
  [13571] = 13569,
  [13572] = 10505,
  [13573] = 10543,
  [13574] = 8398,
  [13575] = 4110,
  [13576] = 13567,
  [13577] = 13577,
  [13578] = 3755,
  [13579] = 10272,
  [13580] = 3806,
  [13581] = 10698,
  [13582] = 13567,
  [13583] = 13577,
  [13584] = 10272,
  [13585] = 10743,
  [13586] = 10741,
  [13587] = 3758,
  [13588] = 13567,
  [13589] = 10272,
  [13590] = 3789,
  [13591] = 10743,
  [13592] = 3753,
  [13593] = 13567,
  [13594] = 13567,
  [13595] = 8333,
  [13596] = 13577,
  [13597] = 10772,
  [13598] = 10272,
  [13599] = 3806,
  [13600] = 13567,
  [13601] = 3746,
  [13602] = 10756,
  [13603] = 10757,
  [13604] = 10759,
  [13605] = 8316,
  [13606] = 10768,
  [13607] = 10762,
  [13608] = 3723,
  [13609] = 10773,
  [13610] = 8414,
  [13611] = 3757,
  [13612] = 10715,
  [13613] = 13613,
  [13614] = 3774,
  [13615] = 13577,
  [13616] = 13616,
  [13617] = 13577,
  [13618] = 3749,
  [13619] = 10272,
  [13620] = 3750,
  [13621] = 13621,
  [13622] = 10741,
  [13623] = 3724,
  [13624] = 10773,
  [13625] = 10775,
  [13626] = 8426,
  [13627] = 8358,
  [13628] = 3796,
  [13629] = 3794,
  [13630] = 10543,
  [13631] = 10775,
  [13632] = 3782,
  [13633] = 3780,
  [13634] = 8356,
  [13635] = 10272,
  [13636] = 13567,
  [13637] = 13637,
  [13638] = 10706,
  [13639] = 13156,
  [13640] = 3751,
  [13641] = 10740,
  [13642] = 3730,
  [13643] = 13577,
  [13644] = 13577,
  [13645] = 10272,
  [13646] = 13646,
  [13647] = 3791,
  [13648] = 13577,
  [13649] = 10543,
  [13650] = 10740,
  [13651] = 10778,
  [13652] = 10772,
  [13653] = 13567,
  [13654] = 13099,
  [13655] = 10778,
  [13656] = 13577,
  [13657] = 13567,
  [13658] = 4111,
  [13659] = 13659,
  [13660] = 10698,
  [13661] = 3723,
  [13662] = 10505,
  [13663] = 13569,
  [13664] = 3772,
  [13665] = 3806,
  [13666] = 3779,
  [13667] = 13667,
  [13668] = 10762,
  [13669] = 3764,
  [13670] = 13567,
  [13671] = 13671,
  [13672] = 13567,
  [13673] = 3731,
  [13674] = 13674,
  [13675] = 8332,
  [13676] = 10741,
  [13677] = 13567,
  [13678] = 13577,
  [13679] = 10772,
  [13680] = 3767,
  [13681] = 8347,
  [13682] = 8369,
  [13683] = 3765,
  [13684] = 10743,
  [13685] = 10715,
  [13686] = 12995,
  [13687] = 13577,
  [13688] = 13613,
  [13689] = 10730,
  [13690] = 13567,
  [13691] = 12995,
  [13692] = 13567,
  [13693] = 13567,
  [13694] = 13577,
  [13695] = 13099,
  [13696] = 10723,
  [13697] = 8443,
  [13698] = 13577,
  [13699] = 3760,
  [13700] = 13456,
  [13701] = 13567,
  [13702] = 10723,
  [13703] = 10730,
  [13704] = 8375,
  [13705] = 13705,
  [13706] = 10505,
  [13707] = 13567,
  [13708] = 4135,
  [13709] = 13577,
  [13710] = 13567,
  [13711] = 13567,
  [13712] = 3762,
  [13713] = 13567,
  [13714] = 13567,
  [13715] = 3769,
  [13716] = 13577,
  [13717] = 13616,
  [13718] = 10756,
  [13719] = 4100,
  [13720] = 13577,
  [13721] = 3754,
  [13722] = 11247,
  [13723] = 4099,
  [13724] = 8324,
  [13725] = 13577,
  [13726] = 13567,
  [13727] = 13613,
  [13728] = 13577,
  [13729] = 13729,
  [13730] = 13567,
  [13731] = 13567,
  [13732] = 10543,
  [13733] = 10643,
  [13734] = 10505,
  [13735] = 13156,
  [13736] = 10775,
  [13737] = 13577,
  [13738] = 10773,
  [13739] = 13616,
  [13740] = 8306,
  [13741] = 13565,
  [13742] = 13577,
  [13743] = 10543,
  [13744] = 8271,
  [13745] = 3770,
  [13746] = 12947,
  [13747] = 3778,
  [13748] = 13567,
  [13749] = 13577,
  [13750] = 3729,
  [13751] = 13053,
  [13752] = 3781,
  [13753] = 10698,
  [13754] = 10543,
  [13755] = 13567,
  [13756] = 10778,
  [13757] = 8427,
  [13758] = 10740,
  [13759] = 10762,
  [13760] = 13729,
  [13761] = 8434,
  [13762] = 13371,
  [13763] = 13577,
  [13764] = 13431,
  [13765] = 10706,
  [13766] = 10759,
  [13767] = 10706,
  [13768] = 10757,
  [13769] = 13577,
  [13770] = 13577,
  [13771] = 3761,
  [13772] = 4097,
  [13773] = 13773,
  [13774] = 13567,
  [13775] = 13567,
  [13776] = 13567,
  [13777] = 13565,
  [13778] = 8379,
  [13779] = 3744,
  [13780] = 13577,
  [13781] = 10756,
  [13782] = 13577,
  [13783] = 3728,
  [13784] = 13567,
  [13785] = 13567,
  [13786] = 3723,
  [13787] = 13577,
  [13788] = 3815,
  [13789] = 10543,
  [13790] = 4094,
  [13791] = 13567,
  [13792] = 13567,
  [13793] = 8447,
  [13794] = 13577,
  [13795] = 13659,
  [13796] = 4086,
  [13797] = 12947,
  [13798] = 4093,
  [13799] = 8235,
  [13800] = 10272,
  [13801] = 13567,
  [13802] = 13577,
  [13803] = 13567,
  [13804] = 4112,
  [13805] = 10715,
  [13806] = 3775,
  [13807] = 13577,
  [13808] = 13567,
  [13809] = 8306,
  [13810] = 8378,
  [13811] = 13811,
  [13812] = 13729,
  [13813] = 13577,
  [13814] = 13567,
  [13815] = 4089,
  [13816] = 4088,
  [13817] = 8271,
  [13818] = 13353,
  [13819] = 13577,
  [13820] = 4087,
  [13821] = 10768,
  [13822] = 10757,
  [13823] = 13577,
  [13824] = 13567,
  [13825] = 10759,
  [13826] = 4095,
  [13827] = 13567,
  [13828] = 13577,
  [13829] = 13577,
  [13830] = 13705,
  [13831] = 13577,
  [13832] = 13567,
  [13833] = 4085,
  [13834] = 13834,
  [13835] = 13577,
  [13836] = 4083,
  [13837] = 4081,
  [13838] = 10723,
  [13839] = 13383,
  [13840] = 10505,
  [13841] = 13773,
  [13842] = 4078,
  [13843] = 13567,
  [13844] = 13383,
  [13845] = 3777,
  [13846] = 13577,
  [13847] = 13577,
  [13848] = 13848,
  [13849] = 13567,
  [13850] = 3783,
  [13851] = 13567,
  [13852] = 3723,
  [13853] = 13577,
  [13854] = 13577,
  [13855] = 13567,
  [13856] = 10730,
  [13857] = 13705,
  [13858] = 13577,
  [13859] = 13053,
  [13860] = 13577,
  [13861] = 10768,
  [13862] = 13577,
  [13863] = 13567,
  [13864] = 13577,
  [13865] = 10505,
  [13866] = 13577,
  [13867] = 10543,
  [13868] = 3723,
  [13869] = 13869,
  [13870] = 13870,
  [13871] = 8235,
  [13872] = 13870,
  [13873] = 8235,
  [13874] = 13869,
  [13875] = 13875,
  [13876] = 13876,
  [13877] = 8316,
  [13878] = 8427,
  [13879] = 3753,
  [13880] = 13880,
  [13881] = 8332,
  [13882] = 8347,
  [13883] = 13870,
  [13884] = 3767,
  [13885] = 3728,
  [13886] = 8434,
  [13887] = 10543,
  [13888] = 10505,
  [13889] = 13053,
  [13890] = 3778,
  [13891] = 8369,
  [13892] = 13870,
  [13893] = 13870,
  [13894] = 13870,
  [13895] = 3729,
  [13896] = 3730,
  [13897] = 3806,
  [13898] = 13898,
  [13899] = 13870,
  [13900] = 8426,
  [13901] = 13870,
  [13902] = 13870,
  [13903] = 13903,
  [13904] = 3780,
  [13905] = 13870,
  [13906] = 3762,
  [13907] = 3730,
  [13908] = 13908,
  [13909] = 13909,
  [13910] = 13870,
  [13911] = 13911,
  [13912] = 3755,
  [13913] = 13869,
  [13914] = 3770,
  [13915] = 13915,
  [13916] = 8414,
  [13917] = 13917,
  [13918] = 10543,
  [13919] = 3728,
  [13920] = 13920,
  [13921] = 13870,
  [13922] = 8306,
  [13923] = 13870,
  [13924] = 13870,
  [13925] = 13870,
  [13926] = 3723,
  [13927] = 13870,
  [13928] = 10543,
  [13929] = 3791,
  [13930] = 3723,
  [13931] = 13931,
  [13932] = 8316,
  [13933] = 3781,
  [13934] = 10543,
  [13935] = 13908,
  [13936] = 13869,
  [13937] = 13875,
  [13938] = 13911,
  [13939] = 3747,
  [13940] = 13870,
  [13941] = 13870,
  [13942] = 13870,
  [13943] = 3760,
  [13944] = 10756,
  [13945] = 13870,
  [13946] = 10543,
  [13947] = 13947,
  [13948] = 13870,
  [13949] = 10757,
  [13950] = 10759,
  [13951] = 13870,
  [13952] = 10762,
  [13953] = 13870,
  [13954] = 13869,
  [13955] = 3806,
  [13956] = 8443,
  [13957] = 13876,
  [13958] = 3775,
  [13959] = 8426,
  [13960] = 8375,
  [13961] = 10543,
  [13962] = 8427,
  [13963] = 13963,
  [13964] = 13870,
  [13965] = 13869,
  [13966] = 3783,
  [13967] = 13869,
  [13968] = 3730,
  [13969] = 10773,
  [13970] = 10775,
  [13971] = 10505,
  [13972] = 10543,
  [13973] = 10272,
  [13974] = 12995,
  [13975] = 13869,
  [13976] = 3723,
  [13977] = 10505,
  [13978] = 13870,
  [13979] = 13870,
  [13980] = 13870,
  [13981] = 13869,
  [13982] = 13773,
  [13983] = 8414,
  [13984] = 3731,
  [13985] = 13870,
  [13986] = 10505,
  [13987] = 3754,
  [13988] = 8443,
  [13989] = 13383,
  [13990] = 13870,
  [13991] = 8332,
  [13992] = 13870,
  [13993] = 8324,
  [13994] = 8447,
  [13995] = 3730,
  [13996] = 3749,
  [13997] = 13870,
  [13998] = 13870,
  [13999] = 10723,
  [14000] = 8379,
  [14001] = 8333,
  [14002] = 13870,
  [14003] = 3750,
  [14004] = 10730,
  [14005] = 14005,
  [14006] = 3758,
  [14007] = 14007,
  [14008] = 13870,
  [14009] = 8434,
  [14010] = 8447,
  [14011] = 8235,
  [14012] = 13870,
  [14013] = 14013,
  [14014] = 10505,
  [14015] = 13903,
  [14016] = 10505,
  [14017] = 13870,
  [14018] = 13908,
  [14019] = 3777,
  [14020] = 13869,
  [14021] = 13911,
  [14022] = 13869,
  [14023] = 13870,
  [14024] = 13870,
  [14025] = 10505,
  [14026] = 8378,
  [14027] = 13870,
  [14028] = 8398,
  [14029] = 10698,
  [14030] = 3772,
  [14031] = 13870,
  [14032] = 13870,
  [14033] = 3779,
  [14034] = 8381,
  [14035] = 8356,
  [14036] = 8347,
  [14037] = 3729,
  [14038] = 3724,
  [14039] = 14039,
  [14040] = 8378,
  [14041] = 3728,
  [14042] = 8356,
  [14043] = 8358,
  [14044] = 8324,
  [14045] = 8333,
  [14046] = 13917,
  [14047] = 8381,
  [14048] = 8358,
  [14049] = 10505,
  [14050] = 13870,
  [14051] = 12947,
  [14052] = 13931,
  [14053] = 10778,
  [14054] = 13646,
  [14055] = 13870,
  [14056] = 10740,
  [14057] = 8271,
  [14058] = 13870,
  [14059] = 8235,
  [14060] = 13099,
  [14061] = 8375,
  [14062] = 13870,
  [14063] = 3730,
  [14064] = 3723,
  [14065] = 13870,
  [14066] = 13915,
  [14067] = 13869,
  [14068] = 13646,
  [14069] = 13869,
  [14070] = 13870,
  [14071] = 13870,
  [14072] = 13870,
  [14073] = 3751,
  [14074] = 13870,
  [14075] = 13870,
  [14076] = 8398,
  [14077] = 3723,
  [14078] = 13870,
  [14079] = 3746,
  [14080] = 8369,
  [14081] = 13870,
  [14082] = 3728,
  [14083] = 10505,
  [14084] = 10768,
  [14085] = 13870,
  [14086] = 13870,
  [14087] = 8379,
  [14088] = 8235,
  [14089] = 3815,
  [14090] = 13869,
  [14091] = 3765,
  [14092] = 13870,
  [14093] = 13870,
  [14094] = 14039,
  [14095] = 3774,
  [14096] = 13870,
  [14097] = 3782,
  [14098] = 13870,
  [14099] = 3723,
  [14100] = 13898,
  [14101] = 13870,
  [14102] = 13870,
  [14103] = 13870,
  [14104] = 3757,
  [14105] = 13156,
  [14106] = 3761,
  [14107] = 3796,
  [14108] = 13870,
  [14109] = 13876,
  [14110] = 13870,
  [14111] = 13963,
  [14112] = 10715,
  [14113] = 13870,
  [14114] = 3769,
  [14115] = 3728,
  [14116] = 10743,
  [14117] = 10741,
  [14118] = 10772,
  [14119] = 3789,
  [14120] = 14013,
  [14121] = 3744,
  [14122] = 3794,
  [14123] = 14123,
  [14124] = 3764,
  [14125] = 10706,
  [14126] = 13880,
  [14127] = 13870,
  [14128] = 14128,
  [14129] = 3758,
  [14130] = 3780,
  [14131] = 10543,
  [14132] = 13773,
  [14133] = 3781,
  [14134] = 14134,
  [14135] = 8271,
  [14136] = 14136,
  [14137] = 3723,
  [14138] = 14138,
  [14139] = 14136,
  [14140] = 14140,
  [14141] = 8447,
  [14142] = 14142,
  [14143] = 14143,
  [14144] = 14144,
  [14145] = 3730,
  [14146] = 3746,
  [14147] = 14143,
  [14148] = 14136,
  [14149] = 3751,
  [14150] = 14136,
  [14151] = 14143,
  [14152] = 14152,
  [14153] = 3724,
  [14154] = 14138,
  [14155] = 14136,
  [14156] = 14142,
  [14157] = 14143,
  [14158] = 14136,
  [14159] = 14136,
  [14160] = 3746,
  [14161] = 14136,
  [14162] = 14136,
  [14163] = 3731,
  [14164] = 14143,
  [14165] = 3730,
  [14166] = 14143,
  [14167] = 14167,
  [14168] = 10715,
  [14169] = 14169,
  [14170] = 14143,
  [14171] = 3758,
  [14172] = 10706,
  [14173] = 8434,
  [14174] = 8427,
  [14175] = 14136,
  [14176] = 14136,
  [14177] = 14136,
  [14178] = 14136,
  [14179] = 14179,
  [14180] = 14180,
  [14181] = 3777,
  [14182] = 8306,
  [14183] = 8271,
  [14184] = 14143,
  [14185] = 3728,
  [14186] = 14143,
  [14187] = 14136,
  [14188] = 14039,
  [14189] = 14013,
  [14190] = 14136,
  [14191] = 14143,
  [14192] = 13917,
  [14193] = 14142,
  [14194] = 14194,
  [14195] = 14143,
  [14196] = 14196,
  [14197] = 14136,
  [14198] = 14136,
  [14199] = 14199,
  [14200] = 14200,
  [14201] = 3746,
  [14202] = 14143,
  [14203] = 8306,
  [14204] = 14200,
  [14205] = 14143,
  [14206] = 3723,
  [14207] = 14136,
  [14208] = 10743,
  [14209] = 3769,
  [14210] = 14136,
  [14211] = 14169,
  [14212] = 13931,
  [14213] = 14136,
  [14214] = 14136,
  [14215] = 14196,
  [14216] = 14136,
  [14217] = 3760,
  [14218] = 14169,
  [14219] = 14143,
  [14220] = 14136,
  [14221] = 14136,
  [14222] = 3724,
  [14223] = 14167,
  [14224] = 14224,
  [14225] = 10698,
  [14226] = 14144,
  [14227] = 14136,
  [14228] = 14136,
  [14229] = 14136,
  [14230] = 13811,
  [14231] = 14196,
  [14232] = 14136,
  [14233] = 14136,
  [14234] = 14128,
  [14235] = 14136,
  [14236] = 14143,
  [14237] = 14136,
  [14238] = 3723,
  [14239] = 14142,
  [14240] = 14136,
  [14241] = 14136,
  [14242] = 14242,
  [14243] = 8398,
  [14244] = 14143,
  [14245] = 14136,
  [14246] = 14143,
  [14247] = 10741,
  [14248] = 3791,
  [14249] = 14169,
  [14250] = 14143,
  [14251] = 3770,
  [14252] = 14143,
  [14253] = 14136,
  [14254] = 14136,
  [14255] = 14136,
  [14256] = 14136,
  [14257] = 14136,
  [14258] = 8332,
  [14259] = 3775,
  [14260] = 14136,
  [14261] = 14005,
  [14262] = 14143,
  [14263] = 14136,
  [14264] = 14136,
  [14265] = 3758,
  [14266] = 14005,
  [14267] = 14267,
  [14268] = 8316,
  [14269] = 14143,
  [14270] = 13909,
  [14271] = 14136,
  [14272] = 13909,
  [14273] = 8271,
  [14274] = 13621,
  [14275] = 14275,
  [14276] = 8306,
  [14277] = 14136,
  [14278] = 14136,
  [14279] = 8235,
  [14280] = 3729,
  [14281] = 14281,
  [14282] = 14136,
  [14283] = 14136,
  [14284] = 3757,
  [14285] = 14136,
  [14286] = 3753,
  [14287] = 3730,
  [14288] = 14136,
  [14289] = 14136,
  [14290] = 14136,
  [14291] = 14169,
  [14292] = 8358,
  [14293] = 14293,
  [14294] = 8379,
  [14295] = 8375,
  [14296] = 3764,
  [14297] = 14143,
  [14298] = 8235,
  [14299] = 3750,
  [14300] = 3744,
  [14301] = 3730,
  [14302] = 14136,
  [14303] = 3728,
  [14304] = 14143,
  [14305] = 3749,
  [14306] = 14136,
  [14307] = 14169,
  [14308] = 14136,
  [14309] = 14143,
  [14310] = 3794,
  [14311] = 13903,
  [14312] = 8356,
  [14313] = 14275,
  [14314] = 14169,
  [14315] = 14315,
  [14316] = 3723,
  [14317] = 8306,
  [14318] = 14318,
  [14319] = 3724,
  [14320] = 8443,
  [14321] = 3761,
  [14322] = 3731,
  [14323] = 3755,
  [14324] = 3729,
  [14325] = 14325,
  [14326] = 14143,
  [14327] = 14136,
  [14328] = 13963,
  [14329] = 14143,
  [14330] = 14136,
  [14331] = 14136,
  [14332] = 14136,
  [14333] = 14333,
  [14334] = 14143,
  [14335] = 14143,
  [14336] = 14136,
  [14337] = 14136,
  [14338] = 3762,
  [14339] = 14136,
  [14340] = 14136,
  [14341] = 14136,
  [14342] = 3774,
  [14343] = 14343,
  [14344] = 3815,
  [14345] = 14136,
  [14346] = 14136,
  [14347] = 14136,
  [14348] = 14123,
  [14349] = 14136,
  [14350] = 14136,
  [14351] = 14136,
  [14352] = 14352,
  [14353] = 3729,
  [14354] = 14354,
  [14355] = 8235,
  [14356] = 14143,
  [14357] = 14136,
  [14358] = 10526,
  [14359] = 14136,
  [14360] = 3782,
  [14361] = 14136,
  [14362] = 14143,
  [14363] = 14143,
  [14364] = 14364,
  [14365] = 14136,
  [14366] = 13773,
  [14367] = 14136,
  [14368] = 8369,
  [14369] = 3758,
  [14370] = 3755,
  [14371] = 14136,
  [14372] = 14136,
  [14373] = 8347,
  [14374] = 14136,
  [14375] = 14143,
  [14376] = 14136,
  [14377] = 14242,
  [14378] = 14143,
  [14379] = 3754,
  [14380] = 14136,
  [14381] = 14136,
  [14382] = 14136,
  [14383] = 14136,
  [14384] = 14136,
  [14385] = 14169,
  [14386] = 14005,
  [14387] = 14196,
  [14388] = 14136,
  [14389] = 14136,
  [14390] = 8378,
  [14391] = 14136,
  [14392] = 14242,
  [14393] = 14136,
  [14394] = 14143,
  [14395] = 14136,
  [14396] = 14318,
  [14397] = 3772,
  [14398] = 14136,
  [14399] = 3724,
  [14400] = 3758,
  [14401] = 14136,
  [14402] = 14136,
  [14403] = 14169,
  [14404] = 14136,
  [14405] = 14136,
  [14406] = 13909,
  [14407] = 14407,
  [14408] = 13811,
  [14409] = 8381,
  [14410] = 14136,
  [14411] = 14136,
  [14412] = 3783,
  [14413] = 14136,
  [14414] = 14142,
  [14415] = 14143,
  [14416] = 10505,
  [14417] = 3746,
  [14418] = 14325,
  [14419] = 3729,
  [14420] = 14267,
  [14421] = 10272,
  [14422] = 14136,
  [14423] = 14169,
  [14424] = 14136,
  [14425] = 3796,
  [14426] = 14136,
  [14427] = 3746,
  [14428] = 8426,
  [14429] = 14143,
  [14430] = 14196,
  [14431] = 14136,
  [14432] = 14136,
  [14433] = 3755,
  [14434] = 14136,
  [14435] = 8414,
  [14436] = 14136,
  [14437] = 14437,
  [14438] = 14136,
  [14439] = 8306,
  [14440] = 14136,
  [14441] = 14136,
  [14442] = 14281,
  [14443] = 14352,
  [14444] = 14407,
  [14445] = 3755,
  [14446] = 14199,
  [14447] = 3789,
  [14448] = 14136,
  [14449] = 14136,
  [14450] = 14136,
  [14451] = 3728,
  [14452] = 3778,
  [14453] = 14453,
  [14454] = 14136,
  [14455] = 13898,
  [14456] = 14136,
  [14457] = 14136,
  [14458] = 3731,
  [14459] = 3806,
  [14460] = 8333,
  [14461] = 14143,
  [14462] = 14136,
  [14463] = 14136,
  [14464] = 14464,
  [14465] = 3729,
  [14466] = 14143,
  [14467] = 14467,
  [14468] = 8324,
  [14469] = 3731,
  [14470] = 3779,
  [14471] = 3728,
  [14472] = 14136,
  [14473] = 3806,
  [14474] = 3747,
  [14475] = 14143,
  [14476] = 14136,
  [14477] = 14180,
  [14478] = 3724,
  [14479] = 3724,
  [14480] = 14136,
  [14481] = 14136,
  [14482] = 14136,
  [14483] = 14136,
  [14484] = 14136,
  [14485] = 14143,
  [14486] = 14140,
  [14487] = 14487,
  [14488] = 14488,
  [14489] = 14136,
  [14490] = 14143,
  [14491] = 14136,
  [14492] = 14169,
  [14493] = 14136,
  [14494] = 14136,
  [14495] = 8271,
  [14496] = 14136,
  [14497] = 14487,
  [14498] = 14498,
  [14499] = 14498,
  [14500] = 13875,
  [14501] = 14136,
  [14502] = 14502,
  [14503] = 14503,
  [14504] = 14325,
  [14505] = 14488,
  [14506] = 3730,
  [14507] = 14136,
  [14508] = 14136,
  [14509] = 14498,
  [14510] = 14224,
  [14511] = 3731,
  [14512] = 14134,
  [14513] = 14136,
  [14514] = 14143,
  [14515] = 14143,
  [14516] = 14136,
  [14517] = 3731,
  [14518] = 8271,
  [14519] = 14487,
  [14520] = 14136,
  [14521] = 14136,
  [14522] = 3765,
  [14523] = 14136,
  [14524] = 14143,
  [14525] = 14143,
  [14526] = 14364,
  [14527] = 14136,
  [14528] = 14293,
  [14529] = 14179,
  [14530] = 14169,
  [14531] = 3767,
  [14532] = 14169,
  [14533] = 3755,
  [14534] = 14169,
  [14535] = 14136,
  [14536] = 14136,
  [14537] = 14467,
  [14538] = 14224,
  [14539] = 14180,
  [14540] = 13646,
  [14541] = 14136,
  [14542] = 14143,
  [14543] = 8434,
  [14544] = 8375,
  [14545] = 3778,
  [14546] = 3796,
  [14547] = 3775,
  [14548] = 14548,
  [14549] = 3765,
  [14550] = 3794,
  [14551] = 8235,
  [14552] = 3791,
  [14553] = 3783,
  [14554] = 14554,
  [14555] = 3806,
  [14556] = 3770,
  [14557] = 3747,
  [14558] = 8324,
  [14559] = 3753,
  [14560] = 3761,
  [14561] = 3754,
  [14562] = 3765,
  [14563] = 3767,
  [14564] = 3789,
  [14565] = 3744,
  [14566] = 3770,
  [14567] = 14364,
  [14568] = 3764,
  [14569] = 3757,
  [14570] = 14570,
  [14571] = 3769,
  [14572] = 3751,
  [14573] = 3750,
  [14574] = 3749,
  [14575] = 8306,
  [14576] = 3747,
  [14577] = 3760,
  [14578] = 3755,
  [14579] = 8316,
  [14580] = 3762,
  [14581] = 3744,
  [14582] = 8306,
  [14583] = 8356,
  [14584] = 8358,
  [14585] = 3746,
  [14586] = 8347,
  [14587] = 14587,
  [14588] = 3754,
  [14589] = 14144,
  [14590] = 3765,
  [14591] = 14591,
  [14592] = 8398,
  [14593] = 3729,
  [14594] = 14594,
  [14595] = 3761,
  [14596] = 3758,
  [14597] = 14597,
  [14598] = 8271,
  [14599] = 3764,
  [14600] = 3762,
  [14601] = 14597,
  [14602] = 3758,
  [14603] = 3746,
  [14604] = 3724,
  [14605] = 3757,
  [14606] = 14281,
  [14607] = 8447,
  [14608] = 14608,
  [14609] = 8434,
  [14610] = 14610,
  [14611] = 3772,
  [14612] = 3779,
  [14613] = 8378,
  [14614] = 8381,
  [14615] = 3780,
  [14616] = 13646,
  [14617] = 3815,
  [14618] = 3774,
  [14619] = 3751,
  [14620] = 3746,
  [14621] = 14621,
  [14622] = 14622,
  [14623] = 8447,
  [14624] = 3758,
  [14625] = 8434,
  [14626] = 14587,
  [14627] = 3767,
  [14628] = 8427,
  [14629] = 8324,
  [14630] = 3750,
  [14631] = 8427,
  [14632] = 3781,
  [14633] = 14005,
  [14634] = 3749,
  [14635] = 8379,
  [14636] = 14636,
  [14637] = 3782,
  [14638] = 3780,
  [14639] = 8375,
  [14640] = 8271,
  [14641] = 3796,
  [14642] = 3779,
  [14643] = 8443,
  [14644] = 14644,
  [14645] = 8369,
  [14646] = 3772,
  [14647] = 8332,
  [14648] = 8426,
  [14649] = 8414,
  [14650] = 3794,
  [14651] = 3753,
  [14652] = 8333,
  [14653] = 10741,
  [14654] = 8447,
  [14655] = 3754,
  [14656] = 8333,
  [14657] = 3747,
  [14658] = 8381,
  [14659] = 3777,
  [14660] = 3769,
  [14661] = 3760,
  [14662] = 3783,
  [14663] = 8443,
  [14664] = 8378,
  [14665] = 3760,
  [14666] = 10743,
  [14667] = 8427,
  [14668] = 3769,
  [14669] = 3791,
  [14670] = 8316,
  [14671] = 13811,
  [14672] = 8379,
  [14673] = 8379,
  [14674] = 8324,
  [14675] = 3762,
  [14676] = 8375,
  [14677] = 3761,
  [14678] = 3744,
  [14679] = 3789,
  [14680] = 14144,
  [14681] = 3775,
  [14682] = 14199,
  [14683] = 3783,
  [14684] = 8443,
  [14685] = 3728,
  [14686] = 10505,
  [14687] = 8369,
  [14688] = 3772,
  [14689] = 3781,
  [14690] = 8347,
  [14691] = 3778,
  [14692] = 8414,
  [14693] = 8332,
  [14694] = 3779,
  [14695] = 14152,
  [14696] = 10526,
  [14697] = 3723,
  [14698] = 3731,
  [14699] = 8426,
  [14700] = 8426,
  [14701] = 3780,
  [14702] = 3774,
  [14703] = 14293,
  [14704] = 8414,
  [14705] = 14318,
  [14706] = 3782,
  [14707] = 8375,
  [14708] = 14407,
  [14709] = 14709,
  [14710] = 13621,
  [14711] = 3815,
  [14712] = 14621,
  [14713] = 14713,
  [14714] = 14714,
  [14715] = 8369,
  [14716] = 3774,
  [14717] = 14570,
  [14718] = 3750,
  [14719] = 8347,
  [14720] = 3815,
  [14721] = 3755,
  [14722] = 3774,
  [14723] = 3815,
  [14724] = 8332,
  [14725] = 3770,
  [14726] = 14554,
  [14727] = 14709,
  [14728] = 8333,
  [14729] = 3782,
  [14730] = 3780,
  [14731] = 8427,
  [14732] = 10698,
  [14733] = 14733,
  [14734] = 3767,
  [14735] = 8332,
  [14736] = 3806,
  [14737] = 8347,
  [14738] = 14610,
  [14739] = 3779,
  [14740] = 3772,
  [14741] = 14714,
  [14742] = 3729,
  [14743] = 8381,
  [14744] = 8378,
  [14745] = 14407,
  [14746] = 8369,
  [14747] = 3781,
  [14748] = 3778,
  [14749] = 3782,
  [14750] = 3796,
  [14751] = 8443,
  [14752] = 8375,
  [14753] = 3769,
  [14754] = 14754,
  [14755] = 8379,
  [14756] = 8316,
  [14757] = 3760,
  [14758] = 14758,
  [14759] = 3762,
  [14760] = 3770,
  [14761] = 3755,
  [14762] = 3754,
  [14763] = 13909,
  [14764] = 3755,
  [14765] = 14144,
  [14766] = 3775,
  [14767] = 14167,
  [14768] = 3761,
  [14769] = 3744,
  [14770] = 8426,
  [14771] = 14594,
  [14772] = 8414,
  [14773] = 3789,
  [14774] = 14591,
  [14775] = 8434,
  [14776] = 8356,
  [14777] = 3749,
  [14778] = 14179,
  [14779] = 8358,
  [14780] = 8333,
  [14781] = 3770,
  [14782] = 3777,
  [14783] = 3753,
  [14784] = 3765,
  [14785] = 3769,
  [14786] = 14786,
  [14787] = 13646,
  [14788] = 3746,
  [14789] = 3754,
  [14790] = 14790,
  [14791] = 8381,
  [14792] = 8378,
  [14793] = 14713,
  [14794] = 14794,
  [14795] = 8447,
  [14796] = 14794,
  [14797] = 3765,
  [14798] = 14798,
  [14799] = 3775,
  [14800] = 3777,
  [14801] = 8316,
  [14802] = 3758,
  [14803] = 3757,
  [14804] = 14804,
  [14805] = 3753,
  [14806] = 14636,
  [14807] = 8398,
  [14808] = 3791,
  [14809] = 3751,
  [14810] = 13773,
  [14811] = 3724,
  [14812] = 3731,
  [14813] = 3753,
  [14814] = 3764,
  [14815] = 3757,
  [14816] = 3731,
  [14817] = 14817,
  [14818] = 3789,
  [14819] = 13646,
  [14820] = 8358,
  [14821] = 3751,
  [14822] = 8398,
  [14823] = 3775,
  [14824] = 3794,
  [14825] = 8356,
  [14826] = 3796,
  [14827] = 3750,
  [14828] = 14790,
  [14829] = 3749,
  [14830] = 3724,
  [14831] = 14831,
  [14832] = 3806,
  [14833] = 3744,
  [14834] = 3761,
  [14835] = 3750,
  [14836] = 3782,
  [14837] = 3767,
  [14838] = 3789,
  [14839] = 3791,
  [14840] = 3791,
  [14841] = 3749,
  [14842] = 3780,
  [14843] = 14467,
  [14844] = 14798,
  [14845] = 8306,
  [14846] = 3791,
  [14847] = 8356,
  [14848] = 3794,
  [14849] = 3796,
  [14850] = 3764,
  [14851] = 8358,
  [14852] = 10743,
  [14853] = 10741,
  [14854] = 14333,
  [14855] = 3774,
  [14856] = 3767,
  [14857] = 3794,
  [14858] = 8324,
  [14859] = 14597,
  [14860] = 14488,
  [14861] = 3815,
  [14862] = 3796,
  [14863] = 3729,
  [14864] = 3747,
  [14865] = 14275,
  [14866] = 14128,
  [14867] = 3789,
  [14868] = 3777,
  [14869] = 3778,
  [14870] = 3757,
  [14871] = 14758,
  [14872] = 8398,
  [14873] = 14587,
  [14874] = 3781,
  [14875] = 3744,
  [14876] = 10715,
  [14877] = 10706,
  [14878] = 14878,
  [14879] = 3747,
  [14880] = 3761,
  [14881] = 3777,
  [14882] = 14882,
  [14883] = 10772,
  [14884] = 14138,
  [14885] = 10706,
  [14886] = 10715,
  [14887] = 13646,
  [14888] = 3794,
  [14889] = 3775,
  [14890] = 14644,
  [14891] = 8316,
  [14892] = 3762,
  [14893] = 3760,
  [14894] = 3815,
  [14895] = 8398,
  [14896] = 8378,
  [14897] = 3774,
  [14898] = 14898,
  [14899] = 8381,
  [14900] = 3778,
  [14901] = 14267,
  [14902] = 3781,
  [14903] = 14354,
  [14904] = 3767,
  [14905] = 3724,
  [14906] = 3769,
  [14907] = 8333,
  [14908] = 14610,
  [14909] = 3777,
  [14910] = 8358,
  [14911] = 14733,
  [14912] = 8271,
  [14913] = 8356,
  [14914] = 14144,
  [14915] = 3778,
  [14916] = 3781,
  [14917] = 3764,
  [14918] = 14754,
  [14919] = 3806,
  [14920] = 14437,
  [14921] = 14786,
  [14922] = 3760,
  [14923] = 3755,
  [14924] = 8414,
  [14925] = 8426,
  [14926] = 3751,
  [14927] = 3783,
  [14928] = 3762,
  [14929] = 3731,
  [14930] = 3806,
  [14931] = 14798,
  [14932] = 3783,
  [14933] = 3783,
  [14934] = 3747,
  [14935] = 3749,
  [14936] = 3750,
  [14937] = 8447,
  [14938] = 3751,
  [14939] = 14794,
  [14940] = 8332,
  [14941] = 13646,
  [14942] = 14140,
  [14943] = 8347,
  [14944] = 3757,
  [14945] = 8369,
  [14946] = 3764,
  [14947] = 14622,
  [14948] = 8443,
  [14949] = 8324,
  [14950] = 10698,
  [14951] = 3772,
  [14952] = 8434,
  [14953] = 3779,
  [14954] = 3765,
  [14955] = 8427,
  [14956] = 3754,
  [14957] = 3780,
  [14958] = 14594,
  [14959] = 3777,
  [14960] = 14831,
  [14961] = 14591,
  [14962] = 3772,
  [14963] = 3779,
  [14964] = 3770,
  [14965] = 8379,
  [14966] = 14134,
  [14967] = 3782,
  [14968] = 3755,
  [14969] = 3729,
  [14970] = 14970,
  [14971] = 14971,
  [14972] = 14972,
  [14973] = 3764,
  [14974] = 14974,
  [14975] = 10698,
  [14976] = 14882,
  [14977] = 14972,
  [14978] = 14970,
  [14979] = 14979,
  [14980] = 3753,
  [14981] = 14981,
  [14982] = 14982,
  [14983] = 14983,
  [14984] = 14644,
  [14985] = 14972,
  [14986] = 14972,
  [14987] = 14972,
  [14988] = 14970,
  [14989] = 14989,
  [14990] = 14990,
  [14991] = 3749,
  [14992] = 14992,
  [14993] = 14970,
  [14994] = 3750,
  [14995] = 14898,
  [14996] = 14996,
  [14997] = 3783,
  [14998] = 14998,
  [14999] = 14999,
  [15000] = 14790,
  [15001] = 15001,
  [15002] = 3753,
  [15003] = 15003,
  [15004] = 14970,
  [15005] = 15005,
  [15006] = 15006,
  [15007] = 14970,
  [15008] = 15008,
  [15009] = 8333,
  [15010] = 15010,
  [15011] = 15011,
  [15012] = 8358,
  [15013] = 8356,
  [15014] = 15014,
  [15015] = 14972,
  [15016] = 3791,
  [15017] = 14972,
  [15018] = 14972,
  [15019] = 15019,
  [15020] = 14758,
  [15021] = 15021,
  [15022] = 15014,
  [15023] = 15023,
  [15024] = 14972,
  [15025] = 14972,
  [15026] = 3794,
  [15027] = 14713,
  [15028] = 14488,
  [15029] = 10715,
  [15030] = 14972,
  [15031] = 10741,
  [15032] = 3749,
  [15033] = 15033,
  [15034] = 15034,
  [15035] = 14972,
  [15036] = 15036,
  [15037] = 14972,
  [15038] = 14970,
  [15039] = 15039,
  [15040] = 10743,
  [15041] = 15041,
  [15042] = 14970,
  [15043] = 3757,
  [15044] = 14970,
  [15045] = 14970,
  [15046] = 3765,
  [15047] = 3781,
  [15048] = 15005,
  [15049] = 14972,
  [15050] = 14972,
  [15051] = 3751,
  [15052] = 14972,
  [15053] = 3778,
  [15054] = 14128,
  [15055] = 15010,
  [15056] = 15056,
  [15057] = 3751,
  [15058] = 15058,
  [15059] = 15059,
  [15060] = 15060,
  [15061] = 15005,
  [15062] = 14972,
  [15063] = 15063,
  [15064] = 15059,
  [15065] = 15065,
  [15066] = 15066,
  [15067] = 14972,
  [15068] = 3750,
  [15069] = 14972,
  [15070] = 15070,
  [15071] = 14972,
  [15072] = 15056,
  [15073] = 15073,
  [15074] = 14972,
  [15075] = 14144,
  [15076] = 15076,
  [15077] = 15070,
  [15078] = 10772,
  [15079] = 3744,
  [15080] = 3754,
  [15081] = 14972,
  [15082] = 15019,
  [15083] = 14970,
  [15084] = 3796,
  [15085] = 15085,
  [15086] = 14970,
  [15087] = 10741,
  [15088] = 15088,
  [15089] = 14972,
  [15090] = 14636,
  [15091] = 15014,
  [15092] = 3761,
  [15093] = 15093,
  [15094] = 8381,
  [15095] = 10706,
  [15096] = 3762,
  [15097] = 3770,
  [15098] = 14974,
  [15099] = 15041,
  [15100] = 14972,
  [15101] = 3770,
  [15102] = 15039,
  [15103] = 3757,
  [15104] = 8378,
  [15105] = 3751,
  [15106] = 14999,
  [15107] = 15107,
  [15108] = 3806,
  [15109] = 8443,
  [15110] = 15110,
  [15111] = 14970,
  [15112] = 14972,
  [15113] = 3767,
  [15114] = 14972,
  [15115] = 3757,
  [15116] = 14972,
  [15117] = 14972,
  [15118] = 3754,
  [15119] = 3747,
  [15120] = 15120,
  [15121] = 3767,
  [15122] = 15122,
  [15123] = 15123,
  [15124] = 14972,
  [15125] = 14972,
  [15126] = 3772,
  [15127] = 14972,
  [15128] = 14972,
  [15129] = 3765,
  [15130] = 3796,
  [15131] = 14971,
  [15132] = 14983,
  [15133] = 15133,
  [15134] = 14972,
  [15135] = 8398,
  [15136] = 14167,
  [15137] = 10698,
  [15138] = 14970,
  [15139] = 3764,
  [15140] = 8414,
  [15141] = 8426,
  [15142] = 14970,
  [15143] = 3794,
  [15144] = 14970,
  [15145] = 3775,
  [15146] = 14983,
  [15147] = 14971,
  [15148] = 14972,
  [15149] = 14972,
  [15150] = 8447,
  [15151] = 14972,
  [15152] = 14972,
  [15153] = 3791,
  [15154] = 15154,
  [15155] = 14972,
  [15156] = 15156,
  [15157] = 15005,
  [15158] = 14972,
  [15159] = 8434,
  [15160] = 3731,
  [15161] = 14621,
  [15162] = 3764,
  [15163] = 8271,
  [15164] = 14972,
  [15165] = 15165,
  [15166] = 15166,
  [15167] = 14972,
  [15168] = 15168,
  [15169] = 3757,
  [15170] = 15170,
  [15171] = 8434,
  [15172] = 3750,
  [15173] = 8427,
  [15174] = 15085,
  [15175] = 15008,
  [15176] = 3749,
  [15177] = 14972,
  [15178] = 14972,
  [15179] = 3724,
  [15180] = 14972,
  [15181] = 15014,
  [15182] = 8379,
  [15183] = 14972,
  [15184] = 3765,
  [15185] = 15063,
  [15186] = 15005,
  [15187] = 3806,
  [15188] = 14972,
  [15189] = 3764,
  [15190] = 15190,
  [15191] = 3751,
  [15192] = 3731,
  [15193] = 3789,
  [15194] = 8375,
  [15195] = 3760,
  [15196] = 14972,
  [15197] = 15019,
  [15198] = 3747,
  [15199] = 14970,
  [15200] = 3754,
  [15201] = 14972,
  [15202] = 14972,
  [15203] = 3769,
  [15204] = 14972,
  [15205] = 15205,
  [15206] = 14972,
  [15207] = 14970,
  [15208] = 3775,
  [15209] = 15001,
  [15210] = 14972,
  [15211] = 8316,
  [15212] = 15212,
  [15213] = 14992,
  [15214] = 14972,
  [15215] = 14970,
  [15216] = 14488,
  [15217] = 15217,
  [15218] = 3765,
  [15219] = 15219,
  [15220] = 15220,
  [15221] = 3789,
  [15222] = 3783,
  [15223] = 14990,
  [15224] = 14972,
  [15225] = 14970,
  [15226] = 14709,
  [15227] = 3781,
  [15228] = 15228,
  [15229] = 14974,
  [15230] = 14972,
  [15231] = 15212,
  [15232] = 3767,
  [15233] = 14714,
  [15234] = 3778,
  [15235] = 3777,
  [15236] = 3754,
  [15237] = 14554,
  [15238] = 14970,
  [15239] = 14970,
  [15240] = 15240,
  [15241] = 15241,
  [15242] = 14972,
  [15243] = 14972,
  [15244] = 15244,
  [15245] = 15217,
  [15246] = 15246,
  [15247] = 14570,
  [15248] = 3750,
  [15249] = 3778,
  [15250] = 10743,
  [15251] = 3749,
  [15252] = 8324,
  [15253] = 14970,
  [15254] = 14972,
  [15255] = 3747,
  [15256] = 15220,
  [15257] = 8398,
  [15258] = 14882,
  [15259] = 15259,
  [15260] = 8369,
  [15261] = 14970,
  [15262] = 15262,
  [15263] = 14972,
  [15264] = 8347,
  [15265] = 15265,
  [15266] = 14972,
  [15267] = 3775,
  [15268] = 14636,
  [15269] = 14713,
  [15270] = 8332,
  [15271] = 14972,
  [15272] = 14970,
  [15273] = 14998,
  [15274] = 14972,
  [15275] = 14972,
  [15276] = 8447,
  [15277] = 3770,
  [15278] = 14713,
  [15279] = 8426,
  [15280] = 14972,
  [15281] = 15281,
  [15282] = 3781,
  [15283] = 10743,
  [15284] = 14972,
  [15285] = 13646,
  [15286] = 14974,
  [15287] = 8427,
  [15288] = 14972,
  [15289] = 15240,
  [15290] = 8414,
  [15291] = 14898,
  [15292] = 8356,
  [15293] = 14972,
  [15294] = 8434,
  [15295] = 15219,
  [15296] = 15296,
  [15297] = 3770,
  [15298] = 15298,
  [15299] = 8427,
  [15300] = 14972,
  [15301] = 15219,
  [15302] = 14982,
  [15303] = 14831,
  [15304] = 14971,
  [15305] = 15305,
  [15306] = 3815,
  [15307] = 14972,
  [15308] = 3723,
  [15309] = 3775,
  [15310] = 3815,
  [15311] = 14972,
  [15312] = 14128,
  [15313] = 3780,
  [15314] = 8358,
  [15315] = 14972,
  [15316] = 3774,
  [15317] = 8333,
  [15318] = 15241,
  [15319] = 15319,
  [15320] = 14998,
  [15321] = 14972,
  [15322] = 3747,
  [15323] = 14983,
  [15324] = 14333,
  [15325] = 8381,
  [15326] = 8378,
  [15327] = 14972,
  [15328] = 14972,
  [15329] = 8398,
  [15330] = 14972,
  [15331] = 3774,
  [15332] = 14138,
  [15333] = 3815,
  [15334] = 14970,
  [15335] = 15244,
  [15336] = 15336,
  [15337] = 10772,
  [15338] = 10741,
  [15339] = 14972,
  [15340] = 14167,
  [15341] = 15063,
  [15342] = 14972,
  [15343] = 15060,
  [15344] = 14972,
  [15345] = 14134,
  [15346] = 14970,
  [15347] = 14996,
  [15348] = 3774,
  [15349] = 14970,
  [15350] = 8379,
  [15351] = 14570,
  [15352] = 8379,
  [15353] = 14972,
  [15354] = 14972,
  [15355] = 8316,
  [15356] = 8375,
  [15357] = 8375,
  [15358] = 15358,
  [15359] = 14333,
  [15360] = 14972,
  [15361] = 3782,
  [15362] = 14970,
  [15363] = 14972,
  [15364] = 15364,
  [15365] = 14972,
  [15366] = 14970,
  [15367] = 15367,
  [15368] = 14972,
  [15369] = 14972,
  [15370] = 8447,
  [15371] = 3782,
  [15372] = 8358,
  [15373] = 3772,
  [15374] = 14140,
  [15375] = 15107,
  [15376] = 10715,
  [15377] = 14972,
  [15378] = 13811,
  [15379] = 8443,
  [15380] = 3724,
  [15381] = 15381,
  [15382] = 14972,
  [15383] = 14972,
  [15384] = 15367,
  [15385] = 15385,
  [15386] = 3780,
  [15387] = 14972,
  [15388] = 3783,
  [15389] = 14786,
  [15390] = 14970,
  [15391] = 3779,
  [15392] = 15070,
  [15393] = 15244,
  [15394] = 3730,
  [15395] = 15241,
  [15396] = 15240,
  [15397] = 14972,
  [15398] = 3780,
  [15399] = 13811,
  [15400] = 3779,
  [15401] = 14972,
  [15402] = 14972,
  [15403] = 15336,
  [15404] = 14972,
  [15405] = 3772,
  [15406] = 10698,
  [15407] = 3782,
  [15408] = 3777,
  [15409] = 14970,
  [15410] = 3769,
  [15411] = 8324,
  [15412] = 3744,
  [15413] = 3760,
  [15414] = 14972,
  [15415] = 14972,
  [15416] = 3729,
  [15417] = 15166,
  [15418] = 15093,
  [15419] = 3746,
  [15420] = 8443,
  [15421] = 8369,
  [15422] = 14754,
  [15423] = 8347,
  [15424] = 14972,
  [15425] = 3728,
  [15426] = 14972,
  [15427] = 3762,
  [15428] = 14972,
  [15429] = 15364,
  [15430] = 14972,
  [15431] = 14733,
  [15432] = 15265,
  [15433] = 14970,
  [15434] = 3796,
  [15435] = 10706,
  [15436] = 3769,
  [15437] = 8332,
  [15438] = 10715,
  [15439] = 14972,
  [15440] = 14972,
  [15441] = 14972,
  [15442] = 15156,
  [15443] = 14144,
  [15444] = 14972,
  [15445] = 3760,
  [15446] = 14972,
  [15447] = 15154,
  [15448] = 3744,
  [15449] = 10706,
  [15450] = 3767,
  [15451] = 10706,
  [15452] = 3794,
  [15453] = 15453,
  [15454] = 15454,
  [15455] = 8426,
  [15456] = 15076,
  [15457] = 3777,
  [15458] = 3730,
  [15459] = 8414,
  [15460] = 10698,
  [15461] = 14972,
  [15462] = 15262,
  [15463] = 14970,
  [15464] = 14970,
  [15465] = 14972,
  [15466] = 14981,
  [15467] = 14989,
  [15468] = 15468,
  [15469] = 15073,
  [15470] = 3761,
  [15471] = 3796,
  [15472] = 8333,
  [15473] = 14972,
  [15474] = 3806,
  [15475] = 15475,
  [15476] = 15165,
  [15477] = 15477,
  [15478] = 3789,
  [15479] = 14983,
  [15480] = 14971,
  [15481] = 14972,
  [15482] = 14970,
  [15483] = 13646,
  [15484] = 14972,
  [15485] = 3744,
  [15486] = 3761,
  [15487] = 3794,
  [15488] = 14972,
  [15489] = 14972,
  [15490] = 3762,
  [15491] = 3723,
  [15492] = 8381,
  [15493] = 15319,
  [15494] = 14140,
  [15495] = 8378,
  [15496] = 10741,
  [15497] = 10743,
  [15498] = 3762,
  [15499] = 15499,
  [15500] = 14134,
  [15501] = 13646,
  [15502] = 15502,
  [15503] = 15503,
  [15504] = 3753,
  [15505] = 14970,
  [15506] = 3760,
  [15507] = 3769,
  [15508] = 14972,
  [15509] = 14970,
  [15510] = 15058,
  [15511] = 15511,
  [15512] = 3772,
  [15513] = 3779,
  [15514] = 15514,
  [15515] = 15515,
  [15516] = 14972,
  [15517] = 14972,
  [15518] = 3778,
  [15519] = 3780,
  [15520] = 3782,
  [15521] = 10715,
  [15522] = 8332,
  [15523] = 14972,
  [15524] = 14972,
  [15525] = 14972,
  [15526] = 15170,
  [15527] = 3791,
  [15528] = 15528,
  [15529] = 15170,
  [15530] = 8316,
  [15531] = 8369,
  [15532] = 15532,
  [15533] = 3761,
  [15534] = 15165,
  [15535] = 3791,
  [15536] = 15536,
  [15537] = 3781,
  [15538] = 14970,
  [15539] = 14972,
  [15540] = 15014,
  [15541] = 15011,
  [15542] = 14972,
  [15543] = 15066,
  [15544] = 14972,
  [15545] = 14972,
  [15546] = 15546,
  [15547] = 15547,
  [15548] = 3774,
  [15549] = 3806,
  [15550] = 14333,
  [15551] = 14882,
  [15552] = 15023,
  [15553] = 15006,
  [15554] = 15107,
  [15555] = 9122,
  [15556] = 9125,
  [15557] = 3815,
  [15558] = 15511,
  [15559] = 14972,
  [15560] = 14972,
  [15561] = 15156,
  [15562] = 3758,
  [15563] = 15503,
  [15564] = 15502,
  [15565] = 14970,
  [15566] = 15154,
  [15567] = 8347,
  [15568] = 15475,
  [15569] = 14972,
  [15570] = 3789,
  [15571] = 15019,
  [15572] = 15536,
  [15573] = 3806,
  [15574] = 14972,
  [15575] = 15281,
  [15576] = 14972,
  [15577] = 14972,
  [15578] = 14979,
  [15579] = 15305,
  [15580] = 14974,
  [15581] = 14972,
  [15582] = 8324,
  [15583] = 15034,
  [15584] = 15454,
  [15585] = 14138,
  [15586] = 14970,
  [15587] = 14970,
  [15588] = 14972,
  [15589] = 3779,
  [15590] = 15006,
  [15591] = 14972,
  [15592] = 3728,
  [15593] = 15019,
  [15594] = 14970,
  [15595] = 15133,
  [15596] = 15014,
  [15597] = 14972,
  [15598] = 14972,
  [15599] = 3783,
  [15600] = 8306,
  [15601] = 15532,
  [15602] = 15076,
  [15603] = 15073,
  [15604] = 14972,
  [15605] = 15066,
  [15606] = 15003,
  [15607] = 14972,
  [15608] = 14972,
  [15609] = 15058,
  [15610] = 15610,
  [15611] = 3729,
  [15612] = 14970,
  [15613] = 8356,
  [15614] = 14898,
  [15615] = 15453,
  [15616] = 14970,
  [15617] = 14972,
  [15618] = 15008,
  [15619] = 14970,
  [15620] = 14972,
  [15621] = 15005,
  [15622] = 15622,
  [15623] = 14972,
  [15624] = 14972,
  [15625] = 15625,
  [15626] = 15381,
  [15627] = 3815,
  [15628] = 15628,
  [15629] = 15629,
  [15630] = 15630,
  [15631] = 3806,
  [15632] = 15632,
  [15633] = 15190,
  [15634] = 15630,
  [15635] = 15628,
  [15636] = 15630,
  [15637] = 14878,
  [15638] = 15630,
  [15639] = 3746,
  [15640] = 15625,
  [15641] = 15641,
  [15642] = 15630,
  [15643] = 15628,
  [15644] = 15547,
  [15645] = 15630,
  [15646] = 3758,
  [15647] = 3767,
  [15648] = 15648,
  [15649] = 15610,
  [15650] = 15546,
  [15651] = 15630,
  [15652] = 15652,
  [15653] = 15653,
  [15654] = 15654,
  [15655] = 15655,
  [15656] = 15630,
  [15657] = 15652,
  [15658] = 15385,
  [15659] = 15628,
  [15660] = 3747,
  [15661] = 15654,
  [15662] = 15628,
  [15663] = 15663,
  [15664] = 15664,
  [15665] = 15630,
  [15666] = 15622,
  [15667] = 15667,
  [15668] = 15668,
  [15669] = 14167,
  [15670] = 15628,
  [15671] = 15630,
  [15672] = 15654,
  [15673] = 15630,
  [15674] = 15654,
  [15675] = 3806,
  [15676] = 14128,
  [15677] = 8333,
  [15678] = 10772,
  [15679] = 3749,
  [15680] = 3750,
  [15681] = 15630,
  [15682] = 15630,
  [15683] = 15683,
  [15684] = 15652,
  [15685] = 3777,
  [15686] = 15630,
  [15687] = 3774,
  [15688] = 15688,
  [15689] = 15652,
  [15690] = 15654,
  [15691] = 15628,
  [15692] = 15630,
  [15693] = 15630,
  [15694] = 15630,
  [15695] = 15630,
  [15696] = 3730,
  [15697] = 3747,
  [15698] = 13903,
  [15699] = 10772,
  [15700] = 3751,
  [15701] = 15630,
  [15702] = 15514,
  [15703] = 14570,
  [15704] = 15704,
  [15705] = 15652,
  [15706] = 15630,
  [15707] = 15707,
  [15708] = 14644,
  [15709] = 10698,
  [15710] = 15630,
  [15711] = 15630,
  [15712] = 15630,
  [15713] = 3796,
  [15714] = 15652,
  [15715] = 3757,
  [15716] = 15654,
  [15717] = 10706,
  [15718] = 3728,
  [15719] = 3764,
  [15720] = 14554,
  [15721] = 15721,
  [15722] = 15630,
  [15723] = 14140,
  [15724] = 15724,
  [15725] = 15725,
  [15726] = 14134,
  [15727] = 15630,
  [15728] = 15628,
  [15729] = 10715,
  [15730] = 15730,
  [15731] = 15630,
  [15732] = 15652,
  [15733] = 15630,
  [15734] = 13646,
  [15735] = 15654,
  [15736] = 15736,
  [15737] = 15628,
  [15738] = 15628,
  [15739] = 3724,
  [15740] = 15652,
  [15741] = 15630,
  [15742] = 15742,
  [15743] = 15743,
  [15744] = 3794,
  [15745] = 3765,
  [15746] = 15654,
  [15747] = 15630,
  [15748] = 14138,
  [15749] = 3782,
  [15750] = 15630,
  [15751] = 14713,
  [15752] = 8414,
  [15753] = 3754,
  [15754] = 8426,
  [15755] = 15664,
  [15756] = 15628,
  [15757] = 9122,
  [15758] = 15630,
  [15759] = 15630,
  [15760] = 9125,
  [15761] = 15630,
  [15762] = 3780,
  [15763] = 15707,
  [15764] = 15764,
  [15765] = 15765,
  [15766] = 15766,
  [15767] = 15630,
  [15768] = 8395,
  [15769] = 15262,
  [15770] = 15630,
  [15771] = 3775,
  [15772] = 15630,
  [15773] = 15664,
  [15774] = 3791,
  [15775] = 15628,
  [15776] = 3779,
  [15777] = 15630,
  [15778] = 10704,
  [15779] = 15652,
  [15780] = 3770,
  [15781] = 3755,
  [15782] = 15628,
  [15783] = 15628,
  [15784] = 8482,
  [15785] = 15785,
  [15786] = 15664,
  [15787] = 15630,
  [15788] = 13931,
  [15789] = 3755,
  [15790] = 15630,
  [15791] = 15653,
  [15792] = 15654,
  [15793] = 15652,
  [15794] = 15630,
  [15795] = 15630,
  [15796] = 15796,
  [15797] = 15628,
  [15798] = 8342,
  [15799] = 15654,
  [15800] = 15800,
  [15801] = 3772,
  [15802] = 3746,
  [15803] = 3806,
  [15804] = 15654,
  [15805] = 15630,
  [15806] = 15630,
  [15807] = 3749,
  [15808] = 15630,
  [15809] = 15281,
  [15810] = 15630,
  [15811] = 15630,
  [15812] = 15630,
  [15813] = 3777,
  [15814] = 15654,
  [15815] = 15630,
  [15816] = 3731,
  [15817] = 15817,
  [15818] = 15688,
  [15819] = 3750,
  [15820] = 15820,
  [15821] = 14713,
  [15822] = 15630,
  [15823] = 3789,
  [15824] = 10772,
  [15825] = 15628,
  [15826] = 3783,
  [15827] = 15652,
  [15828] = 15630,
  [15829] = 3769,
  [15830] = 15630,
  [15831] = 15664,
  [15832] = 10510,
  [15833] = 3729,
  [15834] = 15385,
  [15835] = 15835,
  [15836] = 15547,
  [15837] = 15652,
  [15838] = 15630,
  [15839] = 10543,
  [15840] = 15546,
  [15841] = 10743,
  [15842] = 15630,
  [15843] = 15628,
  [15844] = 10741,
  [15845] = 15654,
  [15846] = 3806,
  [15847] = 3760,
  [15848] = 10741,
  [15849] = 15630,
  [15850] = 15034,
  [15851] = 10743,
  [15852] = 15688,
  [15853] = 15281,
  [15854] = 3751,
  [15855] = 15628,
  [15856] = 14713,
  [15857] = 15630,
  [15858] = 15630,
  [15859] = 14488,
  [15860] = 15860,
  [15861] = 15654,
  [15862] = 8324,
  [15863] = 15654,
  [15864] = 15864,
  [15865] = 15630,
  [15866] = 3806,
  [15867] = 15688,
  [15868] = 15868,
  [15869] = 3723,
  [15870] = 10698,
  [15871] = 15871,
  [15872] = 15652,
  [15873] = 15630,
  [15874] = 15630,
  [15875] = 15652,
  [15876] = 3723,
  [15877] = 10772,
  [15878] = 15630,
  [15879] = 15879,
  [15880] = 3781,
  [15881] = 15630,
  [15882] = 8332,
  [15883] = 8347,
  [15884] = 15630,
  [15885] = 3778,
  [15886] = 15654,
  [15887] = 15630,
  [15888] = 15262,
  [15889] = 15628,
  [15890] = 15628,
  [15891] = 8369,
  [15892] = 15281,
  [15893] = 14882,
  [15894] = 3778,
  [15895] = 15628,
  [15896] = 15514,
  [15897] = 15652,
  [15898] = 15654,
  [15899] = 15899,
  [15900] = 15515,
  [15901] = 15630,
  [15902] = 15630,
  [15903] = 15630,
  [15904] = 15630,
  [15905] = 15385,
  [15906] = 10543,
  [15907] = 15764,
  [15908] = 15630,
  [15909] = 15909,
  [15910] = 15654,
  [15911] = 15765,
  [15912] = 8356,
  [15913] = 15190,
  [15914] = 8443,
  [15915] = 15915,
  [15916] = 3724,
  [15917] = 15628,
  [15918] = 3731,
  [15919] = 15899,
  [15920] = 15909,
  [15921] = 10706,
  [15922] = 15664,
  [15923] = 15630,
  [15924] = 15915,
  [15925] = 8358,
  [15926] = 15630,
  [15927] = 15133,
  [15928] = 15654,
  [15929] = 15652,
  [15930] = 15930,
  [15931] = 8375,
  [15932] = 15630,
  [15933] = 15933,
  [15934] = 15630,
  [15935] = 15630,
  [15936] = 15654,
  [15937] = 14979,
  [15938] = 15938,
  [15939] = 3781,
  [15940] = 15628,
  [15941] = 3757,
  [15942] = 15630,
  [15943] = 8379,
  [15944] = 3764,
  [15945] = 15622,
  [15946] = 15630,
  [15947] = 15630,
  [15948] = 15948,
  [15949] = 15654,
  [15950] = 10772,
  [15951] = 15951,
  [15952] = 15909,
  [15953] = 15953,
  [15954] = 15630,
  [15955] = 15630,
  [15956] = 15628,
  [15957] = 15820,
  [15958] = 15628,
  [15959] = 15664,
  [15960] = 15630,
  [15961] = 15654,
  [15962] = 15630,
  [15963] = 15628,
  [15964] = 15628,
  [15965] = 15688,
  [15966] = 15630,
  [15967] = 15630,
  [15968] = 15742,
  [15969] = 15515,
  [15970] = 15652,
  [15971] = 15630,
  [15972] = 8381,
  [15973] = 15820,
  [15974] = 15630,
  [15975] = 15262,
  [15976] = 15654,
  [15977] = 15630,
  [15978] = 15630,
  [15979] = 15630,
  [15980] = 15980,
  [15981] = 3777,
  [15982] = 15982,
  [15983] = 15628,
  [15984] = 15625,
  [15985] = 15654,
  [15986] = 15654,
  [15987] = 3815,
  [15988] = 8378,
  [15989] = 15688,
  [15990] = 3758,
  [15991] = 15034,
  [15992] = 15992,
  [15993] = 15630,
  [15994] = 15725,
  [15995] = 15995,
  [15996] = 14989,
  [15997] = 15879,
  [15998] = 15654,
  [15999] = 15630,
  [16000] = 15864,
  [16001] = 3779,
  [16002] = 15628,
  [16003] = 15630,
  [16004] = 15654,
  [16005] = 15319,
  [16006] = 15610,
  [16007] = 15688,
  [16008] = 15630,
  [16009] = 3762,
  [16010] = 3772,
  [16011] = 10492,
  [16012] = 15785,
  [16013] = 15652,
  [16014] = 15766,
  [16015] = 15610,
  [16016] = 15625,
  [16017] = 15652,
  [16018] = 15630,
  [16019] = 15864,
  [16020] = 15664,
  [16021] = 15628,
  [16022] = 8427,
  [16023] = 15265,
  [16024] = 15630,
  [16025] = 15630,
  [16026] = 15654,
  [16027] = 10706,
  [16028] = 3760,
  [16029] = 15688,
  [16030] = 3728,
  [16031] = 15654,
  [16032] = 15654,
  [16033] = 15630,
  [16034] = 15630,
  [16035] = 15336,
  [16036] = 15652,
  [16037] = 10715,
  [16038] = 15652,
  [16039] = 15630,
  [16040] = 8434,
  [16041] = 3761,
  [16042] = 3744,
  [16043] = 16043,
  [16044] = 15367,
  [16045] = 15630,
  [16046] = 15364,
  [16047] = 16047,
  [16048] = 15628,
  [16049] = 15630,
  [16050] = 9125,
  [16051] = 3762,
  [16052] = 15664,
  [16053] = 15630,
  [16054] = 15630,
  [16055] = 15630,
  [16056] = 15742,
  [16057] = 14013,
  [16058] = 10715,
  [16059] = 14981,
  [16060] = 9122,
  [16061] = 15003,
  [16062] = 15630,
  [16063] = 15023,
  [16064] = 15683,
  [16065] = 14636,
  [16066] = 3729,
  [16067] = 15953,
  [16068] = 15630,
  [16069] = 15630,
  [16070] = 15547,
  [16071] = 15654,
  [16072] = 16072,
  [16073] = 15220,
  [16074] = 15546,
  [16075] = 15217,
  [16076] = 15630,
  [16077] = 15630,
  [16078] = 15628,
  [16079] = 15653,
  [16080] = 15628,
  [16081] = 15628,
  [16082] = 15654,
  [16083] = 15630,
  [16084] = 15630,
  [16085] = 15655,
  [16086] = 3730,
  [16087] = 15915,
  [16088] = 10698,
  [16089] = 15667,
  [16090] = 15688,
  [16091] = 15514,
  [16092] = 15212,
  [16093] = 15630,
  [16094] = 15721,
  [16095] = 15630,
  [16096] = 15654,
  [16097] = 15980,
  [16098] = 15630,
  [16099] = 15664,
  [16100] = 16100,
  [16101] = 15528,
  [16102] = 15630,
  [16103] = 15628,
  [16104] = 16104,
  [16105] = 15630,
  [16106] = 15654,
  [16107] = 15515,
  [16108] = 15528,
  [16109] = 15630,
  [16110] = 8447,
  [16111] = 3806,
  [16112] = 14898,
  [16113] = 16113,
  [16114] = 15630,
  [16115] = 16115,
  [16116] = 15630,
  [16117] = 15664,
  [16118] = 15628,
  [16119] = 15630,
  [16120] = 15652,
  [16121] = 15085,
  [16122] = 15628,
  [16123] = 10698,
  [16124] = 15190,
  [16125] = 15630,
  [16126] = 15630,
  [16127] = 15630,
  [16128] = 15630,
  [16129] = 10743,
  [16130] = 8398,
  [16131] = 15622,
  [16132] = 15652,
  [16133] = 15630,
  [16134] = 15668,
  [16135] = 3765,
  [16136] = 15664,
  [16137] = 15654,
  [16138] = 10715,
  [16139] = 15654,
  [16140] = 10698,
  [16141] = 15664,
  [16142] = 10715,
  [16143] = 15628,
  [16144] = 15630,
  [16145] = 15630,
  [16146] = 10741,
  [16147] = 16115,
  [16148] = 15654,
  [16149] = 15166,
  [16150] = 16113,
  [16151] = 15093,
  [16152] = 15630,
  [16153] = 15652,
  [16154] = 10706,
  [16155] = 15628,
  [16156] = 15628,
  [16157] = 16157,
  [16158] = 14999,
  [16159] = 15654,
  [16160] = 15654,
  [16161] = 15652,
  [16162] = 3810,
  [16163] = 15011,
  [16164] = 15059,
  [16165] = 8316,
  [16166] = 15056,
  [16167] = 15688,
  [16168] = 15652,
  [16169] = 3754,
  [16170] = 15652,
  [16171] = 15010,
  [16172] = 15305,
  [16173] = 10741,
  [16174] = 15817,
  [16175] = 3775,
  [16176] = 15381,
  [16177] = 15041,
  [16178] = 15630,
  [16179] = 15641,
  [16180] = 15039,
  [16181] = 15630,
  [16182] = 16100,
  [16183] = 15629,
  [16184] = 14878,
  [16185] = 3783,
  [16186] = 16186,
  [16187] = 15648,
  [16188] = 15628,
  [16189] = 15001,
  [16190] = 14992,
  [16191] = 15630,
  [16192] = 15532,
  [16193] = 15536,
  [16194] = 15654,
  [16195] = 9125,
  [16196] = 15652,
  [16197] = 9122,
  [16198] = 15511,
  [16199] = 14990,
  [16200] = 14996,
  [16201] = 15503,
  [16202] = 15502,
  [16203] = 15475,
  [16204] = 15630,
  [16205] = 15628,
  [16206] = 16186,
  [16207] = 15628,
  [16208] = 15654,
  [16209] = 15995,
  [16210] = 15454,
  [16211] = 15630,
  [16212] = 15654,
  [16213] = 3767,
  [16214] = 15630,
  [16215] = 15528,
  [16216] = 3761,
  [16217] = 15630,
  [16218] = 15630,
  [16219] = 3774,
  [16220] = 15654,
  [16221] = 15630,
  [16222] = 15630,
  [16223] = 15628,
  [16224] = 3744,
  [16225] = 10743,
  [16226] = 3796,
  [16227] = 3794,
  [16228] = 10706,
  [16229] = 15630,
  [16230] = 15628,
  [16231] = 15453,
  [16232] = 3782,
  [16233] = 16233,
  [16234] = 3789,
  [16235] = 3780,
  [16236] = 15296,
  [16237] = 15654,
  [16238] = 15628,
  [16239] = 15654,
  [16240] = 3791,
  [16241] = 3769,
  [16242] = 10743,
  [16243] = 15630,
  [16244] = 10741,
  [16245] = 15664,
  [16246] = 15688,
  [16247] = 15228,
  [16248] = 3770,
  [16249] = 16249,
  [16250] = 16250,
  [16251] = 16251,
  [16252] = 16252,
  [16253] = 16253,
  [16254] = 16249,
  [16255] = 16255,
  [16256] = 16256,
  [16257] = 16257,
  [16258] = 16258,
  [16259] = 16259,
  [16260] = 16260,
  [16261] = 16261,
  [16262] = 16262,
  [16263] = 16263,
  [16264] = 16264,
  [16265] = 16265,
  [16266] = 16266,
  [16267] = 16267,
  [16268] = 16268,
  [16269] = 16269,
  [16270] = 16270,
  [16271] = 16263,
  [16272] = 16272,
  [16273] = 16273,
  [16274] = 16258,
  [16275] = 16275,
  [16276] = 16256,
  [16277] = 16255,
  [16278] = 16278,
  [16279] = 15546,
  [16280] = 15547,
  [16281] = 16281,
  [16282] = 16269,
  [16283] = 16281,
  [16284] = 16255,
  [16285] = 16278,
  [16286] = 16268,
  [16287] = 16275,
  [16288] = 16272,
  [16289] = 16267,
  [16290] = 16270,
  [16291] = 16266,
  [16292] = 16256,
  [16293] = 16258,
  [16294] = 16265,
  [16295] = 16249,
  [16296] = 16263,
  [16297] = 16269,
  [16298] = 16262,
  [16299] = 16268,
  [16300] = 16261,
  [16301] = 16267,
  [16302] = 15736,
  [16303] = 16303,
  [16304] = 3765,
  [16305] = 16281,
  [16306] = 16306,
  [16307] = 16260,
  [16308] = 16278,
  [16309] = 16309,
  [16310] = 16259,
  [16311] = 16260,
  [16312] = 16275,
  [16313] = 16267,
  [16314] = 15707,
  [16315] = 16315,
  [16316] = 16268,
  [16317] = 16269,
  [16318] = 16263,
  [16319] = 16259,
  [16320] = 16258,
  [16321] = 16260,
  [16322] = 16256,
  [16323] = 16255,
  [16324] = 16272,
  [16325] = 16325,
  [16326] = 16270,
  [16327] = 16327,
  [16328] = 16252,
  [16329] = 16281,
  [16330] = 16278,
  [16331] = 3747,
  [16332] = 16250,
  [16333] = 16333,
  [16334] = 16334,
  [16335] = 16249,
  [16336] = 16259,
  [16337] = 16275,
  [16338] = 16338,
  [16339] = 16334,
  [16340] = 16113,
  [16341] = 16341,
  [16342] = 16115,
  [16343] = 16252,
  [16344] = 16252,
  [16345] = 16272,
  [16346] = 16270,
  [16347] = 16347,
  [16348] = 16266,
  [16349] = 15704,
  [16350] = 16350,
  [16351] = 16249,
  [16352] = 15995,
  [16353] = 16249,
  [16354] = 16265,
  [16355] = 15528,
  [16356] = 16265,
  [16357] = 16357,
  [16358] = 16358,
  [16359] = 16262,
  [16360] = 16360,
  [16361] = 16361,
  [16362] = 16261,
  [16363] = 16250,
  [16364] = 3749,
  [16365] = 3750,
  [16366] = 16262,
  [16367] = 16261,
  [16368] = 16261,
  [16369] = 16249,
  [16370] = 3751,
  [16371] = 16262,
  [16372] = 16250,
  [16373] = 16257,
  [16374] = 16249,
  [16375] = 16265,
  [16376] = 16261,
  [16377] = 16264,
  [16378] = 16273,
  [16379] = 16266,
  [16380] = 16262,
  [16381] = 16250,
  [16382] = 16270,
  [16383] = 16272,
  [16384] = 3757,
  [16385] = 16249,
  [16386] = 16275,
  [16387] = 16265,
  [16388] = 16278,
  [16389] = 16389,
  [16390] = 16281,
  [16391] = 16391,
  [16392] = 16392,
  [16393] = 16249,
  [16394] = 10772,
  [16395] = 3764,
  [16396] = 16266,
  [16397] = 16270,
  [16398] = 16398,
  [16399] = 16255,
  [16400] = 16272,
  [16401] = 16259,
  [16402] = 16256,
  [16403] = 16260,
  [16404] = 16258,
  [16405] = 16275,
  [16406] = 16263,
  [16407] = 16269,
  [16408] = 16268,
  [16409] = 16267,
  [16410] = 16260,
  [16411] = 16411,
  [16412] = 16412,
  [16413] = 16259,
  [16414] = 16414,
  [16415] = 16278,
  [16416] = 16267,
  [16417] = 16252,
  [16418] = 16268,
  [16419] = 16269,
  [16420] = 15190,
  [16421] = 16263,
  [16422] = 16422,
  [16423] = 16281,
  [16424] = 16258,
  [16425] = 16266,
  [16426] = 16256,
  [16427] = 16255,
  [16428] = 16255,
  [16429] = 16256,
  [16430] = 16249,
  [16431] = 10543,
  [16432] = 16260,
  [16433] = 16258,
  [16434] = 16250,
  [16435] = 16435,
  [16436] = 16281,
  [16437] = 16252,
  [16438] = 16278,
  [16439] = 3754,
  [16440] = 16275,
  [16441] = 16441,
  [16442] = 16272,
  [16443] = 16252,
  [16444] = 16270,
  [16445] = 16263,
  [16446] = 16266,
  [16447] = 16447,
  [16448] = 16269,
  [16449] = 15622,
  [16450] = 16268,
  [16451] = 16265,
  [16452] = 16267,
  [16453] = 16252,
  [16454] = 16454,
  [16455] = 16334,
  [16456] = 16262,
  [16457] = 15625,
  [16458] = 16249,
  [16459] = 16261,
  [16460] = 16460,
  [16461] = 16461,
  [16462] = 3755,
  [16463] = 16249,
  [16464] = 15610,
  [16465] = 16465,
  [16466] = 10492,
  [16467] = 16259,
  [16468] = 16468,
  [16469] = 15667,
  [16470] = 16252,
  [16471] = 16471,
  [16472] = 16472,
  [16473] = 16473,
  [16474] = 16474,
  [16475] = 16475,
  [16476] = 16252,
  [16477] = 16477,
  [16478] = 16478,
  [16479] = 16250,
  [16480] = 16333,
  [16481] = 3770,
  [16482] = 16334,
  [16483] = 16252,
  [16484] = 10505,
  [16485] = 16252,
  [16486] = 16249,
  [16487] = 16334,
  [16488] = 16261,
  [16489] = 16489,
  [16490] = 16414,
  [16491] = 16252,
  [16492] = 16492,
  [16493] = 16493,
  [16494] = 16262,
  [16495] = 16495,
  [16496] = 16252,
  [16497] = 16252,
  [16498] = 16265,
  [16499] = 16499,
  [16500] = 16500,
  [16501] = 16266,
  [16502] = 16502,
  [16503] = 16252,
  [16504] = 16252,
  [16505] = 16270,
  [16506] = 16272,
  [16507] = 16275,
  [16508] = 16411,
  [16509] = 16252,
  [16510] = 16278,
  [16511] = 16334,
  [16512] = 15765,
  [16513] = 16392,
  [16514] = 16281,
  [16515] = 15764,
  [16516] = 16516,
  [16517] = 16517,
  [16518] = 16391,
  [16519] = 16255,
  [16520] = 16361,
  [16521] = 16256,
  [16522] = 16258,
  [16523] = 16341,
  [16524] = 16252,
  [16525] = 16263,
  [16526] = 16338,
  [16527] = 16249,
  [16528] = 16502,
  [16529] = 16249,
  [16530] = 16269,
  [16531] = 16268,
  [16532] = 16267,
  [16533] = 16533,
  [16534] = 16250,
  [16535] = 16260,
  [16536] = 16249,
  [16537] = 16259,
  [16538] = 16252,
  [16539] = 16252,
  [16540] = 16540,
  [16541] = 16250,
  [16542] = 16542,
  [16543] = 16261,
  [16544] = 16249,
  [16545] = 16262,
  [16546] = 16265,
  [16547] = 9122,
  [16548] = 15879,
  [16549] = 16250,
  [16550] = 16550,
  [16551] = 16266,
  [16552] = 16552,
  [16553] = 16270,
  [16554] = 16259,
  [16555] = 16272,
  [16556] = 16260,
  [16557] = 16275,
  [16558] = 16558,
  [16559] = 16281,
  [16560] = 16560,
  [16561] = 16252,
  [16562] = 16562,
  [16563] = 16493,
  [16564] = 16278,
  [16565] = 16252,
  [16566] = 16249,
  [16567] = 16567,
  [16568] = 16255,
  [16569] = 16267,
  [16570] = 16325,
  [16571] = 16268,
  [16572] = 16269,
  [16573] = 16259,
  [16574] = 16263,
  [16575] = 16256,
  [16576] = 16576,
  [16577] = 16258,
  [16578] = 9125,
  [16579] = 16256,
  [16580] = 16273,
  [16581] = 16255,
  [16582] = 16258,
  [16583] = 16583,
  [16584] = 16264,
  [16585] = 16257,
  [16586] = 16586,
  [16587] = 16263,
  [16588] = 16306,
  [16589] = 16281,
  [16590] = 16252,
  [16591] = 16278,
  [16592] = 16309,
  [16593] = 16275,
  [16594] = 16269,
  [16595] = 16272,
  [16596] = 16315,
  [16597] = 16270,
  [16598] = 16268,
  [16599] = 16266,
  [16600] = 16261,
  [16601] = 16260,
  [16602] = 16262,
  [16603] = 16249,
  [16604] = 16265,
  [16605] = 16267,
  [16606] = 16265,
  [16607] = 16261,
  [16608] = 16608,
  [16609] = 16262,
  [16610] = 16460,
  [16611] = 16611,
  [16612] = 16261,
  [16613] = 16461,
  [16614] = 16252,
  [16615] = 16260,
  [16616] = 16468,
  [16617] = 16249,
  [16618] = 16259,
  [16619] = 16500,
  [16620] = 10743,
  [16621] = 16550,
  [16622] = 16622,
  [16623] = 16623,
  [16624] = 16267,
  [16625] = 15817,
  [16626] = 16266,
  [16627] = 10741,
  [16628] = 15034,
  [16629] = 16262,
  [16630] = 16270,
  [16631] = 16268,
  [16632] = 16272,
  [16633] = 16261,
  [16634] = 16262,
  [16635] = 16414,
  [16636] = 16275,
  [16637] = 16334,
  [16638] = 16638,
  [16639] = 16639,
  [16640] = 16249,
  [16641] = 16278,
  [16642] = 16281,
  [16643] = 16643,
  [16644] = 16269,
  [16645] = 16252,
  [16646] = 16252,
  [16647] = 16255,
  [16648] = 16263,
  [16649] = 16256,
  [16650] = 16650,
  [16651] = 16250,
  [16652] = 16258,
  [16653] = 16653,
  [16654] = 16263,
  [16655] = 3774,
  [16656] = 16656,
  [16657] = 16657,
  [16658] = 16249,
  [16659] = 16258,
  [16660] = 16269,
  [16661] = 16360,
  [16662] = 16268,
  [16663] = 16663,
  [16664] = 16267,
  [16665] = 16260,
  [16666] = 16259,
  [16667] = 16256,
  [16668] = 16255,
  [16669] = 16358,
  [16670] = 16670,
  [16671] = 16265,
  [16672] = 16252,
  [16673] = 10704,
  [16674] = 16674,
  [16675] = 16281,
  [16676] = 16278,
  [16677] = 16250,
  [16678] = 16478,
  [16679] = 16638,
  [16680] = 16250,
  [16681] = 16252,
  [16682] = 16682,
  [16683] = 16275,
  [16684] = 16639,
  [16685] = 16272,
  [16686] = 16273,
  [16687] = 16687,
  [16688] = 16270,
  [16689] = 16266,
  [16690] = 16252,
  [16691] = 16691,
  [16692] = 16266,
  [16693] = 16252,
  [16694] = 3783,
  [16695] = 16477,
  [16696] = 16265,
  [16697] = 16252,
  [16698] = 16358,
  [16699] = 10715,
  [16700] = 16259,
  [16701] = 15515,
  [16702] = 16260,
  [16703] = 16334,
  [16704] = 16360,
  [16705] = 16474,
  [16706] = 16252,
  [16707] = 16707,
  [16708] = 16347,
  [16709] = 3781,
  [16710] = 15514,
  [16711] = 16262,
  [16712] = 3778,
  [16713] = 16713,
  [16714] = 16261,
  [16715] = 16267,
  [16716] = 16716,
  [16717] = 16268,
  [16718] = 16269,
  [16719] = 15648,
  [16720] = 16263,
  [16721] = 15655,
  [16722] = 16258,
  [16723] = 16471,
  [16724] = 16256,
  [16725] = 10706,
  [16726] = 16255,
  [16727] = 16262,
  [16728] = 16249,
  [16729] = 16261,
  [16730] = 16265,
  [16731] = 16731,
  [16732] = 16257,
  [16733] = 16266,
  [16734] = 16281,
  [16735] = 16264,
  [16736] = 16278,
  [16737] = 14878,
  [16738] = 16275,
  [16739] = 16739,
  [16740] = 16272,
  [16741] = 16270,
  [16742] = 16270,
  [16743] = 16260,
  [16744] = 16266,
  [16745] = 3775,
  [16746] = 16249,
  [16747] = 16265,
  [16748] = 16272,
  [16749] = 16275,
  [16750] = 16414,
  [16751] = 16252,
  [16752] = 16262,
  [16753] = 16258,
  [16754] = 16270,
  [16755] = 16261,
  [16756] = 16272,
  [16757] = 16261,
  [16758] = 10698,
  [16759] = 16262,
  [16760] = 10772,
  [16761] = 16278,
  [16762] = 16762,
  [16763] = 16275,
  [16764] = 16281,
  [16765] = 16278,
  [16766] = 16281,
  [16767] = 16255,
  [16768] = 16643,
  [16769] = 15683,
  [16770] = 16265,
  [16771] = 16266,
  [16772] = 16270,
  [16773] = 16256,
  [16774] = 16258,
  [16775] = 16650,
  [16776] = 16263,
  [16777] = 16272,
  [16778] = 16334,
  [16779] = 16275,
  [16780] = 16278,
  [16781] = 16269,
  [16782] = 16268,
  [16783] = 16267,
  [16784] = 16260,
  [16785] = 16785,
  [16786] = 16252,
  [16787] = 16281,
  [16788] = 16259,
  [16789] = 16252,
  [16790] = 16608,
  [16791] = 16255,
  [16792] = 16256,
  [16793] = 16657,
  [16794] = 16258,
  [16795] = 16795,
  [16796] = 16334,
  [16797] = 16263,
  [16798] = 16269,
  [16799] = 16250,
  [16800] = 16800,
  [16801] = 16268,
  [16802] = 16267,
  [16803] = 16249,
  [16804] = 16804,
  [16805] = 16252,
  [16806] = 16360,
  [16807] = 16252,
  [16808] = 16252,
  [16809] = 16809,
  [16810] = 16255,
  [16811] = 16811,
  [16812] = 16358,
  [16813] = 16256,
  [16814] = 16252,
  [16815] = 16252,
  [16816] = 16259,
  [16817] = 16252,
  [16818] = 16818,
  [16819] = 16819,
  [16820] = 16250,
  [16821] = 16250,
  [16822] = 16252,
  [16823] = 16249,
  [16824] = 3777,
  [16825] = 16825,
  [16826] = 16252,
  [16827] = 16827,
  [16828] = 16261,
  [16829] = 16265,
  [16830] = 16252,
  [16831] = 16831,
  [16832] = 16249,
  [16833] = 16259,
  [16834] = 16834,
  [16835] = 16252,
  [16836] = 15930,
  [16837] = 16250,
  [16838] = 16838,
  [16839] = 16262,
  [16840] = 16334,
  [16841] = 16259,
  [16842] = 10715,
  [16843] = 16260,
  [16844] = 16265,
  [16845] = 16263,
  [16846] = 16266,
  [16847] = 16269,
  [16848] = 16270,
  [16849] = 16272,
  [16850] = 16275,
  [16851] = 16268,
  [16852] = 16852,
  [16853] = 16267,
  [16854] = 16278,
  [16855] = 16281,
  [16856] = 16267,
  [16857] = 14644,
  [16858] = 16268,
  [16859] = 16269,
  [16860] = 16252,
  [16861] = 16263,
  [16862] = 16249,
  [16863] = 16258,
  [16864] = 16762,
  [16865] = 16256,
  [16866] = 16866,
  [16867] = 16255,
  [16868] = 16868,
  [16869] = 16255,
  [16870] = 16259,
  [16871] = 16260,
  [16872] = 16259,
  [16873] = 16249,
  [16874] = 16261,
  [16875] = 16281,
  [16876] = 16256,
  [16877] = 16278,
  [16878] = 15785,
  [16879] = 16275,
  [16880] = 16258,
  [16881] = 16272,
  [16882] = 16263,
  [16883] = 16270,
  [16884] = 16262,
  [16885] = 16266,
  [16886] = 15899,
  [16887] = 16887,
  [16888] = 16265,
  [16889] = 16269,
  [16890] = 16268,
  [16891] = 16267,
  [16892] = 16252,
  [16893] = 16262,
  [16894] = 16265,
  [16895] = 16268,
  [16896] = 16261,
  [16897] = 16266,
  [16898] = 16269,
  [16899] = 16899,
  [16900] = 16270,
  [16901] = 16263,
  [16902] = 16272,
  [16903] = 16267,
  [16904] = 16275,
  [16905] = 16249,
  [16906] = 16278,
  [16907] = 16260,
  [16908] = 16281,
  [16909] = 16258,
  [16910] = 16252,
  [16911] = 16259,
  [16912] = 16255,
  [16913] = 16887,
  [16914] = 16256,
  [16915] = 16258,
  [16916] = 16256,
  [16917] = 15385,
  [16918] = 10510,
  [16919] = 16334,
  [16920] = 16263,
  [16921] = 16921,
  [16922] = 16922,
  [16923] = 16269,
  [16924] = 16268,
  [16925] = 16267,
  [16926] = 16687,
  [16927] = 16252,
  [16928] = 16465,
  [16929] = 16250,
  [16930] = 16255,
  [16931] = 16562,
  [16932] = 16691,
  [16933] = 16933,
  [16934] = 16252,
  [16935] = 16252,
  [16936] = 16936,
  [16937] = 16937,
  [16938] = 16260,
  [16939] = 10741,
  [16940] = 10510,
  [16941] = 16250,
  [16942] = 15629,
  [16943] = 16252,
  [16944] = 10743,
  [16945] = 16281,
  [16946] = 8342,
  [16947] = 16278,
  [16948] = 16948,
  [16949] = 16275,
  [16950] = 16261,
  [16951] = 16252,
  [16952] = 16250,
  [16953] = 16953,
  [16954] = 16262,
  [16955] = 16955,
  [16956] = 16272,
  [16957] = 16270,
  [16958] = 16266,
  [16959] = 16265,
  [16960] = 16250,
  [16961] = 14554,
  [16962] = 16266,
  [16963] = 16963,
  [16964] = 16260,
  [16965] = 16270,
  [16966] = 16272,
  [16967] = 16275,
  [16968] = 16249,
  [16969] = 16411,
  [16970] = 16252,
  [16971] = 16265,
  [16972] = 16252,
  [16973] = 16347,
  [16974] = 16262,
  [16975] = 16975,
  [16976] = 16252,
  [16977] = 16252,
  [16978] = 16278,
  [16979] = 16281,
  [16980] = 16259,
  [16981] = 16981,
  [16982] = 16260,
  [16983] = 16261,
  [16984] = 16255,
  [16985] = 16186,
  [16986] = 16256,
  [16987] = 16258,
  [16988] = 16263,
  [16989] = 16334,
  [16990] = 16269,
  [16991] = 16100,
  [16992] = 16268,
  [16993] = 16993,
  [16994] = 16267,
  [16995] = 16267,
  [16996] = 16252,
  [16997] = 16268,
  [16998] = 16269,
  [16999] = 15980,
  [17000] = 16263,
  [17001] = 16252,
  [17002] = 16258,
  [17003] = 10772,
  [17004] = 16256,
  [17005] = 15766,
  [17006] = 16255,
  [17007] = 16260,
  [17008] = 14554,
  [17009] = 10698,
  [17010] = 16713,
  [17011] = 16334,
  [17012] = 16259,
  [17013] = 16261,
  [17014] = 16281,
  [17015] = 16262,
  [17016] = 16278,
  [17017] = 16265,
  [17018] = 16275,
  [17019] = 16716,
  [17020] = 16272,
  [17021] = 16266,
  [17022] = 16270,
  [17023] = 16334,
  [17024] = 16266,
  [17025] = 16411,
  [17026] = 16270,
  [17027] = 16265,
  [17028] = 16252,
  [17029] = 16272,
  [17030] = 16275,
  [17031] = 16278,
  [17032] = 16262,
  [17033] = 16281,
  [17034] = 16414,
  [17035] = 16261,
  [17036] = 17036,
  [17037] = 16252,
  [17038] = 16255,
  [17039] = 16256,
  [17040] = 16258,
  [17041] = 8395,
  [17042] = 16263,
  [17043] = 16269,
  [17044] = 16268,
  [17045] = 16465,
  [17046] = 3775,
  [17047] = 16267,
  [17048] = 16252,
  [17049] = 16249,
  [17050] = 17050,
  [17051] = 16252,
  [17052] = 16252,
  [17053] = 17053,
  [17054] = 16260,
  [17055] = 16259,
  [17056] = 16471,
  [17057] = 16250,
  [17058] = 16334,
  [17059] = 16474,
  [17060] = 16249,
  [17061] = 16249,
  [17062] = 16477,
  [17063] = 14713,
  [17064] = 16252,
  [17065] = 17065,
  [17066] = 16252,
  [17067] = 16250,
  [17068] = 10706,
  [17069] = 16250,
  [17070] = 16478,
  [17071] = 16275,
  [17072] = 8342,
  [17073] = 16252,
  [17074] = 8395,
  [17075] = 8482,
  [17076] = 17076,
  [17077] = 17077,
  [17078] = 17078,
  [17079] = 16252,
  [17080] = 16583,
  [17081] = 17081,
  [17082] = 16252,
  [17083] = 17083,
  [17084] = 16249,
  [17085] = 16259,
  [17086] = 16252,
  [17087] = 16493,
  [17088] = 16252,
  [17089] = 10715,
  [17090] = 17090,
  [17091] = 14644,
  [17092] = 16261,
  [17093] = 16260,
  [17094] = 16260,
  [17095] = 16936,
  [17096] = 16262,
  [17097] = 16502,
  [17098] = 16334,
  [17099] = 16250,
  [17100] = 16265,
  [17101] = 16252,
  [17102] = 16267,
  [17103] = 16266,
  [17104] = 16268,
  [17105] = 16270,
  [17106] = 16272,
  [17107] = 16269,
  [17108] = 16263,
  [17109] = 16275,
  [17110] = 16475,
  [17111] = 16278,
  [17112] = 16281,
  [17113] = 16392,
  [17114] = 16391,
  [17115] = 16258,
  [17116] = 16256,
  [17117] = 16255,
  [17118] = 16281,
  [17119] = 16259,
  [17120] = 16255,
  [17121] = 16260,
  [17122] = 16361,
  [17123] = 16256,
  [17124] = 16258,
  [17125] = 14713,
  [17126] = 16263,
  [17127] = 16249,
  [17128] = 16269,
  [17129] = 16268,
  [17130] = 16267,
  [17131] = 16278,
  [17132] = 16275,
  [17133] = 16260,
  [17134] = 16267,
  [17135] = 16259,
  [17136] = 16268,
  [17137] = 16269,
  [17138] = 15298,
  [17139] = 16263,
  [17140] = 16272,
  [17141] = 16258,
  [17142] = 16270,
  [17143] = 16256,
  [17144] = 16261,
  [17145] = 16255,
  [17146] = 16341,
  [17147] = 16266,
  [17148] = 16338,
  [17149] = 16262,
  [17150] = 16333,
  [17151] = 16250,
  [17152] = 10715,
  [17153] = 16281,
  [17154] = 17154,
  [17155] = 16278,
  [17156] = 16325,
  [17157] = 16275,
  [17158] = 16273,
  [17159] = 16272,
  [17160] = 16264,
  [17161] = 16270,
  [17162] = 16265,
  [17163] = 16266,
  [17164] = 16257,
  [17165] = 16253,
  [17166] = 16265,
  [17167] = 16252,
  [17168] = 16251,
  [17169] = 10743,
  [17170] = 10741,
  [17171] = 16262,
  [17172] = 16303,
  [17173] = 10741,
  [17174] = 16261,
  [17175] = 16266,
  [17176] = 10743,
  [17177] = 16306,
  [17178] = 16309,
  [17179] = 16265,
  [17180] = 16811,
  [17181] = 16315,
  [17182] = 16809,
  [17183] = 3806,
  [17184] = 16270,
  [17185] = 16272,
  [17186] = 16255,
  [17187] = 16262,
  [17188] = 16460,
  [17189] = 16252,
  [17190] = 16278,
  [17191] = 16281,
  [17192] = 17192,
  [17193] = 16461,
  [17194] = 16468,
  [17195] = 16261,
  [17196] = 16334,
  [17197] = 17197,
  [17198] = 17198,
  [17199] = 16256,
  [17200] = 16255,
  [17201] = 16258,
  [17202] = 16500,
  [17203] = 16550,
  [17204] = 16252,
  [17205] = 16252,
  [17206] = 16263,
  [17207] = 10772,
  [17208] = 16269,
  [17209] = 15358,
  [17210] = 16261,
  [17211] = 16268,
  [17212] = 16261,
  [17213] = 10741,
  [17214] = 16267,
  [17215] = 16262,
  [17216] = 16262,
  [17217] = 10743,
  [17218] = 10772,
  [17219] = 16638,
  [17220] = 14644,
  [17221] = 16265,
  [17222] = 16639,
  [17223] = 16252,
  [17224] = 16266,
  [17225] = 16643,
  [17226] = 16270,
  [17227] = 16272,
  [17228] = 16650,
  [17229] = 16259,
  [17230] = 16275,
  [17231] = 16657,
  [17232] = 16278,
  [17233] = 16281,
  [17234] = 16260,
  [17235] = 16259,
  [17236] = 16360,
  [17237] = 16250,
  [17238] = 16358,
  [17239] = 16255,
  [17240] = 16265,
  [17241] = 16256,
  [17242] = 16258,
  [17243] = 16263,
  [17244] = 16834,
  [17245] = 17245,
  [17246] = 16269,
  [17247] = 16268,
  [17248] = 16838,
  [17249] = 16249,
  [17250] = 17250,
  [17251] = 16267,
  [17252] = 16334,
  [17253] = 16252,
  [17254] = 16739,
  [17255] = 16260,
  [17256] = 16687,
  [17257] = 16259,
  [17258] = 16259,
  [17259] = 16260,
  [17260] = 15930,
  [17261] = 16250,
  [17262] = 16562,
  [17263] = 16691,
  [17264] = 16937,
  [17265] = 16278,
  [17266] = 16252,
  [17267] = 16347,
  [17268] = 16713,
  [17269] = 17269,
  [17270] = 16389,
  [17271] = 16250,
  [17272] = 16267,
  [17273] = 16716,
  [17274] = 16268,
  [17275] = 16269,
  [17276] = 17036,
  [17277] = 16263,
  [17278] = 16252,
  [17279] = 16258,
  [17280] = 17280,
  [17281] = 16256,
  [17282] = 8482,
  [17283] = 16255,
  [17284] = 16252,
  [17285] = 15704,
  [17286] = 16739,
  [17287] = 16252,
  [17288] = 16266,
  [17289] = 3806,
  [17290] = 16558,
  [17291] = 16281,
  [17292] = 16252,
  [17293] = 16278,
  [17294] = 17294,
  [17295] = 16275,
  [17296] = 16252,
  [17297] = 16272,
  [17298] = 16266,
  [17299] = 16270,
  [17300] = 16270,
  [17301] = 16266,
  [17302] = 16552,
  [17303] = 17303,
  [17304] = 16265,
  [17305] = 16270,
  [17306] = 16272,
  [17307] = 16250,
  [17308] = 16275,
  [17309] = 16262,
  [17310] = 16252,
  [17311] = 16249,
  [17312] = 16261,
  [17313] = 16249,
  [17314] = 16334,
  [17315] = 16278,
  [17316] = 16281,
  [17317] = 16272,
  [17318] = 16540,
  [17319] = 17319,
  [17320] = 16785,
  [17321] = 15632,
  [17322] = 16800,
  [17323] = 16259,
  [17324] = 16260,
  [17325] = 17325,
  [17326] = 16275,
  [17327] = 16334,
  [17328] = 16334,
  [17329] = 16249,
  [17330] = 15668,
  [17331] = 16267,
  [17332] = 16256,
  [17333] = 16258,
  [17334] = 16252,
  [17335] = 16268,
  [17336] = 16269,
  [17337] = 16261,
  [17338] = 16261,
  [17339] = 16818,
  [17340] = 16819,
  [17341] = 16263,
  [17342] = 17342,
  [17343] = 16262,
  [17344] = 15036,
  [17345] = 16262,
  [17346] = 16252,
  [17347] = 16265,
  [17348] = 16265,
  [17349] = 16258,
  [17350] = 16266,
  [17351] = 16256,
  [17352] = 16270,
  [17353] = 16272,
  [17354] = 16266,
  [17355] = 16255,
  [17356] = 16275,
  [17357] = 3758,
  [17358] = 16270,
  [17359] = 16278,
  [17360] = 16281,
  [17361] = 16250,
  [17362] = 16272,
  [17363] = 16275,
  [17364] = 16249,
  [17365] = 16255,
  [17366] = 16278,
  [17367] = 16256,
  [17368] = 16258,
  [17369] = 16281,
  [17370] = 16263,
  [17371] = 16269,
  [17372] = 15641,
  [17373] = 16252,
  [17374] = 16263,
  [17375] = 16268,
  [17376] = 16267,
  [17377] = 17377,
  [17378] = 16252,
  [17379] = 16762,
  [17380] = 16259,
  [17381] = 16260,
  [17382] = 16260,
  [17383] = 16255,
  [17384] = 16259,
  [17385] = 16256,
  [17386] = 16281,
  [17387] = 16269,
  [17388] = 16258,
  [17389] = 16263,
  [17390] = 16268,
  [17391] = 14554,
  [17392] = 16269,
  [17393] = 16250,
  [17394] = 16267,
  [17395] = 16268,
  [17396] = 16268,
  [17397] = 16269,
  [17398] = 16267,
  [17399] = 16263,
  [17400] = 17400,
  [17401] = 16258,
  [17402] = 16267,
  [17403] = 16256,
  [17404] = 16281,
  [17405] = 16255,
  [17406] = 16278,
  [17407] = 16275,
  [17408] = 15736,
  [17409] = 16252,
  [17410] = 16260,
  [17411] = 16259,
  [17412] = 16281,
  [17413] = 16252,
  [17414] = 16278,
  [17415] = 16272,
  [17416] = 16275,
  [17417] = 15736,
  [17418] = 16272,
  [17419] = 17050,
  [17420] = 16270,
  [17421] = 15641,
  [17422] = 16266,
  [17423] = 16270,
  [17424] = 17424,
  [17425] = 16265,
  [17426] = 16252,
  [17427] = 16252,
  [17428] = 16266,
  [17429] = 16250,
  [17430] = 16262,
  [17431] = 16921,
  [17432] = 16265,
  [17433] = 16261,
  [17434] = 16260,
  [17435] = 16252,
  [17436] = 16262,
  [17437] = 16259,
  [17438] = 16261,
  [17439] = 16252,
  [17440] = 3746,
  [17441] = 16350,
  [17442] = 14554,
  [17443] = 16975,
  [17444] = 16357,
  [17445] = 17445,
  [17446] = 16948,
  [17447] = 16887,
  [17448] = 16249,
  [17449] = 16252,
  [17450] = 16975,
  [17451] = 17342,
  [17452] = 16398,
  [17453] = 16252,
  [17454] = 16255,
  [17455] = 16252,
  [17456] = 16252,
  [17457] = 16252,
  [17458] = 16334,
  [17459] = 8482,
  [17460] = 17053,
  [17461] = 16249,
  [17462] = 17462,
  [17463] = 16866,
  [17464] = 16868,
  [17465] = 16921,
  [17466] = 16261,
  [17467] = 15281,
  [17468] = 16262,
  [17469] = 10510,
  [17470] = 17342,
  [17471] = 16265,
  [17472] = 16975,
  [17473] = 16250,
  [17474] = 16261,
  [17475] = 16262,
  [17476] = 16266,
  [17477] = 16249,
  [17478] = 16270,
  [17479] = 16272,
  [17480] = 16250,
  [17481] = 16275,
  [17482] = 17482,
  [17483] = 16278,
  [17484] = 10772,
  [17485] = 16281,
  [17486] = 16252,
  [17487] = 16265,
  [17488] = 14644,
  [17489] = 16266,
  [17490] = 17482,
  [17491] = 16255,
  [17492] = 16270,
  [17493] = 16334,
  [17494] = 15246,
  [17495] = 16250,
  [17496] = 16272,
  [17497] = 16275,
  [17498] = 16256,
  [17499] = 16259,
  [17500] = 16955,
  [17501] = 16260,
  [17502] = 16258,
  [17503] = 16259,
  [17504] = 16263,
  [17505] = 16278,
  [17506] = 16269,
  [17507] = 16268,
  [17508] = 16281,
  [17509] = 16252,
  [17510] = 15930,
  [17511] = 16267,
  [17512] = 16260,
  [17513] = 16267,
  [17514] = 16255,
  [17515] = 16268,
  [17516] = 16269,
  [17517] = 16921,
  [17518] = 16263,
  [17519] = 16256,
  [17520] = 16258,
  [17521] = 16260,
  [17522] = 16256,
  [17523] = 16258,
  [17524] = 16255,
  [17525] = 17525,
  [17526] = 16263,
  [17527] = 16269,
  [17528] = 16268,
  [17529] = 16259,
  [17530] = 17154,
  [17531] = 16281,
  [17532] = 16267,
  [17533] = 16278,
  [17534] = 16252,
  [17535] = 16275,
  [17536] = 16267,
  [17537] = 16272,
  [17538] = 16268,
  [17539] = 16270,
  [17540] = 16269,
  [17541] = 16266,
  [17542] = 16263,
  [17543] = 16785,
  [17544] = 16265,
  [17545] = 16252,
  [17546] = 16800,
  [17547] = 16260,
  [17548] = 17548,
  [17549] = 16262,
  [17550] = 16259,
  [17551] = 16252,
  [17552] = 16261,
  [17553] = 15262,
  [17554] = 16258,
  [17555] = 16411,
  [17556] = 16256,
  [17557] = 3762,
  [17558] = 16250,
  [17559] = 16252,
  [17560] = 17560,
  [17561] = 16278,
  [17562] = 16275,
  [17563] = 16272,
  [17564] = 16252,
  [17565] = 16270,
  [17566] = 16250,
  [17567] = 16266,
  [17568] = 16252,
  [17569] = 16265,
  [17570] = 14644,
  [17571] = 16576,
  [17572] = 16252,
  [17573] = 16252,
  [17574] = 16281,
  [17575] = 16261,
  [17576] = 16255,
  [17577] = 16334,
  [17578] = 16252,
  [17579] = 3744,
  [17580] = 3761,
  [17581] = 16252,
  [17582] = 16258,
  [17583] = 16252,
  [17584] = 3770,
  [17585] = 16334,
  [17586] = 3760,
  [17587] = 3769,
  [17588] = 16256,
  [17589] = 16267,
  [17590] = 16258,
  [17591] = 16268,
  [17592] = 16334,
  [17593] = 8342,
  [17594] = 16269,
  [17595] = 10492,
  [17596] = 3772,
  [17597] = 3779,
  [17598] = 16263,
  [17599] = 16250,
  [17600] = 17342,
  [17601] = 16261,
  [17602] = 16252,
  [17603] = 16975,
  [17604] = 16262,
  [17605] = 16252,
  [17606] = 16265,
  [17607] = 16261,
  [17608] = 16262,
  [17609] = 3780,
  [17610] = 3755,
  [17611] = 3782,
  [17612] = 16818,
  [17613] = 16265,
  [17614] = 16266,
  [17615] = 10743,
  [17616] = 16266,
  [17617] = 16270,
  [17618] = 16259,
  [17619] = 16953,
  [17620] = 16260,
  [17621] = 16270,
  [17622] = 16272,
  [17623] = 16272,
  [17624] = 16275,
  [17625] = 14554,
  [17626] = 16278,
  [17627] = 16281,
  [17628] = 16275,
  [17629] = 17629,
  [17630] = 16278,
  [17631] = 16252,
  [17632] = 16267,
  [17633] = 16281,
  [17634] = 16268,
  [17635] = 16269,
  [17636] = 15868,
  [17637] = 16263,
  [17638] = 8395,
  [17639] = 16258,
  [17640] = 16819,
  [17641] = 16256,
  [17642] = 16255,
  [17643] = 16255,
  [17644] = 16255,
  [17645] = 10741,
  [17646] = 16256,
  [17647] = 17154,
  [17648] = 16263,
  [17649] = 16157,
  [17650] = 16281,
  [17651] = 16256,
  [17652] = 16278,
  [17653] = 16269,
  [17654] = 16275,
  [17655] = 16268,
  [17656] = 16272,
  [17657] = 16258,
  [17658] = 16270,
  [17659] = 17659,
  [17660] = 16266,
  [17661] = 16263,
  [17662] = 16267,
  [17663] = 16265,
  [17664] = 17482,
  [17665] = 16269,
  [17666] = 16252,
  [17667] = 16252,
  [17668] = 16262,
  [17669] = 16993,
  [17670] = 15632,
  [17671] = 16261,
  [17672] = 17342,
  [17673] = 10698,
  [17674] = 16260,
  [17675] = 15871,
  [17676] = 16268,
  [17677] = 3783,
  [17678] = 3754,
  [17679] = 16259,
  [17680] = 16249,
  [17681] = 3765,
  [17682] = 3744,
  [17683] = 16267,
  [17684] = 17684,
  [17685] = 16262,
  [17686] = 10715,
  [17687] = 16252,
  [17688] = 16260,
  [17689] = 16259,
  [17690] = 10706,
  [17691] = 16252,
  [17692] = 10492,
  [17693] = 16250,
  [17694] = 10698,
  [17695] = 3761,
  [17696] = 3762,
  [17697] = 15259,
  [17698] = 3764,
  [17699] = 3758,
  [17700] = 16252,
  [17701] = 3774,
  [17702] = 16921,
  [17703] = 17703,
  [17704] = 16250,
  [17705] = 16250,
  [17706] = 17706,
  [17707] = 3815,
  [17708] = 3746,
  [17709] = 16252,
  [17710] = 16281,
  [17711] = 16252,
  [17712] = 10715,
  [17713] = 16259,
  [17714] = 3815,
  [17715] = 16260,
  [17716] = 16252,
  [17717] = 16252,
  [17718] = 16250,
  [17719] = 17706,
  [17720] = 16334,
  [17721] = 16267,
  [17722] = 16252,
  [17723] = 16268,
  [17724] = 16269,
  [17725] = 16263,
  [17726] = 16258,
  [17727] = 3757,
  [17728] = 3781,
  [17729] = 16256,
  [17730] = 3789,
  [17731] = 3751,
  [17732] = 16255,
  [17733] = 15951,
  [17734] = 3791,
  [17735] = 3794,
  [17736] = 3796,
  [17737] = 16259,
  [17738] = 3760,
  [17739] = 16260,
  [17740] = 16261,
  [17741] = 3769,
  [17742] = 16252,
  [17743] = 16262,
  [17744] = 3789,
  [17745] = 3767,
  [17746] = 3750,
  [17747] = 3749,
  [17748] = 16265,
  [17749] = 3772,
  [17750] = 3779,
  [17751] = 16267,
  [17752] = 16278,
  [17753] = 16268,
  [17754] = 16269,
  [17755] = 16266,
  [17756] = 16263,
  [17757] = 3791,
  [17758] = 16258,
  [17759] = 16270,
  [17760] = 16256,
  [17761] = 3780,
  [17762] = 16255,
  [17763] = 16272,
  [17764] = 3782,
  [17765] = 15668,
  [17766] = 3794,
  [17767] = 3796,
  [17768] = 16275,
  [17769] = 16281,
  [17770] = 3747,
  [17771] = 16278,
  [17772] = 3778,
  [17773] = 16275,
  [17774] = 16278,
  [17775] = 16272,
  [17776] = 16281,
  [17777] = 16270,
  [17778] = 16275,
  [17779] = 16266,
  [17780] = 16272,
  [17781] = 16261,
  [17782] = 16265,
  [17783] = 16270,
  [17784] = 16262,
  [17785] = 16266,
  [17786] = 16265,
  [17787] = 16262,
  [17788] = 16265,
  [17789] = 16266,
  [17790] = 16261,
  [17791] = 17791,
  [17792] = 16270,
  [17793] = 16272,
  [17794] = 16262,
  [17795] = 16275,
  [17796] = 10698,
  [17797] = 16278,
  [17798] = 16252,
  [17799] = 16281,
  [17800] = 16252,
  [17801] = 16255,
  [17802] = 10706,
  [17803] = 10715,
  [17804] = 16256,
  [17805] = 16252,
  [17806] = 16258,
  [17807] = 16263,
  [17808] = 16269,
  [17809] = 10741,
  [17810] = 10743,
  [17811] = 16268,
  [17812] = 3777,
  [17813] = 10706,
  [17814] = 16267,
  [17815] = 16252,
  [17816] = 16250,
  [17817] = 15632,
  [17818] = 16252,
  [17819] = 16260,
  [17820] = 16259,
  [17821] = 16252,
  [17822] = 16250,
  [17823] = 16252,
  [17824] = 17824,
  [17825] = 16259,
  [17826] = 16252,
  [17827] = 16260,
  [17828] = 16252,
  [17829] = 16267,
  [17830] = 16334,
  [17831] = 16268,
  [17832] = 16269,
  [17833] = 16263,
  [17834] = 16261,
  [17835] = 16258,
  [17836] = 16256,
  [17837] = 16252,
  [17838] = 16255,
  [17839] = 3767,
  [17840] = 17840,
  [17841] = 17841,
  [17842] = 17842,
  [17843] = 17841,
  [17844] = 3723,
  [17845] = 10772,
  [17846] = 17846,
  [17847] = 17847,
  [17848] = 17325,
  [17849] = 17849,
  [17850] = 17850,
  [17851] = 17851,
  [17852] = 3731,
  [17853] = 3724,
  [17854] = 3728,
  [17855] = 17855,
  [17856] = 3730,
  [17857] = 17857,
  [17858] = 17858,
  [17859] = 17859,
  [17860] = 17860,
  [17861] = 17861,
  [17862] = 17862,
  [17863] = 17863,
  [17864] = 3723,
  [17865] = 17865,
  [17866] = 17866,
  [17867] = 17867,
  [17868] = 17850,
  [17869] = 17869,
  [17870] = 17840,
  [17871] = 17871,
  [17872] = 17198,
  [17873] = 17873,
  [17874] = 17874,
  [17875] = 17875,
  [17876] = 17857,
  [17877] = 17877,
  [17878] = 17878,
  [17879] = 17847,
  [17880] = 17880,
  [17881] = 17846,
  [17882] = 17882,
  [17883] = 17847,
  [17884] = 17866,
  [17885] = 17867,
  [17886] = 17886,
  [17887] = 16623,
  [17888] = 17840,
  [17889] = 17857,
  [17890] = 17871,
  [17891] = 17891,
  [17892] = 17877,
  [17893] = 17462,
  [17894] = 17886,
  [17895] = 17895,
  [17896] = 17882,
  [17897] = 17842,
  [17898] = 16948,
  [17899] = 17899,
  [17900] = 17869,
  [17901] = 17841,
  [17902] = 17902,
  [17903] = 17903,
  [17904] = 17855,
  [17905] = 17905,
  [17906] = 17863,
  [17907] = 17859,
  [17908] = 17861,
  [17909] = 17909,
  [17910] = 17859,
  [17911] = 17911,
  [17912] = 17855,
  [17913] = 17858,
  [17914] = 17914,
  [17915] = 17915,
  [17916] = 17377,
  [17917] = 17917,
  [17918] = 17861,
  [17919] = 17841,
  [17920] = 17920,
  [17921] = 17847,
  [17922] = 17842,
  [17923] = 17857,
  [17924] = 17863,
  [17925] = 17925,
  [17926] = 17926,
  [17927] = 17867,
  [17928] = 17928,
  [17929] = 17859,
  [17930] = 17860,
  [17931] = 17850,
  [17932] = 17877,
  [17933] = 17319,
  [17934] = 17934,
  [17935] = 17935,
  [17936] = 17869,
  [17937] = 17937,
  [17938] = 17846,
  [17939] = 17871,
  [17940] = 17840,
  [17941] = 17941,
  [17942] = 17942,
  [17943] = 17943,
  [17944] = 17882,
  [17945] = 17945,
  [17946] = 17886,
  [17947] = 17866,
  [17948] = 17840,
  [17949] = 17871,
  [17950] = 17866,
  [17951] = 17951,
  [17952] = 17952,
  [17953] = 17953,
  [17954] = 17877,
  [17955] = 17955,
  [17956] = 17956,
  [17957] = 17957,
  [17958] = 14554,
  [17959] = 17862,
  [17960] = 17960,
  [17961] = 17842,
  [17962] = 17841,
  [17963] = 17963,
  [17964] = 17850,
  [17965] = 15868,
  [17966] = 15743,
  [17967] = 17846,
  [17968] = 17968,
  [17969] = 17875,
  [17970] = 17970,
  [17971] = 17971,
  [17972] = 17972,
  [17973] = 17850,
  [17974] = 17855,
  [17975] = 17975,
  [17976] = 16576,
  [17977] = 17977,
  [17978] = 17859,
  [17979] = 17979,
  [17980] = 17861,
  [17981] = 17981,
  [17982] = 17863,
  [17983] = 17983,
  [17984] = 17984,
  [17985] = 10706,
  [17986] = 17867,
  [17987] = 17987,
  [17988] = 17869,
  [17989] = 17857,
  [17990] = 17847,
  [17991] = 17991,
  [17992] = 17992,
  [17993] = 17993,
  [17994] = 17994,
  [17995] = 17995,
  [17996] = 17996,
  [17997] = 17997,
  [17998] = 14644,
  [17999] = 10698,
  [18000] = 17886,
  [18001] = 17882,
  [18002] = 17882,
  [18003] = 17857,
  [18004] = 17869,
  [18005] = 17886,
  [18006] = 17847,
  [18007] = 17867,
  [18008] = 18008,
  [18009] = 18009,
  [18010] = 17858,
  [18011] = 17863,
  [18012] = 17860,
  [18013] = 17861,
  [18014] = 17862,
  [18015] = 17850,
  [18016] = 17875,
  [18017] = 17855,
  [18018] = 18018,
  [18019] = 18019,
  [18020] = 18020,
  [18021] = 17846,
  [18022] = 18022,
  [18023] = 18023,
  [18024] = 17866,
  [18025] = 17841,
  [18026] = 17842,
  [18027] = 18027,
  [18028] = 17840,
  [18029] = 17871,
  [18030] = 17891,
  [18031] = 17877,
  [18032] = 17877,
  [18033] = 16868,
  [18034] = 18034,
  [18035] = 17871,
  [18036] = 16866,
  [18037] = 17840,
  [18038] = 17866,
  [18039] = 17895,
  [18040] = 17847,
  [18041] = 17842,
  [18042] = 17857,
  [18043] = 17841,
  [18044] = 17902,
  [18045] = 17903,
  [18046] = 17943,
  [18047] = 18047,
  [18048] = 18048,
  [18049] = 18049,
  [18050] = 17850,
  [18051] = 17855,
  [18052] = 17846,
  [18053] = 17846,
  [18054] = 17905,
  [18055] = 18055,
  [18056] = 17859,
  [18057] = 17846,
  [18058] = 18058,
  [18059] = 17850,
  [18060] = 17400,
  [18061] = 18061,
  [18062] = 17909,
  [18063] = 18063,
  [18064] = 17081,
  [18065] = 17861,
  [18066] = 17866,
  [18067] = 17840,
  [18068] = 17871,
  [18069] = 17863,
  [18070] = 17303,
  [18071] = 17867,
  [18072] = 17869,
  [18073] = 17877,
  [18074] = 17937,
  [18075] = 18075,
  [18076] = 17942,
  [18077] = 17963,
  [18078] = 17882,
  [18079] = 17294,
  [18080] = 17842,
  [18081] = 17841,
  [18082] = 17945,
  [18083] = 17857,
  [18084] = 17847,
  [18085] = 18085,
  [18086] = 17250,
  [18087] = 17886,
  [18088] = 17951,
  [18089] = 18089,
  [18090] = 16731,
  [18091] = 17952,
  [18092] = 17955,
  [18093] = 17855,
  [18094] = 18094,
  [18095] = 17886,
  [18096] = 17882,
  [18097] = 17859,
  [18098] = 17956,
  [18099] = 17861,
  [18100] = 17957,
  [18101] = 17863,
  [18102] = 17090,
  [18103] = 17960,
  [18104] = 16653,
  [18105] = 17867,
  [18106] = 17968,
  [18107] = 17869,
  [18108] = 17869,
  [18109] = 17971,
  [18110] = 17867,
  [18111] = 17979,
  [18112] = 17863,
  [18113] = 17866,
  [18114] = 17861,
  [18115] = 17981,
  [18116] = 17993,
  [18117] = 17859,
  [18118] = 17855,
  [18119] = 17997,
  [18120] = 17882,
  [18121] = 18121,
  [18122] = 17840,
  [18123] = 14554,
  [18124] = 17886,
  [18125] = 17847,
  [18126] = 17841,
  [18127] = 17857,
  [18128] = 17842,
  [18129] = 10743,
  [18130] = 10741,
  [18131] = 17858,
  [18132] = 17860,
  [18133] = 17850,
  [18134] = 17875,
  [18135] = 17877,
  [18136] = 18136,
  [18137] = 18137,
  [18138] = 17871,
  [18139] = 17840,
  [18140] = 17871,
  [18141] = 17846,
  [18142] = 17866,
  [18143] = 17866,
  [18144] = 17891,
  [18145] = 17197,
  [18146] = 17840,
  [18147] = 17871,
  [18148] = 10715,
  [18149] = 17891,
  [18150] = 18150,
  [18151] = 15951,
  [18152] = 17877,
  [18153] = 17846,
  [18154] = 18154,
  [18155] = 18155,
  [18156] = 17895,
  [18157] = 17850,
  [18158] = 17877,
  [18159] = 17847,
  [18160] = 17857,
  [18161] = 17857,
  [18162] = 17847,
  [18163] = 10706,
  [18164] = 17842,
  [18165] = 17841,
  [18166] = 17895,
  [18167] = 18167,
  [18168] = 17902,
  [18169] = 17850,
  [18170] = 17855,
  [18171] = 17905,
  [18172] = 18172,
  [18173] = 17859,
  [18174] = 17909,
  [18175] = 14644,
  [18176] = 17846,
  [18177] = 17861,
  [18178] = 17886,
  [18179] = 17882,
  [18180] = 17863,
  [18181] = 17867,
  [18182] = 17869,
  [18183] = 17937,
  [18184] = 17842,
  [18185] = 17866,
  [18186] = 17840,
  [18187] = 17871,
  [18188] = 17882,
  [18189] = 18189,
  [18190] = 18190,
  [18191] = 17841,
  [18192] = 17877,
  [18193] = 17945,
  [18194] = 17886,
  [18195] = 17951,
  [18196] = 18196,
  [18197] = 17968,
  [18198] = 18198,
  [18199] = 17842,
  [18200] = 17841,
  [18201] = 17981,
  [18202] = 17869,
  [18203] = 17993,
  [18204] = 18204,
  [18205] = 17867,
  [18206] = 18206,
  [18207] = 17857,
  [18208] = 18208,
  [18209] = 17858,
  [18210] = 17863,
  [18211] = 17860,
  [18212] = 17855,
  [18213] = 17861,
  [18214] = 17850,
  [18215] = 17859,
  [18216] = 17859,
  [18217] = 17875,
  [18218] = 17861,
  [18219] = 17846,
  [18220] = 17863,
  [18221] = 18221,
  [18222] = 18222,
  [18223] = 17866,
  [18224] = 17867,
  [18225] = 17840,
  [18226] = 17869,
  [18227] = 17855,
  [18228] = 18228,
  [18229] = 17902,
  [18230] = 18230,
  [18231] = 18231,
  [18232] = 18232,
  [18233] = 17871,
  [18234] = 18234,
  [18235] = 17891,
  [18236] = 17877,
  [18237] = 17841,
  [18238] = 17842,
  [18239] = 17882,
  [18240] = 18240,
  [18241] = 17895,
  [18242] = 18242,
  [18243] = 17886,
  [18244] = 18244,
  [18245] = 17842,
  [18246] = 17841,
  [18247] = 18247,
  [18248] = 17877,
  [18249] = 18249,
  [18250] = 17902,
  [18251] = 17871,
  [18252] = 14554,
  [18253] = 17840,
  [18254] = 17866,
  [18255] = 17847,
  [18256] = 14275,
  [18257] = 17855,
  [18258] = 17905,
  [18259] = 17909,
  [18260] = 17861,
  [18261] = 17863,
  [18262] = 17867,
  [18263] = 16157,
  [18264] = 17846,
  [18265] = 17869,
  [18266] = 17937,
  [18267] = 18267,
  [18268] = 18268,
  [18269] = 17850,
  [18270] = 18270,
  [18271] = 16731,
  [18272] = 18272,
  [18273] = 17882,
  [18274] = 18274,
  [18275] = 17857,
  [18276] = 17847,
  [18277] = 17945,
  [18278] = 17847,
  [18279] = 18279,
  [18280] = 17857,
  [18281] = 17886,
  [18282] = 17951,
  [18283] = 18283,
  [18284] = 17981,
  [18285] = 14644,
  [18286] = 18286,
  [18287] = 17847,
  [18288] = 17850,
  [18289] = 17886,
  [18290] = 16608,
  [18291] = 10235,
  [18292] = 17857,
  [18293] = 17859,
  [18294] = 17858,
  [18295] = 17846,
  [18296] = 17945,
  [18297] = 17882,
  [18298] = 18232,
  [18299] = 17860,
  [18300] = 18190,
  [18301] = 17850,
  [18302] = 17875,
  [18303] = 17846,
  [18304] = 17866,
  [18305] = 17840,
  [18306] = 17871,
  [18307] = 17866,
  [18308] = 18244,
  [18309] = 18309,
  [18310] = 18206,
  [18311] = 17877,
  [18312] = 17840,
  [18313] = 17877,
  [18314] = 18314,
  [18315] = 17871,
  [18316] = 17891,
  [18317] = 17869,
  [18318] = 17842,
  [18319] = 17841,
  [18320] = 17877,
  [18321] = 17895,
  [18322] = 17867,
  [18323] = 17842,
  [18324] = 17841,
  [18325] = 17863,
  [18326] = 17903,
  [18327] = 17861,
  [18328] = 18231,
  [18329] = 17902,
  [18330] = 17909,
  [18331] = 17855,
  [18332] = 17859,
  [18333] = 18228,
  [18334] = 17905,
  [18335] = 17859,
  [18336] = 18222,
  [18337] = 17861,
  [18338] = 17855,
  [18339] = 17863,
  [18340] = 17905,
  [18341] = 17855,
  [18342] = 8198,
  [18343] = 17867,
  [18344] = 18208,
  [18345] = 17869,
  [18346] = 17909,
  [18347] = 18347,
  [18348] = 17861,
  [18349] = 18349,
  [18350] = 18350,
  [18351] = 17863,
  [18352] = 18204,
  [18353] = 17841,
  [18354] = 17867,
  [18355] = 17842,
  [18356] = 18356,
  [18357] = 17869,
  [18358] = 17882,
  [18359] = 18198,
  [18360] = 17943,
  [18361] = 17882,
  [18362] = 17886,
  [18363] = 17895,
  [18364] = 18364,
  [18365] = 17945,
  [18366] = 18366,
  [18367] = 18367,
  [18368] = 17891,
  [18369] = 18369,
  [18370] = 17871,
  [18371] = 17886,
  [18372] = 17840,
  [18373] = 18189,
  [18374] = 17866,
  [18375] = 17951,
  [18376] = 17859,
  [18377] = 17847,
  [18378] = 17857,
  [18379] = 17858,
  [18380] = 17860,
  [18381] = 17850,
  [18382] = 18382,
  [18383] = 17090,
  [18384] = 17846,
  [18385] = 17875,
  [18386] = 18172,
  [18387] = 17846,
  [18388] = 15871,
  [18389] = 17855,
  [18390] = 17850,
  [18391] = 18391,
  [18392] = 18392,
  [18393] = 17860,
  [18394] = 18394,
  [18395] = 17858,
  [18396] = 18396,
  [18397] = 17847,
  [18398] = 18398,
  [18399] = 17857,
  [18400] = 18400,
  [18401] = 17866,
  [18402] = 17905,
  [18403] = 17840,
  [18404] = 18404,
  [18405] = 17857,
  [18406] = 17871,
  [18407] = 17850,
  [18408] = 17847,
  [18409] = 18409,
  [18410] = 17081,
  [18411] = 18411,
  [18412] = 18155,
  [18413] = 18413,
  [18414] = 17846,
  [18415] = 17891,
  [18416] = 18416,
  [18417] = 17877,
  [18418] = 17895,
  [18419] = 18419,
  [18420] = 17842,
  [18421] = 17841,
  [18422] = 10698,
  [18423] = 17866,
  [18424] = 17840,
  [18425] = 17871,
  [18426] = 18426,
  [18427] = 17197,
  [18428] = 18428,
  [18429] = 17905,
  [18430] = 17877,
  [18431] = 18431,
  [18432] = 18432,
  [18433] = 17859,
  [18434] = 17909,
  [18435] = 17861,
  [18436] = 17886,
  [18437] = 17842,
  [18438] = 17841,
  [18439] = 18439,
  [18440] = 18440,
  [18441] = 18022,
  [18442] = 18442,
  [18443] = 17945,
  [18444] = 14467,
  [18445] = 17994,
  [18446] = 17987,
  [18447] = 17863,
  [18448] = 17882,
  [18449] = 17867,
  [18450] = 17855,
  [18451] = 18451,
  [18452] = 17983,
  [18453] = 18453,
  [18454] = 17859,
  [18455] = 17869,
  [18456] = 17861,
  [18457] = 17859,
  [18458] = 17863,
  [18459] = 10698,
  [18460] = 17869,
  [18461] = 17855,
  [18462] = 17867,
  [18463] = 17882,
  [18464] = 17869,
  [18465] = 17867,
  [18466] = 10289,
  [18467] = 18467,
  [18468] = 18468,
  [18469] = 17945,
  [18470] = 17863,
  [18471] = 17886,
  [18472] = 17861,
  [18473] = 18473,
  [18474] = 17847,
  [18475] = 17909,
  [18476] = 17859,
  [18477] = 17882,
  [18478] = 18478,
  [18479] = 17905,
  [18480] = 17855,
  [18481] = 17886,
  [18482] = 17909,
  [18483] = 18483,
  [18484] = 17857,
  [18485] = 18485,
  [18486] = 18486,
  [18487] = 17858,
  [18488] = 17860,
  [18489] = 18489,
  [18490] = 17850,
  [18491] = 14267,
  [18492] = 17841,
  [18493] = 17842,
  [18494] = 17875,
  [18495] = 17846,
  [18496] = 17861,
  [18497] = 17250,
  [18498] = 17866,
  [18499] = 18499,
  [18500] = 17840,
  [18501] = 17895,
  [18502] = 17877,
  [18503] = 18503,
  [18504] = 17891,
  [18505] = 18505,
  [18506] = 17871,
  [18507] = 17840,
  [18508] = 17871,
  [18509] = 17866,
  [18510] = 17891,
  [18511] = 17877,
  [18512] = 18512,
  [18513] = 17895,
  [18514] = 18514,
  [18515] = 17445,
  [18516] = 17847,
  [18517] = 18517,
  [18518] = 17857,
  [18519] = 18519,
  [18520] = 17846,
  [18521] = 17842,
  [18522] = 17841,
  [18523] = 17863,
  [18524] = 17855,
  [18525] = 17905,
  [18526] = 17850,
  [18527] = 18527,
  [18528] = 18528,
  [18529] = 18529,
  [18530] = 18530,
  [18531] = 18531,
  [18532] = 17859,
  [18533] = 17846,
  [18534] = 17850,
  [18535] = 17909,
  [18536] = 18536,
  [18537] = 18537,
  [18538] = 18538,
  [18539] = 17926,
  [18540] = 18221,
  [18541] = 17861,
  [18542] = 17866,
  [18543] = 17840,
  [18544] = 17871,
  [18545] = 17860,
  [18546] = 17863,
  [18547] = 17858,
  [18548] = 16623,
  [18549] = 17877,
  [18550] = 17867,
  [18551] = 18049,
  [18552] = 17869,
  [18553] = 18047,
  [18554] = 18554,
  [18555] = 17882,
  [18556] = 17842,
  [18557] = 17841,
  [18558] = 17867,
  [18559] = 17857,
  [18560] = 18560,
  [18561] = 17847,
  [18562] = 17053,
  [18563] = 18537,
  [18564] = 18564,
  [18565] = 18538,
  [18566] = 17945,
  [18567] = 17886,
  [18568] = 17855,
  [18569] = 17855,
  [18570] = 18221,
  [18571] = 17886,
  [18572] = 17945,
  [18573] = 17859,
  [18574] = 17869,
  [18575] = 17861,
  [18576] = 18576,
  [18577] = 17863,
  [18578] = 18578,
  [18579] = 17882,
  [18580] = 17878,
  [18581] = 17867,
  [18582] = 17857,
  [18583] = 17869,
  [18584] = 17858,
  [18585] = 17869,
  [18586] = 17860,
  [18587] = 17867,
  [18588] = 18588,
  [18589] = 17850,
  [18590] = 18590,
  [18591] = 17863,
  [18592] = 18560,
  [18593] = 18537,
  [18594] = 17861,
  [18595] = 18564,
  [18596] = 17882,
  [18597] = 17909,
  [18598] = 18536,
  [18599] = 18599,
  [18600] = 17886,
  [18601] = 17937,
  [18602] = 17859,
  [18603] = 18538,
  [18604] = 17905,
  [18605] = 17192,
  [18606] = 17875,
  [18607] = 18588,
  [18608] = 18221,
  [18609] = 17846,
  [18610] = 17841,
  [18611] = 17842,
  [18612] = 18196,
  [18613] = 18529,
  [18614] = 17866,
  [18615] = 17840,
  [18616] = 17871,
  [18617] = 17891,
  [18618] = 17877,
  [18619] = 17895,
  [18620] = 17877,
  [18621] = 18528,
  [18622] = 17891,
  [18623] = 17871,
  [18624] = 17840,
  [18625] = 17895,
  [18626] = 17866,
  [18627] = 18560,
  [18628] = 18527,
  [18629] = 18519,
  [18630] = 18537,
  [18631] = 18517,
  [18632] = 18632,
  [18633] = 18564,
  [18634] = 17445,
  [18635] = 17847,
  [18636] = 18636,
  [18637] = 17857,
  [18638] = 17842,
  [18639] = 18639,
  [18640] = 17841,
  [18641] = 18503,
  [18642] = 17846,
  [18643] = 18538,
  [18644] = 17855,
  [18645] = 17850,
  [18646] = 18489,
  [18647] = 18647,
  [18648] = 18648,
  [18649] = 18649,
  [18650] = 18440,
  [18651] = 17905,
  [18652] = 17846,
  [18653] = 18221,
  [18654] = 17859,
  [18655] = 18486,
  [18656] = 17995,
  [18657] = 17909,
  [18658] = 18196,
  [18659] = 17861,
  [18660] = 17863,
  [18661] = 17866,
  [18662] = 17840,
  [18663] = 17871,
  [18664] = 17867,
  [18665] = 17869,
  [18666] = 17847,
  [18667] = 18485,
  [18668] = 17877,
  [18669] = 17945,
  [18670] = 14467,
  [18671] = 17886,
  [18672] = 18538,
  [18673] = 17984,
  [18674] = 17850,
  [18675] = 17842,
  [18676] = 17841,
  [18677] = 18677,
  [18678] = 18678,
  [18679] = 18483,
  [18680] = 17860,
  [18681] = 18530,
  [18682] = 17858,
  [18683] = 18468,
  [18684] = 18684,
  [18685] = 10772,
  [18686] = 17847,
  [18687] = 17857,
  [18688] = 17855,
  [18689] = 17857,
  [18690] = 18467,
  [18691] = 17847,
  [18692] = 17859,
  [18693] = 17858,
  [18694] = 17861,
  [18695] = 17860,
  [18696] = 17863,
  [18697] = 17850,
  [18698] = 18698,
  [18699] = 18453,
  [18700] = 17867,
  [18701] = 17875,
  [18702] = 17869,
  [18703] = 17882,
  [18704] = 18649,
  [18705] = 18705,
  [18706] = 18706,
  [18707] = 18451,
  [18708] = 18560,
  [18709] = 18442,
  [18710] = 18537,
  [18711] = 18632,
  [18712] = 18564,
  [18713] = 17846,
  [18714] = 17886,
  [18715] = 17882,
  [18716] = 17945,
  [18717] = 17882,
  [18718] = 18364,
  [18719] = 17886,
  [18720] = 18432,
  [18721] = 18636,
  [18722] = 18538,
  [18723] = 17869,
  [18724] = 17866,
  [18725] = 17867,
  [18726] = 18428,
  [18727] = 18440,
  [18728] = 18221,
  [18729] = 17863,
  [18730] = 17840,
  [18731] = 17861,
  [18732] = 18426,
  [18733] = 17871,
  [18734] = 17909,
  [18735] = 18023,
  [18736] = 18196,
  [18737] = 17859,
  [18738] = 17891,
  [18739] = 17905,
  [18740] = 17877,
  [18741] = 17855,
  [18742] = 17895,
  [18743] = 17842,
  [18744] = 17841,
  [18745] = 17842,
  [18746] = 17855,
  [18747] = 17905,
  [18748] = 18748,
  [18749] = 17859,
  [18750] = 17909,
  [18751] = 17895,
  [18752] = 17877,
  [18753] = 18411,
  [18754] = 17847,
  [18755] = 16389,
  [18756] = 17857,
  [18757] = 17953,
  [18758] = 17891,
  [18759] = 17861,
  [18760] = 17871,
  [18761] = 17863,
  [18762] = 17840,
  [18763] = 17941,
  [18764] = 17850,
  [18765] = 17866,
  [18766] = 18766,
  [18767] = 17867,
  [18768] = 17869,
  [18769] = 17935,
  [18770] = 17882,
  [18771] = 17846,
  [18772] = 17945,
  [18773] = 17886,
  [18774] = 18774,
  [18775] = 17934,
  [18776] = 18776,
  [18777] = 17869,
  [18778] = 17867,
  [18779] = 17841,
  [18780] = 17866,
  [18781] = 17840,
  [18782] = 17871,
  [18783] = 17842,
  [18784] = 18705,
  [18785] = 17840,
  [18786] = 18404,
  [18787] = 17877,
  [18788] = 17866,
  [18789] = 14554,
  [18790] = 17847,
  [18791] = 17857,
  [18792] = 17847,
  [18793] = 18793,
  [18794] = 17842,
  [18795] = 17841,
  [18796] = 17857,
  [18797] = 17942,
  [18798] = 18367,
  [18799] = 18799,
  [18800] = 17846,
  [18801] = 17869,
  [18802] = 17867,
  [18803] = 18803,
  [18804] = 17841,
  [18805] = 17842,
  [18806] = 17840,
  [18807] = 17855,
  [18808] = 17866,
  [18809] = 17858,
  [18810] = 17850,
  [18811] = 17859,
  [18812] = 17860,
  [18813] = 17861,
  [18814] = 17857,
  [18815] = 17863,
  [18816] = 17847,
  [18817] = 17875,
  [18818] = 17869,
  [18819] = 17867,
  [18820] = 17867,
  [18821] = 17869,
  [18822] = 17860,
  [18823] = 17841,
  [18824] = 17842,
  [18825] = 17858,
  [18826] = 17840,
  [18827] = 17866,
  [18828] = 18400,
  [18829] = 14275,
  [18830] = 17846,
  [18831] = 17857,
  [18832] = 17857,
  [18833] = 17847,
  [18834] = 17882,
  [18835] = 17847,
  [18836] = 17869,
  [18837] = 18837,
  [18838] = 17886,
  [18839] = 17867,
  [18840] = 17841,
  [18841] = 17842,
  [18842] = 17840,
  [18843] = 17866,
  [18844] = 17866,
  [18845] = 17857,
  [18846] = 17840,
  [18847] = 17847,
  [18848] = 17871,
  [18849] = 17891,
  [18850] = 17877,
  [18851] = 18851,
  [18852] = 17869,
  [18853] = 17886,
  [18854] = 17867,
  [18855] = 17895,
  [18856] = 18398,
  [18857] = 17841,
  [18858] = 17945,
  [18859] = 17882,
  [18860] = 17842,
  [18861] = 17840,
  [18862] = 17869,
  [18863] = 17866,
  [18864] = 17867,
  [18865] = 18865,
  [18866] = 18394,
  [18867] = 17863,
  [18868] = 17857,
  [18869] = 17861,
  [18870] = 17847,
  [18871] = 17909,
  [18872] = 18392,
  [18873] = 17847,
  [18874] = 17859,
  [18875] = 17857,
  [18876] = 17905,
  [18877] = 17842,
  [18878] = 17841,
  [18879] = 17855,
  [18880] = 18391,
  [18881] = 17869,
  [18882] = 18882,
  [18883] = 17850,
  [18884] = 17867,
  [18885] = 17841,
  [18886] = 17841,
  [18887] = 17842,
  [18888] = 17842,
  [18889] = 17840,
  [18890] = 17846,
  [18891] = 17866,
  [18892] = 18382,
  [18893] = 17855,
  [18894] = 17857,
  [18895] = 17905,
  [18896] = 17847,
  [18897] = 17859,
  [18898] = 17928,
  [18899] = 17866,
  [18900] = 17840,
  [18901] = 17871,
  [18902] = 17909,
  [18903] = 17850,
  [18904] = 18369,
  [18905] = 17869,
  [18906] = 17877,
  [18907] = 17867,
  [18908] = 17895,
  [18909] = 17841,
  [18910] = 17842,
  [18911] = 17840,
  [18912] = 17877,
  [18913] = 17842,
  [18914] = 17841,
  [18915] = 17866,
  [18916] = 17891,
  [18917] = 15930,
  [18918] = 18366,
  [18919] = 17871,
  [18920] = 18356,
  [18921] = 18478,
  [18922] = 18922,
  [18923] = 17861,
  [18924] = 17857,
  [18925] = 17840,
  [18926] = 17855,
  [18927] = 17863,
  [18928] = 18349,
  [18929] = 17866,
  [18930] = 17859,
  [18931] = 17847,
  [18932] = 17861,
  [18933] = 17925,
  [18934] = 17863,
  [18935] = 17867,
  [18936] = 18936,
  [18937] = 17920,
  [18938] = 17867,
  [18939] = 17917,
  [18940] = 17869,
  [18941] = 17869,
  [18942] = 17867,
  [18943] = 17841,
  [18944] = 17842,
  [18945] = 17840,
  [18946] = 17846,
  [18947] = 17866,
  [18948] = 17869,
  [18949] = 14644,
  [18950] = 17857,
  [18951] = 17847,
  [18952] = 17914,
  [18953] = 17882,
  [18954] = 17850,
  [18955] = 18347,
  [18956] = 18956,
  [18957] = 17886,
  [18958] = 18958,
  [18959] = 17860,
  [18960] = 17882,
  [18961] = 10706,
  [18962] = 17858,
  [18963] = 17945,
  [18964] = 17886,
  [18965] = 17869,
  [18966] = 17867,
  [18967] = 17857,
  [18968] = 17841,
  [18969] = 17847,
  [18970] = 17842,
  [18971] = 17840,
  [18972] = 17866,
  [18973] = 17857,
  [18974] = 17847,
  [18975] = 18636,
  [18976] = 17869,
  [18977] = 17867,
  [18978] = 17841,
  [18979] = 17842,
  [18980] = 17840,
  [18981] = 17866,
  [18982] = 17857,
  [18983] = 17857,
  [18984] = 17886,
  [18985] = 17847,
  [18986] = 17945,
  [18987] = 17882,
  [18988] = 18988,
  [18989] = 17858,
  [18990] = 17860,
  [18991] = 17869,
  [18992] = 17847,
  [18993] = 17850,
  [18994] = 17857,
  [18995] = 17867,
  [18996] = 8482,
  [18997] = 17875,
  [18998] = 17869,
  [18999] = 17867,
  [19000] = 17863,
  [19001] = 17841,
  [19002] = 17850,
  [19003] = 19003,
  [19004] = 18309,
  [19005] = 19005,
  [19006] = 19006,
  [19007] = 17842,
  [19008] = 17840,
  [19009] = 17846,
  [19010] = 17997,
  [19011] = 17861,
  [19012] = 17866,
  [19013] = 17847,
  [19014] = 17874,
  [19015] = 17857,
  [19016] = 17847,
  [19017] = 17846,
  [19018] = 17866,
  [19019] = 17840,
  [19020] = 17871,
  [19021] = 17909,
  [19022] = 19022,
  [19023] = 17859,
  [19024] = 17905,
  [19025] = 17877,
  [19026] = 17865,
  [19027] = 17855,
  [19028] = 17869,
  [19029] = 17867,
  [19030] = 17841,
  [19031] = 17842,
  [19032] = 17842,
  [19033] = 17841,
  [19034] = 17840,
  [19035] = 17866,
  [19036] = 17963,
  [19037] = 17706,
  [19038] = 17993,
  [19039] = 17857,
  [19040] = 19040,
  [19041] = 17847,
  [19042] = 17866,
  [19043] = 17841,
  [19044] = 17842,
  [19045] = 17855,
  [19046] = 17840,
  [19047] = 17871,
  [19048] = 17869,
  [19049] = 17859,
  [19050] = 17867,
  [19051] = 17861,
  [19052] = 17891,
  [19053] = 17863,
  [19054] = 17841,
  [19055] = 17842,
  [19056] = 17840,
  [19057] = 17867,
  [19058] = 17866,
  [19059] = 17869,
  [19060] = 17877,
  [19061] = 17895,
  [19062] = 17895,
  [19063] = 17877,
  [19064] = 17857,
  [19065] = 17891,
  [19066] = 17871,
  [19067] = 17847,
  [19068] = 17849,
  [19069] = 17840,
  [19070] = 17842,
  [19071] = 17866,
  [19072] = 17882,
  [19073] = 17869,
  [19074] = 17867,
  [19075] = 17841,
  [19076] = 17886,
  [19077] = 19077,
  [19078] = 17841,
  [19079] = 17842,
  [19080] = 17840,
  [19081] = 17846,
  [19082] = 17866,
  [19083] = 18279,
  [19084] = 17857,
  [19085] = 17847,
  [19086] = 17855,
  [19087] = 17905,
  [19088] = 17859,
  [19089] = 19089,
  [19090] = 17909,
  [19091] = 17869,
  [19092] = 17867,
  [19093] = 17841,
  [19094] = 18706,
  [19095] = 17850,
  [19096] = 17842,
  [19097] = 17860,
  [19098] = 17858,
  [19099] = 17840,
  [19100] = 17866,
  [19101] = 17857,
  [19102] = 17861,
  [19103] = 17847,
  [19104] = 17857,
  [19105] = 17847,
  [19106] = 17863,
  [19107] = 19107,
  [19108] = 19108,
  [19109] = 17895,
  [19110] = 17869,
  [19111] = 17847,
  [19112] = 15632,
  [19113] = 17857,
  [19114] = 17867,
  [19115] = 17841,
  [19116] = 17842,
  [19117] = 17840,
  [19118] = 17866,
  [19119] = 17869,
  [19120] = 19120,
  [19121] = 17850,
  [19122] = 17857,
  [19123] = 19123,
  [19124] = 17847,
  [19125] = 17867,
  [19126] = 17882,
  [19127] = 17945,
  [19128] = 17846,
  [19129] = 17899,
  [19130] = 17886,
  [19131] = 17869,
  [19132] = 17867,
  [19133] = 17841,
  [19134] = 17842,
  [19135] = 17840,
  [19136] = 17866,
  [19137] = 17866,
  [19138] = 17840,
  [19139] = 17871,
  [19140] = 17857,
  [19141] = 17847,
  [19142] = 17851,
  [19143] = 17869,
  [19144] = 17877,
  [19145] = 17867,
  [19146] = 17841,
  [19147] = 17842,
  [19148] = 17840,
  [19149] = 17866,
  [19150] = 17886,
  [19151] = 17842,
  [19152] = 17841,
  [19153] = 17857,
  [19154] = 17945,
  [19155] = 17882,
  [19156] = 18274,
  [19157] = 17847,
  [19158] = 19158,
  [19159] = 17847,
  [19160] = 17857,
  [19161] = 17869,
  [19162] = 17867,
  [19163] = 17869,
  [19164] = 17855,
  [19165] = 17841,
  [19166] = 17867,
  [19167] = 17842,
  [19168] = 17859,
  [19169] = 17840,
  [19170] = 17861,
  [19171] = 17866,
  [19172] = 17863,
  [19173] = 17858,
  [19174] = 17857,
  [19175] = 17860,
  [19176] = 17867,
  [19177] = 17847,
  [19178] = 17869,
  [19179] = 17850,
  [19180] = 18272,
  [19181] = 17863,
  [19182] = 17875,
  [19183] = 18270,
  [19184] = 17861,
  [19185] = 17869,
  [19186] = 17909,
  [19187] = 17867,
  [19188] = 17859,
  [19189] = 17841,
  [19190] = 17905,
  [19191] = 17882,
  [19192] = 17855,
  [19193] = 18268,
  [19194] = 17842,
  [19195] = 17886,
  [19196] = 15668,
  [19197] = 17840,
  [19198] = 17866,
  [19199] = 17857,
  [19200] = 17846,
  [19201] = 17841,
  [19202] = 17842,
  [19203] = 17847,
  [19204] = 17882,
  [19205] = 17869,
  [19206] = 17867,
  [19207] = 17841,
  [19208] = 18267,
  [19209] = 17842,
  [19210] = 17877,
  [19211] = 17840,
  [19212] = 17866,
  [19213] = 17891,
  [19214] = 17866,
  [19215] = 17871,
  [19216] = 17857,
  [19217] = 17840,
  [19218] = 17840,
  [19219] = 17866,
  [19220] = 17847,
  [19221] = 17871,
  [19222] = 17891,
  [19223] = 17873,
  [19224] = 17869,
  [19225] = 17867,
  [19226] = 17846,
  [19227] = 17877,
  [19228] = 17841,
  [19229] = 17842,
  [19230] = 17847,
  [19231] = 17840,
  [19232] = 17857,
  [19233] = 17703,
  [19234] = 17866,
  [19235] = 17895,
  [19236] = 15259,
  [19237] = 19237,
  [19238] = 17850,
  [19239] = 17857,
  [19240] = 17850,
  [19241] = 19241,
  [19242] = 17847,
  [19243] = 18240,
  [19244] = 17860,
  [19245] = 17842,
  [19246] = 17841,
  [19247] = 17846,
  [19248] = 17858,
  [19249] = 18234,
  [19250] = 17869,
  [19251] = 17867,
  [19252] = 17841,
  [19253] = 17842,
  [19254] = 17840,
  [19255] = 17866,
  [19256] = 17866,
  [19257] = 17840,
  [19258] = 17871,
  [19259] = 17861,
  [19260] = 17855,
  [19261] = 18350,
  [19262] = 17325,
  [19263] = 17877,
  [19264] = 17857,
  [19265] = 17905,
  [19266] = 17847,
  [19267] = 17859,
  [19268] = 17880,
  [19269] = 17981,
  [19270] = 17842,
  [19271] = 17841,
  [19272] = 17909,
  [19273] = 17869,
  [19274] = 17867,
  [19275] = 17841,
  [19276] = 17842,
  [19277] = 17857,
  [19278] = 17840,
  [19279] = 17866,
  [19280] = 17861,
  [19281] = 17847,
  [19282] = 17857,
  [19283] = 17855,
  [19284] = 16993,
  [19285] = 17863,
  [19286] = 16955,
  [19287] = 17859,
  [19288] = 17847,
  [19289] = 17861,
  [19290] = 17867,
  [19291] = 17863,
  [19292] = 19292,
  [19293] = 19293,
  [19294] = 19294,
  [19295] = 17867,
  [19296] = 17869,
  [19297] = 17869,
  [19298] = 16953,
  [19299] = 18230,
  [19300] = 17867,
  [19301] = 17841,
  [19302] = 19302,
  [19303] = 17842,
  [19304] = 17840,
  [19305] = 17866,
  [19306] = 17198,
  [19307] = 17857,
  [19308] = 17847,
  [19309] = 17882,
  [19310] = 17882,
  [19311] = 19311,
  [19312] = 19312,
  [19313] = 17945,
  [19314] = 17886,
  [19315] = 19315,
  [19316] = 17869,
  [19317] = 17867,
  [19318] = 17886,
  [19319] = 17945,
  [19320] = 17882,
  [19321] = 17886,
  [19322] = 17841,
  [19323] = 17842,
  [19324] = 17840,
  [19325] = 17866,
  [19326] = 17886,
  [19327] = 17869,
  [19328] = 17857,
  [19329] = 17867,
  [19330] = 17847,
  [19331] = 17945,
  [19332] = 17869,
  [19333] = 17863,
  [19334] = 17867,
  [19335] = 17841,
  [19336] = 17842,
  [19337] = 17840,
  [19338] = 17909,
  [19339] = 17859,
  [19340] = 17866,
  [19341] = 17905,
  [19342] = 17855,
  [19343] = 17857,
  [19344] = 8342,
  [19345] = 17847,
  [19346] = 17847,
  [19347] = 17857,
  [19348] = 17847,
  [19349] = 19349,
  [19350] = 17857,
  [19351] = 8395,
  [19352] = 17841,
  [19353] = 17869,
  [19354] = 17842,
  [19355] = 17867,
  [19356] = 17841,
  [19357] = 17842,
  [19358] = 17850,
  [19359] = 17840,
  [19360] = 17866,
  [19361] = 17858,
  [19362] = 17846,
  [19363] = 17857,
  [19364] = 19364,
  [19365] = 17860,
  [19366] = 17847,
  [19367] = 17850,
  [19368] = 17951,
  [19369] = 17869,
  [19370] = 17866,
  [19371] = 17840,
  [19372] = 17871,
  [19373] = 18564,
  [19374] = 17895,
  [19375] = 17877,
  [19376] = 17869,
  [19377] = 17877,
  [19378] = 17867,
  [19379] = 17841,
  [19380] = 17842,
  [19381] = 17840,
  [19382] = 17842,
  [19383] = 17841,
  [19384] = 17866,
  [19385] = 17891,
  [19386] = 15246,
  [19387] = 17871,
  [19388] = 17857,
  [19389] = 17840,
  [19390] = 17847,
  [19391] = 17866,
  [19392] = 17846,
  [19393] = 17855,
  [19394] = 18009,
  [19395] = 17875,
  [19396] = 17869,
  [19397] = 17859,
  [19398] = 17867,
  [19399] = 17861,
  [19400] = 17841,
  [19401] = 17863,
  [19402] = 17842,
  [19403] = 17867,
  [19404] = 17840,
  [19405] = 17869,
  [19406] = 17866,
  [19407] = 17866,
  [19408] = 17857,
  [19409] = 17846,
  [19410] = 18167,
  [19411] = 17847,
  [19412] = 19412,
  [19413] = 17840,
  [19414] = 17871,
  [19415] = 17911,
  [19416] = 17869,
  [19417] = 17867,
  [19418] = 17882,
  [19419] = 15871,
  [19420] = 17841,
  [19421] = 17850,
  [19422] = 17886,
  [19423] = 19423,
  [19424] = 17842,
  [19425] = 17840,
  [19426] = 17860,
  [19427] = 17858,
  [19428] = 17866,
  [19429] = 17891,
  [19430] = 16398,
  [19431] = 17915,
  [19432] = 17857,
  [19433] = 17857,
  [19434] = 17847,
  [19435] = 16357,
  [19436] = 16350,
  [19437] = 17877,
  [19438] = 17847,
  [19439] = 17895,
  [19440] = 15736,
  [19441] = 17869,
  [19442] = 15641,
  [19443] = 17979,
  [19444] = 17867,
  [19445] = 17841,
  [19446] = 17842,
  [19447] = 17840,
  [19448] = 15036,
  [19449] = 17866,
  [19450] = 17842,
  [19451] = 17971,
  [19452] = 17857,
  [19453] = 17841,
  [19454] = 17847,
  [19455] = 17847,
  [19456] = 16157,
  [19457] = 17857,
  [19458] = 17855,
  [19459] = 19459,
  [19460] = 17869,
  [19461] = 17867,
  [19462] = 17905,
  [19463] = 17841,
  [19464] = 17842,
  [19465] = 17840,
  [19466] = 17866,
  [19467] = 17866,
  [19468] = 17840,
  [19469] = 15951,
  [19470] = 17857,
  [19471] = 17859,
  [19472] = 17842,
  [19473] = 17841,
  [19474] = 17847,
  [19475] = 16552,
  [19476] = 17886,
  [19477] = 17909,
  [19478] = 19478,
  [19479] = 17867,
  [19480] = 17861,
  [19481] = 17869,
  [19482] = 17869,
  [19483] = 17867,
  [19484] = 17945,
  [19485] = 17882,
  [19486] = 17968,
  [19487] = 17841,
  [19488] = 17847,
  [19489] = 17842,
  [19490] = 17857,
  [19491] = 17840,
  [19492] = 17866,
  [19493] = 16540,
  [19494] = 17869,
  [19495] = 17863,
  [19496] = 17857,
  [19497] = 17867,
  [19498] = 17847,
  [19499] = 17869,
  [19500] = 17866,
  [19501] = 17840,
  [19502] = 17882,
  [19503] = 17869,
  [19504] = 17867,
  [19505] = 17842,
  [19506] = 17841,
  [19507] = 17945,
  [19508] = 17841,
  [19509] = 17867,
  [19510] = 17842,
  [19511] = 17840,
  [19512] = 17867,
  [19513] = 17866,
  [19514] = 17869,
  [19515] = 17863,
  [19516] = 17886,
  [19517] = 17861,
  [19518] = 17857,
  [19519] = 17847,
  [19520] = 17909,
  [19521] = 17847,
  [19522] = 17859,
  [19523] = 17857,
  [19524] = 17891,
  [19525] = 18150,
  [19526] = 17905,
  [19527] = 17869,
  [19528] = 17867,
  [19529] = 15868,
  [19530] = 17841,
  [19531] = 17842,
  [19532] = 17866,
  [19533] = 17840,
  [19534] = 17840,
  [19535] = 17866,
  [19536] = 16948,
  [19537] = 17842,
  [19538] = 17841,
  [19539] = 17857,
  [19540] = 17855,
  [19541] = 17847,
  [19542] = 17867,
  [19543] = 17847,
  [19544] = 17869,
  [19545] = 17857,
  [19546] = 16558,
  [19547] = 17869,
  [19548] = 17867,
  [19549] = 17841,
  [19550] = 17842,
  [19551] = 17847,
  [19552] = 17841,
  [19553] = 17857,
  [19554] = 17840,
  [19555] = 17842,
  [19556] = 17866,
  [19557] = 17858,
  [19558] = 17857,
  [19559] = 16576,
  [19560] = 17847,
  [19561] = 17860,
  [19562] = 17866,
  [19563] = 17840,
  [19564] = 17850,
  [19565] = 16868,
  [19566] = 16866,
  [19567] = 17842,
  [19568] = 17841,
  [19569] = 17869,
  [19570] = 17867,
  [19571] = 17841,
  [19572] = 17867,
  [19573] = 17842,
  [19574] = 17869,
  [19575] = 17840,
  [19576] = 19576,
  [19577] = 17866,
  [19578] = 17895,
  [19579] = 17857,
  [19580] = 17877,
  [19581] = 17847,
  [19582] = 17846,
  [19583] = 17857,
  [19584] = 17847,
  [19585] = 17703,
  [19586] = 17869,
  [19587] = 17867,
  [19588] = 17841,
  [19589] = 17842,
  [19590] = 17840,
  [19591] = 17866,
  [19592] = 17866,
  [19593] = 17840,
  [19594] = 17866,
  [19595] = 17857,
  [19596] = 17847,
  [19597] = 17842,
  [19598] = 17841,
  [19599] = 17840,
  [19600] = 17858,
  [19601] = 17871,
  [19602] = 17867,
  [19603] = 17869,
  [19604] = 17869,
  [19605] = 17867,
  [19606] = 17891,
  [19607] = 19607,
  [19608] = 17871,
  [19609] = 19609,
  [19610] = 17841,
  [19611] = 17847,
  [19612] = 17840,
  [19613] = 17857,
  [19614] = 17842,
  [19615] = 17840,
  [19616] = 17866,
  [19617] = 17866,
  [19618] = 17877,
  [19619] = 17895,
  [19620] = 17857,
  [19621] = 17847,
  [19622] = 17866,
  [19623] = 17840,
  [19624] = 17842,
  [19625] = 17841,
  [19626] = 17869,
  [19627] = 17842,
  [19628] = 17841,
  [19629] = 17867,
  [19630] = 17841,
  [19631] = 17842,
  [19632] = 17867,
  [19633] = 17840,
  [19634] = 17869,
  [19635] = 17866,
  [19636] = 17855,
  [19637] = 17857,
  [19638] = 17905,
  [19639] = 17847,
  [19640] = 17859,
  [19641] = 17847,
  [19642] = 17909,
  [19643] = 17857,
  [19644] = 17861,
  [19645] = 17869,
  [19646] = 17846,
  [19647] = 17867,
  [19648] = 17841,
  [19649] = 17842,
  [19650] = 17840,
  [19651] = 17866,
  [19652] = 17866,
  [19653] = 17840,
  [19654] = 17863,
  [19655] = 17857,
  [19656] = 17847,
  [19657] = 17842,
  [19658] = 17841,
  [19659] = 17867,
  [19660] = 17970,
  [19661] = 17869,
  [19662] = 17867,
  [19663] = 17869,
  [19664] = 17869,
  [19665] = 17867,
  [19666] = 17841,
  [19667] = 17842,
  [19668] = 17840,
  [19669] = 17960,
  [19670] = 17866,
  [19671] = 17847,
  [19672] = 17972,
  [19673] = 17857,
  [19674] = 19674,
  [19675] = 15358,
  [19676] = 17857,
  [19677] = 17882,
  [19678] = 17847,
  [19679] = 17945,
  [19680] = 17886,
  [19681] = 17869,
  [19682] = 17866,
  [19683] = 17840,
  [19684] = 17867,
  [19685] = 17841,
  [19686] = 17842,
  [19687] = 17842,
  [19688] = 17841,
  [19689] = 17840,
  [19690] = 17866,
  [19691] = 17975,
  [19692] = 17867,
  [19693] = 17857,
  [19694] = 17869,
  [19695] = 17850,
  [19696] = 17847,
  [19697] = 18137,
  [19698] = 16608,
  [19699] = 17847,
  [19700] = 17977,
  [19701] = 17847,
  [19702] = 17860,
  [19703] = 17857,
  [19704] = 17869,
  [19705] = 17867,
  [19706] = 17857,
  [19707] = 17841,
  [19708] = 17842,
  [19709] = 17840,
  [19710] = 17866,
  [19711] = 17857,
  [19712] = 17866,
  [19713] = 17840,
  [19714] = 17847,
  [19715] = 17858,
  [19716] = 17860,
  [19717] = 17842,
  [19718] = 17841,
  [19719] = 17869,
  [19720] = 17867,
  [19721] = 14878,
  [19722] = 17867,
  [19723] = 17841,
  [19724] = 17869,
  [19725] = 17842,
  [19726] = 19726,
  [19727] = 17840,
  [19728] = 17866,
  [19729] = 17850,
  [19730] = 16731,
  [19731] = 17847,
  [19732] = 16809,
  [19733] = 17857,
  [19734] = 16811,
  [19735] = 17857,
  [19736] = 17857,
  [19737] = 17847,
  [19738] = 17869,
  [19739] = 17867,
  [19740] = 17846,
  [19741] = 17841,
  [19742] = 17866,
  [19743] = 17840,
  [19744] = 17842,
  [19745] = 17840,
  [19746] = 17866,
  [19747] = 17842,
  [19748] = 17841,
  [19749] = 17991,
  [19750] = 17847,
  [19751] = 17857,
  [19752] = 17867,
  [19753] = 17847,
  [19754] = 17869,
  [19755] = 17952,
  [19756] = 17955,
  [19757] = 18136,
  [19758] = 17869,
  [19759] = 17867,
  [19760] = 17841,
  [19761] = 17847,
  [19762] = 17842,
  [19763] = 17857,
  [19764] = 17840,
  [19765] = 18058,
  [19766] = 17866,
  [19767] = 17866,
  [19768] = 17857,
  [19769] = 17840,
  [19770] = 17847,
  [19771] = 17871,
  [19772] = 17866,
  [19773] = 17840,
  [19774] = 17891,
  [19775] = 17869,
  [19776] = 17867,
  [19777] = 17842,
  [19778] = 17841,
  [19779] = 17877,
  [19780] = 15298,
  [19781] = 17841,
  [19782] = 17867,
  [19783] = 17842,
  [19784] = 17869,
  [19785] = 17840,
  [19786] = 17866,
  [19787] = 18121,
  [19788] = 17895,
  [19789] = 17857,
  [19790] = 17847,
  [19791] = 17847,
  [19792] = 17842,
  [19793] = 17857,
  [19794] = 17869,
  [19795] = 17867,
  [19796] = 17841,
  [19797] = 17841,
  [19798] = 17842,
  [19799] = 17840,
  [19800] = 17866,
  [19801] = 17857,
  [19802] = 17866,
  [19803] = 17840,
  [19804] = 17847,
  [19805] = 17855,
  [19806] = 17905,
  [19807] = 17842,
  [19808] = 17841,
  [19809] = 17859,
  [19810] = 16936,
  [19811] = 17909,
  [19812] = 17867,
  [19813] = 17869,
  [19814] = 17869,
  [19815] = 17867,
  [19816] = 17841,
  [19817] = 17842,
  [19818] = 17840,
  [19819] = 17866,
  [19820] = 17861,
  [19821] = 17847,
  [19822] = 17857,
  [19823] = 17857,
  [19824] = 17863,
  [19825] = 17847,
  [19826] = 17867,
  [19827] = 19827,
  [19828] = 17869,
  [19829] = 17867,
  [19830] = 17869,
  [19831] = 17841,
  [19832] = 17866,
  [19833] = 17840,
  [19834] = 17842,
  [19835] = 17840,
  [19836] = 17866,
  [19837] = 17842,
  [19838] = 17841,
  [19839] = 17857,
  [19840] = 17882,
  [19841] = 17847,
  [19842] = 17867,
  [19843] = 17992,
  [19844] = 17869,
  [19845] = 17886,
  [19846] = 17886,
  [19847] = 17869,
  [19848] = 17846,
  [19849] = 17945,
  [19850] = 17882,
  [19851] = 17847,
  [19852] = 17867,
  [19853] = 17857,
  [19854] = 17841,
  [19855] = 17842,
  [19856] = 17840,
  [19857] = 17866,
  [19858] = 17857,
  [19859] = 17847,
  [19860] = 16623,
  [19861] = 17445,
  [19862] = 17866,
  [19863] = 17840,
  [19864] = 15871,
  [19865] = 17869,
  [19866] = 17867,
  [19867] = 17842,
  [19868] = 17841,
  [19869] = 17847,
  [19870] = 17841,
  [19871] = 17842,
  [19872] = 17867,
  [19873] = 17840,
  [19874] = 17869,
  [19875] = 17869,
  [19876] = 17866,
  [19877] = 16157,
  [19878] = 17867,
  [19879] = 17857,
  [19880] = 17863,
  [19881] = 17847,
  [19882] = 17857,
  [19883] = 17857,
  [19884] = 17861,
  [19885] = 19885,
  [19886] = 17847,
  [19887] = 17858,
  [19888] = 17996,
  [19889] = 15951,
  [19890] = 17869,
  [19891] = 17867,
  [19892] = 17866,
  [19893] = 17840,
  [19894] = 17860,
  [19895] = 17841,
  [19896] = 17842,
  [19897] = 17842,
  [19898] = 17841,
  [19899] = 17840,
  [19900] = 17909,
  [19901] = 17866,
  [19902] = 17867,
  [19903] = 17850,
  [19904] = 17869,
  [19905] = 17859,
  [19906] = 17905,
  [19907] = 17855,
  [19908] = 17857,
  [19909] = 17400,
  [19910] = 17847,
  [19911] = 17847,
  [19912] = 14267,
  [19913] = 17857,
  [19914] = 17869,
  [19915] = 17841,
  [19916] = 17842,
  [19917] = 17867,
  [19918] = 17846,
  [19919] = 17841,
  [19920] = 17842,
  [19921] = 17840,
  [19922] = 17866,
  [19923] = 17840,
  [19924] = 17866,
  [19925] = 17857,
  [19926] = 17847,
  [19927] = 17842,
  [19928] = 17841,
  [19929] = 17866,
  [19930] = 17869,
  [19931] = 17867,
  [19932] = 17867,
  [19933] = 17945,
  [19934] = 17869,
  [19935] = 17841,
  [19936] = 17842,
  [19937] = 17840,
  [19938] = 17866,
  [19939] = 17895,
  [19940] = 17877,
  [19941] = 17847,
  [19942] = 17891,
  [19943] = 17857,
  [19944] = 19944,
  [19945] = 17871,
  [19946] = 17871,
  [19947] = 17857,
  [19948] = 17840,
  [19949] = 17847,
  [19950] = 15868,
  [19951] = 17956,
  [19952] = 17866,
  [19953] = 17840,
  [19954] = 17877,
  [19955] = 17895,
  [19956] = 17869,
  [19957] = 17842,
  [19958] = 17841,
  [19959] = 17867,
  [19960] = 17840,
  [19961] = 17841,
  [19962] = 17867,
  [19963] = 17842,
  [19964] = 17869,
  [19965] = 17840,
  [19966] = 17866,
  [19967] = 18094,
  [19968] = 17866,
  [19969] = 17857,
  [19970] = 17842,
  [19971] = 17847,
  [19972] = 17847,
  [19973] = 17857,
  [19974] = 17841,
  [19975] = 18089,
  [19976] = 17090,
  [19977] = 18632,
  [19978] = 17869,
  [19979] = 17867,
  [19980] = 17855,
  [19981] = 17841,
  [19982] = 17866,
  [19983] = 17840,
  [19984] = 17842,
  [19985] = 17840,
  [19986] = 17866,
  [19987] = 17842,
  [19988] = 17841,
  [19989] = 17905,
  [19990] = 19990,
  [19991] = 17857,
  [19992] = 17867,
  [19993] = 17859,
  [19994] = 17869,
  [19995] = 17847,
  [19996] = 17909,
  [19997] = 18020,
  [19998] = 17861,
  [19999] = 17869,
  [20000] = 8482,
  [20001] = 17847,
  [20002] = 17850,
  [20003] = 17857,
  [20004] = 18085,
  [20005] = 17860,
  [20006] = 17867,
  [20007] = 17863,
  [20008] = 17841,
  [20009] = 17842,
  [20010] = 17840,
  [20011] = 17866,
  [20012] = 17840,
  [20013] = 17866,
  [20014] = 17198,
  [20015] = 17857,
  [20016] = 17842,
  [20017] = 17841,
  [20018] = 17325,
  [20019] = 17858,
  [20020] = 17847,
  [20021] = 17867,
  [20022] = 17867,
  [20023] = 17869,
  [20024] = 18560,
  [20025] = 17869,
  [20026] = 17869,
  [20027] = 17867,
  [20028] = 17882,
  [20029] = 17847,
  [20030] = 10510,
  [20031] = 17857,
  [20032] = 18537,
  [20033] = 17857,
  [20034] = 17841,
  [20035] = 17842,
  [20036] = 17840,
  [20037] = 17866,
  [20038] = 17945,
  [20039] = 17866,
  [20040] = 17957,
  [20041] = 17857,
  [20042] = 17886,
  [20043] = 17847,
  [20044] = 17842,
  [20045] = 17841,
  [20046] = 18027,
  [20047] = 17847,
  [20048] = 17891,
  [20049] = 17867,
  [20050] = 17869,
  [20051] = 17869,
  [20052] = 20052,
  [20053] = 17867,
  [20054] = 17081,
  [20055] = 17841,
  [20056] = 17842,
  [20057] = 17847,
  [20058] = 14878,
  [20059] = 17857,
  [20060] = 17840,
  [20061] = 17882,
  [20062] = 17866,
  [20063] = 10492,
  [20064] = 17857,
  [20065] = 17847,
  [20066] = 16576,
  [20067] = 17866,
  [20068] = 17840,
  [20069] = 17847,
  [20070] = 18019,
  [20071] = 17869,
  [20072] = 17842,
  [20073] = 17841,
  [20074] = 17867,
  [20075] = 17841,
  [20076] = 17842,
  [20077] = 17867,
  [20078] = 17840,
  [20079] = 17869,
  [20080] = 17866,
  [20081] = 17857,
  [20082] = 18048,
  [20083] = 17857,
  [20084] = 17847,
  [20085] = 17847,
  [20086] = 20086,
  [20087] = 17857,
  [20088] = 20088,
  [20089] = 17886,
  [20090] = 17869,
  [20091] = 17867,
  [20092] = 17841,
  [20093] = 17842,
  [20094] = 17840,
  [20095] = 17866,
  [20096] = 17840,
  [20097] = 17866,
  [20098] = 17858,
  [20099] = 17857,
  [20100] = 17842,
  [20101] = 17841,
  [20102] = 17847,
  [20103] = 17945,
  [20104] = 17250,
  [20105] = 17867,
  [20106] = 20106,
  [20107] = 17869,
  [20108] = 17850,
  [20109] = 18075,
  [20110] = 20110,
  [20111] = 17869,
  [20112] = 17869,
  [20113] = 17847,
  [20114] = 17867,
  [20115] = 17857,
  [20116] = 17841,
  [20117] = 17867,
  [20118] = 17842,
  [20119] = 17840,
  [20120] = 17866,
  [20121] = 17857,
  [20122] = 17846,
  [20123] = 17866,
  [20124] = 17840,
  [20125] = 17847,
  [20126] = 17197,
  [20127] = 17869,
  [20128] = 17842,
  [20129] = 17841,
  [20130] = 17867,
  [20131] = 17860,
  [20132] = 17841,
  [20133] = 17867,
  [20134] = 17842,
  [20135] = 17869,
  [20136] = 20136,
  [20137] = 17863,
  [20138] = 17840,
  [20139] = 17861,
  [20140] = 17866,
  [20141] = 17847,
  [20142] = 17909,
  [20143] = 17857,
  [20144] = 17400,
  [20145] = 17859,
  [20146] = 17866,
  [20147] = 17857,
  [20148] = 17847,
  [20149] = 17840,
  [20150] = 17871,
  [20151] = 17866,
  [20152] = 17840,
  [20153] = 17891,
  [20154] = 17869,
  [20155] = 17867,
  [20156] = 17842,
  [20157] = 17841,
  [20158] = 17877,
  [20159] = 16608,
  [20160] = 17841,
  [20161] = 17867,
  [20162] = 17842,
  [20163] = 17869,
  [20164] = 17905,
  [20165] = 20165,
  [20166] = 17855,
  [20167] = 17840,
  [20168] = 17866,
  [20169] = 17847,
  [20170] = 17841,
  [20171] = 17857,
  [20172] = 17895,
  [20173] = 17842,
  [20174] = 17857,
  [20175] = 17847,
  [20176] = 20176,
  [20177] = 20177,
  [20178] = 18034,
  [20179] = 17866,
  [20180] = 17840,
  [20181] = 17869,
  [20182] = 17867,
  [20183] = 17841,
  [20184] = 17842,
  [20185] = 18094,
  [20186] = 3775,
  [20187] = 3761,
  [20188] = 20188,
  [20189] = 20189,
  [20190] = 3762,
  [20191] = 20191,
  [20192] = 20192,
  [20193] = 3760,
  [20194] = 3769,
  [20195] = 3772,
  [20196] = 3779,
  [20197] = 3780,
  [20198] = 3782,
  [20199] = 20199,
  [20200] = 20200,
  [20201] = 20201,
  [20202] = 20199,
  [20203] = 3774,
  [20204] = 3815,
  [20205] = 3789,
  [20206] = 20192,
  [20207] = 3791,
  [20208] = 20189,
  [20209] = 3794,
  [20210] = 3796,
  [20211] = 3767,
  [20212] = 3744,
  [20213] = 20188,
  [20214] = 3783,
  [20215] = 3754,
  [20216] = 20188,
  [20217] = 3765,
  [20218] = 3764,
  [20219] = 3757,
  [20220] = 3781,
  [20221] = 20221,
  [20222] = 20192,
  [20223] = 3778,
  [20224] = 3751,
  [20225] = 3750,
  [20226] = 3749,
  [20227] = 3747,
  [20228] = 20199,
  [20229] = 20192,
  [20230] = 20199,
  [20231] = 3770,
  [20232] = 3746,
  [20233] = 3758,
  [20234] = 20192,
  [20235] = 20188,
  [20236] = 3806,
  [20237] = 20237,
  [20238] = 20238,
  [20239] = 20192,
  [20240] = 20188,
  [20241] = 20188,
  [20242] = 20242,
  [20243] = 20242,
  [20244] = 20188,
  [20245] = 20242,
  [20246] = 20242,
  [20247] = 20242,
  [20248] = 20242,
  [20249] = 20249,
  [20250] = 20242,
  [20251] = 20191,
  [20252] = 20252,
  [20253] = 20242,
  [20254] = 20192,
  [20255] = 20199,
  [20256] = 20242,
  [20257] = 20242,
  [20258] = 20199,
  [20259] = 20242,
  [20260] = 20260,
  [20261] = 20242,
  [20262] = 20192,
  [20263] = 20242,
  [20264] = 20242,
  [20265] = 20242,
  [20266] = 20242,
  [20267] = 20237,
  [20268] = 20199,
  [20269] = 20269,
  [20270] = 20242,
  [20271] = 20199,
  [20272] = 20188,
  [20273] = 20273,
  [20274] = 20242,
  [20275] = 20275,
  [20276] = 20242,
  [20277] = 20242,
  [20278] = 20242,
  [20279] = 20242,
  [20280] = 20188,
  [20281] = 20242,
  [20282] = 17294,
  [20283] = 20242,
  [20284] = 20284,
  [20285] = 20191,
  [20286] = 20199,
  [20287] = 20242,
  [20288] = 20284,
  [20289] = 20242,
  [20290] = 20192,
  [20291] = 20284,
  [20292] = 20192,
  [20293] = 20242,
  [20294] = 20284,
  [20295] = 20295,
  [20296] = 20242,
  [20297] = 20284,
  [20298] = 20242,
  [20299] = 20284,
  [20300] = 20188,
  [20301] = 20301,
  [20302] = 20242,
  [20303] = 20199,
  [20304] = 20238,
  [20305] = 20284,
  [20306] = 10706,
  [20307] = 20242,
  [20308] = 18049,
  [20309] = 20284,
  [20310] = 18047,
  [20311] = 20311,
  [20312] = 20242,
  [20313] = 20284,
  [20314] = 20199,
  [20315] = 20242,
  [20316] = 20284,
  [20317] = 20242,
  [20318] = 20192,
  [20319] = 20284,
  [20320] = 20242,
  [20321] = 20284,
  [20322] = 20242,
  [20323] = 20284,
  [20324] = 20188,
  [20325] = 19349,
  [20326] = 20242,
  [20327] = 20237,
  [20328] = 20188,
  [20329] = 20284,
  [20330] = 20242,
  [20331] = 20284,
  [20332] = 20242,
  [20333] = 20284,
  [20334] = 20242,
  [20335] = 20284,
  [20336] = 20192,
  [20337] = 20242,
  [20338] = 20284,
  [20339] = 20339,
  [20340] = 20242,
  [20341] = 20284,
  [20342] = 20199,
  [20343] = 20339,
  [20344] = 20238,
  [20345] = 20242,
  [20346] = 20192,
  [20347] = 20199,
  [20348] = 20348,
  [20349] = 20284,
  [20350] = 20350,
  [20351] = 20339,
  [20352] = 17192,
  [20353] = 20242,
  [20354] = 20284,
  [20355] = 20260,
  [20356] = 20188,
  [20357] = 20357,
  [20358] = 20350,
  [20359] = 20359,
  [20360] = 20188,
  [20361] = 20339,
  [20362] = 20311,
  [20363] = 20189,
  [20364] = 20242,
  [20365] = 20284,
  [20366] = 20260,
  [20367] = 20367,
  [20368] = 20237,
  [20369] = 20192,
  [20370] = 20199,
  [20371] = 20371,
  [20372] = 20192,
  [20373] = 20188,
  [20374] = 20192,
  [20375] = 20375,
  [20376] = 20188,
  [20377] = 20189,
  [20378] = 20199,
  [20379] = 20275,
  [20380] = 20191,
  [20381] = 20199,
  [20382] = 20192,
  [20383] = 20192,
  [20384] = 20188,
  [20385] = 20238,
  [20386] = 20311,
  [20387] = 20269,
  [20388] = 20191,
  [20389] = 20275,
  [20390] = 20199,
  [20391] = 20189,
  [20392] = 20284,
  [20393] = 20188,
  [20394] = 20188,
  [20395] = 20395,
  [20396] = 20237,
  [20397] = 20238,
  [20398] = 20199,
  [20399] = 20188,
  [20400] = 20110,
  [20401] = 20252,
  [20402] = 20192,
  [20403] = 20199,
  [20404] = 20192,
  [20405] = 20189,
  [20406] = 20252,
  [20407] = 20191,
  [20408] = 20192,
  [20409] = 20192,
  [20410] = 20199,
  [20411] = 20189,
  [20412] = 20188,
  [20413] = 20199,
  [20414] = 20371,
  [20415] = 20191,
  [20416] = 20088,
  [20417] = 20199,
  [20418] = 20188,
  [20419] = 20199,
  [20420] = 20199,
  [20421] = 20191,
  [20422] = 20375,
  [20423] = 20188,
  [20424] = 20188,
  [20425] = 20192,
  [20426] = 20199,
  [20427] = 20136,
  [20428] = 20191,
  [20429] = 18512,
  [20430] = 20192,
  [20431] = 20275,
  [20432] = 20432,
  [20433] = 17192,
  [20434] = 20189,
  [20435] = 20311,
  [20436] = 20436,
  [20437] = 20192,
  [20438] = 20188,
  [20439] = 20367,
  [20440] = 20188,
  [20441] = 20273,
  [20442] = 20367,
  [20443] = 20273,
  [20444] = 20199,
  [20445] = 20445,
  [20446] = 20189,
  [20447] = 20192,
  [20448] = 20191,
  [20449] = 20188,
  [20450] = 20367,
  [20451] = 20273,
  [20452] = 20189,
  [20453] = 18439,
  [20454] = 20199,
  [20455] = 20237,
  [20456] = 20367,
  [20457] = 20273,
  [20458] = 20192,
  [20459] = 20192,
  [20460] = 20238,
  [20461] = 18431,
  [20462] = 20367,
  [20463] = 20242,
  [20464] = 20273,
  [20465] = 20188,
  [20466] = 20199,
  [20467] = 20191,
  [20468] = 20188,
  [20469] = 20367,
  [20470] = 20273,
  [20471] = 20192,
  [20472] = 20192,
  [20473] = 20367,
  [20474] = 20191,
  [20475] = 20192,
  [20476] = 20273,
  [20477] = 19459,
  [20478] = 10698,
  [20479] = 20199,
  [20480] = 20199,
  [20481] = 20367,
  [20482] = 20199,
  [20483] = 19423,
  [20484] = 20273,
  [20485] = 19293,
  [20486] = 20192,
  [20487] = 19412,
  [20488] = 20189,
  [20489] = 20367,
  [20490] = 20273,
  [20491] = 20491,
  [20492] = 20199,
  [20493] = 20367,
  [20494] = 20273,
  [20495] = 20375,
  [20496] = 20188,
  [20497] = 20188,
  [20498] = 20188,
  [20499] = 20191,
  [20500] = 20367,
  [20501] = 20273,
  [20502] = 20192,
  [20503] = 20350,
  [20504] = 20192,
  [20505] = 20275,
  [20506] = 19364,
  [20507] = 20367,
  [20508] = 20273,
  [20509] = 20191,
  [20510] = 20199,
  [20511] = 19315,
  [20512] = 20311,
  [20513] = 20367,
  [20514] = 20192,
  [20515] = 20273,
  [20516] = 20192,
  [20517] = 20367,
  [20518] = 20273,
  [20519] = 20237,
  [20520] = 19312,
  [20521] = 20238,
  [20522] = 20367,
  [20523] = 20189,
  [20524] = 20188,
  [20525] = 20199,
  [20526] = 20273,
  [20527] = 20188,
  [20528] = 20188,
  [20529] = 20199,
  [20530] = 20199,
  [20531] = 9122,
  [20532] = 20191,
  [20533] = 18517,
  [20534] = 20534,
  [20535] = 20189,
  [20536] = 9125,
  [20537] = 20367,
  [20538] = 20199,
  [20539] = 20273,
  [20540] = 20192,
  [20541] = 20541,
  [20542] = 20192,
  [20543] = 20188,
  [20544] = 19302,
  [20545] = 20189,
  [20546] = 20367,
  [20547] = 16100,
  [20548] = 20273,
  [20549] = 20549,
  [20550] = 20367,
  [20551] = 20273,
  [20552] = 20188,
  [20553] = 20192,
  [20554] = 18988,
  [20555] = 19241,
  [20556] = 19237,
  [20557] = 20367,
  [20558] = 20199,
  [20559] = 20192,
  [20560] = 20238,
  [20561] = 20188,
  [20562] = 20273,
  [20563] = 20189,
  [20564] = 20237,
  [20565] = 20375,
  [20566] = 20199,
  [20567] = 20367,
  [20568] = 20188,
  [20569] = 20273,
  [20570] = 20192,
  [20571] = 20571,
  [20572] = 20191,
  [20573] = 20199,
  [20574] = 20367,
  [20575] = 20275,
  [20576] = 20188,
  [20577] = 18536,
  [20578] = 20273,
  [20579] = 19089,
  [20580] = 20188,
  [20581] = 15980,
  [20582] = 20367,
  [20583] = 20189,
  [20584] = 20273,
  [20585] = 20192,
  [20586] = 20311,
  [20587] = 20367,
  [20588] = 20273,
  [20589] = 20189,
  [20590] = 20237,
  [20591] = 19006,
  [20592] = 20199,
  [20593] = 20311,
  [20594] = 20199,
  [20595] = 20367,
  [20596] = 20273,
  [20597] = 20191,
  [20598] = 20192,
  [20599] = 20199,
  [20600] = 20275,
  [20601] = 20199,
  [20602] = 20192,
  [20603] = 20191,
  [20604] = 18588,
  [20605] = 20367,
  [20606] = 20273,
  [20607] = 20192,
  [20608] = 20188,
  [20609] = 19005,
  [20610] = 20367,
  [20611] = 18528,
  [20612] = 20273,
  [20613] = 20359,
  [20614] = 18529,
  [20615] = 20371,
  [20616] = 20188,
  [20617] = 20188,
  [20618] = 18958,
  [20619] = 20367,
  [20620] = 20273,
  [20621] = 20275,
  [20622] = 20199,
  [20623] = 20549,
  [20624] = 20189,
  [20625] = 20188,
  [20626] = 20192,
  [20627] = 18956,
  [20628] = 20189,
  [20629] = 20188,
  [20630] = 20238,
  [20631] = 20367,
  [20632] = 20273,
  [20633] = 20192,
  [20634] = 20189,
  [20635] = 20375,
  [20636] = 20188,
  [20637] = 20188,
  [20638] = 18936,
  [20639] = 20367,
  [20640] = 20273,
  [20641] = 20199,
  [20642] = 20275,
  [20643] = 18519,
  [20644] = 20192,
  [20645] = 20367,
  [20646] = 20273,
  [20647] = 20311,
  [20648] = 20311,
  [20649] = 20237,
  [20650] = 20199,
  [20651] = 20238,
  [20652] = 20367,
  [20653] = 20273,
  [20654] = 20192,
  [20655] = 20191,
  [20656] = 20199,
  [20657] = 20491,
  [20658] = 20199,
  [20659] = 20191,
  [20660] = 17445,
  [20661] = 18503,
  [20662] = 20367,
  [20663] = 20192,
  [20664] = 20188,
  [20665] = 20665,
  [20666] = 20273,
  [20667] = 18882,
  [20668] = 20188,
  [20669] = 20192,
  [20670] = 18799,
  [20671] = 20671,
  [20672] = 18793,
  [20673] = 20673,
  [20674] = 20189,
  [20675] = 20192,
  [20676] = 20676,
  [20677] = 15766,
  [20678] = 20199,
  [20679] = 20367,
  [20680] = 20199,
  [20681] = 20273,
  [20682] = 20192,
  [20683] = 18748,
  [20684] = 20191,
  [20685] = 20192,
  [20686] = 20367,
  [20687] = 20273,
  [20688] = 20189,
  [20689] = 20199,
  [20690] = 20690,
  [20691] = 18489,
  [20692] = 20188,
  [20693] = 20375,
  [20694] = 20188,
  [20695] = 18486,
  [20696] = 18485,
  [20697] = 20697,
  [20698] = 20367,
  [20699] = 20273,
  [20700] = 20189,
  [20701] = 18483,
  [20702] = 20702,
  [20703] = 18530,
  [20704] = 20188,
  [20705] = 18468,
  [20706] = 20199,
  [20707] = 20275,
  [20708] = 20367,
  [20709] = 20709,
  [20710] = 20192,
  [20711] = 18467,
  [20712] = 18453,
  [20713] = 20273,
  [20714] = 20311,
  [20715] = 20715,
  [20716] = 20188,
  [20717] = 20188,
  [20718] = 20189,
  [20719] = 20367,
  [20720] = 20188,
  [20721] = 20375,
  [20722] = 20273,
  [20723] = 20237,
  [20724] = 20724,
  [20725] = 20238,
  [20726] = 18648,
  [20727] = 20192,
  [20728] = 18647,
  [20729] = 20729,
  [20730] = 20188,
  [20731] = 20367,
  [20732] = 20191,
  [20733] = 20199,
  [20734] = 20199,
  [20735] = 20273,
  [20736] = 20736,
  [20737] = 20192,
  [20738] = 20192,
  [20739] = 18451,
  [20740] = 18442,
  [20741] = 18639,
  [20742] = 20192,
  [20743] = 20367,
  [20744] = 18364,
  [20745] = 18432,
  [20746] = 20273,
  [20747] = 20191,
  [20748] = 20188,
  [20749] = 18428,
  [20750] = 20750,
  [20751] = 18426,
  [20752] = 20189,
  [20753] = 20753,
  [20754] = 20199,
  [20755] = 18411,
  [20756] = 20756,
  [20757] = 20367,
  [20758] = 20273,
  [20759] = 20188,
  [20760] = 20199,
  [20761] = 20191,
  [20762] = 20199,
  [20763] = 18599,
  [20764] = 20191,
  [20765] = 20375,
  [20766] = 20192,
  [20767] = 20188,
  [20768] = 20768,
  [20769] = 20192,
  [20770] = 18590,
  [20771] = 20275,
  [20772] = 20367,
  [20773] = 20192,
  [20774] = 20273,
  [20775] = 17878,
  [20776] = 20188,
  [20777] = 16623,
  [20778] = 20189,
  [20779] = 20779,
  [20780] = 20780,
  [20781] = 20188,
  [20782] = 20199,
  [20783] = 20783,
  [20784] = 20199,
  [20785] = 20199,
  [20786] = 17192,
  [20787] = 20237,
  [20788] = 20238,
  [20789] = 20789,
  [20790] = 20199,
  [20791] = 20311,
  [20792] = 20237,
  [20793] = 20367,
  [20794] = 20192,
  [20795] = 18404,
  [20796] = 20273,
  [20797] = 20238,
  [20798] = 20188,
  [20799] = 20189,
  [20800] = 20199,
  [20801] = 20191,
  [20802] = 20192,
  [20803] = 20188,
  [20804] = 20188,
  [20805] = 18527,
  [20806] = 20367,
  [20807] = 20273,
  [20808] = 20808,
  [20809] = 20192,
  [20810] = 20810,
  [20811] = 20191,
  [20812] = 17983,
  [20813] = 20189,
  [20814] = 20238,
  [20815] = 20192,
  [20816] = 20199,
  [20817] = 10772,
  [20818] = 20199,
  [20819] = 20199,
  [20820] = 20191,
  [20821] = 20375,
  [20822] = 20192,
  [20823] = 20188,
  [20824] = 20192,
  [20825] = 17987,
  [20826] = 17994,
  [20827] = 20275,
  [20828] = 20828,
  [20829] = 20199,
  [20830] = 20367,
  [20831] = 18400,
  [20832] = 20188,
  [20833] = 20273,
  [20834] = 20311,
  [20835] = 20835,
  [20836] = 20237,
  [20837] = 18398,
  [20838] = 20838,
  [20839] = 18394,
  [20840] = 18022,
  [20841] = 20841,
  [20842] = 20842,
  [20843] = 20843,
  [20844] = 20188,
  [20845] = 20189,
  [20846] = 20199,
  [20847] = 20237,
  [20848] = 17081,
  [20849] = 20238,
  [20850] = 20192,
  [20851] = 18392,
  [20852] = 20188,
  [20853] = 20199,
  [20854] = 16731,
  [20855] = 20810,
  [20856] = 17090,
  [20857] = 20191,
  [20858] = 20192,
  [20859] = 18190,
  [20860] = 20188,
  [20861] = 20690,
  [20862] = 20188,
  [20863] = 20192,
  [20864] = 20311,
  [20865] = 20865,
  [20866] = 20189,
  [20867] = 20275,
  [20868] = 20189,
  [20869] = 20375,
  [20870] = 20199,
  [20871] = 18391,
  [20872] = 15871,
  [20873] = 20367,
  [20874] = 20199,
  [20875] = 18206,
  [20876] = 20273,
  [20877] = 20188,
  [20878] = 20192,
  [20879] = 18382,
  [20880] = 20192,
  [20881] = 20881,
  [20882] = 20275,
  [20883] = 20199,
  [20884] = 20191,
  [20885] = 20199,
  [20886] = 20886,
  [20887] = 20275,
  [20888] = 20188,
  [20889] = 20311,
  [20890] = 20188,
  [20891] = 20192,
  [20892] = 20188,
  [20893] = 20810,
  [20894] = 20192,
  [20895] = 20199,
  [20896] = 20191,
  [20897] = 20237,
  [20898] = 20238,
  [20899] = 18232,
  [20900] = 20900,
  [20901] = 20901,
  [20902] = 20199,
  [20903] = 20188,
  [20904] = 20189,
  [20905] = 20199,
  [20906] = 20192,
  [20907] = 20192,
  [20908] = 20199,
  [20909] = 20192,
  [20910] = 20199,
  [20911] = 20911,
  [20912] = 20188,
  [20913] = 20913,
  [20914] = 20199,
  [20915] = 20915,
  [20916] = 20188,
  [20917] = 20199,
  [20918] = 20188,
  [20919] = 20919,
  [20920] = 20311,
  [20921] = 18369,
  [20922] = 20188,
  [20923] = 18367,
  [20924] = 18366,
  [20925] = 20191,
  [20926] = 20192,
  [20927] = 20927,
  [20928] = 20199,
  [20929] = 20189,
  [20930] = 20199,
  [20931] = 18244,
  [20932] = 20191,
  [20933] = 20549,
  [20934] = 20192,
  [20935] = 20935,
  [20936] = 20936,
  [20937] = 20937,
  [20938] = 20938,
  [20939] = 20188,
  [20940] = 20188,
  [20941] = 20192,
  [20942] = 20192,
  [20943] = 18231,
  [20944] = 20188,
  [20945] = 18228,
  [20946] = 18222,
  [20947] = 20192,
  [20948] = 20199,
  [20949] = 18208,
  [20950] = 20950,
  [20951] = 20951,
  [20952] = 18204,
  [20953] = 20192,
  [20954] = 20188,
  [20955] = 18198,
  [20956] = 17294,
  [20957] = 18189,
  [20958] = 20199,
  [20959] = 20192,
  [20960] = 20199,
  [20961] = 20188,
  [20962] = 20192,
  [20963] = 20199,
  [20964] = 20189,
  [20965] = 17197,
  [20966] = 20188,
  [20967] = 20189,
  [20968] = 20968,
  [20969] = 20199,
  [20970] = 20192,
  [20971] = 20199,
  [20972] = 20188,
  [20973] = 18356,
  [20974] = 20191,
  [20975] = 20192,
  [20976] = 10715,
  [20977] = 20977,
  [20978] = 20188,
  [20979] = 20375,
  [20980] = 20980,
  [20981] = 20188,
  [20982] = 20188,
  [20983] = 20192,
  [20984] = 20199,
  [20985] = 20192,
  [20986] = 20199,
  [20987] = 20189,
  [20988] = 20188,
  [20989] = 20192,
  [20990] = 20192,
  [20991] = 20192,
  [20992] = 20188,
  [20993] = 20191,
  [20994] = 20192,
  [20995] = 20199,
  [20996] = 20199,
  [20997] = 20275,
  [20998] = 17250,
  [20999] = 18049,
  [21000] = 20188,
  [21001] = 20199,
  [21002] = 18047,
  [21003] = 18478,
  [21004] = 20188,
  [21005] = 10743,
  [21006] = 16866,
  [21007] = 21007,
  [21008] = 20191,
  [21009] = 16868,
  [21010] = 18349,
  [21011] = 21011,
  [21012] = 18023,
  [21013] = 20192,
  [21014] = 20199,
  [21015] = 20199,
  [21016] = 20311,
  [21017] = 21017,
  [21018] = 20192,
  [21019] = 20188,
  [21020] = 20237,
  [21021] = 21021,
  [21022] = 17995,
  [21023] = 20311,
  [21024] = 20192,
  [21025] = 20188,
  [21026] = 20199,
  [21027] = 20199,
  [21028] = 20188,
  [21029] = 20191,
  [21030] = 20238,
  [21031] = 17984,
  [21032] = 20275,
  [21033] = 21033,
  [21034] = 15743,
  [21035] = 20188,
  [21036] = 20192,
  [21037] = 20199,
  [21038] = 20188,
  [21039] = 20192,
  [21040] = 20199,
  [21041] = 20199,
  [21042] = 20199,
  [21043] = 20191,
  [21044] = 20192,
  [21045] = 20191,
  [21046] = 20192,
  [21047] = 20188,
  [21048] = 21048,
  [21049] = 20189,
  [21050] = 20192,
  [21051] = 20199,
  [21052] = 17953,
  [21053] = 17941,
  [21054] = 20192,
  [21055] = 20189,
  [21056] = 20188,
  [21057] = 18347,
  [21058] = 17935,
  [21059] = 18309,
  [21060] = 20238,
  [21061] = 20189,
  [21062] = 20237,
  [21063] = 20188,
  [21064] = 10741,
  [21065] = 20188,
  [21066] = 20188,
  [21067] = 21067,
  [21068] = 20192,
  [21069] = 20199,
  [21070] = 20199,
  [21071] = 21071,
  [21072] = 17934,
  [21073] = 20192,
  [21074] = 20192,
  [21075] = 20188,
  [21076] = 17849,
  [21077] = 20192,
  [21078] = 20199,
  [21079] = 20189,
  [21080] = 20192,
  [21081] = 20199,
  [21082] = 17928,
  [21083] = 17920,
  [21084] = 20188,
  [21085] = 20375,
  [21086] = 17917,
  [21087] = 20199,
  [21088] = 20188,
  [21089] = 17914,
  [21090] = 20238,
  [21091] = 20192,
  [21092] = 20311,
  [21093] = 20199,
  [21094] = 20188,
  [21095] = 20188,
  [21096] = 20237,
  [21097] = 17874,
  [21098] = 20199,
  [21099] = 17925,
  [21100] = 17865,
  [21101] = 17851,
  [21102] = 20192,
  [21103] = 21103,
  [21104] = 20188,
  [21105] = 20188,
  [21106] = 20199,
  [21107] = 20192,
  [21108] = 20199,
  [21109] = 20311,
  [21110] = 21110,
  [21111] = 20275,
  [21112] = 20188,
  [21113] = 21113,
  [21114] = 21114,
  [21115] = 20199,
  [21116] = 21116,
  [21117] = 20191,
  [21118] = 20275,
  [21119] = 20192,
  [21120] = 20188,
  [21121] = 20192,
  [21122] = 20192,
  [21123] = 20199,
  [21124] = 21124,
  [21125] = 20199,
  [21126] = 20199,
  [21127] = 17899,
  [21128] = 20311,
  [21129] = 21129,
  [21130] = 20192,
  [21131] = 9122,
  [21132] = 20275,
  [21133] = 20188,
  [21134] = 17873,
  [21135] = 20192,
  [21136] = 18279,
  [21137] = 20199,
  [21138] = 9125,
  [21139] = 16608,
  [21140] = 20188,
  [21141] = 18274,
  [21142] = 16576,
  [21143] = 18272,
  [21144] = 21144,
  [21145] = 20188,
  [21146] = 20188,
  [21147] = 21147,
  [21148] = 20237,
  [21149] = 20275,
  [21150] = 20189,
  [21151] = 17325,
  [21152] = 21152,
  [21153] = 20188,
  [21154] = 20199,
  [21155] = 20238,
  [21156] = 17880,
  [21157] = 20188,
  [21158] = 20192,
  [21159] = 20192,
  [21160] = 20192,
  [21161] = 20199,
  [21162] = 21162,
  [21163] = 20199,
  [21164] = 20188,
  [21165] = 20188,
  [21166] = 17198,
  [21167] = 20199,
  [21168] = 20188,
  [21169] = 20189,
  [21170] = 16948,
  [21171] = 20192,
  [21172] = 20311,
  [21173] = 21173,
  [21174] = 20189,
  [21175] = 20199,
  [21176] = 21176,
  [21177] = 18268,
  [21178] = 18009,
  [21179] = 20188,
  [21180] = 20192,
  [21181] = 18267,
  [21182] = 20199,
  [21183] = 20192,
  [21184] = 20199,
  [21185] = 17911,
  [21186] = 20192,
  [21187] = 20192,
  [21188] = 16157,
  [21189] = 20191,
  [21190] = 17915,
  [21191] = 20188,
  [21192] = 18240,
  [21193] = 18234,
  [21194] = 20199,
  [21195] = 20192,
  [21196] = 20188,
  [21197] = 18350,
  [21198] = 20199,
  [21199] = 18230,
  [21200] = 21200,
  [21201] = 17970,
  [21202] = 17972,
  [21203] = 20191,
  [21204] = 20199,
  [21205] = 20191,
  [21206] = 18167,
  [21207] = 20237,
  [21208] = 20188,
  [21209] = 20238,
  [21210] = 20199,
  [21211] = 20189,
  [21212] = 20192,
  [21213] = 20192,
  [21214] = 20192,
  [21215] = 20199,
  [21216] = 20238,
  [21217] = 17975,
  [21218] = 20375,
  [21219] = 17977,
  [21220] = 18150,
  [21221] = 18137,
  [21222] = 17991,
  [21223] = 18136,
  [21224] = 20188,
  [21225] = 18058,
  [21226] = 20188,
  [21227] = 20188,
  [21228] = 21228,
  [21229] = 20199,
  [21230] = 21230,
  [21231] = 21231,
  [21232] = 20237,
  [21233] = 20192,
  [21234] = 20199,
  [21235] = 18121,
  [21236] = 20191,
  [21237] = 20192,
  [21238] = 20199,
  [21239] = 20189,
  [21240] = 17992,
  [21241] = 17996,
  [21242] = 20192,
  [21243] = 20188,
  [21244] = 21244,
  [21245] = 20188,
  [21246] = 18019,
  [21247] = 18020,
  [21248] = 20192,
  [21249] = 20199,
  [21250] = 20275,
  [21251] = 20311,
  [21252] = 20188,
  [21253] = 20188,
  [21254] = 20395,
  [21255] = 21255,
  [21256] = 18027,
  [21257] = 20188,
  [21258] = 18034,
  [21259] = 20191,
  [21260] = 20192,
  [21261] = 20275,
  [21262] = 18048,
  [21263] = 18270,
  [21264] = 20339,
  [21265] = 20192,
  [21266] = 20199,
  [21267] = 20199,
  [21268] = 20110,
  [21269] = 20311,
  [21270] = 20192,
  [21271] = 21271,
  [21272] = 18089,
  [21273] = 20237,
  [21274] = 20192,
  [21275] = 20199,
  [21276] = 18085,
  [21277] = 18075,
  [21278] = 20189,
  [21279] = 20199,
  [21280] = 20188,
  [21281] = 21281,
  [21282] = 17192,
  [21283] = 15951,
  [21284] = 20192,
  [21285] = 20199,
  [21286] = 20192,
  [21287] = 20238,
  [21288] = 20188,
  [21289] = 15868,
  [21290] = 20191,
  [21291] = 17400,
  [21292] = 20188,
  [21293] = 20188,
  [21294] = 20199,
  [21295] = 21295,
  [21296] = 21296,
  [21297] = 21297,
  [21298] = 21295,
  [21299] = 21299,
  [21300] = 21295,
  [21301] = 21297,
  [21302] = 21302,
  [21303] = 21303,
  [21304] = 21304,
  [21305] = 21305,
  [21306] = 21303,
  [21307] = 21307,
  [21308] = 21296,
  [21309] = 21309,
  [21310] = 21297,
  [21311] = 21311,
  [21312] = 21312,
  [21313] = 21309,
  [21314] = 21296,
  [21315] = 21307,
  [21316] = 21316,
  [21317] = 21297,
  [21318] = 21295,
  [21319] = 21299,
  [21320] = 21295,
  [21321] = 21299,
  [21322] = 21302,
  [21323] = 21304,
  [21324] = 21312,
  [21325] = 21302,
  [21326] = 21326,
  [21327] = 21309,
  [21328] = 21296,
  [21329] = 21307,
  [21330] = 21297,
  [21331] = 21295,
  [21332] = 21299,
  [21333] = 21333,
  [21334] = 21334,
  [21335] = 21302,
  [21336] = 21336,
  [21337] = 21337,
  [21338] = 21304,
  [21339] = 21339,
  [21340] = 21336,
  [21341] = 21341,
  [21342] = 21342,
  [21343] = 21337,
  [21344] = 21302,
  [21345] = 21341,
  [21346] = 21346,
  [21347] = 21304,
  [21348] = 21307,
  [21349] = 21349,
  [21350] = 21296,
  [21351] = 21309,
  [21352] = 21296,
  [21353] = 21307,
  [21354] = 21309,
  [21355] = 21311,
  [21356] = 21356,
  [21357] = 21297,
  [21358] = 21295,
  [21359] = 21299,
  [21360] = 21346,
  [21361] = 21361,
  [21362] = 21302,
  [21363] = 21363,
  [21364] = 21309,
  [21365] = 21349,
  [21366] = 21304,
  [21367] = 21307,
  [21368] = 21368,
  [21369] = 21369,
  [21370] = 21296,
  [21371] = 21349,
  [21372] = 21346,
  [21373] = 21304,
  [21374] = 21363,
  [21375] = 21342,
  [21376] = 21363,
  [21377] = 21307,
  [21378] = 21302,
  [21379] = 21309,
  [21380] = 21296,
  [21381] = 21307,
  [21382] = 21309,
  [21383] = 21341,
  [21384] = 21336,
  [21385] = 21297,
  [21386] = 21295,
  [21387] = 21299,
  [21388] = 21339,
  [21389] = 21299,
  [21390] = 21302,
  [21391] = 21299,
  [21392] = 21295,
  [21393] = 21326,
  [21394] = 21304,
  [21395] = 21304,
  [21396] = 21339,
  [21397] = 21297,
  [21398] = 21304,
  [21399] = 21337,
  [21400] = 21339,
  [21401] = 21304,
  [21402] = 21309,
  [21403] = 21307,
  [21404] = 21337,
  [21405] = 21296,
  [21406] = 21309,
  [21407] = 21309,
  [21408] = 21296,
  [21409] = 21307,
  [21410] = 21361,
  [21411] = 21356,
  [21412] = 21311,
  [21413] = 21297,
  [21414] = 21295,
  [21415] = 21299,
  [21416] = 21333,
  [21417] = 21417,
  [21418] = 21302,
  [21419] = 21363,
  [21420] = 21305,
  [21421] = 21304,
  [21422] = 21304,
  [21423] = 21302,
  [21424] = 21424,
  [21425] = 21299,
  [21426] = 21302,
  [21427] = 21299,
  [21428] = 21295,
  [21429] = 21297,
  [21430] = 21295,
  [21431] = 21303,
  [21432] = 21432,
  [21433] = 21297,
  [21434] = 21349,
  [21435] = 21309,
  [21436] = 21296,
  [21437] = 21307,
  [21438] = 21312,
  [21439] = 21307,
  [21440] = 21307,
  [21441] = 21297,
  [21442] = 21295,
  [21443] = 21299,
  [21444] = 21296,
  [21445] = 21309,
  [21446] = 21302,
  [21447] = 21296,
  [21448] = 21336,
  [21449] = 21346,
  [21450] = 21304,
  [21451] = 21451,
  [21452] = 21302,
  [21453] = 21311,
  [21454] = 21341,
  [21455] = 21336,
  [21456] = 21295,
  [21457] = 21303,
  [21458] = 21297,
  [21459] = 21297,
  [21460] = 21303,
  [21461] = 21312,
  [21462] = 21295,
  [21463] = 21309,
  [21464] = 21296,
  [21465] = 21307,
  [21466] = 21304,
  [21467] = 21467,
  [21468] = 21305,
  [21469] = 21297,
  [21470] = 21295,
  [21471] = 21299,
  [21472] = 21299,
  [21473] = 21311,
  [21474] = 21302,
  [21475] = 21356,
  [21476] = 21302,
  [21477] = 21299,
  [21478] = 21304,
  [21479] = 21295,
  [21480] = 21309,
  [21481] = 21481,
  [21482] = 21296,
  [21483] = 21307,
  [21484] = 21333,
  [21485] = 21297,
  [21486] = 21361,
  [21487] = 21333,
  [21488] = 21361,
  [21489] = 21326,
  [21490] = 21307,
  [21491] = 21309,
  [21492] = 21296,
  [21493] = 21307,
  [21494] = 21296,
  [21495] = 21336,
  [21496] = 21341,
  [21497] = 21297,
  [21498] = 21295,
  [21499] = 21299,
  [21500] = 21312,
  [21501] = 21303,
  [21502] = 21302,
  [21503] = 21309,
  [21504] = 21504,
  [21505] = 21297,
  [21506] = 21304,
  [21507] = 21295,
  [21508] = 21346,
  [21509] = 21307,
  [21510] = 21296,
  [21511] = 21309,
  [21512] = 21363,
  [21513] = 21299,
  [21514] = 21302,
  [21515] = 21299,
  [21516] = 21341,
  [21517] = 21356,
  [21518] = 21302,
  [21519] = 21309,
  [21520] = 21296,
  [21521] = 21307,
  [21522] = 21342,
  [21523] = 21349,
  [21524] = 21346,
  [21525] = 21297,
  [21526] = 21295,
  [21527] = 21299,
  [21528] = 21304,
  [21529] = 21349,
  [21530] = 21302,
  [21531] = 21311,
  [21532] = 21302,
  [21533] = 21363,
  [21534] = 21304,
  [21535] = 21309,
  [21536] = 21296,
  [21537] = 21537,
  [21538] = 21305,
  [21539] = 21337,
  [21540] = 21339,
  [21541] = 21304,
  [21542] = 21299,
  [21543] = 21543,
  [21544] = 21339,
  [21545] = 21312,
  [21546] = 21295,
  [21547] = 21309,
  [21548] = 21296,
  [21549] = 21307,
  [21550] = 21297,
  [21551] = 21337,
  [21552] = 21307,
  [21553] = 21297,
  [21554] = 21295,
  [21555] = 21299,
  [21556] = 21307,
  [21557] = 21304,
  [21558] = 21302,
  [21559] = 21296,
  [21560] = 21309,
  [21561] = 21297,
  [21562] = 21304,
  [21563] = 21295,
  [21564] = 21299,
  [21565] = 21363,
  [21566] = 21302,
  [21567] = 21567,
  [21568] = 21304,
  [21569] = 21363,
  [21570] = 21304,
  [21571] = 21302,
  [21572] = 21572,
  [21573] = 21296,
  [21574] = 21302,
  [21575] = 21309,
  [21576] = 21296,
  [21577] = 21307,
  [21578] = 21363,
  [21579] = 21299,
  [21580] = 21295,
  [21581] = 21297,
  [21582] = 21295,
  [21583] = 21299,
  [21584] = 21297,
  [21585] = 21299,
  [21586] = 21302,
  [21587] = 21326,
  [21588] = 21295,
  [21589] = 21303,
  [21590] = 21304,
  [21591] = 21591,
  [21592] = 21297,
  [21593] = 21336,
  [21594] = 21341,
  [21595] = 21349,
  [21596] = 21342,
  [21597] = 21597,
  [21598] = 21307,
  [21599] = 21296,
  [21600] = 21309,
  [21601] = 21346,
  [21602] = 21339,
  [21603] = 21309,
  [21604] = 21296,
  [21605] = 21307,
  [21606] = 21309,
  [21607] = 21296,
  [21608] = 21307,
  [21609] = 21297,
  [21610] = 21295,
  [21611] = 21299,
  [21612] = 21296,
  [21613] = 21309,
  [21614] = 21302,
  [21615] = 21349,
  [21616] = 21307,
  [21617] = 21304,
  [21618] = 21304,
  [21619] = 21346,
  [21620] = 21363,
  [21621] = 21621,
  [21622] = 21311,
  [21623] = 21297,
  [21624] = 21295,
  [21625] = 21304,
  [21626] = 21299,
  [21627] = 21302,
  [21628] = 21302,
  [21629] = 21304,
  [21630] = 21304,
  [21631] = 21309,
  [21632] = 21296,
  [21633] = 21307,
  [21634] = 21339,
  [21635] = 21342,
  [21636] = 21636,
  [21637] = 21297,
  [21638] = 21295,
  [21639] = 21299,
  [21640] = 21312,
  [21641] = 21341,
  [21642] = 21302,
  [21643] = 21302,
  [21644] = 21295,
  [21645] = 21336,
  [21646] = 21304,
  [21647] = 21326,
  [21648] = 21297,
  [21649] = 21304,
  [21650] = 21339,
  [21651] = 21651,
  [21652] = 21307,
  [21653] = 21296,
  [21654] = 21337,
  [21655] = 21309,
  [21656] = 21337,
  [21657] = 21349,
  [21658] = 21346,
  [21659] = 21309,
  [21660] = 21296,
  [21661] = 21307,
  [21662] = 21662,
  [21663] = 21342,
  [21664] = 21312,
  [21665] = 21297,
  [21666] = 21295,
  [21667] = 21299,
  [21668] = 21341,
  [21669] = 21336,
  [21670] = 21302,
  [21671] = 21424,
  [21672] = 21349,
  [21673] = 21341,
  [21674] = 21304,
  [21675] = 21336,
  [21676] = 21304,
  [21677] = 21309,
  [21678] = 21296,
  [21679] = 21305,
  [21680] = 21296,
  [21681] = 21346,
  [21682] = 21307,
  [21683] = 21311,
  [21684] = 21684,
  [21685] = 21302,
  [21686] = 21299,
  [21687] = 21309,
  [21688] = 21296,
  [21689] = 21307,
  [21690] = 21295,
  [21691] = 21356,
  [21692] = 21297,
  [21693] = 21297,
  [21694] = 21295,
  [21695] = 21299,
  [21696] = 21349,
  [21697] = 21309,
  [21698] = 21302,
  [21699] = 21296,
  [21700] = 21297,
  [21701] = 21307,
  [21702] = 21304,
  [21703] = 21295,
  [21704] = 21361,
  [21705] = 21299,
  [21706] = 21295,
  [21707] = 21363,
  [21708] = 21297,
  [21709] = 21333,
  [21710] = 21303,
  [21711] = 21307,
  [21712] = 21296,
  [21713] = 21303,
  [21714] = 21309,
  [21715] = 21309,
  [21716] = 21296,
  [21717] = 21307,
  [21718] = 21326,
  [21719] = 21304,
  [21720] = 21297,
  [21721] = 21297,
  [21722] = 21295,
  [21723] = 21299,
  [21724] = 21299,
  [21725] = 21339,
  [21726] = 21302,
  [21727] = 21337,
  [21728] = 21302,
  [21729] = 21337,
  [21730] = 21304,
  [21731] = 21295,
  [21732] = 21299,
  [21733] = 21333,
  [21734] = 21304,
  [21735] = 21361,
  [21736] = 21304,
  [21737] = 21302,
  [21738] = 21312,
  [21739] = 21302,
  [21740] = 21740,
  [21741] = 21307,
  [21742] = 21302,
  [21743] = 21309,
  [21744] = 21296,
  [21745] = 21307,
  [21746] = 21299,
  [21747] = 21295,
  [21748] = 21302,
  [21749] = 21297,
  [21750] = 21295,
  [21751] = 21299,
  [21752] = 21297,
  [21753] = 21299,
  [21754] = 21302,
  [21755] = 21296,
  [21756] = 16186,
  [21757] = 21295,
  [21758] = 21304,
  [21759] = 21297,
  [21760] = 21303,
  [21761] = 21309,
  [21762] = 21299,
  [21763] = 21307,
  [21764] = 21356,
  [21765] = 21307,
  [21766] = 21311,
  [21767] = 21296,
  [21768] = 21309,
  [21769] = 21295,
  [21770] = 21309,
  [21771] = 21309,
  [21772] = 21296,
  [21773] = 21307,
  [21774] = 21346,
  [21775] = 21309,
  [21776] = 21311,
  [21777] = 21297,
  [21778] = 21295,
  [21779] = 21299,
  [21780] = 21296,
  [21781] = 21337,
  [21782] = 21302,
  [21783] = 21305,
  [21784] = 21307,
  [21785] = 21339,
  [21786] = 21304,
  [21787] = 21297,
  [21788] = 21312,
  [21789] = 21295,
  [21790] = 21304,
  [21791] = 21299,
  [21792] = 21363,
  [21793] = 21305,
  [21794] = 21312,
  [21795] = 21349,
  [21796] = 21302,
  [21797] = 21304,
  [21798] = 21295,
  [21799] = 21309,
  [21800] = 21296,
  [21801] = 21307,
  [21802] = 21302,
  [21803] = 21304,
  [21804] = 21342,
  [21805] = 21297,
  [21806] = 21299,
  [21807] = 21299,
  [21808] = 21299,
  [21809] = 21295,
  [21810] = 21302,
  [21811] = 21297,
  [21812] = 21297,
  [21813] = 21341,
  [21814] = 21304,
  [21815] = 21336,
  [21816] = 21424,
  [21817] = 21326,
  [21818] = 21336,
  [21819] = 21303,
  [21820] = 21341,
  [21821] = 21336,
  [21822] = 21342,
  [21823] = 21341,
  [21824] = 21307,
  [21825] = 21346,
  [21826] = 21296,
  [21827] = 21309,
  [21828] = 21296,
  [21829] = 21307,
  [21830] = 21309,
  [21831] = 21326,
  [21832] = 21311,
  [21833] = 21297,
  [21834] = 21295,
  [21835] = 21299,
  [21836] = 21356,
  [21837] = 21837,
  [21838] = 21302,
  [21839] = 21349,
  [21840] = 21309,
  [21841] = 21346,
  [21842] = 21304,
  [21843] = 21843,
  [21844] = 21304,
  [21845] = 21312,
  [21846] = 21349,
  [21847] = 21346,
  [21848] = 21363,
  [21849] = 21307,
  [21850] = 21302,
  [21851] = 21309,
  [21852] = 21363,
  [21853] = 21311,
  [21854] = 21296,
  [21855] = 21309,
  [21856] = 21296,
  [21857] = 21307,
  [21858] = 21299,
  [21859] = 21356,
  [21860] = 21295,
  [21861] = 21297,
  [21862] = 21295,
  [21863] = 21299,
  [21864] = 21309,
  [21865] = 21296,
  [21866] = 21302,
  [21867] = 21304,
  [21868] = 21297,
  [21869] = 21307,
  [21870] = 21304,
  [21871] = 21307,
  [21872] = 21304,
  [21873] = 21873,
  [21874] = 21339,
  [21875] = 21337,
  [21876] = 21339,
  [21877] = 21307,
  [21878] = 21361,
  [21879] = 21333,
  [21880] = 21337,
  [21881] = 21296,
  [21882] = 21309,
  [21883] = 21309,
  [21884] = 21296,
  [21885] = 21307,
  [21886] = 21297,
  [21887] = 21302,
  [21888] = 21299,
  [21889] = 21297,
  [21890] = 21295,
  [21891] = 21299,
  [21892] = 21295,
  [21893] = 21297,
  [21894] = 21302,
  [21895] = 21303,
  [21896] = 21361,
  [21897] = 21303,
  [21898] = 21304,
  [21899] = 21303,
  [21900] = 21299,
  [21901] = 21302,
  [21902] = 21297,
  [21903] = 21333,
  [21904] = 21307,
  [21905] = 21296,
  [21906] = 21309,
  [21907] = 21304,
  [21908] = 15785,
  [21909] = 21295,
  [21910] = 21304,
  [21911] = 21309,
  [21912] = 21296,
  [21913] = 21307,
  [21914] = 21914,
  [21915] = 21299,
  [21916] = 21311,
  [21917] = 21297,
  [21918] = 21295,
  [21919] = 21299,
  [21920] = 21302,
  [21921] = 21302,
  [21922] = 21302,
  [21923] = 21333,
  [21924] = 21299,
  [21925] = 21295,
  [21926] = 21304,
  [21927] = 21297,
  [21928] = 21302,
  [21929] = 21312,
  [21930] = 21930,
  [21931] = 21299,
  [21932] = 21295,
  [21933] = 21361,
  [21934] = 21297,
  [21935] = 21337,
  [21936] = 21339,
  [21937] = 21303,
  [21938] = 21307,
  [21939] = 21309,
  [21940] = 21296,
  [21941] = 21307,
  [21942] = 21296,
  [21943] = 21304,
  [21944] = 21309,
  [21945] = 21297,
  [21946] = 21295,
  [21947] = 21299,
  [21948] = 21309,
  [21949] = 21296,
  [21950] = 21302,
  [21951] = 21336,
  [21952] = 21307,
  [21953] = 21341,
  [21954] = 21304,
  [21955] = 21299,
  [21956] = 21297,
  [21957] = 21349,
  [21958] = 21346,
  [21959] = 21341,
  [21960] = 21333,
  [21961] = 21346,
  [21962] = 21336,
  [21963] = 21295,
  [21964] = 21361,
  [21965] = 21299,
  [21966] = 21297,
  [21967] = 21309,
  [21968] = 21296,
  [21969] = 21307,
  [21970] = 21295,
  [21971] = 21299,
  [21972] = 21304,
  [21973] = 21297,
  [21974] = 21295,
  [21975] = 21299,
  [21976] = 21349,
  [21977] = 21302,
  [21978] = 21302,
  [21979] = 21302,
  [21980] = 21302,
  [21981] = 21299,
  [21982] = 21304,
  [21983] = 21295,
  [21984] = 21297,
  [21985] = 21304,
  [21986] = 21307,
  [21987] = 21296,
  [21988] = 21309,
  [21989] = 21307,
  [21990] = 21307,
  [21991] = 21296,
  [21992] = 21992,
  [21993] = 21363,
  [21994] = 21309,
  [21995] = 21309,
  [21996] = 21296,
  [21997] = 21307,
  [21998] = 21296,
  [21999] = 21312,
  [22000] = 22000,
  [22001] = 21297,
  [22002] = 21295,
  [22003] = 21299,
  [22004] = 21363,
  [22005] = 21309,
  [22006] = 21302,
  [22007] = 21356,
  [22008] = 22008,
  [22009] = 21304,
  [22010] = 21304,
  [22011] = 21304,
  [22012] = 21311,
  [22013] = 22013,
  [22014] = 21337,
  [22015] = 21305,
  [22016] = 21302,
  [22017] = 21339,
  [22018] = 21312,
  [22019] = 21337,
  [22020] = 21309,
  [22021] = 21296,
  [22022] = 21295,
  [22023] = 21309,
  [22024] = 21296,
  [22025] = 21307,
  [22026] = 21295,
  [22027] = 21297,
  [22028] = 21311,
  [22029] = 21297,
  [22030] = 21295,
  [22031] = 21299,
  [22032] = 21356,
  [22033] = 21307,
  [22034] = 21302,
  [22035] = 21307,
  [22036] = 21296,
  [22037] = 21309,
  [22038] = 21304,
  [22039] = 21297,
  [22040] = 21342,
  [22041] = 21295,
  [22042] = 21302,
  [22043] = 21299,
  [22044] = 21339,
  [22045] = 21295,
  [22046] = 21297,
  [22047] = 21299,
  [22048] = 21302,
  [22049] = 21309,
  [22050] = 21296,
  [22051] = 21307,
  [22052] = 21356,
  [22053] = 21303,
  [22054] = 21309,
  [22055] = 21297,
  [22056] = 21295,
  [22057] = 21299,
  [22058] = 21296,
  [22059] = 21304,
  [22060] = 21302,
  [22061] = 21326,
  [22062] = 21304,
  [22063] = 21307,
  [22064] = 21304,
  [22065] = 21296,
  [22066] = 21336,
  [22067] = 21341,
  [22068] = 21342,
  [22069] = 21304,
  [22070] = 21311,
  [22071] = 21346,
  [22072] = 21309,
  [22073] = 21349,
  [22074] = 21302,
  [22075] = 20673,
  [22076] = 21307,
  [22077] = 21311,
  [22078] = 22078,
  [22079] = 21363,
  [22080] = 21299,
  [22081] = 21295,
  [22082] = 21304,
  [22083] = 21297,
  [22084] = 21339,
  [22085] = 21361,
  [22086] = 21333,
  [22087] = 21337,
  [22088] = 21312,
  [22089] = 21305,
  [22090] = 22090,
  [22091] = 21307,
  [22092] = 21424,
  [22093] = 22093,
  [22094] = 21296,
  [22095] = 21309,
  [22096] = 21296,
  [22097] = 21303,
  [22098] = 21297,
  [22099] = 21295,
  [22100] = 21299,
  [22101] = 21309,
  [22102] = 21302,
  [22103] = 21305,
  [22104] = 21302,
  [22105] = 21296,
  [22106] = 21299,
  [22107] = 21295,
  [22108] = 21297,
  [22109] = 21303,
  [22110] = 21307,
  [22111] = 21349,
  [22112] = 8453,
  [22113] = 22113,
  [22114] = 21336,
  [22115] = 21341,
  [22116] = 21363,
  [22117] = 21333,
  [22118] = 21337,
  [22119] = 21346,
  [22120] = 21361,
  [22121] = 22121,
  [22122] = 22122,
  [22123] = 21304,
  [22124] = 21297,
  [22125] = 21304,
  [22126] = 21342,
  [22127] = 21307,
  [22128] = 21349,
  [22129] = 22129,
  [22130] = 21296,
  [22131] = 21309,
  [22132] = 21363,
  [22133] = 21302,
  [22134] = 21349,
  [22135] = 21295,
  [22136] = 21299,
  [22137] = 21363,
  [22138] = 22138,
  [22139] = 22139,
  [22140] = 21346,
  [22141] = 21341,
  [22142] = 22142,
  [22143] = 21740,
  [22144] = 21356,
  [22145] = 21567,
  [22146] = 21336,
  [22147] = 21311,
  [22148] = 3777,
  [22149] = 21299,
  [22150] = 22150,
  [22151] = 21295,
  [22152] = 22129,
  [22153] = 21339,
  [22154] = 21304,
  [22155] = 21339,
  [22156] = 21337,
  [22157] = 21297,
  [22158] = 21312,
  [22159] = 21302,
  [22160] = 21307,
  [22161] = 21296,
  [22162] = 21312,
  [22163] = 21309,
  [22164] = 22164,
  [22165] = 21341,
  [22166] = 21326,
  [22167] = 21336,
  [22168] = 22168,
  [22169] = 21341,
  [22170] = 22170,
  [22171] = 21304,
  [22172] = 21336,
  [22173] = 21326,
  [22174] = 21302,
  [22175] = 21342,
  [22176] = 22176,
  [22177] = 21299,
  [22178] = 21346,
  [22179] = 22090,
  [22180] = 21304,
  [22181] = 21295,
  [22182] = 22093,
  [22183] = 22183,
  [22184] = 22184,
  [22185] = 21349,
  [22186] = 21297,
  [22187] = 21303,
  [22188] = 21302,
  [22189] = 21363,
  [22190] = 21309,
  [22191] = 21299,
  [22192] = 21304,
  [22193] = 22193,
  [22194] = 21309,
  [22195] = 21339,
  [22196] = 21297,
  [22197] = 21337,
  [22198] = 21307,
  [22199] = 21296,
  [22200] = 21424,
  [22201] = 22113,
  [22202] = 21296,
  [22203] = 21307,
  [22204] = 21309,
  [22205] = 21307,
  [22206] = 21296,
  [22207] = 21311,
  [22208] = 21311,
  [22209] = 22121,
  [22210] = 22122,
  [22211] = 21309,
  [22212] = 20729,
  [22213] = 22213,
  [22214] = 21302,
  [22215] = 21356,
  [22216] = 22129,
  [22217] = 21312,
  [22218] = 21297,
  [22219] = 21312,
  [22220] = 21299,
  [22221] = 21309,
  [22222] = 22222,
  [22223] = 21296,
  [22224] = 22138,
  [22225] = 21307,
  [22226] = 21295,
  [22227] = 21567,
  [22228] = 21295,
  [22229] = 21297,
  [22230] = 21303,
  [22231] = 21361,
  [22232] = 21303,
  [22233] = 22233,
  [22234] = 21299,
  [22235] = 21336,
  [22236] = 22093,
  [22237] = 21302,
  [22238] = 21341,
  [22239] = 21333,
  [22240] = 21297,
  [22241] = 21361,
  [22242] = 21295,
  [22243] = 21304,
  [22244] = 21307,
  [22245] = 21296,
  [22246] = 21309,
  [22247] = 21302,
  [22248] = 22113,
  [22249] = 21299,
  [22250] = 21346,
  [22251] = 21356,
  [22252] = 21302,
  [22253] = 21311,
  [22254] = 21304,
  [22255] = 21305,
  [22256] = 21312,
  [22257] = 21349,
  [22258] = 22129,
  [22259] = 22259,
  [22260] = 21299,
  [22261] = 21337,
  [22262] = 21363,
  [22263] = 21339,
  [22264] = 21304,
  [22265] = 21363,
  [22266] = 21312,
  [22267] = 21295,
  [22268] = 21297,
  [22269] = 21304,
  [22270] = 22093,
  [22271] = 22271,
  [22272] = 21339,
  [22273] = 21307,
  [22274] = 21296,
  [22275] = 21326,
  [22276] = 21336,
  [22277] = 21337,
  [22278] = 21341,
  [22279] = 21342,
  [22280] = 21296,
  [22281] = 21346,
  [22282] = 22113,
  [22283] = 21305,
  [22284] = 21349,
  [22285] = 21349,
  [22286] = 21311,
  [22287] = 21356,
  [22288] = 21346,
  [22289] = 21309,
  [22290] = 21341,
  [22291] = 21304,
  [22292] = 21336,
  [22293] = 21304,
  [22294] = 21296,
  [22295] = 21302,
  [22296] = 3755,
  [22297] = 10637,
  [22298] = 21307,
  [22299] = 21299,
  [22300] = 22093,
  [22301] = 21302,
  [22302] = 21295,
  [22303] = 21363,
  [22304] = 21297,
  [22305] = 21297,
  [22306] = 21304,
  [22307] = 21312,
  [22308] = 21303,
  [22309] = 21339,
  [22310] = 21299,
  [22311] = 21337,
  [22312] = 21295,
  [22313] = 21307,
  [22314] = 21296,
  [22315] = 21297,
  [22316] = 21295,
  [22317] = 21424,
  [22318] = 21309,
  [22319] = 21299,
  [22320] = 21307,
  [22321] = 21296,
  [22322] = 21311,
  [22323] = 21309,
  [22324] = 21302,
  [22325] = 21339,
  [22326] = 22093,
  [22327] = 21309,
  [22328] = 21304,
  [22329] = 21296,
  [22330] = 21311,
  [22331] = 22331,
  [22332] = 21307,
  [22333] = 21302,
  [22334] = 21356,
  [22335] = 22335,
  [22336] = 21312,
  [22337] = 21299,
  [22338] = 21337,
  [22339] = 21295,
  [22340] = 21304,
  [22341] = 21297,
  [22342] = 21303,
  [22343] = 21309,
  [22344] = 21346,
  [22345] = 21296,
  [22346] = 22093,
  [22347] = 21302,
  [22348] = 21307,
  [22349] = 21299,
  [22350] = 21361,
  [22351] = 21295,
  [22352] = 21333,
  [22353] = 21303,
  [22354] = 21361,
  [22355] = 21297,
  [22356] = 21336,
  [22357] = 21297,
  [22358] = 21341,
  [22359] = 21307,
  [22360] = 21295,
  [22361] = 21307,
  [22362] = 21296,
  [22363] = 21309,
  [22364] = 21299,
  [22365] = 21309,
  [22366] = 22093,
  [22367] = 21361,
  [22368] = 21299,
  [22369] = 21356,
  [22370] = 21311,
  [22371] = 21309,
  [22372] = 21363,
  [22373] = 21305,
  [22374] = 21296,
  [22375] = 21346,
  [22376] = 21307,
  [22377] = 21333,
  [22378] = 21312,
  [22379] = 21297,
  [22380] = 22380,
  [22381] = 21349,
  [22382] = 22382,
  [22383] = 21424,
  [22384] = 21295,
  [22385] = 21304,
  [22386] = 22093,
  [22387] = 21299,
  [22388] = 21302,
  [22389] = 21302,
  [22390] = 21326,
  [22391] = 21336,
  [22392] = 21341,
  [22393] = 21363,
  [22394] = 21342,
  [22395] = 21304,
  [22396] = 21299,
  [22397] = 21346,
  [22398] = 21349,
  [22399] = 21337,
  [22400] = 21339,
  [22401] = 22401,
  [22402] = 21295,
  [22403] = 21297,
  [22404] = 22093,
  [22405] = 21307,
  [22406] = 22406,
  [22407] = 21304,
  [22408] = 21304,
  [22409] = 21339,
  [22410] = 21299,
  [22411] = 21337,
  [22412] = 21309,
  [22413] = 21304,
  [22414] = 22414,
  [22415] = 21363,
  [22416] = 21339,
  [22417] = 21303,
  [22418] = 21337,
  [22419] = 21297,
  [22420] = 21302,
  [22421] = 22093,
  [22422] = 21295,
  [22423] = 21302,
  [22424] = 21299,
  [22425] = 21297,
  [22426] = 21424,
  [22427] = 21304,
  [22428] = 21295,
  [22429] = 21297,
  [22430] = 21303,
  [22431] = 21326,
  [22432] = 21349,
  [22433] = 21346,
  [22434] = 21302,
  [22435] = 21302,
  [22436] = 21309,
  [22437] = 21346,
  [22438] = 22093,
  [22439] = 21299,
  [22440] = 21295,
  [22441] = 21307,
  [22442] = 21296,
  [22443] = 21299,
  [22444] = 21295,
  [22445] = 21297,
  [22446] = 21303,
  [22447] = 21309,
  [22448] = 21297,
  [22449] = 21341,
  [22450] = 21336,
  [22451] = 21296,
  [22452] = 21311,
  [22453] = 21307,
  [22454] = 21307,
  [22455] = 22093,
  [22456] = 21296,
  [22457] = 21309,
  [22458] = 21302,
  [22459] = 21333,
  [22460] = 21297,
  [22461] = 21312,
  [22462] = 21361,
  [22463] = 21295,
  [22464] = 21299,
  [22465] = 21307,
  [22466] = 21312,
  [22467] = 21296,
  [22468] = 21302,
  [22469] = 21304,
  [22470] = 21304,
  [22471] = 22093,
  [22472] = 21326,
  [22473] = 21309,
  [22474] = 21302,
  [22475] = 21299,
  [22476] = 21356,
  [22477] = 21295,
  [22478] = 21311,
  [22479] = 21297,
  [22480] = 21311,
  [22481] = 21305,
  [22482] = 21356,
  [22483] = 21336,
  [22484] = 21309,
  [22485] = 21341,
  [22486] = 21336,
  [22487] = 22093,
  [22488] = 21307,
  [22489] = 21312,
  [22490] = 21296,
  [22491] = 21341,
  [22492] = 21309,
  [22493] = 21296,
  [22494] = 21417,
  [22495] = 21326,
  [22496] = 21336,
  [22497] = 21341,
  [22498] = 21342,
  [22499] = 21342,
  [22500] = 22500,
  [22501] = 21337,
  [22502] = 22502,
  [22503] = 22093,
  [22504] = 21346,
  [22505] = 21307,
  [22506] = 21349,
  [22507] = 21504,
  [22508] = 22508,
  [22509] = 21361,
  [22510] = 21346,
  [22511] = 21349,
  [22512] = 21303,
  [22513] = 21363,
  [22514] = 21339,
  [22515] = 22193,
  [22516] = 21297,
  [22517] = 21304,
  [22518] = 21295,
  [22519] = 22093,
  [22520] = 15629,
  [22521] = 21299,
  [22522] = 21304,
  [22523] = 21363,
  [22524] = 21339,
  [22525] = 8345,
  [22526] = 21302,
  [22527] = 21337,
  [22528] = 21309,
  [22529] = 21304,
  [22530] = 21424,
  [22531] = 21296,
  [22532] = 21307,
  [22533] = 21302,
  [22534] = 21304,
  [22535] = 22093,
  [22536] = 21304,
  [22537] = 21299,
  [22538] = 21339,
  [22539] = 21337,
  [22540] = 22502,
  [22541] = 21295,
  [22542] = 22542,
  [22543] = 21297,
  [22544] = 21295,
  [22545] = 21299,
  [22546] = 21307,
  [22547] = 22547,
  [22548] = 21296,
  [22549] = 21309,
  [22550] = 21337,
  [22551] = 22093,
  [22552] = 21363,
  [22553] = 22553,
  [22554] = 21302,
  [22555] = 21339,
  [22556] = 21302,
  [22557] = 21299,
  [22558] = 21295,
  [22559] = 21349,
  [22560] = 21297,
  [22561] = 21303,
  [22562] = 22562,
  [22563] = 21304,
  [22564] = 22542,
  [22565] = 21304,
  [22566] = 22566,
  [22567] = 22093,
  [22568] = 21349,
  [22569] = 21302,
  [22570] = 21299,
  [22571] = 21295,
  [22572] = 21333,
  [22573] = 21297,
  [22574] = 21303,
  [22575] = 21304,
  [22576] = 21361,
  [22577] = 21363,
  [22578] = 21363,
  [22579] = 21307,
  [22580] = 22122,
  [22581] = 21346,
  [22582] = 21296,
  [22583] = 22093,
  [22584] = 21302,
  [22585] = 21309,
  [22586] = 22586,
  [22587] = 21299,
  [22588] = 21356,
  [22589] = 21311,
  [22590] = 21295,
  [22591] = 21305,
  [22592] = 21307,
  [22593] = 21296,
  [22594] = 21309,
  [22595] = 21297,
  [22596] = 22121,
  [22597] = 21307,
  [22598] = 21311,
  [22599] = 22093,
  [22600] = 21296,
  [22601] = 21312,
  [22602] = 21309,
  [22603] = 21342,
  [22604] = 22604,
  [22605] = 22605,
  [22606] = 21309,
  [22607] = 21349,
  [22608] = 21346,
  [22609] = 21341,
  [22610] = 21341,
  [22611] = 21417,
  [22612] = 21296,
  [22613] = 21334,
  [22614] = 22093,
  [22615] = 21336,
  [22616] = 21326,
  [22617] = 22617,
  [22618] = 21336,
  [22619] = 21341,
  [22620] = 21312,
  [22621] = 22621,
  [22622] = 21342,
  [22623] = 21326,
  [22624] = 21346,
  [22625] = 21307,
  [22626] = 21297,
  [22627] = 22093,
  [22628] = 21295,
  [22629] = 21349,
  [22630] = 21504,
  [22631] = 21336,
  [22632] = 21304,
  [22633] = 22633,
  [22634] = 21299,
  [22635] = 21312,
  [22636] = 21363,
  [22637] = 21684,
  [22638] = 21302,
  [22639] = 21302,
  [22640] = 22093,
  [22641] = 21299,
  [22642] = 22193,
  [22643] = 21295,
  [22644] = 21311,
  [22645] = 21304,
  [22646] = 21297,
  [22647] = 21339,
  [22648] = 21309,
  [22649] = 21337,
  [22650] = 21336,
  [22651] = 21339,
  [22652] = 21307,
  [22653] = 22093,
  [22654] = 21296,
  [22655] = 21424,
  [22656] = 21309,
  [22657] = 21341,
  [22658] = 21304,
  [22659] = 21296,
  [22660] = 21307,
  [22661] = 22500,
  [22662] = 22502,
  [22663] = 22542,
  [22664] = 21299,
  [22665] = 21337,
  [22666] = 22093,
  [22667] = 21312,
  [22668] = 21346,
  [22669] = 21309,
  [22670] = 22547,
  [22671] = 22553,
  [22672] = 21296,
  [22673] = 21302,
  [22674] = 21303,
  [22675] = 21349,
  [22676] = 21307,
  [22677] = 21304,
  [22678] = 21295,
  [22679] = 22093,
  [22680] = 21297,
  [22681] = 21299,
  [22682] = 21295,
  [22683] = 21297,
  [22684] = 21303,
  [22685] = 21299,
  [22686] = 21302,
  [22687] = 21363,
  [22688] = 21302,
  [22689] = 21333,
  [22690] = 21295,
  [22691] = 21299,
  [22692] = 22093,
  [22693] = 21299,
  [22694] = 21295,
  [22695] = 21304,
  [22696] = 21361,
  [22697] = 21297,
  [22698] = 21302,
  [22699] = 21307,
  [22700] = 21307,
  [22701] = 21296,
  [22702] = 21309,
  [22703] = 21296,
  [22704] = 21339,
  [22705] = 22093,
  [22706] = 21309,
  [22707] = 21304,
  [22708] = 21337,
  [22709] = 21356,
  [22710] = 21311,
  [22711] = 21305,
  [22712] = 21305,
  [22713] = 21311,
  [22714] = 21356,
  [22715] = 21337,
  [22716] = 21302,
  [22717] = 21304,
  [22718] = 22093,
  [22719] = 21309,
  [22720] = 21312,
  [22721] = 21302,
  [22722] = 21339,
  [22723] = 22604,
  [22724] = 21296,
  [22725] = 21307,
  [22726] = 22562,
  [22727] = 21304,
  [22728] = 21302,
  [22729] = 21299,
  [22730] = 21417,
  [22731] = 22093,
  [22732] = 21295,
  [22733] = 21334,
  [22734] = 21299,
  [22735] = 21326,
  [22736] = 22617,
  [22737] = 22547,
  [22738] = 21336,
  [22739] = 22739,
  [22740] = 21341,
  [22741] = 22621,
  [22742] = 21297,
  [22743] = 21342,
  [22744] = 22093,
  [22745] = 21297,
  [22746] = 22553,
  [22747] = 21307,
  [22748] = 21346,
  [22749] = 21349,
  [22750] = 21295,
  [22751] = 21504,
  [22752] = 21297,
  [22753] = 21296,
  [22754] = 21303,
  [22755] = 21309,
  [22756] = 21302,
  [22757] = 22093,
  [22758] = 21309,
  [22759] = 21295,
  [22760] = 21297,
  [22761] = 21363,
  [22762] = 21684,
  [22763] = 21296,
  [22764] = 22193,
  [22765] = 21299,
  [22766] = 21307,
  [22767] = 21296,
  [22768] = 21307,
  [22769] = 21304,
  [22770] = 22093,
  [22771] = 21302,
  [22772] = 21309,
  [22773] = 21339,
  [22774] = 21361,
  [22775] = 21337,
  [22776] = 21349,
  [22777] = 21299,
  [22778] = 21311,
  [22779] = 21424,
  [22780] = 21304,
  [22781] = 21304,
  [22782] = 21299,
  [22783] = 22093,
  [22784] = 21302,
  [22785] = 21295,
  [22786] = 21346,
  [22787] = 21341,
  [22788] = 21336,
  [22789] = 22500,
  [22790] = 22502,
  [22791] = 21295,
  [22792] = 21303,
  [22793] = 22542,
  [22794] = 21304,
  [22795] = 21297,
  [22796] = 22093,
  [22797] = 21295,
  [22798] = 21297,
  [22799] = 21336,
  [22800] = 22547,
  [22801] = 22553,
  [22802] = 21303,
  [22803] = 21302,
  [22804] = 21297,
  [22805] = 21303,
  [22806] = 21312,
  [22807] = 21307,
  [22808] = 21296,
  [22809] = 22093,
  [22810] = 21309,
  [22811] = 21312,
  [22812] = 21299,
  [22813] = 21295,
  [22814] = 21297,
  [22815] = 21930,
  [22816] = 21333,
  [22817] = 21311,
  [22818] = 21333,
  [22819] = 21309,
  [22820] = 21296,
  [22821] = 21307,
  [22822] = 22093,
  [22823] = 21297,
  [22824] = 21309,
  [22825] = 21333,
  [22826] = 21296,
  [22827] = 21361,
  [22828] = 21307,
  [22829] = 21295,
  [22830] = 21303,
  [22831] = 21307,
  [22832] = 21296,
  [22833] = 21299,
  [22834] = 21309,
  [22835] = 22093,
  [22836] = 21304,
  [22837] = 21302,
  [22838] = 21336,
  [22839] = 21356,
  [22840] = 21311,
  [22841] = 21341,
  [22842] = 21297,
  [22843] = 22843,
  [22844] = 21305,
  [22845] = 21303,
  [22846] = 21302,
  [22847] = 21304,
  [22848] = 22093,
  [22849] = 21299,
  [22850] = 22850,
  [22851] = 21346,
  [22852] = 21297,
  [22853] = 21295,
  [22854] = 21333,
  [22855] = 21312,
  [22856] = 21297,
  [22857] = 21295,
  [22858] = 21299,
  [22859] = 21361,
  [22860] = 21349,
  [22861] = 22093,
  [22862] = 21307,
  [22863] = 22604,
  [22864] = 21296,
  [22865] = 21309,
  [22866] = 21302,
  [22867] = 21363,
  [22868] = 21346,
  [22869] = 21295,
  [22870] = 21363,
  [22871] = 21451,
  [22872] = 21299,
  [22873] = 21361,
  [22874] = 22093,
  [22875] = 21307,
  [22876] = 21296,
  [22877] = 21417,
  [22878] = 21334,
  [22879] = 21368,
  [22880] = 21337,
  [22881] = 21339,
  [22882] = 21309,
  [22883] = 21304,
  [22884] = 21304,
  [22885] = 21302,
  [22886] = 21307,
  [22887] = 22093,
  [22888] = 21309,
  [22889] = 21296,
  [22890] = 21597,
  [22891] = 21662,
  [22892] = 21363,
  [22893] = 21309,
  [22894] = 21326,
  [22895] = 21339,
  [22896] = 22508,
  [22897] = 22617,
  [22898] = 21295,
  [22899] = 21336,
  [22900] = 22093,
  [22901] = 21296,
  [22902] = 21341,
  [22903] = 22903,
  [22904] = 22621,
  [22905] = 21337,
  [22906] = 21307,
  [22907] = 21302,
  [22908] = 21349,
  [22909] = 21346,
  [22910] = 21342,
  [22911] = 22093,
  [22912] = 21297,
  [22913] = 21299,
  [22914] = 22093,
  [22915] = 21341,
  [22916] = 21349,
  [22917] = 22093,
  [22918] = 21504,
  [22919] = 22113,
  [22920] = 22093,
  [22921] = 21299,
  [22922] = 21309,
  [22923] = 22093,
  [22924] = 21336,
  [22925] = 21297,
  [22926] = 22093,
  [22927] = 21302,
  [22928] = 21299,
  [22929] = 22093,
  [22930] = 21363,
  [22931] = 21684,
  [22932] = 22093,
  [22933] = 21295,
  [22934] = 21297,
  [22935] = 22093,
  [22936] = 21295,
  [22937] = 22129,
  [22938] = 22093,
  [22939] = 22193,
  [22940] = 22233,
  [22941] = 22093,
  [22942] = 21303,
  [22943] = 21299,
  [22944] = 22093,
  [22945] = 21304,
  [22946] = 21312,
  [22947] = 22093,
  [22948] = 21339,
  [22949] = 21307,
  [22950] = 22093,
  [22951] = 21296,
  [22952] = 21337,
  [22953] = 22093,
  [22954] = 21309,
  [22955] = 21302,
  [22956] = 22093,
  [22957] = 21424,
  [22958] = 21307,
  [22959] = 22093,
  [22960] = 21356,
  [22961] = 21296,
  [22962] = 22093,
  [22963] = 21309,
  [22964] = 21304,
  [22965] = 22093,
  [22966] = 21311,
  [22967] = 21311,
  [22968] = 22093,
  [22969] = 22142,
  [22970] = 21311,
  [22971] = 22093,
  [22972] = 21305,
  [22973] = 22500,
  [22974] = 22093,
  [22975] = 22502,
  [22976] = 21356,
  [22977] = 22093,
  [22978] = 21337,
  [22979] = 21312,
  [22980] = 22093,
  [22981] = 8395,
  [22982] = 21311,
  [22983] = 22093,
  [22984] = 22562,
  [22985] = 22542,
  [22986] = 22093,
  [22987] = 21304,
  [22988] = 21309,
  [22989] = 22093,
  [22990] = 21309,
  [22991] = 22547,
  [22992] = 22093,
  [22993] = 22553,
  [22994] = 21302,
  [22995] = 22093,
  [22996] = 21296,
  [22997] = 21307,
  [22998] = 22093,
  [22999] = 22999,
  [23000] = 21295,
  [23001] = 22093,
  [23002] = 21297,
  [23003] = 21303,
  [23004] = 22093,
  [23005] = 21302,
  [23006] = 21303,
  [23007] = 22093,
  [23008] = 21297,
  [23009] = 21295,
  [23010] = 22093,
  [23011] = 21333,
  [23012] = 21299,
  [23013] = 22093,
  [23014] = 21361,
  [23015] = 21302,
  [23016] = 22093,
  [23017] = 21296,
  [23018] = 21307,
  [23019] = 22093,
  [23020] = 21296,
  [23021] = 21309,
  [23022] = 22093,
  [23023] = 21307,
  [23024] = 21336,
  [23025] = 22093,
  [23026] = 21341,
  [23027] = 21299,
  [23028] = 22093,
  [23029] = 21356,
  [23030] = 21295,
  [23031] = 22093,
  [23032] = 21311,
  [23033] = 21297,
  [23034] = 22093,
  [23035] = 21297,
  [23036] = 21305,
  [23037] = 22093,
  [23038] = 21307,
  [23039] = 21296,
  [23040] = 22093,
  [23041] = 21346,
  [23042] = 21337,
  [23043] = 22093,
  [23044] = 21339,
  [23045] = 21349,
  [23046] = 22093,
  [23047] = 21312,
  [23048] = 21304,
  [23049] = 22093,
  [23050] = 21307,
  [23051] = 21363,
  [23052] = 22093,
  [23053] = 22604,
  [23054] = 21339,
  [23055] = 22093,
  [23056] = 21662,
  [23057] = 21930,
  [23058] = 22093,
  [23059] = 21349,
  [23060] = 21346,
  [23061] = 22093,
  [23062] = 21363,
  [23063] = 21341,
  [23064] = 22093,
  [23065] = 21336,
  [23066] = 21304,
  [23067] = 22093,
  [23068] = 21312,
  [23069] = 21339,
  [23070] = 22093,
  [23071] = 21451,
  [23072] = 21337,
  [23073] = 22093,
  [23074] = 21417,
  [23075] = 21295,
  [23076] = 22093,
  [23077] = 21334,
  [23078] = 21305,
  [23079] = 22093,
  [23080] = 21316,
  [23081] = 21368,
  [23082] = 22093,
  [23083] = 21299,
  [23084] = 21302,
  [23085] = 22093,
  [23086] = 21304,
  [23087] = 21304,
  [23088] = 22093,
  [23089] = 21311,
  [23090] = 23090,
  [23091] = 22093,
  [23092] = 21597,
  [23093] = 22617,
  [23094] = 22093,
  [23095] = 21302,
  [23096] = 21309,
  [23097] = 22093,
  [23098] = 21326,
  [23099] = 21299,
  [23100] = 22093,
  [23101] = 22508,
  [23102] = 22617,
  [23103] = 22093,
  [23104] = 21336,
  [23105] = 21341,
  [23106] = 22093,
  [23107] = 22903,
  [23108] = 21363,
  [23109] = 22093,
  [23110] = 21295,
  [23111] = 22621,
  [23112] = 22093,
  [23113] = 21297,
  [23114] = 21296,
  [23115] = 22093,
  [23116] = 21303,
  [23117] = 21307,
  [23118] = 22093,
  [23119] = 21342,
  [23120] = 21312,
  [23121] = 22093,
  [23122] = 21346,
  [23123] = 21349,
  [23124] = 22093,
  [23125] = 21504,
  [23126] = 21304,
  [23127] = 22093,
  [23128] = 8342,
  [23129] = 21307,
  [23130] = 22093,
  [23131] = 21296,
  [23132] = 21363,
  [23133] = 22093,
  [23134] = 21684,
  [23135] = 21309,
  [23136] = 22093,
  [23137] = 21302,
  [23138] = 21309,
  [23139] = 22093,
  [23140] = 22129,
  [23141] = 22193,
  [23142] = 22093,
  [23143] = 22233,
  [23144] = 21311,
  [23145] = 22093,
  [23146] = 21299,
  [23147] = 21303,
  [23148] = 22093,
  [23149] = 21304,
  [23150] = 21295,
  [23151] = 22093,
  [23152] = 21312,
  [23153] = 21339,
  [23154] = 22093,
  [23155] = 21299,
  [23156] = 21337,
  [23157] = 22093,
  [23158] = 21302,
  [23159] = 21295,
  [23160] = 22093,
  [23161] = 21297,
  [23162] = 21424,
  [23163] = 22093,
  [23164] = 21296,
  [23165] = 21307,
  [23166] = 22093,
  [23167] = 21337,
  [23168] = 21339,
  [23169] = 22093,
  [23170] = 21297,
  [23171] = 21312,
  [23172] = 22093,
  [23173] = 22500,
  [23174] = 22502,
  [23175] = 22093,
  [23176] = 21309,
  [23177] = 22999,
  [23178] = 22093,
  [23179] = 21336,
  [23180] = 21296,
  [23181] = 22093,
  [23182] = 22562,
  [23183] = 21309,
  [23184] = 22093,
  [23185] = 21297,
  [23186] = 21295,
  [23187] = 22542,
  [23188] = 21299,
  [23189] = 22843,
  [23190] = 21349,
  [23191] = 22739,
  [23192] = 21341,
  [23193] = 22605,
  [23194] = 22562,
  [23195] = 22547,
  [23196] = 21346,
  [23197] = 21302,
  [23198] = 21304,
  [23199] = 21304,
  [23200] = 21341,
  [23201] = 22553,
  [23202] = 21302,
  [23203] = 22843,
  [23204] = 21302,
  [23205] = 22739,
  [23206] = 21304,
  [23207] = 22605,
  [23208] = 22562,
  [23209] = 21363,
  [23210] = 21341,
  [23211] = 21299,
  [23212] = 21295,
  [23213] = 21297,
  [23214] = 22843,
  [23215] = 21307,
  [23216] = 22739,
  [23217] = 21299,
  [23218] = 22605,
  [23219] = 21296,
  [23220] = 21309,
  [23221] = 21336,
  [23222] = 22843,
  [23223] = 21295,
  [23224] = 22739,
  [23225] = 22605,
  [23226] = 21309,
  [23227] = 21296,
  [23228] = 21326,
  [23229] = 22843,
  [23230] = 21297,
  [23231] = 22739,
  [23232] = 22605,
  [23233] = 21307,
  [23234] = 22621,
  [23235] = 22843,
  [23236] = 21303,
  [23237] = 22605,
  [23238] = 21297,
  [23239] = 22138,
  [23240] = 22843,
  [23241] = 21346,
  [23242] = 22605,
  [23243] = 21295,
  [23244] = 21299,
  [23245] = 22843,
  [23246] = 21349,
  [23247] = 22605,
  [23248] = 21304,
  [23249] = 21302,
  [23250] = 22843,
  [23251] = 21302,
  [23252] = 22605,
  [23253] = 21326,
  [23254] = 21299,
  [23255] = 22843,
  [23256] = 21346,
  [23257] = 22605,
  [23258] = 21295,
  [23259] = 21297,
  [23260] = 22843,
  [23261] = 21333,
  [23262] = 22605,
  [23263] = 21304,
  [23264] = 21336,
  [23265] = 22843,
  [23266] = 22093,
  [23267] = 22605,
  [23268] = 21307,
  [23269] = 21296,
  [23270] = 22843,
  [23271] = 21349,
  [23272] = 22605,
  [23273] = 21297,
  [23274] = 21341,
  [23275] = 22843,
  [23276] = 21341,
  [23277] = 22605,
  [23278] = 21342,
  [23279] = 21346,
  [23280] = 22843,
  [23281] = 21361,
  [23282] = 22605,
  [23283] = 21349,
  [23284] = 22903,
  [23285] = 22843,
  [23286] = 21304,
  [23287] = 22605,
  [23288] = 21309,
  [23289] = 21312,
  [23290] = 22843,
  [23291] = 21336,
  [23292] = 22605,
  [23293] = 21302,
  [23294] = 21296,
  [23295] = 22843,
  [23296] = 21307,
  [23297] = 22605,
  [23298] = 21299,
  [23299] = 21295,
  [23300] = 22843,
  [23301] = 21299,
  [23302] = 22605,
  [23303] = 21302,
  [23304] = 21297,
  [23305] = 22843,
  [23306] = 23306,
  [23307] = 22605,
  [23308] = 21307,
  [23309] = 21296,
  [23310] = 22843,
  [23311] = 21309,
  [23312] = 22605,
  [23313] = 21295,
  [23314] = 21342,
  [23315] = 22843,
  [23316] = 22604,
  [23317] = 22605,
  [23318] = 21299,
  [23319] = 22843,
  [23320] = 21307,
  [23321] = 21302,
  [23322] = 22843,
  [23323] = 21296,
  [23324] = 21304,
  [23325] = 22843,
  [23326] = 21309,
  [23327] = 21307,
  [23328] = 22843,
  [23329] = 21295,
  [23330] = 21305,
  [23331] = 22843,
  [23332] = 21297,
  [23333] = 21363,
  [23334] = 22843,
  [23335] = 21304,
  [23336] = 21304,
  [23337] = 22843,
  [23338] = 21302,
  [23339] = 21299,
  [23340] = 22843,
  [23341] = 21356,
  [23342] = 21295,
  [23343] = 22843,
  [23344] = 23344,
  [23345] = 21297,
  [23346] = 22843,
  [23347] = 21303,
  [23348] = 21309,
  [23349] = 22843,
  [23350] = 21363,
  [23351] = 21296,
  [23352] = 22843,
  [23353] = 21307,
  [23354] = 21296,
  [23355] = 22843,
  [23356] = 21311,
  [23357] = 21309,
  [23358] = 22843,
  [23359] = 22090,
  [23360] = 21311,
  [23361] = 22843,
  [23362] = 21356,
  [23363] = 21307,
  [23364] = 22843,
  [23365] = 21297,
  [23366] = 21295,
  [23367] = 22843,
  [23368] = 21305,
  [23369] = 21309,
  [23370] = 22843,
  [23371] = 21312,
  [23372] = 21296,
  [23373] = 22843,
  [23374] = 21304,
  [23375] = 21299,
  [23376] = 22843,
  [23377] = 21339,
  [23378] = 21304,
  [23379] = 22843,
  [23380] = 21337,
  [23381] = 21302,
  [23382] = 22843,
  [23383] = 23383,
  [23384] = 21339,
  [23385] = 22843,
  [23386] = 21302,
  [23387] = 21304,
  [23388] = 21312,
  [23389] = 22999,
  [23390] = 21299,
  [23391] = 21307,
  [23392] = 22604,
  [23393] = 21295,
  [23394] = 21297,
  [23395] = 21337,
  [23396] = 21296,
  [23397] = 21307,
  [23398] = 21309,
  [23399] = 21296,
  [23400] = 21309,
  [23401] = 21309,
  [23402] = 21361,
  [23403] = 21296,
  [23404] = 21307,
  [23405] = 21333,
  [23406] = 21297,
  [23407] = 21295,
  [23408] = 21304,
  [23409] = 21299,
  [23410] = 21302,
  [23411] = 21302,
  [23412] = 21304,
  [23413] = 21299,
  [23414] = 21295,
  [23415] = 21297,
  [23416] = 21302,
  [23417] = 21307,
  [23418] = 21296,
  [23419] = 21309,
  [23420] = 21303,
  [23421] = 21309,
  [23422] = 21297,
  [23423] = 21296,
  [23424] = 21295,
  [23425] = 21307,
  [23426] = 21297,
  [23427] = 21304,
  [23428] = 21295,
  [23429] = 21299,
  [23430] = 21311,
  [23431] = 21302,
};

static inline bool sym__varid_character_set_1(int32_t c) {
  return (c < 8458
    ? (c < 7296
      ? (c < 891
        ? (c < 445
          ? (c < 223
            ? (c < 181
              ? (c >= '_' && c <= 'z')
              : c <= 181)
            : (c <= 246 || (c >= 248 && c <= 442)))
          : (c <= 447 || (c < 881
            ? (c < 661
              ? (c >= 454 && c <= 659)
              : c <= 687)
            : (c <= 883 || c == 887))))
        : (c <= 893 || (c < 1376
          ? (c < 1016
            ? (c < 940
              ? c == 912
              : c <= 1013)
            : (c <= 1153 || (c >= 1163 && c <= 1327)))
          : (c <= 1416 || (c < 4349
            ? (c >= 4304 && c <= 4346)
            : (c <= 4351 || (c >= 5112 && c <= 5117)))))))
      : (c <= 7304 || (c < 8118
        ? (c < 7968
          ? (c < 7545
            ? (c < 7531
              ? (c >= 7424 && c <= 7467)
              : c <= 7543)
            : (c <= 7578 || (c >= 7681 && c <= 7957)))
          : (c <= 8005 || (c < 8032
            ? (c >= 8016 && c <= 8023)
            : (c <= 8061 || (c >= 8064 && c <= 8116)))))
        : (c <= 8119 || (c < 8150
          ? (c < 8134
            ? (c < 8130
              ? c == 8126
              : c <= 8132)
            : (c <= 8135 || (c >= 8144 && c <= 8147)))
          : (c <= 8151 || (c < 8178
            ? (c >= 8160 && c <= 8167)
            : (c <= 8180 || (c >= 8182 && c <= 8183)))))))))
    : (c <= 8467 || (c < 42897
      ? (c < 11507
        ? (c < 8526
          ? (c < 8508
            ? (c < 8505
              ? (c >= 8495 && c <= 8500)
              : c <= 8505)
            : (c <= 8509 || (c >= 8518 && c <= 8521)))
          : (c <= 8526 || (c < 11393
            ? (c < 11312
              ? c == 8580
              : c <= 11387)
            : (c <= 11492 || (c >= 11500 && c <= 11502)))))
        : (c <= 11507 || (c < 42625
          ? (c < 11565
            ? (c < 11559
              ? (c >= 11520 && c <= 11557)
              : c <= 11559)
            : (c <= 11565 || (c >= 42561 && c <= 42605)))
          : (c <= 42651 || (c < 42865
            ? (c >= 42787 && c <= 42863)
            : (c <= 42887 || (c >= 42892 && c <= 42894)))))))
      : (c <= 42954 || (c < 64256
        ? (c < 43002
          ? (c < 42965
            ? (c < 42963
              ? c == 42961
              : c <= 42963)
            : (c <= 42969 || c == 42998))
          : (c <= 43002 || (c < 43872
            ? (c >= 43824 && c <= 43866)
            : (c <= 43880 || (c >= 43888 && c <= 43967)))))
        : (c <= 64262 || (c < 66967
          ? (c < 66600
            ? (c < 65345
              ? (c >= 64275 && c <= 64279)
              : c <= 65370)
            : (c <= 66639 || (c >= 66776 && c <= 66811)))
          : (c <= 66977 || (c < 66995
            ? (c >= 66979 && c <= 66993)
            : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))));
}

static inline bool sym__varid_character_set_2(int32_t c) {
  return (c < 8458
    ? (c < 5112
      ? (c < 887
        ? (c < 248
          ? (c < 181
            ? (c < 'a'
              ? c == '_'
              : c <= 'z')
            : (c <= 181 || (c >= 223 && c <= 246)))
          : (c <= 442 || (c < 661
            ? (c < 454
              ? (c >= 445 && c <= 447)
              : c <= 659)
            : (c <= 687 || (c >= 881 && c <= 883)))))
        : (c <= 887 || (c < 1163
          ? (c < 940
            ? (c < 912
              ? (c >= 891 && c <= 893)
              : c <= 912)
            : (c <= 1013 || (c >= 1016 && c <= 1153)))
          : (c <= 1327 || (c < 4304
            ? (c >= 1376 && c <= 1416)
            : (c <= 4346 || (c >= 4349 && c <= 4351)))))))
      : (c <= 5117 || (c < 8118
        ? (c < 7681
          ? (c < 7531
            ? (c < 7424
              ? (c >= 7296 && c <= 7304)
              : c <= 7467)
            : (c <= 7543 || (c >= 7545 && c <= 7578)))
          : (c <= 7957 || (c < 8032
            ? (c < 8016
              ? (c >= 7968 && c <= 8005)
              : c <= 8023)
            : (c <= 8061 || (c >= 8064 && c <= 8116)))))
        : (c <= 8119 || (c < 8150
          ? (c < 8134
            ? (c < 8130
              ? c == 8126
              : c <= 8132)
            : (c <= 8135 || (c >= 8144 && c <= 8147)))
          : (c <= 8151 || (c < 8178
            ? (c >= 8160 && c <= 8167)
            : (c <= 8180 || (c >= 8182 && c <= 8183)))))))))
    : (c <= 8467 || (c < 42897
      ? (c < 11507
        ? (c < 8526
          ? (c < 8508
            ? (c < 8505
              ? (c >= 8495 && c <= 8500)
              : c <= 8505)
            : (c <= 8509 || (c >= 8518 && c <= 8521)))
          : (c <= 8526 || (c < 11393
            ? (c < 11312
              ? c == 8580
              : c <= 11387)
            : (c <= 11492 || (c >= 11500 && c <= 11502)))))
        : (c <= 11507 || (c < 42625
          ? (c < 11565
            ? (c < 11559
              ? (c >= 11520 && c <= 11557)
              : c <= 11559)
            : (c <= 11565 || (c >= 42561 && c <= 42605)))
          : (c <= 42651 || (c < 42865
            ? (c >= 42787 && c <= 42863)
            : (c <= 42887 || (c >= 42892 && c <= 42894)))))))
      : (c <= 42954 || (c < 64256
        ? (c < 43002
          ? (c < 42965
            ? (c < 42963
              ? c == 42961
              : c <= 42963)
            : (c <= 42969 || c == 42998))
          : (c <= 43002 || (c < 43872
            ? (c >= 43824 && c <= 43866)
            : (c <= 43880 || (c >= 43888 && c <= 43967)))))
        : (c <= 64262 || (c < 66967
          ? (c < 66600
            ? (c < 65345
              ? (c >= 64275 && c <= 64279)
              : c <= 65370)
            : (c <= 66639 || (c >= 66776 && c <= 66811)))
          : (c <= 66977 || (c < 66995
            ? (c >= 66979 && c <= 66993)
            : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))));
}

static inline bool sym__immediate_varid_character_set_1(int32_t c) {
  return (c < 7749
    ? (c < 987
      ? (c < 424
        ? (c < 326
          ? (c < 285
            ? (c < 265
              ? (c < 248
                ? (c < 181
                  ? (c < 'a'
                    ? c == '_'
                    : c <= 'z')
                  : (c <= 181 || (c >= 223 && c <= 246)))
                : (c <= 255 || (c < 261
                  ? (c < 259
                    ? c == 257
                    : c <= 259)
                  : (c <= 261 || c == 263))))
              : (c <= 265 || (c < 275
                ? (c < 271
                  ? (c < 269
                    ? c == 267
                    : c <= 269)
                  : (c <= 271 || c == 273))
                : (c <= 275 || (c < 281
                  ? (c < 279
                    ? c == 277
                    : c <= 279)
                  : (c <= 281 || c == 283))))))
            : (c <= 285 || (c < 305
              ? (c < 295
                ? (c < 291
                  ? (c < 289
                    ? c == 287
                    : c <= 289)
                  : (c <= 291 || c == 293))
                : (c <= 295 || (c < 301
                  ? (c < 299
                    ? c == 297
                    : c <= 299)
                  : (c <= 301 || c == 303))))
              : (c <= 305 || (c < 316
                ? (c < 311
                  ? (c < 309
                    ? c == 307
                    : c <= 309)
                  : (c <= 312 || c == 314))
                : (c <= 316 || (c < 322
                  ? (c < 320
                    ? c == 318
                    : c <= 320)
                  : (c <= 322 || c == 324))))))))
          : (c <= 326 || (c < 367
            ? (c < 347
              ? (c < 337
                ? (c < 333
                  ? (c < 331
                    ? (c >= 328 && c <= 329)
                    : c <= 331)
                  : (c <= 333 || c == 335))
                : (c <= 337 || (c < 343
                  ? (c < 341
                    ? c == 339
                    : c <= 341)
                  : (c <= 343 || c == 345))))
              : (c <= 347 || (c < 357
                ? (c < 353
                  ? (c < 351
                    ? c == 349
                    : c <= 351)
                  : (c <= 353 || c == 355))
                : (c <= 357 || (c < 363
                  ? (c < 361
                    ? c == 359
                    : c <= 361)
                  : (c <= 363 || c == 365))))))
            : (c <= 367 || (c < 392
              ? (c < 378
                ? (c < 373
                  ? (c < 371
                    ? c == 369
                    : c <= 371)
                  : (c <= 373 || c == 375))
                : (c <= 378 || (c < 387
                  ? (c < 382
                    ? c == 380
                    : c <= 384)
                  : (c <= 387 || c == 389))))
              : (c <= 392 || (c < 414
                ? (c < 405
                  ? (c < 402
                    ? (c >= 396 && c <= 397)
                    : c <= 402)
                  : (c <= 405 || (c >= 409 && c <= 411)))
                : (c <= 414 || (c < 419
                  ? c == 417
                  : (c <= 419 || c == 421))))))))))
        : (c <= 424 || (c < 523
          ? (c < 481
            ? (c < 460
              ? (c < 438
                ? (c < 432
                  ? (c < 429
                    ? (c >= 426 && c <= 427)
                    : c <= 429)
                  : (c <= 432 || c == 436))
                : (c <= 438 || (c < 454
                  ? (c < 445
                    ? (c >= 441 && c <= 442)
                    : c <= 447)
                  : (c <= 454 || c == 457))))
              : (c <= 460 || (c < 470
                ? (c < 466
                  ? (c < 464
                    ? c == 462
                    : c <= 464)
                  : (c <= 466 || c == 468))
                : (c <= 470 || (c < 476
                  ? (c < 474
                    ? c == 472
                    : c <= 474)
                  : (c <= 477 || c == 479))))))
            : (c <= 481 || (c < 505
              ? (c < 491
                ? (c < 487
                  ? (c < 485
                    ? c == 483
                    : c <= 485)
                  : (c <= 487 || c == 489))
                : (c <= 491 || (c < 499
                  ? (c < 495
                    ? c == 493
                    : c <= 496)
                  : (c <= 499 || c == 501))))
              : (c <= 505 || (c < 515
                ? (c < 511
                  ? (c < 509
                    ? c == 507
                    : c <= 509)
                  : (c <= 511 || c == 513))
                : (c <= 515 || (c < 519
                  ? c == 517
                  : (c <= 519 || c == 521))))))))
          : (c <= 523 || (c < 563
            ? (c < 543
              ? (c < 533
                ? (c < 529
                  ? (c < 527
                    ? c == 525
                    : c <= 527)
                  : (c <= 529 || c == 531))
                : (c <= 533 || (c < 539
                  ? (c < 537
                    ? c == 535
                    : c <= 537)
                  : (c <= 539 || c == 541))))
              : (c <= 543 || (c < 553
                ? (c < 549
                  ? (c < 547
                    ? c == 545
                    : c <= 547)
                  : (c <= 549 || c == 551))
                : (c <= 553 || (c < 559
                  ? (c < 557
                    ? c == 555
                    : c <= 557)
                  : (c <= 559 || c == 561))))))
            : (c <= 569 || (c < 881
              ? (c < 585
                ? (c < 578
                  ? (c < 575
                    ? c == 572
                    : c <= 576)
                  : (c <= 578 || c == 583))
                : (c <= 585 || (c < 591
                  ? (c < 589
                    ? c == 587
                    : c <= 589)
                  : (c <= 659 || (c >= 661 && c <= 687)))))
              : (c <= 881 || (c < 940
                ? (c < 891
                  ? (c < 887
                    ? c == 883
                    : c <= 887)
                  : (c <= 893 || c == 912))
                : (c <= 974 || (c < 981
                  ? (c >= 976 && c <= 977)
                  : (c <= 983 || c == 985))))))))))))
      : (c <= 987 || (c < 1257
        ? (c < 1177
          ? (c < 1131
            ? (c < 1007
              ? (c < 997
                ? (c < 993
                  ? (c < 991
                    ? c == 989
                    : c <= 991)
                  : (c <= 993 || c == 995))
                : (c <= 997 || (c < 1003
                  ? (c < 1001
                    ? c == 999
                    : c <= 1001)
                  : (c <= 1003 || c == 1005))))
              : (c <= 1011 || (c < 1121
                ? (c < 1019
                  ? (c < 1016
                    ? c == 1013
                    : c <= 1016)
                  : (c <= 1020 || (c >= 1072 && c <= 1119)))
                : (c <= 1121 || (c < 1127
                  ? (c < 1125
                    ? c == 1123
                    : c <= 1125)
                  : (c <= 1127 || c == 1129))))))
            : (c <= 1131 || (c < 1151
              ? (c < 1141
                ? (c < 1137
                  ? (c < 1135
                    ? c == 1133
                    : c <= 1135)
                  : (c <= 1137 || c == 1139))
                : (c <= 1141 || (c < 1147
                  ? (c < 1145
                    ? c == 1143
                    : c <= 1145)
                  : (c <= 1147 || c == 1149))))
              : (c <= 1151 || (c < 1169
                ? (c < 1165
                  ? (c < 1163
                    ? c == 1153
                    : c <= 1163)
                  : (c <= 1165 || c == 1167))
                : (c <= 1169 || (c < 1173
                  ? c == 1171
                  : (c <= 1173 || c == 1175))))))))
          : (c <= 1177 || (c < 1218
            ? (c < 1197
              ? (c < 1187
                ? (c < 1183
                  ? (c < 1181
                    ? c == 1179
                    : c <= 1181)
                  : (c <= 1183 || c == 1185))
                : (c <= 1187 || (c < 1193
                  ? (c < 1191
                    ? c == 1189
                    : c <= 1191)
                  : (c <= 1193 || c == 1195))))
              : (c <= 1197 || (c < 1207
                ? (c < 1203
                  ? (c < 1201
                    ? c == 1199
                    : c <= 1201)
                  : (c <= 1203 || c == 1205))
                : (c <= 1207 || (c < 1213
                  ? (c < 1211
                    ? c == 1209
                    : c <= 1211)
                  : (c <= 1213 || c == 1215))))))
            : (c <= 1218 || (c < 1239
              ? (c < 1228
                ? (c < 1224
                  ? (c < 1222
                    ? c == 1220
                    : c <= 1222)
                  : (c <= 1224 || c == 1226))
                : (c <= 1228 || (c < 1235
                  ? (c < 1233
                    ? (c >= 1230 && c <= 1231)
                    : c <= 1233)
                  : (c <= 1235 || c == 1237))))
              : (c <= 1239 || (c < 1249
                ? (c < 1245
                  ? (c < 1243
                    ? c == 1241
                    : c <= 1243)
                  : (c <= 1245 || c == 1247))
                : (c <= 1249 || (c < 1253
                  ? c == 1251
                  : (c <= 1253 || c == 1255))))))))))
        : (c <= 1257 || (c < 5112
          ? (c < 1297
            ? (c < 1277
              ? (c < 1267
                ? (c < 1263
                  ? (c < 1261
                    ? c == 1259
                    : c <= 1261)
                  : (c <= 1263 || c == 1265))
                : (c <= 1267 || (c < 1273
                  ? (c < 1271
                    ? c == 1269
                    : c <= 1271)
                  : (c <= 1273 || c == 1275))))
              : (c <= 1277 || (c < 1287
                ? (c < 1283
                  ? (c < 1281
                    ? c == 1279
                    : c <= 1281)
                  : (c <= 1283 || c == 1285))
                : (c <= 1287 || (c < 1293
                  ? (c < 1291
                    ? c == 1289
                    : c <= 1291)
                  : (c <= 1293 || c == 1295))))))
            : (c <= 1297 || (c < 1317
              ? (c < 1307
                ? (c < 1303
                  ? (c < 1301
                    ? c == 1299
                    : c <= 1301)
                  : (c <= 1303 || c == 1305))
                : (c <= 1307 || (c < 1313
                  ? (c < 1311
                    ? c == 1309
                    : c <= 1311)
                  : (c <= 1313 || c == 1315))))
              : (c <= 1317 || (c < 1327
                ? (c < 1323
                  ? (c < 1321
                    ? c == 1319
                    : c <= 1321)
                  : (c <= 1323 || c == 1325))
                : (c <= 1327 || (c < 4304
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 4346 || (c >= 4349 && c <= 4351)))))))))
          : (c <= 5117 || (c < 7711
            ? (c < 7691
              ? (c < 7681
                ? (c < 7531
                  ? (c < 7424
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7467)
                  : (c <= 7543 || (c >= 7545 && c <= 7578)))
                : (c <= 7681 || (c < 7687
                  ? (c < 7685
                    ? c == 7683
                    : c <= 7685)
                  : (c <= 7687 || c == 7689))))
              : (c <= 7691 || (c < 7701
                ? (c < 7697
                  ? (c < 7695
                    ? c == 7693
                    : c <= 7695)
                  : (c <= 7697 || c == 7699))
                : (c <= 7701 || (c < 7707
                  ? (c < 7705
                    ? c == 7703
                    : c <= 7705)
                  : (c <= 7707 || c == 7709))))))
            : (c <= 7711 || (c < 7731
              ? (c < 7721
                ? (c < 7717
                  ? (c < 7715
                    ? c == 7713
                    : c <= 7715)
                  : (c <= 7717 || c == 7719))
                : (c <= 7721 || (c < 7727
                  ? (c < 7725
                    ? c == 7723
                    : c <= 7725)
                  : (c <= 7727 || c == 7729))))
              : (c <= 7731 || (c < 7741
                ? (c < 7737
                  ? (c < 7735
                    ? c == 7733
                    : c <= 7735)
                  : (c <= 7737 || c == 7739))
                : (c <= 7741 || (c < 7745
                  ? c == 7743
                  : (c <= 7745 || c == 7747))))))))))))))
    : (c <= 7749 || (c < 11447
      ? (c < 7913
        ? (c < 7827
          ? (c < 7789
            ? (c < 7769
              ? (c < 7759
                ? (c < 7755
                  ? (c < 7753
                    ? c == 7751
                    : c <= 7753)
                  : (c <= 7755 || c == 7757))
                : (c <= 7759 || (c < 7765
                  ? (c < 7763
                    ? c == 7761
                    : c <= 7763)
                  : (c <= 7765 || c == 7767))))
              : (c <= 7769 || (c < 7779
                ? (c < 7775
                  ? (c < 7773
                    ? c == 7771
                    : c <= 7773)
                  : (c <= 7775 || c == 7777))
                : (c <= 7779 || (c < 7785
                  ? (c < 7783
                    ? c == 7781
                    : c <= 7783)
                  : (c <= 7785 || c == 7787))))))
            : (c <= 7789 || (c < 7809
              ? (c < 7799
                ? (c < 7795
                  ? (c < 7793
                    ? c == 7791
                    : c <= 7793)
                  : (c <= 7795 || c == 7797))
                : (c <= 7799 || (c < 7805
                  ? (c < 7803
                    ? c == 7801
                    : c <= 7803)
                  : (c <= 7805 || c == 7807))))
              : (c <= 7809 || (c < 7819
                ? (c < 7815
                  ? (c < 7813
                    ? c == 7811
                    : c <= 7813)
                  : (c <= 7815 || c == 7817))
                : (c <= 7819 || (c < 7823
                  ? c == 7821
                  : (c <= 7823 || c == 7825))))))))
          : (c <= 7827 || (c < 7875
            ? (c < 7855
              ? (c < 7845
                ? (c < 7841
                  ? (c < 7839
                    ? (c >= 7829 && c <= 7837)
                    : c <= 7839)
                  : (c <= 7841 || c == 7843))
                : (c <= 7845 || (c < 7851
                  ? (c < 7849
                    ? c == 7847
                    : c <= 7849)
                  : (c <= 7851 || c == 7853))))
              : (c <= 7855 || (c < 7865
                ? (c < 7861
                  ? (c < 7859
                    ? c == 7857
                    : c <= 7859)
                  : (c <= 7861 || c == 7863))
                : (c <= 7865 || (c < 7871
                  ? (c < 7869
                    ? c == 7867
                    : c <= 7869)
                  : (c <= 7871 || c == 7873))))))
            : (c <= 7875 || (c < 7895
              ? (c < 7885
                ? (c < 7881
                  ? (c < 7879
                    ? c == 7877
                    : c <= 7879)
                  : (c <= 7881 || c == 7883))
                : (c <= 7885 || (c < 7891
                  ? (c < 7889
                    ? c == 7887
                    : c <= 7889)
                  : (c <= 7891 || c == 7893))))
              : (c <= 7895 || (c < 7905
                ? (c < 7901
                  ? (c < 7899
                    ? c == 7897
                    : c <= 7899)
                  : (c <= 7901 || c == 7903))
                : (c <= 7905 || (c < 7909
                  ? c == 7907
                  : (c <= 7909 || c == 7911))))))))))
        : (c <= 7913 || (c < 8518
          ? (c < 8080
            ? (c < 7933
              ? (c < 7923
                ? (c < 7919
                  ? (c < 7917
                    ? c == 7915
                    : c <= 7917)
                  : (c <= 7919 || c == 7921))
                : (c <= 7923 || (c < 7929
                  ? (c < 7927
                    ? c == 7925
                    : c <= 7927)
                  : (c <= 7929 || c == 7931))))
              : (c <= 7933 || (c < 8000
                ? (c < 7968
                  ? (c < 7952
                    ? (c >= 7935 && c <= 7943)
                    : c <= 7957)
                  : (c <= 7975 || (c >= 7984 && c <= 7991)))
                : (c <= 8005 || (c < 8048
                  ? (c < 8032
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8039)
                  : (c <= 8061 || (c >= 8064 && c <= 8071)))))))
            : (c <= 8087 || (c < 8178
              ? (c < 8130
                ? (c < 8118
                  ? (c < 8112
                    ? (c >= 8096 && c <= 8103)
                    : c <= 8116)
                  : (c <= 8119 || c == 8126))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8135)
                    : c <= 8147)
                  : (c <= 8151 || (c >= 8160 && c <= 8167)))))
              : (c <= 8180 || (c < 8495
                ? (c < 8462
                  ? (c < 8458
                    ? (c >= 8182 && c <= 8183)
                    : c <= 8458)
                  : (c <= 8463 || c == 8467))
                : (c <= 8495 || (c < 8505
                  ? c == 8500
                  : (c <= 8505 || (c >= 8508 && c <= 8509)))))))))
          : (c <= 8521 || (c < 11409
            ? (c < 11379
              ? (c < 11365
                ? (c < 11312
                  ? (c < 8580
                    ? c == 8526
                    : c <= 8580)
                  : (c <= 11359 || c == 11361))
                : (c <= 11366 || (c < 11372
                  ? (c < 11370
                    ? c == 11368
                    : c <= 11370)
                  : (c <= 11372 || c == 11377))))
              : (c <= 11380 || (c < 11399
                ? (c < 11395
                  ? (c < 11393
                    ? (c >= 11382 && c <= 11387)
                    : c <= 11393)
                  : (c <= 11395 || c == 11397))
                : (c <= 11399 || (c < 11405
                  ? (c < 11403
                    ? c == 11401
                    : c <= 11403)
                  : (c <= 11405 || c == 11407))))))
            : (c <= 11409 || (c < 11429
              ? (c < 11419
                ? (c < 11415
                  ? (c < 11413
                    ? c == 11411
                    : c <= 11413)
                  : (c <= 11415 || c == 11417))
                : (c <= 11419 || (c < 11425
                  ? (c < 11423
                    ? c == 11421
                    : c <= 11423)
                  : (c <= 11425 || c == 11427))))
              : (c <= 11429 || (c < 11439
                ? (c < 11435
                  ? (c < 11433
                    ? c == 11431
                    : c <= 11433)
                  : (c <= 11435 || c == 11437))
                : (c <= 11439 || (c < 11443
                  ? c == 11441
                  : (c <= 11443 || c == 11445))))))))))))
      : (c <= 11447 || (c < 42813
        ? (c < 42581
          ? (c < 11487
            ? (c < 11467
              ? (c < 11457
                ? (c < 11453
                  ? (c < 11451
                    ? c == 11449
                    : c <= 11451)
                  : (c <= 11453 || c == 11455))
                : (c <= 11457 || (c < 11463
                  ? (c < 11461
                    ? c == 11459
                    : c <= 11461)
                  : (c <= 11463 || c == 11465))))
              : (c <= 11467 || (c < 11477
                ? (c < 11473
                  ? (c < 11471
                    ? c == 11469
                    : c <= 11471)
                  : (c <= 11473 || c == 11475))
                : (c <= 11477 || (c < 11483
                  ? (c < 11481
                    ? c == 11479
                    : c <= 11481)
                  : (c <= 11483 || c == 11485))))))
            : (c <= 11487 || (c < 42563
              ? (c < 11507
                ? (c < 11500
                  ? (c < 11491
                    ? c == 11489
                    : c <= 11492)
                  : (c <= 11500 || c == 11502))
                : (c <= 11507 || (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || c == 42561))))
              : (c <= 42563 || (c < 42573
                ? (c < 42569
                  ? (c < 42567
                    ? c == 42565
                    : c <= 42567)
                  : (c <= 42569 || c == 42571))
                : (c <= 42573 || (c < 42577
                  ? c == 42575
                  : (c <= 42577 || c == 42579))))))))
          : (c <= 42581 || (c < 42639
            ? (c < 42601
              ? (c < 42591
                ? (c < 42587
                  ? (c < 42585
                    ? c == 42583
                    : c <= 42585)
                  : (c <= 42587 || c == 42589))
                : (c <= 42591 || (c < 42597
                  ? (c < 42595
                    ? c == 42593
                    : c <= 42595)
                  : (c <= 42597 || c == 42599))))
              : (c <= 42601 || (c < 42629
                ? (c < 42625
                  ? (c < 42605
                    ? c == 42603
                    : c <= 42605)
                  : (c <= 42625 || c == 42627))
                : (c <= 42629 || (c < 42635
                  ? (c < 42633
                    ? c == 42631
                    : c <= 42633)
                  : (c <= 42635 || c == 42637))))))
            : (c <= 42639 || (c < 42793
              ? (c < 42649
                ? (c < 42645
                  ? (c < 42643
                    ? c == 42641
                    : c <= 42643)
                  : (c <= 42645 || c == 42647))
                : (c <= 42649 || (c < 42789
                  ? (c < 42787
                    ? c == 42651
                    : c <= 42787)
                  : (c <= 42789 || c == 42791))))
              : (c <= 42793 || (c < 42805
                ? (c < 42799
                  ? (c < 42797
                    ? c == 42795
                    : c <= 42797)
                  : (c <= 42801 || c == 42803))
                : (c <= 42805 || (c < 42809
                  ? c == 42807
                  : (c <= 42809 || c == 42811))))))))))
        : (c <= 42813 || (c < 42905
          ? (c < 42853
            ? (c < 42833
              ? (c < 42823
                ? (c < 42819
                  ? (c < 42817
                    ? c == 42815
                    : c <= 42817)
                  : (c <= 42819 || c == 42821))
                : (c <= 42823 || (c < 42829
                  ? (c < 42827
                    ? c == 42825
                    : c <= 42827)
                  : (c <= 42829 || c == 42831))))
              : (c <= 42833 || (c < 42843
                ? (c < 42839
                  ? (c < 42837
                    ? c == 42835
                    : c <= 42837)
                  : (c <= 42839 || c == 42841))
                : (c <= 42843 || (c < 42849
                  ? (c < 42847
                    ? c == 42845
                    : c <= 42847)
                  : (c <= 42849 || c == 42851))))))
            : (c <= 42853 || (c < 42881
              ? (c < 42863
                ? (c < 42859
                  ? (c < 42857
                    ? c == 42855
                    : c <= 42857)
                  : (c <= 42859 || c == 42861))
                : (c <= 42863 || (c < 42876
                  ? (c < 42874
                    ? (c >= 42865 && c <= 42872)
                    : c <= 42874)
                  : (c <= 42876 || c == 42879))))
              : (c <= 42881 || (c < 42894
                ? (c < 42887
                  ? (c < 42885
                    ? c == 42883
                    : c <= 42885)
                  : (c <= 42887 || c == 42892))
                : (c <= 42894 || (c < 42899
                  ? c == 42897
                  : (c <= 42901 || c == 42903))))))))
          : (c <= 42905 || (c < 42961
            ? (c < 42933
              ? (c < 42915
                ? (c < 42911
                  ? (c < 42909
                    ? c == 42907
                    : c <= 42909)
                  : (c <= 42911 || c == 42913))
                : (c <= 42915 || (c < 42921
                  ? (c < 42919
                    ? c == 42917
                    : c <= 42919)
                  : (c <= 42921 || c == 42927))))
              : (c <= 42933 || (c < 42943
                ? (c < 42939
                  ? (c < 42937
                    ? c == 42935
                    : c <= 42937)
                  : (c <= 42939 || c == 42941))
                : (c <= 42943 || (c < 42952
                  ? (c < 42947
                    ? c == 42945
                    : c <= 42947)
                  : (c <= 42952 || c == 42954))))))
            : (c <= 42961 || (c < 64256
              ? (c < 42998
                ? (c < 42967
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42965)
                  : (c <= 42967 || c == 42969))
                : (c <= 42998 || (c < 43872
                  ? (c < 43824
                    ? c == 43002
                    : c <= 43866)
                  : (c <= 43880 || (c >= 43888 && c <= 43967)))))
              : (c <= 64262 || (c < 66967
                ? (c < 66600
                  ? (c < 65345
                    ? (c >= 64275 && c <= 64279)
                    : c <= 65370)
                  : (c <= 66639 || (c >= 66776 && c <= 66811)))
                : (c <= 66977 || (c < 66995
                  ? (c >= 66979 && c <= 66993)
                  : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))))))))));
}

static inline bool sym__conid_character_set_1(int32_t c) {
  return (c < 7738
    ? (c < 931
      ? (c < 422
        ? (c < 327
          ? (c < 288
            ? (c < 268
              ? (c < 258
                ? (c < 216
                  ? (c < 192
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 214)
                  : (c <= 222 || c == 256))
                : (c <= 258 || (c < 264
                  ? (c < 262
                    ? c == 260
                    : c <= 262)
                  : (c <= 264 || c == 266))))
              : (c <= 268 || (c < 278
                ? (c < 274
                  ? (c < 272
                    ? c == 270
                    : c <= 272)
                  : (c <= 274 || c == 276))
                : (c <= 278 || (c < 284
                  ? (c < 282
                    ? c == 280
                    : c <= 282)
                  : (c <= 284 || c == 286))))))
            : (c <= 288 || (c < 308
              ? (c < 298
                ? (c < 294
                  ? (c < 292
                    ? c == 290
                    : c <= 292)
                  : (c <= 294 || c == 296))
                : (c <= 298 || (c < 304
                  ? (c < 302
                    ? c == 300
                    : c <= 302)
                  : (c <= 304 || c == 306))))
              : (c <= 308 || (c < 319
                ? (c < 315
                  ? (c < 313
                    ? c == 310
                    : c <= 313)
                  : (c <= 315 || c == 317))
                : (c <= 319 || (c < 323
                  ? c == 321
                  : (c <= 323 || c == 325))))))))
          : (c <= 327 || (c < 366
            ? (c < 348
              ? (c < 338
                ? (c < 334
                  ? (c < 332
                    ? c == 330
                    : c <= 332)
                  : (c <= 334 || c == 336))
                : (c <= 338 || (c < 344
                  ? (c < 342
                    ? c == 340
                    : c <= 342)
                  : (c <= 344 || c == 346))))
              : (c <= 348 || (c < 358
                ? (c < 354
                  ? (c < 352
                    ? c == 350
                    : c <= 352)
                  : (c <= 354 || c == 356))
                : (c <= 358 || (c < 362
                  ? c == 360
                  : (c <= 362 || c == 364))))))
            : (c <= 366 || (c < 390
              ? (c < 376
                ? (c < 372
                  ? (c < 370
                    ? c == 368
                    : c <= 370)
                  : (c <= 372 || c == 374))
                : (c <= 377 || (c < 385
                  ? (c < 381
                    ? c == 379
                    : c <= 381)
                  : (c <= 386 || c == 388))))
              : (c <= 391 || (c < 412
                ? (c < 403
                  ? (c < 398
                    ? (c >= 393 && c <= 395)
                    : c <= 401)
                  : (c <= 404 || (c >= 406 && c <= 408)))
                : (c <= 413 || (c < 418
                  ? (c >= 415 && c <= 416)
                  : (c <= 418 || c == 420))))))))))
        : (c <= 423 || (c < 522
          ? (c < 480
            ? (c < 458
              ? (c < 437
                ? (c < 430
                  ? (c < 428
                    ? c == 425
                    : c <= 428)
                  : (c <= 431 || (c >= 433 && c <= 435)))
                : (c <= 437 || (c < 452
                  ? (c < 444
                    ? (c >= 439 && c <= 440)
                    : c <= 444)
                  : (c <= 453 || (c >= 455 && c <= 456)))))
              : (c <= 459 || (c < 469
                ? (c < 465
                  ? (c < 463
                    ? c == 461
                    : c <= 463)
                  : (c <= 465 || c == 467))
                : (c <= 469 || (c < 475
                  ? (c < 473
                    ? c == 471
                    : c <= 473)
                  : (c <= 475 || c == 478))))))
            : (c <= 480 || (c < 502
              ? (c < 490
                ? (c < 486
                  ? (c < 484
                    ? c == 482
                    : c <= 484)
                  : (c <= 486 || c == 488))
                : (c <= 490 || (c < 497
                  ? (c < 494
                    ? c == 492
                    : c <= 494)
                  : (c <= 498 || c == 500))))
              : (c <= 504 || (c < 514
                ? (c < 510
                  ? (c < 508
                    ? c == 506
                    : c <= 508)
                  : (c <= 510 || c == 512))
                : (c <= 514 || (c < 518
                  ? c == 516
                  : (c <= 518 || c == 520))))))))
          : (c <= 522 || (c < 560
            ? (c < 542
              ? (c < 532
                ? (c < 528
                  ? (c < 526
                    ? c == 524
                    : c <= 526)
                  : (c <= 528 || c == 530))
                : (c <= 532 || (c < 538
                  ? (c < 536
                    ? c == 534
                    : c <= 536)
                  : (c <= 538 || c == 540))))
              : (c <= 542 || (c < 552
                ? (c < 548
                  ? (c < 546
                    ? c == 544
                    : c <= 546)
                  : (c <= 548 || c == 550))
                : (c <= 552 || (c < 556
                  ? c == 554
                  : (c <= 556 || c == 558))))))
            : (c <= 560 || (c < 880
              ? (c < 579
                ? (c < 573
                  ? (c < 570
                    ? c == 562
                    : c <= 571)
                  : (c <= 574 || c == 577))
                : (c <= 582 || (c < 588
                  ? (c < 586
                    ? c == 584
                    : c <= 586)
                  : (c <= 588 || c == 590))))
              : (c <= 880 || (c < 904
                ? (c < 895
                  ? (c < 886
                    ? c == 882
                    : c <= 886)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : (c <= 911 || (c >= 913 && c <= 929)))))))))))))
      : (c <= 939 || (c < 1246
        ? (c < 1168
          ? (c < 1122
            ? (c < 998
              ? (c < 988
                ? (c < 984
                  ? (c < 978
                    ? c == 975
                    : c <= 980)
                  : (c <= 984 || c == 986))
                : (c <= 988 || (c < 994
                  ? (c < 992
                    ? c == 990
                    : c <= 992)
                  : (c <= 994 || c == 996))))
              : (c <= 998 || (c < 1012
                ? (c < 1004
                  ? (c < 1002
                    ? c == 1000
                    : c <= 1002)
                  : (c <= 1004 || c == 1006))
                : (c <= 1012 || (c < 1021
                  ? (c < 1017
                    ? c == 1015
                    : c <= 1018)
                  : (c <= 1071 || c == 1120))))))
            : (c <= 1122 || (c < 1142
              ? (c < 1132
                ? (c < 1128
                  ? (c < 1126
                    ? c == 1124
                    : c <= 1126)
                  : (c <= 1128 || c == 1130))
                : (c <= 1132 || (c < 1138
                  ? (c < 1136
                    ? c == 1134
                    : c <= 1136)
                  : (c <= 1138 || c == 1140))))
              : (c <= 1142 || (c < 1152
                ? (c < 1148
                  ? (c < 1146
                    ? c == 1144
                    : c <= 1146)
                  : (c <= 1148 || c == 1150))
                : (c <= 1152 || (c < 1164
                  ? c == 1162
                  : (c <= 1164 || c == 1166))))))))
          : (c <= 1168 || (c < 1206
            ? (c < 1188
              ? (c < 1178
                ? (c < 1174
                  ? (c < 1172
                    ? c == 1170
                    : c <= 1172)
                  : (c <= 1174 || c == 1176))
                : (c <= 1178 || (c < 1184
                  ? (c < 1182
                    ? c == 1180
                    : c <= 1182)
                  : (c <= 1184 || c == 1186))))
              : (c <= 1188 || (c < 1198
                ? (c < 1194
                  ? (c < 1192
                    ? c == 1190
                    : c <= 1192)
                  : (c <= 1194 || c == 1196))
                : (c <= 1198 || (c < 1202
                  ? c == 1200
                  : (c <= 1202 || c == 1204))))))
            : (c <= 1206 || (c < 1227
              ? (c < 1216
                ? (c < 1212
                  ? (c < 1210
                    ? c == 1208
                    : c <= 1210)
                  : (c <= 1212 || c == 1214))
                : (c <= 1217 || (c < 1223
                  ? (c < 1221
                    ? c == 1219
                    : c <= 1221)
                  : (c <= 1223 || c == 1225))))
              : (c <= 1227 || (c < 1238
                ? (c < 1234
                  ? (c < 1232
                    ? c == 1229
                    : c <= 1232)
                  : (c <= 1234 || c == 1236))
                : (c <= 1238 || (c < 1242
                  ? c == 1240
                  : (c <= 1242 || c == 1244))))))))))
        : (c <= 1246 || (c < 1324
          ? (c < 1286
            ? (c < 1266
              ? (c < 1256
                ? (c < 1252
                  ? (c < 1250
                    ? c == 1248
                    : c <= 1250)
                  : (c <= 1252 || c == 1254))
                : (c <= 1256 || (c < 1262
                  ? (c < 1260
                    ? c == 1258
                    : c <= 1260)
                  : (c <= 1262 || c == 1264))))
              : (c <= 1266 || (c < 1276
                ? (c < 1272
                  ? (c < 1270
                    ? c == 1268
                    : c <= 1270)
                  : (c <= 1272 || c == 1274))
                : (c <= 1276 || (c < 1282
                  ? (c < 1280
                    ? c == 1278
                    : c <= 1280)
                  : (c <= 1282 || c == 1284))))))
            : (c <= 1286 || (c < 1306
              ? (c < 1296
                ? (c < 1292
                  ? (c < 1290
                    ? c == 1288
                    : c <= 1290)
                  : (c <= 1292 || c == 1294))
                : (c <= 1296 || (c < 1302
                  ? (c < 1300
                    ? c == 1298
                    : c <= 1300)
                  : (c <= 1302 || c == 1304))))
              : (c <= 1306 || (c < 1316
                ? (c < 1312
                  ? (c < 1310
                    ? c == 1308
                    : c <= 1310)
                  : (c <= 1312 || c == 1314))
                : (c <= 1316 || (c < 1320
                  ? c == 1318
                  : (c <= 1320 || c == 1322))))))))
          : (c <= 1324 || (c < 7700
            ? (c < 7682
              ? (c < 4301
                ? (c < 4256
                  ? (c < 1329
                    ? c == 1326
                    : c <= 1366)
                  : (c <= 4293 || c == 4295))
                : (c <= 4301 || (c < 7357
                  ? (c < 7312
                    ? (c >= 5024 && c <= 5109)
                    : c <= 7354)
                  : (c <= 7359 || c == 7680))))
              : (c <= 7682 || (c < 7692
                ? (c < 7688
                  ? (c < 7686
                    ? c == 7684
                    : c <= 7686)
                  : (c <= 7688 || c == 7690))
                : (c <= 7692 || (c < 7696
                  ? c == 7694
                  : (c <= 7696 || c == 7698))))))
            : (c <= 7700 || (c < 7720
              ? (c < 7710
                ? (c < 7706
                  ? (c < 7704
                    ? c == 7702
                    : c <= 7704)
                  : (c <= 7706 || c == 7708))
                : (c <= 7710 || (c < 7716
                  ? (c < 7714
                    ? c == 7712
                    : c <= 7714)
                  : (c <= 7716 || c == 7718))))
              : (c <= 7720 || (c < 7730
                ? (c < 7726
                  ? (c < 7724
                    ? c == 7722
                    : c <= 7724)
                  : (c <= 7726 || c == 7728))
                : (c <= 7730 || (c < 7734
                  ? c == 7732
                  : (c <= 7734 || c == 7736))))))))))))))
    : (c <= 7738 || (c < 11428
      ? (c < 7900
        ? (c < 7816
          ? (c < 7778
            ? (c < 7758
              ? (c < 7748
                ? (c < 7744
                  ? (c < 7742
                    ? c == 7740
                    : c <= 7742)
                  : (c <= 7744 || c == 7746))
                : (c <= 7748 || (c < 7754
                  ? (c < 7752
                    ? c == 7750
                    : c <= 7752)
                  : (c <= 7754 || c == 7756))))
              : (c <= 7758 || (c < 7768
                ? (c < 7764
                  ? (c < 7762
                    ? c == 7760
                    : c <= 7762)
                  : (c <= 7764 || c == 7766))
                : (c <= 7768 || (c < 7774
                  ? (c < 7772
                    ? c == 7770
                    : c <= 7772)
                  : (c <= 7774 || c == 7776))))))
            : (c <= 7778 || (c < 7798
              ? (c < 7788
                ? (c < 7784
                  ? (c < 7782
                    ? c == 7780
                    : c <= 7782)
                  : (c <= 7784 || c == 7786))
                : (c <= 7788 || (c < 7794
                  ? (c < 7792
                    ? c == 7790
                    : c <= 7792)
                  : (c <= 7794 || c == 7796))))
              : (c <= 7798 || (c < 7808
                ? (c < 7804
                  ? (c < 7802
                    ? c == 7800
                    : c <= 7802)
                  : (c <= 7804 || c == 7806))
                : (c <= 7808 || (c < 7812
                  ? c == 7810
                  : (c <= 7812 || c == 7814))))))))
          : (c <= 7816 || (c < 7862
            ? (c < 7844
              ? (c < 7826
                ? (c < 7822
                  ? (c < 7820
                    ? c == 7818
                    : c <= 7820)
                  : (c <= 7822 || c == 7824))
                : (c <= 7826 || (c < 7840
                  ? (c < 7838
                    ? c == 7828
                    : c <= 7838)
                  : (c <= 7840 || c == 7842))))
              : (c <= 7844 || (c < 7854
                ? (c < 7850
                  ? (c < 7848
                    ? c == 7846
                    : c <= 7848)
                  : (c <= 7850 || c == 7852))
                : (c <= 7854 || (c < 7858
                  ? c == 7856
                  : (c <= 7858 || c == 7860))))))
            : (c <= 7862 || (c < 7882
              ? (c < 7872
                ? (c < 7868
                  ? (c < 7866
                    ? c == 7864
                    : c <= 7866)
                  : (c <= 7868 || c == 7870))
                : (c <= 7872 || (c < 7878
                  ? (c < 7876
                    ? c == 7874
                    : c <= 7876)
                  : (c <= 7878 || c == 7880))))
              : (c <= 7882 || (c < 7892
                ? (c < 7888
                  ? (c < 7886
                    ? c == 7884
                    : c <= 7886)
                  : (c <= 7888 || c == 7890))
                : (c <= 7892 || (c < 7896
                  ? c == 7894
                  : (c <= 7896 || c == 7898))))))))))
        : (c <= 7900 || (c < 8464
          ? (c < 7976
            ? (c < 7920
              ? (c < 7910
                ? (c < 7906
                  ? (c < 7904
                    ? c == 7902
                    : c <= 7904)
                  : (c <= 7906 || c == 7908))
                : (c <= 7910 || (c < 7916
                  ? (c < 7914
                    ? c == 7912
                    : c <= 7914)
                  : (c <= 7916 || c == 7918))))
              : (c <= 7920 || (c < 7930
                ? (c < 7926
                  ? (c < 7924
                    ? c == 7922
                    : c <= 7924)
                  : (c <= 7926 || c == 7928))
                : (c <= 7930 || (c < 7944
                  ? (c < 7934
                    ? c == 7932
                    : c <= 7934)
                  : (c <= 7951 || (c >= 7960 && c <= 7965)))))))
            : (c <= 7983 || (c < 8104
              ? (c < 8029
                ? (c < 8025
                  ? (c < 8008
                    ? (c >= 7992 && c <= 7999)
                    : c <= 8013)
                  : (c <= 8025 || c == 8027))
                : (c <= 8029 || (c < 8072
                  ? (c < 8040
                    ? c == 8031
                    : c <= 8047)
                  : (c <= 8079 || (c >= 8088 && c <= 8095)))))
              : (c <= 8111 || (c < 8184
                ? (c < 8152
                  ? (c < 8136
                    ? (c >= 8120 && c <= 8124)
                    : c <= 8140)
                  : (c <= 8155 || (c >= 8168 && c <= 8172)))
                : (c <= 8188 || (c < 8455
                  ? c == 8450
                  : (c <= 8455 || (c >= 8459 && c <= 8461)))))))))
          : (c <= 8466 || (c < 11381
            ? (c < 8579
              ? (c < 8488
                ? (c < 8484
                  ? (c < 8473
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8510
                  ? (c < 8496
                    ? (c >= 8490 && c <= 8493)
                    : c <= 8499)
                  : (c <= 8511 || c == 8517))))
              : (c <= 8579 || (c < 11369
                ? (c < 11362
                  ? (c < 11360
                    ? (c >= 11264 && c <= 11311)
                    : c <= 11360)
                  : (c <= 11364 || c == 11367))
                : (c <= 11369 || (c < 11373
                  ? c == 11371
                  : (c <= 11376 || c == 11378))))))
            : (c <= 11381 || (c < 11410
              ? (c < 11400
                ? (c < 11396
                  ? (c < 11394
                    ? (c >= 11390 && c <= 11392)
                    : c <= 11394)
                  : (c <= 11396 || c == 11398))
                : (c <= 11400 || (c < 11406
                  ? (c < 11404
                    ? c == 11402
                    : c <= 11404)
                  : (c <= 11406 || c == 11408))))
              : (c <= 11410 || (c < 11420
                ? (c < 11416
                  ? (c < 11414
                    ? c == 11412
                    : c <= 11414)
                  : (c <= 11416 || c == 11418))
                : (c <= 11420 || (c < 11424
                  ? c == 11422
                  : (c <= 11424 || c == 11426))))))))))))
      : (c <= 11428 || (c < 42796
        ? (c < 42568
          ? (c < 11468
            ? (c < 11448
              ? (c < 11438
                ? (c < 11434
                  ? (c < 11432
                    ? c == 11430
                    : c <= 11432)
                  : (c <= 11434 || c == 11436))
                : (c <= 11438 || (c < 11444
                  ? (c < 11442
                    ? c == 11440
                    : c <= 11442)
                  : (c <= 11444 || c == 11446))))
              : (c <= 11448 || (c < 11458
                ? (c < 11454
                  ? (c < 11452
                    ? c == 11450
                    : c <= 11452)
                  : (c <= 11454 || c == 11456))
                : (c <= 11458 || (c < 11464
                  ? (c < 11462
                    ? c == 11460
                    : c <= 11462)
                  : (c <= 11464 || c == 11466))))))
            : (c <= 11468 || (c < 11488
              ? (c < 11478
                ? (c < 11474
                  ? (c < 11472
                    ? c == 11470
                    : c <= 11472)
                  : (c <= 11474 || c == 11476))
                : (c <= 11478 || (c < 11484
                  ? (c < 11482
                    ? c == 11480
                    : c <= 11482)
                  : (c <= 11484 || c == 11486))))
              : (c <= 11488 || (c < 42560
                ? (c < 11501
                  ? (c < 11499
                    ? c == 11490
                    : c <= 11499)
                  : (c <= 11501 || c == 11506))
                : (c <= 42560 || (c < 42564
                  ? c == 42562
                  : (c <= 42564 || c == 42566))))))))
          : (c <= 42568 || (c < 42624
            ? (c < 42588
              ? (c < 42578
                ? (c < 42574
                  ? (c < 42572
                    ? c == 42570
                    : c <= 42572)
                  : (c <= 42574 || c == 42576))
                : (c <= 42578 || (c < 42584
                  ? (c < 42582
                    ? c == 42580
                    : c <= 42582)
                  : (c <= 42584 || c == 42586))))
              : (c <= 42588 || (c < 42598
                ? (c < 42594
                  ? (c < 42592
                    ? c == 42590
                    : c <= 42592)
                  : (c <= 42594 || c == 42596))
                : (c <= 42598 || (c < 42602
                  ? c == 42600
                  : (c <= 42602 || c == 42604))))))
            : (c <= 42624 || (c < 42644
              ? (c < 42634
                ? (c < 42630
                  ? (c < 42628
                    ? c == 42626
                    : c <= 42628)
                  : (c <= 42630 || c == 42632))
                : (c <= 42634 || (c < 42640
                  ? (c < 42638
                    ? c == 42636
                    : c <= 42638)
                  : (c <= 42640 || c == 42642))))
              : (c <= 42644 || (c < 42788
                ? (c < 42650
                  ? (c < 42648
                    ? c == 42646
                    : c <= 42648)
                  : (c <= 42650 || c == 42786))
                : (c <= 42788 || (c < 42792
                  ? c == 42790
                  : (c <= 42792 || c == 42794))))))))))
        : (c <= 42796 || (c < 42884
          ? (c < 42836
            ? (c < 42818
              ? (c < 42808
                ? (c < 42804
                  ? (c < 42802
                    ? c == 42798
                    : c <= 42802)
                  : (c <= 42804 || c == 42806))
                : (c <= 42808 || (c < 42814
                  ? (c < 42812
                    ? c == 42810
                    : c <= 42812)
                  : (c <= 42814 || c == 42816))))
              : (c <= 42818 || (c < 42828
                ? (c < 42824
                  ? (c < 42822
                    ? c == 42820
                    : c <= 42822)
                  : (c <= 42824 || c == 42826))
                : (c <= 42828 || (c < 42832
                  ? c == 42830
                  : (c <= 42832 || c == 42834))))))
            : (c <= 42836 || (c < 42856
              ? (c < 42846
                ? (c < 42842
                  ? (c < 42840
                    ? c == 42838
                    : c <= 42840)
                  : (c <= 42842 || c == 42844))
                : (c <= 42846 || (c < 42852
                  ? (c < 42850
                    ? c == 42848
                    : c <= 42850)
                  : (c <= 42852 || c == 42854))))
              : (c <= 42856 || (c < 42875
                ? (c < 42862
                  ? (c < 42860
                    ? c == 42858
                    : c <= 42860)
                  : (c <= 42862 || c == 42873))
                : (c <= 42875 || (c < 42880
                  ? (c >= 42877 && c <= 42878)
                  : (c <= 42880 || c == 42882))))))))
          : (c <= 42884 || (c < 42936
            ? (c < 42910
              ? (c < 42898
                ? (c < 42893
                  ? (c < 42891
                    ? c == 42886
                    : c <= 42891)
                  : (c <= 42893 || c == 42896))
                : (c <= 42898 || (c < 42906
                  ? (c < 42904
                    ? c == 42902
                    : c <= 42904)
                  : (c <= 42906 || c == 42908))))
              : (c <= 42910 || (c < 42920
                ? (c < 42916
                  ? (c < 42914
                    ? c == 42912
                    : c <= 42914)
                  : (c <= 42916 || c == 42918))
                : (c <= 42920 || (c < 42928
                  ? (c >= 42922 && c <= 42926)
                  : (c <= 42932 || c == 42934))))))
            : (c <= 42936 || (c < 42968
              ? (c < 42946
                ? (c < 42942
                  ? (c < 42940
                    ? c == 42938
                    : c <= 42940)
                  : (c <= 42942 || c == 42944))
                : (c <= 42946 || (c < 42960
                  ? (c < 42953
                    ? (c >= 42948 && c <= 42951)
                    : c <= 42953)
                  : (c <= 42960 || c == 42966))))
              : (c <= 42968 || (c < 66928
                ? (c < 66560
                  ? (c < 65313
                    ? c == 42997
                    : c <= 65338)
                  : (c <= 66599 || (c >= 66736 && c <= 66771)))
                : (c <= 66938 || (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(54)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(157);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == 't') ADVANCE(115);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(145);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8704) ADVANCE(141);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 9733) ADVANCE(147);
      if (lookahead == 10214) ADVANCE(159);
      if (lookahead == 10215) ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(1)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '-') ADVANCE(125);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == 't') ADVANCE(115);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == 10214) ADVANCE(159);
      if (lookahead == 10215) ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(121);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(2)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(127);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8759) ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(121);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(3)
      if (lookahead == '{') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(3)
      if (lookahead == '{') ADVANCE(19);
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(123);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(6)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '@') ADVANCE(157);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 9733) ADVANCE(147);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(121);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(6)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 9733) ADVANCE(147);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(121);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(28);
      if (lookahead == '"') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '^') ADVANCE(13);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(28);
      if (lookahead == '^') ADVANCE(13);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(99);
      if (lookahead == ' ') ADVANCE(98);
      END_STATE();
    case 10:
      if (lookahead == ' ') ADVANCE(31);
      END_STATE();
    case 11:
      if (lookahead == ' ') ADVANCE(22);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 14:
      if (lookahead == '#') ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(20);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '\'') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(16);
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(73);
      END_STATE();
    case 18:
      if (lookahead == '-') ADVANCE(105);
      END_STATE();
    case 19:
      if (lookahead == '-') ADVANCE(14);
      END_STATE();
    case 20:
      if (lookahead == '-') ADVANCE(42);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(24);
      END_STATE();
    case 22:
      if (lookahead == '-') ADVANCE(27);
      END_STATE();
    case 23:
      if (lookahead == '.') ADVANCE(152);
      END_STATE();
    case 24:
      if (lookahead == '1') ADVANCE(11);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(107);
      END_STATE();
    case 26:
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(158);
      END_STATE();
    case 28:
      if (lookahead == '\\') ADVANCE(12);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(17);
      END_STATE();
    case 30:
      if (lookahead == ']') ADVANCE(160);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(41);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 32:
      if (lookahead == 'g') ADVANCE(38);
      END_STATE();
    case 33:
      if (lookahead == 'g') ADVANCE(154);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 36:
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 37:
      if (lookahead == 'p') ADVANCE(10);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(34);
      END_STATE();
    case 40:
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 41:
      if (lookahead == 'y') ADVANCE(153);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(109);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 43:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(67);
      END_STATE();
    case 44:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(88);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(91);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(66);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(67);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(94);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(95);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      END_STATE();
    case 52:
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(124);
      END_STATE();
    case 53:
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(131);
      END_STATE();
    case 54:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(54)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == 't') ADVANCE(115);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(145);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8704) ADVANCE(141);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 9733) ADVANCE(147);
      if (lookahead == 10214) ADVANCE(159);
      if (lookahead == 10215) ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 55:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(55)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 56:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(56)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(138);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(23);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8704) ADVANCE(141);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 9733) ADVANCE(147);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 57:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(57)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(136);
      if (lookahead == '(') ADVANCE(127);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(23);
      if (lookahead == '0') ADVANCE(84);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8759) ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(85);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 58:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(59)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == 'i') ADVANCE(118);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 59:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(59)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(23);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == 'i') ADVANCE(118);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8658) ADVANCE(100);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 60:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(62)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(157);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 61:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(62)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 62:
      if (eof) ADVANCE(63);
      if (lookahead == '\n') ADVANCE(162);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(62)
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '\'') ADVANCE(137);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == ')') ADVANCE(129);
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '.') ADVANCE(23);
      if (lookahead == '0') ADVANCE(82);
      if (lookahead == ':') ADVANCE(25);
      if (lookahead == ';') ADVANCE(64);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '?') ADVANCE(53);
      if (lookahead == '@') ADVANCE(148);
      if (lookahead == '[') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead == ']') ADVANCE(135);
      if (lookahead == '`') ADVANCE(130);
      if (lookahead == '{') ADVANCE(139);
      if (lookahead == '|') ADVANCE(144);
      if (lookahead == '}') ADVANCE(140);
      if (lookahead == 8592) ADVANCE(104);
      if (lookahead == 8594) ADVANCE(102);
      if (lookahead == 8759) ADVANCE(106);
      if (lookahead == 10214) ADVANCE(159);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(83);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(133);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(121);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(65);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_char);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(74);
      if (lookahead == '\'') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(16);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(69);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(70);
      if (lookahead == '\'') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(16);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(71);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '\'') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(16);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(78);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(12);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '#') ADVANCE(75);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '#') ADVANCE(79);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym__integer_literal);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(86);
      if (lookahead == '.') ADVANCE(47);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(45);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(86);
      if (lookahead == '.') ADVANCE(47);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(86);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(81);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym__binary_literal);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym__binary_literal);
      if (lookahead == '#') ADVANCE(89);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym__binary_literal);
      if (lookahead == '#') ADVANCE(87);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym__octal_literal);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym__octal_literal);
      if (lookahead == '#') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym__octal_literal);
      if (lookahead == '#') ADVANCE(90);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym__hex_literal);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(97);
      if (lookahead == '.') ADVANCE(50);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(97);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(93);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LPAREN_POUND);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LPAREN_POUND_LF);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_u2237);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym__immediate_dot);
      if (lookahead == '.') ADVANCE(152);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_pragma);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym__varid);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == ' ') ADVANCE(32);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == ' ') ADVANCE(21);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'd') ||
          ('f' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'f') ADVANCE(116);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'g') ||
          ('i' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'h') ADVANCE(113);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'h') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'm') ||
          ('o' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'n') ADVANCE(111);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'm') ||
          ('o' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'q') ||
          ('s' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'w') ||
          lookahead == 'y' ||
          lookahead == 'z') ADVANCE(121);
      if (lookahead == 'x') ADVANCE(119);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym__immediate_varid);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym__immediate_varid);
      if (lookahead == '#') ADVANCE(122);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_label);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '#') ADVANCE(9);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_implicit_parid);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym__conid);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym__conid);
      if (lookahead == '#') ADVANCE(132);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead != 0) ADVANCE(17);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(17);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '-') ADVANCE(14);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(152);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ']') ADVANCE(160);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_u2605);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_thengroupby);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_thengroupusing);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_AT2);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_decl_special_fun_fixity);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_u27e6);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACK);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_u27e7);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__token1);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(0)
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'h') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'j') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'q') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'v') ADVANCE(20);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(21);
      if (lookahead == 's') ADVANCE(22);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'c') ADVANCE(24);
      if (lookahead == 'l') ADVANCE(25);
      if (lookahead == 'p') ADVANCE(26);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'i') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(35);
      if (lookahead == 'm') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'v') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(40);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(44);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(45);
      if (lookahead == 'h') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 15:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 'y') ADVANCE(54);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(57);
      END_STATE();
    case 21:
      if (lookahead == 'y') ADVANCE(58);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 23:
      if (lookahead == 'p') ADVANCE(59);
      if (lookahead == 's') ADVANCE(60);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(64);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(70);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(72);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(73);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(74);
      if (lookahead == 's') ADVANCE(75);
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 38:
      if (lookahead == 'm') ADVANCE(77);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(80);
      END_STATE();
    case 42:
      if (lookahead == 'w') ADVANCE(81);
      END_STATE();
    case 43:
      if (lookahead == 'm') ADVANCE(82);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(86);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(87);
      if (lookahead == 'p') ADVANCE(88);
      END_STATE();
    case 50:
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 51:
      if (lookahead == 'f') ADVANCE(90);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(91);
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(97);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(98);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 61:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(102);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(103);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(104);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(105);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 71:
      if (lookahead == 'a') ADVANCE(111);
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 73:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(115);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_jvm);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_mdo);
      END_STATE();
    case 80:
      if (lookahead == 'u') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 85:
      if (lookahead == 'm') ADVANCE(123);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(124);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_rec);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 91:
      if (lookahead == 'c') ADVANCE(128);
      END_STATE();
    case 92:
      if (lookahead == 'c') ADVANCE(129);
      END_STATE();
    case 93:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(132);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(133);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_via);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_capi);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == 's') ADVANCE(135);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 102:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 105:
      if (lookahead == 'u') ADVANCE(139);
      END_STATE();
    case 106:
      if (lookahead == 'v') ADVANCE(140);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(142);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(144);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(145);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(146);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(147);
      END_STATE();
    case 115:
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 117:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 119:
      if (lookahead == 'y') ADVANCE(152);
      END_STATE();
    case 120:
      if (lookahead == 'n') ADVANCE(153);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_prim);
      END_STATE();
    case 124:
      if (lookahead == 'i') ADVANCE(156);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_role);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_safe);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(158);
      END_STATE();
    case 129:
      if (lookahead == 'k') ADVANCE(159);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 132:
      if (lookahead == 'f') ADVANCE(160);
      END_STATE();
    case 133:
      if (lookahead == 'g') ADVANCE(161);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(162);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_cases);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_ccall);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 138:
      if (lookahead == 'p') ADVANCE(163);
      END_STATE();
    case 139:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 141:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 143:
      if (lookahead == 'y') ADVANCE(168);
      END_STATE();
    case 144:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 145:
      if (lookahead == 'g') ADVANCE(170);
      END_STATE();
    case 146:
      if (lookahead == 'g') ADVANCE(171);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_infix);
      if (lookahead == 'l') ADVANCE(173);
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(175);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 152:
      if (lookahead == 'p') ADVANCE(178);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(179);
      END_STATE();
    case 154:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 155:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 156:
      if (lookahead == 'f') ADVANCE(182);
      END_STATE();
    case 157:
      if (lookahead == 's') ADVANCE(183);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(184);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_stock);
      END_STATE();
    case 160:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 162:
      if (lookahead == 's') ADVANCE(186);
      END_STATE();
    case 163:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 164:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(189);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_dotnet);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_family);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(190);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_hiding);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_infixl);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_infixr);
      END_STATE();
    case 175:
      if (lookahead == 'c') ADVANCE(191);
      END_STATE();
    case 176:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 179:
      if (lookahead == 'l') ADVANCE(194);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 181:
      if (lookahead == 'm') ADVANCE(196);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(199);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 186:
      if (lookahead == 's') ADVANCE(200);
      END_STATE();
    case 187:
      if (lookahead == 'u') ADVANCE(201);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 189:
      if (lookahead == 'g') ADVANCE(202);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_foreign);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 192:
      if (lookahead == 'p') ADVANCE(204);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_newtype);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_nominal);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_phantom);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 198:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_stdcall);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_anyclass);
      END_STATE();
    case 201:
      if (lookahead == 's') ADVANCE(207);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_deriving);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_instance);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 205:
      if (lookahead == 'd') ADVANCE(209);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_cplusplus);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(211);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_qualified);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(212);
      END_STATE();
    case 211:
      if (lookahead == 'b') ADVANCE(213);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 213:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 214:
      if (lookahead == 'i') ADVANCE(216);
      END_STATE();
    case 215:
      if (lookahead == 'e') ADVANCE(217);
      END_STATE();
    case 216:
      if (lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_interruptible);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(219);
      END_STATE();
    case 219:
      if (lookahead == 'a') ADVANCE(220);
      END_STATE();
    case 220:
      if (lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_representational);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 58, .external_lex_state = 2},
  [2] = {.lex_state = 58, .external_lex_state = 3},
  [3] = {.lex_state = 58, .external_lex_state = 3},
  [4] = {.lex_state = 58, .external_lex_state = 3},
  [5] = {.lex_state = 58, .external_lex_state = 3},
  [6] = {.lex_state = 58, .external_lex_state = 3},
  [7] = {.lex_state = 58, .external_lex_state = 4},
  [8] = {.lex_state = 58, .external_lex_state = 3},
  [9] = {.lex_state = 58, .external_lex_state = 4},
  [10] = {.lex_state = 58, .external_lex_state = 4},
  [11] = {.lex_state = 58, .external_lex_state = 3},
  [12] = {.lex_state = 58, .external_lex_state = 4},
  [13] = {.lex_state = 58, .external_lex_state = 4},
  [14] = {.lex_state = 58, .external_lex_state = 3},
  [15] = {.lex_state = 58, .external_lex_state = 3},
  [16] = {.lex_state = 55, .external_lex_state = 5},
  [17] = {.lex_state = 55, .external_lex_state = 5},
  [18] = {.lex_state = 55, .external_lex_state = 5},
  [19] = {.lex_state = 55, .external_lex_state = 5},
  [20] = {.lex_state = 55, .external_lex_state = 5},
  [21] = {.lex_state = 55, .external_lex_state = 5},
  [22] = {.lex_state = 55, .external_lex_state = 5},
  [23] = {.lex_state = 55, .external_lex_state = 5},
  [24] = {.lex_state = 55, .external_lex_state = 5},
  [25] = {.lex_state = 55, .external_lex_state = 5},
  [26] = {.lex_state = 55, .external_lex_state = 5},
  [27] = {.lex_state = 55, .external_lex_state = 5},
  [28] = {.lex_state = 55, .external_lex_state = 5},
  [29] = {.lex_state = 55, .external_lex_state = 5},
  [30] = {.lex_state = 55, .external_lex_state = 5},
  [31] = {.lex_state = 55, .external_lex_state = 5},
  [32] = {.lex_state = 55, .external_lex_state = 5},
  [33] = {.lex_state = 55, .external_lex_state = 5},
  [34] = {.lex_state = 55, .external_lex_state = 5},
  [35] = {.lex_state = 55, .external_lex_state = 5},
  [36] = {.lex_state = 55, .external_lex_state = 5},
  [37] = {.lex_state = 55, .external_lex_state = 5},
  [38] = {.lex_state = 55, .external_lex_state = 5},
  [39] = {.lex_state = 55, .external_lex_state = 5},
  [40] = {.lex_state = 55, .external_lex_state = 5},
  [41] = {.lex_state = 55, .external_lex_state = 5},
  [42] = {.lex_state = 55, .external_lex_state = 5},
  [43] = {.lex_state = 55, .external_lex_state = 5},
  [44] = {.lex_state = 55, .external_lex_state = 5},
  [45] = {.lex_state = 55, .external_lex_state = 5},
  [46] = {.lex_state = 55, .external_lex_state = 5},
  [47] = {.lex_state = 55, .external_lex_state = 5},
  [48] = {.lex_state = 55, .external_lex_state = 5},
  [49] = {.lex_state = 55, .external_lex_state = 5},
  [50] = {.lex_state = 55, .external_lex_state = 5},
  [51] = {.lex_state = 55, .external_lex_state = 5},
  [52] = {.lex_state = 55, .external_lex_state = 5},
  [53] = {.lex_state = 55, .external_lex_state = 5},
  [54] = {.lex_state = 55, .external_lex_state = 5},
  [55] = {.lex_state = 55, .external_lex_state = 5},
  [56] = {.lex_state = 55, .external_lex_state = 5},
  [57] = {.lex_state = 55, .external_lex_state = 5},
  [58] = {.lex_state = 55, .external_lex_state = 5},
  [59] = {.lex_state = 55, .external_lex_state = 5},
  [60] = {.lex_state = 55, .external_lex_state = 5},
  [61] = {.lex_state = 55, .external_lex_state = 5},
  [62] = {.lex_state = 55, .external_lex_state = 5},
  [63] = {.lex_state = 55, .external_lex_state = 5},
  [64] = {.lex_state = 55, .external_lex_state = 5},
  [65] = {.lex_state = 55, .external_lex_state = 5},
  [66] = {.lex_state = 55, .external_lex_state = 5},
  [67] = {.lex_state = 55, .external_lex_state = 5},
  [68] = {.lex_state = 55, .external_lex_state = 5},
  [69] = {.lex_state = 55, .external_lex_state = 5},
  [70] = {.lex_state = 55, .external_lex_state = 5},
  [71] = {.lex_state = 55, .external_lex_state = 5},
  [72] = {.lex_state = 55, .external_lex_state = 5},
  [73] = {.lex_state = 55, .external_lex_state = 5},
  [74] = {.lex_state = 55, .external_lex_state = 5},
  [75] = {.lex_state = 55, .external_lex_state = 5},
  [76] = {.lex_state = 55, .external_lex_state = 5},
  [77] = {.lex_state = 55, .external_lex_state = 5},
  [78] = {.lex_state = 55, .external_lex_state = 5},
  [79] = {.lex_state = 55, .external_lex_state = 5},
  [80] = {.lex_state = 55, .external_lex_state = 5},
  [81] = {.lex_state = 55, .external_lex_state = 5},
  [82] = {.lex_state = 55, .external_lex_state = 5},
  [83] = {.lex_state = 55, .external_lex_state = 5},
  [84] = {.lex_state = 55, .external_lex_state = 5},
  [85] = {.lex_state = 55, .external_lex_state = 5},
  [86] = {.lex_state = 55, .external_lex_state = 5},
  [87] = {.lex_state = 55, .external_lex_state = 5},
  [88] = {.lex_state = 55, .external_lex_state = 5},
  [89] = {.lex_state = 55, .external_lex_state = 5},
  [90] = {.lex_state = 55, .external_lex_state = 5},
  [91] = {.lex_state = 55, .external_lex_state = 5},
  [92] = {.lex_state = 55, .external_lex_state = 5},
  [93] = {.lex_state = 55, .external_lex_state = 5},
  [94] = {.lex_state = 55, .external_lex_state = 6},
  [95] = {.lex_state = 55, .external_lex_state = 6},
  [96] = {.lex_state = 55, .external_lex_state = 6},
  [97] = {.lex_state = 55, .external_lex_state = 6},
  [98] = {.lex_state = 55, .external_lex_state = 6},
  [99] = {.lex_state = 55, .external_lex_state = 6},
  [100] = {.lex_state = 55, .external_lex_state = 6},
  [101] = {.lex_state = 55, .external_lex_state = 6},
  [102] = {.lex_state = 55, .external_lex_state = 6},
  [103] = {.lex_state = 55, .external_lex_state = 6},
  [104] = {.lex_state = 55, .external_lex_state = 6},
  [105] = {.lex_state = 55, .external_lex_state = 6},
  [106] = {.lex_state = 55, .external_lex_state = 6},
  [107] = {.lex_state = 55, .external_lex_state = 6},
  [108] = {.lex_state = 55, .external_lex_state = 6},
  [109] = {.lex_state = 55, .external_lex_state = 6},
  [110] = {.lex_state = 55, .external_lex_state = 6},
  [111] = {.lex_state = 55, .external_lex_state = 6},
  [112] = {.lex_state = 55, .external_lex_state = 6},
  [113] = {.lex_state = 55, .external_lex_state = 6},
  [114] = {.lex_state = 55, .external_lex_state = 6},
  [115] = {.lex_state = 55, .external_lex_state = 6},
  [116] = {.lex_state = 55, .external_lex_state = 6},
  [117] = {.lex_state = 55, .external_lex_state = 6},
  [118] = {.lex_state = 55, .external_lex_state = 6},
  [119] = {.lex_state = 55, .external_lex_state = 6},
  [120] = {.lex_state = 55, .external_lex_state = 6},
  [121] = {.lex_state = 55, .external_lex_state = 6},
  [122] = {.lex_state = 55, .external_lex_state = 3},
  [123] = {.lex_state = 55, .external_lex_state = 3},
  [124] = {.lex_state = 55, .external_lex_state = 3},
  [125] = {.lex_state = 55, .external_lex_state = 3},
  [126] = {.lex_state = 55, .external_lex_state = 3},
  [127] = {.lex_state = 55, .external_lex_state = 3},
  [128] = {.lex_state = 55, .external_lex_state = 3},
  [129] = {.lex_state = 55, .external_lex_state = 3},
  [130] = {.lex_state = 55, .external_lex_state = 3},
  [131] = {.lex_state = 55, .external_lex_state = 3},
  [132] = {.lex_state = 55, .external_lex_state = 3},
  [133] = {.lex_state = 55, .external_lex_state = 3},
  [134] = {.lex_state = 55, .external_lex_state = 3},
  [135] = {.lex_state = 55, .external_lex_state = 3},
  [136] = {.lex_state = 55, .external_lex_state = 3},
  [137] = {.lex_state = 55, .external_lex_state = 3},
  [138] = {.lex_state = 55, .external_lex_state = 3},
  [139] = {.lex_state = 55, .external_lex_state = 3},
  [140] = {.lex_state = 55, .external_lex_state = 3},
  [141] = {.lex_state = 55, .external_lex_state = 3},
  [142] = {.lex_state = 55, .external_lex_state = 3},
  [143] = {.lex_state = 55, .external_lex_state = 3},
  [144] = {.lex_state = 55, .external_lex_state = 3},
  [145] = {.lex_state = 55, .external_lex_state = 3},
  [146] = {.lex_state = 55, .external_lex_state = 3},
  [147] = {.lex_state = 55, .external_lex_state = 3},
  [148] = {.lex_state = 55, .external_lex_state = 3},
  [149] = {.lex_state = 55, .external_lex_state = 3},
  [150] = {.lex_state = 55, .external_lex_state = 3},
  [151] = {.lex_state = 55, .external_lex_state = 3},
  [152] = {.lex_state = 55, .external_lex_state = 3},
  [153] = {.lex_state = 55, .external_lex_state = 3},
  [154] = {.lex_state = 55, .external_lex_state = 3},
  [155] = {.lex_state = 55, .external_lex_state = 3},
  [156] = {.lex_state = 55, .external_lex_state = 3},
  [157] = {.lex_state = 55, .external_lex_state = 3},
  [158] = {.lex_state = 55, .external_lex_state = 3},
  [159] = {.lex_state = 55, .external_lex_state = 3},
  [160] = {.lex_state = 55, .external_lex_state = 3},
  [161] = {.lex_state = 55, .external_lex_state = 3},
  [162] = {.lex_state = 1, .external_lex_state = 3},
  [163] = {.lex_state = 55, .external_lex_state = 3},
  [164] = {.lex_state = 55, .external_lex_state = 3},
  [165] = {.lex_state = 55, .external_lex_state = 3},
  [166] = {.lex_state = 55, .external_lex_state = 3},
  [167] = {.lex_state = 55, .external_lex_state = 3},
  [168] = {.lex_state = 55, .external_lex_state = 3},
  [169] = {.lex_state = 55, .external_lex_state = 3},
  [170] = {.lex_state = 55, .external_lex_state = 3},
  [171] = {.lex_state = 55, .external_lex_state = 3},
  [172] = {.lex_state = 55, .external_lex_state = 3},
  [173] = {.lex_state = 55, .external_lex_state = 3},
  [174] = {.lex_state = 55, .external_lex_state = 3},
  [175] = {.lex_state = 55, .external_lex_state = 3},
  [176] = {.lex_state = 55, .external_lex_state = 3},
  [177] = {.lex_state = 55, .external_lex_state = 3},
  [178] = {.lex_state = 55, .external_lex_state = 3},
  [179] = {.lex_state = 55, .external_lex_state = 3},
  [180] = {.lex_state = 55, .external_lex_state = 3},
  [181] = {.lex_state = 55, .external_lex_state = 3},
  [182] = {.lex_state = 55, .external_lex_state = 3},
  [183] = {.lex_state = 55, .external_lex_state = 3},
  [184] = {.lex_state = 55, .external_lex_state = 3},
  [185] = {.lex_state = 55, .external_lex_state = 3},
  [186] = {.lex_state = 55, .external_lex_state = 3},
  [187] = {.lex_state = 55, .external_lex_state = 3},
  [188] = {.lex_state = 55, .external_lex_state = 3},
  [189] = {.lex_state = 55, .external_lex_state = 3},
  [190] = {.lex_state = 55, .external_lex_state = 3},
  [191] = {.lex_state = 55, .external_lex_state = 3},
  [192] = {.lex_state = 1, .external_lex_state = 3},
  [193] = {.lex_state = 55, .external_lex_state = 3},
  [194] = {.lex_state = 55, .external_lex_state = 3},
  [195] = {.lex_state = 55, .external_lex_state = 3},
  [196] = {.lex_state = 55, .external_lex_state = 3},
  [197] = {.lex_state = 55, .external_lex_state = 3},
  [198] = {.lex_state = 55, .external_lex_state = 3},
  [199] = {.lex_state = 1, .external_lex_state = 3},
  [200] = {.lex_state = 55, .external_lex_state = 3},
  [201] = {.lex_state = 55, .external_lex_state = 3},
  [202] = {.lex_state = 55, .external_lex_state = 3},
  [203] = {.lex_state = 55, .external_lex_state = 3},
  [204] = {.lex_state = 55, .external_lex_state = 3},
  [205] = {.lex_state = 55, .external_lex_state = 3},
  [206] = {.lex_state = 55, .external_lex_state = 3},
  [207] = {.lex_state = 55, .external_lex_state = 3},
  [208] = {.lex_state = 55, .external_lex_state = 3},
  [209] = {.lex_state = 55, .external_lex_state = 3},
  [210] = {.lex_state = 55, .external_lex_state = 3},
  [211] = {.lex_state = 55, .external_lex_state = 3},
  [212] = {.lex_state = 55, .external_lex_state = 3},
  [213] = {.lex_state = 55, .external_lex_state = 3},
  [214] = {.lex_state = 55, .external_lex_state = 3},
  [215] = {.lex_state = 55, .external_lex_state = 3},
  [216] = {.lex_state = 55, .external_lex_state = 3},
  [217] = {.lex_state = 1, .external_lex_state = 3},
  [218] = {.lex_state = 55, .external_lex_state = 3},
  [219] = {.lex_state = 1, .external_lex_state = 3},
  [220] = {.lex_state = 1, .external_lex_state = 3},
  [221] = {.lex_state = 55, .external_lex_state = 3},
  [222] = {.lex_state = 1, .external_lex_state = 3},
  [223] = {.lex_state = 1, .external_lex_state = 3},
  [224] = {.lex_state = 1, .external_lex_state = 3},
  [225] = {.lex_state = 1, .external_lex_state = 3},
  [226] = {.lex_state = 1, .external_lex_state = 3},
  [227] = {.lex_state = 1, .external_lex_state = 3},
  [228] = {.lex_state = 55, .external_lex_state = 3},
  [229] = {.lex_state = 1, .external_lex_state = 3},
  [230] = {.lex_state = 1, .external_lex_state = 3},
  [231] = {.lex_state = 1, .external_lex_state = 3},
  [232] = {.lex_state = 1, .external_lex_state = 3},
  [233] = {.lex_state = 55, .external_lex_state = 3},
  [234] = {.lex_state = 1, .external_lex_state = 3},
  [235] = {.lex_state = 1, .external_lex_state = 3},
  [236] = {.lex_state = 1, .external_lex_state = 3},
  [237] = {.lex_state = 1, .external_lex_state = 3},
  [238] = {.lex_state = 1, .external_lex_state = 3},
  [239] = {.lex_state = 1, .external_lex_state = 3},
  [240] = {.lex_state = 1, .external_lex_state = 3},
  [241] = {.lex_state = 1, .external_lex_state = 3},
  [242] = {.lex_state = 1, .external_lex_state = 3},
  [243] = {.lex_state = 1, .external_lex_state = 3},
  [244] = {.lex_state = 1, .external_lex_state = 3},
  [245] = {.lex_state = 55, .external_lex_state = 3},
  [246] = {.lex_state = 1, .external_lex_state = 3},
  [247] = {.lex_state = 1, .external_lex_state = 3},
  [248] = {.lex_state = 1, .external_lex_state = 3},
  [249] = {.lex_state = 1, .external_lex_state = 3},
  [250] = {.lex_state = 1, .external_lex_state = 3},
  [251] = {.lex_state = 1, .external_lex_state = 3},
  [252] = {.lex_state = 1, .external_lex_state = 3},
  [253] = {.lex_state = 1, .external_lex_state = 3},
  [254] = {.lex_state = 1, .external_lex_state = 3},
  [255] = {.lex_state = 1, .external_lex_state = 3},
  [256] = {.lex_state = 1, .external_lex_state = 3},
  [257] = {.lex_state = 1, .external_lex_state = 3},
  [258] = {.lex_state = 1, .external_lex_state = 3},
  [259] = {.lex_state = 1, .external_lex_state = 3},
  [260] = {.lex_state = 1, .external_lex_state = 3},
  [261] = {.lex_state = 1, .external_lex_state = 3},
  [262] = {.lex_state = 1, .external_lex_state = 3},
  [263] = {.lex_state = 1, .external_lex_state = 3},
  [264] = {.lex_state = 1, .external_lex_state = 3},
  [265] = {.lex_state = 1, .external_lex_state = 3},
  [266] = {.lex_state = 55, .external_lex_state = 4},
  [267] = {.lex_state = 55, .external_lex_state = 4},
  [268] = {.lex_state = 55, .external_lex_state = 4},
  [269] = {.lex_state = 55, .external_lex_state = 4},
  [270] = {.lex_state = 55, .external_lex_state = 4},
  [271] = {.lex_state = 55, .external_lex_state = 4},
  [272] = {.lex_state = 55, .external_lex_state = 4},
  [273] = {.lex_state = 55, .external_lex_state = 4},
  [274] = {.lex_state = 55, .external_lex_state = 4},
  [275] = {.lex_state = 55, .external_lex_state = 4},
  [276] = {.lex_state = 55, .external_lex_state = 4},
  [277] = {.lex_state = 55, .external_lex_state = 4},
  [278] = {.lex_state = 55, .external_lex_state = 4},
  [279] = {.lex_state = 55, .external_lex_state = 4},
  [280] = {.lex_state = 55, .external_lex_state = 7},
  [281] = {.lex_state = 55, .external_lex_state = 4},
  [282] = {.lex_state = 55, .external_lex_state = 7},
  [283] = {.lex_state = 55, .external_lex_state = 4},
  [284] = {.lex_state = 55, .external_lex_state = 4},
  [285] = {.lex_state = 55, .external_lex_state = 4},
  [286] = {.lex_state = 55, .external_lex_state = 4},
  [287] = {.lex_state = 55, .external_lex_state = 4},
  [288] = {.lex_state = 55, .external_lex_state = 4},
  [289] = {.lex_state = 55, .external_lex_state = 4},
  [290] = {.lex_state = 55, .external_lex_state = 4},
  [291] = {.lex_state = 55, .external_lex_state = 4},
  [292] = {.lex_state = 55, .external_lex_state = 4},
  [293] = {.lex_state = 55, .external_lex_state = 4},
  [294] = {.lex_state = 55, .external_lex_state = 4},
  [295] = {.lex_state = 55, .external_lex_state = 4},
  [296] = {.lex_state = 55, .external_lex_state = 4},
  [297] = {.lex_state = 55, .external_lex_state = 4},
  [298] = {.lex_state = 55, .external_lex_state = 4},
  [299] = {.lex_state = 55, .external_lex_state = 4},
  [300] = {.lex_state = 55, .external_lex_state = 4},
  [301] = {.lex_state = 55, .external_lex_state = 4},
  [302] = {.lex_state = 55, .external_lex_state = 7},
  [303] = {.lex_state = 55, .external_lex_state = 4},
  [304] = {.lex_state = 55, .external_lex_state = 4},
  [305] = {.lex_state = 55, .external_lex_state = 4},
  [306] = {.lex_state = 55, .external_lex_state = 4},
  [307] = {.lex_state = 55, .external_lex_state = 4},
  [308] = {.lex_state = 55, .external_lex_state = 4},
  [309] = {.lex_state = 55, .external_lex_state = 4},
  [310] = {.lex_state = 55, .external_lex_state = 4},
  [311] = {.lex_state = 55, .external_lex_state = 7},
  [312] = {.lex_state = 55, .external_lex_state = 7},
  [313] = {.lex_state = 55, .external_lex_state = 4},
  [314] = {.lex_state = 55, .external_lex_state = 7},
  [315] = {.lex_state = 55, .external_lex_state = 4},
  [316] = {.lex_state = 55, .external_lex_state = 4},
  [317] = {.lex_state = 55, .external_lex_state = 4},
  [318] = {.lex_state = 55, .external_lex_state = 4},
  [319] = {.lex_state = 55, .external_lex_state = 4},
  [320] = {.lex_state = 55, .external_lex_state = 7},
  [321] = {.lex_state = 55, .external_lex_state = 4},
  [322] = {.lex_state = 55, .external_lex_state = 4},
  [323] = {.lex_state = 55, .external_lex_state = 4},
  [324] = {.lex_state = 55, .external_lex_state = 4},
  [325] = {.lex_state = 55, .external_lex_state = 4},
  [326] = {.lex_state = 55, .external_lex_state = 4},
  [327] = {.lex_state = 55, .external_lex_state = 4},
  [328] = {.lex_state = 55, .external_lex_state = 4},
  [329] = {.lex_state = 55, .external_lex_state = 4},
  [330] = {.lex_state = 55, .external_lex_state = 4},
  [331] = {.lex_state = 55, .external_lex_state = 4},
  [332] = {.lex_state = 55, .external_lex_state = 4},
  [333] = {.lex_state = 55, .external_lex_state = 4},
  [334] = {.lex_state = 55, .external_lex_state = 7},
  [335] = {.lex_state = 55, .external_lex_state = 4},
  [336] = {.lex_state = 55, .external_lex_state = 7},
  [337] = {.lex_state = 55, .external_lex_state = 4},
  [338] = {.lex_state = 55, .external_lex_state = 4},
  [339] = {.lex_state = 55, .external_lex_state = 4},
  [340] = {.lex_state = 55, .external_lex_state = 7},
  [341] = {.lex_state = 55, .external_lex_state = 4},
  [342] = {.lex_state = 55, .external_lex_state = 4},
  [343] = {.lex_state = 55, .external_lex_state = 4},
  [344] = {.lex_state = 55, .external_lex_state = 4},
  [345] = {.lex_state = 55, .external_lex_state = 4},
  [346] = {.lex_state = 55, .external_lex_state = 4},
  [347] = {.lex_state = 55, .external_lex_state = 4},
  [348] = {.lex_state = 55, .external_lex_state = 4},
  [349] = {.lex_state = 55, .external_lex_state = 4},
  [350] = {.lex_state = 55, .external_lex_state = 4},
  [351] = {.lex_state = 55, .external_lex_state = 4},
  [352] = {.lex_state = 55, .external_lex_state = 4},
  [353] = {.lex_state = 55, .external_lex_state = 7},
  [354] = {.lex_state = 55, .external_lex_state = 4},
  [355] = {.lex_state = 55, .external_lex_state = 7},
  [356] = {.lex_state = 55, .external_lex_state = 4},
  [357] = {.lex_state = 55, .external_lex_state = 7},
  [358] = {.lex_state = 55, .external_lex_state = 4},
  [359] = {.lex_state = 55, .external_lex_state = 4},
  [360] = {.lex_state = 55, .external_lex_state = 4},
  [361] = {.lex_state = 55, .external_lex_state = 4},
  [362] = {.lex_state = 55, .external_lex_state = 4},
  [363] = {.lex_state = 55, .external_lex_state = 4},
  [364] = {.lex_state = 55, .external_lex_state = 4},
  [365] = {.lex_state = 55, .external_lex_state = 4},
  [366] = {.lex_state = 55, .external_lex_state = 4},
  [367] = {.lex_state = 55, .external_lex_state = 7},
  [368] = {.lex_state = 55, .external_lex_state = 4},
  [369] = {.lex_state = 55, .external_lex_state = 4},
  [370] = {.lex_state = 55, .external_lex_state = 4},
  [371] = {.lex_state = 55, .external_lex_state = 4},
  [372] = {.lex_state = 55, .external_lex_state = 7},
  [373] = {.lex_state = 55, .external_lex_state = 4},
  [374] = {.lex_state = 55, .external_lex_state = 4},
  [375] = {.lex_state = 55, .external_lex_state = 4},
  [376] = {.lex_state = 55, .external_lex_state = 4},
  [377] = {.lex_state = 55, .external_lex_state = 4},
  [378] = {.lex_state = 55, .external_lex_state = 4},
  [379] = {.lex_state = 55, .external_lex_state = 4},
  [380] = {.lex_state = 55, .external_lex_state = 4},
  [381] = {.lex_state = 55, .external_lex_state = 4},
  [382] = {.lex_state = 55, .external_lex_state = 7},
  [383] = {.lex_state = 55, .external_lex_state = 4},
  [384] = {.lex_state = 55, .external_lex_state = 7},
  [385] = {.lex_state = 55, .external_lex_state = 4},
  [386] = {.lex_state = 55, .external_lex_state = 4},
  [387] = {.lex_state = 55, .external_lex_state = 7},
  [388] = {.lex_state = 55, .external_lex_state = 4},
  [389] = {.lex_state = 55, .external_lex_state = 7},
  [390] = {.lex_state = 55, .external_lex_state = 4},
  [391] = {.lex_state = 55, .external_lex_state = 4},
  [392] = {.lex_state = 55, .external_lex_state = 4},
  [393] = {.lex_state = 55, .external_lex_state = 4},
  [394] = {.lex_state = 55, .external_lex_state = 4},
  [395] = {.lex_state = 55, .external_lex_state = 4},
  [396] = {.lex_state = 55, .external_lex_state = 4},
  [397] = {.lex_state = 55, .external_lex_state = 7},
  [398] = {.lex_state = 55, .external_lex_state = 4},
  [399] = {.lex_state = 55, .external_lex_state = 4},
  [400] = {.lex_state = 55, .external_lex_state = 4},
  [401] = {.lex_state = 55, .external_lex_state = 4},
  [402] = {.lex_state = 55, .external_lex_state = 7},
  [403] = {.lex_state = 55, .external_lex_state = 7},
  [404] = {.lex_state = 55, .external_lex_state = 4},
  [405] = {.lex_state = 55, .external_lex_state = 4},
  [406] = {.lex_state = 55, .external_lex_state = 4},
  [407] = {.lex_state = 55, .external_lex_state = 7},
  [408] = {.lex_state = 55, .external_lex_state = 4},
  [409] = {.lex_state = 55, .external_lex_state = 4},
  [410] = {.lex_state = 55, .external_lex_state = 4},
  [411] = {.lex_state = 55, .external_lex_state = 4},
  [412] = {.lex_state = 55, .external_lex_state = 4},
  [413] = {.lex_state = 55, .external_lex_state = 4},
  [414] = {.lex_state = 55, .external_lex_state = 4},
  [415] = {.lex_state = 55, .external_lex_state = 4},
  [416] = {.lex_state = 55, .external_lex_state = 7},
  [417] = {.lex_state = 55, .external_lex_state = 7},
  [418] = {.lex_state = 55, .external_lex_state = 7},
  [419] = {.lex_state = 55, .external_lex_state = 4},
  [420] = {.lex_state = 55, .external_lex_state = 4},
  [421] = {.lex_state = 55, .external_lex_state = 4},
  [422] = {.lex_state = 55, .external_lex_state = 4},
  [423] = {.lex_state = 55, .external_lex_state = 4},
  [424] = {.lex_state = 55, .external_lex_state = 4},
  [425] = {.lex_state = 55, .external_lex_state = 4},
  [426] = {.lex_state = 55, .external_lex_state = 4},
  [427] = {.lex_state = 55, .external_lex_state = 4},
  [428] = {.lex_state = 55, .external_lex_state = 4},
  [429] = {.lex_state = 55, .external_lex_state = 4},
  [430] = {.lex_state = 55, .external_lex_state = 4},
  [431] = {.lex_state = 55, .external_lex_state = 7},
  [432] = {.lex_state = 55, .external_lex_state = 4},
  [433] = {.lex_state = 55, .external_lex_state = 4},
  [434] = {.lex_state = 55, .external_lex_state = 4},
  [435] = {.lex_state = 55, .external_lex_state = 7},
  [436] = {.lex_state = 55, .external_lex_state = 4},
  [437] = {.lex_state = 55, .external_lex_state = 4},
  [438] = {.lex_state = 55, .external_lex_state = 3},
  [439] = {.lex_state = 55, .external_lex_state = 7},
  [440] = {.lex_state = 55, .external_lex_state = 7},
  [441] = {.lex_state = 55, .external_lex_state = 3},
  [442] = {.lex_state = 55, .external_lex_state = 3},
  [443] = {.lex_state = 55, .external_lex_state = 3},
  [444] = {.lex_state = 55, .external_lex_state = 3},
  [445] = {.lex_state = 55, .external_lex_state = 3},
  [446] = {.lex_state = 55, .external_lex_state = 3},
  [447] = {.lex_state = 55, .external_lex_state = 3},
  [448] = {.lex_state = 55, .external_lex_state = 3},
  [449] = {.lex_state = 55, .external_lex_state = 3},
  [450] = {.lex_state = 55, .external_lex_state = 3},
  [451] = {.lex_state = 55, .external_lex_state = 3},
  [452] = {.lex_state = 55, .external_lex_state = 3},
  [453] = {.lex_state = 55, .external_lex_state = 3},
  [454] = {.lex_state = 55, .external_lex_state = 3},
  [455] = {.lex_state = 55, .external_lex_state = 3},
  [456] = {.lex_state = 55, .external_lex_state = 3},
  [457] = {.lex_state = 55, .external_lex_state = 3},
  [458] = {.lex_state = 55, .external_lex_state = 3},
  [459] = {.lex_state = 55, .external_lex_state = 3},
  [460] = {.lex_state = 55, .external_lex_state = 3},
  [461] = {.lex_state = 55, .external_lex_state = 3},
  [462] = {.lex_state = 55, .external_lex_state = 3},
  [463] = {.lex_state = 55, .external_lex_state = 3},
  [464] = {.lex_state = 55, .external_lex_state = 3},
  [465] = {.lex_state = 55, .external_lex_state = 3},
  [466] = {.lex_state = 55, .external_lex_state = 3},
  [467] = {.lex_state = 55, .external_lex_state = 3},
  [468] = {.lex_state = 55, .external_lex_state = 3},
  [469] = {.lex_state = 55, .external_lex_state = 3},
  [470] = {.lex_state = 55, .external_lex_state = 3},
  [471] = {.lex_state = 55, .external_lex_state = 3},
  [472] = {.lex_state = 55, .external_lex_state = 3},
  [473] = {.lex_state = 55, .external_lex_state = 3},
  [474] = {.lex_state = 55, .external_lex_state = 3},
  [475] = {.lex_state = 55, .external_lex_state = 3},
  [476] = {.lex_state = 55, .external_lex_state = 3},
  [477] = {.lex_state = 55, .external_lex_state = 3},
  [478] = {.lex_state = 55, .external_lex_state = 3},
  [479] = {.lex_state = 55, .external_lex_state = 3},
  [480] = {.lex_state = 55, .external_lex_state = 3},
  [481] = {.lex_state = 55, .external_lex_state = 3},
  [482] = {.lex_state = 55, .external_lex_state = 3},
  [483] = {.lex_state = 55, .external_lex_state = 3},
  [484] = {.lex_state = 55, .external_lex_state = 3},
  [485] = {.lex_state = 55, .external_lex_state = 3},
  [486] = {.lex_state = 55, .external_lex_state = 3},
  [487] = {.lex_state = 55, .external_lex_state = 3},
  [488] = {.lex_state = 55, .external_lex_state = 3},
  [489] = {.lex_state = 55, .external_lex_state = 3},
  [490] = {.lex_state = 55, .external_lex_state = 3},
  [491] = {.lex_state = 55, .external_lex_state = 3},
  [492] = {.lex_state = 55, .external_lex_state = 3},
  [493] = {.lex_state = 55, .external_lex_state = 3},
  [494] = {.lex_state = 55, .external_lex_state = 3},
  [495] = {.lex_state = 55, .external_lex_state = 3},
  [496] = {.lex_state = 55, .external_lex_state = 3},
  [497] = {.lex_state = 55, .external_lex_state = 3},
  [498] = {.lex_state = 55, .external_lex_state = 3},
  [499] = {.lex_state = 55, .external_lex_state = 3},
  [500] = {.lex_state = 55, .external_lex_state = 3},
  [501] = {.lex_state = 55, .external_lex_state = 3},
  [502] = {.lex_state = 55, .external_lex_state = 3},
  [503] = {.lex_state = 55, .external_lex_state = 3},
  [504] = {.lex_state = 55, .external_lex_state = 3},
  [505] = {.lex_state = 55, .external_lex_state = 3},
  [506] = {.lex_state = 55, .external_lex_state = 3},
  [507] = {.lex_state = 55, .external_lex_state = 8},
  [508] = {.lex_state = 55, .external_lex_state = 8},
  [509] = {.lex_state = 55, .external_lex_state = 8},
  [510] = {.lex_state = 55, .external_lex_state = 8},
  [511] = {.lex_state = 55, .external_lex_state = 8},
  [512] = {.lex_state = 55, .external_lex_state = 8},
  [513] = {.lex_state = 55, .external_lex_state = 8},
  [514] = {.lex_state = 55, .external_lex_state = 8},
  [515] = {.lex_state = 55, .external_lex_state = 8},
  [516] = {.lex_state = 55, .external_lex_state = 8},
  [517] = {.lex_state = 55, .external_lex_state = 8},
  [518] = {.lex_state = 55, .external_lex_state = 8},
  [519] = {.lex_state = 55, .external_lex_state = 8},
  [520] = {.lex_state = 55, .external_lex_state = 8},
  [521] = {.lex_state = 55, .external_lex_state = 8},
  [522] = {.lex_state = 55, .external_lex_state = 8},
  [523] = {.lex_state = 55, .external_lex_state = 8},
  [524] = {.lex_state = 55, .external_lex_state = 8},
  [525] = {.lex_state = 55, .external_lex_state = 8},
  [526] = {.lex_state = 55, .external_lex_state = 8},
  [527] = {.lex_state = 55, .external_lex_state = 8},
  [528] = {.lex_state = 55, .external_lex_state = 8},
  [529] = {.lex_state = 55, .external_lex_state = 8},
  [530] = {.lex_state = 55, .external_lex_state = 8},
  [531] = {.lex_state = 55, .external_lex_state = 8},
  [532] = {.lex_state = 55, .external_lex_state = 8},
  [533] = {.lex_state = 55, .external_lex_state = 8},
  [534] = {.lex_state = 55, .external_lex_state = 8},
  [535] = {.lex_state = 55, .external_lex_state = 8},
  [536] = {.lex_state = 55, .external_lex_state = 8},
  [537] = {.lex_state = 55, .external_lex_state = 8},
  [538] = {.lex_state = 55, .external_lex_state = 8},
  [539] = {.lex_state = 55, .external_lex_state = 8},
  [540] = {.lex_state = 55, .external_lex_state = 8},
  [541] = {.lex_state = 55, .external_lex_state = 8},
  [542] = {.lex_state = 55, .external_lex_state = 8},
  [543] = {.lex_state = 55, .external_lex_state = 8},
  [544] = {.lex_state = 55, .external_lex_state = 8},
  [545] = {.lex_state = 55, .external_lex_state = 8},
  [546] = {.lex_state = 55, .external_lex_state = 8},
  [547] = {.lex_state = 55, .external_lex_state = 8},
  [548] = {.lex_state = 55, .external_lex_state = 8},
  [549] = {.lex_state = 55, .external_lex_state = 8},
  [550] = {.lex_state = 55, .external_lex_state = 8},
  [551] = {.lex_state = 55, .external_lex_state = 8},
  [552] = {.lex_state = 55, .external_lex_state = 8},
  [553] = {.lex_state = 55, .external_lex_state = 9},
  [554] = {.lex_state = 55, .external_lex_state = 9},
  [555] = {.lex_state = 55, .external_lex_state = 10},
  [556] = {.lex_state = 55, .external_lex_state = 10},
  [557] = {.lex_state = 55, .external_lex_state = 11},
  [558] = {.lex_state = 55, .external_lex_state = 11},
  [559] = {.lex_state = 55, .external_lex_state = 10},
  [560] = {.lex_state = 55, .external_lex_state = 10},
  [561] = {.lex_state = 55, .external_lex_state = 10},
  [562] = {.lex_state = 55, .external_lex_state = 10},
  [563] = {.lex_state = 55, .external_lex_state = 10},
  [564] = {.lex_state = 55, .external_lex_state = 10},
  [565] = {.lex_state = 55, .external_lex_state = 10},
  [566] = {.lex_state = 55, .external_lex_state = 10},
  [567] = {.lex_state = 55, .external_lex_state = 10},
  [568] = {.lex_state = 55, .external_lex_state = 10},
  [569] = {.lex_state = 55, .external_lex_state = 10},
  [570] = {.lex_state = 55, .external_lex_state = 10},
  [571] = {.lex_state = 55, .external_lex_state = 10},
  [572] = {.lex_state = 55, .external_lex_state = 10},
  [573] = {.lex_state = 55, .external_lex_state = 10},
  [574] = {.lex_state = 55, .external_lex_state = 10},
  [575] = {.lex_state = 55, .external_lex_state = 10},
  [576] = {.lex_state = 55, .external_lex_state = 10},
  [577] = {.lex_state = 55, .external_lex_state = 10},
  [578] = {.lex_state = 55, .external_lex_state = 10},
  [579] = {.lex_state = 55, .external_lex_state = 10},
  [580] = {.lex_state = 55, .external_lex_state = 10},
  [581] = {.lex_state = 55, .external_lex_state = 10},
  [582] = {.lex_state = 55, .external_lex_state = 10},
  [583] = {.lex_state = 55, .external_lex_state = 10},
  [584] = {.lex_state = 55, .external_lex_state = 10},
  [585] = {.lex_state = 55, .external_lex_state = 10},
  [586] = {.lex_state = 55, .external_lex_state = 10},
  [587] = {.lex_state = 55, .external_lex_state = 10},
  [588] = {.lex_state = 55, .external_lex_state = 10},
  [589] = {.lex_state = 55, .external_lex_state = 10},
  [590] = {.lex_state = 55, .external_lex_state = 10},
  [591] = {.lex_state = 55, .external_lex_state = 10},
  [592] = {.lex_state = 55, .external_lex_state = 10},
  [593] = {.lex_state = 55, .external_lex_state = 10},
  [594] = {.lex_state = 55, .external_lex_state = 10},
  [595] = {.lex_state = 55, .external_lex_state = 10},
  [596] = {.lex_state = 55, .external_lex_state = 10},
  [597] = {.lex_state = 55, .external_lex_state = 10},
  [598] = {.lex_state = 55, .external_lex_state = 10},
  [599] = {.lex_state = 55, .external_lex_state = 10},
  [600] = {.lex_state = 55, .external_lex_state = 10},
  [601] = {.lex_state = 55, .external_lex_state = 10},
  [602] = {.lex_state = 55, .external_lex_state = 10},
  [603] = {.lex_state = 55, .external_lex_state = 10},
  [604] = {.lex_state = 55, .external_lex_state = 8},
  [605] = {.lex_state = 55, .external_lex_state = 10},
  [606] = {.lex_state = 55, .external_lex_state = 10},
  [607] = {.lex_state = 55, .external_lex_state = 10},
  [608] = {.lex_state = 55, .external_lex_state = 10},
  [609] = {.lex_state = 55, .external_lex_state = 10},
  [610] = {.lex_state = 55, .external_lex_state = 10},
  [611] = {.lex_state = 55, .external_lex_state = 10},
  [612] = {.lex_state = 55, .external_lex_state = 10},
  [613] = {.lex_state = 55, .external_lex_state = 10},
  [614] = {.lex_state = 55, .external_lex_state = 10},
  [615] = {.lex_state = 55, .external_lex_state = 10},
  [616] = {.lex_state = 55, .external_lex_state = 10},
  [617] = {.lex_state = 55, .external_lex_state = 10},
  [618] = {.lex_state = 55, .external_lex_state = 10},
  [619] = {.lex_state = 55, .external_lex_state = 10},
  [620] = {.lex_state = 55, .external_lex_state = 10},
  [621] = {.lex_state = 55, .external_lex_state = 10},
  [622] = {.lex_state = 55, .external_lex_state = 10},
  [623] = {.lex_state = 55, .external_lex_state = 10},
  [624] = {.lex_state = 55, .external_lex_state = 10},
  [625] = {.lex_state = 55, .external_lex_state = 10},
  [626] = {.lex_state = 55, .external_lex_state = 10},
  [627] = {.lex_state = 55, .external_lex_state = 10},
  [628] = {.lex_state = 55, .external_lex_state = 10},
  [629] = {.lex_state = 55, .external_lex_state = 10},
  [630] = {.lex_state = 55, .external_lex_state = 10},
  [631] = {.lex_state = 55, .external_lex_state = 10},
  [632] = {.lex_state = 55, .external_lex_state = 10},
  [633] = {.lex_state = 55, .external_lex_state = 10},
  [634] = {.lex_state = 55, .external_lex_state = 10},
  [635] = {.lex_state = 55, .external_lex_state = 10},
  [636] = {.lex_state = 55, .external_lex_state = 10},
  [637] = {.lex_state = 55, .external_lex_state = 10},
  [638] = {.lex_state = 55, .external_lex_state = 10},
  [639] = {.lex_state = 55, .external_lex_state = 10},
  [640] = {.lex_state = 55, .external_lex_state = 10},
  [641] = {.lex_state = 55, .external_lex_state = 10},
  [642] = {.lex_state = 55, .external_lex_state = 10},
  [643] = {.lex_state = 55, .external_lex_state = 10},
  [644] = {.lex_state = 55, .external_lex_state = 10},
  [645] = {.lex_state = 55, .external_lex_state = 10},
  [646] = {.lex_state = 55, .external_lex_state = 10},
  [647] = {.lex_state = 55, .external_lex_state = 10},
  [648] = {.lex_state = 55, .external_lex_state = 10},
  [649] = {.lex_state = 55, .external_lex_state = 10},
  [650] = {.lex_state = 55, .external_lex_state = 10},
  [651] = {.lex_state = 55, .external_lex_state = 10},
  [652] = {.lex_state = 55, .external_lex_state = 10},
  [653] = {.lex_state = 55, .external_lex_state = 10},
  [654] = {.lex_state = 55, .external_lex_state = 10},
  [655] = {.lex_state = 55, .external_lex_state = 10},
  [656] = {.lex_state = 55, .external_lex_state = 10},
  [657] = {.lex_state = 55, .external_lex_state = 10},
  [658] = {.lex_state = 55, .external_lex_state = 10},
  [659] = {.lex_state = 55, .external_lex_state = 8},
  [660] = {.lex_state = 61, .external_lex_state = 12},
  [661] = {.lex_state = 55, .external_lex_state = 10},
  [662] = {.lex_state = 55, .external_lex_state = 10},
  [663] = {.lex_state = 55, .external_lex_state = 10},
  [664] = {.lex_state = 55, .external_lex_state = 10},
  [665] = {.lex_state = 55, .external_lex_state = 10},
  [666] = {.lex_state = 55, .external_lex_state = 10},
  [667] = {.lex_state = 55, .external_lex_state = 10},
  [668] = {.lex_state = 55, .external_lex_state = 10},
  [669] = {.lex_state = 55, .external_lex_state = 10},
  [670] = {.lex_state = 61, .external_lex_state = 12},
  [671] = {.lex_state = 55, .external_lex_state = 10},
  [672] = {.lex_state = 55, .external_lex_state = 10},
  [673] = {.lex_state = 55, .external_lex_state = 10},
  [674] = {.lex_state = 55, .external_lex_state = 10},
  [675] = {.lex_state = 55, .external_lex_state = 10},
  [676] = {.lex_state = 55, .external_lex_state = 10},
  [677] = {.lex_state = 55, .external_lex_state = 10},
  [678] = {.lex_state = 55, .external_lex_state = 10},
  [679] = {.lex_state = 55, .external_lex_state = 10},
  [680] = {.lex_state = 55, .external_lex_state = 10},
  [681] = {.lex_state = 55, .external_lex_state = 10},
  [682] = {.lex_state = 55, .external_lex_state = 10},
  [683] = {.lex_state = 55, .external_lex_state = 10},
  [684] = {.lex_state = 55, .external_lex_state = 10},
  [685] = {.lex_state = 55, .external_lex_state = 10},
  [686] = {.lex_state = 55, .external_lex_state = 10},
  [687] = {.lex_state = 55, .external_lex_state = 10},
  [688] = {.lex_state = 55, .external_lex_state = 10},
  [689] = {.lex_state = 55, .external_lex_state = 10},
  [690] = {.lex_state = 55, .external_lex_state = 10},
  [691] = {.lex_state = 55, .external_lex_state = 10},
  [692] = {.lex_state = 55, .external_lex_state = 10},
  [693] = {.lex_state = 55, .external_lex_state = 10},
  [694] = {.lex_state = 55, .external_lex_state = 10},
  [695] = {.lex_state = 55, .external_lex_state = 10},
  [696] = {.lex_state = 55, .external_lex_state = 10},
  [697] = {.lex_state = 55, .external_lex_state = 10},
  [698] = {.lex_state = 55, .external_lex_state = 10},
  [699] = {.lex_state = 55, .external_lex_state = 10},
  [700] = {.lex_state = 55, .external_lex_state = 10},
  [701] = {.lex_state = 55, .external_lex_state = 13},
  [702] = {.lex_state = 56, .external_lex_state = 14},
  [703] = {.lex_state = 55, .external_lex_state = 13},
  [704] = {.lex_state = 55, .external_lex_state = 13},
  [705] = {.lex_state = 55, .external_lex_state = 13},
  [706] = {.lex_state = 55, .external_lex_state = 13},
  [707] = {.lex_state = 55, .external_lex_state = 13},
  [708] = {.lex_state = 55, .external_lex_state = 13},
  [709] = {.lex_state = 55, .external_lex_state = 13},
  [710] = {.lex_state = 55, .external_lex_state = 13},
  [711] = {.lex_state = 55, .external_lex_state = 13},
  [712] = {.lex_state = 55, .external_lex_state = 13},
  [713] = {.lex_state = 55, .external_lex_state = 13},
  [714] = {.lex_state = 55, .external_lex_state = 13},
  [715] = {.lex_state = 55, .external_lex_state = 13},
  [716] = {.lex_state = 55, .external_lex_state = 13},
  [717] = {.lex_state = 55, .external_lex_state = 13},
  [718] = {.lex_state = 55, .external_lex_state = 13},
  [719] = {.lex_state = 55, .external_lex_state = 13},
  [720] = {.lex_state = 55, .external_lex_state = 13},
  [721] = {.lex_state = 55, .external_lex_state = 13},
  [722] = {.lex_state = 55, .external_lex_state = 13},
  [723] = {.lex_state = 55, .external_lex_state = 13},
  [724] = {.lex_state = 55, .external_lex_state = 13},
  [725] = {.lex_state = 56, .external_lex_state = 14},
  [726] = {.lex_state = 55, .external_lex_state = 13},
  [727] = {.lex_state = 55, .external_lex_state = 13},
  [728] = {.lex_state = 55, .external_lex_state = 13},
  [729] = {.lex_state = 55, .external_lex_state = 15},
  [730] = {.lex_state = 55, .external_lex_state = 13},
  [731] = {.lex_state = 55, .external_lex_state = 13},
  [732] = {.lex_state = 55, .external_lex_state = 13},
  [733] = {.lex_state = 55, .external_lex_state = 13},
  [734] = {.lex_state = 55, .external_lex_state = 13},
  [735] = {.lex_state = 55, .external_lex_state = 15},
  [736] = {.lex_state = 55, .external_lex_state = 13},
  [737] = {.lex_state = 55, .external_lex_state = 13},
  [738] = {.lex_state = 55, .external_lex_state = 13},
  [739] = {.lex_state = 55, .external_lex_state = 13},
  [740] = {.lex_state = 55, .external_lex_state = 13},
  [741] = {.lex_state = 55, .external_lex_state = 13},
  [742] = {.lex_state = 55, .external_lex_state = 13},
  [743] = {.lex_state = 55, .external_lex_state = 13},
  [744] = {.lex_state = 55, .external_lex_state = 13},
  [745] = {.lex_state = 56, .external_lex_state = 14},
  [746] = {.lex_state = 56, .external_lex_state = 14},
  [747] = {.lex_state = 55, .external_lex_state = 13},
  [748] = {.lex_state = 55, .external_lex_state = 13},
  [749] = {.lex_state = 55, .external_lex_state = 13},
  [750] = {.lex_state = 55, .external_lex_state = 13},
  [751] = {.lex_state = 55, .external_lex_state = 13},
  [752] = {.lex_state = 56, .external_lex_state = 14},
  [753] = {.lex_state = 55, .external_lex_state = 13},
  [754] = {.lex_state = 55, .external_lex_state = 16},
  [755] = {.lex_state = 55, .external_lex_state = 17},
  [756] = {.lex_state = 55, .external_lex_state = 18},
  [757] = {.lex_state = 55, .external_lex_state = 17},
  [758] = {.lex_state = 55, .external_lex_state = 16},
  [759] = {.lex_state = 55, .external_lex_state = 19},
  [760] = {.lex_state = 55, .external_lex_state = 18},
  [761] = {.lex_state = 55, .external_lex_state = 20},
  [762] = {.lex_state = 55, .external_lex_state = 19},
  [763] = {.lex_state = 55, .external_lex_state = 20},
  [764] = {.lex_state = 56, .external_lex_state = 14},
  [765] = {.lex_state = 56, .external_lex_state = 14},
  [766] = {.lex_state = 55, .external_lex_state = 21},
  [767] = {.lex_state = 56, .external_lex_state = 14},
  [768] = {.lex_state = 56, .external_lex_state = 14},
  [769] = {.lex_state = 56, .external_lex_state = 14},
  [770] = {.lex_state = 56, .external_lex_state = 14},
  [771] = {.lex_state = 56, .external_lex_state = 14},
  [772] = {.lex_state = 56, .external_lex_state = 14},
  [773] = {.lex_state = 55, .external_lex_state = 22},
  [774] = {.lex_state = 56, .external_lex_state = 14},
  [775] = {.lex_state = 55, .external_lex_state = 21},
  [776] = {.lex_state = 56, .external_lex_state = 14},
  [777] = {.lex_state = 56, .external_lex_state = 14},
  [778] = {.lex_state = 56, .external_lex_state = 14},
  [779] = {.lex_state = 56, .external_lex_state = 14},
  [780] = {.lex_state = 55, .external_lex_state = 21},
  [781] = {.lex_state = 56, .external_lex_state = 14},
  [782] = {.lex_state = 55, .external_lex_state = 21},
  [783] = {.lex_state = 56, .external_lex_state = 14},
  [784] = {.lex_state = 56, .external_lex_state = 14},
  [785] = {.lex_state = 55, .external_lex_state = 21},
  [786] = {.lex_state = 55, .external_lex_state = 21},
  [787] = {.lex_state = 55, .external_lex_state = 21},
  [788] = {.lex_state = 56, .external_lex_state = 14},
  [789] = {.lex_state = 55, .external_lex_state = 21},
  [790] = {.lex_state = 55, .external_lex_state = 21},
  [791] = {.lex_state = 55, .external_lex_state = 22},
  [792] = {.lex_state = 56, .external_lex_state = 14},
  [793] = {.lex_state = 55, .external_lex_state = 21},
  [794] = {.lex_state = 55, .external_lex_state = 21},
  [795] = {.lex_state = 56, .external_lex_state = 14},
  [796] = {.lex_state = 55, .external_lex_state = 21},
  [797] = {.lex_state = 56, .external_lex_state = 14},
  [798] = {.lex_state = 55, .external_lex_state = 23},
  [799] = {.lex_state = 55, .external_lex_state = 21},
  [800] = {.lex_state = 56, .external_lex_state = 14},
  [801] = {.lex_state = 56, .external_lex_state = 14},
  [802] = {.lex_state = 56, .external_lex_state = 14},
  [803] = {.lex_state = 56, .external_lex_state = 14},
  [804] = {.lex_state = 55, .external_lex_state = 21},
  [805] = {.lex_state = 55, .external_lex_state = 21},
  [806] = {.lex_state = 56, .external_lex_state = 14},
  [807] = {.lex_state = 55, .external_lex_state = 23},
  [808] = {.lex_state = 56, .external_lex_state = 14},
  [809] = {.lex_state = 56, .external_lex_state = 14},
  [810] = {.lex_state = 56, .external_lex_state = 14},
  [811] = {.lex_state = 55, .external_lex_state = 24},
  [812] = {.lex_state = 56, .external_lex_state = 14},
  [813] = {.lex_state = 56, .external_lex_state = 14},
  [814] = {.lex_state = 56, .external_lex_state = 14},
  [815] = {.lex_state = 56, .external_lex_state = 14},
  [816] = {.lex_state = 55, .external_lex_state = 21},
  [817] = {.lex_state = 55, .external_lex_state = 25},
  [818] = {.lex_state = 56, .external_lex_state = 14},
  [819] = {.lex_state = 55, .external_lex_state = 21},
  [820] = {.lex_state = 56, .external_lex_state = 14},
  [821] = {.lex_state = 56, .external_lex_state = 14},
  [822] = {.lex_state = 56, .external_lex_state = 14},
  [823] = {.lex_state = 55, .external_lex_state = 26},
  [824] = {.lex_state = 55, .external_lex_state = 26},
  [825] = {.lex_state = 61, .external_lex_state = 27},
  [826] = {.lex_state = 56, .external_lex_state = 14},
  [827] = {.lex_state = 56, .external_lex_state = 14},
  [828] = {.lex_state = 55, .external_lex_state = 28},
  [829] = {.lex_state = 55, .external_lex_state = 21},
  [830] = {.lex_state = 55, .external_lex_state = 25},
  [831] = {.lex_state = 56, .external_lex_state = 14},
  [832] = {.lex_state = 56, .external_lex_state = 14},
  [833] = {.lex_state = 55, .external_lex_state = 21},
  [834] = {.lex_state = 55, .external_lex_state = 29},
  [835] = {.lex_state = 56, .external_lex_state = 14},
  [836] = {.lex_state = 56, .external_lex_state = 14},
  [837] = {.lex_state = 56, .external_lex_state = 14},
  [838] = {.lex_state = 56, .external_lex_state = 14},
  [839] = {.lex_state = 56, .external_lex_state = 14},
  [840] = {.lex_state = 56, .external_lex_state = 14},
  [841] = {.lex_state = 56, .external_lex_state = 14},
  [842] = {.lex_state = 56, .external_lex_state = 14},
  [843] = {.lex_state = 56, .external_lex_state = 14},
  [844] = {.lex_state = 55, .external_lex_state = 24},
  [845] = {.lex_state = 55, .external_lex_state = 21},
  [846] = {.lex_state = 56, .external_lex_state = 14},
  [847] = {.lex_state = 55, .external_lex_state = 28},
  [848] = {.lex_state = 56, .external_lex_state = 14},
  [849] = {.lex_state = 56, .external_lex_state = 14},
  [850] = {.lex_state = 56, .external_lex_state = 14},
  [851] = {.lex_state = 56, .external_lex_state = 14},
  [852] = {.lex_state = 55, .external_lex_state = 29},
  [853] = {.lex_state = 56, .external_lex_state = 14},
  [854] = {.lex_state = 55, .external_lex_state = 21},
  [855] = {.lex_state = 55, .external_lex_state = 21},
  [856] = {.lex_state = 55, .external_lex_state = 21},
  [857] = {.lex_state = 61, .external_lex_state = 27},
  [858] = {.lex_state = 56, .external_lex_state = 14},
  [859] = {.lex_state = 56, .external_lex_state = 14},
  [860] = {.lex_state = 56, .external_lex_state = 14},
  [861] = {.lex_state = 55, .external_lex_state = 30},
  [862] = {.lex_state = 55, .external_lex_state = 30},
  [863] = {.lex_state = 55, .external_lex_state = 30},
  [864] = {.lex_state = 55, .external_lex_state = 30},
  [865] = {.lex_state = 55, .external_lex_state = 30},
  [866] = {.lex_state = 56, .external_lex_state = 14},
  [867] = {.lex_state = 55, .external_lex_state = 30},
  [868] = {.lex_state = 55, .external_lex_state = 30},
  [869] = {.lex_state = 55, .external_lex_state = 30},
  [870] = {.lex_state = 55, .external_lex_state = 30},
  [871] = {.lex_state = 55, .external_lex_state = 30},
  [872] = {.lex_state = 55, .external_lex_state = 31},
  [873] = {.lex_state = 55, .external_lex_state = 30},
  [874] = {.lex_state = 55, .external_lex_state = 30},
  [875] = {.lex_state = 55, .external_lex_state = 30},
  [876] = {.lex_state = 55, .external_lex_state = 30},
  [877] = {.lex_state = 55, .external_lex_state = 30},
  [878] = {.lex_state = 55, .external_lex_state = 30},
  [879] = {.lex_state = 55, .external_lex_state = 30},
  [880] = {.lex_state = 55, .external_lex_state = 30},
  [881] = {.lex_state = 55, .external_lex_state = 30},
  [882] = {.lex_state = 55, .external_lex_state = 30},
  [883] = {.lex_state = 55, .external_lex_state = 30},
  [884] = {.lex_state = 55, .external_lex_state = 30},
  [885] = {.lex_state = 55, .external_lex_state = 32},
  [886] = {.lex_state = 55, .external_lex_state = 33},
  [887] = {.lex_state = 55, .external_lex_state = 30},
  [888] = {.lex_state = 55, .external_lex_state = 30},
  [889] = {.lex_state = 55, .external_lex_state = 30},
  [890] = {.lex_state = 55, .external_lex_state = 30},
  [891] = {.lex_state = 55, .external_lex_state = 30},
  [892] = {.lex_state = 55, .external_lex_state = 30},
  [893] = {.lex_state = 55, .external_lex_state = 30},
  [894] = {.lex_state = 55, .external_lex_state = 30},
  [895] = {.lex_state = 55, .external_lex_state = 30},
  [896] = {.lex_state = 55, .external_lex_state = 30},
  [897] = {.lex_state = 55, .external_lex_state = 31},
  [898] = {.lex_state = 55, .external_lex_state = 30},
  [899] = {.lex_state = 55, .external_lex_state = 30},
  [900] = {.lex_state = 55, .external_lex_state = 32},
  [901] = {.lex_state = 55, .external_lex_state = 30},
  [902] = {.lex_state = 55, .external_lex_state = 30},
  [903] = {.lex_state = 55, .external_lex_state = 30},
  [904] = {.lex_state = 55, .external_lex_state = 30},
  [905] = {.lex_state = 55, .external_lex_state = 30},
  [906] = {.lex_state = 55, .external_lex_state = 30},
  [907] = {.lex_state = 55, .external_lex_state = 30},
  [908] = {.lex_state = 55, .external_lex_state = 30},
  [909] = {.lex_state = 55, .external_lex_state = 30},
  [910] = {.lex_state = 55, .external_lex_state = 33},
  [911] = {.lex_state = 56, .external_lex_state = 14},
  [912] = {.lex_state = 55, .external_lex_state = 30},
  [913] = {.lex_state = 55, .external_lex_state = 30},
  [914] = {.lex_state = 55, .external_lex_state = 30},
  [915] = {.lex_state = 55, .external_lex_state = 30},
  [916] = {.lex_state = 55, .external_lex_state = 34},
  [917] = {.lex_state = 55, .external_lex_state = 35},
  [918] = {.lex_state = 55, .external_lex_state = 34},
  [919] = {.lex_state = 55, .external_lex_state = 36},
  [920] = {.lex_state = 55, .external_lex_state = 30},
  [921] = {.lex_state = 55, .external_lex_state = 37},
  [922] = {.lex_state = 55, .external_lex_state = 37},
  [923] = {.lex_state = 55, .external_lex_state = 37},
  [924] = {.lex_state = 56, .external_lex_state = 14},
  [925] = {.lex_state = 55, .external_lex_state = 37},
  [926] = {.lex_state = 55, .external_lex_state = 37},
  [927] = {.lex_state = 55, .external_lex_state = 37},
  [928] = {.lex_state = 56, .external_lex_state = 14},
  [929] = {.lex_state = 56, .external_lex_state = 14},
  [930] = {.lex_state = 56, .external_lex_state = 14},
  [931] = {.lex_state = 55, .external_lex_state = 37},
  [932] = {.lex_state = 56, .external_lex_state = 14},
  [933] = {.lex_state = 55, .external_lex_state = 37},
  [934] = {.lex_state = 55, .external_lex_state = 37},
  [935] = {.lex_state = 55, .external_lex_state = 37},
  [936] = {.lex_state = 56, .external_lex_state = 14},
  [937] = {.lex_state = 56, .external_lex_state = 14},
  [938] = {.lex_state = 55, .external_lex_state = 37},
  [939] = {.lex_state = 56, .external_lex_state = 14},
  [940] = {.lex_state = 55, .external_lex_state = 37},
  [941] = {.lex_state = 56, .external_lex_state = 14},
  [942] = {.lex_state = 55, .external_lex_state = 37},
  [943] = {.lex_state = 55, .external_lex_state = 37},
  [944] = {.lex_state = 55, .external_lex_state = 37},
  [945] = {.lex_state = 56, .external_lex_state = 14},
  [946] = {.lex_state = 55, .external_lex_state = 37},
  [947] = {.lex_state = 56, .external_lex_state = 14},
  [948] = {.lex_state = 55, .external_lex_state = 37},
  [949] = {.lex_state = 55, .external_lex_state = 37},
  [950] = {.lex_state = 55, .external_lex_state = 37},
  [951] = {.lex_state = 56, .external_lex_state = 14},
  [952] = {.lex_state = 55, .external_lex_state = 37},
  [953] = {.lex_state = 55, .external_lex_state = 37},
  [954] = {.lex_state = 56, .external_lex_state = 14},
  [955] = {.lex_state = 55, .external_lex_state = 37},
  [956] = {.lex_state = 56, .external_lex_state = 14},
  [957] = {.lex_state = 56, .external_lex_state = 14},
  [958] = {.lex_state = 55, .external_lex_state = 37},
  [959] = {.lex_state = 56, .external_lex_state = 14},
  [960] = {.lex_state = 55, .external_lex_state = 37},
  [961] = {.lex_state = 56, .external_lex_state = 14},
  [962] = {.lex_state = 55, .external_lex_state = 37},
  [963] = {.lex_state = 55, .external_lex_state = 37},
  [964] = {.lex_state = 55, .external_lex_state = 37},
  [965] = {.lex_state = 55, .external_lex_state = 37},
  [966] = {.lex_state = 56, .external_lex_state = 14},
  [967] = {.lex_state = 56, .external_lex_state = 14},
  [968] = {.lex_state = 55, .external_lex_state = 37},
  [969] = {.lex_state = 55, .external_lex_state = 37},
  [970] = {.lex_state = 56, .external_lex_state = 14},
  [971] = {.lex_state = 55, .external_lex_state = 37},
  [972] = {.lex_state = 55, .external_lex_state = 37},
  [973] = {.lex_state = 55, .external_lex_state = 37},
  [974] = {.lex_state = 56, .external_lex_state = 14},
  [975] = {.lex_state = 55, .external_lex_state = 37},
  [976] = {.lex_state = 55, .external_lex_state = 37},
  [977] = {.lex_state = 55, .external_lex_state = 37},
  [978] = {.lex_state = 56, .external_lex_state = 14},
  [979] = {.lex_state = 55, .external_lex_state = 37},
  [980] = {.lex_state = 55, .external_lex_state = 37},
  [981] = {.lex_state = 55, .external_lex_state = 37},
  [982] = {.lex_state = 56, .external_lex_state = 14},
  [983] = {.lex_state = 55, .external_lex_state = 37},
  [984] = {.lex_state = 55, .external_lex_state = 37},
  [985] = {.lex_state = 56, .external_lex_state = 14},
  [986] = {.lex_state = 56, .external_lex_state = 14},
  [987] = {.lex_state = 55, .external_lex_state = 37},
  [988] = {.lex_state = 55, .external_lex_state = 37},
  [989] = {.lex_state = 56, .external_lex_state = 14},
  [990] = {.lex_state = 55, .external_lex_state = 37},
  [991] = {.lex_state = 55, .external_lex_state = 37},
  [992] = {.lex_state = 55, .external_lex_state = 37},
  [993] = {.lex_state = 56, .external_lex_state = 14},
  [994] = {.lex_state = 56, .external_lex_state = 14},
  [995] = {.lex_state = 55, .external_lex_state = 37},
  [996] = {.lex_state = 56, .external_lex_state = 14},
  [997] = {.lex_state = 56, .external_lex_state = 14},
  [998] = {.lex_state = 55, .external_lex_state = 37},
  [999] = {.lex_state = 56, .external_lex_state = 14},
  [1000] = {.lex_state = 55, .external_lex_state = 37},
  [1001] = {.lex_state = 56, .external_lex_state = 14},
  [1002] = {.lex_state = 56, .external_lex_state = 14},
  [1003] = {.lex_state = 56, .external_lex_state = 14},
  [1004] = {.lex_state = 55, .external_lex_state = 37},
  [1005] = {.lex_state = 55, .external_lex_state = 37},
  [1006] = {.lex_state = 55, .external_lex_state = 37},
  [1007] = {.lex_state = 55, .external_lex_state = 37},
  [1008] = {.lex_state = 56, .external_lex_state = 14},
  [1009] = {.lex_state = 56, .external_lex_state = 14},
  [1010] = {.lex_state = 55, .external_lex_state = 37},
  [1011] = {.lex_state = 55, .external_lex_state = 3},
  [1012] = {.lex_state = 55, .external_lex_state = 37},
  [1013] = {.lex_state = 55, .external_lex_state = 37},
  [1014] = {.lex_state = 55, .external_lex_state = 37},
  [1015] = {.lex_state = 55, .external_lex_state = 37},
  [1016] = {.lex_state = 56, .external_lex_state = 14},
  [1017] = {.lex_state = 55, .external_lex_state = 37},
  [1018] = {.lex_state = 55, .external_lex_state = 37},
  [1019] = {.lex_state = 56, .external_lex_state = 14},
  [1020] = {.lex_state = 56, .external_lex_state = 14},
  [1021] = {.lex_state = 56, .external_lex_state = 14},
  [1022] = {.lex_state = 56, .external_lex_state = 14},
  [1023] = {.lex_state = 55, .external_lex_state = 37},
  [1024] = {.lex_state = 55, .external_lex_state = 37},
  [1025] = {.lex_state = 55, .external_lex_state = 37},
  [1026] = {.lex_state = 55, .external_lex_state = 37},
  [1027] = {.lex_state = 55, .external_lex_state = 37},
  [1028] = {.lex_state = 55, .external_lex_state = 37},
  [1029] = {.lex_state = 56, .external_lex_state = 14},
  [1030] = {.lex_state = 56, .external_lex_state = 14},
  [1031] = {.lex_state = 55, .external_lex_state = 37},
  [1032] = {.lex_state = 55, .external_lex_state = 37},
  [1033] = {.lex_state = 55, .external_lex_state = 37},
  [1034] = {.lex_state = 56, .external_lex_state = 14},
  [1035] = {.lex_state = 55, .external_lex_state = 37},
  [1036] = {.lex_state = 55, .external_lex_state = 37},
  [1037] = {.lex_state = 56, .external_lex_state = 14},
  [1038] = {.lex_state = 55, .external_lex_state = 37},
  [1039] = {.lex_state = 55, .external_lex_state = 37},
  [1040] = {.lex_state = 55, .external_lex_state = 37},
  [1041] = {.lex_state = 56, .external_lex_state = 14},
  [1042] = {.lex_state = 56, .external_lex_state = 14},
  [1043] = {.lex_state = 55, .external_lex_state = 37},
  [1044] = {.lex_state = 55, .external_lex_state = 37},
  [1045] = {.lex_state = 55, .external_lex_state = 37},
  [1046] = {.lex_state = 55, .external_lex_state = 37},
  [1047] = {.lex_state = 56, .external_lex_state = 14},
  [1048] = {.lex_state = 56, .external_lex_state = 14},
  [1049] = {.lex_state = 55, .external_lex_state = 37},
  [1050] = {.lex_state = 56, .external_lex_state = 14},
  [1051] = {.lex_state = 56, .external_lex_state = 14},
  [1052] = {.lex_state = 55, .external_lex_state = 37},
  [1053] = {.lex_state = 55, .external_lex_state = 37},
  [1054] = {.lex_state = 55, .external_lex_state = 37},
  [1055] = {.lex_state = 56, .external_lex_state = 14},
  [1056] = {.lex_state = 55, .external_lex_state = 37},
  [1057] = {.lex_state = 55, .external_lex_state = 37},
  [1058] = {.lex_state = 56, .external_lex_state = 14},
  [1059] = {.lex_state = 56, .external_lex_state = 14},
  [1060] = {.lex_state = 56, .external_lex_state = 14},
  [1061] = {.lex_state = 55, .external_lex_state = 37},
  [1062] = {.lex_state = 56, .external_lex_state = 14},
  [1063] = {.lex_state = 56, .external_lex_state = 14},
  [1064] = {.lex_state = 55, .external_lex_state = 37},
  [1065] = {.lex_state = 55, .external_lex_state = 37},
  [1066] = {.lex_state = 56, .external_lex_state = 14},
  [1067] = {.lex_state = 56, .external_lex_state = 14},
  [1068] = {.lex_state = 56, .external_lex_state = 14},
  [1069] = {.lex_state = 55, .external_lex_state = 37},
  [1070] = {.lex_state = 55, .external_lex_state = 37},
  [1071] = {.lex_state = 55, .external_lex_state = 37},
  [1072] = {.lex_state = 56, .external_lex_state = 14},
  [1073] = {.lex_state = 55, .external_lex_state = 37},
  [1074] = {.lex_state = 56, .external_lex_state = 14},
  [1075] = {.lex_state = 55, .external_lex_state = 37},
  [1076] = {.lex_state = 56, .external_lex_state = 14},
  [1077] = {.lex_state = 55, .external_lex_state = 37},
  [1078] = {.lex_state = 55, .external_lex_state = 37},
  [1079] = {.lex_state = 56, .external_lex_state = 14},
  [1080] = {.lex_state = 56, .external_lex_state = 14},
  [1081] = {.lex_state = 56, .external_lex_state = 14},
  [1082] = {.lex_state = 56, .external_lex_state = 14},
  [1083] = {.lex_state = 56, .external_lex_state = 14},
  [1084] = {.lex_state = 55, .external_lex_state = 37},
  [1085] = {.lex_state = 56, .external_lex_state = 14},
  [1086] = {.lex_state = 56, .external_lex_state = 14},
  [1087] = {.lex_state = 55, .external_lex_state = 37},
  [1088] = {.lex_state = 56, .external_lex_state = 14},
  [1089] = {.lex_state = 55, .external_lex_state = 37},
  [1090] = {.lex_state = 55, .external_lex_state = 37},
  [1091] = {.lex_state = 56, .external_lex_state = 14},
  [1092] = {.lex_state = 55, .external_lex_state = 37},
  [1093] = {.lex_state = 56, .external_lex_state = 14},
  [1094] = {.lex_state = 55, .external_lex_state = 37},
  [1095] = {.lex_state = 55, .external_lex_state = 37},
  [1096] = {.lex_state = 55, .external_lex_state = 37},
  [1097] = {.lex_state = 56, .external_lex_state = 14},
  [1098] = {.lex_state = 56, .external_lex_state = 14},
  [1099] = {.lex_state = 56, .external_lex_state = 14},
  [1100] = {.lex_state = 55, .external_lex_state = 37},
  [1101] = {.lex_state = 55, .external_lex_state = 37},
  [1102] = {.lex_state = 55, .external_lex_state = 37},
  [1103] = {.lex_state = 56, .external_lex_state = 14},
  [1104] = {.lex_state = 56, .external_lex_state = 14},
  [1105] = {.lex_state = 55, .external_lex_state = 37},
  [1106] = {.lex_state = 55, .external_lex_state = 37},
  [1107] = {.lex_state = 55, .external_lex_state = 37},
  [1108] = {.lex_state = 55, .external_lex_state = 37},
  [1109] = {.lex_state = 56, .external_lex_state = 14},
  [1110] = {.lex_state = 55, .external_lex_state = 37},
  [1111] = {.lex_state = 56, .external_lex_state = 14},
  [1112] = {.lex_state = 56, .external_lex_state = 14},
  [1113] = {.lex_state = 56, .external_lex_state = 14},
  [1114] = {.lex_state = 55, .external_lex_state = 37},
  [1115] = {.lex_state = 56, .external_lex_state = 14},
  [1116] = {.lex_state = 56, .external_lex_state = 14},
  [1117] = {.lex_state = 56, .external_lex_state = 14},
  [1118] = {.lex_state = 55, .external_lex_state = 37},
  [1119] = {.lex_state = 55, .external_lex_state = 37},
  [1120] = {.lex_state = 56, .external_lex_state = 14},
  [1121] = {.lex_state = 56, .external_lex_state = 14},
  [1122] = {.lex_state = 55, .external_lex_state = 37},
  [1123] = {.lex_state = 56, .external_lex_state = 14},
  [1124] = {.lex_state = 55, .external_lex_state = 37},
  [1125] = {.lex_state = 55, .external_lex_state = 37},
  [1126] = {.lex_state = 56, .external_lex_state = 14},
  [1127] = {.lex_state = 55, .external_lex_state = 37},
  [1128] = {.lex_state = 55, .external_lex_state = 37},
  [1129] = {.lex_state = 55, .external_lex_state = 37},
  [1130] = {.lex_state = 56, .external_lex_state = 14},
  [1131] = {.lex_state = 56, .external_lex_state = 14},
  [1132] = {.lex_state = 55, .external_lex_state = 37},
  [1133] = {.lex_state = 56, .external_lex_state = 14},
  [1134] = {.lex_state = 56, .external_lex_state = 14},
  [1135] = {.lex_state = 55, .external_lex_state = 37},
  [1136] = {.lex_state = 55, .external_lex_state = 37},
  [1137] = {.lex_state = 55, .external_lex_state = 37},
  [1138] = {.lex_state = 56, .external_lex_state = 14},
  [1139] = {.lex_state = 55, .external_lex_state = 37},
  [1140] = {.lex_state = 55, .external_lex_state = 37},
  [1141] = {.lex_state = 55, .external_lex_state = 37},
  [1142] = {.lex_state = 55, .external_lex_state = 37},
  [1143] = {.lex_state = 56, .external_lex_state = 14},
  [1144] = {.lex_state = 55, .external_lex_state = 37},
  [1145] = {.lex_state = 56, .external_lex_state = 14},
  [1146] = {.lex_state = 56, .external_lex_state = 14},
  [1147] = {.lex_state = 56, .external_lex_state = 14},
  [1148] = {.lex_state = 56, .external_lex_state = 14},
  [1149] = {.lex_state = 56, .external_lex_state = 14},
  [1150] = {.lex_state = 55, .external_lex_state = 37},
  [1151] = {.lex_state = 56, .external_lex_state = 14},
  [1152] = {.lex_state = 55, .external_lex_state = 37},
  [1153] = {.lex_state = 55, .external_lex_state = 37},
  [1154] = {.lex_state = 55, .external_lex_state = 37},
  [1155] = {.lex_state = 56, .external_lex_state = 14},
  [1156] = {.lex_state = 55, .external_lex_state = 37},
  [1157] = {.lex_state = 56, .external_lex_state = 14},
  [1158] = {.lex_state = 56, .external_lex_state = 14},
  [1159] = {.lex_state = 55, .external_lex_state = 37},
  [1160] = {.lex_state = 56, .external_lex_state = 14},
  [1161] = {.lex_state = 55, .external_lex_state = 37},
  [1162] = {.lex_state = 55, .external_lex_state = 37},
  [1163] = {.lex_state = 56, .external_lex_state = 14},
  [1164] = {.lex_state = 55, .external_lex_state = 37},
  [1165] = {.lex_state = 55, .external_lex_state = 37},
  [1166] = {.lex_state = 55, .external_lex_state = 37},
  [1167] = {.lex_state = 55, .external_lex_state = 37},
  [1168] = {.lex_state = 56, .external_lex_state = 14},
  [1169] = {.lex_state = 55, .external_lex_state = 37},
  [1170] = {.lex_state = 55, .external_lex_state = 37},
  [1171] = {.lex_state = 56, .external_lex_state = 14},
  [1172] = {.lex_state = 55, .external_lex_state = 37},
  [1173] = {.lex_state = 55, .external_lex_state = 37},
  [1174] = {.lex_state = 56, .external_lex_state = 14},
  [1175] = {.lex_state = 55, .external_lex_state = 37},
  [1176] = {.lex_state = 55, .external_lex_state = 37},
  [1177] = {.lex_state = 55, .external_lex_state = 37},
  [1178] = {.lex_state = 55, .external_lex_state = 37},
  [1179] = {.lex_state = 55, .external_lex_state = 37},
  [1180] = {.lex_state = 55, .external_lex_state = 37},
  [1181] = {.lex_state = 55, .external_lex_state = 37},
  [1182] = {.lex_state = 56, .external_lex_state = 14},
  [1183] = {.lex_state = 55, .external_lex_state = 37},
  [1184] = {.lex_state = 55, .external_lex_state = 37},
  [1185] = {.lex_state = 56, .external_lex_state = 14},
  [1186] = {.lex_state = 55, .external_lex_state = 37},
  [1187] = {.lex_state = 55, .external_lex_state = 37},
  [1188] = {.lex_state = 56, .external_lex_state = 14},
  [1189] = {.lex_state = 55, .external_lex_state = 37},
  [1190] = {.lex_state = 56, .external_lex_state = 14},
  [1191] = {.lex_state = 55, .external_lex_state = 37},
  [1192] = {.lex_state = 56, .external_lex_state = 14},
  [1193] = {.lex_state = 56, .external_lex_state = 14},
  [1194] = {.lex_state = 55, .external_lex_state = 37},
  [1195] = {.lex_state = 56, .external_lex_state = 14},
  [1196] = {.lex_state = 55, .external_lex_state = 37},
  [1197] = {.lex_state = 56, .external_lex_state = 14},
  [1198] = {.lex_state = 55, .external_lex_state = 37},
  [1199] = {.lex_state = 55, .external_lex_state = 37},
  [1200] = {.lex_state = 56, .external_lex_state = 14},
  [1201] = {.lex_state = 55, .external_lex_state = 37},
  [1202] = {.lex_state = 55, .external_lex_state = 37},
  [1203] = {.lex_state = 55, .external_lex_state = 37},
  [1204] = {.lex_state = 55, .external_lex_state = 37},
  [1205] = {.lex_state = 55, .external_lex_state = 37},
  [1206] = {.lex_state = 55, .external_lex_state = 37},
  [1207] = {.lex_state = 56, .external_lex_state = 14},
  [1208] = {.lex_state = 55, .external_lex_state = 37},
  [1209] = {.lex_state = 56, .external_lex_state = 14},
  [1210] = {.lex_state = 55, .external_lex_state = 37},
  [1211] = {.lex_state = 56, .external_lex_state = 14},
  [1212] = {.lex_state = 56, .external_lex_state = 14},
  [1213] = {.lex_state = 55, .external_lex_state = 37},
  [1214] = {.lex_state = 55, .external_lex_state = 37},
  [1215] = {.lex_state = 55, .external_lex_state = 37},
  [1216] = {.lex_state = 56, .external_lex_state = 14},
  [1217] = {.lex_state = 55, .external_lex_state = 37},
  [1218] = {.lex_state = 55, .external_lex_state = 37},
  [1219] = {.lex_state = 56, .external_lex_state = 14},
  [1220] = {.lex_state = 55, .external_lex_state = 37},
  [1221] = {.lex_state = 55, .external_lex_state = 37},
  [1222] = {.lex_state = 55, .external_lex_state = 37},
  [1223] = {.lex_state = 55, .external_lex_state = 37},
  [1224] = {.lex_state = 55, .external_lex_state = 37},
  [1225] = {.lex_state = 55, .external_lex_state = 37},
  [1226] = {.lex_state = 56, .external_lex_state = 14},
  [1227] = {.lex_state = 55, .external_lex_state = 37},
  [1228] = {.lex_state = 55, .external_lex_state = 37},
  [1229] = {.lex_state = 55, .external_lex_state = 37},
  [1230] = {.lex_state = 56, .external_lex_state = 14},
  [1231] = {.lex_state = 55, .external_lex_state = 37},
  [1232] = {.lex_state = 56, .external_lex_state = 14},
  [1233] = {.lex_state = 55, .external_lex_state = 37},
  [1234] = {.lex_state = 56, .external_lex_state = 14},
  [1235] = {.lex_state = 55, .external_lex_state = 37},
  [1236] = {.lex_state = 55, .external_lex_state = 37},
  [1237] = {.lex_state = 55, .external_lex_state = 37},
  [1238] = {.lex_state = 55, .external_lex_state = 37},
  [1239] = {.lex_state = 55, .external_lex_state = 37},
  [1240] = {.lex_state = 56, .external_lex_state = 14},
  [1241] = {.lex_state = 55, .external_lex_state = 37},
  [1242] = {.lex_state = 56, .external_lex_state = 14},
  [1243] = {.lex_state = 56, .external_lex_state = 14},
  [1244] = {.lex_state = 55, .external_lex_state = 37},
  [1245] = {.lex_state = 55, .external_lex_state = 37},
  [1246] = {.lex_state = 55, .external_lex_state = 37},
  [1247] = {.lex_state = 55, .external_lex_state = 37},
  [1248] = {.lex_state = 55, .external_lex_state = 37},
  [1249] = {.lex_state = 56, .external_lex_state = 14},
  [1250] = {.lex_state = 56, .external_lex_state = 14},
  [1251] = {.lex_state = 55, .external_lex_state = 37},
  [1252] = {.lex_state = 56, .external_lex_state = 14},
  [1253] = {.lex_state = 55, .external_lex_state = 37},
  [1254] = {.lex_state = 56, .external_lex_state = 14},
  [1255] = {.lex_state = 55, .external_lex_state = 37},
  [1256] = {.lex_state = 55, .external_lex_state = 37},
  [1257] = {.lex_state = 55, .external_lex_state = 37},
  [1258] = {.lex_state = 55, .external_lex_state = 37},
  [1259] = {.lex_state = 55, .external_lex_state = 37},
  [1260] = {.lex_state = 56, .external_lex_state = 14},
  [1261] = {.lex_state = 56, .external_lex_state = 14},
  [1262] = {.lex_state = 55, .external_lex_state = 37},
  [1263] = {.lex_state = 55, .external_lex_state = 37},
  [1264] = {.lex_state = 55, .external_lex_state = 37},
  [1265] = {.lex_state = 56, .external_lex_state = 14},
  [1266] = {.lex_state = 55, .external_lex_state = 37},
  [1267] = {.lex_state = 55, .external_lex_state = 37},
  [1268] = {.lex_state = 55, .external_lex_state = 37},
  [1269] = {.lex_state = 55, .external_lex_state = 37},
  [1270] = {.lex_state = 56, .external_lex_state = 14},
  [1271] = {.lex_state = 56, .external_lex_state = 14},
  [1272] = {.lex_state = 55, .external_lex_state = 37},
  [1273] = {.lex_state = 55, .external_lex_state = 37},
  [1274] = {.lex_state = 55, .external_lex_state = 37},
  [1275] = {.lex_state = 56, .external_lex_state = 14},
  [1276] = {.lex_state = 55, .external_lex_state = 37},
  [1277] = {.lex_state = 55, .external_lex_state = 37},
  [1278] = {.lex_state = 56, .external_lex_state = 14},
  [1279] = {.lex_state = 55, .external_lex_state = 37},
  [1280] = {.lex_state = 55, .external_lex_state = 37},
  [1281] = {.lex_state = 56, .external_lex_state = 14},
  [1282] = {.lex_state = 55, .external_lex_state = 37},
  [1283] = {.lex_state = 55, .external_lex_state = 37},
  [1284] = {.lex_state = 56, .external_lex_state = 14},
  [1285] = {.lex_state = 55, .external_lex_state = 37},
  [1286] = {.lex_state = 55, .external_lex_state = 37},
  [1287] = {.lex_state = 56, .external_lex_state = 14},
  [1288] = {.lex_state = 55, .external_lex_state = 37},
  [1289] = {.lex_state = 56, .external_lex_state = 14},
  [1290] = {.lex_state = 56, .external_lex_state = 14},
  [1291] = {.lex_state = 55, .external_lex_state = 37},
  [1292] = {.lex_state = 56, .external_lex_state = 14},
  [1293] = {.lex_state = 55, .external_lex_state = 37},
  [1294] = {.lex_state = 55, .external_lex_state = 37},
  [1295] = {.lex_state = 55, .external_lex_state = 37},
  [1296] = {.lex_state = 55, .external_lex_state = 37},
  [1297] = {.lex_state = 55, .external_lex_state = 3},
  [1298] = {.lex_state = 56, .external_lex_state = 14},
  [1299] = {.lex_state = 55, .external_lex_state = 37},
  [1300] = {.lex_state = 55, .external_lex_state = 37},
  [1301] = {.lex_state = 55, .external_lex_state = 37},
  [1302] = {.lex_state = 56, .external_lex_state = 14},
  [1303] = {.lex_state = 55, .external_lex_state = 37},
  [1304] = {.lex_state = 55, .external_lex_state = 37},
  [1305] = {.lex_state = 55, .external_lex_state = 37},
  [1306] = {.lex_state = 55, .external_lex_state = 37},
  [1307] = {.lex_state = 55, .external_lex_state = 37},
  [1308] = {.lex_state = 55, .external_lex_state = 37},
  [1309] = {.lex_state = 55, .external_lex_state = 37},
  [1310] = {.lex_state = 55, .external_lex_state = 37},
  [1311] = {.lex_state = 55, .external_lex_state = 37},
  [1312] = {.lex_state = 55, .external_lex_state = 37},
  [1313] = {.lex_state = 55, .external_lex_state = 37},
  [1314] = {.lex_state = 55, .external_lex_state = 37},
  [1315] = {.lex_state = 55, .external_lex_state = 37},
  [1316] = {.lex_state = 55, .external_lex_state = 37},
  [1317] = {.lex_state = 55, .external_lex_state = 37},
  [1318] = {.lex_state = 55, .external_lex_state = 37},
  [1319] = {.lex_state = 55, .external_lex_state = 37},
  [1320] = {.lex_state = 55, .external_lex_state = 37},
  [1321] = {.lex_state = 55, .external_lex_state = 37},
  [1322] = {.lex_state = 55, .external_lex_state = 37},
  [1323] = {.lex_state = 55, .external_lex_state = 37},
  [1324] = {.lex_state = 55, .external_lex_state = 37},
  [1325] = {.lex_state = 55, .external_lex_state = 37},
  [1326] = {.lex_state = 55, .external_lex_state = 37},
  [1327] = {.lex_state = 55, .external_lex_state = 37},
  [1328] = {.lex_state = 55, .external_lex_state = 37},
  [1329] = {.lex_state = 55, .external_lex_state = 37},
  [1330] = {.lex_state = 55, .external_lex_state = 37},
  [1331] = {.lex_state = 55, .external_lex_state = 37},
  [1332] = {.lex_state = 55, .external_lex_state = 37},
  [1333] = {.lex_state = 55, .external_lex_state = 37},
  [1334] = {.lex_state = 55, .external_lex_state = 37},
  [1335] = {.lex_state = 55, .external_lex_state = 37},
  [1336] = {.lex_state = 55, .external_lex_state = 37},
  [1337] = {.lex_state = 55, .external_lex_state = 37},
  [1338] = {.lex_state = 55, .external_lex_state = 37},
  [1339] = {.lex_state = 55, .external_lex_state = 37},
  [1340] = {.lex_state = 55, .external_lex_state = 37},
  [1341] = {.lex_state = 55, .external_lex_state = 37},
  [1342] = {.lex_state = 55, .external_lex_state = 3},
  [1343] = {.lex_state = 55, .external_lex_state = 37},
  [1344] = {.lex_state = 55, .external_lex_state = 37},
  [1345] = {.lex_state = 55, .external_lex_state = 37},
  [1346] = {.lex_state = 55, .external_lex_state = 37},
  [1347] = {.lex_state = 55, .external_lex_state = 37},
  [1348] = {.lex_state = 55, .external_lex_state = 37},
  [1349] = {.lex_state = 55, .external_lex_state = 37},
  [1350] = {.lex_state = 55, .external_lex_state = 37},
  [1351] = {.lex_state = 55, .external_lex_state = 37},
  [1352] = {.lex_state = 55, .external_lex_state = 37},
  [1353] = {.lex_state = 55, .external_lex_state = 37},
  [1354] = {.lex_state = 55, .external_lex_state = 37},
  [1355] = {.lex_state = 55, .external_lex_state = 37},
  [1356] = {.lex_state = 55, .external_lex_state = 37},
  [1357] = {.lex_state = 55, .external_lex_state = 37},
  [1358] = {.lex_state = 55, .external_lex_state = 37},
  [1359] = {.lex_state = 55, .external_lex_state = 37},
  [1360] = {.lex_state = 55, .external_lex_state = 37},
  [1361] = {.lex_state = 55, .external_lex_state = 37},
  [1362] = {.lex_state = 55, .external_lex_state = 37},
  [1363] = {.lex_state = 55, .external_lex_state = 3},
  [1364] = {.lex_state = 55, .external_lex_state = 37},
  [1365] = {.lex_state = 55, .external_lex_state = 37},
  [1366] = {.lex_state = 55, .external_lex_state = 37},
  [1367] = {.lex_state = 55, .external_lex_state = 37},
  [1368] = {.lex_state = 55, .external_lex_state = 3},
  [1369] = {.lex_state = 55, .external_lex_state = 37},
  [1370] = {.lex_state = 55, .external_lex_state = 37},
  [1371] = {.lex_state = 55, .external_lex_state = 37},
  [1372] = {.lex_state = 55, .external_lex_state = 37},
  [1373] = {.lex_state = 55, .external_lex_state = 37},
  [1374] = {.lex_state = 55, .external_lex_state = 37},
  [1375] = {.lex_state = 55, .external_lex_state = 37},
  [1376] = {.lex_state = 55, .external_lex_state = 37},
  [1377] = {.lex_state = 55, .external_lex_state = 37},
  [1378] = {.lex_state = 55, .external_lex_state = 37},
  [1379] = {.lex_state = 55, .external_lex_state = 37},
  [1380] = {.lex_state = 55, .external_lex_state = 37},
  [1381] = {.lex_state = 55, .external_lex_state = 37},
  [1382] = {.lex_state = 55, .external_lex_state = 37},
  [1383] = {.lex_state = 55, .external_lex_state = 37},
  [1384] = {.lex_state = 55, .external_lex_state = 37},
  [1385] = {.lex_state = 55, .external_lex_state = 37},
  [1386] = {.lex_state = 55, .external_lex_state = 37},
  [1387] = {.lex_state = 55, .external_lex_state = 37},
  [1388] = {.lex_state = 55, .external_lex_state = 37},
  [1389] = {.lex_state = 55, .external_lex_state = 3},
  [1390] = {.lex_state = 55, .external_lex_state = 37},
  [1391] = {.lex_state = 55, .external_lex_state = 37},
  [1392] = {.lex_state = 55, .external_lex_state = 37},
  [1393] = {.lex_state = 55, .external_lex_state = 3},
  [1394] = {.lex_state = 55, .external_lex_state = 37},
  [1395] = {.lex_state = 55, .external_lex_state = 37},
  [1396] = {.lex_state = 55, .external_lex_state = 37},
  [1397] = {.lex_state = 55, .external_lex_state = 37},
  [1398] = {.lex_state = 55, .external_lex_state = 37},
  [1399] = {.lex_state = 55, .external_lex_state = 37},
  [1400] = {.lex_state = 55, .external_lex_state = 37},
  [1401] = {.lex_state = 55, .external_lex_state = 37},
  [1402] = {.lex_state = 55, .external_lex_state = 37},
  [1403] = {.lex_state = 55, .external_lex_state = 37},
  [1404] = {.lex_state = 55, .external_lex_state = 37},
  [1405] = {.lex_state = 55, .external_lex_state = 37},
  [1406] = {.lex_state = 55, .external_lex_state = 37},
  [1407] = {.lex_state = 55, .external_lex_state = 37},
  [1408] = {.lex_state = 55, .external_lex_state = 37},
  [1409] = {.lex_state = 55, .external_lex_state = 37},
  [1410] = {.lex_state = 55, .external_lex_state = 37},
  [1411] = {.lex_state = 55, .external_lex_state = 37},
  [1412] = {.lex_state = 55, .external_lex_state = 37},
  [1413] = {.lex_state = 55, .external_lex_state = 37},
  [1414] = {.lex_state = 55, .external_lex_state = 37},
  [1415] = {.lex_state = 55, .external_lex_state = 37},
  [1416] = {.lex_state = 55, .external_lex_state = 37},
  [1417] = {.lex_state = 55, .external_lex_state = 37},
  [1418] = {.lex_state = 55, .external_lex_state = 37},
  [1419] = {.lex_state = 55, .external_lex_state = 37},
  [1420] = {.lex_state = 55, .external_lex_state = 37},
  [1421] = {.lex_state = 55, .external_lex_state = 37},
  [1422] = {.lex_state = 55, .external_lex_state = 37},
  [1423] = {.lex_state = 55, .external_lex_state = 37},
  [1424] = {.lex_state = 55, .external_lex_state = 37},
  [1425] = {.lex_state = 55, .external_lex_state = 37},
  [1426] = {.lex_state = 55, .external_lex_state = 37},
  [1427] = {.lex_state = 55, .external_lex_state = 37},
  [1428] = {.lex_state = 55, .external_lex_state = 37},
  [1429] = {.lex_state = 55, .external_lex_state = 37},
  [1430] = {.lex_state = 55, .external_lex_state = 37},
  [1431] = {.lex_state = 55, .external_lex_state = 37},
  [1432] = {.lex_state = 55, .external_lex_state = 37},
  [1433] = {.lex_state = 55, .external_lex_state = 37},
  [1434] = {.lex_state = 55, .external_lex_state = 37},
  [1435] = {.lex_state = 55, .external_lex_state = 37},
  [1436] = {.lex_state = 55, .external_lex_state = 37},
  [1437] = {.lex_state = 55, .external_lex_state = 37},
  [1438] = {.lex_state = 55, .external_lex_state = 37},
  [1439] = {.lex_state = 55, .external_lex_state = 37},
  [1440] = {.lex_state = 55, .external_lex_state = 37},
  [1441] = {.lex_state = 55, .external_lex_state = 37},
  [1442] = {.lex_state = 55, .external_lex_state = 37},
  [1443] = {.lex_state = 55, .external_lex_state = 37},
  [1444] = {.lex_state = 55, .external_lex_state = 37},
  [1445] = {.lex_state = 55, .external_lex_state = 37},
  [1446] = {.lex_state = 55, .external_lex_state = 37},
  [1447] = {.lex_state = 55, .external_lex_state = 37},
  [1448] = {.lex_state = 55, .external_lex_state = 37},
  [1449] = {.lex_state = 55, .external_lex_state = 37},
  [1450] = {.lex_state = 55, .external_lex_state = 37},
  [1451] = {.lex_state = 55, .external_lex_state = 37},
  [1452] = {.lex_state = 55, .external_lex_state = 37},
  [1453] = {.lex_state = 55, .external_lex_state = 37},
  [1454] = {.lex_state = 55, .external_lex_state = 37},
  [1455] = {.lex_state = 55, .external_lex_state = 37},
  [1456] = {.lex_state = 55, .external_lex_state = 37},
  [1457] = {.lex_state = 55, .external_lex_state = 37},
  [1458] = {.lex_state = 55, .external_lex_state = 37},
  [1459] = {.lex_state = 55, .external_lex_state = 37},
  [1460] = {.lex_state = 55, .external_lex_state = 37},
  [1461] = {.lex_state = 55, .external_lex_state = 37},
  [1462] = {.lex_state = 55, .external_lex_state = 37},
  [1463] = {.lex_state = 55, .external_lex_state = 37},
  [1464] = {.lex_state = 55, .external_lex_state = 37},
  [1465] = {.lex_state = 55, .external_lex_state = 37},
  [1466] = {.lex_state = 55, .external_lex_state = 37},
  [1467] = {.lex_state = 55, .external_lex_state = 37},
  [1468] = {.lex_state = 55, .external_lex_state = 37},
  [1469] = {.lex_state = 55, .external_lex_state = 37},
  [1470] = {.lex_state = 55, .external_lex_state = 3},
  [1471] = {.lex_state = 55, .external_lex_state = 37},
  [1472] = {.lex_state = 55, .external_lex_state = 37},
  [1473] = {.lex_state = 55, .external_lex_state = 37},
  [1474] = {.lex_state = 55, .external_lex_state = 37},
  [1475] = {.lex_state = 55, .external_lex_state = 37},
  [1476] = {.lex_state = 55, .external_lex_state = 37},
  [1477] = {.lex_state = 55, .external_lex_state = 37},
  [1478] = {.lex_state = 55, .external_lex_state = 37},
  [1479] = {.lex_state = 55, .external_lex_state = 37},
  [1480] = {.lex_state = 55, .external_lex_state = 37},
  [1481] = {.lex_state = 55, .external_lex_state = 37},
  [1482] = {.lex_state = 55, .external_lex_state = 37},
  [1483] = {.lex_state = 55, .external_lex_state = 37},
  [1484] = {.lex_state = 55, .external_lex_state = 37},
  [1485] = {.lex_state = 55, .external_lex_state = 37},
  [1486] = {.lex_state = 55, .external_lex_state = 37},
  [1487] = {.lex_state = 55, .external_lex_state = 37},
  [1488] = {.lex_state = 55, .external_lex_state = 37},
  [1489] = {.lex_state = 55, .external_lex_state = 3},
  [1490] = {.lex_state = 55, .external_lex_state = 37},
  [1491] = {.lex_state = 55, .external_lex_state = 37},
  [1492] = {.lex_state = 55, .external_lex_state = 3},
  [1493] = {.lex_state = 55, .external_lex_state = 37},
  [1494] = {.lex_state = 55, .external_lex_state = 37},
  [1495] = {.lex_state = 55, .external_lex_state = 37},
  [1496] = {.lex_state = 55, .external_lex_state = 37},
  [1497] = {.lex_state = 55, .external_lex_state = 37},
  [1498] = {.lex_state = 55, .external_lex_state = 37},
  [1499] = {.lex_state = 55, .external_lex_state = 37},
  [1500] = {.lex_state = 55, .external_lex_state = 37},
  [1501] = {.lex_state = 55, .external_lex_state = 37},
  [1502] = {.lex_state = 55, .external_lex_state = 37},
  [1503] = {.lex_state = 55, .external_lex_state = 37},
  [1504] = {.lex_state = 55, .external_lex_state = 37},
  [1505] = {.lex_state = 55, .external_lex_state = 37},
  [1506] = {.lex_state = 55, .external_lex_state = 37},
  [1507] = {.lex_state = 55, .external_lex_state = 37},
  [1508] = {.lex_state = 55, .external_lex_state = 37},
  [1509] = {.lex_state = 55, .external_lex_state = 37},
  [1510] = {.lex_state = 55, .external_lex_state = 37},
  [1511] = {.lex_state = 55, .external_lex_state = 37},
  [1512] = {.lex_state = 55, .external_lex_state = 37},
  [1513] = {.lex_state = 55, .external_lex_state = 37},
  [1514] = {.lex_state = 55, .external_lex_state = 3},
  [1515] = {.lex_state = 55, .external_lex_state = 37},
  [1516] = {.lex_state = 55, .external_lex_state = 37},
  [1517] = {.lex_state = 55, .external_lex_state = 37},
  [1518] = {.lex_state = 55, .external_lex_state = 37},
  [1519] = {.lex_state = 55, .external_lex_state = 37},
  [1520] = {.lex_state = 55, .external_lex_state = 37},
  [1521] = {.lex_state = 55, .external_lex_state = 37},
  [1522] = {.lex_state = 55, .external_lex_state = 37},
  [1523] = {.lex_state = 55, .external_lex_state = 37},
  [1524] = {.lex_state = 55, .external_lex_state = 37},
  [1525] = {.lex_state = 55, .external_lex_state = 37},
  [1526] = {.lex_state = 55, .external_lex_state = 37},
  [1527] = {.lex_state = 55, .external_lex_state = 37},
  [1528] = {.lex_state = 55, .external_lex_state = 37},
  [1529] = {.lex_state = 55, .external_lex_state = 37},
  [1530] = {.lex_state = 55, .external_lex_state = 37},
  [1531] = {.lex_state = 55, .external_lex_state = 37},
  [1532] = {.lex_state = 55, .external_lex_state = 37},
  [1533] = {.lex_state = 55, .external_lex_state = 37},
  [1534] = {.lex_state = 55, .external_lex_state = 37},
  [1535] = {.lex_state = 55, .external_lex_state = 37},
  [1536] = {.lex_state = 55, .external_lex_state = 37},
  [1537] = {.lex_state = 55, .external_lex_state = 37},
  [1538] = {.lex_state = 55, .external_lex_state = 37},
  [1539] = {.lex_state = 55, .external_lex_state = 3},
  [1540] = {.lex_state = 55, .external_lex_state = 37},
  [1541] = {.lex_state = 55, .external_lex_state = 37},
  [1542] = {.lex_state = 55, .external_lex_state = 37},
  [1543] = {.lex_state = 55, .external_lex_state = 37},
  [1544] = {.lex_state = 55, .external_lex_state = 37},
  [1545] = {.lex_state = 55, .external_lex_state = 37},
  [1546] = {.lex_state = 55, .external_lex_state = 37},
  [1547] = {.lex_state = 55, .external_lex_state = 37},
  [1548] = {.lex_state = 55, .external_lex_state = 37},
  [1549] = {.lex_state = 55, .external_lex_state = 37},
  [1550] = {.lex_state = 55, .external_lex_state = 37},
  [1551] = {.lex_state = 55, .external_lex_state = 37},
  [1552] = {.lex_state = 55, .external_lex_state = 37},
  [1553] = {.lex_state = 55, .external_lex_state = 37},
  [1554] = {.lex_state = 55, .external_lex_state = 37},
  [1555] = {.lex_state = 55, .external_lex_state = 37},
  [1556] = {.lex_state = 55, .external_lex_state = 37},
  [1557] = {.lex_state = 55, .external_lex_state = 37},
  [1558] = {.lex_state = 55, .external_lex_state = 37},
  [1559] = {.lex_state = 55, .external_lex_state = 37},
  [1560] = {.lex_state = 55, .external_lex_state = 37},
  [1561] = {.lex_state = 55, .external_lex_state = 37},
  [1562] = {.lex_state = 55, .external_lex_state = 37},
  [1563] = {.lex_state = 55, .external_lex_state = 37},
  [1564] = {.lex_state = 55, .external_lex_state = 37},
  [1565] = {.lex_state = 55, .external_lex_state = 37},
  [1566] = {.lex_state = 55, .external_lex_state = 37},
  [1567] = {.lex_state = 55, .external_lex_state = 37},
  [1568] = {.lex_state = 55, .external_lex_state = 37},
  [1569] = {.lex_state = 55, .external_lex_state = 37},
  [1570] = {.lex_state = 55, .external_lex_state = 37},
  [1571] = {.lex_state = 55, .external_lex_state = 37},
  [1572] = {.lex_state = 55, .external_lex_state = 37},
  [1573] = {.lex_state = 55, .external_lex_state = 37},
  [1574] = {.lex_state = 55, .external_lex_state = 37},
  [1575] = {.lex_state = 55, .external_lex_state = 37},
  [1576] = {.lex_state = 55, .external_lex_state = 37},
  [1577] = {.lex_state = 55, .external_lex_state = 37},
  [1578] = {.lex_state = 55, .external_lex_state = 37},
  [1579] = {.lex_state = 55, .external_lex_state = 37},
  [1580] = {.lex_state = 55, .external_lex_state = 37},
  [1581] = {.lex_state = 55, .external_lex_state = 37},
  [1582] = {.lex_state = 55, .external_lex_state = 37},
  [1583] = {.lex_state = 55, .external_lex_state = 37},
  [1584] = {.lex_state = 55, .external_lex_state = 37},
  [1585] = {.lex_state = 55, .external_lex_state = 37},
  [1586] = {.lex_state = 55, .external_lex_state = 37},
  [1587] = {.lex_state = 55, .external_lex_state = 37},
  [1588] = {.lex_state = 55, .external_lex_state = 37},
  [1589] = {.lex_state = 55, .external_lex_state = 37},
  [1590] = {.lex_state = 55, .external_lex_state = 37},
  [1591] = {.lex_state = 55, .external_lex_state = 37},
  [1592] = {.lex_state = 55, .external_lex_state = 37},
  [1593] = {.lex_state = 55, .external_lex_state = 37},
  [1594] = {.lex_state = 55, .external_lex_state = 37},
  [1595] = {.lex_state = 55, .external_lex_state = 37},
  [1596] = {.lex_state = 55, .external_lex_state = 3},
  [1597] = {.lex_state = 55, .external_lex_state = 37},
  [1598] = {.lex_state = 55, .external_lex_state = 37},
  [1599] = {.lex_state = 55, .external_lex_state = 37},
  [1600] = {.lex_state = 55, .external_lex_state = 37},
  [1601] = {.lex_state = 55, .external_lex_state = 37},
  [1602] = {.lex_state = 55, .external_lex_state = 37},
  [1603] = {.lex_state = 55, .external_lex_state = 37},
  [1604] = {.lex_state = 55, .external_lex_state = 37},
  [1605] = {.lex_state = 55, .external_lex_state = 37},
  [1606] = {.lex_state = 55, .external_lex_state = 3},
  [1607] = {.lex_state = 55, .external_lex_state = 37},
  [1608] = {.lex_state = 55, .external_lex_state = 37},
  [1609] = {.lex_state = 55, .external_lex_state = 37},
  [1610] = {.lex_state = 55, .external_lex_state = 37},
  [1611] = {.lex_state = 55, .external_lex_state = 37},
  [1612] = {.lex_state = 55, .external_lex_state = 37},
  [1613] = {.lex_state = 55, .external_lex_state = 37},
  [1614] = {.lex_state = 55, .external_lex_state = 37},
  [1615] = {.lex_state = 55, .external_lex_state = 37},
  [1616] = {.lex_state = 55, .external_lex_state = 37},
  [1617] = {.lex_state = 55, .external_lex_state = 37},
  [1618] = {.lex_state = 55, .external_lex_state = 37},
  [1619] = {.lex_state = 55, .external_lex_state = 37},
  [1620] = {.lex_state = 55, .external_lex_state = 37},
  [1621] = {.lex_state = 55, .external_lex_state = 37},
  [1622] = {.lex_state = 55, .external_lex_state = 37},
  [1623] = {.lex_state = 55, .external_lex_state = 37},
  [1624] = {.lex_state = 55, .external_lex_state = 37},
  [1625] = {.lex_state = 55, .external_lex_state = 37},
  [1626] = {.lex_state = 55, .external_lex_state = 37},
  [1627] = {.lex_state = 55, .external_lex_state = 37},
  [1628] = {.lex_state = 55, .external_lex_state = 37},
  [1629] = {.lex_state = 55, .external_lex_state = 37},
  [1630] = {.lex_state = 55, .external_lex_state = 37},
  [1631] = {.lex_state = 55, .external_lex_state = 37},
  [1632] = {.lex_state = 55, .external_lex_state = 37},
  [1633] = {.lex_state = 55, .external_lex_state = 37},
  [1634] = {.lex_state = 55, .external_lex_state = 37},
  [1635] = {.lex_state = 55, .external_lex_state = 37},
  [1636] = {.lex_state = 55, .external_lex_state = 37},
  [1637] = {.lex_state = 55, .external_lex_state = 37},
  [1638] = {.lex_state = 55, .external_lex_state = 37},
  [1639] = {.lex_state = 55, .external_lex_state = 37},
  [1640] = {.lex_state = 55, .external_lex_state = 37},
  [1641] = {.lex_state = 55, .external_lex_state = 37},
  [1642] = {.lex_state = 55, .external_lex_state = 37},
  [1643] = {.lex_state = 55, .external_lex_state = 37},
  [1644] = {.lex_state = 55, .external_lex_state = 37},
  [1645] = {.lex_state = 55, .external_lex_state = 37},
  [1646] = {.lex_state = 55, .external_lex_state = 37},
  [1647] = {.lex_state = 55, .external_lex_state = 37},
  [1648] = {.lex_state = 55, .external_lex_state = 3},
  [1649] = {.lex_state = 55, .external_lex_state = 37},
  [1650] = {.lex_state = 55, .external_lex_state = 37},
  [1651] = {.lex_state = 55, .external_lex_state = 37},
  [1652] = {.lex_state = 55, .external_lex_state = 37},
  [1653] = {.lex_state = 55, .external_lex_state = 37},
  [1654] = {.lex_state = 55, .external_lex_state = 37},
  [1655] = {.lex_state = 55, .external_lex_state = 37},
  [1656] = {.lex_state = 55, .external_lex_state = 37},
  [1657] = {.lex_state = 55, .external_lex_state = 37},
  [1658] = {.lex_state = 55, .external_lex_state = 37},
  [1659] = {.lex_state = 55, .external_lex_state = 37},
  [1660] = {.lex_state = 55, .external_lex_state = 37},
  [1661] = {.lex_state = 55, .external_lex_state = 37},
  [1662] = {.lex_state = 55, .external_lex_state = 37},
  [1663] = {.lex_state = 55, .external_lex_state = 37},
  [1664] = {.lex_state = 55, .external_lex_state = 37},
  [1665] = {.lex_state = 55, .external_lex_state = 37},
  [1666] = {.lex_state = 55, .external_lex_state = 37},
  [1667] = {.lex_state = 55, .external_lex_state = 37},
  [1668] = {.lex_state = 55, .external_lex_state = 37},
  [1669] = {.lex_state = 55, .external_lex_state = 37},
  [1670] = {.lex_state = 55, .external_lex_state = 37},
  [1671] = {.lex_state = 55, .external_lex_state = 37},
  [1672] = {.lex_state = 55, .external_lex_state = 37},
  [1673] = {.lex_state = 55, .external_lex_state = 37},
  [1674] = {.lex_state = 55, .external_lex_state = 37},
  [1675] = {.lex_state = 55, .external_lex_state = 37},
  [1676] = {.lex_state = 55, .external_lex_state = 37},
  [1677] = {.lex_state = 55, .external_lex_state = 37},
  [1678] = {.lex_state = 55, .external_lex_state = 37},
  [1679] = {.lex_state = 55, .external_lex_state = 37},
  [1680] = {.lex_state = 55, .external_lex_state = 37},
  [1681] = {.lex_state = 55, .external_lex_state = 37},
  [1682] = {.lex_state = 55, .external_lex_state = 37},
  [1683] = {.lex_state = 55, .external_lex_state = 37},
  [1684] = {.lex_state = 55, .external_lex_state = 37},
  [1685] = {.lex_state = 55, .external_lex_state = 37},
  [1686] = {.lex_state = 55, .external_lex_state = 37},
  [1687] = {.lex_state = 55, .external_lex_state = 37},
  [1688] = {.lex_state = 55, .external_lex_state = 37},
  [1689] = {.lex_state = 55, .external_lex_state = 37},
  [1690] = {.lex_state = 55, .external_lex_state = 37},
  [1691] = {.lex_state = 55, .external_lex_state = 37},
  [1692] = {.lex_state = 55, .external_lex_state = 37},
  [1693] = {.lex_state = 55, .external_lex_state = 37},
  [1694] = {.lex_state = 55, .external_lex_state = 37},
  [1695] = {.lex_state = 55, .external_lex_state = 37},
  [1696] = {.lex_state = 55, .external_lex_state = 37},
  [1697] = {.lex_state = 55, .external_lex_state = 37},
  [1698] = {.lex_state = 55, .external_lex_state = 37},
  [1699] = {.lex_state = 55, .external_lex_state = 37},
  [1700] = {.lex_state = 55, .external_lex_state = 37},
  [1701] = {.lex_state = 55, .external_lex_state = 37},
  [1702] = {.lex_state = 55, .external_lex_state = 37},
  [1703] = {.lex_state = 55, .external_lex_state = 37},
  [1704] = {.lex_state = 55, .external_lex_state = 37},
  [1705] = {.lex_state = 55, .external_lex_state = 37},
  [1706] = {.lex_state = 55, .external_lex_state = 37},
  [1707] = {.lex_state = 55, .external_lex_state = 37},
  [1708] = {.lex_state = 55, .external_lex_state = 37},
  [1709] = {.lex_state = 55, .external_lex_state = 37},
  [1710] = {.lex_state = 55, .external_lex_state = 37},
  [1711] = {.lex_state = 55, .external_lex_state = 37},
  [1712] = {.lex_state = 55, .external_lex_state = 37},
  [1713] = {.lex_state = 55, .external_lex_state = 37},
  [1714] = {.lex_state = 55, .external_lex_state = 37},
  [1715] = {.lex_state = 55, .external_lex_state = 37},
  [1716] = {.lex_state = 55, .external_lex_state = 37},
  [1717] = {.lex_state = 55, .external_lex_state = 37},
  [1718] = {.lex_state = 55, .external_lex_state = 37},
  [1719] = {.lex_state = 55, .external_lex_state = 37},
  [1720] = {.lex_state = 55, .external_lex_state = 37},
  [1721] = {.lex_state = 55, .external_lex_state = 37},
  [1722] = {.lex_state = 55, .external_lex_state = 37},
  [1723] = {.lex_state = 55, .external_lex_state = 37},
  [1724] = {.lex_state = 55, .external_lex_state = 37},
  [1725] = {.lex_state = 55, .external_lex_state = 37},
  [1726] = {.lex_state = 55, .external_lex_state = 37},
  [1727] = {.lex_state = 55, .external_lex_state = 37},
  [1728] = {.lex_state = 55, .external_lex_state = 37},
  [1729] = {.lex_state = 55, .external_lex_state = 37},
  [1730] = {.lex_state = 55, .external_lex_state = 37},
  [1731] = {.lex_state = 55, .external_lex_state = 37},
  [1732] = {.lex_state = 55, .external_lex_state = 37},
  [1733] = {.lex_state = 55, .external_lex_state = 37},
  [1734] = {.lex_state = 55, .external_lex_state = 37},
  [1735] = {.lex_state = 55, .external_lex_state = 37},
  [1736] = {.lex_state = 55, .external_lex_state = 37},
  [1737] = {.lex_state = 55, .external_lex_state = 37},
  [1738] = {.lex_state = 55, .external_lex_state = 37},
  [1739] = {.lex_state = 55, .external_lex_state = 37},
  [1740] = {.lex_state = 55, .external_lex_state = 37},
  [1741] = {.lex_state = 55, .external_lex_state = 37},
  [1742] = {.lex_state = 55, .external_lex_state = 37},
  [1743] = {.lex_state = 55, .external_lex_state = 37},
  [1744] = {.lex_state = 55, .external_lex_state = 37},
  [1745] = {.lex_state = 55, .external_lex_state = 37},
  [1746] = {.lex_state = 55, .external_lex_state = 37},
  [1747] = {.lex_state = 55, .external_lex_state = 37},
  [1748] = {.lex_state = 55, .external_lex_state = 37},
  [1749] = {.lex_state = 55, .external_lex_state = 37},
  [1750] = {.lex_state = 55, .external_lex_state = 37},
  [1751] = {.lex_state = 55, .external_lex_state = 37},
  [1752] = {.lex_state = 55, .external_lex_state = 37},
  [1753] = {.lex_state = 55, .external_lex_state = 37},
  [1754] = {.lex_state = 55, .external_lex_state = 37},
  [1755] = {.lex_state = 55, .external_lex_state = 37},
  [1756] = {.lex_state = 55, .external_lex_state = 37},
  [1757] = {.lex_state = 55, .external_lex_state = 37},
  [1758] = {.lex_state = 55, .external_lex_state = 37},
  [1759] = {.lex_state = 55, .external_lex_state = 37},
  [1760] = {.lex_state = 55, .external_lex_state = 37},
  [1761] = {.lex_state = 55, .external_lex_state = 37},
  [1762] = {.lex_state = 55, .external_lex_state = 37},
  [1763] = {.lex_state = 55, .external_lex_state = 37},
  [1764] = {.lex_state = 55, .external_lex_state = 37},
  [1765] = {.lex_state = 55, .external_lex_state = 37},
  [1766] = {.lex_state = 55, .external_lex_state = 37},
  [1767] = {.lex_state = 55, .external_lex_state = 37},
  [1768] = {.lex_state = 55, .external_lex_state = 37},
  [1769] = {.lex_state = 55, .external_lex_state = 37},
  [1770] = {.lex_state = 55, .external_lex_state = 3},
  [1771] = {.lex_state = 55, .external_lex_state = 37},
  [1772] = {.lex_state = 55, .external_lex_state = 37},
  [1773] = {.lex_state = 55, .external_lex_state = 37},
  [1774] = {.lex_state = 55, .external_lex_state = 37},
  [1775] = {.lex_state = 55, .external_lex_state = 37},
  [1776] = {.lex_state = 55, .external_lex_state = 37},
  [1777] = {.lex_state = 55, .external_lex_state = 37},
  [1778] = {.lex_state = 55, .external_lex_state = 37},
  [1779] = {.lex_state = 55, .external_lex_state = 37},
  [1780] = {.lex_state = 55, .external_lex_state = 37},
  [1781] = {.lex_state = 55, .external_lex_state = 3},
  [1782] = {.lex_state = 55, .external_lex_state = 37},
  [1783] = {.lex_state = 55, .external_lex_state = 3},
  [1784] = {.lex_state = 55, .external_lex_state = 37},
  [1785] = {.lex_state = 55, .external_lex_state = 37},
  [1786] = {.lex_state = 55, .external_lex_state = 37},
  [1787] = {.lex_state = 55, .external_lex_state = 37},
  [1788] = {.lex_state = 55, .external_lex_state = 37},
  [1789] = {.lex_state = 55, .external_lex_state = 37},
  [1790] = {.lex_state = 55, .external_lex_state = 37},
  [1791] = {.lex_state = 55, .external_lex_state = 37},
  [1792] = {.lex_state = 55, .external_lex_state = 37},
  [1793] = {.lex_state = 55, .external_lex_state = 37},
  [1794] = {.lex_state = 55, .external_lex_state = 37},
  [1795] = {.lex_state = 55, .external_lex_state = 37},
  [1796] = {.lex_state = 55, .external_lex_state = 37},
  [1797] = {.lex_state = 55, .external_lex_state = 37},
  [1798] = {.lex_state = 55, .external_lex_state = 37},
  [1799] = {.lex_state = 55, .external_lex_state = 37},
  [1800] = {.lex_state = 55, .external_lex_state = 3},
  [1801] = {.lex_state = 55, .external_lex_state = 37},
  [1802] = {.lex_state = 55, .external_lex_state = 37},
  [1803] = {.lex_state = 55, .external_lex_state = 37},
  [1804] = {.lex_state = 55, .external_lex_state = 3},
  [1805] = {.lex_state = 55, .external_lex_state = 37},
  [1806] = {.lex_state = 55, .external_lex_state = 37},
  [1807] = {.lex_state = 55, .external_lex_state = 37},
  [1808] = {.lex_state = 55, .external_lex_state = 37},
  [1809] = {.lex_state = 55, .external_lex_state = 37},
  [1810] = {.lex_state = 55, .external_lex_state = 37},
  [1811] = {.lex_state = 55, .external_lex_state = 3},
  [1812] = {.lex_state = 55, .external_lex_state = 37},
  [1813] = {.lex_state = 55, .external_lex_state = 3},
  [1814] = {.lex_state = 55, .external_lex_state = 37},
  [1815] = {.lex_state = 55, .external_lex_state = 37},
  [1816] = {.lex_state = 55, .external_lex_state = 37},
  [1817] = {.lex_state = 55, .external_lex_state = 37},
  [1818] = {.lex_state = 56, .external_lex_state = 14},
  [1819] = {.lex_state = 56, .external_lex_state = 14},
  [1820] = {.lex_state = 55, .external_lex_state = 4},
  [1821] = {.lex_state = 56, .external_lex_state = 14},
  [1822] = {.lex_state = 55, .external_lex_state = 37},
  [1823] = {.lex_state = 56, .external_lex_state = 14},
  [1824] = {.lex_state = 55, .external_lex_state = 37},
  [1825] = {.lex_state = 56, .external_lex_state = 14},
  [1826] = {.lex_state = 56, .external_lex_state = 14},
  [1827] = {.lex_state = 56, .external_lex_state = 14},
  [1828] = {.lex_state = 56, .external_lex_state = 14},
  [1829] = {.lex_state = 55, .external_lex_state = 4},
  [1830] = {.lex_state = 56, .external_lex_state = 14},
  [1831] = {.lex_state = 56, .external_lex_state = 14},
  [1832] = {.lex_state = 56, .external_lex_state = 14},
  [1833] = {.lex_state = 56, .external_lex_state = 14},
  [1834] = {.lex_state = 56, .external_lex_state = 14},
  [1835] = {.lex_state = 55, .external_lex_state = 4},
  [1836] = {.lex_state = 55, .external_lex_state = 4},
  [1837] = {.lex_state = 56, .external_lex_state = 14},
  [1838] = {.lex_state = 56, .external_lex_state = 14},
  [1839] = {.lex_state = 56, .external_lex_state = 14},
  [1840] = {.lex_state = 55, .external_lex_state = 37},
  [1841] = {.lex_state = 56, .external_lex_state = 14},
  [1842] = {.lex_state = 55, .external_lex_state = 37},
  [1843] = {.lex_state = 55, .external_lex_state = 4},
  [1844] = {.lex_state = 56, .external_lex_state = 14},
  [1845] = {.lex_state = 56, .external_lex_state = 14},
  [1846] = {.lex_state = 56, .external_lex_state = 14},
  [1847] = {.lex_state = 55, .external_lex_state = 37},
  [1848] = {.lex_state = 56, .external_lex_state = 14},
  [1849] = {.lex_state = 55, .external_lex_state = 37},
  [1850] = {.lex_state = 56, .external_lex_state = 14},
  [1851] = {.lex_state = 56, .external_lex_state = 14},
  [1852] = {.lex_state = 56, .external_lex_state = 14},
  [1853] = {.lex_state = 56, .external_lex_state = 14},
  [1854] = {.lex_state = 55, .external_lex_state = 37},
  [1855] = {.lex_state = 56, .external_lex_state = 14},
  [1856] = {.lex_state = 56, .external_lex_state = 14},
  [1857] = {.lex_state = 56, .external_lex_state = 14},
  [1858] = {.lex_state = 56, .external_lex_state = 14},
  [1859] = {.lex_state = 56, .external_lex_state = 14},
  [1860] = {.lex_state = 56, .external_lex_state = 14},
  [1861] = {.lex_state = 56, .external_lex_state = 14},
  [1862] = {.lex_state = 56, .external_lex_state = 14},
  [1863] = {.lex_state = 56, .external_lex_state = 14},
  [1864] = {.lex_state = 56, .external_lex_state = 14},
  [1865] = {.lex_state = 56, .external_lex_state = 14},
  [1866] = {.lex_state = 56, .external_lex_state = 14},
  [1867] = {.lex_state = 56, .external_lex_state = 14},
  [1868] = {.lex_state = 56, .external_lex_state = 14},
  [1869] = {.lex_state = 56, .external_lex_state = 14},
  [1870] = {.lex_state = 56, .external_lex_state = 14},
  [1871] = {.lex_state = 56, .external_lex_state = 14},
  [1872] = {.lex_state = 56, .external_lex_state = 14},
  [1873] = {.lex_state = 56, .external_lex_state = 14},
  [1874] = {.lex_state = 56, .external_lex_state = 14},
  [1875] = {.lex_state = 56, .external_lex_state = 14},
  [1876] = {.lex_state = 56, .external_lex_state = 14},
  [1877] = {.lex_state = 56, .external_lex_state = 14},
  [1878] = {.lex_state = 56, .external_lex_state = 14},
  [1879] = {.lex_state = 56, .external_lex_state = 14},
  [1880] = {.lex_state = 56, .external_lex_state = 14},
  [1881] = {.lex_state = 55, .external_lex_state = 37},
  [1882] = {.lex_state = 56, .external_lex_state = 14},
  [1883] = {.lex_state = 56, .external_lex_state = 14},
  [1884] = {.lex_state = 56, .external_lex_state = 14},
  [1885] = {.lex_state = 56, .external_lex_state = 14},
  [1886] = {.lex_state = 56, .external_lex_state = 14},
  [1887] = {.lex_state = 56, .external_lex_state = 14},
  [1888] = {.lex_state = 56, .external_lex_state = 14},
  [1889] = {.lex_state = 56, .external_lex_state = 14},
  [1890] = {.lex_state = 56, .external_lex_state = 14},
  [1891] = {.lex_state = 56, .external_lex_state = 14},
  [1892] = {.lex_state = 55, .external_lex_state = 37},
  [1893] = {.lex_state = 56, .external_lex_state = 14},
  [1894] = {.lex_state = 56, .external_lex_state = 14},
  [1895] = {.lex_state = 56, .external_lex_state = 14},
  [1896] = {.lex_state = 56, .external_lex_state = 14},
  [1897] = {.lex_state = 56, .external_lex_state = 14},
  [1898] = {.lex_state = 56, .external_lex_state = 14},
  [1899] = {.lex_state = 56, .external_lex_state = 14},
  [1900] = {.lex_state = 56, .external_lex_state = 14},
  [1901] = {.lex_state = 55, .external_lex_state = 37},
  [1902] = {.lex_state = 56, .external_lex_state = 14},
  [1903] = {.lex_state = 56, .external_lex_state = 14},
  [1904] = {.lex_state = 56, .external_lex_state = 14},
  [1905] = {.lex_state = 56, .external_lex_state = 14},
  [1906] = {.lex_state = 56, .external_lex_state = 14},
  [1907] = {.lex_state = 56, .external_lex_state = 14},
  [1908] = {.lex_state = 56, .external_lex_state = 14},
  [1909] = {.lex_state = 56, .external_lex_state = 14},
  [1910] = {.lex_state = 55, .external_lex_state = 37},
  [1911] = {.lex_state = 56, .external_lex_state = 14},
  [1912] = {.lex_state = 56, .external_lex_state = 14},
  [1913] = {.lex_state = 56, .external_lex_state = 14},
  [1914] = {.lex_state = 55, .external_lex_state = 37},
  [1915] = {.lex_state = 56, .external_lex_state = 14},
  [1916] = {.lex_state = 56, .external_lex_state = 14},
  [1917] = {.lex_state = 56, .external_lex_state = 14},
  [1918] = {.lex_state = 56, .external_lex_state = 14},
  [1919] = {.lex_state = 56, .external_lex_state = 14},
  [1920] = {.lex_state = 56, .external_lex_state = 14},
  [1921] = {.lex_state = 56, .external_lex_state = 14},
  [1922] = {.lex_state = 55, .external_lex_state = 37},
  [1923] = {.lex_state = 56, .external_lex_state = 14},
  [1924] = {.lex_state = 56, .external_lex_state = 14},
  [1925] = {.lex_state = 56, .external_lex_state = 14},
  [1926] = {.lex_state = 56, .external_lex_state = 14},
  [1927] = {.lex_state = 56, .external_lex_state = 14},
  [1928] = {.lex_state = 56, .external_lex_state = 14},
  [1929] = {.lex_state = 56, .external_lex_state = 14},
  [1930] = {.lex_state = 56, .external_lex_state = 14},
  [1931] = {.lex_state = 55, .external_lex_state = 37},
  [1932] = {.lex_state = 56, .external_lex_state = 14},
  [1933] = {.lex_state = 56, .external_lex_state = 14},
  [1934] = {.lex_state = 55, .external_lex_state = 4},
  [1935] = {.lex_state = 55, .external_lex_state = 4},
  [1936] = {.lex_state = 56, .external_lex_state = 14},
  [1937] = {.lex_state = 56, .external_lex_state = 14},
  [1938] = {.lex_state = 56, .external_lex_state = 14},
  [1939] = {.lex_state = 56, .external_lex_state = 14},
  [1940] = {.lex_state = 56, .external_lex_state = 14},
  [1941] = {.lex_state = 56, .external_lex_state = 14},
  [1942] = {.lex_state = 56, .external_lex_state = 14},
  [1943] = {.lex_state = 55, .external_lex_state = 4},
  [1944] = {.lex_state = 56, .external_lex_state = 14},
  [1945] = {.lex_state = 56, .external_lex_state = 14},
  [1946] = {.lex_state = 56, .external_lex_state = 14},
  [1947] = {.lex_state = 56, .external_lex_state = 14},
  [1948] = {.lex_state = 55, .external_lex_state = 37},
  [1949] = {.lex_state = 56, .external_lex_state = 14},
  [1950] = {.lex_state = 56, .external_lex_state = 14},
  [1951] = {.lex_state = 56, .external_lex_state = 14},
  [1952] = {.lex_state = 56, .external_lex_state = 14},
  [1953] = {.lex_state = 56, .external_lex_state = 14},
  [1954] = {.lex_state = 56, .external_lex_state = 14},
  [1955] = {.lex_state = 56, .external_lex_state = 14},
  [1956] = {.lex_state = 56, .external_lex_state = 14},
  [1957] = {.lex_state = 56, .external_lex_state = 14},
  [1958] = {.lex_state = 56, .external_lex_state = 14},
  [1959] = {.lex_state = 55, .external_lex_state = 37},
  [1960] = {.lex_state = 55, .external_lex_state = 37},
  [1961] = {.lex_state = 56, .external_lex_state = 14},
  [1962] = {.lex_state = 55, .external_lex_state = 37},
  [1963] = {.lex_state = 56, .external_lex_state = 14},
  [1964] = {.lex_state = 56, .external_lex_state = 14},
  [1965] = {.lex_state = 56, .external_lex_state = 14},
  [1966] = {.lex_state = 55, .external_lex_state = 4},
  [1967] = {.lex_state = 56, .external_lex_state = 14},
  [1968] = {.lex_state = 56, .external_lex_state = 14},
  [1969] = {.lex_state = 56, .external_lex_state = 14},
  [1970] = {.lex_state = 56, .external_lex_state = 14},
  [1971] = {.lex_state = 56, .external_lex_state = 14},
  [1972] = {.lex_state = 56, .external_lex_state = 14},
  [1973] = {.lex_state = 55, .external_lex_state = 37},
  [1974] = {.lex_state = 56, .external_lex_state = 14},
  [1975] = {.lex_state = 56, .external_lex_state = 14},
  [1976] = {.lex_state = 55, .external_lex_state = 37},
  [1977] = {.lex_state = 56, .external_lex_state = 14},
  [1978] = {.lex_state = 56, .external_lex_state = 14},
  [1979] = {.lex_state = 56, .external_lex_state = 14},
  [1980] = {.lex_state = 56, .external_lex_state = 14},
  [1981] = {.lex_state = 56, .external_lex_state = 14},
  [1982] = {.lex_state = 55, .external_lex_state = 37},
  [1983] = {.lex_state = 56, .external_lex_state = 14},
  [1984] = {.lex_state = 56, .external_lex_state = 14},
  [1985] = {.lex_state = 56, .external_lex_state = 14},
  [1986] = {.lex_state = 55, .external_lex_state = 37},
  [1987] = {.lex_state = 56, .external_lex_state = 14},
  [1988] = {.lex_state = 56, .external_lex_state = 14},
  [1989] = {.lex_state = 56, .external_lex_state = 14},
  [1990] = {.lex_state = 56, .external_lex_state = 14},
  [1991] = {.lex_state = 56, .external_lex_state = 14},
  [1992] = {.lex_state = 56, .external_lex_state = 14},
  [1993] = {.lex_state = 55, .external_lex_state = 37},
  [1994] = {.lex_state = 56, .external_lex_state = 14},
  [1995] = {.lex_state = 56, .external_lex_state = 14},
  [1996] = {.lex_state = 56, .external_lex_state = 14},
  [1997] = {.lex_state = 55, .external_lex_state = 3},
  [1998] = {.lex_state = 55, .external_lex_state = 3},
  [1999] = {.lex_state = 55, .external_lex_state = 38},
  [2000] = {.lex_state = 55, .external_lex_state = 3},
  [2001] = {.lex_state = 55, .external_lex_state = 38},
  [2002] = {.lex_state = 55, .external_lex_state = 3},
  [2003] = {.lex_state = 55, .external_lex_state = 3},
  [2004] = {.lex_state = 55, .external_lex_state = 3},
  [2005] = {.lex_state = 55, .external_lex_state = 38},
  [2006] = {.lex_state = 55, .external_lex_state = 3},
  [2007] = {.lex_state = 55, .external_lex_state = 3},
  [2008] = {.lex_state = 55, .external_lex_state = 3},
  [2009] = {.lex_state = 55, .external_lex_state = 38},
  [2010] = {.lex_state = 55, .external_lex_state = 3},
  [2011] = {.lex_state = 55, .external_lex_state = 38},
  [2012] = {.lex_state = 55, .external_lex_state = 3},
  [2013] = {.lex_state = 55, .external_lex_state = 3},
  [2014] = {.lex_state = 55, .external_lex_state = 3},
  [2015] = {.lex_state = 55, .external_lex_state = 3},
  [2016] = {.lex_state = 55, .external_lex_state = 38},
  [2017] = {.lex_state = 55, .external_lex_state = 3},
  [2018] = {.lex_state = 55, .external_lex_state = 38},
  [2019] = {.lex_state = 55, .external_lex_state = 3},
  [2020] = {.lex_state = 55, .external_lex_state = 3},
  [2021] = {.lex_state = 55, .external_lex_state = 3},
  [2022] = {.lex_state = 55, .external_lex_state = 3},
  [2023] = {.lex_state = 55, .external_lex_state = 38},
  [2024] = {.lex_state = 55, .external_lex_state = 3},
  [2025] = {.lex_state = 55, .external_lex_state = 38},
  [2026] = {.lex_state = 55, .external_lex_state = 4},
  [2027] = {.lex_state = 55, .external_lex_state = 4},
  [2028] = {.lex_state = 55, .external_lex_state = 4},
  [2029] = {.lex_state = 55, .external_lex_state = 4},
  [2030] = {.lex_state = 55, .external_lex_state = 4},
  [2031] = {.lex_state = 55, .external_lex_state = 4},
  [2032] = {.lex_state = 55, .external_lex_state = 4},
  [2033] = {.lex_state = 55, .external_lex_state = 39},
  [2034] = {.lex_state = 55, .external_lex_state = 4},
  [2035] = {.lex_state = 55, .external_lex_state = 4},
  [2036] = {.lex_state = 55, .external_lex_state = 4},
  [2037] = {.lex_state = 55, .external_lex_state = 39},
  [2038] = {.lex_state = 55, .external_lex_state = 4},
  [2039] = {.lex_state = 55, .external_lex_state = 4},
  [2040] = {.lex_state = 55, .external_lex_state = 4},
  [2041] = {.lex_state = 55, .external_lex_state = 4},
  [2042] = {.lex_state = 55, .external_lex_state = 4},
  [2043] = {.lex_state = 55, .external_lex_state = 39},
  [2044] = {.lex_state = 56, .external_lex_state = 40},
  [2045] = {.lex_state = 55, .external_lex_state = 3},
  [2046] = {.lex_state = 56, .external_lex_state = 40},
  [2047] = {.lex_state = 55, .external_lex_state = 3},
  [2048] = {.lex_state = 55, .external_lex_state = 3},
  [2049] = {.lex_state = 56, .external_lex_state = 40},
  [2050] = {.lex_state = 56, .external_lex_state = 40},
  [2051] = {.lex_state = 55, .external_lex_state = 3},
  [2052] = {.lex_state = 55, .external_lex_state = 3},
  [2053] = {.lex_state = 55, .external_lex_state = 3},
  [2054] = {.lex_state = 56, .external_lex_state = 41},
  [2055] = {.lex_state = 55, .external_lex_state = 3},
  [2056] = {.lex_state = 56, .external_lex_state = 41},
  [2057] = {.lex_state = 56, .external_lex_state = 41},
  [2058] = {.lex_state = 55, .external_lex_state = 3},
  [2059] = {.lex_state = 55, .external_lex_state = 3},
  [2060] = {.lex_state = 55, .external_lex_state = 3},
  [2061] = {.lex_state = 56, .external_lex_state = 35},
  [2062] = {.lex_state = 56, .external_lex_state = 35},
  [2063] = {.lex_state = 56, .external_lex_state = 35},
  [2064] = {.lex_state = 56, .external_lex_state = 35},
  [2065] = {.lex_state = 56, .external_lex_state = 35},
  [2066] = {.lex_state = 56, .external_lex_state = 35},
  [2067] = {.lex_state = 56, .external_lex_state = 35},
  [2068] = {.lex_state = 56, .external_lex_state = 35},
  [2069] = {.lex_state = 56, .external_lex_state = 35},
  [2070] = {.lex_state = 55, .external_lex_state = 4},
  [2071] = {.lex_state = 56, .external_lex_state = 35},
  [2072] = {.lex_state = 56, .external_lex_state = 35},
  [2073] = {.lex_state = 56, .external_lex_state = 35},
  [2074] = {.lex_state = 56, .external_lex_state = 35},
  [2075] = {.lex_state = 56, .external_lex_state = 35},
  [2076] = {.lex_state = 56, .external_lex_state = 35},
  [2077] = {.lex_state = 56, .external_lex_state = 35},
  [2078] = {.lex_state = 56, .external_lex_state = 35},
  [2079] = {.lex_state = 56, .external_lex_state = 35},
  [2080] = {.lex_state = 56, .external_lex_state = 35},
  [2081] = {.lex_state = 56, .external_lex_state = 35},
  [2082] = {.lex_state = 56, .external_lex_state = 35},
  [2083] = {.lex_state = 56, .external_lex_state = 35},
  [2084] = {.lex_state = 56, .external_lex_state = 35},
  [2085] = {.lex_state = 56, .external_lex_state = 35},
  [2086] = {.lex_state = 56, .external_lex_state = 35},
  [2087] = {.lex_state = 56, .external_lex_state = 35},
  [2088] = {.lex_state = 56, .external_lex_state = 35},
  [2089] = {.lex_state = 56, .external_lex_state = 35},
  [2090] = {.lex_state = 56, .external_lex_state = 35},
  [2091] = {.lex_state = 56, .external_lex_state = 35},
  [2092] = {.lex_state = 56, .external_lex_state = 35},
  [2093] = {.lex_state = 56, .external_lex_state = 35},
  [2094] = {.lex_state = 56, .external_lex_state = 35},
  [2095] = {.lex_state = 55, .external_lex_state = 4},
  [2096] = {.lex_state = 56, .external_lex_state = 35},
  [2097] = {.lex_state = 56, .external_lex_state = 35},
  [2098] = {.lex_state = 56, .external_lex_state = 35},
  [2099] = {.lex_state = 56, .external_lex_state = 35},
  [2100] = {.lex_state = 56, .external_lex_state = 35},
  [2101] = {.lex_state = 56, .external_lex_state = 35},
  [2102] = {.lex_state = 56, .external_lex_state = 35},
  [2103] = {.lex_state = 56, .external_lex_state = 35},
  [2104] = {.lex_state = 56, .external_lex_state = 35},
  [2105] = {.lex_state = 56, .external_lex_state = 35},
  [2106] = {.lex_state = 56, .external_lex_state = 35},
  [2107] = {.lex_state = 56, .external_lex_state = 42},
  [2108] = {.lex_state = 56, .external_lex_state = 35},
  [2109] = {.lex_state = 56, .external_lex_state = 35},
  [2110] = {.lex_state = 56, .external_lex_state = 35},
  [2111] = {.lex_state = 56, .external_lex_state = 35},
  [2112] = {.lex_state = 56, .external_lex_state = 35},
  [2113] = {.lex_state = 56, .external_lex_state = 35},
  [2114] = {.lex_state = 56, .external_lex_state = 42},
  [2115] = {.lex_state = 56, .external_lex_state = 35},
  [2116] = {.lex_state = 56, .external_lex_state = 35},
  [2117] = {.lex_state = 56, .external_lex_state = 35},
  [2118] = {.lex_state = 56, .external_lex_state = 35},
  [2119] = {.lex_state = 56, .external_lex_state = 35},
  [2120] = {.lex_state = 56, .external_lex_state = 35},
  [2121] = {.lex_state = 56, .external_lex_state = 35},
  [2122] = {.lex_state = 56, .external_lex_state = 35},
  [2123] = {.lex_state = 56, .external_lex_state = 35},
  [2124] = {.lex_state = 56, .external_lex_state = 35},
  [2125] = {.lex_state = 56, .external_lex_state = 35},
  [2126] = {.lex_state = 56, .external_lex_state = 35},
  [2127] = {.lex_state = 55, .external_lex_state = 4},
  [2128] = {.lex_state = 56, .external_lex_state = 35},
  [2129] = {.lex_state = 56, .external_lex_state = 35},
  [2130] = {.lex_state = 55, .external_lex_state = 4},
  [2131] = {.lex_state = 56, .external_lex_state = 35},
  [2132] = {.lex_state = 56, .external_lex_state = 35},
  [2133] = {.lex_state = 56, .external_lex_state = 35},
  [2134] = {.lex_state = 56, .external_lex_state = 35},
  [2135] = {.lex_state = 56, .external_lex_state = 35},
  [2136] = {.lex_state = 56, .external_lex_state = 35},
  [2137] = {.lex_state = 56, .external_lex_state = 35},
  [2138] = {.lex_state = 56, .external_lex_state = 35},
  [2139] = {.lex_state = 56, .external_lex_state = 35},
  [2140] = {.lex_state = 56, .external_lex_state = 35},
  [2141] = {.lex_state = 56, .external_lex_state = 35},
  [2142] = {.lex_state = 56, .external_lex_state = 35},
  [2143] = {.lex_state = 55, .external_lex_state = 4},
  [2144] = {.lex_state = 56, .external_lex_state = 35},
  [2145] = {.lex_state = 56, .external_lex_state = 35},
  [2146] = {.lex_state = 56, .external_lex_state = 35},
  [2147] = {.lex_state = 56, .external_lex_state = 35},
  [2148] = {.lex_state = 56, .external_lex_state = 35},
  [2149] = {.lex_state = 55, .external_lex_state = 4},
  [2150] = {.lex_state = 56, .external_lex_state = 35},
  [2151] = {.lex_state = 55, .external_lex_state = 4},
  [2152] = {.lex_state = 56, .external_lex_state = 35},
  [2153] = {.lex_state = 56, .external_lex_state = 35},
  [2154] = {.lex_state = 56, .external_lex_state = 35},
  [2155] = {.lex_state = 56, .external_lex_state = 35},
  [2156] = {.lex_state = 56, .external_lex_state = 35},
  [2157] = {.lex_state = 56, .external_lex_state = 35},
  [2158] = {.lex_state = 56, .external_lex_state = 41},
  [2159] = {.lex_state = 56, .external_lex_state = 35},
  [2160] = {.lex_state = 56, .external_lex_state = 35},
  [2161] = {.lex_state = 56, .external_lex_state = 35},
  [2162] = {.lex_state = 56, .external_lex_state = 35},
  [2163] = {.lex_state = 56, .external_lex_state = 35},
  [2164] = {.lex_state = 56, .external_lex_state = 35},
  [2165] = {.lex_state = 56, .external_lex_state = 35},
  [2166] = {.lex_state = 56, .external_lex_state = 35},
  [2167] = {.lex_state = 56, .external_lex_state = 35},
  [2168] = {.lex_state = 56, .external_lex_state = 35},
  [2169] = {.lex_state = 56, .external_lex_state = 35},
  [2170] = {.lex_state = 56, .external_lex_state = 35},
  [2171] = {.lex_state = 56, .external_lex_state = 35},
  [2172] = {.lex_state = 56, .external_lex_state = 35},
  [2173] = {.lex_state = 56, .external_lex_state = 35},
  [2174] = {.lex_state = 56, .external_lex_state = 35},
  [2175] = {.lex_state = 56, .external_lex_state = 35},
  [2176] = {.lex_state = 56, .external_lex_state = 35},
  [2177] = {.lex_state = 56, .external_lex_state = 42},
  [2178] = {.lex_state = 56, .external_lex_state = 35},
  [2179] = {.lex_state = 56, .external_lex_state = 35},
  [2180] = {.lex_state = 55, .external_lex_state = 4},
  [2181] = {.lex_state = 56, .external_lex_state = 35},
  [2182] = {.lex_state = 56, .external_lex_state = 35},
  [2183] = {.lex_state = 56, .external_lex_state = 35},
  [2184] = {.lex_state = 56, .external_lex_state = 35},
  [2185] = {.lex_state = 56, .external_lex_state = 35},
  [2186] = {.lex_state = 56, .external_lex_state = 35},
  [2187] = {.lex_state = 56, .external_lex_state = 35},
  [2188] = {.lex_state = 56, .external_lex_state = 35},
  [2189] = {.lex_state = 55, .external_lex_state = 4},
  [2190] = {.lex_state = 56, .external_lex_state = 35},
  [2191] = {.lex_state = 56, .external_lex_state = 35},
  [2192] = {.lex_state = 56, .external_lex_state = 35},
  [2193] = {.lex_state = 56, .external_lex_state = 35},
  [2194] = {.lex_state = 56, .external_lex_state = 35},
  [2195] = {.lex_state = 56, .external_lex_state = 35},
  [2196] = {.lex_state = 56, .external_lex_state = 35},
  [2197] = {.lex_state = 56, .external_lex_state = 35},
  [2198] = {.lex_state = 56, .external_lex_state = 35},
  [2199] = {.lex_state = 56, .external_lex_state = 35},
  [2200] = {.lex_state = 56, .external_lex_state = 35},
  [2201] = {.lex_state = 56, .external_lex_state = 35},
  [2202] = {.lex_state = 56, .external_lex_state = 35},
  [2203] = {.lex_state = 56, .external_lex_state = 35},
  [2204] = {.lex_state = 56, .external_lex_state = 35},
  [2205] = {.lex_state = 56, .external_lex_state = 35},
  [2206] = {.lex_state = 56, .external_lex_state = 35},
  [2207] = {.lex_state = 56, .external_lex_state = 35},
  [2208] = {.lex_state = 56, .external_lex_state = 35},
  [2209] = {.lex_state = 56, .external_lex_state = 35},
  [2210] = {.lex_state = 56, .external_lex_state = 35},
  [2211] = {.lex_state = 56, .external_lex_state = 35},
  [2212] = {.lex_state = 56, .external_lex_state = 42},
  [2213] = {.lex_state = 56, .external_lex_state = 3},
  [2214] = {.lex_state = 56, .external_lex_state = 3},
  [2215] = {.lex_state = 55, .external_lex_state = 3},
  [2216] = {.lex_state = 56, .external_lex_state = 3},
  [2217] = {.lex_state = 56, .external_lex_state = 43},
  [2218] = {.lex_state = 56, .external_lex_state = 43},
  [2219] = {.lex_state = 56, .external_lex_state = 3},
  [2220] = {.lex_state = 56, .external_lex_state = 3},
  [2221] = {.lex_state = 56, .external_lex_state = 3},
  [2222] = {.lex_state = 56, .external_lex_state = 43},
  [2223] = {.lex_state = 56, .external_lex_state = 35},
  [2224] = {.lex_state = 56, .external_lex_state = 3},
  [2225] = {.lex_state = 56, .external_lex_state = 44},
  [2226] = {.lex_state = 56, .external_lex_state = 3},
  [2227] = {.lex_state = 56, .external_lex_state = 44},
  [2228] = {.lex_state = 56, .external_lex_state = 44},
  [2229] = {.lex_state = 56, .external_lex_state = 37},
  [2230] = {.lex_state = 56, .external_lex_state = 37},
  [2231] = {.lex_state = 56, .external_lex_state = 37},
  [2232] = {.lex_state = 56, .external_lex_state = 37},
  [2233] = {.lex_state = 56, .external_lex_state = 37},
  [2234] = {.lex_state = 56, .external_lex_state = 45},
  [2235] = {.lex_state = 56, .external_lex_state = 37},
  [2236] = {.lex_state = 56, .external_lex_state = 37},
  [2237] = {.lex_state = 56, .external_lex_state = 37},
  [2238] = {.lex_state = 56, .external_lex_state = 37},
  [2239] = {.lex_state = 56, .external_lex_state = 37},
  [2240] = {.lex_state = 56, .external_lex_state = 37},
  [2241] = {.lex_state = 56, .external_lex_state = 37},
  [2242] = {.lex_state = 56, .external_lex_state = 37},
  [2243] = {.lex_state = 56, .external_lex_state = 37},
  [2244] = {.lex_state = 56, .external_lex_state = 37},
  [2245] = {.lex_state = 56, .external_lex_state = 37},
  [2246] = {.lex_state = 56, .external_lex_state = 37},
  [2247] = {.lex_state = 56, .external_lex_state = 37},
  [2248] = {.lex_state = 56, .external_lex_state = 37},
  [2249] = {.lex_state = 56, .external_lex_state = 37},
  [2250] = {.lex_state = 56, .external_lex_state = 37},
  [2251] = {.lex_state = 56, .external_lex_state = 37},
  [2252] = {.lex_state = 56, .external_lex_state = 37},
  [2253] = {.lex_state = 56, .external_lex_state = 37},
  [2254] = {.lex_state = 56, .external_lex_state = 37},
  [2255] = {.lex_state = 56, .external_lex_state = 37},
  [2256] = {.lex_state = 56, .external_lex_state = 46},
  [2257] = {.lex_state = 56, .external_lex_state = 46},
  [2258] = {.lex_state = 56, .external_lex_state = 37},
  [2259] = {.lex_state = 56, .external_lex_state = 37},
  [2260] = {.lex_state = 56, .external_lex_state = 37},
  [2261] = {.lex_state = 56, .external_lex_state = 47},
  [2262] = {.lex_state = 56, .external_lex_state = 37},
  [2263] = {.lex_state = 56, .external_lex_state = 37},
  [2264] = {.lex_state = 56, .external_lex_state = 37},
  [2265] = {.lex_state = 56, .external_lex_state = 37},
  [2266] = {.lex_state = 56, .external_lex_state = 37},
  [2267] = {.lex_state = 56, .external_lex_state = 37},
  [2268] = {.lex_state = 56, .external_lex_state = 37},
  [2269] = {.lex_state = 56, .external_lex_state = 37},
  [2270] = {.lex_state = 56, .external_lex_state = 37},
  [2271] = {.lex_state = 56, .external_lex_state = 37},
  [2272] = {.lex_state = 56, .external_lex_state = 37},
  [2273] = {.lex_state = 56, .external_lex_state = 37},
  [2274] = {.lex_state = 56, .external_lex_state = 37},
  [2275] = {.lex_state = 56, .external_lex_state = 37},
  [2276] = {.lex_state = 56, .external_lex_state = 37},
  [2277] = {.lex_state = 56, .external_lex_state = 37},
  [2278] = {.lex_state = 56, .external_lex_state = 37},
  [2279] = {.lex_state = 56, .external_lex_state = 47},
  [2280] = {.lex_state = 56, .external_lex_state = 37},
  [2281] = {.lex_state = 56, .external_lex_state = 46},
  [2282] = {.lex_state = 56, .external_lex_state = 37},
  [2283] = {.lex_state = 56, .external_lex_state = 37},
  [2284] = {.lex_state = 56, .external_lex_state = 37},
  [2285] = {.lex_state = 56, .external_lex_state = 37},
  [2286] = {.lex_state = 56, .external_lex_state = 37},
  [2287] = {.lex_state = 56, .external_lex_state = 37},
  [2288] = {.lex_state = 56, .external_lex_state = 37},
  [2289] = {.lex_state = 56, .external_lex_state = 37},
  [2290] = {.lex_state = 56, .external_lex_state = 37},
  [2291] = {.lex_state = 56, .external_lex_state = 37},
  [2292] = {.lex_state = 56, .external_lex_state = 37},
  [2293] = {.lex_state = 56, .external_lex_state = 37},
  [2294] = {.lex_state = 56, .external_lex_state = 37},
  [2295] = {.lex_state = 56, .external_lex_state = 37},
  [2296] = {.lex_state = 56, .external_lex_state = 37},
  [2297] = {.lex_state = 56, .external_lex_state = 48},
  [2298] = {.lex_state = 56, .external_lex_state = 37},
  [2299] = {.lex_state = 56, .external_lex_state = 37},
  [2300] = {.lex_state = 56, .external_lex_state = 37},
  [2301] = {.lex_state = 56, .external_lex_state = 37},
  [2302] = {.lex_state = 56, .external_lex_state = 37},
  [2303] = {.lex_state = 56, .external_lex_state = 37},
  [2304] = {.lex_state = 56, .external_lex_state = 37},
  [2305] = {.lex_state = 56, .external_lex_state = 48},
  [2306] = {.lex_state = 56, .external_lex_state = 37},
  [2307] = {.lex_state = 56, .external_lex_state = 49},
  [2308] = {.lex_state = 56, .external_lex_state = 37},
  [2309] = {.lex_state = 56, .external_lex_state = 43},
  [2310] = {.lex_state = 56, .external_lex_state = 44},
  [2311] = {.lex_state = 56, .external_lex_state = 37},
  [2312] = {.lex_state = 56, .external_lex_state = 37},
  [2313] = {.lex_state = 56, .external_lex_state = 37},
  [2314] = {.lex_state = 56, .external_lex_state = 37},
  [2315] = {.lex_state = 56, .external_lex_state = 37},
  [2316] = {.lex_state = 56, .external_lex_state = 37},
  [2317] = {.lex_state = 56, .external_lex_state = 37},
  [2318] = {.lex_state = 56, .external_lex_state = 37},
  [2319] = {.lex_state = 56, .external_lex_state = 49},
  [2320] = {.lex_state = 56, .external_lex_state = 37},
  [2321] = {.lex_state = 56, .external_lex_state = 37},
  [2322] = {.lex_state = 56, .external_lex_state = 37},
  [2323] = {.lex_state = 56, .external_lex_state = 37},
  [2324] = {.lex_state = 56, .external_lex_state = 37},
  [2325] = {.lex_state = 56, .external_lex_state = 37},
  [2326] = {.lex_state = 56, .external_lex_state = 37},
  [2327] = {.lex_state = 56, .external_lex_state = 47},
  [2328] = {.lex_state = 56, .external_lex_state = 37},
  [2329] = {.lex_state = 56, .external_lex_state = 37},
  [2330] = {.lex_state = 56, .external_lex_state = 37},
  [2331] = {.lex_state = 56, .external_lex_state = 37},
  [2332] = {.lex_state = 56, .external_lex_state = 37},
  [2333] = {.lex_state = 56, .external_lex_state = 49},
  [2334] = {.lex_state = 56, .external_lex_state = 37},
  [2335] = {.lex_state = 56, .external_lex_state = 37},
  [2336] = {.lex_state = 56, .external_lex_state = 45},
  [2337] = {.lex_state = 56, .external_lex_state = 37},
  [2338] = {.lex_state = 56, .external_lex_state = 37},
  [2339] = {.lex_state = 56, .external_lex_state = 37},
  [2340] = {.lex_state = 56, .external_lex_state = 37},
  [2341] = {.lex_state = 56, .external_lex_state = 37},
  [2342] = {.lex_state = 56, .external_lex_state = 45},
  [2343] = {.lex_state = 56, .external_lex_state = 37},
  [2344] = {.lex_state = 56, .external_lex_state = 37},
  [2345] = {.lex_state = 56, .external_lex_state = 37},
  [2346] = {.lex_state = 56, .external_lex_state = 37},
  [2347] = {.lex_state = 56, .external_lex_state = 37},
  [2348] = {.lex_state = 56, .external_lex_state = 37},
  [2349] = {.lex_state = 56, .external_lex_state = 37},
  [2350] = {.lex_state = 56, .external_lex_state = 37},
  [2351] = {.lex_state = 56, .external_lex_state = 37},
  [2352] = {.lex_state = 56, .external_lex_state = 37},
  [2353] = {.lex_state = 56, .external_lex_state = 37},
  [2354] = {.lex_state = 56, .external_lex_state = 37},
  [2355] = {.lex_state = 56, .external_lex_state = 37},
  [2356] = {.lex_state = 56, .external_lex_state = 50},
  [2357] = {.lex_state = 56, .external_lex_state = 37},
  [2358] = {.lex_state = 56, .external_lex_state = 37},
  [2359] = {.lex_state = 56, .external_lex_state = 37},
  [2360] = {.lex_state = 56, .external_lex_state = 37},
  [2361] = {.lex_state = 56, .external_lex_state = 37},
  [2362] = {.lex_state = 56, .external_lex_state = 37},
  [2363] = {.lex_state = 56, .external_lex_state = 37},
  [2364] = {.lex_state = 56, .external_lex_state = 37},
  [2365] = {.lex_state = 56, .external_lex_state = 37},
  [2366] = {.lex_state = 56, .external_lex_state = 37},
  [2367] = {.lex_state = 56, .external_lex_state = 37},
  [2368] = {.lex_state = 56, .external_lex_state = 37},
  [2369] = {.lex_state = 56, .external_lex_state = 37},
  [2370] = {.lex_state = 56, .external_lex_state = 37},
  [2371] = {.lex_state = 56, .external_lex_state = 37},
  [2372] = {.lex_state = 56, .external_lex_state = 37},
  [2373] = {.lex_state = 56, .external_lex_state = 37},
  [2374] = {.lex_state = 56, .external_lex_state = 37},
  [2375] = {.lex_state = 56, .external_lex_state = 37},
  [2376] = {.lex_state = 56, .external_lex_state = 37},
  [2377] = {.lex_state = 56, .external_lex_state = 37},
  [2378] = {.lex_state = 56, .external_lex_state = 37},
  [2379] = {.lex_state = 56, .external_lex_state = 37},
  [2380] = {.lex_state = 56, .external_lex_state = 37},
  [2381] = {.lex_state = 56, .external_lex_state = 50},
  [2382] = {.lex_state = 56, .external_lex_state = 48},
  [2383] = {.lex_state = 56, .external_lex_state = 37},
  [2384] = {.lex_state = 56, .external_lex_state = 37},
  [2385] = {.lex_state = 56, .external_lex_state = 50},
  [2386] = {.lex_state = 56, .external_lex_state = 37},
  [2387] = {.lex_state = 56, .external_lex_state = 51},
  [2388] = {.lex_state = 56, .external_lex_state = 52},
  [2389] = {.lex_state = 56, .external_lex_state = 53},
  [2390] = {.lex_state = 56, .external_lex_state = 54},
  [2391] = {.lex_state = 56, .external_lex_state = 55},
  [2392] = {.lex_state = 56, .external_lex_state = 53},
  [2393] = {.lex_state = 56, .external_lex_state = 51},
  [2394] = {.lex_state = 56, .external_lex_state = 54},
  [2395] = {.lex_state = 56, .external_lex_state = 56},
  [2396] = {.lex_state = 56, .external_lex_state = 56},
  [2397] = {.lex_state = 56, .external_lex_state = 53},
  [2398] = {.lex_state = 56, .external_lex_state = 54},
  [2399] = {.lex_state = 56, .external_lex_state = 57},
  [2400] = {.lex_state = 56, .external_lex_state = 58},
  [2401] = {.lex_state = 56, .external_lex_state = 51},
  [2402] = {.lex_state = 56, .external_lex_state = 58},
  [2403] = {.lex_state = 56, .external_lex_state = 37},
  [2404] = {.lex_state = 56, .external_lex_state = 59},
  [2405] = {.lex_state = 56, .external_lex_state = 57},
  [2406] = {.lex_state = 56, .external_lex_state = 47},
  [2407] = {.lex_state = 56, .external_lex_state = 37},
  [2408] = {.lex_state = 56, .external_lex_state = 55},
  [2409] = {.lex_state = 56, .external_lex_state = 3},
  [2410] = {.lex_state = 56, .external_lex_state = 3},
  [2411] = {.lex_state = 56, .external_lex_state = 60},
  [2412] = {.lex_state = 56, .external_lex_state = 52},
  [2413] = {.lex_state = 56, .external_lex_state = 61},
  [2414] = {.lex_state = 56, .external_lex_state = 45},
  [2415] = {.lex_state = 56, .external_lex_state = 59},
  [2416] = {.lex_state = 56, .external_lex_state = 3},
  [2417] = {.lex_state = 56, .external_lex_state = 58},
  [2418] = {.lex_state = 56, .external_lex_state = 46},
  [2419] = {.lex_state = 56, .external_lex_state = 50},
  [2420] = {.lex_state = 56, .external_lex_state = 3},
  [2421] = {.lex_state = 56, .external_lex_state = 59},
  [2422] = {.lex_state = 56, .external_lex_state = 57},
  [2423] = {.lex_state = 56, .external_lex_state = 52},
  [2424] = {.lex_state = 56, .external_lex_state = 49},
  [2425] = {.lex_state = 56, .external_lex_state = 55},
  [2426] = {.lex_state = 56, .external_lex_state = 48},
  [2427] = {.lex_state = 56, .external_lex_state = 56},
  [2428] = {.lex_state = 56, .external_lex_state = 59},
  [2429] = {.lex_state = 56, .external_lex_state = 37},
  [2430] = {.lex_state = 56, .external_lex_state = 37},
  [2431] = {.lex_state = 56, .external_lex_state = 37},
  [2432] = {.lex_state = 56, .external_lex_state = 51},
  [2433] = {.lex_state = 56, .external_lex_state = 62},
  [2434] = {.lex_state = 56, .external_lex_state = 37},
  [2435] = {.lex_state = 56, .external_lex_state = 37},
  [2436] = {.lex_state = 56, .external_lex_state = 37},
  [2437] = {.lex_state = 56, .external_lex_state = 37},
  [2438] = {.lex_state = 56, .external_lex_state = 37},
  [2439] = {.lex_state = 56, .external_lex_state = 58},
  [2440] = {.lex_state = 56, .external_lex_state = 37},
  [2441] = {.lex_state = 56, .external_lex_state = 63},
  [2442] = {.lex_state = 56, .external_lex_state = 64},
  [2443] = {.lex_state = 56, .external_lex_state = 37},
  [2444] = {.lex_state = 56, .external_lex_state = 64},
  [2445] = {.lex_state = 56, .external_lex_state = 37},
  [2446] = {.lex_state = 56, .external_lex_state = 52},
  [2447] = {.lex_state = 56, .external_lex_state = 37},
  [2448] = {.lex_state = 56, .external_lex_state = 65},
  [2449] = {.lex_state = 56, .external_lex_state = 62},
  [2450] = {.lex_state = 56, .external_lex_state = 37},
  [2451] = {.lex_state = 56, .external_lex_state = 37},
  [2452] = {.lex_state = 56, .external_lex_state = 37},
  [2453] = {.lex_state = 56, .external_lex_state = 37},
  [2454] = {.lex_state = 56, .external_lex_state = 37},
  [2455] = {.lex_state = 56, .external_lex_state = 37},
  [2456] = {.lex_state = 56, .external_lex_state = 66},
  [2457] = {.lex_state = 56, .external_lex_state = 37},
  [2458] = {.lex_state = 56, .external_lex_state = 53},
  [2459] = {.lex_state = 56, .external_lex_state = 37},
  [2460] = {.lex_state = 56, .external_lex_state = 37},
  [2461] = {.lex_state = 56, .external_lex_state = 56},
  [2462] = {.lex_state = 56, .external_lex_state = 37},
  [2463] = {.lex_state = 56, .external_lex_state = 37},
  [2464] = {.lex_state = 56, .external_lex_state = 37},
  [2465] = {.lex_state = 56, .external_lex_state = 37},
  [2466] = {.lex_state = 56, .external_lex_state = 37},
  [2467] = {.lex_state = 56, .external_lex_state = 37},
  [2468] = {.lex_state = 56, .external_lex_state = 37},
  [2469] = {.lex_state = 56, .external_lex_state = 37},
  [2470] = {.lex_state = 56, .external_lex_state = 37},
  [2471] = {.lex_state = 56, .external_lex_state = 37},
  [2472] = {.lex_state = 56, .external_lex_state = 37},
  [2473] = {.lex_state = 56, .external_lex_state = 37},
  [2474] = {.lex_state = 56, .external_lex_state = 63},
  [2475] = {.lex_state = 56, .external_lex_state = 37},
  [2476] = {.lex_state = 56, .external_lex_state = 37},
  [2477] = {.lex_state = 56, .external_lex_state = 37},
  [2478] = {.lex_state = 56, .external_lex_state = 64},
  [2479] = {.lex_state = 56, .external_lex_state = 37},
  [2480] = {.lex_state = 56, .external_lex_state = 57},
  [2481] = {.lex_state = 56, .external_lex_state = 67},
  [2482] = {.lex_state = 56, .external_lex_state = 37},
  [2483] = {.lex_state = 56, .external_lex_state = 37},
  [2484] = {.lex_state = 56, .external_lex_state = 37},
  [2485] = {.lex_state = 56, .external_lex_state = 37},
  [2486] = {.lex_state = 56, .external_lex_state = 37},
  [2487] = {.lex_state = 56, .external_lex_state = 37},
  [2488] = {.lex_state = 56, .external_lex_state = 37},
  [2489] = {.lex_state = 56, .external_lex_state = 37},
  [2490] = {.lex_state = 56, .external_lex_state = 65},
  [2491] = {.lex_state = 56, .external_lex_state = 37},
  [2492] = {.lex_state = 56, .external_lex_state = 37},
  [2493] = {.lex_state = 56, .external_lex_state = 37},
  [2494] = {.lex_state = 56, .external_lex_state = 54},
  [2495] = {.lex_state = 56, .external_lex_state = 37},
  [2496] = {.lex_state = 56, .external_lex_state = 65},
  [2497] = {.lex_state = 56, .external_lex_state = 37},
  [2498] = {.lex_state = 56, .external_lex_state = 55},
  [2499] = {.lex_state = 56, .external_lex_state = 37},
  [2500] = {.lex_state = 56, .external_lex_state = 63},
  [2501] = {.lex_state = 56, .external_lex_state = 37},
  [2502] = {.lex_state = 56, .external_lex_state = 37},
  [2503] = {.lex_state = 56, .external_lex_state = 37},
  [2504] = {.lex_state = 56, .external_lex_state = 62},
  [2505] = {.lex_state = 56, .external_lex_state = 37},
  [2506] = {.lex_state = 56, .external_lex_state = 37},
  [2507] = {.lex_state = 56, .external_lex_state = 66},
  [2508] = {.lex_state = 56, .external_lex_state = 37},
  [2509] = {.lex_state = 56, .external_lex_state = 37},
  [2510] = {.lex_state = 56, .external_lex_state = 66},
  [2511] = {.lex_state = 56, .external_lex_state = 66},
  [2512] = {.lex_state = 56, .external_lex_state = 68},
  [2513] = {.lex_state = 55, .external_lex_state = 37},
  [2514] = {.lex_state = 56, .external_lex_state = 69},
  [2515] = {.lex_state = 56, .external_lex_state = 64},
  [2516] = {.lex_state = 56, .external_lex_state = 68},
  [2517] = {.lex_state = 56, .external_lex_state = 63},
  [2518] = {.lex_state = 56, .external_lex_state = 14},
  [2519] = {.lex_state = 55, .external_lex_state = 37},
  [2520] = {.lex_state = 56, .external_lex_state = 65},
  [2521] = {.lex_state = 56, .external_lex_state = 69},
  [2522] = {.lex_state = 56, .external_lex_state = 62},
  [2523] = {.lex_state = 56, .external_lex_state = 69},
  [2524] = {.lex_state = 56, .external_lex_state = 70},
  [2525] = {.lex_state = 56, .external_lex_state = 14},
  [2526] = {.lex_state = 56, .external_lex_state = 14},
  [2527] = {.lex_state = 56, .external_lex_state = 70},
  [2528] = {.lex_state = 56, .external_lex_state = 70},
  [2529] = {.lex_state = 56, .external_lex_state = 68},
  [2530] = {.lex_state = 56, .external_lex_state = 71},
  [2531] = {.lex_state = 56, .external_lex_state = 72},
  [2532] = {.lex_state = 56, .external_lex_state = 72},
  [2533] = {.lex_state = 56, .external_lex_state = 73},
  [2534] = {.lex_state = 56, .external_lex_state = 74},
  [2535] = {.lex_state = 55, .external_lex_state = 37},
  [2536] = {.lex_state = 56, .external_lex_state = 75},
  [2537] = {.lex_state = 55, .external_lex_state = 37},
  [2538] = {.lex_state = 55, .external_lex_state = 37},
  [2539] = {.lex_state = 55, .external_lex_state = 37},
  [2540] = {.lex_state = 55, .external_lex_state = 37},
  [2541] = {.lex_state = 56, .external_lex_state = 69},
  [2542] = {.lex_state = 56, .external_lex_state = 73},
  [2543] = {.lex_state = 56, .external_lex_state = 75},
  [2544] = {.lex_state = 56, .external_lex_state = 74},
  [2545] = {.lex_state = 56, .external_lex_state = 71},
  [2546] = {.lex_state = 55, .external_lex_state = 37},
  [2547] = {.lex_state = 56, .external_lex_state = 71},
  [2548] = {.lex_state = 56, .external_lex_state = 76},
  [2549] = {.lex_state = 55, .external_lex_state = 37},
  [2550] = {.lex_state = 55, .external_lex_state = 37},
  [2551] = {.lex_state = 56, .external_lex_state = 3},
  [2552] = {.lex_state = 56, .external_lex_state = 77},
  [2553] = {.lex_state = 56, .external_lex_state = 3},
  [2554] = {.lex_state = 56, .external_lex_state = 3},
  [2555] = {.lex_state = 55, .external_lex_state = 37},
  [2556] = {.lex_state = 56, .external_lex_state = 76},
  [2557] = {.lex_state = 56, .external_lex_state = 77},
  [2558] = {.lex_state = 55, .external_lex_state = 37},
  [2559] = {.lex_state = 55, .external_lex_state = 37},
  [2560] = {.lex_state = 55, .external_lex_state = 37},
  [2561] = {.lex_state = 56, .external_lex_state = 75},
  [2562] = {.lex_state = 56, .external_lex_state = 77},
  [2563] = {.lex_state = 56, .external_lex_state = 72},
  [2564] = {.lex_state = 55, .external_lex_state = 37},
  [2565] = {.lex_state = 56, .external_lex_state = 74},
  [2566] = {.lex_state = 55, .external_lex_state = 37},
  [2567] = {.lex_state = 56, .external_lex_state = 3},
  [2568] = {.lex_state = 56, .external_lex_state = 3},
  [2569] = {.lex_state = 56, .external_lex_state = 68},
  [2570] = {.lex_state = 55, .external_lex_state = 37},
  [2571] = {.lex_state = 55, .external_lex_state = 37},
  [2572] = {.lex_state = 55, .external_lex_state = 37},
  [2573] = {.lex_state = 56, .external_lex_state = 3},
  [2574] = {.lex_state = 56, .external_lex_state = 3},
  [2575] = {.lex_state = 55, .external_lex_state = 37},
  [2576] = {.lex_state = 56, .external_lex_state = 73},
  [2577] = {.lex_state = 55, .external_lex_state = 37},
  [2578] = {.lex_state = 56, .external_lex_state = 76},
  [2579] = {.lex_state = 55, .external_lex_state = 37},
  [2580] = {.lex_state = 56, .external_lex_state = 14},
  [2581] = {.lex_state = 55, .external_lex_state = 37},
  [2582] = {.lex_state = 56, .external_lex_state = 3},
  [2583] = {.lex_state = 55, .external_lex_state = 37},
  [2584] = {.lex_state = 55, .external_lex_state = 37},
  [2585] = {.lex_state = 56, .external_lex_state = 70},
  [2586] = {.lex_state = 56, .external_lex_state = 78},
  [2587] = {.lex_state = 56, .external_lex_state = 37},
  [2588] = {.lex_state = 56, .external_lex_state = 73},
  [2589] = {.lex_state = 56, .external_lex_state = 79},
  [2590] = {.lex_state = 56, .external_lex_state = 37},
  [2591] = {.lex_state = 56, .external_lex_state = 37},
  [2592] = {.lex_state = 56, .external_lex_state = 37},
  [2593] = {.lex_state = 56, .external_lex_state = 37},
  [2594] = {.lex_state = 56, .external_lex_state = 37},
  [2595] = {.lex_state = 56, .external_lex_state = 37},
  [2596] = {.lex_state = 56, .external_lex_state = 80},
  [2597] = {.lex_state = 56, .external_lex_state = 75},
  [2598] = {.lex_state = 56, .external_lex_state = 79},
  [2599] = {.lex_state = 56, .external_lex_state = 37},
  [2600] = {.lex_state = 56, .external_lex_state = 37},
  [2601] = {.lex_state = 56, .external_lex_state = 81},
  [2602] = {.lex_state = 56, .external_lex_state = 37},
  [2603] = {.lex_state = 56, .external_lex_state = 37},
  [2604] = {.lex_state = 56, .external_lex_state = 82},
  [2605] = {.lex_state = 56, .external_lex_state = 37},
  [2606] = {.lex_state = 56, .external_lex_state = 37},
  [2607] = {.lex_state = 56, .external_lex_state = 37},
  [2608] = {.lex_state = 56, .external_lex_state = 37},
  [2609] = {.lex_state = 56, .external_lex_state = 83},
  [2610] = {.lex_state = 56, .external_lex_state = 84},
  [2611] = {.lex_state = 56, .external_lex_state = 37},
  [2612] = {.lex_state = 56, .external_lex_state = 82},
  [2613] = {.lex_state = 56, .external_lex_state = 37},
  [2614] = {.lex_state = 56, .external_lex_state = 37},
  [2615] = {.lex_state = 56, .external_lex_state = 37},
  [2616] = {.lex_state = 56, .external_lex_state = 37},
  [2617] = {.lex_state = 56, .external_lex_state = 37},
  [2618] = {.lex_state = 56, .external_lex_state = 81},
  [2619] = {.lex_state = 56, .external_lex_state = 37},
  [2620] = {.lex_state = 56, .external_lex_state = 37},
  [2621] = {.lex_state = 56, .external_lex_state = 37},
  [2622] = {.lex_state = 56, .external_lex_state = 37},
  [2623] = {.lex_state = 56, .external_lex_state = 84},
  [2624] = {.lex_state = 56, .external_lex_state = 83},
  [2625] = {.lex_state = 56, .external_lex_state = 37},
  [2626] = {.lex_state = 56, .external_lex_state = 37},
  [2627] = {.lex_state = 56, .external_lex_state = 84},
  [2628] = {.lex_state = 56, .external_lex_state = 79},
  [2629] = {.lex_state = 56, .external_lex_state = 37},
  [2630] = {.lex_state = 56, .external_lex_state = 37},
  [2631] = {.lex_state = 56, .external_lex_state = 37},
  [2632] = {.lex_state = 56, .external_lex_state = 37},
  [2633] = {.lex_state = 56, .external_lex_state = 78},
  [2634] = {.lex_state = 56, .external_lex_state = 37},
  [2635] = {.lex_state = 56, .external_lex_state = 37},
  [2636] = {.lex_state = 56, .external_lex_state = 37},
  [2637] = {.lex_state = 56, .external_lex_state = 37},
  [2638] = {.lex_state = 56, .external_lex_state = 85},
  [2639] = {.lex_state = 56, .external_lex_state = 37},
  [2640] = {.lex_state = 56, .external_lex_state = 37},
  [2641] = {.lex_state = 56, .external_lex_state = 37},
  [2642] = {.lex_state = 56, .external_lex_state = 37},
  [2643] = {.lex_state = 56, .external_lex_state = 37},
  [2644] = {.lex_state = 56, .external_lex_state = 37},
  [2645] = {.lex_state = 56, .external_lex_state = 37},
  [2646] = {.lex_state = 56, .external_lex_state = 37},
  [2647] = {.lex_state = 56, .external_lex_state = 37},
  [2648] = {.lex_state = 56, .external_lex_state = 37},
  [2649] = {.lex_state = 56, .external_lex_state = 37},
  [2650] = {.lex_state = 56, .external_lex_state = 37},
  [2651] = {.lex_state = 56, .external_lex_state = 37},
  [2652] = {.lex_state = 56, .external_lex_state = 83},
  [2653] = {.lex_state = 56, .external_lex_state = 37},
  [2654] = {.lex_state = 56, .external_lex_state = 37},
  [2655] = {.lex_state = 56, .external_lex_state = 37},
  [2656] = {.lex_state = 56, .external_lex_state = 37},
  [2657] = {.lex_state = 56, .external_lex_state = 37},
  [2658] = {.lex_state = 56, .external_lex_state = 37},
  [2659] = {.lex_state = 56, .external_lex_state = 37},
  [2660] = {.lex_state = 56, .external_lex_state = 37},
  [2661] = {.lex_state = 56, .external_lex_state = 37},
  [2662] = {.lex_state = 56, .external_lex_state = 37},
  [2663] = {.lex_state = 56, .external_lex_state = 37},
  [2664] = {.lex_state = 56, .external_lex_state = 37},
  [2665] = {.lex_state = 56, .external_lex_state = 37},
  [2666] = {.lex_state = 56, .external_lex_state = 37},
  [2667] = {.lex_state = 56, .external_lex_state = 37},
  [2668] = {.lex_state = 56, .external_lex_state = 37},
  [2669] = {.lex_state = 56, .external_lex_state = 37},
  [2670] = {.lex_state = 56, .external_lex_state = 37},
  [2671] = {.lex_state = 56, .external_lex_state = 37},
  [2672] = {.lex_state = 55, .external_lex_state = 86},
  [2673] = {.lex_state = 56, .external_lex_state = 37},
  [2674] = {.lex_state = 56, .external_lex_state = 82},
  [2675] = {.lex_state = 56, .external_lex_state = 81},
  [2676] = {.lex_state = 56, .external_lex_state = 37},
  [2677] = {.lex_state = 56, .external_lex_state = 37},
  [2678] = {.lex_state = 56, .external_lex_state = 37},
  [2679] = {.lex_state = 56, .external_lex_state = 37},
  [2680] = {.lex_state = 56, .external_lex_state = 37},
  [2681] = {.lex_state = 56, .external_lex_state = 37},
  [2682] = {.lex_state = 56, .external_lex_state = 37},
  [2683] = {.lex_state = 56, .external_lex_state = 72},
  [2684] = {.lex_state = 56, .external_lex_state = 37},
  [2685] = {.lex_state = 56, .external_lex_state = 37},
  [2686] = {.lex_state = 56, .external_lex_state = 37},
  [2687] = {.lex_state = 56, .external_lex_state = 37},
  [2688] = {.lex_state = 56, .external_lex_state = 37},
  [2689] = {.lex_state = 56, .external_lex_state = 37},
  [2690] = {.lex_state = 56, .external_lex_state = 37},
  [2691] = {.lex_state = 56, .external_lex_state = 80},
  [2692] = {.lex_state = 56, .external_lex_state = 37},
  [2693] = {.lex_state = 56, .external_lex_state = 37},
  [2694] = {.lex_state = 56, .external_lex_state = 37},
  [2695] = {.lex_state = 56, .external_lex_state = 37},
  [2696] = {.lex_state = 56, .external_lex_state = 37},
  [2697] = {.lex_state = 56, .external_lex_state = 37},
  [2698] = {.lex_state = 56, .external_lex_state = 37},
  [2699] = {.lex_state = 56, .external_lex_state = 37},
  [2700] = {.lex_state = 56, .external_lex_state = 37},
  [2701] = {.lex_state = 56, .external_lex_state = 37},
  [2702] = {.lex_state = 56, .external_lex_state = 37},
  [2703] = {.lex_state = 56, .external_lex_state = 37},
  [2704] = {.lex_state = 56, .external_lex_state = 37},
  [2705] = {.lex_state = 56, .external_lex_state = 80},
  [2706] = {.lex_state = 56, .external_lex_state = 85},
  [2707] = {.lex_state = 56, .external_lex_state = 37},
  [2708] = {.lex_state = 56, .external_lex_state = 37},
  [2709] = {.lex_state = 56, .external_lex_state = 37},
  [2710] = {.lex_state = 56, .external_lex_state = 77},
  [2711] = {.lex_state = 56, .external_lex_state = 37},
  [2712] = {.lex_state = 56, .external_lex_state = 37},
  [2713] = {.lex_state = 56, .external_lex_state = 37},
  [2714] = {.lex_state = 56, .external_lex_state = 37},
  [2715] = {.lex_state = 56, .external_lex_state = 37},
  [2716] = {.lex_state = 56, .external_lex_state = 37},
  [2717] = {.lex_state = 56, .external_lex_state = 37},
  [2718] = {.lex_state = 56, .external_lex_state = 37},
  [2719] = {.lex_state = 56, .external_lex_state = 37},
  [2720] = {.lex_state = 56, .external_lex_state = 37},
  [2721] = {.lex_state = 56, .external_lex_state = 37},
  [2722] = {.lex_state = 56, .external_lex_state = 37},
  [2723] = {.lex_state = 56, .external_lex_state = 37},
  [2724] = {.lex_state = 56, .external_lex_state = 37},
  [2725] = {.lex_state = 56, .external_lex_state = 37},
  [2726] = {.lex_state = 56, .external_lex_state = 37},
  [2727] = {.lex_state = 56, .external_lex_state = 78},
  [2728] = {.lex_state = 56, .external_lex_state = 37},
  [2729] = {.lex_state = 56, .external_lex_state = 37},
  [2730] = {.lex_state = 56, .external_lex_state = 37},
  [2731] = {.lex_state = 56, .external_lex_state = 37},
  [2732] = {.lex_state = 56, .external_lex_state = 37},
  [2733] = {.lex_state = 56, .external_lex_state = 85},
  [2734] = {.lex_state = 56, .external_lex_state = 37},
  [2735] = {.lex_state = 56, .external_lex_state = 37},
  [2736] = {.lex_state = 56, .external_lex_state = 37},
  [2737] = {.lex_state = 56, .external_lex_state = 37},
  [2738] = {.lex_state = 56, .external_lex_state = 37},
  [2739] = {.lex_state = 56, .external_lex_state = 76},
  [2740] = {.lex_state = 56, .external_lex_state = 37},
  [2741] = {.lex_state = 56, .external_lex_state = 37},
  [2742] = {.lex_state = 56, .external_lex_state = 37},
  [2743] = {.lex_state = 56, .external_lex_state = 37},
  [2744] = {.lex_state = 56, .external_lex_state = 37},
  [2745] = {.lex_state = 56, .external_lex_state = 37},
  [2746] = {.lex_state = 56, .external_lex_state = 37},
  [2747] = {.lex_state = 56, .external_lex_state = 37},
  [2748] = {.lex_state = 56, .external_lex_state = 37},
  [2749] = {.lex_state = 56, .external_lex_state = 37},
  [2750] = {.lex_state = 56, .external_lex_state = 37},
  [2751] = {.lex_state = 56, .external_lex_state = 74},
  [2752] = {.lex_state = 56, .external_lex_state = 37},
  [2753] = {.lex_state = 56, .external_lex_state = 37},
  [2754] = {.lex_state = 56, .external_lex_state = 37},
  [2755] = {.lex_state = 56, .external_lex_state = 37},
  [2756] = {.lex_state = 56, .external_lex_state = 37},
  [2757] = {.lex_state = 56, .external_lex_state = 37},
  [2758] = {.lex_state = 56, .external_lex_state = 37},
  [2759] = {.lex_state = 56, .external_lex_state = 37},
  [2760] = {.lex_state = 56, .external_lex_state = 79},
  [2761] = {.lex_state = 56, .external_lex_state = 37},
  [2762] = {.lex_state = 56, .external_lex_state = 85},
  [2763] = {.lex_state = 55, .external_lex_state = 87},
  [2764] = {.lex_state = 56, .external_lex_state = 88},
  [2765] = {.lex_state = 56, .external_lex_state = 37},
  [2766] = {.lex_state = 56, .external_lex_state = 83},
  [2767] = {.lex_state = 56, .external_lex_state = 37},
  [2768] = {.lex_state = 56, .external_lex_state = 37},
  [2769] = {.lex_state = 56, .external_lex_state = 37},
  [2770] = {.lex_state = 56, .external_lex_state = 80},
  [2771] = {.lex_state = 56, .external_lex_state = 37},
  [2772] = {.lex_state = 56, .external_lex_state = 88},
  [2773] = {.lex_state = 56, .external_lex_state = 37},
  [2774] = {.lex_state = 56, .external_lex_state = 37},
  [2775] = {.lex_state = 56, .external_lex_state = 37},
  [2776] = {.lex_state = 56, .external_lex_state = 37},
  [2777] = {.lex_state = 56, .external_lex_state = 88},
  [2778] = {.lex_state = 56, .external_lex_state = 81},
  [2779] = {.lex_state = 56, .external_lex_state = 37},
  [2780] = {.lex_state = 56, .external_lex_state = 84},
  [2781] = {.lex_state = 55, .external_lex_state = 89},
  [2782] = {.lex_state = 56, .external_lex_state = 14},
  [2783] = {.lex_state = 56, .external_lex_state = 37},
  [2784] = {.lex_state = 56, .external_lex_state = 37},
  [2785] = {.lex_state = 56, .external_lex_state = 37},
  [2786] = {.lex_state = 56, .external_lex_state = 37},
  [2787] = {.lex_state = 56, .external_lex_state = 37},
  [2788] = {.lex_state = 56, .external_lex_state = 82},
  [2789] = {.lex_state = 56, .external_lex_state = 78},
  [2790] = {.lex_state = 55, .external_lex_state = 86},
  [2791] = {.lex_state = 55, .external_lex_state = 90},
  [2792] = {.lex_state = 56, .external_lex_state = 37},
  [2793] = {.lex_state = 56, .external_lex_state = 37},
  [2794] = {.lex_state = 56, .external_lex_state = 37},
  [2795] = {.lex_state = 55, .external_lex_state = 86},
  [2796] = {.lex_state = 56, .external_lex_state = 88},
  [2797] = {.lex_state = 55, .external_lex_state = 3},
  [2798] = {.lex_state = 55, .external_lex_state = 3},
  [2799] = {.lex_state = 55, .external_lex_state = 3},
  [2800] = {.lex_state = 55, .external_lex_state = 3},
  [2801] = {.lex_state = 56, .external_lex_state = 3},
  [2802] = {.lex_state = 55, .external_lex_state = 3},
  [2803] = {.lex_state = 56, .external_lex_state = 37},
  [2804] = {.lex_state = 55, .external_lex_state = 89},
  [2805] = {.lex_state = 55, .external_lex_state = 3},
  [2806] = {.lex_state = 55, .external_lex_state = 3},
  [2807] = {.lex_state = 55, .external_lex_state = 3},
  [2808] = {.lex_state = 55, .external_lex_state = 3},
  [2809] = {.lex_state = 55, .external_lex_state = 3},
  [2810] = {.lex_state = 55, .external_lex_state = 3},
  [2811] = {.lex_state = 55, .external_lex_state = 3},
  [2812] = {.lex_state = 55, .external_lex_state = 3},
  [2813] = {.lex_state = 55, .external_lex_state = 3},
  [2814] = {.lex_state = 55, .external_lex_state = 3},
  [2815] = {.lex_state = 55, .external_lex_state = 91},
  [2816] = {.lex_state = 55, .external_lex_state = 3},
  [2817] = {.lex_state = 55, .external_lex_state = 3},
  [2818] = {.lex_state = 55, .external_lex_state = 92},
  [2819] = {.lex_state = 55, .external_lex_state = 93},
  [2820] = {.lex_state = 55, .external_lex_state = 3},
  [2821] = {.lex_state = 56, .external_lex_state = 37},
  [2822] = {.lex_state = 55, .external_lex_state = 3},
  [2823] = {.lex_state = 55, .external_lex_state = 3},
  [2824] = {.lex_state = 55, .external_lex_state = 3},
  [2825] = {.lex_state = 55, .external_lex_state = 3},
  [2826] = {.lex_state = 56, .external_lex_state = 3},
  [2827] = {.lex_state = 55, .external_lex_state = 3},
  [2828] = {.lex_state = 55, .external_lex_state = 3},
  [2829] = {.lex_state = 55, .external_lex_state = 3},
  [2830] = {.lex_state = 55, .external_lex_state = 3},
  [2831] = {.lex_state = 55, .external_lex_state = 3},
  [2832] = {.lex_state = 56, .external_lex_state = 37},
  [2833] = {.lex_state = 55, .external_lex_state = 3},
  [2834] = {.lex_state = 55, .external_lex_state = 3},
  [2835] = {.lex_state = 55, .external_lex_state = 3},
  [2836] = {.lex_state = 55, .external_lex_state = 3},
  [2837] = {.lex_state = 55, .external_lex_state = 3},
  [2838] = {.lex_state = 55, .external_lex_state = 3},
  [2839] = {.lex_state = 55, .external_lex_state = 3},
  [2840] = {.lex_state = 55, .external_lex_state = 3},
  [2841] = {.lex_state = 55, .external_lex_state = 3},
  [2842] = {.lex_state = 56, .external_lex_state = 3},
  [2843] = {.lex_state = 55, .external_lex_state = 3},
  [2844] = {.lex_state = 55, .external_lex_state = 3},
  [2845] = {.lex_state = 55, .external_lex_state = 3},
  [2846] = {.lex_state = 55, .external_lex_state = 3},
  [2847] = {.lex_state = 55, .external_lex_state = 3},
  [2848] = {.lex_state = 55, .external_lex_state = 3},
  [2849] = {.lex_state = 56, .external_lex_state = 37},
  [2850] = {.lex_state = 55, .external_lex_state = 87},
  [2851] = {.lex_state = 55, .external_lex_state = 3},
  [2852] = {.lex_state = 55, .external_lex_state = 3},
  [2853] = {.lex_state = 55, .external_lex_state = 3},
  [2854] = {.lex_state = 55, .external_lex_state = 3},
  [2855] = {.lex_state = 55, .external_lex_state = 3},
  [2856] = {.lex_state = 55, .external_lex_state = 3},
  [2857] = {.lex_state = 56, .external_lex_state = 3},
  [2858] = {.lex_state = 55, .external_lex_state = 3},
  [2859] = {.lex_state = 55, .external_lex_state = 3},
  [2860] = {.lex_state = 56, .external_lex_state = 3},
  [2861] = {.lex_state = 55, .external_lex_state = 3},
  [2862] = {.lex_state = 55, .external_lex_state = 3},
  [2863] = {.lex_state = 55, .external_lex_state = 3},
  [2864] = {.lex_state = 55, .external_lex_state = 3},
  [2865] = {.lex_state = 55, .external_lex_state = 3},
  [2866] = {.lex_state = 55, .external_lex_state = 3},
  [2867] = {.lex_state = 55, .external_lex_state = 3},
  [2868] = {.lex_state = 55, .external_lex_state = 3},
  [2869] = {.lex_state = 55, .external_lex_state = 3},
  [2870] = {.lex_state = 55, .external_lex_state = 87},
  [2871] = {.lex_state = 55, .external_lex_state = 3},
  [2872] = {.lex_state = 56, .external_lex_state = 74},
  [2873] = {.lex_state = 56, .external_lex_state = 3},
  [2874] = {.lex_state = 55, .external_lex_state = 3},
  [2875] = {.lex_state = 56, .external_lex_state = 3},
  [2876] = {.lex_state = 56, .external_lex_state = 71},
  [2877] = {.lex_state = 55, .external_lex_state = 94},
  [2878] = {.lex_state = 55, .external_lex_state = 3},
  [2879] = {.lex_state = 55, .external_lex_state = 3},
  [2880] = {.lex_state = 56, .external_lex_state = 3},
  [2881] = {.lex_state = 55, .external_lex_state = 3},
  [2882] = {.lex_state = 55, .external_lex_state = 3},
  [2883] = {.lex_state = 56, .external_lex_state = 3},
  [2884] = {.lex_state = 55, .external_lex_state = 3},
  [2885] = {.lex_state = 55, .external_lex_state = 3},
  [2886] = {.lex_state = 56, .external_lex_state = 3},
  [2887] = {.lex_state = 55, .external_lex_state = 3},
  [2888] = {.lex_state = 56, .external_lex_state = 3},
  [2889] = {.lex_state = 55, .external_lex_state = 3},
  [2890] = {.lex_state = 55, .external_lex_state = 3},
  [2891] = {.lex_state = 55, .external_lex_state = 3},
  [2892] = {.lex_state = 55, .external_lex_state = 3},
  [2893] = {.lex_state = 55, .external_lex_state = 3},
  [2894] = {.lex_state = 56, .external_lex_state = 3},
  [2895] = {.lex_state = 55, .external_lex_state = 3},
  [2896] = {.lex_state = 55, .external_lex_state = 3},
  [2897] = {.lex_state = 55, .external_lex_state = 3},
  [2898] = {.lex_state = 55, .external_lex_state = 3},
  [2899] = {.lex_state = 55, .external_lex_state = 3},
  [2900] = {.lex_state = 56, .external_lex_state = 3},
  [2901] = {.lex_state = 55, .external_lex_state = 3},
  [2902] = {.lex_state = 55, .external_lex_state = 3},
  [2903] = {.lex_state = 55, .external_lex_state = 3},
  [2904] = {.lex_state = 55, .external_lex_state = 3},
  [2905] = {.lex_state = 56, .external_lex_state = 37},
  [2906] = {.lex_state = 55, .external_lex_state = 3},
  [2907] = {.lex_state = 55, .external_lex_state = 3},
  [2908] = {.lex_state = 56, .external_lex_state = 3},
  [2909] = {.lex_state = 55, .external_lex_state = 3},
  [2910] = {.lex_state = 55, .external_lex_state = 3},
  [2911] = {.lex_state = 55, .external_lex_state = 3},
  [2912] = {.lex_state = 55, .external_lex_state = 92},
  [2913] = {.lex_state = 55, .external_lex_state = 95},
  [2914] = {.lex_state = 55, .external_lex_state = 3},
  [2915] = {.lex_state = 55, .external_lex_state = 3},
  [2916] = {.lex_state = 56, .external_lex_state = 3},
  [2917] = {.lex_state = 55, .external_lex_state = 3},
  [2918] = {.lex_state = 55, .external_lex_state = 3},
  [2919] = {.lex_state = 55, .external_lex_state = 3},
  [2920] = {.lex_state = 55, .external_lex_state = 3},
  [2921] = {.lex_state = 55, .external_lex_state = 3},
  [2922] = {.lex_state = 56, .external_lex_state = 76},
  [2923] = {.lex_state = 55, .external_lex_state = 96},
  [2924] = {.lex_state = 55, .external_lex_state = 3},
  [2925] = {.lex_state = 55, .external_lex_state = 3},
  [2926] = {.lex_state = 56, .external_lex_state = 3},
  [2927] = {.lex_state = 55, .external_lex_state = 3},
  [2928] = {.lex_state = 55, .external_lex_state = 89},
  [2929] = {.lex_state = 55, .external_lex_state = 3},
  [2930] = {.lex_state = 55, .external_lex_state = 3},
  [2931] = {.lex_state = 56, .external_lex_state = 37},
  [2932] = {.lex_state = 55, .external_lex_state = 3},
  [2933] = {.lex_state = 55, .external_lex_state = 3},
  [2934] = {.lex_state = 55, .external_lex_state = 3},
  [2935] = {.lex_state = 55, .external_lex_state = 3},
  [2936] = {.lex_state = 55, .external_lex_state = 4},
  [2937] = {.lex_state = 55, .external_lex_state = 4},
  [2938] = {.lex_state = 55, .external_lex_state = 4},
  [2939] = {.lex_state = 55, .external_lex_state = 4},
  [2940] = {.lex_state = 55, .external_lex_state = 4},
  [2941] = {.lex_state = 55, .external_lex_state = 4},
  [2942] = {.lex_state = 55, .external_lex_state = 4},
  [2943] = {.lex_state = 55, .external_lex_state = 4},
  [2944] = {.lex_state = 55, .external_lex_state = 4},
  [2945] = {.lex_state = 55, .external_lex_state = 4},
  [2946] = {.lex_state = 55, .external_lex_state = 4},
  [2947] = {.lex_state = 55, .external_lex_state = 4},
  [2948] = {.lex_state = 55, .external_lex_state = 4},
  [2949] = {.lex_state = 55, .external_lex_state = 4},
  [2950] = {.lex_state = 55, .external_lex_state = 4},
  [2951] = {.lex_state = 55, .external_lex_state = 4},
  [2952] = {.lex_state = 55, .external_lex_state = 4},
  [2953] = {.lex_state = 55, .external_lex_state = 4},
  [2954] = {.lex_state = 55, .external_lex_state = 4},
  [2955] = {.lex_state = 55, .external_lex_state = 4},
  [2956] = {.lex_state = 55, .external_lex_state = 4},
  [2957] = {.lex_state = 55, .external_lex_state = 4},
  [2958] = {.lex_state = 55, .external_lex_state = 4},
  [2959] = {.lex_state = 55, .external_lex_state = 4},
  [2960] = {.lex_state = 55, .external_lex_state = 4},
  [2961] = {.lex_state = 56, .external_lex_state = 37},
  [2962] = {.lex_state = 55, .external_lex_state = 4},
  [2963] = {.lex_state = 55, .external_lex_state = 4},
  [2964] = {.lex_state = 56, .external_lex_state = 97},
  [2965] = {.lex_state = 55, .external_lex_state = 4},
  [2966] = {.lex_state = 56, .external_lex_state = 97},
  [2967] = {.lex_state = 56, .external_lex_state = 98},
  [2968] = {.lex_state = 55, .external_lex_state = 4},
  [2969] = {.lex_state = 55, .external_lex_state = 4},
  [2970] = {.lex_state = 55, .external_lex_state = 4},
  [2971] = {.lex_state = 55, .external_lex_state = 4},
  [2972] = {.lex_state = 56, .external_lex_state = 98},
  [2973] = {.lex_state = 55, .external_lex_state = 4},
  [2974] = {.lex_state = 55, .external_lex_state = 4},
  [2975] = {.lex_state = 55, .external_lex_state = 4},
  [2976] = {.lex_state = 55, .external_lex_state = 4},
  [2977] = {.lex_state = 55, .external_lex_state = 4},
  [2978] = {.lex_state = 55, .external_lex_state = 4},
  [2979] = {.lex_state = 55, .external_lex_state = 4},
  [2980] = {.lex_state = 55, .external_lex_state = 4},
  [2981] = {.lex_state = 55, .external_lex_state = 4},
  [2982] = {.lex_state = 55, .external_lex_state = 4},
  [2983] = {.lex_state = 55, .external_lex_state = 4},
  [2984] = {.lex_state = 55, .external_lex_state = 4},
  [2985] = {.lex_state = 55, .external_lex_state = 4},
  [2986] = {.lex_state = 55, .external_lex_state = 4},
  [2987] = {.lex_state = 55, .external_lex_state = 4},
  [2988] = {.lex_state = 55, .external_lex_state = 4},
  [2989] = {.lex_state = 55, .external_lex_state = 4},
  [2990] = {.lex_state = 55, .external_lex_state = 4},
  [2991] = {.lex_state = 55, .external_lex_state = 4},
  [2992] = {.lex_state = 56, .external_lex_state = 53},
  [2993] = {.lex_state = 55, .external_lex_state = 4},
  [2994] = {.lex_state = 55, .external_lex_state = 4},
  [2995] = {.lex_state = 55, .external_lex_state = 4},
  [2996] = {.lex_state = 55, .external_lex_state = 4},
  [2997] = {.lex_state = 56, .external_lex_state = 37},
  [2998] = {.lex_state = 56, .external_lex_state = 54},
  [2999] = {.lex_state = 55, .external_lex_state = 4},
  [3000] = {.lex_state = 55, .external_lex_state = 4},
  [3001] = {.lex_state = 55, .external_lex_state = 4},
  [3002] = {.lex_state = 56, .external_lex_state = 37},
  [3003] = {.lex_state = 55, .external_lex_state = 4},
  [3004] = {.lex_state = 55, .external_lex_state = 4},
  [3005] = {.lex_state = 55, .external_lex_state = 90},
  [3006] = {.lex_state = 55, .external_lex_state = 4},
  [3007] = {.lex_state = 55, .external_lex_state = 4},
  [3008] = {.lex_state = 55, .external_lex_state = 4},
  [3009] = {.lex_state = 55, .external_lex_state = 90},
  [3010] = {.lex_state = 55, .external_lex_state = 99},
  [3011] = {.lex_state = 55, .external_lex_state = 4},
  [3012] = {.lex_state = 55, .external_lex_state = 4},
  [3013] = {.lex_state = 55, .external_lex_state = 4},
  [3014] = {.lex_state = 55, .external_lex_state = 4},
  [3015] = {.lex_state = 55, .external_lex_state = 4},
  [3016] = {.lex_state = 56, .external_lex_state = 37},
  [3017] = {.lex_state = 55, .external_lex_state = 4},
  [3018] = {.lex_state = 55, .external_lex_state = 4},
  [3019] = {.lex_state = 55, .external_lex_state = 4},
  [3020] = {.lex_state = 55, .external_lex_state = 4},
  [3021] = {.lex_state = 55, .external_lex_state = 4},
  [3022] = {.lex_state = 55, .external_lex_state = 4},
  [3023] = {.lex_state = 55, .external_lex_state = 4},
  [3024] = {.lex_state = 55, .external_lex_state = 4},
  [3025] = {.lex_state = 55, .external_lex_state = 4},
  [3026] = {.lex_state = 55, .external_lex_state = 4},
  [3027] = {.lex_state = 55, .external_lex_state = 4},
  [3028] = {.lex_state = 55, .external_lex_state = 4},
  [3029] = {.lex_state = 55, .external_lex_state = 4},
  [3030] = {.lex_state = 55, .external_lex_state = 4},
  [3031] = {.lex_state = 55, .external_lex_state = 4},
  [3032] = {.lex_state = 55, .external_lex_state = 4},
  [3033] = {.lex_state = 55, .external_lex_state = 4},
  [3034] = {.lex_state = 55, .external_lex_state = 4},
  [3035] = {.lex_state = 55, .external_lex_state = 4},
  [3036] = {.lex_state = 56, .external_lex_state = 78},
  [3037] = {.lex_state = 55, .external_lex_state = 4},
  [3038] = {.lex_state = 55, .external_lex_state = 4},
  [3039] = {.lex_state = 56, .external_lex_state = 37},
  [3040] = {.lex_state = 55, .external_lex_state = 4},
  [3041] = {.lex_state = 55, .external_lex_state = 4},
  [3042] = {.lex_state = 55, .external_lex_state = 4},
  [3043] = {.lex_state = 55, .external_lex_state = 4},
  [3044] = {.lex_state = 56, .external_lex_state = 37},
  [3045] = {.lex_state = 55, .external_lex_state = 4},
  [3046] = {.lex_state = 56, .external_lex_state = 37},
  [3047] = {.lex_state = 55, .external_lex_state = 4},
  [3048] = {.lex_state = 55, .external_lex_state = 4},
  [3049] = {.lex_state = 55, .external_lex_state = 4},
  [3050] = {.lex_state = 55, .external_lex_state = 4},
  [3051] = {.lex_state = 55, .external_lex_state = 4},
  [3052] = {.lex_state = 55, .external_lex_state = 4},
  [3053] = {.lex_state = 55, .external_lex_state = 100},
  [3054] = {.lex_state = 55, .external_lex_state = 4},
  [3055] = {.lex_state = 55, .external_lex_state = 4},
  [3056] = {.lex_state = 55, .external_lex_state = 4},
  [3057] = {.lex_state = 55, .external_lex_state = 4},
  [3058] = {.lex_state = 55, .external_lex_state = 4},
  [3059] = {.lex_state = 55, .external_lex_state = 4},
  [3060] = {.lex_state = 55, .external_lex_state = 4},
  [3061] = {.lex_state = 55, .external_lex_state = 4},
  [3062] = {.lex_state = 56, .external_lex_state = 37},
  [3063] = {.lex_state = 55, .external_lex_state = 4},
  [3064] = {.lex_state = 55, .external_lex_state = 4},
  [3065] = {.lex_state = 55, .external_lex_state = 4},
  [3066] = {.lex_state = 55, .external_lex_state = 4},
  [3067] = {.lex_state = 55, .external_lex_state = 4},
  [3068] = {.lex_state = 55, .external_lex_state = 4},
  [3069] = {.lex_state = 55, .external_lex_state = 4},
  [3070] = {.lex_state = 55, .external_lex_state = 4},
  [3071] = {.lex_state = 55, .external_lex_state = 4},
  [3072] = {.lex_state = 55, .external_lex_state = 4},
  [3073] = {.lex_state = 55, .external_lex_state = 4},
  [3074] = {.lex_state = 55, .external_lex_state = 4},
  [3075] = {.lex_state = 55, .external_lex_state = 4},
  [3076] = {.lex_state = 55, .external_lex_state = 4},
  [3077] = {.lex_state = 55, .external_lex_state = 4},
  [3078] = {.lex_state = 55, .external_lex_state = 4},
  [3079] = {.lex_state = 55, .external_lex_state = 4},
  [3080] = {.lex_state = 55, .external_lex_state = 4},
  [3081] = {.lex_state = 55, .external_lex_state = 4},
  [3082] = {.lex_state = 55, .external_lex_state = 4},
  [3083] = {.lex_state = 55, .external_lex_state = 4},
  [3084] = {.lex_state = 55, .external_lex_state = 4},
  [3085] = {.lex_state = 55, .external_lex_state = 4},
  [3086] = {.lex_state = 56, .external_lex_state = 97},
  [3087] = {.lex_state = 55, .external_lex_state = 4},
  [3088] = {.lex_state = 55, .external_lex_state = 4},
  [3089] = {.lex_state = 56, .external_lex_state = 98},
  [3090] = {.lex_state = 55, .external_lex_state = 4},
  [3091] = {.lex_state = 55, .external_lex_state = 4},
  [3092] = {.lex_state = 55, .external_lex_state = 4},
  [3093] = {.lex_state = 55, .external_lex_state = 4},
  [3094] = {.lex_state = 55, .external_lex_state = 4},
  [3095] = {.lex_state = 55, .external_lex_state = 101},
  [3096] = {.lex_state = 55, .external_lex_state = 4},
  [3097] = {.lex_state = 55, .external_lex_state = 4},
  [3098] = {.lex_state = 55, .external_lex_state = 4},
  [3099] = {.lex_state = 55, .external_lex_state = 4},
  [3100] = {.lex_state = 55, .external_lex_state = 4},
  [3101] = {.lex_state = 55, .external_lex_state = 4},
  [3102] = {.lex_state = 55, .external_lex_state = 4},
  [3103] = {.lex_state = 55, .external_lex_state = 4},
  [3104] = {.lex_state = 55, .external_lex_state = 4},
  [3105] = {.lex_state = 55, .external_lex_state = 4},
  [3106] = {.lex_state = 55, .external_lex_state = 4},
  [3107] = {.lex_state = 55, .external_lex_state = 4},
  [3108] = {.lex_state = 55, .external_lex_state = 4},
  [3109] = {.lex_state = 55, .external_lex_state = 4},
  [3110] = {.lex_state = 55, .external_lex_state = 4},
  [3111] = {.lex_state = 56, .external_lex_state = 3},
  [3112] = {.lex_state = 55, .external_lex_state = 91},
  [3113] = {.lex_state = 55, .external_lex_state = 3},
  [3114] = {.lex_state = 56, .external_lex_state = 102},
  [3115] = {.lex_state = 55, .external_lex_state = 95},
  [3116] = {.lex_state = 55, .external_lex_state = 94},
  [3117] = {.lex_state = 56, .external_lex_state = 102},
  [3118] = {.lex_state = 55, .external_lex_state = 94},
  [3119] = {.lex_state = 56, .external_lex_state = 103},
  [3120] = {.lex_state = 55, .external_lex_state = 104},
  [3121] = {.lex_state = 55, .external_lex_state = 95},
  [3122] = {.lex_state = 56, .external_lex_state = 62},
  [3123] = {.lex_state = 55, .external_lex_state = 3},
  [3124] = {.lex_state = 55, .external_lex_state = 93},
  [3125] = {.lex_state = 56, .external_lex_state = 3},
  [3126] = {.lex_state = 55, .external_lex_state = 96},
  [3127] = {.lex_state = 56, .external_lex_state = 103},
  [3128] = {.lex_state = 55, .external_lex_state = 93},
  [3129] = {.lex_state = 56, .external_lex_state = 3},
  [3130] = {.lex_state = 56, .external_lex_state = 3},
  [3131] = {.lex_state = 56, .external_lex_state = 3},
  [3132] = {.lex_state = 56, .external_lex_state = 3},
  [3133] = {.lex_state = 55, .external_lex_state = 96},
  [3134] = {.lex_state = 56, .external_lex_state = 3},
  [3135] = {.lex_state = 56, .external_lex_state = 3},
  [3136] = {.lex_state = 55, .external_lex_state = 91},
  [3137] = {.lex_state = 56, .external_lex_state = 81},
  [3138] = {.lex_state = 56, .external_lex_state = 85},
  [3139] = {.lex_state = 55, .external_lex_state = 3},
  [3140] = {.lex_state = 55, .external_lex_state = 101},
  [3141] = {.lex_state = 55, .external_lex_state = 3},
  [3142] = {.lex_state = 55, .external_lex_state = 3},
  [3143] = {.lex_state = 55, .external_lex_state = 3},
  [3144] = {.lex_state = 56, .external_lex_state = 37},
  [3145] = {.lex_state = 55, .external_lex_state = 3},
  [3146] = {.lex_state = 55, .external_lex_state = 3},
  [3147] = {.lex_state = 55, .external_lex_state = 3},
  [3148] = {.lex_state = 55, .external_lex_state = 3},
  [3149] = {.lex_state = 55, .external_lex_state = 99},
  [3150] = {.lex_state = 56, .external_lex_state = 14},
  [3151] = {.lex_state = 55, .external_lex_state = 3},
  [3152] = {.lex_state = 55, .external_lex_state = 3},
  [3153] = {.lex_state = 55, .external_lex_state = 3},
  [3154] = {.lex_state = 56, .external_lex_state = 37},
  [3155] = {.lex_state = 55, .external_lex_state = 3},
  [3156] = {.lex_state = 55, .external_lex_state = 3},
  [3157] = {.lex_state = 55, .external_lex_state = 3},
  [3158] = {.lex_state = 56, .external_lex_state = 40},
  [3159] = {.lex_state = 55, .external_lex_state = 3},
  [3160] = {.lex_state = 55, .external_lex_state = 3},
  [3161] = {.lex_state = 56, .external_lex_state = 92},
  [3162] = {.lex_state = 55, .external_lex_state = 99},
  [3163] = {.lex_state = 55, .external_lex_state = 3},
  [3164] = {.lex_state = 55, .external_lex_state = 100},
  [3165] = {.lex_state = 55, .external_lex_state = 3},
  [3166] = {.lex_state = 55, .external_lex_state = 3},
  [3167] = {.lex_state = 55, .external_lex_state = 3},
  [3168] = {.lex_state = 56, .external_lex_state = 92},
  [3169] = {.lex_state = 55, .external_lex_state = 3},
  [3170] = {.lex_state = 55, .external_lex_state = 3},
  [3171] = {.lex_state = 55, .external_lex_state = 3},
  [3172] = {.lex_state = 55, .external_lex_state = 101},
  [3173] = {.lex_state = 55, .external_lex_state = 3},
  [3174] = {.lex_state = 55, .external_lex_state = 3},
  [3175] = {.lex_state = 55, .external_lex_state = 3},
  [3176] = {.lex_state = 55, .external_lex_state = 3},
  [3177] = {.lex_state = 55, .external_lex_state = 3},
  [3178] = {.lex_state = 55, .external_lex_state = 100},
  [3179] = {.lex_state = 55, .external_lex_state = 3},
  [3180] = {.lex_state = 55, .external_lex_state = 3},
  [3181] = {.lex_state = 55, .external_lex_state = 3},
  [3182] = {.lex_state = 55, .external_lex_state = 3},
  [3183] = {.lex_state = 56, .external_lex_state = 37},
  [3184] = {.lex_state = 55, .external_lex_state = 3},
  [3185] = {.lex_state = 56, .external_lex_state = 3},
  [3186] = {.lex_state = 56, .external_lex_state = 3},
  [3187] = {.lex_state = 56, .external_lex_state = 105},
  [3188] = {.lex_state = 56, .external_lex_state = 37},
  [3189] = {.lex_state = 56, .external_lex_state = 106},
  [3190] = {.lex_state = 56, .external_lex_state = 106},
  [3191] = {.lex_state = 56, .external_lex_state = 3},
  [3192] = {.lex_state = 56, .external_lex_state = 37},
  [3193] = {.lex_state = 56, .external_lex_state = 37},
  [3194] = {.lex_state = 56, .external_lex_state = 3},
  [3195] = {.lex_state = 55, .external_lex_state = 104},
  [3196] = {.lex_state = 56, .external_lex_state = 3},
  [3197] = {.lex_state = 56, .external_lex_state = 3},
  [3198] = {.lex_state = 55, .external_lex_state = 104},
  [3199] = {.lex_state = 56, .external_lex_state = 107},
  [3200] = {.lex_state = 56, .external_lex_state = 37},
  [3201] = {.lex_state = 56, .external_lex_state = 105},
  [3202] = {.lex_state = 55, .external_lex_state = 3},
  [3203] = {.lex_state = 55, .external_lex_state = 3},
  [3204] = {.lex_state = 55, .external_lex_state = 3},
  [3205] = {.lex_state = 55, .external_lex_state = 3},
  [3206] = {.lex_state = 56, .external_lex_state = 108},
  [3207] = {.lex_state = 55, .external_lex_state = 3},
  [3208] = {.lex_state = 55, .external_lex_state = 3},
  [3209] = {.lex_state = 55, .external_lex_state = 3},
  [3210] = {.lex_state = 55, .external_lex_state = 3},
  [3211] = {.lex_state = 55, .external_lex_state = 3},
  [3212] = {.lex_state = 55, .external_lex_state = 3},
  [3213] = {.lex_state = 55, .external_lex_state = 3},
  [3214] = {.lex_state = 56, .external_lex_state = 109},
  [3215] = {.lex_state = 56, .external_lex_state = 37},
  [3216] = {.lex_state = 55, .external_lex_state = 3},
  [3217] = {.lex_state = 55, .external_lex_state = 3},
  [3218] = {.lex_state = 55, .external_lex_state = 3},
  [3219] = {.lex_state = 55, .external_lex_state = 3},
  [3220] = {.lex_state = 55, .external_lex_state = 3},
  [3221] = {.lex_state = 56, .external_lex_state = 37},
  [3222] = {.lex_state = 55, .external_lex_state = 3},
  [3223] = {.lex_state = 55, .external_lex_state = 3},
  [3224] = {.lex_state = 55, .external_lex_state = 3},
  [3225] = {.lex_state = 56, .external_lex_state = 110},
  [3226] = {.lex_state = 55, .external_lex_state = 3},
  [3227] = {.lex_state = 55, .external_lex_state = 3},
  [3228] = {.lex_state = 55, .external_lex_state = 3},
  [3229] = {.lex_state = 55, .external_lex_state = 3},
  [3230] = {.lex_state = 56, .external_lex_state = 37},
  [3231] = {.lex_state = 55, .external_lex_state = 3},
  [3232] = {.lex_state = 55, .external_lex_state = 3},
  [3233] = {.lex_state = 55, .external_lex_state = 3},
  [3234] = {.lex_state = 55, .external_lex_state = 3},
  [3235] = {.lex_state = 55, .external_lex_state = 3},
  [3236] = {.lex_state = 55, .external_lex_state = 3},
  [3237] = {.lex_state = 55, .external_lex_state = 3},
  [3238] = {.lex_state = 55, .external_lex_state = 3},
  [3239] = {.lex_state = 55, .external_lex_state = 3},
  [3240] = {.lex_state = 55, .external_lex_state = 3},
  [3241] = {.lex_state = 55, .external_lex_state = 3},
  [3242] = {.lex_state = 55, .external_lex_state = 3},
  [3243] = {.lex_state = 56, .external_lex_state = 37},
  [3244] = {.lex_state = 55, .external_lex_state = 3},
  [3245] = {.lex_state = 56, .external_lex_state = 37},
  [3246] = {.lex_state = 56, .external_lex_state = 110},
  [3247] = {.lex_state = 55, .external_lex_state = 3},
  [3248] = {.lex_state = 55, .external_lex_state = 3},
  [3249] = {.lex_state = 55, .external_lex_state = 3},
  [3250] = {.lex_state = 55, .external_lex_state = 3},
  [3251] = {.lex_state = 55, .external_lex_state = 3},
  [3252] = {.lex_state = 55, .external_lex_state = 3},
  [3253] = {.lex_state = 55, .external_lex_state = 3},
  [3254] = {.lex_state = 55, .external_lex_state = 3},
  [3255] = {.lex_state = 55, .external_lex_state = 3},
  [3256] = {.lex_state = 55, .external_lex_state = 3},
  [3257] = {.lex_state = 55, .external_lex_state = 3},
  [3258] = {.lex_state = 55, .external_lex_state = 3},
  [3259] = {.lex_state = 55, .external_lex_state = 3},
  [3260] = {.lex_state = 55, .external_lex_state = 3},
  [3261] = {.lex_state = 55, .external_lex_state = 3},
  [3262] = {.lex_state = 55, .external_lex_state = 3},
  [3263] = {.lex_state = 55, .external_lex_state = 3},
  [3264] = {.lex_state = 55, .external_lex_state = 3},
  [3265] = {.lex_state = 55, .external_lex_state = 3},
  [3266] = {.lex_state = 55, .external_lex_state = 3},
  [3267] = {.lex_state = 55, .external_lex_state = 3},
  [3268] = {.lex_state = 55, .external_lex_state = 3},
  [3269] = {.lex_state = 55, .external_lex_state = 3},
  [3270] = {.lex_state = 55, .external_lex_state = 3},
  [3271] = {.lex_state = 55, .external_lex_state = 3},
  [3272] = {.lex_state = 56, .external_lex_state = 40},
  [3273] = {.lex_state = 55, .external_lex_state = 3},
  [3274] = {.lex_state = 55, .external_lex_state = 3},
  [3275] = {.lex_state = 55, .external_lex_state = 3},
  [3276] = {.lex_state = 55, .external_lex_state = 3},
  [3277] = {.lex_state = 55, .external_lex_state = 3},
  [3278] = {.lex_state = 55, .external_lex_state = 3},
  [3279] = {.lex_state = 55, .external_lex_state = 3},
  [3280] = {.lex_state = 55, .external_lex_state = 3},
  [3281] = {.lex_state = 55, .external_lex_state = 3},
  [3282] = {.lex_state = 55, .external_lex_state = 3},
  [3283] = {.lex_state = 55, .external_lex_state = 3},
  [3284] = {.lex_state = 56, .external_lex_state = 37},
  [3285] = {.lex_state = 55, .external_lex_state = 3},
  [3286] = {.lex_state = 55, .external_lex_state = 3},
  [3287] = {.lex_state = 56, .external_lex_state = 37},
  [3288] = {.lex_state = 55, .external_lex_state = 3},
  [3289] = {.lex_state = 55, .external_lex_state = 3},
  [3290] = {.lex_state = 55, .external_lex_state = 3},
  [3291] = {.lex_state = 55, .external_lex_state = 3},
  [3292] = {.lex_state = 55, .external_lex_state = 3},
  [3293] = {.lex_state = 56, .external_lex_state = 108},
  [3294] = {.lex_state = 56, .external_lex_state = 37},
  [3295] = {.lex_state = 55, .external_lex_state = 3},
  [3296] = {.lex_state = 55, .external_lex_state = 92},
  [3297] = {.lex_state = 55, .external_lex_state = 3},
  [3298] = {.lex_state = 55, .external_lex_state = 3},
  [3299] = {.lex_state = 55, .external_lex_state = 3},
  [3300] = {.lex_state = 55, .external_lex_state = 3},
  [3301] = {.lex_state = 56, .external_lex_state = 40},
  [3302] = {.lex_state = 55, .external_lex_state = 3},
  [3303] = {.lex_state = 55, .external_lex_state = 3},
  [3304] = {.lex_state = 55, .external_lex_state = 3},
  [3305] = {.lex_state = 55, .external_lex_state = 3},
  [3306] = {.lex_state = 55, .external_lex_state = 3},
  [3307] = {.lex_state = 55, .external_lex_state = 3},
  [3308] = {.lex_state = 55, .external_lex_state = 3},
  [3309] = {.lex_state = 55, .external_lex_state = 3},
  [3310] = {.lex_state = 56, .external_lex_state = 109},
  [3311] = {.lex_state = 55, .external_lex_state = 3},
  [3312] = {.lex_state = 55, .external_lex_state = 3},
  [3313] = {.lex_state = 55, .external_lex_state = 3},
  [3314] = {.lex_state = 55, .external_lex_state = 3},
  [3315] = {.lex_state = 55, .external_lex_state = 3},
  [3316] = {.lex_state = 55, .external_lex_state = 3},
  [3317] = {.lex_state = 55, .external_lex_state = 3},
  [3318] = {.lex_state = 56, .external_lex_state = 37},
  [3319] = {.lex_state = 55, .external_lex_state = 3},
  [3320] = {.lex_state = 55, .external_lex_state = 3},
  [3321] = {.lex_state = 55, .external_lex_state = 3},
  [3322] = {.lex_state = 55, .external_lex_state = 3},
  [3323] = {.lex_state = 55, .external_lex_state = 3},
  [3324] = {.lex_state = 55, .external_lex_state = 3},
  [3325] = {.lex_state = 55, .external_lex_state = 3},
  [3326] = {.lex_state = 55, .external_lex_state = 3},
  [3327] = {.lex_state = 55, .external_lex_state = 3},
  [3328] = {.lex_state = 55, .external_lex_state = 3},
  [3329] = {.lex_state = 55, .external_lex_state = 3},
  [3330] = {.lex_state = 55, .external_lex_state = 3},
  [3331] = {.lex_state = 55, .external_lex_state = 3},
  [3332] = {.lex_state = 55, .external_lex_state = 3},
  [3333] = {.lex_state = 55, .external_lex_state = 3},
  [3334] = {.lex_state = 55, .external_lex_state = 3},
  [3335] = {.lex_state = 55, .external_lex_state = 3},
  [3336] = {.lex_state = 55, .external_lex_state = 3},
  [3337] = {.lex_state = 56, .external_lex_state = 37},
  [3338] = {.lex_state = 55, .external_lex_state = 4},
  [3339] = {.lex_state = 55, .external_lex_state = 4},
  [3340] = {.lex_state = 55, .external_lex_state = 3},
  [3341] = {.lex_state = 55, .external_lex_state = 4},
  [3342] = {.lex_state = 55, .external_lex_state = 4},
  [3343] = {.lex_state = 55, .external_lex_state = 4},
  [3344] = {.lex_state = 55, .external_lex_state = 4},
  [3345] = {.lex_state = 55, .external_lex_state = 92},
  [3346] = {.lex_state = 55, .external_lex_state = 4},
  [3347] = {.lex_state = 55, .external_lex_state = 4},
  [3348] = {.lex_state = 56, .external_lex_state = 111},
  [3349] = {.lex_state = 55, .external_lex_state = 4},
  [3350] = {.lex_state = 55, .external_lex_state = 3},
  [3351] = {.lex_state = 55, .external_lex_state = 4},
  [3352] = {.lex_state = 56, .external_lex_state = 111},
  [3353] = {.lex_state = 55, .external_lex_state = 4},
  [3354] = {.lex_state = 55, .external_lex_state = 4},
  [3355] = {.lex_state = 55, .external_lex_state = 4},
  [3356] = {.lex_state = 55, .external_lex_state = 3},
  [3357] = {.lex_state = 55, .external_lex_state = 4},
  [3358] = {.lex_state = 55, .external_lex_state = 92},
  [3359] = {.lex_state = 55, .external_lex_state = 3},
  [3360] = {.lex_state = 55, .external_lex_state = 3},
  [3361] = {.lex_state = 55, .external_lex_state = 4},
  [3362] = {.lex_state = 55, .external_lex_state = 4},
  [3363] = {.lex_state = 55, .external_lex_state = 4},
  [3364] = {.lex_state = 55, .external_lex_state = 3},
  [3365] = {.lex_state = 55, .external_lex_state = 4},
  [3366] = {.lex_state = 55, .external_lex_state = 3},
  [3367] = {.lex_state = 55, .external_lex_state = 3},
  [3368] = {.lex_state = 55, .external_lex_state = 4},
  [3369] = {.lex_state = 55, .external_lex_state = 3},
  [3370] = {.lex_state = 55, .external_lex_state = 92},
  [3371] = {.lex_state = 55, .external_lex_state = 4},
  [3372] = {.lex_state = 55, .external_lex_state = 4},
  [3373] = {.lex_state = 55, .external_lex_state = 4},
  [3374] = {.lex_state = 55, .external_lex_state = 4},
  [3375] = {.lex_state = 55, .external_lex_state = 4},
  [3376] = {.lex_state = 55, .external_lex_state = 3},
  [3377] = {.lex_state = 55, .external_lex_state = 4},
  [3378] = {.lex_state = 55, .external_lex_state = 3},
  [3379] = {.lex_state = 55, .external_lex_state = 4},
  [3380] = {.lex_state = 55, .external_lex_state = 4},
  [3381] = {.lex_state = 55, .external_lex_state = 4},
  [3382] = {.lex_state = 55, .external_lex_state = 4},
  [3383] = {.lex_state = 55, .external_lex_state = 4},
  [3384] = {.lex_state = 55, .external_lex_state = 3},
  [3385] = {.lex_state = 55, .external_lex_state = 4},
  [3386] = {.lex_state = 55, .external_lex_state = 3},
  [3387] = {.lex_state = 55, .external_lex_state = 4},
  [3388] = {.lex_state = 55, .external_lex_state = 4},
  [3389] = {.lex_state = 55, .external_lex_state = 4},
  [3390] = {.lex_state = 55, .external_lex_state = 4},
  [3391] = {.lex_state = 55, .external_lex_state = 4},
  [3392] = {.lex_state = 55, .external_lex_state = 3},
  [3393] = {.lex_state = 55, .external_lex_state = 4},
  [3394] = {.lex_state = 55, .external_lex_state = 4},
  [3395] = {.lex_state = 55, .external_lex_state = 4},
  [3396] = {.lex_state = 55, .external_lex_state = 4},
  [3397] = {.lex_state = 55, .external_lex_state = 4},
  [3398] = {.lex_state = 55, .external_lex_state = 4},
  [3399] = {.lex_state = 55, .external_lex_state = 4},
  [3400] = {.lex_state = 55, .external_lex_state = 4},
  [3401] = {.lex_state = 55, .external_lex_state = 4},
  [3402] = {.lex_state = 55, .external_lex_state = 4},
  [3403] = {.lex_state = 55, .external_lex_state = 4},
  [3404] = {.lex_state = 55, .external_lex_state = 4},
  [3405] = {.lex_state = 56, .external_lex_state = 37},
  [3406] = {.lex_state = 55, .external_lex_state = 4},
  [3407] = {.lex_state = 56, .external_lex_state = 37},
  [3408] = {.lex_state = 55, .external_lex_state = 4},
  [3409] = {.lex_state = 55, .external_lex_state = 4},
  [3410] = {.lex_state = 55, .external_lex_state = 3},
  [3411] = {.lex_state = 55, .external_lex_state = 4},
  [3412] = {.lex_state = 55, .external_lex_state = 4},
  [3413] = {.lex_state = 55, .external_lex_state = 3},
  [3414] = {.lex_state = 55, .external_lex_state = 4},
  [3415] = {.lex_state = 55, .external_lex_state = 4},
  [3416] = {.lex_state = 55, .external_lex_state = 4},
  [3417] = {.lex_state = 55, .external_lex_state = 4},
  [3418] = {.lex_state = 55, .external_lex_state = 4},
  [3419] = {.lex_state = 55, .external_lex_state = 4},
  [3420] = {.lex_state = 55, .external_lex_state = 4},
  [3421] = {.lex_state = 55, .external_lex_state = 4},
  [3422] = {.lex_state = 55, .external_lex_state = 4},
  [3423] = {.lex_state = 55, .external_lex_state = 4},
  [3424] = {.lex_state = 55, .external_lex_state = 4},
  [3425] = {.lex_state = 55, .external_lex_state = 4},
  [3426] = {.lex_state = 55, .external_lex_state = 4},
  [3427] = {.lex_state = 55, .external_lex_state = 4},
  [3428] = {.lex_state = 55, .external_lex_state = 4},
  [3429] = {.lex_state = 55, .external_lex_state = 4},
  [3430] = {.lex_state = 55, .external_lex_state = 4},
  [3431] = {.lex_state = 55, .external_lex_state = 4},
  [3432] = {.lex_state = 55, .external_lex_state = 4},
  [3433] = {.lex_state = 55, .external_lex_state = 4},
  [3434] = {.lex_state = 55, .external_lex_state = 4},
  [3435] = {.lex_state = 55, .external_lex_state = 4},
  [3436] = {.lex_state = 55, .external_lex_state = 3},
  [3437] = {.lex_state = 55, .external_lex_state = 4},
  [3438] = {.lex_state = 55, .external_lex_state = 4},
  [3439] = {.lex_state = 55, .external_lex_state = 4},
  [3440] = {.lex_state = 55, .external_lex_state = 4},
  [3441] = {.lex_state = 55, .external_lex_state = 4},
  [3442] = {.lex_state = 55, .external_lex_state = 4},
  [3443] = {.lex_state = 56, .external_lex_state = 37},
  [3444] = {.lex_state = 55, .external_lex_state = 4},
  [3445] = {.lex_state = 55, .external_lex_state = 4},
  [3446] = {.lex_state = 55, .external_lex_state = 3},
  [3447] = {.lex_state = 55, .external_lex_state = 4},
  [3448] = {.lex_state = 55, .external_lex_state = 4},
  [3449] = {.lex_state = 56, .external_lex_state = 112},
  [3450] = {.lex_state = 56, .external_lex_state = 37},
  [3451] = {.lex_state = 55, .external_lex_state = 4},
  [3452] = {.lex_state = 55, .external_lex_state = 3},
  [3453] = {.lex_state = 55, .external_lex_state = 4},
  [3454] = {.lex_state = 55, .external_lex_state = 4},
  [3455] = {.lex_state = 55, .external_lex_state = 4},
  [3456] = {.lex_state = 55, .external_lex_state = 4},
  [3457] = {.lex_state = 55, .external_lex_state = 4},
  [3458] = {.lex_state = 55, .external_lex_state = 3},
  [3459] = {.lex_state = 55, .external_lex_state = 4},
  [3460] = {.lex_state = 55, .external_lex_state = 4},
  [3461] = {.lex_state = 55, .external_lex_state = 4},
  [3462] = {.lex_state = 55, .external_lex_state = 4},
  [3463] = {.lex_state = 55, .external_lex_state = 4},
  [3464] = {.lex_state = 55, .external_lex_state = 4},
  [3465] = {.lex_state = 55, .external_lex_state = 4},
  [3466] = {.lex_state = 55, .external_lex_state = 4},
  [3467] = {.lex_state = 55, .external_lex_state = 4},
  [3468] = {.lex_state = 55, .external_lex_state = 4},
  [3469] = {.lex_state = 55, .external_lex_state = 4},
  [3470] = {.lex_state = 55, .external_lex_state = 4},
  [3471] = {.lex_state = 55, .external_lex_state = 4},
  [3472] = {.lex_state = 55, .external_lex_state = 4},
  [3473] = {.lex_state = 55, .external_lex_state = 4},
  [3474] = {.lex_state = 56, .external_lex_state = 113},
  [3475] = {.lex_state = 55, .external_lex_state = 4},
  [3476] = {.lex_state = 55, .external_lex_state = 4},
  [3477] = {.lex_state = 55, .external_lex_state = 4},
  [3478] = {.lex_state = 55, .external_lex_state = 4},
  [3479] = {.lex_state = 55, .external_lex_state = 4},
  [3480] = {.lex_state = 56, .external_lex_state = 113},
  [3481] = {.lex_state = 55, .external_lex_state = 4},
  [3482] = {.lex_state = 55, .external_lex_state = 4},
  [3483] = {.lex_state = 55, .external_lex_state = 4},
  [3484] = {.lex_state = 55, .external_lex_state = 4},
  [3485] = {.lex_state = 55, .external_lex_state = 4},
  [3486] = {.lex_state = 55, .external_lex_state = 4},
  [3487] = {.lex_state = 55, .external_lex_state = 4},
  [3488] = {.lex_state = 55, .external_lex_state = 4},
  [3489] = {.lex_state = 55, .external_lex_state = 4},
  [3490] = {.lex_state = 56, .external_lex_state = 37},
  [3491] = {.lex_state = 56, .external_lex_state = 37},
  [3492] = {.lex_state = 55, .external_lex_state = 4},
  [3493] = {.lex_state = 56, .external_lex_state = 112},
  [3494] = {.lex_state = 55, .external_lex_state = 4},
  [3495] = {.lex_state = 55, .external_lex_state = 4},
  [3496] = {.lex_state = 55, .external_lex_state = 4},
  [3497] = {.lex_state = 55, .external_lex_state = 4},
  [3498] = {.lex_state = 55, .external_lex_state = 3},
  [3499] = {.lex_state = 55, .external_lex_state = 4},
  [3500] = {.lex_state = 55, .external_lex_state = 4},
  [3501] = {.lex_state = 55, .external_lex_state = 4},
  [3502] = {.lex_state = 55, .external_lex_state = 4},
  [3503] = {.lex_state = 55, .external_lex_state = 4},
  [3504] = {.lex_state = 55, .external_lex_state = 3},
  [3505] = {.lex_state = 55, .external_lex_state = 4},
  [3506] = {.lex_state = 55, .external_lex_state = 3},
  [3507] = {.lex_state = 55, .external_lex_state = 4},
  [3508] = {.lex_state = 56, .external_lex_state = 37},
  [3509] = {.lex_state = 55, .external_lex_state = 4},
  [3510] = {.lex_state = 55, .external_lex_state = 4},
  [3511] = {.lex_state = 55, .external_lex_state = 4},
  [3512] = {.lex_state = 55, .external_lex_state = 4},
  [3513] = {.lex_state = 56, .external_lex_state = 37},
  [3514] = {.lex_state = 55, .external_lex_state = 4},
  [3515] = {.lex_state = 55, .external_lex_state = 4},
  [3516] = {.lex_state = 56, .external_lex_state = 114},
  [3517] = {.lex_state = 56, .external_lex_state = 37},
  [3518] = {.lex_state = 56, .external_lex_state = 37},
  [3519] = {.lex_state = 56, .external_lex_state = 37},
  [3520] = {.lex_state = 56, .external_lex_state = 114},
  [3521] = {.lex_state = 55, .external_lex_state = 3},
  [3522] = {.lex_state = 56, .external_lex_state = 114},
  [3523] = {.lex_state = 56, .external_lex_state = 114},
  [3524] = {.lex_state = 56, .external_lex_state = 114},
  [3525] = {.lex_state = 56, .external_lex_state = 114},
  [3526] = {.lex_state = 56, .external_lex_state = 37},
  [3527] = {.lex_state = 56, .external_lex_state = 114},
  [3528] = {.lex_state = 56, .external_lex_state = 114},
  [3529] = {.lex_state = 56, .external_lex_state = 37},
  [3530] = {.lex_state = 56, .external_lex_state = 37},
  [3531] = {.lex_state = 56, .external_lex_state = 114},
  [3532] = {.lex_state = 56, .external_lex_state = 37},
  [3533] = {.lex_state = 56, .external_lex_state = 37},
  [3534] = {.lex_state = 56, .external_lex_state = 114},
  [3535] = {.lex_state = 56, .external_lex_state = 114},
  [3536] = {.lex_state = 56, .external_lex_state = 114},
  [3537] = {.lex_state = 56, .external_lex_state = 114},
  [3538] = {.lex_state = 56, .external_lex_state = 114},
  [3539] = {.lex_state = 56, .external_lex_state = 114},
  [3540] = {.lex_state = 56, .external_lex_state = 30},
  [3541] = {.lex_state = 56, .external_lex_state = 37},
  [3542] = {.lex_state = 56, .external_lex_state = 37},
  [3543] = {.lex_state = 56, .external_lex_state = 30},
  [3544] = {.lex_state = 56, .external_lex_state = 37},
  [3545] = {.lex_state = 56, .external_lex_state = 37},
  [3546] = {.lex_state = 56, .external_lex_state = 37},
  [3547] = {.lex_state = 56, .external_lex_state = 37},
  [3548] = {.lex_state = 56, .external_lex_state = 37},
  [3549] = {.lex_state = 56, .external_lex_state = 37},
  [3550] = {.lex_state = 56, .external_lex_state = 37},
  [3551] = {.lex_state = 56, .external_lex_state = 37},
  [3552] = {.lex_state = 56, .external_lex_state = 37},
  [3553] = {.lex_state = 56, .external_lex_state = 37},
  [3554] = {.lex_state = 56, .external_lex_state = 37},
  [3555] = {.lex_state = 56, .external_lex_state = 37},
  [3556] = {.lex_state = 56, .external_lex_state = 37},
  [3557] = {.lex_state = 56, .external_lex_state = 37},
  [3558] = {.lex_state = 56, .external_lex_state = 37},
  [3559] = {.lex_state = 56, .external_lex_state = 37},
  [3560] = {.lex_state = 56, .external_lex_state = 37},
  [3561] = {.lex_state = 56, .external_lex_state = 37},
  [3562] = {.lex_state = 56, .external_lex_state = 37},
  [3563] = {.lex_state = 56, .external_lex_state = 37},
  [3564] = {.lex_state = 56, .external_lex_state = 37},
  [3565] = {.lex_state = 56, .external_lex_state = 37},
  [3566] = {.lex_state = 56, .external_lex_state = 37},
  [3567] = {.lex_state = 56, .external_lex_state = 37},
  [3568] = {.lex_state = 56, .external_lex_state = 37},
  [3569] = {.lex_state = 56, .external_lex_state = 37},
  [3570] = {.lex_state = 56, .external_lex_state = 37},
  [3571] = {.lex_state = 56, .external_lex_state = 37},
  [3572] = {.lex_state = 56, .external_lex_state = 37},
  [3573] = {.lex_state = 56, .external_lex_state = 37},
  [3574] = {.lex_state = 56, .external_lex_state = 37},
  [3575] = {.lex_state = 56, .external_lex_state = 37},
  [3576] = {.lex_state = 56, .external_lex_state = 37},
  [3577] = {.lex_state = 56, .external_lex_state = 37},
  [3578] = {.lex_state = 56, .external_lex_state = 37},
  [3579] = {.lex_state = 56, .external_lex_state = 37},
  [3580] = {.lex_state = 56, .external_lex_state = 37},
  [3581] = {.lex_state = 56, .external_lex_state = 37},
  [3582] = {.lex_state = 56, .external_lex_state = 37},
  [3583] = {.lex_state = 56, .external_lex_state = 37},
  [3584] = {.lex_state = 56, .external_lex_state = 37},
  [3585] = {.lex_state = 56, .external_lex_state = 37},
  [3586] = {.lex_state = 56, .external_lex_state = 37},
  [3587] = {.lex_state = 56, .external_lex_state = 37},
  [3588] = {.lex_state = 56, .external_lex_state = 37},
  [3589] = {.lex_state = 56, .external_lex_state = 37},
  [3590] = {.lex_state = 56, .external_lex_state = 37},
  [3591] = {.lex_state = 56, .external_lex_state = 37},
  [3592] = {.lex_state = 56, .external_lex_state = 37},
  [3593] = {.lex_state = 56, .external_lex_state = 37},
  [3594] = {.lex_state = 56, .external_lex_state = 37},
  [3595] = {.lex_state = 56, .external_lex_state = 37},
  [3596] = {.lex_state = 56, .external_lex_state = 37},
  [3597] = {.lex_state = 56, .external_lex_state = 37},
  [3598] = {.lex_state = 56, .external_lex_state = 37},
  [3599] = {.lex_state = 56, .external_lex_state = 37},
  [3600] = {.lex_state = 56, .external_lex_state = 37},
  [3601] = {.lex_state = 56, .external_lex_state = 37},
  [3602] = {.lex_state = 56, .external_lex_state = 37},
  [3603] = {.lex_state = 56, .external_lex_state = 37},
  [3604] = {.lex_state = 56, .external_lex_state = 37},
  [3605] = {.lex_state = 56, .external_lex_state = 37},
  [3606] = {.lex_state = 56, .external_lex_state = 37},
  [3607] = {.lex_state = 56, .external_lex_state = 37},
  [3608] = {.lex_state = 56, .external_lex_state = 37},
  [3609] = {.lex_state = 56, .external_lex_state = 37},
  [3610] = {.lex_state = 56, .external_lex_state = 37},
  [3611] = {.lex_state = 56, .external_lex_state = 37},
  [3612] = {.lex_state = 56, .external_lex_state = 37},
  [3613] = {.lex_state = 56, .external_lex_state = 37},
  [3614] = {.lex_state = 56, .external_lex_state = 37},
  [3615] = {.lex_state = 56, .external_lex_state = 37},
  [3616] = {.lex_state = 56, .external_lex_state = 37},
  [3617] = {.lex_state = 56, .external_lex_state = 37},
  [3618] = {.lex_state = 56, .external_lex_state = 37},
  [3619] = {.lex_state = 56, .external_lex_state = 37},
  [3620] = {.lex_state = 56, .external_lex_state = 37},
  [3621] = {.lex_state = 56, .external_lex_state = 37},
  [3622] = {.lex_state = 56, .external_lex_state = 37},
  [3623] = {.lex_state = 56, .external_lex_state = 37},
  [3624] = {.lex_state = 56, .external_lex_state = 37},
  [3625] = {.lex_state = 56, .external_lex_state = 37},
  [3626] = {.lex_state = 55, .external_lex_state = 3},
  [3627] = {.lex_state = 55, .external_lex_state = 3},
  [3628] = {.lex_state = 55, .external_lex_state = 3},
  [3629] = {.lex_state = 55, .external_lex_state = 3},
  [3630] = {.lex_state = 55, .external_lex_state = 3},
  [3631] = {.lex_state = 55, .external_lex_state = 3},
  [3632] = {.lex_state = 55, .external_lex_state = 3},
  [3633] = {.lex_state = 55, .external_lex_state = 3},
  [3634] = {.lex_state = 55, .external_lex_state = 3},
  [3635] = {.lex_state = 55, .external_lex_state = 3},
  [3636] = {.lex_state = 55, .external_lex_state = 3},
  [3637] = {.lex_state = 55, .external_lex_state = 3},
  [3638] = {.lex_state = 55, .external_lex_state = 3},
  [3639] = {.lex_state = 55, .external_lex_state = 3},
  [3640] = {.lex_state = 55, .external_lex_state = 3},
  [3641] = {.lex_state = 55, .external_lex_state = 3},
  [3642] = {.lex_state = 55, .external_lex_state = 3},
  [3643] = {.lex_state = 55, .external_lex_state = 3},
  [3644] = {.lex_state = 55, .external_lex_state = 3},
  [3645] = {.lex_state = 55, .external_lex_state = 3},
  [3646] = {.lex_state = 55, .external_lex_state = 3},
  [3647] = {.lex_state = 55, .external_lex_state = 3},
  [3648] = {.lex_state = 55, .external_lex_state = 3},
  [3649] = {.lex_state = 55, .external_lex_state = 3},
  [3650] = {.lex_state = 55, .external_lex_state = 3},
  [3651] = {.lex_state = 55, .external_lex_state = 3},
  [3652] = {.lex_state = 55, .external_lex_state = 3},
  [3653] = {.lex_state = 55, .external_lex_state = 3},
  [3654] = {.lex_state = 55, .external_lex_state = 3},
  [3655] = {.lex_state = 55, .external_lex_state = 3},
  [3656] = {.lex_state = 55, .external_lex_state = 3},
  [3657] = {.lex_state = 55, .external_lex_state = 3},
  [3658] = {.lex_state = 55, .external_lex_state = 3},
  [3659] = {.lex_state = 55, .external_lex_state = 3},
  [3660] = {.lex_state = 55, .external_lex_state = 3},
  [3661] = {.lex_state = 55, .external_lex_state = 3},
  [3662] = {.lex_state = 55, .external_lex_state = 3},
  [3663] = {.lex_state = 55, .external_lex_state = 3},
  [3664] = {.lex_state = 55, .external_lex_state = 3},
  [3665] = {.lex_state = 55, .external_lex_state = 3},
  [3666] = {.lex_state = 55, .external_lex_state = 3},
  [3667] = {.lex_state = 55, .external_lex_state = 3},
  [3668] = {.lex_state = 55, .external_lex_state = 3},
  [3669] = {.lex_state = 55, .external_lex_state = 3},
  [3670] = {.lex_state = 55, .external_lex_state = 3},
  [3671] = {.lex_state = 55, .external_lex_state = 3},
  [3672] = {.lex_state = 55, .external_lex_state = 3},
  [3673] = {.lex_state = 55, .external_lex_state = 3},
  [3674] = {.lex_state = 55, .external_lex_state = 3},
  [3675] = {.lex_state = 55, .external_lex_state = 3},
  [3676] = {.lex_state = 55, .external_lex_state = 3},
  [3677] = {.lex_state = 55, .external_lex_state = 3},
  [3678] = {.lex_state = 55, .external_lex_state = 3},
  [3679] = {.lex_state = 55, .external_lex_state = 3},
  [3680] = {.lex_state = 55, .external_lex_state = 3},
  [3681] = {.lex_state = 55, .external_lex_state = 3},
  [3682] = {.lex_state = 55, .external_lex_state = 3},
  [3683] = {.lex_state = 55, .external_lex_state = 3},
  [3684] = {.lex_state = 55, .external_lex_state = 3},
  [3685] = {.lex_state = 55, .external_lex_state = 3},
  [3686] = {.lex_state = 55, .external_lex_state = 3},
  [3687] = {.lex_state = 55, .external_lex_state = 3},
  [3688] = {.lex_state = 55, .external_lex_state = 3},
  [3689] = {.lex_state = 55, .external_lex_state = 3},
  [3690] = {.lex_state = 55, .external_lex_state = 3},
  [3691] = {.lex_state = 55, .external_lex_state = 3},
  [3692] = {.lex_state = 55, .external_lex_state = 3},
  [3693] = {.lex_state = 55, .external_lex_state = 3},
  [3694] = {.lex_state = 55, .external_lex_state = 3},
  [3695] = {.lex_state = 55, .external_lex_state = 3},
  [3696] = {.lex_state = 55, .external_lex_state = 3},
  [3697] = {.lex_state = 55, .external_lex_state = 3},
  [3698] = {.lex_state = 55, .external_lex_state = 3},
  [3699] = {.lex_state = 55, .external_lex_state = 3},
  [3700] = {.lex_state = 55, .external_lex_state = 3},
  [3701] = {.lex_state = 55, .external_lex_state = 3},
  [3702] = {.lex_state = 55, .external_lex_state = 3},
  [3703] = {.lex_state = 55, .external_lex_state = 3},
  [3704] = {.lex_state = 55, .external_lex_state = 3},
  [3705] = {.lex_state = 55, .external_lex_state = 3},
  [3706] = {.lex_state = 55, .external_lex_state = 3},
  [3707] = {.lex_state = 55, .external_lex_state = 3},
  [3708] = {.lex_state = 55, .external_lex_state = 3},
  [3709] = {.lex_state = 55, .external_lex_state = 3},
  [3710] = {.lex_state = 55, .external_lex_state = 3},
  [3711] = {.lex_state = 55, .external_lex_state = 3},
  [3712] = {.lex_state = 55, .external_lex_state = 3},
  [3713] = {.lex_state = 55, .external_lex_state = 3},
  [3714] = {.lex_state = 55, .external_lex_state = 3},
  [3715] = {.lex_state = 55, .external_lex_state = 3},
  [3716] = {.lex_state = 55, .external_lex_state = 3},
  [3717] = {.lex_state = 55, .external_lex_state = 3},
  [3718] = {.lex_state = 55, .external_lex_state = 3},
  [3719] = {.lex_state = 55, .external_lex_state = 3},
  [3720] = {.lex_state = 55, .external_lex_state = 3},
  [3721] = {.lex_state = 55, .external_lex_state = 3},
  [3722] = {.lex_state = 55, .external_lex_state = 3},
  [3723] = {.lex_state = 61, .external_lex_state = 115},
  [3724] = {.lex_state = 61, .external_lex_state = 116},
  [3725] = {.lex_state = 61, .external_lex_state = 115},
  [3726] = {.lex_state = 56, .external_lex_state = 37},
  [3727] = {.lex_state = 56, .external_lex_state = 37},
  [3728] = {.lex_state = 61, .external_lex_state = 117},
  [3729] = {.lex_state = 61, .external_lex_state = 115},
  [3730] = {.lex_state = 61, .external_lex_state = 116},
  [3731] = {.lex_state = 61, .external_lex_state = 115},
  [3732] = {.lex_state = 61, .external_lex_state = 115},
  [3733] = {.lex_state = 61, .external_lex_state = 116},
  [3734] = {.lex_state = 61, .external_lex_state = 116},
  [3735] = {.lex_state = 56, .external_lex_state = 37},
  [3736] = {.lex_state = 56, .external_lex_state = 37},
  [3737] = {.lex_state = 61, .external_lex_state = 116},
  [3738] = {.lex_state = 60, .external_lex_state = 118},
  [3739] = {.lex_state = 61, .external_lex_state = 117},
  [3740] = {.lex_state = 61, .external_lex_state = 116},
  [3741] = {.lex_state = 61, .external_lex_state = 117},
  [3742] = {.lex_state = 61, .external_lex_state = 115},
  [3743] = {.lex_state = 60, .external_lex_state = 119},
  [3744] = {.lex_state = 61, .external_lex_state = 9},
  [3745] = {.lex_state = 55, .external_lex_state = 120},
  [3746] = {.lex_state = 61, .external_lex_state = 9},
  [3747] = {.lex_state = 61, .external_lex_state = 9},
  [3748] = {.lex_state = 58, .external_lex_state = 3},
  [3749] = {.lex_state = 61, .external_lex_state = 9},
  [3750] = {.lex_state = 61, .external_lex_state = 9},
  [3751] = {.lex_state = 61, .external_lex_state = 9},
  [3752] = {.lex_state = 61, .external_lex_state = 118},
  [3753] = {.lex_state = 61, .external_lex_state = 10},
  [3754] = {.lex_state = 61, .external_lex_state = 10},
  [3755] = {.lex_state = 61, .external_lex_state = 10},
  [3756] = {.lex_state = 61, .external_lex_state = 10},
  [3757] = {.lex_state = 61, .external_lex_state = 9},
  [3758] = {.lex_state = 61, .external_lex_state = 9},
  [3759] = {.lex_state = 61, .external_lex_state = 10},
  [3760] = {.lex_state = 61, .external_lex_state = 10},
  [3761] = {.lex_state = 61, .external_lex_state = 9},
  [3762] = {.lex_state = 61, .external_lex_state = 9},
  [3763] = {.lex_state = 61, .external_lex_state = 10},
  [3764] = {.lex_state = 61, .external_lex_state = 9},
  [3765] = {.lex_state = 61, .external_lex_state = 9},
  [3766] = {.lex_state = 61, .external_lex_state = 9},
  [3767] = {.lex_state = 61, .external_lex_state = 10},
  [3768] = {.lex_state = 61, .external_lex_state = 9},
  [3769] = {.lex_state = 61, .external_lex_state = 9},
  [3770] = {.lex_state = 61, .external_lex_state = 10},
  [3771] = {.lex_state = 61, .external_lex_state = 9},
  [3772] = {.lex_state = 61, .external_lex_state = 9},
  [3773] = {.lex_state = 61, .external_lex_state = 10},
  [3774] = {.lex_state = 61, .external_lex_state = 10},
  [3775] = {.lex_state = 61, .external_lex_state = 9},
  [3776] = {.lex_state = 58, .external_lex_state = 3},
  [3777] = {.lex_state = 61, .external_lex_state = 9},
  [3778] = {.lex_state = 61, .external_lex_state = 9},
  [3779] = {.lex_state = 61, .external_lex_state = 9},
  [3780] = {.lex_state = 61, .external_lex_state = 9},
  [3781] = {.lex_state = 61, .external_lex_state = 9},
  [3782] = {.lex_state = 61, .external_lex_state = 9},
  [3783] = {.lex_state = 61, .external_lex_state = 9},
  [3784] = {.lex_state = 61, .external_lex_state = 5},
  [3785] = {.lex_state = 61, .external_lex_state = 9},
  [3786] = {.lex_state = 60, .external_lex_state = 121},
  [3787] = {.lex_state = 61, .external_lex_state = 10},
  [3788] = {.lex_state = 61, .external_lex_state = 10},
  [3789] = {.lex_state = 61, .external_lex_state = 9},
  [3790] = {.lex_state = 61, .external_lex_state = 10},
  [3791] = {.lex_state = 61, .external_lex_state = 9},
  [3792] = {.lex_state = 61, .external_lex_state = 10},
  [3793] = {.lex_state = 61, .external_lex_state = 10},
  [3794] = {.lex_state = 61, .external_lex_state = 9},
  [3795] = {.lex_state = 61, .external_lex_state = 10},
  [3796] = {.lex_state = 61, .external_lex_state = 9},
  [3797] = {.lex_state = 61, .external_lex_state = 10},
  [3798] = {.lex_state = 61, .external_lex_state = 119},
  [3799] = {.lex_state = 61, .external_lex_state = 9},
  [3800] = {.lex_state = 61, .external_lex_state = 10},
  [3801] = {.lex_state = 61, .external_lex_state = 9},
  [3802] = {.lex_state = 61, .external_lex_state = 10},
  [3803] = {.lex_state = 61, .external_lex_state = 10},
  [3804] = {.lex_state = 58, .external_lex_state = 3},
  [3805] = {.lex_state = 61, .external_lex_state = 9},
  [3806] = {.lex_state = 61, .external_lex_state = 9},
  [3807] = {.lex_state = 61, .external_lex_state = 10},
  [3808] = {.lex_state = 61, .external_lex_state = 5},
  [3809] = {.lex_state = 58, .external_lex_state = 3},
  [3810] = {.lex_state = 58, .external_lex_state = 3},
  [3811] = {.lex_state = 61, .external_lex_state = 10},
  [3812] = {.lex_state = 61, .external_lex_state = 10},
  [3813] = {.lex_state = 61, .external_lex_state = 10},
  [3814] = {.lex_state = 61, .external_lex_state = 10},
  [3815] = {.lex_state = 61, .external_lex_state = 9},
  [3816] = {.lex_state = 61, .external_lex_state = 10},
  [3817] = {.lex_state = 61, .external_lex_state = 10},
  [3818] = {.lex_state = 61, .external_lex_state = 10},
  [3819] = {.lex_state = 61, .external_lex_state = 10},
  [3820] = {.lex_state = 61, .external_lex_state = 10},
  [3821] = {.lex_state = 61, .external_lex_state = 10},
  [3822] = {.lex_state = 61, .external_lex_state = 10},
  [3823] = {.lex_state = 61, .external_lex_state = 10},
  [3824] = {.lex_state = 61, .external_lex_state = 10},
  [3825] = {.lex_state = 61, .external_lex_state = 9},
  [3826] = {.lex_state = 61, .external_lex_state = 9},
  [3827] = {.lex_state = 61, .external_lex_state = 122},
  [3828] = {.lex_state = 56, .external_lex_state = 37},
  [3829] = {.lex_state = 61, .external_lex_state = 9},
  [3830] = {.lex_state = 61, .external_lex_state = 9},
  [3831] = {.lex_state = 56, .external_lex_state = 37},
  [3832] = {.lex_state = 61, .external_lex_state = 9},
  [3833] = {.lex_state = 61, .external_lex_state = 9},
  [3834] = {.lex_state = 56, .external_lex_state = 37},
  [3835] = {.lex_state = 61, .external_lex_state = 9},
  [3836] = {.lex_state = 61, .external_lex_state = 9},
  [3837] = {.lex_state = 56, .external_lex_state = 37},
  [3838] = {.lex_state = 61, .external_lex_state = 9},
  [3839] = {.lex_state = 61, .external_lex_state = 9},
  [3840] = {.lex_state = 56, .external_lex_state = 37},
  [3841] = {.lex_state = 61, .external_lex_state = 9},
  [3842] = {.lex_state = 61, .external_lex_state = 9},
  [3843] = {.lex_state = 61, .external_lex_state = 9},
  [3844] = {.lex_state = 61, .external_lex_state = 9},
  [3845] = {.lex_state = 56, .external_lex_state = 37},
  [3846] = {.lex_state = 61, .external_lex_state = 9},
  [3847] = {.lex_state = 56, .external_lex_state = 37},
  [3848] = {.lex_state = 56, .external_lex_state = 37},
  [3849] = {.lex_state = 61, .external_lex_state = 9},
  [3850] = {.lex_state = 61, .external_lex_state = 9},
  [3851] = {.lex_state = 61, .external_lex_state = 9},
  [3852] = {.lex_state = 56, .external_lex_state = 37},
  [3853] = {.lex_state = 61, .external_lex_state = 9},
  [3854] = {.lex_state = 56, .external_lex_state = 37},
  [3855] = {.lex_state = 56, .external_lex_state = 37},
  [3856] = {.lex_state = 61, .external_lex_state = 9},
  [3857] = {.lex_state = 61, .external_lex_state = 9},
  [3858] = {.lex_state = 56, .external_lex_state = 37},
  [3859] = {.lex_state = 61, .external_lex_state = 9},
  [3860] = {.lex_state = 61, .external_lex_state = 9},
  [3861] = {.lex_state = 61, .external_lex_state = 9},
  [3862] = {.lex_state = 61, .external_lex_state = 9},
  [3863] = {.lex_state = 56, .external_lex_state = 37},
  [3864] = {.lex_state = 56, .external_lex_state = 37},
  [3865] = {.lex_state = 56, .external_lex_state = 37},
  [3866] = {.lex_state = 56, .external_lex_state = 37},
  [3867] = {.lex_state = 61, .external_lex_state = 9},
  [3868] = {.lex_state = 56, .external_lex_state = 37},
  [3869] = {.lex_state = 56, .external_lex_state = 37},
  [3870] = {.lex_state = 61, .external_lex_state = 9},
  [3871] = {.lex_state = 56, .external_lex_state = 37},
  [3872] = {.lex_state = 56, .external_lex_state = 37},
  [3873] = {.lex_state = 56, .external_lex_state = 37},
  [3874] = {.lex_state = 61, .external_lex_state = 9},
  [3875] = {.lex_state = 61, .external_lex_state = 9},
  [3876] = {.lex_state = 56, .external_lex_state = 37},
  [3877] = {.lex_state = 56, .external_lex_state = 37},
  [3878] = {.lex_state = 61, .external_lex_state = 122},
  [3879] = {.lex_state = 56, .external_lex_state = 37},
  [3880] = {.lex_state = 56, .external_lex_state = 37},
  [3881] = {.lex_state = 56, .external_lex_state = 37},
  [3882] = {.lex_state = 56, .external_lex_state = 37},
  [3883] = {.lex_state = 56, .external_lex_state = 37},
  [3884] = {.lex_state = 56, .external_lex_state = 37},
  [3885] = {.lex_state = 56, .external_lex_state = 37},
  [3886] = {.lex_state = 56, .external_lex_state = 37},
  [3887] = {.lex_state = 56, .external_lex_state = 37},
  [3888] = {.lex_state = 56, .external_lex_state = 37},
  [3889] = {.lex_state = 56, .external_lex_state = 37},
  [3890] = {.lex_state = 56, .external_lex_state = 37},
  [3891] = {.lex_state = 56, .external_lex_state = 37},
  [3892] = {.lex_state = 56, .external_lex_state = 37},
  [3893] = {.lex_state = 56, .external_lex_state = 37},
  [3894] = {.lex_state = 56, .external_lex_state = 37},
  [3895] = {.lex_state = 56, .external_lex_state = 37},
  [3896] = {.lex_state = 56, .external_lex_state = 37},
  [3897] = {.lex_state = 56, .external_lex_state = 37},
  [3898] = {.lex_state = 56, .external_lex_state = 37},
  [3899] = {.lex_state = 56, .external_lex_state = 37},
  [3900] = {.lex_state = 56, .external_lex_state = 37},
  [3901] = {.lex_state = 56, .external_lex_state = 37},
  [3902] = {.lex_state = 56, .external_lex_state = 37},
  [3903] = {.lex_state = 56, .external_lex_state = 37},
  [3904] = {.lex_state = 56, .external_lex_state = 37},
  [3905] = {.lex_state = 56, .external_lex_state = 37},
  [3906] = {.lex_state = 56, .external_lex_state = 37},
  [3907] = {.lex_state = 56, .external_lex_state = 37},
  [3908] = {.lex_state = 56, .external_lex_state = 37},
  [3909] = {.lex_state = 56, .external_lex_state = 37},
  [3910] = {.lex_state = 56, .external_lex_state = 37},
  [3911] = {.lex_state = 56, .external_lex_state = 37},
  [3912] = {.lex_state = 56, .external_lex_state = 37},
  [3913] = {.lex_state = 56, .external_lex_state = 37},
  [3914] = {.lex_state = 56, .external_lex_state = 37},
  [3915] = {.lex_state = 61, .external_lex_state = 122},
  [3916] = {.lex_state = 56, .external_lex_state = 37},
  [3917] = {.lex_state = 56, .external_lex_state = 37},
  [3918] = {.lex_state = 56, .external_lex_state = 37},
  [3919] = {.lex_state = 56, .external_lex_state = 37},
  [3920] = {.lex_state = 56, .external_lex_state = 37},
  [3921] = {.lex_state = 56, .external_lex_state = 37},
  [3922] = {.lex_state = 56, .external_lex_state = 37},
  [3923] = {.lex_state = 56, .external_lex_state = 37},
  [3924] = {.lex_state = 56, .external_lex_state = 37},
  [3925] = {.lex_state = 56, .external_lex_state = 37},
  [3926] = {.lex_state = 56, .external_lex_state = 37},
  [3927] = {.lex_state = 56, .external_lex_state = 37},
  [3928] = {.lex_state = 56, .external_lex_state = 37},
  [3929] = {.lex_state = 56, .external_lex_state = 37},
  [3930] = {.lex_state = 56, .external_lex_state = 37},
  [3931] = {.lex_state = 56, .external_lex_state = 37},
  [3932] = {.lex_state = 56, .external_lex_state = 37},
  [3933] = {.lex_state = 56, .external_lex_state = 37},
  [3934] = {.lex_state = 56, .external_lex_state = 37},
  [3935] = {.lex_state = 56, .external_lex_state = 37},
  [3936] = {.lex_state = 56, .external_lex_state = 37},
  [3937] = {.lex_state = 56, .external_lex_state = 37},
  [3938] = {.lex_state = 56, .external_lex_state = 37},
  [3939] = {.lex_state = 56, .external_lex_state = 37},
  [3940] = {.lex_state = 56, .external_lex_state = 37},
  [3941] = {.lex_state = 56, .external_lex_state = 37},
  [3942] = {.lex_state = 56, .external_lex_state = 37},
  [3943] = {.lex_state = 56, .external_lex_state = 37},
  [3944] = {.lex_state = 56, .external_lex_state = 37},
  [3945] = {.lex_state = 56, .external_lex_state = 37},
  [3946] = {.lex_state = 56, .external_lex_state = 37},
  [3947] = {.lex_state = 56, .external_lex_state = 37},
  [3948] = {.lex_state = 56, .external_lex_state = 37},
  [3949] = {.lex_state = 56, .external_lex_state = 37},
  [3950] = {.lex_state = 56, .external_lex_state = 37},
  [3951] = {.lex_state = 56, .external_lex_state = 37},
  [3952] = {.lex_state = 56, .external_lex_state = 37},
  [3953] = {.lex_state = 56, .external_lex_state = 37},
  [3954] = {.lex_state = 56, .external_lex_state = 37},
  [3955] = {.lex_state = 56, .external_lex_state = 37},
  [3956] = {.lex_state = 56, .external_lex_state = 37},
  [3957] = {.lex_state = 56, .external_lex_state = 37},
  [3958] = {.lex_state = 56, .external_lex_state = 37},
  [3959] = {.lex_state = 56, .external_lex_state = 37},
  [3960] = {.lex_state = 56, .external_lex_state = 37},
  [3961] = {.lex_state = 56, .external_lex_state = 37},
  [3962] = {.lex_state = 56, .external_lex_state = 37},
  [3963] = {.lex_state = 56, .external_lex_state = 37},
  [3964] = {.lex_state = 56, .external_lex_state = 37},
  [3965] = {.lex_state = 56, .external_lex_state = 37},
  [3966] = {.lex_state = 56, .external_lex_state = 37},
  [3967] = {.lex_state = 56, .external_lex_state = 37},
  [3968] = {.lex_state = 56, .external_lex_state = 37},
  [3969] = {.lex_state = 56, .external_lex_state = 37},
  [3970] = {.lex_state = 56, .external_lex_state = 37},
  [3971] = {.lex_state = 56, .external_lex_state = 37},
  [3972] = {.lex_state = 56, .external_lex_state = 37},
  [3973] = {.lex_state = 56, .external_lex_state = 37},
  [3974] = {.lex_state = 56, .external_lex_state = 37},
  [3975] = {.lex_state = 56, .external_lex_state = 37},
  [3976] = {.lex_state = 56, .external_lex_state = 37},
  [3977] = {.lex_state = 56, .external_lex_state = 37},
  [3978] = {.lex_state = 56, .external_lex_state = 37},
  [3979] = {.lex_state = 56, .external_lex_state = 37},
  [3980] = {.lex_state = 56, .external_lex_state = 37},
  [3981] = {.lex_state = 56, .external_lex_state = 37},
  [3982] = {.lex_state = 56, .external_lex_state = 37},
  [3983] = {.lex_state = 56, .external_lex_state = 37},
  [3984] = {.lex_state = 56, .external_lex_state = 37},
  [3985] = {.lex_state = 56, .external_lex_state = 37},
  [3986] = {.lex_state = 56, .external_lex_state = 37},
  [3987] = {.lex_state = 56, .external_lex_state = 37},
  [3988] = {.lex_state = 56, .external_lex_state = 37},
  [3989] = {.lex_state = 56, .external_lex_state = 37},
  [3990] = {.lex_state = 56, .external_lex_state = 37},
  [3991] = {.lex_state = 56, .external_lex_state = 37},
  [3992] = {.lex_state = 56, .external_lex_state = 37},
  [3993] = {.lex_state = 56, .external_lex_state = 37},
  [3994] = {.lex_state = 56, .external_lex_state = 37},
  [3995] = {.lex_state = 56, .external_lex_state = 37},
  [3996] = {.lex_state = 56, .external_lex_state = 37},
  [3997] = {.lex_state = 56, .external_lex_state = 37},
  [3998] = {.lex_state = 56, .external_lex_state = 37},
  [3999] = {.lex_state = 56, .external_lex_state = 37},
  [4000] = {.lex_state = 56, .external_lex_state = 37},
  [4001] = {.lex_state = 56, .external_lex_state = 37},
  [4002] = {.lex_state = 56, .external_lex_state = 37},
  [4003] = {.lex_state = 56, .external_lex_state = 37},
  [4004] = {.lex_state = 56, .external_lex_state = 37},
  [4005] = {.lex_state = 56, .external_lex_state = 37},
  [4006] = {.lex_state = 56, .external_lex_state = 37},
  [4007] = {.lex_state = 56, .external_lex_state = 37},
  [4008] = {.lex_state = 56, .external_lex_state = 37},
  [4009] = {.lex_state = 56, .external_lex_state = 37},
  [4010] = {.lex_state = 56, .external_lex_state = 37},
  [4011] = {.lex_state = 56, .external_lex_state = 37},
  [4012] = {.lex_state = 56, .external_lex_state = 37},
  [4013] = {.lex_state = 56, .external_lex_state = 37},
  [4014] = {.lex_state = 56, .external_lex_state = 37},
  [4015] = {.lex_state = 56, .external_lex_state = 37},
  [4016] = {.lex_state = 56, .external_lex_state = 37},
  [4017] = {.lex_state = 56, .external_lex_state = 37},
  [4018] = {.lex_state = 55, .external_lex_state = 123},
  [4019] = {.lex_state = 56, .external_lex_state = 37},
  [4020] = {.lex_state = 56, .external_lex_state = 37},
  [4021] = {.lex_state = 56, .external_lex_state = 37},
  [4022] = {.lex_state = 56, .external_lex_state = 37},
  [4023] = {.lex_state = 56, .external_lex_state = 37},
  [4024] = {.lex_state = 56, .external_lex_state = 37},
  [4025] = {.lex_state = 56, .external_lex_state = 37},
  [4026] = {.lex_state = 56, .external_lex_state = 37},
  [4027] = {.lex_state = 56, .external_lex_state = 37},
  [4028] = {.lex_state = 56, .external_lex_state = 37},
  [4029] = {.lex_state = 56, .external_lex_state = 37},
  [4030] = {.lex_state = 56, .external_lex_state = 37},
  [4031] = {.lex_state = 56, .external_lex_state = 37},
  [4032] = {.lex_state = 56, .external_lex_state = 37},
  [4033] = {.lex_state = 56, .external_lex_state = 37},
  [4034] = {.lex_state = 56, .external_lex_state = 37},
  [4035] = {.lex_state = 56, .external_lex_state = 37},
  [4036] = {.lex_state = 56, .external_lex_state = 37},
  [4037] = {.lex_state = 56, .external_lex_state = 37},
  [4038] = {.lex_state = 56, .external_lex_state = 37},
  [4039] = {.lex_state = 56, .external_lex_state = 37},
  [4040] = {.lex_state = 56, .external_lex_state = 37},
  [4041] = {.lex_state = 56, .external_lex_state = 37},
  [4042] = {.lex_state = 56, .external_lex_state = 37},
  [4043] = {.lex_state = 56, .external_lex_state = 37},
  [4044] = {.lex_state = 56, .external_lex_state = 37},
  [4045] = {.lex_state = 56, .external_lex_state = 37},
  [4046] = {.lex_state = 56, .external_lex_state = 37},
  [4047] = {.lex_state = 56, .external_lex_state = 37},
  [4048] = {.lex_state = 56, .external_lex_state = 37},
  [4049] = {.lex_state = 56, .external_lex_state = 37},
  [4050] = {.lex_state = 56, .external_lex_state = 37},
  [4051] = {.lex_state = 56, .external_lex_state = 37},
  [4052] = {.lex_state = 56, .external_lex_state = 37},
  [4053] = {.lex_state = 56, .external_lex_state = 37},
  [4054] = {.lex_state = 56, .external_lex_state = 37},
  [4055] = {.lex_state = 56, .external_lex_state = 37},
  [4056] = {.lex_state = 56, .external_lex_state = 37},
  [4057] = {.lex_state = 56, .external_lex_state = 37},
  [4058] = {.lex_state = 56, .external_lex_state = 37},
  [4059] = {.lex_state = 56, .external_lex_state = 37},
  [4060] = {.lex_state = 56, .external_lex_state = 37},
  [4061] = {.lex_state = 61, .external_lex_state = 121},
  [4062] = {.lex_state = 56, .external_lex_state = 37},
  [4063] = {.lex_state = 56, .external_lex_state = 37},
  [4064] = {.lex_state = 56, .external_lex_state = 37},
  [4065] = {.lex_state = 56, .external_lex_state = 37},
  [4066] = {.lex_state = 56, .external_lex_state = 37},
  [4067] = {.lex_state = 56, .external_lex_state = 37},
  [4068] = {.lex_state = 56, .external_lex_state = 37},
  [4069] = {.lex_state = 56, .external_lex_state = 37},
  [4070] = {.lex_state = 56, .external_lex_state = 37},
  [4071] = {.lex_state = 56, .external_lex_state = 37},
  [4072] = {.lex_state = 56, .external_lex_state = 37},
  [4073] = {.lex_state = 56, .external_lex_state = 37},
  [4074] = {.lex_state = 56, .external_lex_state = 37},
  [4075] = {.lex_state = 56, .external_lex_state = 37},
  [4076] = {.lex_state = 61, .external_lex_state = 10},
  [4077] = {.lex_state = 61, .external_lex_state = 10},
  [4078] = {.lex_state = 55, .external_lex_state = 9},
  [4079] = {.lex_state = 61, .external_lex_state = 10},
  [4080] = {.lex_state = 61, .external_lex_state = 124},
  [4081] = {.lex_state = 55, .external_lex_state = 9},
  [4082] = {.lex_state = 61, .external_lex_state = 10},
  [4083] = {.lex_state = 55, .external_lex_state = 9},
  [4084] = {.lex_state = 61, .external_lex_state = 10},
  [4085] = {.lex_state = 55, .external_lex_state = 9},
  [4086] = {.lex_state = 55, .external_lex_state = 9},
  [4087] = {.lex_state = 55, .external_lex_state = 9},
  [4088] = {.lex_state = 55, .external_lex_state = 9},
  [4089] = {.lex_state = 55, .external_lex_state = 9},
  [4090] = {.lex_state = 60, .external_lex_state = 119},
  [4091] = {.lex_state = 61, .external_lex_state = 124},
  [4092] = {.lex_state = 61, .external_lex_state = 124},
  [4093] = {.lex_state = 55, .external_lex_state = 9},
  [4094] = {.lex_state = 55, .external_lex_state = 9},
  [4095] = {.lex_state = 55, .external_lex_state = 9},
  [4096] = {.lex_state = 61, .external_lex_state = 10},
  [4097] = {.lex_state = 55, .external_lex_state = 9},
  [4098] = {.lex_state = 61, .external_lex_state = 10},
  [4099] = {.lex_state = 55, .external_lex_state = 9},
  [4100] = {.lex_state = 55, .external_lex_state = 9},
  [4101] = {.lex_state = 61, .external_lex_state = 5},
  [4102] = {.lex_state = 61, .external_lex_state = 10},
  [4103] = {.lex_state = 61, .external_lex_state = 10},
  [4104] = {.lex_state = 61, .external_lex_state = 10},
  [4105] = {.lex_state = 61, .external_lex_state = 10},
  [4106] = {.lex_state = 61, .external_lex_state = 10},
  [4107] = {.lex_state = 61, .external_lex_state = 10},
  [4108] = {.lex_state = 61, .external_lex_state = 10},
  [4109] = {.lex_state = 61, .external_lex_state = 10},
  [4110] = {.lex_state = 55, .external_lex_state = 9},
  [4111] = {.lex_state = 55, .external_lex_state = 9},
  [4112] = {.lex_state = 55, .external_lex_state = 9},
  [4113] = {.lex_state = 61, .external_lex_state = 10},
  [4114] = {.lex_state = 61, .external_lex_state = 10},
  [4115] = {.lex_state = 61, .external_lex_state = 124},
  [4116] = {.lex_state = 61, .external_lex_state = 124},
  [4117] = {.lex_state = 61, .external_lex_state = 10},
  [4118] = {.lex_state = 61, .external_lex_state = 10},
  [4119] = {.lex_state = 61, .external_lex_state = 125},
  [4120] = {.lex_state = 61, .external_lex_state = 10},
  [4121] = {.lex_state = 61, .external_lex_state = 124},
  [4122] = {.lex_state = 61, .external_lex_state = 10},
  [4123] = {.lex_state = 61, .external_lex_state = 10},
  [4124] = {.lex_state = 61, .external_lex_state = 10},
  [4125] = {.lex_state = 61, .external_lex_state = 10},
  [4126] = {.lex_state = 61, .external_lex_state = 10},
  [4127] = {.lex_state = 61, .external_lex_state = 125},
  [4128] = {.lex_state = 60, .external_lex_state = 118},
  [4129] = {.lex_state = 60, .external_lex_state = 8},
  [4130] = {.lex_state = 61, .external_lex_state = 10},
  [4131] = {.lex_state = 61, .external_lex_state = 10},
  [4132] = {.lex_state = 61, .external_lex_state = 10},
  [4133] = {.lex_state = 61, .external_lex_state = 10},
  [4134] = {.lex_state = 61, .external_lex_state = 125},
  [4135] = {.lex_state = 55, .external_lex_state = 9},
  [4136] = {.lex_state = 61, .external_lex_state = 8},
  [4137] = {.lex_state = 61, .external_lex_state = 8},
  [4138] = {.lex_state = 55, .external_lex_state = 10},
  [4139] = {.lex_state = 61, .external_lex_state = 8},
  [4140] = {.lex_state = 61, .external_lex_state = 8},
  [4141] = {.lex_state = 55, .external_lex_state = 10},
  [4142] = {.lex_state = 61, .external_lex_state = 8},
  [4143] = {.lex_state = 61, .external_lex_state = 8},
  [4144] = {.lex_state = 61, .external_lex_state = 8},
  [4145] = {.lex_state = 55, .external_lex_state = 10},
  [4146] = {.lex_state = 61, .external_lex_state = 126},
  [4147] = {.lex_state = 61, .external_lex_state = 127},
  [4148] = {.lex_state = 55, .external_lex_state = 10},
  [4149] = {.lex_state = 55, .external_lex_state = 10},
  [4150] = {.lex_state = 61, .external_lex_state = 8},
  [4151] = {.lex_state = 55, .external_lex_state = 10},
  [4152] = {.lex_state = 55, .external_lex_state = 10},
  [4153] = {.lex_state = 61, .external_lex_state = 8},
  [4154] = {.lex_state = 55, .external_lex_state = 10},
  [4155] = {.lex_state = 55, .external_lex_state = 10},
  [4156] = {.lex_state = 55, .external_lex_state = 10},
  [4157] = {.lex_state = 56, .external_lex_state = 107},
  [4158] = {.lex_state = 61, .external_lex_state = 5},
  [4159] = {.lex_state = 61, .external_lex_state = 8},
  [4160] = {.lex_state = 61, .external_lex_state = 126},
  [4161] = {.lex_state = 60, .external_lex_state = 121},
  [4162] = {.lex_state = 61, .external_lex_state = 128},
  [4163] = {.lex_state = 55, .external_lex_state = 10},
  [4164] = {.lex_state = 61, .external_lex_state = 8},
  [4165] = {.lex_state = 61, .external_lex_state = 8},
  [4166] = {.lex_state = 56, .external_lex_state = 107},
  [4167] = {.lex_state = 61, .external_lex_state = 8},
  [4168] = {.lex_state = 61, .external_lex_state = 129},
  [4169] = {.lex_state = 61, .external_lex_state = 129},
  [4170] = {.lex_state = 61, .external_lex_state = 130},
  [4171] = {.lex_state = 61, .external_lex_state = 8},
  [4172] = {.lex_state = 55, .external_lex_state = 10},
  [4173] = {.lex_state = 55, .external_lex_state = 10},
  [4174] = {.lex_state = 55, .external_lex_state = 10},
  [4175] = {.lex_state = 55, .external_lex_state = 10},
  [4176] = {.lex_state = 61, .external_lex_state = 127},
  [4177] = {.lex_state = 61, .external_lex_state = 129},
  [4178] = {.lex_state = 61, .external_lex_state = 8},
  [4179] = {.lex_state = 61, .external_lex_state = 130},
  [4180] = {.lex_state = 61, .external_lex_state = 128},
  [4181] = {.lex_state = 61, .external_lex_state = 8},
  [4182] = {.lex_state = 61, .external_lex_state = 8},
  [4183] = {.lex_state = 61, .external_lex_state = 8},
  [4184] = {.lex_state = 61, .external_lex_state = 8},
  [4185] = {.lex_state = 61, .external_lex_state = 8},
  [4186] = {.lex_state = 61, .external_lex_state = 8},
  [4187] = {.lex_state = 61, .external_lex_state = 128},
  [4188] = {.lex_state = 61, .external_lex_state = 8},
  [4189] = {.lex_state = 61, .external_lex_state = 126},
  [4190] = {.lex_state = 61, .external_lex_state = 8},
  [4191] = {.lex_state = 55, .external_lex_state = 10},
  [4192] = {.lex_state = 61, .external_lex_state = 126},
  [4193] = {.lex_state = 61, .external_lex_state = 127},
  [4194] = {.lex_state = 61, .external_lex_state = 8},
  [4195] = {.lex_state = 61, .external_lex_state = 8},
  [4196] = {.lex_state = 55, .external_lex_state = 10},
  [4197] = {.lex_state = 56, .external_lex_state = 107},
  [4198] = {.lex_state = 56, .external_lex_state = 107},
  [4199] = {.lex_state = 61, .external_lex_state = 8},
  [4200] = {.lex_state = 55, .external_lex_state = 10},
  [4201] = {.lex_state = 56, .external_lex_state = 107},
  [4202] = {.lex_state = 61, .external_lex_state = 8},
  [4203] = {.lex_state = 61, .external_lex_state = 8},
  [4204] = {.lex_state = 61, .external_lex_state = 126},
  [4205] = {.lex_state = 61, .external_lex_state = 8},
  [4206] = {.lex_state = 61, .external_lex_state = 8},
  [4207] = {.lex_state = 61, .external_lex_state = 126},
  [4208] = {.lex_state = 61, .external_lex_state = 8},
  [4209] = {.lex_state = 61, .external_lex_state = 8},
  [4210] = {.lex_state = 61, .external_lex_state = 8},
  [4211] = {.lex_state = 61, .external_lex_state = 8},
  [4212] = {.lex_state = 61, .external_lex_state = 130},
  [4213] = {.lex_state = 55, .external_lex_state = 131},
  [4214] = {.lex_state = 61, .external_lex_state = 8},
  [4215] = {.lex_state = 56, .external_lex_state = 107},
  [4216] = {.lex_state = 56, .external_lex_state = 40},
  [4217] = {.lex_state = 61, .external_lex_state = 132},
  [4218] = {.lex_state = 61, .external_lex_state = 11},
  [4219] = {.lex_state = 61, .external_lex_state = 11},
  [4220] = {.lex_state = 61, .external_lex_state = 11},
  [4221] = {.lex_state = 61, .external_lex_state = 11},
  [4222] = {.lex_state = 61, .external_lex_state = 11},
  [4223] = {.lex_state = 61, .external_lex_state = 11},
  [4224] = {.lex_state = 61, .external_lex_state = 11},
  [4225] = {.lex_state = 61, .external_lex_state = 11},
  [4226] = {.lex_state = 61, .external_lex_state = 11},
  [4227] = {.lex_state = 61, .external_lex_state = 11},
  [4228] = {.lex_state = 61, .external_lex_state = 133},
  [4229] = {.lex_state = 61, .external_lex_state = 11},
  [4230] = {.lex_state = 61, .external_lex_state = 11},
  [4231] = {.lex_state = 61, .external_lex_state = 11},
  [4232] = {.lex_state = 56, .external_lex_state = 40},
  [4233] = {.lex_state = 61, .external_lex_state = 11},
  [4234] = {.lex_state = 61, .external_lex_state = 11},
  [4235] = {.lex_state = 61, .external_lex_state = 11},
  [4236] = {.lex_state = 60, .external_lex_state = 12},
  [4237] = {.lex_state = 61, .external_lex_state = 134},
  [4238] = {.lex_state = 61, .external_lex_state = 135},
  [4239] = {.lex_state = 61, .external_lex_state = 11},
  [4240] = {.lex_state = 56, .external_lex_state = 40},
  [4241] = {.lex_state = 56, .external_lex_state = 40},
  [4242] = {.lex_state = 61, .external_lex_state = 136},
  [4243] = {.lex_state = 61, .external_lex_state = 11},
  [4244] = {.lex_state = 61, .external_lex_state = 11},
  [4245] = {.lex_state = 61, .external_lex_state = 11},
  [4246] = {.lex_state = 61, .external_lex_state = 133},
  [4247] = {.lex_state = 61, .external_lex_state = 11},
  [4248] = {.lex_state = 61, .external_lex_state = 11},
  [4249] = {.lex_state = 61, .external_lex_state = 11},
  [4250] = {.lex_state = 56, .external_lex_state = 40},
  [4251] = {.lex_state = 56, .external_lex_state = 40},
  [4252] = {.lex_state = 61, .external_lex_state = 11},
  [4253] = {.lex_state = 61, .external_lex_state = 11},
  [4254] = {.lex_state = 61, .external_lex_state = 11},
  [4255] = {.lex_state = 61, .external_lex_state = 11},
  [4256] = {.lex_state = 61, .external_lex_state = 11},
  [4257] = {.lex_state = 61, .external_lex_state = 11},
  [4258] = {.lex_state = 61, .external_lex_state = 137},
  [4259] = {.lex_state = 61, .external_lex_state = 11},
  [4260] = {.lex_state = 61, .external_lex_state = 137},
  [4261] = {.lex_state = 61, .external_lex_state = 138},
  [4262] = {.lex_state = 61, .external_lex_state = 11},
  [4263] = {.lex_state = 56, .external_lex_state = 40},
  [4264] = {.lex_state = 61, .external_lex_state = 138},
  [4265] = {.lex_state = 61, .external_lex_state = 139},
  [4266] = {.lex_state = 61, .external_lex_state = 138},
  [4267] = {.lex_state = 61, .external_lex_state = 132},
  [4268] = {.lex_state = 61, .external_lex_state = 11},
  [4269] = {.lex_state = 61, .external_lex_state = 139},
  [4270] = {.lex_state = 61, .external_lex_state = 11},
  [4271] = {.lex_state = 61, .external_lex_state = 11},
  [4272] = {.lex_state = 61, .external_lex_state = 140},
  [4273] = {.lex_state = 56, .external_lex_state = 40},
  [4274] = {.lex_state = 61, .external_lex_state = 140},
  [4275] = {.lex_state = 61, .external_lex_state = 133},
  [4276] = {.lex_state = 56, .external_lex_state = 40},
  [4277] = {.lex_state = 61, .external_lex_state = 141},
  [4278] = {.lex_state = 56, .external_lex_state = 40},
  [4279] = {.lex_state = 56, .external_lex_state = 40},
  [4280] = {.lex_state = 61, .external_lex_state = 133},
  [4281] = {.lex_state = 61, .external_lex_state = 136},
  [4282] = {.lex_state = 56, .external_lex_state = 40},
  [4283] = {.lex_state = 61, .external_lex_state = 133},
  [4284] = {.lex_state = 56, .external_lex_state = 40},
  [4285] = {.lex_state = 56, .external_lex_state = 40},
  [4286] = {.lex_state = 56, .external_lex_state = 40},
  [4287] = {.lex_state = 56, .external_lex_state = 40},
  [4288] = {.lex_state = 56, .external_lex_state = 40},
  [4289] = {.lex_state = 61, .external_lex_state = 140},
  [4290] = {.lex_state = 61, .external_lex_state = 134},
  [4291] = {.lex_state = 56, .external_lex_state = 40},
  [4292] = {.lex_state = 61, .external_lex_state = 11},
  [4293] = {.lex_state = 56, .external_lex_state = 40},
  [4294] = {.lex_state = 56, .external_lex_state = 40},
  [4295] = {.lex_state = 61, .external_lex_state = 11},
  [4296] = {.lex_state = 55, .external_lex_state = 142},
  [4297] = {.lex_state = 56, .external_lex_state = 40},
  [4298] = {.lex_state = 56, .external_lex_state = 40},
  [4299] = {.lex_state = 56, .external_lex_state = 40},
  [4300] = {.lex_state = 61, .external_lex_state = 11},
  [4301] = {.lex_state = 56, .external_lex_state = 40},
  [4302] = {.lex_state = 61, .external_lex_state = 11},
  [4303] = {.lex_state = 61, .external_lex_state = 11},
  [4304] = {.lex_state = 61, .external_lex_state = 137},
  [4305] = {.lex_state = 61, .external_lex_state = 11},
  [4306] = {.lex_state = 61, .external_lex_state = 11},
  [4307] = {.lex_state = 61, .external_lex_state = 11},
  [4308] = {.lex_state = 61, .external_lex_state = 136},
  [4309] = {.lex_state = 61, .external_lex_state = 11},
  [4310] = {.lex_state = 61, .external_lex_state = 11},
  [4311] = {.lex_state = 61, .external_lex_state = 11},
  [4312] = {.lex_state = 56, .external_lex_state = 40},
  [4313] = {.lex_state = 61, .external_lex_state = 11},
  [4314] = {.lex_state = 61, .external_lex_state = 135},
  [4315] = {.lex_state = 60, .external_lex_state = 8},
  [4316] = {.lex_state = 56, .external_lex_state = 40},
  [4317] = {.lex_state = 61, .external_lex_state = 11},
  [4318] = {.lex_state = 61, .external_lex_state = 11},
  [4319] = {.lex_state = 56, .external_lex_state = 40},
  [4320] = {.lex_state = 56, .external_lex_state = 40},
  [4321] = {.lex_state = 56, .external_lex_state = 40},
  [4322] = {.lex_state = 61, .external_lex_state = 11},
  [4323] = {.lex_state = 61, .external_lex_state = 11},
  [4324] = {.lex_state = 56, .external_lex_state = 40},
  [4325] = {.lex_state = 56, .external_lex_state = 40},
  [4326] = {.lex_state = 61, .external_lex_state = 135},
  [4327] = {.lex_state = 61, .external_lex_state = 11},
  [4328] = {.lex_state = 61, .external_lex_state = 11},
  [4329] = {.lex_state = 56, .external_lex_state = 40},
  [4330] = {.lex_state = 61, .external_lex_state = 139},
  [4331] = {.lex_state = 61, .external_lex_state = 11},
  [4332] = {.lex_state = 61, .external_lex_state = 11},
  [4333] = {.lex_state = 56, .external_lex_state = 40},
  [4334] = {.lex_state = 61, .external_lex_state = 11},
  [4335] = {.lex_state = 56, .external_lex_state = 40},
  [4336] = {.lex_state = 61, .external_lex_state = 11},
  [4337] = {.lex_state = 56, .external_lex_state = 40},
  [4338] = {.lex_state = 56, .external_lex_state = 40},
  [4339] = {.lex_state = 61, .external_lex_state = 11},
  [4340] = {.lex_state = 61, .external_lex_state = 11},
  [4341] = {.lex_state = 61, .external_lex_state = 11},
  [4342] = {.lex_state = 61, .external_lex_state = 132},
  [4343] = {.lex_state = 60, .external_lex_state = 12},
  [4344] = {.lex_state = 61, .external_lex_state = 11},
  [4345] = {.lex_state = 61, .external_lex_state = 11},
  [4346] = {.lex_state = 61, .external_lex_state = 134},
  [4347] = {.lex_state = 61, .external_lex_state = 11},
  [4348] = {.lex_state = 61, .external_lex_state = 11},
  [4349] = {.lex_state = 61, .external_lex_state = 11},
  [4350] = {.lex_state = 61, .external_lex_state = 133},
  [4351] = {.lex_state = 61, .external_lex_state = 134},
  [4352] = {.lex_state = 61, .external_lex_state = 12},
  [4353] = {.lex_state = 61, .external_lex_state = 12},
  [4354] = {.lex_state = 55, .external_lex_state = 11},
  [4355] = {.lex_state = 61, .external_lex_state = 8},
  [4356] = {.lex_state = 61, .external_lex_state = 12},
  [4357] = {.lex_state = 61, .external_lex_state = 8},
  [4358] = {.lex_state = 61, .external_lex_state = 104},
  [4359] = {.lex_state = 61, .external_lex_state = 12},
  [4360] = {.lex_state = 55, .external_lex_state = 11},
  [4361] = {.lex_state = 61, .external_lex_state = 8},
  [4362] = {.lex_state = 61, .external_lex_state = 8},
  [4363] = {.lex_state = 61, .external_lex_state = 12},
  [4364] = {.lex_state = 61, .external_lex_state = 12},
  [4365] = {.lex_state = 61, .external_lex_state = 12},
  [4366] = {.lex_state = 55, .external_lex_state = 11},
  [4367] = {.lex_state = 60, .external_lex_state = 8},
  [4368] = {.lex_state = 61, .external_lex_state = 104},
  [4369] = {.lex_state = 61, .external_lex_state = 12},
  [4370] = {.lex_state = 55, .external_lex_state = 11},
  [4371] = {.lex_state = 55, .external_lex_state = 11},
  [4372] = {.lex_state = 55, .external_lex_state = 11},
  [4373] = {.lex_state = 61, .external_lex_state = 5},
  [4374] = {.lex_state = 61, .external_lex_state = 8},
  [4375] = {.lex_state = 56, .external_lex_state = 143},
  [4376] = {.lex_state = 55, .external_lex_state = 11},
  [4377] = {.lex_state = 55, .external_lex_state = 11},
  [4378] = {.lex_state = 61, .external_lex_state = 8},
  [4379] = {.lex_state = 61, .external_lex_state = 8},
  [4380] = {.lex_state = 55, .external_lex_state = 11},
  [4381] = {.lex_state = 55, .external_lex_state = 11},
  [4382] = {.lex_state = 55, .external_lex_state = 11},
  [4383] = {.lex_state = 55, .external_lex_state = 11},
  [4384] = {.lex_state = 61, .external_lex_state = 12},
  [4385] = {.lex_state = 61, .external_lex_state = 8},
  [4386] = {.lex_state = 61, .external_lex_state = 12},
  [4387] = {.lex_state = 55, .external_lex_state = 11},
  [4388] = {.lex_state = 61, .external_lex_state = 8},
  [4389] = {.lex_state = 55, .external_lex_state = 11},
  [4390] = {.lex_state = 61, .external_lex_state = 12},
  [4391] = {.lex_state = 61, .external_lex_state = 8},
  [4392] = {.lex_state = 61, .external_lex_state = 8},
  [4393] = {.lex_state = 61, .external_lex_state = 12},
  [4394] = {.lex_state = 61, .external_lex_state = 12},
  [4395] = {.lex_state = 61, .external_lex_state = 8},
  [4396] = {.lex_state = 61, .external_lex_state = 12},
  [4397] = {.lex_state = 61, .external_lex_state = 12},
  [4398] = {.lex_state = 61, .external_lex_state = 12},
  [4399] = {.lex_state = 61, .external_lex_state = 104},
  [4400] = {.lex_state = 61, .external_lex_state = 12},
  [4401] = {.lex_state = 61, .external_lex_state = 12},
  [4402] = {.lex_state = 61, .external_lex_state = 12},
  [4403] = {.lex_state = 61, .external_lex_state = 12},
  [4404] = {.lex_state = 61, .external_lex_state = 8},
  [4405] = {.lex_state = 61, .external_lex_state = 144},
  [4406] = {.lex_state = 61, .external_lex_state = 8},
  [4407] = {.lex_state = 61, .external_lex_state = 12},
  [4408] = {.lex_state = 61, .external_lex_state = 8},
  [4409] = {.lex_state = 61, .external_lex_state = 8},
  [4410] = {.lex_state = 61, .external_lex_state = 12},
  [4411] = {.lex_state = 61, .external_lex_state = 12},
  [4412] = {.lex_state = 61, .external_lex_state = 12},
  [4413] = {.lex_state = 61, .external_lex_state = 8},
  [4414] = {.lex_state = 61, .external_lex_state = 144},
  [4415] = {.lex_state = 61, .external_lex_state = 12},
  [4416] = {.lex_state = 61, .external_lex_state = 8},
  [4417] = {.lex_state = 56, .external_lex_state = 143},
  [4418] = {.lex_state = 61, .external_lex_state = 12},
  [4419] = {.lex_state = 61, .external_lex_state = 12},
  [4420] = {.lex_state = 61, .external_lex_state = 12},
  [4421] = {.lex_state = 61, .external_lex_state = 12},
  [4422] = {.lex_state = 61, .external_lex_state = 12},
  [4423] = {.lex_state = 61, .external_lex_state = 12},
  [4424] = {.lex_state = 61, .external_lex_state = 8},
  [4425] = {.lex_state = 61, .external_lex_state = 12},
  [4426] = {.lex_state = 61, .external_lex_state = 12},
  [4427] = {.lex_state = 61, .external_lex_state = 12},
  [4428] = {.lex_state = 61, .external_lex_state = 12},
  [4429] = {.lex_state = 55, .external_lex_state = 11},
  [4430] = {.lex_state = 61, .external_lex_state = 145},
  [4431] = {.lex_state = 61, .external_lex_state = 12},
  [4432] = {.lex_state = 61, .external_lex_state = 12},
  [4433] = {.lex_state = 61, .external_lex_state = 12},
  [4434] = {.lex_state = 61, .external_lex_state = 8},
  [4435] = {.lex_state = 61, .external_lex_state = 8},
  [4436] = {.lex_state = 56, .external_lex_state = 143},
  [4437] = {.lex_state = 61, .external_lex_state = 145},
  [4438] = {.lex_state = 61, .external_lex_state = 12},
  [4439] = {.lex_state = 61, .external_lex_state = 12},
  [4440] = {.lex_state = 61, .external_lex_state = 8},
  [4441] = {.lex_state = 61, .external_lex_state = 8},
  [4442] = {.lex_state = 61, .external_lex_state = 146},
  [4443] = {.lex_state = 61, .external_lex_state = 12},
  [4444] = {.lex_state = 61, .external_lex_state = 8},
  [4445] = {.lex_state = 61, .external_lex_state = 145},
  [4446] = {.lex_state = 61, .external_lex_state = 8},
  [4447] = {.lex_state = 61, .external_lex_state = 8},
  [4448] = {.lex_state = 61, .external_lex_state = 12},
  [4449] = {.lex_state = 61, .external_lex_state = 146},
  [4450] = {.lex_state = 61, .external_lex_state = 12},
  [4451] = {.lex_state = 61, .external_lex_state = 12},
  [4452] = {.lex_state = 61, .external_lex_state = 8},
  [4453] = {.lex_state = 61, .external_lex_state = 12},
  [4454] = {.lex_state = 61, .external_lex_state = 12},
  [4455] = {.lex_state = 61, .external_lex_state = 8},
  [4456] = {.lex_state = 61, .external_lex_state = 144},
  [4457] = {.lex_state = 55, .external_lex_state = 11},
  [4458] = {.lex_state = 61, .external_lex_state = 12},
  [4459] = {.lex_state = 61, .external_lex_state = 12},
  [4460] = {.lex_state = 55, .external_lex_state = 147},
  [4461] = {.lex_state = 61, .external_lex_state = 12},
  [4462] = {.lex_state = 56, .external_lex_state = 143},
  [4463] = {.lex_state = 61, .external_lex_state = 12},
  [4464] = {.lex_state = 61, .external_lex_state = 12},
  [4465] = {.lex_state = 56, .external_lex_state = 143},
  [4466] = {.lex_state = 61, .external_lex_state = 12},
  [4467] = {.lex_state = 61, .external_lex_state = 144},
  [4468] = {.lex_state = 61, .external_lex_state = 145},
  [4469] = {.lex_state = 61, .external_lex_state = 145},
  [4470] = {.lex_state = 61, .external_lex_state = 12},
  [4471] = {.lex_state = 56, .external_lex_state = 143},
  [4472] = {.lex_state = 61, .external_lex_state = 12},
  [4473] = {.lex_state = 61, .external_lex_state = 87},
  [4474] = {.lex_state = 61, .external_lex_state = 12},
  [4475] = {.lex_state = 61, .external_lex_state = 146},
  [4476] = {.lex_state = 61, .external_lex_state = 87},
  [4477] = {.lex_state = 61, .external_lex_state = 12},
  [4478] = {.lex_state = 61, .external_lex_state = 12},
  [4479] = {.lex_state = 61, .external_lex_state = 12},
  [4480] = {.lex_state = 61, .external_lex_state = 12},
  [4481] = {.lex_state = 61, .external_lex_state = 12},
  [4482] = {.lex_state = 61, .external_lex_state = 8},
  [4483] = {.lex_state = 61, .external_lex_state = 145},
  [4484] = {.lex_state = 61, .external_lex_state = 12},
  [4485] = {.lex_state = 61, .external_lex_state = 12},
  [4486] = {.lex_state = 61, .external_lex_state = 8},
  [4487] = {.lex_state = 61, .external_lex_state = 8},
  [4488] = {.lex_state = 61, .external_lex_state = 12},
  [4489] = {.lex_state = 61, .external_lex_state = 8},
  [4490] = {.lex_state = 61, .external_lex_state = 12},
  [4491] = {.lex_state = 55, .external_lex_state = 11},
  [4492] = {.lex_state = 61, .external_lex_state = 12},
  [4493] = {.lex_state = 61, .external_lex_state = 12},
  [4494] = {.lex_state = 61, .external_lex_state = 8},
  [4495] = {.lex_state = 55, .external_lex_state = 11},
  [4496] = {.lex_state = 61, .external_lex_state = 12},
  [4497] = {.lex_state = 61, .external_lex_state = 87},
  [4498] = {.lex_state = 61, .external_lex_state = 12},
  [4499] = {.lex_state = 56, .external_lex_state = 41},
  [4500] = {.lex_state = 56, .external_lex_state = 41},
  [4501] = {.lex_state = 61, .external_lex_state = 15},
  [4502] = {.lex_state = 61, .external_lex_state = 15},
  [4503] = {.lex_state = 61, .external_lex_state = 15},
  [4504] = {.lex_state = 61, .external_lex_state = 15},
  [4505] = {.lex_state = 60, .external_lex_state = 19},
  [4506] = {.lex_state = 61, .external_lex_state = 15},
  [4507] = {.lex_state = 61, .external_lex_state = 148},
  [4508] = {.lex_state = 61, .external_lex_state = 15},
  [4509] = {.lex_state = 61, .external_lex_state = 8},
  [4510] = {.lex_state = 61, .external_lex_state = 15},
  [4511] = {.lex_state = 61, .external_lex_state = 15},
  [4512] = {.lex_state = 56, .external_lex_state = 41},
  [4513] = {.lex_state = 61, .external_lex_state = 8},
  [4514] = {.lex_state = 61, .external_lex_state = 12},
  [4515] = {.lex_state = 61, .external_lex_state = 149},
  [4516] = {.lex_state = 61, .external_lex_state = 15},
  [4517] = {.lex_state = 56, .external_lex_state = 41},
  [4518] = {.lex_state = 61, .external_lex_state = 15},
  [4519] = {.lex_state = 60, .external_lex_state = 19},
  [4520] = {.lex_state = 61, .external_lex_state = 12},
  [4521] = {.lex_state = 56, .external_lex_state = 41},
  [4522] = {.lex_state = 61, .external_lex_state = 15},
  [4523] = {.lex_state = 61, .external_lex_state = 15},
  [4524] = {.lex_state = 61, .external_lex_state = 15},
  [4525] = {.lex_state = 61, .external_lex_state = 15},
  [4526] = {.lex_state = 61, .external_lex_state = 15},
  [4527] = {.lex_state = 55, .external_lex_state = 8},
  [4528] = {.lex_state = 61, .external_lex_state = 12},
  [4529] = {.lex_state = 56, .external_lex_state = 150},
  [4530] = {.lex_state = 61, .external_lex_state = 15},
  [4531] = {.lex_state = 61, .external_lex_state = 15},
  [4532] = {.lex_state = 61, .external_lex_state = 15},
  [4533] = {.lex_state = 61, .external_lex_state = 15},
  [4534] = {.lex_state = 56, .external_lex_state = 41},
  [4535] = {.lex_state = 61, .external_lex_state = 15},
  [4536] = {.lex_state = 61, .external_lex_state = 15},
  [4537] = {.lex_state = 55, .external_lex_state = 8},
  [4538] = {.lex_state = 56, .external_lex_state = 150},
  [4539] = {.lex_state = 56, .external_lex_state = 41},
  [4540] = {.lex_state = 61, .external_lex_state = 148},
  [4541] = {.lex_state = 61, .external_lex_state = 15},
  [4542] = {.lex_state = 61, .external_lex_state = 15},
  [4543] = {.lex_state = 56, .external_lex_state = 150},
  [4544] = {.lex_state = 61, .external_lex_state = 151},
  [4545] = {.lex_state = 61, .external_lex_state = 15},
  [4546] = {.lex_state = 61, .external_lex_state = 151},
  [4547] = {.lex_state = 61, .external_lex_state = 15},
  [4548] = {.lex_state = 56, .external_lex_state = 41},
  [4549] = {.lex_state = 61, .external_lex_state = 152},
  [4550] = {.lex_state = 61, .external_lex_state = 15},
  [4551] = {.lex_state = 61, .external_lex_state = 12},
  [4552] = {.lex_state = 56, .external_lex_state = 41},
  [4553] = {.lex_state = 56, .external_lex_state = 41},
  [4554] = {.lex_state = 56, .external_lex_state = 41},
  [4555] = {.lex_state = 56, .external_lex_state = 41},
  [4556] = {.lex_state = 55, .external_lex_state = 8},
  [4557] = {.lex_state = 61, .external_lex_state = 153},
  [4558] = {.lex_state = 61, .external_lex_state = 15},
  [4559] = {.lex_state = 56, .external_lex_state = 41},
  [4560] = {.lex_state = 55, .external_lex_state = 8},
  [4561] = {.lex_state = 61, .external_lex_state = 12},
  [4562] = {.lex_state = 61, .external_lex_state = 15},
  [4563] = {.lex_state = 55, .external_lex_state = 154},
  [4564] = {.lex_state = 61, .external_lex_state = 153},
  [4565] = {.lex_state = 55, .external_lex_state = 155},
  [4566] = {.lex_state = 61, .external_lex_state = 15},
  [4567] = {.lex_state = 61, .external_lex_state = 15},
  [4568] = {.lex_state = 55, .external_lex_state = 8},
  [4569] = {.lex_state = 56, .external_lex_state = 41},
  [4570] = {.lex_state = 61, .external_lex_state = 8},
  [4571] = {.lex_state = 61, .external_lex_state = 148},
  [4572] = {.lex_state = 61, .external_lex_state = 156},
  [4573] = {.lex_state = 61, .external_lex_state = 137},
  [4574] = {.lex_state = 61, .external_lex_state = 15},
  [4575] = {.lex_state = 61, .external_lex_state = 12},
  [4576] = {.lex_state = 55, .external_lex_state = 8},
  [4577] = {.lex_state = 61, .external_lex_state = 157},
  [4578] = {.lex_state = 55, .external_lex_state = 3},
  [4579] = {.lex_state = 56, .external_lex_state = 41},
  [4580] = {.lex_state = 61, .external_lex_state = 151},
  [4581] = {.lex_state = 61, .external_lex_state = 151},
  [4582] = {.lex_state = 61, .external_lex_state = 15},
  [4583] = {.lex_state = 61, .external_lex_state = 15},
  [4584] = {.lex_state = 56, .external_lex_state = 41},
  [4585] = {.lex_state = 61, .external_lex_state = 15},
  [4586] = {.lex_state = 56, .external_lex_state = 41},
  [4587] = {.lex_state = 61, .external_lex_state = 15},
  [4588] = {.lex_state = 61, .external_lex_state = 157},
  [4589] = {.lex_state = 61, .external_lex_state = 158},
  [4590] = {.lex_state = 61, .external_lex_state = 12},
  [4591] = {.lex_state = 61, .external_lex_state = 148},
  [4592] = {.lex_state = 61, .external_lex_state = 153},
  [4593] = {.lex_state = 61, .external_lex_state = 15},
  [4594] = {.lex_state = 61, .external_lex_state = 15},
  [4595] = {.lex_state = 61, .external_lex_state = 12},
  [4596] = {.lex_state = 61, .external_lex_state = 12},
  [4597] = {.lex_state = 61, .external_lex_state = 15},
  [4598] = {.lex_state = 61, .external_lex_state = 15},
  [4599] = {.lex_state = 61, .external_lex_state = 151},
  [4600] = {.lex_state = 61, .external_lex_state = 156},
  [4601] = {.lex_state = 56, .external_lex_state = 41},
  [4602] = {.lex_state = 61, .external_lex_state = 158},
  [4603] = {.lex_state = 61, .external_lex_state = 151},
  [4604] = {.lex_state = 61, .external_lex_state = 15},
  [4605] = {.lex_state = 61, .external_lex_state = 152},
  [4606] = {.lex_state = 61, .external_lex_state = 15},
  [4607] = {.lex_state = 56, .external_lex_state = 41},
  [4608] = {.lex_state = 61, .external_lex_state = 158},
  [4609] = {.lex_state = 56, .external_lex_state = 41},
  [4610] = {.lex_state = 61, .external_lex_state = 15},
  [4611] = {.lex_state = 56, .external_lex_state = 41},
  [4612] = {.lex_state = 61, .external_lex_state = 12},
  [4613] = {.lex_state = 61, .external_lex_state = 15},
  [4614] = {.lex_state = 61, .external_lex_state = 15},
  [4615] = {.lex_state = 55, .external_lex_state = 8},
  [4616] = {.lex_state = 55, .external_lex_state = 8},
  [4617] = {.lex_state = 55, .external_lex_state = 8},
  [4618] = {.lex_state = 61, .external_lex_state = 15},
  [4619] = {.lex_state = 61, .external_lex_state = 12},
  [4620] = {.lex_state = 61, .external_lex_state = 12},
  [4621] = {.lex_state = 61, .external_lex_state = 153},
  [4622] = {.lex_state = 61, .external_lex_state = 15},
  [4623] = {.lex_state = 61, .external_lex_state = 152},
  [4624] = {.lex_state = 55, .external_lex_state = 159},
  [4625] = {.lex_state = 55, .external_lex_state = 8},
  [4626] = {.lex_state = 61, .external_lex_state = 15},
  [4627] = {.lex_state = 56, .external_lex_state = 41},
  [4628] = {.lex_state = 61, .external_lex_state = 15},
  [4629] = {.lex_state = 56, .external_lex_state = 150},
  [4630] = {.lex_state = 55, .external_lex_state = 8},
  [4631] = {.lex_state = 55, .external_lex_state = 8},
  [4632] = {.lex_state = 61, .external_lex_state = 149},
  [4633] = {.lex_state = 56, .external_lex_state = 150},
  [4634] = {.lex_state = 61, .external_lex_state = 157},
  [4635] = {.lex_state = 61, .external_lex_state = 15},
  [4636] = {.lex_state = 55, .external_lex_state = 8},
  [4637] = {.lex_state = 61, .external_lex_state = 156},
  [4638] = {.lex_state = 55, .external_lex_state = 8},
  [4639] = {.lex_state = 61, .external_lex_state = 15},
  [4640] = {.lex_state = 61, .external_lex_state = 149},
  [4641] = {.lex_state = 61, .external_lex_state = 158},
  [4642] = {.lex_state = 61, .external_lex_state = 15},
  [4643] = {.lex_state = 61, .external_lex_state = 156},
  [4644] = {.lex_state = 61, .external_lex_state = 157},
  [4645] = {.lex_state = 61, .external_lex_state = 15},
  [4646] = {.lex_state = 61, .external_lex_state = 15},
  [4647] = {.lex_state = 61, .external_lex_state = 15},
  [4648] = {.lex_state = 56, .external_lex_state = 150},
  [4649] = {.lex_state = 61, .external_lex_state = 153},
  [4650] = {.lex_state = 56, .external_lex_state = 41},
  [4651] = {.lex_state = 61, .external_lex_state = 149},
  [4652] = {.lex_state = 61, .external_lex_state = 153},
  [4653] = {.lex_state = 61, .external_lex_state = 15},
  [4654] = {.lex_state = 61, .external_lex_state = 139},
  [4655] = {.lex_state = 61, .external_lex_state = 15},
  [4656] = {.lex_state = 61, .external_lex_state = 149},
  [4657] = {.lex_state = 60, .external_lex_state = 32},
  [4658] = {.lex_state = 61, .external_lex_state = 148},
  [4659] = {.lex_state = 61, .external_lex_state = 15},
  [4660] = {.lex_state = 56, .external_lex_state = 41},
  [4661] = {.lex_state = 61, .external_lex_state = 15},
  [4662] = {.lex_state = 60, .external_lex_state = 19},
  [4663] = {.lex_state = 56, .external_lex_state = 41},
  [4664] = {.lex_state = 55, .external_lex_state = 8},
  [4665] = {.lex_state = 61, .external_lex_state = 8},
  [4666] = {.lex_state = 61, .external_lex_state = 15},
  [4667] = {.lex_state = 60, .external_lex_state = 32},
  [4668] = {.lex_state = 61, .external_lex_state = 15},
  [4669] = {.lex_state = 61, .external_lex_state = 15},
  [4670] = {.lex_state = 61, .external_lex_state = 12},
  [4671] = {.lex_state = 61, .external_lex_state = 12},
  [4672] = {.lex_state = 61, .external_lex_state = 149},
  [4673] = {.lex_state = 61, .external_lex_state = 12},
  [4674] = {.lex_state = 56, .external_lex_state = 41},
  [4675] = {.lex_state = 61, .external_lex_state = 12},
  [4676] = {.lex_state = 61, .external_lex_state = 158},
  [4677] = {.lex_state = 56, .external_lex_state = 41},
  [4678] = {.lex_state = 61, .external_lex_state = 152},
  [4679] = {.lex_state = 61, .external_lex_state = 157},
  [4680] = {.lex_state = 55, .external_lex_state = 160},
  [4681] = {.lex_state = 61, .external_lex_state = 12},
  [4682] = {.lex_state = 61, .external_lex_state = 12},
  [4683] = {.lex_state = 56, .external_lex_state = 41},
  [4684] = {.lex_state = 61, .external_lex_state = 15},
  [4685] = {.lex_state = 56, .external_lex_state = 41},
  [4686] = {.lex_state = 61, .external_lex_state = 12},
  [4687] = {.lex_state = 55, .external_lex_state = 8},
  [4688] = {.lex_state = 61, .external_lex_state = 156},
  [4689] = {.lex_state = 55, .external_lex_state = 8},
  [4690] = {.lex_state = 61, .external_lex_state = 157},
  [4691] = {.lex_state = 56, .external_lex_state = 41},
  [4692] = {.lex_state = 56, .external_lex_state = 41},
  [4693] = {.lex_state = 61, .external_lex_state = 15},
  [4694] = {.lex_state = 61, .external_lex_state = 148},
  [4695] = {.lex_state = 61, .external_lex_state = 156},
  [4696] = {.lex_state = 55, .external_lex_state = 8},
  [4697] = {.lex_state = 61, .external_lex_state = 15},
  [4698] = {.lex_state = 55, .external_lex_state = 8},
  [4699] = {.lex_state = 55, .external_lex_state = 161},
  [4700] = {.lex_state = 61, .external_lex_state = 152},
  [4701] = {.lex_state = 56, .external_lex_state = 41},
  [4702] = {.lex_state = 56, .external_lex_state = 41},
  [4703] = {.lex_state = 61, .external_lex_state = 158},
  [4704] = {.lex_state = 56, .external_lex_state = 41},
  [4705] = {.lex_state = 61, .external_lex_state = 152},
  [4706] = {.lex_state = 56, .external_lex_state = 41},
  [4707] = {.lex_state = 56, .external_lex_state = 41},
  [4708] = {.lex_state = 55, .external_lex_state = 15},
  [4709] = {.lex_state = 61, .external_lex_state = 19},
  [4710] = {.lex_state = 61, .external_lex_state = 22},
  [4711] = {.lex_state = 61, .external_lex_state = 19},
  [4712] = {.lex_state = 61, .external_lex_state = 23},
  [4713] = {.lex_state = 61, .external_lex_state = 23},
  [4714] = {.lex_state = 61, .external_lex_state = 23},
  [4715] = {.lex_state = 61, .external_lex_state = 16},
  [4716] = {.lex_state = 61, .external_lex_state = 23},
  [4717] = {.lex_state = 61, .external_lex_state = 23},
  [4718] = {.lex_state = 61, .external_lex_state = 23},
  [4719] = {.lex_state = 61, .external_lex_state = 23},
  [4720] = {.lex_state = 60, .external_lex_state = 25},
  [4721] = {.lex_state = 61, .external_lex_state = 23},
  [4722] = {.lex_state = 61, .external_lex_state = 19},
  [4723] = {.lex_state = 61, .external_lex_state = 16},
  [4724] = {.lex_state = 61, .external_lex_state = 22},
  [4725] = {.lex_state = 61, .external_lex_state = 162},
  [4726] = {.lex_state = 61, .external_lex_state = 17},
  [4727] = {.lex_state = 61, .external_lex_state = 16},
  [4728] = {.lex_state = 61, .external_lex_state = 19},
  [4729] = {.lex_state = 61, .external_lex_state = 16},
  [4730] = {.lex_state = 61, .external_lex_state = 16},
  [4731] = {.lex_state = 61, .external_lex_state = 22},
  [4732] = {.lex_state = 61, .external_lex_state = 16},
  [4733] = {.lex_state = 55, .external_lex_state = 163},
  [4734] = {.lex_state = 61, .external_lex_state = 19},
  [4735] = {.lex_state = 61, .external_lex_state = 16},
  [4736] = {.lex_state = 61, .external_lex_state = 19},
  [4737] = {.lex_state = 61, .external_lex_state = 23},
  [4738] = {.lex_state = 61, .external_lex_state = 162},
  [4739] = {.lex_state = 61, .external_lex_state = 16},
  [4740] = {.lex_state = 61, .external_lex_state = 16},
  [4741] = {.lex_state = 61, .external_lex_state = 16},
  [4742] = {.lex_state = 61, .external_lex_state = 23},
  [4743] = {.lex_state = 61, .external_lex_state = 16},
  [4744] = {.lex_state = 61, .external_lex_state = 16},
  [4745] = {.lex_state = 61, .external_lex_state = 16},
  [4746] = {.lex_state = 61, .external_lex_state = 16},
  [4747] = {.lex_state = 61, .external_lex_state = 16},
  [4748] = {.lex_state = 61, .external_lex_state = 16},
  [4749] = {.lex_state = 61, .external_lex_state = 22},
  [4750] = {.lex_state = 61, .external_lex_state = 16},
  [4751] = {.lex_state = 61, .external_lex_state = 32},
  [4752] = {.lex_state = 61, .external_lex_state = 16},
  [4753] = {.lex_state = 61, .external_lex_state = 20},
  [4754] = {.lex_state = 61, .external_lex_state = 22},
  [4755] = {.lex_state = 60, .external_lex_state = 34},
  [4756] = {.lex_state = 61, .external_lex_state = 18},
  [4757] = {.lex_state = 61, .external_lex_state = 22},
  [4758] = {.lex_state = 61, .external_lex_state = 16},
  [4759] = {.lex_state = 61, .external_lex_state = 19},
  [4760] = {.lex_state = 61, .external_lex_state = 22},
  [4761] = {.lex_state = 61, .external_lex_state = 16},
  [4762] = {.lex_state = 61, .external_lex_state = 164},
  [4763] = {.lex_state = 61, .external_lex_state = 22},
  [4764] = {.lex_state = 61, .external_lex_state = 18},
  [4765] = {.lex_state = 61, .external_lex_state = 16},
  [4766] = {.lex_state = 61, .external_lex_state = 16},
  [4767] = {.lex_state = 61, .external_lex_state = 16},
  [4768] = {.lex_state = 61, .external_lex_state = 18},
  [4769] = {.lex_state = 61, .external_lex_state = 16},
  [4770] = {.lex_state = 61, .external_lex_state = 16},
  [4771] = {.lex_state = 61, .external_lex_state = 16},
  [4772] = {.lex_state = 61, .external_lex_state = 18},
  [4773] = {.lex_state = 61, .external_lex_state = 16},
  [4774] = {.lex_state = 61, .external_lex_state = 16},
  [4775] = {.lex_state = 61, .external_lex_state = 16},
  [4776] = {.lex_state = 61, .external_lex_state = 165},
  [4777] = {.lex_state = 61, .external_lex_state = 32},
  [4778] = {.lex_state = 61, .external_lex_state = 16},
  [4779] = {.lex_state = 61, .external_lex_state = 32},
  [4780] = {.lex_state = 61, .external_lex_state = 162},
  [4781] = {.lex_state = 61, .external_lex_state = 166},
  [4782] = {.lex_state = 61, .external_lex_state = 162},
  [4783] = {.lex_state = 61, .external_lex_state = 22},
  [4784] = {.lex_state = 61, .external_lex_state = 166},
  [4785] = {.lex_state = 61, .external_lex_state = 19},
  [4786] = {.lex_state = 61, .external_lex_state = 167},
  [4787] = {.lex_state = 61, .external_lex_state = 18},
  [4788] = {.lex_state = 61, .external_lex_state = 165},
  [4789] = {.lex_state = 61, .external_lex_state = 23},
  [4790] = {.lex_state = 61, .external_lex_state = 162},
  [4791] = {.lex_state = 61, .external_lex_state = 168},
  [4792] = {.lex_state = 61, .external_lex_state = 19},
  [4793] = {.lex_state = 55, .external_lex_state = 15},
  [4794] = {.lex_state = 55, .external_lex_state = 8},
  [4795] = {.lex_state = 61, .external_lex_state = 19},
  [4796] = {.lex_state = 61, .external_lex_state = 19},
  [4797] = {.lex_state = 55, .external_lex_state = 15},
  [4798] = {.lex_state = 55, .external_lex_state = 15},
  [4799] = {.lex_state = 61, .external_lex_state = 19},
  [4800] = {.lex_state = 61, .external_lex_state = 19},
  [4801] = {.lex_state = 61, .external_lex_state = 19},
  [4802] = {.lex_state = 61, .external_lex_state = 19},
  [4803] = {.lex_state = 56, .external_lex_state = 42},
  [4804] = {.lex_state = 56, .external_lex_state = 42},
  [4805] = {.lex_state = 55, .external_lex_state = 15},
  [4806] = {.lex_state = 61, .external_lex_state = 17},
  [4807] = {.lex_state = 56, .external_lex_state = 42},
  [4808] = {.lex_state = 55, .external_lex_state = 15},
  [4809] = {.lex_state = 56, .external_lex_state = 42},
  [4810] = {.lex_state = 56, .external_lex_state = 42},
  [4811] = {.lex_state = 61, .external_lex_state = 19},
  [4812] = {.lex_state = 61, .external_lex_state = 19},
  [4813] = {.lex_state = 56, .external_lex_state = 42},
  [4814] = {.lex_state = 56, .external_lex_state = 42},
  [4815] = {.lex_state = 55, .external_lex_state = 15},
  [4816] = {.lex_state = 56, .external_lex_state = 42},
  [4817] = {.lex_state = 56, .external_lex_state = 42},
  [4818] = {.lex_state = 56, .external_lex_state = 42},
  [4819] = {.lex_state = 56, .external_lex_state = 42},
  [4820] = {.lex_state = 61, .external_lex_state = 23},
  [4821] = {.lex_state = 61, .external_lex_state = 19},
  [4822] = {.lex_state = 55, .external_lex_state = 15},
  [4823] = {.lex_state = 61, .external_lex_state = 19},
  [4824] = {.lex_state = 61, .external_lex_state = 23},
  [4825] = {.lex_state = 61, .external_lex_state = 19},
  [4826] = {.lex_state = 61, .external_lex_state = 23},
  [4827] = {.lex_state = 56, .external_lex_state = 42},
  [4828] = {.lex_state = 55, .external_lex_state = 15},
  [4829] = {.lex_state = 56, .external_lex_state = 42},
  [4830] = {.lex_state = 55, .external_lex_state = 15},
  [4831] = {.lex_state = 61, .external_lex_state = 167},
  [4832] = {.lex_state = 56, .external_lex_state = 42},
  [4833] = {.lex_state = 55, .external_lex_state = 15},
  [4834] = {.lex_state = 56, .external_lex_state = 42},
  [4835] = {.lex_state = 56, .external_lex_state = 42},
  [4836] = {.lex_state = 55, .external_lex_state = 15},
  [4837] = {.lex_state = 61, .external_lex_state = 19},
  [4838] = {.lex_state = 55, .external_lex_state = 15},
  [4839] = {.lex_state = 55, .external_lex_state = 15},
  [4840] = {.lex_state = 61, .external_lex_state = 23},
  [4841] = {.lex_state = 56, .external_lex_state = 42},
  [4842] = {.lex_state = 61, .external_lex_state = 23},
  [4843] = {.lex_state = 61, .external_lex_state = 23},
  [4844] = {.lex_state = 61, .external_lex_state = 19},
  [4845] = {.lex_state = 55, .external_lex_state = 15},
  [4846] = {.lex_state = 55, .external_lex_state = 15},
  [4847] = {.lex_state = 55, .external_lex_state = 15},
  [4848] = {.lex_state = 61, .external_lex_state = 23},
  [4849] = {.lex_state = 55, .external_lex_state = 15},
  [4850] = {.lex_state = 61, .external_lex_state = 23},
  [4851] = {.lex_state = 61, .external_lex_state = 23},
  [4852] = {.lex_state = 61, .external_lex_state = 23},
  [4853] = {.lex_state = 61, .external_lex_state = 23},
  [4854] = {.lex_state = 61, .external_lex_state = 23},
  [4855] = {.lex_state = 61, .external_lex_state = 23},
  [4856] = {.lex_state = 61, .external_lex_state = 23},
  [4857] = {.lex_state = 61, .external_lex_state = 23},
  [4858] = {.lex_state = 61, .external_lex_state = 22},
  [4859] = {.lex_state = 61, .external_lex_state = 18},
  [4860] = {.lex_state = 61, .external_lex_state = 32},
  [4861] = {.lex_state = 61, .external_lex_state = 22},
  [4862] = {.lex_state = 61, .external_lex_state = 23},
  [4863] = {.lex_state = 61, .external_lex_state = 16},
  [4864] = {.lex_state = 61, .external_lex_state = 23},
  [4865] = {.lex_state = 61, .external_lex_state = 19},
  [4866] = {.lex_state = 55, .external_lex_state = 169},
  [4867] = {.lex_state = 61, .external_lex_state = 23},
  [4868] = {.lex_state = 61, .external_lex_state = 23},
  [4869] = {.lex_state = 61, .external_lex_state = 22},
  [4870] = {.lex_state = 61, .external_lex_state = 19},
  [4871] = {.lex_state = 61, .external_lex_state = 23},
  [4872] = {.lex_state = 61, .external_lex_state = 23},
  [4873] = {.lex_state = 60, .external_lex_state = 8},
  [4874] = {.lex_state = 61, .external_lex_state = 170},
  [4875] = {.lex_state = 61, .external_lex_state = 23},
  [4876] = {.lex_state = 61, .external_lex_state = 23},
  [4877] = {.lex_state = 61, .external_lex_state = 32},
  [4878] = {.lex_state = 61, .external_lex_state = 32},
  [4879] = {.lex_state = 61, .external_lex_state = 170},
  [4880] = {.lex_state = 61, .external_lex_state = 162},
  [4881] = {.lex_state = 61, .external_lex_state = 23},
  [4882] = {.lex_state = 55, .external_lex_state = 171},
  [4883] = {.lex_state = 61, .external_lex_state = 19},
  [4884] = {.lex_state = 61, .external_lex_state = 22},
  [4885] = {.lex_state = 61, .external_lex_state = 18},
  [4886] = {.lex_state = 61, .external_lex_state = 19},
  [4887] = {.lex_state = 61, .external_lex_state = 19},
  [4888] = {.lex_state = 61, .external_lex_state = 18},
  [4889] = {.lex_state = 61, .external_lex_state = 18},
  [4890] = {.lex_state = 61, .external_lex_state = 18},
  [4891] = {.lex_state = 61, .external_lex_state = 18},
  [4892] = {.lex_state = 61, .external_lex_state = 18},
  [4893] = {.lex_state = 61, .external_lex_state = 18},
  [4894] = {.lex_state = 61, .external_lex_state = 18},
  [4895] = {.lex_state = 61, .external_lex_state = 18},
  [4896] = {.lex_state = 61, .external_lex_state = 18},
  [4897] = {.lex_state = 61, .external_lex_state = 18},
  [4898] = {.lex_state = 61, .external_lex_state = 172},
  [4899] = {.lex_state = 61, .external_lex_state = 172},
  [4900] = {.lex_state = 61, .external_lex_state = 22},
  [4901] = {.lex_state = 61, .external_lex_state = 22},
  [4902] = {.lex_state = 61, .external_lex_state = 23},
  [4903] = {.lex_state = 61, .external_lex_state = 22},
  [4904] = {.lex_state = 61, .external_lex_state = 23},
  [4905] = {.lex_state = 56, .external_lex_state = 42},
  [4906] = {.lex_state = 61, .external_lex_state = 19},
  [4907] = {.lex_state = 56, .external_lex_state = 42},
  [4908] = {.lex_state = 56, .external_lex_state = 42},
  [4909] = {.lex_state = 56, .external_lex_state = 42},
  [4910] = {.lex_state = 56, .external_lex_state = 42},
  [4911] = {.lex_state = 61, .external_lex_state = 22},
  [4912] = {.lex_state = 56, .external_lex_state = 42},
  [4913] = {.lex_state = 56, .external_lex_state = 42},
  [4914] = {.lex_state = 56, .external_lex_state = 42},
  [4915] = {.lex_state = 61, .external_lex_state = 19},
  [4916] = {.lex_state = 56, .external_lex_state = 42},
  [4917] = {.lex_state = 61, .external_lex_state = 22},
  [4918] = {.lex_state = 61, .external_lex_state = 20},
  [4919] = {.lex_state = 61, .external_lex_state = 20},
  [4920] = {.lex_state = 61, .external_lex_state = 20},
  [4921] = {.lex_state = 61, .external_lex_state = 22},
  [4922] = {.lex_state = 61, .external_lex_state = 19},
  [4923] = {.lex_state = 61, .external_lex_state = 170},
  [4924] = {.lex_state = 61, .external_lex_state = 22},
  [4925] = {.lex_state = 61, .external_lex_state = 170},
  [4926] = {.lex_state = 61, .external_lex_state = 32},
  [4927] = {.lex_state = 61, .external_lex_state = 165},
  [4928] = {.lex_state = 55, .external_lex_state = 173},
  [4929] = {.lex_state = 61, .external_lex_state = 22},
  [4930] = {.lex_state = 61, .external_lex_state = 165},
  [4931] = {.lex_state = 61, .external_lex_state = 19},
  [4932] = {.lex_state = 61, .external_lex_state = 22},
  [4933] = {.lex_state = 61, .external_lex_state = 166},
  [4934] = {.lex_state = 61, .external_lex_state = 16},
  [4935] = {.lex_state = 61, .external_lex_state = 16},
  [4936] = {.lex_state = 61, .external_lex_state = 22},
  [4937] = {.lex_state = 61, .external_lex_state = 166},
  [4938] = {.lex_state = 61, .external_lex_state = 16},
  [4939] = {.lex_state = 61, .external_lex_state = 17},
  [4940] = {.lex_state = 61, .external_lex_state = 17},
  [4941] = {.lex_state = 61, .external_lex_state = 17},
  [4942] = {.lex_state = 61, .external_lex_state = 17},
  [4943] = {.lex_state = 61, .external_lex_state = 17},
  [4944] = {.lex_state = 61, .external_lex_state = 20},
  [4945] = {.lex_state = 61, .external_lex_state = 18},
  [4946] = {.lex_state = 61, .external_lex_state = 17},
  [4947] = {.lex_state = 61, .external_lex_state = 17},
  [4948] = {.lex_state = 61, .external_lex_state = 19},
  [4949] = {.lex_state = 61, .external_lex_state = 18},
  [4950] = {.lex_state = 61, .external_lex_state = 18},
  [4951] = {.lex_state = 61, .external_lex_state = 20},
  [4952] = {.lex_state = 61, .external_lex_state = 17},
  [4953] = {.lex_state = 61, .external_lex_state = 17},
  [4954] = {.lex_state = 61, .external_lex_state = 17},
  [4955] = {.lex_state = 61, .external_lex_state = 18},
  [4956] = {.lex_state = 61, .external_lex_state = 17},
  [4957] = {.lex_state = 61, .external_lex_state = 17},
  [4958] = {.lex_state = 61, .external_lex_state = 17},
  [4959] = {.lex_state = 61, .external_lex_state = 18},
  [4960] = {.lex_state = 61, .external_lex_state = 22},
  [4961] = {.lex_state = 61, .external_lex_state = 18},
  [4962] = {.lex_state = 61, .external_lex_state = 18},
  [4963] = {.lex_state = 61, .external_lex_state = 18},
  [4964] = {.lex_state = 61, .external_lex_state = 18},
  [4965] = {.lex_state = 61, .external_lex_state = 18},
  [4966] = {.lex_state = 61, .external_lex_state = 22},
  [4967] = {.lex_state = 61, .external_lex_state = 18},
  [4968] = {.lex_state = 61, .external_lex_state = 18},
  [4969] = {.lex_state = 61, .external_lex_state = 17},
  [4970] = {.lex_state = 61, .external_lex_state = 32},
  [4971] = {.lex_state = 61, .external_lex_state = 32},
  [4972] = {.lex_state = 61, .external_lex_state = 32},
  [4973] = {.lex_state = 61, .external_lex_state = 17},
  [4974] = {.lex_state = 61, .external_lex_state = 17},
  [4975] = {.lex_state = 61, .external_lex_state = 17},
  [4976] = {.lex_state = 61, .external_lex_state = 17},
  [4977] = {.lex_state = 61, .external_lex_state = 17},
  [4978] = {.lex_state = 61, .external_lex_state = 17},
  [4979] = {.lex_state = 61, .external_lex_state = 170},
  [4980] = {.lex_state = 61, .external_lex_state = 17},
  [4981] = {.lex_state = 61, .external_lex_state = 17},
  [4982] = {.lex_state = 61, .external_lex_state = 17},
  [4983] = {.lex_state = 61, .external_lex_state = 17},
  [4984] = {.lex_state = 61, .external_lex_state = 17},
  [4985] = {.lex_state = 56, .external_lex_state = 42},
  [4986] = {.lex_state = 61, .external_lex_state = 17},
  [4987] = {.lex_state = 61, .external_lex_state = 17},
  [4988] = {.lex_state = 61, .external_lex_state = 22},
  [4989] = {.lex_state = 61, .external_lex_state = 19},
  [4990] = {.lex_state = 61, .external_lex_state = 17},
  [4991] = {.lex_state = 61, .external_lex_state = 18},
  [4992] = {.lex_state = 61, .external_lex_state = 164},
  [4993] = {.lex_state = 56, .external_lex_state = 42},
  [4994] = {.lex_state = 56, .external_lex_state = 42},
  [4995] = {.lex_state = 61, .external_lex_state = 32},
  [4996] = {.lex_state = 61, .external_lex_state = 32},
  [4997] = {.lex_state = 61, .external_lex_state = 18},
  [4998] = {.lex_state = 61, .external_lex_state = 17},
  [4999] = {.lex_state = 61, .external_lex_state = 19},
  [5000] = {.lex_state = 61, .external_lex_state = 18},
  [5001] = {.lex_state = 61, .external_lex_state = 18},
  [5002] = {.lex_state = 61, .external_lex_state = 17},
  [5003] = {.lex_state = 60, .external_lex_state = 10},
  [5004] = {.lex_state = 61, .external_lex_state = 18},
  [5005] = {.lex_state = 61, .external_lex_state = 32},
  [5006] = {.lex_state = 61, .external_lex_state = 32},
  [5007] = {.lex_state = 61, .external_lex_state = 17},
  [5008] = {.lex_state = 61, .external_lex_state = 32},
  [5009] = {.lex_state = 61, .external_lex_state = 17},
  [5010] = {.lex_state = 61, .external_lex_state = 20},
  [5011] = {.lex_state = 61, .external_lex_state = 22},
  [5012] = {.lex_state = 61, .external_lex_state = 17},
  [5013] = {.lex_state = 61, .external_lex_state = 20},
  [5014] = {.lex_state = 56, .external_lex_state = 42},
  [5015] = {.lex_state = 61, .external_lex_state = 20},
  [5016] = {.lex_state = 61, .external_lex_state = 17},
  [5017] = {.lex_state = 61, .external_lex_state = 167},
  [5018] = {.lex_state = 61, .external_lex_state = 32},
  [5019] = {.lex_state = 61, .external_lex_state = 32},
  [5020] = {.lex_state = 61, .external_lex_state = 172},
  [5021] = {.lex_state = 61, .external_lex_state = 20},
  [5022] = {.lex_state = 56, .external_lex_state = 42},
  [5023] = {.lex_state = 61, .external_lex_state = 16},
  [5024] = {.lex_state = 61, .external_lex_state = 16},
  [5025] = {.lex_state = 61, .external_lex_state = 32},
  [5026] = {.lex_state = 61, .external_lex_state = 16},
  [5027] = {.lex_state = 61, .external_lex_state = 16},
  [5028] = {.lex_state = 61, .external_lex_state = 16},
  [5029] = {.lex_state = 61, .external_lex_state = 19},
  [5030] = {.lex_state = 61, .external_lex_state = 19},
  [5031] = {.lex_state = 61, .external_lex_state = 19},
  [5032] = {.lex_state = 61, .external_lex_state = 16},
  [5033] = {.lex_state = 61, .external_lex_state = 20},
  [5034] = {.lex_state = 61, .external_lex_state = 16},
  [5035] = {.lex_state = 61, .external_lex_state = 32},
  [5036] = {.lex_state = 61, .external_lex_state = 19},
  [5037] = {.lex_state = 61, .external_lex_state = 20},
  [5038] = {.lex_state = 61, .external_lex_state = 172},
  [5039] = {.lex_state = 61, .external_lex_state = 32},
  [5040] = {.lex_state = 61, .external_lex_state = 16},
  [5041] = {.lex_state = 61, .external_lex_state = 19},
  [5042] = {.lex_state = 61, .external_lex_state = 16},
  [5043] = {.lex_state = 61, .external_lex_state = 16},
  [5044] = {.lex_state = 61, .external_lex_state = 19},
  [5045] = {.lex_state = 61, .external_lex_state = 32},
  [5046] = {.lex_state = 61, .external_lex_state = 16},
  [5047] = {.lex_state = 61, .external_lex_state = 32},
  [5048] = {.lex_state = 55, .external_lex_state = 174},
  [5049] = {.lex_state = 61, .external_lex_state = 164},
  [5050] = {.lex_state = 61, .external_lex_state = 22},
  [5051] = {.lex_state = 61, .external_lex_state = 16},
  [5052] = {.lex_state = 61, .external_lex_state = 32},
  [5053] = {.lex_state = 61, .external_lex_state = 87},
  [5054] = {.lex_state = 61, .external_lex_state = 20},
  [5055] = {.lex_state = 61, .external_lex_state = 16},
  [5056] = {.lex_state = 61, .external_lex_state = 20},
  [5057] = {.lex_state = 61, .external_lex_state = 32},
  [5058] = {.lex_state = 60, .external_lex_state = 25},
  [5059] = {.lex_state = 61, .external_lex_state = 32},
  [5060] = {.lex_state = 61, .external_lex_state = 18},
  [5061] = {.lex_state = 61, .external_lex_state = 18},
  [5062] = {.lex_state = 61, .external_lex_state = 19},
  [5063] = {.lex_state = 61, .external_lex_state = 22},
  [5064] = {.lex_state = 61, .external_lex_state = 20},
  [5065] = {.lex_state = 61, .external_lex_state = 19},
  [5066] = {.lex_state = 61, .external_lex_state = 19},
  [5067] = {.lex_state = 61, .external_lex_state = 19},
  [5068] = {.lex_state = 61, .external_lex_state = 22},
  [5069] = {.lex_state = 61, .external_lex_state = 19},
  [5070] = {.lex_state = 61, .external_lex_state = 18},
  [5071] = {.lex_state = 61, .external_lex_state = 164},
  [5072] = {.lex_state = 61, .external_lex_state = 18},
  [5073] = {.lex_state = 61, .external_lex_state = 32},
  [5074] = {.lex_state = 61, .external_lex_state = 20},
  [5075] = {.lex_state = 61, .external_lex_state = 20},
  [5076] = {.lex_state = 61, .external_lex_state = 18},
  [5077] = {.lex_state = 61, .external_lex_state = 18},
  [5078] = {.lex_state = 61, .external_lex_state = 18},
  [5079] = {.lex_state = 61, .external_lex_state = 16},
  [5080] = {.lex_state = 61, .external_lex_state = 18},
  [5081] = {.lex_state = 61, .external_lex_state = 16},
  [5082] = {.lex_state = 61, .external_lex_state = 16},
  [5083] = {.lex_state = 61, .external_lex_state = 18},
  [5084] = {.lex_state = 61, .external_lex_state = 18},
  [5085] = {.lex_state = 61, .external_lex_state = 18},
  [5086] = {.lex_state = 61, .external_lex_state = 18},
  [5087] = {.lex_state = 61, .external_lex_state = 16},
  [5088] = {.lex_state = 61, .external_lex_state = 16},
  [5089] = {.lex_state = 61, .external_lex_state = 16},
  [5090] = {.lex_state = 61, .external_lex_state = 16},
  [5091] = {.lex_state = 61, .external_lex_state = 18},
  [5092] = {.lex_state = 61, .external_lex_state = 18},
  [5093] = {.lex_state = 61, .external_lex_state = 16},
  [5094] = {.lex_state = 61, .external_lex_state = 18},
  [5095] = {.lex_state = 61, .external_lex_state = 16},
  [5096] = {.lex_state = 61, .external_lex_state = 18},
  [5097] = {.lex_state = 61, .external_lex_state = 172},
  [5098] = {.lex_state = 61, .external_lex_state = 16},
  [5099] = {.lex_state = 61, .external_lex_state = 16},
  [5100] = {.lex_state = 61, .external_lex_state = 20},
  [5101] = {.lex_state = 61, .external_lex_state = 20},
  [5102] = {.lex_state = 61, .external_lex_state = 20},
  [5103] = {.lex_state = 61, .external_lex_state = 19},
  [5104] = {.lex_state = 61, .external_lex_state = 20},
  [5105] = {.lex_state = 61, .external_lex_state = 19},
  [5106] = {.lex_state = 61, .external_lex_state = 19},
  [5107] = {.lex_state = 61, .external_lex_state = 19},
  [5108] = {.lex_state = 61, .external_lex_state = 19},
  [5109] = {.lex_state = 61, .external_lex_state = 22},
  [5110] = {.lex_state = 61, .external_lex_state = 20},
  [5111] = {.lex_state = 61, .external_lex_state = 18},
  [5112] = {.lex_state = 61, .external_lex_state = 20},
  [5113] = {.lex_state = 61, .external_lex_state = 18},
  [5114] = {.lex_state = 61, .external_lex_state = 18},
  [5115] = {.lex_state = 61, .external_lex_state = 20},
  [5116] = {.lex_state = 61, .external_lex_state = 16},
  [5117] = {.lex_state = 61, .external_lex_state = 170},
  [5118] = {.lex_state = 61, .external_lex_state = 16},
  [5119] = {.lex_state = 61, .external_lex_state = 18},
  [5120] = {.lex_state = 61, .external_lex_state = 18},
  [5121] = {.lex_state = 61, .external_lex_state = 17},
  [5122] = {.lex_state = 61, .external_lex_state = 17},
  [5123] = {.lex_state = 61, .external_lex_state = 17},
  [5124] = {.lex_state = 61, .external_lex_state = 32},
  [5125] = {.lex_state = 61, .external_lex_state = 17},
  [5126] = {.lex_state = 61, .external_lex_state = 17},
  [5127] = {.lex_state = 61, .external_lex_state = 17},
  [5128] = {.lex_state = 61, .external_lex_state = 19},
  [5129] = {.lex_state = 61, .external_lex_state = 17},
  [5130] = {.lex_state = 61, .external_lex_state = 19},
  [5131] = {.lex_state = 61, .external_lex_state = 18},
  [5132] = {.lex_state = 61, .external_lex_state = 19},
  [5133] = {.lex_state = 61, .external_lex_state = 17},
  [5134] = {.lex_state = 61, .external_lex_state = 17},
  [5135] = {.lex_state = 61, .external_lex_state = 18},
  [5136] = {.lex_state = 61, .external_lex_state = 18},
  [5137] = {.lex_state = 61, .external_lex_state = 23},
  [5138] = {.lex_state = 61, .external_lex_state = 18},
  [5139] = {.lex_state = 61, .external_lex_state = 19},
  [5140] = {.lex_state = 61, .external_lex_state = 16},
  [5141] = {.lex_state = 61, .external_lex_state = 17},
  [5142] = {.lex_state = 61, .external_lex_state = 18},
  [5143] = {.lex_state = 61, .external_lex_state = 18},
  [5144] = {.lex_state = 61, .external_lex_state = 19},
  [5145] = {.lex_state = 61, .external_lex_state = 18},
  [5146] = {.lex_state = 61, .external_lex_state = 18},
  [5147] = {.lex_state = 61, .external_lex_state = 17},
  [5148] = {.lex_state = 61, .external_lex_state = 18},
  [5149] = {.lex_state = 61, .external_lex_state = 32},
  [5150] = {.lex_state = 61, .external_lex_state = 20},
  [5151] = {.lex_state = 61, .external_lex_state = 20},
  [5152] = {.lex_state = 61, .external_lex_state = 20},
  [5153] = {.lex_state = 56, .external_lex_state = 42},
  [5154] = {.lex_state = 61, .external_lex_state = 16},
  [5155] = {.lex_state = 61, .external_lex_state = 166},
  [5156] = {.lex_state = 61, .external_lex_state = 32},
  [5157] = {.lex_state = 61, .external_lex_state = 20},
  [5158] = {.lex_state = 61, .external_lex_state = 19},
  [5159] = {.lex_state = 61, .external_lex_state = 32},
  [5160] = {.lex_state = 56, .external_lex_state = 42},
  [5161] = {.lex_state = 61, .external_lex_state = 32},
  [5162] = {.lex_state = 61, .external_lex_state = 20},
  [5163] = {.lex_state = 61, .external_lex_state = 20},
  [5164] = {.lex_state = 61, .external_lex_state = 172},
  [5165] = {.lex_state = 61, .external_lex_state = 19},
  [5166] = {.lex_state = 61, .external_lex_state = 32},
  [5167] = {.lex_state = 61, .external_lex_state = 19},
  [5168] = {.lex_state = 61, .external_lex_state = 19},
  [5169] = {.lex_state = 61, .external_lex_state = 22},
  [5170] = {.lex_state = 61, .external_lex_state = 32},
  [5171] = {.lex_state = 61, .external_lex_state = 32},
  [5172] = {.lex_state = 61, .external_lex_state = 20},
  [5173] = {.lex_state = 61, .external_lex_state = 19},
  [5174] = {.lex_state = 61, .external_lex_state = 19},
  [5175] = {.lex_state = 60, .external_lex_state = 34},
  [5176] = {.lex_state = 56, .external_lex_state = 42},
  [5177] = {.lex_state = 61, .external_lex_state = 167},
  [5178] = {.lex_state = 61, .external_lex_state = 19},
  [5179] = {.lex_state = 61, .external_lex_state = 19},
  [5180] = {.lex_state = 61, .external_lex_state = 19},
  [5181] = {.lex_state = 61, .external_lex_state = 17},
  [5182] = {.lex_state = 61, .external_lex_state = 20},
  [5183] = {.lex_state = 61, .external_lex_state = 19},
  [5184] = {.lex_state = 61, .external_lex_state = 19},
  [5185] = {.lex_state = 61, .external_lex_state = 20},
  [5186] = {.lex_state = 61, .external_lex_state = 20},
  [5187] = {.lex_state = 61, .external_lex_state = 19},
  [5188] = {.lex_state = 60, .external_lex_state = 25},
  [5189] = {.lex_state = 61, .external_lex_state = 20},
  [5190] = {.lex_state = 61, .external_lex_state = 19},
  [5191] = {.lex_state = 61, .external_lex_state = 19},
  [5192] = {.lex_state = 61, .external_lex_state = 20},
  [5193] = {.lex_state = 61, .external_lex_state = 20},
  [5194] = {.lex_state = 61, .external_lex_state = 20},
  [5195] = {.lex_state = 61, .external_lex_state = 20},
  [5196] = {.lex_state = 61, .external_lex_state = 20},
  [5197] = {.lex_state = 61, .external_lex_state = 20},
  [5198] = {.lex_state = 61, .external_lex_state = 20},
  [5199] = {.lex_state = 61, .external_lex_state = 20},
  [5200] = {.lex_state = 61, .external_lex_state = 20},
  [5201] = {.lex_state = 61, .external_lex_state = 22},
  [5202] = {.lex_state = 61, .external_lex_state = 19},
  [5203] = {.lex_state = 61, .external_lex_state = 32},
  [5204] = {.lex_state = 61, .external_lex_state = 20},
  [5205] = {.lex_state = 61, .external_lex_state = 20},
  [5206] = {.lex_state = 61, .external_lex_state = 20},
  [5207] = {.lex_state = 61, .external_lex_state = 32},
  [5208] = {.lex_state = 61, .external_lex_state = 20},
  [5209] = {.lex_state = 61, .external_lex_state = 20},
  [5210] = {.lex_state = 61, .external_lex_state = 20},
  [5211] = {.lex_state = 61, .external_lex_state = 20},
  [5212] = {.lex_state = 61, .external_lex_state = 20},
  [5213] = {.lex_state = 61, .external_lex_state = 20},
  [5214] = {.lex_state = 61, .external_lex_state = 20},
  [5215] = {.lex_state = 61, .external_lex_state = 20},
  [5216] = {.lex_state = 61, .external_lex_state = 32},
  [5217] = {.lex_state = 61, .external_lex_state = 20},
  [5218] = {.lex_state = 61, .external_lex_state = 20},
  [5219] = {.lex_state = 56, .external_lex_state = 42},
  [5220] = {.lex_state = 56, .external_lex_state = 42},
  [5221] = {.lex_state = 61, .external_lex_state = 19},
  [5222] = {.lex_state = 61, .external_lex_state = 20},
  [5223] = {.lex_state = 61, .external_lex_state = 32},
  [5224] = {.lex_state = 61, .external_lex_state = 167},
  [5225] = {.lex_state = 61, .external_lex_state = 16},
  [5226] = {.lex_state = 61, .external_lex_state = 164},
  [5227] = {.lex_state = 61, .external_lex_state = 20},
  [5228] = {.lex_state = 61, .external_lex_state = 20},
  [5229] = {.lex_state = 61, .external_lex_state = 22},
  [5230] = {.lex_state = 61, .external_lex_state = 22},
  [5231] = {.lex_state = 61, .external_lex_state = 164},
  [5232] = {.lex_state = 61, .external_lex_state = 32},
  [5233] = {.lex_state = 61, .external_lex_state = 17},
  [5234] = {.lex_state = 61, .external_lex_state = 17},
  [5235] = {.lex_state = 61, .external_lex_state = 20},
  [5236] = {.lex_state = 61, .external_lex_state = 20},
  [5237] = {.lex_state = 61, .external_lex_state = 17},
  [5238] = {.lex_state = 61, .external_lex_state = 20},
  [5239] = {.lex_state = 61, .external_lex_state = 16},
  [5240] = {.lex_state = 61, .external_lex_state = 22},
  [5241] = {.lex_state = 61, .external_lex_state = 165},
  [5242] = {.lex_state = 55, .external_lex_state = 175},
  [5243] = {.lex_state = 61, .external_lex_state = 166},
  [5244] = {.lex_state = 61, .external_lex_state = 22},
  [5245] = {.lex_state = 55, .external_lex_state = 176},
  [5246] = {.lex_state = 60, .external_lex_state = 10},
  [5247] = {.lex_state = 61, .external_lex_state = 167},
  [5248] = {.lex_state = 61, .external_lex_state = 17},
  [5249] = {.lex_state = 61, .external_lex_state = 17},
  [5250] = {.lex_state = 61, .external_lex_state = 17},
  [5251] = {.lex_state = 61, .external_lex_state = 17},
  [5252] = {.lex_state = 61, .external_lex_state = 17},
  [5253] = {.lex_state = 61, .external_lex_state = 17},
  [5254] = {.lex_state = 61, .external_lex_state = 17},
  [5255] = {.lex_state = 61, .external_lex_state = 19},
  [5256] = {.lex_state = 61, .external_lex_state = 17},
  [5257] = {.lex_state = 61, .external_lex_state = 17},
  [5258] = {.lex_state = 61, .external_lex_state = 22},
  [5259] = {.lex_state = 61, .external_lex_state = 17},
  [5260] = {.lex_state = 61, .external_lex_state = 165},
  [5261] = {.lex_state = 61, .external_lex_state = 20},
  [5262] = {.lex_state = 61, .external_lex_state = 17},
  [5263] = {.lex_state = 61, .external_lex_state = 17},
  [5264] = {.lex_state = 61, .external_lex_state = 17},
  [5265] = {.lex_state = 61, .external_lex_state = 27},
  [5266] = {.lex_state = 61, .external_lex_state = 26},
  [5267] = {.lex_state = 61, .external_lex_state = 34},
  [5268] = {.lex_state = 61, .external_lex_state = 34},
  [5269] = {.lex_state = 61, .external_lex_state = 27},
  [5270] = {.lex_state = 61, .external_lex_state = 34},
  [5271] = {.lex_state = 61, .external_lex_state = 34},
  [5272] = {.lex_state = 61, .external_lex_state = 34},
  [5273] = {.lex_state = 61, .external_lex_state = 34},
  [5274] = {.lex_state = 56, .external_lex_state = 177},
  [5275] = {.lex_state = 61, .external_lex_state = 34},
  [5276] = {.lex_state = 61, .external_lex_state = 34},
  [5277] = {.lex_state = 61, .external_lex_state = 34},
  [5278] = {.lex_state = 61, .external_lex_state = 34},
  [5279] = {.lex_state = 61, .external_lex_state = 34},
  [5280] = {.lex_state = 61, .external_lex_state = 34},
  [5281] = {.lex_state = 61, .external_lex_state = 22},
  [5282] = {.lex_state = 61, .external_lex_state = 34},
  [5283] = {.lex_state = 61, .external_lex_state = 28},
  [5284] = {.lex_state = 61, .external_lex_state = 23},
  [5285] = {.lex_state = 61, .external_lex_state = 28},
  [5286] = {.lex_state = 55, .external_lex_state = 19},
  [5287] = {.lex_state = 61, .external_lex_state = 28},
  [5288] = {.lex_state = 55, .external_lex_state = 19},
  [5289] = {.lex_state = 55, .external_lex_state = 19},
  [5290] = {.lex_state = 61, .external_lex_state = 34},
  [5291] = {.lex_state = 61, .external_lex_state = 29},
  [5292] = {.lex_state = 61, .external_lex_state = 29},
  [5293] = {.lex_state = 61, .external_lex_state = 34},
  [5294] = {.lex_state = 61, .external_lex_state = 22},
  [5295] = {.lex_state = 61, .external_lex_state = 34},
  [5296] = {.lex_state = 61, .external_lex_state = 29},
  [5297] = {.lex_state = 61, .external_lex_state = 29},
  [5298] = {.lex_state = 61, .external_lex_state = 29},
  [5299] = {.lex_state = 61, .external_lex_state = 29},
  [5300] = {.lex_state = 61, .external_lex_state = 29},
  [5301] = {.lex_state = 61, .external_lex_state = 34},
  [5302] = {.lex_state = 61, .external_lex_state = 22},
  [5303] = {.lex_state = 61, .external_lex_state = 26},
  [5304] = {.lex_state = 55, .external_lex_state = 16},
  [5305] = {.lex_state = 61, .external_lex_state = 28},
  [5306] = {.lex_state = 61, .external_lex_state = 23},
  [5307] = {.lex_state = 61, .external_lex_state = 29},
  [5308] = {.lex_state = 61, .external_lex_state = 29},
  [5309] = {.lex_state = 61, .external_lex_state = 29},
  [5310] = {.lex_state = 61, .external_lex_state = 29},
  [5311] = {.lex_state = 61, .external_lex_state = 28},
  [5312] = {.lex_state = 61, .external_lex_state = 29},
  [5313] = {.lex_state = 56, .external_lex_state = 178},
  [5314] = {.lex_state = 61, .external_lex_state = 22},
  [5315] = {.lex_state = 61, .external_lex_state = 34},
  [5316] = {.lex_state = 61, .external_lex_state = 29},
  [5317] = {.lex_state = 61, .external_lex_state = 34},
  [5318] = {.lex_state = 61, .external_lex_state = 34},
  [5319] = {.lex_state = 61, .external_lex_state = 34},
  [5320] = {.lex_state = 61, .external_lex_state = 27},
  [5321] = {.lex_state = 61, .external_lex_state = 28},
  [5322] = {.lex_state = 61, .external_lex_state = 23},
  [5323] = {.lex_state = 61, .external_lex_state = 28},
  [5324] = {.lex_state = 61, .external_lex_state = 23},
  [5325] = {.lex_state = 61, .external_lex_state = 34},
  [5326] = {.lex_state = 61, .external_lex_state = 34},
  [5327] = {.lex_state = 61, .external_lex_state = 26},
  [5328] = {.lex_state = 61, .external_lex_state = 23},
  [5329] = {.lex_state = 61, .external_lex_state = 29},
  [5330] = {.lex_state = 61, .external_lex_state = 29},
  [5331] = {.lex_state = 61, .external_lex_state = 29},
  [5332] = {.lex_state = 61, .external_lex_state = 29},
  [5333] = {.lex_state = 61, .external_lex_state = 29},
  [5334] = {.lex_state = 61, .external_lex_state = 29},
  [5335] = {.lex_state = 61, .external_lex_state = 29},
  [5336] = {.lex_state = 61, .external_lex_state = 23},
  [5337] = {.lex_state = 61, .external_lex_state = 23},
  [5338] = {.lex_state = 61, .external_lex_state = 26},
  [5339] = {.lex_state = 61, .external_lex_state = 179},
  [5340] = {.lex_state = 61, .external_lex_state = 29},
  [5341] = {.lex_state = 61, .external_lex_state = 180},
  [5342] = {.lex_state = 61, .external_lex_state = 22},
  [5343] = {.lex_state = 61, .external_lex_state = 29},
  [5344] = {.lex_state = 61, .external_lex_state = 34},
  [5345] = {.lex_state = 61, .external_lex_state = 29},
  [5346] = {.lex_state = 61, .external_lex_state = 29},
  [5347] = {.lex_state = 61, .external_lex_state = 23},
  [5348] = {.lex_state = 61, .external_lex_state = 22},
  [5349] = {.lex_state = 61, .external_lex_state = 28},
  [5350] = {.lex_state = 61, .external_lex_state = 25},
  [5351] = {.lex_state = 61, .external_lex_state = 34},
  [5352] = {.lex_state = 61, .external_lex_state = 22},
  [5353] = {.lex_state = 61, .external_lex_state = 26},
  [5354] = {.lex_state = 61, .external_lex_state = 28},
  [5355] = {.lex_state = 61, .external_lex_state = 23},
  [5356] = {.lex_state = 61, .external_lex_state = 23},
  [5357] = {.lex_state = 61, .external_lex_state = 23},
  [5358] = {.lex_state = 61, .external_lex_state = 23},
  [5359] = {.lex_state = 61, .external_lex_state = 23},
  [5360] = {.lex_state = 61, .external_lex_state = 23},
  [5361] = {.lex_state = 61, .external_lex_state = 23},
  [5362] = {.lex_state = 61, .external_lex_state = 34},
  [5363] = {.lex_state = 61, .external_lex_state = 29},
  [5364] = {.lex_state = 61, .external_lex_state = 34},
  [5365] = {.lex_state = 61, .external_lex_state = 34},
  [5366] = {.lex_state = 61, .external_lex_state = 29},
  [5367] = {.lex_state = 61, .external_lex_state = 27},
  [5368] = {.lex_state = 61, .external_lex_state = 24},
  [5369] = {.lex_state = 55, .external_lex_state = 19},
  [5370] = {.lex_state = 61, .external_lex_state = 22},
  [5371] = {.lex_state = 61, .external_lex_state = 24},
  [5372] = {.lex_state = 61, .external_lex_state = 23},
  [5373] = {.lex_state = 56, .external_lex_state = 178},
  [5374] = {.lex_state = 61, .external_lex_state = 24},
  [5375] = {.lex_state = 61, .external_lex_state = 23},
  [5376] = {.lex_state = 61, .external_lex_state = 28},
  [5377] = {.lex_state = 61, .external_lex_state = 23},
  [5378] = {.lex_state = 61, .external_lex_state = 29},
  [5379] = {.lex_state = 61, .external_lex_state = 23},
  [5380] = {.lex_state = 61, .external_lex_state = 23},
  [5381] = {.lex_state = 61, .external_lex_state = 23},
  [5382] = {.lex_state = 61, .external_lex_state = 29},
  [5383] = {.lex_state = 61, .external_lex_state = 27},
  [5384] = {.lex_state = 61, .external_lex_state = 34},
  [5385] = {.lex_state = 61, .external_lex_state = 34},
  [5386] = {.lex_state = 61, .external_lex_state = 34},
  [5387] = {.lex_state = 61, .external_lex_state = 24},
  [5388] = {.lex_state = 61, .external_lex_state = 23},
  [5389] = {.lex_state = 61, .external_lex_state = 23},
  [5390] = {.lex_state = 61, .external_lex_state = 23},
  [5391] = {.lex_state = 61, .external_lex_state = 23},
  [5392] = {.lex_state = 61, .external_lex_state = 23},
  [5393] = {.lex_state = 61, .external_lex_state = 24},
  [5394] = {.lex_state = 61, .external_lex_state = 24},
  [5395] = {.lex_state = 61, .external_lex_state = 24},
  [5396] = {.lex_state = 61, .external_lex_state = 23},
  [5397] = {.lex_state = 61, .external_lex_state = 23},
  [5398] = {.lex_state = 61, .external_lex_state = 24},
  [5399] = {.lex_state = 61, .external_lex_state = 24},
  [5400] = {.lex_state = 61, .external_lex_state = 24},
  [5401] = {.lex_state = 61, .external_lex_state = 24},
  [5402] = {.lex_state = 56, .external_lex_state = 177},
  [5403] = {.lex_state = 61, .external_lex_state = 29},
  [5404] = {.lex_state = 61, .external_lex_state = 25},
  [5405] = {.lex_state = 61, .external_lex_state = 27},
  [5406] = {.lex_state = 61, .external_lex_state = 27},
  [5407] = {.lex_state = 61, .external_lex_state = 27},
  [5408] = {.lex_state = 61, .external_lex_state = 27},
  [5409] = {.lex_state = 61, .external_lex_state = 25},
  [5410] = {.lex_state = 61, .external_lex_state = 179},
  [5411] = {.lex_state = 56, .external_lex_state = 177},
  [5412] = {.lex_state = 61, .external_lex_state = 25},
  [5413] = {.lex_state = 61, .external_lex_state = 25},
  [5414] = {.lex_state = 55, .external_lex_state = 19},
  [5415] = {.lex_state = 61, .external_lex_state = 27},
  [5416] = {.lex_state = 61, .external_lex_state = 27},
  [5417] = {.lex_state = 61, .external_lex_state = 27},
  [5418] = {.lex_state = 61, .external_lex_state = 25},
  [5419] = {.lex_state = 61, .external_lex_state = 25},
  [5420] = {.lex_state = 55, .external_lex_state = 20},
  [5421] = {.lex_state = 55, .external_lex_state = 20},
  [5422] = {.lex_state = 55, .external_lex_state = 20},
  [5423] = {.lex_state = 55, .external_lex_state = 20},
  [5424] = {.lex_state = 61, .external_lex_state = 29},
  [5425] = {.lex_state = 61, .external_lex_state = 22},
  [5426] = {.lex_state = 61, .external_lex_state = 27},
  [5427] = {.lex_state = 61, .external_lex_state = 27},
  [5428] = {.lex_state = 61, .external_lex_state = 22},
  [5429] = {.lex_state = 61, .external_lex_state = 25},
  [5430] = {.lex_state = 61, .external_lex_state = 27},
  [5431] = {.lex_state = 61, .external_lex_state = 25},
  [5432] = {.lex_state = 61, .external_lex_state = 25},
  [5433] = {.lex_state = 61, .external_lex_state = 25},
  [5434] = {.lex_state = 61, .external_lex_state = 28},
  [5435] = {.lex_state = 55, .external_lex_state = 20},
  [5436] = {.lex_state = 61, .external_lex_state = 25},
  [5437] = {.lex_state = 55, .external_lex_state = 20},
  [5438] = {.lex_state = 61, .external_lex_state = 29},
  [5439] = {.lex_state = 61, .external_lex_state = 29},
  [5440] = {.lex_state = 55, .external_lex_state = 20},
  [5441] = {.lex_state = 61, .external_lex_state = 179},
  [5442] = {.lex_state = 61, .external_lex_state = 27},
  [5443] = {.lex_state = 61, .external_lex_state = 24},
  [5444] = {.lex_state = 61, .external_lex_state = 27},
  [5445] = {.lex_state = 61, .external_lex_state = 22},
  [5446] = {.lex_state = 61, .external_lex_state = 28},
  [5447] = {.lex_state = 61, .external_lex_state = 24},
  [5448] = {.lex_state = 61, .external_lex_state = 24},
  [5449] = {.lex_state = 61, .external_lex_state = 24},
  [5450] = {.lex_state = 61, .external_lex_state = 22},
  [5451] = {.lex_state = 61, .external_lex_state = 25},
  [5452] = {.lex_state = 61, .external_lex_state = 24},
  [5453] = {.lex_state = 55, .external_lex_state = 18},
  [5454] = {.lex_state = 55, .external_lex_state = 18},
  [5455] = {.lex_state = 55, .external_lex_state = 18},
  [5456] = {.lex_state = 55, .external_lex_state = 18},
  [5457] = {.lex_state = 61, .external_lex_state = 28},
  [5458] = {.lex_state = 55, .external_lex_state = 18},
  [5459] = {.lex_state = 61, .external_lex_state = 179},
  [5460] = {.lex_state = 61, .external_lex_state = 28},
  [5461] = {.lex_state = 61, .external_lex_state = 22},
  [5462] = {.lex_state = 55, .external_lex_state = 18},
  [5463] = {.lex_state = 55, .external_lex_state = 18},
  [5464] = {.lex_state = 61, .external_lex_state = 180},
  [5465] = {.lex_state = 55, .external_lex_state = 18},
  [5466] = {.lex_state = 61, .external_lex_state = 34},
  [5467] = {.lex_state = 61, .external_lex_state = 25},
  [5468] = {.lex_state = 61, .external_lex_state = 25},
  [5469] = {.lex_state = 61, .external_lex_state = 25},
  [5470] = {.lex_state = 61, .external_lex_state = 25},
  [5471] = {.lex_state = 55, .external_lex_state = 18},
  [5472] = {.lex_state = 55, .external_lex_state = 18},
  [5473] = {.lex_state = 55, .external_lex_state = 18},
  [5474] = {.lex_state = 61, .external_lex_state = 25},
  [5475] = {.lex_state = 55, .external_lex_state = 20},
  [5476] = {.lex_state = 55, .external_lex_state = 20},
  [5477] = {.lex_state = 61, .external_lex_state = 25},
  [5478] = {.lex_state = 61, .external_lex_state = 180},
  [5479] = {.lex_state = 61, .external_lex_state = 22},
  [5480] = {.lex_state = 61, .external_lex_state = 27},
  [5481] = {.lex_state = 55, .external_lex_state = 20},
  [5482] = {.lex_state = 61, .external_lex_state = 27},
  [5483] = {.lex_state = 55, .external_lex_state = 18},
  [5484] = {.lex_state = 61, .external_lex_state = 180},
  [5485] = {.lex_state = 55, .external_lex_state = 18},
  [5486] = {.lex_state = 55, .external_lex_state = 18},
  [5487] = {.lex_state = 61, .external_lex_state = 25},
  [5488] = {.lex_state = 61, .external_lex_state = 25},
  [5489] = {.lex_state = 61, .external_lex_state = 8},
  [5490] = {.lex_state = 61, .external_lex_state = 27},
  [5491] = {.lex_state = 61, .external_lex_state = 27},
  [5492] = {.lex_state = 55, .external_lex_state = 19},
  [5493] = {.lex_state = 61, .external_lex_state = 25},
  [5494] = {.lex_state = 61, .external_lex_state = 25},
  [5495] = {.lex_state = 61, .external_lex_state = 25},
  [5496] = {.lex_state = 56, .external_lex_state = 178},
  [5497] = {.lex_state = 55, .external_lex_state = 19},
  [5498] = {.lex_state = 61, .external_lex_state = 34},
  [5499] = {.lex_state = 61, .external_lex_state = 24},
  [5500] = {.lex_state = 55, .external_lex_state = 19},
  [5501] = {.lex_state = 61, .external_lex_state = 29},
  [5502] = {.lex_state = 55, .external_lex_state = 19},
  [5503] = {.lex_state = 55, .external_lex_state = 20},
  [5504] = {.lex_state = 55, .external_lex_state = 20},
  [5505] = {.lex_state = 61, .external_lex_state = 25},
  [5506] = {.lex_state = 55, .external_lex_state = 18},
  [5507] = {.lex_state = 61, .external_lex_state = 28},
  [5508] = {.lex_state = 55, .external_lex_state = 20},
  [5509] = {.lex_state = 61, .external_lex_state = 180},
  [5510] = {.lex_state = 61, .external_lex_state = 27},
  [5511] = {.lex_state = 61, .external_lex_state = 28},
  [5512] = {.lex_state = 61, .external_lex_state = 27},
  [5513] = {.lex_state = 61, .external_lex_state = 24},
  [5514] = {.lex_state = 61, .external_lex_state = 25},
  [5515] = {.lex_state = 55, .external_lex_state = 18},
  [5516] = {.lex_state = 61, .external_lex_state = 179},
  [5517] = {.lex_state = 55, .external_lex_state = 18},
  [5518] = {.lex_state = 61, .external_lex_state = 25},
  [5519] = {.lex_state = 55, .external_lex_state = 20},
  [5520] = {.lex_state = 55, .external_lex_state = 20},
  [5521] = {.lex_state = 55, .external_lex_state = 19},
  [5522] = {.lex_state = 61, .external_lex_state = 29},
  [5523] = {.lex_state = 55, .external_lex_state = 20},
  [5524] = {.lex_state = 55, .external_lex_state = 20},
  [5525] = {.lex_state = 61, .external_lex_state = 25},
  [5526] = {.lex_state = 55, .external_lex_state = 16},
  [5527] = {.lex_state = 55, .external_lex_state = 16},
  [5528] = {.lex_state = 55, .external_lex_state = 20},
  [5529] = {.lex_state = 61, .external_lex_state = 28},
  [5530] = {.lex_state = 61, .external_lex_state = 25},
  [5531] = {.lex_state = 61, .external_lex_state = 25},
  [5532] = {.lex_state = 61, .external_lex_state = 25},
  [5533] = {.lex_state = 61, .external_lex_state = 25},
  [5534] = {.lex_state = 61, .external_lex_state = 25},
  [5535] = {.lex_state = 61, .external_lex_state = 25},
  [5536] = {.lex_state = 61, .external_lex_state = 8},
  [5537] = {.lex_state = 61, .external_lex_state = 25},
  [5538] = {.lex_state = 61, .external_lex_state = 8},
  [5539] = {.lex_state = 55, .external_lex_state = 16},
  [5540] = {.lex_state = 61, .external_lex_state = 25},
  [5541] = {.lex_state = 61, .external_lex_state = 27},
  [5542] = {.lex_state = 61, .external_lex_state = 27},
  [5543] = {.lex_state = 55, .external_lex_state = 19},
  [5544] = {.lex_state = 61, .external_lex_state = 25},
  [5545] = {.lex_state = 55, .external_lex_state = 22},
  [5546] = {.lex_state = 61, .external_lex_state = 25},
  [5547] = {.lex_state = 61, .external_lex_state = 25},
  [5548] = {.lex_state = 55, .external_lex_state = 19},
  [5549] = {.lex_state = 61, .external_lex_state = 25},
  [5550] = {.lex_state = 61, .external_lex_state = 27},
  [5551] = {.lex_state = 61, .external_lex_state = 28},
  [5552] = {.lex_state = 61, .external_lex_state = 25},
  [5553] = {.lex_state = 61, .external_lex_state = 25},
  [5554] = {.lex_state = 61, .external_lex_state = 25},
  [5555] = {.lex_state = 61, .external_lex_state = 34},
  [5556] = {.lex_state = 61, .external_lex_state = 25},
  [5557] = {.lex_state = 61, .external_lex_state = 29},
  [5558] = {.lex_state = 61, .external_lex_state = 25},
  [5559] = {.lex_state = 61, .external_lex_state = 25},
  [5560] = {.lex_state = 61, .external_lex_state = 27},
  [5561] = {.lex_state = 61, .external_lex_state = 29},
  [5562] = {.lex_state = 61, .external_lex_state = 22},
  [5563] = {.lex_state = 61, .external_lex_state = 25},
  [5564] = {.lex_state = 55, .external_lex_state = 181},
  [5565] = {.lex_state = 55, .external_lex_state = 19},
  [5566] = {.lex_state = 61, .external_lex_state = 25},
  [5567] = {.lex_state = 61, .external_lex_state = 29},
  [5568] = {.lex_state = 55, .external_lex_state = 16},
  [5569] = {.lex_state = 55, .external_lex_state = 16},
  [5570] = {.lex_state = 61, .external_lex_state = 29},
  [5571] = {.lex_state = 61, .external_lex_state = 25},
  [5572] = {.lex_state = 61, .external_lex_state = 25},
  [5573] = {.lex_state = 61, .external_lex_state = 25},
  [5574] = {.lex_state = 55, .external_lex_state = 16},
  [5575] = {.lex_state = 61, .external_lex_state = 22},
  [5576] = {.lex_state = 61, .external_lex_state = 22},
  [5577] = {.lex_state = 55, .external_lex_state = 19},
  [5578] = {.lex_state = 55, .external_lex_state = 19},
  [5579] = {.lex_state = 61, .external_lex_state = 34},
  [5580] = {.lex_state = 61, .external_lex_state = 25},
  [5581] = {.lex_state = 61, .external_lex_state = 25},
  [5582] = {.lex_state = 61, .external_lex_state = 22},
  [5583] = {.lex_state = 61, .external_lex_state = 29},
  [5584] = {.lex_state = 61, .external_lex_state = 22},
  [5585] = {.lex_state = 61, .external_lex_state = 27},
  [5586] = {.lex_state = 55, .external_lex_state = 19},
  [5587] = {.lex_state = 55, .external_lex_state = 16},
  [5588] = {.lex_state = 55, .external_lex_state = 16},
  [5589] = {.lex_state = 55, .external_lex_state = 16},
  [5590] = {.lex_state = 61, .external_lex_state = 24},
  [5591] = {.lex_state = 61, .external_lex_state = 34},
  [5592] = {.lex_state = 55, .external_lex_state = 19},
  [5593] = {.lex_state = 61, .external_lex_state = 27},
  [5594] = {.lex_state = 61, .external_lex_state = 24},
  [5595] = {.lex_state = 55, .external_lex_state = 32},
  [5596] = {.lex_state = 55, .external_lex_state = 16},
  [5597] = {.lex_state = 55, .external_lex_state = 16},
  [5598] = {.lex_state = 61, .external_lex_state = 22},
  [5599] = {.lex_state = 55, .external_lex_state = 16},
  [5600] = {.lex_state = 55, .external_lex_state = 182},
  [5601] = {.lex_state = 61, .external_lex_state = 24},
  [5602] = {.lex_state = 55, .external_lex_state = 16},
  [5603] = {.lex_state = 55, .external_lex_state = 16},
  [5604] = {.lex_state = 55, .external_lex_state = 17},
  [5605] = {.lex_state = 55, .external_lex_state = 17},
  [5606] = {.lex_state = 55, .external_lex_state = 16},
  [5607] = {.lex_state = 55, .external_lex_state = 16},
  [5608] = {.lex_state = 55, .external_lex_state = 16},
  [5609] = {.lex_state = 61, .external_lex_state = 29},
  [5610] = {.lex_state = 55, .external_lex_state = 17},
  [5611] = {.lex_state = 61, .external_lex_state = 9},
  [5612] = {.lex_state = 55, .external_lex_state = 17},
  [5613] = {.lex_state = 55, .external_lex_state = 183},
  [5614] = {.lex_state = 61, .external_lex_state = 26},
  [5615] = {.lex_state = 61, .external_lex_state = 25},
  [5616] = {.lex_state = 61, .external_lex_state = 25},
  [5617] = {.lex_state = 61, .external_lex_state = 24},
  [5618] = {.lex_state = 61, .external_lex_state = 24},
  [5619] = {.lex_state = 61, .external_lex_state = 24},
  [5620] = {.lex_state = 61, .external_lex_state = 24},
  [5621] = {.lex_state = 61, .external_lex_state = 23},
  [5622] = {.lex_state = 61, .external_lex_state = 10},
  [5623] = {.lex_state = 61, .external_lex_state = 25},
  [5624] = {.lex_state = 61, .external_lex_state = 24},
  [5625] = {.lex_state = 55, .external_lex_state = 17},
  [5626] = {.lex_state = 55, .external_lex_state = 17},
  [5627] = {.lex_state = 61, .external_lex_state = 34},
  [5628] = {.lex_state = 61, .external_lex_state = 24},
  [5629] = {.lex_state = 55, .external_lex_state = 17},
  [5630] = {.lex_state = 61, .external_lex_state = 24},
  [5631] = {.lex_state = 61, .external_lex_state = 24},
  [5632] = {.lex_state = 61, .external_lex_state = 24},
  [5633] = {.lex_state = 61, .external_lex_state = 22},
  [5634] = {.lex_state = 61, .external_lex_state = 9},
  [5635] = {.lex_state = 61, .external_lex_state = 9},
  [5636] = {.lex_state = 61, .external_lex_state = 34},
  [5637] = {.lex_state = 61, .external_lex_state = 29},
  [5638] = {.lex_state = 61, .external_lex_state = 25},
  [5639] = {.lex_state = 61, .external_lex_state = 29},
  [5640] = {.lex_state = 61, .external_lex_state = 22},
  [5641] = {.lex_state = 61, .external_lex_state = 29},
  [5642] = {.lex_state = 61, .external_lex_state = 29},
  [5643] = {.lex_state = 55, .external_lex_state = 18},
  [5644] = {.lex_state = 61, .external_lex_state = 25},
  [5645] = {.lex_state = 55, .external_lex_state = 17},
  [5646] = {.lex_state = 61, .external_lex_state = 29},
  [5647] = {.lex_state = 61, .external_lex_state = 29},
  [5648] = {.lex_state = 61, .external_lex_state = 29},
  [5649] = {.lex_state = 55, .external_lex_state = 19},
  [5650] = {.lex_state = 61, .external_lex_state = 22},
  [5651] = {.lex_state = 55, .external_lex_state = 17},
  [5652] = {.lex_state = 55, .external_lex_state = 17},
  [5653] = {.lex_state = 61, .external_lex_state = 27},
  [5654] = {.lex_state = 61, .external_lex_state = 22},
  [5655] = {.lex_state = 61, .external_lex_state = 8},
  [5656] = {.lex_state = 61, .external_lex_state = 29},
  [5657] = {.lex_state = 61, .external_lex_state = 29},
  [5658] = {.lex_state = 61, .external_lex_state = 24},
  [5659] = {.lex_state = 55, .external_lex_state = 17},
  [5660] = {.lex_state = 61, .external_lex_state = 24},
  [5661] = {.lex_state = 55, .external_lex_state = 17},
  [5662] = {.lex_state = 55, .external_lex_state = 17},
  [5663] = {.lex_state = 61, .external_lex_state = 24},
  [5664] = {.lex_state = 61, .external_lex_state = 24},
  [5665] = {.lex_state = 61, .external_lex_state = 24},
  [5666] = {.lex_state = 55, .external_lex_state = 17},
  [5667] = {.lex_state = 61, .external_lex_state = 24},
  [5668] = {.lex_state = 61, .external_lex_state = 22},
  [5669] = {.lex_state = 55, .external_lex_state = 17},
  [5670] = {.lex_state = 61, .external_lex_state = 24},
  [5671] = {.lex_state = 61, .external_lex_state = 29},
  [5672] = {.lex_state = 61, .external_lex_state = 29},
  [5673] = {.lex_state = 61, .external_lex_state = 27},
  [5674] = {.lex_state = 61, .external_lex_state = 27},
  [5675] = {.lex_state = 55, .external_lex_state = 17},
  [5676] = {.lex_state = 55, .external_lex_state = 17},
  [5677] = {.lex_state = 55, .external_lex_state = 17},
  [5678] = {.lex_state = 61, .external_lex_state = 24},
  [5679] = {.lex_state = 61, .external_lex_state = 24},
  [5680] = {.lex_state = 61, .external_lex_state = 24},
  [5681] = {.lex_state = 61, .external_lex_state = 24},
  [5682] = {.lex_state = 61, .external_lex_state = 27},
  [5683] = {.lex_state = 61, .external_lex_state = 24},
  [5684] = {.lex_state = 61, .external_lex_state = 27},
  [5685] = {.lex_state = 61, .external_lex_state = 26},
  [5686] = {.lex_state = 61, .external_lex_state = 24},
  [5687] = {.lex_state = 61, .external_lex_state = 26},
  [5688] = {.lex_state = 61, .external_lex_state = 28},
  [5689] = {.lex_state = 61, .external_lex_state = 28},
  [5690] = {.lex_state = 61, .external_lex_state = 28},
  [5691] = {.lex_state = 61, .external_lex_state = 24},
  [5692] = {.lex_state = 61, .external_lex_state = 27},
  [5693] = {.lex_state = 61, .external_lex_state = 24},
  [5694] = {.lex_state = 61, .external_lex_state = 27},
  [5695] = {.lex_state = 61, .external_lex_state = 29},
  [5696] = {.lex_state = 61, .external_lex_state = 27},
  [5697] = {.lex_state = 61, .external_lex_state = 27},
  [5698] = {.lex_state = 61, .external_lex_state = 27},
  [5699] = {.lex_state = 61, .external_lex_state = 26},
  [5700] = {.lex_state = 61, .external_lex_state = 26},
  [5701] = {.lex_state = 61, .external_lex_state = 27},
  [5702] = {.lex_state = 61, .external_lex_state = 24},
  [5703] = {.lex_state = 61, .external_lex_state = 24},
  [5704] = {.lex_state = 61, .external_lex_state = 26},
  [5705] = {.lex_state = 61, .external_lex_state = 26},
  [5706] = {.lex_state = 61, .external_lex_state = 26},
  [5707] = {.lex_state = 61, .external_lex_state = 26},
  [5708] = {.lex_state = 61, .external_lex_state = 26},
  [5709] = {.lex_state = 61, .external_lex_state = 24},
  [5710] = {.lex_state = 61, .external_lex_state = 24},
  [5711] = {.lex_state = 61, .external_lex_state = 24},
  [5712] = {.lex_state = 61, .external_lex_state = 24},
  [5713] = {.lex_state = 61, .external_lex_state = 28},
  [5714] = {.lex_state = 61, .external_lex_state = 28},
  [5715] = {.lex_state = 61, .external_lex_state = 24},
  [5716] = {.lex_state = 61, .external_lex_state = 26},
  [5717] = {.lex_state = 56, .external_lex_state = 177},
  [5718] = {.lex_state = 61, .external_lex_state = 26},
  [5719] = {.lex_state = 61, .external_lex_state = 26},
  [5720] = {.lex_state = 61, .external_lex_state = 26},
  [5721] = {.lex_state = 61, .external_lex_state = 25},
  [5722] = {.lex_state = 61, .external_lex_state = 26},
  [5723] = {.lex_state = 61, .external_lex_state = 27},
  [5724] = {.lex_state = 61, .external_lex_state = 26},
  [5725] = {.lex_state = 61, .external_lex_state = 27},
  [5726] = {.lex_state = 61, .external_lex_state = 22},
  [5727] = {.lex_state = 61, .external_lex_state = 28},
  [5728] = {.lex_state = 61, .external_lex_state = 24},
  [5729] = {.lex_state = 61, .external_lex_state = 28},
  [5730] = {.lex_state = 61, .external_lex_state = 28},
  [5731] = {.lex_state = 61, .external_lex_state = 28},
  [5732] = {.lex_state = 61, .external_lex_state = 22},
  [5733] = {.lex_state = 61, .external_lex_state = 28},
  [5734] = {.lex_state = 61, .external_lex_state = 28},
  [5735] = {.lex_state = 61, .external_lex_state = 26},
  [5736] = {.lex_state = 61, .external_lex_state = 26},
  [5737] = {.lex_state = 61, .external_lex_state = 26},
  [5738] = {.lex_state = 61, .external_lex_state = 26},
  [5739] = {.lex_state = 61, .external_lex_state = 26},
  [5740] = {.lex_state = 61, .external_lex_state = 26},
  [5741] = {.lex_state = 61, .external_lex_state = 26},
  [5742] = {.lex_state = 61, .external_lex_state = 25},
  [5743] = {.lex_state = 61, .external_lex_state = 26},
  [5744] = {.lex_state = 61, .external_lex_state = 25},
  [5745] = {.lex_state = 61, .external_lex_state = 26},
  [5746] = {.lex_state = 61, .external_lex_state = 24},
  [5747] = {.lex_state = 61, .external_lex_state = 26},
  [5748] = {.lex_state = 61, .external_lex_state = 26},
  [5749] = {.lex_state = 61, .external_lex_state = 26},
  [5750] = {.lex_state = 61, .external_lex_state = 26},
  [5751] = {.lex_state = 61, .external_lex_state = 27},
  [5752] = {.lex_state = 61, .external_lex_state = 24},
  [5753] = {.lex_state = 61, .external_lex_state = 25},
  [5754] = {.lex_state = 61, .external_lex_state = 27},
  [5755] = {.lex_state = 61, .external_lex_state = 27},
  [5756] = {.lex_state = 61, .external_lex_state = 26},
  [5757] = {.lex_state = 61, .external_lex_state = 26},
  [5758] = {.lex_state = 61, .external_lex_state = 24},
  [5759] = {.lex_state = 61, .external_lex_state = 27},
  [5760] = {.lex_state = 61, .external_lex_state = 22},
  [5761] = {.lex_state = 61, .external_lex_state = 24},
  [5762] = {.lex_state = 61, .external_lex_state = 26},
  [5763] = {.lex_state = 61, .external_lex_state = 26},
  [5764] = {.lex_state = 61, .external_lex_state = 25},
  [5765] = {.lex_state = 61, .external_lex_state = 26},
  [5766] = {.lex_state = 61, .external_lex_state = 26},
  [5767] = {.lex_state = 56, .external_lex_state = 178},
  [5768] = {.lex_state = 61, .external_lex_state = 24},
  [5769] = {.lex_state = 61, .external_lex_state = 25},
  [5770] = {.lex_state = 61, .external_lex_state = 25},
  [5771] = {.lex_state = 61, .external_lex_state = 24},
  [5772] = {.lex_state = 55, .external_lex_state = 19},
  [5773] = {.lex_state = 56, .external_lex_state = 178},
  [5774] = {.lex_state = 56, .external_lex_state = 177},
  [5775] = {.lex_state = 61, .external_lex_state = 27},
  [5776] = {.lex_state = 61, .external_lex_state = 28},
  [5777] = {.lex_state = 61, .external_lex_state = 27},
  [5778] = {.lex_state = 61, .external_lex_state = 28},
  [5779] = {.lex_state = 61, .external_lex_state = 26},
  [5780] = {.lex_state = 61, .external_lex_state = 25},
  [5781] = {.lex_state = 56, .external_lex_state = 177},
  [5782] = {.lex_state = 61, .external_lex_state = 25},
  [5783] = {.lex_state = 61, .external_lex_state = 25},
  [5784] = {.lex_state = 61, .external_lex_state = 27},
  [5785] = {.lex_state = 61, .external_lex_state = 10},
  [5786] = {.lex_state = 61, .external_lex_state = 26},
  [5787] = {.lex_state = 61, .external_lex_state = 26},
  [5788] = {.lex_state = 61, .external_lex_state = 28},
  [5789] = {.lex_state = 61, .external_lex_state = 26},
  [5790] = {.lex_state = 61, .external_lex_state = 26},
  [5791] = {.lex_state = 61, .external_lex_state = 26},
  [5792] = {.lex_state = 61, .external_lex_state = 26},
  [5793] = {.lex_state = 61, .external_lex_state = 26},
  [5794] = {.lex_state = 61, .external_lex_state = 10},
  [5795] = {.lex_state = 55, .external_lex_state = 23},
  [5796] = {.lex_state = 61, .external_lex_state = 24},
  [5797] = {.lex_state = 61, .external_lex_state = 25},
  [5798] = {.lex_state = 61, .external_lex_state = 26},
  [5799] = {.lex_state = 61, .external_lex_state = 26},
  [5800] = {.lex_state = 61, .external_lex_state = 27},
  [5801] = {.lex_state = 61, .external_lex_state = 27},
  [5802] = {.lex_state = 61, .external_lex_state = 24},
  [5803] = {.lex_state = 61, .external_lex_state = 28},
  [5804] = {.lex_state = 61, .external_lex_state = 24},
  [5805] = {.lex_state = 61, .external_lex_state = 27},
  [5806] = {.lex_state = 61, .external_lex_state = 26},
  [5807] = {.lex_state = 61, .external_lex_state = 26},
  [5808] = {.lex_state = 61, .external_lex_state = 27},
  [5809] = {.lex_state = 61, .external_lex_state = 28},
  [5810] = {.lex_state = 61, .external_lex_state = 28},
  [5811] = {.lex_state = 61, .external_lex_state = 28},
  [5812] = {.lex_state = 61, .external_lex_state = 27},
  [5813] = {.lex_state = 61, .external_lex_state = 27},
  [5814] = {.lex_state = 61, .external_lex_state = 27},
  [5815] = {.lex_state = 61, .external_lex_state = 27},
  [5816] = {.lex_state = 61, .external_lex_state = 29},
  [5817] = {.lex_state = 61, .external_lex_state = 24},
  [5818] = {.lex_state = 61, .external_lex_state = 34},
  [5819] = {.lex_state = 61, .external_lex_state = 26},
  [5820] = {.lex_state = 61, .external_lex_state = 28},
  [5821] = {.lex_state = 61, .external_lex_state = 25},
  [5822] = {.lex_state = 61, .external_lex_state = 29},
  [5823] = {.lex_state = 61, .external_lex_state = 29},
  [5824] = {.lex_state = 61, .external_lex_state = 24},
  [5825] = {.lex_state = 56, .external_lex_state = 178},
  [5826] = {.lex_state = 61, .external_lex_state = 29},
  [5827] = {.lex_state = 61, .external_lex_state = 28},
  [5828] = {.lex_state = 61, .external_lex_state = 28},
  [5829] = {.lex_state = 61, .external_lex_state = 27},
  [5830] = {.lex_state = 61, .external_lex_state = 29},
  [5831] = {.lex_state = 61, .external_lex_state = 27},
  [5832] = {.lex_state = 61, .external_lex_state = 10},
  [5833] = {.lex_state = 61, .external_lex_state = 26},
  [5834] = {.lex_state = 61, .external_lex_state = 27},
  [5835] = {.lex_state = 61, .external_lex_state = 29},
  [5836] = {.lex_state = 61, .external_lex_state = 28},
  [5837] = {.lex_state = 61, .external_lex_state = 28},
  [5838] = {.lex_state = 61, .external_lex_state = 29},
  [5839] = {.lex_state = 61, .external_lex_state = 27},
  [5840] = {.lex_state = 61, .external_lex_state = 29},
  [5841] = {.lex_state = 61, .external_lex_state = 25},
  [5842] = {.lex_state = 61, .external_lex_state = 27},
  [5843] = {.lex_state = 61, .external_lex_state = 27},
  [5844] = {.lex_state = 61, .external_lex_state = 29},
  [5845] = {.lex_state = 61, .external_lex_state = 28},
  [5846] = {.lex_state = 61, .external_lex_state = 29},
  [5847] = {.lex_state = 61, .external_lex_state = 27},
  [5848] = {.lex_state = 61, .external_lex_state = 28},
  [5849] = {.lex_state = 61, .external_lex_state = 28},
  [5850] = {.lex_state = 61, .external_lex_state = 29},
  [5851] = {.lex_state = 61, .external_lex_state = 28},
  [5852] = {.lex_state = 61, .external_lex_state = 28},
  [5853] = {.lex_state = 61, .external_lex_state = 28},
  [5854] = {.lex_state = 61, .external_lex_state = 22},
  [5855] = {.lex_state = 61, .external_lex_state = 28},
  [5856] = {.lex_state = 61, .external_lex_state = 28},
  [5857] = {.lex_state = 61, .external_lex_state = 28},
  [5858] = {.lex_state = 61, .external_lex_state = 29},
  [5859] = {.lex_state = 61, .external_lex_state = 28},
  [5860] = {.lex_state = 61, .external_lex_state = 28},
  [5861] = {.lex_state = 61, .external_lex_state = 28},
  [5862] = {.lex_state = 61, .external_lex_state = 28},
  [5863] = {.lex_state = 61, .external_lex_state = 26},
  [5864] = {.lex_state = 61, .external_lex_state = 28},
  [5865] = {.lex_state = 61, .external_lex_state = 28},
  [5866] = {.lex_state = 61, .external_lex_state = 28},
  [5867] = {.lex_state = 55, .external_lex_state = 19},
  [5868] = {.lex_state = 61, .external_lex_state = 25},
  [5869] = {.lex_state = 61, .external_lex_state = 28},
  [5870] = {.lex_state = 61, .external_lex_state = 179},
  [5871] = {.lex_state = 61, .external_lex_state = 26},
  [5872] = {.lex_state = 61, .external_lex_state = 28},
  [5873] = {.lex_state = 61, .external_lex_state = 26},
  [5874] = {.lex_state = 61, .external_lex_state = 26},
  [5875] = {.lex_state = 61, .external_lex_state = 28},
  [5876] = {.lex_state = 61, .external_lex_state = 26},
  [5877] = {.lex_state = 61, .external_lex_state = 28},
  [5878] = {.lex_state = 61, .external_lex_state = 180},
  [5879] = {.lex_state = 61, .external_lex_state = 26},
  [5880] = {.lex_state = 61, .external_lex_state = 26},
  [5881] = {.lex_state = 61, .external_lex_state = 28},
  [5882] = {.lex_state = 61, .external_lex_state = 28},
  [5883] = {.lex_state = 61, .external_lex_state = 26},
  [5884] = {.lex_state = 61, .external_lex_state = 28},
  [5885] = {.lex_state = 61, .external_lex_state = 26},
  [5886] = {.lex_state = 61, .external_lex_state = 26},
  [5887] = {.lex_state = 55, .external_lex_state = 25},
  [5888] = {.lex_state = 61, .external_lex_state = 27},
  [5889] = {.lex_state = 55, .external_lex_state = 28},
  [5890] = {.lex_state = 61, .external_lex_state = 31},
  [5891] = {.lex_state = 55, .external_lex_state = 25},
  [5892] = {.lex_state = 55, .external_lex_state = 28},
  [5893] = {.lex_state = 55, .external_lex_state = 28},
  [5894] = {.lex_state = 55, .external_lex_state = 28},
  [5895] = {.lex_state = 55, .external_lex_state = 26},
  [5896] = {.lex_state = 61, .external_lex_state = 31},
  [5897] = {.lex_state = 55, .external_lex_state = 28},
  [5898] = {.lex_state = 55, .external_lex_state = 28},
  [5899] = {.lex_state = 61, .external_lex_state = 31},
  [5900] = {.lex_state = 55, .external_lex_state = 22},
  [5901] = {.lex_state = 55, .external_lex_state = 28},
  [5902] = {.lex_state = 55, .external_lex_state = 28},
  [5903] = {.lex_state = 61, .external_lex_state = 31},
  [5904] = {.lex_state = 55, .external_lex_state = 28},
  [5905] = {.lex_state = 55, .external_lex_state = 28},
  [5906] = {.lex_state = 55, .external_lex_state = 28},
  [5907] = {.lex_state = 56, .external_lex_state = 43},
  [5908] = {.lex_state = 56, .external_lex_state = 43},
  [5909] = {.lex_state = 55, .external_lex_state = 28},
  [5910] = {.lex_state = 55, .external_lex_state = 28},
  [5911] = {.lex_state = 55, .external_lex_state = 28},
  [5912] = {.lex_state = 55, .external_lex_state = 28},
  [5913] = {.lex_state = 55, .external_lex_state = 28},
  [5914] = {.lex_state = 61, .external_lex_state = 33},
  [5915] = {.lex_state = 55, .external_lex_state = 10},
  [5916] = {.lex_state = 61, .external_lex_state = 31},
  [5917] = {.lex_state = 56, .external_lex_state = 44},
  [5918] = {.lex_state = 56, .external_lex_state = 43},
  [5919] = {.lex_state = 61, .external_lex_state = 31},
  [5920] = {.lex_state = 56, .external_lex_state = 43},
  [5921] = {.lex_state = 56, .external_lex_state = 184},
  [5922] = {.lex_state = 56, .external_lex_state = 185},
  [5923] = {.lex_state = 61, .external_lex_state = 31},
  [5924] = {.lex_state = 56, .external_lex_state = 43},
  [5925] = {.lex_state = 56, .external_lex_state = 43},
  [5926] = {.lex_state = 56, .external_lex_state = 43},
  [5927] = {.lex_state = 61, .external_lex_state = 31},
  [5928] = {.lex_state = 56, .external_lex_state = 43},
  [5929] = {.lex_state = 61, .external_lex_state = 31},
  [5930] = {.lex_state = 56, .external_lex_state = 43},
  [5931] = {.lex_state = 56, .external_lex_state = 44},
  [5932] = {.lex_state = 61, .external_lex_state = 31},
  [5933] = {.lex_state = 56, .external_lex_state = 43},
  [5934] = {.lex_state = 56, .external_lex_state = 43},
  [5935] = {.lex_state = 56, .external_lex_state = 43},
  [5936] = {.lex_state = 61, .external_lex_state = 31},
  [5937] = {.lex_state = 56, .external_lex_state = 186},
  [5938] = {.lex_state = 56, .external_lex_state = 187},
  [5939] = {.lex_state = 61, .external_lex_state = 31},
  [5940] = {.lex_state = 56, .external_lex_state = 44},
  [5941] = {.lex_state = 61, .external_lex_state = 33},
  [5942] = {.lex_state = 61, .external_lex_state = 31},
  [5943] = {.lex_state = 61, .external_lex_state = 31},
  [5944] = {.lex_state = 61, .external_lex_state = 31},
  [5945] = {.lex_state = 61, .external_lex_state = 33},
  [5946] = {.lex_state = 61, .external_lex_state = 33},
  [5947] = {.lex_state = 61, .external_lex_state = 31},
  [5948] = {.lex_state = 56, .external_lex_state = 188},
  [5949] = {.lex_state = 56, .external_lex_state = 43},
  [5950] = {.lex_state = 61, .external_lex_state = 32},
  [5951] = {.lex_state = 56, .external_lex_state = 44},
  [5952] = {.lex_state = 61, .external_lex_state = 31},
  [5953] = {.lex_state = 56, .external_lex_state = 44},
  [5954] = {.lex_state = 56, .external_lex_state = 187},
  [5955] = {.lex_state = 56, .external_lex_state = 43},
  [5956] = {.lex_state = 61, .external_lex_state = 31},
  [5957] = {.lex_state = 61, .external_lex_state = 31},
  [5958] = {.lex_state = 56, .external_lex_state = 43},
  [5959] = {.lex_state = 56, .external_lex_state = 44},
  [5960] = {.lex_state = 56, .external_lex_state = 43},
  [5961] = {.lex_state = 56, .external_lex_state = 43},
  [5962] = {.lex_state = 61, .external_lex_state = 32},
  [5963] = {.lex_state = 61, .external_lex_state = 31},
  [5964] = {.lex_state = 61, .external_lex_state = 31},
  [5965] = {.lex_state = 56, .external_lex_state = 185},
  [5966] = {.lex_state = 61, .external_lex_state = 33},
  [5967] = {.lex_state = 61, .external_lex_state = 31},
  [5968] = {.lex_state = 55, .external_lex_state = 25},
  [5969] = {.lex_state = 61, .external_lex_state = 31},
  [5970] = {.lex_state = 61, .external_lex_state = 27},
  [5971] = {.lex_state = 56, .external_lex_state = 184},
  [5972] = {.lex_state = 55, .external_lex_state = 22},
  [5973] = {.lex_state = 55, .external_lex_state = 22},
  [5974] = {.lex_state = 55, .external_lex_state = 24},
  [5975] = {.lex_state = 55, .external_lex_state = 24},
  [5976] = {.lex_state = 55, .external_lex_state = 22},
  [5977] = {.lex_state = 56, .external_lex_state = 185},
  [5978] = {.lex_state = 61, .external_lex_state = 32},
  [5979] = {.lex_state = 55, .external_lex_state = 26},
  [5980] = {.lex_state = 55, .external_lex_state = 25},
  [5981] = {.lex_state = 55, .external_lex_state = 22},
  [5982] = {.lex_state = 55, .external_lex_state = 26},
  [5983] = {.lex_state = 55, .external_lex_state = 22},
  [5984] = {.lex_state = 61, .external_lex_state = 32},
  [5985] = {.lex_state = 55, .external_lex_state = 24},
  [5986] = {.lex_state = 61, .external_lex_state = 31},
  [5987] = {.lex_state = 55, .external_lex_state = 26},
  [5988] = {.lex_state = 55, .external_lex_state = 22},
  [5989] = {.lex_state = 55, .external_lex_state = 26},
  [5990] = {.lex_state = 56, .external_lex_state = 184},
  [5991] = {.lex_state = 55, .external_lex_state = 26},
  [5992] = {.lex_state = 61, .external_lex_state = 32},
  [5993] = {.lex_state = 61, .external_lex_state = 32},
  [5994] = {.lex_state = 55, .external_lex_state = 26},
  [5995] = {.lex_state = 56, .external_lex_state = 185},
  [5996] = {.lex_state = 55, .external_lex_state = 26},
  [5997] = {.lex_state = 55, .external_lex_state = 26},
  [5998] = {.lex_state = 55, .external_lex_state = 26},
  [5999] = {.lex_state = 56, .external_lex_state = 185},
  [6000] = {.lex_state = 55, .external_lex_state = 26},
  [6001] = {.lex_state = 61, .external_lex_state = 27},
  [6002] = {.lex_state = 55, .external_lex_state = 26},
  [6003] = {.lex_state = 55, .external_lex_state = 26},
  [6004] = {.lex_state = 55, .external_lex_state = 26},
  [6005] = {.lex_state = 55, .external_lex_state = 26},
  [6006] = {.lex_state = 55, .external_lex_state = 26},
  [6007] = {.lex_state = 55, .external_lex_state = 26},
  [6008] = {.lex_state = 61, .external_lex_state = 32},
  [6009] = {.lex_state = 61, .external_lex_state = 33},
  [6010] = {.lex_state = 56, .external_lex_state = 43},
  [6011] = {.lex_state = 61, .external_lex_state = 31},
  [6012] = {.lex_state = 61, .external_lex_state = 31},
  [6013] = {.lex_state = 55, .external_lex_state = 24},
  [6014] = {.lex_state = 55, .external_lex_state = 24},
  [6015] = {.lex_state = 61, .external_lex_state = 32},
  [6016] = {.lex_state = 56, .external_lex_state = 186},
  [6017] = {.lex_state = 55, .external_lex_state = 24},
  [6018] = {.lex_state = 56, .external_lex_state = 43},
  [6019] = {.lex_state = 61, .external_lex_state = 33},
  [6020] = {.lex_state = 55, .external_lex_state = 22},
  [6021] = {.lex_state = 56, .external_lex_state = 186},
  [6022] = {.lex_state = 55, .external_lex_state = 24},
  [6023] = {.lex_state = 61, .external_lex_state = 32},
  [6024] = {.lex_state = 61, .external_lex_state = 31},
  [6025] = {.lex_state = 61, .external_lex_state = 33},
  [6026] = {.lex_state = 56, .external_lex_state = 43},
  [6027] = {.lex_state = 55, .external_lex_state = 22},
  [6028] = {.lex_state = 56, .external_lex_state = 43},
  [6029] = {.lex_state = 56, .external_lex_state = 187},
  [6030] = {.lex_state = 55, .external_lex_state = 24},
  [6031] = {.lex_state = 55, .external_lex_state = 24},
  [6032] = {.lex_state = 55, .external_lex_state = 24},
  [6033] = {.lex_state = 61, .external_lex_state = 32},
  [6034] = {.lex_state = 56, .external_lex_state = 43},
  [6035] = {.lex_state = 61, .external_lex_state = 32},
  [6036] = {.lex_state = 56, .external_lex_state = 43},
  [6037] = {.lex_state = 61, .external_lex_state = 32},
  [6038] = {.lex_state = 61, .external_lex_state = 32},
  [6039] = {.lex_state = 55, .external_lex_state = 24},
  [6040] = {.lex_state = 55, .external_lex_state = 24},
  [6041] = {.lex_state = 55, .external_lex_state = 24},
  [6042] = {.lex_state = 56, .external_lex_state = 43},
  [6043] = {.lex_state = 61, .external_lex_state = 32},
  [6044] = {.lex_state = 55, .external_lex_state = 24},
  [6045] = {.lex_state = 55, .external_lex_state = 24},
  [6046] = {.lex_state = 55, .external_lex_state = 24},
  [6047] = {.lex_state = 55, .external_lex_state = 24},
  [6048] = {.lex_state = 55, .external_lex_state = 24},
  [6049] = {.lex_state = 61, .external_lex_state = 33},
  [6050] = {.lex_state = 56, .external_lex_state = 43},
  [6051] = {.lex_state = 56, .external_lex_state = 43},
  [6052] = {.lex_state = 61, .external_lex_state = 31},
  [6053] = {.lex_state = 56, .external_lex_state = 186},
  [6054] = {.lex_state = 56, .external_lex_state = 44},
  [6055] = {.lex_state = 56, .external_lex_state = 43},
  [6056] = {.lex_state = 61, .external_lex_state = 32},
  [6057] = {.lex_state = 61, .external_lex_state = 31},
  [6058] = {.lex_state = 61, .external_lex_state = 32},
  [6059] = {.lex_state = 61, .external_lex_state = 33},
  [6060] = {.lex_state = 61, .external_lex_state = 32},
  [6061] = {.lex_state = 61, .external_lex_state = 31},
  [6062] = {.lex_state = 56, .external_lex_state = 189},
  [6063] = {.lex_state = 61, .external_lex_state = 32},
  [6064] = {.lex_state = 61, .external_lex_state = 32},
  [6065] = {.lex_state = 55, .external_lex_state = 22},
  [6066] = {.lex_state = 55, .external_lex_state = 22},
  [6067] = {.lex_state = 56, .external_lex_state = 43},
  [6068] = {.lex_state = 56, .external_lex_state = 189},
  [6069] = {.lex_state = 61, .external_lex_state = 32},
  [6070] = {.lex_state = 61, .external_lex_state = 32},
  [6071] = {.lex_state = 61, .external_lex_state = 33},
  [6072] = {.lex_state = 56, .external_lex_state = 188},
  [6073] = {.lex_state = 55, .external_lex_state = 22},
  [6074] = {.lex_state = 61, .external_lex_state = 32},
  [6075] = {.lex_state = 61, .external_lex_state = 32},
  [6076] = {.lex_state = 61, .external_lex_state = 32},
  [6077] = {.lex_state = 55, .external_lex_state = 9},
  [6078] = {.lex_state = 61, .external_lex_state = 32},
  [6079] = {.lex_state = 56, .external_lex_state = 185},
  [6080] = {.lex_state = 55, .external_lex_state = 25},
  [6081] = {.lex_state = 61, .external_lex_state = 33},
  [6082] = {.lex_state = 61, .external_lex_state = 32},
  [6083] = {.lex_state = 56, .external_lex_state = 186},
  [6084] = {.lex_state = 61, .external_lex_state = 33},
  [6085] = {.lex_state = 61, .external_lex_state = 33},
  [6086] = {.lex_state = 61, .external_lex_state = 32},
  [6087] = {.lex_state = 56, .external_lex_state = 44},
  [6088] = {.lex_state = 56, .external_lex_state = 188},
  [6089] = {.lex_state = 61, .external_lex_state = 32},
  [6090] = {.lex_state = 61, .external_lex_state = 32},
  [6091] = {.lex_state = 55, .external_lex_state = 25},
  [6092] = {.lex_state = 61, .external_lex_state = 33},
  [6093] = {.lex_state = 55, .external_lex_state = 26},
  [6094] = {.lex_state = 61, .external_lex_state = 31},
  [6095] = {.lex_state = 55, .external_lex_state = 23},
  [6096] = {.lex_state = 56, .external_lex_state = 44},
  [6097] = {.lex_state = 61, .external_lex_state = 33},
  [6098] = {.lex_state = 55, .external_lex_state = 25},
  [6099] = {.lex_state = 55, .external_lex_state = 25},
  [6100] = {.lex_state = 55, .external_lex_state = 25},
  [6101] = {.lex_state = 56, .external_lex_state = 186},
  [6102] = {.lex_state = 56, .external_lex_state = 44},
  [6103] = {.lex_state = 56, .external_lex_state = 44},
  [6104] = {.lex_state = 55, .external_lex_state = 25},
  [6105] = {.lex_state = 55, .external_lex_state = 22},
  [6106] = {.lex_state = 55, .external_lex_state = 25},
  [6107] = {.lex_state = 61, .external_lex_state = 27},
  [6108] = {.lex_state = 55, .external_lex_state = 25},
  [6109] = {.lex_state = 61, .external_lex_state = 33},
  [6110] = {.lex_state = 61, .external_lex_state = 33},
  [6111] = {.lex_state = 61, .external_lex_state = 33},
  [6112] = {.lex_state = 61, .external_lex_state = 27},
  [6113] = {.lex_state = 61, .external_lex_state = 33},
  [6114] = {.lex_state = 61, .external_lex_state = 33},
  [6115] = {.lex_state = 55, .external_lex_state = 22},
  [6116] = {.lex_state = 55, .external_lex_state = 25},
  [6117] = {.lex_state = 61, .external_lex_state = 33},
  [6118] = {.lex_state = 55, .external_lex_state = 22},
  [6119] = {.lex_state = 56, .external_lex_state = 44},
  [6120] = {.lex_state = 56, .external_lex_state = 44},
  [6121] = {.lex_state = 61, .external_lex_state = 33},
  [6122] = {.lex_state = 61, .external_lex_state = 33},
  [6123] = {.lex_state = 61, .external_lex_state = 33},
  [6124] = {.lex_state = 55, .external_lex_state = 25},
  [6125] = {.lex_state = 56, .external_lex_state = 44},
  [6126] = {.lex_state = 61, .external_lex_state = 33},
  [6127] = {.lex_state = 61, .external_lex_state = 33},
  [6128] = {.lex_state = 61, .external_lex_state = 33},
  [6129] = {.lex_state = 61, .external_lex_state = 33},
  [6130] = {.lex_state = 61, .external_lex_state = 27},
  [6131] = {.lex_state = 61, .external_lex_state = 33},
  [6132] = {.lex_state = 61, .external_lex_state = 33},
  [6133] = {.lex_state = 61, .external_lex_state = 33},
  [6134] = {.lex_state = 56, .external_lex_state = 189},
  [6135] = {.lex_state = 61, .external_lex_state = 33},
  [6136] = {.lex_state = 61, .external_lex_state = 33},
  [6137] = {.lex_state = 61, .external_lex_state = 33},
  [6138] = {.lex_state = 61, .external_lex_state = 33},
  [6139] = {.lex_state = 56, .external_lex_state = 44},
  [6140] = {.lex_state = 56, .external_lex_state = 44},
  [6141] = {.lex_state = 61, .external_lex_state = 33},
  [6142] = {.lex_state = 55, .external_lex_state = 25},
  [6143] = {.lex_state = 56, .external_lex_state = 188},
  [6144] = {.lex_state = 55, .external_lex_state = 25},
  [6145] = {.lex_state = 55, .external_lex_state = 25},
  [6146] = {.lex_state = 56, .external_lex_state = 43},
  [6147] = {.lex_state = 56, .external_lex_state = 43},
  [6148] = {.lex_state = 56, .external_lex_state = 43},
  [6149] = {.lex_state = 61, .external_lex_state = 31},
  [6150] = {.lex_state = 61, .external_lex_state = 33},
  [6151] = {.lex_state = 61, .external_lex_state = 33},
  [6152] = {.lex_state = 61, .external_lex_state = 31},
  [6153] = {.lex_state = 61, .external_lex_state = 33},
  [6154] = {.lex_state = 61, .external_lex_state = 31},
  [6155] = {.lex_state = 56, .external_lex_state = 44},
  [6156] = {.lex_state = 61, .external_lex_state = 33},
  [6157] = {.lex_state = 61, .external_lex_state = 33},
  [6158] = {.lex_state = 61, .external_lex_state = 33},
  [6159] = {.lex_state = 61, .external_lex_state = 33},
  [6160] = {.lex_state = 61, .external_lex_state = 31},
  [6161] = {.lex_state = 55, .external_lex_state = 25},
  [6162] = {.lex_state = 61, .external_lex_state = 31},
  [6163] = {.lex_state = 56, .external_lex_state = 44},
  [6164] = {.lex_state = 56, .external_lex_state = 43},
  [6165] = {.lex_state = 56, .external_lex_state = 44},
  [6166] = {.lex_state = 56, .external_lex_state = 44},
  [6167] = {.lex_state = 55, .external_lex_state = 8},
  [6168] = {.lex_state = 61, .external_lex_state = 33},
  [6169] = {.lex_state = 61, .external_lex_state = 31},
  [6170] = {.lex_state = 61, .external_lex_state = 33},
  [6171] = {.lex_state = 61, .external_lex_state = 33},
  [6172] = {.lex_state = 61, .external_lex_state = 33},
  [6173] = {.lex_state = 61, .external_lex_state = 33},
  [6174] = {.lex_state = 61, .external_lex_state = 27},
  [6175] = {.lex_state = 61, .external_lex_state = 27},
  [6176] = {.lex_state = 61, .external_lex_state = 27},
  [6177] = {.lex_state = 61, .external_lex_state = 33},
  [6178] = {.lex_state = 61, .external_lex_state = 33},
  [6179] = {.lex_state = 55, .external_lex_state = 25},
  [6180] = {.lex_state = 56, .external_lex_state = 44},
  [6181] = {.lex_state = 55, .external_lex_state = 25},
  [6182] = {.lex_state = 61, .external_lex_state = 31},
  [6183] = {.lex_state = 61, .external_lex_state = 31},
  [6184] = {.lex_state = 61, .external_lex_state = 31},
  [6185] = {.lex_state = 56, .external_lex_state = 43},
  [6186] = {.lex_state = 61, .external_lex_state = 27},
  [6187] = {.lex_state = 61, .external_lex_state = 31},
  [6188] = {.lex_state = 61, .external_lex_state = 31},
  [6189] = {.lex_state = 56, .external_lex_state = 43},
  [6190] = {.lex_state = 61, .external_lex_state = 33},
  [6191] = {.lex_state = 61, .external_lex_state = 27},
  [6192] = {.lex_state = 61, .external_lex_state = 31},
  [6193] = {.lex_state = 61, .external_lex_state = 33},
  [6194] = {.lex_state = 61, .external_lex_state = 31},
  [6195] = {.lex_state = 61, .external_lex_state = 33},
  [6196] = {.lex_state = 61, .external_lex_state = 31},
  [6197] = {.lex_state = 61, .external_lex_state = 31},
  [6198] = {.lex_state = 61, .external_lex_state = 33},
  [6199] = {.lex_state = 61, .external_lex_state = 33},
  [6200] = {.lex_state = 61, .external_lex_state = 31},
  [6201] = {.lex_state = 61, .external_lex_state = 33},
  [6202] = {.lex_state = 61, .external_lex_state = 33},
  [6203] = {.lex_state = 61, .external_lex_state = 31},
  [6204] = {.lex_state = 61, .external_lex_state = 31},
  [6205] = {.lex_state = 56, .external_lex_state = 44},
  [6206] = {.lex_state = 61, .external_lex_state = 33},
  [6207] = {.lex_state = 61, .external_lex_state = 33},
  [6208] = {.lex_state = 61, .external_lex_state = 31},
  [6209] = {.lex_state = 61, .external_lex_state = 31},
  [6210] = {.lex_state = 61, .external_lex_state = 31},
  [6211] = {.lex_state = 61, .external_lex_state = 27},
  [6212] = {.lex_state = 55, .external_lex_state = 190},
  [6213] = {.lex_state = 61, .external_lex_state = 31},
  [6214] = {.lex_state = 61, .external_lex_state = 31},
  [6215] = {.lex_state = 55, .external_lex_state = 29},
  [6216] = {.lex_state = 61, .external_lex_state = 33},
  [6217] = {.lex_state = 61, .external_lex_state = 31},
  [6218] = {.lex_state = 56, .external_lex_state = 43},
  [6219] = {.lex_state = 61, .external_lex_state = 33},
  [6220] = {.lex_state = 61, .external_lex_state = 31},
  [6221] = {.lex_state = 61, .external_lex_state = 33},
  [6222] = {.lex_state = 61, .external_lex_state = 33},
  [6223] = {.lex_state = 55, .external_lex_state = 23},
  [6224] = {.lex_state = 55, .external_lex_state = 23},
  [6225] = {.lex_state = 56, .external_lex_state = 43},
  [6226] = {.lex_state = 61, .external_lex_state = 27},
  [6227] = {.lex_state = 55, .external_lex_state = 23},
  [6228] = {.lex_state = 55, .external_lex_state = 23},
  [6229] = {.lex_state = 55, .external_lex_state = 23},
  [6230] = {.lex_state = 55, .external_lex_state = 23},
  [6231] = {.lex_state = 61, .external_lex_state = 27},
  [6232] = {.lex_state = 55, .external_lex_state = 23},
  [6233] = {.lex_state = 55, .external_lex_state = 23},
  [6234] = {.lex_state = 55, .external_lex_state = 23},
  [6235] = {.lex_state = 56, .external_lex_state = 44},
  [6236] = {.lex_state = 55, .external_lex_state = 28},
  [6237] = {.lex_state = 55, .external_lex_state = 23},
  [6238] = {.lex_state = 55, .external_lex_state = 23},
  [6239] = {.lex_state = 61, .external_lex_state = 31},
  [6240] = {.lex_state = 61, .external_lex_state = 31},
  [6241] = {.lex_state = 55, .external_lex_state = 23},
  [6242] = {.lex_state = 55, .external_lex_state = 23},
  [6243] = {.lex_state = 55, .external_lex_state = 22},
  [6244] = {.lex_state = 61, .external_lex_state = 27},
  [6245] = {.lex_state = 56, .external_lex_state = 187},
  [6246] = {.lex_state = 61, .external_lex_state = 27},
  [6247] = {.lex_state = 61, .external_lex_state = 27},
  [6248] = {.lex_state = 56, .external_lex_state = 44},
  [6249] = {.lex_state = 56, .external_lex_state = 44},
  [6250] = {.lex_state = 61, .external_lex_state = 27},
  [6251] = {.lex_state = 55, .external_lex_state = 29},
  [6252] = {.lex_state = 61, .external_lex_state = 31},
  [6253] = {.lex_state = 55, .external_lex_state = 29},
  [6254] = {.lex_state = 61, .external_lex_state = 31},
  [6255] = {.lex_state = 55, .external_lex_state = 23},
  [6256] = {.lex_state = 56, .external_lex_state = 184},
  [6257] = {.lex_state = 55, .external_lex_state = 29},
  [6258] = {.lex_state = 56, .external_lex_state = 189},
  [6259] = {.lex_state = 55, .external_lex_state = 22},
  [6260] = {.lex_state = 55, .external_lex_state = 22},
  [6261] = {.lex_state = 61, .external_lex_state = 31},
  [6262] = {.lex_state = 55, .external_lex_state = 34},
  [6263] = {.lex_state = 55, .external_lex_state = 23},
  [6264] = {.lex_state = 55, .external_lex_state = 23},
  [6265] = {.lex_state = 61, .external_lex_state = 31},
  [6266] = {.lex_state = 56, .external_lex_state = 189},
  [6267] = {.lex_state = 56, .external_lex_state = 44},
  [6268] = {.lex_state = 56, .external_lex_state = 44},
  [6269] = {.lex_state = 55, .external_lex_state = 29},
  [6270] = {.lex_state = 56, .external_lex_state = 44},
  [6271] = {.lex_state = 55, .external_lex_state = 29},
  [6272] = {.lex_state = 56, .external_lex_state = 187},
  [6273] = {.lex_state = 55, .external_lex_state = 29},
  [6274] = {.lex_state = 56, .external_lex_state = 188},
  [6275] = {.lex_state = 56, .external_lex_state = 44},
  [6276] = {.lex_state = 55, .external_lex_state = 29},
  [6277] = {.lex_state = 56, .external_lex_state = 44},
  [6278] = {.lex_state = 55, .external_lex_state = 29},
  [6279] = {.lex_state = 56, .external_lex_state = 44},
  [6280] = {.lex_state = 56, .external_lex_state = 184},
  [6281] = {.lex_state = 55, .external_lex_state = 29},
  [6282] = {.lex_state = 55, .external_lex_state = 29},
  [6283] = {.lex_state = 56, .external_lex_state = 188},
  [6284] = {.lex_state = 56, .external_lex_state = 44},
  [6285] = {.lex_state = 55, .external_lex_state = 29},
  [6286] = {.lex_state = 61, .external_lex_state = 31},
  [6287] = {.lex_state = 56, .external_lex_state = 44},
  [6288] = {.lex_state = 55, .external_lex_state = 29},
  [6289] = {.lex_state = 55, .external_lex_state = 29},
  [6290] = {.lex_state = 56, .external_lex_state = 184},
  [6291] = {.lex_state = 55, .external_lex_state = 29},
  [6292] = {.lex_state = 55, .external_lex_state = 29},
  [6293] = {.lex_state = 55, .external_lex_state = 28},
  [6294] = {.lex_state = 55, .external_lex_state = 29},
  [6295] = {.lex_state = 55, .external_lex_state = 29},
  [6296] = {.lex_state = 56, .external_lex_state = 187},
  [6297] = {.lex_state = 56, .external_lex_state = 44},
  [6298] = {.lex_state = 61, .external_lex_state = 31},
  [6299] = {.lex_state = 56, .external_lex_state = 44},
  [6300] = {.lex_state = 56, .external_lex_state = 44},
  [6301] = {.lex_state = 55, .external_lex_state = 23},
  [6302] = {.lex_state = 56, .external_lex_state = 189},
  [6303] = {.lex_state = 55, .external_lex_state = 32},
  [6304] = {.lex_state = 56, .external_lex_state = 191},
  [6305] = {.lex_state = 56, .external_lex_state = 50},
  [6306] = {.lex_state = 56, .external_lex_state = 50},
  [6307] = {.lex_state = 56, .external_lex_state = 50},
  [6308] = {.lex_state = 56, .external_lex_state = 50},
  [6309] = {.lex_state = 56, .external_lex_state = 46},
  [6310] = {.lex_state = 56, .external_lex_state = 50},
  [6311] = {.lex_state = 56, .external_lex_state = 46},
  [6312] = {.lex_state = 56, .external_lex_state = 50},
  [6313] = {.lex_state = 56, .external_lex_state = 47},
  [6314] = {.lex_state = 56, .external_lex_state = 47},
  [6315] = {.lex_state = 56, .external_lex_state = 50},
  [6316] = {.lex_state = 56, .external_lex_state = 50},
  [6317] = {.lex_state = 61, .external_lex_state = 34},
  [6318] = {.lex_state = 61, .external_lex_state = 34},
  [6319] = {.lex_state = 56, .external_lex_state = 47},
  [6320] = {.lex_state = 56, .external_lex_state = 47},
  [6321] = {.lex_state = 56, .external_lex_state = 50},
  [6322] = {.lex_state = 56, .external_lex_state = 50},
  [6323] = {.lex_state = 56, .external_lex_state = 192},
  [6324] = {.lex_state = 56, .external_lex_state = 46},
  [6325] = {.lex_state = 56, .external_lex_state = 46},
  [6326] = {.lex_state = 56, .external_lex_state = 47},
  [6327] = {.lex_state = 56, .external_lex_state = 47},
  [6328] = {.lex_state = 56, .external_lex_state = 50},
  [6329] = {.lex_state = 56, .external_lex_state = 47},
  [6330] = {.lex_state = 61, .external_lex_state = 34},
  [6331] = {.lex_state = 56, .external_lex_state = 47},
  [6332] = {.lex_state = 56, .external_lex_state = 47},
  [6333] = {.lex_state = 56, .external_lex_state = 50},
  [6334] = {.lex_state = 56, .external_lex_state = 47},
  [6335] = {.lex_state = 56, .external_lex_state = 46},
  [6336] = {.lex_state = 56, .external_lex_state = 47},
  [6337] = {.lex_state = 56, .external_lex_state = 50},
  [6338] = {.lex_state = 56, .external_lex_state = 47},
  [6339] = {.lex_state = 56, .external_lex_state = 50},
  [6340] = {.lex_state = 61, .external_lex_state = 34},
  [6341] = {.lex_state = 55, .external_lex_state = 31},
  [6342] = {.lex_state = 56, .external_lex_state = 193},
  [6343] = {.lex_state = 56, .external_lex_state = 47},
  [6344] = {.lex_state = 56, .external_lex_state = 46},
  [6345] = {.lex_state = 56, .external_lex_state = 45},
  [6346] = {.lex_state = 61, .external_lex_state = 34},
  [6347] = {.lex_state = 56, .external_lex_state = 46},
  [6348] = {.lex_state = 56, .external_lex_state = 47},
  [6349] = {.lex_state = 56, .external_lex_state = 47},
  [6350] = {.lex_state = 56, .external_lex_state = 50},
  [6351] = {.lex_state = 56, .external_lex_state = 192},
  [6352] = {.lex_state = 56, .external_lex_state = 46},
  [6353] = {.lex_state = 56, .external_lex_state = 46},
  [6354] = {.lex_state = 56, .external_lex_state = 47},
  [6355] = {.lex_state = 56, .external_lex_state = 50},
  [6356] = {.lex_state = 56, .external_lex_state = 46},
  [6357] = {.lex_state = 56, .external_lex_state = 46},
  [6358] = {.lex_state = 56, .external_lex_state = 50},
  [6359] = {.lex_state = 61, .external_lex_state = 34},
  [6360] = {.lex_state = 56, .external_lex_state = 46},
  [6361] = {.lex_state = 56, .external_lex_state = 46},
  [6362] = {.lex_state = 56, .external_lex_state = 50},
  [6363] = {.lex_state = 56, .external_lex_state = 50},
  [6364] = {.lex_state = 61, .external_lex_state = 34},
  [6365] = {.lex_state = 56, .external_lex_state = 193},
  [6366] = {.lex_state = 56, .external_lex_state = 47},
  [6367] = {.lex_state = 61, .external_lex_state = 34},
  [6368] = {.lex_state = 56, .external_lex_state = 49},
  [6369] = {.lex_state = 56, .external_lex_state = 46},
  [6370] = {.lex_state = 56, .external_lex_state = 46},
  [6371] = {.lex_state = 56, .external_lex_state = 46},
  [6372] = {.lex_state = 56, .external_lex_state = 46},
  [6373] = {.lex_state = 61, .external_lex_state = 34},
  [6374] = {.lex_state = 56, .external_lex_state = 50},
  [6375] = {.lex_state = 56, .external_lex_state = 50},
  [6376] = {.lex_state = 56, .external_lex_state = 50},
  [6377] = {.lex_state = 56, .external_lex_state = 50},
  [6378] = {.lex_state = 61, .external_lex_state = 34},
  [6379] = {.lex_state = 56, .external_lex_state = 48},
  [6380] = {.lex_state = 56, .external_lex_state = 48},
  [6381] = {.lex_state = 56, .external_lex_state = 194},
  [6382] = {.lex_state = 55, .external_lex_state = 31},
  [6383] = {.lex_state = 56, .external_lex_state = 45},
  [6384] = {.lex_state = 56, .external_lex_state = 50},
  [6385] = {.lex_state = 56, .external_lex_state = 48},
  [6386] = {.lex_state = 56, .external_lex_state = 46},
  [6387] = {.lex_state = 56, .external_lex_state = 50},
  [6388] = {.lex_state = 56, .external_lex_state = 195},
  [6389] = {.lex_state = 56, .external_lex_state = 48},
  [6390] = {.lex_state = 56, .external_lex_state = 50},
  [6391] = {.lex_state = 56, .external_lex_state = 50},
  [6392] = {.lex_state = 56, .external_lex_state = 48},
  [6393] = {.lex_state = 56, .external_lex_state = 50},
  [6394] = {.lex_state = 56, .external_lex_state = 49},
  [6395] = {.lex_state = 56, .external_lex_state = 49},
  [6396] = {.lex_state = 56, .external_lex_state = 47},
  [6397] = {.lex_state = 56, .external_lex_state = 50},
  [6398] = {.lex_state = 55, .external_lex_state = 31},
  [6399] = {.lex_state = 56, .external_lex_state = 48},
  [6400] = {.lex_state = 56, .external_lex_state = 49},
  [6401] = {.lex_state = 56, .external_lex_state = 46},
  [6402] = {.lex_state = 56, .external_lex_state = 193},
  [6403] = {.lex_state = 56, .external_lex_state = 48},
  [6404] = {.lex_state = 56, .external_lex_state = 49},
  [6405] = {.lex_state = 56, .external_lex_state = 48},
  [6406] = {.lex_state = 56, .external_lex_state = 48},
  [6407] = {.lex_state = 55, .external_lex_state = 33},
  [6408] = {.lex_state = 55, .external_lex_state = 33},
  [6409] = {.lex_state = 55, .external_lex_state = 33},
  [6410] = {.lex_state = 56, .external_lex_state = 48},
  [6411] = {.lex_state = 55, .external_lex_state = 33},
  [6412] = {.lex_state = 55, .external_lex_state = 33},
  [6413] = {.lex_state = 56, .external_lex_state = 196},
  [6414] = {.lex_state = 55, .external_lex_state = 33},
  [6415] = {.lex_state = 56, .external_lex_state = 48},
  [6416] = {.lex_state = 56, .external_lex_state = 48},
  [6417] = {.lex_state = 55, .external_lex_state = 33},
  [6418] = {.lex_state = 55, .external_lex_state = 33},
  [6419] = {.lex_state = 55, .external_lex_state = 33},
  [6420] = {.lex_state = 55, .external_lex_state = 33},
  [6421] = {.lex_state = 55, .external_lex_state = 33},
  [6422] = {.lex_state = 55, .external_lex_state = 31},
  [6423] = {.lex_state = 56, .external_lex_state = 194},
  [6424] = {.lex_state = 56, .external_lex_state = 195},
  [6425] = {.lex_state = 56, .external_lex_state = 48},
  [6426] = {.lex_state = 56, .external_lex_state = 194},
  [6427] = {.lex_state = 56, .external_lex_state = 48},
  [6428] = {.lex_state = 56, .external_lex_state = 49},
  [6429] = {.lex_state = 56, .external_lex_state = 48},
  [6430] = {.lex_state = 56, .external_lex_state = 195},
  [6431] = {.lex_state = 61, .external_lex_state = 34},
  [6432] = {.lex_state = 56, .external_lex_state = 48},
  [6433] = {.lex_state = 56, .external_lex_state = 48},
  [6434] = {.lex_state = 61, .external_lex_state = 34},
  [6435] = {.lex_state = 55, .external_lex_state = 33},
  [6436] = {.lex_state = 55, .external_lex_state = 33},
  [6437] = {.lex_state = 55, .external_lex_state = 33},
  [6438] = {.lex_state = 56, .external_lex_state = 196},
  [6439] = {.lex_state = 56, .external_lex_state = 196},
  [6440] = {.lex_state = 56, .external_lex_state = 49},
  [6441] = {.lex_state = 61, .external_lex_state = 34},
  [6442] = {.lex_state = 61, .external_lex_state = 34},
  [6443] = {.lex_state = 56, .external_lex_state = 48},
  [6444] = {.lex_state = 61, .external_lex_state = 34},
  [6445] = {.lex_state = 61, .external_lex_state = 34},
  [6446] = {.lex_state = 61, .external_lex_state = 34},
  [6447] = {.lex_state = 56, .external_lex_state = 197},
  [6448] = {.lex_state = 61, .external_lex_state = 34},
  [6449] = {.lex_state = 55, .external_lex_state = 33},
  [6450] = {.lex_state = 56, .external_lex_state = 49},
  [6451] = {.lex_state = 56, .external_lex_state = 49},
  [6452] = {.lex_state = 56, .external_lex_state = 49},
  [6453] = {.lex_state = 61, .external_lex_state = 34},
  [6454] = {.lex_state = 55, .external_lex_state = 33},
  [6455] = {.lex_state = 55, .external_lex_state = 33},
  [6456] = {.lex_state = 56, .external_lex_state = 49},
  [6457] = {.lex_state = 56, .external_lex_state = 49},
  [6458] = {.lex_state = 56, .external_lex_state = 49},
  [6459] = {.lex_state = 61, .external_lex_state = 34},
  [6460] = {.lex_state = 56, .external_lex_state = 193},
  [6461] = {.lex_state = 61, .external_lex_state = 34},
  [6462] = {.lex_state = 61, .external_lex_state = 34},
  [6463] = {.lex_state = 61, .external_lex_state = 34},
  [6464] = {.lex_state = 56, .external_lex_state = 49},
  [6465] = {.lex_state = 61, .external_lex_state = 34},
  [6466] = {.lex_state = 61, .external_lex_state = 34},
  [6467] = {.lex_state = 56, .external_lex_state = 198},
  [6468] = {.lex_state = 61, .external_lex_state = 34},
  [6469] = {.lex_state = 61, .external_lex_state = 34},
  [6470] = {.lex_state = 56, .external_lex_state = 198},
  [6471] = {.lex_state = 61, .external_lex_state = 34},
  [6472] = {.lex_state = 56, .external_lex_state = 198},
  [6473] = {.lex_state = 61, .external_lex_state = 34},
  [6474] = {.lex_state = 56, .external_lex_state = 197},
  [6475] = {.lex_state = 56, .external_lex_state = 191},
  [6476] = {.lex_state = 56, .external_lex_state = 199},
  [6477] = {.lex_state = 56, .external_lex_state = 47},
  [6478] = {.lex_state = 56, .external_lex_state = 198},
  [6479] = {.lex_state = 56, .external_lex_state = 49},
  [6480] = {.lex_state = 56, .external_lex_state = 198},
  [6481] = {.lex_state = 56, .external_lex_state = 45},
  [6482] = {.lex_state = 55, .external_lex_state = 31},
  [6483] = {.lex_state = 56, .external_lex_state = 47},
  [6484] = {.lex_state = 56, .external_lex_state = 197},
  [6485] = {.lex_state = 57, .external_lex_state = 200},
  [6486] = {.lex_state = 56, .external_lex_state = 48},
  [6487] = {.lex_state = 56, .external_lex_state = 48},
  [6488] = {.lex_state = 56, .external_lex_state = 48},
  [6489] = {.lex_state = 56, .external_lex_state = 48},
  [6490] = {.lex_state = 56, .external_lex_state = 196},
  [6491] = {.lex_state = 56, .external_lex_state = 48},
  [6492] = {.lex_state = 56, .external_lex_state = 191},
  [6493] = {.lex_state = 56, .external_lex_state = 48},
  [6494] = {.lex_state = 56, .external_lex_state = 48},
  [6495] = {.lex_state = 56, .external_lex_state = 48},
  [6496] = {.lex_state = 56, .external_lex_state = 48},
  [6497] = {.lex_state = 56, .external_lex_state = 48},
  [6498] = {.lex_state = 56, .external_lex_state = 194},
  [6499] = {.lex_state = 56, .external_lex_state = 194},
  [6500] = {.lex_state = 56, .external_lex_state = 48},
  [6501] = {.lex_state = 56, .external_lex_state = 48},
  [6502] = {.lex_state = 56, .external_lex_state = 48},
  [6503] = {.lex_state = 55, .external_lex_state = 31},
  [6504] = {.lex_state = 56, .external_lex_state = 48},
  [6505] = {.lex_state = 56, .external_lex_state = 47},
  [6506] = {.lex_state = 55, .external_lex_state = 32},
  [6507] = {.lex_state = 55, .external_lex_state = 32},
  [6508] = {.lex_state = 56, .external_lex_state = 196},
  [6509] = {.lex_state = 56, .external_lex_state = 48},
  [6510] = {.lex_state = 55, .external_lex_state = 31},
  [6511] = {.lex_state = 56, .external_lex_state = 198},
  [6512] = {.lex_state = 55, .external_lex_state = 32},
  [6513] = {.lex_state = 56, .external_lex_state = 47},
  [6514] = {.lex_state = 56, .external_lex_state = 46},
  [6515] = {.lex_state = 56, .external_lex_state = 192},
  [6516] = {.lex_state = 56, .external_lex_state = 191},
  [6517] = {.lex_state = 56, .external_lex_state = 46},
  [6518] = {.lex_state = 56, .external_lex_state = 195},
  [6519] = {.lex_state = 56, .external_lex_state = 192},
  [6520] = {.lex_state = 56, .external_lex_state = 197},
  [6521] = {.lex_state = 55, .external_lex_state = 31},
  [6522] = {.lex_state = 55, .external_lex_state = 32},
  [6523] = {.lex_state = 55, .external_lex_state = 32},
  [6524] = {.lex_state = 55, .external_lex_state = 32},
  [6525] = {.lex_state = 56, .external_lex_state = 49},
  [6526] = {.lex_state = 56, .external_lex_state = 195},
  [6527] = {.lex_state = 56, .external_lex_state = 195},
  [6528] = {.lex_state = 56, .external_lex_state = 49},
  [6529] = {.lex_state = 56, .external_lex_state = 45},
  [6530] = {.lex_state = 56, .external_lex_state = 45},
  [6531] = {.lex_state = 56, .external_lex_state = 49},
  [6532] = {.lex_state = 56, .external_lex_state = 50},
  [6533] = {.lex_state = 56, .external_lex_state = 49},
  [6534] = {.lex_state = 56, .external_lex_state = 45},
  [6535] = {.lex_state = 56, .external_lex_state = 199},
  [6536] = {.lex_state = 56, .external_lex_state = 50},
  [6537] = {.lex_state = 56, .external_lex_state = 49},
  [6538] = {.lex_state = 56, .external_lex_state = 49},
  [6539] = {.lex_state = 56, .external_lex_state = 49},
  [6540] = {.lex_state = 55, .external_lex_state = 31},
  [6541] = {.lex_state = 55, .external_lex_state = 32},
  [6542] = {.lex_state = 56, .external_lex_state = 45},
  [6543] = {.lex_state = 55, .external_lex_state = 32},
  [6544] = {.lex_state = 56, .external_lex_state = 49},
  [6545] = {.lex_state = 56, .external_lex_state = 49},
  [6546] = {.lex_state = 56, .external_lex_state = 49},
  [6547] = {.lex_state = 56, .external_lex_state = 49},
  [6548] = {.lex_state = 56, .external_lex_state = 49},
  [6549] = {.lex_state = 56, .external_lex_state = 46},
  [6550] = {.lex_state = 56, .external_lex_state = 46},
  [6551] = {.lex_state = 55, .external_lex_state = 32},
  [6552] = {.lex_state = 56, .external_lex_state = 49},
  [6553] = {.lex_state = 56, .external_lex_state = 45},
  [6554] = {.lex_state = 56, .external_lex_state = 46},
  [6555] = {.lex_state = 56, .external_lex_state = 45},
  [6556] = {.lex_state = 56, .external_lex_state = 46},
  [6557] = {.lex_state = 56, .external_lex_state = 46},
  [6558] = {.lex_state = 56, .external_lex_state = 48},
  [6559] = {.lex_state = 56, .external_lex_state = 50},
  [6560] = {.lex_state = 56, .external_lex_state = 46},
  [6561] = {.lex_state = 56, .external_lex_state = 49},
  [6562] = {.lex_state = 56, .external_lex_state = 49},
  [6563] = {.lex_state = 56, .external_lex_state = 49},
  [6564] = {.lex_state = 56, .external_lex_state = 49},
  [6565] = {.lex_state = 55, .external_lex_state = 31},
  [6566] = {.lex_state = 56, .external_lex_state = 45},
  [6567] = {.lex_state = 55, .external_lex_state = 31},
  [6568] = {.lex_state = 56, .external_lex_state = 14},
  [6569] = {.lex_state = 56, .external_lex_state = 46},
  [6570] = {.lex_state = 56, .external_lex_state = 45},
  [6571] = {.lex_state = 56, .external_lex_state = 46},
  [6572] = {.lex_state = 56, .external_lex_state = 192},
  [6573] = {.lex_state = 56, .external_lex_state = 49},
  [6574] = {.lex_state = 56, .external_lex_state = 45},
  [6575] = {.lex_state = 56, .external_lex_state = 45},
  [6576] = {.lex_state = 56, .external_lex_state = 45},
  [6577] = {.lex_state = 56, .external_lex_state = 50},
  [6578] = {.lex_state = 56, .external_lex_state = 45},
  [6579] = {.lex_state = 56, .external_lex_state = 46},
  [6580] = {.lex_state = 56, .external_lex_state = 45},
  [6581] = {.lex_state = 56, .external_lex_state = 50},
  [6582] = {.lex_state = 55, .external_lex_state = 31},
  [6583] = {.lex_state = 56, .external_lex_state = 47},
  [6584] = {.lex_state = 56, .external_lex_state = 45},
  [6585] = {.lex_state = 56, .external_lex_state = 45},
  [6586] = {.lex_state = 56, .external_lex_state = 45},
  [6587] = {.lex_state = 56, .external_lex_state = 47},
  [6588] = {.lex_state = 56, .external_lex_state = 45},
  [6589] = {.lex_state = 56, .external_lex_state = 47},
  [6590] = {.lex_state = 56, .external_lex_state = 196},
  [6591] = {.lex_state = 56, .external_lex_state = 49},
  [6592] = {.lex_state = 56, .external_lex_state = 50},
  [6593] = {.lex_state = 56, .external_lex_state = 50},
  [6594] = {.lex_state = 56, .external_lex_state = 45},
  [6595] = {.lex_state = 56, .external_lex_state = 197},
  [6596] = {.lex_state = 55, .external_lex_state = 31},
  [6597] = {.lex_state = 56, .external_lex_state = 45},
  [6598] = {.lex_state = 56, .external_lex_state = 191},
  [6599] = {.lex_state = 56, .external_lex_state = 49},
  [6600] = {.lex_state = 56, .external_lex_state = 46},
  [6601] = {.lex_state = 56, .external_lex_state = 191},
  [6602] = {.lex_state = 56, .external_lex_state = 193},
  [6603] = {.lex_state = 56, .external_lex_state = 45},
  [6604] = {.lex_state = 56, .external_lex_state = 47},
  [6605] = {.lex_state = 55, .external_lex_state = 31},
  [6606] = {.lex_state = 55, .external_lex_state = 31},
  [6607] = {.lex_state = 55, .external_lex_state = 32},
  [6608] = {.lex_state = 56, .external_lex_state = 193},
  [6609] = {.lex_state = 56, .external_lex_state = 47},
  [6610] = {.lex_state = 55, .external_lex_state = 31},
  [6611] = {.lex_state = 56, .external_lex_state = 192},
  [6612] = {.lex_state = 56, .external_lex_state = 45},
  [6613] = {.lex_state = 56, .external_lex_state = 47},
  [6614] = {.lex_state = 56, .external_lex_state = 47},
  [6615] = {.lex_state = 56, .external_lex_state = 45},
  [6616] = {.lex_state = 56, .external_lex_state = 199},
  [6617] = {.lex_state = 56, .external_lex_state = 194},
  [6618] = {.lex_state = 55, .external_lex_state = 32},
  [6619] = {.lex_state = 55, .external_lex_state = 32},
  [6620] = {.lex_state = 56, .external_lex_state = 47},
  [6621] = {.lex_state = 55, .external_lex_state = 32},
  [6622] = {.lex_state = 55, .external_lex_state = 32},
  [6623] = {.lex_state = 55, .external_lex_state = 31},
  [6624] = {.lex_state = 55, .external_lex_state = 32},
  [6625] = {.lex_state = 56, .external_lex_state = 199},
  [6626] = {.lex_state = 55, .external_lex_state = 32},
  [6627] = {.lex_state = 56, .external_lex_state = 199},
  [6628] = {.lex_state = 56, .external_lex_state = 48},
  [6629] = {.lex_state = 56, .external_lex_state = 45},
  [6630] = {.lex_state = 56, .external_lex_state = 47},
  [6631] = {.lex_state = 56, .external_lex_state = 45},
  [6632] = {.lex_state = 56, .external_lex_state = 45},
  [6633] = {.lex_state = 56, .external_lex_state = 47},
  [6634] = {.lex_state = 56, .external_lex_state = 45},
  [6635] = {.lex_state = 56, .external_lex_state = 45},
  [6636] = {.lex_state = 56, .external_lex_state = 47},
  [6637] = {.lex_state = 56, .external_lex_state = 48},
  [6638] = {.lex_state = 56, .external_lex_state = 197},
  [6639] = {.lex_state = 56, .external_lex_state = 45},
  [6640] = {.lex_state = 56, .external_lex_state = 45},
  [6641] = {.lex_state = 56, .external_lex_state = 45},
  [6642] = {.lex_state = 56, .external_lex_state = 45},
  [6643] = {.lex_state = 56, .external_lex_state = 45},
  [6644] = {.lex_state = 55, .external_lex_state = 33},
  [6645] = {.lex_state = 56, .external_lex_state = 46},
  [6646] = {.lex_state = 56, .external_lex_state = 46},
  [6647] = {.lex_state = 56, .external_lex_state = 46},
  [6648] = {.lex_state = 56, .external_lex_state = 47},
  [6649] = {.lex_state = 56, .external_lex_state = 47},
  [6650] = {.lex_state = 56, .external_lex_state = 46},
  [6651] = {.lex_state = 55, .external_lex_state = 31},
  [6652] = {.lex_state = 56, .external_lex_state = 49},
  [6653] = {.lex_state = 56, .external_lex_state = 46},
  [6654] = {.lex_state = 56, .external_lex_state = 199},
  [6655] = {.lex_state = 55, .external_lex_state = 32},
  [6656] = {.lex_state = 56, .external_lex_state = 47},
  [6657] = {.lex_state = 56, .external_lex_state = 45},
  [6658] = {.lex_state = 56, .external_lex_state = 53},
  [6659] = {.lex_state = 56, .external_lex_state = 58},
  [6660] = {.lex_state = 56, .external_lex_state = 201},
  [6661] = {.lex_state = 56, .external_lex_state = 51},
  [6662] = {.lex_state = 56, .external_lex_state = 53},
  [6663] = {.lex_state = 56, .external_lex_state = 58},
  [6664] = {.lex_state = 56, .external_lex_state = 58},
  [6665] = {.lex_state = 56, .external_lex_state = 58},
  [6666] = {.lex_state = 56, .external_lex_state = 58},
  [6667] = {.lex_state = 56, .external_lex_state = 53},
  [6668] = {.lex_state = 56, .external_lex_state = 58},
  [6669] = {.lex_state = 56, .external_lex_state = 58},
  [6670] = {.lex_state = 56, .external_lex_state = 54},
  [6671] = {.lex_state = 56, .external_lex_state = 58},
  [6672] = {.lex_state = 56, .external_lex_state = 58},
  [6673] = {.lex_state = 56, .external_lex_state = 199},
  [6674] = {.lex_state = 56, .external_lex_state = 52},
  [6675] = {.lex_state = 56, .external_lex_state = 57},
  [6676] = {.lex_state = 56, .external_lex_state = 58},
  [6677] = {.lex_state = 56, .external_lex_state = 54},
  [6678] = {.lex_state = 56, .external_lex_state = 56},
  [6679] = {.lex_state = 56, .external_lex_state = 54},
  [6680] = {.lex_state = 56, .external_lex_state = 58},
  [6681] = {.lex_state = 56, .external_lex_state = 55},
  [6682] = {.lex_state = 55, .external_lex_state = 34},
  [6683] = {.lex_state = 56, .external_lex_state = 202},
  [6684] = {.lex_state = 56, .external_lex_state = 57},
  [6685] = {.lex_state = 56, .external_lex_state = 201},
  [6686] = {.lex_state = 56, .external_lex_state = 201},
  [6687] = {.lex_state = 56, .external_lex_state = 51},
  [6688] = {.lex_state = 56, .external_lex_state = 53},
  [6689] = {.lex_state = 56, .external_lex_state = 51},
  [6690] = {.lex_state = 56, .external_lex_state = 54},
  [6691] = {.lex_state = 56, .external_lex_state = 53},
  [6692] = {.lex_state = 56, .external_lex_state = 58},
  [6693] = {.lex_state = 56, .external_lex_state = 56},
  [6694] = {.lex_state = 56, .external_lex_state = 58},
  [6695] = {.lex_state = 56, .external_lex_state = 52},
  [6696] = {.lex_state = 56, .external_lex_state = 201},
  [6697] = {.lex_state = 56, .external_lex_state = 53},
  [6698] = {.lex_state = 56, .external_lex_state = 52},
  [6699] = {.lex_state = 56, .external_lex_state = 52},
  [6700] = {.lex_state = 56, .external_lex_state = 54},
  [6701] = {.lex_state = 56, .external_lex_state = 55},
  [6702] = {.lex_state = 56, .external_lex_state = 52},
  [6703] = {.lex_state = 56, .external_lex_state = 59},
  [6704] = {.lex_state = 56, .external_lex_state = 55},
  [6705] = {.lex_state = 56, .external_lex_state = 55},
  [6706] = {.lex_state = 56, .external_lex_state = 52},
  [6707] = {.lex_state = 56, .external_lex_state = 56},
  [6708] = {.lex_state = 56, .external_lex_state = 52},
  [6709] = {.lex_state = 56, .external_lex_state = 57},
  [6710] = {.lex_state = 56, .external_lex_state = 57},
  [6711] = {.lex_state = 56, .external_lex_state = 52},
  [6712] = {.lex_state = 56, .external_lex_state = 53},
  [6713] = {.lex_state = 56, .external_lex_state = 57},
  [6714] = {.lex_state = 56, .external_lex_state = 57},
  [6715] = {.lex_state = 56, .external_lex_state = 51},
  [6716] = {.lex_state = 56, .external_lex_state = 54},
  [6717] = {.lex_state = 56, .external_lex_state = 52},
  [6718] = {.lex_state = 56, .external_lex_state = 52},
  [6719] = {.lex_state = 56, .external_lex_state = 54},
  [6720] = {.lex_state = 56, .external_lex_state = 202},
  [6721] = {.lex_state = 56, .external_lex_state = 51},
  [6722] = {.lex_state = 56, .external_lex_state = 51},
  [6723] = {.lex_state = 56, .external_lex_state = 51},
  [6724] = {.lex_state = 56, .external_lex_state = 55},
  [6725] = {.lex_state = 56, .external_lex_state = 55},
  [6726] = {.lex_state = 56, .external_lex_state = 51},
  [6727] = {.lex_state = 56, .external_lex_state = 57},
  [6728] = {.lex_state = 56, .external_lex_state = 54},
  [6729] = {.lex_state = 56, .external_lex_state = 51},
  [6730] = {.lex_state = 56, .external_lex_state = 55},
  [6731] = {.lex_state = 56, .external_lex_state = 56},
  [6732] = {.lex_state = 56, .external_lex_state = 56},
  [6733] = {.lex_state = 56, .external_lex_state = 51},
  [6734] = {.lex_state = 56, .external_lex_state = 51},
  [6735] = {.lex_state = 56, .external_lex_state = 56},
  [6736] = {.lex_state = 56, .external_lex_state = 56},
  [6737] = {.lex_state = 56, .external_lex_state = 51},
  [6738] = {.lex_state = 56, .external_lex_state = 55},
  [6739] = {.lex_state = 56, .external_lex_state = 51},
  [6740] = {.lex_state = 56, .external_lex_state = 51},
  [6741] = {.lex_state = 56, .external_lex_state = 55},
  [6742] = {.lex_state = 56, .external_lex_state = 56},
  [6743] = {.lex_state = 56, .external_lex_state = 51},
  [6744] = {.lex_state = 56, .external_lex_state = 51},
  [6745] = {.lex_state = 56, .external_lex_state = 203},
  [6746] = {.lex_state = 56, .external_lex_state = 203},
  [6747] = {.lex_state = 56, .external_lex_state = 55},
  [6748] = {.lex_state = 56, .external_lex_state = 56},
  [6749] = {.lex_state = 56, .external_lex_state = 56},
  [6750] = {.lex_state = 56, .external_lex_state = 58},
  [6751] = {.lex_state = 56, .external_lex_state = 58},
  [6752] = {.lex_state = 56, .external_lex_state = 58},
  [6753] = {.lex_state = 56, .external_lex_state = 51},
  [6754] = {.lex_state = 56, .external_lex_state = 58},
  [6755] = {.lex_state = 56, .external_lex_state = 58},
  [6756] = {.lex_state = 56, .external_lex_state = 58},
  [6757] = {.lex_state = 56, .external_lex_state = 56},
  [6758] = {.lex_state = 56, .external_lex_state = 58},
  [6759] = {.lex_state = 56, .external_lex_state = 58},
  [6760] = {.lex_state = 56, .external_lex_state = 58},
  [6761] = {.lex_state = 56, .external_lex_state = 58},
  [6762] = {.lex_state = 56, .external_lex_state = 203},
  [6763] = {.lex_state = 56, .external_lex_state = 58},
  [6764] = {.lex_state = 56, .external_lex_state = 56},
  [6765] = {.lex_state = 56, .external_lex_state = 58},
  [6766] = {.lex_state = 56, .external_lex_state = 55},
  [6767] = {.lex_state = 56, .external_lex_state = 58},
  [6768] = {.lex_state = 56, .external_lex_state = 58},
  [6769] = {.lex_state = 56, .external_lex_state = 56},
  [6770] = {.lex_state = 56, .external_lex_state = 58},
  [6771] = {.lex_state = 56, .external_lex_state = 58},
  [6772] = {.lex_state = 56, .external_lex_state = 59},
  [6773] = {.lex_state = 56, .external_lex_state = 58},
  [6774] = {.lex_state = 56, .external_lex_state = 58},
  [6775] = {.lex_state = 56, .external_lex_state = 55},
  [6776] = {.lex_state = 56, .external_lex_state = 54},
  [6777] = {.lex_state = 56, .external_lex_state = 51},
  [6778] = {.lex_state = 56, .external_lex_state = 53},
  [6779] = {.lex_state = 56, .external_lex_state = 204},
  [6780] = {.lex_state = 56, .external_lex_state = 57},
  [6781] = {.lex_state = 56, .external_lex_state = 55},
  [6782] = {.lex_state = 56, .external_lex_state = 202},
  [6783] = {.lex_state = 56, .external_lex_state = 58},
  [6784] = {.lex_state = 56, .external_lex_state = 57},
  [6785] = {.lex_state = 56, .external_lex_state = 57},
  [6786] = {.lex_state = 56, .external_lex_state = 204},
  [6787] = {.lex_state = 56, .external_lex_state = 53},
  [6788] = {.lex_state = 56, .external_lex_state = 57},
  [6789] = {.lex_state = 56, .external_lex_state = 53},
  [6790] = {.lex_state = 56, .external_lex_state = 53},
  [6791] = {.lex_state = 56, .external_lex_state = 59},
  [6792] = {.lex_state = 56, .external_lex_state = 56},
  [6793] = {.lex_state = 56, .external_lex_state = 57},
  [6794] = {.lex_state = 56, .external_lex_state = 54},
  [6795] = {.lex_state = 56, .external_lex_state = 54},
  [6796] = {.lex_state = 56, .external_lex_state = 59},
  [6797] = {.lex_state = 56, .external_lex_state = 52},
  [6798] = {.lex_state = 56, .external_lex_state = 54},
  [6799] = {.lex_state = 56, .external_lex_state = 51},
  [6800] = {.lex_state = 56, .external_lex_state = 55},
  [6801] = {.lex_state = 56, .external_lex_state = 57},
  [6802] = {.lex_state = 56, .external_lex_state = 53},
  [6803] = {.lex_state = 56, .external_lex_state = 57},
  [6804] = {.lex_state = 56, .external_lex_state = 53},
  [6805] = {.lex_state = 56, .external_lex_state = 54},
  [6806] = {.lex_state = 56, .external_lex_state = 57},
  [6807] = {.lex_state = 56, .external_lex_state = 202},
  [6808] = {.lex_state = 56, .external_lex_state = 54},
  [6809] = {.lex_state = 56, .external_lex_state = 57},
  [6810] = {.lex_state = 56, .external_lex_state = 52},
  [6811] = {.lex_state = 56, .external_lex_state = 53},
  [6812] = {.lex_state = 56, .external_lex_state = 59},
  [6813] = {.lex_state = 56, .external_lex_state = 205},
  [6814] = {.lex_state = 56, .external_lex_state = 52},
  [6815] = {.lex_state = 56, .external_lex_state = 53},
  [6816] = {.lex_state = 56, .external_lex_state = 51},
  [6817] = {.lex_state = 56, .external_lex_state = 54},
  [6818] = {.lex_state = 56, .external_lex_state = 51},
  [6819] = {.lex_state = 56, .external_lex_state = 52},
  [6820] = {.lex_state = 56, .external_lex_state = 51},
  [6821] = {.lex_state = 56, .external_lex_state = 54},
  [6822] = {.lex_state = 56, .external_lex_state = 51},
  [6823] = {.lex_state = 56, .external_lex_state = 53},
  [6824] = {.lex_state = 56, .external_lex_state = 51},
  [6825] = {.lex_state = 56, .external_lex_state = 51},
  [6826] = {.lex_state = 56, .external_lex_state = 52},
  [6827] = {.lex_state = 56, .external_lex_state = 51},
  [6828] = {.lex_state = 56, .external_lex_state = 53},
  [6829] = {.lex_state = 56, .external_lex_state = 53},
  [6830] = {.lex_state = 56, .external_lex_state = 51},
  [6831] = {.lex_state = 56, .external_lex_state = 51},
  [6832] = {.lex_state = 56, .external_lex_state = 51},
  [6833] = {.lex_state = 56, .external_lex_state = 55},
  [6834] = {.lex_state = 56, .external_lex_state = 51},
  [6835] = {.lex_state = 56, .external_lex_state = 54},
  [6836] = {.lex_state = 56, .external_lex_state = 51},
  [6837] = {.lex_state = 56, .external_lex_state = 204},
  [6838] = {.lex_state = 56, .external_lex_state = 51},
  [6839] = {.lex_state = 56, .external_lex_state = 57},
  [6840] = {.lex_state = 56, .external_lex_state = 52},
  [6841] = {.lex_state = 56, .external_lex_state = 55},
  [6842] = {.lex_state = 56, .external_lex_state = 58},
  [6843] = {.lex_state = 56, .external_lex_state = 51},
  [6844] = {.lex_state = 56, .external_lex_state = 55},
  [6845] = {.lex_state = 56, .external_lex_state = 58},
  [6846] = {.lex_state = 56, .external_lex_state = 53},
  [6847] = {.lex_state = 56, .external_lex_state = 52},
  [6848] = {.lex_state = 56, .external_lex_state = 51},
  [6849] = {.lex_state = 56, .external_lex_state = 203},
  [6850] = {.lex_state = 56, .external_lex_state = 51},
  [6851] = {.lex_state = 56, .external_lex_state = 53},
  [6852] = {.lex_state = 56, .external_lex_state = 52},
  [6853] = {.lex_state = 56, .external_lex_state = 203},
  [6854] = {.lex_state = 56, .external_lex_state = 53},
  [6855] = {.lex_state = 56, .external_lex_state = 53},
  [6856] = {.lex_state = 56, .external_lex_state = 55},
  [6857] = {.lex_state = 56, .external_lex_state = 55},
  [6858] = {.lex_state = 56, .external_lex_state = 53},
  [6859] = {.lex_state = 56, .external_lex_state = 53},
  [6860] = {.lex_state = 56, .external_lex_state = 53},
  [6861] = {.lex_state = 56, .external_lex_state = 56},
  [6862] = {.lex_state = 56, .external_lex_state = 57},
  [6863] = {.lex_state = 55, .external_lex_state = 34},
  [6864] = {.lex_state = 56, .external_lex_state = 55},
  [6865] = {.lex_state = 56, .external_lex_state = 53},
  [6866] = {.lex_state = 56, .external_lex_state = 59},
  [6867] = {.lex_state = 56, .external_lex_state = 59},
  [6868] = {.lex_state = 56, .external_lex_state = 52},
  [6869] = {.lex_state = 56, .external_lex_state = 54},
  [6870] = {.lex_state = 56, .external_lex_state = 51},
  [6871] = {.lex_state = 56, .external_lex_state = 56},
  [6872] = {.lex_state = 56, .external_lex_state = 56},
  [6873] = {.lex_state = 56, .external_lex_state = 205},
  [6874] = {.lex_state = 56, .external_lex_state = 56},
  [6875] = {.lex_state = 56, .external_lex_state = 53},
  [6876] = {.lex_state = 56, .external_lex_state = 56},
  [6877] = {.lex_state = 56, .external_lex_state = 55},
  [6878] = {.lex_state = 56, .external_lex_state = 52},
  [6879] = {.lex_state = 56, .external_lex_state = 59},
  [6880] = {.lex_state = 56, .external_lex_state = 59},
  [6881] = {.lex_state = 55, .external_lex_state = 34},
  [6882] = {.lex_state = 55, .external_lex_state = 34},
  [6883] = {.lex_state = 56, .external_lex_state = 54},
  [6884] = {.lex_state = 56, .external_lex_state = 53},
  [6885] = {.lex_state = 55, .external_lex_state = 34},
  [6886] = {.lex_state = 56, .external_lex_state = 53},
  [6887] = {.lex_state = 56, .external_lex_state = 59},
  [6888] = {.lex_state = 56, .external_lex_state = 52},
  [6889] = {.lex_state = 56, .external_lex_state = 59},
  [6890] = {.lex_state = 56, .external_lex_state = 59},
  [6891] = {.lex_state = 56, .external_lex_state = 59},
  [6892] = {.lex_state = 56, .external_lex_state = 59},
  [6893] = {.lex_state = 56, .external_lex_state = 53},
  [6894] = {.lex_state = 56, .external_lex_state = 52},
  [6895] = {.lex_state = 56, .external_lex_state = 59},
  [6896] = {.lex_state = 56, .external_lex_state = 55},
  [6897] = {.lex_state = 56, .external_lex_state = 59},
  [6898] = {.lex_state = 56, .external_lex_state = 55},
  [6899] = {.lex_state = 56, .external_lex_state = 59},
  [6900] = {.lex_state = 56, .external_lex_state = 59},
  [6901] = {.lex_state = 56, .external_lex_state = 59},
  [6902] = {.lex_state = 56, .external_lex_state = 54},
  [6903] = {.lex_state = 56, .external_lex_state = 56},
  [6904] = {.lex_state = 56, .external_lex_state = 57},
  [6905] = {.lex_state = 56, .external_lex_state = 53},
  [6906] = {.lex_state = 56, .external_lex_state = 56},
  [6907] = {.lex_state = 56, .external_lex_state = 55},
  [6908] = {.lex_state = 56, .external_lex_state = 56},
  [6909] = {.lex_state = 56, .external_lex_state = 58},
  [6910] = {.lex_state = 56, .external_lex_state = 53},
  [6911] = {.lex_state = 56, .external_lex_state = 57},
  [6912] = {.lex_state = 56, .external_lex_state = 56},
  [6913] = {.lex_state = 56, .external_lex_state = 53},
  [6914] = {.lex_state = 56, .external_lex_state = 52},
  [6915] = {.lex_state = 56, .external_lex_state = 52},
  [6916] = {.lex_state = 56, .external_lex_state = 56},
  [6917] = {.lex_state = 56, .external_lex_state = 53},
  [6918] = {.lex_state = 56, .external_lex_state = 56},
  [6919] = {.lex_state = 56, .external_lex_state = 57},
  [6920] = {.lex_state = 56, .external_lex_state = 53},
  [6921] = {.lex_state = 56, .external_lex_state = 56},
  [6922] = {.lex_state = 56, .external_lex_state = 54},
  [6923] = {.lex_state = 56, .external_lex_state = 55},
  [6924] = {.lex_state = 56, .external_lex_state = 57},
  [6925] = {.lex_state = 56, .external_lex_state = 55},
  [6926] = {.lex_state = 56, .external_lex_state = 52},
  [6927] = {.lex_state = 56, .external_lex_state = 56},
  [6928] = {.lex_state = 56, .external_lex_state = 203},
  [6929] = {.lex_state = 56, .external_lex_state = 57},
  [6930] = {.lex_state = 56, .external_lex_state = 57},
  [6931] = {.lex_state = 56, .external_lex_state = 57},
  [6932] = {.lex_state = 56, .external_lex_state = 56},
  [6933] = {.lex_state = 56, .external_lex_state = 56},
  [6934] = {.lex_state = 56, .external_lex_state = 56},
  [6935] = {.lex_state = 56, .external_lex_state = 57},
  [6936] = {.lex_state = 56, .external_lex_state = 55},
  [6937] = {.lex_state = 56, .external_lex_state = 56},
  [6938] = {.lex_state = 56, .external_lex_state = 56},
  [6939] = {.lex_state = 56, .external_lex_state = 205},
  [6940] = {.lex_state = 56, .external_lex_state = 55},
  [6941] = {.lex_state = 56, .external_lex_state = 54},
  [6942] = {.lex_state = 56, .external_lex_state = 54},
  [6943] = {.lex_state = 55, .external_lex_state = 34},
  [6944] = {.lex_state = 56, .external_lex_state = 54},
  [6945] = {.lex_state = 56, .external_lex_state = 59},
  [6946] = {.lex_state = 56, .external_lex_state = 55},
  [6947] = {.lex_state = 56, .external_lex_state = 55},
  [6948] = {.lex_state = 56, .external_lex_state = 204},
  [6949] = {.lex_state = 56, .external_lex_state = 58},
  [6950] = {.lex_state = 56, .external_lex_state = 55},
  [6951] = {.lex_state = 56, .external_lex_state = 205},
  [6952] = {.lex_state = 56, .external_lex_state = 55},
  [6953] = {.lex_state = 56, .external_lex_state = 205},
  [6954] = {.lex_state = 56, .external_lex_state = 55},
  [6955] = {.lex_state = 56, .external_lex_state = 55},
  [6956] = {.lex_state = 56, .external_lex_state = 56},
  [6957] = {.lex_state = 56, .external_lex_state = 54},
  [6958] = {.lex_state = 56, .external_lex_state = 55},
  [6959] = {.lex_state = 56, .external_lex_state = 54},
  [6960] = {.lex_state = 56, .external_lex_state = 205},
  [6961] = {.lex_state = 56, .external_lex_state = 56},
  [6962] = {.lex_state = 56, .external_lex_state = 55},
  [6963] = {.lex_state = 56, .external_lex_state = 56},
  [6964] = {.lex_state = 56, .external_lex_state = 54},
  [6965] = {.lex_state = 56, .external_lex_state = 195},
  [6966] = {.lex_state = 56, .external_lex_state = 59},
  [6967] = {.lex_state = 56, .external_lex_state = 56},
  [6968] = {.lex_state = 56, .external_lex_state = 59},
  [6969] = {.lex_state = 56, .external_lex_state = 52},
  [6970] = {.lex_state = 56, .external_lex_state = 54},
  [6971] = {.lex_state = 55, .external_lex_state = 34},
  [6972] = {.lex_state = 56, .external_lex_state = 59},
  [6973] = {.lex_state = 56, .external_lex_state = 59},
  [6974] = {.lex_state = 56, .external_lex_state = 53},
  [6975] = {.lex_state = 55, .external_lex_state = 34},
  [6976] = {.lex_state = 56, .external_lex_state = 59},
  [6977] = {.lex_state = 55, .external_lex_state = 34},
  [6978] = {.lex_state = 56, .external_lex_state = 57},
  [6979] = {.lex_state = 56, .external_lex_state = 57},
  [6980] = {.lex_state = 56, .external_lex_state = 59},
  [6981] = {.lex_state = 56, .external_lex_state = 54},
  [6982] = {.lex_state = 56, .external_lex_state = 57},
  [6983] = {.lex_state = 56, .external_lex_state = 54},
  [6984] = {.lex_state = 56, .external_lex_state = 52},
  [6985] = {.lex_state = 56, .external_lex_state = 204},
  [6986] = {.lex_state = 56, .external_lex_state = 204},
  [6987] = {.lex_state = 56, .external_lex_state = 52},
  [6988] = {.lex_state = 56, .external_lex_state = 59},
  [6989] = {.lex_state = 56, .external_lex_state = 59},
  [6990] = {.lex_state = 56, .external_lex_state = 52},
  [6991] = {.lex_state = 56, .external_lex_state = 59},
  [6992] = {.lex_state = 56, .external_lex_state = 52},
  [6993] = {.lex_state = 56, .external_lex_state = 54},
  [6994] = {.lex_state = 56, .external_lex_state = 59},
  [6995] = {.lex_state = 56, .external_lex_state = 52},
  [6996] = {.lex_state = 56, .external_lex_state = 59},
  [6997] = {.lex_state = 56, .external_lex_state = 59},
  [6998] = {.lex_state = 56, .external_lex_state = 52},
  [6999] = {.lex_state = 56, .external_lex_state = 59},
  [7000] = {.lex_state = 56, .external_lex_state = 52},
  [7001] = {.lex_state = 56, .external_lex_state = 54},
  [7002] = {.lex_state = 56, .external_lex_state = 202},
  [7003] = {.lex_state = 56, .external_lex_state = 52},
  [7004] = {.lex_state = 56, .external_lex_state = 59},
  [7005] = {.lex_state = 56, .external_lex_state = 201},
  [7006] = {.lex_state = 56, .external_lex_state = 57},
  [7007] = {.lex_state = 56, .external_lex_state = 57},
  [7008] = {.lex_state = 55, .external_lex_state = 34},
  [7009] = {.lex_state = 56, .external_lex_state = 54},
  [7010] = {.lex_state = 56, .external_lex_state = 202},
  [7011] = {.lex_state = 56, .external_lex_state = 54},
  [7012] = {.lex_state = 56, .external_lex_state = 52},
  [7013] = {.lex_state = 55, .external_lex_state = 34},
  [7014] = {.lex_state = 55, .external_lex_state = 34},
  [7015] = {.lex_state = 56, .external_lex_state = 59},
  [7016] = {.lex_state = 56, .external_lex_state = 201},
  [7017] = {.lex_state = 55, .external_lex_state = 34},
  [7018] = {.lex_state = 56, .external_lex_state = 57},
  [7019] = {.lex_state = 55, .external_lex_state = 34},
  [7020] = {.lex_state = 55, .external_lex_state = 34},
  [7021] = {.lex_state = 56, .external_lex_state = 54},
  [7022] = {.lex_state = 56, .external_lex_state = 54},
  [7023] = {.lex_state = 55, .external_lex_state = 34},
  [7024] = {.lex_state = 55, .external_lex_state = 34},
  [7025] = {.lex_state = 56, .external_lex_state = 57},
  [7026] = {.lex_state = 56, .external_lex_state = 57},
  [7027] = {.lex_state = 56, .external_lex_state = 57},
  [7028] = {.lex_state = 55, .external_lex_state = 34},
  [7029] = {.lex_state = 56, .external_lex_state = 59},
  [7030] = {.lex_state = 56, .external_lex_state = 52},
  [7031] = {.lex_state = 56, .external_lex_state = 57},
  [7032] = {.lex_state = 56, .external_lex_state = 64},
  [7033] = {.lex_state = 56, .external_lex_state = 66},
  [7034] = {.lex_state = 56, .external_lex_state = 206},
  [7035] = {.lex_state = 56, .external_lex_state = 207},
  [7036] = {.lex_state = 56, .external_lex_state = 64},
  [7037] = {.lex_state = 56, .external_lex_state = 64},
  [7038] = {.lex_state = 56, .external_lex_state = 62},
  [7039] = {.lex_state = 56, .external_lex_state = 208},
  [7040] = {.lex_state = 56, .external_lex_state = 207},
  [7041] = {.lex_state = 56, .external_lex_state = 208},
  [7042] = {.lex_state = 56, .external_lex_state = 66},
  [7043] = {.lex_state = 56, .external_lex_state = 66},
  [7044] = {.lex_state = 56, .external_lex_state = 66},
  [7045] = {.lex_state = 56, .external_lex_state = 66},
  [7046] = {.lex_state = 56, .external_lex_state = 63},
  [7047] = {.lex_state = 56, .external_lex_state = 208},
  [7048] = {.lex_state = 56, .external_lex_state = 66},
  [7049] = {.lex_state = 56, .external_lex_state = 66},
  [7050] = {.lex_state = 56, .external_lex_state = 62},
  [7051] = {.lex_state = 56, .external_lex_state = 53},
  [7052] = {.lex_state = 56, .external_lex_state = 66},
  [7053] = {.lex_state = 56, .external_lex_state = 66},
  [7054] = {.lex_state = 56, .external_lex_state = 66},
  [7055] = {.lex_state = 56, .external_lex_state = 66},
  [7056] = {.lex_state = 56, .external_lex_state = 63},
  [7057] = {.lex_state = 56, .external_lex_state = 206},
  [7058] = {.lex_state = 56, .external_lex_state = 206},
  [7059] = {.lex_state = 56, .external_lex_state = 65},
  [7060] = {.lex_state = 56, .external_lex_state = 64},
  [7061] = {.lex_state = 56, .external_lex_state = 207},
  [7062] = {.lex_state = 56, .external_lex_state = 63},
  [7063] = {.lex_state = 56, .external_lex_state = 66},
  [7064] = {.lex_state = 56, .external_lex_state = 62},
  [7065] = {.lex_state = 56, .external_lex_state = 62},
  [7066] = {.lex_state = 56, .external_lex_state = 63},
  [7067] = {.lex_state = 56, .external_lex_state = 62},
  [7068] = {.lex_state = 56, .external_lex_state = 64},
  [7069] = {.lex_state = 56, .external_lex_state = 62},
  [7070] = {.lex_state = 56, .external_lex_state = 64},
  [7071] = {.lex_state = 56, .external_lex_state = 65},
  [7072] = {.lex_state = 56, .external_lex_state = 206},
  [7073] = {.lex_state = 56, .external_lex_state = 64},
  [7074] = {.lex_state = 56, .external_lex_state = 64},
  [7075] = {.lex_state = 56, .external_lex_state = 64},
  [7076] = {.lex_state = 56, .external_lex_state = 65},
  [7077] = {.lex_state = 56, .external_lex_state = 64},
  [7078] = {.lex_state = 56, .external_lex_state = 64},
  [7079] = {.lex_state = 56, .external_lex_state = 64},
  [7080] = {.lex_state = 56, .external_lex_state = 62},
  [7081] = {.lex_state = 56, .external_lex_state = 62},
  [7082] = {.lex_state = 56, .external_lex_state = 62},
  [7083] = {.lex_state = 56, .external_lex_state = 62},
  [7084] = {.lex_state = 56, .external_lex_state = 62},
  [7085] = {.lex_state = 56, .external_lex_state = 66},
  [7086] = {.lex_state = 56, .external_lex_state = 206},
  [7087] = {.lex_state = 56, .external_lex_state = 66},
  [7088] = {.lex_state = 56, .external_lex_state = 62},
  [7089] = {.lex_state = 56, .external_lex_state = 63},
  [7090] = {.lex_state = 56, .external_lex_state = 65},
  [7091] = {.lex_state = 56, .external_lex_state = 64},
  [7092] = {.lex_state = 56, .external_lex_state = 64},
  [7093] = {.lex_state = 56, .external_lex_state = 62},
  [7094] = {.lex_state = 56, .external_lex_state = 207},
  [7095] = {.lex_state = 56, .external_lex_state = 66},
  [7096] = {.lex_state = 56, .external_lex_state = 63},
  [7097] = {.lex_state = 56, .external_lex_state = 64},
  [7098] = {.lex_state = 56, .external_lex_state = 66},
  [7099] = {.lex_state = 56, .external_lex_state = 64},
  [7100] = {.lex_state = 56, .external_lex_state = 207},
  [7101] = {.lex_state = 56, .external_lex_state = 66},
  [7102] = {.lex_state = 56, .external_lex_state = 65},
  [7103] = {.lex_state = 56, .external_lex_state = 62},
  [7104] = {.lex_state = 56, .external_lex_state = 62},
  [7105] = {.lex_state = 56, .external_lex_state = 208},
  [7106] = {.lex_state = 56, .external_lex_state = 66},
  [7107] = {.lex_state = 56, .external_lex_state = 65},
  [7108] = {.lex_state = 56, .external_lex_state = 65},
  [7109] = {.lex_state = 56, .external_lex_state = 65},
  [7110] = {.lex_state = 56, .external_lex_state = 65},
  [7111] = {.lex_state = 56, .external_lex_state = 65},
  [7112] = {.lex_state = 56, .external_lex_state = 208},
  [7113] = {.lex_state = 56, .external_lex_state = 63},
  [7114] = {.lex_state = 56, .external_lex_state = 63},
  [7115] = {.lex_state = 56, .external_lex_state = 63},
  [7116] = {.lex_state = 56, .external_lex_state = 62},
  [7117] = {.lex_state = 56, .external_lex_state = 64},
  [7118] = {.lex_state = 56, .external_lex_state = 63},
  [7119] = {.lex_state = 56, .external_lex_state = 62},
  [7120] = {.lex_state = 56, .external_lex_state = 62},
  [7121] = {.lex_state = 56, .external_lex_state = 64},
  [7122] = {.lex_state = 56, .external_lex_state = 65},
  [7123] = {.lex_state = 56, .external_lex_state = 65},
  [7124] = {.lex_state = 56, .external_lex_state = 65},
  [7125] = {.lex_state = 56, .external_lex_state = 65},
  [7126] = {.lex_state = 56, .external_lex_state = 64},
  [7127] = {.lex_state = 56, .external_lex_state = 64},
  [7128] = {.lex_state = 56, .external_lex_state = 64},
  [7129] = {.lex_state = 56, .external_lex_state = 64},
  [7130] = {.lex_state = 56, .external_lex_state = 65},
  [7131] = {.lex_state = 56, .external_lex_state = 65},
  [7132] = {.lex_state = 56, .external_lex_state = 65},
  [7133] = {.lex_state = 56, .external_lex_state = 64},
  [7134] = {.lex_state = 56, .external_lex_state = 65},
  [7135] = {.lex_state = 56, .external_lex_state = 64},
  [7136] = {.lex_state = 56, .external_lex_state = 202},
  [7137] = {.lex_state = 56, .external_lex_state = 64},
  [7138] = {.lex_state = 56, .external_lex_state = 64},
  [7139] = {.lex_state = 56, .external_lex_state = 66},
  [7140] = {.lex_state = 56, .external_lex_state = 64},
  [7141] = {.lex_state = 56, .external_lex_state = 64},
  [7142] = {.lex_state = 56, .external_lex_state = 62},
  [7143] = {.lex_state = 56, .external_lex_state = 64},
  [7144] = {.lex_state = 56, .external_lex_state = 64},
  [7145] = {.lex_state = 56, .external_lex_state = 207},
  [7146] = {.lex_state = 56, .external_lex_state = 65},
  [7147] = {.lex_state = 56, .external_lex_state = 66},
  [7148] = {.lex_state = 56, .external_lex_state = 66},
  [7149] = {.lex_state = 56, .external_lex_state = 65},
  [7150] = {.lex_state = 56, .external_lex_state = 66},
  [7151] = {.lex_state = 56, .external_lex_state = 65},
  [7152] = {.lex_state = 56, .external_lex_state = 66},
  [7153] = {.lex_state = 56, .external_lex_state = 66},
  [7154] = {.lex_state = 56, .external_lex_state = 66},
  [7155] = {.lex_state = 56, .external_lex_state = 14},
  [7156] = {.lex_state = 56, .external_lex_state = 64},
  [7157] = {.lex_state = 56, .external_lex_state = 64},
  [7158] = {.lex_state = 56, .external_lex_state = 66},
  [7159] = {.lex_state = 56, .external_lex_state = 54},
  [7160] = {.lex_state = 56, .external_lex_state = 208},
  [7161] = {.lex_state = 56, .external_lex_state = 65},
  [7162] = {.lex_state = 56, .external_lex_state = 66},
  [7163] = {.lex_state = 56, .external_lex_state = 65},
  [7164] = {.lex_state = 56, .external_lex_state = 65},
  [7165] = {.lex_state = 56, .external_lex_state = 65},
  [7166] = {.lex_state = 56, .external_lex_state = 66},
  [7167] = {.lex_state = 56, .external_lex_state = 65},
  [7168] = {.lex_state = 56, .external_lex_state = 209},
  [7169] = {.lex_state = 56, .external_lex_state = 65},
  [7170] = {.lex_state = 56, .external_lex_state = 209},
  [7171] = {.lex_state = 56, .external_lex_state = 62},
  [7172] = {.lex_state = 56, .external_lex_state = 62},
  [7173] = {.lex_state = 56, .external_lex_state = 63},
  [7174] = {.lex_state = 56, .external_lex_state = 62},
  [7175] = {.lex_state = 56, .external_lex_state = 62},
  [7176] = {.lex_state = 56, .external_lex_state = 63},
  [7177] = {.lex_state = 56, .external_lex_state = 63},
  [7178] = {.lex_state = 56, .external_lex_state = 62},
  [7179] = {.lex_state = 56, .external_lex_state = 206},
  [7180] = {.lex_state = 56, .external_lex_state = 63},
  [7181] = {.lex_state = 56, .external_lex_state = 64},
  [7182] = {.lex_state = 56, .external_lex_state = 63},
  [7183] = {.lex_state = 56, .external_lex_state = 63},
  [7184] = {.lex_state = 56, .external_lex_state = 64},
  [7185] = {.lex_state = 56, .external_lex_state = 62},
  [7186] = {.lex_state = 56, .external_lex_state = 63},
  [7187] = {.lex_state = 56, .external_lex_state = 209},
  [7188] = {.lex_state = 56, .external_lex_state = 64},
  [7189] = {.lex_state = 56, .external_lex_state = 63},
  [7190] = {.lex_state = 56, .external_lex_state = 65},
  [7191] = {.lex_state = 56, .external_lex_state = 62},
  [7192] = {.lex_state = 56, .external_lex_state = 63},
  [7193] = {.lex_state = 56, .external_lex_state = 66},
  [7194] = {.lex_state = 56, .external_lex_state = 64},
  [7195] = {.lex_state = 57, .external_lex_state = 210},
  [7196] = {.lex_state = 56, .external_lex_state = 63},
  [7197] = {.lex_state = 56, .external_lex_state = 63},
  [7198] = {.lex_state = 56, .external_lex_state = 65},
  [7199] = {.lex_state = 56, .external_lex_state = 66},
  [7200] = {.lex_state = 56, .external_lex_state = 62},
  [7201] = {.lex_state = 56, .external_lex_state = 65},
  [7202] = {.lex_state = 56, .external_lex_state = 63},
  [7203] = {.lex_state = 56, .external_lex_state = 209},
  [7204] = {.lex_state = 56, .external_lex_state = 65},
  [7205] = {.lex_state = 56, .external_lex_state = 65},
  [7206] = {.lex_state = 56, .external_lex_state = 62},
  [7207] = {.lex_state = 56, .external_lex_state = 66},
  [7208] = {.lex_state = 56, .external_lex_state = 62},
  [7209] = {.lex_state = 56, .external_lex_state = 63},
  [7210] = {.lex_state = 56, .external_lex_state = 209},
  [7211] = {.lex_state = 56, .external_lex_state = 66},
  [7212] = {.lex_state = 56, .external_lex_state = 209},
  [7213] = {.lex_state = 56, .external_lex_state = 63},
  [7214] = {.lex_state = 56, .external_lex_state = 62},
  [7215] = {.lex_state = 56, .external_lex_state = 66},
  [7216] = {.lex_state = 56, .external_lex_state = 63},
  [7217] = {.lex_state = 56, .external_lex_state = 62},
  [7218] = {.lex_state = 56, .external_lex_state = 206},
  [7219] = {.lex_state = 56, .external_lex_state = 65},
  [7220] = {.lex_state = 56, .external_lex_state = 63},
  [7221] = {.lex_state = 56, .external_lex_state = 66},
  [7222] = {.lex_state = 56, .external_lex_state = 63},
  [7223] = {.lex_state = 56, .external_lex_state = 63},
  [7224] = {.lex_state = 56, .external_lex_state = 63},
  [7225] = {.lex_state = 56, .external_lex_state = 62},
  [7226] = {.lex_state = 56, .external_lex_state = 66},
  [7227] = {.lex_state = 56, .external_lex_state = 63},
  [7228] = {.lex_state = 56, .external_lex_state = 62},
  [7229] = {.lex_state = 56, .external_lex_state = 63},
  [7230] = {.lex_state = 56, .external_lex_state = 65},
  [7231] = {.lex_state = 56, .external_lex_state = 62},
  [7232] = {.lex_state = 56, .external_lex_state = 62},
  [7233] = {.lex_state = 56, .external_lex_state = 63},
  [7234] = {.lex_state = 56, .external_lex_state = 63},
  [7235] = {.lex_state = 56, .external_lex_state = 63},
  [7236] = {.lex_state = 56, .external_lex_state = 63},
  [7237] = {.lex_state = 56, .external_lex_state = 63},
  [7238] = {.lex_state = 56, .external_lex_state = 65},
  [7239] = {.lex_state = 56, .external_lex_state = 62},
  [7240] = {.lex_state = 56, .external_lex_state = 65},
  [7241] = {.lex_state = 56, .external_lex_state = 66},
  [7242] = {.lex_state = 56, .external_lex_state = 211},
  [7243] = {.lex_state = 55, .external_lex_state = 3},
  [7244] = {.lex_state = 56, .external_lex_state = 212},
  [7245] = {.lex_state = 56, .external_lex_state = 14},
  [7246] = {.lex_state = 56, .external_lex_state = 14},
  [7247] = {.lex_state = 56, .external_lex_state = 211},
  [7248] = {.lex_state = 56, .external_lex_state = 212},
  [7249] = {.lex_state = 56, .external_lex_state = 211},
  [7250] = {.lex_state = 56, .external_lex_state = 212},
  [7251] = {.lex_state = 56, .external_lex_state = 211},
  [7252] = {.lex_state = 56, .external_lex_state = 213},
  [7253] = {.lex_state = 56, .external_lex_state = 14},
  [7254] = {.lex_state = 56, .external_lex_state = 213},
  [7255] = {.lex_state = 56, .external_lex_state = 14},
  [7256] = {.lex_state = 56, .external_lex_state = 14},
  [7257] = {.lex_state = 56, .external_lex_state = 69},
  [7258] = {.lex_state = 56, .external_lex_state = 14},
  [7259] = {.lex_state = 56, .external_lex_state = 69},
  [7260] = {.lex_state = 56, .external_lex_state = 69},
  [7261] = {.lex_state = 56, .external_lex_state = 69},
  [7262] = {.lex_state = 56, .external_lex_state = 69},
  [7263] = {.lex_state = 56, .external_lex_state = 69},
  [7264] = {.lex_state = 56, .external_lex_state = 69},
  [7265] = {.lex_state = 56, .external_lex_state = 69},
  [7266] = {.lex_state = 56, .external_lex_state = 69},
  [7267] = {.lex_state = 56, .external_lex_state = 69},
  [7268] = {.lex_state = 56, .external_lex_state = 62},
  [7269] = {.lex_state = 56, .external_lex_state = 69},
  [7270] = {.lex_state = 56, .external_lex_state = 70},
  [7271] = {.lex_state = 56, .external_lex_state = 70},
  [7272] = {.lex_state = 56, .external_lex_state = 70},
  [7273] = {.lex_state = 55, .external_lex_state = 3},
  [7274] = {.lex_state = 56, .external_lex_state = 70},
  [7275] = {.lex_state = 56, .external_lex_state = 70},
  [7276] = {.lex_state = 56, .external_lex_state = 70},
  [7277] = {.lex_state = 56, .external_lex_state = 70},
  [7278] = {.lex_state = 56, .external_lex_state = 70},
  [7279] = {.lex_state = 56, .external_lex_state = 70},
  [7280] = {.lex_state = 56, .external_lex_state = 70},
  [7281] = {.lex_state = 56, .external_lex_state = 70},
  [7282] = {.lex_state = 56, .external_lex_state = 69},
  [7283] = {.lex_state = 55, .external_lex_state = 3},
  [7284] = {.lex_state = 56, .external_lex_state = 69},
  [7285] = {.lex_state = 56, .external_lex_state = 69},
  [7286] = {.lex_state = 56, .external_lex_state = 69},
  [7287] = {.lex_state = 55, .external_lex_state = 3},
  [7288] = {.lex_state = 55, .external_lex_state = 3},
  [7289] = {.lex_state = 55, .external_lex_state = 3},
  [7290] = {.lex_state = 56, .external_lex_state = 69},
  [7291] = {.lex_state = 55, .external_lex_state = 3},
  [7292] = {.lex_state = 55, .external_lex_state = 3},
  [7293] = {.lex_state = 56, .external_lex_state = 69},
  [7294] = {.lex_state = 55, .external_lex_state = 3},
  [7295] = {.lex_state = 55, .external_lex_state = 3},
  [7296] = {.lex_state = 56, .external_lex_state = 70},
  [7297] = {.lex_state = 55, .external_lex_state = 3},
  [7298] = {.lex_state = 56, .external_lex_state = 70},
  [7299] = {.lex_state = 56, .external_lex_state = 61},
  [7300] = {.lex_state = 56, .external_lex_state = 70},
  [7301] = {.lex_state = 56, .external_lex_state = 70},
  [7302] = {.lex_state = 55, .external_lex_state = 3},
  [7303] = {.lex_state = 55, .external_lex_state = 3},
  [7304] = {.lex_state = 55, .external_lex_state = 3},
  [7305] = {.lex_state = 56, .external_lex_state = 70},
  [7306] = {.lex_state = 55, .external_lex_state = 3},
  [7307] = {.lex_state = 55, .external_lex_state = 3},
  [7308] = {.lex_state = 55, .external_lex_state = 3},
  [7309] = {.lex_state = 56, .external_lex_state = 69},
  [7310] = {.lex_state = 56, .external_lex_state = 69},
  [7311] = {.lex_state = 55, .external_lex_state = 3},
  [7312] = {.lex_state = 55, .external_lex_state = 3},
  [7313] = {.lex_state = 55, .external_lex_state = 3},
  [7314] = {.lex_state = 56, .external_lex_state = 69},
  [7315] = {.lex_state = 55, .external_lex_state = 3},
  [7316] = {.lex_state = 56, .external_lex_state = 69},
  [7317] = {.lex_state = 56, .external_lex_state = 69},
  [7318] = {.lex_state = 56, .external_lex_state = 69},
  [7319] = {.lex_state = 55, .external_lex_state = 3},
  [7320] = {.lex_state = 56, .external_lex_state = 69},
  [7321] = {.lex_state = 55, .external_lex_state = 3},
  [7322] = {.lex_state = 56, .external_lex_state = 69},
  [7323] = {.lex_state = 56, .external_lex_state = 214},
  [7324] = {.lex_state = 56, .external_lex_state = 69},
  [7325] = {.lex_state = 56, .external_lex_state = 14},
  [7326] = {.lex_state = 55, .external_lex_state = 3},
  [7327] = {.lex_state = 56, .external_lex_state = 70},
  [7328] = {.lex_state = 56, .external_lex_state = 70},
  [7329] = {.lex_state = 56, .external_lex_state = 70},
  [7330] = {.lex_state = 56, .external_lex_state = 70},
  [7331] = {.lex_state = 55, .external_lex_state = 3},
  [7332] = {.lex_state = 55, .external_lex_state = 3},
  [7333] = {.lex_state = 56, .external_lex_state = 70},
  [7334] = {.lex_state = 55, .external_lex_state = 3},
  [7335] = {.lex_state = 56, .external_lex_state = 70},
  [7336] = {.lex_state = 57, .external_lex_state = 215},
  [7337] = {.lex_state = 55, .external_lex_state = 3},
  [7338] = {.lex_state = 56, .external_lex_state = 70},
  [7339] = {.lex_state = 55, .external_lex_state = 3},
  [7340] = {.lex_state = 56, .external_lex_state = 70},
  [7341] = {.lex_state = 55, .external_lex_state = 3},
  [7342] = {.lex_state = 56, .external_lex_state = 70},
  [7343] = {.lex_state = 56, .external_lex_state = 211},
  [7344] = {.lex_state = 56, .external_lex_state = 216},
  [7345] = {.lex_state = 55, .external_lex_state = 3},
  [7346] = {.lex_state = 56, .external_lex_state = 216},
  [7347] = {.lex_state = 56, .external_lex_state = 69},
  [7348] = {.lex_state = 56, .external_lex_state = 69},
  [7349] = {.lex_state = 56, .external_lex_state = 216},
  [7350] = {.lex_state = 56, .external_lex_state = 69},
  [7351] = {.lex_state = 56, .external_lex_state = 14},
  [7352] = {.lex_state = 55, .external_lex_state = 3},
  [7353] = {.lex_state = 56, .external_lex_state = 70},
  [7354] = {.lex_state = 55, .external_lex_state = 3},
  [7355] = {.lex_state = 56, .external_lex_state = 69},
  [7356] = {.lex_state = 56, .external_lex_state = 70},
  [7357] = {.lex_state = 56, .external_lex_state = 70},
  [7358] = {.lex_state = 55, .external_lex_state = 3},
  [7359] = {.lex_state = 56, .external_lex_state = 70},
  [7360] = {.lex_state = 56, .external_lex_state = 217},
  [7361] = {.lex_state = 56, .external_lex_state = 69},
  [7362] = {.lex_state = 56, .external_lex_state = 217},
  [7363] = {.lex_state = 56, .external_lex_state = 216},
  [7364] = {.lex_state = 55, .external_lex_state = 3},
  [7365] = {.lex_state = 56, .external_lex_state = 70},
  [7366] = {.lex_state = 55, .external_lex_state = 3},
  [7367] = {.lex_state = 56, .external_lex_state = 70},
  [7368] = {.lex_state = 55, .external_lex_state = 3},
  [7369] = {.lex_state = 56, .external_lex_state = 14},
  [7370] = {.lex_state = 56, .external_lex_state = 14},
  [7371] = {.lex_state = 56, .external_lex_state = 217},
  [7372] = {.lex_state = 56, .external_lex_state = 212},
  [7373] = {.lex_state = 56, .external_lex_state = 69},
  [7374] = {.lex_state = 56, .external_lex_state = 14},
  [7375] = {.lex_state = 56, .external_lex_state = 14},
  [7376] = {.lex_state = 56, .external_lex_state = 69},
  [7377] = {.lex_state = 56, .external_lex_state = 212},
  [7378] = {.lex_state = 55, .external_lex_state = 3},
  [7379] = {.lex_state = 55, .external_lex_state = 3},
  [7380] = {.lex_state = 55, .external_lex_state = 3},
  [7381] = {.lex_state = 56, .external_lex_state = 70},
  [7382] = {.lex_state = 55, .external_lex_state = 3},
  [7383] = {.lex_state = 55, .external_lex_state = 3},
  [7384] = {.lex_state = 55, .external_lex_state = 3},
  [7385] = {.lex_state = 56, .external_lex_state = 14},
  [7386] = {.lex_state = 56, .external_lex_state = 14},
  [7387] = {.lex_state = 56, .external_lex_state = 216},
  [7388] = {.lex_state = 56, .external_lex_state = 14},
  [7389] = {.lex_state = 55, .external_lex_state = 3},
  [7390] = {.lex_state = 55, .external_lex_state = 3},
  [7391] = {.lex_state = 56, .external_lex_state = 69},
  [7392] = {.lex_state = 56, .external_lex_state = 14},
  [7393] = {.lex_state = 56, .external_lex_state = 69},
  [7394] = {.lex_state = 56, .external_lex_state = 14},
  [7395] = {.lex_state = 56, .external_lex_state = 70},
  [7396] = {.lex_state = 56, .external_lex_state = 70},
  [7397] = {.lex_state = 55, .external_lex_state = 3},
  [7398] = {.lex_state = 56, .external_lex_state = 218},
  [7399] = {.lex_state = 56, .external_lex_state = 218},
  [7400] = {.lex_state = 56, .external_lex_state = 212},
  [7401] = {.lex_state = 55, .external_lex_state = 3},
  [7402] = {.lex_state = 56, .external_lex_state = 218},
  [7403] = {.lex_state = 55, .external_lex_state = 3},
  [7404] = {.lex_state = 56, .external_lex_state = 217},
  [7405] = {.lex_state = 56, .external_lex_state = 217},
  [7406] = {.lex_state = 56, .external_lex_state = 214},
  [7407] = {.lex_state = 55, .external_lex_state = 3},
  [7408] = {.lex_state = 56, .external_lex_state = 14},
  [7409] = {.lex_state = 56, .external_lex_state = 211},
  [7410] = {.lex_state = 55, .external_lex_state = 3},
  [7411] = {.lex_state = 55, .external_lex_state = 3},
  [7412] = {.lex_state = 55, .external_lex_state = 3},
  [7413] = {.lex_state = 56, .external_lex_state = 216},
  [7414] = {.lex_state = 56, .external_lex_state = 68},
  [7415] = {.lex_state = 55, .external_lex_state = 3},
  [7416] = {.lex_state = 55, .external_lex_state = 3},
  [7417] = {.lex_state = 56, .external_lex_state = 60},
  [7418] = {.lex_state = 56, .external_lex_state = 70},
  [7419] = {.lex_state = 55, .external_lex_state = 3},
  [7420] = {.lex_state = 56, .external_lex_state = 68},
  [7421] = {.lex_state = 55, .external_lex_state = 3},
  [7422] = {.lex_state = 55, .external_lex_state = 3},
  [7423] = {.lex_state = 56, .external_lex_state = 68},
  [7424] = {.lex_state = 56, .external_lex_state = 68},
  [7425] = {.lex_state = 56, .external_lex_state = 68},
  [7426] = {.lex_state = 55, .external_lex_state = 3},
  [7427] = {.lex_state = 56, .external_lex_state = 68},
  [7428] = {.lex_state = 56, .external_lex_state = 68},
  [7429] = {.lex_state = 56, .external_lex_state = 68},
  [7430] = {.lex_state = 55, .external_lex_state = 3},
  [7431] = {.lex_state = 56, .external_lex_state = 68},
  [7432] = {.lex_state = 55, .external_lex_state = 3},
  [7433] = {.lex_state = 56, .external_lex_state = 68},
  [7434] = {.lex_state = 55, .external_lex_state = 3},
  [7435] = {.lex_state = 56, .external_lex_state = 68},
  [7436] = {.lex_state = 55, .external_lex_state = 3},
  [7437] = {.lex_state = 55, .external_lex_state = 3},
  [7438] = {.lex_state = 55, .external_lex_state = 3},
  [7439] = {.lex_state = 56, .external_lex_state = 68},
  [7440] = {.lex_state = 55, .external_lex_state = 3},
  [7441] = {.lex_state = 55, .external_lex_state = 3},
  [7442] = {.lex_state = 55, .external_lex_state = 3},
  [7443] = {.lex_state = 56, .external_lex_state = 68},
  [7444] = {.lex_state = 56, .external_lex_state = 68},
  [7445] = {.lex_state = 56, .external_lex_state = 214},
  [7446] = {.lex_state = 56, .external_lex_state = 68},
  [7447] = {.lex_state = 56, .external_lex_state = 68},
  [7448] = {.lex_state = 56, .external_lex_state = 68},
  [7449] = {.lex_state = 55, .external_lex_state = 3},
  [7450] = {.lex_state = 55, .external_lex_state = 3},
  [7451] = {.lex_state = 56, .external_lex_state = 69},
  [7452] = {.lex_state = 56, .external_lex_state = 68},
  [7453] = {.lex_state = 56, .external_lex_state = 68},
  [7454] = {.lex_state = 56, .external_lex_state = 70},
  [7455] = {.lex_state = 55, .external_lex_state = 3},
  [7456] = {.lex_state = 56, .external_lex_state = 68},
  [7457] = {.lex_state = 56, .external_lex_state = 217},
  [7458] = {.lex_state = 56, .external_lex_state = 68},
  [7459] = {.lex_state = 56, .external_lex_state = 68},
  [7460] = {.lex_state = 55, .external_lex_state = 3},
  [7461] = {.lex_state = 55, .external_lex_state = 3},
  [7462] = {.lex_state = 56, .external_lex_state = 68},
  [7463] = {.lex_state = 55, .external_lex_state = 3},
  [7464] = {.lex_state = 56, .external_lex_state = 68},
  [7465] = {.lex_state = 56, .external_lex_state = 68},
  [7466] = {.lex_state = 55, .external_lex_state = 3},
  [7467] = {.lex_state = 55, .external_lex_state = 3},
  [7468] = {.lex_state = 56, .external_lex_state = 68},
  [7469] = {.lex_state = 55, .external_lex_state = 3},
  [7470] = {.lex_state = 56, .external_lex_state = 68},
  [7471] = {.lex_state = 56, .external_lex_state = 68},
  [7472] = {.lex_state = 56, .external_lex_state = 14},
  [7473] = {.lex_state = 55, .external_lex_state = 3},
  [7474] = {.lex_state = 56, .external_lex_state = 68},
  [7475] = {.lex_state = 56, .external_lex_state = 68},
  [7476] = {.lex_state = 55, .external_lex_state = 3},
  [7477] = {.lex_state = 55, .external_lex_state = 3},
  [7478] = {.lex_state = 56, .external_lex_state = 14},
  [7479] = {.lex_state = 56, .external_lex_state = 68},
  [7480] = {.lex_state = 56, .external_lex_state = 218},
  [7481] = {.lex_state = 56, .external_lex_state = 68},
  [7482] = {.lex_state = 56, .external_lex_state = 218},
  [7483] = {.lex_state = 56, .external_lex_state = 213},
  [7484] = {.lex_state = 56, .external_lex_state = 68},
  [7485] = {.lex_state = 55, .external_lex_state = 3},
  [7486] = {.lex_state = 55, .external_lex_state = 3},
  [7487] = {.lex_state = 55, .external_lex_state = 3},
  [7488] = {.lex_state = 56, .external_lex_state = 68},
  [7489] = {.lex_state = 56, .external_lex_state = 68},
  [7490] = {.lex_state = 55, .external_lex_state = 3},
  [7491] = {.lex_state = 55, .external_lex_state = 3},
  [7492] = {.lex_state = 55, .external_lex_state = 3},
  [7493] = {.lex_state = 56, .external_lex_state = 218},
  [7494] = {.lex_state = 56, .external_lex_state = 68},
  [7495] = {.lex_state = 56, .external_lex_state = 14},
  [7496] = {.lex_state = 55, .external_lex_state = 3},
  [7497] = {.lex_state = 55, .external_lex_state = 3},
  [7498] = {.lex_state = 55, .external_lex_state = 3},
  [7499] = {.lex_state = 55, .external_lex_state = 3},
  [7500] = {.lex_state = 55, .external_lex_state = 3},
  [7501] = {.lex_state = 55, .external_lex_state = 3},
  [7502] = {.lex_state = 55, .external_lex_state = 3},
  [7503] = {.lex_state = 55, .external_lex_state = 3},
  [7504] = {.lex_state = 55, .external_lex_state = 3},
  [7505] = {.lex_state = 55, .external_lex_state = 3},
  [7506] = {.lex_state = 55, .external_lex_state = 3},
  [7507] = {.lex_state = 55, .external_lex_state = 3},
  [7508] = {.lex_state = 56, .external_lex_state = 214},
  [7509] = {.lex_state = 55, .external_lex_state = 3},
  [7510] = {.lex_state = 56, .external_lex_state = 213},
  [7511] = {.lex_state = 56, .external_lex_state = 214},
  [7512] = {.lex_state = 56, .external_lex_state = 14},
  [7513] = {.lex_state = 55, .external_lex_state = 3},
  [7514] = {.lex_state = 55, .external_lex_state = 3},
  [7515] = {.lex_state = 55, .external_lex_state = 3},
  [7516] = {.lex_state = 55, .external_lex_state = 3},
  [7517] = {.lex_state = 55, .external_lex_state = 3},
  [7518] = {.lex_state = 56, .external_lex_state = 14},
  [7519] = {.lex_state = 56, .external_lex_state = 14},
  [7520] = {.lex_state = 56, .external_lex_state = 14},
  [7521] = {.lex_state = 55, .external_lex_state = 3},
  [7522] = {.lex_state = 55, .external_lex_state = 3},
  [7523] = {.lex_state = 55, .external_lex_state = 3},
  [7524] = {.lex_state = 55, .external_lex_state = 3},
  [7525] = {.lex_state = 55, .external_lex_state = 3},
  [7526] = {.lex_state = 55, .external_lex_state = 3},
  [7527] = {.lex_state = 56, .external_lex_state = 14},
  [7528] = {.lex_state = 56, .external_lex_state = 14},
  [7529] = {.lex_state = 55, .external_lex_state = 3},
  [7530] = {.lex_state = 56, .external_lex_state = 214},
  [7531] = {.lex_state = 55, .external_lex_state = 3},
  [7532] = {.lex_state = 55, .external_lex_state = 3},
  [7533] = {.lex_state = 55, .external_lex_state = 3},
  [7534] = {.lex_state = 55, .external_lex_state = 3},
  [7535] = {.lex_state = 55, .external_lex_state = 3},
  [7536] = {.lex_state = 55, .external_lex_state = 3},
  [7537] = {.lex_state = 56, .external_lex_state = 14},
  [7538] = {.lex_state = 55, .external_lex_state = 3},
  [7539] = {.lex_state = 55, .external_lex_state = 3},
  [7540] = {.lex_state = 56, .external_lex_state = 14},
  [7541] = {.lex_state = 56, .external_lex_state = 14},
  [7542] = {.lex_state = 56, .external_lex_state = 14},
  [7543] = {.lex_state = 56, .external_lex_state = 14},
  [7544] = {.lex_state = 56, .external_lex_state = 14},
  [7545] = {.lex_state = 56, .external_lex_state = 213},
  [7546] = {.lex_state = 56, .external_lex_state = 14},
  [7547] = {.lex_state = 56, .external_lex_state = 213},
  [7548] = {.lex_state = 55, .external_lex_state = 3},
  [7549] = {.lex_state = 55, .external_lex_state = 3},
  [7550] = {.lex_state = 55, .external_lex_state = 3},
  [7551] = {.lex_state = 56, .external_lex_state = 14},
  [7552] = {.lex_state = 56, .external_lex_state = 14},
  [7553] = {.lex_state = 56, .external_lex_state = 14},
  [7554] = {.lex_state = 56, .external_lex_state = 14},
  [7555] = {.lex_state = 55, .external_lex_state = 3},
  [7556] = {.lex_state = 55, .external_lex_state = 3},
  [7557] = {.lex_state = 55, .external_lex_state = 3},
  [7558] = {.lex_state = 55, .external_lex_state = 3},
  [7559] = {.lex_state = 55, .external_lex_state = 3},
  [7560] = {.lex_state = 55, .external_lex_state = 3},
  [7561] = {.lex_state = 55, .external_lex_state = 3},
  [7562] = {.lex_state = 55, .external_lex_state = 3},
  [7563] = {.lex_state = 55, .external_lex_state = 3},
  [7564] = {.lex_state = 55, .external_lex_state = 3},
  [7565] = {.lex_state = 55, .external_lex_state = 3},
  [7566] = {.lex_state = 55, .external_lex_state = 3},
  [7567] = {.lex_state = 55, .external_lex_state = 3},
  [7568] = {.lex_state = 55, .external_lex_state = 3},
  [7569] = {.lex_state = 55, .external_lex_state = 3},
  [7570] = {.lex_state = 55, .external_lex_state = 3},
  [7571] = {.lex_state = 55, .external_lex_state = 3},
  [7572] = {.lex_state = 55, .external_lex_state = 3},
  [7573] = {.lex_state = 55, .external_lex_state = 3},
  [7574] = {.lex_state = 55, .external_lex_state = 3},
  [7575] = {.lex_state = 55, .external_lex_state = 3},
  [7576] = {.lex_state = 55, .external_lex_state = 3},
  [7577] = {.lex_state = 55, .external_lex_state = 3},
  [7578] = {.lex_state = 56, .external_lex_state = 76},
  [7579] = {.lex_state = 56, .external_lex_state = 73},
  [7580] = {.lex_state = 56, .external_lex_state = 74},
  [7581] = {.lex_state = 56, .external_lex_state = 74},
  [7582] = {.lex_state = 56, .external_lex_state = 73},
  [7583] = {.lex_state = 56, .external_lex_state = 74},
  [7584] = {.lex_state = 56, .external_lex_state = 73},
  [7585] = {.lex_state = 56, .external_lex_state = 74},
  [7586] = {.lex_state = 56, .external_lex_state = 219},
  [7587] = {.lex_state = 56, .external_lex_state = 73},
  [7588] = {.lex_state = 56, .external_lex_state = 73},
  [7589] = {.lex_state = 56, .external_lex_state = 71},
  [7590] = {.lex_state = 56, .external_lex_state = 71},
  [7591] = {.lex_state = 56, .external_lex_state = 71},
  [7592] = {.lex_state = 56, .external_lex_state = 71},
  [7593] = {.lex_state = 56, .external_lex_state = 73},
  [7594] = {.lex_state = 56, .external_lex_state = 71},
  [7595] = {.lex_state = 56, .external_lex_state = 74},
  [7596] = {.lex_state = 56, .external_lex_state = 220},
  [7597] = {.lex_state = 56, .external_lex_state = 221},
  [7598] = {.lex_state = 56, .external_lex_state = 73},
  [7599] = {.lex_state = 56, .external_lex_state = 222},
  [7600] = {.lex_state = 56, .external_lex_state = 74},
  [7601] = {.lex_state = 56, .external_lex_state = 74},
  [7602] = {.lex_state = 56, .external_lex_state = 74},
  [7603] = {.lex_state = 56, .external_lex_state = 73},
  [7604] = {.lex_state = 56, .external_lex_state = 222},
  [7605] = {.lex_state = 56, .external_lex_state = 67},
  [7606] = {.lex_state = 56, .external_lex_state = 74},
  [7607] = {.lex_state = 56, .external_lex_state = 74},
  [7608] = {.lex_state = 56, .external_lex_state = 72},
  [7609] = {.lex_state = 56, .external_lex_state = 219},
  [7610] = {.lex_state = 56, .external_lex_state = 74},
  [7611] = {.lex_state = 56, .external_lex_state = 76},
  [7612] = {.lex_state = 56, .external_lex_state = 76},
  [7613] = {.lex_state = 56, .external_lex_state = 219},
  [7614] = {.lex_state = 56, .external_lex_state = 223},
  [7615] = {.lex_state = 56, .external_lex_state = 73},
  [7616] = {.lex_state = 56, .external_lex_state = 76},
  [7617] = {.lex_state = 56, .external_lex_state = 73},
  [7618] = {.lex_state = 56, .external_lex_state = 224},
  [7619] = {.lex_state = 56, .external_lex_state = 74},
  [7620] = {.lex_state = 56, .external_lex_state = 74},
  [7621] = {.lex_state = 60, .external_lex_state = 121},
  [7622] = {.lex_state = 56, .external_lex_state = 74},
  [7623] = {.lex_state = 56, .external_lex_state = 72},
  [7624] = {.lex_state = 56, .external_lex_state = 76},
  [7625] = {.lex_state = 56, .external_lex_state = 76},
  [7626] = {.lex_state = 56, .external_lex_state = 71},
  [7627] = {.lex_state = 56, .external_lex_state = 76},
  [7628] = {.lex_state = 56, .external_lex_state = 71},
  [7629] = {.lex_state = 56, .external_lex_state = 221},
  [7630] = {.lex_state = 56, .external_lex_state = 76},
  [7631] = {.lex_state = 56, .external_lex_state = 73},
  [7632] = {.lex_state = 56, .external_lex_state = 73},
  [7633] = {.lex_state = 56, .external_lex_state = 73},
  [7634] = {.lex_state = 56, .external_lex_state = 75},
  [7635] = {.lex_state = 56, .external_lex_state = 71},
  [7636] = {.lex_state = 56, .external_lex_state = 75},
  [7637] = {.lex_state = 56, .external_lex_state = 75},
  [7638] = {.lex_state = 56, .external_lex_state = 224},
  [7639] = {.lex_state = 56, .external_lex_state = 72},
  [7640] = {.lex_state = 56, .external_lex_state = 220},
  [7641] = {.lex_state = 56, .external_lex_state = 72},
  [7642] = {.lex_state = 56, .external_lex_state = 72},
  [7643] = {.lex_state = 56, .external_lex_state = 222},
  [7644] = {.lex_state = 56, .external_lex_state = 76},
  [7645] = {.lex_state = 56, .external_lex_state = 77},
  [7646] = {.lex_state = 56, .external_lex_state = 72},
  [7647] = {.lex_state = 56, .external_lex_state = 74},
  [7648] = {.lex_state = 56, .external_lex_state = 73},
  [7649] = {.lex_state = 56, .external_lex_state = 73},
  [7650] = {.lex_state = 56, .external_lex_state = 72},
  [7651] = {.lex_state = 56, .external_lex_state = 74},
  [7652] = {.lex_state = 56, .external_lex_state = 73},
  [7653] = {.lex_state = 56, .external_lex_state = 72},
  [7654] = {.lex_state = 56, .external_lex_state = 74},
  [7655] = {.lex_state = 56, .external_lex_state = 222},
  [7656] = {.lex_state = 56, .external_lex_state = 72},
  [7657] = {.lex_state = 56, .external_lex_state = 71},
  [7658] = {.lex_state = 56, .external_lex_state = 76},
  [7659] = {.lex_state = 56, .external_lex_state = 75},
  [7660] = {.lex_state = 56, .external_lex_state = 75},
  [7661] = {.lex_state = 56, .external_lex_state = 71},
  [7662] = {.lex_state = 56, .external_lex_state = 72},
  [7663] = {.lex_state = 56, .external_lex_state = 72},
  [7664] = {.lex_state = 56, .external_lex_state = 72},
  [7665] = {.lex_state = 56, .external_lex_state = 72},
  [7666] = {.lex_state = 56, .external_lex_state = 75},
  [7667] = {.lex_state = 56, .external_lex_state = 72},
  [7668] = {.lex_state = 56, .external_lex_state = 72},
  [7669] = {.lex_state = 56, .external_lex_state = 222},
  [7670] = {.lex_state = 56, .external_lex_state = 72},
  [7671] = {.lex_state = 56, .external_lex_state = 74},
  [7672] = {.lex_state = 56, .external_lex_state = 72},
  [7673] = {.lex_state = 56, .external_lex_state = 225},
  [7674] = {.lex_state = 56, .external_lex_state = 73},
  [7675] = {.lex_state = 56, .external_lex_state = 220},
  [7676] = {.lex_state = 56, .external_lex_state = 73},
  [7677] = {.lex_state = 56, .external_lex_state = 220},
  [7678] = {.lex_state = 56, .external_lex_state = 71},
  [7679] = {.lex_state = 56, .external_lex_state = 71},
  [7680] = {.lex_state = 56, .external_lex_state = 223},
  [7681] = {.lex_state = 56, .external_lex_state = 76},
  [7682] = {.lex_state = 56, .external_lex_state = 77},
  [7683] = {.lex_state = 56, .external_lex_state = 71},
  [7684] = {.lex_state = 56, .external_lex_state = 73},
  [7685] = {.lex_state = 56, .external_lex_state = 223},
  [7686] = {.lex_state = 56, .external_lex_state = 71},
  [7687] = {.lex_state = 56, .external_lex_state = 75},
  [7688] = {.lex_state = 56, .external_lex_state = 77},
  [7689] = {.lex_state = 56, .external_lex_state = 72},
  [7690] = {.lex_state = 56, .external_lex_state = 222},
  [7691] = {.lex_state = 56, .external_lex_state = 226},
  [7692] = {.lex_state = 56, .external_lex_state = 74},
  [7693] = {.lex_state = 56, .external_lex_state = 75},
  [7694] = {.lex_state = 56, .external_lex_state = 72},
  [7695] = {.lex_state = 56, .external_lex_state = 71},
  [7696] = {.lex_state = 56, .external_lex_state = 73},
  [7697] = {.lex_state = 56, .external_lex_state = 72},
  [7698] = {.lex_state = 56, .external_lex_state = 73},
  [7699] = {.lex_state = 56, .external_lex_state = 73},
  [7700] = {.lex_state = 56, .external_lex_state = 73},
  [7701] = {.lex_state = 56, .external_lex_state = 73},
  [7702] = {.lex_state = 56, .external_lex_state = 72},
  [7703] = {.lex_state = 56, .external_lex_state = 71},
  [7704] = {.lex_state = 56, .external_lex_state = 73},
  [7705] = {.lex_state = 56, .external_lex_state = 72},
  [7706] = {.lex_state = 56, .external_lex_state = 72},
  [7707] = {.lex_state = 56, .external_lex_state = 73},
  [7708] = {.lex_state = 56, .external_lex_state = 73},
  [7709] = {.lex_state = 56, .external_lex_state = 224},
  [7710] = {.lex_state = 56, .external_lex_state = 71},
  [7711] = {.lex_state = 56, .external_lex_state = 75},
  [7712] = {.lex_state = 56, .external_lex_state = 72},
  [7713] = {.lex_state = 56, .external_lex_state = 75},
  [7714] = {.lex_state = 56, .external_lex_state = 224},
  [7715] = {.lex_state = 56, .external_lex_state = 72},
  [7716] = {.lex_state = 56, .external_lex_state = 74},
  [7717] = {.lex_state = 56, .external_lex_state = 221},
  [7718] = {.lex_state = 56, .external_lex_state = 72},
  [7719] = {.lex_state = 56, .external_lex_state = 72},
  [7720] = {.lex_state = 56, .external_lex_state = 71},
  [7721] = {.lex_state = 56, .external_lex_state = 221},
  [7722] = {.lex_state = 56, .external_lex_state = 219},
  [7723] = {.lex_state = 56, .external_lex_state = 71},
  [7724] = {.lex_state = 56, .external_lex_state = 74},
  [7725] = {.lex_state = 56, .external_lex_state = 72},
  [7726] = {.lex_state = 56, .external_lex_state = 74},
  [7727] = {.lex_state = 56, .external_lex_state = 71},
  [7728] = {.lex_state = 56, .external_lex_state = 75},
  [7729] = {.lex_state = 56, .external_lex_state = 72},
  [7730] = {.lex_state = 56, .external_lex_state = 75},
  [7731] = {.lex_state = 56, .external_lex_state = 73},
  [7732] = {.lex_state = 56, .external_lex_state = 72},
  [7733] = {.lex_state = 56, .external_lex_state = 226},
  [7734] = {.lex_state = 56, .external_lex_state = 72},
  [7735] = {.lex_state = 56, .external_lex_state = 75},
  [7736] = {.lex_state = 56, .external_lex_state = 75},
  [7737] = {.lex_state = 56, .external_lex_state = 72},
  [7738] = {.lex_state = 56, .external_lex_state = 75},
  [7739] = {.lex_state = 56, .external_lex_state = 72},
  [7740] = {.lex_state = 56, .external_lex_state = 224},
  [7741] = {.lex_state = 56, .external_lex_state = 73},
  [7742] = {.lex_state = 56, .external_lex_state = 226},
  [7743] = {.lex_state = 56, .external_lex_state = 72},
  [7744] = {.lex_state = 56, .external_lex_state = 77},
  [7745] = {.lex_state = 56, .external_lex_state = 225},
  [7746] = {.lex_state = 56, .external_lex_state = 220},
  [7747] = {.lex_state = 56, .external_lex_state = 74},
  [7748] = {.lex_state = 56, .external_lex_state = 76},
  [7749] = {.lex_state = 60, .external_lex_state = 121},
  [7750] = {.lex_state = 56, .external_lex_state = 71},
  [7751] = {.lex_state = 56, .external_lex_state = 74},
  [7752] = {.lex_state = 56, .external_lex_state = 223},
  [7753] = {.lex_state = 56, .external_lex_state = 74},
  [7754] = {.lex_state = 56, .external_lex_state = 76},
  [7755] = {.lex_state = 56, .external_lex_state = 226},
  [7756] = {.lex_state = 56, .external_lex_state = 225},
  [7757] = {.lex_state = 56, .external_lex_state = 76},
  [7758] = {.lex_state = 56, .external_lex_state = 76},
  [7759] = {.lex_state = 56, .external_lex_state = 76},
  [7760] = {.lex_state = 56, .external_lex_state = 74},
  [7761] = {.lex_state = 56, .external_lex_state = 76},
  [7762] = {.lex_state = 56, .external_lex_state = 76},
  [7763] = {.lex_state = 56, .external_lex_state = 221},
  [7764] = {.lex_state = 56, .external_lex_state = 75},
  [7765] = {.lex_state = 56, .external_lex_state = 76},
  [7766] = {.lex_state = 56, .external_lex_state = 75},
  [7767] = {.lex_state = 56, .external_lex_state = 76},
  [7768] = {.lex_state = 56, .external_lex_state = 76},
  [7769] = {.lex_state = 56, .external_lex_state = 220},
  [7770] = {.lex_state = 56, .external_lex_state = 76},
  [7771] = {.lex_state = 56, .external_lex_state = 76},
  [7772] = {.lex_state = 56, .external_lex_state = 73},
  [7773] = {.lex_state = 56, .external_lex_state = 77},
  [7774] = {.lex_state = 56, .external_lex_state = 77},
  [7775] = {.lex_state = 56, .external_lex_state = 77},
  [7776] = {.lex_state = 56, .external_lex_state = 74},
  [7777] = {.lex_state = 56, .external_lex_state = 72},
  [7778] = {.lex_state = 56, .external_lex_state = 71},
  [7779] = {.lex_state = 60, .external_lex_state = 121},
  [7780] = {.lex_state = 56, .external_lex_state = 225},
  [7781] = {.lex_state = 56, .external_lex_state = 77},
  [7782] = {.lex_state = 56, .external_lex_state = 71},
  [7783] = {.lex_state = 56, .external_lex_state = 71},
  [7784] = {.lex_state = 56, .external_lex_state = 71},
  [7785] = {.lex_state = 56, .external_lex_state = 71},
  [7786] = {.lex_state = 56, .external_lex_state = 75},
  [7787] = {.lex_state = 56, .external_lex_state = 225},
  [7788] = {.lex_state = 56, .external_lex_state = 221},
  [7789] = {.lex_state = 56, .external_lex_state = 223},
  [7790] = {.lex_state = 60, .external_lex_state = 121},
  [7791] = {.lex_state = 56, .external_lex_state = 74},
  [7792] = {.lex_state = 56, .external_lex_state = 73},
  [7793] = {.lex_state = 56, .external_lex_state = 71},
  [7794] = {.lex_state = 56, .external_lex_state = 73},
  [7795] = {.lex_state = 56, .external_lex_state = 77},
  [7796] = {.lex_state = 56, .external_lex_state = 223},
  [7797] = {.lex_state = 56, .external_lex_state = 71},
  [7798] = {.lex_state = 56, .external_lex_state = 75},
  [7799] = {.lex_state = 56, .external_lex_state = 75},
  [7800] = {.lex_state = 56, .external_lex_state = 76},
  [7801] = {.lex_state = 56, .external_lex_state = 76},
  [7802] = {.lex_state = 56, .external_lex_state = 71},
  [7803] = {.lex_state = 56, .external_lex_state = 76},
  [7804] = {.lex_state = 56, .external_lex_state = 76},
  [7805] = {.lex_state = 56, .external_lex_state = 73},
  [7806] = {.lex_state = 56, .external_lex_state = 71},
  [7807] = {.lex_state = 56, .external_lex_state = 72},
  [7808] = {.lex_state = 56, .external_lex_state = 75},
  [7809] = {.lex_state = 56, .external_lex_state = 75},
  [7810] = {.lex_state = 56, .external_lex_state = 75},
  [7811] = {.lex_state = 56, .external_lex_state = 77},
  [7812] = {.lex_state = 56, .external_lex_state = 77},
  [7813] = {.lex_state = 56, .external_lex_state = 77},
  [7814] = {.lex_state = 56, .external_lex_state = 76},
  [7815] = {.lex_state = 56, .external_lex_state = 71},
  [7816] = {.lex_state = 56, .external_lex_state = 77},
  [7817] = {.lex_state = 56, .external_lex_state = 75},
  [7818] = {.lex_state = 56, .external_lex_state = 75},
  [7819] = {.lex_state = 56, .external_lex_state = 75},
  [7820] = {.lex_state = 56, .external_lex_state = 75},
  [7821] = {.lex_state = 56, .external_lex_state = 75},
  [7822] = {.lex_state = 56, .external_lex_state = 75},
  [7823] = {.lex_state = 56, .external_lex_state = 74},
  [7824] = {.lex_state = 56, .external_lex_state = 71},
  [7825] = {.lex_state = 56, .external_lex_state = 75},
  [7826] = {.lex_state = 56, .external_lex_state = 74},
  [7827] = {.lex_state = 56, .external_lex_state = 77},
  [7828] = {.lex_state = 56, .external_lex_state = 77},
  [7829] = {.lex_state = 56, .external_lex_state = 77},
  [7830] = {.lex_state = 56, .external_lex_state = 77},
  [7831] = {.lex_state = 56, .external_lex_state = 71},
  [7832] = {.lex_state = 56, .external_lex_state = 76},
  [7833] = {.lex_state = 56, .external_lex_state = 77},
  [7834] = {.lex_state = 56, .external_lex_state = 76},
  [7835] = {.lex_state = 56, .external_lex_state = 76},
  [7836] = {.lex_state = 56, .external_lex_state = 76},
  [7837] = {.lex_state = 56, .external_lex_state = 225},
  [7838] = {.lex_state = 60, .external_lex_state = 121},
  [7839] = {.lex_state = 56, .external_lex_state = 71},
  [7840] = {.lex_state = 56, .external_lex_state = 74},
  [7841] = {.lex_state = 56, .external_lex_state = 75},
  [7842] = {.lex_state = 56, .external_lex_state = 75},
  [7843] = {.lex_state = 56, .external_lex_state = 77},
  [7844] = {.lex_state = 56, .external_lex_state = 77},
  [7845] = {.lex_state = 56, .external_lex_state = 75},
  [7846] = {.lex_state = 56, .external_lex_state = 76},
  [7847] = {.lex_state = 56, .external_lex_state = 77},
  [7848] = {.lex_state = 56, .external_lex_state = 224},
  [7849] = {.lex_state = 56, .external_lex_state = 71},
  [7850] = {.lex_state = 56, .external_lex_state = 77},
  [7851] = {.lex_state = 56, .external_lex_state = 73},
  [7852] = {.lex_state = 56, .external_lex_state = 77},
  [7853] = {.lex_state = 56, .external_lex_state = 77},
  [7854] = {.lex_state = 56, .external_lex_state = 76},
  [7855] = {.lex_state = 56, .external_lex_state = 73},
  [7856] = {.lex_state = 56, .external_lex_state = 75},
  [7857] = {.lex_state = 56, .external_lex_state = 77},
  [7858] = {.lex_state = 56, .external_lex_state = 73},
  [7859] = {.lex_state = 56, .external_lex_state = 76},
  [7860] = {.lex_state = 56, .external_lex_state = 71},
  [7861] = {.lex_state = 56, .external_lex_state = 77},
  [7862] = {.lex_state = 56, .external_lex_state = 77},
  [7863] = {.lex_state = 60, .external_lex_state = 121},
  [7864] = {.lex_state = 56, .external_lex_state = 77},
  [7865] = {.lex_state = 56, .external_lex_state = 74},
  [7866] = {.lex_state = 56, .external_lex_state = 74},
  [7867] = {.lex_state = 56, .external_lex_state = 226},
  [7868] = {.lex_state = 56, .external_lex_state = 77},
  [7869] = {.lex_state = 56, .external_lex_state = 75},
  [7870] = {.lex_state = 56, .external_lex_state = 76},
  [7871] = {.lex_state = 56, .external_lex_state = 77},
  [7872] = {.lex_state = 56, .external_lex_state = 74},
  [7873] = {.lex_state = 56, .external_lex_state = 74},
  [7874] = {.lex_state = 56, .external_lex_state = 77},
  [7875] = {.lex_state = 56, .external_lex_state = 77},
  [7876] = {.lex_state = 56, .external_lex_state = 77},
  [7877] = {.lex_state = 56, .external_lex_state = 74},
  [7878] = {.lex_state = 56, .external_lex_state = 77},
  [7879] = {.lex_state = 56, .external_lex_state = 77},
  [7880] = {.lex_state = 56, .external_lex_state = 77},
  [7881] = {.lex_state = 56, .external_lex_state = 219},
  [7882] = {.lex_state = 56, .external_lex_state = 226},
  [7883] = {.lex_state = 56, .external_lex_state = 219},
  [7884] = {.lex_state = 56, .external_lex_state = 75},
  [7885] = {.lex_state = 56, .external_lex_state = 85},
  [7886] = {.lex_state = 56, .external_lex_state = 80},
  [7887] = {.lex_state = 56, .external_lex_state = 79},
  [7888] = {.lex_state = 56, .external_lex_state = 79},
  [7889] = {.lex_state = 56, .external_lex_state = 78},
  [7890] = {.lex_state = 56, .external_lex_state = 78},
  [7891] = {.lex_state = 56, .external_lex_state = 78},
  [7892] = {.lex_state = 56, .external_lex_state = 81},
  [7893] = {.lex_state = 56, .external_lex_state = 78},
  [7894] = {.lex_state = 56, .external_lex_state = 78},
  [7895] = {.lex_state = 56, .external_lex_state = 227},
  [7896] = {.lex_state = 56, .external_lex_state = 78},
  [7897] = {.lex_state = 56, .external_lex_state = 78},
  [7898] = {.lex_state = 56, .external_lex_state = 78},
  [7899] = {.lex_state = 56, .external_lex_state = 79},
  [7900] = {.lex_state = 56, .external_lex_state = 80},
  [7901] = {.lex_state = 56, .external_lex_state = 79},
  [7902] = {.lex_state = 56, .external_lex_state = 83},
  [7903] = {.lex_state = 56, .external_lex_state = 78},
  [7904] = {.lex_state = 56, .external_lex_state = 78},
  [7905] = {.lex_state = 56, .external_lex_state = 84},
  [7906] = {.lex_state = 56, .external_lex_state = 79},
  [7907] = {.lex_state = 56, .external_lex_state = 78},
  [7908] = {.lex_state = 56, .external_lex_state = 79},
  [7909] = {.lex_state = 56, .external_lex_state = 84},
  [7910] = {.lex_state = 56, .external_lex_state = 78},
  [7911] = {.lex_state = 56, .external_lex_state = 78},
  [7912] = {.lex_state = 56, .external_lex_state = 84},
  [7913] = {.lex_state = 56, .external_lex_state = 81},
  [7914] = {.lex_state = 56, .external_lex_state = 79},
  [7915] = {.lex_state = 56, .external_lex_state = 81},
  [7916] = {.lex_state = 56, .external_lex_state = 79},
  [7917] = {.lex_state = 56, .external_lex_state = 81},
  [7918] = {.lex_state = 56, .external_lex_state = 78},
  [7919] = {.lex_state = 56, .external_lex_state = 79},
  [7920] = {.lex_state = 56, .external_lex_state = 81},
  [7921] = {.lex_state = 56, .external_lex_state = 79},
  [7922] = {.lex_state = 56, .external_lex_state = 79},
  [7923] = {.lex_state = 56, .external_lex_state = 81},
  [7924] = {.lex_state = 55, .external_lex_state = 121},
  [7925] = {.lex_state = 56, .external_lex_state = 78},
  [7926] = {.lex_state = 56, .external_lex_state = 78},
  [7927] = {.lex_state = 56, .external_lex_state = 78},
  [7928] = {.lex_state = 56, .external_lex_state = 78},
  [7929] = {.lex_state = 55, .external_lex_state = 121},
  [7930] = {.lex_state = 56, .external_lex_state = 80},
  [7931] = {.lex_state = 56, .external_lex_state = 79},
  [7932] = {.lex_state = 56, .external_lex_state = 80},
  [7933] = {.lex_state = 56, .external_lex_state = 79},
  [7934] = {.lex_state = 56, .external_lex_state = 80},
  [7935] = {.lex_state = 56, .external_lex_state = 80},
  [7936] = {.lex_state = 56, .external_lex_state = 80},
  [7937] = {.lex_state = 56, .external_lex_state = 79},
  [7938] = {.lex_state = 56, .external_lex_state = 80},
  [7939] = {.lex_state = 56, .external_lex_state = 79},
  [7940] = {.lex_state = 56, .external_lex_state = 82},
  [7941] = {.lex_state = 56, .external_lex_state = 80},
  [7942] = {.lex_state = 56, .external_lex_state = 78},
  [7943] = {.lex_state = 56, .external_lex_state = 83},
  [7944] = {.lex_state = 56, .external_lex_state = 79},
  [7945] = {.lex_state = 56, .external_lex_state = 78},
  [7946] = {.lex_state = 56, .external_lex_state = 79},
  [7947] = {.lex_state = 56, .external_lex_state = 78},
  [7948] = {.lex_state = 56, .external_lex_state = 79},
  [7949] = {.lex_state = 56, .external_lex_state = 81},
  [7950] = {.lex_state = 56, .external_lex_state = 79},
  [7951] = {.lex_state = 56, .external_lex_state = 80},
  [7952] = {.lex_state = 56, .external_lex_state = 79},
  [7953] = {.lex_state = 56, .external_lex_state = 84},
  [7954] = {.lex_state = 56, .external_lex_state = 83},
  [7955] = {.lex_state = 56, .external_lex_state = 78},
  [7956] = {.lex_state = 56, .external_lex_state = 82},
  [7957] = {.lex_state = 56, .external_lex_state = 78},
  [7958] = {.lex_state = 56, .external_lex_state = 83},
  [7959] = {.lex_state = 56, .external_lex_state = 78},
  [7960] = {.lex_state = 56, .external_lex_state = 79},
  [7961] = {.lex_state = 56, .external_lex_state = 83},
  [7962] = {.lex_state = 56, .external_lex_state = 84},
  [7963] = {.lex_state = 56, .external_lex_state = 79},
  [7964] = {.lex_state = 56, .external_lex_state = 227},
  [7965] = {.lex_state = 56, .external_lex_state = 82},
  [7966] = {.lex_state = 56, .external_lex_state = 82},
  [7967] = {.lex_state = 56, .external_lex_state = 84},
  [7968] = {.lex_state = 56, .external_lex_state = 84},
  [7969] = {.lex_state = 56, .external_lex_state = 82},
  [7970] = {.lex_state = 56, .external_lex_state = 79},
  [7971] = {.lex_state = 56, .external_lex_state = 85},
  [7972] = {.lex_state = 56, .external_lex_state = 78},
  [7973] = {.lex_state = 56, .external_lex_state = 85},
  [7974] = {.lex_state = 56, .external_lex_state = 85},
  [7975] = {.lex_state = 56, .external_lex_state = 82},
  [7976] = {.lex_state = 56, .external_lex_state = 82},
  [7977] = {.lex_state = 56, .external_lex_state = 82},
  [7978] = {.lex_state = 56, .external_lex_state = 85},
  [7979] = {.lex_state = 56, .external_lex_state = 85},
  [7980] = {.lex_state = 56, .external_lex_state = 81},
  [7981] = {.lex_state = 56, .external_lex_state = 81},
  [7982] = {.lex_state = 56, .external_lex_state = 78},
  [7983] = {.lex_state = 56, .external_lex_state = 82},
  [7984] = {.lex_state = 56, .external_lex_state = 85},
  [7985] = {.lex_state = 56, .external_lex_state = 84},
  [7986] = {.lex_state = 56, .external_lex_state = 82},
  [7987] = {.lex_state = 56, .external_lex_state = 85},
  [7988] = {.lex_state = 56, .external_lex_state = 85},
  [7989] = {.lex_state = 56, .external_lex_state = 79},
  [7990] = {.lex_state = 56, .external_lex_state = 227},
  [7991] = {.lex_state = 56, .external_lex_state = 83},
  [7992] = {.lex_state = 56, .external_lex_state = 83},
  [7993] = {.lex_state = 56, .external_lex_state = 85},
  [7994] = {.lex_state = 56, .external_lex_state = 83},
  [7995] = {.lex_state = 55, .external_lex_state = 121},
  [7996] = {.lex_state = 56, .external_lex_state = 81},
  [7997] = {.lex_state = 56, .external_lex_state = 83},
  [7998] = {.lex_state = 56, .external_lex_state = 83},
  [7999] = {.lex_state = 56, .external_lex_state = 85},
  [8000] = {.lex_state = 56, .external_lex_state = 80},
  [8001] = {.lex_state = 56, .external_lex_state = 83},
  [8002] = {.lex_state = 56, .external_lex_state = 85},
  [8003] = {.lex_state = 56, .external_lex_state = 80},
  [8004] = {.lex_state = 56, .external_lex_state = 83},
  [8005] = {.lex_state = 56, .external_lex_state = 82},
  [8006] = {.lex_state = 56, .external_lex_state = 83},
  [8007] = {.lex_state = 56, .external_lex_state = 85},
  [8008] = {.lex_state = 56, .external_lex_state = 85},
  [8009] = {.lex_state = 56, .external_lex_state = 81},
  [8010] = {.lex_state = 56, .external_lex_state = 81},
  [8011] = {.lex_state = 56, .external_lex_state = 81},
  [8012] = {.lex_state = 56, .external_lex_state = 81},
  [8013] = {.lex_state = 56, .external_lex_state = 83},
  [8014] = {.lex_state = 56, .external_lex_state = 84},
  [8015] = {.lex_state = 56, .external_lex_state = 81},
  [8016] = {.lex_state = 56, .external_lex_state = 84},
  [8017] = {.lex_state = 56, .external_lex_state = 80},
  [8018] = {.lex_state = 56, .external_lex_state = 81},
  [8019] = {.lex_state = 56, .external_lex_state = 82},
  [8020] = {.lex_state = 56, .external_lex_state = 84},
  [8021] = {.lex_state = 56, .external_lex_state = 81},
  [8022] = {.lex_state = 56, .external_lex_state = 83},
  [8023] = {.lex_state = 56, .external_lex_state = 78},
  [8024] = {.lex_state = 56, .external_lex_state = 79},
  [8025] = {.lex_state = 56, .external_lex_state = 83},
  [8026] = {.lex_state = 56, .external_lex_state = 81},
  [8027] = {.lex_state = 56, .external_lex_state = 81},
  [8028] = {.lex_state = 56, .external_lex_state = 85},
  [8029] = {.lex_state = 56, .external_lex_state = 78},
  [8030] = {.lex_state = 55, .external_lex_state = 121},
  [8031] = {.lex_state = 56, .external_lex_state = 83},
  [8032] = {.lex_state = 56, .external_lex_state = 84},
  [8033] = {.lex_state = 56, .external_lex_state = 81},
  [8034] = {.lex_state = 56, .external_lex_state = 83},
  [8035] = {.lex_state = 56, .external_lex_state = 83},
  [8036] = {.lex_state = 56, .external_lex_state = 78},
  [8037] = {.lex_state = 56, .external_lex_state = 228},
  [8038] = {.lex_state = 56, .external_lex_state = 85},
  [8039] = {.lex_state = 56, .external_lex_state = 79},
  [8040] = {.lex_state = 56, .external_lex_state = 81},
  [8041] = {.lex_state = 56, .external_lex_state = 85},
  [8042] = {.lex_state = 56, .external_lex_state = 85},
  [8043] = {.lex_state = 56, .external_lex_state = 79},
  [8044] = {.lex_state = 57, .external_lex_state = 229},
  [8045] = {.lex_state = 56, .external_lex_state = 79},
  [8046] = {.lex_state = 56, .external_lex_state = 79},
  [8047] = {.lex_state = 56, .external_lex_state = 81},
  [8048] = {.lex_state = 56, .external_lex_state = 85},
  [8049] = {.lex_state = 56, .external_lex_state = 81},
  [8050] = {.lex_state = 56, .external_lex_state = 80},
  [8051] = {.lex_state = 56, .external_lex_state = 84},
  [8052] = {.lex_state = 56, .external_lex_state = 81},
  [8053] = {.lex_state = 56, .external_lex_state = 80},
  [8054] = {.lex_state = 56, .external_lex_state = 80},
  [8055] = {.lex_state = 56, .external_lex_state = 83},
  [8056] = {.lex_state = 56, .external_lex_state = 78},
  [8057] = {.lex_state = 56, .external_lex_state = 80},
  [8058] = {.lex_state = 56, .external_lex_state = 79},
  [8059] = {.lex_state = 56, .external_lex_state = 82},
  [8060] = {.lex_state = 56, .external_lex_state = 79},
  [8061] = {.lex_state = 56, .external_lex_state = 80},
  [8062] = {.lex_state = 56, .external_lex_state = 83},
  [8063] = {.lex_state = 56, .external_lex_state = 84},
  [8064] = {.lex_state = 56, .external_lex_state = 85},
  [8065] = {.lex_state = 56, .external_lex_state = 80},
  [8066] = {.lex_state = 56, .external_lex_state = 78},
  [8067] = {.lex_state = 56, .external_lex_state = 84},
  [8068] = {.lex_state = 56, .external_lex_state = 83},
  [8069] = {.lex_state = 56, .external_lex_state = 82},
  [8070] = {.lex_state = 56, .external_lex_state = 80},
  [8071] = {.lex_state = 56, .external_lex_state = 82},
  [8072] = {.lex_state = 56, .external_lex_state = 85},
  [8073] = {.lex_state = 56, .external_lex_state = 82},
  [8074] = {.lex_state = 56, .external_lex_state = 81},
  [8075] = {.lex_state = 56, .external_lex_state = 81},
  [8076] = {.lex_state = 56, .external_lex_state = 83},
  [8077] = {.lex_state = 56, .external_lex_state = 82},
  [8078] = {.lex_state = 56, .external_lex_state = 82},
  [8079] = {.lex_state = 56, .external_lex_state = 85},
  [8080] = {.lex_state = 56, .external_lex_state = 84},
  [8081] = {.lex_state = 56, .external_lex_state = 85},
  [8082] = {.lex_state = 56, .external_lex_state = 84},
  [8083] = {.lex_state = 56, .external_lex_state = 84},
  [8084] = {.lex_state = 56, .external_lex_state = 81},
  [8085] = {.lex_state = 56, .external_lex_state = 83},
  [8086] = {.lex_state = 56, .external_lex_state = 81},
  [8087] = {.lex_state = 56, .external_lex_state = 82},
  [8088] = {.lex_state = 56, .external_lex_state = 80},
  [8089] = {.lex_state = 56, .external_lex_state = 80},
  [8090] = {.lex_state = 56, .external_lex_state = 82},
  [8091] = {.lex_state = 56, .external_lex_state = 83},
  [8092] = {.lex_state = 56, .external_lex_state = 79},
  [8093] = {.lex_state = 57, .external_lex_state = 230},
  [8094] = {.lex_state = 56, .external_lex_state = 85},
  [8095] = {.lex_state = 56, .external_lex_state = 85},
  [8096] = {.lex_state = 56, .external_lex_state = 85},
  [8097] = {.lex_state = 56, .external_lex_state = 85},
  [8098] = {.lex_state = 56, .external_lex_state = 78},
  [8099] = {.lex_state = 56, .external_lex_state = 83},
  [8100] = {.lex_state = 56, .external_lex_state = 78},
  [8101] = {.lex_state = 56, .external_lex_state = 81},
  [8102] = {.lex_state = 56, .external_lex_state = 84},
  [8103] = {.lex_state = 56, .external_lex_state = 81},
  [8104] = {.lex_state = 56, .external_lex_state = 85},
  [8105] = {.lex_state = 56, .external_lex_state = 81},
  [8106] = {.lex_state = 56, .external_lex_state = 85},
  [8107] = {.lex_state = 56, .external_lex_state = 83},
  [8108] = {.lex_state = 56, .external_lex_state = 84},
  [8109] = {.lex_state = 56, .external_lex_state = 85},
  [8110] = {.lex_state = 56, .external_lex_state = 78},
  [8111] = {.lex_state = 56, .external_lex_state = 85},
  [8112] = {.lex_state = 56, .external_lex_state = 83},
  [8113] = {.lex_state = 56, .external_lex_state = 82},
  [8114] = {.lex_state = 56, .external_lex_state = 84},
  [8115] = {.lex_state = 56, .external_lex_state = 78},
  [8116] = {.lex_state = 56, .external_lex_state = 81},
  [8117] = {.lex_state = 56, .external_lex_state = 80},
  [8118] = {.lex_state = 56, .external_lex_state = 84},
  [8119] = {.lex_state = 56, .external_lex_state = 82},
  [8120] = {.lex_state = 56, .external_lex_state = 80},
  [8121] = {.lex_state = 55, .external_lex_state = 121},
  [8122] = {.lex_state = 56, .external_lex_state = 82},
  [8123] = {.lex_state = 56, .external_lex_state = 82},
  [8124] = {.lex_state = 56, .external_lex_state = 82},
  [8125] = {.lex_state = 56, .external_lex_state = 82},
  [8126] = {.lex_state = 56, .external_lex_state = 82},
  [8127] = {.lex_state = 56, .external_lex_state = 78},
  [8128] = {.lex_state = 56, .external_lex_state = 85},
  [8129] = {.lex_state = 56, .external_lex_state = 82},
  [8130] = {.lex_state = 56, .external_lex_state = 84},
  [8131] = {.lex_state = 56, .external_lex_state = 80},
  [8132] = {.lex_state = 56, .external_lex_state = 80},
  [8133] = {.lex_state = 56, .external_lex_state = 84},
  [8134] = {.lex_state = 56, .external_lex_state = 82},
  [8135] = {.lex_state = 56, .external_lex_state = 80},
  [8136] = {.lex_state = 56, .external_lex_state = 80},
  [8137] = {.lex_state = 56, .external_lex_state = 79},
  [8138] = {.lex_state = 56, .external_lex_state = 228},
  [8139] = {.lex_state = 56, .external_lex_state = 85},
  [8140] = {.lex_state = 56, .external_lex_state = 82},
  [8141] = {.lex_state = 56, .external_lex_state = 82},
  [8142] = {.lex_state = 56, .external_lex_state = 80},
  [8143] = {.lex_state = 56, .external_lex_state = 80},
  [8144] = {.lex_state = 56, .external_lex_state = 84},
  [8145] = {.lex_state = 56, .external_lex_state = 84},
  [8146] = {.lex_state = 56, .external_lex_state = 80},
  [8147] = {.lex_state = 56, .external_lex_state = 82},
  [8148] = {.lex_state = 56, .external_lex_state = 82},
  [8149] = {.lex_state = 56, .external_lex_state = 83},
  [8150] = {.lex_state = 56, .external_lex_state = 82},
  [8151] = {.lex_state = 56, .external_lex_state = 84},
  [8152] = {.lex_state = 56, .external_lex_state = 85},
  [8153] = {.lex_state = 56, .external_lex_state = 228},
  [8154] = {.lex_state = 56, .external_lex_state = 85},
  [8155] = {.lex_state = 56, .external_lex_state = 84},
  [8156] = {.lex_state = 56, .external_lex_state = 228},
  [8157] = {.lex_state = 56, .external_lex_state = 81},
  [8158] = {.lex_state = 56, .external_lex_state = 83},
  [8159] = {.lex_state = 56, .external_lex_state = 80},
  [8160] = {.lex_state = 56, .external_lex_state = 228},
  [8161] = {.lex_state = 56, .external_lex_state = 84},
  [8162] = {.lex_state = 56, .external_lex_state = 84},
  [8163] = {.lex_state = 56, .external_lex_state = 84},
  [8164] = {.lex_state = 56, .external_lex_state = 85},
  [8165] = {.lex_state = 56, .external_lex_state = 80},
  [8166] = {.lex_state = 56, .external_lex_state = 83},
  [8167] = {.lex_state = 56, .external_lex_state = 83},
  [8168] = {.lex_state = 56, .external_lex_state = 80},
  [8169] = {.lex_state = 56, .external_lex_state = 79},
  [8170] = {.lex_state = 56, .external_lex_state = 83},
  [8171] = {.lex_state = 56, .external_lex_state = 79},
  [8172] = {.lex_state = 56, .external_lex_state = 83},
  [8173] = {.lex_state = 56, .external_lex_state = 83},
  [8174] = {.lex_state = 56, .external_lex_state = 81},
  [8175] = {.lex_state = 56, .external_lex_state = 81},
  [8176] = {.lex_state = 55, .external_lex_state = 121},
  [8177] = {.lex_state = 56, .external_lex_state = 79},
  [8178] = {.lex_state = 56, .external_lex_state = 80},
  [8179] = {.lex_state = 56, .external_lex_state = 84},
  [8180] = {.lex_state = 56, .external_lex_state = 81},
  [8181] = {.lex_state = 56, .external_lex_state = 83},
  [8182] = {.lex_state = 56, .external_lex_state = 84},
  [8183] = {.lex_state = 56, .external_lex_state = 80},
  [8184] = {.lex_state = 56, .external_lex_state = 84},
  [8185] = {.lex_state = 56, .external_lex_state = 82},
  [8186] = {.lex_state = 56, .external_lex_state = 82},
  [8187] = {.lex_state = 56, .external_lex_state = 228},
  [8188] = {.lex_state = 56, .external_lex_state = 84},
  [8189] = {.lex_state = 56, .external_lex_state = 84},
  [8190] = {.lex_state = 56, .external_lex_state = 88},
  [8191] = {.lex_state = 55, .external_lex_state = 231},
  [8192] = {.lex_state = 56, .external_lex_state = 88},
  [8193] = {.lex_state = 56, .external_lex_state = 88},
  [8194] = {.lex_state = 57, .external_lex_state = 232},
  [8195] = {.lex_state = 56, .external_lex_state = 88},
  [8196] = {.lex_state = 56, .external_lex_state = 88},
  [8197] = {.lex_state = 55, .external_lex_state = 231},
  [8198] = {.lex_state = 55, .external_lex_state = 30},
  [8199] = {.lex_state = 57, .external_lex_state = 233},
  [8200] = {.lex_state = 56, .external_lex_state = 88},
  [8201] = {.lex_state = 56, .external_lex_state = 88},
  [8202] = {.lex_state = 56, .external_lex_state = 88},
  [8203] = {.lex_state = 56, .external_lex_state = 88},
  [8204] = {.lex_state = 56, .external_lex_state = 88},
  [8205] = {.lex_state = 56, .external_lex_state = 88},
  [8206] = {.lex_state = 56, .external_lex_state = 88},
  [8207] = {.lex_state = 56, .external_lex_state = 88},
  [8208] = {.lex_state = 56, .external_lex_state = 88},
  [8209] = {.lex_state = 56, .external_lex_state = 88},
  [8210] = {.lex_state = 56, .external_lex_state = 88},
  [8211] = {.lex_state = 56, .external_lex_state = 88},
  [8212] = {.lex_state = 57, .external_lex_state = 234},
  [8213] = {.lex_state = 56, .external_lex_state = 227},
  [8214] = {.lex_state = 57, .external_lex_state = 235},
  [8215] = {.lex_state = 57, .external_lex_state = 236},
  [8216] = {.lex_state = 56, .external_lex_state = 88},
  [8217] = {.lex_state = 56, .external_lex_state = 88},
  [8218] = {.lex_state = 56, .external_lex_state = 92},
  [8219] = {.lex_state = 56, .external_lex_state = 88},
  [8220] = {.lex_state = 56, .external_lex_state = 88},
  [8221] = {.lex_state = 56, .external_lex_state = 88},
  [8222] = {.lex_state = 56, .external_lex_state = 227},
  [8223] = {.lex_state = 56, .external_lex_state = 88},
  [8224] = {.lex_state = 55, .external_lex_state = 231},
  [8225] = {.lex_state = 56, .external_lex_state = 88},
  [8226] = {.lex_state = 56, .external_lex_state = 88},
  [8227] = {.lex_state = 5, .external_lex_state = 92},
  [8228] = {.lex_state = 56, .external_lex_state = 88},
  [8229] = {.lex_state = 56, .external_lex_state = 88},
  [8230] = {.lex_state = 56, .external_lex_state = 88},
  [8231] = {.lex_state = 56, .external_lex_state = 88},
  [8232] = {.lex_state = 57, .external_lex_state = 237},
  [8233] = {.lex_state = 56, .external_lex_state = 88},
  [8234] = {.lex_state = 56, .external_lex_state = 88},
  [8235] = {.lex_state = 55, .external_lex_state = 86},
  [8236] = {.lex_state = 56, .external_lex_state = 227},
  [8237] = {.lex_state = 56, .external_lex_state = 88},
  [8238] = {.lex_state = 56, .external_lex_state = 88},
  [8239] = {.lex_state = 56, .external_lex_state = 88},
  [8240] = {.lex_state = 55, .external_lex_state = 231},
  [8241] = {.lex_state = 56, .external_lex_state = 92},
  [8242] = {.lex_state = 55, .external_lex_state = 231},
  [8243] = {.lex_state = 55, .external_lex_state = 231},
  [8244] = {.lex_state = 56, .external_lex_state = 88},
  [8245] = {.lex_state = 56, .external_lex_state = 88},
  [8246] = {.lex_state = 57, .external_lex_state = 238},
  [8247] = {.lex_state = 56, .external_lex_state = 92},
  [8248] = {.lex_state = 56, .external_lex_state = 92},
  [8249] = {.lex_state = 57, .external_lex_state = 239},
  [8250] = {.lex_state = 56, .external_lex_state = 92},
  [8251] = {.lex_state = 55, .external_lex_state = 86},
  [8252] = {.lex_state = 57, .external_lex_state = 240},
  [8253] = {.lex_state = 56, .external_lex_state = 98},
  [8254] = {.lex_state = 55, .external_lex_state = 86},
  [8255] = {.lex_state = 55, .external_lex_state = 241},
  [8256] = {.lex_state = 55, .external_lex_state = 3},
  [8257] = {.lex_state = 55, .external_lex_state = 86},
  [8258] = {.lex_state = 56, .external_lex_state = 92},
  [8259] = {.lex_state = 55, .external_lex_state = 3},
  [8260] = {.lex_state = 55, .external_lex_state = 3},
  [8261] = {.lex_state = 56, .external_lex_state = 92},
  [8262] = {.lex_state = 55, .external_lex_state = 3},
  [8263] = {.lex_state = 55, .external_lex_state = 242},
  [8264] = {.lex_state = 56, .external_lex_state = 92},
  [8265] = {.lex_state = 56, .external_lex_state = 92},
  [8266] = {.lex_state = 57, .external_lex_state = 243},
  [8267] = {.lex_state = 56, .external_lex_state = 92},
  [8268] = {.lex_state = 55, .external_lex_state = 231},
  [8269] = {.lex_state = 57, .external_lex_state = 244},
  [8270] = {.lex_state = 55, .external_lex_state = 241},
  [8271] = {.lex_state = 60, .external_lex_state = 86},
  [8272] = {.lex_state = 56, .external_lex_state = 92},
  [8273] = {.lex_state = 56, .external_lex_state = 92},
  [8274] = {.lex_state = 56, .external_lex_state = 92},
  [8275] = {.lex_state = 56, .external_lex_state = 92},
  [8276] = {.lex_state = 56, .external_lex_state = 92},
  [8277] = {.lex_state = 55, .external_lex_state = 3},
  [8278] = {.lex_state = 55, .external_lex_state = 231},
  [8279] = {.lex_state = 55, .external_lex_state = 86},
  [8280] = {.lex_state = 56, .external_lex_state = 92},
  [8281] = {.lex_state = 56, .external_lex_state = 92},
  [8282] = {.lex_state = 56, .external_lex_state = 92},
  [8283] = {.lex_state = 55, .external_lex_state = 86},
  [8284] = {.lex_state = 55, .external_lex_state = 231},
  [8285] = {.lex_state = 56, .external_lex_state = 92},
  [8286] = {.lex_state = 56, .external_lex_state = 92},
  [8287] = {.lex_state = 55, .external_lex_state = 89},
  [8288] = {.lex_state = 56, .external_lex_state = 92},
  [8289] = {.lex_state = 55, .external_lex_state = 3},
  [8290] = {.lex_state = 56, .external_lex_state = 92},
  [8291] = {.lex_state = 56, .external_lex_state = 92},
  [8292] = {.lex_state = 56, .external_lex_state = 92},
  [8293] = {.lex_state = 56, .external_lex_state = 92},
  [8294] = {.lex_state = 55, .external_lex_state = 3},
  [8295] = {.lex_state = 55, .external_lex_state = 87},
  [8296] = {.lex_state = 57, .external_lex_state = 245},
  [8297] = {.lex_state = 57, .external_lex_state = 246},
  [8298] = {.lex_state = 57, .external_lex_state = 247},
  [8299] = {.lex_state = 56, .external_lex_state = 92},
  [8300] = {.lex_state = 56, .external_lex_state = 92},
  [8301] = {.lex_state = 56, .external_lex_state = 92},
  [8302] = {.lex_state = 55, .external_lex_state = 3},
  [8303] = {.lex_state = 56, .external_lex_state = 92},
  [8304] = {.lex_state = 57, .external_lex_state = 248},
  [8305] = {.lex_state = 60, .external_lex_state = 86},
  [8306] = {.lex_state = 55, .external_lex_state = 86},
  [8307] = {.lex_state = 55, .external_lex_state = 3},
  [8308] = {.lex_state = 56, .external_lex_state = 92},
  [8309] = {.lex_state = 56, .external_lex_state = 92},
  [8310] = {.lex_state = 56, .external_lex_state = 92},
  [8311] = {.lex_state = 55, .external_lex_state = 241},
  [8312] = {.lex_state = 56, .external_lex_state = 92},
  [8313] = {.lex_state = 56, .external_lex_state = 97},
  [8314] = {.lex_state = 55, .external_lex_state = 37},
  [8315] = {.lex_state = 55, .external_lex_state = 37},
  [8316] = {.lex_state = 55, .external_lex_state = 86},
  [8317] = {.lex_state = 55, .external_lex_state = 37},
  [8318] = {.lex_state = 56, .external_lex_state = 249},
  [8319] = {.lex_state = 55, .external_lex_state = 86},
  [8320] = {.lex_state = 55, .external_lex_state = 37},
  [8321] = {.lex_state = 55, .external_lex_state = 37},
  [8322] = {.lex_state = 55, .external_lex_state = 37},
  [8323] = {.lex_state = 55, .external_lex_state = 37},
  [8324] = {.lex_state = 55, .external_lex_state = 86},
  [8325] = {.lex_state = 55, .external_lex_state = 37},
  [8326] = {.lex_state = 55, .external_lex_state = 37},
  [8327] = {.lex_state = 55, .external_lex_state = 37},
  [8328] = {.lex_state = 55, .external_lex_state = 86},
  [8329] = {.lex_state = 55, .external_lex_state = 86},
  [8330] = {.lex_state = 55, .external_lex_state = 37},
  [8331] = {.lex_state = 55, .external_lex_state = 37},
  [8332] = {.lex_state = 55, .external_lex_state = 86},
  [8333] = {.lex_state = 55, .external_lex_state = 86},
  [8334] = {.lex_state = 56, .external_lex_state = 250},
  [8335] = {.lex_state = 55, .external_lex_state = 37},
  [8336] = {.lex_state = 55, .external_lex_state = 86},
  [8337] = {.lex_state = 55, .external_lex_state = 86},
  [8338] = {.lex_state = 55, .external_lex_state = 86},
  [8339] = {.lex_state = 60, .external_lex_state = 89},
  [8340] = {.lex_state = 55, .external_lex_state = 140},
  [8341] = {.lex_state = 55, .external_lex_state = 37},
  [8342] = {.lex_state = 55, .external_lex_state = 37},
  [8343] = {.lex_state = 55, .external_lex_state = 89},
  [8344] = {.lex_state = 55, .external_lex_state = 86},
  [8345] = {.lex_state = 55, .external_lex_state = 37},
  [8346] = {.lex_state = 55, .external_lex_state = 37},
  [8347] = {.lex_state = 55, .external_lex_state = 86},
  [8348] = {.lex_state = 55, .external_lex_state = 37},
  [8349] = {.lex_state = 55, .external_lex_state = 86},
  [8350] = {.lex_state = 55, .external_lex_state = 37},
  [8351] = {.lex_state = 55, .external_lex_state = 251},
  [8352] = {.lex_state = 55, .external_lex_state = 86},
  [8353] = {.lex_state = 55, .external_lex_state = 37},
  [8354] = {.lex_state = 55, .external_lex_state = 37},
  [8355] = {.lex_state = 55, .external_lex_state = 37},
  [8356] = {.lex_state = 55, .external_lex_state = 86},
  [8357] = {.lex_state = 55, .external_lex_state = 37},
  [8358] = {.lex_state = 55, .external_lex_state = 86},
  [8359] = {.lex_state = 55, .external_lex_state = 86},
  [8360] = {.lex_state = 55, .external_lex_state = 37},
  [8361] = {.lex_state = 55, .external_lex_state = 37},
  [8362] = {.lex_state = 55, .external_lex_state = 37},
  [8363] = {.lex_state = 55, .external_lex_state = 86},
  [8364] = {.lex_state = 55, .external_lex_state = 37},
  [8365] = {.lex_state = 56, .external_lex_state = 252},
  [8366] = {.lex_state = 55, .external_lex_state = 37},
  [8367] = {.lex_state = 55, .external_lex_state = 86},
  [8368] = {.lex_state = 56, .external_lex_state = 249},
  [8369] = {.lex_state = 55, .external_lex_state = 86},
  [8370] = {.lex_state = 55, .external_lex_state = 37},
  [8371] = {.lex_state = 55, .external_lex_state = 87},
  [8372] = {.lex_state = 55, .external_lex_state = 37},
  [8373] = {.lex_state = 55, .external_lex_state = 86},
  [8374] = {.lex_state = 55, .external_lex_state = 89},
  [8375] = {.lex_state = 55, .external_lex_state = 86},
  [8376] = {.lex_state = 60, .external_lex_state = 87},
  [8377] = {.lex_state = 55, .external_lex_state = 37},
  [8378] = {.lex_state = 55, .external_lex_state = 86},
  [8379] = {.lex_state = 55, .external_lex_state = 86},
  [8380] = {.lex_state = 55, .external_lex_state = 37},
  [8381] = {.lex_state = 55, .external_lex_state = 86},
  [8382] = {.lex_state = 56, .external_lex_state = 249},
  [8383] = {.lex_state = 55, .external_lex_state = 37},
  [8384] = {.lex_state = 55, .external_lex_state = 86},
  [8385] = {.lex_state = 55, .external_lex_state = 37},
  [8386] = {.lex_state = 55, .external_lex_state = 37},
  [8387] = {.lex_state = 55, .external_lex_state = 86},
  [8388] = {.lex_state = 55, .external_lex_state = 37},
  [8389] = {.lex_state = 55, .external_lex_state = 37},
  [8390] = {.lex_state = 55, .external_lex_state = 37},
  [8391] = {.lex_state = 55, .external_lex_state = 37},
  [8392] = {.lex_state = 56, .external_lex_state = 249},
  [8393] = {.lex_state = 55, .external_lex_state = 37},
  [8394] = {.lex_state = 55, .external_lex_state = 37},
  [8395] = {.lex_state = 55, .external_lex_state = 37},
  [8396] = {.lex_state = 55, .external_lex_state = 37},
  [8397] = {.lex_state = 55, .external_lex_state = 86},
  [8398] = {.lex_state = 55, .external_lex_state = 86},
  [8399] = {.lex_state = 55, .external_lex_state = 37},
  [8400] = {.lex_state = 55, .external_lex_state = 37},
  [8401] = {.lex_state = 60, .external_lex_state = 87},
  [8402] = {.lex_state = 57, .external_lex_state = 253},
  [8403] = {.lex_state = 55, .external_lex_state = 241},
  [8404] = {.lex_state = 55, .external_lex_state = 37},
  [8405] = {.lex_state = 55, .external_lex_state = 37},
  [8406] = {.lex_state = 55, .external_lex_state = 37},
  [8407] = {.lex_state = 55, .external_lex_state = 251},
  [8408] = {.lex_state = 55, .external_lex_state = 140},
  [8409] = {.lex_state = 60, .external_lex_state = 89},
  [8410] = {.lex_state = 56, .external_lex_state = 252},
  [8411] = {.lex_state = 55, .external_lex_state = 37},
  [8412] = {.lex_state = 55, .external_lex_state = 37},
  [8413] = {.lex_state = 56, .external_lex_state = 252},
  [8414] = {.lex_state = 55, .external_lex_state = 86},
  [8415] = {.lex_state = 55, .external_lex_state = 37},
  [8416] = {.lex_state = 55, .external_lex_state = 37},
  [8417] = {.lex_state = 55, .external_lex_state = 37},
  [8418] = {.lex_state = 55, .external_lex_state = 37},
  [8419] = {.lex_state = 55, .external_lex_state = 37},
  [8420] = {.lex_state = 55, .external_lex_state = 37},
  [8421] = {.lex_state = 55, .external_lex_state = 37},
  [8422] = {.lex_state = 57, .external_lex_state = 254},
  [8423] = {.lex_state = 55, .external_lex_state = 86},
  [8424] = {.lex_state = 55, .external_lex_state = 37},
  [8425] = {.lex_state = 55, .external_lex_state = 37},
  [8426] = {.lex_state = 55, .external_lex_state = 86},
  [8427] = {.lex_state = 55, .external_lex_state = 86},
  [8428] = {.lex_state = 56, .external_lex_state = 252},
  [8429] = {.lex_state = 55, .external_lex_state = 37},
  [8430] = {.lex_state = 55, .external_lex_state = 37},
  [8431] = {.lex_state = 55, .external_lex_state = 37},
  [8432] = {.lex_state = 55, .external_lex_state = 241},
  [8433] = {.lex_state = 56, .external_lex_state = 252},
  [8434] = {.lex_state = 55, .external_lex_state = 86},
  [8435] = {.lex_state = 55, .external_lex_state = 37},
  [8436] = {.lex_state = 56, .external_lex_state = 252},
  [8437] = {.lex_state = 55, .external_lex_state = 86},
  [8438] = {.lex_state = 55, .external_lex_state = 86},
  [8439] = {.lex_state = 55, .external_lex_state = 140},
  [8440] = {.lex_state = 55, .external_lex_state = 37},
  [8441] = {.lex_state = 55, .external_lex_state = 37},
  [8442] = {.lex_state = 57, .external_lex_state = 255},
  [8443] = {.lex_state = 55, .external_lex_state = 86},
  [8444] = {.lex_state = 55, .external_lex_state = 37},
  [8445] = {.lex_state = 55, .external_lex_state = 37},
  [8446] = {.lex_state = 55, .external_lex_state = 256},
  [8447] = {.lex_state = 55, .external_lex_state = 86},
  [8448] = {.lex_state = 55, .external_lex_state = 37},
  [8449] = {.lex_state = 55, .external_lex_state = 37},
  [8450] = {.lex_state = 55, .external_lex_state = 86},
  [8451] = {.lex_state = 55, .external_lex_state = 37},
  [8452] = {.lex_state = 55, .external_lex_state = 37},
  [8453] = {.lex_state = 55, .external_lex_state = 37},
  [8454] = {.lex_state = 55, .external_lex_state = 90},
  [8455] = {.lex_state = 55, .external_lex_state = 86},
  [8456] = {.lex_state = 55, .external_lex_state = 86},
  [8457] = {.lex_state = 55, .external_lex_state = 37},
  [8458] = {.lex_state = 55, .external_lex_state = 86},
  [8459] = {.lex_state = 55, .external_lex_state = 86},
  [8460] = {.lex_state = 55, .external_lex_state = 86},
  [8461] = {.lex_state = 55, .external_lex_state = 37},
  [8462] = {.lex_state = 55, .external_lex_state = 86},
  [8463] = {.lex_state = 56, .external_lex_state = 250},
  [8464] = {.lex_state = 55, .external_lex_state = 86},
  [8465] = {.lex_state = 55, .external_lex_state = 37},
  [8466] = {.lex_state = 55, .external_lex_state = 256},
  [8467] = {.lex_state = 55, .external_lex_state = 89},
  [8468] = {.lex_state = 55, .external_lex_state = 86},
  [8469] = {.lex_state = 56, .external_lex_state = 249},
  [8470] = {.lex_state = 55, .external_lex_state = 86},
  [8471] = {.lex_state = 55, .external_lex_state = 37},
  [8472] = {.lex_state = 55, .external_lex_state = 37},
  [8473] = {.lex_state = 55, .external_lex_state = 86},
  [8474] = {.lex_state = 55, .external_lex_state = 37},
  [8475] = {.lex_state = 57, .external_lex_state = 257},
  [8476] = {.lex_state = 55, .external_lex_state = 37},
  [8477] = {.lex_state = 55, .external_lex_state = 256},
  [8478] = {.lex_state = 55, .external_lex_state = 86},
  [8479] = {.lex_state = 56, .external_lex_state = 249},
  [8480] = {.lex_state = 55, .external_lex_state = 86},
  [8481] = {.lex_state = 55, .external_lex_state = 86},
  [8482] = {.lex_state = 55, .external_lex_state = 37},
  [8483] = {.lex_state = 57, .external_lex_state = 258},
  [8484] = {.lex_state = 55, .external_lex_state = 37},
  [8485] = {.lex_state = 55, .external_lex_state = 241},
  [8486] = {.lex_state = 56, .external_lex_state = 98},
  [8487] = {.lex_state = 55, .external_lex_state = 256},
  [8488] = {.lex_state = 56, .external_lex_state = 97},
  [8489] = {.lex_state = 55, .external_lex_state = 259},
  [8490] = {.lex_state = 55, .external_lex_state = 95},
  [8491] = {.lex_state = 55, .external_lex_state = 90},
  [8492] = {.lex_state = 55, .external_lex_state = 89},
  [8493] = {.lex_state = 55, .external_lex_state = 259},
  [8494] = {.lex_state = 56, .external_lex_state = 97},
  [8495] = {.lex_state = 56, .external_lex_state = 98},
  [8496] = {.lex_state = 56, .external_lex_state = 98},
  [8497] = {.lex_state = 55, .external_lex_state = 89},
  [8498] = {.lex_state = 55, .external_lex_state = 91},
  [8499] = {.lex_state = 60, .external_lex_state = 90},
  [8500] = {.lex_state = 55, .external_lex_state = 260},
  [8501] = {.lex_state = 55, .external_lex_state = 256},
  [8502] = {.lex_state = 55, .external_lex_state = 90},
  [8503] = {.lex_state = 56, .external_lex_state = 98},
  [8504] = {.lex_state = 55, .external_lex_state = 89},
  [8505] = {.lex_state = 55, .external_lex_state = 87},
  [8506] = {.lex_state = 55, .external_lex_state = 89},
  [8507] = {.lex_state = 55, .external_lex_state = 87},
  [8508] = {.lex_state = 56, .external_lex_state = 98},
  [8509] = {.lex_state = 55, .external_lex_state = 93},
  [8510] = {.lex_state = 55, .external_lex_state = 89},
  [8511] = {.lex_state = 56, .external_lex_state = 98},
  [8512] = {.lex_state = 56, .external_lex_state = 98},
  [8513] = {.lex_state = 56, .external_lex_state = 98},
  [8514] = {.lex_state = 55, .external_lex_state = 87},
  [8515] = {.lex_state = 56, .external_lex_state = 97},
  [8516] = {.lex_state = 56, .external_lex_state = 97},
  [8517] = {.lex_state = 56, .external_lex_state = 97},
  [8518] = {.lex_state = 56, .external_lex_state = 111},
  [8519] = {.lex_state = 55, .external_lex_state = 87},
  [8520] = {.lex_state = 56, .external_lex_state = 97},
  [8521] = {.lex_state = 55, .external_lex_state = 89},
  [8522] = {.lex_state = 56, .external_lex_state = 98},
  [8523] = {.lex_state = 56, .external_lex_state = 97},
  [8524] = {.lex_state = 55, .external_lex_state = 89},
  [8525] = {.lex_state = 56, .external_lex_state = 97},
  [8526] = {.lex_state = 55, .external_lex_state = 89},
  [8527] = {.lex_state = 55, .external_lex_state = 89},
  [8528] = {.lex_state = 55, .external_lex_state = 261},
  [8529] = {.lex_state = 56, .external_lex_state = 98},
  [8530] = {.lex_state = 55, .external_lex_state = 89},
  [8531] = {.lex_state = 55, .external_lex_state = 260},
  [8532] = {.lex_state = 55, .external_lex_state = 89},
  [8533] = {.lex_state = 56, .external_lex_state = 97},
  [8534] = {.lex_state = 56, .external_lex_state = 98},
  [8535] = {.lex_state = 55, .external_lex_state = 89},
  [8536] = {.lex_state = 55, .external_lex_state = 89},
  [8537] = {.lex_state = 55, .external_lex_state = 87},
  [8538] = {.lex_state = 56, .external_lex_state = 98},
  [8539] = {.lex_state = 56, .external_lex_state = 97},
  [8540] = {.lex_state = 56, .external_lex_state = 97},
  [8541] = {.lex_state = 56, .external_lex_state = 98},
  [8542] = {.lex_state = 55, .external_lex_state = 89},
  [8543] = {.lex_state = 56, .external_lex_state = 97},
  [8544] = {.lex_state = 56, .external_lex_state = 97},
  [8545] = {.lex_state = 56, .external_lex_state = 97},
  [8546] = {.lex_state = 56, .external_lex_state = 97},
  [8547] = {.lex_state = 56, .external_lex_state = 97},
  [8548] = {.lex_state = 56, .external_lex_state = 97},
  [8549] = {.lex_state = 56, .external_lex_state = 97},
  [8550] = {.lex_state = 56, .external_lex_state = 98},
  [8551] = {.lex_state = 56, .external_lex_state = 97},
  [8552] = {.lex_state = 55, .external_lex_state = 87},
  [8553] = {.lex_state = 55, .external_lex_state = 89},
  [8554] = {.lex_state = 56, .external_lex_state = 40},
  [8555] = {.lex_state = 55, .external_lex_state = 94},
  [8556] = {.lex_state = 55, .external_lex_state = 89},
  [8557] = {.lex_state = 56, .external_lex_state = 98},
  [8558] = {.lex_state = 55, .external_lex_state = 89},
  [8559] = {.lex_state = 56, .external_lex_state = 40},
  [8560] = {.lex_state = 55, .external_lex_state = 89},
  [8561] = {.lex_state = 56, .external_lex_state = 98},
  [8562] = {.lex_state = 56, .external_lex_state = 40},
  [8563] = {.lex_state = 55, .external_lex_state = 262},
  [8564] = {.lex_state = 56, .external_lex_state = 97},
  [8565] = {.lex_state = 56, .external_lex_state = 40},
  [8566] = {.lex_state = 55, .external_lex_state = 263},
  [8567] = {.lex_state = 56, .external_lex_state = 40},
  [8568] = {.lex_state = 55, .external_lex_state = 89},
  [8569] = {.lex_state = 56, .external_lex_state = 98},
  [8570] = {.lex_state = 56, .external_lex_state = 98},
  [8571] = {.lex_state = 55, .external_lex_state = 89},
  [8572] = {.lex_state = 55, .external_lex_state = 89},
  [8573] = {.lex_state = 55, .external_lex_state = 89},
  [8574] = {.lex_state = 55, .external_lex_state = 263},
  [8575] = {.lex_state = 55, .external_lex_state = 87},
  [8576] = {.lex_state = 55, .external_lex_state = 87},
  [8577] = {.lex_state = 56, .external_lex_state = 40},
  [8578] = {.lex_state = 55, .external_lex_state = 37},
  [8579] = {.lex_state = 55, .external_lex_state = 87},
  [8580] = {.lex_state = 56, .external_lex_state = 98},
  [8581] = {.lex_state = 56, .external_lex_state = 98},
  [8582] = {.lex_state = 56, .external_lex_state = 98},
  [8583] = {.lex_state = 55, .external_lex_state = 87},
  [8584] = {.lex_state = 55, .external_lex_state = 87},
  [8585] = {.lex_state = 55, .external_lex_state = 89},
  [8586] = {.lex_state = 55, .external_lex_state = 87},
  [8587] = {.lex_state = 55, .external_lex_state = 87},
  [8588] = {.lex_state = 56, .external_lex_state = 98},
  [8589] = {.lex_state = 55, .external_lex_state = 87},
  [8590] = {.lex_state = 55, .external_lex_state = 90},
  [8591] = {.lex_state = 57, .external_lex_state = 264},
  [8592] = {.lex_state = 55, .external_lex_state = 87},
  [8593] = {.lex_state = 55, .external_lex_state = 87},
  [8594] = {.lex_state = 55, .external_lex_state = 89},
  [8595] = {.lex_state = 55, .external_lex_state = 87},
  [8596] = {.lex_state = 55, .external_lex_state = 261},
  [8597] = {.lex_state = 56, .external_lex_state = 98},
  [8598] = {.lex_state = 56, .external_lex_state = 97},
  [8599] = {.lex_state = 56, .external_lex_state = 97},
  [8600] = {.lex_state = 56, .external_lex_state = 97},
  [8601] = {.lex_state = 56, .external_lex_state = 97},
  [8602] = {.lex_state = 56, .external_lex_state = 98},
  [8603] = {.lex_state = 57, .external_lex_state = 265},
  [8604] = {.lex_state = 55, .external_lex_state = 89},
  [8605] = {.lex_state = 56, .external_lex_state = 98},
  [8606] = {.lex_state = 56, .external_lex_state = 98},
  [8607] = {.lex_state = 56, .external_lex_state = 97},
  [8608] = {.lex_state = 56, .external_lex_state = 98},
  [8609] = {.lex_state = 55, .external_lex_state = 89},
  [8610] = {.lex_state = 55, .external_lex_state = 89},
  [8611] = {.lex_state = 56, .external_lex_state = 98},
  [8612] = {.lex_state = 56, .external_lex_state = 98},
  [8613] = {.lex_state = 56, .external_lex_state = 98},
  [8614] = {.lex_state = 55, .external_lex_state = 87},
  [8615] = {.lex_state = 57, .external_lex_state = 266},
  [8616] = {.lex_state = 55, .external_lex_state = 87},
  [8617] = {.lex_state = 56, .external_lex_state = 98},
  [8618] = {.lex_state = 55, .external_lex_state = 89},
  [8619] = {.lex_state = 55, .external_lex_state = 89},
  [8620] = {.lex_state = 55, .external_lex_state = 89},
  [8621] = {.lex_state = 55, .external_lex_state = 89},
  [8622] = {.lex_state = 55, .external_lex_state = 89},
  [8623] = {.lex_state = 55, .external_lex_state = 260},
  [8624] = {.lex_state = 55, .external_lex_state = 96},
  [8625] = {.lex_state = 55, .external_lex_state = 87},
  [8626] = {.lex_state = 55, .external_lex_state = 87},
  [8627] = {.lex_state = 60, .external_lex_state = 90},
  [8628] = {.lex_state = 55, .external_lex_state = 87},
  [8629] = {.lex_state = 55, .external_lex_state = 89},
  [8630] = {.lex_state = 55, .external_lex_state = 259},
  [8631] = {.lex_state = 55, .external_lex_state = 87},
  [8632] = {.lex_state = 55, .external_lex_state = 87},
  [8633] = {.lex_state = 55, .external_lex_state = 261},
  [8634] = {.lex_state = 56, .external_lex_state = 97},
  [8635] = {.lex_state = 56, .external_lex_state = 98},
  [8636] = {.lex_state = 56, .external_lex_state = 97},
  [8637] = {.lex_state = 55, .external_lex_state = 87},
  [8638] = {.lex_state = 55, .external_lex_state = 87},
  [8639] = {.lex_state = 55, .external_lex_state = 87},
  [8640] = {.lex_state = 55, .external_lex_state = 87},
  [8641] = {.lex_state = 55, .external_lex_state = 89},
  [8642] = {.lex_state = 56, .external_lex_state = 98},
  [8643] = {.lex_state = 56, .external_lex_state = 97},
  [8644] = {.lex_state = 55, .external_lex_state = 89},
  [8645] = {.lex_state = 56, .external_lex_state = 97},
  [8646] = {.lex_state = 55, .external_lex_state = 89},
  [8647] = {.lex_state = 55, .external_lex_state = 89},
  [8648] = {.lex_state = 55, .external_lex_state = 262},
  [8649] = {.lex_state = 56, .external_lex_state = 97},
  [8650] = {.lex_state = 55, .external_lex_state = 87},
  [8651] = {.lex_state = 55, .external_lex_state = 256},
  [8652] = {.lex_state = 56, .external_lex_state = 98},
  [8653] = {.lex_state = 55, .external_lex_state = 89},
  [8654] = {.lex_state = 55, .external_lex_state = 87},
  [8655] = {.lex_state = 55, .external_lex_state = 89},
  [8656] = {.lex_state = 56, .external_lex_state = 97},
  [8657] = {.lex_state = 55, .external_lex_state = 89},
  [8658] = {.lex_state = 56, .external_lex_state = 98},
  [8659] = {.lex_state = 55, .external_lex_state = 87},
  [8660] = {.lex_state = 56, .external_lex_state = 97},
  [8661] = {.lex_state = 56, .external_lex_state = 97},
  [8662] = {.lex_state = 55, .external_lex_state = 89},
  [8663] = {.lex_state = 55, .external_lex_state = 89},
  [8664] = {.lex_state = 56, .external_lex_state = 97},
  [8665] = {.lex_state = 55, .external_lex_state = 89},
  [8666] = {.lex_state = 55, .external_lex_state = 87},
  [8667] = {.lex_state = 55, .external_lex_state = 87},
  [8668] = {.lex_state = 56, .external_lex_state = 97},
  [8669] = {.lex_state = 55, .external_lex_state = 89},
  [8670] = {.lex_state = 55, .external_lex_state = 87},
  [8671] = {.lex_state = 56, .external_lex_state = 97},
  [8672] = {.lex_state = 56, .external_lex_state = 97},
  [8673] = {.lex_state = 55, .external_lex_state = 87},
  [8674] = {.lex_state = 55, .external_lex_state = 87},
  [8675] = {.lex_state = 55, .external_lex_state = 87},
  [8676] = {.lex_state = 55, .external_lex_state = 87},
  [8677] = {.lex_state = 55, .external_lex_state = 87},
  [8678] = {.lex_state = 57, .external_lex_state = 267},
  [8679] = {.lex_state = 55, .external_lex_state = 87},
  [8680] = {.lex_state = 55, .external_lex_state = 87},
  [8681] = {.lex_state = 55, .external_lex_state = 262},
  [8682] = {.lex_state = 56, .external_lex_state = 98},
  [8683] = {.lex_state = 56, .external_lex_state = 97},
  [8684] = {.lex_state = 56, .external_lex_state = 268},
  [8685] = {.lex_state = 55, .external_lex_state = 87},
  [8686] = {.lex_state = 55, .external_lex_state = 89},
  [8687] = {.lex_state = 55, .external_lex_state = 263},
  [8688] = {.lex_state = 55, .external_lex_state = 89},
  [8689] = {.lex_state = 55, .external_lex_state = 87},
  [8690] = {.lex_state = 56, .external_lex_state = 98},
  [8691] = {.lex_state = 55, .external_lex_state = 89},
  [8692] = {.lex_state = 55, .external_lex_state = 89},
  [8693] = {.lex_state = 55, .external_lex_state = 87},
  [8694] = {.lex_state = 55, .external_lex_state = 87},
  [8695] = {.lex_state = 55, .external_lex_state = 87},
  [8696] = {.lex_state = 55, .external_lex_state = 89},
  [8697] = {.lex_state = 55, .external_lex_state = 89},
  [8698] = {.lex_state = 55, .external_lex_state = 87},
  [8699] = {.lex_state = 55, .external_lex_state = 89},
  [8700] = {.lex_state = 55, .external_lex_state = 87},
  [8701] = {.lex_state = 55, .external_lex_state = 89},
  [8702] = {.lex_state = 56, .external_lex_state = 98},
  [8703] = {.lex_state = 55, .external_lex_state = 87},
  [8704] = {.lex_state = 55, .external_lex_state = 87},
  [8705] = {.lex_state = 56, .external_lex_state = 268},
  [8706] = {.lex_state = 55, .external_lex_state = 87},
  [8707] = {.lex_state = 55, .external_lex_state = 87},
  [8708] = {.lex_state = 55, .external_lex_state = 3},
  [8709] = {.lex_state = 55, .external_lex_state = 90},
  [8710] = {.lex_state = 56, .external_lex_state = 269},
  [8711] = {.lex_state = 58, .external_lex_state = 270},
  [8712] = {.lex_state = 55, .external_lex_state = 95},
  [8713] = {.lex_state = 56, .external_lex_state = 271},
  [8714] = {.lex_state = 55, .external_lex_state = 262},
  [8715] = {.lex_state = 56, .external_lex_state = 271},
  [8716] = {.lex_state = 55, .external_lex_state = 272},
  [8717] = {.lex_state = 55, .external_lex_state = 3},
  [8718] = {.lex_state = 55, .external_lex_state = 94},
  [8719] = {.lex_state = 56, .external_lex_state = 273},
  [8720] = {.lex_state = 55, .external_lex_state = 263},
  [8721] = {.lex_state = 55, .external_lex_state = 262},
  [8722] = {.lex_state = 55, .external_lex_state = 90},
  [8723] = {.lex_state = 55, .external_lex_state = 263},
  [8724] = {.lex_state = 55, .external_lex_state = 272},
  [8725] = {.lex_state = 56, .external_lex_state = 269},
  [8726] = {.lex_state = 55, .external_lex_state = 262},
  [8727] = {.lex_state = 56, .external_lex_state = 273},
  [8728] = {.lex_state = 55, .external_lex_state = 90},
  [8729] = {.lex_state = 55, .external_lex_state = 90},
  [8730] = {.lex_state = 55, .external_lex_state = 90},
  [8731] = {.lex_state = 55, .external_lex_state = 91},
  [8732] = {.lex_state = 56, .external_lex_state = 269},
  [8733] = {.lex_state = 55, .external_lex_state = 100},
  [8734] = {.lex_state = 55, .external_lex_state = 274},
  [8735] = {.lex_state = 55, .external_lex_state = 90},
  [8736] = {.lex_state = 55, .external_lex_state = 96},
  [8737] = {.lex_state = 55, .external_lex_state = 274},
  [8738] = {.lex_state = 55, .external_lex_state = 90},
  [8739] = {.lex_state = 55, .external_lex_state = 90},
  [8740] = {.lex_state = 55, .external_lex_state = 95},
  [8741] = {.lex_state = 55, .external_lex_state = 90},
  [8742] = {.lex_state = 56, .external_lex_state = 275},
  [8743] = {.lex_state = 56, .external_lex_state = 273},
  [8744] = {.lex_state = 56, .external_lex_state = 40},
  [8745] = {.lex_state = 55, .external_lex_state = 90},
  [8746] = {.lex_state = 56, .external_lex_state = 275},
  [8747] = {.lex_state = 56, .external_lex_state = 40},
  [8748] = {.lex_state = 55, .external_lex_state = 3},
  [8749] = {.lex_state = 56, .external_lex_state = 273},
  [8750] = {.lex_state = 55, .external_lex_state = 3},
  [8751] = {.lex_state = 55, .external_lex_state = 3},
  [8752] = {.lex_state = 55, .external_lex_state = 96},
  [8753] = {.lex_state = 55, .external_lex_state = 3},
  [8754] = {.lex_state = 55, .external_lex_state = 3},
  [8755] = {.lex_state = 55, .external_lex_state = 3},
  [8756] = {.lex_state = 55, .external_lex_state = 3},
  [8757] = {.lex_state = 55, .external_lex_state = 3},
  [8758] = {.lex_state = 56, .external_lex_state = 275},
  [8759] = {.lex_state = 55, .external_lex_state = 3},
  [8760] = {.lex_state = 55, .external_lex_state = 90},
  [8761] = {.lex_state = 55, .external_lex_state = 90},
  [8762] = {.lex_state = 57, .external_lex_state = 276},
  [8763] = {.lex_state = 60, .external_lex_state = 94},
  [8764] = {.lex_state = 55, .external_lex_state = 3},
  [8765] = {.lex_state = 56, .external_lex_state = 269},
  [8766] = {.lex_state = 55, .external_lex_state = 3},
  [8767] = {.lex_state = 55, .external_lex_state = 3},
  [8768] = {.lex_state = 57, .external_lex_state = 277},
  [8769] = {.lex_state = 55, .external_lex_state = 3},
  [8770] = {.lex_state = 55, .external_lex_state = 263},
  [8771] = {.lex_state = 55, .external_lex_state = 90},
  [8772] = {.lex_state = 55, .external_lex_state = 90},
  [8773] = {.lex_state = 55, .external_lex_state = 90},
  [8774] = {.lex_state = 55, .external_lex_state = 90},
  [8775] = {.lex_state = 55, .external_lex_state = 90},
  [8776] = {.lex_state = 55, .external_lex_state = 3},
  [8777] = {.lex_state = 55, .external_lex_state = 278},
  [8778] = {.lex_state = 55, .external_lex_state = 90},
  [8779] = {.lex_state = 55, .external_lex_state = 3},
  [8780] = {.lex_state = 60, .external_lex_state = 93},
  [8781] = {.lex_state = 55, .external_lex_state = 93},
  [8782] = {.lex_state = 56, .external_lex_state = 269},
  [8783] = {.lex_state = 55, .external_lex_state = 260},
  [8784] = {.lex_state = 55, .external_lex_state = 3},
  [8785] = {.lex_state = 55, .external_lex_state = 3},
  [8786] = {.lex_state = 55, .external_lex_state = 3},
  [8787] = {.lex_state = 55, .external_lex_state = 3},
  [8788] = {.lex_state = 55, .external_lex_state = 259},
  [8789] = {.lex_state = 55, .external_lex_state = 90},
  [8790] = {.lex_state = 55, .external_lex_state = 3},
  [8791] = {.lex_state = 55, .external_lex_state = 3},
  [8792] = {.lex_state = 55, .external_lex_state = 90},
  [8793] = {.lex_state = 55, .external_lex_state = 90},
  [8794] = {.lex_state = 55, .external_lex_state = 260},
  [8795] = {.lex_state = 55, .external_lex_state = 3},
  [8796] = {.lex_state = 56, .external_lex_state = 271},
  [8797] = {.lex_state = 55, .external_lex_state = 278},
  [8798] = {.lex_state = 55, .external_lex_state = 93},
  [8799] = {.lex_state = 55, .external_lex_state = 3},
  [8800] = {.lex_state = 55, .external_lex_state = 3},
  [8801] = {.lex_state = 55, .external_lex_state = 259},
  [8802] = {.lex_state = 55, .external_lex_state = 93},
  [8803] = {.lex_state = 55, .external_lex_state = 90},
  [8804] = {.lex_state = 56, .external_lex_state = 275},
  [8805] = {.lex_state = 55, .external_lex_state = 3},
  [8806] = {.lex_state = 55, .external_lex_state = 94},
  [8807] = {.lex_state = 55, .external_lex_state = 3},
  [8808] = {.lex_state = 60, .external_lex_state = 96},
  [8809] = {.lex_state = 55, .external_lex_state = 90},
  [8810] = {.lex_state = 60, .external_lex_state = 91},
  [8811] = {.lex_state = 55, .external_lex_state = 90},
  [8812] = {.lex_state = 55, .external_lex_state = 3},
  [8813] = {.lex_state = 55, .external_lex_state = 90},
  [8814] = {.lex_state = 55, .external_lex_state = 3},
  [8815] = {.lex_state = 55, .external_lex_state = 90},
  [8816] = {.lex_state = 55, .external_lex_state = 90},
  [8817] = {.lex_state = 55, .external_lex_state = 90},
  [8818] = {.lex_state = 55, .external_lex_state = 90},
  [8819] = {.lex_state = 55, .external_lex_state = 90},
  [8820] = {.lex_state = 57, .external_lex_state = 279},
  [8821] = {.lex_state = 55, .external_lex_state = 90},
  [8822] = {.lex_state = 55, .external_lex_state = 90},
  [8823] = {.lex_state = 60, .external_lex_state = 94},
  [8824] = {.lex_state = 60, .external_lex_state = 96},
  [8825] = {.lex_state = 55, .external_lex_state = 101},
  [8826] = {.lex_state = 55, .external_lex_state = 90},
  [8827] = {.lex_state = 55, .external_lex_state = 90},
  [8828] = {.lex_state = 55, .external_lex_state = 90},
  [8829] = {.lex_state = 55, .external_lex_state = 272},
  [8830] = {.lex_state = 56, .external_lex_state = 71},
  [8831] = {.lex_state = 55, .external_lex_state = 91},
  [8832] = {.lex_state = 57, .external_lex_state = 280},
  [8833] = {.lex_state = 60, .external_lex_state = 91},
  [8834] = {.lex_state = 55, .external_lex_state = 90},
  [8835] = {.lex_state = 55, .external_lex_state = 90},
  [8836] = {.lex_state = 55, .external_lex_state = 90},
  [8837] = {.lex_state = 55, .external_lex_state = 90},
  [8838] = {.lex_state = 55, .external_lex_state = 278},
  [8839] = {.lex_state = 55, .external_lex_state = 260},
  [8840] = {.lex_state = 55, .external_lex_state = 90},
  [8841] = {.lex_state = 56, .external_lex_state = 71},
  [8842] = {.lex_state = 55, .external_lex_state = 90},
  [8843] = {.lex_state = 55, .external_lex_state = 90},
  [8844] = {.lex_state = 56, .external_lex_state = 71},
  [8845] = {.lex_state = 56, .external_lex_state = 40},
  [8846] = {.lex_state = 55, .external_lex_state = 3},
  [8847] = {.lex_state = 55, .external_lex_state = 91},
  [8848] = {.lex_state = 56, .external_lex_state = 275},
  [8849] = {.lex_state = 60, .external_lex_state = 93},
  [8850] = {.lex_state = 56, .external_lex_state = 271},
  [8851] = {.lex_state = 55, .external_lex_state = 274},
  [8852] = {.lex_state = 55, .external_lex_state = 3},
  [8853] = {.lex_state = 55, .external_lex_state = 90},
  [8854] = {.lex_state = 55, .external_lex_state = 3},
  [8855] = {.lex_state = 55, .external_lex_state = 259},
  [8856] = {.lex_state = 56, .external_lex_state = 273},
  [8857] = {.lex_state = 56, .external_lex_state = 269},
  [8858] = {.lex_state = 55, .external_lex_state = 99},
  [8859] = {.lex_state = 55, .external_lex_state = 90},
  [8860] = {.lex_state = 56, .external_lex_state = 40},
  [8861] = {.lex_state = 55, .external_lex_state = 90},
  [8862] = {.lex_state = 55, .external_lex_state = 95},
  [8863] = {.lex_state = 56, .external_lex_state = 37},
  [8864] = {.lex_state = 60, .external_lex_state = 95},
  [8865] = {.lex_state = 55, .external_lex_state = 96},
  [8866] = {.lex_state = 55, .external_lex_state = 90},
  [8867] = {.lex_state = 55, .external_lex_state = 90},
  [8868] = {.lex_state = 55, .external_lex_state = 94},
  [8869] = {.lex_state = 55, .external_lex_state = 261},
  [8870] = {.lex_state = 55, .external_lex_state = 90},
  [8871] = {.lex_state = 55, .external_lex_state = 261},
  [8872] = {.lex_state = 57, .external_lex_state = 281},
  [8873] = {.lex_state = 55, .external_lex_state = 90},
  [8874] = {.lex_state = 55, .external_lex_state = 90},
  [8875] = {.lex_state = 57, .external_lex_state = 282},
  [8876] = {.lex_state = 56, .external_lex_state = 275},
  [8877] = {.lex_state = 55, .external_lex_state = 261},
  [8878] = {.lex_state = 56, .external_lex_state = 273},
  [8879] = {.lex_state = 55, .external_lex_state = 3},
  [8880] = {.lex_state = 55, .external_lex_state = 3},
  [8881] = {.lex_state = 56, .external_lex_state = 271},
  [8882] = {.lex_state = 55, .external_lex_state = 3},
  [8883] = {.lex_state = 55, .external_lex_state = 90},
  [8884] = {.lex_state = 56, .external_lex_state = 271},
  [8885] = {.lex_state = 60, .external_lex_state = 95},
  [8886] = {.lex_state = 57, .external_lex_state = 283},
  [8887] = {.lex_state = 55, .external_lex_state = 90},
  [8888] = {.lex_state = 55, .external_lex_state = 93},
  [8889] = {.lex_state = 55, .external_lex_state = 93},
  [8890] = {.lex_state = 55, .external_lex_state = 93},
  [8891] = {.lex_state = 56, .external_lex_state = 102},
  [8892] = {.lex_state = 55, .external_lex_state = 91},
  [8893] = {.lex_state = 56, .external_lex_state = 102},
  [8894] = {.lex_state = 55, .external_lex_state = 93},
  [8895] = {.lex_state = 55, .external_lex_state = 93},
  [8896] = {.lex_state = 56, .external_lex_state = 284},
  [8897] = {.lex_state = 55, .external_lex_state = 93},
  [8898] = {.lex_state = 55, .external_lex_state = 93},
  [8899] = {.lex_state = 55, .external_lex_state = 95},
  [8900] = {.lex_state = 55, .external_lex_state = 95},
  [8901] = {.lex_state = 55, .external_lex_state = 100},
  [8902] = {.lex_state = 56, .external_lex_state = 285},
  [8903] = {.lex_state = 55, .external_lex_state = 95},
  [8904] = {.lex_state = 55, .external_lex_state = 95},
  [8905] = {.lex_state = 56, .external_lex_state = 285},
  [8906] = {.lex_state = 55, .external_lex_state = 95},
  [8907] = {.lex_state = 56, .external_lex_state = 105},
  [8908] = {.lex_state = 55, .external_lex_state = 274},
  [8909] = {.lex_state = 55, .external_lex_state = 91},
  [8910] = {.lex_state = 55, .external_lex_state = 95},
  [8911] = {.lex_state = 55, .external_lex_state = 93},
  [8912] = {.lex_state = 55, .external_lex_state = 95},
  [8913] = {.lex_state = 55, .external_lex_state = 95},
  [8914] = {.lex_state = 55, .external_lex_state = 93},
  [8915] = {.lex_state = 55, .external_lex_state = 93},
  [8916] = {.lex_state = 55, .external_lex_state = 93},
  [8917] = {.lex_state = 55, .external_lex_state = 93},
  [8918] = {.lex_state = 55, .external_lex_state = 93},
  [8919] = {.lex_state = 55, .external_lex_state = 93},
  [8920] = {.lex_state = 55, .external_lex_state = 93},
  [8921] = {.lex_state = 55, .external_lex_state = 93},
  [8922] = {.lex_state = 55, .external_lex_state = 93},
  [8923] = {.lex_state = 55, .external_lex_state = 91},
  [8924] = {.lex_state = 55, .external_lex_state = 99},
  [8925] = {.lex_state = 55, .external_lex_state = 101},
  [8926] = {.lex_state = 55, .external_lex_state = 93},
  [8927] = {.lex_state = 55, .external_lex_state = 93},
  [8928] = {.lex_state = 55, .external_lex_state = 93},
  [8929] = {.lex_state = 56, .external_lex_state = 102},
  [8930] = {.lex_state = 55, .external_lex_state = 274},
  [8931] = {.lex_state = 57, .external_lex_state = 286},
  [8932] = {.lex_state = 55, .external_lex_state = 99},
  [8933] = {.lex_state = 55, .external_lex_state = 95},
  [8934] = {.lex_state = 55, .external_lex_state = 95},
  [8935] = {.lex_state = 55, .external_lex_state = 95},
  [8936] = {.lex_state = 55, .external_lex_state = 95},
  [8937] = {.lex_state = 56, .external_lex_state = 268},
  [8938] = {.lex_state = 56, .external_lex_state = 106},
  [8939] = {.lex_state = 55, .external_lex_state = 94},
  [8940] = {.lex_state = 55, .external_lex_state = 95},
  [8941] = {.lex_state = 57, .external_lex_state = 287},
  [8942] = {.lex_state = 56, .external_lex_state = 105},
  [8943] = {.lex_state = 55, .external_lex_state = 95},
  [8944] = {.lex_state = 56, .external_lex_state = 102},
  [8945] = {.lex_state = 56, .external_lex_state = 268},
  [8946] = {.lex_state = 55, .external_lex_state = 99},
  [8947] = {.lex_state = 55, .external_lex_state = 93},
  [8948] = {.lex_state = 55, .external_lex_state = 94},
  [8949] = {.lex_state = 55, .external_lex_state = 94},
  [8950] = {.lex_state = 56, .external_lex_state = 105},
  [8951] = {.lex_state = 55, .external_lex_state = 94},
  [8952] = {.lex_state = 55, .external_lex_state = 101},
  [8953] = {.lex_state = 56, .external_lex_state = 105},
  [8954] = {.lex_state = 55, .external_lex_state = 95},
  [8955] = {.lex_state = 55, .external_lex_state = 91},
  [8956] = {.lex_state = 55, .external_lex_state = 94},
  [8957] = {.lex_state = 55, .external_lex_state = 95},
  [8958] = {.lex_state = 55, .external_lex_state = 94},
  [8959] = {.lex_state = 55, .external_lex_state = 91},
  [8960] = {.lex_state = 55, .external_lex_state = 91},
  [8961] = {.lex_state = 55, .external_lex_state = 94},
  [8962] = {.lex_state = 55, .external_lex_state = 94},
  [8963] = {.lex_state = 56, .external_lex_state = 102},
  [8964] = {.lex_state = 56, .external_lex_state = 106},
  [8965] = {.lex_state = 56, .external_lex_state = 105},
  [8966] = {.lex_state = 56, .external_lex_state = 102},
  [8967] = {.lex_state = 55, .external_lex_state = 94},
  [8968] = {.lex_state = 55, .external_lex_state = 94},
  [8969] = {.lex_state = 56, .external_lex_state = 102},
  [8970] = {.lex_state = 55, .external_lex_state = 94},
  [8971] = {.lex_state = 55, .external_lex_state = 94},
  [8972] = {.lex_state = 55, .external_lex_state = 91},
  [8973] = {.lex_state = 55, .external_lex_state = 91},
  [8974] = {.lex_state = 55, .external_lex_state = 274},
  [8975] = {.lex_state = 55, .external_lex_state = 94},
  [8976] = {.lex_state = 55, .external_lex_state = 94},
  [8977] = {.lex_state = 55, .external_lex_state = 91},
  [8978] = {.lex_state = 55, .external_lex_state = 91},
  [8979] = {.lex_state = 55, .external_lex_state = 101},
  [8980] = {.lex_state = 55, .external_lex_state = 91},
  [8981] = {.lex_state = 55, .external_lex_state = 95},
  [8982] = {.lex_state = 55, .external_lex_state = 91},
  [8983] = {.lex_state = 56, .external_lex_state = 105},
  [8984] = {.lex_state = 55, .external_lex_state = 91},
  [8985] = {.lex_state = 56, .external_lex_state = 102},
  [8986] = {.lex_state = 55, .external_lex_state = 94},
  [8987] = {.lex_state = 56, .external_lex_state = 105},
  [8988] = {.lex_state = 56, .external_lex_state = 102},
  [8989] = {.lex_state = 56, .external_lex_state = 102},
  [8990] = {.lex_state = 55, .external_lex_state = 100},
  [8991] = {.lex_state = 57, .external_lex_state = 288},
  [8992] = {.lex_state = 56, .external_lex_state = 102},
  [8993] = {.lex_state = 56, .external_lex_state = 284},
  [8994] = {.lex_state = 55, .external_lex_state = 94},
  [8995] = {.lex_state = 55, .external_lex_state = 94},
  [8996] = {.lex_state = 56, .external_lex_state = 102},
  [8997] = {.lex_state = 55, .external_lex_state = 91},
  [8998] = {.lex_state = 56, .external_lex_state = 105},
  [8999] = {.lex_state = 55, .external_lex_state = 94},
  [9000] = {.lex_state = 55, .external_lex_state = 100},
  [9001] = {.lex_state = 55, .external_lex_state = 94},
  [9002] = {.lex_state = 55, .external_lex_state = 91},
  [9003] = {.lex_state = 55, .external_lex_state = 91},
  [9004] = {.lex_state = 55, .external_lex_state = 94},
  [9005] = {.lex_state = 57, .external_lex_state = 289},
  [9006] = {.lex_state = 55, .external_lex_state = 94},
  [9007] = {.lex_state = 55, .external_lex_state = 91},
  [9008] = {.lex_state = 55, .external_lex_state = 91},
  [9009] = {.lex_state = 55, .external_lex_state = 91},
  [9010] = {.lex_state = 55, .external_lex_state = 94},
  [9011] = {.lex_state = 55, .external_lex_state = 94},
  [9012] = {.lex_state = 60, .external_lex_state = 101},
  [9013] = {.lex_state = 55, .external_lex_state = 94},
  [9014] = {.lex_state = 55, .external_lex_state = 94},
  [9015] = {.lex_state = 55, .external_lex_state = 94},
  [9016] = {.lex_state = 55, .external_lex_state = 95},
  [9017] = {.lex_state = 55, .external_lex_state = 95},
  [9018] = {.lex_state = 55, .external_lex_state = 94},
  [9019] = {.lex_state = 56, .external_lex_state = 290},
  [9020] = {.lex_state = 56, .external_lex_state = 106},
  [9021] = {.lex_state = 55, .external_lex_state = 94},
  [9022] = {.lex_state = 56, .external_lex_state = 102},
  [9023] = {.lex_state = 56, .external_lex_state = 102},
  [9024] = {.lex_state = 55, .external_lex_state = 94},
  [9025] = {.lex_state = 55, .external_lex_state = 95},
  [9026] = {.lex_state = 60, .external_lex_state = 100},
  [9027] = {.lex_state = 55, .external_lex_state = 91},
  [9028] = {.lex_state = 55, .external_lex_state = 95},
  [9029] = {.lex_state = 0, .external_lex_state = 291},
  [9030] = {.lex_state = 56, .external_lex_state = 102},
  [9031] = {.lex_state = 56, .external_lex_state = 102},
  [9032] = {.lex_state = 56, .external_lex_state = 103},
  [9033] = {.lex_state = 56, .external_lex_state = 102},
  [9034] = {.lex_state = 55, .external_lex_state = 91},
  [9035] = {.lex_state = 55, .external_lex_state = 93},
  [9036] = {.lex_state = 56, .external_lex_state = 103},
  [9037] = {.lex_state = 56, .external_lex_state = 103},
  [9038] = {.lex_state = 56, .external_lex_state = 103},
  [9039] = {.lex_state = 56, .external_lex_state = 102},
  [9040] = {.lex_state = 55, .external_lex_state = 91},
  [9041] = {.lex_state = 55, .external_lex_state = 96},
  [9042] = {.lex_state = 56, .external_lex_state = 102},
  [9043] = {.lex_state = 55, .external_lex_state = 91},
  [9044] = {.lex_state = 55, .external_lex_state = 91},
  [9045] = {.lex_state = 57, .external_lex_state = 292},
  [9046] = {.lex_state = 55, .external_lex_state = 94},
  [9047] = {.lex_state = 56, .external_lex_state = 290},
  [9048] = {.lex_state = 56, .external_lex_state = 106},
  [9049] = {.lex_state = 55, .external_lex_state = 95},
  [9050] = {.lex_state = 56, .external_lex_state = 103},
  [9051] = {.lex_state = 56, .external_lex_state = 106},
  [9052] = {.lex_state = 56, .external_lex_state = 103},
  [9053] = {.lex_state = 55, .external_lex_state = 91},
  [9054] = {.lex_state = 56, .external_lex_state = 106},
  [9055] = {.lex_state = 56, .external_lex_state = 102},
  [9056] = {.lex_state = 56, .external_lex_state = 102},
  [9057] = {.lex_state = 56, .external_lex_state = 102},
  [9058] = {.lex_state = 56, .external_lex_state = 103},
  [9059] = {.lex_state = 56, .external_lex_state = 103},
  [9060] = {.lex_state = 56, .external_lex_state = 103},
  [9061] = {.lex_state = 56, .external_lex_state = 268},
  [9062] = {.lex_state = 55, .external_lex_state = 95},
  [9063] = {.lex_state = 55, .external_lex_state = 92},
  [9064] = {.lex_state = 56, .external_lex_state = 103},
  [9065] = {.lex_state = 56, .external_lex_state = 103},
  [9066] = {.lex_state = 56, .external_lex_state = 103},
  [9067] = {.lex_state = 55, .external_lex_state = 91},
  [9068] = {.lex_state = 55, .external_lex_state = 96},
  [9069] = {.lex_state = 56, .external_lex_state = 268},
  [9070] = {.lex_state = 55, .external_lex_state = 93},
  [9071] = {.lex_state = 56, .external_lex_state = 106},
  [9072] = {.lex_state = 55, .external_lex_state = 91},
  [9073] = {.lex_state = 56, .external_lex_state = 106},
  [9074] = {.lex_state = 56, .external_lex_state = 105},
  [9075] = {.lex_state = 55, .external_lex_state = 93},
  [9076] = {.lex_state = 55, .external_lex_state = 94},
  [9077] = {.lex_state = 57, .external_lex_state = 293},
  [9078] = {.lex_state = 55, .external_lex_state = 93},
  [9079] = {.lex_state = 56, .external_lex_state = 103},
  [9080] = {.lex_state = 55, .external_lex_state = 93},
  [9081] = {.lex_state = 56, .external_lex_state = 106},
  [9082] = {.lex_state = 55, .external_lex_state = 93},
  [9083] = {.lex_state = 56, .external_lex_state = 103},
  [9084] = {.lex_state = 55, .external_lex_state = 93},
  [9085] = {.lex_state = 56, .external_lex_state = 106},
  [9086] = {.lex_state = 56, .external_lex_state = 103},
  [9087] = {.lex_state = 55, .external_lex_state = 96},
  [9088] = {.lex_state = 56, .external_lex_state = 103},
  [9089] = {.lex_state = 55, .external_lex_state = 91},
  [9090] = {.lex_state = 55, .external_lex_state = 96},
  [9091] = {.lex_state = 55, .external_lex_state = 93},
  [9092] = {.lex_state = 55, .external_lex_state = 93},
  [9093] = {.lex_state = 55, .external_lex_state = 95},
  [9094] = {.lex_state = 56, .external_lex_state = 106},
  [9095] = {.lex_state = 55, .external_lex_state = 93},
  [9096] = {.lex_state = 55, .external_lex_state = 93},
  [9097] = {.lex_state = 56, .external_lex_state = 103},
  [9098] = {.lex_state = 55, .external_lex_state = 91},
  [9099] = {.lex_state = 55, .external_lex_state = 91},
  [9100] = {.lex_state = 55, .external_lex_state = 104},
  [9101] = {.lex_state = 56, .external_lex_state = 106},
  [9102] = {.lex_state = 55, .external_lex_state = 91},
  [9103] = {.lex_state = 55, .external_lex_state = 91},
  [9104] = {.lex_state = 56, .external_lex_state = 284},
  [9105] = {.lex_state = 55, .external_lex_state = 91},
  [9106] = {.lex_state = 55, .external_lex_state = 93},
  [9107] = {.lex_state = 58, .external_lex_state = 294},
  [9108] = {.lex_state = 55, .external_lex_state = 93},
  [9109] = {.lex_state = 55, .external_lex_state = 93},
  [9110] = {.lex_state = 56, .external_lex_state = 106},
  [9111] = {.lex_state = 55, .external_lex_state = 94},
  [9112] = {.lex_state = 55, .external_lex_state = 93},
  [9113] = {.lex_state = 55, .external_lex_state = 96},
  [9114] = {.lex_state = 56, .external_lex_state = 105},
  [9115] = {.lex_state = 55, .external_lex_state = 93},
  [9116] = {.lex_state = 56, .external_lex_state = 106},
  [9117] = {.lex_state = 56, .external_lex_state = 105},
  [9118] = {.lex_state = 55, .external_lex_state = 94},
  [9119] = {.lex_state = 56, .external_lex_state = 106},
  [9120] = {.lex_state = 55, .external_lex_state = 93},
  [9121] = {.lex_state = 55, .external_lex_state = 96},
  [9122] = {.lex_state = 56, .external_lex_state = 103},
  [9123] = {.lex_state = 56, .external_lex_state = 106},
  [9124] = {.lex_state = 56, .external_lex_state = 106},
  [9125] = {.lex_state = 56, .external_lex_state = 103},
  [9126] = {.lex_state = 56, .external_lex_state = 103},
  [9127] = {.lex_state = 55, .external_lex_state = 96},
  [9128] = {.lex_state = 55, .external_lex_state = 96},
  [9129] = {.lex_state = 55, .external_lex_state = 91},
  [9130] = {.lex_state = 56, .external_lex_state = 106},
  [9131] = {.lex_state = 55, .external_lex_state = 95},
  [9132] = {.lex_state = 55, .external_lex_state = 91},
  [9133] = {.lex_state = 55, .external_lex_state = 95},
  [9134] = {.lex_state = 55, .external_lex_state = 96},
  [9135] = {.lex_state = 56, .external_lex_state = 285},
  [9136] = {.lex_state = 55, .external_lex_state = 96},
  [9137] = {.lex_state = 55, .external_lex_state = 96},
  [9138] = {.lex_state = 55, .external_lex_state = 91},
  [9139] = {.lex_state = 55, .external_lex_state = 96},
  [9140] = {.lex_state = 56, .external_lex_state = 106},
  [9141] = {.lex_state = 55, .external_lex_state = 91},
  [9142] = {.lex_state = 55, .external_lex_state = 91},
  [9143] = {.lex_state = 56, .external_lex_state = 103},
  [9144] = {.lex_state = 56, .external_lex_state = 103},
  [9145] = {.lex_state = 56, .external_lex_state = 103},
  [9146] = {.lex_state = 56, .external_lex_state = 103},
  [9147] = {.lex_state = 55, .external_lex_state = 93},
  [9148] = {.lex_state = 56, .external_lex_state = 290},
  [9149] = {.lex_state = 55, .external_lex_state = 91},
  [9150] = {.lex_state = 56, .external_lex_state = 103},
  [9151] = {.lex_state = 55, .external_lex_state = 91},
  [9152] = {.lex_state = 60, .external_lex_state = 101},
  [9153] = {.lex_state = 55, .external_lex_state = 93},
  [9154] = {.lex_state = 57, .external_lex_state = 295},
  [9155] = {.lex_state = 56, .external_lex_state = 103},
  [9156] = {.lex_state = 56, .external_lex_state = 103},
  [9157] = {.lex_state = 55, .external_lex_state = 91},
  [9158] = {.lex_state = 56, .external_lex_state = 103},
  [9159] = {.lex_state = 56, .external_lex_state = 105},
  [9160] = {.lex_state = 55, .external_lex_state = 91},
  [9161] = {.lex_state = 56, .external_lex_state = 103},
  [9162] = {.lex_state = 55, .external_lex_state = 91},
  [9163] = {.lex_state = 55, .external_lex_state = 96},
  [9164] = {.lex_state = 55, .external_lex_state = 91},
  [9165] = {.lex_state = 56, .external_lex_state = 284},
  [9166] = {.lex_state = 55, .external_lex_state = 96},
  [9167] = {.lex_state = 56, .external_lex_state = 103},
  [9168] = {.lex_state = 55, .external_lex_state = 93},
  [9169] = {.lex_state = 55, .external_lex_state = 93},
  [9170] = {.lex_state = 55, .external_lex_state = 91},
  [9171] = {.lex_state = 55, .external_lex_state = 91},
  [9172] = {.lex_state = 55, .external_lex_state = 91},
  [9173] = {.lex_state = 55, .external_lex_state = 93},
  [9174] = {.lex_state = 55, .external_lex_state = 96},
  [9175] = {.lex_state = 55, .external_lex_state = 96},
  [9176] = {.lex_state = 60, .external_lex_state = 100},
  [9177] = {.lex_state = 56, .external_lex_state = 103},
  [9178] = {.lex_state = 55, .external_lex_state = 96},
  [9179] = {.lex_state = 55, .external_lex_state = 91},
  [9180] = {.lex_state = 55, .external_lex_state = 93},
  [9181] = {.lex_state = 56, .external_lex_state = 103},
  [9182] = {.lex_state = 56, .external_lex_state = 102},
  [9183] = {.lex_state = 56, .external_lex_state = 285},
  [9184] = {.lex_state = 55, .external_lex_state = 95},
  [9185] = {.lex_state = 56, .external_lex_state = 105},
  [9186] = {.lex_state = 56, .external_lex_state = 284},
  [9187] = {.lex_state = 56, .external_lex_state = 106},
  [9188] = {.lex_state = 55, .external_lex_state = 91},
  [9189] = {.lex_state = 55, .external_lex_state = 93},
  [9190] = {.lex_state = 55, .external_lex_state = 96},
  [9191] = {.lex_state = 56, .external_lex_state = 102},
  [9192] = {.lex_state = 56, .external_lex_state = 103},
  [9193] = {.lex_state = 55, .external_lex_state = 93},
  [9194] = {.lex_state = 55, .external_lex_state = 93},
  [9195] = {.lex_state = 55, .external_lex_state = 95},
  [9196] = {.lex_state = 56, .external_lex_state = 290},
  [9197] = {.lex_state = 55, .external_lex_state = 96},
  [9198] = {.lex_state = 55, .external_lex_state = 96},
  [9199] = {.lex_state = 60, .external_lex_state = 99},
  [9200] = {.lex_state = 56, .external_lex_state = 106},
  [9201] = {.lex_state = 55, .external_lex_state = 96},
  [9202] = {.lex_state = 55, .external_lex_state = 96},
  [9203] = {.lex_state = 56, .external_lex_state = 106},
  [9204] = {.lex_state = 55, .external_lex_state = 93},
  [9205] = {.lex_state = 55, .external_lex_state = 93},
  [9206] = {.lex_state = 56, .external_lex_state = 103},
  [9207] = {.lex_state = 55, .external_lex_state = 95},
  [9208] = {.lex_state = 55, .external_lex_state = 94},
  [9209] = {.lex_state = 56, .external_lex_state = 106},
  [9210] = {.lex_state = 56, .external_lex_state = 106},
  [9211] = {.lex_state = 56, .external_lex_state = 105},
  [9212] = {.lex_state = 56, .external_lex_state = 106},
  [9213] = {.lex_state = 55, .external_lex_state = 96},
  [9214] = {.lex_state = 55, .external_lex_state = 94},
  [9215] = {.lex_state = 55, .external_lex_state = 94},
  [9216] = {.lex_state = 55, .external_lex_state = 95},
  [9217] = {.lex_state = 55, .external_lex_state = 94},
  [9218] = {.lex_state = 55, .external_lex_state = 94},
  [9219] = {.lex_state = 56, .external_lex_state = 106},
  [9220] = {.lex_state = 55, .external_lex_state = 93},
  [9221] = {.lex_state = 56, .external_lex_state = 106},
  [9222] = {.lex_state = 56, .external_lex_state = 105},
  [9223] = {.lex_state = 56, .external_lex_state = 102},
  [9224] = {.lex_state = 55, .external_lex_state = 95},
  [9225] = {.lex_state = 55, .external_lex_state = 94},
  [9226] = {.lex_state = 56, .external_lex_state = 106},
  [9227] = {.lex_state = 55, .external_lex_state = 95},
  [9228] = {.lex_state = 55, .external_lex_state = 96},
  [9229] = {.lex_state = 55, .external_lex_state = 96},
  [9230] = {.lex_state = 56, .external_lex_state = 285},
  [9231] = {.lex_state = 55, .external_lex_state = 94},
  [9232] = {.lex_state = 55, .external_lex_state = 95},
  [9233] = {.lex_state = 55, .external_lex_state = 96},
  [9234] = {.lex_state = 55, .external_lex_state = 96},
  [9235] = {.lex_state = 55, .external_lex_state = 96},
  [9236] = {.lex_state = 55, .external_lex_state = 96},
  [9237] = {.lex_state = 55, .external_lex_state = 96},
  [9238] = {.lex_state = 55, .external_lex_state = 95},
  [9239] = {.lex_state = 55, .external_lex_state = 272},
  [9240] = {.lex_state = 55, .external_lex_state = 278},
  [9241] = {.lex_state = 55, .external_lex_state = 96},
  [9242] = {.lex_state = 55, .external_lex_state = 96},
  [9243] = {.lex_state = 55, .external_lex_state = 96},
  [9244] = {.lex_state = 55, .external_lex_state = 96},
  [9245] = {.lex_state = 55, .external_lex_state = 96},
  [9246] = {.lex_state = 56, .external_lex_state = 290},
  [9247] = {.lex_state = 55, .external_lex_state = 272},
  [9248] = {.lex_state = 56, .external_lex_state = 106},
  [9249] = {.lex_state = 56, .external_lex_state = 105},
  [9250] = {.lex_state = 56, .external_lex_state = 102},
  [9251] = {.lex_state = 55, .external_lex_state = 91},
  [9252] = {.lex_state = 56, .external_lex_state = 290},
  [9253] = {.lex_state = 56, .external_lex_state = 105},
  [9254] = {.lex_state = 55, .external_lex_state = 272},
  [9255] = {.lex_state = 56, .external_lex_state = 105},
  [9256] = {.lex_state = 56, .external_lex_state = 105},
  [9257] = {.lex_state = 55, .external_lex_state = 94},
  [9258] = {.lex_state = 56, .external_lex_state = 105},
  [9259] = {.lex_state = 56, .external_lex_state = 105},
  [9260] = {.lex_state = 55, .external_lex_state = 96},
  [9261] = {.lex_state = 55, .external_lex_state = 94},
  [9262] = {.lex_state = 55, .external_lex_state = 95},
  [9263] = {.lex_state = 55, .external_lex_state = 95},
  [9264] = {.lex_state = 55, .external_lex_state = 94},
  [9265] = {.lex_state = 56, .external_lex_state = 102},
  [9266] = {.lex_state = 55, .external_lex_state = 96},
  [9267] = {.lex_state = 56, .external_lex_state = 285},
  [9268] = {.lex_state = 56, .external_lex_state = 102},
  [9269] = {.lex_state = 56, .external_lex_state = 105},
  [9270] = {.lex_state = 55, .external_lex_state = 95},
  [9271] = {.lex_state = 60, .external_lex_state = 99},
  [9272] = {.lex_state = 56, .external_lex_state = 102},
  [9273] = {.lex_state = 55, .external_lex_state = 91},
  [9274] = {.lex_state = 56, .external_lex_state = 102},
  [9275] = {.lex_state = 56, .external_lex_state = 105},
  [9276] = {.lex_state = 56, .external_lex_state = 105},
  [9277] = {.lex_state = 55, .external_lex_state = 96},
  [9278] = {.lex_state = 55, .external_lex_state = 93},
  [9279] = {.lex_state = 56, .external_lex_state = 105},
  [9280] = {.lex_state = 56, .external_lex_state = 102},
  [9281] = {.lex_state = 56, .external_lex_state = 284},
  [9282] = {.lex_state = 55, .external_lex_state = 95},
  [9283] = {.lex_state = 56, .external_lex_state = 102},
  [9284] = {.lex_state = 56, .external_lex_state = 105},
  [9285] = {.lex_state = 56, .external_lex_state = 105},
  [9286] = {.lex_state = 55, .external_lex_state = 93},
  [9287] = {.lex_state = 56, .external_lex_state = 102},
  [9288] = {.lex_state = 56, .external_lex_state = 105},
  [9289] = {.lex_state = 55, .external_lex_state = 96},
  [9290] = {.lex_state = 56, .external_lex_state = 105},
  [9291] = {.lex_state = 55, .external_lex_state = 94},
  [9292] = {.lex_state = 55, .external_lex_state = 95},
  [9293] = {.lex_state = 56, .external_lex_state = 102},
  [9294] = {.lex_state = 56, .external_lex_state = 102},
  [9295] = {.lex_state = 55, .external_lex_state = 96},
  [9296] = {.lex_state = 55, .external_lex_state = 96},
  [9297] = {.lex_state = 55, .external_lex_state = 96},
  [9298] = {.lex_state = 55, .external_lex_state = 96},
  [9299] = {.lex_state = 55, .external_lex_state = 96},
  [9300] = {.lex_state = 55, .external_lex_state = 95},
  [9301] = {.lex_state = 55, .external_lex_state = 95},
  [9302] = {.lex_state = 56, .external_lex_state = 102},
  [9303] = {.lex_state = 55, .external_lex_state = 96},
  [9304] = {.lex_state = 55, .external_lex_state = 96},
  [9305] = {.lex_state = 55, .external_lex_state = 96},
  [9306] = {.lex_state = 56, .external_lex_state = 105},
  [9307] = {.lex_state = 55, .external_lex_state = 94},
  [9308] = {.lex_state = 55, .external_lex_state = 96},
  [9309] = {.lex_state = 55, .external_lex_state = 94},
  [9310] = {.lex_state = 58, .external_lex_state = 294},
  [9311] = {.lex_state = 55, .external_lex_state = 95},
  [9312] = {.lex_state = 56, .external_lex_state = 103},
  [9313] = {.lex_state = 55, .external_lex_state = 94},
  [9314] = {.lex_state = 55, .external_lex_state = 95},
  [9315] = {.lex_state = 55, .external_lex_state = 95},
  [9316] = {.lex_state = 55, .external_lex_state = 95},
  [9317] = {.lex_state = 56, .external_lex_state = 268},
  [9318] = {.lex_state = 55, .external_lex_state = 96},
  [9319] = {.lex_state = 55, .external_lex_state = 96},
  [9320] = {.lex_state = 56, .external_lex_state = 106},
  [9321] = {.lex_state = 55, .external_lex_state = 95},
  [9322] = {.lex_state = 56, .external_lex_state = 105},
  [9323] = {.lex_state = 55, .external_lex_state = 95},
  [9324] = {.lex_state = 56, .external_lex_state = 105},
  [9325] = {.lex_state = 55, .external_lex_state = 95},
  [9326] = {.lex_state = 56, .external_lex_state = 105},
  [9327] = {.lex_state = 55, .external_lex_state = 94},
  [9328] = {.lex_state = 56, .external_lex_state = 106},
  [9329] = {.lex_state = 55, .external_lex_state = 96},
  [9330] = {.lex_state = 56, .external_lex_state = 106},
  [9331] = {.lex_state = 55, .external_lex_state = 95},
  [9332] = {.lex_state = 55, .external_lex_state = 95},
  [9333] = {.lex_state = 55, .external_lex_state = 94},
  [9334] = {.lex_state = 56, .external_lex_state = 106},
  [9335] = {.lex_state = 56, .external_lex_state = 106},
  [9336] = {.lex_state = 57, .external_lex_state = 296},
  [9337] = {.lex_state = 55, .external_lex_state = 95},
  [9338] = {.lex_state = 55, .external_lex_state = 278},
  [9339] = {.lex_state = 56, .external_lex_state = 105},
  [9340] = {.lex_state = 55, .external_lex_state = 91},
  [9341] = {.lex_state = 55, .external_lex_state = 278},
  [9342] = {.lex_state = 56, .external_lex_state = 103},
  [9343] = {.lex_state = 55, .external_lex_state = 96},
  [9344] = {.lex_state = 55, .external_lex_state = 94},
  [9345] = {.lex_state = 55, .external_lex_state = 94},
  [9346] = {.lex_state = 55, .external_lex_state = 94},
  [9347] = {.lex_state = 55, .external_lex_state = 95},
  [9348] = {.lex_state = 55, .external_lex_state = 100},
  [9349] = {.lex_state = 56, .external_lex_state = 108},
  [9350] = {.lex_state = 55, .external_lex_state = 99},
  [9351] = {.lex_state = 56, .external_lex_state = 110},
  [9352] = {.lex_state = 56, .external_lex_state = 297},
  [9353] = {.lex_state = 55, .external_lex_state = 132},
  [9354] = {.lex_state = 56, .external_lex_state = 108},
  [9355] = {.lex_state = 56, .external_lex_state = 108},
  [9356] = {.lex_state = 56, .external_lex_state = 108},
  [9357] = {.lex_state = 55, .external_lex_state = 99},
  [9358] = {.lex_state = 55, .external_lex_state = 99},
  [9359] = {.lex_state = 56, .external_lex_state = 108},
  [9360] = {.lex_state = 56, .external_lex_state = 108},
  [9361] = {.lex_state = 55, .external_lex_state = 99},
  [9362] = {.lex_state = 56, .external_lex_state = 108},
  [9363] = {.lex_state = 56, .external_lex_state = 108},
  [9364] = {.lex_state = 56, .external_lex_state = 108},
  [9365] = {.lex_state = 56, .external_lex_state = 108},
  [9366] = {.lex_state = 56, .external_lex_state = 37},
  [9367] = {.lex_state = 56, .external_lex_state = 109},
  [9368] = {.lex_state = 56, .external_lex_state = 108},
  [9369] = {.lex_state = 56, .external_lex_state = 108},
  [9370] = {.lex_state = 55, .external_lex_state = 99},
  [9371] = {.lex_state = 56, .external_lex_state = 108},
  [9372] = {.lex_state = 55, .external_lex_state = 99},
  [9373] = {.lex_state = 55, .external_lex_state = 99},
  [9374] = {.lex_state = 55, .external_lex_state = 132},
  [9375] = {.lex_state = 56, .external_lex_state = 37},
  [9376] = {.lex_state = 56, .external_lex_state = 298},
  [9377] = {.lex_state = 56, .external_lex_state = 109},
  [9378] = {.lex_state = 55, .external_lex_state = 99},
  [9379] = {.lex_state = 55, .external_lex_state = 99},
  [9380] = {.lex_state = 55, .external_lex_state = 99},
  [9381] = {.lex_state = 55, .external_lex_state = 99},
  [9382] = {.lex_state = 55, .external_lex_state = 99},
  [9383] = {.lex_state = 56, .external_lex_state = 298},
  [9384] = {.lex_state = 55, .external_lex_state = 99},
  [9385] = {.lex_state = 55, .external_lex_state = 99},
  [9386] = {.lex_state = 56, .external_lex_state = 37},
  [9387] = {.lex_state = 56, .external_lex_state = 92},
  [9388] = {.lex_state = 56, .external_lex_state = 110},
  [9389] = {.lex_state = 56, .external_lex_state = 92},
  [9390] = {.lex_state = 55, .external_lex_state = 101},
  [9391] = {.lex_state = 55, .external_lex_state = 299},
  [9392] = {.lex_state = 56, .external_lex_state = 109},
  [9393] = {.lex_state = 55, .external_lex_state = 132},
  [9394] = {.lex_state = 60, .external_lex_state = 104},
  [9395] = {.lex_state = 56, .external_lex_state = 109},
  [9396] = {.lex_state = 56, .external_lex_state = 37},
  [9397] = {.lex_state = 56, .external_lex_state = 37},
  [9398] = {.lex_state = 55, .external_lex_state = 92},
  [9399] = {.lex_state = 55, .external_lex_state = 99},
  [9400] = {.lex_state = 56, .external_lex_state = 110},
  [9401] = {.lex_state = 56, .external_lex_state = 37},
  [9402] = {.lex_state = 56, .external_lex_state = 37},
  [9403] = {.lex_state = 60, .external_lex_state = 92},
  [9404] = {.lex_state = 56, .external_lex_state = 110},
  [9405] = {.lex_state = 56, .external_lex_state = 297},
  [9406] = {.lex_state = 56, .external_lex_state = 110},
  [9407] = {.lex_state = 55, .external_lex_state = 101},
  [9408] = {.lex_state = 56, .external_lex_state = 108},
  [9409] = {.lex_state = 55, .external_lex_state = 101},
  [9410] = {.lex_state = 56, .external_lex_state = 110},
  [9411] = {.lex_state = 56, .external_lex_state = 108},
  [9412] = {.lex_state = 56, .external_lex_state = 110},
  [9413] = {.lex_state = 56, .external_lex_state = 110},
  [9414] = {.lex_state = 56, .external_lex_state = 37},
  [9415] = {.lex_state = 56, .external_lex_state = 37},
  [9416] = {.lex_state = 56, .external_lex_state = 110},
  [9417] = {.lex_state = 56, .external_lex_state = 110},
  [9418] = {.lex_state = 56, .external_lex_state = 108},
  [9419] = {.lex_state = 56, .external_lex_state = 110},
  [9420] = {.lex_state = 56, .external_lex_state = 110},
  [9421] = {.lex_state = 56, .external_lex_state = 108},
  [9422] = {.lex_state = 56, .external_lex_state = 108},
  [9423] = {.lex_state = 56, .external_lex_state = 110},
  [9424] = {.lex_state = 56, .external_lex_state = 108},
  [9425] = {.lex_state = 55, .external_lex_state = 99},
  [9426] = {.lex_state = 55, .external_lex_state = 99},
  [9427] = {.lex_state = 55, .external_lex_state = 99},
  [9428] = {.lex_state = 56, .external_lex_state = 110},
  [9429] = {.lex_state = 56, .external_lex_state = 37},
  [9430] = {.lex_state = 56, .external_lex_state = 298},
  [9431] = {.lex_state = 56, .external_lex_state = 37},
  [9432] = {.lex_state = 56, .external_lex_state = 37},
  [9433] = {.lex_state = 55, .external_lex_state = 99},
  [9434] = {.lex_state = 56, .external_lex_state = 37},
  [9435] = {.lex_state = 56, .external_lex_state = 37},
  [9436] = {.lex_state = 56, .external_lex_state = 109},
  [9437] = {.lex_state = 56, .external_lex_state = 109},
  [9438] = {.lex_state = 56, .external_lex_state = 110},
  [9439] = {.lex_state = 56, .external_lex_state = 109},
  [9440] = {.lex_state = 56, .external_lex_state = 109},
  [9441] = {.lex_state = 56, .external_lex_state = 37},
  [9442] = {.lex_state = 55, .external_lex_state = 101},
  [9443] = {.lex_state = 56, .external_lex_state = 37},
  [9444] = {.lex_state = 56, .external_lex_state = 109},
  [9445] = {.lex_state = 56, .external_lex_state = 109},
  [9446] = {.lex_state = 56, .external_lex_state = 109},
  [9447] = {.lex_state = 55, .external_lex_state = 101},
  [9448] = {.lex_state = 56, .external_lex_state = 108},
  [9449] = {.lex_state = 56, .external_lex_state = 110},
  [9450] = {.lex_state = 55, .external_lex_state = 101},
  [9451] = {.lex_state = 55, .external_lex_state = 101},
  [9452] = {.lex_state = 56, .external_lex_state = 108},
  [9453] = {.lex_state = 56, .external_lex_state = 109},
  [9454] = {.lex_state = 55, .external_lex_state = 101},
  [9455] = {.lex_state = 55, .external_lex_state = 101},
  [9456] = {.lex_state = 55, .external_lex_state = 101},
  [9457] = {.lex_state = 56, .external_lex_state = 108},
  [9458] = {.lex_state = 56, .external_lex_state = 108},
  [9459] = {.lex_state = 56, .external_lex_state = 110},
  [9460] = {.lex_state = 55, .external_lex_state = 101},
  [9461] = {.lex_state = 56, .external_lex_state = 110},
  [9462] = {.lex_state = 55, .external_lex_state = 101},
  [9463] = {.lex_state = 56, .external_lex_state = 108},
  [9464] = {.lex_state = 55, .external_lex_state = 101},
  [9465] = {.lex_state = 56, .external_lex_state = 108},
  [9466] = {.lex_state = 56, .external_lex_state = 108},
  [9467] = {.lex_state = 56, .external_lex_state = 108},
  [9468] = {.lex_state = 56, .external_lex_state = 109},
  [9469] = {.lex_state = 56, .external_lex_state = 297},
  [9470] = {.lex_state = 56, .external_lex_state = 109},
  [9471] = {.lex_state = 56, .external_lex_state = 109},
  [9472] = {.lex_state = 56, .external_lex_state = 110},
  [9473] = {.lex_state = 56, .external_lex_state = 109},
  [9474] = {.lex_state = 56, .external_lex_state = 37},
  [9475] = {.lex_state = 56, .external_lex_state = 37},
  [9476] = {.lex_state = 55, .external_lex_state = 100},
  [9477] = {.lex_state = 56, .external_lex_state = 108},
  [9478] = {.lex_state = 56, .external_lex_state = 108},
  [9479] = {.lex_state = 55, .external_lex_state = 100},
  [9480] = {.lex_state = 55, .external_lex_state = 100},
  [9481] = {.lex_state = 55, .external_lex_state = 299},
  [9482] = {.lex_state = 56, .external_lex_state = 108},
  [9483] = {.lex_state = 56, .external_lex_state = 110},
  [9484] = {.lex_state = 56, .external_lex_state = 110},
  [9485] = {.lex_state = 56, .external_lex_state = 110},
  [9486] = {.lex_state = 55, .external_lex_state = 101},
  [9487] = {.lex_state = 56, .external_lex_state = 110},
  [9488] = {.lex_state = 56, .external_lex_state = 110},
  [9489] = {.lex_state = 56, .external_lex_state = 110},
  [9490] = {.lex_state = 56, .external_lex_state = 108},
  [9491] = {.lex_state = 55, .external_lex_state = 100},
  [9492] = {.lex_state = 56, .external_lex_state = 110},
  [9493] = {.lex_state = 55, .external_lex_state = 100},
  [9494] = {.lex_state = 56, .external_lex_state = 109},
  [9495] = {.lex_state = 55, .external_lex_state = 101},
  [9496] = {.lex_state = 57, .external_lex_state = 300},
  [9497] = {.lex_state = 56, .external_lex_state = 110},
  [9498] = {.lex_state = 56, .external_lex_state = 110},
  [9499] = {.lex_state = 56, .external_lex_state = 109},
  [9500] = {.lex_state = 56, .external_lex_state = 108},
  [9501] = {.lex_state = 56, .external_lex_state = 37},
  [9502] = {.lex_state = 55, .external_lex_state = 100},
  [9503] = {.lex_state = 56, .external_lex_state = 37},
  [9504] = {.lex_state = 56, .external_lex_state = 110},
  [9505] = {.lex_state = 56, .external_lex_state = 110},
  [9506] = {.lex_state = 56, .external_lex_state = 37},
  [9507] = {.lex_state = 55, .external_lex_state = 100},
  [9508] = {.lex_state = 56, .external_lex_state = 110},
  [9509] = {.lex_state = 56, .external_lex_state = 37},
  [9510] = {.lex_state = 55, .external_lex_state = 100},
  [9511] = {.lex_state = 56, .external_lex_state = 37},
  [9512] = {.lex_state = 56, .external_lex_state = 297},
  [9513] = {.lex_state = 56, .external_lex_state = 37},
  [9514] = {.lex_state = 56, .external_lex_state = 37},
  [9515] = {.lex_state = 55, .external_lex_state = 100},
  [9516] = {.lex_state = 56, .external_lex_state = 37},
  [9517] = {.lex_state = 55, .external_lex_state = 100},
  [9518] = {.lex_state = 55, .external_lex_state = 101},
  [9519] = {.lex_state = 56, .external_lex_state = 109},
  [9520] = {.lex_state = 56, .external_lex_state = 110},
  [9521] = {.lex_state = 55, .external_lex_state = 100},
  [9522] = {.lex_state = 55, .external_lex_state = 101},
  [9523] = {.lex_state = 55, .external_lex_state = 101},
  [9524] = {.lex_state = 55, .external_lex_state = 100},
  [9525] = {.lex_state = 55, .external_lex_state = 101},
  [9526] = {.lex_state = 56, .external_lex_state = 110},
  [9527] = {.lex_state = 55, .external_lex_state = 100},
  [9528] = {.lex_state = 55, .external_lex_state = 101},
  [9529] = {.lex_state = 56, .external_lex_state = 109},
  [9530] = {.lex_state = 56, .external_lex_state = 37},
  [9531] = {.lex_state = 55, .external_lex_state = 101},
  [9532] = {.lex_state = 56, .external_lex_state = 109},
  [9533] = {.lex_state = 55, .external_lex_state = 100},
  [9534] = {.lex_state = 56, .external_lex_state = 109},
  [9535] = {.lex_state = 55, .external_lex_state = 101},
  [9536] = {.lex_state = 55, .external_lex_state = 101},
  [9537] = {.lex_state = 55, .external_lex_state = 101},
  [9538] = {.lex_state = 55, .external_lex_state = 100},
  [9539] = {.lex_state = 56, .external_lex_state = 109},
  [9540] = {.lex_state = 55, .external_lex_state = 100},
  [9541] = {.lex_state = 55, .external_lex_state = 101},
  [9542] = {.lex_state = 55, .external_lex_state = 101},
  [9543] = {.lex_state = 55, .external_lex_state = 100},
  [9544] = {.lex_state = 55, .external_lex_state = 101},
  [9545] = {.lex_state = 55, .external_lex_state = 101},
  [9546] = {.lex_state = 55, .external_lex_state = 99},
  [9547] = {.lex_state = 55, .external_lex_state = 100},
  [9548] = {.lex_state = 55, .external_lex_state = 99},
  [9549] = {.lex_state = 55, .external_lex_state = 101},
  [9550] = {.lex_state = 55, .external_lex_state = 101},
  [9551] = {.lex_state = 56, .external_lex_state = 37},
  [9552] = {.lex_state = 55, .external_lex_state = 104},
  [9553] = {.lex_state = 55, .external_lex_state = 100},
  [9554] = {.lex_state = 56, .external_lex_state = 250},
  [9555] = {.lex_state = 55, .external_lex_state = 100},
  [9556] = {.lex_state = 56, .external_lex_state = 250},
  [9557] = {.lex_state = 55, .external_lex_state = 100},
  [9558] = {.lex_state = 55, .external_lex_state = 100},
  [9559] = {.lex_state = 56, .external_lex_state = 109},
  [9560] = {.lex_state = 55, .external_lex_state = 100},
  [9561] = {.lex_state = 55, .external_lex_state = 100},
  [9562] = {.lex_state = 55, .external_lex_state = 100},
  [9563] = {.lex_state = 55, .external_lex_state = 100},
  [9564] = {.lex_state = 55, .external_lex_state = 100},
  [9565] = {.lex_state = 55, .external_lex_state = 101},
  [9566] = {.lex_state = 55, .external_lex_state = 100},
  [9567] = {.lex_state = 55, .external_lex_state = 100},
  [9568] = {.lex_state = 55, .external_lex_state = 100},
  [9569] = {.lex_state = 55, .external_lex_state = 100},
  [9570] = {.lex_state = 55, .external_lex_state = 101},
  [9571] = {.lex_state = 55, .external_lex_state = 100},
  [9572] = {.lex_state = 56, .external_lex_state = 297},
  [9573] = {.lex_state = 55, .external_lex_state = 100},
  [9574] = {.lex_state = 56, .external_lex_state = 298},
  [9575] = {.lex_state = 55, .external_lex_state = 99},
  [9576] = {.lex_state = 55, .external_lex_state = 101},
  [9577] = {.lex_state = 55, .external_lex_state = 101},
  [9578] = {.lex_state = 56, .external_lex_state = 298},
  [9579] = {.lex_state = 56, .external_lex_state = 109},
  [9580] = {.lex_state = 56, .external_lex_state = 109},
  [9581] = {.lex_state = 55, .external_lex_state = 99},
  [9582] = {.lex_state = 55, .external_lex_state = 101},
  [9583] = {.lex_state = 55, .external_lex_state = 101},
  [9584] = {.lex_state = 56, .external_lex_state = 250},
  [9585] = {.lex_state = 55, .external_lex_state = 101},
  [9586] = {.lex_state = 55, .external_lex_state = 101},
  [9587] = {.lex_state = 55, .external_lex_state = 101},
  [9588] = {.lex_state = 55, .external_lex_state = 100},
  [9589] = {.lex_state = 55, .external_lex_state = 101},
  [9590] = {.lex_state = 55, .external_lex_state = 100},
  [9591] = {.lex_state = 55, .external_lex_state = 101},
  [9592] = {.lex_state = 55, .external_lex_state = 101},
  [9593] = {.lex_state = 55, .external_lex_state = 101},
  [9594] = {.lex_state = 55, .external_lex_state = 100},
  [9595] = {.lex_state = 55, .external_lex_state = 99},
  [9596] = {.lex_state = 56, .external_lex_state = 37},
  [9597] = {.lex_state = 55, .external_lex_state = 99},
  [9598] = {.lex_state = 55, .external_lex_state = 101},
  [9599] = {.lex_state = 56, .external_lex_state = 108},
  [9600] = {.lex_state = 55, .external_lex_state = 99},
  [9601] = {.lex_state = 56, .external_lex_state = 37},
  [9602] = {.lex_state = 55, .external_lex_state = 99},
  [9603] = {.lex_state = 55, .external_lex_state = 99},
  [9604] = {.lex_state = 56, .external_lex_state = 109},
  [9605] = {.lex_state = 55, .external_lex_state = 99},
  [9606] = {.lex_state = 60, .external_lex_state = 104},
  [9607] = {.lex_state = 55, .external_lex_state = 99},
  [9608] = {.lex_state = 55, .external_lex_state = 99},
  [9609] = {.lex_state = 55, .external_lex_state = 99},
  [9610] = {.lex_state = 55, .external_lex_state = 99},
  [9611] = {.lex_state = 56, .external_lex_state = 109},
  [9612] = {.lex_state = 55, .external_lex_state = 99},
  [9613] = {.lex_state = 55, .external_lex_state = 99},
  [9614] = {.lex_state = 55, .external_lex_state = 99},
  [9615] = {.lex_state = 55, .external_lex_state = 99},
  [9616] = {.lex_state = 56, .external_lex_state = 37},
  [9617] = {.lex_state = 55, .external_lex_state = 100},
  [9618] = {.lex_state = 56, .external_lex_state = 37},
  [9619] = {.lex_state = 56, .external_lex_state = 297},
  [9620] = {.lex_state = 56, .external_lex_state = 37},
  [9621] = {.lex_state = 55, .external_lex_state = 101},
  [9622] = {.lex_state = 56, .external_lex_state = 108},
  [9623] = {.lex_state = 55, .external_lex_state = 101},
  [9624] = {.lex_state = 55, .external_lex_state = 101},
  [9625] = {.lex_state = 55, .external_lex_state = 100},
  [9626] = {.lex_state = 55, .external_lex_state = 101},
  [9627] = {.lex_state = 55, .external_lex_state = 101},
  [9628] = {.lex_state = 56, .external_lex_state = 109},
  [9629] = {.lex_state = 55, .external_lex_state = 99},
  [9630] = {.lex_state = 56, .external_lex_state = 109},
  [9631] = {.lex_state = 55, .external_lex_state = 101},
  [9632] = {.lex_state = 55, .external_lex_state = 101},
  [9633] = {.lex_state = 56, .external_lex_state = 298},
  [9634] = {.lex_state = 55, .external_lex_state = 100},
  [9635] = {.lex_state = 56, .external_lex_state = 37},
  [9636] = {.lex_state = 55, .external_lex_state = 100},
  [9637] = {.lex_state = 56, .external_lex_state = 110},
  [9638] = {.lex_state = 55, .external_lex_state = 100},
  [9639] = {.lex_state = 55, .external_lex_state = 99},
  [9640] = {.lex_state = 55, .external_lex_state = 99},
  [9641] = {.lex_state = 55, .external_lex_state = 99},
  [9642] = {.lex_state = 55, .external_lex_state = 101},
  [9643] = {.lex_state = 55, .external_lex_state = 99},
  [9644] = {.lex_state = 55, .external_lex_state = 99},
  [9645] = {.lex_state = 55, .external_lex_state = 99},
  [9646] = {.lex_state = 55, .external_lex_state = 99},
  [9647] = {.lex_state = 55, .external_lex_state = 99},
  [9648] = {.lex_state = 55, .external_lex_state = 99},
  [9649] = {.lex_state = 55, .external_lex_state = 99},
  [9650] = {.lex_state = 55, .external_lex_state = 99},
  [9651] = {.lex_state = 55, .external_lex_state = 99},
  [9652] = {.lex_state = 56, .external_lex_state = 250},
  [9653] = {.lex_state = 55, .external_lex_state = 100},
  [9654] = {.lex_state = 56, .external_lex_state = 250},
  [9655] = {.lex_state = 55, .external_lex_state = 100},
  [9656] = {.lex_state = 55, .external_lex_state = 100},
  [9657] = {.lex_state = 56, .external_lex_state = 109},
  [9658] = {.lex_state = 55, .external_lex_state = 100},
  [9659] = {.lex_state = 56, .external_lex_state = 109},
  [9660] = {.lex_state = 56, .external_lex_state = 109},
  [9661] = {.lex_state = 55, .external_lex_state = 100},
  [9662] = {.lex_state = 55, .external_lex_state = 100},
  [9663] = {.lex_state = 55, .external_lex_state = 100},
  [9664] = {.lex_state = 55, .external_lex_state = 99},
  [9665] = {.lex_state = 55, .external_lex_state = 100},
  [9666] = {.lex_state = 56, .external_lex_state = 109},
  [9667] = {.lex_state = 55, .external_lex_state = 100},
  [9668] = {.lex_state = 55, .external_lex_state = 99},
  [9669] = {.lex_state = 55, .external_lex_state = 100},
  [9670] = {.lex_state = 55, .external_lex_state = 104},
  [9671] = {.lex_state = 55, .external_lex_state = 104},
  [9672] = {.lex_state = 55, .external_lex_state = 104},
  [9673] = {.lex_state = 56, .external_lex_state = 111},
  [9674] = {.lex_state = 56, .external_lex_state = 111},
  [9675] = {.lex_state = 55, .external_lex_state = 301},
  [9676] = {.lex_state = 55, .external_lex_state = 302},
  [9677] = {.lex_state = 55, .external_lex_state = 104},
  [9678] = {.lex_state = 56, .external_lex_state = 113},
  [9679] = {.lex_state = 55, .external_lex_state = 104},
  [9680] = {.lex_state = 55, .external_lex_state = 104},
  [9681] = {.lex_state = 56, .external_lex_state = 111},
  [9682] = {.lex_state = 56, .external_lex_state = 111},
  [9683] = {.lex_state = 55, .external_lex_state = 104},
  [9684] = {.lex_state = 55, .external_lex_state = 104},
  [9685] = {.lex_state = 55, .external_lex_state = 104},
  [9686] = {.lex_state = 56, .external_lex_state = 112},
  [9687] = {.lex_state = 56, .external_lex_state = 111},
  [9688] = {.lex_state = 56, .external_lex_state = 111},
  [9689] = {.lex_state = 56, .external_lex_state = 111},
  [9690] = {.lex_state = 56, .external_lex_state = 111},
  [9691] = {.lex_state = 55, .external_lex_state = 104},
  [9692] = {.lex_state = 56, .external_lex_state = 111},
  [9693] = {.lex_state = 56, .external_lex_state = 111},
  [9694] = {.lex_state = 56, .external_lex_state = 111},
  [9695] = {.lex_state = 56, .external_lex_state = 111},
  [9696] = {.lex_state = 55, .external_lex_state = 104},
  [9697] = {.lex_state = 55, .external_lex_state = 104},
  [9698] = {.lex_state = 55, .external_lex_state = 104},
  [9699] = {.lex_state = 55, .external_lex_state = 104},
  [9700] = {.lex_state = 56, .external_lex_state = 111},
  [9701] = {.lex_state = 56, .external_lex_state = 111},
  [9702] = {.lex_state = 56, .external_lex_state = 112},
  [9703] = {.lex_state = 56, .external_lex_state = 111},
  [9704] = {.lex_state = 56, .external_lex_state = 112},
  [9705] = {.lex_state = 55, .external_lex_state = 104},
  [9706] = {.lex_state = 55, .external_lex_state = 104},
  [9707] = {.lex_state = 56, .external_lex_state = 113},
  [9708] = {.lex_state = 55, .external_lex_state = 104},
  [9709] = {.lex_state = 55, .external_lex_state = 104},
  [9710] = {.lex_state = 56, .external_lex_state = 113},
  [9711] = {.lex_state = 56, .external_lex_state = 112},
  [9712] = {.lex_state = 56, .external_lex_state = 112},
  [9713] = {.lex_state = 55, .external_lex_state = 104},
  [9714] = {.lex_state = 56, .external_lex_state = 3},
  [9715] = {.lex_state = 58, .external_lex_state = 303},
  [9716] = {.lex_state = 55, .external_lex_state = 104},
  [9717] = {.lex_state = 56, .external_lex_state = 112},
  [9718] = {.lex_state = 56, .external_lex_state = 112},
  [9719] = {.lex_state = 55, .external_lex_state = 104},
  [9720] = {.lex_state = 55, .external_lex_state = 104},
  [9721] = {.lex_state = 56, .external_lex_state = 112},
  [9722] = {.lex_state = 56, .external_lex_state = 112},
  [9723] = {.lex_state = 56, .external_lex_state = 111},
  [9724] = {.lex_state = 56, .external_lex_state = 111},
  [9725] = {.lex_state = 56, .external_lex_state = 112},
  [9726] = {.lex_state = 56, .external_lex_state = 112},
  [9727] = {.lex_state = 55, .external_lex_state = 104},
  [9728] = {.lex_state = 56, .external_lex_state = 111},
  [9729] = {.lex_state = 56, .external_lex_state = 112},
  [9730] = {.lex_state = 56, .external_lex_state = 111},
  [9731] = {.lex_state = 56, .external_lex_state = 111},
  [9732] = {.lex_state = 56, .external_lex_state = 111},
  [9733] = {.lex_state = 56, .external_lex_state = 111},
  [9734] = {.lex_state = 55, .external_lex_state = 104},
  [9735] = {.lex_state = 56, .external_lex_state = 111},
  [9736] = {.lex_state = 55, .external_lex_state = 104},
  [9737] = {.lex_state = 55, .external_lex_state = 104},
  [9738] = {.lex_state = 55, .external_lex_state = 104},
  [9739] = {.lex_state = 56, .external_lex_state = 111},
  [9740] = {.lex_state = 56, .external_lex_state = 111},
  [9741] = {.lex_state = 55, .external_lex_state = 104},
  [9742] = {.lex_state = 56, .external_lex_state = 111},
  [9743] = {.lex_state = 56, .external_lex_state = 111},
  [9744] = {.lex_state = 56, .external_lex_state = 112},
  [9745] = {.lex_state = 56, .external_lex_state = 111},
  [9746] = {.lex_state = 56, .external_lex_state = 304},
  [9747] = {.lex_state = 56, .external_lex_state = 111},
  [9748] = {.lex_state = 56, .external_lex_state = 304},
  [9749] = {.lex_state = 56, .external_lex_state = 111},
  [9750] = {.lex_state = 56, .external_lex_state = 112},
  [9751] = {.lex_state = 56, .external_lex_state = 304},
  [9752] = {.lex_state = 56, .external_lex_state = 111},
  [9753] = {.lex_state = 56, .external_lex_state = 112},
  [9754] = {.lex_state = 56, .external_lex_state = 111},
  [9755] = {.lex_state = 56, .external_lex_state = 112},
  [9756] = {.lex_state = 56, .external_lex_state = 112},
  [9757] = {.lex_state = 56, .external_lex_state = 112},
  [9758] = {.lex_state = 56, .external_lex_state = 111},
  [9759] = {.lex_state = 56, .external_lex_state = 111},
  [9760] = {.lex_state = 55, .external_lex_state = 3},
  [9761] = {.lex_state = 56, .external_lex_state = 112},
  [9762] = {.lex_state = 56, .external_lex_state = 113},
  [9763] = {.lex_state = 58, .external_lex_state = 303},
  [9764] = {.lex_state = 55, .external_lex_state = 104},
  [9765] = {.lex_state = 58, .external_lex_state = 305},
  [9766] = {.lex_state = 55, .external_lex_state = 302},
  [9767] = {.lex_state = 55, .external_lex_state = 104},
  [9768] = {.lex_state = 55, .external_lex_state = 104},
  [9769] = {.lex_state = 58, .external_lex_state = 306},
  [9770] = {.lex_state = 55, .external_lex_state = 301},
  [9771] = {.lex_state = 56, .external_lex_state = 112},
  [9772] = {.lex_state = 56, .external_lex_state = 113},
  [9773] = {.lex_state = 56, .external_lex_state = 113},
  [9774] = {.lex_state = 56, .external_lex_state = 113},
  [9775] = {.lex_state = 56, .external_lex_state = 113},
  [9776] = {.lex_state = 56, .external_lex_state = 304},
  [9777] = {.lex_state = 56, .external_lex_state = 304},
  [9778] = {.lex_state = 56, .external_lex_state = 113},
  [9779] = {.lex_state = 56, .external_lex_state = 113},
  [9780] = {.lex_state = 56, .external_lex_state = 113},
  [9781] = {.lex_state = 56, .external_lex_state = 113},
  [9782] = {.lex_state = 56, .external_lex_state = 304},
  [9783] = {.lex_state = 56, .external_lex_state = 113},
  [9784] = {.lex_state = 56, .external_lex_state = 113},
  [9785] = {.lex_state = 56, .external_lex_state = 113},
  [9786] = {.lex_state = 56, .external_lex_state = 113},
  [9787] = {.lex_state = 58, .external_lex_state = 305},
  [9788] = {.lex_state = 55, .external_lex_state = 92},
  [9789] = {.lex_state = 56, .external_lex_state = 113},
  [9790] = {.lex_state = 56, .external_lex_state = 113},
  [9791] = {.lex_state = 56, .external_lex_state = 113},
  [9792] = {.lex_state = 56, .external_lex_state = 113},
  [9793] = {.lex_state = 56, .external_lex_state = 112},
  [9794] = {.lex_state = 55, .external_lex_state = 104},
  [9795] = {.lex_state = 56, .external_lex_state = 113},
  [9796] = {.lex_state = 56, .external_lex_state = 113},
  [9797] = {.lex_state = 55, .external_lex_state = 104},
  [9798] = {.lex_state = 56, .external_lex_state = 113},
  [9799] = {.lex_state = 56, .external_lex_state = 113},
  [9800] = {.lex_state = 56, .external_lex_state = 112},
  [9801] = {.lex_state = 56, .external_lex_state = 113},
  [9802] = {.lex_state = 56, .external_lex_state = 113},
  [9803] = {.lex_state = 55, .external_lex_state = 104},
  [9804] = {.lex_state = 55, .external_lex_state = 307},
  [9805] = {.lex_state = 55, .external_lex_state = 92},
  [9806] = {.lex_state = 56, .external_lex_state = 113},
  [9807] = {.lex_state = 56, .external_lex_state = 112},
  [9808] = {.lex_state = 56, .external_lex_state = 113},
  [9809] = {.lex_state = 55, .external_lex_state = 92},
  [9810] = {.lex_state = 55, .external_lex_state = 104},
  [9811] = {.lex_state = 56, .external_lex_state = 113},
  [9812] = {.lex_state = 55, .external_lex_state = 104},
  [9813] = {.lex_state = 55, .external_lex_state = 92},
  [9814] = {.lex_state = 56, .external_lex_state = 112},
  [9815] = {.lex_state = 56, .external_lex_state = 113},
  [9816] = {.lex_state = 56, .external_lex_state = 112},
  [9817] = {.lex_state = 56, .external_lex_state = 113},
  [9818] = {.lex_state = 56, .external_lex_state = 112},
  [9819] = {.lex_state = 56, .external_lex_state = 112},
  [9820] = {.lex_state = 55, .external_lex_state = 92},
  [9821] = {.lex_state = 55, .external_lex_state = 92},
  [9822] = {.lex_state = 56, .external_lex_state = 113},
  [9823] = {.lex_state = 56, .external_lex_state = 113},
  [9824] = {.lex_state = 55, .external_lex_state = 307},
  [9825] = {.lex_state = 55, .external_lex_state = 104},
  [9826] = {.lex_state = 56, .external_lex_state = 113},
  [9827] = {.lex_state = 56, .external_lex_state = 112},
  [9828] = {.lex_state = 55, .external_lex_state = 104},
  [9829] = {.lex_state = 55, .external_lex_state = 104},
  [9830] = {.lex_state = 55, .external_lex_state = 307},
  [9831] = {.lex_state = 55, .external_lex_state = 92},
  [9832] = {.lex_state = 55, .external_lex_state = 92},
  [9833] = {.lex_state = 55, .external_lex_state = 92},
  [9834] = {.lex_state = 55, .external_lex_state = 104},
  [9835] = {.lex_state = 58, .external_lex_state = 306},
  [9836] = {.lex_state = 55, .external_lex_state = 92},
  [9837] = {.lex_state = 55, .external_lex_state = 92},
  [9838] = {.lex_state = 55, .external_lex_state = 104},
  [9839] = {.lex_state = 55, .external_lex_state = 92},
  [9840] = {.lex_state = 55, .external_lex_state = 104},
  [9841] = {.lex_state = 56, .external_lex_state = 112},
  [9842] = {.lex_state = 55, .external_lex_state = 104},
  [9843] = {.lex_state = 55, .external_lex_state = 104},
  [9844] = {.lex_state = 55, .external_lex_state = 92},
  [9845] = {.lex_state = 55, .external_lex_state = 92},
  [9846] = {.lex_state = 55, .external_lex_state = 104},
  [9847] = {.lex_state = 55, .external_lex_state = 92},
  [9848] = {.lex_state = 55, .external_lex_state = 92},
  [9849] = {.lex_state = 56, .external_lex_state = 112},
  [9850] = {.lex_state = 55, .external_lex_state = 104},
  [9851] = {.lex_state = 55, .external_lex_state = 92},
  [9852] = {.lex_state = 55, .external_lex_state = 104},
  [9853] = {.lex_state = 55, .external_lex_state = 92},
  [9854] = {.lex_state = 55, .external_lex_state = 92},
  [9855] = {.lex_state = 55, .external_lex_state = 92},
  [9856] = {.lex_state = 55, .external_lex_state = 104},
  [9857] = {.lex_state = 55, .external_lex_state = 104},
  [9858] = {.lex_state = 55, .external_lex_state = 92},
  [9859] = {.lex_state = 56, .external_lex_state = 112},
  [9860] = {.lex_state = 56, .external_lex_state = 112},
  [9861] = {.lex_state = 56, .external_lex_state = 112},
  [9862] = {.lex_state = 56, .external_lex_state = 112},
  [9863] = {.lex_state = 55, .external_lex_state = 104},
  [9864] = {.lex_state = 55, .external_lex_state = 104},
  [9865] = {.lex_state = 55, .external_lex_state = 104},
  [9866] = {.lex_state = 55, .external_lex_state = 3},
  [9867] = {.lex_state = 56, .external_lex_state = 30},
  [9868] = {.lex_state = 2, .external_lex_state = 308},
  [9869] = {.lex_state = 55, .external_lex_state = 3},
  [9870] = {.lex_state = 2, .external_lex_state = 308},
  [9871] = {.lex_state = 2, .external_lex_state = 308},
  [9872] = {.lex_state = 2, .external_lex_state = 308},
  [9873] = {.lex_state = 2, .external_lex_state = 308},
  [9874] = {.lex_state = 55, .external_lex_state = 3},
  [9875] = {.lex_state = 55, .external_lex_state = 3},
  [9876] = {.lex_state = 2, .external_lex_state = 308},
  [9877] = {.lex_state = 55, .external_lex_state = 3},
  [9878] = {.lex_state = 2, .external_lex_state = 308},
  [9879] = {.lex_state = 2, .external_lex_state = 308},
  [9880] = {.lex_state = 55, .external_lex_state = 3},
  [9881] = {.lex_state = 55, .external_lex_state = 3},
  [9882] = {.lex_state = 2, .external_lex_state = 308},
  [9883] = {.lex_state = 2, .external_lex_state = 308},
  [9884] = {.lex_state = 55, .external_lex_state = 3},
  [9885] = {.lex_state = 55, .external_lex_state = 3},
  [9886] = {.lex_state = 55, .external_lex_state = 3},
  [9887] = {.lex_state = 55, .external_lex_state = 3},
  [9888] = {.lex_state = 55, .external_lex_state = 3},
  [9889] = {.lex_state = 58, .external_lex_state = 309},
  [9890] = {.lex_state = 55, .external_lex_state = 3},
  [9891] = {.lex_state = 2, .external_lex_state = 308},
  [9892] = {.lex_state = 2, .external_lex_state = 308},
  [9893] = {.lex_state = 2, .external_lex_state = 308},
  [9894] = {.lex_state = 2, .external_lex_state = 308},
  [9895] = {.lex_state = 2, .external_lex_state = 308},
  [9896] = {.lex_state = 0, .external_lex_state = 291},
  [9897] = {.lex_state = 55, .external_lex_state = 3},
  [9898] = {.lex_state = 55, .external_lex_state = 3},
  [9899] = {.lex_state = 2, .external_lex_state = 308},
  [9900] = {.lex_state = 2, .external_lex_state = 308},
  [9901] = {.lex_state = 2, .external_lex_state = 308},
  [9902] = {.lex_state = 55, .external_lex_state = 3},
  [9903] = {.lex_state = 55, .external_lex_state = 3},
  [9904] = {.lex_state = 2, .external_lex_state = 308},
  [9905] = {.lex_state = 2, .external_lex_state = 308},
  [9906] = {.lex_state = 2, .external_lex_state = 308},
  [9907] = {.lex_state = 2, .external_lex_state = 308},
  [9908] = {.lex_state = 2, .external_lex_state = 308},
  [9909] = {.lex_state = 2, .external_lex_state = 308},
  [9910] = {.lex_state = 2, .external_lex_state = 308},
  [9911] = {.lex_state = 56, .external_lex_state = 30},
  [9912] = {.lex_state = 2, .external_lex_state = 308},
  [9913] = {.lex_state = 2, .external_lex_state = 308},
  [9914] = {.lex_state = 2, .external_lex_state = 308},
  [9915] = {.lex_state = 55, .external_lex_state = 3},
  [9916] = {.lex_state = 2, .external_lex_state = 308},
  [9917] = {.lex_state = 2, .external_lex_state = 308},
  [9918] = {.lex_state = 2, .external_lex_state = 308},
  [9919] = {.lex_state = 2, .external_lex_state = 308},
  [9920] = {.lex_state = 55, .external_lex_state = 3},
  [9921] = {.lex_state = 2, .external_lex_state = 308},
  [9922] = {.lex_state = 55, .external_lex_state = 3},
  [9923] = {.lex_state = 2, .external_lex_state = 308},
  [9924] = {.lex_state = 55, .external_lex_state = 3},
  [9925] = {.lex_state = 2, .external_lex_state = 308},
  [9926] = {.lex_state = 55, .external_lex_state = 3},
  [9927] = {.lex_state = 56, .external_lex_state = 30},
  [9928] = {.lex_state = 55, .external_lex_state = 3},
  [9929] = {.lex_state = 2, .external_lex_state = 308},
  [9930] = {.lex_state = 2, .external_lex_state = 308},
  [9931] = {.lex_state = 2, .external_lex_state = 308},
  [9932] = {.lex_state = 56, .external_lex_state = 30},
  [9933] = {.lex_state = 55, .external_lex_state = 3},
  [9934] = {.lex_state = 56, .external_lex_state = 30},
  [9935] = {.lex_state = 55, .external_lex_state = 3},
  [9936] = {.lex_state = 2, .external_lex_state = 308},
  [9937] = {.lex_state = 2, .external_lex_state = 308},
  [9938] = {.lex_state = 2, .external_lex_state = 308},
  [9939] = {.lex_state = 55, .external_lex_state = 3},
  [9940] = {.lex_state = 55, .external_lex_state = 3},
  [9941] = {.lex_state = 55, .external_lex_state = 3},
  [9942] = {.lex_state = 0, .external_lex_state = 291},
  [9943] = {.lex_state = 55, .external_lex_state = 3},
  [9944] = {.lex_state = 2, .external_lex_state = 308},
  [9945] = {.lex_state = 2, .external_lex_state = 308},
  [9946] = {.lex_state = 2, .external_lex_state = 308},
  [9947] = {.lex_state = 2, .external_lex_state = 308},
  [9948] = {.lex_state = 2, .external_lex_state = 308},
  [9949] = {.lex_state = 55, .external_lex_state = 3},
  [9950] = {.lex_state = 2, .external_lex_state = 308},
  [9951] = {.lex_state = 55, .external_lex_state = 3},
  [9952] = {.lex_state = 2, .external_lex_state = 308},
  [9953] = {.lex_state = 55, .external_lex_state = 3},
  [9954] = {.lex_state = 55, .external_lex_state = 3},
  [9955] = {.lex_state = 2, .external_lex_state = 308},
  [9956] = {.lex_state = 2, .external_lex_state = 308},
  [9957] = {.lex_state = 55, .external_lex_state = 92},
  [9958] = {.lex_state = 55, .external_lex_state = 3},
  [9959] = {.lex_state = 55, .external_lex_state = 3},
  [9960] = {.lex_state = 2, .external_lex_state = 308},
  [9961] = {.lex_state = 55, .external_lex_state = 3},
  [9962] = {.lex_state = 2, .external_lex_state = 308},
  [9963] = {.lex_state = 55, .external_lex_state = 3},
  [9964] = {.lex_state = 2, .external_lex_state = 308},
  [9965] = {.lex_state = 2, .external_lex_state = 308},
  [9966] = {.lex_state = 55, .external_lex_state = 3},
  [9967] = {.lex_state = 56, .external_lex_state = 30},
  [9968] = {.lex_state = 55, .external_lex_state = 3},
  [9969] = {.lex_state = 55, .external_lex_state = 3},
  [9970] = {.lex_state = 2, .external_lex_state = 308},
  [9971] = {.lex_state = 55, .external_lex_state = 307},
  [9972] = {.lex_state = 56, .external_lex_state = 30},
  [9973] = {.lex_state = 2, .external_lex_state = 308},
  [9974] = {.lex_state = 55, .external_lex_state = 3},
  [9975] = {.lex_state = 2, .external_lex_state = 308},
  [9976] = {.lex_state = 55, .external_lex_state = 3},
  [9977] = {.lex_state = 2, .external_lex_state = 308},
  [9978] = {.lex_state = 2, .external_lex_state = 308},
  [9979] = {.lex_state = 55, .external_lex_state = 3},
  [9980] = {.lex_state = 55, .external_lex_state = 3},
  [9981] = {.lex_state = 55, .external_lex_state = 3},
  [9982] = {.lex_state = 2, .external_lex_state = 308},
  [9983] = {.lex_state = 55, .external_lex_state = 3},
  [9984] = {.lex_state = 2, .external_lex_state = 308},
  [9985] = {.lex_state = 55, .external_lex_state = 3},
  [9986] = {.lex_state = 55, .external_lex_state = 3},
  [9987] = {.lex_state = 55, .external_lex_state = 3},
  [9988] = {.lex_state = 56, .external_lex_state = 30},
  [9989] = {.lex_state = 2, .external_lex_state = 308},
  [9990] = {.lex_state = 55, .external_lex_state = 3},
  [9991] = {.lex_state = 2, .external_lex_state = 308},
  [9992] = {.lex_state = 55, .external_lex_state = 3},
  [9993] = {.lex_state = 55, .external_lex_state = 3},
  [9994] = {.lex_state = 58, .external_lex_state = 310},
  [9995] = {.lex_state = 55, .external_lex_state = 3},
  [9996] = {.lex_state = 2, .external_lex_state = 308},
  [9997] = {.lex_state = 2, .external_lex_state = 308},
  [9998] = {.lex_state = 55, .external_lex_state = 3},
  [9999] = {.lex_state = 55, .external_lex_state = 3},
  [10000] = {.lex_state = 2, .external_lex_state = 308},
  [10001] = {.lex_state = 55, .external_lex_state = 3},
  [10002] = {.lex_state = 2, .external_lex_state = 308},
  [10003] = {.lex_state = 55, .external_lex_state = 3},
  [10004] = {.lex_state = 2, .external_lex_state = 308},
  [10005] = {.lex_state = 55, .external_lex_state = 3},
  [10006] = {.lex_state = 2, .external_lex_state = 308},
  [10007] = {.lex_state = 0, .external_lex_state = 291},
  [10008] = {.lex_state = 55, .external_lex_state = 3},
  [10009] = {.lex_state = 2, .external_lex_state = 308},
  [10010] = {.lex_state = 55, .external_lex_state = 3},
  [10011] = {.lex_state = 55, .external_lex_state = 3},
  [10012] = {.lex_state = 2, .external_lex_state = 308},
  [10013] = {.lex_state = 55, .external_lex_state = 3},
  [10014] = {.lex_state = 55, .external_lex_state = 3},
  [10015] = {.lex_state = 55, .external_lex_state = 3},
  [10016] = {.lex_state = 55, .external_lex_state = 3},
  [10017] = {.lex_state = 55, .external_lex_state = 3},
  [10018] = {.lex_state = 55, .external_lex_state = 3},
  [10019] = {.lex_state = 55, .external_lex_state = 3},
  [10020] = {.lex_state = 2, .external_lex_state = 308},
  [10021] = {.lex_state = 2, .external_lex_state = 308},
  [10022] = {.lex_state = 2, .external_lex_state = 308},
  [10023] = {.lex_state = 2, .external_lex_state = 308},
  [10024] = {.lex_state = 55, .external_lex_state = 3},
  [10025] = {.lex_state = 55, .external_lex_state = 3},
  [10026] = {.lex_state = 2, .external_lex_state = 308},
  [10027] = {.lex_state = 55, .external_lex_state = 3},
  [10028] = {.lex_state = 55, .external_lex_state = 3},
  [10029] = {.lex_state = 2, .external_lex_state = 308},
  [10030] = {.lex_state = 55, .external_lex_state = 3},
  [10031] = {.lex_state = 56, .external_lex_state = 30},
  [10032] = {.lex_state = 55, .external_lex_state = 3},
  [10033] = {.lex_state = 56, .external_lex_state = 30},
  [10034] = {.lex_state = 2, .external_lex_state = 308},
  [10035] = {.lex_state = 55, .external_lex_state = 3},
  [10036] = {.lex_state = 55, .external_lex_state = 3},
  [10037] = {.lex_state = 2, .external_lex_state = 308},
  [10038] = {.lex_state = 55, .external_lex_state = 3},
  [10039] = {.lex_state = 55, .external_lex_state = 3},
  [10040] = {.lex_state = 55, .external_lex_state = 3},
  [10041] = {.lex_state = 55, .external_lex_state = 3},
  [10042] = {.lex_state = 55, .external_lex_state = 3},
  [10043] = {.lex_state = 55, .external_lex_state = 307},
  [10044] = {.lex_state = 55, .external_lex_state = 3},
  [10045] = {.lex_state = 2, .external_lex_state = 308},
  [10046] = {.lex_state = 2, .external_lex_state = 308},
  [10047] = {.lex_state = 2, .external_lex_state = 308},
  [10048] = {.lex_state = 55, .external_lex_state = 3},
  [10049] = {.lex_state = 56, .external_lex_state = 30},
  [10050] = {.lex_state = 2, .external_lex_state = 308},
  [10051] = {.lex_state = 55, .external_lex_state = 3},
  [10052] = {.lex_state = 2, .external_lex_state = 308},
  [10053] = {.lex_state = 55, .external_lex_state = 3},
  [10054] = {.lex_state = 2, .external_lex_state = 308},
  [10055] = {.lex_state = 0, .external_lex_state = 291},
  [10056] = {.lex_state = 55, .external_lex_state = 3},
  [10057] = {.lex_state = 2, .external_lex_state = 308},
  [10058] = {.lex_state = 55, .external_lex_state = 3},
  [10059] = {.lex_state = 56, .external_lex_state = 30},
  [10060] = {.lex_state = 55, .external_lex_state = 307},
  [10061] = {.lex_state = 55, .external_lex_state = 3},
  [10062] = {.lex_state = 2, .external_lex_state = 308},
  [10063] = {.lex_state = 2, .external_lex_state = 308},
  [10064] = {.lex_state = 58, .external_lex_state = 311},
  [10065] = {.lex_state = 55, .external_lex_state = 3},
  [10066] = {.lex_state = 2, .external_lex_state = 308},
  [10067] = {.lex_state = 55, .external_lex_state = 3},
  [10068] = {.lex_state = 2, .external_lex_state = 308},
  [10069] = {.lex_state = 0, .external_lex_state = 291},
  [10070] = {.lex_state = 56, .external_lex_state = 30},
  [10071] = {.lex_state = 2, .external_lex_state = 308},
  [10072] = {.lex_state = 2, .external_lex_state = 308},
  [10073] = {.lex_state = 2, .external_lex_state = 308},
  [10074] = {.lex_state = 2, .external_lex_state = 308},
  [10075] = {.lex_state = 56, .external_lex_state = 30},
  [10076] = {.lex_state = 56, .external_lex_state = 30},
  [10077] = {.lex_state = 0, .external_lex_state = 312},
  [10078] = {.lex_state = 2, .external_lex_state = 308},
  [10079] = {.lex_state = 2, .external_lex_state = 308},
  [10080] = {.lex_state = 55, .external_lex_state = 3},
  [10081] = {.lex_state = 2, .external_lex_state = 308},
  [10082] = {.lex_state = 55, .external_lex_state = 3},
  [10083] = {.lex_state = 2, .external_lex_state = 308},
  [10084] = {.lex_state = 0, .external_lex_state = 291},
  [10085] = {.lex_state = 55, .external_lex_state = 3},
  [10086] = {.lex_state = 55, .external_lex_state = 3},
  [10087] = {.lex_state = 55, .external_lex_state = 3},
  [10088] = {.lex_state = 2, .external_lex_state = 308},
  [10089] = {.lex_state = 55, .external_lex_state = 3},
  [10090] = {.lex_state = 0, .external_lex_state = 291},
  [10091] = {.lex_state = 56, .external_lex_state = 30},
  [10092] = {.lex_state = 55, .external_lex_state = 3},
  [10093] = {.lex_state = 55, .external_lex_state = 3},
  [10094] = {.lex_state = 0, .external_lex_state = 291},
  [10095] = {.lex_state = 2, .external_lex_state = 308},
  [10096] = {.lex_state = 55, .external_lex_state = 3},
  [10097] = {.lex_state = 2, .external_lex_state = 308},
  [10098] = {.lex_state = 55, .external_lex_state = 3},
  [10099] = {.lex_state = 2, .external_lex_state = 308},
  [10100] = {.lex_state = 55, .external_lex_state = 3},
  [10101] = {.lex_state = 2, .external_lex_state = 308},
  [10102] = {.lex_state = 2, .external_lex_state = 308},
  [10103] = {.lex_state = 56, .external_lex_state = 30},
  [10104] = {.lex_state = 55, .external_lex_state = 3},
  [10105] = {.lex_state = 56, .external_lex_state = 30},
  [10106] = {.lex_state = 2, .external_lex_state = 308},
  [10107] = {.lex_state = 55, .external_lex_state = 3},
  [10108] = {.lex_state = 55, .external_lex_state = 3},
  [10109] = {.lex_state = 55, .external_lex_state = 3},
  [10110] = {.lex_state = 2, .external_lex_state = 308},
  [10111] = {.lex_state = 2, .external_lex_state = 308},
  [10112] = {.lex_state = 2, .external_lex_state = 308},
  [10113] = {.lex_state = 56, .external_lex_state = 30},
  [10114] = {.lex_state = 2, .external_lex_state = 308},
  [10115] = {.lex_state = 56, .external_lex_state = 30},
  [10116] = {.lex_state = 2, .external_lex_state = 308},
  [10117] = {.lex_state = 55, .external_lex_state = 3},
  [10118] = {.lex_state = 55, .external_lex_state = 3},
  [10119] = {.lex_state = 55, .external_lex_state = 3},
  [10120] = {.lex_state = 60, .external_lex_state = 3},
  [10121] = {.lex_state = 2, .external_lex_state = 308},
  [10122] = {.lex_state = 2, .external_lex_state = 308},
  [10123] = {.lex_state = 55, .external_lex_state = 313},
  [10124] = {.lex_state = 56, .external_lex_state = 30},
  [10125] = {.lex_state = 55, .external_lex_state = 3},
  [10126] = {.lex_state = 56, .external_lex_state = 30},
  [10127] = {.lex_state = 56, .external_lex_state = 30},
  [10128] = {.lex_state = 56, .external_lex_state = 30},
  [10129] = {.lex_state = 2, .external_lex_state = 308},
  [10130] = {.lex_state = 2, .external_lex_state = 308},
  [10131] = {.lex_state = 55, .external_lex_state = 3},
  [10132] = {.lex_state = 55, .external_lex_state = 3},
  [10133] = {.lex_state = 2, .external_lex_state = 308},
  [10134] = {.lex_state = 55, .external_lex_state = 3},
  [10135] = {.lex_state = 55, .external_lex_state = 3},
  [10136] = {.lex_state = 2, .external_lex_state = 308},
  [10137] = {.lex_state = 55, .external_lex_state = 3},
  [10138] = {.lex_state = 56, .external_lex_state = 30},
  [10139] = {.lex_state = 56, .external_lex_state = 30},
  [10140] = {.lex_state = 55, .external_lex_state = 3},
  [10141] = {.lex_state = 2, .external_lex_state = 308},
  [10142] = {.lex_state = 2, .external_lex_state = 308},
  [10143] = {.lex_state = 55, .external_lex_state = 3},
  [10144] = {.lex_state = 2, .external_lex_state = 308},
  [10145] = {.lex_state = 2, .external_lex_state = 308},
  [10146] = {.lex_state = 55, .external_lex_state = 3},
  [10147] = {.lex_state = 55, .external_lex_state = 3},
  [10148] = {.lex_state = 2, .external_lex_state = 308},
  [10149] = {.lex_state = 2, .external_lex_state = 308},
  [10150] = {.lex_state = 58, .external_lex_state = 310},
  [10151] = {.lex_state = 58, .external_lex_state = 314},
  [10152] = {.lex_state = 0, .external_lex_state = 312},
  [10153] = {.lex_state = 55, .external_lex_state = 3},
  [10154] = {.lex_state = 55, .external_lex_state = 313},
  [10155] = {.lex_state = 58, .external_lex_state = 315},
  [10156] = {.lex_state = 55, .external_lex_state = 3},
  [10157] = {.lex_state = 58, .external_lex_state = 311},
  [10158] = {.lex_state = 2, .external_lex_state = 308},
  [10159] = {.lex_state = 56, .external_lex_state = 30},
  [10160] = {.lex_state = 55, .external_lex_state = 3},
  [10161] = {.lex_state = 55, .external_lex_state = 3},
  [10162] = {.lex_state = 0, .external_lex_state = 316},
  [10163] = {.lex_state = 2, .external_lex_state = 308},
  [10164] = {.lex_state = 55, .external_lex_state = 3},
  [10165] = {.lex_state = 2, .external_lex_state = 308},
  [10166] = {.lex_state = 2, .external_lex_state = 308},
  [10167] = {.lex_state = 2, .external_lex_state = 308},
  [10168] = {.lex_state = 58, .external_lex_state = 314},
  [10169] = {.lex_state = 56, .external_lex_state = 30},
  [10170] = {.lex_state = 55, .external_lex_state = 3},
  [10171] = {.lex_state = 55, .external_lex_state = 3},
  [10172] = {.lex_state = 0, .external_lex_state = 291},
  [10173] = {.lex_state = 2, .external_lex_state = 308},
  [10174] = {.lex_state = 2, .external_lex_state = 308},
  [10175] = {.lex_state = 55, .external_lex_state = 3},
  [10176] = {.lex_state = 60, .external_lex_state = 3},
  [10177] = {.lex_state = 56, .external_lex_state = 30},
  [10178] = {.lex_state = 0, .external_lex_state = 291},
  [10179] = {.lex_state = 2, .external_lex_state = 308},
  [10180] = {.lex_state = 55, .external_lex_state = 3},
  [10181] = {.lex_state = 56, .external_lex_state = 30},
  [10182] = {.lex_state = 2, .external_lex_state = 308},
  [10183] = {.lex_state = 2, .external_lex_state = 308},
  [10184] = {.lex_state = 2, .external_lex_state = 308},
  [10185] = {.lex_state = 55, .external_lex_state = 3},
  [10186] = {.lex_state = 2, .external_lex_state = 308},
  [10187] = {.lex_state = 0, .external_lex_state = 291},
  [10188] = {.lex_state = 56, .external_lex_state = 30},
  [10189] = {.lex_state = 55, .external_lex_state = 3},
  [10190] = {.lex_state = 56, .external_lex_state = 30},
  [10191] = {.lex_state = 55, .external_lex_state = 3},
  [10192] = {.lex_state = 2, .external_lex_state = 308},
  [10193] = {.lex_state = 2, .external_lex_state = 308},
  [10194] = {.lex_state = 55, .external_lex_state = 3},
  [10195] = {.lex_state = 0, .external_lex_state = 291},
  [10196] = {.lex_state = 55, .external_lex_state = 3},
  [10197] = {.lex_state = 55, .external_lex_state = 3},
  [10198] = {.lex_state = 2, .external_lex_state = 308},
  [10199] = {.lex_state = 55, .external_lex_state = 3},
  [10200] = {.lex_state = 55, .external_lex_state = 3},
  [10201] = {.lex_state = 2, .external_lex_state = 308},
  [10202] = {.lex_state = 0, .external_lex_state = 291},
  [10203] = {.lex_state = 0, .external_lex_state = 291},
  [10204] = {.lex_state = 0, .external_lex_state = 291},
  [10205] = {.lex_state = 55, .external_lex_state = 3},
  [10206] = {.lex_state = 55, .external_lex_state = 3},
  [10207] = {.lex_state = 55, .external_lex_state = 3},
  [10208] = {.lex_state = 56, .external_lex_state = 30},
  [10209] = {.lex_state = 55, .external_lex_state = 3},
  [10210] = {.lex_state = 2, .external_lex_state = 308},
  [10211] = {.lex_state = 55, .external_lex_state = 3},
  [10212] = {.lex_state = 55, .external_lex_state = 3},
  [10213] = {.lex_state = 2, .external_lex_state = 308},
  [10214] = {.lex_state = 55, .external_lex_state = 3},
  [10215] = {.lex_state = 55, .external_lex_state = 3},
  [10216] = {.lex_state = 55, .external_lex_state = 3},
  [10217] = {.lex_state = 0, .external_lex_state = 316},
  [10218] = {.lex_state = 55, .external_lex_state = 3},
  [10219] = {.lex_state = 55, .external_lex_state = 3},
  [10220] = {.lex_state = 55, .external_lex_state = 3},
  [10221] = {.lex_state = 55, .external_lex_state = 3},
  [10222] = {.lex_state = 55, .external_lex_state = 3},
  [10223] = {.lex_state = 2, .external_lex_state = 308},
  [10224] = {.lex_state = 2, .external_lex_state = 308},
  [10225] = {.lex_state = 55, .external_lex_state = 3},
  [10226] = {.lex_state = 2, .external_lex_state = 308},
  [10227] = {.lex_state = 55, .external_lex_state = 3},
  [10228] = {.lex_state = 55, .external_lex_state = 3},
  [10229] = {.lex_state = 2, .external_lex_state = 308},
  [10230] = {.lex_state = 2, .external_lex_state = 308},
  [10231] = {.lex_state = 56, .external_lex_state = 30},
  [10232] = {.lex_state = 2, .external_lex_state = 308},
  [10233] = {.lex_state = 2, .external_lex_state = 308},
  [10234] = {.lex_state = 55, .external_lex_state = 3},
  [10235] = {.lex_state = 56, .external_lex_state = 3},
  [10236] = {.lex_state = 55, .external_lex_state = 3},
  [10237] = {.lex_state = 55, .external_lex_state = 3},
  [10238] = {.lex_state = 55, .external_lex_state = 3},
  [10239] = {.lex_state = 55, .external_lex_state = 3},
  [10240] = {.lex_state = 55, .external_lex_state = 3},
  [10241] = {.lex_state = 61, .external_lex_state = 317},
  [10242] = {.lex_state = 60, .external_lex_state = 242},
  [10243] = {.lex_state = 55, .external_lex_state = 3},
  [10244] = {.lex_state = 55, .external_lex_state = 3},
  [10245] = {.lex_state = 55, .external_lex_state = 3},
  [10246] = {.lex_state = 55, .external_lex_state = 3},
  [10247] = {.lex_state = 55, .external_lex_state = 3},
  [10248] = {.lex_state = 55, .external_lex_state = 3},
  [10249] = {.lex_state = 55, .external_lex_state = 3},
  [10250] = {.lex_state = 55, .external_lex_state = 3},
  [10251] = {.lex_state = 55, .external_lex_state = 3},
  [10252] = {.lex_state = 61, .external_lex_state = 318},
  [10253] = {.lex_state = 55, .external_lex_state = 3},
  [10254] = {.lex_state = 55, .external_lex_state = 3},
  [10255] = {.lex_state = 55, .external_lex_state = 3},
  [10256] = {.lex_state = 55, .external_lex_state = 3},
  [10257] = {.lex_state = 55, .external_lex_state = 3},
  [10258] = {.lex_state = 55, .external_lex_state = 3},
  [10259] = {.lex_state = 55, .external_lex_state = 3},
  [10260] = {.lex_state = 55, .external_lex_state = 3},
  [10261] = {.lex_state = 55, .external_lex_state = 3},
  [10262] = {.lex_state = 55, .external_lex_state = 3},
  [10263] = {.lex_state = 55, .external_lex_state = 3},
  [10264] = {.lex_state = 55, .external_lex_state = 3},
  [10265] = {.lex_state = 55, .external_lex_state = 3},
  [10266] = {.lex_state = 55, .external_lex_state = 3},
  [10267] = {.lex_state = 55, .external_lex_state = 3},
  [10268] = {.lex_state = 55, .external_lex_state = 3},
  [10269] = {.lex_state = 55, .external_lex_state = 3},
  [10270] = {.lex_state = 55, .external_lex_state = 3},
  [10271] = {.lex_state = 55, .external_lex_state = 3},
  [10272] = {.lex_state = 55, .external_lex_state = 242},
  [10273] = {.lex_state = 55, .external_lex_state = 3},
  [10274] = {.lex_state = 55, .external_lex_state = 3},
  [10275] = {.lex_state = 55, .external_lex_state = 3},
  [10276] = {.lex_state = 61, .external_lex_state = 317},
  [10277] = {.lex_state = 55, .external_lex_state = 3},
  [10278] = {.lex_state = 55, .external_lex_state = 3},
  [10279] = {.lex_state = 55, .external_lex_state = 3},
  [10280] = {.lex_state = 55, .external_lex_state = 3},
  [10281] = {.lex_state = 55, .external_lex_state = 3},
  [10282] = {.lex_state = 55, .external_lex_state = 3},
  [10283] = {.lex_state = 55, .external_lex_state = 3},
  [10284] = {.lex_state = 55, .external_lex_state = 3},
  [10285] = {.lex_state = 55, .external_lex_state = 3},
  [10286] = {.lex_state = 55, .external_lex_state = 3},
  [10287] = {.lex_state = 55, .external_lex_state = 3},
  [10288] = {.lex_state = 55, .external_lex_state = 3},
  [10289] = {.lex_state = 56, .external_lex_state = 3},
  [10290] = {.lex_state = 55, .external_lex_state = 3},
  [10291] = {.lex_state = 55, .external_lex_state = 3},
  [10292] = {.lex_state = 55, .external_lex_state = 3},
  [10293] = {.lex_state = 55, .external_lex_state = 3},
  [10294] = {.lex_state = 55, .external_lex_state = 3},
  [10295] = {.lex_state = 55, .external_lex_state = 3},
  [10296] = {.lex_state = 55, .external_lex_state = 3},
  [10297] = {.lex_state = 55, .external_lex_state = 3},
  [10298] = {.lex_state = 55, .external_lex_state = 3},
  [10299] = {.lex_state = 55, .external_lex_state = 3},
  [10300] = {.lex_state = 55, .external_lex_state = 3},
  [10301] = {.lex_state = 57, .external_lex_state = 319},
  [10302] = {.lex_state = 55, .external_lex_state = 3},
  [10303] = {.lex_state = 0, .external_lex_state = 320},
  [10304] = {.lex_state = 55, .external_lex_state = 3},
  [10305] = {.lex_state = 55, .external_lex_state = 3},
  [10306] = {.lex_state = 55, .external_lex_state = 3},
  [10307] = {.lex_state = 55, .external_lex_state = 3},
  [10308] = {.lex_state = 55, .external_lex_state = 3},
  [10309] = {.lex_state = 55, .external_lex_state = 3},
  [10310] = {.lex_state = 55, .external_lex_state = 3},
  [10311] = {.lex_state = 55, .external_lex_state = 3},
  [10312] = {.lex_state = 55, .external_lex_state = 3},
  [10313] = {.lex_state = 55, .external_lex_state = 3},
  [10314] = {.lex_state = 55, .external_lex_state = 3},
  [10315] = {.lex_state = 0, .external_lex_state = 321},
  [10316] = {.lex_state = 55, .external_lex_state = 3},
  [10317] = {.lex_state = 55, .external_lex_state = 3},
  [10318] = {.lex_state = 55, .external_lex_state = 3},
  [10319] = {.lex_state = 55, .external_lex_state = 3},
  [10320] = {.lex_state = 55, .external_lex_state = 3},
  [10321] = {.lex_state = 55, .external_lex_state = 3},
  [10322] = {.lex_state = 55, .external_lex_state = 3},
  [10323] = {.lex_state = 55, .external_lex_state = 3},
  [10324] = {.lex_state = 55, .external_lex_state = 3},
  [10325] = {.lex_state = 61, .external_lex_state = 318},
  [10326] = {.lex_state = 55, .external_lex_state = 3},
  [10327] = {.lex_state = 55, .external_lex_state = 3},
  [10328] = {.lex_state = 55, .external_lex_state = 3},
  [10329] = {.lex_state = 55, .external_lex_state = 3},
  [10330] = {.lex_state = 55, .external_lex_state = 3},
  [10331] = {.lex_state = 55, .external_lex_state = 3},
  [10332] = {.lex_state = 55, .external_lex_state = 3},
  [10333] = {.lex_state = 55, .external_lex_state = 3},
  [10334] = {.lex_state = 55, .external_lex_state = 3},
  [10335] = {.lex_state = 55, .external_lex_state = 3},
  [10336] = {.lex_state = 55, .external_lex_state = 3},
  [10337] = {.lex_state = 55, .external_lex_state = 3},
  [10338] = {.lex_state = 55, .external_lex_state = 3},
  [10339] = {.lex_state = 55, .external_lex_state = 3},
  [10340] = {.lex_state = 61, .external_lex_state = 317},
  [10341] = {.lex_state = 55, .external_lex_state = 3},
  [10342] = {.lex_state = 55, .external_lex_state = 3},
  [10343] = {.lex_state = 55, .external_lex_state = 3},
  [10344] = {.lex_state = 55, .external_lex_state = 3},
  [10345] = {.lex_state = 55, .external_lex_state = 3},
  [10346] = {.lex_state = 55, .external_lex_state = 3},
  [10347] = {.lex_state = 55, .external_lex_state = 3},
  [10348] = {.lex_state = 0, .external_lex_state = 320},
  [10349] = {.lex_state = 61, .external_lex_state = 317},
  [10350] = {.lex_state = 55, .external_lex_state = 3},
  [10351] = {.lex_state = 55, .external_lex_state = 3},
  [10352] = {.lex_state = 55, .external_lex_state = 3},
  [10353] = {.lex_state = 55, .external_lex_state = 3},
  [10354] = {.lex_state = 55, .external_lex_state = 3},
  [10355] = {.lex_state = 57, .external_lex_state = 322},
  [10356] = {.lex_state = 55, .external_lex_state = 3},
  [10357] = {.lex_state = 55, .external_lex_state = 3},
  [10358] = {.lex_state = 55, .external_lex_state = 3},
  [10359] = {.lex_state = 55, .external_lex_state = 92},
  [10360] = {.lex_state = 55, .external_lex_state = 3},
  [10361] = {.lex_state = 55, .external_lex_state = 3},
  [10362] = {.lex_state = 55, .external_lex_state = 3},
  [10363] = {.lex_state = 55, .external_lex_state = 3},
  [10364] = {.lex_state = 61, .external_lex_state = 318},
  [10365] = {.lex_state = 55, .external_lex_state = 3},
  [10366] = {.lex_state = 55, .external_lex_state = 3},
  [10367] = {.lex_state = 55, .external_lex_state = 3},
  [10368] = {.lex_state = 61, .external_lex_state = 317},
  [10369] = {.lex_state = 55, .external_lex_state = 3},
  [10370] = {.lex_state = 55, .external_lex_state = 3},
  [10371] = {.lex_state = 61, .external_lex_state = 317},
  [10372] = {.lex_state = 55, .external_lex_state = 3},
  [10373] = {.lex_state = 55, .external_lex_state = 3},
  [10374] = {.lex_state = 55, .external_lex_state = 3},
  [10375] = {.lex_state = 55, .external_lex_state = 3},
  [10376] = {.lex_state = 55, .external_lex_state = 3},
  [10377] = {.lex_state = 55, .external_lex_state = 3},
  [10378] = {.lex_state = 55, .external_lex_state = 3},
  [10379] = {.lex_state = 55, .external_lex_state = 3},
  [10380] = {.lex_state = 55, .external_lex_state = 3},
  [10381] = {.lex_state = 55, .external_lex_state = 3},
  [10382] = {.lex_state = 55, .external_lex_state = 3},
  [10383] = {.lex_state = 55, .external_lex_state = 3},
  [10384] = {.lex_state = 55, .external_lex_state = 3},
  [10385] = {.lex_state = 55, .external_lex_state = 3},
  [10386] = {.lex_state = 0, .external_lex_state = 323},
  [10387] = {.lex_state = 55, .external_lex_state = 3},
  [10388] = {.lex_state = 55, .external_lex_state = 3},
  [10389] = {.lex_state = 61, .external_lex_state = 318},
  [10390] = {.lex_state = 55, .external_lex_state = 3},
  [10391] = {.lex_state = 55, .external_lex_state = 3},
  [10392] = {.lex_state = 55, .external_lex_state = 3},
  [10393] = {.lex_state = 55, .external_lex_state = 3},
  [10394] = {.lex_state = 55, .external_lex_state = 3},
  [10395] = {.lex_state = 55, .external_lex_state = 3},
  [10396] = {.lex_state = 61, .external_lex_state = 318},
  [10397] = {.lex_state = 55, .external_lex_state = 3},
  [10398] = {.lex_state = 55, .external_lex_state = 3},
  [10399] = {.lex_state = 0, .external_lex_state = 321},
  [10400] = {.lex_state = 55, .external_lex_state = 3},
  [10401] = {.lex_state = 55, .external_lex_state = 3},
  [10402] = {.lex_state = 55, .external_lex_state = 3},
  [10403] = {.lex_state = 55, .external_lex_state = 3},
  [10404] = {.lex_state = 55, .external_lex_state = 3},
  [10405] = {.lex_state = 55, .external_lex_state = 3},
  [10406] = {.lex_state = 61, .external_lex_state = 318},
  [10407] = {.lex_state = 55, .external_lex_state = 3},
  [10408] = {.lex_state = 55, .external_lex_state = 3},
  [10409] = {.lex_state = 55, .external_lex_state = 3},
  [10410] = {.lex_state = 55, .external_lex_state = 3},
  [10411] = {.lex_state = 55, .external_lex_state = 3},
  [10412] = {.lex_state = 55, .external_lex_state = 3},
  [10413] = {.lex_state = 55, .external_lex_state = 3},
  [10414] = {.lex_state = 55, .external_lex_state = 3},
  [10415] = {.lex_state = 55, .external_lex_state = 3},
  [10416] = {.lex_state = 55, .external_lex_state = 92},
  [10417] = {.lex_state = 55, .external_lex_state = 3},
  [10418] = {.lex_state = 55, .external_lex_state = 3},
  [10419] = {.lex_state = 55, .external_lex_state = 3},
  [10420] = {.lex_state = 55, .external_lex_state = 3},
  [10421] = {.lex_state = 55, .external_lex_state = 3},
  [10422] = {.lex_state = 55, .external_lex_state = 3},
  [10423] = {.lex_state = 55, .external_lex_state = 3},
  [10424] = {.lex_state = 55, .external_lex_state = 3},
  [10425] = {.lex_state = 60, .external_lex_state = 251},
  [10426] = {.lex_state = 55, .external_lex_state = 3},
  [10427] = {.lex_state = 55, .external_lex_state = 3},
  [10428] = {.lex_state = 55, .external_lex_state = 3},
  [10429] = {.lex_state = 55, .external_lex_state = 3},
  [10430] = {.lex_state = 55, .external_lex_state = 3},
  [10431] = {.lex_state = 55, .external_lex_state = 3},
  [10432] = {.lex_state = 55, .external_lex_state = 3},
  [10433] = {.lex_state = 55, .external_lex_state = 3},
  [10434] = {.lex_state = 55, .external_lex_state = 3},
  [10435] = {.lex_state = 55, .external_lex_state = 3},
  [10436] = {.lex_state = 55, .external_lex_state = 3},
  [10437] = {.lex_state = 55, .external_lex_state = 3},
  [10438] = {.lex_state = 55, .external_lex_state = 3},
  [10439] = {.lex_state = 56, .external_lex_state = 3},
  [10440] = {.lex_state = 55, .external_lex_state = 3},
  [10441] = {.lex_state = 55, .external_lex_state = 3},
  [10442] = {.lex_state = 55, .external_lex_state = 3},
  [10443] = {.lex_state = 55, .external_lex_state = 3},
  [10444] = {.lex_state = 55, .external_lex_state = 3},
  [10445] = {.lex_state = 55, .external_lex_state = 3},
  [10446] = {.lex_state = 55, .external_lex_state = 3},
  [10447] = {.lex_state = 55, .external_lex_state = 3},
  [10448] = {.lex_state = 55, .external_lex_state = 3},
  [10449] = {.lex_state = 55, .external_lex_state = 3},
  [10450] = {.lex_state = 55, .external_lex_state = 3},
  [10451] = {.lex_state = 55, .external_lex_state = 3},
  [10452] = {.lex_state = 61, .external_lex_state = 251},
  [10453] = {.lex_state = 61, .external_lex_state = 242},
  [10454] = {.lex_state = 61, .external_lex_state = 251},
  [10455] = {.lex_state = 61, .external_lex_state = 242},
  [10456] = {.lex_state = 0, .external_lex_state = 291},
  [10457] = {.lex_state = 56, .external_lex_state = 37},
  [10458] = {.lex_state = 56, .external_lex_state = 37},
  [10459] = {.lex_state = 56, .external_lex_state = 37},
  [10460] = {.lex_state = 61, .external_lex_state = 251},
  [10461] = {.lex_state = 61, .external_lex_state = 251},
  [10462] = {.lex_state = 61, .external_lex_state = 251},
  [10463] = {.lex_state = 0, .external_lex_state = 291},
  [10464] = {.lex_state = 61, .external_lex_state = 251},
  [10465] = {.lex_state = 56, .external_lex_state = 37},
  [10466] = {.lex_state = 0, .external_lex_state = 291},
  [10467] = {.lex_state = 0, .external_lex_state = 291},
  [10468] = {.lex_state = 56, .external_lex_state = 37},
  [10469] = {.lex_state = 0, .external_lex_state = 291},
  [10470] = {.lex_state = 56, .external_lex_state = 37},
  [10471] = {.lex_state = 61, .external_lex_state = 251},
  [10472] = {.lex_state = 61, .external_lex_state = 242},
  [10473] = {.lex_state = 0, .external_lex_state = 291},
  [10474] = {.lex_state = 61, .external_lex_state = 251},
  [10475] = {.lex_state = 0, .external_lex_state = 291},
  [10476] = {.lex_state = 56, .external_lex_state = 37},
  [10477] = {.lex_state = 61, .external_lex_state = 242},
  [10478] = {.lex_state = 61, .external_lex_state = 242},
  [10479] = {.lex_state = 61, .external_lex_state = 242},
  [10480] = {.lex_state = 61, .external_lex_state = 242},
  [10481] = {.lex_state = 55, .external_lex_state = 242},
  [10482] = {.lex_state = 61, .external_lex_state = 242},
  [10483] = {.lex_state = 61, .external_lex_state = 242},
  [10484] = {.lex_state = 55, .external_lex_state = 3},
  [10485] = {.lex_state = 61, .external_lex_state = 242},
  [10486] = {.lex_state = 61, .external_lex_state = 251},
  [10487] = {.lex_state = 56, .external_lex_state = 37},
  [10488] = {.lex_state = 61, .external_lex_state = 251},
  [10489] = {.lex_state = 61, .external_lex_state = 242},
  [10490] = {.lex_state = 61, .external_lex_state = 242},
  [10491] = {.lex_state = 55, .external_lex_state = 324},
  [10492] = {.lex_state = 55, .external_lex_state = 3},
  [10493] = {.lex_state = 0, .external_lex_state = 291},
  [10494] = {.lex_state = 0, .external_lex_state = 291},
  [10495] = {.lex_state = 61, .external_lex_state = 251},
  [10496] = {.lex_state = 61, .external_lex_state = 242},
  [10497] = {.lex_state = 0, .external_lex_state = 291},
  [10498] = {.lex_state = 61, .external_lex_state = 242},
  [10499] = {.lex_state = 0, .external_lex_state = 291},
  [10500] = {.lex_state = 61, .external_lex_state = 242},
  [10501] = {.lex_state = 61, .external_lex_state = 251},
  [10502] = {.lex_state = 61, .external_lex_state = 251},
  [10503] = {.lex_state = 0, .external_lex_state = 291},
  [10504] = {.lex_state = 56, .external_lex_state = 3},
  [10505] = {.lex_state = 55, .external_lex_state = 242},
  [10506] = {.lex_state = 61, .external_lex_state = 251},
  [10507] = {.lex_state = 61, .external_lex_state = 251},
  [10508] = {.lex_state = 61, .external_lex_state = 242},
  [10509] = {.lex_state = 61, .external_lex_state = 251},
  [10510] = {.lex_state = 55, .external_lex_state = 3},
  [10511] = {.lex_state = 55, .external_lex_state = 251},
  [10512] = {.lex_state = 0, .external_lex_state = 291},
  [10513] = {.lex_state = 0, .external_lex_state = 291},
  [10514] = {.lex_state = 61, .external_lex_state = 242},
  [10515] = {.lex_state = 61, .external_lex_state = 242},
  [10516] = {.lex_state = 61, .external_lex_state = 242},
  [10517] = {.lex_state = 61, .external_lex_state = 251},
  [10518] = {.lex_state = 61, .external_lex_state = 242},
  [10519] = {.lex_state = 0, .external_lex_state = 291},
  [10520] = {.lex_state = 61, .external_lex_state = 242},
  [10521] = {.lex_state = 56, .external_lex_state = 37},
  [10522] = {.lex_state = 61, .external_lex_state = 251},
  [10523] = {.lex_state = 61, .external_lex_state = 242},
  [10524] = {.lex_state = 0, .external_lex_state = 325},
  [10525] = {.lex_state = 56, .external_lex_state = 37},
  [10526] = {.lex_state = 55, .external_lex_state = 242},
  [10527] = {.lex_state = 55, .external_lex_state = 324},
  [10528] = {.lex_state = 0, .external_lex_state = 291},
  [10529] = {.lex_state = 61, .external_lex_state = 242},
  [10530] = {.lex_state = 56, .external_lex_state = 37},
  [10531] = {.lex_state = 61, .external_lex_state = 251},
  [10532] = {.lex_state = 61, .external_lex_state = 251},
  [10533] = {.lex_state = 61, .external_lex_state = 242},
  [10534] = {.lex_state = 0, .external_lex_state = 291},
  [10535] = {.lex_state = 61, .external_lex_state = 251},
  [10536] = {.lex_state = 61, .external_lex_state = 242},
  [10537] = {.lex_state = 61, .external_lex_state = 251},
  [10538] = {.lex_state = 0, .external_lex_state = 291},
  [10539] = {.lex_state = 0, .external_lex_state = 291},
  [10540] = {.lex_state = 0, .external_lex_state = 291},
  [10541] = {.lex_state = 61, .external_lex_state = 242},
  [10542] = {.lex_state = 61, .external_lex_state = 251},
  [10543] = {.lex_state = 55, .external_lex_state = 242},
  [10544] = {.lex_state = 61, .external_lex_state = 242},
  [10545] = {.lex_state = 0, .external_lex_state = 291},
  [10546] = {.lex_state = 56, .external_lex_state = 37},
  [10547] = {.lex_state = 61, .external_lex_state = 242},
  [10548] = {.lex_state = 56, .external_lex_state = 37},
  [10549] = {.lex_state = 61, .external_lex_state = 242},
  [10550] = {.lex_state = 61, .external_lex_state = 251},
  [10551] = {.lex_state = 61, .external_lex_state = 242},
  [10552] = {.lex_state = 56, .external_lex_state = 37},
  [10553] = {.lex_state = 61, .external_lex_state = 251},
  [10554] = {.lex_state = 56, .external_lex_state = 37},
  [10555] = {.lex_state = 61, .external_lex_state = 251},
  [10556] = {.lex_state = 0, .external_lex_state = 291},
  [10557] = {.lex_state = 61, .external_lex_state = 251},
  [10558] = {.lex_state = 61, .external_lex_state = 251},
  [10559] = {.lex_state = 55, .external_lex_state = 3},
  [10560] = {.lex_state = 61, .external_lex_state = 251},
  [10561] = {.lex_state = 0, .external_lex_state = 291},
  [10562] = {.lex_state = 61, .external_lex_state = 251},
  [10563] = {.lex_state = 61, .external_lex_state = 242},
  [10564] = {.lex_state = 0, .external_lex_state = 291},
  [10565] = {.lex_state = 61, .external_lex_state = 251},
  [10566] = {.lex_state = 0, .external_lex_state = 291},
  [10567] = {.lex_state = 56, .external_lex_state = 37},
  [10568] = {.lex_state = 0, .external_lex_state = 291},
  [10569] = {.lex_state = 61, .external_lex_state = 242},
  [10570] = {.lex_state = 0, .external_lex_state = 291},
  [10571] = {.lex_state = 55, .external_lex_state = 3},
  [10572] = {.lex_state = 0, .external_lex_state = 325},
  [10573] = {.lex_state = 0, .external_lex_state = 291},
  [10574] = {.lex_state = 61, .external_lex_state = 242},
  [10575] = {.lex_state = 61, .external_lex_state = 251},
  [10576] = {.lex_state = 0, .external_lex_state = 291},
  [10577] = {.lex_state = 61, .external_lex_state = 251},
  [10578] = {.lex_state = 61, .external_lex_state = 251},
  [10579] = {.lex_state = 0, .external_lex_state = 291},
  [10580] = {.lex_state = 0, .external_lex_state = 291},
  [10581] = {.lex_state = 0, .external_lex_state = 291},
  [10582] = {.lex_state = 61, .external_lex_state = 242},
  [10583] = {.lex_state = 55, .external_lex_state = 242},
  [10584] = {.lex_state = 56, .external_lex_state = 37},
  [10585] = {.lex_state = 61, .external_lex_state = 242},
  [10586] = {.lex_state = 61, .external_lex_state = 242},
  [10587] = {.lex_state = 61, .external_lex_state = 242},
  [10588] = {.lex_state = 61, .external_lex_state = 242},
  [10589] = {.lex_state = 61, .external_lex_state = 242},
  [10590] = {.lex_state = 61, .external_lex_state = 242},
  [10591] = {.lex_state = 61, .external_lex_state = 242},
  [10592] = {.lex_state = 61, .external_lex_state = 242},
  [10593] = {.lex_state = 55, .external_lex_state = 308},
  [10594] = {.lex_state = 61, .external_lex_state = 242},
  [10595] = {.lex_state = 61, .external_lex_state = 242},
  [10596] = {.lex_state = 61, .external_lex_state = 242},
  [10597] = {.lex_state = 61, .external_lex_state = 242},
  [10598] = {.lex_state = 61, .external_lex_state = 242},
  [10599] = {.lex_state = 55, .external_lex_state = 251},
  [10600] = {.lex_state = 55, .external_lex_state = 308},
  [10601] = {.lex_state = 55, .external_lex_state = 251},
  [10602] = {.lex_state = 61, .external_lex_state = 242},
  [10603] = {.lex_state = 61, .external_lex_state = 242},
  [10604] = {.lex_state = 61, .external_lex_state = 242},
  [10605] = {.lex_state = 61, .external_lex_state = 242},
  [10606] = {.lex_state = 55, .external_lex_state = 326},
  [10607] = {.lex_state = 61, .external_lex_state = 242},
  [10608] = {.lex_state = 61, .external_lex_state = 242},
  [10609] = {.lex_state = 61, .external_lex_state = 242},
  [10610] = {.lex_state = 61, .external_lex_state = 242},
  [10611] = {.lex_state = 61, .external_lex_state = 242},
  [10612] = {.lex_state = 55, .external_lex_state = 326},
  [10613] = {.lex_state = 61, .external_lex_state = 242},
  [10614] = {.lex_state = 61, .external_lex_state = 242},
  [10615] = {.lex_state = 61, .external_lex_state = 242},
  [10616] = {.lex_state = 61, .external_lex_state = 242},
  [10617] = {.lex_state = 61, .external_lex_state = 242},
  [10618] = {.lex_state = 61, .external_lex_state = 242},
  [10619] = {.lex_state = 61, .external_lex_state = 242},
  [10620] = {.lex_state = 61, .external_lex_state = 251},
  [10621] = {.lex_state = 61, .external_lex_state = 251},
  [10622] = {.lex_state = 61, .external_lex_state = 251},
  [10623] = {.lex_state = 58, .external_lex_state = 327},
  [10624] = {.lex_state = 55, .external_lex_state = 242},
  [10625] = {.lex_state = 61, .external_lex_state = 251},
  [10626] = {.lex_state = 55, .external_lex_state = 299},
  [10627] = {.lex_state = 55, .external_lex_state = 242},
  [10628] = {.lex_state = 55, .external_lex_state = 242},
  [10629] = {.lex_state = 58, .external_lex_state = 327},
  [10630] = {.lex_state = 61, .external_lex_state = 251},
  [10631] = {.lex_state = 55, .external_lex_state = 242},
  [10632] = {.lex_state = 56, .external_lex_state = 37},
  [10633] = {.lex_state = 55, .external_lex_state = 242},
  [10634] = {.lex_state = 58, .external_lex_state = 327},
  [10635] = {.lex_state = 58, .external_lex_state = 270},
  [10636] = {.lex_state = 61, .external_lex_state = 251},
  [10637] = {.lex_state = 56, .external_lex_state = 37},
  [10638] = {.lex_state = 55, .external_lex_state = 242},
  [10639] = {.lex_state = 61, .external_lex_state = 251},
  [10640] = {.lex_state = 61, .external_lex_state = 251},
  [10641] = {.lex_state = 55, .external_lex_state = 242},
  [10642] = {.lex_state = 61, .external_lex_state = 251},
  [10643] = {.lex_state = 55, .external_lex_state = 242},
  [10644] = {.lex_state = 61, .external_lex_state = 251},
  [10645] = {.lex_state = 61, .external_lex_state = 251},
  [10646] = {.lex_state = 61, .external_lex_state = 251},
  [10647] = {.lex_state = 61, .external_lex_state = 251},
  [10648] = {.lex_state = 56, .external_lex_state = 37},
  [10649] = {.lex_state = 55, .external_lex_state = 242},
  [10650] = {.lex_state = 61, .external_lex_state = 251},
  [10651] = {.lex_state = 55, .external_lex_state = 242},
  [10652] = {.lex_state = 61, .external_lex_state = 251},
  [10653] = {.lex_state = 56, .external_lex_state = 37},
  [10654] = {.lex_state = 55, .external_lex_state = 242},
  [10655] = {.lex_state = 61, .external_lex_state = 251},
  [10656] = {.lex_state = 61, .external_lex_state = 251},
  [10657] = {.lex_state = 0, .external_lex_state = 291},
  [10658] = {.lex_state = 55, .external_lex_state = 242},
  [10659] = {.lex_state = 55, .external_lex_state = 242},
  [10660] = {.lex_state = 56, .external_lex_state = 37},
  [10661] = {.lex_state = 61, .external_lex_state = 251},
  [10662] = {.lex_state = 57, .external_lex_state = 200},
  [10663] = {.lex_state = 60, .external_lex_state = 291},
  [10664] = {.lex_state = 61, .external_lex_state = 251},
  [10665] = {.lex_state = 61, .external_lex_state = 251},
  [10666] = {.lex_state = 61, .external_lex_state = 251},
  [10667] = {.lex_state = 55, .external_lex_state = 242},
  [10668] = {.lex_state = 61, .external_lex_state = 251},
  [10669] = {.lex_state = 61, .external_lex_state = 251},
  [10670] = {.lex_state = 55, .external_lex_state = 242},
  [10671] = {.lex_state = 55, .external_lex_state = 242},
  [10672] = {.lex_state = 0, .external_lex_state = 291},
  [10673] = {.lex_state = 61, .external_lex_state = 251},
  [10674] = {.lex_state = 58, .external_lex_state = 327},
  [10675] = {.lex_state = 58, .external_lex_state = 327},
  [10676] = {.lex_state = 56, .external_lex_state = 37},
  [10677] = {.lex_state = 55, .external_lex_state = 242},
  [10678] = {.lex_state = 61, .external_lex_state = 251},
  [10679] = {.lex_state = 61, .external_lex_state = 251},
  [10680] = {.lex_state = 61, .external_lex_state = 251},
  [10681] = {.lex_state = 55, .external_lex_state = 242},
  [10682] = {.lex_state = 56, .external_lex_state = 37},
  [10683] = {.lex_state = 56, .external_lex_state = 37},
  [10684] = {.lex_state = 58, .external_lex_state = 327},
  [10685] = {.lex_state = 55, .external_lex_state = 242},
  [10686] = {.lex_state = 61, .external_lex_state = 251},
  [10687] = {.lex_state = 55, .external_lex_state = 308},
  [10688] = {.lex_state = 61, .external_lex_state = 251},
  [10689] = {.lex_state = 58, .external_lex_state = 328},
  [10690] = {.lex_state = 55, .external_lex_state = 251},
  [10691] = {.lex_state = 58, .external_lex_state = 291},
  [10692] = {.lex_state = 58, .external_lex_state = 270},
  [10693] = {.lex_state = 58, .external_lex_state = 291},
  [10694] = {.lex_state = 58, .external_lex_state = 291},
  [10695] = {.lex_state = 58, .external_lex_state = 328},
  [10696] = {.lex_state = 55, .external_lex_state = 251},
  [10697] = {.lex_state = 55, .external_lex_state = 251},
  [10698] = {.lex_state = 55, .external_lex_state = 242},
  [10699] = {.lex_state = 58, .external_lex_state = 328},
  [10700] = {.lex_state = 58, .external_lex_state = 329},
  [10701] = {.lex_state = 58, .external_lex_state = 328},
  [10702] = {.lex_state = 58, .external_lex_state = 291},
  [10703] = {.lex_state = 58, .external_lex_state = 291},
  [10704] = {.lex_state = 55, .external_lex_state = 242},
  [10705] = {.lex_state = 0, .external_lex_state = 320},
  [10706] = {.lex_state = 55, .external_lex_state = 242},
  [10707] = {.lex_state = 55, .external_lex_state = 302},
  [10708] = {.lex_state = 58, .external_lex_state = 291},
  [10709] = {.lex_state = 55, .external_lex_state = 251},
  [10710] = {.lex_state = 55, .external_lex_state = 301},
  [10711] = {.lex_state = 58, .external_lex_state = 329},
  [10712] = {.lex_state = 58, .external_lex_state = 291},
  [10713] = {.lex_state = 58, .external_lex_state = 270},
  [10714] = {.lex_state = 0, .external_lex_state = 291},
  [10715] = {.lex_state = 55, .external_lex_state = 242},
  [10716] = {.lex_state = 58, .external_lex_state = 270},
  [10717] = {.lex_state = 58, .external_lex_state = 291},
  [10718] = {.lex_state = 58, .external_lex_state = 291},
  [10719] = {.lex_state = 0, .external_lex_state = 323},
  [10720] = {.lex_state = 58, .external_lex_state = 291},
  [10721] = {.lex_state = 58, .external_lex_state = 294},
  [10722] = {.lex_state = 58, .external_lex_state = 291},
  [10723] = {.lex_state = 55, .external_lex_state = 242},
  [10724] = {.lex_state = 58, .external_lex_state = 305},
  [10725] = {.lex_state = 58, .external_lex_state = 306},
  [10726] = {.lex_state = 58, .external_lex_state = 291},
  [10727] = {.lex_state = 58, .external_lex_state = 291},
  [10728] = {.lex_state = 58, .external_lex_state = 291},
  [10729] = {.lex_state = 58, .external_lex_state = 291},
  [10730] = {.lex_state = 55, .external_lex_state = 242},
  [10731] = {.lex_state = 58, .external_lex_state = 291},
  [10732] = {.lex_state = 58, .external_lex_state = 291},
  [10733] = {.lex_state = 58, .external_lex_state = 291},
  [10734] = {.lex_state = 58, .external_lex_state = 270},
  [10735] = {.lex_state = 55, .external_lex_state = 299},
  [10736] = {.lex_state = 58, .external_lex_state = 291},
  [10737] = {.lex_state = 55, .external_lex_state = 251},
  [10738] = {.lex_state = 58, .external_lex_state = 291},
  [10739] = {.lex_state = 55, .external_lex_state = 299},
  [10740] = {.lex_state = 55, .external_lex_state = 242},
  [10741] = {.lex_state = 55, .external_lex_state = 242},
  [10742] = {.lex_state = 55, .external_lex_state = 251},
  [10743] = {.lex_state = 55, .external_lex_state = 242},
  [10744] = {.lex_state = 58, .external_lex_state = 291},
  [10745] = {.lex_state = 58, .external_lex_state = 328},
  [10746] = {.lex_state = 58, .external_lex_state = 291},
  [10747] = {.lex_state = 58, .external_lex_state = 291},
  [10748] = {.lex_state = 58, .external_lex_state = 291},
  [10749] = {.lex_state = 58, .external_lex_state = 328},
  [10750] = {.lex_state = 55, .external_lex_state = 251},
  [10751] = {.lex_state = 58, .external_lex_state = 291},
  [10752] = {.lex_state = 55, .external_lex_state = 251},
  [10753] = {.lex_state = 55, .external_lex_state = 251},
  [10754] = {.lex_state = 58, .external_lex_state = 291},
  [10755] = {.lex_state = 58, .external_lex_state = 291},
  [10756] = {.lex_state = 55, .external_lex_state = 242},
  [10757] = {.lex_state = 55, .external_lex_state = 242},
  [10758] = {.lex_state = 55, .external_lex_state = 251},
  [10759] = {.lex_state = 55, .external_lex_state = 242},
  [10760] = {.lex_state = 55, .external_lex_state = 251},
  [10761] = {.lex_state = 58, .external_lex_state = 291},
  [10762] = {.lex_state = 55, .external_lex_state = 242},
  [10763] = {.lex_state = 55, .external_lex_state = 251},
  [10764] = {.lex_state = 55, .external_lex_state = 251},
  [10765] = {.lex_state = 58, .external_lex_state = 291},
  [10766] = {.lex_state = 55, .external_lex_state = 251},
  [10767] = {.lex_state = 55, .external_lex_state = 251},
  [10768] = {.lex_state = 55, .external_lex_state = 242},
  [10769] = {.lex_state = 58, .external_lex_state = 291},
  [10770] = {.lex_state = 55, .external_lex_state = 251},
  [10771] = {.lex_state = 58, .external_lex_state = 291},
  [10772] = {.lex_state = 55, .external_lex_state = 242},
  [10773] = {.lex_state = 55, .external_lex_state = 242},
  [10774] = {.lex_state = 55, .external_lex_state = 251},
  [10775] = {.lex_state = 55, .external_lex_state = 242},
  [10776] = {.lex_state = 58, .external_lex_state = 270},
  [10777] = {.lex_state = 58, .external_lex_state = 291},
  [10778] = {.lex_state = 55, .external_lex_state = 242},
  [10779] = {.lex_state = 55, .external_lex_state = 251},
  [10780] = {.lex_state = 55, .external_lex_state = 251},
  [10781] = {.lex_state = 58, .external_lex_state = 291},
  [10782] = {.lex_state = 58, .external_lex_state = 291},
  [10783] = {.lex_state = 58, .external_lex_state = 294},
  [10784] = {.lex_state = 57, .external_lex_state = 200},
  [10785] = {.lex_state = 58, .external_lex_state = 270},
  [10786] = {.lex_state = 58, .external_lex_state = 270},
  [10787] = {.lex_state = 58, .external_lex_state = 270},
  [10788] = {.lex_state = 58, .external_lex_state = 306},
  [10789] = {.lex_state = 58, .external_lex_state = 270},
  [10790] = {.lex_state = 58, .external_lex_state = 330},
  [10791] = {.lex_state = 58, .external_lex_state = 270},
  [10792] = {.lex_state = 58, .external_lex_state = 270},
  [10793] = {.lex_state = 58, .external_lex_state = 270},
  [10794] = {.lex_state = 58, .external_lex_state = 270},
  [10795] = {.lex_state = 58, .external_lex_state = 270},
  [10796] = {.lex_state = 55, .external_lex_state = 251},
  [10797] = {.lex_state = 55, .external_lex_state = 302},
  [10798] = {.lex_state = 58, .external_lex_state = 270},
  [10799] = {.lex_state = 58, .external_lex_state = 270},
  [10800] = {.lex_state = 58, .external_lex_state = 270},
  [10801] = {.lex_state = 58, .external_lex_state = 270},
  [10802] = {.lex_state = 58, .external_lex_state = 306},
  [10803] = {.lex_state = 58, .external_lex_state = 270},
  [10804] = {.lex_state = 58, .external_lex_state = 270},
  [10805] = {.lex_state = 58, .external_lex_state = 270},
  [10806] = {.lex_state = 58, .external_lex_state = 270},
  [10807] = {.lex_state = 58, .external_lex_state = 270},
  [10808] = {.lex_state = 58, .external_lex_state = 270},
  [10809] = {.lex_state = 58, .external_lex_state = 270},
  [10810] = {.lex_state = 58, .external_lex_state = 270},
  [10811] = {.lex_state = 58, .external_lex_state = 270},
  [10812] = {.lex_state = 57, .external_lex_state = 200},
  [10813] = {.lex_state = 55, .external_lex_state = 251},
  [10814] = {.lex_state = 0, .external_lex_state = 312},
  [10815] = {.lex_state = 58, .external_lex_state = 330},
  [10816] = {.lex_state = 58, .external_lex_state = 270},
  [10817] = {.lex_state = 57, .external_lex_state = 200},
  [10818] = {.lex_state = 58, .external_lex_state = 270},
  [10819] = {.lex_state = 58, .external_lex_state = 270},
  [10820] = {.lex_state = 55, .external_lex_state = 251},
  [10821] = {.lex_state = 55, .external_lex_state = 251},
  [10822] = {.lex_state = 58, .external_lex_state = 270},
  [10823] = {.lex_state = 58, .external_lex_state = 294},
  [10824] = {.lex_state = 58, .external_lex_state = 309},
  [10825] = {.lex_state = 55, .external_lex_state = 251},
  [10826] = {.lex_state = 58, .external_lex_state = 270},
  [10827] = {.lex_state = 60, .external_lex_state = 294},
  [10828] = {.lex_state = 58, .external_lex_state = 270},
  [10829] = {.lex_state = 55, .external_lex_state = 251},
  [10830] = {.lex_state = 58, .external_lex_state = 270},
  [10831] = {.lex_state = 55, .external_lex_state = 251},
  [10832] = {.lex_state = 58, .external_lex_state = 331},
  [10833] = {.lex_state = 55, .external_lex_state = 251},
  [10834] = {.lex_state = 55, .external_lex_state = 251},
  [10835] = {.lex_state = 58, .external_lex_state = 270},
  [10836] = {.lex_state = 58, .external_lex_state = 270},
  [10837] = {.lex_state = 55, .external_lex_state = 251},
  [10838] = {.lex_state = 58, .external_lex_state = 270},
  [10839] = {.lex_state = 55, .external_lex_state = 302},
  [10840] = {.lex_state = 0, .external_lex_state = 332},
  [10841] = {.lex_state = 55, .external_lex_state = 301},
  [10842] = {.lex_state = 58, .external_lex_state = 270},
  [10843] = {.lex_state = 58, .external_lex_state = 270},
  [10844] = {.lex_state = 58, .external_lex_state = 270},
  [10845] = {.lex_state = 55, .external_lex_state = 251},
  [10846] = {.lex_state = 58, .external_lex_state = 270},
  [10847] = {.lex_state = 58, .external_lex_state = 270},
  [10848] = {.lex_state = 58, .external_lex_state = 270},
  [10849] = {.lex_state = 0, .external_lex_state = 291},
  [10850] = {.lex_state = 57, .external_lex_state = 200},
  [10851] = {.lex_state = 58, .external_lex_state = 270},
  [10852] = {.lex_state = 0, .external_lex_state = 332},
  [10853] = {.lex_state = 58, .external_lex_state = 270},
  [10854] = {.lex_state = 60, .external_lex_state = 291},
  [10855] = {.lex_state = 58, .external_lex_state = 330},
  [10856] = {.lex_state = 58, .external_lex_state = 330},
  [10857] = {.lex_state = 58, .external_lex_state = 311},
  [10858] = {.lex_state = 58, .external_lex_state = 330},
  [10859] = {.lex_state = 58, .external_lex_state = 270},
  [10860] = {.lex_state = 57, .external_lex_state = 200},
  [10861] = {.lex_state = 58, .external_lex_state = 270},
  [10862] = {.lex_state = 58, .external_lex_state = 305},
  [10863] = {.lex_state = 58, .external_lex_state = 270},
  [10864] = {.lex_state = 58, .external_lex_state = 270},
  [10865] = {.lex_state = 55, .external_lex_state = 313},
  [10866] = {.lex_state = 58, .external_lex_state = 270},
  [10867] = {.lex_state = 55, .external_lex_state = 301},
  [10868] = {.lex_state = 58, .external_lex_state = 270},
  [10869] = {.lex_state = 55, .external_lex_state = 251},
  [10870] = {.lex_state = 58, .external_lex_state = 270},
  [10871] = {.lex_state = 55, .external_lex_state = 251},
  [10872] = {.lex_state = 58, .external_lex_state = 315},
  [10873] = {.lex_state = 57, .external_lex_state = 333},
  [10874] = {.lex_state = 58, .external_lex_state = 270},
  [10875] = {.lex_state = 58, .external_lex_state = 270},
  [10876] = {.lex_state = 55, .external_lex_state = 251},
  [10877] = {.lex_state = 55, .external_lex_state = 251},
  [10878] = {.lex_state = 0, .external_lex_state = 251},
  [10879] = {.lex_state = 57, .external_lex_state = 200},
  [10880] = {.lex_state = 58, .external_lex_state = 270},
  [10881] = {.lex_state = 58, .external_lex_state = 270},
  [10882] = {.lex_state = 58, .external_lex_state = 270},
  [10883] = {.lex_state = 58, .external_lex_state = 270},
  [10884] = {.lex_state = 58, .external_lex_state = 270},
  [10885] = {.lex_state = 0, .external_lex_state = 291},
  [10886] = {.lex_state = 57, .external_lex_state = 200},
  [10887] = {.lex_state = 58, .external_lex_state = 331},
  [10888] = {.lex_state = 57, .external_lex_state = 200},
  [10889] = {.lex_state = 60, .external_lex_state = 294},
  [10890] = {.lex_state = 58, .external_lex_state = 310},
  [10891] = {.lex_state = 58, .external_lex_state = 270},
  [10892] = {.lex_state = 58, .external_lex_state = 330},
  [10893] = {.lex_state = 58, .external_lex_state = 270},
  [10894] = {.lex_state = 0, .external_lex_state = 316},
  [10895] = {.lex_state = 58, .external_lex_state = 270},
  [10896] = {.lex_state = 57, .external_lex_state = 200},
  [10897] = {.lex_state = 58, .external_lex_state = 270},
  [10898] = {.lex_state = 58, .external_lex_state = 305},
  [10899] = {.lex_state = 57, .external_lex_state = 200},
  [10900] = {.lex_state = 58, .external_lex_state = 294},
  [10901] = {.lex_state = 58, .external_lex_state = 270},
  [10902] = {.lex_state = 58, .external_lex_state = 294},
  [10903] = {.lex_state = 58, .external_lex_state = 270},
  [10904] = {.lex_state = 58, .external_lex_state = 270},
  [10905] = {.lex_state = 55, .external_lex_state = 251},
  [10906] = {.lex_state = 55, .external_lex_state = 251},
  [10907] = {.lex_state = 58, .external_lex_state = 270},
  [10908] = {.lex_state = 58, .external_lex_state = 270},
  [10909] = {.lex_state = 58, .external_lex_state = 270},
  [10910] = {.lex_state = 57, .external_lex_state = 200},
  [10911] = {.lex_state = 0, .external_lex_state = 251},
  [10912] = {.lex_state = 58, .external_lex_state = 294},
  [10913] = {.lex_state = 0, .external_lex_state = 251},
  [10914] = {.lex_state = 0, .external_lex_state = 251},
  [10915] = {.lex_state = 0, .external_lex_state = 251},
  [10916] = {.lex_state = 0, .external_lex_state = 251},
  [10917] = {.lex_state = 58, .external_lex_state = 294},
  [10918] = {.lex_state = 58, .external_lex_state = 310},
  [10919] = {.lex_state = 0, .external_lex_state = 251},
  [10920] = {.lex_state = 0, .external_lex_state = 251},
  [10921] = {.lex_state = 58, .external_lex_state = 294},
  [10922] = {.lex_state = 0, .external_lex_state = 251},
  [10923] = {.lex_state = 58, .external_lex_state = 294},
  [10924] = {.lex_state = 58, .external_lex_state = 270},
  [10925] = {.lex_state = 0, .external_lex_state = 251},
  [10926] = {.lex_state = 58, .external_lex_state = 294},
  [10927] = {.lex_state = 0, .external_lex_state = 251},
  [10928] = {.lex_state = 58, .external_lex_state = 294},
  [10929] = {.lex_state = 58, .external_lex_state = 294},
  [10930] = {.lex_state = 55, .external_lex_state = 299},
  [10931] = {.lex_state = 58, .external_lex_state = 294},
  [10932] = {.lex_state = 58, .external_lex_state = 294},
  [10933] = {.lex_state = 0, .external_lex_state = 251},
  [10934] = {.lex_state = 58, .external_lex_state = 294},
  [10935] = {.lex_state = 60, .external_lex_state = 291},
  [10936] = {.lex_state = 58, .external_lex_state = 311},
  [10937] = {.lex_state = 58, .external_lex_state = 294},
  [10938] = {.lex_state = 0, .external_lex_state = 251},
  [10939] = {.lex_state = 0, .external_lex_state = 251},
  [10940] = {.lex_state = 0, .external_lex_state = 251},
  [10941] = {.lex_state = 0, .external_lex_state = 251},
  [10942] = {.lex_state = 0, .external_lex_state = 251},
  [10943] = {.lex_state = 58, .external_lex_state = 294},
  [10944] = {.lex_state = 0, .external_lex_state = 251},
  [10945] = {.lex_state = 58, .external_lex_state = 294},
  [10946] = {.lex_state = 58, .external_lex_state = 294},
  [10947] = {.lex_state = 58, .external_lex_state = 270},
  [10948] = {.lex_state = 0, .external_lex_state = 251},
  [10949] = {.lex_state = 58, .external_lex_state = 294},
  [10950] = {.lex_state = 0, .external_lex_state = 251},
  [10951] = {.lex_state = 0, .external_lex_state = 251},
  [10952] = {.lex_state = 58, .external_lex_state = 291},
  [10953] = {.lex_state = 58, .external_lex_state = 294},
  [10954] = {.lex_state = 0, .external_lex_state = 321},
  [10955] = {.lex_state = 0, .external_lex_state = 251},
  [10956] = {.lex_state = 0, .external_lex_state = 251},
  [10957] = {.lex_state = 58, .external_lex_state = 270},
  [10958] = {.lex_state = 58, .external_lex_state = 294},
  [10959] = {.lex_state = 58, .external_lex_state = 270},
  [10960] = {.lex_state = 0, .external_lex_state = 312},
  [10961] = {.lex_state = 58, .external_lex_state = 294},
  [10962] = {.lex_state = 58, .external_lex_state = 270},
  [10963] = {.lex_state = 0, .external_lex_state = 251},
  [10964] = {.lex_state = 58, .external_lex_state = 309},
  [10965] = {.lex_state = 0, .external_lex_state = 251},
  [10966] = {.lex_state = 0, .external_lex_state = 251},
  [10967] = {.lex_state = 58, .external_lex_state = 294},
  [10968] = {.lex_state = 58, .external_lex_state = 294},
  [10969] = {.lex_state = 61, .external_lex_state = 334},
  [10970] = {.lex_state = 58, .external_lex_state = 294},
  [10971] = {.lex_state = 58, .external_lex_state = 294},
  [10972] = {.lex_state = 58, .external_lex_state = 294},
  [10973] = {.lex_state = 0, .external_lex_state = 251},
  [10974] = {.lex_state = 58, .external_lex_state = 294},
  [10975] = {.lex_state = 0, .external_lex_state = 251},
  [10976] = {.lex_state = 0, .external_lex_state = 251},
  [10977] = {.lex_state = 58, .external_lex_state = 294},
  [10978] = {.lex_state = 58, .external_lex_state = 294},
  [10979] = {.lex_state = 58, .external_lex_state = 294},
  [10980] = {.lex_state = 58, .external_lex_state = 294},
  [10981] = {.lex_state = 58, .external_lex_state = 270},
  [10982] = {.lex_state = 0, .external_lex_state = 251},
  [10983] = {.lex_state = 0, .external_lex_state = 251},
  [10984] = {.lex_state = 0, .external_lex_state = 251},
  [10985] = {.lex_state = 0, .external_lex_state = 251},
  [10986] = {.lex_state = 58, .external_lex_state = 294},
  [10987] = {.lex_state = 0, .external_lex_state = 251},
  [10988] = {.lex_state = 58, .external_lex_state = 294},
  [10989] = {.lex_state = 0, .external_lex_state = 251},
  [10990] = {.lex_state = 0, .external_lex_state = 251},
  [10991] = {.lex_state = 55, .external_lex_state = 299},
  [10992] = {.lex_state = 58, .external_lex_state = 270},
  [10993] = {.lex_state = 58, .external_lex_state = 294},
  [10994] = {.lex_state = 58, .external_lex_state = 294},
  [10995] = {.lex_state = 0, .external_lex_state = 251},
  [10996] = {.lex_state = 58, .external_lex_state = 294},
  [10997] = {.lex_state = 0, .external_lex_state = 251},
  [10998] = {.lex_state = 58, .external_lex_state = 294},
  [10999] = {.lex_state = 58, .external_lex_state = 294},
  [11000] = {.lex_state = 0, .external_lex_state = 251},
  [11001] = {.lex_state = 58, .external_lex_state = 294},
  [11002] = {.lex_state = 58, .external_lex_state = 294},
  [11003] = {.lex_state = 55, .external_lex_state = 313},
  [11004] = {.lex_state = 0, .external_lex_state = 251},
  [11005] = {.lex_state = 58, .external_lex_state = 315},
  [11006] = {.lex_state = 0, .external_lex_state = 251},
  [11007] = {.lex_state = 58, .external_lex_state = 294},
  [11008] = {.lex_state = 0, .external_lex_state = 251},
  [11009] = {.lex_state = 0, .external_lex_state = 251},
  [11010] = {.lex_state = 0, .external_lex_state = 251},
  [11011] = {.lex_state = 58, .external_lex_state = 294},
  [11012] = {.lex_state = 61, .external_lex_state = 334},
  [11013] = {.lex_state = 58, .external_lex_state = 294},
  [11014] = {.lex_state = 0, .external_lex_state = 251},
  [11015] = {.lex_state = 0, .external_lex_state = 251},
  [11016] = {.lex_state = 0, .external_lex_state = 251},
  [11017] = {.lex_state = 61, .external_lex_state = 334},
  [11018] = {.lex_state = 58, .external_lex_state = 270},
  [11019] = {.lex_state = 58, .external_lex_state = 294},
  [11020] = {.lex_state = 58, .external_lex_state = 310},
  [11021] = {.lex_state = 58, .external_lex_state = 294},
  [11022] = {.lex_state = 0, .external_lex_state = 251},
  [11023] = {.lex_state = 58, .external_lex_state = 294},
  [11024] = {.lex_state = 58, .external_lex_state = 294},
  [11025] = {.lex_state = 0, .external_lex_state = 251},
  [11026] = {.lex_state = 55, .external_lex_state = 335},
  [11027] = {.lex_state = 58, .external_lex_state = 294},
  [11028] = {.lex_state = 58, .external_lex_state = 291},
  [11029] = {.lex_state = 58, .external_lex_state = 294},
  [11030] = {.lex_state = 58, .external_lex_state = 294},
  [11031] = {.lex_state = 58, .external_lex_state = 294},
  [11032] = {.lex_state = 58, .external_lex_state = 294},
  [11033] = {.lex_state = 0, .external_lex_state = 251},
  [11034] = {.lex_state = 0, .external_lex_state = 312},
  [11035] = {.lex_state = 61, .external_lex_state = 334},
  [11036] = {.lex_state = 58, .external_lex_state = 291},
  [11037] = {.lex_state = 0, .external_lex_state = 251},
  [11038] = {.lex_state = 58, .external_lex_state = 294},
  [11039] = {.lex_state = 0, .external_lex_state = 251},
  [11040] = {.lex_state = 58, .external_lex_state = 291},
  [11041] = {.lex_state = 0, .external_lex_state = 251},
  [11042] = {.lex_state = 58, .external_lex_state = 294},
  [11043] = {.lex_state = 0, .external_lex_state = 251},
  [11044] = {.lex_state = 0, .external_lex_state = 251},
  [11045] = {.lex_state = 0, .external_lex_state = 251},
  [11046] = {.lex_state = 0, .external_lex_state = 251},
  [11047] = {.lex_state = 0, .external_lex_state = 251},
  [11048] = {.lex_state = 58, .external_lex_state = 291},
  [11049] = {.lex_state = 58, .external_lex_state = 270},
  [11050] = {.lex_state = 58, .external_lex_state = 294},
  [11051] = {.lex_state = 0, .external_lex_state = 251},
  [11052] = {.lex_state = 0, .external_lex_state = 251},
  [11053] = {.lex_state = 0, .external_lex_state = 251},
  [11054] = {.lex_state = 0, .external_lex_state = 251},
  [11055] = {.lex_state = 58, .external_lex_state = 270},
  [11056] = {.lex_state = 58, .external_lex_state = 291},
  [11057] = {.lex_state = 55, .external_lex_state = 299},
  [11058] = {.lex_state = 58, .external_lex_state = 270},
  [11059] = {.lex_state = 58, .external_lex_state = 294},
  [11060] = {.lex_state = 0, .external_lex_state = 251},
  [11061] = {.lex_state = 0, .external_lex_state = 251},
  [11062] = {.lex_state = 58, .external_lex_state = 294},
  [11063] = {.lex_state = 0, .external_lex_state = 251},
  [11064] = {.lex_state = 58, .external_lex_state = 294},
  [11065] = {.lex_state = 0, .external_lex_state = 323},
  [11066] = {.lex_state = 0, .external_lex_state = 251},
  [11067] = {.lex_state = 58, .external_lex_state = 311},
  [11068] = {.lex_state = 58, .external_lex_state = 294},
  [11069] = {.lex_state = 0, .external_lex_state = 251},
  [11070] = {.lex_state = 58, .external_lex_state = 291},
  [11071] = {.lex_state = 58, .external_lex_state = 294},
  [11072] = {.lex_state = 58, .external_lex_state = 291},
  [11073] = {.lex_state = 0, .external_lex_state = 251},
  [11074] = {.lex_state = 0, .external_lex_state = 251},
  [11075] = {.lex_state = 55, .external_lex_state = 313},
  [11076] = {.lex_state = 58, .external_lex_state = 294},
  [11077] = {.lex_state = 58, .external_lex_state = 270},
  [11078] = {.lex_state = 58, .external_lex_state = 270},
  [11079] = {.lex_state = 58, .external_lex_state = 291},
  [11080] = {.lex_state = 57, .external_lex_state = 336},
  [11081] = {.lex_state = 0, .external_lex_state = 251},
  [11082] = {.lex_state = 0, .external_lex_state = 251},
  [11083] = {.lex_state = 58, .external_lex_state = 291},
  [11084] = {.lex_state = 58, .external_lex_state = 270},
  [11085] = {.lex_state = 58, .external_lex_state = 291},
  [11086] = {.lex_state = 0, .external_lex_state = 251},
  [11087] = {.lex_state = 0, .external_lex_state = 251},
  [11088] = {.lex_state = 0, .external_lex_state = 251},
  [11089] = {.lex_state = 0, .external_lex_state = 251},
  [11090] = {.lex_state = 58, .external_lex_state = 294},
  [11091] = {.lex_state = 58, .external_lex_state = 294},
  [11092] = {.lex_state = 58, .external_lex_state = 291},
  [11093] = {.lex_state = 58, .external_lex_state = 315},
  [11094] = {.lex_state = 0, .external_lex_state = 251},
  [11095] = {.lex_state = 58, .external_lex_state = 291},
  [11096] = {.lex_state = 0, .external_lex_state = 251},
  [11097] = {.lex_state = 0, .external_lex_state = 251},
  [11098] = {.lex_state = 58, .external_lex_state = 270},
  [11099] = {.lex_state = 55, .external_lex_state = 335},
  [11100] = {.lex_state = 58, .external_lex_state = 294},
  [11101] = {.lex_state = 0, .external_lex_state = 251},
  [11102] = {.lex_state = 58, .external_lex_state = 291},
  [11103] = {.lex_state = 0, .external_lex_state = 251},
  [11104] = {.lex_state = 0, .external_lex_state = 251},
  [11105] = {.lex_state = 0, .external_lex_state = 251},
  [11106] = {.lex_state = 0, .external_lex_state = 251},
  [11107] = {.lex_state = 0, .external_lex_state = 316},
  [11108] = {.lex_state = 58, .external_lex_state = 291},
  [11109] = {.lex_state = 58, .external_lex_state = 294},
  [11110] = {.lex_state = 58, .external_lex_state = 291},
  [11111] = {.lex_state = 58, .external_lex_state = 309},
  [11112] = {.lex_state = 0, .external_lex_state = 316},
  [11113] = {.lex_state = 58, .external_lex_state = 291},
  [11114] = {.lex_state = 58, .external_lex_state = 270},
  [11115] = {.lex_state = 0, .external_lex_state = 251},
  [11116] = {.lex_state = 58, .external_lex_state = 291},
  [11117] = {.lex_state = 58, .external_lex_state = 291},
  [11118] = {.lex_state = 58, .external_lex_state = 291},
  [11119] = {.lex_state = 58, .external_lex_state = 291},
  [11120] = {.lex_state = 0, .external_lex_state = 251},
  [11121] = {.lex_state = 61, .external_lex_state = 334},
  [11122] = {.lex_state = 58, .external_lex_state = 291},
  [11123] = {.lex_state = 58, .external_lex_state = 294},
  [11124] = {.lex_state = 58, .external_lex_state = 294},
  [11125] = {.lex_state = 58, .external_lex_state = 294},
  [11126] = {.lex_state = 58, .external_lex_state = 270},
  [11127] = {.lex_state = 58, .external_lex_state = 294},
  [11128] = {.lex_state = 0, .external_lex_state = 251},
  [11129] = {.lex_state = 58, .external_lex_state = 270},
  [11130] = {.lex_state = 58, .external_lex_state = 270},
  [11131] = {.lex_state = 58, .external_lex_state = 294},
  [11132] = {.lex_state = 0, .external_lex_state = 251},
  [11133] = {.lex_state = 0, .external_lex_state = 251},
  [11134] = {.lex_state = 0, .external_lex_state = 251},
  [11135] = {.lex_state = 0, .external_lex_state = 251},
  [11136] = {.lex_state = 0, .external_lex_state = 320},
  [11137] = {.lex_state = 0, .external_lex_state = 215},
  [11138] = {.lex_state = 58, .external_lex_state = 294},
  [11139] = {.lex_state = 61, .external_lex_state = 334},
  [11140] = {.lex_state = 0, .external_lex_state = 251},
  [11141] = {.lex_state = 58, .external_lex_state = 291},
  [11142] = {.lex_state = 58, .external_lex_state = 291},
  [11143] = {.lex_state = 58, .external_lex_state = 303},
  [11144] = {.lex_state = 0, .external_lex_state = 251},
  [11145] = {.lex_state = 58, .external_lex_state = 291},
  [11146] = {.lex_state = 58, .external_lex_state = 291},
  [11147] = {.lex_state = 58, .external_lex_state = 291},
  [11148] = {.lex_state = 58, .external_lex_state = 291},
  [11149] = {.lex_state = 58, .external_lex_state = 291},
  [11150] = {.lex_state = 58, .external_lex_state = 291},
  [11151] = {.lex_state = 58, .external_lex_state = 291},
  [11152] = {.lex_state = 0, .external_lex_state = 251},
  [11153] = {.lex_state = 58, .external_lex_state = 291},
  [11154] = {.lex_state = 58, .external_lex_state = 291},
  [11155] = {.lex_state = 58, .external_lex_state = 291},
  [11156] = {.lex_state = 61, .external_lex_state = 299},
  [11157] = {.lex_state = 58, .external_lex_state = 337},
  [11158] = {.lex_state = 58, .external_lex_state = 338},
  [11159] = {.lex_state = 0, .external_lex_state = 291},
  [11160] = {.lex_state = 57, .external_lex_state = 308},
  [11161] = {.lex_state = 57, .external_lex_state = 308},
  [11162] = {.lex_state = 57, .external_lex_state = 308},
  [11163] = {.lex_state = 58, .external_lex_state = 338},
  [11164] = {.lex_state = 58, .external_lex_state = 270},
  [11165] = {.lex_state = 0, .external_lex_state = 291},
  [11166] = {.lex_state = 0, .external_lex_state = 291},
  [11167] = {.lex_state = 0, .external_lex_state = 291},
  [11168] = {.lex_state = 57, .external_lex_state = 308},
  [11169] = {.lex_state = 0, .external_lex_state = 291},
  [11170] = {.lex_state = 0, .external_lex_state = 291},
  [11171] = {.lex_state = 0, .external_lex_state = 291},
  [11172] = {.lex_state = 55, .external_lex_state = 339},
  [11173] = {.lex_state = 57, .external_lex_state = 308},
  [11174] = {.lex_state = 57, .external_lex_state = 308},
  [11175] = {.lex_state = 0, .external_lex_state = 291},
  [11176] = {.lex_state = 57, .external_lex_state = 308},
  [11177] = {.lex_state = 0, .external_lex_state = 291},
  [11178] = {.lex_state = 0, .external_lex_state = 291},
  [11179] = {.lex_state = 58, .external_lex_state = 340},
  [11180] = {.lex_state = 0, .external_lex_state = 291},
  [11181] = {.lex_state = 58, .external_lex_state = 340},
  [11182] = {.lex_state = 58, .external_lex_state = 338},
  [11183] = {.lex_state = 57, .external_lex_state = 308},
  [11184] = {.lex_state = 57, .external_lex_state = 308},
  [11185] = {.lex_state = 0, .external_lex_state = 291},
  [11186] = {.lex_state = 57, .external_lex_state = 308},
  [11187] = {.lex_state = 57, .external_lex_state = 308},
  [11188] = {.lex_state = 57, .external_lex_state = 308},
  [11189] = {.lex_state = 57, .external_lex_state = 308},
  [11190] = {.lex_state = 55, .external_lex_state = 339},
  [11191] = {.lex_state = 61, .external_lex_state = 299},
  [11192] = {.lex_state = 58, .external_lex_state = 341},
  [11193] = {.lex_state = 61, .external_lex_state = 299},
  [11194] = {.lex_state = 0, .external_lex_state = 291},
  [11195] = {.lex_state = 61, .external_lex_state = 342},
  [11196] = {.lex_state = 61, .external_lex_state = 299},
  [11197] = {.lex_state = 61, .external_lex_state = 299},
  [11198] = {.lex_state = 0, .external_lex_state = 291},
  [11199] = {.lex_state = 57, .external_lex_state = 308},
  [11200] = {.lex_state = 57, .external_lex_state = 308},
  [11201] = {.lex_state = 58, .external_lex_state = 343},
  [11202] = {.lex_state = 57, .external_lex_state = 308},
  [11203] = {.lex_state = 55, .external_lex_state = 339},
  [11204] = {.lex_state = 0, .external_lex_state = 323},
  [11205] = {.lex_state = 0, .external_lex_state = 320},
  [11206] = {.lex_state = 58, .external_lex_state = 344},
  [11207] = {.lex_state = 61, .external_lex_state = 299},
  [11208] = {.lex_state = 57, .external_lex_state = 308},
  [11209] = {.lex_state = 58, .external_lex_state = 291},
  [11210] = {.lex_state = 61, .external_lex_state = 299},
  [11211] = {.lex_state = 57, .external_lex_state = 308},
  [11212] = {.lex_state = 57, .external_lex_state = 308},
  [11213] = {.lex_state = 60, .external_lex_state = 303},
  [11214] = {.lex_state = 58, .external_lex_state = 343},
  [11215] = {.lex_state = 57, .external_lex_state = 308},
  [11216] = {.lex_state = 58, .external_lex_state = 341},
  [11217] = {.lex_state = 57, .external_lex_state = 308},
  [11218] = {.lex_state = 57, .external_lex_state = 308},
  [11219] = {.lex_state = 58, .external_lex_state = 291},
  [11220] = {.lex_state = 55, .external_lex_state = 251},
  [11221] = {.lex_state = 58, .external_lex_state = 291},
  [11222] = {.lex_state = 58, .external_lex_state = 291},
  [11223] = {.lex_state = 57, .external_lex_state = 308},
  [11224] = {.lex_state = 61, .external_lex_state = 345},
  [11225] = {.lex_state = 57, .external_lex_state = 308},
  [11226] = {.lex_state = 57, .external_lex_state = 308},
  [11227] = {.lex_state = 0, .external_lex_state = 291},
  [11228] = {.lex_state = 0, .external_lex_state = 321},
  [11229] = {.lex_state = 60, .external_lex_state = 309},
  [11230] = {.lex_state = 58, .external_lex_state = 291},
  [11231] = {.lex_state = 55, .external_lex_state = 339},
  [11232] = {.lex_state = 0, .external_lex_state = 321},
  [11233] = {.lex_state = 0, .external_lex_state = 323},
  [11234] = {.lex_state = 55, .external_lex_state = 251},
  [11235] = {.lex_state = 55, .external_lex_state = 346},
  [11236] = {.lex_state = 55, .external_lex_state = 251},
  [11237] = {.lex_state = 0, .external_lex_state = 291},
  [11238] = {.lex_state = 0, .external_lex_state = 291},
  [11239] = {.lex_state = 57, .external_lex_state = 308},
  [11240] = {.lex_state = 58, .external_lex_state = 337},
  [11241] = {.lex_state = 0, .external_lex_state = 291},
  [11242] = {.lex_state = 55, .external_lex_state = 302},
  [11243] = {.lex_state = 57, .external_lex_state = 308},
  [11244] = {.lex_state = 58, .external_lex_state = 347},
  [11245] = {.lex_state = 58, .external_lex_state = 306},
  [11246] = {.lex_state = 58, .external_lex_state = 337},
  [11247] = {.lex_state = 0, .external_lex_state = 348},
  [11248] = {.lex_state = 58, .external_lex_state = 343},
  [11249] = {.lex_state = 58, .external_lex_state = 270},
  [11250] = {.lex_state = 57, .external_lex_state = 308},
  [11251] = {.lex_state = 58, .external_lex_state = 270},
  [11252] = {.lex_state = 55, .external_lex_state = 349},
  [11253] = {.lex_state = 58, .external_lex_state = 270},
  [11254] = {.lex_state = 58, .external_lex_state = 347},
  [11255] = {.lex_state = 58, .external_lex_state = 270},
  [11256] = {.lex_state = 58, .external_lex_state = 294},
  [11257] = {.lex_state = 58, .external_lex_state = 338},
  [11258] = {.lex_state = 55, .external_lex_state = 346},
  [11259] = {.lex_state = 58, .external_lex_state = 303},
  [11260] = {.lex_state = 60, .external_lex_state = 315},
  [11261] = {.lex_state = 58, .external_lex_state = 270},
  [11262] = {.lex_state = 58, .external_lex_state = 270},
  [11263] = {.lex_state = 57, .external_lex_state = 308},
  [11264] = {.lex_state = 58, .external_lex_state = 347},
  [11265] = {.lex_state = 58, .external_lex_state = 270},
  [11266] = {.lex_state = 57, .external_lex_state = 308},
  [11267] = {.lex_state = 57, .external_lex_state = 308},
  [11268] = {.lex_state = 57, .external_lex_state = 308},
  [11269] = {.lex_state = 57, .external_lex_state = 308},
  [11270] = {.lex_state = 57, .external_lex_state = 308},
  [11271] = {.lex_state = 58, .external_lex_state = 270},
  [11272] = {.lex_state = 58, .external_lex_state = 270},
  [11273] = {.lex_state = 58, .external_lex_state = 270},
  [11274] = {.lex_state = 58, .external_lex_state = 338},
  [11275] = {.lex_state = 58, .external_lex_state = 306},
  [11276] = {.lex_state = 58, .external_lex_state = 270},
  [11277] = {.lex_state = 58, .external_lex_state = 294},
  [11278] = {.lex_state = 58, .external_lex_state = 270},
  [11279] = {.lex_state = 57, .external_lex_state = 308},
  [11280] = {.lex_state = 58, .external_lex_state = 338},
  [11281] = {.lex_state = 57, .external_lex_state = 308},
  [11282] = {.lex_state = 58, .external_lex_state = 294},
  [11283] = {.lex_state = 58, .external_lex_state = 270},
  [11284] = {.lex_state = 57, .external_lex_state = 308},
  [11285] = {.lex_state = 58, .external_lex_state = 305},
  [11286] = {.lex_state = 58, .external_lex_state = 270},
  [11287] = {.lex_state = 58, .external_lex_state = 270},
  [11288] = {.lex_state = 57, .external_lex_state = 308},
  [11289] = {.lex_state = 57, .external_lex_state = 308},
  [11290] = {.lex_state = 58, .external_lex_state = 270},
  [11291] = {.lex_state = 58, .external_lex_state = 344},
  [11292] = {.lex_state = 60, .external_lex_state = 303},
  [11293] = {.lex_state = 61, .external_lex_state = 299},
  [11294] = {.lex_state = 61, .external_lex_state = 299},
  [11295] = {.lex_state = 61, .external_lex_state = 299},
  [11296] = {.lex_state = 61, .external_lex_state = 299},
  [11297] = {.lex_state = 61, .external_lex_state = 299},
  [11298] = {.lex_state = 58, .external_lex_state = 347},
  [11299] = {.lex_state = 61, .external_lex_state = 299},
  [11300] = {.lex_state = 61, .external_lex_state = 299},
  [11301] = {.lex_state = 58, .external_lex_state = 294},
  [11302] = {.lex_state = 61, .external_lex_state = 299},
  [11303] = {.lex_state = 61, .external_lex_state = 299},
  [11304] = {.lex_state = 0, .external_lex_state = 320},
  [11305] = {.lex_state = 61, .external_lex_state = 299},
  [11306] = {.lex_state = 61, .external_lex_state = 299},
  [11307] = {.lex_state = 61, .external_lex_state = 299},
  [11308] = {.lex_state = 55, .external_lex_state = 350},
  [11309] = {.lex_state = 57, .external_lex_state = 308},
  [11310] = {.lex_state = 61, .external_lex_state = 299},
  [11311] = {.lex_state = 55, .external_lex_state = 308},
  [11312] = {.lex_state = 57, .external_lex_state = 308},
  [11313] = {.lex_state = 58, .external_lex_state = 270},
  [11314] = {.lex_state = 57, .external_lex_state = 308},
  [11315] = {.lex_state = 58, .external_lex_state = 340},
  [11316] = {.lex_state = 61, .external_lex_state = 299},
  [11317] = {.lex_state = 57, .external_lex_state = 308},
  [11318] = {.lex_state = 61, .external_lex_state = 299},
  [11319] = {.lex_state = 57, .external_lex_state = 308},
  [11320] = {.lex_state = 61, .external_lex_state = 299},
  [11321] = {.lex_state = 57, .external_lex_state = 308},
  [11322] = {.lex_state = 58, .external_lex_state = 340},
  [11323] = {.lex_state = 0, .external_lex_state = 325},
  [11324] = {.lex_state = 57, .external_lex_state = 308},
  [11325] = {.lex_state = 57, .external_lex_state = 308},
  [11326] = {.lex_state = 57, .external_lex_state = 308},
  [11327] = {.lex_state = 55, .external_lex_state = 350},
  [11328] = {.lex_state = 58, .external_lex_state = 351},
  [11329] = {.lex_state = 61, .external_lex_state = 342},
  [11330] = {.lex_state = 58, .external_lex_state = 294},
  [11331] = {.lex_state = 58, .external_lex_state = 294},
  [11332] = {.lex_state = 61, .external_lex_state = 342},
  [11333] = {.lex_state = 58, .external_lex_state = 294},
  [11334] = {.lex_state = 58, .external_lex_state = 305},
  [11335] = {.lex_state = 57, .external_lex_state = 308},
  [11336] = {.lex_state = 57, .external_lex_state = 308},
  [11337] = {.lex_state = 57, .external_lex_state = 308},
  [11338] = {.lex_state = 57, .external_lex_state = 308},
  [11339] = {.lex_state = 57, .external_lex_state = 308},
  [11340] = {.lex_state = 57, .external_lex_state = 308},
  [11341] = {.lex_state = 57, .external_lex_state = 308},
  [11342] = {.lex_state = 58, .external_lex_state = 294},
  [11343] = {.lex_state = 58, .external_lex_state = 294},
  [11344] = {.lex_state = 58, .external_lex_state = 294},
  [11345] = {.lex_state = 61, .external_lex_state = 299},
  [11346] = {.lex_state = 61, .external_lex_state = 342},
  [11347] = {.lex_state = 58, .external_lex_state = 341},
  [11348] = {.lex_state = 55, .external_lex_state = 308},
  [11349] = {.lex_state = 55, .external_lex_state = 308},
  [11350] = {.lex_state = 57, .external_lex_state = 308},
  [11351] = {.lex_state = 57, .external_lex_state = 308},
  [11352] = {.lex_state = 58, .external_lex_state = 340},
  [11353] = {.lex_state = 58, .external_lex_state = 306},
  [11354] = {.lex_state = 58, .external_lex_state = 314},
  [11355] = {.lex_state = 57, .external_lex_state = 308},
  [11356] = {.lex_state = 58, .external_lex_state = 294},
  [11357] = {.lex_state = 57, .external_lex_state = 308},
  [11358] = {.lex_state = 58, .external_lex_state = 294},
  [11359] = {.lex_state = 57, .external_lex_state = 308},
  [11360] = {.lex_state = 58, .external_lex_state = 337},
  [11361] = {.lex_state = 58, .external_lex_state = 294},
  [11362] = {.lex_state = 58, .external_lex_state = 303},
  [11363] = {.lex_state = 57, .external_lex_state = 308},
  [11364] = {.lex_state = 61, .external_lex_state = 345},
  [11365] = {.lex_state = 57, .external_lex_state = 308},
  [11366] = {.lex_state = 57, .external_lex_state = 308},
  [11367] = {.lex_state = 57, .external_lex_state = 308},
  [11368] = {.lex_state = 57, .external_lex_state = 308},
  [11369] = {.lex_state = 57, .external_lex_state = 308},
  [11370] = {.lex_state = 58, .external_lex_state = 294},
  [11371] = {.lex_state = 57, .external_lex_state = 308},
  [11372] = {.lex_state = 58, .external_lex_state = 294},
  [11373] = {.lex_state = 60, .external_lex_state = 315},
  [11374] = {.lex_state = 61, .external_lex_state = 345},
  [11375] = {.lex_state = 57, .external_lex_state = 308},
  [11376] = {.lex_state = 57, .external_lex_state = 308},
  [11377] = {.lex_state = 58, .external_lex_state = 294},
  [11378] = {.lex_state = 58, .external_lex_state = 294},
  [11379] = {.lex_state = 57, .external_lex_state = 308},
  [11380] = {.lex_state = 58, .external_lex_state = 294},
  [11381] = {.lex_state = 57, .external_lex_state = 308},
  [11382] = {.lex_state = 57, .external_lex_state = 308},
  [11383] = {.lex_state = 57, .external_lex_state = 308},
  [11384] = {.lex_state = 57, .external_lex_state = 308},
  [11385] = {.lex_state = 61, .external_lex_state = 299},
  [11386] = {.lex_state = 57, .external_lex_state = 308},
  [11387] = {.lex_state = 57, .external_lex_state = 308},
  [11388] = {.lex_state = 57, .external_lex_state = 308},
  [11389] = {.lex_state = 61, .external_lex_state = 299},
  [11390] = {.lex_state = 58, .external_lex_state = 343},
  [11391] = {.lex_state = 57, .external_lex_state = 308},
  [11392] = {.lex_state = 57, .external_lex_state = 308},
  [11393] = {.lex_state = 57, .external_lex_state = 308},
  [11394] = {.lex_state = 57, .external_lex_state = 308},
  [11395] = {.lex_state = 57, .external_lex_state = 308},
  [11396] = {.lex_state = 57, .external_lex_state = 308},
  [11397] = {.lex_state = 61, .external_lex_state = 299},
  [11398] = {.lex_state = 57, .external_lex_state = 308},
  [11399] = {.lex_state = 58, .external_lex_state = 341},
  [11400] = {.lex_state = 61, .external_lex_state = 299},
  [11401] = {.lex_state = 57, .external_lex_state = 308},
  [11402] = {.lex_state = 57, .external_lex_state = 308},
  [11403] = {.lex_state = 55, .external_lex_state = 302},
  [11404] = {.lex_state = 61, .external_lex_state = 299},
  [11405] = {.lex_state = 57, .external_lex_state = 308},
  [11406] = {.lex_state = 61, .external_lex_state = 299},
  [11407] = {.lex_state = 61, .external_lex_state = 299},
  [11408] = {.lex_state = 61, .external_lex_state = 299},
  [11409] = {.lex_state = 58, .external_lex_state = 294},
  [11410] = {.lex_state = 61, .external_lex_state = 299},
  [11411] = {.lex_state = 58, .external_lex_state = 305},
  [11412] = {.lex_state = 57, .external_lex_state = 308},
  [11413] = {.lex_state = 58, .external_lex_state = 294},
  [11414] = {.lex_state = 61, .external_lex_state = 299},
  [11415] = {.lex_state = 61, .external_lex_state = 299},
  [11416] = {.lex_state = 61, .external_lex_state = 299},
  [11417] = {.lex_state = 61, .external_lex_state = 299},
  [11418] = {.lex_state = 61, .external_lex_state = 345},
  [11419] = {.lex_state = 61, .external_lex_state = 299},
  [11420] = {.lex_state = 57, .external_lex_state = 308},
  [11421] = {.lex_state = 57, .external_lex_state = 308},
  [11422] = {.lex_state = 61, .external_lex_state = 299},
  [11423] = {.lex_state = 61, .external_lex_state = 299},
  [11424] = {.lex_state = 57, .external_lex_state = 308},
  [11425] = {.lex_state = 57, .external_lex_state = 308},
  [11426] = {.lex_state = 58, .external_lex_state = 337},
  [11427] = {.lex_state = 61, .external_lex_state = 299},
  [11428] = {.lex_state = 57, .external_lex_state = 308},
  [11429] = {.lex_state = 61, .external_lex_state = 299},
  [11430] = {.lex_state = 57, .external_lex_state = 308},
  [11431] = {.lex_state = 61, .external_lex_state = 299},
  [11432] = {.lex_state = 61, .external_lex_state = 342},
  [11433] = {.lex_state = 57, .external_lex_state = 308},
  [11434] = {.lex_state = 0, .external_lex_state = 291},
  [11435] = {.lex_state = 58, .external_lex_state = 341},
  [11436] = {.lex_state = 58, .external_lex_state = 352},
  [11437] = {.lex_state = 57, .external_lex_state = 308},
  [11438] = {.lex_state = 57, .external_lex_state = 308},
  [11439] = {.lex_state = 61, .external_lex_state = 299},
  [11440] = {.lex_state = 61, .external_lex_state = 299},
  [11441] = {.lex_state = 61, .external_lex_state = 342},
  [11442] = {.lex_state = 57, .external_lex_state = 308},
  [11443] = {.lex_state = 61, .external_lex_state = 299},
  [11444] = {.lex_state = 57, .external_lex_state = 308},
  [11445] = {.lex_state = 55, .external_lex_state = 350},
  [11446] = {.lex_state = 61, .external_lex_state = 299},
  [11447] = {.lex_state = 57, .external_lex_state = 308},
  [11448] = {.lex_state = 61, .external_lex_state = 299},
  [11449] = {.lex_state = 61, .external_lex_state = 299},
  [11450] = {.lex_state = 61, .external_lex_state = 299},
  [11451] = {.lex_state = 57, .external_lex_state = 308},
  [11452] = {.lex_state = 61, .external_lex_state = 299},
  [11453] = {.lex_state = 57, .external_lex_state = 308},
  [11454] = {.lex_state = 57, .external_lex_state = 308},
  [11455] = {.lex_state = 58, .external_lex_state = 337},
  [11456] = {.lex_state = 61, .external_lex_state = 299},
  [11457] = {.lex_state = 61, .external_lex_state = 299},
  [11458] = {.lex_state = 57, .external_lex_state = 308},
  [11459] = {.lex_state = 61, .external_lex_state = 299},
  [11460] = {.lex_state = 57, .external_lex_state = 308},
  [11461] = {.lex_state = 57, .external_lex_state = 308},
  [11462] = {.lex_state = 61, .external_lex_state = 299},
  [11463] = {.lex_state = 61, .external_lex_state = 299},
  [11464] = {.lex_state = 55, .external_lex_state = 349},
  [11465] = {.lex_state = 58, .external_lex_state = 343},
  [11466] = {.lex_state = 57, .external_lex_state = 308},
  [11467] = {.lex_state = 57, .external_lex_state = 308},
  [11468] = {.lex_state = 57, .external_lex_state = 308},
  [11469] = {.lex_state = 61, .external_lex_state = 345},
  [11470] = {.lex_state = 57, .external_lex_state = 308},
  [11471] = {.lex_state = 57, .external_lex_state = 308},
  [11472] = {.lex_state = 58, .external_lex_state = 343},
  [11473] = {.lex_state = 57, .external_lex_state = 308},
  [11474] = {.lex_state = 58, .external_lex_state = 341},
  [11475] = {.lex_state = 57, .external_lex_state = 308},
  [11476] = {.lex_state = 57, .external_lex_state = 308},
  [11477] = {.lex_state = 57, .external_lex_state = 308},
  [11478] = {.lex_state = 57, .external_lex_state = 308},
  [11479] = {.lex_state = 57, .external_lex_state = 308},
  [11480] = {.lex_state = 60, .external_lex_state = 320},
  [11481] = {.lex_state = 57, .external_lex_state = 308},
  [11482] = {.lex_state = 61, .external_lex_state = 345},
  [11483] = {.lex_state = 60, .external_lex_state = 320},
  [11484] = {.lex_state = 57, .external_lex_state = 308},
  [11485] = {.lex_state = 58, .external_lex_state = 340},
  [11486] = {.lex_state = 58, .external_lex_state = 347},
  [11487] = {.lex_state = 61, .external_lex_state = 299},
  [11488] = {.lex_state = 61, .external_lex_state = 299},
  [11489] = {.lex_state = 61, .external_lex_state = 299},
  [11490] = {.lex_state = 58, .external_lex_state = 351},
  [11491] = {.lex_state = 57, .external_lex_state = 308},
  [11492] = {.lex_state = 58, .external_lex_state = 352},
  [11493] = {.lex_state = 61, .external_lex_state = 299},
  [11494] = {.lex_state = 61, .external_lex_state = 299},
  [11495] = {.lex_state = 58, .external_lex_state = 303},
  [11496] = {.lex_state = 57, .external_lex_state = 308},
  [11497] = {.lex_state = 57, .external_lex_state = 308},
  [11498] = {.lex_state = 57, .external_lex_state = 308},
  [11499] = {.lex_state = 57, .external_lex_state = 308},
  [11500] = {.lex_state = 61, .external_lex_state = 299},
  [11501] = {.lex_state = 57, .external_lex_state = 308},
  [11502] = {.lex_state = 61, .external_lex_state = 299},
  [11503] = {.lex_state = 57, .external_lex_state = 308},
  [11504] = {.lex_state = 58, .external_lex_state = 347},
  [11505] = {.lex_state = 61, .external_lex_state = 299},
  [11506] = {.lex_state = 57, .external_lex_state = 308},
  [11507] = {.lex_state = 57, .external_lex_state = 308},
  [11508] = {.lex_state = 57, .external_lex_state = 308},
  [11509] = {.lex_state = 57, .external_lex_state = 308},
  [11510] = {.lex_state = 57, .external_lex_state = 308},
  [11511] = {.lex_state = 57, .external_lex_state = 308},
  [11512] = {.lex_state = 57, .external_lex_state = 308},
  [11513] = {.lex_state = 58, .external_lex_state = 294},
  [11514] = {.lex_state = 58, .external_lex_state = 303},
  [11515] = {.lex_state = 57, .external_lex_state = 308},
  [11516] = {.lex_state = 55, .external_lex_state = 302},
  [11517] = {.lex_state = 57, .external_lex_state = 308},
  [11518] = {.lex_state = 60, .external_lex_state = 309},
  [11519] = {.lex_state = 60, .external_lex_state = 303},
  [11520] = {.lex_state = 57, .external_lex_state = 308},
  [11521] = {.lex_state = 57, .external_lex_state = 308},
  [11522] = {.lex_state = 0, .external_lex_state = 291},
  [11523] = {.lex_state = 57, .external_lex_state = 308},
  [11524] = {.lex_state = 57, .external_lex_state = 308},
  [11525] = {.lex_state = 57, .external_lex_state = 308},
  [11526] = {.lex_state = 55, .external_lex_state = 350},
  [11527] = {.lex_state = 57, .external_lex_state = 308},
  [11528] = {.lex_state = 58, .external_lex_state = 309},
  [11529] = {.lex_state = 58, .external_lex_state = 306},
  [11530] = {.lex_state = 58, .external_lex_state = 353},
  [11531] = {.lex_state = 58, .external_lex_state = 309},
  [11532] = {.lex_state = 58, .external_lex_state = 309},
  [11533] = {.lex_state = 61, .external_lex_state = 302},
  [11534] = {.lex_state = 58, .external_lex_state = 320},
  [11535] = {.lex_state = 58, .external_lex_state = 305},
  [11536] = {.lex_state = 55, .external_lex_state = 299},
  [11537] = {.lex_state = 58, .external_lex_state = 354},
  [11538] = {.lex_state = 55, .external_lex_state = 299},
  [11539] = {.lex_state = 55, .external_lex_state = 299},
  [11540] = {.lex_state = 58, .external_lex_state = 320},
  [11541] = {.lex_state = 55, .external_lex_state = 299},
  [11542] = {.lex_state = 58, .external_lex_state = 320},
  [11543] = {.lex_state = 58, .external_lex_state = 353},
  [11544] = {.lex_state = 58, .external_lex_state = 305},
  [11545] = {.lex_state = 58, .external_lex_state = 309},
  [11546] = {.lex_state = 58, .external_lex_state = 305},
  [11547] = {.lex_state = 58, .external_lex_state = 309},
  [11548] = {.lex_state = 58, .external_lex_state = 355},
  [11549] = {.lex_state = 58, .external_lex_state = 353},
  [11550] = {.lex_state = 0, .external_lex_state = 291},
  [11551] = {.lex_state = 58, .external_lex_state = 306},
  [11552] = {.lex_state = 61, .external_lex_state = 302},
  [11553] = {.lex_state = 61, .external_lex_state = 302},
  [11554] = {.lex_state = 58, .external_lex_state = 356},
  [11555] = {.lex_state = 55, .external_lex_state = 299},
  [11556] = {.lex_state = 58, .external_lex_state = 309},
  [11557] = {.lex_state = 58, .external_lex_state = 357},
  [11558] = {.lex_state = 55, .external_lex_state = 299},
  [11559] = {.lex_state = 55, .external_lex_state = 299},
  [11560] = {.lex_state = 58, .external_lex_state = 309},
  [11561] = {.lex_state = 58, .external_lex_state = 306},
  [11562] = {.lex_state = 58, .external_lex_state = 305},
  [11563] = {.lex_state = 58, .external_lex_state = 320},
  [11564] = {.lex_state = 58, .external_lex_state = 356},
  [11565] = {.lex_state = 58, .external_lex_state = 358},
  [11566] = {.lex_state = 61, .external_lex_state = 302},
  [11567] = {.lex_state = 58, .external_lex_state = 315},
  [11568] = {.lex_state = 61, .external_lex_state = 301},
  [11569] = {.lex_state = 0, .external_lex_state = 359},
  [11570] = {.lex_state = 58, .external_lex_state = 306},
  [11571] = {.lex_state = 61, .external_lex_state = 302},
  [11572] = {.lex_state = 60, .external_lex_state = 314},
  [11573] = {.lex_state = 58, .external_lex_state = 360},
  [11574] = {.lex_state = 58, .external_lex_state = 303},
  [11575] = {.lex_state = 61, .external_lex_state = 302},
  [11576] = {.lex_state = 58, .external_lex_state = 320},
  [11577] = {.lex_state = 61, .external_lex_state = 302},
  [11578] = {.lex_state = 58, .external_lex_state = 355},
  [11579] = {.lex_state = 55, .external_lex_state = 299},
  [11580] = {.lex_state = 55, .external_lex_state = 299},
  [11581] = {.lex_state = 58, .external_lex_state = 320},
  [11582] = {.lex_state = 61, .external_lex_state = 301},
  [11583] = {.lex_state = 58, .external_lex_state = 320},
  [11584] = {.lex_state = 58, .external_lex_state = 320},
  [11585] = {.lex_state = 58, .external_lex_state = 320},
  [11586] = {.lex_state = 58, .external_lex_state = 320},
  [11587] = {.lex_state = 61, .external_lex_state = 301},
  [11588] = {.lex_state = 55, .external_lex_state = 299},
  [11589] = {.lex_state = 58, .external_lex_state = 303},
  [11590] = {.lex_state = 58, .external_lex_state = 320},
  [11591] = {.lex_state = 61, .external_lex_state = 301},
  [11592] = {.lex_state = 58, .external_lex_state = 315},
  [11593] = {.lex_state = 58, .external_lex_state = 320},
  [11594] = {.lex_state = 61, .external_lex_state = 302},
  [11595] = {.lex_state = 58, .external_lex_state = 303},
  [11596] = {.lex_state = 0, .external_lex_state = 200},
  [11597] = {.lex_state = 58, .external_lex_state = 320},
  [11598] = {.lex_state = 61, .external_lex_state = 302},
  [11599] = {.lex_state = 58, .external_lex_state = 315},
  [11600] = {.lex_state = 58, .external_lex_state = 303},
  [11601] = {.lex_state = 58, .external_lex_state = 309},
  [11602] = {.lex_state = 58, .external_lex_state = 309},
  [11603] = {.lex_state = 61, .external_lex_state = 302},
  [11604] = {.lex_state = 61, .external_lex_state = 302},
  [11605] = {.lex_state = 58, .external_lex_state = 305},
  [11606] = {.lex_state = 58, .external_lex_state = 320},
  [11607] = {.lex_state = 58, .external_lex_state = 309},
  [11608] = {.lex_state = 58, .external_lex_state = 303},
  [11609] = {.lex_state = 58, .external_lex_state = 320},
  [11610] = {.lex_state = 61, .external_lex_state = 302},
  [11611] = {.lex_state = 58, .external_lex_state = 303},
  [11612] = {.lex_state = 58, .external_lex_state = 320},
  [11613] = {.lex_state = 58, .external_lex_state = 305},
  [11614] = {.lex_state = 58, .external_lex_state = 309},
  [11615] = {.lex_state = 61, .external_lex_state = 301},
  [11616] = {.lex_state = 58, .external_lex_state = 303},
  [11617] = {.lex_state = 58, .external_lex_state = 303},
  [11618] = {.lex_state = 58, .external_lex_state = 309},
  [11619] = {.lex_state = 0, .external_lex_state = 359},
  [11620] = {.lex_state = 58, .external_lex_state = 320},
  [11621] = {.lex_state = 58, .external_lex_state = 303},
  [11622] = {.lex_state = 61, .external_lex_state = 302},
  [11623] = {.lex_state = 58, .external_lex_state = 309},
  [11624] = {.lex_state = 58, .external_lex_state = 309},
  [11625] = {.lex_state = 58, .external_lex_state = 303},
  [11626] = {.lex_state = 58, .external_lex_state = 303},
  [11627] = {.lex_state = 58, .external_lex_state = 320},
  [11628] = {.lex_state = 58, .external_lex_state = 309},
  [11629] = {.lex_state = 58, .external_lex_state = 305},
  [11630] = {.lex_state = 58, .external_lex_state = 303},
  [11631] = {.lex_state = 58, .external_lex_state = 294},
  [11632] = {.lex_state = 61, .external_lex_state = 301},
  [11633] = {.lex_state = 58, .external_lex_state = 303},
  [11634] = {.lex_state = 61, .external_lex_state = 302},
  [11635] = {.lex_state = 58, .external_lex_state = 361},
  [11636] = {.lex_state = 58, .external_lex_state = 306},
  [11637] = {.lex_state = 61, .external_lex_state = 302},
  [11638] = {.lex_state = 55, .external_lex_state = 299},
  [11639] = {.lex_state = 58, .external_lex_state = 305},
  [11640] = {.lex_state = 55, .external_lex_state = 299},
  [11641] = {.lex_state = 61, .external_lex_state = 301},
  [11642] = {.lex_state = 55, .external_lex_state = 299},
  [11643] = {.lex_state = 61, .external_lex_state = 301},
  [11644] = {.lex_state = 58, .external_lex_state = 303},
  [11645] = {.lex_state = 58, .external_lex_state = 305},
  [11646] = {.lex_state = 55, .external_lex_state = 299},
  [11647] = {.lex_state = 61, .external_lex_state = 301},
  [11648] = {.lex_state = 58, .external_lex_state = 356},
  [11649] = {.lex_state = 58, .external_lex_state = 309},
  [11650] = {.lex_state = 58, .external_lex_state = 309},
  [11651] = {.lex_state = 61, .external_lex_state = 301},
  [11652] = {.lex_state = 61, .external_lex_state = 301},
  [11653] = {.lex_state = 58, .external_lex_state = 305},
  [11654] = {.lex_state = 58, .external_lex_state = 309},
  [11655] = {.lex_state = 61, .external_lex_state = 301},
  [11656] = {.lex_state = 58, .external_lex_state = 362},
  [11657] = {.lex_state = 58, .external_lex_state = 303},
  [11658] = {.lex_state = 61, .external_lex_state = 302},
  [11659] = {.lex_state = 55, .external_lex_state = 299},
  [11660] = {.lex_state = 61, .external_lex_state = 302},
  [11661] = {.lex_state = 58, .external_lex_state = 305},
  [11662] = {.lex_state = 61, .external_lex_state = 302},
  [11663] = {.lex_state = 58, .external_lex_state = 306},
  [11664] = {.lex_state = 58, .external_lex_state = 306},
  [11665] = {.lex_state = 55, .external_lex_state = 299},
  [11666] = {.lex_state = 58, .external_lex_state = 309},
  [11667] = {.lex_state = 58, .external_lex_state = 363},
  [11668] = {.lex_state = 55, .external_lex_state = 299},
  [11669] = {.lex_state = 55, .external_lex_state = 299},
  [11670] = {.lex_state = 58, .external_lex_state = 303},
  [11671] = {.lex_state = 58, .external_lex_state = 363},
  [11672] = {.lex_state = 61, .external_lex_state = 301},
  [11673] = {.lex_state = 58, .external_lex_state = 303},
  [11674] = {.lex_state = 58, .external_lex_state = 306},
  [11675] = {.lex_state = 58, .external_lex_state = 303},
  [11676] = {.lex_state = 58, .external_lex_state = 305},
  [11677] = {.lex_state = 58, .external_lex_state = 320},
  [11678] = {.lex_state = 58, .external_lex_state = 303},
  [11679] = {.lex_state = 58, .external_lex_state = 306},
  [11680] = {.lex_state = 58, .external_lex_state = 320},
  [11681] = {.lex_state = 61, .external_lex_state = 301},
  [11682] = {.lex_state = 58, .external_lex_state = 320},
  [11683] = {.lex_state = 58, .external_lex_state = 315},
  [11684] = {.lex_state = 58, .external_lex_state = 306},
  [11685] = {.lex_state = 58, .external_lex_state = 315},
  [11686] = {.lex_state = 58, .external_lex_state = 294},
  [11687] = {.lex_state = 58, .external_lex_state = 303},
  [11688] = {.lex_state = 58, .external_lex_state = 303},
  [11689] = {.lex_state = 58, .external_lex_state = 315},
  [11690] = {.lex_state = 58, .external_lex_state = 305},
  [11691] = {.lex_state = 58, .external_lex_state = 306},
  [11692] = {.lex_state = 58, .external_lex_state = 303},
  [11693] = {.lex_state = 58, .external_lex_state = 306},
  [11694] = {.lex_state = 61, .external_lex_state = 301},
  [11695] = {.lex_state = 61, .external_lex_state = 301},
  [11696] = {.lex_state = 58, .external_lex_state = 315},
  [11697] = {.lex_state = 58, .external_lex_state = 309},
  [11698] = {.lex_state = 58, .external_lex_state = 320},
  [11699] = {.lex_state = 58, .external_lex_state = 303},
  [11700] = {.lex_state = 0, .external_lex_state = 325},
  [11701] = {.lex_state = 58, .external_lex_state = 303},
  [11702] = {.lex_state = 58, .external_lex_state = 320},
  [11703] = {.lex_state = 58, .external_lex_state = 303},
  [11704] = {.lex_state = 58, .external_lex_state = 303},
  [11705] = {.lex_state = 58, .external_lex_state = 303},
  [11706] = {.lex_state = 58, .external_lex_state = 303},
  [11707] = {.lex_state = 61, .external_lex_state = 301},
  [11708] = {.lex_state = 61, .external_lex_state = 301},
  [11709] = {.lex_state = 58, .external_lex_state = 303},
  [11710] = {.lex_state = 58, .external_lex_state = 360},
  [11711] = {.lex_state = 61, .external_lex_state = 301},
  [11712] = {.lex_state = 58, .external_lex_state = 360},
  [11713] = {.lex_state = 58, .external_lex_state = 294},
  [11714] = {.lex_state = 61, .external_lex_state = 301},
  [11715] = {.lex_state = 58, .external_lex_state = 355},
  [11716] = {.lex_state = 58, .external_lex_state = 306},
  [11717] = {.lex_state = 58, .external_lex_state = 303},
  [11718] = {.lex_state = 58, .external_lex_state = 303},
  [11719] = {.lex_state = 58, .external_lex_state = 294},
  [11720] = {.lex_state = 58, .external_lex_state = 355},
  [11721] = {.lex_state = 61, .external_lex_state = 301},
  [11722] = {.lex_state = 58, .external_lex_state = 320},
  [11723] = {.lex_state = 61, .external_lex_state = 301},
  [11724] = {.lex_state = 58, .external_lex_state = 303},
  [11725] = {.lex_state = 58, .external_lex_state = 303},
  [11726] = {.lex_state = 58, .external_lex_state = 303},
  [11727] = {.lex_state = 58, .external_lex_state = 320},
  [11728] = {.lex_state = 58, .external_lex_state = 314},
  [11729] = {.lex_state = 58, .external_lex_state = 294},
  [11730] = {.lex_state = 58, .external_lex_state = 320},
  [11731] = {.lex_state = 61, .external_lex_state = 301},
  [11732] = {.lex_state = 58, .external_lex_state = 303},
  [11733] = {.lex_state = 58, .external_lex_state = 303},
  [11734] = {.lex_state = 58, .external_lex_state = 303},
  [11735] = {.lex_state = 58, .external_lex_state = 303},
  [11736] = {.lex_state = 58, .external_lex_state = 360},
  [11737] = {.lex_state = 58, .external_lex_state = 303},
  [11738] = {.lex_state = 58, .external_lex_state = 306},
  [11739] = {.lex_state = 58, .external_lex_state = 306},
  [11740] = {.lex_state = 58, .external_lex_state = 305},
  [11741] = {.lex_state = 58, .external_lex_state = 303},
  [11742] = {.lex_state = 60, .external_lex_state = 251},
  [11743] = {.lex_state = 58, .external_lex_state = 303},
  [11744] = {.lex_state = 58, .external_lex_state = 303},
  [11745] = {.lex_state = 58, .external_lex_state = 306},
  [11746] = {.lex_state = 61, .external_lex_state = 301},
  [11747] = {.lex_state = 58, .external_lex_state = 303},
  [11748] = {.lex_state = 61, .external_lex_state = 301},
  [11749] = {.lex_state = 58, .external_lex_state = 303},
  [11750] = {.lex_state = 58, .external_lex_state = 303},
  [11751] = {.lex_state = 58, .external_lex_state = 303},
  [11752] = {.lex_state = 61, .external_lex_state = 301},
  [11753] = {.lex_state = 58, .external_lex_state = 353},
  [11754] = {.lex_state = 58, .external_lex_state = 303},
  [11755] = {.lex_state = 58, .external_lex_state = 364},
  [11756] = {.lex_state = 58, .external_lex_state = 306},
  [11757] = {.lex_state = 58, .external_lex_state = 320},
  [11758] = {.lex_state = 58, .external_lex_state = 305},
  [11759] = {.lex_state = 58, .external_lex_state = 305},
  [11760] = {.lex_state = 58, .external_lex_state = 303},
  [11761] = {.lex_state = 58, .external_lex_state = 314},
  [11762] = {.lex_state = 58, .external_lex_state = 364},
  [11763] = {.lex_state = 58, .external_lex_state = 303},
  [11764] = {.lex_state = 58, .external_lex_state = 309},
  [11765] = {.lex_state = 58, .external_lex_state = 305},
  [11766] = {.lex_state = 58, .external_lex_state = 364},
  [11767] = {.lex_state = 61, .external_lex_state = 365},
  [11768] = {.lex_state = 57, .external_lex_state = 308},
  [11769] = {.lex_state = 58, .external_lex_state = 364},
  [11770] = {.lex_state = 58, .external_lex_state = 303},
  [11771] = {.lex_state = 60, .external_lex_state = 314},
  [11772] = {.lex_state = 58, .external_lex_state = 314},
  [11773] = {.lex_state = 58, .external_lex_state = 303},
  [11774] = {.lex_state = 58, .external_lex_state = 305},
  [11775] = {.lex_state = 58, .external_lex_state = 303},
  [11776] = {.lex_state = 58, .external_lex_state = 355},
  [11777] = {.lex_state = 58, .external_lex_state = 306},
  [11778] = {.lex_state = 58, .external_lex_state = 303},
  [11779] = {.lex_state = 61, .external_lex_state = 302},
  [11780] = {.lex_state = 58, .external_lex_state = 306},
  [11781] = {.lex_state = 58, .external_lex_state = 303},
  [11782] = {.lex_state = 58, .external_lex_state = 294},
  [11783] = {.lex_state = 61, .external_lex_state = 302},
  [11784] = {.lex_state = 58, .external_lex_state = 360},
  [11785] = {.lex_state = 58, .external_lex_state = 303},
  [11786] = {.lex_state = 58, .external_lex_state = 310},
  [11787] = {.lex_state = 61, .external_lex_state = 302},
  [11788] = {.lex_state = 55, .external_lex_state = 366},
  [11789] = {.lex_state = 58, .external_lex_state = 306},
  [11790] = {.lex_state = 58, .external_lex_state = 294},
  [11791] = {.lex_state = 58, .external_lex_state = 315},
  [11792] = {.lex_state = 58, .external_lex_state = 294},
  [11793] = {.lex_state = 58, .external_lex_state = 315},
  [11794] = {.lex_state = 58, .external_lex_state = 315},
  [11795] = {.lex_state = 58, .external_lex_state = 315},
  [11796] = {.lex_state = 58, .external_lex_state = 303},
  [11797] = {.lex_state = 58, .external_lex_state = 303},
  [11798] = {.lex_state = 61, .external_lex_state = 302},
  [11799] = {.lex_state = 58, .external_lex_state = 315},
  [11800] = {.lex_state = 58, .external_lex_state = 305},
  [11801] = {.lex_state = 58, .external_lex_state = 305},
  [11802] = {.lex_state = 58, .external_lex_state = 305},
  [11803] = {.lex_state = 58, .external_lex_state = 353},
  [11804] = {.lex_state = 55, .external_lex_state = 367},
  [11805] = {.lex_state = 58, .external_lex_state = 303},
  [11806] = {.lex_state = 58, .external_lex_state = 315},
  [11807] = {.lex_state = 58, .external_lex_state = 357},
  [11808] = {.lex_state = 58, .external_lex_state = 305},
  [11809] = {.lex_state = 58, .external_lex_state = 353},
  [11810] = {.lex_state = 58, .external_lex_state = 305},
  [11811] = {.lex_state = 58, .external_lex_state = 305},
  [11812] = {.lex_state = 58, .external_lex_state = 305},
  [11813] = {.lex_state = 58, .external_lex_state = 305},
  [11814] = {.lex_state = 61, .external_lex_state = 301},
  [11815] = {.lex_state = 58, .external_lex_state = 306},
  [11816] = {.lex_state = 61, .external_lex_state = 302},
  [11817] = {.lex_state = 58, .external_lex_state = 306},
  [11818] = {.lex_state = 58, .external_lex_state = 305},
  [11819] = {.lex_state = 61, .external_lex_state = 302},
  [11820] = {.lex_state = 58, .external_lex_state = 305},
  [11821] = {.lex_state = 58, .external_lex_state = 306},
  [11822] = {.lex_state = 61, .external_lex_state = 302},
  [11823] = {.lex_state = 58, .external_lex_state = 305},
  [11824] = {.lex_state = 61, .external_lex_state = 301},
  [11825] = {.lex_state = 61, .external_lex_state = 302},
  [11826] = {.lex_state = 58, .external_lex_state = 360},
  [11827] = {.lex_state = 58, .external_lex_state = 306},
  [11828] = {.lex_state = 58, .external_lex_state = 305},
  [11829] = {.lex_state = 61, .external_lex_state = 302},
  [11830] = {.lex_state = 61, .external_lex_state = 301},
  [11831] = {.lex_state = 58, .external_lex_state = 305},
  [11832] = {.lex_state = 61, .external_lex_state = 302},
  [11833] = {.lex_state = 60, .external_lex_state = 242},
  [11834] = {.lex_state = 58, .external_lex_state = 305},
  [11835] = {.lex_state = 61, .external_lex_state = 302},
  [11836] = {.lex_state = 61, .external_lex_state = 302},
  [11837] = {.lex_state = 58, .external_lex_state = 305},
  [11838] = {.lex_state = 58, .external_lex_state = 305},
  [11839] = {.lex_state = 58, .external_lex_state = 305},
  [11840] = {.lex_state = 61, .external_lex_state = 302},
  [11841] = {.lex_state = 58, .external_lex_state = 309},
  [11842] = {.lex_state = 58, .external_lex_state = 309},
  [11843] = {.lex_state = 61, .external_lex_state = 302},
  [11844] = {.lex_state = 61, .external_lex_state = 302},
  [11845] = {.lex_state = 58, .external_lex_state = 356},
  [11846] = {.lex_state = 58, .external_lex_state = 315},
  [11847] = {.lex_state = 61, .external_lex_state = 301},
  [11848] = {.lex_state = 61, .external_lex_state = 301},
  [11849] = {.lex_state = 61, .external_lex_state = 302},
  [11850] = {.lex_state = 58, .external_lex_state = 361},
  [11851] = {.lex_state = 58, .external_lex_state = 305},
  [11852] = {.lex_state = 61, .external_lex_state = 302},
  [11853] = {.lex_state = 61, .external_lex_state = 302},
  [11854] = {.lex_state = 58, .external_lex_state = 356},
  [11855] = {.lex_state = 58, .external_lex_state = 294},
  [11856] = {.lex_state = 58, .external_lex_state = 303},
  [11857] = {.lex_state = 58, .external_lex_state = 294},
  [11858] = {.lex_state = 61, .external_lex_state = 302},
  [11859] = {.lex_state = 58, .external_lex_state = 315},
  [11860] = {.lex_state = 58, .external_lex_state = 315},
  [11861] = {.lex_state = 58, .external_lex_state = 315},
  [11862] = {.lex_state = 58, .external_lex_state = 315},
  [11863] = {.lex_state = 58, .external_lex_state = 320},
  [11864] = {.lex_state = 58, .external_lex_state = 315},
  [11865] = {.lex_state = 58, .external_lex_state = 315},
  [11866] = {.lex_state = 60, .external_lex_state = 291},
  [11867] = {.lex_state = 58, .external_lex_state = 305},
  [11868] = {.lex_state = 58, .external_lex_state = 315},
  [11869] = {.lex_state = 58, .external_lex_state = 315},
  [11870] = {.lex_state = 61, .external_lex_state = 301},
  [11871] = {.lex_state = 58, .external_lex_state = 305},
  [11872] = {.lex_state = 61, .external_lex_state = 301},
  [11873] = {.lex_state = 58, .external_lex_state = 315},
  [11874] = {.lex_state = 61, .external_lex_state = 301},
  [11875] = {.lex_state = 58, .external_lex_state = 315},
  [11876] = {.lex_state = 58, .external_lex_state = 315},
  [11877] = {.lex_state = 0, .external_lex_state = 368},
  [11878] = {.lex_state = 60, .external_lex_state = 325},
  [11879] = {.lex_state = 58, .external_lex_state = 364},
  [11880] = {.lex_state = 58, .external_lex_state = 305},
  [11881] = {.lex_state = 61, .external_lex_state = 301},
  [11882] = {.lex_state = 55, .external_lex_state = 367},
  [11883] = {.lex_state = 58, .external_lex_state = 355},
  [11884] = {.lex_state = 61, .external_lex_state = 302},
  [11885] = {.lex_state = 61, .external_lex_state = 301},
  [11886] = {.lex_state = 61, .external_lex_state = 301},
  [11887] = {.lex_state = 61, .external_lex_state = 301},
  [11888] = {.lex_state = 61, .external_lex_state = 301},
  [11889] = {.lex_state = 0, .external_lex_state = 325},
  [11890] = {.lex_state = 58, .external_lex_state = 309},
  [11891] = {.lex_state = 58, .external_lex_state = 315},
  [11892] = {.lex_state = 61, .external_lex_state = 301},
  [11893] = {.lex_state = 61, .external_lex_state = 301},
  [11894] = {.lex_state = 58, .external_lex_state = 309},
  [11895] = {.lex_state = 58, .external_lex_state = 315},
  [11896] = {.lex_state = 61, .external_lex_state = 302},
  [11897] = {.lex_state = 58, .external_lex_state = 303},
  [11898] = {.lex_state = 55, .external_lex_state = 367},
  [11899] = {.lex_state = 58, .external_lex_state = 315},
  [11900] = {.lex_state = 58, .external_lex_state = 306},
  [11901] = {.lex_state = 58, .external_lex_state = 309},
  [11902] = {.lex_state = 58, .external_lex_state = 320},
  [11903] = {.lex_state = 61, .external_lex_state = 301},
  [11904] = {.lex_state = 61, .external_lex_state = 301},
  [11905] = {.lex_state = 61, .external_lex_state = 301},
  [11906] = {.lex_state = 61, .external_lex_state = 301},
  [11907] = {.lex_state = 61, .external_lex_state = 301},
  [11908] = {.lex_state = 58, .external_lex_state = 309},
  [11909] = {.lex_state = 61, .external_lex_state = 301},
  [11910] = {.lex_state = 60, .external_lex_state = 314},
  [11911] = {.lex_state = 58, .external_lex_state = 306},
  [11912] = {.lex_state = 58, .external_lex_state = 303},
  [11913] = {.lex_state = 58, .external_lex_state = 294},
  [11914] = {.lex_state = 58, .external_lex_state = 305},
  [11915] = {.lex_state = 58, .external_lex_state = 306},
  [11916] = {.lex_state = 58, .external_lex_state = 294},
  [11917] = {.lex_state = 58, .external_lex_state = 309},
  [11918] = {.lex_state = 55, .external_lex_state = 367},
  [11919] = {.lex_state = 58, .external_lex_state = 306},
  [11920] = {.lex_state = 58, .external_lex_state = 303},
  [11921] = {.lex_state = 58, .external_lex_state = 309},
  [11922] = {.lex_state = 61, .external_lex_state = 365},
  [11923] = {.lex_state = 58, .external_lex_state = 314},
  [11924] = {.lex_state = 58, .external_lex_state = 306},
  [11925] = {.lex_state = 58, .external_lex_state = 306},
  [11926] = {.lex_state = 61, .external_lex_state = 301},
  [11927] = {.lex_state = 58, .external_lex_state = 309},
  [11928] = {.lex_state = 58, .external_lex_state = 309},
  [11929] = {.lex_state = 58, .external_lex_state = 303},
  [11930] = {.lex_state = 61, .external_lex_state = 302},
  [11931] = {.lex_state = 61, .external_lex_state = 302},
  [11932] = {.lex_state = 61, .external_lex_state = 302},
  [11933] = {.lex_state = 58, .external_lex_state = 306},
  [11934] = {.lex_state = 61, .external_lex_state = 301},
  [11935] = {.lex_state = 61, .external_lex_state = 301},
  [11936] = {.lex_state = 61, .external_lex_state = 301},
  [11937] = {.lex_state = 61, .external_lex_state = 301},
  [11938] = {.lex_state = 61, .external_lex_state = 301},
  [11939] = {.lex_state = 58, .external_lex_state = 306},
  [11940] = {.lex_state = 61, .external_lex_state = 302},
  [11941] = {.lex_state = 61, .external_lex_state = 301},
  [11942] = {.lex_state = 61, .external_lex_state = 301},
  [11943] = {.lex_state = 61, .external_lex_state = 301},
  [11944] = {.lex_state = 61, .external_lex_state = 302},
  [11945] = {.lex_state = 61, .external_lex_state = 302},
  [11946] = {.lex_state = 61, .external_lex_state = 301},
  [11947] = {.lex_state = 61, .external_lex_state = 301},
  [11948] = {.lex_state = 61, .external_lex_state = 301},
  [11949] = {.lex_state = 61, .external_lex_state = 301},
  [11950] = {.lex_state = 58, .external_lex_state = 309},
  [11951] = {.lex_state = 58, .external_lex_state = 309},
  [11952] = {.lex_state = 58, .external_lex_state = 309},
  [11953] = {.lex_state = 0, .external_lex_state = 291},
  [11954] = {.lex_state = 0, .external_lex_state = 369},
  [11955] = {.lex_state = 58, .external_lex_state = 315},
  [11956] = {.lex_state = 58, .external_lex_state = 356},
  [11957] = {.lex_state = 58, .external_lex_state = 294},
  [11958] = {.lex_state = 58, .external_lex_state = 306},
  [11959] = {.lex_state = 61, .external_lex_state = 365},
  [11960] = {.lex_state = 61, .external_lex_state = 302},
  [11961] = {.lex_state = 58, .external_lex_state = 309},
  [11962] = {.lex_state = 58, .external_lex_state = 306},
  [11963] = {.lex_state = 58, .external_lex_state = 309},
  [11964] = {.lex_state = 61, .external_lex_state = 302},
  [11965] = {.lex_state = 61, .external_lex_state = 301},
  [11966] = {.lex_state = 61, .external_lex_state = 301},
  [11967] = {.lex_state = 58, .external_lex_state = 306},
  [11968] = {.lex_state = 58, .external_lex_state = 309},
  [11969] = {.lex_state = 61, .external_lex_state = 302},
  [11970] = {.lex_state = 58, .external_lex_state = 315},
  [11971] = {.lex_state = 58, .external_lex_state = 364},
  [11972] = {.lex_state = 61, .external_lex_state = 365},
  [11973] = {.lex_state = 61, .external_lex_state = 302},
  [11974] = {.lex_state = 58, .external_lex_state = 315},
  [11975] = {.lex_state = 58, .external_lex_state = 354},
  [11976] = {.lex_state = 61, .external_lex_state = 365},
  [11977] = {.lex_state = 61, .external_lex_state = 301},
  [11978] = {.lex_state = 61, .external_lex_state = 301},
  [11979] = {.lex_state = 55, .external_lex_state = 366},
  [11980] = {.lex_state = 58, .external_lex_state = 361},
  [11981] = {.lex_state = 0, .external_lex_state = 368},
  [11982] = {.lex_state = 0, .external_lex_state = 291},
  [11983] = {.lex_state = 61, .external_lex_state = 365},
  [11984] = {.lex_state = 61, .external_lex_state = 302},
  [11985] = {.lex_state = 58, .external_lex_state = 361},
  [11986] = {.lex_state = 0, .external_lex_state = 291},
  [11987] = {.lex_state = 58, .external_lex_state = 306},
  [11988] = {.lex_state = 58, .external_lex_state = 306},
  [11989] = {.lex_state = 0, .external_lex_state = 291},
  [11990] = {.lex_state = 58, .external_lex_state = 309},
  [11991] = {.lex_state = 61, .external_lex_state = 302},
  [11992] = {.lex_state = 58, .external_lex_state = 242},
  [11993] = {.lex_state = 60, .external_lex_state = 325},
  [11994] = {.lex_state = 0, .external_lex_state = 291},
  [11995] = {.lex_state = 58, .external_lex_state = 310},
  [11996] = {.lex_state = 58, .external_lex_state = 306},
  [11997] = {.lex_state = 58, .external_lex_state = 305},
  [11998] = {.lex_state = 0, .external_lex_state = 291},
  [11999] = {.lex_state = 58, .external_lex_state = 306},
  [12000] = {.lex_state = 0, .external_lex_state = 291},
  [12001] = {.lex_state = 58, .external_lex_state = 320},
  [12002] = {.lex_state = 58, .external_lex_state = 320},
  [12003] = {.lex_state = 58, .external_lex_state = 309},
  [12004] = {.lex_state = 58, .external_lex_state = 305},
  [12005] = {.lex_state = 58, .external_lex_state = 320},
  [12006] = {.lex_state = 0, .external_lex_state = 291},
  [12007] = {.lex_state = 58, .external_lex_state = 306},
  [12008] = {.lex_state = 58, .external_lex_state = 303},
  [12009] = {.lex_state = 58, .external_lex_state = 320},
  [12010] = {.lex_state = 58, .external_lex_state = 306},
  [12011] = {.lex_state = 58, .external_lex_state = 305},
  [12012] = {.lex_state = 58, .external_lex_state = 305},
  [12013] = {.lex_state = 0, .external_lex_state = 291},
  [12014] = {.lex_state = 2, .external_lex_state = 308},
  [12015] = {.lex_state = 58, .external_lex_state = 315},
  [12016] = {.lex_state = 58, .external_lex_state = 315},
  [12017] = {.lex_state = 0, .external_lex_state = 291},
  [12018] = {.lex_state = 58, .external_lex_state = 310},
  [12019] = {.lex_state = 61, .external_lex_state = 302},
  [12020] = {.lex_state = 58, .external_lex_state = 305},
  [12021] = {.lex_state = 58, .external_lex_state = 315},
  [12022] = {.lex_state = 58, .external_lex_state = 306},
  [12023] = {.lex_state = 58, .external_lex_state = 315},
  [12024] = {.lex_state = 61, .external_lex_state = 302},
  [12025] = {.lex_state = 61, .external_lex_state = 302},
  [12026] = {.lex_state = 58, .external_lex_state = 315},
  [12027] = {.lex_state = 58, .external_lex_state = 320},
  [12028] = {.lex_state = 61, .external_lex_state = 302},
  [12029] = {.lex_state = 58, .external_lex_state = 306},
  [12030] = {.lex_state = 58, .external_lex_state = 320},
  [12031] = {.lex_state = 58, .external_lex_state = 320},
  [12032] = {.lex_state = 58, .external_lex_state = 315},
  [12033] = {.lex_state = 58, .external_lex_state = 305},
  [12034] = {.lex_state = 58, .external_lex_state = 305},
  [12035] = {.lex_state = 58, .external_lex_state = 306},
  [12036] = {.lex_state = 58, .external_lex_state = 306},
  [12037] = {.lex_state = 58, .external_lex_state = 303},
  [12038] = {.lex_state = 58, .external_lex_state = 306},
  [12039] = {.lex_state = 58, .external_lex_state = 315},
  [12040] = {.lex_state = 58, .external_lex_state = 315},
  [12041] = {.lex_state = 61, .external_lex_state = 302},
  [12042] = {.lex_state = 58, .external_lex_state = 315},
  [12043] = {.lex_state = 58, .external_lex_state = 294},
  [12044] = {.lex_state = 61, .external_lex_state = 302},
  [12045] = {.lex_state = 58, .external_lex_state = 309},
  [12046] = {.lex_state = 58, .external_lex_state = 306},
  [12047] = {.lex_state = 58, .external_lex_state = 306},
  [12048] = {.lex_state = 58, .external_lex_state = 320},
  [12049] = {.lex_state = 58, .external_lex_state = 306},
  [12050] = {.lex_state = 58, .external_lex_state = 306},
  [12051] = {.lex_state = 58, .external_lex_state = 303},
  [12052] = {.lex_state = 58, .external_lex_state = 306},
  [12053] = {.lex_state = 58, .external_lex_state = 303},
  [12054] = {.lex_state = 58, .external_lex_state = 306},
  [12055] = {.lex_state = 58, .external_lex_state = 306},
  [12056] = {.lex_state = 58, .external_lex_state = 294},
  [12057] = {.lex_state = 0, .external_lex_state = 291},
  [12058] = {.lex_state = 58, .external_lex_state = 306},
  [12059] = {.lex_state = 0, .external_lex_state = 291},
  [12060] = {.lex_state = 58, .external_lex_state = 294},
  [12061] = {.lex_state = 58, .external_lex_state = 309},
  [12062] = {.lex_state = 61, .external_lex_state = 302},
  [12063] = {.lex_state = 58, .external_lex_state = 306},
  [12064] = {.lex_state = 58, .external_lex_state = 306},
  [12065] = {.lex_state = 58, .external_lex_state = 294},
  [12066] = {.lex_state = 58, .external_lex_state = 294},
  [12067] = {.lex_state = 58, .external_lex_state = 303},
  [12068] = {.lex_state = 58, .external_lex_state = 306},
  [12069] = {.lex_state = 58, .external_lex_state = 320},
  [12070] = {.lex_state = 58, .external_lex_state = 305},
  [12071] = {.lex_state = 55, .external_lex_state = 299},
  [12072] = {.lex_state = 58, .external_lex_state = 306},
  [12073] = {.lex_state = 58, .external_lex_state = 361},
  [12074] = {.lex_state = 58, .external_lex_state = 305},
  [12075] = {.lex_state = 58, .external_lex_state = 305},
  [12076] = {.lex_state = 61, .external_lex_state = 302},
  [12077] = {.lex_state = 58, .external_lex_state = 358},
  [12078] = {.lex_state = 61, .external_lex_state = 302},
  [12079] = {.lex_state = 0, .external_lex_state = 291},
  [12080] = {.lex_state = 58, .external_lex_state = 306},
  [12081] = {.lex_state = 58, .external_lex_state = 303},
  [12082] = {.lex_state = 58, .external_lex_state = 315},
  [12083] = {.lex_state = 0, .external_lex_state = 291},
  [12084] = {.lex_state = 58, .external_lex_state = 306},
  [12085] = {.lex_state = 58, .external_lex_state = 305},
  [12086] = {.lex_state = 58, .external_lex_state = 306},
  [12087] = {.lex_state = 58, .external_lex_state = 305},
  [12088] = {.lex_state = 58, .external_lex_state = 315},
  [12089] = {.lex_state = 58, .external_lex_state = 306},
  [12090] = {.lex_state = 58, .external_lex_state = 303},
  [12091] = {.lex_state = 61, .external_lex_state = 302},
  [12092] = {.lex_state = 58, .external_lex_state = 305},
  [12093] = {.lex_state = 58, .external_lex_state = 305},
  [12094] = {.lex_state = 58, .external_lex_state = 305},
  [12095] = {.lex_state = 58, .external_lex_state = 305},
  [12096] = {.lex_state = 58, .external_lex_state = 305},
  [12097] = {.lex_state = 58, .external_lex_state = 305},
  [12098] = {.lex_state = 58, .external_lex_state = 305},
  [12099] = {.lex_state = 58, .external_lex_state = 303},
  [12100] = {.lex_state = 58, .external_lex_state = 320},
  [12101] = {.lex_state = 0, .external_lex_state = 291},
  [12102] = {.lex_state = 61, .external_lex_state = 302},
  [12103] = {.lex_state = 58, .external_lex_state = 362},
  [12104] = {.lex_state = 58, .external_lex_state = 305},
  [12105] = {.lex_state = 58, .external_lex_state = 305},
  [12106] = {.lex_state = 58, .external_lex_state = 305},
  [12107] = {.lex_state = 58, .external_lex_state = 303},
  [12108] = {.lex_state = 0, .external_lex_state = 291},
  [12109] = {.lex_state = 58, .external_lex_state = 361},
  [12110] = {.lex_state = 0, .external_lex_state = 291},
  [12111] = {.lex_state = 58, .external_lex_state = 305},
  [12112] = {.lex_state = 58, .external_lex_state = 309},
  [12113] = {.lex_state = 58, .external_lex_state = 306},
  [12114] = {.lex_state = 61, .external_lex_state = 302},
  [12115] = {.lex_state = 58, .external_lex_state = 305},
  [12116] = {.lex_state = 58, .external_lex_state = 306},
  [12117] = {.lex_state = 58, .external_lex_state = 303},
  [12118] = {.lex_state = 61, .external_lex_state = 302},
  [12119] = {.lex_state = 58, .external_lex_state = 310},
  [12120] = {.lex_state = 58, .external_lex_state = 310},
  [12121] = {.lex_state = 55, .external_lex_state = 302},
  [12122] = {.lex_state = 58, .external_lex_state = 305},
  [12123] = {.lex_state = 58, .external_lex_state = 316},
  [12124] = {.lex_state = 58, .external_lex_state = 370},
  [12125] = {.lex_state = 58, .external_lex_state = 316},
  [12126] = {.lex_state = 58, .external_lex_state = 316},
  [12127] = {.lex_state = 58, .external_lex_state = 325},
  [12128] = {.lex_state = 58, .external_lex_state = 325},
  [12129] = {.lex_state = 55, .external_lex_state = 308},
  [12130] = {.lex_state = 58, .external_lex_state = 325},
  [12131] = {.lex_state = 58, .external_lex_state = 325},
  [12132] = {.lex_state = 58, .external_lex_state = 325},
  [12133] = {.lex_state = 58, .external_lex_state = 325},
  [12134] = {.lex_state = 58, .external_lex_state = 325},
  [12135] = {.lex_state = 55, .external_lex_state = 302},
  [12136] = {.lex_state = 58, .external_lex_state = 305},
  [12137] = {.lex_state = 58, .external_lex_state = 316},
  [12138] = {.lex_state = 58, .external_lex_state = 291},
  [12139] = {.lex_state = 58, .external_lex_state = 305},
  [12140] = {.lex_state = 58, .external_lex_state = 316},
  [12141] = {.lex_state = 55, .external_lex_state = 339},
  [12142] = {.lex_state = 55, .external_lex_state = 302},
  [12143] = {.lex_state = 55, .external_lex_state = 302},
  [12144] = {.lex_state = 58, .external_lex_state = 311},
  [12145] = {.lex_state = 58, .external_lex_state = 325},
  [12146] = {.lex_state = 58, .external_lex_state = 306},
  [12147] = {.lex_state = 58, .external_lex_state = 306},
  [12148] = {.lex_state = 58, .external_lex_state = 314},
  [12149] = {.lex_state = 0, .external_lex_state = 371},
  [12150] = {.lex_state = 58, .external_lex_state = 325},
  [12151] = {.lex_state = 58, .external_lex_state = 311},
  [12152] = {.lex_state = 58, .external_lex_state = 314},
  [12153] = {.lex_state = 58, .external_lex_state = 316},
  [12154] = {.lex_state = 58, .external_lex_state = 306},
  [12155] = {.lex_state = 58, .external_lex_state = 325},
  [12156] = {.lex_state = 55, .external_lex_state = 339},
  [12157] = {.lex_state = 58, .external_lex_state = 311},
  [12158] = {.lex_state = 58, .external_lex_state = 312},
  [12159] = {.lex_state = 58, .external_lex_state = 311},
  [12160] = {.lex_state = 58, .external_lex_state = 316},
  [12161] = {.lex_state = 58, .external_lex_state = 316},
  [12162] = {.lex_state = 58, .external_lex_state = 310},
  [12163] = {.lex_state = 58, .external_lex_state = 314},
  [12164] = {.lex_state = 58, .external_lex_state = 303},
  [12165] = {.lex_state = 58, .external_lex_state = 325},
  [12166] = {.lex_state = 58, .external_lex_state = 291},
  [12167] = {.lex_state = 58, .external_lex_state = 291},
  [12168] = {.lex_state = 58, .external_lex_state = 325},
  [12169] = {.lex_state = 58, .external_lex_state = 325},
  [12170] = {.lex_state = 58, .external_lex_state = 316},
  [12171] = {.lex_state = 58, .external_lex_state = 314},
  [12172] = {.lex_state = 58, .external_lex_state = 311},
  [12173] = {.lex_state = 58, .external_lex_state = 372},
  [12174] = {.lex_state = 58, .external_lex_state = 325},
  [12175] = {.lex_state = 61, .external_lex_state = 313},
  [12176] = {.lex_state = 58, .external_lex_state = 291},
  [12177] = {.lex_state = 58, .external_lex_state = 311},
  [12178] = {.lex_state = 58, .external_lex_state = 314},
  [12179] = {.lex_state = 58, .external_lex_state = 314},
  [12180] = {.lex_state = 58, .external_lex_state = 314},
  [12181] = {.lex_state = 0, .external_lex_state = 373},
  [12182] = {.lex_state = 55, .external_lex_state = 302},
  [12183] = {.lex_state = 58, .external_lex_state = 311},
  [12184] = {.lex_state = 55, .external_lex_state = 302},
  [12185] = {.lex_state = 58, .external_lex_state = 314},
  [12186] = {.lex_state = 58, .external_lex_state = 314},
  [12187] = {.lex_state = 58, .external_lex_state = 325},
  [12188] = {.lex_state = 58, .external_lex_state = 325},
  [12189] = {.lex_state = 58, .external_lex_state = 314},
  [12190] = {.lex_state = 58, .external_lex_state = 311},
  [12191] = {.lex_state = 58, .external_lex_state = 314},
  [12192] = {.lex_state = 58, .external_lex_state = 314},
  [12193] = {.lex_state = 58, .external_lex_state = 314},
  [12194] = {.lex_state = 58, .external_lex_state = 310},
  [12195] = {.lex_state = 58, .external_lex_state = 314},
  [12196] = {.lex_state = 58, .external_lex_state = 325},
  [12197] = {.lex_state = 58, .external_lex_state = 316},
  [12198] = {.lex_state = 58, .external_lex_state = 291},
  [12199] = {.lex_state = 58, .external_lex_state = 305},
  [12200] = {.lex_state = 58, .external_lex_state = 305},
  [12201] = {.lex_state = 58, .external_lex_state = 325},
  [12202] = {.lex_state = 58, .external_lex_state = 305},
  [12203] = {.lex_state = 55, .external_lex_state = 350},
  [12204] = {.lex_state = 58, .external_lex_state = 316},
  [12205] = {.lex_state = 58, .external_lex_state = 372},
  [12206] = {.lex_state = 58, .external_lex_state = 372},
  [12207] = {.lex_state = 55, .external_lex_state = 302},
  [12208] = {.lex_state = 58, .external_lex_state = 306},
  [12209] = {.lex_state = 58, .external_lex_state = 325},
  [12210] = {.lex_state = 55, .external_lex_state = 302},
  [12211] = {.lex_state = 0, .external_lex_state = 371},
  [12212] = {.lex_state = 55, .external_lex_state = 302},
  [12213] = {.lex_state = 58, .external_lex_state = 316},
  [12214] = {.lex_state = 58, .external_lex_state = 314},
  [12215] = {.lex_state = 58, .external_lex_state = 325},
  [12216] = {.lex_state = 58, .external_lex_state = 314},
  [12217] = {.lex_state = 58, .external_lex_state = 310},
  [12218] = {.lex_state = 58, .external_lex_state = 306},
  [12219] = {.lex_state = 58, .external_lex_state = 314},
  [12220] = {.lex_state = 58, .external_lex_state = 314},
  [12221] = {.lex_state = 58, .external_lex_state = 306},
  [12222] = {.lex_state = 58, .external_lex_state = 306},
  [12223] = {.lex_state = 58, .external_lex_state = 305},
  [12224] = {.lex_state = 58, .external_lex_state = 314},
  [12225] = {.lex_state = 58, .external_lex_state = 310},
  [12226] = {.lex_state = 58, .external_lex_state = 310},
  [12227] = {.lex_state = 58, .external_lex_state = 311},
  [12228] = {.lex_state = 58, .external_lex_state = 325},
  [12229] = {.lex_state = 58, .external_lex_state = 310},
  [12230] = {.lex_state = 58, .external_lex_state = 314},
  [12231] = {.lex_state = 58, .external_lex_state = 311},
  [12232] = {.lex_state = 55, .external_lex_state = 299},
  [12233] = {.lex_state = 58, .external_lex_state = 311},
  [12234] = {.lex_state = 55, .external_lex_state = 302},
  [12235] = {.lex_state = 58, .external_lex_state = 325},
  [12236] = {.lex_state = 58, .external_lex_state = 310},
  [12237] = {.lex_state = 58, .external_lex_state = 306},
  [12238] = {.lex_state = 58, .external_lex_state = 311},
  [12239] = {.lex_state = 58, .external_lex_state = 314},
  [12240] = {.lex_state = 0, .external_lex_state = 373},
  [12241] = {.lex_state = 58, .external_lex_state = 314},
  [12242] = {.lex_state = 58, .external_lex_state = 311},
  [12243] = {.lex_state = 55, .external_lex_state = 302},
  [12244] = {.lex_state = 58, .external_lex_state = 306},
  [12245] = {.lex_state = 58, .external_lex_state = 311},
  [12246] = {.lex_state = 55, .external_lex_state = 302},
  [12247] = {.lex_state = 58, .external_lex_state = 311},
  [12248] = {.lex_state = 58, .external_lex_state = 303},
  [12249] = {.lex_state = 55, .external_lex_state = 299},
  [12250] = {.lex_state = 58, .external_lex_state = 314},
  [12251] = {.lex_state = 58, .external_lex_state = 312},
  [12252] = {.lex_state = 58, .external_lex_state = 311},
  [12253] = {.lex_state = 58, .external_lex_state = 305},
  [12254] = {.lex_state = 58, .external_lex_state = 314},
  [12255] = {.lex_state = 58, .external_lex_state = 310},
  [12256] = {.lex_state = 58, .external_lex_state = 305},
  [12257] = {.lex_state = 55, .external_lex_state = 302},
  [12258] = {.lex_state = 55, .external_lex_state = 302},
  [12259] = {.lex_state = 55, .external_lex_state = 302},
  [12260] = {.lex_state = 58, .external_lex_state = 311},
  [12261] = {.lex_state = 58, .external_lex_state = 311},
  [12262] = {.lex_state = 58, .external_lex_state = 310},
  [12263] = {.lex_state = 58, .external_lex_state = 314},
  [12264] = {.lex_state = 58, .external_lex_state = 314},
  [12265] = {.lex_state = 58, .external_lex_state = 311},
  [12266] = {.lex_state = 55, .external_lex_state = 302},
  [12267] = {.lex_state = 55, .external_lex_state = 302},
  [12268] = {.lex_state = 58, .external_lex_state = 310},
  [12269] = {.lex_state = 58, .external_lex_state = 314},
  [12270] = {.lex_state = 61, .external_lex_state = 313},
  [12271] = {.lex_state = 58, .external_lex_state = 314},
  [12272] = {.lex_state = 58, .external_lex_state = 314},
  [12273] = {.lex_state = 58, .external_lex_state = 314},
  [12274] = {.lex_state = 58, .external_lex_state = 314},
  [12275] = {.lex_state = 58, .external_lex_state = 311},
  [12276] = {.lex_state = 58, .external_lex_state = 314},
  [12277] = {.lex_state = 58, .external_lex_state = 310},
  [12278] = {.lex_state = 58, .external_lex_state = 311},
  [12279] = {.lex_state = 58, .external_lex_state = 370},
  [12280] = {.lex_state = 58, .external_lex_state = 311},
  [12281] = {.lex_state = 58, .external_lex_state = 310},
  [12282] = {.lex_state = 58, .external_lex_state = 314},
  [12283] = {.lex_state = 55, .external_lex_state = 302},
  [12284] = {.lex_state = 58, .external_lex_state = 314},
  [12285] = {.lex_state = 58, .external_lex_state = 314},
  [12286] = {.lex_state = 58, .external_lex_state = 310},
  [12287] = {.lex_state = 58, .external_lex_state = 310},
  [12288] = {.lex_state = 58, .external_lex_state = 314},
  [12289] = {.lex_state = 58, .external_lex_state = 310},
  [12290] = {.lex_state = 58, .external_lex_state = 311},
  [12291] = {.lex_state = 58, .external_lex_state = 314},
  [12292] = {.lex_state = 58, .external_lex_state = 310},
  [12293] = {.lex_state = 58, .external_lex_state = 314},
  [12294] = {.lex_state = 58, .external_lex_state = 305},
  [12295] = {.lex_state = 58, .external_lex_state = 314},
  [12296] = {.lex_state = 58, .external_lex_state = 310},
  [12297] = {.lex_state = 57, .external_lex_state = 251},
  [12298] = {.lex_state = 58, .external_lex_state = 310},
  [12299] = {.lex_state = 58, .external_lex_state = 311},
  [12300] = {.lex_state = 58, .external_lex_state = 310},
  [12301] = {.lex_state = 58, .external_lex_state = 314},
  [12302] = {.lex_state = 58, .external_lex_state = 314},
  [12303] = {.lex_state = 58, .external_lex_state = 310},
  [12304] = {.lex_state = 58, .external_lex_state = 314},
  [12305] = {.lex_state = 58, .external_lex_state = 314},
  [12306] = {.lex_state = 58, .external_lex_state = 314},
  [12307] = {.lex_state = 58, .external_lex_state = 316},
  [12308] = {.lex_state = 58, .external_lex_state = 305},
  [12309] = {.lex_state = 58, .external_lex_state = 305},
  [12310] = {.lex_state = 58, .external_lex_state = 314},
  [12311] = {.lex_state = 58, .external_lex_state = 314},
  [12312] = {.lex_state = 58, .external_lex_state = 314},
  [12313] = {.lex_state = 58, .external_lex_state = 314},
  [12314] = {.lex_state = 58, .external_lex_state = 314},
  [12315] = {.lex_state = 58, .external_lex_state = 315},
  [12316] = {.lex_state = 58, .external_lex_state = 305},
  [12317] = {.lex_state = 58, .external_lex_state = 314},
  [12318] = {.lex_state = 58, .external_lex_state = 305},
  [12319] = {.lex_state = 58, .external_lex_state = 314},
  [12320] = {.lex_state = 58, .external_lex_state = 305},
  [12321] = {.lex_state = 58, .external_lex_state = 314},
  [12322] = {.lex_state = 61, .external_lex_state = 313},
  [12323] = {.lex_state = 55, .external_lex_state = 308},
  [12324] = {.lex_state = 58, .external_lex_state = 314},
  [12325] = {.lex_state = 58, .external_lex_state = 309},
  [12326] = {.lex_state = 58, .external_lex_state = 312},
  [12327] = {.lex_state = 58, .external_lex_state = 312},
  [12328] = {.lex_state = 58, .external_lex_state = 316},
  [12329] = {.lex_state = 58, .external_lex_state = 311},
  [12330] = {.lex_state = 58, .external_lex_state = 312},
  [12331] = {.lex_state = 58, .external_lex_state = 312},
  [12332] = {.lex_state = 58, .external_lex_state = 311},
  [12333] = {.lex_state = 58, .external_lex_state = 310},
  [12334] = {.lex_state = 58, .external_lex_state = 314},
  [12335] = {.lex_state = 58, .external_lex_state = 312},
  [12336] = {.lex_state = 58, .external_lex_state = 314},
  [12337] = {.lex_state = 58, .external_lex_state = 305},
  [12338] = {.lex_state = 58, .external_lex_state = 316},
  [12339] = {.lex_state = 58, .external_lex_state = 305},
  [12340] = {.lex_state = 55, .external_lex_state = 350},
  [12341] = {.lex_state = 58, .external_lex_state = 316},
  [12342] = {.lex_state = 58, .external_lex_state = 312},
  [12343] = {.lex_state = 58, .external_lex_state = 314},
  [12344] = {.lex_state = 58, .external_lex_state = 314},
  [12345] = {.lex_state = 58, .external_lex_state = 316},
  [12346] = {.lex_state = 58, .external_lex_state = 316},
  [12347] = {.lex_state = 58, .external_lex_state = 312},
  [12348] = {.lex_state = 58, .external_lex_state = 315},
  [12349] = {.lex_state = 58, .external_lex_state = 316},
  [12350] = {.lex_state = 58, .external_lex_state = 312},
  [12351] = {.lex_state = 61, .external_lex_state = 313},
  [12352] = {.lex_state = 58, .external_lex_state = 314},
  [12353] = {.lex_state = 61, .external_lex_state = 313},
  [12354] = {.lex_state = 58, .external_lex_state = 315},
  [12355] = {.lex_state = 58, .external_lex_state = 312},
  [12356] = {.lex_state = 58, .external_lex_state = 312},
  [12357] = {.lex_state = 58, .external_lex_state = 316},
  [12358] = {.lex_state = 58, .external_lex_state = 312},
  [12359] = {.lex_state = 58, .external_lex_state = 311},
  [12360] = {.lex_state = 58, .external_lex_state = 316},
  [12361] = {.lex_state = 57, .external_lex_state = 251},
  [12362] = {.lex_state = 58, .external_lex_state = 316},
  [12363] = {.lex_state = 58, .external_lex_state = 242},
  [12364] = {.lex_state = 58, .external_lex_state = 312},
  [12365] = {.lex_state = 58, .external_lex_state = 316},
  [12366] = {.lex_state = 58, .external_lex_state = 316},
  [12367] = {.lex_state = 58, .external_lex_state = 316},
  [12368] = {.lex_state = 58, .external_lex_state = 316},
  [12369] = {.lex_state = 58, .external_lex_state = 316},
  [12370] = {.lex_state = 58, .external_lex_state = 303},
  [12371] = {.lex_state = 55, .external_lex_state = 299},
  [12372] = {.lex_state = 58, .external_lex_state = 310},
  [12373] = {.lex_state = 55, .external_lex_state = 299},
  [12374] = {.lex_state = 58, .external_lex_state = 316},
  [12375] = {.lex_state = 58, .external_lex_state = 310},
  [12376] = {.lex_state = 58, .external_lex_state = 312},
  [12377] = {.lex_state = 58, .external_lex_state = 316},
  [12378] = {.lex_state = 58, .external_lex_state = 316},
  [12379] = {.lex_state = 58, .external_lex_state = 310},
  [12380] = {.lex_state = 58, .external_lex_state = 242},
  [12381] = {.lex_state = 58, .external_lex_state = 242},
  [12382] = {.lex_state = 58, .external_lex_state = 242},
  [12383] = {.lex_state = 57, .external_lex_state = 374},
  [12384] = {.lex_state = 58, .external_lex_state = 310},
  [12385] = {.lex_state = 58, .external_lex_state = 306},
  [12386] = {.lex_state = 58, .external_lex_state = 316},
  [12387] = {.lex_state = 58, .external_lex_state = 306},
  [12388] = {.lex_state = 58, .external_lex_state = 314},
  [12389] = {.lex_state = 58, .external_lex_state = 316},
  [12390] = {.lex_state = 58, .external_lex_state = 316},
  [12391] = {.lex_state = 58, .external_lex_state = 306},
  [12392] = {.lex_state = 58, .external_lex_state = 312},
  [12393] = {.lex_state = 58, .external_lex_state = 314},
  [12394] = {.lex_state = 58, .external_lex_state = 312},
  [12395] = {.lex_state = 58, .external_lex_state = 312},
  [12396] = {.lex_state = 55, .external_lex_state = 299},
  [12397] = {.lex_state = 58, .external_lex_state = 312},
  [12398] = {.lex_state = 58, .external_lex_state = 314},
  [12399] = {.lex_state = 58, .external_lex_state = 316},
  [12400] = {.lex_state = 58, .external_lex_state = 306},
  [12401] = {.lex_state = 58, .external_lex_state = 309},
  [12402] = {.lex_state = 58, .external_lex_state = 310},
  [12403] = {.lex_state = 58, .external_lex_state = 312},
  [12404] = {.lex_state = 58, .external_lex_state = 316},
  [12405] = {.lex_state = 58, .external_lex_state = 314},
  [12406] = {.lex_state = 58, .external_lex_state = 315},
  [12407] = {.lex_state = 58, .external_lex_state = 306},
  [12408] = {.lex_state = 58, .external_lex_state = 316},
  [12409] = {.lex_state = 58, .external_lex_state = 309},
  [12410] = {.lex_state = 58, .external_lex_state = 316},
  [12411] = {.lex_state = 58, .external_lex_state = 306},
  [12412] = {.lex_state = 58, .external_lex_state = 310},
  [12413] = {.lex_state = 58, .external_lex_state = 312},
  [12414] = {.lex_state = 58, .external_lex_state = 312},
  [12415] = {.lex_state = 61, .external_lex_state = 313},
  [12416] = {.lex_state = 58, .external_lex_state = 311},
  [12417] = {.lex_state = 58, .external_lex_state = 316},
  [12418] = {.lex_state = 58, .external_lex_state = 316},
  [12419] = {.lex_state = 58, .external_lex_state = 306},
  [12420] = {.lex_state = 58, .external_lex_state = 309},
  [12421] = {.lex_state = 58, .external_lex_state = 310},
  [12422] = {.lex_state = 58, .external_lex_state = 315},
  [12423] = {.lex_state = 58, .external_lex_state = 309},
  [12424] = {.lex_state = 58, .external_lex_state = 316},
  [12425] = {.lex_state = 58, .external_lex_state = 309},
  [12426] = {.lex_state = 58, .external_lex_state = 316},
  [12427] = {.lex_state = 58, .external_lex_state = 306},
  [12428] = {.lex_state = 58, .external_lex_state = 312},
  [12429] = {.lex_state = 58, .external_lex_state = 312},
  [12430] = {.lex_state = 58, .external_lex_state = 310},
  [12431] = {.lex_state = 58, .external_lex_state = 310},
  [12432] = {.lex_state = 58, .external_lex_state = 310},
  [12433] = {.lex_state = 58, .external_lex_state = 325},
  [12434] = {.lex_state = 58, .external_lex_state = 315},
  [12435] = {.lex_state = 58, .external_lex_state = 316},
  [12436] = {.lex_state = 58, .external_lex_state = 310},
  [12437] = {.lex_state = 55, .external_lex_state = 333},
  [12438] = {.lex_state = 58, .external_lex_state = 309},
  [12439] = {.lex_state = 58, .external_lex_state = 314},
  [12440] = {.lex_state = 58, .external_lex_state = 310},
  [12441] = {.lex_state = 58, .external_lex_state = 316},
  [12442] = {.lex_state = 58, .external_lex_state = 316},
  [12443] = {.lex_state = 61, .external_lex_state = 313},
  [12444] = {.lex_state = 58, .external_lex_state = 316},
  [12445] = {.lex_state = 58, .external_lex_state = 312},
  [12446] = {.lex_state = 58, .external_lex_state = 314},
  [12447] = {.lex_state = 58, .external_lex_state = 316},
  [12448] = {.lex_state = 61, .external_lex_state = 313},
  [12449] = {.lex_state = 58, .external_lex_state = 309},
  [12450] = {.lex_state = 61, .external_lex_state = 313},
  [12451] = {.lex_state = 58, .external_lex_state = 309},
  [12452] = {.lex_state = 58, .external_lex_state = 309},
  [12453] = {.lex_state = 58, .external_lex_state = 309},
  [12454] = {.lex_state = 0, .external_lex_state = 375},
  [12455] = {.lex_state = 58, .external_lex_state = 315},
  [12456] = {.lex_state = 61, .external_lex_state = 313},
  [12457] = {.lex_state = 61, .external_lex_state = 313},
  [12458] = {.lex_state = 61, .external_lex_state = 313},
  [12459] = {.lex_state = 58, .external_lex_state = 312},
  [12460] = {.lex_state = 58, .external_lex_state = 309},
  [12461] = {.lex_state = 58, .external_lex_state = 316},
  [12462] = {.lex_state = 58, .external_lex_state = 309},
  [12463] = {.lex_state = 58, .external_lex_state = 310},
  [12464] = {.lex_state = 58, .external_lex_state = 316},
  [12465] = {.lex_state = 55, .external_lex_state = 302},
  [12466] = {.lex_state = 58, .external_lex_state = 312},
  [12467] = {.lex_state = 58, .external_lex_state = 312},
  [12468] = {.lex_state = 58, .external_lex_state = 310},
  [12469] = {.lex_state = 58, .external_lex_state = 312},
  [12470] = {.lex_state = 58, .external_lex_state = 316},
  [12471] = {.lex_state = 58, .external_lex_state = 312},
  [12472] = {.lex_state = 58, .external_lex_state = 310},
  [12473] = {.lex_state = 58, .external_lex_state = 312},
  [12474] = {.lex_state = 58, .external_lex_state = 309},
  [12475] = {.lex_state = 58, .external_lex_state = 310},
  [12476] = {.lex_state = 58, .external_lex_state = 316},
  [12477] = {.lex_state = 58, .external_lex_state = 325},
  [12478] = {.lex_state = 58, .external_lex_state = 309},
  [12479] = {.lex_state = 58, .external_lex_state = 376},
  [12480] = {.lex_state = 58, .external_lex_state = 316},
  [12481] = {.lex_state = 58, .external_lex_state = 310},
  [12482] = {.lex_state = 58, .external_lex_state = 316},
  [12483] = {.lex_state = 58, .external_lex_state = 309},
  [12484] = {.lex_state = 58, .external_lex_state = 309},
  [12485] = {.lex_state = 58, .external_lex_state = 310},
  [12486] = {.lex_state = 58, .external_lex_state = 309},
  [12487] = {.lex_state = 58, .external_lex_state = 309},
  [12488] = {.lex_state = 58, .external_lex_state = 309},
  [12489] = {.lex_state = 58, .external_lex_state = 314},
  [12490] = {.lex_state = 61, .external_lex_state = 313},
  [12491] = {.lex_state = 61, .external_lex_state = 313},
  [12492] = {.lex_state = 58, .external_lex_state = 309},
  [12493] = {.lex_state = 58, .external_lex_state = 309},
  [12494] = {.lex_state = 58, .external_lex_state = 309},
  [12495] = {.lex_state = 58, .external_lex_state = 316},
  [12496] = {.lex_state = 58, .external_lex_state = 372},
  [12497] = {.lex_state = 58, .external_lex_state = 312},
  [12498] = {.lex_state = 58, .external_lex_state = 305},
  [12499] = {.lex_state = 58, .external_lex_state = 316},
  [12500] = {.lex_state = 58, .external_lex_state = 316},
  [12501] = {.lex_state = 55, .external_lex_state = 299},
  [12502] = {.lex_state = 58, .external_lex_state = 316},
  [12503] = {.lex_state = 58, .external_lex_state = 316},
  [12504] = {.lex_state = 58, .external_lex_state = 316},
  [12505] = {.lex_state = 58, .external_lex_state = 316},
  [12506] = {.lex_state = 61, .external_lex_state = 313},
  [12507] = {.lex_state = 61, .external_lex_state = 313},
  [12508] = {.lex_state = 61, .external_lex_state = 313},
  [12509] = {.lex_state = 58, .external_lex_state = 309},
  [12510] = {.lex_state = 58, .external_lex_state = 311},
  [12511] = {.lex_state = 58, .external_lex_state = 314},
  [12512] = {.lex_state = 58, .external_lex_state = 316},
  [12513] = {.lex_state = 58, .external_lex_state = 312},
  [12514] = {.lex_state = 58, .external_lex_state = 309},
  [12515] = {.lex_state = 58, .external_lex_state = 315},
  [12516] = {.lex_state = 58, .external_lex_state = 314},
  [12517] = {.lex_state = 58, .external_lex_state = 312},
  [12518] = {.lex_state = 58, .external_lex_state = 316},
  [12519] = {.lex_state = 61, .external_lex_state = 313},
  [12520] = {.lex_state = 58, .external_lex_state = 310},
  [12521] = {.lex_state = 58, .external_lex_state = 309},
  [12522] = {.lex_state = 61, .external_lex_state = 313},
  [12523] = {.lex_state = 58, .external_lex_state = 310},
  [12524] = {.lex_state = 58, .external_lex_state = 310},
  [12525] = {.lex_state = 61, .external_lex_state = 313},
  [12526] = {.lex_state = 58, .external_lex_state = 312},
  [12527] = {.lex_state = 61, .external_lex_state = 313},
  [12528] = {.lex_state = 58, .external_lex_state = 309},
  [12529] = {.lex_state = 58, .external_lex_state = 310},
  [12530] = {.lex_state = 58, .external_lex_state = 310},
  [12531] = {.lex_state = 58, .external_lex_state = 310},
  [12532] = {.lex_state = 58, .external_lex_state = 310},
  [12533] = {.lex_state = 58, .external_lex_state = 372},
  [12534] = {.lex_state = 61, .external_lex_state = 313},
  [12535] = {.lex_state = 57, .external_lex_state = 251},
  [12536] = {.lex_state = 58, .external_lex_state = 303},
  [12537] = {.lex_state = 58, .external_lex_state = 325},
  [12538] = {.lex_state = 58, .external_lex_state = 312},
  [12539] = {.lex_state = 58, .external_lex_state = 311},
  [12540] = {.lex_state = 61, .external_lex_state = 313},
  [12541] = {.lex_state = 61, .external_lex_state = 313},
  [12542] = {.lex_state = 58, .external_lex_state = 316},
  [12543] = {.lex_state = 58, .external_lex_state = 311},
  [12544] = {.lex_state = 61, .external_lex_state = 313},
  [12545] = {.lex_state = 58, .external_lex_state = 311},
  [12546] = {.lex_state = 61, .external_lex_state = 313},
  [12547] = {.lex_state = 58, .external_lex_state = 325},
  [12548] = {.lex_state = 61, .external_lex_state = 313},
  [12549] = {.lex_state = 55, .external_lex_state = 301},
  [12550] = {.lex_state = 61, .external_lex_state = 313},
  [12551] = {.lex_state = 58, .external_lex_state = 312},
  [12552] = {.lex_state = 58, .external_lex_state = 311},
  [12553] = {.lex_state = 58, .external_lex_state = 312},
  [12554] = {.lex_state = 58, .external_lex_state = 311},
  [12555] = {.lex_state = 58, .external_lex_state = 303},
  [12556] = {.lex_state = 58, .external_lex_state = 312},
  [12557] = {.lex_state = 58, .external_lex_state = 311},
  [12558] = {.lex_state = 58, .external_lex_state = 325},
  [12559] = {.lex_state = 58, .external_lex_state = 303},
  [12560] = {.lex_state = 58, .external_lex_state = 311},
  [12561] = {.lex_state = 61, .external_lex_state = 313},
  [12562] = {.lex_state = 58, .external_lex_state = 325},
  [12563] = {.lex_state = 58, .external_lex_state = 309},
  [12564] = {.lex_state = 58, .external_lex_state = 311},
  [12565] = {.lex_state = 58, .external_lex_state = 311},
  [12566] = {.lex_state = 58, .external_lex_state = 370},
  [12567] = {.lex_state = 55, .external_lex_state = 301},
  [12568] = {.lex_state = 58, .external_lex_state = 325},
  [12569] = {.lex_state = 58, .external_lex_state = 314},
  [12570] = {.lex_state = 55, .external_lex_state = 301},
  [12571] = {.lex_state = 58, .external_lex_state = 310},
  [12572] = {.lex_state = 58, .external_lex_state = 314},
  [12573] = {.lex_state = 58, .external_lex_state = 325},
  [12574] = {.lex_state = 58, .external_lex_state = 311},
  [12575] = {.lex_state = 55, .external_lex_state = 301},
  [12576] = {.lex_state = 58, .external_lex_state = 311},
  [12577] = {.lex_state = 58, .external_lex_state = 303},
  [12578] = {.lex_state = 61, .external_lex_state = 313},
  [12579] = {.lex_state = 58, .external_lex_state = 325},
  [12580] = {.lex_state = 58, .external_lex_state = 311},
  [12581] = {.lex_state = 58, .external_lex_state = 311},
  [12582] = {.lex_state = 58, .external_lex_state = 311},
  [12583] = {.lex_state = 58, .external_lex_state = 311},
  [12584] = {.lex_state = 58, .external_lex_state = 315},
  [12585] = {.lex_state = 58, .external_lex_state = 306},
  [12586] = {.lex_state = 58, .external_lex_state = 311},
  [12587] = {.lex_state = 58, .external_lex_state = 325},
  [12588] = {.lex_state = 58, .external_lex_state = 311},
  [12589] = {.lex_state = 55, .external_lex_state = 299},
  [12590] = {.lex_state = 58, .external_lex_state = 325},
  [12591] = {.lex_state = 58, .external_lex_state = 309},
  [12592] = {.lex_state = 58, .external_lex_state = 315},
  [12593] = {.lex_state = 61, .external_lex_state = 313},
  [12594] = {.lex_state = 58, .external_lex_state = 316},
  [12595] = {.lex_state = 55, .external_lex_state = 299},
  [12596] = {.lex_state = 58, .external_lex_state = 315},
  [12597] = {.lex_state = 61, .external_lex_state = 313},
  [12598] = {.lex_state = 58, .external_lex_state = 314},
  [12599] = {.lex_state = 0, .external_lex_state = 320},
  [12600] = {.lex_state = 55, .external_lex_state = 299},
  [12601] = {.lex_state = 58, .external_lex_state = 316},
  [12602] = {.lex_state = 58, .external_lex_state = 311},
  [12603] = {.lex_state = 58, .external_lex_state = 325},
  [12604] = {.lex_state = 61, .external_lex_state = 313},
  [12605] = {.lex_state = 58, .external_lex_state = 306},
  [12606] = {.lex_state = 58, .external_lex_state = 311},
  [12607] = {.lex_state = 58, .external_lex_state = 310},
  [12608] = {.lex_state = 58, .external_lex_state = 311},
  [12609] = {.lex_state = 58, .external_lex_state = 312},
  [12610] = {.lex_state = 58, .external_lex_state = 315},
  [12611] = {.lex_state = 58, .external_lex_state = 303},
  [12612] = {.lex_state = 58, .external_lex_state = 303},
  [12613] = {.lex_state = 58, .external_lex_state = 303},
  [12614] = {.lex_state = 58, .external_lex_state = 310},
  [12615] = {.lex_state = 58, .external_lex_state = 315},
  [12616] = {.lex_state = 61, .external_lex_state = 313},
  [12617] = {.lex_state = 58, .external_lex_state = 325},
  [12618] = {.lex_state = 58, .external_lex_state = 309},
  [12619] = {.lex_state = 61, .external_lex_state = 313},
  [12620] = {.lex_state = 58, .external_lex_state = 311},
  [12621] = {.lex_state = 55, .external_lex_state = 299},
  [12622] = {.lex_state = 58, .external_lex_state = 310},
  [12623] = {.lex_state = 55, .external_lex_state = 299},
  [12624] = {.lex_state = 58, .external_lex_state = 325},
  [12625] = {.lex_state = 58, .external_lex_state = 325},
  [12626] = {.lex_state = 61, .external_lex_state = 313},
  [12627] = {.lex_state = 57, .external_lex_state = 251},
  [12628] = {.lex_state = 61, .external_lex_state = 313},
  [12629] = {.lex_state = 58, .external_lex_state = 311},
  [12630] = {.lex_state = 58, .external_lex_state = 303},
  [12631] = {.lex_state = 58, .external_lex_state = 303},
  [12632] = {.lex_state = 58, .external_lex_state = 303},
  [12633] = {.lex_state = 61, .external_lex_state = 313},
  [12634] = {.lex_state = 58, .external_lex_state = 303},
  [12635] = {.lex_state = 58, .external_lex_state = 311},
  [12636] = {.lex_state = 58, .external_lex_state = 311},
  [12637] = {.lex_state = 58, .external_lex_state = 303},
  [12638] = {.lex_state = 58, .external_lex_state = 303},
  [12639] = {.lex_state = 58, .external_lex_state = 303},
  [12640] = {.lex_state = 58, .external_lex_state = 325},
  [12641] = {.lex_state = 58, .external_lex_state = 303},
  [12642] = {.lex_state = 61, .external_lex_state = 313},
  [12643] = {.lex_state = 58, .external_lex_state = 303},
  [12644] = {.lex_state = 58, .external_lex_state = 303},
  [12645] = {.lex_state = 61, .external_lex_state = 313},
  [12646] = {.lex_state = 58, .external_lex_state = 311},
  [12647] = {.lex_state = 58, .external_lex_state = 303},
  [12648] = {.lex_state = 58, .external_lex_state = 242},
  [12649] = {.lex_state = 58, .external_lex_state = 310},
  [12650] = {.lex_state = 58, .external_lex_state = 315},
  [12651] = {.lex_state = 58, .external_lex_state = 312},
  [12652] = {.lex_state = 58, .external_lex_state = 312},
  [12653] = {.lex_state = 55, .external_lex_state = 301},
  [12654] = {.lex_state = 58, .external_lex_state = 310},
  [12655] = {.lex_state = 61, .external_lex_state = 313},
  [12656] = {.lex_state = 58, .external_lex_state = 312},
  [12657] = {.lex_state = 58, .external_lex_state = 312},
  [12658] = {.lex_state = 61, .external_lex_state = 313},
  [12659] = {.lex_state = 58, .external_lex_state = 310},
  [12660] = {.lex_state = 55, .external_lex_state = 301},
  [12661] = {.lex_state = 55, .external_lex_state = 301},
  [12662] = {.lex_state = 58, .external_lex_state = 310},
  [12663] = {.lex_state = 61, .external_lex_state = 313},
  [12664] = {.lex_state = 58, .external_lex_state = 314},
  [12665] = {.lex_state = 58, .external_lex_state = 305},
  [12666] = {.lex_state = 58, .external_lex_state = 310},
  [12667] = {.lex_state = 61, .external_lex_state = 313},
  [12668] = {.lex_state = 58, .external_lex_state = 310},
  [12669] = {.lex_state = 58, .external_lex_state = 312},
  [12670] = {.lex_state = 58, .external_lex_state = 310},
  [12671] = {.lex_state = 58, .external_lex_state = 310},
  [12672] = {.lex_state = 58, .external_lex_state = 312},
  [12673] = {.lex_state = 58, .external_lex_state = 310},
  [12674] = {.lex_state = 61, .external_lex_state = 313},
  [12675] = {.lex_state = 0, .external_lex_state = 375},
  [12676] = {.lex_state = 61, .external_lex_state = 313},
  [12677] = {.lex_state = 61, .external_lex_state = 313},
  [12678] = {.lex_state = 58, .external_lex_state = 310},
  [12679] = {.lex_state = 58, .external_lex_state = 312},
  [12680] = {.lex_state = 61, .external_lex_state = 313},
  [12681] = {.lex_state = 61, .external_lex_state = 313},
  [12682] = {.lex_state = 61, .external_lex_state = 313},
  [12683] = {.lex_state = 61, .external_lex_state = 313},
  [12684] = {.lex_state = 58, .external_lex_state = 311},
  [12685] = {.lex_state = 61, .external_lex_state = 313},
  [12686] = {.lex_state = 58, .external_lex_state = 310},
  [12687] = {.lex_state = 61, .external_lex_state = 313},
  [12688] = {.lex_state = 58, .external_lex_state = 311},
  [12689] = {.lex_state = 58, .external_lex_state = 311},
  [12690] = {.lex_state = 58, .external_lex_state = 312},
  [12691] = {.lex_state = 58, .external_lex_state = 312},
  [12692] = {.lex_state = 55, .external_lex_state = 301},
  [12693] = {.lex_state = 61, .external_lex_state = 313},
  [12694] = {.lex_state = 61, .external_lex_state = 313},
  [12695] = {.lex_state = 61, .external_lex_state = 313},
  [12696] = {.lex_state = 58, .external_lex_state = 311},
  [12697] = {.lex_state = 58, .external_lex_state = 370},
  [12698] = {.lex_state = 58, .external_lex_state = 251},
  [12699] = {.lex_state = 58, .external_lex_state = 312},
  [12700] = {.lex_state = 55, .external_lex_state = 301},
  [12701] = {.lex_state = 61, .external_lex_state = 313},
  [12702] = {.lex_state = 58, .external_lex_state = 312},
  [12703] = {.lex_state = 55, .external_lex_state = 301},
  [12704] = {.lex_state = 61, .external_lex_state = 313},
  [12705] = {.lex_state = 58, .external_lex_state = 312},
  [12706] = {.lex_state = 58, .external_lex_state = 312},
  [12707] = {.lex_state = 58, .external_lex_state = 251},
  [12708] = {.lex_state = 55, .external_lex_state = 301},
  [12709] = {.lex_state = 58, .external_lex_state = 314},
  [12710] = {.lex_state = 61, .external_lex_state = 313},
  [12711] = {.lex_state = 58, .external_lex_state = 251},
  [12712] = {.lex_state = 58, .external_lex_state = 251},
  [12713] = {.lex_state = 55, .external_lex_state = 299},
  [12714] = {.lex_state = 61, .external_lex_state = 313},
  [12715] = {.lex_state = 55, .external_lex_state = 301},
  [12716] = {.lex_state = 58, .external_lex_state = 311},
  [12717] = {.lex_state = 58, .external_lex_state = 303},
  [12718] = {.lex_state = 55, .external_lex_state = 301},
  [12719] = {.lex_state = 58, .external_lex_state = 314},
  [12720] = {.lex_state = 58, .external_lex_state = 312},
  [12721] = {.lex_state = 58, .external_lex_state = 311},
  [12722] = {.lex_state = 58, .external_lex_state = 315},
  [12723] = {.lex_state = 58, .external_lex_state = 315},
  [12724] = {.lex_state = 58, .external_lex_state = 315},
  [12725] = {.lex_state = 58, .external_lex_state = 312},
  [12726] = {.lex_state = 58, .external_lex_state = 312},
  [12727] = {.lex_state = 61, .external_lex_state = 313},
  [12728] = {.lex_state = 58, .external_lex_state = 370},
  [12729] = {.lex_state = 55, .external_lex_state = 299},
  [12730] = {.lex_state = 58, .external_lex_state = 312},
  [12731] = {.lex_state = 58, .external_lex_state = 315},
  [12732] = {.lex_state = 58, .external_lex_state = 312},
  [12733] = {.lex_state = 58, .external_lex_state = 315},
  [12734] = {.lex_state = 61, .external_lex_state = 313},
  [12735] = {.lex_state = 55, .external_lex_state = 299},
  [12736] = {.lex_state = 58, .external_lex_state = 315},
  [12737] = {.lex_state = 58, .external_lex_state = 312},
  [12738] = {.lex_state = 58, .external_lex_state = 315},
  [12739] = {.lex_state = 55, .external_lex_state = 301},
  [12740] = {.lex_state = 58, .external_lex_state = 311},
  [12741] = {.lex_state = 58, .external_lex_state = 370},
  [12742] = {.lex_state = 58, .external_lex_state = 312},
  [12743] = {.lex_state = 58, .external_lex_state = 315},
  [12744] = {.lex_state = 55, .external_lex_state = 301},
  [12745] = {.lex_state = 55, .external_lex_state = 301},
  [12746] = {.lex_state = 58, .external_lex_state = 315},
  [12747] = {.lex_state = 55, .external_lex_state = 301},
  [12748] = {.lex_state = 58, .external_lex_state = 312},
  [12749] = {.lex_state = 58, .external_lex_state = 312},
  [12750] = {.lex_state = 58, .external_lex_state = 325},
  [12751] = {.lex_state = 58, .external_lex_state = 315},
  [12752] = {.lex_state = 58, .external_lex_state = 251},
  [12753] = {.lex_state = 61, .external_lex_state = 313},
  [12754] = {.lex_state = 58, .external_lex_state = 315},
  [12755] = {.lex_state = 58, .external_lex_state = 315},
  [12756] = {.lex_state = 58, .external_lex_state = 315},
  [12757] = {.lex_state = 58, .external_lex_state = 315},
  [12758] = {.lex_state = 58, .external_lex_state = 312},
  [12759] = {.lex_state = 55, .external_lex_state = 301},
  [12760] = {.lex_state = 55, .external_lex_state = 301},
  [12761] = {.lex_state = 58, .external_lex_state = 311},
  [12762] = {.lex_state = 58, .external_lex_state = 311},
  [12763] = {.lex_state = 58, .external_lex_state = 311},
  [12764] = {.lex_state = 58, .external_lex_state = 312},
  [12765] = {.lex_state = 57, .external_lex_state = 251},
  [12766] = {.lex_state = 58, .external_lex_state = 315},
  [12767] = {.lex_state = 55, .external_lex_state = 299},
  [12768] = {.lex_state = 55, .external_lex_state = 299},
  [12769] = {.lex_state = 58, .external_lex_state = 315},
  [12770] = {.lex_state = 55, .external_lex_state = 299},
  [12771] = {.lex_state = 58, .external_lex_state = 372},
  [12772] = {.lex_state = 58, .external_lex_state = 310},
  [12773] = {.lex_state = 55, .external_lex_state = 299},
  [12774] = {.lex_state = 61, .external_lex_state = 313},
  [12775] = {.lex_state = 58, .external_lex_state = 242},
  [12776] = {.lex_state = 58, .external_lex_state = 321},
  [12777] = {.lex_state = 55, .external_lex_state = 302},
  [12778] = {.lex_state = 0, .external_lex_state = 312},
  [12779] = {.lex_state = 58, .external_lex_state = 315},
  [12780] = {.lex_state = 58, .external_lex_state = 321},
  [12781] = {.lex_state = 57, .external_lex_state = 200},
  [12782] = {.lex_state = 58, .external_lex_state = 309},
  [12783] = {.lex_state = 58, .external_lex_state = 323},
  [12784] = {.lex_state = 55, .external_lex_state = 302},
  [12785] = {.lex_state = 58, .external_lex_state = 320},
  [12786] = {.lex_state = 58, .external_lex_state = 320},
  [12787] = {.lex_state = 55, .external_lex_state = 377},
  [12788] = {.lex_state = 58, .external_lex_state = 315},
  [12789] = {.lex_state = 55, .external_lex_state = 301},
  [12790] = {.lex_state = 58, .external_lex_state = 309},
  [12791] = {.lex_state = 0, .external_lex_state = 316},
  [12792] = {.lex_state = 0, .external_lex_state = 251},
  [12793] = {.lex_state = 58, .external_lex_state = 321},
  [12794] = {.lex_state = 58, .external_lex_state = 321},
  [12795] = {.lex_state = 58, .external_lex_state = 321},
  [12796] = {.lex_state = 58, .external_lex_state = 321},
  [12797] = {.lex_state = 55, .external_lex_state = 367},
  [12798] = {.lex_state = 58, .external_lex_state = 323},
  [12799] = {.lex_state = 58, .external_lex_state = 310},
  [12800] = {.lex_state = 0, .external_lex_state = 312},
  [12801] = {.lex_state = 58, .external_lex_state = 320},
  [12802] = {.lex_state = 0, .external_lex_state = 316},
  [12803] = {.lex_state = 58, .external_lex_state = 321},
  [12804] = {.lex_state = 58, .external_lex_state = 323},
  [12805] = {.lex_state = 58, .external_lex_state = 306},
  [12806] = {.lex_state = 58, .external_lex_state = 303},
  [12807] = {.lex_state = 0, .external_lex_state = 251},
  [12808] = {.lex_state = 58, .external_lex_state = 323},
  [12809] = {.lex_state = 58, .external_lex_state = 306},
  [12810] = {.lex_state = 58, .external_lex_state = 321},
  [12811] = {.lex_state = 58, .external_lex_state = 323},
  [12812] = {.lex_state = 58, .external_lex_state = 315},
  [12813] = {.lex_state = 0, .external_lex_state = 251},
  [12814] = {.lex_state = 58, .external_lex_state = 323},
  [12815] = {.lex_state = 58, .external_lex_state = 315},
  [12816] = {.lex_state = 58, .external_lex_state = 311},
  [12817] = {.lex_state = 58, .external_lex_state = 323},
  [12818] = {.lex_state = 58, .external_lex_state = 309},
  [12819] = {.lex_state = 58, .external_lex_state = 311},
  [12820] = {.lex_state = 58, .external_lex_state = 320},
  [12821] = {.lex_state = 58, .external_lex_state = 323},
  [12822] = {.lex_state = 58, .external_lex_state = 311},
  [12823] = {.lex_state = 0, .external_lex_state = 316},
  [12824] = {.lex_state = 58, .external_lex_state = 305},
  [12825] = {.lex_state = 58, .external_lex_state = 323},
  [12826] = {.lex_state = 58, .external_lex_state = 310},
  [12827] = {.lex_state = 0, .external_lex_state = 316},
  [12828] = {.lex_state = 58, .external_lex_state = 311},
  [12829] = {.lex_state = 58, .external_lex_state = 323},
  [12830] = {.lex_state = 0, .external_lex_state = 251},
  [12831] = {.lex_state = 58, .external_lex_state = 321},
  [12832] = {.lex_state = 58, .external_lex_state = 323},
  [12833] = {.lex_state = 58, .external_lex_state = 321},
  [12834] = {.lex_state = 58, .external_lex_state = 305},
  [12835] = {.lex_state = 58, .external_lex_state = 311},
  [12836] = {.lex_state = 0, .external_lex_state = 316},
  [12837] = {.lex_state = 0, .external_lex_state = 251},
  [12838] = {.lex_state = 58, .external_lex_state = 310},
  [12839] = {.lex_state = 58, .external_lex_state = 309},
  [12840] = {.lex_state = 58, .external_lex_state = 305},
  [12841] = {.lex_state = 58, .external_lex_state = 320},
  [12842] = {.lex_state = 58, .external_lex_state = 323},
  [12843] = {.lex_state = 58, .external_lex_state = 305},
  [12844] = {.lex_state = 58, .external_lex_state = 309},
  [12845] = {.lex_state = 58, .external_lex_state = 305},
  [12846] = {.lex_state = 58, .external_lex_state = 305},
  [12847] = {.lex_state = 58, .external_lex_state = 323},
  [12848] = {.lex_state = 0, .external_lex_state = 316},
  [12849] = {.lex_state = 58, .external_lex_state = 323},
  [12850] = {.lex_state = 58, .external_lex_state = 323},
  [12851] = {.lex_state = 55, .external_lex_state = 302},
  [12852] = {.lex_state = 0, .external_lex_state = 316},
  [12853] = {.lex_state = 58, .external_lex_state = 321},
  [12854] = {.lex_state = 58, .external_lex_state = 315},
  [12855] = {.lex_state = 58, .external_lex_state = 320},
  [12856] = {.lex_state = 58, .external_lex_state = 315},
  [12857] = {.lex_state = 58, .external_lex_state = 320},
  [12858] = {.lex_state = 58, .external_lex_state = 310},
  [12859] = {.lex_state = 58, .external_lex_state = 323},
  [12860] = {.lex_state = 58, .external_lex_state = 320},
  [12861] = {.lex_state = 55, .external_lex_state = 301},
  [12862] = {.lex_state = 58, .external_lex_state = 310},
  [12863] = {.lex_state = 55, .external_lex_state = 301},
  [12864] = {.lex_state = 55, .external_lex_state = 367},
  [12865] = {.lex_state = 58, .external_lex_state = 320},
  [12866] = {.lex_state = 58, .external_lex_state = 320},
  [12867] = {.lex_state = 58, .external_lex_state = 306},
  [12868] = {.lex_state = 55, .external_lex_state = 301},
  [12869] = {.lex_state = 58, .external_lex_state = 320},
  [12870] = {.lex_state = 0, .external_lex_state = 251},
  [12871] = {.lex_state = 0, .external_lex_state = 316},
  [12872] = {.lex_state = 0, .external_lex_state = 316},
  [12873] = {.lex_state = 0, .external_lex_state = 251},
  [12874] = {.lex_state = 58, .external_lex_state = 320},
  [12875] = {.lex_state = 58, .external_lex_state = 320},
  [12876] = {.lex_state = 58, .external_lex_state = 309},
  [12877] = {.lex_state = 0, .external_lex_state = 251},
  [12878] = {.lex_state = 58, .external_lex_state = 321},
  [12879] = {.lex_state = 0, .external_lex_state = 378},
  [12880] = {.lex_state = 0, .external_lex_state = 316},
  [12881] = {.lex_state = 58, .external_lex_state = 306},
  [12882] = {.lex_state = 58, .external_lex_state = 303},
  [12883] = {.lex_state = 58, .external_lex_state = 321},
  [12884] = {.lex_state = 0, .external_lex_state = 251},
  [12885] = {.lex_state = 58, .external_lex_state = 323},
  [12886] = {.lex_state = 58, .external_lex_state = 323},
  [12887] = {.lex_state = 0, .external_lex_state = 316},
  [12888] = {.lex_state = 55, .external_lex_state = 302},
  [12889] = {.lex_state = 58, .external_lex_state = 310},
  [12890] = {.lex_state = 55, .external_lex_state = 313},
  [12891] = {.lex_state = 55, .external_lex_state = 313},
  [12892] = {.lex_state = 55, .external_lex_state = 313},
  [12893] = {.lex_state = 58, .external_lex_state = 306},
  [12894] = {.lex_state = 58, .external_lex_state = 315},
  [12895] = {.lex_state = 0, .external_lex_state = 251},
  [12896] = {.lex_state = 0, .external_lex_state = 251},
  [12897] = {.lex_state = 58, .external_lex_state = 305},
  [12898] = {.lex_state = 57, .external_lex_state = 200},
  [12899] = {.lex_state = 0, .external_lex_state = 379},
  [12900] = {.lex_state = 55, .external_lex_state = 313},
  [12901] = {.lex_state = 0, .external_lex_state = 251},
  [12902] = {.lex_state = 58, .external_lex_state = 314},
  [12903] = {.lex_state = 58, .external_lex_state = 314},
  [12904] = {.lex_state = 58, .external_lex_state = 321},
  [12905] = {.lex_state = 58, .external_lex_state = 321},
  [12906] = {.lex_state = 58, .external_lex_state = 311},
  [12907] = {.lex_state = 0, .external_lex_state = 312},
  [12908] = {.lex_state = 58, .external_lex_state = 321},
  [12909] = {.lex_state = 58, .external_lex_state = 306},
  [12910] = {.lex_state = 58, .external_lex_state = 309},
  [12911] = {.lex_state = 58, .external_lex_state = 315},
  [12912] = {.lex_state = 55, .external_lex_state = 302},
  [12913] = {.lex_state = 0, .external_lex_state = 251},
  [12914] = {.lex_state = 0, .external_lex_state = 312},
  [12915] = {.lex_state = 58, .external_lex_state = 309},
  [12916] = {.lex_state = 58, .external_lex_state = 321},
  [12917] = {.lex_state = 0, .external_lex_state = 348},
  [12918] = {.lex_state = 0, .external_lex_state = 251},
  [12919] = {.lex_state = 58, .external_lex_state = 309},
  [12920] = {.lex_state = 0, .external_lex_state = 251},
  [12921] = {.lex_state = 58, .external_lex_state = 323},
  [12922] = {.lex_state = 0, .external_lex_state = 251},
  [12923] = {.lex_state = 0, .external_lex_state = 316},
  [12924] = {.lex_state = 0, .external_lex_state = 251},
  [12925] = {.lex_state = 58, .external_lex_state = 303},
  [12926] = {.lex_state = 58, .external_lex_state = 321},
  [12927] = {.lex_state = 58, .external_lex_state = 323},
  [12928] = {.lex_state = 58, .external_lex_state = 323},
  [12929] = {.lex_state = 0, .external_lex_state = 291},
  [12930] = {.lex_state = 58, .external_lex_state = 311},
  [12931] = {.lex_state = 58, .external_lex_state = 314},
  [12932] = {.lex_state = 0, .external_lex_state = 316},
  [12933] = {.lex_state = 0, .external_lex_state = 312},
  [12934] = {.lex_state = 0, .external_lex_state = 312},
  [12935] = {.lex_state = 0, .external_lex_state = 312},
  [12936] = {.lex_state = 58, .external_lex_state = 321},
  [12937] = {.lex_state = 58, .external_lex_state = 323},
  [12938] = {.lex_state = 58, .external_lex_state = 323},
  [12939] = {.lex_state = 58, .external_lex_state = 310},
  [12940] = {.lex_state = 58, .external_lex_state = 323},
  [12941] = {.lex_state = 58, .external_lex_state = 321},
  [12942] = {.lex_state = 0, .external_lex_state = 316},
  [12943] = {.lex_state = 58, .external_lex_state = 309},
  [12944] = {.lex_state = 58, .external_lex_state = 320},
  [12945] = {.lex_state = 58, .external_lex_state = 309},
  [12946] = {.lex_state = 58, .external_lex_state = 321},
  [12947] = {.lex_state = 57, .external_lex_state = 339},
  [12948] = {.lex_state = 58, .external_lex_state = 321},
  [12949] = {.lex_state = 58, .external_lex_state = 323},
  [12950] = {.lex_state = 58, .external_lex_state = 321},
  [12951] = {.lex_state = 58, .external_lex_state = 323},
  [12952] = {.lex_state = 58, .external_lex_state = 309},
  [12953] = {.lex_state = 58, .external_lex_state = 323},
  [12954] = {.lex_state = 58, .external_lex_state = 311},
  [12955] = {.lex_state = 58, .external_lex_state = 321},
  [12956] = {.lex_state = 58, .external_lex_state = 305},
  [12957] = {.lex_state = 58, .external_lex_state = 305},
  [12958] = {.lex_state = 58, .external_lex_state = 323},
  [12959] = {.lex_state = 58, .external_lex_state = 323},
  [12960] = {.lex_state = 58, .external_lex_state = 305},
  [12961] = {.lex_state = 0, .external_lex_state = 312},
  [12962] = {.lex_state = 58, .external_lex_state = 309},
  [12963] = {.lex_state = 58, .external_lex_state = 321},
  [12964] = {.lex_state = 58, .external_lex_state = 310},
  [12965] = {.lex_state = 58, .external_lex_state = 311},
  [12966] = {.lex_state = 58, .external_lex_state = 323},
  [12967] = {.lex_state = 58, .external_lex_state = 310},
  [12968] = {.lex_state = 58, .external_lex_state = 323},
  [12969] = {.lex_state = 58, .external_lex_state = 321},
  [12970] = {.lex_state = 0, .external_lex_state = 312},
  [12971] = {.lex_state = 58, .external_lex_state = 306},
  [12972] = {.lex_state = 58, .external_lex_state = 320},
  [12973] = {.lex_state = 58, .external_lex_state = 310},
  [12974] = {.lex_state = 58, .external_lex_state = 320},
  [12975] = {.lex_state = 58, .external_lex_state = 323},
  [12976] = {.lex_state = 58, .external_lex_state = 321},
  [12977] = {.lex_state = 58, .external_lex_state = 323},
  [12978] = {.lex_state = 0, .external_lex_state = 251},
  [12979] = {.lex_state = 58, .external_lex_state = 323},
  [12980] = {.lex_state = 58, .external_lex_state = 321},
  [12981] = {.lex_state = 58, .external_lex_state = 310},
  [12982] = {.lex_state = 58, .external_lex_state = 320},
  [12983] = {.lex_state = 0, .external_lex_state = 251},
  [12984] = {.lex_state = 57, .external_lex_state = 200},
  [12985] = {.lex_state = 58, .external_lex_state = 323},
  [12986] = {.lex_state = 55, .external_lex_state = 301},
  [12987] = {.lex_state = 55, .external_lex_state = 313},
  [12988] = {.lex_state = 58, .external_lex_state = 320},
  [12989] = {.lex_state = 58, .external_lex_state = 321},
  [12990] = {.lex_state = 55, .external_lex_state = 313},
  [12991] = {.lex_state = 58, .external_lex_state = 310},
  [12992] = {.lex_state = 0, .external_lex_state = 380},
  [12993] = {.lex_state = 55, .external_lex_state = 302},
  [12994] = {.lex_state = 58, .external_lex_state = 321},
  [12995] = {.lex_state = 57, .external_lex_state = 350},
  [12996] = {.lex_state = 58, .external_lex_state = 306},
  [12997] = {.lex_state = 58, .external_lex_state = 306},
  [12998] = {.lex_state = 0, .external_lex_state = 312},
  [12999] = {.lex_state = 58, .external_lex_state = 320},
  [13000] = {.lex_state = 58, .external_lex_state = 321},
  [13001] = {.lex_state = 58, .external_lex_state = 321},
  [13002] = {.lex_state = 58, .external_lex_state = 320},
  [13003] = {.lex_state = 58, .external_lex_state = 323},
  [13004] = {.lex_state = 58, .external_lex_state = 303},
  [13005] = {.lex_state = 0, .external_lex_state = 251},
  [13006] = {.lex_state = 58, .external_lex_state = 323},
  [13007] = {.lex_state = 58, .external_lex_state = 306},
  [13008] = {.lex_state = 58, .external_lex_state = 306},
  [13009] = {.lex_state = 58, .external_lex_state = 321},
  [13010] = {.lex_state = 58, .external_lex_state = 315},
  [13011] = {.lex_state = 58, .external_lex_state = 321},
  [13012] = {.lex_state = 55, .external_lex_state = 302},
  [13013] = {.lex_state = 58, .external_lex_state = 309},
  [13014] = {.lex_state = 58, .external_lex_state = 306},
  [13015] = {.lex_state = 58, .external_lex_state = 309},
  [13016] = {.lex_state = 58, .external_lex_state = 306},
  [13017] = {.lex_state = 58, .external_lex_state = 303},
  [13018] = {.lex_state = 58, .external_lex_state = 309},
  [13019] = {.lex_state = 58, .external_lex_state = 310},
  [13020] = {.lex_state = 58, .external_lex_state = 321},
  [13021] = {.lex_state = 0, .external_lex_state = 316},
  [13022] = {.lex_state = 0, .external_lex_state = 312},
  [13023] = {.lex_state = 58, .external_lex_state = 321},
  [13024] = {.lex_state = 58, .external_lex_state = 314},
  [13025] = {.lex_state = 58, .external_lex_state = 323},
  [13026] = {.lex_state = 58, .external_lex_state = 321},
  [13027] = {.lex_state = 58, .external_lex_state = 309},
  [13028] = {.lex_state = 58, .external_lex_state = 320},
  [13029] = {.lex_state = 58, .external_lex_state = 311},
  [13030] = {.lex_state = 58, .external_lex_state = 310},
  [13031] = {.lex_state = 0, .external_lex_state = 378},
  [13032] = {.lex_state = 58, .external_lex_state = 310},
  [13033] = {.lex_state = 58, .external_lex_state = 321},
  [13034] = {.lex_state = 58, .external_lex_state = 323},
  [13035] = {.lex_state = 0, .external_lex_state = 312},
  [13036] = {.lex_state = 58, .external_lex_state = 309},
  [13037] = {.lex_state = 58, .external_lex_state = 321},
  [13038] = {.lex_state = 0, .external_lex_state = 251},
  [13039] = {.lex_state = 57, .external_lex_state = 200},
  [13040] = {.lex_state = 0, .external_lex_state = 380},
  [13041] = {.lex_state = 58, .external_lex_state = 305},
  [13042] = {.lex_state = 55, .external_lex_state = 313},
  [13043] = {.lex_state = 55, .external_lex_state = 313},
  [13044] = {.lex_state = 0, .external_lex_state = 251},
  [13045] = {.lex_state = 55, .external_lex_state = 313},
  [13046] = {.lex_state = 58, .external_lex_state = 305},
  [13047] = {.lex_state = 58, .external_lex_state = 306},
  [13048] = {.lex_state = 0, .external_lex_state = 312},
  [13049] = {.lex_state = 58, .external_lex_state = 315},
  [13050] = {.lex_state = 55, .external_lex_state = 313},
  [13051] = {.lex_state = 58, .external_lex_state = 321},
  [13052] = {.lex_state = 55, .external_lex_state = 302},
  [13053] = {.lex_state = 57, .external_lex_state = 339},
  [13054] = {.lex_state = 58, .external_lex_state = 321},
  [13055] = {.lex_state = 58, .external_lex_state = 323},
  [13056] = {.lex_state = 58, .external_lex_state = 323},
  [13057] = {.lex_state = 58, .external_lex_state = 323},
  [13058] = {.lex_state = 58, .external_lex_state = 315},
  [13059] = {.lex_state = 58, .external_lex_state = 321},
  [13060] = {.lex_state = 58, .external_lex_state = 311},
  [13061] = {.lex_state = 0, .external_lex_state = 312},
  [13062] = {.lex_state = 58, .external_lex_state = 323},
  [13063] = {.lex_state = 0, .external_lex_state = 312},
  [13064] = {.lex_state = 58, .external_lex_state = 305},
  [13065] = {.lex_state = 58, .external_lex_state = 323},
  [13066] = {.lex_state = 58, .external_lex_state = 323},
  [13067] = {.lex_state = 58, .external_lex_state = 305},
  [13068] = {.lex_state = 58, .external_lex_state = 321},
  [13069] = {.lex_state = 58, .external_lex_state = 303},
  [13070] = {.lex_state = 58, .external_lex_state = 381},
  [13071] = {.lex_state = 58, .external_lex_state = 315},
  [13072] = {.lex_state = 0, .external_lex_state = 378},
  [13073] = {.lex_state = 58, .external_lex_state = 310},
  [13074] = {.lex_state = 55, .external_lex_state = 302},
  [13075] = {.lex_state = 57, .external_lex_state = 350},
  [13076] = {.lex_state = 58, .external_lex_state = 305},
  [13077] = {.lex_state = 0, .external_lex_state = 316},
  [13078] = {.lex_state = 58, .external_lex_state = 311},
  [13079] = {.lex_state = 58, .external_lex_state = 311},
  [13080] = {.lex_state = 58, .external_lex_state = 321},
  [13081] = {.lex_state = 58, .external_lex_state = 314},
  [13082] = {.lex_state = 0, .external_lex_state = 251},
  [13083] = {.lex_state = 58, .external_lex_state = 314},
  [13084] = {.lex_state = 0, .external_lex_state = 316},
  [13085] = {.lex_state = 0, .external_lex_state = 251},
  [13086] = {.lex_state = 58, .external_lex_state = 382},
  [13087] = {.lex_state = 58, .external_lex_state = 314},
  [13088] = {.lex_state = 58, .external_lex_state = 321},
  [13089] = {.lex_state = 55, .external_lex_state = 302},
  [13090] = {.lex_state = 55, .external_lex_state = 302},
  [13091] = {.lex_state = 55, .external_lex_state = 301},
  [13092] = {.lex_state = 58, .external_lex_state = 303},
  [13093] = {.lex_state = 55, .external_lex_state = 301},
  [13094] = {.lex_state = 58, .external_lex_state = 314},
  [13095] = {.lex_state = 55, .external_lex_state = 301},
  [13096] = {.lex_state = 0, .external_lex_state = 251},
  [13097] = {.lex_state = 0, .external_lex_state = 251},
  [13098] = {.lex_state = 58, .external_lex_state = 314},
  [13099] = {.lex_state = 57, .external_lex_state = 350},
  [13100] = {.lex_state = 58, .external_lex_state = 314},
  [13101] = {.lex_state = 58, .external_lex_state = 323},
  [13102] = {.lex_state = 58, .external_lex_state = 306},
  [13103] = {.lex_state = 55, .external_lex_state = 313},
  [13104] = {.lex_state = 55, .external_lex_state = 301},
  [13105] = {.lex_state = 58, .external_lex_state = 383},
  [13106] = {.lex_state = 58, .external_lex_state = 303},
  [13107] = {.lex_state = 58, .external_lex_state = 314},
  [13108] = {.lex_state = 55, .external_lex_state = 302},
  [13109] = {.lex_state = 58, .external_lex_state = 314},
  [13110] = {.lex_state = 58, .external_lex_state = 311},
  [13111] = {.lex_state = 58, .external_lex_state = 310},
  [13112] = {.lex_state = 58, .external_lex_state = 314},
  [13113] = {.lex_state = 58, .external_lex_state = 310},
  [13114] = {.lex_state = 58, .external_lex_state = 321},
  [13115] = {.lex_state = 58, .external_lex_state = 320},
  [13116] = {.lex_state = 0, .external_lex_state = 251},
  [13117] = {.lex_state = 58, .external_lex_state = 321},
  [13118] = {.lex_state = 58, .external_lex_state = 315},
  [13119] = {.lex_state = 58, .external_lex_state = 310},
  [13120] = {.lex_state = 58, .external_lex_state = 321},
  [13121] = {.lex_state = 58, .external_lex_state = 314},
  [13122] = {.lex_state = 58, .external_lex_state = 323},
  [13123] = {.lex_state = 58, .external_lex_state = 323},
  [13124] = {.lex_state = 58, .external_lex_state = 314},
  [13125] = {.lex_state = 57, .external_lex_state = 200},
  [13126] = {.lex_state = 0, .external_lex_state = 251},
  [13127] = {.lex_state = 58, .external_lex_state = 311},
  [13128] = {.lex_state = 58, .external_lex_state = 314},
  [13129] = {.lex_state = 58, .external_lex_state = 320},
  [13130] = {.lex_state = 58, .external_lex_state = 303},
  [13131] = {.lex_state = 58, .external_lex_state = 303},
  [13132] = {.lex_state = 58, .external_lex_state = 303},
  [13133] = {.lex_state = 55, .external_lex_state = 313},
  [13134] = {.lex_state = 58, .external_lex_state = 320},
  [13135] = {.lex_state = 0, .external_lex_state = 384},
  [13136] = {.lex_state = 0, .external_lex_state = 251},
  [13137] = {.lex_state = 58, .external_lex_state = 305},
  [13138] = {.lex_state = 58, .external_lex_state = 320},
  [13139] = {.lex_state = 0, .external_lex_state = 312},
  [13140] = {.lex_state = 58, .external_lex_state = 320},
  [13141] = {.lex_state = 58, .external_lex_state = 323},
  [13142] = {.lex_state = 58, .external_lex_state = 320},
  [13143] = {.lex_state = 58, .external_lex_state = 320},
  [13144] = {.lex_state = 55, .external_lex_state = 302},
  [13145] = {.lex_state = 55, .external_lex_state = 301},
  [13146] = {.lex_state = 58, .external_lex_state = 323},
  [13147] = {.lex_state = 58, .external_lex_state = 321},
  [13148] = {.lex_state = 58, .external_lex_state = 321},
  [13149] = {.lex_state = 0, .external_lex_state = 251},
  [13150] = {.lex_state = 58, .external_lex_state = 314},
  [13151] = {.lex_state = 58, .external_lex_state = 321},
  [13152] = {.lex_state = 0, .external_lex_state = 251},
  [13153] = {.lex_state = 57, .external_lex_state = 200},
  [13154] = {.lex_state = 58, .external_lex_state = 321},
  [13155] = {.lex_state = 58, .external_lex_state = 314},
  [13156] = {.lex_state = 57, .external_lex_state = 339},
  [13157] = {.lex_state = 58, .external_lex_state = 321},
  [13158] = {.lex_state = 55, .external_lex_state = 313},
  [13159] = {.lex_state = 55, .external_lex_state = 313},
  [13160] = {.lex_state = 0, .external_lex_state = 316},
  [13161] = {.lex_state = 58, .external_lex_state = 320},
  [13162] = {.lex_state = 58, .external_lex_state = 321},
  [13163] = {.lex_state = 0, .external_lex_state = 251},
  [13164] = {.lex_state = 55, .external_lex_state = 302},
  [13165] = {.lex_state = 55, .external_lex_state = 302},
  [13166] = {.lex_state = 58, .external_lex_state = 311},
  [13167] = {.lex_state = 0, .external_lex_state = 251},
  [13168] = {.lex_state = 58, .external_lex_state = 314},
  [13169] = {.lex_state = 58, .external_lex_state = 321},
  [13170] = {.lex_state = 58, .external_lex_state = 315},
  [13171] = {.lex_state = 0, .external_lex_state = 312},
  [13172] = {.lex_state = 58, .external_lex_state = 314},
  [13173] = {.lex_state = 58, .external_lex_state = 303},
  [13174] = {.lex_state = 0, .external_lex_state = 251},
  [13175] = {.lex_state = 0, .external_lex_state = 312},
  [13176] = {.lex_state = 58, .external_lex_state = 323},
  [13177] = {.lex_state = 58, .external_lex_state = 323},
  [13178] = {.lex_state = 58, .external_lex_state = 303},
  [13179] = {.lex_state = 58, .external_lex_state = 303},
  [13180] = {.lex_state = 58, .external_lex_state = 321},
  [13181] = {.lex_state = 58, .external_lex_state = 303},
  [13182] = {.lex_state = 55, .external_lex_state = 301},
  [13183] = {.lex_state = 58, .external_lex_state = 303},
  [13184] = {.lex_state = 58, .external_lex_state = 311},
  [13185] = {.lex_state = 58, .external_lex_state = 321},
  [13186] = {.lex_state = 0, .external_lex_state = 251},
  [13187] = {.lex_state = 0, .external_lex_state = 385},
  [13188] = {.lex_state = 57, .external_lex_state = 339},
  [13189] = {.lex_state = 0, .external_lex_state = 336},
  [13190] = {.lex_state = 0, .external_lex_state = 251},
  [13191] = {.lex_state = 0, .external_lex_state = 251},
  [13192] = {.lex_state = 55, .external_lex_state = 301},
  [13193] = {.lex_state = 55, .external_lex_state = 313},
  [13194] = {.lex_state = 0, .external_lex_state = 251},
  [13195] = {.lex_state = 58, .external_lex_state = 321},
  [13196] = {.lex_state = 58, .external_lex_state = 323},
  [13197] = {.lex_state = 58, .external_lex_state = 323},
  [13198] = {.lex_state = 0, .external_lex_state = 312},
  [13199] = {.lex_state = 0, .external_lex_state = 251},
  [13200] = {.lex_state = 57, .external_lex_state = 350},
  [13201] = {.lex_state = 58, .external_lex_state = 321},
  [13202] = {.lex_state = 58, .external_lex_state = 311},
  [13203] = {.lex_state = 0, .external_lex_state = 316},
  [13204] = {.lex_state = 58, .external_lex_state = 323},
  [13205] = {.lex_state = 58, .external_lex_state = 323},
  [13206] = {.lex_state = 0, .external_lex_state = 251},
  [13207] = {.lex_state = 58, .external_lex_state = 305},
  [13208] = {.lex_state = 0, .external_lex_state = 251},
  [13209] = {.lex_state = 55, .external_lex_state = 301},
  [13210] = {.lex_state = 58, .external_lex_state = 306},
  [13211] = {.lex_state = 57, .external_lex_state = 339},
  [13212] = {.lex_state = 58, .external_lex_state = 321},
  [13213] = {.lex_state = 58, .external_lex_state = 309},
  [13214] = {.lex_state = 0, .external_lex_state = 325},
  [13215] = {.lex_state = 0, .external_lex_state = 251},
  [13216] = {.lex_state = 58, .external_lex_state = 323},
  [13217] = {.lex_state = 55, .external_lex_state = 313},
  [13218] = {.lex_state = 55, .external_lex_state = 301},
  [13219] = {.lex_state = 55, .external_lex_state = 339},
  [13220] = {.lex_state = 58, .external_lex_state = 321},
  [13221] = {.lex_state = 58, .external_lex_state = 315},
  [13222] = {.lex_state = 58, .external_lex_state = 306},
  [13223] = {.lex_state = 55, .external_lex_state = 301},
  [13224] = {.lex_state = 55, .external_lex_state = 313},
  [13225] = {.lex_state = 58, .external_lex_state = 323},
  [13226] = {.lex_state = 55, .external_lex_state = 302},
  [13227] = {.lex_state = 58, .external_lex_state = 315},
  [13228] = {.lex_state = 58, .external_lex_state = 305},
  [13229] = {.lex_state = 58, .external_lex_state = 321},
  [13230] = {.lex_state = 58, .external_lex_state = 323},
  [13231] = {.lex_state = 0, .external_lex_state = 251},
  [13232] = {.lex_state = 55, .external_lex_state = 302},
  [13233] = {.lex_state = 58, .external_lex_state = 306},
  [13234] = {.lex_state = 58, .external_lex_state = 321},
  [13235] = {.lex_state = 58, .external_lex_state = 321},
  [13236] = {.lex_state = 0, .external_lex_state = 251},
  [13237] = {.lex_state = 58, .external_lex_state = 323},
  [13238] = {.lex_state = 58, .external_lex_state = 323},
  [13239] = {.lex_state = 55, .external_lex_state = 301},
  [13240] = {.lex_state = 58, .external_lex_state = 323},
  [13241] = {.lex_state = 58, .external_lex_state = 303},
  [13242] = {.lex_state = 58, .external_lex_state = 314},
  [13243] = {.lex_state = 55, .external_lex_state = 313},
  [13244] = {.lex_state = 0, .external_lex_state = 251},
  [13245] = {.lex_state = 57, .external_lex_state = 350},
  [13246] = {.lex_state = 58, .external_lex_state = 315},
  [13247] = {.lex_state = 55, .external_lex_state = 350},
  [13248] = {.lex_state = 58, .external_lex_state = 303},
  [13249] = {.lex_state = 55, .external_lex_state = 313},
  [13250] = {.lex_state = 58, .external_lex_state = 315},
  [13251] = {.lex_state = 58, .external_lex_state = 323},
  [13252] = {.lex_state = 58, .external_lex_state = 323},
  [13253] = {.lex_state = 0, .external_lex_state = 251},
  [13254] = {.lex_state = 0, .external_lex_state = 251},
  [13255] = {.lex_state = 58, .external_lex_state = 311},
  [13256] = {.lex_state = 55, .external_lex_state = 301},
  [13257] = {.lex_state = 55, .external_lex_state = 302},
  [13258] = {.lex_state = 58, .external_lex_state = 315},
  [13259] = {.lex_state = 57, .external_lex_state = 386},
  [13260] = {.lex_state = 55, .external_lex_state = 387},
  [13261] = {.lex_state = 58, .external_lex_state = 315},
  [13262] = {.lex_state = 58, .external_lex_state = 325},
  [13263] = {.lex_state = 57, .external_lex_state = 308},
  [13264] = {.lex_state = 0, .external_lex_state = 323},
  [13265] = {.lex_state = 58, .external_lex_state = 325},
  [13266] = {.lex_state = 0, .external_lex_state = 312},
  [13267] = {.lex_state = 57, .external_lex_state = 308},
  [13268] = {.lex_state = 58, .external_lex_state = 315},
  [13269] = {.lex_state = 0, .external_lex_state = 321},
  [13270] = {.lex_state = 55, .external_lex_state = 313},
  [13271] = {.lex_state = 58, .external_lex_state = 325},
  [13272] = {.lex_state = 0, .external_lex_state = 316},
  [13273] = {.lex_state = 0, .external_lex_state = 316},
  [13274] = {.lex_state = 58, .external_lex_state = 315},
  [13275] = {.lex_state = 0, .external_lex_state = 388},
  [13276] = {.lex_state = 58, .external_lex_state = 311},
  [13277] = {.lex_state = 0, .external_lex_state = 323},
  [13278] = {.lex_state = 58, .external_lex_state = 309},
  [13279] = {.lex_state = 57, .external_lex_state = 308},
  [13280] = {.lex_state = 58, .external_lex_state = 309},
  [13281] = {.lex_state = 58, .external_lex_state = 309},
  [13282] = {.lex_state = 0, .external_lex_state = 312},
  [13283] = {.lex_state = 0, .external_lex_state = 312},
  [13284] = {.lex_state = 58, .external_lex_state = 325},
  [13285] = {.lex_state = 58, .external_lex_state = 315},
  [13286] = {.lex_state = 58, .external_lex_state = 310},
  [13287] = {.lex_state = 57, .external_lex_state = 308},
  [13288] = {.lex_state = 0, .external_lex_state = 320},
  [13289] = {.lex_state = 58, .external_lex_state = 315},
  [13290] = {.lex_state = 0, .external_lex_state = 320},
  [13291] = {.lex_state = 58, .external_lex_state = 325},
  [13292] = {.lex_state = 58, .external_lex_state = 314},
  [13293] = {.lex_state = 0, .external_lex_state = 312},
  [13294] = {.lex_state = 58, .external_lex_state = 309},
  [13295] = {.lex_state = 0, .external_lex_state = 316},
  [13296] = {.lex_state = 58, .external_lex_state = 325},
  [13297] = {.lex_state = 58, .external_lex_state = 389},
  [13298] = {.lex_state = 57, .external_lex_state = 308},
  [13299] = {.lex_state = 0, .external_lex_state = 321},
  [13300] = {.lex_state = 0, .external_lex_state = 320},
  [13301] = {.lex_state = 0, .external_lex_state = 316},
  [13302] = {.lex_state = 0, .external_lex_state = 321},
  [13303] = {.lex_state = 0, .external_lex_state = 316},
  [13304] = {.lex_state = 57, .external_lex_state = 308},
  [13305] = {.lex_state = 58, .external_lex_state = 310},
  [13306] = {.lex_state = 0, .external_lex_state = 336},
  [13307] = {.lex_state = 58, .external_lex_state = 310},
  [13308] = {.lex_state = 0, .external_lex_state = 320},
  [13309] = {.lex_state = 0, .external_lex_state = 321},
  [13310] = {.lex_state = 55, .external_lex_state = 313},
  [13311] = {.lex_state = 0, .external_lex_state = 323},
  [13312] = {.lex_state = 0, .external_lex_state = 321},
  [13313] = {.lex_state = 58, .external_lex_state = 309},
  [13314] = {.lex_state = 58, .external_lex_state = 325},
  [13315] = {.lex_state = 55, .external_lex_state = 313},
  [13316] = {.lex_state = 0, .external_lex_state = 320},
  [13317] = {.lex_state = 0, .external_lex_state = 312},
  [13318] = {.lex_state = 58, .external_lex_state = 325},
  [13319] = {.lex_state = 0, .external_lex_state = 312},
  [13320] = {.lex_state = 58, .external_lex_state = 325},
  [13321] = {.lex_state = 58, .external_lex_state = 325},
  [13322] = {.lex_state = 58, .external_lex_state = 314},
  [13323] = {.lex_state = 57, .external_lex_state = 308},
  [13324] = {.lex_state = 58, .external_lex_state = 309},
  [13325] = {.lex_state = 58, .external_lex_state = 325},
  [13326] = {.lex_state = 58, .external_lex_state = 309},
  [13327] = {.lex_state = 55, .external_lex_state = 313},
  [13328] = {.lex_state = 58, .external_lex_state = 325},
  [13329] = {.lex_state = 58, .external_lex_state = 309},
  [13330] = {.lex_state = 58, .external_lex_state = 309},
  [13331] = {.lex_state = 58, .external_lex_state = 309},
  [13332] = {.lex_state = 58, .external_lex_state = 315},
  [13333] = {.lex_state = 0, .external_lex_state = 321},
  [13334] = {.lex_state = 0, .external_lex_state = 320},
  [13335] = {.lex_state = 58, .external_lex_state = 325},
  [13336] = {.lex_state = 58, .external_lex_state = 310},
  [13337] = {.lex_state = 58, .external_lex_state = 325},
  [13338] = {.lex_state = 57, .external_lex_state = 308},
  [13339] = {.lex_state = 0, .external_lex_state = 312},
  [13340] = {.lex_state = 0, .external_lex_state = 320},
  [13341] = {.lex_state = 58, .external_lex_state = 310},
  [13342] = {.lex_state = 0, .external_lex_state = 200},
  [13343] = {.lex_state = 58, .external_lex_state = 315},
  [13344] = {.lex_state = 58, .external_lex_state = 309},
  [13345] = {.lex_state = 58, .external_lex_state = 309},
  [13346] = {.lex_state = 55, .external_lex_state = 348},
  [13347] = {.lex_state = 58, .external_lex_state = 314},
  [13348] = {.lex_state = 57, .external_lex_state = 308},
  [13349] = {.lex_state = 57, .external_lex_state = 308},
  [13350] = {.lex_state = 58, .external_lex_state = 310},
  [13351] = {.lex_state = 58, .external_lex_state = 390},
  [13352] = {.lex_state = 55, .external_lex_state = 377},
  [13353] = {.lex_state = 55, .external_lex_state = 350},
  [13354] = {.lex_state = 58, .external_lex_state = 311},
  [13355] = {.lex_state = 0, .external_lex_state = 321},
  [13356] = {.lex_state = 57, .external_lex_state = 308},
  [13357] = {.lex_state = 58, .external_lex_state = 391},
  [13358] = {.lex_state = 0, .external_lex_state = 316},
  [13359] = {.lex_state = 55, .external_lex_state = 313},
  [13360] = {.lex_state = 57, .external_lex_state = 308},
  [13361] = {.lex_state = 0, .external_lex_state = 316},
  [13362] = {.lex_state = 55, .external_lex_state = 313},
  [13363] = {.lex_state = 58, .external_lex_state = 325},
  [13364] = {.lex_state = 58, .external_lex_state = 314},
  [13365] = {.lex_state = 58, .external_lex_state = 310},
  [13366] = {.lex_state = 0, .external_lex_state = 378},
  [13367] = {.lex_state = 55, .external_lex_state = 313},
  [13368] = {.lex_state = 0, .external_lex_state = 323},
  [13369] = {.lex_state = 0, .external_lex_state = 323},
  [13370] = {.lex_state = 0, .external_lex_state = 369},
  [13371] = {.lex_state = 55, .external_lex_state = 339},
  [13372] = {.lex_state = 0, .external_lex_state = 320},
  [13373] = {.lex_state = 58, .external_lex_state = 311},
  [13374] = {.lex_state = 58, .external_lex_state = 315},
  [13375] = {.lex_state = 57, .external_lex_state = 367},
  [13376] = {.lex_state = 58, .external_lex_state = 325},
  [13377] = {.lex_state = 58, .external_lex_state = 315},
  [13378] = {.lex_state = 0, .external_lex_state = 323},
  [13379] = {.lex_state = 0, .external_lex_state = 388},
  [13380] = {.lex_state = 0, .external_lex_state = 321},
  [13381] = {.lex_state = 0, .external_lex_state = 321},
  [13382] = {.lex_state = 58, .external_lex_state = 315},
  [13383] = {.lex_state = 0, .external_lex_state = 350},
  [13384] = {.lex_state = 0, .external_lex_state = 323},
  [13385] = {.lex_state = 0, .external_lex_state = 323},
  [13386] = {.lex_state = 58, .external_lex_state = 309},
  [13387] = {.lex_state = 0, .external_lex_state = 321},
  [13388] = {.lex_state = 0, .external_lex_state = 321},
  [13389] = {.lex_state = 57, .external_lex_state = 367},
  [13390] = {.lex_state = 0, .external_lex_state = 312},
  [13391] = {.lex_state = 0, .external_lex_state = 320},
  [13392] = {.lex_state = 57, .external_lex_state = 308},
  [13393] = {.lex_state = 0, .external_lex_state = 320},
  [13394] = {.lex_state = 0, .external_lex_state = 215},
  [13395] = {.lex_state = 57, .external_lex_state = 308},
  [13396] = {.lex_state = 55, .external_lex_state = 313},
  [13397] = {.lex_state = 58, .external_lex_state = 242},
  [13398] = {.lex_state = 0, .external_lex_state = 321},
  [13399] = {.lex_state = 57, .external_lex_state = 308},
  [13400] = {.lex_state = 0, .external_lex_state = 321},
  [13401] = {.lex_state = 0, .external_lex_state = 320},
  [13402] = {.lex_state = 55, .external_lex_state = 313},
  [13403] = {.lex_state = 0, .external_lex_state = 323},
  [13404] = {.lex_state = 0, .external_lex_state = 320},
  [13405] = {.lex_state = 0, .external_lex_state = 316},
  [13406] = {.lex_state = 58, .external_lex_state = 325},
  [13407] = {.lex_state = 57, .external_lex_state = 308},
  [13408] = {.lex_state = 57, .external_lex_state = 367},
  [13409] = {.lex_state = 0, .external_lex_state = 378},
  [13410] = {.lex_state = 58, .external_lex_state = 310},
  [13411] = {.lex_state = 58, .external_lex_state = 315},
  [13412] = {.lex_state = 55, .external_lex_state = 350},
  [13413] = {.lex_state = 0, .external_lex_state = 200},
  [13414] = {.lex_state = 0, .external_lex_state = 323},
  [13415] = {.lex_state = 58, .external_lex_state = 315},
  [13416] = {.lex_state = 58, .external_lex_state = 310},
  [13417] = {.lex_state = 58, .external_lex_state = 309},
  [13418] = {.lex_state = 58, .external_lex_state = 309},
  [13419] = {.lex_state = 58, .external_lex_state = 392},
  [13420] = {.lex_state = 0, .external_lex_state = 316},
  [13421] = {.lex_state = 0, .external_lex_state = 323},
  [13422] = {.lex_state = 0, .external_lex_state = 323},
  [13423] = {.lex_state = 58, .external_lex_state = 310},
  [13424] = {.lex_state = 55, .external_lex_state = 313},
  [13425] = {.lex_state = 0, .external_lex_state = 323},
  [13426] = {.lex_state = 57, .external_lex_state = 308},
  [13427] = {.lex_state = 0, .external_lex_state = 316},
  [13428] = {.lex_state = 55, .external_lex_state = 393},
  [13429] = {.lex_state = 57, .external_lex_state = 308},
  [13430] = {.lex_state = 57, .external_lex_state = 308},
  [13431] = {.lex_state = 55, .external_lex_state = 339},
  [13432] = {.lex_state = 58, .external_lex_state = 314},
  [13433] = {.lex_state = 0, .external_lex_state = 323},
  [13434] = {.lex_state = 0, .external_lex_state = 320},
  [13435] = {.lex_state = 0, .external_lex_state = 316},
  [13436] = {.lex_state = 55, .external_lex_state = 313},
  [13437] = {.lex_state = 58, .external_lex_state = 314},
  [13438] = {.lex_state = 55, .external_lex_state = 313},
  [13439] = {.lex_state = 0, .external_lex_state = 200},
  [13440] = {.lex_state = 0, .external_lex_state = 312},
  [13441] = {.lex_state = 55, .external_lex_state = 367},
  [13442] = {.lex_state = 57, .external_lex_state = 308},
  [13443] = {.lex_state = 0, .external_lex_state = 312},
  [13444] = {.lex_state = 55, .external_lex_state = 313},
  [13445] = {.lex_state = 58, .external_lex_state = 325},
  [13446] = {.lex_state = 0, .external_lex_state = 316},
  [13447] = {.lex_state = 57, .external_lex_state = 308},
  [13448] = {.lex_state = 58, .external_lex_state = 314},
  [13449] = {.lex_state = 55, .external_lex_state = 339},
  [13450] = {.lex_state = 58, .external_lex_state = 310},
  [13451] = {.lex_state = 58, .external_lex_state = 325},
  [13452] = {.lex_state = 58, .external_lex_state = 310},
  [13453] = {.lex_state = 0, .external_lex_state = 320},
  [13454] = {.lex_state = 0, .external_lex_state = 320},
  [13455] = {.lex_state = 0, .external_lex_state = 320},
  [13456] = {.lex_state = 55, .external_lex_state = 350},
  [13457] = {.lex_state = 57, .external_lex_state = 308},
  [13458] = {.lex_state = 0, .external_lex_state = 394},
  [13459] = {.lex_state = 58, .external_lex_state = 309},
  [13460] = {.lex_state = 58, .external_lex_state = 315},
  [13461] = {.lex_state = 0, .external_lex_state = 336},
  [13462] = {.lex_state = 0, .external_lex_state = 321},
  [13463] = {.lex_state = 58, .external_lex_state = 314},
  [13464] = {.lex_state = 58, .external_lex_state = 311},
  [13465] = {.lex_state = 0, .external_lex_state = 395},
  [13466] = {.lex_state = 0, .external_lex_state = 312},
  [13467] = {.lex_state = 0, .external_lex_state = 316},
  [13468] = {.lex_state = 0, .external_lex_state = 200},
  [13469] = {.lex_state = 55, .external_lex_state = 313},
  [13470] = {.lex_state = 0, .external_lex_state = 321},
  [13471] = {.lex_state = 58, .external_lex_state = 325},
  [13472] = {.lex_state = 0, .external_lex_state = 316},
  [13473] = {.lex_state = 55, .external_lex_state = 350},
  [13474] = {.lex_state = 57, .external_lex_state = 367},
  [13475] = {.lex_state = 57, .external_lex_state = 308},
  [13476] = {.lex_state = 57, .external_lex_state = 308},
  [13477] = {.lex_state = 57, .external_lex_state = 308},
  [13478] = {.lex_state = 58, .external_lex_state = 309},
  [13479] = {.lex_state = 57, .external_lex_state = 308},
  [13480] = {.lex_state = 0, .external_lex_state = 312},
  [13481] = {.lex_state = 0, .external_lex_state = 348},
  [13482] = {.lex_state = 58, .external_lex_state = 310},
  [13483] = {.lex_state = 0, .external_lex_state = 316},
  [13484] = {.lex_state = 57, .external_lex_state = 308},
  [13485] = {.lex_state = 0, .external_lex_state = 316},
  [13486] = {.lex_state = 58, .external_lex_state = 311},
  [13487] = {.lex_state = 58, .external_lex_state = 311},
  [13488] = {.lex_state = 0, .external_lex_state = 316},
  [13489] = {.lex_state = 58, .external_lex_state = 314},
  [13490] = {.lex_state = 0, .external_lex_state = 348},
  [13491] = {.lex_state = 0, .external_lex_state = 348},
  [13492] = {.lex_state = 58, .external_lex_state = 314},
  [13493] = {.lex_state = 0, .external_lex_state = 321},
  [13494] = {.lex_state = 0, .external_lex_state = 312},
  [13495] = {.lex_state = 0, .external_lex_state = 339},
  [13496] = {.lex_state = 58, .external_lex_state = 311},
  [13497] = {.lex_state = 58, .external_lex_state = 310},
  [13498] = {.lex_state = 58, .external_lex_state = 315},
  [13499] = {.lex_state = 0, .external_lex_state = 388},
  [13500] = {.lex_state = 57, .external_lex_state = 308},
  [13501] = {.lex_state = 58, .external_lex_state = 315},
  [13502] = {.lex_state = 58, .external_lex_state = 314},
  [13503] = {.lex_state = 58, .external_lex_state = 310},
  [13504] = {.lex_state = 58, .external_lex_state = 310},
  [13505] = {.lex_state = 0, .external_lex_state = 321},
  [13506] = {.lex_state = 58, .external_lex_state = 311},
  [13507] = {.lex_state = 0, .external_lex_state = 323},
  [13508] = {.lex_state = 58, .external_lex_state = 311},
  [13509] = {.lex_state = 58, .external_lex_state = 311},
  [13510] = {.lex_state = 58, .external_lex_state = 311},
  [13511] = {.lex_state = 57, .external_lex_state = 308},
  [13512] = {.lex_state = 58, .external_lex_state = 314},
  [13513] = {.lex_state = 58, .external_lex_state = 314},
  [13514] = {.lex_state = 58, .external_lex_state = 314},
  [13515] = {.lex_state = 58, .external_lex_state = 314},
  [13516] = {.lex_state = 58, .external_lex_state = 314},
  [13517] = {.lex_state = 58, .external_lex_state = 311},
  [13518] = {.lex_state = 58, .external_lex_state = 311},
  [13519] = {.lex_state = 0, .external_lex_state = 321},
  [13520] = {.lex_state = 57, .external_lex_state = 367},
  [13521] = {.lex_state = 0, .external_lex_state = 348},
  [13522] = {.lex_state = 58, .external_lex_state = 325},
  [13523] = {.lex_state = 58, .external_lex_state = 315},
  [13524] = {.lex_state = 0, .external_lex_state = 321},
  [13525] = {.lex_state = 58, .external_lex_state = 314},
  [13526] = {.lex_state = 0, .external_lex_state = 323},
  [13527] = {.lex_state = 0, .external_lex_state = 323},
  [13528] = {.lex_state = 55, .external_lex_state = 339},
  [13529] = {.lex_state = 0, .external_lex_state = 312},
  [13530] = {.lex_state = 58, .external_lex_state = 310},
  [13531] = {.lex_state = 58, .external_lex_state = 311},
  [13532] = {.lex_state = 58, .external_lex_state = 309},
  [13533] = {.lex_state = 0, .external_lex_state = 396},
  [13534] = {.lex_state = 0, .external_lex_state = 320},
  [13535] = {.lex_state = 58, .external_lex_state = 315},
  [13536] = {.lex_state = 58, .external_lex_state = 310},
  [13537] = {.lex_state = 58, .external_lex_state = 325},
  [13538] = {.lex_state = 58, .external_lex_state = 325},
  [13539] = {.lex_state = 0, .external_lex_state = 312},
  [13540] = {.lex_state = 55, .external_lex_state = 377},
  [13541] = {.lex_state = 0, .external_lex_state = 378},
  [13542] = {.lex_state = 58, .external_lex_state = 325},
  [13543] = {.lex_state = 58, .external_lex_state = 325},
  [13544] = {.lex_state = 55, .external_lex_state = 313},
  [13545] = {.lex_state = 55, .external_lex_state = 313},
  [13546] = {.lex_state = 0, .external_lex_state = 323},
  [13547] = {.lex_state = 0, .external_lex_state = 320},
  [13548] = {.lex_state = 57, .external_lex_state = 308},
  [13549] = {.lex_state = 58, .external_lex_state = 311},
  [13550] = {.lex_state = 58, .external_lex_state = 325},
  [13551] = {.lex_state = 0, .external_lex_state = 348},
  [13552] = {.lex_state = 58, .external_lex_state = 311},
  [13553] = {.lex_state = 0, .external_lex_state = 320},
  [13554] = {.lex_state = 58, .external_lex_state = 314},
  [13555] = {.lex_state = 57, .external_lex_state = 308},
  [13556] = {.lex_state = 0, .external_lex_state = 312},
  [13557] = {.lex_state = 58, .external_lex_state = 315},
  [13558] = {.lex_state = 58, .external_lex_state = 325},
  [13559] = {.lex_state = 58, .external_lex_state = 311},
  [13560] = {.lex_state = 58, .external_lex_state = 325},
  [13561] = {.lex_state = 0, .external_lex_state = 323},
  [13562] = {.lex_state = 0, .external_lex_state = 312},
  [13563] = {.lex_state = 58, .external_lex_state = 325},
  [13564] = {.lex_state = 55, .external_lex_state = 313},
  [13565] = {.lex_state = 57, .external_lex_state = 308},
  [13566] = {.lex_state = 0, .external_lex_state = 320},
  [13567] = {.lex_state = 57, .external_lex_state = 308},
  [13568] = {.lex_state = 0, .external_lex_state = 348},
  [13569] = {.lex_state = 57, .external_lex_state = 308},
  [13570] = {.lex_state = 0, .external_lex_state = 348},
  [13571] = {.lex_state = 57, .external_lex_state = 308},
  [13572] = {.lex_state = 58, .external_lex_state = 389},
  [13573] = {.lex_state = 55, .external_lex_state = 397},
  [13574] = {.lex_state = 0, .external_lex_state = 348},
  [13575] = {.lex_state = 0, .external_lex_state = 325},
  [13576] = {.lex_state = 57, .external_lex_state = 308},
  [13577] = {.lex_state = 57, .external_lex_state = 308},
  [13578] = {.lex_state = 0, .external_lex_state = 369},
  [13579] = {.lex_state = 55, .external_lex_state = 398},
  [13580] = {.lex_state = 57, .external_lex_state = 339},
  [13581] = {.lex_state = 0, .external_lex_state = 320},
  [13582] = {.lex_state = 57, .external_lex_state = 308},
  [13583] = {.lex_state = 57, .external_lex_state = 308},
  [13584] = {.lex_state = 58, .external_lex_state = 399},
  [13585] = {.lex_state = 0, .external_lex_state = 323},
  [13586] = {.lex_state = 0, .external_lex_state = 323},
  [13587] = {.lex_state = 0, .external_lex_state = 369},
  [13588] = {.lex_state = 57, .external_lex_state = 308},
  [13589] = {.lex_state = 58, .external_lex_state = 400},
  [13590] = {.lex_state = 0, .external_lex_state = 348},
  [13591] = {.lex_state = 0, .external_lex_state = 321},
  [13592] = {.lex_state = 0, .external_lex_state = 348},
  [13593] = {.lex_state = 57, .external_lex_state = 308},
  [13594] = {.lex_state = 57, .external_lex_state = 308},
  [13595] = {.lex_state = 0, .external_lex_state = 348},
  [13596] = {.lex_state = 57, .external_lex_state = 308},
  [13597] = {.lex_state = 0, .external_lex_state = 323},
  [13598] = {.lex_state = 58, .external_lex_state = 401},
  [13599] = {.lex_state = 57, .external_lex_state = 350},
  [13600] = {.lex_state = 57, .external_lex_state = 308},
  [13601] = {.lex_state = 0, .external_lex_state = 369},
  [13602] = {.lex_state = 0, .external_lex_state = 321},
  [13603] = {.lex_state = 0, .external_lex_state = 321},
  [13604] = {.lex_state = 0, .external_lex_state = 321},
  [13605] = {.lex_state = 0, .external_lex_state = 348},
  [13606] = {.lex_state = 0, .external_lex_state = 320},
  [13607] = {.lex_state = 0, .external_lex_state = 321},
  [13608] = {.lex_state = 58, .external_lex_state = 402},
  [13609] = {.lex_state = 0, .external_lex_state = 323},
  [13610] = {.lex_state = 0, .external_lex_state = 348},
  [13611] = {.lex_state = 0, .external_lex_state = 348},
  [13612] = {.lex_state = 0, .external_lex_state = 320},
  [13613] = {.lex_state = 57, .external_lex_state = 308},
  [13614] = {.lex_state = 0, .external_lex_state = 348},
  [13615] = {.lex_state = 57, .external_lex_state = 308},
  [13616] = {.lex_state = 57, .external_lex_state = 308},
  [13617] = {.lex_state = 57, .external_lex_state = 308},
  [13618] = {.lex_state = 0, .external_lex_state = 348},
  [13619] = {.lex_state = 55, .external_lex_state = 386},
  [13620] = {.lex_state = 0, .external_lex_state = 348},
  [13621] = {.lex_state = 55, .external_lex_state = 403},
  [13622] = {.lex_state = 0, .external_lex_state = 321},
  [13623] = {.lex_state = 0, .external_lex_state = 388},
  [13624] = {.lex_state = 0, .external_lex_state = 321},
  [13625] = {.lex_state = 0, .external_lex_state = 321},
  [13626] = {.lex_state = 0, .external_lex_state = 348},
  [13627] = {.lex_state = 0, .external_lex_state = 348},
  [13628] = {.lex_state = 0, .external_lex_state = 348},
  [13629] = {.lex_state = 0, .external_lex_state = 348},
  [13630] = {.lex_state = 55, .external_lex_state = 393},
  [13631] = {.lex_state = 0, .external_lex_state = 323},
  [13632] = {.lex_state = 0, .external_lex_state = 348},
  [13633] = {.lex_state = 0, .external_lex_state = 348},
  [13634] = {.lex_state = 0, .external_lex_state = 348},
  [13635] = {.lex_state = 0, .external_lex_state = 404},
  [13636] = {.lex_state = 57, .external_lex_state = 308},
  [13637] = {.lex_state = 2, .external_lex_state = 308},
  [13638] = {.lex_state = 0, .external_lex_state = 323},
  [13639] = {.lex_state = 57, .external_lex_state = 386},
  [13640] = {.lex_state = 0, .external_lex_state = 348},
  [13641] = {.lex_state = 0, .external_lex_state = 323},
  [13642] = {.lex_state = 58, .external_lex_state = 402},
  [13643] = {.lex_state = 57, .external_lex_state = 308},
  [13644] = {.lex_state = 57, .external_lex_state = 308},
  [13645] = {.lex_state = 55, .external_lex_state = 405},
  [13646] = {.lex_state = 0, .external_lex_state = 348},
  [13647] = {.lex_state = 0, .external_lex_state = 348},
  [13648] = {.lex_state = 57, .external_lex_state = 308},
  [13649] = {.lex_state = 55, .external_lex_state = 387},
  [13650] = {.lex_state = 0, .external_lex_state = 320},
  [13651] = {.lex_state = 0, .external_lex_state = 320},
  [13652] = {.lex_state = 55, .external_lex_state = 308},
  [13653] = {.lex_state = 57, .external_lex_state = 308},
  [13654] = {.lex_state = 57, .external_lex_state = 386},
  [13655] = {.lex_state = 0, .external_lex_state = 323},
  [13656] = {.lex_state = 57, .external_lex_state = 308},
  [13657] = {.lex_state = 57, .external_lex_state = 308},
  [13658] = {.lex_state = 0, .external_lex_state = 325},
  [13659] = {.lex_state = 0, .external_lex_state = 251},
  [13660] = {.lex_state = 0, .external_lex_state = 323},
  [13661] = {.lex_state = 57, .external_lex_state = 350},
  [13662] = {.lex_state = 58, .external_lex_state = 392},
  [13663] = {.lex_state = 57, .external_lex_state = 308},
  [13664] = {.lex_state = 0, .external_lex_state = 348},
  [13665] = {.lex_state = 0, .external_lex_state = 348},
  [13666] = {.lex_state = 0, .external_lex_state = 348},
  [13667] = {.lex_state = 2, .external_lex_state = 308},
  [13668] = {.lex_state = 0, .external_lex_state = 323},
  [13669] = {.lex_state = 0, .external_lex_state = 348},
  [13670] = {.lex_state = 57, .external_lex_state = 308},
  [13671] = {.lex_state = 57, .external_lex_state = 308},
  [13672] = {.lex_state = 57, .external_lex_state = 308},
  [13673] = {.lex_state = 0, .external_lex_state = 388},
  [13674] = {.lex_state = 57, .external_lex_state = 308},
  [13675] = {.lex_state = 0, .external_lex_state = 348},
  [13676] = {.lex_state = 0, .external_lex_state = 320},
  [13677] = {.lex_state = 57, .external_lex_state = 308},
  [13678] = {.lex_state = 57, .external_lex_state = 308},
  [13679] = {.lex_state = 0, .external_lex_state = 321},
  [13680] = {.lex_state = 0, .external_lex_state = 348},
  [13681] = {.lex_state = 0, .external_lex_state = 348},
  [13682] = {.lex_state = 0, .external_lex_state = 348},
  [13683] = {.lex_state = 0, .external_lex_state = 348},
  [13684] = {.lex_state = 0, .external_lex_state = 320},
  [13685] = {.lex_state = 0, .external_lex_state = 323},
  [13686] = {.lex_state = 57, .external_lex_state = 386},
  [13687] = {.lex_state = 57, .external_lex_state = 308},
  [13688] = {.lex_state = 57, .external_lex_state = 308},
  [13689] = {.lex_state = 0, .external_lex_state = 320},
  [13690] = {.lex_state = 57, .external_lex_state = 308},
  [13691] = {.lex_state = 57, .external_lex_state = 308},
  [13692] = {.lex_state = 57, .external_lex_state = 308},
  [13693] = {.lex_state = 57, .external_lex_state = 308},
  [13694] = {.lex_state = 57, .external_lex_state = 308},
  [13695] = {.lex_state = 57, .external_lex_state = 308},
  [13696] = {.lex_state = 0, .external_lex_state = 320},
  [13697] = {.lex_state = 0, .external_lex_state = 348},
  [13698] = {.lex_state = 57, .external_lex_state = 308},
  [13699] = {.lex_state = 0, .external_lex_state = 348},
  [13700] = {.lex_state = 55, .external_lex_state = 367},
  [13701] = {.lex_state = 57, .external_lex_state = 308},
  [13702] = {.lex_state = 0, .external_lex_state = 321},
  [13703] = {.lex_state = 0, .external_lex_state = 321},
  [13704] = {.lex_state = 0, .external_lex_state = 348},
  [13705] = {.lex_state = 57, .external_lex_state = 308},
  [13706] = {.lex_state = 55, .external_lex_state = 393},
  [13707] = {.lex_state = 57, .external_lex_state = 308},
  [13708] = {.lex_state = 0, .external_lex_state = 325},
  [13709] = {.lex_state = 57, .external_lex_state = 308},
  [13710] = {.lex_state = 57, .external_lex_state = 308},
  [13711] = {.lex_state = 57, .external_lex_state = 308},
  [13712] = {.lex_state = 0, .external_lex_state = 348},
  [13713] = {.lex_state = 57, .external_lex_state = 308},
  [13714] = {.lex_state = 57, .external_lex_state = 308},
  [13715] = {.lex_state = 0, .external_lex_state = 348},
  [13716] = {.lex_state = 57, .external_lex_state = 308},
  [13717] = {.lex_state = 57, .external_lex_state = 308},
  [13718] = {.lex_state = 0, .external_lex_state = 323},
  [13719] = {.lex_state = 0, .external_lex_state = 325},
  [13720] = {.lex_state = 57, .external_lex_state = 308},
  [13721] = {.lex_state = 0, .external_lex_state = 348},
  [13722] = {.lex_state = 0, .external_lex_state = 251},
  [13723] = {.lex_state = 0, .external_lex_state = 325},
  [13724] = {.lex_state = 0, .external_lex_state = 348},
  [13725] = {.lex_state = 57, .external_lex_state = 308},
  [13726] = {.lex_state = 57, .external_lex_state = 308},
  [13727] = {.lex_state = 57, .external_lex_state = 308},
  [13728] = {.lex_state = 57, .external_lex_state = 308},
  [13729] = {.lex_state = 57, .external_lex_state = 308},
  [13730] = {.lex_state = 57, .external_lex_state = 308},
  [13731] = {.lex_state = 57, .external_lex_state = 308},
  [13732] = {.lex_state = 58, .external_lex_state = 392},
  [13733] = {.lex_state = 0, .external_lex_state = 325},
  [13734] = {.lex_state = 58, .external_lex_state = 391},
  [13735] = {.lex_state = 57, .external_lex_state = 308},
  [13736] = {.lex_state = 0, .external_lex_state = 320},
  [13737] = {.lex_state = 57, .external_lex_state = 308},
  [13738] = {.lex_state = 0, .external_lex_state = 320},
  [13739] = {.lex_state = 57, .external_lex_state = 308},
  [13740] = {.lex_state = 0, .external_lex_state = 369},
  [13741] = {.lex_state = 57, .external_lex_state = 308},
  [13742] = {.lex_state = 57, .external_lex_state = 308},
  [13743] = {.lex_state = 58, .external_lex_state = 389},
  [13744] = {.lex_state = 0, .external_lex_state = 369},
  [13745] = {.lex_state = 0, .external_lex_state = 348},
  [13746] = {.lex_state = 57, .external_lex_state = 308},
  [13747] = {.lex_state = 0, .external_lex_state = 348},
  [13748] = {.lex_state = 57, .external_lex_state = 308},
  [13749] = {.lex_state = 57, .external_lex_state = 308},
  [13750] = {.lex_state = 0, .external_lex_state = 388},
  [13751] = {.lex_state = 57, .external_lex_state = 308},
  [13752] = {.lex_state = 0, .external_lex_state = 348},
  [13753] = {.lex_state = 0, .external_lex_state = 321},
  [13754] = {.lex_state = 58, .external_lex_state = 391},
  [13755] = {.lex_state = 57, .external_lex_state = 308},
  [13756] = {.lex_state = 0, .external_lex_state = 321},
  [13757] = {.lex_state = 0, .external_lex_state = 348},
  [13758] = {.lex_state = 0, .external_lex_state = 321},
  [13759] = {.lex_state = 0, .external_lex_state = 320},
  [13760] = {.lex_state = 57, .external_lex_state = 308},
  [13761] = {.lex_state = 0, .external_lex_state = 348},
  [13762] = {.lex_state = 55, .external_lex_state = 367},
  [13763] = {.lex_state = 57, .external_lex_state = 308},
  [13764] = {.lex_state = 55, .external_lex_state = 367},
  [13765] = {.lex_state = 0, .external_lex_state = 321},
  [13766] = {.lex_state = 0, .external_lex_state = 320},
  [13767] = {.lex_state = 0, .external_lex_state = 320},
  [13768] = {.lex_state = 0, .external_lex_state = 320},
  [13769] = {.lex_state = 57, .external_lex_state = 308},
  [13770] = {.lex_state = 57, .external_lex_state = 308},
  [13771] = {.lex_state = 0, .external_lex_state = 348},
  [13772] = {.lex_state = 0, .external_lex_state = 325},
  [13773] = {.lex_state = 57, .external_lex_state = 339},
  [13774] = {.lex_state = 57, .external_lex_state = 308},
  [13775] = {.lex_state = 57, .external_lex_state = 308},
  [13776] = {.lex_state = 57, .external_lex_state = 308},
  [13777] = {.lex_state = 57, .external_lex_state = 308},
  [13778] = {.lex_state = 0, .external_lex_state = 348},
  [13779] = {.lex_state = 0, .external_lex_state = 348},
  [13780] = {.lex_state = 57, .external_lex_state = 308},
  [13781] = {.lex_state = 0, .external_lex_state = 320},
  [13782] = {.lex_state = 57, .external_lex_state = 308},
  [13783] = {.lex_state = 58, .external_lex_state = 402},
  [13784] = {.lex_state = 57, .external_lex_state = 308},
  [13785] = {.lex_state = 57, .external_lex_state = 308},
  [13786] = {.lex_state = 57, .external_lex_state = 339},
  [13787] = {.lex_state = 57, .external_lex_state = 308},
  [13788] = {.lex_state = 0, .external_lex_state = 348},
  [13789] = {.lex_state = 58, .external_lex_state = 390},
  [13790] = {.lex_state = 0, .external_lex_state = 325},
  [13791] = {.lex_state = 57, .external_lex_state = 308},
  [13792] = {.lex_state = 57, .external_lex_state = 308},
  [13793] = {.lex_state = 0, .external_lex_state = 348},
  [13794] = {.lex_state = 57, .external_lex_state = 308},
  [13795] = {.lex_state = 0, .external_lex_state = 251},
  [13796] = {.lex_state = 0, .external_lex_state = 325},
  [13797] = {.lex_state = 57, .external_lex_state = 386},
  [13798] = {.lex_state = 0, .external_lex_state = 325},
  [13799] = {.lex_state = 58, .external_lex_state = 376},
  [13800] = {.lex_state = 55, .external_lex_state = 406},
  [13801] = {.lex_state = 57, .external_lex_state = 308},
  [13802] = {.lex_state = 57, .external_lex_state = 308},
  [13803] = {.lex_state = 57, .external_lex_state = 308},
  [13804] = {.lex_state = 0, .external_lex_state = 325},
  [13805] = {.lex_state = 0, .external_lex_state = 321},
  [13806] = {.lex_state = 0, .external_lex_state = 348},
  [13807] = {.lex_state = 57, .external_lex_state = 308},
  [13808] = {.lex_state = 57, .external_lex_state = 308},
  [13809] = {.lex_state = 58, .external_lex_state = 242},
  [13810] = {.lex_state = 0, .external_lex_state = 348},
  [13811] = {.lex_state = 55, .external_lex_state = 251},
  [13812] = {.lex_state = 57, .external_lex_state = 308},
  [13813] = {.lex_state = 57, .external_lex_state = 308},
  [13814] = {.lex_state = 57, .external_lex_state = 308},
  [13815] = {.lex_state = 0, .external_lex_state = 325},
  [13816] = {.lex_state = 0, .external_lex_state = 325},
  [13817] = {.lex_state = 60, .external_lex_state = 242},
  [13818] = {.lex_state = 55, .external_lex_state = 367},
  [13819] = {.lex_state = 57, .external_lex_state = 308},
  [13820] = {.lex_state = 0, .external_lex_state = 325},
  [13821] = {.lex_state = 0, .external_lex_state = 321},
  [13822] = {.lex_state = 0, .external_lex_state = 323},
  [13823] = {.lex_state = 57, .external_lex_state = 308},
  [13824] = {.lex_state = 57, .external_lex_state = 308},
  [13825] = {.lex_state = 0, .external_lex_state = 323},
  [13826] = {.lex_state = 0, .external_lex_state = 325},
  [13827] = {.lex_state = 57, .external_lex_state = 308},
  [13828] = {.lex_state = 57, .external_lex_state = 308},
  [13829] = {.lex_state = 57, .external_lex_state = 308},
  [13830] = {.lex_state = 57, .external_lex_state = 308},
  [13831] = {.lex_state = 57, .external_lex_state = 308},
  [13832] = {.lex_state = 57, .external_lex_state = 308},
  [13833] = {.lex_state = 0, .external_lex_state = 325},
  [13834] = {.lex_state = 2, .external_lex_state = 308},
  [13835] = {.lex_state = 57, .external_lex_state = 308},
  [13836] = {.lex_state = 0, .external_lex_state = 325},
  [13837] = {.lex_state = 0, .external_lex_state = 325},
  [13838] = {.lex_state = 0, .external_lex_state = 323},
  [13839] = {.lex_state = 0, .external_lex_state = 386},
  [13840] = {.lex_state = 55, .external_lex_state = 387},
  [13841] = {.lex_state = 57, .external_lex_state = 350},
  [13842] = {.lex_state = 0, .external_lex_state = 325},
  [13843] = {.lex_state = 57, .external_lex_state = 308},
  [13844] = {.lex_state = 0, .external_lex_state = 367},
  [13845] = {.lex_state = 0, .external_lex_state = 348},
  [13846] = {.lex_state = 57, .external_lex_state = 308},
  [13847] = {.lex_state = 57, .external_lex_state = 308},
  [13848] = {.lex_state = 0, .external_lex_state = 200},
  [13849] = {.lex_state = 57, .external_lex_state = 308},
  [13850] = {.lex_state = 0, .external_lex_state = 348},
  [13851] = {.lex_state = 57, .external_lex_state = 308},
  [13852] = {.lex_state = 57, .external_lex_state = 407},
  [13853] = {.lex_state = 57, .external_lex_state = 308},
  [13854] = {.lex_state = 57, .external_lex_state = 308},
  [13855] = {.lex_state = 57, .external_lex_state = 308},
  [13856] = {.lex_state = 0, .external_lex_state = 323},
  [13857] = {.lex_state = 57, .external_lex_state = 308},
  [13858] = {.lex_state = 57, .external_lex_state = 308},
  [13859] = {.lex_state = 57, .external_lex_state = 386},
  [13860] = {.lex_state = 57, .external_lex_state = 308},
  [13861] = {.lex_state = 0, .external_lex_state = 323},
  [13862] = {.lex_state = 57, .external_lex_state = 308},
  [13863] = {.lex_state = 57, .external_lex_state = 308},
  [13864] = {.lex_state = 57, .external_lex_state = 308},
  [13865] = {.lex_state = 58, .external_lex_state = 390},
  [13866] = {.lex_state = 57, .external_lex_state = 308},
  [13867] = {.lex_state = 58, .external_lex_state = 401},
  [13868] = {.lex_state = 58, .external_lex_state = 408},
  [13869] = {.lex_state = 58, .external_lex_state = 392},
  [13870] = {.lex_state = 55, .external_lex_state = 308},
  [13871] = {.lex_state = 0, .external_lex_state = 379},
  [13872] = {.lex_state = 55, .external_lex_state = 308},
  [13873] = {.lex_state = 58, .external_lex_state = 382},
  [13874] = {.lex_state = 58, .external_lex_state = 392},
  [13875] = {.lex_state = 55, .external_lex_state = 405},
  [13876] = {.lex_state = 57, .external_lex_state = 308},
  [13877] = {.lex_state = 0, .external_lex_state = 369},
  [13878] = {.lex_state = 0, .external_lex_state = 369},
  [13879] = {.lex_state = 0, .external_lex_state = 369},
  [13880] = {.lex_state = 57, .external_lex_state = 308},
  [13881] = {.lex_state = 58, .external_lex_state = 242},
  [13882] = {.lex_state = 58, .external_lex_state = 242},
  [13883] = {.lex_state = 55, .external_lex_state = 308},
  [13884] = {.lex_state = 0, .external_lex_state = 369},
  [13885] = {.lex_state = 58, .external_lex_state = 409},
  [13886] = {.lex_state = 0, .external_lex_state = 369},
  [13887] = {.lex_state = 55, .external_lex_state = 406},
  [13888] = {.lex_state = 58, .external_lex_state = 399},
  [13889] = {.lex_state = 57, .external_lex_state = 405},
  [13890] = {.lex_state = 0, .external_lex_state = 369},
  [13891] = {.lex_state = 58, .external_lex_state = 242},
  [13892] = {.lex_state = 55, .external_lex_state = 308},
  [13893] = {.lex_state = 55, .external_lex_state = 308},
  [13894] = {.lex_state = 55, .external_lex_state = 308},
  [13895] = {.lex_state = 58, .external_lex_state = 402},
  [13896] = {.lex_state = 58, .external_lex_state = 409},
  [13897] = {.lex_state = 0, .external_lex_state = 369},
  [13898] = {.lex_state = 58, .external_lex_state = 391},
  [13899] = {.lex_state = 55, .external_lex_state = 308},
  [13900] = {.lex_state = 0, .external_lex_state = 369},
  [13901] = {.lex_state = 55, .external_lex_state = 308},
  [13902] = {.lex_state = 55, .external_lex_state = 308},
  [13903] = {.lex_state = 0, .external_lex_state = 350},
  [13904] = {.lex_state = 0, .external_lex_state = 369},
  [13905] = {.lex_state = 55, .external_lex_state = 308},
  [13906] = {.lex_state = 0, .external_lex_state = 369},
  [13907] = {.lex_state = 0, .external_lex_state = 410},
  [13908] = {.lex_state = 55, .external_lex_state = 308},
  [13909] = {.lex_state = 55, .external_lex_state = 377},
  [13910] = {.lex_state = 55, .external_lex_state = 308},
  [13911] = {.lex_state = 55, .external_lex_state = 308},
  [13912] = {.lex_state = 60, .external_lex_state = 376},
  [13913] = {.lex_state = 58, .external_lex_state = 392},
  [13914] = {.lex_state = 0, .external_lex_state = 369},
  [13915] = {.lex_state = 57, .external_lex_state = 308},
  [13916] = {.lex_state = 0, .external_lex_state = 369},
  [13917] = {.lex_state = 55, .external_lex_state = 386},
  [13918] = {.lex_state = 0, .external_lex_state = 404},
  [13919] = {.lex_state = 58, .external_lex_state = 408},
  [13920] = {.lex_state = 0, .external_lex_state = 411},
  [13921] = {.lex_state = 55, .external_lex_state = 308},
  [13922] = {.lex_state = 58, .external_lex_state = 376},
  [13923] = {.lex_state = 55, .external_lex_state = 308},
  [13924] = {.lex_state = 55, .external_lex_state = 308},
  [13925] = {.lex_state = 55, .external_lex_state = 308},
  [13926] = {.lex_state = 0, .external_lex_state = 410},
  [13927] = {.lex_state = 55, .external_lex_state = 308},
  [13928] = {.lex_state = 58, .external_lex_state = 400},
  [13929] = {.lex_state = 0, .external_lex_state = 369},
  [13930] = {.lex_state = 57, .external_lex_state = 367},
  [13931] = {.lex_state = 0, .external_lex_state = 339},
  [13932] = {.lex_state = 58, .external_lex_state = 242},
  [13933] = {.lex_state = 0, .external_lex_state = 369},
  [13934] = {.lex_state = 55, .external_lex_state = 398},
  [13935] = {.lex_state = 55, .external_lex_state = 308},
  [13936] = {.lex_state = 58, .external_lex_state = 392},
  [13937] = {.lex_state = 55, .external_lex_state = 386},
  [13938] = {.lex_state = 55, .external_lex_state = 308},
  [13939] = {.lex_state = 0, .external_lex_state = 369},
  [13940] = {.lex_state = 55, .external_lex_state = 308},
  [13941] = {.lex_state = 55, .external_lex_state = 308},
  [13942] = {.lex_state = 55, .external_lex_state = 308},
  [13943] = {.lex_state = 0, .external_lex_state = 369},
  [13944] = {.lex_state = 0, .external_lex_state = 325},
  [13945] = {.lex_state = 55, .external_lex_state = 308},
  [13946] = {.lex_state = 55, .external_lex_state = 386},
  [13947] = {.lex_state = 0, .external_lex_state = 411},
  [13948] = {.lex_state = 55, .external_lex_state = 308},
  [13949] = {.lex_state = 0, .external_lex_state = 325},
  [13950] = {.lex_state = 0, .external_lex_state = 325},
  [13951] = {.lex_state = 55, .external_lex_state = 308},
  [13952] = {.lex_state = 0, .external_lex_state = 325},
  [13953] = {.lex_state = 55, .external_lex_state = 308},
  [13954] = {.lex_state = 58, .external_lex_state = 392},
  [13955] = {.lex_state = 57, .external_lex_state = 367},
  [13956] = {.lex_state = 58, .external_lex_state = 242},
  [13957] = {.lex_state = 57, .external_lex_state = 308},
  [13958] = {.lex_state = 0, .external_lex_state = 369},
  [13959] = {.lex_state = 58, .external_lex_state = 242},
  [13960] = {.lex_state = 0, .external_lex_state = 369},
  [13961] = {.lex_state = 58, .external_lex_state = 399},
  [13962] = {.lex_state = 58, .external_lex_state = 242},
  [13963] = {.lex_state = 55, .external_lex_state = 386},
  [13964] = {.lex_state = 55, .external_lex_state = 308},
  [13965] = {.lex_state = 58, .external_lex_state = 392},
  [13966] = {.lex_state = 0, .external_lex_state = 369},
  [13967] = {.lex_state = 58, .external_lex_state = 392},
  [13968] = {.lex_state = 0, .external_lex_state = 412},
  [13969] = {.lex_state = 0, .external_lex_state = 325},
  [13970] = {.lex_state = 0, .external_lex_state = 325},
  [13971] = {.lex_state = 55, .external_lex_state = 406},
  [13972] = {.lex_state = 55, .external_lex_state = 405},
  [13973] = {.lex_state = 55, .external_lex_state = 413},
  [13974] = {.lex_state = 57, .external_lex_state = 405},
  [13975] = {.lex_state = 58, .external_lex_state = 392},
  [13976] = {.lex_state = 58, .external_lex_state = 409},
  [13977] = {.lex_state = 0, .external_lex_state = 336},
  [13978] = {.lex_state = 55, .external_lex_state = 308},
  [13979] = {.lex_state = 55, .external_lex_state = 308},
  [13980] = {.lex_state = 55, .external_lex_state = 308},
  [13981] = {.lex_state = 58, .external_lex_state = 392},
  [13982] = {.lex_state = 57, .external_lex_state = 367},
  [13983] = {.lex_state = 58, .external_lex_state = 242},
  [13984] = {.lex_state = 58, .external_lex_state = 402},
  [13985] = {.lex_state = 55, .external_lex_state = 308},
  [13986] = {.lex_state = 58, .external_lex_state = 400},
  [13987] = {.lex_state = 0, .external_lex_state = 369},
  [13988] = {.lex_state = 0, .external_lex_state = 369},
  [13989] = {.lex_state = 0, .external_lex_state = 308},
  [13990] = {.lex_state = 55, .external_lex_state = 308},
  [13991] = {.lex_state = 0, .external_lex_state = 369},
  [13992] = {.lex_state = 55, .external_lex_state = 308},
  [13993] = {.lex_state = 0, .external_lex_state = 369},
  [13994] = {.lex_state = 0, .external_lex_state = 369},
  [13995] = {.lex_state = 58, .external_lex_state = 408},
  [13996] = {.lex_state = 0, .external_lex_state = 369},
  [13997] = {.lex_state = 55, .external_lex_state = 308},
  [13998] = {.lex_state = 55, .external_lex_state = 308},
  [13999] = {.lex_state = 0, .external_lex_state = 325},
  [14000] = {.lex_state = 0, .external_lex_state = 369},
  [14001] = {.lex_state = 58, .external_lex_state = 242},
  [14002] = {.lex_state = 55, .external_lex_state = 308},
  [14003] = {.lex_state = 0, .external_lex_state = 369},
  [14004] = {.lex_state = 0, .external_lex_state = 325},
  [14005] = {.lex_state = 55, .external_lex_state = 377},
  [14006] = {.lex_state = 58, .external_lex_state = 376},
  [14007] = {.lex_state = 57, .external_lex_state = 308},
  [14008] = {.lex_state = 55, .external_lex_state = 308},
  [14009] = {.lex_state = 58, .external_lex_state = 242},
  [14010] = {.lex_state = 58, .external_lex_state = 242},
  [14011] = {.lex_state = 0, .external_lex_state = 385},
  [14012] = {.lex_state = 55, .external_lex_state = 308},
  [14013] = {.lex_state = 0, .external_lex_state = 350},
  [14014] = {.lex_state = 58, .external_lex_state = 401},
  [14015] = {.lex_state = 0, .external_lex_state = 339},
  [14016] = {.lex_state = 0, .external_lex_state = 404},
  [14017] = {.lex_state = 55, .external_lex_state = 308},
  [14018] = {.lex_state = 55, .external_lex_state = 308},
  [14019] = {.lex_state = 0, .external_lex_state = 369},
  [14020] = {.lex_state = 58, .external_lex_state = 392},
  [14021] = {.lex_state = 55, .external_lex_state = 308},
  [14022] = {.lex_state = 58, .external_lex_state = 392},
  [14023] = {.lex_state = 55, .external_lex_state = 308},
  [14024] = {.lex_state = 55, .external_lex_state = 308},
  [14025] = {.lex_state = 55, .external_lex_state = 405},
  [14026] = {.lex_state = 0, .external_lex_state = 369},
  [14027] = {.lex_state = 55, .external_lex_state = 308},
  [14028] = {.lex_state = 58, .external_lex_state = 242},
  [14029] = {.lex_state = 0, .external_lex_state = 325},
  [14030] = {.lex_state = 0, .external_lex_state = 369},
  [14031] = {.lex_state = 55, .external_lex_state = 308},
  [14032] = {.lex_state = 55, .external_lex_state = 308},
  [14033] = {.lex_state = 0, .external_lex_state = 369},
  [14034] = {.lex_state = 0, .external_lex_state = 369},
  [14035] = {.lex_state = 58, .external_lex_state = 242},
  [14036] = {.lex_state = 0, .external_lex_state = 369},
  [14037] = {.lex_state = 55, .external_lex_state = 374},
  [14038] = {.lex_state = 58, .external_lex_state = 402},
  [14039] = {.lex_state = 55, .external_lex_state = 405},
  [14040] = {.lex_state = 58, .external_lex_state = 242},
  [14041] = {.lex_state = 0, .external_lex_state = 412},
  [14042] = {.lex_state = 0, .external_lex_state = 369},
  [14043] = {.lex_state = 58, .external_lex_state = 242},
  [14044] = {.lex_state = 58, .external_lex_state = 242},
  [14045] = {.lex_state = 0, .external_lex_state = 369},
  [14046] = {.lex_state = 55, .external_lex_state = 405},
  [14047] = {.lex_state = 58, .external_lex_state = 242},
  [14048] = {.lex_state = 0, .external_lex_state = 369},
  [14049] = {.lex_state = 55, .external_lex_state = 386},
  [14050] = {.lex_state = 55, .external_lex_state = 308},
  [14051] = {.lex_state = 57, .external_lex_state = 405},
  [14052] = {.lex_state = 0, .external_lex_state = 350},
  [14053] = {.lex_state = 0, .external_lex_state = 325},
  [14054] = {.lex_state = 58, .external_lex_state = 242},
  [14055] = {.lex_state = 55, .external_lex_state = 308},
  [14056] = {.lex_state = 0, .external_lex_state = 325},
  [14057] = {.lex_state = 60, .external_lex_state = 376},
  [14058] = {.lex_state = 55, .external_lex_state = 308},
  [14059] = {.lex_state = 0, .external_lex_state = 384},
  [14060] = {.lex_state = 57, .external_lex_state = 405},
  [14061] = {.lex_state = 58, .external_lex_state = 242},
  [14062] = {.lex_state = 55, .external_lex_state = 308},
  [14063] = {.lex_state = 0, .external_lex_state = 414},
  [14064] = {.lex_state = 0, .external_lex_state = 414},
  [14065] = {.lex_state = 55, .external_lex_state = 308},
  [14066] = {.lex_state = 57, .external_lex_state = 308},
  [14067] = {.lex_state = 58, .external_lex_state = 392},
  [14068] = {.lex_state = 0, .external_lex_state = 369},
  [14069] = {.lex_state = 58, .external_lex_state = 392},
  [14070] = {.lex_state = 55, .external_lex_state = 308},
  [14071] = {.lex_state = 55, .external_lex_state = 308},
  [14072] = {.lex_state = 55, .external_lex_state = 308},
  [14073] = {.lex_state = 0, .external_lex_state = 369},
  [14074] = {.lex_state = 55, .external_lex_state = 308},
  [14075] = {.lex_state = 55, .external_lex_state = 308},
  [14076] = {.lex_state = 0, .external_lex_state = 369},
  [14077] = {.lex_state = 57, .external_lex_state = 308},
  [14078] = {.lex_state = 55, .external_lex_state = 308},
  [14079] = {.lex_state = 58, .external_lex_state = 376},
  [14080] = {.lex_state = 0, .external_lex_state = 369},
  [14081] = {.lex_state = 55, .external_lex_state = 308},
  [14082] = {.lex_state = 0, .external_lex_state = 410},
  [14083] = {.lex_state = 55, .external_lex_state = 398},
  [14084] = {.lex_state = 0, .external_lex_state = 325},
  [14085] = {.lex_state = 55, .external_lex_state = 308},
  [14086] = {.lex_state = 55, .external_lex_state = 308},
  [14087] = {.lex_state = 58, .external_lex_state = 242},
  [14088] = {.lex_state = 58, .external_lex_state = 381},
  [14089] = {.lex_state = 0, .external_lex_state = 369},
  [14090] = {.lex_state = 58, .external_lex_state = 392},
  [14091] = {.lex_state = 0, .external_lex_state = 369},
  [14092] = {.lex_state = 55, .external_lex_state = 308},
  [14093] = {.lex_state = 55, .external_lex_state = 308},
  [14094] = {.lex_state = 55, .external_lex_state = 386},
  [14095] = {.lex_state = 0, .external_lex_state = 369},
  [14096] = {.lex_state = 55, .external_lex_state = 308},
  [14097] = {.lex_state = 0, .external_lex_state = 369},
  [14098] = {.lex_state = 55, .external_lex_state = 308},
  [14099] = {.lex_state = 0, .external_lex_state = 412},
  [14100] = {.lex_state = 58, .external_lex_state = 389},
  [14101] = {.lex_state = 55, .external_lex_state = 308},
  [14102] = {.lex_state = 55, .external_lex_state = 308},
  [14103] = {.lex_state = 55, .external_lex_state = 308},
  [14104] = {.lex_state = 0, .external_lex_state = 369},
  [14105] = {.lex_state = 57, .external_lex_state = 405},
  [14106] = {.lex_state = 0, .external_lex_state = 369},
  [14107] = {.lex_state = 0, .external_lex_state = 369},
  [14108] = {.lex_state = 55, .external_lex_state = 308},
  [14109] = {.lex_state = 57, .external_lex_state = 308},
  [14110] = {.lex_state = 55, .external_lex_state = 308},
  [14111] = {.lex_state = 55, .external_lex_state = 405},
  [14112] = {.lex_state = 0, .external_lex_state = 325},
  [14113] = {.lex_state = 55, .external_lex_state = 308},
  [14114] = {.lex_state = 0, .external_lex_state = 369},
  [14115] = {.lex_state = 0, .external_lex_state = 414},
  [14116] = {.lex_state = 0, .external_lex_state = 325},
  [14117] = {.lex_state = 0, .external_lex_state = 325},
  [14118] = {.lex_state = 0, .external_lex_state = 325},
  [14119] = {.lex_state = 0, .external_lex_state = 369},
  [14120] = {.lex_state = 0, .external_lex_state = 339},
  [14121] = {.lex_state = 0, .external_lex_state = 369},
  [14122] = {.lex_state = 0, .external_lex_state = 369},
  [14123] = {.lex_state = 0, .external_lex_state = 386},
  [14124] = {.lex_state = 0, .external_lex_state = 369},
  [14125] = {.lex_state = 0, .external_lex_state = 325},
  [14126] = {.lex_state = 57, .external_lex_state = 308},
  [14127] = {.lex_state = 55, .external_lex_state = 308},
  [14128] = {.lex_state = 55, .external_lex_state = 350},
  [14129] = {.lex_state = 0, .external_lex_state = 379},
  [14130] = {.lex_state = 58, .external_lex_state = 376},
  [14131] = {.lex_state = 55, .external_lex_state = 413},
  [14132] = {.lex_state = 57, .external_lex_state = 308},
  [14133] = {.lex_state = 58, .external_lex_state = 376},
  [14134] = {.lex_state = 55, .external_lex_state = 339},
  [14135] = {.lex_state = 60, .external_lex_state = 381},
  [14136] = {.lex_state = 55, .external_lex_state = 415},
  [14137] = {.lex_state = 0, .external_lex_state = 416},
  [14138] = {.lex_state = 55, .external_lex_state = 339},
  [14139] = {.lex_state = 55, .external_lex_state = 415},
  [14140] = {.lex_state = 55, .external_lex_state = 339},
  [14141] = {.lex_state = 58, .external_lex_state = 376},
  [14142] = {.lex_state = 0, .external_lex_state = 251},
  [14143] = {.lex_state = 55, .external_lex_state = 308},
  [14144] = {.lex_state = 55, .external_lex_state = 417},
  [14145] = {.lex_state = 0, .external_lex_state = 418},
  [14146] = {.lex_state = 0, .external_lex_state = 385},
  [14147] = {.lex_state = 55, .external_lex_state = 308},
  [14148] = {.lex_state = 55, .external_lex_state = 415},
  [14149] = {.lex_state = 58, .external_lex_state = 376},
  [14150] = {.lex_state = 55, .external_lex_state = 415},
  [14151] = {.lex_state = 55, .external_lex_state = 308},
  [14152] = {.lex_state = 58, .external_lex_state = 389},
  [14153] = {.lex_state = 0, .external_lex_state = 414},
  [14154] = {.lex_state = 55, .external_lex_state = 350},
  [14155] = {.lex_state = 55, .external_lex_state = 415},
  [14156] = {.lex_state = 0, .external_lex_state = 251},
  [14157] = {.lex_state = 55, .external_lex_state = 308},
  [14158] = {.lex_state = 55, .external_lex_state = 415},
  [14159] = {.lex_state = 55, .external_lex_state = 415},
  [14160] = {.lex_state = 0, .external_lex_state = 384},
  [14161] = {.lex_state = 55, .external_lex_state = 415},
  [14162] = {.lex_state = 55, .external_lex_state = 415},
  [14163] = {.lex_state = 0, .external_lex_state = 412},
  [14164] = {.lex_state = 55, .external_lex_state = 308},
  [14165] = {.lex_state = 55, .external_lex_state = 333},
  [14166] = {.lex_state = 55, .external_lex_state = 308},
  [14167] = {.lex_state = 55, .external_lex_state = 350},
  [14168] = {.lex_state = 0, .external_lex_state = 336},
  [14169] = {.lex_state = 58, .external_lex_state = 390},
  [14170] = {.lex_state = 55, .external_lex_state = 308},
  [14171] = {.lex_state = 0, .external_lex_state = 385},
  [14172] = {.lex_state = 0, .external_lex_state = 336},
  [14173] = {.lex_state = 58, .external_lex_state = 376},
  [14174] = {.lex_state = 58, .external_lex_state = 376},
  [14175] = {.lex_state = 55, .external_lex_state = 415},
  [14176] = {.lex_state = 55, .external_lex_state = 415},
  [14177] = {.lex_state = 55, .external_lex_state = 415},
  [14178] = {.lex_state = 55, .external_lex_state = 415},
  [14179] = {.lex_state = 57, .external_lex_state = 386},
  [14180] = {.lex_state = 55, .external_lex_state = 308},
  [14181] = {.lex_state = 58, .external_lex_state = 376},
  [14182] = {.lex_state = 58, .external_lex_state = 381},
  [14183] = {.lex_state = 60, .external_lex_state = 382},
  [14184] = {.lex_state = 55, .external_lex_state = 308},
  [14185] = {.lex_state = 0, .external_lex_state = 418},
  [14186] = {.lex_state = 55, .external_lex_state = 308},
  [14187] = {.lex_state = 55, .external_lex_state = 415},
  [14188] = {.lex_state = 55, .external_lex_state = 308},
  [14189] = {.lex_state = 0, .external_lex_state = 367},
  [14190] = {.lex_state = 55, .external_lex_state = 415},
  [14191] = {.lex_state = 55, .external_lex_state = 308},
  [14192] = {.lex_state = 55, .external_lex_state = 308},
  [14193] = {.lex_state = 0, .external_lex_state = 251},
  [14194] = {.lex_state = 57, .external_lex_state = 308},
  [14195] = {.lex_state = 55, .external_lex_state = 308},
  [14196] = {.lex_state = 0, .external_lex_state = 251},
  [14197] = {.lex_state = 55, .external_lex_state = 415},
  [14198] = {.lex_state = 55, .external_lex_state = 415},
  [14199] = {.lex_state = 0, .external_lex_state = 350},
  [14200] = {.lex_state = 57, .external_lex_state = 308},
  [14201] = {.lex_state = 0, .external_lex_state = 379},
  [14202] = {.lex_state = 55, .external_lex_state = 308},
  [14203] = {.lex_state = 0, .external_lex_state = 384},
  [14204] = {.lex_state = 57, .external_lex_state = 308},
  [14205] = {.lex_state = 55, .external_lex_state = 308},
  [14206] = {.lex_state = 0, .external_lex_state = 418},
  [14207] = {.lex_state = 55, .external_lex_state = 415},
  [14208] = {.lex_state = 0, .external_lex_state = 336},
  [14209] = {.lex_state = 58, .external_lex_state = 376},
  [14210] = {.lex_state = 55, .external_lex_state = 415},
  [14211] = {.lex_state = 58, .external_lex_state = 390},
  [14212] = {.lex_state = 0, .external_lex_state = 367},
  [14213] = {.lex_state = 55, .external_lex_state = 415},
  [14214] = {.lex_state = 55, .external_lex_state = 415},
  [14215] = {.lex_state = 0, .external_lex_state = 251},
  [14216] = {.lex_state = 55, .external_lex_state = 415},
  [14217] = {.lex_state = 58, .external_lex_state = 376},
  [14218] = {.lex_state = 58, .external_lex_state = 390},
  [14219] = {.lex_state = 55, .external_lex_state = 308},
  [14220] = {.lex_state = 55, .external_lex_state = 415},
  [14221] = {.lex_state = 55, .external_lex_state = 415},
  [14222] = {.lex_state = 0, .external_lex_state = 410},
  [14223] = {.lex_state = 55, .external_lex_state = 339},
  [14224] = {.lex_state = 55, .external_lex_state = 308},
  [14225] = {.lex_state = 0, .external_lex_state = 336},
  [14226] = {.lex_state = 55, .external_lex_state = 419},
  [14227] = {.lex_state = 55, .external_lex_state = 415},
  [14228] = {.lex_state = 55, .external_lex_state = 415},
  [14229] = {.lex_state = 55, .external_lex_state = 415},
  [14230] = {.lex_state = 0, .external_lex_state = 215},
  [14231] = {.lex_state = 0, .external_lex_state = 251},
  [14232] = {.lex_state = 55, .external_lex_state = 415},
  [14233] = {.lex_state = 55, .external_lex_state = 415},
  [14234] = {.lex_state = 55, .external_lex_state = 339},
  [14235] = {.lex_state = 55, .external_lex_state = 415},
  [14236] = {.lex_state = 55, .external_lex_state = 308},
  [14237] = {.lex_state = 55, .external_lex_state = 415},
  [14238] = {.lex_state = 0, .external_lex_state = 420},
  [14239] = {.lex_state = 0, .external_lex_state = 251},
  [14240] = {.lex_state = 55, .external_lex_state = 415},
  [14241] = {.lex_state = 55, .external_lex_state = 415},
  [14242] = {.lex_state = 57, .external_lex_state = 308},
  [14243] = {.lex_state = 58, .external_lex_state = 376},
  [14244] = {.lex_state = 55, .external_lex_state = 308},
  [14245] = {.lex_state = 55, .external_lex_state = 415},
  [14246] = {.lex_state = 55, .external_lex_state = 308},
  [14247] = {.lex_state = 0, .external_lex_state = 336},
  [14248] = {.lex_state = 58, .external_lex_state = 376},
  [14249] = {.lex_state = 58, .external_lex_state = 390},
  [14250] = {.lex_state = 55, .external_lex_state = 308},
  [14251] = {.lex_state = 58, .external_lex_state = 376},
  [14252] = {.lex_state = 55, .external_lex_state = 308},
  [14253] = {.lex_state = 55, .external_lex_state = 415},
  [14254] = {.lex_state = 55, .external_lex_state = 415},
  [14255] = {.lex_state = 55, .external_lex_state = 415},
  [14256] = {.lex_state = 55, .external_lex_state = 415},
  [14257] = {.lex_state = 55, .external_lex_state = 415},
  [14258] = {.lex_state = 58, .external_lex_state = 376},
  [14259] = {.lex_state = 58, .external_lex_state = 376},
  [14260] = {.lex_state = 55, .external_lex_state = 415},
  [14261] = {.lex_state = 58, .external_lex_state = 389},
  [14262] = {.lex_state = 55, .external_lex_state = 308},
  [14263] = {.lex_state = 55, .external_lex_state = 415},
  [14264] = {.lex_state = 55, .external_lex_state = 415},
  [14265] = {.lex_state = 58, .external_lex_state = 381},
  [14266] = {.lex_state = 58, .external_lex_state = 391},
  [14267] = {.lex_state = 57, .external_lex_state = 407},
  [14268] = {.lex_state = 58, .external_lex_state = 376},
  [14269] = {.lex_state = 55, .external_lex_state = 308},
  [14270] = {.lex_state = 58, .external_lex_state = 389},
  [14271] = {.lex_state = 55, .external_lex_state = 415},
  [14272] = {.lex_state = 58, .external_lex_state = 391},
  [14273] = {.lex_state = 0, .external_lex_state = 385},
  [14274] = {.lex_state = 55, .external_lex_state = 421},
  [14275] = {.lex_state = 57, .external_lex_state = 407},
  [14276] = {.lex_state = 0, .external_lex_state = 379},
  [14277] = {.lex_state = 55, .external_lex_state = 415},
  [14278] = {.lex_state = 55, .external_lex_state = 415},
  [14279] = {.lex_state = 0, .external_lex_state = 396},
  [14280] = {.lex_state = 0, .external_lex_state = 414},
  [14281] = {.lex_state = 57, .external_lex_state = 386},
  [14282] = {.lex_state = 55, .external_lex_state = 415},
  [14283] = {.lex_state = 55, .external_lex_state = 415},
  [14284] = {.lex_state = 58, .external_lex_state = 376},
  [14285] = {.lex_state = 55, .external_lex_state = 415},
  [14286] = {.lex_state = 58, .external_lex_state = 376},
  [14287] = {.lex_state = 0, .external_lex_state = 420},
  [14288] = {.lex_state = 55, .external_lex_state = 415},
  [14289] = {.lex_state = 55, .external_lex_state = 415},
  [14290] = {.lex_state = 55, .external_lex_state = 415},
  [14291] = {.lex_state = 58, .external_lex_state = 390},
  [14292] = {.lex_state = 58, .external_lex_state = 376},
  [14293] = {.lex_state = 57, .external_lex_state = 405},
  [14294] = {.lex_state = 58, .external_lex_state = 376},
  [14295] = {.lex_state = 58, .external_lex_state = 376},
  [14296] = {.lex_state = 58, .external_lex_state = 376},
  [14297] = {.lex_state = 55, .external_lex_state = 308},
  [14298] = {.lex_state = 0, .external_lex_state = 395},
  [14299] = {.lex_state = 58, .external_lex_state = 376},
  [14300] = {.lex_state = 58, .external_lex_state = 376},
  [14301] = {.lex_state = 0, .external_lex_state = 416},
  [14302] = {.lex_state = 55, .external_lex_state = 415},
  [14303] = {.lex_state = 0, .external_lex_state = 416},
  [14304] = {.lex_state = 55, .external_lex_state = 308},
  [14305] = {.lex_state = 58, .external_lex_state = 376},
  [14306] = {.lex_state = 55, .external_lex_state = 415},
  [14307] = {.lex_state = 58, .external_lex_state = 390},
  [14308] = {.lex_state = 55, .external_lex_state = 415},
  [14309] = {.lex_state = 55, .external_lex_state = 308},
  [14310] = {.lex_state = 58, .external_lex_state = 376},
  [14311] = {.lex_state = 0, .external_lex_state = 367},
  [14312] = {.lex_state = 58, .external_lex_state = 376},
  [14313] = {.lex_state = 57, .external_lex_state = 374},
  [14314] = {.lex_state = 58, .external_lex_state = 390},
  [14315] = {.lex_state = 0, .external_lex_state = 411},
  [14316] = {.lex_state = 57, .external_lex_state = 386},
  [14317] = {.lex_state = 0, .external_lex_state = 385},
  [14318] = {.lex_state = 57, .external_lex_state = 405},
  [14319] = {.lex_state = 58, .external_lex_state = 408},
  [14320] = {.lex_state = 58, .external_lex_state = 376},
  [14321] = {.lex_state = 58, .external_lex_state = 376},
  [14322] = {.lex_state = 0, .external_lex_state = 410},
  [14323] = {.lex_state = 60, .external_lex_state = 382},
  [14324] = {.lex_state = 58, .external_lex_state = 409},
  [14325] = {.lex_state = 57, .external_lex_state = 308},
  [14326] = {.lex_state = 55, .external_lex_state = 308},
  [14327] = {.lex_state = 55, .external_lex_state = 415},
  [14328] = {.lex_state = 55, .external_lex_state = 308},
  [14329] = {.lex_state = 55, .external_lex_state = 308},
  [14330] = {.lex_state = 55, .external_lex_state = 415},
  [14331] = {.lex_state = 55, .external_lex_state = 415},
  [14332] = {.lex_state = 55, .external_lex_state = 415},
  [14333] = {.lex_state = 0, .external_lex_state = 336},
  [14334] = {.lex_state = 55, .external_lex_state = 308},
  [14335] = {.lex_state = 55, .external_lex_state = 308},
  [14336] = {.lex_state = 55, .external_lex_state = 415},
  [14337] = {.lex_state = 55, .external_lex_state = 415},
  [14338] = {.lex_state = 58, .external_lex_state = 376},
  [14339] = {.lex_state = 55, .external_lex_state = 415},
  [14340] = {.lex_state = 55, .external_lex_state = 415},
  [14341] = {.lex_state = 55, .external_lex_state = 415},
  [14342] = {.lex_state = 58, .external_lex_state = 376},
  [14343] = {.lex_state = 55, .external_lex_state = 308},
  [14344] = {.lex_state = 58, .external_lex_state = 376},
  [14345] = {.lex_state = 55, .external_lex_state = 415},
  [14346] = {.lex_state = 55, .external_lex_state = 415},
  [14347] = {.lex_state = 55, .external_lex_state = 415},
  [14348] = {.lex_state = 0, .external_lex_state = 308},
  [14349] = {.lex_state = 55, .external_lex_state = 415},
  [14350] = {.lex_state = 55, .external_lex_state = 415},
  [14351] = {.lex_state = 55, .external_lex_state = 415},
  [14352] = {.lex_state = 58, .external_lex_state = 397},
  [14353] = {.lex_state = 58, .external_lex_state = 408},
  [14354] = {.lex_state = 0, .external_lex_state = 339},
  [14355] = {.lex_state = 0, .external_lex_state = 394},
  [14356] = {.lex_state = 55, .external_lex_state = 308},
  [14357] = {.lex_state = 55, .external_lex_state = 415},
  [14358] = {.lex_state = 58, .external_lex_state = 389},
  [14359] = {.lex_state = 55, .external_lex_state = 415},
  [14360] = {.lex_state = 58, .external_lex_state = 376},
  [14361] = {.lex_state = 55, .external_lex_state = 415},
  [14362] = {.lex_state = 55, .external_lex_state = 308},
  [14363] = {.lex_state = 55, .external_lex_state = 308},
  [14364] = {.lex_state = 55, .external_lex_state = 419},
  [14365] = {.lex_state = 55, .external_lex_state = 415},
  [14366] = {.lex_state = 57, .external_lex_state = 386},
  [14367] = {.lex_state = 55, .external_lex_state = 415},
  [14368] = {.lex_state = 58, .external_lex_state = 376},
  [14369] = {.lex_state = 0, .external_lex_state = 384},
  [14370] = {.lex_state = 60, .external_lex_state = 381},
  [14371] = {.lex_state = 55, .external_lex_state = 415},
  [14372] = {.lex_state = 55, .external_lex_state = 415},
  [14373] = {.lex_state = 58, .external_lex_state = 376},
  [14374] = {.lex_state = 55, .external_lex_state = 415},
  [14375] = {.lex_state = 55, .external_lex_state = 308},
  [14376] = {.lex_state = 55, .external_lex_state = 415},
  [14377] = {.lex_state = 57, .external_lex_state = 308},
  [14378] = {.lex_state = 55, .external_lex_state = 308},
  [14379] = {.lex_state = 58, .external_lex_state = 376},
  [14380] = {.lex_state = 55, .external_lex_state = 415},
  [14381] = {.lex_state = 55, .external_lex_state = 415},
  [14382] = {.lex_state = 55, .external_lex_state = 415},
  [14383] = {.lex_state = 55, .external_lex_state = 415},
  [14384] = {.lex_state = 55, .external_lex_state = 415},
  [14385] = {.lex_state = 58, .external_lex_state = 390},
  [14386] = {.lex_state = 55, .external_lex_state = 393},
  [14387] = {.lex_state = 0, .external_lex_state = 251},
  [14388] = {.lex_state = 55, .external_lex_state = 415},
  [14389] = {.lex_state = 55, .external_lex_state = 415},
  [14390] = {.lex_state = 58, .external_lex_state = 376},
  [14391] = {.lex_state = 55, .external_lex_state = 415},
  [14392] = {.lex_state = 57, .external_lex_state = 308},
  [14393] = {.lex_state = 55, .external_lex_state = 415},
  [14394] = {.lex_state = 55, .external_lex_state = 308},
  [14395] = {.lex_state = 55, .external_lex_state = 415},
  [14396] = {.lex_state = 57, .external_lex_state = 386},
  [14397] = {.lex_state = 58, .external_lex_state = 376},
  [14398] = {.lex_state = 55, .external_lex_state = 415},
  [14399] = {.lex_state = 0, .external_lex_state = 412},
  [14400] = {.lex_state = 58, .external_lex_state = 382},
  [14401] = {.lex_state = 55, .external_lex_state = 415},
  [14402] = {.lex_state = 55, .external_lex_state = 415},
  [14403] = {.lex_state = 58, .external_lex_state = 390},
  [14404] = {.lex_state = 55, .external_lex_state = 415},
  [14405] = {.lex_state = 55, .external_lex_state = 415},
  [14406] = {.lex_state = 55, .external_lex_state = 393},
  [14407] = {.lex_state = 58, .external_lex_state = 390},
  [14408] = {.lex_state = 55, .external_lex_state = 348},
  [14409] = {.lex_state = 58, .external_lex_state = 376},
  [14410] = {.lex_state = 55, .external_lex_state = 415},
  [14411] = {.lex_state = 55, .external_lex_state = 415},
  [14412] = {.lex_state = 58, .external_lex_state = 376},
  [14413] = {.lex_state = 55, .external_lex_state = 415},
  [14414] = {.lex_state = 0, .external_lex_state = 251},
  [14415] = {.lex_state = 55, .external_lex_state = 308},
  [14416] = {.lex_state = 55, .external_lex_state = 413},
  [14417] = {.lex_state = 58, .external_lex_state = 381},
  [14418] = {.lex_state = 57, .external_lex_state = 308},
  [14419] = {.lex_state = 0, .external_lex_state = 412},
  [14420] = {.lex_state = 57, .external_lex_state = 374},
  [14421] = {.lex_state = 58, .external_lex_state = 397},
  [14422] = {.lex_state = 55, .external_lex_state = 415},
  [14423] = {.lex_state = 58, .external_lex_state = 390},
  [14424] = {.lex_state = 55, .external_lex_state = 415},
  [14425] = {.lex_state = 58, .external_lex_state = 376},
  [14426] = {.lex_state = 55, .external_lex_state = 415},
  [14427] = {.lex_state = 58, .external_lex_state = 382},
  [14428] = {.lex_state = 58, .external_lex_state = 376},
  [14429] = {.lex_state = 55, .external_lex_state = 308},
  [14430] = {.lex_state = 0, .external_lex_state = 251},
  [14431] = {.lex_state = 55, .external_lex_state = 415},
  [14432] = {.lex_state = 55, .external_lex_state = 415},
  [14433] = {.lex_state = 0, .external_lex_state = 379},
  [14434] = {.lex_state = 55, .external_lex_state = 415},
  [14435] = {.lex_state = 58, .external_lex_state = 376},
  [14436] = {.lex_state = 55, .external_lex_state = 415},
  [14437] = {.lex_state = 0, .external_lex_state = 339},
  [14438] = {.lex_state = 55, .external_lex_state = 415},
  [14439] = {.lex_state = 58, .external_lex_state = 382},
  [14440] = {.lex_state = 55, .external_lex_state = 415},
  [14441] = {.lex_state = 55, .external_lex_state = 415},
  [14442] = {.lex_state = 57, .external_lex_state = 405},
  [14443] = {.lex_state = 58, .external_lex_state = 397},
  [14444] = {.lex_state = 0, .external_lex_state = 336},
  [14445] = {.lex_state = 0, .external_lex_state = 385},
  [14446] = {.lex_state = 0, .external_lex_state = 339},
  [14447] = {.lex_state = 58, .external_lex_state = 376},
  [14448] = {.lex_state = 55, .external_lex_state = 415},
  [14449] = {.lex_state = 55, .external_lex_state = 415},
  [14450] = {.lex_state = 55, .external_lex_state = 415},
  [14451] = {.lex_state = 0, .external_lex_state = 420},
  [14452] = {.lex_state = 58, .external_lex_state = 376},
  [14453] = {.lex_state = 57, .external_lex_state = 308},
  [14454] = {.lex_state = 55, .external_lex_state = 415},
  [14455] = {.lex_state = 58, .external_lex_state = 401},
  [14456] = {.lex_state = 55, .external_lex_state = 415},
  [14457] = {.lex_state = 55, .external_lex_state = 415},
  [14458] = {.lex_state = 0, .external_lex_state = 414},
  [14459] = {.lex_state = 57, .external_lex_state = 405},
  [14460] = {.lex_state = 58, .external_lex_state = 376},
  [14461] = {.lex_state = 55, .external_lex_state = 308},
  [14462] = {.lex_state = 55, .external_lex_state = 415},
  [14463] = {.lex_state = 55, .external_lex_state = 415},
  [14464] = {.lex_state = 0, .external_lex_state = 215},
  [14465] = {.lex_state = 0, .external_lex_state = 410},
  [14466] = {.lex_state = 55, .external_lex_state = 308},
  [14467] = {.lex_state = 57, .external_lex_state = 374},
  [14468] = {.lex_state = 58, .external_lex_state = 376},
  [14469] = {.lex_state = 55, .external_lex_state = 374},
  [14470] = {.lex_state = 58, .external_lex_state = 376},
  [14471] = {.lex_state = 55, .external_lex_state = 374},
  [14472] = {.lex_state = 55, .external_lex_state = 415},
  [14473] = {.lex_state = 58, .external_lex_state = 376},
  [14474] = {.lex_state = 58, .external_lex_state = 376},
  [14475] = {.lex_state = 55, .external_lex_state = 308},
  [14476] = {.lex_state = 55, .external_lex_state = 415},
  [14477] = {.lex_state = 55, .external_lex_state = 308},
  [14478] = {.lex_state = 58, .external_lex_state = 409},
  [14479] = {.lex_state = 55, .external_lex_state = 374},
  [14480] = {.lex_state = 55, .external_lex_state = 415},
  [14481] = {.lex_state = 55, .external_lex_state = 415},
  [14482] = {.lex_state = 55, .external_lex_state = 415},
  [14483] = {.lex_state = 55, .external_lex_state = 415},
  [14484] = {.lex_state = 55, .external_lex_state = 415},
  [14485] = {.lex_state = 55, .external_lex_state = 308},
  [14486] = {.lex_state = 55, .external_lex_state = 350},
  [14487] = {.lex_state = 57, .external_lex_state = 308},
  [14488] = {.lex_state = 55, .external_lex_state = 350},
  [14489] = {.lex_state = 55, .external_lex_state = 415},
  [14490] = {.lex_state = 55, .external_lex_state = 308},
  [14491] = {.lex_state = 55, .external_lex_state = 415},
  [14492] = {.lex_state = 58, .external_lex_state = 390},
  [14493] = {.lex_state = 55, .external_lex_state = 415},
  [14494] = {.lex_state = 55, .external_lex_state = 415},
  [14495] = {.lex_state = 0, .external_lex_state = 384},
  [14496] = {.lex_state = 55, .external_lex_state = 415},
  [14497] = {.lex_state = 57, .external_lex_state = 308},
  [14498] = {.lex_state = 0, .external_lex_state = 367},
  [14499] = {.lex_state = 0, .external_lex_state = 367},
  [14500] = {.lex_state = 55, .external_lex_state = 308},
  [14501] = {.lex_state = 55, .external_lex_state = 415},
  [14502] = {.lex_state = 0, .external_lex_state = 215},
  [14503] = {.lex_state = 57, .external_lex_state = 308},
  [14504] = {.lex_state = 57, .external_lex_state = 308},
  [14505] = {.lex_state = 55, .external_lex_state = 339},
  [14506] = {.lex_state = 55, .external_lex_state = 374},
  [14507] = {.lex_state = 55, .external_lex_state = 415},
  [14508] = {.lex_state = 55, .external_lex_state = 415},
  [14509] = {.lex_state = 0, .external_lex_state = 367},
  [14510] = {.lex_state = 55, .external_lex_state = 308},
  [14511] = {.lex_state = 58, .external_lex_state = 409},
  [14512] = {.lex_state = 55, .external_lex_state = 350},
  [14513] = {.lex_state = 55, .external_lex_state = 415},
  [14514] = {.lex_state = 55, .external_lex_state = 308},
  [14515] = {.lex_state = 55, .external_lex_state = 308},
  [14516] = {.lex_state = 55, .external_lex_state = 415},
  [14517] = {.lex_state = 58, .external_lex_state = 408},
  [14518] = {.lex_state = 0, .external_lex_state = 379},
  [14519] = {.lex_state = 57, .external_lex_state = 308},
  [14520] = {.lex_state = 55, .external_lex_state = 415},
  [14521] = {.lex_state = 55, .external_lex_state = 415},
  [14522] = {.lex_state = 58, .external_lex_state = 376},
  [14523] = {.lex_state = 55, .external_lex_state = 415},
  [14524] = {.lex_state = 55, .external_lex_state = 308},
  [14525] = {.lex_state = 55, .external_lex_state = 308},
  [14526] = {.lex_state = 55, .external_lex_state = 417},
  [14527] = {.lex_state = 55, .external_lex_state = 415},
  [14528] = {.lex_state = 57, .external_lex_state = 386},
  [14529] = {.lex_state = 57, .external_lex_state = 405},
  [14530] = {.lex_state = 58, .external_lex_state = 390},
  [14531] = {.lex_state = 58, .external_lex_state = 376},
  [14532] = {.lex_state = 58, .external_lex_state = 390},
  [14533] = {.lex_state = 0, .external_lex_state = 384},
  [14534] = {.lex_state = 58, .external_lex_state = 390},
  [14535] = {.lex_state = 55, .external_lex_state = 415},
  [14536] = {.lex_state = 55, .external_lex_state = 415},
  [14537] = {.lex_state = 57, .external_lex_state = 407},
  [14538] = {.lex_state = 55, .external_lex_state = 308},
  [14539] = {.lex_state = 55, .external_lex_state = 308},
  [14540] = {.lex_state = 58, .external_lex_state = 376},
  [14541] = {.lex_state = 55, .external_lex_state = 415},
  [14542] = {.lex_state = 55, .external_lex_state = 308},
  [14543] = {.lex_state = 58, .external_lex_state = 381},
  [14544] = {.lex_state = 0, .external_lex_state = 379},
  [14545] = {.lex_state = 0, .external_lex_state = 379},
  [14546] = {.lex_state = 55, .external_lex_state = 386},
  [14547] = {.lex_state = 0, .external_lex_state = 385},
  [14548] = {.lex_state = 0, .external_lex_state = 200},
  [14549] = {.lex_state = 58, .external_lex_state = 382},
  [14550] = {.lex_state = 55, .external_lex_state = 386},
  [14551] = {.lex_state = 0, .external_lex_state = 251},
  [14552] = {.lex_state = 55, .external_lex_state = 386},
  [14553] = {.lex_state = 0, .external_lex_state = 379},
  [14554] = {.lex_state = 0, .external_lex_state = 308},
  [14555] = {.lex_state = 58, .external_lex_state = 382},
  [14556] = {.lex_state = 0, .external_lex_state = 385},
  [14557] = {.lex_state = 58, .external_lex_state = 382},
  [14558] = {.lex_state = 58, .external_lex_state = 382},
  [14559] = {.lex_state = 0, .external_lex_state = 384},
  [14560] = {.lex_state = 58, .external_lex_state = 382},
  [14561] = {.lex_state = 0, .external_lex_state = 385},
  [14562] = {.lex_state = 0, .external_lex_state = 385},
  [14563] = {.lex_state = 55, .external_lex_state = 386},
  [14564] = {.lex_state = 55, .external_lex_state = 386},
  [14565] = {.lex_state = 58, .external_lex_state = 382},
  [14566] = {.lex_state = 0, .external_lex_state = 384},
  [14567] = {.lex_state = 55, .external_lex_state = 422},
  [14568] = {.lex_state = 0, .external_lex_state = 385},
  [14569] = {.lex_state = 0, .external_lex_state = 385},
  [14570] = {.lex_state = 0, .external_lex_state = 350},
  [14571] = {.lex_state = 58, .external_lex_state = 382},
  [14572] = {.lex_state = 0, .external_lex_state = 385},
  [14573] = {.lex_state = 0, .external_lex_state = 385},
  [14574] = {.lex_state = 0, .external_lex_state = 385},
  [14575] = {.lex_state = 0, .external_lex_state = 395},
  [14576] = {.lex_state = 0, .external_lex_state = 385},
  [14577] = {.lex_state = 58, .external_lex_state = 382},
  [14578] = {.lex_state = 0, .external_lex_state = 394},
  [14579] = {.lex_state = 58, .external_lex_state = 382},
  [14580] = {.lex_state = 58, .external_lex_state = 382},
  [14581] = {.lex_state = 58, .external_lex_state = 381},
  [14582] = {.lex_state = 0, .external_lex_state = 394},
  [14583] = {.lex_state = 58, .external_lex_state = 382},
  [14584] = {.lex_state = 58, .external_lex_state = 382},
  [14585] = {.lex_state = 0, .external_lex_state = 396},
  [14586] = {.lex_state = 0, .external_lex_state = 385},
  [14587] = {.lex_state = 57, .external_lex_state = 423},
  [14588] = {.lex_state = 0, .external_lex_state = 384},
  [14589] = {.lex_state = 55, .external_lex_state = 339},
  [14590] = {.lex_state = 0, .external_lex_state = 384},
  [14591] = {.lex_state = 55, .external_lex_state = 333},
  [14592] = {.lex_state = 58, .external_lex_state = 382},
  [14593] = {.lex_state = 0, .external_lex_state = 418},
  [14594] = {.lex_state = 57, .external_lex_state = 308},
  [14595] = {.lex_state = 58, .external_lex_state = 381},
  [14596] = {.lex_state = 0, .external_lex_state = 395},
  [14597] = {.lex_state = 57, .external_lex_state = 423},
  [14598] = {.lex_state = 0, .external_lex_state = 395},
  [14599] = {.lex_state = 0, .external_lex_state = 384},
  [14600] = {.lex_state = 58, .external_lex_state = 381},
  [14601] = {.lex_state = 57, .external_lex_state = 423},
  [14602] = {.lex_state = 0, .external_lex_state = 394},
  [14603] = {.lex_state = 0, .external_lex_state = 395},
  [14604] = {.lex_state = 0, .external_lex_state = 418},
  [14605] = {.lex_state = 0, .external_lex_state = 384},
  [14606] = {.lex_state = 57, .external_lex_state = 308},
  [14607] = {.lex_state = 58, .external_lex_state = 381},
  [14608] = {.lex_state = 57, .external_lex_state = 308},
  [14609] = {.lex_state = 0, .external_lex_state = 384},
  [14610] = {.lex_state = 57, .external_lex_state = 423},
  [14611] = {.lex_state = 58, .external_lex_state = 382},
  [14612] = {.lex_state = 58, .external_lex_state = 382},
  [14613] = {.lex_state = 58, .external_lex_state = 382},
  [14614] = {.lex_state = 58, .external_lex_state = 382},
  [14615] = {.lex_state = 58, .external_lex_state = 382},
  [14616] = {.lex_state = 0, .external_lex_state = 384},
  [14617] = {.lex_state = 55, .external_lex_state = 386},
  [14618] = {.lex_state = 55, .external_lex_state = 386},
  [14619] = {.lex_state = 0, .external_lex_state = 384},
  [14620] = {.lex_state = 0, .external_lex_state = 394},
  [14621] = {.lex_state = 55, .external_lex_state = 374},
  [14622] = {.lex_state = 0, .external_lex_state = 200},
  [14623] = {.lex_state = 0, .external_lex_state = 385},
  [14624] = {.lex_state = 0, .external_lex_state = 396},
  [14625] = {.lex_state = 0, .external_lex_state = 385},
  [14626] = {.lex_state = 57, .external_lex_state = 423},
  [14627] = {.lex_state = 0, .external_lex_state = 384},
  [14628] = {.lex_state = 58, .external_lex_state = 381},
  [14629] = {.lex_state = 0, .external_lex_state = 385},
  [14630] = {.lex_state = 0, .external_lex_state = 384},
  [14631] = {.lex_state = 0, .external_lex_state = 385},
  [14632] = {.lex_state = 0, .external_lex_state = 379},
  [14633] = {.lex_state = 58, .external_lex_state = 401},
  [14634] = {.lex_state = 0, .external_lex_state = 384},
  [14635] = {.lex_state = 0, .external_lex_state = 385},
  [14636] = {.lex_state = 55, .external_lex_state = 350},
  [14637] = {.lex_state = 55, .external_lex_state = 386},
  [14638] = {.lex_state = 55, .external_lex_state = 386},
  [14639] = {.lex_state = 0, .external_lex_state = 385},
  [14640] = {.lex_state = 0, .external_lex_state = 396},
  [14641] = {.lex_state = 0, .external_lex_state = 384},
  [14642] = {.lex_state = 55, .external_lex_state = 386},
  [14643] = {.lex_state = 0, .external_lex_state = 385},
  [14644] = {.lex_state = 0, .external_lex_state = 308},
  [14645] = {.lex_state = 0, .external_lex_state = 385},
  [14646] = {.lex_state = 55, .external_lex_state = 386},
  [14647] = {.lex_state = 0, .external_lex_state = 385},
  [14648] = {.lex_state = 0, .external_lex_state = 385},
  [14649] = {.lex_state = 0, .external_lex_state = 385},
  [14650] = {.lex_state = 0, .external_lex_state = 384},
  [14651] = {.lex_state = 58, .external_lex_state = 382},
  [14652] = {.lex_state = 0, .external_lex_state = 385},
  [14653] = {.lex_state = 58, .external_lex_state = 390},
  [14654] = {.lex_state = 0, .external_lex_state = 384},
  [14655] = {.lex_state = 58, .external_lex_state = 382},
  [14656] = {.lex_state = 58, .external_lex_state = 382},
  [14657] = {.lex_state = 0, .external_lex_state = 384},
  [14658] = {.lex_state = 0, .external_lex_state = 385},
  [14659] = {.lex_state = 55, .external_lex_state = 308},
  [14660] = {.lex_state = 55, .external_lex_state = 386},
  [14661] = {.lex_state = 55, .external_lex_state = 386},
  [14662] = {.lex_state = 0, .external_lex_state = 384},
  [14663] = {.lex_state = 0, .external_lex_state = 384},
  [14664] = {.lex_state = 0, .external_lex_state = 385},
  [14665] = {.lex_state = 58, .external_lex_state = 381},
  [14666] = {.lex_state = 58, .external_lex_state = 390},
  [14667] = {.lex_state = 0, .external_lex_state = 384},
  [14668] = {.lex_state = 58, .external_lex_state = 381},
  [14669] = {.lex_state = 0, .external_lex_state = 384},
  [14670] = {.lex_state = 0, .external_lex_state = 385},
  [14671] = {.lex_state = 55, .external_lex_state = 308},
  [14672] = {.lex_state = 58, .external_lex_state = 381},
  [14673] = {.lex_state = 0, .external_lex_state = 384},
  [14674] = {.lex_state = 0, .external_lex_state = 384},
  [14675] = {.lex_state = 55, .external_lex_state = 386},
  [14676] = {.lex_state = 0, .external_lex_state = 384},
  [14677] = {.lex_state = 55, .external_lex_state = 386},
  [14678] = {.lex_state = 55, .external_lex_state = 386},
  [14679] = {.lex_state = 0, .external_lex_state = 384},
  [14680] = {.lex_state = 55, .external_lex_state = 350},
  [14681] = {.lex_state = 55, .external_lex_state = 386},
  [14682] = {.lex_state = 0, .external_lex_state = 367},
  [14683] = {.lex_state = 0, .external_lex_state = 385},
  [14684] = {.lex_state = 58, .external_lex_state = 381},
  [14685] = {.lex_state = 55, .external_lex_state = 333},
  [14686] = {.lex_state = 58, .external_lex_state = 397},
  [14687] = {.lex_state = 58, .external_lex_state = 381},
  [14688] = {.lex_state = 58, .external_lex_state = 381},
  [14689] = {.lex_state = 0, .external_lex_state = 384},
  [14690] = {.lex_state = 58, .external_lex_state = 381},
  [14691] = {.lex_state = 0, .external_lex_state = 384},
  [14692] = {.lex_state = 58, .external_lex_state = 382},
  [14693] = {.lex_state = 58, .external_lex_state = 381},
  [14694] = {.lex_state = 58, .external_lex_state = 381},
  [14695] = {.lex_state = 58, .external_lex_state = 401},
  [14696] = {.lex_state = 58, .external_lex_state = 401},
  [14697] = {.lex_state = 57, .external_lex_state = 405},
  [14698] = {.lex_state = 0, .external_lex_state = 418},
  [14699] = {.lex_state = 58, .external_lex_state = 382},
  [14700] = {.lex_state = 58, .external_lex_state = 381},
  [14701] = {.lex_state = 58, .external_lex_state = 381},
  [14702] = {.lex_state = 58, .external_lex_state = 382},
  [14703] = {.lex_state = 57, .external_lex_state = 308},
  [14704] = {.lex_state = 58, .external_lex_state = 381},
  [14705] = {.lex_state = 57, .external_lex_state = 308},
  [14706] = {.lex_state = 58, .external_lex_state = 381},
  [14707] = {.lex_state = 58, .external_lex_state = 381},
  [14708] = {.lex_state = 0, .external_lex_state = 404},
  [14709] = {.lex_state = 57, .external_lex_state = 405},
  [14710] = {.lex_state = 55, .external_lex_state = 424},
  [14711] = {.lex_state = 0, .external_lex_state = 384},
  [14712] = {.lex_state = 55, .external_lex_state = 407},
  [14713] = {.lex_state = 58, .external_lex_state = 389},
  [14714] = {.lex_state = 57, .external_lex_state = 405},
  [14715] = {.lex_state = 0, .external_lex_state = 384},
  [14716] = {.lex_state = 58, .external_lex_state = 381},
  [14717] = {.lex_state = 0, .external_lex_state = 339},
  [14718] = {.lex_state = 58, .external_lex_state = 382},
  [14719] = {.lex_state = 0, .external_lex_state = 384},
  [14720] = {.lex_state = 58, .external_lex_state = 381},
  [14721] = {.lex_state = 58, .external_lex_state = 336},
  [14722] = {.lex_state = 0, .external_lex_state = 384},
  [14723] = {.lex_state = 58, .external_lex_state = 382},
  [14724] = {.lex_state = 0, .external_lex_state = 384},
  [14725] = {.lex_state = 58, .external_lex_state = 382},
  [14726] = {.lex_state = 58, .external_lex_state = 383},
  [14727] = {.lex_state = 57, .external_lex_state = 386},
  [14728] = {.lex_state = 58, .external_lex_state = 381},
  [14729] = {.lex_state = 0, .external_lex_state = 384},
  [14730] = {.lex_state = 0, .external_lex_state = 384},
  [14731] = {.lex_state = 58, .external_lex_state = 382},
  [14732] = {.lex_state = 58, .external_lex_state = 392},
  [14733] = {.lex_state = 57, .external_lex_state = 405},
  [14734] = {.lex_state = 0, .external_lex_state = 379},
  [14735] = {.lex_state = 58, .external_lex_state = 382},
  [14736] = {.lex_state = 0, .external_lex_state = 379},
  [14737] = {.lex_state = 58, .external_lex_state = 382},
  [14738] = {.lex_state = 57, .external_lex_state = 423},
  [14739] = {.lex_state = 0, .external_lex_state = 384},
  [14740] = {.lex_state = 0, .external_lex_state = 384},
  [14741] = {.lex_state = 57, .external_lex_state = 386},
  [14742] = {.lex_state = 0, .external_lex_state = 420},
  [14743] = {.lex_state = 58, .external_lex_state = 381},
  [14744] = {.lex_state = 58, .external_lex_state = 381},
  [14745] = {.lex_state = 58, .external_lex_state = 400},
  [14746] = {.lex_state = 58, .external_lex_state = 382},
  [14747] = {.lex_state = 0, .external_lex_state = 385},
  [14748] = {.lex_state = 0, .external_lex_state = 385},
  [14749] = {.lex_state = 58, .external_lex_state = 382},
  [14750] = {.lex_state = 0, .external_lex_state = 379},
  [14751] = {.lex_state = 58, .external_lex_state = 382},
  [14752] = {.lex_state = 58, .external_lex_state = 382},
  [14753] = {.lex_state = 0, .external_lex_state = 384},
  [14754] = {.lex_state = 0, .external_lex_state = 405},
  [14755] = {.lex_state = 58, .external_lex_state = 382},
  [14756] = {.lex_state = 58, .external_lex_state = 381},
  [14757] = {.lex_state = 0, .external_lex_state = 384},
  [14758] = {.lex_state = 57, .external_lex_state = 386},
  [14759] = {.lex_state = 0, .external_lex_state = 384},
  [14760] = {.lex_state = 0, .external_lex_state = 379},
  [14761] = {.lex_state = 0, .external_lex_state = 396},
  [14762] = {.lex_state = 0, .external_lex_state = 379},
  [14763] = {.lex_state = 58, .external_lex_state = 401},
  [14764] = {.lex_state = 55, .external_lex_state = 386},
  [14765] = {.lex_state = 55, .external_lex_state = 308},
  [14766] = {.lex_state = 58, .external_lex_state = 381},
  [14767] = {.lex_state = 55, .external_lex_state = 367},
  [14768] = {.lex_state = 0, .external_lex_state = 384},
  [14769] = {.lex_state = 0, .external_lex_state = 384},
  [14770] = {.lex_state = 0, .external_lex_state = 384},
  [14771] = {.lex_state = 57, .external_lex_state = 308},
  [14772] = {.lex_state = 0, .external_lex_state = 384},
  [14773] = {.lex_state = 58, .external_lex_state = 381},
  [14774] = {.lex_state = 55, .external_lex_state = 333},
  [14775] = {.lex_state = 58, .external_lex_state = 382},
  [14776] = {.lex_state = 0, .external_lex_state = 384},
  [14777] = {.lex_state = 58, .external_lex_state = 382},
  [14778] = {.lex_state = 57, .external_lex_state = 308},
  [14779] = {.lex_state = 0, .external_lex_state = 384},
  [14780] = {.lex_state = 0, .external_lex_state = 384},
  [14781] = {.lex_state = 58, .external_lex_state = 381},
  [14782] = {.lex_state = 58, .external_lex_state = 382},
  [14783] = {.lex_state = 0, .external_lex_state = 385},
  [14784] = {.lex_state = 0, .external_lex_state = 379},
  [14785] = {.lex_state = 0, .external_lex_state = 385},
  [14786] = {.lex_state = 58, .external_lex_state = 391},
  [14787] = {.lex_state = 0, .external_lex_state = 379},
  [14788] = {.lex_state = 55, .external_lex_state = 386},
  [14789] = {.lex_state = 58, .external_lex_state = 381},
  [14790] = {.lex_state = 55, .external_lex_state = 407},
  [14791] = {.lex_state = 0, .external_lex_state = 384},
  [14792] = {.lex_state = 0, .external_lex_state = 384},
  [14793] = {.lex_state = 58, .external_lex_state = 391},
  [14794] = {.lex_state = 57, .external_lex_state = 308},
  [14795] = {.lex_state = 58, .external_lex_state = 382},
  [14796] = {.lex_state = 57, .external_lex_state = 308},
  [14797] = {.lex_state = 58, .external_lex_state = 381},
  [14798] = {.lex_state = 0, .external_lex_state = 308},
  [14799] = {.lex_state = 58, .external_lex_state = 382},
  [14800] = {.lex_state = 0, .external_lex_state = 385},
  [14801] = {.lex_state = 0, .external_lex_state = 384},
  [14802] = {.lex_state = 55, .external_lex_state = 386},
  [14803] = {.lex_state = 0, .external_lex_state = 379},
  [14804] = {.lex_state = 57, .external_lex_state = 308},
  [14805] = {.lex_state = 58, .external_lex_state = 381},
  [14806] = {.lex_state = 55, .external_lex_state = 339},
  [14807] = {.lex_state = 0, .external_lex_state = 379},
  [14808] = {.lex_state = 58, .external_lex_state = 381},
  [14809] = {.lex_state = 0, .external_lex_state = 379},
  [14810] = {.lex_state = 57, .external_lex_state = 405},
  [14811] = {.lex_state = 0, .external_lex_state = 420},
  [14812] = {.lex_state = 0, .external_lex_state = 416},
  [14813] = {.lex_state = 0, .external_lex_state = 379},
  [14814] = {.lex_state = 58, .external_lex_state = 381},
  [14815] = {.lex_state = 58, .external_lex_state = 381},
  [14816] = {.lex_state = 0, .external_lex_state = 420},
  [14817] = {.lex_state = 57, .external_lex_state = 308},
  [14818] = {.lex_state = 58, .external_lex_state = 382},
  [14819] = {.lex_state = 58, .external_lex_state = 381},
  [14820] = {.lex_state = 0, .external_lex_state = 379},
  [14821] = {.lex_state = 58, .external_lex_state = 381},
  [14822] = {.lex_state = 0, .external_lex_state = 384},
  [14823] = {.lex_state = 0, .external_lex_state = 379},
  [14824] = {.lex_state = 58, .external_lex_state = 381},
  [14825] = {.lex_state = 0, .external_lex_state = 379},
  [14826] = {.lex_state = 58, .external_lex_state = 381},
  [14827] = {.lex_state = 0, .external_lex_state = 379},
  [14828] = {.lex_state = 55, .external_lex_state = 374},
  [14829] = {.lex_state = 0, .external_lex_state = 379},
  [14830] = {.lex_state = 0, .external_lex_state = 416},
  [14831] = {.lex_state = 55, .external_lex_state = 386},
  [14832] = {.lex_state = 0, .external_lex_state = 384},
  [14833] = {.lex_state = 0, .external_lex_state = 385},
  [14834] = {.lex_state = 0, .external_lex_state = 385},
  [14835] = {.lex_state = 58, .external_lex_state = 381},
  [14836] = {.lex_state = 0, .external_lex_state = 385},
  [14837] = {.lex_state = 58, .external_lex_state = 381},
  [14838] = {.lex_state = 0, .external_lex_state = 385},
  [14839] = {.lex_state = 0, .external_lex_state = 385},
  [14840] = {.lex_state = 0, .external_lex_state = 379},
  [14841] = {.lex_state = 58, .external_lex_state = 381},
  [14842] = {.lex_state = 0, .external_lex_state = 385},
  [14843] = {.lex_state = 57, .external_lex_state = 333},
  [14844] = {.lex_state = 0, .external_lex_state = 308},
  [14845] = {.lex_state = 0, .external_lex_state = 396},
  [14846] = {.lex_state = 58, .external_lex_state = 382},
  [14847] = {.lex_state = 0, .external_lex_state = 385},
  [14848] = {.lex_state = 0, .external_lex_state = 385},
  [14849] = {.lex_state = 0, .external_lex_state = 385},
  [14850] = {.lex_state = 0, .external_lex_state = 379},
  [14851] = {.lex_state = 0, .external_lex_state = 385},
  [14852] = {.lex_state = 58, .external_lex_state = 392},
  [14853] = {.lex_state = 58, .external_lex_state = 392},
  [14854] = {.lex_state = 58, .external_lex_state = 390},
  [14855] = {.lex_state = 0, .external_lex_state = 385},
  [14856] = {.lex_state = 0, .external_lex_state = 385},
  [14857] = {.lex_state = 58, .external_lex_state = 382},
  [14858] = {.lex_state = 0, .external_lex_state = 379},
  [14859] = {.lex_state = 57, .external_lex_state = 423},
  [14860] = {.lex_state = 55, .external_lex_state = 367},
  [14861] = {.lex_state = 0, .external_lex_state = 385},
  [14862] = {.lex_state = 58, .external_lex_state = 382},
  [14863] = {.lex_state = 0, .external_lex_state = 416},
  [14864] = {.lex_state = 58, .external_lex_state = 381},
  [14865] = {.lex_state = 57, .external_lex_state = 333},
  [14866] = {.lex_state = 55, .external_lex_state = 367},
  [14867] = {.lex_state = 0, .external_lex_state = 379},
  [14868] = {.lex_state = 55, .external_lex_state = 386},
  [14869] = {.lex_state = 58, .external_lex_state = 382},
  [14870] = {.lex_state = 58, .external_lex_state = 382},
  [14871] = {.lex_state = 57, .external_lex_state = 405},
  [14872] = {.lex_state = 0, .external_lex_state = 385},
  [14873] = {.lex_state = 57, .external_lex_state = 423},
  [14874] = {.lex_state = 58, .external_lex_state = 382},
  [14875] = {.lex_state = 0, .external_lex_state = 379},
  [14876] = {.lex_state = 58, .external_lex_state = 390},
  [14877] = {.lex_state = 58, .external_lex_state = 390},
  [14878] = {.lex_state = 55, .external_lex_state = 251},
  [14879] = {.lex_state = 0, .external_lex_state = 379},
  [14880] = {.lex_state = 0, .external_lex_state = 379},
  [14881] = {.lex_state = 58, .external_lex_state = 381},
  [14882] = {.lex_state = 55, .external_lex_state = 421},
  [14883] = {.lex_state = 58, .external_lex_state = 392},
  [14884] = {.lex_state = 55, .external_lex_state = 367},
  [14885] = {.lex_state = 58, .external_lex_state = 392},
  [14886] = {.lex_state = 58, .external_lex_state = 392},
  [14887] = {.lex_state = 0, .external_lex_state = 385},
  [14888] = {.lex_state = 0, .external_lex_state = 379},
  [14889] = {.lex_state = 0, .external_lex_state = 384},
  [14890] = {.lex_state = 58, .external_lex_state = 383},
  [14891] = {.lex_state = 0, .external_lex_state = 379},
  [14892] = {.lex_state = 0, .external_lex_state = 385},
  [14893] = {.lex_state = 0, .external_lex_state = 379},
  [14894] = {.lex_state = 0, .external_lex_state = 379},
  [14895] = {.lex_state = 58, .external_lex_state = 381},
  [14896] = {.lex_state = 0, .external_lex_state = 379},
  [14897] = {.lex_state = 0, .external_lex_state = 379},
  [14898] = {.lex_state = 55, .external_lex_state = 421},
  [14899] = {.lex_state = 0, .external_lex_state = 379},
  [14900] = {.lex_state = 58, .external_lex_state = 381},
  [14901] = {.lex_state = 57, .external_lex_state = 333},
  [14902] = {.lex_state = 58, .external_lex_state = 381},
  [14903] = {.lex_state = 0, .external_lex_state = 367},
  [14904] = {.lex_state = 58, .external_lex_state = 382},
  [14905] = {.lex_state = 55, .external_lex_state = 333},
  [14906] = {.lex_state = 0, .external_lex_state = 379},
  [14907] = {.lex_state = 0, .external_lex_state = 379},
  [14908] = {.lex_state = 57, .external_lex_state = 423},
  [14909] = {.lex_state = 0, .external_lex_state = 384},
  [14910] = {.lex_state = 58, .external_lex_state = 381},
  [14911] = {.lex_state = 57, .external_lex_state = 386},
  [14912] = {.lex_state = 0, .external_lex_state = 394},
  [14913] = {.lex_state = 58, .external_lex_state = 381},
  [14914] = {.lex_state = 55, .external_lex_state = 422},
  [14915] = {.lex_state = 55, .external_lex_state = 386},
  [14916] = {.lex_state = 55, .external_lex_state = 386},
  [14917] = {.lex_state = 58, .external_lex_state = 382},
  [14918] = {.lex_state = 0, .external_lex_state = 386},
  [14919] = {.lex_state = 58, .external_lex_state = 381},
  [14920] = {.lex_state = 0, .external_lex_state = 367},
  [14921] = {.lex_state = 58, .external_lex_state = 389},
  [14922] = {.lex_state = 0, .external_lex_state = 385},
  [14923] = {.lex_state = 55, .external_lex_state = 308},
  [14924] = {.lex_state = 0, .external_lex_state = 379},
  [14925] = {.lex_state = 0, .external_lex_state = 379},
  [14926] = {.lex_state = 58, .external_lex_state = 382},
  [14927] = {.lex_state = 58, .external_lex_state = 381},
  [14928] = {.lex_state = 0, .external_lex_state = 379},
  [14929] = {.lex_state = 55, .external_lex_state = 333},
  [14930] = {.lex_state = 0, .external_lex_state = 385},
  [14931] = {.lex_state = 0, .external_lex_state = 308},
  [14932] = {.lex_state = 58, .external_lex_state = 382},
  [14933] = {.lex_state = 55, .external_lex_state = 386},
  [14934] = {.lex_state = 55, .external_lex_state = 386},
  [14935] = {.lex_state = 55, .external_lex_state = 386},
  [14936] = {.lex_state = 55, .external_lex_state = 386},
  [14937] = {.lex_state = 0, .external_lex_state = 379},
  [14938] = {.lex_state = 55, .external_lex_state = 386},
  [14939] = {.lex_state = 57, .external_lex_state = 308},
  [14940] = {.lex_state = 0, .external_lex_state = 379},
  [14941] = {.lex_state = 58, .external_lex_state = 382},
  [14942] = {.lex_state = 55, .external_lex_state = 367},
  [14943] = {.lex_state = 0, .external_lex_state = 379},
  [14944] = {.lex_state = 55, .external_lex_state = 386},
  [14945] = {.lex_state = 0, .external_lex_state = 379},
  [14946] = {.lex_state = 55, .external_lex_state = 386},
  [14947] = {.lex_state = 0, .external_lex_state = 200},
  [14948] = {.lex_state = 0, .external_lex_state = 379},
  [14949] = {.lex_state = 58, .external_lex_state = 381},
  [14950] = {.lex_state = 58, .external_lex_state = 390},
  [14951] = {.lex_state = 0, .external_lex_state = 379},
  [14952] = {.lex_state = 0, .external_lex_state = 379},
  [14953] = {.lex_state = 0, .external_lex_state = 379},
  [14954] = {.lex_state = 55, .external_lex_state = 386},
  [14955] = {.lex_state = 0, .external_lex_state = 379},
  [14956] = {.lex_state = 55, .external_lex_state = 386},
  [14957] = {.lex_state = 0, .external_lex_state = 379},
  [14958] = {.lex_state = 57, .external_lex_state = 308},
  [14959] = {.lex_state = 0, .external_lex_state = 379},
  [14960] = {.lex_state = 55, .external_lex_state = 405},
  [14961] = {.lex_state = 55, .external_lex_state = 333},
  [14962] = {.lex_state = 0, .external_lex_state = 385},
  [14963] = {.lex_state = 0, .external_lex_state = 385},
  [14964] = {.lex_state = 55, .external_lex_state = 386},
  [14965] = {.lex_state = 0, .external_lex_state = 379},
  [14966] = {.lex_state = 55, .external_lex_state = 367},
  [14967] = {.lex_state = 0, .external_lex_state = 379},
  [14968] = {.lex_state = 0, .external_lex_state = 395},
  [14969] = {.lex_state = 55, .external_lex_state = 425},
  [14970] = {.lex_state = 58, .external_lex_state = 392},
  [14971] = {.lex_state = 58, .external_lex_state = 397},
  [14972] = {.lex_state = 55, .external_lex_state = 308},
  [14973] = {.lex_state = 0, .external_lex_state = 395},
  [14974] = {.lex_state = 0, .external_lex_state = 336},
  [14975] = {.lex_state = 58, .external_lex_state = 400},
  [14976] = {.lex_state = 55, .external_lex_state = 426},
  [14977] = {.lex_state = 55, .external_lex_state = 308},
  [14978] = {.lex_state = 58, .external_lex_state = 392},
  [14979] = {.lex_state = 55, .external_lex_state = 405},
  [14980] = {.lex_state = 0, .external_lex_state = 394},
  [14981] = {.lex_state = 55, .external_lex_state = 386},
  [14982] = {.lex_state = 55, .external_lex_state = 308},
  [14983] = {.lex_state = 58, .external_lex_state = 397},
  [14984] = {.lex_state = 0, .external_lex_state = 336},
  [14985] = {.lex_state = 55, .external_lex_state = 308},
  [14986] = {.lex_state = 55, .external_lex_state = 308},
  [14987] = {.lex_state = 55, .external_lex_state = 308},
  [14988] = {.lex_state = 58, .external_lex_state = 392},
  [14989] = {.lex_state = 57, .external_lex_state = 405},
  [14990] = {.lex_state = 57, .external_lex_state = 386},
  [14991] = {.lex_state = 0, .external_lex_state = 394},
  [14992] = {.lex_state = 57, .external_lex_state = 386},
  [14993] = {.lex_state = 58, .external_lex_state = 392},
  [14994] = {.lex_state = 0, .external_lex_state = 394},
  [14995] = {.lex_state = 0, .external_lex_state = 427},
  [14996] = {.lex_state = 55, .external_lex_state = 386},
  [14997] = {.lex_state = 0, .external_lex_state = 396},
  [14998] = {.lex_state = 0, .external_lex_state = 336},
  [14999] = {.lex_state = 0, .external_lex_state = 417},
  [15000] = {.lex_state = 55, .external_lex_state = 333},
  [15001] = {.lex_state = 57, .external_lex_state = 386},
  [15002] = {.lex_state = 0, .external_lex_state = 396},
  [15003] = {.lex_state = 55, .external_lex_state = 386},
  [15004] = {.lex_state = 58, .external_lex_state = 392},
  [15005] = {.lex_state = 0, .external_lex_state = 200},
  [15006] = {.lex_state = 55, .external_lex_state = 308},
  [15007] = {.lex_state = 58, .external_lex_state = 392},
  [15008] = {.lex_state = 55, .external_lex_state = 308},
  [15009] = {.lex_state = 0, .external_lex_state = 394},
  [15010] = {.lex_state = 55, .external_lex_state = 428},
  [15011] = {.lex_state = 55, .external_lex_state = 386},
  [15012] = {.lex_state = 0, .external_lex_state = 394},
  [15013] = {.lex_state = 0, .external_lex_state = 394},
  [15014] = {.lex_state = 0, .external_lex_state = 200},
  [15015] = {.lex_state = 55, .external_lex_state = 308},
  [15016] = {.lex_state = 0, .external_lex_state = 395},
  [15017] = {.lex_state = 55, .external_lex_state = 308},
  [15018] = {.lex_state = 55, .external_lex_state = 308},
  [15019] = {.lex_state = 0, .external_lex_state = 336},
  [15020] = {.lex_state = 57, .external_lex_state = 308},
  [15021] = {.lex_state = 0, .external_lex_state = 411},
  [15022] = {.lex_state = 0, .external_lex_state = 200},
  [15023] = {.lex_state = 0, .external_lex_state = 419},
  [15024] = {.lex_state = 55, .external_lex_state = 308},
  [15025] = {.lex_state = 55, .external_lex_state = 308},
  [15026] = {.lex_state = 0, .external_lex_state = 395},
  [15027] = {.lex_state = 0, .external_lex_state = 339},
  [15028] = {.lex_state = 0, .external_lex_state = 386},
  [15029] = {.lex_state = 58, .external_lex_state = 400},
  [15030] = {.lex_state = 55, .external_lex_state = 308},
  [15031] = {.lex_state = 58, .external_lex_state = 400},
  [15032] = {.lex_state = 0, .external_lex_state = 396},
  [15033] = {.lex_state = 0, .external_lex_state = 308},
  [15034] = {.lex_state = 58, .external_lex_state = 391},
  [15035] = {.lex_state = 55, .external_lex_state = 308},
  [15036] = {.lex_state = 55, .external_lex_state = 429},
  [15037] = {.lex_state = 55, .external_lex_state = 308},
  [15038] = {.lex_state = 58, .external_lex_state = 392},
  [15039] = {.lex_state = 55, .external_lex_state = 430},
  [15040] = {.lex_state = 58, .external_lex_state = 400},
  [15041] = {.lex_state = 55, .external_lex_state = 430},
  [15042] = {.lex_state = 58, .external_lex_state = 392},
  [15043] = {.lex_state = 0, .external_lex_state = 395},
  [15044] = {.lex_state = 58, .external_lex_state = 392},
  [15045] = {.lex_state = 58, .external_lex_state = 392},
  [15046] = {.lex_state = 0, .external_lex_state = 395},
  [15047] = {.lex_state = 0, .external_lex_state = 396},
  [15048] = {.lex_state = 0, .external_lex_state = 200},
  [15049] = {.lex_state = 55, .external_lex_state = 308},
  [15050] = {.lex_state = 55, .external_lex_state = 308},
  [15051] = {.lex_state = 0, .external_lex_state = 395},
  [15052] = {.lex_state = 55, .external_lex_state = 308},
  [15053] = {.lex_state = 0, .external_lex_state = 396},
  [15054] = {.lex_state = 0, .external_lex_state = 308},
  [15055] = {.lex_state = 55, .external_lex_state = 430},
  [15056] = {.lex_state = 55, .external_lex_state = 386},
  [15057] = {.lex_state = 0, .external_lex_state = 394},
  [15058] = {.lex_state = 0, .external_lex_state = 308},
  [15059] = {.lex_state = 55, .external_lex_state = 386},
  [15060] = {.lex_state = 58, .external_lex_state = 397},
  [15061] = {.lex_state = 0, .external_lex_state = 200},
  [15062] = {.lex_state = 55, .external_lex_state = 308},
  [15063] = {.lex_state = 57, .external_lex_state = 308},
  [15064] = {.lex_state = 55, .external_lex_state = 405},
  [15065] = {.lex_state = 57, .external_lex_state = 308},
  [15066] = {.lex_state = 0, .external_lex_state = 308},
  [15067] = {.lex_state = 55, .external_lex_state = 308},
  [15068] = {.lex_state = 0, .external_lex_state = 396},
  [15069] = {.lex_state = 55, .external_lex_state = 308},
  [15070] = {.lex_state = 55, .external_lex_state = 308},
  [15071] = {.lex_state = 55, .external_lex_state = 308},
  [15072] = {.lex_state = 55, .external_lex_state = 405},
  [15073] = {.lex_state = 57, .external_lex_state = 308},
  [15074] = {.lex_state = 55, .external_lex_state = 308},
  [15075] = {.lex_state = 55, .external_lex_state = 367},
  [15076] = {.lex_state = 57, .external_lex_state = 308},
  [15077] = {.lex_state = 55, .external_lex_state = 308},
  [15078] = {.lex_state = 0, .external_lex_state = 336},
  [15079] = {.lex_state = 55, .external_lex_state = 308},
  [15080] = {.lex_state = 0, .external_lex_state = 395},
  [15081] = {.lex_state = 55, .external_lex_state = 308},
  [15082] = {.lex_state = 0, .external_lex_state = 336},
  [15083] = {.lex_state = 58, .external_lex_state = 392},
  [15084] = {.lex_state = 0, .external_lex_state = 395},
  [15085] = {.lex_state = 57, .external_lex_state = 405},
  [15086] = {.lex_state = 58, .external_lex_state = 392},
  [15087] = {.lex_state = 55, .external_lex_state = 377},
  [15088] = {.lex_state = 57, .external_lex_state = 308},
  [15089] = {.lex_state = 55, .external_lex_state = 308},
  [15090] = {.lex_state = 55, .external_lex_state = 367},
  [15091] = {.lex_state = 0, .external_lex_state = 200},
  [15092] = {.lex_state = 55, .external_lex_state = 308},
  [15093] = {.lex_state = 55, .external_lex_state = 405},
  [15094] = {.lex_state = 0, .external_lex_state = 394},
  [15095] = {.lex_state = 58, .external_lex_state = 400},
  [15096] = {.lex_state = 55, .external_lex_state = 308},
  [15097] = {.lex_state = 0, .external_lex_state = 395},
  [15098] = {.lex_state = 0, .external_lex_state = 336},
  [15099] = {.lex_state = 55, .external_lex_state = 428},
  [15100] = {.lex_state = 55, .external_lex_state = 308},
  [15101] = {.lex_state = 55, .external_lex_state = 308},
  [15102] = {.lex_state = 55, .external_lex_state = 428},
  [15103] = {.lex_state = 0, .external_lex_state = 394},
  [15104] = {.lex_state = 0, .external_lex_state = 394},
  [15105] = {.lex_state = 0, .external_lex_state = 396},
  [15106] = {.lex_state = 0, .external_lex_state = 419},
  [15107] = {.lex_state = 0, .external_lex_state = 308},
  [15108] = {.lex_state = 0, .external_lex_state = 395},
  [15109] = {.lex_state = 0, .external_lex_state = 396},
  [15110] = {.lex_state = 55, .external_lex_state = 308},
  [15111] = {.lex_state = 58, .external_lex_state = 392},
  [15112] = {.lex_state = 55, .external_lex_state = 308},
  [15113] = {.lex_state = 55, .external_lex_state = 308},
  [15114] = {.lex_state = 55, .external_lex_state = 308},
  [15115] = {.lex_state = 0, .external_lex_state = 396},
  [15116] = {.lex_state = 55, .external_lex_state = 308},
  [15117] = {.lex_state = 55, .external_lex_state = 308},
  [15118] = {.lex_state = 55, .external_lex_state = 308},
  [15119] = {.lex_state = 0, .external_lex_state = 396},
  [15120] = {.lex_state = 2, .external_lex_state = 308},
  [15121] = {.lex_state = 0, .external_lex_state = 396},
  [15122] = {.lex_state = 0, .external_lex_state = 308},
  [15123] = {.lex_state = 2, .external_lex_state = 308},
  [15124] = {.lex_state = 55, .external_lex_state = 308},
  [15125] = {.lex_state = 55, .external_lex_state = 308},
  [15126] = {.lex_state = 55, .external_lex_state = 308},
  [15127] = {.lex_state = 55, .external_lex_state = 308},
  [15128] = {.lex_state = 55, .external_lex_state = 308},
  [15129] = {.lex_state = 55, .external_lex_state = 308},
  [15130] = {.lex_state = 0, .external_lex_state = 396},
  [15131] = {.lex_state = 58, .external_lex_state = 397},
  [15132] = {.lex_state = 58, .external_lex_state = 397},
  [15133] = {.lex_state = 55, .external_lex_state = 386},
  [15134] = {.lex_state = 55, .external_lex_state = 308},
  [15135] = {.lex_state = 0, .external_lex_state = 394},
  [15136] = {.lex_state = 0, .external_lex_state = 308},
  [15137] = {.lex_state = 55, .external_lex_state = 339},
  [15138] = {.lex_state = 58, .external_lex_state = 392},
  [15139] = {.lex_state = 0, .external_lex_state = 394},
  [15140] = {.lex_state = 0, .external_lex_state = 394},
  [15141] = {.lex_state = 0, .external_lex_state = 394},
  [15142] = {.lex_state = 58, .external_lex_state = 392},
  [15143] = {.lex_state = 0, .external_lex_state = 396},
  [15144] = {.lex_state = 58, .external_lex_state = 392},
  [15145] = {.lex_state = 0, .external_lex_state = 396},
  [15146] = {.lex_state = 58, .external_lex_state = 397},
  [15147] = {.lex_state = 58, .external_lex_state = 397},
  [15148] = {.lex_state = 55, .external_lex_state = 308},
  [15149] = {.lex_state = 55, .external_lex_state = 308},
  [15150] = {.lex_state = 0, .external_lex_state = 396},
  [15151] = {.lex_state = 55, .external_lex_state = 308},
  [15152] = {.lex_state = 55, .external_lex_state = 308},
  [15153] = {.lex_state = 0, .external_lex_state = 396},
  [15154] = {.lex_state = 0, .external_lex_state = 308},
  [15155] = {.lex_state = 55, .external_lex_state = 308},
  [15156] = {.lex_state = 0, .external_lex_state = 308},
  [15157] = {.lex_state = 0, .external_lex_state = 200},
  [15158] = {.lex_state = 55, .external_lex_state = 308},
  [15159] = {.lex_state = 0, .external_lex_state = 396},
  [15160] = {.lex_state = 55, .external_lex_state = 425},
  [15161] = {.lex_state = 55, .external_lex_state = 333},
  [15162] = {.lex_state = 55, .external_lex_state = 308},
  [15163] = {.lex_state = 0, .external_lex_state = 251},
  [15164] = {.lex_state = 55, .external_lex_state = 308},
  [15165] = {.lex_state = 57, .external_lex_state = 308},
  [15166] = {.lex_state = 55, .external_lex_state = 405},
  [15167] = {.lex_state = 55, .external_lex_state = 308},
  [15168] = {.lex_state = 0, .external_lex_state = 251},
  [15169] = {.lex_state = 55, .external_lex_state = 308},
  [15170] = {.lex_state = 0, .external_lex_state = 336},
  [15171] = {.lex_state = 0, .external_lex_state = 395},
  [15172] = {.lex_state = 0, .external_lex_state = 395},
  [15173] = {.lex_state = 0, .external_lex_state = 396},
  [15174] = {.lex_state = 57, .external_lex_state = 386},
  [15175] = {.lex_state = 55, .external_lex_state = 308},
  [15176] = {.lex_state = 0, .external_lex_state = 395},
  [15177] = {.lex_state = 55, .external_lex_state = 308},
  [15178] = {.lex_state = 55, .external_lex_state = 308},
  [15179] = {.lex_state = 55, .external_lex_state = 425},
  [15180] = {.lex_state = 55, .external_lex_state = 308},
  [15181] = {.lex_state = 0, .external_lex_state = 200},
  [15182] = {.lex_state = 0, .external_lex_state = 396},
  [15183] = {.lex_state = 55, .external_lex_state = 308},
  [15184] = {.lex_state = 0, .external_lex_state = 394},
  [15185] = {.lex_state = 57, .external_lex_state = 308},
  [15186] = {.lex_state = 0, .external_lex_state = 200},
  [15187] = {.lex_state = 0, .external_lex_state = 396},
  [15188] = {.lex_state = 55, .external_lex_state = 308},
  [15189] = {.lex_state = 0, .external_lex_state = 396},
  [15190] = {.lex_state = 55, .external_lex_state = 377},
  [15191] = {.lex_state = 55, .external_lex_state = 308},
  [15192] = {.lex_state = 55, .external_lex_state = 431},
  [15193] = {.lex_state = 0, .external_lex_state = 396},
  [15194] = {.lex_state = 0, .external_lex_state = 396},
  [15195] = {.lex_state = 55, .external_lex_state = 308},
  [15196] = {.lex_state = 55, .external_lex_state = 308},
  [15197] = {.lex_state = 0, .external_lex_state = 336},
  [15198] = {.lex_state = 0, .external_lex_state = 394},
  [15199] = {.lex_state = 58, .external_lex_state = 392},
  [15200] = {.lex_state = 0, .external_lex_state = 394},
  [15201] = {.lex_state = 55, .external_lex_state = 308},
  [15202] = {.lex_state = 55, .external_lex_state = 308},
  [15203] = {.lex_state = 55, .external_lex_state = 308},
  [15204] = {.lex_state = 55, .external_lex_state = 308},
  [15205] = {.lex_state = 0, .external_lex_state = 251},
  [15206] = {.lex_state = 55, .external_lex_state = 308},
  [15207] = {.lex_state = 58, .external_lex_state = 392},
  [15208] = {.lex_state = 0, .external_lex_state = 395},
  [15209] = {.lex_state = 57, .external_lex_state = 405},
  [15210] = {.lex_state = 55, .external_lex_state = 308},
  [15211] = {.lex_state = 0, .external_lex_state = 394},
  [15212] = {.lex_state = 55, .external_lex_state = 430},
  [15213] = {.lex_state = 57, .external_lex_state = 405},
  [15214] = {.lex_state = 55, .external_lex_state = 308},
  [15215] = {.lex_state = 58, .external_lex_state = 392},
  [15216] = {.lex_state = 0, .external_lex_state = 308},
  [15217] = {.lex_state = 55, .external_lex_state = 386},
  [15218] = {.lex_state = 0, .external_lex_state = 396},
  [15219] = {.lex_state = 0, .external_lex_state = 308},
  [15220] = {.lex_state = 55, .external_lex_state = 386},
  [15221] = {.lex_state = 0, .external_lex_state = 395},
  [15222] = {.lex_state = 0, .external_lex_state = 394},
  [15223] = {.lex_state = 57, .external_lex_state = 405},
  [15224] = {.lex_state = 55, .external_lex_state = 308},
  [15225] = {.lex_state = 58, .external_lex_state = 392},
  [15226] = {.lex_state = 57, .external_lex_state = 308},
  [15227] = {.lex_state = 0, .external_lex_state = 394},
  [15228] = {.lex_state = 0, .external_lex_state = 432},
  [15229] = {.lex_state = 0, .external_lex_state = 336},
  [15230] = {.lex_state = 55, .external_lex_state = 308},
  [15231] = {.lex_state = 55, .external_lex_state = 428},
  [15232] = {.lex_state = 0, .external_lex_state = 395},
  [15233] = {.lex_state = 57, .external_lex_state = 308},
  [15234] = {.lex_state = 0, .external_lex_state = 395},
  [15235] = {.lex_state = 0, .external_lex_state = 396},
  [15236] = {.lex_state = 0, .external_lex_state = 396},
  [15237] = {.lex_state = 0, .external_lex_state = 336},
  [15238] = {.lex_state = 58, .external_lex_state = 392},
  [15239] = {.lex_state = 58, .external_lex_state = 392},
  [15240] = {.lex_state = 0, .external_lex_state = 308},
  [15241] = {.lex_state = 0, .external_lex_state = 308},
  [15242] = {.lex_state = 55, .external_lex_state = 308},
  [15243] = {.lex_state = 55, .external_lex_state = 308},
  [15244] = {.lex_state = 0, .external_lex_state = 308},
  [15245] = {.lex_state = 55, .external_lex_state = 405},
  [15246] = {.lex_state = 55, .external_lex_state = 429},
  [15247] = {.lex_state = 0, .external_lex_state = 386},
  [15248] = {.lex_state = 55, .external_lex_state = 308},
  [15249] = {.lex_state = 0, .external_lex_state = 394},
  [15250] = {.lex_state = 55, .external_lex_state = 377},
  [15251] = {.lex_state = 55, .external_lex_state = 308},
  [15252] = {.lex_state = 0, .external_lex_state = 396},
  [15253] = {.lex_state = 58, .external_lex_state = 392},
  [15254] = {.lex_state = 55, .external_lex_state = 308},
  [15255] = {.lex_state = 55, .external_lex_state = 308},
  [15256] = {.lex_state = 55, .external_lex_state = 405},
  [15257] = {.lex_state = 0, .external_lex_state = 395},
  [15258] = {.lex_state = 0, .external_lex_state = 427},
  [15259] = {.lex_state = 55, .external_lex_state = 429},
  [15260] = {.lex_state = 0, .external_lex_state = 396},
  [15261] = {.lex_state = 58, .external_lex_state = 392},
  [15262] = {.lex_state = 0, .external_lex_state = 350},
  [15263] = {.lex_state = 55, .external_lex_state = 308},
  [15264] = {.lex_state = 0, .external_lex_state = 396},
  [15265] = {.lex_state = 55, .external_lex_state = 405},
  [15266] = {.lex_state = 55, .external_lex_state = 308},
  [15267] = {.lex_state = 55, .external_lex_state = 308},
  [15268] = {.lex_state = 55, .external_lex_state = 386},
  [15269] = {.lex_state = 58, .external_lex_state = 401},
  [15270] = {.lex_state = 0, .external_lex_state = 396},
  [15271] = {.lex_state = 55, .external_lex_state = 308},
  [15272] = {.lex_state = 58, .external_lex_state = 392},
  [15273] = {.lex_state = 0, .external_lex_state = 336},
  [15274] = {.lex_state = 55, .external_lex_state = 308},
  [15275] = {.lex_state = 55, .external_lex_state = 308},
  [15276] = {.lex_state = 0, .external_lex_state = 395},
  [15277] = {.lex_state = 0, .external_lex_state = 394},
  [15278] = {.lex_state = 0, .external_lex_state = 350},
  [15279] = {.lex_state = 0, .external_lex_state = 396},
  [15280] = {.lex_state = 55, .external_lex_state = 308},
  [15281] = {.lex_state = 0, .external_lex_state = 350},
  [15282] = {.lex_state = 0, .external_lex_state = 395},
  [15283] = {.lex_state = 55, .external_lex_state = 339},
  [15284] = {.lex_state = 55, .external_lex_state = 308},
  [15285] = {.lex_state = 0, .external_lex_state = 394},
  [15286] = {.lex_state = 0, .external_lex_state = 336},
  [15287] = {.lex_state = 0, .external_lex_state = 394},
  [15288] = {.lex_state = 55, .external_lex_state = 308},
  [15289] = {.lex_state = 0, .external_lex_state = 308},
  [15290] = {.lex_state = 0, .external_lex_state = 396},
  [15291] = {.lex_state = 55, .external_lex_state = 426},
  [15292] = {.lex_state = 0, .external_lex_state = 396},
  [15293] = {.lex_state = 55, .external_lex_state = 308},
  [15294] = {.lex_state = 0, .external_lex_state = 394},
  [15295] = {.lex_state = 0, .external_lex_state = 308},
  [15296] = {.lex_state = 0, .external_lex_state = 432},
  [15297] = {.lex_state = 0, .external_lex_state = 396},
  [15298] = {.lex_state = 55, .external_lex_state = 429},
  [15299] = {.lex_state = 0, .external_lex_state = 395},
  [15300] = {.lex_state = 55, .external_lex_state = 308},
  [15301] = {.lex_state = 0, .external_lex_state = 308},
  [15302] = {.lex_state = 55, .external_lex_state = 308},
  [15303] = {.lex_state = 55, .external_lex_state = 308},
  [15304] = {.lex_state = 58, .external_lex_state = 397},
  [15305] = {.lex_state = 57, .external_lex_state = 405},
  [15306] = {.lex_state = 0, .external_lex_state = 395},
  [15307] = {.lex_state = 55, .external_lex_state = 308},
  [15308] = {.lex_state = 55, .external_lex_state = 425},
  [15309] = {.lex_state = 0, .external_lex_state = 394},
  [15310] = {.lex_state = 0, .external_lex_state = 396},
  [15311] = {.lex_state = 55, .external_lex_state = 308},
  [15312] = {.lex_state = 0, .external_lex_state = 386},
  [15313] = {.lex_state = 55, .external_lex_state = 308},
  [15314] = {.lex_state = 0, .external_lex_state = 396},
  [15315] = {.lex_state = 55, .external_lex_state = 308},
  [15316] = {.lex_state = 0, .external_lex_state = 395},
  [15317] = {.lex_state = 0, .external_lex_state = 396},
  [15318] = {.lex_state = 0, .external_lex_state = 308},
  [15319] = {.lex_state = 55, .external_lex_state = 386},
  [15320] = {.lex_state = 0, .external_lex_state = 336},
  [15321] = {.lex_state = 55, .external_lex_state = 308},
  [15322] = {.lex_state = 0, .external_lex_state = 395},
  [15323] = {.lex_state = 58, .external_lex_state = 397},
  [15324] = {.lex_state = 0, .external_lex_state = 404},
  [15325] = {.lex_state = 0, .external_lex_state = 396},
  [15326] = {.lex_state = 0, .external_lex_state = 396},
  [15327] = {.lex_state = 55, .external_lex_state = 308},
  [15328] = {.lex_state = 55, .external_lex_state = 308},
  [15329] = {.lex_state = 0, .external_lex_state = 396},
  [15330] = {.lex_state = 55, .external_lex_state = 308},
  [15331] = {.lex_state = 55, .external_lex_state = 308},
  [15332] = {.lex_state = 0, .external_lex_state = 308},
  [15333] = {.lex_state = 55, .external_lex_state = 308},
  [15334] = {.lex_state = 58, .external_lex_state = 392},
  [15335] = {.lex_state = 0, .external_lex_state = 308},
  [15336] = {.lex_state = 55, .external_lex_state = 405},
  [15337] = {.lex_state = 55, .external_lex_state = 377},
  [15338] = {.lex_state = 55, .external_lex_state = 339},
  [15339] = {.lex_state = 55, .external_lex_state = 308},
  [15340] = {.lex_state = 0, .external_lex_state = 386},
  [15341] = {.lex_state = 57, .external_lex_state = 308},
  [15342] = {.lex_state = 55, .external_lex_state = 308},
  [15343] = {.lex_state = 58, .external_lex_state = 397},
  [15344] = {.lex_state = 55, .external_lex_state = 308},
  [15345] = {.lex_state = 0, .external_lex_state = 308},
  [15346] = {.lex_state = 58, .external_lex_state = 392},
  [15347] = {.lex_state = 55, .external_lex_state = 405},
  [15348] = {.lex_state = 0, .external_lex_state = 396},
  [15349] = {.lex_state = 58, .external_lex_state = 392},
  [15350] = {.lex_state = 0, .external_lex_state = 394},
  [15351] = {.lex_state = 0, .external_lex_state = 367},
  [15352] = {.lex_state = 0, .external_lex_state = 395},
  [15353] = {.lex_state = 55, .external_lex_state = 308},
  [15354] = {.lex_state = 55, .external_lex_state = 308},
  [15355] = {.lex_state = 0, .external_lex_state = 396},
  [15356] = {.lex_state = 0, .external_lex_state = 394},
  [15357] = {.lex_state = 0, .external_lex_state = 395},
  [15358] = {.lex_state = 55, .external_lex_state = 429},
  [15359] = {.lex_state = 0, .external_lex_state = 308},
  [15360] = {.lex_state = 55, .external_lex_state = 308},
  [15361] = {.lex_state = 0, .external_lex_state = 396},
  [15362] = {.lex_state = 58, .external_lex_state = 392},
  [15363] = {.lex_state = 55, .external_lex_state = 308},
  [15364] = {.lex_state = 55, .external_lex_state = 386},
  [15365] = {.lex_state = 55, .external_lex_state = 308},
  [15366] = {.lex_state = 58, .external_lex_state = 392},
  [15367] = {.lex_state = 55, .external_lex_state = 430},
  [15368] = {.lex_state = 55, .external_lex_state = 308},
  [15369] = {.lex_state = 55, .external_lex_state = 308},
  [15370] = {.lex_state = 0, .external_lex_state = 394},
  [15371] = {.lex_state = 0, .external_lex_state = 395},
  [15372] = {.lex_state = 0, .external_lex_state = 395},
  [15373] = {.lex_state = 0, .external_lex_state = 395},
  [15374] = {.lex_state = 0, .external_lex_state = 308},
  [15375] = {.lex_state = 0, .external_lex_state = 308},
  [15376] = {.lex_state = 55, .external_lex_state = 377},
  [15377] = {.lex_state = 55, .external_lex_state = 308},
  [15378] = {.lex_state = 0, .external_lex_state = 411},
  [15379] = {.lex_state = 0, .external_lex_state = 395},
  [15380] = {.lex_state = 55, .external_lex_state = 431},
  [15381] = {.lex_state = 57, .external_lex_state = 405},
  [15382] = {.lex_state = 55, .external_lex_state = 308},
  [15383] = {.lex_state = 55, .external_lex_state = 308},
  [15384] = {.lex_state = 55, .external_lex_state = 428},
  [15385] = {.lex_state = 55, .external_lex_state = 433},
  [15386] = {.lex_state = 0, .external_lex_state = 396},
  [15387] = {.lex_state = 55, .external_lex_state = 308},
  [15388] = {.lex_state = 0, .external_lex_state = 395},
  [15389] = {.lex_state = 58, .external_lex_state = 401},
  [15390] = {.lex_state = 58, .external_lex_state = 392},
  [15391] = {.lex_state = 0, .external_lex_state = 396},
  [15392] = {.lex_state = 55, .external_lex_state = 308},
  [15393] = {.lex_state = 0, .external_lex_state = 308},
  [15394] = {.lex_state = 55, .external_lex_state = 425},
  [15395] = {.lex_state = 0, .external_lex_state = 308},
  [15396] = {.lex_state = 0, .external_lex_state = 308},
  [15397] = {.lex_state = 55, .external_lex_state = 308},
  [15398] = {.lex_state = 0, .external_lex_state = 395},
  [15399] = {.lex_state = 0, .external_lex_state = 200},
  [15400] = {.lex_state = 0, .external_lex_state = 395},
  [15401] = {.lex_state = 55, .external_lex_state = 308},
  [15402] = {.lex_state = 55, .external_lex_state = 308},
  [15403] = {.lex_state = 55, .external_lex_state = 386},
  [15404] = {.lex_state = 55, .external_lex_state = 308},
  [15405] = {.lex_state = 0, .external_lex_state = 396},
  [15406] = {.lex_state = 55, .external_lex_state = 350},
  [15407] = {.lex_state = 55, .external_lex_state = 308},
  [15408] = {.lex_state = 0, .external_lex_state = 394},
  [15409] = {.lex_state = 58, .external_lex_state = 392},
  [15410] = {.lex_state = 0, .external_lex_state = 396},
  [15411] = {.lex_state = 0, .external_lex_state = 394},
  [15412] = {.lex_state = 0, .external_lex_state = 395},
  [15413] = {.lex_state = 0, .external_lex_state = 396},
  [15414] = {.lex_state = 55, .external_lex_state = 308},
  [15415] = {.lex_state = 55, .external_lex_state = 308},
  [15416] = {.lex_state = 55, .external_lex_state = 431},
  [15417] = {.lex_state = 55, .external_lex_state = 386},
  [15418] = {.lex_state = 55, .external_lex_state = 386},
  [15419] = {.lex_state = 55, .external_lex_state = 308},
  [15420] = {.lex_state = 0, .external_lex_state = 394},
  [15421] = {.lex_state = 0, .external_lex_state = 395},
  [15422] = {.lex_state = 0, .external_lex_state = 308},
  [15423] = {.lex_state = 0, .external_lex_state = 395},
  [15424] = {.lex_state = 55, .external_lex_state = 308},
  [15425] = {.lex_state = 55, .external_lex_state = 431},
  [15426] = {.lex_state = 55, .external_lex_state = 308},
  [15427] = {.lex_state = 0, .external_lex_state = 396},
  [15428] = {.lex_state = 55, .external_lex_state = 308},
  [15429] = {.lex_state = 55, .external_lex_state = 405},
  [15430] = {.lex_state = 55, .external_lex_state = 308},
  [15431] = {.lex_state = 57, .external_lex_state = 308},
  [15432] = {.lex_state = 55, .external_lex_state = 386},
  [15433] = {.lex_state = 58, .external_lex_state = 392},
  [15434] = {.lex_state = 55, .external_lex_state = 308},
  [15435] = {.lex_state = 55, .external_lex_state = 350},
  [15436] = {.lex_state = 0, .external_lex_state = 395},
  [15437] = {.lex_state = 0, .external_lex_state = 395},
  [15438] = {.lex_state = 55, .external_lex_state = 350},
  [15439] = {.lex_state = 55, .external_lex_state = 308},
  [15440] = {.lex_state = 55, .external_lex_state = 308},
  [15441] = {.lex_state = 55, .external_lex_state = 308},
  [15442] = {.lex_state = 0, .external_lex_state = 308},
  [15443] = {.lex_state = 55, .external_lex_state = 386},
  [15444] = {.lex_state = 55, .external_lex_state = 308},
  [15445] = {.lex_state = 0, .external_lex_state = 395},
  [15446] = {.lex_state = 55, .external_lex_state = 308},
  [15447] = {.lex_state = 0, .external_lex_state = 308},
  [15448] = {.lex_state = 0, .external_lex_state = 396},
  [15449] = {.lex_state = 55, .external_lex_state = 377},
  [15450] = {.lex_state = 0, .external_lex_state = 394},
  [15451] = {.lex_state = 55, .external_lex_state = 339},
  [15452] = {.lex_state = 55, .external_lex_state = 308},
  [15453] = {.lex_state = 0, .external_lex_state = 419},
  [15454] = {.lex_state = 55, .external_lex_state = 386},
  [15455] = {.lex_state = 0, .external_lex_state = 395},
  [15456] = {.lex_state = 57, .external_lex_state = 308},
  [15457] = {.lex_state = 0, .external_lex_state = 395},
  [15458] = {.lex_state = 55, .external_lex_state = 431},
  [15459] = {.lex_state = 0, .external_lex_state = 395},
  [15460] = {.lex_state = 55, .external_lex_state = 377},
  [15461] = {.lex_state = 55, .external_lex_state = 308},
  [15462] = {.lex_state = 0, .external_lex_state = 339},
  [15463] = {.lex_state = 58, .external_lex_state = 392},
  [15464] = {.lex_state = 58, .external_lex_state = 392},
  [15465] = {.lex_state = 55, .external_lex_state = 308},
  [15466] = {.lex_state = 55, .external_lex_state = 405},
  [15467] = {.lex_state = 57, .external_lex_state = 386},
  [15468] = {.lex_state = 57, .external_lex_state = 308},
  [15469] = {.lex_state = 57, .external_lex_state = 308},
  [15470] = {.lex_state = 0, .external_lex_state = 396},
  [15471] = {.lex_state = 0, .external_lex_state = 394},
  [15472] = {.lex_state = 0, .external_lex_state = 395},
  [15473] = {.lex_state = 55, .external_lex_state = 308},
  [15474] = {.lex_state = 0, .external_lex_state = 394},
  [15475] = {.lex_state = 55, .external_lex_state = 386},
  [15476] = {.lex_state = 57, .external_lex_state = 308},
  [15477] = {.lex_state = 57, .external_lex_state = 308},
  [15478] = {.lex_state = 55, .external_lex_state = 308},
  [15479] = {.lex_state = 58, .external_lex_state = 397},
  [15480] = {.lex_state = 58, .external_lex_state = 397},
  [15481] = {.lex_state = 55, .external_lex_state = 308},
  [15482] = {.lex_state = 58, .external_lex_state = 392},
  [15483] = {.lex_state = 0, .external_lex_state = 396},
  [15484] = {.lex_state = 55, .external_lex_state = 308},
  [15485] = {.lex_state = 0, .external_lex_state = 394},
  [15486] = {.lex_state = 0, .external_lex_state = 394},
  [15487] = {.lex_state = 0, .external_lex_state = 394},
  [15488] = {.lex_state = 55, .external_lex_state = 308},
  [15489] = {.lex_state = 55, .external_lex_state = 308},
  [15490] = {.lex_state = 0, .external_lex_state = 394},
  [15491] = {.lex_state = 55, .external_lex_state = 431},
  [15492] = {.lex_state = 0, .external_lex_state = 395},
  [15493] = {.lex_state = 55, .external_lex_state = 405},
  [15494] = {.lex_state = 0, .external_lex_state = 386},
  [15495] = {.lex_state = 0, .external_lex_state = 395},
  [15496] = {.lex_state = 55, .external_lex_state = 350},
  [15497] = {.lex_state = 55, .external_lex_state = 350},
  [15498] = {.lex_state = 0, .external_lex_state = 395},
  [15499] = {.lex_state = 0, .external_lex_state = 348},
  [15500] = {.lex_state = 0, .external_lex_state = 386},
  [15501] = {.lex_state = 0, .external_lex_state = 395},
  [15502] = {.lex_state = 55, .external_lex_state = 386},
  [15503] = {.lex_state = 55, .external_lex_state = 430},
  [15504] = {.lex_state = 0, .external_lex_state = 395},
  [15505] = {.lex_state = 58, .external_lex_state = 392},
  [15506] = {.lex_state = 0, .external_lex_state = 394},
  [15507] = {.lex_state = 0, .external_lex_state = 394},
  [15508] = {.lex_state = 55, .external_lex_state = 308},
  [15509] = {.lex_state = 58, .external_lex_state = 392},
  [15510] = {.lex_state = 0, .external_lex_state = 308},
  [15511] = {.lex_state = 55, .external_lex_state = 430},
  [15512] = {.lex_state = 0, .external_lex_state = 394},
  [15513] = {.lex_state = 0, .external_lex_state = 394},
  [15514] = {.lex_state = 55, .external_lex_state = 433},
  [15515] = {.lex_state = 55, .external_lex_state = 433},
  [15516] = {.lex_state = 55, .external_lex_state = 308},
  [15517] = {.lex_state = 55, .external_lex_state = 308},
  [15518] = {.lex_state = 55, .external_lex_state = 308},
  [15519] = {.lex_state = 0, .external_lex_state = 394},
  [15520] = {.lex_state = 0, .external_lex_state = 394},
  [15521] = {.lex_state = 55, .external_lex_state = 339},
  [15522] = {.lex_state = 0, .external_lex_state = 394},
  [15523] = {.lex_state = 55, .external_lex_state = 308},
  [15524] = {.lex_state = 55, .external_lex_state = 308},
  [15525] = {.lex_state = 55, .external_lex_state = 308},
  [15526] = {.lex_state = 0, .external_lex_state = 336},
  [15527] = {.lex_state = 0, .external_lex_state = 394},
  [15528] = {.lex_state = 55, .external_lex_state = 433},
  [15529] = {.lex_state = 0, .external_lex_state = 336},
  [15530] = {.lex_state = 0, .external_lex_state = 395},
  [15531] = {.lex_state = 0, .external_lex_state = 394},
  [15532] = {.lex_state = 55, .external_lex_state = 405},
  [15533] = {.lex_state = 0, .external_lex_state = 395},
  [15534] = {.lex_state = 57, .external_lex_state = 308},
  [15535] = {.lex_state = 55, .external_lex_state = 308},
  [15536] = {.lex_state = 55, .external_lex_state = 405},
  [15537] = {.lex_state = 55, .external_lex_state = 308},
  [15538] = {.lex_state = 58, .external_lex_state = 392},
  [15539] = {.lex_state = 55, .external_lex_state = 308},
  [15540] = {.lex_state = 0, .external_lex_state = 200},
  [15541] = {.lex_state = 55, .external_lex_state = 405},
  [15542] = {.lex_state = 55, .external_lex_state = 308},
  [15543] = {.lex_state = 0, .external_lex_state = 308},
  [15544] = {.lex_state = 55, .external_lex_state = 308},
  [15545] = {.lex_state = 55, .external_lex_state = 308},
  [15546] = {.lex_state = 55, .external_lex_state = 433},
  [15547] = {.lex_state = 55, .external_lex_state = 433},
  [15548] = {.lex_state = 0, .external_lex_state = 394},
  [15549] = {.lex_state = 55, .external_lex_state = 419},
  [15550] = {.lex_state = 58, .external_lex_state = 400},
  [15551] = {.lex_state = 0, .external_lex_state = 432},
  [15552] = {.lex_state = 0, .external_lex_state = 417},
  [15553] = {.lex_state = 55, .external_lex_state = 308},
  [15554] = {.lex_state = 0, .external_lex_state = 308},
  [15555] = {.lex_state = 0, .external_lex_state = 386},
  [15556] = {.lex_state = 0, .external_lex_state = 386},
  [15557] = {.lex_state = 0, .external_lex_state = 394},
  [15558] = {.lex_state = 55, .external_lex_state = 428},
  [15559] = {.lex_state = 55, .external_lex_state = 308},
  [15560] = {.lex_state = 55, .external_lex_state = 308},
  [15561] = {.lex_state = 0, .external_lex_state = 308},
  [15562] = {.lex_state = 55, .external_lex_state = 308},
  [15563] = {.lex_state = 55, .external_lex_state = 428},
  [15564] = {.lex_state = 55, .external_lex_state = 405},
  [15565] = {.lex_state = 58, .external_lex_state = 392},
  [15566] = {.lex_state = 0, .external_lex_state = 308},
  [15567] = {.lex_state = 0, .external_lex_state = 394},
  [15568] = {.lex_state = 55, .external_lex_state = 405},
  [15569] = {.lex_state = 55, .external_lex_state = 308},
  [15570] = {.lex_state = 0, .external_lex_state = 394},
  [15571] = {.lex_state = 0, .external_lex_state = 336},
  [15572] = {.lex_state = 55, .external_lex_state = 386},
  [15573] = {.lex_state = 55, .external_lex_state = 417},
  [15574] = {.lex_state = 55, .external_lex_state = 308},
  [15575] = {.lex_state = 0, .external_lex_state = 339},
  [15576] = {.lex_state = 55, .external_lex_state = 308},
  [15577] = {.lex_state = 55, .external_lex_state = 308},
  [15578] = {.lex_state = 55, .external_lex_state = 386},
  [15579] = {.lex_state = 57, .external_lex_state = 386},
  [15580] = {.lex_state = 0, .external_lex_state = 336},
  [15581] = {.lex_state = 55, .external_lex_state = 308},
  [15582] = {.lex_state = 0, .external_lex_state = 395},
  [15583] = {.lex_state = 58, .external_lex_state = 389},
  [15584] = {.lex_state = 55, .external_lex_state = 405},
  [15585] = {.lex_state = 0, .external_lex_state = 386},
  [15586] = {.lex_state = 58, .external_lex_state = 392},
  [15587] = {.lex_state = 58, .external_lex_state = 392},
  [15588] = {.lex_state = 55, .external_lex_state = 308},
  [15589] = {.lex_state = 55, .external_lex_state = 308},
  [15590] = {.lex_state = 55, .external_lex_state = 308},
  [15591] = {.lex_state = 55, .external_lex_state = 308},
  [15592] = {.lex_state = 55, .external_lex_state = 425},
  [15593] = {.lex_state = 0, .external_lex_state = 336},
  [15594] = {.lex_state = 58, .external_lex_state = 392},
  [15595] = {.lex_state = 55, .external_lex_state = 405},
  [15596] = {.lex_state = 0, .external_lex_state = 200},
  [15597] = {.lex_state = 55, .external_lex_state = 308},
  [15598] = {.lex_state = 55, .external_lex_state = 308},
  [15599] = {.lex_state = 55, .external_lex_state = 308},
  [15600] = {.lex_state = 0, .external_lex_state = 251},
  [15601] = {.lex_state = 55, .external_lex_state = 386},
  [15602] = {.lex_state = 57, .external_lex_state = 308},
  [15603] = {.lex_state = 57, .external_lex_state = 308},
  [15604] = {.lex_state = 55, .external_lex_state = 308},
  [15605] = {.lex_state = 0, .external_lex_state = 308},
  [15606] = {.lex_state = 55, .external_lex_state = 405},
  [15607] = {.lex_state = 55, .external_lex_state = 308},
  [15608] = {.lex_state = 55, .external_lex_state = 308},
  [15609] = {.lex_state = 0, .external_lex_state = 308},
  [15610] = {.lex_state = 55, .external_lex_state = 433},
  [15611] = {.lex_state = 55, .external_lex_state = 407},
  [15612] = {.lex_state = 58, .external_lex_state = 392},
  [15613] = {.lex_state = 0, .external_lex_state = 395},
  [15614] = {.lex_state = 0, .external_lex_state = 432},
  [15615] = {.lex_state = 0, .external_lex_state = 417},
  [15616] = {.lex_state = 58, .external_lex_state = 392},
  [15617] = {.lex_state = 55, .external_lex_state = 308},
  [15618] = {.lex_state = 55, .external_lex_state = 308},
  [15619] = {.lex_state = 58, .external_lex_state = 392},
  [15620] = {.lex_state = 55, .external_lex_state = 308},
  [15621] = {.lex_state = 0, .external_lex_state = 200},
  [15622] = {.lex_state = 55, .external_lex_state = 433},
  [15623] = {.lex_state = 55, .external_lex_state = 308},
  [15624] = {.lex_state = 55, .external_lex_state = 308},
  [15625] = {.lex_state = 55, .external_lex_state = 433},
  [15626] = {.lex_state = 57, .external_lex_state = 386},
  [15627] = {.lex_state = 55, .external_lex_state = 430},
  [15628] = {.lex_state = 58, .external_lex_state = 390},
  [15629] = {.lex_state = 0, .external_lex_state = 350},
  [15630] = {.lex_state = 58, .external_lex_state = 390},
  [15631] = {.lex_state = 55, .external_lex_state = 422},
  [15632] = {.lex_state = 55, .external_lex_state = 433},
  [15633] = {.lex_state = 58, .external_lex_state = 389},
  [15634] = {.lex_state = 58, .external_lex_state = 390},
  [15635] = {.lex_state = 58, .external_lex_state = 390},
  [15636] = {.lex_state = 58, .external_lex_state = 390},
  [15637] = {.lex_state = 55, .external_lex_state = 348},
  [15638] = {.lex_state = 58, .external_lex_state = 390},
  [15639] = {.lex_state = 55, .external_lex_state = 428},
  [15640] = {.lex_state = 0, .external_lex_state = 434},
  [15641] = {.lex_state = 58, .external_lex_state = 389},
  [15642] = {.lex_state = 58, .external_lex_state = 390},
  [15643] = {.lex_state = 58, .external_lex_state = 390},
  [15644] = {.lex_state = 0, .external_lex_state = 434},
  [15645] = {.lex_state = 58, .external_lex_state = 390},
  [15646] = {.lex_state = 55, .external_lex_state = 430},
  [15647] = {.lex_state = 55, .external_lex_state = 430},
  [15648] = {.lex_state = 0, .external_lex_state = 350},
  [15649] = {.lex_state = 0, .external_lex_state = 434},
  [15650] = {.lex_state = 0, .external_lex_state = 434},
  [15651] = {.lex_state = 58, .external_lex_state = 390},
  [15652] = {.lex_state = 58, .external_lex_state = 390},
  [15653] = {.lex_state = 57, .external_lex_state = 308},
  [15654] = {.lex_state = 55, .external_lex_state = 308},
  [15655] = {.lex_state = 0, .external_lex_state = 427},
  [15656] = {.lex_state = 58, .external_lex_state = 390},
  [15657] = {.lex_state = 58, .external_lex_state = 390},
  [15658] = {.lex_state = 0, .external_lex_state = 434},
  [15659] = {.lex_state = 58, .external_lex_state = 390},
  [15660] = {.lex_state = 55, .external_lex_state = 428},
  [15661] = {.lex_state = 55, .external_lex_state = 308},
  [15662] = {.lex_state = 58, .external_lex_state = 390},
  [15663] = {.lex_state = 0, .external_lex_state = 336},
  [15664] = {.lex_state = 0, .external_lex_state = 336},
  [15665] = {.lex_state = 58, .external_lex_state = 390},
  [15666] = {.lex_state = 0, .external_lex_state = 434},
  [15667] = {.lex_state = 0, .external_lex_state = 350},
  [15668] = {.lex_state = 58, .external_lex_state = 389},
  [15669] = {.lex_state = 0, .external_lex_state = 405},
  [15670] = {.lex_state = 58, .external_lex_state = 390},
  [15671] = {.lex_state = 58, .external_lex_state = 390},
  [15672] = {.lex_state = 55, .external_lex_state = 308},
  [15673] = {.lex_state = 58, .external_lex_state = 390},
  [15674] = {.lex_state = 55, .external_lex_state = 308},
  [15675] = {.lex_state = 58, .external_lex_state = 389},
  [15676] = {.lex_state = 0, .external_lex_state = 405},
  [15677] = {.lex_state = 0, .external_lex_state = 251},
  [15678] = {.lex_state = 58, .external_lex_state = 389},
  [15679] = {.lex_state = 55, .external_lex_state = 428},
  [15680] = {.lex_state = 55, .external_lex_state = 428},
  [15681] = {.lex_state = 58, .external_lex_state = 390},
  [15682] = {.lex_state = 58, .external_lex_state = 390},
  [15683] = {.lex_state = 0, .external_lex_state = 427},
  [15684] = {.lex_state = 58, .external_lex_state = 390},
  [15685] = {.lex_state = 58, .external_lex_state = 336},
  [15686] = {.lex_state = 58, .external_lex_state = 390},
  [15687] = {.lex_state = 55, .external_lex_state = 430},
  [15688] = {.lex_state = 0, .external_lex_state = 308},
  [15689] = {.lex_state = 58, .external_lex_state = 390},
  [15690] = {.lex_state = 55, .external_lex_state = 308},
  [15691] = {.lex_state = 58, .external_lex_state = 390},
  [15692] = {.lex_state = 58, .external_lex_state = 390},
  [15693] = {.lex_state = 58, .external_lex_state = 390},
  [15694] = {.lex_state = 58, .external_lex_state = 390},
  [15695] = {.lex_state = 58, .external_lex_state = 390},
  [15696] = {.lex_state = 55, .external_lex_state = 435},
  [15697] = {.lex_state = 55, .external_lex_state = 430},
  [15698] = {.lex_state = 0, .external_lex_state = 308},
  [15699] = {.lex_state = 55, .external_lex_state = 387},
  [15700] = {.lex_state = 55, .external_lex_state = 428},
  [15701] = {.lex_state = 58, .external_lex_state = 390},
  [15702] = {.lex_state = 0, .external_lex_state = 434},
  [15703] = {.lex_state = 0, .external_lex_state = 308},
  [15704] = {.lex_state = 55, .external_lex_state = 406},
  [15705] = {.lex_state = 58, .external_lex_state = 390},
  [15706] = {.lex_state = 58, .external_lex_state = 390},
  [15707] = {.lex_state = 55, .external_lex_state = 428},
  [15708] = {.lex_state = 58, .external_lex_state = 390},
  [15709] = {.lex_state = 58, .external_lex_state = 391},
  [15710] = {.lex_state = 58, .external_lex_state = 390},
  [15711] = {.lex_state = 58, .external_lex_state = 390},
  [15712] = {.lex_state = 58, .external_lex_state = 390},
  [15713] = {.lex_state = 55, .external_lex_state = 430},
  [15714] = {.lex_state = 58, .external_lex_state = 390},
  [15715] = {.lex_state = 55, .external_lex_state = 428},
  [15716] = {.lex_state = 55, .external_lex_state = 308},
  [15717] = {.lex_state = 58, .external_lex_state = 391},
  [15718] = {.lex_state = 55, .external_lex_state = 435},
  [15719] = {.lex_state = 55, .external_lex_state = 428},
  [15720] = {.lex_state = 58, .external_lex_state = 390},
  [15721] = {.lex_state = 0, .external_lex_state = 336},
  [15722] = {.lex_state = 58, .external_lex_state = 390},
  [15723] = {.lex_state = 0, .external_lex_state = 405},
  [15724] = {.lex_state = 58, .external_lex_state = 336},
  [15725] = {.lex_state = 0, .external_lex_state = 336},
  [15726] = {.lex_state = 0, .external_lex_state = 405},
  [15727] = {.lex_state = 58, .external_lex_state = 390},
  [15728] = {.lex_state = 58, .external_lex_state = 390},
  [15729] = {.lex_state = 58, .external_lex_state = 391},
  [15730] = {.lex_state = 58, .external_lex_state = 336},
  [15731] = {.lex_state = 58, .external_lex_state = 390},
  [15732] = {.lex_state = 58, .external_lex_state = 390},
  [15733] = {.lex_state = 58, .external_lex_state = 390},
  [15734] = {.lex_state = 0, .external_lex_state = 251},
  [15735] = {.lex_state = 55, .external_lex_state = 308},
  [15736] = {.lex_state = 55, .external_lex_state = 433},
  [15737] = {.lex_state = 58, .external_lex_state = 390},
  [15738] = {.lex_state = 58, .external_lex_state = 390},
  [15739] = {.lex_state = 55, .external_lex_state = 435},
  [15740] = {.lex_state = 58, .external_lex_state = 390},
  [15741] = {.lex_state = 58, .external_lex_state = 390},
  [15742] = {.lex_state = 0, .external_lex_state = 308},
  [15743] = {.lex_state = 0, .external_lex_state = 336},
  [15744] = {.lex_state = 55, .external_lex_state = 430},
  [15745] = {.lex_state = 55, .external_lex_state = 428},
  [15746] = {.lex_state = 55, .external_lex_state = 308},
  [15747] = {.lex_state = 58, .external_lex_state = 390},
  [15748] = {.lex_state = 0, .external_lex_state = 405},
  [15749] = {.lex_state = 55, .external_lex_state = 430},
  [15750] = {.lex_state = 58, .external_lex_state = 390},
  [15751] = {.lex_state = 0, .external_lex_state = 386},
  [15752] = {.lex_state = 0, .external_lex_state = 251},
  [15753] = {.lex_state = 55, .external_lex_state = 428},
  [15754] = {.lex_state = 0, .external_lex_state = 251},
  [15755] = {.lex_state = 0, .external_lex_state = 336},
  [15756] = {.lex_state = 58, .external_lex_state = 390},
  [15757] = {.lex_state = 55, .external_lex_state = 430},
  [15758] = {.lex_state = 58, .external_lex_state = 390},
  [15759] = {.lex_state = 58, .external_lex_state = 390},
  [15760] = {.lex_state = 55, .external_lex_state = 430},
  [15761] = {.lex_state = 58, .external_lex_state = 390},
  [15762] = {.lex_state = 55, .external_lex_state = 430},
  [15763] = {.lex_state = 55, .external_lex_state = 430},
  [15764] = {.lex_state = 55, .external_lex_state = 428},
  [15765] = {.lex_state = 55, .external_lex_state = 428},
  [15766] = {.lex_state = 55, .external_lex_state = 428},
  [15767] = {.lex_state = 58, .external_lex_state = 390},
  [15768] = {.lex_state = 55, .external_lex_state = 433},
  [15769] = {.lex_state = 0, .external_lex_state = 367},
  [15770] = {.lex_state = 58, .external_lex_state = 390},
  [15771] = {.lex_state = 55, .external_lex_state = 430},
  [15772] = {.lex_state = 58, .external_lex_state = 390},
  [15773] = {.lex_state = 0, .external_lex_state = 336},
  [15774] = {.lex_state = 55, .external_lex_state = 430},
  [15775] = {.lex_state = 58, .external_lex_state = 390},
  [15776] = {.lex_state = 55, .external_lex_state = 430},
  [15777] = {.lex_state = 58, .external_lex_state = 390},
  [15778] = {.lex_state = 58, .external_lex_state = 389},
  [15779] = {.lex_state = 58, .external_lex_state = 390},
  [15780] = {.lex_state = 55, .external_lex_state = 428},
  [15781] = {.lex_state = 55, .external_lex_state = 430},
  [15782] = {.lex_state = 58, .external_lex_state = 390},
  [15783] = {.lex_state = 58, .external_lex_state = 390},
  [15784] = {.lex_state = 55, .external_lex_state = 433},
  [15785] = {.lex_state = 0, .external_lex_state = 350},
  [15786] = {.lex_state = 0, .external_lex_state = 336},
  [15787] = {.lex_state = 58, .external_lex_state = 390},
  [15788] = {.lex_state = 0, .external_lex_state = 308},
  [15789] = {.lex_state = 55, .external_lex_state = 428},
  [15790] = {.lex_state = 58, .external_lex_state = 390},
  [15791] = {.lex_state = 57, .external_lex_state = 308},
  [15792] = {.lex_state = 55, .external_lex_state = 308},
  [15793] = {.lex_state = 58, .external_lex_state = 390},
  [15794] = {.lex_state = 58, .external_lex_state = 390},
  [15795] = {.lex_state = 58, .external_lex_state = 390},
  [15796] = {.lex_state = 57, .external_lex_state = 436},
  [15797] = {.lex_state = 58, .external_lex_state = 390},
  [15798] = {.lex_state = 55, .external_lex_state = 433},
  [15799] = {.lex_state = 55, .external_lex_state = 308},
  [15800] = {.lex_state = 58, .external_lex_state = 400},
  [15801] = {.lex_state = 55, .external_lex_state = 430},
  [15802] = {.lex_state = 55, .external_lex_state = 430},
  [15803] = {.lex_state = 58, .external_lex_state = 391},
  [15804] = {.lex_state = 55, .external_lex_state = 308},
  [15805] = {.lex_state = 58, .external_lex_state = 390},
  [15806] = {.lex_state = 58, .external_lex_state = 390},
  [15807] = {.lex_state = 55, .external_lex_state = 430},
  [15808] = {.lex_state = 58, .external_lex_state = 390},
  [15809] = {.lex_state = 0, .external_lex_state = 386},
  [15810] = {.lex_state = 58, .external_lex_state = 390},
  [15811] = {.lex_state = 58, .external_lex_state = 390},
  [15812] = {.lex_state = 58, .external_lex_state = 390},
  [15813] = {.lex_state = 55, .external_lex_state = 430},
  [15814] = {.lex_state = 55, .external_lex_state = 308},
  [15815] = {.lex_state = 58, .external_lex_state = 390},
  [15816] = {.lex_state = 55, .external_lex_state = 435},
  [15817] = {.lex_state = 0, .external_lex_state = 432},
  [15818] = {.lex_state = 0, .external_lex_state = 308},
  [15819] = {.lex_state = 55, .external_lex_state = 430},
  [15820] = {.lex_state = 55, .external_lex_state = 406},
  [15821] = {.lex_state = 0, .external_lex_state = 367},
  [15822] = {.lex_state = 58, .external_lex_state = 390},
  [15823] = {.lex_state = 55, .external_lex_state = 430},
  [15824] = {.lex_state = 58, .external_lex_state = 390},
  [15825] = {.lex_state = 58, .external_lex_state = 390},
  [15826] = {.lex_state = 55, .external_lex_state = 428},
  [15827] = {.lex_state = 58, .external_lex_state = 390},
  [15828] = {.lex_state = 58, .external_lex_state = 390},
  [15829] = {.lex_state = 55, .external_lex_state = 430},
  [15830] = {.lex_state = 58, .external_lex_state = 390},
  [15831] = {.lex_state = 0, .external_lex_state = 336},
  [15832] = {.lex_state = 55, .external_lex_state = 433},
  [15833] = {.lex_state = 55, .external_lex_state = 435},
  [15834] = {.lex_state = 0, .external_lex_state = 437},
  [15835] = {.lex_state = 0, .external_lex_state = 336},
  [15836] = {.lex_state = 55, .external_lex_state = 438},
  [15837] = {.lex_state = 58, .external_lex_state = 390},
  [15838] = {.lex_state = 58, .external_lex_state = 390},
  [15839] = {.lex_state = 55, .external_lex_state = 428},
  [15840] = {.lex_state = 55, .external_lex_state = 438},
  [15841] = {.lex_state = 55, .external_lex_state = 387},
  [15842] = {.lex_state = 58, .external_lex_state = 390},
  [15843] = {.lex_state = 58, .external_lex_state = 390},
  [15844] = {.lex_state = 55, .external_lex_state = 387},
  [15845] = {.lex_state = 55, .external_lex_state = 308},
  [15846] = {.lex_state = 55, .external_lex_state = 428},
  [15847] = {.lex_state = 55, .external_lex_state = 430},
  [15848] = {.lex_state = 58, .external_lex_state = 391},
  [15849] = {.lex_state = 58, .external_lex_state = 390},
  [15850] = {.lex_state = 58, .external_lex_state = 430},
  [15851] = {.lex_state = 58, .external_lex_state = 391},
  [15852] = {.lex_state = 0, .external_lex_state = 308},
  [15853] = {.lex_state = 0, .external_lex_state = 367},
  [15854] = {.lex_state = 55, .external_lex_state = 430},
  [15855] = {.lex_state = 58, .external_lex_state = 390},
  [15856] = {.lex_state = 0, .external_lex_state = 405},
  [15857] = {.lex_state = 58, .external_lex_state = 390},
  [15858] = {.lex_state = 58, .external_lex_state = 390},
  [15859] = {.lex_state = 0, .external_lex_state = 405},
  [15860] = {.lex_state = 58, .external_lex_state = 336},
  [15861] = {.lex_state = 55, .external_lex_state = 308},
  [15862] = {.lex_state = 0, .external_lex_state = 251},
  [15863] = {.lex_state = 55, .external_lex_state = 308},
  [15864] = {.lex_state = 57, .external_lex_state = 308},
  [15865] = {.lex_state = 58, .external_lex_state = 390},
  [15866] = {.lex_state = 0, .external_lex_state = 200},
  [15867] = {.lex_state = 0, .external_lex_state = 308},
  [15868] = {.lex_state = 0, .external_lex_state = 336},
  [15869] = {.lex_state = 55, .external_lex_state = 435},
  [15870] = {.lex_state = 55, .external_lex_state = 393},
  [15871] = {.lex_state = 0, .external_lex_state = 336},
  [15872] = {.lex_state = 58, .external_lex_state = 390},
  [15873] = {.lex_state = 58, .external_lex_state = 390},
  [15874] = {.lex_state = 58, .external_lex_state = 390},
  [15875] = {.lex_state = 58, .external_lex_state = 390},
  [15876] = {.lex_state = 57, .external_lex_state = 436},
  [15877] = {.lex_state = 58, .external_lex_state = 391},
  [15878] = {.lex_state = 58, .external_lex_state = 390},
  [15879] = {.lex_state = 55, .external_lex_state = 428},
  [15880] = {.lex_state = 55, .external_lex_state = 428},
  [15881] = {.lex_state = 58, .external_lex_state = 390},
  [15882] = {.lex_state = 0, .external_lex_state = 251},
  [15883] = {.lex_state = 0, .external_lex_state = 251},
  [15884] = {.lex_state = 58, .external_lex_state = 390},
  [15885] = {.lex_state = 55, .external_lex_state = 428},
  [15886] = {.lex_state = 55, .external_lex_state = 308},
  [15887] = {.lex_state = 58, .external_lex_state = 390},
  [15888] = {.lex_state = 0, .external_lex_state = 386},
  [15889] = {.lex_state = 58, .external_lex_state = 390},
  [15890] = {.lex_state = 58, .external_lex_state = 390},
  [15891] = {.lex_state = 0, .external_lex_state = 251},
  [15892] = {.lex_state = 0, .external_lex_state = 405},
  [15893] = {.lex_state = 0, .external_lex_state = 439},
  [15894] = {.lex_state = 55, .external_lex_state = 430},
  [15895] = {.lex_state = 58, .external_lex_state = 390},
  [15896] = {.lex_state = 0, .external_lex_state = 437},
  [15897] = {.lex_state = 58, .external_lex_state = 390},
  [15898] = {.lex_state = 55, .external_lex_state = 308},
  [15899] = {.lex_state = 0, .external_lex_state = 427},
  [15900] = {.lex_state = 0, .external_lex_state = 437},
  [15901] = {.lex_state = 58, .external_lex_state = 390},
  [15902] = {.lex_state = 58, .external_lex_state = 390},
  [15903] = {.lex_state = 58, .external_lex_state = 390},
  [15904] = {.lex_state = 58, .external_lex_state = 390},
  [15905] = {.lex_state = 55, .external_lex_state = 438},
  [15906] = {.lex_state = 55, .external_lex_state = 430},
  [15907] = {.lex_state = 55, .external_lex_state = 430},
  [15908] = {.lex_state = 58, .external_lex_state = 390},
  [15909] = {.lex_state = 55, .external_lex_state = 406},
  [15910] = {.lex_state = 55, .external_lex_state = 308},
  [15911] = {.lex_state = 55, .external_lex_state = 430},
  [15912] = {.lex_state = 0, .external_lex_state = 251},
  [15913] = {.lex_state = 55, .external_lex_state = 393},
  [15914] = {.lex_state = 0, .external_lex_state = 251},
  [15915] = {.lex_state = 57, .external_lex_state = 308},
  [15916] = {.lex_state = 55, .external_lex_state = 407},
  [15917] = {.lex_state = 58, .external_lex_state = 390},
  [15918] = {.lex_state = 55, .external_lex_state = 407},
  [15919] = {.lex_state = 0, .external_lex_state = 432},
  [15920] = {.lex_state = 55, .external_lex_state = 406},
  [15921] = {.lex_state = 58, .external_lex_state = 389},
  [15922] = {.lex_state = 0, .external_lex_state = 336},
  [15923] = {.lex_state = 58, .external_lex_state = 390},
  [15924] = {.lex_state = 57, .external_lex_state = 308},
  [15925] = {.lex_state = 0, .external_lex_state = 251},
  [15926] = {.lex_state = 58, .external_lex_state = 390},
  [15927] = {.lex_state = 55, .external_lex_state = 308},
  [15928] = {.lex_state = 55, .external_lex_state = 308},
  [15929] = {.lex_state = 58, .external_lex_state = 390},
  [15930] = {.lex_state = 55, .external_lex_state = 387},
  [15931] = {.lex_state = 0, .external_lex_state = 251},
  [15932] = {.lex_state = 58, .external_lex_state = 390},
  [15933] = {.lex_state = 57, .external_lex_state = 436},
  [15934] = {.lex_state = 58, .external_lex_state = 390},
  [15935] = {.lex_state = 58, .external_lex_state = 390},
  [15936] = {.lex_state = 55, .external_lex_state = 308},
  [15937] = {.lex_state = 55, .external_lex_state = 308},
  [15938] = {.lex_state = 0, .external_lex_state = 336},
  [15939] = {.lex_state = 55, .external_lex_state = 430},
  [15940] = {.lex_state = 58, .external_lex_state = 390},
  [15941] = {.lex_state = 55, .external_lex_state = 430},
  [15942] = {.lex_state = 58, .external_lex_state = 390},
  [15943] = {.lex_state = 0, .external_lex_state = 251},
  [15944] = {.lex_state = 55, .external_lex_state = 430},
  [15945] = {.lex_state = 55, .external_lex_state = 438},
  [15946] = {.lex_state = 58, .external_lex_state = 390},
  [15947] = {.lex_state = 58, .external_lex_state = 390},
  [15948] = {.lex_state = 0, .external_lex_state = 308},
  [15949] = {.lex_state = 55, .external_lex_state = 308},
  [15950] = {.lex_state = 55, .external_lex_state = 393},
  [15951] = {.lex_state = 0, .external_lex_state = 336},
  [15952] = {.lex_state = 55, .external_lex_state = 406},
  [15953] = {.lex_state = 55, .external_lex_state = 308},
  [15954] = {.lex_state = 58, .external_lex_state = 390},
  [15955] = {.lex_state = 58, .external_lex_state = 390},
  [15956] = {.lex_state = 58, .external_lex_state = 390},
  [15957] = {.lex_state = 55, .external_lex_state = 406},
  [15958] = {.lex_state = 58, .external_lex_state = 390},
  [15959] = {.lex_state = 0, .external_lex_state = 336},
  [15960] = {.lex_state = 58, .external_lex_state = 390},
  [15961] = {.lex_state = 55, .external_lex_state = 308},
  [15962] = {.lex_state = 58, .external_lex_state = 390},
  [15963] = {.lex_state = 58, .external_lex_state = 390},
  [15964] = {.lex_state = 58, .external_lex_state = 390},
  [15965] = {.lex_state = 0, .external_lex_state = 308},
  [15966] = {.lex_state = 58, .external_lex_state = 390},
  [15967] = {.lex_state = 58, .external_lex_state = 390},
  [15968] = {.lex_state = 0, .external_lex_state = 308},
  [15969] = {.lex_state = 0, .external_lex_state = 434},
  [15970] = {.lex_state = 58, .external_lex_state = 390},
  [15971] = {.lex_state = 58, .external_lex_state = 390},
  [15972] = {.lex_state = 0, .external_lex_state = 251},
  [15973] = {.lex_state = 55, .external_lex_state = 406},
  [15974] = {.lex_state = 58, .external_lex_state = 390},
  [15975] = {.lex_state = 0, .external_lex_state = 405},
  [15976] = {.lex_state = 55, .external_lex_state = 308},
  [15977] = {.lex_state = 58, .external_lex_state = 390},
  [15978] = {.lex_state = 58, .external_lex_state = 390},
  [15979] = {.lex_state = 58, .external_lex_state = 390},
  [15980] = {.lex_state = 55, .external_lex_state = 428},
  [15981] = {.lex_state = 55, .external_lex_state = 428},
  [15982] = {.lex_state = 0, .external_lex_state = 336},
  [15983] = {.lex_state = 58, .external_lex_state = 390},
  [15984] = {.lex_state = 55, .external_lex_state = 438},
  [15985] = {.lex_state = 55, .external_lex_state = 308},
  [15986] = {.lex_state = 55, .external_lex_state = 308},
  [15987] = {.lex_state = 55, .external_lex_state = 428},
  [15988] = {.lex_state = 0, .external_lex_state = 251},
  [15989] = {.lex_state = 0, .external_lex_state = 308},
  [15990] = {.lex_state = 55, .external_lex_state = 428},
  [15991] = {.lex_state = 58, .external_lex_state = 401},
  [15992] = {.lex_state = 55, .external_lex_state = 308},
  [15993] = {.lex_state = 58, .external_lex_state = 390},
  [15994] = {.lex_state = 0, .external_lex_state = 336},
  [15995] = {.lex_state = 0, .external_lex_state = 419},
  [15996] = {.lex_state = 57, .external_lex_state = 308},
  [15997] = {.lex_state = 55, .external_lex_state = 430},
  [15998] = {.lex_state = 55, .external_lex_state = 308},
  [15999] = {.lex_state = 58, .external_lex_state = 390},
  [16000] = {.lex_state = 57, .external_lex_state = 308},
  [16001] = {.lex_state = 55, .external_lex_state = 428},
  [16002] = {.lex_state = 58, .external_lex_state = 390},
  [16003] = {.lex_state = 58, .external_lex_state = 390},
  [16004] = {.lex_state = 55, .external_lex_state = 308},
  [16005] = {.lex_state = 55, .external_lex_state = 308},
  [16006] = {.lex_state = 55, .external_lex_state = 438},
  [16007] = {.lex_state = 0, .external_lex_state = 308},
  [16008] = {.lex_state = 58, .external_lex_state = 390},
  [16009] = {.lex_state = 55, .external_lex_state = 430},
  [16010] = {.lex_state = 55, .external_lex_state = 428},
  [16011] = {.lex_state = 55, .external_lex_state = 433},
  [16012] = {.lex_state = 0, .external_lex_state = 339},
  [16013] = {.lex_state = 58, .external_lex_state = 390},
  [16014] = {.lex_state = 55, .external_lex_state = 430},
  [16015] = {.lex_state = 0, .external_lex_state = 437},
  [16016] = {.lex_state = 0, .external_lex_state = 437},
  [16017] = {.lex_state = 58, .external_lex_state = 390},
  [16018] = {.lex_state = 58, .external_lex_state = 390},
  [16019] = {.lex_state = 57, .external_lex_state = 308},
  [16020] = {.lex_state = 0, .external_lex_state = 336},
  [16021] = {.lex_state = 58, .external_lex_state = 390},
  [16022] = {.lex_state = 0, .external_lex_state = 251},
  [16023] = {.lex_state = 55, .external_lex_state = 308},
  [16024] = {.lex_state = 58, .external_lex_state = 390},
  [16025] = {.lex_state = 58, .external_lex_state = 390},
  [16026] = {.lex_state = 55, .external_lex_state = 308},
  [16027] = {.lex_state = 55, .external_lex_state = 393},
  [16028] = {.lex_state = 55, .external_lex_state = 428},
  [16029] = {.lex_state = 0, .external_lex_state = 308},
  [16030] = {.lex_state = 55, .external_lex_state = 407},
  [16031] = {.lex_state = 55, .external_lex_state = 308},
  [16032] = {.lex_state = 55, .external_lex_state = 308},
  [16033] = {.lex_state = 58, .external_lex_state = 390},
  [16034] = {.lex_state = 58, .external_lex_state = 390},
  [16035] = {.lex_state = 55, .external_lex_state = 308},
  [16036] = {.lex_state = 58, .external_lex_state = 390},
  [16037] = {.lex_state = 55, .external_lex_state = 393},
  [16038] = {.lex_state = 58, .external_lex_state = 390},
  [16039] = {.lex_state = 58, .external_lex_state = 390},
  [16040] = {.lex_state = 0, .external_lex_state = 251},
  [16041] = {.lex_state = 55, .external_lex_state = 430},
  [16042] = {.lex_state = 55, .external_lex_state = 430},
  [16043] = {.lex_state = 0, .external_lex_state = 308},
  [16044] = {.lex_state = 55, .external_lex_state = 397},
  [16045] = {.lex_state = 58, .external_lex_state = 390},
  [16046] = {.lex_state = 55, .external_lex_state = 308},
  [16047] = {.lex_state = 58, .external_lex_state = 336},
  [16048] = {.lex_state = 58, .external_lex_state = 390},
  [16049] = {.lex_state = 58, .external_lex_state = 390},
  [16050] = {.lex_state = 0, .external_lex_state = 308},
  [16051] = {.lex_state = 55, .external_lex_state = 428},
  [16052] = {.lex_state = 0, .external_lex_state = 336},
  [16053] = {.lex_state = 58, .external_lex_state = 390},
  [16054] = {.lex_state = 58, .external_lex_state = 390},
  [16055] = {.lex_state = 58, .external_lex_state = 390},
  [16056] = {.lex_state = 0, .external_lex_state = 308},
  [16057] = {.lex_state = 0, .external_lex_state = 308},
  [16058] = {.lex_state = 58, .external_lex_state = 389},
  [16059] = {.lex_state = 55, .external_lex_state = 308},
  [16060] = {.lex_state = 0, .external_lex_state = 308},
  [16061] = {.lex_state = 55, .external_lex_state = 308},
  [16062] = {.lex_state = 58, .external_lex_state = 390},
  [16063] = {.lex_state = 0, .external_lex_state = 422},
  [16064] = {.lex_state = 0, .external_lex_state = 432},
  [16065] = {.lex_state = 55, .external_lex_state = 308},
  [16066] = {.lex_state = 57, .external_lex_state = 436},
  [16067] = {.lex_state = 55, .external_lex_state = 308},
  [16068] = {.lex_state = 58, .external_lex_state = 390},
  [16069] = {.lex_state = 58, .external_lex_state = 390},
  [16070] = {.lex_state = 0, .external_lex_state = 437},
  [16071] = {.lex_state = 55, .external_lex_state = 308},
  [16072] = {.lex_state = 57, .external_lex_state = 308},
  [16073] = {.lex_state = 55, .external_lex_state = 308},
  [16074] = {.lex_state = 0, .external_lex_state = 437},
  [16075] = {.lex_state = 55, .external_lex_state = 308},
  [16076] = {.lex_state = 58, .external_lex_state = 390},
  [16077] = {.lex_state = 58, .external_lex_state = 390},
  [16078] = {.lex_state = 58, .external_lex_state = 390},
  [16079] = {.lex_state = 57, .external_lex_state = 308},
  [16080] = {.lex_state = 58, .external_lex_state = 390},
  [16081] = {.lex_state = 58, .external_lex_state = 390},
  [16082] = {.lex_state = 55, .external_lex_state = 308},
  [16083] = {.lex_state = 58, .external_lex_state = 390},
  [16084] = {.lex_state = 58, .external_lex_state = 390},
  [16085] = {.lex_state = 0, .external_lex_state = 432},
  [16086] = {.lex_state = 55, .external_lex_state = 407},
  [16087] = {.lex_state = 57, .external_lex_state = 308},
  [16088] = {.lex_state = 55, .external_lex_state = 367},
  [16089] = {.lex_state = 0, .external_lex_state = 339},
  [16090] = {.lex_state = 0, .external_lex_state = 308},
  [16091] = {.lex_state = 55, .external_lex_state = 438},
  [16092] = {.lex_state = 55, .external_lex_state = 397},
  [16093] = {.lex_state = 58, .external_lex_state = 390},
  [16094] = {.lex_state = 0, .external_lex_state = 336},
  [16095] = {.lex_state = 58, .external_lex_state = 390},
  [16096] = {.lex_state = 55, .external_lex_state = 308},
  [16097] = {.lex_state = 55, .external_lex_state = 430},
  [16098] = {.lex_state = 58, .external_lex_state = 390},
  [16099] = {.lex_state = 0, .external_lex_state = 336},
  [16100] = {.lex_state = 55, .external_lex_state = 428},
  [16101] = {.lex_state = 55, .external_lex_state = 438},
  [16102] = {.lex_state = 58, .external_lex_state = 390},
  [16103] = {.lex_state = 58, .external_lex_state = 390},
  [16104] = {.lex_state = 55, .external_lex_state = 308},
  [16105] = {.lex_state = 58, .external_lex_state = 390},
  [16106] = {.lex_state = 55, .external_lex_state = 308},
  [16107] = {.lex_state = 55, .external_lex_state = 438},
  [16108] = {.lex_state = 0, .external_lex_state = 437},
  [16109] = {.lex_state = 58, .external_lex_state = 390},
  [16110] = {.lex_state = 0, .external_lex_state = 251},
  [16111] = {.lex_state = 55, .external_lex_state = 430},
  [16112] = {.lex_state = 0, .external_lex_state = 439},
  [16113] = {.lex_state = 55, .external_lex_state = 428},
  [16114] = {.lex_state = 58, .external_lex_state = 390},
  [16115] = {.lex_state = 55, .external_lex_state = 428},
  [16116] = {.lex_state = 58, .external_lex_state = 390},
  [16117] = {.lex_state = 0, .external_lex_state = 336},
  [16118] = {.lex_state = 58, .external_lex_state = 390},
  [16119] = {.lex_state = 58, .external_lex_state = 390},
  [16120] = {.lex_state = 58, .external_lex_state = 390},
  [16121] = {.lex_state = 57, .external_lex_state = 308},
  [16122] = {.lex_state = 58, .external_lex_state = 390},
  [16123] = {.lex_state = 58, .external_lex_state = 389},
  [16124] = {.lex_state = 58, .external_lex_state = 391},
  [16125] = {.lex_state = 58, .external_lex_state = 390},
  [16126] = {.lex_state = 58, .external_lex_state = 390},
  [16127] = {.lex_state = 58, .external_lex_state = 390},
  [16128] = {.lex_state = 58, .external_lex_state = 390},
  [16129] = {.lex_state = 55, .external_lex_state = 367},
  [16130] = {.lex_state = 0, .external_lex_state = 251},
  [16131] = {.lex_state = 0, .external_lex_state = 437},
  [16132] = {.lex_state = 58, .external_lex_state = 390},
  [16133] = {.lex_state = 58, .external_lex_state = 390},
  [16134] = {.lex_state = 58, .external_lex_state = 391},
  [16135] = {.lex_state = 55, .external_lex_state = 430},
  [16136] = {.lex_state = 0, .external_lex_state = 336},
  [16137] = {.lex_state = 55, .external_lex_state = 308},
  [16138] = {.lex_state = 55, .external_lex_state = 387},
  [16139] = {.lex_state = 55, .external_lex_state = 308},
  [16140] = {.lex_state = 55, .external_lex_state = 387},
  [16141] = {.lex_state = 0, .external_lex_state = 336},
  [16142] = {.lex_state = 55, .external_lex_state = 367},
  [16143] = {.lex_state = 58, .external_lex_state = 390},
  [16144] = {.lex_state = 58, .external_lex_state = 390},
  [16145] = {.lex_state = 58, .external_lex_state = 390},
  [16146] = {.lex_state = 55, .external_lex_state = 393},
  [16147] = {.lex_state = 55, .external_lex_state = 430},
  [16148] = {.lex_state = 55, .external_lex_state = 308},
  [16149] = {.lex_state = 55, .external_lex_state = 308},
  [16150] = {.lex_state = 55, .external_lex_state = 430},
  [16151] = {.lex_state = 55, .external_lex_state = 308},
  [16152] = {.lex_state = 58, .external_lex_state = 390},
  [16153] = {.lex_state = 58, .external_lex_state = 390},
  [16154] = {.lex_state = 55, .external_lex_state = 367},
  [16155] = {.lex_state = 58, .external_lex_state = 390},
  [16156] = {.lex_state = 58, .external_lex_state = 390},
  [16157] = {.lex_state = 0, .external_lex_state = 336},
  [16158] = {.lex_state = 0, .external_lex_state = 422},
  [16159] = {.lex_state = 55, .external_lex_state = 308},
  [16160] = {.lex_state = 55, .external_lex_state = 308},
  [16161] = {.lex_state = 58, .external_lex_state = 390},
  [16162] = {.lex_state = 57, .external_lex_state = 308},
  [16163] = {.lex_state = 55, .external_lex_state = 308},
  [16164] = {.lex_state = 55, .external_lex_state = 308},
  [16165] = {.lex_state = 0, .external_lex_state = 251},
  [16166] = {.lex_state = 55, .external_lex_state = 308},
  [16167] = {.lex_state = 0, .external_lex_state = 308},
  [16168] = {.lex_state = 58, .external_lex_state = 390},
  [16169] = {.lex_state = 55, .external_lex_state = 430},
  [16170] = {.lex_state = 58, .external_lex_state = 390},
  [16171] = {.lex_state = 55, .external_lex_state = 397},
  [16172] = {.lex_state = 57, .external_lex_state = 308},
  [16173] = {.lex_state = 55, .external_lex_state = 367},
  [16174] = {.lex_state = 0, .external_lex_state = 427},
  [16175] = {.lex_state = 55, .external_lex_state = 428},
  [16176] = {.lex_state = 57, .external_lex_state = 308},
  [16177] = {.lex_state = 55, .external_lex_state = 397},
  [16178] = {.lex_state = 58, .external_lex_state = 390},
  [16179] = {.lex_state = 58, .external_lex_state = 391},
  [16180] = {.lex_state = 55, .external_lex_state = 397},
  [16181] = {.lex_state = 58, .external_lex_state = 390},
  [16182] = {.lex_state = 55, .external_lex_state = 430},
  [16183] = {.lex_state = 0, .external_lex_state = 339},
  [16184] = {.lex_state = 0, .external_lex_state = 215},
  [16185] = {.lex_state = 55, .external_lex_state = 430},
  [16186] = {.lex_state = 0, .external_lex_state = 339},
  [16187] = {.lex_state = 0, .external_lex_state = 339},
  [16188] = {.lex_state = 58, .external_lex_state = 390},
  [16189] = {.lex_state = 57, .external_lex_state = 308},
  [16190] = {.lex_state = 57, .external_lex_state = 308},
  [16191] = {.lex_state = 58, .external_lex_state = 390},
  [16192] = {.lex_state = 55, .external_lex_state = 308},
  [16193] = {.lex_state = 55, .external_lex_state = 308},
  [16194] = {.lex_state = 55, .external_lex_state = 308},
  [16195] = {.lex_state = 55, .external_lex_state = 428},
  [16196] = {.lex_state = 58, .external_lex_state = 390},
  [16197] = {.lex_state = 55, .external_lex_state = 428},
  [16198] = {.lex_state = 55, .external_lex_state = 397},
  [16199] = {.lex_state = 57, .external_lex_state = 308},
  [16200] = {.lex_state = 55, .external_lex_state = 308},
  [16201] = {.lex_state = 55, .external_lex_state = 397},
  [16202] = {.lex_state = 55, .external_lex_state = 308},
  [16203] = {.lex_state = 55, .external_lex_state = 308},
  [16204] = {.lex_state = 58, .external_lex_state = 390},
  [16205] = {.lex_state = 58, .external_lex_state = 390},
  [16206] = {.lex_state = 0, .external_lex_state = 350},
  [16207] = {.lex_state = 58, .external_lex_state = 390},
  [16208] = {.lex_state = 55, .external_lex_state = 308},
  [16209] = {.lex_state = 0, .external_lex_state = 417},
  [16210] = {.lex_state = 55, .external_lex_state = 308},
  [16211] = {.lex_state = 58, .external_lex_state = 390},
  [16212] = {.lex_state = 55, .external_lex_state = 308},
  [16213] = {.lex_state = 55, .external_lex_state = 428},
  [16214] = {.lex_state = 58, .external_lex_state = 390},
  [16215] = {.lex_state = 0, .external_lex_state = 434},
  [16216] = {.lex_state = 55, .external_lex_state = 428},
  [16217] = {.lex_state = 58, .external_lex_state = 390},
  [16218] = {.lex_state = 58, .external_lex_state = 390},
  [16219] = {.lex_state = 55, .external_lex_state = 428},
  [16220] = {.lex_state = 55, .external_lex_state = 308},
  [16221] = {.lex_state = 58, .external_lex_state = 390},
  [16222] = {.lex_state = 58, .external_lex_state = 390},
  [16223] = {.lex_state = 58, .external_lex_state = 390},
  [16224] = {.lex_state = 55, .external_lex_state = 428},
  [16225] = {.lex_state = 58, .external_lex_state = 389},
  [16226] = {.lex_state = 55, .external_lex_state = 428},
  [16227] = {.lex_state = 55, .external_lex_state = 428},
  [16228] = {.lex_state = 55, .external_lex_state = 387},
  [16229] = {.lex_state = 58, .external_lex_state = 390},
  [16230] = {.lex_state = 58, .external_lex_state = 390},
  [16231] = {.lex_state = 0, .external_lex_state = 422},
  [16232] = {.lex_state = 55, .external_lex_state = 428},
  [16233] = {.lex_state = 58, .external_lex_state = 336},
  [16234] = {.lex_state = 55, .external_lex_state = 428},
  [16235] = {.lex_state = 55, .external_lex_state = 428},
  [16236] = {.lex_state = 0, .external_lex_state = 439},
  [16237] = {.lex_state = 55, .external_lex_state = 308},
  [16238] = {.lex_state = 58, .external_lex_state = 390},
  [16239] = {.lex_state = 55, .external_lex_state = 308},
  [16240] = {.lex_state = 55, .external_lex_state = 428},
  [16241] = {.lex_state = 55, .external_lex_state = 428},
  [16242] = {.lex_state = 55, .external_lex_state = 393},
  [16243] = {.lex_state = 58, .external_lex_state = 390},
  [16244] = {.lex_state = 58, .external_lex_state = 389},
  [16245] = {.lex_state = 0, .external_lex_state = 336},
  [16246] = {.lex_state = 0, .external_lex_state = 308},
  [16247] = {.lex_state = 0, .external_lex_state = 439},
  [16248] = {.lex_state = 55, .external_lex_state = 430},
  [16249] = {.lex_state = 58, .external_lex_state = 399},
  [16250] = {.lex_state = 0, .external_lex_state = 308},
  [16251] = {.lex_state = 0, .external_lex_state = 308},
  [16252] = {.lex_state = 0, .external_lex_state = 308},
  [16253] = {.lex_state = 0, .external_lex_state = 308},
  [16254] = {.lex_state = 58, .external_lex_state = 399},
  [16255] = {.lex_state = 0, .external_lex_state = 308},
  [16256] = {.lex_state = 0, .external_lex_state = 308},
  [16257] = {.lex_state = 0, .external_lex_state = 386},
  [16258] = {.lex_state = 0, .external_lex_state = 386},
  [16259] = {.lex_state = 0, .external_lex_state = 386},
  [16260] = {.lex_state = 0, .external_lex_state = 308},
  [16261] = {.lex_state = 0, .external_lex_state = 308},
  [16262] = {.lex_state = 0, .external_lex_state = 308},
  [16263] = {.lex_state = 0, .external_lex_state = 308},
  [16264] = {.lex_state = 0, .external_lex_state = 308},
  [16265] = {.lex_state = 0, .external_lex_state = 308},
  [16266] = {.lex_state = 0, .external_lex_state = 308},
  [16267] = {.lex_state = 0, .external_lex_state = 386},
  [16268] = {.lex_state = 0, .external_lex_state = 308},
  [16269] = {.lex_state = 0, .external_lex_state = 386},
  [16270] = {.lex_state = 0, .external_lex_state = 308},
  [16271] = {.lex_state = 0, .external_lex_state = 308},
  [16272] = {.lex_state = 0, .external_lex_state = 386},
  [16273] = {.lex_state = 0, .external_lex_state = 308},
  [16274] = {.lex_state = 0, .external_lex_state = 386},
  [16275] = {.lex_state = 0, .external_lex_state = 308},
  [16276] = {.lex_state = 0, .external_lex_state = 308},
  [16277] = {.lex_state = 0, .external_lex_state = 308},
  [16278] = {.lex_state = 0, .external_lex_state = 308},
  [16279] = {.lex_state = 0, .external_lex_state = 336},
  [16280] = {.lex_state = 0, .external_lex_state = 336},
  [16281] = {.lex_state = 0, .external_lex_state = 386},
  [16282] = {.lex_state = 0, .external_lex_state = 386},
  [16283] = {.lex_state = 0, .external_lex_state = 386},
  [16284] = {.lex_state = 0, .external_lex_state = 308},
  [16285] = {.lex_state = 0, .external_lex_state = 308},
  [16286] = {.lex_state = 0, .external_lex_state = 308},
  [16287] = {.lex_state = 0, .external_lex_state = 308},
  [16288] = {.lex_state = 0, .external_lex_state = 386},
  [16289] = {.lex_state = 0, .external_lex_state = 386},
  [16290] = {.lex_state = 0, .external_lex_state = 308},
  [16291] = {.lex_state = 0, .external_lex_state = 308},
  [16292] = {.lex_state = 0, .external_lex_state = 308},
  [16293] = {.lex_state = 0, .external_lex_state = 386},
  [16294] = {.lex_state = 0, .external_lex_state = 308},
  [16295] = {.lex_state = 58, .external_lex_state = 399},
  [16296] = {.lex_state = 0, .external_lex_state = 308},
  [16297] = {.lex_state = 0, .external_lex_state = 386},
  [16298] = {.lex_state = 0, .external_lex_state = 308},
  [16299] = {.lex_state = 0, .external_lex_state = 308},
  [16300] = {.lex_state = 0, .external_lex_state = 308},
  [16301] = {.lex_state = 0, .external_lex_state = 386},
  [16302] = {.lex_state = 0, .external_lex_state = 434},
  [16303] = {.lex_state = 0, .external_lex_state = 386},
  [16304] = {.lex_state = 55, .external_lex_state = 405},
  [16305] = {.lex_state = 0, .external_lex_state = 386},
  [16306] = {.lex_state = 0, .external_lex_state = 308},
  [16307] = {.lex_state = 0, .external_lex_state = 308},
  [16308] = {.lex_state = 0, .external_lex_state = 308},
  [16309] = {.lex_state = 0, .external_lex_state = 308},
  [16310] = {.lex_state = 0, .external_lex_state = 386},
  [16311] = {.lex_state = 0, .external_lex_state = 308},
  [16312] = {.lex_state = 0, .external_lex_state = 308},
  [16313] = {.lex_state = 0, .external_lex_state = 386},
  [16314] = {.lex_state = 55, .external_lex_state = 397},
  [16315] = {.lex_state = 0, .external_lex_state = 386},
  [16316] = {.lex_state = 0, .external_lex_state = 308},
  [16317] = {.lex_state = 0, .external_lex_state = 386},
  [16318] = {.lex_state = 0, .external_lex_state = 308},
  [16319] = {.lex_state = 0, .external_lex_state = 386},
  [16320] = {.lex_state = 0, .external_lex_state = 386},
  [16321] = {.lex_state = 0, .external_lex_state = 308},
  [16322] = {.lex_state = 0, .external_lex_state = 308},
  [16323] = {.lex_state = 0, .external_lex_state = 308},
  [16324] = {.lex_state = 0, .external_lex_state = 386},
  [16325] = {.lex_state = 0, .external_lex_state = 308},
  [16326] = {.lex_state = 0, .external_lex_state = 308},
  [16327] = {.lex_state = 0, .external_lex_state = 308},
  [16328] = {.lex_state = 0, .external_lex_state = 308},
  [16329] = {.lex_state = 0, .external_lex_state = 386},
  [16330] = {.lex_state = 0, .external_lex_state = 308},
  [16331] = {.lex_state = 55, .external_lex_state = 405},
  [16332] = {.lex_state = 0, .external_lex_state = 308},
  [16333] = {.lex_state = 0, .external_lex_state = 386},
  [16334] = {.lex_state = 0, .external_lex_state = 308},
  [16335] = {.lex_state = 58, .external_lex_state = 399},
  [16336] = {.lex_state = 0, .external_lex_state = 386},
  [16337] = {.lex_state = 0, .external_lex_state = 308},
  [16338] = {.lex_state = 0, .external_lex_state = 308},
  [16339] = {.lex_state = 0, .external_lex_state = 308},
  [16340] = {.lex_state = 55, .external_lex_state = 397},
  [16341] = {.lex_state = 0, .external_lex_state = 308},
  [16342] = {.lex_state = 55, .external_lex_state = 397},
  [16343] = {.lex_state = 0, .external_lex_state = 308},
  [16344] = {.lex_state = 0, .external_lex_state = 308},
  [16345] = {.lex_state = 0, .external_lex_state = 386},
  [16346] = {.lex_state = 0, .external_lex_state = 308},
  [16347] = {.lex_state = 55, .external_lex_state = 308},
  [16348] = {.lex_state = 0, .external_lex_state = 308},
  [16349] = {.lex_state = 0, .external_lex_state = 386},
  [16350] = {.lex_state = 55, .external_lex_state = 405},
  [16351] = {.lex_state = 58, .external_lex_state = 399},
  [16352] = {.lex_state = 0, .external_lex_state = 422},
  [16353] = {.lex_state = 58, .external_lex_state = 399},
  [16354] = {.lex_state = 0, .external_lex_state = 308},
  [16355] = {.lex_state = 0, .external_lex_state = 336},
  [16356] = {.lex_state = 0, .external_lex_state = 308},
  [16357] = {.lex_state = 55, .external_lex_state = 405},
  [16358] = {.lex_state = 0, .external_lex_state = 386},
  [16359] = {.lex_state = 0, .external_lex_state = 308},
  [16360] = {.lex_state = 0, .external_lex_state = 308},
  [16361] = {.lex_state = 0, .external_lex_state = 308},
  [16362] = {.lex_state = 0, .external_lex_state = 308},
  [16363] = {.lex_state = 0, .external_lex_state = 308},
  [16364] = {.lex_state = 55, .external_lex_state = 405},
  [16365] = {.lex_state = 55, .external_lex_state = 405},
  [16366] = {.lex_state = 0, .external_lex_state = 308},
  [16367] = {.lex_state = 0, .external_lex_state = 308},
  [16368] = {.lex_state = 0, .external_lex_state = 308},
  [16369] = {.lex_state = 58, .external_lex_state = 399},
  [16370] = {.lex_state = 55, .external_lex_state = 405},
  [16371] = {.lex_state = 0, .external_lex_state = 308},
  [16372] = {.lex_state = 0, .external_lex_state = 308},
  [16373] = {.lex_state = 0, .external_lex_state = 386},
  [16374] = {.lex_state = 58, .external_lex_state = 399},
  [16375] = {.lex_state = 0, .external_lex_state = 308},
  [16376] = {.lex_state = 0, .external_lex_state = 308},
  [16377] = {.lex_state = 0, .external_lex_state = 308},
  [16378] = {.lex_state = 0, .external_lex_state = 308},
  [16379] = {.lex_state = 0, .external_lex_state = 308},
  [16380] = {.lex_state = 0, .external_lex_state = 308},
  [16381] = {.lex_state = 0, .external_lex_state = 308},
  [16382] = {.lex_state = 0, .external_lex_state = 308},
  [16383] = {.lex_state = 0, .external_lex_state = 386},
  [16384] = {.lex_state = 55, .external_lex_state = 405},
  [16385] = {.lex_state = 58, .external_lex_state = 399},
  [16386] = {.lex_state = 0, .external_lex_state = 308},
  [16387] = {.lex_state = 0, .external_lex_state = 308},
  [16388] = {.lex_state = 0, .external_lex_state = 308},
  [16389] = {.lex_state = 0, .external_lex_state = 350},
  [16390] = {.lex_state = 0, .external_lex_state = 386},
  [16391] = {.lex_state = 0, .external_lex_state = 386},
  [16392] = {.lex_state = 0, .external_lex_state = 308},
  [16393] = {.lex_state = 58, .external_lex_state = 399},
  [16394] = {.lex_state = 0, .external_lex_state = 339},
  [16395] = {.lex_state = 55, .external_lex_state = 405},
  [16396] = {.lex_state = 0, .external_lex_state = 308},
  [16397] = {.lex_state = 0, .external_lex_state = 308},
  [16398] = {.lex_state = 55, .external_lex_state = 405},
  [16399] = {.lex_state = 0, .external_lex_state = 308},
  [16400] = {.lex_state = 0, .external_lex_state = 386},
  [16401] = {.lex_state = 0, .external_lex_state = 386},
  [16402] = {.lex_state = 0, .external_lex_state = 308},
  [16403] = {.lex_state = 0, .external_lex_state = 308},
  [16404] = {.lex_state = 0, .external_lex_state = 386},
  [16405] = {.lex_state = 0, .external_lex_state = 308},
  [16406] = {.lex_state = 0, .external_lex_state = 308},
  [16407] = {.lex_state = 0, .external_lex_state = 386},
  [16408] = {.lex_state = 0, .external_lex_state = 308},
  [16409] = {.lex_state = 0, .external_lex_state = 386},
  [16410] = {.lex_state = 0, .external_lex_state = 308},
  [16411] = {.lex_state = 0, .external_lex_state = 308},
  [16412] = {.lex_state = 0, .external_lex_state = 386},
  [16413] = {.lex_state = 0, .external_lex_state = 386},
  [16414] = {.lex_state = 0, .external_lex_state = 308},
  [16415] = {.lex_state = 0, .external_lex_state = 308},
  [16416] = {.lex_state = 0, .external_lex_state = 386},
  [16417] = {.lex_state = 0, .external_lex_state = 308},
  [16418] = {.lex_state = 0, .external_lex_state = 308},
  [16419] = {.lex_state = 0, .external_lex_state = 386},
  [16420] = {.lex_state = 58, .external_lex_state = 401},
  [16421] = {.lex_state = 0, .external_lex_state = 308},
  [16422] = {.lex_state = 57, .external_lex_state = 336},
  [16423] = {.lex_state = 0, .external_lex_state = 386},
  [16424] = {.lex_state = 0, .external_lex_state = 386},
  [16425] = {.lex_state = 0, .external_lex_state = 308},
  [16426] = {.lex_state = 0, .external_lex_state = 308},
  [16427] = {.lex_state = 0, .external_lex_state = 308},
  [16428] = {.lex_state = 0, .external_lex_state = 308},
  [16429] = {.lex_state = 0, .external_lex_state = 308},
  [16430] = {.lex_state = 58, .external_lex_state = 399},
  [16431] = {.lex_state = 0, .external_lex_state = 348},
  [16432] = {.lex_state = 0, .external_lex_state = 308},
  [16433] = {.lex_state = 0, .external_lex_state = 386},
  [16434] = {.lex_state = 0, .external_lex_state = 308},
  [16435] = {.lex_state = 0, .external_lex_state = 308},
  [16436] = {.lex_state = 0, .external_lex_state = 386},
  [16437] = {.lex_state = 0, .external_lex_state = 308},
  [16438] = {.lex_state = 0, .external_lex_state = 308},
  [16439] = {.lex_state = 55, .external_lex_state = 405},
  [16440] = {.lex_state = 0, .external_lex_state = 308},
  [16441] = {.lex_state = 0, .external_lex_state = 308},
  [16442] = {.lex_state = 0, .external_lex_state = 386},
  [16443] = {.lex_state = 0, .external_lex_state = 308},
  [16444] = {.lex_state = 0, .external_lex_state = 308},
  [16445] = {.lex_state = 0, .external_lex_state = 308},
  [16446] = {.lex_state = 0, .external_lex_state = 308},
  [16447] = {.lex_state = 57, .external_lex_state = 336},
  [16448] = {.lex_state = 0, .external_lex_state = 386},
  [16449] = {.lex_state = 0, .external_lex_state = 336},
  [16450] = {.lex_state = 0, .external_lex_state = 308},
  [16451] = {.lex_state = 0, .external_lex_state = 308},
  [16452] = {.lex_state = 0, .external_lex_state = 386},
  [16453] = {.lex_state = 0, .external_lex_state = 308},
  [16454] = {.lex_state = 0, .external_lex_state = 386},
  [16455] = {.lex_state = 0, .external_lex_state = 308},
  [16456] = {.lex_state = 0, .external_lex_state = 308},
  [16457] = {.lex_state = 0, .external_lex_state = 336},
  [16458] = {.lex_state = 58, .external_lex_state = 399},
  [16459] = {.lex_state = 0, .external_lex_state = 308},
  [16460] = {.lex_state = 0, .external_lex_state = 308},
  [16461] = {.lex_state = 0, .external_lex_state = 308},
  [16462] = {.lex_state = 55, .external_lex_state = 405},
  [16463] = {.lex_state = 58, .external_lex_state = 399},
  [16464] = {.lex_state = 0, .external_lex_state = 336},
  [16465] = {.lex_state = 0, .external_lex_state = 308},
  [16466] = {.lex_state = 55, .external_lex_state = 438},
  [16467] = {.lex_state = 0, .external_lex_state = 386},
  [16468] = {.lex_state = 0, .external_lex_state = 386},
  [16469] = {.lex_state = 0, .external_lex_state = 367},
  [16470] = {.lex_state = 0, .external_lex_state = 308},
  [16471] = {.lex_state = 0, .external_lex_state = 308},
  [16472] = {.lex_state = 0, .external_lex_state = 386},
  [16473] = {.lex_state = 0, .external_lex_state = 308},
  [16474] = {.lex_state = 0, .external_lex_state = 308},
  [16475] = {.lex_state = 0, .external_lex_state = 308},
  [16476] = {.lex_state = 0, .external_lex_state = 308},
  [16477] = {.lex_state = 0, .external_lex_state = 386},
  [16478] = {.lex_state = 0, .external_lex_state = 308},
  [16479] = {.lex_state = 0, .external_lex_state = 308},
  [16480] = {.lex_state = 0, .external_lex_state = 386},
  [16481] = {.lex_state = 55, .external_lex_state = 405},
  [16482] = {.lex_state = 0, .external_lex_state = 308},
  [16483] = {.lex_state = 0, .external_lex_state = 308},
  [16484] = {.lex_state = 0, .external_lex_state = 348},
  [16485] = {.lex_state = 0, .external_lex_state = 308},
  [16486] = {.lex_state = 58, .external_lex_state = 399},
  [16487] = {.lex_state = 0, .external_lex_state = 308},
  [16488] = {.lex_state = 0, .external_lex_state = 308},
  [16489] = {.lex_state = 57, .external_lex_state = 336},
  [16490] = {.lex_state = 0, .external_lex_state = 308},
  [16491] = {.lex_state = 0, .external_lex_state = 308},
  [16492] = {.lex_state = 0, .external_lex_state = 308},
  [16493] = {.lex_state = 0, .external_lex_state = 308},
  [16494] = {.lex_state = 0, .external_lex_state = 308},
  [16495] = {.lex_state = 0, .external_lex_state = 308},
  [16496] = {.lex_state = 0, .external_lex_state = 308},
  [16497] = {.lex_state = 0, .external_lex_state = 308},
  [16498] = {.lex_state = 0, .external_lex_state = 308},
  [16499] = {.lex_state = 0, .external_lex_state = 386},
  [16500] = {.lex_state = 0, .external_lex_state = 308},
  [16501] = {.lex_state = 0, .external_lex_state = 308},
  [16502] = {.lex_state = 0, .external_lex_state = 308},
  [16503] = {.lex_state = 0, .external_lex_state = 308},
  [16504] = {.lex_state = 0, .external_lex_state = 308},
  [16505] = {.lex_state = 0, .external_lex_state = 308},
  [16506] = {.lex_state = 0, .external_lex_state = 386},
  [16507] = {.lex_state = 0, .external_lex_state = 308},
  [16508] = {.lex_state = 0, .external_lex_state = 308},
  [16509] = {.lex_state = 0, .external_lex_state = 308},
  [16510] = {.lex_state = 0, .external_lex_state = 308},
  [16511] = {.lex_state = 0, .external_lex_state = 308},
  [16512] = {.lex_state = 55, .external_lex_state = 397},
  [16513] = {.lex_state = 0, .external_lex_state = 308},
  [16514] = {.lex_state = 0, .external_lex_state = 386},
  [16515] = {.lex_state = 55, .external_lex_state = 397},
  [16516] = {.lex_state = 57, .external_lex_state = 336},
  [16517] = {.lex_state = 0, .external_lex_state = 386},
  [16518] = {.lex_state = 0, .external_lex_state = 386},
  [16519] = {.lex_state = 0, .external_lex_state = 308},
  [16520] = {.lex_state = 0, .external_lex_state = 308},
  [16521] = {.lex_state = 0, .external_lex_state = 308},
  [16522] = {.lex_state = 0, .external_lex_state = 386},
  [16523] = {.lex_state = 0, .external_lex_state = 308},
  [16524] = {.lex_state = 0, .external_lex_state = 308},
  [16525] = {.lex_state = 0, .external_lex_state = 308},
  [16526] = {.lex_state = 0, .external_lex_state = 308},
  [16527] = {.lex_state = 58, .external_lex_state = 399},
  [16528] = {.lex_state = 0, .external_lex_state = 308},
  [16529] = {.lex_state = 58, .external_lex_state = 399},
  [16530] = {.lex_state = 0, .external_lex_state = 386},
  [16531] = {.lex_state = 0, .external_lex_state = 308},
  [16532] = {.lex_state = 0, .external_lex_state = 386},
  [16533] = {.lex_state = 0, .external_lex_state = 308},
  [16534] = {.lex_state = 0, .external_lex_state = 308},
  [16535] = {.lex_state = 0, .external_lex_state = 308},
  [16536] = {.lex_state = 58, .external_lex_state = 399},
  [16537] = {.lex_state = 0, .external_lex_state = 386},
  [16538] = {.lex_state = 0, .external_lex_state = 308},
  [16539] = {.lex_state = 0, .external_lex_state = 308},
  [16540] = {.lex_state = 55, .external_lex_state = 405},
  [16541] = {.lex_state = 0, .external_lex_state = 308},
  [16542] = {.lex_state = 0, .external_lex_state = 336},
  [16543] = {.lex_state = 0, .external_lex_state = 308},
  [16544] = {.lex_state = 58, .external_lex_state = 399},
  [16545] = {.lex_state = 0, .external_lex_state = 308},
  [16546] = {.lex_state = 0, .external_lex_state = 308},
  [16547] = {.lex_state = 55, .external_lex_state = 397},
  [16548] = {.lex_state = 55, .external_lex_state = 397},
  [16549] = {.lex_state = 0, .external_lex_state = 308},
  [16550] = {.lex_state = 0, .external_lex_state = 308},
  [16551] = {.lex_state = 0, .external_lex_state = 308},
  [16552] = {.lex_state = 55, .external_lex_state = 405},
  [16553] = {.lex_state = 0, .external_lex_state = 308},
  [16554] = {.lex_state = 0, .external_lex_state = 386},
  [16555] = {.lex_state = 0, .external_lex_state = 386},
  [16556] = {.lex_state = 0, .external_lex_state = 308},
  [16557] = {.lex_state = 0, .external_lex_state = 308},
  [16558] = {.lex_state = 55, .external_lex_state = 405},
  [16559] = {.lex_state = 0, .external_lex_state = 386},
  [16560] = {.lex_state = 0, .external_lex_state = 386},
  [16561] = {.lex_state = 0, .external_lex_state = 308},
  [16562] = {.lex_state = 0, .external_lex_state = 308},
  [16563] = {.lex_state = 0, .external_lex_state = 308},
  [16564] = {.lex_state = 0, .external_lex_state = 308},
  [16565] = {.lex_state = 0, .external_lex_state = 308},
  [16566] = {.lex_state = 58, .external_lex_state = 399},
  [16567] = {.lex_state = 0, .external_lex_state = 308},
  [16568] = {.lex_state = 0, .external_lex_state = 308},
  [16569] = {.lex_state = 0, .external_lex_state = 386},
  [16570] = {.lex_state = 0, .external_lex_state = 308},
  [16571] = {.lex_state = 0, .external_lex_state = 308},
  [16572] = {.lex_state = 0, .external_lex_state = 386},
  [16573] = {.lex_state = 0, .external_lex_state = 386},
  [16574] = {.lex_state = 0, .external_lex_state = 308},
  [16575] = {.lex_state = 0, .external_lex_state = 308},
  [16576] = {.lex_state = 0, .external_lex_state = 339},
  [16577] = {.lex_state = 0, .external_lex_state = 386},
  [16578] = {.lex_state = 55, .external_lex_state = 397},
  [16579] = {.lex_state = 0, .external_lex_state = 308},
  [16580] = {.lex_state = 0, .external_lex_state = 308},
  [16581] = {.lex_state = 0, .external_lex_state = 308},
  [16582] = {.lex_state = 0, .external_lex_state = 386},
  [16583] = {.lex_state = 0, .external_lex_state = 308},
  [16584] = {.lex_state = 0, .external_lex_state = 308},
  [16585] = {.lex_state = 0, .external_lex_state = 386},
  [16586] = {.lex_state = 0, .external_lex_state = 308},
  [16587] = {.lex_state = 0, .external_lex_state = 308},
  [16588] = {.lex_state = 0, .external_lex_state = 308},
  [16589] = {.lex_state = 0, .external_lex_state = 386},
  [16590] = {.lex_state = 0, .external_lex_state = 308},
  [16591] = {.lex_state = 0, .external_lex_state = 308},
  [16592] = {.lex_state = 0, .external_lex_state = 308},
  [16593] = {.lex_state = 0, .external_lex_state = 308},
  [16594] = {.lex_state = 0, .external_lex_state = 386},
  [16595] = {.lex_state = 0, .external_lex_state = 386},
  [16596] = {.lex_state = 0, .external_lex_state = 386},
  [16597] = {.lex_state = 0, .external_lex_state = 308},
  [16598] = {.lex_state = 0, .external_lex_state = 308},
  [16599] = {.lex_state = 0, .external_lex_state = 308},
  [16600] = {.lex_state = 0, .external_lex_state = 308},
  [16601] = {.lex_state = 0, .external_lex_state = 308},
  [16602] = {.lex_state = 0, .external_lex_state = 308},
  [16603] = {.lex_state = 58, .external_lex_state = 399},
  [16604] = {.lex_state = 0, .external_lex_state = 308},
  [16605] = {.lex_state = 0, .external_lex_state = 386},
  [16606] = {.lex_state = 0, .external_lex_state = 308},
  [16607] = {.lex_state = 0, .external_lex_state = 308},
  [16608] = {.lex_state = 0, .external_lex_state = 350},
  [16609] = {.lex_state = 0, .external_lex_state = 308},
  [16610] = {.lex_state = 0, .external_lex_state = 308},
  [16611] = {.lex_state = 0, .external_lex_state = 386},
  [16612] = {.lex_state = 0, .external_lex_state = 308},
  [16613] = {.lex_state = 0, .external_lex_state = 308},
  [16614] = {.lex_state = 0, .external_lex_state = 308},
  [16615] = {.lex_state = 0, .external_lex_state = 308},
  [16616] = {.lex_state = 0, .external_lex_state = 386},
  [16617] = {.lex_state = 58, .external_lex_state = 399},
  [16618] = {.lex_state = 0, .external_lex_state = 386},
  [16619] = {.lex_state = 0, .external_lex_state = 308},
  [16620] = {.lex_state = 0, .external_lex_state = 404},
  [16621] = {.lex_state = 0, .external_lex_state = 308},
  [16622] = {.lex_state = 0, .external_lex_state = 308},
  [16623] = {.lex_state = 55, .external_lex_state = 406},
  [16624] = {.lex_state = 0, .external_lex_state = 386},
  [16625] = {.lex_state = 0, .external_lex_state = 439},
  [16626] = {.lex_state = 0, .external_lex_state = 308},
  [16627] = {.lex_state = 0, .external_lex_state = 404},
  [16628] = {.lex_state = 58, .external_lex_state = 397},
  [16629] = {.lex_state = 0, .external_lex_state = 308},
  [16630] = {.lex_state = 0, .external_lex_state = 308},
  [16631] = {.lex_state = 0, .external_lex_state = 308},
  [16632] = {.lex_state = 0, .external_lex_state = 386},
  [16633] = {.lex_state = 0, .external_lex_state = 308},
  [16634] = {.lex_state = 0, .external_lex_state = 308},
  [16635] = {.lex_state = 0, .external_lex_state = 308},
  [16636] = {.lex_state = 0, .external_lex_state = 308},
  [16637] = {.lex_state = 0, .external_lex_state = 308},
  [16638] = {.lex_state = 0, .external_lex_state = 308},
  [16639] = {.lex_state = 0, .external_lex_state = 386},
  [16640] = {.lex_state = 58, .external_lex_state = 399},
  [16641] = {.lex_state = 0, .external_lex_state = 308},
  [16642] = {.lex_state = 0, .external_lex_state = 386},
  [16643] = {.lex_state = 0, .external_lex_state = 308},
  [16644] = {.lex_state = 0, .external_lex_state = 386},
  [16645] = {.lex_state = 0, .external_lex_state = 308},
  [16646] = {.lex_state = 0, .external_lex_state = 308},
  [16647] = {.lex_state = 0, .external_lex_state = 308},
  [16648] = {.lex_state = 0, .external_lex_state = 308},
  [16649] = {.lex_state = 0, .external_lex_state = 308},
  [16650] = {.lex_state = 0, .external_lex_state = 308},
  [16651] = {.lex_state = 0, .external_lex_state = 308},
  [16652] = {.lex_state = 0, .external_lex_state = 386},
  [16653] = {.lex_state = 0, .external_lex_state = 339},
  [16654] = {.lex_state = 0, .external_lex_state = 308},
  [16655] = {.lex_state = 55, .external_lex_state = 397},
  [16656] = {.lex_state = 0, .external_lex_state = 386},
  [16657] = {.lex_state = 0, .external_lex_state = 386},
  [16658] = {.lex_state = 58, .external_lex_state = 399},
  [16659] = {.lex_state = 0, .external_lex_state = 386},
  [16660] = {.lex_state = 0, .external_lex_state = 386},
  [16661] = {.lex_state = 0, .external_lex_state = 308},
  [16662] = {.lex_state = 0, .external_lex_state = 308},
  [16663] = {.lex_state = 55, .external_lex_state = 413},
  [16664] = {.lex_state = 0, .external_lex_state = 386},
  [16665] = {.lex_state = 0, .external_lex_state = 308},
  [16666] = {.lex_state = 0, .external_lex_state = 386},
  [16667] = {.lex_state = 0, .external_lex_state = 308},
  [16668] = {.lex_state = 0, .external_lex_state = 308},
  [16669] = {.lex_state = 0, .external_lex_state = 386},
  [16670] = {.lex_state = 0, .external_lex_state = 386},
  [16671] = {.lex_state = 0, .external_lex_state = 308},
  [16672] = {.lex_state = 0, .external_lex_state = 308},
  [16673] = {.lex_state = 58, .external_lex_state = 401},
  [16674] = {.lex_state = 0, .external_lex_state = 308},
  [16675] = {.lex_state = 0, .external_lex_state = 386},
  [16676] = {.lex_state = 0, .external_lex_state = 308},
  [16677] = {.lex_state = 0, .external_lex_state = 308},
  [16678] = {.lex_state = 0, .external_lex_state = 308},
  [16679] = {.lex_state = 0, .external_lex_state = 308},
  [16680] = {.lex_state = 0, .external_lex_state = 308},
  [16681] = {.lex_state = 0, .external_lex_state = 308},
  [16682] = {.lex_state = 0, .external_lex_state = 308},
  [16683] = {.lex_state = 0, .external_lex_state = 308},
  [16684] = {.lex_state = 0, .external_lex_state = 386},
  [16685] = {.lex_state = 0, .external_lex_state = 386},
  [16686] = {.lex_state = 0, .external_lex_state = 308},
  [16687] = {.lex_state = 55, .external_lex_state = 308},
  [16688] = {.lex_state = 0, .external_lex_state = 308},
  [16689] = {.lex_state = 0, .external_lex_state = 308},
  [16690] = {.lex_state = 0, .external_lex_state = 308},
  [16691] = {.lex_state = 0, .external_lex_state = 386},
  [16692] = {.lex_state = 0, .external_lex_state = 308},
  [16693] = {.lex_state = 0, .external_lex_state = 308},
  [16694] = {.lex_state = 55, .external_lex_state = 405},
  [16695] = {.lex_state = 0, .external_lex_state = 386},
  [16696] = {.lex_state = 0, .external_lex_state = 308},
  [16697] = {.lex_state = 0, .external_lex_state = 308},
  [16698] = {.lex_state = 0, .external_lex_state = 386},
  [16699] = {.lex_state = 0, .external_lex_state = 404},
  [16700] = {.lex_state = 0, .external_lex_state = 386},
  [16701] = {.lex_state = 0, .external_lex_state = 336},
  [16702] = {.lex_state = 0, .external_lex_state = 308},
  [16703] = {.lex_state = 0, .external_lex_state = 308},
  [16704] = {.lex_state = 0, .external_lex_state = 308},
  [16705] = {.lex_state = 0, .external_lex_state = 308},
  [16706] = {.lex_state = 0, .external_lex_state = 308},
  [16707] = {.lex_state = 0, .external_lex_state = 336},
  [16708] = {.lex_state = 55, .external_lex_state = 308},
  [16709] = {.lex_state = 55, .external_lex_state = 405},
  [16710] = {.lex_state = 0, .external_lex_state = 336},
  [16711] = {.lex_state = 0, .external_lex_state = 308},
  [16712] = {.lex_state = 55, .external_lex_state = 405},
  [16713] = {.lex_state = 0, .external_lex_state = 308},
  [16714] = {.lex_state = 0, .external_lex_state = 308},
  [16715] = {.lex_state = 0, .external_lex_state = 386},
  [16716] = {.lex_state = 0, .external_lex_state = 386},
  [16717] = {.lex_state = 0, .external_lex_state = 308},
  [16718] = {.lex_state = 0, .external_lex_state = 386},
  [16719] = {.lex_state = 0, .external_lex_state = 367},
  [16720] = {.lex_state = 0, .external_lex_state = 308},
  [16721] = {.lex_state = 0, .external_lex_state = 439},
  [16722] = {.lex_state = 0, .external_lex_state = 386},
  [16723] = {.lex_state = 0, .external_lex_state = 308},
  [16724] = {.lex_state = 0, .external_lex_state = 308},
  [16725] = {.lex_state = 0, .external_lex_state = 404},
  [16726] = {.lex_state = 0, .external_lex_state = 308},
  [16727] = {.lex_state = 0, .external_lex_state = 308},
  [16728] = {.lex_state = 58, .external_lex_state = 399},
  [16729] = {.lex_state = 0, .external_lex_state = 308},
  [16730] = {.lex_state = 0, .external_lex_state = 308},
  [16731] = {.lex_state = 55, .external_lex_state = 406},
  [16732] = {.lex_state = 0, .external_lex_state = 386},
  [16733] = {.lex_state = 0, .external_lex_state = 308},
  [16734] = {.lex_state = 0, .external_lex_state = 386},
  [16735] = {.lex_state = 0, .external_lex_state = 308},
  [16736] = {.lex_state = 0, .external_lex_state = 308},
  [16737] = {.lex_state = 55, .external_lex_state = 308},
  [16738] = {.lex_state = 0, .external_lex_state = 308},
  [16739] = {.lex_state = 0, .external_lex_state = 308},
  [16740] = {.lex_state = 0, .external_lex_state = 386},
  [16741] = {.lex_state = 0, .external_lex_state = 308},
  [16742] = {.lex_state = 0, .external_lex_state = 308},
  [16743] = {.lex_state = 0, .external_lex_state = 308},
  [16744] = {.lex_state = 0, .external_lex_state = 308},
  [16745] = {.lex_state = 55, .external_lex_state = 405},
  [16746] = {.lex_state = 58, .external_lex_state = 399},
  [16747] = {.lex_state = 0, .external_lex_state = 308},
  [16748] = {.lex_state = 0, .external_lex_state = 386},
  [16749] = {.lex_state = 0, .external_lex_state = 308},
  [16750] = {.lex_state = 0, .external_lex_state = 308},
  [16751] = {.lex_state = 0, .external_lex_state = 308},
  [16752] = {.lex_state = 0, .external_lex_state = 308},
  [16753] = {.lex_state = 0, .external_lex_state = 386},
  [16754] = {.lex_state = 0, .external_lex_state = 308},
  [16755] = {.lex_state = 0, .external_lex_state = 308},
  [16756] = {.lex_state = 0, .external_lex_state = 386},
  [16757] = {.lex_state = 0, .external_lex_state = 308},
  [16758] = {.lex_state = 0, .external_lex_state = 404},
  [16759] = {.lex_state = 0, .external_lex_state = 308},
  [16760] = {.lex_state = 58, .external_lex_state = 399},
  [16761] = {.lex_state = 0, .external_lex_state = 308},
  [16762] = {.lex_state = 55, .external_lex_state = 386},
  [16763] = {.lex_state = 0, .external_lex_state = 308},
  [16764] = {.lex_state = 0, .external_lex_state = 386},
  [16765] = {.lex_state = 0, .external_lex_state = 308},
  [16766] = {.lex_state = 0, .external_lex_state = 386},
  [16767] = {.lex_state = 0, .external_lex_state = 308},
  [16768] = {.lex_state = 0, .external_lex_state = 308},
  [16769] = {.lex_state = 0, .external_lex_state = 439},
  [16770] = {.lex_state = 0, .external_lex_state = 308},
  [16771] = {.lex_state = 0, .external_lex_state = 308},
  [16772] = {.lex_state = 0, .external_lex_state = 308},
  [16773] = {.lex_state = 0, .external_lex_state = 308},
  [16774] = {.lex_state = 0, .external_lex_state = 386},
  [16775] = {.lex_state = 0, .external_lex_state = 308},
  [16776] = {.lex_state = 0, .external_lex_state = 308},
  [16777] = {.lex_state = 0, .external_lex_state = 386},
  [16778] = {.lex_state = 0, .external_lex_state = 308},
  [16779] = {.lex_state = 0, .external_lex_state = 308},
  [16780] = {.lex_state = 0, .external_lex_state = 308},
  [16781] = {.lex_state = 0, .external_lex_state = 386},
  [16782] = {.lex_state = 0, .external_lex_state = 308},
  [16783] = {.lex_state = 0, .external_lex_state = 386},
  [16784] = {.lex_state = 0, .external_lex_state = 308},
  [16785] = {.lex_state = 0, .external_lex_state = 308},
  [16786] = {.lex_state = 0, .external_lex_state = 308},
  [16787] = {.lex_state = 0, .external_lex_state = 386},
  [16788] = {.lex_state = 0, .external_lex_state = 386},
  [16789] = {.lex_state = 0, .external_lex_state = 308},
  [16790] = {.lex_state = 0, .external_lex_state = 339},
  [16791] = {.lex_state = 0, .external_lex_state = 308},
  [16792] = {.lex_state = 0, .external_lex_state = 308},
  [16793] = {.lex_state = 0, .external_lex_state = 386},
  [16794] = {.lex_state = 0, .external_lex_state = 386},
  [16795] = {.lex_state = 0, .external_lex_state = 308},
  [16796] = {.lex_state = 0, .external_lex_state = 308},
  [16797] = {.lex_state = 0, .external_lex_state = 308},
  [16798] = {.lex_state = 0, .external_lex_state = 386},
  [16799] = {.lex_state = 0, .external_lex_state = 308},
  [16800] = {.lex_state = 0, .external_lex_state = 386},
  [16801] = {.lex_state = 0, .external_lex_state = 308},
  [16802] = {.lex_state = 0, .external_lex_state = 386},
  [16803] = {.lex_state = 58, .external_lex_state = 399},
  [16804] = {.lex_state = 0, .external_lex_state = 336},
  [16805] = {.lex_state = 0, .external_lex_state = 308},
  [16806] = {.lex_state = 0, .external_lex_state = 308},
  [16807] = {.lex_state = 0, .external_lex_state = 308},
  [16808] = {.lex_state = 0, .external_lex_state = 308},
  [16809] = {.lex_state = 55, .external_lex_state = 405},
  [16810] = {.lex_state = 0, .external_lex_state = 308},
  [16811] = {.lex_state = 55, .external_lex_state = 405},
  [16812] = {.lex_state = 0, .external_lex_state = 386},
  [16813] = {.lex_state = 0, .external_lex_state = 308},
  [16814] = {.lex_state = 0, .external_lex_state = 308},
  [16815] = {.lex_state = 0, .external_lex_state = 308},
  [16816] = {.lex_state = 0, .external_lex_state = 386},
  [16817] = {.lex_state = 0, .external_lex_state = 308},
  [16818] = {.lex_state = 57, .external_lex_state = 308},
  [16819] = {.lex_state = 57, .external_lex_state = 308},
  [16820] = {.lex_state = 0, .external_lex_state = 308},
  [16821] = {.lex_state = 0, .external_lex_state = 308},
  [16822] = {.lex_state = 0, .external_lex_state = 308},
  [16823] = {.lex_state = 58, .external_lex_state = 399},
  [16824] = {.lex_state = 55, .external_lex_state = 405},
  [16825] = {.lex_state = 58, .external_lex_state = 336},
  [16826] = {.lex_state = 0, .external_lex_state = 308},
  [16827] = {.lex_state = 0, .external_lex_state = 308},
  [16828] = {.lex_state = 0, .external_lex_state = 308},
  [16829] = {.lex_state = 0, .external_lex_state = 308},
  [16830] = {.lex_state = 0, .external_lex_state = 308},
  [16831] = {.lex_state = 0, .external_lex_state = 386},
  [16832] = {.lex_state = 58, .external_lex_state = 399},
  [16833] = {.lex_state = 0, .external_lex_state = 386},
  [16834] = {.lex_state = 0, .external_lex_state = 308},
  [16835] = {.lex_state = 0, .external_lex_state = 308},
  [16836] = {.lex_state = 0, .external_lex_state = 339},
  [16837] = {.lex_state = 0, .external_lex_state = 308},
  [16838] = {.lex_state = 0, .external_lex_state = 386},
  [16839] = {.lex_state = 0, .external_lex_state = 308},
  [16840] = {.lex_state = 0, .external_lex_state = 308},
  [16841] = {.lex_state = 0, .external_lex_state = 386},
  [16842] = {.lex_state = 55, .external_lex_state = 405},
  [16843] = {.lex_state = 0, .external_lex_state = 308},
  [16844] = {.lex_state = 0, .external_lex_state = 308},
  [16845] = {.lex_state = 0, .external_lex_state = 308},
  [16846] = {.lex_state = 0, .external_lex_state = 308},
  [16847] = {.lex_state = 0, .external_lex_state = 386},
  [16848] = {.lex_state = 0, .external_lex_state = 308},
  [16849] = {.lex_state = 0, .external_lex_state = 386},
  [16850] = {.lex_state = 0, .external_lex_state = 308},
  [16851] = {.lex_state = 0, .external_lex_state = 308},
  [16852] = {.lex_state = 0, .external_lex_state = 367},
  [16853] = {.lex_state = 0, .external_lex_state = 386},
  [16854] = {.lex_state = 0, .external_lex_state = 308},
  [16855] = {.lex_state = 0, .external_lex_state = 386},
  [16856] = {.lex_state = 0, .external_lex_state = 386},
  [16857] = {.lex_state = 0, .external_lex_state = 339},
  [16858] = {.lex_state = 0, .external_lex_state = 308},
  [16859] = {.lex_state = 0, .external_lex_state = 386},
  [16860] = {.lex_state = 0, .external_lex_state = 308},
  [16861] = {.lex_state = 0, .external_lex_state = 308},
  [16862] = {.lex_state = 58, .external_lex_state = 399},
  [16863] = {.lex_state = 0, .external_lex_state = 386},
  [16864] = {.lex_state = 55, .external_lex_state = 308},
  [16865] = {.lex_state = 0, .external_lex_state = 308},
  [16866] = {.lex_state = 0, .external_lex_state = 339},
  [16867] = {.lex_state = 0, .external_lex_state = 308},
  [16868] = {.lex_state = 0, .external_lex_state = 339},
  [16869] = {.lex_state = 0, .external_lex_state = 308},
  [16870] = {.lex_state = 0, .external_lex_state = 386},
  [16871] = {.lex_state = 0, .external_lex_state = 308},
  [16872] = {.lex_state = 0, .external_lex_state = 386},
  [16873] = {.lex_state = 58, .external_lex_state = 399},
  [16874] = {.lex_state = 0, .external_lex_state = 308},
  [16875] = {.lex_state = 0, .external_lex_state = 386},
  [16876] = {.lex_state = 0, .external_lex_state = 308},
  [16877] = {.lex_state = 0, .external_lex_state = 308},
  [16878] = {.lex_state = 0, .external_lex_state = 367},
  [16879] = {.lex_state = 0, .external_lex_state = 308},
  [16880] = {.lex_state = 0, .external_lex_state = 386},
  [16881] = {.lex_state = 0, .external_lex_state = 386},
  [16882] = {.lex_state = 0, .external_lex_state = 308},
  [16883] = {.lex_state = 0, .external_lex_state = 308},
  [16884] = {.lex_state = 0, .external_lex_state = 308},
  [16885] = {.lex_state = 0, .external_lex_state = 308},
  [16886] = {.lex_state = 0, .external_lex_state = 439},
  [16887] = {.lex_state = 55, .external_lex_state = 308},
  [16888] = {.lex_state = 0, .external_lex_state = 308},
  [16889] = {.lex_state = 0, .external_lex_state = 386},
  [16890] = {.lex_state = 0, .external_lex_state = 308},
  [16891] = {.lex_state = 0, .external_lex_state = 386},
  [16892] = {.lex_state = 0, .external_lex_state = 308},
  [16893] = {.lex_state = 0, .external_lex_state = 308},
  [16894] = {.lex_state = 0, .external_lex_state = 308},
  [16895] = {.lex_state = 0, .external_lex_state = 308},
  [16896] = {.lex_state = 0, .external_lex_state = 308},
  [16897] = {.lex_state = 0, .external_lex_state = 308},
  [16898] = {.lex_state = 0, .external_lex_state = 386},
  [16899] = {.lex_state = 0, .external_lex_state = 405},
  [16900] = {.lex_state = 0, .external_lex_state = 308},
  [16901] = {.lex_state = 0, .external_lex_state = 308},
  [16902] = {.lex_state = 0, .external_lex_state = 386},
  [16903] = {.lex_state = 0, .external_lex_state = 386},
  [16904] = {.lex_state = 0, .external_lex_state = 308},
  [16905] = {.lex_state = 58, .external_lex_state = 399},
  [16906] = {.lex_state = 0, .external_lex_state = 308},
  [16907] = {.lex_state = 0, .external_lex_state = 308},
  [16908] = {.lex_state = 0, .external_lex_state = 386},
  [16909] = {.lex_state = 0, .external_lex_state = 386},
  [16910] = {.lex_state = 0, .external_lex_state = 308},
  [16911] = {.lex_state = 0, .external_lex_state = 386},
  [16912] = {.lex_state = 0, .external_lex_state = 308},
  [16913] = {.lex_state = 55, .external_lex_state = 308},
  [16914] = {.lex_state = 0, .external_lex_state = 308},
  [16915] = {.lex_state = 0, .external_lex_state = 386},
  [16916] = {.lex_state = 0, .external_lex_state = 308},
  [16917] = {.lex_state = 0, .external_lex_state = 336},
  [16918] = {.lex_state = 55, .external_lex_state = 438},
  [16919] = {.lex_state = 0, .external_lex_state = 308},
  [16920] = {.lex_state = 0, .external_lex_state = 308},
  [16921] = {.lex_state = 55, .external_lex_state = 308},
  [16922] = {.lex_state = 0, .external_lex_state = 386},
  [16923] = {.lex_state = 0, .external_lex_state = 386},
  [16924] = {.lex_state = 0, .external_lex_state = 308},
  [16925] = {.lex_state = 0, .external_lex_state = 386},
  [16926] = {.lex_state = 55, .external_lex_state = 308},
  [16927] = {.lex_state = 0, .external_lex_state = 308},
  [16928] = {.lex_state = 0, .external_lex_state = 308},
  [16929] = {.lex_state = 0, .external_lex_state = 308},
  [16930] = {.lex_state = 0, .external_lex_state = 308},
  [16931] = {.lex_state = 0, .external_lex_state = 308},
  [16932] = {.lex_state = 0, .external_lex_state = 386},
  [16933] = {.lex_state = 0, .external_lex_state = 308},
  [16934] = {.lex_state = 0, .external_lex_state = 308},
  [16935] = {.lex_state = 0, .external_lex_state = 308},
  [16936] = {.lex_state = 55, .external_lex_state = 405},
  [16937] = {.lex_state = 57, .external_lex_state = 308},
  [16938] = {.lex_state = 0, .external_lex_state = 308},
  [16939] = {.lex_state = 55, .external_lex_state = 405},
  [16940] = {.lex_state = 0, .external_lex_state = 434},
  [16941] = {.lex_state = 0, .external_lex_state = 308},
  [16942] = {.lex_state = 0, .external_lex_state = 367},
  [16943] = {.lex_state = 0, .external_lex_state = 308},
  [16944] = {.lex_state = 55, .external_lex_state = 405},
  [16945] = {.lex_state = 0, .external_lex_state = 386},
  [16946] = {.lex_state = 0, .external_lex_state = 434},
  [16947] = {.lex_state = 0, .external_lex_state = 308},
  [16948] = {.lex_state = 0, .external_lex_state = 339},
  [16949] = {.lex_state = 0, .external_lex_state = 308},
  [16950] = {.lex_state = 0, .external_lex_state = 308},
  [16951] = {.lex_state = 0, .external_lex_state = 308},
  [16952] = {.lex_state = 0, .external_lex_state = 308},
  [16953] = {.lex_state = 55, .external_lex_state = 405},
  [16954] = {.lex_state = 0, .external_lex_state = 308},
  [16955] = {.lex_state = 55, .external_lex_state = 405},
  [16956] = {.lex_state = 0, .external_lex_state = 386},
  [16957] = {.lex_state = 0, .external_lex_state = 308},
  [16958] = {.lex_state = 0, .external_lex_state = 308},
  [16959] = {.lex_state = 0, .external_lex_state = 308},
  [16960] = {.lex_state = 0, .external_lex_state = 308},
  [16961] = {.lex_state = 0, .external_lex_state = 339},
  [16962] = {.lex_state = 0, .external_lex_state = 308},
  [16963] = {.lex_state = 57, .external_lex_state = 336},
  [16964] = {.lex_state = 0, .external_lex_state = 308},
  [16965] = {.lex_state = 0, .external_lex_state = 308},
  [16966] = {.lex_state = 0, .external_lex_state = 386},
  [16967] = {.lex_state = 0, .external_lex_state = 308},
  [16968] = {.lex_state = 58, .external_lex_state = 399},
  [16969] = {.lex_state = 0, .external_lex_state = 308},
  [16970] = {.lex_state = 0, .external_lex_state = 308},
  [16971] = {.lex_state = 0, .external_lex_state = 308},
  [16972] = {.lex_state = 0, .external_lex_state = 308},
  [16973] = {.lex_state = 55, .external_lex_state = 308},
  [16974] = {.lex_state = 0, .external_lex_state = 308},
  [16975] = {.lex_state = 55, .external_lex_state = 308},
  [16976] = {.lex_state = 0, .external_lex_state = 308},
  [16977] = {.lex_state = 0, .external_lex_state = 308},
  [16978] = {.lex_state = 0, .external_lex_state = 308},
  [16979] = {.lex_state = 0, .external_lex_state = 386},
  [16980] = {.lex_state = 0, .external_lex_state = 386},
  [16981] = {.lex_state = 0, .external_lex_state = 367},
  [16982] = {.lex_state = 0, .external_lex_state = 308},
  [16983] = {.lex_state = 0, .external_lex_state = 308},
  [16984] = {.lex_state = 0, .external_lex_state = 308},
  [16985] = {.lex_state = 0, .external_lex_state = 367},
  [16986] = {.lex_state = 0, .external_lex_state = 308},
  [16987] = {.lex_state = 0, .external_lex_state = 386},
  [16988] = {.lex_state = 0, .external_lex_state = 308},
  [16989] = {.lex_state = 0, .external_lex_state = 308},
  [16990] = {.lex_state = 0, .external_lex_state = 386},
  [16991] = {.lex_state = 55, .external_lex_state = 397},
  [16992] = {.lex_state = 0, .external_lex_state = 308},
  [16993] = {.lex_state = 55, .external_lex_state = 405},
  [16994] = {.lex_state = 0, .external_lex_state = 386},
  [16995] = {.lex_state = 0, .external_lex_state = 386},
  [16996] = {.lex_state = 0, .external_lex_state = 308},
  [16997] = {.lex_state = 0, .external_lex_state = 308},
  [16998] = {.lex_state = 0, .external_lex_state = 386},
  [16999] = {.lex_state = 55, .external_lex_state = 397},
  [17000] = {.lex_state = 0, .external_lex_state = 308},
  [17001] = {.lex_state = 0, .external_lex_state = 308},
  [17002] = {.lex_state = 0, .external_lex_state = 386},
  [17003] = {.lex_state = 55, .external_lex_state = 398},
  [17004] = {.lex_state = 0, .external_lex_state = 308},
  [17005] = {.lex_state = 55, .external_lex_state = 397},
  [17006] = {.lex_state = 0, .external_lex_state = 308},
  [17007] = {.lex_state = 0, .external_lex_state = 308},
  [17008] = {.lex_state = 0, .external_lex_state = 404},
  [17009] = {.lex_state = 55, .external_lex_state = 398},
  [17010] = {.lex_state = 0, .external_lex_state = 308},
  [17011] = {.lex_state = 0, .external_lex_state = 308},
  [17012] = {.lex_state = 0, .external_lex_state = 386},
  [17013] = {.lex_state = 0, .external_lex_state = 308},
  [17014] = {.lex_state = 0, .external_lex_state = 386},
  [17015] = {.lex_state = 0, .external_lex_state = 308},
  [17016] = {.lex_state = 0, .external_lex_state = 308},
  [17017] = {.lex_state = 0, .external_lex_state = 308},
  [17018] = {.lex_state = 0, .external_lex_state = 308},
  [17019] = {.lex_state = 0, .external_lex_state = 386},
  [17020] = {.lex_state = 0, .external_lex_state = 386},
  [17021] = {.lex_state = 0, .external_lex_state = 308},
  [17022] = {.lex_state = 0, .external_lex_state = 308},
  [17023] = {.lex_state = 0, .external_lex_state = 308},
  [17024] = {.lex_state = 0, .external_lex_state = 308},
  [17025] = {.lex_state = 0, .external_lex_state = 308},
  [17026] = {.lex_state = 0, .external_lex_state = 308},
  [17027] = {.lex_state = 0, .external_lex_state = 308},
  [17028] = {.lex_state = 0, .external_lex_state = 308},
  [17029] = {.lex_state = 0, .external_lex_state = 386},
  [17030] = {.lex_state = 0, .external_lex_state = 308},
  [17031] = {.lex_state = 0, .external_lex_state = 308},
  [17032] = {.lex_state = 0, .external_lex_state = 308},
  [17033] = {.lex_state = 0, .external_lex_state = 386},
  [17034] = {.lex_state = 0, .external_lex_state = 308},
  [17035] = {.lex_state = 0, .external_lex_state = 308},
  [17036] = {.lex_state = 0, .external_lex_state = 308},
  [17037] = {.lex_state = 0, .external_lex_state = 308},
  [17038] = {.lex_state = 0, .external_lex_state = 308},
  [17039] = {.lex_state = 0, .external_lex_state = 308},
  [17040] = {.lex_state = 0, .external_lex_state = 386},
  [17041] = {.lex_state = 55, .external_lex_state = 438},
  [17042] = {.lex_state = 0, .external_lex_state = 308},
  [17043] = {.lex_state = 0, .external_lex_state = 386},
  [17044] = {.lex_state = 0, .external_lex_state = 308},
  [17045] = {.lex_state = 0, .external_lex_state = 308},
  [17046] = {.lex_state = 55, .external_lex_state = 397},
  [17047] = {.lex_state = 0, .external_lex_state = 386},
  [17048] = {.lex_state = 0, .external_lex_state = 308},
  [17049] = {.lex_state = 58, .external_lex_state = 399},
  [17050] = {.lex_state = 0, .external_lex_state = 405},
  [17051] = {.lex_state = 0, .external_lex_state = 308},
  [17052] = {.lex_state = 0, .external_lex_state = 308},
  [17053] = {.lex_state = 0, .external_lex_state = 339},
  [17054] = {.lex_state = 0, .external_lex_state = 308},
  [17055] = {.lex_state = 0, .external_lex_state = 386},
  [17056] = {.lex_state = 0, .external_lex_state = 308},
  [17057] = {.lex_state = 0, .external_lex_state = 308},
  [17058] = {.lex_state = 0, .external_lex_state = 308},
  [17059] = {.lex_state = 0, .external_lex_state = 308},
  [17060] = {.lex_state = 58, .external_lex_state = 399},
  [17061] = {.lex_state = 58, .external_lex_state = 399},
  [17062] = {.lex_state = 0, .external_lex_state = 386},
  [17063] = {.lex_state = 0, .external_lex_state = 336},
  [17064] = {.lex_state = 0, .external_lex_state = 308},
  [17065] = {.lex_state = 0, .external_lex_state = 411},
  [17066] = {.lex_state = 0, .external_lex_state = 308},
  [17067] = {.lex_state = 0, .external_lex_state = 308},
  [17068] = {.lex_state = 55, .external_lex_state = 398},
  [17069] = {.lex_state = 0, .external_lex_state = 308},
  [17070] = {.lex_state = 0, .external_lex_state = 308},
  [17071] = {.lex_state = 0, .external_lex_state = 308},
  [17072] = {.lex_state = 55, .external_lex_state = 438},
  [17073] = {.lex_state = 0, .external_lex_state = 308},
  [17074] = {.lex_state = 0, .external_lex_state = 434},
  [17075] = {.lex_state = 0, .external_lex_state = 434},
  [17076] = {.lex_state = 0, .external_lex_state = 308},
  [17077] = {.lex_state = 0, .external_lex_state = 336},
  [17078] = {.lex_state = 0, .external_lex_state = 386},
  [17079] = {.lex_state = 0, .external_lex_state = 308},
  [17080] = {.lex_state = 0, .external_lex_state = 308},
  [17081] = {.lex_state = 55, .external_lex_state = 406},
  [17082] = {.lex_state = 0, .external_lex_state = 308},
  [17083] = {.lex_state = 57, .external_lex_state = 336},
  [17084] = {.lex_state = 58, .external_lex_state = 399},
  [17085] = {.lex_state = 0, .external_lex_state = 386},
  [17086] = {.lex_state = 0, .external_lex_state = 308},
  [17087] = {.lex_state = 0, .external_lex_state = 308},
  [17088] = {.lex_state = 0, .external_lex_state = 308},
  [17089] = {.lex_state = 55, .external_lex_state = 398},
  [17090] = {.lex_state = 55, .external_lex_state = 406},
  [17091] = {.lex_state = 0, .external_lex_state = 404},
  [17092] = {.lex_state = 0, .external_lex_state = 308},
  [17093] = {.lex_state = 0, .external_lex_state = 308},
  [17094] = {.lex_state = 0, .external_lex_state = 308},
  [17095] = {.lex_state = 55, .external_lex_state = 386},
  [17096] = {.lex_state = 0, .external_lex_state = 308},
  [17097] = {.lex_state = 0, .external_lex_state = 308},
  [17098] = {.lex_state = 0, .external_lex_state = 308},
  [17099] = {.lex_state = 0, .external_lex_state = 308},
  [17100] = {.lex_state = 0, .external_lex_state = 308},
  [17101] = {.lex_state = 0, .external_lex_state = 308},
  [17102] = {.lex_state = 0, .external_lex_state = 386},
  [17103] = {.lex_state = 0, .external_lex_state = 308},
  [17104] = {.lex_state = 0, .external_lex_state = 308},
  [17105] = {.lex_state = 0, .external_lex_state = 308},
  [17106] = {.lex_state = 0, .external_lex_state = 386},
  [17107] = {.lex_state = 0, .external_lex_state = 386},
  [17108] = {.lex_state = 0, .external_lex_state = 308},
  [17109] = {.lex_state = 0, .external_lex_state = 308},
  [17110] = {.lex_state = 0, .external_lex_state = 308},
  [17111] = {.lex_state = 0, .external_lex_state = 308},
  [17112] = {.lex_state = 0, .external_lex_state = 386},
  [17113] = {.lex_state = 0, .external_lex_state = 308},
  [17114] = {.lex_state = 0, .external_lex_state = 386},
  [17115] = {.lex_state = 0, .external_lex_state = 386},
  [17116] = {.lex_state = 0, .external_lex_state = 308},
  [17117] = {.lex_state = 0, .external_lex_state = 308},
  [17118] = {.lex_state = 0, .external_lex_state = 386},
  [17119] = {.lex_state = 0, .external_lex_state = 386},
  [17120] = {.lex_state = 0, .external_lex_state = 308},
  [17121] = {.lex_state = 0, .external_lex_state = 308},
  [17122] = {.lex_state = 0, .external_lex_state = 308},
  [17123] = {.lex_state = 0, .external_lex_state = 308},
  [17124] = {.lex_state = 0, .external_lex_state = 386},
  [17125] = {.lex_state = 0, .external_lex_state = 308},
  [17126] = {.lex_state = 0, .external_lex_state = 308},
  [17127] = {.lex_state = 58, .external_lex_state = 399},
  [17128] = {.lex_state = 0, .external_lex_state = 386},
  [17129] = {.lex_state = 0, .external_lex_state = 308},
  [17130] = {.lex_state = 0, .external_lex_state = 386},
  [17131] = {.lex_state = 0, .external_lex_state = 308},
  [17132] = {.lex_state = 0, .external_lex_state = 308},
  [17133] = {.lex_state = 0, .external_lex_state = 308},
  [17134] = {.lex_state = 0, .external_lex_state = 386},
  [17135] = {.lex_state = 0, .external_lex_state = 386},
  [17136] = {.lex_state = 0, .external_lex_state = 308},
  [17137] = {.lex_state = 0, .external_lex_state = 386},
  [17138] = {.lex_state = 55, .external_lex_state = 406},
  [17139] = {.lex_state = 0, .external_lex_state = 308},
  [17140] = {.lex_state = 0, .external_lex_state = 386},
  [17141] = {.lex_state = 0, .external_lex_state = 386},
  [17142] = {.lex_state = 0, .external_lex_state = 308},
  [17143] = {.lex_state = 0, .external_lex_state = 308},
  [17144] = {.lex_state = 0, .external_lex_state = 308},
  [17145] = {.lex_state = 0, .external_lex_state = 308},
  [17146] = {.lex_state = 0, .external_lex_state = 308},
  [17147] = {.lex_state = 0, .external_lex_state = 308},
  [17148] = {.lex_state = 0, .external_lex_state = 308},
  [17149] = {.lex_state = 0, .external_lex_state = 308},
  [17150] = {.lex_state = 0, .external_lex_state = 386},
  [17151] = {.lex_state = 0, .external_lex_state = 308},
  [17152] = {.lex_state = 55, .external_lex_state = 386},
  [17153] = {.lex_state = 0, .external_lex_state = 386},
  [17154] = {.lex_state = 0, .external_lex_state = 308},
  [17155] = {.lex_state = 0, .external_lex_state = 308},
  [17156] = {.lex_state = 0, .external_lex_state = 308},
  [17157] = {.lex_state = 0, .external_lex_state = 308},
  [17158] = {.lex_state = 0, .external_lex_state = 308},
  [17159] = {.lex_state = 0, .external_lex_state = 386},
  [17160] = {.lex_state = 0, .external_lex_state = 308},
  [17161] = {.lex_state = 0, .external_lex_state = 308},
  [17162] = {.lex_state = 0, .external_lex_state = 308},
  [17163] = {.lex_state = 0, .external_lex_state = 308},
  [17164] = {.lex_state = 0, .external_lex_state = 386},
  [17165] = {.lex_state = 0, .external_lex_state = 308},
  [17166] = {.lex_state = 0, .external_lex_state = 308},
  [17167] = {.lex_state = 0, .external_lex_state = 308},
  [17168] = {.lex_state = 0, .external_lex_state = 308},
  [17169] = {.lex_state = 55, .external_lex_state = 406},
  [17170] = {.lex_state = 55, .external_lex_state = 406},
  [17171] = {.lex_state = 0, .external_lex_state = 308},
  [17172] = {.lex_state = 0, .external_lex_state = 386},
  [17173] = {.lex_state = 55, .external_lex_state = 398},
  [17174] = {.lex_state = 0, .external_lex_state = 308},
  [17175] = {.lex_state = 0, .external_lex_state = 308},
  [17176] = {.lex_state = 55, .external_lex_state = 398},
  [17177] = {.lex_state = 0, .external_lex_state = 308},
  [17178] = {.lex_state = 0, .external_lex_state = 308},
  [17179] = {.lex_state = 0, .external_lex_state = 308},
  [17180] = {.lex_state = 55, .external_lex_state = 386},
  [17181] = {.lex_state = 0, .external_lex_state = 386},
  [17182] = {.lex_state = 55, .external_lex_state = 386},
  [17183] = {.lex_state = 58, .external_lex_state = 401},
  [17184] = {.lex_state = 0, .external_lex_state = 308},
  [17185] = {.lex_state = 0, .external_lex_state = 386},
  [17186] = {.lex_state = 0, .external_lex_state = 308},
  [17187] = {.lex_state = 0, .external_lex_state = 308},
  [17188] = {.lex_state = 0, .external_lex_state = 308},
  [17189] = {.lex_state = 0, .external_lex_state = 308},
  [17190] = {.lex_state = 0, .external_lex_state = 308},
  [17191] = {.lex_state = 0, .external_lex_state = 386},
  [17192] = {.lex_state = 0, .external_lex_state = 336},
  [17193] = {.lex_state = 0, .external_lex_state = 308},
  [17194] = {.lex_state = 0, .external_lex_state = 386},
  [17195] = {.lex_state = 0, .external_lex_state = 308},
  [17196] = {.lex_state = 0, .external_lex_state = 308},
  [17197] = {.lex_state = 55, .external_lex_state = 406},
  [17198] = {.lex_state = 55, .external_lex_state = 406},
  [17199] = {.lex_state = 0, .external_lex_state = 308},
  [17200] = {.lex_state = 0, .external_lex_state = 308},
  [17201] = {.lex_state = 0, .external_lex_state = 386},
  [17202] = {.lex_state = 0, .external_lex_state = 308},
  [17203] = {.lex_state = 0, .external_lex_state = 308},
  [17204] = {.lex_state = 0, .external_lex_state = 308},
  [17205] = {.lex_state = 0, .external_lex_state = 308},
  [17206] = {.lex_state = 0, .external_lex_state = 308},
  [17207] = {.lex_state = 0, .external_lex_state = 350},
  [17208] = {.lex_state = 0, .external_lex_state = 386},
  [17209] = {.lex_state = 55, .external_lex_state = 406},
  [17210] = {.lex_state = 0, .external_lex_state = 308},
  [17211] = {.lex_state = 0, .external_lex_state = 308},
  [17212] = {.lex_state = 0, .external_lex_state = 308},
  [17213] = {.lex_state = 55, .external_lex_state = 386},
  [17214] = {.lex_state = 0, .external_lex_state = 386},
  [17215] = {.lex_state = 0, .external_lex_state = 308},
  [17216] = {.lex_state = 0, .external_lex_state = 308},
  [17217] = {.lex_state = 55, .external_lex_state = 386},
  [17218] = {.lex_state = 58, .external_lex_state = 401},
  [17219] = {.lex_state = 0, .external_lex_state = 308},
  [17220] = {.lex_state = 58, .external_lex_state = 400},
  [17221] = {.lex_state = 0, .external_lex_state = 308},
  [17222] = {.lex_state = 0, .external_lex_state = 386},
  [17223] = {.lex_state = 0, .external_lex_state = 308},
  [17224] = {.lex_state = 0, .external_lex_state = 308},
  [17225] = {.lex_state = 0, .external_lex_state = 308},
  [17226] = {.lex_state = 0, .external_lex_state = 308},
  [17227] = {.lex_state = 0, .external_lex_state = 386},
  [17228] = {.lex_state = 0, .external_lex_state = 308},
  [17229] = {.lex_state = 0, .external_lex_state = 386},
  [17230] = {.lex_state = 0, .external_lex_state = 308},
  [17231] = {.lex_state = 0, .external_lex_state = 386},
  [17232] = {.lex_state = 0, .external_lex_state = 308},
  [17233] = {.lex_state = 0, .external_lex_state = 386},
  [17234] = {.lex_state = 0, .external_lex_state = 308},
  [17235] = {.lex_state = 0, .external_lex_state = 386},
  [17236] = {.lex_state = 0, .external_lex_state = 308},
  [17237] = {.lex_state = 0, .external_lex_state = 308},
  [17238] = {.lex_state = 0, .external_lex_state = 386},
  [17239] = {.lex_state = 0, .external_lex_state = 308},
  [17240] = {.lex_state = 0, .external_lex_state = 308},
  [17241] = {.lex_state = 0, .external_lex_state = 308},
  [17242] = {.lex_state = 0, .external_lex_state = 386},
  [17243] = {.lex_state = 0, .external_lex_state = 308},
  [17244] = {.lex_state = 0, .external_lex_state = 308},
  [17245] = {.lex_state = 0, .external_lex_state = 336},
  [17246] = {.lex_state = 0, .external_lex_state = 386},
  [17247] = {.lex_state = 0, .external_lex_state = 308},
  [17248] = {.lex_state = 0, .external_lex_state = 386},
  [17249] = {.lex_state = 58, .external_lex_state = 399},
  [17250] = {.lex_state = 55, .external_lex_state = 406},
  [17251] = {.lex_state = 0, .external_lex_state = 386},
  [17252] = {.lex_state = 0, .external_lex_state = 308},
  [17253] = {.lex_state = 0, .external_lex_state = 308},
  [17254] = {.lex_state = 0, .external_lex_state = 308},
  [17255] = {.lex_state = 0, .external_lex_state = 308},
  [17256] = {.lex_state = 55, .external_lex_state = 308},
  [17257] = {.lex_state = 0, .external_lex_state = 386},
  [17258] = {.lex_state = 0, .external_lex_state = 386},
  [17259] = {.lex_state = 0, .external_lex_state = 308},
  [17260] = {.lex_state = 0, .external_lex_state = 350},
  [17261] = {.lex_state = 0, .external_lex_state = 308},
  [17262] = {.lex_state = 0, .external_lex_state = 308},
  [17263] = {.lex_state = 0, .external_lex_state = 386},
  [17264] = {.lex_state = 57, .external_lex_state = 308},
  [17265] = {.lex_state = 0, .external_lex_state = 308},
  [17266] = {.lex_state = 0, .external_lex_state = 308},
  [17267] = {.lex_state = 55, .external_lex_state = 308},
  [17268] = {.lex_state = 0, .external_lex_state = 308},
  [17269] = {.lex_state = 0, .external_lex_state = 308},
  [17270] = {.lex_state = 0, .external_lex_state = 339},
  [17271] = {.lex_state = 0, .external_lex_state = 308},
  [17272] = {.lex_state = 0, .external_lex_state = 386},
  [17273] = {.lex_state = 0, .external_lex_state = 386},
  [17274] = {.lex_state = 0, .external_lex_state = 308},
  [17275] = {.lex_state = 0, .external_lex_state = 386},
  [17276] = {.lex_state = 0, .external_lex_state = 308},
  [17277] = {.lex_state = 0, .external_lex_state = 308},
  [17278] = {.lex_state = 0, .external_lex_state = 308},
  [17279] = {.lex_state = 0, .external_lex_state = 386},
  [17280] = {.lex_state = 0, .external_lex_state = 308},
  [17281] = {.lex_state = 0, .external_lex_state = 308},
  [17282] = {.lex_state = 0, .external_lex_state = 437},
  [17283] = {.lex_state = 0, .external_lex_state = 308},
  [17284] = {.lex_state = 0, .external_lex_state = 308},
  [17285] = {.lex_state = 55, .external_lex_state = 413},
  [17286] = {.lex_state = 0, .external_lex_state = 308},
  [17287] = {.lex_state = 0, .external_lex_state = 308},
  [17288] = {.lex_state = 0, .external_lex_state = 308},
  [17289] = {.lex_state = 55, .external_lex_state = 397},
  [17290] = {.lex_state = 55, .external_lex_state = 386},
  [17291] = {.lex_state = 0, .external_lex_state = 386},
  [17292] = {.lex_state = 0, .external_lex_state = 308},
  [17293] = {.lex_state = 0, .external_lex_state = 308},
  [17294] = {.lex_state = 0, .external_lex_state = 336},
  [17295] = {.lex_state = 0, .external_lex_state = 308},
  [17296] = {.lex_state = 0, .external_lex_state = 308},
  [17297] = {.lex_state = 0, .external_lex_state = 386},
  [17298] = {.lex_state = 0, .external_lex_state = 308},
  [17299] = {.lex_state = 0, .external_lex_state = 308},
  [17300] = {.lex_state = 0, .external_lex_state = 308},
  [17301] = {.lex_state = 0, .external_lex_state = 308},
  [17302] = {.lex_state = 55, .external_lex_state = 386},
  [17303] = {.lex_state = 0, .external_lex_state = 336},
  [17304] = {.lex_state = 0, .external_lex_state = 308},
  [17305] = {.lex_state = 0, .external_lex_state = 308},
  [17306] = {.lex_state = 0, .external_lex_state = 386},
  [17307] = {.lex_state = 0, .external_lex_state = 308},
  [17308] = {.lex_state = 0, .external_lex_state = 308},
  [17309] = {.lex_state = 0, .external_lex_state = 308},
  [17310] = {.lex_state = 0, .external_lex_state = 308},
  [17311] = {.lex_state = 58, .external_lex_state = 399},
  [17312] = {.lex_state = 0, .external_lex_state = 308},
  [17313] = {.lex_state = 58, .external_lex_state = 399},
  [17314] = {.lex_state = 0, .external_lex_state = 308},
  [17315] = {.lex_state = 0, .external_lex_state = 308},
  [17316] = {.lex_state = 0, .external_lex_state = 386},
  [17317] = {.lex_state = 0, .external_lex_state = 386},
  [17318] = {.lex_state = 55, .external_lex_state = 386},
  [17319] = {.lex_state = 0, .external_lex_state = 339},
  [17320] = {.lex_state = 0, .external_lex_state = 308},
  [17321] = {.lex_state = 0, .external_lex_state = 437},
  [17322] = {.lex_state = 0, .external_lex_state = 386},
  [17323] = {.lex_state = 0, .external_lex_state = 386},
  [17324] = {.lex_state = 0, .external_lex_state = 308},
  [17325] = {.lex_state = 55, .external_lex_state = 406},
  [17326] = {.lex_state = 0, .external_lex_state = 308},
  [17327] = {.lex_state = 0, .external_lex_state = 308},
  [17328] = {.lex_state = 0, .external_lex_state = 308},
  [17329] = {.lex_state = 58, .external_lex_state = 399},
  [17330] = {.lex_state = 58, .external_lex_state = 401},
  [17331] = {.lex_state = 0, .external_lex_state = 386},
  [17332] = {.lex_state = 0, .external_lex_state = 308},
  [17333] = {.lex_state = 0, .external_lex_state = 386},
  [17334] = {.lex_state = 0, .external_lex_state = 308},
  [17335] = {.lex_state = 0, .external_lex_state = 308},
  [17336] = {.lex_state = 0, .external_lex_state = 386},
  [17337] = {.lex_state = 0, .external_lex_state = 308},
  [17338] = {.lex_state = 0, .external_lex_state = 308},
  [17339] = {.lex_state = 57, .external_lex_state = 308},
  [17340] = {.lex_state = 57, .external_lex_state = 308},
  [17341] = {.lex_state = 0, .external_lex_state = 308},
  [17342] = {.lex_state = 55, .external_lex_state = 308},
  [17343] = {.lex_state = 0, .external_lex_state = 308},
  [17344] = {.lex_state = 55, .external_lex_state = 406},
  [17345] = {.lex_state = 0, .external_lex_state = 308},
  [17346] = {.lex_state = 0, .external_lex_state = 308},
  [17347] = {.lex_state = 0, .external_lex_state = 308},
  [17348] = {.lex_state = 0, .external_lex_state = 308},
  [17349] = {.lex_state = 0, .external_lex_state = 386},
  [17350] = {.lex_state = 0, .external_lex_state = 308},
  [17351] = {.lex_state = 0, .external_lex_state = 308},
  [17352] = {.lex_state = 0, .external_lex_state = 308},
  [17353] = {.lex_state = 0, .external_lex_state = 386},
  [17354] = {.lex_state = 0, .external_lex_state = 308},
  [17355] = {.lex_state = 0, .external_lex_state = 308},
  [17356] = {.lex_state = 0, .external_lex_state = 308},
  [17357] = {.lex_state = 55, .external_lex_state = 405},
  [17358] = {.lex_state = 0, .external_lex_state = 308},
  [17359] = {.lex_state = 0, .external_lex_state = 308},
  [17360] = {.lex_state = 0, .external_lex_state = 386},
  [17361] = {.lex_state = 0, .external_lex_state = 308},
  [17362] = {.lex_state = 0, .external_lex_state = 386},
  [17363] = {.lex_state = 0, .external_lex_state = 308},
  [17364] = {.lex_state = 58, .external_lex_state = 399},
  [17365] = {.lex_state = 0, .external_lex_state = 308},
  [17366] = {.lex_state = 0, .external_lex_state = 308},
  [17367] = {.lex_state = 0, .external_lex_state = 308},
  [17368] = {.lex_state = 0, .external_lex_state = 386},
  [17369] = {.lex_state = 0, .external_lex_state = 386},
  [17370] = {.lex_state = 0, .external_lex_state = 308},
  [17371] = {.lex_state = 0, .external_lex_state = 386},
  [17372] = {.lex_state = 58, .external_lex_state = 430},
  [17373] = {.lex_state = 0, .external_lex_state = 308},
  [17374] = {.lex_state = 0, .external_lex_state = 308},
  [17375] = {.lex_state = 0, .external_lex_state = 308},
  [17376] = {.lex_state = 0, .external_lex_state = 386},
  [17377] = {.lex_state = 0, .external_lex_state = 339},
  [17378] = {.lex_state = 0, .external_lex_state = 308},
  [17379] = {.lex_state = 55, .external_lex_state = 405},
  [17380] = {.lex_state = 0, .external_lex_state = 386},
  [17381] = {.lex_state = 0, .external_lex_state = 308},
  [17382] = {.lex_state = 0, .external_lex_state = 308},
  [17383] = {.lex_state = 0, .external_lex_state = 308},
  [17384] = {.lex_state = 0, .external_lex_state = 386},
  [17385] = {.lex_state = 0, .external_lex_state = 308},
  [17386] = {.lex_state = 0, .external_lex_state = 386},
  [17387] = {.lex_state = 0, .external_lex_state = 386},
  [17388] = {.lex_state = 0, .external_lex_state = 386},
  [17389] = {.lex_state = 0, .external_lex_state = 308},
  [17390] = {.lex_state = 0, .external_lex_state = 308},
  [17391] = {.lex_state = 58, .external_lex_state = 400},
  [17392] = {.lex_state = 0, .external_lex_state = 386},
  [17393] = {.lex_state = 0, .external_lex_state = 308},
  [17394] = {.lex_state = 0, .external_lex_state = 386},
  [17395] = {.lex_state = 0, .external_lex_state = 308},
  [17396] = {.lex_state = 0, .external_lex_state = 308},
  [17397] = {.lex_state = 0, .external_lex_state = 386},
  [17398] = {.lex_state = 0, .external_lex_state = 386},
  [17399] = {.lex_state = 0, .external_lex_state = 308},
  [17400] = {.lex_state = 55, .external_lex_state = 406},
  [17401] = {.lex_state = 0, .external_lex_state = 386},
  [17402] = {.lex_state = 0, .external_lex_state = 386},
  [17403] = {.lex_state = 0, .external_lex_state = 308},
  [17404] = {.lex_state = 0, .external_lex_state = 386},
  [17405] = {.lex_state = 0, .external_lex_state = 308},
  [17406] = {.lex_state = 0, .external_lex_state = 308},
  [17407] = {.lex_state = 0, .external_lex_state = 308},
  [17408] = {.lex_state = 55, .external_lex_state = 438},
  [17409] = {.lex_state = 0, .external_lex_state = 308},
  [17410] = {.lex_state = 0, .external_lex_state = 308},
  [17411] = {.lex_state = 0, .external_lex_state = 386},
  [17412] = {.lex_state = 0, .external_lex_state = 386},
  [17413] = {.lex_state = 0, .external_lex_state = 308},
  [17414] = {.lex_state = 0, .external_lex_state = 308},
  [17415] = {.lex_state = 0, .external_lex_state = 386},
  [17416] = {.lex_state = 0, .external_lex_state = 308},
  [17417] = {.lex_state = 0, .external_lex_state = 437},
  [17418] = {.lex_state = 0, .external_lex_state = 386},
  [17419] = {.lex_state = 0, .external_lex_state = 386},
  [17420] = {.lex_state = 0, .external_lex_state = 308},
  [17421] = {.lex_state = 58, .external_lex_state = 401},
  [17422] = {.lex_state = 0, .external_lex_state = 308},
  [17423] = {.lex_state = 0, .external_lex_state = 308},
  [17424] = {.lex_state = 0, .external_lex_state = 336},
  [17425] = {.lex_state = 0, .external_lex_state = 308},
  [17426] = {.lex_state = 0, .external_lex_state = 308},
  [17427] = {.lex_state = 0, .external_lex_state = 308},
  [17428] = {.lex_state = 0, .external_lex_state = 308},
  [17429] = {.lex_state = 0, .external_lex_state = 308},
  [17430] = {.lex_state = 0, .external_lex_state = 308},
  [17431] = {.lex_state = 55, .external_lex_state = 308},
  [17432] = {.lex_state = 0, .external_lex_state = 308},
  [17433] = {.lex_state = 0, .external_lex_state = 308},
  [17434] = {.lex_state = 0, .external_lex_state = 308},
  [17435] = {.lex_state = 0, .external_lex_state = 308},
  [17436] = {.lex_state = 0, .external_lex_state = 308},
  [17437] = {.lex_state = 0, .external_lex_state = 386},
  [17438] = {.lex_state = 0, .external_lex_state = 308},
  [17439] = {.lex_state = 0, .external_lex_state = 308},
  [17440] = {.lex_state = 55, .external_lex_state = 405},
  [17441] = {.lex_state = 55, .external_lex_state = 386},
  [17442] = {.lex_state = 0, .external_lex_state = 350},
  [17443] = {.lex_state = 55, .external_lex_state = 308},
  [17444] = {.lex_state = 55, .external_lex_state = 386},
  [17445] = {.lex_state = 55, .external_lex_state = 406},
  [17446] = {.lex_state = 0, .external_lex_state = 350},
  [17447] = {.lex_state = 55, .external_lex_state = 308},
  [17448] = {.lex_state = 58, .external_lex_state = 399},
  [17449] = {.lex_state = 0, .external_lex_state = 308},
  [17450] = {.lex_state = 55, .external_lex_state = 308},
  [17451] = {.lex_state = 55, .external_lex_state = 308},
  [17452] = {.lex_state = 55, .external_lex_state = 386},
  [17453] = {.lex_state = 0, .external_lex_state = 308},
  [17454] = {.lex_state = 0, .external_lex_state = 308},
  [17455] = {.lex_state = 0, .external_lex_state = 308},
  [17456] = {.lex_state = 0, .external_lex_state = 308},
  [17457] = {.lex_state = 0, .external_lex_state = 308},
  [17458] = {.lex_state = 0, .external_lex_state = 308},
  [17459] = {.lex_state = 55, .external_lex_state = 438},
  [17460] = {.lex_state = 0, .external_lex_state = 350},
  [17461] = {.lex_state = 58, .external_lex_state = 399},
  [17462] = {.lex_state = 0, .external_lex_state = 336},
  [17463] = {.lex_state = 0, .external_lex_state = 350},
  [17464] = {.lex_state = 0, .external_lex_state = 350},
  [17465] = {.lex_state = 55, .external_lex_state = 308},
  [17466] = {.lex_state = 0, .external_lex_state = 308},
  [17467] = {.lex_state = 0, .external_lex_state = 308},
  [17468] = {.lex_state = 0, .external_lex_state = 308},
  [17469] = {.lex_state = 0, .external_lex_state = 437},
  [17470] = {.lex_state = 55, .external_lex_state = 308},
  [17471] = {.lex_state = 0, .external_lex_state = 308},
  [17472] = {.lex_state = 55, .external_lex_state = 308},
  [17473] = {.lex_state = 0, .external_lex_state = 308},
  [17474] = {.lex_state = 0, .external_lex_state = 308},
  [17475] = {.lex_state = 0, .external_lex_state = 308},
  [17476] = {.lex_state = 0, .external_lex_state = 308},
  [17477] = {.lex_state = 58, .external_lex_state = 399},
  [17478] = {.lex_state = 0, .external_lex_state = 308},
  [17479] = {.lex_state = 0, .external_lex_state = 386},
  [17480] = {.lex_state = 0, .external_lex_state = 308},
  [17481] = {.lex_state = 0, .external_lex_state = 308},
  [17482] = {.lex_state = 0, .external_lex_state = 411},
  [17483] = {.lex_state = 0, .external_lex_state = 308},
  [17484] = {.lex_state = 58, .external_lex_state = 400},
  [17485] = {.lex_state = 0, .external_lex_state = 386},
  [17486] = {.lex_state = 0, .external_lex_state = 308},
  [17487] = {.lex_state = 0, .external_lex_state = 308},
  [17488] = {.lex_state = 0, .external_lex_state = 350},
  [17489] = {.lex_state = 0, .external_lex_state = 308},
  [17490] = {.lex_state = 0, .external_lex_state = 411},
  [17491] = {.lex_state = 0, .external_lex_state = 308},
  [17492] = {.lex_state = 0, .external_lex_state = 308},
  [17493] = {.lex_state = 0, .external_lex_state = 308},
  [17494] = {.lex_state = 55, .external_lex_state = 406},
  [17495] = {.lex_state = 0, .external_lex_state = 308},
  [17496] = {.lex_state = 0, .external_lex_state = 386},
  [17497] = {.lex_state = 0, .external_lex_state = 308},
  [17498] = {.lex_state = 0, .external_lex_state = 308},
  [17499] = {.lex_state = 0, .external_lex_state = 386},
  [17500] = {.lex_state = 55, .external_lex_state = 386},
  [17501] = {.lex_state = 0, .external_lex_state = 308},
  [17502] = {.lex_state = 0, .external_lex_state = 386},
  [17503] = {.lex_state = 0, .external_lex_state = 386},
  [17504] = {.lex_state = 0, .external_lex_state = 308},
  [17505] = {.lex_state = 0, .external_lex_state = 308},
  [17506] = {.lex_state = 0, .external_lex_state = 386},
  [17507] = {.lex_state = 0, .external_lex_state = 308},
  [17508] = {.lex_state = 0, .external_lex_state = 386},
  [17509] = {.lex_state = 0, .external_lex_state = 308},
  [17510] = {.lex_state = 55, .external_lex_state = 398},
  [17511] = {.lex_state = 0, .external_lex_state = 386},
  [17512] = {.lex_state = 0, .external_lex_state = 308},
  [17513] = {.lex_state = 0, .external_lex_state = 386},
  [17514] = {.lex_state = 0, .external_lex_state = 308},
  [17515] = {.lex_state = 0, .external_lex_state = 308},
  [17516] = {.lex_state = 0, .external_lex_state = 386},
  [17517] = {.lex_state = 55, .external_lex_state = 308},
  [17518] = {.lex_state = 0, .external_lex_state = 308},
  [17519] = {.lex_state = 0, .external_lex_state = 308},
  [17520] = {.lex_state = 0, .external_lex_state = 386},
  [17521] = {.lex_state = 0, .external_lex_state = 308},
  [17522] = {.lex_state = 0, .external_lex_state = 308},
  [17523] = {.lex_state = 0, .external_lex_state = 386},
  [17524] = {.lex_state = 0, .external_lex_state = 308},
  [17525] = {.lex_state = 0, .external_lex_state = 308},
  [17526] = {.lex_state = 0, .external_lex_state = 308},
  [17527] = {.lex_state = 0, .external_lex_state = 386},
  [17528] = {.lex_state = 0, .external_lex_state = 308},
  [17529] = {.lex_state = 0, .external_lex_state = 386},
  [17530] = {.lex_state = 0, .external_lex_state = 308},
  [17531] = {.lex_state = 0, .external_lex_state = 386},
  [17532] = {.lex_state = 0, .external_lex_state = 386},
  [17533] = {.lex_state = 0, .external_lex_state = 308},
  [17534] = {.lex_state = 0, .external_lex_state = 308},
  [17535] = {.lex_state = 0, .external_lex_state = 308},
  [17536] = {.lex_state = 0, .external_lex_state = 386},
  [17537] = {.lex_state = 0, .external_lex_state = 386},
  [17538] = {.lex_state = 0, .external_lex_state = 308},
  [17539] = {.lex_state = 0, .external_lex_state = 308},
  [17540] = {.lex_state = 0, .external_lex_state = 386},
  [17541] = {.lex_state = 0, .external_lex_state = 308},
  [17542] = {.lex_state = 0, .external_lex_state = 308},
  [17543] = {.lex_state = 0, .external_lex_state = 308},
  [17544] = {.lex_state = 0, .external_lex_state = 308},
  [17545] = {.lex_state = 0, .external_lex_state = 308},
  [17546] = {.lex_state = 0, .external_lex_state = 386},
  [17547] = {.lex_state = 0, .external_lex_state = 308},
  [17548] = {.lex_state = 0, .external_lex_state = 405},
  [17549] = {.lex_state = 0, .external_lex_state = 308},
  [17550] = {.lex_state = 0, .external_lex_state = 386},
  [17551] = {.lex_state = 0, .external_lex_state = 308},
  [17552] = {.lex_state = 0, .external_lex_state = 308},
  [17553] = {.lex_state = 0, .external_lex_state = 308},
  [17554] = {.lex_state = 0, .external_lex_state = 386},
  [17555] = {.lex_state = 0, .external_lex_state = 308},
  [17556] = {.lex_state = 0, .external_lex_state = 308},
  [17557] = {.lex_state = 55, .external_lex_state = 405},
  [17558] = {.lex_state = 0, .external_lex_state = 308},
  [17559] = {.lex_state = 0, .external_lex_state = 308},
  [17560] = {.lex_state = 55, .external_lex_state = 424},
  [17561] = {.lex_state = 0, .external_lex_state = 308},
  [17562] = {.lex_state = 0, .external_lex_state = 308},
  [17563] = {.lex_state = 0, .external_lex_state = 386},
  [17564] = {.lex_state = 0, .external_lex_state = 308},
  [17565] = {.lex_state = 0, .external_lex_state = 308},
  [17566] = {.lex_state = 0, .external_lex_state = 308},
  [17567] = {.lex_state = 0, .external_lex_state = 308},
  [17568] = {.lex_state = 0, .external_lex_state = 308},
  [17569] = {.lex_state = 0, .external_lex_state = 308},
  [17570] = {.lex_state = 58, .external_lex_state = 397},
  [17571] = {.lex_state = 0, .external_lex_state = 350},
  [17572] = {.lex_state = 0, .external_lex_state = 308},
  [17573] = {.lex_state = 0, .external_lex_state = 308},
  [17574] = {.lex_state = 0, .external_lex_state = 386},
  [17575] = {.lex_state = 0, .external_lex_state = 308},
  [17576] = {.lex_state = 0, .external_lex_state = 308},
  [17577] = {.lex_state = 0, .external_lex_state = 308},
  [17578] = {.lex_state = 0, .external_lex_state = 308},
  [17579] = {.lex_state = 55, .external_lex_state = 405},
  [17580] = {.lex_state = 55, .external_lex_state = 405},
  [17581] = {.lex_state = 0, .external_lex_state = 308},
  [17582] = {.lex_state = 0, .external_lex_state = 386},
  [17583] = {.lex_state = 0, .external_lex_state = 308},
  [17584] = {.lex_state = 55, .external_lex_state = 397},
  [17585] = {.lex_state = 0, .external_lex_state = 308},
  [17586] = {.lex_state = 55, .external_lex_state = 405},
  [17587] = {.lex_state = 55, .external_lex_state = 405},
  [17588] = {.lex_state = 0, .external_lex_state = 308},
  [17589] = {.lex_state = 0, .external_lex_state = 386},
  [17590] = {.lex_state = 0, .external_lex_state = 386},
  [17591] = {.lex_state = 0, .external_lex_state = 308},
  [17592] = {.lex_state = 0, .external_lex_state = 308},
  [17593] = {.lex_state = 0, .external_lex_state = 437},
  [17594] = {.lex_state = 0, .external_lex_state = 386},
  [17595] = {.lex_state = 0, .external_lex_state = 437},
  [17596] = {.lex_state = 55, .external_lex_state = 405},
  [17597] = {.lex_state = 55, .external_lex_state = 405},
  [17598] = {.lex_state = 0, .external_lex_state = 308},
  [17599] = {.lex_state = 0, .external_lex_state = 308},
  [17600] = {.lex_state = 55, .external_lex_state = 308},
  [17601] = {.lex_state = 0, .external_lex_state = 308},
  [17602] = {.lex_state = 0, .external_lex_state = 308},
  [17603] = {.lex_state = 55, .external_lex_state = 308},
  [17604] = {.lex_state = 0, .external_lex_state = 308},
  [17605] = {.lex_state = 0, .external_lex_state = 308},
  [17606] = {.lex_state = 0, .external_lex_state = 308},
  [17607] = {.lex_state = 0, .external_lex_state = 308},
  [17608] = {.lex_state = 0, .external_lex_state = 308},
  [17609] = {.lex_state = 55, .external_lex_state = 405},
  [17610] = {.lex_state = 55, .external_lex_state = 397},
  [17611] = {.lex_state = 55, .external_lex_state = 405},
  [17612] = {.lex_state = 57, .external_lex_state = 308},
  [17613] = {.lex_state = 0, .external_lex_state = 308},
  [17614] = {.lex_state = 0, .external_lex_state = 308},
  [17615] = {.lex_state = 58, .external_lex_state = 401},
  [17616] = {.lex_state = 0, .external_lex_state = 308},
  [17617] = {.lex_state = 0, .external_lex_state = 308},
  [17618] = {.lex_state = 0, .external_lex_state = 386},
  [17619] = {.lex_state = 55, .external_lex_state = 386},
  [17620] = {.lex_state = 0, .external_lex_state = 308},
  [17621] = {.lex_state = 0, .external_lex_state = 308},
  [17622] = {.lex_state = 0, .external_lex_state = 386},
  [17623] = {.lex_state = 0, .external_lex_state = 386},
  [17624] = {.lex_state = 0, .external_lex_state = 308},
  [17625] = {.lex_state = 58, .external_lex_state = 397},
  [17626] = {.lex_state = 0, .external_lex_state = 308},
  [17627] = {.lex_state = 0, .external_lex_state = 386},
  [17628] = {.lex_state = 0, .external_lex_state = 308},
  [17629] = {.lex_state = 55, .external_lex_state = 413},
  [17630] = {.lex_state = 0, .external_lex_state = 308},
  [17631] = {.lex_state = 0, .external_lex_state = 308},
  [17632] = {.lex_state = 0, .external_lex_state = 386},
  [17633] = {.lex_state = 0, .external_lex_state = 386},
  [17634] = {.lex_state = 0, .external_lex_state = 308},
  [17635] = {.lex_state = 0, .external_lex_state = 386},
  [17636] = {.lex_state = 55, .external_lex_state = 406},
  [17637] = {.lex_state = 0, .external_lex_state = 308},
  [17638] = {.lex_state = 0, .external_lex_state = 437},
  [17639] = {.lex_state = 0, .external_lex_state = 386},
  [17640] = {.lex_state = 57, .external_lex_state = 308},
  [17641] = {.lex_state = 0, .external_lex_state = 308},
  [17642] = {.lex_state = 0, .external_lex_state = 308},
  [17643] = {.lex_state = 0, .external_lex_state = 308},
  [17644] = {.lex_state = 0, .external_lex_state = 308},
  [17645] = {.lex_state = 58, .external_lex_state = 401},
  [17646] = {.lex_state = 0, .external_lex_state = 308},
  [17647] = {.lex_state = 0, .external_lex_state = 308},
  [17648] = {.lex_state = 0, .external_lex_state = 308},
  [17649] = {.lex_state = 55, .external_lex_state = 406},
  [17650] = {.lex_state = 0, .external_lex_state = 386},
  [17651] = {.lex_state = 0, .external_lex_state = 308},
  [17652] = {.lex_state = 0, .external_lex_state = 308},
  [17653] = {.lex_state = 0, .external_lex_state = 386},
  [17654] = {.lex_state = 0, .external_lex_state = 308},
  [17655] = {.lex_state = 0, .external_lex_state = 308},
  [17656] = {.lex_state = 0, .external_lex_state = 386},
  [17657] = {.lex_state = 0, .external_lex_state = 386},
  [17658] = {.lex_state = 0, .external_lex_state = 308},
  [17659] = {.lex_state = 0, .external_lex_state = 308},
  [17660] = {.lex_state = 0, .external_lex_state = 308},
  [17661] = {.lex_state = 0, .external_lex_state = 308},
  [17662] = {.lex_state = 0, .external_lex_state = 386},
  [17663] = {.lex_state = 0, .external_lex_state = 308},
  [17664] = {.lex_state = 0, .external_lex_state = 411},
  [17665] = {.lex_state = 0, .external_lex_state = 386},
  [17666] = {.lex_state = 0, .external_lex_state = 308},
  [17667] = {.lex_state = 0, .external_lex_state = 308},
  [17668] = {.lex_state = 0, .external_lex_state = 308},
  [17669] = {.lex_state = 55, .external_lex_state = 386},
  [17670] = {.lex_state = 0, .external_lex_state = 434},
  [17671] = {.lex_state = 0, .external_lex_state = 308},
  [17672] = {.lex_state = 55, .external_lex_state = 308},
  [17673] = {.lex_state = 55, .external_lex_state = 406},
  [17674] = {.lex_state = 0, .external_lex_state = 308},
  [17675] = {.lex_state = 55, .external_lex_state = 406},
  [17676] = {.lex_state = 0, .external_lex_state = 308},
  [17677] = {.lex_state = 55, .external_lex_state = 397},
  [17678] = {.lex_state = 55, .external_lex_state = 397},
  [17679] = {.lex_state = 0, .external_lex_state = 386},
  [17680] = {.lex_state = 58, .external_lex_state = 399},
  [17681] = {.lex_state = 55, .external_lex_state = 397},
  [17682] = {.lex_state = 55, .external_lex_state = 397},
  [17683] = {.lex_state = 0, .external_lex_state = 386},
  [17684] = {.lex_state = 0, .external_lex_state = 308},
  [17685] = {.lex_state = 0, .external_lex_state = 308},
  [17686] = {.lex_state = 58, .external_lex_state = 401},
  [17687] = {.lex_state = 0, .external_lex_state = 308},
  [17688] = {.lex_state = 0, .external_lex_state = 308},
  [17689] = {.lex_state = 0, .external_lex_state = 386},
  [17690] = {.lex_state = 58, .external_lex_state = 401},
  [17691] = {.lex_state = 0, .external_lex_state = 308},
  [17692] = {.lex_state = 0, .external_lex_state = 434},
  [17693] = {.lex_state = 0, .external_lex_state = 308},
  [17694] = {.lex_state = 58, .external_lex_state = 401},
  [17695] = {.lex_state = 55, .external_lex_state = 397},
  [17696] = {.lex_state = 55, .external_lex_state = 397},
  [17697] = {.lex_state = 55, .external_lex_state = 406},
  [17698] = {.lex_state = 55, .external_lex_state = 397},
  [17699] = {.lex_state = 55, .external_lex_state = 397},
  [17700] = {.lex_state = 0, .external_lex_state = 308},
  [17701] = {.lex_state = 55, .external_lex_state = 405},
  [17702] = {.lex_state = 55, .external_lex_state = 308},
  [17703] = {.lex_state = 55, .external_lex_state = 406},
  [17704] = {.lex_state = 0, .external_lex_state = 308},
  [17705] = {.lex_state = 0, .external_lex_state = 308},
  [17706] = {.lex_state = 0, .external_lex_state = 339},
  [17707] = {.lex_state = 55, .external_lex_state = 405},
  [17708] = {.lex_state = 55, .external_lex_state = 397},
  [17709] = {.lex_state = 0, .external_lex_state = 308},
  [17710] = {.lex_state = 0, .external_lex_state = 386},
  [17711] = {.lex_state = 0, .external_lex_state = 308},
  [17712] = {.lex_state = 55, .external_lex_state = 406},
  [17713] = {.lex_state = 0, .external_lex_state = 386},
  [17714] = {.lex_state = 55, .external_lex_state = 397},
  [17715] = {.lex_state = 0, .external_lex_state = 308},
  [17716] = {.lex_state = 0, .external_lex_state = 308},
  [17717] = {.lex_state = 0, .external_lex_state = 308},
  [17718] = {.lex_state = 0, .external_lex_state = 308},
  [17719] = {.lex_state = 0, .external_lex_state = 350},
  [17720] = {.lex_state = 0, .external_lex_state = 308},
  [17721] = {.lex_state = 0, .external_lex_state = 386},
  [17722] = {.lex_state = 0, .external_lex_state = 308},
  [17723] = {.lex_state = 0, .external_lex_state = 308},
  [17724] = {.lex_state = 0, .external_lex_state = 386},
  [17725] = {.lex_state = 0, .external_lex_state = 308},
  [17726] = {.lex_state = 0, .external_lex_state = 386},
  [17727] = {.lex_state = 55, .external_lex_state = 397},
  [17728] = {.lex_state = 55, .external_lex_state = 397},
  [17729] = {.lex_state = 0, .external_lex_state = 308},
  [17730] = {.lex_state = 55, .external_lex_state = 405},
  [17731] = {.lex_state = 55, .external_lex_state = 397},
  [17732] = {.lex_state = 0, .external_lex_state = 308},
  [17733] = {.lex_state = 55, .external_lex_state = 406},
  [17734] = {.lex_state = 55, .external_lex_state = 405},
  [17735] = {.lex_state = 55, .external_lex_state = 405},
  [17736] = {.lex_state = 55, .external_lex_state = 405},
  [17737] = {.lex_state = 0, .external_lex_state = 386},
  [17738] = {.lex_state = 55, .external_lex_state = 397},
  [17739] = {.lex_state = 0, .external_lex_state = 308},
  [17740] = {.lex_state = 0, .external_lex_state = 308},
  [17741] = {.lex_state = 55, .external_lex_state = 397},
  [17742] = {.lex_state = 0, .external_lex_state = 308},
  [17743] = {.lex_state = 0, .external_lex_state = 308},
  [17744] = {.lex_state = 55, .external_lex_state = 397},
  [17745] = {.lex_state = 55, .external_lex_state = 405},
  [17746] = {.lex_state = 55, .external_lex_state = 397},
  [17747] = {.lex_state = 55, .external_lex_state = 397},
  [17748] = {.lex_state = 0, .external_lex_state = 308},
  [17749] = {.lex_state = 55, .external_lex_state = 397},
  [17750] = {.lex_state = 55, .external_lex_state = 397},
  [17751] = {.lex_state = 0, .external_lex_state = 386},
  [17752] = {.lex_state = 0, .external_lex_state = 308},
  [17753] = {.lex_state = 0, .external_lex_state = 308},
  [17754] = {.lex_state = 0, .external_lex_state = 386},
  [17755] = {.lex_state = 0, .external_lex_state = 308},
  [17756] = {.lex_state = 0, .external_lex_state = 308},
  [17757] = {.lex_state = 55, .external_lex_state = 397},
  [17758] = {.lex_state = 0, .external_lex_state = 386},
  [17759] = {.lex_state = 0, .external_lex_state = 308},
  [17760] = {.lex_state = 0, .external_lex_state = 308},
  [17761] = {.lex_state = 55, .external_lex_state = 397},
  [17762] = {.lex_state = 0, .external_lex_state = 308},
  [17763] = {.lex_state = 0, .external_lex_state = 386},
  [17764] = {.lex_state = 55, .external_lex_state = 397},
  [17765] = {.lex_state = 58, .external_lex_state = 430},
  [17766] = {.lex_state = 55, .external_lex_state = 397},
  [17767] = {.lex_state = 55, .external_lex_state = 397},
  [17768] = {.lex_state = 0, .external_lex_state = 308},
  [17769] = {.lex_state = 0, .external_lex_state = 386},
  [17770] = {.lex_state = 55, .external_lex_state = 397},
  [17771] = {.lex_state = 0, .external_lex_state = 308},
  [17772] = {.lex_state = 55, .external_lex_state = 397},
  [17773] = {.lex_state = 0, .external_lex_state = 308},
  [17774] = {.lex_state = 0, .external_lex_state = 308},
  [17775] = {.lex_state = 0, .external_lex_state = 386},
  [17776] = {.lex_state = 0, .external_lex_state = 386},
  [17777] = {.lex_state = 0, .external_lex_state = 308},
  [17778] = {.lex_state = 0, .external_lex_state = 308},
  [17779] = {.lex_state = 0, .external_lex_state = 308},
  [17780] = {.lex_state = 0, .external_lex_state = 386},
  [17781] = {.lex_state = 0, .external_lex_state = 308},
  [17782] = {.lex_state = 0, .external_lex_state = 308},
  [17783] = {.lex_state = 0, .external_lex_state = 308},
  [17784] = {.lex_state = 0, .external_lex_state = 308},
  [17785] = {.lex_state = 0, .external_lex_state = 308},
  [17786] = {.lex_state = 0, .external_lex_state = 308},
  [17787] = {.lex_state = 0, .external_lex_state = 308},
  [17788] = {.lex_state = 0, .external_lex_state = 308},
  [17789] = {.lex_state = 0, .external_lex_state = 308},
  [17790] = {.lex_state = 0, .external_lex_state = 308},
  [17791] = {.lex_state = 57, .external_lex_state = 336},
  [17792] = {.lex_state = 0, .external_lex_state = 308},
  [17793] = {.lex_state = 0, .external_lex_state = 386},
  [17794] = {.lex_state = 0, .external_lex_state = 308},
  [17795] = {.lex_state = 0, .external_lex_state = 308},
  [17796] = {.lex_state = 58, .external_lex_state = 399},
  [17797] = {.lex_state = 0, .external_lex_state = 308},
  [17798] = {.lex_state = 0, .external_lex_state = 308},
  [17799] = {.lex_state = 0, .external_lex_state = 386},
  [17800] = {.lex_state = 0, .external_lex_state = 308},
  [17801] = {.lex_state = 0, .external_lex_state = 308},
  [17802] = {.lex_state = 58, .external_lex_state = 399},
  [17803] = {.lex_state = 58, .external_lex_state = 399},
  [17804] = {.lex_state = 0, .external_lex_state = 308},
  [17805] = {.lex_state = 0, .external_lex_state = 308},
  [17806] = {.lex_state = 0, .external_lex_state = 386},
  [17807] = {.lex_state = 0, .external_lex_state = 308},
  [17808] = {.lex_state = 0, .external_lex_state = 386},
  [17809] = {.lex_state = 58, .external_lex_state = 399},
  [17810] = {.lex_state = 58, .external_lex_state = 399},
  [17811] = {.lex_state = 0, .external_lex_state = 308},
  [17812] = {.lex_state = 55, .external_lex_state = 397},
  [17813] = {.lex_state = 55, .external_lex_state = 406},
  [17814] = {.lex_state = 0, .external_lex_state = 386},
  [17815] = {.lex_state = 0, .external_lex_state = 308},
  [17816] = {.lex_state = 0, .external_lex_state = 308},
  [17817] = {.lex_state = 55, .external_lex_state = 438},
  [17818] = {.lex_state = 0, .external_lex_state = 308},
  [17819] = {.lex_state = 0, .external_lex_state = 308},
  [17820] = {.lex_state = 0, .external_lex_state = 386},
  [17821] = {.lex_state = 0, .external_lex_state = 308},
  [17822] = {.lex_state = 0, .external_lex_state = 308},
  [17823] = {.lex_state = 0, .external_lex_state = 308},
  [17824] = {.lex_state = 57, .external_lex_state = 336},
  [17825] = {.lex_state = 0, .external_lex_state = 386},
  [17826] = {.lex_state = 0, .external_lex_state = 308},
  [17827] = {.lex_state = 0, .external_lex_state = 308},
  [17828] = {.lex_state = 0, .external_lex_state = 308},
  [17829] = {.lex_state = 0, .external_lex_state = 386},
  [17830] = {.lex_state = 0, .external_lex_state = 308},
  [17831] = {.lex_state = 0, .external_lex_state = 308},
  [17832] = {.lex_state = 0, .external_lex_state = 386},
  [17833] = {.lex_state = 0, .external_lex_state = 308},
  [17834] = {.lex_state = 0, .external_lex_state = 308},
  [17835] = {.lex_state = 0, .external_lex_state = 386},
  [17836] = {.lex_state = 0, .external_lex_state = 308},
  [17837] = {.lex_state = 0, .external_lex_state = 308},
  [17838] = {.lex_state = 0, .external_lex_state = 308},
  [17839] = {.lex_state = 55, .external_lex_state = 397},
  [17840] = {.lex_state = 0, .external_lex_state = 336},
  [17841] = {.lex_state = 0, .external_lex_state = 336},
  [17842] = {.lex_state = 0, .external_lex_state = 336},
  [17843] = {.lex_state = 0, .external_lex_state = 336},
  [17844] = {.lex_state = 57, .external_lex_state = 336},
  [17845] = {.lex_state = 0, .external_lex_state = 367},
  [17846] = {.lex_state = 0, .external_lex_state = 404},
  [17847] = {.lex_state = 1, .external_lex_state = 440},
  [17848] = {.lex_state = 55, .external_lex_state = 413},
  [17849] = {.lex_state = 0, .external_lex_state = 386},
  [17850] = {.lex_state = 0, .external_lex_state = 439},
  [17851] = {.lex_state = 0, .external_lex_state = 386},
  [17852] = {.lex_state = 0, .external_lex_state = 436},
  [17853] = {.lex_state = 0, .external_lex_state = 436},
  [17854] = {.lex_state = 0, .external_lex_state = 436},
  [17855] = {.lex_state = 0, .external_lex_state = 404},
  [17856] = {.lex_state = 0, .external_lex_state = 436},
  [17857] = {.lex_state = 1, .external_lex_state = 440},
  [17858] = {.lex_state = 0, .external_lex_state = 336},
  [17859] = {.lex_state = 0, .external_lex_state = 336},
  [17860] = {.lex_state = 0, .external_lex_state = 336},
  [17861] = {.lex_state = 58, .external_lex_state = 308},
  [17862] = {.lex_state = 0, .external_lex_state = 308},
  [17863] = {.lex_state = 0, .external_lex_state = 336},
  [17864] = {.lex_state = 57, .external_lex_state = 441},
  [17865] = {.lex_state = 0, .external_lex_state = 386},
  [17866] = {.lex_state = 1, .external_lex_state = 440},
  [17867] = {.lex_state = 0, .external_lex_state = 336},
  [17868] = {.lex_state = 0, .external_lex_state = 439},
  [17869] = {.lex_state = 0, .external_lex_state = 404},
  [17870] = {.lex_state = 0, .external_lex_state = 336},
  [17871] = {.lex_state = 58, .external_lex_state = 308},
  [17872] = {.lex_state = 55, .external_lex_state = 413},
  [17873] = {.lex_state = 0, .external_lex_state = 386},
  [17874] = {.lex_state = 0, .external_lex_state = 386},
  [17875] = {.lex_state = 0, .external_lex_state = 308},
  [17876] = {.lex_state = 1, .external_lex_state = 440},
  [17877] = {.lex_state = 0, .external_lex_state = 336},
  [17878] = {.lex_state = 0, .external_lex_state = 405},
  [17879] = {.lex_state = 1, .external_lex_state = 440},
  [17880] = {.lex_state = 0, .external_lex_state = 386},
  [17881] = {.lex_state = 0, .external_lex_state = 404},
  [17882] = {.lex_state = 0, .external_lex_state = 336},
  [17883] = {.lex_state = 1, .external_lex_state = 440},
  [17884] = {.lex_state = 1, .external_lex_state = 440},
  [17885] = {.lex_state = 0, .external_lex_state = 336},
  [17886] = {.lex_state = 0, .external_lex_state = 336},
  [17887] = {.lex_state = 0, .external_lex_state = 405},
  [17888] = {.lex_state = 0, .external_lex_state = 336},
  [17889] = {.lex_state = 1, .external_lex_state = 440},
  [17890] = {.lex_state = 58, .external_lex_state = 308},
  [17891] = {.lex_state = 0, .external_lex_state = 336},
  [17892] = {.lex_state = 0, .external_lex_state = 336},
  [17893] = {.lex_state = 0, .external_lex_state = 404},
  [17894] = {.lex_state = 0, .external_lex_state = 336},
  [17895] = {.lex_state = 0, .external_lex_state = 336},
  [17896] = {.lex_state = 0, .external_lex_state = 336},
  [17897] = {.lex_state = 0, .external_lex_state = 336},
  [17898] = {.lex_state = 0, .external_lex_state = 386},
  [17899] = {.lex_state = 0, .external_lex_state = 386},
  [17900] = {.lex_state = 0, .external_lex_state = 404},
  [17901] = {.lex_state = 0, .external_lex_state = 336},
  [17902] = {.lex_state = 57, .external_lex_state = 308},
  [17903] = {.lex_state = 0, .external_lex_state = 308},
  [17904] = {.lex_state = 0, .external_lex_state = 404},
  [17905] = {.lex_state = 0, .external_lex_state = 404},
  [17906] = {.lex_state = 0, .external_lex_state = 336},
  [17907] = {.lex_state = 0, .external_lex_state = 336},
  [17908] = {.lex_state = 58, .external_lex_state = 308},
  [17909] = {.lex_state = 0, .external_lex_state = 336},
  [17910] = {.lex_state = 0, .external_lex_state = 336},
  [17911] = {.lex_state = 0, .external_lex_state = 386},
  [17912] = {.lex_state = 0, .external_lex_state = 404},
  [17913] = {.lex_state = 0, .external_lex_state = 336},
  [17914] = {.lex_state = 0, .external_lex_state = 386},
  [17915] = {.lex_state = 0, .external_lex_state = 386},
  [17916] = {.lex_state = 0, .external_lex_state = 367},
  [17917] = {.lex_state = 0, .external_lex_state = 386},
  [17918] = {.lex_state = 58, .external_lex_state = 308},
  [17919] = {.lex_state = 0, .external_lex_state = 336},
  [17920] = {.lex_state = 0, .external_lex_state = 386},
  [17921] = {.lex_state = 1, .external_lex_state = 440},
  [17922] = {.lex_state = 0, .external_lex_state = 336},
  [17923] = {.lex_state = 1, .external_lex_state = 440},
  [17924] = {.lex_state = 0, .external_lex_state = 336},
  [17925] = {.lex_state = 0, .external_lex_state = 386},
  [17926] = {.lex_state = 0, .external_lex_state = 308},
  [17927] = {.lex_state = 0, .external_lex_state = 336},
  [17928] = {.lex_state = 0, .external_lex_state = 386},
  [17929] = {.lex_state = 0, .external_lex_state = 336},
  [17930] = {.lex_state = 0, .external_lex_state = 336},
  [17931] = {.lex_state = 0, .external_lex_state = 439},
  [17932] = {.lex_state = 0, .external_lex_state = 336},
  [17933] = {.lex_state = 0, .external_lex_state = 367},
  [17934] = {.lex_state = 0, .external_lex_state = 386},
  [17935] = {.lex_state = 0, .external_lex_state = 386},
  [17936] = {.lex_state = 0, .external_lex_state = 404},
  [17937] = {.lex_state = 57, .external_lex_state = 308},
  [17938] = {.lex_state = 0, .external_lex_state = 404},
  [17939] = {.lex_state = 58, .external_lex_state = 308},
  [17940] = {.lex_state = 0, .external_lex_state = 336},
  [17941] = {.lex_state = 0, .external_lex_state = 386},
  [17942] = {.lex_state = 0, .external_lex_state = 336},
  [17943] = {.lex_state = 0, .external_lex_state = 336},
  [17944] = {.lex_state = 0, .external_lex_state = 336},
  [17945] = {.lex_state = 0, .external_lex_state = 336},
  [17946] = {.lex_state = 0, .external_lex_state = 336},
  [17947] = {.lex_state = 1, .external_lex_state = 440},
  [17948] = {.lex_state = 0, .external_lex_state = 336},
  [17949] = {.lex_state = 58, .external_lex_state = 308},
  [17950] = {.lex_state = 1, .external_lex_state = 440},
  [17951] = {.lex_state = 57, .external_lex_state = 308},
  [17952] = {.lex_state = 0, .external_lex_state = 336},
  [17953] = {.lex_state = 0, .external_lex_state = 386},
  [17954] = {.lex_state = 0, .external_lex_state = 336},
  [17955] = {.lex_state = 0, .external_lex_state = 336},
  [17956] = {.lex_state = 0, .external_lex_state = 336},
  [17957] = {.lex_state = 55, .external_lex_state = 308},
  [17958] = {.lex_state = 0, .external_lex_state = 367},
  [17959] = {.lex_state = 0, .external_lex_state = 308},
  [17960] = {.lex_state = 0, .external_lex_state = 336},
  [17961] = {.lex_state = 0, .external_lex_state = 336},
  [17962] = {.lex_state = 0, .external_lex_state = 336},
  [17963] = {.lex_state = 0, .external_lex_state = 336},
  [17964] = {.lex_state = 0, .external_lex_state = 439},
  [17965] = {.lex_state = 0, .external_lex_state = 386},
  [17966] = {.lex_state = 0, .external_lex_state = 386},
  [17967] = {.lex_state = 0, .external_lex_state = 404},
  [17968] = {.lex_state = 0, .external_lex_state = 336},
  [17969] = {.lex_state = 0, .external_lex_state = 308},
  [17970] = {.lex_state = 0, .external_lex_state = 386},
  [17971] = {.lex_state = 0, .external_lex_state = 336},
  [17972] = {.lex_state = 0, .external_lex_state = 386},
  [17973] = {.lex_state = 0, .external_lex_state = 439},
  [17974] = {.lex_state = 0, .external_lex_state = 404},
  [17975] = {.lex_state = 0, .external_lex_state = 386},
  [17976] = {.lex_state = 0, .external_lex_state = 405},
  [17977] = {.lex_state = 0, .external_lex_state = 386},
  [17978] = {.lex_state = 0, .external_lex_state = 336},
  [17979] = {.lex_state = 0, .external_lex_state = 336},
  [17980] = {.lex_state = 58, .external_lex_state = 308},
  [17981] = {.lex_state = 55, .external_lex_state = 308},
  [17982] = {.lex_state = 0, .external_lex_state = 336},
  [17983] = {.lex_state = 0, .external_lex_state = 405},
  [17984] = {.lex_state = 0, .external_lex_state = 386},
  [17985] = {.lex_state = 0, .external_lex_state = 386},
  [17986] = {.lex_state = 0, .external_lex_state = 336},
  [17987] = {.lex_state = 0, .external_lex_state = 405},
  [17988] = {.lex_state = 0, .external_lex_state = 404},
  [17989] = {.lex_state = 1, .external_lex_state = 440},
  [17990] = {.lex_state = 1, .external_lex_state = 440},
  [17991] = {.lex_state = 0, .external_lex_state = 386},
  [17992] = {.lex_state = 0, .external_lex_state = 386},
  [17993] = {.lex_state = 0, .external_lex_state = 336},
  [17994] = {.lex_state = 0, .external_lex_state = 405},
  [17995] = {.lex_state = 0, .external_lex_state = 386},
  [17996] = {.lex_state = 0, .external_lex_state = 386},
  [17997] = {.lex_state = 0, .external_lex_state = 336},
  [17998] = {.lex_state = 0, .external_lex_state = 367},
  [17999] = {.lex_state = 0, .external_lex_state = 386},
  [18000] = {.lex_state = 0, .external_lex_state = 336},
  [18001] = {.lex_state = 0, .external_lex_state = 336},
  [18002] = {.lex_state = 0, .external_lex_state = 336},
  [18003] = {.lex_state = 1, .external_lex_state = 440},
  [18004] = {.lex_state = 0, .external_lex_state = 404},
  [18005] = {.lex_state = 0, .external_lex_state = 336},
  [18006] = {.lex_state = 1, .external_lex_state = 440},
  [18007] = {.lex_state = 0, .external_lex_state = 336},
  [18008] = {.lex_state = 57, .external_lex_state = 367},
  [18009] = {.lex_state = 0, .external_lex_state = 386},
  [18010] = {.lex_state = 0, .external_lex_state = 336},
  [18011] = {.lex_state = 0, .external_lex_state = 336},
  [18012] = {.lex_state = 0, .external_lex_state = 336},
  [18013] = {.lex_state = 58, .external_lex_state = 308},
  [18014] = {.lex_state = 0, .external_lex_state = 308},
  [18015] = {.lex_state = 0, .external_lex_state = 439},
  [18016] = {.lex_state = 0, .external_lex_state = 308},
  [18017] = {.lex_state = 0, .external_lex_state = 404},
  [18018] = {.lex_state = 57, .external_lex_state = 308},
  [18019] = {.lex_state = 0, .external_lex_state = 386},
  [18020] = {.lex_state = 0, .external_lex_state = 386},
  [18021] = {.lex_state = 0, .external_lex_state = 404},
  [18022] = {.lex_state = 0, .external_lex_state = 405},
  [18023] = {.lex_state = 0, .external_lex_state = 386},
  [18024] = {.lex_state = 1, .external_lex_state = 440},
  [18025] = {.lex_state = 0, .external_lex_state = 336},
  [18026] = {.lex_state = 0, .external_lex_state = 336},
  [18027] = {.lex_state = 0, .external_lex_state = 386},
  [18028] = {.lex_state = 0, .external_lex_state = 336},
  [18029] = {.lex_state = 58, .external_lex_state = 308},
  [18030] = {.lex_state = 0, .external_lex_state = 336},
  [18031] = {.lex_state = 0, .external_lex_state = 336},
  [18032] = {.lex_state = 0, .external_lex_state = 336},
  [18033] = {.lex_state = 0, .external_lex_state = 386},
  [18034] = {.lex_state = 0, .external_lex_state = 386},
  [18035] = {.lex_state = 58, .external_lex_state = 308},
  [18036] = {.lex_state = 0, .external_lex_state = 386},
  [18037] = {.lex_state = 0, .external_lex_state = 336},
  [18038] = {.lex_state = 1, .external_lex_state = 440},
  [18039] = {.lex_state = 0, .external_lex_state = 336},
  [18040] = {.lex_state = 1, .external_lex_state = 440},
  [18041] = {.lex_state = 0, .external_lex_state = 336},
  [18042] = {.lex_state = 1, .external_lex_state = 440},
  [18043] = {.lex_state = 0, .external_lex_state = 336},
  [18044] = {.lex_state = 57, .external_lex_state = 308},
  [18045] = {.lex_state = 0, .external_lex_state = 308},
  [18046] = {.lex_state = 0, .external_lex_state = 336},
  [18047] = {.lex_state = 58, .external_lex_state = 390},
  [18048] = {.lex_state = 0, .external_lex_state = 386},
  [18049] = {.lex_state = 58, .external_lex_state = 390},
  [18050] = {.lex_state = 0, .external_lex_state = 439},
  [18051] = {.lex_state = 0, .external_lex_state = 404},
  [18052] = {.lex_state = 0, .external_lex_state = 404},
  [18053] = {.lex_state = 0, .external_lex_state = 404},
  [18054] = {.lex_state = 0, .external_lex_state = 404},
  [18055] = {.lex_state = 58, .external_lex_state = 400},
  [18056] = {.lex_state = 0, .external_lex_state = 336},
  [18057] = {.lex_state = 0, .external_lex_state = 404},
  [18058] = {.lex_state = 0, .external_lex_state = 386},
  [18059] = {.lex_state = 0, .external_lex_state = 439},
  [18060] = {.lex_state = 55, .external_lex_state = 413},
  [18061] = {.lex_state = 58, .external_lex_state = 400},
  [18062] = {.lex_state = 0, .external_lex_state = 336},
  [18063] = {.lex_state = 57, .external_lex_state = 308},
  [18064] = {.lex_state = 0, .external_lex_state = 405},
  [18065] = {.lex_state = 58, .external_lex_state = 308},
  [18066] = {.lex_state = 1, .external_lex_state = 440},
  [18067] = {.lex_state = 0, .external_lex_state = 336},
  [18068] = {.lex_state = 58, .external_lex_state = 308},
  [18069] = {.lex_state = 0, .external_lex_state = 336},
  [18070] = {.lex_state = 0, .external_lex_state = 404},
  [18071] = {.lex_state = 0, .external_lex_state = 336},
  [18072] = {.lex_state = 0, .external_lex_state = 404},
  [18073] = {.lex_state = 0, .external_lex_state = 336},
  [18074] = {.lex_state = 57, .external_lex_state = 308},
  [18075] = {.lex_state = 0, .external_lex_state = 386},
  [18076] = {.lex_state = 0, .external_lex_state = 336},
  [18077] = {.lex_state = 0, .external_lex_state = 336},
  [18078] = {.lex_state = 0, .external_lex_state = 336},
  [18079] = {.lex_state = 58, .external_lex_state = 390},
  [18080] = {.lex_state = 0, .external_lex_state = 336},
  [18081] = {.lex_state = 0, .external_lex_state = 336},
  [18082] = {.lex_state = 0, .external_lex_state = 336},
  [18083] = {.lex_state = 1, .external_lex_state = 440},
  [18084] = {.lex_state = 1, .external_lex_state = 440},
  [18085] = {.lex_state = 0, .external_lex_state = 386},
  [18086] = {.lex_state = 55, .external_lex_state = 413},
  [18087] = {.lex_state = 0, .external_lex_state = 336},
  [18088] = {.lex_state = 57, .external_lex_state = 308},
  [18089] = {.lex_state = 0, .external_lex_state = 386},
  [18090] = {.lex_state = 0, .external_lex_state = 405},
  [18091] = {.lex_state = 0, .external_lex_state = 336},
  [18092] = {.lex_state = 0, .external_lex_state = 336},
  [18093] = {.lex_state = 0, .external_lex_state = 404},
  [18094] = {.lex_state = 0, .external_lex_state = 386},
  [18095] = {.lex_state = 0, .external_lex_state = 336},
  [18096] = {.lex_state = 0, .external_lex_state = 336},
  [18097] = {.lex_state = 0, .external_lex_state = 336},
  [18098] = {.lex_state = 0, .external_lex_state = 336},
  [18099] = {.lex_state = 58, .external_lex_state = 308},
  [18100] = {.lex_state = 55, .external_lex_state = 308},
  [18101] = {.lex_state = 0, .external_lex_state = 336},
  [18102] = {.lex_state = 0, .external_lex_state = 405},
  [18103] = {.lex_state = 0, .external_lex_state = 336},
  [18104] = {.lex_state = 0, .external_lex_state = 367},
  [18105] = {.lex_state = 0, .external_lex_state = 336},
  [18106] = {.lex_state = 0, .external_lex_state = 336},
  [18107] = {.lex_state = 0, .external_lex_state = 404},
  [18108] = {.lex_state = 0, .external_lex_state = 404},
  [18109] = {.lex_state = 0, .external_lex_state = 336},
  [18110] = {.lex_state = 0, .external_lex_state = 336},
  [18111] = {.lex_state = 0, .external_lex_state = 336},
  [18112] = {.lex_state = 0, .external_lex_state = 336},
  [18113] = {.lex_state = 1, .external_lex_state = 440},
  [18114] = {.lex_state = 58, .external_lex_state = 308},
  [18115] = {.lex_state = 55, .external_lex_state = 308},
  [18116] = {.lex_state = 0, .external_lex_state = 336},
  [18117] = {.lex_state = 0, .external_lex_state = 336},
  [18118] = {.lex_state = 0, .external_lex_state = 404},
  [18119] = {.lex_state = 0, .external_lex_state = 336},
  [18120] = {.lex_state = 0, .external_lex_state = 336},
  [18121] = {.lex_state = 0, .external_lex_state = 386},
  [18122] = {.lex_state = 0, .external_lex_state = 336},
  [18123] = {.lex_state = 0, .external_lex_state = 386},
  [18124] = {.lex_state = 0, .external_lex_state = 336},
  [18125] = {.lex_state = 1, .external_lex_state = 440},
  [18126] = {.lex_state = 0, .external_lex_state = 336},
  [18127] = {.lex_state = 1, .external_lex_state = 440},
  [18128] = {.lex_state = 0, .external_lex_state = 336},
  [18129] = {.lex_state = 55, .external_lex_state = 413},
  [18130] = {.lex_state = 55, .external_lex_state = 413},
  [18131] = {.lex_state = 0, .external_lex_state = 336},
  [18132] = {.lex_state = 0, .external_lex_state = 336},
  [18133] = {.lex_state = 0, .external_lex_state = 439},
  [18134] = {.lex_state = 0, .external_lex_state = 308},
  [18135] = {.lex_state = 0, .external_lex_state = 336},
  [18136] = {.lex_state = 0, .external_lex_state = 386},
  [18137] = {.lex_state = 0, .external_lex_state = 386},
  [18138] = {.lex_state = 58, .external_lex_state = 308},
  [18139] = {.lex_state = 0, .external_lex_state = 336},
  [18140] = {.lex_state = 58, .external_lex_state = 308},
  [18141] = {.lex_state = 0, .external_lex_state = 404},
  [18142] = {.lex_state = 1, .external_lex_state = 440},
  [18143] = {.lex_state = 1, .external_lex_state = 440},
  [18144] = {.lex_state = 0, .external_lex_state = 336},
  [18145] = {.lex_state = 55, .external_lex_state = 413},
  [18146] = {.lex_state = 0, .external_lex_state = 336},
  [18147] = {.lex_state = 58, .external_lex_state = 308},
  [18148] = {.lex_state = 55, .external_lex_state = 413},
  [18149] = {.lex_state = 0, .external_lex_state = 336},
  [18150] = {.lex_state = 0, .external_lex_state = 386},
  [18151] = {.lex_state = 0, .external_lex_state = 386},
  [18152] = {.lex_state = 0, .external_lex_state = 336},
  [18153] = {.lex_state = 0, .external_lex_state = 404},
  [18154] = {.lex_state = 0, .external_lex_state = 336},
  [18155] = {.lex_state = 0, .external_lex_state = 336},
  [18156] = {.lex_state = 0, .external_lex_state = 336},
  [18157] = {.lex_state = 0, .external_lex_state = 439},
  [18158] = {.lex_state = 0, .external_lex_state = 336},
  [18159] = {.lex_state = 1, .external_lex_state = 440},
  [18160] = {.lex_state = 1, .external_lex_state = 440},
  [18161] = {.lex_state = 1, .external_lex_state = 440},
  [18162] = {.lex_state = 1, .external_lex_state = 440},
  [18163] = {.lex_state = 55, .external_lex_state = 413},
  [18164] = {.lex_state = 0, .external_lex_state = 336},
  [18165] = {.lex_state = 0, .external_lex_state = 336},
  [18166] = {.lex_state = 0, .external_lex_state = 336},
  [18167] = {.lex_state = 0, .external_lex_state = 386},
  [18168] = {.lex_state = 57, .external_lex_state = 308},
  [18169] = {.lex_state = 0, .external_lex_state = 439},
  [18170] = {.lex_state = 0, .external_lex_state = 404},
  [18171] = {.lex_state = 0, .external_lex_state = 404},
  [18172] = {.lex_state = 0, .external_lex_state = 386},
  [18173] = {.lex_state = 0, .external_lex_state = 336},
  [18174] = {.lex_state = 0, .external_lex_state = 336},
  [18175] = {.lex_state = 0, .external_lex_state = 386},
  [18176] = {.lex_state = 0, .external_lex_state = 404},
  [18177] = {.lex_state = 58, .external_lex_state = 308},
  [18178] = {.lex_state = 0, .external_lex_state = 336},
  [18179] = {.lex_state = 0, .external_lex_state = 336},
  [18180] = {.lex_state = 0, .external_lex_state = 336},
  [18181] = {.lex_state = 0, .external_lex_state = 336},
  [18182] = {.lex_state = 0, .external_lex_state = 404},
  [18183] = {.lex_state = 57, .external_lex_state = 308},
  [18184] = {.lex_state = 0, .external_lex_state = 336},
  [18185] = {.lex_state = 1, .external_lex_state = 440},
  [18186] = {.lex_state = 0, .external_lex_state = 336},
  [18187] = {.lex_state = 58, .external_lex_state = 308},
  [18188] = {.lex_state = 0, .external_lex_state = 336},
  [18189] = {.lex_state = 0, .external_lex_state = 386},
  [18190] = {.lex_state = 0, .external_lex_state = 386},
  [18191] = {.lex_state = 0, .external_lex_state = 336},
  [18192] = {.lex_state = 0, .external_lex_state = 336},
  [18193] = {.lex_state = 0, .external_lex_state = 336},
  [18194] = {.lex_state = 0, .external_lex_state = 336},
  [18195] = {.lex_state = 57, .external_lex_state = 308},
  [18196] = {.lex_state = 0, .external_lex_state = 308},
  [18197] = {.lex_state = 0, .external_lex_state = 336},
  [18198] = {.lex_state = 0, .external_lex_state = 386},
  [18199] = {.lex_state = 0, .external_lex_state = 336},
  [18200] = {.lex_state = 0, .external_lex_state = 336},
  [18201] = {.lex_state = 55, .external_lex_state = 308},
  [18202] = {.lex_state = 0, .external_lex_state = 404},
  [18203] = {.lex_state = 0, .external_lex_state = 336},
  [18204] = {.lex_state = 0, .external_lex_state = 386},
  [18205] = {.lex_state = 0, .external_lex_state = 336},
  [18206] = {.lex_state = 0, .external_lex_state = 405},
  [18207] = {.lex_state = 1, .external_lex_state = 440},
  [18208] = {.lex_state = 0, .external_lex_state = 386},
  [18209] = {.lex_state = 0, .external_lex_state = 336},
  [18210] = {.lex_state = 0, .external_lex_state = 336},
  [18211] = {.lex_state = 0, .external_lex_state = 336},
  [18212] = {.lex_state = 0, .external_lex_state = 404},
  [18213] = {.lex_state = 58, .external_lex_state = 308},
  [18214] = {.lex_state = 0, .external_lex_state = 439},
  [18215] = {.lex_state = 0, .external_lex_state = 336},
  [18216] = {.lex_state = 0, .external_lex_state = 336},
  [18217] = {.lex_state = 0, .external_lex_state = 308},
  [18218] = {.lex_state = 58, .external_lex_state = 308},
  [18219] = {.lex_state = 0, .external_lex_state = 404},
  [18220] = {.lex_state = 0, .external_lex_state = 336},
  [18221] = {.lex_state = 55, .external_lex_state = 308},
  [18222] = {.lex_state = 0, .external_lex_state = 386},
  [18223] = {.lex_state = 1, .external_lex_state = 440},
  [18224] = {.lex_state = 0, .external_lex_state = 336},
  [18225] = {.lex_state = 0, .external_lex_state = 336},
  [18226] = {.lex_state = 0, .external_lex_state = 404},
  [18227] = {.lex_state = 0, .external_lex_state = 404},
  [18228] = {.lex_state = 0, .external_lex_state = 386},
  [18229] = {.lex_state = 57, .external_lex_state = 308},
  [18230] = {.lex_state = 0, .external_lex_state = 386},
  [18231] = {.lex_state = 0, .external_lex_state = 386},
  [18232] = {.lex_state = 0, .external_lex_state = 405},
  [18233] = {.lex_state = 58, .external_lex_state = 308},
  [18234] = {.lex_state = 0, .external_lex_state = 386},
  [18235] = {.lex_state = 0, .external_lex_state = 336},
  [18236] = {.lex_state = 0, .external_lex_state = 336},
  [18237] = {.lex_state = 0, .external_lex_state = 336},
  [18238] = {.lex_state = 0, .external_lex_state = 336},
  [18239] = {.lex_state = 0, .external_lex_state = 336},
  [18240] = {.lex_state = 0, .external_lex_state = 386},
  [18241] = {.lex_state = 0, .external_lex_state = 336},
  [18242] = {.lex_state = 0, .external_lex_state = 336},
  [18243] = {.lex_state = 0, .external_lex_state = 336},
  [18244] = {.lex_state = 0, .external_lex_state = 386},
  [18245] = {.lex_state = 0, .external_lex_state = 336},
  [18246] = {.lex_state = 0, .external_lex_state = 336},
  [18247] = {.lex_state = 55, .external_lex_state = 308},
  [18248] = {.lex_state = 0, .external_lex_state = 336},
  [18249] = {.lex_state = 55, .external_lex_state = 308},
  [18250] = {.lex_state = 57, .external_lex_state = 308},
  [18251] = {.lex_state = 58, .external_lex_state = 308},
  [18252] = {.lex_state = 0, .external_lex_state = 411},
  [18253] = {.lex_state = 0, .external_lex_state = 336},
  [18254] = {.lex_state = 1, .external_lex_state = 440},
  [18255] = {.lex_state = 1, .external_lex_state = 440},
  [18256] = {.lex_state = 57, .external_lex_state = 441},
  [18257] = {.lex_state = 0, .external_lex_state = 404},
  [18258] = {.lex_state = 0, .external_lex_state = 404},
  [18259] = {.lex_state = 0, .external_lex_state = 336},
  [18260] = {.lex_state = 58, .external_lex_state = 308},
  [18261] = {.lex_state = 0, .external_lex_state = 336},
  [18262] = {.lex_state = 0, .external_lex_state = 336},
  [18263] = {.lex_state = 0, .external_lex_state = 386},
  [18264] = {.lex_state = 0, .external_lex_state = 404},
  [18265] = {.lex_state = 0, .external_lex_state = 404},
  [18266] = {.lex_state = 57, .external_lex_state = 308},
  [18267] = {.lex_state = 0, .external_lex_state = 386},
  [18268] = {.lex_state = 0, .external_lex_state = 386},
  [18269] = {.lex_state = 0, .external_lex_state = 439},
  [18270] = {.lex_state = 0, .external_lex_state = 386},
  [18271] = {.lex_state = 55, .external_lex_state = 413},
  [18272] = {.lex_state = 0, .external_lex_state = 386},
  [18273] = {.lex_state = 0, .external_lex_state = 336},
  [18274] = {.lex_state = 0, .external_lex_state = 386},
  [18275] = {.lex_state = 1, .external_lex_state = 440},
  [18276] = {.lex_state = 1, .external_lex_state = 440},
  [18277] = {.lex_state = 0, .external_lex_state = 336},
  [18278] = {.lex_state = 1, .external_lex_state = 440},
  [18279] = {.lex_state = 0, .external_lex_state = 386},
  [18280] = {.lex_state = 1, .external_lex_state = 440},
  [18281] = {.lex_state = 0, .external_lex_state = 336},
  [18282] = {.lex_state = 57, .external_lex_state = 308},
  [18283] = {.lex_state = 58, .external_lex_state = 400},
  [18284] = {.lex_state = 55, .external_lex_state = 308},
  [18285] = {.lex_state = 0, .external_lex_state = 411},
  [18286] = {.lex_state = 0, .external_lex_state = 308},
  [18287] = {.lex_state = 1, .external_lex_state = 440},
  [18288] = {.lex_state = 0, .external_lex_state = 439},
  [18289] = {.lex_state = 0, .external_lex_state = 336},
  [18290] = {.lex_state = 0, .external_lex_state = 405},
  [18291] = {.lex_state = 57, .external_lex_state = 308},
  [18292] = {.lex_state = 1, .external_lex_state = 440},
  [18293] = {.lex_state = 0, .external_lex_state = 336},
  [18294] = {.lex_state = 0, .external_lex_state = 336},
  [18295] = {.lex_state = 0, .external_lex_state = 404},
  [18296] = {.lex_state = 0, .external_lex_state = 336},
  [18297] = {.lex_state = 0, .external_lex_state = 336},
  [18298] = {.lex_state = 0, .external_lex_state = 386},
  [18299] = {.lex_state = 0, .external_lex_state = 336},
  [18300] = {.lex_state = 0, .external_lex_state = 405},
  [18301] = {.lex_state = 0, .external_lex_state = 439},
  [18302] = {.lex_state = 0, .external_lex_state = 308},
  [18303] = {.lex_state = 0, .external_lex_state = 404},
  [18304] = {.lex_state = 1, .external_lex_state = 440},
  [18305] = {.lex_state = 0, .external_lex_state = 336},
  [18306] = {.lex_state = 58, .external_lex_state = 308},
  [18307] = {.lex_state = 1, .external_lex_state = 440},
  [18308] = {.lex_state = 0, .external_lex_state = 405},
  [18309] = {.lex_state = 0, .external_lex_state = 386},
  [18310] = {.lex_state = 0, .external_lex_state = 386},
  [18311] = {.lex_state = 0, .external_lex_state = 336},
  [18312] = {.lex_state = 0, .external_lex_state = 336},
  [18313] = {.lex_state = 0, .external_lex_state = 336},
  [18314] = {.lex_state = 0, .external_lex_state = 439},
  [18315] = {.lex_state = 58, .external_lex_state = 308},
  [18316] = {.lex_state = 0, .external_lex_state = 336},
  [18317] = {.lex_state = 0, .external_lex_state = 404},
  [18318] = {.lex_state = 0, .external_lex_state = 336},
  [18319] = {.lex_state = 0, .external_lex_state = 336},
  [18320] = {.lex_state = 0, .external_lex_state = 336},
  [18321] = {.lex_state = 0, .external_lex_state = 336},
  [18322] = {.lex_state = 0, .external_lex_state = 336},
  [18323] = {.lex_state = 0, .external_lex_state = 336},
  [18324] = {.lex_state = 0, .external_lex_state = 336},
  [18325] = {.lex_state = 0, .external_lex_state = 336},
  [18326] = {.lex_state = 0, .external_lex_state = 308},
  [18327] = {.lex_state = 58, .external_lex_state = 308},
  [18328] = {.lex_state = 0, .external_lex_state = 405},
  [18329] = {.lex_state = 57, .external_lex_state = 308},
  [18330] = {.lex_state = 0, .external_lex_state = 336},
  [18331] = {.lex_state = 0, .external_lex_state = 404},
  [18332] = {.lex_state = 0, .external_lex_state = 336},
  [18333] = {.lex_state = 0, .external_lex_state = 405},
  [18334] = {.lex_state = 0, .external_lex_state = 404},
  [18335] = {.lex_state = 0, .external_lex_state = 336},
  [18336] = {.lex_state = 0, .external_lex_state = 405},
  [18337] = {.lex_state = 58, .external_lex_state = 308},
  [18338] = {.lex_state = 0, .external_lex_state = 404},
  [18339] = {.lex_state = 0, .external_lex_state = 336},
  [18340] = {.lex_state = 0, .external_lex_state = 404},
  [18341] = {.lex_state = 0, .external_lex_state = 404},
  [18342] = {.lex_state = 0, .external_lex_state = 336},
  [18343] = {.lex_state = 0, .external_lex_state = 336},
  [18344] = {.lex_state = 0, .external_lex_state = 405},
  [18345] = {.lex_state = 0, .external_lex_state = 404},
  [18346] = {.lex_state = 0, .external_lex_state = 336},
  [18347] = {.lex_state = 0, .external_lex_state = 386},
  [18348] = {.lex_state = 58, .external_lex_state = 308},
  [18349] = {.lex_state = 0, .external_lex_state = 386},
  [18350] = {.lex_state = 0, .external_lex_state = 386},
  [18351] = {.lex_state = 0, .external_lex_state = 336},
  [18352] = {.lex_state = 0, .external_lex_state = 405},
  [18353] = {.lex_state = 0, .external_lex_state = 336},
  [18354] = {.lex_state = 0, .external_lex_state = 336},
  [18355] = {.lex_state = 0, .external_lex_state = 336},
  [18356] = {.lex_state = 0, .external_lex_state = 386},
  [18357] = {.lex_state = 0, .external_lex_state = 404},
  [18358] = {.lex_state = 0, .external_lex_state = 336},
  [18359] = {.lex_state = 0, .external_lex_state = 405},
  [18360] = {.lex_state = 0, .external_lex_state = 336},
  [18361] = {.lex_state = 0, .external_lex_state = 336},
  [18362] = {.lex_state = 0, .external_lex_state = 336},
  [18363] = {.lex_state = 0, .external_lex_state = 336},
  [18364] = {.lex_state = 0, .external_lex_state = 386},
  [18365] = {.lex_state = 0, .external_lex_state = 336},
  [18366] = {.lex_state = 0, .external_lex_state = 386},
  [18367] = {.lex_state = 0, .external_lex_state = 386},
  [18368] = {.lex_state = 0, .external_lex_state = 336},
  [18369] = {.lex_state = 0, .external_lex_state = 386},
  [18370] = {.lex_state = 58, .external_lex_state = 308},
  [18371] = {.lex_state = 0, .external_lex_state = 336},
  [18372] = {.lex_state = 0, .external_lex_state = 336},
  [18373] = {.lex_state = 0, .external_lex_state = 405},
  [18374] = {.lex_state = 1, .external_lex_state = 440},
  [18375] = {.lex_state = 57, .external_lex_state = 308},
  [18376] = {.lex_state = 0, .external_lex_state = 336},
  [18377] = {.lex_state = 1, .external_lex_state = 440},
  [18378] = {.lex_state = 1, .external_lex_state = 440},
  [18379] = {.lex_state = 0, .external_lex_state = 336},
  [18380] = {.lex_state = 0, .external_lex_state = 336},
  [18381] = {.lex_state = 0, .external_lex_state = 439},
  [18382] = {.lex_state = 0, .external_lex_state = 386},
  [18383] = {.lex_state = 55, .external_lex_state = 413},
  [18384] = {.lex_state = 0, .external_lex_state = 404},
  [18385] = {.lex_state = 0, .external_lex_state = 308},
  [18386] = {.lex_state = 0, .external_lex_state = 405},
  [18387] = {.lex_state = 0, .external_lex_state = 404},
  [18388] = {.lex_state = 0, .external_lex_state = 386},
  [18389] = {.lex_state = 0, .external_lex_state = 404},
  [18390] = {.lex_state = 0, .external_lex_state = 439},
  [18391] = {.lex_state = 0, .external_lex_state = 386},
  [18392] = {.lex_state = 0, .external_lex_state = 386},
  [18393] = {.lex_state = 0, .external_lex_state = 336},
  [18394] = {.lex_state = 0, .external_lex_state = 386},
  [18395] = {.lex_state = 0, .external_lex_state = 336},
  [18396] = {.lex_state = 58, .external_lex_state = 400},
  [18397] = {.lex_state = 1, .external_lex_state = 440},
  [18398] = {.lex_state = 0, .external_lex_state = 386},
  [18399] = {.lex_state = 1, .external_lex_state = 440},
  [18400] = {.lex_state = 0, .external_lex_state = 386},
  [18401] = {.lex_state = 1, .external_lex_state = 440},
  [18402] = {.lex_state = 0, .external_lex_state = 404},
  [18403] = {.lex_state = 0, .external_lex_state = 336},
  [18404] = {.lex_state = 0, .external_lex_state = 386},
  [18405] = {.lex_state = 1, .external_lex_state = 440},
  [18406] = {.lex_state = 58, .external_lex_state = 308},
  [18407] = {.lex_state = 0, .external_lex_state = 439},
  [18408] = {.lex_state = 1, .external_lex_state = 440},
  [18409] = {.lex_state = 58, .external_lex_state = 400},
  [18410] = {.lex_state = 55, .external_lex_state = 413},
  [18411] = {.lex_state = 0, .external_lex_state = 386},
  [18412] = {.lex_state = 0, .external_lex_state = 404},
  [18413] = {.lex_state = 58, .external_lex_state = 400},
  [18414] = {.lex_state = 0, .external_lex_state = 404},
  [18415] = {.lex_state = 0, .external_lex_state = 336},
  [18416] = {.lex_state = 58, .external_lex_state = 400},
  [18417] = {.lex_state = 0, .external_lex_state = 336},
  [18418] = {.lex_state = 0, .external_lex_state = 336},
  [18419] = {.lex_state = 0, .external_lex_state = 336},
  [18420] = {.lex_state = 0, .external_lex_state = 336},
  [18421] = {.lex_state = 0, .external_lex_state = 336},
  [18422] = {.lex_state = 0, .external_lex_state = 405},
  [18423] = {.lex_state = 1, .external_lex_state = 440},
  [18424] = {.lex_state = 0, .external_lex_state = 336},
  [18425] = {.lex_state = 58, .external_lex_state = 308},
  [18426] = {.lex_state = 0, .external_lex_state = 386},
  [18427] = {.lex_state = 0, .external_lex_state = 405},
  [18428] = {.lex_state = 0, .external_lex_state = 386},
  [18429] = {.lex_state = 0, .external_lex_state = 404},
  [18430] = {.lex_state = 0, .external_lex_state = 336},
  [18431] = {.lex_state = 0, .external_lex_state = 386},
  [18432] = {.lex_state = 0, .external_lex_state = 386},
  [18433] = {.lex_state = 0, .external_lex_state = 336},
  [18434] = {.lex_state = 0, .external_lex_state = 336},
  [18435] = {.lex_state = 58, .external_lex_state = 308},
  [18436] = {.lex_state = 0, .external_lex_state = 336},
  [18437] = {.lex_state = 0, .external_lex_state = 336},
  [18438] = {.lex_state = 0, .external_lex_state = 336},
  [18439] = {.lex_state = 0, .external_lex_state = 386},
  [18440] = {.lex_state = 0, .external_lex_state = 308},
  [18441] = {.lex_state = 0, .external_lex_state = 386},
  [18442] = {.lex_state = 0, .external_lex_state = 386},
  [18443] = {.lex_state = 0, .external_lex_state = 336},
  [18444] = {.lex_state = 57, .external_lex_state = 441},
  [18445] = {.lex_state = 0, .external_lex_state = 386},
  [18446] = {.lex_state = 0, .external_lex_state = 386},
  [18447] = {.lex_state = 0, .external_lex_state = 336},
  [18448] = {.lex_state = 0, .external_lex_state = 336},
  [18449] = {.lex_state = 0, .external_lex_state = 336},
  [18450] = {.lex_state = 0, .external_lex_state = 404},
  [18451] = {.lex_state = 0, .external_lex_state = 386},
  [18452] = {.lex_state = 0, .external_lex_state = 386},
  [18453] = {.lex_state = 0, .external_lex_state = 386},
  [18454] = {.lex_state = 0, .external_lex_state = 336},
  [18455] = {.lex_state = 0, .external_lex_state = 404},
  [18456] = {.lex_state = 58, .external_lex_state = 308},
  [18457] = {.lex_state = 0, .external_lex_state = 336},
  [18458] = {.lex_state = 0, .external_lex_state = 336},
  [18459] = {.lex_state = 55, .external_lex_state = 413},
  [18460] = {.lex_state = 0, .external_lex_state = 404},
  [18461] = {.lex_state = 0, .external_lex_state = 404},
  [18462] = {.lex_state = 0, .external_lex_state = 336},
  [18463] = {.lex_state = 0, .external_lex_state = 336},
  [18464] = {.lex_state = 0, .external_lex_state = 404},
  [18465] = {.lex_state = 0, .external_lex_state = 336},
  [18466] = {.lex_state = 57, .external_lex_state = 308},
  [18467] = {.lex_state = 0, .external_lex_state = 386},
  [18468] = {.lex_state = 0, .external_lex_state = 386},
  [18469] = {.lex_state = 0, .external_lex_state = 336},
  [18470] = {.lex_state = 0, .external_lex_state = 336},
  [18471] = {.lex_state = 0, .external_lex_state = 336},
  [18472] = {.lex_state = 58, .external_lex_state = 308},
  [18473] = {.lex_state = 0, .external_lex_state = 336},
  [18474] = {.lex_state = 1, .external_lex_state = 440},
  [18475] = {.lex_state = 0, .external_lex_state = 336},
  [18476] = {.lex_state = 0, .external_lex_state = 336},
  [18477] = {.lex_state = 0, .external_lex_state = 336},
  [18478] = {.lex_state = 0, .external_lex_state = 386},
  [18479] = {.lex_state = 0, .external_lex_state = 404},
  [18480] = {.lex_state = 0, .external_lex_state = 404},
  [18481] = {.lex_state = 0, .external_lex_state = 336},
  [18482] = {.lex_state = 0, .external_lex_state = 336},
  [18483] = {.lex_state = 0, .external_lex_state = 386},
  [18484] = {.lex_state = 1, .external_lex_state = 440},
  [18485] = {.lex_state = 0, .external_lex_state = 386},
  [18486] = {.lex_state = 0, .external_lex_state = 386},
  [18487] = {.lex_state = 0, .external_lex_state = 336},
  [18488] = {.lex_state = 0, .external_lex_state = 336},
  [18489] = {.lex_state = 0, .external_lex_state = 386},
  [18490] = {.lex_state = 0, .external_lex_state = 439},
  [18491] = {.lex_state = 57, .external_lex_state = 441},
  [18492] = {.lex_state = 0, .external_lex_state = 336},
  [18493] = {.lex_state = 0, .external_lex_state = 336},
  [18494] = {.lex_state = 0, .external_lex_state = 308},
  [18495] = {.lex_state = 0, .external_lex_state = 404},
  [18496] = {.lex_state = 58, .external_lex_state = 308},
  [18497] = {.lex_state = 0, .external_lex_state = 405},
  [18498] = {.lex_state = 1, .external_lex_state = 440},
  [18499] = {.lex_state = 0, .external_lex_state = 336},
  [18500] = {.lex_state = 0, .external_lex_state = 336},
  [18501] = {.lex_state = 0, .external_lex_state = 336},
  [18502] = {.lex_state = 0, .external_lex_state = 336},
  [18503] = {.lex_state = 0, .external_lex_state = 386},
  [18504] = {.lex_state = 0, .external_lex_state = 336},
  [18505] = {.lex_state = 0, .external_lex_state = 336},
  [18506] = {.lex_state = 58, .external_lex_state = 308},
  [18507] = {.lex_state = 0, .external_lex_state = 336},
  [18508] = {.lex_state = 58, .external_lex_state = 308},
  [18509] = {.lex_state = 1, .external_lex_state = 440},
  [18510] = {.lex_state = 0, .external_lex_state = 336},
  [18511] = {.lex_state = 0, .external_lex_state = 336},
  [18512] = {.lex_state = 0, .external_lex_state = 336},
  [18513] = {.lex_state = 0, .external_lex_state = 336},
  [18514] = {.lex_state = 0, .external_lex_state = 336},
  [18515] = {.lex_state = 55, .external_lex_state = 413},
  [18516] = {.lex_state = 1, .external_lex_state = 440},
  [18517] = {.lex_state = 0, .external_lex_state = 386},
  [18518] = {.lex_state = 1, .external_lex_state = 440},
  [18519] = {.lex_state = 0, .external_lex_state = 386},
  [18520] = {.lex_state = 0, .external_lex_state = 404},
  [18521] = {.lex_state = 0, .external_lex_state = 336},
  [18522] = {.lex_state = 0, .external_lex_state = 336},
  [18523] = {.lex_state = 0, .external_lex_state = 336},
  [18524] = {.lex_state = 0, .external_lex_state = 404},
  [18525] = {.lex_state = 0, .external_lex_state = 404},
  [18526] = {.lex_state = 0, .external_lex_state = 439},
  [18527] = {.lex_state = 0, .external_lex_state = 386},
  [18528] = {.lex_state = 0, .external_lex_state = 386},
  [18529] = {.lex_state = 0, .external_lex_state = 386},
  [18530] = {.lex_state = 0, .external_lex_state = 386},
  [18531] = {.lex_state = 0, .external_lex_state = 336},
  [18532] = {.lex_state = 0, .external_lex_state = 336},
  [18533] = {.lex_state = 0, .external_lex_state = 404},
  [18534] = {.lex_state = 0, .external_lex_state = 439},
  [18535] = {.lex_state = 0, .external_lex_state = 336},
  [18536] = {.lex_state = 0, .external_lex_state = 386},
  [18537] = {.lex_state = 55, .external_lex_state = 308},
  [18538] = {.lex_state = 55, .external_lex_state = 308},
  [18539] = {.lex_state = 0, .external_lex_state = 308},
  [18540] = {.lex_state = 55, .external_lex_state = 308},
  [18541] = {.lex_state = 58, .external_lex_state = 308},
  [18542] = {.lex_state = 1, .external_lex_state = 440},
  [18543] = {.lex_state = 0, .external_lex_state = 336},
  [18544] = {.lex_state = 58, .external_lex_state = 308},
  [18545] = {.lex_state = 0, .external_lex_state = 336},
  [18546] = {.lex_state = 0, .external_lex_state = 336},
  [18547] = {.lex_state = 0, .external_lex_state = 336},
  [18548] = {.lex_state = 55, .external_lex_state = 413},
  [18549] = {.lex_state = 0, .external_lex_state = 336},
  [18550] = {.lex_state = 0, .external_lex_state = 336},
  [18551] = {.lex_state = 0, .external_lex_state = 336},
  [18552] = {.lex_state = 0, .external_lex_state = 404},
  [18553] = {.lex_state = 0, .external_lex_state = 336},
  [18554] = {.lex_state = 0, .external_lex_state = 336},
  [18555] = {.lex_state = 0, .external_lex_state = 336},
  [18556] = {.lex_state = 0, .external_lex_state = 336},
  [18557] = {.lex_state = 0, .external_lex_state = 336},
  [18558] = {.lex_state = 0, .external_lex_state = 336},
  [18559] = {.lex_state = 1, .external_lex_state = 440},
  [18560] = {.lex_state = 0, .external_lex_state = 308},
  [18561] = {.lex_state = 1, .external_lex_state = 440},
  [18562] = {.lex_state = 0, .external_lex_state = 367},
  [18563] = {.lex_state = 55, .external_lex_state = 308},
  [18564] = {.lex_state = 55, .external_lex_state = 308},
  [18565] = {.lex_state = 55, .external_lex_state = 308},
  [18566] = {.lex_state = 0, .external_lex_state = 336},
  [18567] = {.lex_state = 0, .external_lex_state = 336},
  [18568] = {.lex_state = 0, .external_lex_state = 404},
  [18569] = {.lex_state = 0, .external_lex_state = 404},
  [18570] = {.lex_state = 55, .external_lex_state = 308},
  [18571] = {.lex_state = 0, .external_lex_state = 336},
  [18572] = {.lex_state = 0, .external_lex_state = 336},
  [18573] = {.lex_state = 0, .external_lex_state = 336},
  [18574] = {.lex_state = 0, .external_lex_state = 404},
  [18575] = {.lex_state = 58, .external_lex_state = 308},
  [18576] = {.lex_state = 58, .external_lex_state = 400},
  [18577] = {.lex_state = 0, .external_lex_state = 336},
  [18578] = {.lex_state = 58, .external_lex_state = 400},
  [18579] = {.lex_state = 0, .external_lex_state = 336},
  [18580] = {.lex_state = 0, .external_lex_state = 386},
  [18581] = {.lex_state = 0, .external_lex_state = 336},
  [18582] = {.lex_state = 1, .external_lex_state = 440},
  [18583] = {.lex_state = 0, .external_lex_state = 404},
  [18584] = {.lex_state = 0, .external_lex_state = 336},
  [18585] = {.lex_state = 0, .external_lex_state = 404},
  [18586] = {.lex_state = 0, .external_lex_state = 336},
  [18587] = {.lex_state = 0, .external_lex_state = 336},
  [18588] = {.lex_state = 0, .external_lex_state = 386},
  [18589] = {.lex_state = 0, .external_lex_state = 439},
  [18590] = {.lex_state = 0, .external_lex_state = 386},
  [18591] = {.lex_state = 0, .external_lex_state = 336},
  [18592] = {.lex_state = 0, .external_lex_state = 308},
  [18593] = {.lex_state = 55, .external_lex_state = 308},
  [18594] = {.lex_state = 58, .external_lex_state = 308},
  [18595] = {.lex_state = 55, .external_lex_state = 308},
  [18596] = {.lex_state = 0, .external_lex_state = 336},
  [18597] = {.lex_state = 0, .external_lex_state = 336},
  [18598] = {.lex_state = 0, .external_lex_state = 405},
  [18599] = {.lex_state = 0, .external_lex_state = 386},
  [18600] = {.lex_state = 0, .external_lex_state = 336},
  [18601] = {.lex_state = 57, .external_lex_state = 308},
  [18602] = {.lex_state = 0, .external_lex_state = 336},
  [18603] = {.lex_state = 55, .external_lex_state = 308},
  [18604] = {.lex_state = 0, .external_lex_state = 404},
  [18605] = {.lex_state = 58, .external_lex_state = 390},
  [18606] = {.lex_state = 0, .external_lex_state = 308},
  [18607] = {.lex_state = 0, .external_lex_state = 405},
  [18608] = {.lex_state = 55, .external_lex_state = 308},
  [18609] = {.lex_state = 0, .external_lex_state = 404},
  [18610] = {.lex_state = 0, .external_lex_state = 336},
  [18611] = {.lex_state = 0, .external_lex_state = 336},
  [18612] = {.lex_state = 0, .external_lex_state = 308},
  [18613] = {.lex_state = 0, .external_lex_state = 405},
  [18614] = {.lex_state = 1, .external_lex_state = 440},
  [18615] = {.lex_state = 0, .external_lex_state = 336},
  [18616] = {.lex_state = 58, .external_lex_state = 308},
  [18617] = {.lex_state = 0, .external_lex_state = 336},
  [18618] = {.lex_state = 0, .external_lex_state = 336},
  [18619] = {.lex_state = 0, .external_lex_state = 336},
  [18620] = {.lex_state = 0, .external_lex_state = 336},
  [18621] = {.lex_state = 0, .external_lex_state = 405},
  [18622] = {.lex_state = 0, .external_lex_state = 336},
  [18623] = {.lex_state = 58, .external_lex_state = 308},
  [18624] = {.lex_state = 0, .external_lex_state = 336},
  [18625] = {.lex_state = 0, .external_lex_state = 336},
  [18626] = {.lex_state = 1, .external_lex_state = 440},
  [18627] = {.lex_state = 0, .external_lex_state = 308},
  [18628] = {.lex_state = 0, .external_lex_state = 405},
  [18629] = {.lex_state = 0, .external_lex_state = 405},
  [18630] = {.lex_state = 55, .external_lex_state = 308},
  [18631] = {.lex_state = 0, .external_lex_state = 405},
  [18632] = {.lex_state = 55, .external_lex_state = 308},
  [18633] = {.lex_state = 55, .external_lex_state = 308},
  [18634] = {.lex_state = 0, .external_lex_state = 405},
  [18635] = {.lex_state = 1, .external_lex_state = 440},
  [18636] = {.lex_state = 0, .external_lex_state = 348},
  [18637] = {.lex_state = 1, .external_lex_state = 440},
  [18638] = {.lex_state = 0, .external_lex_state = 336},
  [18639] = {.lex_state = 0, .external_lex_state = 386},
  [18640] = {.lex_state = 0, .external_lex_state = 336},
  [18641] = {.lex_state = 0, .external_lex_state = 405},
  [18642] = {.lex_state = 0, .external_lex_state = 404},
  [18643] = {.lex_state = 55, .external_lex_state = 308},
  [18644] = {.lex_state = 0, .external_lex_state = 404},
  [18645] = {.lex_state = 0, .external_lex_state = 439},
  [18646] = {.lex_state = 0, .external_lex_state = 405},
  [18647] = {.lex_state = 0, .external_lex_state = 386},
  [18648] = {.lex_state = 0, .external_lex_state = 386},
  [18649] = {.lex_state = 0, .external_lex_state = 308},
  [18650] = {.lex_state = 0, .external_lex_state = 308},
  [18651] = {.lex_state = 0, .external_lex_state = 404},
  [18652] = {.lex_state = 0, .external_lex_state = 404},
  [18653] = {.lex_state = 55, .external_lex_state = 308},
  [18654] = {.lex_state = 0, .external_lex_state = 336},
  [18655] = {.lex_state = 0, .external_lex_state = 405},
  [18656] = {.lex_state = 0, .external_lex_state = 405},
  [18657] = {.lex_state = 0, .external_lex_state = 336},
  [18658] = {.lex_state = 0, .external_lex_state = 308},
  [18659] = {.lex_state = 58, .external_lex_state = 308},
  [18660] = {.lex_state = 0, .external_lex_state = 336},
  [18661] = {.lex_state = 1, .external_lex_state = 440},
  [18662] = {.lex_state = 0, .external_lex_state = 336},
  [18663] = {.lex_state = 58, .external_lex_state = 308},
  [18664] = {.lex_state = 0, .external_lex_state = 336},
  [18665] = {.lex_state = 0, .external_lex_state = 404},
  [18666] = {.lex_state = 1, .external_lex_state = 440},
  [18667] = {.lex_state = 0, .external_lex_state = 405},
  [18668] = {.lex_state = 0, .external_lex_state = 336},
  [18669] = {.lex_state = 0, .external_lex_state = 336},
  [18670] = {.lex_state = 0, .external_lex_state = 436},
  [18671] = {.lex_state = 0, .external_lex_state = 336},
  [18672] = {.lex_state = 55, .external_lex_state = 308},
  [18673] = {.lex_state = 0, .external_lex_state = 405},
  [18674] = {.lex_state = 0, .external_lex_state = 439},
  [18675] = {.lex_state = 0, .external_lex_state = 336},
  [18676] = {.lex_state = 0, .external_lex_state = 336},
  [18677] = {.lex_state = 0, .external_lex_state = 336},
  [18678] = {.lex_state = 0, .external_lex_state = 336},
  [18679] = {.lex_state = 0, .external_lex_state = 405},
  [18680] = {.lex_state = 0, .external_lex_state = 336},
  [18681] = {.lex_state = 0, .external_lex_state = 405},
  [18682] = {.lex_state = 0, .external_lex_state = 336},
  [18683] = {.lex_state = 0, .external_lex_state = 405},
  [18684] = {.lex_state = 0, .external_lex_state = 386},
  [18685] = {.lex_state = 0, .external_lex_state = 386},
  [18686] = {.lex_state = 1, .external_lex_state = 440},
  [18687] = {.lex_state = 1, .external_lex_state = 440},
  [18688] = {.lex_state = 0, .external_lex_state = 404},
  [18689] = {.lex_state = 1, .external_lex_state = 440},
  [18690] = {.lex_state = 0, .external_lex_state = 405},
  [18691] = {.lex_state = 1, .external_lex_state = 440},
  [18692] = {.lex_state = 0, .external_lex_state = 336},
  [18693] = {.lex_state = 0, .external_lex_state = 336},
  [18694] = {.lex_state = 58, .external_lex_state = 308},
  [18695] = {.lex_state = 0, .external_lex_state = 336},
  [18696] = {.lex_state = 0, .external_lex_state = 336},
  [18697] = {.lex_state = 0, .external_lex_state = 439},
  [18698] = {.lex_state = 0, .external_lex_state = 386},
  [18699] = {.lex_state = 0, .external_lex_state = 405},
  [18700] = {.lex_state = 0, .external_lex_state = 336},
  [18701] = {.lex_state = 0, .external_lex_state = 308},
  [18702] = {.lex_state = 0, .external_lex_state = 404},
  [18703] = {.lex_state = 0, .external_lex_state = 336},
  [18704] = {.lex_state = 0, .external_lex_state = 308},
  [18705] = {.lex_state = 0, .external_lex_state = 308},
  [18706] = {.lex_state = 0, .external_lex_state = 308},
  [18707] = {.lex_state = 0, .external_lex_state = 405},
  [18708] = {.lex_state = 0, .external_lex_state = 308},
  [18709] = {.lex_state = 0, .external_lex_state = 405},
  [18710] = {.lex_state = 55, .external_lex_state = 308},
  [18711] = {.lex_state = 55, .external_lex_state = 308},
  [18712] = {.lex_state = 55, .external_lex_state = 308},
  [18713] = {.lex_state = 0, .external_lex_state = 404},
  [18714] = {.lex_state = 0, .external_lex_state = 336},
  [18715] = {.lex_state = 0, .external_lex_state = 336},
  [18716] = {.lex_state = 0, .external_lex_state = 336},
  [18717] = {.lex_state = 0, .external_lex_state = 336},
  [18718] = {.lex_state = 0, .external_lex_state = 405},
  [18719] = {.lex_state = 0, .external_lex_state = 336},
  [18720] = {.lex_state = 0, .external_lex_state = 405},
  [18721] = {.lex_state = 0, .external_lex_state = 348},
  [18722] = {.lex_state = 55, .external_lex_state = 308},
  [18723] = {.lex_state = 0, .external_lex_state = 404},
  [18724] = {.lex_state = 1, .external_lex_state = 440},
  [18725] = {.lex_state = 0, .external_lex_state = 336},
  [18726] = {.lex_state = 0, .external_lex_state = 405},
  [18727] = {.lex_state = 0, .external_lex_state = 308},
  [18728] = {.lex_state = 55, .external_lex_state = 308},
  [18729] = {.lex_state = 0, .external_lex_state = 336},
  [18730] = {.lex_state = 0, .external_lex_state = 336},
  [18731] = {.lex_state = 58, .external_lex_state = 308},
  [18732] = {.lex_state = 0, .external_lex_state = 405},
  [18733] = {.lex_state = 58, .external_lex_state = 308},
  [18734] = {.lex_state = 0, .external_lex_state = 336},
  [18735] = {.lex_state = 0, .external_lex_state = 405},
  [18736] = {.lex_state = 0, .external_lex_state = 308},
  [18737] = {.lex_state = 0, .external_lex_state = 336},
  [18738] = {.lex_state = 0, .external_lex_state = 336},
  [18739] = {.lex_state = 0, .external_lex_state = 404},
  [18740] = {.lex_state = 0, .external_lex_state = 336},
  [18741] = {.lex_state = 0, .external_lex_state = 404},
  [18742] = {.lex_state = 0, .external_lex_state = 336},
  [18743] = {.lex_state = 0, .external_lex_state = 336},
  [18744] = {.lex_state = 0, .external_lex_state = 336},
  [18745] = {.lex_state = 0, .external_lex_state = 336},
  [18746] = {.lex_state = 0, .external_lex_state = 404},
  [18747] = {.lex_state = 0, .external_lex_state = 404},
  [18748] = {.lex_state = 0, .external_lex_state = 386},
  [18749] = {.lex_state = 0, .external_lex_state = 336},
  [18750] = {.lex_state = 0, .external_lex_state = 336},
  [18751] = {.lex_state = 0, .external_lex_state = 336},
  [18752] = {.lex_state = 0, .external_lex_state = 336},
  [18753] = {.lex_state = 0, .external_lex_state = 405},
  [18754] = {.lex_state = 1, .external_lex_state = 440},
  [18755] = {.lex_state = 0, .external_lex_state = 367},
  [18756] = {.lex_state = 1, .external_lex_state = 440},
  [18757] = {.lex_state = 0, .external_lex_state = 405},
  [18758] = {.lex_state = 0, .external_lex_state = 336},
  [18759] = {.lex_state = 58, .external_lex_state = 308},
  [18760] = {.lex_state = 58, .external_lex_state = 308},
  [18761] = {.lex_state = 0, .external_lex_state = 336},
  [18762] = {.lex_state = 0, .external_lex_state = 336},
  [18763] = {.lex_state = 0, .external_lex_state = 405},
  [18764] = {.lex_state = 0, .external_lex_state = 439},
  [18765] = {.lex_state = 1, .external_lex_state = 440},
  [18766] = {.lex_state = 0, .external_lex_state = 336},
  [18767] = {.lex_state = 0, .external_lex_state = 336},
  [18768] = {.lex_state = 0, .external_lex_state = 404},
  [18769] = {.lex_state = 0, .external_lex_state = 405},
  [18770] = {.lex_state = 0, .external_lex_state = 336},
  [18771] = {.lex_state = 0, .external_lex_state = 404},
  [18772] = {.lex_state = 0, .external_lex_state = 336},
  [18773] = {.lex_state = 0, .external_lex_state = 336},
  [18774] = {.lex_state = 0, .external_lex_state = 336},
  [18775] = {.lex_state = 0, .external_lex_state = 405},
  [18776] = {.lex_state = 57, .external_lex_state = 308},
  [18777] = {.lex_state = 0, .external_lex_state = 404},
  [18778] = {.lex_state = 0, .external_lex_state = 336},
  [18779] = {.lex_state = 0, .external_lex_state = 336},
  [18780] = {.lex_state = 1, .external_lex_state = 440},
  [18781] = {.lex_state = 0, .external_lex_state = 336},
  [18782] = {.lex_state = 58, .external_lex_state = 308},
  [18783] = {.lex_state = 0, .external_lex_state = 336},
  [18784] = {.lex_state = 0, .external_lex_state = 308},
  [18785] = {.lex_state = 0, .external_lex_state = 336},
  [18786] = {.lex_state = 0, .external_lex_state = 405},
  [18787] = {.lex_state = 0, .external_lex_state = 336},
  [18788] = {.lex_state = 1, .external_lex_state = 440},
  [18789] = {.lex_state = 0, .external_lex_state = 405},
  [18790] = {.lex_state = 1, .external_lex_state = 440},
  [18791] = {.lex_state = 1, .external_lex_state = 440},
  [18792] = {.lex_state = 1, .external_lex_state = 440},
  [18793] = {.lex_state = 0, .external_lex_state = 386},
  [18794] = {.lex_state = 0, .external_lex_state = 336},
  [18795] = {.lex_state = 0, .external_lex_state = 336},
  [18796] = {.lex_state = 1, .external_lex_state = 440},
  [18797] = {.lex_state = 0, .external_lex_state = 336},
  [18798] = {.lex_state = 0, .external_lex_state = 405},
  [18799] = {.lex_state = 0, .external_lex_state = 386},
  [18800] = {.lex_state = 0, .external_lex_state = 404},
  [18801] = {.lex_state = 0, .external_lex_state = 404},
  [18802] = {.lex_state = 0, .external_lex_state = 336},
  [18803] = {.lex_state = 0, .external_lex_state = 336},
  [18804] = {.lex_state = 0, .external_lex_state = 336},
  [18805] = {.lex_state = 0, .external_lex_state = 336},
  [18806] = {.lex_state = 0, .external_lex_state = 336},
  [18807] = {.lex_state = 0, .external_lex_state = 404},
  [18808] = {.lex_state = 1, .external_lex_state = 440},
  [18809] = {.lex_state = 0, .external_lex_state = 336},
  [18810] = {.lex_state = 0, .external_lex_state = 439},
  [18811] = {.lex_state = 0, .external_lex_state = 336},
  [18812] = {.lex_state = 0, .external_lex_state = 336},
  [18813] = {.lex_state = 58, .external_lex_state = 308},
  [18814] = {.lex_state = 1, .external_lex_state = 440},
  [18815] = {.lex_state = 0, .external_lex_state = 336},
  [18816] = {.lex_state = 1, .external_lex_state = 440},
  [18817] = {.lex_state = 0, .external_lex_state = 308},
  [18818] = {.lex_state = 0, .external_lex_state = 404},
  [18819] = {.lex_state = 0, .external_lex_state = 336},
  [18820] = {.lex_state = 0, .external_lex_state = 336},
  [18821] = {.lex_state = 0, .external_lex_state = 404},
  [18822] = {.lex_state = 0, .external_lex_state = 336},
  [18823] = {.lex_state = 0, .external_lex_state = 336},
  [18824] = {.lex_state = 0, .external_lex_state = 336},
  [18825] = {.lex_state = 0, .external_lex_state = 336},
  [18826] = {.lex_state = 0, .external_lex_state = 336},
  [18827] = {.lex_state = 1, .external_lex_state = 440},
  [18828] = {.lex_state = 0, .external_lex_state = 405},
  [18829] = {.lex_state = 0, .external_lex_state = 436},
  [18830] = {.lex_state = 0, .external_lex_state = 404},
  [18831] = {.lex_state = 1, .external_lex_state = 440},
  [18832] = {.lex_state = 1, .external_lex_state = 440},
  [18833] = {.lex_state = 1, .external_lex_state = 440},
  [18834] = {.lex_state = 0, .external_lex_state = 336},
  [18835] = {.lex_state = 1, .external_lex_state = 440},
  [18836] = {.lex_state = 0, .external_lex_state = 404},
  [18837] = {.lex_state = 0, .external_lex_state = 336},
  [18838] = {.lex_state = 0, .external_lex_state = 336},
  [18839] = {.lex_state = 0, .external_lex_state = 336},
  [18840] = {.lex_state = 0, .external_lex_state = 336},
  [18841] = {.lex_state = 0, .external_lex_state = 336},
  [18842] = {.lex_state = 0, .external_lex_state = 336},
  [18843] = {.lex_state = 1, .external_lex_state = 440},
  [18844] = {.lex_state = 1, .external_lex_state = 440},
  [18845] = {.lex_state = 1, .external_lex_state = 440},
  [18846] = {.lex_state = 0, .external_lex_state = 336},
  [18847] = {.lex_state = 1, .external_lex_state = 440},
  [18848] = {.lex_state = 58, .external_lex_state = 308},
  [18849] = {.lex_state = 0, .external_lex_state = 336},
  [18850] = {.lex_state = 0, .external_lex_state = 336},
  [18851] = {.lex_state = 0, .external_lex_state = 336},
  [18852] = {.lex_state = 0, .external_lex_state = 404},
  [18853] = {.lex_state = 0, .external_lex_state = 336},
  [18854] = {.lex_state = 0, .external_lex_state = 336},
  [18855] = {.lex_state = 0, .external_lex_state = 336},
  [18856] = {.lex_state = 0, .external_lex_state = 405},
  [18857] = {.lex_state = 0, .external_lex_state = 336},
  [18858] = {.lex_state = 0, .external_lex_state = 336},
  [18859] = {.lex_state = 0, .external_lex_state = 336},
  [18860] = {.lex_state = 0, .external_lex_state = 336},
  [18861] = {.lex_state = 0, .external_lex_state = 336},
  [18862] = {.lex_state = 0, .external_lex_state = 404},
  [18863] = {.lex_state = 1, .external_lex_state = 440},
  [18864] = {.lex_state = 0, .external_lex_state = 336},
  [18865] = {.lex_state = 0, .external_lex_state = 439},
  [18866] = {.lex_state = 0, .external_lex_state = 405},
  [18867] = {.lex_state = 0, .external_lex_state = 336},
  [18868] = {.lex_state = 1, .external_lex_state = 440},
  [18869] = {.lex_state = 58, .external_lex_state = 308},
  [18870] = {.lex_state = 1, .external_lex_state = 440},
  [18871] = {.lex_state = 0, .external_lex_state = 336},
  [18872] = {.lex_state = 0, .external_lex_state = 405},
  [18873] = {.lex_state = 1, .external_lex_state = 440},
  [18874] = {.lex_state = 0, .external_lex_state = 336},
  [18875] = {.lex_state = 1, .external_lex_state = 440},
  [18876] = {.lex_state = 0, .external_lex_state = 404},
  [18877] = {.lex_state = 0, .external_lex_state = 336},
  [18878] = {.lex_state = 0, .external_lex_state = 336},
  [18879] = {.lex_state = 0, .external_lex_state = 404},
  [18880] = {.lex_state = 0, .external_lex_state = 405},
  [18881] = {.lex_state = 0, .external_lex_state = 404},
  [18882] = {.lex_state = 0, .external_lex_state = 386},
  [18883] = {.lex_state = 0, .external_lex_state = 439},
  [18884] = {.lex_state = 0, .external_lex_state = 336},
  [18885] = {.lex_state = 0, .external_lex_state = 336},
  [18886] = {.lex_state = 0, .external_lex_state = 336},
  [18887] = {.lex_state = 0, .external_lex_state = 336},
  [18888] = {.lex_state = 0, .external_lex_state = 336},
  [18889] = {.lex_state = 0, .external_lex_state = 336},
  [18890] = {.lex_state = 0, .external_lex_state = 404},
  [18891] = {.lex_state = 1, .external_lex_state = 440},
  [18892] = {.lex_state = 0, .external_lex_state = 405},
  [18893] = {.lex_state = 0, .external_lex_state = 404},
  [18894] = {.lex_state = 1, .external_lex_state = 440},
  [18895] = {.lex_state = 0, .external_lex_state = 404},
  [18896] = {.lex_state = 1, .external_lex_state = 440},
  [18897] = {.lex_state = 0, .external_lex_state = 336},
  [18898] = {.lex_state = 0, .external_lex_state = 405},
  [18899] = {.lex_state = 1, .external_lex_state = 440},
  [18900] = {.lex_state = 0, .external_lex_state = 336},
  [18901] = {.lex_state = 58, .external_lex_state = 308},
  [18902] = {.lex_state = 0, .external_lex_state = 336},
  [18903] = {.lex_state = 0, .external_lex_state = 439},
  [18904] = {.lex_state = 0, .external_lex_state = 405},
  [18905] = {.lex_state = 0, .external_lex_state = 404},
  [18906] = {.lex_state = 0, .external_lex_state = 336},
  [18907] = {.lex_state = 0, .external_lex_state = 336},
  [18908] = {.lex_state = 0, .external_lex_state = 336},
  [18909] = {.lex_state = 0, .external_lex_state = 336},
  [18910] = {.lex_state = 0, .external_lex_state = 336},
  [18911] = {.lex_state = 0, .external_lex_state = 336},
  [18912] = {.lex_state = 0, .external_lex_state = 336},
  [18913] = {.lex_state = 0, .external_lex_state = 336},
  [18914] = {.lex_state = 0, .external_lex_state = 336},
  [18915] = {.lex_state = 1, .external_lex_state = 440},
  [18916] = {.lex_state = 0, .external_lex_state = 336},
  [18917] = {.lex_state = 0, .external_lex_state = 367},
  [18918] = {.lex_state = 0, .external_lex_state = 405},
  [18919] = {.lex_state = 58, .external_lex_state = 308},
  [18920] = {.lex_state = 0, .external_lex_state = 405},
  [18921] = {.lex_state = 0, .external_lex_state = 405},
  [18922] = {.lex_state = 0, .external_lex_state = 386},
  [18923] = {.lex_state = 58, .external_lex_state = 308},
  [18924] = {.lex_state = 1, .external_lex_state = 440},
  [18925] = {.lex_state = 0, .external_lex_state = 336},
  [18926] = {.lex_state = 0, .external_lex_state = 404},
  [18927] = {.lex_state = 0, .external_lex_state = 336},
  [18928] = {.lex_state = 0, .external_lex_state = 405},
  [18929] = {.lex_state = 1, .external_lex_state = 440},
  [18930] = {.lex_state = 0, .external_lex_state = 336},
  [18931] = {.lex_state = 1, .external_lex_state = 440},
  [18932] = {.lex_state = 58, .external_lex_state = 308},
  [18933] = {.lex_state = 0, .external_lex_state = 405},
  [18934] = {.lex_state = 0, .external_lex_state = 336},
  [18935] = {.lex_state = 0, .external_lex_state = 336},
  [18936] = {.lex_state = 0, .external_lex_state = 386},
  [18937] = {.lex_state = 0, .external_lex_state = 405},
  [18938] = {.lex_state = 0, .external_lex_state = 336},
  [18939] = {.lex_state = 0, .external_lex_state = 405},
  [18940] = {.lex_state = 0, .external_lex_state = 404},
  [18941] = {.lex_state = 0, .external_lex_state = 404},
  [18942] = {.lex_state = 0, .external_lex_state = 336},
  [18943] = {.lex_state = 0, .external_lex_state = 336},
  [18944] = {.lex_state = 0, .external_lex_state = 336},
  [18945] = {.lex_state = 0, .external_lex_state = 336},
  [18946] = {.lex_state = 0, .external_lex_state = 404},
  [18947] = {.lex_state = 1, .external_lex_state = 440},
  [18948] = {.lex_state = 0, .external_lex_state = 404},
  [18949] = {.lex_state = 0, .external_lex_state = 405},
  [18950] = {.lex_state = 1, .external_lex_state = 440},
  [18951] = {.lex_state = 1, .external_lex_state = 440},
  [18952] = {.lex_state = 0, .external_lex_state = 405},
  [18953] = {.lex_state = 0, .external_lex_state = 336},
  [18954] = {.lex_state = 0, .external_lex_state = 439},
  [18955] = {.lex_state = 0, .external_lex_state = 405},
  [18956] = {.lex_state = 0, .external_lex_state = 386},
  [18957] = {.lex_state = 0, .external_lex_state = 336},
  [18958] = {.lex_state = 0, .external_lex_state = 386},
  [18959] = {.lex_state = 0, .external_lex_state = 336},
  [18960] = {.lex_state = 0, .external_lex_state = 336},
  [18961] = {.lex_state = 0, .external_lex_state = 405},
  [18962] = {.lex_state = 0, .external_lex_state = 336},
  [18963] = {.lex_state = 0, .external_lex_state = 336},
  [18964] = {.lex_state = 0, .external_lex_state = 336},
  [18965] = {.lex_state = 0, .external_lex_state = 404},
  [18966] = {.lex_state = 0, .external_lex_state = 336},
  [18967] = {.lex_state = 1, .external_lex_state = 440},
  [18968] = {.lex_state = 0, .external_lex_state = 336},
  [18969] = {.lex_state = 1, .external_lex_state = 440},
  [18970] = {.lex_state = 0, .external_lex_state = 336},
  [18971] = {.lex_state = 0, .external_lex_state = 336},
  [18972] = {.lex_state = 1, .external_lex_state = 440},
  [18973] = {.lex_state = 1, .external_lex_state = 440},
  [18974] = {.lex_state = 1, .external_lex_state = 440},
  [18975] = {.lex_state = 0, .external_lex_state = 348},
  [18976] = {.lex_state = 0, .external_lex_state = 404},
  [18977] = {.lex_state = 0, .external_lex_state = 336},
  [18978] = {.lex_state = 0, .external_lex_state = 336},
  [18979] = {.lex_state = 0, .external_lex_state = 336},
  [18980] = {.lex_state = 0, .external_lex_state = 336},
  [18981] = {.lex_state = 1, .external_lex_state = 440},
  [18982] = {.lex_state = 1, .external_lex_state = 440},
  [18983] = {.lex_state = 1, .external_lex_state = 440},
  [18984] = {.lex_state = 0, .external_lex_state = 336},
  [18985] = {.lex_state = 1, .external_lex_state = 440},
  [18986] = {.lex_state = 0, .external_lex_state = 336},
  [18987] = {.lex_state = 0, .external_lex_state = 336},
  [18988] = {.lex_state = 0, .external_lex_state = 386},
  [18989] = {.lex_state = 0, .external_lex_state = 336},
  [18990] = {.lex_state = 0, .external_lex_state = 336},
  [18991] = {.lex_state = 0, .external_lex_state = 404},
  [18992] = {.lex_state = 1, .external_lex_state = 440},
  [18993] = {.lex_state = 0, .external_lex_state = 439},
  [18994] = {.lex_state = 1, .external_lex_state = 440},
  [18995] = {.lex_state = 0, .external_lex_state = 336},
  [18996] = {.lex_state = 0, .external_lex_state = 336},
  [18997] = {.lex_state = 0, .external_lex_state = 308},
  [18998] = {.lex_state = 0, .external_lex_state = 404},
  [18999] = {.lex_state = 0, .external_lex_state = 336},
  [19000] = {.lex_state = 0, .external_lex_state = 336},
  [19001] = {.lex_state = 0, .external_lex_state = 336},
  [19002] = {.lex_state = 0, .external_lex_state = 439},
  [19003] = {.lex_state = 0, .external_lex_state = 386},
  [19004] = {.lex_state = 0, .external_lex_state = 405},
  [19005] = {.lex_state = 0, .external_lex_state = 386},
  [19006] = {.lex_state = 0, .external_lex_state = 386},
  [19007] = {.lex_state = 0, .external_lex_state = 336},
  [19008] = {.lex_state = 0, .external_lex_state = 336},
  [19009] = {.lex_state = 0, .external_lex_state = 404},
  [19010] = {.lex_state = 0, .external_lex_state = 336},
  [19011] = {.lex_state = 58, .external_lex_state = 308},
  [19012] = {.lex_state = 1, .external_lex_state = 440},
  [19013] = {.lex_state = 1, .external_lex_state = 440},
  [19014] = {.lex_state = 0, .external_lex_state = 405},
  [19015] = {.lex_state = 1, .external_lex_state = 440},
  [19016] = {.lex_state = 1, .external_lex_state = 440},
  [19017] = {.lex_state = 0, .external_lex_state = 404},
  [19018] = {.lex_state = 1, .external_lex_state = 440},
  [19019] = {.lex_state = 0, .external_lex_state = 336},
  [19020] = {.lex_state = 58, .external_lex_state = 308},
  [19021] = {.lex_state = 0, .external_lex_state = 336},
  [19022] = {.lex_state = 0, .external_lex_state = 336},
  [19023] = {.lex_state = 0, .external_lex_state = 336},
  [19024] = {.lex_state = 0, .external_lex_state = 404},
  [19025] = {.lex_state = 0, .external_lex_state = 336},
  [19026] = {.lex_state = 0, .external_lex_state = 405},
  [19027] = {.lex_state = 0, .external_lex_state = 404},
  [19028] = {.lex_state = 0, .external_lex_state = 404},
  [19029] = {.lex_state = 0, .external_lex_state = 336},
  [19030] = {.lex_state = 0, .external_lex_state = 336},
  [19031] = {.lex_state = 0, .external_lex_state = 336},
  [19032] = {.lex_state = 0, .external_lex_state = 336},
  [19033] = {.lex_state = 0, .external_lex_state = 336},
  [19034] = {.lex_state = 0, .external_lex_state = 336},
  [19035] = {.lex_state = 1, .external_lex_state = 440},
  [19036] = {.lex_state = 0, .external_lex_state = 336},
  [19037] = {.lex_state = 0, .external_lex_state = 367},
  [19038] = {.lex_state = 0, .external_lex_state = 336},
  [19039] = {.lex_state = 1, .external_lex_state = 440},
  [19040] = {.lex_state = 55, .external_lex_state = 308},
  [19041] = {.lex_state = 1, .external_lex_state = 440},
  [19042] = {.lex_state = 1, .external_lex_state = 440},
  [19043] = {.lex_state = 0, .external_lex_state = 336},
  [19044] = {.lex_state = 0, .external_lex_state = 336},
  [19045] = {.lex_state = 0, .external_lex_state = 404},
  [19046] = {.lex_state = 0, .external_lex_state = 336},
  [19047] = {.lex_state = 58, .external_lex_state = 308},
  [19048] = {.lex_state = 0, .external_lex_state = 404},
  [19049] = {.lex_state = 0, .external_lex_state = 336},
  [19050] = {.lex_state = 0, .external_lex_state = 336},
  [19051] = {.lex_state = 58, .external_lex_state = 308},
  [19052] = {.lex_state = 0, .external_lex_state = 336},
  [19053] = {.lex_state = 0, .external_lex_state = 336},
  [19054] = {.lex_state = 0, .external_lex_state = 336},
  [19055] = {.lex_state = 0, .external_lex_state = 336},
  [19056] = {.lex_state = 0, .external_lex_state = 336},
  [19057] = {.lex_state = 0, .external_lex_state = 336},
  [19058] = {.lex_state = 1, .external_lex_state = 440},
  [19059] = {.lex_state = 0, .external_lex_state = 404},
  [19060] = {.lex_state = 0, .external_lex_state = 336},
  [19061] = {.lex_state = 0, .external_lex_state = 336},
  [19062] = {.lex_state = 0, .external_lex_state = 336},
  [19063] = {.lex_state = 0, .external_lex_state = 336},
  [19064] = {.lex_state = 1, .external_lex_state = 440},
  [19065] = {.lex_state = 0, .external_lex_state = 336},
  [19066] = {.lex_state = 58, .external_lex_state = 308},
  [19067] = {.lex_state = 1, .external_lex_state = 440},
  [19068] = {.lex_state = 0, .external_lex_state = 405},
  [19069] = {.lex_state = 0, .external_lex_state = 336},
  [19070] = {.lex_state = 0, .external_lex_state = 336},
  [19071] = {.lex_state = 1, .external_lex_state = 440},
  [19072] = {.lex_state = 0, .external_lex_state = 336},
  [19073] = {.lex_state = 0, .external_lex_state = 404},
  [19074] = {.lex_state = 0, .external_lex_state = 336},
  [19075] = {.lex_state = 0, .external_lex_state = 336},
  [19076] = {.lex_state = 0, .external_lex_state = 336},
  [19077] = {.lex_state = 0, .external_lex_state = 386},
  [19078] = {.lex_state = 0, .external_lex_state = 336},
  [19079] = {.lex_state = 0, .external_lex_state = 336},
  [19080] = {.lex_state = 0, .external_lex_state = 336},
  [19081] = {.lex_state = 0, .external_lex_state = 404},
  [19082] = {.lex_state = 1, .external_lex_state = 440},
  [19083] = {.lex_state = 0, .external_lex_state = 405},
  [19084] = {.lex_state = 1, .external_lex_state = 440},
  [19085] = {.lex_state = 1, .external_lex_state = 440},
  [19086] = {.lex_state = 0, .external_lex_state = 404},
  [19087] = {.lex_state = 0, .external_lex_state = 404},
  [19088] = {.lex_state = 0, .external_lex_state = 336},
  [19089] = {.lex_state = 0, .external_lex_state = 386},
  [19090] = {.lex_state = 0, .external_lex_state = 336},
  [19091] = {.lex_state = 0, .external_lex_state = 404},
  [19092] = {.lex_state = 0, .external_lex_state = 336},
  [19093] = {.lex_state = 0, .external_lex_state = 336},
  [19094] = {.lex_state = 0, .external_lex_state = 308},
  [19095] = {.lex_state = 0, .external_lex_state = 439},
  [19096] = {.lex_state = 0, .external_lex_state = 336},
  [19097] = {.lex_state = 0, .external_lex_state = 336},
  [19098] = {.lex_state = 0, .external_lex_state = 336},
  [19099] = {.lex_state = 0, .external_lex_state = 336},
  [19100] = {.lex_state = 1, .external_lex_state = 440},
  [19101] = {.lex_state = 1, .external_lex_state = 440},
  [19102] = {.lex_state = 58, .external_lex_state = 308},
  [19103] = {.lex_state = 1, .external_lex_state = 440},
  [19104] = {.lex_state = 1, .external_lex_state = 440},
  [19105] = {.lex_state = 1, .external_lex_state = 440},
  [19106] = {.lex_state = 0, .external_lex_state = 336},
  [19107] = {.lex_state = 57, .external_lex_state = 308},
  [19108] = {.lex_state = 57, .external_lex_state = 308},
  [19109] = {.lex_state = 0, .external_lex_state = 336},
  [19110] = {.lex_state = 0, .external_lex_state = 404},
  [19111] = {.lex_state = 1, .external_lex_state = 440},
  [19112] = {.lex_state = 0, .external_lex_state = 336},
  [19113] = {.lex_state = 1, .external_lex_state = 440},
  [19114] = {.lex_state = 0, .external_lex_state = 336},
  [19115] = {.lex_state = 0, .external_lex_state = 336},
  [19116] = {.lex_state = 0, .external_lex_state = 336},
  [19117] = {.lex_state = 0, .external_lex_state = 336},
  [19118] = {.lex_state = 1, .external_lex_state = 440},
  [19119] = {.lex_state = 0, .external_lex_state = 404},
  [19120] = {.lex_state = 0, .external_lex_state = 336},
  [19121] = {.lex_state = 0, .external_lex_state = 439},
  [19122] = {.lex_state = 1, .external_lex_state = 440},
  [19123] = {.lex_state = 0, .external_lex_state = 336},
  [19124] = {.lex_state = 1, .external_lex_state = 440},
  [19125] = {.lex_state = 0, .external_lex_state = 336},
  [19126] = {.lex_state = 0, .external_lex_state = 336},
  [19127] = {.lex_state = 0, .external_lex_state = 336},
  [19128] = {.lex_state = 0, .external_lex_state = 404},
  [19129] = {.lex_state = 0, .external_lex_state = 405},
  [19130] = {.lex_state = 0, .external_lex_state = 336},
  [19131] = {.lex_state = 0, .external_lex_state = 404},
  [19132] = {.lex_state = 0, .external_lex_state = 336},
  [19133] = {.lex_state = 0, .external_lex_state = 336},
  [19134] = {.lex_state = 0, .external_lex_state = 336},
  [19135] = {.lex_state = 0, .external_lex_state = 336},
  [19136] = {.lex_state = 1, .external_lex_state = 440},
  [19137] = {.lex_state = 1, .external_lex_state = 440},
  [19138] = {.lex_state = 0, .external_lex_state = 336},
  [19139] = {.lex_state = 58, .external_lex_state = 308},
  [19140] = {.lex_state = 1, .external_lex_state = 440},
  [19141] = {.lex_state = 1, .external_lex_state = 440},
  [19142] = {.lex_state = 0, .external_lex_state = 405},
  [19143] = {.lex_state = 0, .external_lex_state = 404},
  [19144] = {.lex_state = 0, .external_lex_state = 336},
  [19145] = {.lex_state = 0, .external_lex_state = 336},
  [19146] = {.lex_state = 0, .external_lex_state = 336},
  [19147] = {.lex_state = 0, .external_lex_state = 336},
  [19148] = {.lex_state = 0, .external_lex_state = 336},
  [19149] = {.lex_state = 1, .external_lex_state = 440},
  [19150] = {.lex_state = 0, .external_lex_state = 336},
  [19151] = {.lex_state = 0, .external_lex_state = 336},
  [19152] = {.lex_state = 0, .external_lex_state = 336},
  [19153] = {.lex_state = 1, .external_lex_state = 440},
  [19154] = {.lex_state = 0, .external_lex_state = 336},
  [19155] = {.lex_state = 0, .external_lex_state = 336},
  [19156] = {.lex_state = 0, .external_lex_state = 405},
  [19157] = {.lex_state = 1, .external_lex_state = 440},
  [19158] = {.lex_state = 0, .external_lex_state = 336},
  [19159] = {.lex_state = 1, .external_lex_state = 440},
  [19160] = {.lex_state = 1, .external_lex_state = 440},
  [19161] = {.lex_state = 0, .external_lex_state = 404},
  [19162] = {.lex_state = 0, .external_lex_state = 336},
  [19163] = {.lex_state = 0, .external_lex_state = 404},
  [19164] = {.lex_state = 0, .external_lex_state = 404},
  [19165] = {.lex_state = 0, .external_lex_state = 336},
  [19166] = {.lex_state = 0, .external_lex_state = 336},
  [19167] = {.lex_state = 0, .external_lex_state = 336},
  [19168] = {.lex_state = 0, .external_lex_state = 336},
  [19169] = {.lex_state = 0, .external_lex_state = 336},
  [19170] = {.lex_state = 58, .external_lex_state = 308},
  [19171] = {.lex_state = 1, .external_lex_state = 440},
  [19172] = {.lex_state = 0, .external_lex_state = 336},
  [19173] = {.lex_state = 0, .external_lex_state = 336},
  [19174] = {.lex_state = 1, .external_lex_state = 440},
  [19175] = {.lex_state = 0, .external_lex_state = 336},
  [19176] = {.lex_state = 0, .external_lex_state = 336},
  [19177] = {.lex_state = 1, .external_lex_state = 440},
  [19178] = {.lex_state = 0, .external_lex_state = 404},
  [19179] = {.lex_state = 0, .external_lex_state = 439},
  [19180] = {.lex_state = 0, .external_lex_state = 405},
  [19181] = {.lex_state = 0, .external_lex_state = 336},
  [19182] = {.lex_state = 0, .external_lex_state = 308},
  [19183] = {.lex_state = 0, .external_lex_state = 405},
  [19184] = {.lex_state = 58, .external_lex_state = 308},
  [19185] = {.lex_state = 0, .external_lex_state = 404},
  [19186] = {.lex_state = 0, .external_lex_state = 336},
  [19187] = {.lex_state = 0, .external_lex_state = 336},
  [19188] = {.lex_state = 0, .external_lex_state = 336},
  [19189] = {.lex_state = 0, .external_lex_state = 336},
  [19190] = {.lex_state = 0, .external_lex_state = 404},
  [19191] = {.lex_state = 0, .external_lex_state = 336},
  [19192] = {.lex_state = 0, .external_lex_state = 404},
  [19193] = {.lex_state = 0, .external_lex_state = 405},
  [19194] = {.lex_state = 0, .external_lex_state = 336},
  [19195] = {.lex_state = 0, .external_lex_state = 336},
  [19196] = {.lex_state = 58, .external_lex_state = 397},
  [19197] = {.lex_state = 0, .external_lex_state = 336},
  [19198] = {.lex_state = 1, .external_lex_state = 440},
  [19199] = {.lex_state = 1, .external_lex_state = 440},
  [19200] = {.lex_state = 0, .external_lex_state = 404},
  [19201] = {.lex_state = 0, .external_lex_state = 336},
  [19202] = {.lex_state = 0, .external_lex_state = 336},
  [19203] = {.lex_state = 1, .external_lex_state = 440},
  [19204] = {.lex_state = 0, .external_lex_state = 336},
  [19205] = {.lex_state = 0, .external_lex_state = 404},
  [19206] = {.lex_state = 0, .external_lex_state = 336},
  [19207] = {.lex_state = 0, .external_lex_state = 336},
  [19208] = {.lex_state = 0, .external_lex_state = 405},
  [19209] = {.lex_state = 0, .external_lex_state = 336},
  [19210] = {.lex_state = 0, .external_lex_state = 336},
  [19211] = {.lex_state = 0, .external_lex_state = 336},
  [19212] = {.lex_state = 1, .external_lex_state = 440},
  [19213] = {.lex_state = 0, .external_lex_state = 336},
  [19214] = {.lex_state = 1, .external_lex_state = 440},
  [19215] = {.lex_state = 58, .external_lex_state = 308},
  [19216] = {.lex_state = 1, .external_lex_state = 440},
  [19217] = {.lex_state = 0, .external_lex_state = 336},
  [19218] = {.lex_state = 0, .external_lex_state = 336},
  [19219] = {.lex_state = 1, .external_lex_state = 440},
  [19220] = {.lex_state = 1, .external_lex_state = 440},
  [19221] = {.lex_state = 58, .external_lex_state = 308},
  [19222] = {.lex_state = 0, .external_lex_state = 336},
  [19223] = {.lex_state = 0, .external_lex_state = 405},
  [19224] = {.lex_state = 0, .external_lex_state = 404},
  [19225] = {.lex_state = 0, .external_lex_state = 336},
  [19226] = {.lex_state = 0, .external_lex_state = 404},
  [19227] = {.lex_state = 0, .external_lex_state = 336},
  [19228] = {.lex_state = 0, .external_lex_state = 336},
  [19229] = {.lex_state = 0, .external_lex_state = 336},
  [19230] = {.lex_state = 1, .external_lex_state = 440},
  [19231] = {.lex_state = 0, .external_lex_state = 336},
  [19232] = {.lex_state = 1, .external_lex_state = 440},
  [19233] = {.lex_state = 0, .external_lex_state = 386},
  [19234] = {.lex_state = 1, .external_lex_state = 440},
  [19235] = {.lex_state = 0, .external_lex_state = 336},
  [19236] = {.lex_state = 55, .external_lex_state = 442},
  [19237] = {.lex_state = 0, .external_lex_state = 386},
  [19238] = {.lex_state = 0, .external_lex_state = 439},
  [19239] = {.lex_state = 1, .external_lex_state = 440},
  [19240] = {.lex_state = 0, .external_lex_state = 439},
  [19241] = {.lex_state = 0, .external_lex_state = 386},
  [19242] = {.lex_state = 1, .external_lex_state = 440},
  [19243] = {.lex_state = 0, .external_lex_state = 405},
  [19244] = {.lex_state = 0, .external_lex_state = 336},
  [19245] = {.lex_state = 0, .external_lex_state = 336},
  [19246] = {.lex_state = 0, .external_lex_state = 336},
  [19247] = {.lex_state = 0, .external_lex_state = 404},
  [19248] = {.lex_state = 0, .external_lex_state = 336},
  [19249] = {.lex_state = 0, .external_lex_state = 405},
  [19250] = {.lex_state = 0, .external_lex_state = 404},
  [19251] = {.lex_state = 0, .external_lex_state = 336},
  [19252] = {.lex_state = 0, .external_lex_state = 336},
  [19253] = {.lex_state = 0, .external_lex_state = 336},
  [19254] = {.lex_state = 0, .external_lex_state = 336},
  [19255] = {.lex_state = 1, .external_lex_state = 440},
  [19256] = {.lex_state = 1, .external_lex_state = 440},
  [19257] = {.lex_state = 0, .external_lex_state = 336},
  [19258] = {.lex_state = 58, .external_lex_state = 308},
  [19259] = {.lex_state = 58, .external_lex_state = 308},
  [19260] = {.lex_state = 0, .external_lex_state = 404},
  [19261] = {.lex_state = 0, .external_lex_state = 405},
  [19262] = {.lex_state = 0, .external_lex_state = 405},
  [19263] = {.lex_state = 0, .external_lex_state = 336},
  [19264] = {.lex_state = 1, .external_lex_state = 440},
  [19265] = {.lex_state = 0, .external_lex_state = 404},
  [19266] = {.lex_state = 1, .external_lex_state = 440},
  [19267] = {.lex_state = 0, .external_lex_state = 336},
  [19268] = {.lex_state = 0, .external_lex_state = 405},
  [19269] = {.lex_state = 55, .external_lex_state = 308},
  [19270] = {.lex_state = 0, .external_lex_state = 336},
  [19271] = {.lex_state = 0, .external_lex_state = 336},
  [19272] = {.lex_state = 0, .external_lex_state = 336},
  [19273] = {.lex_state = 0, .external_lex_state = 404},
  [19274] = {.lex_state = 0, .external_lex_state = 336},
  [19275] = {.lex_state = 0, .external_lex_state = 336},
  [19276] = {.lex_state = 0, .external_lex_state = 336},
  [19277] = {.lex_state = 1, .external_lex_state = 440},
  [19278] = {.lex_state = 0, .external_lex_state = 336},
  [19279] = {.lex_state = 1, .external_lex_state = 440},
  [19280] = {.lex_state = 58, .external_lex_state = 308},
  [19281] = {.lex_state = 1, .external_lex_state = 440},
  [19282] = {.lex_state = 1, .external_lex_state = 440},
  [19283] = {.lex_state = 0, .external_lex_state = 404},
  [19284] = {.lex_state = 55, .external_lex_state = 308},
  [19285] = {.lex_state = 0, .external_lex_state = 336},
  [19286] = {.lex_state = 55, .external_lex_state = 308},
  [19287] = {.lex_state = 0, .external_lex_state = 336},
  [19288] = {.lex_state = 1, .external_lex_state = 440},
  [19289] = {.lex_state = 58, .external_lex_state = 308},
  [19290] = {.lex_state = 0, .external_lex_state = 336},
  [19291] = {.lex_state = 0, .external_lex_state = 336},
  [19292] = {.lex_state = 58, .external_lex_state = 308},
  [19293] = {.lex_state = 0, .external_lex_state = 386},
  [19294] = {.lex_state = 0, .external_lex_state = 386},
  [19295] = {.lex_state = 0, .external_lex_state = 336},
  [19296] = {.lex_state = 0, .external_lex_state = 404},
  [19297] = {.lex_state = 0, .external_lex_state = 404},
  [19298] = {.lex_state = 55, .external_lex_state = 308},
  [19299] = {.lex_state = 0, .external_lex_state = 405},
  [19300] = {.lex_state = 0, .external_lex_state = 336},
  [19301] = {.lex_state = 0, .external_lex_state = 336},
  [19302] = {.lex_state = 0, .external_lex_state = 386},
  [19303] = {.lex_state = 0, .external_lex_state = 336},
  [19304] = {.lex_state = 0, .external_lex_state = 336},
  [19305] = {.lex_state = 1, .external_lex_state = 440},
  [19306] = {.lex_state = 0, .external_lex_state = 405},
  [19307] = {.lex_state = 1, .external_lex_state = 440},
  [19308] = {.lex_state = 1, .external_lex_state = 440},
  [19309] = {.lex_state = 0, .external_lex_state = 336},
  [19310] = {.lex_state = 0, .external_lex_state = 336},
  [19311] = {.lex_state = 0, .external_lex_state = 336},
  [19312] = {.lex_state = 0, .external_lex_state = 386},
  [19313] = {.lex_state = 0, .external_lex_state = 336},
  [19314] = {.lex_state = 0, .external_lex_state = 336},
  [19315] = {.lex_state = 0, .external_lex_state = 386},
  [19316] = {.lex_state = 0, .external_lex_state = 404},
  [19317] = {.lex_state = 0, .external_lex_state = 336},
  [19318] = {.lex_state = 0, .external_lex_state = 336},
  [19319] = {.lex_state = 0, .external_lex_state = 336},
  [19320] = {.lex_state = 0, .external_lex_state = 336},
  [19321] = {.lex_state = 0, .external_lex_state = 336},
  [19322] = {.lex_state = 0, .external_lex_state = 336},
  [19323] = {.lex_state = 0, .external_lex_state = 336},
  [19324] = {.lex_state = 0, .external_lex_state = 336},
  [19325] = {.lex_state = 1, .external_lex_state = 440},
  [19326] = {.lex_state = 0, .external_lex_state = 336},
  [19327] = {.lex_state = 0, .external_lex_state = 404},
  [19328] = {.lex_state = 1, .external_lex_state = 440},
  [19329] = {.lex_state = 0, .external_lex_state = 336},
  [19330] = {.lex_state = 1, .external_lex_state = 440},
  [19331] = {.lex_state = 0, .external_lex_state = 336},
  [19332] = {.lex_state = 0, .external_lex_state = 404},
  [19333] = {.lex_state = 0, .external_lex_state = 336},
  [19334] = {.lex_state = 0, .external_lex_state = 336},
  [19335] = {.lex_state = 0, .external_lex_state = 336},
  [19336] = {.lex_state = 0, .external_lex_state = 336},
  [19337] = {.lex_state = 0, .external_lex_state = 336},
  [19338] = {.lex_state = 0, .external_lex_state = 336},
  [19339] = {.lex_state = 0, .external_lex_state = 336},
  [19340] = {.lex_state = 1, .external_lex_state = 440},
  [19341] = {.lex_state = 0, .external_lex_state = 404},
  [19342] = {.lex_state = 0, .external_lex_state = 404},
  [19343] = {.lex_state = 1, .external_lex_state = 440},
  [19344] = {.lex_state = 0, .external_lex_state = 336},
  [19345] = {.lex_state = 1, .external_lex_state = 440},
  [19346] = {.lex_state = 1, .external_lex_state = 440},
  [19347] = {.lex_state = 1, .external_lex_state = 440},
  [19348] = {.lex_state = 1, .external_lex_state = 440},
  [19349] = {.lex_state = 0, .external_lex_state = 336},
  [19350] = {.lex_state = 1, .external_lex_state = 440},
  [19351] = {.lex_state = 0, .external_lex_state = 336},
  [19352] = {.lex_state = 0, .external_lex_state = 336},
  [19353] = {.lex_state = 0, .external_lex_state = 404},
  [19354] = {.lex_state = 0, .external_lex_state = 336},
  [19355] = {.lex_state = 0, .external_lex_state = 336},
  [19356] = {.lex_state = 0, .external_lex_state = 336},
  [19357] = {.lex_state = 0, .external_lex_state = 336},
  [19358] = {.lex_state = 0, .external_lex_state = 439},
  [19359] = {.lex_state = 0, .external_lex_state = 336},
  [19360] = {.lex_state = 1, .external_lex_state = 440},
  [19361] = {.lex_state = 0, .external_lex_state = 336},
  [19362] = {.lex_state = 0, .external_lex_state = 404},
  [19363] = {.lex_state = 1, .external_lex_state = 440},
  [19364] = {.lex_state = 0, .external_lex_state = 386},
  [19365] = {.lex_state = 0, .external_lex_state = 336},
  [19366] = {.lex_state = 1, .external_lex_state = 440},
  [19367] = {.lex_state = 0, .external_lex_state = 439},
  [19368] = {.lex_state = 57, .external_lex_state = 308},
  [19369] = {.lex_state = 0, .external_lex_state = 404},
  [19370] = {.lex_state = 1, .external_lex_state = 440},
  [19371] = {.lex_state = 0, .external_lex_state = 336},
  [19372] = {.lex_state = 58, .external_lex_state = 308},
  [19373] = {.lex_state = 55, .external_lex_state = 308},
  [19374] = {.lex_state = 0, .external_lex_state = 336},
  [19375] = {.lex_state = 0, .external_lex_state = 336},
  [19376] = {.lex_state = 0, .external_lex_state = 404},
  [19377] = {.lex_state = 0, .external_lex_state = 336},
  [19378] = {.lex_state = 0, .external_lex_state = 336},
  [19379] = {.lex_state = 0, .external_lex_state = 336},
  [19380] = {.lex_state = 0, .external_lex_state = 336},
  [19381] = {.lex_state = 0, .external_lex_state = 336},
  [19382] = {.lex_state = 0, .external_lex_state = 336},
  [19383] = {.lex_state = 0, .external_lex_state = 336},
  [19384] = {.lex_state = 1, .external_lex_state = 440},
  [19385] = {.lex_state = 0, .external_lex_state = 336},
  [19386] = {.lex_state = 55, .external_lex_state = 442},
  [19387] = {.lex_state = 58, .external_lex_state = 308},
  [19388] = {.lex_state = 1, .external_lex_state = 440},
  [19389] = {.lex_state = 0, .external_lex_state = 336},
  [19390] = {.lex_state = 1, .external_lex_state = 440},
  [19391] = {.lex_state = 1, .external_lex_state = 440},
  [19392] = {.lex_state = 0, .external_lex_state = 404},
  [19393] = {.lex_state = 0, .external_lex_state = 404},
  [19394] = {.lex_state = 0, .external_lex_state = 405},
  [19395] = {.lex_state = 0, .external_lex_state = 308},
  [19396] = {.lex_state = 0, .external_lex_state = 404},
  [19397] = {.lex_state = 0, .external_lex_state = 336},
  [19398] = {.lex_state = 0, .external_lex_state = 336},
  [19399] = {.lex_state = 58, .external_lex_state = 308},
  [19400] = {.lex_state = 0, .external_lex_state = 336},
  [19401] = {.lex_state = 0, .external_lex_state = 336},
  [19402] = {.lex_state = 0, .external_lex_state = 336},
  [19403] = {.lex_state = 0, .external_lex_state = 336},
  [19404] = {.lex_state = 0, .external_lex_state = 336},
  [19405] = {.lex_state = 0, .external_lex_state = 404},
  [19406] = {.lex_state = 1, .external_lex_state = 440},
  [19407] = {.lex_state = 1, .external_lex_state = 440},
  [19408] = {.lex_state = 1, .external_lex_state = 440},
  [19409] = {.lex_state = 0, .external_lex_state = 404},
  [19410] = {.lex_state = 0, .external_lex_state = 405},
  [19411] = {.lex_state = 1, .external_lex_state = 440},
  [19412] = {.lex_state = 0, .external_lex_state = 386},
  [19413] = {.lex_state = 0, .external_lex_state = 336},
  [19414] = {.lex_state = 58, .external_lex_state = 308},
  [19415] = {.lex_state = 0, .external_lex_state = 405},
  [19416] = {.lex_state = 0, .external_lex_state = 404},
  [19417] = {.lex_state = 0, .external_lex_state = 336},
  [19418] = {.lex_state = 0, .external_lex_state = 336},
  [19419] = {.lex_state = 55, .external_lex_state = 413},
  [19420] = {.lex_state = 0, .external_lex_state = 336},
  [19421] = {.lex_state = 0, .external_lex_state = 439},
  [19422] = {.lex_state = 0, .external_lex_state = 336},
  [19423] = {.lex_state = 0, .external_lex_state = 386},
  [19424] = {.lex_state = 0, .external_lex_state = 336},
  [19425] = {.lex_state = 0, .external_lex_state = 336},
  [19426] = {.lex_state = 0, .external_lex_state = 336},
  [19427] = {.lex_state = 0, .external_lex_state = 336},
  [19428] = {.lex_state = 1, .external_lex_state = 440},
  [19429] = {.lex_state = 0, .external_lex_state = 336},
  [19430] = {.lex_state = 55, .external_lex_state = 308},
  [19431] = {.lex_state = 0, .external_lex_state = 405},
  [19432] = {.lex_state = 1, .external_lex_state = 440},
  [19433] = {.lex_state = 1, .external_lex_state = 440},
  [19434] = {.lex_state = 1, .external_lex_state = 440},
  [19435] = {.lex_state = 55, .external_lex_state = 308},
  [19436] = {.lex_state = 55, .external_lex_state = 308},
  [19437] = {.lex_state = 0, .external_lex_state = 336},
  [19438] = {.lex_state = 1, .external_lex_state = 440},
  [19439] = {.lex_state = 0, .external_lex_state = 336},
  [19440] = {.lex_state = 0, .external_lex_state = 336},
  [19441] = {.lex_state = 0, .external_lex_state = 404},
  [19442] = {.lex_state = 58, .external_lex_state = 397},
  [19443] = {.lex_state = 0, .external_lex_state = 336},
  [19444] = {.lex_state = 0, .external_lex_state = 336},
  [19445] = {.lex_state = 0, .external_lex_state = 336},
  [19446] = {.lex_state = 0, .external_lex_state = 336},
  [19447] = {.lex_state = 0, .external_lex_state = 336},
  [19448] = {.lex_state = 55, .external_lex_state = 442},
  [19449] = {.lex_state = 1, .external_lex_state = 440},
  [19450] = {.lex_state = 0, .external_lex_state = 336},
  [19451] = {.lex_state = 0, .external_lex_state = 336},
  [19452] = {.lex_state = 1, .external_lex_state = 440},
  [19453] = {.lex_state = 0, .external_lex_state = 336},
  [19454] = {.lex_state = 1, .external_lex_state = 440},
  [19455] = {.lex_state = 1, .external_lex_state = 440},
  [19456] = {.lex_state = 55, .external_lex_state = 413},
  [19457] = {.lex_state = 1, .external_lex_state = 440},
  [19458] = {.lex_state = 0, .external_lex_state = 404},
  [19459] = {.lex_state = 0, .external_lex_state = 386},
  [19460] = {.lex_state = 0, .external_lex_state = 404},
  [19461] = {.lex_state = 0, .external_lex_state = 336},
  [19462] = {.lex_state = 0, .external_lex_state = 404},
  [19463] = {.lex_state = 0, .external_lex_state = 336},
  [19464] = {.lex_state = 0, .external_lex_state = 336},
  [19465] = {.lex_state = 0, .external_lex_state = 336},
  [19466] = {.lex_state = 1, .external_lex_state = 440},
  [19467] = {.lex_state = 1, .external_lex_state = 440},
  [19468] = {.lex_state = 0, .external_lex_state = 336},
  [19469] = {.lex_state = 55, .external_lex_state = 413},
  [19470] = {.lex_state = 1, .external_lex_state = 440},
  [19471] = {.lex_state = 0, .external_lex_state = 336},
  [19472] = {.lex_state = 0, .external_lex_state = 336},
  [19473] = {.lex_state = 0, .external_lex_state = 336},
  [19474] = {.lex_state = 1, .external_lex_state = 440},
  [19475] = {.lex_state = 55, .external_lex_state = 308},
  [19476] = {.lex_state = 0, .external_lex_state = 336},
  [19477] = {.lex_state = 0, .external_lex_state = 336},
  [19478] = {.lex_state = 0, .external_lex_state = 336},
  [19479] = {.lex_state = 0, .external_lex_state = 336},
  [19480] = {.lex_state = 58, .external_lex_state = 308},
  [19481] = {.lex_state = 0, .external_lex_state = 404},
  [19482] = {.lex_state = 0, .external_lex_state = 404},
  [19483] = {.lex_state = 0, .external_lex_state = 336},
  [19484] = {.lex_state = 0, .external_lex_state = 336},
  [19485] = {.lex_state = 0, .external_lex_state = 336},
  [19486] = {.lex_state = 0, .external_lex_state = 336},
  [19487] = {.lex_state = 0, .external_lex_state = 336},
  [19488] = {.lex_state = 1, .external_lex_state = 440},
  [19489] = {.lex_state = 0, .external_lex_state = 336},
  [19490] = {.lex_state = 1, .external_lex_state = 440},
  [19491] = {.lex_state = 0, .external_lex_state = 336},
  [19492] = {.lex_state = 1, .external_lex_state = 440},
  [19493] = {.lex_state = 55, .external_lex_state = 308},
  [19494] = {.lex_state = 0, .external_lex_state = 404},
  [19495] = {.lex_state = 0, .external_lex_state = 336},
  [19496] = {.lex_state = 1, .external_lex_state = 440},
  [19497] = {.lex_state = 0, .external_lex_state = 336},
  [19498] = {.lex_state = 1, .external_lex_state = 440},
  [19499] = {.lex_state = 0, .external_lex_state = 404},
  [19500] = {.lex_state = 1, .external_lex_state = 440},
  [19501] = {.lex_state = 0, .external_lex_state = 336},
  [19502] = {.lex_state = 0, .external_lex_state = 336},
  [19503] = {.lex_state = 0, .external_lex_state = 404},
  [19504] = {.lex_state = 0, .external_lex_state = 336},
  [19505] = {.lex_state = 0, .external_lex_state = 336},
  [19506] = {.lex_state = 0, .external_lex_state = 336},
  [19507] = {.lex_state = 0, .external_lex_state = 336},
  [19508] = {.lex_state = 0, .external_lex_state = 336},
  [19509] = {.lex_state = 0, .external_lex_state = 336},
  [19510] = {.lex_state = 0, .external_lex_state = 336},
  [19511] = {.lex_state = 0, .external_lex_state = 336},
  [19512] = {.lex_state = 0, .external_lex_state = 336},
  [19513] = {.lex_state = 1, .external_lex_state = 440},
  [19514] = {.lex_state = 0, .external_lex_state = 404},
  [19515] = {.lex_state = 0, .external_lex_state = 336},
  [19516] = {.lex_state = 0, .external_lex_state = 336},
  [19517] = {.lex_state = 58, .external_lex_state = 308},
  [19518] = {.lex_state = 1, .external_lex_state = 440},
  [19519] = {.lex_state = 1, .external_lex_state = 440},
  [19520] = {.lex_state = 0, .external_lex_state = 336},
  [19521] = {.lex_state = 1, .external_lex_state = 440},
  [19522] = {.lex_state = 0, .external_lex_state = 336},
  [19523] = {.lex_state = 1, .external_lex_state = 440},
  [19524] = {.lex_state = 0, .external_lex_state = 336},
  [19525] = {.lex_state = 0, .external_lex_state = 405},
  [19526] = {.lex_state = 0, .external_lex_state = 404},
  [19527] = {.lex_state = 0, .external_lex_state = 404},
  [19528] = {.lex_state = 0, .external_lex_state = 336},
  [19529] = {.lex_state = 55, .external_lex_state = 413},
  [19530] = {.lex_state = 0, .external_lex_state = 336},
  [19531] = {.lex_state = 0, .external_lex_state = 336},
  [19532] = {.lex_state = 1, .external_lex_state = 440},
  [19533] = {.lex_state = 0, .external_lex_state = 336},
  [19534] = {.lex_state = 0, .external_lex_state = 336},
  [19535] = {.lex_state = 1, .external_lex_state = 440},
  [19536] = {.lex_state = 0, .external_lex_state = 367},
  [19537] = {.lex_state = 0, .external_lex_state = 336},
  [19538] = {.lex_state = 0, .external_lex_state = 336},
  [19539] = {.lex_state = 1, .external_lex_state = 440},
  [19540] = {.lex_state = 0, .external_lex_state = 404},
  [19541] = {.lex_state = 1, .external_lex_state = 440},
  [19542] = {.lex_state = 0, .external_lex_state = 336},
  [19543] = {.lex_state = 1, .external_lex_state = 440},
  [19544] = {.lex_state = 0, .external_lex_state = 404},
  [19545] = {.lex_state = 1, .external_lex_state = 440},
  [19546] = {.lex_state = 55, .external_lex_state = 308},
  [19547] = {.lex_state = 0, .external_lex_state = 404},
  [19548] = {.lex_state = 0, .external_lex_state = 336},
  [19549] = {.lex_state = 0, .external_lex_state = 336},
  [19550] = {.lex_state = 0, .external_lex_state = 336},
  [19551] = {.lex_state = 1, .external_lex_state = 440},
  [19552] = {.lex_state = 0, .external_lex_state = 336},
  [19553] = {.lex_state = 1, .external_lex_state = 440},
  [19554] = {.lex_state = 0, .external_lex_state = 336},
  [19555] = {.lex_state = 0, .external_lex_state = 336},
  [19556] = {.lex_state = 1, .external_lex_state = 440},
  [19557] = {.lex_state = 0, .external_lex_state = 336},
  [19558] = {.lex_state = 1, .external_lex_state = 440},
  [19559] = {.lex_state = 0, .external_lex_state = 386},
  [19560] = {.lex_state = 1, .external_lex_state = 440},
  [19561] = {.lex_state = 0, .external_lex_state = 336},
  [19562] = {.lex_state = 1, .external_lex_state = 440},
  [19563] = {.lex_state = 0, .external_lex_state = 336},
  [19564] = {.lex_state = 0, .external_lex_state = 439},
  [19565] = {.lex_state = 0, .external_lex_state = 367},
  [19566] = {.lex_state = 0, .external_lex_state = 367},
  [19567] = {.lex_state = 0, .external_lex_state = 336},
  [19568] = {.lex_state = 0, .external_lex_state = 336},
  [19569] = {.lex_state = 0, .external_lex_state = 404},
  [19570] = {.lex_state = 0, .external_lex_state = 336},
  [19571] = {.lex_state = 0, .external_lex_state = 336},
  [19572] = {.lex_state = 0, .external_lex_state = 336},
  [19573] = {.lex_state = 0, .external_lex_state = 336},
  [19574] = {.lex_state = 0, .external_lex_state = 404},
  [19575] = {.lex_state = 0, .external_lex_state = 336},
  [19576] = {.lex_state = 0, .external_lex_state = 336},
  [19577] = {.lex_state = 1, .external_lex_state = 440},
  [19578] = {.lex_state = 0, .external_lex_state = 336},
  [19579] = {.lex_state = 1, .external_lex_state = 440},
  [19580] = {.lex_state = 0, .external_lex_state = 336},
  [19581] = {.lex_state = 1, .external_lex_state = 440},
  [19582] = {.lex_state = 0, .external_lex_state = 404},
  [19583] = {.lex_state = 1, .external_lex_state = 440},
  [19584] = {.lex_state = 1, .external_lex_state = 440},
  [19585] = {.lex_state = 55, .external_lex_state = 413},
  [19586] = {.lex_state = 0, .external_lex_state = 404},
  [19587] = {.lex_state = 0, .external_lex_state = 336},
  [19588] = {.lex_state = 0, .external_lex_state = 336},
  [19589] = {.lex_state = 0, .external_lex_state = 336},
  [19590] = {.lex_state = 0, .external_lex_state = 336},
  [19591] = {.lex_state = 1, .external_lex_state = 440},
  [19592] = {.lex_state = 1, .external_lex_state = 440},
  [19593] = {.lex_state = 0, .external_lex_state = 336},
  [19594] = {.lex_state = 1, .external_lex_state = 440},
  [19595] = {.lex_state = 1, .external_lex_state = 440},
  [19596] = {.lex_state = 1, .external_lex_state = 440},
  [19597] = {.lex_state = 0, .external_lex_state = 336},
  [19598] = {.lex_state = 0, .external_lex_state = 336},
  [19599] = {.lex_state = 0, .external_lex_state = 336},
  [19600] = {.lex_state = 0, .external_lex_state = 336},
  [19601] = {.lex_state = 58, .external_lex_state = 308},
  [19602] = {.lex_state = 0, .external_lex_state = 336},
  [19603] = {.lex_state = 0, .external_lex_state = 404},
  [19604] = {.lex_state = 0, .external_lex_state = 404},
  [19605] = {.lex_state = 0, .external_lex_state = 336},
  [19606] = {.lex_state = 0, .external_lex_state = 336},
  [19607] = {.lex_state = 0, .external_lex_state = 336},
  [19608] = {.lex_state = 58, .external_lex_state = 308},
  [19609] = {.lex_state = 0, .external_lex_state = 336},
  [19610] = {.lex_state = 0, .external_lex_state = 336},
  [19611] = {.lex_state = 1, .external_lex_state = 440},
  [19612] = {.lex_state = 0, .external_lex_state = 336},
  [19613] = {.lex_state = 1, .external_lex_state = 440},
  [19614] = {.lex_state = 0, .external_lex_state = 336},
  [19615] = {.lex_state = 0, .external_lex_state = 336},
  [19616] = {.lex_state = 1, .external_lex_state = 440},
  [19617] = {.lex_state = 1, .external_lex_state = 440},
  [19618] = {.lex_state = 0, .external_lex_state = 336},
  [19619] = {.lex_state = 0, .external_lex_state = 336},
  [19620] = {.lex_state = 1, .external_lex_state = 440},
  [19621] = {.lex_state = 1, .external_lex_state = 440},
  [19622] = {.lex_state = 1, .external_lex_state = 440},
  [19623] = {.lex_state = 0, .external_lex_state = 336},
  [19624] = {.lex_state = 0, .external_lex_state = 336},
  [19625] = {.lex_state = 0, .external_lex_state = 336},
  [19626] = {.lex_state = 0, .external_lex_state = 404},
  [19627] = {.lex_state = 0, .external_lex_state = 336},
  [19628] = {.lex_state = 0, .external_lex_state = 336},
  [19629] = {.lex_state = 0, .external_lex_state = 336},
  [19630] = {.lex_state = 0, .external_lex_state = 336},
  [19631] = {.lex_state = 0, .external_lex_state = 336},
  [19632] = {.lex_state = 0, .external_lex_state = 336},
  [19633] = {.lex_state = 0, .external_lex_state = 336},
  [19634] = {.lex_state = 0, .external_lex_state = 404},
  [19635] = {.lex_state = 1, .external_lex_state = 440},
  [19636] = {.lex_state = 0, .external_lex_state = 404},
  [19637] = {.lex_state = 1, .external_lex_state = 440},
  [19638] = {.lex_state = 0, .external_lex_state = 404},
  [19639] = {.lex_state = 1, .external_lex_state = 440},
  [19640] = {.lex_state = 0, .external_lex_state = 336},
  [19641] = {.lex_state = 1, .external_lex_state = 440},
  [19642] = {.lex_state = 0, .external_lex_state = 336},
  [19643] = {.lex_state = 1, .external_lex_state = 440},
  [19644] = {.lex_state = 58, .external_lex_state = 308},
  [19645] = {.lex_state = 0, .external_lex_state = 404},
  [19646] = {.lex_state = 0, .external_lex_state = 404},
  [19647] = {.lex_state = 0, .external_lex_state = 336},
  [19648] = {.lex_state = 0, .external_lex_state = 336},
  [19649] = {.lex_state = 0, .external_lex_state = 336},
  [19650] = {.lex_state = 0, .external_lex_state = 336},
  [19651] = {.lex_state = 1, .external_lex_state = 440},
  [19652] = {.lex_state = 1, .external_lex_state = 440},
  [19653] = {.lex_state = 0, .external_lex_state = 336},
  [19654] = {.lex_state = 0, .external_lex_state = 336},
  [19655] = {.lex_state = 1, .external_lex_state = 440},
  [19656] = {.lex_state = 1, .external_lex_state = 440},
  [19657] = {.lex_state = 0, .external_lex_state = 336},
  [19658] = {.lex_state = 0, .external_lex_state = 336},
  [19659] = {.lex_state = 0, .external_lex_state = 336},
  [19660] = {.lex_state = 0, .external_lex_state = 405},
  [19661] = {.lex_state = 0, .external_lex_state = 404},
  [19662] = {.lex_state = 0, .external_lex_state = 336},
  [19663] = {.lex_state = 0, .external_lex_state = 404},
  [19664] = {.lex_state = 0, .external_lex_state = 404},
  [19665] = {.lex_state = 0, .external_lex_state = 336},
  [19666] = {.lex_state = 0, .external_lex_state = 336},
  [19667] = {.lex_state = 0, .external_lex_state = 336},
  [19668] = {.lex_state = 0, .external_lex_state = 336},
  [19669] = {.lex_state = 0, .external_lex_state = 336},
  [19670] = {.lex_state = 1, .external_lex_state = 440},
  [19671] = {.lex_state = 1, .external_lex_state = 440},
  [19672] = {.lex_state = 0, .external_lex_state = 405},
  [19673] = {.lex_state = 1, .external_lex_state = 440},
  [19674] = {.lex_state = 0, .external_lex_state = 336},
  [19675] = {.lex_state = 55, .external_lex_state = 442},
  [19676] = {.lex_state = 1, .external_lex_state = 440},
  [19677] = {.lex_state = 0, .external_lex_state = 336},
  [19678] = {.lex_state = 1, .external_lex_state = 440},
  [19679] = {.lex_state = 0, .external_lex_state = 336},
  [19680] = {.lex_state = 0, .external_lex_state = 336},
  [19681] = {.lex_state = 0, .external_lex_state = 404},
  [19682] = {.lex_state = 1, .external_lex_state = 440},
  [19683] = {.lex_state = 0, .external_lex_state = 336},
  [19684] = {.lex_state = 0, .external_lex_state = 336},
  [19685] = {.lex_state = 0, .external_lex_state = 336},
  [19686] = {.lex_state = 0, .external_lex_state = 336},
  [19687] = {.lex_state = 0, .external_lex_state = 336},
  [19688] = {.lex_state = 0, .external_lex_state = 336},
  [19689] = {.lex_state = 0, .external_lex_state = 336},
  [19690] = {.lex_state = 1, .external_lex_state = 440},
  [19691] = {.lex_state = 0, .external_lex_state = 405},
  [19692] = {.lex_state = 0, .external_lex_state = 336},
  [19693] = {.lex_state = 1, .external_lex_state = 440},
  [19694] = {.lex_state = 0, .external_lex_state = 404},
  [19695] = {.lex_state = 0, .external_lex_state = 439},
  [19696] = {.lex_state = 1, .external_lex_state = 440},
  [19697] = {.lex_state = 0, .external_lex_state = 405},
  [19698] = {.lex_state = 0, .external_lex_state = 386},
  [19699] = {.lex_state = 1, .external_lex_state = 440},
  [19700] = {.lex_state = 0, .external_lex_state = 405},
  [19701] = {.lex_state = 1, .external_lex_state = 440},
  [19702] = {.lex_state = 0, .external_lex_state = 336},
  [19703] = {.lex_state = 1, .external_lex_state = 440},
  [19704] = {.lex_state = 0, .external_lex_state = 404},
  [19705] = {.lex_state = 0, .external_lex_state = 336},
  [19706] = {.lex_state = 1, .external_lex_state = 440},
  [19707] = {.lex_state = 0, .external_lex_state = 336},
  [19708] = {.lex_state = 0, .external_lex_state = 336},
  [19709] = {.lex_state = 0, .external_lex_state = 336},
  [19710] = {.lex_state = 1, .external_lex_state = 440},
  [19711] = {.lex_state = 1, .external_lex_state = 440},
  [19712] = {.lex_state = 1, .external_lex_state = 440},
  [19713] = {.lex_state = 0, .external_lex_state = 336},
  [19714] = {.lex_state = 1, .external_lex_state = 440},
  [19715] = {.lex_state = 0, .external_lex_state = 336},
  [19716] = {.lex_state = 0, .external_lex_state = 336},
  [19717] = {.lex_state = 0, .external_lex_state = 336},
  [19718] = {.lex_state = 0, .external_lex_state = 336},
  [19719] = {.lex_state = 0, .external_lex_state = 404},
  [19720] = {.lex_state = 0, .external_lex_state = 336},
  [19721] = {.lex_state = 0, .external_lex_state = 411},
  [19722] = {.lex_state = 0, .external_lex_state = 336},
  [19723] = {.lex_state = 0, .external_lex_state = 336},
  [19724] = {.lex_state = 0, .external_lex_state = 404},
  [19725] = {.lex_state = 0, .external_lex_state = 336},
  [19726] = {.lex_state = 0, .external_lex_state = 336},
  [19727] = {.lex_state = 0, .external_lex_state = 336},
  [19728] = {.lex_state = 1, .external_lex_state = 440},
  [19729] = {.lex_state = 0, .external_lex_state = 439},
  [19730] = {.lex_state = 0, .external_lex_state = 386},
  [19731] = {.lex_state = 1, .external_lex_state = 440},
  [19732] = {.lex_state = 55, .external_lex_state = 308},
  [19733] = {.lex_state = 1, .external_lex_state = 440},
  [19734] = {.lex_state = 55, .external_lex_state = 308},
  [19735] = {.lex_state = 1, .external_lex_state = 440},
  [19736] = {.lex_state = 1, .external_lex_state = 440},
  [19737] = {.lex_state = 1, .external_lex_state = 440},
  [19738] = {.lex_state = 0, .external_lex_state = 404},
  [19739] = {.lex_state = 0, .external_lex_state = 336},
  [19740] = {.lex_state = 0, .external_lex_state = 404},
  [19741] = {.lex_state = 0, .external_lex_state = 336},
  [19742] = {.lex_state = 1, .external_lex_state = 440},
  [19743] = {.lex_state = 0, .external_lex_state = 336},
  [19744] = {.lex_state = 0, .external_lex_state = 336},
  [19745] = {.lex_state = 0, .external_lex_state = 336},
  [19746] = {.lex_state = 1, .external_lex_state = 440},
  [19747] = {.lex_state = 0, .external_lex_state = 336},
  [19748] = {.lex_state = 0, .external_lex_state = 336},
  [19749] = {.lex_state = 0, .external_lex_state = 405},
  [19750] = {.lex_state = 1, .external_lex_state = 440},
  [19751] = {.lex_state = 1, .external_lex_state = 440},
  [19752] = {.lex_state = 0, .external_lex_state = 336},
  [19753] = {.lex_state = 1, .external_lex_state = 440},
  [19754] = {.lex_state = 0, .external_lex_state = 404},
  [19755] = {.lex_state = 0, .external_lex_state = 336},
  [19756] = {.lex_state = 0, .external_lex_state = 336},
  [19757] = {.lex_state = 0, .external_lex_state = 405},
  [19758] = {.lex_state = 0, .external_lex_state = 404},
  [19759] = {.lex_state = 0, .external_lex_state = 336},
  [19760] = {.lex_state = 0, .external_lex_state = 336},
  [19761] = {.lex_state = 1, .external_lex_state = 440},
  [19762] = {.lex_state = 0, .external_lex_state = 336},
  [19763] = {.lex_state = 1, .external_lex_state = 440},
  [19764] = {.lex_state = 0, .external_lex_state = 336},
  [19765] = {.lex_state = 0, .external_lex_state = 405},
  [19766] = {.lex_state = 1, .external_lex_state = 440},
  [19767] = {.lex_state = 1, .external_lex_state = 440},
  [19768] = {.lex_state = 1, .external_lex_state = 440},
  [19769] = {.lex_state = 0, .external_lex_state = 336},
  [19770] = {.lex_state = 1, .external_lex_state = 440},
  [19771] = {.lex_state = 58, .external_lex_state = 308},
  [19772] = {.lex_state = 1, .external_lex_state = 440},
  [19773] = {.lex_state = 0, .external_lex_state = 336},
  [19774] = {.lex_state = 0, .external_lex_state = 336},
  [19775] = {.lex_state = 0, .external_lex_state = 404},
  [19776] = {.lex_state = 0, .external_lex_state = 336},
  [19777] = {.lex_state = 0, .external_lex_state = 336},
  [19778] = {.lex_state = 0, .external_lex_state = 336},
  [19779] = {.lex_state = 0, .external_lex_state = 336},
  [19780] = {.lex_state = 55, .external_lex_state = 442},
  [19781] = {.lex_state = 0, .external_lex_state = 336},
  [19782] = {.lex_state = 0, .external_lex_state = 336},
  [19783] = {.lex_state = 0, .external_lex_state = 336},
  [19784] = {.lex_state = 0, .external_lex_state = 404},
  [19785] = {.lex_state = 0, .external_lex_state = 336},
  [19786] = {.lex_state = 1, .external_lex_state = 440},
  [19787] = {.lex_state = 0, .external_lex_state = 405},
  [19788] = {.lex_state = 0, .external_lex_state = 336},
  [19789] = {.lex_state = 1, .external_lex_state = 440},
  [19790] = {.lex_state = 1, .external_lex_state = 440},
  [19791] = {.lex_state = 1, .external_lex_state = 440},
  [19792] = {.lex_state = 0, .external_lex_state = 336},
  [19793] = {.lex_state = 1, .external_lex_state = 440},
  [19794] = {.lex_state = 0, .external_lex_state = 404},
  [19795] = {.lex_state = 0, .external_lex_state = 336},
  [19796] = {.lex_state = 0, .external_lex_state = 336},
  [19797] = {.lex_state = 0, .external_lex_state = 336},
  [19798] = {.lex_state = 0, .external_lex_state = 336},
  [19799] = {.lex_state = 0, .external_lex_state = 336},
  [19800] = {.lex_state = 1, .external_lex_state = 440},
  [19801] = {.lex_state = 1, .external_lex_state = 440},
  [19802] = {.lex_state = 1, .external_lex_state = 440},
  [19803] = {.lex_state = 0, .external_lex_state = 336},
  [19804] = {.lex_state = 1, .external_lex_state = 440},
  [19805] = {.lex_state = 0, .external_lex_state = 404},
  [19806] = {.lex_state = 0, .external_lex_state = 404},
  [19807] = {.lex_state = 0, .external_lex_state = 336},
  [19808] = {.lex_state = 0, .external_lex_state = 336},
  [19809] = {.lex_state = 0, .external_lex_state = 336},
  [19810] = {.lex_state = 55, .external_lex_state = 308},
  [19811] = {.lex_state = 0, .external_lex_state = 336},
  [19812] = {.lex_state = 0, .external_lex_state = 336},
  [19813] = {.lex_state = 0, .external_lex_state = 404},
  [19814] = {.lex_state = 0, .external_lex_state = 404},
  [19815] = {.lex_state = 0, .external_lex_state = 336},
  [19816] = {.lex_state = 0, .external_lex_state = 336},
  [19817] = {.lex_state = 0, .external_lex_state = 336},
  [19818] = {.lex_state = 0, .external_lex_state = 336},
  [19819] = {.lex_state = 1, .external_lex_state = 440},
  [19820] = {.lex_state = 58, .external_lex_state = 308},
  [19821] = {.lex_state = 1, .external_lex_state = 440},
  [19822] = {.lex_state = 1, .external_lex_state = 440},
  [19823] = {.lex_state = 1, .external_lex_state = 440},
  [19824] = {.lex_state = 0, .external_lex_state = 336},
  [19825] = {.lex_state = 1, .external_lex_state = 440},
  [19826] = {.lex_state = 0, .external_lex_state = 336},
  [19827] = {.lex_state = 0, .external_lex_state = 336},
  [19828] = {.lex_state = 0, .external_lex_state = 404},
  [19829] = {.lex_state = 0, .external_lex_state = 336},
  [19830] = {.lex_state = 0, .external_lex_state = 404},
  [19831] = {.lex_state = 0, .external_lex_state = 336},
  [19832] = {.lex_state = 1, .external_lex_state = 440},
  [19833] = {.lex_state = 0, .external_lex_state = 336},
  [19834] = {.lex_state = 0, .external_lex_state = 336},
  [19835] = {.lex_state = 0, .external_lex_state = 336},
  [19836] = {.lex_state = 1, .external_lex_state = 440},
  [19837] = {.lex_state = 0, .external_lex_state = 336},
  [19838] = {.lex_state = 0, .external_lex_state = 336},
  [19839] = {.lex_state = 1, .external_lex_state = 440},
  [19840] = {.lex_state = 0, .external_lex_state = 336},
  [19841] = {.lex_state = 1, .external_lex_state = 440},
  [19842] = {.lex_state = 0, .external_lex_state = 336},
  [19843] = {.lex_state = 0, .external_lex_state = 405},
  [19844] = {.lex_state = 0, .external_lex_state = 404},
  [19845] = {.lex_state = 0, .external_lex_state = 336},
  [19846] = {.lex_state = 0, .external_lex_state = 336},
  [19847] = {.lex_state = 0, .external_lex_state = 404},
  [19848] = {.lex_state = 0, .external_lex_state = 404},
  [19849] = {.lex_state = 0, .external_lex_state = 336},
  [19850] = {.lex_state = 0, .external_lex_state = 336},
  [19851] = {.lex_state = 1, .external_lex_state = 440},
  [19852] = {.lex_state = 0, .external_lex_state = 336},
  [19853] = {.lex_state = 1, .external_lex_state = 440},
  [19854] = {.lex_state = 0, .external_lex_state = 336},
  [19855] = {.lex_state = 0, .external_lex_state = 336},
  [19856] = {.lex_state = 0, .external_lex_state = 336},
  [19857] = {.lex_state = 1, .external_lex_state = 440},
  [19858] = {.lex_state = 1, .external_lex_state = 440},
  [19859] = {.lex_state = 1, .external_lex_state = 440},
  [19860] = {.lex_state = 0, .external_lex_state = 386},
  [19861] = {.lex_state = 0, .external_lex_state = 386},
  [19862] = {.lex_state = 1, .external_lex_state = 440},
  [19863] = {.lex_state = 0, .external_lex_state = 336},
  [19864] = {.lex_state = 0, .external_lex_state = 405},
  [19865] = {.lex_state = 0, .external_lex_state = 404},
  [19866] = {.lex_state = 0, .external_lex_state = 336},
  [19867] = {.lex_state = 0, .external_lex_state = 336},
  [19868] = {.lex_state = 0, .external_lex_state = 336},
  [19869] = {.lex_state = 1, .external_lex_state = 440},
  [19870] = {.lex_state = 0, .external_lex_state = 336},
  [19871] = {.lex_state = 0, .external_lex_state = 336},
  [19872] = {.lex_state = 0, .external_lex_state = 336},
  [19873] = {.lex_state = 0, .external_lex_state = 336},
  [19874] = {.lex_state = 0, .external_lex_state = 404},
  [19875] = {.lex_state = 0, .external_lex_state = 404},
  [19876] = {.lex_state = 1, .external_lex_state = 440},
  [19877] = {.lex_state = 0, .external_lex_state = 405},
  [19878] = {.lex_state = 0, .external_lex_state = 336},
  [19879] = {.lex_state = 1, .external_lex_state = 440},
  [19880] = {.lex_state = 0, .external_lex_state = 336},
  [19881] = {.lex_state = 1, .external_lex_state = 440},
  [19882] = {.lex_state = 1, .external_lex_state = 440},
  [19883] = {.lex_state = 1, .external_lex_state = 440},
  [19884] = {.lex_state = 58, .external_lex_state = 308},
  [19885] = {.lex_state = 0, .external_lex_state = 386},
  [19886] = {.lex_state = 1, .external_lex_state = 440},
  [19887] = {.lex_state = 0, .external_lex_state = 336},
  [19888] = {.lex_state = 0, .external_lex_state = 405},
  [19889] = {.lex_state = 0, .external_lex_state = 405},
  [19890] = {.lex_state = 0, .external_lex_state = 404},
  [19891] = {.lex_state = 0, .external_lex_state = 336},
  [19892] = {.lex_state = 1, .external_lex_state = 440},
  [19893] = {.lex_state = 0, .external_lex_state = 336},
  [19894] = {.lex_state = 0, .external_lex_state = 336},
  [19895] = {.lex_state = 0, .external_lex_state = 336},
  [19896] = {.lex_state = 0, .external_lex_state = 336},
  [19897] = {.lex_state = 0, .external_lex_state = 336},
  [19898] = {.lex_state = 0, .external_lex_state = 336},
  [19899] = {.lex_state = 0, .external_lex_state = 336},
  [19900] = {.lex_state = 0, .external_lex_state = 336},
  [19901] = {.lex_state = 1, .external_lex_state = 440},
  [19902] = {.lex_state = 0, .external_lex_state = 336},
  [19903] = {.lex_state = 0, .external_lex_state = 439},
  [19904] = {.lex_state = 0, .external_lex_state = 404},
  [19905] = {.lex_state = 0, .external_lex_state = 336},
  [19906] = {.lex_state = 0, .external_lex_state = 404},
  [19907] = {.lex_state = 0, .external_lex_state = 404},
  [19908] = {.lex_state = 1, .external_lex_state = 440},
  [19909] = {.lex_state = 0, .external_lex_state = 386},
  [19910] = {.lex_state = 1, .external_lex_state = 440},
  [19911] = {.lex_state = 1, .external_lex_state = 440},
  [19912] = {.lex_state = 0, .external_lex_state = 436},
  [19913] = {.lex_state = 1, .external_lex_state = 440},
  [19914] = {.lex_state = 0, .external_lex_state = 404},
  [19915] = {.lex_state = 0, .external_lex_state = 336},
  [19916] = {.lex_state = 0, .external_lex_state = 336},
  [19917] = {.lex_state = 0, .external_lex_state = 336},
  [19918] = {.lex_state = 0, .external_lex_state = 404},
  [19919] = {.lex_state = 0, .external_lex_state = 336},
  [19920] = {.lex_state = 0, .external_lex_state = 336},
  [19921] = {.lex_state = 0, .external_lex_state = 336},
  [19922] = {.lex_state = 1, .external_lex_state = 440},
  [19923] = {.lex_state = 0, .external_lex_state = 336},
  [19924] = {.lex_state = 1, .external_lex_state = 440},
  [19925] = {.lex_state = 1, .external_lex_state = 440},
  [19926] = {.lex_state = 1, .external_lex_state = 440},
  [19927] = {.lex_state = 0, .external_lex_state = 336},
  [19928] = {.lex_state = 0, .external_lex_state = 336},
  [19929] = {.lex_state = 1, .external_lex_state = 440},
  [19930] = {.lex_state = 0, .external_lex_state = 404},
  [19931] = {.lex_state = 0, .external_lex_state = 336},
  [19932] = {.lex_state = 0, .external_lex_state = 336},
  [19933] = {.lex_state = 0, .external_lex_state = 336},
  [19934] = {.lex_state = 0, .external_lex_state = 404},
  [19935] = {.lex_state = 0, .external_lex_state = 336},
  [19936] = {.lex_state = 0, .external_lex_state = 336},
  [19937] = {.lex_state = 0, .external_lex_state = 336},
  [19938] = {.lex_state = 1, .external_lex_state = 440},
  [19939] = {.lex_state = 0, .external_lex_state = 336},
  [19940] = {.lex_state = 0, .external_lex_state = 336},
  [19941] = {.lex_state = 1, .external_lex_state = 440},
  [19942] = {.lex_state = 0, .external_lex_state = 336},
  [19943] = {.lex_state = 1, .external_lex_state = 440},
  [19944] = {.lex_state = 0, .external_lex_state = 386},
  [19945] = {.lex_state = 58, .external_lex_state = 308},
  [19946] = {.lex_state = 58, .external_lex_state = 308},
  [19947] = {.lex_state = 1, .external_lex_state = 440},
  [19948] = {.lex_state = 0, .external_lex_state = 336},
  [19949] = {.lex_state = 1, .external_lex_state = 440},
  [19950] = {.lex_state = 0, .external_lex_state = 405},
  [19951] = {.lex_state = 0, .external_lex_state = 336},
  [19952] = {.lex_state = 1, .external_lex_state = 440},
  [19953] = {.lex_state = 0, .external_lex_state = 336},
  [19954] = {.lex_state = 0, .external_lex_state = 336},
  [19955] = {.lex_state = 0, .external_lex_state = 336},
  [19956] = {.lex_state = 0, .external_lex_state = 404},
  [19957] = {.lex_state = 0, .external_lex_state = 336},
  [19958] = {.lex_state = 0, .external_lex_state = 336},
  [19959] = {.lex_state = 0, .external_lex_state = 336},
  [19960] = {.lex_state = 0, .external_lex_state = 336},
  [19961] = {.lex_state = 0, .external_lex_state = 336},
  [19962] = {.lex_state = 0, .external_lex_state = 336},
  [19963] = {.lex_state = 0, .external_lex_state = 336},
  [19964] = {.lex_state = 0, .external_lex_state = 404},
  [19965] = {.lex_state = 0, .external_lex_state = 336},
  [19966] = {.lex_state = 1, .external_lex_state = 440},
  [19967] = {.lex_state = 0, .external_lex_state = 405},
  [19968] = {.lex_state = 1, .external_lex_state = 440},
  [19969] = {.lex_state = 1, .external_lex_state = 440},
  [19970] = {.lex_state = 0, .external_lex_state = 336},
  [19971] = {.lex_state = 1, .external_lex_state = 440},
  [19972] = {.lex_state = 1, .external_lex_state = 440},
  [19973] = {.lex_state = 1, .external_lex_state = 440},
  [19974] = {.lex_state = 0, .external_lex_state = 336},
  [19975] = {.lex_state = 0, .external_lex_state = 405},
  [19976] = {.lex_state = 0, .external_lex_state = 386},
  [19977] = {.lex_state = 55, .external_lex_state = 308},
  [19978] = {.lex_state = 0, .external_lex_state = 404},
  [19979] = {.lex_state = 0, .external_lex_state = 336},
  [19980] = {.lex_state = 0, .external_lex_state = 404},
  [19981] = {.lex_state = 0, .external_lex_state = 336},
  [19982] = {.lex_state = 1, .external_lex_state = 440},
  [19983] = {.lex_state = 0, .external_lex_state = 336},
  [19984] = {.lex_state = 0, .external_lex_state = 336},
  [19985] = {.lex_state = 0, .external_lex_state = 336},
  [19986] = {.lex_state = 1, .external_lex_state = 440},
  [19987] = {.lex_state = 0, .external_lex_state = 336},
  [19988] = {.lex_state = 0, .external_lex_state = 336},
  [19989] = {.lex_state = 0, .external_lex_state = 404},
  [19990] = {.lex_state = 0, .external_lex_state = 336},
  [19991] = {.lex_state = 1, .external_lex_state = 440},
  [19992] = {.lex_state = 0, .external_lex_state = 336},
  [19993] = {.lex_state = 0, .external_lex_state = 336},
  [19994] = {.lex_state = 0, .external_lex_state = 404},
  [19995] = {.lex_state = 1, .external_lex_state = 440},
  [19996] = {.lex_state = 0, .external_lex_state = 336},
  [19997] = {.lex_state = 0, .external_lex_state = 405},
  [19998] = {.lex_state = 58, .external_lex_state = 308},
  [19999] = {.lex_state = 0, .external_lex_state = 404},
  [20000] = {.lex_state = 57, .external_lex_state = 308},
  [20001] = {.lex_state = 1, .external_lex_state = 440},
  [20002] = {.lex_state = 0, .external_lex_state = 439},
  [20003] = {.lex_state = 1, .external_lex_state = 440},
  [20004] = {.lex_state = 0, .external_lex_state = 405},
  [20005] = {.lex_state = 0, .external_lex_state = 336},
  [20006] = {.lex_state = 0, .external_lex_state = 336},
  [20007] = {.lex_state = 0, .external_lex_state = 336},
  [20008] = {.lex_state = 0, .external_lex_state = 336},
  [20009] = {.lex_state = 0, .external_lex_state = 336},
  [20010] = {.lex_state = 0, .external_lex_state = 336},
  [20011] = {.lex_state = 1, .external_lex_state = 440},
  [20012] = {.lex_state = 0, .external_lex_state = 336},
  [20013] = {.lex_state = 1, .external_lex_state = 440},
  [20014] = {.lex_state = 0, .external_lex_state = 386},
  [20015] = {.lex_state = 1, .external_lex_state = 440},
  [20016] = {.lex_state = 0, .external_lex_state = 336},
  [20017] = {.lex_state = 0, .external_lex_state = 336},
  [20018] = {.lex_state = 0, .external_lex_state = 386},
  [20019] = {.lex_state = 0, .external_lex_state = 336},
  [20020] = {.lex_state = 1, .external_lex_state = 440},
  [20021] = {.lex_state = 0, .external_lex_state = 336},
  [20022] = {.lex_state = 0, .external_lex_state = 336},
  [20023] = {.lex_state = 0, .external_lex_state = 404},
  [20024] = {.lex_state = 0, .external_lex_state = 308},
  [20025] = {.lex_state = 0, .external_lex_state = 404},
  [20026] = {.lex_state = 0, .external_lex_state = 404},
  [20027] = {.lex_state = 0, .external_lex_state = 336},
  [20028] = {.lex_state = 0, .external_lex_state = 336},
  [20029] = {.lex_state = 1, .external_lex_state = 440},
  [20030] = {.lex_state = 0, .external_lex_state = 336},
  [20031] = {.lex_state = 1, .external_lex_state = 440},
  [20032] = {.lex_state = 55, .external_lex_state = 308},
  [20033] = {.lex_state = 1, .external_lex_state = 440},
  [20034] = {.lex_state = 0, .external_lex_state = 336},
  [20035] = {.lex_state = 0, .external_lex_state = 336},
  [20036] = {.lex_state = 0, .external_lex_state = 336},
  [20037] = {.lex_state = 1, .external_lex_state = 440},
  [20038] = {.lex_state = 0, .external_lex_state = 336},
  [20039] = {.lex_state = 1, .external_lex_state = 440},
  [20040] = {.lex_state = 55, .external_lex_state = 308},
  [20041] = {.lex_state = 1, .external_lex_state = 440},
  [20042] = {.lex_state = 0, .external_lex_state = 336},
  [20043] = {.lex_state = 1, .external_lex_state = 440},
  [20044] = {.lex_state = 0, .external_lex_state = 336},
  [20045] = {.lex_state = 0, .external_lex_state = 336},
  [20046] = {.lex_state = 0, .external_lex_state = 405},
  [20047] = {.lex_state = 1, .external_lex_state = 440},
  [20048] = {.lex_state = 0, .external_lex_state = 336},
  [20049] = {.lex_state = 0, .external_lex_state = 336},
  [20050] = {.lex_state = 0, .external_lex_state = 404},
  [20051] = {.lex_state = 0, .external_lex_state = 404},
  [20052] = {.lex_state = 0, .external_lex_state = 336},
  [20053] = {.lex_state = 0, .external_lex_state = 336},
  [20054] = {.lex_state = 0, .external_lex_state = 386},
  [20055] = {.lex_state = 0, .external_lex_state = 336},
  [20056] = {.lex_state = 0, .external_lex_state = 336},
  [20057] = {.lex_state = 1, .external_lex_state = 440},
  [20058] = {.lex_state = 0, .external_lex_state = 200},
  [20059] = {.lex_state = 1, .external_lex_state = 440},
  [20060] = {.lex_state = 0, .external_lex_state = 336},
  [20061] = {.lex_state = 0, .external_lex_state = 336},
  [20062] = {.lex_state = 1, .external_lex_state = 440},
  [20063] = {.lex_state = 0, .external_lex_state = 336},
  [20064] = {.lex_state = 1, .external_lex_state = 440},
  [20065] = {.lex_state = 1, .external_lex_state = 440},
  [20066] = {.lex_state = 0, .external_lex_state = 367},
  [20067] = {.lex_state = 1, .external_lex_state = 440},
  [20068] = {.lex_state = 0, .external_lex_state = 336},
  [20069] = {.lex_state = 1, .external_lex_state = 440},
  [20070] = {.lex_state = 0, .external_lex_state = 405},
  [20071] = {.lex_state = 0, .external_lex_state = 404},
  [20072] = {.lex_state = 0, .external_lex_state = 336},
  [20073] = {.lex_state = 0, .external_lex_state = 336},
  [20074] = {.lex_state = 0, .external_lex_state = 336},
  [20075] = {.lex_state = 0, .external_lex_state = 336},
  [20076] = {.lex_state = 0, .external_lex_state = 336},
  [20077] = {.lex_state = 0, .external_lex_state = 336},
  [20078] = {.lex_state = 0, .external_lex_state = 336},
  [20079] = {.lex_state = 0, .external_lex_state = 404},
  [20080] = {.lex_state = 1, .external_lex_state = 440},
  [20081] = {.lex_state = 1, .external_lex_state = 440},
  [20082] = {.lex_state = 0, .external_lex_state = 405},
  [20083] = {.lex_state = 1, .external_lex_state = 440},
  [20084] = {.lex_state = 1, .external_lex_state = 440},
  [20085] = {.lex_state = 1, .external_lex_state = 440},
  [20086] = {.lex_state = 0, .external_lex_state = 336},
  [20087] = {.lex_state = 1, .external_lex_state = 440},
  [20088] = {.lex_state = 0, .external_lex_state = 386},
  [20089] = {.lex_state = 0, .external_lex_state = 336},
  [20090] = {.lex_state = 0, .external_lex_state = 404},
  [20091] = {.lex_state = 0, .external_lex_state = 336},
  [20092] = {.lex_state = 0, .external_lex_state = 336},
  [20093] = {.lex_state = 0, .external_lex_state = 336},
  [20094] = {.lex_state = 0, .external_lex_state = 336},
  [20095] = {.lex_state = 1, .external_lex_state = 440},
  [20096] = {.lex_state = 0, .external_lex_state = 336},
  [20097] = {.lex_state = 1, .external_lex_state = 440},
  [20098] = {.lex_state = 0, .external_lex_state = 336},
  [20099] = {.lex_state = 1, .external_lex_state = 440},
  [20100] = {.lex_state = 0, .external_lex_state = 336},
  [20101] = {.lex_state = 0, .external_lex_state = 336},
  [20102] = {.lex_state = 1, .external_lex_state = 440},
  [20103] = {.lex_state = 0, .external_lex_state = 336},
  [20104] = {.lex_state = 0, .external_lex_state = 386},
  [20105] = {.lex_state = 0, .external_lex_state = 336},
  [20106] = {.lex_state = 0, .external_lex_state = 386},
  [20107] = {.lex_state = 0, .external_lex_state = 404},
  [20108] = {.lex_state = 0, .external_lex_state = 439},
  [20109] = {.lex_state = 0, .external_lex_state = 405},
  [20110] = {.lex_state = 0, .external_lex_state = 386},
  [20111] = {.lex_state = 0, .external_lex_state = 404},
  [20112] = {.lex_state = 0, .external_lex_state = 404},
  [20113] = {.lex_state = 1, .external_lex_state = 440},
  [20114] = {.lex_state = 0, .external_lex_state = 336},
  [20115] = {.lex_state = 1, .external_lex_state = 440},
  [20116] = {.lex_state = 0, .external_lex_state = 336},
  [20117] = {.lex_state = 0, .external_lex_state = 336},
  [20118] = {.lex_state = 0, .external_lex_state = 336},
  [20119] = {.lex_state = 0, .external_lex_state = 336},
  [20120] = {.lex_state = 1, .external_lex_state = 440},
  [20121] = {.lex_state = 1, .external_lex_state = 440},
  [20122] = {.lex_state = 0, .external_lex_state = 404},
  [20123] = {.lex_state = 1, .external_lex_state = 440},
  [20124] = {.lex_state = 0, .external_lex_state = 336},
  [20125] = {.lex_state = 1, .external_lex_state = 440},
  [20126] = {.lex_state = 0, .external_lex_state = 386},
  [20127] = {.lex_state = 0, .external_lex_state = 404},
  [20128] = {.lex_state = 0, .external_lex_state = 336},
  [20129] = {.lex_state = 0, .external_lex_state = 336},
  [20130] = {.lex_state = 0, .external_lex_state = 336},
  [20131] = {.lex_state = 0, .external_lex_state = 336},
  [20132] = {.lex_state = 0, .external_lex_state = 336},
  [20133] = {.lex_state = 0, .external_lex_state = 336},
  [20134] = {.lex_state = 0, .external_lex_state = 336},
  [20135] = {.lex_state = 0, .external_lex_state = 404},
  [20136] = {.lex_state = 0, .external_lex_state = 386},
  [20137] = {.lex_state = 0, .external_lex_state = 336},
  [20138] = {.lex_state = 0, .external_lex_state = 336},
  [20139] = {.lex_state = 58, .external_lex_state = 308},
  [20140] = {.lex_state = 1, .external_lex_state = 440},
  [20141] = {.lex_state = 1, .external_lex_state = 440},
  [20142] = {.lex_state = 0, .external_lex_state = 336},
  [20143] = {.lex_state = 1, .external_lex_state = 440},
  [20144] = {.lex_state = 0, .external_lex_state = 405},
  [20145] = {.lex_state = 0, .external_lex_state = 336},
  [20146] = {.lex_state = 1, .external_lex_state = 440},
  [20147] = {.lex_state = 1, .external_lex_state = 440},
  [20148] = {.lex_state = 1, .external_lex_state = 440},
  [20149] = {.lex_state = 0, .external_lex_state = 336},
  [20150] = {.lex_state = 58, .external_lex_state = 308},
  [20151] = {.lex_state = 1, .external_lex_state = 440},
  [20152] = {.lex_state = 0, .external_lex_state = 336},
  [20153] = {.lex_state = 0, .external_lex_state = 336},
  [20154] = {.lex_state = 0, .external_lex_state = 404},
  [20155] = {.lex_state = 0, .external_lex_state = 336},
  [20156] = {.lex_state = 0, .external_lex_state = 336},
  [20157] = {.lex_state = 0, .external_lex_state = 336},
  [20158] = {.lex_state = 0, .external_lex_state = 336},
  [20159] = {.lex_state = 0, .external_lex_state = 367},
  [20160] = {.lex_state = 0, .external_lex_state = 336},
  [20161] = {.lex_state = 0, .external_lex_state = 336},
  [20162] = {.lex_state = 0, .external_lex_state = 336},
  [20163] = {.lex_state = 0, .external_lex_state = 404},
  [20164] = {.lex_state = 0, .external_lex_state = 404},
  [20165] = {.lex_state = 0, .external_lex_state = 336},
  [20166] = {.lex_state = 0, .external_lex_state = 404},
  [20167] = {.lex_state = 0, .external_lex_state = 336},
  [20168] = {.lex_state = 1, .external_lex_state = 440},
  [20169] = {.lex_state = 1, .external_lex_state = 440},
  [20170] = {.lex_state = 0, .external_lex_state = 336},
  [20171] = {.lex_state = 1, .external_lex_state = 440},
  [20172] = {.lex_state = 0, .external_lex_state = 336},
  [20173] = {.lex_state = 0, .external_lex_state = 336},
  [20174] = {.lex_state = 1, .external_lex_state = 440},
  [20175] = {.lex_state = 1, .external_lex_state = 440},
  [20176] = {.lex_state = 0, .external_lex_state = 336},
  [20177] = {.lex_state = 0, .external_lex_state = 336},
  [20178] = {.lex_state = 0, .external_lex_state = 405},
  [20179] = {.lex_state = 1, .external_lex_state = 440},
  [20180] = {.lex_state = 0, .external_lex_state = 336},
  [20181] = {.lex_state = 0, .external_lex_state = 404},
  [20182] = {.lex_state = 0, .external_lex_state = 336},
  [20183] = {.lex_state = 0, .external_lex_state = 336},
  [20184] = {.lex_state = 0, .external_lex_state = 336},
  [20185] = {.lex_state = 0, .external_lex_state = 308},
  [20186] = {.lex_state = 0, .external_lex_state = 336},
  [20187] = {.lex_state = 0, .external_lex_state = 336},
  [20188] = {.lex_state = 1, .external_lex_state = 308},
  [20189] = {.lex_state = 0, .external_lex_state = 336},
  [20190] = {.lex_state = 0, .external_lex_state = 336},
  [20191] = {.lex_state = 4, .external_lex_state = 308},
  [20192] = {.lex_state = 1, .external_lex_state = 308},
  [20193] = {.lex_state = 0, .external_lex_state = 336},
  [20194] = {.lex_state = 0, .external_lex_state = 336},
  [20195] = {.lex_state = 0, .external_lex_state = 336},
  [20196] = {.lex_state = 0, .external_lex_state = 336},
  [20197] = {.lex_state = 0, .external_lex_state = 336},
  [20198] = {.lex_state = 0, .external_lex_state = 336},
  [20199] = {.lex_state = 1, .external_lex_state = 308},
  [20200] = {.lex_state = 0, .external_lex_state = 336},
  [20201] = {.lex_state = 0, .external_lex_state = 336},
  [20202] = {.lex_state = 1, .external_lex_state = 308},
  [20203] = {.lex_state = 0, .external_lex_state = 336},
  [20204] = {.lex_state = 0, .external_lex_state = 336},
  [20205] = {.lex_state = 0, .external_lex_state = 336},
  [20206] = {.lex_state = 1, .external_lex_state = 308},
  [20207] = {.lex_state = 0, .external_lex_state = 336},
  [20208] = {.lex_state = 0, .external_lex_state = 336},
  [20209] = {.lex_state = 0, .external_lex_state = 336},
  [20210] = {.lex_state = 0, .external_lex_state = 336},
  [20211] = {.lex_state = 0, .external_lex_state = 336},
  [20212] = {.lex_state = 0, .external_lex_state = 336},
  [20213] = {.lex_state = 1, .external_lex_state = 308},
  [20214] = {.lex_state = 0, .external_lex_state = 336},
  [20215] = {.lex_state = 0, .external_lex_state = 336},
  [20216] = {.lex_state = 1, .external_lex_state = 308},
  [20217] = {.lex_state = 0, .external_lex_state = 336},
  [20218] = {.lex_state = 0, .external_lex_state = 336},
  [20219] = {.lex_state = 0, .external_lex_state = 336},
  [20220] = {.lex_state = 0, .external_lex_state = 336},
  [20221] = {.lex_state = 0, .external_lex_state = 336},
  [20222] = {.lex_state = 1, .external_lex_state = 308},
  [20223] = {.lex_state = 0, .external_lex_state = 336},
  [20224] = {.lex_state = 0, .external_lex_state = 336},
  [20225] = {.lex_state = 0, .external_lex_state = 336},
  [20226] = {.lex_state = 0, .external_lex_state = 336},
  [20227] = {.lex_state = 0, .external_lex_state = 336},
  [20228] = {.lex_state = 1, .external_lex_state = 308},
  [20229] = {.lex_state = 1, .external_lex_state = 308},
  [20230] = {.lex_state = 1, .external_lex_state = 308},
  [20231] = {.lex_state = 0, .external_lex_state = 336},
  [20232] = {.lex_state = 0, .external_lex_state = 336},
  [20233] = {.lex_state = 0, .external_lex_state = 336},
  [20234] = {.lex_state = 1, .external_lex_state = 308},
  [20235] = {.lex_state = 1, .external_lex_state = 308},
  [20236] = {.lex_state = 0, .external_lex_state = 336},
  [20237] = {.lex_state = 55, .external_lex_state = 442},
  [20238] = {.lex_state = 55, .external_lex_state = 308},
  [20239] = {.lex_state = 1, .external_lex_state = 308},
  [20240] = {.lex_state = 1, .external_lex_state = 308},
  [20241] = {.lex_state = 1, .external_lex_state = 308},
  [20242] = {.lex_state = 0, .external_lex_state = 333},
  [20243] = {.lex_state = 0, .external_lex_state = 333},
  [20244] = {.lex_state = 1, .external_lex_state = 308},
  [20245] = {.lex_state = 0, .external_lex_state = 333},
  [20246] = {.lex_state = 0, .external_lex_state = 333},
  [20247] = {.lex_state = 0, .external_lex_state = 333},
  [20248] = {.lex_state = 0, .external_lex_state = 333},
  [20249] = {.lex_state = 0, .external_lex_state = 308},
  [20250] = {.lex_state = 0, .external_lex_state = 333},
  [20251] = {.lex_state = 4, .external_lex_state = 308},
  [20252] = {.lex_state = 55, .external_lex_state = 308},
  [20253] = {.lex_state = 0, .external_lex_state = 333},
  [20254] = {.lex_state = 1, .external_lex_state = 308},
  [20255] = {.lex_state = 1, .external_lex_state = 308},
  [20256] = {.lex_state = 0, .external_lex_state = 333},
  [20257] = {.lex_state = 0, .external_lex_state = 333},
  [20258] = {.lex_state = 1, .external_lex_state = 308},
  [20259] = {.lex_state = 0, .external_lex_state = 333},
  [20260] = {.lex_state = 55, .external_lex_state = 308},
  [20261] = {.lex_state = 0, .external_lex_state = 333},
  [20262] = {.lex_state = 1, .external_lex_state = 308},
  [20263] = {.lex_state = 0, .external_lex_state = 333},
  [20264] = {.lex_state = 0, .external_lex_state = 333},
  [20265] = {.lex_state = 0, .external_lex_state = 333},
  [20266] = {.lex_state = 0, .external_lex_state = 333},
  [20267] = {.lex_state = 55, .external_lex_state = 442},
  [20268] = {.lex_state = 1, .external_lex_state = 308},
  [20269] = {.lex_state = 0, .external_lex_state = 308},
  [20270] = {.lex_state = 0, .external_lex_state = 333},
  [20271] = {.lex_state = 1, .external_lex_state = 308},
  [20272] = {.lex_state = 1, .external_lex_state = 308},
  [20273] = {.lex_state = 0, .external_lex_state = 439},
  [20274] = {.lex_state = 0, .external_lex_state = 333},
  [20275] = {.lex_state = 55, .external_lex_state = 308},
  [20276] = {.lex_state = 0, .external_lex_state = 333},
  [20277] = {.lex_state = 0, .external_lex_state = 333},
  [20278] = {.lex_state = 0, .external_lex_state = 333},
  [20279] = {.lex_state = 0, .external_lex_state = 333},
  [20280] = {.lex_state = 1, .external_lex_state = 308},
  [20281] = {.lex_state = 0, .external_lex_state = 333},
  [20282] = {.lex_state = 0, .external_lex_state = 404},
  [20283] = {.lex_state = 0, .external_lex_state = 333},
  [20284] = {.lex_state = 55, .external_lex_state = 308},
  [20285] = {.lex_state = 4, .external_lex_state = 308},
  [20286] = {.lex_state = 1, .external_lex_state = 308},
  [20287] = {.lex_state = 0, .external_lex_state = 333},
  [20288] = {.lex_state = 55, .external_lex_state = 308},
  [20289] = {.lex_state = 0, .external_lex_state = 333},
  [20290] = {.lex_state = 1, .external_lex_state = 308},
  [20291] = {.lex_state = 55, .external_lex_state = 308},
  [20292] = {.lex_state = 1, .external_lex_state = 308},
  [20293] = {.lex_state = 0, .external_lex_state = 333},
  [20294] = {.lex_state = 55, .external_lex_state = 308},
  [20295] = {.lex_state = 58, .external_lex_state = 397},
  [20296] = {.lex_state = 0, .external_lex_state = 333},
  [20297] = {.lex_state = 55, .external_lex_state = 308},
  [20298] = {.lex_state = 0, .external_lex_state = 333},
  [20299] = {.lex_state = 55, .external_lex_state = 308},
  [20300] = {.lex_state = 1, .external_lex_state = 308},
  [20301] = {.lex_state = 58, .external_lex_state = 397},
  [20302] = {.lex_state = 0, .external_lex_state = 333},
  [20303] = {.lex_state = 1, .external_lex_state = 308},
  [20304] = {.lex_state = 55, .external_lex_state = 308},
  [20305] = {.lex_state = 55, .external_lex_state = 308},
  [20306] = {.lex_state = 58, .external_lex_state = 397},
  [20307] = {.lex_state = 0, .external_lex_state = 333},
  [20308] = {.lex_state = 0, .external_lex_state = 404},
  [20309] = {.lex_state = 55, .external_lex_state = 308},
  [20310] = {.lex_state = 0, .external_lex_state = 404},
  [20311] = {.lex_state = 55, .external_lex_state = 308},
  [20312] = {.lex_state = 0, .external_lex_state = 333},
  [20313] = {.lex_state = 55, .external_lex_state = 308},
  [20314] = {.lex_state = 1, .external_lex_state = 308},
  [20315] = {.lex_state = 0, .external_lex_state = 333},
  [20316] = {.lex_state = 55, .external_lex_state = 308},
  [20317] = {.lex_state = 0, .external_lex_state = 333},
  [20318] = {.lex_state = 1, .external_lex_state = 308},
  [20319] = {.lex_state = 55, .external_lex_state = 308},
  [20320] = {.lex_state = 0, .external_lex_state = 333},
  [20321] = {.lex_state = 55, .external_lex_state = 308},
  [20322] = {.lex_state = 0, .external_lex_state = 333},
  [20323] = {.lex_state = 55, .external_lex_state = 308},
  [20324] = {.lex_state = 1, .external_lex_state = 308},
  [20325] = {.lex_state = 0, .external_lex_state = 404},
  [20326] = {.lex_state = 0, .external_lex_state = 333},
  [20327] = {.lex_state = 55, .external_lex_state = 442},
  [20328] = {.lex_state = 1, .external_lex_state = 308},
  [20329] = {.lex_state = 55, .external_lex_state = 308},
  [20330] = {.lex_state = 0, .external_lex_state = 333},
  [20331] = {.lex_state = 55, .external_lex_state = 308},
  [20332] = {.lex_state = 0, .external_lex_state = 333},
  [20333] = {.lex_state = 55, .external_lex_state = 308},
  [20334] = {.lex_state = 0, .external_lex_state = 333},
  [20335] = {.lex_state = 55, .external_lex_state = 308},
  [20336] = {.lex_state = 1, .external_lex_state = 308},
  [20337] = {.lex_state = 0, .external_lex_state = 333},
  [20338] = {.lex_state = 55, .external_lex_state = 308},
  [20339] = {.lex_state = 55, .external_lex_state = 308},
  [20340] = {.lex_state = 0, .external_lex_state = 333},
  [20341] = {.lex_state = 55, .external_lex_state = 308},
  [20342] = {.lex_state = 1, .external_lex_state = 308},
  [20343] = {.lex_state = 55, .external_lex_state = 308},
  [20344] = {.lex_state = 55, .external_lex_state = 308},
  [20345] = {.lex_state = 0, .external_lex_state = 333},
  [20346] = {.lex_state = 1, .external_lex_state = 308},
  [20347] = {.lex_state = 1, .external_lex_state = 308},
  [20348] = {.lex_state = 0, .external_lex_state = 336},
  [20349] = {.lex_state = 55, .external_lex_state = 308},
  [20350] = {.lex_state = 0, .external_lex_state = 308},
  [20351] = {.lex_state = 55, .external_lex_state = 308},
  [20352] = {.lex_state = 58, .external_lex_state = 400},
  [20353] = {.lex_state = 0, .external_lex_state = 333},
  [20354] = {.lex_state = 55, .external_lex_state = 308},
  [20355] = {.lex_state = 55, .external_lex_state = 308},
  [20356] = {.lex_state = 1, .external_lex_state = 308},
  [20357] = {.lex_state = 0, .external_lex_state = 336},
  [20358] = {.lex_state = 0, .external_lex_state = 308},
  [20359] = {.lex_state = 0, .external_lex_state = 348},
  [20360] = {.lex_state = 1, .external_lex_state = 308},
  [20361] = {.lex_state = 55, .external_lex_state = 308},
  [20362] = {.lex_state = 55, .external_lex_state = 308},
  [20363] = {.lex_state = 0, .external_lex_state = 336},
  [20364] = {.lex_state = 0, .external_lex_state = 333},
  [20365] = {.lex_state = 55, .external_lex_state = 308},
  [20366] = {.lex_state = 55, .external_lex_state = 308},
  [20367] = {.lex_state = 4, .external_lex_state = 308},
  [20368] = {.lex_state = 55, .external_lex_state = 442},
  [20369] = {.lex_state = 1, .external_lex_state = 308},
  [20370] = {.lex_state = 1, .external_lex_state = 308},
  [20371] = {.lex_state = 0, .external_lex_state = 308},
  [20372] = {.lex_state = 1, .external_lex_state = 308},
  [20373] = {.lex_state = 1, .external_lex_state = 308},
  [20374] = {.lex_state = 1, .external_lex_state = 308},
  [20375] = {.lex_state = 0, .external_lex_state = 333},
  [20376] = {.lex_state = 1, .external_lex_state = 308},
  [20377] = {.lex_state = 0, .external_lex_state = 336},
  [20378] = {.lex_state = 1, .external_lex_state = 308},
  [20379] = {.lex_state = 55, .external_lex_state = 308},
  [20380] = {.lex_state = 4, .external_lex_state = 308},
  [20381] = {.lex_state = 1, .external_lex_state = 308},
  [20382] = {.lex_state = 1, .external_lex_state = 308},
  [20383] = {.lex_state = 1, .external_lex_state = 308},
  [20384] = {.lex_state = 1, .external_lex_state = 308},
  [20385] = {.lex_state = 55, .external_lex_state = 308},
  [20386] = {.lex_state = 55, .external_lex_state = 308},
  [20387] = {.lex_state = 0, .external_lex_state = 308},
  [20388] = {.lex_state = 4, .external_lex_state = 308},
  [20389] = {.lex_state = 55, .external_lex_state = 308},
  [20390] = {.lex_state = 1, .external_lex_state = 308},
  [20391] = {.lex_state = 0, .external_lex_state = 336},
  [20392] = {.lex_state = 55, .external_lex_state = 308},
  [20393] = {.lex_state = 1, .external_lex_state = 308},
  [20394] = {.lex_state = 1, .external_lex_state = 308},
  [20395] = {.lex_state = 0, .external_lex_state = 308},
  [20396] = {.lex_state = 55, .external_lex_state = 442},
  [20397] = {.lex_state = 55, .external_lex_state = 308},
  [20398] = {.lex_state = 1, .external_lex_state = 308},
  [20399] = {.lex_state = 1, .external_lex_state = 308},
  [20400] = {.lex_state = 0, .external_lex_state = 308},
  [20401] = {.lex_state = 55, .external_lex_state = 308},
  [20402] = {.lex_state = 1, .external_lex_state = 308},
  [20403] = {.lex_state = 1, .external_lex_state = 308},
  [20404] = {.lex_state = 1, .external_lex_state = 308},
  [20405] = {.lex_state = 0, .external_lex_state = 336},
  [20406] = {.lex_state = 55, .external_lex_state = 308},
  [20407] = {.lex_state = 4, .external_lex_state = 308},
  [20408] = {.lex_state = 1, .external_lex_state = 308},
  [20409] = {.lex_state = 1, .external_lex_state = 308},
  [20410] = {.lex_state = 1, .external_lex_state = 308},
  [20411] = {.lex_state = 0, .external_lex_state = 336},
  [20412] = {.lex_state = 1, .external_lex_state = 308},
  [20413] = {.lex_state = 1, .external_lex_state = 308},
  [20414] = {.lex_state = 0, .external_lex_state = 308},
  [20415] = {.lex_state = 4, .external_lex_state = 308},
  [20416] = {.lex_state = 0, .external_lex_state = 308},
  [20417] = {.lex_state = 1, .external_lex_state = 308},
  [20418] = {.lex_state = 1, .external_lex_state = 308},
  [20419] = {.lex_state = 1, .external_lex_state = 308},
  [20420] = {.lex_state = 1, .external_lex_state = 308},
  [20421] = {.lex_state = 4, .external_lex_state = 308},
  [20422] = {.lex_state = 0, .external_lex_state = 333},
  [20423] = {.lex_state = 1, .external_lex_state = 308},
  [20424] = {.lex_state = 1, .external_lex_state = 308},
  [20425] = {.lex_state = 1, .external_lex_state = 308},
  [20426] = {.lex_state = 1, .external_lex_state = 308},
  [20427] = {.lex_state = 0, .external_lex_state = 308},
  [20428] = {.lex_state = 4, .external_lex_state = 308},
  [20429] = {.lex_state = 0, .external_lex_state = 404},
  [20430] = {.lex_state = 1, .external_lex_state = 308},
  [20431] = {.lex_state = 55, .external_lex_state = 308},
  [20432] = {.lex_state = 55, .external_lex_state = 308},
  [20433] = {.lex_state = 58, .external_lex_state = 397},
  [20434] = {.lex_state = 0, .external_lex_state = 336},
  [20435] = {.lex_state = 55, .external_lex_state = 308},
  [20436] = {.lex_state = 0, .external_lex_state = 439},
  [20437] = {.lex_state = 1, .external_lex_state = 308},
  [20438] = {.lex_state = 1, .external_lex_state = 308},
  [20439] = {.lex_state = 4, .external_lex_state = 308},
  [20440] = {.lex_state = 1, .external_lex_state = 308},
  [20441] = {.lex_state = 0, .external_lex_state = 439},
  [20442] = {.lex_state = 4, .external_lex_state = 308},
  [20443] = {.lex_state = 0, .external_lex_state = 439},
  [20444] = {.lex_state = 1, .external_lex_state = 308},
  [20445] = {.lex_state = 0, .external_lex_state = 336},
  [20446] = {.lex_state = 0, .external_lex_state = 336},
  [20447] = {.lex_state = 1, .external_lex_state = 308},
  [20448] = {.lex_state = 4, .external_lex_state = 308},
  [20449] = {.lex_state = 1, .external_lex_state = 308},
  [20450] = {.lex_state = 4, .external_lex_state = 308},
  [20451] = {.lex_state = 0, .external_lex_state = 439},
  [20452] = {.lex_state = 0, .external_lex_state = 336},
  [20453] = {.lex_state = 0, .external_lex_state = 308},
  [20454] = {.lex_state = 1, .external_lex_state = 308},
  [20455] = {.lex_state = 55, .external_lex_state = 442},
  [20456] = {.lex_state = 4, .external_lex_state = 308},
  [20457] = {.lex_state = 0, .external_lex_state = 439},
  [20458] = {.lex_state = 1, .external_lex_state = 308},
  [20459] = {.lex_state = 1, .external_lex_state = 308},
  [20460] = {.lex_state = 55, .external_lex_state = 308},
  [20461] = {.lex_state = 0, .external_lex_state = 308},
  [20462] = {.lex_state = 4, .external_lex_state = 308},
  [20463] = {.lex_state = 0, .external_lex_state = 333},
  [20464] = {.lex_state = 0, .external_lex_state = 439},
  [20465] = {.lex_state = 1, .external_lex_state = 308},
  [20466] = {.lex_state = 1, .external_lex_state = 308},
  [20467] = {.lex_state = 4, .external_lex_state = 308},
  [20468] = {.lex_state = 1, .external_lex_state = 308},
  [20469] = {.lex_state = 4, .external_lex_state = 308},
  [20470] = {.lex_state = 0, .external_lex_state = 439},
  [20471] = {.lex_state = 1, .external_lex_state = 308},
  [20472] = {.lex_state = 1, .external_lex_state = 308},
  [20473] = {.lex_state = 4, .external_lex_state = 308},
  [20474] = {.lex_state = 4, .external_lex_state = 308},
  [20475] = {.lex_state = 1, .external_lex_state = 308},
  [20476] = {.lex_state = 0, .external_lex_state = 439},
  [20477] = {.lex_state = 0, .external_lex_state = 308},
  [20478] = {.lex_state = 58, .external_lex_state = 397},
  [20479] = {.lex_state = 1, .external_lex_state = 308},
  [20480] = {.lex_state = 1, .external_lex_state = 308},
  [20481] = {.lex_state = 4, .external_lex_state = 308},
  [20482] = {.lex_state = 1, .external_lex_state = 308},
  [20483] = {.lex_state = 0, .external_lex_state = 308},
  [20484] = {.lex_state = 0, .external_lex_state = 439},
  [20485] = {.lex_state = 0, .external_lex_state = 308},
  [20486] = {.lex_state = 1, .external_lex_state = 308},
  [20487] = {.lex_state = 0, .external_lex_state = 308},
  [20488] = {.lex_state = 0, .external_lex_state = 336},
  [20489] = {.lex_state = 4, .external_lex_state = 308},
  [20490] = {.lex_state = 0, .external_lex_state = 439},
  [20491] = {.lex_state = 0, .external_lex_state = 336},
  [20492] = {.lex_state = 1, .external_lex_state = 308},
  [20493] = {.lex_state = 4, .external_lex_state = 308},
  [20494] = {.lex_state = 0, .external_lex_state = 439},
  [20495] = {.lex_state = 0, .external_lex_state = 333},
  [20496] = {.lex_state = 1, .external_lex_state = 308},
  [20497] = {.lex_state = 1, .external_lex_state = 308},
  [20498] = {.lex_state = 1, .external_lex_state = 308},
  [20499] = {.lex_state = 4, .external_lex_state = 308},
  [20500] = {.lex_state = 4, .external_lex_state = 308},
  [20501] = {.lex_state = 0, .external_lex_state = 439},
  [20502] = {.lex_state = 1, .external_lex_state = 308},
  [20503] = {.lex_state = 0, .external_lex_state = 308},
  [20504] = {.lex_state = 1, .external_lex_state = 308},
  [20505] = {.lex_state = 55, .external_lex_state = 308},
  [20506] = {.lex_state = 0, .external_lex_state = 308},
  [20507] = {.lex_state = 4, .external_lex_state = 308},
  [20508] = {.lex_state = 0, .external_lex_state = 439},
  [20509] = {.lex_state = 4, .external_lex_state = 308},
  [20510] = {.lex_state = 1, .external_lex_state = 308},
  [20511] = {.lex_state = 0, .external_lex_state = 308},
  [20512] = {.lex_state = 55, .external_lex_state = 308},
  [20513] = {.lex_state = 4, .external_lex_state = 308},
  [20514] = {.lex_state = 1, .external_lex_state = 308},
  [20515] = {.lex_state = 0, .external_lex_state = 439},
  [20516] = {.lex_state = 1, .external_lex_state = 308},
  [20517] = {.lex_state = 4, .external_lex_state = 308},
  [20518] = {.lex_state = 0, .external_lex_state = 439},
  [20519] = {.lex_state = 55, .external_lex_state = 442},
  [20520] = {.lex_state = 0, .external_lex_state = 308},
  [20521] = {.lex_state = 55, .external_lex_state = 308},
  [20522] = {.lex_state = 4, .external_lex_state = 308},
  [20523] = {.lex_state = 0, .external_lex_state = 336},
  [20524] = {.lex_state = 1, .external_lex_state = 308},
  [20525] = {.lex_state = 1, .external_lex_state = 308},
  [20526] = {.lex_state = 0, .external_lex_state = 439},
  [20527] = {.lex_state = 1, .external_lex_state = 308},
  [20528] = {.lex_state = 1, .external_lex_state = 308},
  [20529] = {.lex_state = 1, .external_lex_state = 308},
  [20530] = {.lex_state = 1, .external_lex_state = 308},
  [20531] = {.lex_state = 0, .external_lex_state = 348},
  [20532] = {.lex_state = 4, .external_lex_state = 308},
  [20533] = {.lex_state = 0, .external_lex_state = 308},
  [20534] = {.lex_state = 0, .external_lex_state = 308},
  [20535] = {.lex_state = 0, .external_lex_state = 336},
  [20536] = {.lex_state = 0, .external_lex_state = 348},
  [20537] = {.lex_state = 4, .external_lex_state = 308},
  [20538] = {.lex_state = 1, .external_lex_state = 308},
  [20539] = {.lex_state = 0, .external_lex_state = 439},
  [20540] = {.lex_state = 1, .external_lex_state = 308},
  [20541] = {.lex_state = 0, .external_lex_state = 308},
  [20542] = {.lex_state = 1, .external_lex_state = 308},
  [20543] = {.lex_state = 1, .external_lex_state = 308},
  [20544] = {.lex_state = 0, .external_lex_state = 308},
  [20545] = {.lex_state = 0, .external_lex_state = 336},
  [20546] = {.lex_state = 4, .external_lex_state = 308},
  [20547] = {.lex_state = 0, .external_lex_state = 308},
  [20548] = {.lex_state = 0, .external_lex_state = 439},
  [20549] = {.lex_state = 0, .external_lex_state = 367},
  [20550] = {.lex_state = 4, .external_lex_state = 308},
  [20551] = {.lex_state = 0, .external_lex_state = 439},
  [20552] = {.lex_state = 1, .external_lex_state = 308},
  [20553] = {.lex_state = 1, .external_lex_state = 308},
  [20554] = {.lex_state = 0, .external_lex_state = 308},
  [20555] = {.lex_state = 0, .external_lex_state = 308},
  [20556] = {.lex_state = 0, .external_lex_state = 308},
  [20557] = {.lex_state = 4, .external_lex_state = 308},
  [20558] = {.lex_state = 1, .external_lex_state = 308},
  [20559] = {.lex_state = 1, .external_lex_state = 308},
  [20560] = {.lex_state = 55, .external_lex_state = 308},
  [20561] = {.lex_state = 1, .external_lex_state = 308},
  [20562] = {.lex_state = 0, .external_lex_state = 439},
  [20563] = {.lex_state = 0, .external_lex_state = 336},
  [20564] = {.lex_state = 55, .external_lex_state = 442},
  [20565] = {.lex_state = 0, .external_lex_state = 333},
  [20566] = {.lex_state = 1, .external_lex_state = 308},
  [20567] = {.lex_state = 4, .external_lex_state = 308},
  [20568] = {.lex_state = 1, .external_lex_state = 308},
  [20569] = {.lex_state = 0, .external_lex_state = 439},
  [20570] = {.lex_state = 1, .external_lex_state = 308},
  [20571] = {.lex_state = 0, .external_lex_state = 308},
  [20572] = {.lex_state = 4, .external_lex_state = 308},
  [20573] = {.lex_state = 1, .external_lex_state = 308},
  [20574] = {.lex_state = 4, .external_lex_state = 308},
  [20575] = {.lex_state = 55, .external_lex_state = 308},
  [20576] = {.lex_state = 1, .external_lex_state = 308},
  [20577] = {.lex_state = 0, .external_lex_state = 308},
  [20578] = {.lex_state = 0, .external_lex_state = 439},
  [20579] = {.lex_state = 0, .external_lex_state = 308},
  [20580] = {.lex_state = 1, .external_lex_state = 308},
  [20581] = {.lex_state = 0, .external_lex_state = 308},
  [20582] = {.lex_state = 4, .external_lex_state = 308},
  [20583] = {.lex_state = 0, .external_lex_state = 336},
  [20584] = {.lex_state = 0, .external_lex_state = 439},
  [20585] = {.lex_state = 1, .external_lex_state = 308},
  [20586] = {.lex_state = 55, .external_lex_state = 308},
  [20587] = {.lex_state = 4, .external_lex_state = 308},
  [20588] = {.lex_state = 0, .external_lex_state = 439},
  [20589] = {.lex_state = 0, .external_lex_state = 336},
  [20590] = {.lex_state = 55, .external_lex_state = 442},
  [20591] = {.lex_state = 0, .external_lex_state = 308},
  [20592] = {.lex_state = 1, .external_lex_state = 308},
  [20593] = {.lex_state = 55, .external_lex_state = 308},
  [20594] = {.lex_state = 1, .external_lex_state = 308},
  [20595] = {.lex_state = 4, .external_lex_state = 308},
  [20596] = {.lex_state = 0, .external_lex_state = 439},
  [20597] = {.lex_state = 4, .external_lex_state = 308},
  [20598] = {.lex_state = 1, .external_lex_state = 308},
  [20599] = {.lex_state = 1, .external_lex_state = 308},
  [20600] = {.lex_state = 55, .external_lex_state = 308},
  [20601] = {.lex_state = 1, .external_lex_state = 308},
  [20602] = {.lex_state = 1, .external_lex_state = 308},
  [20603] = {.lex_state = 4, .external_lex_state = 308},
  [20604] = {.lex_state = 0, .external_lex_state = 308},
  [20605] = {.lex_state = 4, .external_lex_state = 308},
  [20606] = {.lex_state = 0, .external_lex_state = 439},
  [20607] = {.lex_state = 1, .external_lex_state = 308},
  [20608] = {.lex_state = 1, .external_lex_state = 308},
  [20609] = {.lex_state = 0, .external_lex_state = 308},
  [20610] = {.lex_state = 4, .external_lex_state = 308},
  [20611] = {.lex_state = 0, .external_lex_state = 308},
  [20612] = {.lex_state = 0, .external_lex_state = 439},
  [20613] = {.lex_state = 0, .external_lex_state = 348},
  [20614] = {.lex_state = 0, .external_lex_state = 308},
  [20615] = {.lex_state = 0, .external_lex_state = 308},
  [20616] = {.lex_state = 1, .external_lex_state = 308},
  [20617] = {.lex_state = 1, .external_lex_state = 308},
  [20618] = {.lex_state = 0, .external_lex_state = 308},
  [20619] = {.lex_state = 4, .external_lex_state = 308},
  [20620] = {.lex_state = 0, .external_lex_state = 439},
  [20621] = {.lex_state = 55, .external_lex_state = 308},
  [20622] = {.lex_state = 1, .external_lex_state = 308},
  [20623] = {.lex_state = 0, .external_lex_state = 367},
  [20624] = {.lex_state = 0, .external_lex_state = 336},
  [20625] = {.lex_state = 1, .external_lex_state = 308},
  [20626] = {.lex_state = 1, .external_lex_state = 308},
  [20627] = {.lex_state = 0, .external_lex_state = 308},
  [20628] = {.lex_state = 0, .external_lex_state = 336},
  [20629] = {.lex_state = 1, .external_lex_state = 308},
  [20630] = {.lex_state = 55, .external_lex_state = 308},
  [20631] = {.lex_state = 4, .external_lex_state = 308},
  [20632] = {.lex_state = 0, .external_lex_state = 439},
  [20633] = {.lex_state = 1, .external_lex_state = 308},
  [20634] = {.lex_state = 0, .external_lex_state = 336},
  [20635] = {.lex_state = 0, .external_lex_state = 333},
  [20636] = {.lex_state = 1, .external_lex_state = 308},
  [20637] = {.lex_state = 1, .external_lex_state = 308},
  [20638] = {.lex_state = 0, .external_lex_state = 308},
  [20639] = {.lex_state = 4, .external_lex_state = 308},
  [20640] = {.lex_state = 0, .external_lex_state = 439},
  [20641] = {.lex_state = 1, .external_lex_state = 308},
  [20642] = {.lex_state = 55, .external_lex_state = 308},
  [20643] = {.lex_state = 0, .external_lex_state = 308},
  [20644] = {.lex_state = 1, .external_lex_state = 308},
  [20645] = {.lex_state = 4, .external_lex_state = 308},
  [20646] = {.lex_state = 0, .external_lex_state = 439},
  [20647] = {.lex_state = 55, .external_lex_state = 308},
  [20648] = {.lex_state = 55, .external_lex_state = 308},
  [20649] = {.lex_state = 55, .external_lex_state = 442},
  [20650] = {.lex_state = 1, .external_lex_state = 308},
  [20651] = {.lex_state = 55, .external_lex_state = 308},
  [20652] = {.lex_state = 4, .external_lex_state = 308},
  [20653] = {.lex_state = 0, .external_lex_state = 439},
  [20654] = {.lex_state = 1, .external_lex_state = 308},
  [20655] = {.lex_state = 4, .external_lex_state = 308},
  [20656] = {.lex_state = 1, .external_lex_state = 308},
  [20657] = {.lex_state = 0, .external_lex_state = 404},
  [20658] = {.lex_state = 1, .external_lex_state = 308},
  [20659] = {.lex_state = 4, .external_lex_state = 308},
  [20660] = {.lex_state = 0, .external_lex_state = 308},
  [20661] = {.lex_state = 0, .external_lex_state = 308},
  [20662] = {.lex_state = 4, .external_lex_state = 308},
  [20663] = {.lex_state = 1, .external_lex_state = 308},
  [20664] = {.lex_state = 1, .external_lex_state = 308},
  [20665] = {.lex_state = 58, .external_lex_state = 400},
  [20666] = {.lex_state = 0, .external_lex_state = 439},
  [20667] = {.lex_state = 0, .external_lex_state = 308},
  [20668] = {.lex_state = 1, .external_lex_state = 308},
  [20669] = {.lex_state = 1, .external_lex_state = 308},
  [20670] = {.lex_state = 0, .external_lex_state = 308},
  [20671] = {.lex_state = 0, .external_lex_state = 336},
  [20672] = {.lex_state = 0, .external_lex_state = 308},
  [20673] = {.lex_state = 0, .external_lex_state = 336},
  [20674] = {.lex_state = 0, .external_lex_state = 336},
  [20675] = {.lex_state = 1, .external_lex_state = 308},
  [20676] = {.lex_state = 0, .external_lex_state = 336},
  [20677] = {.lex_state = 0, .external_lex_state = 308},
  [20678] = {.lex_state = 1, .external_lex_state = 308},
  [20679] = {.lex_state = 4, .external_lex_state = 308},
  [20680] = {.lex_state = 1, .external_lex_state = 308},
  [20681] = {.lex_state = 0, .external_lex_state = 439},
  [20682] = {.lex_state = 1, .external_lex_state = 308},
  [20683] = {.lex_state = 0, .external_lex_state = 308},
  [20684] = {.lex_state = 4, .external_lex_state = 308},
  [20685] = {.lex_state = 1, .external_lex_state = 308},
  [20686] = {.lex_state = 4, .external_lex_state = 308},
  [20687] = {.lex_state = 0, .external_lex_state = 439},
  [20688] = {.lex_state = 0, .external_lex_state = 336},
  [20689] = {.lex_state = 1, .external_lex_state = 308},
  [20690] = {.lex_state = 0, .external_lex_state = 439},
  [20691] = {.lex_state = 0, .external_lex_state = 308},
  [20692] = {.lex_state = 1, .external_lex_state = 308},
  [20693] = {.lex_state = 0, .external_lex_state = 333},
  [20694] = {.lex_state = 1, .external_lex_state = 308},
  [20695] = {.lex_state = 0, .external_lex_state = 308},
  [20696] = {.lex_state = 0, .external_lex_state = 308},
  [20697] = {.lex_state = 0, .external_lex_state = 336},
  [20698] = {.lex_state = 4, .external_lex_state = 308},
  [20699] = {.lex_state = 0, .external_lex_state = 439},
  [20700] = {.lex_state = 0, .external_lex_state = 336},
  [20701] = {.lex_state = 0, .external_lex_state = 308},
  [20702] = {.lex_state = 0, .external_lex_state = 336},
  [20703] = {.lex_state = 0, .external_lex_state = 308},
  [20704] = {.lex_state = 1, .external_lex_state = 308},
  [20705] = {.lex_state = 0, .external_lex_state = 308},
  [20706] = {.lex_state = 1, .external_lex_state = 308},
  [20707] = {.lex_state = 55, .external_lex_state = 308},
  [20708] = {.lex_state = 4, .external_lex_state = 308},
  [20709] = {.lex_state = 0, .external_lex_state = 333},
  [20710] = {.lex_state = 1, .external_lex_state = 308},
  [20711] = {.lex_state = 0, .external_lex_state = 308},
  [20712] = {.lex_state = 0, .external_lex_state = 308},
  [20713] = {.lex_state = 0, .external_lex_state = 439},
  [20714] = {.lex_state = 55, .external_lex_state = 308},
  [20715] = {.lex_state = 0, .external_lex_state = 336},
  [20716] = {.lex_state = 1, .external_lex_state = 308},
  [20717] = {.lex_state = 1, .external_lex_state = 308},
  [20718] = {.lex_state = 0, .external_lex_state = 336},
  [20719] = {.lex_state = 4, .external_lex_state = 308},
  [20720] = {.lex_state = 1, .external_lex_state = 308},
  [20721] = {.lex_state = 0, .external_lex_state = 333},
  [20722] = {.lex_state = 0, .external_lex_state = 439},
  [20723] = {.lex_state = 55, .external_lex_state = 442},
  [20724] = {.lex_state = 58, .external_lex_state = 397},
  [20725] = {.lex_state = 55, .external_lex_state = 308},
  [20726] = {.lex_state = 0, .external_lex_state = 308},
  [20727] = {.lex_state = 1, .external_lex_state = 308},
  [20728] = {.lex_state = 0, .external_lex_state = 308},
  [20729] = {.lex_state = 0, .external_lex_state = 336},
  [20730] = {.lex_state = 1, .external_lex_state = 308},
  [20731] = {.lex_state = 4, .external_lex_state = 308},
  [20732] = {.lex_state = 4, .external_lex_state = 308},
  [20733] = {.lex_state = 1, .external_lex_state = 308},
  [20734] = {.lex_state = 1, .external_lex_state = 308},
  [20735] = {.lex_state = 0, .external_lex_state = 439},
  [20736] = {.lex_state = 4, .external_lex_state = 308},
  [20737] = {.lex_state = 1, .external_lex_state = 308},
  [20738] = {.lex_state = 1, .external_lex_state = 308},
  [20739] = {.lex_state = 0, .external_lex_state = 308},
  [20740] = {.lex_state = 0, .external_lex_state = 308},
  [20741] = {.lex_state = 0, .external_lex_state = 308},
  [20742] = {.lex_state = 1, .external_lex_state = 308},
  [20743] = {.lex_state = 4, .external_lex_state = 308},
  [20744] = {.lex_state = 0, .external_lex_state = 308},
  [20745] = {.lex_state = 0, .external_lex_state = 308},
  [20746] = {.lex_state = 0, .external_lex_state = 439},
  [20747] = {.lex_state = 4, .external_lex_state = 308},
  [20748] = {.lex_state = 1, .external_lex_state = 308},
  [20749] = {.lex_state = 0, .external_lex_state = 308},
  [20750] = {.lex_state = 0, .external_lex_state = 336},
  [20751] = {.lex_state = 0, .external_lex_state = 308},
  [20752] = {.lex_state = 0, .external_lex_state = 336},
  [20753] = {.lex_state = 0, .external_lex_state = 336},
  [20754] = {.lex_state = 1, .external_lex_state = 308},
  [20755] = {.lex_state = 0, .external_lex_state = 308},
  [20756] = {.lex_state = 0, .external_lex_state = 336},
  [20757] = {.lex_state = 4, .external_lex_state = 308},
  [20758] = {.lex_state = 0, .external_lex_state = 439},
  [20759] = {.lex_state = 1, .external_lex_state = 308},
  [20760] = {.lex_state = 1, .external_lex_state = 308},
  [20761] = {.lex_state = 4, .external_lex_state = 308},
  [20762] = {.lex_state = 1, .external_lex_state = 308},
  [20763] = {.lex_state = 0, .external_lex_state = 308},
  [20764] = {.lex_state = 4, .external_lex_state = 308},
  [20765] = {.lex_state = 0, .external_lex_state = 333},
  [20766] = {.lex_state = 1, .external_lex_state = 308},
  [20767] = {.lex_state = 1, .external_lex_state = 308},
  [20768] = {.lex_state = 0, .external_lex_state = 308},
  [20769] = {.lex_state = 1, .external_lex_state = 308},
  [20770] = {.lex_state = 0, .external_lex_state = 308},
  [20771] = {.lex_state = 55, .external_lex_state = 308},
  [20772] = {.lex_state = 4, .external_lex_state = 308},
  [20773] = {.lex_state = 1, .external_lex_state = 308},
  [20774] = {.lex_state = 0, .external_lex_state = 439},
  [20775] = {.lex_state = 0, .external_lex_state = 308},
  [20776] = {.lex_state = 1, .external_lex_state = 308},
  [20777] = {.lex_state = 0, .external_lex_state = 308},
  [20778] = {.lex_state = 0, .external_lex_state = 336},
  [20779] = {.lex_state = 0, .external_lex_state = 336},
  [20780] = {.lex_state = 58, .external_lex_state = 400},
  [20781] = {.lex_state = 1, .external_lex_state = 308},
  [20782] = {.lex_state = 1, .external_lex_state = 308},
  [20783] = {.lex_state = 0, .external_lex_state = 336},
  [20784] = {.lex_state = 1, .external_lex_state = 308},
  [20785] = {.lex_state = 1, .external_lex_state = 308},
  [20786] = {.lex_state = 0, .external_lex_state = 308},
  [20787] = {.lex_state = 55, .external_lex_state = 442},
  [20788] = {.lex_state = 55, .external_lex_state = 308},
  [20789] = {.lex_state = 0, .external_lex_state = 336},
  [20790] = {.lex_state = 1, .external_lex_state = 308},
  [20791] = {.lex_state = 55, .external_lex_state = 308},
  [20792] = {.lex_state = 55, .external_lex_state = 442},
  [20793] = {.lex_state = 4, .external_lex_state = 308},
  [20794] = {.lex_state = 1, .external_lex_state = 308},
  [20795] = {.lex_state = 0, .external_lex_state = 308},
  [20796] = {.lex_state = 0, .external_lex_state = 439},
  [20797] = {.lex_state = 55, .external_lex_state = 308},
  [20798] = {.lex_state = 1, .external_lex_state = 308},
  [20799] = {.lex_state = 0, .external_lex_state = 336},
  [20800] = {.lex_state = 1, .external_lex_state = 308},
  [20801] = {.lex_state = 4, .external_lex_state = 308},
  [20802] = {.lex_state = 1, .external_lex_state = 308},
  [20803] = {.lex_state = 1, .external_lex_state = 308},
  [20804] = {.lex_state = 1, .external_lex_state = 308},
  [20805] = {.lex_state = 0, .external_lex_state = 308},
  [20806] = {.lex_state = 4, .external_lex_state = 308},
  [20807] = {.lex_state = 0, .external_lex_state = 439},
  [20808] = {.lex_state = 0, .external_lex_state = 336},
  [20809] = {.lex_state = 1, .external_lex_state = 308},
  [20810] = {.lex_state = 0, .external_lex_state = 439},
  [20811] = {.lex_state = 4, .external_lex_state = 308},
  [20812] = {.lex_state = 0, .external_lex_state = 308},
  [20813] = {.lex_state = 0, .external_lex_state = 336},
  [20814] = {.lex_state = 55, .external_lex_state = 308},
  [20815] = {.lex_state = 1, .external_lex_state = 308},
  [20816] = {.lex_state = 1, .external_lex_state = 308},
  [20817] = {.lex_state = 0, .external_lex_state = 404},
  [20818] = {.lex_state = 1, .external_lex_state = 308},
  [20819] = {.lex_state = 1, .external_lex_state = 308},
  [20820] = {.lex_state = 4, .external_lex_state = 308},
  [20821] = {.lex_state = 0, .external_lex_state = 333},
  [20822] = {.lex_state = 1, .external_lex_state = 308},
  [20823] = {.lex_state = 1, .external_lex_state = 308},
  [20824] = {.lex_state = 1, .external_lex_state = 308},
  [20825] = {.lex_state = 0, .external_lex_state = 308},
  [20826] = {.lex_state = 0, .external_lex_state = 308},
  [20827] = {.lex_state = 55, .external_lex_state = 308},
  [20828] = {.lex_state = 0, .external_lex_state = 308},
  [20829] = {.lex_state = 1, .external_lex_state = 308},
  [20830] = {.lex_state = 4, .external_lex_state = 308},
  [20831] = {.lex_state = 0, .external_lex_state = 308},
  [20832] = {.lex_state = 1, .external_lex_state = 308},
  [20833] = {.lex_state = 0, .external_lex_state = 439},
  [20834] = {.lex_state = 55, .external_lex_state = 308},
  [20835] = {.lex_state = 0, .external_lex_state = 308},
  [20836] = {.lex_state = 55, .external_lex_state = 442},
  [20837] = {.lex_state = 0, .external_lex_state = 308},
  [20838] = {.lex_state = 0, .external_lex_state = 336},
  [20839] = {.lex_state = 0, .external_lex_state = 308},
  [20840] = {.lex_state = 0, .external_lex_state = 308},
  [20841] = {.lex_state = 0, .external_lex_state = 336},
  [20842] = {.lex_state = 0, .external_lex_state = 336},
  [20843] = {.lex_state = 0, .external_lex_state = 333},
  [20844] = {.lex_state = 1, .external_lex_state = 308},
  [20845] = {.lex_state = 0, .external_lex_state = 336},
  [20846] = {.lex_state = 1, .external_lex_state = 308},
  [20847] = {.lex_state = 55, .external_lex_state = 442},
  [20848] = {.lex_state = 0, .external_lex_state = 308},
  [20849] = {.lex_state = 55, .external_lex_state = 308},
  [20850] = {.lex_state = 1, .external_lex_state = 308},
  [20851] = {.lex_state = 0, .external_lex_state = 308},
  [20852] = {.lex_state = 1, .external_lex_state = 308},
  [20853] = {.lex_state = 1, .external_lex_state = 308},
  [20854] = {.lex_state = 0, .external_lex_state = 308},
  [20855] = {.lex_state = 0, .external_lex_state = 439},
  [20856] = {.lex_state = 0, .external_lex_state = 308},
  [20857] = {.lex_state = 4, .external_lex_state = 308},
  [20858] = {.lex_state = 1, .external_lex_state = 308},
  [20859] = {.lex_state = 0, .external_lex_state = 308},
  [20860] = {.lex_state = 1, .external_lex_state = 308},
  [20861] = {.lex_state = 0, .external_lex_state = 439},
  [20862] = {.lex_state = 1, .external_lex_state = 308},
  [20863] = {.lex_state = 1, .external_lex_state = 308},
  [20864] = {.lex_state = 55, .external_lex_state = 308},
  [20865] = {.lex_state = 0, .external_lex_state = 336},
  [20866] = {.lex_state = 0, .external_lex_state = 336},
  [20867] = {.lex_state = 55, .external_lex_state = 308},
  [20868] = {.lex_state = 0, .external_lex_state = 336},
  [20869] = {.lex_state = 0, .external_lex_state = 333},
  [20870] = {.lex_state = 1, .external_lex_state = 308},
  [20871] = {.lex_state = 0, .external_lex_state = 308},
  [20872] = {.lex_state = 0, .external_lex_state = 308},
  [20873] = {.lex_state = 4, .external_lex_state = 308},
  [20874] = {.lex_state = 1, .external_lex_state = 308},
  [20875] = {.lex_state = 0, .external_lex_state = 308},
  [20876] = {.lex_state = 0, .external_lex_state = 439},
  [20877] = {.lex_state = 1, .external_lex_state = 308},
  [20878] = {.lex_state = 1, .external_lex_state = 308},
  [20879] = {.lex_state = 0, .external_lex_state = 308},
  [20880] = {.lex_state = 1, .external_lex_state = 308},
  [20881] = {.lex_state = 0, .external_lex_state = 336},
  [20882] = {.lex_state = 55, .external_lex_state = 308},
  [20883] = {.lex_state = 1, .external_lex_state = 308},
  [20884] = {.lex_state = 4, .external_lex_state = 308},
  [20885] = {.lex_state = 1, .external_lex_state = 308},
  [20886] = {.lex_state = 0, .external_lex_state = 336},
  [20887] = {.lex_state = 55, .external_lex_state = 308},
  [20888] = {.lex_state = 1, .external_lex_state = 308},
  [20889] = {.lex_state = 55, .external_lex_state = 308},
  [20890] = {.lex_state = 1, .external_lex_state = 308},
  [20891] = {.lex_state = 1, .external_lex_state = 308},
  [20892] = {.lex_state = 1, .external_lex_state = 308},
  [20893] = {.lex_state = 0, .external_lex_state = 439},
  [20894] = {.lex_state = 1, .external_lex_state = 308},
  [20895] = {.lex_state = 1, .external_lex_state = 308},
  [20896] = {.lex_state = 4, .external_lex_state = 308},
  [20897] = {.lex_state = 55, .external_lex_state = 442},
  [20898] = {.lex_state = 55, .external_lex_state = 308},
  [20899] = {.lex_state = 0, .external_lex_state = 308},
  [20900] = {.lex_state = 0, .external_lex_state = 336},
  [20901] = {.lex_state = 0, .external_lex_state = 336},
  [20902] = {.lex_state = 1, .external_lex_state = 308},
  [20903] = {.lex_state = 1, .external_lex_state = 308},
  [20904] = {.lex_state = 0, .external_lex_state = 336},
  [20905] = {.lex_state = 1, .external_lex_state = 308},
  [20906] = {.lex_state = 1, .external_lex_state = 308},
  [20907] = {.lex_state = 1, .external_lex_state = 308},
  [20908] = {.lex_state = 1, .external_lex_state = 308},
  [20909] = {.lex_state = 1, .external_lex_state = 308},
  [20910] = {.lex_state = 1, .external_lex_state = 308},
  [20911] = {.lex_state = 0, .external_lex_state = 336},
  [20912] = {.lex_state = 1, .external_lex_state = 308},
  [20913] = {.lex_state = 0, .external_lex_state = 336},
  [20914] = {.lex_state = 1, .external_lex_state = 308},
  [20915] = {.lex_state = 0, .external_lex_state = 336},
  [20916] = {.lex_state = 1, .external_lex_state = 308},
  [20917] = {.lex_state = 1, .external_lex_state = 308},
  [20918] = {.lex_state = 1, .external_lex_state = 308},
  [20919] = {.lex_state = 0, .external_lex_state = 336},
  [20920] = {.lex_state = 55, .external_lex_state = 308},
  [20921] = {.lex_state = 0, .external_lex_state = 308},
  [20922] = {.lex_state = 1, .external_lex_state = 308},
  [20923] = {.lex_state = 0, .external_lex_state = 308},
  [20924] = {.lex_state = 0, .external_lex_state = 308},
  [20925] = {.lex_state = 4, .external_lex_state = 308},
  [20926] = {.lex_state = 1, .external_lex_state = 308},
  [20927] = {.lex_state = 0, .external_lex_state = 336},
  [20928] = {.lex_state = 1, .external_lex_state = 308},
  [20929] = {.lex_state = 0, .external_lex_state = 336},
  [20930] = {.lex_state = 1, .external_lex_state = 308},
  [20931] = {.lex_state = 0, .external_lex_state = 308},
  [20932] = {.lex_state = 4, .external_lex_state = 308},
  [20933] = {.lex_state = 0, .external_lex_state = 367},
  [20934] = {.lex_state = 1, .external_lex_state = 308},
  [20935] = {.lex_state = 0, .external_lex_state = 336},
  [20936] = {.lex_state = 58, .external_lex_state = 400},
  [20937] = {.lex_state = 0, .external_lex_state = 336},
  [20938] = {.lex_state = 0, .external_lex_state = 336},
  [20939] = {.lex_state = 1, .external_lex_state = 308},
  [20940] = {.lex_state = 1, .external_lex_state = 308},
  [20941] = {.lex_state = 1, .external_lex_state = 308},
  [20942] = {.lex_state = 1, .external_lex_state = 308},
  [20943] = {.lex_state = 0, .external_lex_state = 308},
  [20944] = {.lex_state = 1, .external_lex_state = 308},
  [20945] = {.lex_state = 0, .external_lex_state = 308},
  [20946] = {.lex_state = 0, .external_lex_state = 308},
  [20947] = {.lex_state = 1, .external_lex_state = 308},
  [20948] = {.lex_state = 1, .external_lex_state = 308},
  [20949] = {.lex_state = 0, .external_lex_state = 308},
  [20950] = {.lex_state = 0, .external_lex_state = 336},
  [20951] = {.lex_state = 0, .external_lex_state = 336},
  [20952] = {.lex_state = 0, .external_lex_state = 308},
  [20953] = {.lex_state = 1, .external_lex_state = 308},
  [20954] = {.lex_state = 1, .external_lex_state = 308},
  [20955] = {.lex_state = 0, .external_lex_state = 308},
  [20956] = {.lex_state = 58, .external_lex_state = 400},
  [20957] = {.lex_state = 0, .external_lex_state = 308},
  [20958] = {.lex_state = 1, .external_lex_state = 308},
  [20959] = {.lex_state = 1, .external_lex_state = 308},
  [20960] = {.lex_state = 1, .external_lex_state = 308},
  [20961] = {.lex_state = 1, .external_lex_state = 308},
  [20962] = {.lex_state = 1, .external_lex_state = 308},
  [20963] = {.lex_state = 1, .external_lex_state = 308},
  [20964] = {.lex_state = 0, .external_lex_state = 336},
  [20965] = {.lex_state = 0, .external_lex_state = 308},
  [20966] = {.lex_state = 1, .external_lex_state = 308},
  [20967] = {.lex_state = 0, .external_lex_state = 336},
  [20968] = {.lex_state = 0, .external_lex_state = 336},
  [20969] = {.lex_state = 1, .external_lex_state = 308},
  [20970] = {.lex_state = 1, .external_lex_state = 308},
  [20971] = {.lex_state = 1, .external_lex_state = 308},
  [20972] = {.lex_state = 1, .external_lex_state = 308},
  [20973] = {.lex_state = 0, .external_lex_state = 308},
  [20974] = {.lex_state = 4, .external_lex_state = 308},
  [20975] = {.lex_state = 1, .external_lex_state = 308},
  [20976] = {.lex_state = 58, .external_lex_state = 397},
  [20977] = {.lex_state = 0, .external_lex_state = 308},
  [20978] = {.lex_state = 1, .external_lex_state = 308},
  [20979] = {.lex_state = 0, .external_lex_state = 333},
  [20980] = {.lex_state = 0, .external_lex_state = 308},
  [20981] = {.lex_state = 1, .external_lex_state = 308},
  [20982] = {.lex_state = 1, .external_lex_state = 308},
  [20983] = {.lex_state = 1, .external_lex_state = 308},
  [20984] = {.lex_state = 1, .external_lex_state = 308},
  [20985] = {.lex_state = 1, .external_lex_state = 308},
  [20986] = {.lex_state = 1, .external_lex_state = 308},
  [20987] = {.lex_state = 0, .external_lex_state = 336},
  [20988] = {.lex_state = 1, .external_lex_state = 308},
  [20989] = {.lex_state = 1, .external_lex_state = 308},
  [20990] = {.lex_state = 1, .external_lex_state = 308},
  [20991] = {.lex_state = 1, .external_lex_state = 308},
  [20992] = {.lex_state = 1, .external_lex_state = 308},
  [20993] = {.lex_state = 4, .external_lex_state = 308},
  [20994] = {.lex_state = 1, .external_lex_state = 308},
  [20995] = {.lex_state = 1, .external_lex_state = 308},
  [20996] = {.lex_state = 1, .external_lex_state = 308},
  [20997] = {.lex_state = 55, .external_lex_state = 308},
  [20998] = {.lex_state = 0, .external_lex_state = 308},
  [20999] = {.lex_state = 58, .external_lex_state = 400},
  [21000] = {.lex_state = 1, .external_lex_state = 308},
  [21001] = {.lex_state = 1, .external_lex_state = 308},
  [21002] = {.lex_state = 58, .external_lex_state = 400},
  [21003] = {.lex_state = 0, .external_lex_state = 308},
  [21004] = {.lex_state = 1, .external_lex_state = 308},
  [21005] = {.lex_state = 58, .external_lex_state = 397},
  [21006] = {.lex_state = 0, .external_lex_state = 308},
  [21007] = {.lex_state = 0, .external_lex_state = 336},
  [21008] = {.lex_state = 4, .external_lex_state = 308},
  [21009] = {.lex_state = 0, .external_lex_state = 308},
  [21010] = {.lex_state = 0, .external_lex_state = 308},
  [21011] = {.lex_state = 0, .external_lex_state = 336},
  [21012] = {.lex_state = 0, .external_lex_state = 308},
  [21013] = {.lex_state = 1, .external_lex_state = 308},
  [21014] = {.lex_state = 1, .external_lex_state = 308},
  [21015] = {.lex_state = 1, .external_lex_state = 308},
  [21016] = {.lex_state = 55, .external_lex_state = 308},
  [21017] = {.lex_state = 0, .external_lex_state = 336},
  [21018] = {.lex_state = 1, .external_lex_state = 308},
  [21019] = {.lex_state = 1, .external_lex_state = 308},
  [21020] = {.lex_state = 55, .external_lex_state = 442},
  [21021] = {.lex_state = 0, .external_lex_state = 336},
  [21022] = {.lex_state = 0, .external_lex_state = 308},
  [21023] = {.lex_state = 55, .external_lex_state = 308},
  [21024] = {.lex_state = 1, .external_lex_state = 308},
  [21025] = {.lex_state = 1, .external_lex_state = 308},
  [21026] = {.lex_state = 1, .external_lex_state = 308},
  [21027] = {.lex_state = 1, .external_lex_state = 308},
  [21028] = {.lex_state = 1, .external_lex_state = 308},
  [21029] = {.lex_state = 4, .external_lex_state = 308},
  [21030] = {.lex_state = 55, .external_lex_state = 308},
  [21031] = {.lex_state = 0, .external_lex_state = 308},
  [21032] = {.lex_state = 55, .external_lex_state = 308},
  [21033] = {.lex_state = 0, .external_lex_state = 308},
  [21034] = {.lex_state = 0, .external_lex_state = 308},
  [21035] = {.lex_state = 1, .external_lex_state = 308},
  [21036] = {.lex_state = 1, .external_lex_state = 308},
  [21037] = {.lex_state = 1, .external_lex_state = 308},
  [21038] = {.lex_state = 1, .external_lex_state = 308},
  [21039] = {.lex_state = 1, .external_lex_state = 308},
  [21040] = {.lex_state = 1, .external_lex_state = 308},
  [21041] = {.lex_state = 1, .external_lex_state = 308},
  [21042] = {.lex_state = 1, .external_lex_state = 308},
  [21043] = {.lex_state = 4, .external_lex_state = 308},
  [21044] = {.lex_state = 1, .external_lex_state = 308},
  [21045] = {.lex_state = 4, .external_lex_state = 308},
  [21046] = {.lex_state = 1, .external_lex_state = 308},
  [21047] = {.lex_state = 1, .external_lex_state = 308},
  [21048] = {.lex_state = 0, .external_lex_state = 336},
  [21049] = {.lex_state = 0, .external_lex_state = 336},
  [21050] = {.lex_state = 1, .external_lex_state = 308},
  [21051] = {.lex_state = 1, .external_lex_state = 308},
  [21052] = {.lex_state = 0, .external_lex_state = 308},
  [21053] = {.lex_state = 0, .external_lex_state = 308},
  [21054] = {.lex_state = 1, .external_lex_state = 308},
  [21055] = {.lex_state = 0, .external_lex_state = 336},
  [21056] = {.lex_state = 1, .external_lex_state = 308},
  [21057] = {.lex_state = 0, .external_lex_state = 308},
  [21058] = {.lex_state = 0, .external_lex_state = 308},
  [21059] = {.lex_state = 0, .external_lex_state = 308},
  [21060] = {.lex_state = 55, .external_lex_state = 308},
  [21061] = {.lex_state = 0, .external_lex_state = 336},
  [21062] = {.lex_state = 55, .external_lex_state = 442},
  [21063] = {.lex_state = 1, .external_lex_state = 308},
  [21064] = {.lex_state = 58, .external_lex_state = 397},
  [21065] = {.lex_state = 1, .external_lex_state = 308},
  [21066] = {.lex_state = 1, .external_lex_state = 308},
  [21067] = {.lex_state = 55, .external_lex_state = 308},
  [21068] = {.lex_state = 1, .external_lex_state = 308},
  [21069] = {.lex_state = 1, .external_lex_state = 308},
  [21070] = {.lex_state = 1, .external_lex_state = 308},
  [21071] = {.lex_state = 0, .external_lex_state = 308},
  [21072] = {.lex_state = 0, .external_lex_state = 308},
  [21073] = {.lex_state = 1, .external_lex_state = 308},
  [21074] = {.lex_state = 1, .external_lex_state = 308},
  [21075] = {.lex_state = 1, .external_lex_state = 308},
  [21076] = {.lex_state = 0, .external_lex_state = 308},
  [21077] = {.lex_state = 1, .external_lex_state = 308},
  [21078] = {.lex_state = 1, .external_lex_state = 308},
  [21079] = {.lex_state = 0, .external_lex_state = 336},
  [21080] = {.lex_state = 1, .external_lex_state = 308},
  [21081] = {.lex_state = 1, .external_lex_state = 308},
  [21082] = {.lex_state = 0, .external_lex_state = 308},
  [21083] = {.lex_state = 0, .external_lex_state = 308},
  [21084] = {.lex_state = 1, .external_lex_state = 308},
  [21085] = {.lex_state = 0, .external_lex_state = 333},
  [21086] = {.lex_state = 0, .external_lex_state = 308},
  [21087] = {.lex_state = 1, .external_lex_state = 308},
  [21088] = {.lex_state = 1, .external_lex_state = 308},
  [21089] = {.lex_state = 0, .external_lex_state = 308},
  [21090] = {.lex_state = 55, .external_lex_state = 308},
  [21091] = {.lex_state = 1, .external_lex_state = 308},
  [21092] = {.lex_state = 55, .external_lex_state = 308},
  [21093] = {.lex_state = 1, .external_lex_state = 308},
  [21094] = {.lex_state = 1, .external_lex_state = 308},
  [21095] = {.lex_state = 1, .external_lex_state = 308},
  [21096] = {.lex_state = 55, .external_lex_state = 442},
  [21097] = {.lex_state = 0, .external_lex_state = 308},
  [21098] = {.lex_state = 1, .external_lex_state = 308},
  [21099] = {.lex_state = 0, .external_lex_state = 308},
  [21100] = {.lex_state = 0, .external_lex_state = 308},
  [21101] = {.lex_state = 0, .external_lex_state = 308},
  [21102] = {.lex_state = 1, .external_lex_state = 308},
  [21103] = {.lex_state = 57, .external_lex_state = 308},
  [21104] = {.lex_state = 1, .external_lex_state = 308},
  [21105] = {.lex_state = 1, .external_lex_state = 308},
  [21106] = {.lex_state = 1, .external_lex_state = 308},
  [21107] = {.lex_state = 1, .external_lex_state = 308},
  [21108] = {.lex_state = 1, .external_lex_state = 308},
  [21109] = {.lex_state = 55, .external_lex_state = 308},
  [21110] = {.lex_state = 0, .external_lex_state = 336},
  [21111] = {.lex_state = 55, .external_lex_state = 308},
  [21112] = {.lex_state = 1, .external_lex_state = 308},
  [21113] = {.lex_state = 0, .external_lex_state = 336},
  [21114] = {.lex_state = 0, .external_lex_state = 336},
  [21115] = {.lex_state = 1, .external_lex_state = 308},
  [21116] = {.lex_state = 0, .external_lex_state = 336},
  [21117] = {.lex_state = 4, .external_lex_state = 308},
  [21118] = {.lex_state = 55, .external_lex_state = 308},
  [21119] = {.lex_state = 1, .external_lex_state = 308},
  [21120] = {.lex_state = 1, .external_lex_state = 308},
  [21121] = {.lex_state = 1, .external_lex_state = 308},
  [21122] = {.lex_state = 1, .external_lex_state = 308},
  [21123] = {.lex_state = 1, .external_lex_state = 308},
  [21124] = {.lex_state = 57, .external_lex_state = 308},
  [21125] = {.lex_state = 1, .external_lex_state = 308},
  [21126] = {.lex_state = 1, .external_lex_state = 308},
  [21127] = {.lex_state = 0, .external_lex_state = 308},
  [21128] = {.lex_state = 55, .external_lex_state = 308},
  [21129] = {.lex_state = 0, .external_lex_state = 308},
  [21130] = {.lex_state = 1, .external_lex_state = 308},
  [21131] = {.lex_state = 0, .external_lex_state = 336},
  [21132] = {.lex_state = 55, .external_lex_state = 308},
  [21133] = {.lex_state = 1, .external_lex_state = 308},
  [21134] = {.lex_state = 0, .external_lex_state = 308},
  [21135] = {.lex_state = 1, .external_lex_state = 308},
  [21136] = {.lex_state = 0, .external_lex_state = 308},
  [21137] = {.lex_state = 1, .external_lex_state = 308},
  [21138] = {.lex_state = 0, .external_lex_state = 336},
  [21139] = {.lex_state = 0, .external_lex_state = 308},
  [21140] = {.lex_state = 1, .external_lex_state = 308},
  [21141] = {.lex_state = 0, .external_lex_state = 308},
  [21142] = {.lex_state = 0, .external_lex_state = 308},
  [21143] = {.lex_state = 0, .external_lex_state = 308},
  [21144] = {.lex_state = 0, .external_lex_state = 336},
  [21145] = {.lex_state = 1, .external_lex_state = 308},
  [21146] = {.lex_state = 1, .external_lex_state = 308},
  [21147] = {.lex_state = 0, .external_lex_state = 308},
  [21148] = {.lex_state = 55, .external_lex_state = 442},
  [21149] = {.lex_state = 55, .external_lex_state = 308},
  [21150] = {.lex_state = 0, .external_lex_state = 336},
  [21151] = {.lex_state = 0, .external_lex_state = 308},
  [21152] = {.lex_state = 0, .external_lex_state = 336},
  [21153] = {.lex_state = 1, .external_lex_state = 308},
  [21154] = {.lex_state = 1, .external_lex_state = 308},
  [21155] = {.lex_state = 55, .external_lex_state = 308},
  [21156] = {.lex_state = 0, .external_lex_state = 308},
  [21157] = {.lex_state = 1, .external_lex_state = 308},
  [21158] = {.lex_state = 1, .external_lex_state = 308},
  [21159] = {.lex_state = 1, .external_lex_state = 308},
  [21160] = {.lex_state = 1, .external_lex_state = 308},
  [21161] = {.lex_state = 1, .external_lex_state = 308},
  [21162] = {.lex_state = 0, .external_lex_state = 336},
  [21163] = {.lex_state = 1, .external_lex_state = 308},
  [21164] = {.lex_state = 1, .external_lex_state = 308},
  [21165] = {.lex_state = 1, .external_lex_state = 308},
  [21166] = {.lex_state = 0, .external_lex_state = 308},
  [21167] = {.lex_state = 1, .external_lex_state = 308},
  [21168] = {.lex_state = 1, .external_lex_state = 308},
  [21169] = {.lex_state = 0, .external_lex_state = 336},
  [21170] = {.lex_state = 0, .external_lex_state = 308},
  [21171] = {.lex_state = 1, .external_lex_state = 308},
  [21172] = {.lex_state = 55, .external_lex_state = 308},
  [21173] = {.lex_state = 0, .external_lex_state = 336},
  [21174] = {.lex_state = 0, .external_lex_state = 336},
  [21175] = {.lex_state = 1, .external_lex_state = 308},
  [21176] = {.lex_state = 4, .external_lex_state = 308},
  [21177] = {.lex_state = 0, .external_lex_state = 308},
  [21178] = {.lex_state = 0, .external_lex_state = 308},
  [21179] = {.lex_state = 1, .external_lex_state = 308},
  [21180] = {.lex_state = 1, .external_lex_state = 308},
  [21181] = {.lex_state = 0, .external_lex_state = 308},
  [21182] = {.lex_state = 1, .external_lex_state = 308},
  [21183] = {.lex_state = 1, .external_lex_state = 308},
  [21184] = {.lex_state = 1, .external_lex_state = 308},
  [21185] = {.lex_state = 0, .external_lex_state = 308},
  [21186] = {.lex_state = 1, .external_lex_state = 308},
  [21187] = {.lex_state = 1, .external_lex_state = 308},
  [21188] = {.lex_state = 0, .external_lex_state = 308},
  [21189] = {.lex_state = 4, .external_lex_state = 308},
  [21190] = {.lex_state = 0, .external_lex_state = 308},
  [21191] = {.lex_state = 1, .external_lex_state = 308},
  [21192] = {.lex_state = 0, .external_lex_state = 308},
  [21193] = {.lex_state = 0, .external_lex_state = 308},
  [21194] = {.lex_state = 1, .external_lex_state = 308},
  [21195] = {.lex_state = 1, .external_lex_state = 308},
  [21196] = {.lex_state = 1, .external_lex_state = 308},
  [21197] = {.lex_state = 0, .external_lex_state = 308},
  [21198] = {.lex_state = 1, .external_lex_state = 308},
  [21199] = {.lex_state = 0, .external_lex_state = 308},
  [21200] = {.lex_state = 57, .external_lex_state = 308},
  [21201] = {.lex_state = 0, .external_lex_state = 308},
  [21202] = {.lex_state = 0, .external_lex_state = 308},
  [21203] = {.lex_state = 4, .external_lex_state = 308},
  [21204] = {.lex_state = 1, .external_lex_state = 308},
  [21205] = {.lex_state = 4, .external_lex_state = 308},
  [21206] = {.lex_state = 0, .external_lex_state = 308},
  [21207] = {.lex_state = 55, .external_lex_state = 442},
  [21208] = {.lex_state = 1, .external_lex_state = 308},
  [21209] = {.lex_state = 55, .external_lex_state = 308},
  [21210] = {.lex_state = 1, .external_lex_state = 308},
  [21211] = {.lex_state = 0, .external_lex_state = 336},
  [21212] = {.lex_state = 1, .external_lex_state = 308},
  [21213] = {.lex_state = 1, .external_lex_state = 308},
  [21214] = {.lex_state = 1, .external_lex_state = 308},
  [21215] = {.lex_state = 1, .external_lex_state = 308},
  [21216] = {.lex_state = 55, .external_lex_state = 308},
  [21217] = {.lex_state = 0, .external_lex_state = 308},
  [21218] = {.lex_state = 0, .external_lex_state = 333},
  [21219] = {.lex_state = 0, .external_lex_state = 308},
  [21220] = {.lex_state = 0, .external_lex_state = 308},
  [21221] = {.lex_state = 0, .external_lex_state = 308},
  [21222] = {.lex_state = 0, .external_lex_state = 308},
  [21223] = {.lex_state = 0, .external_lex_state = 308},
  [21224] = {.lex_state = 1, .external_lex_state = 308},
  [21225] = {.lex_state = 0, .external_lex_state = 308},
  [21226] = {.lex_state = 1, .external_lex_state = 308},
  [21227] = {.lex_state = 1, .external_lex_state = 308},
  [21228] = {.lex_state = 0, .external_lex_state = 308},
  [21229] = {.lex_state = 1, .external_lex_state = 308},
  [21230] = {.lex_state = 0, .external_lex_state = 336},
  [21231] = {.lex_state = 0, .external_lex_state = 308},
  [21232] = {.lex_state = 55, .external_lex_state = 442},
  [21233] = {.lex_state = 1, .external_lex_state = 308},
  [21234] = {.lex_state = 1, .external_lex_state = 308},
  [21235] = {.lex_state = 0, .external_lex_state = 308},
  [21236] = {.lex_state = 4, .external_lex_state = 308},
  [21237] = {.lex_state = 1, .external_lex_state = 308},
  [21238] = {.lex_state = 1, .external_lex_state = 308},
  [21239] = {.lex_state = 0, .external_lex_state = 336},
  [21240] = {.lex_state = 0, .external_lex_state = 308},
  [21241] = {.lex_state = 0, .external_lex_state = 308},
  [21242] = {.lex_state = 1, .external_lex_state = 308},
  [21243] = {.lex_state = 1, .external_lex_state = 308},
  [21244] = {.lex_state = 58, .external_lex_state = 308},
  [21245] = {.lex_state = 1, .external_lex_state = 308},
  [21246] = {.lex_state = 0, .external_lex_state = 308},
  [21247] = {.lex_state = 0, .external_lex_state = 308},
  [21248] = {.lex_state = 1, .external_lex_state = 308},
  [21249] = {.lex_state = 1, .external_lex_state = 308},
  [21250] = {.lex_state = 55, .external_lex_state = 308},
  [21251] = {.lex_state = 55, .external_lex_state = 308},
  [21252] = {.lex_state = 1, .external_lex_state = 308},
  [21253] = {.lex_state = 1, .external_lex_state = 308},
  [21254] = {.lex_state = 0, .external_lex_state = 308},
  [21255] = {.lex_state = 0, .external_lex_state = 336},
  [21256] = {.lex_state = 0, .external_lex_state = 308},
  [21257] = {.lex_state = 1, .external_lex_state = 308},
  [21258] = {.lex_state = 0, .external_lex_state = 308},
  [21259] = {.lex_state = 4, .external_lex_state = 308},
  [21260] = {.lex_state = 1, .external_lex_state = 308},
  [21261] = {.lex_state = 55, .external_lex_state = 308},
  [21262] = {.lex_state = 0, .external_lex_state = 308},
  [21263] = {.lex_state = 0, .external_lex_state = 308},
  [21264] = {.lex_state = 55, .external_lex_state = 308},
  [21265] = {.lex_state = 1, .external_lex_state = 308},
  [21266] = {.lex_state = 1, .external_lex_state = 308},
  [21267] = {.lex_state = 1, .external_lex_state = 308},
  [21268] = {.lex_state = 0, .external_lex_state = 336},
  [21269] = {.lex_state = 55, .external_lex_state = 308},
  [21270] = {.lex_state = 1, .external_lex_state = 308},
  [21271] = {.lex_state = 0, .external_lex_state = 336},
  [21272] = {.lex_state = 0, .external_lex_state = 308},
  [21273] = {.lex_state = 55, .external_lex_state = 442},
  [21274] = {.lex_state = 1, .external_lex_state = 308},
  [21275] = {.lex_state = 1, .external_lex_state = 308},
  [21276] = {.lex_state = 0, .external_lex_state = 308},
  [21277] = {.lex_state = 0, .external_lex_state = 308},
  [21278] = {.lex_state = 0, .external_lex_state = 336},
  [21279] = {.lex_state = 1, .external_lex_state = 308},
  [21280] = {.lex_state = 1, .external_lex_state = 308},
  [21281] = {.lex_state = 0, .external_lex_state = 336},
  [21282] = {.lex_state = 0, .external_lex_state = 404},
  [21283] = {.lex_state = 0, .external_lex_state = 308},
  [21284] = {.lex_state = 1, .external_lex_state = 308},
  [21285] = {.lex_state = 1, .external_lex_state = 308},
  [21286] = {.lex_state = 1, .external_lex_state = 308},
  [21287] = {.lex_state = 55, .external_lex_state = 308},
  [21288] = {.lex_state = 1, .external_lex_state = 308},
  [21289] = {.lex_state = 0, .external_lex_state = 308},
  [21290] = {.lex_state = 4, .external_lex_state = 308},
  [21291] = {.lex_state = 0, .external_lex_state = 308},
  [21292] = {.lex_state = 1, .external_lex_state = 308},
  [21293] = {.lex_state = 1, .external_lex_state = 308},
  [21294] = {.lex_state = 1, .external_lex_state = 308},
  [21295] = {.lex_state = 0, .external_lex_state = 308},
  [21296] = {.lex_state = 0, .external_lex_state = 308},
  [21297] = {.lex_state = 0, .external_lex_state = 308},
  [21298] = {.lex_state = 0, .external_lex_state = 308},
  [21299] = {.lex_state = 0, .external_lex_state = 308},
  [21300] = {.lex_state = 0, .external_lex_state = 308},
  [21301] = {.lex_state = 0, .external_lex_state = 308},
  [21302] = {.lex_state = 0, .external_lex_state = 443},
  [21303] = {.lex_state = 0, .external_lex_state = 308},
  [21304] = {.lex_state = 0, .external_lex_state = 308},
  [21305] = {.lex_state = 55, .external_lex_state = 308},
  [21306] = {.lex_state = 0, .external_lex_state = 308},
  [21307] = {.lex_state = 0, .external_lex_state = 308},
  [21308] = {.lex_state = 0, .external_lex_state = 308},
  [21309] = {.lex_state = 0, .external_lex_state = 308},
  [21310] = {.lex_state = 0, .external_lex_state = 308},
  [21311] = {.lex_state = 0, .external_lex_state = 443},
  [21312] = {.lex_state = 0, .external_lex_state = 308},
  [21313] = {.lex_state = 0, .external_lex_state = 308},
  [21314] = {.lex_state = 0, .external_lex_state = 308},
  [21315] = {.lex_state = 0, .external_lex_state = 308},
  [21316] = {.lex_state = 0, .external_lex_state = 308},
  [21317] = {.lex_state = 0, .external_lex_state = 308},
  [21318] = {.lex_state = 0, .external_lex_state = 308},
  [21319] = {.lex_state = 0, .external_lex_state = 308},
  [21320] = {.lex_state = 0, .external_lex_state = 308},
  [21321] = {.lex_state = 0, .external_lex_state = 308},
  [21322] = {.lex_state = 0, .external_lex_state = 443},
  [21323] = {.lex_state = 0, .external_lex_state = 308},
  [21324] = {.lex_state = 0, .external_lex_state = 308},
  [21325] = {.lex_state = 0, .external_lex_state = 443},
  [21326] = {.lex_state = 55, .external_lex_state = 308},
  [21327] = {.lex_state = 0, .external_lex_state = 308},
  [21328] = {.lex_state = 0, .external_lex_state = 308},
  [21329] = {.lex_state = 0, .external_lex_state = 308},
  [21330] = {.lex_state = 0, .external_lex_state = 308},
  [21331] = {.lex_state = 0, .external_lex_state = 308},
  [21332] = {.lex_state = 0, .external_lex_state = 308},
  [21333] = {.lex_state = 0, .external_lex_state = 308},
  [21334] = {.lex_state = 0, .external_lex_state = 308},
  [21335] = {.lex_state = 0, .external_lex_state = 443},
  [21336] = {.lex_state = 0, .external_lex_state = 308},
  [21337] = {.lex_state = 0, .external_lex_state = 308},
  [21338] = {.lex_state = 0, .external_lex_state = 308},
  [21339] = {.lex_state = 0, .external_lex_state = 308},
  [21340] = {.lex_state = 0, .external_lex_state = 308},
  [21341] = {.lex_state = 0, .external_lex_state = 308},
  [21342] = {.lex_state = 55, .external_lex_state = 308},
  [21343] = {.lex_state = 0, .external_lex_state = 308},
  [21344] = {.lex_state = 0, .external_lex_state = 443},
  [21345] = {.lex_state = 0, .external_lex_state = 308},
  [21346] = {.lex_state = 0, .external_lex_state = 308},
  [21347] = {.lex_state = 0, .external_lex_state = 308},
  [21348] = {.lex_state = 0, .external_lex_state = 308},
  [21349] = {.lex_state = 0, .external_lex_state = 308},
  [21350] = {.lex_state = 0, .external_lex_state = 308},
  [21351] = {.lex_state = 0, .external_lex_state = 308},
  [21352] = {.lex_state = 0, .external_lex_state = 308},
  [21353] = {.lex_state = 0, .external_lex_state = 308},
  [21354] = {.lex_state = 0, .external_lex_state = 308},
  [21355] = {.lex_state = 0, .external_lex_state = 443},
  [21356] = {.lex_state = 0, .external_lex_state = 443},
  [21357] = {.lex_state = 0, .external_lex_state = 308},
  [21358] = {.lex_state = 0, .external_lex_state = 308},
  [21359] = {.lex_state = 0, .external_lex_state = 308},
  [21360] = {.lex_state = 0, .external_lex_state = 308},
  [21361] = {.lex_state = 0, .external_lex_state = 308},
  [21362] = {.lex_state = 0, .external_lex_state = 443},
  [21363] = {.lex_state = 0, .external_lex_state = 308},
  [21364] = {.lex_state = 0, .external_lex_state = 308},
  [21365] = {.lex_state = 0, .external_lex_state = 308},
  [21366] = {.lex_state = 0, .external_lex_state = 308},
  [21367] = {.lex_state = 0, .external_lex_state = 308},
  [21368] = {.lex_state = 0, .external_lex_state = 308},
  [21369] = {.lex_state = 55, .external_lex_state = 308},
  [21370] = {.lex_state = 0, .external_lex_state = 308},
  [21371] = {.lex_state = 0, .external_lex_state = 308},
  [21372] = {.lex_state = 0, .external_lex_state = 308},
  [21373] = {.lex_state = 0, .external_lex_state = 308},
  [21374] = {.lex_state = 0, .external_lex_state = 308},
  [21375] = {.lex_state = 55, .external_lex_state = 308},
  [21376] = {.lex_state = 0, .external_lex_state = 308},
  [21377] = {.lex_state = 0, .external_lex_state = 308},
  [21378] = {.lex_state = 0, .external_lex_state = 443},
  [21379] = {.lex_state = 0, .external_lex_state = 308},
  [21380] = {.lex_state = 0, .external_lex_state = 308},
  [21381] = {.lex_state = 0, .external_lex_state = 308},
  [21382] = {.lex_state = 0, .external_lex_state = 308},
  [21383] = {.lex_state = 0, .external_lex_state = 308},
  [21384] = {.lex_state = 0, .external_lex_state = 308},
  [21385] = {.lex_state = 0, .external_lex_state = 308},
  [21386] = {.lex_state = 0, .external_lex_state = 308},
  [21387] = {.lex_state = 0, .external_lex_state = 308},
  [21388] = {.lex_state = 0, .external_lex_state = 308},
  [21389] = {.lex_state = 0, .external_lex_state = 308},
  [21390] = {.lex_state = 0, .external_lex_state = 443},
  [21391] = {.lex_state = 0, .external_lex_state = 308},
  [21392] = {.lex_state = 0, .external_lex_state = 308},
  [21393] = {.lex_state = 55, .external_lex_state = 308},
  [21394] = {.lex_state = 0, .external_lex_state = 308},
  [21395] = {.lex_state = 0, .external_lex_state = 308},
  [21396] = {.lex_state = 0, .external_lex_state = 308},
  [21397] = {.lex_state = 0, .external_lex_state = 308},
  [21398] = {.lex_state = 0, .external_lex_state = 308},
  [21399] = {.lex_state = 0, .external_lex_state = 308},
  [21400] = {.lex_state = 0, .external_lex_state = 308},
  [21401] = {.lex_state = 0, .external_lex_state = 308},
  [21402] = {.lex_state = 0, .external_lex_state = 308},
  [21403] = {.lex_state = 0, .external_lex_state = 308},
  [21404] = {.lex_state = 0, .external_lex_state = 308},
  [21405] = {.lex_state = 0, .external_lex_state = 308},
  [21406] = {.lex_state = 0, .external_lex_state = 308},
  [21407] = {.lex_state = 0, .external_lex_state = 308},
  [21408] = {.lex_state = 0, .external_lex_state = 308},
  [21409] = {.lex_state = 0, .external_lex_state = 308},
  [21410] = {.lex_state = 0, .external_lex_state = 308},
  [21411] = {.lex_state = 0, .external_lex_state = 443},
  [21412] = {.lex_state = 0, .external_lex_state = 443},
  [21413] = {.lex_state = 0, .external_lex_state = 308},
  [21414] = {.lex_state = 0, .external_lex_state = 308},
  [21415] = {.lex_state = 0, .external_lex_state = 308},
  [21416] = {.lex_state = 0, .external_lex_state = 308},
  [21417] = {.lex_state = 0, .external_lex_state = 308},
  [21418] = {.lex_state = 0, .external_lex_state = 443},
  [21419] = {.lex_state = 0, .external_lex_state = 308},
  [21420] = {.lex_state = 55, .external_lex_state = 308},
  [21421] = {.lex_state = 0, .external_lex_state = 308},
  [21422] = {.lex_state = 0, .external_lex_state = 308},
  [21423] = {.lex_state = 0, .external_lex_state = 443},
  [21424] = {.lex_state = 0, .external_lex_state = 308},
  [21425] = {.lex_state = 0, .external_lex_state = 308},
  [21426] = {.lex_state = 0, .external_lex_state = 443},
  [21427] = {.lex_state = 0, .external_lex_state = 308},
  [21428] = {.lex_state = 0, .external_lex_state = 308},
  [21429] = {.lex_state = 0, .external_lex_state = 308},
  [21430] = {.lex_state = 0, .external_lex_state = 308},
  [21431] = {.lex_state = 0, .external_lex_state = 308},
  [21432] = {.lex_state = 0, .external_lex_state = 308},
  [21433] = {.lex_state = 0, .external_lex_state = 308},
  [21434] = {.lex_state = 0, .external_lex_state = 308},
  [21435] = {.lex_state = 0, .external_lex_state = 308},
  [21436] = {.lex_state = 0, .external_lex_state = 308},
  [21437] = {.lex_state = 0, .external_lex_state = 308},
  [21438] = {.lex_state = 0, .external_lex_state = 308},
  [21439] = {.lex_state = 0, .external_lex_state = 308},
  [21440] = {.lex_state = 0, .external_lex_state = 308},
  [21441] = {.lex_state = 0, .external_lex_state = 308},
  [21442] = {.lex_state = 0, .external_lex_state = 308},
  [21443] = {.lex_state = 0, .external_lex_state = 308},
  [21444] = {.lex_state = 0, .external_lex_state = 308},
  [21445] = {.lex_state = 0, .external_lex_state = 308},
  [21446] = {.lex_state = 0, .external_lex_state = 443},
  [21447] = {.lex_state = 0, .external_lex_state = 308},
  [21448] = {.lex_state = 0, .external_lex_state = 308},
  [21449] = {.lex_state = 0, .external_lex_state = 308},
  [21450] = {.lex_state = 0, .external_lex_state = 308},
  [21451] = {.lex_state = 0, .external_lex_state = 308},
  [21452] = {.lex_state = 0, .external_lex_state = 443},
  [21453] = {.lex_state = 0, .external_lex_state = 443},
  [21454] = {.lex_state = 0, .external_lex_state = 308},
  [21455] = {.lex_state = 0, .external_lex_state = 308},
  [21456] = {.lex_state = 0, .external_lex_state = 308},
  [21457] = {.lex_state = 0, .external_lex_state = 308},
  [21458] = {.lex_state = 0, .external_lex_state = 308},
  [21459] = {.lex_state = 0, .external_lex_state = 308},
  [21460] = {.lex_state = 0, .external_lex_state = 308},
  [21461] = {.lex_state = 0, .external_lex_state = 308},
  [21462] = {.lex_state = 0, .external_lex_state = 308},
  [21463] = {.lex_state = 0, .external_lex_state = 308},
  [21464] = {.lex_state = 0, .external_lex_state = 308},
  [21465] = {.lex_state = 0, .external_lex_state = 308},
  [21466] = {.lex_state = 0, .external_lex_state = 308},
  [21467] = {.lex_state = 55, .external_lex_state = 442},
  [21468] = {.lex_state = 55, .external_lex_state = 308},
  [21469] = {.lex_state = 0, .external_lex_state = 308},
  [21470] = {.lex_state = 0, .external_lex_state = 308},
  [21471] = {.lex_state = 0, .external_lex_state = 308},
  [21472] = {.lex_state = 0, .external_lex_state = 308},
  [21473] = {.lex_state = 0, .external_lex_state = 443},
  [21474] = {.lex_state = 0, .external_lex_state = 443},
  [21475] = {.lex_state = 0, .external_lex_state = 443},
  [21476] = {.lex_state = 0, .external_lex_state = 443},
  [21477] = {.lex_state = 0, .external_lex_state = 308},
  [21478] = {.lex_state = 0, .external_lex_state = 308},
  [21479] = {.lex_state = 0, .external_lex_state = 308},
  [21480] = {.lex_state = 0, .external_lex_state = 308},
  [21481] = {.lex_state = 0, .external_lex_state = 308},
  [21482] = {.lex_state = 0, .external_lex_state = 308},
  [21483] = {.lex_state = 0, .external_lex_state = 308},
  [21484] = {.lex_state = 0, .external_lex_state = 308},
  [21485] = {.lex_state = 0, .external_lex_state = 308},
  [21486] = {.lex_state = 0, .external_lex_state = 308},
  [21487] = {.lex_state = 0, .external_lex_state = 308},
  [21488] = {.lex_state = 0, .external_lex_state = 308},
  [21489] = {.lex_state = 55, .external_lex_state = 308},
  [21490] = {.lex_state = 0, .external_lex_state = 308},
  [21491] = {.lex_state = 0, .external_lex_state = 308},
  [21492] = {.lex_state = 0, .external_lex_state = 308},
  [21493] = {.lex_state = 0, .external_lex_state = 308},
  [21494] = {.lex_state = 0, .external_lex_state = 308},
  [21495] = {.lex_state = 0, .external_lex_state = 308},
  [21496] = {.lex_state = 0, .external_lex_state = 308},
  [21497] = {.lex_state = 0, .external_lex_state = 308},
  [21498] = {.lex_state = 0, .external_lex_state = 308},
  [21499] = {.lex_state = 0, .external_lex_state = 308},
  [21500] = {.lex_state = 0, .external_lex_state = 308},
  [21501] = {.lex_state = 0, .external_lex_state = 308},
  [21502] = {.lex_state = 0, .external_lex_state = 443},
  [21503] = {.lex_state = 0, .external_lex_state = 308},
  [21504] = {.lex_state = 0, .external_lex_state = 308},
  [21505] = {.lex_state = 0, .external_lex_state = 308},
  [21506] = {.lex_state = 0, .external_lex_state = 308},
  [21507] = {.lex_state = 0, .external_lex_state = 308},
  [21508] = {.lex_state = 0, .external_lex_state = 308},
  [21509] = {.lex_state = 0, .external_lex_state = 308},
  [21510] = {.lex_state = 0, .external_lex_state = 308},
  [21511] = {.lex_state = 0, .external_lex_state = 308},
  [21512] = {.lex_state = 0, .external_lex_state = 308},
  [21513] = {.lex_state = 0, .external_lex_state = 308},
  [21514] = {.lex_state = 0, .external_lex_state = 443},
  [21515] = {.lex_state = 0, .external_lex_state = 308},
  [21516] = {.lex_state = 0, .external_lex_state = 308},
  [21517] = {.lex_state = 0, .external_lex_state = 443},
  [21518] = {.lex_state = 0, .external_lex_state = 443},
  [21519] = {.lex_state = 0, .external_lex_state = 308},
  [21520] = {.lex_state = 0, .external_lex_state = 308},
  [21521] = {.lex_state = 0, .external_lex_state = 308},
  [21522] = {.lex_state = 55, .external_lex_state = 308},
  [21523] = {.lex_state = 0, .external_lex_state = 308},
  [21524] = {.lex_state = 0, .external_lex_state = 308},
  [21525] = {.lex_state = 0, .external_lex_state = 308},
  [21526] = {.lex_state = 0, .external_lex_state = 308},
  [21527] = {.lex_state = 0, .external_lex_state = 308},
  [21528] = {.lex_state = 0, .external_lex_state = 308},
  [21529] = {.lex_state = 0, .external_lex_state = 308},
  [21530] = {.lex_state = 0, .external_lex_state = 443},
  [21531] = {.lex_state = 0, .external_lex_state = 443},
  [21532] = {.lex_state = 0, .external_lex_state = 443},
  [21533] = {.lex_state = 0, .external_lex_state = 308},
  [21534] = {.lex_state = 0, .external_lex_state = 308},
  [21535] = {.lex_state = 0, .external_lex_state = 308},
  [21536] = {.lex_state = 0, .external_lex_state = 308},
  [21537] = {.lex_state = 0, .external_lex_state = 308},
  [21538] = {.lex_state = 55, .external_lex_state = 308},
  [21539] = {.lex_state = 0, .external_lex_state = 308},
  [21540] = {.lex_state = 0, .external_lex_state = 308},
  [21541] = {.lex_state = 0, .external_lex_state = 308},
  [21542] = {.lex_state = 0, .external_lex_state = 308},
  [21543] = {.lex_state = 0, .external_lex_state = 308},
  [21544] = {.lex_state = 0, .external_lex_state = 308},
  [21545] = {.lex_state = 0, .external_lex_state = 308},
  [21546] = {.lex_state = 0, .external_lex_state = 308},
  [21547] = {.lex_state = 0, .external_lex_state = 308},
  [21548] = {.lex_state = 0, .external_lex_state = 308},
  [21549] = {.lex_state = 0, .external_lex_state = 308},
  [21550] = {.lex_state = 0, .external_lex_state = 308},
  [21551] = {.lex_state = 0, .external_lex_state = 308},
  [21552] = {.lex_state = 0, .external_lex_state = 308},
  [21553] = {.lex_state = 0, .external_lex_state = 308},
  [21554] = {.lex_state = 0, .external_lex_state = 308},
  [21555] = {.lex_state = 0, .external_lex_state = 308},
  [21556] = {.lex_state = 0, .external_lex_state = 308},
  [21557] = {.lex_state = 0, .external_lex_state = 308},
  [21558] = {.lex_state = 0, .external_lex_state = 443},
  [21559] = {.lex_state = 0, .external_lex_state = 308},
  [21560] = {.lex_state = 0, .external_lex_state = 308},
  [21561] = {.lex_state = 0, .external_lex_state = 308},
  [21562] = {.lex_state = 0, .external_lex_state = 308},
  [21563] = {.lex_state = 0, .external_lex_state = 308},
  [21564] = {.lex_state = 0, .external_lex_state = 308},
  [21565] = {.lex_state = 0, .external_lex_state = 308},
  [21566] = {.lex_state = 0, .external_lex_state = 443},
  [21567] = {.lex_state = 0, .external_lex_state = 308},
  [21568] = {.lex_state = 0, .external_lex_state = 308},
  [21569] = {.lex_state = 0, .external_lex_state = 308},
  [21570] = {.lex_state = 0, .external_lex_state = 308},
  [21571] = {.lex_state = 0, .external_lex_state = 443},
  [21572] = {.lex_state = 0, .external_lex_state = 308},
  [21573] = {.lex_state = 0, .external_lex_state = 308},
  [21574] = {.lex_state = 0, .external_lex_state = 443},
  [21575] = {.lex_state = 0, .external_lex_state = 308},
  [21576] = {.lex_state = 0, .external_lex_state = 308},
  [21577] = {.lex_state = 0, .external_lex_state = 308},
  [21578] = {.lex_state = 0, .external_lex_state = 308},
  [21579] = {.lex_state = 0, .external_lex_state = 308},
  [21580] = {.lex_state = 0, .external_lex_state = 308},
  [21581] = {.lex_state = 0, .external_lex_state = 308},
  [21582] = {.lex_state = 0, .external_lex_state = 308},
  [21583] = {.lex_state = 0, .external_lex_state = 308},
  [21584] = {.lex_state = 0, .external_lex_state = 308},
  [21585] = {.lex_state = 0, .external_lex_state = 308},
  [21586] = {.lex_state = 0, .external_lex_state = 443},
  [21587] = {.lex_state = 55, .external_lex_state = 308},
  [21588] = {.lex_state = 0, .external_lex_state = 308},
  [21589] = {.lex_state = 0, .external_lex_state = 308},
  [21590] = {.lex_state = 0, .external_lex_state = 308},
  [21591] = {.lex_state = 0, .external_lex_state = 308},
  [21592] = {.lex_state = 0, .external_lex_state = 308},
  [21593] = {.lex_state = 0, .external_lex_state = 308},
  [21594] = {.lex_state = 0, .external_lex_state = 308},
  [21595] = {.lex_state = 0, .external_lex_state = 308},
  [21596] = {.lex_state = 55, .external_lex_state = 308},
  [21597] = {.lex_state = 0, .external_lex_state = 308},
  [21598] = {.lex_state = 0, .external_lex_state = 308},
  [21599] = {.lex_state = 0, .external_lex_state = 308},
  [21600] = {.lex_state = 0, .external_lex_state = 308},
  [21601] = {.lex_state = 0, .external_lex_state = 308},
  [21602] = {.lex_state = 0, .external_lex_state = 308},
  [21603] = {.lex_state = 0, .external_lex_state = 308},
  [21604] = {.lex_state = 0, .external_lex_state = 308},
  [21605] = {.lex_state = 0, .external_lex_state = 308},
  [21606] = {.lex_state = 0, .external_lex_state = 308},
  [21607] = {.lex_state = 0, .external_lex_state = 308},
  [21608] = {.lex_state = 0, .external_lex_state = 308},
  [21609] = {.lex_state = 0, .external_lex_state = 308},
  [21610] = {.lex_state = 0, .external_lex_state = 308},
  [21611] = {.lex_state = 0, .external_lex_state = 308},
  [21612] = {.lex_state = 0, .external_lex_state = 308},
  [21613] = {.lex_state = 0, .external_lex_state = 308},
  [21614] = {.lex_state = 0, .external_lex_state = 443},
  [21615] = {.lex_state = 0, .external_lex_state = 308},
  [21616] = {.lex_state = 0, .external_lex_state = 308},
  [21617] = {.lex_state = 0, .external_lex_state = 308},
  [21618] = {.lex_state = 0, .external_lex_state = 308},
  [21619] = {.lex_state = 0, .external_lex_state = 308},
  [21620] = {.lex_state = 0, .external_lex_state = 308},
  [21621] = {.lex_state = 0, .external_lex_state = 308},
  [21622] = {.lex_state = 0, .external_lex_state = 443},
  [21623] = {.lex_state = 0, .external_lex_state = 308},
  [21624] = {.lex_state = 0, .external_lex_state = 308},
  [21625] = {.lex_state = 0, .external_lex_state = 308},
  [21626] = {.lex_state = 0, .external_lex_state = 308},
  [21627] = {.lex_state = 0, .external_lex_state = 443},
  [21628] = {.lex_state = 0, .external_lex_state = 443},
  [21629] = {.lex_state = 0, .external_lex_state = 308},
  [21630] = {.lex_state = 0, .external_lex_state = 308},
  [21631] = {.lex_state = 0, .external_lex_state = 308},
  [21632] = {.lex_state = 0, .external_lex_state = 308},
  [21633] = {.lex_state = 0, .external_lex_state = 308},
  [21634] = {.lex_state = 0, .external_lex_state = 308},
  [21635] = {.lex_state = 55, .external_lex_state = 308},
  [21636] = {.lex_state = 0, .external_lex_state = 367},
  [21637] = {.lex_state = 0, .external_lex_state = 308},
  [21638] = {.lex_state = 0, .external_lex_state = 308},
  [21639] = {.lex_state = 0, .external_lex_state = 308},
  [21640] = {.lex_state = 0, .external_lex_state = 308},
  [21641] = {.lex_state = 0, .external_lex_state = 308},
  [21642] = {.lex_state = 0, .external_lex_state = 443},
  [21643] = {.lex_state = 0, .external_lex_state = 443},
  [21644] = {.lex_state = 0, .external_lex_state = 308},
  [21645] = {.lex_state = 0, .external_lex_state = 308},
  [21646] = {.lex_state = 0, .external_lex_state = 308},
  [21647] = {.lex_state = 55, .external_lex_state = 308},
  [21648] = {.lex_state = 0, .external_lex_state = 308},
  [21649] = {.lex_state = 0, .external_lex_state = 308},
  [21650] = {.lex_state = 0, .external_lex_state = 308},
  [21651] = {.lex_state = 0, .external_lex_state = 308},
  [21652] = {.lex_state = 0, .external_lex_state = 308},
  [21653] = {.lex_state = 0, .external_lex_state = 308},
  [21654] = {.lex_state = 0, .external_lex_state = 308},
  [21655] = {.lex_state = 0, .external_lex_state = 308},
  [21656] = {.lex_state = 0, .external_lex_state = 308},
  [21657] = {.lex_state = 0, .external_lex_state = 308},
  [21658] = {.lex_state = 0, .external_lex_state = 308},
  [21659] = {.lex_state = 0, .external_lex_state = 308},
  [21660] = {.lex_state = 0, .external_lex_state = 308},
  [21661] = {.lex_state = 0, .external_lex_state = 308},
  [21662] = {.lex_state = 0, .external_lex_state = 308},
  [21663] = {.lex_state = 55, .external_lex_state = 308},
  [21664] = {.lex_state = 0, .external_lex_state = 308},
  [21665] = {.lex_state = 0, .external_lex_state = 308},
  [21666] = {.lex_state = 0, .external_lex_state = 308},
  [21667] = {.lex_state = 0, .external_lex_state = 308},
  [21668] = {.lex_state = 0, .external_lex_state = 308},
  [21669] = {.lex_state = 0, .external_lex_state = 308},
  [21670] = {.lex_state = 0, .external_lex_state = 443},
  [21671] = {.lex_state = 0, .external_lex_state = 308},
  [21672] = {.lex_state = 0, .external_lex_state = 308},
  [21673] = {.lex_state = 0, .external_lex_state = 308},
  [21674] = {.lex_state = 0, .external_lex_state = 308},
  [21675] = {.lex_state = 0, .external_lex_state = 308},
  [21676] = {.lex_state = 0, .external_lex_state = 308},
  [21677] = {.lex_state = 0, .external_lex_state = 308},
  [21678] = {.lex_state = 0, .external_lex_state = 308},
  [21679] = {.lex_state = 55, .external_lex_state = 308},
  [21680] = {.lex_state = 0, .external_lex_state = 308},
  [21681] = {.lex_state = 0, .external_lex_state = 308},
  [21682] = {.lex_state = 0, .external_lex_state = 308},
  [21683] = {.lex_state = 0, .external_lex_state = 443},
  [21684] = {.lex_state = 0, .external_lex_state = 308},
  [21685] = {.lex_state = 0, .external_lex_state = 443},
  [21686] = {.lex_state = 0, .external_lex_state = 308},
  [21687] = {.lex_state = 0, .external_lex_state = 308},
  [21688] = {.lex_state = 0, .external_lex_state = 308},
  [21689] = {.lex_state = 0, .external_lex_state = 308},
  [21690] = {.lex_state = 0, .external_lex_state = 308},
  [21691] = {.lex_state = 0, .external_lex_state = 443},
  [21692] = {.lex_state = 0, .external_lex_state = 308},
  [21693] = {.lex_state = 0, .external_lex_state = 308},
  [21694] = {.lex_state = 0, .external_lex_state = 308},
  [21695] = {.lex_state = 0, .external_lex_state = 308},
  [21696] = {.lex_state = 0, .external_lex_state = 308},
  [21697] = {.lex_state = 0, .external_lex_state = 308},
  [21698] = {.lex_state = 0, .external_lex_state = 443},
  [21699] = {.lex_state = 0, .external_lex_state = 308},
  [21700] = {.lex_state = 0, .external_lex_state = 308},
  [21701] = {.lex_state = 0, .external_lex_state = 308},
  [21702] = {.lex_state = 0, .external_lex_state = 308},
  [21703] = {.lex_state = 0, .external_lex_state = 308},
  [21704] = {.lex_state = 0, .external_lex_state = 308},
  [21705] = {.lex_state = 0, .external_lex_state = 308},
  [21706] = {.lex_state = 0, .external_lex_state = 308},
  [21707] = {.lex_state = 0, .external_lex_state = 308},
  [21708] = {.lex_state = 0, .external_lex_state = 308},
  [21709] = {.lex_state = 0, .external_lex_state = 308},
  [21710] = {.lex_state = 0, .external_lex_state = 308},
  [21711] = {.lex_state = 0, .external_lex_state = 308},
  [21712] = {.lex_state = 0, .external_lex_state = 308},
  [21713] = {.lex_state = 0, .external_lex_state = 308},
  [21714] = {.lex_state = 0, .external_lex_state = 308},
  [21715] = {.lex_state = 0, .external_lex_state = 308},
  [21716] = {.lex_state = 0, .external_lex_state = 308},
  [21717] = {.lex_state = 0, .external_lex_state = 308},
  [21718] = {.lex_state = 55, .external_lex_state = 308},
  [21719] = {.lex_state = 0, .external_lex_state = 308},
  [21720] = {.lex_state = 0, .external_lex_state = 308},
  [21721] = {.lex_state = 0, .external_lex_state = 308},
  [21722] = {.lex_state = 0, .external_lex_state = 308},
  [21723] = {.lex_state = 0, .external_lex_state = 308},
  [21724] = {.lex_state = 0, .external_lex_state = 308},
  [21725] = {.lex_state = 0, .external_lex_state = 308},
  [21726] = {.lex_state = 0, .external_lex_state = 443},
  [21727] = {.lex_state = 0, .external_lex_state = 308},
  [21728] = {.lex_state = 0, .external_lex_state = 443},
  [21729] = {.lex_state = 0, .external_lex_state = 308},
  [21730] = {.lex_state = 0, .external_lex_state = 308},
  [21731] = {.lex_state = 0, .external_lex_state = 308},
  [21732] = {.lex_state = 0, .external_lex_state = 308},
  [21733] = {.lex_state = 0, .external_lex_state = 308},
  [21734] = {.lex_state = 0, .external_lex_state = 308},
  [21735] = {.lex_state = 0, .external_lex_state = 308},
  [21736] = {.lex_state = 0, .external_lex_state = 308},
  [21737] = {.lex_state = 0, .external_lex_state = 443},
  [21738] = {.lex_state = 0, .external_lex_state = 308},
  [21739] = {.lex_state = 0, .external_lex_state = 443},
  [21740] = {.lex_state = 0, .external_lex_state = 308},
  [21741] = {.lex_state = 0, .external_lex_state = 308},
  [21742] = {.lex_state = 0, .external_lex_state = 443},
  [21743] = {.lex_state = 0, .external_lex_state = 308},
  [21744] = {.lex_state = 0, .external_lex_state = 308},
  [21745] = {.lex_state = 0, .external_lex_state = 308},
  [21746] = {.lex_state = 0, .external_lex_state = 308},
  [21747] = {.lex_state = 0, .external_lex_state = 308},
  [21748] = {.lex_state = 0, .external_lex_state = 443},
  [21749] = {.lex_state = 0, .external_lex_state = 308},
  [21750] = {.lex_state = 0, .external_lex_state = 308},
  [21751] = {.lex_state = 0, .external_lex_state = 308},
  [21752] = {.lex_state = 0, .external_lex_state = 308},
  [21753] = {.lex_state = 0, .external_lex_state = 308},
  [21754] = {.lex_state = 0, .external_lex_state = 443},
  [21755] = {.lex_state = 0, .external_lex_state = 308},
  [21756] = {.lex_state = 0, .external_lex_state = 308},
  [21757] = {.lex_state = 0, .external_lex_state = 308},
  [21758] = {.lex_state = 0, .external_lex_state = 308},
  [21759] = {.lex_state = 0, .external_lex_state = 308},
  [21760] = {.lex_state = 0, .external_lex_state = 308},
  [21761] = {.lex_state = 0, .external_lex_state = 308},
  [21762] = {.lex_state = 0, .external_lex_state = 308},
  [21763] = {.lex_state = 0, .external_lex_state = 308},
  [21764] = {.lex_state = 0, .external_lex_state = 443},
  [21765] = {.lex_state = 0, .external_lex_state = 308},
  [21766] = {.lex_state = 0, .external_lex_state = 443},
  [21767] = {.lex_state = 0, .external_lex_state = 308},
  [21768] = {.lex_state = 0, .external_lex_state = 308},
  [21769] = {.lex_state = 0, .external_lex_state = 308},
  [21770] = {.lex_state = 0, .external_lex_state = 308},
  [21771] = {.lex_state = 0, .external_lex_state = 308},
  [21772] = {.lex_state = 0, .external_lex_state = 308},
  [21773] = {.lex_state = 0, .external_lex_state = 308},
  [21774] = {.lex_state = 0, .external_lex_state = 308},
  [21775] = {.lex_state = 0, .external_lex_state = 308},
  [21776] = {.lex_state = 0, .external_lex_state = 443},
  [21777] = {.lex_state = 0, .external_lex_state = 308},
  [21778] = {.lex_state = 0, .external_lex_state = 308},
  [21779] = {.lex_state = 0, .external_lex_state = 308},
  [21780] = {.lex_state = 0, .external_lex_state = 308},
  [21781] = {.lex_state = 0, .external_lex_state = 308},
  [21782] = {.lex_state = 0, .external_lex_state = 443},
  [21783] = {.lex_state = 55, .external_lex_state = 308},
  [21784] = {.lex_state = 0, .external_lex_state = 308},
  [21785] = {.lex_state = 0, .external_lex_state = 308},
  [21786] = {.lex_state = 0, .external_lex_state = 308},
  [21787] = {.lex_state = 0, .external_lex_state = 308},
  [21788] = {.lex_state = 0, .external_lex_state = 308},
  [21789] = {.lex_state = 0, .external_lex_state = 308},
  [21790] = {.lex_state = 0, .external_lex_state = 308},
  [21791] = {.lex_state = 0, .external_lex_state = 308},
  [21792] = {.lex_state = 0, .external_lex_state = 308},
  [21793] = {.lex_state = 55, .external_lex_state = 308},
  [21794] = {.lex_state = 0, .external_lex_state = 308},
  [21795] = {.lex_state = 0, .external_lex_state = 308},
  [21796] = {.lex_state = 0, .external_lex_state = 443},
  [21797] = {.lex_state = 0, .external_lex_state = 308},
  [21798] = {.lex_state = 0, .external_lex_state = 308},
  [21799] = {.lex_state = 0, .external_lex_state = 308},
  [21800] = {.lex_state = 0, .external_lex_state = 308},
  [21801] = {.lex_state = 0, .external_lex_state = 308},
  [21802] = {.lex_state = 0, .external_lex_state = 443},
  [21803] = {.lex_state = 0, .external_lex_state = 308},
  [21804] = {.lex_state = 55, .external_lex_state = 308},
  [21805] = {.lex_state = 0, .external_lex_state = 308},
  [21806] = {.lex_state = 0, .external_lex_state = 308},
  [21807] = {.lex_state = 0, .external_lex_state = 308},
  [21808] = {.lex_state = 0, .external_lex_state = 308},
  [21809] = {.lex_state = 0, .external_lex_state = 308},
  [21810] = {.lex_state = 0, .external_lex_state = 443},
  [21811] = {.lex_state = 0, .external_lex_state = 308},
  [21812] = {.lex_state = 0, .external_lex_state = 308},
  [21813] = {.lex_state = 0, .external_lex_state = 308},
  [21814] = {.lex_state = 0, .external_lex_state = 308},
  [21815] = {.lex_state = 0, .external_lex_state = 308},
  [21816] = {.lex_state = 0, .external_lex_state = 308},
  [21817] = {.lex_state = 55, .external_lex_state = 308},
  [21818] = {.lex_state = 0, .external_lex_state = 308},
  [21819] = {.lex_state = 0, .external_lex_state = 308},
  [21820] = {.lex_state = 0, .external_lex_state = 308},
  [21821] = {.lex_state = 0, .external_lex_state = 308},
  [21822] = {.lex_state = 55, .external_lex_state = 308},
  [21823] = {.lex_state = 0, .external_lex_state = 308},
  [21824] = {.lex_state = 0, .external_lex_state = 308},
  [21825] = {.lex_state = 0, .external_lex_state = 308},
  [21826] = {.lex_state = 0, .external_lex_state = 308},
  [21827] = {.lex_state = 0, .external_lex_state = 308},
  [21828] = {.lex_state = 0, .external_lex_state = 308},
  [21829] = {.lex_state = 0, .external_lex_state = 308},
  [21830] = {.lex_state = 0, .external_lex_state = 308},
  [21831] = {.lex_state = 55, .external_lex_state = 308},
  [21832] = {.lex_state = 0, .external_lex_state = 443},
  [21833] = {.lex_state = 0, .external_lex_state = 308},
  [21834] = {.lex_state = 0, .external_lex_state = 308},
  [21835] = {.lex_state = 0, .external_lex_state = 308},
  [21836] = {.lex_state = 0, .external_lex_state = 443},
  [21837] = {.lex_state = 0, .external_lex_state = 367},
  [21838] = {.lex_state = 0, .external_lex_state = 443},
  [21839] = {.lex_state = 0, .external_lex_state = 308},
  [21840] = {.lex_state = 0, .external_lex_state = 308},
  [21841] = {.lex_state = 0, .external_lex_state = 308},
  [21842] = {.lex_state = 0, .external_lex_state = 308},
  [21843] = {.lex_state = 55, .external_lex_state = 442},
  [21844] = {.lex_state = 0, .external_lex_state = 308},
  [21845] = {.lex_state = 0, .external_lex_state = 308},
  [21846] = {.lex_state = 0, .external_lex_state = 308},
  [21847] = {.lex_state = 0, .external_lex_state = 308},
  [21848] = {.lex_state = 0, .external_lex_state = 308},
  [21849] = {.lex_state = 0, .external_lex_state = 308},
  [21850] = {.lex_state = 0, .external_lex_state = 443},
  [21851] = {.lex_state = 0, .external_lex_state = 308},
  [21852] = {.lex_state = 0, .external_lex_state = 308},
  [21853] = {.lex_state = 0, .external_lex_state = 443},
  [21854] = {.lex_state = 0, .external_lex_state = 308},
  [21855] = {.lex_state = 0, .external_lex_state = 308},
  [21856] = {.lex_state = 0, .external_lex_state = 308},
  [21857] = {.lex_state = 0, .external_lex_state = 308},
  [21858] = {.lex_state = 0, .external_lex_state = 308},
  [21859] = {.lex_state = 0, .external_lex_state = 443},
  [21860] = {.lex_state = 0, .external_lex_state = 308},
  [21861] = {.lex_state = 0, .external_lex_state = 308},
  [21862] = {.lex_state = 0, .external_lex_state = 308},
  [21863] = {.lex_state = 0, .external_lex_state = 308},
  [21864] = {.lex_state = 0, .external_lex_state = 308},
  [21865] = {.lex_state = 0, .external_lex_state = 308},
  [21866] = {.lex_state = 0, .external_lex_state = 443},
  [21867] = {.lex_state = 0, .external_lex_state = 308},
  [21868] = {.lex_state = 0, .external_lex_state = 308},
  [21869] = {.lex_state = 0, .external_lex_state = 308},
  [21870] = {.lex_state = 0, .external_lex_state = 308},
  [21871] = {.lex_state = 0, .external_lex_state = 308},
  [21872] = {.lex_state = 0, .external_lex_state = 308},
  [21873] = {.lex_state = 0, .external_lex_state = 308},
  [21874] = {.lex_state = 0, .external_lex_state = 308},
  [21875] = {.lex_state = 0, .external_lex_state = 308},
  [21876] = {.lex_state = 0, .external_lex_state = 308},
  [21877] = {.lex_state = 0, .external_lex_state = 308},
  [21878] = {.lex_state = 0, .external_lex_state = 308},
  [21879] = {.lex_state = 0, .external_lex_state = 308},
  [21880] = {.lex_state = 0, .external_lex_state = 308},
  [21881] = {.lex_state = 0, .external_lex_state = 308},
  [21882] = {.lex_state = 0, .external_lex_state = 308},
  [21883] = {.lex_state = 0, .external_lex_state = 308},
  [21884] = {.lex_state = 0, .external_lex_state = 308},
  [21885] = {.lex_state = 0, .external_lex_state = 308},
  [21886] = {.lex_state = 0, .external_lex_state = 308},
  [21887] = {.lex_state = 0, .external_lex_state = 443},
  [21888] = {.lex_state = 0, .external_lex_state = 308},
  [21889] = {.lex_state = 0, .external_lex_state = 308},
  [21890] = {.lex_state = 0, .external_lex_state = 308},
  [21891] = {.lex_state = 0, .external_lex_state = 308},
  [21892] = {.lex_state = 0, .external_lex_state = 308},
  [21893] = {.lex_state = 0, .external_lex_state = 308},
  [21894] = {.lex_state = 0, .external_lex_state = 443},
  [21895] = {.lex_state = 0, .external_lex_state = 308},
  [21896] = {.lex_state = 0, .external_lex_state = 308},
  [21897] = {.lex_state = 0, .external_lex_state = 308},
  [21898] = {.lex_state = 0, .external_lex_state = 308},
  [21899] = {.lex_state = 0, .external_lex_state = 308},
  [21900] = {.lex_state = 0, .external_lex_state = 308},
  [21901] = {.lex_state = 0, .external_lex_state = 443},
  [21902] = {.lex_state = 0, .external_lex_state = 308},
  [21903] = {.lex_state = 0, .external_lex_state = 308},
  [21904] = {.lex_state = 0, .external_lex_state = 308},
  [21905] = {.lex_state = 0, .external_lex_state = 308},
  [21906] = {.lex_state = 0, .external_lex_state = 308},
  [21907] = {.lex_state = 0, .external_lex_state = 308},
  [21908] = {.lex_state = 0, .external_lex_state = 308},
  [21909] = {.lex_state = 0, .external_lex_state = 308},
  [21910] = {.lex_state = 0, .external_lex_state = 308},
  [21911] = {.lex_state = 0, .external_lex_state = 308},
  [21912] = {.lex_state = 0, .external_lex_state = 308},
  [21913] = {.lex_state = 0, .external_lex_state = 308},
  [21914] = {.lex_state = 0, .external_lex_state = 308},
  [21915] = {.lex_state = 0, .external_lex_state = 308},
  [21916] = {.lex_state = 0, .external_lex_state = 443},
  [21917] = {.lex_state = 0, .external_lex_state = 308},
  [21918] = {.lex_state = 0, .external_lex_state = 308},
  [21919] = {.lex_state = 0, .external_lex_state = 308},
  [21920] = {.lex_state = 0, .external_lex_state = 443},
  [21921] = {.lex_state = 0, .external_lex_state = 443},
  [21922] = {.lex_state = 0, .external_lex_state = 443},
  [21923] = {.lex_state = 0, .external_lex_state = 308},
  [21924] = {.lex_state = 0, .external_lex_state = 308},
  [21925] = {.lex_state = 0, .external_lex_state = 308},
  [21926] = {.lex_state = 0, .external_lex_state = 308},
  [21927] = {.lex_state = 0, .external_lex_state = 308},
  [21928] = {.lex_state = 0, .external_lex_state = 443},
  [21929] = {.lex_state = 0, .external_lex_state = 308},
  [21930] = {.lex_state = 0, .external_lex_state = 308},
  [21931] = {.lex_state = 0, .external_lex_state = 308},
  [21932] = {.lex_state = 0, .external_lex_state = 308},
  [21933] = {.lex_state = 0, .external_lex_state = 308},
  [21934] = {.lex_state = 0, .external_lex_state = 308},
  [21935] = {.lex_state = 0, .external_lex_state = 308},
  [21936] = {.lex_state = 0, .external_lex_state = 308},
  [21937] = {.lex_state = 0, .external_lex_state = 308},
  [21938] = {.lex_state = 0, .external_lex_state = 308},
  [21939] = {.lex_state = 0, .external_lex_state = 308},
  [21940] = {.lex_state = 0, .external_lex_state = 308},
  [21941] = {.lex_state = 0, .external_lex_state = 308},
  [21942] = {.lex_state = 0, .external_lex_state = 308},
  [21943] = {.lex_state = 0, .external_lex_state = 308},
  [21944] = {.lex_state = 0, .external_lex_state = 308},
  [21945] = {.lex_state = 0, .external_lex_state = 308},
  [21946] = {.lex_state = 0, .external_lex_state = 308},
  [21947] = {.lex_state = 0, .external_lex_state = 308},
  [21948] = {.lex_state = 0, .external_lex_state = 308},
  [21949] = {.lex_state = 0, .external_lex_state = 308},
  [21950] = {.lex_state = 0, .external_lex_state = 443},
  [21951] = {.lex_state = 0, .external_lex_state = 308},
  [21952] = {.lex_state = 0, .external_lex_state = 308},
  [21953] = {.lex_state = 0, .external_lex_state = 308},
  [21954] = {.lex_state = 0, .external_lex_state = 308},
  [21955] = {.lex_state = 0, .external_lex_state = 308},
  [21956] = {.lex_state = 0, .external_lex_state = 308},
  [21957] = {.lex_state = 0, .external_lex_state = 308},
  [21958] = {.lex_state = 0, .external_lex_state = 308},
  [21959] = {.lex_state = 0, .external_lex_state = 308},
  [21960] = {.lex_state = 0, .external_lex_state = 308},
  [21961] = {.lex_state = 0, .external_lex_state = 308},
  [21962] = {.lex_state = 0, .external_lex_state = 308},
  [21963] = {.lex_state = 0, .external_lex_state = 308},
  [21964] = {.lex_state = 0, .external_lex_state = 308},
  [21965] = {.lex_state = 0, .external_lex_state = 308},
  [21966] = {.lex_state = 0, .external_lex_state = 308},
  [21967] = {.lex_state = 0, .external_lex_state = 308},
  [21968] = {.lex_state = 0, .external_lex_state = 308},
  [21969] = {.lex_state = 0, .external_lex_state = 308},
  [21970] = {.lex_state = 0, .external_lex_state = 308},
  [21971] = {.lex_state = 0, .external_lex_state = 308},
  [21972] = {.lex_state = 0, .external_lex_state = 308},
  [21973] = {.lex_state = 0, .external_lex_state = 308},
  [21974] = {.lex_state = 0, .external_lex_state = 308},
  [21975] = {.lex_state = 0, .external_lex_state = 308},
  [21976] = {.lex_state = 0, .external_lex_state = 308},
  [21977] = {.lex_state = 0, .external_lex_state = 443},
  [21978] = {.lex_state = 0, .external_lex_state = 443},
  [21979] = {.lex_state = 0, .external_lex_state = 443},
  [21980] = {.lex_state = 0, .external_lex_state = 443},
  [21981] = {.lex_state = 0, .external_lex_state = 308},
  [21982] = {.lex_state = 0, .external_lex_state = 308},
  [21983] = {.lex_state = 0, .external_lex_state = 308},
  [21984] = {.lex_state = 0, .external_lex_state = 308},
  [21985] = {.lex_state = 0, .external_lex_state = 308},
  [21986] = {.lex_state = 0, .external_lex_state = 308},
  [21987] = {.lex_state = 0, .external_lex_state = 308},
  [21988] = {.lex_state = 0, .external_lex_state = 308},
  [21989] = {.lex_state = 0, .external_lex_state = 308},
  [21990] = {.lex_state = 0, .external_lex_state = 308},
  [21991] = {.lex_state = 0, .external_lex_state = 308},
  [21992] = {.lex_state = 0, .external_lex_state = 367},
  [21993] = {.lex_state = 0, .external_lex_state = 308},
  [21994] = {.lex_state = 0, .external_lex_state = 308},
  [21995] = {.lex_state = 0, .external_lex_state = 308},
  [21996] = {.lex_state = 0, .external_lex_state = 308},
  [21997] = {.lex_state = 0, .external_lex_state = 308},
  [21998] = {.lex_state = 0, .external_lex_state = 308},
  [21999] = {.lex_state = 0, .external_lex_state = 308},
  [22000] = {.lex_state = 0, .external_lex_state = 308},
  [22001] = {.lex_state = 0, .external_lex_state = 308},
  [22002] = {.lex_state = 0, .external_lex_state = 308},
  [22003] = {.lex_state = 0, .external_lex_state = 308},
  [22004] = {.lex_state = 0, .external_lex_state = 308},
  [22005] = {.lex_state = 0, .external_lex_state = 308},
  [22006] = {.lex_state = 0, .external_lex_state = 443},
  [22007] = {.lex_state = 0, .external_lex_state = 443},
  [22008] = {.lex_state = 0, .external_lex_state = 308},
  [22009] = {.lex_state = 0, .external_lex_state = 308},
  [22010] = {.lex_state = 0, .external_lex_state = 308},
  [22011] = {.lex_state = 0, .external_lex_state = 308},
  [22012] = {.lex_state = 0, .external_lex_state = 443},
  [22013] = {.lex_state = 0, .external_lex_state = 308},
  [22014] = {.lex_state = 0, .external_lex_state = 308},
  [22015] = {.lex_state = 55, .external_lex_state = 308},
  [22016] = {.lex_state = 0, .external_lex_state = 443},
  [22017] = {.lex_state = 0, .external_lex_state = 308},
  [22018] = {.lex_state = 0, .external_lex_state = 308},
  [22019] = {.lex_state = 0, .external_lex_state = 308},
  [22020] = {.lex_state = 0, .external_lex_state = 308},
  [22021] = {.lex_state = 0, .external_lex_state = 308},
  [22022] = {.lex_state = 0, .external_lex_state = 308},
  [22023] = {.lex_state = 0, .external_lex_state = 308},
  [22024] = {.lex_state = 0, .external_lex_state = 308},
  [22025] = {.lex_state = 0, .external_lex_state = 308},
  [22026] = {.lex_state = 0, .external_lex_state = 308},
  [22027] = {.lex_state = 0, .external_lex_state = 308},
  [22028] = {.lex_state = 0, .external_lex_state = 443},
  [22029] = {.lex_state = 0, .external_lex_state = 308},
  [22030] = {.lex_state = 0, .external_lex_state = 308},
  [22031] = {.lex_state = 0, .external_lex_state = 308},
  [22032] = {.lex_state = 0, .external_lex_state = 443},
  [22033] = {.lex_state = 0, .external_lex_state = 308},
  [22034] = {.lex_state = 0, .external_lex_state = 443},
  [22035] = {.lex_state = 0, .external_lex_state = 308},
  [22036] = {.lex_state = 0, .external_lex_state = 308},
  [22037] = {.lex_state = 0, .external_lex_state = 308},
  [22038] = {.lex_state = 0, .external_lex_state = 308},
  [22039] = {.lex_state = 0, .external_lex_state = 308},
  [22040] = {.lex_state = 55, .external_lex_state = 308},
  [22041] = {.lex_state = 0, .external_lex_state = 308},
  [22042] = {.lex_state = 0, .external_lex_state = 443},
  [22043] = {.lex_state = 0, .external_lex_state = 308},
  [22044] = {.lex_state = 0, .external_lex_state = 308},
  [22045] = {.lex_state = 0, .external_lex_state = 308},
  [22046] = {.lex_state = 0, .external_lex_state = 308},
  [22047] = {.lex_state = 0, .external_lex_state = 308},
  [22048] = {.lex_state = 0, .external_lex_state = 443},
  [22049] = {.lex_state = 0, .external_lex_state = 308},
  [22050] = {.lex_state = 0, .external_lex_state = 308},
  [22051] = {.lex_state = 0, .external_lex_state = 308},
  [22052] = {.lex_state = 0, .external_lex_state = 443},
  [22053] = {.lex_state = 0, .external_lex_state = 308},
  [22054] = {.lex_state = 0, .external_lex_state = 308},
  [22055] = {.lex_state = 0, .external_lex_state = 308},
  [22056] = {.lex_state = 0, .external_lex_state = 308},
  [22057] = {.lex_state = 0, .external_lex_state = 308},
  [22058] = {.lex_state = 0, .external_lex_state = 308},
  [22059] = {.lex_state = 0, .external_lex_state = 308},
  [22060] = {.lex_state = 0, .external_lex_state = 443},
  [22061] = {.lex_state = 55, .external_lex_state = 308},
  [22062] = {.lex_state = 0, .external_lex_state = 308},
  [22063] = {.lex_state = 0, .external_lex_state = 308},
  [22064] = {.lex_state = 0, .external_lex_state = 308},
  [22065] = {.lex_state = 0, .external_lex_state = 308},
  [22066] = {.lex_state = 0, .external_lex_state = 308},
  [22067] = {.lex_state = 0, .external_lex_state = 308},
  [22068] = {.lex_state = 55, .external_lex_state = 308},
  [22069] = {.lex_state = 0, .external_lex_state = 308},
  [22070] = {.lex_state = 0, .external_lex_state = 443},
  [22071] = {.lex_state = 0, .external_lex_state = 308},
  [22072] = {.lex_state = 0, .external_lex_state = 308},
  [22073] = {.lex_state = 0, .external_lex_state = 308},
  [22074] = {.lex_state = 0, .external_lex_state = 443},
  [22075] = {.lex_state = 0, .external_lex_state = 308},
  [22076] = {.lex_state = 0, .external_lex_state = 308},
  [22077] = {.lex_state = 0, .external_lex_state = 443},
  [22078] = {.lex_state = 0, .external_lex_state = 308},
  [22079] = {.lex_state = 0, .external_lex_state = 308},
  [22080] = {.lex_state = 0, .external_lex_state = 308},
  [22081] = {.lex_state = 0, .external_lex_state = 308},
  [22082] = {.lex_state = 0, .external_lex_state = 308},
  [22083] = {.lex_state = 0, .external_lex_state = 308},
  [22084] = {.lex_state = 0, .external_lex_state = 308},
  [22085] = {.lex_state = 0, .external_lex_state = 308},
  [22086] = {.lex_state = 0, .external_lex_state = 308},
  [22087] = {.lex_state = 0, .external_lex_state = 308},
  [22088] = {.lex_state = 0, .external_lex_state = 308},
  [22089] = {.lex_state = 55, .external_lex_state = 308},
  [22090] = {.lex_state = 57, .external_lex_state = 308},
  [22091] = {.lex_state = 0, .external_lex_state = 308},
  [22092] = {.lex_state = 0, .external_lex_state = 308},
  [22093] = {.lex_state = 0, .external_lex_state = 415},
  [22094] = {.lex_state = 0, .external_lex_state = 308},
  [22095] = {.lex_state = 0, .external_lex_state = 308},
  [22096] = {.lex_state = 0, .external_lex_state = 308},
  [22097] = {.lex_state = 0, .external_lex_state = 308},
  [22098] = {.lex_state = 0, .external_lex_state = 308},
  [22099] = {.lex_state = 0, .external_lex_state = 308},
  [22100] = {.lex_state = 0, .external_lex_state = 308},
  [22101] = {.lex_state = 0, .external_lex_state = 308},
  [22102] = {.lex_state = 0, .external_lex_state = 443},
  [22103] = {.lex_state = 55, .external_lex_state = 308},
  [22104] = {.lex_state = 0, .external_lex_state = 443},
  [22105] = {.lex_state = 0, .external_lex_state = 308},
  [22106] = {.lex_state = 0, .external_lex_state = 308},
  [22107] = {.lex_state = 0, .external_lex_state = 308},
  [22108] = {.lex_state = 0, .external_lex_state = 308},
  [22109] = {.lex_state = 0, .external_lex_state = 308},
  [22110] = {.lex_state = 0, .external_lex_state = 308},
  [22111] = {.lex_state = 0, .external_lex_state = 308},
  [22112] = {.lex_state = 0, .external_lex_state = 308},
  [22113] = {.lex_state = 0, .external_lex_state = 308},
  [22114] = {.lex_state = 0, .external_lex_state = 308},
  [22115] = {.lex_state = 0, .external_lex_state = 308},
  [22116] = {.lex_state = 0, .external_lex_state = 308},
  [22117] = {.lex_state = 0, .external_lex_state = 308},
  [22118] = {.lex_state = 0, .external_lex_state = 308},
  [22119] = {.lex_state = 0, .external_lex_state = 308},
  [22120] = {.lex_state = 0, .external_lex_state = 308},
  [22121] = {.lex_state = 0, .external_lex_state = 308},
  [22122] = {.lex_state = 57, .external_lex_state = 308},
  [22123] = {.lex_state = 0, .external_lex_state = 308},
  [22124] = {.lex_state = 0, .external_lex_state = 308},
  [22125] = {.lex_state = 0, .external_lex_state = 308},
  [22126] = {.lex_state = 55, .external_lex_state = 308},
  [22127] = {.lex_state = 0, .external_lex_state = 308},
  [22128] = {.lex_state = 0, .external_lex_state = 308},
  [22129] = {.lex_state = 0, .external_lex_state = 308},
  [22130] = {.lex_state = 0, .external_lex_state = 308},
  [22131] = {.lex_state = 0, .external_lex_state = 308},
  [22132] = {.lex_state = 0, .external_lex_state = 308},
  [22133] = {.lex_state = 0, .external_lex_state = 443},
  [22134] = {.lex_state = 0, .external_lex_state = 308},
  [22135] = {.lex_state = 0, .external_lex_state = 308},
  [22136] = {.lex_state = 0, .external_lex_state = 308},
  [22137] = {.lex_state = 0, .external_lex_state = 308},
  [22138] = {.lex_state = 0, .external_lex_state = 308},
  [22139] = {.lex_state = 55, .external_lex_state = 442},
  [22140] = {.lex_state = 0, .external_lex_state = 308},
  [22141] = {.lex_state = 0, .external_lex_state = 308},
  [22142] = {.lex_state = 0, .external_lex_state = 308},
  [22143] = {.lex_state = 0, .external_lex_state = 308},
  [22144] = {.lex_state = 0, .external_lex_state = 443},
  [22145] = {.lex_state = 0, .external_lex_state = 308},
  [22146] = {.lex_state = 0, .external_lex_state = 308},
  [22147] = {.lex_state = 0, .external_lex_state = 443},
  [22148] = {.lex_state = 0, .external_lex_state = 415},
  [22149] = {.lex_state = 0, .external_lex_state = 308},
  [22150] = {.lex_state = 0, .external_lex_state = 308},
  [22151] = {.lex_state = 0, .external_lex_state = 308},
  [22152] = {.lex_state = 0, .external_lex_state = 308},
  [22153] = {.lex_state = 0, .external_lex_state = 308},
  [22154] = {.lex_state = 0, .external_lex_state = 308},
  [22155] = {.lex_state = 0, .external_lex_state = 308},
  [22156] = {.lex_state = 0, .external_lex_state = 308},
  [22157] = {.lex_state = 0, .external_lex_state = 308},
  [22158] = {.lex_state = 0, .external_lex_state = 308},
  [22159] = {.lex_state = 0, .external_lex_state = 443},
  [22160] = {.lex_state = 0, .external_lex_state = 308},
  [22161] = {.lex_state = 0, .external_lex_state = 308},
  [22162] = {.lex_state = 0, .external_lex_state = 308},
  [22163] = {.lex_state = 0, .external_lex_state = 308},
  [22164] = {.lex_state = 0, .external_lex_state = 308},
  [22165] = {.lex_state = 0, .external_lex_state = 308},
  [22166] = {.lex_state = 55, .external_lex_state = 308},
  [22167] = {.lex_state = 0, .external_lex_state = 308},
  [22168] = {.lex_state = 0, .external_lex_state = 308},
  [22169] = {.lex_state = 0, .external_lex_state = 308},
  [22170] = {.lex_state = 0, .external_lex_state = 308},
  [22171] = {.lex_state = 0, .external_lex_state = 308},
  [22172] = {.lex_state = 0, .external_lex_state = 308},
  [22173] = {.lex_state = 55, .external_lex_state = 308},
  [22174] = {.lex_state = 0, .external_lex_state = 443},
  [22175] = {.lex_state = 55, .external_lex_state = 308},
  [22176] = {.lex_state = 0, .external_lex_state = 308},
  [22177] = {.lex_state = 0, .external_lex_state = 308},
  [22178] = {.lex_state = 0, .external_lex_state = 308},
  [22179] = {.lex_state = 57, .external_lex_state = 308},
  [22180] = {.lex_state = 0, .external_lex_state = 308},
  [22181] = {.lex_state = 0, .external_lex_state = 308},
  [22182] = {.lex_state = 0, .external_lex_state = 415},
  [22183] = {.lex_state = 0, .external_lex_state = 308},
  [22184] = {.lex_state = 0, .external_lex_state = 308},
  [22185] = {.lex_state = 0, .external_lex_state = 308},
  [22186] = {.lex_state = 0, .external_lex_state = 308},
  [22187] = {.lex_state = 0, .external_lex_state = 308},
  [22188] = {.lex_state = 0, .external_lex_state = 443},
  [22189] = {.lex_state = 0, .external_lex_state = 308},
  [22190] = {.lex_state = 0, .external_lex_state = 308},
  [22191] = {.lex_state = 0, .external_lex_state = 308},
  [22192] = {.lex_state = 0, .external_lex_state = 308},
  [22193] = {.lex_state = 0, .external_lex_state = 308},
  [22194] = {.lex_state = 0, .external_lex_state = 308},
  [22195] = {.lex_state = 0, .external_lex_state = 308},
  [22196] = {.lex_state = 0, .external_lex_state = 308},
  [22197] = {.lex_state = 0, .external_lex_state = 308},
  [22198] = {.lex_state = 0, .external_lex_state = 308},
  [22199] = {.lex_state = 0, .external_lex_state = 308},
  [22200] = {.lex_state = 0, .external_lex_state = 308},
  [22201] = {.lex_state = 0, .external_lex_state = 308},
  [22202] = {.lex_state = 0, .external_lex_state = 308},
  [22203] = {.lex_state = 0, .external_lex_state = 308},
  [22204] = {.lex_state = 0, .external_lex_state = 308},
  [22205] = {.lex_state = 0, .external_lex_state = 308},
  [22206] = {.lex_state = 0, .external_lex_state = 308},
  [22207] = {.lex_state = 0, .external_lex_state = 443},
  [22208] = {.lex_state = 0, .external_lex_state = 443},
  [22209] = {.lex_state = 0, .external_lex_state = 308},
  [22210] = {.lex_state = 57, .external_lex_state = 308},
  [22211] = {.lex_state = 0, .external_lex_state = 308},
  [22212] = {.lex_state = 0, .external_lex_state = 308},
  [22213] = {.lex_state = 0, .external_lex_state = 308},
  [22214] = {.lex_state = 0, .external_lex_state = 443},
  [22215] = {.lex_state = 0, .external_lex_state = 443},
  [22216] = {.lex_state = 0, .external_lex_state = 308},
  [22217] = {.lex_state = 0, .external_lex_state = 308},
  [22218] = {.lex_state = 0, .external_lex_state = 308},
  [22219] = {.lex_state = 0, .external_lex_state = 308},
  [22220] = {.lex_state = 0, .external_lex_state = 308},
  [22221] = {.lex_state = 0, .external_lex_state = 308},
  [22222] = {.lex_state = 0, .external_lex_state = 308},
  [22223] = {.lex_state = 0, .external_lex_state = 308},
  [22224] = {.lex_state = 0, .external_lex_state = 308},
  [22225] = {.lex_state = 0, .external_lex_state = 308},
  [22226] = {.lex_state = 0, .external_lex_state = 308},
  [22227] = {.lex_state = 0, .external_lex_state = 308},
  [22228] = {.lex_state = 0, .external_lex_state = 308},
  [22229] = {.lex_state = 0, .external_lex_state = 308},
  [22230] = {.lex_state = 0, .external_lex_state = 308},
  [22231] = {.lex_state = 0, .external_lex_state = 308},
  [22232] = {.lex_state = 0, .external_lex_state = 308},
  [22233] = {.lex_state = 0, .external_lex_state = 308},
  [22234] = {.lex_state = 0, .external_lex_state = 308},
  [22235] = {.lex_state = 0, .external_lex_state = 308},
  [22236] = {.lex_state = 0, .external_lex_state = 415},
  [22237] = {.lex_state = 0, .external_lex_state = 443},
  [22238] = {.lex_state = 0, .external_lex_state = 308},
  [22239] = {.lex_state = 0, .external_lex_state = 308},
  [22240] = {.lex_state = 0, .external_lex_state = 308},
  [22241] = {.lex_state = 0, .external_lex_state = 308},
  [22242] = {.lex_state = 0, .external_lex_state = 308},
  [22243] = {.lex_state = 0, .external_lex_state = 308},
  [22244] = {.lex_state = 0, .external_lex_state = 308},
  [22245] = {.lex_state = 0, .external_lex_state = 308},
  [22246] = {.lex_state = 0, .external_lex_state = 308},
  [22247] = {.lex_state = 0, .external_lex_state = 443},
  [22248] = {.lex_state = 0, .external_lex_state = 308},
  [22249] = {.lex_state = 0, .external_lex_state = 308},
  [22250] = {.lex_state = 0, .external_lex_state = 308},
  [22251] = {.lex_state = 0, .external_lex_state = 443},
  [22252] = {.lex_state = 0, .external_lex_state = 443},
  [22253] = {.lex_state = 0, .external_lex_state = 443},
  [22254] = {.lex_state = 0, .external_lex_state = 308},
  [22255] = {.lex_state = 55, .external_lex_state = 308},
  [22256] = {.lex_state = 0, .external_lex_state = 308},
  [22257] = {.lex_state = 0, .external_lex_state = 308},
  [22258] = {.lex_state = 0, .external_lex_state = 308},
  [22259] = {.lex_state = 0, .external_lex_state = 308},
  [22260] = {.lex_state = 0, .external_lex_state = 308},
  [22261] = {.lex_state = 0, .external_lex_state = 308},
  [22262] = {.lex_state = 0, .external_lex_state = 308},
  [22263] = {.lex_state = 0, .external_lex_state = 308},
  [22264] = {.lex_state = 0, .external_lex_state = 308},
  [22265] = {.lex_state = 0, .external_lex_state = 308},
  [22266] = {.lex_state = 0, .external_lex_state = 308},
  [22267] = {.lex_state = 0, .external_lex_state = 308},
  [22268] = {.lex_state = 0, .external_lex_state = 308},
  [22269] = {.lex_state = 0, .external_lex_state = 308},
  [22270] = {.lex_state = 0, .external_lex_state = 415},
  [22271] = {.lex_state = 0, .external_lex_state = 308},
  [22272] = {.lex_state = 0, .external_lex_state = 308},
  [22273] = {.lex_state = 0, .external_lex_state = 308},
  [22274] = {.lex_state = 0, .external_lex_state = 308},
  [22275] = {.lex_state = 55, .external_lex_state = 308},
  [22276] = {.lex_state = 0, .external_lex_state = 308},
  [22277] = {.lex_state = 0, .external_lex_state = 308},
  [22278] = {.lex_state = 0, .external_lex_state = 308},
  [22279] = {.lex_state = 55, .external_lex_state = 308},
  [22280] = {.lex_state = 0, .external_lex_state = 308},
  [22281] = {.lex_state = 0, .external_lex_state = 308},
  [22282] = {.lex_state = 0, .external_lex_state = 308},
  [22283] = {.lex_state = 55, .external_lex_state = 308},
  [22284] = {.lex_state = 0, .external_lex_state = 308},
  [22285] = {.lex_state = 0, .external_lex_state = 308},
  [22286] = {.lex_state = 0, .external_lex_state = 443},
  [22287] = {.lex_state = 0, .external_lex_state = 443},
  [22288] = {.lex_state = 0, .external_lex_state = 308},
  [22289] = {.lex_state = 0, .external_lex_state = 308},
  [22290] = {.lex_state = 0, .external_lex_state = 308},
  [22291] = {.lex_state = 0, .external_lex_state = 308},
  [22292] = {.lex_state = 0, .external_lex_state = 308},
  [22293] = {.lex_state = 0, .external_lex_state = 308},
  [22294] = {.lex_state = 0, .external_lex_state = 308},
  [22295] = {.lex_state = 0, .external_lex_state = 443},
  [22296] = {.lex_state = 0, .external_lex_state = 415},
  [22297] = {.lex_state = 0, .external_lex_state = 308},
  [22298] = {.lex_state = 0, .external_lex_state = 308},
  [22299] = {.lex_state = 0, .external_lex_state = 308},
  [22300] = {.lex_state = 0, .external_lex_state = 415},
  [22301] = {.lex_state = 0, .external_lex_state = 443},
  [22302] = {.lex_state = 0, .external_lex_state = 308},
  [22303] = {.lex_state = 0, .external_lex_state = 308},
  [22304] = {.lex_state = 0, .external_lex_state = 308},
  [22305] = {.lex_state = 0, .external_lex_state = 308},
  [22306] = {.lex_state = 0, .external_lex_state = 308},
  [22307] = {.lex_state = 0, .external_lex_state = 308},
  [22308] = {.lex_state = 0, .external_lex_state = 308},
  [22309] = {.lex_state = 0, .external_lex_state = 308},
  [22310] = {.lex_state = 0, .external_lex_state = 308},
  [22311] = {.lex_state = 0, .external_lex_state = 308},
  [22312] = {.lex_state = 0, .external_lex_state = 308},
  [22313] = {.lex_state = 0, .external_lex_state = 308},
  [22314] = {.lex_state = 0, .external_lex_state = 308},
  [22315] = {.lex_state = 0, .external_lex_state = 308},
  [22316] = {.lex_state = 0, .external_lex_state = 308},
  [22317] = {.lex_state = 0, .external_lex_state = 308},
  [22318] = {.lex_state = 0, .external_lex_state = 308},
  [22319] = {.lex_state = 0, .external_lex_state = 308},
  [22320] = {.lex_state = 0, .external_lex_state = 308},
  [22321] = {.lex_state = 0, .external_lex_state = 308},
  [22322] = {.lex_state = 0, .external_lex_state = 443},
  [22323] = {.lex_state = 0, .external_lex_state = 308},
  [22324] = {.lex_state = 0, .external_lex_state = 443},
  [22325] = {.lex_state = 0, .external_lex_state = 308},
  [22326] = {.lex_state = 0, .external_lex_state = 415},
  [22327] = {.lex_state = 0, .external_lex_state = 308},
  [22328] = {.lex_state = 0, .external_lex_state = 308},
  [22329] = {.lex_state = 0, .external_lex_state = 308},
  [22330] = {.lex_state = 0, .external_lex_state = 443},
  [22331] = {.lex_state = 0, .external_lex_state = 308},
  [22332] = {.lex_state = 0, .external_lex_state = 308},
  [22333] = {.lex_state = 0, .external_lex_state = 443},
  [22334] = {.lex_state = 0, .external_lex_state = 443},
  [22335] = {.lex_state = 0, .external_lex_state = 308},
  [22336] = {.lex_state = 0, .external_lex_state = 308},
  [22337] = {.lex_state = 0, .external_lex_state = 308},
  [22338] = {.lex_state = 0, .external_lex_state = 308},
  [22339] = {.lex_state = 0, .external_lex_state = 308},
  [22340] = {.lex_state = 0, .external_lex_state = 308},
  [22341] = {.lex_state = 0, .external_lex_state = 308},
  [22342] = {.lex_state = 0, .external_lex_state = 308},
  [22343] = {.lex_state = 0, .external_lex_state = 308},
  [22344] = {.lex_state = 0, .external_lex_state = 308},
  [22345] = {.lex_state = 0, .external_lex_state = 308},
  [22346] = {.lex_state = 0, .external_lex_state = 415},
  [22347] = {.lex_state = 0, .external_lex_state = 443},
  [22348] = {.lex_state = 0, .external_lex_state = 308},
  [22349] = {.lex_state = 0, .external_lex_state = 308},
  [22350] = {.lex_state = 0, .external_lex_state = 308},
  [22351] = {.lex_state = 0, .external_lex_state = 308},
  [22352] = {.lex_state = 0, .external_lex_state = 308},
  [22353] = {.lex_state = 0, .external_lex_state = 308},
  [22354] = {.lex_state = 0, .external_lex_state = 308},
  [22355] = {.lex_state = 0, .external_lex_state = 308},
  [22356] = {.lex_state = 0, .external_lex_state = 308},
  [22357] = {.lex_state = 0, .external_lex_state = 308},
  [22358] = {.lex_state = 0, .external_lex_state = 308},
  [22359] = {.lex_state = 0, .external_lex_state = 308},
  [22360] = {.lex_state = 0, .external_lex_state = 308},
  [22361] = {.lex_state = 0, .external_lex_state = 308},
  [22362] = {.lex_state = 0, .external_lex_state = 308},
  [22363] = {.lex_state = 0, .external_lex_state = 308},
  [22364] = {.lex_state = 0, .external_lex_state = 308},
  [22365] = {.lex_state = 0, .external_lex_state = 308},
  [22366] = {.lex_state = 0, .external_lex_state = 415},
  [22367] = {.lex_state = 0, .external_lex_state = 308},
  [22368] = {.lex_state = 0, .external_lex_state = 308},
  [22369] = {.lex_state = 0, .external_lex_state = 443},
  [22370] = {.lex_state = 0, .external_lex_state = 443},
  [22371] = {.lex_state = 0, .external_lex_state = 308},
  [22372] = {.lex_state = 0, .external_lex_state = 308},
  [22373] = {.lex_state = 55, .external_lex_state = 308},
  [22374] = {.lex_state = 0, .external_lex_state = 308},
  [22375] = {.lex_state = 0, .external_lex_state = 308},
  [22376] = {.lex_state = 0, .external_lex_state = 308},
  [22377] = {.lex_state = 0, .external_lex_state = 308},
  [22378] = {.lex_state = 0, .external_lex_state = 308},
  [22379] = {.lex_state = 0, .external_lex_state = 308},
  [22380] = {.lex_state = 0, .external_lex_state = 367},
  [22381] = {.lex_state = 0, .external_lex_state = 308},
  [22382] = {.lex_state = 0, .external_lex_state = 308},
  [22383] = {.lex_state = 0, .external_lex_state = 308},
  [22384] = {.lex_state = 0, .external_lex_state = 308},
  [22385] = {.lex_state = 0, .external_lex_state = 308},
  [22386] = {.lex_state = 0, .external_lex_state = 415},
  [22387] = {.lex_state = 0, .external_lex_state = 308},
  [22388] = {.lex_state = 0, .external_lex_state = 443},
  [22389] = {.lex_state = 0, .external_lex_state = 443},
  [22390] = {.lex_state = 55, .external_lex_state = 308},
  [22391] = {.lex_state = 0, .external_lex_state = 308},
  [22392] = {.lex_state = 0, .external_lex_state = 308},
  [22393] = {.lex_state = 0, .external_lex_state = 308},
  [22394] = {.lex_state = 55, .external_lex_state = 308},
  [22395] = {.lex_state = 0, .external_lex_state = 308},
  [22396] = {.lex_state = 0, .external_lex_state = 308},
  [22397] = {.lex_state = 0, .external_lex_state = 308},
  [22398] = {.lex_state = 0, .external_lex_state = 308},
  [22399] = {.lex_state = 0, .external_lex_state = 308},
  [22400] = {.lex_state = 0, .external_lex_state = 308},
  [22401] = {.lex_state = 0, .external_lex_state = 308},
  [22402] = {.lex_state = 0, .external_lex_state = 308},
  [22403] = {.lex_state = 0, .external_lex_state = 308},
  [22404] = {.lex_state = 0, .external_lex_state = 415},
  [22405] = {.lex_state = 0, .external_lex_state = 308},
  [22406] = {.lex_state = 0, .external_lex_state = 308},
  [22407] = {.lex_state = 0, .external_lex_state = 308},
  [22408] = {.lex_state = 0, .external_lex_state = 308},
  [22409] = {.lex_state = 0, .external_lex_state = 308},
  [22410] = {.lex_state = 0, .external_lex_state = 308},
  [22411] = {.lex_state = 0, .external_lex_state = 308},
  [22412] = {.lex_state = 0, .external_lex_state = 308},
  [22413] = {.lex_state = 0, .external_lex_state = 308},
  [22414] = {.lex_state = 0, .external_lex_state = 308},
  [22415] = {.lex_state = 0, .external_lex_state = 308},
  [22416] = {.lex_state = 0, .external_lex_state = 308},
  [22417] = {.lex_state = 0, .external_lex_state = 308},
  [22418] = {.lex_state = 0, .external_lex_state = 308},
  [22419] = {.lex_state = 0, .external_lex_state = 308},
  [22420] = {.lex_state = 0, .external_lex_state = 443},
  [22421] = {.lex_state = 0, .external_lex_state = 415},
  [22422] = {.lex_state = 0, .external_lex_state = 308},
  [22423] = {.lex_state = 0, .external_lex_state = 443},
  [22424] = {.lex_state = 0, .external_lex_state = 308},
  [22425] = {.lex_state = 0, .external_lex_state = 308},
  [22426] = {.lex_state = 0, .external_lex_state = 308},
  [22427] = {.lex_state = 0, .external_lex_state = 308},
  [22428] = {.lex_state = 0, .external_lex_state = 308},
  [22429] = {.lex_state = 0, .external_lex_state = 308},
  [22430] = {.lex_state = 0, .external_lex_state = 308},
  [22431] = {.lex_state = 55, .external_lex_state = 308},
  [22432] = {.lex_state = 0, .external_lex_state = 308},
  [22433] = {.lex_state = 0, .external_lex_state = 308},
  [22434] = {.lex_state = 0, .external_lex_state = 443},
  [22435] = {.lex_state = 0, .external_lex_state = 443},
  [22436] = {.lex_state = 0, .external_lex_state = 308},
  [22437] = {.lex_state = 0, .external_lex_state = 308},
  [22438] = {.lex_state = 0, .external_lex_state = 415},
  [22439] = {.lex_state = 0, .external_lex_state = 308},
  [22440] = {.lex_state = 0, .external_lex_state = 308},
  [22441] = {.lex_state = 0, .external_lex_state = 308},
  [22442] = {.lex_state = 0, .external_lex_state = 308},
  [22443] = {.lex_state = 0, .external_lex_state = 308},
  [22444] = {.lex_state = 0, .external_lex_state = 308},
  [22445] = {.lex_state = 0, .external_lex_state = 308},
  [22446] = {.lex_state = 0, .external_lex_state = 308},
  [22447] = {.lex_state = 0, .external_lex_state = 308},
  [22448] = {.lex_state = 0, .external_lex_state = 308},
  [22449] = {.lex_state = 0, .external_lex_state = 308},
  [22450] = {.lex_state = 0, .external_lex_state = 308},
  [22451] = {.lex_state = 0, .external_lex_state = 308},
  [22452] = {.lex_state = 0, .external_lex_state = 443},
  [22453] = {.lex_state = 0, .external_lex_state = 308},
  [22454] = {.lex_state = 0, .external_lex_state = 308},
  [22455] = {.lex_state = 0, .external_lex_state = 415},
  [22456] = {.lex_state = 0, .external_lex_state = 308},
  [22457] = {.lex_state = 0, .external_lex_state = 308},
  [22458] = {.lex_state = 0, .external_lex_state = 443},
  [22459] = {.lex_state = 0, .external_lex_state = 308},
  [22460] = {.lex_state = 0, .external_lex_state = 308},
  [22461] = {.lex_state = 0, .external_lex_state = 308},
  [22462] = {.lex_state = 0, .external_lex_state = 308},
  [22463] = {.lex_state = 0, .external_lex_state = 308},
  [22464] = {.lex_state = 0, .external_lex_state = 308},
  [22465] = {.lex_state = 0, .external_lex_state = 308},
  [22466] = {.lex_state = 0, .external_lex_state = 308},
  [22467] = {.lex_state = 0, .external_lex_state = 308},
  [22468] = {.lex_state = 0, .external_lex_state = 443},
  [22469] = {.lex_state = 0, .external_lex_state = 308},
  [22470] = {.lex_state = 0, .external_lex_state = 308},
  [22471] = {.lex_state = 0, .external_lex_state = 415},
  [22472] = {.lex_state = 55, .external_lex_state = 308},
  [22473] = {.lex_state = 0, .external_lex_state = 308},
  [22474] = {.lex_state = 0, .external_lex_state = 443},
  [22475] = {.lex_state = 0, .external_lex_state = 308},
  [22476] = {.lex_state = 0, .external_lex_state = 443},
  [22477] = {.lex_state = 0, .external_lex_state = 308},
  [22478] = {.lex_state = 0, .external_lex_state = 443},
  [22479] = {.lex_state = 0, .external_lex_state = 308},
  [22480] = {.lex_state = 0, .external_lex_state = 443},
  [22481] = {.lex_state = 55, .external_lex_state = 308},
  [22482] = {.lex_state = 0, .external_lex_state = 443},
  [22483] = {.lex_state = 0, .external_lex_state = 308},
  [22484] = {.lex_state = 0, .external_lex_state = 308},
  [22485] = {.lex_state = 0, .external_lex_state = 308},
  [22486] = {.lex_state = 0, .external_lex_state = 308},
  [22487] = {.lex_state = 0, .external_lex_state = 415},
  [22488] = {.lex_state = 0, .external_lex_state = 308},
  [22489] = {.lex_state = 0, .external_lex_state = 308},
  [22490] = {.lex_state = 0, .external_lex_state = 308},
  [22491] = {.lex_state = 0, .external_lex_state = 308},
  [22492] = {.lex_state = 0, .external_lex_state = 308},
  [22493] = {.lex_state = 0, .external_lex_state = 308},
  [22494] = {.lex_state = 0, .external_lex_state = 308},
  [22495] = {.lex_state = 55, .external_lex_state = 308},
  [22496] = {.lex_state = 0, .external_lex_state = 308},
  [22497] = {.lex_state = 0, .external_lex_state = 308},
  [22498] = {.lex_state = 55, .external_lex_state = 308},
  [22499] = {.lex_state = 55, .external_lex_state = 308},
  [22500] = {.lex_state = 0, .external_lex_state = 308},
  [22501] = {.lex_state = 0, .external_lex_state = 308},
  [22502] = {.lex_state = 0, .external_lex_state = 308},
  [22503] = {.lex_state = 0, .external_lex_state = 415},
  [22504] = {.lex_state = 0, .external_lex_state = 308},
  [22505] = {.lex_state = 0, .external_lex_state = 308},
  [22506] = {.lex_state = 0, .external_lex_state = 308},
  [22507] = {.lex_state = 0, .external_lex_state = 308},
  [22508] = {.lex_state = 0, .external_lex_state = 308},
  [22509] = {.lex_state = 0, .external_lex_state = 308},
  [22510] = {.lex_state = 0, .external_lex_state = 308},
  [22511] = {.lex_state = 0, .external_lex_state = 308},
  [22512] = {.lex_state = 0, .external_lex_state = 308},
  [22513] = {.lex_state = 0, .external_lex_state = 308},
  [22514] = {.lex_state = 0, .external_lex_state = 308},
  [22515] = {.lex_state = 0, .external_lex_state = 308},
  [22516] = {.lex_state = 0, .external_lex_state = 308},
  [22517] = {.lex_state = 0, .external_lex_state = 308},
  [22518] = {.lex_state = 0, .external_lex_state = 308},
  [22519] = {.lex_state = 0, .external_lex_state = 415},
  [22520] = {.lex_state = 0, .external_lex_state = 308},
  [22521] = {.lex_state = 0, .external_lex_state = 308},
  [22522] = {.lex_state = 0, .external_lex_state = 308},
  [22523] = {.lex_state = 0, .external_lex_state = 308},
  [22524] = {.lex_state = 0, .external_lex_state = 308},
  [22525] = {.lex_state = 0, .external_lex_state = 308},
  [22526] = {.lex_state = 0, .external_lex_state = 443},
  [22527] = {.lex_state = 0, .external_lex_state = 308},
  [22528] = {.lex_state = 0, .external_lex_state = 308},
  [22529] = {.lex_state = 0, .external_lex_state = 308},
  [22530] = {.lex_state = 0, .external_lex_state = 308},
  [22531] = {.lex_state = 0, .external_lex_state = 308},
  [22532] = {.lex_state = 0, .external_lex_state = 308},
  [22533] = {.lex_state = 0, .external_lex_state = 443},
  [22534] = {.lex_state = 0, .external_lex_state = 308},
  [22535] = {.lex_state = 0, .external_lex_state = 415},
  [22536] = {.lex_state = 0, .external_lex_state = 308},
  [22537] = {.lex_state = 0, .external_lex_state = 308},
  [22538] = {.lex_state = 0, .external_lex_state = 308},
  [22539] = {.lex_state = 0, .external_lex_state = 308},
  [22540] = {.lex_state = 0, .external_lex_state = 308},
  [22541] = {.lex_state = 0, .external_lex_state = 308},
  [22542] = {.lex_state = 0, .external_lex_state = 308},
  [22543] = {.lex_state = 0, .external_lex_state = 308},
  [22544] = {.lex_state = 0, .external_lex_state = 308},
  [22545] = {.lex_state = 0, .external_lex_state = 308},
  [22546] = {.lex_state = 0, .external_lex_state = 308},
  [22547] = {.lex_state = 0, .external_lex_state = 308},
  [22548] = {.lex_state = 0, .external_lex_state = 308},
  [22549] = {.lex_state = 0, .external_lex_state = 308},
  [22550] = {.lex_state = 0, .external_lex_state = 308},
  [22551] = {.lex_state = 0, .external_lex_state = 415},
  [22552] = {.lex_state = 0, .external_lex_state = 308},
  [22553] = {.lex_state = 0, .external_lex_state = 308},
  [22554] = {.lex_state = 0, .external_lex_state = 443},
  [22555] = {.lex_state = 0, .external_lex_state = 308},
  [22556] = {.lex_state = 0, .external_lex_state = 443},
  [22557] = {.lex_state = 0, .external_lex_state = 308},
  [22558] = {.lex_state = 0, .external_lex_state = 308},
  [22559] = {.lex_state = 0, .external_lex_state = 308},
  [22560] = {.lex_state = 0, .external_lex_state = 308},
  [22561] = {.lex_state = 0, .external_lex_state = 308},
  [22562] = {.lex_state = 0, .external_lex_state = 308},
  [22563] = {.lex_state = 0, .external_lex_state = 308},
  [22564] = {.lex_state = 0, .external_lex_state = 308},
  [22565] = {.lex_state = 0, .external_lex_state = 308},
  [22566] = {.lex_state = 0, .external_lex_state = 367},
  [22567] = {.lex_state = 0, .external_lex_state = 415},
  [22568] = {.lex_state = 0, .external_lex_state = 308},
  [22569] = {.lex_state = 0, .external_lex_state = 443},
  [22570] = {.lex_state = 0, .external_lex_state = 308},
  [22571] = {.lex_state = 0, .external_lex_state = 308},
  [22572] = {.lex_state = 0, .external_lex_state = 308},
  [22573] = {.lex_state = 0, .external_lex_state = 308},
  [22574] = {.lex_state = 0, .external_lex_state = 308},
  [22575] = {.lex_state = 0, .external_lex_state = 308},
  [22576] = {.lex_state = 0, .external_lex_state = 308},
  [22577] = {.lex_state = 0, .external_lex_state = 308},
  [22578] = {.lex_state = 0, .external_lex_state = 308},
  [22579] = {.lex_state = 0, .external_lex_state = 308},
  [22580] = {.lex_state = 57, .external_lex_state = 308},
  [22581] = {.lex_state = 0, .external_lex_state = 308},
  [22582] = {.lex_state = 0, .external_lex_state = 308},
  [22583] = {.lex_state = 0, .external_lex_state = 415},
  [22584] = {.lex_state = 0, .external_lex_state = 443},
  [22585] = {.lex_state = 0, .external_lex_state = 308},
  [22586] = {.lex_state = 55, .external_lex_state = 442},
  [22587] = {.lex_state = 0, .external_lex_state = 308},
  [22588] = {.lex_state = 0, .external_lex_state = 443},
  [22589] = {.lex_state = 0, .external_lex_state = 443},
  [22590] = {.lex_state = 0, .external_lex_state = 308},
  [22591] = {.lex_state = 55, .external_lex_state = 308},
  [22592] = {.lex_state = 0, .external_lex_state = 308},
  [22593] = {.lex_state = 0, .external_lex_state = 308},
  [22594] = {.lex_state = 0, .external_lex_state = 308},
  [22595] = {.lex_state = 0, .external_lex_state = 308},
  [22596] = {.lex_state = 0, .external_lex_state = 308},
  [22597] = {.lex_state = 0, .external_lex_state = 308},
  [22598] = {.lex_state = 0, .external_lex_state = 443},
  [22599] = {.lex_state = 0, .external_lex_state = 415},
  [22600] = {.lex_state = 0, .external_lex_state = 308},
  [22601] = {.lex_state = 0, .external_lex_state = 308},
  [22602] = {.lex_state = 0, .external_lex_state = 308},
  [22603] = {.lex_state = 55, .external_lex_state = 308},
  [22604] = {.lex_state = 0, .external_lex_state = 333},
  [22605] = {.lex_state = 55, .external_lex_state = 308},
  [22606] = {.lex_state = 0, .external_lex_state = 308},
  [22607] = {.lex_state = 0, .external_lex_state = 308},
  [22608] = {.lex_state = 0, .external_lex_state = 308},
  [22609] = {.lex_state = 0, .external_lex_state = 308},
  [22610] = {.lex_state = 0, .external_lex_state = 308},
  [22611] = {.lex_state = 0, .external_lex_state = 308},
  [22612] = {.lex_state = 0, .external_lex_state = 308},
  [22613] = {.lex_state = 0, .external_lex_state = 308},
  [22614] = {.lex_state = 0, .external_lex_state = 415},
  [22615] = {.lex_state = 0, .external_lex_state = 308},
  [22616] = {.lex_state = 55, .external_lex_state = 308},
  [22617] = {.lex_state = 0, .external_lex_state = 308},
  [22618] = {.lex_state = 0, .external_lex_state = 308},
  [22619] = {.lex_state = 0, .external_lex_state = 308},
  [22620] = {.lex_state = 0, .external_lex_state = 308},
  [22621] = {.lex_state = 0, .external_lex_state = 308},
  [22622] = {.lex_state = 55, .external_lex_state = 308},
  [22623] = {.lex_state = 55, .external_lex_state = 308},
  [22624] = {.lex_state = 0, .external_lex_state = 308},
  [22625] = {.lex_state = 0, .external_lex_state = 308},
  [22626] = {.lex_state = 0, .external_lex_state = 308},
  [22627] = {.lex_state = 0, .external_lex_state = 415},
  [22628] = {.lex_state = 0, .external_lex_state = 308},
  [22629] = {.lex_state = 0, .external_lex_state = 308},
  [22630] = {.lex_state = 0, .external_lex_state = 308},
  [22631] = {.lex_state = 0, .external_lex_state = 308},
  [22632] = {.lex_state = 0, .external_lex_state = 308},
  [22633] = {.lex_state = 55, .external_lex_state = 442},
  [22634] = {.lex_state = 0, .external_lex_state = 308},
  [22635] = {.lex_state = 0, .external_lex_state = 308},
  [22636] = {.lex_state = 0, .external_lex_state = 308},
  [22637] = {.lex_state = 0, .external_lex_state = 308},
  [22638] = {.lex_state = 0, .external_lex_state = 443},
  [22639] = {.lex_state = 0, .external_lex_state = 443},
  [22640] = {.lex_state = 0, .external_lex_state = 415},
  [22641] = {.lex_state = 0, .external_lex_state = 308},
  [22642] = {.lex_state = 0, .external_lex_state = 308},
  [22643] = {.lex_state = 0, .external_lex_state = 308},
  [22644] = {.lex_state = 0, .external_lex_state = 443},
  [22645] = {.lex_state = 0, .external_lex_state = 308},
  [22646] = {.lex_state = 0, .external_lex_state = 308},
  [22647] = {.lex_state = 0, .external_lex_state = 308},
  [22648] = {.lex_state = 0, .external_lex_state = 308},
  [22649] = {.lex_state = 0, .external_lex_state = 308},
  [22650] = {.lex_state = 0, .external_lex_state = 308},
  [22651] = {.lex_state = 0, .external_lex_state = 308},
  [22652] = {.lex_state = 0, .external_lex_state = 308},
  [22653] = {.lex_state = 0, .external_lex_state = 415},
  [22654] = {.lex_state = 0, .external_lex_state = 308},
  [22655] = {.lex_state = 0, .external_lex_state = 308},
  [22656] = {.lex_state = 0, .external_lex_state = 308},
  [22657] = {.lex_state = 0, .external_lex_state = 308},
  [22658] = {.lex_state = 0, .external_lex_state = 308},
  [22659] = {.lex_state = 0, .external_lex_state = 308},
  [22660] = {.lex_state = 0, .external_lex_state = 308},
  [22661] = {.lex_state = 0, .external_lex_state = 308},
  [22662] = {.lex_state = 0, .external_lex_state = 308},
  [22663] = {.lex_state = 0, .external_lex_state = 308},
  [22664] = {.lex_state = 0, .external_lex_state = 308},
  [22665] = {.lex_state = 0, .external_lex_state = 308},
  [22666] = {.lex_state = 0, .external_lex_state = 415},
  [22667] = {.lex_state = 0, .external_lex_state = 308},
  [22668] = {.lex_state = 0, .external_lex_state = 308},
  [22669] = {.lex_state = 0, .external_lex_state = 308},
  [22670] = {.lex_state = 0, .external_lex_state = 308},
  [22671] = {.lex_state = 0, .external_lex_state = 308},
  [22672] = {.lex_state = 0, .external_lex_state = 308},
  [22673] = {.lex_state = 0, .external_lex_state = 443},
  [22674] = {.lex_state = 0, .external_lex_state = 308},
  [22675] = {.lex_state = 0, .external_lex_state = 308},
  [22676] = {.lex_state = 0, .external_lex_state = 308},
  [22677] = {.lex_state = 0, .external_lex_state = 308},
  [22678] = {.lex_state = 0, .external_lex_state = 308},
  [22679] = {.lex_state = 0, .external_lex_state = 415},
  [22680] = {.lex_state = 0, .external_lex_state = 308},
  [22681] = {.lex_state = 0, .external_lex_state = 308},
  [22682] = {.lex_state = 0, .external_lex_state = 308},
  [22683] = {.lex_state = 0, .external_lex_state = 308},
  [22684] = {.lex_state = 0, .external_lex_state = 308},
  [22685] = {.lex_state = 0, .external_lex_state = 308},
  [22686] = {.lex_state = 0, .external_lex_state = 443},
  [22687] = {.lex_state = 0, .external_lex_state = 308},
  [22688] = {.lex_state = 0, .external_lex_state = 443},
  [22689] = {.lex_state = 0, .external_lex_state = 308},
  [22690] = {.lex_state = 0, .external_lex_state = 308},
  [22691] = {.lex_state = 0, .external_lex_state = 308},
  [22692] = {.lex_state = 0, .external_lex_state = 415},
  [22693] = {.lex_state = 0, .external_lex_state = 308},
  [22694] = {.lex_state = 0, .external_lex_state = 308},
  [22695] = {.lex_state = 0, .external_lex_state = 308},
  [22696] = {.lex_state = 0, .external_lex_state = 308},
  [22697] = {.lex_state = 0, .external_lex_state = 308},
  [22698] = {.lex_state = 0, .external_lex_state = 443},
  [22699] = {.lex_state = 0, .external_lex_state = 308},
  [22700] = {.lex_state = 0, .external_lex_state = 308},
  [22701] = {.lex_state = 0, .external_lex_state = 308},
  [22702] = {.lex_state = 0, .external_lex_state = 308},
  [22703] = {.lex_state = 0, .external_lex_state = 308},
  [22704] = {.lex_state = 0, .external_lex_state = 308},
  [22705] = {.lex_state = 0, .external_lex_state = 415},
  [22706] = {.lex_state = 0, .external_lex_state = 308},
  [22707] = {.lex_state = 0, .external_lex_state = 308},
  [22708] = {.lex_state = 0, .external_lex_state = 308},
  [22709] = {.lex_state = 0, .external_lex_state = 443},
  [22710] = {.lex_state = 0, .external_lex_state = 443},
  [22711] = {.lex_state = 55, .external_lex_state = 308},
  [22712] = {.lex_state = 55, .external_lex_state = 308},
  [22713] = {.lex_state = 0, .external_lex_state = 443},
  [22714] = {.lex_state = 0, .external_lex_state = 443},
  [22715] = {.lex_state = 0, .external_lex_state = 308},
  [22716] = {.lex_state = 0, .external_lex_state = 443},
  [22717] = {.lex_state = 0, .external_lex_state = 308},
  [22718] = {.lex_state = 0, .external_lex_state = 415},
  [22719] = {.lex_state = 0, .external_lex_state = 308},
  [22720] = {.lex_state = 0, .external_lex_state = 308},
  [22721] = {.lex_state = 0, .external_lex_state = 443},
  [22722] = {.lex_state = 0, .external_lex_state = 308},
  [22723] = {.lex_state = 0, .external_lex_state = 333},
  [22724] = {.lex_state = 0, .external_lex_state = 308},
  [22725] = {.lex_state = 0, .external_lex_state = 308},
  [22726] = {.lex_state = 0, .external_lex_state = 308},
  [22727] = {.lex_state = 0, .external_lex_state = 308},
  [22728] = {.lex_state = 0, .external_lex_state = 443},
  [22729] = {.lex_state = 0, .external_lex_state = 308},
  [22730] = {.lex_state = 0, .external_lex_state = 308},
  [22731] = {.lex_state = 0, .external_lex_state = 415},
  [22732] = {.lex_state = 0, .external_lex_state = 308},
  [22733] = {.lex_state = 0, .external_lex_state = 308},
  [22734] = {.lex_state = 0, .external_lex_state = 308},
  [22735] = {.lex_state = 55, .external_lex_state = 308},
  [22736] = {.lex_state = 0, .external_lex_state = 308},
  [22737] = {.lex_state = 0, .external_lex_state = 308},
  [22738] = {.lex_state = 0, .external_lex_state = 308},
  [22739] = {.lex_state = 0, .external_lex_state = 308},
  [22740] = {.lex_state = 0, .external_lex_state = 308},
  [22741] = {.lex_state = 0, .external_lex_state = 308},
  [22742] = {.lex_state = 0, .external_lex_state = 308},
  [22743] = {.lex_state = 55, .external_lex_state = 308},
  [22744] = {.lex_state = 0, .external_lex_state = 415},
  [22745] = {.lex_state = 0, .external_lex_state = 308},
  [22746] = {.lex_state = 0, .external_lex_state = 308},
  [22747] = {.lex_state = 0, .external_lex_state = 308},
  [22748] = {.lex_state = 0, .external_lex_state = 308},
  [22749] = {.lex_state = 0, .external_lex_state = 308},
  [22750] = {.lex_state = 0, .external_lex_state = 308},
  [22751] = {.lex_state = 0, .external_lex_state = 308},
  [22752] = {.lex_state = 0, .external_lex_state = 308},
  [22753] = {.lex_state = 0, .external_lex_state = 308},
  [22754] = {.lex_state = 0, .external_lex_state = 308},
  [22755] = {.lex_state = 0, .external_lex_state = 308},
  [22756] = {.lex_state = 0, .external_lex_state = 443},
  [22757] = {.lex_state = 0, .external_lex_state = 415},
  [22758] = {.lex_state = 0, .external_lex_state = 308},
  [22759] = {.lex_state = 0, .external_lex_state = 308},
  [22760] = {.lex_state = 0, .external_lex_state = 308},
  [22761] = {.lex_state = 0, .external_lex_state = 308},
  [22762] = {.lex_state = 0, .external_lex_state = 308},
  [22763] = {.lex_state = 0, .external_lex_state = 308},
  [22764] = {.lex_state = 0, .external_lex_state = 308},
  [22765] = {.lex_state = 0, .external_lex_state = 308},
  [22766] = {.lex_state = 0, .external_lex_state = 308},
  [22767] = {.lex_state = 0, .external_lex_state = 308},
  [22768] = {.lex_state = 0, .external_lex_state = 308},
  [22769] = {.lex_state = 0, .external_lex_state = 308},
  [22770] = {.lex_state = 0, .external_lex_state = 415},
  [22771] = {.lex_state = 0, .external_lex_state = 443},
  [22772] = {.lex_state = 0, .external_lex_state = 308},
  [22773] = {.lex_state = 0, .external_lex_state = 308},
  [22774] = {.lex_state = 0, .external_lex_state = 308},
  [22775] = {.lex_state = 0, .external_lex_state = 308},
  [22776] = {.lex_state = 0, .external_lex_state = 308},
  [22777] = {.lex_state = 0, .external_lex_state = 308},
  [22778] = {.lex_state = 0, .external_lex_state = 443},
  [22779] = {.lex_state = 0, .external_lex_state = 308},
  [22780] = {.lex_state = 0, .external_lex_state = 308},
  [22781] = {.lex_state = 0, .external_lex_state = 308},
  [22782] = {.lex_state = 0, .external_lex_state = 308},
  [22783] = {.lex_state = 0, .external_lex_state = 415},
  [22784] = {.lex_state = 0, .external_lex_state = 443},
  [22785] = {.lex_state = 0, .external_lex_state = 308},
  [22786] = {.lex_state = 0, .external_lex_state = 308},
  [22787] = {.lex_state = 0, .external_lex_state = 308},
  [22788] = {.lex_state = 0, .external_lex_state = 308},
  [22789] = {.lex_state = 0, .external_lex_state = 308},
  [22790] = {.lex_state = 0, .external_lex_state = 308},
  [22791] = {.lex_state = 0, .external_lex_state = 308},
  [22792] = {.lex_state = 0, .external_lex_state = 308},
  [22793] = {.lex_state = 0, .external_lex_state = 308},
  [22794] = {.lex_state = 0, .external_lex_state = 308},
  [22795] = {.lex_state = 0, .external_lex_state = 308},
  [22796] = {.lex_state = 0, .external_lex_state = 415},
  [22797] = {.lex_state = 0, .external_lex_state = 308},
  [22798] = {.lex_state = 0, .external_lex_state = 308},
  [22799] = {.lex_state = 0, .external_lex_state = 308},
  [22800] = {.lex_state = 0, .external_lex_state = 308},
  [22801] = {.lex_state = 0, .external_lex_state = 308},
  [22802] = {.lex_state = 0, .external_lex_state = 308},
  [22803] = {.lex_state = 0, .external_lex_state = 443},
  [22804] = {.lex_state = 0, .external_lex_state = 308},
  [22805] = {.lex_state = 0, .external_lex_state = 308},
  [22806] = {.lex_state = 0, .external_lex_state = 308},
  [22807] = {.lex_state = 0, .external_lex_state = 308},
  [22808] = {.lex_state = 0, .external_lex_state = 308},
  [22809] = {.lex_state = 0, .external_lex_state = 415},
  [22810] = {.lex_state = 0, .external_lex_state = 308},
  [22811] = {.lex_state = 0, .external_lex_state = 308},
  [22812] = {.lex_state = 0, .external_lex_state = 308},
  [22813] = {.lex_state = 0, .external_lex_state = 308},
  [22814] = {.lex_state = 0, .external_lex_state = 308},
  [22815] = {.lex_state = 0, .external_lex_state = 308},
  [22816] = {.lex_state = 0, .external_lex_state = 308},
  [22817] = {.lex_state = 0, .external_lex_state = 443},
  [22818] = {.lex_state = 0, .external_lex_state = 308},
  [22819] = {.lex_state = 0, .external_lex_state = 308},
  [22820] = {.lex_state = 0, .external_lex_state = 308},
  [22821] = {.lex_state = 0, .external_lex_state = 308},
  [22822] = {.lex_state = 0, .external_lex_state = 415},
  [22823] = {.lex_state = 0, .external_lex_state = 308},
  [22824] = {.lex_state = 0, .external_lex_state = 308},
  [22825] = {.lex_state = 0, .external_lex_state = 308},
  [22826] = {.lex_state = 0, .external_lex_state = 308},
  [22827] = {.lex_state = 0, .external_lex_state = 308},
  [22828] = {.lex_state = 0, .external_lex_state = 308},
  [22829] = {.lex_state = 0, .external_lex_state = 308},
  [22830] = {.lex_state = 0, .external_lex_state = 308},
  [22831] = {.lex_state = 0, .external_lex_state = 308},
  [22832] = {.lex_state = 0, .external_lex_state = 308},
  [22833] = {.lex_state = 0, .external_lex_state = 308},
  [22834] = {.lex_state = 0, .external_lex_state = 308},
  [22835] = {.lex_state = 0, .external_lex_state = 415},
  [22836] = {.lex_state = 0, .external_lex_state = 308},
  [22837] = {.lex_state = 0, .external_lex_state = 443},
  [22838] = {.lex_state = 0, .external_lex_state = 308},
  [22839] = {.lex_state = 0, .external_lex_state = 443},
  [22840] = {.lex_state = 0, .external_lex_state = 443},
  [22841] = {.lex_state = 0, .external_lex_state = 308},
  [22842] = {.lex_state = 0, .external_lex_state = 308},
  [22843] = {.lex_state = 0, .external_lex_state = 308},
  [22844] = {.lex_state = 55, .external_lex_state = 308},
  [22845] = {.lex_state = 0, .external_lex_state = 308},
  [22846] = {.lex_state = 0, .external_lex_state = 443},
  [22847] = {.lex_state = 0, .external_lex_state = 308},
  [22848] = {.lex_state = 0, .external_lex_state = 415},
  [22849] = {.lex_state = 0, .external_lex_state = 308},
  [22850] = {.lex_state = 0, .external_lex_state = 308},
  [22851] = {.lex_state = 0, .external_lex_state = 308},
  [22852] = {.lex_state = 0, .external_lex_state = 308},
  [22853] = {.lex_state = 0, .external_lex_state = 308},
  [22854] = {.lex_state = 0, .external_lex_state = 308},
  [22855] = {.lex_state = 0, .external_lex_state = 308},
  [22856] = {.lex_state = 0, .external_lex_state = 308},
  [22857] = {.lex_state = 0, .external_lex_state = 308},
  [22858] = {.lex_state = 0, .external_lex_state = 308},
  [22859] = {.lex_state = 0, .external_lex_state = 308},
  [22860] = {.lex_state = 0, .external_lex_state = 308},
  [22861] = {.lex_state = 0, .external_lex_state = 415},
  [22862] = {.lex_state = 0, .external_lex_state = 308},
  [22863] = {.lex_state = 0, .external_lex_state = 333},
  [22864] = {.lex_state = 0, .external_lex_state = 308},
  [22865] = {.lex_state = 0, .external_lex_state = 308},
  [22866] = {.lex_state = 0, .external_lex_state = 443},
  [22867] = {.lex_state = 0, .external_lex_state = 308},
  [22868] = {.lex_state = 0, .external_lex_state = 308},
  [22869] = {.lex_state = 0, .external_lex_state = 308},
  [22870] = {.lex_state = 0, .external_lex_state = 308},
  [22871] = {.lex_state = 0, .external_lex_state = 308},
  [22872] = {.lex_state = 0, .external_lex_state = 308},
  [22873] = {.lex_state = 0, .external_lex_state = 308},
  [22874] = {.lex_state = 0, .external_lex_state = 415},
  [22875] = {.lex_state = 0, .external_lex_state = 308},
  [22876] = {.lex_state = 0, .external_lex_state = 308},
  [22877] = {.lex_state = 0, .external_lex_state = 308},
  [22878] = {.lex_state = 0, .external_lex_state = 308},
  [22879] = {.lex_state = 0, .external_lex_state = 308},
  [22880] = {.lex_state = 0, .external_lex_state = 308},
  [22881] = {.lex_state = 0, .external_lex_state = 308},
  [22882] = {.lex_state = 0, .external_lex_state = 308},
  [22883] = {.lex_state = 0, .external_lex_state = 308},
  [22884] = {.lex_state = 0, .external_lex_state = 308},
  [22885] = {.lex_state = 0, .external_lex_state = 443},
  [22886] = {.lex_state = 0, .external_lex_state = 308},
  [22887] = {.lex_state = 0, .external_lex_state = 415},
  [22888] = {.lex_state = 0, .external_lex_state = 308},
  [22889] = {.lex_state = 0, .external_lex_state = 308},
  [22890] = {.lex_state = 0, .external_lex_state = 308},
  [22891] = {.lex_state = 0, .external_lex_state = 308},
  [22892] = {.lex_state = 0, .external_lex_state = 308},
  [22893] = {.lex_state = 0, .external_lex_state = 308},
  [22894] = {.lex_state = 55, .external_lex_state = 308},
  [22895] = {.lex_state = 0, .external_lex_state = 308},
  [22896] = {.lex_state = 0, .external_lex_state = 308},
  [22897] = {.lex_state = 0, .external_lex_state = 308},
  [22898] = {.lex_state = 0, .external_lex_state = 308},
  [22899] = {.lex_state = 0, .external_lex_state = 308},
  [22900] = {.lex_state = 0, .external_lex_state = 415},
  [22901] = {.lex_state = 0, .external_lex_state = 308},
  [22902] = {.lex_state = 0, .external_lex_state = 308},
  [22903] = {.lex_state = 0, .external_lex_state = 308},
  [22904] = {.lex_state = 0, .external_lex_state = 308},
  [22905] = {.lex_state = 0, .external_lex_state = 308},
  [22906] = {.lex_state = 0, .external_lex_state = 308},
  [22907] = {.lex_state = 0, .external_lex_state = 443},
  [22908] = {.lex_state = 0, .external_lex_state = 308},
  [22909] = {.lex_state = 0, .external_lex_state = 308},
  [22910] = {.lex_state = 55, .external_lex_state = 308},
  [22911] = {.lex_state = 0, .external_lex_state = 415},
  [22912] = {.lex_state = 0, .external_lex_state = 308},
  [22913] = {.lex_state = 0, .external_lex_state = 308},
  [22914] = {.lex_state = 0, .external_lex_state = 415},
  [22915] = {.lex_state = 0, .external_lex_state = 308},
  [22916] = {.lex_state = 0, .external_lex_state = 308},
  [22917] = {.lex_state = 0, .external_lex_state = 415},
  [22918] = {.lex_state = 0, .external_lex_state = 308},
  [22919] = {.lex_state = 0, .external_lex_state = 308},
  [22920] = {.lex_state = 0, .external_lex_state = 415},
  [22921] = {.lex_state = 0, .external_lex_state = 308},
  [22922] = {.lex_state = 0, .external_lex_state = 308},
  [22923] = {.lex_state = 0, .external_lex_state = 415},
  [22924] = {.lex_state = 0, .external_lex_state = 308},
  [22925] = {.lex_state = 0, .external_lex_state = 308},
  [22926] = {.lex_state = 0, .external_lex_state = 415},
  [22927] = {.lex_state = 0, .external_lex_state = 443},
  [22928] = {.lex_state = 0, .external_lex_state = 308},
  [22929] = {.lex_state = 0, .external_lex_state = 415},
  [22930] = {.lex_state = 0, .external_lex_state = 308},
  [22931] = {.lex_state = 0, .external_lex_state = 308},
  [22932] = {.lex_state = 0, .external_lex_state = 415},
  [22933] = {.lex_state = 0, .external_lex_state = 308},
  [22934] = {.lex_state = 0, .external_lex_state = 308},
  [22935] = {.lex_state = 0, .external_lex_state = 415},
  [22936] = {.lex_state = 0, .external_lex_state = 308},
  [22937] = {.lex_state = 0, .external_lex_state = 308},
  [22938] = {.lex_state = 0, .external_lex_state = 415},
  [22939] = {.lex_state = 0, .external_lex_state = 308},
  [22940] = {.lex_state = 0, .external_lex_state = 308},
  [22941] = {.lex_state = 0, .external_lex_state = 415},
  [22942] = {.lex_state = 0, .external_lex_state = 308},
  [22943] = {.lex_state = 0, .external_lex_state = 308},
  [22944] = {.lex_state = 0, .external_lex_state = 415},
  [22945] = {.lex_state = 0, .external_lex_state = 308},
  [22946] = {.lex_state = 0, .external_lex_state = 308},
  [22947] = {.lex_state = 0, .external_lex_state = 415},
  [22948] = {.lex_state = 0, .external_lex_state = 308},
  [22949] = {.lex_state = 0, .external_lex_state = 308},
  [22950] = {.lex_state = 0, .external_lex_state = 415},
  [22951] = {.lex_state = 0, .external_lex_state = 308},
  [22952] = {.lex_state = 0, .external_lex_state = 308},
  [22953] = {.lex_state = 0, .external_lex_state = 415},
  [22954] = {.lex_state = 0, .external_lex_state = 308},
  [22955] = {.lex_state = 0, .external_lex_state = 443},
  [22956] = {.lex_state = 0, .external_lex_state = 415},
  [22957] = {.lex_state = 0, .external_lex_state = 308},
  [22958] = {.lex_state = 0, .external_lex_state = 308},
  [22959] = {.lex_state = 0, .external_lex_state = 415},
  [22960] = {.lex_state = 0, .external_lex_state = 443},
  [22961] = {.lex_state = 0, .external_lex_state = 308},
  [22962] = {.lex_state = 0, .external_lex_state = 415},
  [22963] = {.lex_state = 0, .external_lex_state = 308},
  [22964] = {.lex_state = 0, .external_lex_state = 308},
  [22965] = {.lex_state = 0, .external_lex_state = 415},
  [22966] = {.lex_state = 0, .external_lex_state = 443},
  [22967] = {.lex_state = 0, .external_lex_state = 443},
  [22968] = {.lex_state = 0, .external_lex_state = 415},
  [22969] = {.lex_state = 0, .external_lex_state = 308},
  [22970] = {.lex_state = 0, .external_lex_state = 443},
  [22971] = {.lex_state = 0, .external_lex_state = 415},
  [22972] = {.lex_state = 55, .external_lex_state = 308},
  [22973] = {.lex_state = 0, .external_lex_state = 308},
  [22974] = {.lex_state = 0, .external_lex_state = 415},
  [22975] = {.lex_state = 0, .external_lex_state = 308},
  [22976] = {.lex_state = 0, .external_lex_state = 443},
  [22977] = {.lex_state = 0, .external_lex_state = 415},
  [22978] = {.lex_state = 0, .external_lex_state = 308},
  [22979] = {.lex_state = 0, .external_lex_state = 308},
  [22980] = {.lex_state = 0, .external_lex_state = 415},
  [22981] = {.lex_state = 0, .external_lex_state = 308},
  [22982] = {.lex_state = 0, .external_lex_state = 443},
  [22983] = {.lex_state = 0, .external_lex_state = 415},
  [22984] = {.lex_state = 0, .external_lex_state = 308},
  [22985] = {.lex_state = 0, .external_lex_state = 308},
  [22986] = {.lex_state = 0, .external_lex_state = 415},
  [22987] = {.lex_state = 0, .external_lex_state = 308},
  [22988] = {.lex_state = 0, .external_lex_state = 308},
  [22989] = {.lex_state = 0, .external_lex_state = 415},
  [22990] = {.lex_state = 0, .external_lex_state = 308},
  [22991] = {.lex_state = 0, .external_lex_state = 308},
  [22992] = {.lex_state = 0, .external_lex_state = 415},
  [22993] = {.lex_state = 0, .external_lex_state = 308},
  [22994] = {.lex_state = 0, .external_lex_state = 443},
  [22995] = {.lex_state = 0, .external_lex_state = 415},
  [22996] = {.lex_state = 0, .external_lex_state = 308},
  [22997] = {.lex_state = 0, .external_lex_state = 308},
  [22998] = {.lex_state = 0, .external_lex_state = 415},
  [22999] = {.lex_state = 0, .external_lex_state = 308},
  [23000] = {.lex_state = 0, .external_lex_state = 308},
  [23001] = {.lex_state = 0, .external_lex_state = 415},
  [23002] = {.lex_state = 0, .external_lex_state = 308},
  [23003] = {.lex_state = 0, .external_lex_state = 308},
  [23004] = {.lex_state = 0, .external_lex_state = 415},
  [23005] = {.lex_state = 0, .external_lex_state = 443},
  [23006] = {.lex_state = 0, .external_lex_state = 308},
  [23007] = {.lex_state = 0, .external_lex_state = 415},
  [23008] = {.lex_state = 0, .external_lex_state = 308},
  [23009] = {.lex_state = 0, .external_lex_state = 308},
  [23010] = {.lex_state = 0, .external_lex_state = 415},
  [23011] = {.lex_state = 0, .external_lex_state = 308},
  [23012] = {.lex_state = 0, .external_lex_state = 308},
  [23013] = {.lex_state = 0, .external_lex_state = 415},
  [23014] = {.lex_state = 0, .external_lex_state = 308},
  [23015] = {.lex_state = 0, .external_lex_state = 443},
  [23016] = {.lex_state = 0, .external_lex_state = 415},
  [23017] = {.lex_state = 0, .external_lex_state = 308},
  [23018] = {.lex_state = 0, .external_lex_state = 308},
  [23019] = {.lex_state = 0, .external_lex_state = 415},
  [23020] = {.lex_state = 0, .external_lex_state = 308},
  [23021] = {.lex_state = 0, .external_lex_state = 308},
  [23022] = {.lex_state = 0, .external_lex_state = 415},
  [23023] = {.lex_state = 0, .external_lex_state = 308},
  [23024] = {.lex_state = 0, .external_lex_state = 308},
  [23025] = {.lex_state = 0, .external_lex_state = 415},
  [23026] = {.lex_state = 0, .external_lex_state = 308},
  [23027] = {.lex_state = 0, .external_lex_state = 308},
  [23028] = {.lex_state = 0, .external_lex_state = 415},
  [23029] = {.lex_state = 0, .external_lex_state = 443},
  [23030] = {.lex_state = 0, .external_lex_state = 308},
  [23031] = {.lex_state = 0, .external_lex_state = 415},
  [23032] = {.lex_state = 0, .external_lex_state = 443},
  [23033] = {.lex_state = 0, .external_lex_state = 308},
  [23034] = {.lex_state = 0, .external_lex_state = 415},
  [23035] = {.lex_state = 0, .external_lex_state = 308},
  [23036] = {.lex_state = 55, .external_lex_state = 308},
  [23037] = {.lex_state = 0, .external_lex_state = 415},
  [23038] = {.lex_state = 0, .external_lex_state = 308},
  [23039] = {.lex_state = 0, .external_lex_state = 308},
  [23040] = {.lex_state = 0, .external_lex_state = 415},
  [23041] = {.lex_state = 0, .external_lex_state = 308},
  [23042] = {.lex_state = 0, .external_lex_state = 308},
  [23043] = {.lex_state = 0, .external_lex_state = 415},
  [23044] = {.lex_state = 0, .external_lex_state = 308},
  [23045] = {.lex_state = 0, .external_lex_state = 308},
  [23046] = {.lex_state = 0, .external_lex_state = 415},
  [23047] = {.lex_state = 0, .external_lex_state = 308},
  [23048] = {.lex_state = 0, .external_lex_state = 308},
  [23049] = {.lex_state = 0, .external_lex_state = 415},
  [23050] = {.lex_state = 0, .external_lex_state = 308},
  [23051] = {.lex_state = 0, .external_lex_state = 308},
  [23052] = {.lex_state = 0, .external_lex_state = 415},
  [23053] = {.lex_state = 0, .external_lex_state = 333},
  [23054] = {.lex_state = 0, .external_lex_state = 308},
  [23055] = {.lex_state = 0, .external_lex_state = 415},
  [23056] = {.lex_state = 0, .external_lex_state = 308},
  [23057] = {.lex_state = 0, .external_lex_state = 308},
  [23058] = {.lex_state = 0, .external_lex_state = 415},
  [23059] = {.lex_state = 0, .external_lex_state = 308},
  [23060] = {.lex_state = 0, .external_lex_state = 308},
  [23061] = {.lex_state = 0, .external_lex_state = 415},
  [23062] = {.lex_state = 0, .external_lex_state = 308},
  [23063] = {.lex_state = 0, .external_lex_state = 308},
  [23064] = {.lex_state = 0, .external_lex_state = 415},
  [23065] = {.lex_state = 0, .external_lex_state = 308},
  [23066] = {.lex_state = 0, .external_lex_state = 308},
  [23067] = {.lex_state = 0, .external_lex_state = 415},
  [23068] = {.lex_state = 0, .external_lex_state = 308},
  [23069] = {.lex_state = 0, .external_lex_state = 308},
  [23070] = {.lex_state = 0, .external_lex_state = 415},
  [23071] = {.lex_state = 0, .external_lex_state = 308},
  [23072] = {.lex_state = 0, .external_lex_state = 308},
  [23073] = {.lex_state = 0, .external_lex_state = 415},
  [23074] = {.lex_state = 0, .external_lex_state = 308},
  [23075] = {.lex_state = 0, .external_lex_state = 308},
  [23076] = {.lex_state = 0, .external_lex_state = 415},
  [23077] = {.lex_state = 0, .external_lex_state = 308},
  [23078] = {.lex_state = 55, .external_lex_state = 308},
  [23079] = {.lex_state = 0, .external_lex_state = 415},
  [23080] = {.lex_state = 0, .external_lex_state = 308},
  [23081] = {.lex_state = 0, .external_lex_state = 308},
  [23082] = {.lex_state = 0, .external_lex_state = 415},
  [23083] = {.lex_state = 0, .external_lex_state = 308},
  [23084] = {.lex_state = 0, .external_lex_state = 443},
  [23085] = {.lex_state = 0, .external_lex_state = 415},
  [23086] = {.lex_state = 0, .external_lex_state = 308},
  [23087] = {.lex_state = 0, .external_lex_state = 308},
  [23088] = {.lex_state = 0, .external_lex_state = 415},
  [23089] = {.lex_state = 0, .external_lex_state = 443},
  [23090] = {.lex_state = 55, .external_lex_state = 442},
  [23091] = {.lex_state = 0, .external_lex_state = 415},
  [23092] = {.lex_state = 0, .external_lex_state = 308},
  [23093] = {.lex_state = 0, .external_lex_state = 308},
  [23094] = {.lex_state = 0, .external_lex_state = 415},
  [23095] = {.lex_state = 0, .external_lex_state = 443},
  [23096] = {.lex_state = 0, .external_lex_state = 308},
  [23097] = {.lex_state = 0, .external_lex_state = 415},
  [23098] = {.lex_state = 55, .external_lex_state = 308},
  [23099] = {.lex_state = 0, .external_lex_state = 308},
  [23100] = {.lex_state = 0, .external_lex_state = 415},
  [23101] = {.lex_state = 0, .external_lex_state = 308},
  [23102] = {.lex_state = 0, .external_lex_state = 308},
  [23103] = {.lex_state = 0, .external_lex_state = 415},
  [23104] = {.lex_state = 0, .external_lex_state = 308},
  [23105] = {.lex_state = 0, .external_lex_state = 308},
  [23106] = {.lex_state = 0, .external_lex_state = 415},
  [23107] = {.lex_state = 0, .external_lex_state = 308},
  [23108] = {.lex_state = 0, .external_lex_state = 308},
  [23109] = {.lex_state = 0, .external_lex_state = 415},
  [23110] = {.lex_state = 0, .external_lex_state = 308},
  [23111] = {.lex_state = 0, .external_lex_state = 308},
  [23112] = {.lex_state = 0, .external_lex_state = 415},
  [23113] = {.lex_state = 0, .external_lex_state = 308},
  [23114] = {.lex_state = 0, .external_lex_state = 308},
  [23115] = {.lex_state = 0, .external_lex_state = 415},
  [23116] = {.lex_state = 0, .external_lex_state = 308},
  [23117] = {.lex_state = 0, .external_lex_state = 308},
  [23118] = {.lex_state = 0, .external_lex_state = 415},
  [23119] = {.lex_state = 55, .external_lex_state = 308},
  [23120] = {.lex_state = 0, .external_lex_state = 308},
  [23121] = {.lex_state = 0, .external_lex_state = 415},
  [23122] = {.lex_state = 0, .external_lex_state = 308},
  [23123] = {.lex_state = 0, .external_lex_state = 308},
  [23124] = {.lex_state = 0, .external_lex_state = 415},
  [23125] = {.lex_state = 0, .external_lex_state = 308},
  [23126] = {.lex_state = 0, .external_lex_state = 308},
  [23127] = {.lex_state = 0, .external_lex_state = 415},
  [23128] = {.lex_state = 0, .external_lex_state = 308},
  [23129] = {.lex_state = 0, .external_lex_state = 308},
  [23130] = {.lex_state = 0, .external_lex_state = 415},
  [23131] = {.lex_state = 0, .external_lex_state = 308},
  [23132] = {.lex_state = 0, .external_lex_state = 308},
  [23133] = {.lex_state = 0, .external_lex_state = 415},
  [23134] = {.lex_state = 0, .external_lex_state = 308},
  [23135] = {.lex_state = 0, .external_lex_state = 308},
  [23136] = {.lex_state = 0, .external_lex_state = 415},
  [23137] = {.lex_state = 0, .external_lex_state = 443},
  [23138] = {.lex_state = 0, .external_lex_state = 308},
  [23139] = {.lex_state = 0, .external_lex_state = 415},
  [23140] = {.lex_state = 0, .external_lex_state = 308},
  [23141] = {.lex_state = 0, .external_lex_state = 308},
  [23142] = {.lex_state = 0, .external_lex_state = 415},
  [23143] = {.lex_state = 0, .external_lex_state = 308},
  [23144] = {.lex_state = 0, .external_lex_state = 443},
  [23145] = {.lex_state = 0, .external_lex_state = 415},
  [23146] = {.lex_state = 0, .external_lex_state = 308},
  [23147] = {.lex_state = 0, .external_lex_state = 308},
  [23148] = {.lex_state = 0, .external_lex_state = 415},
  [23149] = {.lex_state = 0, .external_lex_state = 308},
  [23150] = {.lex_state = 0, .external_lex_state = 308},
  [23151] = {.lex_state = 0, .external_lex_state = 415},
  [23152] = {.lex_state = 0, .external_lex_state = 308},
  [23153] = {.lex_state = 0, .external_lex_state = 308},
  [23154] = {.lex_state = 0, .external_lex_state = 415},
  [23155] = {.lex_state = 0, .external_lex_state = 308},
  [23156] = {.lex_state = 0, .external_lex_state = 308},
  [23157] = {.lex_state = 0, .external_lex_state = 415},
  [23158] = {.lex_state = 0, .external_lex_state = 443},
  [23159] = {.lex_state = 0, .external_lex_state = 308},
  [23160] = {.lex_state = 0, .external_lex_state = 415},
  [23161] = {.lex_state = 0, .external_lex_state = 308},
  [23162] = {.lex_state = 0, .external_lex_state = 308},
  [23163] = {.lex_state = 0, .external_lex_state = 415},
  [23164] = {.lex_state = 0, .external_lex_state = 308},
  [23165] = {.lex_state = 0, .external_lex_state = 308},
  [23166] = {.lex_state = 0, .external_lex_state = 415},
  [23167] = {.lex_state = 0, .external_lex_state = 308},
  [23168] = {.lex_state = 0, .external_lex_state = 308},
  [23169] = {.lex_state = 0, .external_lex_state = 415},
  [23170] = {.lex_state = 0, .external_lex_state = 308},
  [23171] = {.lex_state = 0, .external_lex_state = 308},
  [23172] = {.lex_state = 0, .external_lex_state = 415},
  [23173] = {.lex_state = 0, .external_lex_state = 308},
  [23174] = {.lex_state = 0, .external_lex_state = 308},
  [23175] = {.lex_state = 0, .external_lex_state = 415},
  [23176] = {.lex_state = 0, .external_lex_state = 308},
  [23177] = {.lex_state = 0, .external_lex_state = 308},
  [23178] = {.lex_state = 0, .external_lex_state = 415},
  [23179] = {.lex_state = 0, .external_lex_state = 308},
  [23180] = {.lex_state = 0, .external_lex_state = 308},
  [23181] = {.lex_state = 0, .external_lex_state = 415},
  [23182] = {.lex_state = 0, .external_lex_state = 308},
  [23183] = {.lex_state = 0, .external_lex_state = 308},
  [23184] = {.lex_state = 0, .external_lex_state = 415},
  [23185] = {.lex_state = 0, .external_lex_state = 308},
  [23186] = {.lex_state = 0, .external_lex_state = 308},
  [23187] = {.lex_state = 0, .external_lex_state = 308},
  [23188] = {.lex_state = 0, .external_lex_state = 308},
  [23189] = {.lex_state = 0, .external_lex_state = 308},
  [23190] = {.lex_state = 0, .external_lex_state = 308},
  [23191] = {.lex_state = 0, .external_lex_state = 308},
  [23192] = {.lex_state = 0, .external_lex_state = 308},
  [23193] = {.lex_state = 55, .external_lex_state = 308},
  [23194] = {.lex_state = 0, .external_lex_state = 308},
  [23195] = {.lex_state = 0, .external_lex_state = 308},
  [23196] = {.lex_state = 0, .external_lex_state = 308},
  [23197] = {.lex_state = 0, .external_lex_state = 443},
  [23198] = {.lex_state = 0, .external_lex_state = 308},
  [23199] = {.lex_state = 0, .external_lex_state = 308},
  [23200] = {.lex_state = 0, .external_lex_state = 308},
  [23201] = {.lex_state = 0, .external_lex_state = 308},
  [23202] = {.lex_state = 0, .external_lex_state = 443},
  [23203] = {.lex_state = 0, .external_lex_state = 308},
  [23204] = {.lex_state = 0, .external_lex_state = 443},
  [23205] = {.lex_state = 0, .external_lex_state = 308},
  [23206] = {.lex_state = 0, .external_lex_state = 308},
  [23207] = {.lex_state = 55, .external_lex_state = 308},
  [23208] = {.lex_state = 0, .external_lex_state = 308},
  [23209] = {.lex_state = 0, .external_lex_state = 308},
  [23210] = {.lex_state = 0, .external_lex_state = 308},
  [23211] = {.lex_state = 0, .external_lex_state = 308},
  [23212] = {.lex_state = 0, .external_lex_state = 308},
  [23213] = {.lex_state = 0, .external_lex_state = 308},
  [23214] = {.lex_state = 0, .external_lex_state = 308},
  [23215] = {.lex_state = 0, .external_lex_state = 308},
  [23216] = {.lex_state = 0, .external_lex_state = 308},
  [23217] = {.lex_state = 0, .external_lex_state = 308},
  [23218] = {.lex_state = 55, .external_lex_state = 308},
  [23219] = {.lex_state = 0, .external_lex_state = 308},
  [23220] = {.lex_state = 0, .external_lex_state = 308},
  [23221] = {.lex_state = 0, .external_lex_state = 308},
  [23222] = {.lex_state = 0, .external_lex_state = 308},
  [23223] = {.lex_state = 0, .external_lex_state = 308},
  [23224] = {.lex_state = 0, .external_lex_state = 308},
  [23225] = {.lex_state = 55, .external_lex_state = 308},
  [23226] = {.lex_state = 0, .external_lex_state = 308},
  [23227] = {.lex_state = 0, .external_lex_state = 308},
  [23228] = {.lex_state = 55, .external_lex_state = 308},
  [23229] = {.lex_state = 0, .external_lex_state = 308},
  [23230] = {.lex_state = 0, .external_lex_state = 308},
  [23231] = {.lex_state = 0, .external_lex_state = 308},
  [23232] = {.lex_state = 55, .external_lex_state = 308},
  [23233] = {.lex_state = 0, .external_lex_state = 308},
  [23234] = {.lex_state = 0, .external_lex_state = 308},
  [23235] = {.lex_state = 0, .external_lex_state = 308},
  [23236] = {.lex_state = 0, .external_lex_state = 308},
  [23237] = {.lex_state = 55, .external_lex_state = 308},
  [23238] = {.lex_state = 0, .external_lex_state = 308},
  [23239] = {.lex_state = 0, .external_lex_state = 308},
  [23240] = {.lex_state = 0, .external_lex_state = 308},
  [23241] = {.lex_state = 0, .external_lex_state = 308},
  [23242] = {.lex_state = 55, .external_lex_state = 308},
  [23243] = {.lex_state = 0, .external_lex_state = 308},
  [23244] = {.lex_state = 0, .external_lex_state = 308},
  [23245] = {.lex_state = 0, .external_lex_state = 308},
  [23246] = {.lex_state = 0, .external_lex_state = 308},
  [23247] = {.lex_state = 55, .external_lex_state = 308},
  [23248] = {.lex_state = 0, .external_lex_state = 308},
  [23249] = {.lex_state = 0, .external_lex_state = 443},
  [23250] = {.lex_state = 0, .external_lex_state = 308},
  [23251] = {.lex_state = 0, .external_lex_state = 443},
  [23252] = {.lex_state = 55, .external_lex_state = 308},
  [23253] = {.lex_state = 55, .external_lex_state = 308},
  [23254] = {.lex_state = 0, .external_lex_state = 308},
  [23255] = {.lex_state = 0, .external_lex_state = 308},
  [23256] = {.lex_state = 0, .external_lex_state = 308},
  [23257] = {.lex_state = 55, .external_lex_state = 308},
  [23258] = {.lex_state = 0, .external_lex_state = 308},
  [23259] = {.lex_state = 0, .external_lex_state = 308},
  [23260] = {.lex_state = 0, .external_lex_state = 308},
  [23261] = {.lex_state = 0, .external_lex_state = 308},
  [23262] = {.lex_state = 55, .external_lex_state = 308},
  [23263] = {.lex_state = 0, .external_lex_state = 308},
  [23264] = {.lex_state = 0, .external_lex_state = 308},
  [23265] = {.lex_state = 0, .external_lex_state = 308},
  [23266] = {.lex_state = 0, .external_lex_state = 415},
  [23267] = {.lex_state = 55, .external_lex_state = 308},
  [23268] = {.lex_state = 0, .external_lex_state = 308},
  [23269] = {.lex_state = 0, .external_lex_state = 308},
  [23270] = {.lex_state = 0, .external_lex_state = 308},
  [23271] = {.lex_state = 0, .external_lex_state = 308},
  [23272] = {.lex_state = 55, .external_lex_state = 308},
  [23273] = {.lex_state = 0, .external_lex_state = 308},
  [23274] = {.lex_state = 0, .external_lex_state = 308},
  [23275] = {.lex_state = 0, .external_lex_state = 308},
  [23276] = {.lex_state = 0, .external_lex_state = 308},
  [23277] = {.lex_state = 55, .external_lex_state = 308},
  [23278] = {.lex_state = 55, .external_lex_state = 308},
  [23279] = {.lex_state = 0, .external_lex_state = 308},
  [23280] = {.lex_state = 0, .external_lex_state = 308},
  [23281] = {.lex_state = 0, .external_lex_state = 308},
  [23282] = {.lex_state = 55, .external_lex_state = 308},
  [23283] = {.lex_state = 0, .external_lex_state = 308},
  [23284] = {.lex_state = 0, .external_lex_state = 308},
  [23285] = {.lex_state = 0, .external_lex_state = 308},
  [23286] = {.lex_state = 0, .external_lex_state = 308},
  [23287] = {.lex_state = 55, .external_lex_state = 308},
  [23288] = {.lex_state = 0, .external_lex_state = 308},
  [23289] = {.lex_state = 0, .external_lex_state = 308},
  [23290] = {.lex_state = 0, .external_lex_state = 308},
  [23291] = {.lex_state = 0, .external_lex_state = 308},
  [23292] = {.lex_state = 55, .external_lex_state = 308},
  [23293] = {.lex_state = 0, .external_lex_state = 443},
  [23294] = {.lex_state = 0, .external_lex_state = 308},
  [23295] = {.lex_state = 0, .external_lex_state = 308},
  [23296] = {.lex_state = 0, .external_lex_state = 308},
  [23297] = {.lex_state = 55, .external_lex_state = 308},
  [23298] = {.lex_state = 0, .external_lex_state = 308},
  [23299] = {.lex_state = 0, .external_lex_state = 308},
  [23300] = {.lex_state = 0, .external_lex_state = 308},
  [23301] = {.lex_state = 0, .external_lex_state = 308},
  [23302] = {.lex_state = 55, .external_lex_state = 308},
  [23303] = {.lex_state = 0, .external_lex_state = 443},
  [23304] = {.lex_state = 0, .external_lex_state = 308},
  [23305] = {.lex_state = 0, .external_lex_state = 308},
  [23306] = {.lex_state = 0, .external_lex_state = 308},
  [23307] = {.lex_state = 55, .external_lex_state = 308},
  [23308] = {.lex_state = 0, .external_lex_state = 308},
  [23309] = {.lex_state = 0, .external_lex_state = 308},
  [23310] = {.lex_state = 0, .external_lex_state = 308},
  [23311] = {.lex_state = 0, .external_lex_state = 308},
  [23312] = {.lex_state = 55, .external_lex_state = 308},
  [23313] = {.lex_state = 0, .external_lex_state = 308},
  [23314] = {.lex_state = 55, .external_lex_state = 308},
  [23315] = {.lex_state = 0, .external_lex_state = 308},
  [23316] = {.lex_state = 0, .external_lex_state = 333},
  [23317] = {.lex_state = 55, .external_lex_state = 308},
  [23318] = {.lex_state = 0, .external_lex_state = 308},
  [23319] = {.lex_state = 0, .external_lex_state = 308},
  [23320] = {.lex_state = 0, .external_lex_state = 308},
  [23321] = {.lex_state = 0, .external_lex_state = 443},
  [23322] = {.lex_state = 0, .external_lex_state = 308},
  [23323] = {.lex_state = 0, .external_lex_state = 308},
  [23324] = {.lex_state = 0, .external_lex_state = 308},
  [23325] = {.lex_state = 0, .external_lex_state = 308},
  [23326] = {.lex_state = 0, .external_lex_state = 308},
  [23327] = {.lex_state = 0, .external_lex_state = 308},
  [23328] = {.lex_state = 0, .external_lex_state = 308},
  [23329] = {.lex_state = 0, .external_lex_state = 308},
  [23330] = {.lex_state = 55, .external_lex_state = 308},
  [23331] = {.lex_state = 0, .external_lex_state = 308},
  [23332] = {.lex_state = 0, .external_lex_state = 308},
  [23333] = {.lex_state = 0, .external_lex_state = 308},
  [23334] = {.lex_state = 0, .external_lex_state = 308},
  [23335] = {.lex_state = 0, .external_lex_state = 308},
  [23336] = {.lex_state = 0, .external_lex_state = 308},
  [23337] = {.lex_state = 0, .external_lex_state = 308},
  [23338] = {.lex_state = 0, .external_lex_state = 443},
  [23339] = {.lex_state = 0, .external_lex_state = 308},
  [23340] = {.lex_state = 0, .external_lex_state = 308},
  [23341] = {.lex_state = 0, .external_lex_state = 443},
  [23342] = {.lex_state = 0, .external_lex_state = 308},
  [23343] = {.lex_state = 0, .external_lex_state = 308},
  [23344] = {.lex_state = 0, .external_lex_state = 308},
  [23345] = {.lex_state = 0, .external_lex_state = 308},
  [23346] = {.lex_state = 0, .external_lex_state = 308},
  [23347] = {.lex_state = 0, .external_lex_state = 308},
  [23348] = {.lex_state = 0, .external_lex_state = 308},
  [23349] = {.lex_state = 0, .external_lex_state = 308},
  [23350] = {.lex_state = 0, .external_lex_state = 308},
  [23351] = {.lex_state = 0, .external_lex_state = 308},
  [23352] = {.lex_state = 0, .external_lex_state = 308},
  [23353] = {.lex_state = 0, .external_lex_state = 308},
  [23354] = {.lex_state = 0, .external_lex_state = 308},
  [23355] = {.lex_state = 0, .external_lex_state = 308},
  [23356] = {.lex_state = 0, .external_lex_state = 443},
  [23357] = {.lex_state = 0, .external_lex_state = 308},
  [23358] = {.lex_state = 0, .external_lex_state = 308},
  [23359] = {.lex_state = 57, .external_lex_state = 308},
  [23360] = {.lex_state = 0, .external_lex_state = 443},
  [23361] = {.lex_state = 0, .external_lex_state = 308},
  [23362] = {.lex_state = 0, .external_lex_state = 443},
  [23363] = {.lex_state = 0, .external_lex_state = 308},
  [23364] = {.lex_state = 0, .external_lex_state = 308},
  [23365] = {.lex_state = 0, .external_lex_state = 308},
  [23366] = {.lex_state = 0, .external_lex_state = 308},
  [23367] = {.lex_state = 0, .external_lex_state = 308},
  [23368] = {.lex_state = 55, .external_lex_state = 308},
  [23369] = {.lex_state = 0, .external_lex_state = 308},
  [23370] = {.lex_state = 0, .external_lex_state = 308},
  [23371] = {.lex_state = 0, .external_lex_state = 308},
  [23372] = {.lex_state = 0, .external_lex_state = 308},
  [23373] = {.lex_state = 0, .external_lex_state = 308},
  [23374] = {.lex_state = 0, .external_lex_state = 308},
  [23375] = {.lex_state = 0, .external_lex_state = 308},
  [23376] = {.lex_state = 0, .external_lex_state = 308},
  [23377] = {.lex_state = 0, .external_lex_state = 308},
  [23378] = {.lex_state = 0, .external_lex_state = 308},
  [23379] = {.lex_state = 0, .external_lex_state = 308},
  [23380] = {.lex_state = 0, .external_lex_state = 308},
  [23381] = {.lex_state = 0, .external_lex_state = 443},
  [23382] = {.lex_state = 0, .external_lex_state = 308},
  [23383] = {.lex_state = 0, .external_lex_state = 308},
  [23384] = {.lex_state = 0, .external_lex_state = 308},
  [23385] = {.lex_state = 0, .external_lex_state = 308},
  [23386] = {.lex_state = 0, .external_lex_state = 443},
  [23387] = {.lex_state = 0, .external_lex_state = 308},
  [23388] = {.lex_state = 0, .external_lex_state = 308},
  [23389] = {.lex_state = 0, .external_lex_state = 308},
  [23390] = {.lex_state = 0, .external_lex_state = 308},
  [23391] = {.lex_state = 0, .external_lex_state = 308},
  [23392] = {.lex_state = 0, .external_lex_state = 333},
  [23393] = {.lex_state = 0, .external_lex_state = 308},
  [23394] = {.lex_state = 0, .external_lex_state = 308},
  [23395] = {.lex_state = 0, .external_lex_state = 308},
  [23396] = {.lex_state = 0, .external_lex_state = 308},
  [23397] = {.lex_state = 0, .external_lex_state = 308},
  [23398] = {.lex_state = 0, .external_lex_state = 308},
  [23399] = {.lex_state = 0, .external_lex_state = 308},
  [23400] = {.lex_state = 0, .external_lex_state = 308},
  [23401] = {.lex_state = 0, .external_lex_state = 308},
  [23402] = {.lex_state = 0, .external_lex_state = 308},
  [23403] = {.lex_state = 0, .external_lex_state = 308},
  [23404] = {.lex_state = 0, .external_lex_state = 308},
  [23405] = {.lex_state = 0, .external_lex_state = 308},
  [23406] = {.lex_state = 0, .external_lex_state = 308},
  [23407] = {.lex_state = 0, .external_lex_state = 308},
  [23408] = {.lex_state = 0, .external_lex_state = 308},
  [23409] = {.lex_state = 0, .external_lex_state = 308},
  [23410] = {.lex_state = 0, .external_lex_state = 443},
  [23411] = {.lex_state = 0, .external_lex_state = 443},
  [23412] = {.lex_state = 0, .external_lex_state = 308},
  [23413] = {.lex_state = 0, .external_lex_state = 308},
  [23414] = {.lex_state = 0, .external_lex_state = 308},
  [23415] = {.lex_state = 0, .external_lex_state = 308},
  [23416] = {.lex_state = 0, .external_lex_state = 443},
  [23417] = {.lex_state = 0, .external_lex_state = 308},
  [23418] = {.lex_state = 0, .external_lex_state = 308},
  [23419] = {.lex_state = 0, .external_lex_state = 308},
  [23420] = {.lex_state = 0, .external_lex_state = 308},
  [23421] = {.lex_state = 0, .external_lex_state = 308},
  [23422] = {.lex_state = 0, .external_lex_state = 308},
  [23423] = {.lex_state = 0, .external_lex_state = 308},
  [23424] = {.lex_state = 0, .external_lex_state = 308},
  [23425] = {.lex_state = 0, .external_lex_state = 308},
  [23426] = {.lex_state = 0, .external_lex_state = 308},
  [23427] = {.lex_state = 0, .external_lex_state = 308},
  [23428] = {.lex_state = 0, .external_lex_state = 308},
  [23429] = {.lex_state = 0, .external_lex_state = 308},
  [23430] = {.lex_state = 0, .external_lex_state = 443},
  [23431] = {.lex_state = 0, .external_lex_state = 443},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__varid] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_char] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym__integer_literal] = ACTIONS(1),
    [sym__binary_literal] = ACTIONS(1),
    [sym__octal_literal] = ACTIONS(1),
    [sym__hex_literal] = ACTIONS(1),
    [anon_sym_LPAREN_POUND] = ACTIONS(1),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_u2237] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym__immediate_dot] = ACTIONS(1),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym_implicit_parid] = ACTIONS(1),
    [sym__conid] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_u2605] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_family] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_representational] = ACTIONS(1),
    [anon_sym_nominal] = ACTIONS(1),
    [anon_sym_phantom] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_role] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_thengroupby] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_thengroupusing] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_cases] = ACTIONS(1),
    [anon_sym_rec] = ACTIONS(1),
    [anon_sym_mdo] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_AT2] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [anon_sym_hiding] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_qualified] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_via] = ACTIONS(1),
    [anon_sym_stock] = ACTIONS(1),
    [anon_sym_newtype] = ACTIONS(1),
    [anon_sym_anyclass] = ACTIONS(1),
    [anon_sym_deriving] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_infixl] = ACTIONS(1),
    [anon_sym_infixr] = ACTIONS(1),
    [anon_sym_infix] = ACTIONS(1),
    [anon_sym_ccall] = ACTIONS(1),
    [anon_sym_stdcall] = ACTIONS(1),
    [anon_sym_cplusplus] = ACTIONS(1),
    [anon_sym_jvm] = ACTIONS(1),
    [anon_sym_dotnet] = ACTIONS(1),
    [anon_sym_prim] = ACTIONS(1),
    [anon_sym_capi] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_safe] = ACTIONS(1),
    [anon_sym_interruptible] = ACTIONS(1),
    [anon_sym_foreign] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_u27e6] = ACTIONS(1),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1),
    [anon_sym_u27e7] = ACTIONS(1),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1),
    [sym__layout_start] = ACTIONS(1),
    [sym__layout_end] = ACTIONS(1),
    [sym__dot] = ACTIONS(1),
    [sym__arith_dotdot] = ACTIONS(1),
    [sym_where] = ACTIONS(1),
    [sym__splice_dollar] = ACTIONS(1),
    [sym__varsym] = ACTIONS(1),
    [sym__consym] = ACTIONS(1),
    [sym__tyconsym] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1),
    [sym_quasiquote_start] = ACTIONS(1),
    [sym_quasiquote_bar] = ACTIONS(1),
    [sym_quasiquote_body] = ACTIONS(1),
    [sym__strict] = ACTIONS(1),
    [sym__lazy] = ACTIONS(1),
    [sym__unboxed_close] = ACTIONS(1),
    [sym_empty_file] = ACTIONS(1),
  },
  [1] = {
    [sym_haskell] = STATE(23344),
    [sym__topdecl] = STATE(17548),
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3743),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(4147),
    [sym_qualified_constructor] = STATE(4265),
    [sym__qcon] = STATE(4269),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5240),
    [sym_decl_type] = STATE(17548),
    [sym_decl_tyfam] = STATE(17548),
    [sym_decl_tyinst] = STATE(17548),
    [sym_decl_role] = STATE(17548),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10719),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10719),
    [sym_exp_cond] = STATE(10719),
    [sym_exp_if_guard] = STATE(10719),
    [sym_exp_case] = STATE(10719),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10719),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10719),
    [sym__lexp] = STATE(10719),
    [sym_exp_infix] = STATE(10719),
    [sym__exp_infix] = STATE(10719),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(14983),
    [sym__typed_pat] = STATE(14983),
    [sym_decl_import] = STATE(17548),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14101),
    [sym__module] = STATE(23306),
    [sym_decl_adt] = STATE(17548),
    [sym_decl_newtype] = STATE(17548),
    [sym_decl_datafam] = STATE(17548),
    [sym_decl_datainst] = STATE(17548),
    [sym_decl_class] = STATE(17548),
    [sym__instance] = STATE(17460),
    [sym_decl_instance] = STATE(17548),
    [sym_decl_deriving] = STATE(17548),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(17887),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(14971),
    [sym_function] = STATE(17548),
    [sym_fixity] = STATE(17548),
    [sym_signature] = STATE(17548),
    [sym__gendecl] = STATE(17548),
    [sym__decl_fun] = STATE(17548),
    [sym__decl] = STATE(17548),
    [sym_decl_foreign_import] = STATE(17548),
    [sym_decl_foreign_export] = STATE(17548),
    [sym__decl_foreign] = STATE(17548),
    [sym_decl_special] = STATE(17548),
    [sym_decl_pattern] = STATE(17548),
    [sym_decl_default] = STATE(17548),
    [sym_splice] = STATE(5230),
    [sym_top_splice] = STATE(17548),
    [sym_quasiquote] = STATE(5230),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_instance] = ACTIONS(33),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_module] = ACTIONS(53),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [sym_decl_special_fun_fixity] = ACTIONS(69),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
    [sym_empty_file] = ACTIONS(81),
  },
  [2] = {
    [sym__topdecl] = STATE(16495),
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(115),
    [sym_variable] = STATE(3786),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(4497),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(5635),
    [sym_decl_type] = STATE(16495),
    [sym_decl_tyfam] = STATE(16495),
    [sym_decl_tyinst] = STATE(16495),
    [sym_decl_role] = STATE(16495),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10878),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10878),
    [sym_exp_cond] = STATE(10878),
    [sym_exp_if_guard] = STATE(10878),
    [sym_exp_case] = STATE(10878),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10878),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10878),
    [sym__lexp] = STATE(10878),
    [sym_exp_infix] = STATE(10878),
    [sym__exp_infix] = STATE(10878),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym_decl_import] = STATE(16495),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14092),
    [sym_decl_adt] = STATE(16495),
    [sym_decl_newtype] = STATE(16495),
    [sym_decl_datafam] = STATE(16495),
    [sym_decl_datainst] = STATE(16495),
    [sym_decl_class] = STATE(16495),
    [sym__instance] = STATE(18562),
    [sym_decl_instance] = STATE(16495),
    [sym_decl_deriving] = STATE(16495),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16495),
    [sym_fixity] = STATE(16495),
    [sym_signature] = STATE(16495),
    [sym__gendecl] = STATE(16495),
    [sym__decl_fun] = STATE(16495),
    [sym__decl] = STATE(16495),
    [sym_decl_foreign_import] = STATE(16495),
    [sym_decl_foreign_export] = STATE(16495),
    [sym__decl_foreign] = STATE(16495),
    [sym_decl_special] = STATE(16495),
    [sym_decl_pattern] = STATE(16495),
    [sym_decl_default] = STATE(16495),
    [sym_splice] = STATE(5634),
    [sym_top_splice] = STATE(16495),
    [sym_quasiquote] = STATE(5634),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(85),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(93),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(93),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(99),
    [sym_implicit_parid] = ACTIONS(101),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(113),
    [anon_sym_instance] = ACTIONS(115),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_pattern] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_newtype] = ACTIONS(131),
    [anon_sym_deriving] = ACTIONS(133),
    [anon_sym_data] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_foreign] = ACTIONS(143),
    [sym_decl_special_fun_fixity] = ACTIONS(145),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [3] = {
    [sym__topdecl] = STATE(17076),
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(115),
    [sym_variable] = STATE(3786),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(4497),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(5635),
    [sym_decl_type] = STATE(17076),
    [sym_decl_tyfam] = STATE(17076),
    [sym_decl_tyinst] = STATE(17076),
    [sym_decl_role] = STATE(17076),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10878),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10878),
    [sym_exp_cond] = STATE(10878),
    [sym_exp_if_guard] = STATE(10878),
    [sym_exp_case] = STATE(10878),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10878),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10878),
    [sym__lexp] = STATE(10878),
    [sym_exp_infix] = STATE(10878),
    [sym__exp_infix] = STATE(10878),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym_decl_import] = STATE(17076),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14092),
    [sym_decl_adt] = STATE(17076),
    [sym_decl_newtype] = STATE(17076),
    [sym_decl_datafam] = STATE(17076),
    [sym_decl_datainst] = STATE(17076),
    [sym_decl_class] = STATE(17076),
    [sym__instance] = STATE(18562),
    [sym_decl_instance] = STATE(17076),
    [sym_decl_deriving] = STATE(17076),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17076),
    [sym_fixity] = STATE(17076),
    [sym_signature] = STATE(17076),
    [sym__gendecl] = STATE(17076),
    [sym__decl_fun] = STATE(17076),
    [sym__decl] = STATE(17076),
    [sym_decl_foreign_import] = STATE(17076),
    [sym_decl_foreign_export] = STATE(17076),
    [sym__decl_foreign] = STATE(17076),
    [sym_decl_special] = STATE(17076),
    [sym_decl_pattern] = STATE(17076),
    [sym_decl_default] = STATE(17076),
    [sym_splice] = STATE(5634),
    [sym_top_splice] = STATE(17076),
    [sym_quasiquote] = STATE(5634),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(153),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(93),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(93),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(99),
    [sym_implicit_parid] = ACTIONS(101),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(113),
    [anon_sym_instance] = ACTIONS(115),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_pattern] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_newtype] = ACTIONS(131),
    [anon_sym_deriving] = ACTIONS(133),
    [anon_sym_data] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_foreign] = ACTIONS(143),
    [sym_decl_special_fun_fixity] = ACTIONS(145),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [4] = {
    [sym__topdecl] = STATE(16495),
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(115),
    [sym_variable] = STATE(3786),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(4497),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(5635),
    [sym_decl_type] = STATE(16495),
    [sym_decl_tyfam] = STATE(16495),
    [sym_decl_tyinst] = STATE(16495),
    [sym_decl_role] = STATE(16495),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10878),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10878),
    [sym_exp_cond] = STATE(10878),
    [sym_exp_if_guard] = STATE(10878),
    [sym_exp_case] = STATE(10878),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10878),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10878),
    [sym__lexp] = STATE(10878),
    [sym_exp_infix] = STATE(10878),
    [sym__exp_infix] = STATE(10878),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym_decl_import] = STATE(16495),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14092),
    [sym_decl_adt] = STATE(16495),
    [sym_decl_newtype] = STATE(16495),
    [sym_decl_datafam] = STATE(16495),
    [sym_decl_datainst] = STATE(16495),
    [sym_decl_class] = STATE(16495),
    [sym__instance] = STATE(18562),
    [sym_decl_instance] = STATE(16495),
    [sym_decl_deriving] = STATE(16495),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16495),
    [sym_fixity] = STATE(16495),
    [sym_signature] = STATE(16495),
    [sym__gendecl] = STATE(16495),
    [sym__decl_fun] = STATE(16495),
    [sym__decl] = STATE(16495),
    [sym_decl_foreign_import] = STATE(16495),
    [sym_decl_foreign_export] = STATE(16495),
    [sym__decl_foreign] = STATE(16495),
    [sym_decl_special] = STATE(16495),
    [sym_decl_pattern] = STATE(16495),
    [sym_decl_default] = STATE(16495),
    [sym_splice] = STATE(5634),
    [sym_top_splice] = STATE(16495),
    [sym_quasiquote] = STATE(5634),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(157),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(93),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(93),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(99),
    [sym_implicit_parid] = ACTIONS(101),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(113),
    [anon_sym_instance] = ACTIONS(115),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_pattern] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_newtype] = ACTIONS(131),
    [anon_sym_deriving] = ACTIONS(133),
    [anon_sym_data] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_foreign] = ACTIONS(143),
    [sym_decl_special_fun_fixity] = ACTIONS(145),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [5] = {
    [sym__topdecl] = STATE(21129),
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(115),
    [sym_variable] = STATE(3786),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(4497),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(5635),
    [sym_decl_type] = STATE(21129),
    [sym_decl_tyfam] = STATE(21129),
    [sym_decl_tyinst] = STATE(21129),
    [sym_decl_role] = STATE(21129),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10878),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10878),
    [sym_exp_cond] = STATE(10878),
    [sym_exp_if_guard] = STATE(10878),
    [sym_exp_case] = STATE(10878),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10878),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10878),
    [sym__lexp] = STATE(10878),
    [sym_exp_infix] = STATE(10878),
    [sym__exp_infix] = STATE(10878),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym_decl_import] = STATE(21129),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14092),
    [sym_decl_adt] = STATE(21129),
    [sym_decl_newtype] = STATE(21129),
    [sym_decl_datafam] = STATE(21129),
    [sym_decl_datainst] = STATE(21129),
    [sym_decl_class] = STATE(21129),
    [sym__instance] = STATE(18562),
    [sym_decl_instance] = STATE(21129),
    [sym_decl_deriving] = STATE(21129),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(21129),
    [sym_fixity] = STATE(21129),
    [sym_signature] = STATE(21129),
    [sym__gendecl] = STATE(21129),
    [sym__decl_fun] = STATE(21129),
    [sym__decl] = STATE(21129),
    [sym_decl_foreign_import] = STATE(21129),
    [sym_decl_foreign_export] = STATE(21129),
    [sym__decl_foreign] = STATE(21129),
    [sym_decl_special] = STATE(21129),
    [sym_decl_pattern] = STATE(21129),
    [sym_decl_default] = STATE(21129),
    [sym_splice] = STATE(5634),
    [sym_top_splice] = STATE(21129),
    [sym_quasiquote] = STATE(5634),
    [aux_sym_decl_tyfam_repeat1] = STATE(3810),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(159),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(93),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(93),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(99),
    [sym_implicit_parid] = ACTIONS(101),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(113),
    [anon_sym_instance] = ACTIONS(115),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_pattern] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_newtype] = ACTIONS(131),
    [anon_sym_deriving] = ACTIONS(133),
    [anon_sym_data] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_foreign] = ACTIONS(143),
    [sym_decl_special_fun_fixity] = ACTIONS(145),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [6] = {
    [sym__topdecl] = STATE(16473),
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(115),
    [sym_variable] = STATE(3786),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(4497),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(5635),
    [sym_decl_type] = STATE(16473),
    [sym_decl_tyfam] = STATE(16473),
    [sym_decl_tyinst] = STATE(16473),
    [sym_decl_role] = STATE(16473),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10878),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10878),
    [sym_exp_cond] = STATE(10878),
    [sym_exp_if_guard] = STATE(10878),
    [sym_exp_case] = STATE(10878),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10878),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10878),
    [sym__lexp] = STATE(10878),
    [sym_exp_infix] = STATE(10878),
    [sym__exp_infix] = STATE(10878),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym_decl_import] = STATE(16473),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14092),
    [sym_decl_adt] = STATE(16473),
    [sym_decl_newtype] = STATE(16473),
    [sym_decl_datafam] = STATE(16473),
    [sym_decl_datainst] = STATE(16473),
    [sym_decl_class] = STATE(16473),
    [sym__instance] = STATE(18562),
    [sym_decl_instance] = STATE(16473),
    [sym_decl_deriving] = STATE(16473),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16473),
    [sym_fixity] = STATE(16473),
    [sym_signature] = STATE(16473),
    [sym__gendecl] = STATE(16473),
    [sym__decl_fun] = STATE(16473),
    [sym__decl] = STATE(16473),
    [sym_decl_foreign_import] = STATE(16473),
    [sym_decl_foreign_export] = STATE(16473),
    [sym__decl_foreign] = STATE(16473),
    [sym_decl_special] = STATE(16473),
    [sym_decl_pattern] = STATE(16473),
    [sym_decl_default] = STATE(16473),
    [sym_splice] = STATE(5634),
    [sym_top_splice] = STATE(16473),
    [sym_quasiquote] = STATE(5634),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(161),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(93),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(93),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(99),
    [sym_implicit_parid] = ACTIONS(101),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(113),
    [anon_sym_instance] = ACTIONS(115),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_pattern] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_newtype] = ACTIONS(131),
    [anon_sym_deriving] = ACTIONS(133),
    [anon_sym_data] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(139),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_foreign] = ACTIONS(143),
    [sym_decl_special_fun_fixity] = ACTIONS(145),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [7] = {
    [sym__topdecl] = STATE(18172),
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(3738),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4187),
    [sym_qualified_constructor] = STATE(4258),
    [sym__qcon] = STATE(4304),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(4876),
    [sym_decl_type] = STATE(18172),
    [sym_decl_tyfam] = STATE(18172),
    [sym_decl_tyinst] = STATE(18172),
    [sym_decl_role] = STATE(18172),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10705),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10705),
    [sym_exp_cond] = STATE(10705),
    [sym_exp_if_guard] = STATE(10705),
    [sym_exp_case] = STATE(10705),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10705),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10705),
    [sym__lexp] = STATE(10705),
    [sym_exp_infix] = STATE(10705),
    [sym__exp_infix] = STATE(10705),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym_decl_import] = STATE(18172),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14102),
    [sym_decl_adt] = STATE(18172),
    [sym_decl_newtype] = STATE(18172),
    [sym_decl_datafam] = STATE(18172),
    [sym_decl_datainst] = STATE(18172),
    [sym_decl_class] = STATE(18172),
    [sym__instance] = STATE(17053),
    [sym_decl_instance] = STATE(18172),
    [sym_decl_deriving] = STATE(18172),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(18172),
    [sym_fixity] = STATE(18172),
    [sym_signature] = STATE(18172),
    [sym__gendecl] = STATE(18172),
    [sym__decl_fun] = STATE(18172),
    [sym__decl] = STATE(18172),
    [sym_decl_foreign_import] = STATE(18172),
    [sym_decl_foreign_export] = STATE(18172),
    [sym__decl_foreign] = STATE(18172),
    [sym_decl_special] = STATE(18172),
    [sym_decl_pattern] = STATE(18172),
    [sym_decl_default] = STATE(18172),
    [sym_splice] = STATE(4875),
    [sym_top_splice] = STATE(18172),
    [sym_quasiquote] = STATE(4875),
    [sym__varid] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(173),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(173),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [sym_implicit_parid] = ACTIONS(181),
    [sym__conid] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_type] = ACTIONS(191),
    [anon_sym_instance] = ACTIONS(193),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_pattern] = ACTIONS(205),
    [anon_sym_import] = ACTIONS(207),
    [anon_sym_newtype] = ACTIONS(209),
    [anon_sym_deriving] = ACTIONS(211),
    [anon_sym_data] = ACTIONS(213),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(217),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_foreign] = ACTIONS(221),
    [sym_decl_special_fun_fixity] = ACTIONS(223),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(227),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [8] = {
    [sym__topdecl] = STATE(18386),
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3743),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(4147),
    [sym_qualified_constructor] = STATE(4265),
    [sym__qcon] = STATE(4269),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5240),
    [sym_decl_type] = STATE(18386),
    [sym_decl_tyfam] = STATE(18386),
    [sym_decl_tyinst] = STATE(18386),
    [sym_decl_role] = STATE(18386),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10719),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10719),
    [sym_exp_cond] = STATE(10719),
    [sym_exp_if_guard] = STATE(10719),
    [sym_exp_case] = STATE(10719),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10719),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10719),
    [sym__lexp] = STATE(10719),
    [sym_exp_infix] = STATE(10719),
    [sym__exp_infix] = STATE(10719),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(14983),
    [sym__typed_pat] = STATE(14983),
    [sym_decl_import] = STATE(18386),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14101),
    [sym_decl_adt] = STATE(18386),
    [sym_decl_newtype] = STATE(18386),
    [sym_decl_datafam] = STATE(18386),
    [sym_decl_datainst] = STATE(18386),
    [sym_decl_class] = STATE(18386),
    [sym__instance] = STATE(17460),
    [sym_decl_instance] = STATE(18386),
    [sym_decl_deriving] = STATE(18386),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(17887),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(14971),
    [sym_function] = STATE(18386),
    [sym_fixity] = STATE(18386),
    [sym_signature] = STATE(18386),
    [sym__gendecl] = STATE(18386),
    [sym__decl_fun] = STATE(18386),
    [sym__decl] = STATE(18386),
    [sym_decl_foreign_import] = STATE(18386),
    [sym_decl_foreign_export] = STATE(18386),
    [sym__decl_foreign] = STATE(18386),
    [sym_decl_special] = STATE(18386),
    [sym_decl_pattern] = STATE(18386),
    [sym_decl_default] = STATE(18386),
    [sym_splice] = STATE(5230),
    [sym_top_splice] = STATE(18386),
    [sym_quasiquote] = STATE(5230),
    [ts_builtin_sym_end] = ACTIONS(233),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_instance] = ACTIONS(33),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [sym_decl_special_fun_fixity] = ACTIONS(69),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [9] = {
    [sym__topdecl] = STATE(17078),
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(3738),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4187),
    [sym_qualified_constructor] = STATE(4258),
    [sym__qcon] = STATE(4304),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(4876),
    [sym_decl_type] = STATE(17078),
    [sym_decl_tyfam] = STATE(17078),
    [sym_decl_tyinst] = STATE(17078),
    [sym_decl_role] = STATE(17078),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10705),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10705),
    [sym_exp_cond] = STATE(10705),
    [sym_exp_if_guard] = STATE(10705),
    [sym_exp_case] = STATE(10705),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10705),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10705),
    [sym__lexp] = STATE(10705),
    [sym_exp_infix] = STATE(10705),
    [sym__exp_infix] = STATE(10705),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym_decl_import] = STATE(17078),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14102),
    [sym_decl_adt] = STATE(17078),
    [sym_decl_newtype] = STATE(17078),
    [sym_decl_datafam] = STATE(17078),
    [sym_decl_datainst] = STATE(17078),
    [sym_decl_class] = STATE(17078),
    [sym__instance] = STATE(17053),
    [sym_decl_instance] = STATE(17078),
    [sym_decl_deriving] = STATE(17078),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(17078),
    [sym_fixity] = STATE(17078),
    [sym_signature] = STATE(17078),
    [sym__gendecl] = STATE(17078),
    [sym__decl_fun] = STATE(17078),
    [sym__decl] = STATE(17078),
    [sym_decl_foreign_import] = STATE(17078),
    [sym_decl_foreign_export] = STATE(17078),
    [sym__decl_foreign] = STATE(17078),
    [sym_decl_special] = STATE(17078),
    [sym_decl_pattern] = STATE(17078),
    [sym_decl_default] = STATE(17078),
    [sym_splice] = STATE(4875),
    [sym_top_splice] = STATE(17078),
    [sym_quasiquote] = STATE(4875),
    [sym__varid] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(173),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(173),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [sym_implicit_parid] = ACTIONS(181),
    [sym__conid] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_type] = ACTIONS(191),
    [anon_sym_instance] = ACTIONS(193),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_pattern] = ACTIONS(205),
    [anon_sym_import] = ACTIONS(207),
    [anon_sym_newtype] = ACTIONS(209),
    [anon_sym_deriving] = ACTIONS(211),
    [anon_sym_data] = ACTIONS(213),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(217),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_foreign] = ACTIONS(221),
    [sym_decl_special_fun_fixity] = ACTIONS(223),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(155),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [10] = {
    [sym__topdecl] = STATE(18172),
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(3738),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4187),
    [sym_qualified_constructor] = STATE(4258),
    [sym__qcon] = STATE(4304),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(4876),
    [sym_decl_type] = STATE(18172),
    [sym_decl_tyfam] = STATE(18172),
    [sym_decl_tyinst] = STATE(18172),
    [sym_decl_role] = STATE(18172),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10705),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10705),
    [sym_exp_cond] = STATE(10705),
    [sym_exp_if_guard] = STATE(10705),
    [sym_exp_case] = STATE(10705),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10705),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10705),
    [sym__lexp] = STATE(10705),
    [sym_exp_infix] = STATE(10705),
    [sym__exp_infix] = STATE(10705),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym_decl_import] = STATE(18172),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14102),
    [sym_decl_adt] = STATE(18172),
    [sym_decl_newtype] = STATE(18172),
    [sym_decl_datafam] = STATE(18172),
    [sym_decl_datainst] = STATE(18172),
    [sym_decl_class] = STATE(18172),
    [sym__instance] = STATE(17053),
    [sym_decl_instance] = STATE(18172),
    [sym_decl_deriving] = STATE(18172),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(18172),
    [sym_fixity] = STATE(18172),
    [sym_signature] = STATE(18172),
    [sym__gendecl] = STATE(18172),
    [sym__decl_fun] = STATE(18172),
    [sym__decl] = STATE(18172),
    [sym_decl_foreign_import] = STATE(18172),
    [sym_decl_foreign_export] = STATE(18172),
    [sym__decl_foreign] = STATE(18172),
    [sym_decl_special] = STATE(18172),
    [sym_decl_pattern] = STATE(18172),
    [sym_decl_default] = STATE(18172),
    [sym_splice] = STATE(4875),
    [sym_top_splice] = STATE(18172),
    [sym_quasiquote] = STATE(4875),
    [sym__varid] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(173),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(173),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [sym_implicit_parid] = ACTIONS(181),
    [sym__conid] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_type] = ACTIONS(191),
    [anon_sym_instance] = ACTIONS(193),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_pattern] = ACTIONS(205),
    [anon_sym_import] = ACTIONS(207),
    [anon_sym_newtype] = ACTIONS(209),
    [anon_sym_deriving] = ACTIONS(211),
    [anon_sym_data] = ACTIONS(213),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(217),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_foreign] = ACTIONS(221),
    [sym_decl_special_fun_fixity] = ACTIONS(223),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(163),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [11] = {
    [sym__topdecl] = STATE(18386),
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3743),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(4147),
    [sym_qualified_constructor] = STATE(4265),
    [sym__qcon] = STATE(4269),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5240),
    [sym_decl_type] = STATE(18386),
    [sym_decl_tyfam] = STATE(18386),
    [sym_decl_tyinst] = STATE(18386),
    [sym_decl_role] = STATE(18386),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10719),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10719),
    [sym_exp_cond] = STATE(10719),
    [sym_exp_if_guard] = STATE(10719),
    [sym_exp_case] = STATE(10719),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10719),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10719),
    [sym__lexp] = STATE(10719),
    [sym_exp_infix] = STATE(10719),
    [sym__exp_infix] = STATE(10719),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(14983),
    [sym__typed_pat] = STATE(14983),
    [sym_decl_import] = STATE(18386),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14101),
    [sym_decl_adt] = STATE(18386),
    [sym_decl_newtype] = STATE(18386),
    [sym_decl_datafam] = STATE(18386),
    [sym_decl_datainst] = STATE(18386),
    [sym_decl_class] = STATE(18386),
    [sym__instance] = STATE(17460),
    [sym_decl_instance] = STATE(18386),
    [sym_decl_deriving] = STATE(18386),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(17887),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(14971),
    [sym_function] = STATE(18386),
    [sym_fixity] = STATE(18386),
    [sym_signature] = STATE(18386),
    [sym__gendecl] = STATE(18386),
    [sym__decl_fun] = STATE(18386),
    [sym__decl] = STATE(18386),
    [sym_decl_foreign_import] = STATE(18386),
    [sym_decl_foreign_export] = STATE(18386),
    [sym__decl_foreign] = STATE(18386),
    [sym_decl_special] = STATE(18386),
    [sym_decl_pattern] = STATE(18386),
    [sym_decl_default] = STATE(18386),
    [sym_splice] = STATE(5230),
    [sym_top_splice] = STATE(18386),
    [sym_quasiquote] = STATE(5230),
    [ts_builtin_sym_end] = ACTIONS(235),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_instance] = ACTIONS(33),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [sym_decl_special_fun_fixity] = ACTIONS(69),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [12] = {
    [sym__topdecl] = STATE(16472),
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(3738),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4187),
    [sym_qualified_constructor] = STATE(4258),
    [sym__qcon] = STATE(4304),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(4876),
    [sym_decl_type] = STATE(16472),
    [sym_decl_tyfam] = STATE(16472),
    [sym_decl_tyinst] = STATE(16472),
    [sym_decl_role] = STATE(16472),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10705),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10705),
    [sym_exp_cond] = STATE(10705),
    [sym_exp_if_guard] = STATE(10705),
    [sym_exp_case] = STATE(10705),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10705),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10705),
    [sym__lexp] = STATE(10705),
    [sym_exp_infix] = STATE(10705),
    [sym__exp_infix] = STATE(10705),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym_decl_import] = STATE(16472),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14102),
    [sym_decl_adt] = STATE(16472),
    [sym_decl_newtype] = STATE(16472),
    [sym_decl_datafam] = STATE(16472),
    [sym_decl_datainst] = STATE(16472),
    [sym_decl_class] = STATE(16472),
    [sym__instance] = STATE(17053),
    [sym_decl_instance] = STATE(16472),
    [sym_decl_deriving] = STATE(16472),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16472),
    [sym_fixity] = STATE(16472),
    [sym_signature] = STATE(16472),
    [sym__gendecl] = STATE(16472),
    [sym__decl_fun] = STATE(16472),
    [sym__decl] = STATE(16472),
    [sym_decl_foreign_import] = STATE(16472),
    [sym_decl_foreign_export] = STATE(16472),
    [sym__decl_foreign] = STATE(16472),
    [sym_decl_special] = STATE(16472),
    [sym_decl_pattern] = STATE(16472),
    [sym_decl_default] = STATE(16472),
    [sym_splice] = STATE(4875),
    [sym_top_splice] = STATE(16472),
    [sym_quasiquote] = STATE(4875),
    [sym__varid] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(173),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(173),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [sym_implicit_parid] = ACTIONS(181),
    [sym__conid] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_type] = ACTIONS(191),
    [anon_sym_instance] = ACTIONS(193),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_pattern] = ACTIONS(205),
    [anon_sym_import] = ACTIONS(207),
    [anon_sym_newtype] = ACTIONS(209),
    [anon_sym_deriving] = ACTIONS(211),
    [anon_sym_data] = ACTIONS(213),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(217),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_foreign] = ACTIONS(221),
    [sym_decl_special_fun_fixity] = ACTIONS(223),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(109),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [13] = {
    [sym__topdecl] = STATE(18172),
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(3738),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4187),
    [sym_qualified_constructor] = STATE(4258),
    [sym__qcon] = STATE(4304),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(4876),
    [sym_decl_type] = STATE(18172),
    [sym_decl_tyfam] = STATE(18172),
    [sym_decl_tyinst] = STATE(18172),
    [sym_decl_role] = STATE(18172),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10705),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10705),
    [sym_exp_cond] = STATE(10705),
    [sym_exp_if_guard] = STATE(10705),
    [sym_exp_case] = STATE(10705),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10705),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10705),
    [sym__lexp] = STATE(10705),
    [sym_exp_infix] = STATE(10705),
    [sym__exp_infix] = STATE(10705),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym_decl_import] = STATE(18172),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14102),
    [sym_decl_adt] = STATE(18172),
    [sym_decl_newtype] = STATE(18172),
    [sym_decl_datafam] = STATE(18172),
    [sym_decl_datainst] = STATE(18172),
    [sym_decl_class] = STATE(18172),
    [sym__instance] = STATE(17053),
    [sym_decl_instance] = STATE(18172),
    [sym_decl_deriving] = STATE(18172),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(18172),
    [sym_fixity] = STATE(18172),
    [sym_signature] = STATE(18172),
    [sym__gendecl] = STATE(18172),
    [sym__decl_fun] = STATE(18172),
    [sym__decl] = STATE(18172),
    [sym_decl_foreign_import] = STATE(18172),
    [sym_decl_foreign_export] = STATE(18172),
    [sym__decl_foreign] = STATE(18172),
    [sym_decl_special] = STATE(18172),
    [sym_decl_pattern] = STATE(18172),
    [sym_decl_default] = STATE(18172),
    [sym_splice] = STATE(4875),
    [sym_top_splice] = STATE(18172),
    [sym_quasiquote] = STATE(4875),
    [sym__varid] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(173),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(173),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [sym_implicit_parid] = ACTIONS(181),
    [sym__conid] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_type] = ACTIONS(191),
    [anon_sym_instance] = ACTIONS(193),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_pattern] = ACTIONS(205),
    [anon_sym_import] = ACTIONS(207),
    [anon_sym_newtype] = ACTIONS(209),
    [anon_sym_deriving] = ACTIONS(211),
    [anon_sym_data] = ACTIONS(213),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(217),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_foreign] = ACTIONS(221),
    [sym_decl_special_fun_fixity] = ACTIONS(223),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(237),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [14] = {
    [sym__topdecl] = STATE(18386),
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3743),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(4147),
    [sym_qualified_constructor] = STATE(4265),
    [sym__qcon] = STATE(4269),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5240),
    [sym_decl_type] = STATE(18386),
    [sym_decl_tyfam] = STATE(18386),
    [sym_decl_tyinst] = STATE(18386),
    [sym_decl_role] = STATE(18386),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10719),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10719),
    [sym_exp_cond] = STATE(10719),
    [sym_exp_if_guard] = STATE(10719),
    [sym_exp_case] = STATE(10719),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10719),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10719),
    [sym__lexp] = STATE(10719),
    [sym_exp_infix] = STATE(10719),
    [sym__exp_infix] = STATE(10719),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(14983),
    [sym__typed_pat] = STATE(14983),
    [sym_decl_import] = STATE(18386),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14101),
    [sym_decl_adt] = STATE(18386),
    [sym_decl_newtype] = STATE(18386),
    [sym_decl_datafam] = STATE(18386),
    [sym_decl_datainst] = STATE(18386),
    [sym_decl_class] = STATE(18386),
    [sym__instance] = STATE(17460),
    [sym_decl_instance] = STATE(18386),
    [sym_decl_deriving] = STATE(18386),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(17887),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(14971),
    [sym_function] = STATE(18386),
    [sym_fixity] = STATE(18386),
    [sym_signature] = STATE(18386),
    [sym__gendecl] = STATE(18386),
    [sym__decl_fun] = STATE(18386),
    [sym__decl] = STATE(18386),
    [sym_decl_foreign_import] = STATE(18386),
    [sym_decl_foreign_export] = STATE(18386),
    [sym__decl_foreign] = STATE(18386),
    [sym_decl_special] = STATE(18386),
    [sym_decl_pattern] = STATE(18386),
    [sym_decl_default] = STATE(18386),
    [sym_splice] = STATE(5230),
    [sym_top_splice] = STATE(18386),
    [sym_quasiquote] = STATE(5230),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_instance] = ACTIONS(33),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [sym_decl_special_fun_fixity] = ACTIONS(69),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [15] = {
    [sym__topdecl] = STATE(18172),
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(3738),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4187),
    [sym_qualified_constructor] = STATE(4258),
    [sym__qcon] = STATE(4304),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(4876),
    [sym_decl_type] = STATE(18172),
    [sym_decl_tyfam] = STATE(18172),
    [sym_decl_tyinst] = STATE(18172),
    [sym_decl_role] = STATE(18172),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10705),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10705),
    [sym_exp_cond] = STATE(10705),
    [sym_exp_if_guard] = STATE(10705),
    [sym_exp_case] = STATE(10705),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10705),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10705),
    [sym__lexp] = STATE(10705),
    [sym_exp_infix] = STATE(10705),
    [sym__exp_infix] = STATE(10705),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym_decl_import] = STATE(18172),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14102),
    [sym_decl_adt] = STATE(18172),
    [sym_decl_newtype] = STATE(18172),
    [sym_decl_datafam] = STATE(18172),
    [sym_decl_datainst] = STATE(18172),
    [sym_decl_class] = STATE(18172),
    [sym__instance] = STATE(17053),
    [sym_decl_instance] = STATE(18172),
    [sym_decl_deriving] = STATE(18172),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(18172),
    [sym_fixity] = STATE(18172),
    [sym_signature] = STATE(18172),
    [sym__gendecl] = STATE(18172),
    [sym__decl_fun] = STATE(18172),
    [sym__decl] = STATE(18172),
    [sym_decl_foreign_import] = STATE(18172),
    [sym_decl_foreign_export] = STATE(18172),
    [sym__decl_foreign] = STATE(18172),
    [sym_decl_special] = STATE(18172),
    [sym_decl_pattern] = STATE(18172),
    [sym_decl_default] = STATE(18172),
    [sym_splice] = STATE(4875),
    [sym_top_splice] = STATE(18172),
    [sym_quasiquote] = STATE(4875),
    [sym__varid] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(173),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(173),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [sym_implicit_parid] = ACTIONS(181),
    [sym__conid] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(185),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_type] = ACTIONS(191),
    [anon_sym_instance] = ACTIONS(193),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_pattern] = ACTIONS(205),
    [anon_sym_import] = ACTIONS(207),
    [anon_sym_newtype] = ACTIONS(209),
    [anon_sym_deriving] = ACTIONS(211),
    [anon_sym_data] = ACTIONS(213),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(217),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_foreign] = ACTIONS(221),
    [sym_decl_special_fun_fixity] = ACTIONS(223),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [16] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8417),
    [sym__minus] = STATE(23177),
    [sym_qualified_operator] = STATE(8474),
    [sym__qvarop_nominus] = STATE(1745),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1473),
    [sym_qualified_constructor_operator] = STATE(1473),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23171),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10094),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10094),
    [sym_exp_cond] = STATE(10094),
    [sym_exp_if_guard] = STATE(10094),
    [sym_exp_case] = STATE(10094),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10094),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10094),
    [sym__lexp] = STATE(10094),
    [sym_exp_infix] = STATE(10094),
    [sym__exp_infix] = STATE(10094),
    [sym__exp] = STATE(16117),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(877),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(257),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(289),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [17] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8372),
    [sym__minus] = STATE(22117),
    [sym_qualified_operator] = STATE(8435),
    [sym__qvarop_nominus] = STATE(1737),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1400),
    [sym_qualified_constructor_operator] = STATE(1400),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22018),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10204),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10204),
    [sym_exp_cond] = STATE(10204),
    [sym_exp_if_guard] = STATE(10204),
    [sym_exp_case] = STATE(10204),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10204),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10204),
    [sym__lexp] = STATE(10204),
    [sym_exp_infix] = STATE(10204),
    [sym__exp_infix] = STATE(10204),
    [sym__exp] = STATE(16136),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18209),
    [sym__typed_pat] = STATE(18209),
    [sym_pat_view] = STATE(18209),
    [sym__nested_pat] = STATE(18209),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(901),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(303),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [18] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8399),
    [sym__minus] = STATE(22352),
    [sym_qualified_operator] = STATE(8400),
    [sym__qvarop_nominus] = STATE(1675),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1549),
    [sym_qualified_constructor_operator] = STATE(1549),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22378),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10187),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10187),
    [sym_exp_cond] = STATE(10187),
    [sym_exp_if_guard] = STATE(10187),
    [sym_exp_case] = STATE(10187),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10187),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10187),
    [sym__lexp] = STATE(10187),
    [sym_exp_infix] = STATE(10187),
    [sym__exp_infix] = STATE(10187),
    [sym__exp] = STATE(15959),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(914),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_BQUOTE] = ACTIONS(307),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(311),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [19] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8386),
    [sym__minus] = STATE(21709),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1332),
    [sym_qualified_constructor_operator] = STATE(1332),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(15786),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19715),
    [sym__typed_pat] = STATE(19715),
    [sym_pat_view] = STATE(19715),
    [sym__nested_pat] = STATE(19715),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(892),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(319),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [20] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8412),
    [sym__minus] = STATE(23405),
    [sym_qualified_operator] = STATE(8418),
    [sym__qvarop_nominus] = STATE(1756),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1408),
    [sym_qualified_constructor_operator] = STATE(1408),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23289),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10090),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10090),
    [sym_exp_cond] = STATE(10090),
    [sym_exp_if_guard] = STATE(10090),
    [sym_exp_case] = STATE(10090),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10090),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10090),
    [sym__lexp] = STATE(10090),
    [sym_exp_infix] = STATE(10090),
    [sym__exp_infix] = STATE(10090),
    [sym__exp] = STATE(15922),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18693),
    [sym__typed_pat] = STATE(18693),
    [sym_pat_view] = STATE(18693),
    [sym__nested_pat] = STATE(18693),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(864),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(327),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [21] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8411),
    [sym__minus] = STATE(23261),
    [sym_qualified_operator] = STATE(8383),
    [sym__qvarop_nominus] = STATE(1702),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1465),
    [sym_qualified_constructor_operator] = STATE(1465),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23047),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10007),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10007),
    [sym_exp_cond] = STATE(10007),
    [sym_exp_if_guard] = STATE(10007),
    [sym_exp_case] = STATE(10007),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10007),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10007),
    [sym__lexp] = STATE(10007),
    [sym_exp_infix] = STATE(10007),
    [sym__exp_infix] = STATE(10007),
    [sym__exp] = STATE(15755),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(874),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [22] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8457),
    [sym__minus] = STATE(21487),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1640),
    [sym_qualified_constructor_operator] = STATE(1640),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(15786),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18693),
    [sym__typed_pat] = STATE(18693),
    [sym_pat_view] = STATE(18693),
    [sym__nested_pat] = STATE(18693),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(864),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(327),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [23] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8419),
    [sym__minus] = STATE(23389),
    [sym_qualified_operator] = STATE(8326),
    [sym__qvarop_nominus] = STATE(1744),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1427),
    [sym_qualified_constructor_operator] = STATE(1427),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21545),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10195),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10195),
    [sym_exp_cond] = STATE(10195),
    [sym_exp_if_guard] = STATE(10195),
    [sym_exp_case] = STATE(10195),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10195),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10195),
    [sym__lexp] = STATE(10195),
    [sym_exp_infix] = STATE(10195),
    [sym__exp_infix] = STATE(10195),
    [sym__exp] = STATE(16245),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(878),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(341),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(343),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [24] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8430),
    [sym__minus] = STATE(21903),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1530),
    [sym_qualified_constructor_operator] = STATE(1530),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(15786),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18209),
    [sym__typed_pat] = STATE(18209),
    [sym_pat_view] = STATE(18209),
    [sym__nested_pat] = STATE(18209),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(901),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(303),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [25] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8476),
    [sym__minus] = STATE(21416),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1535),
    [sym_qualified_constructor_operator] = STATE(1535),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(15786),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(890),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(347),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [26] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8441),
    [sym__minus] = STATE(22854),
    [sym_qualified_operator] = STATE(8415),
    [sym__qvarop_nominus] = STATE(1676),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1325),
    [sym_qualified_constructor_operator] = STATE(1325),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23388),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9942),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9942),
    [sym_exp_cond] = STATE(9942),
    [sym_exp_if_guard] = STATE(9942),
    [sym_exp_case] = STATE(9942),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9942),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9942),
    [sym__lexp] = STATE(9942),
    [sym_exp_infix] = STATE(9942),
    [sym__exp_infix] = STATE(9942),
    [sym__exp] = STATE(16020),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(912),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(353),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(355),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [27] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8331),
    [sym__minus] = STATE(22818),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1446),
    [sym_qualified_constructor_operator] = STATE(1446),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(15664),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19715),
    [sym__typed_pat] = STATE(19715),
    [sym_pat_view] = STATE(19715),
    [sym__nested_pat] = STATE(19715),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(876),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(357),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(363),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [28] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8360),
    [sym__minus] = STATE(21733),
    [sym_qualified_operator] = STATE(8326),
    [sym__qvarop_nominus] = STATE(1744),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1444),
    [sym_qualified_constructor_operator] = STATE(1444),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21545),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10195),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10195),
    [sym_exp_cond] = STATE(10195),
    [sym_exp_if_guard] = STATE(10195),
    [sym_exp_case] = STATE(10195),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10195),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10195),
    [sym__lexp] = STATE(10195),
    [sym_exp_infix] = STATE(10195),
    [sym__exp_infix] = STATE(10195),
    [sym__exp] = STATE(16245),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(884),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(341),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(367),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [29] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8317),
    [sym__minus] = STATE(21484),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1654),
    [sym_qualified_constructor_operator] = STATE(1654),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(15664),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(909),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [30] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8380),
    [sym__minus] = STATE(22999),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1382),
    [sym_qualified_constructor_operator] = STATE(1382),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(15664),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(870),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(373),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [31] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8451),
    [sym__minus] = STATE(22572),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1479),
    [sym_qualified_constructor_operator] = STATE(1479),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(15664),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18209),
    [sym__typed_pat] = STATE(18209),
    [sym_pat_view] = STATE(18209),
    [sym__nested_pat] = STATE(18209),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(889),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [32] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8406),
    [sym__minus] = STATE(23011),
    [sym_qualified_operator] = STATE(8445),
    [sym__qvarop_nominus] = STATE(1708),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1419),
    [sym_qualified_constructor_operator] = STATE(1419),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22855),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10055),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10055),
    [sym_exp_cond] = STATE(10055),
    [sym_exp_if_guard] = STATE(10055),
    [sym_exp_case] = STATE(10055),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10055),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10055),
    [sym__lexp] = STATE(10055),
    [sym_exp_infix] = STATE(10055),
    [sym__exp_infix] = STATE(10055),
    [sym__exp] = STATE(16099),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(891),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(381),
    [anon_sym_BQUOTE] = ACTIONS(383),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [33] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8361),
    [sym__minus] = STATE(21879),
    [sym_qualified_operator] = STATE(8346),
    [sym__qvarop_nominus] = STATE(1753),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1475),
    [sym_qualified_constructor_operator] = STATE(1475),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23120),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10069),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10069),
    [sym_exp_cond] = STATE(10069),
    [sym_exp_if_guard] = STATE(10069),
    [sym_exp_case] = STATE(10069),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10069),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10069),
    [sym__lexp] = STATE(10069),
    [sym_exp_infix] = STATE(10069),
    [sym__exp_infix] = STATE(10069),
    [sym__exp] = STATE(16141),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(887),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(393),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [34] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8389),
    [sym__minus] = STATE(22689),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1555),
    [sym_qualified_constructor_operator] = STATE(1555),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(15664),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(874),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [35] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8391),
    [sym__minus] = STATE(22459),
    [sym_qualified_operator] = STATE(8421),
    [sym__qvarop_nominus] = STATE(1720),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1667),
    [sym_qualified_constructor_operator] = STATE(1667),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22489),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10178),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10178),
    [sym_exp_cond] = STATE(10178),
    [sym_exp_if_guard] = STATE(10178),
    [sym_exp_case] = STATE(10178),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10178),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10178),
    [sym__lexp] = STATE(10178),
    [sym_exp_infix] = STATE(10178),
    [sym__exp_infix] = STATE(10178),
    [sym__exp] = STATE(15773),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(890),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(397),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(347),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [36] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8353),
    [sym__minus] = STATE(22086),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1482),
    [sym_qualified_constructor_operator] = STATE(1482),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(15786),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(879),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [37] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8394),
    [sym__minus] = STATE(21923),
    [sym_qualified_operator] = STATE(8346),
    [sym__qvarop_nominus] = STATE(1753),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1507),
    [sym_qualified_constructor_operator] = STATE(1507),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23120),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10069),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10069),
    [sym_exp_cond] = STATE(10069),
    [sym_exp_if_guard] = STATE(10069),
    [sym_exp_case] = STATE(10069),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10069),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10069),
    [sym__lexp] = STATE(10069),
    [sym_exp_infix] = STATE(10069),
    [sym__exp_infix] = STATE(10069),
    [sym__exp] = STATE(16141),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(906),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(393),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [38] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8396),
    [sym__minus] = STATE(22816),
    [sym_qualified_operator] = STATE(8421),
    [sym__qvarop_nominus] = STATE(1720),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1667),
    [sym_qualified_constructor_operator] = STATE(1667),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22489),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10178),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10178),
    [sym_exp_cond] = STATE(10178),
    [sym_exp_if_guard] = STATE(10178),
    [sym_exp_case] = STATE(10178),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10178),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10178),
    [sym__lexp] = STATE(10178),
    [sym_exp_infix] = STATE(10178),
    [sym__exp_infix] = STATE(10178),
    [sym__exp] = STATE(15773),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(890),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(397),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(347),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [39] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8484),
    [sym__minus] = STATE(21960),
    [sym_qualified_operator] = STATE(8366),
    [sym__qvarop_nominus] = STATE(1741),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1354),
    [sym_qualified_constructor_operator] = STATE(1354),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21794),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10202),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10202),
    [sym_exp_cond] = STATE(10202),
    [sym_exp_if_guard] = STATE(10202),
    [sym_exp_case] = STATE(10202),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10202),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10202),
    [sym__lexp] = STATE(10202),
    [sym_exp_infix] = STATE(10202),
    [sym__exp_infix] = STATE(10202),
    [sym__exp] = STATE(15831),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18693),
    [sym__typed_pat] = STATE(18693),
    [sym_pat_view] = STATE(18693),
    [sym__nested_pat] = STATE(18693),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(894),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [40] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8471),
    [sym__minus] = STATE(22377),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1432),
    [sym_qualified_constructor_operator] = STATE(1432),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(15664),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18693),
    [sym__typed_pat] = STATE(18693),
    [sym_pat_view] = STATE(18693),
    [sym__nested_pat] = STATE(18693),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(894),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [41] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8472),
    [sym__minus] = STATE(21333),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1323),
    [sym_qualified_constructor_operator] = STATE(1323),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(15786),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(915),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [42] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8425),
    [sym__minus] = STATE(22825),
    [sym_qualified_operator] = STATE(8449),
    [sym__qvarop_nominus] = STATE(1714),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1451),
    [sym_qualified_constructor_operator] = STATE(1451),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22601),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10172),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10172),
    [sym_exp_cond] = STATE(10172),
    [sym_exp_if_guard] = STATE(10172),
    [sym_exp_case] = STATE(10172),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10172),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10172),
    [sym__lexp] = STATE(10172),
    [sym_exp_infix] = STATE(10172),
    [sym__exp_infix] = STATE(10172),
    [sym__exp] = STATE(16052),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18209),
    [sym__typed_pat] = STATE(18209),
    [sym_pat_view] = STATE(18209),
    [sym__nested_pat] = STATE(18209),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(889),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(421),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [43] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4873),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8322),
    [sym__minus] = STATE(22239),
    [sym_qualified_operator] = STATE(8383),
    [sym__qvarop_nominus] = STATE(1702),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(1465),
    [sym_qualified_constructor_operator] = STATE(1465),
    [sym__qcon] = STATE(4373),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(5538),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23047),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10007),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10007),
    [sym_exp_cond] = STATE(10007),
    [sym_exp_if_guard] = STATE(10007),
    [sym_exp_case] = STATE(10007),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10007),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10007),
    [sym__lexp] = STATE(10007),
    [sym_exp_infix] = STATE(10007),
    [sym__exp_infix] = STATE(10007),
    [sym__exp] = STATE(15755),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11236),
    [sym_splice] = STATE(5536),
    [sym_quasiquote] = STATE(5536),
    [aux_sym_con_tuple_repeat1] = STATE(874),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(247),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(247),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [44] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21964),
    [sym__minus] = STATE(21964),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22202),
    [sym_qualified_constructor_operator] = STATE(22202),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18989),
    [sym__typed_pat] = STATE(18989),
    [sym_pat_view] = STATE(18989),
    [sym__nested_pat] = STATE(18989),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18372),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(431),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [45] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22827),
    [sym__minus] = STATE(22827),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18294),
    [sym__typed_pat] = STATE(18294),
    [sym_pat_view] = STATE(18294),
    [sym__nested_pat] = STATE(18294),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18403),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [46] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22152),
    [sym__minus] = STATE(22152),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [47] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22354),
    [sym__minus] = STATE(22354),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22701),
    [sym_qualified_constructor_operator] = STATE(22701),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18584),
    [sym__typed_pat] = STATE(18584),
    [sym_pat_view] = STATE(18584),
    [sym__nested_pat] = STATE(18584),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19612),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(449),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(451),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [48] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21410),
    [sym__minus] = STATE(21410),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22961),
    [sym_qualified_constructor_operator] = STATE(22961),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18693),
    [sym__typed_pat] = STATE(18693),
    [sym_pat_view] = STATE(18693),
    [sym__nested_pat] = STATE(18693),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18900),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(453),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(455),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [49] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22873),
    [sym__minus] = STATE(22873),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [50] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22937),
    [sym__minus] = STATE(22937),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21905),
    [sym_qualified_constructor_operator] = STATE(21905),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20098),
    [sym__typed_pat] = STATE(20098),
    [sym_pat_view] = STATE(20098),
    [sym__nested_pat] = STATE(20098),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(17948),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [51] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22576),
    [sym__minus] = STATE(22576),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21755),
    [sym_qualified_constructor_operator] = STATE(21755),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18846),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [52] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23014),
    [sym__minus] = STATE(23014),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22329),
    [sym_qualified_constructor_operator] = STATE(22329),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [53] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22241),
    [sym__minus] = STATE(22241),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(23372),
    [sym_qualified_constructor_operator] = STATE(23372),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18209),
    [sym__typed_pat] = STATE(18209),
    [sym_pat_view] = STATE(18209),
    [sym__nested_pat] = STATE(18209),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19069),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(469),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [54] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21488),
    [sym__minus] = STATE(21488),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22659),
    [sym_qualified_constructor_operator] = STATE(22659),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19361),
    [sym__typed_pat] = STATE(19361),
    [sym_pat_view] = STATE(19361),
    [sym__nested_pat] = STATE(19361),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18186),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(471),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(473),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [55] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22367),
    [sym__minus] = STATE(22367),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21998),
    [sym_qualified_constructor_operator] = STATE(21998),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19887),
    [sym__typed_pat] = STATE(19887),
    [sym_pat_view] = STATE(19887),
    [sym__nested_pat] = STATE(19887),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19371),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(475),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(477),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [56] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22241),
    [sym__minus] = STATE(22241),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22876),
    [sym_qualified_constructor_operator] = STATE(22876),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18209),
    [sym__typed_pat] = STATE(18209),
    [sym_pat_view] = STATE(18209),
    [sym__nested_pat] = STATE(18209),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19069),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(469),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [57] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21486),
    [sym__minus] = STATE(21486),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21905),
    [sym_qualified_constructor_operator] = STATE(21905),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19248),
    [sym__typed_pat] = STATE(19248),
    [sym_pat_view] = STATE(19248),
    [sym__nested_pat] = STATE(19248),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(17840),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(479),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(481),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [58] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23281),
    [sym__minus] = STATE(23281),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22832),
    [sym_qualified_constructor_operator] = STATE(22832),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18010),
    [sym__typed_pat] = STATE(18010),
    [sym_pat_view] = STATE(18010),
    [sym__nested_pat] = STATE(18010),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18225),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(483),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(485),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [59] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21735),
    [sym__minus] = STATE(21735),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21536),
    [sym_qualified_constructor_operator] = STATE(21536),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19173),
    [sym__typed_pat] = STATE(19173),
    [sym_pat_view] = STATE(19173),
    [sym__nested_pat] = STATE(19173),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18067),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(487),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(489),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [60] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21488),
    [sym__minus] = STATE(21488),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21607),
    [sym_qualified_constructor_operator] = STATE(21607),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19361),
    [sym__typed_pat] = STATE(19361),
    [sym_pat_view] = STATE(19361),
    [sym__nested_pat] = STATE(19361),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18186),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(471),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(473),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [61] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23014),
    [sym__minus] = STATE(23014),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22596),
    [sym_qualified_constructor_operator] = STATE(22701),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [62] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22774),
    [sym__minus] = STATE(22774),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22493),
    [sym_qualified_constructor_operator] = STATE(22493),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20019),
    [sym__typed_pat] = STATE(20019),
    [sym_pat_view] = STATE(20019),
    [sym__nested_pat] = STATE(20019),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19623),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(491),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(493),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [63] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22120),
    [sym__minus] = STATE(22120),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22876),
    [sym_qualified_constructor_operator] = STATE(22876),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18809),
    [sym__typed_pat] = STATE(18809),
    [sym_pat_view] = STATE(18809),
    [sym__nested_pat] = STATE(18809),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18762),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(495),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(497),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [64] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21735),
    [sym__minus] = STATE(21735),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22493),
    [sym_qualified_constructor_operator] = STATE(22493),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19173),
    [sym__typed_pat] = STATE(19173),
    [sym_pat_view] = STATE(19173),
    [sym__nested_pat] = STATE(19173),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18067),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(487),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(489),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [65] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22462),
    [sym__minus] = STATE(22462),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21755),
    [sym_qualified_constructor_operator] = STATE(21755),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18487),
    [sym__typed_pat] = STATE(18487),
    [sym_pat_view] = STATE(18487),
    [sym__nested_pat] = STATE(18487),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19218),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(499),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(501),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [66] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23140),
    [sym__minus] = STATE(23140),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21905),
    [sym_qualified_constructor_operator] = STATE(21905),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20098),
    [sym__typed_pat] = STATE(20098),
    [sym_pat_view] = STATE(20098),
    [sym__nested_pat] = STATE(20098),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(17948),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [67] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21410),
    [sym__minus] = STATE(21410),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22767),
    [sym_qualified_constructor_operator] = STATE(22767),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18693),
    [sym__typed_pat] = STATE(18693),
    [sym_pat_view] = STATE(18693),
    [sym__nested_pat] = STATE(18693),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18900),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(453),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(455),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [68] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22859),
    [sym__minus] = STATE(22859),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22199),
    [sym_qualified_constructor_operator] = STATE(22199),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19715),
    [sym__typed_pat] = STATE(19715),
    [sym_pat_view] = STATE(19715),
    [sym__nested_pat] = STATE(19715),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19803),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(503),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(505),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [69] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21896),
    [sym__minus] = STATE(21896),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22767),
    [sym_qualified_constructor_operator] = STATE(22767),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19557),
    [sym__typed_pat] = STATE(19557),
    [sym_pat_view] = STATE(19557),
    [sym__nested_pat] = STATE(19557),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19138),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(507),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(509),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [70] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23402),
    [sym__minus] = STATE(23402),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22659),
    [sym_qualified_constructor_operator] = STATE(22659),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19600),
    [sym__typed_pat] = STATE(19600),
    [sym_pat_view] = STATE(19600),
    [sym__nested_pat] = STATE(19600),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19653),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(511),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(513),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [71] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21361),
    [sym__minus] = STATE(21361),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21905),
    [sym_qualified_constructor_operator] = STATE(21905),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20098),
    [sym__typed_pat] = STATE(20098),
    [sym_pat_view] = STATE(20098),
    [sym__nested_pat] = STATE(20098),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(17948),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [72] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21704),
    [sym__minus] = STATE(21704),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21408),
    [sym_qualified_constructor_operator] = STATE(21408),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19098),
    [sym__typed_pat] = STATE(19098),
    [sym_pat_view] = STATE(19098),
    [sym__nested_pat] = STATE(19098),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19404),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(515),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(517),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [73] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22873),
    [sym__minus] = STATE(22873),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(23323),
    [sym_qualified_constructor_operator] = STATE(23323),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [74] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22509),
    [sym__minus] = STATE(22509),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21680),
    [sym_qualified_constructor_operator] = STATE(21680),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18395),
    [sym__typed_pat] = STATE(18395),
    [sym_pat_view] = STATE(18395),
    [sym__nested_pat] = STATE(18395),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19056),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(519),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(521),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [75] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22350),
    [sym__minus] = STATE(22350),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21942),
    [sym_qualified_constructor_operator] = STATE(21942),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18547),
    [sym__typed_pat] = STATE(18547),
    [sym_pat_view] = STATE(18547),
    [sym__nested_pat] = STATE(18547),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19080),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(523),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(525),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [76] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21704),
    [sym__minus] = STATE(21704),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21991),
    [sym_qualified_constructor_operator] = STATE(21991),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19098),
    [sym__typed_pat] = STATE(19098),
    [sym_pat_view] = STATE(19098),
    [sym__nested_pat] = STATE(19098),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19404),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(515),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(517),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [77] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21878),
    [sym__minus] = STATE(21878),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21436),
    [sym_qualified_constructor_operator] = STATE(21436),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18962),
    [sym__typed_pat] = STATE(18962),
    [sym_pat_view] = STATE(18962),
    [sym__nested_pat] = STATE(18962),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19381),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(527),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [78] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21361),
    [sym__minus] = STATE(21361),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22345),
    [sym_qualified_constructor_operator] = STATE(22345),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20098),
    [sym__typed_pat] = STATE(20098),
    [sym_pat_view] = STATE(20098),
    [sym__nested_pat] = STATE(20098),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(17948),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [79] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22859),
    [sym__minus] = STATE(22859),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22105),
    [sym_qualified_constructor_operator] = STATE(22105),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19715),
    [sym__typed_pat] = STATE(19715),
    [sym_pat_view] = STATE(19715),
    [sym__nested_pat] = STATE(19715),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19803),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(503),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(505),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [80] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22576),
    [sym__minus] = STATE(22576),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21987),
    [sym_qualified_constructor_operator] = STATE(21987),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17858),
    [sym__typed_pat] = STATE(17858),
    [sym_pat_view] = STATE(17858),
    [sym__nested_pat] = STATE(17858),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18846),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [81] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22085),
    [sym__minus] = STATE(22085),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21520),
    [sym_qualified_constructor_operator] = STATE(21520),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18825),
    [sym__typed_pat] = STATE(18825),
    [sym_pat_view] = STATE(18825),
    [sym__nested_pat] = STATE(18825),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19324),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(531),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(533),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [82] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22258),
    [sym__minus] = STATE(22258),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [83] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21964),
    [sym__minus] = STATE(21964),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21998),
    [sym_qualified_constructor_operator] = STATE(21998),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18989),
    [sym__typed_pat] = STATE(18989),
    [sym_pat_view] = STATE(18989),
    [sym__nested_pat] = STATE(18989),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18372),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(431),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [84] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23014),
    [sym__minus] = STATE(23014),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22701),
    [sym_qualified_constructor_operator] = STATE(22701),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [85] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22216),
    [sym__minus] = STATE(22216),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [86] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21878),
    [sym__minus] = STATE(21878),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21942),
    [sym_qualified_constructor_operator] = STATE(21942),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18962),
    [sym__typed_pat] = STATE(18962),
    [sym_pat_view] = STATE(18962),
    [sym__nested_pat] = STATE(18962),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19381),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(527),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [87] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23014),
    [sym__minus] = STATE(23014),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22209),
    [sym_qualified_constructor_operator] = STATE(22701),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [88] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22129),
    [sym__minus] = STATE(22129),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17913),
    [sym__typed_pat] = STATE(17913),
    [sym_pat_view] = STATE(17913),
    [sym__nested_pat] = STATE(17913),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [89] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22696),
    [sym__minus] = STATE(22696),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22467),
    [sym_qualified_constructor_operator] = STATE(22467),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18379),
    [sym__typed_pat] = STATE(18379),
    [sym_pat_view] = STATE(18379),
    [sym__nested_pat] = STATE(18379),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18500),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(535),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(537),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [90] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23014),
    [sym__minus] = STATE(23014),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22121),
    [sym_qualified_constructor_operator] = STATE(22701),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18131),
    [sym__typed_pat] = STATE(18131),
    [sym_pat_view] = STATE(18131),
    [sym__nested_pat] = STATE(18131),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [91] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22231),
    [sym__minus] = STATE(22231),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21991),
    [sym_qualified_constructor_operator] = STATE(21991),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18682),
    [sym__typed_pat] = STATE(18682),
    [sym_pat_view] = STATE(18682),
    [sym__nested_pat] = STATE(18682),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19099),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(539),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(541),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [92] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21933),
    [sym__minus] = STATE(21933),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(22199),
    [sym_qualified_constructor_operator] = STATE(22199),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19427),
    [sym__typed_pat] = STATE(19427),
    [sym_pat_view] = STATE(19427),
    [sym__nested_pat] = STATE(19427),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19833),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(543),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [93] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22085),
    [sym__minus] = STATE(22085),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym_constructor_operator] = STATE(21680),
    [sym_qualified_constructor_operator] = STATE(21680),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18825),
    [sym__typed_pat] = STATE(18825),
    [sym_pat_view] = STATE(18825),
    [sym__nested_pat] = STATE(18825),
    [sym__modid] = STATE(23053),
    [aux_sym__qualifying_module] = STATE(13346),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [aux_sym_con_tuple_repeat1] = STATE(19324),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(531),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(533),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [94] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14291),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(597),
  },
  [95] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22967),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14169),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(19848),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(599),
  },
  [96] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14291),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22287),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15837),
    [sym__typed_pat] = STATE(15837),
    [sym_pat_view] = STATE(15837),
    [sym__nested_pat] = STATE(15837),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(601),
  },
  [97] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22589),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14218),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22709),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16017),
    [sym__typed_pat] = STATE(16017),
    [sym_pat_view] = STATE(16017),
    [sym__nested_pat] = STATE(16017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18303),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(603),
  },
  [98] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21766),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14385),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22144),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15684),
    [sym__typed_pat] = STATE(15684),
    [sym_pat_view] = STATE(15684),
    [sym__nested_pat] = STATE(15684),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(19017),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(605),
  },
  [99] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22012),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14211),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22709),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16017),
    [sym__typed_pat] = STATE(16017),
    [sym_pat_view] = STATE(16017),
    [sym__nested_pat] = STATE(16017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18830),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(607),
  },
  [100] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22967),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14169),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(19848),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(609),
  },
  [101] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21531),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14532),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(19200),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(611),
  },
  [102] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23032),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14492),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18021),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(613),
  },
  [103] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14423),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(615),
  },
  [104] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14291),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(617),
  },
  [105] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22370),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14249),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18495),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(619),
  },
  [106] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14423),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(621),
  },
  [107] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22982),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14403),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18053),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(623),
  },
  [108] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14423),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22144),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15684),
    [sym__typed_pat] = STATE(15684),
    [sym_pat_view] = STATE(15684),
    [sym__nested_pat] = STATE(15684),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(625),
  },
  [109] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22478),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14534),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18387),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(627),
  },
  [110] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14423),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22709),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16017),
    [sym__typed_pat] = STATE(16017),
    [sym_pat_view] = STATE(16017),
    [sym__nested_pat] = STATE(16017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(629),
  },
  [111] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22840),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14307),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18141),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(631),
  },
  [112] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21531),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14532),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(19200),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(633),
  },
  [113] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14291),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22709),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16017),
    [sym__typed_pat] = STATE(16017),
    [sym_pat_view] = STATE(16017),
    [sym__nested_pat] = STATE(16017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(635),
  },
  [114] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14291),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22144),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15684),
    [sym__typed_pat] = STATE(15684),
    [sym_pat_view] = STATE(15684),
    [sym__nested_pat] = STATE(15684),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(637),
  },
  [115] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14291),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(639),
  },
  [116] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23356),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14530),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(17881),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(641),
  },
  [117] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22478),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14534),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18387),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(643),
  },
  [118] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14423),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22287),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15837),
    [sym__typed_pat] = STATE(15837),
    [sym_pat_view] = STATE(15837),
    [sym__nested_pat] = STATE(15837),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(645),
  },
  [119] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14423),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(647),
  },
  [120] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23032),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14492),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(18021),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(649),
  },
  [121] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(4505),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4346),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(5067),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23360),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(14314),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22144),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15684),
    [sym__typed_pat] = STATE(15684),
    [sym_pat_view] = STATE(15684),
    [sym__nested_pat] = STATE(15684),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14027),
    [sym_splice] = STATE(5062),
    [sym_quasiquote] = STATE(5062),
    [aux_sym__exp_tuple_repeat1] = STATE(20122),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(555),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(555),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(561),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(651),
  },
  [122] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16938),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(655),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [123] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(20249),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [aux_sym_decl_tyfam_repeat1] = STATE(4578),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(693),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [124] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17004),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(695),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [125] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16813),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(699),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [126] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17121),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(703),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [127] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16871),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(707),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [128] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17143),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(711),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [129] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17804),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(715),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [130] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17259),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(719),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [131] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17281),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(723),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [132] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16601),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(727),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [133] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17382),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(731),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [134] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16615),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(735),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [135] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17403),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(739),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [136] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16667),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(743),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [137] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17501),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(747),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [138] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17522),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(751),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [139] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17620),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(755),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [140] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17641),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(759),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [141] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17739),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(763),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [142] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17760),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(767),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [143] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16792),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(771),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [144] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17827),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(775),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [145] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17836),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(779),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [146] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17688),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(783),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [147] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17651),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [148] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17521),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(791),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [149] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17498),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(795),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [150] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17381),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(799),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [151] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17367),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(803),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(805),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [152] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17168),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(807),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [153] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17255),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(811),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [154] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17241),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(815),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [155] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17244),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(819),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [156] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17133),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(823),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [157] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17123),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(827),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [158] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17007),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [159] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17332),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(835),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [160] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16986),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(839),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [161] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16743),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(843),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [162] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18577),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [163] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16907),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [164] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16876),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [165] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16784),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [166] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16432),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [167] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17434),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [168] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16773),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(885),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [169] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16665),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(889),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [170] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16649),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(893),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [171] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16535),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(897),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [172] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16964),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(901),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [173] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16521),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(905),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [174] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16914),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(909),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [175] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16865),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(913),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [176] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16410),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(917),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [177] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16916),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(921),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [178] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16402),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(925),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [179] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16575),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [180] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16307),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(933),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [181] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16292),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(937),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [182] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16843),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(941),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [183] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16311),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(945),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [184] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16322),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(949),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [185] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16724),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(953),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [186] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17093),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(957),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [187] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17039),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(961),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [188] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16251),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(965),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [189] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17054),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(969),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [190] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17116),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(973),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [191] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16702),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(977),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [192] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(20357),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [193] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16982),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(981),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [194] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16834),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(985),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [195] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17199),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(989),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [196] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16579),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(993),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [197] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16556),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(997),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [198] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17234),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1001),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [199] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(17924),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [200] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16426),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1005),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [201] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17324),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1009),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [202] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17351),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1013),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [203] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17385),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1017),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [204] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17410),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1021),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [205] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16321),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1025),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [206] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16403),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1029),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [207] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17512),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1033),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [208] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17556),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1037),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [209] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17519),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1041),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [210] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17547),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1045),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [211] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16256),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1049),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [212] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16276),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1053),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [213] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17715),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1057),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [214] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17729),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1061),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [215] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17646),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1065),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [216] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17674),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1069),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [217] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18069),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [218] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16260),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [219] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18180),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [220] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18261),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [221] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17094),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1077),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [222] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18351),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [223] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18447),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [224] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18546),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [225] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18660),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [226] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18761),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [227] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18927),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [228] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17588),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1081),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [229] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19106),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [230] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19285),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [231] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19495),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [232] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19654),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [233] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(16429),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1085),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [234] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19824),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [235] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(20007),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [236] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(20137),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [237] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19880),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [238] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19515),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [239] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19333),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [240] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19181),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [241] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19000),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [242] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18867),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [243] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18729),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [244] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19401),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [245] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(5003),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(4399),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(5785),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_bind_pattern] = STATE(20461),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_let] = STATE(20461),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym_rec] = STATE(20461),
    [sym_stmt] = STATE(17819),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20453),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18727),
    [sym__typed_pat] = STATE(18727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13992),
    [sym_splice] = STATE(5794),
    [sym_quasiquote] = STATE(5794),
    [sym__varid] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1089),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(663),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(663),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_rec] = ACTIONS(681),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [246] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18591),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [247] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18470),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [248] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18325),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [249] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19291),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [250] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18210),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [251] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18112),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [252] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18011),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [253] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(17906),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [254] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19172),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [255] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(17863),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [256] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(17982),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [257] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18101),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [258] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18220),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [259] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(19053),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [260] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18339),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [261] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18458),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [262] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18523),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [263] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18934),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [264] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18815),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [265] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_bind_pattern] = STATE(20750),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_transform] = STATE(20750),
    [sym_qual] = STATE(18696),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_let] = STATE(20750),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20756),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18650),
    [sym__typed_pat] = STATE(18650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_thengroupby] = ACTIONS(857),
    [anon_sym_thengroupusing] = ACTIONS(859),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [266] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16467),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(879),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [267] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16788),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(875),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [268] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16401),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1031),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [269] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17384),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(801),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [270] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1123),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [271] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1125),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [272] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1127),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [273] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1129),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [274] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1131),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [275] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1133),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [276] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1135),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [277] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17529),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(793),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [278] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1137),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [279] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1139),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [280] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22709),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16017),
    [sym__typed_pat] = STATE(16017),
    [sym_pat_view] = STATE(16017),
    [sym__nested_pat] = STATE(16017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1153),
  },
  [281] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1155),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [282] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21836),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15872),
    [sym__typed_pat] = STATE(15872),
    [sym_pat_view] = STATE(15872),
    [sym__nested_pat] = STATE(15872),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1157),
  },
  [283] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1159),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [284] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1161),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [285] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1163),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [286] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16336),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1027),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [287] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17820),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1091),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [288] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1165),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [289] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17258),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(813),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [290] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17229),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1079),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [291] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17689),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(785),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [292] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17323),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1011),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [293] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1167),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [294] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1169),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [295] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17825),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(777),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [296] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1171),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [297] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16911),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(867),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [298] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1173),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [299] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17235),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1003),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [300] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1175),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [301] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1177),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [302] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22251),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16161),
    [sym__typed_pat] = STATE(16161),
    [sym_pat_view] = STATE(16161),
    [sym__nested_pat] = STATE(16161),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1179),
  },
  [303] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1181),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [304] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1183),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [305] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17248),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(821),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [306] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1185),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [307] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17135),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(825),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [308] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17737),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(765),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [309] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1187),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [310] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1189),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [311] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22714),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15705),
    [sym__typed_pat] = STATE(15705),
    [sym_pat_view] = STATE(15705),
    [sym__nested_pat] = STATE(15705),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1191),
  },
  [312] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21764),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15732),
    [sym__typed_pat] = STATE(15732),
    [sym_pat_view] = STATE(15732),
    [sym__nested_pat] = STATE(15732),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1193),
  },
  [313] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1195),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [314] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21517),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16038),
    [sym__typed_pat] = STATE(16038),
    [sym_pat_view] = STATE(16038),
    [sym__nested_pat] = STATE(16038),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1197),
  },
  [315] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1199),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [316] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1201),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [317] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17055),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(971),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [318] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1203),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [319] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1205),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [320] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22144),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15684),
    [sym__typed_pat] = STATE(15684),
    [sym_pat_view] = STATE(15684),
    [sym__nested_pat] = STATE(15684),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1207),
  },
  [321] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17618),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(757),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [322] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17085),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(959),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [323] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1209),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [324] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16838),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(987),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [325] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17012),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(833),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [326] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1211),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [327] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1213),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [328] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17679),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1071),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [329] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1215),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [330] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17499),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(749),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [331] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1217),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [332] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1219),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [333] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1221),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [334] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22369),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15970),
    [sym__typed_pat] = STATE(15970),
    [sym_pat_view] = STATE(15970),
    [sym__nested_pat] = STATE(15970),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1223),
  },
  [335] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1225),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [336] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22839),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16120),
    [sym__typed_pat] = STATE(16120),
    [sym_pat_view] = STATE(16120),
    [sym__nested_pat] = STATE(16120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1227),
  },
  [337] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1229),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [338] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17503),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1035),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [339] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17380),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(733),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [340] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23362),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15714),
    [sym__typed_pat] = STATE(15714),
    [sym_pat_view] = STATE(15714),
    [sym__nested_pat] = STATE(15714),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1231),
  },
  [341] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1233),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [342] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1235),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [343] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1237),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [344] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1239),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [345] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1241),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [346] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16833),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(673),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [347] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1243),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [348] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1245),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [349] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1247),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [350] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1249),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [351] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1251),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [352] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17257),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(721),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [353] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21475),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16153),
    [sym__typed_pat] = STATE(16153),
    [sym_pat_view] = STATE(16153),
    [sym__nested_pat] = STATE(16153),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1253),
  },
  [354] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1255),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [355] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22482),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15929),
    [sym__typed_pat] = STATE(15929),
    [sym_pat_view] = STATE(15929),
    [sym__nested_pat] = STATE(15929),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1257),
  },
  [356] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16870),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(903),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [357] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22960),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15875),
    [sym__typed_pat] = STATE(15875),
    [sym_pat_view] = STATE(15875),
    [sym__nested_pat] = STATE(15875),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1259),
  },
  [358] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1261),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [359] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17437),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(883),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [360] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1263),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [361] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17713),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1059),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [362] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1265),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [363] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1267),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [364] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1269),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [365] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16872),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(709),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [366] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17119),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(705),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [367] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23341),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16168),
    [sym__typed_pat] = STATE(16168),
    [sym_pat_view] = STATE(16168),
    [sym__nested_pat] = STATE(16168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1271),
  },
  [368] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16816),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(845),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [369] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16666),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(891),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [370] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1273),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [371] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1275),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [372] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22334),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15827),
    [sym__typed_pat] = STATE(15827),
    [sym_pat_view] = STATE(15827),
    [sym__nested_pat] = STATE(15827),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1277),
  },
  [373] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1279),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [374] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17411),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1023),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [375] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1281),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [376] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1283),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [377] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1285),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [378] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1287),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [379] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1289),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [380] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16980),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(983),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [381] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1291),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [382] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22052),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16036),
    [sym__typed_pat] = STATE(16036),
    [sym_pat_view] = STATE(16036),
    [sym__nested_pat] = STATE(16036),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1293),
  },
  [383] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16537),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(899),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [384] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22007),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16170),
    [sym__typed_pat] = STATE(16170),
    [sym_pat_view] = STATE(16170),
    [sym__nested_pat] = STATE(16170),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1295),
  },
  [385] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16618),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(737),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [386] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1297),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [387] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22215),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15657),
    [sym__typed_pat] = STATE(15657),
    [sym_pat_view] = STATE(15657),
    [sym__nested_pat] = STATE(15657),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1299),
  },
  [388] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1301),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [389] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(23029),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15689),
    [sym__typed_pat] = STATE(15689),
    [sym_pat_view] = STATE(15689),
    [sym__nested_pat] = STATE(15689),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1303),
  },
  [390] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1305),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [391] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16573),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(729),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [392] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1307),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [393] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1309),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [394] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1311),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [395] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1313),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [396] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1315),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [397] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21356),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16132),
    [sym__typed_pat] = STATE(16132),
    [sym_pat_view] = STATE(16132),
    [sym__nested_pat] = STATE(16132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1317),
  },
  [398] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1319),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [399] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1321),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [400] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16413),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(919),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [401] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16841),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(943),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [402] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22476),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15793),
    [sym__typed_pat] = STATE(15793),
    [sym_pat_view] = STATE(15793),
    [sym__nested_pat] = STATE(15793),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1323),
  },
  [403] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22032),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15779),
    [sym__typed_pat] = STATE(15779),
    [sym_pat_view] = STATE(15779),
    [sym__nested_pat] = STATE(15779),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1325),
  },
  [404] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1327),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [405] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1329),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [406] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1331),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [407] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22287),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15837),
    [sym__typed_pat] = STATE(15837),
    [sym_pat_view] = STATE(15837),
    [sym__nested_pat] = STATE(15837),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1333),
  },
  [408] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1335),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [409] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1337),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [410] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16700),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(979),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [411] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1339),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [412] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1341),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [413] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1343),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [414] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16319),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(935),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [415] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1345),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [416] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22976),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15652),
    [sym__typed_pat] = STATE(15652),
    [sym_pat_view] = STATE(15652),
    [sym__nested_pat] = STATE(15652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1347),
  },
  [417] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21859),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15897),
    [sym__typed_pat] = STATE(15897),
    [sym_pat_view] = STATE(15897),
    [sym__nested_pat] = STATE(15897),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1349),
  },
  [418] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21411),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16196),
    [sym__typed_pat] = STATE(16196),
    [sym_pat_view] = STATE(16196),
    [sym__nested_pat] = STATE(16196),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1351),
  },
  [419] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16259),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1075),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [420] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1353),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [421] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1355),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [422] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1357),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [423] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1359),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [424] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1361),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [425] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1363),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [426] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1365),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [427] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1367),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [428] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1369),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [429] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16310),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(947),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [430] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1371),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [431] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(22588),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(15740),
    [sym__typed_pat] = STATE(15740),
    [sym_pat_view] = STATE(15740),
    [sym__nested_pat] = STATE(15740),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1373),
  },
  [432] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(16554),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(999),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [433] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1375),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [434] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1377),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [435] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym__pat_unboxed_sum] = STATE(21691),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(16013),
    [sym__typed_pat] = STATE(16013),
    [sym_pat_view] = STATE(16013),
    [sym__nested_pat] = STATE(16013),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(18061),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
    [sym__unboxed_close] = ACTIONS(1379),
  },
  [436] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(17550),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1047),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [437] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1381),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [438] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(4667),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4168),
    [sym_qualified_constructor] = STATE(4314),
    [sym__qcon] = STATE(4238),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(5008),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_bind_pattern] = STATE(18431),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_let] = STATE(18431),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym_rec] = STATE(18431),
    [sym_stmt] = STATE(20106),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(18439),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(15359),
    [sym__pat] = STATE(15359),
    [sym_pat_typed] = STATE(18440),
    [sym__typed_pat] = STATE(18440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13923),
    [sym_splice] = STATE(5006),
    [sym_quasiquote] = STATE(5006),
    [sym__varid] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(1101),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1101),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_rec] = ACTIONS(1115),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [439] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(98),
    [sym_variable] = STATE(5188),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(4242),
    [sym_qualified_constructor] = STATE(4405),
    [sym__qcon] = STATE(4456),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5467),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10151),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10151),
    [sym_exp_cond] = STATE(10151),
    [sym_exp_if_guard] = STATE(10151),
    [sym_exp_case] = STATE(10151),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10151),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10151),
    [sym__lexp] = STATE(10151),
    [sym_exp_infix] = STATE(10151),
    [sym__exp_infix] = STATE(10151),
    [sym__exp] = STATE(15800),
    [sym_pat_name] = STATE(13070),
    [sym_pat_as] = STATE(13070),
    [sym__pat_constructor] = STATE(2819),
    [sym_pat_record] = STATE(13070),
    [sym_pat_wildcard] = STATE(13070),
    [sym_pat_parens] = STATE(13070),
    [sym_pat_tuple] = STATE(13070),
    [sym_pat_unboxed_tuple] = STATE(13070),
    [sym_pat_unboxed_sum] = STATE(13070),
    [sym_pat_list] = STATE(13070),
    [sym_pat_strict] = STATE(13070),
    [sym_pat_irrefutable] = STATE(13070),
    [sym_pat_type_binder] = STATE(13070),
    [sym__apat] = STATE(13070),
    [sym_pat_negation] = STATE(13070),
    [sym_pat_apply] = STATE(13070),
    [sym__lpat] = STATE(13070),
    [sym_pat_infix] = STATE(15550),
    [sym__pat] = STATE(15550),
    [sym_pat_typed] = STATE(20665),
    [sym__typed_pat] = STATE(20665),
    [sym_pat_view] = STATE(20665),
    [sym__nested_pat] = STATE(20665),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14070),
    [sym_splice] = STATE(5470),
    [sym_quasiquote] = STATE(5470),
    [sym__varid] = ACTIONS(1383),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(1391),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1391),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_PIPE] = ACTIONS(1405),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1410),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
    [sym__strict] = ACTIONS(1428),
    [sym__lazy] = ACTIONS(1430),
    [sym__unboxed_close] = ACTIONS(1405),
  },
  [440] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(4720),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4242),
    [sym_qualified_constructor] = STATE(4405),
    [sym__qcon] = STATE(4467),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5841),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18658),
    [sym_pat_name] = STATE(13070),
    [sym_pat_as] = STATE(13070),
    [sym__pat_constructor] = STATE(2819),
    [sym_pat_record] = STATE(13070),
    [sym_pat_wildcard] = STATE(13070),
    [sym_pat_parens] = STATE(13070),
    [sym_pat_tuple] = STATE(13070),
    [sym_pat_unboxed_tuple] = STATE(13070),
    [sym_pat_unboxed_sum] = STATE(13070),
    [sym_pat_list] = STATE(13070),
    [sym_pat_strict] = STATE(13070),
    [sym_pat_irrefutable] = STATE(13070),
    [sym_pat_type_binder] = STATE(13070),
    [sym__apat] = STATE(13070),
    [sym_pat_negation] = STATE(13070),
    [sym_pat_apply] = STATE(13070),
    [sym__lpat] = STATE(13070),
    [sym_pat_infix] = STATE(15550),
    [sym__pat] = STATE(15550),
    [sym_pat_typed] = STATE(20665),
    [sym__typed_pat] = STATE(20665),
    [sym_pat_view] = STATE(20665),
    [sym__nested_pat] = STATE(20665),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14072),
    [sym_splice] = STATE(5780),
    [sym_quasiquote] = STATE(5780),
    [sym__varid] = ACTIONS(1383),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(1432),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1432),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym__] = ACTIONS(1410),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
    [sym__strict] = ACTIONS(1428),
    [sym__lazy] = ACTIONS(1430),
    [sym__unboxed_close] = ACTIONS(1440),
  },
  [441] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13913),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18695),
    [sym__typed_pat] = STATE(18695),
    [sym_pat_view] = STATE(18695),
    [sym__nested_pat] = STATE(18695),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [442] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18393),
    [sym__typed_pat] = STATE(18393),
    [sym_pat_view] = STATE(18393),
    [sym__nested_pat] = STATE(18393),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [443] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14067),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [444] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13975),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [445] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13913),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [446] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14069),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18211),
    [sym__typed_pat] = STATE(18211),
    [sym_pat_view] = STATE(18211),
    [sym__nested_pat] = STATE(18211),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [447] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19097),
    [sym__typed_pat] = STATE(19097),
    [sym_pat_view] = STATE(19097),
    [sym__nested_pat] = STATE(19097),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [448] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19244),
    [sym__typed_pat] = STATE(19244),
    [sym_pat_view] = STATE(19244),
    [sym__nested_pat] = STATE(19244),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [449] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13913),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19716),
    [sym__typed_pat] = STATE(19716),
    [sym_pat_view] = STATE(19716),
    [sym__nested_pat] = STATE(19716),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [450] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13913),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18211),
    [sym__typed_pat] = STATE(18211),
    [sym_pat_view] = STATE(18211),
    [sym__nested_pat] = STATE(18211),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [451] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18299),
    [sym__typed_pat] = STATE(18299),
    [sym_pat_view] = STATE(18299),
    [sym__nested_pat] = STATE(18299),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [452] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19561),
    [sym__typed_pat] = STATE(19561),
    [sym_pat_view] = STATE(19561),
    [sym__nested_pat] = STATE(19561),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1506),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [453] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14022),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [454] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13913),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [455] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18211),
    [sym__typed_pat] = STATE(18211),
    [sym_pat_view] = STATE(18211),
    [sym__nested_pat] = STATE(18211),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [456] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13965),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18695),
    [sym__typed_pat] = STATE(18695),
    [sym_pat_view] = STATE(18695),
    [sym__nested_pat] = STATE(18695),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [457] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19426),
    [sym__typed_pat] = STATE(19426),
    [sym_pat_view] = STATE(19426),
    [sym__nested_pat] = STATE(19426),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [458] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18959),
    [sym__typed_pat] = STATE(18959),
    [sym_pat_view] = STATE(18959),
    [sym__nested_pat] = STATE(18959),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [459] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13975),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [460] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13981),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18695),
    [sym__typed_pat] = STATE(18695),
    [sym_pat_view] = STATE(18695),
    [sym__nested_pat] = STATE(18695),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [461] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13975),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18211),
    [sym__typed_pat] = STATE(18211),
    [sym_pat_view] = STATE(18211),
    [sym__nested_pat] = STATE(18211),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [462] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13975),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [463] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14090),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18211),
    [sym__typed_pat] = STATE(18211),
    [sym_pat_view] = STATE(18211),
    [sym__nested_pat] = STATE(18211),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [464] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18586),
    [sym__typed_pat] = STATE(18586),
    [sym_pat_view] = STATE(18586),
    [sym__nested_pat] = STATE(18586),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [465] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13874),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [466] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19175),
    [sym__typed_pat] = STATE(19175),
    [sym_pat_view] = STATE(19175),
    [sym__nested_pat] = STATE(19175),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [467] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19716),
    [sym__typed_pat] = STATE(19716),
    [sym_pat_view] = STATE(19716),
    [sym__nested_pat] = STATE(19716),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [468] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13967),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [469] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18380),
    [sym__typed_pat] = STATE(18380),
    [sym_pat_view] = STATE(18380),
    [sym__nested_pat] = STATE(18380),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [470] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18822),
    [sym__typed_pat] = STATE(18822),
    [sym_pat_view] = STATE(18822),
    [sym__nested_pat] = STATE(18822),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [471] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13869),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [472] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13975),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19716),
    [sym__typed_pat] = STATE(19716),
    [sym_pat_view] = STATE(19716),
    [sym__nested_pat] = STATE(19716),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [473] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19894),
    [sym__typed_pat] = STATE(19894),
    [sym_pat_view] = STATE(19894),
    [sym__nested_pat] = STATE(19894),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [474] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18990),
    [sym__typed_pat] = STATE(18990),
    [sym_pat_view] = STATE(18990),
    [sym__nested_pat] = STATE(18990),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [475] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13874),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [476] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18012),
    [sym__typed_pat] = STATE(18012),
    [sym_pat_view] = STATE(18012),
    [sym__nested_pat] = STATE(18012),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1546),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [477] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19365),
    [sym__typed_pat] = STATE(19365),
    [sym_pat_view] = STATE(19365),
    [sym__nested_pat] = STATE(19365),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [478] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18680),
    [sym__typed_pat] = STATE(18680),
    [sym_pat_view] = STATE(18680),
    [sym__nested_pat] = STATE(18680),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [479] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18812),
    [sym__typed_pat] = STATE(18812),
    [sym_pat_view] = STATE(18812),
    [sym__nested_pat] = STATE(18812),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [480] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13869),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [481] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13954),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [482] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17930),
    [sym__typed_pat] = STATE(17930),
    [sym_pat_view] = STATE(17930),
    [sym__nested_pat] = STATE(17930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [483] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18695),
    [sym__typed_pat] = STATE(18695),
    [sym_pat_view] = STATE(18695),
    [sym__nested_pat] = STATE(18695),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [484] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(19702),
    [sym__typed_pat] = STATE(19702),
    [sym_pat_view] = STATE(19702),
    [sym__nested_pat] = STATE(19702),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [485] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [486] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13975),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18695),
    [sym__typed_pat] = STATE(18695),
    [sym_pat_view] = STATE(18695),
    [sym__nested_pat] = STATE(18695),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [487] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18488),
    [sym__typed_pat] = STATE(18488),
    [sym_pat_view] = STATE(18488),
    [sym__nested_pat] = STATE(18488),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [488] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18545),
    [sym__typed_pat] = STATE(18545),
    [sym_pat_view] = STATE(18545),
    [sym__nested_pat] = STATE(18545),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [489] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14020),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [490] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13936),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [491] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14067),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [492] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13936),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [493] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20131),
    [sym__typed_pat] = STATE(20131),
    [sym_pat_view] = STATE(20131),
    [sym__nested_pat] = STATE(20131),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [494] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17860),
    [sym__typed_pat] = STATE(17860),
    [sym_pat_view] = STATE(17860),
    [sym__nested_pat] = STATE(17860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1574),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [495] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4343),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(3915),
    [sym_qualified_constructor] = STATE(4127),
    [sym__qcon] = STATE(4134),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4480),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(13913),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18132),
    [sym__typed_pat] = STATE(18132),
    [sym_pat_view] = STATE(18132),
    [sym__nested_pat] = STATE(18132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13941),
    [sym_splice] = STATE(4484),
    [sym_quasiquote] = STATE(4484),
    [sym__varid] = ACTIONS(1444),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1452),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1452),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [496] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20005),
    [sym__typed_pat] = STATE(20005),
    [sym_pat_view] = STATE(20005),
    [sym__nested_pat] = STATE(20005),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_RBRACK] = ACTIONS(1576),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [497] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(96),
    [sym_variable] = STATE(5175),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4266),
    [sym_qualified_constructor] = STATE(4449),
    [sym__qcon] = STATE(4475),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(5315),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18612),
    [sym_pat_name] = STATE(13187),
    [sym_pat_as] = STATE(13187),
    [sym__pat_constructor] = STATE(2913),
    [sym_pat_record] = STATE(13187),
    [sym_pat_wildcard] = STATE(13187),
    [sym_pat_parens] = STATE(13187),
    [sym_pat_tuple] = STATE(13187),
    [sym_pat_unboxed_tuple] = STATE(13187),
    [sym_pat_unboxed_sum] = STATE(13187),
    [sym_pat_list] = STATE(13187),
    [sym_pat_strict] = STATE(13187),
    [sym_pat_irrefutable] = STATE(13187),
    [sym_pat_type_binder] = STATE(13187),
    [sym__apat] = STATE(13187),
    [sym_pat_negation] = STATE(13187),
    [sym_pat_apply] = STATE(13187),
    [sym__lpat] = STATE(13187),
    [sym_pat_infix] = STATE(15324),
    [sym__pat] = STATE(15324),
    [sym_pat_typed] = STATE(20429),
    [sym__typed_pat] = STATE(20429),
    [sym_pat_view] = STATE(20429),
    [sym__nested_pat] = STATE(20429),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14065),
    [sym_splice] = STATE(5319),
    [sym_quasiquote] = STATE(5319),
    [sym__varid] = ACTIONS(1578),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(1586),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1586),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1596),
    [anon_sym__] = ACTIONS(1598),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
    [sym__strict] = ACTIONS(1606),
    [sym__lazy] = ACTIONS(1608),
  },
  [498] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(96),
    [sym_variable] = STATE(5175),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4266),
    [sym_qualified_constructor] = STATE(4449),
    [sym__qcon] = STATE(4475),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(5315),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18612),
    [sym_pat_name] = STATE(13187),
    [sym_pat_as] = STATE(13187),
    [sym__pat_constructor] = STATE(2913),
    [sym_pat_record] = STATE(13187),
    [sym_pat_wildcard] = STATE(13187),
    [sym_pat_parens] = STATE(13187),
    [sym_pat_tuple] = STATE(13187),
    [sym_pat_unboxed_tuple] = STATE(13187),
    [sym_pat_unboxed_sum] = STATE(13187),
    [sym_pat_list] = STATE(13187),
    [sym_pat_strict] = STATE(13187),
    [sym_pat_irrefutable] = STATE(13187),
    [sym_pat_type_binder] = STATE(13187),
    [sym__apat] = STATE(13187),
    [sym_pat_negation] = STATE(13187),
    [sym_pat_apply] = STATE(13187),
    [sym__lpat] = STATE(13187),
    [sym_pat_infix] = STATE(15324),
    [sym__pat] = STATE(15324),
    [sym_pat_typed] = STATE(20282),
    [sym__typed_pat] = STATE(20282),
    [sym_pat_view] = STATE(20282),
    [sym__nested_pat] = STATE(20282),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14065),
    [sym_splice] = STATE(5319),
    [sym_quasiquote] = STATE(5319),
    [sym__varid] = ACTIONS(1578),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(1586),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1586),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1596),
    [anon_sym__] = ACTIONS(1598),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
    [sym__strict] = ACTIONS(1606),
    [sym__lazy] = ACTIONS(1608),
  },
  [499] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(17294),
    [sym__typed_pat] = STATE(17294),
    [sym_pat_view] = STATE(17294),
    [sym__nested_pat] = STATE(17294),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [500] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(21017),
    [sym__typed_pat] = STATE(21017),
    [sym_pat_view] = STATE(21017),
    [sym__nested_pat] = STATE(21017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [501] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(18512),
    [sym__typed_pat] = STATE(18512),
    [sym_pat_view] = STATE(18512),
    [sym__nested_pat] = STATE(18512),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [502] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(4720),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4242),
    [sym_qualified_constructor] = STATE(4405),
    [sym__qcon] = STATE(4467),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5841),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18658),
    [sym_pat_name] = STATE(13070),
    [sym_pat_as] = STATE(13070),
    [sym__pat_constructor] = STATE(2819),
    [sym_pat_record] = STATE(13070),
    [sym_pat_wildcard] = STATE(13070),
    [sym_pat_parens] = STATE(13070),
    [sym_pat_tuple] = STATE(13070),
    [sym_pat_unboxed_tuple] = STATE(13070),
    [sym_pat_unboxed_sum] = STATE(13070),
    [sym_pat_list] = STATE(13070),
    [sym_pat_strict] = STATE(13070),
    [sym_pat_irrefutable] = STATE(13070),
    [sym_pat_type_binder] = STATE(13070),
    [sym__apat] = STATE(13070),
    [sym_pat_negation] = STATE(13070),
    [sym_pat_apply] = STATE(13070),
    [sym__lpat] = STATE(13070),
    [sym_pat_infix] = STATE(15550),
    [sym__pat] = STATE(15550),
    [sym_pat_typed] = STATE(20956),
    [sym__typed_pat] = STATE(20956),
    [sym_pat_view] = STATE(20956),
    [sym__nested_pat] = STATE(20956),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14072),
    [sym_splice] = STATE(5780),
    [sym_quasiquote] = STATE(5780),
    [sym__varid] = ACTIONS(1383),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(1432),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1432),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym__] = ACTIONS(1410),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
    [sym__strict] = ACTIONS(1428),
    [sym__lazy] = ACTIONS(1430),
  },
  [503] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(94),
    [sym_variable] = STATE(4367),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4158),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4509),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18196),
    [sym_pat_name] = STATE(11954),
    [sym_pat_as] = STATE(11954),
    [sym__pat_constructor] = STATE(2781),
    [sym_pat_record] = STATE(11954),
    [sym_pat_wildcard] = STATE(11954),
    [sym_pat_parens] = STATE(11954),
    [sym_pat_tuple] = STATE(11954),
    [sym_pat_unboxed_tuple] = STATE(11954),
    [sym_pat_unboxed_sum] = STATE(11954),
    [sym_pat_list] = STATE(11954),
    [sym_pat_strict] = STATE(11954),
    [sym_pat_irrefutable] = STATE(11954),
    [sym_pat_type_binder] = STATE(11954),
    [sym__apat] = STATE(11954),
    [sym_pat_negation] = STATE(11954),
    [sym_pat_apply] = STATE(11954),
    [sym__lpat] = STATE(11954),
    [sym_pat_infix] = STATE(14333),
    [sym__pat] = STATE(14333),
    [sym_pat_typed] = STATE(20348),
    [sym__typed_pat] = STATE(20348),
    [sym_pat_view] = STATE(20348),
    [sym__nested_pat] = STATE(20348),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14032),
    [sym_splice] = STATE(4513),
    [sym_quasiquote] = STATE(4513),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(425),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(425),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [504] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4519),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(4179),
    [sym_qualified_constructor] = STATE(4290),
    [sym__qcon] = STATE(4237),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4734),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(18736),
    [sym_pat_name] = STATE(12479),
    [sym_pat_as] = STATE(12479),
    [sym__pat_constructor] = STATE(2791),
    [sym_pat_record] = STATE(12479),
    [sym_pat_wildcard] = STATE(12479),
    [sym_pat_parens] = STATE(12479),
    [sym_pat_tuple] = STATE(12479),
    [sym_pat_unboxed_tuple] = STATE(12479),
    [sym_pat_unboxed_sum] = STATE(12479),
    [sym_pat_list] = STATE(12479),
    [sym_pat_strict] = STATE(12479),
    [sym_pat_irrefutable] = STATE(12479),
    [sym_pat_type_binder] = STATE(12479),
    [sym__apat] = STATE(12479),
    [sym_pat_negation] = STATE(12479),
    [sym_pat_apply] = STATE(12479),
    [sym__lpat] = STATE(12479),
    [sym_pat_infix] = STATE(14854),
    [sym__pat] = STATE(14854),
    [sym_pat_typed] = STATE(18079),
    [sym__typed_pat] = STATE(18079),
    [sym_pat_view] = STATE(18079),
    [sym__nested_pat] = STATE(18079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13978),
    [sym_splice] = STATE(4736),
    [sym_quasiquote] = STATE(4736),
    [sym__varid] = ACTIONS(547),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1141),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1141),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
  },
  [505] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10672),
    [sym_let] = STATE(16707),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10672),
    [sym_exp_cond] = STATE(10672),
    [sym_pattern_guard] = STATE(16707),
    [sym_guard] = STATE(17245),
    [sym_exp_if_guard] = STATE(10672),
    [sym_exp_case] = STATE(10672),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10672),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10672),
    [sym__lexp] = STATE(10672),
    [sym_exp_infix] = STATE(10672),
    [sym__exp_infix] = STATE(10672),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(18286),
    [sym__pat] = STATE(18286),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [506] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(4315),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(3728),
    [sym_qualified_constructor] = STATE(3784),
    [sym__qcon] = STATE(4101),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4440),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10672),
    [sym_let] = STATE(16707),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10672),
    [sym_exp_cond] = STATE(10672),
    [sym_pattern_guard] = STATE(16707),
    [sym_guard] = STATE(15835),
    [sym_exp_if_guard] = STATE(10672),
    [sym_exp_case] = STATE(10672),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10672),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10672),
    [sym__lexp] = STATE(10672),
    [sym_exp_infix] = STATE(10672),
    [sym__exp_infix] = STATE(10672),
    [sym_pat_name] = STATE(11247),
    [sym_pat_as] = STATE(11247),
    [sym__pat_constructor] = STATE(2672),
    [sym_pat_record] = STATE(11247),
    [sym_pat_wildcard] = STATE(11247),
    [sym_pat_parens] = STATE(11247),
    [sym_pat_tuple] = STATE(11247),
    [sym_pat_unboxed_tuple] = STATE(11247),
    [sym_pat_unboxed_sum] = STATE(11247),
    [sym_pat_list] = STATE(11247),
    [sym_pat_strict] = STATE(11247),
    [sym_pat_irrefutable] = STATE(11247),
    [sym_pat_type_binder] = STATE(11247),
    [sym__apat] = STATE(11247),
    [sym_pat_negation] = STATE(11247),
    [sym_pat_apply] = STATE(11247),
    [sym__lpat] = STATE(11247),
    [sym_pat_infix] = STATE(18286),
    [sym__pat] = STATE(18286),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14050),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(239),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(847),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(847),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(259),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [507] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8321),
    [sym__minus] = STATE(22131),
    [sym_qualified_operator] = STATE(8321),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1323),
    [sym_qualified_constructor_operator] = STATE(1323),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22266),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10203),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10203),
    [sym_exp_cond] = STATE(10203),
    [sym_exp_if_guard] = STATE(10203),
    [sym_exp_case] = STATE(10203),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10203),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10203),
    [sym__lexp] = STATE(10203),
    [sym_exp_infix] = STATE(10203),
    [sym__exp_infix] = STATE(10203),
    [sym__exp] = STATE(20488),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(915),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [508] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8420),
    [sym__minus] = STATE(22893),
    [sym_qualified_operator] = STATE(8420),
    [sym__qvarop_nominus] = STATE(1762),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1315),
    [sym_qualified_constructor_operator] = STATE(1315),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22219),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10568),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10568),
    [sym_exp_cond] = STATE(10568),
    [sym_exp_if_guard] = STATE(10568),
    [sym_exp_case] = STATE(10568),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10568),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10568),
    [sym__lexp] = STATE(10568),
    [sym_exp_infix] = STATE(10568),
    [sym__exp_infix] = STATE(10568),
    [sym__exp] = STATE(21211),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(877),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(289),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [509] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8385),
    [sym__minus] = STATE(22318),
    [sym_qualified_operator] = STATE(8385),
    [sym__qvarop_nominus] = STATE(1751),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1589),
    [sym_qualified_constructor_operator] = STATE(1589),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22256),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10499),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10499),
    [sym_exp_cond] = STATE(10499),
    [sym_exp_if_guard] = STATE(10499),
    [sym_exp_case] = STATE(10499),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10499),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10499),
    [sym__lexp] = STATE(10499),
    [sym_exp_infix] = STATE(10499),
    [sym__exp_infix] = STATE(10499),
    [sym__exp] = STATE(20446),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(893),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1632),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1634),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [510] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8429),
    [sym__minus] = STATE(22204),
    [sym_qualified_operator] = STATE(8429),
    [sym__qvarop_nominus] = STATE(1736),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1612),
    [sym_qualified_constructor_operator] = STATE(1612),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21438),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10497),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10497),
    [sym_exp_cond] = STATE(10497),
    [sym_exp_if_guard] = STATE(10497),
    [sym_exp_case] = STATE(10497),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10497),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10497),
    [sym__lexp] = STATE(10497),
    [sym_exp_infix] = STATE(10497),
    [sym__exp_infix] = STATE(10497),
    [sym__exp] = STATE(20208),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(881),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1640),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1642),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [511] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8440),
    [sym__minus] = STATE(22606),
    [sym_qualified_operator] = STATE(8440),
    [sym__qvarop_nominus] = STATE(1680),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1365),
    [sym_qualified_constructor_operator] = STATE(1365),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22635),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10580),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10580),
    [sym_exp_cond] = STATE(10580),
    [sym_exp_if_guard] = STATE(10580),
    [sym_exp_case] = STATE(10580),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10580),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10580),
    [sym__lexp] = STATE(10580),
    [sym_exp_infix] = STATE(10580),
    [sym__exp_infix] = STATE(10580),
    [sym__exp] = STATE(20718),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(902),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1646),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1648),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1650),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [512] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8320),
    [sym__minus] = STATE(22988),
    [sym_qualified_operator] = STATE(8320),
    [sym__qvarop_nominus] = STATE(1685),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1437),
    [sym_qualified_constructor_operator] = STATE(1437),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22946),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10473),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10473),
    [sym_exp_cond] = STATE(10473),
    [sym_exp_if_guard] = STATE(10473),
    [sym_exp_case] = STATE(10473),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10473),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10473),
    [sym__lexp] = STATE(10473),
    [sym_exp_infix] = STATE(10473),
    [sym__exp_infix] = STATE(10473),
    [sym__exp] = STATE(20545),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(882),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1658),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [513] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8474),
    [sym__minus] = STATE(23021),
    [sym_qualified_operator] = STATE(8474),
    [sym__qvarop_nominus] = STATE(1745),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1324),
    [sym_qualified_constructor_operator] = STATE(1324),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23171),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10094),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10094),
    [sym_exp_cond] = STATE(10094),
    [sym_exp_if_guard] = STATE(10094),
    [sym_exp_case] = STATE(10094),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10094),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10094),
    [sym__lexp] = STATE(10094),
    [sym_exp_infix] = STATE(10094),
    [sym__exp_infix] = STATE(10094),
    [sym__exp] = STATE(20589),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(905),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(257),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1662),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [514] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8431),
    [sym__minus] = STATE(21480),
    [sym_qualified_operator] = STATE(8431),
    [sym__qvarop_nominus] = STATE(1757),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1374),
    [sym_qualified_constructor_operator] = STATE(1374),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21738),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10581),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10581),
    [sym_exp_cond] = STATE(10581),
    [sym_exp_if_guard] = STATE(10581),
    [sym_exp_case] = STATE(10581),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10581),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10581),
    [sym__lexp] = STATE(10581),
    [sym_exp_infix] = STATE(10581),
    [sym__exp_infix] = STATE(10581),
    [sym__exp] = STATE(20813),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(867),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1666),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1670),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [515] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8335),
    [sym__minus] = STATE(22549),
    [sym_qualified_operator] = STATE(8335),
    [sym__qvarop_nominus] = STATE(1691),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1512),
    [sym_qualified_constructor_operator] = STATE(1512),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22088),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10528),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10528),
    [sym_exp_cond] = STATE(10528),
    [sym_exp_if_guard] = STATE(10528),
    [sym_exp_case] = STATE(10528),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10528),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10528),
    [sym__lexp] = STATE(10528),
    [sym_exp_infix] = STATE(10528),
    [sym__exp_infix] = STATE(10528),
    [sym__exp] = STATE(20845),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(869),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1672),
    [anon_sym_BQUOTE] = ACTIONS(1674),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1676),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1678),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [516] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8314),
    [sym__minus] = STATE(21511),
    [sym_qualified_operator] = STATE(8314),
    [sym__qvarop_nominus] = STATE(1731),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1523),
    [sym_qualified_constructor_operator] = STATE(1523),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22158),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10503),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10503),
    [sym_exp_cond] = STATE(10503),
    [sym_exp_if_guard] = STATE(10503),
    [sym_exp_case] = STATE(10503),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10503),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10503),
    [sym__lexp] = STATE(10503),
    [sym_exp_infix] = STATE(10503),
    [sym__exp_infix] = STATE(10503),
    [sym__exp] = STATE(20628),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(876),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(357),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(363),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [517] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8377),
    [sym__minus] = STATE(22037),
    [sym_qualified_operator] = STATE(8377),
    [sym__qvarop_nominus] = STATE(1701),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1521),
    [sym_qualified_constructor_operator] = STATE(1521),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21640),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10466),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10466),
    [sym_exp_cond] = STATE(10466),
    [sym_exp_if_guard] = STATE(10466),
    [sym_exp_case] = STATE(10466),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10466),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10466),
    [sym__lexp] = STATE(10466),
    [sym_exp_infix] = STATE(10466),
    [sym__exp_infix] = STATE(10466),
    [sym__exp] = STATE(21055),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(898),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1690),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [518] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8350),
    [sym__minus] = STATE(23138),
    [sym_qualified_operator] = STATE(8350),
    [sym__qvarop_nominus] = STATE(1688),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1453),
    [sym_qualified_constructor_operator] = STATE(1453),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23068),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10463),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10463),
    [sym_exp_cond] = STATE(10463),
    [sym_exp_if_guard] = STATE(10463),
    [sym_exp_case] = STATE(10463),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10463),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10463),
    [sym__lexp] = STATE(10463),
    [sym_exp_infix] = STATE(10463),
    [sym__exp_infix] = STATE(10463),
    [sym__exp] = STATE(20452),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(865),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1692),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1696),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1698),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [519] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8421),
    [sym__minus] = STATE(22882),
    [sym_qualified_operator] = STATE(8421),
    [sym__qvarop_nominus] = STATE(1720),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1667),
    [sym_qualified_constructor_operator] = STATE(1667),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22489),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10178),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10178),
    [sym_exp_cond] = STATE(10178),
    [sym_exp_if_guard] = STATE(10178),
    [sym_exp_case] = STATE(10178),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10178),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10178),
    [sym__lexp] = STATE(10178),
    [sym_exp_infix] = STATE(10178),
    [sym__exp_infix] = STATE(10178),
    [sym__exp] = STATE(20752),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(890),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(397),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(347),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [520] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8330),
    [sym__minus] = STATE(23226),
    [sym_qualified_operator] = STATE(8330),
    [sym__qvarop_nominus] = STATE(1700),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1458),
    [sym_qualified_constructor_operator] = STATE(1458),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23371),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10456),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10456),
    [sym_exp_cond] = STATE(10456),
    [sym_exp_if_guard] = STATE(10456),
    [sym_exp_case] = STATE(10456),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10456),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10456),
    [sym__lexp] = STATE(10456),
    [sym_exp_infix] = STATE(10456),
    [sym__exp_infix] = STATE(10456),
    [sym__exp] = STATE(20405),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(875),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1700),
    [anon_sym_BQUOTE] = ACTIONS(1702),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1706),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [521] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8323),
    [sym__minus] = STATE(22602),
    [sym_qualified_operator] = STATE(8323),
    [sym__qvarop_nominus] = STATE(1699),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1509),
    [sym_qualified_constructor_operator] = STATE(1509),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22217),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10540),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10540),
    [sym_exp_cond] = STATE(10540),
    [sym_exp_if_guard] = STATE(10540),
    [sym_exp_case] = STATE(10540),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10540),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10540),
    [sym__lexp] = STATE(10540),
    [sym_exp_infix] = STATE(10540),
    [sym__exp_infix] = STATE(10540),
    [sym__exp] = STATE(20778),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(899),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1714),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [522] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8435),
    [sym__minus] = STATE(22343),
    [sym_qualified_operator] = STATE(8435),
    [sym__qvarop_nominus] = STATE(1737),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1400),
    [sym_qualified_constructor_operator] = STATE(1400),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22018),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10204),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10204),
    [sym_exp_cond] = STATE(10204),
    [sym_exp_if_guard] = STATE(10204),
    [sym_exp_case] = STATE(10204),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10204),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10204),
    [sym__lexp] = STATE(10204),
    [sym_exp_infix] = STATE(10204),
    [sym__exp_infix] = STATE(10204),
    [sym__exp] = STATE(20967),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(901),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(303),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [523] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8448),
    [sym__minus] = STATE(22528),
    [sym_qualified_operator] = STATE(8448),
    [sym__qvarop_nominus] = STATE(1678),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1321),
    [sym_qualified_constructor_operator] = STATE(1321),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22466),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10576),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10576),
    [sym_exp_cond] = STATE(10576),
    [sym_exp_if_guard] = STATE(10576),
    [sym_exp_case] = STATE(10576),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10576),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10576),
    [sym__lexp] = STATE(10576),
    [sym_exp_infix] = STATE(10576),
    [sym__exp_infix] = STATE(10576),
    [sym__exp] = STATE(20799),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(913),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1716),
    [anon_sym_BQUOTE] = ACTIONS(1718),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1720),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1722),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [524] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8465),
    [sym__minus] = STATE(22072),
    [sym_qualified_operator] = STATE(8465),
    [sym__qvarop_nominus] = STATE(1672),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1666),
    [sym_qualified_constructor_operator] = STATE(1666),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21500),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10494),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10494),
    [sym_exp_cond] = STATE(10494),
    [sym_exp_if_guard] = STATE(10494),
    [sym_exp_case] = STATE(10494),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10494),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10494),
    [sym__lexp] = STATE(10494),
    [sym_exp_infix] = STATE(10494),
    [sym__exp_infix] = STATE(10494),
    [sym__exp] = STATE(20535),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(868),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1730),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [525] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8325),
    [sym__minus] = STATE(23326),
    [sym_qualified_operator] = STATE(8325),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1621),
    [sym_qualified_constructor_operator] = STATE(1621),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22720),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10084),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10084),
    [sym_exp_cond] = STATE(10084),
    [sym_exp_if_guard] = STATE(10084),
    [sym_exp_case] = STATE(10084),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10084),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10084),
    [sym__lexp] = STATE(10084),
    [sym_exp_infix] = STATE(10084),
    [sym__exp_infix] = STATE(10084),
    [sym__exp] = STATE(20583),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(909),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [526] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8326),
    [sym__minus] = STATE(22772),
    [sym_qualified_operator] = STATE(8326),
    [sym__qvarop_nominus] = STATE(1744),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1544),
    [sym_qualified_constructor_operator] = STATE(1544),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21545),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10195),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10195),
    [sym_exp_cond] = STATE(10195),
    [sym_exp_if_guard] = STATE(10195),
    [sym_exp_case] = STATE(10195),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10195),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10195),
    [sym__lexp] = STATE(10195),
    [sym_exp_infix] = STATE(10195),
    [sym__exp_infix] = STATE(10195),
    [sym__exp] = STATE(20674),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(884),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(341),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(367),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [527] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8445),
    [sym__minus] = STATE(22473),
    [sym_qualified_operator] = STATE(8445),
    [sym__qvarop_nominus] = STATE(1708),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1547),
    [sym_qualified_constructor_operator] = STATE(1547),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22855),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10055),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10055),
    [sym_exp_cond] = STATE(10055),
    [sym_exp_if_guard] = STATE(10055),
    [sym_exp_case] = STATE(10055),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10055),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10055),
    [sym__lexp] = STATE(10055),
    [sym_exp_infix] = STATE(10055),
    [sym__exp_infix] = STATE(10055),
    [sym__exp] = STATE(20411),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(891),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(381),
    [anon_sym_BQUOTE] = ACTIONS(383),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [528] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8355),
    [sym__minus] = STATE(22211),
    [sym_qualified_operator] = STATE(8355),
    [sym__qvarop_nominus] = STATE(1673),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1517),
    [sym_qualified_constructor_operator] = STATE(1517),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21788),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10513),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10513),
    [sym_exp_cond] = STATE(10513),
    [sym_exp_if_guard] = STATE(10513),
    [sym_exp_case] = STATE(10513),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10513),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10513),
    [sym__lexp] = STATE(10513),
    [sym_exp_infix] = STATE(10513),
    [sym__exp_infix] = STATE(10513),
    [sym__exp] = STATE(20987),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(908),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1738),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [529] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8424),
    [sym__minus] = STATE(23288),
    [sym_qualified_operator] = STATE(8424),
    [sym__qvarop_nominus] = STATE(1715),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1467),
    [sym_qualified_constructor_operator] = STATE(1467),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23152),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10538),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10538),
    [sym_exp_cond] = STATE(10538),
    [sym_exp_if_guard] = STATE(10538),
    [sym_exp_case] = STATE(10538),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10538),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10538),
    [sym__lexp] = STATE(10538),
    [sym_exp_infix] = STATE(10538),
    [sym__exp_infix] = STATE(10538),
    [sym__exp] = STATE(20377),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(888),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [anon_sym_BQUOTE] = ACTIONS(1742),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1744),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1746),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [530] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8390),
    [sym__minus] = STATE(22755),
    [sym_qualified_operator] = STATE(8390),
    [sym__qvarop_nominus] = STATE(1739),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1491),
    [sym_qualified_constructor_operator] = STATE(1491),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22620),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10561),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10561),
    [sym_exp_cond] = STATE(10561),
    [sym_exp_if_guard] = STATE(10561),
    [sym_exp_case] = STATE(10561),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10561),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10561),
    [sym__lexp] = STATE(10561),
    [sym_exp_infix] = STATE(10561),
    [sym__exp_infix] = STATE(10561),
    [sym__exp] = STATE(20523),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(863),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1754),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [531] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8461),
    [sym__minus] = STATE(22702),
    [sym_qualified_operator] = STATE(8461),
    [sym__qvarop_nominus] = STATE(1733),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1552),
    [sym_qualified_constructor_operator] = STATE(1552),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22307),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10566),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10566),
    [sym_exp_cond] = STATE(10566),
    [sym_exp_if_guard] = STATE(10566),
    [sym_exp_case] = STATE(10566),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10566),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10566),
    [sym__lexp] = STATE(10566),
    [sym_exp_infix] = STATE(10566),
    [sym__exp_infix] = STATE(10566),
    [sym__exp] = STATE(20866),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(912),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1756),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(355),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [532] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8357),
    [sym__minus] = STATE(21535),
    [sym_qualified_operator] = STATE(8357),
    [sym__qvarop_nominus] = STATE(1706),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1524),
    [sym_qualified_constructor_operator] = STATE(1524),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21999),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10512),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10512),
    [sym_exp_cond] = STATE(10512),
    [sym_exp_if_guard] = STATE(10512),
    [sym_exp_case] = STATE(10512),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10512),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10512),
    [sym__lexp] = STATE(10512),
    [sym_exp_infix] = STATE(10512),
    [sym__exp_infix] = STATE(10512),
    [sym__exp] = STATE(21169),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(904),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1766),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [533] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8444),
    [sym__minus] = STATE(21327),
    [sym_qualified_operator] = STATE(8444),
    [sym__qvarop_nominus] = STATE(1704),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1540),
    [sym_qualified_constructor_operator] = STATE(1540),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21324),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10475),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10475),
    [sym_exp_cond] = STATE(10475),
    [sym_exp_if_guard] = STATE(10475),
    [sym_exp_case] = STATE(10475),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10475),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10475),
    [sym__lexp] = STATE(10475),
    [sym_exp_infix] = STATE(10475),
    [sym__exp_infix] = STATE(10475),
    [sym__exp] = STATE(21239),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(873),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_BQUOTE] = ACTIONS(1770),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1774),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [534] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8418),
    [sym__minus] = STATE(21677),
    [sym_qualified_operator] = STATE(8418),
    [sym__qvarop_nominus] = STATE(1756),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1408),
    [sym_qualified_constructor_operator] = STATE(1408),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23289),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10090),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10090),
    [sym_exp_cond] = STATE(10090),
    [sym_exp_if_guard] = STATE(10090),
    [sym_exp_case] = STATE(10090),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10090),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10090),
    [sym__lexp] = STATE(10090),
    [sym_exp_infix] = STATE(10090),
    [sym__exp_infix] = STATE(10090),
    [sym__exp] = STATE(20964),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(864),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(327),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [535] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8315),
    [sym__minus] = STATE(21768),
    [sym_qualified_operator] = STATE(8315),
    [sym__qvarop_nominus] = STATE(1721),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1636),
    [sym_qualified_constructor_operator] = STATE(1636),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21664),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10469),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10469),
    [sym_exp_cond] = STATE(10469),
    [sym_exp_if_guard] = STATE(10469),
    [sym_exp_case] = STATE(10469),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10469),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10469),
    [sym__lexp] = STATE(10469),
    [sym_exp_infix] = STATE(10469),
    [sym__exp_infix] = STATE(10469),
    [sym__exp] = STATE(21061),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(883),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1776),
    [anon_sym_BQUOTE] = ACTIONS(1778),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1782),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [536] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8416),
    [sym__minus] = STATE(22656),
    [sym_qualified_operator] = STATE(8416),
    [sym__qvarop_nominus] = STATE(1716),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1500),
    [sym_qualified_constructor_operator] = STATE(1500),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22336),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10534),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10534),
    [sym_exp_cond] = STATE(10534),
    [sym_exp_if_guard] = STATE(10534),
    [sym_exp_case] = STATE(10534),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10534),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10534),
    [sym__lexp] = STATE(10534),
    [sym_exp_infix] = STATE(10534),
    [sym__exp_infix] = STATE(10534),
    [sym__exp] = STATE(20700),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(871),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [anon_sym_BQUOTE] = ACTIONS(1786),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1790),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [537] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8400),
    [sym__minus] = STATE(21402),
    [sym_qualified_operator] = STATE(8400),
    [sym__qvarop_nominus] = STATE(1675),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1549),
    [sym_qualified_constructor_operator] = STATE(1549),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22378),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10187),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10187),
    [sym_exp_cond] = STATE(10187),
    [sym_exp_if_guard] = STATE(10187),
    [sym_exp_case] = STATE(10187),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10187),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10187),
    [sym__lexp] = STATE(10187),
    [sym_exp_infix] = STATE(10187),
    [sym__exp_infix] = STATE(10187),
    [sym__exp] = STATE(20868),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(914),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_BQUOTE] = ACTIONS(307),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(311),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [538] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8415),
    [sym__minus] = STATE(22758),
    [sym_qualified_operator] = STATE(8415),
    [sym__qvarop_nominus] = STATE(1676),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1303),
    [sym_qualified_constructor_operator] = STATE(1303),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23388),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9942),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9942),
    [sym_exp_cond] = STATE(9942),
    [sym_exp_if_guard] = STATE(9942),
    [sym_exp_case] = STATE(9942),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9942),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9942),
    [sym__lexp] = STATE(9942),
    [sym_exp_infix] = STATE(9942),
    [sym__exp_infix] = STATE(9942),
    [sym__exp] = STATE(20929),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(880),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1792),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(353),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1794),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [539] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8327),
    [sym__minus] = STATE(22834),
    [sym_qualified_operator] = STATE(8327),
    [sym__qvarop_nominus] = STATE(1760),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1469),
    [sym_qualified_constructor_operator] = STATE(1469),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22979),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10573),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10573),
    [sym_exp_cond] = STATE(10573),
    [sym_exp_if_guard] = STATE(10573),
    [sym_exp_case] = STATE(10573),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10573),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10573),
    [sym__lexp] = STATE(10573),
    [sym_exp_infix] = STATE(10573),
    [sym__exp_infix] = STATE(10573),
    [sym__exp] = STATE(20189),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(879),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(1796),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [540] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8393),
    [sym__minus] = STATE(23096),
    [sym_qualified_operator] = STATE(8393),
    [sym__qvarop_nominus] = STATE(1764),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1360),
    [sym_qualified_constructor_operator] = STATE(1360),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22667),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10539),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10539),
    [sym_exp_cond] = STATE(10539),
    [sym_exp_if_guard] = STATE(10539),
    [sym_exp_case] = STATE(10539),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10539),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10539),
    [sym__lexp] = STATE(10539),
    [sym_exp_infix] = STATE(10539),
    [sym__exp_infix] = STATE(10539),
    [sym__exp] = STATE(21174),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(892),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(319),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [541] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8366),
    [sym__minus] = STATE(22484),
    [sym_qualified_operator] = STATE(8366),
    [sym__qvarop_nominus] = STATE(1741),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1345),
    [sym_qualified_constructor_operator] = STATE(1345),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21794),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10202),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10202),
    [sym_exp_cond] = STATE(10202),
    [sym_exp_if_guard] = STATE(10202),
    [sym_exp_case] = STATE(10202),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10202),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10202),
    [sym__lexp] = STATE(10202),
    [sym_exp_infix] = STATE(10202),
    [sym__exp_infix] = STATE(10202),
    [sym__exp] = STATE(21079),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(894),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [542] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8388),
    [sym__minus] = STATE(23421),
    [sym_qualified_operator] = STATE(8388),
    [sym__qvarop_nominus] = STATE(1747),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1632),
    [sym_qualified_constructor_operator] = STATE(1632),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22806),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10570),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10570),
    [sym_exp_cond] = STATE(10570),
    [sym_exp_if_guard] = STATE(10570),
    [sym_exp_case] = STATE(10570),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10570),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10570),
    [sym__lexp] = STATE(10570),
    [sym_exp_infix] = STATE(10570),
    [sym__exp_infix] = STATE(10570),
    [sym__exp] = STATE(20391),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(878),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(1804),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1806),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(343),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [543] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8449),
    [sym__minus] = STATE(21988),
    [sym_qualified_operator] = STATE(8449),
    [sym__qvarop_nominus] = STATE(1714),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1406),
    [sym_qualified_constructor_operator] = STATE(1406),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22601),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10172),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10172),
    [sym_exp_cond] = STATE(10172),
    [sym_exp_if_guard] = STATE(10172),
    [sym_exp_case] = STATE(10172),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10172),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10172),
    [sym__lexp] = STATE(10172),
    [sym_exp_infix] = STATE(10172),
    [sym__exp_infix] = STATE(10172),
    [sym__exp] = STATE(20563),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(889),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(421),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [544] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8348),
    [sym__minus] = STATE(21606),
    [sym_qualified_operator] = STATE(8348),
    [sym__qvarop_nominus] = STATE(1694),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1472),
    [sym_qualified_constructor_operator] = STATE(1472),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22162),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10545),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10545),
    [sym_exp_cond] = STATE(10545),
    [sym_exp_if_guard] = STATE(10545),
    [sym_exp_case] = STATE(10545),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10545),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10545),
    [sym__lexp] = STATE(10545),
    [sym_exp_infix] = STATE(10545),
    [sym__exp_infix] = STATE(10545),
    [sym__exp] = STATE(21049),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(870),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(373),
    [anon_sym_BQUOTE] = ACTIONS(1808),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1810),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [545] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8383),
    [sym__minus] = STATE(22585),
    [sym_qualified_operator] = STATE(8383),
    [sym__qvarop_nominus] = STATE(1702),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1336),
    [sym_qualified_constructor_operator] = STATE(1336),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23047),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10007),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10007),
    [sym_exp_cond] = STATE(10007),
    [sym_exp_if_guard] = STATE(10007),
    [sym_exp_case] = STATE(10007),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10007),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10007),
    [sym__lexp] = STATE(10007),
    [sym_exp_infix] = STATE(10007),
    [sym__exp_infix] = STATE(10007),
    [sym__exp] = STATE(20363),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(874),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [546] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8364),
    [sym__minus] = STATE(21840),
    [sym_qualified_operator] = STATE(8364),
    [sym__qvarop_nominus] = STATE(1748),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1603),
    [sym_qualified_constructor_operator] = STATE(1603),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21312),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10564),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10564),
    [sym_exp_cond] = STATE(10564),
    [sym_exp_if_guard] = STATE(10564),
    [sym_exp_case] = STATE(10564),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10564),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10564),
    [sym__lexp] = STATE(10564),
    [sym_exp_infix] = STATE(10564),
    [sym__exp_infix] = STATE(10564),
    [sym__exp] = STATE(20688),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(903),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1816),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1818),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [547] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8354),
    [sym__minus] = STATE(22706),
    [sym_qualified_operator] = STATE(8354),
    [sym__qvarop_nominus] = STATE(1735),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1494),
    [sym_qualified_constructor_operator] = STATE(1494),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22461),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10556),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10556),
    [sym_exp_cond] = STATE(10556),
    [sym_exp_if_guard] = STATE(10556),
    [sym_exp_case] = STATE(10556),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10556),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10556),
    [sym__lexp] = STATE(10556),
    [sym_exp_infix] = STATE(10556),
    [sym__exp_infix] = STATE(10556),
    [sym__exp] = STATE(20624),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(895),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1826),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [548] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8346),
    [sym__minus] = STATE(22371),
    [sym_qualified_operator] = STATE(8346),
    [sym__qvarop_nominus] = STATE(1753),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1507),
    [sym_qualified_constructor_operator] = STATE(1507),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(23120),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10069),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10069),
    [sym_exp_cond] = STATE(10069),
    [sym_exp_if_guard] = STATE(10069),
    [sym_exp_case] = STATE(10069),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10069),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10069),
    [sym__lexp] = STATE(10069),
    [sym_exp_infix] = STATE(10069),
    [sym__exp_infix] = STATE(10069),
    [sym__exp] = STATE(20434),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(906),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(393),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [549] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8362),
    [sym__minus] = STATE(21309),
    [sym_qualified_operator] = STATE(8362),
    [sym__qvarop_nominus] = STATE(1713),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1582),
    [sym_qualified_constructor_operator] = STATE(1582),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21845),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10493),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10493),
    [sym_exp_cond] = STATE(10493),
    [sym_exp_if_guard] = STATE(10493),
    [sym_exp_case] = STATE(10493),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10493),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10493),
    [sym__lexp] = STATE(10493),
    [sym_exp_infix] = STATE(10493),
    [sym__exp_infix] = STATE(10493),
    [sym__exp] = STATE(21278),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(896),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1834),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [550] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8341),
    [sym__minus] = STATE(22412),
    [sym_qualified_operator] = STATE(8341),
    [sym__qvarop_nominus] = STATE(1677),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1515),
    [sym_qualified_constructor_operator] = STATE(1515),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21929),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10519),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10519),
    [sym_exp_cond] = STATE(10519),
    [sym_exp_if_guard] = STATE(10519),
    [sym_exp_case] = STATE(10519),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10519),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10519),
    [sym__lexp] = STATE(10519),
    [sym_exp_infix] = STATE(10519),
    [sym__exp_infix] = STATE(10519),
    [sym__exp] = STATE(20904),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(887),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(1836),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1838),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [551] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8404),
    [sym__minus] = STATE(22819),
    [sym_qualified_operator] = STATE(8404),
    [sym__qvarop_nominus] = STATE(1683),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1404),
    [sym_qualified_constructor_operator] = STATE(1404),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(22811),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10579),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10579),
    [sym_exp_cond] = STATE(10579),
    [sym_exp_if_guard] = STATE(10579),
    [sym_exp_case] = STATE(10579),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10579),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10579),
    [sym__lexp] = STATE(10579),
    [sym_exp_infix] = STATE(10579),
    [sym__exp_infix] = STATE(10579),
    [sym__exp] = STATE(20634),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(862),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1846),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [552] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_operator] = STATE(8405),
    [sym__minus] = STATE(21994),
    [sym_qualified_operator] = STATE(8405),
    [sym__qvarop_nominus] = STATE(1681),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym_constructor_operator] = STATE(1531),
    [sym_qualified_constructor_operator] = STATE(1531),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym__exp_tuple] = STATE(21461),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10467),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10467),
    [sym_exp_cond] = STATE(10467),
    [sym_exp_if_guard] = STATE(10467),
    [sym_exp_case] = STATE(10467),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10467),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10467),
    [sym__lexp] = STATE(10467),
    [sym_exp_infix] = STATE(10467),
    [sym__exp_infix] = STATE(10467),
    [sym__exp] = STATE(21150),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11220),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(861),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(285),
    [sym__consym] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1854),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [553] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(553),
    [sym_exp_lambda] = STATE(10778),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(10778),
    [sym_exp_cond] = STATE(10778),
    [sym_exp_if_guard] = STATE(10778),
    [sym_exp_case] = STATE(10778),
    [sym_exp_lambda_case] = STATE(553),
    [sym_exp_lambda_cases] = STATE(553),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(553),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(553),
    [sym__exp_apply] = STATE(10778),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_RPAREN] = ACTIONS(1858),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_using] = ACTIONS(1864),
    [anon_sym_then] = ACTIONS(1864),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_of] = ACTIONS(1864),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [554] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(553),
    [sym_exp_lambda] = STATE(10778),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(10778),
    [sym_exp_cond] = STATE(10778),
    [sym_exp_if_guard] = STATE(10778),
    [sym_exp_case] = STATE(10778),
    [sym_exp_lambda_case] = STATE(553),
    [sym_exp_lambda_cases] = STATE(553),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(553),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(553),
    [sym__exp_apply] = STATE(10778),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(1895),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_using] = ACTIONS(1892),
    [anon_sym_then] = ACTIONS(1892),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_else] = ACTIONS(1892),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_of] = ACTIONS(1892),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [555] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(556),
    [sym_exp_lambda] = STATE(10833),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10833),
    [sym_exp_cond] = STATE(10833),
    [sym_exp_if_guard] = STATE(10833),
    [sym_exp_case] = STATE(10833),
    [sym_exp_lambda_case] = STATE(556),
    [sym_exp_lambda_cases] = STATE(556),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(556),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(556),
    [sym__exp_apply] = STATE(10833),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1892),
    [anon_sym_then] = ACTIONS(1892),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_else] = ACTIONS(1892),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_of] = ACTIONS(1892),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [556] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(556),
    [sym_exp_lambda] = STATE(10833),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10833),
    [sym_exp_cond] = STATE(10833),
    [sym_exp_if_guard] = STATE(10833),
    [sym_exp_case] = STATE(10833),
    [sym_exp_lambda_case] = STATE(556),
    [sym_exp_lambda_cases] = STATE(556),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(556),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(556),
    [sym__exp_apply] = STATE(10833),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(1858),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1864),
    [anon_sym_then] = ACTIONS(1864),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_of] = ACTIONS(1864),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [557] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(558),
    [sym_exp_lambda] = STATE(11286),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(11286),
    [sym_exp_cond] = STATE(11286),
    [sym_exp_if_guard] = STATE(11286),
    [sym_exp_case] = STATE(11286),
    [sym_exp_lambda_case] = STATE(558),
    [sym_exp_lambda_cases] = STATE(558),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(558),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(558),
    [sym__exp_apply] = STATE(11286),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_EQ] = ACTIONS(1889),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1889),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [558] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(558),
    [sym_exp_lambda] = STATE(11286),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(11286),
    [sym_exp_cond] = STATE(11286),
    [sym_exp_if_guard] = STATE(11286),
    [sym_exp_case] = STATE(11286),
    [sym_exp_lambda_case] = STATE(558),
    [sym_exp_lambda_cases] = STATE(558),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(558),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(558),
    [sym__exp_apply] = STATE(11286),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1858),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_EQ] = ACTIONS(1858),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1858),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [559] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22656),
    [sym__minus] = STATE(22656),
    [sym_qualified_operator] = STATE(22656),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22321),
    [sym_qualified_constructor_operator] = STATE(22321),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22320),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [560] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22954),
    [sym__minus] = STATE(22954),
    [sym_qualified_operator] = STATE(22954),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23309),
    [sym_qualified_constructor_operator] = STATE(23309),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23308),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [561] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22072),
    [sym__minus] = STATE(22072),
    [sym_qualified_operator] = STATE(22072),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22531),
    [sym_qualified_constructor_operator] = STATE(22531),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22110),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [562] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23138),
    [sym__minus] = STATE(23138),
    [sym_qualified_operator] = STATE(23138),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22951),
    [sym_qualified_constructor_operator] = STATE(22951),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22949),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [563] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21364),
    [sym__minus] = STATE(21364),
    [sym_qualified_operator] = STATE(21364),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22582),
    [sym_qualified_constructor_operator] = STATE(22582),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21741),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [564] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22204),
    [sym__minus] = STATE(22204),
    [sym_qualified_operator] = STATE(22204),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22451),
    [sym_qualified_constructor_operator] = STATE(22451),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22033),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [565] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21775),
    [sym__minus] = STATE(21775),
    [sym_qualified_operator] = STATE(21775),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21536),
    [sym_qualified_constructor_operator] = STATE(21536),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22063),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [566] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21354),
    [sym__minus] = STATE(21354),
    [sym_qualified_operator] = STATE(21354),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21314),
    [sym_qualified_constructor_operator] = STATE(21314),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21439),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [567] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22327),
    [sym__minus] = STATE(22327),
    [sym_qualified_operator] = STATE(22327),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22467),
    [sym_qualified_constructor_operator] = STATE(22467),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21509),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [568] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23226),
    [sym__minus] = STATE(23226),
    [sym_qualified_operator] = STATE(23226),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22864),
    [sym_qualified_constructor_operator] = STATE(22864),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22862),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [569] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21768),
    [sym__minus] = STATE(21768),
    [sym_qualified_operator] = STATE(21768),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22612),
    [sym_qualified_constructor_operator] = STATE(22612),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22203),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [570] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22758),
    [sym__minus] = STATE(22758),
    [sym_qualified_operator] = STATE(22758),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22245),
    [sym_qualified_constructor_operator] = STATE(22245),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21377),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [571] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21988),
    [sym__minus] = STATE(21988),
    [sym_qualified_operator] = STATE(21988),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22763),
    [sym_qualified_constructor_operator] = STATE(22763),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21986),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [572] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22888),
    [sym__minus] = STATE(22888),
    [sym_qualified_operator] = STATE(22888),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22820),
    [sym_qualified_constructor_operator] = STATE(22820),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22453),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [573] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23369),
    [sym__minus] = STATE(23369),
    [sym_qualified_operator] = STATE(23369),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21987),
    [sym_qualified_constructor_operator] = STATE(21987),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21849),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [574] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21445),
    [sym__minus] = STATE(21445),
    [sym_qualified_operator] = STATE(21445),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21308),
    [sym_qualified_constructor_operator] = STATE(21308),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22198),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [575] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22363),
    [sym__minus] = STATE(22363),
    [sym_qualified_operator] = STATE(22363),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21573),
    [sym_qualified_constructor_operator] = STATE(21573),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22579),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [576] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22318),
    [sym__minus] = STATE(22318),
    [sym_qualified_operator] = STATE(22318),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22374),
    [sym_qualified_constructor_operator] = STATE(22374),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21952),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [577] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22023),
    [sym__minus] = STATE(22023),
    [sym_qualified_operator] = STATE(22023),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22024),
    [sym_qualified_constructor_operator] = STATE(22024),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22025),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [578] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22436),
    [sym__minus] = STATE(22436),
    [sym_qualified_operator] = STATE(22436),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21998),
    [sym_qualified_constructor_operator] = STATE(21998),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21871),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [579] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21851),
    [sym__minus] = STATE(21851),
    [sym_qualified_operator] = STATE(21851),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21607),
    [sym_qualified_constructor_operator] = STATE(21607),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21904),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [580] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21995),
    [sym__minus] = STATE(21995),
    [sym_qualified_operator] = STATE(21995),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21996),
    [sym_qualified_constructor_operator] = STATE(21996),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21997),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [581] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21967),
    [sym__minus] = STATE(21967),
    [sym_qualified_operator] = STATE(21967),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21968),
    [sym_qualified_constructor_operator] = STATE(21968),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21969),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [582] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21939),
    [sym__minus] = STATE(21939),
    [sym_qualified_operator] = STATE(21939),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21940),
    [sym_qualified_constructor_operator] = STATE(21940),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21941),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [583] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21309),
    [sym__minus] = STATE(21309),
    [sym_qualified_operator] = STATE(21309),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22901),
    [sym_qualified_constructor_operator] = STATE(22901),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22532),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [584] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21613),
    [sym__minus] = STATE(21613),
    [sym_qualified_operator] = STATE(21613),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21444),
    [sym_qualified_constructor_operator] = STATE(21444),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22313),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [585] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22882),
    [sym__minus] = STATE(22882),
    [sym_qualified_operator] = STATE(22882),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21370),
    [sym_qualified_constructor_operator] = STATE(21370),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22332),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [586] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22492),
    [sym__minus] = STATE(22492),
    [sym_qualified_operator] = STATE(22492),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22753),
    [sym_qualified_constructor_operator] = STATE(22753),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22747),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [587] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23288),
    [sym__minus] = STATE(23288),
    [sym_qualified_operator] = STATE(23288),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22808),
    [sym_qualified_constructor_operator] = STATE(22808),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22807),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [588] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22473),
    [sym__minus] = STATE(22473),
    [sym_qualified_operator] = STATE(22473),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21510),
    [sym_qualified_constructor_operator] = STATE(21510),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22700),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [589] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22211),
    [sym__minus] = STATE(22211),
    [sym_qualified_operator] = STATE(22211),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21350),
    [sym_qualified_constructor_operator] = STATE(21350),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21490),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [590] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23021),
    [sym__minus] = STATE(23021),
    [sym_qualified_operator] = STATE(23021),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23020),
    [sym_qualified_constructor_operator] = STATE(23020),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22465),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [591] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22893),
    [sym__minus] = STATE(22893),
    [sym_qualified_operator] = STATE(22893),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22889),
    [sym_qualified_constructor_operator] = STATE(22889),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22886),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [592] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21480),
    [sym__minus] = STATE(21480),
    [sym_qualified_operator] = STATE(21480),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21612),
    [sym_qualified_constructor_operator] = STATE(21612),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22441),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [593] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21911),
    [sym__minus] = STATE(21911),
    [sym_qualified_operator] = STATE(21911),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21912),
    [sym_qualified_constructor_operator] = STATE(21912),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21913),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [594] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21883),
    [sym__minus] = STATE(21883),
    [sym_qualified_operator] = STATE(21883),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21884),
    [sym_qualified_constructor_operator] = STATE(21884),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21885),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [595] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21948),
    [sym__minus] = STATE(21948),
    [sym_qualified_operator] = STATE(21948),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21678),
    [sym_qualified_constructor_operator] = STATE(21678),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21765),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [596] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22585),
    [sym__minus] = STATE(22585),
    [sym_qualified_operator] = STATE(22585),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22130),
    [sym_qualified_constructor_operator] = STATE(22130),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22831),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [597] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22005),
    [sym__minus] = STATE(22005),
    [sym_qualified_operator] = STATE(22005),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21755),
    [sym_qualified_constructor_operator] = STATE(21755),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22768),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [598] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21906),
    [sym__minus] = STATE(21906),
    [sym_qualified_operator] = STATE(21906),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21767),
    [sym_qualified_constructor_operator] = STATE(21767),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22592),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [599] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21535),
    [sym__minus] = STATE(21535),
    [sym_qualified_operator] = STATE(21535),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23017),
    [sym_qualified_constructor_operator] = STATE(23017),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22625),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [600] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22371),
    [sym__minus] = STATE(22371),
    [sym_qualified_operator] = STATE(22371),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22294),
    [sym_qualified_constructor_operator] = STATE(22294),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21784),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [601] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21855),
    [sym__minus] = STATE(21855),
    [sym_qualified_operator] = STATE(21855),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21856),
    [sym_qualified_constructor_operator] = STATE(21856),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21857),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [602] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21761),
    [sym__minus] = STATE(21761),
    [sym_qualified_operator] = STATE(21761),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22329),
    [sym_qualified_constructor_operator] = STATE(22329),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22127),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [603] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22049),
    [sym__minus] = STATE(22049),
    [sym_qualified_operator] = STATE(22049),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22050),
    [sym_qualified_constructor_operator] = STATE(22050),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22051),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [604] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(12006),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12006),
    [sym_exp_cond] = STATE(12006),
    [sym_exp_if_guard] = STATE(12006),
    [sym_exp_case] = STATE(12006),
    [sym_exp_lambda_case] = STATE(604),
    [sym_exp_lambda_cases] = STATE(604),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(604),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(12006),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1858),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1858),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1858),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [605] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21402),
    [sym__minus] = STATE(21402),
    [sym_qualified_operator] = STATE(21402),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21482),
    [sym_qualified_constructor_operator] = STATE(21482),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23327),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [606] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21799),
    [sym__minus] = STATE(21799),
    [sym_qualified_operator] = STATE(21799),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21800),
    [sym_qualified_constructor_operator] = STATE(21800),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21801),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [607] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21771),
    [sym__minus] = STATE(21771),
    [sym_qualified_operator] = STATE(21771),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21772),
    [sym_qualified_constructor_operator] = STATE(21772),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21773),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [608] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22702),
    [sym__minus] = STATE(22702),
    [sym_qualified_operator] = STATE(22702),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22362),
    [sym_qualified_constructor_operator] = STATE(22362),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23018),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [609] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21840),
    [sym__minus] = STATE(21840),
    [sym_qualified_operator] = STATE(21840),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22065),
    [sym_qualified_constructor_operator] = STATE(22065),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22766),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [610] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22457),
    [sym__minus] = STATE(22457),
    [sym_qualified_operator] = STATE(22457),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22703),
    [sym_qualified_constructor_operator] = STATE(22703),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22699),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [611] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21606),
    [sym__minus] = STATE(21606),
    [sym_qualified_operator] = STATE(21606),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23164),
    [sym_qualified_constructor_operator] = STATE(23164),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22676),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [612] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23348),
    [sym__minus] = STATE(23348),
    [sym_qualified_operator] = STATE(23348),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22493),
    [sym_qualified_constructor_operator] = STATE(22493),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22725),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [613] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22412),
    [sym__minus] = STATE(22412),
    [sym_qualified_operator] = STATE(22412),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22654),
    [sym_qualified_constructor_operator] = STATE(22654),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22652),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [614] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21743),
    [sym__minus] = STATE(21743),
    [sym_qualified_operator] = STATE(21743),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21680),
    [sym_qualified_constructor_operator] = STATE(21680),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21745),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [615] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21697),
    [sym__minus] = STATE(21697),
    [sym_qualified_operator] = STATE(21697),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21699),
    [sym_qualified_constructor_operator] = STATE(21699),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22875),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [616] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23401),
    [sym__minus] = STATE(23401),
    [sym_qualified_operator] = STATE(23401),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22659),
    [sym_qualified_constructor_operator] = STATE(22659),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22821),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [617] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23421),
    [sym__minus] = STATE(23421),
    [sym_qualified_operator] = STATE(23421),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23227),
    [sym_qualified_constructor_operator] = STATE(23227),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22906),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [618] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23419),
    [sym__minus] = STATE(23419),
    [sym_qualified_operator] = STATE(23419),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23294),
    [sym_qualified_constructor_operator] = STATE(23294),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23023),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [619] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23400),
    [sym__minus] = STATE(23400),
    [sym_qualified_operator] = STATE(23400),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23351),
    [sym_qualified_constructor_operator] = STATE(23351),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23165),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [620] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23357),
    [sym__minus] = STATE(23357),
    [sym_qualified_operator] = STATE(23357),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22105),
    [sym_qualified_constructor_operator] = STATE(22105),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23233),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [621] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23311),
    [sym__minus] = STATE(23311),
    [sym_qualified_operator] = STATE(23311),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22199),
    [sym_qualified_constructor_operator] = STATE(22199),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23296),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [622] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22289),
    [sym__minus] = STATE(22289),
    [sym_qualified_operator] = STATE(22289),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22767),
    [sym_qualified_constructor_operator] = STATE(22767),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21682),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [623] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23176),
    [sym__minus] = STATE(23176),
    [sym_qualified_operator] = STATE(23176),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23403),
    [sym_qualified_constructor_operator] = STATE(23403),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23363),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [624] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23220),
    [sym__minus] = STATE(23220),
    [sym_qualified_operator] = STATE(23220),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23423),
    [sym_qualified_constructor_operator] = STATE(23423),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23404),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [625] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21382),
    [sym__minus] = STATE(21382),
    [sym_qualified_operator] = STATE(21382),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21447),
    [sym_qualified_constructor_operator] = STATE(21447),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21598),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [626] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21715),
    [sym__minus] = STATE(21715),
    [sym_qualified_operator] = STATE(21715),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21942),
    [sym_qualified_constructor_operator] = STATE(21942),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21717),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [627] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21379),
    [sym__minus] = STATE(21379),
    [sym_qualified_operator] = STATE(21379),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21436),
    [sym_qualified_constructor_operator] = STATE(21436),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21353),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [628] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21313),
    [sym__minus] = STATE(21313),
    [sym_qualified_operator] = STATE(21313),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21328),
    [sym_qualified_constructor_operator] = STATE(21328),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21403),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [629] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22447),
    [sym__minus] = STATE(22447),
    [sym_qualified_operator] = STATE(22447),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22202),
    [sym_qualified_constructor_operator] = STATE(22202),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22958),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [630] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22365),
    [sym__minus] = STATE(22365),
    [sym_qualified_operator] = STATE(22365),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22600),
    [sym_qualified_constructor_operator] = STATE(22600),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22597),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [631] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21406),
    [sym__minus] = STATE(21406),
    [sym_qualified_operator] = STATE(21406),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21405),
    [sym_qualified_constructor_operator] = STATE(21405),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21556),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [632] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21687),
    [sym__minus] = STATE(21687),
    [sym_qualified_operator] = STATE(21687),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21991),
    [sym_qualified_constructor_operator] = STATE(21991),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21689),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [633] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21864),
    [sym__minus] = STATE(21864),
    [sym_qualified_operator] = STATE(21864),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21865),
    [sym_qualified_constructor_operator] = STATE(21865),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21989),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [634] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22528),
    [sym__minus] = STATE(22528),
    [sym_qualified_operator] = STATE(22528),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23418),
    [sym_qualified_constructor_operator] = STATE(23418),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23425),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [635] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21677),
    [sym__minus] = STATE(21677),
    [sym_qualified_operator] = STATE(21677),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22021),
    [sym_qualified_constructor_operator] = STATE(22021),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21616),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [636] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22669),
    [sym__minus] = STATE(22669),
    [sym_qualified_operator] = STATE(22669),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22672),
    [sym_qualified_constructor_operator] = STATE(22672),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22298),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [637] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22020),
    [sym__minus] = STATE(22020),
    [sym_qualified_operator] = STATE(22020),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21780),
    [sym_qualified_constructor_operator] = STATE(21780),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21608),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [638] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21327),
    [sym__minus] = STATE(21327),
    [sym_qualified_operator] = STATE(21327),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21744),
    [sym_qualified_constructor_operator] = STATE(21744),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21661),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [639] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22323),
    [sym__minus] = STATE(22323),
    [sym_qualified_operator] = STATE(22323),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22548),
    [sym_qualified_constructor_operator] = STATE(22548),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22546),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [640] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22054),
    [sym__minus] = STATE(22054),
    [sym_qualified_operator] = STATE(22054),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22058),
    [sym_qualified_constructor_operator] = STATE(22058),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21367),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [641] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22037),
    [sym__minus] = STATE(22037),
    [sym_qualified_operator] = STATE(22037),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21352),
    [sym_qualified_constructor_operator] = STATE(21352),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21348),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [642] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22190),
    [sym__minus] = STATE(22190),
    [sym_qualified_operator] = STATE(22190),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22961),
    [sym_qualified_constructor_operator] = STATE(22961),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21552),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [643] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21994),
    [sym__minus] = STATE(21994),
    [sym_qualified_operator] = STATE(21994),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21380),
    [sym_qualified_constructor_operator] = STATE(21380),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21315),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [644] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22988),
    [sym__minus] = STATE(22988),
    [sym_qualified_operator] = STATE(22988),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23039),
    [sym_qualified_constructor_operator] = STATE(23039),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23038),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [645] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22594),
    [sym__minus] = STATE(22594),
    [sym_qualified_operator] = STATE(22594),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22314),
    [sym_qualified_constructor_operator] = STATE(22314),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23129),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [646] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21827),
    [sym__minus] = STATE(21827),
    [sym_qualified_operator] = STATE(21827),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21828),
    [sym_qualified_constructor_operator] = STATE(21828),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21829),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [647] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22194),
    [sym__minus] = STATE(22194),
    [sym_qualified_operator] = STATE(22194),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22490),
    [sym_qualified_constructor_operator] = STATE(22490),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22488),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [648] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22819),
    [sym__minus] = STATE(22819),
    [sym_qualified_operator] = STATE(22819),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23180),
    [sym_qualified_constructor_operator] = STATE(23180),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23050),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [649] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22834),
    [sym__minus] = STATE(22834),
    [sym_qualified_operator] = STATE(22834),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23323),
    [sym_qualified_constructor_operator] = STATE(23323),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23320),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [650] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21351),
    [sym__minus] = STATE(21351),
    [sym_qualified_operator] = STATE(21351),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21408),
    [sym_qualified_constructor_operator] = STATE(21408),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21329),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [651] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22755),
    [sym__minus] = STATE(22755),
    [sym_qualified_operator] = STATE(22755),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22456),
    [sym_qualified_constructor_operator] = STATE(22456),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22454),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [652] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22772),
    [sym__minus] = STATE(22772),
    [sym_qualified_operator] = STATE(22772),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22442),
    [sym_qualified_constructor_operator] = STATE(22442),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23391),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [653] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22221),
    [sym__minus] = STATE(22221),
    [sym_qualified_operator] = STATE(22221),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22223),
    [sym_qualified_constructor_operator] = STATE(22223),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21483),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [654] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22706),
    [sym__minus] = STATE(22706),
    [sym_qualified_operator] = STATE(22706),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22280),
    [sym_qualified_constructor_operator] = STATE(22280),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22405),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [655] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21560),
    [sym__minus] = STATE(21560),
    [sym_qualified_operator] = STATE(21560),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21559),
    [sym_qualified_constructor_operator] = STATE(21559),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21711),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [656] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21830),
    [sym__minus] = STATE(21830),
    [sym_qualified_operator] = STATE(21830),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21881),
    [sym_qualified_constructor_operator] = STATE(21881),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21990),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [657] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21659),
    [sym__minus] = STATE(21659),
    [sym_qualified_operator] = STATE(21659),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21716),
    [sym_qualified_constructor_operator] = STATE(21716),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21633),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [658] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22131),
    [sym__minus] = STATE(22131),
    [sym_qualified_operator] = STATE(22131),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22345),
    [sym_qualified_constructor_operator] = STATE(22345),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21701),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [659] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(12006),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12006),
    [sym_exp_cond] = STATE(12006),
    [sym_exp_if_guard] = STATE(12006),
    [sym_exp_case] = STATE(12006),
    [sym_exp_lambda_case] = STATE(604),
    [sym_exp_lambda_cases] = STATE(604),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(604),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(12006),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1889),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1889),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [660] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(660),
    [sym_exp_lambda] = STATE(11913),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(11913),
    [sym_exp_cond] = STATE(11913),
    [sym_exp_if_guard] = STATE(11913),
    [sym_exp_case] = STATE(11913),
    [sym_exp_lambda_case] = STATE(660),
    [sym_exp_lambda_cases] = STATE(660),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(660),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(660),
    [sym__exp_apply] = STATE(11913),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1858),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1858),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [661] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21600),
    [sym__minus] = STATE(21600),
    [sym_qualified_operator] = STATE(21600),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21599),
    [sym_qualified_constructor_operator] = STATE(21599),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21763),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [662] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23326),
    [sym__minus] = STATE(23326),
    [sym_qualified_operator] = STATE(23326),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22096),
    [sym_qualified_constructor_operator] = STATE(22096),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22244),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [663] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22163),
    [sym__minus] = STATE(22163),
    [sym_qualified_operator] = STATE(22163),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21296),
    [sym_qualified_constructor_operator] = STATE(21296),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22361),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [664] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22648),
    [sym__minus] = STATE(22648),
    [sym_qualified_operator] = STATE(22648),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22701),
    [sym_qualified_constructor_operator] = STATE(22701),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21869),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [665] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22810),
    [sym__minus] = STATE(22810),
    [sym_qualified_operator] = STATE(22810),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23219),
    [sym_qualified_constructor_operator] = STATE(23219),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23215),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [666] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22824),
    [sym__minus] = STATE(22824),
    [sym_qualified_operator] = STATE(22824),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22826),
    [sym_qualified_constructor_operator] = STATE(22826),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22076),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [667] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22922),
    [sym__minus] = STATE(22922),
    [sym_qualified_operator] = STATE(22922),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21905),
    [sym_qualified_constructor_operator] = STATE(21905),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23397),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [668] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22606),
    [sym__minus] = STATE(22606),
    [sym_qualified_operator] = STATE(22606),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23354),
    [sym_qualified_constructor_operator] = STATE(23354),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23353),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [669] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22963),
    [sym__minus] = STATE(22963),
    [sym_qualified_operator] = STATE(22963),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22593),
    [sym_qualified_constructor_operator] = STATE(22593),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23117),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [670] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(660),
    [sym_exp_lambda] = STATE(11913),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(11913),
    [sym_exp_cond] = STATE(11913),
    [sym_exp_if_guard] = STATE(11913),
    [sym_exp_case] = STATE(11913),
    [sym_exp_lambda_case] = STATE(660),
    [sym_exp_lambda_cases] = STATE(660),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(660),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(660),
    [sym__exp_apply] = STATE(11913),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1889),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1889),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [671] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22602),
    [sym__minus] = STATE(22602),
    [sym_qualified_operator] = STATE(22602),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22274),
    [sym_qualified_constructor_operator] = STATE(22274),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22273),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [672] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22990),
    [sym__minus] = STATE(22990),
    [sym_qualified_operator] = STATE(22990),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22996),
    [sym_qualified_constructor_operator] = STATE(22996),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22225),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [673] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22865),
    [sym__minus] = STATE(22865),
    [sym_qualified_operator] = STATE(22865),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23269),
    [sym_qualified_constructor_operator] = STATE(23269),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23268),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [674] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21491),
    [sym__minus] = STATE(21491),
    [sym_qualified_operator] = STATE(21491),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21548),
    [sym_qualified_constructor_operator] = STATE(21548),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21465),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [675] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21655),
    [sym__minus] = STATE(21655),
    [sym_qualified_operator] = STATE(21655),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21653),
    [sym_qualified_constructor_operator] = STATE(21653),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21824),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [676] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23183),
    [sym__minus] = STATE(23183),
    [sym_qualified_operator] = STATE(23183),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23399),
    [sym_qualified_constructor_operator] = STATE(23399),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23417),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [677] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23096),
    [sym__minus] = STATE(23096),
    [sym_qualified_operator] = STATE(23096),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21949),
    [sym_qualified_constructor_operator] = STATE(21949),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21307),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [678] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23135),
    [sym__minus] = STATE(23135),
    [sym_qualified_operator] = STATE(23135),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22876),
    [sym_qualified_constructor_operator] = STATE(22876),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22997),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [679] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22095),
    [sym__minus] = STATE(22095),
    [sym_qualified_operator] = STATE(22095),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22206),
    [sym_qualified_constructor_operator] = STATE(22206),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22205),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [680] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22101),
    [sym__minus] = STATE(22101),
    [sym_qualified_operator] = STATE(22101),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21854),
    [sym_qualified_constructor_operator] = STATE(21854),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21440),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [681] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21603),
    [sym__minus] = STATE(21603),
    [sym_qualified_operator] = STATE(21603),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21660),
    [sym_qualified_constructor_operator] = STATE(21660),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21577),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [682] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21575),
    [sym__minus] = STATE(21575),
    [sym_qualified_operator] = STATE(21575),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21632),
    [sym_qualified_constructor_operator] = STATE(21632),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21549),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [683] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22246),
    [sym__minus] = STATE(22246),
    [sym_qualified_operator] = STATE(22246),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22832),
    [sym_qualified_constructor_operator] = STATE(22832),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22359),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [684] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21407),
    [sym__minus] = STATE(21407),
    [sym_qualified_operator] = STATE(21407),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21464),
    [sym_qualified_constructor_operator] = STATE(21464),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21381),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [685] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21547),
    [sym__minus] = STATE(21547),
    [sym_qualified_operator] = STATE(21547),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21604),
    [sym_qualified_constructor_operator] = STATE(21604),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21521),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [686] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22549),
    [sym__minus] = STATE(22549),
    [sym_qualified_operator] = STATE(22549),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22161),
    [sym_qualified_constructor_operator] = STATE(22161),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22160),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [687] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22719),
    [sym__minus] = STATE(22719),
    [sym_qualified_operator] = STATE(22719),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22724),
    [sym_qualified_constructor_operator] = STATE(22724),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22376),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [688] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21511),
    [sym__minus] = STATE(21511),
    [sym_qualified_operator] = STATE(21511),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23114),
    [sym_qualified_constructor_operator] = STATE(23114),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22348),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [689] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21944),
    [sym__minus] = STATE(21944),
    [sym_qualified_operator] = STATE(21944),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22094),
    [sym_qualified_constructor_operator] = STATE(22094),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22091),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [690] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21882),
    [sym__minus] = STATE(21882),
    [sym_qualified_operator] = STATE(21882),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(22036),
    [sym_qualified_constructor_operator] = STATE(22036),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22035),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [691] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21714),
    [sym__minus] = STATE(21714),
    [sym_qualified_operator] = STATE(21714),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21712),
    [sym_qualified_constructor_operator] = STATE(21712),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21877),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [692] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21435),
    [sym__minus] = STATE(21435),
    [sym_qualified_operator] = STATE(21435),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21492),
    [sym_qualified_constructor_operator] = STATE(21492),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21409),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [693] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22484),
    [sym__minus] = STATE(22484),
    [sym_qualified_operator] = STATE(22484),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23131),
    [sym_qualified_constructor_operator] = STATE(23131),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22828),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [694] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21503),
    [sym__minus] = STATE(21503),
    [sym_qualified_operator] = STATE(21503),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21494),
    [sym_qualified_constructor_operator] = STATE(21494),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21652),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [695] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21519),
    [sym__minus] = STATE(21519),
    [sym_qualified_operator] = STATE(21519),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21576),
    [sym_qualified_constructor_operator] = STATE(21576),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21493),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [696] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(23398),
    [sym__minus] = STATE(23398),
    [sym_qualified_operator] = STATE(23398),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23372),
    [sym_qualified_constructor_operator] = STATE(23372),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22505),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [697] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21770),
    [sym__minus] = STATE(21770),
    [sym_qualified_operator] = STATE(21770),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21826),
    [sym_qualified_constructor_operator] = STATE(21826),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21938),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [698] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21463),
    [sym__minus] = STATE(21463),
    [sym_qualified_operator] = STATE(21463),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21520),
    [sym_qualified_constructor_operator] = STATE(21520),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21437),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [699] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(21631),
    [sym__minus] = STATE(21631),
    [sym_qualified_operator] = STATE(21631),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(21688),
    [sym_qualified_constructor_operator] = STATE(21688),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21605),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [700] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_operator] = STATE(22343),
    [sym__minus] = STATE(22343),
    [sym_qualified_operator] = STATE(22343),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym_constructor_operator] = STATE(23396),
    [sym_qualified_constructor_operator] = STATE(23396),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22660),
    [sym__modid] = STATE(23392),
    [aux_sym__qualifying_module] = STATE(11234),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym__varsym] = ACTIONS(437),
    [sym__consym] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [701] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22589),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15670),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18303),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2011),
  },
  [702] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21934),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(22985),
    [sym_qualified_constructor_operator] = STATE(21932),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22985),
    [sym_qualified_type_operator] = STATE(21932),
    [sym__qualified_type_operator] = STATE(21932),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(23182),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22220),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18638),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(22737),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19599),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2023),
    [anon_sym_DASH_GT] = ACTIONS(2023),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_RPAREN] = ACTIONS(2027),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [703] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22967),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16081),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19848),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2053),
  },
  [704] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22253),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15964),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18609),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2055),
  },
  [705] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22778),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16207),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18176),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2057),
  },
  [706] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22077),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15782),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18771),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2059),
  },
  [707] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22286),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16103),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19740),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2061),
  },
  [708] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21473),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16078),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19226),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2063),
  },
  [709] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23360),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15691),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(20122),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2065),
  },
  [710] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21683),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16238),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19081),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2067),
  },
  [711] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22817),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16080),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18153),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2069),
  },
  [712] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22644),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15956),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18264),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2071),
  },
  [713] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22598),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15958),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18295),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2073),
  },
  [714] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22966),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15659),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18057),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2075),
  },
  [715] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22070),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15756),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19646),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2077),
  },
  [716] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22710),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15738),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18219),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2079),
  },
  [717] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21853),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16122),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18946),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2081),
  },
  [718] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22208),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15628),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18652),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2083),
  },
  [719] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23144),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16143),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(17938),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2085),
  },
  [720] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21776),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15983),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19009),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2087),
  },
  [721] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22840),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16155),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18141),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2089),
  },
  [722] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23032),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15643),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18021),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2091),
  },
  [723] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22012),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15635),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18830),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2093),
  },
  [724] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21832),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15775),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19582),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2095),
  },
  [725] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(22793),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22793),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(23208),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(22670),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2101),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [726] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21766),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16156),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19017),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2105),
  },
  [727] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22330),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15728),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18520),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2107),
  },
  [728] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22028),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15963),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18800),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2109),
  },
  [729] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(729),
    [sym_exp_lambda] = STATE(12371),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(12371),
    [sym_exp_cond] = STATE(12371),
    [sym_exp_if_guard] = STATE(12371),
    [sym_exp_case] = STATE(12371),
    [sym_exp_lambda_case] = STATE(729),
    [sym_exp_lambda_cases] = STATE(729),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(729),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(729),
    [sym__exp_apply] = STATE(12371),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_in] = ACTIONS(1864),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__layout_end] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [730] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23356),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15797),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(17881),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2152),
  },
  [731] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21412),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15917),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19409),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2154),
  },
  [732] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23089),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15783),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(17967),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2156),
  },
  [733] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22370),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16002),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18495),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2158),
  },
  [734] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21311),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16205),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19362),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2160),
  },
  [735] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(729),
    [sym_exp_lambda] = STATE(12371),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(12371),
    [sym_exp_cond] = STATE(12371),
    [sym_exp_if_guard] = STATE(12371),
    [sym_exp_case] = STATE(12371),
    [sym_exp_lambda_case] = STATE(729),
    [sym_exp_lambda_cases] = STATE(729),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(729),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(729),
    [sym__exp_apply] = STATE(12371),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_in] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__layout_end] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [736] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22982),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16048),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18053),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2166),
  },
  [737] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21916),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15889),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2168),
  },
  [738] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22480),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15890),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18384),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2170),
  },
  [739] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22452),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15895),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18414),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2172),
  },
  [740] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(23430),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15825),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(17846),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2174),
  },
  [741] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21453),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16188),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19247),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2176),
  },
  [742] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21531),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15662),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19200),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2178),
  },
  [743] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22207),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15855),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18642),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2180),
  },
  [744] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22322),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15737),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18533),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2182),
  },
  [745] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21934),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(22985),
    [sym_qualified_constructor_operator] = STATE(21932),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22985),
    [sym_qualified_type_operator] = STATE(21932),
    [sym__qualified_type_operator] = STATE(21932),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(23182),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22220),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18677),
    [sym__constraint_context] = STATE(18677),
    [sym__constraint] = STATE(18677),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18638),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(22737),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19599),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2023),
    [anon_sym_DASH_GT] = ACTIONS(2023),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_RPAREN] = ACTIONS(2027),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [746] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(23187),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23187),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(23194),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(22991),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2184),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [747] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22478),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16223),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18387),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2186),
  },
  [748] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21355),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19392),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2188),
  },
  [749] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22147),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15843),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18713),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2190),
  },
  [750] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22713),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(15940),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19918),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2192),
  },
  [751] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(22970),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16230),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(18052),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2194),
  },
  [752] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(22564),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22564),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(22562),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(23195),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [753] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym__exp_unboxed_sum] = STATE(21622),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9715),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9715),
    [sym_exp_cond] = STATE(9715),
    [sym_exp_if_guard] = STATE(9715),
    [sym_exp_case] = STATE(9715),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9715),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9715),
    [sym__lexp] = STATE(9715),
    [sym_exp_infix] = STATE(9715),
    [sym__exp_infix] = STATE(9715),
    [sym__exp] = STATE(16118),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [aux_sym__exp_tuple_repeat1] = STATE(19128),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(18055),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(589),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(2198),
  },
  [754] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(758),
    [sym_exp_lambda] = STATE(13041),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(13041),
    [sym_exp_cond] = STATE(13041),
    [sym_exp_if_guard] = STATE(13041),
    [sym_exp_case] = STATE(13041),
    [sym_exp_lambda_case] = STATE(758),
    [sym_exp_lambda_cases] = STATE(758),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(758),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(758),
    [sym__exp_apply] = STATE(13041),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym__varid] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [755] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(755),
    [sym_exp_lambda] = STATE(12861),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(12861),
    [sym_exp_cond] = STATE(12861),
    [sym_exp_if_guard] = STATE(12861),
    [sym_exp_case] = STATE(12861),
    [sym_exp_lambda_case] = STATE(755),
    [sym_exp_lambda_cases] = STATE(755),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(755),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(755),
    [sym__exp_apply] = STATE(12861),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2263),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1864),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__layout_end] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [756] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(760),
    [sym_exp_lambda] = STATE(13012),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(13012),
    [sym_exp_cond] = STATE(13012),
    [sym_exp_if_guard] = STATE(13012),
    [sym_exp_case] = STATE(13012),
    [sym_exp_lambda_case] = STATE(760),
    [sym_exp_lambda_cases] = STATE(760),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(760),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(760),
    [sym__exp_apply] = STATE(13012),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_in] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [757] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(755),
    [sym_exp_lambda] = STATE(12861),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(12861),
    [sym_exp_cond] = STATE(12861),
    [sym_exp_if_guard] = STATE(12861),
    [sym_exp_case] = STATE(12861),
    [sym_exp_lambda_case] = STATE(755),
    [sym_exp_lambda_cases] = STATE(755),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(755),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(755),
    [sym__exp_apply] = STATE(12861),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2263),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_in] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__layout_end] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [758] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(758),
    [sym_exp_lambda] = STATE(13041),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(13041),
    [sym_exp_cond] = STATE(13041),
    [sym_exp_if_guard] = STATE(13041),
    [sym_exp_case] = STATE(13041),
    [sym_exp_lambda_case] = STATE(758),
    [sym_exp_lambda_cases] = STATE(758),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(758),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(758),
    [sym__exp_apply] = STATE(13041),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym__varid] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(2329),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [759] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(759),
    [sym_exp_lambda] = STATE(13183),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(13183),
    [sym_exp_cond] = STATE(13183),
    [sym_exp_if_guard] = STATE(13183),
    [sym_exp_case] = STATE(13183),
    [sym_exp_lambda_case] = STATE(759),
    [sym_exp_lambda_cases] = STATE(759),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(759),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(759),
    [sym__exp_apply] = STATE(13183),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1858),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(1858),
  },
  [760] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(760),
    [sym_exp_lambda] = STATE(13012),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(13012),
    [sym_exp_cond] = STATE(13012),
    [sym_exp_if_guard] = STATE(13012),
    [sym_exp_case] = STATE(13012),
    [sym_exp_lambda_case] = STATE(760),
    [sym_exp_lambda_cases] = STATE(760),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(760),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(760),
    [sym__exp_apply] = STATE(13012),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_in] = ACTIONS(1864),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [761] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(761),
    [sym_exp_lambda] = STATE(13222),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(13222),
    [sym_exp_cond] = STATE(13222),
    [sym_exp_if_guard] = STATE(13222),
    [sym_exp_case] = STATE(13222),
    [sym_exp_lambda_case] = STATE(761),
    [sym_exp_lambda_cases] = STATE(761),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(761),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(761),
    [sym__exp_apply] = STATE(13222),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__layout_end] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [762] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(759),
    [sym_exp_lambda] = STATE(13183),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(13183),
    [sym_exp_cond] = STATE(13183),
    [sym_exp_if_guard] = STATE(13183),
    [sym_exp_case] = STATE(13183),
    [sym_exp_lambda_case] = STATE(759),
    [sym_exp_lambda_cases] = STATE(759),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(759),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(759),
    [sym__exp_apply] = STATE(13183),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1889),
    [sym_quasiquote_start] = ACTIONS(591),
    [sym__unboxed_close] = ACTIONS(1889),
  },
  [763] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(761),
    [sym_exp_lambda] = STATE(13222),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(13222),
    [sym_exp_cond] = STATE(13222),
    [sym_exp_if_guard] = STATE(13222),
    [sym_exp_case] = STATE(13222),
    [sym_exp_lambda_case] = STATE(761),
    [sym_exp_lambda_cases] = STATE(761),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(761),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(761),
    [sym__exp_apply] = STATE(13222),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__layout_end] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [764] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21692),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21690),
    [sym_qualified_constructor_operator] = STATE(21690),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21690),
    [sym_qualified_type_operator] = STATE(21690),
    [sym__qualified_type_operator] = STATE(21690),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21690),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21746),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19573),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19575),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2389),
    [anon_sym_DASH_GT] = ACTIONS(2389),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2393),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2397),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [765] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [766] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18997),
    [sym_gdpat] = STATE(11995),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20297),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11995),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [767] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21525),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21526),
    [sym_qualified_constructor_operator] = STATE(21526),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21526),
    [sym_qualified_type_operator] = STATE(21526),
    [sym__qualified_type_operator] = STATE(21526),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21526),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21555),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19194),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19135),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2405),
    [anon_sym_DASH_GT] = ACTIONS(2405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2407),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2411),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [768] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21934),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21932),
    [sym_qualified_constructor_operator] = STATE(21932),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21932),
    [sym_qualified_type_operator] = STATE(21932),
    [sym__qualified_type_operator] = STATE(21932),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21932),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22220),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18638),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19599),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2023),
    [anon_sym_DASH_GT] = ACTIONS(2023),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2027),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [769] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21752),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21747),
    [sym_qualified_constructor_operator] = STATE(21747),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21747),
    [sym_qualified_type_operator] = STATE(21747),
    [sym__qualified_type_operator] = STATE(21747),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21747),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21858),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19589),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19590),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2415),
    [anon_sym_DASH_GT] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2417),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2419),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2421),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [770] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21330),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21331),
    [sym_qualified_constructor_operator] = STATE(21331),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21331),
    [sym_qualified_type_operator] = STATE(21331),
    [sym__qualified_type_operator] = STATE(21331),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21331),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21359),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19336),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19278),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2423),
    [anon_sym_DASH_GT] = ACTIONS(2423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2425),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2429),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [771] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23259),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23258),
    [sym_qualified_constructor_operator] = STATE(23258),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23258),
    [sym_qualified_type_operator] = STATE(23258),
    [sym__qualified_type_operator] = STATE(23258),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23258),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2431),
    [anon_sym_DASH_GT] = ACTIONS(2431),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [772] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22680),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22690),
    [sym_qualified_constructor_operator] = STATE(22690),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22690),
    [sym_qualified_type_operator] = STATE(22690),
    [sym__qualified_type_operator] = STATE(22690),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22690),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22765),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20012),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2435),
    [anon_sym_DASH_GT] = ACTIONS(2435),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2437),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2441),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [773] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(791),
    [sym_exp_lambda] = STATE(13417),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(13417),
    [sym_exp_cond] = STATE(13417),
    [sym_exp_if_guard] = STATE(13417),
    [sym_exp_case] = STATE(13417),
    [sym_exp_lambda_case] = STATE(791),
    [sym_exp_lambda_cases] = STATE(791),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(791),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(791),
    [sym__exp_apply] = STATE(13417),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym__varid] = ACTIONS(2443),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(2451),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(73),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [774] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23422),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23424),
    [sym_qualified_constructor_operator] = STATE(23424),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23424),
    [sym_qualified_type_operator] = STATE(23424),
    [sym__qualified_type_operator] = STATE(23424),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22777),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19916),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18624),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2473),
    [anon_sym_DASH_GT] = ACTIONS(2473),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2475),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2479),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [775] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18385),
    [sym_gdpat] = STATE(11567),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20294),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11567),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [776] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22760),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22678),
    [sym_qualified_constructor_operator] = STATE(22678),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22678),
    [sym_qualified_type_operator] = STATE(22678),
    [sym__qualified_type_operator] = STATE(22678),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22678),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22521),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18355),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17940),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2481),
    [anon_sym_DASH_GT] = ACTIONS(2481),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2485),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2487),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [777] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21749),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21750),
    [sym_qualified_constructor_operator] = STATE(21750),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21750),
    [sym_qualified_type_operator] = STATE(21750),
    [sym__qualified_type_operator] = STATE(21750),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21750),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21751),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19031),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18971),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2489),
    [anon_sym_DASH_GT] = ACTIONS(2489),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2493),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2495),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [778] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22516),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22518),
    [sym_qualified_constructor_operator] = STATE(22518),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22518),
    [sym_qualified_type_operator] = STATE(22518),
    [sym__qualified_type_operator] = STATE(22518),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22518),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22368),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18493),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18037),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2497),
    [anon_sym_DASH_GT] = ACTIONS(2497),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2499),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2503),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [779] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21811),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21809),
    [sym_qualified_constructor_operator] = STATE(21809),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21809),
    [sym_qualified_type_operator] = STATE(21809),
    [sym__qualified_type_operator] = STATE(21809),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21809),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21924),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19614),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19615),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2505),
    [anon_sym_DASH_GT] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2507),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2511),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [780] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(17875),
    [sym_gdpat] = STATE(10776),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20319),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(10776),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [781] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22315),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22312),
    [sym_qualified_constructor_operator] = STATE(22312),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22312),
    [sym_qualified_type_operator] = STATE(22312),
    [sym__qualified_type_operator] = STATE(22312),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22312),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22396),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19783),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19785),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2513),
    [anon_sym_DASH_GT] = ACTIONS(2513),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2517),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2519),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [782] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18817),
    [sym_gdpat] = STATE(11242),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20316),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11242),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [783] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23426),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23428),
    [sym_qualified_constructor_operator] = STATE(23428),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23428),
    [sym_qualified_type_operator] = STATE(23428),
    [sym__qualified_type_operator] = STATE(23428),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23428),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23413),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20184),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20078),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2521),
    [anon_sym_DASH_GT] = ACTIONS(2521),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [784] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22379),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22384),
    [sym_qualified_constructor_operator] = STATE(22384),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22384),
    [sym_qualified_type_operator] = STATE(22384),
    [sym__qualified_type_operator] = STATE(22384),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22384),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22464),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19777),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19923),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2529),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2531),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2535),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [785] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18217),
    [sym_gdpat] = STATE(11514),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20341),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11514),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [786] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18016),
    [sym_gdpat] = STATE(10900),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20354),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(10900),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [787] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(17969),
    [sym_gdpat] = STATE(11921),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20392),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11921),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [788] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21808),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [789] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18302),
    [sym_gdpat] = STATE(11923),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20335),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11923),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [790] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18134),
    [sym_gdpat] = STATE(10481),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20309),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(10481),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [791] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(791),
    [sym_exp_lambda] = STATE(13417),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(13417),
    [sym_exp_cond] = STATE(13417),
    [sym_exp_if_guard] = STATE(13417),
    [sym_exp_case] = STATE(13417),
    [sym_exp_lambda_case] = STATE(791),
    [sym_exp_lambda_cases] = STATE(791),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(791),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(791),
    [sym__exp_apply] = STATE(13417),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym__varid] = ACTIONS(2443),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(73),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [792] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21777),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21778),
    [sym_qualified_constructor_operator] = STATE(21778),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21778),
    [sym_qualified_type_operator] = STATE(21778),
    [sym__qualified_type_operator] = STATE(21778),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21778),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21779),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19007),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18945),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2542),
    [anon_sym_DASH_GT] = ACTIONS(2542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2544),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2548),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [793] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(19182),
    [sym_gdpat] = STATE(11245),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20305),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11245),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [794] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18494),
    [sym_gdpat] = STATE(11411),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20331),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11411),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [795] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21441),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21442),
    [sym_qualified_constructor_operator] = STATE(21442),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21442),
    [sym_qualified_type_operator] = STATE(21442),
    [sym__qualified_type_operator] = STATE(21442),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21442),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21471),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19253),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19197),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2550),
    [anon_sym_DASH_GT] = ACTIONS(2550),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2556),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [796] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(17875),
    [sym_gdpat] = STATE(10713),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20365),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(10713),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [797] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22357),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22351),
    [sym_qualified_constructor_operator] = STATE(22351),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22351),
    [sym_qualified_type_operator] = STATE(22351),
    [sym__qualified_type_operator] = STATE(22351),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22351),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22439),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19798),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19799),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2558),
    [anon_sym_DASH_GT] = ACTIONS(2558),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2564),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [798] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(798),
    [sym_exp_lambda] = STATE(13289),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(13289),
    [sym_exp_cond] = STATE(13289),
    [sym_exp_if_guard] = STATE(13289),
    [sym_exp_case] = STATE(13289),
    [sym_exp_lambda_case] = STATE(798),
    [sym_exp_lambda_cases] = STATE(798),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(798),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(798),
    [sym__exp_apply] = STATE(13289),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__layout_end] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(229),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [799] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(19182),
    [sym_gdpat] = STATE(11353),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20291),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11353),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [800] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23273),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23299),
    [sym_qualified_constructor_operator] = STATE(23299),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23299),
    [sym_qualified_type_operator] = STATE(23299),
    [sym__qualified_type_operator] = STATE(23299),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23299),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [801] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22683),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22682),
    [sym_qualified_constructor_operator] = STATE(22682),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22682),
    [sym_qualified_type_operator] = STATE(22682),
    [sym__qualified_type_operator] = STATE(22682),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22682),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2599),
    [anon_sym_DASH_GT] = ACTIONS(2599),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [802] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21301),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21300),
    [sym_qualified_constructor_operator] = STATE(21300),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21300),
    [sym_qualified_type_operator] = STATE(21300),
    [sym__qualified_type_operator] = STATE(21300),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21300),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21564),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19382),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19593),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2603),
    [anon_sym_DASH_GT] = ACTIONS(2603),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2605),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2607),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2609),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [803] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22218),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22226),
    [sym_qualified_constructor_operator] = STATE(22226),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22226),
    [sym_qualified_type_operator] = STATE(22226),
    [sym__qualified_type_operator] = STATE(22226),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22226),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22319),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19717),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19863),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2611),
    [anon_sym_DASH_GT] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2617),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [804] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(17969),
    [sym_gdpat] = STATE(11624),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20323),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11624),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [805] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18997),
    [sym_gdpat] = STATE(12018),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20313),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(12018),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [806] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23161),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23159),
    [sym_qualified_constructor_operator] = STATE(23159),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23159),
    [sym_qualified_type_operator] = STATE(23159),
    [sym__qualified_type_operator] = STATE(23159),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23159),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23254),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20076),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20010),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2619),
    [anon_sym_DASH_GT] = ACTIONS(2619),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2621),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2625),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [807] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(798),
    [sym_exp_lambda] = STATE(13289),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(13289),
    [sym_exp_cond] = STATE(13289),
    [sym_exp_if_guard] = STATE(13289),
    [sym_exp_case] = STATE(13289),
    [sym_exp_lambda_case] = STATE(798),
    [sym_exp_lambda_cases] = STATE(798),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(798),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(798),
    [sym__exp_apply] = STATE(13289),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__layout_end] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(229),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [808] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22912),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22936),
    [sym_qualified_constructor_operator] = STATE(22936),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22936),
    [sym_qualified_type_operator] = STATE(22936),
    [sym__qualified_type_operator] = STATE(22936),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22936),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23083),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19987),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20124),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2631),
    [anon_sym_DASH_GT] = ACTIONS(2631),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2633),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2637),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [809] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22379),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22384),
    [sym_qualified_constructor_operator] = STATE(22384),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22384),
    [sym_qualified_type_operator] = STATE(22384),
    [sym__qualified_type_operator] = STATE(22384),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22384),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2529),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [810] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21934),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21932),
    [sym_qualified_constructor_operator] = STATE(21932),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21932),
    [sym_qualified_type_operator] = STATE(21932),
    [sym__qualified_type_operator] = STATE(21932),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21932),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22220),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18677),
    [sym__constraint_context] = STATE(18677),
    [sym__constraint] = STATE(18677),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18638),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19599),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2023),
    [anon_sym_DASH_GT] = ACTIONS(2023),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2027),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [811] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(811),
    [sym_exp_lambda] = STATE(13545),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(13545),
    [sym_exp_cond] = STATE(13545),
    [sym_exp_if_guard] = STATE(13545),
    [sym_exp_case] = STATE(13545),
    [sym_exp_lambda_case] = STATE(811),
    [sym_exp_lambda_cases] = STATE(811),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(811),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(811),
    [sym__exp_apply] = STATE(13545),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_LBRACE] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_in] = ACTIONS(1864),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [812] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21833),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21834),
    [sym_qualified_constructor_operator] = STATE(21834),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21834),
    [sym_qualified_type_operator] = STATE(21834),
    [sym__qualified_type_operator] = STATE(21834),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21834),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21835),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18970),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18889),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2680),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2682),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2686),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [813] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23259),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23258),
    [sym_qualified_constructor_operator] = STATE(23258),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23258),
    [sym_qualified_type_operator] = STATE(23258),
    [sym__qualified_type_operator] = STATE(23258),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23258),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21425),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19446),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19447),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2431),
    [anon_sym_DASH_GT] = ACTIONS(2431),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2690),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [814] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21357),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21358),
    [sym_qualified_constructor_operator] = STATE(21358),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21358),
    [sym_qualified_type_operator] = STATE(21358),
    [sym__qualified_type_operator] = STATE(21358),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21358),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21387),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19323),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19254),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2692),
    [anon_sym_DASH_GT] = ACTIONS(2692),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2694),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2698),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [815] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21927),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21925),
    [sym_qualified_constructor_operator] = STATE(21925),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21925),
    [sym_qualified_type_operator] = STATE(21925),
    [sym__qualified_type_operator] = STATE(21925),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21925),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21955),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19649),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19650),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2700),
    [anon_sym_DASH_GT] = ACTIONS(2700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2706),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [816] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(19395),
    [sym_gdpat] = STATE(10930),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20288),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(10930),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [817] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(830),
    [sym_exp_lambda] = STATE(13492),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(13492),
    [sym_exp_cond] = STATE(13492),
    [sym_exp_if_guard] = STATE(13492),
    [sym_exp_case] = STATE(13492),
    [sym_exp_lambda_case] = STATE(830),
    [sym_exp_lambda_cases] = STATE(830),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(830),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(830),
    [sym__exp_apply] = STATE(13492),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [anon_sym_u2192] = ACTIONS(1889),
    [anon_sym_DASH_GT] = ACTIONS(1889),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2720),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
    [sym__unboxed_close] = ACTIONS(1889),
  },
  [818] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22543),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22541),
    [sym_qualified_constructor_operator] = STATE(22541),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22541),
    [sym_qualified_type_operator] = STATE(22541),
    [sym__qualified_type_operator] = STATE(22541),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22541),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22641),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19871),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19873),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2724),
    [anon_sym_DASH_GT] = ACTIONS(2724),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2730),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [819] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18016),
    [sym_gdpat] = STATE(11513),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20329),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11513),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [820] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21868),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21860),
    [sym_qualified_constructor_operator] = STATE(21860),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21860),
    [sym_qualified_type_operator] = STATE(21860),
    [sym__qualified_type_operator] = STATE(21860),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21860),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21981),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19631),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19633),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2732),
    [anon_sym_DASH_GT] = ACTIONS(2732),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2736),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2738),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [821] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21485),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21479),
    [sym_qualified_constructor_operator] = STATE(21479),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21479),
    [sym_qualified_type_operator] = STATE(21479),
    [sym__qualified_type_operator] = STATE(21479),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21479),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21542),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19489),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19491),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2742),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2746),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [822] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21321),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2748),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [823] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(824),
    [sym_exp_lambda] = STATE(13317),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(13317),
    [sym_exp_cond] = STATE(13317),
    [sym_exp_if_guard] = STATE(13317),
    [sym_exp_case] = STATE(13317),
    [sym_exp_lambda_case] = STATE(824),
    [sym_exp_lambda_cases] = STATE(824),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(824),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(824),
    [sym__exp_apply] = STATE(13317),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__layout_end] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [824] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(824),
    [sym_exp_lambda] = STATE(13317),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(13317),
    [sym_exp_cond] = STATE(13317),
    [sym_exp_if_guard] = STATE(13317),
    [sym_exp_case] = STATE(13317),
    [sym_exp_lambda_case] = STATE(824),
    [sym_exp_lambda_cases] = STATE(824),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(824),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(824),
    [sym__exp_apply] = STATE(13317),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__layout_end] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [825] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(857),
    [sym_exp_lambda] = STATE(13487),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(13487),
    [sym_exp_cond] = STATE(13487),
    [sym_exp_if_guard] = STATE(13487),
    [sym_exp_case] = STATE(13487),
    [sym_exp_lambda_case] = STATE(857),
    [sym_exp_lambda_cases] = STATE(857),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(857),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(857),
    [sym__exp_apply] = STATE(13487),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_DOT_DOT] = ACTIONS(1889),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1889),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [826] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22680),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22690),
    [sym_qualified_constructor_operator] = STATE(22690),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22690),
    [sym_qualified_type_operator] = STATE(22690),
    [sym__qualified_type_operator] = STATE(22690),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22690),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2435),
    [anon_sym_DASH_GT] = ACTIONS(2435),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [827] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23406),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23407),
    [sym_qualified_constructor_operator] = STATE(23407),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23407),
    [sym_qualified_type_operator] = STATE(23407),
    [sym__qualified_type_operator] = STATE(23407),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23407),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21806),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20156),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20094),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2837),
    [anon_sym_DASH_GT] = ACTIONS(2837),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2839),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2841),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2843),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [828] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(847),
    [sym_exp_lambda] = STATE(13272),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(13272),
    [sym_exp_cond] = STATE(13272),
    [sym_exp_if_guard] = STATE(13272),
    [sym_exp_case] = STATE(13272),
    [sym_exp_lambda_case] = STATE(847),
    [sym_exp_lambda_cases] = STATE(847),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(847),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(847),
    [sym__exp_apply] = STATE(13272),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym__varid] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [829] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18134),
    [sym_gdpat] = STATE(10583),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20349),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(10583),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [830] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(830),
    [sym_exp_lambda] = STATE(13492),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(13492),
    [sym_exp_cond] = STATE(13492),
    [sym_exp_if_guard] = STATE(13492),
    [sym_exp_case] = STATE(13492),
    [sym_exp_lambda_case] = STATE(830),
    [sym_exp_lambda_cases] = STATE(830),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(830),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(830),
    [sym__exp_apply] = STATE(13492),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [anon_sym_u2192] = ACTIONS(1858),
    [anon_sym_DASH_GT] = ACTIONS(1858),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2720),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
    [sym__unboxed_close] = ACTIONS(1858),
  },
  [831] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23099),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [832] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22683),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22682),
    [sym_qualified_constructor_operator] = STATE(22682),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22682),
    [sym_qualified_type_operator] = STATE(22682),
    [sym__qualified_type_operator] = STATE(22682),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22682),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22928),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17961),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18543),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2599),
    [anon_sym_DASH_GT] = ACTIONS(2599),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2892),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2894),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [833] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18217),
    [sym_gdpat] = STATE(12248),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20338),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(12248),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [834] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(834),
    [sym_exp_lambda] = STATE(13504),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(13504),
    [sym_exp_cond] = STATE(13504),
    [sym_exp_if_guard] = STATE(13504),
    [sym_exp_case] = STATE(13504),
    [sym_exp_lambda_case] = STATE(834),
    [sym_exp_lambda_cases] = STATE(834),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(834),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(834),
    [sym__exp_apply] = STATE(13504),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [835] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21934),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21932),
    [sym_qualified_constructor_operator] = STATE(21932),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21932),
    [sym_qualified_type_operator] = STATE(21932),
    [sym__qualified_type_operator] = STATE(21932),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21932),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18677),
    [sym__constraint_context] = STATE(18677),
    [sym__constraint] = STATE(18677),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2023),
    [anon_sym_DASH_GT] = ACTIONS(2023),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [836] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22001),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22002),
    [sym_qualified_constructor_operator] = STATE(22002),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22002),
    [sym_qualified_type_operator] = STATE(22002),
    [sym__qualified_type_operator] = STATE(22002),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22002),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22003),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18824),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18826),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2937),
    [anon_sym_DASH_GT] = ACTIONS(2937),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2943),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [837] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23332),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23329),
    [sym_qualified_constructor_operator] = STATE(23329),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23329),
    [sym_qualified_type_operator] = STATE(23329),
    [sym__qualified_type_operator] = STATE(23329),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23329),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2945),
    [anon_sym_DASH_GT] = ACTIONS(2945),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [838] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21721),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21722),
    [sym_qualified_constructor_operator] = STATE(21722),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21722),
    [sym_qualified_type_operator] = STATE(21722),
    [sym__qualified_type_operator] = STATE(21722),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21722),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21723),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19055),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18980),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2949),
    [anon_sym_DASH_GT] = ACTIONS(2949),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2955),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [839] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23230),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23223),
    [sym_qualified_constructor_operator] = STATE(23223),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23223),
    [sym_qualified_type_operator] = STATE(23223),
    [sym__qualified_type_operator] = STATE(23223),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23223),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2957),
    [anon_sym_DASH_GT] = ACTIONS(2957),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [840] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23185),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23186),
    [sym_qualified_constructor_operator] = STATE(23186),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23186),
    [sym_qualified_type_operator] = STATE(23186),
    [sym__qualified_type_operator] = STATE(23186),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23186),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23244),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20044),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20180),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2961),
    [anon_sym_DASH_GT] = ACTIONS(2961),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2967),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [841] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23273),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23299),
    [sym_qualified_constructor_operator] = STATE(23299),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23299),
    [sym_qualified_type_operator] = STATE(23299),
    [sym__qualified_type_operator] = STATE(23299),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23299),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21319),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19380),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19337),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2971),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [842] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23332),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23329),
    [sym_qualified_constructor_operator] = STATE(23329),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23329),
    [sym_qualified_type_operator] = STATE(23329),
    [sym__qualified_type_operator] = STATE(23329),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23329),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23155),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17922),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18305),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2945),
    [anon_sym_DASH_GT] = ACTIONS(2945),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2975),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [843] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21469),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21470),
    [sym_qualified_constructor_operator] = STATE(21470),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21470),
    [sym_qualified_type_operator] = STATE(21470),
    [sym__qualified_type_operator] = STATE(21470),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21470),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21499),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19229),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19169),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2977),
    [anon_sym_DASH_GT] = ACTIONS(2977),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2981),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2983),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [844] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(811),
    [sym_exp_lambda] = STATE(13545),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(13545),
    [sym_exp_cond] = STATE(13545),
    [sym_exp_if_guard] = STATE(13545),
    [sym_exp_case] = STATE(13545),
    [sym_exp_lambda_case] = STATE(811),
    [sym_exp_lambda_cases] = STATE(811),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(811),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(811),
    [sym__exp_apply] = STATE(13545),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_LBRACE] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_in] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [845] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18385),
    [sym_gdpat] = STATE(11955),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20333),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11955),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [846] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22697),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22694),
    [sym_qualified_constructor_operator] = STATE(22694),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22694),
    [sym_qualified_type_operator] = STATE(22694),
    [sym__qualified_type_operator] = STATE(22694),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22694),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22664),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19936),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19937),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2989),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2995),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [847] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(847),
    [sym_exp_lambda] = STATE(13272),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(13272),
    [sym_exp_cond] = STATE(13272),
    [sym_exp_if_guard] = STATE(13272),
    [sym_exp_case] = STATE(13272),
    [sym_exp_lambda_case] = STATE(847),
    [sym_exp_lambda_cases] = STATE(847),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(847),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(847),
    [sym__exp_apply] = STATE(13272),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym__varid] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [848] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23422),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23424),
    [sym_qualified_constructor_operator] = STATE(23424),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23424),
    [sym_qualified_type_operator] = STATE(23424),
    [sym__qualified_type_operator] = STATE(23424),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2473),
    [anon_sym_DASH_GT] = ACTIONS(2473),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [849] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22055),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22056),
    [sym_qualified_constructor_operator] = STATE(22056),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22056),
    [sym_qualified_type_operator] = STATE(22056),
    [sym__qualified_type_operator] = STATE(22056),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22056),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22057),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18783),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18785),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3000),
    [anon_sym_DASH_GT] = ACTIONS(3000),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3004),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3006),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [850] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22823),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22829),
    [sym_qualified_constructor_operator] = STATE(22829),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22829),
    [sym_qualified_type_operator] = STATE(22829),
    [sym__qualified_type_operator] = STATE(22829),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22829),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22943),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19957),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20096),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3008),
    [anon_sym_DASH_GT] = ACTIONS(3008),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(3010),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3014),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [851] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21708),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21706),
    [sym_qualified_constructor_operator] = STATE(21706),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21706),
    [sym_qualified_type_operator] = STATE(21706),
    [sym__qualified_type_operator] = STATE(21706),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21706),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22106),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18743),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19769),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3016),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3022),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [852] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(834),
    [sym_exp_lambda] = STATE(13504),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(13504),
    [sym_exp_cond] = STATE(13504),
    [sym_exp_if_guard] = STATE(13504),
    [sym_exp_case] = STATE(13504),
    [sym_exp_lambda_case] = STATE(834),
    [sym_exp_lambda_cases] = STATE(834),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(834),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(834),
    [sym__exp_apply] = STATE(13504),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [853] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21429),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21428),
    [sym_qualified_constructor_operator] = STATE(21428),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21428),
    [sym_qualified_type_operator] = STATE(21428),
    [sym__qualified_type_operator] = STATE(21428),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21428),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22364),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19270),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19563),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3028),
    [anon_sym_DASH_GT] = ACTIONS(3028),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(3030),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3034),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [854] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18817),
    [sym_gdpat] = STATE(11516),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20299),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11516),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [855] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(18494),
    [sym_gdpat] = STATE(11334),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20321),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11334),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [856] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_guards] = STATE(19395),
    [sym_gdpat] = STATE(11057),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20284),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [aux_sym_exp_if_guard_repeat1] = STATE(11057),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [857] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(857),
    [sym_exp_lambda] = STATE(13487),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(13487),
    [sym_exp_cond] = STATE(13487),
    [sym_exp_if_guard] = STATE(13487),
    [sym_exp_case] = STATE(13487),
    [sym_exp_lambda_case] = STATE(857),
    [sym_exp_lambda_cases] = STATE(857),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(857),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(857),
    [sym__exp_apply] = STATE(13487),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_DOT_DOT] = ACTIONS(1858),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1858),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [858] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23230),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23223),
    [sym_qualified_constructor_operator] = STATE(23223),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23223),
    [sym_qualified_type_operator] = STATE(23223),
    [sym__qualified_type_operator] = STATE(23223),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23223),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22410),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19792),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19389),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2957),
    [anon_sym_DASH_GT] = ACTIONS(2957),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3041),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [859] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22029),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22030),
    [sym_qualified_constructor_operator] = STATE(22030),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22030),
    [sym_qualified_type_operator] = STATE(22030),
    [sym__qualified_type_operator] = STATE(22030),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22030),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22031),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18805),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18806),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3043),
    [anon_sym_DASH_GT] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3047),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [860] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21505),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21507),
    [sym_qualified_constructor_operator] = STATE(21507),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21507),
    [sym_qualified_type_operator] = STATE(21507),
    [sym__qualified_type_operator] = STATE(21507),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21507),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21321),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(15982),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(18242),
    [sym__constraint_context] = STATE(18242),
    [sym__constraint] = STATE(18242),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19354),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18507),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3051),
    [anon_sym_DASH_GT] = ACTIONS(3051),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2748),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3053),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3055),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [861] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [862] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [863] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3065),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [864] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [865] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3069),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [866] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21458),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(22663),
    [sym_qualified_constructor_operator] = STATE(21456),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22663),
    [sym_qualified_type_operator] = STATE(21456),
    [sym__qualified_type_operator] = STATE(21456),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(22984),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21931),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18877),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(22547),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19948),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3077),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3079),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [867] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3081),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [868] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [869] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [870] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [871] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3089),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [872] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(897),
    [sym_exp_lambda] = STATE(13655),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(13655),
    [sym_exp_cond] = STATE(13655),
    [sym_exp_if_guard] = STATE(13655),
    [sym_exp_case] = STATE(13655),
    [sym_exp_lambda_case] = STATE(897),
    [sym_exp_lambda_cases] = STATE(897),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(897),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(897),
    [sym__exp_apply] = STATE(13655),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym__varid] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [873] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [874] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [875] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3123),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [876] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [877] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3127),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [878] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [879] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3131),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [880] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [881] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3135),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [882] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3137),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [883] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3139),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [884] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3141),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [885] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(885),
    [sym_exp_lambda] = STATE(13651),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(13651),
    [sym_exp_cond] = STATE(13651),
    [sym_exp_if_guard] = STATE(13651),
    [sym_exp_case] = STATE(13651),
    [sym_exp_lambda_case] = STATE(885),
    [sym_exp_lambda_cases] = STATE(885),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(885),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(885),
    [sym__exp_apply] = STATE(13651),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(3149),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__layout_end] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [886] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(886),
    [sym_exp_lambda] = STATE(13756),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(13756),
    [sym_exp_cond] = STATE(13756),
    [sym_exp_if_guard] = STATE(13756),
    [sym_exp_case] = STATE(13756),
    [sym_exp_lambda_case] = STATE(886),
    [sym_exp_lambda_cases] = STATE(886),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(886),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(886),
    [sym__exp_apply] = STATE(13756),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [887] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3199),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [888] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3201),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [889] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3203),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [890] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3205),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [891] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3207),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [892] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3209),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [893] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [894] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [895] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3215),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [896] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3217),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [897] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(897),
    [sym_exp_lambda] = STATE(13655),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(13655),
    [sym_exp_cond] = STATE(13655),
    [sym_exp_if_guard] = STATE(13655),
    [sym_exp_case] = STATE(13655),
    [sym_exp_lambda_case] = STATE(897),
    [sym_exp_lambda_cases] = STATE(897),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(897),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(897),
    [sym__exp_apply] = STATE(13655),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym__varid] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(1858),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1858),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [898] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3222),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [899] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3224),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [900] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(885),
    [sym_exp_lambda] = STATE(13651),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(13651),
    [sym_exp_cond] = STATE(13651),
    [sym_exp_if_guard] = STATE(13651),
    [sym_exp_case] = STATE(13651),
    [sym_exp_lambda_case] = STATE(885),
    [sym_exp_lambda_cases] = STATE(885),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(885),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(885),
    [sym__exp_apply] = STATE(13651),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1889),
    [sym__layout_end] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [901] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3230),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [902] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3232),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [903] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [904] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3236),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [905] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3238),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [906] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3240),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [907] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18499),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym__exp_tuple_repeat1] = STATE(18505),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3242),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3244),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [908] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3246),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [909] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3248),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [910] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(886),
    [sym_exp_lambda] = STATE(13756),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(13756),
    [sym_exp_cond] = STATE(13756),
    [sym_exp_if_guard] = STATE(13756),
    [sym_exp_case] = STATE(13756),
    [sym_exp_lambda_case] = STATE(886),
    [sym_exp_lambda_cases] = STATE(886),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(886),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(886),
    [sym__exp_apply] = STATE(13756),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1889),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [911] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21458),
    [sym_constructor] = STATE(7086),
    [sym_constructor_operator] = STATE(22542),
    [sym_qualified_constructor_operator] = STATE(21456),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22542),
    [sym_qualified_type_operator] = STATE(21456),
    [sym__qualified_type_operator] = STATE(21456),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(6568),
    [sym_annotated_type_variable] = STATE(22726),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21931),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18877),
    [sym__simpletype_infix] = STATE(15216),
    [sym__simpletype] = STATE(22737),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19948),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3079),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [912] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3256),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [913] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3258),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [914] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3260),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [915] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(18154),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [aux_sym_con_tuple_repeat1] = STATE(8198),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3061),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [916] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(918),
    [sym_exp_lambda] = STATE(14053),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(14053),
    [sym_exp_cond] = STATE(14053),
    [sym_exp_if_guard] = STATE(14053),
    [sym_exp_case] = STATE(14053),
    [sym_exp_lambda_case] = STATE(918),
    [sym_exp_lambda_cases] = STATE(918),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(918),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(918),
    [sym__exp_apply] = STATE(14053),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [anon_sym_u2237] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym__varsym] = ACTIONS(1889),
    [sym__consym] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1889),
    [sym_quasiquote_start] = ACTIONS(1604),
    [sym__unboxed_close] = ACTIONS(1889),
  },
  [917] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10151),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10151),
    [sym_exp_cond] = STATE(10151),
    [sym_exp_if_guard] = STATE(10151),
    [sym_exp_case] = STATE(10151),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10151),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10151),
    [sym__lexp] = STATE(10151),
    [sym_exp_infix] = STATE(10151),
    [sym__exp_infix] = STATE(10151),
    [sym__exp] = STATE(20936),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_PIPE] = ACTIONS(3298),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
    [sym__unboxed_close] = ACTIONS(3298),
  },
  [918] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(918),
    [sym_exp_lambda] = STATE(14053),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(14053),
    [sym_exp_cond] = STATE(14053),
    [sym_exp_if_guard] = STATE(14053),
    [sym_exp_case] = STATE(14053),
    [sym_exp_lambda_case] = STATE(918),
    [sym_exp_lambda_cases] = STATE(918),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(918),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(918),
    [sym__exp_apply] = STATE(14053),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [anon_sym_u2237] = ACTIONS(1858),
    [anon_sym_COLON_COLON] = ACTIONS(1858),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym__varsym] = ACTIONS(1858),
    [sym__consym] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1858),
    [sym_quasiquote_start] = ACTIONS(1604),
    [sym__unboxed_close] = ACTIONS(1858),
  },
  [919] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10524),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10524),
    [sym_exp_cond] = STATE(10524),
    [sym_exp_if_guard] = STATE(10524),
    [sym_exp_case] = STATE(10524),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10524),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10524),
    [sym__lexp] = STATE(10524),
    [sym_exp_infix] = STATE(10524),
    [sym__exp_infix] = STATE(10524),
    [sym__exp] = STATE(20657),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3307),
    [sym_quasiquote_start] = ACTIONS(1604),
    [sym__unboxed_close] = ACTIONS(3307),
  },
  [920] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20491),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(3307),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3307),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [921] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15083),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [922] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22141),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [923] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15111),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [924] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22268),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22267),
    [sym_qualified_constructor_operator] = STATE(22267),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22267),
    [sym_qualified_type_operator] = STATE(22267),
    [sym__qualified_type_operator] = STATE(22267),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22267),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22349),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19762),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19764),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3317),
    [anon_sym_DASH_GT] = ACTIONS(3317),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3323),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [925] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21820),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [926] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22708),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [927] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22704),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [928] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23426),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23428),
    [sym_qualified_constructor_operator] = STATE(23428),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23428),
    [sym_qualified_type_operator] = STATE(23428),
    [sym__qualified_type_operator] = STATE(23428),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23428),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23413),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20184),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20078),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2521),
    [anon_sym_DASH_GT] = ACTIONS(2521),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3331),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [929] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21934),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21932),
    [sym_qualified_constructor_operator] = STATE(21932),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21932),
    [sym_qualified_type_operator] = STATE(21932),
    [sym__qualified_type_operator] = STATE(21932),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21932),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22220),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18638),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19599),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2023),
    [anon_sym_DASH_GT] = ACTIONS(2023),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [930] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22305),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22302),
    [sym_qualified_constructor_operator] = STATE(22302),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22302),
    [sym_qualified_type_operator] = STATE(22302),
    [sym__qualified_type_operator] = STATE(22302),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22302),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22177),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18556),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18762),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3335),
    [anon_sym_DASH_GT] = ACTIONS(3335),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(495),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(497),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [931] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21818),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [932] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23406),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23407),
    [sym_qualified_constructor_operator] = STATE(23407),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23407),
    [sym_qualified_type_operator] = STATE(23407),
    [sym__qualified_type_operator] = STATE(23407),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23407),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21806),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20156),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20094),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2837),
    [anon_sym_DASH_GT] = ACTIONS(2837),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3341),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2841),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2843),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [933] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22838),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [934] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22841),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [935] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21876),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [936] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22403),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22402),
    [sym_qualified_constructor_operator] = STATE(22402),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22402),
    [sym_qualified_type_operator] = STATE(22402),
    [sym__qualified_type_operator] = STATE(22402),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22402),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22475),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19817),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19818),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3349),
    [anon_sym_DASH_GT] = ACTIONS(3349),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3351),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3353),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [937] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22419),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22422),
    [sym_qualified_constructor_operator] = STATE(22422),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22422),
    [sym_qualified_type_operator] = STATE(22422),
    [sym__qualified_type_operator] = STATE(22422),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22422),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21472),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19450),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19960),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3355),
    [anon_sym_DASH_GT] = ACTIONS(3355),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(369),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3359),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [938] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22895),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [939] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22448),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22440),
    [sym_qualified_constructor_operator] = STATE(22440),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22440),
    [sym_qualified_type_operator] = STATE(22440),
    [sym__qualified_type_operator] = STATE(22440),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22440),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22537),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19834),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19835),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3363),
    [anon_sym_DASH_GT] = ACTIONS(3363),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1700),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3365),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3367),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [940] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22647),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [941] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22479),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22477),
    [sym_qualified_constructor_operator] = STATE(22477),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22477),
    [sym_qualified_type_operator] = STATE(22477),
    [sym__qualified_type_operator] = STATE(22477),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22477),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22587),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19855),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19856),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3371),
    [anon_sym_DASH_GT] = ACTIONS(3371),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1692),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3375),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [942] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22649),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [943] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14970),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [944] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22905),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [945] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22083),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22081),
    [sym_qualified_constructor_operator] = STATE(22081),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22081),
    [sym_qualified_type_operator] = STATE(22081),
    [sym__qualified_type_operator] = STATE(22081),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22081),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22191),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19708),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19709),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3383),
    [anon_sym_DASH_GT] = ACTIONS(3383),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3385),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3389),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [946] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22665),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [947] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22595),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22590),
    [sym_qualified_constructor_operator] = STATE(22590),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22590),
    [sym_qualified_type_operator] = STATE(22590),
    [sym__qualified_type_operator] = STATE(22590),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22590),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22693),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19896),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19899),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3393),
    [anon_sym_DASH_GT] = ACTIONS(3393),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3397),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [948] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22651),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [949] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21880),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [950] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22657),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [951] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22646),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22643),
    [sym_qualified_constructor_operator] = STATE(22643),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22643),
    [sym_qualified_type_operator] = STATE(22643),
    [sym__qualified_type_operator] = STATE(22643),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22643),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22729),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19920),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19921),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3405),
    [anon_sym_DASH_GT] = ACTIONS(3405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3409),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [952] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [953] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15004),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [954] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22196),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22151),
    [sym_qualified_constructor_operator] = STATE(22151),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22151),
    [sym_qualified_type_operator] = STATE(22151),
    [sym__qualified_type_operator] = STATE(22151),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22151),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22310),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19744),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19745),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3413),
    [anon_sym_DASH_GT] = ACTIONS(3413),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3415),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3419),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [955] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15042),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [956] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23185),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23186),
    [sym_qualified_constructor_operator] = STATE(23186),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23186),
    [sym_qualified_type_operator] = STATE(23186),
    [sym__qualified_type_operator] = STATE(23186),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23186),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23244),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20044),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20180),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2961),
    [anon_sym_DASH_GT] = ACTIONS(2961),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2967),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [957] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23422),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23424),
    [sym_qualified_constructor_operator] = STATE(23424),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23424),
    [sym_qualified_type_operator] = STATE(23424),
    [sym__qualified_type_operator] = STATE(23424),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22777),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19916),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18624),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2473),
    [anon_sym_DASH_GT] = ACTIONS(2473),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2479),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [958] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21729),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [959] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22429),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22428),
    [sym_qualified_constructor_operator] = STATE(22428),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22428),
    [sym_qualified_type_operator] = STATE(22428),
    [sym__qualified_type_operator] = STATE(22428),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22428),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22299),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18437),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19019),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3431),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [960] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22485),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [961] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22912),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22936),
    [sym_qualified_constructor_operator] = STATE(22936),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22936),
    [sym_qualified_type_operator] = STATE(22936),
    [sym__qualified_type_operator] = STATE(22936),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22936),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23083),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19987),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20124),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2631),
    [anon_sym_DASH_GT] = ACTIONS(2631),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3435),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2637),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [962] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22483),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [963] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22619),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [964] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22169),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [965] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23024),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [966] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22823),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22829),
    [sym_qualified_constructor_operator] = STATE(22829),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22829),
    [sym_qualified_type_operator] = STATE(22829),
    [sym__qualified_type_operator] = STATE(22829),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22829),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22943),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19957),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20096),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3008),
    [anon_sym_DASH_GT] = ACTIONS(3008),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3014),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [967] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21902),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21909),
    [sym_qualified_constructor_operator] = STATE(21909),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21909),
    [sym_qualified_type_operator] = STATE(21909),
    [sym__qualified_type_operator] = STATE(21909),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21909),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21732),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19044),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18846),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3447),
    [anon_sym_DASH_GT] = ACTIONS(3447),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [968] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21602),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [969] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22338),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [970] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22742),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22732),
    [sym_qualified_constructor_operator] = STATE(22732),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22732),
    [sym_qualified_type_operator] = STATE(22732),
    [sym__qualified_type_operator] = STATE(22732),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22732),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22849),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19963),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19965),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3455),
    [anon_sym_DASH_GT] = ACTIONS(3455),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3457),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3459),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [971] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15253),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [972] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23026),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3463),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [973] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15362),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [974] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22798),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22797),
    [sym_qualified_constructor_operator] = STATE(22797),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22797),
    [sym_qualified_type_operator] = STATE(22797),
    [sym__qualified_type_operator] = STATE(22797),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22797),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22913),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19984),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17840),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3465),
    [anon_sym_DASH_GT] = ACTIONS(3465),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(479),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(481),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [975] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23069),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3469),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [976] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23072),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3471),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [977] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22539),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [978] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22680),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22690),
    [sym_qualified_constructor_operator] = STATE(22690),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22690),
    [sym_qualified_type_operator] = STATE(22690),
    [sym__qualified_type_operator] = STATE(22690),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22690),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22765),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20012),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2435),
    [anon_sym_DASH_GT] = ACTIONS(2435),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3475),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2441),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [979] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22167),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [980] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22538),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3479),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [981] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21336),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3481),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [982] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22680),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22690),
    [sym_qualified_constructor_operator] = STATE(22690),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22690),
    [sym_qualified_type_operator] = STATE(22690),
    [sym__qualified_type_operator] = STATE(22690),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22690),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2435),
    [anon_sym_DASH_GT] = ACTIONS(2435),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [983] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22325),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [984] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15587),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [985] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22856),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22853),
    [sym_qualified_constructor_operator] = STATE(22853),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22853),
    [sym_qualified_type_operator] = STATE(22853),
    [sym__qualified_type_operator] = STATE(22853),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22853),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23027),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20009),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19985),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1716),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3491),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [986] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22573),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22571),
    [sym_qualified_constructor_operator] = STATE(22571),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22571),
    [sym_qualified_type_operator] = STATE(22571),
    [sym__qualified_type_operator] = STATE(22571),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22571),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22424),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18318),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18781),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3493),
    [anon_sym_DASH_GT] = ACTIONS(3493),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(297),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3497),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [987] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23179),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [988] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23192),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3501),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [989] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22379),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22384),
    [sym_qualified_constructor_operator] = STATE(22384),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22384),
    [sym_qualified_type_operator] = STATE(22384),
    [sym__qualified_type_operator] = STATE(22384),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22384),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22464),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19777),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19923),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2529),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3503),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2535),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [990] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21341),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3505),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [991] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23377),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [992] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23380),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3509),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [993] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22218),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22226),
    [sym_qualified_constructor_operator] = STATE(22226),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22226),
    [sym_qualified_type_operator] = STATE(22226),
    [sym__qualified_type_operator] = STATE(22226),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22226),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22319),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19717),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19863),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2611),
    [anon_sym_DASH_GT] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3511),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2617),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [994] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [995] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22618),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3513),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [996] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21720),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21731),
    [sym_qualified_constructor_operator] = STATE(21731),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21731),
    [sym_qualified_type_operator] = STATE(21731),
    [sym__qualified_type_operator] = STATE(21731),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21731),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21513),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19202),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18500),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(535),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(537),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [997] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22157),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22022),
    [sym_qualified_constructor_operator] = STATE(22022),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22022),
    [sym_qualified_type_operator] = STATE(22022),
    [sym__qualified_type_operator] = STATE(22022),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22022),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22260),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19725),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19727),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3521),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3525),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [998] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15142),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [999] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22925),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22898),
    [sym_qualified_constructor_operator] = STATE(22898),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22898),
    [sym_qualified_type_operator] = STATE(22898),
    [sym__qualified_type_operator] = STATE(22898),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22898),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23146),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20035),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19833),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3529),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(543),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1000] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22491),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1001] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23230),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23223),
    [sym_qualified_constructor_operator] = STATE(23223),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23223),
    [sym_qualified_type_operator] = STATE(23223),
    [sym__qualified_type_operator] = STATE(23223),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23223),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2957),
    [anon_sym_DASH_GT] = ACTIONS(2957),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1002] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22108),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22107),
    [sym_qualified_constructor_operator] = STATE(22107),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22107),
    [sym_qualified_type_operator] = STATE(22107),
    [sym__qualified_type_operator] = STATE(22107),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22107),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22337),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18521),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19413),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(381),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3539),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1003] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23033),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23030),
    [sym_qualified_constructor_operator] = STATE(23030),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23030),
    [sym_qualified_type_operator] = STATE(23030),
    [sym__qualified_type_operator] = STATE(23030),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23030),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23211),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20056),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19803),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3541),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(503),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(505),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1004] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22486),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3545),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1005] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21656),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3547),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1006] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21634),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3549),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1007] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23264),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3551),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1008] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23213),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23212),
    [sym_qualified_constructor_operator] = STATE(23212),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23212),
    [sym_qualified_type_operator] = STATE(23212),
    [sym__qualified_type_operator] = STATE(23212),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23212),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23099),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20093),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20036),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3553),
    [anon_sym_DASH_GT] = ACTIONS(3553),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3555),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3557),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3559),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1009] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23273),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23299),
    [sym_qualified_constructor_operator] = STATE(23299),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23299),
    [sym_qualified_type_operator] = STATE(23299),
    [sym__qualified_type_operator] = STATE(23299),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23299),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1010] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23104),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1011] = {
    [sym_integer] = STATE(10708),
    [sym__literal] = STATE(10708),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(11866),
    [sym_qualified_variable] = STATE(10761),
    [sym_constructor] = STATE(10623),
    [sym_qualified_constructor] = STATE(10748),
    [sym__qcon] = STATE(12166),
    [sym_con_unit] = STATE(10708),
    [sym_con_list] = STATE(10708),
    [sym_con_tuple] = STATE(10708),
    [sym_literal] = STATE(12167),
    [sym_exp_parens] = STATE(11036),
    [sym_exp_tuple] = STATE(11036),
    [sym_exp_unboxed_tuple] = STATE(11036),
    [sym_exp_unboxed_sum] = STATE(11036),
    [sym_exp_list] = STATE(11036),
    [sym_exp_arithmetic_sequence] = STATE(11036),
    [sym_exp_list_comprehension] = STATE(11036),
    [sym_exp_section_left] = STATE(11036),
    [sym_exp_section_right] = STATE(11036),
    [sym_exp_th_quoted_name] = STATE(11036),
    [sym_exp_type_application] = STATE(11241),
    [sym_exp_lambda_case] = STATE(11241),
    [sym_exp_lambda_cases] = STATE(11241),
    [sym__do_keyword] = STATE(20758),
    [sym_do_module] = STATE(20758),
    [sym_exp_do] = STATE(11241),
    [sym_exp_record] = STATE(11036),
    [sym_exp_name] = STATE(11036),
    [sym_exp_projection_selector] = STATE(11036),
    [sym__aexp_projection] = STATE(11036),
    [sym_exp_projection] = STATE(11036),
    [sym__aexp] = STATE(11241),
    [sym_pat_name] = STATE(14068),
    [sym_pat_as] = STATE(14068),
    [sym__pat_constructor] = STATE(13370),
    [sym_pat_record] = STATE(14068),
    [sym_pat_wildcard] = STATE(14068),
    [sym_pat_parens] = STATE(14068),
    [sym_pat_tuple] = STATE(14068),
    [sym_pat_unboxed_tuple] = STATE(14068),
    [sym_pat_unboxed_sum] = STATE(14068),
    [sym_pat_list] = STATE(14068),
    [sym_pat_strict] = STATE(14068),
    [sym_pat_irrefutable] = STATE(14068),
    [sym_pat_type_binder] = STATE(14068),
    [sym__apat] = STATE(14068),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14108),
    [sym_splice] = STATE(12176),
    [sym_quasiquote] = STATE(12176),
    [sym__varid] = ACTIONS(3563),
    [sym_float] = ACTIONS(3565),
    [sym_char] = ACTIONS(3565),
    [sym_string] = ACTIONS(3565),
    [sym__integer_literal] = ACTIONS(3567),
    [sym__binary_literal] = ACTIONS(3569),
    [sym__octal_literal] = ACTIONS(3569),
    [sym__hex_literal] = ACTIONS(3569),
    [anon_sym_LPAREN_POUND] = ACTIONS(3571),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3571),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_RPAREN] = ACTIONS(3577),
    [sym_implicit_parid] = ACTIONS(3573),
    [sym__conid] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [anon_sym_AT] = ACTIONS(3585),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3587),
    [anon_sym_BSLASH] = ACTIONS(3589),
    [anon_sym_mdo] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_u27e6] = ACTIONS(3593),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3597),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [1012] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23105),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1013] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21516),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1014] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21448),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1015] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23274),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1016] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23345),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23342),
    [sym_qualified_constructor_operator] = STATE(23342),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23342),
    [sym_qualified_type_operator] = STATE(23342),
    [sym__qualified_type_operator] = STATE(23342),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23342),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23298),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20118),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20060),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3607),
    [anon_sym_DASH_GT] = ACTIONS(3607),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(337),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3611),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1017] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15509),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1018] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22276),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1019] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22098),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22099),
    [sym_qualified_constructor_operator] = STATE(22099),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22099),
    [sym_qualified_type_operator] = STATE(22099),
    [sym__qualified_type_operator] = STATE(22099),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22099),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21915),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18887),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18253),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3615),
    [anon_sym_DASH_GT] = ACTIONS(3615),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(345),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3619),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1020] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23394),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23393),
    [sym_qualified_constructor_operator] = STATE(23393),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23393),
    [sym_qualified_type_operator] = STATE(23393),
    [sym__qualified_type_operator] = STATE(23393),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23393),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23339),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20134),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19653),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3621),
    [anon_sym_DASH_GT] = ACTIONS(3621),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(511),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(513),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1021] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22186),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22181),
    [sym_qualified_constructor_operator] = STATE(22181),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22181),
    [sym_qualified_type_operator] = STATE(22181),
    [sym__qualified_type_operator] = STATE(22181),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22181),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22043),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18675),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19257),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3625),
    [anon_sym_DASH_GT] = ACTIONS(3625),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(365),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3629),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1022] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22752),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22750),
    [sym_qualified_constructor_operator] = STATE(22750),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22750),
    [sym_qualified_type_operator] = STATE(22750),
    [sym__qualified_type_operator] = STATE(22750),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22750),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22570),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18199),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19069),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3631),
    [anon_sym_DASH_GT] = ACTIONS(3631),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(469),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1023] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22278),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1024] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23291),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3637),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1025] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23276),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1026] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21668),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3641),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1027] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21675),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1028] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15334),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1029] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23415),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23414),
    [sym_qualified_constructor_operator] = STATE(23414),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23414),
    [sym_qualified_type_operator] = STATE(23414),
    [sym__qualified_type_operator] = STATE(23414),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23414),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23390),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20162),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19623),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3647),
    [anon_sym_DASH_GT] = ACTIONS(3647),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(491),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(493),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1030] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22804),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22785),
    [sym_qualified_constructor_operator] = STATE(22785),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22785),
    [sym_qualified_type_operator] = STATE(22785),
    [sym__qualified_type_operator] = STATE(22785),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22785),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22872),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19970),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19217),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3651),
    [anon_sym_DASH_GT] = ACTIONS(3651),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3653),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3657),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1031] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22309),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3659),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1032] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22411),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3661),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1033] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22409),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1034] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23365),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23366),
    [sym_qualified_constructor_operator] = STATE(23366),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23366),
    [sym_qualified_type_operator] = STATE(23366),
    [sym__qualified_type_operator] = STATE(23366),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23366),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23409),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20128),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20119),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3665),
    [anon_sym_DASH_GT] = ACTIONS(3665),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(373),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3669),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1035] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1036] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23167),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3673),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1037] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21432),
    [sym_qualified_constructor_operator] = STATE(21432),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21432),
    [sym_qualified_type_operator] = STATE(21432),
    [sym__qualified_type_operator] = STATE(21432),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1038] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15044),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1039] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15409),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3677),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1040] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22311),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1041] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23304),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23313),
    [sym_qualified_constructor_operator] = STATE(23313),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23313),
    [sym_qualified_type_operator] = STATE(23313),
    [sym__qualified_type_operator] = STATE(23313),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23313),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23375),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20100),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20138),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3685),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1042] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22934),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22933),
    [sym_qualified_constructor_operator] = STATE(22933),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22933),
    [sym_qualified_type_operator] = STATE(22933),
    [sym__qualified_type_operator] = STATE(22933),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22933),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22734),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18080),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18662),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3687),
    [anon_sym_DASH_GT] = ACTIONS(3687),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(357),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3691),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1043] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22358),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1044] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22356),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3695),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1045] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23065),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1046] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23063),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1047] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23238),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23243),
    [sym_qualified_constructor_operator] = STATE(23243),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23243),
    [sym_qualified_type_operator] = STATE(23243),
    [sym__qualified_type_operator] = STATE(23243),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23243),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23318),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20072),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20167),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3701),
    [anon_sym_DASH_GT] = ACTIONS(3701),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1828),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3705),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1048] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23002),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23000),
    [sym_qualified_constructor_operator] = STATE(23000),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23000),
    [sym_qualified_type_operator] = STATE(23000),
    [sym__qualified_type_operator] = STATE(23000),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23000),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22921),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18041),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18146),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3707),
    [anon_sym_DASH_GT] = ACTIONS(3707),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3709),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3711),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1049] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15390),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1050] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21505),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21507),
    [sym_qualified_constructor_operator] = STATE(21507),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21507),
    [sym_qualified_type_operator] = STATE(21507),
    [sym__qualified_type_operator] = STATE(21507),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21507),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21321),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19354),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18507),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3051),
    [anon_sym_DASH_GT] = ACTIONS(3051),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3053),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3055),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1051] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23332),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23329),
    [sym_qualified_constructor_operator] = STATE(23329),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23329),
    [sym_qualified_type_operator] = STATE(23329),
    [sym__qualified_type_operator] = STATE(23329),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23329),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2945),
    [anon_sym_DASH_GT] = ACTIONS(2945),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1052] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21400),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1053] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14978),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1054] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23044),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1055] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21301),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21300),
    [sym_qualified_constructor_operator] = STATE(21300),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21300),
    [sym_qualified_type_operator] = STATE(21300),
    [sym__qualified_type_operator] = STATE(21300),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21300),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21564),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19382),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19593),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2603),
    [anon_sym_DASH_GT] = ACTIONS(2603),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3723),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2607),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2609),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1056] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23042),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1057] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15207),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1058] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22055),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22056),
    [sym_qualified_constructor_operator] = STATE(22056),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22056),
    [sym_qualified_type_operator] = STATE(22056),
    [sym__qualified_type_operator] = STATE(22056),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22056),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22057),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18783),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18785),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3000),
    [anon_sym_DASH_GT] = ACTIONS(3000),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3004),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3006),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1059] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22029),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22030),
    [sym_qualified_constructor_operator] = STATE(22030),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22030),
    [sym_qualified_type_operator] = STATE(22030),
    [sym__qualified_type_operator] = STATE(22030),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22030),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22031),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18805),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18806),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3043),
    [anon_sym_DASH_GT] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3047),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1060] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21429),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21428),
    [sym_qualified_constructor_operator] = STATE(21428),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21428),
    [sym_qualified_type_operator] = STATE(21428),
    [sym__qualified_type_operator] = STATE(21428),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21428),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22364),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19270),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19563),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3028),
    [anon_sym_DASH_GT] = ACTIONS(3028),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3034),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1061] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15482),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1062] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22229),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22228),
    [sym_qualified_constructor_operator] = STATE(22228),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22228),
    [sym_qualified_type_operator] = STATE(22228),
    [sym__qualified_type_operator] = STATE(22228),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22228),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22443),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18420),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19046),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3735),
    [anon_sym_DASH_GT] = ACTIONS(3735),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(329),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3739),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1063] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22001),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22002),
    [sym_qualified_constructor_operator] = STATE(22002),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22002),
    [sym_qualified_type_operator] = STATE(22002),
    [sym__qualified_type_operator] = STATE(22002),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22002),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22003),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18824),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18826),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2937),
    [anon_sym_DASH_GT] = ACTIONS(2937),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2943),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1064] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21337),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3743),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1065] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21339),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1066] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22027),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22026),
    [sym_qualified_constructor_operator] = STATE(22026),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22026),
    [sym_qualified_type_operator] = STATE(22026),
    [sym__qualified_type_operator] = STATE(22026),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22026),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22149),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19686),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19689),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3747),
    [anon_sym_DASH_GT] = ACTIONS(3747),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3753),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1067] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23035),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23075),
    [sym_qualified_constructor_operator] = STATE(23075),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23075),
    [sym_qualified_type_operator] = STATE(23075),
    [sym__qualified_type_operator] = STATE(23075),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23075),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23188),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20016),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20152),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3755),
    [anon_sym_DASH_GT] = ACTIONS(3755),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1776),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3759),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1068] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21833),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21834),
    [sym_qualified_constructor_operator] = STATE(21834),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21834),
    [sym_qualified_type_operator] = STATE(21834),
    [sym__qualified_type_operator] = STATE(21834),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21834),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21835),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18970),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18889),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2680),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2686),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1069] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15463),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3763),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1070] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22738),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1071] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22740),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3767),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1072] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21777),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21778),
    [sym_qualified_constructor_operator] = STATE(21778),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21778),
    [sym_qualified_type_operator] = STATE(21778),
    [sym__qualified_type_operator] = STATE(21778),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21778),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21779),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19007),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18945),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2542),
    [anon_sym_DASH_GT] = ACTIONS(2542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3769),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2548),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1073] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21383),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3771),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1074] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22745),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22759),
    [sym_qualified_constructor_operator] = STATE(22759),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22759),
    [sym_qualified_type_operator] = STATE(22759),
    [sym__qualified_type_operator] = STATE(22759),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22759),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22833),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19927),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20068),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3773),
    [anon_sym_DASH_GT] = ACTIONS(3773),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3775),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3777),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1075] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21384),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3779),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1076] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21749),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21750),
    [sym_qualified_constructor_operator] = STATE(21750),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21750),
    [sym_qualified_type_operator] = STATE(21750),
    [sym__qualified_type_operator] = STATE(21750),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21750),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21751),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19031),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18971),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2489),
    [anon_sym_DASH_GT] = ACTIONS(2489),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2493),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2495),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1077] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22277),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3783),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1078] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22272),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3785),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1079] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22626),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22628),
    [sym_qualified_constructor_operator] = STATE(22628),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22628),
    [sym_qualified_type_operator] = STATE(22628),
    [sym__qualified_type_operator] = STATE(22628),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22628),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22691),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19867),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19983),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3787),
    [anon_sym_DASH_GT] = ACTIONS(3787),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3789),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3791),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1080] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22240),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22242),
    [sym_qualified_constructor_operator] = STATE(22242),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22242),
    [sym_qualified_type_operator] = STATE(22242),
    [sym__qualified_type_operator] = STATE(22242),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22242),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22100),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18745),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19218),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3793),
    [anon_sym_DASH_GT] = ACTIONS(3793),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(499),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(501),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1081] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21721),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21722),
    [sym_qualified_constructor_operator] = STATE(21722),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21722),
    [sym_qualified_type_operator] = STATE(21722),
    [sym__qualified_type_operator] = STATE(21722),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21722),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21723),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19055),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18980),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2949),
    [anon_sym_DASH_GT] = ACTIONS(2949),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3797),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2955),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1082] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21973),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21974),
    [sym_qualified_constructor_operator] = STATE(21974),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21974),
    [sym_qualified_type_operator] = STATE(21974),
    [sym__qualified_type_operator] = STATE(21974),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21975),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18841),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18842),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3799),
    [anon_sym_DASH_GT] = ACTIONS(3799),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3805),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1083] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22683),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22682),
    [sym_qualified_constructor_operator] = STATE(22682),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22682),
    [sym_qualified_type_operator] = STATE(22682),
    [sym__qualified_type_operator] = STATE(22682),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22682),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22928),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17961),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18543),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2599),
    [anon_sym_DASH_GT] = ACTIONS(2599),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3807),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2894),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1084] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21654),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3809),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1085] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21945),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21946),
    [sym_qualified_constructor_operator] = STATE(21946),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21946),
    [sym_qualified_type_operator] = STATE(21946),
    [sym__qualified_type_operator] = STATE(21946),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21946),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21947),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18860),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18861),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3811),
    [anon_sym_DASH_GT] = ACTIONS(3811),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3813),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3815),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3817),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1086] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21917),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21918),
    [sym_qualified_constructor_operator] = STATE(21918),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21918),
    [sym_qualified_type_operator] = STATE(21918),
    [sym__qualified_type_operator] = STATE(21918),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21918),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21919),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18888),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19056),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3819),
    [anon_sym_DASH_GT] = ACTIONS(3819),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(519),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(521),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1087] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22924),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3823),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1088] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22425),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22544),
    [sym_qualified_constructor_operator] = STATE(22544),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22544),
    [sym_qualified_type_operator] = STATE(22544),
    [sym__qualified_type_operator] = STATE(22544),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22544),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22634),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19837),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19953),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3825),
    [anon_sym_DASH_GT] = ACTIONS(3825),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3827),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3829),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1089] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22915),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3831),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1090] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21650),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3833),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1091] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21889),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21890),
    [sym_qualified_constructor_operator] = STATE(21890),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21890),
    [sym_qualified_type_operator] = STATE(21890),
    [sym__qualified_type_operator] = STATE(21890),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21890),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21891),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18910),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19080),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3835),
    [anon_sym_DASH_GT] = ACTIONS(3835),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(523),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3837),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(525),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1092] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22881),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3839),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1093] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22460),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22463),
    [sym_qualified_constructor_operator] = STATE(22463),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22463),
    [sym_qualified_type_operator] = STATE(22463),
    [sym__qualified_type_operator] = STATE(22463),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22463),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22545),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19807),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19371),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3841),
    [anon_sym_DASH_GT] = ACTIONS(3841),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(475),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3843),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(477),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1094] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23384),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1095] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22880),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1096] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23395),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3849),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1097] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23259),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23258),
    [sym_qualified_constructor_operator] = STATE(23258),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23258),
    [sym_qualified_type_operator] = STATE(23258),
    [sym__qualified_type_operator] = STATE(23258),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23258),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2431),
    [anon_sym_DASH_GT] = ACTIONS(2431),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1098] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22304),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22316),
    [sym_qualified_constructor_operator] = STATE(22316),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22316),
    [sym_qualified_type_operator] = STATE(22316),
    [sym__qualified_type_operator] = STATE(22316),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22316),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22387),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19747),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19893),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3851),
    [anon_sym_DASH_GT] = ACTIONS(3851),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3855),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1099] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21861),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21862),
    [sym_qualified_constructor_operator] = STATE(21862),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21862),
    [sym_qualified_type_operator] = STATE(21862),
    [sym__qualified_type_operator] = STATE(21862),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21862),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21863),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18944),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19099),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3857),
    [anon_sym_DASH_GT] = ACTIONS(3857),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(539),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3859),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(541),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1100] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14988),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3861),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1101] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15272),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1102] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21404),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3865),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1103] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22124),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22135),
    [sym_qualified_constructor_operator] = STATE(22135),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22135),
    [sym_qualified_type_operator] = STATE(22135),
    [sym__qualified_type_operator] = STATE(22135),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22135),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22234),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19687),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19138),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3867),
    [anon_sym_DASH_GT] = ACTIONS(3867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(507),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(509),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1104] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21805),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21295),
    [sym_qualified_constructor_operator] = STATE(21295),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21295),
    [sym_qualified_type_operator] = STATE(21295),
    [sym__qualified_type_operator] = STATE(21295),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21295),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21807),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18979),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18911),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3871),
    [anon_sym_DASH_GT] = ACTIONS(3871),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3875),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1105] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3877),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1106] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22238),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1107] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22044),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1108] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22235),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3883),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1109] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22039),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22041),
    [sym_qualified_constructor_operator] = STATE(22041),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22041),
    [sym_qualified_type_operator] = STATE(22041),
    [sym__qualified_type_operator] = STATE(22041),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22041),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22136),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19657),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19773),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(3885),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(321),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3887),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3889),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1110] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22195),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1111] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23422),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23424),
    [sym_qualified_constructor_operator] = STATE(23424),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23424),
    [sym_qualified_type_operator] = STATE(23424),
    [sym__qualified_type_operator] = STATE(23424),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2473),
    [anon_sym_DASH_GT] = ACTIONS(2473),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1112] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21525),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21526),
    [sym_qualified_constructor_operator] = STATE(21526),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21526),
    [sym_qualified_type_operator] = STATE(21526),
    [sym__qualified_type_operator] = STATE(21526),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21526),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21555),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19194),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19135),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2405),
    [anon_sym_DASH_GT] = ACTIONS(2405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2411),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1113] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21984),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21983),
    [sym_qualified_constructor_operator] = STATE(21983),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21983),
    [sym_qualified_type_operator] = STATE(21983),
    [sym__qualified_type_operator] = STATE(21983),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21983),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22080),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19667),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19668),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3895),
    [anon_sym_DASH_GT] = ACTIONS(3895),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3899),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3901),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1114] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15505),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3903),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1115] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23161),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23159),
    [sym_qualified_constructor_operator] = STATE(23159),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23159),
    [sym_qualified_type_operator] = STATE(23159),
    [sym__qualified_type_operator] = STATE(23159),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23159),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23254),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20076),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20010),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2619),
    [anon_sym_DASH_GT] = ACTIONS(2619),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3905),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2625),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1116] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21966),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21970),
    [sym_qualified_constructor_operator] = STATE(21970),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21970),
    [sym_qualified_type_operator] = STATE(21970),
    [sym__qualified_type_operator] = STATE(21970),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21970),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22047),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19627),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18900),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3907),
    [anon_sym_DASH_GT] = ACTIONS(3907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(453),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(455),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1117] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22046),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22045),
    [sym_qualified_constructor_operator] = STATE(22045),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22045),
    [sym_qualified_type_operator] = STATE(22045),
    [sym__qualified_type_operator] = STATE(22045),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22045),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21888),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18794),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18372),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3911),
    [anon_sym_DASH_GT] = ACTIONS(3911),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(431),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1118] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22799),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3915),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1119] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22787),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3917),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1120] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21469),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21470),
    [sym_qualified_constructor_operator] = STATE(21470),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21470),
    [sym_qualified_type_operator] = STATE(21470),
    [sym__qualified_type_operator] = STATE(21470),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21470),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21499),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19229),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19169),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2977),
    [anon_sym_DASH_GT] = ACTIONS(2977),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2981),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2983),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1121] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21886),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21769),
    [sym_qualified_constructor_operator] = STATE(21769),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21769),
    [sym_qualified_type_operator] = STATE(21769),
    [sym__qualified_type_operator] = STATE(21769),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21769),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21971),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19597),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19743),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3921),
    [anon_sym_DASH_GT] = ACTIONS(3921),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(313),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3925),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1122] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21539),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1123] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21441),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21442),
    [sym_qualified_constructor_operator] = STATE(21442),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21442),
    [sym_qualified_type_operator] = STATE(21442),
    [sym__qualified_type_operator] = STATE(21442),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21442),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21471),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19253),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19197),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2550),
    [anon_sym_DASH_GT] = ACTIONS(2550),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2556),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1124] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21540),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1125] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22773),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3933),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1126] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23099),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3555),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1127] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22775),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3935),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1128] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22165),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1129] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15616),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3939),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1130] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21693),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21694),
    [sym_qualified_constructor_operator] = STATE(21694),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21694),
    [sym_qualified_type_operator] = STATE(21694),
    [sym__qualified_type_operator] = STATE(21694),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21694),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21808),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19079),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19008),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3941),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3945),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3947),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1131] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22445),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22444),
    [sym_qualified_constructor_operator] = STATE(22444),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22444),
    [sym_qualified_type_operator] = STATE(22444),
    [sym__qualified_type_operator] = STATE(22444),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22444),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22681),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18245),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18615),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3949),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(349),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3953),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1132] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22722),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1133] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21787),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21789),
    [sym_qualified_constructor_operator] = STATE(21789),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21789),
    [sym_qualified_type_operator] = STATE(21789),
    [sym__qualified_type_operator] = STATE(21789),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21789),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21900),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19567),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19713),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3957),
    [anon_sym_DASH_GT] = ACTIONS(3957),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3959),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3961),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3963),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1134] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22697),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22694),
    [sym_qualified_constructor_operator] = STATE(22694),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22694),
    [sym_qualified_type_operator] = STATE(22694),
    [sym__qualified_type_operator] = STATE(22694),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22694),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22664),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19936),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19937),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2989),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3965),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2995),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1135] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22156),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3967),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1136] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22155),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1137] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22197),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3971),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1138] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23332),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23329),
    [sym_qualified_constructor_operator] = STATE(23329),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23329),
    [sym_qualified_type_operator] = STATE(23329),
    [sym__qualified_type_operator] = STATE(23329),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23329),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23155),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17922),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18305),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2945),
    [anon_sym_DASH_GT] = ACTIONS(2945),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3973),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2975),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1139] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21641),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3975),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1140] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21645),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3977),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1141] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22715),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(3979),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1142] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15612),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1143] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21357),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21358),
    [sym_qualified_constructor_operator] = STATE(21358),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21358),
    [sym_qualified_type_operator] = STATE(21358),
    [sym__qualified_type_operator] = STATE(21358),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21358),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21387),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19323),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19254),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2692),
    [anon_sym_DASH_GT] = ACTIONS(2692),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2698),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1144] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15144),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(3983),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1145] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22683),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22682),
    [sym_qualified_constructor_operator] = STATE(22682),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22682),
    [sym_qualified_type_operator] = STATE(22682),
    [sym__qualified_type_operator] = STATE(22682),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22682),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2599),
    [anon_sym_DASH_GT] = ACTIONS(2599),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1146] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22355),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22360),
    [sym_qualified_constructor_operator] = STATE(22360),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22360),
    [sym_qualified_type_operator] = STATE(22360),
    [sym__qualified_type_operator] = STATE(22360),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22360),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22249),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18611),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18139),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3985),
    [anon_sym_DASH_GT] = ACTIONS(3985),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(305),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3989),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1147] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21700),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21703),
    [sym_qualified_constructor_operator] = STATE(21703),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21703),
    [sym_qualified_type_operator] = STATE(21703),
    [sym__qualified_type_operator] = STATE(21703),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21703),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21791),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19537),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19683),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3993),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3997),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1148] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21648),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21644),
    [sym_qualified_constructor_operator] = STATE(21644),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21644),
    [sym_qualified_type_operator] = STATE(21644),
    [sym__qualified_type_operator] = STATE(21644),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21644),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21686),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19550),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19554),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3999),
    [anon_sym_DASH_GT] = ACTIONS(3999),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4001),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4003),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1149] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23113),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23110),
    [sym_qualified_constructor_operator] = STATE(23110),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23110),
    [sym_qualified_type_operator] = STATE(23110),
    [sym__qualified_type_operator] = STATE(23110),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23110),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23301),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17842),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18424),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4005),
    [anon_sym_DASH_GT] = ACTIONS(4005),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4007),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4011),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1150] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22115),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4013),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1151] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21592),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21588),
    [sym_qualified_constructor_operator] = STATE(21588),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21588),
    [sym_qualified_type_operator] = STATE(21588),
    [sym__qualified_type_operator] = STATE(21588),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21588),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21515),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19531),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19534),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4015),
    [anon_sym_DASH_GT] = ACTIONS(4015),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4017),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4019),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1152] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23153),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4021),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1153] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22114),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4023),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1154] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23156),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4025),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1155] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21956),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21963),
    [sym_qualified_constructor_operator] = STATE(21963),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21963),
    [sym_qualified_type_operator] = STATE(21963),
    [sym__qualified_type_operator] = STATE(21963),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21963),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21391),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19245),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18225),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4027),
    [anon_sym_DASH_GT] = ACTIONS(4027),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4029),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(485),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1156] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22066),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4031),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1157] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22543),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22541),
    [sym_qualified_constructor_operator] = STATE(22541),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22541),
    [sym_qualified_type_operator] = STATE(22541),
    [sym__qualified_type_operator] = STATE(22541),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22541),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22641),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19871),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19873),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2724),
    [anon_sym_DASH_GT] = ACTIONS(2724),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2730),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1158] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21623),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21624),
    [sym_qualified_constructor_operator] = STATE(21624),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21624),
    [sym_qualified_type_operator] = STATE(21624),
    [sym__qualified_type_operator] = STATE(21624),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21624),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21724),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19505),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18186),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(471),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(473),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1159] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22631),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4039),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1160] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21893),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21892),
    [sym_qualified_constructor_operator] = STATE(21892),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21892),
    [sym_qualified_type_operator] = STATE(21892),
    [sym__qualified_type_operator] = STATE(21892),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21892),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21753),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18913),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19468),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4041),
    [anon_sym_DASH_GT] = ACTIONS(4041),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4043),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4045),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1161] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22609),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4047),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1162] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22067),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4049),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1163] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21330),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21331),
    [sym_qualified_constructor_operator] = STATE(21331),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21331),
    [sym_qualified_type_operator] = STATE(21331),
    [sym__qualified_type_operator] = STATE(21331),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21331),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21359),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19336),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19278),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2423),
    [anon_sym_DASH_GT] = ACTIONS(2423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2429),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1164] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22555),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4053),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1165] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21455),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4055),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1166] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21454),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1167] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15464),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1168] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21550),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21546),
    [sym_qualified_constructor_operator] = STATE(21546),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21546),
    [sym_qualified_type_operator] = STATE(21546),
    [sym__qualified_type_operator] = STATE(21546),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21546),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21585),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19510),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19511),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4059),
    [anon_sym_DASH_GT] = ACTIONS(4059),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4063),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1169] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22550),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1170] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15239),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1171] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21665),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21666),
    [sym_qualified_constructor_operator] = STATE(21666),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21666),
    [sym_qualified_type_operator] = STATE(21666),
    [sym__qualified_type_operator] = STATE(21666),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21666),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21695),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19096),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19034),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4067),
    [anon_sym_DASH_GT] = ACTIONS(4067),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4073),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1172] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21594),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4075),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1173] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22172),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1174] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21637),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21638),
    [sym_qualified_constructor_operator] = STATE(21638),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21638),
    [sym_qualified_type_operator] = STATE(21638),
    [sym__qualified_type_operator] = STATE(21638),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21638),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21667),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19116),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19324),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4079),
    [anon_sym_DASH_GT] = ACTIONS(4079),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(531),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4081),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(533),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1175] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21781),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4083),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1176] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21785),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4085),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1177] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15238),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1178] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22019),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1179] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21388),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4089),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1180] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21343),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4091),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1181] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15261),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4093),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1182] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21433),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21430),
    [sym_qualified_constructor_operator] = STATE(21430),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21430),
    [sym_qualified_type_operator] = STATE(21430),
    [sym__qualified_type_operator] = STATE(21430),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21430),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21477),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19464),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19465),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4095),
    [anon_sym_DASH_GT] = ACTIONS(4095),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1708),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4099),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1183] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1184] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22391),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4103),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1185] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21310),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21320),
    [sym_qualified_constructor_operator] = STATE(21320),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21320),
    [sym_qualified_type_operator] = STATE(21320),
    [sym__qualified_type_operator] = STATE(21320),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21320),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21762),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19555),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18403),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4105),
    [anon_sym_DASH_GT] = ACTIONS(4105),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4107),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1186] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22392),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1187] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22084),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1188] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22357),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22351),
    [sym_qualified_constructor_operator] = STATE(22351),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22351),
    [sym_qualified_type_operator] = STATE(22351),
    [sym__qualified_type_operator] = STATE(22351),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22351),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22439),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19798),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19799),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2558),
    [anon_sym_DASH_GT] = ACTIONS(2558),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2564),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1189] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22087),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4115),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1190] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21609),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21610),
    [sym_qualified_constructor_operator] = STATE(21610),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21610),
    [sym_qualified_type_operator] = STATE(21610),
    [sym__qualified_type_operator] = STATE(21610),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21610),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21639),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19134),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19381),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4117),
    [anon_sym_DASH_GT] = ACTIONS(4117),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(527),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1191] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15038),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1192] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21581),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21582),
    [sym_qualified_constructor_operator] = STATE(21582),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21582),
    [sym_qualified_type_operator] = STATE(21582),
    [sym__qualified_type_operator] = STATE(21582),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21582),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21611),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19147),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19404),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(515),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4123),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(517),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1193] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23170),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23150),
    [sym_qualified_constructor_operator] = STATE(23150),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23150),
    [sym_qualified_type_operator] = STATE(23150),
    [sym__qualified_type_operator] = STATE(23150),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23150),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23012),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18026),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19612),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4125),
    [anon_sym_DASH_GT] = ACTIONS(4125),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(449),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(451),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1194] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22527),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4129),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1195] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21561),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21563),
    [sym_qualified_constructor_operator] = STATE(21563),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21563),
    [sym_qualified_type_operator] = STATE(21563),
    [sym__qualified_type_operator] = STATE(21563),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21563),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21626),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19472),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18067),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4131),
    [anon_sym_DASH_GT] = ACTIONS(4131),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(487),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(489),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1196] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23221),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4135),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1197] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22842),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22869),
    [sym_qualified_constructor_operator] = STATE(22869),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22869),
    [sym_qualified_type_operator] = STATE(22869),
    [sym__qualified_type_operator] = STATE(22869),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22869),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21965),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19624),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4137),
    [anon_sym_DASH_GT] = ACTIONS(4137),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4139),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1198] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21813),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4141),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1199] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21815),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4143),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1200] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21397),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21392),
    [sym_qualified_constructor_operator] = STATE(21392),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21392),
    [sym_qualified_type_operator] = STATE(21392),
    [sym__qualified_type_operator] = STATE(21392),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21392),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21389),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19424),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19425),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4145),
    [anon_sym_DASH_GT] = ACTIONS(4145),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1672),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4149),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1201] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23200),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4151),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1202] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21953),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4153),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1203] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21340),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4155),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1204] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21345),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1205] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21951),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4159),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1206] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22450),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4161),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1207] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21708),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21706),
    [sym_qualified_constructor_operator] = STATE(21706),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21706),
    [sym_qualified_type_operator] = STATE(21706),
    [sym__qualified_type_operator] = STATE(21706),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21706),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22106),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18743),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19769),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3016),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4163),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3022),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1208] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22449),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4165),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1209] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21553),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21554),
    [sym_qualified_constructor_operator] = STATE(21554),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21554),
    [sym_qualified_type_operator] = STATE(21554),
    [sym__qualified_type_operator] = STATE(21554),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21554),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21583),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19167),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19117),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4169),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4171),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1210] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22524),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4173),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1211] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22516),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22518),
    [sym_qualified_constructor_operator] = STATE(22518),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22518),
    [sym_qualified_type_operator] = STATE(22518),
    [sym__qualified_type_operator] = STATE(22518),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22518),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22368),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18493),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18037),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2497),
    [anon_sym_DASH_GT] = ACTIONS(2497),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2503),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1212] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22315),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22312),
    [sym_qualified_constructor_operator] = STATE(22312),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22312),
    [sym_qualified_type_operator] = STATE(22312),
    [sym__qualified_type_operator] = STATE(22312),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22312),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22396),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19783),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19785),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2513),
    [anon_sym_DASH_GT] = ACTIONS(2513),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2517),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2519),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1213] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15433),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1214] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22400),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4179),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1215] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22399),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4181),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1216] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21497),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21498),
    [sym_qualified_constructor_operator] = STATE(21498),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21498),
    [sym_qualified_type_operator] = STATE(21498),
    [sym__qualified_type_operator] = STATE(21498),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21498),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21527),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19209),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19148),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4183),
    [anon_sym_DASH_GT] = ACTIONS(4183),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4187),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1217] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22501),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4189),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1218] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(14993),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1219] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21297),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21298),
    [sym_qualified_constructor_operator] = STATE(21298),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21298),
    [sym_qualified_type_operator] = STATE(21298),
    [sym__qualified_type_operator] = STATE(21298),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21298),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21299),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19402),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19359),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4193),
    [anon_sym_DASH_GT] = ACTIONS(4193),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4195),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4197),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4199),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1220] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22514),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4201),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1221] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21396),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4203),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1222] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21399),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4205),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1223] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4207),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1224] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15619),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1225] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15346),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4209),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1226] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21485),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21479),
    [sym_qualified_constructor_operator] = STATE(21479),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21479),
    [sym_qualified_type_operator] = STATE(21479),
    [sym__qualified_type_operator] = STATE(21479),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21479),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21542),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19489),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19491),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2740),
    [anon_sym_DASH_GT] = ACTIONS(2740),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2746),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1227] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22416),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4213),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1228] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15215),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4215),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1229] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22418),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4217),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1230] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22341),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22339),
    [sym_qualified_constructor_operator] = STATE(22339),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22339),
    [sym_qualified_type_operator] = STATE(22339),
    [sym__qualified_type_operator] = STATE(22339),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22339),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22557),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18323),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18730),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4219),
    [anon_sym_DASH_GT] = ACTIONS(4219),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1792),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4223),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1231] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22497),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4225),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1232] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22379),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22384),
    [sym_qualified_constructor_operator] = STATE(22384),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22384),
    [sym_qualified_type_operator] = STATE(22384),
    [sym__qualified_type_operator] = STATE(22384),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22384),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2529),
    [anon_sym_DASH_GT] = ACTIONS(2529),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1233] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22978),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4227),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1234] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21413),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21414),
    [sym_qualified_constructor_operator] = STATE(21414),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21414),
    [sym_qualified_type_operator] = STATE(21414),
    [sym__qualified_type_operator] = STATE(21414),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21414),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21443),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19276),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19211),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4229),
    [anon_sym_DASH_GT] = ACTIONS(4229),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4231),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4233),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1235] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15007),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4235),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1236] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15366),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1237] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15349),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4237),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1238] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21875),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1239] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22496),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4241),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1240] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23273),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23299),
    [sym_qualified_constructor_operator] = STATE(23299),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23299),
    [sym_qualified_type_operator] = STATE(23299),
    [sym__qualified_type_operator] = STATE(23299),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23299),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21319),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19380),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19337),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2595),
    [anon_sym_DASH_GT] = ACTIONS(2595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4243),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2971),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1241] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15594),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4245),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1242] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21458),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21456),
    [sym_qualified_constructor_operator] = STATE(21456),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21456),
    [sym_qualified_type_operator] = STATE(21456),
    [sym__qualified_type_operator] = STATE(21456),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21456),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21931),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18877),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19948),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4247),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3079),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1243] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23259),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23258),
    [sym_qualified_constructor_operator] = STATE(23258),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23258),
    [sym_qualified_type_operator] = STATE(23258),
    [sym__qualified_type_operator] = STATE(23258),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23258),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21425),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19446),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19447),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2431),
    [anon_sym_DASH_GT] = ACTIONS(2431),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4249),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2690),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1244] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21935),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4251),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1245] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21874),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4253),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1246] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15199),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1247] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21936),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4255),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1248] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22610),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4257),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1249] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21692),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21690),
    [sym_qualified_constructor_operator] = STATE(21690),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21690),
    [sym_qualified_type_operator] = STATE(21690),
    [sym__qualified_type_operator] = STATE(21690),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21690),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21746),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19573),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19575),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2389),
    [anon_sym_DASH_GT] = ACTIONS(2389),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4259),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2397),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1250] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22760),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22678),
    [sym_qualified_constructor_operator] = STATE(22678),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22678),
    [sym_qualified_type_operator] = STATE(22678),
    [sym__qualified_type_operator] = STATE(22678),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22678),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22521),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18355),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17940),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2481),
    [anon_sym_DASH_GT] = ACTIONS(2481),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2485),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2487),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1251] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22952),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4263),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1252] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22795),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22791),
    [sym_qualified_constructor_operator] = STATE(22791),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22791),
    [sym_qualified_type_operator] = STATE(22791),
    [sym__qualified_type_operator] = STATE(22791),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22791),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22782),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18184),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17888),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4265),
    [anon_sym_DASH_GT] = ACTIONS(4265),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(255),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4267),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4269),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1253] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21959),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4271),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1254] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21317),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21318),
    [sym_qualified_constructor_operator] = STATE(21318),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21318),
    [sym_qualified_type_operator] = STATE(21318),
    [sym__qualified_type_operator] = STATE(21318),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21318),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21332),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19357),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19304),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4273),
    [anon_sym_DASH_GT] = ACTIONS(4273),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4277),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4279),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1255] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22948),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4281),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1256] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21962),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4283),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1257] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21495),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4285),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1258] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22615),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4287),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1259] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21496),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4289),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1260] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23008),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23009),
    [sym_qualified_constructor_operator] = STATE(23009),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23009),
    [sym_qualified_type_operator] = STATE(23009),
    [sym__qualified_type_operator] = STATE(23009),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23009),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22858),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18128),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17948),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4291),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4293),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1261] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22852),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22857),
    [sym_qualified_constructor_operator] = STATE(22857),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22857),
    [sym_qualified_type_operator] = STATE(22857),
    [sym__qualified_type_operator] = STATE(22857),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22857),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22685),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18238),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17870),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4295),
    [anon_sym_DASH_GT] = ACTIONS(4295),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4297),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4299),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4301),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1262] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15586),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1263] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21823),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4303),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1264] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21821),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1265] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21927),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21925),
    [sym_qualified_constructor_operator] = STATE(21925),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21925),
    [sym_qualified_type_operator] = STATE(21925),
    [sym__qualified_type_operator] = STATE(21925),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21925),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21955),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19649),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19650),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2700),
    [anon_sym_DASH_GT] = ACTIONS(2700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4307),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2706),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1266] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22292),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4309),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1267] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22788),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4311),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1268] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23210),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4313),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1269] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22290),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4315),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1270] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22560),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22558),
    [sym_qualified_constructor_operator] = STATE(22558),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22558),
    [sym_qualified_type_operator] = STATE(22558),
    [sym__qualified_type_operator] = STATE(22558),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22558),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22812),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18164),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4317),
    [anon_sym_DASH_GT] = ACTIONS(4317),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4319),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1271] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21321),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1272] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15565),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1273] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21544),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4321),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1274] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21551),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4323),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1275] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21759),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21757),
    [sym_qualified_constructor_operator] = STATE(21757),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21757),
    [sym_qualified_type_operator] = STATE(21757),
    [sym__qualified_type_operator] = STATE(21757),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21757),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21579),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19032),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19501),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4325),
    [anon_sym_DASH_GT] = ACTIONS(4325),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4329),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1276] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22263),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4331),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1277] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22261),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4333),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1278] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21868),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21860),
    [sym_qualified_constructor_operator] = STATE(21860),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21860),
    [sym_qualified_type_operator] = STATE(21860),
    [sym__qualified_type_operator] = STATE(21860),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21860),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21981),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19631),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19633),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2732),
    [anon_sym_DASH_GT] = ACTIONS(2732),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2736),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2738),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1279] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15045),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1280] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22118),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4337),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1281] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21812),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21798),
    [sym_qualified_constructor_operator] = STATE(21798),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21798),
    [sym_qualified_type_operator] = STATE(21798),
    [sym__qualified_type_operator] = STATE(21798),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21798),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23429),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20173),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18925),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4339),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(377),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4341),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4343),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1282] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22153),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4345),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1283] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15086),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4347),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1284] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(22814),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22813),
    [sym_qualified_constructor_operator] = STATE(22813),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22813),
    [sym_qualified_type_operator] = STATE(22813),
    [sym__qualified_type_operator] = STATE(22813),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(22813),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21808),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17897),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1285] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15225),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1286] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15538),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4351),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1287] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21811),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21809),
    [sym_qualified_constructor_operator] = STATE(21809),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21809),
    [sym_qualified_type_operator] = STATE(21809),
    [sym__qualified_type_operator] = STATE(21809),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21809),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21924),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19614),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19615),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2505),
    [anon_sym_DASH_GT] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4353),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2511),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1288] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9310),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9310),
    [sym_exp_cond] = STATE(9310),
    [sym_exp_if_guard] = STATE(9310),
    [sym_exp_case] = STATE(9310),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9310),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9310),
    [sym__lexp] = STATE(9310),
    [sym_exp_infix] = STATE(9310),
    [sym__exp_infix] = STATE(9310),
    [sym__exp] = STATE(15138),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(4355),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1289] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21459),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21462),
    [sym_qualified_constructor_operator] = STATE(21462),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21462),
    [sym_qualified_type_operator] = STATE(21462),
    [sym__qualified_type_operator] = STATE(21462),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21462),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21705),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19070),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20149),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4357),
    [anon_sym_DASH_GT] = ACTIONS(4357),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4359),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4361),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4363),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1290] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21385),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21386),
    [sym_qualified_constructor_operator] = STATE(21386),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21386),
    [sym_qualified_type_operator] = STATE(21386),
    [sym__qualified_type_operator] = STATE(21386),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21386),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21415),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19303),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19231),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4365),
    [anon_sym_DASH_GT] = ACTIONS(4365),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4367),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4369),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4371),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1291] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4373),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1292] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21584),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21580),
    [sym_qualified_constructor_operator] = STATE(21580),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21580),
    [sym_qualified_type_operator] = STATE(21580),
    [sym__qualified_type_operator] = STATE(21580),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21580),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21427),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19151),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19533),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(4375),
    [anon_sym_DASH_GT] = ACTIONS(4375),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4377),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(4379),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4381),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1293] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22899),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4383),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1294] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22902),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4385),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1295] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21593),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4387),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1296] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21725),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4389),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1297] = {
    [sym_integer] = STATE(10708),
    [sym__literal] = STATE(10708),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(10935),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(10623),
    [sym_qualified_constructor] = STATE(10748),
    [sym__qcon] = STATE(11222),
    [sym_con_unit] = STATE(10708),
    [sym_con_list] = STATE(10708),
    [sym_con_tuple] = STATE(10708),
    [sym_literal] = STATE(11221),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(14068),
    [sym_pat_as] = STATE(14068),
    [sym__pat_constructor] = STATE(13370),
    [sym_pat_record] = STATE(14068),
    [sym_pat_wildcard] = STATE(14068),
    [sym_pat_parens] = STATE(14068),
    [sym_pat_tuple] = STATE(14068),
    [sym_pat_unboxed_tuple] = STATE(14068),
    [sym_pat_unboxed_sum] = STATE(14068),
    [sym_pat_list] = STATE(14068),
    [sym_pat_strict] = STATE(14068),
    [sym_pat_irrefutable] = STATE(14068),
    [sym_pat_type_binder] = STATE(14068),
    [sym__apat] = STATE(14068),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13927),
    [sym_splice] = STATE(11219),
    [sym_quasiquote] = STATE(11219),
    [sym__varid] = ACTIONS(3563),
    [sym_float] = ACTIONS(3565),
    [sym_char] = ACTIONS(3565),
    [sym_string] = ACTIONS(3565),
    [sym__integer_literal] = ACTIONS(3567),
    [sym__binary_literal] = ACTIONS(3569),
    [sym__octal_literal] = ACTIONS(3569),
    [sym__hex_literal] = ACTIONS(3569),
    [anon_sym_LPAREN_POUND] = ACTIONS(4391),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4391),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_RPAREN] = ACTIONS(3577),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(4397),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4401),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(3593),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3597),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [1298] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(21752),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21747),
    [sym_qualified_constructor_operator] = STATE(21747),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21747),
    [sym_qualified_type_operator] = STATE(21747),
    [sym__qualified_type_operator] = STATE(21747),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(21747),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21858),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19589),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19590),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2415),
    [anon_sym_DASH_GT] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4409),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2419),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2421),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1299] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4411),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1300] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21669),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4413),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1301] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21673),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_RBRACK] = ACTIONS(4415),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1302] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym__arrow] = STATE(23230),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23223),
    [sym_qualified_constructor_operator] = STATE(23223),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23223),
    [sym_qualified_type_operator] = STATE(23223),
    [sym__qualified_type_operator] = STATE(23223),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7258),
    [sym_annotated_type_variable] = STATE(23223),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22410),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19792),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19389),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u2192] = ACTIONS(2957),
    [anon_sym_DASH_GT] = ACTIONS(2957),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4417),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3041),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1303] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10997),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10997),
    [sym_exp_cond] = STATE(10997),
    [sym_exp_if_guard] = STATE(10997),
    [sym_exp_case] = STATE(10997),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10997),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10997),
    [sym__lexp] = STATE(10997),
    [sym_exp_infix] = STATE(10997),
    [sym__exp_infix] = STATE(10997),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4419),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1304] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13411),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1305] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(21268),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1306] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13052),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1307] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13090),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1308] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20867),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1309] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13326),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1310] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13478),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1311] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16458),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1312] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21109),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1313] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13108),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1314] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16430),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1315] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11134),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11134),
    [sym_exp_cond] = STATE(11134),
    [sym_exp_if_guard] = STATE(11134),
    [sym_exp_case] = STATE(11134),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11134),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11134),
    [sym__lexp] = STATE(11134),
    [sym_exp_infix] = STATE(11134),
    [sym__exp_infix] = STATE(11134),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4437),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1316] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13165),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1317] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22255),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1318] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13501),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1319] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16658),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1320] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16566),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1321] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11009),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11009),
    [sym_exp_cond] = STATE(11009),
    [sym_exp_if_guard] = STATE(11009),
    [sym_exp_case] = STATE(11009),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11009),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11009),
    [sym__lexp] = STATE(11009),
    [sym_exp_infix] = STATE(11009),
    [sym__exp_infix] = STATE(11009),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4439),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1322] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21032),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1323] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4441),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1324] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10948),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10948),
    [sym_exp_cond] = STATE(10948),
    [sym_exp_if_guard] = STATE(10948),
    [sym_exp_case] = STATE(10948),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10948),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10948),
    [sym__lexp] = STATE(10948),
    [sym_exp_infix] = STATE(10948),
    [sym__exp_infix] = STATE(10948),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4443),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1325] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10997),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10997),
    [sym_exp_cond] = STATE(10997),
    [sym_exp_if_guard] = STATE(10997),
    [sym_exp_case] = STATE(10997),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10997),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10997),
    [sym__lexp] = STATE(10997),
    [sym_exp_infix] = STATE(10997),
    [sym__exp_infix] = STATE(10997),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4445),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1326] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13502),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1327] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21023),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1328] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13514),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1329] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13232),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1330] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20221),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1331] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16746),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1332] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4447),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1333] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16374),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1334] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13515),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1335] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13525),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1336] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11094),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11094),
    [sym_exp_cond] = STATE(11094),
    [sym_exp_if_guard] = STATE(11094),
    [sym_exp_case] = STATE(11094),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11094),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11094),
    [sym__lexp] = STATE(11094),
    [sym_exp_infix] = STATE(11094),
    [sym__exp_infix] = STATE(11094),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4449),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1337] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13557),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1338] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21468),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1339] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16803),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1340] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(9994),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(9994),
    [sym_exp_cond] = STATE(9994),
    [sym_exp_if_guard] = STATE(9994),
    [sym_exp_case] = STATE(9994),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(9994),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(9994),
    [sym__lexp] = STATE(9994),
    [sym_exp_infix] = STATE(9994),
    [sym__exp_infix] = STATE(9994),
    [sym__exp] = STATE(16420),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1341] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(20865),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1342] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(119),
    [sym_variable] = STATE(11833),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(10340),
    [sym_qualified_constructor] = STATE(10549),
    [sym__qcon] = STATE(12382),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(12381),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(14054),
    [sym_pat_as] = STATE(14054),
    [sym__pat_constructor] = STATE(13397),
    [sym_pat_record] = STATE(14054),
    [sym_pat_wildcard] = STATE(14054),
    [sym_pat_parens] = STATE(14054),
    [sym_pat_tuple] = STATE(14054),
    [sym_pat_unboxed_tuple] = STATE(14054),
    [sym_pat_unboxed_sum] = STATE(14054),
    [sym_pat_list] = STATE(14054),
    [sym_pat_strict] = STATE(14054),
    [sym_pat_irrefutable] = STATE(14054),
    [sym_pat_type_binder] = STATE(14054),
    [sym__apat] = STATE(14054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14078),
    [sym_splice] = STATE(12380),
    [sym_quasiquote] = STATE(12380),
    [sym__varid] = ACTIONS(4455),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(4463),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4463),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4465),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4467),
    [anon_sym_LBRACK] = ACTIONS(4469),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4471),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [1343] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20791),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1344] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13278),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1345] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11043),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11043),
    [sym_exp_cond] = STATE(11043),
    [sym_exp_if_guard] = STATE(11043),
    [sym_exp_case] = STATE(11043),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11043),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11043),
    [sym__lexp] = STATE(11043),
    [sym_exp_infix] = STATE(11043),
    [sym__exp_infix] = STATE(11043),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4479),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1346] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21251),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1347] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10315),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10315),
    [sym_exp_cond] = STATE(10315),
    [sym_exp_if_guard] = STATE(10315),
    [sym_exp_case] = STATE(10315),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10315),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10315),
    [sym__lexp] = STATE(10315),
    [sym_exp_infix] = STATE(10315),
    [sym__exp_infix] = STATE(10315),
    [sym__exp] = STATE(13602),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1348] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13292),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1349] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10154),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10154),
    [sym_exp_cond] = STATE(10154),
    [sym_exp_if_guard] = STATE(10154),
    [sym_exp_case] = STATE(10154),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10154),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10154),
    [sym__lexp] = STATE(10154),
    [sym_exp_infix] = STATE(10154),
    [sym__exp_infix] = STATE(10154),
    [sym__exp] = STATE(13310),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1350] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21261),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1351] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10315),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10315),
    [sym_exp_cond] = STATE(10315),
    [sym_exp_if_guard] = STATE(10315),
    [sym_exp_case] = STATE(10315),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10315),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10315),
    [sym__lexp] = STATE(10315),
    [sym_exp_infix] = STATE(10315),
    [sym__exp_infix] = STATE(10315),
    [sym__exp] = STATE(13603),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1352] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16823),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1353] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10386),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10386),
    [sym_exp_cond] = STATE(10386),
    [sym_exp_if_guard] = STATE(10386),
    [sym_exp_case] = STATE(10386),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10386),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10386),
    [sym__lexp] = STATE(10386),
    [sym_exp_infix] = STATE(10386),
    [sym__exp_infix] = STATE(10386),
    [sym__exp] = STATE(13718),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1354] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11043),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11043),
    [sym_exp_cond] = STATE(11043),
    [sym_exp_if_guard] = STATE(11043),
    [sym_exp_case] = STATE(11043),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11043),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11043),
    [sym__lexp] = STATE(11043),
    [sym_exp_infix] = STATE(11043),
    [sym__exp_infix] = STATE(11043),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4493),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1355] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21420),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1356] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10154),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10154),
    [sym_exp_cond] = STATE(10154),
    [sym_exp_if_guard] = STATE(10154),
    [sym_exp_case] = STATE(10154),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10154),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10154),
    [sym__lexp] = STATE(10154),
    [sym_exp_infix] = STATE(10154),
    [sym__exp_infix] = STATE(10154),
    [sym__exp] = STATE(13315),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1357] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10348),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10348),
    [sym_exp_cond] = STATE(10348),
    [sym_exp_if_guard] = STATE(10348),
    [sym_exp_case] = STATE(10348),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10348),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10348),
    [sym__lexp] = STATE(10348),
    [sym_exp_infix] = STATE(10348),
    [sym__exp_infix] = STATE(10348),
    [sym__exp] = STATE(20110),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1358] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10154),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10154),
    [sym_exp_cond] = STATE(10154),
    [sym_exp_if_guard] = STATE(10154),
    [sym_exp_case] = STATE(10154),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10154),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10154),
    [sym__lexp] = STATE(10154),
    [sym_exp_infix] = STATE(10154),
    [sym__exp_infix] = STATE(10154),
    [sym__exp] = STATE(13367),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1359] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13513),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1360] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11054),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11054),
    [sym_exp_cond] = STATE(11054),
    [sym_exp_if_guard] = STATE(11054),
    [sym_exp_case] = STATE(11054),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11054),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11054),
    [sym__lexp] = STATE(11054),
    [sym_exp_infix] = STATE(11054),
    [sym__exp_infix] = STATE(11054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4447),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1361] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16369),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1362] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20771),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1363] = {
    [sym_integer] = STATE(11125),
    [sym__literal] = STATE(11125),
    [sym__unboxed_open] = STATE(105),
    [sym_variable] = STATE(10827),
    [sym_qualified_variable] = STATE(11068),
    [sym_constructor] = STATE(10858),
    [sym_qualified_constructor] = STATE(11007),
    [sym__qcon] = STATE(10929),
    [sym_con_unit] = STATE(11125),
    [sym_con_list] = STATE(11125),
    [sym_con_tuple] = STATE(11125),
    [sym_literal] = STATE(10928),
    [sym_exp_parens] = STATE(11071),
    [sym_exp_tuple] = STATE(11071),
    [sym_exp_unboxed_tuple] = STATE(11071),
    [sym_exp_unboxed_sum] = STATE(11071),
    [sym_exp_list] = STATE(11071),
    [sym_exp_arithmetic_sequence] = STATE(11071),
    [sym_exp_list_comprehension] = STATE(11071),
    [sym_exp_section_left] = STATE(11071),
    [sym_exp_section_right] = STATE(11071),
    [sym_exp_th_quoted_name] = STATE(11071),
    [sym_exp_type_application] = STATE(11256),
    [sym_exp_lambda_case] = STATE(11256),
    [sym_exp_lambda_cases] = STATE(11256),
    [sym__do_keyword] = STATE(20746),
    [sym_do_module] = STATE(20746),
    [sym_exp_do] = STATE(11256),
    [sym_exp_record] = STATE(11071),
    [sym_exp_name] = STATE(11071),
    [sym_exp_projection_selector] = STATE(11071),
    [sym__aexp_projection] = STATE(11071),
    [sym_exp_projection] = STATE(11071),
    [sym__aexp] = STATE(11256),
    [sym_pat_name] = STATE(14068),
    [sym_pat_as] = STATE(14068),
    [sym__pat_constructor] = STATE(13370),
    [sym_pat_record] = STATE(14068),
    [sym_pat_wildcard] = STATE(14068),
    [sym_pat_parens] = STATE(14068),
    [sym_pat_tuple] = STATE(14068),
    [sym_pat_unboxed_tuple] = STATE(14068),
    [sym_pat_unboxed_sum] = STATE(14068),
    [sym_pat_list] = STATE(14068),
    [sym_pat_strict] = STATE(14068),
    [sym_pat_irrefutable] = STATE(14068),
    [sym_pat_type_binder] = STATE(14068),
    [sym__apat] = STATE(14068),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13892),
    [sym_splice] = STATE(10921),
    [sym_quasiquote] = STATE(10921),
    [sym__varid] = ACTIONS(4499),
    [sym_float] = ACTIONS(4501),
    [sym_char] = ACTIONS(4501),
    [sym_string] = ACTIONS(4501),
    [sym__integer_literal] = ACTIONS(4503),
    [sym__binary_literal] = ACTIONS(4505),
    [sym__octal_literal] = ACTIONS(4505),
    [sym__hex_literal] = ACTIONS(4505),
    [anon_sym_LPAREN_POUND] = ACTIONS(4507),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4507),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [sym_implicit_parid] = ACTIONS(4509),
    [sym__conid] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4515),
    [anon_sym_SQUOTE] = ACTIONS(4517),
    [anon_sym_AT] = ACTIONS(4519),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4521),
    [anon_sym_BSLASH] = ACTIONS(4523),
    [anon_sym_mdo] = ACTIONS(4525),
    [anon_sym_do] = ACTIONS(4525),
    [anon_sym_u27e6] = ACTIONS(4527),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4529),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4531),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [1364] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16529),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1365] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11037),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11037),
    [sym_exp_cond] = STATE(11037),
    [sym_exp_if_guard] = STATE(11037),
    [sym_exp_case] = STATE(11037),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11037),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11037),
    [sym__lexp] = STATE(11037),
    [sym_exp_infix] = STATE(11037),
    [sym__exp_infix] = STATE(11037),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4533),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1366] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9787),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9787),
    [sym_exp_cond] = STATE(9787),
    [sym_exp_if_guard] = STATE(9787),
    [sym_exp_case] = STATE(9787),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9787),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9787),
    [sym__lexp] = STATE(9787),
    [sym_exp_infix] = STATE(9787),
    [sym__exp_infix] = STATE(9787),
    [sym__exp] = STATE(16124),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1367] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21172),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1368] = {
    [sym_integer] = STATE(12301),
    [sym__literal] = STATE(12301),
    [sym__unboxed_open] = STATE(121),
    [sym_variable] = STATE(11572),
    [sym_qualified_variable] = STATE(12709),
    [sym_constructor] = STATE(11712),
    [sym_qualified_constructor] = STATE(12598),
    [sym__qcon] = STATE(12241),
    [sym_con_unit] = STATE(12301),
    [sym_con_list] = STATE(12301),
    [sym_con_tuple] = STATE(12301),
    [sym_literal] = STATE(12239),
    [sym_exp_parens] = STATE(12569),
    [sym_exp_tuple] = STATE(12569),
    [sym_exp_unboxed_tuple] = STATE(12569),
    [sym_exp_unboxed_sum] = STATE(12569),
    [sym_exp_list] = STATE(12569),
    [sym_exp_arithmetic_sequence] = STATE(12569),
    [sym_exp_list_comprehension] = STATE(12569),
    [sym_exp_section_left] = STATE(12569),
    [sym_exp_section_right] = STATE(12569),
    [sym_exp_th_quoted_name] = STATE(12569),
    [sym_exp_type_application] = STATE(12902),
    [sym_exp_lambda_case] = STATE(12902),
    [sym_exp_lambda_cases] = STATE(12902),
    [sym__do_keyword] = STATE(20640),
    [sym_do_module] = STATE(20640),
    [sym_exp_do] = STATE(12902),
    [sym_exp_record] = STATE(12569),
    [sym_exp_name] = STATE(12569),
    [sym_exp_projection_selector] = STATE(12569),
    [sym__aexp_projection] = STATE(12569),
    [sym_exp_projection] = STATE(12569),
    [sym__aexp] = STATE(12902),
    [sym_pat_name] = STATE(14819),
    [sym_pat_as] = STATE(14819),
    [sym__pat_constructor] = STATE(14088),
    [sym_pat_record] = STATE(14819),
    [sym_pat_wildcard] = STATE(14819),
    [sym_pat_parens] = STATE(14819),
    [sym_pat_tuple] = STATE(14819),
    [sym_pat_unboxed_tuple] = STATE(14819),
    [sym_pat_unboxed_sum] = STATE(14819),
    [sym_pat_list] = STATE(14819),
    [sym_pat_strict] = STATE(14819),
    [sym_pat_irrefutable] = STATE(14819),
    [sym_pat_type_binder] = STATE(14819),
    [sym__apat] = STATE(14819),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14071),
    [sym_splice] = STATE(12230),
    [sym_quasiquote] = STATE(12230),
    [sym__varid] = ACTIONS(4539),
    [sym_float] = ACTIONS(4541),
    [sym_char] = ACTIONS(4541),
    [sym_string] = ACTIONS(4541),
    [sym__integer_literal] = ACTIONS(4543),
    [sym__binary_literal] = ACTIONS(4545),
    [sym__octal_literal] = ACTIONS(4545),
    [sym__hex_literal] = ACTIONS(4545),
    [anon_sym_LPAREN_POUND] = ACTIONS(4547),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4547),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4549),
    [anon_sym_LPAREN] = ACTIONS(4551),
    [sym_implicit_parid] = ACTIONS(4549),
    [sym__conid] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4555),
    [anon_sym_SQUOTE] = ACTIONS(4557),
    [anon_sym_AT] = ACTIONS(4559),
    [anon_sym__] = ACTIONS(1410),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4561),
    [anon_sym_BSLASH] = ACTIONS(4563),
    [anon_sym_mdo] = ACTIONS(4565),
    [anon_sym_do] = ACTIONS(4565),
    [anon_sym_u27e6] = ACTIONS(4567),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4571),
    [sym__strict] = ACTIONS(1428),
    [sym__lazy] = ACTIONS(1430),
  },
  [1369] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10386),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10386),
    [sym_exp_cond] = STATE(10386),
    [sym_exp_if_guard] = STATE(10386),
    [sym_exp_case] = STATE(10386),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10386),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10386),
    [sym__lexp] = STATE(10386),
    [sym_exp_infix] = STATE(10386),
    [sym__exp_infix] = STATE(10386),
    [sym__exp] = STATE(13631),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1370] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16463),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1371] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1372] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20827),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1373] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8351),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8351),
    [sym_exp_cond] = STATE(8351),
    [sym_exp_if_guard] = STATE(8351),
    [sym_exp_case] = STATE(8351),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8351),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8351),
    [sym__lexp] = STATE(8351),
    [sym_exp_infix] = STATE(8351),
    [sym__exp_infix] = STATE(8351),
    [sym__exp] = STATE(10906),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1374] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10965),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10965),
    [sym_exp_cond] = STATE(10965),
    [sym_exp_if_guard] = STATE(10965),
    [sym_exp_case] = STATE(10965),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10965),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10965),
    [sym__lexp] = STATE(10965),
    [sym_exp_infix] = STATE(10965),
    [sym__exp_infix] = STATE(10965),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1375] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8351),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8351),
    [sym_exp_cond] = STATE(8351),
    [sym_exp_if_guard] = STATE(8351),
    [sym_exp_case] = STATE(8351),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8351),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8351),
    [sym__lexp] = STATE(8351),
    [sym_exp_infix] = STATE(8351),
    [sym__exp_infix] = STATE(8351),
    [sym__exp] = STATE(10871),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1376] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10154),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10154),
    [sym_exp_cond] = STATE(10154),
    [sym_exp_if_guard] = STATE(10154),
    [sym_exp_case] = STATE(10154),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10154),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10154),
    [sym__lexp] = STATE(10154),
    [sym_exp_infix] = STATE(10154),
    [sym__exp_infix] = STATE(10154),
    [sym__exp] = STATE(13327),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1377] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10704),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1378] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16862),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1379] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8351),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8351),
    [sym_exp_cond] = STATE(8351),
    [sym_exp_if_guard] = STATE(8351),
    [sym_exp_case] = STATE(8351),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8351),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8351),
    [sym__lexp] = STATE(8351),
    [sym_exp_infix] = STATE(8351),
    [sym__exp_infix] = STATE(8351),
    [sym__exp] = STATE(10837),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1380] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8351),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8351),
    [sym_exp_cond] = STATE(8351),
    [sym_exp_if_guard] = STATE(8351),
    [sym_exp_case] = STATE(8351),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8351),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8351),
    [sym__lexp] = STATE(8351),
    [sym_exp_infix] = STATE(8351),
    [sym__exp_infix] = STATE(8351),
    [sym__exp] = STATE(10831),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1381] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8351),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8351),
    [sym_exp_cond] = STATE(8351),
    [sym_exp_if_guard] = STATE(8351),
    [sym_exp_case] = STATE(8351),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8351),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8351),
    [sym__lexp] = STATE(8351),
    [sym_exp_infix] = STATE(8351),
    [sym__exp_infix] = STATE(8351),
    [sym__exp] = STATE(10829),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1382] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1383] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8351),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8351),
    [sym_exp_cond] = STATE(8351),
    [sym_exp_if_guard] = STATE(8351),
    [sym_exp_case] = STATE(8351),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8351),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8351),
    [sym__lexp] = STATE(8351),
    [sym_exp_infix] = STATE(8351),
    [sym__exp_infix] = STATE(8351),
    [sym__exp] = STATE(10825),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1384] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10399),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10399),
    [sym_exp_cond] = STATE(10399),
    [sym_exp_if_guard] = STATE(10399),
    [sym_exp_case] = STATE(10399),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10399),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10399),
    [sym__lexp] = STATE(10399),
    [sym_exp_infix] = STATE(10399),
    [sym__exp_infix] = STATE(10399),
    [sym__exp] = STATE(18917),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1385] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16873),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1386] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10315),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10315),
    [sym_exp_cond] = STATE(10315),
    [sym_exp_if_guard] = STATE(10315),
    [sym_exp_case] = STATE(10315),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10315),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10315),
    [sym__lexp] = STATE(10315),
    [sym_exp_infix] = STATE(10315),
    [sym__exp_infix] = STATE(10315),
    [sym__exp] = STATE(13604),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1387] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22089),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1388] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(13210),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1389] = {
    [sym_integer] = STATE(10708),
    [sym__literal] = STATE(10708),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(10935),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(10623),
    [sym_qualified_constructor] = STATE(10748),
    [sym__qcon] = STATE(11222),
    [sym_con_unit] = STATE(10708),
    [sym_con_list] = STATE(10708),
    [sym_con_tuple] = STATE(10708),
    [sym_literal] = STATE(11221),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(14068),
    [sym_pat_as] = STATE(14068),
    [sym__pat_constructor] = STATE(13370),
    [sym_pat_record] = STATE(14068),
    [sym_pat_wildcard] = STATE(14068),
    [sym_pat_parens] = STATE(14068),
    [sym_pat_tuple] = STATE(14068),
    [sym_pat_unboxed_tuple] = STATE(14068),
    [sym_pat_unboxed_sum] = STATE(14068),
    [sym_pat_list] = STATE(14068),
    [sym_pat_strict] = STATE(14068),
    [sym_pat_irrefutable] = STATE(14068),
    [sym_pat_type_binder] = STATE(14068),
    [sym__apat] = STATE(14068),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13927),
    [sym_splice] = STATE(11219),
    [sym_quasiquote] = STATE(11219),
    [sym__varid] = ACTIONS(3563),
    [sym_float] = ACTIONS(3565),
    [sym_char] = ACTIONS(3565),
    [sym_string] = ACTIONS(3565),
    [sym__integer_literal] = ACTIONS(3567),
    [sym__binary_literal] = ACTIONS(3569),
    [sym__octal_literal] = ACTIONS(3569),
    [sym__hex_literal] = ACTIONS(3569),
    [anon_sym_LPAREN_POUND] = ACTIONS(4391),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4391),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(4397),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4401),
    [anon_sym__] = ACTIONS(269),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(3593),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3597),
    [sym__strict] = ACTIONS(293),
    [sym__lazy] = ACTIONS(295),
  },
  [1390] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10154),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10154),
    [sym_exp_cond] = STATE(10154),
    [sym_exp_if_guard] = STATE(10154),
    [sym_exp_case] = STATE(10154),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10154),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10154),
    [sym__lexp] = STATE(10154),
    [sym_exp_infix] = STATE(10154),
    [sym__exp_infix] = STATE(10154),
    [sym__exp] = STATE(13362),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1391] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20647),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1392] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10154),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10154),
    [sym_exp_cond] = STATE(10154),
    [sym_exp_if_guard] = STATE(10154),
    [sym_exp_case] = STATE(10154),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10154),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10154),
    [sym__lexp] = STATE(10154),
    [sym_exp_infix] = STATE(10154),
    [sym__exp_infix] = STATE(10154),
    [sym__exp] = STATE(13438),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1393] = {
    [sym_integer] = STATE(12301),
    [sym__literal] = STATE(12301),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(11910),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(11712),
    [sym_qualified_constructor] = STATE(12598),
    [sym__qcon] = STATE(12516),
    [sym_con_unit] = STATE(12301),
    [sym_con_list] = STATE(12301),
    [sym_con_tuple] = STATE(12301),
    [sym_literal] = STATE(12511),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(14819),
    [sym_pat_as] = STATE(14819),
    [sym__pat_constructor] = STATE(14088),
    [sym_pat_record] = STATE(14819),
    [sym_pat_wildcard] = STATE(14819),
    [sym_pat_parens] = STATE(14819),
    [sym_pat_tuple] = STATE(14819),
    [sym_pat_unboxed_tuple] = STATE(14819),
    [sym_pat_unboxed_sum] = STATE(14819),
    [sym_pat_list] = STATE(14819),
    [sym_pat_strict] = STATE(14819),
    [sym_pat_irrefutable] = STATE(14819),
    [sym_pat_type_binder] = STATE(14819),
    [sym__apat] = STATE(14819),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14110),
    [sym_splice] = STATE(12489),
    [sym_quasiquote] = STATE(12489),
    [sym__varid] = ACTIONS(4539),
    [sym_float] = ACTIONS(4541),
    [sym_char] = ACTIONS(4541),
    [sym_string] = ACTIONS(4541),
    [sym__integer_literal] = ACTIONS(4543),
    [sym__binary_literal] = ACTIONS(4545),
    [sym__octal_literal] = ACTIONS(4545),
    [sym__hex_literal] = ACTIONS(4545),
    [anon_sym_LPAREN_POUND] = ACTIONS(4585),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4585),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4587),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4589),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4591),
    [anon_sym__] = ACTIONS(1410),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4567),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4571),
    [sym__strict] = ACTIONS(1428),
    [sym__lazy] = ACTIONS(1430),
  },
  [1394] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20600),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1395] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10157),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10157),
    [sym_exp_cond] = STATE(10157),
    [sym_exp_if_guard] = STATE(10157),
    [sym_exp_case] = STATE(10157),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10157),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10157),
    [sym__lexp] = STATE(10157),
    [sym_exp_infix] = STATE(10157),
    [sym__exp_infix] = STATE(10157),
    [sym__exp] = STATE(13506),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1396] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(21021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1397] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20834),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1398] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16527),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1399] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22972),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1400] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11128),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11128),
    [sym_exp_cond] = STATE(11128),
    [sym_exp_if_guard] = STATE(11128),
    [sym_exp_case] = STATE(11128),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11128),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11128),
    [sym__lexp] = STATE(11128),
    [sym_exp_infix] = STATE(11128),
    [sym__exp_infix] = STATE(11128),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4593),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1401] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22373),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1402] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16905),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1403] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16544),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1404] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11051),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11051),
    [sym_exp_cond] = STATE(11051),
    [sym_exp_if_guard] = STATE(11051),
    [sym_exp_case] = STATE(11051),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11051),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11051),
    [sym__lexp] = STATE(11051),
    [sym_exp_infix] = STATE(11051),
    [sym__exp_infix] = STATE(11051),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4595),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1405] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20311),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1406] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11074),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11074),
    [sym_exp_cond] = STATE(11074),
    [sym_exp_if_guard] = STATE(11074),
    [sym_exp_case] = STATE(11074),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11074),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11074),
    [sym__lexp] = STATE(11074),
    [sym_exp_infix] = STATE(11074),
    [sym__exp_infix] = STATE(11074),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4597),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1407] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(10123),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(10123),
    [sym_exp_cond] = STATE(10123),
    [sym_exp_if_guard] = STATE(10123),
    [sym_exp_case] = STATE(10123),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(10123),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(10123),
    [sym__lexp] = STATE(10123),
    [sym_exp_infix] = STATE(10123),
    [sym__exp_infix] = STATE(10123),
    [sym__exp] = STATE(17510),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1408] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10927),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10927),
    [sym_exp_cond] = STATE(10927),
    [sym_exp_if_guard] = STATE(10927),
    [sym_exp_case] = STATE(10927),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10927),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10927),
    [sym__lexp] = STATE(10927),
    [sym_exp_infix] = STATE(10927),
    [sym__exp_infix] = STATE(10927),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4599),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1409] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10315),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10315),
    [sym_exp_cond] = STATE(10315),
    [sym_exp_if_guard] = STATE(10315),
    [sym_exp_case] = STATE(10315),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10315),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10315),
    [sym__lexp] = STATE(10315),
    [sym_exp_infix] = STATE(10315),
    [sym__exp_infix] = STATE(10315),
    [sym__exp] = STATE(13607),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1410] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10157),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10157),
    [sym_exp_cond] = STATE(10157),
    [sym_exp_if_guard] = STATE(10157),
    [sym_exp_case] = STATE(10157),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10157),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10157),
    [sym__lexp] = STATE(10157),
    [sym_exp_infix] = STATE(10157),
    [sym__exp_infix] = STATE(10157),
    [sym__exp] = STATE(13508),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1411] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10157),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10157),
    [sym_exp_cond] = STATE(10157),
    [sym_exp_if_guard] = STATE(10157),
    [sym_exp_case] = STATE(10157),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10157),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10157),
    [sym__lexp] = STATE(10157),
    [sym_exp_infix] = STATE(10157),
    [sym__exp_infix] = STATE(10157),
    [sym__exp] = STATE(13509),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1412] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20714),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1413] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20275),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1414] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13536),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1415] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10077),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10077),
    [sym_exp_cond] = STATE(10077),
    [sym_exp_if_guard] = STATE(10077),
    [sym_exp_case] = STATE(10077),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10077),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10077),
    [sym__lexp] = STATE(10077),
    [sym_exp_infix] = STATE(10077),
    [sym__exp_infix] = STATE(10077),
    [sym__exp] = STATE(16653),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1416] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10217),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10217),
    [sym_exp_cond] = STATE(10217),
    [sym_exp_if_guard] = STATE(10217),
    [sym_exp_case] = STATE(10217),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10217),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10217),
    [sym__lexp] = STATE(10217),
    [sym_exp_infix] = STATE(10217),
    [sym__exp_infix] = STATE(10217),
    [sym__exp] = STATE(17260),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1417] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16536),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1418] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13452),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1419] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11000),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11000),
    [sym_exp_cond] = STATE(11000),
    [sym_exp_if_guard] = STATE(11000),
    [sym_exp_case] = STATE(11000),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11000),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11000),
    [sym__lexp] = STATE(11000),
    [sym_exp_infix] = STATE(11000),
    [sym__exp_infix] = STATE(11000),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4609),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1420] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10303),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10303),
    [sym_exp_cond] = STATE(10303),
    [sym_exp_if_guard] = STATE(10303),
    [sym_exp_case] = STATE(10303),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10303),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10303),
    [sym__lexp] = STATE(10303),
    [sym_exp_infix] = STATE(10303),
    [sym__exp_infix] = STATE(10303),
    [sym__exp] = STATE(13689),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1421] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13336),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1422] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13307),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1423] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10152),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10152),
    [sym_exp_cond] = STATE(10152),
    [sym_exp_if_guard] = STATE(10152),
    [sym_exp_case] = STATE(10152),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10152),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10152),
    [sym__lexp] = STATE(10152),
    [sym_exp_infix] = STATE(10152),
    [sym__exp_infix] = STATE(10152),
    [sym__exp] = STATE(13293),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1424] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10152),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10152),
    [sym_exp_cond] = STATE(10152),
    [sym_exp_if_guard] = STATE(10152),
    [sym_exp_case] = STATE(10152),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10152),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10152),
    [sym__lexp] = STATE(10152),
    [sym_exp_infix] = STATE(10152),
    [sym__exp_infix] = STATE(10152),
    [sym__exp] = STATE(13283),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1425] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13305),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1426] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10152),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10152),
    [sym_exp_cond] = STATE(10152),
    [sym_exp_if_guard] = STATE(10152),
    [sym_exp_case] = STATE(10152),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10152),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10152),
    [sym__lexp] = STATE(10152),
    [sym_exp_infix] = STATE(10152),
    [sym__exp_infix] = STATE(10152),
    [sym__exp] = STATE(13282),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1427] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10995),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10995),
    [sym_exp_cond] = STATE(10995),
    [sym_exp_if_guard] = STATE(10995),
    [sym_exp_case] = STATE(10995),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10995),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10995),
    [sym__lexp] = STATE(10995),
    [sym_exp_infix] = STATE(10995),
    [sym__exp_infix] = STATE(10995),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4611),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1428] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16728),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1429] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13286),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1430] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16832),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1431] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23330),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1432] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4493),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1433] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10152),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10152),
    [sym_exp_cond] = STATE(10152),
    [sym_exp_if_guard] = STATE(10152),
    [sym_exp_case] = STATE(10152),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10152),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10152),
    [sym__lexp] = STATE(10152),
    [sym_exp_infix] = STATE(10152),
    [sym__exp_infix] = STATE(10152),
    [sym__exp] = STATE(13266),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1434] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21149),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1435] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20389),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1436] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16617),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1437] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11097),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11097),
    [sym_exp_cond] = STATE(11097),
    [sym_exp_if_guard] = STATE(11097),
    [sym_exp_case] = STATE(11097),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11097),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11097),
    [sym__lexp] = STATE(11097),
    [sym_exp_infix] = STATE(11097),
    [sym__exp_infix] = STATE(11097),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4613),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1438] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10152),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10152),
    [sym_exp_cond] = STATE(10152),
    [sym_exp_if_guard] = STATE(10152),
    [sym_exp_case] = STATE(10152),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10152),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10152),
    [sym__lexp] = STATE(10152),
    [sym_exp_infix] = STATE(10152),
    [sym__exp_infix] = STATE(10152),
    [sym__exp] = STATE(13390),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1439] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12373),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1440] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10315),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10315),
    [sym_exp_cond] = STATE(10315),
    [sym_exp_if_guard] = STATE(10315),
    [sym_exp_case] = STATE(10315),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10315),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10315),
    [sym__lexp] = STATE(10315),
    [sym_exp_infix] = STATE(10315),
    [sym__exp_infix] = STATE(10315),
    [sym__exp] = STATE(13625),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1441] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17049),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1442] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10303),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10303),
    [sym_exp_cond] = STATE(10303),
    [sym_exp_if_guard] = STATE(10303),
    [sym_exp_case] = STATE(10303),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10303),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10303),
    [sym__lexp] = STATE(10303),
    [sym_exp_infix] = STATE(10303),
    [sym__exp_infix] = STATE(10303),
    [sym__exp] = STATE(13736),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1443] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(12960),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1444] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10995),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10995),
    [sym_exp_cond] = STATE(10995),
    [sym_exp_if_guard] = STATE(10995),
    [sym_exp_case] = STATE(10995),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10995),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10995),
    [sym__lexp] = STATE(10995),
    [sym_exp_infix] = STATE(10995),
    [sym__exp_infix] = STATE(10995),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4619),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1445] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10152),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10152),
    [sym_exp_cond] = STATE(10152),
    [sym_exp_if_guard] = STATE(10152),
    [sym_exp_case] = STATE(10152),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10152),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10152),
    [sym__lexp] = STATE(10152),
    [sym_exp_infix] = STATE(10152),
    [sym__exp_infix] = STATE(10152),
    [sym__exp] = STATE(13556),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1446] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4621),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1447] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10157),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10157),
    [sym_exp_cond] = STATE(10157),
    [sym_exp_if_guard] = STATE(10157),
    [sym_exp_case] = STATE(10157),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10157),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10157),
    [sym__lexp] = STATE(10157),
    [sym_exp_infix] = STATE(10157),
    [sym__exp_infix] = STATE(10157),
    [sym__exp] = STATE(13510),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1448] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(13076),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1449] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10303),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10303),
    [sym_exp_cond] = STATE(10303),
    [sym_exp_if_guard] = STATE(10303),
    [sym_exp_case] = STATE(10303),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10303),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10303),
    [sym__lexp] = STATE(10303),
    [sym_exp_infix] = STATE(10303),
    [sym__exp_infix] = STATE(10303),
    [sym__exp] = STATE(13759),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1450] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(12897),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1451] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11074),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11074),
    [sym_exp_cond] = STATE(11074),
    [sym_exp_if_guard] = STATE(11074),
    [sym_exp_case] = STATE(11074),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11074),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11074),
    [sym__lexp] = STATE(11074),
    [sym_exp_infix] = STATE(11074),
    [sym__exp_infix] = STATE(11074),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1452] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9029),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9029),
    [sym_exp_cond] = STATE(9029),
    [sym_exp_if_guard] = STATE(9029),
    [sym_exp_case] = STATE(9029),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9029),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9029),
    [sym__lexp] = STATE(9029),
    [sym_exp_infix] = STATE(9029),
    [sym__exp_infix] = STATE(9029),
    [sym__exp] = STATE(12013),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1453] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11133),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11133),
    [sym_exp_cond] = STATE(11133),
    [sym_exp_if_guard] = STATE(11133),
    [sym_exp_case] = STATE(11133),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11133),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11133),
    [sym__lexp] = STATE(11133),
    [sym_exp_infix] = STATE(11133),
    [sym__exp_infix] = STATE(11133),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4625),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1454] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20707),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1455] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10303),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10303),
    [sym_exp_cond] = STATE(10303),
    [sym_exp_if_guard] = STATE(10303),
    [sym_exp_case] = STATE(10303),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10303),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10303),
    [sym__lexp] = STATE(10303),
    [sym_exp_infix] = STATE(10303),
    [sym__exp_infix] = STATE(10303),
    [sym__exp] = STATE(13766),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1456] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20882),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1457] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22711),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1458] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11152),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11152),
    [sym_exp_cond] = STATE(11152),
    [sym_exp_if_guard] = STATE(11152),
    [sym_exp_case] = STATE(11152),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11152),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11152),
    [sym__lexp] = STATE(11152),
    [sym_exp_infix] = STATE(11152),
    [sym__exp_infix] = STATE(11152),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4627),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1459] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20593),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1460] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10303),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10303),
    [sym_exp_cond] = STATE(10303),
    [sym_exp_if_guard] = STATE(10303),
    [sym_exp_case] = STATE(10303),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10303),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10303),
    [sym__lexp] = STATE(10303),
    [sym_exp_infix] = STATE(10303),
    [sym__exp_infix] = STATE(10303),
    [sym__exp] = STATE(13768),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1461] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17060),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1462] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(10077),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(10077),
    [sym_exp_cond] = STATE(10077),
    [sym_exp_if_guard] = STATE(10077),
    [sym_exp_case] = STATE(10077),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(10077),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(10077),
    [sym__lexp] = STATE(10077),
    [sym_exp_infix] = STATE(10077),
    [sym__exp_infix] = STATE(10077),
    [sym__exp] = STATE(16836),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1463] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(10303),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(10303),
    [sym_exp_cond] = STATE(10303),
    [sym_exp_if_guard] = STATE(10303),
    [sym_exp_case] = STATE(10303),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(10303),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(10303),
    [sym__lexp] = STATE(10303),
    [sym_exp_infix] = STATE(10303),
    [sym__exp_infix] = STATE(10303),
    [sym__exp] = STATE(13781),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1464] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16351),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1465] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11094),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11094),
    [sym_exp_cond] = STATE(11094),
    [sym_exp_if_guard] = STATE(11094),
    [sym_exp_case] = STATE(11094),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11094),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11094),
    [sym__lexp] = STATE(11094),
    [sym_exp_infix] = STATE(11094),
    [sym__exp_infix] = STATE(11094),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4629),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1466] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(9994),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(9994),
    [sym_exp_cond] = STATE(9994),
    [sym_exp_if_guard] = STATE(9994),
    [sym_exp_case] = STATE(9994),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(9994),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(9994),
    [sym__lexp] = STATE(9994),
    [sym_exp_infix] = STATE(9994),
    [sym__exp_infix] = STATE(9994),
    [sym__exp] = STATE(16673),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1467] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11132),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11132),
    [sym_exp_cond] = STATE(11132),
    [sym_exp_if_guard] = STATE(11132),
    [sym_exp_case] = STATE(11132),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11132),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11132),
    [sym__lexp] = STATE(11132),
    [sym_exp_infix] = STATE(11132),
    [sym__exp_infix] = STATE(11132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4631),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1468] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13226),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1469] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11089),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11089),
    [sym_exp_cond] = STATE(11089),
    [sym_exp_if_guard] = STATE(11089),
    [sym_exp_case] = STATE(11089),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11089),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11089),
    [sym__lexp] = STATE(11089),
    [sym_exp_infix] = STATE(11089),
    [sym__exp_infix] = STATE(11089),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4633),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1470] = {
    [sym_integer] = STATE(11902),
    [sym__literal] = STATE(11902),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(11480),
    [sym_qualified_variable] = STATE(11540),
    [sym_constructor] = STATE(11192),
    [sym_qualified_constructor] = STATE(12069),
    [sym__qcon] = STATE(11722),
    [sym_con_unit] = STATE(11902),
    [sym_con_list] = STATE(11902),
    [sym_con_tuple] = STATE(11902),
    [sym_literal] = STATE(11727),
    [sym_exp_parens] = STATE(13028),
    [sym_exp_tuple] = STATE(13028),
    [sym_exp_unboxed_tuple] = STATE(13028),
    [sym_exp_unboxed_sum] = STATE(13028),
    [sym_exp_list] = STATE(13028),
    [sym_exp_arithmetic_sequence] = STATE(13028),
    [sym_exp_list_comprehension] = STATE(13028),
    [sym_exp_section_left] = STATE(13028),
    [sym_exp_section_right] = STATE(13028),
    [sym_exp_th_quoted_name] = STATE(13028),
    [sym_exp_type_application] = STATE(13455),
    [sym_exp_lambda_case] = STATE(13455),
    [sym_exp_lambda_cases] = STATE(13455),
    [sym__do_keyword] = STATE(20632),
    [sym_do_module] = STATE(20632),
    [sym_exp_do] = STATE(13455),
    [sym_exp_record] = STATE(13028),
    [sym_exp_name] = STATE(13028),
    [sym_exp_projection_selector] = STATE(13028),
    [sym__aexp_projection] = STATE(13028),
    [sym_exp_projection] = STATE(13028),
    [sym__aexp] = STATE(13455),
    [sym_pat_name] = STATE(13646),
    [sym_pat_as] = STATE(13646),
    [sym__pat_constructor] = STATE(12917),
    [sym_pat_record] = STATE(13646),
    [sym_pat_wildcard] = STATE(13646),
    [sym_pat_parens] = STATE(13646),
    [sym_pat_tuple] = STATE(13646),
    [sym_pat_unboxed_tuple] = STATE(13646),
    [sym_pat_unboxed_sum] = STATE(13646),
    [sym_pat_list] = STATE(13646),
    [sym_pat_strict] = STATE(13646),
    [sym_pat_irrefutable] = STATE(13646),
    [sym_pat_type_binder] = STATE(13646),
    [sym__apat] = STATE(13646),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13893),
    [sym_splice] = STATE(11730),
    [sym_quasiquote] = STATE(11730),
    [sym__varid] = ACTIONS(4635),
    [sym_float] = ACTIONS(4637),
    [sym_char] = ACTIONS(4637),
    [sym_string] = ACTIONS(4637),
    [sym__integer_literal] = ACTIONS(4639),
    [sym__binary_literal] = ACTIONS(4641),
    [sym__octal_literal] = ACTIONS(4641),
    [sym__hex_literal] = ACTIONS(4641),
    [anon_sym_LPAREN_POUND] = ACTIONS(4643),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4643),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4645),
    [anon_sym_LPAREN] = ACTIONS(4647),
    [sym_implicit_parid] = ACTIONS(4645),
    [sym__conid] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4651),
    [anon_sym_SQUOTE] = ACTIONS(4653),
    [anon_sym_AT] = ACTIONS(4655),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4657),
    [anon_sym_BSLASH] = ACTIONS(4659),
    [anon_sym_mdo] = ACTIONS(4661),
    [anon_sym_do] = ACTIONS(4661),
    [anon_sym_u27e6] = ACTIONS(4663),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4667),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [1471] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21369),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1472] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10939),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10939),
    [sym_exp_cond] = STATE(10939),
    [sym_exp_if_guard] = STATE(10939),
    [sym_exp_case] = STATE(10939),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10939),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10939),
    [sym__lexp] = STATE(10939),
    [sym_exp_infix] = STATE(10939),
    [sym__exp_infix] = STATE(10939),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4669),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1473] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10948),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10948),
    [sym_exp_cond] = STATE(10948),
    [sym_exp_if_guard] = STATE(10948),
    [sym_exp_case] = STATE(10948),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10948),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10948),
    [sym__lexp] = STATE(10948),
    [sym_exp_infix] = STATE(10948),
    [sym__exp_infix] = STATE(10948),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4671),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1474] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20621),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1475] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11096),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11096),
    [sym_exp_cond] = STATE(11096),
    [sym_exp_if_guard] = STATE(11096),
    [sym_exp_case] = STATE(11096),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11096),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11096),
    [sym__lexp] = STATE(11096),
    [sym_exp_infix] = STATE(11096),
    [sym__exp_infix] = STATE(11096),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4673),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1476] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20889),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1477] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(12846),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1478] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(21255),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1479] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1480] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(12845),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1481] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16393),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1482] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4633),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1483] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22015),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1484] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13324),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1485] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10386),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10386),
    [sym_exp_cond] = STATE(10386),
    [sym_exp_if_guard] = STATE(10386),
    [sym_exp_case] = STATE(10386),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10386),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10386),
    [sym__lexp] = STATE(10386),
    [sym_exp_infix] = STATE(10386),
    [sym__exp_infix] = STATE(10386),
    [sym__exp] = STATE(13668),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1486] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(12843),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1487] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9766),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9766),
    [sym_exp_cond] = STATE(9766),
    [sym_exp_if_guard] = STATE(9766),
    [sym_exp_case] = STATE(9766),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9766),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9766),
    [sym__lexp] = STATE(9766),
    [sym_exp_infix] = STATE(9766),
    [sym__exp_infix] = STATE(9766),
    [sym__exp] = STATE(13089),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1488] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21679),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1489] = {
    [sym_integer] = STATE(11709),
    [sym__literal] = STATE(11709),
    [sym__unboxed_open] = STATE(99),
    [sym_variable] = STATE(11519),
    [sym_qualified_variable] = STATE(12090),
    [sym_constructor] = STATE(11390),
    [sym_qualified_constructor] = STATE(11692),
    [sym__qcon] = STATE(11608),
    [sym_con_unit] = STATE(11709),
    [sym_con_list] = STATE(11709),
    [sym_con_tuple] = STATE(11709),
    [sym_literal] = STATE(11611),
    [sym_exp_parens] = STATE(11616),
    [sym_exp_tuple] = STATE(11616),
    [sym_exp_unboxed_tuple] = STATE(11616),
    [sym_exp_unboxed_sum] = STATE(11616),
    [sym_exp_list] = STATE(11616),
    [sym_exp_arithmetic_sequence] = STATE(11616),
    [sym_exp_list_comprehension] = STATE(11616),
    [sym_exp_section_left] = STATE(11616),
    [sym_exp_section_right] = STATE(11616),
    [sym_exp_th_quoted_name] = STATE(11616),
    [sym_exp_type_application] = STATE(12370),
    [sym_exp_lambda_case] = STATE(12370),
    [sym_exp_lambda_cases] = STATE(12370),
    [sym__do_keyword] = STATE(20713),
    [sym_do_module] = STATE(20713),
    [sym_exp_do] = STATE(12370),
    [sym_exp_record] = STATE(11616),
    [sym_exp_name] = STATE(11616),
    [sym_exp_projection_selector] = STATE(11616),
    [sym__aexp_projection] = STATE(11616),
    [sym_exp_projection] = STATE(11616),
    [sym__aexp] = STATE(12370),
    [sym_pat_name] = STATE(14540),
    [sym_pat_as] = STATE(14540),
    [sym__pat_constructor] = STATE(13799),
    [sym_pat_record] = STATE(14540),
    [sym_pat_wildcard] = STATE(14540),
    [sym_pat_parens] = STATE(14540),
    [sym_pat_tuple] = STATE(14540),
    [sym_pat_unboxed_tuple] = STATE(14540),
    [sym_pat_unboxed_sum] = STATE(14540),
    [sym_pat_list] = STATE(14540),
    [sym_pat_strict] = STATE(14540),
    [sym_pat_irrefutable] = STATE(14540),
    [sym_pat_type_binder] = STATE(14540),
    [sym__apat] = STATE(14540),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13998),
    [sym_splice] = STATE(11617),
    [sym_quasiquote] = STATE(11617),
    [sym__varid] = ACTIONS(4675),
    [sym_float] = ACTIONS(4677),
    [sym_char] = ACTIONS(4677),
    [sym_string] = ACTIONS(4677),
    [sym__integer_literal] = ACTIONS(4679),
    [sym__binary_literal] = ACTIONS(4681),
    [sym__octal_literal] = ACTIONS(4681),
    [sym__hex_literal] = ACTIONS(4681),
    [anon_sym_LPAREN_POUND] = ACTIONS(4683),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4683),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4685),
    [anon_sym_LPAREN] = ACTIONS(4687),
    [sym_implicit_parid] = ACTIONS(4685),
    [sym__conid] = ACTIONS(4689),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4693),
    [anon_sym_AT] = ACTIONS(4695),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4697),
    [anon_sym_BSLASH] = ACTIONS(4699),
    [anon_sym_mdo] = ACTIONS(4701),
    [anon_sym_do] = ACTIONS(4701),
    [anon_sym_u27e6] = ACTIONS(4703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4707),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
  },
  [1490] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9835),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9835),
    [sym_exp_cond] = STATE(9835),
    [sym_exp_if_guard] = STATE(9835),
    [sym_exp_case] = STATE(9835),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9835),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9835),
    [sym__lexp] = STATE(9835),
    [sym_exp_infix] = STATE(9835),
    [sym__exp_infix] = STATE(9835),
    [sym__exp] = STATE(15633),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1491] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11016),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11016),
    [sym_exp_cond] = STATE(11016),
    [sym_exp_if_guard] = STATE(11016),
    [sym_exp_case] = STATE(11016),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11016),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11016),
    [sym__lexp] = STATE(11016),
    [sym_exp_infix] = STATE(11016),
    [sym__exp_infix] = STATE(11016),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4709),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1492] = {
    [sym_integer] = STATE(10708),
    [sym__literal] = STATE(10708),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(10854),
    [sym_qualified_variable] = STATE(10761),
    [sym_constructor] = STATE(10623),
    [sym_qualified_constructor] = STATE(10748),
    [sym__qcon] = STATE(11028),
    [sym_con_unit] = STATE(10708),
    [sym_con_list] = STATE(10708),
    [sym_con_tuple] = STATE(10708),
    [sym_literal] = STATE(11040),
    [sym_exp_parens] = STATE(11036),
    [sym_exp_tuple] = STATE(11036),
    [sym_exp_unboxed_tuple] = STATE(11036),
    [sym_exp_unboxed_sum] = STATE(11036),
    [sym_exp_list] = STATE(11036),
    [sym_exp_arithmetic_sequence] = STATE(11036),
    [sym_exp_list_comprehension] = STATE(11036),
    [sym_exp_section_left] = STATE(11036),
    [sym_exp_section_right] = STATE(11036),
    [sym_exp_th_quoted_name] = STATE(11036),
    [sym_exp_type_application] = STATE(11241),
    [sym_exp_lambda_case] = STATE(11241),
    [sym_exp_lambda_cases] = STATE(11241),
    [sym__do_keyword] = STATE(20758),
    [sym_do_module] = STATE(20758),
    [sym_exp_do] = STATE(11241),
    [sym_exp_record] = STATE(11036),
    [sym_exp_name] = STATE(11036),
    [sym_exp_projection_selector] = STATE(11036),
    [sym__aexp_projection] = STATE(11036),
    [sym_exp_projection] = STATE(11036),
    [sym__aexp] = STATE(11241),
    [sym_pat_name] = STATE(13646),
    [sym_pat_as] = STATE(13646),
    [sym__pat_constructor] = STATE(12917),
    [sym_pat_record] = STATE(13646),
    [sym_pat_wildcard] = STATE(13646),
    [sym_pat_parens] = STATE(13646),
    [sym_pat_tuple] = STATE(13646),
    [sym_pat_unboxed_tuple] = STATE(13646),
    [sym_pat_unboxed_sum] = STATE(13646),
    [sym_pat_list] = STATE(13646),
    [sym_pat_strict] = STATE(13646),
    [sym_pat_irrefutable] = STATE(13646),
    [sym_pat_type_binder] = STATE(13646),
    [sym__apat] = STATE(13646),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14108),
    [sym_splice] = STATE(11048),
    [sym_quasiquote] = STATE(11048),
    [sym__varid] = ACTIONS(3563),
    [sym_float] = ACTIONS(3565),
    [sym_char] = ACTIONS(3565),
    [sym_string] = ACTIONS(3565),
    [sym__integer_literal] = ACTIONS(3567),
    [sym__binary_literal] = ACTIONS(3569),
    [sym__octal_literal] = ACTIONS(3569),
    [sym__hex_literal] = ACTIONS(3569),
    [anon_sym_LPAREN_POUND] = ACTIONS(4711),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4711),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [sym_implicit_parid] = ACTIONS(3573),
    [sym__conid] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(4715),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [anon_sym_AT] = ACTIONS(4717),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3587),
    [anon_sym_BSLASH] = ACTIONS(3589),
    [anon_sym_mdo] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_u27e6] = ACTIONS(3593),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3597),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [1493] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__exp] = STATE(12834),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1494] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10990),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10990),
    [sym_exp_cond] = STATE(10990),
    [sym_exp_if_guard] = STATE(10990),
    [sym_exp_case] = STATE(10990),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10990),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10990),
    [sym__lexp] = STATE(10990),
    [sym_exp_infix] = STATE(10990),
    [sym__exp_infix] = STATE(10990),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4719),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1495] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22283),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1496] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9029),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9029),
    [sym_exp_cond] = STATE(9029),
    [sym_exp_if_guard] = STATE(9029),
    [sym_exp_case] = STATE(9029),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9029),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9029),
    [sym__lexp] = STATE(9029),
    [sym_exp_infix] = STATE(9029),
    [sym__exp_infix] = STATE(9029),
    [sym__exp] = STATE(12057),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1497] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9029),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9029),
    [sym_exp_cond] = STATE(9029),
    [sym_exp_if_guard] = STATE(9029),
    [sym_exp_case] = STATE(9029),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9029),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9029),
    [sym__lexp] = STATE(9029),
    [sym_exp_infix] = STATE(9029),
    [sym__exp_infix] = STATE(9029),
    [sym__exp] = STATE(12059),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1498] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12770),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1499] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym__exp] = STATE(15913),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1500] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10911),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10911),
    [sym_exp_cond] = STATE(10911),
    [sym_exp_if_guard] = STATE(10911),
    [sym_exp_case] = STATE(10911),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10911),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10911),
    [sym__lexp] = STATE(10911),
    [sym_exp_infix] = STATE(10911),
    [sym__exp_infix] = STATE(10911),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4721),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1501] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12768),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1502] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12767),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1503] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12729),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1504] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12589),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1505] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9481),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9481),
    [sym_exp_cond] = STATE(9481),
    [sym_exp_if_guard] = STATE(9481),
    [sym_exp_case] = STATE(9481),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9481),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9481),
    [sym__lexp] = STATE(9481),
    [sym_exp_infix] = STATE(9481),
    [sym__exp_infix] = STATE(9481),
    [sym__exp] = STATE(12249),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1506] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10386),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10386),
    [sym_exp_cond] = STATE(10386),
    [sym_exp_if_guard] = STATE(10386),
    [sym_exp_case] = STATE(10386),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10386),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10386),
    [sym__lexp] = STATE(10386),
    [sym_exp_infix] = STATE(10386),
    [sym__exp_infix] = STATE(10386),
    [sym__exp] = STATE(13822),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1507] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11096),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11096),
    [sym_exp_cond] = STATE(11096),
    [sym_exp_if_guard] = STATE(11096),
    [sym_exp_case] = STATE(11096),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11096),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11096),
    [sym__lexp] = STATE(11096),
    [sym_exp_infix] = STATE(11096),
    [sym__exp_infix] = STATE(11096),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4723),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1508] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10386),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10386),
    [sym_exp_cond] = STATE(10386),
    [sym_exp_if_guard] = STATE(10386),
    [sym_exp_case] = STATE(10386),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10386),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10386),
    [sym__lexp] = STATE(10386),
    [sym_exp_infix] = STATE(10386),
    [sym__exp_infix] = STATE(10386),
    [sym__exp] = STATE(13825),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1509] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10919),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10919),
    [sym_exp_cond] = STATE(10919),
    [sym_exp_if_guard] = STATE(10919),
    [sym_exp_case] = STATE(10919),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10919),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10919),
    [sym__lexp] = STATE(10919),
    [sym_exp_infix] = STATE(10919),
    [sym__exp_infix] = STATE(10919),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4725),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1510] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20864),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1511] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10157),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10157),
    [sym_exp_cond] = STATE(10157),
    [sym_exp_if_guard] = STATE(10157),
    [sym_exp_case] = STATE(10157),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10157),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10157),
    [sym__lexp] = STATE(10157),
    [sym_exp_infix] = STATE(10157),
    [sym__exp_infix] = STATE(10157),
    [sym__exp] = STATE(13552),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1512] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10951),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10951),
    [sym_exp_cond] = STATE(10951),
    [sym_exp_if_guard] = STATE(10951),
    [sym_exp_case] = STATE(10951),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10951),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10951),
    [sym__lexp] = STATE(10951),
    [sym_exp_infix] = STATE(10951),
    [sym__exp_infix] = STATE(10951),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4727),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1513] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20887),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1514] = {
    [sym_integer] = STATE(12228),
    [sym__literal] = STATE(12228),
    [sym__unboxed_open] = STATE(118),
    [sym_variable] = STATE(11993),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(11980),
    [sym_qualified_constructor] = STATE(12433),
    [sym__qcon] = STATE(12640),
    [sym_con_unit] = STATE(12228),
    [sym_con_list] = STATE(12228),
    [sym_con_tuple] = STATE(12228),
    [sym_literal] = STATE(12625),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(14887),
    [sym_pat_as] = STATE(14887),
    [sym__pat_constructor] = STATE(14011),
    [sym_pat_record] = STATE(14887),
    [sym_pat_wildcard] = STATE(14887),
    [sym_pat_parens] = STATE(14887),
    [sym_pat_tuple] = STATE(14887),
    [sym_pat_unboxed_tuple] = STATE(14887),
    [sym_pat_unboxed_sum] = STATE(14887),
    [sym_pat_list] = STATE(14887),
    [sym_pat_strict] = STATE(14887),
    [sym_pat_irrefutable] = STATE(14887),
    [sym_pat_type_binder] = STATE(14887),
    [sym__apat] = STATE(14887),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14113),
    [sym_splice] = STATE(12624),
    [sym_quasiquote] = STATE(12624),
    [sym__varid] = ACTIONS(4729),
    [sym_float] = ACTIONS(4731),
    [sym_char] = ACTIONS(4731),
    [sym_string] = ACTIONS(4731),
    [sym__integer_literal] = ACTIONS(4733),
    [sym__binary_literal] = ACTIONS(4735),
    [sym__octal_literal] = ACTIONS(4735),
    [sym__hex_literal] = ACTIONS(4735),
    [anon_sym_LPAREN_POUND] = ACTIONS(4737),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4737),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4741),
    [anon_sym_LBRACK] = ACTIONS(4743),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4745),
    [anon_sym__] = ACTIONS(1598),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4747),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4749),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4751),
    [sym__strict] = ACTIONS(1606),
    [sym__lazy] = ACTIONS(1608),
  },
  [1515] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11088),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11088),
    [sym_exp_cond] = STATE(11088),
    [sym_exp_if_guard] = STATE(11088),
    [sym_exp_case] = STATE(11088),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11088),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11088),
    [sym__lexp] = STATE(11088),
    [sym_exp_infix] = STATE(11088),
    [sym__exp_infix] = STATE(11088),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4673),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1516] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10572),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10572),
    [sym_exp_cond] = STATE(10572),
    [sym_exp_if_guard] = STATE(10572),
    [sym_exp_case] = STATE(10572),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10572),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10572),
    [sym__lexp] = STATE(10572),
    [sym_exp_infix] = STATE(10572),
    [sym__exp_infix] = STATE(10572),
    [sym__exp] = STATE(13944),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1517] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11066),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11066),
    [sym_exp_cond] = STATE(11066),
    [sym_exp_if_guard] = STATE(11066),
    [sym_exp_case] = STATE(11066),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11066),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11066),
    [sym__lexp] = STATE(11066),
    [sym_exp_infix] = STATE(11066),
    [sym__exp_infix] = STATE(11066),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1518] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10572),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10572),
    [sym_exp_cond] = STATE(10572),
    [sym_exp_if_guard] = STATE(10572),
    [sym_exp_case] = STATE(10572),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10572),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10572),
    [sym__lexp] = STATE(10572),
    [sym_exp_infix] = STATE(10572),
    [sym__exp_infix] = STATE(10572),
    [sym__exp] = STATE(13949),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1519] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13330),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1520] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13331),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1521] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11015),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11015),
    [sym_exp_cond] = STATE(11015),
    [sym_exp_if_guard] = STATE(11015),
    [sym_exp_case] = STATE(11015),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11015),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11015),
    [sym__lexp] = STATE(11015),
    [sym_exp_infix] = STATE(11015),
    [sym__exp_infix] = STATE(11015),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1522] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23368),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1523] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11081),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11081),
    [sym_exp_cond] = STATE(11081),
    [sym_exp_if_guard] = STATE(11081),
    [sym_exp_case] = STATE(11081),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11081),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11081),
    [sym__lexp] = STATE(11081),
    [sym_exp_infix] = STATE(11081),
    [sym__exp_infix] = STATE(11081),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1524] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10944),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10944),
    [sym_exp_cond] = STATE(10944),
    [sym_exp_if_guard] = STATE(10944),
    [sym_exp_case] = STATE(10944),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10944),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10944),
    [sym__lexp] = STATE(10944),
    [sym_exp_infix] = STATE(10944),
    [sym__exp_infix] = STATE(10944),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1525] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10572),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10572),
    [sym_exp_cond] = STATE(10572),
    [sym_exp_if_guard] = STATE(10572),
    [sym_exp_case] = STATE(10572),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10572),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10572),
    [sym__lexp] = STATE(10572),
    [sym_exp_infix] = STATE(10572),
    [sym__exp_infix] = STATE(10572),
    [sym__exp] = STATE(13950),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1526] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10572),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10572),
    [sym_exp_cond] = STATE(10572),
    [sym_exp_if_guard] = STATE(10572),
    [sym_exp_case] = STATE(10572),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10572),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10572),
    [sym__lexp] = STATE(10572),
    [sym_exp_infix] = STATE(10572),
    [sym__exp_infix] = STATE(10572),
    [sym__exp] = STATE(13952),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1527] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23078),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1528] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(10168),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(10168),
    [sym_exp_cond] = STATE(10168),
    [sym_exp_if_guard] = STATE(10168),
    [sym_exp_case] = STATE(10168),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(10168),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(10168),
    [sym__lexp] = STATE(10168),
    [sym_exp_infix] = STATE(10168),
    [sym__exp_infix] = STATE(10168),
    [sym__exp] = STATE(13448),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1529] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20920),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1530] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4593),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1531] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10966),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10966),
    [sym_exp_cond] = STATE(10966),
    [sym_exp_if_guard] = STATE(10966),
    [sym_exp_case] = STATE(10966),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10966),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10966),
    [sym__lexp] = STATE(10966),
    [sym_exp_infix] = STATE(10966),
    [sym__exp_infix] = STATE(10966),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4761),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1532] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16486),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1533] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10572),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10572),
    [sym_exp_cond] = STATE(10572),
    [sym_exp_if_guard] = STATE(10572),
    [sym_exp_case] = STATE(10572),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10572),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10572),
    [sym__lexp] = STATE(10572),
    [sym_exp_infix] = STATE(10572),
    [sym__exp_infix] = STATE(10572),
    [sym__exp] = STATE(13970),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1534] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16385),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1535] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4763),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1536] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17061),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1537] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20379),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1538] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20386),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1539] = {
    [sym_integer] = STATE(11890),
    [sym__literal] = STATE(11890),
    [sym__unboxed_open] = STATE(116),
    [sym_variable] = STATE(11229),
    [sym_qualified_variable] = STATE(12985),
    [sym_constructor] = STATE(11426),
    [sym_qualified_constructor] = STATE(11528),
    [sym__qcon] = STATE(11950),
    [sym_con_unit] = STATE(11890),
    [sym_con_list] = STATE(11890),
    [sym_con_tuple] = STATE(11890),
    [sym_literal] = STATE(11951),
    [sym_exp_parens] = STATE(12783),
    [sym_exp_tuple] = STATE(12783),
    [sym_exp_unboxed_tuple] = STATE(12783),
    [sym_exp_unboxed_sum] = STATE(12783),
    [sym_exp_list] = STATE(12783),
    [sym_exp_arithmetic_sequence] = STATE(12783),
    [sym_exp_list_comprehension] = STATE(12783),
    [sym_exp_section_left] = STATE(12783),
    [sym_exp_section_right] = STATE(12783),
    [sym_exp_th_quoted_name] = STATE(12783),
    [sym_exp_type_application] = STATE(13403),
    [sym_exp_lambda_case] = STATE(13403),
    [sym_exp_lambda_cases] = STATE(13403),
    [sym__do_keyword] = STATE(20876),
    [sym_do_module] = STATE(20876),
    [sym_exp_do] = STATE(13403),
    [sym_exp_record] = STATE(12783),
    [sym_exp_name] = STATE(12783),
    [sym_exp_projection_selector] = STATE(12783),
    [sym__aexp_projection] = STATE(12783),
    [sym_exp_projection] = STATE(12783),
    [sym__aexp] = STATE(13403),
    [sym_pat_name] = STATE(14054),
    [sym_pat_as] = STATE(14054),
    [sym__pat_constructor] = STATE(13397),
    [sym_pat_record] = STATE(14054),
    [sym_pat_wildcard] = STATE(14054),
    [sym_pat_parens] = STATE(14054),
    [sym_pat_tuple] = STATE(14054),
    [sym_pat_unboxed_tuple] = STATE(14054),
    [sym_pat_unboxed_sum] = STATE(14054),
    [sym_pat_list] = STATE(14054),
    [sym_pat_strict] = STATE(14054),
    [sym_pat_irrefutable] = STATE(14054),
    [sym_pat_type_binder] = STATE(14054),
    [sym__apat] = STATE(14054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13997),
    [sym_splice] = STATE(11963),
    [sym_quasiquote] = STATE(11963),
    [sym__varid] = ACTIONS(4765),
    [sym_float] = ACTIONS(4767),
    [sym_char] = ACTIONS(4767),
    [sym_string] = ACTIONS(4767),
    [sym__integer_literal] = ACTIONS(4769),
    [sym__binary_literal] = ACTIONS(4771),
    [sym__octal_literal] = ACTIONS(4771),
    [sym__hex_literal] = ACTIONS(4771),
    [anon_sym_LPAREN_POUND] = ACTIONS(4773),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4773),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4775),
    [anon_sym_LPAREN] = ACTIONS(4777),
    [sym_implicit_parid] = ACTIONS(4775),
    [sym__conid] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4781),
    [anon_sym_SQUOTE] = ACTIONS(4783),
    [anon_sym_AT] = ACTIONS(4785),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4787),
    [anon_sym_BSLASH] = ACTIONS(4789),
    [anon_sym_mdo] = ACTIONS(4791),
    [anon_sym_do] = ACTIONS(4791),
    [anon_sym_u27e6] = ACTIONS(4793),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4797),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [1540] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11087),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11087),
    [sym_exp_cond] = STATE(11087),
    [sym_exp_if_guard] = STATE(11087),
    [sym_exp_case] = STATE(11087),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11087),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11087),
    [sym__lexp] = STATE(11087),
    [sym_exp_infix] = STATE(11087),
    [sym__exp_infix] = STATE(11087),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1541] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13248),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1542] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16640),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1543] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21793),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1544] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10995),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10995),
    [sym_exp_cond] = STATE(10995),
    [sym_exp_if_guard] = STATE(10995),
    [sym_exp_case] = STATE(10995),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10995),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10995),
    [sym__lexp] = STATE(10995),
    [sym_exp_infix] = STATE(10995),
    [sym__exp_infix] = STATE(10995),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4801),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1545] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22481),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1546] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10157),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10157),
    [sym_exp_cond] = STATE(10157),
    [sym_exp_if_guard] = STATE(10157),
    [sym_exp_case] = STATE(10157),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10157),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10157),
    [sym__lexp] = STATE(10157),
    [sym_exp_infix] = STATE(10157),
    [sym__exp_infix] = STATE(10157),
    [sym__exp] = STATE(13517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1547] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11000),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11000),
    [sym_exp_cond] = STATE(11000),
    [sym_exp_if_guard] = STATE(11000),
    [sym_exp_case] = STATE(11000),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11000),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11000),
    [sym__lexp] = STATE(11000),
    [sym_exp_infix] = STATE(11000),
    [sym__exp_infix] = STATE(11000),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4803),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1548] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22103),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1549] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10920),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10920),
    [sym_exp_cond] = STATE(10920),
    [sym_exp_if_guard] = STATE(10920),
    [sym_exp_case] = STATE(10920),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10920),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10920),
    [sym__lexp] = STATE(10920),
    [sym_exp_infix] = STATE(10920),
    [sym__exp_infix] = STATE(10920),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4805),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1550] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20362),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1551] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9029),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9029),
    [sym_exp_cond] = STATE(9029),
    [sym_exp_if_guard] = STATE(9029),
    [sym_exp_case] = STATE(9029),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9029),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9029),
    [sym__lexp] = STATE(9029),
    [sym_exp_infix] = STATE(9029),
    [sym__exp_infix] = STATE(9029),
    [sym__exp] = STATE(12083),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1552] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10976),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10976),
    [sym_exp_cond] = STATE(10976),
    [sym_exp_if_guard] = STATE(10976),
    [sym_exp_case] = STATE(10976),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10976),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10976),
    [sym__lexp] = STATE(10976),
    [sym_exp_infix] = STATE(10976),
    [sym__exp_infix] = STATE(10976),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4445),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1553] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10756),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1554] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11686),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1555] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4629),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1556] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10757),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1557] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13179),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1558] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13178),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1559] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11719),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1560] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11729),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1561] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11713),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1562] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9770),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9770),
    [sym_exp_cond] = STATE(9770),
    [sym_exp_if_guard] = STATE(9770),
    [sym_exp_case] = STATE(9770),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9770),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9770),
    [sym__lexp] = STATE(9770),
    [sym_exp_infix] = STATE(9770),
    [sym__exp_infix] = STATE(9770),
    [sym__exp] = STATE(13182),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1563] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9770),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9770),
    [sym_exp_cond] = STATE(9770),
    [sym_exp_if_guard] = STATE(9770),
    [sym_exp_case] = STATE(9770),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9770),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9770),
    [sym__lexp] = STATE(9770),
    [sym_exp_infix] = STATE(9770),
    [sym__exp_infix] = STATE(9770),
    [sym__exp] = STATE(13209),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1564] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10759),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1565] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9770),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9770),
    [sym_exp_cond] = STATE(9770),
    [sym_exp_if_guard] = STATE(9770),
    [sym_exp_case] = STATE(9770),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9770),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9770),
    [sym__lexp] = STATE(9770),
    [sym_exp_infix] = STATE(9770),
    [sym__exp_infix] = STATE(9770),
    [sym__exp] = STATE(13223),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1566] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16603),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1567] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10762),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1568] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10775),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1569] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(8263),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(8263),
    [sym_exp_cond] = STATE(8263),
    [sym_exp_if_guard] = STATE(8263),
    [sym_exp_case] = STATE(8263),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(8263),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(8263),
    [sym__lexp] = STATE(8263),
    [sym_exp_infix] = STATE(8263),
    [sym__exp_infix] = STATE(8263),
    [sym__exp] = STATE(10730),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1570] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9770),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9770),
    [sym_exp_cond] = STATE(9770),
    [sym_exp_if_guard] = STATE(9770),
    [sym_exp_case] = STATE(9770),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9770),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9770),
    [sym__lexp] = STATE(9770),
    [sym_exp_infix] = STATE(9770),
    [sym__exp_infix] = STATE(9770),
    [sym__exp] = STATE(13239),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1571] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16254),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1572] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(21230),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1573] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9029),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9029),
    [sym_exp_cond] = STATE(9029),
    [sym_exp_if_guard] = STATE(9029),
    [sym_exp_case] = STATE(9029),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9029),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9029),
    [sym__lexp] = STATE(9029),
    [sym_exp_infix] = STATE(9029),
    [sym__exp_infix] = STATE(9029),
    [sym__exp] = STATE(12101),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1574] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(23036),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1575] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1576] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(10572),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(10572),
    [sym_exp_cond] = STATE(10572),
    [sym_exp_if_guard] = STATE(10572),
    [sym_exp_case] = STATE(10572),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(10572),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(10572),
    [sym__lexp] = STATE(10572),
    [sym_exp_infix] = STATE(10572),
    [sym__exp_infix] = STATE(10572),
    [sym__exp] = STATE(14004),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1577] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9770),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9770),
    [sym_exp_cond] = STATE(9770),
    [sym_exp_if_guard] = STATE(9770),
    [sym_exp_case] = STATE(9770),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9770),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9770),
    [sym__lexp] = STATE(9770),
    [sym_exp_infix] = STATE(9770),
    [sym__exp_infix] = STATE(9770),
    [sym__exp] = STATE(13091),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1578] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11790),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1579] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(10386),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(10386),
    [sym_exp_cond] = STATE(10386),
    [sym_exp_if_guard] = STATE(10386),
    [sym_exp_case] = STATE(10386),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(10386),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(10386),
    [sym__lexp] = STATE(10386),
    [sym_exp_infix] = STATE(10386),
    [sym__exp_infix] = STATE(10386),
    [sym__exp] = STATE(13856),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1580] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11792),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1581] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13131),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1582] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11105),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11105),
    [sym_exp_cond] = STATE(11105),
    [sym_exp_if_guard] = STATE(11105),
    [sym_exp_case] = STATE(11105),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11105),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11105),
    [sym__lexp] = STATE(11105),
    [sym_exp_infix] = STATE(11105),
    [sym__exp_infix] = STATE(11105),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1583] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20431),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1584] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13130),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1585] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(9107),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(9107),
    [sym_exp_cond] = STATE(9107),
    [sym_exp_if_guard] = STATE(9107),
    [sym_exp_case] = STATE(9107),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(9107),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(9107),
    [sym__lexp] = STATE(9107),
    [sym_exp_infix] = STATE(9107),
    [sym__exp_infix] = STATE(9107),
    [sym__exp] = STATE(11857),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1586] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20400),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1587] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9770),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9770),
    [sym_exp_cond] = STATE(9770),
    [sym_exp_if_guard] = STATE(9770),
    [sym_exp_case] = STATE(9770),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9770),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9770),
    [sym__lexp] = STATE(9770),
    [sym_exp_infix] = STATE(9770),
    [sym__exp_infix] = STATE(9770),
    [sym__exp] = STATE(12789),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1588] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__exp] = STATE(13106),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1589] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11008),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11008),
    [sym_exp_cond] = STATE(11008),
    [sym_exp_if_guard] = STATE(11008),
    [sym_exp_case] = STATE(11008),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11008),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11008),
    [sym__lexp] = STATE(11008),
    [sym_exp_infix] = STATE(11008),
    [sym__exp_infix] = STATE(11008),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4813),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1590] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20435),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1591] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__exp] = STATE(13386),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1592] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16295),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1593] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21092),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1594] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22844),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1595] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21118),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1596] = {
    [sym_integer] = STATE(11709),
    [sym__literal] = STATE(11709),
    [sym__unboxed_open] = STATE(110),
    [sym_variable] = STATE(11213),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(11390),
    [sym_qualified_constructor] = STATE(11692),
    [sym__qcon] = STATE(12107),
    [sym_con_unit] = STATE(11709),
    [sym_con_list] = STATE(11709),
    [sym_con_tuple] = STATE(11709),
    [sym_literal] = STATE(12099),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(14540),
    [sym_pat_as] = STATE(14540),
    [sym__pat_constructor] = STATE(13799),
    [sym_pat_record] = STATE(14540),
    [sym_pat_wildcard] = STATE(14540),
    [sym_pat_parens] = STATE(14540),
    [sym_pat_tuple] = STATE(14540),
    [sym_pat_unboxed_tuple] = STATE(14540),
    [sym_pat_unboxed_sum] = STATE(14540),
    [sym_pat_list] = STATE(14540),
    [sym_pat_strict] = STATE(14540),
    [sym_pat_irrefutable] = STATE(14540),
    [sym_pat_type_binder] = STATE(14540),
    [sym__apat] = STATE(14540),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14086),
    [sym_splice] = STATE(12081),
    [sym_quasiquote] = STATE(12081),
    [sym__varid] = ACTIONS(4675),
    [sym_float] = ACTIONS(4677),
    [sym_char] = ACTIONS(4677),
    [sym_string] = ACTIONS(4677),
    [sym__integer_literal] = ACTIONS(4679),
    [sym__binary_literal] = ACTIONS(4681),
    [sym__octal_literal] = ACTIONS(4681),
    [sym__hex_literal] = ACTIONS(4681),
    [anon_sym_LPAREN_POUND] = ACTIONS(4815),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4815),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4817),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4689),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4821),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4707),
    [sym__strict] = ACTIONS(593),
    [sym__lazy] = ACTIONS(595),
  },
  [1597] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17680),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1598] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17477),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1599] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(21281),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1600] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20505),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1601] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10162),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10162),
    [sym_exp_cond] = STATE(10162),
    [sym_exp_if_guard] = STATE(10162),
    [sym_exp_case] = STATE(10162),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10162),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10162),
    [sym__lexp] = STATE(10162),
    [sym_exp_infix] = STATE(10162),
    [sym__exp_infix] = STATE(10162),
    [sym__exp] = STATE(13295),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1602] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20512),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1603] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10938),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10938),
    [sym_exp_cond] = STATE(10938),
    [sym_exp_if_guard] = STATE(10938),
    [sym_exp_case] = STATE(10938),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10938),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10938),
    [sym__lexp] = STATE(10938),
    [sym_exp_infix] = STATE(10938),
    [sym__exp_infix] = STATE(10938),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1604] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17461),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1605] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10162),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10162),
    [sym_exp_cond] = STATE(10162),
    [sym_exp_if_guard] = STATE(10162),
    [sym_exp_case] = STATE(10162),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10162),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10162),
    [sym__lexp] = STATE(10162),
    [sym_exp_infix] = STATE(10162),
    [sym__exp_infix] = STATE(10162),
    [sym__exp] = STATE(13358),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1606] = {
    [sym_integer] = STATE(11592),
    [sym__literal] = STATE(11592),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(11260),
    [sym_qualified_variable] = STATE(11540),
    [sym_constructor] = STATE(11179),
    [sym_qualified_constructor] = STATE(12088),
    [sym__qcon] = STATE(11689),
    [sym_con_unit] = STATE(11592),
    [sym_con_list] = STATE(11592),
    [sym_con_tuple] = STATE(11592),
    [sym_literal] = STATE(11685),
    [sym_exp_parens] = STATE(13028),
    [sym_exp_tuple] = STATE(13028),
    [sym_exp_unboxed_tuple] = STATE(13028),
    [sym_exp_unboxed_sum] = STATE(13028),
    [sym_exp_list] = STATE(13028),
    [sym_exp_arithmetic_sequence] = STATE(13028),
    [sym_exp_list_comprehension] = STATE(13028),
    [sym_exp_section_left] = STATE(13028),
    [sym_exp_section_right] = STATE(13028),
    [sym_exp_th_quoted_name] = STATE(13028),
    [sym_exp_type_application] = STATE(13455),
    [sym_exp_lambda_case] = STATE(13455),
    [sym_exp_lambda_cases] = STATE(13455),
    [sym__do_keyword] = STATE(20632),
    [sym_do_module] = STATE(20632),
    [sym_exp_do] = STATE(13455),
    [sym_exp_record] = STATE(13028),
    [sym_exp_name] = STATE(13028),
    [sym_exp_projection_selector] = STATE(13028),
    [sym__aexp_projection] = STATE(13028),
    [sym_exp_projection] = STATE(13028),
    [sym__aexp] = STATE(13455),
    [sym_pat_name] = STATE(14054),
    [sym_pat_as] = STATE(14054),
    [sym__pat_constructor] = STATE(13397),
    [sym_pat_record] = STATE(14054),
    [sym_pat_wildcard] = STATE(14054),
    [sym_pat_parens] = STATE(14054),
    [sym_pat_tuple] = STATE(14054),
    [sym_pat_unboxed_tuple] = STATE(14054),
    [sym_pat_unboxed_sum] = STATE(14054),
    [sym_pat_list] = STATE(14054),
    [sym_pat_strict] = STATE(14054),
    [sym_pat_irrefutable] = STATE(14054),
    [sym_pat_type_binder] = STATE(14054),
    [sym__apat] = STATE(14054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14093),
    [sym_splice] = STATE(11683),
    [sym_quasiquote] = STATE(11683),
    [sym__varid] = ACTIONS(4825),
    [sym_float] = ACTIONS(4827),
    [sym_char] = ACTIONS(4827),
    [sym_string] = ACTIONS(4827),
    [sym__integer_literal] = ACTIONS(4829),
    [sym__binary_literal] = ACTIONS(4831),
    [sym__octal_literal] = ACTIONS(4831),
    [sym__hex_literal] = ACTIONS(4831),
    [anon_sym_LPAREN_POUND] = ACTIONS(4833),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4833),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4645),
    [anon_sym_LPAREN] = ACTIONS(4835),
    [sym_implicit_parid] = ACTIONS(4645),
    [sym__conid] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(4839),
    [anon_sym_SQUOTE] = ACTIONS(4653),
    [anon_sym_AT] = ACTIONS(4841),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4657),
    [anon_sym_BSLASH] = ACTIONS(4659),
    [anon_sym_mdo] = ACTIONS(4661),
    [anon_sym_do] = ACTIONS(4661),
    [anon_sym_u27e6] = ACTIONS(4843),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4847),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [1607] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17448),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1608] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21305),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1609] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11249),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1610] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10399),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10399),
    [sym_exp_cond] = STATE(10399),
    [sym_exp_if_guard] = STATE(10399),
    [sym_exp_case] = STATE(10399),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10399),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10399),
    [sym__lexp] = STATE(10399),
    [sym_exp_infix] = STATE(10399),
    [sym__exp_infix] = STATE(10399),
    [sym__exp] = STATE(18104),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1611] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17329),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1612] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10913),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10913),
    [sym_exp_cond] = STATE(10913),
    [sym_exp_if_guard] = STATE(10913),
    [sym_exp_case] = STATE(10913),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10913),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10913),
    [sym__lexp] = STATE(10913),
    [sym_exp_infix] = STATE(10913),
    [sym__exp_infix] = STATE(10913),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4853),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1613] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22712),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1614] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9835),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9835),
    [sym_exp_cond] = STATE(9835),
    [sym_exp_if_guard] = STATE(9835),
    [sym_exp_case] = STATE(9835),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9835),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9835),
    [sym__lexp] = STATE(9835),
    [sym_exp_infix] = STATE(9835),
    [sym__exp_infix] = STATE(9835),
    [sym__exp] = STATE(15778),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1615] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10162),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10162),
    [sym_exp_cond] = STATE(10162),
    [sym_exp_if_guard] = STATE(10162),
    [sym_exp_case] = STATE(10162),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10162),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10162),
    [sym__lexp] = STATE(10162),
    [sym_exp_infix] = STATE(10162),
    [sym__exp_infix] = STATE(10162),
    [sym__exp] = STATE(13405),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1616] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21269),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1617] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10162),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10162),
    [sym_exp_cond] = STATE(10162),
    [sym_exp_if_guard] = STATE(10162),
    [sym_exp_case] = STATE(10162),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10162),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10162),
    [sym__lexp] = STATE(10162),
    [sym_exp_infix] = STATE(10162),
    [sym__exp_infix] = STATE(10162),
    [sym__exp] = STATE(13427),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1618] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17311),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1619] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21250),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1620] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17364),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1621] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4855),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1622] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11251),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1623] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11253),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1624] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(12996),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1625] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20575),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1626] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17313),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1627] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(12997),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1628] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(13007),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1629] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(13008),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1630] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(13016),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1631] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__exp] = STATE(12909),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1632] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11044),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11044),
    [sym_exp_cond] = STATE(11044),
    [sym_exp_if_guard] = STATE(11044),
    [sym_exp_case] = STATE(11044),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11044),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11044),
    [sym__lexp] = STATE(11044),
    [sym_exp_infix] = STATE(11044),
    [sym__exp_infix] = STATE(11044),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1633] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9029),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9029),
    [sym_exp_cond] = STATE(9029),
    [sym_exp_if_guard] = STATE(9029),
    [sym_exp_case] = STATE(9029),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9029),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9029),
    [sym__lexp] = STATE(9029),
    [sym_exp_infix] = STATE(9029),
    [sym__exp_infix] = STATE(9029),
    [sym__exp] = STATE(12108),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1634] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20586),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1635] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10162),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10162),
    [sym_exp_cond] = STATE(10162),
    [sym_exp_if_guard] = STATE(10162),
    [sym_exp_case] = STATE(10162),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10162),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10162),
    [sym__lexp] = STATE(10162),
    [sym_exp_infix] = STATE(10162),
    [sym__exp_infix] = STATE(10162),
    [sym__exp] = STATE(13435),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1636] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11061),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11061),
    [sym_exp_cond] = STATE(11061),
    [sym_exp_if_guard] = STATE(11061),
    [sym_exp_case] = STATE(11061),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11061),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11061),
    [sym__lexp] = STATE(11061),
    [sym_exp_infix] = STATE(11061),
    [sym__exp_infix] = STATE(11061),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1637] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11255),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1638] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(10150),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(10150),
    [sym_exp_cond] = STATE(10150),
    [sym_exp_if_guard] = STATE(10150),
    [sym_exp_case] = STATE(10150),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(10150),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(10150),
    [sym__lexp] = STATE(10150),
    [sym_exp_infix] = STATE(10150),
    [sym__exp_infix] = STATE(10150),
    [sym__exp] = STATE(13482),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1639] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13498),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1640] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4599),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1641] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11164),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1642] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17249),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1643] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21538),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1644] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(22591),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1645] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(10162),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(10162),
    [sym_exp_cond] = STATE(10162),
    [sym_exp_if_guard] = STATE(10162),
    [sym_exp_case] = STATE(10162),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(10162),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(10162),
    [sym__lexp] = STATE(10162),
    [sym_exp_infix] = STATE(10162),
    [sym__exp_infix] = STATE(10162),
    [sym__exp] = STATE(13446),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1646] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11262),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1647] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21128),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1648] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(11742),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(10325),
    [sym_qualified_constructor] = STATE(10464),
    [sym__qcon] = STATE(12711),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(12712),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym_pat_name] = STATE(13646),
    [sym_pat_as] = STATE(13646),
    [sym__pat_constructor] = STATE(12917),
    [sym_pat_record] = STATE(13646),
    [sym_pat_wildcard] = STATE(13646),
    [sym_pat_parens] = STATE(13646),
    [sym_pat_tuple] = STATE(13646),
    [sym_pat_unboxed_tuple] = STATE(13646),
    [sym_pat_unboxed_sum] = STATE(13646),
    [sym_pat_list] = STATE(13646),
    [sym_pat_strict] = STATE(13646),
    [sym_pat_irrefutable] = STATE(13646),
    [sym_pat_type_binder] = STATE(13646),
    [sym__apat] = STATE(13646),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13964),
    [sym_splice] = STATE(12707),
    [sym_quasiquote] = STATE(12707),
    [sym__varid] = ACTIONS(4861),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4869),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4869),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4873),
    [anon_sym_LBRACK] = ACTIONS(4875),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(4877),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(689),
    [sym__lazy] = ACTIONS(691),
  },
  [1649] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13523),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1650] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21111),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1651] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16968),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1652] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(8711),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(8711),
    [sym_exp_cond] = STATE(8711),
    [sym_exp_if_guard] = STATE(8711),
    [sym_exp_case] = STATE(8711),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(8711),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(8711),
    [sym__lexp] = STATE(8711),
    [sym_exp_infix] = STATE(8711),
    [sym__exp_infix] = STATE(8711),
    [sym__exp] = STATE(11272),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1653] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(9675),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(9675),
    [sym_exp_cond] = STATE(9675),
    [sym_exp_if_guard] = STATE(9675),
    [sym_exp_case] = STATE(9675),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(9675),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(9675),
    [sym__lexp] = STATE(9675),
    [sym_exp_infix] = STATE(9675),
    [sym__exp_infix] = STATE(9675),
    [sym__exp] = STATE(15930),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1654] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1655] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16335),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1656] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21783),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1657] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20642),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1658] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16353),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1659] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17127),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1660] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(9391),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(9391),
    [sym_exp_cond] = STATE(9391),
    [sym_exp_if_guard] = STATE(9391),
    [sym_exp_case] = STATE(9391),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(9391),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(9391),
    [sym__lexp] = STATE(9391),
    [sym_exp_infix] = STATE(9391),
    [sym__exp_infix] = STATE(9391),
    [sym__exp] = STATE(15190),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1661] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(21016),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1662] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(16249),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1663] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(10064),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(10064),
    [sym_exp_cond] = STATE(10064),
    [sym_exp_if_guard] = STATE(10064),
    [sym_exp_case] = STATE(10064),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(10064),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(10064),
    [sym__lexp] = STATE(10064),
    [sym_exp_infix] = STATE(10064),
    [sym__exp_infix] = STATE(10064),
    [sym__exp] = STATE(17084),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1664] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(10315),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(10315),
    [sym_exp_cond] = STATE(10315),
    [sym_exp_if_guard] = STATE(10315),
    [sym_exp_case] = STATE(10315),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(10315),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(10315),
    [sym__lexp] = STATE(10315),
    [sym_exp_infix] = STATE(10315),
    [sym__exp_infix] = STATE(10315),
    [sym__exp] = STATE(13703),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1665] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20997),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1666] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10983),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10983),
    [sym_exp_cond] = STATE(10983),
    [sym_exp_if_guard] = STATE(10983),
    [sym_exp_case] = STATE(10983),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10983),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10983),
    [sym__lexp] = STATE(10983),
    [sym_exp_infix] = STATE(10983),
    [sym__exp_infix] = STATE(10983),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4887),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1667] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11053),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11053),
    [sym_exp_cond] = STATE(11053),
    [sym_exp_if_guard] = STATE(11053),
    [sym_exp_case] = STATE(11053),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11053),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11053),
    [sym__lexp] = STATE(11053),
    [sym_exp_infix] = STATE(11053),
    [sym__exp_infix] = STATE(11053),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(4763),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1668] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13535),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1669] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(8407),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(8407),
    [sym_exp_cond] = STATE(8407),
    [sym_exp_if_guard] = STATE(8407),
    [sym_exp_case] = STATE(8407),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(8407),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(8407),
    [sym__lexp] = STATE(8407),
    [sym_exp_infix] = STATE(8407),
    [sym__exp_infix] = STATE(8407),
    [sym__exp] = STATE(20648),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1670] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(10155),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(10155),
    [sym_exp_cond] = STATE(10155),
    [sym_exp_if_guard] = STATE(10155),
    [sym_exp_case] = STATE(10155),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(10155),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(10155),
    [sym__lexp] = STATE(10155),
    [sym_exp_infix] = STATE(10155),
    [sym__exp_infix] = STATE(10155),
    [sym__exp] = STATE(13261),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1671] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(9896),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(9896),
    [sym_exp_cond] = STATE(9896),
    [sym_exp_if_guard] = STATE(9896),
    [sym_exp_case] = STATE(9896),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(9896),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(9896),
    [sym__lexp] = STATE(9896),
    [sym_exp_infix] = STATE(9896),
    [sym__exp_infix] = STATE(9896),
    [sym__exp] = STATE(21271),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1672] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10983),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10983),
    [sym_exp_cond] = STATE(10983),
    [sym_exp_if_guard] = STATE(10983),
    [sym_exp_case] = STATE(10983),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10983),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10983),
    [sym__lexp] = STATE(10983),
    [sym_exp_infix] = STATE(10983),
    [sym__exp_infix] = STATE(10983),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1673] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11066),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11066),
    [sym_exp_cond] = STATE(11066),
    [sym_exp_if_guard] = STATE(11066),
    [sym_exp_case] = STATE(11066),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11066),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11066),
    [sym__lexp] = STATE(11066),
    [sym_exp_infix] = STATE(11066),
    [sym__exp_infix] = STATE(11066),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1674] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10922),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10922),
    [sym_exp_cond] = STATE(10922),
    [sym_exp_if_guard] = STATE(10922),
    [sym_exp_case] = STATE(10922),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10922),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10922),
    [sym__lexp] = STATE(10922),
    [sym_exp_infix] = STATE(10922),
    [sym__exp_infix] = STATE(10922),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1675] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10920),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10920),
    [sym_exp_cond] = STATE(10920),
    [sym_exp_if_guard] = STATE(10920),
    [sym_exp_case] = STATE(10920),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10920),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10920),
    [sym__lexp] = STATE(10920),
    [sym_exp_infix] = STATE(10920),
    [sym__exp_infix] = STATE(10920),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1676] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10997),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10997),
    [sym_exp_cond] = STATE(10997),
    [sym_exp_if_guard] = STATE(10997),
    [sym_exp_case] = STATE(10997),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10997),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10997),
    [sym__lexp] = STATE(10997),
    [sym_exp_infix] = STATE(10997),
    [sym__exp_infix] = STATE(10997),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1677] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11088),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11088),
    [sym_exp_cond] = STATE(11088),
    [sym_exp_if_guard] = STATE(11088),
    [sym_exp_case] = STATE(11088),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11088),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11088),
    [sym__lexp] = STATE(11088),
    [sym_exp_infix] = STATE(11088),
    [sym__exp_infix] = STATE(11088),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1678] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11009),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11009),
    [sym_exp_cond] = STATE(11009),
    [sym_exp_if_guard] = STATE(11009),
    [sym_exp_case] = STATE(11009),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11009),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11009),
    [sym__lexp] = STATE(11009),
    [sym_exp_infix] = STATE(11009),
    [sym__exp_infix] = STATE(11009),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1679] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11022),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11022),
    [sym_exp_cond] = STATE(11022),
    [sym_exp_if_guard] = STATE(11022),
    [sym_exp_case] = STATE(11022),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11022),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11022),
    [sym__lexp] = STATE(11022),
    [sym_exp_infix] = STATE(11022),
    [sym__exp_infix] = STATE(11022),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1680] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11037),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11037),
    [sym_exp_cond] = STATE(11037),
    [sym_exp_if_guard] = STATE(11037),
    [sym_exp_case] = STATE(11037),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11037),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11037),
    [sym__lexp] = STATE(11037),
    [sym_exp_infix] = STATE(11037),
    [sym__exp_infix] = STATE(11037),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1681] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10966),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10966),
    [sym_exp_cond] = STATE(10966),
    [sym_exp_if_guard] = STATE(10966),
    [sym_exp_case] = STATE(10966),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10966),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10966),
    [sym__lexp] = STATE(10966),
    [sym_exp_infix] = STATE(10966),
    [sym__exp_infix] = STATE(10966),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1682] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11045),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11045),
    [sym_exp_cond] = STATE(11045),
    [sym_exp_if_guard] = STATE(11045),
    [sym_exp_case] = STATE(11045),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11045),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11045),
    [sym__lexp] = STATE(11045),
    [sym_exp_infix] = STATE(11045),
    [sym__exp_infix] = STATE(11045),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1683] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11051),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11051),
    [sym_exp_cond] = STATE(11051),
    [sym_exp_if_guard] = STATE(11051),
    [sym_exp_case] = STATE(11051),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11051),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11051),
    [sym__lexp] = STATE(11051),
    [sym_exp_infix] = STATE(11051),
    [sym__exp_infix] = STATE(11051),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1684] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11069),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11069),
    [sym_exp_cond] = STATE(11069),
    [sym_exp_if_guard] = STATE(11069),
    [sym_exp_case] = STATE(11069),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11069),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11069),
    [sym__lexp] = STATE(11069),
    [sym_exp_infix] = STATE(11069),
    [sym__exp_infix] = STATE(11069),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1685] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11097),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11097),
    [sym_exp_cond] = STATE(11097),
    [sym_exp_if_guard] = STATE(11097),
    [sym_exp_case] = STATE(11097),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11097),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11097),
    [sym__lexp] = STATE(11097),
    [sym_exp_infix] = STATE(11097),
    [sym__exp_infix] = STATE(11097),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1686] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11006),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11006),
    [sym_exp_cond] = STATE(11006),
    [sym_exp_if_guard] = STATE(11006),
    [sym_exp_case] = STATE(11006),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11006),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11006),
    [sym__lexp] = STATE(11006),
    [sym_exp_infix] = STATE(11006),
    [sym__exp_infix] = STATE(11006),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1687] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11104),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11104),
    [sym_exp_cond] = STATE(11104),
    [sym_exp_if_guard] = STATE(11104),
    [sym_exp_case] = STATE(11104),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11104),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11104),
    [sym__lexp] = STATE(11104),
    [sym_exp_infix] = STATE(11104),
    [sym__exp_infix] = STATE(11104),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1688] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11133),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11133),
    [sym_exp_cond] = STATE(11133),
    [sym_exp_if_guard] = STATE(11133),
    [sym_exp_case] = STATE(11133),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11133),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11133),
    [sym__lexp] = STATE(11133),
    [sym_exp_infix] = STATE(11133),
    [sym__exp_infix] = STATE(11133),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1689] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10956),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10956),
    [sym_exp_cond] = STATE(10956),
    [sym_exp_if_guard] = STATE(10956),
    [sym_exp_case] = STATE(10956),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10956),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10956),
    [sym__lexp] = STATE(10956),
    [sym_exp_infix] = STATE(10956),
    [sym__exp_infix] = STATE(10956),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1690] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10987),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10987),
    [sym_exp_cond] = STATE(10987),
    [sym_exp_if_guard] = STATE(10987),
    [sym_exp_case] = STATE(10987),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10987),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10987),
    [sym__lexp] = STATE(10987),
    [sym_exp_infix] = STATE(10987),
    [sym__exp_infix] = STATE(10987),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1691] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10951),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10951),
    [sym_exp_cond] = STATE(10951),
    [sym_exp_if_guard] = STATE(10951),
    [sym_exp_case] = STATE(10951),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10951),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10951),
    [sym__lexp] = STATE(10951),
    [sym_exp_infix] = STATE(10951),
    [sym__exp_infix] = STATE(10951),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1692] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10955),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10955),
    [sym_exp_cond] = STATE(10955),
    [sym_exp_if_guard] = STATE(10955),
    [sym_exp_case] = STATE(10955),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10955),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10955),
    [sym__lexp] = STATE(10955),
    [sym_exp_infix] = STATE(10955),
    [sym__exp_infix] = STATE(10955),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1693] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10942),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10942),
    [sym_exp_cond] = STATE(10942),
    [sym_exp_if_guard] = STATE(10942),
    [sym_exp_case] = STATE(10942),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10942),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10942),
    [sym__lexp] = STATE(10942),
    [sym_exp_infix] = STATE(10942),
    [sym__exp_infix] = STATE(10942),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1694] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10939),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10939),
    [sym_exp_cond] = STATE(10939),
    [sym_exp_if_guard] = STATE(10939),
    [sym_exp_case] = STATE(10939),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10939),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10939),
    [sym__lexp] = STATE(10939),
    [sym_exp_infix] = STATE(10939),
    [sym__exp_infix] = STATE(10939),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1695] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10915),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10915),
    [sym_exp_cond] = STATE(10915),
    [sym_exp_if_guard] = STATE(10915),
    [sym_exp_case] = STATE(10915),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10915),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10915),
    [sym__lexp] = STATE(10915),
    [sym_exp_infix] = STATE(10915),
    [sym__exp_infix] = STATE(10915),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1696] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11140),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11140),
    [sym_exp_cond] = STATE(11140),
    [sym_exp_if_guard] = STATE(11140),
    [sym_exp_case] = STATE(11140),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11140),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11140),
    [sym__lexp] = STATE(11140),
    [sym_exp_infix] = STATE(11140),
    [sym__exp_infix] = STATE(11140),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1697] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(10657),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(10657),
    [sym_exp_cond] = STATE(10657),
    [sym_exp_if_guard] = STATE(10657),
    [sym_exp_case] = STATE(10657),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(10657),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(10657),
    [sym__lexp] = STATE(10657),
    [sym_exp_infix] = STATE(10657),
    [sym__exp_infix] = STATE(10657),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1698] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10963),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10963),
    [sym_exp_cond] = STATE(10963),
    [sym_exp_if_guard] = STATE(10963),
    [sym_exp_case] = STATE(10963),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10963),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10963),
    [sym__lexp] = STATE(10963),
    [sym_exp_infix] = STATE(10963),
    [sym__exp_infix] = STATE(10963),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1699] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10919),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10919),
    [sym_exp_cond] = STATE(10919),
    [sym_exp_if_guard] = STATE(10919),
    [sym_exp_case] = STATE(10919),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10919),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10919),
    [sym__lexp] = STATE(10919),
    [sym_exp_infix] = STATE(10919),
    [sym__exp_infix] = STATE(10919),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1700] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11152),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11152),
    [sym_exp_cond] = STATE(11152),
    [sym_exp_if_guard] = STATE(11152),
    [sym_exp_case] = STATE(11152),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11152),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11152),
    [sym__lexp] = STATE(11152),
    [sym_exp_infix] = STATE(11152),
    [sym__exp_infix] = STATE(11152),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1701] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11015),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11015),
    [sym_exp_cond] = STATE(11015),
    [sym_exp_if_guard] = STATE(11015),
    [sym_exp_case] = STATE(11015),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11015),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11015),
    [sym__lexp] = STATE(11015),
    [sym_exp_infix] = STATE(11015),
    [sym__exp_infix] = STATE(11015),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1702] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11094),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11094),
    [sym_exp_cond] = STATE(11094),
    [sym_exp_if_guard] = STATE(11094),
    [sym_exp_case] = STATE(11094),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11094),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11094),
    [sym__lexp] = STATE(11094),
    [sym_exp_infix] = STATE(11094),
    [sym__exp_infix] = STATE(11094),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1703] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11052),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11052),
    [sym_exp_cond] = STATE(11052),
    [sym_exp_if_guard] = STATE(11052),
    [sym_exp_case] = STATE(11052),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11052),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11052),
    [sym__lexp] = STATE(11052),
    [sym_exp_infix] = STATE(11052),
    [sym__exp_infix] = STATE(11052),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1704] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11087),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11087),
    [sym_exp_cond] = STATE(11087),
    [sym_exp_if_guard] = STATE(11087),
    [sym_exp_case] = STATE(11087),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11087),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11087),
    [sym__lexp] = STATE(11087),
    [sym_exp_infix] = STATE(11087),
    [sym__exp_infix] = STATE(11087),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1705] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11046),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11046),
    [sym_exp_cond] = STATE(11046),
    [sym_exp_if_guard] = STATE(11046),
    [sym_exp_case] = STATE(11046),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11046),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11046),
    [sym__lexp] = STATE(11046),
    [sym_exp_infix] = STATE(11046),
    [sym__exp_infix] = STATE(11046),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1706] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10944),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10944),
    [sym_exp_cond] = STATE(10944),
    [sym_exp_if_guard] = STATE(10944),
    [sym_exp_case] = STATE(10944),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10944),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10944),
    [sym__lexp] = STATE(10944),
    [sym_exp_infix] = STATE(10944),
    [sym__exp_infix] = STATE(10944),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1707] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11004),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11004),
    [sym_exp_cond] = STATE(11004),
    [sym_exp_if_guard] = STATE(11004),
    [sym_exp_case] = STATE(11004),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11004),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11004),
    [sym__lexp] = STATE(11004),
    [sym_exp_infix] = STATE(11004),
    [sym__exp_infix] = STATE(11004),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1708] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11000),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11000),
    [sym_exp_cond] = STATE(11000),
    [sym_exp_if_guard] = STATE(11000),
    [sym_exp_case] = STATE(11000),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11000),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11000),
    [sym__lexp] = STATE(11000),
    [sym_exp_infix] = STATE(11000),
    [sym__exp_infix] = STATE(11000),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1709] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10950),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10950),
    [sym_exp_cond] = STATE(10950),
    [sym_exp_if_guard] = STATE(10950),
    [sym_exp_case] = STATE(10950),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10950),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10950),
    [sym__lexp] = STATE(10950),
    [sym_exp_infix] = STATE(10950),
    [sym__exp_infix] = STATE(10950),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1710] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11047),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11047),
    [sym_exp_cond] = STATE(11047),
    [sym_exp_if_guard] = STATE(11047),
    [sym_exp_case] = STATE(11047),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11047),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11047),
    [sym__lexp] = STATE(11047),
    [sym_exp_infix] = STATE(11047),
    [sym__exp_infix] = STATE(11047),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1711] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11082),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11082),
    [sym_exp_cond] = STATE(11082),
    [sym_exp_if_guard] = STATE(11082),
    [sym_exp_case] = STATE(11082),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11082),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11082),
    [sym__lexp] = STATE(11082),
    [sym_exp_infix] = STATE(11082),
    [sym__exp_infix] = STATE(11082),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1712] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10933),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10933),
    [sym_exp_cond] = STATE(10933),
    [sym_exp_if_guard] = STATE(10933),
    [sym_exp_case] = STATE(10933),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10933),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10933),
    [sym__lexp] = STATE(10933),
    [sym_exp_infix] = STATE(10933),
    [sym__exp_infix] = STATE(10933),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1713] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11105),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11105),
    [sym_exp_cond] = STATE(11105),
    [sym_exp_if_guard] = STATE(11105),
    [sym_exp_case] = STATE(11105),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11105),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11105),
    [sym__lexp] = STATE(11105),
    [sym_exp_infix] = STATE(11105),
    [sym__exp_infix] = STATE(11105),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1714] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11074),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11074),
    [sym_exp_cond] = STATE(11074),
    [sym_exp_if_guard] = STATE(11074),
    [sym_exp_case] = STATE(11074),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11074),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11074),
    [sym__lexp] = STATE(11074),
    [sym_exp_infix] = STATE(11074),
    [sym__exp_infix] = STATE(11074),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1715] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11132),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11132),
    [sym_exp_cond] = STATE(11132),
    [sym_exp_if_guard] = STATE(11132),
    [sym_exp_case] = STATE(11132),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11132),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11132),
    [sym__lexp] = STATE(11132),
    [sym_exp_infix] = STATE(11132),
    [sym__exp_infix] = STATE(11132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1716] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10911),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10911),
    [sym_exp_cond] = STATE(10911),
    [sym_exp_if_guard] = STATE(10911),
    [sym_exp_case] = STATE(10911),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10911),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10911),
    [sym__lexp] = STATE(10911),
    [sym_exp_infix] = STATE(10911),
    [sym__exp_infix] = STATE(10911),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1717] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11115),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11115),
    [sym_exp_cond] = STATE(11115),
    [sym_exp_if_guard] = STATE(11115),
    [sym_exp_case] = STATE(11115),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11115),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11115),
    [sym__lexp] = STATE(11115),
    [sym_exp_infix] = STATE(11115),
    [sym__exp_infix] = STATE(11115),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1718] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11086),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11086),
    [sym_exp_cond] = STATE(11086),
    [sym_exp_if_guard] = STATE(11086),
    [sym_exp_case] = STATE(11086),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11086),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11086),
    [sym__lexp] = STATE(11086),
    [sym_exp_infix] = STATE(11086),
    [sym__exp_infix] = STATE(11086),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1719] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11101),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11101),
    [sym_exp_cond] = STATE(11101),
    [sym_exp_if_guard] = STATE(11101),
    [sym_exp_case] = STATE(11101),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11101),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11101),
    [sym__lexp] = STATE(11101),
    [sym_exp_infix] = STATE(11101),
    [sym__exp_infix] = STATE(11101),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1720] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11053),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11053),
    [sym_exp_cond] = STATE(11053),
    [sym_exp_if_guard] = STATE(11053),
    [sym_exp_case] = STATE(11053),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11053),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11053),
    [sym__lexp] = STATE(11053),
    [sym_exp_infix] = STATE(11053),
    [sym__exp_infix] = STATE(11053),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1721] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11061),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11061),
    [sym_exp_cond] = STATE(11061),
    [sym_exp_if_guard] = STATE(11061),
    [sym_exp_case] = STATE(11061),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11061),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11061),
    [sym__lexp] = STATE(11061),
    [sym_exp_infix] = STATE(11061),
    [sym__exp_infix] = STATE(11061),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1722] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10973),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10973),
    [sym_exp_cond] = STATE(10973),
    [sym_exp_if_guard] = STATE(10973),
    [sym_exp_case] = STATE(10973),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10973),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10973),
    [sym__lexp] = STATE(10973),
    [sym_exp_infix] = STATE(10973),
    [sym__exp_infix] = STATE(10973),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1723] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10940),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10940),
    [sym_exp_cond] = STATE(10940),
    [sym_exp_if_guard] = STATE(10940),
    [sym_exp_case] = STATE(10940),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10940),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10940),
    [sym__lexp] = STATE(10940),
    [sym_exp_infix] = STATE(10940),
    [sym__exp_infix] = STATE(10940),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1724] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11060),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11060),
    [sym_exp_cond] = STATE(11060),
    [sym_exp_if_guard] = STATE(11060),
    [sym_exp_case] = STATE(11060),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11060),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11060),
    [sym__lexp] = STATE(11060),
    [sym_exp_infix] = STATE(11060),
    [sym__exp_infix] = STATE(11060),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1725] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10985),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10985),
    [sym_exp_cond] = STATE(10985),
    [sym_exp_if_guard] = STATE(10985),
    [sym_exp_case] = STATE(10985),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10985),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10985),
    [sym__lexp] = STATE(10985),
    [sym_exp_infix] = STATE(10985),
    [sym__exp_infix] = STATE(10985),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1726] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11014),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11014),
    [sym_exp_cond] = STATE(11014),
    [sym_exp_if_guard] = STATE(11014),
    [sym_exp_case] = STATE(11014),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11014),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11014),
    [sym__lexp] = STATE(11014),
    [sym_exp_infix] = STATE(11014),
    [sym__exp_infix] = STATE(11014),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1727] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10982),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10982),
    [sym_exp_cond] = STATE(10982),
    [sym_exp_if_guard] = STATE(10982),
    [sym_exp_case] = STATE(10982),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10982),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10982),
    [sym__lexp] = STATE(10982),
    [sym_exp_infix] = STATE(10982),
    [sym__exp_infix] = STATE(10982),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1728] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11135),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11135),
    [sym_exp_cond] = STATE(11135),
    [sym_exp_if_guard] = STATE(11135),
    [sym_exp_case] = STATE(11135),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11135),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11135),
    [sym__lexp] = STATE(11135),
    [sym_exp_infix] = STATE(11135),
    [sym__exp_infix] = STATE(11135),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1729] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10914),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10914),
    [sym_exp_cond] = STATE(10914),
    [sym_exp_if_guard] = STATE(10914),
    [sym_exp_case] = STATE(10914),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10914),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10914),
    [sym__lexp] = STATE(10914),
    [sym_exp_infix] = STATE(10914),
    [sym__exp_infix] = STATE(10914),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1730] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11039),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11039),
    [sym_exp_cond] = STATE(11039),
    [sym_exp_if_guard] = STATE(11039),
    [sym_exp_case] = STATE(11039),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11039),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11039),
    [sym__lexp] = STATE(11039),
    [sym_exp_infix] = STATE(11039),
    [sym__exp_infix] = STATE(11039),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1731] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11081),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11081),
    [sym_exp_cond] = STATE(11081),
    [sym_exp_if_guard] = STATE(11081),
    [sym_exp_case] = STATE(11081),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11081),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11081),
    [sym__lexp] = STATE(11081),
    [sym_exp_infix] = STATE(11081),
    [sym__exp_infix] = STATE(11081),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1732] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11120),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11120),
    [sym_exp_cond] = STATE(11120),
    [sym_exp_if_guard] = STATE(11120),
    [sym_exp_case] = STATE(11120),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11120),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11120),
    [sym__lexp] = STATE(11120),
    [sym_exp_infix] = STATE(11120),
    [sym__exp_infix] = STATE(11120),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1733] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10976),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10976),
    [sym_exp_cond] = STATE(10976),
    [sym_exp_if_guard] = STATE(10976),
    [sym_exp_case] = STATE(10976),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10976),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10976),
    [sym__lexp] = STATE(10976),
    [sym_exp_infix] = STATE(10976),
    [sym__exp_infix] = STATE(10976),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1734] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10941),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10941),
    [sym_exp_cond] = STATE(10941),
    [sym_exp_if_guard] = STATE(10941),
    [sym_exp_case] = STATE(10941),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10941),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10941),
    [sym__lexp] = STATE(10941),
    [sym_exp_infix] = STATE(10941),
    [sym__exp_infix] = STATE(10941),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1735] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10990),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10990),
    [sym_exp_cond] = STATE(10990),
    [sym_exp_if_guard] = STATE(10990),
    [sym_exp_case] = STATE(10990),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10990),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10990),
    [sym__lexp] = STATE(10990),
    [sym_exp_infix] = STATE(10990),
    [sym__exp_infix] = STATE(10990),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1736] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10913),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10913),
    [sym_exp_cond] = STATE(10913),
    [sym_exp_if_guard] = STATE(10913),
    [sym_exp_case] = STATE(10913),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10913),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10913),
    [sym__lexp] = STATE(10913),
    [sym_exp_infix] = STATE(10913),
    [sym__exp_infix] = STATE(10913),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1737] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11128),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11128),
    [sym_exp_cond] = STATE(11128),
    [sym_exp_if_guard] = STATE(11128),
    [sym_exp_case] = STATE(11128),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11128),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11128),
    [sym__lexp] = STATE(11128),
    [sym_exp_infix] = STATE(11128),
    [sym__exp_infix] = STATE(11128),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1738] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11010),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11010),
    [sym_exp_cond] = STATE(11010),
    [sym_exp_if_guard] = STATE(11010),
    [sym_exp_case] = STATE(11010),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11010),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11010),
    [sym__lexp] = STATE(11010),
    [sym_exp_infix] = STATE(11010),
    [sym__exp_infix] = STATE(11010),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1739] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11016),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11016),
    [sym_exp_cond] = STATE(11016),
    [sym_exp_if_guard] = STATE(11016),
    [sym_exp_case] = STATE(11016),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11016),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11016),
    [sym__lexp] = STATE(11016),
    [sym_exp_infix] = STATE(11016),
    [sym__exp_infix] = STATE(11016),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1740] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11103),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11103),
    [sym_exp_cond] = STATE(11103),
    [sym_exp_if_guard] = STATE(11103),
    [sym_exp_case] = STATE(11103),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11103),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11103),
    [sym__lexp] = STATE(11103),
    [sym_exp_infix] = STATE(11103),
    [sym__exp_infix] = STATE(11103),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1741] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11043),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11043),
    [sym_exp_cond] = STATE(11043),
    [sym_exp_if_guard] = STATE(11043),
    [sym_exp_case] = STATE(11043),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11043),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11043),
    [sym__lexp] = STATE(11043),
    [sym_exp_infix] = STATE(11043),
    [sym__exp_infix] = STATE(11043),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1742] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11025),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11025),
    [sym_exp_cond] = STATE(11025),
    [sym_exp_if_guard] = STATE(11025),
    [sym_exp_case] = STATE(11025),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11025),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11025),
    [sym__lexp] = STATE(11025),
    [sym_exp_infix] = STATE(11025),
    [sym__exp_infix] = STATE(11025),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1743] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11041),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11041),
    [sym_exp_cond] = STATE(11041),
    [sym_exp_if_guard] = STATE(11041),
    [sym_exp_case] = STATE(11041),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11041),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11041),
    [sym__lexp] = STATE(11041),
    [sym_exp_infix] = STATE(11041),
    [sym__exp_infix] = STATE(11041),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1744] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10995),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10995),
    [sym_exp_cond] = STATE(10995),
    [sym_exp_if_guard] = STATE(10995),
    [sym_exp_case] = STATE(10995),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10995),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10995),
    [sym__lexp] = STATE(10995),
    [sym_exp_infix] = STATE(10995),
    [sym__exp_infix] = STATE(10995),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1745] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10948),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10948),
    [sym_exp_cond] = STATE(10948),
    [sym_exp_if_guard] = STATE(10948),
    [sym_exp_case] = STATE(10948),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10948),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10948),
    [sym__lexp] = STATE(10948),
    [sym_exp_infix] = STATE(10948),
    [sym__exp_infix] = STATE(10948),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1746] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10975),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10975),
    [sym_exp_cond] = STATE(10975),
    [sym_exp_if_guard] = STATE(10975),
    [sym_exp_case] = STATE(10975),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10975),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10975),
    [sym__lexp] = STATE(10975),
    [sym_exp_infix] = STATE(10975),
    [sym__exp_infix] = STATE(10975),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1747] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11044),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11044),
    [sym_exp_cond] = STATE(11044),
    [sym_exp_if_guard] = STATE(11044),
    [sym_exp_case] = STATE(11044),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11044),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11044),
    [sym__lexp] = STATE(11044),
    [sym_exp_infix] = STATE(11044),
    [sym__exp_infix] = STATE(11044),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1748] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10938),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10938),
    [sym_exp_cond] = STATE(10938),
    [sym_exp_if_guard] = STATE(10938),
    [sym_exp_case] = STATE(10938),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10938),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10938),
    [sym__lexp] = STATE(10938),
    [sym_exp_infix] = STATE(10938),
    [sym__exp_infix] = STATE(10938),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1749] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10916),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10916),
    [sym_exp_cond] = STATE(10916),
    [sym_exp_if_guard] = STATE(10916),
    [sym_exp_case] = STATE(10916),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10916),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10916),
    [sym__lexp] = STATE(10916),
    [sym_exp_infix] = STATE(10916),
    [sym__exp_infix] = STATE(10916),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1750] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10984),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10984),
    [sym_exp_cond] = STATE(10984),
    [sym_exp_if_guard] = STATE(10984),
    [sym_exp_case] = STATE(10984),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10984),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10984),
    [sym__lexp] = STATE(10984),
    [sym_exp_infix] = STATE(10984),
    [sym__exp_infix] = STATE(10984),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1751] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11008),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11008),
    [sym_exp_cond] = STATE(11008),
    [sym_exp_if_guard] = STATE(11008),
    [sym_exp_case] = STATE(11008),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11008),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11008),
    [sym__lexp] = STATE(11008),
    [sym_exp_infix] = STATE(11008),
    [sym__exp_infix] = STATE(11008),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1752] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11144),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11144),
    [sym_exp_cond] = STATE(11144),
    [sym_exp_if_guard] = STATE(11144),
    [sym_exp_case] = STATE(11144),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11144),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11144),
    [sym__lexp] = STATE(11144),
    [sym_exp_infix] = STATE(11144),
    [sym__exp_infix] = STATE(11144),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1753] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11096),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11096),
    [sym_exp_cond] = STATE(11096),
    [sym_exp_if_guard] = STATE(11096),
    [sym_exp_case] = STATE(11096),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11096),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11096),
    [sym__lexp] = STATE(11096),
    [sym_exp_infix] = STATE(11096),
    [sym__exp_infix] = STATE(11096),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1754] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11063),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11063),
    [sym_exp_cond] = STATE(11063),
    [sym_exp_if_guard] = STATE(11063),
    [sym_exp_case] = STATE(11063),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11063),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11063),
    [sym__lexp] = STATE(11063),
    [sym_exp_infix] = STATE(11063),
    [sym__exp_infix] = STATE(11063),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1755] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10989),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10989),
    [sym_exp_cond] = STATE(10989),
    [sym_exp_if_guard] = STATE(10989),
    [sym_exp_case] = STATE(10989),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10989),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10989),
    [sym__lexp] = STATE(10989),
    [sym_exp_infix] = STATE(10989),
    [sym__exp_infix] = STATE(10989),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1756] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10927),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10927),
    [sym_exp_cond] = STATE(10927),
    [sym_exp_if_guard] = STATE(10927),
    [sym_exp_case] = STATE(10927),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10927),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10927),
    [sym__lexp] = STATE(10927),
    [sym_exp_infix] = STATE(10927),
    [sym__exp_infix] = STATE(10927),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1757] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10965),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10965),
    [sym_exp_cond] = STATE(10965),
    [sym_exp_if_guard] = STATE(10965),
    [sym_exp_case] = STATE(10965),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10965),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10965),
    [sym__lexp] = STATE(10965),
    [sym_exp_infix] = STATE(10965),
    [sym__exp_infix] = STATE(10965),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1758] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11073),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11073),
    [sym_exp_cond] = STATE(11073),
    [sym_exp_if_guard] = STATE(11073),
    [sym_exp_case] = STATE(11073),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11073),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11073),
    [sym__lexp] = STATE(11073),
    [sym_exp_infix] = STATE(11073),
    [sym__exp_infix] = STATE(11073),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1759] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10925),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10925),
    [sym_exp_cond] = STATE(10925),
    [sym_exp_if_guard] = STATE(10925),
    [sym_exp_case] = STATE(10925),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10925),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10925),
    [sym__lexp] = STATE(10925),
    [sym_exp_infix] = STATE(10925),
    [sym__exp_infix] = STATE(10925),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1760] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11089),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11089),
    [sym_exp_cond] = STATE(11089),
    [sym_exp_if_guard] = STATE(11089),
    [sym_exp_case] = STATE(11089),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11089),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11089),
    [sym__lexp] = STATE(11089),
    [sym_exp_infix] = STATE(11089),
    [sym__exp_infix] = STATE(11089),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1761] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11033),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11033),
    [sym_exp_cond] = STATE(11033),
    [sym_exp_if_guard] = STATE(11033),
    [sym_exp_case] = STATE(11033),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11033),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11033),
    [sym__lexp] = STATE(11033),
    [sym_exp_infix] = STATE(11033),
    [sym__exp_infix] = STATE(11033),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1762] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11134),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11134),
    [sym_exp_cond] = STATE(11134),
    [sym_exp_if_guard] = STATE(11134),
    [sym_exp_case] = STATE(11134),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11134),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11134),
    [sym__lexp] = STATE(11134),
    [sym_exp_infix] = STATE(11134),
    [sym__exp_infix] = STATE(11134),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1763] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11106),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11106),
    [sym_exp_cond] = STATE(11106),
    [sym_exp_if_guard] = STATE(11106),
    [sym_exp_case] = STATE(11106),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11106),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11106),
    [sym__lexp] = STATE(11106),
    [sym_exp_infix] = STATE(11106),
    [sym__exp_infix] = STATE(11106),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1764] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(11054),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(11054),
    [sym_exp_cond] = STATE(11054),
    [sym_exp_if_guard] = STATE(11054),
    [sym_exp_case] = STATE(11054),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(11054),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(11054),
    [sym__lexp] = STATE(11054),
    [sym_exp_infix] = STATE(11054),
    [sym__exp_infix] = STATE(11054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1765] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1766] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4891),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1767] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1768] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4895),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1769] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1770] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(17178),
    [sym_class_datafam] = STATE(17178),
    [sym_class_tyfam] = STATE(17178),
    [sym__cdecl] = STATE(17178),
    [sym_inst_tyinst] = STATE(17178),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17178),
    [sym_fixity] = STATE(17178),
    [sym_signature] = STATE(17178),
    [sym__gendecl] = STATE(17178),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(4899),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1771] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1772] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4929),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1773] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4931),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1774] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4933),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1775] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4935),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1776] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4937),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1777] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1778] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1779] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1780] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4945),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1781] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(16562),
    [sym_class_datafam] = STATE(16562),
    [sym_class_tyfam] = STATE(16562),
    [sym__cdecl] = STATE(16562),
    [sym_inst_tyinst] = STATE(16562),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16562),
    [sym_fixity] = STATE(16562),
    [sym_signature] = STATE(16562),
    [sym__gendecl] = STATE(16562),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(4947),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1782] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1783] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(16592),
    [sym_class_datafam] = STATE(16592),
    [sym_class_tyfam] = STATE(16592),
    [sym__cdecl] = STATE(16592),
    [sym_inst_tyinst] = STATE(16592),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16592),
    [sym_fixity] = STATE(16592),
    [sym_signature] = STATE(16592),
    [sym__gendecl] = STATE(16592),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(4953),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1784] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1785] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1786] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1787] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1788] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1789] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1790] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4969),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1791] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4971),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1792] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4973),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1793] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1794] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4977),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1795] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4979),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1796] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1797] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1798] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4985),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1799] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1800] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(21033),
    [sym_class_datafam] = STATE(21033),
    [sym_class_tyfam] = STATE(21033),
    [sym__cdecl] = STATE(21033),
    [sym_inst_tyinst] = STATE(21033),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(21033),
    [sym_fixity] = STATE(21033),
    [sym_signature] = STATE(21033),
    [sym__gendecl] = STATE(21033),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [aux_sym_decl_tyfam_repeat1] = STATE(4578),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(693),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1801] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4989),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1802] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4991),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1803] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4993),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1804] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(16931),
    [sym_class_datafam] = STATE(16931),
    [sym_class_tyfam] = STATE(16931),
    [sym__cdecl] = STATE(16931),
    [sym_inst_tyinst] = STATE(16931),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16931),
    [sym_fixity] = STATE(16931),
    [sym_signature] = STATE(16931),
    [sym__gendecl] = STATE(16931),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(4995),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1805] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(4999),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1806] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1807] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1808] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5005),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1809] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1810] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5009),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1811] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(17262),
    [sym_class_datafam] = STATE(17262),
    [sym_class_tyfam] = STATE(17262),
    [sym__cdecl] = STATE(17262),
    [sym_inst_tyinst] = STATE(17262),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17262),
    [sym_fixity] = STATE(17262),
    [sym_signature] = STATE(17262),
    [sym__gendecl] = STATE(17262),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5011),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1812] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5015),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1813] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(16309),
    [sym_class_datafam] = STATE(16309),
    [sym_class_tyfam] = STATE(16309),
    [sym__cdecl] = STATE(16309),
    [sym_inst_tyinst] = STATE(16309),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16309),
    [sym_fixity] = STATE(16309),
    [sym_signature] = STATE(16309),
    [sym__gendecl] = STATE(16309),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5017),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4915),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(4919),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1814] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5021),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1815] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5023),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1816] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5025),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1817] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1818] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22658),
    [sym_qualified_constructor_operator] = STATE(22658),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22658),
    [sym_qualified_type_operator] = STATE(22658),
    [sym__qualified_type_operator] = STATE(22658),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22872),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19217),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3653),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5029),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3657),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1819] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22563),
    [sym_qualified_constructor_operator] = STATE(22563),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22563),
    [sym_qualified_type_operator] = STATE(22563),
    [sym__qualified_type_operator] = STATE(22563),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22368),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18037),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2503),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1820] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5041),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1821] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21401),
    [sym_qualified_constructor_operator] = STATE(21401),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21401),
    [sym_qualified_type_operator] = STATE(21401),
    [sym__qualified_type_operator] = STATE(21401),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21564),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19593),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3723),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2609),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1822] = {
    [sym_integer] = STATE(4359),
    [sym__literal] = STATE(4359),
    [sym__unboxed_open] = STATE(721),
    [sym_variable] = STATE(4365),
    [sym_qualified_variable] = STATE(4365),
    [sym_constructor] = STATE(4228),
    [sym_qualified_constructor] = STATE(4427),
    [sym__qcon] = STATE(4365),
    [sym_con_unit] = STATE(4359),
    [sym_con_list] = STATE(4359),
    [sym_con_tuple] = STATE(4359),
    [sym_literal] = STATE(4481),
    [sym_exp_parens] = STATE(4481),
    [sym_exp_tuple] = STATE(4481),
    [sym_exp_unboxed_tuple] = STATE(4481),
    [sym_exp_unboxed_sum] = STATE(4481),
    [sym_exp_list] = STATE(4481),
    [sym_exp_arithmetic_sequence] = STATE(4481),
    [sym_exp_list_comprehension] = STATE(4481),
    [sym_exp_section_left] = STATE(4481),
    [sym_exp_section_right] = STATE(4481),
    [sym_exp_th_quoted_name] = STATE(4481),
    [sym_exp_type_application] = STATE(670),
    [sym_exp_lambda] = STATE(11855),
    [sym_exp_let] = STATE(20396),
    [sym_exp_let_in] = STATE(11855),
    [sym_exp_cond] = STATE(11855),
    [sym_exp_if_guard] = STATE(11855),
    [sym_exp_case] = STATE(11855),
    [sym_exp_lambda_case] = STATE(670),
    [sym_exp_lambda_cases] = STATE(670),
    [sym__do_keyword] = STATE(20807),
    [sym_do_module] = STATE(20807),
    [sym_exp_do] = STATE(670),
    [sym_exp_negation] = STATE(11855),
    [sym_exp_record] = STATE(4481),
    [sym_exp_name] = STATE(4481),
    [sym_exp_projection_selector] = STATE(4481),
    [sym__aexp_projection] = STATE(4481),
    [sym_exp_projection] = STATE(4481),
    [sym__aexp] = STATE(670),
    [sym__exp_apply] = STATE(11957),
    [sym__fexp] = STATE(11855),
    [sym__lexp] = STATE(11855),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13902),
    [sym_splice] = STATE(4481),
    [sym_quasiquote] = STATE(4481),
    [sym__varid] = ACTIONS(1976),
    [sym_float] = ACTIONS(1446),
    [sym_char] = ACTIONS(1446),
    [sym_string] = ACTIONS(1446),
    [sym__integer_literal] = ACTIONS(1448),
    [sym__binary_literal] = ACTIONS(1450),
    [sym__octal_literal] = ACTIONS(1450),
    [sym__hex_literal] = ACTIONS(1450),
    [anon_sym_LPAREN_POUND] = ACTIONS(1978),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1978),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(1980),
    [sym_implicit_parid] = ACTIONS(1454),
    [sym__conid] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_mdo] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_u27e6] = ACTIONS(1480),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1484),
  },
  [1823] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21797),
    [sym_qualified_constructor_operator] = STATE(21797),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21797),
    [sym_qualified_type_operator] = STATE(21797),
    [sym__qualified_type_operator] = STATE(21797),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21924),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19615),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4353),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2511),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1824] = {
    [sym_integer] = STATE(4311),
    [sym__literal] = STATE(4311),
    [sym__unboxed_open] = STATE(708),
    [sym_variable] = STATE(4327),
    [sym_qualified_variable] = STATE(4327),
    [sym_constructor] = STATE(4189),
    [sym_qualified_constructor] = STATE(4245),
    [sym__qcon] = STATE(4327),
    [sym_con_unit] = STATE(4311),
    [sym_con_list] = STATE(4311),
    [sym_con_tuple] = STATE(4311),
    [sym_literal] = STATE(4227),
    [sym_exp_parens] = STATE(4227),
    [sym_exp_tuple] = STATE(4227),
    [sym_exp_unboxed_tuple] = STATE(4227),
    [sym_exp_unboxed_sum] = STATE(4227),
    [sym_exp_list] = STATE(4227),
    [sym_exp_arithmetic_sequence] = STATE(4227),
    [sym_exp_list_comprehension] = STATE(4227),
    [sym_exp_section_left] = STATE(4227),
    [sym_exp_section_right] = STATE(4227),
    [sym_exp_th_quoted_name] = STATE(4227),
    [sym_exp_type_application] = STATE(557),
    [sym_exp_lambda] = STATE(11271),
    [sym_exp_let] = STATE(21148),
    [sym_exp_let_in] = STATE(11271),
    [sym_exp_cond] = STATE(11271),
    [sym_exp_if_guard] = STATE(11271),
    [sym_exp_case] = STATE(11271),
    [sym_exp_lambda_case] = STATE(557),
    [sym_exp_lambda_cases] = STATE(557),
    [sym__do_keyword] = STATE(20606),
    [sym_do_module] = STATE(20606),
    [sym_exp_do] = STATE(557),
    [sym_exp_negation] = STATE(11271),
    [sym_exp_record] = STATE(4227),
    [sym_exp_name] = STATE(4227),
    [sym_exp_projection_selector] = STATE(4227),
    [sym__aexp_projection] = STATE(4227),
    [sym_exp_projection] = STATE(4227),
    [sym__aexp] = STATE(557),
    [sym__exp_apply] = STATE(11313),
    [sym__fexp] = STATE(11271),
    [sym__lexp] = STATE(11271),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14085),
    [sym_splice] = STATE(4227),
    [sym_quasiquote] = STATE(4227),
    [sym__varid] = ACTIONS(1918),
    [sym_float] = ACTIONS(1920),
    [sym_char] = ACTIONS(1920),
    [sym_string] = ACTIONS(1920),
    [sym__integer_literal] = ACTIONS(1922),
    [sym__binary_literal] = ACTIONS(1924),
    [sym__octal_literal] = ACTIONS(1924),
    [sym__hex_literal] = ACTIONS(1924),
    [anon_sym_LPAREN_POUND] = ACTIONS(1926),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1926),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [sym_implicit_parid] = ACTIONS(1928),
    [sym__conid] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1944),
    [anon_sym_BSLASH] = ACTIONS(1946),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_mdo] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_u27e6] = ACTIONS(1954),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1958),
  },
  [1825] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22565),
    [sym_qualified_constructor_operator] = STATE(22565),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22565),
    [sym_qualified_type_operator] = STATE(22565),
    [sym__qualified_type_operator] = STATE(22565),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22634),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19953),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5047),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3829),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1826] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22328),
    [sym_qualified_constructor_operator] = STATE(22328),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22328),
    [sym_qualified_type_operator] = STATE(22328),
    [sym__qualified_type_operator] = STATE(22328),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22387),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19893),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3855),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1827] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22529),
    [sym_qualified_constructor_operator] = STATE(22529),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22529),
    [sym_qualified_type_operator] = STATE(22529),
    [sym__qualified_type_operator] = STATE(22529),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22641),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19873),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4033),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5051),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2730),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1828] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21985),
    [sym_qualified_constructor_operator] = STATE(21985),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21985),
    [sym_qualified_type_operator] = STATE(21985),
    [sym__qualified_type_operator] = STATE(21985),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22047),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18900),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(453),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5053),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(455),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1829] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5055),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1830] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22645),
    [sym_qualified_constructor_operator] = STATE(22645),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22645),
    [sym_qualified_type_operator] = STATE(22645),
    [sym__qualified_type_operator] = STATE(22645),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22928),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18543),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3807),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5057),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2894),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1831] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21562),
    [sym_qualified_constructor_operator] = STATE(21562),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21562),
    [sym_qualified_type_operator] = STATE(21562),
    [sym__qualified_type_operator] = STATE(21562),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21583),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19117),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4171),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1832] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23286),
    [sym_qualified_constructor_operator] = STATE(23286),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23286),
    [sym_qualified_type_operator] = STATE(23286),
    [sym__qualified_type_operator] = STATE(23286),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21319),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19337),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4243),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5061),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2971),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1833] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22727),
    [sym_qualified_constructor_operator] = STATE(22727),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22727),
    [sym_qualified_type_operator] = STATE(22727),
    [sym__qualified_type_operator] = STATE(22727),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22521),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17940),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2487),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1834] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22575),
    [sym_qualified_constructor_operator] = STATE(22575),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22575),
    [sym_qualified_type_operator] = STATE(22575),
    [sym__qualified_type_operator] = STATE(22575),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22693),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19899),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3397),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1835] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(17263),
    [sym_class_datafam] = STATE(17263),
    [sym_class_tyfam] = STATE(17263),
    [sym__cdecl] = STATE(17263),
    [sym_inst_tyinst] = STATE(17263),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(17263),
    [sym_fixity] = STATE(17263),
    [sym_signature] = STATE(17263),
    [sym__gendecl] = STATE(17263),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5013),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1836] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5067),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1837] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22069),
    [sym_qualified_constructor_operator] = STATE(22069),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22069),
    [sym_qualified_type_operator] = STATE(22069),
    [sym__qualified_type_operator] = STATE(22069),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22191),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19709),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3385),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5069),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3389),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1838] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22470),
    [sym_qualified_constructor_operator] = STATE(22470),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22470),
    [sym_qualified_type_operator] = STATE(22470),
    [sym__qualified_type_operator] = STATE(22470),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22587),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19856),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1692),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5071),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3375),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1839] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21617),
    [sym_qualified_constructor_operator] = STATE(21617),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21617),
    [sym_qualified_type_operator] = STATE(21617),
    [sym__qualified_type_operator] = STATE(21617),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21705),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20149),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4359),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5073),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4363),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1840] = {
    [sym_integer] = STATE(5466),
    [sym__literal] = STATE(5466),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(5351),
    [sym_qualified_variable] = STATE(5351),
    [sym_constructor] = STATE(4831),
    [sym_qualified_constructor] = STATE(5636),
    [sym__qcon] = STATE(5351),
    [sym_con_unit] = STATE(5466),
    [sym_con_list] = STATE(5466),
    [sym_con_tuple] = STATE(5466),
    [sym_literal] = STATE(6468),
    [sym_exp_parens] = STATE(6468),
    [sym_exp_tuple] = STATE(6468),
    [sym_exp_unboxed_tuple] = STATE(6468),
    [sym_exp_unboxed_sum] = STATE(6468),
    [sym_exp_list] = STATE(6468),
    [sym_exp_arithmetic_sequence] = STATE(6468),
    [sym_exp_list_comprehension] = STATE(6468),
    [sym_exp_section_left] = STATE(6468),
    [sym_exp_section_right] = STATE(6468),
    [sym_exp_th_quoted_name] = STATE(6468),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(13999),
    [sym_exp_let] = STATE(20590),
    [sym_exp_let_in] = STATE(13999),
    [sym_exp_cond] = STATE(13999),
    [sym_exp_if_guard] = STATE(13999),
    [sym_exp_case] = STATE(13999),
    [sym_exp_lambda_case] = STATE(916),
    [sym_exp_lambda_cases] = STATE(916),
    [sym__do_keyword] = STATE(20722),
    [sym_do_module] = STATE(20722),
    [sym_exp_do] = STATE(916),
    [sym_exp_negation] = STATE(13999),
    [sym_exp_record] = STATE(6468),
    [sym_exp_name] = STATE(6468),
    [sym_exp_projection_selector] = STATE(6468),
    [sym__aexp_projection] = STATE(6468),
    [sym_exp_projection] = STATE(6468),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(14084),
    [sym__fexp] = STATE(13999),
    [sym__lexp] = STATE(13999),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13953),
    [sym_splice] = STATE(6468),
    [sym_quasiquote] = STATE(6468),
    [sym__varid] = ACTIONS(3264),
    [sym_float] = ACTIONS(1580),
    [sym_char] = ACTIONS(1580),
    [sym_string] = ACTIONS(1580),
    [sym__integer_literal] = ACTIONS(1582),
    [sym__binary_literal] = ACTIONS(1584),
    [sym__octal_literal] = ACTIONS(1584),
    [sym__hex_literal] = ACTIONS(1584),
    [anon_sym_LPAREN_POUND] = ACTIONS(3266),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3266),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [sym_implicit_parid] = ACTIONS(3268),
    [sym__conid] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3284),
    [anon_sym_BSLASH] = ACTIONS(3286),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_mdo] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_u27e6] = ACTIONS(1600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1604),
  },
  [1841] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22769),
    [sym_qualified_constructor_operator] = STATE(22769),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22769),
    [sym_qualified_type_operator] = STATE(22769),
    [sym__qualified_type_operator] = STATE(22769),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5075),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1842] = {
    [sym_integer] = STATE(5239),
    [sym__literal] = STATE(5239),
    [sym__unboxed_open] = STATE(731),
    [sym_variable] = STATE(4938),
    [sym_qualified_variable] = STATE(4938),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4761),
    [sym__qcon] = STATE(4938),
    [sym_con_unit] = STATE(5239),
    [sym_con_list] = STATE(5239),
    [sym_con_tuple] = STATE(5239),
    [sym_literal] = STATE(5154),
    [sym_exp_parens] = STATE(5154),
    [sym_exp_tuple] = STATE(5154),
    [sym_exp_unboxed_tuple] = STATE(5154),
    [sym_exp_unboxed_sum] = STATE(5154),
    [sym_exp_list] = STATE(5154),
    [sym_exp_arithmetic_sequence] = STATE(5154),
    [sym_exp_list_comprehension] = STATE(5154),
    [sym_exp_section_left] = STATE(5154),
    [sym_exp_section_right] = STATE(5154),
    [sym_exp_th_quoted_name] = STATE(5154),
    [sym_exp_type_application] = STATE(754),
    [sym_exp_lambda] = STATE(12957),
    [sym_exp_let] = STATE(21020),
    [sym_exp_let_in] = STATE(12957),
    [sym_exp_cond] = STATE(12957),
    [sym_exp_if_guard] = STATE(12957),
    [sym_exp_case] = STATE(12957),
    [sym_exp_lambda_case] = STATE(754),
    [sym_exp_lambda_cases] = STATE(754),
    [sym__do_keyword] = STATE(20612),
    [sym_do_module] = STATE(20612),
    [sym_exp_do] = STATE(754),
    [sym_exp_negation] = STATE(12957),
    [sym_exp_record] = STATE(5154),
    [sym_exp_name] = STATE(5154),
    [sym_exp_projection_selector] = STATE(5154),
    [sym__aexp_projection] = STATE(5154),
    [sym_exp_projection] = STATE(5154),
    [sym__aexp] = STATE(754),
    [sym__exp_apply] = STATE(13137),
    [sym__fexp] = STATE(12957),
    [sym__lexp] = STATE(12957),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13979),
    [sym_splice] = STATE(5154),
    [sym_quasiquote] = STATE(5154),
    [sym__varid] = ACTIONS(2200),
    [sym_float] = ACTIONS(2202),
    [sym_char] = ACTIONS(2202),
    [sym_string] = ACTIONS(2202),
    [sym__integer_literal] = ACTIONS(2204),
    [sym__binary_literal] = ACTIONS(2206),
    [sym__octal_literal] = ACTIONS(2206),
    [sym__hex_literal] = ACTIONS(2206),
    [anon_sym_LPAREN_POUND] = ACTIONS(2208),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2208),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [sym_implicit_parid] = ACTIONS(2210),
    [sym__conid] = ACTIONS(4537),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2224),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2226),
    [anon_sym_BSLASH] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_mdo] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_u27e6] = ACTIONS(2236),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2240),
  },
  [1843] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5077),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1844] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23149),
    [sym_qualified_constructor_operator] = STATE(23149),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23149),
    [sym_qualified_type_operator] = STATE(23149),
    [sym__qualified_type_operator] = STATE(23149),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22410),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19389),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4417),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3041),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1845] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22632),
    [sym_qualified_constructor_operator] = STATE(22632),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22632),
    [sym_qualified_type_operator] = STATE(22632),
    [sym__qualified_type_operator] = STATE(22632),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22729),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19921),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3409),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1846] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21304),
    [sym_qualified_constructor_operator] = STATE(21304),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21304),
    [sym_qualified_type_operator] = STATE(21304),
    [sym__qualified_type_operator] = STATE(21304),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21299),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19359),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4195),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4199),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1847] = {
    [sym_integer] = STATE(3801),
    [sym__literal] = STATE(3801),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = STATE(3783),
    [sym_qualified_variable] = STATE(3783),
    [sym_constructor] = STATE(3737),
    [sym_qualified_constructor] = STATE(3746),
    [sym__qcon] = STATE(3783),
    [sym_con_unit] = STATE(3801),
    [sym_con_list] = STATE(3801),
    [sym_con_tuple] = STATE(3801),
    [sym_literal] = STATE(3875),
    [sym_exp_parens] = STATE(3875),
    [sym_exp_tuple] = STATE(3875),
    [sym_exp_unboxed_tuple] = STATE(3875),
    [sym_exp_unboxed_sum] = STATE(3875),
    [sym_exp_list] = STATE(3875),
    [sym_exp_arithmetic_sequence] = STATE(3875),
    [sym_exp_list_comprehension] = STATE(3875),
    [sym_exp_section_left] = STATE(3875),
    [sym_exp_section_right] = STATE(3875),
    [sym_exp_th_quoted_name] = STATE(3875),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_lambda] = STATE(10723),
    [sym_exp_let] = STATE(20836),
    [sym_exp_let_in] = STATE(10723),
    [sym_exp_cond] = STATE(10723),
    [sym_exp_if_guard] = STATE(10723),
    [sym_exp_case] = STATE(10723),
    [sym_exp_lambda_case] = STATE(554),
    [sym_exp_lambda_cases] = STATE(554),
    [sym__do_keyword] = STATE(20578),
    [sym_do_module] = STATE(20578),
    [sym_exp_do] = STATE(554),
    [sym_exp_negation] = STATE(10723),
    [sym_exp_record] = STATE(3875),
    [sym_exp_name] = STATE(3875),
    [sym_exp_projection_selector] = STATE(3875),
    [sym__aexp_projection] = STATE(3875),
    [sym_exp_projection] = STATE(3875),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(10768),
    [sym__fexp] = STATE(10723),
    [sym__lexp] = STATE(10723),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13901),
    [sym_splice] = STATE(3875),
    [sym_quasiquote] = STATE(3875),
    [sym__varid] = ACTIONS(1856),
    [sym_float] = ACTIONS(87),
    [sym_char] = ACTIONS(87),
    [sym_string] = ACTIONS(87),
    [sym__integer_literal] = ACTIONS(89),
    [sym__binary_literal] = ACTIONS(91),
    [sym__octal_literal] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(91),
    [anon_sym_LPAREN_POUND] = ACTIONS(1860),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1860),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [sym_implicit_parid] = ACTIONS(1862),
    [sym__conid] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1879),
    [anon_sym_BSLASH] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_mdo] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_u27e6] = ACTIONS(147),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(151),
  },
  [1848] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22408),
    [sym_qualified_constructor_operator] = STATE(22408),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22408),
    [sym_qualified_type_operator] = STATE(22408),
    [sym__qualified_type_operator] = STATE(22408),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22249),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18139),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(305),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5085),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3989),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1849] = {
    [sym_integer] = STATE(3753),
    [sym__literal] = STATE(3753),
    [sym__unboxed_open] = STATE(716),
    [sym_variable] = STATE(3814),
    [sym_qualified_variable] = STATE(3814),
    [sym_constructor] = STATE(3732),
    [sym_qualified_constructor] = STATE(3756),
    [sym__qcon] = STATE(3814),
    [sym_con_unit] = STATE(3753),
    [sym_con_list] = STATE(3753),
    [sym_con_tuple] = STATE(3753),
    [sym_literal] = STATE(4105),
    [sym_exp_parens] = STATE(4105),
    [sym_exp_tuple] = STATE(4105),
    [sym_exp_unboxed_tuple] = STATE(4105),
    [sym_exp_unboxed_sum] = STATE(4105),
    [sym_exp_list] = STATE(4105),
    [sym_exp_arithmetic_sequence] = STATE(4105),
    [sym_exp_list_comprehension] = STATE(4105),
    [sym_exp_section_left] = STATE(4105),
    [sym_exp_section_right] = STATE(4105),
    [sym_exp_th_quoted_name] = STATE(4105),
    [sym_exp_type_application] = STATE(555),
    [sym_exp_lambda] = STATE(10905),
    [sym_exp_let] = STATE(20455),
    [sym_exp_let_in] = STATE(10905),
    [sym_exp_cond] = STATE(10905),
    [sym_exp_if_guard] = STATE(10905),
    [sym_exp_case] = STATE(10905),
    [sym_exp_lambda_case] = STATE(555),
    [sym_exp_lambda_cases] = STATE(555),
    [sym__do_keyword] = STATE(20796),
    [sym_do_module] = STATE(20796),
    [sym_exp_do] = STATE(555),
    [sym_exp_negation] = STATE(10905),
    [sym_exp_record] = STATE(4105),
    [sym_exp_name] = STATE(4105),
    [sym_exp_projection_selector] = STATE(4105),
    [sym__aexp_projection] = STATE(4105),
    [sym_exp_projection] = STATE(4105),
    [sym__aexp] = STATE(555),
    [sym__exp_apply] = STATE(10796),
    [sym__fexp] = STATE(10905),
    [sym__lexp] = STATE(10905),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14075),
    [sym_splice] = STATE(4105),
    [sym_quasiquote] = STATE(4105),
    [sym__varid] = ACTIONS(1899),
    [sym_float] = ACTIONS(657),
    [sym_char] = ACTIONS(657),
    [sym_string] = ACTIONS(657),
    [sym__integer_literal] = ACTIONS(659),
    [sym__binary_literal] = ACTIONS(661),
    [sym__octal_literal] = ACTIONS(661),
    [sym__hex_literal] = ACTIONS(661),
    [anon_sym_LPAREN_POUND] = ACTIONS(1901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1901),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [sym_implicit_parid] = ACTIONS(95),
    [sym__conid] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(107),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(117),
    [anon_sym_BSLASH] = ACTIONS(119),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_mdo] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(125),
    [anon_sym_u27e6] = ACTIONS(683),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(687),
  },
  [1850] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22064),
    [sym_qualified_constructor_operator] = STATE(22064),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22064),
    [sym_qualified_type_operator] = STATE(22064),
    [sym__qualified_type_operator] = STATE(22064),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22057),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18785),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3006),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1851] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22536),
    [sym_qualified_constructor_operator] = STATE(22536),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22536),
    [sym_qualified_type_operator] = STATE(22536),
    [sym__qualified_type_operator] = STATE(22536),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22691),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19983),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5089),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3791),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1852] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23066),
    [sym_qualified_constructor_operator] = STATE(23066),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23066),
    [sym_qualified_type_operator] = STATE(23066),
    [sym__qualified_type_operator] = STATE(23066),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23301),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18424),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4007),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4011),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1853] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22192),
    [sym_qualified_constructor_operator] = STATE(22192),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22192),
    [sym_qualified_type_operator] = STATE(22192),
    [sym__qualified_type_operator] = STATE(22192),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22443),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19046),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(329),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5093),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3739),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1854] = {
    [sym_integer] = STATE(4887),
    [sym__literal] = STATE(4887),
    [sym__unboxed_open] = STATE(701),
    [sym_variable] = STATE(4709),
    [sym_qualified_variable] = STATE(4709),
    [sym_constructor] = STATE(4694),
    [sym_qualified_constructor] = STATE(4922),
    [sym__qcon] = STATE(4709),
    [sym_con_unit] = STATE(4887),
    [sym_con_list] = STATE(4887),
    [sym_con_tuple] = STATE(4887),
    [sym_literal] = STATE(4844),
    [sym_exp_parens] = STATE(4844),
    [sym_exp_tuple] = STATE(4844),
    [sym_exp_unboxed_tuple] = STATE(4844),
    [sym_exp_unboxed_sum] = STATE(4844),
    [sym_exp_list] = STATE(4844),
    [sym_exp_arithmetic_sequence] = STATE(4844),
    [sym_exp_list_comprehension] = STATE(4844),
    [sym_exp_section_left] = STATE(4844),
    [sym_exp_section_right] = STATE(4844),
    [sym_exp_th_quoted_name] = STATE(4844),
    [sym_exp_type_application] = STATE(762),
    [sym_exp_lambda] = STATE(13241),
    [sym_exp_let] = STATE(20519),
    [sym_exp_let_in] = STATE(13241),
    [sym_exp_cond] = STATE(13241),
    [sym_exp_if_guard] = STATE(13241),
    [sym_exp_case] = STATE(13241),
    [sym_exp_lambda_case] = STATE(762),
    [sym_exp_lambda_cases] = STATE(762),
    [sym__do_keyword] = STATE(20774),
    [sym_do_module] = STATE(20774),
    [sym_exp_do] = STATE(762),
    [sym_exp_negation] = STATE(13241),
    [sym_exp_record] = STATE(4844),
    [sym_exp_name] = STATE(4844),
    [sym_exp_projection_selector] = STATE(4844),
    [sym__aexp_projection] = STATE(4844),
    [sym_exp_projection] = STATE(4844),
    [sym__aexp] = STATE(762),
    [sym__exp_apply] = STATE(13069),
    [sym__fexp] = STATE(13241),
    [sym__lexp] = STATE(13241),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14098),
    [sym_splice] = STATE(4844),
    [sym_quasiquote] = STATE(4844),
    [sym__varid] = ACTIONS(1995),
    [sym_float] = ACTIONS(549),
    [sym_char] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [sym__integer_literal] = ACTIONS(551),
    [sym__binary_literal] = ACTIONS(553),
    [sym__octal_literal] = ACTIONS(553),
    [sym__hex_literal] = ACTIONS(553),
    [anon_sym_LPAREN_POUND] = ACTIONS(1997),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1997),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_implicit_parid] = ACTIONS(557),
    [sym__conid] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_BSLASH] = ACTIONS(577),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_case] = ACTIONS(581),
    [anon_sym_mdo] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_u27e6] = ACTIONS(585),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(591),
  },
  [1855] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21590),
    [sym_qualified_constructor_operator] = STATE(21590),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21590),
    [sym_qualified_type_operator] = STATE(21590),
    [sym__qualified_type_operator] = STATE(21590),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21611),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19404),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(515),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(517),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1856] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21373),
    [sym_qualified_constructor_operator] = STATE(21373),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21373),
    [sym_qualified_type_operator] = STATE(21373),
    [sym__qualified_type_operator] = STATE(21373),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21389),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19425),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1672),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4149),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1857] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22413),
    [sym_qualified_constructor_operator] = STATE(22413),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22413),
    [sym_qualified_type_operator] = STATE(22413),
    [sym__qualified_type_operator] = STATE(22413),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22681),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18615),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(349),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3953),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1858] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22123),
    [sym_qualified_constructor_operator] = STATE(22123),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22123),
    [sym_qualified_type_operator] = STATE(22123),
    [sym__qualified_type_operator] = STATE(22123),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22260),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19727),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3521),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5101),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3525),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1859] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22677),
    [sym_qualified_constructor_operator] = STATE(22677),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22677),
    [sym_qualified_type_operator] = STATE(22677),
    [sym__qualified_type_operator] = STATE(22677),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22664),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19937),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3965),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2995),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1860] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22883),
    [sym_qualified_constructor_operator] = STATE(22883),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22883),
    [sym_qualified_type_operator] = STATE(22883),
    [sym__qualified_type_operator] = STATE(22883),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22685),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17870),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4297),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5105),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4301),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1861] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21676),
    [sym_qualified_constructor_operator] = STATE(21676),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21676),
    [sym_qualified_type_operator] = STATE(21676),
    [sym__qualified_type_operator] = STATE(21676),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21746),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19575),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4259),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2397),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1862] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21366),
    [sym_qualified_constructor_operator] = STATE(21366),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21366),
    [sym_qualified_type_operator] = STATE(21366),
    [sym__qualified_type_operator] = STATE(21366),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21387),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19254),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2698),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1863] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22011),
    [sym_qualified_constructor_operator] = STATE(22011),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22011),
    [sym_qualified_type_operator] = STATE(22011),
    [sym__qualified_type_operator] = STATE(22011),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22149),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19689),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3753),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1864] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23248),
    [sym_qualified_constructor_operator] = STATE(23248),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23248),
    [sym_qualified_type_operator] = STATE(23248),
    [sym__qualified_type_operator] = STATE(23248),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21425),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19447),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4249),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2690),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1865] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22269),
    [sym_qualified_constructor_operator] = STATE(22269),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22269),
    [sym_qualified_type_operator] = STATE(22269),
    [sym__qualified_type_operator] = STATE(22269),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22177),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18762),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(495),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(497),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1866] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22717),
    [sym_qualified_constructor_operator] = STATE(22717),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22717),
    [sym_qualified_type_operator] = STATE(22717),
    [sym__qualified_type_operator] = STATE(22717),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22849),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19965),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3459),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1867] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22945),
    [sym_qualified_constructor_operator] = STATE(22945),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22945),
    [sym_qualified_type_operator] = STATE(22945),
    [sym__qualified_type_operator] = STATE(22945),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22921),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18146),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3711),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1868] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21618),
    [sym_qualified_constructor_operator] = STATE(21618),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21618),
    [sym_qualified_type_operator] = STATE(21618),
    [sym__qualified_type_operator] = STATE(21618),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21639),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19381),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(527),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5121),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(529),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1869] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22038),
    [sym_qualified_constructor_operator] = STATE(22038),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22038),
    [sym_qualified_type_operator] = STATE(22038),
    [sym__qualified_type_operator] = STATE(22038),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22031),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18806),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3729),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1870] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22645),
    [sym_qualified_constructor_operator] = STATE(22645),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22645),
    [sym_qualified_type_operator] = STATE(22645),
    [sym__qualified_type_operator] = STATE(22645),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5057),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1871] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22780),
    [sym_qualified_constructor_operator] = STATE(22780),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22780),
    [sym_qualified_type_operator] = STATE(22780),
    [sym__qualified_type_operator] = STATE(22780),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22913),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17840),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(479),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5125),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(481),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1872] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22082),
    [sym_qualified_constructor_operator] = STATE(22082),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22082),
    [sym_qualified_type_operator] = STATE(22082),
    [sym__qualified_type_operator] = STATE(22082),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22337),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19413),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(381),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3539),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1873] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23087),
    [sym_qualified_constructor_operator] = STATE(23087),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23087),
    [sym_qualified_type_operator] = STATE(23087),
    [sym__qualified_type_operator] = STATE(23087),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21965),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18312),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1874] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22395),
    [sym_qualified_constructor_operator] = STATE(22395),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22395),
    [sym_qualified_type_operator] = STATE(22395),
    [sym__qualified_type_operator] = STATE(22395),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22464),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19923),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3503),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2535),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1875] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21421),
    [sym_qualified_constructor_operator] = STATE(21421),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21421),
    [sym_qualified_type_operator] = STATE(21421),
    [sym__qualified_type_operator] = STATE(21421),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21477),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19465),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1708),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4099),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1876] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21506),
    [sym_qualified_constructor_operator] = STATE(21506),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21506),
    [sym_qualified_type_operator] = STATE(21506),
    [sym__qualified_type_operator] = STATE(21506),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21527),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19148),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4187),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1877] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22154),
    [sym_qualified_constructor_operator] = STATE(22154),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22154),
    [sym_qualified_type_operator] = STATE(22154),
    [sym__qualified_type_operator] = STATE(22154),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22043),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19257),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(365),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5137),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3629),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1878] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22264),
    [sym_qualified_constructor_operator] = STATE(22264),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22264),
    [sym_qualified_type_operator] = STATE(22264),
    [sym__qualified_type_operator] = STATE(22264),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22100),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19218),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(499),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5139),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(501),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1879] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22836),
    [sym_qualified_constructor_operator] = STATE(22836),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22836),
    [sym_qualified_type_operator] = STATE(22836),
    [sym__qualified_type_operator] = STATE(22836),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23027),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19985),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1716),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5141),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3491),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1880] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22059),
    [sym_qualified_constructor_operator] = STATE(22059),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22059),
    [sym_qualified_type_operator] = STATE(22059),
    [sym__qualified_type_operator] = STATE(22059),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21391),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18225),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5143),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(485),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1881] = {
    [sym_integer] = STATE(4753),
    [sym__literal] = STATE(4753),
    [sym__unboxed_open] = STATE(739),
    [sym_variable] = STATE(4918),
    [sym_qualified_variable] = STATE(4918),
    [sym_constructor] = STATE(4599),
    [sym_qualified_constructor] = STATE(5112),
    [sym__qcon] = STATE(4918),
    [sym_con_unit] = STATE(4753),
    [sym_con_list] = STATE(4753),
    [sym_con_tuple] = STATE(4753),
    [sym_literal] = STATE(5238),
    [sym_exp_parens] = STATE(5238),
    [sym_exp_tuple] = STATE(5238),
    [sym_exp_unboxed_tuple] = STATE(5238),
    [sym_exp_unboxed_sum] = STATE(5238),
    [sym_exp_list] = STATE(5238),
    [sym_exp_arithmetic_sequence] = STATE(5238),
    [sym_exp_list_comprehension] = STATE(5238),
    [sym_exp_section_left] = STATE(5238),
    [sym_exp_section_right] = STATE(5238),
    [sym_exp_th_quoted_name] = STATE(5238),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(13047),
    [sym_exp_let] = STATE(21207),
    [sym_exp_let_in] = STATE(13047),
    [sym_exp_cond] = STATE(13047),
    [sym_exp_if_guard] = STATE(13047),
    [sym_exp_case] = STATE(13047),
    [sym_exp_lambda_case] = STATE(763),
    [sym_exp_lambda_cases] = STATE(763),
    [sym__do_keyword] = STATE(20490),
    [sym_do_module] = STATE(20490),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(13047),
    [sym_exp_record] = STATE(5238),
    [sym_exp_name] = STATE(5238),
    [sym_exp_projection_selector] = STATE(5238),
    [sym__aexp_projection] = STATE(5238),
    [sym_exp_projection] = STATE(5238),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(13102),
    [sym__fexp] = STATE(13047),
    [sym__lexp] = STATE(13047),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14023),
    [sym_splice] = STATE(5238),
    [sym_quasiquote] = STATE(5238),
    [sym__varid] = ACTIONS(2340),
    [sym_float] = ACTIONS(2342),
    [sym_char] = ACTIONS(2342),
    [sym_string] = ACTIONS(2342),
    [sym__integer_literal] = ACTIONS(2344),
    [sym__binary_literal] = ACTIONS(2346),
    [sym__octal_literal] = ACTIONS(2346),
    [sym__hex_literal] = ACTIONS(2346),
    [anon_sym_LPAREN_POUND] = ACTIONS(2348),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2348),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(4581),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [sym_implicit_parid] = ACTIONS(2350),
    [sym__conid] = ACTIONS(4583),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2365),
    [anon_sym_BSLASH] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2371),
    [anon_sym_mdo] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_u27e6] = ACTIONS(2375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2379),
  },
  [1882] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21557),
    [sym_qualified_constructor_operator] = STATE(21557),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21557),
    [sym_qualified_type_operator] = STATE(21557),
    [sym__qualified_type_operator] = STATE(21557),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21321),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18507),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3055),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1883] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21394),
    [sym_qualified_constructor_operator] = STATE(21394),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21394),
    [sym_qualified_type_operator] = STATE(21394),
    [sym__qualified_type_operator] = STATE(21394),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21415),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19231),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4367),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5147),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4371),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1884] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22794),
    [sym_qualified_constructor_operator] = STATE(22794),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22794),
    [sym_qualified_type_operator] = STATE(22794),
    [sym__qualified_type_operator] = STATE(22794),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23146),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19833),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(543),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(545),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1885] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21395),
    [sym_qualified_constructor_operator] = STATE(21395),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21395),
    [sym_qualified_type_operator] = STATE(21395),
    [sym__qualified_type_operator] = STATE(21395),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22364),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19563),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3034),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1886] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22987),
    [sym_qualified_constructor_operator] = STATE(22987),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22987),
    [sym_qualified_type_operator] = STATE(22987),
    [sym__qualified_type_operator] = STATE(22987),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23211),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19803),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(503),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5153),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(505),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1887] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22010),
    [sym_qualified_constructor_operator] = STATE(22010),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22010),
    [sym_qualified_type_operator] = STATE(22010),
    [sym__qualified_type_operator] = STATE(22010),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22003),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18826),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5155),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2943),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1888] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22522),
    [sym_qualified_constructor_operator] = STATE(22522),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22522),
    [sym_qualified_type_operator] = STATE(22522),
    [sym__qualified_type_operator] = STATE(22522),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22812),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18122),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5157),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(447),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1889] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21646),
    [sym_qualified_constructor_operator] = STATE(21646),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21646),
    [sym_qualified_type_operator] = STATE(21646),
    [sym__qualified_type_operator] = STATE(21646),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21667),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19324),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(531),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5159),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(533),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1890] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23126),
    [sym_qualified_constructor_operator] = STATE(23126),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23126),
    [sym_qualified_type_operator] = STATE(23126),
    [sym__qualified_type_operator] = STATE(23126),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23254),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20010),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3905),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5161),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2625),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1891] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23374),
    [sym_qualified_constructor_operator] = STATE(23374),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23374),
    [sym_qualified_type_operator] = STATE(23374),
    [sym__qualified_type_operator] = STATE(23374),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23155),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18305),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3973),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2975),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1892] = {
    [sym_integer] = STATE(5457),
    [sym__literal] = STATE(5457),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(5460),
    [sym_qualified_variable] = STATE(5460),
    [sym_constructor] = STATE(5155),
    [sym_qualified_constructor] = STATE(5446),
    [sym__qcon] = STATE(5460),
    [sym_con_unit] = STATE(5457),
    [sym_con_list] = STATE(5457),
    [sym_con_tuple] = STATE(5457),
    [sym_literal] = STATE(5788),
    [sym_exp_parens] = STATE(5788),
    [sym_exp_tuple] = STATE(5788),
    [sym_exp_unboxed_tuple] = STATE(5788),
    [sym_exp_unboxed_sum] = STATE(5788),
    [sym_exp_list] = STATE(5788),
    [sym_exp_arithmetic_sequence] = STATE(5788),
    [sym_exp_list_comprehension] = STATE(5788),
    [sym_exp_section_left] = STATE(5788),
    [sym_exp_section_right] = STATE(5788),
    [sym_exp_th_quoted_name] = STATE(5788),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(13303),
    [sym_exp_let] = STATE(20792),
    [sym_exp_let_in] = STATE(13303),
    [sym_exp_cond] = STATE(13303),
    [sym_exp_if_guard] = STATE(13303),
    [sym_exp_case] = STATE(13303),
    [sym_exp_lambda_case] = STATE(828),
    [sym_exp_lambda_cases] = STATE(828),
    [sym__do_keyword] = STATE(20681),
    [sym_do_module] = STATE(20681),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(13303),
    [sym_exp_record] = STATE(5788),
    [sym_exp_name] = STATE(5788),
    [sym_exp_projection_selector] = STATE(5788),
    [sym__aexp_projection] = STATE(5788),
    [sym_exp_projection] = STATE(5788),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(13301),
    [sym__fexp] = STATE(13303),
    [sym__lexp] = STATE(13303),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13948),
    [sym_splice] = STATE(5788),
    [sym_quasiquote] = STATE(5788),
    [sym__varid] = ACTIONS(2845),
    [sym_float] = ACTIONS(2847),
    [sym_char] = ACTIONS(2847),
    [sym_string] = ACTIONS(2847),
    [sym__integer_literal] = ACTIONS(2849),
    [sym__binary_literal] = ACTIONS(2851),
    [sym__octal_literal] = ACTIONS(2851),
    [sym__hex_literal] = ACTIONS(2851),
    [anon_sym_LPAREN_POUND] = ACTIONS(2853),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2853),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [sym_implicit_parid] = ACTIONS(2855),
    [sym__conid] = ACTIONS(4607),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2871),
    [anon_sym_BSLASH] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_mdo] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2885),
  },
  [1893] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21323),
    [sym_qualified_constructor_operator] = STATE(21323),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21323),
    [sym_qualified_type_operator] = STATE(21323),
    [sym__qualified_type_operator] = STATE(21323),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21332),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19304),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5165),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4279),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1894] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23199),
    [sym_qualified_constructor_operator] = STATE(23199),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23199),
    [sym_qualified_type_operator] = STATE(23199),
    [sym__qualified_type_operator] = STATE(23199),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23099),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20036),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3555),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3559),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1895] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21629),
    [sym_qualified_constructor_operator] = STATE(21629),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21629),
    [sym_qualified_type_operator] = STATE(21629),
    [sym__qualified_type_operator] = STATE(21629),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22106),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19769),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4163),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3022),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1896] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23335),
    [sym_qualified_constructor_operator] = STATE(23335),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23335),
    [sym_qualified_type_operator] = STATE(23335),
    [sym__qualified_type_operator] = STATE(23335),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23298),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20060),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(337),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5171),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3611),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1897] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23336),
    [sym_qualified_constructor_operator] = STATE(23336),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23336),
    [sym_qualified_type_operator] = STATE(23336),
    [sym__qualified_type_operator] = STATE(23336),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1898] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21982),
    [sym_qualified_constructor_operator] = STATE(21982),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21982),
    [sym_qualified_type_operator] = STATE(21982),
    [sym__qualified_type_operator] = STATE(21982),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21975),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18842),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3805),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1899] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23378),
    [sym_qualified_constructor_operator] = STATE(23378),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23378),
    [sym_qualified_type_operator] = STATE(23378),
    [sym__qualified_type_operator] = STATE(23378),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23339),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19653),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(511),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(513),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1900] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21719),
    [sym_qualified_constructor_operator] = STATE(21719),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21719),
    [sym_qualified_type_operator] = STATE(21719),
    [sym__qualified_type_operator] = STATE(21719),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21579),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19501),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4329),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1901] = {
    [sym_integer] = STATE(5590),
    [sym__literal] = STATE(5590),
    [sym__unboxed_open] = STATE(717),
    [sym_variable] = STATE(5817),
    [sym_qualified_variable] = STATE(5817),
    [sym_constructor] = STATE(4738),
    [sym_qualified_constructor] = STATE(5513),
    [sym__qcon] = STATE(5817),
    [sym_con_unit] = STATE(5590),
    [sym_con_list] = STATE(5590),
    [sym_con_tuple] = STATE(5590),
    [sym_literal] = STATE(5824),
    [sym_exp_parens] = STATE(5824),
    [sym_exp_tuple] = STATE(5824),
    [sym_exp_unboxed_tuple] = STATE(5824),
    [sym_exp_unboxed_sum] = STATE(5824),
    [sym_exp_list] = STATE(5824),
    [sym_exp_arithmetic_sequence] = STATE(5824),
    [sym_exp_list_comprehension] = STATE(5824),
    [sym_exp_section_left] = STATE(5824),
    [sym_exp_section_right] = STATE(5824),
    [sym_exp_th_quoted_name] = STATE(5824),
    [sym_exp_type_application] = STATE(844),
    [sym_exp_lambda] = STATE(13436),
    [sym_exp_let] = STATE(21273),
    [sym_exp_let_in] = STATE(13436),
    [sym_exp_cond] = STATE(13436),
    [sym_exp_if_guard] = STATE(13436),
    [sym_exp_case] = STATE(13436),
    [sym_exp_lambda_case] = STATE(844),
    [sym_exp_lambda_cases] = STATE(844),
    [sym__do_keyword] = STATE(20588),
    [sym_do_module] = STATE(20588),
    [sym_exp_do] = STATE(844),
    [sym_exp_negation] = STATE(13436),
    [sym_exp_record] = STATE(5824),
    [sym_exp_name] = STATE(5824),
    [sym_exp_projection_selector] = STATE(5824),
    [sym__aexp_projection] = STATE(5824),
    [sym_exp_projection] = STATE(5824),
    [sym__aexp] = STATE(844),
    [sym__exp_apply] = STATE(13424),
    [sym__fexp] = STATE(13436),
    [sym__lexp] = STATE(13436),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14008),
    [sym_splice] = STATE(5824),
    [sym_quasiquote] = STATE(5824),
    [sym__varid] = ACTIONS(2639),
    [sym_float] = ACTIONS(2641),
    [sym_char] = ACTIONS(2641),
    [sym_string] = ACTIONS(2641),
    [sym__integer_literal] = ACTIONS(2643),
    [sym__binary_literal] = ACTIONS(2645),
    [sym__octal_literal] = ACTIONS(2645),
    [sym__hex_literal] = ACTIONS(2645),
    [anon_sym_LPAREN_POUND] = ACTIONS(2647),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2647),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [sym_implicit_parid] = ACTIONS(2649),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2664),
    [anon_sym_BSLASH] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_mdo] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_u27e6] = ACTIONS(2674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2678),
  },
  [1902] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22517),
    [sym_qualified_constructor_operator] = STATE(22517),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22517),
    [sym_qualified_type_operator] = STATE(22517),
    [sym__qualified_type_operator] = STATE(22517),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21472),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19960),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(369),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3359),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1903] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21972),
    [sym_qualified_constructor_operator] = STATE(21972),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21972),
    [sym_qualified_type_operator] = STATE(21972),
    [sym__qualified_type_operator] = STATE(21972),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22080),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19668),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3901),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1904] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21478),
    [sym_qualified_constructor_operator] = STATE(21478),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21478),
    [sym_qualified_type_operator] = STATE(21478),
    [sym__qualified_type_operator] = STATE(21478),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21499),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19169),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5185),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2983),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1905] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21466),
    [sym_qualified_constructor_operator] = STATE(21466),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21466),
    [sym_qualified_type_operator] = STATE(21466),
    [sym__qualified_type_operator] = STATE(21466),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21542),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19491),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4211),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2746),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1906] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21630),
    [sym_qualified_constructor_operator] = STATE(21630),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21630),
    [sym_qualified_type_operator] = STATE(21630),
    [sym__qualified_type_operator] = STATE(21630),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23429),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18925),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(377),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5189),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4343),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1907] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21568),
    [sym_qualified_constructor_operator] = STATE(21568),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21568),
    [sym_qualified_type_operator] = STATE(21568),
    [sym__qualified_type_operator] = STATE(21568),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21626),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18067),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(487),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(489),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1908] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23408),
    [sym_qualified_constructor_operator] = STATE(23408),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23408),
    [sym_qualified_type_operator] = STATE(23408),
    [sym__qualified_type_operator] = STATE(23408),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23390),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19623),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(491),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5193),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(493),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1909] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21867),
    [sym_qualified_constructor_operator] = STATE(21867),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21867),
    [sym_qualified_type_operator] = STATE(21867),
    [sym__qualified_type_operator] = STATE(21867),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1910] = {
    [sym_integer] = STATE(5695),
    [sym__literal] = STATE(5695),
    [sym__unboxed_open] = STATE(719),
    [sym_variable] = STATE(5403),
    [sym_qualified_variable] = STATE(5403),
    [sym_constructor] = STATE(4898),
    [sym_qualified_constructor] = STATE(5850),
    [sym__qcon] = STATE(5403),
    [sym_con_unit] = STATE(5695),
    [sym_con_list] = STATE(5695),
    [sym_con_tuple] = STATE(5695),
    [sym_literal] = STATE(5382),
    [sym_exp_parens] = STATE(5382),
    [sym_exp_tuple] = STATE(5382),
    [sym_exp_unboxed_tuple] = STATE(5382),
    [sym_exp_unboxed_sum] = STATE(5382),
    [sym_exp_list] = STATE(5382),
    [sym_exp_arithmetic_sequence] = STATE(5382),
    [sym_exp_list_comprehension] = STATE(5382),
    [sym_exp_section_left] = STATE(5382),
    [sym_exp_section_right] = STATE(5382),
    [sym_exp_th_quoted_name] = STATE(5382),
    [sym_exp_type_application] = STATE(852),
    [sym_exp_lambda] = STATE(13530),
    [sym_exp_let] = STATE(20368),
    [sym_exp_let_in] = STATE(13530),
    [sym_exp_cond] = STATE(13530),
    [sym_exp_if_guard] = STATE(13530),
    [sym_exp_case] = STATE(13530),
    [sym_exp_lambda_case] = STATE(852),
    [sym_exp_lambda_cases] = STATE(852),
    [sym__do_keyword] = STATE(20515),
    [sym_do_module] = STATE(20515),
    [sym_exp_do] = STATE(852),
    [sym_exp_negation] = STATE(13530),
    [sym_exp_record] = STATE(5382),
    [sym_exp_name] = STATE(5382),
    [sym_exp_projection_selector] = STATE(5382),
    [sym__aexp_projection] = STATE(5382),
    [sym_exp_projection] = STATE(5382),
    [sym__aexp] = STATE(852),
    [sym__exp_apply] = STATE(13410),
    [sym__fexp] = STATE(13530),
    [sym__lexp] = STATE(13530),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14127),
    [sym_splice] = STATE(5382),
    [sym_quasiquote] = STATE(5382),
    [sym__varid] = ACTIONS(2896),
    [sym_float] = ACTIONS(2898),
    [sym_char] = ACTIONS(2898),
    [sym_string] = ACTIONS(2898),
    [sym__integer_literal] = ACTIONS(2900),
    [sym__binary_literal] = ACTIONS(2902),
    [sym__octal_literal] = ACTIONS(2902),
    [sym__hex_literal] = ACTIONS(2902),
    [anon_sym_LPAREN_POUND] = ACTIONS(2904),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2904),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_implicit_parid] = ACTIONS(2906),
    [sym__conid] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2921),
    [anon_sym_BSLASH] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_mdo] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_u27e6] = ACTIONS(2931),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2935),
  },
  [1911] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23248),
    [sym_qualified_constructor_operator] = STATE(23248),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23248),
    [sym_qualified_type_operator] = STATE(23248),
    [sym__qualified_type_operator] = STATE(23248),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1912] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21450),
    [sym_qualified_constructor_operator] = STATE(21450),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21450),
    [sym_qualified_type_operator] = STATE(21450),
    [sym__qualified_type_operator] = STATE(21450),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21471),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19197),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5197),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2556),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1913] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23427),
    [sym_qualified_constructor_operator] = STATE(23427),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23427),
    [sym_qualified_type_operator] = STATE(23427),
    [sym__qualified_type_operator] = STATE(23427),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23413),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20078),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3331),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5199),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1914] = {
    [sym_integer] = STATE(4764),
    [sym__literal] = STATE(4764),
    [sym__unboxed_open] = STATE(732),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4637),
    [sym_qualified_constructor] = STATE(4885),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4764),
    [sym_con_list] = STATE(4764),
    [sym_con_tuple] = STATE(4764),
    [sym_literal] = STATE(5060),
    [sym_exp_parens] = STATE(5060),
    [sym_exp_tuple] = STATE(5060),
    [sym_exp_unboxed_tuple] = STATE(5060),
    [sym_exp_unboxed_sum] = STATE(5060),
    [sym_exp_list] = STATE(5060),
    [sym_exp_arithmetic_sequence] = STATE(5060),
    [sym_exp_list_comprehension] = STATE(5060),
    [sym_exp_section_left] = STATE(5060),
    [sym_exp_section_right] = STATE(5060),
    [sym_exp_th_quoted_name] = STATE(5060),
    [sym_exp_type_application] = STATE(756),
    [sym_exp_lambda] = STATE(13257),
    [sym_exp_let] = STATE(20327),
    [sym_exp_let_in] = STATE(13257),
    [sym_exp_cond] = STATE(13257),
    [sym_exp_if_guard] = STATE(13257),
    [sym_exp_case] = STATE(13257),
    [sym_exp_lambda_case] = STATE(756),
    [sym_exp_lambda_cases] = STATE(756),
    [sym__do_keyword] = STATE(20526),
    [sym_do_module] = STATE(20526),
    [sym_exp_do] = STATE(756),
    [sym_exp_negation] = STATE(13257),
    [sym_exp_record] = STATE(5060),
    [sym_exp_name] = STATE(5060),
    [sym_exp_projection_selector] = STATE(5060),
    [sym__aexp_projection] = STATE(5060),
    [sym_exp_projection] = STATE(5060),
    [sym__aexp] = STATE(756),
    [sym__exp_apply] = STATE(13144),
    [sym__fexp] = STATE(13257),
    [sym__lexp] = STATE(13257),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14081),
    [sym_splice] = STATE(5060),
    [sym_quasiquote] = STATE(5060),
    [sym__varid] = ACTIONS(2283),
    [sym_float] = ACTIONS(2285),
    [sym_char] = ACTIONS(2285),
    [sym_string] = ACTIONS(2285),
    [sym__integer_literal] = ACTIONS(2287),
    [sym__binary_literal] = ACTIONS(2289),
    [sym__octal_literal] = ACTIONS(2289),
    [sym__hex_literal] = ACTIONS(2289),
    [anon_sym_LPAREN_POUND] = ACTIONS(2291),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2291),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(4425),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [sym_implicit_parid] = ACTIONS(2293),
    [sym__conid] = ACTIONS(4427),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2309),
    [anon_sym_BSLASH] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_mdo] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_u27e6] = ACTIONS(2319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2323),
  },
  [1915] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23336),
    [sym_qualified_constructor_operator] = STATE(23336),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23336),
    [sym_qualified_type_operator] = STATE(23336),
    [sym__qualified_type_operator] = STATE(23336),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22777),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18624),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2479),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1916] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22534),
    [sym_qualified_constructor_operator] = STATE(22534),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22534),
    [sym_qualified_type_operator] = STATE(22534),
    [sym__qualified_type_operator] = STATE(22534),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22424),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18781),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(297),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5201),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3497),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1917] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21625),
    [sym_qualified_constructor_operator] = STATE(21625),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21625),
    [sym_qualified_type_operator] = STATE(21625),
    [sym__qualified_type_operator] = STATE(21625),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21686),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19554),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5203),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4003),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1918] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22062),
    [sym_qualified_constructor_operator] = STATE(22062),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22062),
    [sym_qualified_type_operator] = STATE(22062),
    [sym__qualified_type_operator] = STATE(22062),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22136),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19773),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(321),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5205),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3889),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1919] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22385),
    [sym_qualified_constructor_operator] = STATE(22385),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22385),
    [sym_qualified_type_operator] = STATE(22385),
    [sym__qualified_type_operator] = STATE(22385),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22475),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19818),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5207),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3353),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1920] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21534),
    [sym_qualified_constructor_operator] = STATE(21534),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21534),
    [sym_qualified_type_operator] = STATE(21534),
    [sym__qualified_type_operator] = STATE(21534),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21555),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19135),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5209),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2411),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1921] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21814),
    [sym_qualified_constructor_operator] = STATE(21814),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21814),
    [sym_qualified_type_operator] = STATE(21814),
    [sym__qualified_type_operator] = STATE(21814),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21807),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18911),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5211),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3875),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1922] = {
    [sym_integer] = STATE(6019),
    [sym__literal] = STATE(6019),
    [sym__unboxed_open] = STATE(728),
    [sym_variable] = STATE(5941),
    [sym_qualified_variable] = STATE(5941),
    [sym_constructor] = STATE(5459),
    [sym_qualified_constructor] = STATE(6190),
    [sym__qcon] = STATE(5941),
    [sym_con_unit] = STATE(6019),
    [sym_con_list] = STATE(6019),
    [sym_con_tuple] = STATE(6019),
    [sym_literal] = STATE(6059),
    [sym_exp_parens] = STATE(6059),
    [sym_exp_tuple] = STATE(6059),
    [sym_exp_unboxed_tuple] = STATE(6059),
    [sym_exp_unboxed_sum] = STATE(6059),
    [sym_exp_list] = STATE(6059),
    [sym_exp_arithmetic_sequence] = STATE(6059),
    [sym_exp_list_comprehension] = STATE(6059),
    [sym_exp_section_left] = STATE(6059),
    [sym_exp_section_right] = STATE(6059),
    [sym_exp_th_quoted_name] = STATE(6059),
    [sym_exp_type_application] = STATE(910),
    [sym_exp_lambda] = STATE(13702),
    [sym_exp_let] = STATE(21062),
    [sym_exp_let_in] = STATE(13702),
    [sym_exp_cond] = STATE(13702),
    [sym_exp_if_guard] = STATE(13702),
    [sym_exp_case] = STATE(13702),
    [sym_exp_lambda_case] = STATE(910),
    [sym_exp_lambda_cases] = STATE(910),
    [sym__do_keyword] = STATE(20584),
    [sym_do_module] = STATE(20584),
    [sym_exp_do] = STATE(910),
    [sym_exp_negation] = STATE(13702),
    [sym_exp_record] = STATE(6059),
    [sym_exp_name] = STATE(6059),
    [sym_exp_projection_selector] = STATE(6059),
    [sym__aexp_projection] = STATE(6059),
    [sym_exp_projection] = STATE(6059),
    [sym__aexp] = STATE(910),
    [sym__exp_apply] = STATE(13821),
    [sym__fexp] = STATE(13702),
    [sym__lexp] = STATE(13702),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14055),
    [sym_splice] = STATE(6059),
    [sym_quasiquote] = STATE(6059),
    [sym__varid] = ACTIONS(3158),
    [sym_float] = ACTIONS(3160),
    [sym_char] = ACTIONS(3160),
    [sym_string] = ACTIONS(3160),
    [sym__integer_literal] = ACTIONS(3162),
    [sym__binary_literal] = ACTIONS(3164),
    [sym__octal_literal] = ACTIONS(3164),
    [sym__hex_literal] = ACTIONS(3164),
    [anon_sym_LPAREN_POUND] = ACTIONS(3166),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3166),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [sym_implicit_parid] = ACTIONS(3168),
    [sym__conid] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3183),
    [anon_sym_BSLASH] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_mdo] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_u27e6] = ACTIONS(3193),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3197),
  },
  [1923] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22340),
    [sym_qualified_constructor_operator] = STATE(22340),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22340),
    [sym_qualified_type_operator] = STATE(22340),
    [sym__qualified_type_operator] = STATE(22340),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22439),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19799),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5213),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2564),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1924] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21674),
    [sym_qualified_constructor_operator] = STATE(21674),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21674),
    [sym_qualified_type_operator] = STATE(21674),
    [sym__qualified_type_operator] = STATE(21674),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21695),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19034),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5215),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4073),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1925] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21954),
    [sym_qualified_constructor_operator] = STATE(21954),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21954),
    [sym_qualified_type_operator] = STATE(21954),
    [sym__qualified_type_operator] = STATE(21954),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21947),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18861),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3813),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3817),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1926] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21528),
    [sym_qualified_constructor_operator] = STATE(21528),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21528),
    [sym_qualified_type_operator] = STATE(21528),
    [sym__qualified_type_operator] = STATE(21528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21585),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19511),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5219),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4063),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1927] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23412),
    [sym_qualified_constructor_operator] = STATE(23412),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23412),
    [sym_qualified_type_operator] = STATE(23412),
    [sym__qualified_type_operator] = STATE(23412),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21806),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20094),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3341),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5221),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2843),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1928] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21910),
    [sym_qualified_constructor_operator] = STATE(21910),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21910),
    [sym_qualified_type_operator] = STATE(21910),
    [sym__qualified_type_operator] = STATE(21910),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21955),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19650),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4307),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5223),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2706),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1929] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22707),
    [sym_qualified_constructor_operator] = STATE(22707),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22707),
    [sym_qualified_type_operator] = STATE(22707),
    [sym__qualified_type_operator] = STATE(22707),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22765),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20012),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3475),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2441),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1930] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21338),
    [sym_qualified_constructor_operator] = STATE(21338),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21338),
    [sym_qualified_type_operator] = STATE(21338),
    [sym__qualified_type_operator] = STATE(21338),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21359),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19278),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2429),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1931] = {
    [sym_integer] = STATE(5244),
    [sym__literal] = STATE(5244),
    [sym__unboxed_open] = STATE(707),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4588),
    [sym_qualified_constructor] = STATE(4869),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(5244),
    [sym_con_list] = STATE(5244),
    [sym_con_tuple] = STATE(5244),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(773),
    [sym_exp_lambda] = STATE(13313),
    [sym_exp_let] = STATE(20897),
    [sym_exp_let_in] = STATE(13313),
    [sym_exp_cond] = STATE(13313),
    [sym_exp_if_guard] = STATE(13313),
    [sym_exp_case] = STATE(13313),
    [sym_exp_lambda_case] = STATE(773),
    [sym_exp_lambda_cases] = STATE(773),
    [sym__do_keyword] = STATE(20653),
    [sym_do_module] = STATE(20653),
    [sym_exp_do] = STATE(773),
    [sym_exp_negation] = STATE(13313),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(773),
    [sym__exp_apply] = STATE(13459),
    [sym__fexp] = STATE(13313),
    [sym__lexp] = STATE(13313),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13924),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2443),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2445),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2445),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(2449),
    [sym_implicit_parid] = ACTIONS(2447),
    [sym__conid] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2461),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2463),
    [anon_sym_BSLASH] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_mdo] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_u27e6] = ACTIONS(71),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(75),
  },
  [1932] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23206),
    [sym_qualified_constructor_operator] = STATE(23206),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23206),
    [sym_qualified_type_operator] = STATE(23206),
    [sym__qualified_type_operator] = STATE(23206),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23012),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19612),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(449),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(451),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1933] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22180),
    [sym_qualified_constructor_operator] = STATE(22180),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22180),
    [sym_qualified_type_operator] = STATE(22180),
    [sym__qualified_type_operator] = STATE(22180),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22310),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19745),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3415),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5231),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3419),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1934] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5233),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1935] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(16691),
    [sym_class_datafam] = STATE(16691),
    [sym_class_tyfam] = STATE(16691),
    [sym__cdecl] = STATE(16691),
    [sym_inst_tyinst] = STATE(16691),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16691),
    [sym_fixity] = STATE(16691),
    [sym_signature] = STATE(16691),
    [sym__gendecl] = STATE(16691),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4949),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1936] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21570),
    [sym_qualified_constructor_operator] = STATE(21570),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21570),
    [sym_qualified_type_operator] = STATE(21570),
    [sym__qualified_type_operator] = STATE(21570),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21515),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19534),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4019),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1937] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22707),
    [sym_qualified_constructor_operator] = STATE(22707),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22707),
    [sym_qualified_type_operator] = STATE(22707),
    [sym__qualified_type_operator] = STATE(22707),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1938] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23387),
    [sym_qualified_constructor_operator] = STATE(23387),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23387),
    [sym_qualified_type_operator] = STATE(23387),
    [sym__qualified_type_operator] = STATE(23387),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23409),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20119),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(373),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5237),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3669),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1939] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21926),
    [sym_qualified_constructor_operator] = STATE(21926),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21926),
    [sym_qualified_type_operator] = STATE(21926),
    [sym__qualified_type_operator] = STATE(21926),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21919),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19056),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(519),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5239),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(521),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1940] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21702),
    [sym_qualified_constructor_operator] = STATE(21702),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21702),
    [sym_qualified_type_operator] = STATE(21702),
    [sym__qualified_type_operator] = STATE(21702),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21808),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19008),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3947),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1941] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21649),
    [sym_qualified_constructor_operator] = STATE(21649),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21649),
    [sym_qualified_type_operator] = STATE(21649),
    [sym__qualified_type_operator] = STATE(21649),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21724),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18186),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(471),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5243),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(473),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1942] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22009),
    [sym_qualified_constructor_operator] = STATE(22009),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22009),
    [sym_qualified_type_operator] = STATE(22009),
    [sym__qualified_type_operator] = STATE(22009),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21888),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18372),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(431),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5245),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1943] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5247),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1944] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21422),
    [sym_qualified_constructor_operator] = STATE(21422),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21422),
    [sym_qualified_type_operator] = STATE(21422),
    [sym__qualified_type_operator] = STATE(21422),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21443),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19211),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5249),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4233),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1945] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21898),
    [sym_qualified_constructor_operator] = STATE(21898),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21898),
    [sym_qualified_type_operator] = STATE(21898),
    [sym__qualified_type_operator] = STATE(21898),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21891),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19080),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(523),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5251),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(525),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1946] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22125),
    [sym_qualified_constructor_operator] = STATE(22125),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22125),
    [sym_qualified_type_operator] = STATE(22125),
    [sym__qualified_type_operator] = STATE(22125),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21915),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18253),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(345),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3619),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1947] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21541),
    [sym_qualified_constructor_operator] = STATE(21541),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21541),
    [sym_qualified_type_operator] = STATE(21541),
    [sym__qualified_type_operator] = STATE(21541),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21427),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19533),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4377),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5255),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4381),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1948] = {
    [sym_integer] = STATE(4726),
    [sym__literal] = STATE(4726),
    [sym__unboxed_open] = STATE(706),
    [sym_variable] = STATE(4969),
    [sym_qualified_variable] = STATE(4969),
    [sym_constructor] = STATE(4705),
    [sym_qualified_constructor] = STATE(5141),
    [sym__qcon] = STATE(4969),
    [sym_con_unit] = STATE(4726),
    [sym_con_list] = STATE(4726),
    [sym_con_tuple] = STATE(4726),
    [sym_literal] = STATE(5016),
    [sym_exp_parens] = STATE(5016),
    [sym_exp_tuple] = STATE(5016),
    [sym_exp_unboxed_tuple] = STATE(5016),
    [sym_exp_unboxed_sum] = STATE(5016),
    [sym_exp_list] = STATE(5016),
    [sym_exp_arithmetic_sequence] = STATE(5016),
    [sym_exp_list_comprehension] = STATE(5016),
    [sym_exp_section_left] = STATE(5016),
    [sym_exp_section_right] = STATE(5016),
    [sym_exp_th_quoted_name] = STATE(5016),
    [sym_exp_type_application] = STATE(757),
    [sym_exp_lambda] = STATE(12868),
    [sym_exp_let] = STATE(21232),
    [sym_exp_let_in] = STATE(12868),
    [sym_exp_cond] = STATE(12868),
    [sym_exp_if_guard] = STATE(12868),
    [sym_exp_case] = STATE(12868),
    [sym_exp_lambda_case] = STATE(757),
    [sym_exp_lambda_cases] = STATE(757),
    [sym__do_keyword] = STATE(20470),
    [sym_do_module] = STATE(20470),
    [sym_exp_do] = STATE(757),
    [sym_exp_negation] = STATE(12868),
    [sym_exp_record] = STATE(5016),
    [sym_exp_name] = STATE(5016),
    [sym_exp_projection_selector] = STATE(5016),
    [sym__aexp_projection] = STATE(5016),
    [sym_exp_projection] = STATE(5016),
    [sym__aexp] = STATE(757),
    [sym__exp_apply] = STATE(12986),
    [sym__fexp] = STATE(12868),
    [sym__lexp] = STATE(12868),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13942),
    [sym_splice] = STATE(5016),
    [sym_quasiquote] = STATE(5016),
    [sym__varid] = ACTIONS(2242),
    [sym_float] = ACTIONS(2244),
    [sym_char] = ACTIONS(2244),
    [sym_string] = ACTIONS(2244),
    [sym__integer_literal] = ACTIONS(2246),
    [sym__binary_literal] = ACTIONS(2248),
    [sym__octal_literal] = ACTIONS(2248),
    [sym__hex_literal] = ACTIONS(2248),
    [anon_sym_LPAREN_POUND] = ACTIONS(2250),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [sym_implicit_parid] = ACTIONS(2252),
    [sym__conid] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2265),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2267),
    [anon_sym_BSLASH] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_mdo] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_u27e6] = ACTIONS(2277),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2281),
  },
  [1949] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22243),
    [sym_qualified_constructor_operator] = STATE(22243),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22243),
    [sym_qualified_type_operator] = STATE(22243),
    [sym__qualified_type_operator] = STATE(22243),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22349),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19764),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5257),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3323),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1950] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21734),
    [sym_qualified_constructor_operator] = STATE(21734),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21734),
    [sym_qualified_type_operator] = STATE(21734),
    [sym__qualified_type_operator] = STATE(21734),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21791),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19683),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3993),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5259),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3997),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1951] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21790),
    [sym_qualified_constructor_operator] = STATE(21790),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21790),
    [sym_qualified_type_operator] = STATE(21790),
    [sym__qualified_type_operator] = STATE(21790),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21513),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18500),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(535),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5261),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(537),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1952] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23324),
    [sym_qualified_constructor_operator] = STATE(23324),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23324),
    [sym_qualified_type_operator] = STATE(23324),
    [sym__qualified_type_operator] = STATE(23324),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23375),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20138),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5263),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3685),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1953] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22395),
    [sym_qualified_constructor_operator] = STATE(22395),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22395),
    [sym_qualified_type_operator] = STATE(22395),
    [sym__qualified_type_operator] = STATE(22395),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1954] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23263),
    [sym_qualified_constructor_operator] = STATE(23263),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23263),
    [sym_qualified_type_operator] = STATE(23263),
    [sym__qualified_type_operator] = STATE(23263),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23318),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20167),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1828),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5265),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3705),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1955] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21786),
    [sym_qualified_constructor_operator] = STATE(21786),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21786),
    [sym_qualified_type_operator] = STATE(21786),
    [sym__qualified_type_operator] = STATE(21786),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21779),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18945),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3769),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5267),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2548),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1956] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23149),
    [sym_qualified_constructor_operator] = STATE(23149),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23149),
    [sym_qualified_type_operator] = STATE(23149),
    [sym__qualified_type_operator] = STATE(23149),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1957] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23198),
    [sym_qualified_constructor_operator] = STATE(23198),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23198),
    [sym_qualified_type_operator] = STATE(23198),
    [sym__qualified_type_operator] = STATE(23198),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23244),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20180),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5269),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2967),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1958] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22306),
    [sym_qualified_constructor_operator] = STATE(22306),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22306),
    [sym_qualified_type_operator] = STATE(22306),
    [sym__qualified_type_operator] = STATE(22306),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22557),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18730),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1792),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4223),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1959] = {
    [sym_integer] = STATE(4140),
    [sym__literal] = STATE(4140),
    [sym__unboxed_open] = STATE(722),
    [sym_variable] = STATE(4142),
    [sym_qualified_variable] = STATE(4142),
    [sym_constructor] = STATE(4116),
    [sym_qualified_constructor] = STATE(4164),
    [sym__qcon] = STATE(4142),
    [sym_con_unit] = STATE(4140),
    [sym_con_list] = STATE(4140),
    [sym_con_tuple] = STATE(4140),
    [sym_literal] = STATE(4355),
    [sym_exp_parens] = STATE(4355),
    [sym_exp_tuple] = STATE(4355),
    [sym_exp_unboxed_tuple] = STATE(4355),
    [sym_exp_unboxed_sum] = STATE(4355),
    [sym_exp_list] = STATE(4355),
    [sym_exp_arithmetic_sequence] = STATE(4355),
    [sym_exp_list_comprehension] = STATE(4355),
    [sym_exp_section_left] = STATE(4355),
    [sym_exp_section_right] = STATE(4355),
    [sym_exp_th_quoted_name] = STATE(4355),
    [sym_exp_type_application] = STATE(659),
    [sym_exp_lambda] = STATE(12079),
    [sym_exp_let] = STATE(20237),
    [sym_exp_let_in] = STATE(12079),
    [sym_exp_cond] = STATE(12079),
    [sym_exp_if_guard] = STATE(12079),
    [sym_exp_case] = STATE(12079),
    [sym_exp_lambda_case] = STATE(659),
    [sym_exp_lambda_cases] = STATE(659),
    [sym__do_keyword] = STATE(20833),
    [sym_do_module] = STATE(20833),
    [sym_exp_do] = STATE(659),
    [sym_exp_negation] = STATE(12079),
    [sym_exp_record] = STATE(4355),
    [sym_exp_name] = STATE(4355),
    [sym_exp_projection_selector] = STATE(4355),
    [sym__aexp_projection] = STATE(4355),
    [sym_exp_projection] = STATE(4355),
    [sym__aexp] = STATE(659),
    [sym__exp_apply] = STATE(11953),
    [sym__fexp] = STATE(12079),
    [sym__lexp] = STATE(12079),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13985),
    [sym_splice] = STATE(4355),
    [sym_quasiquote] = STATE(4355),
    [sym__varid] = ACTIONS(1610),
    [sym_float] = ACTIONS(241),
    [sym_char] = ACTIONS(241),
    [sym_string] = ACTIONS(241),
    [sym__integer_literal] = ACTIONS(243),
    [sym__binary_literal] = ACTIONS(245),
    [sym__octal_literal] = ACTIONS(245),
    [sym__hex_literal] = ACTIONS(245),
    [anon_sym_LPAREN_POUND] = ACTIONS(1612),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1612),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [sym_implicit_parid] = ACTIONS(249),
    [sym__conid] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(271),
    [anon_sym_BSLASH] = ACTIONS(273),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_mdo] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_u27e6] = ACTIONS(281),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(291),
  },
  [1960] = {
    [sym_integer] = STATE(4789),
    [sym__literal] = STATE(4789),
    [sym__unboxed_open] = STATE(705),
    [sym_variable] = STATE(4820),
    [sym_qualified_variable] = STATE(4820),
    [sym_constructor] = STATE(4649),
    [sym_qualified_constructor] = STATE(4902),
    [sym__qcon] = STATE(4820),
    [sym_con_unit] = STATE(4789),
    [sym_con_list] = STATE(4789),
    [sym_con_tuple] = STATE(4789),
    [sym_literal] = STATE(5284),
    [sym_exp_parens] = STATE(5284),
    [sym_exp_tuple] = STATE(5284),
    [sym_exp_unboxed_tuple] = STATE(5284),
    [sym_exp_unboxed_sum] = STATE(5284),
    [sym_exp_list] = STATE(5284),
    [sym_exp_arithmetic_sequence] = STATE(5284),
    [sym_exp_list_comprehension] = STATE(5284),
    [sym_exp_section_left] = STATE(5284),
    [sym_exp_section_right] = STATE(5284),
    [sym_exp_th_quoted_name] = STATE(5284),
    [sym_exp_type_application] = STATE(807),
    [sym_exp_lambda] = STATE(13415),
    [sym_exp_let] = STATE(20787),
    [sym_exp_let_in] = STATE(13415),
    [sym_exp_cond] = STATE(13415),
    [sym_exp_if_guard] = STATE(13415),
    [sym_exp_case] = STATE(13415),
    [sym_exp_lambda_case] = STATE(807),
    [sym_exp_lambda_cases] = STATE(807),
    [sym__do_keyword] = STATE(20501),
    [sym_do_module] = STATE(20501),
    [sym_exp_do] = STATE(807),
    [sym_exp_negation] = STATE(13415),
    [sym_exp_record] = STATE(5284),
    [sym_exp_name] = STATE(5284),
    [sym_exp_projection_selector] = STATE(5284),
    [sym__aexp_projection] = STATE(5284),
    [sym_exp_projection] = STATE(5284),
    [sym__aexp] = STATE(807),
    [sym__exp_apply] = STATE(13332),
    [sym__fexp] = STATE(13415),
    [sym__lexp] = STATE(13415),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14074),
    [sym_splice] = STATE(5284),
    [sym_quasiquote] = STATE(5284),
    [sym__varid] = ACTIONS(2566),
    [sym_float] = ACTIONS(167),
    [sym_char] = ACTIONS(167),
    [sym_string] = ACTIONS(167),
    [sym__integer_literal] = ACTIONS(169),
    [sym__binary_literal] = ACTIONS(171),
    [sym__octal_literal] = ACTIONS(171),
    [sym__hex_literal] = ACTIONS(171),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4423),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_u27e6] = ACTIONS(225),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(231),
  },
  [1961] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23086),
    [sym_qualified_constructor_operator] = STATE(23086),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23086),
    [sym_qualified_type_operator] = STATE(23086),
    [sym__qualified_type_operator] = STATE(23086),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23188),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20152),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1776),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5273),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3759),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1962] = {
    [sym_integer] = STATE(5615),
    [sym__literal] = STATE(5615),
    [sym__unboxed_open] = STATE(726),
    [sym_variable] = STATE(5644),
    [sym_qualified_variable] = STATE(5644),
    [sym_constructor] = STATE(5071),
    [sym_qualified_constructor] = STATE(5533),
    [sym__qcon] = STATE(5644),
    [sym_con_unit] = STATE(5615),
    [sym_con_list] = STATE(5615),
    [sym_con_tuple] = STATE(5615),
    [sym_literal] = STATE(5468),
    [sym_exp_parens] = STATE(5468),
    [sym_exp_tuple] = STATE(5468),
    [sym_exp_unboxed_tuple] = STATE(5468),
    [sym_exp_unboxed_sum] = STATE(5468),
    [sym_exp_list] = STATE(5468),
    [sym_exp_arithmetic_sequence] = STATE(5468),
    [sym_exp_list_comprehension] = STATE(5468),
    [sym_exp_section_left] = STATE(5468),
    [sym_exp_section_right] = STATE(5468),
    [sym_exp_th_quoted_name] = STATE(5468),
    [sym_exp_type_application] = STATE(817),
    [sym_exp_lambda] = STATE(13516),
    [sym_exp_let] = STATE(20649),
    [sym_exp_let_in] = STATE(13516),
    [sym_exp_cond] = STATE(13516),
    [sym_exp_if_guard] = STATE(13516),
    [sym_exp_case] = STATE(13516),
    [sym_exp_lambda_case] = STATE(817),
    [sym_exp_lambda_cases] = STATE(817),
    [sym__do_keyword] = STATE(20699),
    [sym_do_module] = STATE(20699),
    [sym_exp_do] = STATE(817),
    [sym_exp_negation] = STATE(13516),
    [sym_exp_record] = STATE(5468),
    [sym_exp_name] = STATE(5468),
    [sym_exp_projection_selector] = STATE(5468),
    [sym__aexp_projection] = STATE(5468),
    [sym_exp_projection] = STATE(5468),
    [sym__aexp] = STATE(817),
    [sym__exp_apply] = STATE(13463),
    [sym__fexp] = STATE(13516),
    [sym__lexp] = STATE(13516),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13921),
    [sym_splice] = STATE(5468),
    [sym_quasiquote] = STATE(5468),
    [sym__varid] = ACTIONS(2708),
    [sym_float] = ACTIONS(1385),
    [sym_char] = ACTIONS(1385),
    [sym_string] = ACTIONS(1385),
    [sym__integer_literal] = ACTIONS(1387),
    [sym__binary_literal] = ACTIONS(1389),
    [sym__octal_literal] = ACTIONS(1389),
    [sym__hex_literal] = ACTIONS(1389),
    [anon_sym_LPAREN_POUND] = ACTIONS(2710),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2710),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(1393),
    [sym__conid] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_mdo] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_u27e6] = ACTIONS(1422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1426),
  },
  [1963] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21803),
    [sym_qualified_constructor_operator] = STATE(21803),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21803),
    [sym_qualified_type_operator] = STATE(21803),
    [sym__qualified_type_operator] = STATE(21803),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21900),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19713),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3959),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3963),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1964] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21730),
    [sym_qualified_constructor_operator] = STATE(21730),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21730),
    [sym_qualified_type_operator] = STATE(21730),
    [sym__qualified_type_operator] = STATE(21730),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21723),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18980),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3797),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5277),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2955),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1965] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21870),
    [sym_qualified_constructor_operator] = STATE(21870),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21870),
    [sym_qualified_type_operator] = STATE(21870),
    [sym__qualified_type_operator] = STATE(21870),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21863),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19099),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(539),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(541),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1966] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(16932),
    [sym_class_datafam] = STATE(16932),
    [sym_class_tyfam] = STATE(16932),
    [sym__cdecl] = STATE(16932),
    [sym_inst_tyinst] = STATE(16932),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16932),
    [sym_fixity] = STATE(16932),
    [sym_signature] = STATE(16932),
    [sym__gendecl] = STATE(16932),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4997),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1967] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23286),
    [sym_qualified_constructor_operator] = STATE(23286),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23286),
    [sym_qualified_type_operator] = STATE(23286),
    [sym__qualified_type_operator] = STATE(23286),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5061),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1968] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21907),
    [sym_qualified_constructor_operator] = STATE(21907),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21907),
    [sym_qualified_type_operator] = STATE(21907),
    [sym__qualified_type_operator] = STATE(21907),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21971),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19743),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(313),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5281),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3925),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1969] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22964),
    [sym_qualified_constructor_operator] = STATE(22964),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22964),
    [sym_qualified_type_operator] = STATE(22964),
    [sym__qualified_type_operator] = STATE(22964),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23083),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20124),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3435),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2637),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1970] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21867),
    [sym_qualified_constructor_operator] = STATE(21867),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21867),
    [sym_qualified_type_operator] = STATE(21867),
    [sym__qualified_type_operator] = STATE(21867),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22220),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19599),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2049),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1971] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22884),
    [sym_qualified_constructor_operator] = STATE(22884),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22884),
    [sym_qualified_type_operator] = STATE(22884),
    [sym__qualified_type_operator] = STATE(22884),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22734),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18662),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(357),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5285),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3691),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1972] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23048),
    [sym_qualified_constructor_operator] = STATE(23048),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23048),
    [sym_qualified_type_operator] = STATE(23048),
    [sym__qualified_type_operator] = STATE(23048),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22858),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17948),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1973] = {
    [sym_integer] = STATE(5765),
    [sym__literal] = STATE(5765),
    [sym__unboxed_open] = STATE(711),
    [sym_variable] = STATE(5353),
    [sym_qualified_variable] = STATE(5353),
    [sym_constructor] = STATE(4874),
    [sym_qualified_constructor] = STATE(5819),
    [sym__qcon] = STATE(5353),
    [sym_con_unit] = STATE(5765),
    [sym_con_list] = STATE(5765),
    [sym_con_tuple] = STATE(5765),
    [sym_literal] = STATE(5266),
    [sym_exp_parens] = STATE(5266),
    [sym_exp_tuple] = STATE(5266),
    [sym_exp_unboxed_tuple] = STATE(5266),
    [sym_exp_unboxed_sum] = STATE(5266),
    [sym_exp_list] = STATE(5266),
    [sym_exp_arithmetic_sequence] = STATE(5266),
    [sym_exp_list_comprehension] = STATE(5266),
    [sym_exp_section_left] = STATE(5266),
    [sym_exp_section_right] = STATE(5266),
    [sym_exp_th_quoted_name] = STATE(5266),
    [sym_exp_type_application] = STATE(823),
    [sym_exp_lambda] = STATE(13529),
    [sym_exp_let] = STATE(20564),
    [sym_exp_let_in] = STATE(13529),
    [sym_exp_cond] = STATE(13529),
    [sym_exp_if_guard] = STATE(13529),
    [sym_exp_case] = STATE(13529),
    [sym_exp_lambda_case] = STATE(823),
    [sym_exp_lambda_cases] = STATE(823),
    [sym__do_keyword] = STATE(20548),
    [sym_do_module] = STATE(20548),
    [sym_exp_do] = STATE(823),
    [sym_exp_negation] = STATE(13529),
    [sym_exp_record] = STATE(5266),
    [sym_exp_name] = STATE(5266),
    [sym_exp_projection_selector] = STATE(5266),
    [sym__aexp_projection] = STATE(5266),
    [sym_exp_projection] = STATE(5266),
    [sym__aexp] = STATE(823),
    [sym__exp_apply] = STATE(13539),
    [sym__fexp] = STATE(13529),
    [sym__lexp] = STATE(13529),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13980),
    [sym_splice] = STATE(5266),
    [sym_quasiquote] = STATE(5266),
    [sym__varid] = ACTIONS(2750),
    [sym_float] = ACTIONS(2752),
    [sym_char] = ACTIONS(2752),
    [sym_string] = ACTIONS(2752),
    [sym__integer_literal] = ACTIONS(2754),
    [sym__binary_literal] = ACTIONS(2756),
    [sym__octal_literal] = ACTIONS(2756),
    [sym__hex_literal] = ACTIONS(2756),
    [anon_sym_LPAREN_POUND] = ACTIONS(2758),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2758),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [sym_implicit_parid] = ACTIONS(2760),
    [sym__conid] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2776),
    [anon_sym_BSLASH] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_case] = ACTIONS(2782),
    [anon_sym_mdo] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_u27e6] = ACTIONS(2786),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2790),
  },
  [1974] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21844),
    [sym_qualified_constructor_operator] = STATE(21844),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21844),
    [sym_qualified_type_operator] = STATE(21844),
    [sym__qualified_type_operator] = STATE(21844),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21981),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19633),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2738),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1975] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21347),
    [sym_qualified_constructor_operator] = STATE(21347),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21347),
    [sym_qualified_type_operator] = STATE(21347),
    [sym__qualified_type_operator] = STATE(21347),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21762),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18403),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5291),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1976] = {
    [sym_integer] = STATE(4878),
    [sym__literal] = STATE(4878),
    [sym__unboxed_open] = STATE(742),
    [sym_variable] = STATE(5156),
    [sym_qualified_variable] = STATE(5156),
    [sym_constructor] = STATE(4602),
    [sym_qualified_constructor] = STATE(4779),
    [sym__qcon] = STATE(5156),
    [sym_con_unit] = STATE(4878),
    [sym_con_list] = STATE(4878),
    [sym_con_tuple] = STATE(4878),
    [sym_literal] = STATE(6090),
    [sym_exp_parens] = STATE(6090),
    [sym_exp_tuple] = STATE(6090),
    [sym_exp_unboxed_tuple] = STATE(6090),
    [sym_exp_unboxed_sum] = STATE(6090),
    [sym_exp_list] = STATE(6090),
    [sym_exp_arithmetic_sequence] = STATE(6090),
    [sym_exp_list_comprehension] = STATE(6090),
    [sym_exp_section_left] = STATE(6090),
    [sym_exp_section_right] = STATE(6090),
    [sym_exp_th_quoted_name] = STATE(6090),
    [sym_exp_type_application] = STATE(900),
    [sym_exp_lambda] = STATE(13696),
    [sym_exp_let] = STATE(20723),
    [sym_exp_let_in] = STATE(13696),
    [sym_exp_cond] = STATE(13696),
    [sym_exp_if_guard] = STATE(13696),
    [sym_exp_case] = STATE(13696),
    [sym_exp_lambda_case] = STATE(900),
    [sym_exp_lambda_cases] = STATE(900),
    [sym__do_keyword] = STATE(20687),
    [sym_do_module] = STATE(20687),
    [sym_exp_do] = STATE(900),
    [sym_exp_negation] = STATE(13696),
    [sym_exp_record] = STATE(6090),
    [sym_exp_name] = STATE(6090),
    [sym_exp_projection_selector] = STATE(6090),
    [sym__aexp_projection] = STATE(6090),
    [sym_exp_projection] = STATE(6090),
    [sym__aexp] = STATE(900),
    [sym__exp_apply] = STATE(13606),
    [sym__fexp] = STATE(13696),
    [sym__lexp] = STATE(13696),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14058),
    [sym_splice] = STATE(6090),
    [sym_quasiquote] = STATE(6090),
    [sym__varid] = ACTIONS(3143),
    [sym_float] = ACTIONS(1095),
    [sym_char] = ACTIONS(1095),
    [sym_string] = ACTIONS(1095),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__binary_literal] = ACTIONS(1099),
    [sym__octal_literal] = ACTIONS(1099),
    [sym__hex_literal] = ACTIONS(1099),
    [anon_sym_LPAREN_POUND] = ACTIONS(3145),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(175),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [sym_implicit_parid] = ACTIONS(175),
    [sym__conid] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_mdo] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_u27e6] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1121),
  },
  [1977] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22695),
    [sym_qualified_constructor_operator] = STATE(22695),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22695),
    [sym_qualified_type_operator] = STATE(22695),
    [sym__qualified_type_operator] = STATE(22695),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22570),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19069),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5293),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(469),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1978] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22847),
    [sym_qualified_constructor_operator] = STATE(22847),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22847),
    [sym_qualified_type_operator] = STATE(22847),
    [sym__qualified_type_operator] = STATE(22847),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22943),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20096),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5295),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3014),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1979] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22427),
    [sym_qualified_constructor_operator] = STATE(22427),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22427),
    [sym_qualified_type_operator] = STATE(22427),
    [sym__qualified_type_operator] = STATE(22427),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22537),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19835),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1700),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5297),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3367),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1980] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22293),
    [sym_qualified_constructor_operator] = STATE(22293),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22293),
    [sym_qualified_type_operator] = STATE(22293),
    [sym__qualified_type_operator] = STATE(22293),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22396),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19785),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5299),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2519),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1981] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(23374),
    [sym_qualified_constructor_operator] = STATE(23374),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(23374),
    [sym_qualified_type_operator] = STATE(23374),
    [sym__qualified_type_operator] = STATE(23374),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(23217),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18028),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3483),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2103),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1982] = {
    [sym_integer] = STATE(4646),
    [sym__literal] = STATE(4646),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = STATE(4622),
    [sym_qualified_variable] = STATE(4622),
    [sym_constructor] = STATE(4469),
    [sym_qualified_constructor] = STATE(4558),
    [sym__qcon] = STATE(4622),
    [sym_con_unit] = STATE(4646),
    [sym_con_list] = STATE(4646),
    [sym_con_tuple] = STATE(4646),
    [sym_literal] = STATE(4618),
    [sym_exp_parens] = STATE(4618),
    [sym_exp_tuple] = STATE(4618),
    [sym_exp_unboxed_tuple] = STATE(4618),
    [sym_exp_unboxed_sum] = STATE(4618),
    [sym_exp_list] = STATE(4618),
    [sym_exp_arithmetic_sequence] = STATE(4618),
    [sym_exp_list_comprehension] = STATE(4618),
    [sym_exp_section_left] = STATE(4618),
    [sym_exp_section_right] = STATE(4618),
    [sym_exp_th_quoted_name] = STATE(4618),
    [sym_exp_type_application] = STATE(735),
    [sym_exp_lambda] = STATE(12232),
    [sym_exp_let] = STATE(21096),
    [sym_exp_let_in] = STATE(12232),
    [sym_exp_cond] = STATE(12232),
    [sym_exp_if_guard] = STATE(12232),
    [sym_exp_case] = STATE(12232),
    [sym_exp_lambda_case] = STATE(735),
    [sym_exp_lambda_cases] = STATE(735),
    [sym__do_keyword] = STATE(20443),
    [sym_do_module] = STATE(20443),
    [sym_exp_do] = STATE(735),
    [sym_exp_negation] = STATE(12232),
    [sym_exp_record] = STATE(4618),
    [sym_exp_name] = STATE(4618),
    [sym_exp_projection_selector] = STATE(4618),
    [sym__aexp_projection] = STATE(4618),
    [sym_exp_projection] = STATE(4618),
    [sym__aexp] = STATE(735),
    [sym__exp_apply] = STATE(12501),
    [sym__fexp] = STATE(12232),
    [sym__lexp] = STATE(12232),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13872),
    [sym_splice] = STATE(4618),
    [sym_quasiquote] = STATE(4618),
    [sym__varid] = ACTIONS(2111),
    [sym_float] = ACTIONS(2113),
    [sym_char] = ACTIONS(2113),
    [sym_string] = ACTIONS(2113),
    [sym__integer_literal] = ACTIONS(2115),
    [sym__binary_literal] = ACTIONS(2117),
    [sym__octal_literal] = ACTIONS(2117),
    [sym__hex_literal] = ACTIONS(2117),
    [anon_sym_LPAREN_POUND] = ACTIONS(2119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2119),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [sym_implicit_parid] = ACTIONS(2121),
    [sym__conid] = ACTIONS(4617),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2136),
    [anon_sym_BSLASH] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_mdo] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_u27e6] = ACTIONS(2146),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2150),
  },
  [1983] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22254),
    [sym_qualified_constructor_operator] = STATE(22254),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22254),
    [sym_qualified_type_operator] = STATE(22254),
    [sym__qualified_type_operator] = STATE(22254),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22319),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19863),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3511),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5301),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2617),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1984] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22291),
    [sym_qualified_constructor_operator] = STATE(22291),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22291),
    [sym_qualified_type_operator] = STATE(22291),
    [sym__qualified_type_operator] = STATE(22291),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22782),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(17888),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(255),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5303),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4269),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1985] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22781),
    [sym_qualified_constructor_operator] = STATE(22781),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22781),
    [sym_qualified_type_operator] = STATE(22781),
    [sym__qualified_type_operator] = STATE(22781),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22833),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(20068),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5305),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3777),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1986] = {
    [sym_integer] = STATE(6203),
    [sym__literal] = STATE(6203),
    [sym__unboxed_open] = STATE(736),
    [sym_variable] = STATE(6298),
    [sym_qualified_variable] = STATE(6298),
    [sym_constructor] = STATE(5341),
    [sym_qualified_constructor] = STATE(6252),
    [sym__qcon] = STATE(6298),
    [sym_con_unit] = STATE(6203),
    [sym_con_list] = STATE(6203),
    [sym_con_tuple] = STATE(6203),
    [sym_literal] = STATE(6220),
    [sym_exp_parens] = STATE(6220),
    [sym_exp_tuple] = STATE(6220),
    [sym_exp_unboxed_tuple] = STATE(6220),
    [sym_exp_unboxed_sum] = STATE(6220),
    [sym_exp_list] = STATE(6220),
    [sym_exp_arithmetic_sequence] = STATE(6220),
    [sym_exp_list_comprehension] = STATE(6220),
    [sym_exp_section_left] = STATE(6220),
    [sym_exp_section_right] = STATE(6220),
    [sym_exp_th_quoted_name] = STATE(6220),
    [sym_exp_type_application] = STATE(872),
    [sym_exp_lambda] = STATE(13838),
    [sym_exp_let] = STATE(20267),
    [sym_exp_let_in] = STATE(13838),
    [sym_exp_cond] = STATE(13838),
    [sym_exp_if_guard] = STATE(13838),
    [sym_exp_case] = STATE(13838),
    [sym_exp_lambda_case] = STATE(872),
    [sym_exp_lambda_cases] = STATE(872),
    [sym__do_keyword] = STATE(20273),
    [sym_do_module] = STATE(20273),
    [sym_exp_do] = STATE(872),
    [sym_exp_negation] = STATE(13838),
    [sym_exp_record] = STATE(6220),
    [sym_exp_name] = STATE(6220),
    [sym_exp_projection_selector] = STATE(6220),
    [sym__aexp_projection] = STATE(6220),
    [sym_exp_projection] = STATE(6220),
    [sym__aexp] = STATE(872),
    [sym__exp_apply] = STATE(13861),
    [sym__fexp] = STATE(13838),
    [sym__lexp] = STATE(13838),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13940),
    [sym_splice] = STATE(6220),
    [sym_quasiquote] = STATE(6220),
    [sym__varid] = ACTIONS(3091),
    [sym_float] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym__integer_literal] = ACTIONS(3095),
    [sym__binary_literal] = ACTIONS(3097),
    [sym__octal_literal] = ACTIONS(3097),
    [sym__hex_literal] = ACTIONS(3097),
    [anon_sym_LPAREN_POUND] = ACTIONS(3099),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3099),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_u27e6] = ACTIONS(3113),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3117),
  },
  [1987] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22469),
    [sym_qualified_constructor_operator] = STATE(22469),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22469),
    [sym_qualified_type_operator] = STATE(22469),
    [sym__qualified_type_operator] = STATE(22469),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22545),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19371),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(475),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(477),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1988] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21943),
    [sym_qualified_constructor_operator] = STATE(21943),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21943),
    [sym_qualified_type_operator] = STATE(21943),
    [sym__qualified_type_operator] = STATE(21943),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21732),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18846),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5309),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1989] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21872),
    [sym_qualified_constructor_operator] = STATE(21872),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21872),
    [sym_qualified_type_operator] = STATE(21872),
    [sym__qualified_type_operator] = STATE(21872),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21753),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19468),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4045),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1990] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21758),
    [sym_qualified_constructor_operator] = STATE(21758),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21758),
    [sym_qualified_type_operator] = STATE(21758),
    [sym__qualified_type_operator] = STATE(21758),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21751),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18971),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3781),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2495),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1991] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22171),
    [sym_qualified_constructor_operator] = STATE(22171),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22171),
    [sym_qualified_type_operator] = STATE(22171),
    [sym__qualified_type_operator] = STATE(22171),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22234),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19138),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(507),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(509),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1992] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21398),
    [sym_qualified_constructor_operator] = STATE(21398),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21398),
    [sym_qualified_type_operator] = STATE(21398),
    [sym__qualified_type_operator] = STATE(21398),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21931),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19948),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5317),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3079),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1993] = {
    [sym_integer] = STATE(5269),
    [sym__literal] = STATE(5269),
    [sym__unboxed_open] = STATE(724),
    [sym_variable] = STATE(5653),
    [sym_qualified_variable] = STATE(5653),
    [sym_constructor] = STATE(5241),
    [sym_qualified_constructor] = STATE(5383),
    [sym__qcon] = STATE(5653),
    [sym_con_unit] = STATE(5269),
    [sym_con_list] = STATE(5269),
    [sym_con_tuple] = STATE(5269),
    [sym_literal] = STATE(5831),
    [sym_exp_parens] = STATE(5831),
    [sym_exp_tuple] = STATE(5831),
    [sym_exp_unboxed_tuple] = STATE(5831),
    [sym_exp_unboxed_sum] = STATE(5831),
    [sym_exp_list] = STATE(5831),
    [sym_exp_arithmetic_sequence] = STATE(5831),
    [sym_exp_list_comprehension] = STATE(5831),
    [sym_exp_section_left] = STATE(5831),
    [sym_exp_section_right] = STATE(5831),
    [sym_exp_th_quoted_name] = STATE(5831),
    [sym_exp_type_application] = STATE(825),
    [sym_exp_lambda] = STATE(13518),
    [sym_exp_let] = STATE(20847),
    [sym_exp_let_in] = STATE(13518),
    [sym_exp_cond] = STATE(13518),
    [sym_exp_if_guard] = STATE(13518),
    [sym_exp_case] = STATE(13518),
    [sym_exp_lambda_case] = STATE(825),
    [sym_exp_lambda_cases] = STATE(825),
    [sym__do_keyword] = STATE(20666),
    [sym_do_module] = STATE(20666),
    [sym_exp_do] = STATE(825),
    [sym_exp_negation] = STATE(13518),
    [sym_exp_record] = STATE(5831),
    [sym_exp_name] = STATE(5831),
    [sym_exp_projection_selector] = STATE(5831),
    [sym__aexp_projection] = STATE(5831),
    [sym_exp_projection] = STATE(5831),
    [sym__aexp] = STATE(825),
    [sym__exp_apply] = STATE(13464),
    [sym__fexp] = STATE(13518),
    [sym__lexp] = STATE(13518),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14017),
    [sym_splice] = STATE(5831),
    [sym_quasiquote] = STATE(5831),
    [sym__varid] = ACTIONS(2795),
    [sym_float] = ACTIONS(2797),
    [sym_char] = ACTIONS(2797),
    [sym_string] = ACTIONS(2797),
    [sym__integer_literal] = ACTIONS(2799),
    [sym__binary_literal] = ACTIONS(2801),
    [sym__octal_literal] = ACTIONS(2801),
    [sym__hex_literal] = ACTIONS(2801),
    [anon_sym_LPAREN_POUND] = ACTIONS(2803),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2803),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [sym_implicit_parid] = ACTIONS(2805),
    [sym__conid] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2821),
    [anon_sym_BSLASH] = ACTIONS(2823),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_mdo] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_u27e6] = ACTIONS(2831),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2835),
  },
  [1994] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21736),
    [sym_qualified_constructor_operator] = STATE(21736),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21736),
    [sym_qualified_type_operator] = STATE(21736),
    [sym__qualified_type_operator] = STATE(21736),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21858),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19590),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(4409),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2421),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1995] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(21842),
    [sym_qualified_constructor_operator] = STATE(21842),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(21842),
    [sym_qualified_type_operator] = STATE(21842),
    [sym__qualified_type_operator] = STATE(21842),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(21835),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(18889),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2686),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1996] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_constructor_operator] = STATE(22407),
    [sym_qualified_constructor_operator] = STATE(22407),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym__type_operator] = STATE(22407),
    [sym_qualified_type_operator] = STATE(22407),
    [sym__qualified_type_operator] = STATE(22407),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym__type_tuple] = STATE(22299),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20779),
    [sym__modid] = STATE(22863),
    [aux_sym__qualifying_module] = STATE(14548),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [aux_sym_con_tuple_repeat1] = STATE(19019),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(439),
    [sym__tyconsym] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3431),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [1997] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_default_signature] = STATE(19003),
    [sym_class_datafam] = STATE(19003),
    [sym_class_tyfam] = STATE(19003),
    [sym__cdecl] = STATE(19003),
    [sym_inst_tyinst] = STATE(19003),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19003),
    [sym_fixity] = STATE(19003),
    [sym_signature] = STATE(19003),
    [sym__gendecl] = STATE(19003),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5035),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_data] = ACTIONS(5037),
    [anon_sym_default] = ACTIONS(5039),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [1998] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16621),
    [sym_fixity] = STATE(16621),
    [sym_signature] = STATE(16621),
    [sym__gendecl] = STATE(16621),
    [sym__decl_fun] = STATE(16621),
    [sym__decl] = STATE(16621),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5325),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5335),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [1999] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5341),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5345),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2000] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17203),
    [sym_fixity] = STATE(17203),
    [sym_signature] = STATE(17203),
    [sym__gendecl] = STATE(17203),
    [sym__decl_fun] = STATE(17203),
    [sym__decl] = STATE(17203),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5347),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2001] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(15820),
    [sym_fixity] = STATE(15820),
    [sym_signature] = STATE(15820),
    [sym__gendecl] = STATE(15820),
    [sym__decl_fun] = STATE(15820),
    [sym__decl] = STATE(15820),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5353),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2002] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16550),
    [sym_fixity] = STATE(16550),
    [sym_signature] = STATE(16550),
    [sym__gendecl] = STATE(16550),
    [sym__decl_fun] = STATE(16550),
    [sym__decl] = STATE(16550),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5355),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2003] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17160),
    [sym_fixity] = STATE(17160),
    [sym_signature] = STATE(17160),
    [sym__gendecl] = STATE(17160),
    [sym__decl_fun] = STATE(17160),
    [sym__decl] = STATE(17160),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5359),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2004] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17659),
    [sym_fixity] = STATE(17659),
    [sym_signature] = STATE(17659),
    [sym__gendecl] = STATE(17659),
    [sym__decl_fun] = STATE(17659),
    [sym__decl] = STATE(17659),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5363),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2005] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5367),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5369),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2006] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16264),
    [sym_fixity] = STATE(16264),
    [sym_signature] = STATE(16264),
    [sym__gendecl] = STATE(16264),
    [sym__decl_fun] = STATE(16264),
    [sym__decl] = STATE(16264),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5371),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2007] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16735),
    [sym_fixity] = STATE(16735),
    [sym_signature] = STATE(16735),
    [sym__gendecl] = STATE(16735),
    [sym__decl_fun] = STATE(16735),
    [sym__decl] = STATE(16735),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5375),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2008] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16661),
    [sym_fixity] = STATE(16661),
    [sym_signature] = STATE(16661),
    [sym__gendecl] = STATE(16661),
    [sym__decl_fun] = STATE(16661),
    [sym__decl] = STATE(16661),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5379),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5353),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2009] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5341),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5381),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2010] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16704),
    [sym_fixity] = STATE(16704),
    [sym_signature] = STATE(16704),
    [sym__gendecl] = STATE(16704),
    [sym__decl_fun] = STATE(16704),
    [sym__decl] = STATE(16704),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5383),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2011] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5367),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5387),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2012] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16739),
    [sym_fixity] = STATE(16739),
    [sym_signature] = STATE(16739),
    [sym__gendecl] = STATE(16739),
    [sym__decl_fun] = STATE(16739),
    [sym__decl] = STATE(16739),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5389),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2013] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16674),
    [sym_fixity] = STATE(16674),
    [sym_signature] = STATE(16674),
    [sym__gendecl] = STATE(16674),
    [sym__decl_fun] = STATE(16674),
    [sym__decl] = STATE(16674),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5393),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5395),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2014] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16584),
    [sym_fixity] = STATE(16584),
    [sym_signature] = STATE(16584),
    [sym__gendecl] = STATE(16584),
    [sym__decl_fun] = STATE(16584),
    [sym__decl] = STATE(16584),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5397),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2015] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16806),
    [sym_fixity] = STATE(16806),
    [sym_signature] = STATE(16806),
    [sym__gendecl] = STATE(16806),
    [sym__decl_fun] = STATE(16806),
    [sym__decl] = STATE(16806),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5401),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2016] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(15973),
    [sym_fixity] = STATE(15973),
    [sym_signature] = STATE(15973),
    [sym__gendecl] = STATE(15973),
    [sym__decl_fun] = STATE(15973),
    [sym__decl] = STATE(15973),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5405),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2017] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17286),
    [sym_fixity] = STATE(17286),
    [sym_signature] = STATE(17286),
    [sym__gendecl] = STATE(17286),
    [sym__decl_fun] = STATE(17286),
    [sym__decl] = STATE(17286),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5407),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5409),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2018] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5367),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5411),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2019] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16360),
    [sym_fixity] = STATE(16360),
    [sym_signature] = STATE(16360),
    [sym__gendecl] = STATE(16360),
    [sym__decl_fun] = STATE(16360),
    [sym__decl] = STATE(16360),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5413),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5405),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2020] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17236),
    [sym_fixity] = STATE(17236),
    [sym_signature] = STATE(17236),
    [sym__gendecl] = STATE(17236),
    [sym__decl_fun] = STATE(17236),
    [sym__decl] = STATE(17236),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5415),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2021] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16377),
    [sym_fixity] = STATE(16377),
    [sym_signature] = STATE(16377),
    [sym__gendecl] = STATE(16377),
    [sym__decl_fun] = STATE(16377),
    [sym__decl] = STATE(16377),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5419),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2022] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(20977),
    [sym_fixity] = STATE(20977),
    [sym_signature] = STATE(20977),
    [sym__gendecl] = STATE(20977),
    [sym__decl_fun] = STATE(20977),
    [sym__decl] = STATE(20977),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [aux_sym_decl_tyfam_repeat1] = STATE(4578),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(693),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2023] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(15957),
    [sym_fixity] = STATE(15957),
    [sym_signature] = STATE(15957),
    [sym__gendecl] = STATE(15957),
    [sym__decl_fun] = STATE(15957),
    [sym__decl] = STATE(15957),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5423),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2024] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7749),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15479),
    [sym__typed_pat] = STATE(15479),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(20777),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17254),
    [sym_fixity] = STATE(17254),
    [sym_signature] = STATE(17254),
    [sym__gendecl] = STATE(17254),
    [sym__decl_fun] = STATE(17254),
    [sym__decl] = STATE(17254),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5425),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(141),
    [anon_sym_infixr] = ACTIONS(141),
    [anon_sym_infix] = ACTIONS(141),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2025] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5341),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5429),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2026] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5433),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2027] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5435),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2028] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5381),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2029] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5369),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2030] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5437),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2031] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5411),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2032] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(17238),
    [sym_fixity] = STATE(17238),
    [sym_signature] = STATE(17238),
    [sym__gendecl] = STATE(17238),
    [sym__decl_fun] = STATE(17238),
    [sym__decl] = STATE(17238),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5417),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2033] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7621),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15323),
    [sym__typed_pat] = STATE(15323),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(18548),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15304),
    [sym_function] = STATE(19585),
    [sym_fixity] = STATE(19585),
    [sym_signature] = STATE(19585),
    [sym__gendecl] = STATE(19585),
    [sym__decl_fun] = STATE(19585),
    [sym__decl] = STATE(19585),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5439),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5367),
    [anon_sym_infixl] = ACTIONS(5441),
    [anon_sym_infixr] = ACTIONS(5441),
    [anon_sym_infix] = ACTIONS(5441),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2034] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16698),
    [sym_fixity] = STATE(16698),
    [sym_signature] = STATE(16698),
    [sym__gendecl] = STATE(16698),
    [sym__decl_fun] = STATE(16698),
    [sym__decl] = STATE(16698),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5385),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2035] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16669),
    [sym_fixity] = STATE(16669),
    [sym_signature] = STATE(16669),
    [sym__gendecl] = STATE(16669),
    [sym__decl_fun] = STATE(16669),
    [sym__decl] = STATE(16669),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5353),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2036] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5443),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2037] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7621),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15323),
    [sym__typed_pat] = STATE(15323),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(18548),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15304),
    [sym_function] = STATE(16663),
    [sym_fixity] = STATE(16663),
    [sym_signature] = STATE(16663),
    [sym__gendecl] = STATE(16663),
    [sym__decl_fun] = STATE(16663),
    [sym__decl] = STATE(16663),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5439),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_infixl] = ACTIONS(5441),
    [anon_sym_infixr] = ACTIONS(5441),
    [anon_sym_infix] = ACTIONS(5441),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2038] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5345),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2039] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16358),
    [sym_fixity] = STATE(16358),
    [sym_signature] = STATE(16358),
    [sym__gendecl] = STATE(16358),
    [sym__decl_fun] = STATE(16358),
    [sym__decl] = STATE(16358),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5405),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2040] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16812),
    [sym_fixity] = STATE(16812),
    [sym_signature] = STATE(16812),
    [sym__gendecl] = STATE(16812),
    [sym__decl_fun] = STATE(16812),
    [sym__decl] = STATE(16812),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5403),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2041] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5445),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2042] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5447),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2043] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7621),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15323),
    [sym__typed_pat] = STATE(15323),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(18548),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15304),
    [sym_function] = STATE(19585),
    [sym_fixity] = STATE(19585),
    [sym_signature] = STATE(19585),
    [sym__gendecl] = STATE(19585),
    [sym__decl_fun] = STATE(19585),
    [sym__decl] = STATE(19585),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5439),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(5341),
    [anon_sym_infixl] = ACTIONS(5441),
    [anon_sym_infixr] = ACTIONS(5441),
    [anon_sym_infix] = ACTIONS(5441),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2044] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2049),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2049),
    [sym_type_list] = STATE(2049),
    [sym_type_tuple] = STATE(2049),
    [sym__type_promotable_literal] = STATE(2049),
    [sym__type_promoted_literal] = STATE(2049),
    [sym__type_literal] = STATE(2049),
    [sym_type_name] = STATE(2049),
    [sym_type_star] = STATE(2049),
    [sym_type_unboxed_tuple] = STATE(2049),
    [sym_type_unboxed_sum] = STATE(2049),
    [sym__atype] = STATE(2049),
    [sym_type_invisible] = STATE(2049),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2049),
    [sym_quasiquote] = STATE(2049),
    [aux_sym_type_apply_repeat1] = STATE(2049),
    [sym__varid] = ACTIONS(5449),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2190] = ACTIONS(5451),
    [anon_sym_LT_DASH] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5461),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(5463),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_AT] = ACTIONS(5473),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_instance] = ACTIONS(5475),
    [anon_sym_using] = ACTIONS(5475),
    [anon_sym_then] = ACTIONS(5475),
    [anon_sym_else] = ACTIONS(5475),
    [anon_sym_of] = ACTIONS(5475),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2045] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7863),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15146),
    [sym__typed_pat] = STATE(15146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(19860),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19233),
    [sym_fixity] = STATE(19233),
    [sym_signature] = STATE(19233),
    [sym__gendecl] = STATE(19233),
    [sym__decl_fun] = STATE(19233),
    [sym__decl] = STATE(19233),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(219),
    [anon_sym_infixr] = ACTIONS(219),
    [anon_sym_infix] = ACTIONS(219),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2046] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2044),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2044),
    [sym_type_list] = STATE(2044),
    [sym_type_tuple] = STATE(2044),
    [sym__type_promotable_literal] = STATE(2044),
    [sym__type_promoted_literal] = STATE(2044),
    [sym__type_literal] = STATE(2044),
    [sym_type_name] = STATE(2044),
    [sym_type_star] = STATE(2044),
    [sym_type_unboxed_tuple] = STATE(2044),
    [sym_type_unboxed_sum] = STATE(2044),
    [sym__atype] = STATE(2044),
    [sym_type_invisible] = STATE(2044),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2044),
    [sym_quasiquote] = STATE(2044),
    [aux_sym_type_apply_repeat1] = STATE(2044),
    [sym__varid] = ACTIONS(5449),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2190] = ACTIONS(5483),
    [anon_sym_LT_DASH] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5461),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(5485),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(5488),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_AT] = ACTIONS(5473),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_instance] = ACTIONS(5491),
    [anon_sym_using] = ACTIONS(5491),
    [anon_sym_then] = ACTIONS(5491),
    [anon_sym_else] = ACTIONS(5491),
    [anon_sym_of] = ACTIONS(5491),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2047] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7621),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15323),
    [sym__typed_pat] = STATE(15323),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(18548),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15304),
    [sym_function] = STATE(19585),
    [sym_fixity] = STATE(19585),
    [sym_signature] = STATE(19585),
    [sym__gendecl] = STATE(19585),
    [sym__decl_fun] = STATE(19585),
    [sym__decl] = STATE(19585),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5439),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(5441),
    [anon_sym_infixr] = ACTIONS(5441),
    [anon_sym_infix] = ACTIONS(5441),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2048] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(416),
    [sym_variable] = STATE(7838),
    [sym_constructor] = STATE(4289),
    [sym_qualified_constructor] = STATE(4476),
    [sym__qcon] = STATE(8371),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(14028),
    [sym_pat_name] = STATE(11992),
    [sym_pat_as] = STATE(11992),
    [sym__pat_constructor] = STATE(2763),
    [sym_pat_record] = STATE(11992),
    [sym_pat_wildcard] = STATE(11992),
    [sym_pat_parens] = STATE(11992),
    [sym_pat_tuple] = STATE(11992),
    [sym_pat_unboxed_tuple] = STATE(11992),
    [sym_pat_unboxed_sum] = STATE(11992),
    [sym_pat_list] = STATE(11992),
    [sym_pat_strict] = STATE(11992),
    [sym_pat_irrefutable] = STATE(11992),
    [sym_pat_type_binder] = STATE(11992),
    [sym__apat] = STATE(11992),
    [sym_pat_negation] = STATE(11992),
    [sym_pat_apply] = STATE(11992),
    [sym__lpat] = STATE(11992),
    [sym_pat_infix] = STATE(13105),
    [sym__pat] = STATE(13105),
    [sym_pat_typed] = STATE(15132),
    [sym__typed_pat] = STATE(15132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16455),
    [sym__funpat_infix] = STATE(20295),
    [sym__funpat] = STATE(16623),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15147),
    [sym_function] = STATE(17703),
    [sym_fixity] = STATE(17703),
    [sym_signature] = STATE(17703),
    [sym__gendecl] = STATE(17703),
    [sym__decl_fun] = STATE(17703),
    [sym__decl] = STATE(17703),
    [sym_splice] = STATE(11992),
    [sym_quasiquote] = STATE(11992),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(5327),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5327),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5329),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(5333),
    [anon_sym_AT] = ACTIONS(5337),
    [anon_sym__] = ACTIONS(35),
    [anon_sym_infixl] = ACTIONS(5343),
    [anon_sym_infixr] = ACTIONS(5343),
    [anon_sym_infix] = ACTIONS(5343),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
    [sym__strict] = ACTIONS(77),
    [sym__lazy] = ACTIONS(79),
  },
  [2049] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2049),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2049),
    [sym_type_list] = STATE(2049),
    [sym_type_tuple] = STATE(2049),
    [sym__type_promotable_literal] = STATE(2049),
    [sym__type_promoted_literal] = STATE(2049),
    [sym__type_literal] = STATE(2049),
    [sym_type_name] = STATE(2049),
    [sym_type_star] = STATE(2049),
    [sym_type_unboxed_tuple] = STATE(2049),
    [sym_type_unboxed_sum] = STATE(2049),
    [sym__atype] = STATE(2049),
    [sym_type_invisible] = STATE(2049),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2049),
    [sym_quasiquote] = STATE(2049),
    [aux_sym_type_apply_repeat1] = STATE(2049),
    [sym__varid] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(5498),
    [sym_char] = ACTIONS(5498),
    [sym_string] = ACTIONS(5498),
    [sym__integer_literal] = ACTIONS(5501),
    [sym__binary_literal] = ACTIONS(5504),
    [sym__octal_literal] = ACTIONS(5504),
    [sym__hex_literal] = ACTIONS(5504),
    [anon_sym_LPAREN_POUND] = ACTIONS(5507),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5507),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2190] = ACTIONS(5496),
    [anon_sym_LT_DASH] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(5513),
    [anon_sym_LBRACK] = ACTIONS(5516),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(5519),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_u2605] = ACTIONS(5522),
    [anon_sym_AT] = ACTIONS(5525),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_instance] = ACTIONS(5528),
    [anon_sym_using] = ACTIONS(5528),
    [anon_sym_then] = ACTIONS(5528),
    [anon_sym_else] = ACTIONS(5528),
    [anon_sym_of] = ACTIONS(5528),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(5530),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5533),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5536),
  },
  [2050] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2190] = ACTIONS(5542),
    [anon_sym_LT_DASH] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_instance] = ACTIONS(5573),
    [anon_sym_using] = ACTIONS(5573),
    [anon_sym_then] = ACTIONS(5573),
    [anon_sym_else] = ACTIONS(5573),
    [anon_sym_of] = ACTIONS(5573),
    [anon_sym_deriving] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2051] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(17320),
    [sym_inst_tyinst] = STATE(17320),
    [sym__idecl] = STATE(17320),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17320),
    [sym_signature] = STATE(17320),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5584),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2052] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(17228),
    [sym_inst_tyinst] = STATE(17228),
    [sym__idecl] = STATE(17228),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17228),
    [sym_signature] = STATE(17228),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5594),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2053] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(21231),
    [sym_inst_tyinst] = STATE(21231),
    [sym__idecl] = STATE(21231),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(21231),
    [sym_signature] = STATE(21231),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [aux_sym_decl_tyfam_repeat1] = STATE(4578),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(693),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2054] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2054),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym_type_parens] = STATE(2054),
    [sym_type_list] = STATE(2054),
    [sym_type_tuple] = STATE(2054),
    [sym__type_promotable_literal] = STATE(2054),
    [sym__type_promoted_literal] = STATE(2054),
    [sym__type_literal] = STATE(2054),
    [sym_type_name] = STATE(2054),
    [sym_type_star] = STATE(2054),
    [sym_type_unboxed_tuple] = STATE(2054),
    [sym_type_unboxed_sum] = STATE(2054),
    [sym__atype] = STATE(2054),
    [sym_type_invisible] = STATE(2054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2054),
    [sym_quasiquote] = STATE(2054),
    [aux_sym_type_apply_repeat1] = STATE(2054),
    [sym__varid] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(5601),
    [sym_char] = ACTIONS(5601),
    [sym_string] = ACTIONS(5601),
    [sym__integer_literal] = ACTIONS(5604),
    [sym__binary_literal] = ACTIONS(5607),
    [sym__octal_literal] = ACTIONS(5607),
    [sym__hex_literal] = ACTIONS(5607),
    [anon_sym_LPAREN_POUND] = ACTIONS(5610),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5610),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(5613),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(5622),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_u2605] = ACTIONS(5625),
    [anon_sym_AT] = ACTIONS(5628),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_using] = ACTIONS(5528),
    [anon_sym_then] = ACTIONS(5528),
    [anon_sym_else] = ACTIONS(5528),
    [anon_sym_of] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(5631),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5634),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5637),
  },
  [2055] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(16650),
    [sym_inst_tyinst] = STATE(16650),
    [sym__idecl] = STATE(16650),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16650),
    [sym_signature] = STATE(16650),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5640),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5642),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2056] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2054),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym_type_parens] = STATE(2054),
    [sym_type_list] = STATE(2054),
    [sym_type_tuple] = STATE(2054),
    [sym__type_promotable_literal] = STATE(2054),
    [sym__type_promoted_literal] = STATE(2054),
    [sym__type_literal] = STATE(2054),
    [sym_type_name] = STATE(2054),
    [sym_type_star] = STATE(2054),
    [sym_type_unboxed_tuple] = STATE(2054),
    [sym_type_unboxed_sum] = STATE(2054),
    [sym__atype] = STATE(2054),
    [sym_type_invisible] = STATE(2054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2054),
    [sym_quasiquote] = STATE(2054),
    [aux_sym_type_apply_repeat1] = STATE(2054),
    [sym__varid] = ACTIONS(5644),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(5646),
    [sym_char] = ACTIONS(5646),
    [sym_string] = ACTIONS(5646),
    [sym__integer_literal] = ACTIONS(5648),
    [sym__binary_literal] = ACTIONS(5650),
    [sym__octal_literal] = ACTIONS(5650),
    [sym__hex_literal] = ACTIONS(5650),
    [anon_sym_LPAREN_POUND] = ACTIONS(5652),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5652),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(5654),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(5661),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_u2605] = ACTIONS(5664),
    [anon_sym_AT] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_using] = ACTIONS(5475),
    [anon_sym_then] = ACTIONS(5475),
    [anon_sym_else] = ACTIONS(5475),
    [anon_sym_of] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(5668),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5670),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5672),
  },
  [2057] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2056),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym_type_parens] = STATE(2056),
    [sym_type_list] = STATE(2056),
    [sym_type_tuple] = STATE(2056),
    [sym__type_promotable_literal] = STATE(2056),
    [sym__type_promoted_literal] = STATE(2056),
    [sym__type_literal] = STATE(2056),
    [sym_type_name] = STATE(2056),
    [sym_type_star] = STATE(2056),
    [sym_type_unboxed_tuple] = STATE(2056),
    [sym_type_unboxed_sum] = STATE(2056),
    [sym__atype] = STATE(2056),
    [sym_type_invisible] = STATE(2056),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2056),
    [sym_quasiquote] = STATE(2056),
    [aux_sym_type_apply_repeat1] = STATE(2056),
    [sym__varid] = ACTIONS(5644),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(5646),
    [sym_char] = ACTIONS(5646),
    [sym_string] = ACTIONS(5646),
    [sym__integer_literal] = ACTIONS(5648),
    [sym__binary_literal] = ACTIONS(5650),
    [sym__octal_literal] = ACTIONS(5650),
    [sym__hex_literal] = ACTIONS(5650),
    [anon_sym_LPAREN_POUND] = ACTIONS(5652),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5652),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(5654),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(5677),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_u2605] = ACTIONS(5664),
    [anon_sym_AT] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_using] = ACTIONS(5491),
    [anon_sym_then] = ACTIONS(5491),
    [anon_sym_else] = ACTIONS(5491),
    [anon_sym_of] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(5668),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5670),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5672),
  },
  [2058] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(16785),
    [sym_inst_tyinst] = STATE(16785),
    [sym__idecl] = STATE(16785),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16785),
    [sym_signature] = STATE(16785),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5680),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2059] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(16775),
    [sym_inst_tyinst] = STATE(16775),
    [sym__idecl] = STATE(16775),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(16775),
    [sym_signature] = STATE(16775),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5684),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2060] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7779),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(17543),
    [sym_inst_tyinst] = STATE(17543),
    [sym__idecl] = STATE(17543),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15480),
    [sym_function] = STATE(17543),
    [sym_signature] = STATE(17543),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(5688),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5590),
    [anon_sym_data] = ACTIONS(5592),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2061] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23137),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15630),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5722),
  },
  [2062] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21782),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15759),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5724),
  },
  [2063] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22237),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16018),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5726),
  },
  [2064] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21887),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15881),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5728),
  },
  [2065] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22569),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15962),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5730),
  },
  [2066] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22159),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16025),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5732),
  },
  [2067] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22420),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15874),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5734),
  },
  [2068] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21514),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16128),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5736),
  },
  [2069] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21980),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15955),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5738),
  },
  [2070] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(17546),
    [sym_inst_tyinst] = STATE(17546),
    [sym__idecl] = STATE(17546),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(17546),
    [sym_signature] = STATE(17546),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5690),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2071] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22048),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16034),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5746),
  },
  [2072] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21977),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16045),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5748),
  },
  [2073] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21362),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16243),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5750),
  },
  [2074] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22016),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15932),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5752),
  },
  [2075] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21810),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15808),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5754),
  },
  [2076] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22034),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15858),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5756),
  },
  [2077] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21901),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5758),
  },
  [2078] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22423),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15901),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5760),
  },
  [2079] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22837),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15887),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5762),
  },
  [2080] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21426),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16178),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5764),
  },
  [2081] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21502),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16055),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5766),
  },
  [2082] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23095),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15701),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5768),
  },
  [2083] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23431),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15971),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5770),
  },
  [2084] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22698),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15923),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5772),
  },
  [2085] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22771),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15902),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5774),
  },
  [2086] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22434),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15812),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5776),
  },
  [2087] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21698),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15636),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5778),
  },
  [2088] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22688),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5780),
  },
  [2089] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21796),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16062),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5782),
  },
  [2090] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21390),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16204),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5784),
  },
  [2091] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22458),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15810),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5786),
  },
  [2092] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21418),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16181),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5788),
  },
  [2093] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21802),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15977),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5790),
  },
  [2094] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21739),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15999),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5792),
  },
  [2095] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(16800),
    [sym_inst_tyinst] = STATE(16800),
    [sym__idecl] = STATE(16800),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(16800),
    [sym_signature] = STATE(16800),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5682),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2096] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21378),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16127),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5794),
  },
  [2097] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22686),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16068),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5796),
  },
  [2098] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21728),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16076),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5798),
  },
  [2099] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21325),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16229),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5800),
  },
  [2100] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22994),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15638),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5802),
  },
  [2101] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22174),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15642),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5804),
  },
  [2102] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21838),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15884),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5806),
  },
  [2103] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21518),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16109),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5808),
  },
  [2104] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22955),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15873),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5810),
  },
  [2105] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23084),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15857),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5812),
  },
  [2106] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23204),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16218),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5814),
  },
  [2107] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2177),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym_type_parens] = STATE(2177),
    [sym_type_list] = STATE(2177),
    [sym_type_tuple] = STATE(2177),
    [sym__type_promotable_literal] = STATE(2177),
    [sym__type_promoted_literal] = STATE(2177),
    [sym__type_literal] = STATE(2177),
    [sym_type_name] = STATE(2177),
    [sym_type_star] = STATE(2177),
    [sym_type_unboxed_tuple] = STATE(2177),
    [sym_type_unboxed_sum] = STATE(2177),
    [sym__atype] = STATE(2177),
    [sym_type_invisible] = STATE(2177),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2177),
    [sym_quasiquote] = STATE(2177),
    [aux_sym_type_apply_repeat1] = STATE(2177),
    [sym__varid] = ACTIONS(5816),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(5818),
    [sym_char] = ACTIONS(5818),
    [sym_string] = ACTIONS(5818),
    [sym__integer_literal] = ACTIONS(5820),
    [sym__binary_literal] = ACTIONS(5822),
    [sym__octal_literal] = ACTIONS(5822),
    [sym__hex_literal] = ACTIONS(5822),
    [anon_sym_LPAREN_POUND] = ACTIONS(5824),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5824),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(5826),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5831),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(5833),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_u2605] = ACTIONS(5836),
    [anon_sym_AT] = ACTIONS(5838),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_using] = ACTIONS(5491),
    [anon_sym_then] = ACTIONS(5491),
    [anon_sym_else] = ACTIONS(5491),
    [anon_sym_of] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(5840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5842),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5844),
  },
  [2108] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21627),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16093),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5846),
  },
  [2109] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23197),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15842),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5848),
  },
  [2110] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21452),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16126),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5850),
  },
  [2111] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22756),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16217),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5852),
  },
  [2112] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22639),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15750),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5854),
  },
  [2113] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22716),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15908),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5856),
  },
  [2114] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2114),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym_type_parens] = STATE(2114),
    [sym_type_list] = STATE(2114),
    [sym_type_tuple] = STATE(2114),
    [sym__type_promotable_literal] = STATE(2114),
    [sym__type_promoted_literal] = STATE(2114),
    [sym__type_literal] = STATE(2114),
    [sym_type_name] = STATE(2114),
    [sym_type_star] = STATE(2114),
    [sym_type_unboxed_tuple] = STATE(2114),
    [sym_type_unboxed_sum] = STATE(2114),
    [sym__atype] = STATE(2114),
    [sym_type_invisible] = STATE(2114),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2114),
    [sym_quasiquote] = STATE(2114),
    [aux_sym_type_apply_repeat1] = STATE(2114),
    [sym__varid] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(5861),
    [sym_char] = ACTIONS(5861),
    [sym_string] = ACTIONS(5861),
    [sym__integer_literal] = ACTIONS(5864),
    [sym__binary_literal] = ACTIONS(5867),
    [sym__octal_literal] = ACTIONS(5867),
    [sym__hex_literal] = ACTIONS(5867),
    [anon_sym_LPAREN_POUND] = ACTIONS(5870),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(5873),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5879),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(5882),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5885),
    [anon_sym_u2605] = ACTIONS(5885),
    [anon_sym_AT] = ACTIONS(5888),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_using] = ACTIONS(5528),
    [anon_sym_then] = ACTIONS(5528),
    [anon_sym_else] = ACTIONS(5528),
    [anon_sym_of] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(5891),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5894),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5897),
  },
  [2115] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21748),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15967),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5900),
  },
  [2116] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21866),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15935),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5902),
  },
  [2117] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23249),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15811),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5904),
  },
  [2118] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22803),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16144),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5906),
  },
  [2119] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21566),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16114),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5908),
  },
  [2120] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22214),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16221),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5910),
  },
  [2121] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22252),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15692),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5912),
  },
  [2122] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22074),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15926),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5914),
  },
  [2123] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21670),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15656),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5916),
  },
  [2124] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21685),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15634),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5918),
  },
  [2125] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23321),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15787),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5920),
  },
  [2126] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21894),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15946),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5922),
  },
  [2127] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5924),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2128] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22721),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15706),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5926),
  },
  [2129] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21737),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15978),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5928),
  },
  [2130] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5930),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2131] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22927),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16053),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5932),
  },
  [2132] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21474),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16083),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5934),
  },
  [2133] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21642),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15671),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5936),
  },
  [2134] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22533),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15790),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5938),
  },
  [2135] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22435),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15828),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5940),
  },
  [2136] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22866),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16222),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5942),
  },
  [2137] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21643),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16049),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5944),
  },
  [2138] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21614),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15761),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5946),
  },
  [2139] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23381),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15767),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5948),
  },
  [2140] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21530),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16024),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5950),
  },
  [2141] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22324),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16003),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5952),
  },
  [2142] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22102),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15731),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5954),
  },
  [2143] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5956),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2144] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22584),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15772),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5958),
  },
  [2145] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22474),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15795),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5960),
  },
  [2146] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21344),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16214),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5962),
  },
  [2147] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21922),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16039),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5964),
  },
  [2148] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23410),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15758),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5966),
  },
  [2149] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(17322),
    [sym_inst_tyinst] = STATE(17322),
    [sym__idecl] = STATE(17322),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(17322),
    [sym_signature] = STATE(17322),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5586),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2150] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22885),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15673),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5968),
  },
  [2151] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5970),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2152] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23303),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15741),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5972),
  },
  [2153] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22388),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15993),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5974),
  },
  [2154] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21920),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15960),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5976),
  },
  [2155] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23416),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15747),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5978),
  },
  [2156] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22133),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15904),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5980),
  },
  [2157] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21628),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16077),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5982),
  },
  [2158] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_using] = ACTIONS(5573),
    [anon_sym_then] = ACTIONS(5573),
    [anon_sym_else] = ACTIONS(5573),
    [anon_sym_of] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2159] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21742),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16069),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5984),
  },
  [2160] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22468),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15979),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5986),
  },
  [2161] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21302),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16133),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5988),
  },
  [2162] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21950),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16095),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5990),
  },
  [2163] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23411),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15733),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5992),
  },
  [2164] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23386),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15722),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5994),
  },
  [2165] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23338),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15710),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5996),
  },
  [2166] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21726),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15694),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5998),
  },
  [2167] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21322),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16152),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6000),
  },
  [2168] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21850),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15966),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6002),
  },
  [2169] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23293),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15693),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6004),
  },
  [2170] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23015),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15805),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6006),
  },
  [2171] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23251),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15682),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6008),
  },
  [2172] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21571),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16105),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6010),
  },
  [2173] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22347),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15830),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6012),
  },
  [2174] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23202),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15645),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6014),
  },
  [2175] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21978),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16145),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6016),
  },
  [2176] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22295),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15794),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6018),
  },
  [2177] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2114),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym_type_parens] = STATE(2114),
    [sym_type_list] = STATE(2114),
    [sym_type_tuple] = STATE(2114),
    [sym__type_promotable_literal] = STATE(2114),
    [sym__type_promoted_literal] = STATE(2114),
    [sym__type_literal] = STATE(2114),
    [sym_type_name] = STATE(2114),
    [sym_type_star] = STATE(2114),
    [sym_type_unboxed_tuple] = STATE(2114),
    [sym_type_unboxed_sum] = STATE(2114),
    [sym__atype] = STATE(2114),
    [sym_type_invisible] = STATE(2114),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2114),
    [sym_quasiquote] = STATE(2114),
    [aux_sym_type_apply_repeat1] = STATE(2114),
    [sym__varid] = ACTIONS(5816),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(5818),
    [sym_char] = ACTIONS(5818),
    [sym_string] = ACTIONS(5818),
    [sym__integer_literal] = ACTIONS(5820),
    [sym__binary_literal] = ACTIONS(5822),
    [sym__octal_literal] = ACTIONS(5822),
    [sym__hex_literal] = ACTIONS(5822),
    [anon_sym_LPAREN_POUND] = ACTIONS(5824),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5824),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(5826),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6020),
    [anon_sym_LBRACK] = ACTIONS(5831),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(6023),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_u2605] = ACTIONS(5836),
    [anon_sym_AT] = ACTIONS(5838),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_using] = ACTIONS(5475),
    [anon_sym_then] = ACTIONS(5475),
    [anon_sym_else] = ACTIONS(5475),
    [anon_sym_of] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(5840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5842),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5844),
  },
  [2178] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22673),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15974),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6026),
  },
  [2179] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22042),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15777),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6028),
  },
  [2180] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(6030),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2181] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22333),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16008),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6032),
  },
  [2182] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22556),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15954),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6034),
  },
  [2183] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21574),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16098),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6036),
  },
  [2184] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23005),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15651),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6038),
  },
  [2185] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22188),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15770),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6040),
  },
  [2186] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21586),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15806),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6042),
  },
  [2187] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21532),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16102),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6044),
  },
  [2188] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22060),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15878),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6046),
  },
  [2189] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(6048),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2190] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22554),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15681),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6050),
  },
  [2191] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22104),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15711),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6052),
  },
  [2192] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22907),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15665),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6054),
  },
  [2193] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21558),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15903),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6056),
  },
  [2194] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21928),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16033),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6058),
  },
  [2195] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21423),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16119),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6060),
  },
  [2196] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22247),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15849),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6062),
  },
  [2197] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22006),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16191),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6064),
  },
  [2198] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22301),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15838),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6066),
  },
  [2199] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22846),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15686),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6068),
  },
  [2200] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21921),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15865),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6070),
  },
  [2201] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21476),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16116),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6072),
  },
  [2202] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22526),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15942),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6074),
  },
  [2203] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21979),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15947),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6076),
  },
  [2204] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(23158),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15815),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6078),
  },
  [2205] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22389),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15822),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6080),
  },
  [2206] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21754),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15712),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6082),
  },
  [2207] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21446),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16125),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6084),
  },
  [2208] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22784),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15695),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6086),
  },
  [2209] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22638),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(15934),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6088),
  },
  [2210] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(21335),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16211),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6090),
  },
  [2211] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_sum] = STATE(22728),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14407),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14407),
    [sym__type_context] = STATE(14407),
    [sym__type_fun] = STATE(14407),
    [sym__type] = STATE(14407),
    [sym__type_or_implicit] = STATE(14407),
    [sym__type_with_kind] = STATE(16084),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [aux_sym__type_sum_repeat1] = STATE(18283),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(6092),
  },
  [2212] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_using] = ACTIONS(5573),
    [anon_sym_then] = ACTIONS(5573),
    [anon_sym_else] = ACTIONS(5573),
    [anon_sym_of] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2213] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2093),
    [sym_constructor] = STATE(2411),
    [sym_con_unit] = STATE(8515),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2554),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8488),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18721),
    [sym_lazy_type] = STATE(18721),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8494),
    [sym_type_unboxed_sum] = STATE(8494),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18721),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2801),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(15367),
    [sym_data_constructor_infix] = STATE(15367),
    [sym_data_constructor_record] = STATE(15367),
    [sym_data_constructor_special] = STATE(15367),
    [sym_constructors] = STATE(15364),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6094),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6094),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6096),
    [sym__conid] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2214] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2082),
    [sym_constructor] = STATE(2413),
    [sym_con_unit] = STATE(8550),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2568),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8529),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18975),
    [sym_lazy_type] = STATE(18975),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8513),
    [sym_type_unboxed_sum] = STATE(8513),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18975),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2894),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(15384),
    [sym_data_constructor_infix] = STATE(15384),
    [sym_data_constructor_record] = STATE(15384),
    [sym_data_constructor_special] = STATE(15384),
    [sym_constructors] = STATE(15429),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6106),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6106),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6108),
    [sym__conid] = ACTIONS(6110),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2215] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(340),
    [sym_variable] = STATE(7790),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4368),
    [sym__qcon] = STATE(9552),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(16130),
    [sym_pat_name] = STATE(13722),
    [sym_pat_as] = STATE(13722),
    [sym__pat_constructor] = STATE(3120),
    [sym_pat_record] = STATE(13722),
    [sym_pat_wildcard] = STATE(13722),
    [sym_pat_parens] = STATE(13722),
    [sym_pat_tuple] = STATE(13722),
    [sym_pat_unboxed_tuple] = STATE(13722),
    [sym_pat_unboxed_sum] = STATE(13722),
    [sym_pat_list] = STATE(13722),
    [sym_pat_strict] = STATE(13722),
    [sym_pat_irrefutable] = STATE(13722),
    [sym_pat_type_binder] = STATE(13722),
    [sym__apat] = STATE(13722),
    [sym_pat_negation] = STATE(13722),
    [sym_pat_apply] = STATE(13722),
    [sym__lpat] = STATE(13722),
    [sym_pat_infix] = STATE(15021),
    [sym__pat] = STATE(15021),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16840),
    [sym_inst_datainst] = STATE(19294),
    [sym_inst_tyinst] = STATE(19294),
    [sym__idecl] = STATE(19294),
    [sym__funpat_infix] = STATE(20295),
    [sym__fun_name] = STATE(3345),
    [sym__funvar] = STATE(20301),
    [sym__funlhs] = STATE(15131),
    [sym_function] = STATE(19294),
    [sym_signature] = STATE(19294),
    [sym_splice] = STATE(13722),
    [sym_quasiquote] = STATE(13722),
    [sym__varid] = ACTIONS(83),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(4901),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4901),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(5033),
    [sym_implicit_parid] = ACTIONS(4907),
    [sym__conid] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(5740),
    [anon_sym__] = ACTIONS(4917),
    [anon_sym_newtype] = ACTIONS(5742),
    [anon_sym_data] = ACTIONS(5744),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
    [sym__strict] = ACTIONS(4923),
    [sym__lazy] = ACTIONS(4925),
  },
  [2216] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(2481),
    [sym_con_unit] = STATE(8844),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2574),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8841),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18636),
    [sym_lazy_type] = STATE(18636),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8830),
    [sym_type_unboxed_sum] = STATE(8830),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18636),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2873),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(16044),
    [sym_data_constructor_infix] = STATE(16044),
    [sym_data_constructor_record] = STATE(16044),
    [sym_data_constructor_special] = STATE(16044),
    [sym_constructors] = STATE(16046),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6114),
    [sym__conid] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2217] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2222),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym_type_parens] = STATE(2222),
    [sym_type_list] = STATE(2222),
    [sym_type_tuple] = STATE(2222),
    [sym__type_promotable_literal] = STATE(2222),
    [sym__type_promoted_literal] = STATE(2222),
    [sym__type_literal] = STATE(2222),
    [sym_type_name] = STATE(2222),
    [sym_type_star] = STATE(2222),
    [sym_type_unboxed_tuple] = STATE(2222),
    [sym_type_unboxed_sum] = STATE(2222),
    [sym__atype] = STATE(2222),
    [sym_type_invisible] = STATE(2222),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2222),
    [sym_quasiquote] = STATE(2222),
    [aux_sym_type_apply_repeat1] = STATE(2222),
    [sym__varid] = ACTIONS(6118),
    [sym_float] = ACTIONS(6120),
    [sym_char] = ACTIONS(6120),
    [sym_string] = ACTIONS(6120),
    [sym__integer_literal] = ACTIONS(6122),
    [sym__binary_literal] = ACTIONS(6124),
    [sym__octal_literal] = ACTIONS(6124),
    [sym__hex_literal] = ACTIONS(6124),
    [anon_sym_LPAREN_POUND] = ACTIONS(6126),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6126),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6128),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6130),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(6135),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_u2605] = ACTIONS(6138),
    [anon_sym_AT] = ACTIONS(6140),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(6142),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6144),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(6146),
  },
  [2218] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2218),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym_type_parens] = STATE(2218),
    [sym_type_list] = STATE(2218),
    [sym_type_tuple] = STATE(2218),
    [sym__type_promotable_literal] = STATE(2218),
    [sym__type_promoted_literal] = STATE(2218),
    [sym__type_literal] = STATE(2218),
    [sym_type_name] = STATE(2218),
    [sym_type_star] = STATE(2218),
    [sym_type_unboxed_tuple] = STATE(2218),
    [sym_type_unboxed_sum] = STATE(2218),
    [sym__atype] = STATE(2218),
    [sym_type_invisible] = STATE(2218),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2218),
    [sym_quasiquote] = STATE(2218),
    [aux_sym_type_apply_repeat1] = STATE(2218),
    [sym__varid] = ACTIONS(6148),
    [sym_float] = ACTIONS(6151),
    [sym_char] = ACTIONS(6151),
    [sym_string] = ACTIONS(6151),
    [sym__integer_literal] = ACTIONS(6154),
    [sym__binary_literal] = ACTIONS(6157),
    [sym__octal_literal] = ACTIONS(6157),
    [sym__hex_literal] = ACTIONS(6157),
    [anon_sym_LPAREN_POUND] = ACTIONS(6160),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6160),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6163),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(6169),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(6172),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6175),
    [anon_sym_u2605] = ACTIONS(6175),
    [anon_sym_AT] = ACTIONS(6178),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(6181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6184),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(6187),
  },
  [2219] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2082),
    [sym_constructor] = STATE(2413),
    [sym_con_unit] = STATE(8550),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2553),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8529),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18975),
    [sym_lazy_type] = STATE(18975),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8513),
    [sym_type_unboxed_sum] = STATE(8513),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18975),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2916),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(16115),
    [sym_data_constructor_infix] = STATE(16115),
    [sym_data_constructor_record] = STATE(16115),
    [sym_data_constructor_special] = STATE(16115),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6106),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6106),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6108),
    [sym__conid] = ACTIONS(6110),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2220] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2567),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(14348),
    [sym_lazy_type] = STATE(14348),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(14348),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2888),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_record_fields] = STATE(18706),
    [sym__gadt_fun] = STATE(20579),
    [sym__gadt_sig] = STATE(20579),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(6194),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6196),
    [sym__lazy] = ACTIONS(6198),
  },
  [2221] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(2481),
    [sym_con_unit] = STATE(8844),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2582),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8841),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18636),
    [sym_lazy_type] = STATE(18636),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8830),
    [sym_type_unboxed_sum] = STATE(8830),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18636),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2908),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(16342),
    [sym_data_constructor_infix] = STATE(16342),
    [sym_data_constructor_record] = STATE(16342),
    [sym_data_constructor_special] = STATE(16342),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6114),
    [sym__conid] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2222] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2218),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym_type_parens] = STATE(2218),
    [sym_type_list] = STATE(2218),
    [sym_type_tuple] = STATE(2218),
    [sym__type_promotable_literal] = STATE(2218),
    [sym__type_promoted_literal] = STATE(2218),
    [sym__type_literal] = STATE(2218),
    [sym_type_name] = STATE(2218),
    [sym_type_star] = STATE(2218),
    [sym_type_unboxed_tuple] = STATE(2218),
    [sym_type_unboxed_sum] = STATE(2218),
    [sym__atype] = STATE(2218),
    [sym_type_invisible] = STATE(2218),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2218),
    [sym_quasiquote] = STATE(2218),
    [aux_sym_type_apply_repeat1] = STATE(2218),
    [sym__varid] = ACTIONS(6118),
    [sym_float] = ACTIONS(6120),
    [sym_char] = ACTIONS(6120),
    [sym_string] = ACTIONS(6120),
    [sym__integer_literal] = ACTIONS(6122),
    [sym__binary_literal] = ACTIONS(6124),
    [sym__octal_literal] = ACTIONS(6124),
    [sym__hex_literal] = ACTIONS(6124),
    [anon_sym_LPAREN_POUND] = ACTIONS(6126),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6126),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6128),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6200),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(6203),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_u2605] = ACTIONS(6138),
    [anon_sym_AT] = ACTIONS(6140),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(6142),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6144),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(6146),
  },
  [2223] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2705),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16004),
    [sym_type_parens] = STATE(2705),
    [sym_type_list] = STATE(2705),
    [sym_type_tuple] = STATE(2705),
    [sym__type_promotable_literal] = STATE(2705),
    [sym__type_promoted_literal] = STATE(2705),
    [sym__type_literal] = STATE(2705),
    [sym_type_name] = STATE(2770),
    [sym_type_star] = STATE(2705),
    [sym_type_unboxed_tuple] = STATE(2705),
    [sym_type_unboxed_sum] = STATE(2705),
    [sym__atype] = STATE(2705),
    [sym_type_apply] = STATE(9045),
    [sym__btype] = STATE(9045),
    [sym_implicit_param] = STATE(14745),
    [sym_type_infix] = STATE(13986),
    [sym__type_infix] = STATE(13589),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(14745),
    [sym__type_context] = STATE(14745),
    [sym__type_fun] = STATE(14745),
    [sym__type] = STATE(14745),
    [sym__type_or_implicit] = STATE(14745),
    [sym__type_with_kind] = STATE(20780),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2705),
    [sym_quasiquote] = STATE(2705),
    [sym__varid] = ACTIONS(6206),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [sym_implicit_parid] = ACTIONS(6218),
    [sym__conid] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6224),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
    [sym__unboxed_close] = ACTIONS(6226),
  },
  [2224] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2551),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_strict_type] = STATE(14123),
    [sym_lazy_type] = STATE(14123),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(14123),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2883),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_record_fields] = STATE(19094),
    [sym__gadt_fun] = STATE(19089),
    [sym__gadt_sig] = STATE(19089),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6194),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
    [sym__strict] = ACTIONS(6262),
    [sym__lazy] = ACTIONS(6264),
  },
  [2225] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2228),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym_type_parens] = STATE(2228),
    [sym_type_list] = STATE(2228),
    [sym_type_tuple] = STATE(2228),
    [sym__type_promotable_literal] = STATE(2228),
    [sym__type_promoted_literal] = STATE(2228),
    [sym__type_literal] = STATE(2228),
    [sym_type_name] = STATE(2228),
    [sym_type_star] = STATE(2228),
    [sym_type_unboxed_tuple] = STATE(2228),
    [sym_type_unboxed_sum] = STATE(2228),
    [sym__atype] = STATE(2228),
    [sym_type_invisible] = STATE(2228),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2228),
    [sym_quasiquote] = STATE(2228),
    [aux_sym_type_apply_repeat1] = STATE(2228),
    [sym__varid] = ACTIONS(6266),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6268),
    [sym_char] = ACTIONS(6268),
    [sym_string] = ACTIONS(6268),
    [sym__integer_literal] = ACTIONS(6270),
    [sym__binary_literal] = ACTIONS(6272),
    [sym__octal_literal] = ACTIONS(6272),
    [sym__hex_literal] = ACTIONS(6272),
    [anon_sym_LPAREN_POUND] = ACTIONS(6274),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6274),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [anon_sym_SQUOTE] = ACTIONS(6283),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_u2605] = ACTIONS(6286),
    [anon_sym_AT] = ACTIONS(6288),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(6290),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6292),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6294),
  },
  [2226] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2093),
    [sym_constructor] = STATE(2411),
    [sym_con_unit] = STATE(8515),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16067),
    [sym_forall] = STATE(2573),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8488),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18721),
    [sym_lazy_type] = STATE(18721),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8494),
    [sym_type_unboxed_sum] = STATE(8494),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18721),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2900),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(16147),
    [sym_data_constructor_infix] = STATE(16147),
    [sym_data_constructor_record] = STATE(16147),
    [sym_data_constructor_special] = STATE(16147),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6094),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6094),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6096),
    [sym__conid] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2227] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2227),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym_type_parens] = STATE(2227),
    [sym_type_list] = STATE(2227),
    [sym_type_tuple] = STATE(2227),
    [sym__type_promotable_literal] = STATE(2227),
    [sym__type_promoted_literal] = STATE(2227),
    [sym__type_literal] = STATE(2227),
    [sym_type_name] = STATE(2227),
    [sym_type_star] = STATE(2227),
    [sym_type_unboxed_tuple] = STATE(2227),
    [sym_type_unboxed_sum] = STATE(2227),
    [sym__atype] = STATE(2227),
    [sym_type_invisible] = STATE(2227),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2227),
    [sym_quasiquote] = STATE(2227),
    [aux_sym_type_apply_repeat1] = STATE(2227),
    [sym__varid] = ACTIONS(6296),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(6299),
    [sym_char] = ACTIONS(6299),
    [sym_string] = ACTIONS(6299),
    [sym__integer_literal] = ACTIONS(6302),
    [sym__binary_literal] = ACTIONS(6305),
    [sym__octal_literal] = ACTIONS(6305),
    [sym__hex_literal] = ACTIONS(6305),
    [anon_sym_LPAREN_POUND] = ACTIONS(6308),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6308),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6311),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6317),
    [anon_sym_SQUOTE] = ACTIONS(6320),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6323),
    [anon_sym_u2605] = ACTIONS(6323),
    [anon_sym_AT] = ACTIONS(6326),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(6329),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(6332),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6335),
  },
  [2228] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2227),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym_type_parens] = STATE(2227),
    [sym_type_list] = STATE(2227),
    [sym_type_tuple] = STATE(2227),
    [sym__type_promotable_literal] = STATE(2227),
    [sym__type_promoted_literal] = STATE(2227),
    [sym__type_literal] = STATE(2227),
    [sym_type_name] = STATE(2227),
    [sym_type_star] = STATE(2227),
    [sym_type_unboxed_tuple] = STATE(2227),
    [sym_type_unboxed_sum] = STATE(2227),
    [sym__atype] = STATE(2227),
    [sym_type_invisible] = STATE(2227),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2227),
    [sym_quasiquote] = STATE(2227),
    [aux_sym_type_apply_repeat1] = STATE(2227),
    [sym__varid] = ACTIONS(6266),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6268),
    [sym_char] = ACTIONS(6268),
    [sym_string] = ACTIONS(6268),
    [sym__integer_literal] = ACTIONS(6270),
    [sym__binary_literal] = ACTIONS(6272),
    [sym__octal_literal] = ACTIONS(6272),
    [sym__hex_literal] = ACTIONS(6272),
    [anon_sym_LPAREN_POUND] = ACTIONS(6274),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6274),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [anon_sym_SQUOTE] = ACTIONS(6341),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_u2605] = ACTIONS(6286),
    [anon_sym_AT] = ACTIONS(6288),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(6290),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6292),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6294),
  },
  [2229] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19796),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2230] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19549),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4355),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2231] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19207),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2232] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19831),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3763),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2233] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19246),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1546),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2234] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2342),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym_type_parens] = STATE(2342),
    [sym_type_list] = STATE(2342),
    [sym_type_tuple] = STATE(2342),
    [sym__type_promotable_literal] = STATE(2342),
    [sym__type_promoted_literal] = STATE(2342),
    [sym__type_literal] = STATE(2342),
    [sym_type_name] = STATE(2342),
    [sym_type_star] = STATE(2342),
    [sym_type_unboxed_tuple] = STATE(2342),
    [sym_type_unboxed_sum] = STATE(2342),
    [sym__atype] = STATE(2342),
    [sym_type_invisible] = STATE(2342),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2342),
    [sym_quasiquote] = STATE(2342),
    [aux_sym_type_apply_repeat1] = STATE(2342),
    [sym__varid] = ACTIONS(6346),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6348),
    [sym_char] = ACTIONS(6348),
    [sym_string] = ACTIONS(6348),
    [sym__integer_literal] = ACTIONS(6350),
    [sym__binary_literal] = ACTIONS(6352),
    [sym__octal_literal] = ACTIONS(6352),
    [sym__hex_literal] = ACTIONS(6352),
    [anon_sym_LPAREN_POUND] = ACTIONS(6354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6354),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_SQUOTE] = ACTIONS(6363),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_u2605] = ACTIONS(6366),
    [anon_sym_AT] = ACTIONS(6368),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(6370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6372),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6374),
  },
  [2235] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19356),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2236] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19854),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3861),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2237] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20170),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2238] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18043),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4215),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2239] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19707),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2240] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19870),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2241] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19165),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4347),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2242] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17962),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2243] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19379),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2244] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18610),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2245] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18421),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2246] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19895),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3983),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2247] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18779),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2248] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19075),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2249] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18246),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2250] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18557),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2251] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19301),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2252] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19400),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2253] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17843),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2254] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19420),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3939),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2255] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19133),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2256] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2257),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym_type_parens] = STATE(2257),
    [sym_type_list] = STATE(2257),
    [sym_type_tuple] = STATE(2257),
    [sym__type_promotable_literal] = STATE(2257),
    [sym__type_promoted_literal] = STATE(2257),
    [sym__type_literal] = STATE(2257),
    [sym_type_name] = STATE(2257),
    [sym_type_star] = STATE(2257),
    [sym_type_unboxed_tuple] = STATE(2257),
    [sym_type_unboxed_sum] = STATE(2257),
    [sym__atype] = STATE(2257),
    [sym_type_invisible] = STATE(2257),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2257),
    [sym_quasiquote] = STATE(2257),
    [aux_sym_type_apply_repeat1] = STATE(2257),
    [sym__varid] = ACTIONS(6396),
    [sym_float] = ACTIONS(6398),
    [sym_char] = ACTIONS(6398),
    [sym_string] = ACTIONS(6398),
    [sym__integer_literal] = ACTIONS(6400),
    [sym__binary_literal] = ACTIONS(6402),
    [sym__octal_literal] = ACTIONS(6402),
    [sym__hex_literal] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND] = ACTIONS(6404),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6404),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6406),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6411),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(6413),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_u2605] = ACTIONS(6416),
    [anon_sym_AT] = ACTIONS(6418),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(6420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6422),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(6424),
  },
  [2257] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2281),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym_type_parens] = STATE(2281),
    [sym_type_list] = STATE(2281),
    [sym_type_tuple] = STATE(2281),
    [sym__type_promotable_literal] = STATE(2281),
    [sym__type_promoted_literal] = STATE(2281),
    [sym__type_literal] = STATE(2281),
    [sym_type_name] = STATE(2281),
    [sym_type_star] = STATE(2281),
    [sym_type_unboxed_tuple] = STATE(2281),
    [sym_type_unboxed_sum] = STATE(2281),
    [sym__atype] = STATE(2281),
    [sym_type_invisible] = STATE(2281),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2281),
    [sym_quasiquote] = STATE(2281),
    [aux_sym_type_apply_repeat1] = STATE(2281),
    [sym__varid] = ACTIONS(6396),
    [sym_float] = ACTIONS(6398),
    [sym_char] = ACTIONS(6398),
    [sym_string] = ACTIONS(6398),
    [sym__integer_literal] = ACTIONS(6400),
    [sym__binary_literal] = ACTIONS(6402),
    [sym__octal_literal] = ACTIONS(6402),
    [sym__hex_literal] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND] = ACTIONS(6404),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6404),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6406),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6411),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(6429),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_u2605] = ACTIONS(6416),
    [anon_sym_AT] = ACTIONS(6418),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(6420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6422),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(6424),
  },
  [2258] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19685),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2259] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19935),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2260] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19445),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2261] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2279),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym_type_parens] = STATE(2279),
    [sym_type_list] = STATE(2279),
    [sym_type_tuple] = STATE(2279),
    [sym__type_promotable_literal] = STATE(2279),
    [sym__type_promoted_literal] = STATE(2279),
    [sym__type_literal] = STATE(2279),
    [sym_type_name] = STATE(2279),
    [sym_type_star] = STATE(2279),
    [sym_type_unboxed_tuple] = STATE(2279),
    [sym_type_unboxed_sum] = STATE(2279),
    [sym__atype] = STATE(2279),
    [sym_type_invisible] = STATE(2279),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2279),
    [sym_quasiquote] = STATE(2279),
    [aux_sym_type_apply_repeat1] = STATE(2279),
    [sym__varid] = ACTIONS(6438),
    [sym_float] = ACTIONS(6440),
    [sym_char] = ACTIONS(6440),
    [sym_string] = ACTIONS(6440),
    [sym__integer_literal] = ACTIONS(6442),
    [sym__binary_literal] = ACTIONS(6444),
    [sym__octal_literal] = ACTIONS(6444),
    [sym__hex_literal] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND] = ACTIONS(6446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6446),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_u2605] = ACTIONS(6458),
    [anon_sym_AT] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_DOT_DOT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(6462),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6464),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(6466),
  },
  [2262] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17901),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2263] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19961),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4237),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2264] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19275),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4209),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2265] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17841),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2266] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18676),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2267] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19981),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2268] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19115),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2269] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19352),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2270] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18744),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2271] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20008),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4351),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2272] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19723),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2273] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20034),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2274] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18191),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2275] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18804),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2276] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19666),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2277] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18823),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2278] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19463),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2279] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2327),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym_type_parens] = STATE(2327),
    [sym_type_list] = STATE(2327),
    [sym_type_tuple] = STATE(2327),
    [sym__type_promotable_literal] = STATE(2327),
    [sym__type_promoted_literal] = STATE(2327),
    [sym__type_literal] = STATE(2327),
    [sym_type_name] = STATE(2327),
    [sym_type_star] = STATE(2327),
    [sym_type_unboxed_tuple] = STATE(2327),
    [sym_type_unboxed_sum] = STATE(2327),
    [sym__atype] = STATE(2327),
    [sym_type_invisible] = STATE(2327),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [aux_sym_type_apply_repeat1] = STATE(2327),
    [sym__varid] = ACTIONS(6438),
    [sym_float] = ACTIONS(6440),
    [sym_char] = ACTIONS(6440),
    [sym_string] = ACTIONS(6440),
    [sym__integer_literal] = ACTIONS(6442),
    [sym__binary_literal] = ACTIONS(6444),
    [sym__octal_literal] = ACTIONS(6444),
    [sym__hex_literal] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND] = ACTIONS(6446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6446),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(6485),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_u2605] = ACTIONS(6458),
    [anon_sym_AT] = ACTIONS(6460),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(6462),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6464),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(6466),
  },
  [2280] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19271),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2281] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2281),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym_type_parens] = STATE(2281),
    [sym_type_list] = STATE(2281),
    [sym_type_tuple] = STATE(2281),
    [sym__type_promotable_literal] = STATE(2281),
    [sym__type_promoted_literal] = STATE(2281),
    [sym__type_literal] = STATE(2281),
    [sym_type_name] = STATE(2281),
    [sym_type_star] = STATE(2281),
    [sym_type_unboxed_tuple] = STATE(2281),
    [sym_type_unboxed_sum] = STATE(2281),
    [sym__atype] = STATE(2281),
    [sym_type_invisible] = STATE(2281),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2281),
    [sym_quasiquote] = STATE(2281),
    [aux_sym_type_apply_repeat1] = STATE(2281),
    [sym__varid] = ACTIONS(6490),
    [sym_float] = ACTIONS(6493),
    [sym_char] = ACTIONS(6493),
    [sym_string] = ACTIONS(6493),
    [sym__integer_literal] = ACTIONS(6496),
    [sym__binary_literal] = ACTIONS(6499),
    [sym__octal_literal] = ACTIONS(6499),
    [sym__hex_literal] = ACTIONS(6499),
    [anon_sym_LPAREN_POUND] = ACTIONS(6502),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6502),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6505),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6508),
    [anon_sym_LBRACK] = ACTIONS(6511),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6517),
    [anon_sym_u2605] = ACTIONS(6517),
    [anon_sym_AT] = ACTIONS(6520),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(6523),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6526),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2282] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20055),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2283] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19915),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6532),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2284] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18840),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6534),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2285] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(17919),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6536),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2286] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20075),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6538),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2287] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19228),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6540),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2288] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20092),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2289] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19473),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2290] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20116),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2291] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19453),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2292] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20132),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2293] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20160),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1576),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2294] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19487),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2295] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19335),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2296] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20183),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2297] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2305),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym_type_parens] = STATE(2305),
    [sym_type_list] = STATE(2305),
    [sym_type_tuple] = STATE(2305),
    [sym__type_promotable_literal] = STATE(2305),
    [sym__type_promoted_literal] = STATE(2305),
    [sym__type_literal] = STATE(2305),
    [sym_type_name] = STATE(2305),
    [sym_type_star] = STATE(2305),
    [sym_type_unboxed_tuple] = STATE(2305),
    [sym_type_unboxed_sum] = STATE(2305),
    [sym__atype] = STATE(2305),
    [sym_type_invisible] = STATE(2305),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2305),
    [sym_quasiquote] = STATE(2305),
    [aux_sym_type_apply_repeat1] = STATE(2305),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(6550),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6552),
    [sym_char] = ACTIONS(6552),
    [sym_string] = ACTIONS(6552),
    [sym__integer_literal] = ACTIONS(6554),
    [sym__binary_literal] = ACTIONS(6556),
    [sym__octal_literal] = ACTIONS(6556),
    [sym__hex_literal] = ACTIONS(6556),
    [anon_sym_LPAREN_POUND] = ACTIONS(6558),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6558),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6565),
    [anon_sym_SQUOTE] = ACTIONS(6567),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6570),
    [anon_sym_u2605] = ACTIONS(6570),
    [anon_sym_AT] = ACTIONS(6572),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(6574),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6576),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6578),
  },
  [2298] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19383),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6580),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2299] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18492),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6582),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2300] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19816),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3677),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2301] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19093),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6584),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2302] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18025),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2303] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19648),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2304] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18857),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2305] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2382),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym_type_parens] = STATE(2382),
    [sym_type_list] = STATE(2382),
    [sym_type_tuple] = STATE(2382),
    [sym__type_promotable_literal] = STATE(2382),
    [sym__type_promoted_literal] = STATE(2382),
    [sym__type_literal] = STATE(2382),
    [sym_type_name] = STATE(2382),
    [sym_type_star] = STATE(2382),
    [sym_type_unboxed_tuple] = STATE(2382),
    [sym_type_unboxed_sum] = STATE(2382),
    [sym__atype] = STATE(2382),
    [sym_type_invisible] = STATE(2382),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2382),
    [sym_quasiquote] = STATE(2382),
    [aux_sym_type_apply_repeat1] = STATE(2382),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(6550),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6552),
    [sym_char] = ACTIONS(6552),
    [sym_string] = ACTIONS(6552),
    [sym__integer_literal] = ACTIONS(6554),
    [sym__binary_literal] = ACTIONS(6556),
    [sym__octal_literal] = ACTIONS(6556),
    [sym__hex_literal] = ACTIONS(6556),
    [anon_sym_LPAREN_POUND] = ACTIONS(6558),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6558),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6565),
    [anon_sym_SQUOTE] = ACTIONS(6593),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6570),
    [anon_sym_u2605] = ACTIONS(6570),
    [anon_sym_AT] = ACTIONS(6572),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(6574),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6576),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6578),
  },
  [2306] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20157),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2307] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2319),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_type_parens] = STATE(2319),
    [sym_type_list] = STATE(2319),
    [sym_type_tuple] = STATE(2319),
    [sym__type_promotable_literal] = STATE(2319),
    [sym__type_promoted_literal] = STATE(2319),
    [sym__type_literal] = STATE(2319),
    [sym_type_name] = STATE(2319),
    [sym_type_star] = STATE(2319),
    [sym_type_unboxed_tuple] = STATE(2319),
    [sym_type_unboxed_sum] = STATE(2319),
    [sym__atype] = STATE(2319),
    [sym_type_invisible] = STATE(2319),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2319),
    [sym_quasiquote] = STATE(2319),
    [aux_sym_type_apply_repeat1] = STATE(2319),
    [sym__varid] = ACTIONS(6598),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6600),
    [sym_char] = ACTIONS(6600),
    [sym_string] = ACTIONS(6600),
    [sym__integer_literal] = ACTIONS(6602),
    [sym__binary_literal] = ACTIONS(6604),
    [sym__octal_literal] = ACTIONS(6604),
    [sym__hex_literal] = ACTIONS(6604),
    [anon_sym_LPAREN_POUND] = ACTIONS(6606),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6606),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_SQUOTE] = ACTIONS(6615),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6618),
    [anon_sym_u2605] = ACTIONS(6618),
    [anon_sym_AT] = ACTIONS(6620),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(6622),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6624),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6626),
  },
  [2308] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19741),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2309] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2310] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2311] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19988),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6633),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2312] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19508),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2313] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19078),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6635),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2314] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20129),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2315] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19552),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2316] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19506),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2317] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18795),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2318] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19201),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2319] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2333),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_type_parens] = STATE(2333),
    [sym_type_list] = STATE(2333),
    [sym_type_tuple] = STATE(2333),
    [sym__type_promotable_literal] = STATE(2333),
    [sym__type_promoted_literal] = STATE(2333),
    [sym__type_literal] = STATE(2333),
    [sym_type_name] = STATE(2333),
    [sym_type_star] = STATE(2333),
    [sym_type_unboxed_tuple] = STATE(2333),
    [sym_type_unboxed_sum] = STATE(2333),
    [sym__atype] = STATE(2333),
    [sym_type_invisible] = STATE(2333),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2333),
    [sym_quasiquote] = STATE(2333),
    [aux_sym_type_apply_repeat1] = STATE(2333),
    [sym__varid] = ACTIONS(6598),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6600),
    [sym_char] = ACTIONS(6600),
    [sym_string] = ACTIONS(6600),
    [sym__integer_literal] = ACTIONS(6602),
    [sym__binary_literal] = ACTIONS(6604),
    [sym__octal_literal] = ACTIONS(6604),
    [sym__hex_literal] = ACTIONS(6604),
    [anon_sym_LPAREN_POUND] = ACTIONS(6606),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6606),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6637),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_SQUOTE] = ACTIONS(6640),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6618),
    [anon_sym_u2605] = ACTIONS(6618),
    [anon_sym_AT] = ACTIONS(6620),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(6622),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6624),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6626),
  },
  [2320] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20101),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2321] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18885),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2322] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20073),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2323] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19919),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4093),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2324] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19054),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6643),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2325] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20045),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6645),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2326] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18886),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2327] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2327),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym_type_parens] = STATE(2327),
    [sym_type_list] = STATE(2327),
    [sym_type_tuple] = STATE(2327),
    [sym__type_promotable_literal] = STATE(2327),
    [sym__type_promoted_literal] = STATE(2327),
    [sym__type_literal] = STATE(2327),
    [sym_type_name] = STATE(2327),
    [sym_type_star] = STATE(2327),
    [sym_type_unboxed_tuple] = STATE(2327),
    [sym_type_unboxed_sum] = STATE(2327),
    [sym__atype] = STATE(2327),
    [sym_type_invisible] = STATE(2327),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [aux_sym_type_apply_repeat1] = STATE(2327),
    [sym__varid] = ACTIONS(6647),
    [sym_float] = ACTIONS(6650),
    [sym_char] = ACTIONS(6650),
    [sym_string] = ACTIONS(6650),
    [sym__integer_literal] = ACTIONS(6653),
    [sym__binary_literal] = ACTIONS(6656),
    [sym__octal_literal] = ACTIONS(6656),
    [sym__hex_literal] = ACTIONS(6656),
    [anon_sym_LPAREN_POUND] = ACTIONS(6659),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6659),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6662),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6665),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(6671),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6674),
    [anon_sym_u2605] = ACTIONS(6674),
    [anon_sym_AT] = ACTIONS(6677),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(6680),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(6683),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(6686),
  },
  [2328] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(20017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2329] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18909),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2330] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18200),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2331] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19538),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6689),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2332] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18438),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2333] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2333),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_type_parens] = STATE(2333),
    [sym_type_list] = STATE(2333),
    [sym_type_tuple] = STATE(2333),
    [sym__type_promotable_literal] = STATE(2333),
    [sym__type_promoted_literal] = STATE(2333),
    [sym__type_literal] = STATE(2333),
    [sym_type_name] = STATE(2333),
    [sym_type_star] = STATE(2333),
    [sym_type_unboxed_tuple] = STATE(2333),
    [sym_type_unboxed_sum] = STATE(2333),
    [sym__atype] = STATE(2333),
    [sym_type_invisible] = STATE(2333),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2333),
    [sym_quasiquote] = STATE(2333),
    [aux_sym_type_apply_repeat1] = STATE(2333),
    [sym__varid] = ACTIONS(6691),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(6694),
    [sym_char] = ACTIONS(6694),
    [sym_string] = ACTIONS(6694),
    [sym__integer_literal] = ACTIONS(6697),
    [sym__binary_literal] = ACTIONS(6700),
    [sym__octal_literal] = ACTIONS(6700),
    [sym__hex_literal] = ACTIONS(6700),
    [anon_sym_LPAREN_POUND] = ACTIONS(6703),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6703),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6706),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6709),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_SQUOTE] = ACTIONS(6715),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6718),
    [anon_sym_u2605] = ACTIONS(6718),
    [anon_sym_AT] = ACTIONS(6721),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(6724),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(6727),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6730),
  },
  [2334] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18081),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2335] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18126),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2336] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2336),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym_type_parens] = STATE(2336),
    [sym_type_list] = STATE(2336),
    [sym_type_tuple] = STATE(2336),
    [sym__type_promotable_literal] = STATE(2336),
    [sym__type_promoted_literal] = STATE(2336),
    [sym__type_literal] = STATE(2336),
    [sym_type_name] = STATE(2336),
    [sym_type_star] = STATE(2336),
    [sym_type_unboxed_tuple] = STATE(2336),
    [sym_type_unboxed_sum] = STATE(2336),
    [sym__atype] = STATE(2336),
    [sym_type_invisible] = STATE(2336),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2336),
    [sym_quasiquote] = STATE(2336),
    [aux_sym_type_apply_repeat1] = STATE(2336),
    [sym__varid] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(6736),
    [sym_char] = ACTIONS(6736),
    [sym_string] = ACTIONS(6736),
    [sym__integer_literal] = ACTIONS(6739),
    [sym__binary_literal] = ACTIONS(6742),
    [sym__octal_literal] = ACTIONS(6742),
    [sym__hex_literal] = ACTIONS(6742),
    [anon_sym_LPAREN_POUND] = ACTIONS(6745),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6745),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6748),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6751),
    [anon_sym_LBRACK] = ACTIONS(6754),
    [anon_sym_SQUOTE] = ACTIONS(6757),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6760),
    [anon_sym_u2605] = ACTIONS(6760),
    [anon_sym_AT] = ACTIONS(6763),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(6766),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(6769),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6772),
  },
  [2337] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19030),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6775),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2338] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18324),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2339] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19568),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6777),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2340] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19152),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6779),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2341] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19974),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6781),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2342] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2336),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym_type_parens] = STATE(2336),
    [sym_type_list] = STATE(2336),
    [sym_type_tuple] = STATE(2336),
    [sym__type_promotable_literal] = STATE(2336),
    [sym__type_promoted_literal] = STATE(2336),
    [sym__type_literal] = STATE(2336),
    [sym_type_name] = STATE(2336),
    [sym_type_star] = STATE(2336),
    [sym_type_unboxed_tuple] = STATE(2336),
    [sym_type_unboxed_sum] = STATE(2336),
    [sym__atype] = STATE(2336),
    [sym_type_invisible] = STATE(2336),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2336),
    [sym_quasiquote] = STATE(2336),
    [aux_sym_type_apply_repeat1] = STATE(2336),
    [sym__varid] = ACTIONS(6346),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6348),
    [sym_char] = ACTIONS(6348),
    [sym_string] = ACTIONS(6348),
    [sym__integer_literal] = ACTIONS(6350),
    [sym__binary_literal] = ACTIONS(6352),
    [sym__octal_literal] = ACTIONS(6352),
    [sym__hex_literal] = ACTIONS(6352),
    [anon_sym_LPAREN_POUND] = ACTIONS(6354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6354),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_SQUOTE] = ACTIONS(6786),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_u2605] = ACTIONS(6366),
    [anon_sym_AT] = ACTIONS(6368),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(6370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6372),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6374),
  },
  [2343] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19760),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2344] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19958),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6789),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2345] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18914),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2346] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18165),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2347] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19797),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6791),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2348] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19252),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6793),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2349] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19598),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2350] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18319),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2351] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19630),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6795),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2352] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19530),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3461),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2353] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19928),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2354] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19189),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6797),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2355] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19001),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6799),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2356] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2385),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_type_parens] = STATE(2385),
    [sym_type_list] = STATE(2385),
    [sym_type_tuple] = STATE(2385),
    [sym__type_promotable_literal] = STATE(2385),
    [sym__type_promoted_literal] = STATE(2385),
    [sym__type_literal] = STATE(2385),
    [sym_type_name] = STATE(2385),
    [sym_type_star] = STATE(2385),
    [sym_type_unboxed_tuple] = STATE(2385),
    [sym_type_unboxed_sum] = STATE(2385),
    [sym__atype] = STATE(2385),
    [sym_type_invisible] = STATE(2385),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2385),
    [sym_quasiquote] = STATE(2385),
    [aux_sym_type_apply_repeat1] = STATE(2385),
    [sym__varid] = ACTIONS(6801),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6803),
    [sym_char] = ACTIONS(6803),
    [sym_string] = ACTIONS(6803),
    [sym__integer_literal] = ACTIONS(6805),
    [sym__binary_literal] = ACTIONS(6807),
    [sym__octal_literal] = ACTIONS(6807),
    [sym__hex_literal] = ACTIONS(6807),
    [anon_sym_LPAREN_POUND] = ACTIONS(6809),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6809),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6811),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_SQUOTE] = ACTIONS(6818),
    [anon_sym_STAR] = ACTIONS(6821),
    [anon_sym_u2605] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(6823),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(6825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6827),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6829),
  },
  [2357] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18878),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6831),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2358] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18522),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2359] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19898),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6833),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2360] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19628),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2361] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19658),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2362] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18943),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2363] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2364] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18353),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6835),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2365] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19688),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1506),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2366] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19610),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6837),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2367] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19718),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6839),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2368] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19748),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2369] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19778),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6841),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2370] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19781),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6843),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2371] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19588),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6845),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2372] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18968),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6847),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2373] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19033),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2374] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19808),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2375] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19322),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6849),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2376] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19625),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2377] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19838),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4245),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2378] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18640),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6851),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2379] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19571),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6853),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2380] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19043),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(1574),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2381] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2381),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_type_parens] = STATE(2381),
    [sym_type_list] = STATE(2381),
    [sym_type_tuple] = STATE(2381),
    [sym__type_promotable_literal] = STATE(2381),
    [sym__type_promoted_literal] = STATE(2381),
    [sym__type_literal] = STATE(2381),
    [sym_type_name] = STATE(2381),
    [sym_type_star] = STATE(2381),
    [sym_type_unboxed_tuple] = STATE(2381),
    [sym_type_unboxed_sum] = STATE(2381),
    [sym__atype] = STATE(2381),
    [sym_type_invisible] = STATE(2381),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2381),
    [sym_quasiquote] = STATE(2381),
    [aux_sym_type_apply_repeat1] = STATE(2381),
    [sym__varid] = ACTIONS(6855),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(6858),
    [sym_char] = ACTIONS(6858),
    [sym_string] = ACTIONS(6858),
    [sym__integer_literal] = ACTIONS(6861),
    [sym__binary_literal] = ACTIONS(6864),
    [sym__octal_literal] = ACTIONS(6864),
    [sym__hex_literal] = ACTIONS(6864),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6870),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6873),
    [anon_sym_LBRACK] = ACTIONS(6876),
    [anon_sym_SQUOTE] = ACTIONS(6879),
    [anon_sym_STAR] = ACTIONS(6882),
    [anon_sym_u2605] = ACTIONS(6882),
    [anon_sym_AT] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(6888),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(6891),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6894),
  },
  [2382] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2382),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym_type_parens] = STATE(2382),
    [sym_type_list] = STATE(2382),
    [sym_type_tuple] = STATE(2382),
    [sym__type_promotable_literal] = STATE(2382),
    [sym__type_promoted_literal] = STATE(2382),
    [sym__type_literal] = STATE(2382),
    [sym_type_name] = STATE(2382),
    [sym_type_star] = STATE(2382),
    [sym_type_unboxed_tuple] = STATE(2382),
    [sym_type_unboxed_sum] = STATE(2382),
    [sym__atype] = STATE(2382),
    [sym_type_invisible] = STATE(2382),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2382),
    [sym_quasiquote] = STATE(2382),
    [aux_sym_type_apply_repeat1] = STATE(2382),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(6897),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(6900),
    [sym_char] = ACTIONS(6900),
    [sym_string] = ACTIONS(6900),
    [sym__integer_literal] = ACTIONS(6903),
    [sym__binary_literal] = ACTIONS(6906),
    [sym__octal_literal] = ACTIONS(6906),
    [sym__hex_literal] = ACTIONS(6906),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(6912),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(6915),
    [anon_sym_LBRACK] = ACTIONS(6918),
    [anon_sym_SQUOTE] = ACTIONS(6921),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(6924),
    [anon_sym_u2605] = ACTIONS(6924),
    [anon_sym_AT] = ACTIONS(6927),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(6930),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(6933),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6936),
  },
  [2383] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19868),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(3903),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2384] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18978),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(4235),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2385] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2381),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_type_parens] = STATE(2381),
    [sym_type_list] = STATE(2381),
    [sym_type_tuple] = STATE(2381),
    [sym__type_promotable_literal] = STATE(2381),
    [sym__type_promoted_literal] = STATE(2381),
    [sym__type_literal] = STATE(2381),
    [sym_type_name] = STATE(2381),
    [sym_type_star] = STATE(2381),
    [sym_type_unboxed_tuple] = STATE(2381),
    [sym_type_unboxed_sum] = STATE(2381),
    [sym__atype] = STATE(2381),
    [sym_type_invisible] = STATE(2381),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2381),
    [sym_quasiquote] = STATE(2381),
    [aux_sym_type_apply_repeat1] = STATE(2381),
    [sym__varid] = ACTIONS(6801),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6803),
    [sym_char] = ACTIONS(6803),
    [sym_string] = ACTIONS(6803),
    [sym__integer_literal] = ACTIONS(6805),
    [sym__binary_literal] = ACTIONS(6807),
    [sym__octal_literal] = ACTIONS(6807),
    [sym__hex_literal] = ACTIONS(6807),
    [anon_sym_LPAREN_POUND] = ACTIONS(6809),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6809),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6811),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6939),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_SQUOTE] = ACTIONS(6942),
    [anon_sym_STAR] = ACTIONS(6821),
    [anon_sym_u2605] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(6823),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(6825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6827),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6829),
  },
  [2386] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(18237),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2387] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2393),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym_type_parens] = STATE(2393),
    [sym_type_list] = STATE(2393),
    [sym_type_tuple] = STATE(2393),
    [sym__type_promotable_literal] = STATE(2393),
    [sym__type_promoted_literal] = STATE(2393),
    [sym__type_literal] = STATE(2393),
    [sym_type_name] = STATE(2393),
    [sym_type_star] = STATE(2393),
    [sym_type_unboxed_tuple] = STATE(2393),
    [sym_type_unboxed_sum] = STATE(2393),
    [sym__atype] = STATE(2393),
    [sym_type_invisible] = STATE(2393),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2393),
    [sym_quasiquote] = STATE(2393),
    [aux_sym_type_apply_repeat1] = STATE(2393),
    [sym__varid] = ACTIONS(6947),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6949),
    [sym_char] = ACTIONS(6949),
    [sym_string] = ACTIONS(6949),
    [sym__integer_literal] = ACTIONS(6951),
    [sym__binary_literal] = ACTIONS(6953),
    [sym__octal_literal] = ACTIONS(6953),
    [sym__hex_literal] = ACTIONS(6953),
    [anon_sym_LPAREN_POUND] = ACTIONS(6955),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6955),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6957),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6959),
    [anon_sym_LBRACK] = ACTIONS(6962),
    [anon_sym_SQUOTE] = ACTIONS(6964),
    [anon_sym_STAR] = ACTIONS(6967),
    [anon_sym_u2605] = ACTIONS(6967),
    [anon_sym_AT] = ACTIONS(6969),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(6971),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6973),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6975),
  },
  [2388] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2412),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym_type_parens] = STATE(2412),
    [sym_type_list] = STATE(2412),
    [sym_type_tuple] = STATE(2412),
    [sym__type_promotable_literal] = STATE(2412),
    [sym__type_promoted_literal] = STATE(2412),
    [sym__type_literal] = STATE(2412),
    [sym_type_name] = STATE(2412),
    [sym_type_star] = STATE(2412),
    [sym_type_unboxed_tuple] = STATE(2412),
    [sym_type_unboxed_sum] = STATE(2412),
    [sym__atype] = STATE(2412),
    [sym_type_invisible] = STATE(2412),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2412),
    [sym_quasiquote] = STATE(2412),
    [aux_sym_type_apply_repeat1] = STATE(2412),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(6977),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6979),
    [sym_char] = ACTIONS(6979),
    [sym_string] = ACTIONS(6979),
    [sym__integer_literal] = ACTIONS(6981),
    [sym__binary_literal] = ACTIONS(6983),
    [sym__octal_literal] = ACTIONS(6983),
    [sym__hex_literal] = ACTIONS(6983),
    [anon_sym_LPAREN_POUND] = ACTIONS(6985),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6985),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(6987),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(6989),
    [anon_sym_LBRACK] = ACTIONS(6992),
    [anon_sym_SQUOTE] = ACTIONS(6994),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_u2605] = ACTIONS(6997),
    [anon_sym_AT] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7001),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7003),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7005),
  },
  [2389] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2392),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym_type_parens] = STATE(2392),
    [sym_type_list] = STATE(2392),
    [sym_type_tuple] = STATE(2392),
    [sym__type_promotable_literal] = STATE(2392),
    [sym__type_promoted_literal] = STATE(2392),
    [sym__type_literal] = STATE(2392),
    [sym_type_name] = STATE(2392),
    [sym_type_star] = STATE(2392),
    [sym_type_unboxed_tuple] = STATE(2392),
    [sym_type_unboxed_sum] = STATE(2392),
    [sym__atype] = STATE(2392),
    [sym_type_invisible] = STATE(2392),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2392),
    [sym_quasiquote] = STATE(2392),
    [aux_sym_type_apply_repeat1] = STATE(2392),
    [sym__varid] = ACTIONS(7007),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7017),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7019),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(7024),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_AT] = ACTIONS(7029),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2390] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2398),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym_type_parens] = STATE(2398),
    [sym_type_list] = STATE(2398),
    [sym_type_tuple] = STATE(2398),
    [sym__type_promotable_literal] = STATE(2398),
    [sym__type_promoted_literal] = STATE(2398),
    [sym__type_literal] = STATE(2398),
    [sym_type_name] = STATE(2398),
    [sym_type_star] = STATE(2398),
    [sym_type_unboxed_tuple] = STATE(2398),
    [sym_type_unboxed_sum] = STATE(2398),
    [sym__atype] = STATE(2398),
    [sym_type_invisible] = STATE(2398),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2398),
    [sym_quasiquote] = STATE(2398),
    [aux_sym_type_apply_repeat1] = STATE(2398),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(7037),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7039),
    [sym_char] = ACTIONS(7039),
    [sym_string] = ACTIONS(7039),
    [sym__integer_literal] = ACTIONS(7041),
    [sym__binary_literal] = ACTIONS(7043),
    [sym__octal_literal] = ACTIONS(7043),
    [sym__hex_literal] = ACTIONS(7043),
    [anon_sym_LPAREN_POUND] = ACTIONS(7045),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7045),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7049),
    [anon_sym_LBRACK] = ACTIONS(7052),
    [anon_sym_SQUOTE] = ACTIONS(7054),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_u2605] = ACTIONS(7057),
    [anon_sym_AT] = ACTIONS(7059),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(7061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7063),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7065),
  },
  [2391] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2408),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym_type_parens] = STATE(2408),
    [sym_type_list] = STATE(2408),
    [sym_type_tuple] = STATE(2408),
    [sym__type_promotable_literal] = STATE(2408),
    [sym__type_promoted_literal] = STATE(2408),
    [sym__type_literal] = STATE(2408),
    [sym_type_name] = STATE(2408),
    [sym_type_star] = STATE(2408),
    [sym_type_unboxed_tuple] = STATE(2408),
    [sym_type_unboxed_sum] = STATE(2408),
    [sym__atype] = STATE(2408),
    [sym_type_invisible] = STATE(2408),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2408),
    [sym_quasiquote] = STATE(2408),
    [aux_sym_type_apply_repeat1] = STATE(2408),
    [sym__varid] = ACTIONS(7067),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7069),
    [sym_char] = ACTIONS(7069),
    [sym_string] = ACTIONS(7069),
    [sym__integer_literal] = ACTIONS(7071),
    [sym__binary_literal] = ACTIONS(7073),
    [sym__octal_literal] = ACTIONS(7073),
    [sym__hex_literal] = ACTIONS(7073),
    [anon_sym_LPAREN_POUND] = ACTIONS(7075),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7075),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7077),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7079),
    [anon_sym_LBRACK] = ACTIONS(7082),
    [anon_sym_SQUOTE] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(7087),
    [anon_sym_u2605] = ACTIONS(7087),
    [anon_sym_AT] = ACTIONS(7089),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7093),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7095),
  },
  [2392] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2397),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym_type_parens] = STATE(2397),
    [sym_type_list] = STATE(2397),
    [sym_type_tuple] = STATE(2397),
    [sym__type_promotable_literal] = STATE(2397),
    [sym__type_promoted_literal] = STATE(2397),
    [sym__type_literal] = STATE(2397),
    [sym_type_name] = STATE(2397),
    [sym_type_star] = STATE(2397),
    [sym_type_unboxed_tuple] = STATE(2397),
    [sym_type_unboxed_sum] = STATE(2397),
    [sym__atype] = STATE(2397),
    [sym_type_invisible] = STATE(2397),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2397),
    [sym_quasiquote] = STATE(2397),
    [aux_sym_type_apply_repeat1] = STATE(2397),
    [sym__varid] = ACTIONS(7007),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7017),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7097),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(7100),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_AT] = ACTIONS(7029),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2393] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2393),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym_type_parens] = STATE(2393),
    [sym_type_list] = STATE(2393),
    [sym_type_tuple] = STATE(2393),
    [sym__type_promotable_literal] = STATE(2393),
    [sym__type_promoted_literal] = STATE(2393),
    [sym__type_literal] = STATE(2393),
    [sym_type_name] = STATE(2393),
    [sym_type_star] = STATE(2393),
    [sym_type_unboxed_tuple] = STATE(2393),
    [sym_type_unboxed_sum] = STATE(2393),
    [sym__atype] = STATE(2393),
    [sym_type_invisible] = STATE(2393),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2393),
    [sym_quasiquote] = STATE(2393),
    [aux_sym_type_apply_repeat1] = STATE(2393),
    [sym__varid] = ACTIONS(7103),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7106),
    [sym_char] = ACTIONS(7106),
    [sym_string] = ACTIONS(7106),
    [sym__integer_literal] = ACTIONS(7109),
    [sym__binary_literal] = ACTIONS(7112),
    [sym__octal_literal] = ACTIONS(7112),
    [sym__hex_literal] = ACTIONS(7112),
    [anon_sym_LPAREN_POUND] = ACTIONS(7115),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7115),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7118),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7121),
    [anon_sym_LBRACK] = ACTIONS(7124),
    [anon_sym_SQUOTE] = ACTIONS(7127),
    [anon_sym_STAR] = ACTIONS(7130),
    [anon_sym_u2605] = ACTIONS(7130),
    [anon_sym_AT] = ACTIONS(7133),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(7136),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7139),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7142),
  },
  [2394] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2394),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym_type_parens] = STATE(2394),
    [sym_type_list] = STATE(2394),
    [sym_type_tuple] = STATE(2394),
    [sym__type_promotable_literal] = STATE(2394),
    [sym__type_promoted_literal] = STATE(2394),
    [sym__type_literal] = STATE(2394),
    [sym_type_name] = STATE(2394),
    [sym_type_star] = STATE(2394),
    [sym_type_unboxed_tuple] = STATE(2394),
    [sym_type_unboxed_sum] = STATE(2394),
    [sym__atype] = STATE(2394),
    [sym_type_invisible] = STATE(2394),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2394),
    [sym_quasiquote] = STATE(2394),
    [aux_sym_type_apply_repeat1] = STATE(2394),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(7145),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7148),
    [sym_char] = ACTIONS(7148),
    [sym_string] = ACTIONS(7148),
    [sym__integer_literal] = ACTIONS(7151),
    [sym__binary_literal] = ACTIONS(7154),
    [sym__octal_literal] = ACTIONS(7154),
    [sym__hex_literal] = ACTIONS(7154),
    [anon_sym_LPAREN_POUND] = ACTIONS(7157),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7157),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7160),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7163),
    [anon_sym_LBRACK] = ACTIONS(7166),
    [anon_sym_SQUOTE] = ACTIONS(7169),
    [anon_sym_STAR] = ACTIONS(7172),
    [anon_sym_u2605] = ACTIONS(7172),
    [anon_sym_AT] = ACTIONS(7175),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(7178),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7181),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7184),
  },
  [2395] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2427),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym_type_parens] = STATE(2427),
    [sym_type_list] = STATE(2427),
    [sym_type_tuple] = STATE(2427),
    [sym__type_promotable_literal] = STATE(2427),
    [sym__type_promoted_literal] = STATE(2427),
    [sym__type_literal] = STATE(2427),
    [sym_type_name] = STATE(2427),
    [sym_type_star] = STATE(2427),
    [sym_type_unboxed_tuple] = STATE(2427),
    [sym_type_unboxed_sum] = STATE(2427),
    [sym__atype] = STATE(2427),
    [sym_type_invisible] = STATE(2427),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2427),
    [sym_quasiquote] = STATE(2427),
    [aux_sym_type_apply_repeat1] = STATE(2427),
    [sym__varid] = ACTIONS(7187),
    [sym_float] = ACTIONS(7189),
    [sym_char] = ACTIONS(7189),
    [sym_string] = ACTIONS(7189),
    [sym__integer_literal] = ACTIONS(7191),
    [sym__binary_literal] = ACTIONS(7193),
    [sym__octal_literal] = ACTIONS(7193),
    [sym__hex_literal] = ACTIONS(7193),
    [anon_sym_LPAREN_POUND] = ACTIONS(7195),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7195),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7199),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(7204),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_u2605] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(7209),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_DOT_DOT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7211),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7213),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(7215),
  },
  [2396] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2396),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym_type_parens] = STATE(2396),
    [sym_type_list] = STATE(2396),
    [sym_type_tuple] = STATE(2396),
    [sym__type_promotable_literal] = STATE(2396),
    [sym__type_promoted_literal] = STATE(2396),
    [sym__type_literal] = STATE(2396),
    [sym_type_name] = STATE(2396),
    [sym_type_star] = STATE(2396),
    [sym_type_unboxed_tuple] = STATE(2396),
    [sym_type_unboxed_sum] = STATE(2396),
    [sym__atype] = STATE(2396),
    [sym_type_invisible] = STATE(2396),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2396),
    [sym_quasiquote] = STATE(2396),
    [aux_sym_type_apply_repeat1] = STATE(2396),
    [sym__varid] = ACTIONS(7217),
    [sym_float] = ACTIONS(7220),
    [sym_char] = ACTIONS(7220),
    [sym_string] = ACTIONS(7220),
    [sym__integer_literal] = ACTIONS(7223),
    [sym__binary_literal] = ACTIONS(7226),
    [sym__octal_literal] = ACTIONS(7226),
    [sym__hex_literal] = ACTIONS(7226),
    [anon_sym_LPAREN_POUND] = ACTIONS(7229),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7229),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7232),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7235),
    [anon_sym_LBRACK] = ACTIONS(7238),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(7241),
    [anon_sym_STAR] = ACTIONS(7244),
    [anon_sym_u2605] = ACTIONS(7244),
    [anon_sym_AT] = ACTIONS(7247),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(7250),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(7256),
  },
  [2397] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2397),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym_type_parens] = STATE(2397),
    [sym_type_list] = STATE(2397),
    [sym_type_tuple] = STATE(2397),
    [sym__type_promotable_literal] = STATE(2397),
    [sym__type_promoted_literal] = STATE(2397),
    [sym__type_literal] = STATE(2397),
    [sym_type_name] = STATE(2397),
    [sym_type_star] = STATE(2397),
    [sym_type_unboxed_tuple] = STATE(2397),
    [sym_type_unboxed_sum] = STATE(2397),
    [sym__atype] = STATE(2397),
    [sym_type_invisible] = STATE(2397),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2397),
    [sym_quasiquote] = STATE(2397),
    [aux_sym_type_apply_repeat1] = STATE(2397),
    [sym__varid] = ACTIONS(7259),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7262),
    [sym_char] = ACTIONS(7262),
    [sym_string] = ACTIONS(7262),
    [sym__integer_literal] = ACTIONS(7265),
    [sym__binary_literal] = ACTIONS(7268),
    [sym__octal_literal] = ACTIONS(7268),
    [sym__hex_literal] = ACTIONS(7268),
    [anon_sym_LPAREN_POUND] = ACTIONS(7271),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7271),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7274),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7277),
    [anon_sym_LBRACK] = ACTIONS(7280),
    [anon_sym_SQUOTE] = ACTIONS(7283),
    [anon_sym_STAR] = ACTIONS(7286),
    [anon_sym_u2605] = ACTIONS(7286),
    [anon_sym_AT] = ACTIONS(7289),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(7292),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7295),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7298),
  },
  [2398] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2394),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym_type_parens] = STATE(2394),
    [sym_type_list] = STATE(2394),
    [sym_type_tuple] = STATE(2394),
    [sym__type_promotable_literal] = STATE(2394),
    [sym__type_promoted_literal] = STATE(2394),
    [sym__type_literal] = STATE(2394),
    [sym_type_name] = STATE(2394),
    [sym_type_star] = STATE(2394),
    [sym_type_unboxed_tuple] = STATE(2394),
    [sym_type_unboxed_sum] = STATE(2394),
    [sym__atype] = STATE(2394),
    [sym_type_invisible] = STATE(2394),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2394),
    [sym_quasiquote] = STATE(2394),
    [aux_sym_type_apply_repeat1] = STATE(2394),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(7037),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7039),
    [sym_char] = ACTIONS(7039),
    [sym_string] = ACTIONS(7039),
    [sym__integer_literal] = ACTIONS(7041),
    [sym__binary_literal] = ACTIONS(7043),
    [sym__octal_literal] = ACTIONS(7043),
    [sym__hex_literal] = ACTIONS(7043),
    [anon_sym_LPAREN_POUND] = ACTIONS(7045),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7045),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7047),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7301),
    [anon_sym_LBRACK] = ACTIONS(7052),
    [anon_sym_SQUOTE] = ACTIONS(7304),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_u2605] = ACTIONS(7057),
    [anon_sym_AT] = ACTIONS(7059),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(7061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7063),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7065),
  },
  [2399] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2422),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym_type_parens] = STATE(2422),
    [sym_type_list] = STATE(2422),
    [sym_type_tuple] = STATE(2422),
    [sym__type_promotable_literal] = STATE(2422),
    [sym__type_promoted_literal] = STATE(2422),
    [sym__type_literal] = STATE(2422),
    [sym_type_name] = STATE(2422),
    [sym_type_star] = STATE(2422),
    [sym_type_unboxed_tuple] = STATE(2422),
    [sym_type_unboxed_sum] = STATE(2422),
    [sym__atype] = STATE(2422),
    [sym_type_invisible] = STATE(2422),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2422),
    [sym_quasiquote] = STATE(2422),
    [aux_sym_type_apply_repeat1] = STATE(2422),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(7307),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7309),
    [sym_char] = ACTIONS(7309),
    [sym_string] = ACTIONS(7309),
    [sym__integer_literal] = ACTIONS(7311),
    [sym__binary_literal] = ACTIONS(7313),
    [sym__octal_literal] = ACTIONS(7313),
    [sym__hex_literal] = ACTIONS(7313),
    [anon_sym_LPAREN_POUND] = ACTIONS(7315),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7315),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7317),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7319),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7324),
    [anon_sym_STAR] = ACTIONS(7327),
    [anon_sym_u2605] = ACTIONS(7327),
    [anon_sym_AT] = ACTIONS(7329),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7333),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7335),
  },
  [2400] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2402),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym_type_parens] = STATE(2402),
    [sym_type_list] = STATE(2402),
    [sym_type_tuple] = STATE(2402),
    [sym__type_promotable_literal] = STATE(2402),
    [sym__type_promoted_literal] = STATE(2402),
    [sym__type_literal] = STATE(2402),
    [sym_type_name] = STATE(2402),
    [sym_type_star] = STATE(2402),
    [sym_type_unboxed_tuple] = STATE(2402),
    [sym_type_unboxed_sum] = STATE(2402),
    [sym__atype] = STATE(2402),
    [sym_type_invisible] = STATE(2402),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2402),
    [sym_quasiquote] = STATE(2402),
    [aux_sym_type_apply_repeat1] = STATE(2402),
    [sym__varid] = ACTIONS(7337),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7339),
    [sym_char] = ACTIONS(7339),
    [sym_string] = ACTIONS(7339),
    [sym__integer_literal] = ACTIONS(7341),
    [sym__binary_literal] = ACTIONS(7343),
    [sym__octal_literal] = ACTIONS(7343),
    [sym__hex_literal] = ACTIONS(7343),
    [anon_sym_LPAREN_POUND] = ACTIONS(7345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7345),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7347),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7349),
    [anon_sym_LBRACK] = ACTIONS(7352),
    [anon_sym_SQUOTE] = ACTIONS(7354),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(7357),
    [anon_sym_u2605] = ACTIONS(7357),
    [anon_sym_AT] = ACTIONS(7359),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7363),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7365),
  },
  [2401] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2387),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym_type_parens] = STATE(2387),
    [sym_type_list] = STATE(2387),
    [sym_type_tuple] = STATE(2387),
    [sym__type_promotable_literal] = STATE(2387),
    [sym__type_promoted_literal] = STATE(2387),
    [sym__type_literal] = STATE(2387),
    [sym_type_name] = STATE(2387),
    [sym_type_star] = STATE(2387),
    [sym_type_unboxed_tuple] = STATE(2387),
    [sym_type_unboxed_sum] = STATE(2387),
    [sym__atype] = STATE(2387),
    [sym_type_invisible] = STATE(2387),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2387),
    [sym_quasiquote] = STATE(2387),
    [aux_sym_type_apply_repeat1] = STATE(2387),
    [sym__varid] = ACTIONS(6947),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6949),
    [sym_char] = ACTIONS(6949),
    [sym_string] = ACTIONS(6949),
    [sym__integer_literal] = ACTIONS(6951),
    [sym__binary_literal] = ACTIONS(6953),
    [sym__octal_literal] = ACTIONS(6953),
    [sym__hex_literal] = ACTIONS(6953),
    [anon_sym_LPAREN_POUND] = ACTIONS(6955),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6955),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6957),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7367),
    [anon_sym_LBRACK] = ACTIONS(6962),
    [anon_sym_SQUOTE] = ACTIONS(7370),
    [anon_sym_STAR] = ACTIONS(6967),
    [anon_sym_u2605] = ACTIONS(6967),
    [anon_sym_AT] = ACTIONS(6969),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(6971),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6973),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6975),
  },
  [2402] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2402),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym_type_parens] = STATE(2402),
    [sym_type_list] = STATE(2402),
    [sym_type_tuple] = STATE(2402),
    [sym__type_promotable_literal] = STATE(2402),
    [sym__type_promoted_literal] = STATE(2402),
    [sym__type_literal] = STATE(2402),
    [sym_type_name] = STATE(2402),
    [sym_type_star] = STATE(2402),
    [sym_type_unboxed_tuple] = STATE(2402),
    [sym_type_unboxed_sum] = STATE(2402),
    [sym__atype] = STATE(2402),
    [sym_type_invisible] = STATE(2402),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2402),
    [sym_quasiquote] = STATE(2402),
    [aux_sym_type_apply_repeat1] = STATE(2402),
    [sym__varid] = ACTIONS(7373),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7376),
    [sym_char] = ACTIONS(7376),
    [sym_string] = ACTIONS(7376),
    [sym__integer_literal] = ACTIONS(7379),
    [sym__binary_literal] = ACTIONS(7382),
    [sym__octal_literal] = ACTIONS(7382),
    [sym__hex_literal] = ACTIONS(7382),
    [anon_sym_LPAREN_POUND] = ACTIONS(7385),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7385),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7388),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7391),
    [anon_sym_LBRACK] = ACTIONS(7394),
    [anon_sym_SQUOTE] = ACTIONS(7397),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(7400),
    [anon_sym_u2605] = ACTIONS(7400),
    [anon_sym_AT] = ACTIONS(7403),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(7406),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7409),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7412),
  },
  [2403] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2604),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15898),
    [sym_type_parens] = STATE(2604),
    [sym_type_list] = STATE(2604),
    [sym_type_tuple] = STATE(2604),
    [sym__type_promotable_literal] = STATE(2604),
    [sym__type_promoted_literal] = STATE(2604),
    [sym__type_literal] = STATE(2604),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2604),
    [sym_type_unboxed_tuple] = STATE(2604),
    [sym_type_unboxed_sum] = STATE(2604),
    [sym__atype] = STATE(2604),
    [sym_type_apply] = STATE(8941),
    [sym__btype] = STATE(8941),
    [sym_implicit_param] = STATE(14708),
    [sym_type_infix] = STATE(14016),
    [sym__type_infix] = STATE(13635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2717),
    [sym__type_quantifiers] = STATE(14708),
    [sym__type_context] = STATE(14708),
    [sym__type_fun] = STATE(14708),
    [sym__type] = STATE(14708),
    [sym__type_or_implicit] = STATE(14708),
    [sym__type_with_kind] = STATE(20325),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2604),
    [sym_quasiquote] = STATE(2604),
    [sym__varid] = ACTIONS(7415),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7425),
    [sym_implicit_parid] = ACTIONS(7427),
    [sym__conid] = ACTIONS(7429),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(7433),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7441),
  },
  [2404] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2415),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym_type_parens] = STATE(2415),
    [sym_type_list] = STATE(2415),
    [sym_type_tuple] = STATE(2415),
    [sym__type_promotable_literal] = STATE(2415),
    [sym__type_promoted_literal] = STATE(2415),
    [sym__type_literal] = STATE(2415),
    [sym_type_name] = STATE(2415),
    [sym_type_star] = STATE(2415),
    [sym_type_unboxed_tuple] = STATE(2415),
    [sym_type_unboxed_sum] = STATE(2415),
    [sym__atype] = STATE(2415),
    [sym_type_invisible] = STATE(2415),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2415),
    [sym_quasiquote] = STATE(2415),
    [aux_sym_type_apply_repeat1] = STATE(2415),
    [sym__varid] = ACTIONS(7443),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7445),
    [sym_char] = ACTIONS(7445),
    [sym_string] = ACTIONS(7445),
    [sym__integer_literal] = ACTIONS(7447),
    [sym__binary_literal] = ACTIONS(7449),
    [sym__octal_literal] = ACTIONS(7449),
    [sym__hex_literal] = ACTIONS(7449),
    [anon_sym_LPAREN_POUND] = ACTIONS(7451),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7451),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7453),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7455),
    [anon_sym_LBRACK] = ACTIONS(7458),
    [anon_sym_SQUOTE] = ACTIONS(7460),
    [anon_sym_STAR] = ACTIONS(7463),
    [anon_sym_u2605] = ACTIONS(7463),
    [anon_sym_AT] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(7467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7469),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7471),
  },
  [2405] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2399),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym_type_parens] = STATE(2399),
    [sym_type_list] = STATE(2399),
    [sym_type_tuple] = STATE(2399),
    [sym__type_promotable_literal] = STATE(2399),
    [sym__type_promoted_literal] = STATE(2399),
    [sym__type_literal] = STATE(2399),
    [sym_type_name] = STATE(2399),
    [sym_type_star] = STATE(2399),
    [sym_type_unboxed_tuple] = STATE(2399),
    [sym_type_unboxed_sum] = STATE(2399),
    [sym__atype] = STATE(2399),
    [sym_type_invisible] = STATE(2399),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2399),
    [sym_quasiquote] = STATE(2399),
    [aux_sym_type_apply_repeat1] = STATE(2399),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(7307),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7309),
    [sym_char] = ACTIONS(7309),
    [sym_string] = ACTIONS(7309),
    [sym__integer_literal] = ACTIONS(7311),
    [sym__binary_literal] = ACTIONS(7313),
    [sym__octal_literal] = ACTIONS(7313),
    [sym__hex_literal] = ACTIONS(7313),
    [anon_sym_LPAREN_POUND] = ACTIONS(7315),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7315),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7317),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7473),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7476),
    [anon_sym_STAR] = ACTIONS(7327),
    [anon_sym_u2605] = ACTIONS(7327),
    [anon_sym_AT] = ACTIONS(7329),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7333),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7335),
  },
  [2406] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DOT_DOT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2407] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14444),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14444),
    [sym__type_context] = STATE(14444),
    [sym__type_fun] = STATE(14444),
    [sym__type] = STATE(14444),
    [sym__type_or_implicit] = STATE(14444),
    [sym__type_with_kind] = STATE(19349),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2408] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2425),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym_type_parens] = STATE(2425),
    [sym_type_list] = STATE(2425),
    [sym_type_tuple] = STATE(2425),
    [sym__type_promotable_literal] = STATE(2425),
    [sym__type_promoted_literal] = STATE(2425),
    [sym__type_literal] = STATE(2425),
    [sym_type_name] = STATE(2425),
    [sym_type_star] = STATE(2425),
    [sym_type_unboxed_tuple] = STATE(2425),
    [sym_type_unboxed_sum] = STATE(2425),
    [sym__atype] = STATE(2425),
    [sym_type_invisible] = STATE(2425),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2425),
    [sym_quasiquote] = STATE(2425),
    [aux_sym_type_apply_repeat1] = STATE(2425),
    [sym__varid] = ACTIONS(7067),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7069),
    [sym_char] = ACTIONS(7069),
    [sym_string] = ACTIONS(7069),
    [sym__integer_literal] = ACTIONS(7071),
    [sym__binary_literal] = ACTIONS(7073),
    [sym__octal_literal] = ACTIONS(7073),
    [sym__hex_literal] = ACTIONS(7073),
    [anon_sym_LPAREN_POUND] = ACTIONS(7075),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7075),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7077),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7479),
    [anon_sym_LBRACK] = ACTIONS(7082),
    [anon_sym_SQUOTE] = ACTIONS(7482),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(7087),
    [anon_sym_u2605] = ACTIONS(7087),
    [anon_sym_AT] = ACTIONS(7089),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7093),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7095),
  },
  [2409] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(22075),
    [sym_lazy_type] = STATE(22075),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(22075),
    [sym__type_context] = STATE(22075),
    [sym__type_fun] = STATE(22075),
    [sym__type] = STATE(22075),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6196),
    [sym__lazy] = ACTIONS(6198),
  },
  [2410] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_strict_type] = STATE(20729),
    [sym_lazy_type] = STATE(20729),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(20729),
    [sym__type_context] = STATE(20729),
    [sym__type_fun] = STATE(20729),
    [sym__type] = STATE(20729),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
    [sym__strict] = ACTIONS(7485),
    [sym__lazy] = ACTIONS(7487),
  },
  [2411] = {
    [sym_integer] = STATE(9037),
    [sym__literal] = STATE(9037),
    [sym__unboxed_open] = STATE(2092),
    [sym_constructor] = STATE(8742),
    [sym_con_unit] = STATE(9037),
    [sym_con_list] = STATE(9037),
    [sym_con_tuple] = STATE(9037),
    [sym_qualified_type] = STATE(9038),
    [sym_tycon_arrow] = STATE(9038),
    [sym_type_literal] = STATE(3127),
    [sym__promoted_tycon] = STATE(9038),
    [sym_type_variable] = STATE(9038),
    [sym_type_parens] = STATE(3127),
    [sym_type_list] = STATE(3127),
    [sym_type_tuple] = STATE(3127),
    [sym__type_promotable_literal] = STATE(3127),
    [sym__type_promoted_literal] = STATE(3127),
    [sym__type_literal] = STATE(3127),
    [sym_strict_type] = STATE(3127),
    [sym_lazy_type] = STATE(3127),
    [sym_type_name] = STATE(3127),
    [sym_type_star] = STATE(3127),
    [sym_type_unboxed_tuple] = STATE(3127),
    [sym_type_unboxed_sum] = STATE(3127),
    [sym__atype] = STATE(3127),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17545),
    [sym_record_fields] = STATE(15763),
    [sym_splice] = STATE(3127),
    [sym_quasiquote] = STATE(3127),
    [aux_sym_data_constructor_repeat1] = STATE(3127),
    [sym__varid] = ACTIONS(7489),
    [anon_sym_SEMI] = ACTIONS(7492),
    [sym_float] = ACTIONS(7494),
    [sym_char] = ACTIONS(7494),
    [sym_string] = ACTIONS(7494),
    [sym__integer_literal] = ACTIONS(7497),
    [sym__binary_literal] = ACTIONS(7500),
    [sym__octal_literal] = ACTIONS(7500),
    [sym__hex_literal] = ACTIONS(7500),
    [anon_sym_LPAREN_POUND] = ACTIONS(7503),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7503),
    [anon_sym_u21d2] = ACTIONS(7506),
    [anon_sym_EQ_GT] = ACTIONS(7506),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7508),
    [anon_sym_BQUOTE] = ACTIONS(7506),
    [sym__conid] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7514),
    [anon_sym_SQUOTE] = ACTIONS(7517),
    [anon_sym_LBRACE] = ACTIONS(7520),
    [anon_sym_PIPE] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7522),
    [anon_sym_u2605] = ACTIONS(7522),
    [anon_sym_AT] = ACTIONS(7506),
    [anon_sym_deriving] = ACTIONS(7525),
    [anon_sym_u27e6] = ACTIONS(7527),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(7492),
    [sym__layout_end] = ACTIONS(7492),
    [sym__dot] = ACTIONS(7530),
    [sym__splice_dollar] = ACTIONS(7532),
    [sym__consym] = ACTIONS(7506),
    [sym__tyconsym] = ACTIONS(7506),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7535),
    [sym__strict] = ACTIONS(7538),
    [sym__lazy] = ACTIONS(7540),
  },
  [2412] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2412),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym_type_parens] = STATE(2412),
    [sym_type_list] = STATE(2412),
    [sym_type_tuple] = STATE(2412),
    [sym__type_promotable_literal] = STATE(2412),
    [sym__type_promoted_literal] = STATE(2412),
    [sym__type_literal] = STATE(2412),
    [sym_type_name] = STATE(2412),
    [sym_type_star] = STATE(2412),
    [sym_type_unboxed_tuple] = STATE(2412),
    [sym_type_unboxed_sum] = STATE(2412),
    [sym__atype] = STATE(2412),
    [sym_type_invisible] = STATE(2412),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2412),
    [sym_quasiquote] = STATE(2412),
    [aux_sym_type_apply_repeat1] = STATE(2412),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(7542),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7545),
    [sym_char] = ACTIONS(7545),
    [sym_string] = ACTIONS(7545),
    [sym__integer_literal] = ACTIONS(7548),
    [sym__binary_literal] = ACTIONS(7551),
    [sym__octal_literal] = ACTIONS(7551),
    [sym__hex_literal] = ACTIONS(7551),
    [anon_sym_LPAREN_POUND] = ACTIONS(7554),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7554),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7557),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7563),
    [anon_sym_SQUOTE] = ACTIONS(7566),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(7569),
    [anon_sym_u2605] = ACTIONS(7569),
    [anon_sym_AT] = ACTIONS(7572),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(7575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7578),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7581),
  },
  [2413] = {
    [sym_integer] = STATE(9056),
    [sym__literal] = STATE(9056),
    [sym__unboxed_open] = STATE(2077),
    [sym_constructor] = STATE(8749),
    [sym_con_unit] = STATE(9056),
    [sym_con_list] = STATE(9056),
    [sym_con_tuple] = STATE(9056),
    [sym_qualified_type] = STATE(9055),
    [sym_tycon_arrow] = STATE(9055),
    [sym_type_literal] = STATE(3114),
    [sym__promoted_tycon] = STATE(9055),
    [sym_type_variable] = STATE(9055),
    [sym_type_parens] = STATE(3114),
    [sym_type_list] = STATE(3114),
    [sym_type_tuple] = STATE(3114),
    [sym__type_promotable_literal] = STATE(3114),
    [sym__type_promoted_literal] = STATE(3114),
    [sym__type_literal] = STATE(3114),
    [sym_strict_type] = STATE(3114),
    [sym_lazy_type] = STATE(3114),
    [sym_type_name] = STATE(3114),
    [sym_type_star] = STATE(3114),
    [sym_type_unboxed_tuple] = STATE(3114),
    [sym_type_unboxed_sum] = STATE(3114),
    [sym__atype] = STATE(3114),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16483),
    [sym_record_fields] = STATE(15707),
    [sym_splice] = STATE(3114),
    [sym_quasiquote] = STATE(3114),
    [aux_sym_data_constructor_repeat1] = STATE(3114),
    [ts_builtin_sym_end] = ACTIONS(7492),
    [sym__varid] = ACTIONS(7584),
    [anon_sym_SEMI] = ACTIONS(7492),
    [sym_float] = ACTIONS(7587),
    [sym_char] = ACTIONS(7587),
    [sym_string] = ACTIONS(7587),
    [sym__integer_literal] = ACTIONS(7590),
    [sym__binary_literal] = ACTIONS(7593),
    [sym__octal_literal] = ACTIONS(7593),
    [sym__hex_literal] = ACTIONS(7593),
    [anon_sym_LPAREN_POUND] = ACTIONS(7596),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7596),
    [anon_sym_u21d2] = ACTIONS(7506),
    [anon_sym_EQ_GT] = ACTIONS(7506),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7599),
    [anon_sym_BQUOTE] = ACTIONS(7506),
    [sym__conid] = ACTIONS(7602),
    [anon_sym_LBRACK] = ACTIONS(7605),
    [anon_sym_SQUOTE] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7611),
    [anon_sym_PIPE] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7613),
    [anon_sym_u2605] = ACTIONS(7613),
    [anon_sym_AT] = ACTIONS(7506),
    [anon_sym_deriving] = ACTIONS(7525),
    [anon_sym_u27e6] = ACTIONS(7616),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(7492),
    [sym__dot] = ACTIONS(7530),
    [sym__splice_dollar] = ACTIONS(7619),
    [sym__consym] = ACTIONS(7506),
    [sym__tyconsym] = ACTIONS(7506),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7622),
    [sym__strict] = ACTIONS(7625),
    [sym__lazy] = ACTIONS(7627),
  },
  [2414] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2415] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2421),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym_type_parens] = STATE(2421),
    [sym_type_list] = STATE(2421),
    [sym_type_tuple] = STATE(2421),
    [sym__type_promotable_literal] = STATE(2421),
    [sym__type_promoted_literal] = STATE(2421),
    [sym__type_literal] = STATE(2421),
    [sym_type_name] = STATE(2421),
    [sym_type_star] = STATE(2421),
    [sym_type_unboxed_tuple] = STATE(2421),
    [sym_type_unboxed_sum] = STATE(2421),
    [sym__atype] = STATE(2421),
    [sym_type_invisible] = STATE(2421),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2421),
    [sym_quasiquote] = STATE(2421),
    [aux_sym_type_apply_repeat1] = STATE(2421),
    [sym__varid] = ACTIONS(7443),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7445),
    [sym_char] = ACTIONS(7445),
    [sym_string] = ACTIONS(7445),
    [sym__integer_literal] = ACTIONS(7447),
    [sym__binary_literal] = ACTIONS(7449),
    [sym__octal_literal] = ACTIONS(7449),
    [sym__hex_literal] = ACTIONS(7449),
    [anon_sym_LPAREN_POUND] = ACTIONS(7451),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7451),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7453),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7629),
    [anon_sym_LBRACK] = ACTIONS(7458),
    [anon_sym_SQUOTE] = ACTIONS(7632),
    [anon_sym_STAR] = ACTIONS(7463),
    [anon_sym_u2605] = ACTIONS(7463),
    [anon_sym_AT] = ACTIONS(7465),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(7467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7469),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7471),
  },
  [2416] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_strict_type] = STATE(20673),
    [sym_lazy_type] = STATE(20673),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(20673),
    [sym__type_context] = STATE(20673),
    [sym__type_fun] = STATE(20673),
    [sym__type] = STATE(20673),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
    [sym__strict] = ACTIONS(7485),
    [sym__lazy] = ACTIONS(7487),
  },
  [2417] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2400),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym_type_parens] = STATE(2400),
    [sym_type_list] = STATE(2400),
    [sym_type_tuple] = STATE(2400),
    [sym__type_promotable_literal] = STATE(2400),
    [sym__type_promoted_literal] = STATE(2400),
    [sym__type_literal] = STATE(2400),
    [sym_type_name] = STATE(2400),
    [sym_type_star] = STATE(2400),
    [sym_type_unboxed_tuple] = STATE(2400),
    [sym_type_unboxed_sum] = STATE(2400),
    [sym__atype] = STATE(2400),
    [sym_type_invisible] = STATE(2400),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2400),
    [sym_quasiquote] = STATE(2400),
    [aux_sym_type_apply_repeat1] = STATE(2400),
    [sym__varid] = ACTIONS(7337),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7339),
    [sym_char] = ACTIONS(7339),
    [sym_string] = ACTIONS(7339),
    [sym__integer_literal] = ACTIONS(7341),
    [sym__binary_literal] = ACTIONS(7343),
    [sym__octal_literal] = ACTIONS(7343),
    [sym__hex_literal] = ACTIONS(7343),
    [anon_sym_LPAREN_POUND] = ACTIONS(7345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7345),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7347),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7635),
    [anon_sym_LBRACK] = ACTIONS(7352),
    [anon_sym_SQUOTE] = ACTIONS(7638),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(7357),
    [anon_sym_u2605] = ACTIONS(7357),
    [anon_sym_AT] = ACTIONS(7359),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7363),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7365),
  },
  [2418] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2419] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2420] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(22212),
    [sym_lazy_type] = STATE(22212),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(22212),
    [sym__type_context] = STATE(22212),
    [sym__type_fun] = STATE(22212),
    [sym__type] = STATE(22212),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6196),
    [sym__lazy] = ACTIONS(6198),
  },
  [2421] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2421),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym_type_parens] = STATE(2421),
    [sym_type_list] = STATE(2421),
    [sym_type_tuple] = STATE(2421),
    [sym__type_promotable_literal] = STATE(2421),
    [sym__type_promoted_literal] = STATE(2421),
    [sym__type_literal] = STATE(2421),
    [sym_type_name] = STATE(2421),
    [sym_type_star] = STATE(2421),
    [sym_type_unboxed_tuple] = STATE(2421),
    [sym_type_unboxed_sum] = STATE(2421),
    [sym__atype] = STATE(2421),
    [sym_type_invisible] = STATE(2421),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2421),
    [sym_quasiquote] = STATE(2421),
    [aux_sym_type_apply_repeat1] = STATE(2421),
    [sym__varid] = ACTIONS(7641),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7644),
    [sym_char] = ACTIONS(7644),
    [sym_string] = ACTIONS(7644),
    [sym__integer_literal] = ACTIONS(7647),
    [sym__binary_literal] = ACTIONS(7650),
    [sym__octal_literal] = ACTIONS(7650),
    [sym__hex_literal] = ACTIONS(7650),
    [anon_sym_LPAREN_POUND] = ACTIONS(7653),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7653),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7656),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7662),
    [anon_sym_SQUOTE] = ACTIONS(7665),
    [anon_sym_STAR] = ACTIONS(7668),
    [anon_sym_u2605] = ACTIONS(7668),
    [anon_sym_AT] = ACTIONS(7671),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(7674),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7677),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7680),
  },
  [2422] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2422),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym_type_parens] = STATE(2422),
    [sym_type_list] = STATE(2422),
    [sym_type_tuple] = STATE(2422),
    [sym__type_promotable_literal] = STATE(2422),
    [sym__type_promoted_literal] = STATE(2422),
    [sym__type_literal] = STATE(2422),
    [sym_type_name] = STATE(2422),
    [sym_type_star] = STATE(2422),
    [sym_type_unboxed_tuple] = STATE(2422),
    [sym_type_unboxed_sum] = STATE(2422),
    [sym__atype] = STATE(2422),
    [sym_type_invisible] = STATE(2422),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2422),
    [sym_quasiquote] = STATE(2422),
    [aux_sym_type_apply_repeat1] = STATE(2422),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(7683),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7686),
    [sym_char] = ACTIONS(7686),
    [sym_string] = ACTIONS(7686),
    [sym__integer_literal] = ACTIONS(7689),
    [sym__binary_literal] = ACTIONS(7692),
    [sym__octal_literal] = ACTIONS(7692),
    [sym__hex_literal] = ACTIONS(7692),
    [anon_sym_LPAREN_POUND] = ACTIONS(7695),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7695),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7698),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7701),
    [anon_sym_LBRACK] = ACTIONS(7704),
    [anon_sym_SQUOTE] = ACTIONS(7707),
    [anon_sym_STAR] = ACTIONS(7710),
    [anon_sym_u2605] = ACTIONS(7710),
    [anon_sym_AT] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(7716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7719),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7722),
  },
  [2423] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2388),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym_type_parens] = STATE(2388),
    [sym_type_list] = STATE(2388),
    [sym_type_tuple] = STATE(2388),
    [sym__type_promotable_literal] = STATE(2388),
    [sym__type_promoted_literal] = STATE(2388),
    [sym__type_literal] = STATE(2388),
    [sym_type_name] = STATE(2388),
    [sym_type_star] = STATE(2388),
    [sym_type_unboxed_tuple] = STATE(2388),
    [sym_type_unboxed_sum] = STATE(2388),
    [sym__atype] = STATE(2388),
    [sym_type_invisible] = STATE(2388),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2388),
    [sym_quasiquote] = STATE(2388),
    [aux_sym_type_apply_repeat1] = STATE(2388),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(6977),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6979),
    [sym_char] = ACTIONS(6979),
    [sym_string] = ACTIONS(6979),
    [sym__integer_literal] = ACTIONS(6981),
    [sym__binary_literal] = ACTIONS(6983),
    [sym__octal_literal] = ACTIONS(6983),
    [sym__hex_literal] = ACTIONS(6983),
    [anon_sym_LPAREN_POUND] = ACTIONS(6985),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6985),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(6987),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(7725),
    [anon_sym_LBRACK] = ACTIONS(6992),
    [anon_sym_SQUOTE] = ACTIONS(7728),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_u2605] = ACTIONS(6997),
    [anon_sym_AT] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7001),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7003),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7005),
  },
  [2424] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2425] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2425),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym_type_parens] = STATE(2425),
    [sym_type_list] = STATE(2425),
    [sym_type_tuple] = STATE(2425),
    [sym__type_promotable_literal] = STATE(2425),
    [sym__type_promoted_literal] = STATE(2425),
    [sym__type_literal] = STATE(2425),
    [sym_type_name] = STATE(2425),
    [sym_type_star] = STATE(2425),
    [sym_type_unboxed_tuple] = STATE(2425),
    [sym_type_unboxed_sum] = STATE(2425),
    [sym__atype] = STATE(2425),
    [sym_type_invisible] = STATE(2425),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2425),
    [sym_quasiquote] = STATE(2425),
    [aux_sym_type_apply_repeat1] = STATE(2425),
    [sym__varid] = ACTIONS(7731),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7734),
    [sym_char] = ACTIONS(7734),
    [sym_string] = ACTIONS(7734),
    [sym__integer_literal] = ACTIONS(7737),
    [sym__binary_literal] = ACTIONS(7740),
    [sym__octal_literal] = ACTIONS(7740),
    [sym__hex_literal] = ACTIONS(7740),
    [anon_sym_LPAREN_POUND] = ACTIONS(7743),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7743),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(7746),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7749),
    [anon_sym_LBRACK] = ACTIONS(7752),
    [anon_sym_SQUOTE] = ACTIONS(7755),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(7758),
    [anon_sym_u2605] = ACTIONS(7758),
    [anon_sym_AT] = ACTIONS(7761),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(7764),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7767),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7770),
  },
  [2426] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [ts_builtin_sym_end] = ACTIONS(5542),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2427] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2396),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym_type_parens] = STATE(2396),
    [sym_type_list] = STATE(2396),
    [sym_type_tuple] = STATE(2396),
    [sym__type_promotable_literal] = STATE(2396),
    [sym__type_promoted_literal] = STATE(2396),
    [sym__type_literal] = STATE(2396),
    [sym_type_name] = STATE(2396),
    [sym_type_star] = STATE(2396),
    [sym_type_unboxed_tuple] = STATE(2396),
    [sym_type_unboxed_sum] = STATE(2396),
    [sym__atype] = STATE(2396),
    [sym_type_invisible] = STATE(2396),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2396),
    [sym_quasiquote] = STATE(2396),
    [aux_sym_type_apply_repeat1] = STATE(2396),
    [sym__varid] = ACTIONS(7187),
    [sym_float] = ACTIONS(7189),
    [sym_char] = ACTIONS(7189),
    [sym_string] = ACTIONS(7189),
    [sym__integer_literal] = ACTIONS(7191),
    [sym__binary_literal] = ACTIONS(7193),
    [sym__octal_literal] = ACTIONS(7193),
    [sym__hex_literal] = ACTIONS(7193),
    [anon_sym_LPAREN_POUND] = ACTIONS(7195),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7195),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7197),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7773),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(7776),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_u2605] = ACTIONS(7207),
    [anon_sym_AT] = ACTIONS(7209),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7211),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7213),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(7215),
  },
  [2428] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2429] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2390),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15961),
    [sym_type_parens] = STATE(2390),
    [sym_type_list] = STATE(2390),
    [sym_type_tuple] = STATE(2390),
    [sym__type_promotable_literal] = STATE(2390),
    [sym__type_promoted_literal] = STATE(2390),
    [sym__type_literal] = STATE(2390),
    [sym_type_name] = STATE(2494),
    [sym_type_star] = STATE(2390),
    [sym_type_unboxed_tuple] = STATE(2390),
    [sym_type_unboxed_sum] = STATE(2390),
    [sym__atype] = STATE(2390),
    [sym_type_apply] = STATE(8252),
    [sym__btype] = STATE(8252),
    [sym_implicit_param] = STATE(15406),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(13247),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2678),
    [sym__type_quantifiers] = STATE(15406),
    [sym__type_context] = STATE(15406),
    [sym__type_fun] = STATE(15406),
    [sym__type] = STATE(15406),
    [sym__type_or_implicit] = STATE(15406),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2390),
    [sym_quasiquote] = STATE(2390),
    [sym__varid] = ACTIONS(7037),
    [sym_float] = ACTIONS(7039),
    [sym_char] = ACTIONS(7039),
    [sym_string] = ACTIONS(7039),
    [sym__integer_literal] = ACTIONS(7041),
    [sym__binary_literal] = ACTIONS(7043),
    [sym__octal_literal] = ACTIONS(7043),
    [sym__hex_literal] = ACTIONS(7043),
    [anon_sym_LPAREN_POUND] = ACTIONS(7045),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7045),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7779),
    [sym_implicit_parid] = ACTIONS(7781),
    [sym__conid] = ACTIONS(7783),
    [anon_sym_LBRACK] = ACTIONS(7052),
    [anon_sym_SQUOTE] = ACTIONS(7785),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_u2605] = ACTIONS(7057),
    [anon_sym_u27e6] = ACTIONS(7061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7063),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7065),
  },
  [2430] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_implicit_param] = STATE(21031),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(21031),
    [sym__type_context] = STATE(21031),
    [sym__type_fun] = STATE(21031),
    [sym__type] = STATE(21031),
    [sym__type_or_implicit] = STATE(21031),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym_implicit_parid] = ACTIONS(7787),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2431] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_implicit_param] = STATE(18735),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(18735),
    [sym__type_context] = STATE(18735),
    [sym__type_fun] = STATE(18735),
    [sym__type] = STATE(18735),
    [sym__type_or_implicit] = STATE(18735),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym_implicit_parid] = ACTIONS(7801),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2432] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2433] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2433),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym_type_parens] = STATE(2433),
    [sym_type_list] = STATE(2433),
    [sym_type_tuple] = STATE(2433),
    [sym__type_promotable_literal] = STATE(2433),
    [sym__type_promoted_literal] = STATE(2433),
    [sym__type_literal] = STATE(2433),
    [sym_type_name] = STATE(2433),
    [sym_type_star] = STATE(2433),
    [sym_type_unboxed_tuple] = STATE(2433),
    [sym_type_unboxed_sum] = STATE(2433),
    [sym__atype] = STATE(2433),
    [sym_type_invisible] = STATE(2433),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2433),
    [sym_quasiquote] = STATE(2433),
    [aux_sym_type_apply_repeat1] = STATE(2433),
    [sym__varid] = ACTIONS(7817),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7820),
    [sym_char] = ACTIONS(7820),
    [sym_string] = ACTIONS(7820),
    [sym__integer_literal] = ACTIONS(7823),
    [sym__binary_literal] = ACTIONS(7826),
    [sym__octal_literal] = ACTIONS(7826),
    [sym__hex_literal] = ACTIONS(7826),
    [anon_sym_LPAREN_POUND] = ACTIONS(7829),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7829),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7832),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(7835),
    [anon_sym_LBRACK] = ACTIONS(7838),
    [anon_sym_SQUOTE] = ACTIONS(7841),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(7844),
    [anon_sym_u2605] = ACTIONS(7844),
    [anon_sym_AT] = ACTIONS(7847),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(7850),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(7853),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7856),
  },
  [2434] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2478),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16159),
    [sym_type_parens] = STATE(2478),
    [sym_type_list] = STATE(2478),
    [sym_type_tuple] = STATE(2478),
    [sym__type_promotable_literal] = STATE(2478),
    [sym__type_promoted_literal] = STATE(2478),
    [sym__type_literal] = STATE(2478),
    [sym_type_name] = STATE(2515),
    [sym_type_star] = STATE(2478),
    [sym_type_unboxed_tuple] = STATE(2478),
    [sym_type_unboxed_sum] = STATE(2478),
    [sym__atype] = STATE(2478),
    [sym_type_apply] = STATE(8475),
    [sym__btype] = STATE(8475),
    [sym_implicit_param] = STATE(13753),
    [sym_type_infix] = STATE(11228),
    [sym__type_infix] = STATE(10954),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2746),
    [sym__type_quantifiers] = STATE(13753),
    [sym__type_context] = STATE(13753),
    [sym__type_fun] = STATE(13753),
    [sym__type] = STATE(13753),
    [sym__type_or_implicit] = STATE(13753),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2478),
    [sym_quasiquote] = STATE(2478),
    [sym__varid] = ACTIONS(7859),
    [sym_float] = ACTIONS(7861),
    [sym_char] = ACTIONS(7861),
    [sym_string] = ACTIONS(7861),
    [sym__integer_literal] = ACTIONS(7863),
    [sym__binary_literal] = ACTIONS(7865),
    [sym__octal_literal] = ACTIONS(7865),
    [sym__hex_literal] = ACTIONS(7865),
    [anon_sym_LPAREN_POUND] = ACTIONS(7867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7869),
    [sym_implicit_parid] = ACTIONS(7871),
    [sym__conid] = ACTIONS(7873),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_SQUOTE] = ACTIONS(7877),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7879),
    [anon_sym_u2605] = ACTIONS(7879),
    [anon_sym_u27e6] = ACTIONS(7881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7885),
  },
  [2435] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2057),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15863),
    [sym_type_parens] = STATE(2057),
    [sym_type_list] = STATE(2057),
    [sym_type_tuple] = STATE(2057),
    [sym__type_promotable_literal] = STATE(2057),
    [sym__type_promoted_literal] = STATE(2057),
    [sym__type_literal] = STATE(2057),
    [sym_type_name] = STATE(2158),
    [sym_type_star] = STATE(2057),
    [sym_type_unboxed_tuple] = STATE(2057),
    [sym_type_unboxed_sum] = STATE(2057),
    [sym__atype] = STATE(2057),
    [sym_type_apply] = STATE(7195),
    [sym__btype] = STATE(7195),
    [sym_implicit_param] = STATE(10698),
    [sym_type_infix] = STATE(10505),
    [sym__type_infix] = STATE(10272),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2639),
    [sym__type_quantifiers] = STATE(10698),
    [sym__type_context] = STATE(10698),
    [sym__type_fun] = STATE(10698),
    [sym__type] = STATE(10698),
    [sym__type_or_implicit] = STATE(10698),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2057),
    [sym_quasiquote] = STATE(2057),
    [sym__varid] = ACTIONS(5644),
    [sym_float] = ACTIONS(5646),
    [sym_char] = ACTIONS(5646),
    [sym_string] = ACTIONS(5646),
    [sym__integer_literal] = ACTIONS(5648),
    [sym__binary_literal] = ACTIONS(5650),
    [sym__octal_literal] = ACTIONS(5650),
    [sym__hex_literal] = ACTIONS(5650),
    [anon_sym_LPAREN_POUND] = ACTIONS(5652),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5652),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7887),
    [sym_implicit_parid] = ACTIONS(7889),
    [sym__conid] = ACTIONS(7891),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_SQUOTE] = ACTIONS(7893),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_u2605] = ACTIONS(5664),
    [anon_sym_u27e6] = ACTIONS(5668),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5672),
  },
  [2436] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2417),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16106),
    [sym_type_parens] = STATE(2417),
    [sym_type_list] = STATE(2417),
    [sym_type_tuple] = STATE(2417),
    [sym__type_promotable_literal] = STATE(2417),
    [sym__type_promoted_literal] = STATE(2417),
    [sym__type_literal] = STATE(2417),
    [sym_type_name] = STATE(2439),
    [sym_type_star] = STATE(2417),
    [sym_type_unboxed_tuple] = STATE(2417),
    [sym_type_unboxed_sum] = STATE(2417),
    [sym__atype] = STATE(2417),
    [sym_type_apply] = STATE(8304),
    [sym__btype] = STATE(8304),
    [sym_implicit_param] = STATE(13341),
    [sym_type_infix] = STATE(11020),
    [sym__type_infix] = STATE(10890),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2692),
    [sym__type_quantifiers] = STATE(13341),
    [sym__type_context] = STATE(13341),
    [sym__type_fun] = STATE(13341),
    [sym__type] = STATE(13341),
    [sym__type_or_implicit] = STATE(13341),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2417),
    [sym_quasiquote] = STATE(2417),
    [sym__varid] = ACTIONS(7895),
    [sym_float] = ACTIONS(7339),
    [sym_char] = ACTIONS(7339),
    [sym_string] = ACTIONS(7339),
    [sym__integer_literal] = ACTIONS(7341),
    [sym__binary_literal] = ACTIONS(7343),
    [sym__octal_literal] = ACTIONS(7343),
    [sym__hex_literal] = ACTIONS(7343),
    [anon_sym_LPAREN_POUND] = ACTIONS(7345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7345),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7897),
    [sym_implicit_parid] = ACTIONS(7899),
    [sym__conid] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7352),
    [anon_sym_SQUOTE] = ACTIONS(7903),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7357),
    [anon_sym_u2605] = ACTIONS(7357),
    [anon_sym_u27e6] = ACTIONS(7361),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7363),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7365),
  },
  [2437] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2405),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15976),
    [sym_type_parens] = STATE(2405),
    [sym_type_list] = STATE(2405),
    [sym_type_tuple] = STATE(2405),
    [sym__type_promotable_literal] = STATE(2405),
    [sym__type_promoted_literal] = STATE(2405),
    [sym__type_literal] = STATE(2405),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2405),
    [sym_type_unboxed_tuple] = STATE(2405),
    [sym_type_unboxed_sum] = STATE(2405),
    [sym__atype] = STATE(2405),
    [sym_type_apply] = STATE(8249),
    [sym__btype] = STATE(8249),
    [sym_implicit_param] = STATE(13420),
    [sym_type_infix] = STATE(11107),
    [sym__type_infix] = STATE(10894),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2693),
    [sym__type_quantifiers] = STATE(13420),
    [sym__type_context] = STATE(13420),
    [sym__type_fun] = STATE(13420),
    [sym__type] = STATE(13420),
    [sym__type_or_implicit] = STATE(13420),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2405),
    [sym_quasiquote] = STATE(2405),
    [sym__varid] = ACTIONS(7905),
    [sym_float] = ACTIONS(7309),
    [sym_char] = ACTIONS(7309),
    [sym_string] = ACTIONS(7309),
    [sym__integer_literal] = ACTIONS(7311),
    [sym__binary_literal] = ACTIONS(7313),
    [sym__octal_literal] = ACTIONS(7313),
    [sym__hex_literal] = ACTIONS(7313),
    [anon_sym_LPAREN_POUND] = ACTIONS(7315),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7315),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7907),
    [sym_implicit_parid] = ACTIONS(7909),
    [sym__conid] = ACTIONS(7911),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7913),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7327),
    [anon_sym_u2605] = ACTIONS(7327),
    [anon_sym_u27e6] = ACTIONS(7331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7333),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7335),
  },
  [2438] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_implicit_param] = STATE(21012),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(21012),
    [sym__type_context] = STATE(21012),
    [sym__type_fun] = STATE(21012),
    [sym__type] = STATE(21012),
    [sym__type_or_implicit] = STATE(21012),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym_implicit_parid] = ACTIONS(7787),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2439] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2440] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2297),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16212),
    [sym_type_parens] = STATE(2297),
    [sym_type_list] = STATE(2297),
    [sym_type_tuple] = STATE(2297),
    [sym__type_promotable_literal] = STATE(2297),
    [sym__type_promoted_literal] = STATE(2297),
    [sym__type_literal] = STATE(2297),
    [sym_type_name] = STATE(2426),
    [sym_type_star] = STATE(2297),
    [sym_type_unboxed_tuple] = STATE(2297),
    [sym_type_unboxed_sum] = STATE(2297),
    [sym__atype] = STATE(2297),
    [sym_type_apply] = STATE(8194),
    [sym__btype] = STATE(8194),
    [sym_implicit_param] = STATE(13228),
    [sym_type_infix] = STATE(10862),
    [sym__type_infix] = STATE(10724),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2747),
    [sym__type_quantifiers] = STATE(13228),
    [sym__type_context] = STATE(13228),
    [sym__type_fun] = STATE(13228),
    [sym__type] = STATE(13228),
    [sym__type_or_implicit] = STATE(13228),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2297),
    [sym_quasiquote] = STATE(2297),
    [sym__varid] = ACTIONS(7915),
    [sym_float] = ACTIONS(6552),
    [sym_char] = ACTIONS(6552),
    [sym_string] = ACTIONS(6552),
    [sym__integer_literal] = ACTIONS(6554),
    [sym__binary_literal] = ACTIONS(6556),
    [sym__octal_literal] = ACTIONS(6556),
    [sym__hex_literal] = ACTIONS(6556),
    [anon_sym_LPAREN_POUND] = ACTIONS(6558),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6558),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7917),
    [sym_implicit_parid] = ACTIONS(7919),
    [sym__conid] = ACTIONS(7921),
    [anon_sym_LBRACK] = ACTIONS(6565),
    [anon_sym_SQUOTE] = ACTIONS(7923),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6570),
    [anon_sym_u2605] = ACTIONS(6570),
    [anon_sym_u27e6] = ACTIONS(6574),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6578),
  },
  [2441] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2500),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym_type_parens] = STATE(2500),
    [sym_type_list] = STATE(2500),
    [sym_type_tuple] = STATE(2500),
    [sym__type_promotable_literal] = STATE(2500),
    [sym__type_promoted_literal] = STATE(2500),
    [sym__type_literal] = STATE(2500),
    [sym_type_name] = STATE(2500),
    [sym_type_star] = STATE(2500),
    [sym_type_unboxed_tuple] = STATE(2500),
    [sym_type_unboxed_sum] = STATE(2500),
    [sym__atype] = STATE(2500),
    [sym_type_invisible] = STATE(2500),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2500),
    [sym_quasiquote] = STATE(2500),
    [aux_sym_type_apply_repeat1] = STATE(2500),
    [sym__varid] = ACTIONS(7925),
    [sym_float] = ACTIONS(7927),
    [sym_char] = ACTIONS(7927),
    [sym_string] = ACTIONS(7927),
    [sym__integer_literal] = ACTIONS(7929),
    [sym__binary_literal] = ACTIONS(7931),
    [sym__octal_literal] = ACTIONS(7931),
    [sym__hex_literal] = ACTIONS(7931),
    [anon_sym_LPAREN_POUND] = ACTIONS(7933),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7933),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7935),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7937),
    [anon_sym_LBRACK] = ACTIONS(7940),
    [anon_sym_SQUOTE] = ACTIONS(7942),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_u2605] = ACTIONS(7945),
    [anon_sym_AT] = ACTIONS(7947),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7949),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7951),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(7953),
    [sym__unboxed_close] = ACTIONS(5451),
  },
  [2442] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2444),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym_type_parens] = STATE(2444),
    [sym_type_list] = STATE(2444),
    [sym_type_tuple] = STATE(2444),
    [sym__type_promotable_literal] = STATE(2444),
    [sym__type_promoted_literal] = STATE(2444),
    [sym__type_literal] = STATE(2444),
    [sym_type_name] = STATE(2444),
    [sym_type_star] = STATE(2444),
    [sym_type_unboxed_tuple] = STATE(2444),
    [sym_type_unboxed_sum] = STATE(2444),
    [sym__atype] = STATE(2444),
    [sym_type_invisible] = STATE(2444),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2444),
    [sym_quasiquote] = STATE(2444),
    [aux_sym_type_apply_repeat1] = STATE(2444),
    [sym__varid] = ACTIONS(7955),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7861),
    [sym_char] = ACTIONS(7861),
    [sym_string] = ACTIONS(7861),
    [sym__integer_literal] = ACTIONS(7863),
    [sym__binary_literal] = ACTIONS(7865),
    [sym__octal_literal] = ACTIONS(7865),
    [sym__hex_literal] = ACTIONS(7865),
    [anon_sym_LPAREN_POUND] = ACTIONS(7867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7867),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(7957),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(7959),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_SQUOTE] = ACTIONS(7962),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(7879),
    [anon_sym_u2605] = ACTIONS(7879),
    [anon_sym_AT] = ACTIONS(7965),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7883),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7885),
  },
  [2443] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2531),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16208),
    [sym_type_parens] = STATE(2531),
    [sym_type_list] = STATE(2531),
    [sym_type_tuple] = STATE(2531),
    [sym__type_promotable_literal] = STATE(2531),
    [sym__type_promoted_literal] = STATE(2531),
    [sym__type_literal] = STATE(2531),
    [sym_type_name] = STATE(2683),
    [sym_type_star] = STATE(2531),
    [sym_type_unboxed_tuple] = STATE(2531),
    [sym_type_unboxed_sum] = STATE(2531),
    [sym__atype] = STATE(2531),
    [sym_type_apply] = STATE(8762),
    [sym__btype] = STATE(8762),
    [sym_implicit_param] = STATE(16140),
    [sym_type_infix] = STATE(13840),
    [sym__type_infix] = STATE(13260),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2735),
    [sym__type_quantifiers] = STATE(16140),
    [sym__type_context] = STATE(16140),
    [sym__type_fun] = STATE(16140),
    [sym__type] = STATE(16140),
    [sym__type_or_implicit] = STATE(16140),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2531),
    [sym_quasiquote] = STATE(2531),
    [sym__varid] = ACTIONS(7967),
    [sym_float] = ACTIONS(7969),
    [sym_char] = ACTIONS(7969),
    [sym_string] = ACTIONS(7969),
    [sym__integer_literal] = ACTIONS(7971),
    [sym__binary_literal] = ACTIONS(7973),
    [sym__octal_literal] = ACTIONS(7973),
    [sym__hex_literal] = ACTIONS(7973),
    [anon_sym_LPAREN_POUND] = ACTIONS(7975),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7975),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7977),
    [sym_implicit_parid] = ACTIONS(7979),
    [sym__conid] = ACTIONS(7981),
    [anon_sym_LBRACK] = ACTIONS(7983),
    [anon_sym_SQUOTE] = ACTIONS(7985),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_u2605] = ACTIONS(7987),
    [anon_sym_u27e6] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7991),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7993),
  },
  [2444] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2444),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym_type_parens] = STATE(2444),
    [sym_type_list] = STATE(2444),
    [sym_type_tuple] = STATE(2444),
    [sym__type_promotable_literal] = STATE(2444),
    [sym__type_promoted_literal] = STATE(2444),
    [sym__type_literal] = STATE(2444),
    [sym_type_name] = STATE(2444),
    [sym_type_star] = STATE(2444),
    [sym_type_unboxed_tuple] = STATE(2444),
    [sym_type_unboxed_sum] = STATE(2444),
    [sym__atype] = STATE(2444),
    [sym_type_invisible] = STATE(2444),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2444),
    [sym_quasiquote] = STATE(2444),
    [aux_sym_type_apply_repeat1] = STATE(2444),
    [sym__varid] = ACTIONS(7995),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(7998),
    [sym_char] = ACTIONS(7998),
    [sym_string] = ACTIONS(7998),
    [sym__integer_literal] = ACTIONS(8001),
    [sym__binary_literal] = ACTIONS(8004),
    [sym__octal_literal] = ACTIONS(8004),
    [sym__hex_literal] = ACTIONS(8004),
    [anon_sym_LPAREN_POUND] = ACTIONS(8007),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8007),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(8010),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(8013),
    [anon_sym_LBRACK] = ACTIONS(8016),
    [anon_sym_SQUOTE] = ACTIONS(8019),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(8022),
    [anon_sym_u2605] = ACTIONS(8022),
    [anon_sym_AT] = ACTIONS(8025),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(8028),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(8031),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8034),
  },
  [2445] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2423),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15661),
    [sym_type_parens] = STATE(2423),
    [sym_type_list] = STATE(2423),
    [sym_type_tuple] = STATE(2423),
    [sym__type_promotable_literal] = STATE(2423),
    [sym__type_promoted_literal] = STATE(2423),
    [sym__type_literal] = STATE(2423),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2423),
    [sym_type_unboxed_tuple] = STATE(2423),
    [sym_type_unboxed_sum] = STATE(2423),
    [sym__atype] = STATE(2423),
    [sym_type_apply] = STATE(8297),
    [sym__btype] = STATE(8297),
    [sym_implicit_param] = STATE(13280),
    [sym_type_infix] = STATE(11111),
    [sym__type_infix] = STATE(10824),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2660),
    [sym__type_quantifiers] = STATE(13280),
    [sym__type_context] = STATE(13280),
    [sym__type_fun] = STATE(13280),
    [sym__type] = STATE(13280),
    [sym__type_or_implicit] = STATE(13280),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2423),
    [sym_quasiquote] = STATE(2423),
    [sym__varid] = ACTIONS(8037),
    [sym_float] = ACTIONS(6979),
    [sym_char] = ACTIONS(6979),
    [sym_string] = ACTIONS(6979),
    [sym__integer_literal] = ACTIONS(6981),
    [sym__binary_literal] = ACTIONS(6983),
    [sym__octal_literal] = ACTIONS(6983),
    [sym__hex_literal] = ACTIONS(6983),
    [anon_sym_LPAREN_POUND] = ACTIONS(6985),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6985),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8039),
    [sym_implicit_parid] = ACTIONS(8041),
    [sym__conid] = ACTIONS(8043),
    [anon_sym_LBRACK] = ACTIONS(6992),
    [anon_sym_SQUOTE] = ACTIONS(8045),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_u2605] = ACTIONS(6997),
    [anon_sym_u27e6] = ACTIONS(7001),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7005),
  },
  [2446] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [ts_builtin_sym_end] = ACTIONS(5542),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2447] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_implicit_param] = STATE(14950),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14950),
    [sym__type_context] = STATE(14950),
    [sym__type_fun] = STATE(14950),
    [sym__type] = STATE(14950),
    [sym__type_or_implicit] = STATE(14950),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym_implicit_parid] = ACTIONS(5704),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
  },
  [2448] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2490),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym_type_parens] = STATE(2490),
    [sym_type_list] = STATE(2490),
    [sym_type_tuple] = STATE(2490),
    [sym__type_promotable_literal] = STATE(2490),
    [sym__type_promoted_literal] = STATE(2490),
    [sym__type_literal] = STATE(2490),
    [sym_type_name] = STATE(2490),
    [sym_type_star] = STATE(2490),
    [sym_type_unboxed_tuple] = STATE(2490),
    [sym_type_unboxed_sum] = STATE(2490),
    [sym__atype] = STATE(2490),
    [sym_type_invisible] = STATE(2490),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2490),
    [sym_quasiquote] = STATE(2490),
    [aux_sym_type_apply_repeat1] = STATE(2490),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(8047),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8049),
    [sym_char] = ACTIONS(8049),
    [sym_string] = ACTIONS(8049),
    [sym__integer_literal] = ACTIONS(8051),
    [sym__binary_literal] = ACTIONS(8053),
    [sym__octal_literal] = ACTIONS(8053),
    [sym__hex_literal] = ACTIONS(8053),
    [anon_sym_LPAREN_POUND] = ACTIONS(8055),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8055),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(8057),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(8059),
    [anon_sym_LBRACK] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(8064),
    [anon_sym_STAR] = ACTIONS(8067),
    [anon_sym_u2605] = ACTIONS(8067),
    [anon_sym_AT] = ACTIONS(8069),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8073),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8075),
  },
  [2449] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2433),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym_type_parens] = STATE(2433),
    [sym_type_list] = STATE(2433),
    [sym_type_tuple] = STATE(2433),
    [sym__type_promotable_literal] = STATE(2433),
    [sym__type_promoted_literal] = STATE(2433),
    [sym__type_literal] = STATE(2433),
    [sym_type_name] = STATE(2433),
    [sym_type_star] = STATE(2433),
    [sym_type_unboxed_tuple] = STATE(2433),
    [sym_type_unboxed_sum] = STATE(2433),
    [sym__atype] = STATE(2433),
    [sym_type_invisible] = STATE(2433),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2433),
    [sym_quasiquote] = STATE(2433),
    [aux_sym_type_apply_repeat1] = STATE(2433),
    [sym__varid] = ACTIONS(8077),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8087),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(8089),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8094),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_AT] = ACTIONS(8099),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2450] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_implicit_param] = STATE(21178),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(21178),
    [sym__type_context] = STATE(21178),
    [sym__type_fun] = STATE(21178),
    [sym__type] = STATE(21178),
    [sym__type_or_implicit] = STATE(21178),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym_implicit_parid] = ACTIONS(7787),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2451] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2107),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15654),
    [sym_type_parens] = STATE(2107),
    [sym_type_list] = STATE(2107),
    [sym_type_tuple] = STATE(2107),
    [sym__type_promotable_literal] = STATE(2107),
    [sym__type_promoted_literal] = STATE(2107),
    [sym__type_literal] = STATE(2107),
    [sym_type_name] = STATE(2212),
    [sym_type_star] = STATE(2107),
    [sym_type_unboxed_tuple] = STATE(2107),
    [sym_type_unboxed_sum] = STATE(2107),
    [sym__atype] = STATE(2107),
    [sym_type_apply] = STATE(7336),
    [sym__btype] = STATE(7336),
    [sym_implicit_param] = STATE(10834),
    [sym_type_infix] = STATE(10601),
    [sym__type_infix] = STATE(10511),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2731),
    [sym__type_quantifiers] = STATE(10834),
    [sym__type_context] = STATE(10834),
    [sym__type_fun] = STATE(10834),
    [sym__type] = STATE(10834),
    [sym__type_or_implicit] = STATE(10834),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2107),
    [sym_quasiquote] = STATE(2107),
    [sym__varid] = ACTIONS(5816),
    [sym_float] = ACTIONS(5818),
    [sym_char] = ACTIONS(5818),
    [sym_string] = ACTIONS(5818),
    [sym__integer_literal] = ACTIONS(5820),
    [sym__binary_literal] = ACTIONS(5822),
    [sym__octal_literal] = ACTIONS(5822),
    [sym__hex_literal] = ACTIONS(5822),
    [anon_sym_LPAREN_POUND] = ACTIONS(5824),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5824),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8107),
    [sym_implicit_parid] = ACTIONS(8109),
    [sym__conid] = ACTIONS(8111),
    [anon_sym_LBRACK] = ACTIONS(5831),
    [anon_sym_SQUOTE] = ACTIONS(8113),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_u2605] = ACTIONS(5836),
    [anon_sym_u27e6] = ACTIONS(5840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5842),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5844),
  },
  [2452] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2217),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15716),
    [sym_type_parens] = STATE(2217),
    [sym_type_list] = STATE(2217),
    [sym_type_tuple] = STATE(2217),
    [sym__type_promotable_literal] = STATE(2217),
    [sym__type_promoted_literal] = STATE(2217),
    [sym__type_literal] = STATE(2217),
    [sym_type_name] = STATE(2309),
    [sym_type_star] = STATE(2217),
    [sym_type_unboxed_tuple] = STATE(2217),
    [sym_type_unboxed_sum] = STATE(2217),
    [sym__atype] = STATE(2217),
    [sym_type_apply] = STATE(8093),
    [sym__btype] = STATE(8093),
    [sym_implicit_param] = STATE(11290),
    [sym_type_infix] = STATE(10692),
    [sym__type_infix] = STATE(10635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2611),
    [sym__type_quantifiers] = STATE(11290),
    [sym__type_context] = STATE(11290),
    [sym__type_fun] = STATE(11290),
    [sym__type] = STATE(11290),
    [sym__type_or_implicit] = STATE(11290),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2217),
    [sym_quasiquote] = STATE(2217),
    [sym__varid] = ACTIONS(8115),
    [sym_float] = ACTIONS(6120),
    [sym_char] = ACTIONS(6120),
    [sym_string] = ACTIONS(6120),
    [sym__integer_literal] = ACTIONS(6122),
    [sym__binary_literal] = ACTIONS(6124),
    [sym__octal_literal] = ACTIONS(6124),
    [sym__hex_literal] = ACTIONS(6124),
    [anon_sym_LPAREN_POUND] = ACTIONS(6126),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6126),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8117),
    [sym_implicit_parid] = ACTIONS(8119),
    [sym__conid] = ACTIONS(8121),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_SQUOTE] = ACTIONS(8123),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_u2605] = ACTIONS(6138),
    [anon_sym_u27e6] = ACTIONS(6142),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6144),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6146),
  },
  [2453] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_implicit_param] = STATE(17999),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(17999),
    [sym__type_context] = STATE(17999),
    [sym__type_fun] = STATE(17999),
    [sym__type] = STATE(17999),
    [sym__type_or_implicit] = STATE(17999),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym_implicit_parid] = ACTIONS(8125),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2454] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_implicit_param] = STATE(18673),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(18673),
    [sym__type_context] = STATE(18673),
    [sym__type_fun] = STATE(18673),
    [sym__type] = STATE(18673),
    [sym__type_or_implicit] = STATE(18673),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym_implicit_parid] = ACTIONS(7801),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2455] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2542),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16026),
    [sym_type_parens] = STATE(2542),
    [sym_type_list] = STATE(2542),
    [sym_type_tuple] = STATE(2542),
    [sym__type_promotable_literal] = STATE(2542),
    [sym__type_promoted_literal] = STATE(2542),
    [sym__type_literal] = STATE(2542),
    [sym_type_name] = STATE(2588),
    [sym_type_star] = STATE(2542),
    [sym_type_unboxed_tuple] = STATE(2542),
    [sym_type_unboxed_sum] = STATE(2542),
    [sym__atype] = STATE(2542),
    [sym_type_apply] = STATE(8820),
    [sym__btype] = STATE(8820),
    [sym_implicit_param] = STATE(14732),
    [sym_type_infix] = STATE(13662),
    [sym__type_infix] = STATE(13419),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2723),
    [sym__type_quantifiers] = STATE(14732),
    [sym__type_context] = STATE(14732),
    [sym__type_fun] = STATE(14732),
    [sym__type] = STATE(14732),
    [sym__type_or_implicit] = STATE(14732),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2542),
    [sym_quasiquote] = STATE(2542),
    [sym__varid] = ACTIONS(8127),
    [sym_float] = ACTIONS(8129),
    [sym_char] = ACTIONS(8129),
    [sym_string] = ACTIONS(8129),
    [sym__integer_literal] = ACTIONS(8131),
    [sym__binary_literal] = ACTIONS(8133),
    [sym__octal_literal] = ACTIONS(8133),
    [sym__hex_literal] = ACTIONS(8133),
    [anon_sym_LPAREN_POUND] = ACTIONS(8135),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8135),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8137),
    [sym_implicit_parid] = ACTIONS(8139),
    [sym__conid] = ACTIONS(8141),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8145),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8147),
    [anon_sym_u2605] = ACTIONS(8147),
    [anon_sym_u27e6] = ACTIONS(8149),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8151),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8153),
  },
  [2456] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2456),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_invisible] = STATE(2456),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [aux_sym_type_apply_repeat1] = STATE(2456),
    [sym__varid] = ACTIONS(8155),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(8158),
    [sym_char] = ACTIONS(8158),
    [sym_string] = ACTIONS(8158),
    [sym__integer_literal] = ACTIONS(8161),
    [sym__binary_literal] = ACTIONS(8164),
    [sym__octal_literal] = ACTIONS(8164),
    [sym__hex_literal] = ACTIONS(8164),
    [anon_sym_LPAREN_POUND] = ACTIONS(8167),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8167),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(8170),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(8173),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_SQUOTE] = ACTIONS(8179),
    [anon_sym_STAR] = ACTIONS(8182),
    [anon_sym_u2605] = ACTIONS(8182),
    [anon_sym_AT] = ACTIONS(8185),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(8188),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(8191),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8194),
  },
  [2457] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2225),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15910),
    [sym_type_parens] = STATE(2225),
    [sym_type_list] = STATE(2225),
    [sym_type_tuple] = STATE(2225),
    [sym__type_promotable_literal] = STATE(2225),
    [sym__type_promoted_literal] = STATE(2225),
    [sym__type_literal] = STATE(2225),
    [sym_type_name] = STATE(2310),
    [sym_type_star] = STATE(2225),
    [sym_type_unboxed_tuple] = STATE(2225),
    [sym_type_unboxed_sum] = STATE(2225),
    [sym__atype] = STATE(2225),
    [sym_type_apply] = STATE(8044),
    [sym__btype] = STATE(8044),
    [sym_implicit_param] = STATE(12773),
    [sym_type_infix] = STATE(10739),
    [sym__type_infix] = STATE(10626),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(12773),
    [sym__type_context] = STATE(12773),
    [sym__type_fun] = STATE(12773),
    [sym__type] = STATE(12773),
    [sym__type_or_implicit] = STATE(12773),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2225),
    [sym_quasiquote] = STATE(2225),
    [sym__varid] = ACTIONS(6266),
    [sym_float] = ACTIONS(6268),
    [sym_char] = ACTIONS(6268),
    [sym_string] = ACTIONS(6268),
    [sym__integer_literal] = ACTIONS(6270),
    [sym__binary_literal] = ACTIONS(6272),
    [sym__octal_literal] = ACTIONS(6272),
    [sym__hex_literal] = ACTIONS(6272),
    [anon_sym_LPAREN_POUND] = ACTIONS(6274),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8197),
    [sym_implicit_parid] = ACTIONS(8199),
    [sym__conid] = ACTIONS(8201),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [anon_sym_SQUOTE] = ACTIONS(8203),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_u2605] = ACTIONS(6286),
    [anon_sym_u27e6] = ACTIONS(6290),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6292),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6294),
  },
  [2458] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_deriving] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2459] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15674),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2517),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(8422),
    [sym__btype] = STATE(8422),
    [sym_implicit_param] = STATE(12806),
    [sym_type_infix] = STATE(11259),
    [sym__type_infix] = STATE(11143),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2590),
    [sym__type_quantifiers] = STATE(12806),
    [sym__type_context] = STATE(12806),
    [sym__type_fun] = STATE(12806),
    [sym__type] = STATE(12806),
    [sym__type_or_implicit] = STATE(12806),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(8205),
    [sym_float] = ACTIONS(7927),
    [sym_char] = ACTIONS(7927),
    [sym_string] = ACTIONS(7927),
    [sym__integer_literal] = ACTIONS(7929),
    [sym__binary_literal] = ACTIONS(7931),
    [sym__octal_literal] = ACTIONS(7931),
    [sym__hex_literal] = ACTIONS(7931),
    [anon_sym_LPAREN_POUND] = ACTIONS(7933),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7933),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8207),
    [sym_implicit_parid] = ACTIONS(8209),
    [sym__conid] = ACTIONS(8211),
    [anon_sym_LBRACK] = ACTIONS(7940),
    [anon_sym_SQUOTE] = ACTIONS(8213),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_u2605] = ACTIONS(7945),
    [anon_sym_u27e6] = ACTIONS(7949),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7951),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7953),
  },
  [2460] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2633),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16071),
    [sym_type_parens] = STATE(2633),
    [sym_type_list] = STATE(2633),
    [sym_type_tuple] = STATE(2633),
    [sym__type_promotable_literal] = STATE(2633),
    [sym__type_promoted_literal] = STATE(2633),
    [sym__type_literal] = STATE(2633),
    [sym_type_name] = STATE(2789),
    [sym_type_star] = STATE(2633),
    [sym_type_unboxed_tuple] = STATE(2633),
    [sym_type_unboxed_sum] = STATE(2633),
    [sym__atype] = STATE(2633),
    [sym_type_apply] = STATE(8991),
    [sym__btype] = STATE(8991),
    [sym_implicit_param] = STATE(17694),
    [sym_type_infix] = STATE(14014),
    [sym__type_infix] = STATE(13598),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2734),
    [sym__type_quantifiers] = STATE(17694),
    [sym__type_context] = STATE(17694),
    [sym__type_fun] = STATE(17694),
    [sym__type] = STATE(17694),
    [sym__type_or_implicit] = STATE(17694),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2633),
    [sym_quasiquote] = STATE(2633),
    [sym__varid] = ACTIONS(8215),
    [sym_float] = ACTIONS(8217),
    [sym_char] = ACTIONS(8217),
    [sym_string] = ACTIONS(8217),
    [sym__integer_literal] = ACTIONS(8219),
    [sym__binary_literal] = ACTIONS(8221),
    [sym__octal_literal] = ACTIONS(8221),
    [sym__hex_literal] = ACTIONS(8221),
    [anon_sym_LPAREN_POUND] = ACTIONS(8223),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8223),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8225),
    [sym_implicit_parid] = ACTIONS(8227),
    [sym__conid] = ACTIONS(8229),
    [anon_sym_LBRACK] = ACTIONS(8231),
    [anon_sym_SQUOTE] = ACTIONS(8233),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8235),
    [anon_sym_u2605] = ACTIONS(8235),
    [anon_sym_u27e6] = ACTIONS(8237),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8239),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8241),
  },
  [2461] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DOT_DOT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2462] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_implicit_param] = STATE(18023),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(18023),
    [sym__type_context] = STATE(18023),
    [sym__type_fun] = STATE(18023),
    [sym__type] = STATE(18023),
    [sym__type_or_implicit] = STATE(18023),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym_implicit_parid] = ACTIONS(8125),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2463] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_implicit_param] = STATE(18422),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(18422),
    [sym__type_context] = STATE(18422),
    [sym__type_fun] = STATE(18422),
    [sym__type] = STATE(18422),
    [sym__type_or_implicit] = STATE(18422),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym_implicit_parid] = ACTIONS(7801),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2464] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2389),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15985),
    [sym_type_parens] = STATE(2389),
    [sym_type_list] = STATE(2389),
    [sym_type_tuple] = STATE(2389),
    [sym__type_promotable_literal] = STATE(2389),
    [sym__type_promoted_literal] = STATE(2389),
    [sym__type_literal] = STATE(2389),
    [sym_type_name] = STATE(2458),
    [sym_type_star] = STATE(2389),
    [sym_type_unboxed_tuple] = STATE(2389),
    [sym_type_unboxed_sum] = STATE(2389),
    [sym__atype] = STATE(2389),
    [sym_type_apply] = STATE(8266),
    [sym__btype] = STATE(8266),
    [sym_implicit_param] = STATE(15137),
    [sym_type_infix] = STATE(12156),
    [sym__type_infix] = STATE(13219),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2701),
    [sym__type_quantifiers] = STATE(15137),
    [sym__type_context] = STATE(15137),
    [sym__type_fun] = STATE(15137),
    [sym__type] = STATE(15137),
    [sym__type_or_implicit] = STATE(15137),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2389),
    [sym_quasiquote] = STATE(2389),
    [sym__varid] = ACTIONS(7007),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8243),
    [sym_implicit_parid] = ACTIONS(8245),
    [sym__conid] = ACTIONS(8247),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(8249),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2465] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_implicit_param] = STATE(17984),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(17984),
    [sym__type_context] = STATE(17984),
    [sym__type_fun] = STATE(17984),
    [sym__type] = STATE(17984),
    [sym__type_or_implicit] = STATE(17984),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym_implicit_parid] = ACTIONS(8125),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2466] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2528),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15928),
    [sym_type_parens] = STATE(2528),
    [sym_type_list] = STATE(2528),
    [sym_type_tuple] = STATE(2528),
    [sym__type_promotable_literal] = STATE(2528),
    [sym__type_promoted_literal] = STATE(2528),
    [sym__type_literal] = STATE(2528),
    [sym_type_name] = STATE(2585),
    [sym_type_star] = STATE(2528),
    [sym_type_unboxed_tuple] = STATE(2528),
    [sym_type_unboxed_sum] = STATE(2528),
    [sym__atype] = STATE(2528),
    [sym_type_apply] = STATE(8603),
    [sym__btype] = STATE(8603),
    [sym_implicit_param] = STATE(13364),
    [sym_type_infix] = STATE(11728),
    [sym__type_infix] = STATE(11354),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2667),
    [sym__type_quantifiers] = STATE(13364),
    [sym__type_context] = STATE(13364),
    [sym__type_fun] = STATE(13364),
    [sym__type] = STATE(13364),
    [sym__type_or_implicit] = STATE(13364),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2528),
    [sym_quasiquote] = STATE(2528),
    [sym__varid] = ACTIONS(8251),
    [sym_float] = ACTIONS(8253),
    [sym_char] = ACTIONS(8253),
    [sym_string] = ACTIONS(8253),
    [sym__integer_literal] = ACTIONS(8255),
    [sym__binary_literal] = ACTIONS(8257),
    [sym__octal_literal] = ACTIONS(8257),
    [sym__hex_literal] = ACTIONS(8257),
    [anon_sym_LPAREN_POUND] = ACTIONS(8259),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8259),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8261),
    [sym_implicit_parid] = ACTIONS(8263),
    [sym__conid] = ACTIONS(8265),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_SQUOTE] = ACTIONS(8269),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8271),
    [anon_sym_u2605] = ACTIONS(8271),
    [anon_sym_u27e6] = ACTIONS(8273),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8277),
  },
  [2467] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_implicit_param] = STATE(12323),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(12323),
    [sym__type_context] = STATE(12323),
    [sym__type_fun] = STATE(12323),
    [sym__type] = STATE(12323),
    [sym__type_or_implicit] = STATE(12323),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym_implicit_parid] = ACTIONS(7787),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2468] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2307),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16032),
    [sym_type_parens] = STATE(2307),
    [sym_type_list] = STATE(2307),
    [sym_type_tuple] = STATE(2307),
    [sym__type_promotable_literal] = STATE(2307),
    [sym__type_promoted_literal] = STATE(2307),
    [sym__type_literal] = STATE(2307),
    [sym_type_name] = STATE(2424),
    [sym_type_star] = STATE(2307),
    [sym_type_unboxed_tuple] = STATE(2307),
    [sym_type_unboxed_sum] = STATE(2307),
    [sym__atype] = STATE(2307),
    [sym_type_apply] = STATE(8199),
    [sym__btype] = STATE(8199),
    [sym_implicit_param] = STATE(12971),
    [sym_type_infix] = STATE(10802),
    [sym__type_infix] = STATE(10725),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(12971),
    [sym__type_context] = STATE(12971),
    [sym__type_fun] = STATE(12971),
    [sym__type] = STATE(12971),
    [sym__type_or_implicit] = STATE(12971),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2307),
    [sym_quasiquote] = STATE(2307),
    [sym__varid] = ACTIONS(8279),
    [sym_float] = ACTIONS(6600),
    [sym_char] = ACTIONS(6600),
    [sym_string] = ACTIONS(6600),
    [sym__integer_literal] = ACTIONS(6602),
    [sym__binary_literal] = ACTIONS(6604),
    [sym__octal_literal] = ACTIONS(6604),
    [sym__hex_literal] = ACTIONS(6604),
    [anon_sym_LPAREN_POUND] = ACTIONS(6606),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6606),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8281),
    [sym_implicit_parid] = ACTIONS(8283),
    [sym__conid] = ACTIONS(8285),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6618),
    [anon_sym_u2605] = ACTIONS(6618),
    [anon_sym_u27e6] = ACTIONS(6622),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6624),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6626),
  },
  [2469] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2234),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16137),
    [sym_type_parens] = STATE(2234),
    [sym_type_list] = STATE(2234),
    [sym_type_tuple] = STATE(2234),
    [sym__type_promotable_literal] = STATE(2234),
    [sym__type_promoted_literal] = STATE(2234),
    [sym__type_literal] = STATE(2234),
    [sym_type_name] = STATE(2414),
    [sym_type_star] = STATE(2234),
    [sym_type_unboxed_tuple] = STATE(2234),
    [sym_type_unboxed_sum] = STATE(2234),
    [sym__atype] = STATE(2234),
    [sym_type_apply] = STATE(8214),
    [sym__btype] = STATE(8214),
    [sym_implicit_param] = STATE(13074),
    [sym_type_infix] = STATE(10797),
    [sym__type_infix] = STATE(10707),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2700),
    [sym__type_quantifiers] = STATE(13074),
    [sym__type_context] = STATE(13074),
    [sym__type_fun] = STATE(13074),
    [sym__type] = STATE(13074),
    [sym__type_or_implicit] = STATE(13074),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2234),
    [sym_quasiquote] = STATE(2234),
    [sym__varid] = ACTIONS(6346),
    [sym_float] = ACTIONS(6348),
    [sym_char] = ACTIONS(6348),
    [sym_string] = ACTIONS(6348),
    [sym__integer_literal] = ACTIONS(6350),
    [sym__binary_literal] = ACTIONS(6352),
    [sym__octal_literal] = ACTIONS(6352),
    [sym__hex_literal] = ACTIONS(6352),
    [anon_sym_LPAREN_POUND] = ACTIONS(6354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6354),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8289),
    [sym_implicit_parid] = ACTIONS(8291),
    [sym__conid] = ACTIONS(8293),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_SQUOTE] = ACTIONS(8295),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_u2605] = ACTIONS(6366),
    [anon_sym_u27e6] = ACTIONS(6370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6374),
  },
  [2470] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(20842),
    [sym__constraint_context] = STATE(20842),
    [sym__constraint] = STATE(20842),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14168),
    [sym__type_context] = STATE(14168),
    [sym__type_fun] = STATE(14168),
    [sym__type] = STATE(14168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2471] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_implicit_param] = STATE(18936),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(18936),
    [sym__type_context] = STATE(18936),
    [sym__type_fun] = STATE(18936),
    [sym__type] = STATE(18936),
    [sym__type_or_implicit] = STATE(18936),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym_implicit_parid] = ACTIONS(8125),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2472] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2705),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16004),
    [sym_type_parens] = STATE(2705),
    [sym_type_list] = STATE(2705),
    [sym_type_tuple] = STATE(2705),
    [sym__type_promotable_literal] = STATE(2705),
    [sym__type_promoted_literal] = STATE(2705),
    [sym__type_literal] = STATE(2705),
    [sym_type_name] = STATE(2770),
    [sym_type_star] = STATE(2705),
    [sym_type_unboxed_tuple] = STATE(2705),
    [sym_type_unboxed_sum] = STATE(2705),
    [sym__atype] = STATE(2705),
    [sym_type_apply] = STATE(9045),
    [sym__btype] = STATE(9045),
    [sym_implicit_param] = STATE(14975),
    [sym_type_infix] = STATE(13986),
    [sym__type_infix] = STATE(13589),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(14975),
    [sym__type_context] = STATE(14975),
    [sym__type_fun] = STATE(14975),
    [sym__type] = STATE(14975),
    [sym__type_or_implicit] = STATE(14975),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2705),
    [sym_quasiquote] = STATE(2705),
    [sym__varid] = ACTIONS(6206),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [sym_implicit_parid] = ACTIONS(6218),
    [sym__conid] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6224),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
  },
  [2473] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15992),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2782),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13977),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(21173),
    [sym__constraint_context] = STATE(21173),
    [sym__constraint] = STATE(21173),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2470),
    [sym__type_quantifiers] = STATE(14247),
    [sym__type_context] = STATE(14247),
    [sym__type_fun] = STATE(14247),
    [sym__type] = STATE(14247),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2474] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2441),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym_type_parens] = STATE(2441),
    [sym_type_list] = STATE(2441),
    [sym_type_tuple] = STATE(2441),
    [sym__type_promotable_literal] = STATE(2441),
    [sym__type_promoted_literal] = STATE(2441),
    [sym__type_literal] = STATE(2441),
    [sym_type_name] = STATE(2441),
    [sym_type_star] = STATE(2441),
    [sym_type_unboxed_tuple] = STATE(2441),
    [sym_type_unboxed_sum] = STATE(2441),
    [sym__atype] = STATE(2441),
    [sym_type_invisible] = STATE(2441),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2441),
    [sym_quasiquote] = STATE(2441),
    [aux_sym_type_apply_repeat1] = STATE(2441),
    [sym__varid] = ACTIONS(7925),
    [sym_float] = ACTIONS(7927),
    [sym_char] = ACTIONS(7927),
    [sym_string] = ACTIONS(7927),
    [sym__integer_literal] = ACTIONS(7929),
    [sym__binary_literal] = ACTIONS(7931),
    [sym__octal_literal] = ACTIONS(7931),
    [sym__hex_literal] = ACTIONS(7931),
    [anon_sym_LPAREN_POUND] = ACTIONS(7933),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7933),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7935),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8297),
    [anon_sym_LBRACK] = ACTIONS(7940),
    [anon_sym_SQUOTE] = ACTIONS(8300),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_u2605] = ACTIONS(7945),
    [anon_sym_AT] = ACTIONS(7947),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7949),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7951),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(7953),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2475] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2547),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16082),
    [sym_type_parens] = STATE(2547),
    [sym_type_list] = STATE(2547),
    [sym_type_tuple] = STATE(2547),
    [sym__type_promotable_literal] = STATE(2547),
    [sym__type_promoted_literal] = STATE(2547),
    [sym__type_literal] = STATE(2547),
    [sym_type_name] = STATE(2876),
    [sym_type_star] = STATE(2547),
    [sym_type_unboxed_tuple] = STATE(2547),
    [sym_type_unboxed_sum] = STATE(2547),
    [sym__atype] = STATE(2547),
    [sym_type_apply] = STATE(8875),
    [sym__btype] = STATE(8875),
    [sym_implicit_param] = STATE(20478),
    [sym_type_infix] = STATE(14686),
    [sym__type_infix] = STATE(14421),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(20478),
    [sym__type_context] = STATE(20478),
    [sym__type_fun] = STATE(20478),
    [sym__type] = STATE(20478),
    [sym__type_or_implicit] = STATE(20478),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2547),
    [sym_quasiquote] = STATE(2547),
    [sym__varid] = ACTIONS(8303),
    [sym_float] = ACTIONS(8305),
    [sym_char] = ACTIONS(8305),
    [sym_string] = ACTIONS(8305),
    [sym__integer_literal] = ACTIONS(8307),
    [sym__binary_literal] = ACTIONS(8309),
    [sym__octal_literal] = ACTIONS(8309),
    [sym__hex_literal] = ACTIONS(8309),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8311),
    [sym_implicit_parid] = ACTIONS(8313),
    [sym__conid] = ACTIONS(8315),
    [anon_sym_LBRACK] = ACTIONS(8317),
    [anon_sym_SQUOTE] = ACTIONS(8319),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8321),
    [anon_sym_u2605] = ACTIONS(8321),
    [anon_sym_u27e6] = ACTIONS(8323),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8325),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8327),
  },
  [2476] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_implicit_param] = STATE(14225),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14225),
    [sym__type_context] = STATE(14225),
    [sym__type_fun] = STATE(14225),
    [sym__type] = STATE(14225),
    [sym__type_or_implicit] = STATE(14225),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2477] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2496),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15845),
    [sym_type_parens] = STATE(2496),
    [sym_type_list] = STATE(2496),
    [sym_type_tuple] = STATE(2496),
    [sym__type_promotable_literal] = STATE(2496),
    [sym__type_promoted_literal] = STATE(2496),
    [sym__type_literal] = STATE(2496),
    [sym_type_name] = STATE(2520),
    [sym_type_star] = STATE(2496),
    [sym_type_unboxed_tuple] = STATE(2496),
    [sym_type_unboxed_sum] = STATE(2496),
    [sym__atype] = STATE(2496),
    [sym_type_apply] = STATE(8402),
    [sym__btype] = STATE(8402),
    [sym_implicit_param] = STATE(13660),
    [sym_type_infix] = STATE(11233),
    [sym__type_infix] = STATE(11065),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2738),
    [sym__type_quantifiers] = STATE(13660),
    [sym__type_context] = STATE(13660),
    [sym__type_fun] = STATE(13660),
    [sym__type] = STATE(13660),
    [sym__type_or_implicit] = STATE(13660),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2496),
    [sym_quasiquote] = STATE(2496),
    [sym__varid] = ACTIONS(8329),
    [sym_float] = ACTIONS(8049),
    [sym_char] = ACTIONS(8049),
    [sym_string] = ACTIONS(8049),
    [sym__integer_literal] = ACTIONS(8051),
    [sym__binary_literal] = ACTIONS(8053),
    [sym__octal_literal] = ACTIONS(8053),
    [sym__hex_literal] = ACTIONS(8053),
    [anon_sym_LPAREN_POUND] = ACTIONS(8055),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8055),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8331),
    [sym_implicit_parid] = ACTIONS(8333),
    [sym__conid] = ACTIONS(8335),
    [anon_sym_LBRACK] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(8337),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8067),
    [anon_sym_u2605] = ACTIONS(8067),
    [anon_sym_u27e6] = ACTIONS(8071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8073),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8075),
  },
  [2478] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2442),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym_type_parens] = STATE(2442),
    [sym_type_list] = STATE(2442),
    [sym_type_tuple] = STATE(2442),
    [sym__type_promotable_literal] = STATE(2442),
    [sym__type_promoted_literal] = STATE(2442),
    [sym__type_literal] = STATE(2442),
    [sym_type_name] = STATE(2442),
    [sym_type_star] = STATE(2442),
    [sym_type_unboxed_tuple] = STATE(2442),
    [sym_type_unboxed_sum] = STATE(2442),
    [sym__atype] = STATE(2442),
    [sym_type_invisible] = STATE(2442),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2442),
    [sym_quasiquote] = STATE(2442),
    [aux_sym_type_apply_repeat1] = STATE(2442),
    [sym__varid] = ACTIONS(7955),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7861),
    [sym_char] = ACTIONS(7861),
    [sym_string] = ACTIONS(7861),
    [sym__integer_literal] = ACTIONS(7863),
    [sym__binary_literal] = ACTIONS(7865),
    [sym__octal_literal] = ACTIONS(7865),
    [sym__hex_literal] = ACTIONS(7865),
    [anon_sym_LPAREN_POUND] = ACTIONS(7867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7867),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(7957),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8339),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_SQUOTE] = ACTIONS(8342),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(7879),
    [anon_sym_u2605] = ACTIONS(7879),
    [anon_sym_AT] = ACTIONS(7965),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7883),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7885),
  },
  [2479] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2261),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15792),
    [sym_type_parens] = STATE(2261),
    [sym_type_list] = STATE(2261),
    [sym_type_tuple] = STATE(2261),
    [sym__type_promotable_literal] = STATE(2261),
    [sym__type_promoted_literal] = STATE(2261),
    [sym__type_literal] = STATE(2261),
    [sym_type_name] = STATE(2406),
    [sym_type_star] = STATE(2261),
    [sym_type_unboxed_tuple] = STATE(2261),
    [sym_type_unboxed_sum] = STATE(2261),
    [sym__atype] = STATE(2261),
    [sym_type_apply] = STATE(8212),
    [sym__btype] = STATE(8212),
    [sym_implicit_param] = STATE(12043),
    [sym_type_infix] = STATE(10823),
    [sym__type_infix] = STATE(10721),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2622),
    [sym__type_quantifiers] = STATE(12043),
    [sym__type_context] = STATE(12043),
    [sym__type_fun] = STATE(12043),
    [sym__type] = STATE(12043),
    [sym__type_or_implicit] = STATE(12043),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2261),
    [sym_quasiquote] = STATE(2261),
    [sym__varid] = ACTIONS(8345),
    [sym_float] = ACTIONS(6440),
    [sym_char] = ACTIONS(6440),
    [sym_string] = ACTIONS(6440),
    [sym__integer_literal] = ACTIONS(6442),
    [sym__binary_literal] = ACTIONS(6444),
    [sym__octal_literal] = ACTIONS(6444),
    [sym__hex_literal] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND] = ACTIONS(6446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6446),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8347),
    [sym_implicit_parid] = ACTIONS(8349),
    [sym__conid] = ACTIONS(8351),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_SQUOTE] = ACTIONS(8353),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_u2605] = ACTIONS(6458),
    [anon_sym_u27e6] = ACTIONS(6462),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6464),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6466),
  },
  [2480] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [ts_builtin_sym_end] = ACTIONS(5542),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2481] = {
    [sym_integer] = STATE(8274),
    [sym__literal] = STATE(8274),
    [sym__unboxed_open] = STATE(2068),
    [sym_constructor] = STATE(8222),
    [sym_con_unit] = STATE(8274),
    [sym_con_list] = STATE(8274),
    [sym_con_tuple] = STATE(8274),
    [sym_qualified_type] = STATE(8300),
    [sym_tycon_arrow] = STATE(8300),
    [sym_type_literal] = STATE(3168),
    [sym__promoted_tycon] = STATE(8300),
    [sym_type_variable] = STATE(8300),
    [sym_type_parens] = STATE(3168),
    [sym_type_list] = STATE(3168),
    [sym_type_tuple] = STATE(3168),
    [sym__type_promotable_literal] = STATE(3168),
    [sym__type_promoted_literal] = STATE(3168),
    [sym__type_literal] = STATE(3168),
    [sym_strict_type] = STATE(3168),
    [sym_lazy_type] = STATE(3168),
    [sym_type_name] = STATE(3168),
    [sym_type_star] = STATE(3168),
    [sym_type_unboxed_tuple] = STATE(3168),
    [sym_type_unboxed_sum] = STATE(3168),
    [sym__atype] = STATE(3168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16645),
    [sym_record_fields] = STATE(16314),
    [sym_splice] = STATE(3168),
    [sym_quasiquote] = STATE(3168),
    [aux_sym_data_constructor_repeat1] = STATE(3168),
    [sym__varid] = ACTIONS(8355),
    [anon_sym_SEMI] = ACTIONS(7492),
    [sym_float] = ACTIONS(8358),
    [sym_char] = ACTIONS(8358),
    [sym_string] = ACTIONS(8358),
    [sym__integer_literal] = ACTIONS(8361),
    [sym__binary_literal] = ACTIONS(8364),
    [sym__octal_literal] = ACTIONS(8364),
    [sym__hex_literal] = ACTIONS(8364),
    [anon_sym_LPAREN_POUND] = ACTIONS(8367),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8367),
    [anon_sym_u21d2] = ACTIONS(7506),
    [anon_sym_EQ_GT] = ACTIONS(7506),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8370),
    [anon_sym_BQUOTE] = ACTIONS(7506),
    [sym__conid] = ACTIONS(8373),
    [anon_sym_LBRACK] = ACTIONS(8376),
    [anon_sym_SQUOTE] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(8382),
    [anon_sym_RBRACE] = ACTIONS(7492),
    [anon_sym_PIPE] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(8384),
    [anon_sym_u2605] = ACTIONS(8384),
    [anon_sym_AT] = ACTIONS(7506),
    [anon_sym_deriving] = ACTIONS(7525),
    [anon_sym_u27e6] = ACTIONS(8387),
    [aux_sym__token1] = ACTIONS(3),
    [sym__dot] = ACTIONS(7530),
    [sym__splice_dollar] = ACTIONS(8390),
    [sym__consym] = ACTIONS(7506),
    [sym__tyconsym] = ACTIONS(7506),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8393),
    [sym__strict] = ACTIONS(8396),
    [sym__lazy] = ACTIONS(8398),
  },
  [2482] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_implicit_param] = STATE(19394),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(19394),
    [sym__type_context] = STATE(19394),
    [sym__type_fun] = STATE(19394),
    [sym__type] = STATE(19394),
    [sym__type_or_implicit] = STATE(19394),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym_implicit_parid] = ACTIONS(7801),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2483] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2523),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15886),
    [sym_type_parens] = STATE(2523),
    [sym_type_list] = STATE(2523),
    [sym_type_tuple] = STATE(2523),
    [sym__type_promotable_literal] = STATE(2523),
    [sym__type_promoted_literal] = STATE(2523),
    [sym__type_literal] = STATE(2523),
    [sym_type_name] = STATE(2541),
    [sym_type_star] = STATE(2523),
    [sym_type_unboxed_tuple] = STATE(2523),
    [sym_type_unboxed_sum] = STATE(2523),
    [sym__atype] = STATE(2523),
    [sym_type_apply] = STATE(8591),
    [sym__btype] = STATE(8591),
    [sym_implicit_param] = STATE(14029),
    [sym_type_infix] = STATE(11700),
    [sym__type_infix] = STATE(11323),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2654),
    [sym__type_quantifiers] = STATE(14029),
    [sym__type_context] = STATE(14029),
    [sym__type_fun] = STATE(14029),
    [sym__type] = STATE(14029),
    [sym__type_or_implicit] = STATE(14029),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2523),
    [sym_quasiquote] = STATE(2523),
    [sym__varid] = ACTIONS(8400),
    [sym_float] = ACTIONS(8402),
    [sym_char] = ACTIONS(8402),
    [sym_string] = ACTIONS(8402),
    [sym__integer_literal] = ACTIONS(8404),
    [sym__binary_literal] = ACTIONS(8406),
    [sym__octal_literal] = ACTIONS(8406),
    [sym__hex_literal] = ACTIONS(8406),
    [anon_sym_LPAREN_POUND] = ACTIONS(8408),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8408),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [sym_implicit_parid] = ACTIONS(8412),
    [sym__conid] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8420),
    [anon_sym_u2605] = ACTIONS(8420),
    [anon_sym_u27e6] = ACTIONS(8422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8426),
  },
  [2484] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2516),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16096),
    [sym_type_parens] = STATE(2516),
    [sym_type_list] = STATE(2516),
    [sym_type_tuple] = STATE(2516),
    [sym__type_promotable_literal] = STATE(2516),
    [sym__type_promoted_literal] = STATE(2516),
    [sym__type_literal] = STATE(2516),
    [sym_type_name] = STATE(2569),
    [sym_type_star] = STATE(2516),
    [sym_type_unboxed_tuple] = STATE(2516),
    [sym_type_unboxed_sum] = STATE(2516),
    [sym__atype] = STATE(2516),
    [sym_type_apply] = STATE(8678),
    [sym__btype] = STATE(8678),
    [sym_implicit_param] = STATE(15460),
    [sym_type_infix] = STATE(13540),
    [sym__type_infix] = STATE(12787),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2677),
    [sym__type_quantifiers] = STATE(15460),
    [sym__type_context] = STATE(15460),
    [sym__type_fun] = STATE(15460),
    [sym__type] = STATE(15460),
    [sym__type_or_implicit] = STATE(15460),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2516),
    [sym_quasiquote] = STATE(2516),
    [sym__varid] = ACTIONS(8428),
    [sym_float] = ACTIONS(8430),
    [sym_char] = ACTIONS(8430),
    [sym_string] = ACTIONS(8430),
    [sym__integer_literal] = ACTIONS(8432),
    [sym__binary_literal] = ACTIONS(8434),
    [sym__octal_literal] = ACTIONS(8434),
    [sym__hex_literal] = ACTIONS(8434),
    [anon_sym_LPAREN_POUND] = ACTIONS(8436),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8436),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8438),
    [sym_implicit_parid] = ACTIONS(8440),
    [sym__conid] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8444),
    [anon_sym_SQUOTE] = ACTIONS(8446),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8448),
    [anon_sym_u2605] = ACTIONS(8448),
    [anon_sym_u27e6] = ACTIONS(8450),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8452),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8454),
  },
  [2485] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2627),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15735),
    [sym_type_parens] = STATE(2627),
    [sym_type_list] = STATE(2627),
    [sym_type_tuple] = STATE(2627),
    [sym__type_promotable_literal] = STATE(2627),
    [sym__type_promoted_literal] = STATE(2627),
    [sym__type_literal] = STATE(2627),
    [sym_type_name] = STATE(2780),
    [sym_type_star] = STATE(2627),
    [sym_type_unboxed_tuple] = STATE(2627),
    [sym_type_unboxed_sum] = STATE(2627),
    [sym__atype] = STATE(2627),
    [sym_type_apply] = STATE(9005),
    [sym__btype] = STATE(9005),
    [sym_implicit_param] = STATE(17796),
    [sym_type_infix] = STATE(13888),
    [sym__type_infix] = STATE(13584),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(17796),
    [sym__type_context] = STATE(17796),
    [sym__type_fun] = STATE(17796),
    [sym__type] = STATE(17796),
    [sym__type_or_implicit] = STATE(17796),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2627),
    [sym_quasiquote] = STATE(2627),
    [sym__varid] = ACTIONS(8456),
    [sym_float] = ACTIONS(8458),
    [sym_char] = ACTIONS(8458),
    [sym_string] = ACTIONS(8458),
    [sym__integer_literal] = ACTIONS(8460),
    [sym__binary_literal] = ACTIONS(8462),
    [sym__octal_literal] = ACTIONS(8462),
    [sym__hex_literal] = ACTIONS(8462),
    [anon_sym_LPAREN_POUND] = ACTIONS(8464),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8464),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [sym_implicit_parid] = ACTIONS(8468),
    [sym__conid] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8472),
    [anon_sym_SQUOTE] = ACTIONS(8474),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8476),
    [anon_sym_u2605] = ACTIONS(8476),
    [anon_sym_u27e6] = ACTIONS(8478),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8480),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8482),
  },
  [2486] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16031),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2710),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(8872),
    [sym__btype] = STATE(8872),
    [sym_implicit_param] = STATE(15870),
    [sym_type_infix] = STATE(13706),
    [sym__type_infix] = STATE(13428),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2716),
    [sym__type_quantifiers] = STATE(15870),
    [sym__type_context] = STATE(15870),
    [sym__type_fun] = STATE(15870),
    [sym__type] = STATE(15870),
    [sym__type_or_implicit] = STATE(15870),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(8484),
    [sym_float] = ACTIONS(8486),
    [sym_char] = ACTIONS(8486),
    [sym_string] = ACTIONS(8486),
    [sym__integer_literal] = ACTIONS(8488),
    [sym__binary_literal] = ACTIONS(8490),
    [sym__octal_literal] = ACTIONS(8490),
    [sym__hex_literal] = ACTIONS(8490),
    [anon_sym_LPAREN_POUND] = ACTIONS(8492),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8492),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8494),
    [sym_implicit_parid] = ACTIONS(8496),
    [sym__conid] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8504),
    [anon_sym_u2605] = ACTIONS(8504),
    [anon_sym_u27e6] = ACTIONS(8506),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8508),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8510),
  },
  [2487] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2356),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15936),
    [sym_type_parens] = STATE(2356),
    [sym_type_list] = STATE(2356),
    [sym_type_tuple] = STATE(2356),
    [sym__type_promotable_literal] = STATE(2356),
    [sym__type_promoted_literal] = STATE(2356),
    [sym__type_literal] = STATE(2356),
    [sym_type_name] = STATE(2419),
    [sym_type_star] = STATE(2356),
    [sym_type_unboxed_tuple] = STATE(2356),
    [sym_type_unboxed_sum] = STATE(2356),
    [sym__atype] = STATE(2356),
    [sym_type_apply] = STATE(8215),
    [sym__btype] = STATE(8215),
    [sym_implicit_param] = STATE(13145),
    [sym_type_infix] = STATE(10841),
    [sym__type_infix] = STATE(10710),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2656),
    [sym__type_quantifiers] = STATE(13145),
    [sym__type_context] = STATE(13145),
    [sym__type_fun] = STATE(13145),
    [sym__type] = STATE(13145),
    [sym__type_or_implicit] = STATE(13145),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2356),
    [sym_quasiquote] = STATE(2356),
    [sym__varid] = ACTIONS(6801),
    [sym_float] = ACTIONS(6803),
    [sym_char] = ACTIONS(6803),
    [sym_string] = ACTIONS(6803),
    [sym__integer_literal] = ACTIONS(6805),
    [sym__binary_literal] = ACTIONS(6807),
    [sym__octal_literal] = ACTIONS(6807),
    [sym__hex_literal] = ACTIONS(6807),
    [anon_sym_LPAREN_POUND] = ACTIONS(6809),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6809),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8512),
    [sym_implicit_parid] = ACTIONS(8514),
    [sym__conid] = ACTIONS(8516),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_SQUOTE] = ACTIONS(8518),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6821),
    [anon_sym_u2605] = ACTIONS(6821),
    [anon_sym_u27e6] = ACTIONS(6825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6829),
  },
  [2488] = {
    [sym_integer] = STATE(8192),
    [sym__literal] = STATE(8192),
    [sym__unboxed_open] = STATE(2119),
    [sym_constructor] = STATE(8160),
    [sym_con_unit] = STATE(8192),
    [sym_con_list] = STATE(8192),
    [sym_con_tuple] = STATE(8192),
    [sym_qualified_type] = STATE(8196),
    [sym_tycon_arrow] = STATE(8196),
    [sym_type_literal] = STATE(2772),
    [sym__promoted_tycon] = STATE(8196),
    [sym_type_variable] = STATE(8196),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15861),
    [sym_type_parens] = STATE(2772),
    [sym_type_list] = STATE(2772),
    [sym_type_tuple] = STATE(2772),
    [sym__type_promotable_literal] = STATE(2772),
    [sym__type_promoted_literal] = STATE(2772),
    [sym__type_literal] = STATE(2772),
    [sym_type_name] = STATE(2796),
    [sym_type_star] = STATE(2772),
    [sym_type_unboxed_tuple] = STATE(2772),
    [sym_type_unboxed_sum] = STATE(2772),
    [sym__atype] = STATE(2772),
    [sym_type_apply] = STATE(9496),
    [sym__btype] = STATE(9496),
    [sym_implicit_param] = STATE(18459),
    [sym_type_infix] = STATE(14416),
    [sym__type_infix] = STATE(13973),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2757),
    [sym__type_quantifiers] = STATE(18459),
    [sym__type_context] = STATE(18459),
    [sym__type_fun] = STATE(18459),
    [sym__type] = STATE(18459),
    [sym__type_or_implicit] = STATE(18459),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16417),
    [sym_splice] = STATE(2772),
    [sym_quasiquote] = STATE(2772),
    [sym__varid] = ACTIONS(8520),
    [sym_float] = ACTIONS(8522),
    [sym_char] = ACTIONS(8522),
    [sym_string] = ACTIONS(8522),
    [sym__integer_literal] = ACTIONS(8524),
    [sym__binary_literal] = ACTIONS(8526),
    [sym__octal_literal] = ACTIONS(8526),
    [sym__hex_literal] = ACTIONS(8526),
    [anon_sym_LPAREN_POUND] = ACTIONS(8528),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8528),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8530),
    [sym_implicit_parid] = ACTIONS(8532),
    [sym__conid] = ACTIONS(8534),
    [anon_sym_LBRACK] = ACTIONS(8536),
    [anon_sym_SQUOTE] = ACTIONS(8538),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8540),
    [anon_sym_u2605] = ACTIONS(8540),
    [anon_sym_u27e6] = ACTIONS(8542),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8544),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8546),
  },
  [2489] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2589),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15746),
    [sym_type_parens] = STATE(2589),
    [sym_type_list] = STATE(2589),
    [sym_type_tuple] = STATE(2589),
    [sym__type_promotable_literal] = STATE(2589),
    [sym__type_promoted_literal] = STATE(2589),
    [sym__type_literal] = STATE(2589),
    [sym_type_name] = STATE(2760),
    [sym_type_star] = STATE(2589),
    [sym_type_unboxed_tuple] = STATE(2589),
    [sym_type_unboxed_sum] = STATE(2589),
    [sym__atype] = STATE(2589),
    [sym_type_apply] = STATE(9077),
    [sym__btype] = STATE(9077),
    [sym_implicit_param] = STATE(17009),
    [sym_type_infix] = STATE(14083),
    [sym__type_infix] = STATE(13579),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2617),
    [sym__type_quantifiers] = STATE(17009),
    [sym__type_context] = STATE(17009),
    [sym__type_fun] = STATE(17009),
    [sym__type] = STATE(17009),
    [sym__type_or_implicit] = STATE(17009),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2589),
    [sym_quasiquote] = STATE(2589),
    [sym__varid] = ACTIONS(8548),
    [sym_float] = ACTIONS(8550),
    [sym_char] = ACTIONS(8550),
    [sym_string] = ACTIONS(8550),
    [sym__integer_literal] = ACTIONS(8552),
    [sym__binary_literal] = ACTIONS(8554),
    [sym__octal_literal] = ACTIONS(8554),
    [sym__hex_literal] = ACTIONS(8554),
    [anon_sym_LPAREN_POUND] = ACTIONS(8556),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8556),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [sym_implicit_parid] = ACTIONS(8560),
    [sym__conid] = ACTIONS(8562),
    [anon_sym_LBRACK] = ACTIONS(8564),
    [anon_sym_SQUOTE] = ACTIONS(8566),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8568),
    [anon_sym_u2605] = ACTIONS(8568),
    [anon_sym_u27e6] = ACTIONS(8570),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8572),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8574),
  },
  [2490] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2490),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym_type_parens] = STATE(2490),
    [sym_type_list] = STATE(2490),
    [sym_type_tuple] = STATE(2490),
    [sym__type_promotable_literal] = STATE(2490),
    [sym__type_promoted_literal] = STATE(2490),
    [sym__type_literal] = STATE(2490),
    [sym_type_name] = STATE(2490),
    [sym_type_star] = STATE(2490),
    [sym_type_unboxed_tuple] = STATE(2490),
    [sym_type_unboxed_sum] = STATE(2490),
    [sym__atype] = STATE(2490),
    [sym_type_invisible] = STATE(2490),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2490),
    [sym_quasiquote] = STATE(2490),
    [aux_sym_type_apply_repeat1] = STATE(2490),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(8576),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(8579),
    [sym_char] = ACTIONS(8579),
    [sym_string] = ACTIONS(8579),
    [sym__integer_literal] = ACTIONS(8582),
    [sym__binary_literal] = ACTIONS(8585),
    [sym__octal_literal] = ACTIONS(8585),
    [sym__hex_literal] = ACTIONS(8585),
    [anon_sym_LPAREN_POUND] = ACTIONS(8588),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8588),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(8591),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(8594),
    [anon_sym_LBRACK] = ACTIONS(8597),
    [anon_sym_SQUOTE] = ACTIONS(8600),
    [anon_sym_STAR] = ACTIONS(8603),
    [anon_sym_u2605] = ACTIONS(8603),
    [anon_sym_AT] = ACTIONS(8606),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(8609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(8612),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8615),
  },
  [2491] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2404),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16220),
    [sym_type_parens] = STATE(2404),
    [sym_type_list] = STATE(2404),
    [sym_type_tuple] = STATE(2404),
    [sym__type_promotable_literal] = STATE(2404),
    [sym__type_promoted_literal] = STATE(2404),
    [sym__type_literal] = STATE(2404),
    [sym_type_name] = STATE(2428),
    [sym_type_star] = STATE(2404),
    [sym_type_unboxed_tuple] = STATE(2404),
    [sym_type_unboxed_sum] = STATE(2404),
    [sym__atype] = STATE(2404),
    [sym_type_apply] = STATE(8296),
    [sym__btype] = STATE(8296),
    [sym_implicit_param] = STATE(13270),
    [sym_type_infix] = STATE(11075),
    [sym__type_infix] = STATE(10865),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2758),
    [sym__type_quantifiers] = STATE(13270),
    [sym__type_context] = STATE(13270),
    [sym__type_fun] = STATE(13270),
    [sym__type] = STATE(13270),
    [sym__type_or_implicit] = STATE(13270),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2404),
    [sym_quasiquote] = STATE(2404),
    [sym__varid] = ACTIONS(7443),
    [sym_float] = ACTIONS(7445),
    [sym_char] = ACTIONS(7445),
    [sym_string] = ACTIONS(7445),
    [sym__integer_literal] = ACTIONS(7447),
    [sym__binary_literal] = ACTIONS(7449),
    [sym__octal_literal] = ACTIONS(7449),
    [sym__hex_literal] = ACTIONS(7449),
    [anon_sym_LPAREN_POUND] = ACTIONS(7451),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8618),
    [sym_implicit_parid] = ACTIONS(8620),
    [sym__conid] = ACTIONS(8622),
    [anon_sym_LBRACK] = ACTIONS(7458),
    [anon_sym_SQUOTE] = ACTIONS(8624),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7463),
    [anon_sym_u2605] = ACTIONS(7463),
    [anon_sym_u27e6] = ACTIONS(7467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7469),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7471),
  },
  [2492] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2609),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15799),
    [sym_type_parens] = STATE(2609),
    [sym_type_list] = STATE(2609),
    [sym_type_tuple] = STATE(2609),
    [sym__type_promotable_literal] = STATE(2609),
    [sym__type_promoted_literal] = STATE(2609),
    [sym__type_literal] = STATE(2609),
    [sym_type_name] = STATE(2766),
    [sym_type_star] = STATE(2609),
    [sym_type_unboxed_tuple] = STATE(2609),
    [sym_type_unboxed_sum] = STATE(2609),
    [sym__atype] = STATE(2609),
    [sym_type_apply] = STATE(9336),
    [sym__btype] = STATE(9336),
    [sym_implicit_param] = STATE(17673),
    [sym_type_infix] = STATE(13971),
    [sym__type_infix] = STATE(13800),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2629),
    [sym__type_quantifiers] = STATE(17673),
    [sym__type_context] = STATE(17673),
    [sym__type_fun] = STATE(17673),
    [sym__type] = STATE(17673),
    [sym__type_or_implicit] = STATE(17673),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2609),
    [sym_quasiquote] = STATE(2609),
    [sym__varid] = ACTIONS(8626),
    [sym_float] = ACTIONS(8628),
    [sym_char] = ACTIONS(8628),
    [sym_string] = ACTIONS(8628),
    [sym__integer_literal] = ACTIONS(8630),
    [sym__binary_literal] = ACTIONS(8632),
    [sym__octal_literal] = ACTIONS(8632),
    [sym__hex_literal] = ACTIONS(8632),
    [anon_sym_LPAREN_POUND] = ACTIONS(8634),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8634),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8636),
    [sym_implicit_parid] = ACTIONS(8638),
    [sym__conid] = ACTIONS(8640),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_SQUOTE] = ACTIONS(8644),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8646),
    [anon_sym_u2605] = ACTIONS(8646),
    [anon_sym_u27e6] = ACTIONS(8648),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8650),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8652),
  },
  [2493] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_implicit_param] = STATE(18009),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(18009),
    [sym__type_context] = STATE(18009),
    [sym__type_fun] = STATE(18009),
    [sym__type] = STATE(18009),
    [sym__type_or_implicit] = STATE(18009),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym_implicit_parid] = ACTIONS(8125),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2494] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [ts_builtin_sym_end] = ACTIONS(5542),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_deriving] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2495] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2395),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15998),
    [sym_type_parens] = STATE(2395),
    [sym_type_list] = STATE(2395),
    [sym_type_tuple] = STATE(2395),
    [sym__type_promotable_literal] = STATE(2395),
    [sym__type_promoted_literal] = STATE(2395),
    [sym__type_literal] = STATE(2395),
    [sym_type_name] = STATE(2461),
    [sym_type_star] = STATE(2395),
    [sym_type_unboxed_tuple] = STATE(2395),
    [sym_type_unboxed_sum] = STATE(2395),
    [sym__atype] = STATE(2395),
    [sym_type_apply] = STATE(8269),
    [sym__btype] = STATE(8269),
    [sym_implicit_param] = STATE(13354),
    [sym_type_infix] = STATE(11067),
    [sym__type_infix] = STATE(10857),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2709),
    [sym__type_quantifiers] = STATE(13354),
    [sym__type_context] = STATE(13354),
    [sym__type_fun] = STATE(13354),
    [sym__type] = STATE(13354),
    [sym__type_or_implicit] = STATE(13354),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2395),
    [sym_quasiquote] = STATE(2395),
    [sym__varid] = ACTIONS(8654),
    [sym_float] = ACTIONS(7189),
    [sym_char] = ACTIONS(7189),
    [sym_string] = ACTIONS(7189),
    [sym__integer_literal] = ACTIONS(7191),
    [sym__binary_literal] = ACTIONS(7193),
    [sym__octal_literal] = ACTIONS(7193),
    [sym__hex_literal] = ACTIONS(7193),
    [anon_sym_LPAREN_POUND] = ACTIONS(7195),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7195),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8656),
    [sym_implicit_parid] = ACTIONS(8658),
    [sym__conid] = ACTIONS(8660),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_SQUOTE] = ACTIONS(8662),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_u2605] = ACTIONS(7207),
    [anon_sym_u27e6] = ACTIONS(7211),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7213),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7215),
  },
  [2496] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2448),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym_type_parens] = STATE(2448),
    [sym_type_list] = STATE(2448),
    [sym_type_tuple] = STATE(2448),
    [sym__type_promotable_literal] = STATE(2448),
    [sym__type_promoted_literal] = STATE(2448),
    [sym__type_literal] = STATE(2448),
    [sym_type_name] = STATE(2448),
    [sym_type_star] = STATE(2448),
    [sym_type_unboxed_tuple] = STATE(2448),
    [sym_type_unboxed_sum] = STATE(2448),
    [sym__atype] = STATE(2448),
    [sym_type_invisible] = STATE(2448),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2448),
    [sym_quasiquote] = STATE(2448),
    [aux_sym_type_apply_repeat1] = STATE(2448),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(8047),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8049),
    [sym_char] = ACTIONS(8049),
    [sym_string] = ACTIONS(8049),
    [sym__integer_literal] = ACTIONS(8051),
    [sym__binary_literal] = ACTIONS(8053),
    [sym__octal_literal] = ACTIONS(8053),
    [sym__hex_literal] = ACTIONS(8053),
    [anon_sym_LPAREN_POUND] = ACTIONS(8055),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8055),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(8057),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8664),
    [anon_sym_LBRACK] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(8667),
    [anon_sym_STAR] = ACTIONS(8067),
    [anon_sym_u2605] = ACTIONS(8067),
    [anon_sym_AT] = ACTIONS(8069),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8073),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8075),
  },
  [2497] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2401),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16139),
    [sym_type_parens] = STATE(2401),
    [sym_type_list] = STATE(2401),
    [sym_type_tuple] = STATE(2401),
    [sym__type_promotable_literal] = STATE(2401),
    [sym__type_promoted_literal] = STATE(2401),
    [sym__type_literal] = STATE(2401),
    [sym_type_name] = STATE(2432),
    [sym_type_star] = STATE(2401),
    [sym_type_unboxed_tuple] = STATE(2401),
    [sym_type_unboxed_sum] = STATE(2401),
    [sym__atype] = STATE(2401),
    [sym_type_apply] = STATE(8298),
    [sym__btype] = STATE(8298),
    [sym_implicit_param] = STATE(13562),
    [sym_type_infix] = STATE(10960),
    [sym__type_infix] = STATE(10814),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2715),
    [sym__type_quantifiers] = STATE(13562),
    [sym__type_context] = STATE(13562),
    [sym__type_fun] = STATE(13562),
    [sym__type] = STATE(13562),
    [sym__type_or_implicit] = STATE(13562),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2401),
    [sym_quasiquote] = STATE(2401),
    [sym__varid] = ACTIONS(8670),
    [sym_float] = ACTIONS(6949),
    [sym_char] = ACTIONS(6949),
    [sym_string] = ACTIONS(6949),
    [sym__integer_literal] = ACTIONS(6951),
    [sym__binary_literal] = ACTIONS(6953),
    [sym__octal_literal] = ACTIONS(6953),
    [sym__hex_literal] = ACTIONS(6953),
    [anon_sym_LPAREN_POUND] = ACTIONS(6955),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6955),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8672),
    [sym_implicit_parid] = ACTIONS(8674),
    [sym__conid] = ACTIONS(8676),
    [anon_sym_LBRACK] = ACTIONS(6962),
    [anon_sym_SQUOTE] = ACTIONS(8678),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6967),
    [anon_sym_u2605] = ACTIONS(6967),
    [anon_sym_u27e6] = ACTIONS(6971),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6973),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6975),
  },
  [2498] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2499] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2578),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16239),
    [sym_type_parens] = STATE(2578),
    [sym_type_list] = STATE(2578),
    [sym_type_tuple] = STATE(2578),
    [sym__type_promotable_literal] = STATE(2578),
    [sym__type_promoted_literal] = STATE(2578),
    [sym__type_literal] = STATE(2578),
    [sym_type_name] = STATE(2739),
    [sym_type_star] = STATE(2578),
    [sym_type_unboxed_tuple] = STATE(2578),
    [sym_type_unboxed_sum] = STATE(2578),
    [sym__atype] = STATE(2578),
    [sym_type_apply] = STATE(8886),
    [sym__btype] = STATE(8886),
    [sym_implicit_param] = STATE(16123),
    [sym_type_infix] = STATE(13572),
    [sym__type_infix] = STATE(13297),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2754),
    [sym__type_quantifiers] = STATE(16123),
    [sym__type_context] = STATE(16123),
    [sym__type_fun] = STATE(16123),
    [sym__type] = STATE(16123),
    [sym__type_or_implicit] = STATE(16123),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2578),
    [sym_quasiquote] = STATE(2578),
    [sym__varid] = ACTIONS(8680),
    [sym_float] = ACTIONS(8682),
    [sym_char] = ACTIONS(8682),
    [sym_string] = ACTIONS(8682),
    [sym__integer_literal] = ACTIONS(8684),
    [sym__binary_literal] = ACTIONS(8686),
    [sym__octal_literal] = ACTIONS(8686),
    [sym__hex_literal] = ACTIONS(8686),
    [anon_sym_LPAREN_POUND] = ACTIONS(8688),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8688),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8690),
    [sym_implicit_parid] = ACTIONS(8692),
    [sym__conid] = ACTIONS(8694),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_SQUOTE] = ACTIONS(8698),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8700),
    [anon_sym_u2605] = ACTIONS(8700),
    [anon_sym_u27e6] = ACTIONS(8702),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8704),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8706),
  },
  [2500] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2500),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym_type_parens] = STATE(2500),
    [sym_type_list] = STATE(2500),
    [sym_type_tuple] = STATE(2500),
    [sym__type_promotable_literal] = STATE(2500),
    [sym__type_promoted_literal] = STATE(2500),
    [sym__type_literal] = STATE(2500),
    [sym_type_name] = STATE(2500),
    [sym_type_star] = STATE(2500),
    [sym_type_unboxed_tuple] = STATE(2500),
    [sym_type_unboxed_sum] = STATE(2500),
    [sym__atype] = STATE(2500),
    [sym_type_invisible] = STATE(2500),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2500),
    [sym_quasiquote] = STATE(2500),
    [aux_sym_type_apply_repeat1] = STATE(2500),
    [sym__varid] = ACTIONS(8708),
    [sym_float] = ACTIONS(8711),
    [sym_char] = ACTIONS(8711),
    [sym_string] = ACTIONS(8711),
    [sym__integer_literal] = ACTIONS(8714),
    [sym__binary_literal] = ACTIONS(8717),
    [sym__octal_literal] = ACTIONS(8717),
    [sym__hex_literal] = ACTIONS(8717),
    [anon_sym_LPAREN_POUND] = ACTIONS(8720),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8720),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(8723),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(8726),
    [anon_sym_LBRACK] = ACTIONS(8729),
    [anon_sym_SQUOTE] = ACTIONS(8732),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(8735),
    [anon_sym_u2605] = ACTIONS(8735),
    [anon_sym_AT] = ACTIONS(8738),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(8741),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8744),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(8747),
    [sym__unboxed_close] = ACTIONS(5496),
  },
  [2501] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2391),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16148),
    [sym_type_parens] = STATE(2391),
    [sym_type_list] = STATE(2391),
    [sym_type_tuple] = STATE(2391),
    [sym__type_promotable_literal] = STATE(2391),
    [sym__type_promoted_literal] = STATE(2391),
    [sym__type_literal] = STATE(2391),
    [sym_type_name] = STATE(2498),
    [sym_type_star] = STATE(2391),
    [sym_type_unboxed_tuple] = STATE(2391),
    [sym_type_unboxed_sum] = STATE(2391),
    [sym__atype] = STATE(2391),
    [sym_type_apply] = STATE(8246),
    [sym__btype] = STATE(8246),
    [sym_implicit_param] = STATE(13382),
    [sym_type_infix] = STATE(11005),
    [sym__type_infix] = STATE(10872),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2743),
    [sym__type_quantifiers] = STATE(13382),
    [sym__type_context] = STATE(13382),
    [sym__type_fun] = STATE(13382),
    [sym__type] = STATE(13382),
    [sym__type_or_implicit] = STATE(13382),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2391),
    [sym_quasiquote] = STATE(2391),
    [sym__varid] = ACTIONS(8750),
    [sym_float] = ACTIONS(7069),
    [sym_char] = ACTIONS(7069),
    [sym_string] = ACTIONS(7069),
    [sym__integer_literal] = ACTIONS(7071),
    [sym__binary_literal] = ACTIONS(7073),
    [sym__octal_literal] = ACTIONS(7073),
    [sym__hex_literal] = ACTIONS(7073),
    [anon_sym_LPAREN_POUND] = ACTIONS(7075),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7075),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8752),
    [sym_implicit_parid] = ACTIONS(8754),
    [sym__conid] = ACTIONS(8756),
    [anon_sym_LBRACK] = ACTIONS(7082),
    [anon_sym_SQUOTE] = ACTIONS(8758),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7087),
    [anon_sym_u2605] = ACTIONS(7087),
    [anon_sym_u27e6] = ACTIONS(7091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7093),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7095),
  },
  [2502] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2507),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15949),
    [sym_type_parens] = STATE(2507),
    [sym_type_list] = STATE(2507),
    [sym_type_tuple] = STATE(2507),
    [sym__type_promotable_literal] = STATE(2507),
    [sym__type_promoted_literal] = STATE(2507),
    [sym__type_literal] = STATE(2507),
    [sym_type_name] = STATE(2511),
    [sym_type_star] = STATE(2507),
    [sym_type_unboxed_tuple] = STATE(2507),
    [sym_type_unboxed_sum] = STATE(2507),
    [sym__atype] = STATE(2507),
    [sym_type_apply] = STATE(8483),
    [sym__btype] = STATE(8483),
    [sym_implicit_param] = STATE(13581),
    [sym_type_infix] = STATE(11205),
    [sym__type_infix] = STATE(11136),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2680),
    [sym__type_quantifiers] = STATE(13581),
    [sym__type_context] = STATE(13581),
    [sym__type_fun] = STATE(13581),
    [sym__type] = STATE(13581),
    [sym__type_or_implicit] = STATE(13581),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2507),
    [sym_quasiquote] = STATE(2507),
    [sym__varid] = ACTIONS(8760),
    [sym_float] = ACTIONS(8762),
    [sym_char] = ACTIONS(8762),
    [sym_string] = ACTIONS(8762),
    [sym__integer_literal] = ACTIONS(8764),
    [sym__binary_literal] = ACTIONS(8766),
    [sym__octal_literal] = ACTIONS(8766),
    [sym__hex_literal] = ACTIONS(8766),
    [anon_sym_LPAREN_POUND] = ACTIONS(8768),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8768),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8770),
    [sym_implicit_parid] = ACTIONS(8772),
    [sym__conid] = ACTIONS(8774),
    [anon_sym_LBRACK] = ACTIONS(8776),
    [anon_sym_SQUOTE] = ACTIONS(8778),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8780),
    [anon_sym_u2605] = ACTIONS(8780),
    [anon_sym_u27e6] = ACTIONS(8782),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8784),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8786),
  },
  [2503] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2544),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15690),
    [sym_type_parens] = STATE(2544),
    [sym_type_list] = STATE(2544),
    [sym_type_tuple] = STATE(2544),
    [sym__type_promotable_literal] = STATE(2544),
    [sym__type_promoted_literal] = STATE(2544),
    [sym__type_literal] = STATE(2544),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2544),
    [sym_type_unboxed_tuple] = STATE(2544),
    [sym_type_unboxed_sum] = STATE(2544),
    [sym__atype] = STATE(2544),
    [sym_type_apply] = STATE(8832),
    [sym__btype] = STATE(8832),
    [sym_implicit_param] = STATE(15709),
    [sym_type_infix] = STATE(13734),
    [sym__type_infix] = STATE(13357),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2602),
    [sym__type_quantifiers] = STATE(15709),
    [sym__type_context] = STATE(15709),
    [sym__type_fun] = STATE(15709),
    [sym__type] = STATE(15709),
    [sym__type_or_implicit] = STATE(15709),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2544),
    [sym_quasiquote] = STATE(2544),
    [sym__varid] = ACTIONS(8788),
    [sym_float] = ACTIONS(8790),
    [sym_char] = ACTIONS(8790),
    [sym_string] = ACTIONS(8790),
    [sym__integer_literal] = ACTIONS(8792),
    [sym__binary_literal] = ACTIONS(8794),
    [sym__octal_literal] = ACTIONS(8794),
    [sym__hex_literal] = ACTIONS(8794),
    [anon_sym_LPAREN_POUND] = ACTIONS(8796),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8796),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8798),
    [sym_implicit_parid] = ACTIONS(8800),
    [sym__conid] = ACTIONS(8802),
    [anon_sym_LBRACK] = ACTIONS(8804),
    [anon_sym_SQUOTE] = ACTIONS(8806),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8808),
    [anon_sym_u2605] = ACTIONS(8808),
    [anon_sym_u27e6] = ACTIONS(8810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8812),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8814),
  },
  [2504] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2449),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym_type_parens] = STATE(2449),
    [sym_type_list] = STATE(2449),
    [sym_type_tuple] = STATE(2449),
    [sym__type_promotable_literal] = STATE(2449),
    [sym__type_promoted_literal] = STATE(2449),
    [sym__type_literal] = STATE(2449),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2449),
    [sym_type_unboxed_tuple] = STATE(2449),
    [sym_type_unboxed_sum] = STATE(2449),
    [sym__atype] = STATE(2449),
    [sym_type_invisible] = STATE(2449),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2449),
    [sym_quasiquote] = STATE(2449),
    [aux_sym_type_apply_repeat1] = STATE(2449),
    [sym__varid] = ACTIONS(8077),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8087),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8816),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8819),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_AT] = ACTIONS(8099),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2505] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2256),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15804),
    [sym_type_parens] = STATE(2256),
    [sym_type_list] = STATE(2256),
    [sym_type_tuple] = STATE(2256),
    [sym__type_promotable_literal] = STATE(2256),
    [sym__type_promoted_literal] = STATE(2256),
    [sym__type_literal] = STATE(2256),
    [sym_type_name] = STATE(2418),
    [sym_type_star] = STATE(2256),
    [sym_type_unboxed_tuple] = STATE(2256),
    [sym_type_unboxed_sum] = STATE(2256),
    [sym__atype] = STATE(2256),
    [sym_type_apply] = STATE(8232),
    [sym__btype] = STATE(8232),
    [sym_implicit_param] = STATE(11982),
    [sym_type_infix] = STATE(10885),
    [sym__type_infix] = STATE(10714),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2655),
    [sym__type_quantifiers] = STATE(11982),
    [sym__type_context] = STATE(11982),
    [sym__type_fun] = STATE(11982),
    [sym__type] = STATE(11982),
    [sym__type_or_implicit] = STATE(11982),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2256),
    [sym_quasiquote] = STATE(2256),
    [sym__varid] = ACTIONS(8822),
    [sym_float] = ACTIONS(6398),
    [sym_char] = ACTIONS(6398),
    [sym_string] = ACTIONS(6398),
    [sym__integer_literal] = ACTIONS(6400),
    [sym__binary_literal] = ACTIONS(6402),
    [sym__octal_literal] = ACTIONS(6402),
    [sym__hex_literal] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND] = ACTIONS(6404),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6404),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8824),
    [sym_implicit_parid] = ACTIONS(8826),
    [sym__conid] = ACTIONS(8828),
    [anon_sym_LBRACK] = ACTIONS(6411),
    [anon_sym_SQUOTE] = ACTIONS(8830),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_u2605] = ACTIONS(6416),
    [anon_sym_u27e6] = ACTIONS(6420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6422),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6424),
  },
  [2506] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2504),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15986),
    [sym_type_parens] = STATE(2504),
    [sym_type_list] = STATE(2504),
    [sym_type_tuple] = STATE(2504),
    [sym__type_promotable_literal] = STATE(2504),
    [sym__type_promoted_literal] = STATE(2504),
    [sym__type_literal] = STATE(2504),
    [sym_type_name] = STATE(2522),
    [sym_type_star] = STATE(2504),
    [sym_type_unboxed_tuple] = STATE(2504),
    [sym_type_unboxed_sum] = STATE(2504),
    [sym__atype] = STATE(2504),
    [sym_type_apply] = STATE(8442),
    [sym__btype] = STATE(8442),
    [sym_implicit_param] = STATE(16088),
    [sym_type_infix] = STATE(12864),
    [sym__type_infix] = STATE(13441),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2645),
    [sym__type_quantifiers] = STATE(16088),
    [sym__type_context] = STATE(16088),
    [sym__type_fun] = STATE(16088),
    [sym__type] = STATE(16088),
    [sym__type_or_implicit] = STATE(16088),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2504),
    [sym_quasiquote] = STATE(2504),
    [sym__varid] = ACTIONS(8077),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8832),
    [sym_implicit_parid] = ACTIONS(8834),
    [sym__conid] = ACTIONS(8836),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8838),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2507] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2510),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym_type_parens] = STATE(2510),
    [sym_type_list] = STATE(2510),
    [sym_type_tuple] = STATE(2510),
    [sym__type_promotable_literal] = STATE(2510),
    [sym__type_promoted_literal] = STATE(2510),
    [sym__type_literal] = STATE(2510),
    [sym_type_name] = STATE(2510),
    [sym_type_star] = STATE(2510),
    [sym_type_unboxed_tuple] = STATE(2510),
    [sym_type_unboxed_sum] = STATE(2510),
    [sym__atype] = STATE(2510),
    [sym_type_invisible] = STATE(2510),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2510),
    [sym_quasiquote] = STATE(2510),
    [aux_sym_type_apply_repeat1] = STATE(2510),
    [sym__varid] = ACTIONS(8840),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8762),
    [sym_char] = ACTIONS(8762),
    [sym_string] = ACTIONS(8762),
    [sym__integer_literal] = ACTIONS(8764),
    [sym__binary_literal] = ACTIONS(8766),
    [sym__octal_literal] = ACTIONS(8766),
    [sym__hex_literal] = ACTIONS(8766),
    [anon_sym_LPAREN_POUND] = ACTIONS(8768),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8768),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(8842),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8844),
    [anon_sym_LBRACK] = ACTIONS(8776),
    [anon_sym_SQUOTE] = ACTIONS(8847),
    [anon_sym_STAR] = ACTIONS(8780),
    [anon_sym_u2605] = ACTIONS(8780),
    [anon_sym_AT] = ACTIONS(8850),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8782),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8784),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8786),
  },
  [2508] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2604),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15898),
    [sym_type_parens] = STATE(2604),
    [sym_type_list] = STATE(2604),
    [sym_type_tuple] = STATE(2604),
    [sym__type_promotable_literal] = STATE(2604),
    [sym__type_promoted_literal] = STATE(2604),
    [sym__type_literal] = STATE(2604),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2604),
    [sym_type_unboxed_tuple] = STATE(2604),
    [sym_type_unboxed_sum] = STATE(2604),
    [sym__atype] = STATE(2604),
    [sym_type_apply] = STATE(8941),
    [sym__btype] = STATE(8941),
    [sym_implicit_param] = STATE(16758),
    [sym_type_infix] = STATE(14016),
    [sym__type_infix] = STATE(13635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2717),
    [sym__type_quantifiers] = STATE(16758),
    [sym__type_context] = STATE(16758),
    [sym__type_fun] = STATE(16758),
    [sym__type] = STATE(16758),
    [sym__type_or_implicit] = STATE(16758),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2604),
    [sym_quasiquote] = STATE(2604),
    [sym__varid] = ACTIONS(7415),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7425),
    [sym_implicit_parid] = ACTIONS(7427),
    [sym__conid] = ACTIONS(7429),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(7433),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7441),
  },
  [2509] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_implicit_param] = STATE(20638),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(20638),
    [sym__type_context] = STATE(20638),
    [sym__type_fun] = STATE(20638),
    [sym__type] = STATE(20638),
    [sym__type_or_implicit] = STATE(20638),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym_implicit_parid] = ACTIONS(7787),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2510] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2456),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_invisible] = STATE(2456),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [aux_sym_type_apply_repeat1] = STATE(2456),
    [sym__varid] = ACTIONS(8840),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8762),
    [sym_char] = ACTIONS(8762),
    [sym_string] = ACTIONS(8762),
    [sym__integer_literal] = ACTIONS(8764),
    [sym__binary_literal] = ACTIONS(8766),
    [sym__octal_literal] = ACTIONS(8766),
    [sym__hex_literal] = ACTIONS(8766),
    [anon_sym_LPAREN_POUND] = ACTIONS(8768),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8768),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(8842),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(8852),
    [anon_sym_LBRACK] = ACTIONS(8776),
    [anon_sym_SQUOTE] = ACTIONS(8855),
    [anon_sym_STAR] = ACTIONS(8780),
    [anon_sym_u2605] = ACTIONS(8780),
    [anon_sym_AT] = ACTIONS(8850),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8782),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8784),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8786),
  },
  [2511] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2512] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2512),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym_type_parens] = STATE(2512),
    [sym_type_list] = STATE(2512),
    [sym_type_tuple] = STATE(2512),
    [sym__type_promotable_literal] = STATE(2512),
    [sym__type_promoted_literal] = STATE(2512),
    [sym__type_literal] = STATE(2512),
    [sym_type_name] = STATE(2512),
    [sym_type_star] = STATE(2512),
    [sym_type_unboxed_tuple] = STATE(2512),
    [sym_type_unboxed_sum] = STATE(2512),
    [sym__atype] = STATE(2512),
    [sym_type_invisible] = STATE(2512),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2512),
    [sym_quasiquote] = STATE(2512),
    [aux_sym_type_apply_repeat1] = STATE(2512),
    [sym__varid] = ACTIONS(8858),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(8861),
    [sym_char] = ACTIONS(8861),
    [sym_string] = ACTIONS(8861),
    [sym__integer_literal] = ACTIONS(8864),
    [sym__binary_literal] = ACTIONS(8867),
    [sym__octal_literal] = ACTIONS(8867),
    [sym__hex_literal] = ACTIONS(8867),
    [anon_sym_LPAREN_POUND] = ACTIONS(8870),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8870),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8873),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(8879),
    [anon_sym_SQUOTE] = ACTIONS(8882),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(8885),
    [anon_sym_u2605] = ACTIONS(8885),
    [anon_sym_AT] = ACTIONS(8888),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(8891),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(8894),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8897),
  },
  [2513] = {
    [sym_integer] = STATE(10708),
    [sym__literal] = STATE(10708),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(10761),
    [sym_qualified_variable] = STATE(10761),
    [sym_constructor] = STATE(10623),
    [sym_qualified_constructor] = STATE(10748),
    [sym__qcon] = STATE(10761),
    [sym_con_unit] = STATE(10708),
    [sym_con_list] = STATE(10708),
    [sym_con_tuple] = STATE(10708),
    [sym_literal] = STATE(11036),
    [sym_exp_parens] = STATE(11036),
    [sym_exp_tuple] = STATE(11036),
    [sym_exp_unboxed_tuple] = STATE(11036),
    [sym_exp_unboxed_sum] = STATE(11036),
    [sym_exp_list] = STATE(11036),
    [sym_exp_arithmetic_sequence] = STATE(11036),
    [sym_exp_list_comprehension] = STATE(11036),
    [sym_exp_section_left] = STATE(11036),
    [sym_exp_section_right] = STATE(11036),
    [sym_exp_th_quoted_name] = STATE(11036),
    [sym_exp_type_application] = STATE(11241),
    [sym_exp_lambda_case] = STATE(11241),
    [sym_exp_lambda_cases] = STATE(11241),
    [sym__do_keyword] = STATE(20758),
    [sym_do_module] = STATE(20758),
    [sym_exp_do] = STATE(11241),
    [sym_exp_record] = STATE(11036),
    [sym_exp_name] = STATE(11036),
    [sym_exp_projection_selector] = STATE(11036),
    [sym__aexp_projection] = STATE(11036),
    [sym_exp_projection] = STATE(11036),
    [sym__aexp] = STATE(11241),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14108),
    [sym_splice] = STATE(11036),
    [sym_quasiquote] = STATE(11036),
    [sym__varid] = ACTIONS(3563),
    [sym_float] = ACTIONS(3565),
    [sym_char] = ACTIONS(3565),
    [sym_string] = ACTIONS(3565),
    [sym__integer_literal] = ACTIONS(3567),
    [sym__binary_literal] = ACTIONS(3569),
    [sym__octal_literal] = ACTIONS(3569),
    [sym__hex_literal] = ACTIONS(3569),
    [anon_sym_LPAREN_POUND] = ACTIONS(8900),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8900),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(8902),
    [anon_sym_RPAREN] = ACTIONS(3577),
    [sym_implicit_parid] = ACTIONS(3573),
    [sym__conid] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(8904),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [anon_sym_AT] = ACTIONS(8906),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3587),
    [anon_sym_BSLASH] = ACTIONS(3589),
    [anon_sym_mdo] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_u27e6] = ACTIONS(3593),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3597),
  },
  [2514] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2521),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym_type_parens] = STATE(2521),
    [sym_type_list] = STATE(2521),
    [sym_type_tuple] = STATE(2521),
    [sym__type_promotable_literal] = STATE(2521),
    [sym__type_promoted_literal] = STATE(2521),
    [sym__type_literal] = STATE(2521),
    [sym_type_name] = STATE(2521),
    [sym_type_star] = STATE(2521),
    [sym_type_unboxed_tuple] = STATE(2521),
    [sym_type_unboxed_sum] = STATE(2521),
    [sym__atype] = STATE(2521),
    [sym_type_invisible] = STATE(2521),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2521),
    [sym_quasiquote] = STATE(2521),
    [aux_sym_type_apply_repeat1] = STATE(2521),
    [sym__varid] = ACTIONS(8908),
    [sym_float] = ACTIONS(8402),
    [sym_char] = ACTIONS(8402),
    [sym_string] = ACTIONS(8402),
    [sym__integer_literal] = ACTIONS(8404),
    [sym__binary_literal] = ACTIONS(8406),
    [sym__octal_literal] = ACTIONS(8406),
    [sym__hex_literal] = ACTIONS(8406),
    [anon_sym_LPAREN_POUND] = ACTIONS(8408),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8408),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(8910),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(8912),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8915),
    [anon_sym_STAR] = ACTIONS(8420),
    [anon_sym_u2605] = ACTIONS(8420),
    [anon_sym_AT] = ACTIONS(8918),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8424),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(8426),
    [sym__unboxed_close] = ACTIONS(5451),
  },
  [2515] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2516] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2529),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym_type_parens] = STATE(2529),
    [sym_type_list] = STATE(2529),
    [sym_type_tuple] = STATE(2529),
    [sym__type_promotable_literal] = STATE(2529),
    [sym__type_promoted_literal] = STATE(2529),
    [sym__type_literal] = STATE(2529),
    [sym_type_name] = STATE(2529),
    [sym_type_star] = STATE(2529),
    [sym_type_unboxed_tuple] = STATE(2529),
    [sym_type_unboxed_sum] = STATE(2529),
    [sym__atype] = STATE(2529),
    [sym_type_invisible] = STATE(2529),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2529),
    [sym_quasiquote] = STATE(2529),
    [aux_sym_type_apply_repeat1] = STATE(2529),
    [sym__varid] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8430),
    [sym_char] = ACTIONS(8430),
    [sym_string] = ACTIONS(8430),
    [sym__integer_literal] = ACTIONS(8432),
    [sym__binary_literal] = ACTIONS(8434),
    [sym__octal_literal] = ACTIONS(8434),
    [sym__hex_literal] = ACTIONS(8434),
    [anon_sym_LPAREN_POUND] = ACTIONS(8436),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8436),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8920),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8922),
    [anon_sym_LBRACK] = ACTIONS(8444),
    [anon_sym_SQUOTE] = ACTIONS(8925),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8448),
    [anon_sym_u2605] = ACTIONS(8448),
    [anon_sym_AT] = ACTIONS(8928),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(8450),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8452),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8454),
  },
  [2517] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
    [sym__unboxed_close] = ACTIONS(5542),
  },
  [2518] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2526),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym_type_parens] = STATE(2526),
    [sym_type_list] = STATE(2526),
    [sym_type_tuple] = STATE(2526),
    [sym__type_promotable_literal] = STATE(2526),
    [sym__type_promoted_literal] = STATE(2526),
    [sym__type_literal] = STATE(2526),
    [sym_type_name] = STATE(2526),
    [sym_type_star] = STATE(2526),
    [sym_type_unboxed_tuple] = STATE(2526),
    [sym_type_unboxed_sum] = STATE(2526),
    [sym__atype] = STATE(2526),
    [sym_type_invisible] = STATE(2526),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2526),
    [sym_quasiquote] = STATE(2526),
    [aux_sym_type_apply_repeat1] = STATE(2526),
    [sym__varid] = ACTIONS(8930),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8932),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8934),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(8937),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_AT] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2519] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(704),
    [sym_variable] = STATE(10558),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(10325),
    [sym_qualified_constructor] = STATE(10464),
    [sym__qcon] = STATE(10558),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(10680),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13964),
    [sym_splice] = STATE(10680),
    [sym_quasiquote] = STATE(10680),
    [sym__varid] = ACTIONS(4861),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(8942),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8942),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(8944),
    [anon_sym_RPAREN] = ACTIONS(3577),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4873),
    [anon_sym_LBRACK] = ACTIONS(8946),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(8948),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
  },
  [2520] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [ts_builtin_sym_end] = ACTIONS(5542),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2521] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2521),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym_type_parens] = STATE(2521),
    [sym_type_list] = STATE(2521),
    [sym_type_tuple] = STATE(2521),
    [sym__type_promotable_literal] = STATE(2521),
    [sym__type_promoted_literal] = STATE(2521),
    [sym__type_literal] = STATE(2521),
    [sym_type_name] = STATE(2521),
    [sym_type_star] = STATE(2521),
    [sym_type_unboxed_tuple] = STATE(2521),
    [sym_type_unboxed_sum] = STATE(2521),
    [sym__atype] = STATE(2521),
    [sym_type_invisible] = STATE(2521),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2521),
    [sym_quasiquote] = STATE(2521),
    [aux_sym_type_apply_repeat1] = STATE(2521),
    [sym__varid] = ACTIONS(8950),
    [sym_float] = ACTIONS(8953),
    [sym_char] = ACTIONS(8953),
    [sym_string] = ACTIONS(8953),
    [sym__integer_literal] = ACTIONS(8956),
    [sym__binary_literal] = ACTIONS(8959),
    [sym__octal_literal] = ACTIONS(8959),
    [sym__hex_literal] = ACTIONS(8959),
    [anon_sym_LPAREN_POUND] = ACTIONS(8962),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8962),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(8965),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(8968),
    [anon_sym_LBRACK] = ACTIONS(8971),
    [anon_sym_SQUOTE] = ACTIONS(8974),
    [anon_sym_STAR] = ACTIONS(8977),
    [anon_sym_u2605] = ACTIONS(8977),
    [anon_sym_AT] = ACTIONS(8980),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(8983),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8986),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(8989),
    [sym__unboxed_close] = ACTIONS(5496),
  },
  [2522] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_deriving] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2523] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2514),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym_type_parens] = STATE(2514),
    [sym_type_list] = STATE(2514),
    [sym_type_tuple] = STATE(2514),
    [sym__type_promotable_literal] = STATE(2514),
    [sym__type_promoted_literal] = STATE(2514),
    [sym__type_literal] = STATE(2514),
    [sym_type_name] = STATE(2514),
    [sym_type_star] = STATE(2514),
    [sym_type_unboxed_tuple] = STATE(2514),
    [sym_type_unboxed_sum] = STATE(2514),
    [sym__atype] = STATE(2514),
    [sym_type_invisible] = STATE(2514),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2514),
    [sym_quasiquote] = STATE(2514),
    [aux_sym_type_apply_repeat1] = STATE(2514),
    [sym__varid] = ACTIONS(8908),
    [sym_float] = ACTIONS(8402),
    [sym_char] = ACTIONS(8402),
    [sym_string] = ACTIONS(8402),
    [sym__integer_literal] = ACTIONS(8404),
    [sym__binary_literal] = ACTIONS(8406),
    [sym__octal_literal] = ACTIONS(8406),
    [sym__hex_literal] = ACTIONS(8406),
    [anon_sym_LPAREN_POUND] = ACTIONS(8408),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8408),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(8910),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(8992),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8995),
    [anon_sym_STAR] = ACTIONS(8420),
    [anon_sym_u2605] = ACTIONS(8420),
    [anon_sym_AT] = ACTIONS(8918),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8424),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(8426),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2524] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2527),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym_type_parens] = STATE(2527),
    [sym_type_list] = STATE(2527),
    [sym_type_tuple] = STATE(2527),
    [sym__type_promotable_literal] = STATE(2527),
    [sym__type_promoted_literal] = STATE(2527),
    [sym__type_literal] = STATE(2527),
    [sym_type_name] = STATE(2527),
    [sym_type_star] = STATE(2527),
    [sym_type_unboxed_tuple] = STATE(2527),
    [sym_type_unboxed_sum] = STATE(2527),
    [sym__atype] = STATE(2527),
    [sym_type_invisible] = STATE(2527),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2527),
    [sym_quasiquote] = STATE(2527),
    [aux_sym_type_apply_repeat1] = STATE(2527),
    [sym__varid] = ACTIONS(8998),
    [sym_float] = ACTIONS(8253),
    [sym_char] = ACTIONS(8253),
    [sym_string] = ACTIONS(8253),
    [sym__integer_literal] = ACTIONS(8255),
    [sym__binary_literal] = ACTIONS(8257),
    [sym__octal_literal] = ACTIONS(8257),
    [sym__hex_literal] = ACTIONS(8257),
    [anon_sym_LPAREN_POUND] = ACTIONS(8259),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8259),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(9000),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9002),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_SQUOTE] = ACTIONS(9005),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8271),
    [anon_sym_u2605] = ACTIONS(8271),
    [anon_sym_AT] = ACTIONS(9008),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8273),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8275),
    [sym__varsym] = ACTIONS(5451),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8277),
    [sym__unboxed_close] = ACTIONS(5451),
  },
  [2525] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2525),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym_type_parens] = STATE(2525),
    [sym_type_list] = STATE(2525),
    [sym_type_tuple] = STATE(2525),
    [sym__type_promotable_literal] = STATE(2525),
    [sym__type_promoted_literal] = STATE(2525),
    [sym__type_literal] = STATE(2525),
    [sym_type_name] = STATE(2525),
    [sym_type_star] = STATE(2525),
    [sym_type_unboxed_tuple] = STATE(2525),
    [sym_type_unboxed_sum] = STATE(2525),
    [sym__atype] = STATE(2525),
    [sym_type_invisible] = STATE(2525),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2525),
    [sym_quasiquote] = STATE(2525),
    [aux_sym_type_apply_repeat1] = STATE(2525),
    [sym__varid] = ACTIONS(9010),
    [sym_float] = ACTIONS(9013),
    [sym_char] = ACTIONS(9013),
    [sym_string] = ACTIONS(9013),
    [sym__integer_literal] = ACTIONS(9016),
    [sym__binary_literal] = ACTIONS(9019),
    [sym__octal_literal] = ACTIONS(9019),
    [sym__hex_literal] = ACTIONS(9019),
    [anon_sym_LPAREN_POUND] = ACTIONS(9022),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9022),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9025),
    [anon_sym_RPAREN] = ACTIONS(5496),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9028),
    [anon_sym_LBRACK] = ACTIONS(9031),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(9034),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9037),
    [anon_sym_u2605] = ACTIONS(9037),
    [anon_sym_AT] = ACTIONS(9040),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(9043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9046),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(9049),
  },
  [2526] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2525),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym_type_parens] = STATE(2525),
    [sym_type_list] = STATE(2525),
    [sym_type_tuple] = STATE(2525),
    [sym__type_promotable_literal] = STATE(2525),
    [sym__type_promoted_literal] = STATE(2525),
    [sym__type_literal] = STATE(2525),
    [sym_type_name] = STATE(2525),
    [sym_type_star] = STATE(2525),
    [sym_type_unboxed_tuple] = STATE(2525),
    [sym_type_unboxed_sum] = STATE(2525),
    [sym__atype] = STATE(2525),
    [sym_type_invisible] = STATE(2525),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2525),
    [sym_quasiquote] = STATE(2525),
    [aux_sym_type_apply_repeat1] = STATE(2525),
    [sym__varid] = ACTIONS(8930),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8932),
    [anon_sym_RPAREN] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9052),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(9055),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_AT] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2527] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2527),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym_type_parens] = STATE(2527),
    [sym_type_list] = STATE(2527),
    [sym_type_tuple] = STATE(2527),
    [sym__type_promotable_literal] = STATE(2527),
    [sym__type_promoted_literal] = STATE(2527),
    [sym__type_literal] = STATE(2527),
    [sym_type_name] = STATE(2527),
    [sym_type_star] = STATE(2527),
    [sym_type_unboxed_tuple] = STATE(2527),
    [sym_type_unboxed_sum] = STATE(2527),
    [sym__atype] = STATE(2527),
    [sym_type_invisible] = STATE(2527),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2527),
    [sym_quasiquote] = STATE(2527),
    [aux_sym_type_apply_repeat1] = STATE(2527),
    [sym__varid] = ACTIONS(9058),
    [sym_float] = ACTIONS(9061),
    [sym_char] = ACTIONS(9061),
    [sym_string] = ACTIONS(9061),
    [sym__integer_literal] = ACTIONS(9064),
    [sym__binary_literal] = ACTIONS(9067),
    [sym__octal_literal] = ACTIONS(9067),
    [sym__hex_literal] = ACTIONS(9067),
    [anon_sym_LPAREN_POUND] = ACTIONS(9070),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9070),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_LPAREN] = ACTIONS(9073),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9076),
    [anon_sym_LBRACK] = ACTIONS(9079),
    [anon_sym_SQUOTE] = ACTIONS(9082),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9085),
    [anon_sym_u2605] = ACTIONS(9085),
    [anon_sym_AT] = ACTIONS(9088),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(9091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9094),
    [sym__varsym] = ACTIONS(5496),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9097),
    [sym__unboxed_close] = ACTIONS(5496),
  },
  [2528] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2524),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym_type_parens] = STATE(2524),
    [sym_type_list] = STATE(2524),
    [sym_type_tuple] = STATE(2524),
    [sym__type_promotable_literal] = STATE(2524),
    [sym__type_promoted_literal] = STATE(2524),
    [sym__type_literal] = STATE(2524),
    [sym_type_name] = STATE(2524),
    [sym_type_star] = STATE(2524),
    [sym_type_unboxed_tuple] = STATE(2524),
    [sym_type_unboxed_sum] = STATE(2524),
    [sym__atype] = STATE(2524),
    [sym_type_invisible] = STATE(2524),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2524),
    [sym_quasiquote] = STATE(2524),
    [aux_sym_type_apply_repeat1] = STATE(2524),
    [sym__varid] = ACTIONS(8998),
    [sym_float] = ACTIONS(8253),
    [sym_char] = ACTIONS(8253),
    [sym_string] = ACTIONS(8253),
    [sym__integer_literal] = ACTIONS(8255),
    [sym__binary_literal] = ACTIONS(8257),
    [sym__octal_literal] = ACTIONS(8257),
    [sym__hex_literal] = ACTIONS(8257),
    [anon_sym_LPAREN_POUND] = ACTIONS(8259),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8259),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(9000),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9100),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_SQUOTE] = ACTIONS(9103),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8271),
    [anon_sym_u2605] = ACTIONS(8271),
    [anon_sym_AT] = ACTIONS(9008),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8273),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8275),
    [sym__varsym] = ACTIONS(5483),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8277),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2529] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2512),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym_type_parens] = STATE(2512),
    [sym_type_list] = STATE(2512),
    [sym_type_tuple] = STATE(2512),
    [sym__type_promotable_literal] = STATE(2512),
    [sym__type_promoted_literal] = STATE(2512),
    [sym__type_literal] = STATE(2512),
    [sym_type_name] = STATE(2512),
    [sym_type_star] = STATE(2512),
    [sym_type_unboxed_tuple] = STATE(2512),
    [sym_type_unboxed_sum] = STATE(2512),
    [sym__atype] = STATE(2512),
    [sym_type_invisible] = STATE(2512),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2512),
    [sym_quasiquote] = STATE(2512),
    [aux_sym_type_apply_repeat1] = STATE(2512),
    [sym__varid] = ACTIONS(8428),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8430),
    [sym_char] = ACTIONS(8430),
    [sym_string] = ACTIONS(8430),
    [sym__integer_literal] = ACTIONS(8432),
    [sym__binary_literal] = ACTIONS(8434),
    [sym__octal_literal] = ACTIONS(8434),
    [sym__hex_literal] = ACTIONS(8434),
    [anon_sym_LPAREN_POUND] = ACTIONS(8436),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8436),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8920),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9106),
    [anon_sym_LBRACK] = ACTIONS(8444),
    [anon_sym_SQUOTE] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8448),
    [anon_sym_u2605] = ACTIONS(8448),
    [anon_sym_AT] = ACTIONS(8928),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(8450),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8452),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8454),
  },
  [2530] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2545),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym_type_parens] = STATE(2545),
    [sym_type_list] = STATE(2545),
    [sym_type_tuple] = STATE(2545),
    [sym__type_promotable_literal] = STATE(2545),
    [sym__type_promoted_literal] = STATE(2545),
    [sym__type_literal] = STATE(2545),
    [sym_type_name] = STATE(2545),
    [sym_type_star] = STATE(2545),
    [sym_type_unboxed_tuple] = STATE(2545),
    [sym_type_unboxed_sum] = STATE(2545),
    [sym__atype] = STATE(2545),
    [sym_type_invisible] = STATE(2545),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2545),
    [sym_quasiquote] = STATE(2545),
    [aux_sym_type_apply_repeat1] = STATE(2545),
    [sym__varid] = ACTIONS(8303),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8305),
    [sym_char] = ACTIONS(8305),
    [sym_string] = ACTIONS(8305),
    [sym__integer_literal] = ACTIONS(8307),
    [sym__binary_literal] = ACTIONS(8309),
    [sym__octal_literal] = ACTIONS(8309),
    [sym__hex_literal] = ACTIONS(8309),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9112),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9114),
    [anon_sym_LBRACK] = ACTIONS(8317),
    [anon_sym_SQUOTE] = ACTIONS(9117),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8321),
    [anon_sym_u2605] = ACTIONS(8321),
    [anon_sym_AT] = ACTIONS(9120),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5475),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(8323),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8325),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8327),
  },
  [2531] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2563),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym_type_parens] = STATE(2563),
    [sym_type_list] = STATE(2563),
    [sym_type_tuple] = STATE(2563),
    [sym__type_promotable_literal] = STATE(2563),
    [sym__type_promoted_literal] = STATE(2563),
    [sym__type_literal] = STATE(2563),
    [sym_type_name] = STATE(2563),
    [sym_type_star] = STATE(2563),
    [sym_type_unboxed_tuple] = STATE(2563),
    [sym_type_unboxed_sum] = STATE(2563),
    [sym__atype] = STATE(2563),
    [sym_type_invisible] = STATE(2563),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2563),
    [sym_quasiquote] = STATE(2563),
    [aux_sym_type_apply_repeat1] = STATE(2563),
    [sym__varid] = ACTIONS(7967),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7969),
    [sym_char] = ACTIONS(7969),
    [sym_string] = ACTIONS(7969),
    [sym__integer_literal] = ACTIONS(7971),
    [sym__binary_literal] = ACTIONS(7973),
    [sym__octal_literal] = ACTIONS(7973),
    [sym__hex_literal] = ACTIONS(7973),
    [anon_sym_LPAREN_POUND] = ACTIONS(7975),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7975),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9122),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9124),
    [anon_sym_LBRACK] = ACTIONS(7983),
    [anon_sym_SQUOTE] = ACTIONS(9127),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_u2605] = ACTIONS(7987),
    [anon_sym_AT] = ACTIONS(9130),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7991),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7993),
  },
  [2532] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2532),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym_type_parens] = STATE(2532),
    [sym_type_list] = STATE(2532),
    [sym_type_tuple] = STATE(2532),
    [sym__type_promotable_literal] = STATE(2532),
    [sym__type_promoted_literal] = STATE(2532),
    [sym__type_literal] = STATE(2532),
    [sym_type_name] = STATE(2532),
    [sym_type_star] = STATE(2532),
    [sym_type_unboxed_tuple] = STATE(2532),
    [sym_type_unboxed_sum] = STATE(2532),
    [sym__atype] = STATE(2532),
    [sym_type_invisible] = STATE(2532),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2532),
    [sym_quasiquote] = STATE(2532),
    [aux_sym_type_apply_repeat1] = STATE(2532),
    [sym__varid] = ACTIONS(9132),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(9135),
    [sym_char] = ACTIONS(9135),
    [sym_string] = ACTIONS(9135),
    [sym__integer_literal] = ACTIONS(9138),
    [sym__binary_literal] = ACTIONS(9141),
    [sym__octal_literal] = ACTIONS(9141),
    [sym__hex_literal] = ACTIONS(9141),
    [anon_sym_LPAREN_POUND] = ACTIONS(9144),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9144),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9147),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9150),
    [anon_sym_LBRACK] = ACTIONS(9153),
    [anon_sym_SQUOTE] = ACTIONS(9156),
    [anon_sym_STAR] = ACTIONS(9159),
    [anon_sym_u2605] = ACTIONS(9159),
    [anon_sym_AT] = ACTIONS(9162),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(9165),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(9168),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9171),
  },
  [2533] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2576),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym_type_parens] = STATE(2576),
    [sym_type_list] = STATE(2576),
    [sym_type_tuple] = STATE(2576),
    [sym__type_promotable_literal] = STATE(2576),
    [sym__type_promoted_literal] = STATE(2576),
    [sym__type_literal] = STATE(2576),
    [sym_type_name] = STATE(2576),
    [sym_type_star] = STATE(2576),
    [sym_type_unboxed_tuple] = STATE(2576),
    [sym_type_unboxed_sum] = STATE(2576),
    [sym__atype] = STATE(2576),
    [sym_type_invisible] = STATE(2576),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2576),
    [sym_quasiquote] = STATE(2576),
    [aux_sym_type_apply_repeat1] = STATE(2576),
    [sym__varid] = ACTIONS(9174),
    [sym_float] = ACTIONS(8129),
    [sym_char] = ACTIONS(8129),
    [sym_string] = ACTIONS(8129),
    [sym__integer_literal] = ACTIONS(8131),
    [sym__binary_literal] = ACTIONS(8133),
    [sym__octal_literal] = ACTIONS(8133),
    [sym__hex_literal] = ACTIONS(8133),
    [anon_sym_LPAREN_POUND] = ACTIONS(8135),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8135),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9176),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9178),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(9181),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8147),
    [anon_sym_u2605] = ACTIONS(8147),
    [anon_sym_AT] = ACTIONS(9184),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8149),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8151),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(8153),
  },
  [2534] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2565),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym_type_parens] = STATE(2565),
    [sym_type_list] = STATE(2565),
    [sym_type_tuple] = STATE(2565),
    [sym__type_promotable_literal] = STATE(2565),
    [sym__type_promoted_literal] = STATE(2565),
    [sym__type_literal] = STATE(2565),
    [sym_type_name] = STATE(2565),
    [sym_type_star] = STATE(2565),
    [sym_type_unboxed_tuple] = STATE(2565),
    [sym_type_unboxed_sum] = STATE(2565),
    [sym__atype] = STATE(2565),
    [sym_type_invisible] = STATE(2565),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2565),
    [sym_quasiquote] = STATE(2565),
    [aux_sym_type_apply_repeat1] = STATE(2565),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(9186),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8790),
    [sym_char] = ACTIONS(8790),
    [sym_string] = ACTIONS(8790),
    [sym__integer_literal] = ACTIONS(8792),
    [sym__binary_literal] = ACTIONS(8794),
    [sym__octal_literal] = ACTIONS(8794),
    [sym__hex_literal] = ACTIONS(8794),
    [anon_sym_LPAREN_POUND] = ACTIONS(8796),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8796),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9188),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9190),
    [anon_sym_LBRACK] = ACTIONS(8804),
    [anon_sym_SQUOTE] = ACTIONS(9193),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8808),
    [anon_sym_u2605] = ACTIONS(8808),
    [anon_sym_AT] = ACTIONS(9196),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8812),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8814),
  },
  [2535] = {
    [sym_integer] = STATE(11880),
    [sym__literal] = STATE(11880),
    [sym__unboxed_open] = STATE(738),
    [sym_variable] = STATE(11562),
    [sym_qualified_variable] = STATE(11562),
    [sym_constructor] = STATE(11280),
    [sym_qualified_constructor] = STATE(11867),
    [sym__qcon] = STATE(11562),
    [sym_con_unit] = STATE(11880),
    [sym_con_list] = STATE(11880),
    [sym_con_tuple] = STATE(11880),
    [sym_literal] = STATE(11535),
    [sym_exp_parens] = STATE(11535),
    [sym_exp_tuple] = STATE(11535),
    [sym_exp_unboxed_tuple] = STATE(11535),
    [sym_exp_unboxed_sum] = STATE(11535),
    [sym_exp_list] = STATE(11535),
    [sym_exp_arithmetic_sequence] = STATE(11535),
    [sym_exp_list_comprehension] = STATE(11535),
    [sym_exp_section_left] = STATE(11535),
    [sym_exp_section_right] = STATE(11535),
    [sym_exp_th_quoted_name] = STATE(11535),
    [sym_exp_type_application] = STATE(12665),
    [sym_exp_lambda_case] = STATE(12665),
    [sym_exp_lambda_cases] = STATE(12665),
    [sym__do_keyword] = STATE(20562),
    [sym_do_module] = STATE(20562),
    [sym_exp_do] = STATE(12665),
    [sym_exp_record] = STATE(11535),
    [sym_exp_name] = STATE(11535),
    [sym_exp_projection_selector] = STATE(11535),
    [sym__aexp_projection] = STATE(11535),
    [sym_exp_projection] = STATE(11535),
    [sym__aexp] = STATE(12665),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13951),
    [sym_splice] = STATE(11535),
    [sym_quasiquote] = STATE(11535),
    [sym__varid] = ACTIONS(9198),
    [sym_float] = ACTIONS(9200),
    [sym_char] = ACTIONS(9200),
    [sym_string] = ACTIONS(9200),
    [sym__integer_literal] = ACTIONS(9202),
    [sym__binary_literal] = ACTIONS(9204),
    [sym__octal_literal] = ACTIONS(9204),
    [sym__hex_literal] = ACTIONS(9204),
    [anon_sym_LPAREN_POUND] = ACTIONS(9206),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9206),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9208),
    [anon_sym_LPAREN] = ACTIONS(9210),
    [sym_implicit_parid] = ACTIONS(9208),
    [sym__conid] = ACTIONS(9212),
    [anon_sym_LBRACK] = ACTIONS(9214),
    [anon_sym_SQUOTE] = ACTIONS(9216),
    [anon_sym_AT] = ACTIONS(9218),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9220),
    [anon_sym_BSLASH] = ACTIONS(9222),
    [anon_sym_mdo] = ACTIONS(9224),
    [anon_sym_do] = ACTIONS(9224),
    [anon_sym_u27e6] = ACTIONS(9226),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9228),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9230),
  },
  [2536] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2536),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym_type_parens] = STATE(2536),
    [sym_type_list] = STATE(2536),
    [sym_type_tuple] = STATE(2536),
    [sym__type_promotable_literal] = STATE(2536),
    [sym__type_promoted_literal] = STATE(2536),
    [sym__type_literal] = STATE(2536),
    [sym_type_name] = STATE(2536),
    [sym_type_star] = STATE(2536),
    [sym_type_unboxed_tuple] = STATE(2536),
    [sym_type_unboxed_sum] = STATE(2536),
    [sym__atype] = STATE(2536),
    [sym_type_invisible] = STATE(2536),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2536),
    [sym_quasiquote] = STATE(2536),
    [aux_sym_type_apply_repeat1] = STATE(2536),
    [sym__varid] = ACTIONS(9232),
    [sym_float] = ACTIONS(9235),
    [sym_char] = ACTIONS(9235),
    [sym_string] = ACTIONS(9235),
    [sym__integer_literal] = ACTIONS(9238),
    [sym__binary_literal] = ACTIONS(9241),
    [sym__octal_literal] = ACTIONS(9241),
    [sym__hex_literal] = ACTIONS(9241),
    [anon_sym_LPAREN_POUND] = ACTIONS(9244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9244),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9247),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9253),
    [anon_sym_SQUOTE] = ACTIONS(9256),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9259),
    [anon_sym_u2605] = ACTIONS(9259),
    [anon_sym_AT] = ACTIONS(9262),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(9265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9268),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(9271),
    [sym__unboxed_close] = ACTIONS(5496),
  },
  [2537] = {
    [sym_integer] = STATE(10791),
    [sym__literal] = STATE(10791),
    [sym__unboxed_open] = STATE(712),
    [sym_variable] = STATE(10804),
    [sym_qualified_variable] = STATE(10804),
    [sym_constructor] = STATE(10701),
    [sym_qualified_constructor] = STATE(10874),
    [sym__qcon] = STATE(10804),
    [sym_con_unit] = STATE(10791),
    [sym_con_list] = STATE(10791),
    [sym_con_tuple] = STATE(10791),
    [sym_literal] = STATE(10801),
    [sym_exp_parens] = STATE(10801),
    [sym_exp_tuple] = STATE(10801),
    [sym_exp_unboxed_tuple] = STATE(10801),
    [sym_exp_unboxed_sum] = STATE(10801),
    [sym_exp_list] = STATE(10801),
    [sym_exp_arithmetic_sequence] = STATE(10801),
    [sym_exp_list_comprehension] = STATE(10801),
    [sym_exp_section_left] = STATE(10801),
    [sym_exp_section_right] = STATE(10801),
    [sym_exp_th_quoted_name] = STATE(10801),
    [sym_exp_type_application] = STATE(11129),
    [sym_exp_lambda_case] = STATE(11129),
    [sym_exp_lambda_cases] = STATE(11129),
    [sym__do_keyword] = STATE(20551),
    [sym_do_module] = STATE(20551),
    [sym_exp_do] = STATE(11129),
    [sym_exp_record] = STATE(10801),
    [sym_exp_name] = STATE(10801),
    [sym_exp_projection_selector] = STATE(10801),
    [sym__aexp_projection] = STATE(10801),
    [sym_exp_projection] = STATE(10801),
    [sym__aexp] = STATE(11129),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13899),
    [sym_splice] = STATE(10801),
    [sym_quasiquote] = STATE(10801),
    [sym__varid] = ACTIONS(9274),
    [sym_float] = ACTIONS(9276),
    [sym_char] = ACTIONS(9276),
    [sym_string] = ACTIONS(9276),
    [sym__integer_literal] = ACTIONS(9278),
    [sym__binary_literal] = ACTIONS(9280),
    [sym__octal_literal] = ACTIONS(9280),
    [sym__hex_literal] = ACTIONS(9280),
    [anon_sym_LPAREN_POUND] = ACTIONS(9282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9282),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9284),
    [anon_sym_LPAREN] = ACTIONS(9286),
    [sym_implicit_parid] = ACTIONS(9284),
    [sym__conid] = ACTIONS(9288),
    [anon_sym_LBRACK] = ACTIONS(9290),
    [anon_sym_SQUOTE] = ACTIONS(9292),
    [anon_sym_AT] = ACTIONS(9294),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9296),
    [anon_sym_BSLASH] = ACTIONS(9298),
    [anon_sym_mdo] = ACTIONS(9300),
    [anon_sym_do] = ACTIONS(9300),
    [anon_sym_u27e6] = ACTIONS(9302),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9304),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9306),
  },
  [2538] = {
    [sym_integer] = STATE(12326),
    [sym__literal] = STATE(12326),
    [sym__unboxed_open] = STATE(713),
    [sym_variable] = STATE(12358),
    [sym_qualified_variable] = STATE(12358),
    [sym_constructor] = STATE(11854),
    [sym_qualified_constructor] = STATE(12691),
    [sym__qcon] = STATE(12358),
    [sym_con_unit] = STATE(12326),
    [sym_con_list] = STATE(12326),
    [sym_con_tuple] = STATE(12326),
    [sym_literal] = STATE(12428),
    [sym_exp_parens] = STATE(12428),
    [sym_exp_tuple] = STATE(12428),
    [sym_exp_unboxed_tuple] = STATE(12428),
    [sym_exp_unboxed_sum] = STATE(12428),
    [sym_exp_list] = STATE(12428),
    [sym_exp_arithmetic_sequence] = STATE(12428),
    [sym_exp_list_comprehension] = STATE(12428),
    [sym_exp_section_left] = STATE(12428),
    [sym_exp_section_right] = STATE(12428),
    [sym_exp_th_quoted_name] = STATE(12428),
    [sym_exp_type_application] = STATE(13198),
    [sym_exp_lambda_case] = STATE(13198),
    [sym_exp_lambda_cases] = STATE(13198),
    [sym__do_keyword] = STATE(20494),
    [sym_do_module] = STATE(20494),
    [sym_exp_do] = STATE(13198),
    [sym_exp_record] = STATE(12428),
    [sym_exp_name] = STATE(12428),
    [sym_exp_projection_selector] = STATE(12428),
    [sym__aexp_projection] = STATE(12428),
    [sym_exp_projection] = STATE(12428),
    [sym__aexp] = STATE(13198),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14062),
    [sym_splice] = STATE(12428),
    [sym_quasiquote] = STATE(12428),
    [sym__varid] = ACTIONS(9308),
    [sym_float] = ACTIONS(9310),
    [sym_char] = ACTIONS(9310),
    [sym_string] = ACTIONS(9310),
    [sym__integer_literal] = ACTIONS(9312),
    [sym__binary_literal] = ACTIONS(9314),
    [sym__octal_literal] = ACTIONS(9314),
    [sym__hex_literal] = ACTIONS(9314),
    [anon_sym_LPAREN_POUND] = ACTIONS(9316),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9316),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9318),
    [anon_sym_LPAREN] = ACTIONS(9320),
    [sym_implicit_parid] = ACTIONS(9318),
    [sym__conid] = ACTIONS(9322),
    [anon_sym_LBRACK] = ACTIONS(9324),
    [anon_sym_SQUOTE] = ACTIONS(9326),
    [anon_sym_AT] = ACTIONS(9328),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9330),
    [anon_sym_BSLASH] = ACTIONS(9332),
    [anon_sym_mdo] = ACTIONS(9334),
    [anon_sym_do] = ACTIONS(9334),
    [anon_sym_u27e6] = ACTIONS(9336),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9338),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9340),
  },
  [2539] = {
    [sym_integer] = STATE(11672),
    [sym__literal] = STATE(11672),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(11615),
    [sym_qualified_variable] = STATE(11615),
    [sym_constructor] = STATE(11482),
    [sym_qualified_constructor] = STATE(11582),
    [sym__qcon] = STATE(11615),
    [sym_con_unit] = STATE(11672),
    [sym_con_list] = STATE(11672),
    [sym_con_tuple] = STATE(11672),
    [sym_literal] = STATE(11978),
    [sym_exp_parens] = STATE(11978),
    [sym_exp_tuple] = STATE(11978),
    [sym_exp_unboxed_tuple] = STATE(11978),
    [sym_exp_unboxed_sum] = STATE(11978),
    [sym_exp_list] = STATE(11978),
    [sym_exp_arithmetic_sequence] = STATE(11978),
    [sym_exp_list_comprehension] = STATE(11978),
    [sym_exp_section_left] = STATE(11978),
    [sym_exp_section_right] = STATE(11978),
    [sym_exp_th_quoted_name] = STATE(11978),
    [sym_exp_type_application] = STATE(12744),
    [sym_exp_lambda_case] = STATE(12744),
    [sym_exp_lambda_cases] = STATE(12744),
    [sym__do_keyword] = STATE(20451),
    [sym_do_module] = STATE(20451),
    [sym_exp_do] = STATE(12744),
    [sym_exp_record] = STATE(11978),
    [sym_exp_name] = STATE(11978),
    [sym_exp_projection_selector] = STATE(11978),
    [sym__aexp_projection] = STATE(11978),
    [sym_exp_projection] = STATE(11978),
    [sym__aexp] = STATE(12744),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13883),
    [sym_splice] = STATE(11978),
    [sym_quasiquote] = STATE(11978),
    [sym__varid] = ACTIONS(9342),
    [sym_float] = ACTIONS(9344),
    [sym_char] = ACTIONS(9344),
    [sym_string] = ACTIONS(9344),
    [sym__integer_literal] = ACTIONS(9346),
    [sym__binary_literal] = ACTIONS(9348),
    [sym__octal_literal] = ACTIONS(9348),
    [sym__hex_literal] = ACTIONS(9348),
    [anon_sym_LPAREN_POUND] = ACTIONS(9350),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9350),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9352),
    [anon_sym_LPAREN] = ACTIONS(9354),
    [sym_implicit_parid] = ACTIONS(9352),
    [sym__conid] = ACTIONS(9356),
    [anon_sym_LBRACK] = ACTIONS(9358),
    [anon_sym_SQUOTE] = ACTIONS(9360),
    [anon_sym_AT] = ACTIONS(9362),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9364),
    [anon_sym_BSLASH] = ACTIONS(9366),
    [anon_sym_mdo] = ACTIONS(9368),
    [anon_sym_do] = ACTIONS(9368),
    [anon_sym_u27e6] = ACTIONS(9370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9372),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9374),
  },
  [2540] = {
    [sym_integer] = STATE(11345),
    [sym__literal] = STATE(11345),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = STATE(11210),
    [sym_qualified_variable] = STATE(11210),
    [sym_constructor] = STATE(11035),
    [sym_qualified_constructor] = STATE(11156),
    [sym__qcon] = STATE(11210),
    [sym_con_unit] = STATE(11345),
    [sym_con_list] = STATE(11345),
    [sym_con_tuple] = STATE(11345),
    [sym_literal] = STATE(11385),
    [sym_exp_parens] = STATE(11385),
    [sym_exp_tuple] = STATE(11385),
    [sym_exp_unboxed_tuple] = STATE(11385),
    [sym_exp_unboxed_sum] = STATE(11385),
    [sym_exp_list] = STATE(11385),
    [sym_exp_arithmetic_sequence] = STATE(11385),
    [sym_exp_list_comprehension] = STATE(11385),
    [sym_exp_section_left] = STATE(11385),
    [sym_exp_section_right] = STATE(11385),
    [sym_exp_th_quoted_name] = STATE(11385),
    [sym_exp_type_application] = STATE(12071),
    [sym_exp_lambda_case] = STATE(12071),
    [sym_exp_lambda_cases] = STATE(12071),
    [sym__do_keyword] = STATE(20441),
    [sym_do_module] = STATE(20441),
    [sym_exp_do] = STATE(12071),
    [sym_exp_record] = STATE(11385),
    [sym_exp_name] = STATE(11385),
    [sym_exp_projection_selector] = STATE(11385),
    [sym__aexp_projection] = STATE(11385),
    [sym_exp_projection] = STATE(11385),
    [sym__aexp] = STATE(12071),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13870),
    [sym_splice] = STATE(11385),
    [sym_quasiquote] = STATE(11385),
    [sym__varid] = ACTIONS(9376),
    [sym_float] = ACTIONS(9378),
    [sym_char] = ACTIONS(9378),
    [sym_string] = ACTIONS(9378),
    [sym__integer_literal] = ACTIONS(9380),
    [sym__binary_literal] = ACTIONS(9382),
    [sym__octal_literal] = ACTIONS(9382),
    [sym__hex_literal] = ACTIONS(9382),
    [anon_sym_LPAREN_POUND] = ACTIONS(9384),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9384),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9386),
    [anon_sym_LPAREN] = ACTIONS(9388),
    [sym_implicit_parid] = ACTIONS(9386),
    [sym__conid] = ACTIONS(9390),
    [anon_sym_LBRACK] = ACTIONS(9392),
    [anon_sym_SQUOTE] = ACTIONS(9394),
    [anon_sym_AT] = ACTIONS(9396),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9398),
    [anon_sym_BSLASH] = ACTIONS(9400),
    [anon_sym_mdo] = ACTIONS(9402),
    [anon_sym_do] = ACTIONS(9402),
    [anon_sym_u27e6] = ACTIONS(9404),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9406),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9408),
  },
  [2541] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
    [sym__unboxed_close] = ACTIONS(5542),
  },
  [2542] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2533),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym_type_parens] = STATE(2533),
    [sym_type_list] = STATE(2533),
    [sym_type_tuple] = STATE(2533),
    [sym__type_promotable_literal] = STATE(2533),
    [sym__type_promoted_literal] = STATE(2533),
    [sym__type_literal] = STATE(2533),
    [sym_type_name] = STATE(2533),
    [sym_type_star] = STATE(2533),
    [sym_type_unboxed_tuple] = STATE(2533),
    [sym_type_unboxed_sum] = STATE(2533),
    [sym__atype] = STATE(2533),
    [sym_type_invisible] = STATE(2533),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2533),
    [sym_quasiquote] = STATE(2533),
    [aux_sym_type_apply_repeat1] = STATE(2533),
    [sym__varid] = ACTIONS(9174),
    [sym_float] = ACTIONS(8129),
    [sym_char] = ACTIONS(8129),
    [sym_string] = ACTIONS(8129),
    [sym__integer_literal] = ACTIONS(8131),
    [sym__binary_literal] = ACTIONS(8133),
    [sym__octal_literal] = ACTIONS(8133),
    [sym__hex_literal] = ACTIONS(8133),
    [anon_sym_LPAREN_POUND] = ACTIONS(8135),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8135),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9176),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9410),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(9413),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8147),
    [anon_sym_u2605] = ACTIONS(8147),
    [anon_sym_AT] = ACTIONS(9184),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_DOT_DOT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8149),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8151),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(8153),
  },
  [2543] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2536),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym_type_parens] = STATE(2536),
    [sym_type_list] = STATE(2536),
    [sym_type_tuple] = STATE(2536),
    [sym__type_promotable_literal] = STATE(2536),
    [sym__type_promoted_literal] = STATE(2536),
    [sym__type_literal] = STATE(2536),
    [sym_type_name] = STATE(2536),
    [sym_type_star] = STATE(2536),
    [sym_type_unboxed_tuple] = STATE(2536),
    [sym_type_unboxed_sum] = STATE(2536),
    [sym__atype] = STATE(2536),
    [sym_type_invisible] = STATE(2536),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2536),
    [sym_quasiquote] = STATE(2536),
    [aux_sym_type_apply_repeat1] = STATE(2536),
    [sym__varid] = ACTIONS(9416),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9418),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9420),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(9423),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_AT] = ACTIONS(9426),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5451),
  },
  [2544] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2534),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym_type_parens] = STATE(2534),
    [sym_type_list] = STATE(2534),
    [sym_type_tuple] = STATE(2534),
    [sym__type_promotable_literal] = STATE(2534),
    [sym__type_promoted_literal] = STATE(2534),
    [sym__type_literal] = STATE(2534),
    [sym_type_name] = STATE(2534),
    [sym_type_star] = STATE(2534),
    [sym_type_unboxed_tuple] = STATE(2534),
    [sym_type_unboxed_sum] = STATE(2534),
    [sym__atype] = STATE(2534),
    [sym_type_invisible] = STATE(2534),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2534),
    [sym_quasiquote] = STATE(2534),
    [aux_sym_type_apply_repeat1] = STATE(2534),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(9186),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8790),
    [sym_char] = ACTIONS(8790),
    [sym_string] = ACTIONS(8790),
    [sym__integer_literal] = ACTIONS(8792),
    [sym__binary_literal] = ACTIONS(8794),
    [sym__octal_literal] = ACTIONS(8794),
    [sym__hex_literal] = ACTIONS(8794),
    [anon_sym_LPAREN_POUND] = ACTIONS(8796),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8796),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9188),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9428),
    [anon_sym_LBRACK] = ACTIONS(8804),
    [anon_sym_SQUOTE] = ACTIONS(9431),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8808),
    [anon_sym_u2605] = ACTIONS(8808),
    [anon_sym_AT] = ACTIONS(9196),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8812),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8814),
  },
  [2545] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2545),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym_type_parens] = STATE(2545),
    [sym_type_list] = STATE(2545),
    [sym_type_tuple] = STATE(2545),
    [sym__type_promotable_literal] = STATE(2545),
    [sym__type_promoted_literal] = STATE(2545),
    [sym__type_literal] = STATE(2545),
    [sym_type_name] = STATE(2545),
    [sym_type_star] = STATE(2545),
    [sym_type_unboxed_tuple] = STATE(2545),
    [sym_type_unboxed_sum] = STATE(2545),
    [sym__atype] = STATE(2545),
    [sym_type_invisible] = STATE(2545),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2545),
    [sym_quasiquote] = STATE(2545),
    [aux_sym_type_apply_repeat1] = STATE(2545),
    [sym__varid] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(9437),
    [sym_char] = ACTIONS(9437),
    [sym_string] = ACTIONS(9437),
    [sym__integer_literal] = ACTIONS(9440),
    [sym__binary_literal] = ACTIONS(9443),
    [sym__octal_literal] = ACTIONS(9443),
    [sym__hex_literal] = ACTIONS(9443),
    [anon_sym_LPAREN_POUND] = ACTIONS(9446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9446),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9449),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9452),
    [anon_sym_LBRACK] = ACTIONS(9455),
    [anon_sym_SQUOTE] = ACTIONS(9458),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9461),
    [anon_sym_u2605] = ACTIONS(9461),
    [anon_sym_AT] = ACTIONS(9464),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(9467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9470),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9473),
  },
  [2546] = {
    [sym_integer] = STATE(12228),
    [sym__literal] = STATE(12228),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(12196),
    [sym_qualified_variable] = STATE(12196),
    [sym_constructor] = STATE(11980),
    [sym_qualified_constructor] = STATE(12433),
    [sym__qcon] = STATE(12196),
    [sym_con_unit] = STATE(12228),
    [sym_con_list] = STATE(12228),
    [sym_con_tuple] = STATE(12228),
    [sym_literal] = STATE(13538),
    [sym_exp_parens] = STATE(13538),
    [sym_exp_tuple] = STATE(13538),
    [sym_exp_unboxed_tuple] = STATE(13538),
    [sym_exp_unboxed_sum] = STATE(13538),
    [sym_exp_list] = STATE(13538),
    [sym_exp_arithmetic_sequence] = STATE(13538),
    [sym_exp_list_comprehension] = STATE(13538),
    [sym_exp_section_left] = STATE(13538),
    [sym_exp_section_right] = STATE(13538),
    [sym_exp_th_quoted_name] = STATE(13538),
    [sym_exp_type_application] = STATE(13733),
    [sym_exp_lambda_case] = STATE(13733),
    [sym_exp_lambda_cases] = STATE(13733),
    [sym__do_keyword] = STATE(20646),
    [sym_do_module] = STATE(20646),
    [sym_exp_do] = STATE(13733),
    [sym_exp_record] = STATE(13538),
    [sym_exp_name] = STATE(13538),
    [sym_exp_projection_selector] = STATE(13538),
    [sym__aexp_projection] = STATE(13538),
    [sym_exp_projection] = STATE(13538),
    [sym__aexp] = STATE(13733),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13925),
    [sym_splice] = STATE(13538),
    [sym_quasiquote] = STATE(13538),
    [sym__varid] = ACTIONS(4729),
    [sym_float] = ACTIONS(4731),
    [sym_char] = ACTIONS(4731),
    [sym_string] = ACTIONS(4731),
    [sym__integer_literal] = ACTIONS(4733),
    [sym__binary_literal] = ACTIONS(4735),
    [sym__octal_literal] = ACTIONS(4735),
    [sym__hex_literal] = ACTIONS(4735),
    [anon_sym_LPAREN_POUND] = ACTIONS(9476),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9476),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9478),
    [anon_sym_LPAREN] = ACTIONS(9480),
    [sym_implicit_parid] = ACTIONS(9478),
    [sym__conid] = ACTIONS(4741),
    [anon_sym_LBRACK] = ACTIONS(9482),
    [anon_sym_SQUOTE] = ACTIONS(9484),
    [anon_sym_AT] = ACTIONS(9486),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9488),
    [anon_sym_BSLASH] = ACTIONS(9490),
    [anon_sym_mdo] = ACTIONS(9492),
    [anon_sym_do] = ACTIONS(9492),
    [anon_sym_u27e6] = ACTIONS(4747),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4749),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4751),
  },
  [2547] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2530),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym_type_parens] = STATE(2530),
    [sym_type_list] = STATE(2530),
    [sym_type_tuple] = STATE(2530),
    [sym__type_promotable_literal] = STATE(2530),
    [sym__type_promoted_literal] = STATE(2530),
    [sym__type_literal] = STATE(2530),
    [sym_type_name] = STATE(2530),
    [sym_type_star] = STATE(2530),
    [sym_type_unboxed_tuple] = STATE(2530),
    [sym_type_unboxed_sum] = STATE(2530),
    [sym__atype] = STATE(2530),
    [sym_type_invisible] = STATE(2530),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2530),
    [sym_quasiquote] = STATE(2530),
    [aux_sym_type_apply_repeat1] = STATE(2530),
    [sym__varid] = ACTIONS(8303),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8305),
    [sym_char] = ACTIONS(8305),
    [sym_string] = ACTIONS(8305),
    [sym__integer_literal] = ACTIONS(8307),
    [sym__binary_literal] = ACTIONS(8309),
    [sym__octal_literal] = ACTIONS(8309),
    [sym__hex_literal] = ACTIONS(8309),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9112),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9494),
    [anon_sym_LBRACK] = ACTIONS(8317),
    [anon_sym_SQUOTE] = ACTIONS(9497),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8321),
    [anon_sym_u2605] = ACTIONS(8321),
    [anon_sym_AT] = ACTIONS(9120),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5491),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(8323),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8325),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8327),
  },
  [2548] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2556),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym_type_parens] = STATE(2556),
    [sym_type_list] = STATE(2556),
    [sym_type_tuple] = STATE(2556),
    [sym__type_promotable_literal] = STATE(2556),
    [sym__type_promoted_literal] = STATE(2556),
    [sym__type_literal] = STATE(2556),
    [sym_type_name] = STATE(2556),
    [sym_type_star] = STATE(2556),
    [sym_type_unboxed_tuple] = STATE(2556),
    [sym_type_unboxed_sum] = STATE(2556),
    [sym__atype] = STATE(2556),
    [sym_type_invisible] = STATE(2556),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2556),
    [sym_quasiquote] = STATE(2556),
    [aux_sym_type_apply_repeat1] = STATE(2556),
    [sym__varid] = ACTIONS(9500),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8682),
    [sym_char] = ACTIONS(8682),
    [sym_string] = ACTIONS(8682),
    [sym__integer_literal] = ACTIONS(8684),
    [sym__binary_literal] = ACTIONS(8686),
    [sym__octal_literal] = ACTIONS(8686),
    [sym__hex_literal] = ACTIONS(8686),
    [anon_sym_LPAREN_POUND] = ACTIONS(8688),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8688),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9502),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9504),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_SQUOTE] = ACTIONS(9507),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8700),
    [anon_sym_u2605] = ACTIONS(8700),
    [anon_sym_AT] = ACTIONS(9510),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8702),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8704),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8706),
  },
  [2549] = {
    [sym_integer] = STATE(12175),
    [sym__literal] = STATE(12175),
    [sym__unboxed_open] = STATE(751),
    [sym_variable] = STATE(12534),
    [sym_qualified_variable] = STATE(12534),
    [sym_constructor] = STATE(11972),
    [sym_qualified_constructor] = STATE(12687),
    [sym__qcon] = STATE(12534),
    [sym_con_unit] = STATE(12175),
    [sym_con_list] = STATE(12175),
    [sym_con_tuple] = STATE(12175),
    [sym_literal] = STATE(12774),
    [sym_exp_parens] = STATE(12774),
    [sym_exp_tuple] = STATE(12774),
    [sym_exp_unboxed_tuple] = STATE(12774),
    [sym_exp_unboxed_sum] = STATE(12774),
    [sym_exp_list] = STATE(12774),
    [sym_exp_arithmetic_sequence] = STATE(12774),
    [sym_exp_list_comprehension] = STATE(12774),
    [sym_exp_section_left] = STATE(12774),
    [sym_exp_section_right] = STATE(12774),
    [sym_exp_th_quoted_name] = STATE(12774),
    [sym_exp_type_application] = STATE(12891),
    [sym_exp_lambda_case] = STATE(12891),
    [sym_exp_lambda_cases] = STATE(12891),
    [sym__do_keyword] = STATE(20539),
    [sym_do_module] = STATE(20539),
    [sym_exp_do] = STATE(12891),
    [sym_exp_record] = STATE(12774),
    [sym_exp_name] = STATE(12774),
    [sym_exp_projection_selector] = STATE(12774),
    [sym__aexp_projection] = STATE(12774),
    [sym_exp_projection] = STATE(12774),
    [sym__aexp] = STATE(12891),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14024),
    [sym_splice] = STATE(12774),
    [sym_quasiquote] = STATE(12774),
    [sym__varid] = ACTIONS(9512),
    [sym_float] = ACTIONS(9514),
    [sym_char] = ACTIONS(9514),
    [sym_string] = ACTIONS(9514),
    [sym__integer_literal] = ACTIONS(9516),
    [sym__binary_literal] = ACTIONS(9518),
    [sym__octal_literal] = ACTIONS(9518),
    [sym__hex_literal] = ACTIONS(9518),
    [anon_sym_LPAREN_POUND] = ACTIONS(9520),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9520),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9522),
    [anon_sym_LPAREN] = ACTIONS(9524),
    [sym_implicit_parid] = ACTIONS(9522),
    [sym__conid] = ACTIONS(9526),
    [anon_sym_LBRACK] = ACTIONS(9528),
    [anon_sym_SQUOTE] = ACTIONS(9530),
    [anon_sym_AT] = ACTIONS(9532),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9534),
    [anon_sym_BSLASH] = ACTIONS(9536),
    [anon_sym_mdo] = ACTIONS(9538),
    [anon_sym_do] = ACTIONS(9538),
    [anon_sym_u27e6] = ACTIONS(9540),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9544),
  },
  [2550] = {
    [sym_integer] = STATE(11592),
    [sym__literal] = STATE(11592),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = STATE(11899),
    [sym_qualified_variable] = STATE(11899),
    [sym_constructor] = STATE(11179),
    [sym_qualified_constructor] = STATE(12088),
    [sym__qcon] = STATE(11899),
    [sym_con_unit] = STATE(11592),
    [sym_con_list] = STATE(11592),
    [sym_con_tuple] = STATE(11592),
    [sym_literal] = STATE(12743),
    [sym_exp_parens] = STATE(12743),
    [sym_exp_tuple] = STATE(12743),
    [sym_exp_unboxed_tuple] = STATE(12743),
    [sym_exp_unboxed_sum] = STATE(12743),
    [sym_exp_list] = STATE(12743),
    [sym_exp_arithmetic_sequence] = STATE(12743),
    [sym_exp_list_comprehension] = STATE(12743),
    [sym_exp_section_left] = STATE(12743),
    [sym_exp_section_right] = STATE(12743),
    [sym_exp_th_quoted_name] = STATE(12743),
    [sym_exp_type_application] = STATE(13246),
    [sym_exp_lambda_case] = STATE(13246),
    [sym_exp_lambda_cases] = STATE(13246),
    [sym__do_keyword] = STATE(20464),
    [sym_do_module] = STATE(20464),
    [sym_exp_do] = STATE(13246),
    [sym_exp_record] = STATE(12743),
    [sym_exp_name] = STATE(12743),
    [sym_exp_projection_selector] = STATE(12743),
    [sym__aexp_projection] = STATE(12743),
    [sym_exp_projection] = STATE(12743),
    [sym__aexp] = STATE(13246),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14012),
    [sym_splice] = STATE(12743),
    [sym_quasiquote] = STATE(12743),
    [sym__varid] = ACTIONS(4825),
    [sym_float] = ACTIONS(4827),
    [sym_char] = ACTIONS(4827),
    [sym_string] = ACTIONS(4827),
    [sym__integer_literal] = ACTIONS(4829),
    [sym__binary_literal] = ACTIONS(4831),
    [sym__octal_literal] = ACTIONS(4831),
    [sym__hex_literal] = ACTIONS(4831),
    [anon_sym_LPAREN_POUND] = ACTIONS(9546),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9546),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9548),
    [anon_sym_LPAREN] = ACTIONS(9550),
    [sym_implicit_parid] = ACTIONS(9548),
    [sym__conid] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(9552),
    [anon_sym_SQUOTE] = ACTIONS(9554),
    [anon_sym_AT] = ACTIONS(9556),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9558),
    [anon_sym_BSLASH] = ACTIONS(9560),
    [anon_sym_mdo] = ACTIONS(9562),
    [anon_sym_do] = ACTIONS(9562),
    [anon_sym_u27e6] = ACTIONS(4843),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4847),
  },
  [2551] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_strict_type] = STATE(14123),
    [sym_lazy_type] = STATE(14123),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(14123),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2842),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_record_fields] = STATE(18784),
    [sym__gadt_fun] = STATE(18793),
    [sym__gadt_sig] = STATE(18793),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(9564),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6194),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
    [sym__strict] = ACTIONS(6262),
    [sym__lazy] = ACTIONS(6264),
  },
  [2552] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2552),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym_type_parens] = STATE(2552),
    [sym_type_list] = STATE(2552),
    [sym_type_tuple] = STATE(2552),
    [sym__type_promotable_literal] = STATE(2552),
    [sym__type_promoted_literal] = STATE(2552),
    [sym__type_literal] = STATE(2552),
    [sym_type_name] = STATE(2552),
    [sym_type_star] = STATE(2552),
    [sym_type_unboxed_tuple] = STATE(2552),
    [sym_type_unboxed_sum] = STATE(2552),
    [sym__atype] = STATE(2552),
    [sym_type_invisible] = STATE(2552),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2552),
    [sym_quasiquote] = STATE(2552),
    [aux_sym_type_apply_repeat1] = STATE(2552),
    [sym__varid] = ACTIONS(9566),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(9569),
    [sym_char] = ACTIONS(9569),
    [sym_string] = ACTIONS(9569),
    [sym__integer_literal] = ACTIONS(9572),
    [sym__binary_literal] = ACTIONS(9575),
    [sym__octal_literal] = ACTIONS(9575),
    [sym__hex_literal] = ACTIONS(9575),
    [anon_sym_LPAREN_POUND] = ACTIONS(9578),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9578),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9581),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9584),
    [anon_sym_LBRACK] = ACTIONS(9587),
    [anon_sym_SQUOTE] = ACTIONS(9590),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9593),
    [anon_sym_u2605] = ACTIONS(9593),
    [anon_sym_AT] = ACTIONS(9596),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(9599),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(9602),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9605),
  },
  [2553] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2082),
    [sym_constructor] = STATE(2413),
    [sym_con_unit] = STATE(8550),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8529),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18975),
    [sym_lazy_type] = STATE(18975),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8513),
    [sym_type_unboxed_sum] = STATE(8513),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18975),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2875),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(15879),
    [sym_data_constructor_infix] = STATE(15879),
    [sym_data_constructor_record] = STATE(15879),
    [sym_data_constructor_special] = STATE(15879),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6106),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6106),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6108),
    [sym__conid] = ACTIONS(6110),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2554] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2093),
    [sym_constructor] = STATE(2411),
    [sym_con_unit] = STATE(8515),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8488),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18721),
    [sym_lazy_type] = STATE(18721),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8494),
    [sym_type_unboxed_sum] = STATE(8494),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18721),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2857),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(15511),
    [sym_data_constructor_infix] = STATE(15511),
    [sym_data_constructor_record] = STATE(15511),
    [sym_data_constructor_special] = STATE(15511),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6094),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6094),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6096),
    [sym__conid] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2555] = {
    [sym_integer] = STATE(12927),
    [sym__literal] = STATE(12927),
    [sym__unboxed_open] = STATE(730),
    [sym_variable] = STATE(12985),
    [sym_qualified_variable] = STATE(12985),
    [sym_constructor] = STATE(12771),
    [sym_qualified_constructor] = STATE(13025),
    [sym__qcon] = STATE(12985),
    [sym_con_unit] = STATE(12927),
    [sym_con_list] = STATE(12927),
    [sym_con_tuple] = STATE(12927),
    [sym_literal] = STATE(12783),
    [sym_exp_parens] = STATE(12783),
    [sym_exp_tuple] = STATE(12783),
    [sym_exp_unboxed_tuple] = STATE(12783),
    [sym_exp_unboxed_sum] = STATE(12783),
    [sym_exp_list] = STATE(12783),
    [sym_exp_arithmetic_sequence] = STATE(12783),
    [sym_exp_list_comprehension] = STATE(12783),
    [sym_exp_section_left] = STATE(12783),
    [sym_exp_section_right] = STATE(12783),
    [sym_exp_th_quoted_name] = STATE(12783),
    [sym_exp_type_application] = STATE(13403),
    [sym_exp_lambda_case] = STATE(13403),
    [sym_exp_lambda_cases] = STATE(13403),
    [sym__do_keyword] = STATE(20876),
    [sym_do_module] = STATE(20876),
    [sym_exp_do] = STATE(13403),
    [sym_exp_record] = STATE(12783),
    [sym_exp_name] = STATE(12783),
    [sym_exp_projection_selector] = STATE(12783),
    [sym__aexp_projection] = STATE(12783),
    [sym_exp_projection] = STATE(12783),
    [sym__aexp] = STATE(13403),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14031),
    [sym_splice] = STATE(12783),
    [sym_quasiquote] = STATE(12783),
    [sym__varid] = ACTIONS(9610),
    [sym_float] = ACTIONS(9612),
    [sym_char] = ACTIONS(9612),
    [sym_string] = ACTIONS(9612),
    [sym__integer_literal] = ACTIONS(9614),
    [sym__binary_literal] = ACTIONS(9616),
    [sym__octal_literal] = ACTIONS(9616),
    [sym__hex_literal] = ACTIONS(9616),
    [anon_sym_LPAREN_POUND] = ACTIONS(9618),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9618),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4775),
    [anon_sym_LPAREN] = ACTIONS(9620),
    [sym_implicit_parid] = ACTIONS(4775),
    [sym__conid] = ACTIONS(9622),
    [anon_sym_LBRACK] = ACTIONS(9624),
    [anon_sym_SQUOTE] = ACTIONS(4783),
    [anon_sym_AT] = ACTIONS(9626),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4787),
    [anon_sym_BSLASH] = ACTIONS(4789),
    [anon_sym_mdo] = ACTIONS(4791),
    [anon_sym_do] = ACTIONS(4791),
    [anon_sym_u27e6] = ACTIONS(9628),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9630),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9632),
  },
  [2556] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2556),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym_type_parens] = STATE(2556),
    [sym_type_list] = STATE(2556),
    [sym_type_tuple] = STATE(2556),
    [sym__type_promotable_literal] = STATE(2556),
    [sym__type_promoted_literal] = STATE(2556),
    [sym__type_literal] = STATE(2556),
    [sym_type_name] = STATE(2556),
    [sym_type_star] = STATE(2556),
    [sym_type_unboxed_tuple] = STATE(2556),
    [sym_type_unboxed_sum] = STATE(2556),
    [sym__atype] = STATE(2556),
    [sym_type_invisible] = STATE(2556),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2556),
    [sym_quasiquote] = STATE(2556),
    [aux_sym_type_apply_repeat1] = STATE(2556),
    [sym__varid] = ACTIONS(9634),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(9637),
    [sym_char] = ACTIONS(9637),
    [sym_string] = ACTIONS(9637),
    [sym__integer_literal] = ACTIONS(9640),
    [sym__binary_literal] = ACTIONS(9643),
    [sym__octal_literal] = ACTIONS(9643),
    [sym__hex_literal] = ACTIONS(9643),
    [anon_sym_LPAREN_POUND] = ACTIONS(9646),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9646),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9649),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9652),
    [anon_sym_LBRACK] = ACTIONS(9655),
    [anon_sym_SQUOTE] = ACTIONS(9658),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9661),
    [anon_sym_u2605] = ACTIONS(9661),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(9667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(9670),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9673),
  },
  [2557] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2562),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym_type_parens] = STATE(2562),
    [sym_type_list] = STATE(2562),
    [sym_type_tuple] = STATE(2562),
    [sym__type_promotable_literal] = STATE(2562),
    [sym__type_promoted_literal] = STATE(2562),
    [sym__type_literal] = STATE(2562),
    [sym_type_name] = STATE(2562),
    [sym_type_star] = STATE(2562),
    [sym_type_unboxed_tuple] = STATE(2562),
    [sym_type_unboxed_sum] = STATE(2562),
    [sym__atype] = STATE(2562),
    [sym_type_invisible] = STATE(2562),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2562),
    [sym_quasiquote] = STATE(2562),
    [aux_sym_type_apply_repeat1] = STATE(2562),
    [sym__varid] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8486),
    [sym_char] = ACTIONS(8486),
    [sym_string] = ACTIONS(8486),
    [sym__integer_literal] = ACTIONS(8488),
    [sym__binary_literal] = ACTIONS(8490),
    [sym__octal_literal] = ACTIONS(8490),
    [sym__hex_literal] = ACTIONS(8490),
    [anon_sym_LPAREN_POUND] = ACTIONS(8492),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8492),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9676),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9678),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(9681),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8504),
    [anon_sym_u2605] = ACTIONS(8504),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(8506),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8508),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8510),
  },
  [2558] = {
    [sym_integer] = STATE(11709),
    [sym__literal] = STATE(11709),
    [sym__unboxed_open] = STATE(723),
    [sym_variable] = STATE(12090),
    [sym_qualified_variable] = STATE(12090),
    [sym_constructor] = STATE(11390),
    [sym_qualified_constructor] = STATE(11692),
    [sym__qcon] = STATE(12090),
    [sym_con_unit] = STATE(11709),
    [sym_con_list] = STATE(11709),
    [sym_con_tuple] = STATE(11709),
    [sym_literal] = STATE(11616),
    [sym_exp_parens] = STATE(11616),
    [sym_exp_tuple] = STATE(11616),
    [sym_exp_unboxed_tuple] = STATE(11616),
    [sym_exp_unboxed_sum] = STATE(11616),
    [sym_exp_list] = STATE(11616),
    [sym_exp_arithmetic_sequence] = STATE(11616),
    [sym_exp_list_comprehension] = STATE(11616),
    [sym_exp_section_left] = STATE(11616),
    [sym_exp_section_right] = STATE(11616),
    [sym_exp_th_quoted_name] = STATE(11616),
    [sym_exp_type_application] = STATE(12370),
    [sym_exp_lambda_case] = STATE(12370),
    [sym_exp_lambda_cases] = STATE(12370),
    [sym__do_keyword] = STATE(20713),
    [sym_do_module] = STATE(20713),
    [sym_exp_do] = STATE(12370),
    [sym_exp_record] = STATE(11616),
    [sym_exp_name] = STATE(11616),
    [sym_exp_projection_selector] = STATE(11616),
    [sym__aexp_projection] = STATE(11616),
    [sym_exp_projection] = STATE(11616),
    [sym__aexp] = STATE(12370),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13998),
    [sym_splice] = STATE(11616),
    [sym_quasiquote] = STATE(11616),
    [sym__varid] = ACTIONS(4675),
    [sym_float] = ACTIONS(4677),
    [sym_char] = ACTIONS(4677),
    [sym_string] = ACTIONS(4677),
    [sym__integer_literal] = ACTIONS(4679),
    [sym__binary_literal] = ACTIONS(4681),
    [sym__octal_literal] = ACTIONS(4681),
    [sym__hex_literal] = ACTIONS(4681),
    [anon_sym_LPAREN_POUND] = ACTIONS(9686),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9686),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4685),
    [anon_sym_LPAREN] = ACTIONS(9688),
    [sym_implicit_parid] = ACTIONS(4685),
    [sym__conid] = ACTIONS(4689),
    [anon_sym_LBRACK] = ACTIONS(9690),
    [anon_sym_SQUOTE] = ACTIONS(4693),
    [anon_sym_AT] = ACTIONS(9692),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4697),
    [anon_sym_BSLASH] = ACTIONS(4699),
    [anon_sym_mdo] = ACTIONS(4701),
    [anon_sym_do] = ACTIONS(4701),
    [anon_sym_u27e6] = ACTIONS(4703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4707),
  },
  [2559] = {
    [sym_integer] = STATE(11533),
    [sym__literal] = STATE(11533),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = STATE(12041),
    [sym_qualified_variable] = STATE(12041),
    [sym_constructor] = STATE(11329),
    [sym_qualified_constructor] = STATE(11783),
    [sym__qcon] = STATE(12041),
    [sym_con_unit] = STATE(11533),
    [sym_con_list] = STATE(11533),
    [sym_con_tuple] = STATE(11533),
    [sym_literal] = STATE(11930),
    [sym_exp_parens] = STATE(11930),
    [sym_exp_tuple] = STATE(11930),
    [sym_exp_unboxed_tuple] = STATE(11930),
    [sym_exp_unboxed_sum] = STATE(11930),
    [sym_exp_list] = STATE(11930),
    [sym_exp_arithmetic_sequence] = STATE(11930),
    [sym_exp_list_comprehension] = STATE(11930),
    [sym_exp_section_left] = STATE(11930),
    [sym_exp_section_right] = STATE(11930),
    [sym_exp_th_quoted_name] = STATE(11930),
    [sym_exp_type_application] = STATE(12465),
    [sym_exp_lambda_case] = STATE(12465),
    [sym_exp_lambda_cases] = STATE(12465),
    [sym__do_keyword] = STATE(20484),
    [sym_do_module] = STATE(20484),
    [sym_exp_do] = STATE(12465),
    [sym_exp_record] = STATE(11930),
    [sym_exp_name] = STATE(11930),
    [sym_exp_projection_selector] = STATE(11930),
    [sym__aexp_projection] = STATE(11930),
    [sym_exp_projection] = STATE(11930),
    [sym__aexp] = STATE(12465),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14002),
    [sym_splice] = STATE(11930),
    [sym_quasiquote] = STATE(11930),
    [sym__varid] = ACTIONS(9694),
    [sym_float] = ACTIONS(9696),
    [sym_char] = ACTIONS(9696),
    [sym_string] = ACTIONS(9696),
    [sym__integer_literal] = ACTIONS(9698),
    [sym__binary_literal] = ACTIONS(9700),
    [sym__octal_literal] = ACTIONS(9700),
    [sym__hex_literal] = ACTIONS(9700),
    [anon_sym_LPAREN_POUND] = ACTIONS(9702),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9702),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9704),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [sym_implicit_parid] = ACTIONS(9704),
    [sym__conid] = ACTIONS(9708),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9712),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9716),
    [anon_sym_BSLASH] = ACTIONS(9718),
    [anon_sym_mdo] = ACTIONS(9720),
    [anon_sym_do] = ACTIONS(9720),
    [anon_sym_u27e6] = ACTIONS(9722),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9724),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9726),
  },
  [2560] = {
    [sym_integer] = STATE(10563),
    [sym__literal] = STATE(10563),
    [sym__unboxed_open] = STATE(714),
    [sym_variable] = STATE(10582),
    [sym_qualified_variable] = STATE(10582),
    [sym_constructor] = STATE(10340),
    [sym_qualified_constructor] = STATE(10549),
    [sym__qcon] = STATE(10582),
    [sym_con_unit] = STATE(10563),
    [sym_con_list] = STATE(10563),
    [sym_con_tuple] = STATE(10563),
    [sym_literal] = STATE(10586),
    [sym_exp_parens] = STATE(10586),
    [sym_exp_tuple] = STATE(10586),
    [sym_exp_unboxed_tuple] = STATE(10586),
    [sym_exp_unboxed_sum] = STATE(10586),
    [sym_exp_list] = STATE(10586),
    [sym_exp_arithmetic_sequence] = STATE(10586),
    [sym_exp_list_comprehension] = STATE(10586),
    [sym_exp_section_left] = STATE(10586),
    [sym_exp_section_right] = STATE(10586),
    [sym_exp_th_quoted_name] = STATE(10586),
    [sym_exp_type_application] = STATE(10643),
    [sym_exp_lambda_case] = STATE(10643),
    [sym_exp_lambda_cases] = STATE(10643),
    [sym__do_keyword] = STATE(20508),
    [sym_do_module] = STATE(20508),
    [sym_exp_do] = STATE(10643),
    [sym_exp_record] = STATE(10586),
    [sym_exp_name] = STATE(10586),
    [sym_exp_projection_selector] = STATE(10586),
    [sym__aexp_projection] = STATE(10586),
    [sym_exp_projection] = STATE(10586),
    [sym__aexp] = STATE(10643),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14103),
    [sym_splice] = STATE(10586),
    [sym_quasiquote] = STATE(10586),
    [sym__varid] = ACTIONS(4455),
    [sym_float] = ACTIONS(4457),
    [sym_char] = ACTIONS(4457),
    [sym_string] = ACTIONS(4457),
    [sym__integer_literal] = ACTIONS(4459),
    [sym__binary_literal] = ACTIONS(4461),
    [sym__octal_literal] = ACTIONS(4461),
    [sym__hex_literal] = ACTIONS(4461),
    [anon_sym_LPAREN_POUND] = ACTIONS(9728),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9728),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9732),
    [sym_implicit_parid] = ACTIONS(9730),
    [sym__conid] = ACTIONS(4467),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9740),
    [anon_sym_BSLASH] = ACTIONS(9742),
    [anon_sym_mdo] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_u27e6] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4477),
  },
  [2561] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2543),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym_type_parens] = STATE(2543),
    [sym_type_list] = STATE(2543),
    [sym_type_tuple] = STATE(2543),
    [sym__type_promotable_literal] = STATE(2543),
    [sym__type_promoted_literal] = STATE(2543),
    [sym__type_literal] = STATE(2543),
    [sym_type_name] = STATE(2543),
    [sym_type_star] = STATE(2543),
    [sym_type_unboxed_tuple] = STATE(2543),
    [sym_type_unboxed_sum] = STATE(2543),
    [sym__atype] = STATE(2543),
    [sym_type_invisible] = STATE(2543),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2543),
    [sym_quasiquote] = STATE(2543),
    [aux_sym_type_apply_repeat1] = STATE(2543),
    [sym__varid] = ACTIONS(9416),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9418),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9746),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(9749),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_AT] = ACTIONS(9426),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(5720),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2562] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2552),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym_type_parens] = STATE(2552),
    [sym_type_list] = STATE(2552),
    [sym_type_tuple] = STATE(2552),
    [sym__type_promotable_literal] = STATE(2552),
    [sym__type_promoted_literal] = STATE(2552),
    [sym__type_literal] = STATE(2552),
    [sym_type_name] = STATE(2552),
    [sym_type_star] = STATE(2552),
    [sym_type_unboxed_tuple] = STATE(2552),
    [sym_type_unboxed_sum] = STATE(2552),
    [sym__atype] = STATE(2552),
    [sym_type_invisible] = STATE(2552),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2552),
    [sym_quasiquote] = STATE(2552),
    [aux_sym_type_apply_repeat1] = STATE(2552),
    [sym__varid] = ACTIONS(8484),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8486),
    [sym_char] = ACTIONS(8486),
    [sym_string] = ACTIONS(8486),
    [sym__integer_literal] = ACTIONS(8488),
    [sym__binary_literal] = ACTIONS(8490),
    [sym__octal_literal] = ACTIONS(8490),
    [sym__hex_literal] = ACTIONS(8490),
    [anon_sym_LPAREN_POUND] = ACTIONS(8492),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8492),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9676),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(9755),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8504),
    [anon_sym_u2605] = ACTIONS(8504),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(8506),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8508),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8510),
  },
  [2563] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2532),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym_type_parens] = STATE(2532),
    [sym_type_list] = STATE(2532),
    [sym_type_tuple] = STATE(2532),
    [sym__type_promotable_literal] = STATE(2532),
    [sym__type_promoted_literal] = STATE(2532),
    [sym__type_literal] = STATE(2532),
    [sym_type_name] = STATE(2532),
    [sym_type_star] = STATE(2532),
    [sym_type_unboxed_tuple] = STATE(2532),
    [sym_type_unboxed_sum] = STATE(2532),
    [sym__atype] = STATE(2532),
    [sym_type_invisible] = STATE(2532),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2532),
    [sym_quasiquote] = STATE(2532),
    [aux_sym_type_apply_repeat1] = STATE(2532),
    [sym__varid] = ACTIONS(7967),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7969),
    [sym_char] = ACTIONS(7969),
    [sym_string] = ACTIONS(7969),
    [sym__integer_literal] = ACTIONS(7971),
    [sym__binary_literal] = ACTIONS(7973),
    [sym__octal_literal] = ACTIONS(7973),
    [sym__hex_literal] = ACTIONS(7973),
    [anon_sym_LPAREN_POUND] = ACTIONS(7975),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7975),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9122),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(7983),
    [anon_sym_SQUOTE] = ACTIONS(9761),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_u2605] = ACTIONS(7987),
    [anon_sym_AT] = ACTIONS(9130),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7991),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7993),
  },
  [2564] = {
    [sym_integer] = STATE(11902),
    [sym__literal] = STATE(11902),
    [sym__unboxed_open] = STATE(703),
    [sym_variable] = STATE(11540),
    [sym_qualified_variable] = STATE(11540),
    [sym_constructor] = STATE(11192),
    [sym_qualified_constructor] = STATE(12069),
    [sym__qcon] = STATE(11540),
    [sym_con_unit] = STATE(11902),
    [sym_con_list] = STATE(11902),
    [sym_con_tuple] = STATE(11902),
    [sym_literal] = STATE(13028),
    [sym_exp_parens] = STATE(13028),
    [sym_exp_tuple] = STATE(13028),
    [sym_exp_unboxed_tuple] = STATE(13028),
    [sym_exp_unboxed_sum] = STATE(13028),
    [sym_exp_list] = STATE(13028),
    [sym_exp_arithmetic_sequence] = STATE(13028),
    [sym_exp_list_comprehension] = STATE(13028),
    [sym_exp_section_left] = STATE(13028),
    [sym_exp_section_right] = STATE(13028),
    [sym_exp_th_quoted_name] = STATE(13028),
    [sym_exp_type_application] = STATE(13455),
    [sym_exp_lambda_case] = STATE(13455),
    [sym_exp_lambda_cases] = STATE(13455),
    [sym__do_keyword] = STATE(20632),
    [sym_do_module] = STATE(20632),
    [sym_exp_do] = STATE(13455),
    [sym_exp_record] = STATE(13028),
    [sym_exp_name] = STATE(13028),
    [sym_exp_projection_selector] = STATE(13028),
    [sym__aexp_projection] = STATE(13028),
    [sym_exp_projection] = STATE(13028),
    [sym__aexp] = STATE(13455),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13893),
    [sym_splice] = STATE(13028),
    [sym_quasiquote] = STATE(13028),
    [sym__varid] = ACTIONS(4635),
    [sym_float] = ACTIONS(4637),
    [sym_char] = ACTIONS(4637),
    [sym_string] = ACTIONS(4637),
    [sym__integer_literal] = ACTIONS(4639),
    [sym__binary_literal] = ACTIONS(4641),
    [sym__octal_literal] = ACTIONS(4641),
    [sym__hex_literal] = ACTIONS(4641),
    [anon_sym_LPAREN_POUND] = ACTIONS(9764),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9764),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4645),
    [anon_sym_LPAREN] = ACTIONS(9766),
    [sym_implicit_parid] = ACTIONS(4645),
    [sym__conid] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(9768),
    [anon_sym_SQUOTE] = ACTIONS(4653),
    [anon_sym_AT] = ACTIONS(9770),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4657),
    [anon_sym_BSLASH] = ACTIONS(4659),
    [anon_sym_mdo] = ACTIONS(4661),
    [anon_sym_do] = ACTIONS(4661),
    [anon_sym_u27e6] = ACTIONS(4663),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4667),
  },
  [2565] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2565),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym_type_parens] = STATE(2565),
    [sym_type_list] = STATE(2565),
    [sym_type_tuple] = STATE(2565),
    [sym__type_promotable_literal] = STATE(2565),
    [sym__type_promoted_literal] = STATE(2565),
    [sym__type_literal] = STATE(2565),
    [sym_type_name] = STATE(2565),
    [sym_type_star] = STATE(2565),
    [sym_type_unboxed_tuple] = STATE(2565),
    [sym_type_unboxed_sum] = STATE(2565),
    [sym__atype] = STATE(2565),
    [sym_type_invisible] = STATE(2565),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2565),
    [sym_quasiquote] = STATE(2565),
    [aux_sym_type_apply_repeat1] = STATE(2565),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(9775),
    [sym_char] = ACTIONS(9775),
    [sym_string] = ACTIONS(9775),
    [sym__integer_literal] = ACTIONS(9778),
    [sym__binary_literal] = ACTIONS(9781),
    [sym__octal_literal] = ACTIONS(9781),
    [sym__hex_literal] = ACTIONS(9781),
    [anon_sym_LPAREN_POUND] = ACTIONS(9784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9784),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9787),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9799),
    [anon_sym_u2605] = ACTIONS(9799),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(9805),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(9808),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9811),
  },
  [2566] = {
    [sym_integer] = STATE(11636),
    [sym__literal] = STATE(11636),
    [sym__unboxed_open] = STATE(720),
    [sym_variable] = STATE(11789),
    [sym_qualified_variable] = STATE(11789),
    [sym_constructor] = STATE(11486),
    [sym_qualified_constructor] = STATE(11570),
    [sym__qcon] = STATE(11789),
    [sym_con_unit] = STATE(11636),
    [sym_con_list] = STATE(11636),
    [sym_con_tuple] = STATE(11636),
    [sym_literal] = STATE(12010),
    [sym_exp_parens] = STATE(12010),
    [sym_exp_tuple] = STATE(12010),
    [sym_exp_unboxed_tuple] = STATE(12010),
    [sym_exp_unboxed_sum] = STATE(12010),
    [sym_exp_list] = STATE(12010),
    [sym_exp_arithmetic_sequence] = STATE(12010),
    [sym_exp_list_comprehension] = STATE(12010),
    [sym_exp_section_left] = STATE(12010),
    [sym_exp_section_right] = STATE(12010),
    [sym_exp_th_quoted_name] = STATE(12010),
    [sym_exp_type_application] = STATE(12585),
    [sym_exp_lambda_case] = STATE(12585),
    [sym_exp_lambda_cases] = STATE(12585),
    [sym__do_keyword] = STATE(20457),
    [sym_do_module] = STATE(20457),
    [sym_exp_do] = STATE(12585),
    [sym_exp_record] = STATE(12010),
    [sym_exp_name] = STATE(12010),
    [sym_exp_projection_selector] = STATE(12010),
    [sym__aexp_projection] = STATE(12010),
    [sym_exp_projection] = STATE(12010),
    [sym__aexp] = STATE(12585),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13910),
    [sym_splice] = STATE(12010),
    [sym_quasiquote] = STATE(12010),
    [sym__varid] = ACTIONS(9814),
    [sym_float] = ACTIONS(9816),
    [sym_char] = ACTIONS(9816),
    [sym_string] = ACTIONS(9816),
    [sym__integer_literal] = ACTIONS(9818),
    [sym__binary_literal] = ACTIONS(9820),
    [sym__octal_literal] = ACTIONS(9820),
    [sym__hex_literal] = ACTIONS(9820),
    [anon_sym_LPAREN_POUND] = ACTIONS(9822),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9822),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [sym_implicit_parid] = ACTIONS(9824),
    [sym__conid] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9836),
    [anon_sym_BSLASH] = ACTIONS(9838),
    [anon_sym_mdo] = ACTIONS(9840),
    [anon_sym_do] = ACTIONS(9840),
    [anon_sym_u27e6] = ACTIONS(9842),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9844),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9846),
  },
  [2567] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(14348),
    [sym_lazy_type] = STATE(14348),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(14348),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2860),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_record_fields] = STATE(18705),
    [sym__gadt_fun] = STATE(20672),
    [sym__gadt_sig] = STATE(20672),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(6194),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6196),
    [sym__lazy] = ACTIONS(6198),
  },
  [2568] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2082),
    [sym_constructor] = STATE(2413),
    [sym_con_unit] = STATE(8550),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8529),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18975),
    [sym_lazy_type] = STATE(18975),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8513),
    [sym_type_unboxed_sum] = STATE(8513),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18975),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2826),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(15558),
    [sym_data_constructor_infix] = STATE(15558),
    [sym_data_constructor_record] = STATE(15558),
    [sym_data_constructor_special] = STATE(15558),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6106),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6106),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6108),
    [sym__conid] = ACTIONS(6110),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2569] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2570] = {
    [sym_integer] = STATE(12378),
    [sym__literal] = STATE(12378),
    [sym__unboxed_open] = STATE(715),
    [sym_variable] = STATE(12542),
    [sym_qualified_variable] = STATE(12542),
    [sym_constructor] = STATE(11803),
    [sym_qualified_constructor] = STATE(12197),
    [sym__qcon] = STATE(12542),
    [sym_con_unit] = STATE(12378),
    [sym_con_list] = STATE(12378),
    [sym_con_tuple] = STATE(12378),
    [sym_literal] = STATE(12307),
    [sym_exp_parens] = STATE(12307),
    [sym_exp_tuple] = STATE(12307),
    [sym_exp_unboxed_tuple] = STATE(12307),
    [sym_exp_unboxed_sum] = STATE(12307),
    [sym_exp_list] = STATE(12307),
    [sym_exp_arithmetic_sequence] = STATE(12307),
    [sym_exp_list_comprehension] = STATE(12307),
    [sym_exp_section_left] = STATE(12307),
    [sym_exp_section_right] = STATE(12307),
    [sym_exp_th_quoted_name] = STATE(12307),
    [sym_exp_type_application] = STATE(13203),
    [sym_exp_lambda_case] = STATE(13203),
    [sym_exp_lambda_cases] = STATE(13203),
    [sym__do_keyword] = STATE(20620),
    [sym_do_module] = STATE(20620),
    [sym_exp_do] = STATE(13203),
    [sym_exp_record] = STATE(12307),
    [sym_exp_name] = STATE(12307),
    [sym_exp_projection_selector] = STATE(12307),
    [sym__aexp_projection] = STATE(12307),
    [sym_exp_projection] = STATE(12307),
    [sym__aexp] = STATE(13203),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13894),
    [sym_splice] = STATE(12307),
    [sym_quasiquote] = STATE(12307),
    [sym__varid] = ACTIONS(9848),
    [sym_float] = ACTIONS(9850),
    [sym_char] = ACTIONS(9850),
    [sym_string] = ACTIONS(9850),
    [sym__integer_literal] = ACTIONS(9852),
    [sym__binary_literal] = ACTIONS(9854),
    [sym__octal_literal] = ACTIONS(9854),
    [sym__hex_literal] = ACTIONS(9854),
    [anon_sym_LPAREN_POUND] = ACTIONS(9856),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9856),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(9860),
    [sym_implicit_parid] = ACTIONS(9858),
    [sym__conid] = ACTIONS(9862),
    [anon_sym_LBRACK] = ACTIONS(9864),
    [anon_sym_SQUOTE] = ACTIONS(9866),
    [anon_sym_AT] = ACTIONS(9868),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9870),
    [anon_sym_BSLASH] = ACTIONS(9872),
    [anon_sym_mdo] = ACTIONS(9874),
    [anon_sym_do] = ACTIONS(9874),
    [anon_sym_u27e6] = ACTIONS(9876),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9878),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9880),
  },
  [2571] = {
    [sym_integer] = STATE(10708),
    [sym__literal] = STATE(10708),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(10761),
    [sym_qualified_variable] = STATE(10761),
    [sym_constructor] = STATE(10623),
    [sym_qualified_constructor] = STATE(10748),
    [sym__qcon] = STATE(10761),
    [sym_con_unit] = STATE(10708),
    [sym_con_list] = STATE(10708),
    [sym_con_tuple] = STATE(10708),
    [sym_literal] = STATE(11036),
    [sym_exp_parens] = STATE(11036),
    [sym_exp_tuple] = STATE(11036),
    [sym_exp_unboxed_tuple] = STATE(11036),
    [sym_exp_unboxed_sum] = STATE(11036),
    [sym_exp_list] = STATE(11036),
    [sym_exp_arithmetic_sequence] = STATE(11036),
    [sym_exp_list_comprehension] = STATE(11036),
    [sym_exp_section_left] = STATE(11036),
    [sym_exp_section_right] = STATE(11036),
    [sym_exp_th_quoted_name] = STATE(11036),
    [sym_exp_type_application] = STATE(11241),
    [sym_exp_lambda_case] = STATE(11241),
    [sym_exp_lambda_cases] = STATE(11241),
    [sym__do_keyword] = STATE(20758),
    [sym_do_module] = STATE(20758),
    [sym_exp_do] = STATE(11241),
    [sym_exp_record] = STATE(11036),
    [sym_exp_name] = STATE(11036),
    [sym_exp_projection_selector] = STATE(11036),
    [sym__aexp_projection] = STATE(11036),
    [sym_exp_projection] = STATE(11036),
    [sym__aexp] = STATE(11241),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14108),
    [sym_splice] = STATE(11036),
    [sym_quasiquote] = STATE(11036),
    [sym__varid] = ACTIONS(3563),
    [sym_float] = ACTIONS(3565),
    [sym_char] = ACTIONS(3565),
    [sym_string] = ACTIONS(3565),
    [sym__integer_literal] = ACTIONS(3567),
    [sym__binary_literal] = ACTIONS(3569),
    [sym__octal_literal] = ACTIONS(3569),
    [sym__hex_literal] = ACTIONS(3569),
    [anon_sym_LPAREN_POUND] = ACTIONS(8900),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8900),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(8902),
    [sym_implicit_parid] = ACTIONS(3573),
    [sym__conid] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(8904),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [anon_sym_AT] = ACTIONS(8906),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3587),
    [anon_sym_BSLASH] = ACTIONS(3589),
    [anon_sym_mdo] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_u27e6] = ACTIONS(3593),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3597),
  },
  [2572] = {
    [sym_integer] = STATE(12421),
    [sym__literal] = STATE(12421),
    [sym__unboxed_open] = STATE(718),
    [sym_variable] = STATE(12614),
    [sym_qualified_variable] = STATE(12614),
    [sym_constructor] = STATE(11766),
    [sym_qualified_constructor] = STATE(12622),
    [sym__qcon] = STATE(12614),
    [sym_con_unit] = STATE(12421),
    [sym_con_list] = STATE(12421),
    [sym_con_tuple] = STATE(12421),
    [sym_literal] = STATE(12303),
    [sym_exp_parens] = STATE(12303),
    [sym_exp_tuple] = STATE(12303),
    [sym_exp_unboxed_tuple] = STATE(12303),
    [sym_exp_unboxed_sum] = STATE(12303),
    [sym_exp_list] = STATE(12303),
    [sym_exp_arithmetic_sequence] = STATE(12303),
    [sym_exp_list_comprehension] = STATE(12303),
    [sym_exp_section_left] = STATE(12303),
    [sym_exp_section_right] = STATE(12303),
    [sym_exp_th_quoted_name] = STATE(12303),
    [sym_exp_type_application] = STATE(12981),
    [sym_exp_lambda_case] = STATE(12981),
    [sym_exp_lambda_cases] = STATE(12981),
    [sym__do_keyword] = STATE(20476),
    [sym_do_module] = STATE(20476),
    [sym_exp_do] = STATE(12981),
    [sym_exp_record] = STATE(12303),
    [sym_exp_name] = STATE(12303),
    [sym_exp_projection_selector] = STATE(12303),
    [sym__aexp_projection] = STATE(12303),
    [sym_exp_projection] = STATE(12303),
    [sym__aexp] = STATE(12981),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13905),
    [sym_splice] = STATE(12303),
    [sym_quasiquote] = STATE(12303),
    [sym__varid] = ACTIONS(9882),
    [sym_float] = ACTIONS(9884),
    [sym_char] = ACTIONS(9884),
    [sym_string] = ACTIONS(9884),
    [sym__integer_literal] = ACTIONS(9886),
    [sym__binary_literal] = ACTIONS(9888),
    [sym__octal_literal] = ACTIONS(9888),
    [sym__hex_literal] = ACTIONS(9888),
    [anon_sym_LPAREN_POUND] = ACTIONS(9890),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9890),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9892),
    [anon_sym_LPAREN] = ACTIONS(9894),
    [sym_implicit_parid] = ACTIONS(9892),
    [sym__conid] = ACTIONS(9896),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9900),
    [anon_sym_AT] = ACTIONS(9902),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9904),
    [anon_sym_BSLASH] = ACTIONS(9906),
    [anon_sym_mdo] = ACTIONS(9908),
    [anon_sym_do] = ACTIONS(9908),
    [anon_sym_u27e6] = ACTIONS(9910),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9912),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9914),
  },
  [2573] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2093),
    [sym_constructor] = STATE(2411),
    [sym_con_unit] = STATE(8515),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8488),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18721),
    [sym_lazy_type] = STATE(18721),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8494),
    [sym_type_unboxed_sum] = STATE(8494),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18721),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2880),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(15997),
    [sym_data_constructor_infix] = STATE(15997),
    [sym_data_constructor_record] = STATE(15997),
    [sym_data_constructor_special] = STATE(15997),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6094),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6094),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6096),
    [sym__conid] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2574] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(2481),
    [sym_con_unit] = STATE(8844),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8841),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18636),
    [sym_lazy_type] = STATE(18636),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8830),
    [sym_type_unboxed_sum] = STATE(8830),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18636),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2886),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(16198),
    [sym_data_constructor_infix] = STATE(16198),
    [sym_data_constructor_record] = STATE(16198),
    [sym_data_constructor_special] = STATE(16198),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6114),
    [sym__conid] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2575] = {
    [sym_integer] = STATE(12280),
    [sym__literal] = STATE(12280),
    [sym__unboxed_open] = STATE(710),
    [sym_variable] = STATE(12761),
    [sym_qualified_variable] = STATE(12761),
    [sym_constructor] = STATE(11578),
    [sym_qualified_constructor] = STATE(12329),
    [sym__qcon] = STATE(12761),
    [sym_con_unit] = STATE(12280),
    [sym_con_list] = STATE(12280),
    [sym_con_tuple] = STATE(12280),
    [sym_literal] = STATE(12510),
    [sym_exp_parens] = STATE(12510),
    [sym_exp_tuple] = STATE(12510),
    [sym_exp_unboxed_tuple] = STATE(12510),
    [sym_exp_unboxed_sum] = STATE(12510),
    [sym_exp_list] = STATE(12510),
    [sym_exp_arithmetic_sequence] = STATE(12510),
    [sym_exp_list_comprehension] = STATE(12510),
    [sym_exp_section_left] = STATE(12510),
    [sym_exp_section_right] = STATE(12510),
    [sym_exp_th_quoted_name] = STATE(12510),
    [sym_exp_type_application] = STATE(12906),
    [sym_exp_lambda_case] = STATE(12906),
    [sym_exp_lambda_cases] = STATE(12906),
    [sym__do_keyword] = STATE(20596),
    [sym_do_module] = STATE(20596),
    [sym_exp_do] = STATE(12906),
    [sym_exp_record] = STATE(12510),
    [sym_exp_name] = STATE(12510),
    [sym_exp_projection_selector] = STATE(12510),
    [sym__aexp_projection] = STATE(12510),
    [sym_exp_projection] = STATE(12510),
    [sym__aexp] = STATE(12906),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13945),
    [sym_splice] = STATE(12510),
    [sym_quasiquote] = STATE(12510),
    [sym__varid] = ACTIONS(9916),
    [sym_float] = ACTIONS(9918),
    [sym_char] = ACTIONS(9918),
    [sym_string] = ACTIONS(9918),
    [sym__integer_literal] = ACTIONS(9920),
    [sym__binary_literal] = ACTIONS(9922),
    [sym__octal_literal] = ACTIONS(9922),
    [sym__hex_literal] = ACTIONS(9922),
    [anon_sym_LPAREN_POUND] = ACTIONS(9924),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9924),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [sym_implicit_parid] = ACTIONS(9926),
    [sym__conid] = ACTIONS(9930),
    [anon_sym_LBRACK] = ACTIONS(9932),
    [anon_sym_SQUOTE] = ACTIONS(9934),
    [anon_sym_AT] = ACTIONS(9936),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9938),
    [anon_sym_BSLASH] = ACTIONS(9940),
    [anon_sym_mdo] = ACTIONS(9942),
    [anon_sym_do] = ACTIONS(9942),
    [anon_sym_u27e6] = ACTIONS(9944),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9946),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9948),
  },
  [2576] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2576),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym_type_parens] = STATE(2576),
    [sym_type_list] = STATE(2576),
    [sym_type_tuple] = STATE(2576),
    [sym__type_promotable_literal] = STATE(2576),
    [sym__type_promoted_literal] = STATE(2576),
    [sym__type_literal] = STATE(2576),
    [sym_type_name] = STATE(2576),
    [sym_type_star] = STATE(2576),
    [sym_type_unboxed_tuple] = STATE(2576),
    [sym_type_unboxed_sum] = STATE(2576),
    [sym__atype] = STATE(2576),
    [sym_type_invisible] = STATE(2576),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2576),
    [sym_quasiquote] = STATE(2576),
    [aux_sym_type_apply_repeat1] = STATE(2576),
    [sym__varid] = ACTIONS(9950),
    [sym_float] = ACTIONS(9953),
    [sym_char] = ACTIONS(9953),
    [sym_string] = ACTIONS(9953),
    [sym__integer_literal] = ACTIONS(9956),
    [sym__binary_literal] = ACTIONS(9959),
    [sym__octal_literal] = ACTIONS(9959),
    [sym__hex_literal] = ACTIONS(9959),
    [anon_sym_LPAREN_POUND] = ACTIONS(9962),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9962),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9965),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(9968),
    [anon_sym_LBRACK] = ACTIONS(9971),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(9974),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(9977),
    [anon_sym_u2605] = ACTIONS(9977),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(9983),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(9986),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(9989),
  },
  [2577] = {
    [sym_integer] = STATE(10522),
    [sym__literal] = STATE(10522),
    [sym__unboxed_open] = STATE(704),
    [sym_variable] = STATE(10558),
    [sym_qualified_variable] = STATE(10558),
    [sym_constructor] = STATE(10325),
    [sym_qualified_constructor] = STATE(10464),
    [sym__qcon] = STATE(10558),
    [sym_con_unit] = STATE(10522),
    [sym_con_list] = STATE(10522),
    [sym_con_tuple] = STATE(10522),
    [sym_literal] = STATE(10680),
    [sym_exp_parens] = STATE(10680),
    [sym_exp_tuple] = STATE(10680),
    [sym_exp_unboxed_tuple] = STATE(10680),
    [sym_exp_unboxed_sum] = STATE(10680),
    [sym_exp_list] = STATE(10680),
    [sym_exp_arithmetic_sequence] = STATE(10680),
    [sym_exp_list_comprehension] = STATE(10680),
    [sym_exp_section_left] = STATE(10680),
    [sym_exp_section_right] = STATE(10680),
    [sym_exp_th_quoted_name] = STATE(10680),
    [sym_exp_type_application] = STATE(10760),
    [sym_exp_lambda_case] = STATE(10760),
    [sym_exp_lambda_cases] = STATE(10760),
    [sym__do_keyword] = STATE(20735),
    [sym_do_module] = STATE(20735),
    [sym_exp_do] = STATE(10760),
    [sym_exp_record] = STATE(10680),
    [sym_exp_name] = STATE(10680),
    [sym_exp_projection_selector] = STATE(10680),
    [sym__aexp_projection] = STATE(10680),
    [sym_exp_projection] = STATE(10680),
    [sym__aexp] = STATE(10760),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13964),
    [sym_splice] = STATE(10680),
    [sym_quasiquote] = STATE(10680),
    [sym__varid] = ACTIONS(4861),
    [sym_float] = ACTIONS(4863),
    [sym_char] = ACTIONS(4863),
    [sym_string] = ACTIONS(4863),
    [sym__integer_literal] = ACTIONS(4865),
    [sym__binary_literal] = ACTIONS(4867),
    [sym__octal_literal] = ACTIONS(4867),
    [sym__hex_literal] = ACTIONS(4867),
    [anon_sym_LPAREN_POUND] = ACTIONS(8942),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8942),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4393),
    [anon_sym_LPAREN] = ACTIONS(8944),
    [sym_implicit_parid] = ACTIONS(4393),
    [sym__conid] = ACTIONS(4873),
    [anon_sym_LBRACK] = ACTIONS(8946),
    [anon_sym_SQUOTE] = ACTIONS(4399),
    [anon_sym_AT] = ACTIONS(8948),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4403),
    [anon_sym_BSLASH] = ACTIONS(4405),
    [anon_sym_mdo] = ACTIONS(4407),
    [anon_sym_do] = ACTIONS(4407),
    [anon_sym_u27e6] = ACTIONS(4879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4883),
  },
  [2578] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2548),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym_type_parens] = STATE(2548),
    [sym_type_list] = STATE(2548),
    [sym_type_tuple] = STATE(2548),
    [sym__type_promotable_literal] = STATE(2548),
    [sym__type_promoted_literal] = STATE(2548),
    [sym__type_literal] = STATE(2548),
    [sym_type_name] = STATE(2548),
    [sym_type_star] = STATE(2548),
    [sym_type_unboxed_tuple] = STATE(2548),
    [sym_type_unboxed_sum] = STATE(2548),
    [sym__atype] = STATE(2548),
    [sym_type_invisible] = STATE(2548),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2548),
    [sym_quasiquote] = STATE(2548),
    [aux_sym_type_apply_repeat1] = STATE(2548),
    [sym__varid] = ACTIONS(9500),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8682),
    [sym_char] = ACTIONS(8682),
    [sym_string] = ACTIONS(8682),
    [sym__integer_literal] = ACTIONS(8684),
    [sym__binary_literal] = ACTIONS(8686),
    [sym__octal_literal] = ACTIONS(8686),
    [sym__hex_literal] = ACTIONS(8686),
    [anon_sym_LPAREN_POUND] = ACTIONS(8688),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8688),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9502),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(9992),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_SQUOTE] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8700),
    [anon_sym_u2605] = ACTIONS(8700),
    [anon_sym_AT] = ACTIONS(9510),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8702),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8704),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8706),
  },
  [2579] = {
    [sym_integer] = STATE(11890),
    [sym__literal] = STATE(11890),
    [sym__unboxed_open] = STATE(727),
    [sym_variable] = STATE(11697),
    [sym_qualified_variable] = STATE(11697),
    [sym_constructor] = STATE(11426),
    [sym_qualified_constructor] = STATE(11528),
    [sym__qcon] = STATE(11697),
    [sym_con_unit] = STATE(11890),
    [sym_con_list] = STATE(11890),
    [sym_con_tuple] = STATE(11890),
    [sym_literal] = STATE(12528),
    [sym_exp_parens] = STATE(12528),
    [sym_exp_tuple] = STATE(12528),
    [sym_exp_unboxed_tuple] = STATE(12528),
    [sym_exp_unboxed_sum] = STATE(12528),
    [sym_exp_list] = STATE(12528),
    [sym_exp_arithmetic_sequence] = STATE(12528),
    [sym_exp_list_comprehension] = STATE(12528),
    [sym_exp_section_left] = STATE(12528),
    [sym_exp_section_right] = STATE(12528),
    [sym_exp_th_quoted_name] = STATE(12528),
    [sym_exp_type_application] = STATE(12943),
    [sym_exp_lambda_case] = STATE(12943),
    [sym_exp_lambda_cases] = STATE(12943),
    [sym__do_keyword] = STATE(20569),
    [sym_do_module] = STATE(20569),
    [sym_exp_do] = STATE(12943),
    [sym_exp_record] = STATE(12528),
    [sym_exp_name] = STATE(12528),
    [sym_exp_projection_selector] = STATE(12528),
    [sym__aexp_projection] = STATE(12528),
    [sym_exp_projection] = STATE(12528),
    [sym__aexp] = STATE(12943),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13990),
    [sym_splice] = STATE(12528),
    [sym_quasiquote] = STATE(12528),
    [sym__varid] = ACTIONS(4765),
    [sym_float] = ACTIONS(4767),
    [sym_char] = ACTIONS(4767),
    [sym_string] = ACTIONS(4767),
    [sym__integer_literal] = ACTIONS(4769),
    [sym__binary_literal] = ACTIONS(4771),
    [sym__octal_literal] = ACTIONS(4771),
    [sym__hex_literal] = ACTIONS(4771),
    [anon_sym_LPAREN_POUND] = ACTIONS(9998),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9998),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [sym_implicit_parid] = ACTIONS(10000),
    [sym__conid] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10006),
    [anon_sym_AT] = ACTIONS(10008),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(10010),
    [anon_sym_BSLASH] = ACTIONS(10012),
    [anon_sym_mdo] = ACTIONS(10014),
    [anon_sym_do] = ACTIONS(10014),
    [anon_sym_u27e6] = ACTIONS(4793),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4797),
  },
  [2580] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2581] = {
    [sym_integer] = STATE(12301),
    [sym__literal] = STATE(12301),
    [sym__unboxed_open] = STATE(709),
    [sym_variable] = STATE(12709),
    [sym_qualified_variable] = STATE(12709),
    [sym_constructor] = STATE(11712),
    [sym_qualified_constructor] = STATE(12598),
    [sym__qcon] = STATE(12709),
    [sym_con_unit] = STATE(12301),
    [sym_con_list] = STATE(12301),
    [sym_con_tuple] = STATE(12301),
    [sym_literal] = STATE(12569),
    [sym_exp_parens] = STATE(12569),
    [sym_exp_tuple] = STATE(12569),
    [sym_exp_unboxed_tuple] = STATE(12569),
    [sym_exp_unboxed_sum] = STATE(12569),
    [sym_exp_list] = STATE(12569),
    [sym_exp_arithmetic_sequence] = STATE(12569),
    [sym_exp_list_comprehension] = STATE(12569),
    [sym_exp_section_left] = STATE(12569),
    [sym_exp_section_right] = STATE(12569),
    [sym_exp_th_quoted_name] = STATE(12569),
    [sym_exp_type_application] = STATE(12902),
    [sym_exp_lambda_case] = STATE(12902),
    [sym_exp_lambda_cases] = STATE(12902),
    [sym__do_keyword] = STATE(20640),
    [sym_do_module] = STATE(20640),
    [sym_exp_do] = STATE(12902),
    [sym_exp_record] = STATE(12569),
    [sym_exp_name] = STATE(12569),
    [sym_exp_projection_selector] = STATE(12569),
    [sym__aexp_projection] = STATE(12569),
    [sym_exp_projection] = STATE(12569),
    [sym__aexp] = STATE(12902),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14071),
    [sym_splice] = STATE(12569),
    [sym_quasiquote] = STATE(12569),
    [sym__varid] = ACTIONS(4539),
    [sym_float] = ACTIONS(4541),
    [sym_char] = ACTIONS(4541),
    [sym_string] = ACTIONS(4541),
    [sym__integer_literal] = ACTIONS(4543),
    [sym__binary_literal] = ACTIONS(4545),
    [sym__octal_literal] = ACTIONS(4545),
    [sym__hex_literal] = ACTIONS(4545),
    [anon_sym_LPAREN_POUND] = ACTIONS(10016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4549),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [sym_implicit_parid] = ACTIONS(4549),
    [sym__conid] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(4557),
    [anon_sym_AT] = ACTIONS(10022),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4561),
    [anon_sym_BSLASH] = ACTIONS(4563),
    [anon_sym_mdo] = ACTIONS(4565),
    [anon_sym_do] = ACTIONS(4565),
    [anon_sym_u27e6] = ACTIONS(4567),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4571),
  },
  [2582] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(2481),
    [sym_con_unit] = STATE(8844),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(8841),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_strict_type] = STATE(18636),
    [sym_lazy_type] = STATE(18636),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(8830),
    [sym_type_unboxed_sum] = STATE(8830),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10662),
    [sym__btype] = STATE(10662),
    [sym_type_infix] = STATE(16484),
    [sym__type_infix] = STATE(18636),
    [sym_constraint] = STATE(18014),
    [sym__context_constraints] = STATE(18014),
    [sym__context] = STATE(10289),
    [sym_context] = STATE(2926),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_data_constructor] = STATE(16548),
    [sym_data_constructor_infix] = STATE(16548),
    [sym_data_constructor_record] = STATE(16548),
    [sym_data_constructor_special] = STATE(16548),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(9608),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6114),
    [sym__conid] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
    [sym__strict] = ACTIONS(6102),
    [sym__lazy] = ACTIONS(6104),
  },
  [2583] = {
    [sym_integer] = STATE(11125),
    [sym__literal] = STATE(11125),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = STATE(11068),
    [sym_qualified_variable] = STATE(11068),
    [sym_constructor] = STATE(10858),
    [sym_qualified_constructor] = STATE(11007),
    [sym__qcon] = STATE(11068),
    [sym_con_unit] = STATE(11125),
    [sym_con_list] = STATE(11125),
    [sym_con_tuple] = STATE(11125),
    [sym_literal] = STATE(11071),
    [sym_exp_parens] = STATE(11071),
    [sym_exp_tuple] = STATE(11071),
    [sym_exp_unboxed_tuple] = STATE(11071),
    [sym_exp_unboxed_sum] = STATE(11071),
    [sym_exp_list] = STATE(11071),
    [sym_exp_arithmetic_sequence] = STATE(11071),
    [sym_exp_list_comprehension] = STATE(11071),
    [sym_exp_section_left] = STATE(11071),
    [sym_exp_section_right] = STATE(11071),
    [sym_exp_th_quoted_name] = STATE(11071),
    [sym_exp_type_application] = STATE(11256),
    [sym_exp_lambda_case] = STATE(11256),
    [sym_exp_lambda_cases] = STATE(11256),
    [sym__do_keyword] = STATE(20746),
    [sym_do_module] = STATE(20746),
    [sym_exp_do] = STATE(11256),
    [sym_exp_record] = STATE(11071),
    [sym_exp_name] = STATE(11071),
    [sym_exp_projection_selector] = STATE(11071),
    [sym__aexp_projection] = STATE(11071),
    [sym_exp_projection] = STATE(11071),
    [sym__aexp] = STATE(11256),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(13892),
    [sym_splice] = STATE(11071),
    [sym_quasiquote] = STATE(11071),
    [sym__varid] = ACTIONS(4499),
    [sym_float] = ACTIONS(4501),
    [sym_char] = ACTIONS(4501),
    [sym_string] = ACTIONS(4501),
    [sym__integer_literal] = ACTIONS(4503),
    [sym__binary_literal] = ACTIONS(4505),
    [sym__octal_literal] = ACTIONS(4505),
    [sym__hex_literal] = ACTIONS(4505),
    [anon_sym_LPAREN_POUND] = ACTIONS(10024),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10024),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(10026),
    [sym_implicit_parid] = ACTIONS(4509),
    [sym__conid] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(4517),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4521),
    [anon_sym_BSLASH] = ACTIONS(4523),
    [anon_sym_mdo] = ACTIONS(4525),
    [anon_sym_do] = ACTIONS(4525),
    [anon_sym_u27e6] = ACTIONS(4527),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4529),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4531),
  },
  [2584] = {
    [sym_integer] = STATE(13023),
    [sym__literal] = STATE(13023),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = STATE(13201),
    [sym_qualified_variable] = STATE(13201),
    [sym_constructor] = STATE(12279),
    [sym_qualified_constructor] = STATE(13114),
    [sym__qcon] = STATE(13201),
    [sym_con_unit] = STATE(13023),
    [sym_con_list] = STATE(13023),
    [sym_con_tuple] = STATE(13023),
    [sym_literal] = STATE(12941),
    [sym_exp_parens] = STATE(12941),
    [sym_exp_tuple] = STATE(12941),
    [sym_exp_unboxed_tuple] = STATE(12941),
    [sym_exp_unboxed_sum] = STATE(12941),
    [sym_exp_list] = STATE(12941),
    [sym_exp_arithmetic_sequence] = STATE(12941),
    [sym_exp_list_comprehension] = STATE(12941),
    [sym_exp_section_left] = STATE(12941),
    [sym_exp_section_right] = STATE(12941),
    [sym_exp_th_quoted_name] = STATE(12941),
    [sym_exp_type_application] = STATE(13309),
    [sym_exp_lambda_case] = STATE(13309),
    [sym_exp_lambda_cases] = STATE(13309),
    [sym__do_keyword] = STATE(20518),
    [sym_do_module] = STATE(20518),
    [sym_exp_do] = STATE(13309),
    [sym_exp_record] = STATE(12941),
    [sym_exp_name] = STATE(12941),
    [sym_exp_projection_selector] = STATE(12941),
    [sym__aexp_projection] = STATE(12941),
    [sym_exp_projection] = STATE(12941),
    [sym__aexp] = STATE(13309),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(14096),
    [sym_splice] = STATE(12941),
    [sym_quasiquote] = STATE(12941),
    [sym__varid] = ACTIONS(10032),
    [sym_float] = ACTIONS(10034),
    [sym_char] = ACTIONS(10034),
    [sym_string] = ACTIONS(10034),
    [sym__integer_literal] = ACTIONS(10036),
    [sym__binary_literal] = ACTIONS(10038),
    [sym__octal_literal] = ACTIONS(10038),
    [sym__hex_literal] = ACTIONS(10038),
    [anon_sym_LPAREN_POUND] = ACTIONS(10040),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10040),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(10042),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [sym_implicit_parid] = ACTIONS(10042),
    [sym__conid] = ACTIONS(10046),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10050),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(10054),
    [anon_sym_BSLASH] = ACTIONS(10056),
    [anon_sym_mdo] = ACTIONS(10058),
    [anon_sym_do] = ACTIONS(10058),
    [anon_sym_u27e6] = ACTIONS(10060),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(10062),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10064),
  },
  [2585] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__varsym] = ACTIONS(5542),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
    [sym__unboxed_close] = ACTIONS(5542),
  },
  [2586] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2727),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym_type_parens] = STATE(2727),
    [sym_type_list] = STATE(2727),
    [sym_type_tuple] = STATE(2727),
    [sym__type_promotable_literal] = STATE(2727),
    [sym__type_promoted_literal] = STATE(2727),
    [sym__type_literal] = STATE(2727),
    [sym_type_name] = STATE(2727),
    [sym_type_star] = STATE(2727),
    [sym_type_unboxed_tuple] = STATE(2727),
    [sym_type_unboxed_sum] = STATE(2727),
    [sym__atype] = STATE(2727),
    [sym_type_invisible] = STATE(2727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2727),
    [sym_quasiquote] = STATE(2727),
    [aux_sym_type_apply_repeat1] = STATE(2727),
    [sym__varid] = ACTIONS(10066),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8217),
    [sym_char] = ACTIONS(8217),
    [sym_string] = ACTIONS(8217),
    [sym__integer_literal] = ACTIONS(8219),
    [sym__binary_literal] = ACTIONS(8221),
    [sym__octal_literal] = ACTIONS(8221),
    [sym__hex_literal] = ACTIONS(8221),
    [anon_sym_LPAREN_POUND] = ACTIONS(8223),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8223),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10070),
    [anon_sym_LBRACK] = ACTIONS(8231),
    [anon_sym_SQUOTE] = ACTIONS(10073),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(8235),
    [anon_sym_u2605] = ACTIONS(8235),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8237),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8239),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8241),
  },
  [2587] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2627),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15735),
    [sym_type_parens] = STATE(2627),
    [sym_type_list] = STATE(2627),
    [sym_type_tuple] = STATE(2627),
    [sym__type_promotable_literal] = STATE(2627),
    [sym__type_promoted_literal] = STATE(2627),
    [sym__type_literal] = STATE(2627),
    [sym_type_name] = STATE(2780),
    [sym_type_star] = STATE(2627),
    [sym_type_unboxed_tuple] = STATE(2627),
    [sym_type_unboxed_sum] = STATE(2627),
    [sym__atype] = STATE(2627),
    [sym_type_apply] = STATE(9005),
    [sym__btype] = STATE(9005),
    [sym_type_infix] = STATE(13888),
    [sym__type_infix] = STATE(13584),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(17809),
    [sym__type_context] = STATE(17809),
    [sym__type_fun] = STATE(17809),
    [sym__type] = STATE(17809),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2627),
    [sym_quasiquote] = STATE(2627),
    [sym__varid] = ACTIONS(8456),
    [sym_float] = ACTIONS(8458),
    [sym_char] = ACTIONS(8458),
    [sym_string] = ACTIONS(8458),
    [sym__integer_literal] = ACTIONS(8460),
    [sym__binary_literal] = ACTIONS(8462),
    [sym__octal_literal] = ACTIONS(8462),
    [sym__hex_literal] = ACTIONS(8462),
    [anon_sym_LPAREN_POUND] = ACTIONS(8464),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8464),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [sym__conid] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8472),
    [anon_sym_SQUOTE] = ACTIONS(8474),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8476),
    [anon_sym_u2605] = ACTIONS(8476),
    [anon_sym_u27e6] = ACTIONS(8478),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8480),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8482),
  },
  [2588] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DOT_DOT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2589] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2598),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym_type_parens] = STATE(2598),
    [sym_type_list] = STATE(2598),
    [sym_type_tuple] = STATE(2598),
    [sym__type_promotable_literal] = STATE(2598),
    [sym__type_promoted_literal] = STATE(2598),
    [sym__type_literal] = STATE(2598),
    [sym_type_name] = STATE(2598),
    [sym_type_star] = STATE(2598),
    [sym_type_unboxed_tuple] = STATE(2598),
    [sym_type_unboxed_sum] = STATE(2598),
    [sym__atype] = STATE(2598),
    [sym_type_invisible] = STATE(2598),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2598),
    [sym_quasiquote] = STATE(2598),
    [aux_sym_type_apply_repeat1] = STATE(2598),
    [sym__varid] = ACTIONS(8548),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8550),
    [sym_char] = ACTIONS(8550),
    [sym_string] = ACTIONS(8550),
    [sym__integer_literal] = ACTIONS(8552),
    [sym__binary_literal] = ACTIONS(8554),
    [sym__octal_literal] = ACTIONS(8554),
    [sym__hex_literal] = ACTIONS(8554),
    [anon_sym_LPAREN_POUND] = ACTIONS(8556),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8556),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(8564),
    [anon_sym_SQUOTE] = ACTIONS(10083),
    [anon_sym_STAR] = ACTIONS(8568),
    [anon_sym_u2605] = ACTIONS(8568),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(8570),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8572),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8574),
  },
  [2590] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15674),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2517),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(8422),
    [sym__btype] = STATE(8422),
    [sym_type_infix] = STATE(11259),
    [sym__type_infix] = STATE(11143),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2590),
    [sym__type_quantifiers] = STATE(12925),
    [sym__type_context] = STATE(12925),
    [sym__type_fun] = STATE(12925),
    [sym__type] = STATE(12925),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(8205),
    [sym_float] = ACTIONS(7927),
    [sym_char] = ACTIONS(7927),
    [sym_string] = ACTIONS(7927),
    [sym__integer_literal] = ACTIONS(7929),
    [sym__binary_literal] = ACTIONS(7931),
    [sym__octal_literal] = ACTIONS(7931),
    [sym__hex_literal] = ACTIONS(7931),
    [anon_sym_LPAREN_POUND] = ACTIONS(7933),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7933),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8207),
    [sym__conid] = ACTIONS(8211),
    [anon_sym_LBRACK] = ACTIONS(7940),
    [anon_sym_SQUOTE] = ACTIONS(8213),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_u2605] = ACTIONS(7945),
    [anon_sym_u27e6] = ACTIONS(7949),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7951),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7953),
  },
  [2591] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15674),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2517),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(8422),
    [sym__btype] = STATE(8422),
    [sym_type_infix] = STATE(11259),
    [sym__type_infix] = STATE(11143),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2590),
    [sym__type_quantifiers] = STATE(13017),
    [sym__type_context] = STATE(13017),
    [sym__type_fun] = STATE(13017),
    [sym__type] = STATE(13017),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(8205),
    [sym_float] = ACTIONS(7927),
    [sym_char] = ACTIONS(7927),
    [sym_string] = ACTIONS(7927),
    [sym__integer_literal] = ACTIONS(7929),
    [sym__binary_literal] = ACTIONS(7931),
    [sym__octal_literal] = ACTIONS(7931),
    [sym__hex_literal] = ACTIONS(7931),
    [anon_sym_LPAREN_POUND] = ACTIONS(7933),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7933),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8207),
    [sym__conid] = ACTIONS(8211),
    [anon_sym_LBRACK] = ACTIONS(7940),
    [anon_sym_SQUOTE] = ACTIONS(8213),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_u2605] = ACTIONS(7945),
    [anon_sym_u27e6] = ACTIONS(7949),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7951),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7953),
  },
  [2592] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2627),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15735),
    [sym_type_parens] = STATE(2627),
    [sym_type_list] = STATE(2627),
    [sym_type_tuple] = STATE(2627),
    [sym__type_promotable_literal] = STATE(2627),
    [sym__type_promoted_literal] = STATE(2627),
    [sym__type_literal] = STATE(2627),
    [sym_type_name] = STATE(2780),
    [sym_type_star] = STATE(2627),
    [sym_type_unboxed_tuple] = STATE(2627),
    [sym_type_unboxed_sum] = STATE(2627),
    [sym__atype] = STATE(2627),
    [sym_type_apply] = STATE(9005),
    [sym__btype] = STATE(9005),
    [sym_type_infix] = STATE(13888),
    [sym__type_infix] = STATE(13584),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(17810),
    [sym__type_context] = STATE(17810),
    [sym__type_fun] = STATE(17810),
    [sym__type] = STATE(17810),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2627),
    [sym_quasiquote] = STATE(2627),
    [sym__varid] = ACTIONS(8456),
    [sym_float] = ACTIONS(8458),
    [sym_char] = ACTIONS(8458),
    [sym_string] = ACTIONS(8458),
    [sym__integer_literal] = ACTIONS(8460),
    [sym__binary_literal] = ACTIONS(8462),
    [sym__octal_literal] = ACTIONS(8462),
    [sym__hex_literal] = ACTIONS(8462),
    [anon_sym_LPAREN_POUND] = ACTIONS(8464),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8464),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [sym__conid] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8472),
    [anon_sym_SQUOTE] = ACTIONS(8474),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8476),
    [anon_sym_u2605] = ACTIONS(8476),
    [anon_sym_u27e6] = ACTIONS(8478),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8480),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8482),
  },
  [2593] = {
    [sym_integer] = STATE(7197),
    [sym__literal] = STATE(7197),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(6696),
    [sym_con_unit] = STATE(7197),
    [sym_con_list] = STATE(7197),
    [sym_con_tuple] = STATE(7197),
    [sym_qualified_type] = STATE(7229),
    [sym_tycon_arrow] = STATE(7229),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(7229),
    [sym_type_variable] = STATE(7229),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15674),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2517),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(8422),
    [sym__btype] = STATE(8422),
    [sym_type_infix] = STATE(11259),
    [sym__type_infix] = STATE(11143),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2590),
    [sym__type_quantifiers] = STATE(13004),
    [sym__type_context] = STATE(13004),
    [sym__type_fun] = STATE(13004),
    [sym__type] = STATE(13004),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16943),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(8205),
    [sym_float] = ACTIONS(7927),
    [sym_char] = ACTIONS(7927),
    [sym_string] = ACTIONS(7927),
    [sym__integer_literal] = ACTIONS(7929),
    [sym__binary_literal] = ACTIONS(7931),
    [sym__octal_literal] = ACTIONS(7931),
    [sym__hex_literal] = ACTIONS(7931),
    [anon_sym_LPAREN_POUND] = ACTIONS(7933),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7933),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8207),
    [sym__conid] = ACTIONS(8211),
    [anon_sym_LBRACK] = ACTIONS(7940),
    [anon_sym_SQUOTE] = ACTIONS(8213),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_u2605] = ACTIONS(7945),
    [anon_sym_u27e6] = ACTIONS(7949),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7951),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7953),
  },
  [2594] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2705),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16004),
    [sym_type_parens] = STATE(2705),
    [sym_type_list] = STATE(2705),
    [sym_type_tuple] = STATE(2705),
    [sym__type_promotable_literal] = STATE(2705),
    [sym__type_promoted_literal] = STATE(2705),
    [sym__type_literal] = STATE(2705),
    [sym_type_name] = STATE(2770),
    [sym_type_star] = STATE(2705),
    [sym_type_unboxed_tuple] = STATE(2705),
    [sym_type_unboxed_sum] = STATE(2705),
    [sym__atype] = STATE(2705),
    [sym_type_apply] = STATE(9045),
    [sym__btype] = STATE(9045),
    [sym_type_infix] = STATE(13986),
    [sym__type_infix] = STATE(13589),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(15029),
    [sym__type_context] = STATE(15029),
    [sym__type_fun] = STATE(15029),
    [sym__type] = STATE(15029),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2705),
    [sym_quasiquote] = STATE(2705),
    [sym__varid] = ACTIONS(6206),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [sym__conid] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6224),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
  },
  [2595] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2547),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16082),
    [sym_type_parens] = STATE(2547),
    [sym_type_list] = STATE(2547),
    [sym_type_tuple] = STATE(2547),
    [sym__type_promotable_literal] = STATE(2547),
    [sym__type_promoted_literal] = STATE(2547),
    [sym__type_literal] = STATE(2547),
    [sym_type_name] = STATE(2876),
    [sym_type_star] = STATE(2547),
    [sym_type_unboxed_tuple] = STATE(2547),
    [sym_type_unboxed_sum] = STATE(2547),
    [sym__atype] = STATE(2547),
    [sym_type_apply] = STATE(8875),
    [sym__btype] = STATE(8875),
    [sym_type_infix] = STATE(14686),
    [sym__type_infix] = STATE(14421),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(20976),
    [sym__type_context] = STATE(20976),
    [sym__type_fun] = STATE(20976),
    [sym__type] = STATE(20976),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2547),
    [sym_quasiquote] = STATE(2547),
    [sym__varid] = ACTIONS(8303),
    [sym_float] = ACTIONS(8305),
    [sym_char] = ACTIONS(8305),
    [sym_string] = ACTIONS(8305),
    [sym__integer_literal] = ACTIONS(8307),
    [sym__binary_literal] = ACTIONS(8309),
    [sym__octal_literal] = ACTIONS(8309),
    [sym__hex_literal] = ACTIONS(8309),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8311),
    [sym__conid] = ACTIONS(8315),
    [anon_sym_LBRACK] = ACTIONS(8317),
    [anon_sym_SQUOTE] = ACTIONS(8319),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8321),
    [anon_sym_u2605] = ACTIONS(8321),
    [anon_sym_u27e6] = ACTIONS(8323),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8325),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8327),
  },
  [2596] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2596),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym_type_parens] = STATE(2596),
    [sym_type_list] = STATE(2596),
    [sym_type_tuple] = STATE(2596),
    [sym__type_promotable_literal] = STATE(2596),
    [sym__type_promoted_literal] = STATE(2596),
    [sym__type_literal] = STATE(2596),
    [sym_type_name] = STATE(2596),
    [sym_type_star] = STATE(2596),
    [sym_type_unboxed_tuple] = STATE(2596),
    [sym_type_unboxed_sum] = STATE(2596),
    [sym__atype] = STATE(2596),
    [sym_type_invisible] = STATE(2596),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2596),
    [sym_quasiquote] = STATE(2596),
    [aux_sym_type_apply_repeat1] = STATE(2596),
    [sym__varid] = ACTIONS(10088),
    [sym_float] = ACTIONS(10091),
    [sym_char] = ACTIONS(10091),
    [sym_string] = ACTIONS(10091),
    [sym__integer_literal] = ACTIONS(10094),
    [sym__binary_literal] = ACTIONS(10097),
    [sym__octal_literal] = ACTIONS(10097),
    [sym__hex_literal] = ACTIONS(10097),
    [anon_sym_LPAREN_POUND] = ACTIONS(10100),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10100),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10103),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10109),
    [anon_sym_SQUOTE] = ACTIONS(10112),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(10115),
    [anon_sym_u2605] = ACTIONS(10115),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(10121),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(10124),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10127),
    [sym__unboxed_close] = ACTIONS(5496),
  },
  [2597] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_u2237] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5542),
    [sym_quasiquote_start] = ACTIONS(5581),
    [sym__unboxed_close] = ACTIONS(5542),
  },
  [2598] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2628),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym_type_parens] = STATE(2628),
    [sym_type_list] = STATE(2628),
    [sym_type_tuple] = STATE(2628),
    [sym__type_promotable_literal] = STATE(2628),
    [sym__type_promoted_literal] = STATE(2628),
    [sym__type_literal] = STATE(2628),
    [sym_type_name] = STATE(2628),
    [sym_type_star] = STATE(2628),
    [sym_type_unboxed_tuple] = STATE(2628),
    [sym_type_unboxed_sum] = STATE(2628),
    [sym__atype] = STATE(2628),
    [sym_type_invisible] = STATE(2628),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2628),
    [sym_quasiquote] = STATE(2628),
    [aux_sym_type_apply_repeat1] = STATE(2628),
    [sym__varid] = ACTIONS(8548),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8550),
    [sym_char] = ACTIONS(8550),
    [sym_string] = ACTIONS(8550),
    [sym__integer_literal] = ACTIONS(8552),
    [sym__binary_literal] = ACTIONS(8554),
    [sym__octal_literal] = ACTIONS(8554),
    [sym__hex_literal] = ACTIONS(8554),
    [anon_sym_LPAREN_POUND] = ACTIONS(8556),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8556),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10130),
    [anon_sym_LBRACK] = ACTIONS(8564),
    [anon_sym_SQUOTE] = ACTIONS(10133),
    [anon_sym_STAR] = ACTIONS(8568),
    [anon_sym_u2605] = ACTIONS(8568),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(8570),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym_where] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8572),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8574),
  },
  [2599] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2547),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16082),
    [sym_type_parens] = STATE(2547),
    [sym_type_list] = STATE(2547),
    [sym_type_tuple] = STATE(2547),
    [sym__type_promotable_literal] = STATE(2547),
    [sym__type_promoted_literal] = STATE(2547),
    [sym__type_literal] = STATE(2547),
    [sym_type_name] = STATE(2876),
    [sym_type_star] = STATE(2547),
    [sym_type_unboxed_tuple] = STATE(2547),
    [sym_type_unboxed_sum] = STATE(2547),
    [sym__atype] = STATE(2547),
    [sym_type_apply] = STATE(8875),
    [sym__btype] = STATE(8875),
    [sym_type_infix] = STATE(14686),
    [sym__type_infix] = STATE(14421),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(21064),
    [sym__type_context] = STATE(21064),
    [sym__type_fun] = STATE(21064),
    [sym__type] = STATE(21064),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2547),
    [sym_quasiquote] = STATE(2547),
    [sym__varid] = ACTIONS(8303),
    [sym_float] = ACTIONS(8305),
    [sym_char] = ACTIONS(8305),
    [sym_string] = ACTIONS(8305),
    [sym__integer_literal] = ACTIONS(8307),
    [sym__binary_literal] = ACTIONS(8309),
    [sym__octal_literal] = ACTIONS(8309),
    [sym__hex_literal] = ACTIONS(8309),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8311),
    [sym__conid] = ACTIONS(8315),
    [anon_sym_LBRACK] = ACTIONS(8317),
    [anon_sym_SQUOTE] = ACTIONS(8319),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8321),
    [anon_sym_u2605] = ACTIONS(8321),
    [anon_sym_u27e6] = ACTIONS(8323),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8325),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8327),
  },
  [2600] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2705),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16004),
    [sym_type_parens] = STATE(2705),
    [sym_type_list] = STATE(2705),
    [sym_type_tuple] = STATE(2705),
    [sym__type_promotable_literal] = STATE(2705),
    [sym__type_promoted_literal] = STATE(2705),
    [sym__type_literal] = STATE(2705),
    [sym_type_name] = STATE(2770),
    [sym_type_star] = STATE(2705),
    [sym_type_unboxed_tuple] = STATE(2705),
    [sym_type_unboxed_sum] = STATE(2705),
    [sym__atype] = STATE(2705),
    [sym_type_apply] = STATE(9045),
    [sym__btype] = STATE(9045),
    [sym_type_infix] = STATE(13986),
    [sym__type_infix] = STATE(13589),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(15040),
    [sym__type_context] = STATE(15040),
    [sym__type_fun] = STATE(15040),
    [sym__type] = STATE(15040),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2705),
    [sym_quasiquote] = STATE(2705),
    [sym__varid] = ACTIONS(6206),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [sym__conid] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6224),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
  },
  [2601] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2618),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym_type_parens] = STATE(2618),
    [sym_type_list] = STATE(2618),
    [sym_type_tuple] = STATE(2618),
    [sym__type_promotable_literal] = STATE(2618),
    [sym__type_promoted_literal] = STATE(2618),
    [sym__type_literal] = STATE(2618),
    [sym_type_name] = STATE(2618),
    [sym_type_star] = STATE(2618),
    [sym_type_unboxed_tuple] = STATE(2618),
    [sym_type_unboxed_sum] = STATE(2618),
    [sym__atype] = STATE(2618),
    [sym_type_invisible] = STATE(2618),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2618),
    [sym_quasiquote] = STATE(2618),
    [aux_sym_type_apply_repeat1] = STATE(2618),
    [ts_builtin_sym_end] = ACTIONS(5483),
    [sym__varid] = ACTIONS(7789),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(10141),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2602] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2544),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15690),
    [sym_type_parens] = STATE(2544),
    [sym_type_list] = STATE(2544),
    [sym_type_tuple] = STATE(2544),
    [sym__type_promotable_literal] = STATE(2544),
    [sym__type_promoted_literal] = STATE(2544),
    [sym__type_literal] = STATE(2544),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2544),
    [sym_type_unboxed_tuple] = STATE(2544),
    [sym_type_unboxed_sum] = STATE(2544),
    [sym__atype] = STATE(2544),
    [sym_type_apply] = STATE(8832),
    [sym__btype] = STATE(8832),
    [sym_type_infix] = STATE(13734),
    [sym__type_infix] = STATE(13357),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2602),
    [sym__type_quantifiers] = STATE(15729),
    [sym__type_context] = STATE(15729),
    [sym__type_fun] = STATE(15729),
    [sym__type] = STATE(15729),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2544),
    [sym_quasiquote] = STATE(2544),
    [sym__varid] = ACTIONS(8788),
    [sym_float] = ACTIONS(8790),
    [sym_char] = ACTIONS(8790),
    [sym_string] = ACTIONS(8790),
    [sym__integer_literal] = ACTIONS(8792),
    [sym__binary_literal] = ACTIONS(8794),
    [sym__octal_literal] = ACTIONS(8794),
    [sym__hex_literal] = ACTIONS(8794),
    [anon_sym_LPAREN_POUND] = ACTIONS(8796),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8796),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8798),
    [sym__conid] = ACTIONS(8802),
    [anon_sym_LBRACK] = ACTIONS(8804),
    [anon_sym_SQUOTE] = ACTIONS(8806),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8808),
    [anon_sym_u2605] = ACTIONS(8808),
    [anon_sym_u27e6] = ACTIONS(8810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8812),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8814),
  },
  [2603] = {
    [sym_integer] = STATE(7589),
    [sym__literal] = STATE(7589),
    [sym__unboxed_open] = STATE(2099),
    [sym_constructor] = STATE(7250),
    [sym_con_unit] = STATE(7589),
    [sym_con_list] = STATE(7589),
    [sym_con_tuple] = STATE(7589),
    [sym_qualified_type] = STATE(7626),
    [sym_tycon_arrow] = STATE(7626),
    [sym_type_literal] = STATE(2547),
    [sym__promoted_tycon] = STATE(7626),
    [sym_type_variable] = STATE(7626),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16082),
    [sym_type_parens] = STATE(2547),
    [sym_type_list] = STATE(2547),
    [sym_type_tuple] = STATE(2547),
    [sym__type_promotable_literal] = STATE(2547),
    [sym__type_promoted_literal] = STATE(2547),
    [sym__type_literal] = STATE(2547),
    [sym_type_name] = STATE(2876),
    [sym_type_star] = STATE(2547),
    [sym_type_unboxed_tuple] = STATE(2547),
    [sym_type_unboxed_sum] = STATE(2547),
    [sym__atype] = STATE(2547),
    [sym_type_apply] = STATE(8875),
    [sym__btype] = STATE(8875),
    [sym_type_infix] = STATE(14686),
    [sym__type_infix] = STATE(14421),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(21005),
    [sym__type_context] = STATE(21005),
    [sym__type_fun] = STATE(21005),
    [sym__type] = STATE(21005),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16496),
    [sym_splice] = STATE(2547),
    [sym_quasiquote] = STATE(2547),
    [sym__varid] = ACTIONS(8303),
    [sym_float] = ACTIONS(8305),
    [sym_char] = ACTIONS(8305),
    [sym_string] = ACTIONS(8305),
    [sym__integer_literal] = ACTIONS(8307),
    [sym__binary_literal] = ACTIONS(8309),
    [sym__octal_literal] = ACTIONS(8309),
    [sym__hex_literal] = ACTIONS(8309),
    [anon_sym_LPAREN_POUND] = ACTIONS(6112),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6112),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8311),
    [sym__conid] = ACTIONS(8315),
    [anon_sym_LBRACK] = ACTIONS(8317),
    [anon_sym_SQUOTE] = ACTIONS(8319),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8321),
    [anon_sym_u2605] = ACTIONS(8321),
    [anon_sym_u27e6] = ACTIONS(8323),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8325),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8327),
  },
  [2604] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2612),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym_type_parens] = STATE(2612),
    [sym_type_list] = STATE(2612),
    [sym_type_tuple] = STATE(2612),
    [sym__type_promotable_literal] = STATE(2612),
    [sym__type_promoted_literal] = STATE(2612),
    [sym__type_literal] = STATE(2612),
    [sym_type_name] = STATE(2612),
    [sym_type_star] = STATE(2612),
    [sym_type_unboxed_tuple] = STATE(2612),
    [sym_type_unboxed_sum] = STATE(2612),
    [sym__atype] = STATE(2612),
    [sym_type_invisible] = STATE(2612),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2612),
    [sym_quasiquote] = STATE(2612),
    [aux_sym_type_apply_repeat1] = STATE(2612),
    [sym__varid] = ACTIONS(10146),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10148),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10150),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(10153),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_AT] = ACTIONS(10156),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(7441),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2605] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2627),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15735),
    [sym_type_parens] = STATE(2627),
    [sym_type_list] = STATE(2627),
    [sym_type_tuple] = STATE(2627),
    [sym__type_promotable_literal] = STATE(2627),
    [sym__type_promoted_literal] = STATE(2627),
    [sym__type_literal] = STATE(2627),
    [sym_type_name] = STATE(2780),
    [sym_type_star] = STATE(2627),
    [sym_type_unboxed_tuple] = STATE(2627),
    [sym_type_unboxed_sum] = STATE(2627),
    [sym__atype] = STATE(2627),
    [sym_type_apply] = STATE(9005),
    [sym__btype] = STATE(9005),
    [sym_type_infix] = STATE(13888),
    [sym__type_infix] = STATE(13584),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(17803),
    [sym__type_context] = STATE(17803),
    [sym__type_fun] = STATE(17803),
    [sym__type] = STATE(17803),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2627),
    [sym_quasiquote] = STATE(2627),
    [sym__varid] = ACTIONS(8456),
    [sym_float] = ACTIONS(8458),
    [sym_char] = ACTIONS(8458),
    [sym_string] = ACTIONS(8458),
    [sym__integer_literal] = ACTIONS(8460),
    [sym__binary_literal] = ACTIONS(8462),
    [sym__octal_literal] = ACTIONS(8462),
    [sym__hex_literal] = ACTIONS(8462),
    [anon_sym_LPAREN_POUND] = ACTIONS(8464),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8464),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8466),
    [sym__conid] = ACTIONS(8470),
    [anon_sym_LBRACK] = ACTIONS(8472),
    [anon_sym_SQUOTE] = ACTIONS(8474),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8476),
    [anon_sym_u2605] = ACTIONS(8476),
    [anon_sym_u27e6] = ACTIONS(8478),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8480),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8482),
  },
  [2606] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2544),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15690),
    [sym_type_parens] = STATE(2544),
    [sym_type_list] = STATE(2544),
    [sym_type_tuple] = STATE(2544),
    [sym__type_promotable_literal] = STATE(2544),
    [sym__type_promoted_literal] = STATE(2544),
    [sym__type_literal] = STATE(2544),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2544),
    [sym_type_unboxed_tuple] = STATE(2544),
    [sym_type_unboxed_sum] = STATE(2544),
    [sym__atype] = STATE(2544),
    [sym_type_apply] = STATE(8832),
    [sym__btype] = STATE(8832),
    [sym_type_infix] = STATE(13734),
    [sym__type_infix] = STATE(13357),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2602),
    [sym__type_quantifiers] = STATE(15848),
    [sym__type_context] = STATE(15848),
    [sym__type_fun] = STATE(15848),
    [sym__type] = STATE(15848),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2544),
    [sym_quasiquote] = STATE(2544),
    [sym__varid] = ACTIONS(8788),
    [sym_float] = ACTIONS(8790),
    [sym_char] = ACTIONS(8790),
    [sym_string] = ACTIONS(8790),
    [sym__integer_literal] = ACTIONS(8792),
    [sym__binary_literal] = ACTIONS(8794),
    [sym__octal_literal] = ACTIONS(8794),
    [sym__hex_literal] = ACTIONS(8794),
    [anon_sym_LPAREN_POUND] = ACTIONS(8796),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8796),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8798),
    [sym__conid] = ACTIONS(8802),
    [anon_sym_LBRACK] = ACTIONS(8804),
    [anon_sym_SQUOTE] = ACTIONS(8806),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8808),
    [anon_sym_u2605] = ACTIONS(8808),
    [anon_sym_u27e6] = ACTIONS(8810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8812),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8814),
  },
  [2607] = {
    [sym_integer] = STATE(7753),
    [sym__literal] = STATE(7753),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7510),
    [sym_con_unit] = STATE(7753),
    [sym_con_list] = STATE(7753),
    [sym_con_tuple] = STATE(7753),
    [sym_qualified_type] = STATE(7791),
    [sym_tycon_arrow] = STATE(7791),
    [sym_type_literal] = STATE(2544),
    [sym__promoted_tycon] = STATE(7791),
    [sym_type_variable] = STATE(7791),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15690),
    [sym_type_parens] = STATE(2544),
    [sym_type_list] = STATE(2544),
    [sym_type_tuple] = STATE(2544),
    [sym__type_promotable_literal] = STATE(2544),
    [sym__type_promoted_literal] = STATE(2544),
    [sym__type_literal] = STATE(2544),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2544),
    [sym_type_unboxed_tuple] = STATE(2544),
    [sym_type_unboxed_sum] = STATE(2544),
    [sym__atype] = STATE(2544),
    [sym_type_apply] = STATE(8832),
    [sym__btype] = STATE(8832),
    [sym_type_infix] = STATE(13734),
    [sym__type_infix] = STATE(13357),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2602),
    [sym__type_quantifiers] = STATE(15851),
    [sym__type_context] = STATE(15851),
    [sym__type_fun] = STATE(15851),
    [sym__type] = STATE(15851),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16491),
    [sym_splice] = STATE(2544),
    [sym_quasiquote] = STATE(2544),
    [sym__varid] = ACTIONS(8788),
    [sym_float] = ACTIONS(8790),
    [sym_char] = ACTIONS(8790),
    [sym_string] = ACTIONS(8790),
    [sym__integer_literal] = ACTIONS(8792),
    [sym__binary_literal] = ACTIONS(8794),
    [sym__octal_literal] = ACTIONS(8794),
    [sym__hex_literal] = ACTIONS(8794),
    [anon_sym_LPAREN_POUND] = ACTIONS(8796),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8796),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8798),
    [sym__conid] = ACTIONS(8802),
    [anon_sym_LBRACK] = ACTIONS(8804),
    [anon_sym_SQUOTE] = ACTIONS(8806),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8808),
    [anon_sym_u2605] = ACTIONS(8808),
    [anon_sym_u27e6] = ACTIONS(8810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8812),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8814),
  },
  [2608] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2705),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16004),
    [sym_type_parens] = STATE(2705),
    [sym_type_list] = STATE(2705),
    [sym_type_tuple] = STATE(2705),
    [sym__type_promotable_literal] = STATE(2705),
    [sym__type_promoted_literal] = STATE(2705),
    [sym__type_literal] = STATE(2705),
    [sym_type_name] = STATE(2770),
    [sym_type_star] = STATE(2705),
    [sym_type_unboxed_tuple] = STATE(2705),
    [sym_type_unboxed_sum] = STATE(2705),
    [sym__atype] = STATE(2705),
    [sym_type_apply] = STATE(9045),
    [sym__btype] = STATE(9045),
    [sym_type_infix] = STATE(13986),
    [sym__type_infix] = STATE(13589),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(15031),
    [sym__type_context] = STATE(15031),
    [sym__type_fun] = STATE(15031),
    [sym__type] = STATE(15031),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2705),
    [sym_quasiquote] = STATE(2705),
    [sym__varid] = ACTIONS(6206),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [sym__conid] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6224),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
  },
  [2609] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2624),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym_type_parens] = STATE(2624),
    [sym_type_list] = STATE(2624),
    [sym_type_tuple] = STATE(2624),
    [sym__type_promotable_literal] = STATE(2624),
    [sym__type_promoted_literal] = STATE(2624),
    [sym__type_literal] = STATE(2624),
    [sym_type_name] = STATE(2624),
    [sym_type_star] = STATE(2624),
    [sym_type_unboxed_tuple] = STATE(2624),
    [sym_type_unboxed_sum] = STATE(2624),
    [sym__atype] = STATE(2624),
    [sym_type_invisible] = STATE(2624),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2624),
    [sym_quasiquote] = STATE(2624),
    [aux_sym_type_apply_repeat1] = STATE(2624),
    [sym__varid] = ACTIONS(8626),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8628),
    [sym_char] = ACTIONS(8628),
    [sym_string] = ACTIONS(8628),
    [sym__integer_literal] = ACTIONS(8630),
    [sym__binary_literal] = ACTIONS(8632),
    [sym__octal_literal] = ACTIONS(8632),
    [sym__hex_literal] = ACTIONS(8632),
    [anon_sym_LPAREN_POUND] = ACTIONS(8634),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8634),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10158),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10160),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_SQUOTE] = ACTIONS(10163),
    [anon_sym_STAR] = ACTIONS(8646),
    [anon_sym_u2605] = ACTIONS(8646),
    [anon_sym_AT] = ACTIONS(10166),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(8648),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8650),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8652),
  },
  [2610] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2610),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym_type_parens] = STATE(2610),
    [sym_type_list] = STATE(2610),
    [sym_type_tuple] = STATE(2610),
    [sym__type_promotable_literal] = STATE(2610),
    [sym__type_promoted_literal] = STATE(2610),
    [sym__type_literal] = STATE(2610),
    [sym_type_name] = STATE(2610),
    [sym_type_star] = STATE(2610),
    [sym_type_unboxed_tuple] = STATE(2610),
    [sym_type_unboxed_sum] = STATE(2610),
    [sym__atype] = STATE(2610),
    [sym_type_invisible] = STATE(2610),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2610),
    [sym_quasiquote] = STATE(2610),
    [aux_sym_type_apply_repeat1] = STATE(2610),
    [sym__varid] = ACTIONS(10168),
    [sym_float] = ACTIONS(10171),
    [sym_char] = ACTIONS(10171),
    [sym_string] = ACTIONS(10171),
    [sym__integer_literal] = ACTIONS(10174),
    [sym__binary_literal] = ACTIONS(10177),
    [sym__octal_literal] = ACTIONS(10177),
    [sym__hex_literal] = ACTIONS(10177),
    [anon_sym_LPAREN_POUND] = ACTIONS(10180),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10180),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10183),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10186),
    [anon_sym_LBRACK] = ACTIONS(10189),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_SQUOTE] = ACTIONS(10192),
    [anon_sym_STAR] = ACTIONS(10195),
    [anon_sym_u2605] = ACTIONS(10195),
    [anon_sym_AT] = ACTIONS(10198),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_DOT_DOT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(10201),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(10204),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(10207),
  },
  [2611] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2217),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15716),
    [sym_type_parens] = STATE(2217),
    [sym_type_list] = STATE(2217),
    [sym_type_tuple] = STATE(2217),
    [sym__type_promotable_literal] = STATE(2217),
    [sym__type_promoted_literal] = STATE(2217),
    [sym__type_literal] = STATE(2217),
    [sym_type_name] = STATE(2309),
    [sym_type_star] = STATE(2217),
    [sym_type_unboxed_tuple] = STATE(2217),
    [sym_type_unboxed_sum] = STATE(2217),
    [sym__atype] = STATE(2217),
    [sym_type_apply] = STATE(8093),
    [sym__btype] = STATE(8093),
    [sym_type_infix] = STATE(10692),
    [sym__type_infix] = STATE(10635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2611),
    [sym__type_quantifiers] = STATE(11276),
    [sym__type_context] = STATE(11276),
    [sym__type_fun] = STATE(11276),
    [sym__type] = STATE(11276),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2217),
    [sym_quasiquote] = STATE(2217),
    [sym__varid] = ACTIONS(8115),
    [sym_float] = ACTIONS(6120),
    [sym_char] = ACTIONS(6120),
    [sym_string] = ACTIONS(6120),
    [sym__integer_literal] = ACTIONS(6122),
    [sym__binary_literal] = ACTIONS(6124),
    [sym__octal_literal] = ACTIONS(6124),
    [sym__hex_literal] = ACTIONS(6124),
    [anon_sym_LPAREN_POUND] = ACTIONS(6126),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6126),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8117),
    [sym__conid] = ACTIONS(8121),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_SQUOTE] = ACTIONS(8123),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_u2605] = ACTIONS(6138),
    [anon_sym_u27e6] = ACTIONS(6142),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6144),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6146),
  },
  [2612] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2674),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym_type_parens] = STATE(2674),
    [sym_type_list] = STATE(2674),
    [sym_type_tuple] = STATE(2674),
    [sym__type_promotable_literal] = STATE(2674),
    [sym__type_promoted_literal] = STATE(2674),
    [sym__type_literal] = STATE(2674),
    [sym_type_name] = STATE(2674),
    [sym_type_star] = STATE(2674),
    [sym_type_unboxed_tuple] = STATE(2674),
    [sym_type_unboxed_sum] = STATE(2674),
    [sym__atype] = STATE(2674),
    [sym_type_invisible] = STATE(2674),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2674),
    [sym_quasiquote] = STATE(2674),
    [aux_sym_type_apply_repeat1] = STATE(2674),
    [sym__varid] = ACTIONS(10146),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10148),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10210),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(10213),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_AT] = ACTIONS(10156),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(7441),
    [sym__unboxed_close] = ACTIONS(5451),
  },
  [2613] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2217),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15716),
    [sym_type_parens] = STATE(2217),
    [sym_type_list] = STATE(2217),
    [sym_type_tuple] = STATE(2217),
    [sym__type_promotable_literal] = STATE(2217),
    [sym__type_promoted_literal] = STATE(2217),
    [sym__type_literal] = STATE(2217),
    [sym_type_name] = STATE(2309),
    [sym_type_star] = STATE(2217),
    [sym_type_unboxed_tuple] = STATE(2217),
    [sym_type_unboxed_sum] = STATE(2217),
    [sym__atype] = STATE(2217),
    [sym_type_apply] = STATE(8093),
    [sym__btype] = STATE(8093),
    [sym_type_infix] = STATE(10692),
    [sym__type_infix] = STATE(10635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2611),
    [sym__type_quantifiers] = STATE(11273),
    [sym__type_context] = STATE(11273),
    [sym__type_fun] = STATE(11273),
    [sym__type] = STATE(11273),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2217),
    [sym_quasiquote] = STATE(2217),
    [sym__varid] = ACTIONS(8115),
    [sym_float] = ACTIONS(6120),
    [sym_char] = ACTIONS(6120),
    [sym_string] = ACTIONS(6120),
    [sym__integer_literal] = ACTIONS(6122),
    [sym__binary_literal] = ACTIONS(6124),
    [sym__octal_literal] = ACTIONS(6124),
    [sym__hex_literal] = ACTIONS(6124),
    [anon_sym_LPAREN_POUND] = ACTIONS(6126),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6126),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8117),
    [sym__conid] = ACTIONS(8121),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_SQUOTE] = ACTIONS(8123),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_u2605] = ACTIONS(6138),
    [anon_sym_u27e6] = ACTIONS(6142),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6144),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6146),
  },
  [2614] = {
    [sym_integer] = STATE(5908),
    [sym__literal] = STATE(5908),
    [sym__unboxed_open] = STATE(2208),
    [sym_constructor] = STATE(5781),
    [sym_con_unit] = STATE(5908),
    [sym_con_list] = STATE(5908),
    [sym_con_tuple] = STATE(5908),
    [sym_qualified_type] = STATE(5949),
    [sym_tycon_arrow] = STATE(5949),
    [sym_type_literal] = STATE(2217),
    [sym__promoted_tycon] = STATE(5949),
    [sym_type_variable] = STATE(5949),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15716),
    [sym_type_parens] = STATE(2217),
    [sym_type_list] = STATE(2217),
    [sym_type_tuple] = STATE(2217),
    [sym__type_promotable_literal] = STATE(2217),
    [sym__type_promoted_literal] = STATE(2217),
    [sym__type_literal] = STATE(2217),
    [sym_type_name] = STATE(2309),
    [sym_type_star] = STATE(2217),
    [sym_type_unboxed_tuple] = STATE(2217),
    [sym_type_unboxed_sum] = STATE(2217),
    [sym__atype] = STATE(2217),
    [sym_type_apply] = STATE(8093),
    [sym__btype] = STATE(8093),
    [sym_type_infix] = STATE(10692),
    [sym__type_infix] = STATE(10635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2611),
    [sym__type_quantifiers] = STATE(11283),
    [sym__type_context] = STATE(11283),
    [sym__type_fun] = STATE(11283),
    [sym__type] = STATE(11283),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17028),
    [sym_splice] = STATE(2217),
    [sym_quasiquote] = STATE(2217),
    [sym__varid] = ACTIONS(8115),
    [sym_float] = ACTIONS(6120),
    [sym_char] = ACTIONS(6120),
    [sym_string] = ACTIONS(6120),
    [sym__integer_literal] = ACTIONS(6122),
    [sym__binary_literal] = ACTIONS(6124),
    [sym__octal_literal] = ACTIONS(6124),
    [sym__hex_literal] = ACTIONS(6124),
    [anon_sym_LPAREN_POUND] = ACTIONS(6126),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6126),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8117),
    [sym__conid] = ACTIONS(8121),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_SQUOTE] = ACTIONS(8123),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_u2605] = ACTIONS(6138),
    [anon_sym_u27e6] = ACTIONS(6142),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6144),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6146),
  },
  [2615] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(16944),
    [sym__type_context] = STATE(16944),
    [sym__type_fun] = STATE(16944),
    [sym__type] = STATE(16944),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2616] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(16939),
    [sym__type_context] = STATE(16939),
    [sym__type_fun] = STATE(16939),
    [sym__type] = STATE(16939),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2617] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2589),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15746),
    [sym_type_parens] = STATE(2589),
    [sym_type_list] = STATE(2589),
    [sym_type_tuple] = STATE(2589),
    [sym__type_promotable_literal] = STATE(2589),
    [sym__type_promoted_literal] = STATE(2589),
    [sym__type_literal] = STATE(2589),
    [sym_type_name] = STATE(2760),
    [sym_type_star] = STATE(2589),
    [sym_type_unboxed_tuple] = STATE(2589),
    [sym_type_unboxed_sum] = STATE(2589),
    [sym__atype] = STATE(2589),
    [sym_type_apply] = STATE(9077),
    [sym__btype] = STATE(9077),
    [sym_type_infix] = STATE(14083),
    [sym__type_infix] = STATE(13579),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2617),
    [sym__type_quantifiers] = STATE(17089),
    [sym__type_context] = STATE(17089),
    [sym__type_fun] = STATE(17089),
    [sym__type] = STATE(17089),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2589),
    [sym_quasiquote] = STATE(2589),
    [sym__varid] = ACTIONS(8548),
    [sym_float] = ACTIONS(8550),
    [sym_char] = ACTIONS(8550),
    [sym_string] = ACTIONS(8550),
    [sym__integer_literal] = ACTIONS(8552),
    [sym__binary_literal] = ACTIONS(8554),
    [sym__octal_literal] = ACTIONS(8554),
    [sym__hex_literal] = ACTIONS(8554),
    [anon_sym_LPAREN_POUND] = ACTIONS(8556),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8556),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [sym__conid] = ACTIONS(8562),
    [anon_sym_LBRACK] = ACTIONS(8564),
    [anon_sym_SQUOTE] = ACTIONS(8566),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8568),
    [anon_sym_u2605] = ACTIONS(8568),
    [anon_sym_u27e6] = ACTIONS(8570),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8572),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8574),
  },
  [2618] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2675),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym_type_parens] = STATE(2675),
    [sym_type_list] = STATE(2675),
    [sym_type_tuple] = STATE(2675),
    [sym__type_promotable_literal] = STATE(2675),
    [sym__type_promoted_literal] = STATE(2675),
    [sym__type_literal] = STATE(2675),
    [sym_type_name] = STATE(2675),
    [sym_type_star] = STATE(2675),
    [sym_type_unboxed_tuple] = STATE(2675),
    [sym_type_unboxed_sum] = STATE(2675),
    [sym__atype] = STATE(2675),
    [sym_type_invisible] = STATE(2675),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2675),
    [sym_quasiquote] = STATE(2675),
    [aux_sym_type_apply_repeat1] = STATE(2675),
    [ts_builtin_sym_end] = ACTIONS(5451),
    [sym__varid] = ACTIONS(7789),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10216),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(10219),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2619] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(16842),
    [sym__type_context] = STATE(16842),
    [sym__type_fun] = STATE(16842),
    [sym__type] = STATE(16842),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2620] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2589),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15746),
    [sym_type_parens] = STATE(2589),
    [sym_type_list] = STATE(2589),
    [sym_type_tuple] = STATE(2589),
    [sym__type_promotable_literal] = STATE(2589),
    [sym__type_promoted_literal] = STATE(2589),
    [sym__type_literal] = STATE(2589),
    [sym_type_name] = STATE(2760),
    [sym_type_star] = STATE(2589),
    [sym_type_unboxed_tuple] = STATE(2589),
    [sym_type_unboxed_sum] = STATE(2589),
    [sym__atype] = STATE(2589),
    [sym_type_apply] = STATE(9077),
    [sym__btype] = STATE(9077),
    [sym_type_infix] = STATE(14083),
    [sym__type_infix] = STATE(13579),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2617),
    [sym__type_quantifiers] = STATE(17173),
    [sym__type_context] = STATE(17173),
    [sym__type_fun] = STATE(17173),
    [sym__type] = STATE(17173),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2589),
    [sym_quasiquote] = STATE(2589),
    [sym__varid] = ACTIONS(8548),
    [sym_float] = ACTIONS(8550),
    [sym_char] = ACTIONS(8550),
    [sym_string] = ACTIONS(8550),
    [sym__integer_literal] = ACTIONS(8552),
    [sym__binary_literal] = ACTIONS(8554),
    [sym__octal_literal] = ACTIONS(8554),
    [sym__hex_literal] = ACTIONS(8554),
    [anon_sym_LPAREN_POUND] = ACTIONS(8556),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8556),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [sym__conid] = ACTIONS(8562),
    [anon_sym_LBRACK] = ACTIONS(8564),
    [anon_sym_SQUOTE] = ACTIONS(8566),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8568),
    [anon_sym_u2605] = ACTIONS(8568),
    [anon_sym_u27e6] = ACTIONS(8570),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8572),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8574),
  },
  [2621] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2589),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15746),
    [sym_type_parens] = STATE(2589),
    [sym_type_list] = STATE(2589),
    [sym_type_tuple] = STATE(2589),
    [sym__type_promotable_literal] = STATE(2589),
    [sym__type_promoted_literal] = STATE(2589),
    [sym__type_literal] = STATE(2589),
    [sym_type_name] = STATE(2760),
    [sym_type_star] = STATE(2589),
    [sym_type_unboxed_tuple] = STATE(2589),
    [sym_type_unboxed_sum] = STATE(2589),
    [sym__atype] = STATE(2589),
    [sym_type_apply] = STATE(9077),
    [sym__btype] = STATE(9077),
    [sym_type_infix] = STATE(14083),
    [sym__type_infix] = STATE(13579),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2617),
    [sym__type_quantifiers] = STATE(17176),
    [sym__type_context] = STATE(17176),
    [sym__type_fun] = STATE(17176),
    [sym__type] = STATE(17176),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2589),
    [sym_quasiquote] = STATE(2589),
    [sym__varid] = ACTIONS(8548),
    [sym_float] = ACTIONS(8550),
    [sym_char] = ACTIONS(8550),
    [sym_string] = ACTIONS(8550),
    [sym__integer_literal] = ACTIONS(8552),
    [sym__binary_literal] = ACTIONS(8554),
    [sym__octal_literal] = ACTIONS(8554),
    [sym__hex_literal] = ACTIONS(8554),
    [anon_sym_LPAREN_POUND] = ACTIONS(8556),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8556),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [sym__conid] = ACTIONS(8562),
    [anon_sym_LBRACK] = ACTIONS(8564),
    [anon_sym_SQUOTE] = ACTIONS(8566),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8568),
    [anon_sym_u2605] = ACTIONS(8568),
    [anon_sym_u27e6] = ACTIONS(8570),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8572),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8574),
  },
  [2622] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2261),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15792),
    [sym_type_parens] = STATE(2261),
    [sym_type_list] = STATE(2261),
    [sym_type_tuple] = STATE(2261),
    [sym__type_promotable_literal] = STATE(2261),
    [sym__type_promoted_literal] = STATE(2261),
    [sym__type_literal] = STATE(2261),
    [sym_type_name] = STATE(2406),
    [sym_type_star] = STATE(2261),
    [sym_type_unboxed_tuple] = STATE(2261),
    [sym_type_unboxed_sum] = STATE(2261),
    [sym__atype] = STATE(2261),
    [sym_type_apply] = STATE(8212),
    [sym__btype] = STATE(8212),
    [sym_type_infix] = STATE(10823),
    [sym__type_infix] = STATE(10721),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2622),
    [sym__type_quantifiers] = STATE(12060),
    [sym__type_context] = STATE(12060),
    [sym__type_fun] = STATE(12060),
    [sym__type] = STATE(12060),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2261),
    [sym_quasiquote] = STATE(2261),
    [sym__varid] = ACTIONS(8345),
    [sym_float] = ACTIONS(6440),
    [sym_char] = ACTIONS(6440),
    [sym_string] = ACTIONS(6440),
    [sym__integer_literal] = ACTIONS(6442),
    [sym__binary_literal] = ACTIONS(6444),
    [sym__octal_literal] = ACTIONS(6444),
    [sym__hex_literal] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND] = ACTIONS(6446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6446),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8347),
    [sym__conid] = ACTIONS(8351),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_SQUOTE] = ACTIONS(8353),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_u2605] = ACTIONS(6458),
    [anon_sym_u27e6] = ACTIONS(6462),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6464),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6466),
  },
  [2623] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2610),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym_type_parens] = STATE(2610),
    [sym_type_list] = STATE(2610),
    [sym_type_tuple] = STATE(2610),
    [sym__type_promotable_literal] = STATE(2610),
    [sym__type_promoted_literal] = STATE(2610),
    [sym__type_literal] = STATE(2610),
    [sym_type_name] = STATE(2610),
    [sym_type_star] = STATE(2610),
    [sym_type_unboxed_tuple] = STATE(2610),
    [sym_type_unboxed_sum] = STATE(2610),
    [sym__atype] = STATE(2610),
    [sym_type_invisible] = STATE(2610),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2610),
    [sym_quasiquote] = STATE(2610),
    [aux_sym_type_apply_repeat1] = STATE(2610),
    [sym__varid] = ACTIONS(10222),
    [sym_float] = ACTIONS(8458),
    [sym_char] = ACTIONS(8458),
    [sym_string] = ACTIONS(8458),
    [sym__integer_literal] = ACTIONS(8460),
    [sym__binary_literal] = ACTIONS(8462),
    [sym__octal_literal] = ACTIONS(8462),
    [sym__hex_literal] = ACTIONS(8462),
    [anon_sym_LPAREN_POUND] = ACTIONS(8464),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8464),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10224),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10226),
    [anon_sym_LBRACK] = ACTIONS(8472),
    [anon_sym_RBRACK] = ACTIONS(5451),
    [anon_sym_SQUOTE] = ACTIONS(10229),
    [anon_sym_STAR] = ACTIONS(8476),
    [anon_sym_u2605] = ACTIONS(8476),
    [anon_sym_AT] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(8478),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8480),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5451),
    [sym_quasiquote_start] = ACTIONS(8482),
  },
  [2624] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2652),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym_type_parens] = STATE(2652),
    [sym_type_list] = STATE(2652),
    [sym_type_tuple] = STATE(2652),
    [sym__type_promotable_literal] = STATE(2652),
    [sym__type_promoted_literal] = STATE(2652),
    [sym__type_literal] = STATE(2652),
    [sym_type_name] = STATE(2652),
    [sym_type_star] = STATE(2652),
    [sym_type_unboxed_tuple] = STATE(2652),
    [sym_type_unboxed_sum] = STATE(2652),
    [sym__atype] = STATE(2652),
    [sym_type_invisible] = STATE(2652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2652),
    [sym_quasiquote] = STATE(2652),
    [aux_sym_type_apply_repeat1] = STATE(2652),
    [sym__varid] = ACTIONS(8626),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(8628),
    [sym_char] = ACTIONS(8628),
    [sym_string] = ACTIONS(8628),
    [sym__integer_literal] = ACTIONS(8630),
    [sym__binary_literal] = ACTIONS(8632),
    [sym__octal_literal] = ACTIONS(8632),
    [sym__hex_literal] = ACTIONS(8632),
    [anon_sym_LPAREN_POUND] = ACTIONS(8634),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8634),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10158),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10234),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_SQUOTE] = ACTIONS(10237),
    [anon_sym_STAR] = ACTIONS(8646),
    [anon_sym_u2605] = ACTIONS(8646),
    [anon_sym_AT] = ACTIONS(10166),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(8648),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(8650),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8652),
  },
  [2625] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2261),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15792),
    [sym_type_parens] = STATE(2261),
    [sym_type_list] = STATE(2261),
    [sym_type_tuple] = STATE(2261),
    [sym__type_promotable_literal] = STATE(2261),
    [sym__type_promoted_literal] = STATE(2261),
    [sym__type_literal] = STATE(2261),
    [sym_type_name] = STATE(2406),
    [sym_type_star] = STATE(2261),
    [sym_type_unboxed_tuple] = STATE(2261),
    [sym_type_unboxed_sum] = STATE(2261),
    [sym__atype] = STATE(2261),
    [sym_type_apply] = STATE(8212),
    [sym__btype] = STATE(8212),
    [sym_type_infix] = STATE(10823),
    [sym__type_infix] = STATE(10721),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2622),
    [sym__type_quantifiers] = STATE(12066),
    [sym__type_context] = STATE(12066),
    [sym__type_fun] = STATE(12066),
    [sym__type] = STATE(12066),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2261),
    [sym_quasiquote] = STATE(2261),
    [sym__varid] = ACTIONS(8345),
    [sym_float] = ACTIONS(6440),
    [sym_char] = ACTIONS(6440),
    [sym_string] = ACTIONS(6440),
    [sym__integer_literal] = ACTIONS(6442),
    [sym__binary_literal] = ACTIONS(6444),
    [sym__octal_literal] = ACTIONS(6444),
    [sym__hex_literal] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND] = ACTIONS(6446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6446),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8347),
    [sym__conid] = ACTIONS(8351),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_SQUOTE] = ACTIONS(8353),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_u2605] = ACTIONS(6458),
    [anon_sym_u27e6] = ACTIONS(6462),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6464),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6466),
  },
  [2626] = {
    [sym_integer] = STATE(6336),
    [sym__literal] = STATE(6336),
    [sym__unboxed_open] = STATE(2105),
    [sym_constructor] = STATE(6283),
    [sym_con_unit] = STATE(6336),
    [sym_con_list] = STATE(6336),
    [sym_con_tuple] = STATE(6336),
    [sym_qualified_type] = STATE(6334),
    [sym_tycon_arrow] = STATE(6334),
    [sym_type_literal] = STATE(2261),
    [sym__promoted_tycon] = STATE(6334),
    [sym_type_variable] = STATE(6334),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15792),
    [sym_type_parens] = STATE(2261),
    [sym_type_list] = STATE(2261),
    [sym_type_tuple] = STATE(2261),
    [sym__type_promotable_literal] = STATE(2261),
    [sym__type_promoted_literal] = STATE(2261),
    [sym__type_literal] = STATE(2261),
    [sym_type_name] = STATE(2406),
    [sym_type_star] = STATE(2261),
    [sym_type_unboxed_tuple] = STATE(2261),
    [sym_type_unboxed_sum] = STATE(2261),
    [sym__atype] = STATE(2261),
    [sym_type_apply] = STATE(8212),
    [sym__btype] = STATE(8212),
    [sym_type_infix] = STATE(10823),
    [sym__type_infix] = STATE(10721),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2622),
    [sym__type_quantifiers] = STATE(12065),
    [sym__type_context] = STATE(12065),
    [sym__type_fun] = STATE(12065),
    [sym__type] = STATE(12065),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16697),
    [sym_splice] = STATE(2261),
    [sym_quasiquote] = STATE(2261),
    [sym__varid] = ACTIONS(8345),
    [sym_float] = ACTIONS(6440),
    [sym_char] = ACTIONS(6440),
    [sym_string] = ACTIONS(6440),
    [sym__integer_literal] = ACTIONS(6442),
    [sym__binary_literal] = ACTIONS(6444),
    [sym__octal_literal] = ACTIONS(6444),
    [sym__hex_literal] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND] = ACTIONS(6446),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6446),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8347),
    [sym__conid] = ACTIONS(8351),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_SQUOTE] = ACTIONS(8353),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6458),
    [anon_sym_u2605] = ACTIONS(6458),
    [anon_sym_u27e6] = ACTIONS(6462),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6464),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6466),
  },
  [2627] = {
    [sym_integer] = STATE(8189),
    [sym__literal] = STATE(8189),
    [sym__unboxed_open] = STATE(2117),
    [sym_constructor] = STATE(7613),
    [sym_con_unit] = STATE(8189),
    [sym_con_list] = STATE(8189),
    [sym_con_tuple] = STATE(8189),
    [sym_qualified_type] = STATE(8184),
    [sym_tycon_arrow] = STATE(8184),
    [sym_type_literal] = STATE(2623),
    [sym__promoted_tycon] = STATE(8184),
    [sym_type_variable] = STATE(8184),
    [sym_type_parens] = STATE(2623),
    [sym_type_list] = STATE(2623),
    [sym_type_tuple] = STATE(2623),
    [sym__type_promotable_literal] = STATE(2623),
    [sym__type_promoted_literal] = STATE(2623),
    [sym__type_literal] = STATE(2623),
    [sym_type_name] = STATE(2623),
    [sym_type_star] = STATE(2623),
    [sym_type_unboxed_tuple] = STATE(2623),
    [sym_type_unboxed_sum] = STATE(2623),
    [sym__atype] = STATE(2623),
    [sym_type_invisible] = STATE(2623),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16751),
    [sym_splice] = STATE(2623),
    [sym_quasiquote] = STATE(2623),
    [aux_sym_type_apply_repeat1] = STATE(2623),
    [sym__varid] = ACTIONS(10222),
    [sym_float] = ACTIONS(8458),
    [sym_char] = ACTIONS(8458),
    [sym_string] = ACTIONS(8458),
    [sym__integer_literal] = ACTIONS(8460),
    [sym__binary_literal] = ACTIONS(8462),
    [sym__octal_literal] = ACTIONS(8462),
    [sym__hex_literal] = ACTIONS(8462),
    [anon_sym_LPAREN_POUND] = ACTIONS(8464),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8464),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10224),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10240),
    [anon_sym_LBRACK] = ACTIONS(8472),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_SQUOTE] = ACTIONS(10243),
    [anon_sym_STAR] = ACTIONS(8476),
    [anon_sym_u2605] = ACTIONS(8476),
    [anon_sym_AT] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_DOT_DOT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8478),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8480),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5483),
    [sym_quasiquote_start] = ACTIONS(8482),
  },
  [2628] = {
    [sym_integer] = STATE(7922),
    [sym__literal] = STATE(7922),
    [sym__unboxed_open] = STATE(2112),
    [sym_constructor] = STATE(7629),
    [sym_con_unit] = STATE(7922),
    [sym_con_list] = STATE(7922),
    [sym_con_tuple] = STATE(7922),
    [sym_qualified_type] = STATE(8169),
    [sym_tycon_arrow] = STATE(8169),
    [sym_type_literal] = STATE(2628),
    [sym__promoted_tycon] = STATE(8169),
    [sym_type_variable] = STATE(8169),
    [sym_type_parens] = STATE(2628),
    [sym_type_list] = STATE(2628),
    [sym_type_tuple] = STATE(2628),
    [sym__type_promotable_literal] = STATE(2628),
    [sym__type_promoted_literal] = STATE(2628),
    [sym__type_literal] = STATE(2628),
    [sym_type_name] = STATE(2628),
    [sym_type_star] = STATE(2628),
    [sym_type_unboxed_tuple] = STATE(2628),
    [sym_type_unboxed_sum] = STATE(2628),
    [sym__atype] = STATE(2628),
    [sym_type_invisible] = STATE(2628),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17064),
    [sym_splice] = STATE(2628),
    [sym_quasiquote] = STATE(2628),
    [aux_sym_type_apply_repeat1] = STATE(2628),
    [sym__varid] = ACTIONS(10246),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(10249),
    [sym_char] = ACTIONS(10249),
    [sym_string] = ACTIONS(10249),
    [sym__integer_literal] = ACTIONS(10252),
    [sym__binary_literal] = ACTIONS(10255),
    [sym__octal_literal] = ACTIONS(10255),
    [sym__hex_literal] = ACTIONS(10255),
    [anon_sym_LPAREN_POUND] = ACTIONS(10258),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10258),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10261),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10264),
    [anon_sym_LBRACK] = ACTIONS(10267),
    [anon_sym_SQUOTE] = ACTIONS(10270),
    [anon_sym_STAR] = ACTIONS(10273),
    [anon_sym_u2605] = ACTIONS(10273),
    [anon_sym_AT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(10279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(10282),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10285),
  },
  [2629] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2609),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15799),
    [sym_type_parens] = STATE(2609),
    [sym_type_list] = STATE(2609),
    [sym_type_tuple] = STATE(2609),
    [sym__type_promotable_literal] = STATE(2609),
    [sym__type_promoted_literal] = STATE(2609),
    [sym__type_literal] = STATE(2609),
    [sym_type_name] = STATE(2766),
    [sym_type_star] = STATE(2609),
    [sym_type_unboxed_tuple] = STATE(2609),
    [sym_type_unboxed_sum] = STATE(2609),
    [sym__atype] = STATE(2609),
    [sym_type_apply] = STATE(9336),
    [sym__btype] = STATE(9336),
    [sym_type_infix] = STATE(13971),
    [sym__type_infix] = STATE(13800),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2629),
    [sym__type_quantifiers] = STATE(17712),
    [sym__type_context] = STATE(17712),
    [sym__type_fun] = STATE(17712),
    [sym__type] = STATE(17712),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2609),
    [sym_quasiquote] = STATE(2609),
    [sym__varid] = ACTIONS(8626),
    [sym_float] = ACTIONS(8628),
    [sym_char] = ACTIONS(8628),
    [sym_string] = ACTIONS(8628),
    [sym__integer_literal] = ACTIONS(8630),
    [sym__binary_literal] = ACTIONS(8632),
    [sym__octal_literal] = ACTIONS(8632),
    [sym__hex_literal] = ACTIONS(8632),
    [anon_sym_LPAREN_POUND] = ACTIONS(8634),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8634),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8636),
    [sym__conid] = ACTIONS(8640),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_SQUOTE] = ACTIONS(8644),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8646),
    [anon_sym_u2605] = ACTIONS(8646),
    [anon_sym_u27e6] = ACTIONS(8648),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8650),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8652),
  },
  [2630] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2609),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15799),
    [sym_type_parens] = STATE(2609),
    [sym_type_list] = STATE(2609),
    [sym_type_tuple] = STATE(2609),
    [sym__type_promotable_literal] = STATE(2609),
    [sym__type_promoted_literal] = STATE(2609),
    [sym__type_literal] = STATE(2609),
    [sym_type_name] = STATE(2766),
    [sym_type_star] = STATE(2609),
    [sym_type_unboxed_tuple] = STATE(2609),
    [sym_type_unboxed_sum] = STATE(2609),
    [sym__atype] = STATE(2609),
    [sym_type_apply] = STATE(9336),
    [sym__btype] = STATE(9336),
    [sym_type_infix] = STATE(13971),
    [sym__type_infix] = STATE(13800),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2629),
    [sym__type_quantifiers] = STATE(17170),
    [sym__type_context] = STATE(17170),
    [sym__type_fun] = STATE(17170),
    [sym__type] = STATE(17170),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2609),
    [sym_quasiquote] = STATE(2609),
    [sym__varid] = ACTIONS(8626),
    [sym_float] = ACTIONS(8628),
    [sym_char] = ACTIONS(8628),
    [sym_string] = ACTIONS(8628),
    [sym__integer_literal] = ACTIONS(8630),
    [sym__binary_literal] = ACTIONS(8632),
    [sym__octal_literal] = ACTIONS(8632),
    [sym__hex_literal] = ACTIONS(8632),
    [anon_sym_LPAREN_POUND] = ACTIONS(8634),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8634),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8636),
    [sym__conid] = ACTIONS(8640),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_SQUOTE] = ACTIONS(8644),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8646),
    [anon_sym_u2605] = ACTIONS(8646),
    [anon_sym_u27e6] = ACTIONS(8648),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8650),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8652),
  },
  [2631] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2609),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15799),
    [sym_type_parens] = STATE(2609),
    [sym_type_list] = STATE(2609),
    [sym_type_tuple] = STATE(2609),
    [sym__type_promotable_literal] = STATE(2609),
    [sym__type_promoted_literal] = STATE(2609),
    [sym__type_literal] = STATE(2609),
    [sym_type_name] = STATE(2766),
    [sym_type_star] = STATE(2609),
    [sym_type_unboxed_tuple] = STATE(2609),
    [sym_type_unboxed_sum] = STATE(2609),
    [sym__atype] = STATE(2609),
    [sym_type_apply] = STATE(9336),
    [sym__btype] = STATE(9336),
    [sym_type_infix] = STATE(13971),
    [sym__type_infix] = STATE(13800),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2629),
    [sym__type_quantifiers] = STATE(17169),
    [sym__type_context] = STATE(17169),
    [sym__type_fun] = STATE(17169),
    [sym__type] = STATE(17169),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2609),
    [sym_quasiquote] = STATE(2609),
    [sym__varid] = ACTIONS(8626),
    [sym_float] = ACTIONS(8628),
    [sym_char] = ACTIONS(8628),
    [sym_string] = ACTIONS(8628),
    [sym__integer_literal] = ACTIONS(8630),
    [sym__binary_literal] = ACTIONS(8632),
    [sym__octal_literal] = ACTIONS(8632),
    [sym__hex_literal] = ACTIONS(8632),
    [anon_sym_LPAREN_POUND] = ACTIONS(8634),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8634),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8636),
    [sym__conid] = ACTIONS(8640),
    [anon_sym_LBRACK] = ACTIONS(8642),
    [anon_sym_SQUOTE] = ACTIONS(8644),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8646),
    [anon_sym_u2605] = ACTIONS(8646),
    [anon_sym_u27e6] = ACTIONS(8648),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8650),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8652),
  },
  [2632] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16104),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(3150),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(10886),
    [sym__btype] = STATE(10886),
    [sym_implicit_param] = STATE(21152),
    [sym_type_infix] = STATE(17063),
    [sym_constraint] = STATE(16542),
    [sym__quantified_constraint] = STATE(21152),
    [sym__constraint_context] = STATE(21152),
    [sym__constraint] = STATE(21152),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2793),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10288),
    [sym_implicit_parid] = ACTIONS(2029),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(10290),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2633] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2586),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym_type_parens] = STATE(2586),
    [sym_type_list] = STATE(2586),
    [sym_type_tuple] = STATE(2586),
    [sym__type_promotable_literal] = STATE(2586),
    [sym__type_promoted_literal] = STATE(2586),
    [sym__type_literal] = STATE(2586),
    [sym_type_name] = STATE(2586),
    [sym_type_star] = STATE(2586),
    [sym_type_unboxed_tuple] = STATE(2586),
    [sym_type_unboxed_sum] = STATE(2586),
    [sym__atype] = STATE(2586),
    [sym_type_invisible] = STATE(2586),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2586),
    [sym_quasiquote] = STATE(2586),
    [aux_sym_type_apply_repeat1] = STATE(2586),
    [sym__varid] = ACTIONS(10066),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(8217),
    [sym_char] = ACTIONS(8217),
    [sym_string] = ACTIONS(8217),
    [sym__integer_literal] = ACTIONS(8219),
    [sym__binary_literal] = ACTIONS(8221),
    [sym__octal_literal] = ACTIONS(8221),
    [sym__hex_literal] = ACTIONS(8221),
    [anon_sym_LPAREN_POUND] = ACTIONS(8223),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8223),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10292),
    [anon_sym_LBRACK] = ACTIONS(8231),
    [anon_sym_SQUOTE] = ACTIONS(10295),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(8235),
    [anon_sym_u2605] = ACTIONS(8235),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(8237),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(8239),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8241),
  },
  [2634] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2225),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15910),
    [sym_type_parens] = STATE(2225),
    [sym_type_list] = STATE(2225),
    [sym_type_tuple] = STATE(2225),
    [sym__type_promotable_literal] = STATE(2225),
    [sym__type_promoted_literal] = STATE(2225),
    [sym__type_literal] = STATE(2225),
    [sym_type_name] = STATE(2310),
    [sym_type_star] = STATE(2225),
    [sym_type_unboxed_tuple] = STATE(2225),
    [sym_type_unboxed_sum] = STATE(2225),
    [sym__atype] = STATE(2225),
    [sym_type_apply] = STATE(8044),
    [sym__btype] = STATE(8044),
    [sym_type_infix] = STATE(10739),
    [sym__type_infix] = STATE(10626),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(12621),
    [sym__type_context] = STATE(12621),
    [sym__type_fun] = STATE(12621),
    [sym__type] = STATE(12621),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2225),
    [sym_quasiquote] = STATE(2225),
    [sym__varid] = ACTIONS(6266),
    [sym_float] = ACTIONS(6268),
    [sym_char] = ACTIONS(6268),
    [sym_string] = ACTIONS(6268),
    [sym__integer_literal] = ACTIONS(6270),
    [sym__binary_literal] = ACTIONS(6272),
    [sym__octal_literal] = ACTIONS(6272),
    [sym__hex_literal] = ACTIONS(6272),
    [anon_sym_LPAREN_POUND] = ACTIONS(6274),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8197),
    [sym__conid] = ACTIONS(8201),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [anon_sym_SQUOTE] = ACTIONS(8203),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_u2605] = ACTIONS(6286),
    [anon_sym_u27e6] = ACTIONS(6290),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6292),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6294),
  },
  [2635] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2225),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15910),
    [sym_type_parens] = STATE(2225),
    [sym_type_list] = STATE(2225),
    [sym_type_tuple] = STATE(2225),
    [sym__type_promotable_literal] = STATE(2225),
    [sym__type_promoted_literal] = STATE(2225),
    [sym__type_literal] = STATE(2225),
    [sym_type_name] = STATE(2310),
    [sym_type_star] = STATE(2225),
    [sym_type_unboxed_tuple] = STATE(2225),
    [sym_type_unboxed_sum] = STATE(2225),
    [sym__atype] = STATE(2225),
    [sym_type_apply] = STATE(8044),
    [sym__btype] = STATE(8044),
    [sym_type_infix] = STATE(10739),
    [sym__type_infix] = STATE(10626),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(12623),
    [sym__type_context] = STATE(12623),
    [sym__type_fun] = STATE(12623),
    [sym__type] = STATE(12623),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2225),
    [sym_quasiquote] = STATE(2225),
    [sym__varid] = ACTIONS(6266),
    [sym_float] = ACTIONS(6268),
    [sym_char] = ACTIONS(6268),
    [sym_string] = ACTIONS(6268),
    [sym__integer_literal] = ACTIONS(6270),
    [sym__binary_literal] = ACTIONS(6272),
    [sym__octal_literal] = ACTIONS(6272),
    [sym__hex_literal] = ACTIONS(6272),
    [anon_sym_LPAREN_POUND] = ACTIONS(6274),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8197),
    [sym__conid] = ACTIONS(8201),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [anon_sym_SQUOTE] = ACTIONS(8203),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_u2605] = ACTIONS(6286),
    [anon_sym_u27e6] = ACTIONS(6290),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6292),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6294),
  },
  [2636] = {
    [sym_integer] = STATE(6275),
    [sym__literal] = STATE(6275),
    [sym__unboxed_open] = STATE(2188),
    [sym_constructor] = STATE(5313),
    [sym_con_unit] = STATE(6275),
    [sym_con_list] = STATE(6275),
    [sym_con_tuple] = STATE(6275),
    [sym_qualified_type] = STATE(6297),
    [sym_tycon_arrow] = STATE(6297),
    [sym_type_literal] = STATE(2225),
    [sym__promoted_tycon] = STATE(6297),
    [sym_type_variable] = STATE(6297),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15910),
    [sym_type_parens] = STATE(2225),
    [sym_type_list] = STATE(2225),
    [sym_type_tuple] = STATE(2225),
    [sym__type_promotable_literal] = STATE(2225),
    [sym__type_promoted_literal] = STATE(2225),
    [sym__type_literal] = STATE(2225),
    [sym_type_name] = STATE(2310),
    [sym_type_star] = STATE(2225),
    [sym_type_unboxed_tuple] = STATE(2225),
    [sym_type_unboxed_sum] = STATE(2225),
    [sym__atype] = STATE(2225),
    [sym_type_apply] = STATE(8044),
    [sym__btype] = STATE(8044),
    [sym_type_infix] = STATE(10739),
    [sym__type_infix] = STATE(10626),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(12713),
    [sym__type_context] = STATE(12713),
    [sym__type_fun] = STATE(12713),
    [sym__type] = STATE(12713),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17800),
    [sym_splice] = STATE(2225),
    [sym_quasiquote] = STATE(2225),
    [sym__varid] = ACTIONS(6266),
    [sym_float] = ACTIONS(6268),
    [sym_char] = ACTIONS(6268),
    [sym_string] = ACTIONS(6268),
    [sym__integer_literal] = ACTIONS(6270),
    [sym__binary_literal] = ACTIONS(6272),
    [sym__octal_literal] = ACTIONS(6272),
    [sym__hex_literal] = ACTIONS(6272),
    [anon_sym_LPAREN_POUND] = ACTIONS(6274),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8197),
    [sym__conid] = ACTIONS(8201),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [anon_sym_SQUOTE] = ACTIONS(8203),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_u2605] = ACTIONS(6286),
    [anon_sym_u27e6] = ACTIONS(6290),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6292),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6294),
  },
  [2637] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(16864),
    [sym__type_context] = STATE(16864),
    [sym__type_fun] = STATE(16864),
    [sym__type] = STATE(16864),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2638] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2638),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym_type_parens] = STATE(2638),
    [sym_type_list] = STATE(2638),
    [sym_type_tuple] = STATE(2638),
    [sym__type_promotable_literal] = STATE(2638),
    [sym__type_promoted_literal] = STATE(2638),
    [sym__type_literal] = STATE(2638),
    [sym_type_name] = STATE(2638),
    [sym_type_star] = STATE(2638),
    [sym_type_unboxed_tuple] = STATE(2638),
    [sym_type_unboxed_sum] = STATE(2638),
    [sym__atype] = STATE(2638),
    [sym_type_invisible] = STATE(2638),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2638),
    [sym_quasiquote] = STATE(2638),
    [aux_sym_type_apply_repeat1] = STATE(2638),
    [sym__varid] = ACTIONS(10298),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(10301),
    [sym_char] = ACTIONS(10301),
    [sym_string] = ACTIONS(10301),
    [sym__integer_literal] = ACTIONS(10304),
    [sym__binary_literal] = ACTIONS(10307),
    [sym__octal_literal] = ACTIONS(10307),
    [sym__hex_literal] = ACTIONS(10307),
    [anon_sym_LPAREN_POUND] = ACTIONS(10310),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10310),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10313),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10316),
    [anon_sym_LBRACK] = ACTIONS(10319),
    [anon_sym_SQUOTE] = ACTIONS(10322),
    [anon_sym_STAR] = ACTIONS(10325),
    [anon_sym_u2605] = ACTIONS(10325),
    [anon_sym_AT] = ACTIONS(10328),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(10331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(10334),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10337),
  },
  [2639] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2057),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15863),
    [sym_type_parens] = STATE(2057),
    [sym_type_list] = STATE(2057),
    [sym_type_tuple] = STATE(2057),
    [sym__type_promotable_literal] = STATE(2057),
    [sym__type_promoted_literal] = STATE(2057),
    [sym__type_literal] = STATE(2057),
    [sym_type_name] = STATE(2158),
    [sym_type_star] = STATE(2057),
    [sym_type_unboxed_tuple] = STATE(2057),
    [sym_type_unboxed_sum] = STATE(2057),
    [sym__atype] = STATE(2057),
    [sym_type_apply] = STATE(7195),
    [sym__btype] = STATE(7195),
    [sym_type_infix] = STATE(10505),
    [sym__type_infix] = STATE(10272),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2639),
    [sym__type_quantifiers] = STATE(10715),
    [sym__type_context] = STATE(10715),
    [sym__type_fun] = STATE(10715),
    [sym__type] = STATE(10715),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2057),
    [sym_quasiquote] = STATE(2057),
    [sym__varid] = ACTIONS(5644),
    [sym_float] = ACTIONS(5646),
    [sym_char] = ACTIONS(5646),
    [sym_string] = ACTIONS(5646),
    [sym__integer_literal] = ACTIONS(5648),
    [sym__binary_literal] = ACTIONS(5650),
    [sym__octal_literal] = ACTIONS(5650),
    [sym__hex_literal] = ACTIONS(5650),
    [anon_sym_LPAREN_POUND] = ACTIONS(5652),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5652),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7887),
    [sym__conid] = ACTIONS(7891),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_SQUOTE] = ACTIONS(7893),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_u2605] = ACTIONS(5664),
    [anon_sym_u27e6] = ACTIONS(5668),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5672),
  },
  [2640] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2057),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15863),
    [sym_type_parens] = STATE(2057),
    [sym_type_list] = STATE(2057),
    [sym_type_tuple] = STATE(2057),
    [sym__type_promotable_literal] = STATE(2057),
    [sym__type_promoted_literal] = STATE(2057),
    [sym__type_literal] = STATE(2057),
    [sym_type_name] = STATE(2158),
    [sym_type_star] = STATE(2057),
    [sym_type_unboxed_tuple] = STATE(2057),
    [sym_type_unboxed_sum] = STATE(2057),
    [sym__atype] = STATE(2057),
    [sym_type_apply] = STATE(7195),
    [sym__btype] = STATE(7195),
    [sym_type_infix] = STATE(10505),
    [sym__type_infix] = STATE(10272),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2639),
    [sym__type_quantifiers] = STATE(10741),
    [sym__type_context] = STATE(10741),
    [sym__type_fun] = STATE(10741),
    [sym__type] = STATE(10741),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2057),
    [sym_quasiquote] = STATE(2057),
    [sym__varid] = ACTIONS(5644),
    [sym_float] = ACTIONS(5646),
    [sym_char] = ACTIONS(5646),
    [sym_string] = ACTIONS(5646),
    [sym__integer_literal] = ACTIONS(5648),
    [sym__binary_literal] = ACTIONS(5650),
    [sym__octal_literal] = ACTIONS(5650),
    [sym__hex_literal] = ACTIONS(5650),
    [anon_sym_LPAREN_POUND] = ACTIONS(5652),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5652),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7887),
    [sym__conid] = ACTIONS(7891),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_SQUOTE] = ACTIONS(7893),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_u2605] = ACTIONS(5664),
    [anon_sym_u27e6] = ACTIONS(5668),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5672),
  },
  [2641] = {
    [sym_integer] = STATE(4704),
    [sym__literal] = STATE(4704),
    [sym__unboxed_open] = STATE(2205),
    [sym_constructor] = STATE(4375),
    [sym_con_unit] = STATE(4704),
    [sym_con_list] = STATE(4704),
    [sym_con_tuple] = STATE(4704),
    [sym_qualified_type] = STATE(4539),
    [sym_tycon_arrow] = STATE(4539),
    [sym_type_literal] = STATE(2057),
    [sym__promoted_tycon] = STATE(4539),
    [sym_type_variable] = STATE(4539),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15863),
    [sym_type_parens] = STATE(2057),
    [sym_type_list] = STATE(2057),
    [sym_type_tuple] = STATE(2057),
    [sym__type_promotable_literal] = STATE(2057),
    [sym__type_promoted_literal] = STATE(2057),
    [sym__type_literal] = STATE(2057),
    [sym_type_name] = STATE(2158),
    [sym_type_star] = STATE(2057),
    [sym_type_unboxed_tuple] = STATE(2057),
    [sym_type_unboxed_sum] = STATE(2057),
    [sym__atype] = STATE(2057),
    [sym_type_apply] = STATE(7195),
    [sym__btype] = STATE(7195),
    [sym_type_infix] = STATE(10505),
    [sym__type_infix] = STATE(10272),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2639),
    [sym__type_quantifiers] = STATE(10743),
    [sym__type_context] = STATE(10743),
    [sym__type_fun] = STATE(10743),
    [sym__type] = STATE(10743),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17101),
    [sym_splice] = STATE(2057),
    [sym_quasiquote] = STATE(2057),
    [sym__varid] = ACTIONS(5644),
    [sym_float] = ACTIONS(5646),
    [sym_char] = ACTIONS(5646),
    [sym_string] = ACTIONS(5646),
    [sym__integer_literal] = ACTIONS(5648),
    [sym__binary_literal] = ACTIONS(5650),
    [sym__octal_literal] = ACTIONS(5650),
    [sym__hex_literal] = ACTIONS(5650),
    [anon_sym_LPAREN_POUND] = ACTIONS(5652),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5652),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7887),
    [sym__conid] = ACTIONS(7891),
    [anon_sym_LBRACK] = ACTIONS(5659),
    [anon_sym_SQUOTE] = ACTIONS(7893),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_u2605] = ACTIONS(5664),
    [anon_sym_u27e6] = ACTIONS(5668),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5672),
  },
  [2642] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15953),
    [sym_forall] = STATE(3200),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(15698),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(10676),
    [sym_context] = STATE(3570),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym__datainst] = STATE(20387),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_instance] = ACTIONS(10340),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2643] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2423),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15661),
    [sym_type_parens] = STATE(2423),
    [sym_type_list] = STATE(2423),
    [sym_type_tuple] = STATE(2423),
    [sym__type_promotable_literal] = STATE(2423),
    [sym__type_promoted_literal] = STATE(2423),
    [sym__type_literal] = STATE(2423),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2423),
    [sym_type_unboxed_tuple] = STATE(2423),
    [sym_type_unboxed_sum] = STATE(2423),
    [sym__atype] = STATE(2423),
    [sym_type_apply] = STATE(8297),
    [sym__btype] = STATE(8297),
    [sym_type_infix] = STATE(11111),
    [sym__type_infix] = STATE(10824),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2660),
    [sym__type_quantifiers] = STATE(13345),
    [sym__type_context] = STATE(13345),
    [sym__type_fun] = STATE(13345),
    [sym__type] = STATE(13345),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2423),
    [sym_quasiquote] = STATE(2423),
    [sym__varid] = ACTIONS(8037),
    [sym_float] = ACTIONS(6979),
    [sym_char] = ACTIONS(6979),
    [sym_string] = ACTIONS(6979),
    [sym__integer_literal] = ACTIONS(6981),
    [sym__binary_literal] = ACTIONS(6983),
    [sym__octal_literal] = ACTIONS(6983),
    [sym__hex_literal] = ACTIONS(6983),
    [anon_sym_LPAREN_POUND] = ACTIONS(6985),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6985),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8039),
    [sym__conid] = ACTIONS(8043),
    [anon_sym_LBRACK] = ACTIONS(6992),
    [anon_sym_SQUOTE] = ACTIONS(8045),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_u2605] = ACTIONS(6997),
    [anon_sym_u27e6] = ACTIONS(7001),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7005),
  },
  [2644] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2423),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15661),
    [sym_type_parens] = STATE(2423),
    [sym_type_list] = STATE(2423),
    [sym_type_tuple] = STATE(2423),
    [sym__type_promotable_literal] = STATE(2423),
    [sym__type_promoted_literal] = STATE(2423),
    [sym__type_literal] = STATE(2423),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2423),
    [sym_type_unboxed_tuple] = STATE(2423),
    [sym_type_unboxed_sum] = STATE(2423),
    [sym__atype] = STATE(2423),
    [sym_type_apply] = STATE(8297),
    [sym__btype] = STATE(8297),
    [sym_type_infix] = STATE(11111),
    [sym__type_infix] = STATE(10824),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2660),
    [sym__type_quantifiers] = STATE(13344),
    [sym__type_context] = STATE(13344),
    [sym__type_fun] = STATE(13344),
    [sym__type] = STATE(13344),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2423),
    [sym_quasiquote] = STATE(2423),
    [sym__varid] = ACTIONS(8037),
    [sym_float] = ACTIONS(6979),
    [sym_char] = ACTIONS(6979),
    [sym_string] = ACTIONS(6979),
    [sym__integer_literal] = ACTIONS(6981),
    [sym__binary_literal] = ACTIONS(6983),
    [sym__octal_literal] = ACTIONS(6983),
    [sym__hex_literal] = ACTIONS(6983),
    [anon_sym_LPAREN_POUND] = ACTIONS(6985),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6985),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8039),
    [sym__conid] = ACTIONS(8043),
    [anon_sym_LBRACK] = ACTIONS(6992),
    [anon_sym_SQUOTE] = ACTIONS(8045),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_u2605] = ACTIONS(6997),
    [anon_sym_u27e6] = ACTIONS(7001),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7005),
  },
  [2645] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2504),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15986),
    [sym_type_parens] = STATE(2504),
    [sym_type_list] = STATE(2504),
    [sym_type_tuple] = STATE(2504),
    [sym__type_promotable_literal] = STATE(2504),
    [sym__type_promoted_literal] = STATE(2504),
    [sym__type_literal] = STATE(2504),
    [sym_type_name] = STATE(2522),
    [sym_type_star] = STATE(2504),
    [sym_type_unboxed_tuple] = STATE(2504),
    [sym_type_unboxed_sum] = STATE(2504),
    [sym__atype] = STATE(2504),
    [sym_type_apply] = STATE(8442),
    [sym__btype] = STATE(8442),
    [sym_type_infix] = STATE(12864),
    [sym__type_infix] = STATE(13441),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2645),
    [sym__type_quantifiers] = STATE(16142),
    [sym__type_context] = STATE(16142),
    [sym__type_fun] = STATE(16142),
    [sym__type] = STATE(16142),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2504),
    [sym_quasiquote] = STATE(2504),
    [sym__varid] = ACTIONS(8077),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8832),
    [sym__conid] = ACTIONS(8836),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8838),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2646] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2356),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15936),
    [sym_type_parens] = STATE(2356),
    [sym_type_list] = STATE(2356),
    [sym_type_tuple] = STATE(2356),
    [sym__type_promotable_literal] = STATE(2356),
    [sym__type_promoted_literal] = STATE(2356),
    [sym__type_literal] = STATE(2356),
    [sym_type_name] = STATE(2419),
    [sym_type_star] = STATE(2356),
    [sym_type_unboxed_tuple] = STATE(2356),
    [sym_type_unboxed_sum] = STATE(2356),
    [sym__atype] = STATE(2356),
    [sym_type_apply] = STATE(8215),
    [sym__btype] = STATE(8215),
    [sym_type_infix] = STATE(10841),
    [sym__type_infix] = STATE(10710),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2656),
    [sym__type_quantifiers] = STATE(13093),
    [sym__type_context] = STATE(13093),
    [sym__type_fun] = STATE(13093),
    [sym__type] = STATE(13093),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2356),
    [sym_quasiquote] = STATE(2356),
    [sym__varid] = ACTIONS(6801),
    [sym_float] = ACTIONS(6803),
    [sym_char] = ACTIONS(6803),
    [sym_string] = ACTIONS(6803),
    [sym__integer_literal] = ACTIONS(6805),
    [sym__binary_literal] = ACTIONS(6807),
    [sym__octal_literal] = ACTIONS(6807),
    [sym__hex_literal] = ACTIONS(6807),
    [anon_sym_LPAREN_POUND] = ACTIONS(6809),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6809),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8512),
    [sym__conid] = ACTIONS(8516),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_SQUOTE] = ACTIONS(8518),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6821),
    [anon_sym_u2605] = ACTIONS(6821),
    [anon_sym_u27e6] = ACTIONS(6825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6829),
  },
  [2647] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2356),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15936),
    [sym_type_parens] = STATE(2356),
    [sym_type_list] = STATE(2356),
    [sym_type_tuple] = STATE(2356),
    [sym__type_promotable_literal] = STATE(2356),
    [sym__type_promoted_literal] = STATE(2356),
    [sym__type_literal] = STATE(2356),
    [sym_type_name] = STATE(2419),
    [sym_type_star] = STATE(2356),
    [sym_type_unboxed_tuple] = STATE(2356),
    [sym_type_unboxed_sum] = STATE(2356),
    [sym__atype] = STATE(2356),
    [sym_type_apply] = STATE(8215),
    [sym__btype] = STATE(8215),
    [sym_type_infix] = STATE(10841),
    [sym__type_infix] = STATE(10710),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2656),
    [sym__type_quantifiers] = STATE(13095),
    [sym__type_context] = STATE(13095),
    [sym__type_fun] = STATE(13095),
    [sym__type] = STATE(13095),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2356),
    [sym_quasiquote] = STATE(2356),
    [sym__varid] = ACTIONS(6801),
    [sym_float] = ACTIONS(6803),
    [sym_char] = ACTIONS(6803),
    [sym_string] = ACTIONS(6803),
    [sym__integer_literal] = ACTIONS(6805),
    [sym__binary_literal] = ACTIONS(6807),
    [sym__octal_literal] = ACTIONS(6807),
    [sym__hex_literal] = ACTIONS(6807),
    [anon_sym_LPAREN_POUND] = ACTIONS(6809),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6809),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8512),
    [sym__conid] = ACTIONS(8516),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_SQUOTE] = ACTIONS(8518),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6821),
    [anon_sym_u2605] = ACTIONS(6821),
    [anon_sym_u27e6] = ACTIONS(6825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6829),
  },
  [2648] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2504),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15986),
    [sym_type_parens] = STATE(2504),
    [sym_type_list] = STATE(2504),
    [sym_type_tuple] = STATE(2504),
    [sym__type_promotable_literal] = STATE(2504),
    [sym__type_promoted_literal] = STATE(2504),
    [sym__type_literal] = STATE(2504),
    [sym_type_name] = STATE(2522),
    [sym_type_star] = STATE(2504),
    [sym_type_unboxed_tuple] = STATE(2504),
    [sym_type_unboxed_sum] = STATE(2504),
    [sym__atype] = STATE(2504),
    [sym_type_apply] = STATE(8442),
    [sym__btype] = STATE(8442),
    [sym_type_infix] = STATE(12864),
    [sym__type_infix] = STATE(13441),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2645),
    [sym__type_quantifiers] = STATE(16173),
    [sym__type_context] = STATE(16173),
    [sym__type_fun] = STATE(16173),
    [sym__type] = STATE(16173),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2504),
    [sym_quasiquote] = STATE(2504),
    [sym__varid] = ACTIONS(8077),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8832),
    [sym__conid] = ACTIONS(8836),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8838),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2649] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2504),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15986),
    [sym_type_parens] = STATE(2504),
    [sym_type_list] = STATE(2504),
    [sym_type_tuple] = STATE(2504),
    [sym__type_promotable_literal] = STATE(2504),
    [sym__type_promoted_literal] = STATE(2504),
    [sym__type_literal] = STATE(2504),
    [sym_type_name] = STATE(2522),
    [sym_type_star] = STATE(2504),
    [sym_type_unboxed_tuple] = STATE(2504),
    [sym_type_unboxed_sum] = STATE(2504),
    [sym__atype] = STATE(2504),
    [sym_type_apply] = STATE(8442),
    [sym__btype] = STATE(8442),
    [sym_type_infix] = STATE(12864),
    [sym__type_infix] = STATE(13441),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2645),
    [sym__type_quantifiers] = STATE(16129),
    [sym__type_context] = STATE(16129),
    [sym__type_fun] = STATE(16129),
    [sym__type] = STATE(16129),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym_splice] = STATE(2504),
    [sym_quasiquote] = STATE(2504),
    [sym__varid] = ACTIONS(8077),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8832),
    [sym__conid] = ACTIONS(8836),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8838),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2650] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(11311),
    [sym__type_context] = STATE(11311),
    [sym__type_fun] = STATE(11311),
    [sym__type] = STATE(11311),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2651] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2256),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15804),
    [sym_type_parens] = STATE(2256),
    [sym_type_list] = STATE(2256),
    [sym_type_tuple] = STATE(2256),
    [sym__type_promotable_literal] = STATE(2256),
    [sym__type_promoted_literal] = STATE(2256),
    [sym__type_literal] = STATE(2256),
    [sym_type_name] = STATE(2418),
    [sym_type_star] = STATE(2256),
    [sym_type_unboxed_tuple] = STATE(2256),
    [sym_type_unboxed_sum] = STATE(2256),
    [sym__atype] = STATE(2256),
    [sym_type_apply] = STATE(8232),
    [sym__btype] = STATE(8232),
    [sym_type_infix] = STATE(10885),
    [sym__type_infix] = STATE(10714),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2655),
    [sym__type_quantifiers] = STATE(12000),
    [sym__type_context] = STATE(12000),
    [sym__type_fun] = STATE(12000),
    [sym__type] = STATE(12000),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2256),
    [sym_quasiquote] = STATE(2256),
    [sym__varid] = ACTIONS(8822),
    [sym_float] = ACTIONS(6398),
    [sym_char] = ACTIONS(6398),
    [sym_string] = ACTIONS(6398),
    [sym__integer_literal] = ACTIONS(6400),
    [sym__binary_literal] = ACTIONS(6402),
    [sym__octal_literal] = ACTIONS(6402),
    [sym__hex_literal] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND] = ACTIONS(6404),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6404),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8824),
    [sym__conid] = ACTIONS(8828),
    [anon_sym_LBRACK] = ACTIONS(6411),
    [anon_sym_SQUOTE] = ACTIONS(8830),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_u2605] = ACTIONS(6416),
    [anon_sym_u27e6] = ACTIONS(6420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6422),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6424),
  },
  [2652] = {
    [sym_integer] = STATE(8034),
    [sym__literal] = STATE(8034),
    [sym__unboxed_open] = STATE(2086),
    [sym_constructor] = STATE(7882),
    [sym_con_unit] = STATE(8034),
    [sym_con_list] = STATE(8034),
    [sym_con_tuple] = STATE(8034),
    [sym_qualified_type] = STATE(7902),
    [sym_tycon_arrow] = STATE(7902),
    [sym_type_literal] = STATE(2652),
    [sym__promoted_tycon] = STATE(7902),
    [sym_type_variable] = STATE(7902),
    [sym_type_parens] = STATE(2652),
    [sym_type_list] = STATE(2652),
    [sym_type_tuple] = STATE(2652),
    [sym__type_promotable_literal] = STATE(2652),
    [sym__type_promoted_literal] = STATE(2652),
    [sym__type_literal] = STATE(2652),
    [sym_type_name] = STATE(2652),
    [sym_type_star] = STATE(2652),
    [sym_type_unboxed_tuple] = STATE(2652),
    [sym_type_unboxed_sum] = STATE(2652),
    [sym__atype] = STATE(2652),
    [sym_type_invisible] = STATE(2652),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17086),
    [sym_splice] = STATE(2652),
    [sym_quasiquote] = STATE(2652),
    [aux_sym_type_apply_repeat1] = STATE(2652),
    [sym__varid] = ACTIONS(10342),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(10345),
    [sym_char] = ACTIONS(10345),
    [sym_string] = ACTIONS(10345),
    [sym__integer_literal] = ACTIONS(10348),
    [sym__binary_literal] = ACTIONS(10351),
    [sym__octal_literal] = ACTIONS(10351),
    [sym__hex_literal] = ACTIONS(10351),
    [anon_sym_LPAREN_POUND] = ACTIONS(10354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10354),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10357),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10360),
    [anon_sym_LBRACK] = ACTIONS(10363),
    [anon_sym_SQUOTE] = ACTIONS(10366),
    [anon_sym_STAR] = ACTIONS(10369),
    [anon_sym_u2605] = ACTIONS(10369),
    [anon_sym_AT] = ACTIONS(10372),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(10375),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__layout_end] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(10378),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10381),
  },
  [2653] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2256),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15804),
    [sym_type_parens] = STATE(2256),
    [sym_type_list] = STATE(2256),
    [sym_type_tuple] = STATE(2256),
    [sym__type_promotable_literal] = STATE(2256),
    [sym__type_promoted_literal] = STATE(2256),
    [sym__type_literal] = STATE(2256),
    [sym_type_name] = STATE(2418),
    [sym_type_star] = STATE(2256),
    [sym_type_unboxed_tuple] = STATE(2256),
    [sym_type_unboxed_sum] = STATE(2256),
    [sym__atype] = STATE(2256),
    [sym_type_apply] = STATE(8232),
    [sym__btype] = STATE(8232),
    [sym_type_infix] = STATE(10885),
    [sym__type_infix] = STATE(10714),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2655),
    [sym__type_quantifiers] = STATE(11998),
    [sym__type_context] = STATE(11998),
    [sym__type_fun] = STATE(11998),
    [sym__type] = STATE(11998),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2256),
    [sym_quasiquote] = STATE(2256),
    [sym__varid] = ACTIONS(8822),
    [sym_float] = ACTIONS(6398),
    [sym_char] = ACTIONS(6398),
    [sym_string] = ACTIONS(6398),
    [sym__integer_literal] = ACTIONS(6400),
    [sym__binary_literal] = ACTIONS(6402),
    [sym__octal_literal] = ACTIONS(6402),
    [sym__hex_literal] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND] = ACTIONS(6404),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6404),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8824),
    [sym__conid] = ACTIONS(8828),
    [anon_sym_LBRACK] = ACTIONS(6411),
    [anon_sym_SQUOTE] = ACTIONS(8830),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_u2605] = ACTIONS(6416),
    [anon_sym_u27e6] = ACTIONS(6420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6422),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6424),
  },
  [2654] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2523),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15886),
    [sym_type_parens] = STATE(2523),
    [sym_type_list] = STATE(2523),
    [sym_type_tuple] = STATE(2523),
    [sym__type_promotable_literal] = STATE(2523),
    [sym__type_promoted_literal] = STATE(2523),
    [sym__type_literal] = STATE(2523),
    [sym_type_name] = STATE(2541),
    [sym_type_star] = STATE(2523),
    [sym_type_unboxed_tuple] = STATE(2523),
    [sym_type_unboxed_sum] = STATE(2523),
    [sym__atype] = STATE(2523),
    [sym_type_apply] = STATE(8591),
    [sym__btype] = STATE(8591),
    [sym_type_infix] = STATE(11700),
    [sym__type_infix] = STATE(11323),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2654),
    [sym__type_quantifiers] = STATE(14112),
    [sym__type_context] = STATE(14112),
    [sym__type_fun] = STATE(14112),
    [sym__type] = STATE(14112),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2523),
    [sym_quasiquote] = STATE(2523),
    [sym__varid] = ACTIONS(8400),
    [sym_float] = ACTIONS(8402),
    [sym_char] = ACTIONS(8402),
    [sym_string] = ACTIONS(8402),
    [sym__integer_literal] = ACTIONS(8404),
    [sym__binary_literal] = ACTIONS(8406),
    [sym__octal_literal] = ACTIONS(8406),
    [sym__hex_literal] = ACTIONS(8406),
    [anon_sym_LPAREN_POUND] = ACTIONS(8408),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8408),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [sym__conid] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8420),
    [anon_sym_u2605] = ACTIONS(8420),
    [anon_sym_u27e6] = ACTIONS(8422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8426),
  },
  [2655] = {
    [sym_integer] = STATE(6371),
    [sym__literal] = STATE(6371),
    [sym__unboxed_open] = STATE(2104),
    [sym_constructor] = STATE(6258),
    [sym_con_unit] = STATE(6371),
    [sym_con_list] = STATE(6371),
    [sym_con_tuple] = STATE(6371),
    [sym_qualified_type] = STATE(6369),
    [sym_tycon_arrow] = STATE(6369),
    [sym_type_literal] = STATE(2256),
    [sym__promoted_tycon] = STATE(6369),
    [sym_type_variable] = STATE(6369),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15804),
    [sym_type_parens] = STATE(2256),
    [sym_type_list] = STATE(2256),
    [sym_type_tuple] = STATE(2256),
    [sym__type_promotable_literal] = STATE(2256),
    [sym__type_promoted_literal] = STATE(2256),
    [sym__type_literal] = STATE(2256),
    [sym_type_name] = STATE(2418),
    [sym_type_star] = STATE(2256),
    [sym_type_unboxed_tuple] = STATE(2256),
    [sym_type_unboxed_sum] = STATE(2256),
    [sym__atype] = STATE(2256),
    [sym_type_apply] = STATE(8232),
    [sym__btype] = STATE(8232),
    [sym_type_infix] = STATE(10885),
    [sym__type_infix] = STATE(10714),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2655),
    [sym__type_quantifiers] = STATE(11989),
    [sym__type_context] = STATE(11989),
    [sym__type_fun] = STATE(11989),
    [sym__type] = STATE(11989),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16681),
    [sym_splice] = STATE(2256),
    [sym_quasiquote] = STATE(2256),
    [sym__varid] = ACTIONS(8822),
    [sym_float] = ACTIONS(6398),
    [sym_char] = ACTIONS(6398),
    [sym_string] = ACTIONS(6398),
    [sym__integer_literal] = ACTIONS(6400),
    [sym__binary_literal] = ACTIONS(6402),
    [sym__octal_literal] = ACTIONS(6402),
    [sym__hex_literal] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND] = ACTIONS(6404),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6404),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8824),
    [sym__conid] = ACTIONS(8828),
    [anon_sym_LBRACK] = ACTIONS(6411),
    [anon_sym_SQUOTE] = ACTIONS(8830),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_u2605] = ACTIONS(6416),
    [anon_sym_u27e6] = ACTIONS(6420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6422),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6424),
  },
  [2656] = {
    [sym_integer] = STATE(6376),
    [sym__literal] = STATE(6376),
    [sym__unboxed_open] = STATE(2076),
    [sym_constructor] = STATE(6256),
    [sym_con_unit] = STATE(6376),
    [sym_con_list] = STATE(6376),
    [sym_con_tuple] = STATE(6376),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2356),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15936),
    [sym_type_parens] = STATE(2356),
    [sym_type_list] = STATE(2356),
    [sym_type_tuple] = STATE(2356),
    [sym__type_promotable_literal] = STATE(2356),
    [sym__type_promoted_literal] = STATE(2356),
    [sym__type_literal] = STATE(2356),
    [sym_type_name] = STATE(2419),
    [sym_type_star] = STATE(2356),
    [sym_type_unboxed_tuple] = STATE(2356),
    [sym_type_unboxed_sum] = STATE(2356),
    [sym__atype] = STATE(2356),
    [sym_type_apply] = STATE(8215),
    [sym__btype] = STATE(8215),
    [sym_type_infix] = STATE(10841),
    [sym__type_infix] = STATE(10710),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2656),
    [sym__type_quantifiers] = STATE(13218),
    [sym__type_context] = STATE(13218),
    [sym__type_fun] = STATE(13218),
    [sym__type] = STATE(13218),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17742),
    [sym_splice] = STATE(2356),
    [sym_quasiquote] = STATE(2356),
    [sym__varid] = ACTIONS(6801),
    [sym_float] = ACTIONS(6803),
    [sym_char] = ACTIONS(6803),
    [sym_string] = ACTIONS(6803),
    [sym__integer_literal] = ACTIONS(6805),
    [sym__binary_literal] = ACTIONS(6807),
    [sym__octal_literal] = ACTIONS(6807),
    [sym__hex_literal] = ACTIONS(6807),
    [anon_sym_LPAREN_POUND] = ACTIONS(6809),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6809),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8512),
    [sym__conid] = ACTIONS(8516),
    [anon_sym_LBRACK] = ACTIONS(6816),
    [anon_sym_SQUOTE] = ACTIONS(8518),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6821),
    [anon_sym_u2605] = ACTIONS(6821),
    [anon_sym_u27e6] = ACTIONS(6825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6829),
  },
  [2657] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2523),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15886),
    [sym_type_parens] = STATE(2523),
    [sym_type_list] = STATE(2523),
    [sym_type_tuple] = STATE(2523),
    [sym__type_promotable_literal] = STATE(2523),
    [sym__type_promoted_literal] = STATE(2523),
    [sym__type_literal] = STATE(2523),
    [sym_type_name] = STATE(2541),
    [sym_type_star] = STATE(2523),
    [sym_type_unboxed_tuple] = STATE(2523),
    [sym_type_unboxed_sum] = STATE(2523),
    [sym__atype] = STATE(2523),
    [sym_type_apply] = STATE(8591),
    [sym__btype] = STATE(8591),
    [sym_type_infix] = STATE(11700),
    [sym__type_infix] = STATE(11323),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2654),
    [sym__type_quantifiers] = STATE(14117),
    [sym__type_context] = STATE(14117),
    [sym__type_fun] = STATE(14117),
    [sym__type] = STATE(14117),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2523),
    [sym_quasiquote] = STATE(2523),
    [sym__varid] = ACTIONS(8400),
    [sym_float] = ACTIONS(8402),
    [sym_char] = ACTIONS(8402),
    [sym_string] = ACTIONS(8402),
    [sym__integer_literal] = ACTIONS(8404),
    [sym__binary_literal] = ACTIONS(8406),
    [sym__octal_literal] = ACTIONS(8406),
    [sym__hex_literal] = ACTIONS(8406),
    [anon_sym_LPAREN_POUND] = ACTIONS(8408),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8408),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [sym__conid] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8420),
    [anon_sym_u2605] = ACTIONS(8420),
    [anon_sym_u27e6] = ACTIONS(8422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8426),
  },
  [2658] = {
    [sym_integer] = STATE(7259),
    [sym__literal] = STATE(7259),
    [sym__unboxed_open] = STATE(2074),
    [sym_constructor] = STATE(7035),
    [sym_con_unit] = STATE(7259),
    [sym_con_list] = STATE(7259),
    [sym_con_tuple] = STATE(7259),
    [sym_qualified_type] = STATE(7282),
    [sym_tycon_arrow] = STATE(7282),
    [sym_type_literal] = STATE(2523),
    [sym__promoted_tycon] = STATE(7282),
    [sym_type_variable] = STATE(7282),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15886),
    [sym_type_parens] = STATE(2523),
    [sym_type_list] = STATE(2523),
    [sym_type_tuple] = STATE(2523),
    [sym__type_promotable_literal] = STATE(2523),
    [sym__type_promoted_literal] = STATE(2523),
    [sym__type_literal] = STATE(2523),
    [sym_type_name] = STATE(2541),
    [sym_type_star] = STATE(2523),
    [sym_type_unboxed_tuple] = STATE(2523),
    [sym_type_unboxed_sum] = STATE(2523),
    [sym__atype] = STATE(2523),
    [sym_type_apply] = STATE(8591),
    [sym__btype] = STATE(8591),
    [sym_type_infix] = STATE(11700),
    [sym__type_infix] = STATE(11323),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2654),
    [sym__type_quantifiers] = STATE(14116),
    [sym__type_context] = STATE(14116),
    [sym__type_fun] = STATE(14116),
    [sym__type] = STATE(14116),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17287),
    [sym_splice] = STATE(2523),
    [sym_quasiquote] = STATE(2523),
    [sym__varid] = ACTIONS(8400),
    [sym_float] = ACTIONS(8402),
    [sym_char] = ACTIONS(8402),
    [sym_string] = ACTIONS(8402),
    [sym__integer_literal] = ACTIONS(8404),
    [sym__binary_literal] = ACTIONS(8406),
    [sym__octal_literal] = ACTIONS(8406),
    [sym__hex_literal] = ACTIONS(8406),
    [anon_sym_LPAREN_POUND] = ACTIONS(8408),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8408),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8410),
    [sym__conid] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8416),
    [anon_sym_SQUOTE] = ACTIONS(8418),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8420),
    [anon_sym_u2605] = ACTIONS(8420),
    [anon_sym_u27e6] = ACTIONS(8422),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8424),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8426),
  },
  [2659] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15953),
    [sym_forall] = STATE(3200),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(15698),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(10676),
    [sym_context] = STATE(3570),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym__datainst] = STATE(20269),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_instance] = ACTIONS(10384),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2660] = {
    [sym_integer] = STATE(7030),
    [sym__literal] = STATE(7030),
    [sym__unboxed_open] = STATE(2163),
    [sym_constructor] = STATE(6467),
    [sym_con_unit] = STATE(7030),
    [sym_con_list] = STATE(7030),
    [sym_con_tuple] = STATE(7030),
    [sym_qualified_type] = STATE(7012),
    [sym_tycon_arrow] = STATE(7012),
    [sym_type_literal] = STATE(2423),
    [sym__promoted_tycon] = STATE(7012),
    [sym_type_variable] = STATE(7012),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15661),
    [sym_type_parens] = STATE(2423),
    [sym_type_list] = STATE(2423),
    [sym_type_tuple] = STATE(2423),
    [sym__type_promotable_literal] = STATE(2423),
    [sym__type_promoted_literal] = STATE(2423),
    [sym__type_literal] = STATE(2423),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2423),
    [sym_type_unboxed_tuple] = STATE(2423),
    [sym_type_unboxed_sum] = STATE(2423),
    [sym__atype] = STATE(2423),
    [sym_type_apply] = STATE(8297),
    [sym__btype] = STATE(8297),
    [sym_type_infix] = STATE(11111),
    [sym__type_infix] = STATE(10824),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2660),
    [sym__type_quantifiers] = STATE(13329),
    [sym__type_context] = STATE(13329),
    [sym__type_fun] = STATE(13329),
    [sym__type] = STATE(13329),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16822),
    [sym_splice] = STATE(2423),
    [sym_quasiquote] = STATE(2423),
    [sym__varid] = ACTIONS(8037),
    [sym_float] = ACTIONS(6979),
    [sym_char] = ACTIONS(6979),
    [sym_string] = ACTIONS(6979),
    [sym__integer_literal] = ACTIONS(6981),
    [sym__binary_literal] = ACTIONS(6983),
    [sym__octal_literal] = ACTIONS(6983),
    [sym__hex_literal] = ACTIONS(6983),
    [anon_sym_LPAREN_POUND] = ACTIONS(6985),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6985),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8039),
    [sym__conid] = ACTIONS(8043),
    [anon_sym_LBRACK] = ACTIONS(6992),
    [anon_sym_SQUOTE] = ACTIONS(8045),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_u2605] = ACTIONS(6997),
    [anon_sym_u27e6] = ACTIONS(7001),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7005),
  },
  [2661] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14208),
    [sym__type_context] = STATE(14208),
    [sym__type_fun] = STATE(14208),
    [sym__type] = STATE(14208),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2662] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2389),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15953),
    [sym_forall] = STATE(3193),
    [sym_type_parens] = STATE(2389),
    [sym_type_list] = STATE(2389),
    [sym_type_tuple] = STATE(2389),
    [sym__type_promotable_literal] = STATE(2389),
    [sym__type_promoted_literal] = STATE(2389),
    [sym__type_literal] = STATE(2389),
    [sym_type_name] = STATE(2458),
    [sym_type_star] = STATE(2389),
    [sym_type_unboxed_tuple] = STATE(2389),
    [sym_type_unboxed_sum] = STATE(2389),
    [sym__atype] = STATE(2389),
    [sym_type_apply] = STATE(8266),
    [sym__btype] = STATE(8266),
    [sym_type_infix] = STATE(12156),
    [sym__type_infix] = STATE(14015),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(10676),
    [sym_context] = STATE(3544),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym__datainst] = STATE(14354),
    [sym_splice] = STATE(2389),
    [sym_quasiquote] = STATE(2389),
    [sym__varid] = ACTIONS(7007),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8243),
    [sym__conid] = ACTIONS(8247),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(8249),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_instance] = ACTIONS(10386),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2663] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2307),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16032),
    [sym_type_parens] = STATE(2307),
    [sym_type_list] = STATE(2307),
    [sym_type_tuple] = STATE(2307),
    [sym__type_promotable_literal] = STATE(2307),
    [sym__type_promoted_literal] = STATE(2307),
    [sym__type_literal] = STATE(2307),
    [sym_type_name] = STATE(2424),
    [sym_type_star] = STATE(2307),
    [sym_type_unboxed_tuple] = STATE(2307),
    [sym_type_unboxed_sum] = STATE(2307),
    [sym__atype] = STATE(2307),
    [sym_type_apply] = STATE(8199),
    [sym__btype] = STATE(8199),
    [sym_type_infix] = STATE(10802),
    [sym__type_infix] = STATE(10725),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(12805),
    [sym__type_context] = STATE(12805),
    [sym__type_fun] = STATE(12805),
    [sym__type] = STATE(12805),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2307),
    [sym_quasiquote] = STATE(2307),
    [sym__varid] = ACTIONS(8279),
    [sym_float] = ACTIONS(6600),
    [sym_char] = ACTIONS(6600),
    [sym_string] = ACTIONS(6600),
    [sym__integer_literal] = ACTIONS(6602),
    [sym__binary_literal] = ACTIONS(6604),
    [sym__octal_literal] = ACTIONS(6604),
    [sym__hex_literal] = ACTIONS(6604),
    [anon_sym_LPAREN_POUND] = ACTIONS(6606),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6606),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8281),
    [sym__conid] = ACTIONS(8285),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6618),
    [anon_sym_u2605] = ACTIONS(6618),
    [anon_sym_u27e6] = ACTIONS(6622),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6624),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6626),
  },
  [2664] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14247),
    [sym__type_context] = STATE(14247),
    [sym__type_fun] = STATE(14247),
    [sym__type] = STATE(14247),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2665] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2307),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16032),
    [sym_type_parens] = STATE(2307),
    [sym_type_list] = STATE(2307),
    [sym_type_tuple] = STATE(2307),
    [sym__type_promotable_literal] = STATE(2307),
    [sym__type_promoted_literal] = STATE(2307),
    [sym__type_literal] = STATE(2307),
    [sym_type_name] = STATE(2424),
    [sym_type_star] = STATE(2307),
    [sym_type_unboxed_tuple] = STATE(2307),
    [sym_type_unboxed_sum] = STATE(2307),
    [sym__atype] = STATE(2307),
    [sym_type_apply] = STATE(8199),
    [sym__btype] = STATE(8199),
    [sym_type_infix] = STATE(10802),
    [sym__type_infix] = STATE(10725),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(12809),
    [sym__type_context] = STATE(12809),
    [sym__type_fun] = STATE(12809),
    [sym__type] = STATE(12809),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2307),
    [sym_quasiquote] = STATE(2307),
    [sym__varid] = ACTIONS(8279),
    [sym_float] = ACTIONS(6600),
    [sym_char] = ACTIONS(6600),
    [sym_string] = ACTIONS(6600),
    [sym__integer_literal] = ACTIONS(6602),
    [sym__binary_literal] = ACTIONS(6604),
    [sym__octal_literal] = ACTIONS(6604),
    [sym__hex_literal] = ACTIONS(6604),
    [anon_sym_LPAREN_POUND] = ACTIONS(6606),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6606),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8281),
    [sym__conid] = ACTIONS(8285),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6618),
    [anon_sym_u2605] = ACTIONS(6618),
    [anon_sym_u27e6] = ACTIONS(6622),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6624),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6626),
  },
  [2666] = {
    [sym_integer] = STATE(6546),
    [sym__literal] = STATE(6546),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(5965),
    [sym_con_unit] = STATE(6546),
    [sym_con_list] = STATE(6546),
    [sym_con_tuple] = STATE(6546),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2307),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16032),
    [sym_type_parens] = STATE(2307),
    [sym_type_list] = STATE(2307),
    [sym_type_tuple] = STATE(2307),
    [sym__type_promotable_literal] = STATE(2307),
    [sym__type_promoted_literal] = STATE(2307),
    [sym__type_literal] = STATE(2307),
    [sym_type_name] = STATE(2424),
    [sym_type_star] = STATE(2307),
    [sym_type_unboxed_tuple] = STATE(2307),
    [sym_type_unboxed_sum] = STATE(2307),
    [sym__atype] = STATE(2307),
    [sym_type_apply] = STATE(8199),
    [sym__btype] = STATE(8199),
    [sym_type_infix] = STATE(10802),
    [sym__type_infix] = STATE(10725),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(12881),
    [sym__type_context] = STATE(12881),
    [sym__type_fun] = STATE(12881),
    [sym__type] = STATE(12881),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17828),
    [sym_splice] = STATE(2307),
    [sym_quasiquote] = STATE(2307),
    [sym__varid] = ACTIONS(8279),
    [sym_float] = ACTIONS(6600),
    [sym_char] = ACTIONS(6600),
    [sym_string] = ACTIONS(6600),
    [sym__integer_literal] = ACTIONS(6602),
    [sym__binary_literal] = ACTIONS(6604),
    [sym__octal_literal] = ACTIONS(6604),
    [sym__hex_literal] = ACTIONS(6604),
    [anon_sym_LPAREN_POUND] = ACTIONS(6606),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6606),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8281),
    [sym__conid] = ACTIONS(8285),
    [anon_sym_LBRACK] = ACTIONS(6613),
    [anon_sym_SQUOTE] = ACTIONS(8287),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6618),
    [anon_sym_u2605] = ACTIONS(6618),
    [anon_sym_u27e6] = ACTIONS(6622),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6624),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6626),
  },
  [2667] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2528),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15928),
    [sym_type_parens] = STATE(2528),
    [sym_type_list] = STATE(2528),
    [sym_type_tuple] = STATE(2528),
    [sym__type_promotable_literal] = STATE(2528),
    [sym__type_promoted_literal] = STATE(2528),
    [sym__type_literal] = STATE(2528),
    [sym_type_name] = STATE(2585),
    [sym_type_star] = STATE(2528),
    [sym_type_unboxed_tuple] = STATE(2528),
    [sym_type_unboxed_sum] = STATE(2528),
    [sym__atype] = STATE(2528),
    [sym_type_apply] = STATE(8603),
    [sym__btype] = STATE(8603),
    [sym_type_infix] = STATE(11728),
    [sym__type_infix] = STATE(11354),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2667),
    [sym__type_quantifiers] = STATE(13347),
    [sym__type_context] = STATE(13347),
    [sym__type_fun] = STATE(13347),
    [sym__type] = STATE(13347),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2528),
    [sym_quasiquote] = STATE(2528),
    [sym__varid] = ACTIONS(8251),
    [sym_float] = ACTIONS(8253),
    [sym_char] = ACTIONS(8253),
    [sym_string] = ACTIONS(8253),
    [sym__integer_literal] = ACTIONS(8255),
    [sym__binary_literal] = ACTIONS(8257),
    [sym__octal_literal] = ACTIONS(8257),
    [sym__hex_literal] = ACTIONS(8257),
    [anon_sym_LPAREN_POUND] = ACTIONS(8259),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8259),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8261),
    [sym__conid] = ACTIONS(8265),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_SQUOTE] = ACTIONS(8269),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8271),
    [anon_sym_u2605] = ACTIONS(8271),
    [anon_sym_u27e6] = ACTIONS(8273),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8277),
  },
  [2668] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(11349),
    [sym__type_context] = STATE(11349),
    [sym__type_fun] = STATE(11349),
    [sym__type] = STATE(11349),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2669] = {
    [sym_integer] = STATE(4298),
    [sym__literal] = STATE(4298),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(4157),
    [sym_con_unit] = STATE(4298),
    [sym_con_list] = STATE(4298),
    [sym_con_tuple] = STATE(4298),
    [sym_qualified_type] = STATE(4278),
    [sym_tycon_arrow] = STATE(4278),
    [sym_type_literal] = STATE(2046),
    [sym__promoted_tycon] = STATE(4278),
    [sym_type_variable] = STATE(4278),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16237),
    [sym_type_parens] = STATE(2046),
    [sym_type_list] = STATE(2046),
    [sym_type_tuple] = STATE(2046),
    [sym__type_promotable_literal] = STATE(2046),
    [sym__type_promoted_literal] = STATE(2046),
    [sym__type_literal] = STATE(2046),
    [sym_type_name] = STATE(2050),
    [sym_type_star] = STATE(2046),
    [sym_type_unboxed_tuple] = STATE(2046),
    [sym_type_unboxed_sum] = STATE(2046),
    [sym__atype] = STATE(2046),
    [sym_type_apply] = STATE(6485),
    [sym__btype] = STATE(6485),
    [sym_type_infix] = STATE(10593),
    [sym__type_infix] = STATE(10687),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2650),
    [sym__type_quantifiers] = STATE(11348),
    [sym__type_context] = STATE(11348),
    [sym__type_fun] = STATE(11348),
    [sym__type] = STATE(11348),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16437),
    [sym_splice] = STATE(2046),
    [sym_quasiquote] = STATE(2046),
    [sym__varid] = ACTIONS(5449),
    [sym_float] = ACTIONS(5453),
    [sym_char] = ACTIONS(5453),
    [sym_string] = ACTIONS(5453),
    [sym__integer_literal] = ACTIONS(5455),
    [sym__binary_literal] = ACTIONS(5457),
    [sym__octal_literal] = ACTIONS(5457),
    [sym__hex_literal] = ACTIONS(5457),
    [anon_sym_LPAREN_POUND] = ACTIONS(5459),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5459),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym__conid] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_SQUOTE] = ACTIONS(6100),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_u2605] = ACTIONS(5471),
    [anon_sym_u27e6] = ACTIONS(5477),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5481),
  },
  [2670] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2528),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15928),
    [sym_type_parens] = STATE(2528),
    [sym_type_list] = STATE(2528),
    [sym_type_tuple] = STATE(2528),
    [sym__type_promotable_literal] = STATE(2528),
    [sym__type_promoted_literal] = STATE(2528),
    [sym__type_literal] = STATE(2528),
    [sym_type_name] = STATE(2585),
    [sym_type_star] = STATE(2528),
    [sym_type_unboxed_tuple] = STATE(2528),
    [sym_type_unboxed_sum] = STATE(2528),
    [sym__atype] = STATE(2528),
    [sym_type_apply] = STATE(8603),
    [sym__btype] = STATE(8603),
    [sym_type_infix] = STATE(11728),
    [sym__type_infix] = STATE(11354),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2667),
    [sym__type_quantifiers] = STATE(13432),
    [sym__type_context] = STATE(13432),
    [sym__type_fun] = STATE(13432),
    [sym__type] = STATE(13432),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2528),
    [sym_quasiquote] = STATE(2528),
    [sym__varid] = ACTIONS(8251),
    [sym_float] = ACTIONS(8253),
    [sym_char] = ACTIONS(8253),
    [sym_string] = ACTIONS(8253),
    [sym__integer_literal] = ACTIONS(8255),
    [sym__binary_literal] = ACTIONS(8257),
    [sym__octal_literal] = ACTIONS(8257),
    [sym__hex_literal] = ACTIONS(8257),
    [anon_sym_LPAREN_POUND] = ACTIONS(8259),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8259),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8261),
    [sym__conid] = ACTIONS(8265),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_SQUOTE] = ACTIONS(8269),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8271),
    [anon_sym_u2605] = ACTIONS(8271),
    [anon_sym_u27e6] = ACTIONS(8273),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8277),
  },
  [2671] = {
    [sym_integer] = STATE(7271),
    [sym__literal] = STATE(7271),
    [sym__unboxed_open] = STATE(2069),
    [sym_constructor] = STATE(7041),
    [sym_con_unit] = STATE(7271),
    [sym_con_list] = STATE(7271),
    [sym_con_tuple] = STATE(7271),
    [sym_qualified_type] = STATE(7296),
    [sym_tycon_arrow] = STATE(7296),
    [sym_type_literal] = STATE(2528),
    [sym__promoted_tycon] = STATE(7296),
    [sym_type_variable] = STATE(7296),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15928),
    [sym_type_parens] = STATE(2528),
    [sym_type_list] = STATE(2528),
    [sym_type_tuple] = STATE(2528),
    [sym__type_promotable_literal] = STATE(2528),
    [sym__type_promoted_literal] = STATE(2528),
    [sym__type_literal] = STATE(2528),
    [sym_type_name] = STATE(2585),
    [sym_type_star] = STATE(2528),
    [sym_type_unboxed_tuple] = STATE(2528),
    [sym_type_unboxed_sum] = STATE(2528),
    [sym__atype] = STATE(2528),
    [sym_type_apply] = STATE(8603),
    [sym__btype] = STATE(8603),
    [sym_type_infix] = STATE(11728),
    [sym__type_infix] = STATE(11354),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2667),
    [sym__type_quantifiers] = STATE(13437),
    [sym__type_context] = STATE(13437),
    [sym__type_fun] = STATE(13437),
    [sym__type] = STATE(13437),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17310),
    [sym_splice] = STATE(2528),
    [sym_quasiquote] = STATE(2528),
    [sym__varid] = ACTIONS(8251),
    [sym_float] = ACTIONS(8253),
    [sym_char] = ACTIONS(8253),
    [sym_string] = ACTIONS(8253),
    [sym__integer_literal] = ACTIONS(8255),
    [sym__binary_literal] = ACTIONS(8257),
    [sym__octal_literal] = ACTIONS(8257),
    [sym__hex_literal] = ACTIONS(8257),
    [anon_sym_LPAREN_POUND] = ACTIONS(8259),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8259),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8261),
    [sym__conid] = ACTIONS(8265),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_SQUOTE] = ACTIONS(8269),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8271),
    [anon_sym_u2605] = ACTIONS(8271),
    [anon_sym_u27e6] = ACTIONS(8273),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8277),
  },
  [2672] = {
    [sym_integer] = STATE(8373),
    [sym__literal] = STATE(8373),
    [sym__unboxed_open] = STATE(302),
    [sym_variable] = STATE(8271),
    [sym_constructor] = STATE(8191),
    [sym_qualified_constructor] = STATE(8257),
    [sym__qcon] = STATE(8306),
    [sym_con_unit] = STATE(8373),
    [sym_con_list] = STATE(8373),
    [sym_con_tuple] = STATE(8373),
    [sym_literal] = STATE(8398),
    [sym_pat_fields] = STATE(13595),
    [sym_pat_name] = STATE(2795),
    [sym_pat_as] = STATE(2795),
    [sym__pat_constructor] = STATE(8235),
    [sym_pat_record] = STATE(2795),
    [sym_pat_wildcard] = STATE(2795),
    [sym_pat_parens] = STATE(2795),
    [sym_pat_tuple] = STATE(2795),
    [sym_pat_unboxed_tuple] = STATE(2795),
    [sym_pat_unboxed_sum] = STATE(2795),
    [sym_pat_list] = STATE(2795),
    [sym_pat_strict] = STATE(2795),
    [sym_pat_irrefutable] = STATE(2795),
    [sym_pat_type_binder] = STATE(2795),
    [sym__apat] = STATE(2795),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17011),
    [sym_splice] = STATE(2795),
    [sym_quasiquote] = STATE(2795),
    [aux_sym_exp_lambda_repeat1] = STATE(2795),
    [sym__varid] = ACTIONS(10388),
    [anon_sym_SEMI] = ACTIONS(10390),
    [sym_float] = ACTIONS(10392),
    [sym_char] = ACTIONS(10392),
    [sym_string] = ACTIONS(10392),
    [sym__integer_literal] = ACTIONS(10394),
    [sym__binary_literal] = ACTIONS(10396),
    [sym__octal_literal] = ACTIONS(10396),
    [sym__hex_literal] = ACTIONS(10396),
    [anon_sym_LPAREN_POUND] = ACTIONS(10398),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10398),
    [anon_sym_u2190] = ACTIONS(10390),
    [anon_sym_LT_DASH] = ACTIONS(10390),
    [anon_sym_u2237] = ACTIONS(10390),
    [anon_sym_COLON_COLON] = ACTIONS(10390),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10400),
    [anon_sym_BQUOTE] = ACTIONS(10390),
    [sym__conid] = ACTIONS(10402),
    [anon_sym_LBRACK] = ACTIONS(10405),
    [anon_sym_LBRACE] = ACTIONS(10407),
    [anon_sym_RBRACE] = ACTIONS(10390),
    [anon_sym_AT] = ACTIONS(10409),
    [anon_sym_EQ] = ACTIONS(10390),
    [anon_sym__] = ACTIONS(10411),
    [anon_sym_u27e6] = ACTIONS(10413),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(10415),
    [sym__consym] = ACTIONS(10390),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10417),
    [sym__strict] = ACTIONS(10419),
    [sym__lazy] = ACTIONS(10421),
  },
  [2673] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2516),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16096),
    [sym_type_parens] = STATE(2516),
    [sym_type_list] = STATE(2516),
    [sym_type_tuple] = STATE(2516),
    [sym__type_promotable_literal] = STATE(2516),
    [sym__type_promoted_literal] = STATE(2516),
    [sym__type_literal] = STATE(2516),
    [sym_type_name] = STATE(2569),
    [sym_type_star] = STATE(2516),
    [sym_type_unboxed_tuple] = STATE(2516),
    [sym_type_unboxed_sum] = STATE(2516),
    [sym__atype] = STATE(2516),
    [sym_type_apply] = STATE(8678),
    [sym__btype] = STATE(8678),
    [sym_type_infix] = STATE(13540),
    [sym__type_infix] = STATE(12787),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2677),
    [sym__type_quantifiers] = STATE(15250),
    [sym__type_context] = STATE(15250),
    [sym__type_fun] = STATE(15250),
    [sym__type] = STATE(15250),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2516),
    [sym_quasiquote] = STATE(2516),
    [sym__varid] = ACTIONS(8428),
    [sym_float] = ACTIONS(8430),
    [sym_char] = ACTIONS(8430),
    [sym_string] = ACTIONS(8430),
    [sym__integer_literal] = ACTIONS(8432),
    [sym__binary_literal] = ACTIONS(8434),
    [sym__octal_literal] = ACTIONS(8434),
    [sym__hex_literal] = ACTIONS(8434),
    [anon_sym_LPAREN_POUND] = ACTIONS(8436),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8436),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8438),
    [sym__conid] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8444),
    [anon_sym_SQUOTE] = ACTIONS(8446),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8448),
    [anon_sym_u2605] = ACTIONS(8448),
    [anon_sym_u27e6] = ACTIONS(8450),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8452),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8454),
  },
  [2674] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2674),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym_type_parens] = STATE(2674),
    [sym_type_list] = STATE(2674),
    [sym_type_tuple] = STATE(2674),
    [sym__type_promotable_literal] = STATE(2674),
    [sym__type_promoted_literal] = STATE(2674),
    [sym__type_literal] = STATE(2674),
    [sym_type_name] = STATE(2674),
    [sym_type_star] = STATE(2674),
    [sym_type_unboxed_tuple] = STATE(2674),
    [sym_type_unboxed_sum] = STATE(2674),
    [sym__atype] = STATE(2674),
    [sym_type_invisible] = STATE(2674),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2674),
    [sym_quasiquote] = STATE(2674),
    [aux_sym_type_apply_repeat1] = STATE(2674),
    [sym__varid] = ACTIONS(10423),
    [sym_float] = ACTIONS(10426),
    [sym_char] = ACTIONS(10426),
    [sym_string] = ACTIONS(10426),
    [sym__integer_literal] = ACTIONS(10429),
    [sym__binary_literal] = ACTIONS(10432),
    [sym__octal_literal] = ACTIONS(10432),
    [sym__hex_literal] = ACTIONS(10432),
    [anon_sym_LPAREN_POUND] = ACTIONS(10435),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10435),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_u2237] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10438),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10441),
    [anon_sym_LBRACK] = ACTIONS(10444),
    [anon_sym_SQUOTE] = ACTIONS(10447),
    [anon_sym_STAR] = ACTIONS(10450),
    [anon_sym_u2605] = ACTIONS(10450),
    [anon_sym_AT] = ACTIONS(10453),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(10456),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(10459),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5496),
    [sym_quasiquote_start] = ACTIONS(10462),
    [sym__unboxed_close] = ACTIONS(5496),
  },
  [2675] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2675),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym_type_parens] = STATE(2675),
    [sym_type_list] = STATE(2675),
    [sym_type_tuple] = STATE(2675),
    [sym__type_promotable_literal] = STATE(2675),
    [sym__type_promoted_literal] = STATE(2675),
    [sym__type_literal] = STATE(2675),
    [sym_type_name] = STATE(2675),
    [sym_type_star] = STATE(2675),
    [sym_type_unboxed_tuple] = STATE(2675),
    [sym_type_unboxed_sum] = STATE(2675),
    [sym__atype] = STATE(2675),
    [sym_type_invisible] = STATE(2675),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2675),
    [sym_quasiquote] = STATE(2675),
    [aux_sym_type_apply_repeat1] = STATE(2675),
    [ts_builtin_sym_end] = ACTIONS(5496),
    [sym__varid] = ACTIONS(10465),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(10468),
    [sym_char] = ACTIONS(10468),
    [sym_string] = ACTIONS(10468),
    [sym__integer_literal] = ACTIONS(10471),
    [sym__binary_literal] = ACTIONS(10474),
    [sym__octal_literal] = ACTIONS(10474),
    [sym__hex_literal] = ACTIONS(10474),
    [anon_sym_LPAREN_POUND] = ACTIONS(10477),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10477),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10480),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10483),
    [anon_sym_LBRACK] = ACTIONS(10486),
    [anon_sym_SQUOTE] = ACTIONS(10489),
    [anon_sym_STAR] = ACTIONS(10492),
    [anon_sym_u2605] = ACTIONS(10492),
    [anon_sym_AT] = ACTIONS(10495),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_deriving] = ACTIONS(5528),
    [anon_sym_u27e6] = ACTIONS(10498),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(10501),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10504),
  },
  [2676] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2516),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16096),
    [sym_type_parens] = STATE(2516),
    [sym_type_list] = STATE(2516),
    [sym_type_tuple] = STATE(2516),
    [sym__type_promotable_literal] = STATE(2516),
    [sym__type_promoted_literal] = STATE(2516),
    [sym__type_literal] = STATE(2516),
    [sym_type_name] = STATE(2569),
    [sym_type_star] = STATE(2516),
    [sym_type_unboxed_tuple] = STATE(2516),
    [sym_type_unboxed_sum] = STATE(2516),
    [sym__atype] = STATE(2516),
    [sym_type_apply] = STATE(8678),
    [sym__btype] = STATE(8678),
    [sym_type_infix] = STATE(13540),
    [sym__type_infix] = STATE(12787),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2677),
    [sym__type_quantifiers] = STATE(15087),
    [sym__type_context] = STATE(15087),
    [sym__type_fun] = STATE(15087),
    [sym__type] = STATE(15087),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2516),
    [sym_quasiquote] = STATE(2516),
    [sym__varid] = ACTIONS(8428),
    [sym_float] = ACTIONS(8430),
    [sym_char] = ACTIONS(8430),
    [sym_string] = ACTIONS(8430),
    [sym__integer_literal] = ACTIONS(8432),
    [sym__binary_literal] = ACTIONS(8434),
    [sym__octal_literal] = ACTIONS(8434),
    [sym__hex_literal] = ACTIONS(8434),
    [anon_sym_LPAREN_POUND] = ACTIONS(8436),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8436),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8438),
    [sym__conid] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8444),
    [anon_sym_SQUOTE] = ACTIONS(8446),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8448),
    [anon_sym_u2605] = ACTIONS(8448),
    [anon_sym_u27e6] = ACTIONS(8450),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8452),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8454),
  },
  [2677] = {
    [sym_integer] = STATE(7423),
    [sym__literal] = STATE(7423),
    [sym__unboxed_open] = STATE(2102),
    [sym_constructor] = STATE(7203),
    [sym_con_unit] = STATE(7423),
    [sym_con_list] = STATE(7423),
    [sym_con_tuple] = STATE(7423),
    [sym_qualified_type] = STATE(7424),
    [sym_tycon_arrow] = STATE(7424),
    [sym_type_literal] = STATE(2516),
    [sym__promoted_tycon] = STATE(7424),
    [sym_type_variable] = STATE(7424),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16096),
    [sym_type_parens] = STATE(2516),
    [sym_type_list] = STATE(2516),
    [sym_type_tuple] = STATE(2516),
    [sym__type_promotable_literal] = STATE(2516),
    [sym__type_promoted_literal] = STATE(2516),
    [sym__type_literal] = STATE(2516),
    [sym_type_name] = STATE(2569),
    [sym_type_star] = STATE(2516),
    [sym_type_unboxed_tuple] = STATE(2516),
    [sym_type_unboxed_sum] = STATE(2516),
    [sym__atype] = STATE(2516),
    [sym_type_apply] = STATE(8678),
    [sym__btype] = STATE(8678),
    [sym_type_infix] = STATE(13540),
    [sym__type_infix] = STATE(12787),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2677),
    [sym__type_quantifiers] = STATE(15376),
    [sym__type_context] = STATE(15376),
    [sym__type_fun] = STATE(15376),
    [sym__type] = STATE(15376),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17798),
    [sym_splice] = STATE(2516),
    [sym_quasiquote] = STATE(2516),
    [sym__varid] = ACTIONS(8428),
    [sym_float] = ACTIONS(8430),
    [sym_char] = ACTIONS(8430),
    [sym_string] = ACTIONS(8430),
    [sym__integer_literal] = ACTIONS(8432),
    [sym__binary_literal] = ACTIONS(8434),
    [sym__octal_literal] = ACTIONS(8434),
    [sym__hex_literal] = ACTIONS(8434),
    [anon_sym_LPAREN_POUND] = ACTIONS(8436),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8436),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8438),
    [sym__conid] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(8444),
    [anon_sym_SQUOTE] = ACTIONS(8446),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8448),
    [anon_sym_u2605] = ACTIONS(8448),
    [anon_sym_u27e6] = ACTIONS(8450),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8452),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8454),
  },
  [2678] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2390),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15961),
    [sym_type_parens] = STATE(2390),
    [sym_type_list] = STATE(2390),
    [sym_type_tuple] = STATE(2390),
    [sym__type_promotable_literal] = STATE(2390),
    [sym__type_promoted_literal] = STATE(2390),
    [sym__type_literal] = STATE(2390),
    [sym_type_name] = STATE(2494),
    [sym_type_star] = STATE(2390),
    [sym_type_unboxed_tuple] = STATE(2390),
    [sym_type_unboxed_sum] = STATE(2390),
    [sym__atype] = STATE(2390),
    [sym_type_apply] = STATE(8252),
    [sym__btype] = STATE(8252),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(13247),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2678),
    [sym__type_quantifiers] = STATE(15438),
    [sym__type_context] = STATE(15438),
    [sym__type_fun] = STATE(15438),
    [sym__type] = STATE(15438),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2390),
    [sym_quasiquote] = STATE(2390),
    [sym__varid] = ACTIONS(7037),
    [sym_float] = ACTIONS(7039),
    [sym_char] = ACTIONS(7039),
    [sym_string] = ACTIONS(7039),
    [sym__integer_literal] = ACTIONS(7041),
    [sym__binary_literal] = ACTIONS(7043),
    [sym__octal_literal] = ACTIONS(7043),
    [sym__hex_literal] = ACTIONS(7043),
    [anon_sym_LPAREN_POUND] = ACTIONS(7045),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7045),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7779),
    [sym__conid] = ACTIONS(7783),
    [anon_sym_LBRACK] = ACTIONS(7052),
    [anon_sym_SQUOTE] = ACTIONS(7785),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_u2605] = ACTIONS(7057),
    [anon_sym_u27e6] = ACTIONS(7061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7063),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7065),
  },
  [2679] = {
    [sym_integer] = STATE(8026),
    [sym__literal] = STATE(8026),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(7673),
    [sym_con_unit] = STATE(8026),
    [sym_con_list] = STATE(8026),
    [sym_con_tuple] = STATE(8026),
    [sym_qualified_type] = STATE(8101),
    [sym_tycon_arrow] = STATE(8101),
    [sym_type_literal] = STATE(2601),
    [sym__promoted_tycon] = STATE(8101),
    [sym_type_variable] = STATE(8101),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16160),
    [sym_type_parens] = STATE(2601),
    [sym_type_list] = STATE(2601),
    [sym_type_tuple] = STATE(2601),
    [sym__type_promotable_literal] = STATE(2601),
    [sym__type_promoted_literal] = STATE(2601),
    [sym__type_literal] = STATE(2601),
    [sym_type_name] = STATE(2778),
    [sym_type_star] = STATE(2601),
    [sym_type_unboxed_tuple] = STATE(2601),
    [sym_type_unboxed_sum] = STATE(2601),
    [sym__atype] = STATE(2601),
    [sym_type_apply] = STATE(8931),
    [sym__btype] = STATE(8931),
    [sym_type_infix] = STATE(14025),
    [sym__type_infix] = STATE(13645),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(17379),
    [sym__type_context] = STATE(17379),
    [sym__type_fun] = STATE(17379),
    [sym__type] = STATE(17379),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16693),
    [sym_splice] = STATE(2601),
    [sym_quasiquote] = STATE(2601),
    [sym__varid] = ACTIONS(7789),
    [sym_float] = ACTIONS(7791),
    [sym_char] = ACTIONS(7791),
    [sym_string] = ACTIONS(7791),
    [sym__integer_literal] = ACTIONS(7793),
    [sym__binary_literal] = ACTIONS(7795),
    [sym__octal_literal] = ACTIONS(7795),
    [sym__hex_literal] = ACTIONS(7795),
    [anon_sym_LPAREN_POUND] = ACTIONS(7797),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7797),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7799),
    [sym__conid] = ACTIONS(7803),
    [anon_sym_LBRACK] = ACTIONS(7805),
    [anon_sym_SQUOTE] = ACTIONS(7807),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_u2605] = ACTIONS(7809),
    [anon_sym_u27e6] = ACTIONS(7811),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7815),
  },
  [2680] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2507),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15949),
    [sym_type_parens] = STATE(2507),
    [sym_type_list] = STATE(2507),
    [sym_type_tuple] = STATE(2507),
    [sym__type_promotable_literal] = STATE(2507),
    [sym__type_promoted_literal] = STATE(2507),
    [sym__type_literal] = STATE(2507),
    [sym_type_name] = STATE(2511),
    [sym_type_star] = STATE(2507),
    [sym_type_unboxed_tuple] = STATE(2507),
    [sym_type_unboxed_sum] = STATE(2507),
    [sym__atype] = STATE(2507),
    [sym_type_apply] = STATE(8483),
    [sym__btype] = STATE(8483),
    [sym_type_infix] = STATE(11205),
    [sym__type_infix] = STATE(11136),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2680),
    [sym__type_quantifiers] = STATE(13612),
    [sym__type_context] = STATE(13612),
    [sym__type_fun] = STATE(13612),
    [sym__type] = STATE(13612),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2507),
    [sym_quasiquote] = STATE(2507),
    [sym__varid] = ACTIONS(8760),
    [sym_float] = ACTIONS(8762),
    [sym_char] = ACTIONS(8762),
    [sym_string] = ACTIONS(8762),
    [sym__integer_literal] = ACTIONS(8764),
    [sym__binary_literal] = ACTIONS(8766),
    [sym__octal_literal] = ACTIONS(8766),
    [sym__hex_literal] = ACTIONS(8766),
    [anon_sym_LPAREN_POUND] = ACTIONS(8768),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8768),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8770),
    [sym__conid] = ACTIONS(8774),
    [anon_sym_LBRACK] = ACTIONS(8776),
    [anon_sym_SQUOTE] = ACTIONS(8778),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8780),
    [anon_sym_u2605] = ACTIONS(8780),
    [anon_sym_u27e6] = ACTIONS(8782),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8784),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8786),
  },
  [2681] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2507),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15949),
    [sym_type_parens] = STATE(2507),
    [sym_type_list] = STATE(2507),
    [sym_type_tuple] = STATE(2507),
    [sym__type_promotable_literal] = STATE(2507),
    [sym__type_promoted_literal] = STATE(2507),
    [sym__type_literal] = STATE(2507),
    [sym_type_name] = STATE(2511),
    [sym_type_star] = STATE(2507),
    [sym_type_unboxed_tuple] = STATE(2507),
    [sym_type_unboxed_sum] = STATE(2507),
    [sym__atype] = STATE(2507),
    [sym_type_apply] = STATE(8483),
    [sym__btype] = STATE(8483),
    [sym_type_infix] = STATE(11205),
    [sym__type_infix] = STATE(11136),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2680),
    [sym__type_quantifiers] = STATE(13676),
    [sym__type_context] = STATE(13676),
    [sym__type_fun] = STATE(13676),
    [sym__type] = STATE(13676),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2507),
    [sym_quasiquote] = STATE(2507),
    [sym__varid] = ACTIONS(8760),
    [sym_float] = ACTIONS(8762),
    [sym_char] = ACTIONS(8762),
    [sym_string] = ACTIONS(8762),
    [sym__integer_literal] = ACTIONS(8764),
    [sym__binary_literal] = ACTIONS(8766),
    [sym__octal_literal] = ACTIONS(8766),
    [sym__hex_literal] = ACTIONS(8766),
    [anon_sym_LPAREN_POUND] = ACTIONS(8768),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8768),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8770),
    [sym__conid] = ACTIONS(8774),
    [anon_sym_LBRACK] = ACTIONS(8776),
    [anon_sym_SQUOTE] = ACTIONS(8778),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8780),
    [anon_sym_u2605] = ACTIONS(8780),
    [anon_sym_u27e6] = ACTIONS(8782),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8784),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8786),
  },
  [2682] = {
    [sym_integer] = STATE(7033),
    [sym__literal] = STATE(7033),
    [sym__unboxed_open] = STATE(2154),
    [sym_constructor] = STATE(6951),
    [sym_con_unit] = STATE(7033),
    [sym_con_list] = STATE(7033),
    [sym_con_tuple] = STATE(7033),
    [sym_qualified_type] = STATE(7095),
    [sym_tycon_arrow] = STATE(7095),
    [sym_type_literal] = STATE(2507),
    [sym__promoted_tycon] = STATE(7095),
    [sym_type_variable] = STATE(7095),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15949),
    [sym_type_parens] = STATE(2507),
    [sym_type_list] = STATE(2507),
    [sym_type_tuple] = STATE(2507),
    [sym__type_promotable_literal] = STATE(2507),
    [sym__type_promoted_literal] = STATE(2507),
    [sym__type_literal] = STATE(2507),
    [sym_type_name] = STATE(2511),
    [sym_type_star] = STATE(2507),
    [sym_type_unboxed_tuple] = STATE(2507),
    [sym_type_unboxed_sum] = STATE(2507),
    [sym__atype] = STATE(2507),
    [sym_type_apply] = STATE(8483),
    [sym__btype] = STATE(8483),
    [sym_type_infix] = STATE(11205),
    [sym__type_infix] = STATE(11136),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2680),
    [sym__type_quantifiers] = STATE(13684),
    [sym__type_context] = STATE(13684),
    [sym__type_fun] = STATE(13684),
    [sym__type] = STATE(13684),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17346),
    [sym_splice] = STATE(2507),
    [sym_quasiquote] = STATE(2507),
    [sym__varid] = ACTIONS(8760),
    [sym_float] = ACTIONS(8762),
    [sym_char] = ACTIONS(8762),
    [sym_string] = ACTIONS(8762),
    [sym__integer_literal] = ACTIONS(8764),
    [sym__binary_literal] = ACTIONS(8766),
    [sym__octal_literal] = ACTIONS(8766),
    [sym__hex_literal] = ACTIONS(8766),
    [anon_sym_LPAREN_POUND] = ACTIONS(8768),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8768),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8770),
    [sym__conid] = ACTIONS(8774),
    [anon_sym_LBRACK] = ACTIONS(8776),
    [anon_sym_SQUOTE] = ACTIONS(8778),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8780),
    [anon_sym_u2605] = ACTIONS(8780),
    [anon_sym_u27e6] = ACTIONS(8782),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8784),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8786),
  },
  [2683] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2684] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2390),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15961),
    [sym_type_parens] = STATE(2390),
    [sym_type_list] = STATE(2390),
    [sym_type_tuple] = STATE(2390),
    [sym__type_promotable_literal] = STATE(2390),
    [sym__type_promoted_literal] = STATE(2390),
    [sym__type_literal] = STATE(2390),
    [sym_type_name] = STATE(2494),
    [sym_type_star] = STATE(2390),
    [sym_type_unboxed_tuple] = STATE(2390),
    [sym_type_unboxed_sum] = STATE(2390),
    [sym__atype] = STATE(2390),
    [sym_type_apply] = STATE(8252),
    [sym__btype] = STATE(8252),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(13247),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2678),
    [sym__type_quantifiers] = STATE(15496),
    [sym__type_context] = STATE(15496),
    [sym__type_fun] = STATE(15496),
    [sym__type] = STATE(15496),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2390),
    [sym_quasiquote] = STATE(2390),
    [sym__varid] = ACTIONS(7037),
    [sym_float] = ACTIONS(7039),
    [sym_char] = ACTIONS(7039),
    [sym_string] = ACTIONS(7039),
    [sym__integer_literal] = ACTIONS(7041),
    [sym__binary_literal] = ACTIONS(7043),
    [sym__octal_literal] = ACTIONS(7043),
    [sym__hex_literal] = ACTIONS(7043),
    [anon_sym_LPAREN_POUND] = ACTIONS(7045),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7045),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7779),
    [sym__conid] = ACTIONS(7783),
    [anon_sym_LBRACK] = ACTIONS(7052),
    [anon_sym_SQUOTE] = ACTIONS(7785),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_u2605] = ACTIONS(7057),
    [anon_sym_u27e6] = ACTIONS(7061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7063),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7065),
  },
  [2685] = {
    [sym_integer] = STATE(6677),
    [sym__literal] = STATE(6677),
    [sym__unboxed_open] = STATE(2091),
    [sym_constructor] = STATE(6654),
    [sym_con_unit] = STATE(6677),
    [sym_con_list] = STATE(6677),
    [sym_con_tuple] = STATE(6677),
    [sym_qualified_type] = STATE(6670),
    [sym_tycon_arrow] = STATE(6670),
    [sym_type_literal] = STATE(2390),
    [sym__promoted_tycon] = STATE(6670),
    [sym_type_variable] = STATE(6670),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15961),
    [sym_type_parens] = STATE(2390),
    [sym_type_list] = STATE(2390),
    [sym_type_tuple] = STATE(2390),
    [sym__type_promotable_literal] = STATE(2390),
    [sym__type_promoted_literal] = STATE(2390),
    [sym__type_literal] = STATE(2390),
    [sym_type_name] = STATE(2494),
    [sym_type_star] = STATE(2390),
    [sym_type_unboxed_tuple] = STATE(2390),
    [sym_type_unboxed_sum] = STATE(2390),
    [sym__atype] = STATE(2390),
    [sym_type_apply] = STATE(8252),
    [sym__btype] = STATE(8252),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(13247),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2678),
    [sym__type_quantifiers] = STATE(15497),
    [sym__type_context] = STATE(15497),
    [sym__type_fun] = STATE(15497),
    [sym__type] = STATE(15497),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17568),
    [sym_splice] = STATE(2390),
    [sym_quasiquote] = STATE(2390),
    [sym__varid] = ACTIONS(7037),
    [sym_float] = ACTIONS(7039),
    [sym_char] = ACTIONS(7039),
    [sym_string] = ACTIONS(7039),
    [sym__integer_literal] = ACTIONS(7041),
    [sym__binary_literal] = ACTIONS(7043),
    [sym__octal_literal] = ACTIONS(7043),
    [sym__hex_literal] = ACTIONS(7043),
    [anon_sym_LPAREN_POUND] = ACTIONS(7045),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7045),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7779),
    [sym__conid] = ACTIONS(7783),
    [anon_sym_LBRACK] = ACTIONS(7052),
    [anon_sym_SQUOTE] = ACTIONS(7785),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7057),
    [anon_sym_u2605] = ACTIONS(7057),
    [anon_sym_u27e6] = ACTIONS(7061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7063),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7065),
  },
  [2686] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(16762),
    [sym__type_context] = STATE(16762),
    [sym__type_fun] = STATE(16762),
    [sym__type] = STATE(16762),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2687] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2417),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16106),
    [sym_type_parens] = STATE(2417),
    [sym_type_list] = STATE(2417),
    [sym_type_tuple] = STATE(2417),
    [sym__type_promotable_literal] = STATE(2417),
    [sym__type_promoted_literal] = STATE(2417),
    [sym__type_literal] = STATE(2417),
    [sym_type_name] = STATE(2439),
    [sym_type_star] = STATE(2417),
    [sym_type_unboxed_tuple] = STATE(2417),
    [sym_type_unboxed_sum] = STATE(2417),
    [sym__atype] = STATE(2417),
    [sym_type_apply] = STATE(8304),
    [sym__btype] = STATE(8304),
    [sym_type_infix] = STATE(11020),
    [sym__type_infix] = STATE(10890),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2692),
    [sym__type_quantifiers] = STATE(13423),
    [sym__type_context] = STATE(13423),
    [sym__type_fun] = STATE(13423),
    [sym__type] = STATE(13423),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2417),
    [sym_quasiquote] = STATE(2417),
    [sym__varid] = ACTIONS(7895),
    [sym_float] = ACTIONS(7339),
    [sym_char] = ACTIONS(7339),
    [sym_string] = ACTIONS(7339),
    [sym__integer_literal] = ACTIONS(7341),
    [sym__binary_literal] = ACTIONS(7343),
    [sym__octal_literal] = ACTIONS(7343),
    [sym__hex_literal] = ACTIONS(7343),
    [anon_sym_LPAREN_POUND] = ACTIONS(7345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7345),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7897),
    [sym__conid] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7352),
    [anon_sym_SQUOTE] = ACTIONS(7903),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7357),
    [anon_sym_u2605] = ACTIONS(7357),
    [anon_sym_u27e6] = ACTIONS(7361),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7363),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7365),
  },
  [2688] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2417),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16106),
    [sym_type_parens] = STATE(2417),
    [sym_type_list] = STATE(2417),
    [sym_type_tuple] = STATE(2417),
    [sym__type_promotable_literal] = STATE(2417),
    [sym__type_promoted_literal] = STATE(2417),
    [sym__type_literal] = STATE(2417),
    [sym_type_name] = STATE(2439),
    [sym_type_star] = STATE(2417),
    [sym_type_unboxed_tuple] = STATE(2417),
    [sym_type_unboxed_sum] = STATE(2417),
    [sym__atype] = STATE(2417),
    [sym_type_apply] = STATE(8304),
    [sym__btype] = STATE(8304),
    [sym_type_infix] = STATE(11020),
    [sym__type_infix] = STATE(10890),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2692),
    [sym__type_quantifiers] = STATE(13416),
    [sym__type_context] = STATE(13416),
    [sym__type_fun] = STATE(13416),
    [sym__type] = STATE(13416),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2417),
    [sym_quasiquote] = STATE(2417),
    [sym__varid] = ACTIONS(7895),
    [sym_float] = ACTIONS(7339),
    [sym_char] = ACTIONS(7339),
    [sym_string] = ACTIONS(7339),
    [sym__integer_literal] = ACTIONS(7341),
    [sym__binary_literal] = ACTIONS(7343),
    [sym__octal_literal] = ACTIONS(7343),
    [sym__hex_literal] = ACTIONS(7343),
    [anon_sym_LPAREN_POUND] = ACTIONS(7345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7345),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7897),
    [sym__conid] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7352),
    [anon_sym_SQUOTE] = ACTIONS(7903),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7357),
    [anon_sym_u2605] = ACTIONS(7357),
    [anon_sym_u27e6] = ACTIONS(7361),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7363),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7365),
  },
  [2689] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(17217),
    [sym__type_context] = STATE(17217),
    [sym__type_fun] = STATE(17217),
    [sym__type] = STATE(17217),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2690] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(17213),
    [sym__type_context] = STATE(17213),
    [sym__type_fun] = STATE(17213),
    [sym__type] = STATE(17213),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2691] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2596),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym_type_parens] = STATE(2596),
    [sym_type_list] = STATE(2596),
    [sym_type_tuple] = STATE(2596),
    [sym__type_promotable_literal] = STATE(2596),
    [sym__type_promoted_literal] = STATE(2596),
    [sym__type_literal] = STATE(2596),
    [sym_type_name] = STATE(2596),
    [sym_type_star] = STATE(2596),
    [sym_type_unboxed_tuple] = STATE(2596),
    [sym_type_unboxed_sum] = STATE(2596),
    [sym__atype] = STATE(2596),
    [sym_type_invisible] = STATE(2596),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2596),
    [sym_quasiquote] = STATE(2596),
    [aux_sym_type_apply_repeat1] = STATE(2596),
    [sym__varid] = ACTIONS(10507),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [anon_sym_u2237] = ACTIONS(5451),
    [anon_sym_COLON_COLON] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10509),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10511),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(10514),
    [anon_sym_PIPE] = ACTIONS(5451),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_AT] = ACTIONS(10517),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
    [sym__unboxed_close] = ACTIONS(5451),
  },
  [2692] = {
    [sym_integer] = STATE(6773),
    [sym__literal] = STATE(6773),
    [sym__unboxed_open] = STATE(2062),
    [sym_constructor] = STATE(6304),
    [sym_con_unit] = STATE(6773),
    [sym_con_list] = STATE(6773),
    [sym_con_tuple] = STATE(6773),
    [sym_qualified_type] = STATE(6770),
    [sym_tycon_arrow] = STATE(6770),
    [sym_type_literal] = STATE(2417),
    [sym__promoted_tycon] = STATE(6770),
    [sym_type_variable] = STATE(6770),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16106),
    [sym_type_parens] = STATE(2417),
    [sym_type_list] = STATE(2417),
    [sym_type_tuple] = STATE(2417),
    [sym__type_promotable_literal] = STATE(2417),
    [sym__type_promoted_literal] = STATE(2417),
    [sym__type_literal] = STATE(2417),
    [sym_type_name] = STATE(2439),
    [sym_type_star] = STATE(2417),
    [sym_type_unboxed_tuple] = STATE(2417),
    [sym_type_unboxed_sum] = STATE(2417),
    [sym__atype] = STATE(2417),
    [sym_type_apply] = STATE(8304),
    [sym__btype] = STATE(8304),
    [sym_type_infix] = STATE(11020),
    [sym__type_infix] = STATE(10890),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2692),
    [sym__type_quantifiers] = STATE(13365),
    [sym__type_context] = STATE(13365),
    [sym__type_fun] = STATE(13365),
    [sym__type] = STATE(13365),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17711),
    [sym_splice] = STATE(2417),
    [sym_quasiquote] = STATE(2417),
    [sym__varid] = ACTIONS(7895),
    [sym_float] = ACTIONS(7339),
    [sym_char] = ACTIONS(7339),
    [sym_string] = ACTIONS(7339),
    [sym__integer_literal] = ACTIONS(7341),
    [sym__binary_literal] = ACTIONS(7343),
    [sym__octal_literal] = ACTIONS(7343),
    [sym__hex_literal] = ACTIONS(7343),
    [anon_sym_LPAREN_POUND] = ACTIONS(7345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7345),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7897),
    [sym__conid] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7352),
    [anon_sym_SQUOTE] = ACTIONS(7903),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7357),
    [anon_sym_u2605] = ACTIONS(7357),
    [anon_sym_u27e6] = ACTIONS(7361),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7363),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7365),
  },
  [2693] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2405),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15976),
    [sym_type_parens] = STATE(2405),
    [sym_type_list] = STATE(2405),
    [sym_type_tuple] = STATE(2405),
    [sym__type_promotable_literal] = STATE(2405),
    [sym__type_promoted_literal] = STATE(2405),
    [sym__type_literal] = STATE(2405),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2405),
    [sym_type_unboxed_tuple] = STATE(2405),
    [sym_type_unboxed_sum] = STATE(2405),
    [sym__atype] = STATE(2405),
    [sym_type_apply] = STATE(8249),
    [sym__btype] = STATE(8249),
    [sym_type_infix] = STATE(11107),
    [sym__type_infix] = STATE(10894),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2693),
    [sym__type_quantifiers] = STATE(13472),
    [sym__type_context] = STATE(13472),
    [sym__type_fun] = STATE(13472),
    [sym__type] = STATE(13472),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2405),
    [sym_quasiquote] = STATE(2405),
    [sym__varid] = ACTIONS(7905),
    [sym_float] = ACTIONS(7309),
    [sym_char] = ACTIONS(7309),
    [sym_string] = ACTIONS(7309),
    [sym__integer_literal] = ACTIONS(7311),
    [sym__binary_literal] = ACTIONS(7313),
    [sym__octal_literal] = ACTIONS(7313),
    [sym__hex_literal] = ACTIONS(7313),
    [anon_sym_LPAREN_POUND] = ACTIONS(7315),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7315),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7907),
    [sym__conid] = ACTIONS(7911),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7913),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7327),
    [anon_sym_u2605] = ACTIONS(7327),
    [anon_sym_u27e6] = ACTIONS(7331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7333),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7335),
  },
  [2694] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2733),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15814),
    [sym_type_parens] = STATE(2733),
    [sym_type_list] = STATE(2733),
    [sym_type_tuple] = STATE(2733),
    [sym__type_promotable_literal] = STATE(2733),
    [sym__type_promoted_literal] = STATE(2733),
    [sym__type_literal] = STATE(2733),
    [sym_type_name] = STATE(2762),
    [sym_type_star] = STATE(2733),
    [sym_type_unboxed_tuple] = STATE(2733),
    [sym_type_unboxed_sum] = STATE(2733),
    [sym__atype] = STATE(2733),
    [sym_type_apply] = STATE(9154),
    [sym__btype] = STATE(9154),
    [sym_type_infix] = STATE(14049),
    [sym__type_infix] = STATE(13619),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2694),
    [sym__type_quantifiers] = STATE(17152),
    [sym__type_context] = STATE(17152),
    [sym__type_fun] = STATE(17152),
    [sym__type] = STATE(17152),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2733),
    [sym_quasiquote] = STATE(2733),
    [sym__varid] = ACTIONS(6236),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6246),
    [sym__conid] = ACTIONS(6248),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6252),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2695] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2405),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15976),
    [sym_type_parens] = STATE(2405),
    [sym_type_list] = STATE(2405),
    [sym_type_tuple] = STATE(2405),
    [sym__type_promotable_literal] = STATE(2405),
    [sym__type_promoted_literal] = STATE(2405),
    [sym__type_literal] = STATE(2405),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2405),
    [sym_type_unboxed_tuple] = STATE(2405),
    [sym_type_unboxed_sum] = STATE(2405),
    [sym__atype] = STATE(2405),
    [sym_type_apply] = STATE(8249),
    [sym__btype] = STATE(8249),
    [sym_type_infix] = STATE(11107),
    [sym__type_infix] = STATE(10894),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2693),
    [sym__type_quantifiers] = STATE(13488),
    [sym__type_context] = STATE(13488),
    [sym__type_fun] = STATE(13488),
    [sym__type] = STATE(13488),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2405),
    [sym_quasiquote] = STATE(2405),
    [sym__varid] = ACTIONS(7905),
    [sym_float] = ACTIONS(7309),
    [sym_char] = ACTIONS(7309),
    [sym_string] = ACTIONS(7309),
    [sym__integer_literal] = ACTIONS(7311),
    [sym__binary_literal] = ACTIONS(7313),
    [sym__octal_literal] = ACTIONS(7313),
    [sym__hex_literal] = ACTIONS(7313),
    [anon_sym_LPAREN_POUND] = ACTIONS(7315),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7315),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7907),
    [sym__conid] = ACTIONS(7911),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7913),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7327),
    [anon_sym_u2605] = ACTIONS(7327),
    [anon_sym_u27e6] = ACTIONS(7331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7333),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7335),
  },
  [2696] = {
    [sym_integer] = STATE(7007),
    [sym__literal] = STATE(7007),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(6439),
    [sym_con_unit] = STATE(7007),
    [sym_con_list] = STATE(7007),
    [sym_con_tuple] = STATE(7007),
    [sym_qualified_type] = STATE(6930),
    [sym_tycon_arrow] = STATE(6930),
    [sym_type_literal] = STATE(2405),
    [sym__promoted_tycon] = STATE(6930),
    [sym_type_variable] = STATE(6930),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15976),
    [sym_type_parens] = STATE(2405),
    [sym_type_list] = STATE(2405),
    [sym_type_tuple] = STATE(2405),
    [sym__type_promotable_literal] = STATE(2405),
    [sym__type_promoted_literal] = STATE(2405),
    [sym__type_literal] = STATE(2405),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2405),
    [sym_type_unboxed_tuple] = STATE(2405),
    [sym_type_unboxed_sum] = STATE(2405),
    [sym__atype] = STATE(2405),
    [sym_type_apply] = STATE(8249),
    [sym__btype] = STATE(8249),
    [sym_type_infix] = STATE(11107),
    [sym__type_infix] = STATE(10894),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2693),
    [sym__type_quantifiers] = STATE(13485),
    [sym__type_context] = STATE(13485),
    [sym__type_fun] = STATE(13485),
    [sym__type] = STATE(13485),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17378),
    [sym_splice] = STATE(2405),
    [sym_quasiquote] = STATE(2405),
    [sym__varid] = ACTIONS(7905),
    [sym_float] = ACTIONS(7309),
    [sym_char] = ACTIONS(7309),
    [sym_string] = ACTIONS(7309),
    [sym__integer_literal] = ACTIONS(7311),
    [sym__binary_literal] = ACTIONS(7313),
    [sym__octal_literal] = ACTIONS(7313),
    [sym__hex_literal] = ACTIONS(7313),
    [anon_sym_LPAREN_POUND] = ACTIONS(7315),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7315),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7907),
    [sym__conid] = ACTIONS(7911),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7913),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7327),
    [anon_sym_u2605] = ACTIONS(7327),
    [anon_sym_u27e6] = ACTIONS(7331),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7333),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7335),
  },
  [2697] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2234),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16137),
    [sym_type_parens] = STATE(2234),
    [sym_type_list] = STATE(2234),
    [sym_type_tuple] = STATE(2234),
    [sym__type_promotable_literal] = STATE(2234),
    [sym__type_promoted_literal] = STATE(2234),
    [sym__type_literal] = STATE(2234),
    [sym_type_name] = STATE(2414),
    [sym_type_star] = STATE(2234),
    [sym_type_unboxed_tuple] = STATE(2234),
    [sym_type_unboxed_sum] = STATE(2234),
    [sym__atype] = STATE(2234),
    [sym_type_apply] = STATE(8214),
    [sym__btype] = STATE(8214),
    [sym_type_infix] = STATE(10797),
    [sym__type_infix] = STATE(10707),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2700),
    [sym__type_quantifiers] = STATE(12784),
    [sym__type_context] = STATE(12784),
    [sym__type_fun] = STATE(12784),
    [sym__type] = STATE(12784),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2234),
    [sym_quasiquote] = STATE(2234),
    [sym__varid] = ACTIONS(6346),
    [sym_float] = ACTIONS(6348),
    [sym_char] = ACTIONS(6348),
    [sym_string] = ACTIONS(6348),
    [sym__integer_literal] = ACTIONS(6350),
    [sym__binary_literal] = ACTIONS(6352),
    [sym__octal_literal] = ACTIONS(6352),
    [sym__hex_literal] = ACTIONS(6352),
    [anon_sym_LPAREN_POUND] = ACTIONS(6354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6354),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8289),
    [sym__conid] = ACTIONS(8293),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_SQUOTE] = ACTIONS(8295),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_u2605] = ACTIONS(6366),
    [anon_sym_u27e6] = ACTIONS(6370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6374),
  },
  [2698] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2234),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16137),
    [sym_type_parens] = STATE(2234),
    [sym_type_list] = STATE(2234),
    [sym_type_tuple] = STATE(2234),
    [sym__type_promotable_literal] = STATE(2234),
    [sym__type_promoted_literal] = STATE(2234),
    [sym__type_literal] = STATE(2234),
    [sym_type_name] = STATE(2414),
    [sym_type_star] = STATE(2234),
    [sym_type_unboxed_tuple] = STATE(2234),
    [sym_type_unboxed_sum] = STATE(2234),
    [sym__atype] = STATE(2234),
    [sym_type_apply] = STATE(8214),
    [sym__btype] = STATE(8214),
    [sym_type_infix] = STATE(10797),
    [sym__type_infix] = STATE(10707),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2700),
    [sym__type_quantifiers] = STATE(12777),
    [sym__type_context] = STATE(12777),
    [sym__type_fun] = STATE(12777),
    [sym__type] = STATE(12777),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2234),
    [sym_quasiquote] = STATE(2234),
    [sym__varid] = ACTIONS(6346),
    [sym_float] = ACTIONS(6348),
    [sym_char] = ACTIONS(6348),
    [sym_string] = ACTIONS(6348),
    [sym__integer_literal] = ACTIONS(6350),
    [sym__binary_literal] = ACTIONS(6352),
    [sym__octal_literal] = ACTIONS(6352),
    [sym__hex_literal] = ACTIONS(6352),
    [anon_sym_LPAREN_POUND] = ACTIONS(6354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6354),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8289),
    [sym__conid] = ACTIONS(8293),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_SQUOTE] = ACTIONS(8295),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_u2605] = ACTIONS(6366),
    [anon_sym_u27e6] = ACTIONS(6370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6374),
  },
  [2699] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14876),
    [sym__type_context] = STATE(14876),
    [sym__type_fun] = STATE(14876),
    [sym__type] = STATE(14876),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
  },
  [2700] = {
    [sym_integer] = STATE(6530),
    [sym__literal] = STATE(6530),
    [sym__unboxed_open] = STATE(2206),
    [sym_constructor] = STATE(6021),
    [sym_con_unit] = STATE(6530),
    [sym_con_list] = STATE(6530),
    [sym_con_tuple] = STATE(6530),
    [sym_qualified_type] = STATE(6534),
    [sym_tycon_arrow] = STATE(6534),
    [sym_type_literal] = STATE(2234),
    [sym__promoted_tycon] = STATE(6534),
    [sym_type_variable] = STATE(6534),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16137),
    [sym_type_parens] = STATE(2234),
    [sym_type_list] = STATE(2234),
    [sym_type_tuple] = STATE(2234),
    [sym__type_promotable_literal] = STATE(2234),
    [sym__type_promoted_literal] = STATE(2234),
    [sym__type_literal] = STATE(2234),
    [sym_type_name] = STATE(2414),
    [sym_type_star] = STATE(2234),
    [sym_type_unboxed_tuple] = STATE(2234),
    [sym_type_unboxed_sum] = STATE(2234),
    [sym__atype] = STATE(2234),
    [sym_type_apply] = STATE(8214),
    [sym__btype] = STATE(8214),
    [sym_type_infix] = STATE(10797),
    [sym__type_infix] = STATE(10707),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2700),
    [sym__type_quantifiers] = STATE(12888),
    [sym__type_context] = STATE(12888),
    [sym__type_fun] = STATE(12888),
    [sym__type] = STATE(12888),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17709),
    [sym_splice] = STATE(2234),
    [sym_quasiquote] = STATE(2234),
    [sym__varid] = ACTIONS(6346),
    [sym_float] = ACTIONS(6348),
    [sym_char] = ACTIONS(6348),
    [sym_string] = ACTIONS(6348),
    [sym__integer_literal] = ACTIONS(6350),
    [sym__binary_literal] = ACTIONS(6352),
    [sym__octal_literal] = ACTIONS(6352),
    [sym__hex_literal] = ACTIONS(6352),
    [anon_sym_LPAREN_POUND] = ACTIONS(6354),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6354),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8289),
    [sym__conid] = ACTIONS(8293),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_SQUOTE] = ACTIONS(8295),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_u2605] = ACTIONS(6366),
    [anon_sym_u27e6] = ACTIONS(6370),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6374),
  },
  [2701] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2389),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15985),
    [sym_type_parens] = STATE(2389),
    [sym_type_list] = STATE(2389),
    [sym_type_tuple] = STATE(2389),
    [sym__type_promotable_literal] = STATE(2389),
    [sym__type_promoted_literal] = STATE(2389),
    [sym__type_literal] = STATE(2389),
    [sym_type_name] = STATE(2458),
    [sym_type_star] = STATE(2389),
    [sym_type_unboxed_tuple] = STATE(2389),
    [sym_type_unboxed_sum] = STATE(2389),
    [sym__atype] = STATE(2389),
    [sym_type_apply] = STATE(8266),
    [sym__btype] = STATE(8266),
    [sym_type_infix] = STATE(12156),
    [sym__type_infix] = STATE(13219),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2701),
    [sym__type_quantifiers] = STATE(15521),
    [sym__type_context] = STATE(15521),
    [sym__type_fun] = STATE(15521),
    [sym__type] = STATE(15521),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2389),
    [sym_quasiquote] = STATE(2389),
    [sym__varid] = ACTIONS(7007),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8243),
    [sym__conid] = ACTIONS(8247),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(8249),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2702] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2389),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15985),
    [sym_type_parens] = STATE(2389),
    [sym_type_list] = STATE(2389),
    [sym_type_tuple] = STATE(2389),
    [sym__type_promotable_literal] = STATE(2389),
    [sym__type_promoted_literal] = STATE(2389),
    [sym__type_literal] = STATE(2389),
    [sym_type_name] = STATE(2458),
    [sym_type_star] = STATE(2389),
    [sym_type_unboxed_tuple] = STATE(2389),
    [sym_type_unboxed_sum] = STATE(2389),
    [sym__atype] = STATE(2389),
    [sym_type_apply] = STATE(8266),
    [sym__btype] = STATE(8266),
    [sym_type_infix] = STATE(12156),
    [sym__type_infix] = STATE(13219),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2701),
    [sym__type_quantifiers] = STATE(15338),
    [sym__type_context] = STATE(15338),
    [sym__type_fun] = STATE(15338),
    [sym__type] = STATE(15338),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2389),
    [sym_quasiquote] = STATE(2389),
    [sym__varid] = ACTIONS(7007),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8243),
    [sym__conid] = ACTIONS(8247),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(8249),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2703] = {
    [sym_integer] = STATE(6886),
    [sym__literal] = STATE(6886),
    [sym__unboxed_open] = STATE(2085),
    [sym_constructor] = STATE(6430),
    [sym_con_unit] = STATE(6886),
    [sym_con_list] = STATE(6886),
    [sym_con_tuple] = STATE(6886),
    [sym_qualified_type] = STATE(6884),
    [sym_tycon_arrow] = STATE(6884),
    [sym_type_literal] = STATE(2389),
    [sym__promoted_tycon] = STATE(6884),
    [sym_type_variable] = STATE(6884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15985),
    [sym_type_parens] = STATE(2389),
    [sym_type_list] = STATE(2389),
    [sym_type_tuple] = STATE(2389),
    [sym__type_promotable_literal] = STATE(2389),
    [sym__type_promoted_literal] = STATE(2389),
    [sym__type_literal] = STATE(2389),
    [sym_type_name] = STATE(2458),
    [sym_type_star] = STATE(2389),
    [sym_type_unboxed_tuple] = STATE(2389),
    [sym_type_unboxed_sum] = STATE(2389),
    [sym__atype] = STATE(2389),
    [sym_type_apply] = STATE(8266),
    [sym__btype] = STATE(8266),
    [sym_type_infix] = STATE(12156),
    [sym__type_infix] = STATE(13219),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2701),
    [sym__type_quantifiers] = STATE(15283),
    [sym__type_context] = STATE(15283),
    [sym__type_fun] = STATE(15283),
    [sym__type] = STATE(15283),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16646),
    [sym_splice] = STATE(2389),
    [sym_quasiquote] = STATE(2389),
    [sym__varid] = ACTIONS(7007),
    [sym_float] = ACTIONS(7009),
    [sym_char] = ACTIONS(7009),
    [sym_string] = ACTIONS(7009),
    [sym__integer_literal] = ACTIONS(7011),
    [sym__binary_literal] = ACTIONS(7013),
    [sym__octal_literal] = ACTIONS(7013),
    [sym__hex_literal] = ACTIONS(7013),
    [anon_sym_LPAREN_POUND] = ACTIONS(7015),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7015),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8243),
    [sym__conid] = ACTIONS(8247),
    [anon_sym_LBRACK] = ACTIONS(7022),
    [anon_sym_SQUOTE] = ACTIONS(8249),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_u2605] = ACTIONS(7027),
    [anon_sym_u27e6] = ACTIONS(7031),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7033),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7035),
  },
  [2704] = {
    [sym_integer] = STATE(7119),
    [sym__literal] = STATE(7119),
    [sym__unboxed_open] = STATE(2204),
    [sym_constructor] = STATE(7002),
    [sym_con_unit] = STATE(7119),
    [sym_con_list] = STATE(7119),
    [sym_con_tuple] = STATE(7119),
    [sym_qualified_type] = STATE(7050),
    [sym_tycon_arrow] = STATE(7050),
    [sym_type_literal] = STATE(2504),
    [sym__promoted_tycon] = STATE(7050),
    [sym_type_variable] = STATE(7050),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15953),
    [sym_forall] = STATE(3188),
    [sym_type_parens] = STATE(2504),
    [sym_type_list] = STATE(2504),
    [sym_type_tuple] = STATE(2504),
    [sym__type_promotable_literal] = STATE(2504),
    [sym__type_promoted_literal] = STATE(2504),
    [sym__type_literal] = STATE(2504),
    [sym_type_name] = STATE(2522),
    [sym_type_star] = STATE(2504),
    [sym_type_unboxed_tuple] = STATE(2504),
    [sym_type_unboxed_sum] = STATE(2504),
    [sym__atype] = STATE(2504),
    [sym_type_apply] = STATE(8442),
    [sym__btype] = STATE(8442),
    [sym_type_infix] = STATE(12864),
    [sym__type_infix] = STATE(14311),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(10676),
    [sym_context] = STATE(3574),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17717),
    [sym__datainst] = STATE(14903),
    [sym_splice] = STATE(2504),
    [sym_quasiquote] = STATE(2504),
    [sym__varid] = ACTIONS(8077),
    [sym_float] = ACTIONS(8079),
    [sym_char] = ACTIONS(8079),
    [sym_string] = ACTIONS(8079),
    [sym__integer_literal] = ACTIONS(8081),
    [sym__binary_literal] = ACTIONS(8083),
    [sym__octal_literal] = ACTIONS(8083),
    [sym__hex_literal] = ACTIONS(8083),
    [anon_sym_LPAREN_POUND] = ACTIONS(8085),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8085),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8832),
    [sym__conid] = ACTIONS(8836),
    [anon_sym_LBRACK] = ACTIONS(8092),
    [anon_sym_SQUOTE] = ACTIONS(8838),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8097),
    [anon_sym_u2605] = ACTIONS(8097),
    [anon_sym_instance] = ACTIONS(10519),
    [anon_sym_u27e6] = ACTIONS(8101),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8103),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8105),
  },
  [2705] = {
    [sym_integer] = STATE(8053),
    [sym__literal] = STATE(8053),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7638),
    [sym_con_unit] = STATE(8053),
    [sym_con_list] = STATE(8053),
    [sym_con_tuple] = STATE(8053),
    [sym_qualified_type] = STATE(8165),
    [sym_tycon_arrow] = STATE(8165),
    [sym_type_literal] = STATE(2691),
    [sym__promoted_tycon] = STATE(8165),
    [sym_type_variable] = STATE(8165),
    [sym_type_parens] = STATE(2691),
    [sym_type_list] = STATE(2691),
    [sym_type_tuple] = STATE(2691),
    [sym__type_promotable_literal] = STATE(2691),
    [sym__type_promoted_literal] = STATE(2691),
    [sym__type_literal] = STATE(2691),
    [sym_type_name] = STATE(2691),
    [sym_type_star] = STATE(2691),
    [sym_type_unboxed_tuple] = STATE(2691),
    [sym_type_unboxed_sum] = STATE(2691),
    [sym__atype] = STATE(2691),
    [sym_type_invisible] = STATE(2691),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17453),
    [sym_splice] = STATE(2691),
    [sym_quasiquote] = STATE(2691),
    [aux_sym_type_apply_repeat1] = STATE(2691),
    [sym__varid] = ACTIONS(10507),
    [sym_float] = ACTIONS(6208),
    [sym_char] = ACTIONS(6208),
    [sym_string] = ACTIONS(6208),
    [sym__integer_literal] = ACTIONS(6210),
    [sym__binary_literal] = ACTIONS(6212),
    [sym__octal_literal] = ACTIONS(6212),
    [sym__hex_literal] = ACTIONS(6212),
    [anon_sym_LPAREN_POUND] = ACTIONS(6214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6214),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [anon_sym_u2237] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10509),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10521),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(10524),
    [anon_sym_PIPE] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_u2605] = ACTIONS(6228),
    [anon_sym_AT] = ACTIONS(10517),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_u27e6] = ACTIONS(6230),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6232),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6234),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2706] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2638),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym_type_parens] = STATE(2638),
    [sym_type_list] = STATE(2638),
    [sym_type_tuple] = STATE(2638),
    [sym__type_promotable_literal] = STATE(2638),
    [sym__type_promoted_literal] = STATE(2638),
    [sym__type_literal] = STATE(2638),
    [sym_type_name] = STATE(2638),
    [sym_type_star] = STATE(2638),
    [sym_type_unboxed_tuple] = STATE(2638),
    [sym_type_unboxed_sum] = STATE(2638),
    [sym__atype] = STATE(2638),
    [sym_type_invisible] = STATE(2638),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2638),
    [sym_quasiquote] = STATE(2638),
    [aux_sym_type_apply_repeat1] = STATE(2638),
    [sym__varid] = ACTIONS(6236),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u2192] = ACTIONS(5451),
    [anon_sym_DASH_GT] = ACTIONS(5451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10527),
    [anon_sym_BQUOTE] = ACTIONS(5451),
    [sym__conid] = ACTIONS(10529),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(10532),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_AT] = ACTIONS(10535),
    [anon_sym_PERCENT] = ACTIONS(5451),
    [anon_sym_deriving] = ACTIONS(5475),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5451),
    [sym__layout_end] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym__consym] = ACTIONS(5451),
    [sym__tyconsym] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2707] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2401),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16139),
    [sym_type_parens] = STATE(2401),
    [sym_type_list] = STATE(2401),
    [sym_type_tuple] = STATE(2401),
    [sym__type_promotable_literal] = STATE(2401),
    [sym__type_promoted_literal] = STATE(2401),
    [sym__type_literal] = STATE(2401),
    [sym_type_name] = STATE(2432),
    [sym_type_star] = STATE(2401),
    [sym_type_unboxed_tuple] = STATE(2401),
    [sym_type_unboxed_sum] = STATE(2401),
    [sym__atype] = STATE(2401),
    [sym_type_apply] = STATE(8298),
    [sym__btype] = STATE(8298),
    [sym_type_infix] = STATE(10960),
    [sym__type_infix] = STATE(10814),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2715),
    [sym__type_quantifiers] = STATE(13440),
    [sym__type_context] = STATE(13440),
    [sym__type_fun] = STATE(13440),
    [sym__type] = STATE(13440),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2401),
    [sym_quasiquote] = STATE(2401),
    [sym__varid] = ACTIONS(8670),
    [sym_float] = ACTIONS(6949),
    [sym_char] = ACTIONS(6949),
    [sym_string] = ACTIONS(6949),
    [sym__integer_literal] = ACTIONS(6951),
    [sym__binary_literal] = ACTIONS(6953),
    [sym__octal_literal] = ACTIONS(6953),
    [sym__hex_literal] = ACTIONS(6953),
    [anon_sym_LPAREN_POUND] = ACTIONS(6955),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6955),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8672),
    [sym__conid] = ACTIONS(8676),
    [anon_sym_LBRACK] = ACTIONS(6962),
    [anon_sym_SQUOTE] = ACTIONS(8678),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6967),
    [anon_sym_u2605] = ACTIONS(6967),
    [anon_sym_u27e6] = ACTIONS(6971),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6973),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6975),
  },
  [2708] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2401),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16139),
    [sym_type_parens] = STATE(2401),
    [sym_type_list] = STATE(2401),
    [sym_type_tuple] = STATE(2401),
    [sym__type_promotable_literal] = STATE(2401),
    [sym__type_promoted_literal] = STATE(2401),
    [sym__type_literal] = STATE(2401),
    [sym_type_name] = STATE(2432),
    [sym_type_star] = STATE(2401),
    [sym_type_unboxed_tuple] = STATE(2401),
    [sym_type_unboxed_sum] = STATE(2401),
    [sym__atype] = STATE(2401),
    [sym_type_apply] = STATE(8298),
    [sym__btype] = STATE(8298),
    [sym_type_infix] = STATE(10960),
    [sym__type_infix] = STATE(10814),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2715),
    [sym__type_quantifiers] = STATE(13443),
    [sym__type_context] = STATE(13443),
    [sym__type_fun] = STATE(13443),
    [sym__type] = STATE(13443),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2401),
    [sym_quasiquote] = STATE(2401),
    [sym__varid] = ACTIONS(8670),
    [sym_float] = ACTIONS(6949),
    [sym_char] = ACTIONS(6949),
    [sym_string] = ACTIONS(6949),
    [sym__integer_literal] = ACTIONS(6951),
    [sym__binary_literal] = ACTIONS(6953),
    [sym__octal_literal] = ACTIONS(6953),
    [sym__hex_literal] = ACTIONS(6953),
    [anon_sym_LPAREN_POUND] = ACTIONS(6955),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6955),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8672),
    [sym__conid] = ACTIONS(8676),
    [anon_sym_LBRACK] = ACTIONS(6962),
    [anon_sym_SQUOTE] = ACTIONS(8678),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6967),
    [anon_sym_u2605] = ACTIONS(6967),
    [anon_sym_u27e6] = ACTIONS(6971),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6973),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6975),
  },
  [2709] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2395),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15998),
    [sym_type_parens] = STATE(2395),
    [sym_type_list] = STATE(2395),
    [sym_type_tuple] = STATE(2395),
    [sym__type_promotable_literal] = STATE(2395),
    [sym__type_promoted_literal] = STATE(2395),
    [sym__type_literal] = STATE(2395),
    [sym_type_name] = STATE(2461),
    [sym_type_star] = STATE(2395),
    [sym_type_unboxed_tuple] = STATE(2395),
    [sym_type_unboxed_sum] = STATE(2395),
    [sym__atype] = STATE(2395),
    [sym_type_apply] = STATE(8269),
    [sym__btype] = STATE(8269),
    [sym_type_infix] = STATE(11067),
    [sym__type_infix] = STATE(10857),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2709),
    [sym__type_quantifiers] = STATE(13559),
    [sym__type_context] = STATE(13559),
    [sym__type_fun] = STATE(13559),
    [sym__type] = STATE(13559),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2395),
    [sym_quasiquote] = STATE(2395),
    [sym__varid] = ACTIONS(8654),
    [sym_float] = ACTIONS(7189),
    [sym_char] = ACTIONS(7189),
    [sym_string] = ACTIONS(7189),
    [sym__integer_literal] = ACTIONS(7191),
    [sym__binary_literal] = ACTIONS(7193),
    [sym__octal_literal] = ACTIONS(7193),
    [sym__hex_literal] = ACTIONS(7193),
    [anon_sym_LPAREN_POUND] = ACTIONS(7195),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7195),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8656),
    [sym__conid] = ACTIONS(8660),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_SQUOTE] = ACTIONS(8662),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_u2605] = ACTIONS(7207),
    [anon_sym_u27e6] = ACTIONS(7211),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7213),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7215),
  },
  [2710] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5573),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2711] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2395),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15998),
    [sym_type_parens] = STATE(2395),
    [sym_type_list] = STATE(2395),
    [sym_type_tuple] = STATE(2395),
    [sym__type_promotable_literal] = STATE(2395),
    [sym__type_promoted_literal] = STATE(2395),
    [sym__type_literal] = STATE(2395),
    [sym_type_name] = STATE(2461),
    [sym_type_star] = STATE(2395),
    [sym_type_unboxed_tuple] = STATE(2395),
    [sym_type_unboxed_sum] = STATE(2395),
    [sym__atype] = STATE(2395),
    [sym_type_apply] = STATE(8269),
    [sym__btype] = STATE(8269),
    [sym_type_infix] = STATE(11067),
    [sym__type_infix] = STATE(10857),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2709),
    [sym__type_quantifiers] = STATE(13496),
    [sym__type_context] = STATE(13496),
    [sym__type_fun] = STATE(13496),
    [sym__type] = STATE(13496),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2395),
    [sym_quasiquote] = STATE(2395),
    [sym__varid] = ACTIONS(8654),
    [sym_float] = ACTIONS(7189),
    [sym_char] = ACTIONS(7189),
    [sym_string] = ACTIONS(7189),
    [sym__integer_literal] = ACTIONS(7191),
    [sym__binary_literal] = ACTIONS(7193),
    [sym__octal_literal] = ACTIONS(7193),
    [sym__hex_literal] = ACTIONS(7193),
    [anon_sym_LPAREN_POUND] = ACTIONS(7195),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7195),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8656),
    [sym__conid] = ACTIONS(8660),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_SQUOTE] = ACTIONS(8662),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_u2605] = ACTIONS(7207),
    [anon_sym_u27e6] = ACTIONS(7211),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7213),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7215),
  },
  [2712] = {
    [sym_integer] = STATE(6961),
    [sym__literal] = STATE(6961),
    [sym__unboxed_open] = STATE(2094),
    [sym_constructor] = STATE(6426),
    [sym_con_unit] = STATE(6961),
    [sym_con_list] = STATE(6961),
    [sym_con_tuple] = STATE(6961),
    [sym_qualified_type] = STATE(6876),
    [sym_tycon_arrow] = STATE(6876),
    [sym_type_literal] = STATE(2395),
    [sym__promoted_tycon] = STATE(6876),
    [sym_type_variable] = STATE(6876),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15998),
    [sym_type_parens] = STATE(2395),
    [sym_type_list] = STATE(2395),
    [sym_type_tuple] = STATE(2395),
    [sym__type_promotable_literal] = STATE(2395),
    [sym__type_promoted_literal] = STATE(2395),
    [sym__type_literal] = STATE(2395),
    [sym_type_name] = STATE(2461),
    [sym_type_star] = STATE(2395),
    [sym_type_unboxed_tuple] = STATE(2395),
    [sym_type_unboxed_sum] = STATE(2395),
    [sym__atype] = STATE(2395),
    [sym_type_apply] = STATE(8269),
    [sym__btype] = STATE(8269),
    [sym_type_infix] = STATE(11067),
    [sym__type_infix] = STATE(10857),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2709),
    [sym__type_quantifiers] = STATE(13531),
    [sym__type_context] = STATE(13531),
    [sym__type_fun] = STATE(13531),
    [sym__type] = STATE(13531),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17409),
    [sym_splice] = STATE(2395),
    [sym_quasiquote] = STATE(2395),
    [sym__varid] = ACTIONS(8654),
    [sym_float] = ACTIONS(7189),
    [sym_char] = ACTIONS(7189),
    [sym_string] = ACTIONS(7189),
    [sym__integer_literal] = ACTIONS(7191),
    [sym__binary_literal] = ACTIONS(7193),
    [sym__octal_literal] = ACTIONS(7193),
    [sym__hex_literal] = ACTIONS(7193),
    [anon_sym_LPAREN_POUND] = ACTIONS(7195),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7195),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8656),
    [sym__conid] = ACTIONS(8660),
    [anon_sym_LBRACK] = ACTIONS(7202),
    [anon_sym_SQUOTE] = ACTIONS(8662),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_u2605] = ACTIONS(7207),
    [anon_sym_u27e6] = ACTIONS(7211),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7213),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7215),
  },
  [2713] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14653),
    [sym__type_context] = STATE(14653),
    [sym__type_fun] = STATE(14653),
    [sym__type] = STATE(14653),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
  },
  [2714] = {
    [sym_integer] = STATE(7799),
    [sym__literal] = STATE(7799),
    [sym__unboxed_open] = STATE(2142),
    [sym_constructor] = STATE(7530),
    [sym_con_unit] = STATE(7799),
    [sym_con_list] = STATE(7799),
    [sym_con_tuple] = STATE(7799),
    [sym_qualified_type] = STATE(7884),
    [sym_tycon_arrow] = STATE(7884),
    [sym_type_literal] = STATE(2561),
    [sym__promoted_tycon] = STATE(7884),
    [sym_type_variable] = STATE(7884),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15672),
    [sym_type_parens] = STATE(2561),
    [sym_type_list] = STATE(2561),
    [sym_type_tuple] = STATE(2561),
    [sym__type_promotable_literal] = STATE(2561),
    [sym__type_promoted_literal] = STATE(2561),
    [sym__type_literal] = STATE(2561),
    [sym_type_name] = STATE(2597),
    [sym_type_star] = STATE(2561),
    [sym_type_unboxed_tuple] = STATE(2561),
    [sym_type_unboxed_sum] = STATE(2561),
    [sym__atype] = STATE(2561),
    [sym_type_apply] = STATE(8768),
    [sym__btype] = STATE(8768),
    [sym_type_infix] = STATE(13865),
    [sym__type_infix] = STATE(13351),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2699),
    [sym__type_quantifiers] = STATE(14666),
    [sym__type_context] = STATE(14666),
    [sym__type_fun] = STATE(14666),
    [sym__type] = STATE(14666),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17716),
    [sym_splice] = STATE(2561),
    [sym_quasiquote] = STATE(2561),
    [sym__varid] = ACTIONS(5692),
    [sym_float] = ACTIONS(5694),
    [sym_char] = ACTIONS(5694),
    [sym_string] = ACTIONS(5694),
    [sym__integer_literal] = ACTIONS(5696),
    [sym__binary_literal] = ACTIONS(5698),
    [sym__octal_literal] = ACTIONS(5698),
    [sym__hex_literal] = ACTIONS(5698),
    [anon_sym_LPAREN_POUND] = ACTIONS(5700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5700),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5702),
    [sym__conid] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_SQUOTE] = ACTIONS(5710),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_u2605] = ACTIONS(5714),
    [anon_sym_u27e6] = ACTIONS(5716),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5720),
  },
  [2715] = {
    [sym_integer] = STATE(6848),
    [sym__literal] = STATE(6848),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6515),
    [sym_con_unit] = STATE(6848),
    [sym_con_list] = STATE(6848),
    [sym_con_tuple] = STATE(6848),
    [sym_qualified_type] = STATE(6843),
    [sym_tycon_arrow] = STATE(6843),
    [sym_type_literal] = STATE(2401),
    [sym__promoted_tycon] = STATE(6843),
    [sym_type_variable] = STATE(6843),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16139),
    [sym_type_parens] = STATE(2401),
    [sym_type_list] = STATE(2401),
    [sym_type_tuple] = STATE(2401),
    [sym__type_promotable_literal] = STATE(2401),
    [sym__type_promoted_literal] = STATE(2401),
    [sym__type_literal] = STATE(2401),
    [sym_type_name] = STATE(2432),
    [sym_type_star] = STATE(2401),
    [sym_type_unboxed_tuple] = STATE(2401),
    [sym_type_unboxed_sum] = STATE(2401),
    [sym__atype] = STATE(2401),
    [sym_type_apply] = STATE(8298),
    [sym__btype] = STATE(8298),
    [sym_type_infix] = STATE(10960),
    [sym__type_infix] = STATE(10814),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2715),
    [sym__type_quantifiers] = STATE(13480),
    [sym__type_context] = STATE(13480),
    [sym__type_fun] = STATE(13480),
    [sym__type] = STATE(13480),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17700),
    [sym_splice] = STATE(2401),
    [sym_quasiquote] = STATE(2401),
    [sym__varid] = ACTIONS(8670),
    [sym_float] = ACTIONS(6949),
    [sym_char] = ACTIONS(6949),
    [sym_string] = ACTIONS(6949),
    [sym__integer_literal] = ACTIONS(6951),
    [sym__binary_literal] = ACTIONS(6953),
    [sym__octal_literal] = ACTIONS(6953),
    [sym__hex_literal] = ACTIONS(6953),
    [anon_sym_LPAREN_POUND] = ACTIONS(6955),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6955),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8672),
    [sym__conid] = ACTIONS(8676),
    [anon_sym_LBRACK] = ACTIONS(6962),
    [anon_sym_SQUOTE] = ACTIONS(8678),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6967),
    [anon_sym_u2605] = ACTIONS(6967),
    [anon_sym_u27e6] = ACTIONS(6971),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6973),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6975),
  },
  [2716] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16031),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2710),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(8872),
    [sym__btype] = STATE(8872),
    [sym_type_infix] = STATE(13706),
    [sym__type_infix] = STATE(13428),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2716),
    [sym__type_quantifiers] = STATE(16037),
    [sym__type_context] = STATE(16037),
    [sym__type_fun] = STATE(16037),
    [sym__type] = STATE(16037),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(8484),
    [sym_float] = ACTIONS(8486),
    [sym_char] = ACTIONS(8486),
    [sym_string] = ACTIONS(8486),
    [sym__integer_literal] = ACTIONS(8488),
    [sym__binary_literal] = ACTIONS(8490),
    [sym__octal_literal] = ACTIONS(8490),
    [sym__hex_literal] = ACTIONS(8490),
    [anon_sym_LPAREN_POUND] = ACTIONS(8492),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8492),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8494),
    [sym__conid] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8504),
    [anon_sym_u2605] = ACTIONS(8504),
    [anon_sym_u27e6] = ACTIONS(8506),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8508),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8510),
  },
  [2717] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2604),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15898),
    [sym_type_parens] = STATE(2604),
    [sym_type_list] = STATE(2604),
    [sym_type_tuple] = STATE(2604),
    [sym__type_promotable_literal] = STATE(2604),
    [sym__type_promoted_literal] = STATE(2604),
    [sym__type_literal] = STATE(2604),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2604),
    [sym_type_unboxed_tuple] = STATE(2604),
    [sym_type_unboxed_sum] = STATE(2604),
    [sym__atype] = STATE(2604),
    [sym_type_apply] = STATE(8941),
    [sym__btype] = STATE(8941),
    [sym_type_infix] = STATE(14016),
    [sym__type_infix] = STATE(13635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2717),
    [sym__type_quantifiers] = STATE(16699),
    [sym__type_context] = STATE(16699),
    [sym__type_fun] = STATE(16699),
    [sym__type] = STATE(16699),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2604),
    [sym_quasiquote] = STATE(2604),
    [sym__varid] = ACTIONS(7415),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7425),
    [sym__conid] = ACTIONS(7429),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(7433),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7441),
  },
  [2718] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16031),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2710),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(8872),
    [sym__btype] = STATE(8872),
    [sym_type_infix] = STATE(13706),
    [sym__type_infix] = STATE(13428),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2716),
    [sym__type_quantifiers] = STATE(16146),
    [sym__type_context] = STATE(16146),
    [sym__type_fun] = STATE(16146),
    [sym__type] = STATE(16146),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(8484),
    [sym_float] = ACTIONS(8486),
    [sym_char] = ACTIONS(8486),
    [sym_string] = ACTIONS(8486),
    [sym__integer_literal] = ACTIONS(8488),
    [sym__binary_literal] = ACTIONS(8490),
    [sym__octal_literal] = ACTIONS(8490),
    [sym__hex_literal] = ACTIONS(8490),
    [anon_sym_LPAREN_POUND] = ACTIONS(8492),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8492),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8494),
    [sym__conid] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8504),
    [anon_sym_u2605] = ACTIONS(8504),
    [anon_sym_u27e6] = ACTIONS(8506),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8508),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8510),
  },
  [2719] = {
    [sym_integer] = STATE(7775),
    [sym__literal] = STATE(7775),
    [sym__unboxed_open] = STATE(2187),
    [sym_constructor] = STATE(7360),
    [sym_con_unit] = STATE(7775),
    [sym_con_list] = STATE(7775),
    [sym_con_tuple] = STATE(7775),
    [sym_qualified_type] = STATE(7844),
    [sym_tycon_arrow] = STATE(7844),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(7844),
    [sym_type_variable] = STATE(7844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16031),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2710),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(8872),
    [sym__btype] = STATE(8872),
    [sym_type_infix] = STATE(13706),
    [sym__type_infix] = STATE(13428),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2716),
    [sym__type_quantifiers] = STATE(16242),
    [sym__type_context] = STATE(16242),
    [sym__type_fun] = STATE(16242),
    [sym__type] = STATE(16242),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17439),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(8484),
    [sym_float] = ACTIONS(8486),
    [sym_char] = ACTIONS(8486),
    [sym_string] = ACTIONS(8486),
    [sym__integer_literal] = ACTIONS(8488),
    [sym__binary_literal] = ACTIONS(8490),
    [sym__octal_literal] = ACTIONS(8490),
    [sym__hex_literal] = ACTIONS(8490),
    [anon_sym_LPAREN_POUND] = ACTIONS(8492),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8492),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8494),
    [sym__conid] = ACTIONS(8498),
    [anon_sym_LBRACK] = ACTIONS(8500),
    [anon_sym_SQUOTE] = ACTIONS(8502),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8504),
    [anon_sym_u2605] = ACTIONS(8504),
    [anon_sym_u27e6] = ACTIONS(8506),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8508),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8510),
  },
  [2720] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2604),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15898),
    [sym_type_parens] = STATE(2604),
    [sym_type_list] = STATE(2604),
    [sym_type_tuple] = STATE(2604),
    [sym__type_promotable_literal] = STATE(2604),
    [sym__type_promoted_literal] = STATE(2604),
    [sym__type_literal] = STATE(2604),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2604),
    [sym_type_unboxed_tuple] = STATE(2604),
    [sym_type_unboxed_sum] = STATE(2604),
    [sym__atype] = STATE(2604),
    [sym_type_apply] = STATE(8941),
    [sym__btype] = STATE(8941),
    [sym_type_infix] = STATE(14016),
    [sym__type_infix] = STATE(13635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2717),
    [sym__type_quantifiers] = STATE(16627),
    [sym__type_context] = STATE(16627),
    [sym__type_fun] = STATE(16627),
    [sym__type] = STATE(16627),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2604),
    [sym_quasiquote] = STATE(2604),
    [sym__varid] = ACTIONS(7415),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7425),
    [sym__conid] = ACTIONS(7429),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(7433),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7441),
  },
  [2721] = {
    [sym_integer] = STATE(8073),
    [sym__literal] = STATE(8073),
    [sym__unboxed_open] = STATE(2146),
    [sym_constructor] = STATE(7599),
    [sym_con_unit] = STATE(8073),
    [sym_con_list] = STATE(8073),
    [sym_con_tuple] = STATE(8073),
    [sym_qualified_type] = STATE(8078),
    [sym_tycon_arrow] = STATE(8078),
    [sym_type_literal] = STATE(2604),
    [sym__promoted_tycon] = STATE(8078),
    [sym_type_variable] = STATE(8078),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15898),
    [sym_type_parens] = STATE(2604),
    [sym_type_list] = STATE(2604),
    [sym_type_tuple] = STATE(2604),
    [sym__type_promotable_literal] = STATE(2604),
    [sym__type_promoted_literal] = STATE(2604),
    [sym__type_literal] = STATE(2604),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2604),
    [sym_type_unboxed_tuple] = STATE(2604),
    [sym_type_unboxed_sum] = STATE(2604),
    [sym__atype] = STATE(2604),
    [sym_type_apply] = STATE(8941),
    [sym__btype] = STATE(8941),
    [sym_type_infix] = STATE(14016),
    [sym__type_infix] = STATE(13635),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2717),
    [sym__type_quantifiers] = STATE(16620),
    [sym__type_context] = STATE(16620),
    [sym__type_fun] = STATE(16620),
    [sym__type] = STATE(16620),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16252),
    [sym_splice] = STATE(2604),
    [sym_quasiquote] = STATE(2604),
    [sym__varid] = ACTIONS(7415),
    [sym_float] = ACTIONS(7417),
    [sym_char] = ACTIONS(7417),
    [sym_string] = ACTIONS(7417),
    [sym__integer_literal] = ACTIONS(7419),
    [sym__binary_literal] = ACTIONS(7421),
    [sym__octal_literal] = ACTIONS(7421),
    [sym__hex_literal] = ACTIONS(7421),
    [anon_sym_LPAREN_POUND] = ACTIONS(7423),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7423),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7425),
    [sym__conid] = ACTIONS(7429),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_SQUOTE] = ACTIONS(7433),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7435),
    [anon_sym_u2605] = ACTIONS(7435),
    [anon_sym_u27e6] = ACTIONS(7437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7441),
  },
  [2722] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2496),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15845),
    [sym_type_parens] = STATE(2496),
    [sym_type_list] = STATE(2496),
    [sym_type_tuple] = STATE(2496),
    [sym__type_promotable_literal] = STATE(2496),
    [sym__type_promoted_literal] = STATE(2496),
    [sym__type_literal] = STATE(2496),
    [sym_type_name] = STATE(2520),
    [sym_type_star] = STATE(2496),
    [sym_type_unboxed_tuple] = STATE(2496),
    [sym_type_unboxed_sum] = STATE(2496),
    [sym__atype] = STATE(2496),
    [sym_type_apply] = STATE(8402),
    [sym__btype] = STATE(8402),
    [sym_type_infix] = STATE(11233),
    [sym__type_infix] = STATE(11065),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2738),
    [sym__type_quantifiers] = STATE(13585),
    [sym__type_context] = STATE(13585),
    [sym__type_fun] = STATE(13585),
    [sym__type] = STATE(13585),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2496),
    [sym_quasiquote] = STATE(2496),
    [sym__varid] = ACTIONS(8329),
    [sym_float] = ACTIONS(8049),
    [sym_char] = ACTIONS(8049),
    [sym_string] = ACTIONS(8049),
    [sym__integer_literal] = ACTIONS(8051),
    [sym__binary_literal] = ACTIONS(8053),
    [sym__octal_literal] = ACTIONS(8053),
    [sym__hex_literal] = ACTIONS(8053),
    [anon_sym_LPAREN_POUND] = ACTIONS(8055),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8055),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8331),
    [sym__conid] = ACTIONS(8335),
    [anon_sym_LBRACK] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(8337),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8067),
    [anon_sym_u2605] = ACTIONS(8067),
    [anon_sym_u27e6] = ACTIONS(8071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8073),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8075),
  },
  [2723] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2542),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16026),
    [sym_type_parens] = STATE(2542),
    [sym_type_list] = STATE(2542),
    [sym_type_tuple] = STATE(2542),
    [sym__type_promotable_literal] = STATE(2542),
    [sym__type_promoted_literal] = STATE(2542),
    [sym__type_literal] = STATE(2542),
    [sym_type_name] = STATE(2588),
    [sym_type_star] = STATE(2542),
    [sym_type_unboxed_tuple] = STATE(2542),
    [sym_type_unboxed_sum] = STATE(2542),
    [sym__atype] = STATE(2542),
    [sym_type_apply] = STATE(8820),
    [sym__btype] = STATE(8820),
    [sym_type_infix] = STATE(13662),
    [sym__type_infix] = STATE(13419),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2723),
    [sym__type_quantifiers] = STATE(14886),
    [sym__type_context] = STATE(14886),
    [sym__type_fun] = STATE(14886),
    [sym__type] = STATE(14886),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2542),
    [sym_quasiquote] = STATE(2542),
    [sym__varid] = ACTIONS(8127),
    [sym_float] = ACTIONS(8129),
    [sym_char] = ACTIONS(8129),
    [sym_string] = ACTIONS(8129),
    [sym__integer_literal] = ACTIONS(8131),
    [sym__binary_literal] = ACTIONS(8133),
    [sym__octal_literal] = ACTIONS(8133),
    [sym__hex_literal] = ACTIONS(8133),
    [anon_sym_LPAREN_POUND] = ACTIONS(8135),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8135),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8137),
    [sym__conid] = ACTIONS(8141),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8145),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8147),
    [anon_sym_u2605] = ACTIONS(8147),
    [anon_sym_u27e6] = ACTIONS(8149),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8151),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8153),
  },
  [2724] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2107),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15654),
    [sym_type_parens] = STATE(2107),
    [sym_type_list] = STATE(2107),
    [sym_type_tuple] = STATE(2107),
    [sym__type_promotable_literal] = STATE(2107),
    [sym__type_promoted_literal] = STATE(2107),
    [sym__type_literal] = STATE(2107),
    [sym_type_name] = STATE(2212),
    [sym_type_star] = STATE(2107),
    [sym_type_unboxed_tuple] = STATE(2107),
    [sym_type_unboxed_sum] = STATE(2107),
    [sym__atype] = STATE(2107),
    [sym_type_apply] = STATE(7336),
    [sym__btype] = STATE(7336),
    [sym_type_infix] = STATE(10601),
    [sym__type_infix] = STATE(10511),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2731),
    [sym__type_quantifiers] = STATE(10877),
    [sym__type_context] = STATE(10877),
    [sym__type_fun] = STATE(10877),
    [sym__type] = STATE(10877),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2107),
    [sym_quasiquote] = STATE(2107),
    [sym__varid] = ACTIONS(5816),
    [sym_float] = ACTIONS(5818),
    [sym_char] = ACTIONS(5818),
    [sym_string] = ACTIONS(5818),
    [sym__integer_literal] = ACTIONS(5820),
    [sym__binary_literal] = ACTIONS(5822),
    [sym__octal_literal] = ACTIONS(5822),
    [sym__hex_literal] = ACTIONS(5822),
    [anon_sym_LPAREN_POUND] = ACTIONS(5824),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5824),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8107),
    [sym__conid] = ACTIONS(8111),
    [anon_sym_LBRACK] = ACTIONS(5831),
    [anon_sym_SQUOTE] = ACTIONS(8113),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_u2605] = ACTIONS(5836),
    [anon_sym_u27e6] = ACTIONS(5840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5842),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5844),
  },
  [2725] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2107),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15654),
    [sym_type_parens] = STATE(2107),
    [sym_type_list] = STATE(2107),
    [sym_type_tuple] = STATE(2107),
    [sym__type_promotable_literal] = STATE(2107),
    [sym__type_promoted_literal] = STATE(2107),
    [sym__type_literal] = STATE(2107),
    [sym_type_name] = STATE(2212),
    [sym_type_star] = STATE(2107),
    [sym_type_unboxed_tuple] = STATE(2107),
    [sym_type_unboxed_sum] = STATE(2107),
    [sym__atype] = STATE(2107),
    [sym_type_apply] = STATE(7336),
    [sym__btype] = STATE(7336),
    [sym_type_infix] = STATE(10601),
    [sym__type_infix] = STATE(10511),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2731),
    [sym__type_quantifiers] = STATE(10876),
    [sym__type_context] = STATE(10876),
    [sym__type_fun] = STATE(10876),
    [sym__type] = STATE(10876),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2107),
    [sym_quasiquote] = STATE(2107),
    [sym__varid] = ACTIONS(5816),
    [sym_float] = ACTIONS(5818),
    [sym_char] = ACTIONS(5818),
    [sym_string] = ACTIONS(5818),
    [sym__integer_literal] = ACTIONS(5820),
    [sym__binary_literal] = ACTIONS(5822),
    [sym__octal_literal] = ACTIONS(5822),
    [sym__hex_literal] = ACTIONS(5822),
    [anon_sym_LPAREN_POUND] = ACTIONS(5824),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5824),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8107),
    [sym__conid] = ACTIONS(8111),
    [anon_sym_LBRACK] = ACTIONS(5831),
    [anon_sym_SQUOTE] = ACTIONS(8113),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_u2605] = ACTIONS(5836),
    [anon_sym_u27e6] = ACTIONS(5840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5842),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5844),
  },
  [2726] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2496),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15845),
    [sym_type_parens] = STATE(2496),
    [sym_type_list] = STATE(2496),
    [sym_type_tuple] = STATE(2496),
    [sym__type_promotable_literal] = STATE(2496),
    [sym__type_promoted_literal] = STATE(2496),
    [sym__type_literal] = STATE(2496),
    [sym_type_name] = STATE(2520),
    [sym_type_star] = STATE(2496),
    [sym_type_unboxed_tuple] = STATE(2496),
    [sym_type_unboxed_sum] = STATE(2496),
    [sym__atype] = STATE(2496),
    [sym_type_apply] = STATE(8402),
    [sym__btype] = STATE(8402),
    [sym_type_infix] = STATE(11233),
    [sym__type_infix] = STATE(11065),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2738),
    [sym__type_quantifiers] = STATE(13586),
    [sym__type_context] = STATE(13586),
    [sym__type_fun] = STATE(13586),
    [sym__type] = STATE(13586),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2496),
    [sym_quasiquote] = STATE(2496),
    [sym__varid] = ACTIONS(8329),
    [sym_float] = ACTIONS(8049),
    [sym_char] = ACTIONS(8049),
    [sym_string] = ACTIONS(8049),
    [sym__integer_literal] = ACTIONS(8051),
    [sym__binary_literal] = ACTIONS(8053),
    [sym__octal_literal] = ACTIONS(8053),
    [sym__hex_literal] = ACTIONS(8053),
    [anon_sym_LPAREN_POUND] = ACTIONS(8055),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8055),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8331),
    [sym__conid] = ACTIONS(8335),
    [anon_sym_LBRACK] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(8337),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8067),
    [anon_sym_u2605] = ACTIONS(8067),
    [anon_sym_u27e6] = ACTIONS(8071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8073),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8075),
  },
  [2727] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2727),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym_type_parens] = STATE(2727),
    [sym_type_list] = STATE(2727),
    [sym_type_tuple] = STATE(2727),
    [sym__type_promotable_literal] = STATE(2727),
    [sym__type_promoted_literal] = STATE(2727),
    [sym__type_literal] = STATE(2727),
    [sym_type_name] = STATE(2727),
    [sym_type_star] = STATE(2727),
    [sym_type_unboxed_tuple] = STATE(2727),
    [sym_type_unboxed_sum] = STATE(2727),
    [sym__atype] = STATE(2727),
    [sym_type_invisible] = STATE(2727),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2727),
    [sym_quasiquote] = STATE(2727),
    [aux_sym_type_apply_repeat1] = STATE(2727),
    [sym__varid] = ACTIONS(10537),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_float] = ACTIONS(10540),
    [sym_char] = ACTIONS(10540),
    [sym_string] = ACTIONS(10540),
    [sym__integer_literal] = ACTIONS(10543),
    [sym__binary_literal] = ACTIONS(10546),
    [sym__octal_literal] = ACTIONS(10546),
    [sym__hex_literal] = ACTIONS(10546),
    [anon_sym_LPAREN_POUND] = ACTIONS(10549),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(10549),
    [anon_sym_u21d2] = ACTIONS(5496),
    [anon_sym_EQ_GT] = ACTIONS(5496),
    [anon_sym_u2192] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10552),
    [anon_sym_BQUOTE] = ACTIONS(5496),
    [sym__conid] = ACTIONS(10555),
    [anon_sym_LBRACK] = ACTIONS(10558),
    [anon_sym_SQUOTE] = ACTIONS(10561),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_PIPE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(10564),
    [anon_sym_u2605] = ACTIONS(10564),
    [anon_sym_AT] = ACTIONS(10567),
    [anon_sym_PERCENT] = ACTIONS(5496),
    [anon_sym_u27e6] = ACTIONS(10570),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5496),
    [sym__splice_dollar] = ACTIONS(10573),
    [sym__consym] = ACTIONS(5496),
    [sym__tyconsym] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(10576),
  },
  [2728] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2531),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16208),
    [sym_type_parens] = STATE(2531),
    [sym_type_list] = STATE(2531),
    [sym_type_tuple] = STATE(2531),
    [sym__type_promotable_literal] = STATE(2531),
    [sym__type_promoted_literal] = STATE(2531),
    [sym__type_literal] = STATE(2531),
    [sym_type_name] = STATE(2683),
    [sym_type_star] = STATE(2531),
    [sym_type_unboxed_tuple] = STATE(2531),
    [sym_type_unboxed_sum] = STATE(2531),
    [sym__atype] = STATE(2531),
    [sym_type_apply] = STATE(8762),
    [sym__btype] = STATE(8762),
    [sym_type_infix] = STATE(13840),
    [sym__type_infix] = STATE(13260),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2735),
    [sym__type_quantifiers] = STATE(15841),
    [sym__type_context] = STATE(15841),
    [sym__type_fun] = STATE(15841),
    [sym__type] = STATE(15841),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2531),
    [sym_quasiquote] = STATE(2531),
    [sym__varid] = ACTIONS(7967),
    [sym_float] = ACTIONS(7969),
    [sym_char] = ACTIONS(7969),
    [sym_string] = ACTIONS(7969),
    [sym__integer_literal] = ACTIONS(7971),
    [sym__binary_literal] = ACTIONS(7973),
    [sym__octal_literal] = ACTIONS(7973),
    [sym__hex_literal] = ACTIONS(7973),
    [anon_sym_LPAREN_POUND] = ACTIONS(7975),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7975),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7977),
    [sym__conid] = ACTIONS(7981),
    [anon_sym_LBRACK] = ACTIONS(7983),
    [anon_sym_SQUOTE] = ACTIONS(7985),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_u2605] = ACTIONS(7987),
    [anon_sym_u27e6] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7991),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7993),
  },
  [2729] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2542),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16026),
    [sym_type_parens] = STATE(2542),
    [sym_type_list] = STATE(2542),
    [sym_type_tuple] = STATE(2542),
    [sym__type_promotable_literal] = STATE(2542),
    [sym__type_promoted_literal] = STATE(2542),
    [sym__type_literal] = STATE(2542),
    [sym_type_name] = STATE(2588),
    [sym_type_star] = STATE(2542),
    [sym_type_unboxed_tuple] = STATE(2542),
    [sym_type_unboxed_sum] = STATE(2542),
    [sym__atype] = STATE(2542),
    [sym_type_apply] = STATE(8820),
    [sym__btype] = STATE(8820),
    [sym_type_infix] = STATE(13662),
    [sym__type_infix] = STATE(13419),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2723),
    [sym__type_quantifiers] = STATE(14853),
    [sym__type_context] = STATE(14853),
    [sym__type_fun] = STATE(14853),
    [sym__type] = STATE(14853),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2542),
    [sym_quasiquote] = STATE(2542),
    [sym__varid] = ACTIONS(8127),
    [sym_float] = ACTIONS(8129),
    [sym_char] = ACTIONS(8129),
    [sym_string] = ACTIONS(8129),
    [sym__integer_literal] = ACTIONS(8131),
    [sym__binary_literal] = ACTIONS(8133),
    [sym__octal_literal] = ACTIONS(8133),
    [sym__hex_literal] = ACTIONS(8133),
    [anon_sym_LPAREN_POUND] = ACTIONS(8135),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8135),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8137),
    [sym__conid] = ACTIONS(8141),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8145),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8147),
    [anon_sym_u2605] = ACTIONS(8147),
    [anon_sym_u27e6] = ACTIONS(8149),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8151),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8153),
  },
  [2730] = {
    [sym_integer] = STATE(7649),
    [sym__literal] = STATE(7649),
    [sym__unboxed_open] = STATE(2067),
    [sym_constructor] = STATE(7344),
    [sym_con_unit] = STATE(7649),
    [sym_con_list] = STATE(7649),
    [sym_con_tuple] = STATE(7649),
    [sym_qualified_type] = STATE(7741),
    [sym_tycon_arrow] = STATE(7741),
    [sym_type_literal] = STATE(2542),
    [sym__promoted_tycon] = STATE(7741),
    [sym_type_variable] = STATE(7741),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16026),
    [sym_type_parens] = STATE(2542),
    [sym_type_list] = STATE(2542),
    [sym_type_tuple] = STATE(2542),
    [sym__type_promotable_literal] = STATE(2542),
    [sym__type_promoted_literal] = STATE(2542),
    [sym__type_literal] = STATE(2542),
    [sym_type_name] = STATE(2588),
    [sym_type_star] = STATE(2542),
    [sym_type_unboxed_tuple] = STATE(2542),
    [sym_type_unboxed_sum] = STATE(2542),
    [sym__atype] = STATE(2542),
    [sym_type_apply] = STATE(8820),
    [sym__btype] = STATE(8820),
    [sym_type_infix] = STATE(13662),
    [sym__type_infix] = STATE(13419),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2723),
    [sym__type_quantifiers] = STATE(14852),
    [sym__type_context] = STATE(14852),
    [sym__type_fun] = STATE(14852),
    [sym__type] = STATE(14852),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17334),
    [sym_splice] = STATE(2542),
    [sym_quasiquote] = STATE(2542),
    [sym__varid] = ACTIONS(8127),
    [sym_float] = ACTIONS(8129),
    [sym_char] = ACTIONS(8129),
    [sym_string] = ACTIONS(8129),
    [sym__integer_literal] = ACTIONS(8131),
    [sym__binary_literal] = ACTIONS(8133),
    [sym__octal_literal] = ACTIONS(8133),
    [sym__hex_literal] = ACTIONS(8133),
    [anon_sym_LPAREN_POUND] = ACTIONS(8135),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8135),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8137),
    [sym__conid] = ACTIONS(8141),
    [anon_sym_LBRACK] = ACTIONS(8143),
    [anon_sym_SQUOTE] = ACTIONS(8145),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8147),
    [anon_sym_u2605] = ACTIONS(8147),
    [anon_sym_u27e6] = ACTIONS(8149),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8151),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8153),
  },
  [2731] = {
    [sym_integer] = STATE(4804),
    [sym__literal] = STATE(4804),
    [sym__unboxed_open] = STATE(2152),
    [sym_constructor] = STATE(4543),
    [sym_con_unit] = STATE(4804),
    [sym_con_list] = STATE(4804),
    [sym_con_tuple] = STATE(4804),
    [sym_qualified_type] = STATE(4807),
    [sym_tycon_arrow] = STATE(4807),
    [sym_type_literal] = STATE(2107),
    [sym__promoted_tycon] = STATE(4807),
    [sym_type_variable] = STATE(4807),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15654),
    [sym_type_parens] = STATE(2107),
    [sym_type_list] = STATE(2107),
    [sym_type_tuple] = STATE(2107),
    [sym__type_promotable_literal] = STATE(2107),
    [sym__type_promoted_literal] = STATE(2107),
    [sym__type_literal] = STATE(2107),
    [sym_type_name] = STATE(2212),
    [sym_type_star] = STATE(2107),
    [sym_type_unboxed_tuple] = STATE(2107),
    [sym_type_unboxed_sum] = STATE(2107),
    [sym__atype] = STATE(2107),
    [sym_type_apply] = STATE(7336),
    [sym__btype] = STATE(7336),
    [sym_type_infix] = STATE(10601),
    [sym__type_infix] = STATE(10511),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2731),
    [sym__type_quantifiers] = STATE(10813),
    [sym__type_context] = STATE(10813),
    [sym__type_fun] = STATE(10813),
    [sym__type] = STATE(10813),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16817),
    [sym_splice] = STATE(2107),
    [sym_quasiquote] = STATE(2107),
    [sym__varid] = ACTIONS(5816),
    [sym_float] = ACTIONS(5818),
    [sym_char] = ACTIONS(5818),
    [sym_string] = ACTIONS(5818),
    [sym__integer_literal] = ACTIONS(5820),
    [sym__binary_literal] = ACTIONS(5822),
    [sym__octal_literal] = ACTIONS(5822),
    [sym__hex_literal] = ACTIONS(5822),
    [anon_sym_LPAREN_POUND] = ACTIONS(5824),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5824),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8107),
    [sym__conid] = ACTIONS(8111),
    [anon_sym_LBRACK] = ACTIONS(5831),
    [anon_sym_SQUOTE] = ACTIONS(8113),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_u2605] = ACTIONS(5836),
    [anon_sym_u27e6] = ACTIONS(5840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5842),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5844),
  },
  [2732] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2531),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16208),
    [sym_type_parens] = STATE(2531),
    [sym_type_list] = STATE(2531),
    [sym_type_tuple] = STATE(2531),
    [sym__type_promotable_literal] = STATE(2531),
    [sym__type_promoted_literal] = STATE(2531),
    [sym__type_literal] = STATE(2531),
    [sym_type_name] = STATE(2683),
    [sym_type_star] = STATE(2531),
    [sym_type_unboxed_tuple] = STATE(2531),
    [sym_type_unboxed_sum] = STATE(2531),
    [sym__atype] = STATE(2531),
    [sym_type_apply] = STATE(8762),
    [sym__btype] = STATE(8762),
    [sym_type_infix] = STATE(13840),
    [sym__type_infix] = STATE(13260),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2735),
    [sym__type_quantifiers] = STATE(15844),
    [sym__type_context] = STATE(15844),
    [sym__type_fun] = STATE(15844),
    [sym__type] = STATE(15844),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2531),
    [sym_quasiquote] = STATE(2531),
    [sym__varid] = ACTIONS(7967),
    [sym_float] = ACTIONS(7969),
    [sym_char] = ACTIONS(7969),
    [sym_string] = ACTIONS(7969),
    [sym__integer_literal] = ACTIONS(7971),
    [sym__binary_literal] = ACTIONS(7973),
    [sym__octal_literal] = ACTIONS(7973),
    [sym__hex_literal] = ACTIONS(7973),
    [anon_sym_LPAREN_POUND] = ACTIONS(7975),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7975),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7977),
    [sym__conid] = ACTIONS(7981),
    [anon_sym_LBRACK] = ACTIONS(7983),
    [anon_sym_SQUOTE] = ACTIONS(7985),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_u2605] = ACTIONS(7987),
    [anon_sym_u27e6] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7991),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7993),
  },
  [2733] = {
    [sym_integer] = STATE(7973),
    [sym__literal] = STATE(7973),
    [sym__unboxed_open] = STATE(2160),
    [sym_constructor] = STATE(7796),
    [sym_con_unit] = STATE(7973),
    [sym_con_list] = STATE(7973),
    [sym_con_tuple] = STATE(7973),
    [sym_qualified_type] = STATE(7974),
    [sym_tycon_arrow] = STATE(7974),
    [sym_type_literal] = STATE(2706),
    [sym__promoted_tycon] = STATE(7974),
    [sym_type_variable] = STATE(7974),
    [sym_type_parens] = STATE(2706),
    [sym_type_list] = STATE(2706),
    [sym_type_tuple] = STATE(2706),
    [sym__type_promotable_literal] = STATE(2706),
    [sym__type_promoted_literal] = STATE(2706),
    [sym__type_literal] = STATE(2706),
    [sym_type_name] = STATE(2706),
    [sym_type_star] = STATE(2706),
    [sym_type_unboxed_tuple] = STATE(2706),
    [sym_type_unboxed_sum] = STATE(2706),
    [sym__atype] = STATE(2706),
    [sym_type_invisible] = STATE(2706),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16539),
    [sym_splice] = STATE(2706),
    [sym_quasiquote] = STATE(2706),
    [aux_sym_type_apply_repeat1] = STATE(2706),
    [sym__varid] = ACTIONS(6236),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_float] = ACTIONS(6238),
    [sym_char] = ACTIONS(6238),
    [sym_string] = ACTIONS(6238),
    [sym__integer_literal] = ACTIONS(6240),
    [sym__binary_literal] = ACTIONS(6242),
    [sym__octal_literal] = ACTIONS(6242),
    [sym__hex_literal] = ACTIONS(6242),
    [anon_sym_LPAREN_POUND] = ACTIONS(6244),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6244),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u2192] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(10527),
    [anon_sym_BQUOTE] = ACTIONS(5483),
    [sym__conid] = ACTIONS(10579),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(10582),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_u2605] = ACTIONS(6254),
    [anon_sym_AT] = ACTIONS(10535),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_deriving] = ACTIONS(5491),
    [anon_sym_u27e6] = ACTIONS(6256),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5483),
    [sym__layout_end] = ACTIONS(5483),
    [sym__splice_dollar] = ACTIONS(6258),
    [sym__consym] = ACTIONS(5483),
    [sym__tyconsym] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6260),
  },
  [2734] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2633),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16071),
    [sym_type_parens] = STATE(2633),
    [sym_type_list] = STATE(2633),
    [sym_type_tuple] = STATE(2633),
    [sym__type_promotable_literal] = STATE(2633),
    [sym__type_promoted_literal] = STATE(2633),
    [sym__type_literal] = STATE(2633),
    [sym_type_name] = STATE(2789),
    [sym_type_star] = STATE(2633),
    [sym_type_unboxed_tuple] = STATE(2633),
    [sym_type_unboxed_sum] = STATE(2633),
    [sym__atype] = STATE(2633),
    [sym_type_apply] = STATE(8991),
    [sym__btype] = STATE(8991),
    [sym_type_infix] = STATE(14014),
    [sym__type_infix] = STATE(13598),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2734),
    [sym__type_quantifiers] = STATE(17686),
    [sym__type_context] = STATE(17686),
    [sym__type_fun] = STATE(17686),
    [sym__type] = STATE(17686),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2633),
    [sym_quasiquote] = STATE(2633),
    [sym__varid] = ACTIONS(8215),
    [sym_float] = ACTIONS(8217),
    [sym_char] = ACTIONS(8217),
    [sym_string] = ACTIONS(8217),
    [sym__integer_literal] = ACTIONS(8219),
    [sym__binary_literal] = ACTIONS(8221),
    [sym__octal_literal] = ACTIONS(8221),
    [sym__hex_literal] = ACTIONS(8221),
    [anon_sym_LPAREN_POUND] = ACTIONS(8223),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8223),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8225),
    [sym__conid] = ACTIONS(8229),
    [anon_sym_LBRACK] = ACTIONS(8231),
    [anon_sym_SQUOTE] = ACTIONS(8233),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8235),
    [anon_sym_u2605] = ACTIONS(8235),
    [anon_sym_u27e6] = ACTIONS(8237),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8239),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8241),
  },
  [2735] = {
    [sym_integer] = STATE(7739),
    [sym__literal] = STATE(7739),
    [sym__unboxed_open] = STATE(2193),
    [sym_constructor] = STATE(7398),
    [sym_con_unit] = STATE(7739),
    [sym_con_list] = STATE(7739),
    [sym_con_tuple] = STATE(7739),
    [sym_qualified_type] = STATE(7737),
    [sym_tycon_arrow] = STATE(7737),
    [sym_type_literal] = STATE(2531),
    [sym__promoted_tycon] = STATE(7737),
    [sym_type_variable] = STATE(7737),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16208),
    [sym_type_parens] = STATE(2531),
    [sym_type_list] = STATE(2531),
    [sym_type_tuple] = STATE(2531),
    [sym__type_promotable_literal] = STATE(2531),
    [sym__type_promoted_literal] = STATE(2531),
    [sym__type_literal] = STATE(2531),
    [sym_type_name] = STATE(2683),
    [sym_type_star] = STATE(2531),
    [sym_type_unboxed_tuple] = STATE(2531),
    [sym_type_unboxed_sum] = STATE(2531),
    [sym__atype] = STATE(2531),
    [sym_type_apply] = STATE(8762),
    [sym__btype] = STATE(8762),
    [sym_type_infix] = STATE(13840),
    [sym__type_infix] = STATE(13260),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2735),
    [sym__type_quantifiers] = STATE(16138),
    [sym__type_context] = STATE(16138),
    [sym__type_fun] = STATE(16138),
    [sym__type] = STATE(16138),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17581),
    [sym_splice] = STATE(2531),
    [sym_quasiquote] = STATE(2531),
    [sym__varid] = ACTIONS(7967),
    [sym_float] = ACTIONS(7969),
    [sym_char] = ACTIONS(7969),
    [sym_string] = ACTIONS(7969),
    [sym__integer_literal] = ACTIONS(7971),
    [sym__binary_literal] = ACTIONS(7973),
    [sym__octal_literal] = ACTIONS(7973),
    [sym__hex_literal] = ACTIONS(7973),
    [anon_sym_LPAREN_POUND] = ACTIONS(7975),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7975),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7977),
    [sym__conid] = ACTIONS(7981),
    [anon_sym_LBRACK] = ACTIONS(7983),
    [anon_sym_SQUOTE] = ACTIONS(7985),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_u2605] = ACTIONS(7987),
    [anon_sym_u27e6] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7991),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7993),
  },
  [2736] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2633),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16071),
    [sym_type_parens] = STATE(2633),
    [sym_type_list] = STATE(2633),
    [sym_type_tuple] = STATE(2633),
    [sym__type_promotable_literal] = STATE(2633),
    [sym__type_promoted_literal] = STATE(2633),
    [sym__type_literal] = STATE(2633),
    [sym_type_name] = STATE(2789),
    [sym_type_star] = STATE(2633),
    [sym_type_unboxed_tuple] = STATE(2633),
    [sym_type_unboxed_sum] = STATE(2633),
    [sym__atype] = STATE(2633),
    [sym_type_apply] = STATE(8991),
    [sym__btype] = STATE(8991),
    [sym_type_infix] = STATE(14014),
    [sym__type_infix] = STATE(13598),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2734),
    [sym__type_quantifiers] = STATE(17645),
    [sym__type_context] = STATE(17645),
    [sym__type_fun] = STATE(17645),
    [sym__type] = STATE(17645),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2633),
    [sym_quasiquote] = STATE(2633),
    [sym__varid] = ACTIONS(8215),
    [sym_float] = ACTIONS(8217),
    [sym_char] = ACTIONS(8217),
    [sym_string] = ACTIONS(8217),
    [sym__integer_literal] = ACTIONS(8219),
    [sym__binary_literal] = ACTIONS(8221),
    [sym__octal_literal] = ACTIONS(8221),
    [sym__hex_literal] = ACTIONS(8221),
    [anon_sym_LPAREN_POUND] = ACTIONS(8223),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8223),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8225),
    [sym__conid] = ACTIONS(8229),
    [anon_sym_LBRACK] = ACTIONS(8231),
    [anon_sym_SQUOTE] = ACTIONS(8233),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8235),
    [anon_sym_u2605] = ACTIONS(8235),
    [anon_sym_u27e6] = ACTIONS(8237),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8239),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8241),
  },
  [2737] = {
    [sym_integer] = STATE(7945),
    [sym__literal] = STATE(7945),
    [sym__unboxed_open] = STATE(2195),
    [sym_constructor] = STATE(7746),
    [sym_con_unit] = STATE(7945),
    [sym_con_list] = STATE(7945),
    [sym_con_tuple] = STATE(7945),
    [sym_qualified_type] = STATE(7972),
    [sym_tycon_arrow] = STATE(7972),
    [sym_type_literal] = STATE(2633),
    [sym__promoted_tycon] = STATE(7972),
    [sym_type_variable] = STATE(7972),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16071),
    [sym_type_parens] = STATE(2633),
    [sym_type_list] = STATE(2633),
    [sym_type_tuple] = STATE(2633),
    [sym__type_promotable_literal] = STATE(2633),
    [sym__type_promoted_literal] = STATE(2633),
    [sym__type_literal] = STATE(2633),
    [sym_type_name] = STATE(2789),
    [sym_type_star] = STATE(2633),
    [sym_type_unboxed_tuple] = STATE(2633),
    [sym_type_unboxed_sum] = STATE(2633),
    [sym__atype] = STATE(2633),
    [sym_type_apply] = STATE(8991),
    [sym__btype] = STATE(8991),
    [sym_type_infix] = STATE(14014),
    [sym__type_infix] = STATE(13598),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2734),
    [sym__type_quantifiers] = STATE(17615),
    [sym__type_context] = STATE(17615),
    [sym__type_fun] = STATE(17615),
    [sym__type] = STATE(17615),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16892),
    [sym_splice] = STATE(2633),
    [sym_quasiquote] = STATE(2633),
    [sym__varid] = ACTIONS(8215),
    [sym_float] = ACTIONS(8217),
    [sym_char] = ACTIONS(8217),
    [sym_string] = ACTIONS(8217),
    [sym__integer_literal] = ACTIONS(8219),
    [sym__binary_literal] = ACTIONS(8221),
    [sym__octal_literal] = ACTIONS(8221),
    [sym__hex_literal] = ACTIONS(8221),
    [anon_sym_LPAREN_POUND] = ACTIONS(8223),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8223),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8225),
    [sym__conid] = ACTIONS(8229),
    [anon_sym_LBRACK] = ACTIONS(8231),
    [anon_sym_SQUOTE] = ACTIONS(8233),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8235),
    [anon_sym_u2605] = ACTIONS(8235),
    [anon_sym_u27e6] = ACTIONS(8237),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8239),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8241),
  },
  [2738] = {
    [sym_integer] = STATE(7163),
    [sym__literal] = STATE(7163),
    [sym__unboxed_open] = STATE(2141),
    [sym_constructor] = STATE(6849),
    [sym_con_unit] = STATE(7163),
    [sym_con_list] = STATE(7163),
    [sym_con_tuple] = STATE(7163),
    [sym_qualified_type] = STATE(7161),
    [sym_tycon_arrow] = STATE(7161),
    [sym_type_literal] = STATE(2496),
    [sym__promoted_tycon] = STATE(7161),
    [sym_type_variable] = STATE(7161),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15845),
    [sym_type_parens] = STATE(2496),
    [sym_type_list] = STATE(2496),
    [sym_type_tuple] = STATE(2496),
    [sym__type_promotable_literal] = STATE(2496),
    [sym__type_promoted_literal] = STATE(2496),
    [sym__type_literal] = STATE(2496),
    [sym_type_name] = STATE(2520),
    [sym_type_star] = STATE(2496),
    [sym_type_unboxed_tuple] = STATE(2496),
    [sym_type_unboxed_sum] = STATE(2496),
    [sym__atype] = STATE(2496),
    [sym_type_apply] = STATE(8402),
    [sym__btype] = STATE(8402),
    [sym_type_infix] = STATE(11233),
    [sym__type_infix] = STATE(11065),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2738),
    [sym__type_quantifiers] = STATE(13685),
    [sym__type_context] = STATE(13685),
    [sym__type_fun] = STATE(13685),
    [sym__type] = STATE(13685),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16524),
    [sym_splice] = STATE(2496),
    [sym_quasiquote] = STATE(2496),
    [sym__varid] = ACTIONS(8329),
    [sym_float] = ACTIONS(8049),
    [sym_char] = ACTIONS(8049),
    [sym_string] = ACTIONS(8049),
    [sym__integer_literal] = ACTIONS(8051),
    [sym__binary_literal] = ACTIONS(8053),
    [sym__octal_literal] = ACTIONS(8053),
    [sym__hex_literal] = ACTIONS(8053),
    [anon_sym_LPAREN_POUND] = ACTIONS(8055),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8055),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8331),
    [sym__conid] = ACTIONS(8335),
    [anon_sym_LBRACK] = ACTIONS(8062),
    [anon_sym_SQUOTE] = ACTIONS(8337),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8067),
    [anon_sym_u2605] = ACTIONS(8067),
    [anon_sym_u27e6] = ACTIONS(8071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8073),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8075),
  },
  [2739] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym__layout_end] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2740] = {
    [sym_integer] = STATE(8192),
    [sym__literal] = STATE(8192),
    [sym__unboxed_open] = STATE(2119),
    [sym_constructor] = STATE(8160),
    [sym_con_unit] = STATE(8192),
    [sym_con_list] = STATE(8192),
    [sym_con_tuple] = STATE(8192),
    [sym_qualified_type] = STATE(8196),
    [sym_tycon_arrow] = STATE(8196),
    [sym_type_literal] = STATE(2772),
    [sym__promoted_tycon] = STATE(8196),
    [sym_type_variable] = STATE(8196),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15861),
    [sym_type_parens] = STATE(2772),
    [sym_type_list] = STATE(2772),
    [sym_type_tuple] = STATE(2772),
    [sym__type_promotable_literal] = STATE(2772),
    [sym__type_promoted_literal] = STATE(2772),
    [sym__type_literal] = STATE(2772),
    [sym_type_name] = STATE(2796),
    [sym_type_star] = STATE(2772),
    [sym_type_unboxed_tuple] = STATE(2772),
    [sym_type_unboxed_sum] = STATE(2772),
    [sym__atype] = STATE(2772),
    [sym_type_apply] = STATE(9496),
    [sym__btype] = STATE(9496),
    [sym_type_infix] = STATE(14416),
    [sym__type_infix] = STATE(13973),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2757),
    [sym__type_quantifiers] = STATE(18130),
    [sym__type_context] = STATE(18130),
    [sym__type_fun] = STATE(18130),
    [sym__type] = STATE(18130),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16417),
    [sym_splice] = STATE(2772),
    [sym_quasiquote] = STATE(2772),
    [sym__varid] = ACTIONS(8520),
    [sym_float] = ACTIONS(8522),
    [sym_char] = ACTIONS(8522),
    [sym_string] = ACTIONS(8522),
    [sym__integer_literal] = ACTIONS(8524),
    [sym__binary_literal] = ACTIONS(8526),
    [sym__octal_literal] = ACTIONS(8526),
    [sym__hex_literal] = ACTIONS(8526),
    [anon_sym_LPAREN_POUND] = ACTIONS(8528),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8528),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8530),
    [sym__conid] = ACTIONS(8534),
    [anon_sym_LBRACK] = ACTIONS(8536),
    [anon_sym_SQUOTE] = ACTIONS(8538),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8540),
    [anon_sym_u2605] = ACTIONS(8540),
    [anon_sym_u27e6] = ACTIONS(8542),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8544),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8546),
  },
  [2741] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2478),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16159),
    [sym_type_parens] = STATE(2478),
    [sym_type_list] = STATE(2478),
    [sym_type_tuple] = STATE(2478),
    [sym__type_promotable_literal] = STATE(2478),
    [sym__type_promoted_literal] = STATE(2478),
    [sym__type_literal] = STATE(2478),
    [sym_type_name] = STATE(2515),
    [sym_type_star] = STATE(2478),
    [sym_type_unboxed_tuple] = STATE(2478),
    [sym_type_unboxed_sum] = STATE(2478),
    [sym__atype] = STATE(2478),
    [sym_type_apply] = STATE(8475),
    [sym__btype] = STATE(8475),
    [sym_type_infix] = STATE(11228),
    [sym__type_infix] = STATE(10954),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2746),
    [sym__type_quantifiers] = STATE(13591),
    [sym__type_context] = STATE(13591),
    [sym__type_fun] = STATE(13591),
    [sym__type] = STATE(13591),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2478),
    [sym_quasiquote] = STATE(2478),
    [sym__varid] = ACTIONS(7859),
    [sym_float] = ACTIONS(7861),
    [sym_char] = ACTIONS(7861),
    [sym_string] = ACTIONS(7861),
    [sym__integer_literal] = ACTIONS(7863),
    [sym__binary_literal] = ACTIONS(7865),
    [sym__octal_literal] = ACTIONS(7865),
    [sym__hex_literal] = ACTIONS(7865),
    [anon_sym_LPAREN_POUND] = ACTIONS(7867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7869),
    [sym__conid] = ACTIONS(7873),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_SQUOTE] = ACTIONS(7877),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7879),
    [anon_sym_u2605] = ACTIONS(7879),
    [anon_sym_u27e6] = ACTIONS(7881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7885),
  },
  [2742] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2478),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16159),
    [sym_type_parens] = STATE(2478),
    [sym_type_list] = STATE(2478),
    [sym_type_tuple] = STATE(2478),
    [sym__type_promotable_literal] = STATE(2478),
    [sym__type_promoted_literal] = STATE(2478),
    [sym__type_literal] = STATE(2478),
    [sym_type_name] = STATE(2515),
    [sym_type_star] = STATE(2478),
    [sym_type_unboxed_tuple] = STATE(2478),
    [sym_type_unboxed_sum] = STATE(2478),
    [sym__atype] = STATE(2478),
    [sym_type_apply] = STATE(8475),
    [sym__btype] = STATE(8475),
    [sym_type_infix] = STATE(11228),
    [sym__type_infix] = STATE(10954),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2746),
    [sym__type_quantifiers] = STATE(13622),
    [sym__type_context] = STATE(13622),
    [sym__type_fun] = STATE(13622),
    [sym__type] = STATE(13622),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2478),
    [sym_quasiquote] = STATE(2478),
    [sym__varid] = ACTIONS(7859),
    [sym_float] = ACTIONS(7861),
    [sym_char] = ACTIONS(7861),
    [sym_string] = ACTIONS(7861),
    [sym__integer_literal] = ACTIONS(7863),
    [sym__binary_literal] = ACTIONS(7865),
    [sym__octal_literal] = ACTIONS(7865),
    [sym__hex_literal] = ACTIONS(7865),
    [anon_sym_LPAREN_POUND] = ACTIONS(7867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7869),
    [sym__conid] = ACTIONS(7873),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_SQUOTE] = ACTIONS(7877),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7879),
    [anon_sym_u2605] = ACTIONS(7879),
    [anon_sym_u27e6] = ACTIONS(7881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7885),
  },
  [2743] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2391),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16148),
    [sym_type_parens] = STATE(2391),
    [sym_type_list] = STATE(2391),
    [sym_type_tuple] = STATE(2391),
    [sym__type_promotable_literal] = STATE(2391),
    [sym__type_promoted_literal] = STATE(2391),
    [sym__type_literal] = STATE(2391),
    [sym_type_name] = STATE(2498),
    [sym_type_star] = STATE(2391),
    [sym_type_unboxed_tuple] = STATE(2391),
    [sym_type_unboxed_sum] = STATE(2391),
    [sym__atype] = STATE(2391),
    [sym_type_apply] = STATE(8246),
    [sym__btype] = STATE(8246),
    [sym_type_infix] = STATE(11005),
    [sym__type_infix] = STATE(10872),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2743),
    [sym__type_quantifiers] = STATE(13274),
    [sym__type_context] = STATE(13274),
    [sym__type_fun] = STATE(13274),
    [sym__type] = STATE(13274),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2391),
    [sym_quasiquote] = STATE(2391),
    [sym__varid] = ACTIONS(8750),
    [sym_float] = ACTIONS(7069),
    [sym_char] = ACTIONS(7069),
    [sym_string] = ACTIONS(7069),
    [sym__integer_literal] = ACTIONS(7071),
    [sym__binary_literal] = ACTIONS(7073),
    [sym__octal_literal] = ACTIONS(7073),
    [sym__hex_literal] = ACTIONS(7073),
    [anon_sym_LPAREN_POUND] = ACTIONS(7075),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7075),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8752),
    [sym__conid] = ACTIONS(8756),
    [anon_sym_LBRACK] = ACTIONS(7082),
    [anon_sym_SQUOTE] = ACTIONS(8758),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7087),
    [anon_sym_u2605] = ACTIONS(7087),
    [anon_sym_u27e6] = ACTIONS(7091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7093),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7095),
  },
  [2744] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2391),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16148),
    [sym_type_parens] = STATE(2391),
    [sym_type_list] = STATE(2391),
    [sym_type_tuple] = STATE(2391),
    [sym__type_promotable_literal] = STATE(2391),
    [sym__type_promoted_literal] = STATE(2391),
    [sym__type_literal] = STATE(2391),
    [sym_type_name] = STATE(2498),
    [sym_type_star] = STATE(2391),
    [sym_type_unboxed_tuple] = STATE(2391),
    [sym_type_unboxed_sum] = STATE(2391),
    [sym__atype] = STATE(2391),
    [sym_type_apply] = STATE(8246),
    [sym__btype] = STATE(8246),
    [sym_type_infix] = STATE(11005),
    [sym__type_infix] = STATE(10872),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2743),
    [sym__type_quantifiers] = STATE(13374),
    [sym__type_context] = STATE(13374),
    [sym__type_fun] = STATE(13374),
    [sym__type] = STATE(13374),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2391),
    [sym_quasiquote] = STATE(2391),
    [sym__varid] = ACTIONS(8750),
    [sym_float] = ACTIONS(7069),
    [sym_char] = ACTIONS(7069),
    [sym_string] = ACTIONS(7069),
    [sym__integer_literal] = ACTIONS(7071),
    [sym__binary_literal] = ACTIONS(7073),
    [sym__octal_literal] = ACTIONS(7073),
    [sym__hex_literal] = ACTIONS(7073),
    [anon_sym_LPAREN_POUND] = ACTIONS(7075),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7075),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8752),
    [sym__conid] = ACTIONS(8756),
    [anon_sym_LBRACK] = ACTIONS(7082),
    [anon_sym_SQUOTE] = ACTIONS(8758),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7087),
    [anon_sym_u2605] = ACTIONS(7087),
    [anon_sym_u27e6] = ACTIONS(7091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7093),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7095),
  },
  [2745] = {
    [sym_integer] = STATE(6704),
    [sym__literal] = STATE(6704),
    [sym__unboxed_open] = STATE(2073),
    [sym_constructor] = STATE(6342),
    [sym_con_unit] = STATE(6704),
    [sym_con_list] = STATE(6704),
    [sym_con_tuple] = STATE(6704),
    [sym_qualified_type] = STATE(6844),
    [sym_tycon_arrow] = STATE(6844),
    [sym_type_literal] = STATE(2391),
    [sym__promoted_tycon] = STATE(6844),
    [sym_type_variable] = STATE(6844),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16148),
    [sym_type_parens] = STATE(2391),
    [sym_type_list] = STATE(2391),
    [sym_type_tuple] = STATE(2391),
    [sym__type_promotable_literal] = STATE(2391),
    [sym__type_promoted_literal] = STATE(2391),
    [sym__type_literal] = STATE(2391),
    [sym_type_name] = STATE(2498),
    [sym_type_star] = STATE(2391),
    [sym_type_unboxed_tuple] = STATE(2391),
    [sym_type_unboxed_sum] = STATE(2391),
    [sym__atype] = STATE(2391),
    [sym_type_apply] = STATE(8246),
    [sym__btype] = STATE(8246),
    [sym_type_infix] = STATE(11005),
    [sym__type_infix] = STATE(10872),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2743),
    [sym__type_quantifiers] = STATE(13377),
    [sym__type_context] = STATE(13377),
    [sym__type_fun] = STATE(13377),
    [sym__type] = STATE(13377),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17509),
    [sym_splice] = STATE(2391),
    [sym_quasiquote] = STATE(2391),
    [sym__varid] = ACTIONS(8750),
    [sym_float] = ACTIONS(7069),
    [sym_char] = ACTIONS(7069),
    [sym_string] = ACTIONS(7069),
    [sym__integer_literal] = ACTIONS(7071),
    [sym__binary_literal] = ACTIONS(7073),
    [sym__octal_literal] = ACTIONS(7073),
    [sym__hex_literal] = ACTIONS(7073),
    [anon_sym_LPAREN_POUND] = ACTIONS(7075),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7075),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8752),
    [sym__conid] = ACTIONS(8756),
    [anon_sym_LBRACK] = ACTIONS(7082),
    [anon_sym_SQUOTE] = ACTIONS(8758),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7087),
    [anon_sym_u2605] = ACTIONS(7087),
    [anon_sym_u27e6] = ACTIONS(7091),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7093),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7095),
  },
  [2746] = {
    [sym_integer] = STATE(7036),
    [sym__literal] = STATE(7036),
    [sym__unboxed_open] = STATE(2081),
    [sym_constructor] = STATE(6986),
    [sym_con_unit] = STATE(7036),
    [sym_con_list] = STATE(7036),
    [sym_con_tuple] = STATE(7036),
    [sym_qualified_type] = STATE(7060),
    [sym_tycon_arrow] = STATE(7060),
    [sym_type_literal] = STATE(2478),
    [sym__promoted_tycon] = STATE(7060),
    [sym_type_variable] = STATE(7060),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16159),
    [sym_type_parens] = STATE(2478),
    [sym_type_list] = STATE(2478),
    [sym_type_tuple] = STATE(2478),
    [sym__type_promotable_literal] = STATE(2478),
    [sym__type_promoted_literal] = STATE(2478),
    [sym__type_literal] = STATE(2478),
    [sym_type_name] = STATE(2515),
    [sym_type_star] = STATE(2478),
    [sym_type_unboxed_tuple] = STATE(2478),
    [sym_type_unboxed_sum] = STATE(2478),
    [sym__atype] = STATE(2478),
    [sym_type_apply] = STATE(8475),
    [sym__btype] = STATE(8475),
    [sym_type_infix] = STATE(11228),
    [sym__type_infix] = STATE(10954),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2746),
    [sym__type_quantifiers] = STATE(13805),
    [sym__type_context] = STATE(13805),
    [sym__type_fun] = STATE(13805),
    [sym__type] = STATE(13805),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17564),
    [sym_splice] = STATE(2478),
    [sym_quasiquote] = STATE(2478),
    [sym__varid] = ACTIONS(7859),
    [sym_float] = ACTIONS(7861),
    [sym_char] = ACTIONS(7861),
    [sym_string] = ACTIONS(7861),
    [sym__integer_literal] = ACTIONS(7863),
    [sym__binary_literal] = ACTIONS(7865),
    [sym__octal_literal] = ACTIONS(7865),
    [sym__hex_literal] = ACTIONS(7865),
    [anon_sym_LPAREN_POUND] = ACTIONS(7867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7869),
    [sym__conid] = ACTIONS(7873),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_SQUOTE] = ACTIONS(7877),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7879),
    [anon_sym_u2605] = ACTIONS(7879),
    [anon_sym_u27e6] = ACTIONS(7881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7885),
  },
  [2747] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2297),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16212),
    [sym_type_parens] = STATE(2297),
    [sym_type_list] = STATE(2297),
    [sym_type_tuple] = STATE(2297),
    [sym__type_promotable_literal] = STATE(2297),
    [sym__type_promoted_literal] = STATE(2297),
    [sym__type_literal] = STATE(2297),
    [sym_type_name] = STATE(2426),
    [sym_type_star] = STATE(2297),
    [sym_type_unboxed_tuple] = STATE(2297),
    [sym_type_unboxed_sum] = STATE(2297),
    [sym__atype] = STATE(2297),
    [sym_type_apply] = STATE(8194),
    [sym__btype] = STATE(8194),
    [sym_type_infix] = STATE(10862),
    [sym__type_infix] = STATE(10724),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2747),
    [sym__type_quantifiers] = STATE(13064),
    [sym__type_context] = STATE(13064),
    [sym__type_fun] = STATE(13064),
    [sym__type] = STATE(13064),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2297),
    [sym_quasiquote] = STATE(2297),
    [sym__varid] = ACTIONS(7915),
    [sym_float] = ACTIONS(6552),
    [sym_char] = ACTIONS(6552),
    [sym_string] = ACTIONS(6552),
    [sym__integer_literal] = ACTIONS(6554),
    [sym__binary_literal] = ACTIONS(6556),
    [sym__octal_literal] = ACTIONS(6556),
    [sym__hex_literal] = ACTIONS(6556),
    [anon_sym_LPAREN_POUND] = ACTIONS(6558),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6558),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7917),
    [sym__conid] = ACTIONS(7921),
    [anon_sym_LBRACK] = ACTIONS(6565),
    [anon_sym_SQUOTE] = ACTIONS(7923),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6570),
    [anon_sym_u2605] = ACTIONS(6570),
    [anon_sym_u27e6] = ACTIONS(6574),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6578),
  },
  [2748] = {
    [sym_integer] = STATE(7553),
    [sym__literal] = STATE(7553),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(7057),
    [sym_con_unit] = STATE(7553),
    [sym_con_list] = STATE(7553),
    [sym_con_tuple] = STATE(7553),
    [sym_qualified_type] = STATE(7528),
    [sym_tycon_arrow] = STATE(7528),
    [sym_type_literal] = STATE(2518),
    [sym__promoted_tycon] = STATE(7528),
    [sym_type_variable] = STATE(7528),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16194),
    [sym_type_parens] = STATE(2518),
    [sym_type_list] = STATE(2518),
    [sym_type_tuple] = STATE(2518),
    [sym__type_promotable_literal] = STATE(2518),
    [sym__type_promoted_literal] = STATE(2518),
    [sym__type_literal] = STATE(2518),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2518),
    [sym_type_unboxed_tuple] = STATE(2518),
    [sym_type_unboxed_sum] = STATE(2518),
    [sym__atype] = STATE(2518),
    [sym_type_apply] = STATE(8615),
    [sym__btype] = STATE(8615),
    [sym_type_infix] = STATE(13306),
    [sym__type_infix] = STATE(13189),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2748),
    [sym__type_quantifiers] = STATE(14168),
    [sym__type_context] = STATE(14168),
    [sym__type_fun] = STATE(14168),
    [sym__type] = STATE(14168),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17837),
    [sym_splice] = STATE(2518),
    [sym_quasiquote] = STATE(2518),
    [sym__varid] = ACTIONS(2013),
    [sym_float] = ACTIONS(2015),
    [sym_char] = ACTIONS(2015),
    [sym_string] = ACTIONS(2015),
    [sym__integer_literal] = ACTIONS(2017),
    [sym__binary_literal] = ACTIONS(2019),
    [sym__octal_literal] = ACTIONS(2019),
    [sym__hex_literal] = ACTIONS(2019),
    [anon_sym_LPAREN_POUND] = ACTIONS(2021),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2021),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [sym__conid] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u2605] = ACTIONS(2041),
    [anon_sym_u27e6] = ACTIONS(2043),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2051),
  },
  [2749] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2297),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16212),
    [sym_type_parens] = STATE(2297),
    [sym_type_list] = STATE(2297),
    [sym_type_tuple] = STATE(2297),
    [sym__type_promotable_literal] = STATE(2297),
    [sym__type_promoted_literal] = STATE(2297),
    [sym__type_literal] = STATE(2297),
    [sym_type_name] = STATE(2426),
    [sym_type_star] = STATE(2297),
    [sym_type_unboxed_tuple] = STATE(2297),
    [sym_type_unboxed_sum] = STATE(2297),
    [sym__atype] = STATE(2297),
    [sym_type_apply] = STATE(8194),
    [sym__btype] = STATE(8194),
    [sym_type_infix] = STATE(10862),
    [sym__type_infix] = STATE(10724),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2747),
    [sym__type_quantifiers] = STATE(12824),
    [sym__type_context] = STATE(12824),
    [sym__type_fun] = STATE(12824),
    [sym__type] = STATE(12824),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2297),
    [sym_quasiquote] = STATE(2297),
    [sym__varid] = ACTIONS(7915),
    [sym_float] = ACTIONS(6552),
    [sym_char] = ACTIONS(6552),
    [sym_string] = ACTIONS(6552),
    [sym__integer_literal] = ACTIONS(6554),
    [sym__binary_literal] = ACTIONS(6556),
    [sym__octal_literal] = ACTIONS(6556),
    [sym__hex_literal] = ACTIONS(6556),
    [anon_sym_LPAREN_POUND] = ACTIONS(6558),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6558),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7917),
    [sym__conid] = ACTIONS(7921),
    [anon_sym_LBRACK] = ACTIONS(6565),
    [anon_sym_SQUOTE] = ACTIONS(7923),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6570),
    [anon_sym_u2605] = ACTIONS(6570),
    [anon_sym_u27e6] = ACTIONS(6574),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6578),
  },
  [2750] = {
    [sym_integer] = STATE(6380),
    [sym__literal] = STATE(6380),
    [sym__unboxed_open] = STATE(2090),
    [sym_constructor] = STATE(6272),
    [sym_con_unit] = STATE(6380),
    [sym_con_list] = STATE(6380),
    [sym_con_tuple] = STATE(6380),
    [sym_qualified_type] = STATE(6385),
    [sym_tycon_arrow] = STATE(6385),
    [sym_type_literal] = STATE(2297),
    [sym__promoted_tycon] = STATE(6385),
    [sym_type_variable] = STATE(6385),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16212),
    [sym_type_parens] = STATE(2297),
    [sym_type_list] = STATE(2297),
    [sym_type_tuple] = STATE(2297),
    [sym__type_promotable_literal] = STATE(2297),
    [sym__type_promoted_literal] = STATE(2297),
    [sym__type_literal] = STATE(2297),
    [sym_type_name] = STATE(2426),
    [sym_type_star] = STATE(2297),
    [sym_type_unboxed_tuple] = STATE(2297),
    [sym_type_unboxed_sum] = STATE(2297),
    [sym__atype] = STATE(2297),
    [sym_type_apply] = STATE(8194),
    [sym__btype] = STATE(8194),
    [sym_type_infix] = STATE(10862),
    [sym__type_infix] = STATE(10724),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2747),
    [sym__type_quantifiers] = STATE(12956),
    [sym__type_context] = STATE(12956),
    [sym__type_fun] = STATE(12956),
    [sym__type] = STATE(12956),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17534),
    [sym_splice] = STATE(2297),
    [sym_quasiquote] = STATE(2297),
    [sym__varid] = ACTIONS(7915),
    [sym_float] = ACTIONS(6552),
    [sym_char] = ACTIONS(6552),
    [sym_string] = ACTIONS(6552),
    [sym__integer_literal] = ACTIONS(6554),
    [sym__binary_literal] = ACTIONS(6556),
    [sym__octal_literal] = ACTIONS(6556),
    [sym__hex_literal] = ACTIONS(6556),
    [anon_sym_LPAREN_POUND] = ACTIONS(6558),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6558),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7917),
    [sym__conid] = ACTIONS(7921),
    [anon_sym_LBRACK] = ACTIONS(6565),
    [anon_sym_SQUOTE] = ACTIONS(7923),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(6570),
    [anon_sym_u2605] = ACTIONS(6570),
    [anon_sym_u27e6] = ACTIONS(6574),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6578),
  },
  [2751] = {
    [sym_integer] = STATE(9397),
    [sym__literal] = STATE(9397),
    [sym__unboxed_open] = STATE(2194),
    [sym_constructor] = STATE(8937),
    [sym_con_unit] = STATE(9397),
    [sym_con_list] = STATE(9397),
    [sym_con_tuple] = STATE(9397),
    [sym_qualified_type] = STATE(9551),
    [sym_tycon_arrow] = STATE(9551),
    [sym_type_literal] = STATE(3517),
    [sym__promoted_tycon] = STATE(9551),
    [sym_type_variable] = STATE(9551),
    [sym_type_parens] = STATE(3517),
    [sym_type_list] = STATE(3517),
    [sym_type_tuple] = STATE(3517),
    [sym__type_promotable_literal] = STATE(3517),
    [sym__type_promoted_literal] = STATE(3517),
    [sym__type_literal] = STATE(3517),
    [sym_type_name] = STATE(3517),
    [sym_type_star] = STATE(3517),
    [sym_type_unboxed_tuple] = STATE(3517),
    [sym_type_unboxed_sum] = STATE(3517),
    [sym__atype] = STATE(3517),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17578),
    [sym_splice] = STATE(3517),
    [sym_quasiquote] = STATE(3517),
    [aux_sym_constraint_repeat1] = STATE(3517),
    [ts_builtin_sym_end] = ACTIONS(5542),
    [sym__varid] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_float] = ACTIONS(5544),
    [sym_char] = ACTIONS(5544),
    [sym_string] = ACTIONS(5544),
    [sym__integer_literal] = ACTIONS(5547),
    [sym__binary_literal] = ACTIONS(5550),
    [sym__octal_literal] = ACTIONS(5550),
    [sym__hex_literal] = ACTIONS(5550),
    [anon_sym_LPAREN_POUND] = ACTIONS(5553),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5553),
    [anon_sym_u21d2] = ACTIONS(5556),
    [anon_sym_EQ_GT] = ACTIONS(5556),
    [anon_sym_u2192] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym__conid] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_u2605] = ACTIONS(5570),
    [anon_sym_AT] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_u27e6] = ACTIONS(5575),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5542),
    [sym_where] = ACTIONS(5542),
    [sym__splice_dollar] = ACTIONS(5578),
    [sym__consym] = ACTIONS(5542),
    [sym__tyconsym] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5581),
  },
  [2752] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2404),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16220),
    [sym_type_parens] = STATE(2404),
    [sym_type_list] = STATE(2404),
    [sym_type_tuple] = STATE(2404),
    [sym__type_promotable_literal] = STATE(2404),
    [sym__type_promoted_literal] = STATE(2404),
    [sym__type_literal] = STATE(2404),
    [sym_type_name] = STATE(2428),
    [sym_type_star] = STATE(2404),
    [sym_type_unboxed_tuple] = STATE(2404),
    [sym_type_unboxed_sum] = STATE(2404),
    [sym__atype] = STATE(2404),
    [sym_type_apply] = STATE(8296),
    [sym__btype] = STATE(8296),
    [sym_type_infix] = STATE(11075),
    [sym__type_infix] = STATE(10865),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2758),
    [sym__type_quantifiers] = STATE(13396),
    [sym__type_context] = STATE(13396),
    [sym__type_fun] = STATE(13396),
    [sym__type] = STATE(13396),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2404),
    [sym_quasiquote] = STATE(2404),
    [sym__varid] = ACTIONS(7443),
    [sym_float] = ACTIONS(7445),
    [sym_char] = ACTIONS(7445),
    [sym_string] = ACTIONS(7445),
    [sym__integer_literal] = ACTIONS(7447),
    [sym__binary_literal] = ACTIONS(7449),
    [sym__octal_literal] = ACTIONS(7449),
    [sym__hex_literal] = ACTIONS(7449),
    [anon_sym_LPAREN_POUND] = ACTIONS(7451),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8618),
    [sym__conid] = ACTIONS(8622),
    [anon_sym_LBRACK] = ACTIONS(7458),
    [anon_sym_SQUOTE] = ACTIONS(8624),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7463),
    [anon_sym_u2605] = ACTIONS(7463),
    [anon_sym_u27e6] = ACTIONS(7467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7469),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7471),
  },
  [2753] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2404),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16220),
    [sym_type_parens] = STATE(2404),
    [sym_type_list] = STATE(2404),
    [sym_type_tuple] = STATE(2404),
    [sym__type_promotable_literal] = STATE(2404),
    [sym__type_promoted_literal] = STATE(2404),
    [sym__type_literal] = STATE(2404),
    [sym_type_name] = STATE(2428),
    [sym_type_star] = STATE(2404),
    [sym_type_unboxed_tuple] = STATE(2404),
    [sym_type_unboxed_sum] = STATE(2404),
    [sym__atype] = STATE(2404),
    [sym_type_apply] = STATE(8296),
    [sym__btype] = STATE(8296),
    [sym_type_infix] = STATE(11075),
    [sym__type_infix] = STATE(10865),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2758),
    [sym__type_quantifiers] = STATE(13564),
    [sym__type_context] = STATE(13564),
    [sym__type_fun] = STATE(13564),
    [sym__type] = STATE(13564),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2404),
    [sym_quasiquote] = STATE(2404),
    [sym__varid] = ACTIONS(7443),
    [sym_float] = ACTIONS(7445),
    [sym_char] = ACTIONS(7445),
    [sym_string] = ACTIONS(7445),
    [sym__integer_literal] = ACTIONS(7447),
    [sym__binary_literal] = ACTIONS(7449),
    [sym__octal_literal] = ACTIONS(7449),
    [sym__hex_literal] = ACTIONS(7449),
    [anon_sym_LPAREN_POUND] = ACTIONS(7451),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8618),
    [sym__conid] = ACTIONS(8622),
    [anon_sym_LBRACK] = ACTIONS(7458),
    [anon_sym_SQUOTE] = ACTIONS(8624),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7463),
    [anon_sym_u2605] = ACTIONS(7463),
    [anon_sym_u27e6] = ACTIONS(7467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7469),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7471),
  },
  [2754] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2578),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16239),
    [sym_type_parens] = STATE(2578),
    [sym_type_list] = STATE(2578),
    [sym_type_tuple] = STATE(2578),
    [sym__type_promotable_literal] = STATE(2578),
    [sym__type_promoted_literal] = STATE(2578),
    [sym__type_literal] = STATE(2578),
    [sym_type_name] = STATE(2739),
    [sym_type_star] = STATE(2578),
    [sym_type_unboxed_tuple] = STATE(2578),
    [sym_type_unboxed_sum] = STATE(2578),
    [sym__atype] = STATE(2578),
    [sym_type_apply] = STATE(8886),
    [sym__btype] = STATE(8886),
    [sym_type_infix] = STATE(13572),
    [sym__type_infix] = STATE(13297),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2754),
    [sym__type_quantifiers] = STATE(16058),
    [sym__type_context] = STATE(16058),
    [sym__type_fun] = STATE(16058),
    [sym__type] = STATE(16058),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2578),
    [sym_quasiquote] = STATE(2578),
    [sym__varid] = ACTIONS(8680),
    [sym_float] = ACTIONS(8682),
    [sym_char] = ACTIONS(8682),
    [sym_string] = ACTIONS(8682),
    [sym__integer_literal] = ACTIONS(8684),
    [sym__binary_literal] = ACTIONS(8686),
    [sym__octal_literal] = ACTIONS(8686),
    [sym__hex_literal] = ACTIONS(8686),
    [anon_sym_LPAREN_POUND] = ACTIONS(8688),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8688),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8690),
    [sym__conid] = ACTIONS(8694),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_SQUOTE] = ACTIONS(8698),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8700),
    [anon_sym_u2605] = ACTIONS(8700),
    [anon_sym_u27e6] = ACTIONS(8702),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8704),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8706),
  },
  [2755] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2578),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16239),
    [sym_type_parens] = STATE(2578),
    [sym_type_list] = STATE(2578),
    [sym_type_tuple] = STATE(2578),
    [sym__type_promotable_literal] = STATE(2578),
    [sym__type_promoted_literal] = STATE(2578),
    [sym__type_literal] = STATE(2578),
    [sym_type_name] = STATE(2739),
    [sym_type_star] = STATE(2578),
    [sym_type_unboxed_tuple] = STATE(2578),
    [sym_type_unboxed_sum] = STATE(2578),
    [sym__atype] = STATE(2578),
    [sym_type_apply] = STATE(8886),
    [sym__btype] = STATE(8886),
    [sym_type_infix] = STATE(13572),
    [sym__type_infix] = STATE(13297),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2754),
    [sym__type_quantifiers] = STATE(16244),
    [sym__type_context] = STATE(16244),
    [sym__type_fun] = STATE(16244),
    [sym__type] = STATE(16244),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2578),
    [sym_quasiquote] = STATE(2578),
    [sym__varid] = ACTIONS(8680),
    [sym_float] = ACTIONS(8682),
    [sym_char] = ACTIONS(8682),
    [sym_string] = ACTIONS(8682),
    [sym__integer_literal] = ACTIONS(8684),
    [sym__binary_literal] = ACTIONS(8686),
    [sym__octal_literal] = ACTIONS(8686),
    [sym__hex_literal] = ACTIONS(8686),
    [anon_sym_LPAREN_POUND] = ACTIONS(8688),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8688),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8690),
    [sym__conid] = ACTIONS(8694),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_SQUOTE] = ACTIONS(8698),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8700),
    [anon_sym_u2605] = ACTIONS(8700),
    [anon_sym_u27e6] = ACTIONS(8702),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8704),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8706),
  },
  [2756] = {
    [sym_integer] = STATE(7854),
    [sym__literal] = STATE(7854),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(7251),
    [sym_con_unit] = STATE(7854),
    [sym_con_list] = STATE(7854),
    [sym_con_tuple] = STATE(7854),
    [sym_qualified_type] = STATE(7644),
    [sym_tycon_arrow] = STATE(7644),
    [sym_type_literal] = STATE(2578),
    [sym__promoted_tycon] = STATE(7644),
    [sym_type_variable] = STATE(7644),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16239),
    [sym_type_parens] = STATE(2578),
    [sym_type_list] = STATE(2578),
    [sym_type_tuple] = STATE(2578),
    [sym__type_promotable_literal] = STATE(2578),
    [sym__type_promoted_literal] = STATE(2578),
    [sym__type_literal] = STATE(2578),
    [sym_type_name] = STATE(2739),
    [sym_type_star] = STATE(2578),
    [sym_type_unboxed_tuple] = STATE(2578),
    [sym_type_unboxed_sum] = STATE(2578),
    [sym__atype] = STATE(2578),
    [sym_type_apply] = STATE(8886),
    [sym__btype] = STATE(8886),
    [sym_type_infix] = STATE(13572),
    [sym__type_infix] = STATE(13297),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2754),
    [sym__type_quantifiers] = STATE(16225),
    [sym__type_context] = STATE(16225),
    [sym__type_fun] = STATE(16225),
    [sym__type] = STATE(16225),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16860),
    [sym_splice] = STATE(2578),
    [sym_quasiquote] = STATE(2578),
    [sym__varid] = ACTIONS(8680),
    [sym_float] = ACTIONS(8682),
    [sym_char] = ACTIONS(8682),
    [sym_string] = ACTIONS(8682),
    [sym__integer_literal] = ACTIONS(8684),
    [sym__binary_literal] = ACTIONS(8686),
    [sym__octal_literal] = ACTIONS(8686),
    [sym__hex_literal] = ACTIONS(8686),
    [anon_sym_LPAREN_POUND] = ACTIONS(8688),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8688),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8690),
    [sym__conid] = ACTIONS(8694),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_SQUOTE] = ACTIONS(8698),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8700),
    [anon_sym_u2605] = ACTIONS(8700),
    [anon_sym_u27e6] = ACTIONS(8702),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8704),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8706),
  },
  [2757] = {
    [sym_integer] = STATE(8192),
    [sym__literal] = STATE(8192),
    [sym__unboxed_open] = STATE(2119),
    [sym_constructor] = STATE(8160),
    [sym_con_unit] = STATE(8192),
    [sym_con_list] = STATE(8192),
    [sym_con_tuple] = STATE(8192),
    [sym_qualified_type] = STATE(8196),
    [sym_tycon_arrow] = STATE(8196),
    [sym_type_literal] = STATE(2772),
    [sym__promoted_tycon] = STATE(8196),
    [sym_type_variable] = STATE(8196),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15861),
    [sym_type_parens] = STATE(2772),
    [sym_type_list] = STATE(2772),
    [sym_type_tuple] = STATE(2772),
    [sym__type_promotable_literal] = STATE(2772),
    [sym__type_promoted_literal] = STATE(2772),
    [sym__type_literal] = STATE(2772),
    [sym_type_name] = STATE(2796),
    [sym_type_star] = STATE(2772),
    [sym_type_unboxed_tuple] = STATE(2772),
    [sym_type_unboxed_sum] = STATE(2772),
    [sym__atype] = STATE(2772),
    [sym_type_apply] = STATE(9496),
    [sym__btype] = STATE(9496),
    [sym_type_infix] = STATE(14416),
    [sym__type_infix] = STATE(13973),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2757),
    [sym__type_quantifiers] = STATE(18148),
    [sym__type_context] = STATE(18148),
    [sym__type_fun] = STATE(18148),
    [sym__type] = STATE(18148),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16417),
    [sym_splice] = STATE(2772),
    [sym_quasiquote] = STATE(2772),
    [sym__varid] = ACTIONS(8520),
    [sym_float] = ACTIONS(8522),
    [sym_char] = ACTIONS(8522),
    [sym_string] = ACTIONS(8522),
    [sym__integer_literal] = ACTIONS(8524),
    [sym__binary_literal] = ACTIONS(8526),
    [sym__octal_literal] = ACTIONS(8526),
    [sym__hex_literal] = ACTIONS(8526),
    [anon_sym_LPAREN_POUND] = ACTIONS(8528),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8528),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8530),
    [sym__conid] = ACTIONS(8534),
    [anon_sym_LBRACK] = ACTIONS(8536),
    [anon_sym_SQUOTE] = ACTIONS(8538),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8540),
    [anon_sym_u2605] = ACTIONS(8540),
    [anon_sym_u27e6] = ACTIONS(8542),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8544),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8546),
  },
  [2758] = {
    [sym_integer] = STATE(6966),
    [sym__literal] = STATE(6966),
    [sym__unboxed_open] = STATE(2132),
    [sym_constructor] = STATE(6447),
    [sym_con_unit] = STATE(6966),
    [sym_con_list] = STATE(6966),
    [sym_con_tuple] = STATE(6966),
    [sym_qualified_type] = STATE(7015),
    [sym_tycon_arrow] = STATE(7015),
    [sym_type_literal] = STATE(2404),
    [sym__promoted_tycon] = STATE(7015),
    [sym_type_variable] = STATE(7015),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(16220),
    [sym_type_parens] = STATE(2404),
    [sym_type_list] = STATE(2404),
    [sym_type_tuple] = STATE(2404),
    [sym__type_promotable_literal] = STATE(2404),
    [sym__type_promoted_literal] = STATE(2404),
    [sym__type_literal] = STATE(2404),
    [sym_type_name] = STATE(2428),
    [sym_type_star] = STATE(2404),
    [sym_type_unboxed_tuple] = STATE(2404),
    [sym_type_unboxed_sum] = STATE(2404),
    [sym__atype] = STATE(2404),
    [sym_type_apply] = STATE(8296),
    [sym__btype] = STATE(8296),
    [sym_type_infix] = STATE(11075),
    [sym__type_infix] = STATE(10865),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2758),
    [sym__type_quantifiers] = STATE(13469),
    [sym__type_context] = STATE(13469),
    [sym__type_fun] = STATE(13469),
    [sym__type] = STATE(13469),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(17559),
    [sym_splice] = STATE(2404),
    [sym_quasiquote] = STATE(2404),
    [sym__varid] = ACTIONS(7443),
    [sym_float] = ACTIONS(7445),
    [sym_char] = ACTIONS(7445),
    [sym_string] = ACTIONS(7445),
    [sym__integer_literal] = ACTIONS(7447),
    [sym__binary_literal] = ACTIONS(7449),
    [sym__octal_literal] = ACTIONS(7449),
    [sym__hex_literal] = ACTIONS(7449),
    [anon_sym_LPAREN_POUND] = ACTIONS(7451),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7451),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8618),
    [sym__conid] = ACTIONS(8622),
    [anon_sym_LBRACK] = ACTIONS(7458),
    [anon_sym_SQUOTE] = ACTIONS(8624),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(7463),
    [anon_sym_u2605] = ACTIONS(7463),
    [anon_sym_u27e6] = ACTIONS(7467),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7469),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7471),
  },
  [2759] = {
    [sym_integer] = STATE(8192),
    [sym__literal] = STATE(8192),
    [sym__unboxed_open] = STATE(2119),
    [sym_constructor] = STATE(8160),
    [sym_con_unit] = STATE(8192),
    [sym_con_list] = STATE(8192),
    [sym_con_tuple] = STATE(8192),
    [sym_qualified_type] = STATE(8196),
    [sym_tycon_arrow] = STATE(8196),
    [sym_type_literal] = STATE(2772),
    [sym__promoted_tycon] = STATE(8196),
    [sym_type_variable] = STATE(8196),
    [sym__forall_kw] = STATE(13834),
    [sym__forall] = STATE(15861),
    [sym_type_parens] = STATE(2772),
    [sym_type_list] = STATE(2772),
    [sym_type_tuple] = STATE(2772),
    [sym__type_promotable_literal] = STATE(2772),
    [sym__type_promoted_literal] = STATE(2772),
    [sym__type_literal] = STATE(2772),
    [sym_type_name] = STATE(2796),
    [sym_type_star] = STATE(2772),
    [sym_type_unboxed_tuple] = STATE(2772),
    [sym_type_unboxed_sum] = STATE(2772),
    [sym__atype] = STATE(2772),
    [sym_type_apply] = STATE(9496),
    [sym__btype] = STATE(9496),
    [sym_type_infix] = STATE(14416),
    [sym__type_infix] = STATE(13973),
    [sym_constraint] = STATE(17959),
    [sym__context_constraints] = STATE(17959),
    [sym__context] = STATE(2757),
    [sym__type_quantifiers] = STATE(18129),
    [sym__type_context] = STATE(18129),
    [sym__type_fun] = STATE(18129),
    [sym__type] = STATE(18129),
    [sym__modid] = STATE(23316),
    [aux_sym__qualifying_module] = STATE(16417),
    [sym_splice] = STATE(2772),
    [sym_quasiquote] = STATE(2772),
    [sym__varid] = ACTIONS(8520),
    [sym_float] = ACTIONS(8522),
    [sym_char] = ACTIONS(8522),
    [sym_string] = ACTIONS(8522),
    [sym__integer_literal] = ACTIONS(8524),
    [sym__binary_literal] = ACTIONS(8526),
    [sym__octal_literal] = ACTIONS(8526),
    [sym__hex_literal] = ACTIONS(8526),
    [anon_sym_LPAREN_POUND] = ACTIONS(8528),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8528),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8530),
    [sym__conid] = ACTIONS(8534),
    [anon_sym_LBRACK] = ACTIONS(8536),
    [anon_sym_SQUOTE] = ACTIONS(8538),
    [anon_sym_forall] = ACTIONS(2037),
    [anon_sym_u2200] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(8540),
    [anon_sym_u2605] = ACTIONS(8540),
    [anon_sym_u27e6] = ACTIONS(8542),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8544),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8546),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 24,
    ACTIONS(5539), 1,
      sym__varid,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5573), 1,
      anon_sym_in,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 10,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [113] = 33,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    ACTIONS(10585), 1,
      anon_sym_RPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(19443), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [244] = 24,
    ACTIONS(5539), 1,
      sym__varid,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5573), 1,
      anon_sym_deriving,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [357] = 30,
    ACTIONS(10587), 1,
      sym__varid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(10597), 1,
      anon_sym_LPAREN,
    ACTIONS(10599), 1,
      sym__conid,
    ACTIONS(10602), 1,
      anon_sym_LBRACK,
    ACTIONS(10604), 1,
      anon_sym_LBRACE,
    ACTIONS(10606), 1,
      anon_sym_AT,
    ACTIONS(10608), 1,
      anon_sym__,
    ACTIONS(10610), 1,
      anon_sym_u27e6,
    ACTIONS(10612), 1,
      sym__splice_dollar,
    ACTIONS(10614), 1,
      sym_quasiquote_start,
    ACTIONS(10616), 1,
      sym__strict,
    ACTIONS(10618), 1,
      sym__lazy,
    STATE(431), 1,
      sym__unboxed_open,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8295), 1,
      sym__pat_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(8376), 1,
      sym_variable,
    STATE(8592), 1,
      sym_literal,
    STATE(14001), 1,
      sym_pat_fields,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10595), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 8,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(2850), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [482] = 24,
    ACTIONS(5528), 1,
      anon_sym_in,
    ACTIONS(10620), 1,
      sym__varid,
    ACTIONS(10626), 1,
      sym__integer_literal,
    ACTIONS(10635), 1,
      anon_sym_LPAREN,
    ACTIONS(10638), 1,
      sym__conid,
    ACTIONS(10641), 1,
      anon_sym_LBRACK,
    ACTIONS(10644), 1,
      anon_sym_SQUOTE,
    ACTIONS(10650), 1,
      anon_sym_AT,
    ACTIONS(10653), 1,
      anon_sym_u27e6,
    ACTIONS(10656), 1,
      sym__splice_dollar,
    ACTIONS(10659), 1,
      sym_quasiquote_start,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(8160), 1,
      sym_constructor,
    STATE(16417), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10632), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10647), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10623), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10629), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8192), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5496), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2764), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [595] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3200), 1,
      sym_forall,
    STATE(3570), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10593), 1,
      sym_type_infix,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15698), 1,
      sym__type_infix,
    STATE(15953), 1,
      sym__forall,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(20371), 1,
      sym__datainst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [728] = 24,
    ACTIONS(5539), 1,
      sym__varid,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5573), 1,
      anon_sym_in,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [841] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3200), 1,
      sym_forall,
    STATE(3570), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10593), 1,
      sym_type_infix,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15698), 1,
      sym__type_infix,
    STATE(15953), 1,
      sym__forall,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(20395), 1,
      sym__datainst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [974] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(7037), 1,
      sym__varid,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7061), 1,
      anon_sym_u27e6,
    ACTIONS(7063), 1,
      sym__splice_dollar,
    ACTIONS(7065), 1,
      sym_quasiquote_start,
    ACTIONS(7779), 1,
      anon_sym_LPAREN,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(7785), 1,
      anon_sym_SQUOTE,
    STATE(2091), 1,
      sym__unboxed_open,
    STATE(2494), 1,
      sym_type_name,
    STATE(3192), 1,
      sym_forall,
    STATE(3564), 1,
      sym_context,
    STATE(6654), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12340), 1,
      sym_type_infix,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(13903), 1,
      sym__type_infix,
    STATE(14199), 1,
      sym__datainst,
    STATE(15953), 1,
      sym__forall,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7045), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7057), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8252), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2390), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1107] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3200), 1,
      sym_forall,
    STATE(3570), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10593), 1,
      sym_type_infix,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15698), 1,
      sym__type_infix,
    STATE(15953), 1,
      sym__forall,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(20414), 1,
      sym__datainst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1240] = 23,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    ACTIONS(6630), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 11,
      sym__consym,
      sym__tyconsym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [1351] = 33,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    ACTIONS(10662), 1,
      anon_sym_RPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(19951), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1482] = 24,
    ACTIONS(5491), 1,
      anon_sym_in,
    ACTIONS(8520), 1,
      sym__varid,
    ACTIONS(8524), 1,
      sym__integer_literal,
    ACTIONS(8536), 1,
      anon_sym_LBRACK,
    ACTIONS(8542), 1,
      anon_sym_u27e6,
    ACTIONS(8544), 1,
      sym__splice_dollar,
    ACTIONS(8546), 1,
      sym_quasiquote_start,
    ACTIONS(10664), 1,
      anon_sym_LPAREN,
    ACTIONS(10666), 1,
      sym__conid,
    ACTIONS(10669), 1,
      anon_sym_SQUOTE,
    ACTIONS(10672), 1,
      anon_sym_AT,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(8160), 1,
      sym_constructor,
    STATE(16417), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8528), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8540), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8522), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8526), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8192), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5483), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2777), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1595] = 33,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    ACTIONS(10674), 1,
      anon_sym_RPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(18111), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1726] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(8077), 1,
      sym__varid,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8832), 1,
      anon_sym_LPAREN,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(2522), 1,
      sym_type_name,
    STATE(3188), 1,
      sym_forall,
    STATE(3574), 1,
      sym_context,
    STATE(7002), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12864), 1,
      sym_type_infix,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(14311), 1,
      sym__type_infix,
    STATE(14682), 1,
      sym__datainst,
    STATE(15953), 1,
      sym__forall,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8442), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2504), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1859] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(8077), 1,
      sym__varid,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8832), 1,
      anon_sym_LPAREN,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(2522), 1,
      sym_type_name,
    STATE(3188), 1,
      sym_forall,
    STATE(3574), 1,
      sym_context,
    STATE(7002), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12864), 1,
      sym_type_infix,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(14311), 1,
      sym__type_infix,
    STATE(14920), 1,
      sym__datainst,
    STATE(15953), 1,
      sym__forall,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8442), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2504), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1992] = 33,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    ACTIONS(10676), 1,
      anon_sym_RPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(18098), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [2123] = 24,
    ACTIONS(5475), 1,
      anon_sym_in,
    ACTIONS(8520), 1,
      sym__varid,
    ACTIONS(8524), 1,
      sym__integer_literal,
    ACTIONS(8536), 1,
      anon_sym_LBRACK,
    ACTIONS(8542), 1,
      anon_sym_u27e6,
    ACTIONS(8544), 1,
      sym__splice_dollar,
    ACTIONS(8546), 1,
      sym_quasiquote_start,
    ACTIONS(10664), 1,
      anon_sym_LPAREN,
    ACTIONS(10672), 1,
      anon_sym_AT,
    ACTIONS(10678), 1,
      sym__conid,
    ACTIONS(10681), 1,
      anon_sym_SQUOTE,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(8160), 1,
      sym_constructor,
    STATE(16417), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8528), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8540), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8522), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8526), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8192), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5451), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2764), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2236] = 24,
    ACTIONS(5539), 1,
      sym__varid,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5573), 1,
      anon_sym_deriving,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [2349] = 33,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    ACTIONS(10684), 1,
      anon_sym_RPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(17956), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [2480] = 23,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    ACTIONS(6630), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 11,
      sym__arith_dotdot,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [2591] = 30,
    ACTIONS(10686), 1,
      sym__varid,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    ACTIONS(10698), 1,
      sym__conid,
    ACTIONS(10701), 1,
      anon_sym_LBRACK,
    ACTIONS(10703), 1,
      anon_sym_LBRACE,
    ACTIONS(10705), 1,
      anon_sym_AT,
    ACTIONS(10707), 1,
      anon_sym__,
    ACTIONS(10709), 1,
      anon_sym_u27e6,
    ACTIONS(10711), 1,
      sym__splice_dollar,
    ACTIONS(10713), 1,
      sym_quasiquote_start,
    ACTIONS(10715), 1,
      sym__strict,
    ACTIONS(10717), 1,
      sym__lazy,
    STATE(334), 1,
      sym__unboxed_open,
    STATE(8270), 1,
      sym_constructor,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8339), 1,
      sym_variable,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_literal,
    STATE(14045), 1,
      sym_pat_fields,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10694), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10688), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8536), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 8,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2804), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [2716] = 24,
    ACTIONS(10719), 1,
      sym__varid,
    ACTIONS(10725), 1,
      sym__integer_literal,
    ACTIONS(10734), 1,
      anon_sym_LPAREN,
    ACTIONS(10740), 1,
      sym__conid,
    ACTIONS(10743), 1,
      anon_sym_LBRACK,
    ACTIONS(10746), 1,
      anon_sym_SQUOTE,
    ACTIONS(10752), 1,
      anon_sym_u27e6,
    ACTIONS(10755), 1,
      sym__splice_dollar,
    ACTIONS(10758), 1,
      sym_quasiquote_start,
    STATE(2097), 1,
      sym__unboxed_open,
    STATE(9746), 1,
      sym_constructor,
    STATE(17572), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(10731), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10737), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(10749), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10722), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10728), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10031), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9934), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 9,
      sym__consym,
      sym__tyconsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3543), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [2829] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3200), 1,
      sym_forall,
    STATE(3570), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10593), 1,
      sym_type_infix,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15698), 1,
      sym__type_infix,
    STATE(15953), 1,
      sym__forall,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(20615), 1,
      sym__datainst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [2962] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(7007), 1,
      sym__varid,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8243), 1,
      anon_sym_LPAREN,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(2458), 1,
      sym_type_name,
    STATE(3193), 1,
      sym_forall,
    STATE(3544), 1,
      sym_context,
    STATE(6430), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12156), 1,
      sym_type_infix,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(14015), 1,
      sym__type_infix,
    STATE(14446), 1,
      sym__datainst,
    STATE(15953), 1,
      sym__forall,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8266), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2389), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [3095] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(7007), 1,
      sym__varid,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8243), 1,
      anon_sym_LPAREN,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(2458), 1,
      sym_type_name,
    STATE(3193), 1,
      sym_forall,
    STATE(3544), 1,
      sym_context,
    STATE(6430), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12156), 1,
      sym_type_infix,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(14015), 1,
      sym__type_infix,
    STATE(14437), 1,
      sym__datainst,
    STATE(15953), 1,
      sym__forall,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8266), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2389), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [3228] = 33,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    ACTIONS(10761), 1,
      anon_sym_RPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(17979), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [3359] = 34,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3200), 1,
      sym_forall,
    STATE(3570), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10593), 1,
      sym_type_infix,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15698), 1,
      sym__type_infix,
    STATE(15953), 1,
      sym__forall,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(21254), 1,
      sym__datainst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [3492] = 23,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    ACTIONS(6630), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 11,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [3603] = 23,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    ACTIONS(6630), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 11,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [3714] = 28,
    ACTIONS(10763), 1,
      sym__varid,
    ACTIONS(10771), 1,
      sym__integer_literal,
    ACTIONS(10780), 1,
      anon_sym_LPAREN,
    ACTIONS(10783), 1,
      sym__conid,
    ACTIONS(10786), 1,
      anon_sym_LBRACK,
    ACTIONS(10789), 1,
      anon_sym_AT,
    ACTIONS(10792), 1,
      anon_sym__,
    ACTIONS(10795), 1,
      anon_sym_u27e6,
    ACTIONS(10798), 1,
      sym__splice_dollar,
    ACTIONS(10801), 1,
      sym_quasiquote_start,
    ACTIONS(10804), 1,
      sym__strict,
    ACTIONS(10807), 1,
      sym__lazy,
    STATE(302), 1,
      sym__unboxed_open,
    STATE(8191), 1,
      sym_constructor,
    STATE(8235), 1,
      sym__pat_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8271), 1,
      sym_variable,
    STATE(8306), 1,
      sym__qcon,
    STATE(8398), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10777), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10768), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10774), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8373), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 9,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_EQ,
    STATE(2790), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [3834] = 30,
    ACTIONS(10810), 1,
      sym__varid,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(10820), 1,
      anon_sym_LPAREN,
    ACTIONS(10822), 1,
      sym__conid,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10827), 1,
      anon_sym_LBRACE,
    ACTIONS(10829), 1,
      anon_sym_AT,
    ACTIONS(10831), 1,
      anon_sym__,
    ACTIONS(10833), 1,
      anon_sym_u27e6,
    ACTIONS(10835), 1,
      sym__splice_dollar,
    ACTIONS(10837), 1,
      sym_quasiquote_start,
    ACTIONS(10839), 1,
      sym__strict,
    ACTIONS(10841), 1,
      sym__lazy,
    STATE(384), 1,
      sym__unboxed_open,
    STATE(8454), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8499), 1,
      sym_variable,
    STATE(8502), 1,
      sym__qcon,
    STATE(8809), 1,
      sym_literal,
    STATE(14460), 1,
      sym_pat_fields,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10818), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10812), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3009), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [3958] = 32,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(21173), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [4086] = 32,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(20842), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [4214] = 32,
    ACTIONS(2013), 1,
      sym__varid,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(10288), 1,
      anon_sym_LPAREN,
    ACTIONS(10290), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2793), 1,
      sym__context,
    STATE(3150), 1,
      sym_type_name,
    STATE(7057), 1,
      sym_constructor,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(16104), 1,
      sym__forall,
    STATE(16542), 1,
      sym_constraint,
    STATE(17063), 1,
      sym_type_infix,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10886), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(21048), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [4342] = 28,
    ACTIONS(10388), 1,
      sym__varid,
    ACTIONS(10394), 1,
      sym__integer_literal,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    ACTIONS(10405), 1,
      anon_sym_LBRACK,
    ACTIONS(10409), 1,
      anon_sym_AT,
    ACTIONS(10411), 1,
      anon_sym__,
    ACTIONS(10413), 1,
      anon_sym_u27e6,
    ACTIONS(10415), 1,
      sym__splice_dollar,
    ACTIONS(10417), 1,
      sym_quasiquote_start,
    ACTIONS(10419), 1,
      sym__strict,
    ACTIONS(10421), 1,
      sym__lazy,
    ACTIONS(10845), 1,
      sym__conid,
    STATE(302), 1,
      sym__unboxed_open,
    STATE(8191), 1,
      sym_constructor,
    STATE(8235), 1,
      sym__pat_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8271), 1,
      sym_variable,
    STATE(8306), 1,
      sym__qcon,
    STATE(8398), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10398), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10392), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8373), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 9,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_EQ,
    STATE(2790), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [4462] = 24,
    ACTIONS(5539), 1,
      sym__varid,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5573), 1,
      anon_sym_in,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 9,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [4574] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10850), 1,
      anon_sym_SEMI,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10868), 1,
      anon_sym_RBRACE,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17111), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [4701] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10884), 1,
      anon_sym_SEMI,
    ACTIONS(10886), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17016), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [4828] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10888), 1,
      anon_sym_SEMI,
    ACTIONS(10890), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17774), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [4955] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10892), 1,
      anon_sym_SEMI,
    ACTIONS(10894), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17831), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [5082] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6098), 1,
      sym__conid,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(10896), 1,
      anon_sym_LPAREN,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(2411), 1,
      sym_constructor,
    STATE(8488), 1,
      sym_type_tuple,
    STATE(8515), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8494), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15511), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18721), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5203] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10898), 1,
      anon_sym_SEMI,
    ACTIONS(10900), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17113), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [5330] = 33,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3158), 1,
      sym_type_name,
    STATE(3284), 1,
      sym_forall,
    STATE(3571), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15953), 1,
      sym__forall,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(17467), 1,
      sym_constraint,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5459] = 28,
    ACTIONS(10686), 1,
      sym__varid,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    ACTIONS(10701), 1,
      anon_sym_LBRACK,
    ACTIONS(10705), 1,
      anon_sym_AT,
    ACTIONS(10707), 1,
      anon_sym__,
    ACTIONS(10709), 1,
      anon_sym_u27e6,
    ACTIONS(10711), 1,
      sym__splice_dollar,
    ACTIONS(10713), 1,
      sym_quasiquote_start,
    ACTIONS(10715), 1,
      sym__strict,
    ACTIONS(10717), 1,
      sym__lazy,
    ACTIONS(10902), 1,
      sym__conid,
    STATE(334), 1,
      sym__unboxed_open,
    STATE(8270), 1,
      sym_constructor,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8339), 1,
      sym_variable,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10694), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10688), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8536), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 8,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2928), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [5578] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10905), 1,
      anon_sym_SEMI,
    ACTIONS(10907), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17771), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [5705] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10909), 1,
      anon_sym_SEMI,
    ACTIONS(10911), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17753), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [5832] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10913), 1,
      anon_sym_SEMI,
    ACTIONS(10915), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16801), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [5959] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10917), 1,
      anon_sym_SEMI,
    ACTIONS(10919), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17129), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6086] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10921), 1,
      anon_sym_SEMI,
    ACTIONS(10923), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17655), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6213] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10925), 1,
      anon_sym_SEMI,
    ACTIONS(10927), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16780), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6340] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10929), 1,
      anon_sym_SEMI,
    ACTIONS(10931), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17630), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6467] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10933), 1,
      anon_sym_SEMI,
    ACTIONS(10935), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17752), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6594] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10937), 1,
      anon_sym_SEMI,
    ACTIONS(10939), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17652), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6721] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10941), 1,
      anon_sym_SEMI,
    ACTIONS(10943), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17634), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [6848] = 30,
    ACTIONS(10945), 1,
      sym__varid,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(10955), 1,
      anon_sym_LPAREN,
    ACTIONS(10957), 1,
      sym__conid,
    ACTIONS(10960), 1,
      anon_sym_LBRACK,
    ACTIONS(10962), 1,
      anon_sym_LBRACE,
    ACTIONS(10964), 1,
      anon_sym_AT,
    ACTIONS(10966), 1,
      anon_sym__,
    ACTIONS(10968), 1,
      anon_sym_u27e6,
    ACTIONS(10970), 1,
      sym__splice_dollar,
    ACTIONS(10972), 1,
      sym_quasiquote_start,
    ACTIONS(10974), 1,
      sym__strict,
    ACTIONS(10976), 1,
      sym__lazy,
    STATE(382), 1,
      sym__unboxed_open,
    STATE(8498), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8833), 1,
      sym_variable,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(9103), 1,
      sym_literal,
    STATE(14907), 1,
      sym_pat_fields,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10953), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10947), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9340), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 6,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3136), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [6971] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10978), 1,
      anon_sym_SEMI,
    ACTIONS(10980), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17723), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [7098] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10982), 1,
      anon_sym_SEMI,
    ACTIONS(10984), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16676), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [7225] = 34,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(1610), 1,
      sym__arrow,
    STATE(3296), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17933), 1,
      sym__alt_variants,
    STATE(18701), 1,
      sym_guards,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10996), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14695), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [7356] = 30,
    ACTIONS(11018), 1,
      sym__varid,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(11028), 1,
      anon_sym_LPAREN,
    ACTIONS(11030), 1,
      sym__conid,
    ACTIONS(11033), 1,
      anon_sym_LBRACK,
    ACTIONS(11035), 1,
      anon_sym_LBRACE,
    ACTIONS(11037), 1,
      anon_sym_AT,
    ACTIONS(11039), 1,
      anon_sym__,
    ACTIONS(11041), 1,
      anon_sym_u27e6,
    ACTIONS(11043), 1,
      sym__splice_dollar,
    ACTIONS(11045), 1,
      sym_quasiquote_start,
    ACTIONS(11047), 1,
      sym__strict,
    ACTIONS(11049), 1,
      sym__lazy,
    STATE(282), 1,
      sym__unboxed_open,
    STATE(8500), 1,
      sym_constructor,
    STATE(8509), 1,
      sym__pat_constructor,
    STATE(8780), 1,
      sym_variable,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(9108), 1,
      sym_literal,
    STATE(14728), 1,
      sym_pat_fields,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11026), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 6,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3124), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [7479] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11051), 1,
      anon_sym_SEMI,
    ACTIONS(11053), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16631), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [7606] = 33,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7007), 1,
      sym__varid,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(11055), 1,
      anon_sym_LPAREN,
    ACTIONS(11057), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2992), 1,
      sym_type_name,
    STATE(3243), 1,
      sym_forall,
    STATE(3609), 1,
      sym_context,
    STATE(6430), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15027), 1,
      sym_type_infix,
    STATE(15575), 1,
      sym_constraint,
    STATE(15953), 1,
      sym__forall,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10896), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7735] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11059), 1,
      anon_sym_SEMI,
    ACTIONS(11061), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16992), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [7862] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11063), 1,
      anon_sym_SEMI,
    ACTIONS(11065), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17533), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [7989] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11067), 1,
      anon_sym_SEMI,
    ACTIONS(11069), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17591), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8116] = 32,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11081), 1,
      anon_sym_DASH,
    ACTIONS(11083), 1,
      anon_sym_LPAREN,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(2672), 1,
      sym__pat_constructor,
    STATE(8243), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8306), 1,
      sym__qcon,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(20812), 1,
      sym__pattern_type,
    STATE(20825), 1,
      sym__pattern_equals,
    STATE(20826), 1,
      sym__pattern_arrow,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17530), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11247), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8243] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6110), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11097), 1,
      anon_sym_LPAREN,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(2413), 1,
      sym_constructor,
    STATE(8529), 1,
      sym_type_tuple,
    STATE(8550), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8513), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15102), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18975), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [8364] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11099), 1,
      anon_sym_SEMI,
    ACTIONS(11101), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17515), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8491] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11103), 1,
      anon_sym_SEMI,
    ACTIONS(11105), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16978), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8618] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11107), 1,
      anon_sym_SEMI,
    ACTIONS(11109), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16598), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8745] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11111), 1,
      anon_sym_SEMI,
    ACTIONS(11113), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17315), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8872] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11115), 1,
      anon_sym_SEMI,
    ACTIONS(11117), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17031), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [8999] = 33,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7037), 1,
      sym__varid,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(11119), 1,
      anon_sym_LPAREN,
    ACTIONS(11121), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2998), 1,
      sym_type_name,
    STATE(3221), 1,
      sym_forall,
    STATE(3552), 1,
      sym_context,
    STATE(6654), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15278), 1,
      sym_type_infix,
    STATE(15281), 1,
      sym_constraint,
    STATE(15953), 1,
      sym__forall,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10888), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9128] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11123), 1,
      anon_sym_SEMI,
    ACTIONS(11125), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17414), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [9255] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11127), 1,
      anon_sym_SEMI,
    ACTIONS(11129), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17390), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [9382] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11131), 1,
      anon_sym_SEMI,
    ACTIONS(11133), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17396), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [9509] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11135), 1,
      anon_sym_SEMI,
    ACTIONS(11137), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16564), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [9636] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11139), 1,
      anon_sym_SEMI,
    ACTIONS(11141), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16890), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [9763] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11143), 1,
      anon_sym_SEMI,
    ACTIONS(11145), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16854), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [9890] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11147), 1,
      anon_sym_SEMI,
    ACTIONS(11149), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17293), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10017] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11151), 1,
      anon_sym_SEMI,
    ACTIONS(11153), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17274), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10144] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11155), 1,
      anon_sym_SEMI,
    ACTIONS(11157), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17044), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10271] = 28,
    ACTIONS(6194), 1,
      anon_sym_LBRACE,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(6262), 1,
      sym__strict,
    ACTIONS(6264), 1,
      sym__lazy,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(18649), 1,
      sym_record_fields,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(18648), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14123), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [10390] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11159), 1,
      anon_sym_SEMI,
    ACTIONS(11161), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16782), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10517] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11163), 1,
      anon_sym_SEMI,
    ACTIONS(11165), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17528), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10644] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11167), 1,
      anon_sym_SEMI,
    ACTIONS(11169), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16761), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10771] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11171), 1,
      anon_sym_SEMI,
    ACTIONS(11173), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17505), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [10898] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11175), 1,
      anon_sym_SEMI,
    ACTIONS(11177), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17811), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11025] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11179), 1,
      anon_sym_SEMI,
    ACTIONS(11181), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17104), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11152] = 33,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6236), 1,
      sym__varid,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(11183), 1,
      anon_sym_LPAREN,
    ACTIONS(11185), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3138), 1,
      sym_type_name,
    STATE(3230), 1,
      sym_forall,
    STATE(3556), 1,
      sym_context,
    STATE(7796), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15751), 1,
      sym_type_infix,
    STATE(15809), 1,
      sym_constraint,
    STATE(15953), 1,
      sym__forall,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10879), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [11281] = 28,
    ACTIONS(10587), 1,
      sym__varid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(10597), 1,
      anon_sym_LPAREN,
    ACTIONS(10602), 1,
      anon_sym_LBRACK,
    ACTIONS(10606), 1,
      anon_sym_AT,
    ACTIONS(10608), 1,
      anon_sym__,
    ACTIONS(10610), 1,
      anon_sym_u27e6,
    ACTIONS(10612), 1,
      sym__splice_dollar,
    ACTIONS(10614), 1,
      sym_quasiquote_start,
    ACTIONS(10616), 1,
      sym__strict,
    ACTIONS(10618), 1,
      sym__lazy,
    ACTIONS(11187), 1,
      sym__conid,
    STATE(431), 1,
      sym__unboxed_open,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8295), 1,
      sym__pat_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(8376), 1,
      sym_variable,
    STATE(8592), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10595), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 8,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(2870), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [11400] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11190), 1,
      anon_sym_SEMI,
    ACTIONS(11192), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16450), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11527] = 32,
    ACTIONS(693), 1,
      anon_sym_SEMI,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(4578), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(20534), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11654] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11194), 1,
      anon_sym_SEMI,
    ACTIONS(11196), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17561), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11781] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11198), 1,
      anon_sym_SEMI,
    ACTIONS(11200), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16415), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11908] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11202), 1,
      anon_sym_SEMI,
    ACTIONS(11204), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17155), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12035] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11206), 1,
      anon_sym_SEMI,
    ACTIONS(11208), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17538), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12162] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6098), 1,
      sym__conid,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(10896), 1,
      anon_sym_LPAREN,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(2411), 1,
      sym_constructor,
    STATE(8488), 1,
      sym_type_tuple,
    STATE(8515), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8494), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15039), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18721), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [12283] = 32,
    ACTIONS(693), 1,
      anon_sym_SEMI,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(4578), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(20828), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12410] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11210), 1,
      anon_sym_SEMI,
    ACTIONS(11212), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17136), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12537] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(6194), 1,
      anon_sym_LBRACE,
    ACTIONS(6196), 1,
      sym__strict,
    ACTIONS(6198), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18704), 1,
      sym_record_fields,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(20726), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14348), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [12656] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11214), 1,
      anon_sym_SEMI,
    ACTIONS(11216), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17676), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12783] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11218), 1,
      anon_sym_SEMI,
    ACTIONS(11220), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16662), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12910] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11222), 1,
      anon_sym_SEMI,
    ACTIONS(11224), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16851), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13037] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11226), 1,
      anon_sym_SEMI,
    ACTIONS(11228), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17626), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13164] = 32,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11081), 1,
      anon_sym_DASH,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(11230), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(2672), 1,
      sym__pat_constructor,
    STATE(8197), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8306), 1,
      sym__qcon,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(17983), 1,
      sym__pattern_type,
    STATE(17987), 1,
      sym__pattern_equals,
    STATE(17994), 1,
      sym__pattern_arrow,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17154), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11247), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13291] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11232), 1,
      anon_sym_SEMI,
    ACTIONS(11234), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17247), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13418] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11236), 1,
      anon_sym_SEMI,
    ACTIONS(11238), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16895), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13545] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11240), 1,
      anon_sym_SEMI,
    ACTIONS(11242), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17131), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13672] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11244), 1,
      anon_sym_SEMI,
    ACTIONS(11246), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16997), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13799] = 28,
    ACTIONS(11248), 1,
      sym__varid,
    ACTIONS(11254), 1,
      sym__integer_literal,
    ACTIONS(11263), 1,
      anon_sym_LPAREN,
    ACTIONS(11266), 1,
      sym__conid,
    ACTIONS(11269), 1,
      anon_sym_LBRACK,
    ACTIONS(11272), 1,
      anon_sym_AT,
    ACTIONS(11275), 1,
      anon_sym__,
    ACTIONS(11278), 1,
      anon_sym_u27e6,
    ACTIONS(11281), 1,
      sym__splice_dollar,
    ACTIONS(11284), 1,
      sym_quasiquote_start,
    ACTIONS(11287), 1,
      sym__strict,
    ACTIONS(11290), 1,
      sym__lazy,
    STATE(431), 1,
      sym__unboxed_open,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8295), 1,
      sym__pat_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(8376), 1,
      sym_variable,
    STATE(8592), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11260), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11251), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11257), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 8,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(2870), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [13918] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11293), 1,
      anon_sym_SEMI,
    ACTIONS(11295), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16765), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14045] = 23,
    ACTIONS(11297), 1,
      sym__varid,
    ACTIONS(11303), 1,
      sym__integer_literal,
    ACTIONS(11312), 1,
      anon_sym_LPAREN,
    ACTIONS(11315), 1,
      sym__conid,
    ACTIONS(11318), 1,
      anon_sym_LBRACK,
    ACTIONS(11321), 1,
      anon_sym_SQUOTE,
    ACTIONS(11327), 1,
      anon_sym_u27e6,
    ACTIONS(11330), 1,
      sym__splice_dollar,
    ACTIONS(11333), 1,
      sym_quasiquote_start,
    STATE(2150), 1,
      sym__unboxed_open,
    STATE(8765), 1,
      sym_constructor,
    STATE(16504), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11309), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11324), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11300), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11306), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9074), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9253), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5556), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3187), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [14154] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6116), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11336), 1,
      anon_sym_LPAREN,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(2481), 1,
      sym_constructor,
    STATE(8841), 1,
      sym_type_tuple,
    STATE(8844), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8830), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(16198), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18636), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [14275] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11338), 1,
      anon_sym_SEMI,
    ACTIONS(11340), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16268), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14402] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6110), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11097), 1,
      anon_sym_LPAREN,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(2413), 1,
      sym_constructor,
    STATE(8529), 1,
      sym_type_tuple,
    STATE(8550), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8513), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15764), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18975), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [14523] = 24,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5573), 1,
      anon_sym_EQ,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    ACTIONS(6630), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5556), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5542), 8,
      sym__consym,
      sym__tyconsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_PERCENT,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [14634] = 30,
    ACTIONS(11342), 1,
      sym__varid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(11352), 1,
      anon_sym_LPAREN,
    ACTIONS(11354), 1,
      sym__conid,
    ACTIONS(11357), 1,
      anon_sym_LBRACK,
    ACTIONS(11359), 1,
      anon_sym_LBRACE,
    ACTIONS(11361), 1,
      anon_sym_AT,
    ACTIONS(11363), 1,
      anon_sym__,
    ACTIONS(11365), 1,
      anon_sym_u27e6,
    ACTIONS(11367), 1,
      sym__splice_dollar,
    ACTIONS(11369), 1,
      sym_quasiquote_start,
    ACTIONS(11371), 1,
      sym__strict,
    ACTIONS(11373), 1,
      sym__lazy,
    STATE(311), 1,
      sym__unboxed_open,
    STATE(8555), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(8868), 1,
      sym__qcon,
    STATE(9208), 1,
      sym_literal,
    STATE(14656), 1,
      sym_pat_fields,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11350), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11344), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9046), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 6,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(3118), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [14757] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11375), 1,
      anon_sym_SEMI,
    ACTIONS(11377), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16906), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14884] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11379), 1,
      anon_sym_SEMI,
    ACTIONS(11381), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16531), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15011] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6098), 1,
      sym__conid,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(10896), 1,
      anon_sym_LPAREN,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(2411), 1,
      sym_constructor,
    STATE(8488), 1,
      sym_type_tuple,
    STATE(8515), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8494), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15907), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18721), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [15132] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11383), 1,
      anon_sym_SEMI,
    ACTIONS(11385), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16510), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15259] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11387), 1,
      anon_sym_SEMI,
    ACTIONS(11389), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16285), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15386] = 28,
    ACTIONS(6194), 1,
      anon_sym_LBRACE,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(6262), 1,
      sym__strict,
    ACTIONS(6264), 1,
      sym__lazy,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(18784), 1,
      sym_record_fields,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(18793), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14123), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [15505] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11391), 1,
      anon_sym_SEMI,
    ACTIONS(11393), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16877), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15632] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11395), 1,
      anon_sym_SEMI,
    ACTIONS(11397), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16858), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15759] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6116), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11336), 1,
      anon_sym_LPAREN,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(2481), 1,
      sym_constructor,
    STATE(8841), 1,
      sym_type_tuple,
    STATE(8844), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8830), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(16180), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18636), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [15880] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11399), 1,
      anon_sym_SEMI,
    ACTIONS(11401), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16392), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16007] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(6194), 1,
      anon_sym_LBRACE,
    ACTIONS(6196), 1,
      sym__strict,
    ACTIONS(6198), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18705), 1,
      sym_record_fields,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(20672), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14348), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [16126] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11403), 1,
      anon_sym_SEMI,
    ACTIONS(11405), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17395), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16253] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11407), 1,
      anon_sym_SEMI,
    ACTIONS(11409), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17059), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16380] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11411), 1,
      anon_sym_SEMI,
    ACTIONS(11413), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16947), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16507] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11415), 1,
      anon_sym_SEMI,
    ACTIONS(11417), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16308), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16634] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11419), 1,
      anon_sym_SEMI,
    ACTIONS(11421), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17359), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16761] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6110), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11097), 1,
      anon_sym_LPAREN,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(2413), 1,
      sym_constructor,
    STATE(8529), 1,
      sym_type_tuple,
    STATE(8550), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8513), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15558), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18975), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [16882] = 32,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11081), 1,
      anon_sym_DASH,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(11423), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(2672), 1,
      sym__pat_constructor,
    STATE(8224), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8306), 1,
      sym__qcon,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(18445), 1,
      sym__pattern_arrow,
    STATE(18446), 1,
      sym__pattern_equals,
    STATE(18452), 1,
      sym__pattern_type,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17647), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11247), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17009] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11425), 1,
      anon_sym_SEMI,
    ACTIONS(11427), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16641), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17136] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11429), 1,
      anon_sym_SEMI,
    ACTIONS(11431), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16286), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17263] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11433), 1,
      anon_sym_SEMI,
    ACTIONS(11435), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17366), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17390] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11437), 1,
      anon_sym_SEMI,
    ACTIONS(11439), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17507), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17517] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6098), 1,
      sym__conid,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(10896), 1,
      anon_sym_LPAREN,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(2411), 1,
      sym_constructor,
    STATE(8488), 1,
      sym_type_tuple,
    STATE(8515), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8494), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15997), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18721), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [17638] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11441), 1,
      anon_sym_SEMI,
    ACTIONS(11443), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16418), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17765] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11445), 1,
      anon_sym_SEMI,
    ACTIONS(11447), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17406), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17892] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11449), 1,
      anon_sym_SEMI,
    ACTIONS(11451), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16408), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18019] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11453), 1,
      anon_sym_SEMI,
    ACTIONS(11455), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16438), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18146] = 33,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7789), 1,
      sym__varid,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(11457), 1,
      anon_sym_LPAREN,
    ACTIONS(11459), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3137), 1,
      sym_type_name,
    STATE(3245), 1,
      sym_forall,
    STATE(3586), 1,
      sym_context,
    STATE(7673), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15856), 1,
      sym_type_infix,
    STATE(15892), 1,
      sym_constraint,
    STATE(15953), 1,
      sym__forall,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10860), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8101), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [18275] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11461), 1,
      anon_sym_SEMI,
    ACTIONS(11463), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16513), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18402] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11465), 1,
      anon_sym_SEMI,
    ACTIONS(11467), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16388), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18529] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6116), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11336), 1,
      anon_sym_LPAREN,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(2481), 1,
      sym_constructor,
    STATE(8841), 1,
      sym_type_tuple,
    STATE(8844), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8830), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(16548), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18636), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [18650] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11469), 1,
      anon_sym_SEMI,
    ACTIONS(11471), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17335), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18777] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11473), 1,
      anon_sym_SEMI,
    ACTIONS(11475), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17265), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18904] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11477), 1,
      anon_sym_SEMI,
    ACTIONS(11479), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16705), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19031] = 34,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(1415), 1,
      sym__arrow,
    STATE(3296), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17319), 1,
      sym__alt_variants,
    STATE(18606), 1,
      sym_guards,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11481), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14152), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [19162] = 30,
    ACTIONS(11483), 1,
      sym__varid,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(11493), 1,
      anon_sym_LPAREN,
    ACTIONS(11495), 1,
      sym__conid,
    ACTIONS(11498), 1,
      anon_sym_LBRACK,
    ACTIONS(11500), 1,
      anon_sym_LBRACE,
    ACTIONS(11502), 1,
      anon_sym_AT,
    ACTIONS(11504), 1,
      anon_sym__,
    ACTIONS(11506), 1,
      anon_sym_u27e6,
    ACTIONS(11508), 1,
      sym__splice_dollar,
    ACTIONS(11510), 1,
      sym_quasiquote_start,
    ACTIONS(11512), 1,
      sym__strict,
    ACTIONS(11514), 1,
      sym__lazy,
    STATE(418), 1,
      sym__unboxed_open,
    STATE(8490), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(8885), 1,
      sym_variable,
    STATE(9263), 1,
      sym_literal,
    STATE(14652), 1,
      sym_pat_fields,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11491), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11485), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9131), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 6,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    STATE(3115), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [19285] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11516), 1,
      anon_sym_SEMI,
    ACTIONS(11518), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16736), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19412] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11520), 1,
      anon_sym_SEMI,
    ACTIONS(11522), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17375), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19539] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6110), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11097), 1,
      anon_sym_LPAREN,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(2413), 1,
      sym_constructor,
    STATE(8529), 1,
      sym_type_tuple,
    STATE(8550), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8513), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(15879), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18975), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [19660] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11524), 1,
      anon_sym_SEMI,
    ACTIONS(11526), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16299), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19787] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11528), 1,
      anon_sym_SEMI,
    ACTIONS(11530), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16924), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19914] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11532), 1,
      anon_sym_SEMI,
    ACTIONS(11534), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16717), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20041] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11536), 1,
      anon_sym_SEMI,
    ACTIONS(11538), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16474), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15343), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20168] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11540), 1,
      anon_sym_SEMI,
    ACTIONS(11542), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17190), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20295] = 23,
    ACTIONS(11544), 1,
      sym__varid,
    ACTIONS(11550), 1,
      sym__integer_literal,
    ACTIONS(11559), 1,
      anon_sym_LPAREN,
    ACTIONS(11562), 1,
      sym__conid,
    ACTIONS(11565), 1,
      anon_sym_LBRACK,
    ACTIONS(11568), 1,
      anon_sym_SQUOTE,
    ACTIONS(11574), 1,
      anon_sym_u27e6,
    ACTIONS(11577), 1,
      sym__splice_dollar,
    ACTIONS(11580), 1,
      sym_quasiquote_start,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8881), 1,
      sym_constructor,
    STATE(17223), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11556), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11571), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11547), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11553), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9334), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9054), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5556), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3189), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [20404] = 30,
    ACTIONS(11583), 1,
      sym__varid,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    ACTIONS(11595), 1,
      sym__conid,
    ACTIONS(11598), 1,
      anon_sym_LBRACK,
    ACTIONS(11600), 1,
      anon_sym_LBRACE,
    ACTIONS(11602), 1,
      anon_sym_AT,
    ACTIONS(11604), 1,
      anon_sym__,
    ACTIONS(11606), 1,
      anon_sym_u27e6,
    ACTIONS(11608), 1,
      sym__splice_dollar,
    ACTIONS(11610), 1,
      sym_quasiquote_start,
    ACTIONS(11612), 1,
      sym__strict,
    ACTIONS(11614), 1,
      sym__lazy,
    STATE(372), 1,
      sym__unboxed_open,
    STATE(8596), 1,
      sym_constructor,
    STATE(8624), 1,
      sym__pat_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8824), 1,
      sym_variable,
    STATE(8865), 1,
      sym__qcon,
    STATE(9201), 1,
      sym_literal,
    STATE(14780), 1,
      sym_pat_fields,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11591), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11585), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10390), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3126), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [20527] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11616), 1,
      anon_sym_SEMI,
    ACTIONS(11618), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16330), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20654] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11620), 1,
      anon_sym_SEMI,
    ACTIONS(11622), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17483), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20781] = 29,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      sym__strict,
    ACTIONS(6104), 1,
      sym__lazy,
    ACTIONS(6116), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11336), 1,
      anon_sym_LPAREN,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(2481), 1,
      sym_constructor,
    STATE(8841), 1,
      sym_type_tuple,
    STATE(8844), 1,
      sym_con_unit,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(8830), 2,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 4,
      sym_integer,
      sym__literal,
      sym_con_list,
      sym_con_tuple,
    STATE(16515), 4,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
      sym_data_constructor_special,
    STATE(18636), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(2046), 11,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [20902] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11624), 1,
      anon_sym_SEMI,
    ACTIONS(11626), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17797), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21029] = 28,
    ACTIONS(11628), 1,
      sym__varid,
    ACTIONS(11634), 1,
      sym__integer_literal,
    ACTIONS(11643), 1,
      anon_sym_LPAREN,
    ACTIONS(11646), 1,
      sym__conid,
    ACTIONS(11649), 1,
      anon_sym_LBRACK,
    ACTIONS(11652), 1,
      anon_sym_AT,
    ACTIONS(11655), 1,
      anon_sym__,
    ACTIONS(11658), 1,
      anon_sym_u27e6,
    ACTIONS(11661), 1,
      sym__splice_dollar,
    ACTIONS(11664), 1,
      sym_quasiquote_start,
    ACTIONS(11667), 1,
      sym__strict,
    ACTIONS(11670), 1,
      sym__lazy,
    STATE(334), 1,
      sym__unboxed_open,
    STATE(8270), 1,
      sym_constructor,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8339), 1,
      sym_variable,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11640), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11631), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11637), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8536), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 8,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2928), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [21148] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11673), 1,
      anon_sym_SEMI,
    ACTIONS(11675), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17211), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21275] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11677), 1,
      anon_sym_SEMI,
    ACTIONS(11679), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16316), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21402] = 33,
    ACTIONS(2037), 1,
      anon_sym_forall,
    ACTIONS(2039), 1,
      anon_sym_u2200,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8077), 1,
      sym__varid,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11681), 1,
      anon_sym_LPAREN,
    ACTIONS(11683), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3122), 1,
      sym_type_name,
    STATE(3318), 1,
      sym_forall,
    STATE(3581), 1,
      sym_context,
    STATE(7002), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13834), 1,
      sym__forall_kw,
    STATE(15821), 1,
      sym_type_infix,
    STATE(15853), 1,
      sym_constraint,
    STATE(15953), 1,
      sym__forall,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10784), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [21531] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11685), 1,
      anon_sym_SEMI,
    ACTIONS(11687), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16591), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21658] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11689), 1,
      anon_sym_SEMI,
    ACTIONS(11691), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17232), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21785] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11693), 1,
      anon_sym_SEMI,
    ACTIONS(11695), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16278), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21912] = 32,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11697), 1,
      anon_sym_SEMI,
    ACTIONS(11699), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16571), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22039] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11101), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17513), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22163] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11153), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17272), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22287] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11675), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17214), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22411] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11699), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16569), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22535] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11701), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22659] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11703), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22783] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11705), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22907] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11707), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23031] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11709), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23155] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11711), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23279] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11713), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23403] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11715), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23527] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11053), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16624), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23651] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11717), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23775] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10900), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17114), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23899] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11522), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17376), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24023] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11526), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16301), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24147] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11719), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24271] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11177), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17814), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24395] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11721), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18684), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24519] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11723), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24643] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11725), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18684), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24767] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11727), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24891] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11069), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17589), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25015] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11729), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25139] = 32,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11731), 1,
      anon_sym_LPAREN,
    ACTIONS(11733), 1,
      anon_sym_instance,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(7136), 1,
      sym_constructor,
    STATE(8562), 1,
      sym_type_variable,
    STATE(14509), 1,
      sym__context_newtype,
    STATE(14804), 1,
      sym_context,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16981), 1,
      sym__simpletype,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [25265] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11735), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25389] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11737), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25513] = 24,
    ACTIONS(5491), 1,
      anon_sym_deriving,
    ACTIONS(11739), 1,
      sym__varid,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11747), 1,
      anon_sym_LPAREN,
    ACTIONS(11749), 1,
      sym__conid,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(11754), 1,
      anon_sym_SQUOTE,
    ACTIONS(11759), 1,
      anon_sym_AT,
    ACTIONS(11761), 1,
      anon_sym_u27e6,
    ACTIONS(11763), 1,
      sym__splice_dollar,
    ACTIONS(11765), 1,
      sym_quasiquote_start,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11757), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5483), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3086), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [25623] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11767), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25747] = 24,
    ACTIONS(5528), 1,
      anon_sym_deriving,
    ACTIONS(11769), 1,
      sym__varid,
    ACTIONS(11775), 1,
      sym__integer_literal,
    ACTIONS(11784), 1,
      anon_sym_LPAREN,
    ACTIONS(11787), 1,
      sym__conid,
    ACTIONS(11790), 1,
      anon_sym_LBRACK,
    ACTIONS(11793), 1,
      anon_sym_SQUOTE,
    ACTIONS(11799), 1,
      anon_sym_AT,
    ACTIONS(11802), 1,
      anon_sym_u27e6,
    ACTIONS(11805), 1,
      sym__splice_dollar,
    ACTIONS(11808), 1,
      sym_quasiquote_start,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11781), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11796), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11772), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11778), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5496), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2966), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [25857] = 24,
    ACTIONS(5528), 1,
      anon_sym_deriving,
    ACTIONS(11811), 1,
      sym__varid,
    ACTIONS(11817), 1,
      sym__integer_literal,
    ACTIONS(11826), 1,
      anon_sym_LPAREN,
    ACTIONS(11829), 1,
      sym__conid,
    ACTIONS(11832), 1,
      anon_sym_LBRACK,
    ACTIONS(11835), 1,
      anon_sym_SQUOTE,
    ACTIONS(11841), 1,
      anon_sym_AT,
    ACTIONS(11844), 1,
      anon_sym_u27e6,
    ACTIONS(11847), 1,
      sym__splice_dollar,
    ACTIONS(11850), 1,
      sym_quasiquote_start,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11823), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11838), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11814), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11820), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5496), 7,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2967), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [25967] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11853), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26091] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11534), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16715), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26215] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11855), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26339] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11857), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26463] = 24,
    ACTIONS(5475), 1,
      anon_sym_deriving,
    ACTIONS(11859), 1,
      sym__varid,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11867), 1,
      anon_sym_LPAREN,
    ACTIONS(11869), 1,
      sym__conid,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(11874), 1,
      anon_sym_SQUOTE,
    ACTIONS(11879), 1,
      anon_sym_AT,
    ACTIONS(11881), 1,
      anon_sym_u27e6,
    ACTIONS(11883), 1,
      sym__splice_dollar,
    ACTIONS(11885), 1,
      sym_quasiquote_start,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11877), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5451), 7,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2967), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [26573] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11887), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26697] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11530), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16925), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26821] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11439), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17511), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26945] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11889), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27069] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11891), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27193] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11893), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27317] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11895), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27441] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11897), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27565] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11899), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27689] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11901), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27813] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11903), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27937] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11905), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28061] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11471), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17331), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28185] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11907), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28309] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10980), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17721), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28433] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11909), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28557] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11911), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28681] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11913), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28805] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11915), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28929] = 23,
    ACTIONS(11917), 1,
      sym__varid,
    ACTIONS(11923), 1,
      sym__integer_literal,
    ACTIONS(11932), 1,
      anon_sym_LPAREN,
    ACTIONS(11935), 1,
      sym__conid,
    ACTIONS(11938), 1,
      anon_sym_LBRACK,
    ACTIONS(11941), 1,
      anon_sym_SQUOTE,
    ACTIONS(11947), 1,
      anon_sym_u27e6,
    ACTIONS(11950), 1,
      sym__splice_dollar,
    ACTIONS(11953), 1,
      sym_quasiquote_start,
    STATE(2198), 1,
      sym__unboxed_open,
    STATE(9183), 1,
      sym_constructor,
    STATE(17205), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11929), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11944), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11920), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11926), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9428), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5556), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3246), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [29037] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11956), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29161] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11463), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16518), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29285] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11958), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29409] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11238), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16891), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29533] = 32,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11731), 1,
      anon_sym_LPAREN,
    ACTIONS(11960), 1,
      anon_sym_family,
    ACTIONS(11962), 1,
      anon_sym_instance,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(7136), 1,
      sym_constructor,
    STATE(8562), 1,
      sym_type_variable,
    STATE(11918), 1,
      sym__simpletype,
    STATE(14796), 1,
      sym_context,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [29659] = 23,
    ACTIONS(11964), 1,
      sym__varid,
    ACTIONS(11970), 1,
      sym__integer_literal,
    ACTIONS(11979), 1,
      anon_sym_LPAREN,
    ACTIONS(11982), 1,
      sym__conid,
    ACTIONS(11985), 1,
      anon_sym_LBRACK,
    ACTIONS(11988), 1,
      anon_sym_SQUOTE,
    ACTIONS(11994), 1,
      anon_sym_u27e6,
    ACTIONS(11997), 1,
      sym__splice_dollar,
    ACTIONS(12000), 1,
      sym_quasiquote_start,
    STATE(2124), 1,
      sym__unboxed_open,
    STATE(8993), 1,
      sym_constructor,
    STATE(17296), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11976), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11991), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11967), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11973), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9519), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9437), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5556), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3214), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [29767] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10943), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17632), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29891] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12003), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30015] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12005), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30139] = 32,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11731), 1,
      anon_sym_LPAREN,
    ACTIONS(12007), 1,
      anon_sym_instance,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(7136), 1,
      sym_constructor,
    STATE(8562), 1,
      sym_type_variable,
    STATE(14499), 1,
      sym__context_newtype,
    STATE(14804), 1,
      sym_context,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16981), 1,
      sym__simpletype,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [30265] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11451), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16409), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30389] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12009), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30513] = 28,
    ACTIONS(12011), 1,
      sym__varid,
    ACTIONS(12017), 1,
      sym__integer_literal,
    ACTIONS(12026), 1,
      anon_sym_LPAREN,
    ACTIONS(12029), 1,
      sym__conid,
    ACTIONS(12032), 1,
      anon_sym_LBRACK,
    ACTIONS(12035), 1,
      anon_sym_AT,
    ACTIONS(12038), 1,
      anon_sym__,
    ACTIONS(12041), 1,
      anon_sym_u27e6,
    ACTIONS(12044), 1,
      sym__splice_dollar,
    ACTIONS(12047), 1,
      sym_quasiquote_start,
    ACTIONS(12050), 1,
      sym__strict,
    ACTIONS(12053), 1,
      sym__lazy,
    STATE(384), 1,
      sym__unboxed_open,
    STATE(8454), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8499), 1,
      sym_variable,
    STATE(8502), 1,
      sym__qcon,
    STATE(8809), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12023), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12014), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12020), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3005), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [30631] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11109), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16605), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30755] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11443), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16416), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30879] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11431), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16289), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31003] = 28,
    ACTIONS(10810), 1,
      sym__varid,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(10820), 1,
      anon_sym_LPAREN,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10829), 1,
      anon_sym_AT,
    ACTIONS(10831), 1,
      anon_sym__,
    ACTIONS(10833), 1,
      anon_sym_u27e6,
    ACTIONS(10835), 1,
      sym__splice_dollar,
    ACTIONS(10837), 1,
      sym_quasiquote_start,
    ACTIONS(10839), 1,
      sym__strict,
    ACTIONS(10841), 1,
      sym__lazy,
    ACTIONS(12056), 1,
      sym__conid,
    STATE(384), 1,
      sym__unboxed_open,
    STATE(8454), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8499), 1,
      sym_variable,
    STATE(8502), 1,
      sym__qcon,
    STATE(8809), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10818), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10812), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3005), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [31121] = 30,
    ACTIONS(12059), 1,
      sym__varid,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(12069), 1,
      anon_sym_LPAREN,
    ACTIONS(12071), 1,
      sym__conid,
    ACTIONS(12074), 1,
      anon_sym_LBRACK,
    ACTIONS(12076), 1,
      anon_sym_LBRACE,
    ACTIONS(12078), 1,
      anon_sym_AT,
    ACTIONS(12080), 1,
      anon_sym__,
    ACTIONS(12082), 1,
      anon_sym_u27e6,
    ACTIONS(12084), 1,
      sym__splice_dollar,
    ACTIONS(12086), 1,
      sym_quasiquote_start,
    ACTIONS(12088), 1,
      sym__strict,
    ACTIONS(12090), 1,
      sym__lazy,
    STATE(387), 1,
      sym__unboxed_open,
    STATE(8797), 1,
      sym_constructor,
    STATE(8858), 1,
      sym__pat_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(9271), 1,
      sym_variable,
    STATE(9381), 1,
      sym_literal,
    STATE(15009), 1,
      sym_pat_fields,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12067), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(9433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3162), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [31243] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12092), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31367] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12094), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31491] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12096), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31615] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12098), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31739] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12100), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31863] = 32,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(12102), 1,
      anon_sym_LPAREN,
    ACTIONS(12104), 1,
      anon_sym_family,
    ACTIONS(12106), 1,
      anon_sym_instance,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(6965), 1,
      sym_constructor,
    STATE(8567), 1,
      sym_type_variable,
    STATE(11231), 1,
      sym__simpletype,
    STATE(14505), 1,
      sym__simpletype_infix,
    STATE(14939), 1,
      sym_context,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [31989] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12108), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32113] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12110), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32237] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12112), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32361] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11405), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17402), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32485] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12114), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32609] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11216), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17683), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32733] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12116), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32857] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12118), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32981] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11397), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16856), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33105] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12120), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33229] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11401), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16391), 1,
      sym__pattern_decl,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33353] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12122), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33477] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12124), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18684), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33601] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12126), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33725] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12128), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33849] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12130), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33973] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12132), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34097] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12134), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34221] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11133), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17394), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34345] = 23,
    ACTIONS(12136), 1,
      sym__varid,
    ACTIONS(12142), 1,
      sym__integer_literal,
    ACTIONS(12151), 1,
      anon_sym_LPAREN,
    ACTIONS(12154), 1,
      sym__conid,
    ACTIONS(12157), 1,
      anon_sym_LBRACK,
    ACTIONS(12160), 1,
      anon_sym_SQUOTE,
    ACTIONS(12166), 1,
      anon_sym_u27e6,
    ACTIONS(12169), 1,
      sym__splice_dollar,
    ACTIONS(12172), 1,
      sym_quasiquote_start,
    STATE(2156), 1,
      sym__unboxed_open,
    STATE(9252), 1,
      sym_constructor,
    STATE(17266), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12148), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12163), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12139), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12145), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9411), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9360), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5556), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    STATE(3293), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [34453] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12175), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34577] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12177), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34701] = 31,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12187), 1,
      anon_sym_LPAREN,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12199), 1,
      anon_sym_EQ,
    ACTIONS(12201), 1,
      anon_sym_family,
    ACTIONS(12203), 1,
      anon_sym_instance,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8705), 1,
      sym_constructor,
    STATE(8747), 1,
      sym_type_variable,
    STATE(13989), 1,
      sym_tyfam_head,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15703), 1,
      sym__simpletype,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(20427), 1,
      sym__tyinst,
    STATE(20483), 1,
      sym__tyfam,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(9551), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3592), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [34825] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12211), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34949] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11129), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17398), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35073] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12213), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35197] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11141), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16903), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35321] = 32,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(12215), 1,
      anon_sym_LPAREN,
    ACTIONS(12217), 1,
      anon_sym_family,
    ACTIONS(12219), 1,
      anon_sym_instance,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(6673), 1,
      sym_constructor,
    STATE(8559), 1,
      sym_type_variable,
    STATE(11327), 1,
      sym__simpletype,
    STATE(14488), 1,
      sym__simpletype_infix,
    STATE(14794), 1,
      sym_context,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [35447] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12221), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18684), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35571] = 31,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(12223), 1,
      anon_sym_LPAREN,
    ACTIONS(12225), 1,
      sym__conid,
    ACTIONS(12227), 1,
      anon_sym_EQ,
    ACTIONS(12229), 1,
      anon_sym_family,
    ACTIONS(12231), 1,
      anon_sym_instance,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8463), 1,
      sym_constructor,
    STATE(8860), 1,
      sym_type_variable,
    STATE(13839), 1,
      sym_tyfam_head,
    STATE(15028), 1,
      sym__simpletype_infix,
    STATE(15247), 1,
      sym__simpletype,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(19423), 1,
      sym__tyfam,
    STATE(20136), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(9551), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3593), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [35695] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12233), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35819] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12235), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35943] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12237), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36067] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11381), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16532), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36191] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12239), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36315] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12241), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36439] = 30,
    ACTIONS(12243), 1,
      sym__varid,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12253), 1,
      anon_sym_LPAREN,
    ACTIONS(12255), 1,
      sym__conid,
    ACTIONS(12258), 1,
      anon_sym_LBRACK,
    ACTIONS(12260), 1,
      anon_sym_LBRACE,
    ACTIONS(12262), 1,
      anon_sym_AT,
    ACTIONS(12264), 1,
      anon_sym__,
    ACTIONS(12266), 1,
      anon_sym_u27e6,
    ACTIONS(12268), 1,
      sym__splice_dollar,
    ACTIONS(12270), 1,
      sym_quasiquote_start,
    ACTIONS(12272), 1,
      sym__strict,
    ACTIONS(12274), 1,
      sym__lazy,
    STATE(355), 1,
      sym__unboxed_open,
    STATE(8724), 1,
      sym_constructor,
    STATE(8733), 1,
      sym__pat_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(9026), 1,
      sym_variable,
    STATE(9480), 1,
      sym_literal,
    STATE(15317), 1,
      sym_pat_fields,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12251), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12245), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 5,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
    STATE(9515), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3164), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [36561] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12276), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36685] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12278), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36809] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12280), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36933] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12282), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37057] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11340), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16267), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37181] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12284), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37305] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12286), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37429] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12288), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37553] = 32,
    ACTIONS(5449), 1,
      sym__varid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11731), 1,
      anon_sym_LPAREN,
    ACTIONS(12290), 1,
      anon_sym_instance,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(7136), 1,
      sym_constructor,
    STATE(8562), 1,
      sym_type_variable,
    STATE(14498), 1,
      sym__context_newtype,
    STATE(14804), 1,
      sym_context,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16981), 1,
      sym__simpletype,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [37679] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11246), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16995), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37803] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12292), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37927] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12294), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38051] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12296), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38175] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11234), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17251), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38299] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12298), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38423] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12300), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38547] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12302), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38671] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12304), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38795] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12306), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38919] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12308), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39043] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12310), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39167] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11061), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16994), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39291] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11679), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16313), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39415] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10919), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17130), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39539] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12312), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39663] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11157), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17047), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39787] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11161), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16783), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39911] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12314), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18684), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40035] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12316), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40159] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11224), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16853), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40283] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10894), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17829), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40407] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11165), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17532), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40531] = 24,
    ACTIONS(5475), 1,
      anon_sym_deriving,
    ACTIONS(11739), 1,
      sym__varid,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11747), 1,
      anon_sym_LPAREN,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(11759), 1,
      anon_sym_AT,
    ACTIONS(11761), 1,
      anon_sym_u27e6,
    ACTIONS(11763), 1,
      sym__splice_dollar,
    ACTIONS(11765), 1,
      sym_quasiquote_start,
    ACTIONS(12318), 1,
      sym__conid,
    ACTIONS(12321), 1,
      anon_sym_SQUOTE,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11757), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5451), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2966), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [40641] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10923), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17662), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40765] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11220), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16664), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40889] = 24,
    ACTIONS(5491), 1,
      anon_sym_deriving,
    ACTIONS(11859), 1,
      sym__varid,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11867), 1,
      anon_sym_LPAREN,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(11879), 1,
      anon_sym_AT,
    ACTIONS(11881), 1,
      anon_sym_u27e6,
    ACTIONS(11883), 1,
      sym__splice_dollar,
    ACTIONS(11885), 1,
      sym_quasiquote_start,
    ACTIONS(12324), 1,
      sym__conid,
    ACTIONS(12327), 1,
      anon_sym_SQUOTE,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11877), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5483), 7,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2972), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [40999] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12330), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41123] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12332), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18684), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41247] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10911), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(17751), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41371] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11212), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17134), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41495] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(10915), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16802), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41619] = 30,
    ACTIONS(12334), 1,
      sym__varid,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(12344), 1,
      anon_sym_LPAREN,
    ACTIONS(12346), 1,
      sym__conid,
    ACTIONS(12349), 1,
      anon_sym_LBRACK,
    ACTIONS(12351), 1,
      anon_sym_LBRACE,
    ACTIONS(12353), 1,
      anon_sym_AT,
    ACTIONS(12355), 1,
      anon_sym__,
    ACTIONS(12357), 1,
      anon_sym_u27e6,
    ACTIONS(12359), 1,
      sym__splice_dollar,
    ACTIONS(12361), 1,
      sym_quasiquote_start,
    ACTIONS(12363), 1,
      sym__strict,
    ACTIONS(12365), 1,
      sym__lazy,
    STATE(357), 1,
      sym__unboxed_open,
    STATE(8734), 1,
      sym_constructor,
    STATE(8825), 1,
      sym__pat_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(9152), 1,
      sym_variable,
    STATE(9642), 1,
      sym_literal,
    STATE(15472), 1,
      sym_pat_fields,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12342), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12336), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 5,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(9565), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3140), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [41741] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12367), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41865] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11208), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17536), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41989] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12369), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42113] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11181), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17102), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42237] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(11192), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(16452), 1,
      sym_alt,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42361] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12371), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42485] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12373), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42609] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42733] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12377), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42857] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12379), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42981] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12381), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43105] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12383), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43229] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12385), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43353] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12387), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43477] = 31,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(12389), 1,
      sym__layout_end,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43601] = 26,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(6262), 1,
      sym__strict,
    ACTIONS(6264), 1,
      sym__lazy,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(18590), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14123), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [43714] = 28,
    ACTIONS(12391), 1,
      sym__varid,
    ACTIONS(12397), 1,
      sym__integer_literal,
    ACTIONS(12406), 1,
      anon_sym_LPAREN,
    ACTIONS(12409), 1,
      sym__conid,
    ACTIONS(12412), 1,
      anon_sym_LBRACK,
    ACTIONS(12415), 1,
      anon_sym_AT,
    ACTIONS(12418), 1,
      anon_sym__,
    ACTIONS(12421), 1,
      anon_sym_u27e6,
    ACTIONS(12424), 1,
      sym__splice_dollar,
    ACTIONS(12427), 1,
      sym_quasiquote_start,
    ACTIONS(12430), 1,
      sym__strict,
    ACTIONS(12433), 1,
      sym__lazy,
    STATE(382), 1,
      sym__unboxed_open,
    STATE(8498), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8833), 1,
      sym_variable,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(9103), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12403), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12394), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12400), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9340), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 6,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3112), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [43831] = 30,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(19944), 1,
      sym_alt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14352), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43952] = 25,
    ACTIONS(7625), 1,
      sym__strict,
    ACTIONS(7627), 1,
      sym__lazy,
    ACTIONS(12438), 1,
      sym__varid,
    ACTIONS(12442), 1,
      sym__integer_literal,
    ACTIONS(12448), 1,
      anon_sym_LPAREN,
    ACTIONS(12450), 1,
      sym__conid,
    ACTIONS(12452), 1,
      anon_sym_LBRACK,
    ACTIONS(12454), 1,
      anon_sym_SQUOTE,
    ACTIONS(12458), 1,
      anon_sym_deriving,
    ACTIONS(12460), 1,
      anon_sym_u27e6,
    ACTIONS(12462), 1,
      sym__splice_dollar,
    ACTIONS(12464), 1,
      sym_quasiquote_start,
    STATE(2077), 1,
      sym__unboxed_open,
    STATE(8749), 1,
      sym_constructor,
    STATE(16483), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12456), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(12436), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(9055), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3117), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [44063] = 28,
    ACTIONS(11483), 1,
      sym__varid,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(11493), 1,
      anon_sym_LPAREN,
    ACTIONS(11498), 1,
      anon_sym_LBRACK,
    ACTIONS(11502), 1,
      anon_sym_AT,
    ACTIONS(11504), 1,
      anon_sym__,
    ACTIONS(11506), 1,
      anon_sym_u27e6,
    ACTIONS(11508), 1,
      sym__splice_dollar,
    ACTIONS(11510), 1,
      sym_quasiquote_start,
    ACTIONS(11512), 1,
      sym__strict,
    ACTIONS(11514), 1,
      sym__lazy,
    ACTIONS(12466), 1,
      sym__conid,
    STATE(418), 1,
      sym__unboxed_open,
    STATE(8490), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(8885), 1,
      sym_variable,
    STATE(9263), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11491), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11485), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9131), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 6,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    STATE(3121), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [44180] = 28,
    ACTIONS(12469), 1,
      sym__varid,
    ACTIONS(12475), 1,
      sym__integer_literal,
    ACTIONS(12484), 1,
      anon_sym_LPAREN,
    ACTIONS(12487), 1,
      sym__conid,
    ACTIONS(12490), 1,
      anon_sym_LBRACK,
    ACTIONS(12493), 1,
      anon_sym_AT,
    ACTIONS(12496), 1,
      anon_sym__,
    ACTIONS(12499), 1,
      anon_sym_u27e6,
    ACTIONS(12502), 1,
      sym__splice_dollar,
    ACTIONS(12505), 1,
      sym_quasiquote_start,
    ACTIONS(12508), 1,
      sym__strict,
    ACTIONS(12511), 1,
      sym__lazy,
    STATE(311), 1,
      sym__unboxed_open,
    STATE(8555), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(8868), 1,
      sym__qcon,
    STATE(9208), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12481), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12472), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12478), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9046), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 6,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(3116), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [44297] = 25,
    ACTIONS(12516), 1,
      sym__varid,
    ACTIONS(12522), 1,
      sym__integer_literal,
    ACTIONS(12531), 1,
      anon_sym_LPAREN,
    ACTIONS(12534), 1,
      sym__conid,
    ACTIONS(12537), 1,
      anon_sym_LBRACK,
    ACTIONS(12540), 1,
      anon_sym_SQUOTE,
    ACTIONS(12546), 1,
      anon_sym_deriving,
    ACTIONS(12548), 1,
      anon_sym_u27e6,
    ACTIONS(12551), 1,
      sym__splice_dollar,
    ACTIONS(12554), 1,
      sym_quasiquote_start,
    ACTIONS(12557), 1,
      sym__strict,
    ACTIONS(12560), 1,
      sym__lazy,
    STATE(2077), 1,
      sym__unboxed_open,
    STATE(8749), 1,
      sym_constructor,
    STATE(16483), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12528), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12543), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12519), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12525), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(12514), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(9055), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3117), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [44408] = 28,
    ACTIONS(11342), 1,
      sym__varid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(11352), 1,
      anon_sym_LPAREN,
    ACTIONS(11357), 1,
      anon_sym_LBRACK,
    ACTIONS(11361), 1,
      anon_sym_AT,
    ACTIONS(11363), 1,
      anon_sym__,
    ACTIONS(11365), 1,
      anon_sym_u27e6,
    ACTIONS(11367), 1,
      sym__splice_dollar,
    ACTIONS(11369), 1,
      sym_quasiquote_start,
    ACTIONS(11371), 1,
      sym__strict,
    ACTIONS(11373), 1,
      sym__lazy,
    ACTIONS(12563), 1,
      sym__conid,
    STATE(311), 1,
      sym__unboxed_open,
    STATE(8555), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(8868), 1,
      sym__qcon,
    STATE(9208), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11350), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11344), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9046), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 6,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(3116), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [44525] = 25,
    ACTIONS(12546), 1,
      anon_sym_deriving,
    ACTIONS(12566), 1,
      sym__varid,
    ACTIONS(12572), 1,
      sym__integer_literal,
    ACTIONS(12581), 1,
      anon_sym_LPAREN,
    ACTIONS(12584), 1,
      sym__conid,
    ACTIONS(12587), 1,
      anon_sym_LBRACK,
    ACTIONS(12590), 1,
      anon_sym_SQUOTE,
    ACTIONS(12596), 1,
      anon_sym_u27e6,
    ACTIONS(12599), 1,
      sym__splice_dollar,
    ACTIONS(12602), 1,
      sym_quasiquote_start,
    ACTIONS(12605), 1,
      sym__strict,
    ACTIONS(12608), 1,
      sym__lazy,
    STATE(2092), 1,
      sym__unboxed_open,
    STATE(8742), 1,
      sym_constructor,
    STATE(17545), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12578), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12593), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12569), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12575), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(12514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(9038), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9037), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3119), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [44636] = 30,
    ACTIONS(12611), 1,
      sym__varid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(12621), 1,
      anon_sym_LPAREN,
    ACTIONS(12623), 1,
      sym__conid,
    ACTIONS(12626), 1,
      anon_sym_LBRACK,
    ACTIONS(12628), 1,
      anon_sym_LBRACE,
    ACTIONS(12630), 1,
      anon_sym_AT,
    ACTIONS(12632), 1,
      anon_sym__,
    ACTIONS(12634), 1,
      anon_sym_u27e6,
    ACTIONS(12636), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    ACTIONS(12640), 1,
      sym__strict,
    ACTIONS(12642), 1,
      sym__lazy,
    STATE(353), 1,
      sym__unboxed_open,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9100), 1,
      sym__pat_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(9606), 1,
      sym_variable,
    STATE(9685), 1,
      sym_literal,
    STATE(15677), 1,
      sym_pat_fields,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12619), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12613), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(9691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3195), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [44757] = 28,
    ACTIONS(12644), 1,
      sym__varid,
    ACTIONS(12650), 1,
      sym__integer_literal,
    ACTIONS(12659), 1,
      anon_sym_LPAREN,
    ACTIONS(12662), 1,
      sym__conid,
    ACTIONS(12665), 1,
      anon_sym_LBRACK,
    ACTIONS(12668), 1,
      anon_sym_AT,
    ACTIONS(12671), 1,
      anon_sym__,
    ACTIONS(12674), 1,
      anon_sym_u27e6,
    ACTIONS(12677), 1,
      sym__splice_dollar,
    ACTIONS(12680), 1,
      sym_quasiquote_start,
    ACTIONS(12683), 1,
      sym__strict,
    ACTIONS(12686), 1,
      sym__lazy,
    STATE(418), 1,
      sym__unboxed_open,
    STATE(8490), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(8885), 1,
      sym_variable,
    STATE(9263), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12656), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12647), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12653), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9131), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 6,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    STATE(3121), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [44874] = 23,
    ACTIONS(12689), 1,
      sym__varid,
    ACTIONS(12695), 1,
      sym__integer_literal,
    ACTIONS(12704), 1,
      anon_sym_LPAREN,
    ACTIONS(12707), 1,
      sym__conid,
    ACTIONS(12710), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym_SQUOTE,
    ACTIONS(12719), 1,
      anon_sym_u27e6,
    ACTIONS(12722), 1,
      sym__splice_dollar,
    ACTIONS(12725), 1,
      sym_quasiquote_start,
    STATE(2185), 1,
      sym__unboxed_open,
    STATE(9376), 1,
      sym_constructor,
    STATE(17253), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12701), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12716), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12692), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12698), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9826), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(5556), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(9791), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3480), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [44981] = 30,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(18698), 1,
      sym__pattern_decl,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15060), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45102] = 28,
    ACTIONS(11018), 1,
      sym__varid,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(11028), 1,
      anon_sym_LPAREN,
    ACTIONS(11033), 1,
      anon_sym_LBRACK,
    ACTIONS(11037), 1,
      anon_sym_AT,
    ACTIONS(11039), 1,
      anon_sym__,
    ACTIONS(11041), 1,
      anon_sym_u27e6,
    ACTIONS(11043), 1,
      sym__splice_dollar,
    ACTIONS(11045), 1,
      sym_quasiquote_start,
    ACTIONS(11047), 1,
      sym__strict,
    ACTIONS(11049), 1,
      sym__lazy,
    ACTIONS(12728), 1,
      sym__conid,
    STATE(282), 1,
      sym__unboxed_open,
    STATE(8500), 1,
      sym_constructor,
    STATE(8509), 1,
      sym__pat_constructor,
    STATE(8780), 1,
      sym_variable,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(9108), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11026), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 6,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3128), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [45219] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(6196), 1,
      sym__strict,
    ACTIONS(6198), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(20763), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14348), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [45332] = 28,
    ACTIONS(11583), 1,
      sym__varid,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    ACTIONS(11598), 1,
      anon_sym_LBRACK,
    ACTIONS(11602), 1,
      anon_sym_AT,
    ACTIONS(11604), 1,
      anon_sym__,
    ACTIONS(11606), 1,
      anon_sym_u27e6,
    ACTIONS(11608), 1,
      sym__splice_dollar,
    ACTIONS(11610), 1,
      sym_quasiquote_start,
    ACTIONS(11612), 1,
      sym__strict,
    ACTIONS(11614), 1,
      sym__lazy,
    ACTIONS(12731), 1,
      sym__conid,
    STATE(372), 1,
      sym__unboxed_open,
    STATE(8596), 1,
      sym_constructor,
    STATE(8624), 1,
      sym__pat_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8824), 1,
      sym_variable,
    STATE(8865), 1,
      sym__qcon,
    STATE(9201), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11591), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11585), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3133), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [45449] = 25,
    ACTIONS(7538), 1,
      sym__strict,
    ACTIONS(7540), 1,
      sym__lazy,
    ACTIONS(12458), 1,
      anon_sym_deriving,
    ACTIONS(12734), 1,
      sym__varid,
    ACTIONS(12738), 1,
      sym__integer_literal,
    ACTIONS(12744), 1,
      anon_sym_LPAREN,
    ACTIONS(12746), 1,
      sym__conid,
    ACTIONS(12748), 1,
      anon_sym_LBRACK,
    ACTIONS(12750), 1,
      anon_sym_SQUOTE,
    ACTIONS(12754), 1,
      anon_sym_u27e6,
    ACTIONS(12756), 1,
      sym__splice_dollar,
    ACTIONS(12758), 1,
      sym_quasiquote_start,
    STATE(2092), 1,
      sym__unboxed_open,
    STATE(8742), 1,
      sym_constructor,
    STATE(17545), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12742), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12752), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12736), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12740), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(12436), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(9038), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9037), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3119), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [45560] = 28,
    ACTIONS(12760), 1,
      sym__varid,
    ACTIONS(12766), 1,
      sym__integer_literal,
    ACTIONS(12775), 1,
      anon_sym_LPAREN,
    ACTIONS(12778), 1,
      sym__conid,
    ACTIONS(12781), 1,
      anon_sym_LBRACK,
    ACTIONS(12784), 1,
      anon_sym_AT,
    ACTIONS(12787), 1,
      anon_sym__,
    ACTIONS(12790), 1,
      anon_sym_u27e6,
    ACTIONS(12793), 1,
      sym__splice_dollar,
    ACTIONS(12796), 1,
      sym_quasiquote_start,
    ACTIONS(12799), 1,
      sym__strict,
    ACTIONS(12802), 1,
      sym__lazy,
    STATE(282), 1,
      sym__unboxed_open,
    STATE(8500), 1,
      sym_constructor,
    STATE(8509), 1,
      sym__pat_constructor,
    STATE(8780), 1,
      sym_variable,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(9108), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12772), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12769), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 6,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3128), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [45677] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(6196), 1,
      sym__strict,
    ACTIONS(6198), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(20728), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14348), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [45790] = 26,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(6262), 1,
      sym__strict,
    ACTIONS(6264), 1,
      sym__lazy,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(18599), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14123), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [45903] = 26,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(6262), 1,
      sym__strict,
    ACTIONS(6264), 1,
      sym__lazy,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(18647), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14123), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [46016] = 26,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(6262), 1,
      sym__strict,
    ACTIONS(6264), 1,
      sym__lazy,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(18648), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14123), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [46129] = 28,
    ACTIONS(12805), 1,
      sym__varid,
    ACTIONS(12811), 1,
      sym__integer_literal,
    ACTIONS(12820), 1,
      anon_sym_LPAREN,
    ACTIONS(12823), 1,
      sym__conid,
    ACTIONS(12826), 1,
      anon_sym_LBRACK,
    ACTIONS(12829), 1,
      anon_sym_AT,
    ACTIONS(12832), 1,
      anon_sym__,
    ACTIONS(12835), 1,
      anon_sym_u27e6,
    ACTIONS(12838), 1,
      sym__splice_dollar,
    ACTIONS(12841), 1,
      sym_quasiquote_start,
    ACTIONS(12844), 1,
      sym__strict,
    ACTIONS(12847), 1,
      sym__lazy,
    STATE(372), 1,
      sym__unboxed_open,
    STATE(8596), 1,
      sym_constructor,
    STATE(8624), 1,
      sym__pat_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8824), 1,
      sym_variable,
    STATE(8865), 1,
      sym__qcon,
    STATE(9201), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12817), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12808), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12814), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10766), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3133), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [46246] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(6196), 1,
      sym__strict,
    ACTIONS(6198), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(20770), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14348), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [46359] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(6196), 1,
      sym__strict,
    ACTIONS(6198), 1,
      sym__lazy,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(20726), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14348), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [46472] = 28,
    ACTIONS(10945), 1,
      sym__varid,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(10955), 1,
      anon_sym_LPAREN,
    ACTIONS(10960), 1,
      anon_sym_LBRACK,
    ACTIONS(10964), 1,
      anon_sym_AT,
    ACTIONS(10966), 1,
      anon_sym__,
    ACTIONS(10968), 1,
      anon_sym_u27e6,
    ACTIONS(10970), 1,
      sym__splice_dollar,
    ACTIONS(10972), 1,
      sym_quasiquote_start,
    ACTIONS(10974), 1,
      sym__strict,
    ACTIONS(10976), 1,
      sym__lazy,
    ACTIONS(12850), 1,
      sym__conid,
    STATE(382), 1,
      sym__unboxed_open,
    STATE(8498), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8833), 1,
      sym_variable,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(9103), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10953), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10947), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9340), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10843), 6,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3112), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [46589] = 23,
    ACTIONS(12853), 1,
      sym__varid,
    ACTIONS(12859), 1,
      sym__integer_literal,
    ACTIONS(12868), 1,
      anon_sym_LPAREN,
    ACTIONS(12871), 1,
      sym__conid,
    ACTIONS(12874), 1,
      anon_sym_LBRACK,
    ACTIONS(12877), 1,
      anon_sym_SQUOTE,
    ACTIONS(12883), 1,
      anon_sym_u27e6,
    ACTIONS(12886), 1,
      sym__splice_dollar,
    ACTIONS(12889), 1,
      sym_quasiquote_start,
    STATE(2083), 1,
      sym__unboxed_open,
    STATE(9619), 1,
      sym_constructor,
    STATE(17583), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12865), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12880), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12856), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12862), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9686), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(5556), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(9861), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3449), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [46696] = 23,
    ACTIONS(12892), 1,
      sym__varid,
    ACTIONS(12898), 1,
      sym__integer_literal,
    ACTIONS(12907), 1,
      anon_sym_LPAREN,
    ACTIONS(12910), 1,
      sym__conid,
    ACTIONS(12913), 1,
      anon_sym_LBRACK,
    ACTIONS(12916), 1,
      anon_sym_SQUOTE,
    ACTIONS(12922), 1,
      anon_sym_u27e6,
    ACTIONS(12925), 1,
      sym__splice_dollar,
    ACTIONS(12928), 1,
      sym_quasiquote_start,
    STATE(2161), 1,
      sym__unboxed_open,
    STATE(9554), 1,
      sym_constructor,
    STATE(17486), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12904), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12919), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12895), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12901), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    STATE(9759), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(5556), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(9752), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3352), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [46803] = 29,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12941), 1,
      anon_sym_DASH,
    ACTIONS(12943), 1,
      anon_sym_LPAREN,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(2923), 1,
      sym__pat_constructor,
    STATE(8596), 1,
      sym_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8865), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16857), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13135), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46921] = 28,
    ACTIONS(12334), 1,
      sym__varid,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(12344), 1,
      anon_sym_LPAREN,
    ACTIONS(12349), 1,
      anon_sym_LBRACK,
    ACTIONS(12353), 1,
      anon_sym_AT,
    ACTIONS(12355), 1,
      anon_sym__,
    ACTIONS(12357), 1,
      anon_sym_u27e6,
    ACTIONS(12359), 1,
      sym__splice_dollar,
    ACTIONS(12361), 1,
      sym_quasiquote_start,
    ACTIONS(12363), 1,
      sym__strict,
    ACTIONS(12365), 1,
      sym__lazy,
    ACTIONS(12963), 1,
      sym__conid,
    STATE(357), 1,
      sym__unboxed_open,
    STATE(8734), 1,
      sym_constructor,
    STATE(8825), 1,
      sym__pat_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(9152), 1,
      sym_variable,
    STATE(9642), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12342), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12336), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10843), 5,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(9565), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3172), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [47037] = 29,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12976), 1,
      anon_sym_DASH,
    ACTIONS(12978), 1,
      anon_sym_LPAREN,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(3053), 1,
      sym__pat_constructor,
    STATE(8724), 1,
      sym_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(15329), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(19037), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13533), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47155] = 29,
    ACTIONS(573), 1,
      anon_sym__,
    ACTIONS(593), 1,
      sym__strict,
    ACTIONS(595), 1,
      sym__lazy,
    ACTIONS(12998), 1,
      sym__varid,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13008), 1,
      anon_sym_DASH,
    ACTIONS(13010), 1,
      anon_sym_LPAREN,
    ACTIONS(13012), 1,
      sym__conid,
    ACTIONS(13014), 1,
      anon_sym_LBRACK,
    ACTIONS(13016), 1,
      anon_sym_AT,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    STATE(280), 1,
      sym__unboxed_open,
    STATE(2791), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8502), 1,
      sym__qcon,
    STATE(14057), 1,
      sym_variable,
    STATE(14243), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13006), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15708), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13000), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12479), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47273] = 29,
    ACTIONS(1410), 1,
      anon_sym__,
    ACTIONS(1428), 1,
      sym__strict,
    ACTIONS(1430), 1,
      sym__lazy,
    ACTIONS(13024), 1,
      sym__varid,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13034), 1,
      anon_sym_DASH,
    ACTIONS(13036), 1,
      anon_sym_LPAREN,
    ACTIONS(13038), 1,
      sym__conid,
    ACTIONS(13040), 1,
      anon_sym_LBRACK,
    ACTIONS(13042), 1,
      anon_sym_AT,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    STATE(320), 1,
      sym__unboxed_open,
    STATE(2819), 1,
      sym__pat_constructor,
    STATE(8500), 1,
      sym_constructor,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(14135), 1,
      sym_variable,
    STATE(14895), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13032), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17391), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13026), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14805), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13070), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47391] = 30,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(12102), 1,
      anon_sym_LPAREN,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(6965), 1,
      sym_constructor,
    STATE(8567), 1,
      sym_type_variable,
    STATE(11203), 1,
      sym__simpletype,
    STATE(14505), 1,
      sym__simpletype_infix,
    STATE(14958), 1,
      sym_context,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [47511] = 29,
    ACTIONS(1410), 1,
      anon_sym__,
    ACTIONS(1428), 1,
      sym__strict,
    ACTIONS(1430), 1,
      sym__lazy,
    ACTIONS(13024), 1,
      sym__varid,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13034), 1,
      anon_sym_DASH,
    ACTIONS(13036), 1,
      anon_sym_LPAREN,
    ACTIONS(13038), 1,
      sym__conid,
    ACTIONS(13040), 1,
      anon_sym_LBRACK,
    ACTIONS(13042), 1,
      anon_sym_AT,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    STATE(320), 1,
      sym__unboxed_open,
    STATE(2819), 1,
      sym__pat_constructor,
    STATE(8500), 1,
      sym_constructor,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(14135), 1,
      sym_variable,
    STATE(14895), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13032), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17220), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13026), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14805), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13070), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47629] = 29,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13060), 1,
      anon_sym_DASH,
    ACTIONS(13062), 1,
      anon_sym_LPAREN,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(2815), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17488), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12899), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47747] = 29,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13092), 1,
      anon_sym_DASH,
    ACTIONS(13094), 1,
      anon_sym_LPAREN,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(3095), 1,
      sym__pat_constructor,
    STATE(8734), 1,
      sym_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(14598), 1,
      sym_variable,
    STATE(15257), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18789), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13465), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47865] = 29,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12941), 1,
      anon_sym_DASH,
    ACTIONS(12943), 1,
      anon_sym_LPAREN,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(2923), 1,
      sym__pat_constructor,
    STATE(8596), 1,
      sym_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8865), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17706), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13135), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47983] = 28,
    ACTIONS(13114), 1,
      sym__varid,
    ACTIONS(13120), 1,
      sym__integer_literal,
    ACTIONS(13129), 1,
      anon_sym_LPAREN,
    ACTIONS(13132), 1,
      sym__conid,
    ACTIONS(13135), 1,
      anon_sym_LBRACK,
    ACTIONS(13138), 1,
      anon_sym_AT,
    ACTIONS(13141), 1,
      anon_sym__,
    ACTIONS(13144), 1,
      anon_sym_u27e6,
    ACTIONS(13147), 1,
      sym__splice_dollar,
    ACTIONS(13150), 1,
      sym_quasiquote_start,
    ACTIONS(13153), 1,
      sym__strict,
    ACTIONS(13156), 1,
      sym__lazy,
    STATE(387), 1,
      sym__unboxed_open,
    STATE(8797), 1,
      sym_constructor,
    STATE(8858), 1,
      sym__pat_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(9271), 1,
      sym_variable,
    STATE(9381), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13126), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13123), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10766), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(9433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3149), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [48099] = 23,
    ACTIONS(10719), 1,
      sym__varid,
    ACTIONS(10725), 1,
      sym__integer_literal,
    ACTIONS(10734), 1,
      anon_sym_LPAREN,
    ACTIONS(10740), 1,
      sym__conid,
    ACTIONS(10743), 1,
      anon_sym_LBRACK,
    ACTIONS(10746), 1,
      anon_sym_SQUOTE,
    ACTIONS(10752), 1,
      anon_sym_u27e6,
    ACTIONS(10755), 1,
      sym__splice_dollar,
    ACTIONS(10758), 1,
      sym_quasiquote_start,
    STATE(2097), 1,
      sym__unboxed_open,
    STATE(9746), 1,
      sym_constructor,
    STATE(17572), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10731), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10749), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10722), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10728), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    ACTIONS(5556), 4,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
    STATE(10031), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9934), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3543), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [48205] = 29,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13092), 1,
      anon_sym_DASH,
    ACTIONS(13094), 1,
      anon_sym_LPAREN,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(3095), 1,
      sym__pat_constructor,
    STATE(8734), 1,
      sym_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(14598), 1,
      sym_variable,
    STATE(15257), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18949), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13465), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48323] = 29,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13169), 1,
      anon_sym_DASH,
    ACTIONS(13171), 1,
      anon_sym_LPAREN,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(3010), 1,
      sym__pat_constructor,
    STATE(8797), 1,
      sym_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18175), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13458), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48441] = 29,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13169), 1,
      anon_sym_DASH,
    ACTIONS(13171), 1,
      anon_sym_LPAREN,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(3010), 1,
      sym__pat_constructor,
    STATE(8797), 1,
      sym_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18123), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13458), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48559] = 30,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(11731), 1,
      anon_sym_LPAREN,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(7136), 1,
      sym_constructor,
    STATE(8562), 1,
      sym_type_variable,
    STATE(11898), 1,
      sym__simpletype,
    STATE(14771), 1,
      sym_context,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [48679] = 29,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12941), 1,
      anon_sym_DASH,
    ACTIONS(12943), 1,
      anon_sym_LPAREN,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(2923), 1,
      sym__pat_constructor,
    STATE(8596), 1,
      sym_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8865), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16961), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13135), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48797] = 29,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(20724), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48915] = 29,
    ACTIONS(269), 1,
      anon_sym__,
    ACTIONS(293), 1,
      sym__strict,
    ACTIONS(295), 1,
      sym__lazy,
    ACTIONS(13191), 1,
      sym__varid,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13201), 1,
      anon_sym_DASH,
    ACTIONS(13203), 1,
      anon_sym_LPAREN,
    ACTIONS(13205), 1,
      sym__conid,
    ACTIONS(13207), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(2781), 1,
      sym__pat_constructor,
    STATE(8270), 1,
      sym_constructor,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(13744), 1,
      sym_variable,
    STATE(14076), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14984), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11954), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49033] = 23,
    ACTIONS(5547), 1,
      sym__integer_literal,
    ACTIONS(5558), 1,
      anon_sym_LPAREN,
    ACTIONS(5561), 1,
      sym__conid,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5567), 1,
      anon_sym_SQUOTE,
    ACTIONS(5575), 1,
      anon_sym_u27e6,
    ACTIONS(5578), 1,
      sym__splice_dollar,
    ACTIONS(5581), 1,
      sym_quasiquote_start,
    ACTIONS(6630), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5553), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5544), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5550), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5542), 4,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
      anon_sym_AT,
    ACTIONS(5556), 4,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3517), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [49139] = 29,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11081), 1,
      anon_sym_DASH,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(13217), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(2672), 1,
      sym__pat_constructor,
    STATE(8191), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8306), 1,
      sym__qcon,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(21052), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11247), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49257] = 29,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(4903), 1,
      anon_sym_DASH,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_AT,
    ACTIONS(4917), 1,
      anon_sym__,
    ACTIONS(4923), 1,
      sym__strict,
    ACTIONS(4925), 1,
      sym__lazy,
    ACTIONS(13219), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym__unboxed_open,
    STATE(3120), 1,
      sym__pat_constructor,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(15163), 1,
      sym_variable,
    STATE(16130), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4901), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18252), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4863), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10522), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13722), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49375] = 25,
    ACTIONS(12546), 1,
      anon_sym_deriving,
    ACTIONS(13221), 1,
      sym__varid,
    ACTIONS(13227), 1,
      sym__integer_literal,
    ACTIONS(13236), 1,
      anon_sym_LPAREN,
    ACTIONS(13239), 1,
      sym__conid,
    ACTIONS(13242), 1,
      anon_sym_LBRACK,
    ACTIONS(13245), 1,
      anon_sym_SQUOTE,
    ACTIONS(13251), 1,
      anon_sym_u27e6,
    ACTIONS(13254), 1,
      sym__splice_dollar,
    ACTIONS(13257), 1,
      sym_quasiquote_start,
    ACTIONS(13260), 1,
      sym__strict,
    ACTIONS(13263), 1,
      sym__lazy,
    STATE(2068), 1,
      sym__unboxed_open,
    STATE(8222), 1,
      sym_constructor,
    STATE(16645), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13233), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13248), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12514), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(13224), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13230), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8300), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3161), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [49485] = 28,
    ACTIONS(12059), 1,
      sym__varid,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(12069), 1,
      anon_sym_LPAREN,
    ACTIONS(12074), 1,
      anon_sym_LBRACK,
    ACTIONS(12078), 1,
      anon_sym_AT,
    ACTIONS(12080), 1,
      anon_sym__,
    ACTIONS(12082), 1,
      anon_sym_u27e6,
    ACTIONS(12084), 1,
      sym__splice_dollar,
    ACTIONS(12086), 1,
      sym_quasiquote_start,
    ACTIONS(12088), 1,
      sym__strict,
    ACTIONS(12090), 1,
      sym__lazy,
    ACTIONS(13266), 1,
      sym__conid,
    STATE(387), 1,
      sym__unboxed_open,
    STATE(8797), 1,
      sym_constructor,
    STATE(8858), 1,
      sym__pat_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(9271), 1,
      sym_variable,
    STATE(9381), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12067), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10843), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(9433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3149), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [49601] = 29,
    ACTIONS(573), 1,
      anon_sym__,
    ACTIONS(593), 1,
      sym__strict,
    ACTIONS(595), 1,
      sym__lazy,
    ACTIONS(12998), 1,
      sym__varid,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13008), 1,
      anon_sym_DASH,
    ACTIONS(13010), 1,
      anon_sym_LPAREN,
    ACTIONS(13012), 1,
      sym__conid,
    ACTIONS(13014), 1,
      anon_sym_LBRACK,
    ACTIONS(13016), 1,
      anon_sym_AT,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    STATE(280), 1,
      sym__unboxed_open,
    STATE(2791), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8502), 1,
      sym__qcon,
    STATE(14057), 1,
      sym_variable,
    STATE(14243), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13006), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15720), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13000), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12479), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49719] = 28,
    ACTIONS(12243), 1,
      sym__varid,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12253), 1,
      anon_sym_LPAREN,
    ACTIONS(12258), 1,
      anon_sym_LBRACK,
    ACTIONS(12262), 1,
      anon_sym_AT,
    ACTIONS(12264), 1,
      anon_sym__,
    ACTIONS(12266), 1,
      anon_sym_u27e6,
    ACTIONS(12268), 1,
      sym__splice_dollar,
    ACTIONS(12270), 1,
      sym_quasiquote_start,
    ACTIONS(12272), 1,
      sym__strict,
    ACTIONS(12274), 1,
      sym__lazy,
    ACTIONS(13269), 1,
      sym__conid,
    STATE(355), 1,
      sym__unboxed_open,
    STATE(8724), 1,
      sym_constructor,
    STATE(8733), 1,
      sym__pat_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(9026), 1,
      sym_variable,
    STATE(9480), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12251), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12245), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10843), 5,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
    STATE(9515), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3178), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [49835] = 29,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(4903), 1,
      anon_sym_DASH,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_AT,
    ACTIONS(4917), 1,
      anon_sym__,
    ACTIONS(4923), 1,
      sym__strict,
    ACTIONS(4925), 1,
      sym__lazy,
    ACTIONS(13219), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym__unboxed_open,
    STATE(3120), 1,
      sym__pat_constructor,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(15163), 1,
      sym_variable,
    STATE(16130), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4901), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18285), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4863), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10522), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13722), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49953] = 29,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13060), 1,
      anon_sym_DASH,
    ACTIONS(13062), 1,
      anon_sym_LPAREN,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(2815), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17719), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12899), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50071] = 29,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13060), 1,
      anon_sym_DASH,
    ACTIONS(13062), 1,
      anon_sym_LPAREN,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(2815), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17442), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12899), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50189] = 25,
    ACTIONS(8396), 1,
      sym__strict,
    ACTIONS(8398), 1,
      sym__lazy,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(12458), 1,
      anon_sym_deriving,
    ACTIONS(13272), 1,
      sym__varid,
    ACTIONS(13278), 1,
      anon_sym_LPAREN,
    ACTIONS(13280), 1,
      anon_sym_LBRACK,
    ACTIONS(13282), 1,
      anon_sym_SQUOTE,
    ACTIONS(13286), 1,
      sym__splice_dollar,
    STATE(2068), 1,
      sym__unboxed_open,
    STATE(8222), 1,
      sym_constructor,
    STATE(16645), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13276), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13284), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(12436), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(13274), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8300), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3161), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [50299] = 29,
    ACTIONS(35), 1,
      anon_sym__,
    ACTIONS(77), 1,
      sym__strict,
    ACTIONS(79), 1,
      sym__lazy,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(5329), 1,
      anon_sym_DASH,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(5337), 1,
      anon_sym_AT,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2763), 1,
      sym__pat_constructor,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(13817), 1,
      sym_variable,
    STATE(14028), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5327), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14726), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4457), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10563), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11992), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50417] = 29,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13092), 1,
      anon_sym_DASH,
    ACTIONS(13094), 1,
      anon_sym_LPAREN,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(3095), 1,
      sym__pat_constructor,
    STATE(8734), 1,
      sym_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(14598), 1,
      sym_variable,
    STATE(15257), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18757), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13465), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50535] = 29,
    ACTIONS(1598), 1,
      anon_sym__,
    ACTIONS(1606), 1,
      sym__strict,
    ACTIONS(1608), 1,
      sym__lazy,
    ACTIONS(13290), 1,
      sym__varid,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13300), 1,
      anon_sym_DASH,
    ACTIONS(13302), 1,
      anon_sym_LPAREN,
    ACTIONS(13304), 1,
      sym__conid,
    ACTIONS(13306), 1,
      anon_sym_LBRACK,
    ACTIONS(13308), 1,
      anon_sym_AT,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    STATE(407), 1,
      sym__unboxed_open,
    STATE(2913), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(14273), 1,
      sym_variable,
    STATE(14872), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13298), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17008), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13292), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13187), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50653] = 28,
    ACTIONS(13316), 1,
      sym__varid,
    ACTIONS(13322), 1,
      sym__integer_literal,
    ACTIONS(13331), 1,
      anon_sym_LPAREN,
    ACTIONS(13334), 1,
      sym__conid,
    ACTIONS(13337), 1,
      anon_sym_LBRACK,
    ACTIONS(13340), 1,
      anon_sym_AT,
    ACTIONS(13343), 1,
      anon_sym__,
    ACTIONS(13346), 1,
      anon_sym_u27e6,
    ACTIONS(13349), 1,
      sym__splice_dollar,
    ACTIONS(13352), 1,
      sym_quasiquote_start,
    ACTIONS(13355), 1,
      sym__strict,
    ACTIONS(13358), 1,
      sym__lazy,
    STATE(357), 1,
      sym__unboxed_open,
    STATE(8734), 1,
      sym_constructor,
    STATE(8825), 1,
      sym__pat_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(9152), 1,
      sym_variable,
    STATE(9642), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13328), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13319), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13325), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10766), 5,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(9565), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3172), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [50769] = 29,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17570), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50887] = 29,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11081), 1,
      anon_sym_DASH,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(13217), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(2672), 1,
      sym__pat_constructor,
    STATE(8191), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8306), 1,
      sym__qcon,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14644), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11247), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51005] = 29,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12976), 1,
      anon_sym_DASH,
    ACTIONS(12978), 1,
      anon_sym_LPAREN,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(3053), 1,
      sym__pat_constructor,
    STATE(8724), 1,
      sym_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(15329), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17958), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13533), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51123] = 29,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12976), 1,
      anon_sym_DASH,
    ACTIONS(12978), 1,
      anon_sym_LPAREN,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(3053), 1,
      sym__pat_constructor,
    STATE(8724), 1,
      sym_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(15329), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17998), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13533), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51241] = 29,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13169), 1,
      anon_sym_DASH,
    ACTIONS(13171), 1,
      anon_sym_LPAREN,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(3010), 1,
      sym__pat_constructor,
    STATE(8797), 1,
      sym_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17953), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13458), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51359] = 28,
    ACTIONS(13361), 1,
      sym__varid,
    ACTIONS(13367), 1,
      sym__integer_literal,
    ACTIONS(13376), 1,
      anon_sym_LPAREN,
    ACTIONS(13379), 1,
      sym__conid,
    ACTIONS(13382), 1,
      anon_sym_LBRACK,
    ACTIONS(13385), 1,
      anon_sym_AT,
    ACTIONS(13388), 1,
      anon_sym__,
    ACTIONS(13391), 1,
      anon_sym_u27e6,
    ACTIONS(13394), 1,
      sym__splice_dollar,
    ACTIONS(13397), 1,
      sym_quasiquote_start,
    ACTIONS(13400), 1,
      sym__strict,
    ACTIONS(13403), 1,
      sym__lazy,
    STATE(355), 1,
      sym__unboxed_open,
    STATE(8724), 1,
      sym_constructor,
    STATE(8733), 1,
      sym__pat_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(9026), 1,
      sym_variable,
    STATE(9480), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13373), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13364), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13370), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10766), 5,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
    STATE(9515), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3178), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [51475] = 29,
    ACTIONS(35), 1,
      anon_sym__,
    ACTIONS(77), 1,
      sym__strict,
    ACTIONS(79), 1,
      sym__lazy,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(5329), 1,
      anon_sym_DASH,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(5337), 1,
      anon_sym_AT,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2763), 1,
      sym__pat_constructor,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(13817), 1,
      sym_variable,
    STATE(14028), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5327), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14890), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4457), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10563), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11992), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51593] = 29,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10860), 1,
      anon_sym_DASH,
    ACTIONS(10862), 1,
      anon_sym_LPAREN,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(2877), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8868), 1,
      sym__qcon,
    STATE(14183), 1,
      sym_variable,
    STATE(14592), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17625), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13086), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51711] = 29,
    ACTIONS(269), 1,
      anon_sym__,
    ACTIONS(293), 1,
      sym__strict,
    ACTIONS(295), 1,
      sym__lazy,
    ACTIONS(13191), 1,
      sym__varid,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13201), 1,
      anon_sym_DASH,
    ACTIONS(13203), 1,
      anon_sym_LPAREN,
    ACTIONS(13205), 1,
      sym__conid,
    ACTIONS(13207), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(2781), 1,
      sym__pat_constructor,
    STATE(8270), 1,
      sym_constructor,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(13744), 1,
      sym_variable,
    STATE(14076), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15237), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11954), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51829] = 29,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11081), 1,
      anon_sym_DASH,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(13217), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(2672), 1,
      sym__pat_constructor,
    STATE(8191), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8306), 1,
      sym__qcon,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14554), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11247), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51947] = 30,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(12215), 1,
      anon_sym_LPAREN,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(6673), 1,
      sym_constructor,
    STATE(8559), 1,
      sym_type_variable,
    STATE(11445), 1,
      sym__simpletype,
    STATE(14488), 1,
      sym__simpletype_infix,
    STATE(14594), 1,
      sym_context,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(18466), 1,
      sym__context,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    STATE(17862), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [52067] = 29,
    ACTIONS(1598), 1,
      anon_sym__,
    ACTIONS(1606), 1,
      sym__strict,
    ACTIONS(1608), 1,
      sym__lazy,
    ACTIONS(13290), 1,
      sym__varid,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13300), 1,
      anon_sym_DASH,
    ACTIONS(13302), 1,
      anon_sym_LPAREN,
    ACTIONS(13304), 1,
      sym__conid,
    ACTIONS(13306), 1,
      anon_sym_LBRACK,
    ACTIONS(13308), 1,
      anon_sym_AT,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    STATE(407), 1,
      sym__unboxed_open,
    STATE(2913), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(14273), 1,
      sym_variable,
    STATE(14872), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13298), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17091), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(13292), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13187), 18,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52185] = 25,
    ACTIONS(8307), 1,
      sym__integer_literal,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_LBRACK,
    ACTIONS(8319), 1,
      anon_sym_SQUOTE,
    ACTIONS(8323), 1,
      anon_sym_u27e6,
    ACTIONS(8325), 1,
      sym__splice_dollar,
    ACTIONS(8327), 1,
      sym_quasiquote_start,
    ACTIONS(9112), 1,
      anon_sym_LPAREN,
    ACTIONS(13406), 1,
      sym__varid,
    ACTIONS(13408), 1,
      sym__strict,
    ACTIONS(13410), 1,
      sym__lazy,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(7250), 1,
      sym_constructor,
    STATE(16496), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8321), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8875), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(8305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7626), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16340), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7589), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2547), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [52294] = 25,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11747), 1,
      anon_sym_LPAREN,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(11761), 1,
      anon_sym_u27e6,
    ACTIONS(11763), 1,
      sym__splice_dollar,
    ACTIONS(11765), 1,
      sym_quasiquote_start,
    ACTIONS(13412), 1,
      sym__varid,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(13416), 1,
      anon_sym_SQUOTE,
    ACTIONS(13418), 1,
      sym__strict,
    ACTIONS(13420), 1,
      sym__lazy,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11757), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10355), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15911), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2964), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [52403] = 22,
    ACTIONS(13424), 1,
      sym__varid,
    ACTIONS(13428), 1,
      sym__integer_literal,
    ACTIONS(13434), 1,
      anon_sym_LPAREN,
    ACTIONS(13436), 1,
      sym__conid,
    ACTIONS(13438), 1,
      anon_sym_LBRACK,
    ACTIONS(13440), 1,
      anon_sym_SQUOTE,
    ACTIONS(13444), 1,
      anon_sym_u27e6,
    ACTIONS(13446), 1,
      sym__splice_dollar,
    ACTIONS(13448), 1,
      sym_quasiquote_start,
    STATE(2150), 1,
      sym__unboxed_open,
    STATE(8765), 1,
      sym_constructor,
    STATE(16504), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13432), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13442), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13426), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13430), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9074), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9253), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13422), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3201), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [52506] = 28,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8832), 1,
      anon_sym_LPAREN,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(2522), 1,
      sym_type_name,
    STATE(3573), 1,
      sym_context,
    STATE(7002), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12864), 1,
      sym_type_infix,
    STATE(14189), 1,
      sym__type_infix,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8442), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2504), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [52621] = 22,
    ACTIONS(13452), 1,
      sym__varid,
    ACTIONS(13456), 1,
      sym__integer_literal,
    ACTIONS(13462), 1,
      anon_sym_LPAREN,
    ACTIONS(13464), 1,
      sym__conid,
    ACTIONS(13466), 1,
      anon_sym_LBRACK,
    ACTIONS(13468), 1,
      anon_sym_SQUOTE,
    ACTIONS(13472), 1,
      anon_sym_u27e6,
    ACTIONS(13474), 1,
      sym__splice_dollar,
    ACTIONS(13476), 1,
      sym_quasiquote_start,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8881), 1,
      sym_constructor,
    STATE(17223), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13460), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13470), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13454), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13458), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9334), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9054), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13422), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3190), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [52724] = 22,
    ACTIONS(13478), 1,
      sym__varid,
    ACTIONS(13486), 1,
      sym__integer_literal,
    ACTIONS(13495), 1,
      anon_sym_LPAREN,
    ACTIONS(13498), 1,
      sym__conid,
    ACTIONS(13501), 1,
      anon_sym_LBRACK,
    ACTIONS(13504), 1,
      anon_sym_SQUOTE,
    ACTIONS(13510), 1,
      anon_sym_u27e6,
    ACTIONS(13513), 1,
      sym__splice_dollar,
    ACTIONS(13516), 1,
      sym_quasiquote_start,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8881), 1,
      sym_constructor,
    STATE(17223), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13492), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13507), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13483), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9334), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9054), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13481), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3190), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [52827] = 25,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11867), 1,
      anon_sym_LPAREN,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(11881), 1,
      anon_sym_u27e6,
    ACTIONS(11883), 1,
      sym__splice_dollar,
    ACTIONS(11885), 1,
      sym_quasiquote_start,
    ACTIONS(13519), 1,
      sym__varid,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(13523), 1,
      anon_sym_SQUOTE,
    ACTIONS(13525), 1,
      sym__strict,
    ACTIONS(13527), 1,
      sym__lazy,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11877), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10301), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16113), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3089), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [52936] = 28,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7061), 1,
      anon_sym_u27e6,
    ACTIONS(7063), 1,
      sym__splice_dollar,
    ACTIONS(7065), 1,
      sym_quasiquote_start,
    ACTIONS(7779), 1,
      anon_sym_LPAREN,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(7785), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    STATE(2091), 1,
      sym__unboxed_open,
    STATE(2494), 1,
      sym_type_name,
    STATE(3569), 1,
      sym_context,
    STATE(6654), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12340), 1,
      sym_type_infix,
    STATE(14013), 1,
      sym__type_infix,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7045), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7057), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8252), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2390), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [53051] = 28,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8243), 1,
      anon_sym_LPAREN,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(2458), 1,
      sym_type_name,
    STATE(3597), 1,
      sym_context,
    STATE(6430), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(12156), 1,
      sym_type_infix,
    STATE(14120), 1,
      sym__type_infix,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8266), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2389), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [53166] = 25,
    ACTIONS(8307), 1,
      sym__integer_literal,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_LBRACK,
    ACTIONS(8319), 1,
      anon_sym_SQUOTE,
    ACTIONS(8323), 1,
      anon_sym_u27e6,
    ACTIONS(8325), 1,
      sym__splice_dollar,
    ACTIONS(8327), 1,
      sym_quasiquote_start,
    ACTIONS(9112), 1,
      anon_sym_LPAREN,
    ACTIONS(13406), 1,
      sym__varid,
    ACTIONS(13408), 1,
      sym__strict,
    ACTIONS(13410), 1,
      sym__lazy,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(7250), 1,
      sym_constructor,
    STATE(16496), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8321), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8875), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(8305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7626), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16512), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7589), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2547), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [53275] = 28,
    ACTIONS(12611), 1,
      sym__varid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(12621), 1,
      anon_sym_LPAREN,
    ACTIONS(12626), 1,
      anon_sym_LBRACK,
    ACTIONS(12630), 1,
      anon_sym_AT,
    ACTIONS(12632), 1,
      anon_sym__,
    ACTIONS(12634), 1,
      anon_sym_u27e6,
    ACTIONS(12636), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    ACTIONS(12640), 1,
      sym__strict,
    ACTIONS(12642), 1,
      sym__lazy,
    ACTIONS(13533), 1,
      sym__conid,
    STATE(353), 1,
      sym__unboxed_open,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9100), 1,
      sym__pat_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(9606), 1,
      sym_variable,
    STATE(9685), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12619), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12613), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10843), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(9691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3198), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [53390] = 25,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11747), 1,
      anon_sym_LPAREN,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(11761), 1,
      anon_sym_u27e6,
    ACTIONS(11763), 1,
      sym__splice_dollar,
    ACTIONS(11765), 1,
      sym_quasiquote_start,
    ACTIONS(13412), 1,
      sym__varid,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(13416), 1,
      anon_sym_SQUOTE,
    ACTIONS(13418), 1,
      sym__strict,
    ACTIONS(13420), 1,
      sym__lazy,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11757), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10355), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16150), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2964), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [53499] = 25,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11867), 1,
      anon_sym_LPAREN,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(11881), 1,
      anon_sym_u27e6,
    ACTIONS(11883), 1,
      sym__splice_dollar,
    ACTIONS(11885), 1,
      sym_quasiquote_start,
    ACTIONS(13519), 1,
      sym__varid,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(13523), 1,
      anon_sym_SQUOTE,
    ACTIONS(13525), 1,
      sym__strict,
    ACTIONS(13527), 1,
      sym__lazy,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11877), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10301), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15765), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3089), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [53608] = 28,
    ACTIONS(13536), 1,
      sym__varid,
    ACTIONS(13542), 1,
      sym__integer_literal,
    ACTIONS(13551), 1,
      anon_sym_LPAREN,
    ACTIONS(13554), 1,
      sym__conid,
    ACTIONS(13557), 1,
      anon_sym_LBRACK,
    ACTIONS(13560), 1,
      anon_sym_AT,
    ACTIONS(13563), 1,
      anon_sym__,
    ACTIONS(13566), 1,
      anon_sym_u27e6,
    ACTIONS(13569), 1,
      sym__splice_dollar,
    ACTIONS(13572), 1,
      sym_quasiquote_start,
    ACTIONS(13575), 1,
      sym__strict,
    ACTIONS(13578), 1,
      sym__lazy,
    STATE(353), 1,
      sym__unboxed_open,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9100), 1,
      sym__pat_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(9606), 1,
      sym_variable,
    STATE(9685), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13548), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13539), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13545), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10766), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(9691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3198), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [53723] = 25,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(13581), 1,
      sym__varid,
    ACTIONS(13587), 1,
      sym__integer_literal,
    ACTIONS(13596), 1,
      anon_sym_LPAREN,
    ACTIONS(13599), 1,
      sym__conid,
    ACTIONS(13602), 1,
      anon_sym_LBRACK,
    ACTIONS(13605), 1,
      anon_sym_SQUOTE,
    ACTIONS(13611), 1,
      anon_sym_AT,
    ACTIONS(13614), 1,
      anon_sym_EQ,
    ACTIONS(13616), 1,
      anon_sym_u27e6,
    ACTIONS(13619), 1,
      sym__splice_dollar,
    ACTIONS(13622), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13593), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13608), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7506), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(13584), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13590), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3606), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [53832] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2050), 1,
      sym_type_name,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3604), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10593), 1,
      sym_type_infix,
    STATE(10676), 1,
      sym__context,
    STATE(16057), 1,
      sym__type_infix,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(17959), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [53947] = 22,
    ACTIONS(13625), 1,
      sym__varid,
    ACTIONS(13631), 1,
      sym__integer_literal,
    ACTIONS(13640), 1,
      anon_sym_LPAREN,
    ACTIONS(13643), 1,
      sym__conid,
    ACTIONS(13646), 1,
      anon_sym_LBRACK,
    ACTIONS(13649), 1,
      anon_sym_SQUOTE,
    ACTIONS(13655), 1,
      anon_sym_u27e6,
    ACTIONS(13658), 1,
      sym__splice_dollar,
    ACTIONS(13661), 1,
      sym_quasiquote_start,
    STATE(2150), 1,
      sym__unboxed_open,
    STATE(8765), 1,
      sym_constructor,
    STATE(16504), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13637), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13652), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13634), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9074), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9253), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13481), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3201), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [54050] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1580), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13674), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [54166] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13696), 1,
      anon_sym_SEMI,
    ACTIONS(13698), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17539), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [54286] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1418), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13700), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [54402] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13702), 1,
      anon_sym_SEMI,
    ACTIONS(13704), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16988), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [54522] = 22,
    ACTIONS(13706), 1,
      sym__varid,
    ACTIONS(13712), 1,
      sym__integer_literal,
    ACTIONS(13721), 1,
      anon_sym_LPAREN,
    ACTIONS(13724), 1,
      sym__conid,
    ACTIONS(13727), 1,
      anon_sym_LBRACK,
    ACTIONS(13730), 1,
      anon_sym_SQUOTE,
    ACTIONS(13736), 1,
      anon_sym_u27e6,
    ACTIONS(13739), 1,
      sym__splice_dollar,
    ACTIONS(13742), 1,
      sym_quasiquote_start,
    STATE(2156), 1,
      sym__unboxed_open,
    STATE(9252), 1,
      sym_constructor,
    STATE(17266), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13718), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13709), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13715), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9411), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9360), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13481), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    STATE(3206), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [54624] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13745), 1,
      anon_sym_SEMI,
    ACTIONS(13747), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17022), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [54744] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13749), 1,
      anon_sym_SEMI,
    ACTIONS(13751), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17518), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [54864] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1630), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13753), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [54980] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13755), 1,
      anon_sym_SEMI,
    ACTIONS(13757), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17598), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [55100] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13759), 1,
      anon_sym_SEMI,
    ACTIONS(13761), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16901), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [55220] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1511), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13763), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [55336] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1348), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13765), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [55452] = 22,
    ACTIONS(13767), 1,
      sym__varid,
    ACTIONS(13771), 1,
      sym__integer_literal,
    ACTIONS(13777), 1,
      anon_sym_LPAREN,
    ACTIONS(13779), 1,
      sym__conid,
    ACTIONS(13781), 1,
      anon_sym_LBRACK,
    ACTIONS(13783), 1,
      anon_sym_SQUOTE,
    ACTIONS(13787), 1,
      anon_sym_u27e6,
    ACTIONS(13789), 1,
      sym__splice_dollar,
    ACTIONS(13791), 1,
      sym_quasiquote_start,
    STATE(2124), 1,
      sym__unboxed_open,
    STATE(8993), 1,
      sym_constructor,
    STATE(17296), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13775), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13785), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13769), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13773), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9519), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9437), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13422), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3310), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [55554] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(10066), 1,
      sym__varid,
    ACTIONS(13793), 1,
      anon_sym_LPAREN,
    ACTIONS(13795), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3036), 1,
      sym_type_name,
    STATE(3605), 1,
      sym_context,
    STATE(7746), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(14455), 1,
      sym_constraint,
    STATE(15269), 1,
      sym_type_infix,
    STATE(16892), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10910), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7972), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [55668] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13797), 1,
      anon_sym_SEMI,
    ACTIONS(13799), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16688), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [55788] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13801), 1,
      anon_sym_SEMI,
    ACTIONS(13803), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17725), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [55908] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13805), 1,
      anon_sym_SEMI,
    ACTIONS(13807), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17300), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56028] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13809), 1,
      anon_sym_SEMI,
    ACTIONS(13811), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17637), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56148] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13813), 1,
      anon_sym_SEMI,
    ACTIONS(13815), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17617), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56268] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(11119), 1,
      anon_sym_LPAREN,
    ACTIONS(11121), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2998), 1,
      sym_type_name,
    STATE(3566), 1,
      sym_context,
    STATE(6654), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(15262), 1,
      sym_constraint,
    STATE(15278), 1,
      sym_type_infix,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10888), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [56382] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13817), 1,
      anon_sym_SEMI,
    ACTIONS(13819), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17658), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56502] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13821), 1,
      anon_sym_SEMI,
    ACTIONS(13823), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17026), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56622] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13825), 1,
      anon_sym_SEMI,
    ACTIONS(13827), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17783), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56742] = 22,
    ACTIONS(13829), 1,
      sym__varid,
    ACTIONS(13835), 1,
      sym__integer_literal,
    ACTIONS(13844), 1,
      anon_sym_LPAREN,
    ACTIONS(13847), 1,
      sym__conid,
    ACTIONS(13850), 1,
      anon_sym_LBRACK,
    ACTIONS(13853), 1,
      anon_sym_SQUOTE,
    ACTIONS(13859), 1,
      anon_sym_u27e6,
    ACTIONS(13862), 1,
      sym__splice_dollar,
    ACTIONS(13865), 1,
      sym_quasiquote_start,
    STATE(2198), 1,
      sym__unboxed_open,
    STATE(9183), 1,
      sym_constructor,
    STATE(17205), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13841), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13856), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13832), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13838), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9428), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13481), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3225), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [56844] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13868), 1,
      anon_sym_SEMI,
    ACTIONS(13870), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17374), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [56964] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13872), 1,
      anon_sym_SEMI,
    ACTIONS(13874), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16587), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [57084] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13876), 1,
      anon_sym_SEMI,
    ACTIONS(13878), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17420), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [57204] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1557), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13880), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [57320] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(11183), 1,
      anon_sym_LPAREN,
    ACTIONS(11185), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3138), 1,
      sym_type_name,
    STATE(3554), 1,
      sym_context,
    STATE(7796), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(15751), 1,
      sym_type_infix,
    STATE(15888), 1,
      sym_constraint,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10879), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [57434] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13882), 1,
      anon_sym_SEMI,
    ACTIONS(13884), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17399), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [57554] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13886), 1,
      anon_sym_SEMI,
    ACTIONS(13888), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16553), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [57674] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13890), 1,
      anon_sym_SEMI,
    ACTIONS(13892), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17648), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [57794] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13894), 1,
      anon_sym_SEMI,
    ACTIONS(13896), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17105), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [57914] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1646), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13898), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [58030] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13900), 1,
      anon_sym_SEMI,
    ACTIONS(13902), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16882), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58150] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13904), 1,
      anon_sym_SEMI,
    ACTIONS(13906), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17042), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58270] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13908), 1,
      anon_sym_SEMI,
    ACTIONS(13910), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16848), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58390] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13912), 1,
      anon_sym_SEMI,
    ACTIONS(13914), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16772), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58510] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13916), 1,
      anon_sym_SEMI,
    ACTIONS(13918), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17299), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58630] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13920), 1,
      anon_sym_SEMI,
    ACTIONS(13922), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17126), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58750] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13924), 1,
      anon_sym_SEMI,
    ACTIONS(13926), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17277), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [58870] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(11055), 1,
      anon_sym_LPAREN,
    ACTIONS(11057), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2992), 1,
      sym_type_name,
    STATE(3601), 1,
      sym_context,
    STATE(6430), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(15027), 1,
      sym_type_infix,
    STATE(15462), 1,
      sym_constraint,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10896), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [58984] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13928), 1,
      anon_sym_SEMI,
    ACTIONS(13930), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16797), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [59104] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(11457), 1,
      anon_sym_LPAREN,
    ACTIONS(11459), 1,
      anon_sym_SQUOTE,
    ACTIONS(13932), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3137), 1,
      sym_type_name,
    STATE(3561), 1,
      sym_context,
    STATE(7673), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(15856), 1,
      sym_type_infix,
    STATE(15975), 1,
      sym_constraint,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10860), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8101), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [59218] = 22,
    ACTIONS(13934), 1,
      sym__varid,
    ACTIONS(13938), 1,
      sym__integer_literal,
    ACTIONS(13944), 1,
      anon_sym_LPAREN,
    ACTIONS(13946), 1,
      sym__conid,
    ACTIONS(13948), 1,
      anon_sym_LBRACK,
    ACTIONS(13950), 1,
      anon_sym_SQUOTE,
    ACTIONS(13954), 1,
      anon_sym_u27e6,
    ACTIONS(13956), 1,
      sym__splice_dollar,
    ACTIONS(13958), 1,
      sym_quasiquote_start,
    STATE(2198), 1,
      sym__unboxed_open,
    STATE(9183), 1,
      sym_constructor,
    STATE(17205), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13942), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13952), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13936), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13940), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9428), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13422), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3225), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [59320] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13960), 1,
      anon_sym_SEMI,
    ACTIONS(13962), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17526), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [59440] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13964), 1,
      anon_sym_SEMI,
    ACTIONS(13966), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16776), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [59560] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13968), 1,
      anon_sym_SEMI,
    ACTIONS(13970), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17756), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [59680] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1639), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13972), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [59796] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13974), 1,
      anon_sym_SEMI,
    ACTIONS(13976), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17492), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [59916] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13978), 1,
      anon_sym_SEMI,
    ACTIONS(13980), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17777), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60036] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13982), 1,
      anon_sym_SEMI,
    ACTIONS(13984), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16445), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60156] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13986), 1,
      anon_sym_SEMI,
    ACTIONS(13988), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16741), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60276] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13990), 1,
      anon_sym_SEMI,
    ACTIONS(13992), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17565), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60396] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13994), 1,
      anon_sym_SEMI,
    ACTIONS(13996), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17108), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60516] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13998), 1,
      anon_sym_SEMI,
    ACTIONS(14000), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17161), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60636] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14002), 1,
      anon_sym_SEMI,
    ACTIONS(14004), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16397), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60756] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14006), 1,
      anon_sym_SEMI,
    ACTIONS(14008), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17139), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60876] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14010), 1,
      anon_sym_SEMI,
    ACTIONS(14012), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17226), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [60996] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1316), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14014), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [61112] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14016), 1,
      anon_sym_SEMI,
    ACTIONS(14018), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17542), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [61232] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1633), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14020), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [61348] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14022), 1,
      anon_sym_SEMI,
    ACTIONS(14024), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16654), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [61468] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14026), 1,
      anon_sym_SEMI,
    ACTIONS(14028), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16965), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [61588] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1450), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14030), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [61704] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14032), 1,
      anon_sym_SEMI,
    ACTIONS(14034), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16648), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [61824] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14036), 1,
      anon_sym_SEMI,
    ACTIONS(14038), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17833), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [61944] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14040), 1,
      anon_sym_SEMI,
    ACTIONS(14042), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17243), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [62064] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14044), 1,
      anon_sym_SEMI,
    ACTIONS(14046), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16845), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [62184] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14048), 1,
      anon_sym_SEMI,
    ACTIONS(14050), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17759), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [62304] = 24,
    ACTIONS(14052), 1,
      sym__varid,
    ACTIONS(14058), 1,
      sym__integer_literal,
    ACTIONS(14067), 1,
      anon_sym_LPAREN,
    ACTIONS(14072), 1,
      sym__conid,
    ACTIONS(14075), 1,
      anon_sym_LBRACK,
    ACTIONS(14078), 1,
      anon_sym_SQUOTE,
    ACTIONS(14084), 1,
      anon_sym_AT,
    ACTIONS(14087), 1,
      anon_sym_EQ,
    ACTIONS(14089), 1,
      anon_sym_u27e6,
    ACTIONS(14092), 1,
      sym__splice_dollar,
    ACTIONS(14095), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14064), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14081), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14055), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14061), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14070), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3557), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [62410] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1568), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14098), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [62526] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14100), 1,
      anon_sym_SEMI,
    ACTIONS(14102), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16630), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [62646] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14104), 1,
      anon_sym_SEMI,
    ACTIONS(14106), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16574), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [62766] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14108), 1,
      anon_sym_SEMI,
    ACTIONS(14110), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17142), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [62886] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1605), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14112), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [63002] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14114), 1,
      anon_sym_SEMI,
    ACTIONS(14116), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17000), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [63122] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14118), 1,
      anon_sym_SEMI,
    ACTIONS(14120), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16754), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [63242] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1390), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14122), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [63358] = 31,
    ACTIONS(693), 1,
      anon_sym_SEMI,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(4578), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(20571), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [63478] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14124), 1,
      anon_sym_SEMI,
    ACTIONS(14126), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16271), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [63598] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14128), 1,
      anon_sym_SEMI,
    ACTIONS(14130), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16525), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [63718] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3158), 1,
      sym_type_name,
    STATE(3579), 1,
      sym_context,
    STATE(4157), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(17553), 1,
      sym_constraint,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63832] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14132), 1,
      anon_sym_SEMI,
    ACTIONS(14134), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16290), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [63952] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14136), 1,
      anon_sym_SEMI,
    ACTIONS(14138), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16505), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [64072] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(9186), 1,
      sym__varid,
    ACTIONS(14140), 1,
      anon_sym_LPAREN,
    ACTIONS(14142), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2872), 1,
      sym_type_name,
    STATE(3551), 1,
      sym_context,
    STATE(7510), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(13898), 1,
      sym_constraint,
    STATE(14793), 1,
      sym_type_infix,
    STATE(16491), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10850), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7791), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64186] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1369), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14144), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [64302] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1533), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14146), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [64418] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14148), 1,
      anon_sym_SEMI,
    ACTIONS(14150), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16883), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [64538] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1344), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14152), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [64654] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14154), 1,
      anon_sym_SEMI,
    ACTIONS(14156), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16861), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [64774] = 22,
    ACTIONS(14158), 1,
      sym__varid,
    ACTIONS(14162), 1,
      sym__integer_literal,
    ACTIONS(14168), 1,
      anon_sym_LPAREN,
    ACTIONS(14170), 1,
      sym__conid,
    ACTIONS(14172), 1,
      anon_sym_LBRACK,
    ACTIONS(14174), 1,
      anon_sym_SQUOTE,
    ACTIONS(14178), 1,
      anon_sym_u27e6,
    ACTIONS(14180), 1,
      sym__splice_dollar,
    ACTIONS(14182), 1,
      sym_quasiquote_start,
    STATE(2156), 1,
      sym__unboxed_open,
    STATE(9252), 1,
      sym_constructor,
    STATE(17266), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14166), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14176), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14160), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14164), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9411), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9360), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13422), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    STATE(3206), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [64876] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(9500), 1,
      sym__varid,
    ACTIONS(14184), 1,
      anon_sym_LPAREN,
    ACTIONS(14186), 1,
      anon_sym_SQUOTE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2922), 1,
      sym_type_name,
    STATE(3582), 1,
      sym_context,
    STATE(7251), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(14100), 1,
      sym_constraint,
    STATE(14713), 1,
      sym_type_infix,
    STATE(16860), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10899), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7644), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64990] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14188), 1,
      anon_sym_SEMI,
    ACTIONS(14190), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17661), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65110] = 29,
    ACTIONS(14192), 1,
      sym__varid,
    ACTIONS(14198), 1,
      sym__integer_literal,
    ACTIONS(14209), 1,
      anon_sym_LPAREN,
    ACTIONS(14212), 1,
      sym__conid,
    ACTIONS(14215), 1,
      anon_sym_LBRACK,
    ACTIONS(14218), 1,
      anon_sym_AT,
    ACTIONS(14221), 1,
      anon_sym__,
    ACTIONS(14224), 1,
      anon_sym_u27e6,
    ACTIONS(14227), 1,
      sym__splice_dollar,
    ACTIONS(14230), 1,
      sym_quasiquote_start,
    ACTIONS(14233), 1,
      sym__strict,
    ACTIONS(14236), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(3296), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14204), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14195), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14201), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14207), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65226] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14239), 1,
      anon_sym_SEMI,
    ACTIONS(14241), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17621), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65346] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14243), 1,
      anon_sym_SEMI,
    ACTIONS(14245), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16326), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65466] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14247), 1,
      anon_sym_SEMI,
    ACTIONS(14249), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17389), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65586] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14251), 1,
      anon_sym_SEMI,
    ACTIONS(14253), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16346), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65706] = 24,
    ACTIONS(14255), 1,
      sym__varid,
    ACTIONS(14261), 1,
      sym__integer_literal,
    ACTIONS(14270), 1,
      anon_sym_LPAREN,
    ACTIONS(14275), 1,
      sym__conid,
    ACTIONS(14278), 1,
      anon_sym_LBRACK,
    ACTIONS(14281), 1,
      anon_sym_SQUOTE,
    ACTIONS(14287), 1,
      anon_sym_AT,
    ACTIONS(14290), 1,
      anon_sym_EQ,
    ACTIONS(14292), 1,
      anon_sym_u27e6,
    ACTIONS(14295), 1,
      sym__splice_dollar,
    ACTIONS(14298), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14267), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14284), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14258), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14264), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14273), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3618), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [65812] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14301), 1,
      anon_sym_SEMI,
    ACTIONS(14303), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16263), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [65932] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14305), 1,
      anon_sym_SEMI,
    ACTIONS(14307), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17358), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66052] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14309), 1,
      anon_sym_SEMI,
    ACTIONS(14311), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17423), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66172] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14313), 1,
      anon_sym_SEMI,
    ACTIONS(14315), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16900), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66292] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14317), 1,
      anon_sym_SEMI,
    ACTIONS(14319), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16421), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66412] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14321), 1,
      anon_sym_SEMI,
    ACTIONS(14323), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16444), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66532] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14325), 1,
      anon_sym_SEMI,
    ACTIONS(14327), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16406), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66652] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14329), 1,
      anon_sym_SEMI,
    ACTIONS(14331), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17341), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66772] = 22,
    ACTIONS(14333), 1,
      sym__varid,
    ACTIONS(14339), 1,
      sym__integer_literal,
    ACTIONS(14348), 1,
      anon_sym_LPAREN,
    ACTIONS(14351), 1,
      sym__conid,
    ACTIONS(14354), 1,
      anon_sym_LBRACK,
    ACTIONS(14357), 1,
      anon_sym_SQUOTE,
    ACTIONS(14363), 1,
      anon_sym_u27e6,
    ACTIONS(14366), 1,
      sym__splice_dollar,
    ACTIONS(14369), 1,
      sym_quasiquote_start,
    STATE(2124), 1,
      sym__unboxed_open,
    STATE(8993), 1,
      sym_constructor,
    STATE(17296), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14345), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14360), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14336), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14342), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9519), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9437), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(13481), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3310), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [66874] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14372), 1,
      anon_sym_SEMI,
    ACTIONS(14374), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16382), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [66994] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1375), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14376), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [67110] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14378), 1,
      anon_sym_SEMI,
    ACTIONS(14380), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17352), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [67230] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14382), 1,
      anon_sym_SEMI,
    ACTIONS(14384), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17305), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [67350] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14386), 1,
      anon_sym_SEMI,
    ACTIONS(14388), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16957), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [67470] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14390), 1,
      anon_sym_SEMI,
    ACTIONS(14392), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17370), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [67590] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14394), 1,
      anon_sym_SEMI,
    ACTIONS(14396), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16742), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [67710] = 28,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11681), 1,
      anon_sym_LPAREN,
    ACTIONS(11683), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3122), 1,
      sym_type_name,
    STATE(3576), 1,
      sym_context,
    STATE(7002), 1,
      sym_constructor,
    STATE(10676), 1,
      sym__context,
    STATE(15769), 1,
      sym_constraint,
    STATE(15821), 1,
      sym_type_infix,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(17959), 1,
      sym__context_constraints,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10784), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67824] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14398), 1,
      anon_sym_SEMI,
    ACTIONS(14400), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17184), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [67944] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14402), 1,
      anon_sym_SEMI,
    ACTIONS(14404), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17504), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [68064] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14406), 1,
      anon_sym_SEMI,
    ACTIONS(14408), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16720), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [68184] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1504), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14410), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [68300] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14412), 1,
      anon_sym_SEMI,
    ACTIONS(14414), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17206), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [68420] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14416), 1,
      anon_sym_SEMI,
    ACTIONS(14418), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17478), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [68540] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1442), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14420), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [68656] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14422), 1,
      anon_sym_SEMI,
    ACTIONS(14424), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16318), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [68776] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1440), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14426), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [68892] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1577), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14428), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [69008] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14430), 1,
      anon_sym_SEMI,
    ACTIONS(14432), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16296), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [69128] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14434), 1,
      anon_sym_SEMI,
    ACTIONS(14436), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17792), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [69248] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(1438), 1,
      sym__arrow,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14438), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [69364] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14440), 1,
      anon_sym_SEMI,
    ACTIONS(14442), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16270), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [69484] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14444), 1,
      anon_sym_SEMI,
    ACTIONS(14446), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16597), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [69604] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14448), 1,
      anon_sym_SEMI,
    ACTIONS(14450), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16920), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [69724] = 31,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14452), 1,
      anon_sym_SEMI,
    ACTIONS(14454), 1,
      anon_sym_RBRACE,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17807), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [69844] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14456), 1,
      anon_sym_case,
    ACTIONS(14458), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3325), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [69959] = 25,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(12227), 1,
      anon_sym_EQ,
    ACTIONS(12231), 1,
      anon_sym_instance,
    ACTIONS(14460), 1,
      sym__varid,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(20136), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3593), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [70066] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14454), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17808), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70183] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14464), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70300] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14466), 1,
      anon_sym_case,
    ACTIONS(14468), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3288), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [70415] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14470), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70532] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14472), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70649] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14474), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70766] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14476), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70883] = 29,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(3358), 1,
      aux_sym__fun_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14478), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10416), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [70998] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14480), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [71115] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14482), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [71232] = 22,
    ACTIONS(14484), 1,
      sym__varid,
    ACTIONS(14490), 1,
      sym__integer_literal,
    ACTIONS(14499), 1,
      anon_sym_LPAREN,
    ACTIONS(14502), 1,
      sym__conid,
    ACTIONS(14505), 1,
      anon_sym_LBRACK,
    ACTIONS(14508), 1,
      anon_sym_SQUOTE,
    ACTIONS(14514), 1,
      anon_sym_u27e6,
    ACTIONS(14517), 1,
      sym__splice_dollar,
    ACTIONS(14520), 1,
      sym_quasiquote_start,
    STATE(2161), 1,
      sym__unboxed_open,
    STATE(9554), 1,
      sym_constructor,
    STATE(17486), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14496), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14511), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14487), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14493), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9759), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(13481), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(9752), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3348), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [71333] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14523), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [71450] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14525), 1,
      anon_sym_case,
    ACTIONS(14527), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3204), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [71565] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14529), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [71682] = 22,
    ACTIONS(12225), 1,
      sym__conid,
    ACTIONS(14531), 1,
      sym__varid,
    ACTIONS(14535), 1,
      sym__integer_literal,
    ACTIONS(14541), 1,
      anon_sym_LPAREN,
    ACTIONS(14543), 1,
      anon_sym_LBRACK,
    ACTIONS(14545), 1,
      anon_sym_SQUOTE,
    ACTIONS(14549), 1,
      anon_sym_u27e6,
    ACTIONS(14551), 1,
      sym__splice_dollar,
    ACTIONS(14553), 1,
      sym_quasiquote_start,
    STATE(2161), 1,
      sym__unboxed_open,
    STATE(9554), 1,
      sym_constructor,
    STATE(17486), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14539), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14547), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14533), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14537), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9759), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(13422), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(9752), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3348), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [71783] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14034), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16644), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [71900] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13874), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16594), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [72017] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14555), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [72134] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14557), 1,
      anon_sym_case,
    ACTIONS(14559), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3289), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [72249] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14561), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [72366] = 29,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(3370), 1,
      aux_sym__fun_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14563), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10416), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [72481] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14565), 1,
      anon_sym_case,
    ACTIONS(14567), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3250), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [72596] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14569), 1,
      anon_sym_case,
    ACTIONS(14571), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3229), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [72711] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13984), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16448), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [72828] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14573), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [72945] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14575), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [73062] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14577), 1,
      anon_sym_case,
    ACTIONS(14579), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3266), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [73177] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13757), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17594), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [73294] = 28,
    ACTIONS(14581), 1,
      sym__varid,
    ACTIONS(14587), 1,
      sym__integer_literal,
    ACTIONS(14596), 1,
      anon_sym_LPAREN,
    ACTIONS(14599), 1,
      sym__conid,
    ACTIONS(14602), 1,
      anon_sym_LBRACK,
    ACTIONS(14605), 1,
      anon_sym_AT,
    ACTIONS(14608), 1,
      anon_sym__,
    ACTIONS(14611), 1,
      anon_sym_u27e6,
    ACTIONS(14614), 1,
      sym__splice_dollar,
    ACTIONS(14617), 1,
      sym_quasiquote_start,
    ACTIONS(14620), 1,
      sym__strict,
    ACTIONS(14623), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10766), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(14593), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14584), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14590), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3366), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [73407] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14626), 1,
      anon_sym_case,
    ACTIONS(14628), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3209), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [73522] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14630), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [73639] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14632), 1,
      anon_sym_case,
    ACTIONS(14634), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3261), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [73754] = 29,
    ACTIONS(14636), 1,
      sym__varid,
    ACTIONS(14642), 1,
      sym__integer_literal,
    ACTIONS(14651), 1,
      anon_sym_LPAREN,
    ACTIONS(14654), 1,
      sym__conid,
    ACTIONS(14657), 1,
      anon_sym_LBRACK,
    ACTIONS(14662), 1,
      anon_sym_AT,
    ACTIONS(14665), 1,
      anon_sym__,
    ACTIONS(14668), 1,
      anon_sym_u27e6,
    ACTIONS(14671), 1,
      sym__splice_dollar,
    ACTIONS(14674), 1,
      sym_quasiquote_start,
    ACTIONS(14677), 1,
      sym__strict,
    ACTIONS(14680), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(3370), 1,
      aux_sym__fun_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14648), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14660), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14645), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10416), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [73869] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14683), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [73986] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13704), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16990), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [74103] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14126), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16269), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [74220] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14685), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [74337] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14687), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [74454] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14689), 1,
      anon_sym_case,
    ACTIONS(14691), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3328), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [74569] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14303), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16282), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [74686] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14693), 1,
      anon_sym_case,
    ACTIONS(14695), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3291), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [74801] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14697), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [74918] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14699), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75035] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14319), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16419), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75152] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14701), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75269] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14703), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75386] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14705), 1,
      anon_sym_case,
    ACTIONS(14707), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3322), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [75501] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14106), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16572), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75618] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14709), 1,
      anon_sym_case,
    ACTIONS(14711), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3312), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [75733] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13761), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16898), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75850] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14713), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [75967] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14715), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76084] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14450), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16923), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76201] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14717), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76318] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14719), 1,
      anon_sym_case,
    ACTIONS(14721), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3277), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [76433] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14723), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76550] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13902), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16889), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76667] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14408), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16718), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76784] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14725), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [76901] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14727), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77018] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14729), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77135] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14731), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77252] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14733), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77369] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14735), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77486] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13892), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17653), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77603] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14737), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77720] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14739), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [77837] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14741), 1,
      anon_sym_SEMI,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(14745), 1,
      anon_sym_RBRACE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16526), 1,
      sym_tyfam_eq,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77948] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14747), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [78065] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(14749), 1,
      anon_sym_SEMI,
    ACTIONS(14751), 1,
      anon_sym_RBRACE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16638), 1,
      sym_tyfam_eq,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78176] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14249), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17392), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [78293] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14156), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16859), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [78410] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14753), 1,
      anon_sym_case,
    ACTIONS(14755), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3331), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [78525] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14757), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [78642] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14759), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [78759] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14761), 1,
      anon_sym_case,
    ACTIONS(14763), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3213), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [78874] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14116), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16998), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [78991] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13930), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16798), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79108] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14765), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79225] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13803), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17724), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79342] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14767), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79459] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14046), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16847), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79576] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14769), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79693] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14008), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17137), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79810] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14771), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79927] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14773), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80044] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14775), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80161] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14777), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80278] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13906), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17043), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80395] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13926), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17275), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80512] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14779), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80629] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14781), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80746] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13996), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17107), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80863] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13966), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16781), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [80980] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13884), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17397), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81097] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14783), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81214] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14785), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81331] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13751), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17516), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81448] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14787), 1,
      anon_sym_case,
    ACTIONS(14789), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3202), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [81563] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14791), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81680] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14793), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81797] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14795), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [81914] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14797), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82031] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14799), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82148] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14801), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82265] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(14803), 1,
      anon_sym_SEMI,
    ACTIONS(14805), 1,
      anon_sym_RBRACE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16679), 1,
      sym_tyfam_eq,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [82376] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14807), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82493] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14809), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82610] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14811), 1,
      anon_sym_case,
    ACTIONS(14813), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3273), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82725] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13811), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17635), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82842] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13870), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17387), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [82959] = 22,
    ACTIONS(14815), 1,
      sym__varid,
    ACTIONS(14819), 1,
      sym__integer_literal,
    ACTIONS(14825), 1,
      anon_sym_LPAREN,
    ACTIONS(14827), 1,
      sym__conid,
    ACTIONS(14829), 1,
      anon_sym_LBRACK,
    ACTIONS(14831), 1,
      anon_sym_SQUOTE,
    ACTIONS(14835), 1,
      anon_sym_u27e6,
    ACTIONS(14837), 1,
      sym__splice_dollar,
    ACTIONS(14839), 1,
      sym_quasiquote_start,
    STATE(2083), 1,
      sym__unboxed_open,
    STATE(9619), 1,
      sym_constructor,
    STATE(17583), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14823), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14833), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14817), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14821), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9686), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(13422), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(9861), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3493), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [83060] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(14841), 1,
      anon_sym_SEMI,
    ACTIONS(14843), 1,
      anon_sym_RBRACE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16338), 1,
      sym_tyfam_eq,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [83171] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14845), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [83288] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14847), 1,
      anon_sym_case,
    ACTIONS(14849), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3235), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [83403] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14851), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [83520] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14853), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [83637] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13970), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17754), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [83754] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14855), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [83871] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14857), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [83988] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(14859), 1,
      anon_sym_case,
    ACTIONS(14861), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3212), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [84103] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14863), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84220] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14424), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16317), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84337] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14865), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84454] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14867), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84571] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14038), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17832), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84688] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14869), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84805] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14414), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17208), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84922] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14871), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85039] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14873), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85156] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14432), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16297), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85273] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14875), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85390] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14877), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85507] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14879), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85624] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14190), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17665), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85741] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14881), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85858] = 22,
    ACTIONS(14883), 1,
      sym__varid,
    ACTIONS(14889), 1,
      sym__integer_literal,
    ACTIONS(14898), 1,
      anon_sym_LPAREN,
    ACTIONS(14901), 1,
      sym__conid,
    ACTIONS(14904), 1,
      anon_sym_LBRACK,
    ACTIONS(14907), 1,
      anon_sym_SQUOTE,
    ACTIONS(14913), 1,
      anon_sym_u27e6,
    ACTIONS(14916), 1,
      sym__splice_dollar,
    ACTIONS(14919), 1,
      sym_quasiquote_start,
    STATE(2185), 1,
      sym__unboxed_open,
    STATE(9376), 1,
      sym_constructor,
    STATE(17253), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14895), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14910), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14886), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14892), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9826), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(13481), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(9791), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3474), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [85959] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14922), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86076] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14924), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86193] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14926), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86310] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13922), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17128), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86427] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14404), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17506), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86544] = 22,
    ACTIONS(14928), 1,
      sym__varid,
    ACTIONS(14932), 1,
      sym__integer_literal,
    ACTIONS(14938), 1,
      anon_sym_LPAREN,
    ACTIONS(14940), 1,
      sym__conid,
    ACTIONS(14942), 1,
      anon_sym_LBRACK,
    ACTIONS(14944), 1,
      anon_sym_SQUOTE,
    ACTIONS(14948), 1,
      anon_sym_u27e6,
    ACTIONS(14950), 1,
      sym__splice_dollar,
    ACTIONS(14952), 1,
      sym_quasiquote_start,
    STATE(2185), 1,
      sym__unboxed_open,
    STATE(9376), 1,
      sym_constructor,
    STATE(17253), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14936), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14946), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14930), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14934), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9826), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(13422), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(9791), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3474), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [86645] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14954), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86762] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14956), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86879] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14958), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86996] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14960), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87113] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14331), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17336), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87230] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14962), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87347] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14392), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17371), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87464] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14964), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87581] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(13962), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17527), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87698] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(14966), 1,
      anon_sym_SEMI,
    ACTIONS(14968), 1,
      anon_sym_RBRACE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17148), 1,
      sym_tyfam_eq,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [87809] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(14970), 1,
      anon_sym_SEMI,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(10487), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(20980), 1,
      sym_tyfam_eq,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [87920] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14972), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88037] = 22,
    ACTIONS(14974), 1,
      sym__varid,
    ACTIONS(14980), 1,
      sym__integer_literal,
    ACTIONS(14989), 1,
      anon_sym_LPAREN,
    ACTIONS(14992), 1,
      sym__conid,
    ACTIONS(14995), 1,
      anon_sym_LBRACK,
    ACTIONS(14998), 1,
      anon_sym_SQUOTE,
    ACTIONS(15004), 1,
      anon_sym_u27e6,
    ACTIONS(15007), 1,
      sym__splice_dollar,
    ACTIONS(15010), 1,
      sym_quasiquote_start,
    STATE(2083), 1,
      sym__unboxed_open,
    STATE(9619), 1,
      sym_constructor,
    STATE(17583), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14986), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15001), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(14977), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9686), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(13481), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(9861), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3493), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [88138] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15013), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88255] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15015), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88372] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15017), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88489] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14024), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16660), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88606] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(15019), 1,
      anon_sym_case,
    ACTIONS(15021), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3327), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [88721] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15023), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88838] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15025), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88955] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14018), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17540), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89072] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15027), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89189] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14327), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16407), 1,
      sym_nalt,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89306] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(15029), 1,
      anon_sym_case,
    ACTIONS(15031), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3280), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [89421] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15033), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89538] = 29,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    ACTIONS(15035), 1,
      anon_sym_case,
    ACTIONS(15037), 1,
      anon_sym_cases,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 16,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [89653] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14042), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(17246), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89770] = 27,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15039), 1,
      anon_sym_SEMI,
    ACTIONS(15041), 1,
      anon_sym_RBRACE,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17219), 1,
      sym_tyfam_eq,
    STATE(22142), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89881] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15043), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89998] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15045), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90115] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15047), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90232] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(14130), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(16530), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90349] = 25,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12199), 1,
      anon_sym_EQ,
    ACTIONS(12203), 1,
      anon_sym_instance,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14460), 1,
      sym__varid,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(20427), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3592), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [90456] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15049), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90573] = 30,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    ACTIONS(15051), 1,
      sym__layout_end,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90690] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15053), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17222), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [90798] = 22,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13422), 4,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3526), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [90898] = 24,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(12227), 1,
      anon_sym_EQ,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(18310), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3593), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [91002] = 24,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12199), 1,
      anon_sym_EQ,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(20511), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3592), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [91106] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15057), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91214] = 29,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(2912), 1,
      aux_sym__nalt_patterns,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(19885), 1,
      sym_nalt,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9957), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91328] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15059), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91436] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15061), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91544] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15063), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91652] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15065), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91760] = 22,
    ACTIONS(15067), 1,
      sym__varid,
    ACTIONS(15073), 1,
      sym__integer_literal,
    ACTIONS(15082), 1,
      anon_sym_LPAREN,
    ACTIONS(15085), 1,
      sym__conid,
    ACTIONS(15088), 1,
      anon_sym_LBRACK,
    ACTIONS(15091), 1,
      anon_sym_SQUOTE,
    ACTIONS(15097), 1,
      anon_sym_u27e6,
    ACTIONS(15100), 1,
      sym__splice_dollar,
    ACTIONS(15103), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15094), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15070), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15076), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13481), 4,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3526), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [91860] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15106), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91968] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15108), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92076] = 24,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_u27e6,
    ACTIONS(2045), 1,
      sym__splice_dollar,
    ACTIONS(2051), 1,
      sym_quasiquote_start,
    ACTIONS(8930), 1,
      sym__varid,
    ACTIONS(8932), 1,
      anon_sym_LPAREN,
    ACTIONS(15110), 1,
      anon_sym_RPAREN,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(7057), 1,
      sym_constructor,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2021), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(2041), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8615), 2,
      sym_type_apply,
      sym__btype,
    STATE(17943), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2518), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92180] = 24,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(12227), 1,
      anon_sym_EQ,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(19315), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3593), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [92284] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15112), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16684), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92392] = 24,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12199), 1,
      anon_sym_EQ,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(20875), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3592), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [92496] = 24,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_u27e6,
    ACTIONS(2045), 1,
      sym__splice_dollar,
    ACTIONS(2051), 1,
      sym_quasiquote_start,
    ACTIONS(8930), 1,
      sym__varid,
    ACTIONS(8932), 1,
      anon_sym_LPAREN,
    ACTIONS(15114), 1,
      anon_sym_RPAREN,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(7057), 1,
      sym_constructor,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2021), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(2041), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8615), 2,
      sym_type_apply,
      sym__btype,
    STATE(18046), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2518), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92600] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15116), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92708] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15118), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(16639), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92816] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15120), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92924] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15122), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93032] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15124), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93140] = 26,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    ACTIONS(15126), 1,
      sym__layout_end,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93248] = 22,
    ACTIONS(15128), 1,
      sym__varid,
    ACTIONS(15134), 1,
      sym__integer_literal,
    ACTIONS(15143), 1,
      anon_sym_LPAREN,
    ACTIONS(15146), 1,
      sym__conid,
    ACTIONS(15149), 1,
      anon_sym_LBRACK,
    ACTIONS(15152), 1,
      anon_sym_SQUOTE,
    ACTIONS(15158), 1,
      anon_sym_u27e6,
    ACTIONS(15161), 1,
      sym__splice_dollar,
    ACTIONS(15164), 1,
      sym_quasiquote_start,
    STATE(2097), 1,
      sym__unboxed_open,
    STATE(9746), 1,
      sym_constructor,
    STATE(17572), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15155), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13481), 4,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
    STATE(10031), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9934), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3540), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [93348] = 24,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_u27e6,
    ACTIONS(2045), 1,
      sym__splice_dollar,
    ACTIONS(2051), 1,
      sym_quasiquote_start,
    ACTIONS(8930), 1,
      sym__varid,
    ACTIONS(8932), 1,
      anon_sym_LPAREN,
    ACTIONS(15167), 1,
      anon_sym_RPAREN,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(7057), 1,
      sym_constructor,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2021), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(2041), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8615), 2,
      sym_type_apply,
      sym__btype,
    STATE(18360), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2518), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93452] = 24,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15169), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(18206), 1,
      sym__tyinst,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3560), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [93556] = 22,
    ACTIONS(15171), 1,
      sym__varid,
    ACTIONS(15175), 1,
      sym__integer_literal,
    ACTIONS(15181), 1,
      anon_sym_LPAREN,
    ACTIONS(15183), 1,
      sym__conid,
    ACTIONS(15185), 1,
      anon_sym_LBRACK,
    ACTIONS(15187), 1,
      anon_sym_SQUOTE,
    ACTIONS(15191), 1,
      anon_sym_u27e6,
    ACTIONS(15193), 1,
      sym__splice_dollar,
    ACTIONS(15195), 1,
      sym_quasiquote_start,
    STATE(2097), 1,
      sym__unboxed_open,
    STATE(9746), 1,
      sym_constructor,
    STATE(17572), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15179), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15189), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15173), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15177), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13422), 4,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
    STATE(10031), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9934), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3540), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_constraint_repeat1,
  [93656] = 23,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7017), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(6430), 1,
      sym_constructor,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8266), 2,
      sym_type_apply,
      sym__btype,
    STATE(14120), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2389), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93757] = 23,
    ACTIONS(5648), 1,
      sym__integer_literal,
    ACTIONS(5654), 1,
      anon_sym_LPAREN,
    ACTIONS(5659), 1,
      anon_sym_LBRACK,
    ACTIONS(5668), 1,
      anon_sym_u27e6,
    ACTIONS(5670), 1,
      sym__splice_dollar,
    ACTIONS(5672), 1,
      sym_quasiquote_start,
    ACTIONS(7891), 1,
      sym__conid,
    ACTIONS(7893), 1,
      anon_sym_SQUOTE,
    ACTIONS(15197), 1,
      sym__varid,
    STATE(2205), 1,
      sym__unboxed_open,
    STATE(4375), 1,
      sym_constructor,
    STATE(17101), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5652), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5664), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(7195), 2,
      sym_type_apply,
      sym__btype,
    STATE(10543), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5646), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5650), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4539), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4704), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2057), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93858] = 23,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10662), 2,
      sym_type_apply,
      sym__btype,
    STATE(16431), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93959] = 23,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11747), 1,
      anon_sym_LPAREN,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(11761), 1,
      anon_sym_u27e6,
    ACTIONS(11763), 1,
      sym__splice_dollar,
    ACTIONS(11765), 1,
      sym_quasiquote_start,
    ACTIONS(13412), 1,
      sym__varid,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(13416), 1,
      anon_sym_SQUOTE,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11757), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10355), 2,
      sym_type_apply,
      sym__btype,
    STATE(15906), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2964), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94060] = 23,
    ACTIONS(6438), 1,
      sym__varid,
    ACTIONS(6442), 1,
      sym__integer_literal,
    ACTIONS(6448), 1,
      anon_sym_LPAREN,
    ACTIONS(6453), 1,
      anon_sym_LBRACK,
    ACTIONS(6462), 1,
      anon_sym_u27e6,
    ACTIONS(6464), 1,
      sym__splice_dollar,
    ACTIONS(6466), 1,
      sym_quasiquote_start,
    ACTIONS(8351), 1,
      sym__conid,
    ACTIONS(8353), 1,
      anon_sym_SQUOTE,
    STATE(2105), 1,
      sym__unboxed_open,
    STATE(6283), 1,
      sym_constructor,
    STATE(16697), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6458), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8212), 2,
      sym_type_apply,
      sym__btype,
    STATE(10902), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6334), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6336), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2261), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94161] = 23,
    ACTIONS(5451), 1,
      anon_sym_EQ,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [94262] = 23,
    ACTIONS(5483), 1,
      anon_sym_EQ,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3549), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [94363] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(9186), 1,
      sym__varid,
    ACTIONS(14142), 1,
      anon_sym_SQUOTE,
    ACTIONS(15199), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2872), 1,
      sym_type_name,
    STATE(7510), 1,
      sym_constructor,
    STATE(14786), 1,
      sym_constraint,
    STATE(14793), 1,
      sym_type_infix,
    STATE(16491), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10850), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7791), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94468] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(11121), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    ACTIONS(15201), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2998), 1,
      sym_type_name,
    STATE(6654), 1,
      sym_constructor,
    STATE(15278), 1,
      sym_type_infix,
    STATE(16608), 1,
      sym_constraint,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10888), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94573] = 23,
    ACTIONS(5696), 1,
      sym__integer_literal,
    ACTIONS(5706), 1,
      sym__conid,
    ACTIONS(5708), 1,
      anon_sym_LBRACK,
    ACTIONS(5710), 1,
      anon_sym_SQUOTE,
    ACTIONS(5716), 1,
      anon_sym_u27e6,
    ACTIONS(5718), 1,
      sym__splice_dollar,
    ACTIONS(5720), 1,
      sym_quasiquote_start,
    ACTIONS(9416), 1,
      sym__varid,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    STATE(2142), 1,
      sym__unboxed_open,
    STATE(7530), 1,
      sym_constructor,
    STATE(17716), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5700), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5714), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8768), 2,
      sym_type_apply,
      sym__btype,
    STATE(13789), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5694), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5698), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7799), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2561), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94674] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(11185), 1,
      anon_sym_SQUOTE,
    ACTIONS(15203), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3138), 1,
      sym_type_name,
    STATE(7796), 1,
      sym_constructor,
    STATE(15751), 1,
      sym_type_infix,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(19559), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10879), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94779] = 23,
    ACTIONS(8460), 1,
      sym__integer_literal,
    ACTIONS(8470), 1,
      sym__conid,
    ACTIONS(8472), 1,
      anon_sym_LBRACK,
    ACTIONS(8474), 1,
      anon_sym_SQUOTE,
    ACTIONS(8478), 1,
      anon_sym_u27e6,
    ACTIONS(8480), 1,
      sym__splice_dollar,
    ACTIONS(8482), 1,
      sym_quasiquote_start,
    ACTIONS(10222), 1,
      sym__varid,
    ACTIONS(10224), 1,
      anon_sym_LPAREN,
    STATE(2117), 1,
      sym__unboxed_open,
    STATE(7613), 1,
      sym_constructor,
    STATE(16751), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8476), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9005), 2,
      sym_type_apply,
      sym__btype,
    STATE(13961), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8458), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8462), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8184), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8189), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2627), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94880] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(11185), 1,
      anon_sym_SQUOTE,
    ACTIONS(15203), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3138), 1,
      sym_type_name,
    STATE(7796), 1,
      sym_constructor,
    STATE(15751), 1,
      sym_type_infix,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(19698), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10879), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94985] = 23,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15205), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [95086] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    ACTIONS(14743), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3199), 1,
      sym_constructor,
    STATE(3301), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(18922), 1,
      sym_tyfam_eq,
    STATE(22969), 1,
      sym_tyfam_pat,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10812), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4278), 3,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95191] = 23,
    ACTIONS(7971), 1,
      sym__integer_literal,
    ACTIONS(7981), 1,
      sym__conid,
    ACTIONS(7983), 1,
      anon_sym_LBRACK,
    ACTIONS(7985), 1,
      anon_sym_SQUOTE,
    ACTIONS(7989), 1,
      anon_sym_u27e6,
    ACTIONS(7991), 1,
      sym__splice_dollar,
    ACTIONS(7993), 1,
      sym_quasiquote_start,
    ACTIONS(9122), 1,
      anon_sym_LPAREN,
    ACTIONS(15207), 1,
      sym__varid,
    STATE(2193), 1,
      sym__unboxed_open,
    STATE(7398), 1,
      sym_constructor,
    STATE(17581), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7975), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7987), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8762), 2,
      sym_type_apply,
      sym__btype,
    STATE(13649), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7969), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7973), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7737), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7739), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2531), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95292] = 23,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15209), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [95393] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(11459), 1,
      anon_sym_SQUOTE,
    ACTIONS(13932), 1,
      sym__varid,
    ACTIONS(15211), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3137), 1,
      sym_type_name,
    STATE(7673), 1,
      sym_constructor,
    STATE(15856), 1,
      sym_type_infix,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(17976), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10860), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8101), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95498] = 23,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(10600), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95599] = 23,
    ACTIONS(8047), 1,
      sym__varid,
    ACTIONS(8051), 1,
      sym__integer_literal,
    ACTIONS(8057), 1,
      anon_sym_LPAREN,
    ACTIONS(8062), 1,
      anon_sym_LBRACK,
    ACTIONS(8071), 1,
      anon_sym_u27e6,
    ACTIONS(8073), 1,
      sym__splice_dollar,
    ACTIONS(8075), 1,
      sym_quasiquote_start,
    ACTIONS(8335), 1,
      sym__conid,
    ACTIONS(8337), 1,
      anon_sym_SQUOTE,
    STATE(2141), 1,
      sym__unboxed_open,
    STATE(6849), 1,
      sym_constructor,
    STATE(16524), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8055), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8067), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8402), 2,
      sym_type_apply,
      sym__btype,
    STATE(11204), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8049), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8053), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7161), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2496), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95700] = 23,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7047), 1,
      anon_sym_LPAREN,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7061), 1,
      anon_sym_u27e6,
    ACTIONS(7063), 1,
      sym__splice_dollar,
    ACTIONS(7065), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(7785), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    STATE(2091), 1,
      sym__unboxed_open,
    STATE(6654), 1,
      sym_constructor,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7045), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7057), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8252), 2,
      sym_type_apply,
      sym__btype,
    STATE(14013), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2390), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95801] = 23,
    ACTIONS(5820), 1,
      sym__integer_literal,
    ACTIONS(5826), 1,
      anon_sym_LPAREN,
    ACTIONS(5831), 1,
      anon_sym_LBRACK,
    ACTIONS(5840), 1,
      anon_sym_u27e6,
    ACTIONS(5842), 1,
      sym__splice_dollar,
    ACTIONS(5844), 1,
      sym_quasiquote_start,
    ACTIONS(8111), 1,
      sym__conid,
    ACTIONS(8113), 1,
      anon_sym_SQUOTE,
    ACTIONS(15213), 1,
      sym__varid,
    STATE(2152), 1,
      sym__unboxed_open,
    STATE(4543), 1,
      sym_constructor,
    STATE(16817), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5824), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5836), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(7336), 2,
      sym_type_apply,
      sym__btype,
    STATE(10599), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5818), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5822), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4807), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4804), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2107), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95902] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(11121), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    ACTIONS(15201), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2998), 1,
      sym_type_name,
    STATE(6654), 1,
      sym_constructor,
    STATE(15278), 1,
      sym_type_infix,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(17571), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10888), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96007] = 23,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7047), 1,
      anon_sym_LPAREN,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7061), 1,
      anon_sym_u27e6,
    ACTIONS(7063), 1,
      sym__splice_dollar,
    ACTIONS(7065), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(7785), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    STATE(2091), 1,
      sym__unboxed_open,
    STATE(6654), 1,
      sym_constructor,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7045), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7057), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8252), 2,
      sym_type_apply,
      sym__btype,
    STATE(12203), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2390), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96108] = 23,
    ACTIONS(7863), 1,
      sym__integer_literal,
    ACTIONS(7873), 1,
      sym__conid,
    ACTIONS(7875), 1,
      anon_sym_LBRACK,
    ACTIONS(7877), 1,
      anon_sym_SQUOTE,
    ACTIONS(7881), 1,
      anon_sym_u27e6,
    ACTIONS(7883), 1,
      sym__splice_dollar,
    ACTIONS(7885), 1,
      sym_quasiquote_start,
    ACTIONS(7955), 1,
      sym__varid,
    ACTIONS(7957), 1,
      anon_sym_LPAREN,
    STATE(2081), 1,
      sym__unboxed_open,
    STATE(6986), 1,
      sym_constructor,
    STATE(17564), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7867), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7879), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8475), 2,
      sym_type_apply,
      sym__btype,
    STATE(11232), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7060), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7036), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2478), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96209] = 23,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7047), 1,
      anon_sym_LPAREN,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7061), 1,
      anon_sym_u27e6,
    ACTIONS(7063), 1,
      sym__splice_dollar,
    ACTIONS(7065), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(7785), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    STATE(2091), 1,
      sym__unboxed_open,
    STATE(6654), 1,
      sym_constructor,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7045), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7057), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8252), 2,
      sym_type_apply,
      sym__btype,
    STATE(14052), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2390), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96310] = 23,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(16057), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96411] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3158), 1,
      sym_type_name,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(21139), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96516] = 23,
    ACTIONS(6977), 1,
      sym__varid,
    ACTIONS(6981), 1,
      sym__integer_literal,
    ACTIONS(6987), 1,
      anon_sym_LPAREN,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(7001), 1,
      anon_sym_u27e6,
    ACTIONS(7003), 1,
      sym__splice_dollar,
    ACTIONS(7005), 1,
      sym_quasiquote_start,
    ACTIONS(8043), 1,
      sym__conid,
    ACTIONS(8045), 1,
      anon_sym_SQUOTE,
    STATE(2163), 1,
      sym__unboxed_open,
    STATE(6467), 1,
      sym_constructor,
    STATE(16822), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6985), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6997), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8297), 2,
      sym_type_apply,
      sym__btype,
    STATE(10964), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7012), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7030), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2423), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96617] = 23,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8087), 1,
      anon_sym_LPAREN,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(7002), 1,
      sym_constructor,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8442), 2,
      sym_type_apply,
      sym__btype,
    STATE(14212), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2504), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96718] = 23,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8087), 1,
      anon_sym_LPAREN,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(7002), 1,
      sym_constructor,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8442), 2,
      sym_type_apply,
      sym__btype,
    STATE(14189), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2504), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96819] = 23,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_u27e6,
    ACTIONS(2045), 1,
      sym__splice_dollar,
    ACTIONS(2051), 1,
      sym_quasiquote_start,
    ACTIONS(8930), 1,
      sym__varid,
    ACTIONS(8932), 1,
      anon_sym_LPAREN,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(7057), 1,
      sym_constructor,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2021), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(2041), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8615), 2,
      sym_type_apply,
      sym__btype,
    STATE(13461), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2518), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96920] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11683), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    ACTIONS(15215), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3122), 1,
      sym_type_name,
    STATE(7002), 1,
      sym_constructor,
    STATE(15821), 1,
      sym_type_infix,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(20066), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10784), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97025] = 23,
    ACTIONS(8684), 1,
      sym__integer_literal,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(8696), 1,
      anon_sym_LBRACK,
    ACTIONS(8698), 1,
      anon_sym_SQUOTE,
    ACTIONS(8702), 1,
      anon_sym_u27e6,
    ACTIONS(8704), 1,
      sym__splice_dollar,
    ACTIONS(8706), 1,
      sym_quasiquote_start,
    ACTIONS(9500), 1,
      sym__varid,
    ACTIONS(9502), 1,
      anon_sym_LPAREN,
    STATE(2167), 1,
      sym__unboxed_open,
    STATE(7251), 1,
      sym_constructor,
    STATE(16860), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8688), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8700), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8886), 2,
      sym_type_apply,
      sym__btype,
    STATE(13743), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8682), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8686), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7644), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7854), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2578), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97126] = 23,
    ACTIONS(7447), 1,
      sym__integer_literal,
    ACTIONS(7453), 1,
      anon_sym_LPAREN,
    ACTIONS(7458), 1,
      anon_sym_LBRACK,
    ACTIONS(7467), 1,
      anon_sym_u27e6,
    ACTIONS(7469), 1,
      sym__splice_dollar,
    ACTIONS(7471), 1,
      sym_quasiquote_start,
    ACTIONS(8622), 1,
      sym__conid,
    ACTIONS(8624), 1,
      anon_sym_SQUOTE,
    ACTIONS(15217), 1,
      sym__varid,
    STATE(2132), 1,
      sym__unboxed_open,
    STATE(6447), 1,
      sym_constructor,
    STATE(17559), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7451), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7463), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8296), 2,
      sym_type_apply,
      sym__btype,
    STATE(11003), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7445), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7449), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7015), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6966), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2404), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97227] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3158), 1,
      sym_type_name,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(17125), 1,
      sym_type_infix,
    STATE(21142), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10817), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97332] = 23,
    ACTIONS(7793), 1,
      sym__integer_literal,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(7805), 1,
      anon_sym_LBRACK,
    ACTIONS(7807), 1,
      anon_sym_SQUOTE,
    ACTIONS(7811), 1,
      anon_sym_u27e6,
    ACTIONS(7813), 1,
      sym__splice_dollar,
    ACTIONS(7815), 1,
      sym_quasiquote_start,
    ACTIONS(10136), 1,
      anon_sym_LPAREN,
    ACTIONS(13932), 1,
      sym__varid,
    STATE(2113), 1,
      sym__unboxed_open,
    STATE(7673), 1,
      sym_constructor,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7797), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7809), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8931), 2,
      sym_type_apply,
      sym__btype,
    STATE(13972), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8101), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8026), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2601), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97433] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(11683), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    ACTIONS(15215), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3122), 1,
      sym_type_name,
    STATE(7002), 1,
      sym_constructor,
    STATE(15821), 1,
      sym_type_infix,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(20159), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10784), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97538] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(9500), 1,
      sym__varid,
    ACTIONS(14186), 1,
      anon_sym_SQUOTE,
    ACTIONS(15219), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2922), 1,
      sym_type_name,
    STATE(7251), 1,
      sym_constructor,
    STATE(14713), 1,
      sym_type_infix,
    STATE(14921), 1,
      sym_constraint,
    STATE(16860), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10899), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7644), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97643] = 23,
    ACTIONS(8131), 1,
      sym__integer_literal,
    ACTIONS(8141), 1,
      sym__conid,
    ACTIONS(8143), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_SQUOTE,
    ACTIONS(8149), 1,
      anon_sym_u27e6,
    ACTIONS(8151), 1,
      sym__splice_dollar,
    ACTIONS(8153), 1,
      sym_quasiquote_start,
    ACTIONS(9174), 1,
      sym__varid,
    ACTIONS(9176), 1,
      anon_sym_LPAREN,
    STATE(2067), 1,
      sym__unboxed_open,
    STATE(7344), 1,
      sym_constructor,
    STATE(17334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8135), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8147), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8820), 2,
      sym_type_apply,
      sym__btype,
    STATE(13732), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8129), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8133), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7741), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7649), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2542), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97744] = 23,
    ACTIONS(8219), 1,
      sym__integer_literal,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(8231), 1,
      anon_sym_LBRACK,
    ACTIONS(8233), 1,
      anon_sym_SQUOTE,
    ACTIONS(8237), 1,
      anon_sym_u27e6,
    ACTIONS(8239), 1,
      sym__splice_dollar,
    ACTIONS(8241), 1,
      sym_quasiquote_start,
    ACTIONS(10066), 1,
      sym__varid,
    ACTIONS(10068), 1,
      anon_sym_LPAREN,
    STATE(2195), 1,
      sym__unboxed_open,
    STATE(7746), 1,
      sym_constructor,
    STATE(16892), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8223), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8235), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8991), 2,
      sym_type_apply,
      sym__btype,
    STATE(13867), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8217), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8221), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7972), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2633), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97845] = 23,
    ACTIONS(6947), 1,
      sym__varid,
    ACTIONS(6951), 1,
      sym__integer_literal,
    ACTIONS(6957), 1,
      anon_sym_LPAREN,
    ACTIONS(6962), 1,
      anon_sym_LBRACK,
    ACTIONS(6971), 1,
      anon_sym_u27e6,
    ACTIONS(6973), 1,
      sym__splice_dollar,
    ACTIONS(6975), 1,
      sym_quasiquote_start,
    ACTIONS(8676), 1,
      sym__conid,
    ACTIONS(8678), 1,
      anon_sym_SQUOTE,
    STATE(2166), 1,
      sym__unboxed_open,
    STATE(6515), 1,
      sym_constructor,
    STATE(17700), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6955), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6967), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8298), 2,
      sym_type_apply,
      sym__btype,
    STATE(11034), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6949), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6953), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6843), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6848), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2401), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97946] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(11459), 1,
      anon_sym_SQUOTE,
    ACTIONS(13932), 1,
      sym__varid,
    ACTIONS(15211), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3137), 1,
      sym_type_name,
    STATE(7673), 1,
      sym_constructor,
    STATE(15856), 1,
      sym_type_infix,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(18290), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10860), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8101), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98051] = 23,
    ACTIONS(6350), 1,
      sym__integer_literal,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    ACTIONS(6361), 1,
      anon_sym_LBRACK,
    ACTIONS(6370), 1,
      anon_sym_u27e6,
    ACTIONS(6372), 1,
      sym__splice_dollar,
    ACTIONS(6374), 1,
      sym_quasiquote_start,
    ACTIONS(8293), 1,
      sym__conid,
    ACTIONS(8295), 1,
      anon_sym_SQUOTE,
    ACTIONS(15221), 1,
      sym__varid,
    STATE(2206), 1,
      sym__unboxed_open,
    STATE(6021), 1,
      sym_constructor,
    STATE(17709), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6354), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6366), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8214), 2,
      sym_type_apply,
      sym__btype,
    STATE(10839), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6348), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6352), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6534), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6530), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2234), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98152] = 23,
    ACTIONS(7419), 1,
      sym__integer_literal,
    ACTIONS(7429), 1,
      sym__conid,
    ACTIONS(7431), 1,
      anon_sym_LBRACK,
    ACTIONS(7433), 1,
      anon_sym_SQUOTE,
    ACTIONS(7437), 1,
      anon_sym_u27e6,
    ACTIONS(7439), 1,
      sym__splice_dollar,
    ACTIONS(7441), 1,
      sym_quasiquote_start,
    ACTIONS(10146), 1,
      sym__varid,
    ACTIONS(10148), 1,
      anon_sym_LPAREN,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7599), 1,
      sym_constructor,
    STATE(16252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7423), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7435), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8941), 2,
      sym_type_apply,
      sym__btype,
    STATE(13918), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7417), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7421), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8078), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8073), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2604), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98253] = 23,
    ACTIONS(6396), 1,
      sym__varid,
    ACTIONS(6400), 1,
      sym__integer_literal,
    ACTIONS(6406), 1,
      anon_sym_LPAREN,
    ACTIONS(6411), 1,
      anon_sym_LBRACK,
    ACTIONS(6420), 1,
      anon_sym_u27e6,
    ACTIONS(6422), 1,
      sym__splice_dollar,
    ACTIONS(6424), 1,
      sym_quasiquote_start,
    ACTIONS(8828), 1,
      sym__conid,
    ACTIONS(8830), 1,
      anon_sym_SQUOTE,
    STATE(2104), 1,
      sym__unboxed_open,
    STATE(6258), 1,
      sym_constructor,
    STATE(16681), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6404), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6416), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8232), 2,
      sym_type_apply,
      sym__btype,
    STATE(10849), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6398), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6402), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6369), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6371), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2256), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98354] = 23,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11867), 1,
      anon_sym_LPAREN,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(11881), 1,
      anon_sym_u27e6,
    ACTIONS(11883), 1,
      sym__splice_dollar,
    ACTIONS(11885), 1,
      sym_quasiquote_start,
    ACTIONS(13519), 1,
      sym__varid,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(13523), 1,
      anon_sym_SQUOTE,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11877), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10301), 2,
      sym_type_apply,
      sym__btype,
    STATE(15839), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3089), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98455] = 23,
    ACTIONS(5496), 1,
      anon_sym_EQ,
    ACTIONS(15223), 1,
      sym__varid,
    ACTIONS(15229), 1,
      sym__integer_literal,
    ACTIONS(15238), 1,
      anon_sym_LPAREN,
    ACTIONS(15241), 1,
      sym__conid,
    ACTIONS(15244), 1,
      anon_sym_LBRACK,
    ACTIONS(15247), 1,
      anon_sym_SQUOTE,
    ACTIONS(15253), 1,
      anon_sym_AT,
    ACTIONS(15256), 1,
      anon_sym_u27e6,
    ACTIONS(15259), 1,
      sym__splice_dollar,
    ACTIONS(15262), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15235), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15250), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15226), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15232), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [98556] = 23,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15265), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [98657] = 23,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15267), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [98758] = 23,
    ACTIONS(6118), 1,
      sym__varid,
    ACTIONS(6122), 1,
      sym__integer_literal,
    ACTIONS(6128), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym_LBRACK,
    ACTIONS(6142), 1,
      anon_sym_u27e6,
    ACTIONS(6144), 1,
      sym__splice_dollar,
    ACTIONS(6146), 1,
      sym_quasiquote_start,
    ACTIONS(8121), 1,
      sym__conid,
    ACTIONS(8123), 1,
      anon_sym_SQUOTE,
    STATE(2208), 1,
      sym__unboxed_open,
    STATE(5781), 1,
      sym_constructor,
    STATE(17028), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6126), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6138), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8093), 2,
      sym_type_apply,
      sym__btype,
    STATE(10716), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6120), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6124), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5949), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5908), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2217), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98859] = 23,
    ACTIONS(7925), 1,
      sym__varid,
    ACTIONS(7929), 1,
      sym__integer_literal,
    ACTIONS(7935), 1,
      anon_sym_LPAREN,
    ACTIONS(7940), 1,
      anon_sym_LBRACK,
    ACTIONS(7949), 1,
      anon_sym_u27e6,
    ACTIONS(7951), 1,
      sym__splice_dollar,
    ACTIONS(7953), 1,
      sym_quasiquote_start,
    ACTIONS(8211), 1,
      sym__conid,
    ACTIONS(8213), 1,
      anon_sym_SQUOTE,
    STATE(2171), 1,
      sym__unboxed_open,
    STATE(6696), 1,
      sym_constructor,
    STATE(16943), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7933), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7945), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8422), 2,
      sym_type_apply,
      sym__btype,
    STATE(11362), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7927), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7931), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7229), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7197), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2474), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98960] = 23,
    ACTIONS(6550), 1,
      sym__varid,
    ACTIONS(6554), 1,
      sym__integer_literal,
    ACTIONS(6560), 1,
      anon_sym_LPAREN,
    ACTIONS(6565), 1,
      anon_sym_LBRACK,
    ACTIONS(6574), 1,
      anon_sym_u27e6,
    ACTIONS(6576), 1,
      sym__splice_dollar,
    ACTIONS(6578), 1,
      sym_quasiquote_start,
    ACTIONS(7921), 1,
      sym__conid,
    ACTIONS(7923), 1,
      anon_sym_SQUOTE,
    STATE(2090), 1,
      sym__unboxed_open,
    STATE(6272), 1,
      sym_constructor,
    STATE(17534), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6558), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8194), 2,
      sym_type_apply,
      sym__btype,
    STATE(10898), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6552), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6556), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6385), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6380), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2297), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99061] = 23,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7017), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(6430), 1,
      sym_constructor,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8266), 2,
      sym_type_apply,
      sym__btype,
    STATE(13931), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2389), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99162] = 23,
    ACTIONS(7337), 1,
      sym__varid,
    ACTIONS(7341), 1,
      sym__integer_literal,
    ACTIONS(7347), 1,
      anon_sym_LPAREN,
    ACTIONS(7352), 1,
      anon_sym_LBRACK,
    ACTIONS(7361), 1,
      anon_sym_u27e6,
    ACTIONS(7363), 1,
      sym__splice_dollar,
    ACTIONS(7365), 1,
      sym_quasiquote_start,
    ACTIONS(7901), 1,
      sym__conid,
    ACTIONS(7903), 1,
      anon_sym_SQUOTE,
    STATE(2062), 1,
      sym__unboxed_open,
    STATE(6304), 1,
      sym_constructor,
    STATE(17711), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7345), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7357), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8304), 2,
      sym_type_apply,
      sym__btype,
    STATE(10918), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7339), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7343), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6770), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6773), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2417), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99263] = 23,
    ACTIONS(6210), 1,
      sym__integer_literal,
    ACTIONS(6220), 1,
      sym__conid,
    ACTIONS(6222), 1,
      anon_sym_LBRACK,
    ACTIONS(6224), 1,
      anon_sym_SQUOTE,
    ACTIONS(6230), 1,
      anon_sym_u27e6,
    ACTIONS(6232), 1,
      sym__splice_dollar,
    ACTIONS(6234), 1,
      sym_quasiquote_start,
    ACTIONS(10507), 1,
      sym__varid,
    ACTIONS(10509), 1,
      anon_sym_LPAREN,
    STATE(2202), 1,
      sym__unboxed_open,
    STATE(7638), 1,
      sym_constructor,
    STATE(17453), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6214), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9045), 2,
      sym_type_apply,
      sym__btype,
    STATE(13928), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6208), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6212), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8165), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8053), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2705), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99364] = 23,
    ACTIONS(8792), 1,
      sym__integer_literal,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(8804), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_SQUOTE,
    ACTIONS(8810), 1,
      anon_sym_u27e6,
    ACTIONS(8812), 1,
      sym__splice_dollar,
    ACTIONS(8814), 1,
      sym_quasiquote_start,
    ACTIONS(9186), 1,
      sym__varid,
    ACTIONS(9188), 1,
      anon_sym_LPAREN,
    STATE(2131), 1,
      sym__unboxed_open,
    STATE(7510), 1,
      sym_constructor,
    STATE(16491), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8796), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8808), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8832), 2,
      sym_type_apply,
      sym__btype,
    STATE(13754), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8790), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8794), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7791), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7753), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2544), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99465] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(11057), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    ACTIONS(15269), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2992), 1,
      sym_type_name,
    STATE(6430), 1,
      sym_constructor,
    STATE(15027), 1,
      sym_type_infix,
    STATE(16576), 1,
      sym_constraint,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10896), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99570] = 23,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8087), 1,
      anon_sym_LPAREN,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(7002), 1,
      sym_constructor,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8442), 2,
      sym_type_apply,
      sym__btype,
    STATE(12797), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2504), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99671] = 23,
    ACTIONS(8552), 1,
      sym__integer_literal,
    ACTIONS(8562), 1,
      sym__conid,
    ACTIONS(8564), 1,
      anon_sym_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_SQUOTE,
    ACTIONS(8570), 1,
      anon_sym_u27e6,
    ACTIONS(8572), 1,
      sym__splice_dollar,
    ACTIONS(8574), 1,
      sym_quasiquote_start,
    ACTIONS(10078), 1,
      anon_sym_LPAREN,
    ACTIONS(15271), 1,
      sym__varid,
    STATE(2112), 1,
      sym__unboxed_open,
    STATE(7629), 1,
      sym_constructor,
    STATE(17064), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8556), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8568), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9077), 2,
      sym_type_apply,
      sym__btype,
    STATE(13934), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8550), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8554), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8169), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7922), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2589), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99772] = 23,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(6485), 2,
      sym_type_apply,
      sym__btype,
    STATE(15788), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99873] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(10066), 1,
      sym__varid,
    ACTIONS(13795), 1,
      anon_sym_SQUOTE,
    ACTIONS(15273), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(3036), 1,
      sym_type_name,
    STATE(7746), 1,
      sym_constructor,
    STATE(15269), 1,
      sym_type_infix,
    STATE(15389), 1,
      sym_constraint,
    STATE(16892), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10910), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7972), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99978] = 23,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15275), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [100079] = 23,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7017), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(6430), 1,
      sym_constructor,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8266), 2,
      sym_type_apply,
      sym__btype,
    STATE(12141), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2389), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100180] = 23,
    ACTIONS(7067), 1,
      sym__varid,
    ACTIONS(7071), 1,
      sym__integer_literal,
    ACTIONS(7077), 1,
      anon_sym_LPAREN,
    ACTIONS(7082), 1,
      anon_sym_LBRACK,
    ACTIONS(7091), 1,
      anon_sym_u27e6,
    ACTIONS(7093), 1,
      sym__splice_dollar,
    ACTIONS(7095), 1,
      sym_quasiquote_start,
    ACTIONS(8756), 1,
      sym__conid,
    ACTIONS(8758), 1,
      anon_sym_SQUOTE,
    STATE(2073), 1,
      sym__unboxed_open,
    STATE(6342), 1,
      sym_constructor,
    STATE(17509), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7075), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7087), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8246), 2,
      sym_type_apply,
      sym__btype,
    STATE(11093), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7069), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7073), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6844), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6704), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2391), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100281] = 25,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(11057), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    ACTIONS(15269), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(2992), 1,
      sym_type_name,
    STATE(6430), 1,
      sym_constructor,
    STATE(15027), 1,
      sym_type_infix,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(16790), 1,
      sym_constraint,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(10896), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2046), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100386] = 23,
    ACTIONS(8630), 1,
      sym__integer_literal,
    ACTIONS(8640), 1,
      sym__conid,
    ACTIONS(8642), 1,
      anon_sym_LBRACK,
    ACTIONS(8644), 1,
      anon_sym_SQUOTE,
    ACTIONS(8648), 1,
      anon_sym_u27e6,
    ACTIONS(8650), 1,
      sym__splice_dollar,
    ACTIONS(8652), 1,
      sym_quasiquote_start,
    ACTIONS(10158), 1,
      anon_sym_LPAREN,
    ACTIONS(15277), 1,
      sym__varid,
    STATE(2086), 1,
      sym__unboxed_open,
    STATE(7882), 1,
      sym_constructor,
    STATE(17086), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8634), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8646), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9336), 2,
      sym_type_apply,
      sym__btype,
    STATE(13887), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8632), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7902), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8034), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2609), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100487] = 23,
    ACTIONS(8307), 1,
      sym__integer_literal,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_LBRACK,
    ACTIONS(8319), 1,
      anon_sym_SQUOTE,
    ACTIONS(8323), 1,
      anon_sym_u27e6,
    ACTIONS(8325), 1,
      sym__splice_dollar,
    ACTIONS(8327), 1,
      sym_quasiquote_start,
    ACTIONS(9112), 1,
      anon_sym_LPAREN,
    ACTIONS(13406), 1,
      sym__varid,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(7250), 1,
      sym_constructor,
    STATE(16496), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8321), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8875), 2,
      sym_type_apply,
      sym__btype,
    STATE(13573), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7626), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7589), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2547), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100588] = 23,
    ACTIONS(8488), 1,
      sym__integer_literal,
    ACTIONS(8498), 1,
      sym__conid,
    ACTIONS(8500), 1,
      anon_sym_LBRACK,
    ACTIONS(8502), 1,
      anon_sym_SQUOTE,
    ACTIONS(8506), 1,
      anon_sym_u27e6,
    ACTIONS(8508), 1,
      sym__splice_dollar,
    ACTIONS(8510), 1,
      sym_quasiquote_start,
    ACTIONS(9676), 1,
      anon_sym_LPAREN,
    ACTIONS(15279), 1,
      sym__varid,
    STATE(2187), 1,
      sym__unboxed_open,
    STATE(7360), 1,
      sym_constructor,
    STATE(17439), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8492), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8504), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8872), 2,
      sym_type_apply,
      sym__btype,
    STATE(13630), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8486), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8490), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7844), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2557), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100689] = 23,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_u27e6,
    ACTIONS(2045), 1,
      sym__splice_dollar,
    ACTIONS(2051), 1,
      sym_quasiquote_start,
    ACTIONS(8930), 1,
      sym__varid,
    ACTIONS(8932), 1,
      anon_sym_LPAREN,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(7057), 1,
      sym_constructor,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2021), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(2041), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8615), 2,
      sym_type_apply,
      sym__btype,
    STATE(20445), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2518), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100790] = 23,
    ACTIONS(8524), 1,
      sym__integer_literal,
    ACTIONS(8534), 1,
      sym__conid,
    ACTIONS(8536), 1,
      anon_sym_LBRACK,
    ACTIONS(8538), 1,
      anon_sym_SQUOTE,
    ACTIONS(8542), 1,
      anon_sym_u27e6,
    ACTIONS(8544), 1,
      sym__splice_dollar,
    ACTIONS(8546), 1,
      sym_quasiquote_start,
    ACTIONS(10664), 1,
      anon_sym_LPAREN,
    ACTIONS(15281), 1,
      sym__varid,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(8160), 1,
      sym_constructor,
    STATE(16417), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8528), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8540), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9496), 2,
      sym_type_apply,
      sym__btype,
    STATE(14131), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8522), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8526), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8192), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2772), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100891] = 23,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(9154), 2,
      sym_type_apply,
      sym__btype,
    STATE(13946), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2733), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100992] = 23,
    ACTIONS(8255), 1,
      sym__integer_literal,
    ACTIONS(8265), 1,
      sym__conid,
    ACTIONS(8267), 1,
      anon_sym_LBRACK,
    ACTIONS(8269), 1,
      anon_sym_SQUOTE,
    ACTIONS(8273), 1,
      anon_sym_u27e6,
    ACTIONS(8275), 1,
      sym__splice_dollar,
    ACTIONS(8277), 1,
      sym_quasiquote_start,
    ACTIONS(8998), 1,
      sym__varid,
    ACTIONS(9000), 1,
      anon_sym_LPAREN,
    STATE(2069), 1,
      sym__unboxed_open,
    STATE(7041), 1,
      sym_constructor,
    STATE(17310), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8259), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8271), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8603), 2,
      sym_type_apply,
      sym__btype,
    STATE(11761), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8253), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8257), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7296), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7271), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2528), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101093] = 23,
    ACTIONS(8404), 1,
      sym__integer_literal,
    ACTIONS(8414), 1,
      sym__conid,
    ACTIONS(8416), 1,
      anon_sym_LBRACK,
    ACTIONS(8418), 1,
      anon_sym_SQUOTE,
    ACTIONS(8422), 1,
      anon_sym_u27e6,
    ACTIONS(8424), 1,
      sym__splice_dollar,
    ACTIONS(8426), 1,
      sym_quasiquote_start,
    ACTIONS(8908), 1,
      sym__varid,
    ACTIONS(8910), 1,
      anon_sym_LPAREN,
    STATE(2074), 1,
      sym__unboxed_open,
    STATE(7035), 1,
      sym_constructor,
    STATE(17287), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8408), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8420), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8591), 2,
      sym_type_apply,
      sym__btype,
    STATE(11889), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8402), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8406), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7282), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7259), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2523), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101194] = 23,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12197), 1,
      anon_sym_AT,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    ACTIONS(15283), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3591), 16,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_type_invisible,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [101295] = 23,
    ACTIONS(6270), 1,
      sym__integer_literal,
    ACTIONS(6276), 1,
      anon_sym_LPAREN,
    ACTIONS(6281), 1,
      anon_sym_LBRACK,
    ACTIONS(6290), 1,
      anon_sym_u27e6,
    ACTIONS(6292), 1,
      sym__splice_dollar,
    ACTIONS(6294), 1,
      sym_quasiquote_start,
    ACTIONS(8201), 1,
      sym__conid,
    ACTIONS(8203), 1,
      anon_sym_SQUOTE,
    ACTIONS(15285), 1,
      sym__varid,
    STATE(2188), 1,
      sym__unboxed_open,
    STATE(5313), 1,
      sym_constructor,
    STATE(17800), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6274), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6286), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8044), 2,
      sym_type_apply,
      sym__btype,
    STATE(10735), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6268), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6272), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6297), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6275), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2225), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101396] = 23,
    ACTIONS(6805), 1,
      sym__integer_literal,
    ACTIONS(6811), 1,
      anon_sym_LPAREN,
    ACTIONS(6816), 1,
      anon_sym_LBRACK,
    ACTIONS(6825), 1,
      anon_sym_u27e6,
    ACTIONS(6827), 1,
      sym__splice_dollar,
    ACTIONS(6829), 1,
      sym_quasiquote_start,
    ACTIONS(8516), 1,
      sym__conid,
    ACTIONS(8518), 1,
      anon_sym_SQUOTE,
    ACTIONS(15287), 1,
      sym__varid,
    STATE(2076), 1,
      sym__unboxed_open,
    STATE(6256), 1,
      sym_constructor,
    STATE(17742), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6809), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6821), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8215), 2,
      sym_type_apply,
      sym__btype,
    STATE(10867), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6803), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6807), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6375), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6376), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2356), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101497] = 23,
    ACTIONS(8764), 1,
      sym__integer_literal,
    ACTIONS(8774), 1,
      sym__conid,
    ACTIONS(8776), 1,
      anon_sym_LBRACK,
    ACTIONS(8778), 1,
      anon_sym_SQUOTE,
    ACTIONS(8782), 1,
      anon_sym_u27e6,
    ACTIONS(8784), 1,
      sym__splice_dollar,
    ACTIONS(8786), 1,
      sym_quasiquote_start,
    ACTIONS(8840), 1,
      sym__varid,
    ACTIONS(8842), 1,
      anon_sym_LPAREN,
    STATE(2154), 1,
      sym__unboxed_open,
    STATE(6951), 1,
      sym_constructor,
    STATE(17346), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8768), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8483), 2,
      sym_type_apply,
      sym__btype,
    STATE(11304), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8766), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7095), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7033), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2507), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101598] = 23,
    ACTIONS(6598), 1,
      sym__varid,
    ACTIONS(6602), 1,
      sym__integer_literal,
    ACTIONS(6608), 1,
      anon_sym_LPAREN,
    ACTIONS(6613), 1,
      anon_sym_LBRACK,
    ACTIONS(6622), 1,
      anon_sym_u27e6,
    ACTIONS(6624), 1,
      sym__splice_dollar,
    ACTIONS(6626), 1,
      sym_quasiquote_start,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_SQUOTE,
    STATE(2197), 1,
      sym__unboxed_open,
    STATE(5965), 1,
      sym_constructor,
    STATE(17828), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6606), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6618), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8199), 2,
      sym_type_apply,
      sym__btype,
    STATE(10788), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6600), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6604), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6545), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6546), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2307), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101699] = 23,
    ACTIONS(8432), 1,
      sym__integer_literal,
    ACTIONS(8442), 1,
      sym__conid,
    ACTIONS(8444), 1,
      anon_sym_LBRACK,
    ACTIONS(8446), 1,
      anon_sym_SQUOTE,
    ACTIONS(8450), 1,
      anon_sym_u27e6,
    ACTIONS(8452), 1,
      sym__splice_dollar,
    ACTIONS(8454), 1,
      sym_quasiquote_start,
    ACTIONS(8920), 1,
      anon_sym_LPAREN,
    ACTIONS(15289), 1,
      sym__varid,
    STATE(2102), 1,
      sym__unboxed_open,
    STATE(7203), 1,
      sym_constructor,
    STATE(17798), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8436), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8448), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8678), 2,
      sym_type_apply,
      sym__btype,
    STATE(13352), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(8430), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8434), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7424), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2516), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101800] = 23,
    ACTIONS(7187), 1,
      sym__varid,
    ACTIONS(7191), 1,
      sym__integer_literal,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7202), 1,
      anon_sym_LBRACK,
    ACTIONS(7211), 1,
      anon_sym_u27e6,
    ACTIONS(7213), 1,
      sym__splice_dollar,
    ACTIONS(7215), 1,
      sym_quasiquote_start,
    ACTIONS(8660), 1,
      sym__conid,
    ACTIONS(8662), 1,
      anon_sym_SQUOTE,
    STATE(2094), 1,
      sym__unboxed_open,
    STATE(6426), 1,
      sym_constructor,
    STATE(17409), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7195), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7207), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8269), 2,
      sym_type_apply,
      sym__btype,
    STATE(10936), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7189), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7193), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6876), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6961), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2395), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101901] = 23,
    ACTIONS(7307), 1,
      sym__varid,
    ACTIONS(7311), 1,
      sym__integer_literal,
    ACTIONS(7317), 1,
      anon_sym_LPAREN,
    ACTIONS(7322), 1,
      anon_sym_LBRACK,
    ACTIONS(7331), 1,
      anon_sym_u27e6,
    ACTIONS(7333), 1,
      sym__splice_dollar,
    ACTIONS(7335), 1,
      sym_quasiquote_start,
    ACTIONS(7911), 1,
      sym__conid,
    ACTIONS(7913), 1,
      anon_sym_SQUOTE,
    STATE(2168), 1,
      sym__unboxed_open,
    STATE(6439), 1,
      sym_constructor,
    STATE(17378), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7315), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7327), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(8249), 2,
      sym_type_apply,
      sym__btype,
    STATE(11112), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7309), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7313), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6930), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7007), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2405), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [102002] = 27,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    ACTIONS(15291), 1,
      anon_sym_LPAREN,
    ACTIONS(15293), 1,
      sym__conid,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(14355), 1,
      sym__pat_constructor,
    STATE(14451), 1,
      sym_constructor,
    STATE(14582), 1,
      sym__qcon,
    STATE(14620), 1,
      sym_qualified_constructor,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(17058), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15094), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102110] = 27,
    ACTIONS(11483), 1,
      sym__varid,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(11493), 1,
      anon_sym_LPAREN,
    ACTIONS(11498), 1,
      anon_sym_LBRACK,
    ACTIONS(11502), 1,
      anon_sym_AT,
    ACTIONS(11504), 1,
      anon_sym__,
    ACTIONS(11506), 1,
      anon_sym_u27e6,
    ACTIONS(11508), 1,
      sym__splice_dollar,
    ACTIONS(11510), 1,
      sym_quasiquote_start,
    ACTIONS(11512), 1,
      sym__strict,
    ACTIONS(11514), 1,
      sym__lazy,
    ACTIONS(13304), 1,
      sym__conid,
    STATE(418), 1,
      sym__unboxed_open,
    STATE(8490), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(8885), 1,
      sym_variable,
    STATE(9263), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11491), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11485), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9131), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9292), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102218] = 27,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    ACTIONS(15291), 1,
      anon_sym_LPAREN,
    ACTIONS(15293), 1,
      sym__conid,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(14355), 1,
      sym__pat_constructor,
    STATE(14451), 1,
      sym_constructor,
    STATE(14582), 1,
      sym__qcon,
    STATE(14620), 1,
      sym_qualified_constructor,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(17058), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15104), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102326] = 27,
    ACTIONS(35), 1,
      anon_sym__,
    ACTIONS(77), 1,
      sym__strict,
    ACTIONS(79), 1,
      sym__lazy,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(5337), 1,
      anon_sym_AT,
    ACTIONS(15295), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(10340), 1,
      sym_constructor,
    STATE(10549), 1,
      sym_qualified_constructor,
    STATE(13397), 1,
      sym__pat_constructor,
    STATE(13809), 1,
      sym__qcon,
    STATE(13817), 1,
      sym_variable,
    STATE(14028), 1,
      sym_literal,
    STATE(17493), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5327), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4457), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10563), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14040), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102434] = 27,
    ACTIONS(10388), 1,
      sym__varid,
    ACTIONS(10394), 1,
      sym__integer_literal,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    ACTIONS(10405), 1,
      anon_sym_LBRACK,
    ACTIONS(10409), 1,
      anon_sym_AT,
    ACTIONS(10411), 1,
      anon_sym__,
    ACTIONS(10413), 1,
      anon_sym_u27e6,
    ACTIONS(10415), 1,
      sym__splice_dollar,
    ACTIONS(10417), 1,
      sym_quasiquote_start,
    ACTIONS(10419), 1,
      sym__strict,
    ACTIONS(10421), 1,
      sym__lazy,
    ACTIONS(11085), 1,
      sym__conid,
    STATE(302), 1,
      sym__unboxed_open,
    STATE(8191), 1,
      sym_constructor,
    STATE(8235), 1,
      sym__pat_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8271), 1,
      sym_variable,
    STATE(8306), 1,
      sym__qcon,
    STATE(8398), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10398), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10392), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8373), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8369), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102542] = 27,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15297), 1,
      anon_sym_LPAREN,
    ACTIONS(15299), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(12879), 1,
      sym_constructor,
    STATE(12917), 1,
      sym__pat_constructor,
    STATE(13481), 1,
      sym__qcon,
    STATE(13521), 1,
      sym_qualified_constructor,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13646), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102650] = 27,
    ACTIONS(12334), 1,
      sym__varid,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(12344), 1,
      anon_sym_LPAREN,
    ACTIONS(12349), 1,
      anon_sym_LBRACK,
    ACTIONS(12353), 1,
      anon_sym_AT,
    ACTIONS(12355), 1,
      anon_sym__,
    ACTIONS(12357), 1,
      anon_sym_u27e6,
    ACTIONS(12359), 1,
      sym__splice_dollar,
    ACTIONS(12361), 1,
      sym_quasiquote_start,
    ACTIONS(12363), 1,
      sym__strict,
    ACTIONS(12365), 1,
      sym__lazy,
    ACTIONS(13096), 1,
      sym__conid,
    STATE(357), 1,
      sym__unboxed_open,
    STATE(8734), 1,
      sym_constructor,
    STATE(8825), 1,
      sym__pat_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(9152), 1,
      sym_variable,
    STATE(9642), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12342), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12336), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9565), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9624), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102758] = 27,
    ACTIONS(12334), 1,
      sym__varid,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(12344), 1,
      anon_sym_LPAREN,
    ACTIONS(12349), 1,
      anon_sym_LBRACK,
    ACTIONS(12353), 1,
      anon_sym_AT,
    ACTIONS(12355), 1,
      anon_sym__,
    ACTIONS(12357), 1,
      anon_sym_u27e6,
    ACTIONS(12359), 1,
      sym__splice_dollar,
    ACTIONS(12361), 1,
      sym_quasiquote_start,
    ACTIONS(12363), 1,
      sym__strict,
    ACTIONS(12365), 1,
      sym__lazy,
    ACTIONS(13096), 1,
      sym__conid,
    STATE(357), 1,
      sym__unboxed_open,
    STATE(8734), 1,
      sym_constructor,
    STATE(8825), 1,
      sym__pat_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(9152), 1,
      sym_variable,
    STATE(9642), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12342), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12336), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9565), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9623), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102866] = 27,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(11342), 1,
      sym__varid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(11352), 1,
      anon_sym_LPAREN,
    ACTIONS(11357), 1,
      anon_sym_LBRACK,
    ACTIONS(11361), 1,
      anon_sym_AT,
    ACTIONS(11363), 1,
      anon_sym__,
    ACTIONS(11365), 1,
      anon_sym_u27e6,
    ACTIONS(11367), 1,
      sym__splice_dollar,
    ACTIONS(11369), 1,
      sym_quasiquote_start,
    ACTIONS(11371), 1,
      sym__strict,
    ACTIONS(11373), 1,
      sym__lazy,
    STATE(311), 1,
      sym__unboxed_open,
    STATE(8555), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(8868), 1,
      sym__qcon,
    STATE(9208), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11350), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11344), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9046), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9327), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102974] = 27,
    ACTIONS(269), 1,
      anon_sym__,
    ACTIONS(293), 1,
      sym__strict,
    ACTIONS(295), 1,
      sym__lazy,
    ACTIONS(13191), 1,
      sym__varid,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13207), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    ACTIONS(15301), 1,
      anon_sym_LPAREN,
    ACTIONS(15303), 1,
      sym__conid,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(13275), 1,
      sym_constructor,
    STATE(13370), 1,
      sym__pat_constructor,
    STATE(13601), 1,
      sym_qualified_constructor,
    STATE(13740), 1,
      sym__qcon,
    STATE(13744), 1,
      sym_variable,
    STATE(14076), 1,
      sym_literal,
    STATE(16796), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14080), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103082] = 27,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    ACTIONS(15305), 1,
      anon_sym_LPAREN,
    ACTIONS(15307), 1,
      sym__conid,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(14185), 1,
      sym_constructor,
    STATE(14279), 1,
      sym__pat_constructor,
    STATE(14585), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(14845), 1,
      sym__qcon,
    STATE(15329), 1,
      sym_literal,
    STATE(17328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15483), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103190] = 27,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15297), 1,
      anon_sym_LPAREN,
    ACTIONS(15299), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(12879), 1,
      sym_constructor,
    STATE(12917), 1,
      sym__pat_constructor,
    STATE(13481), 1,
      sym__qcon,
    STATE(13521), 1,
      sym_qualified_constructor,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13682), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103298] = 27,
    ACTIONS(10686), 1,
      sym__varid,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    ACTIONS(10701), 1,
      anon_sym_LBRACK,
    ACTIONS(10705), 1,
      anon_sym_AT,
    ACTIONS(10707), 1,
      anon_sym__,
    ACTIONS(10709), 1,
      anon_sym_u27e6,
    ACTIONS(10711), 1,
      sym__splice_dollar,
    ACTIONS(10713), 1,
      sym_quasiquote_start,
    ACTIONS(10715), 1,
      sym__strict,
    ACTIONS(10717), 1,
      sym__lazy,
    ACTIONS(13205), 1,
      sym__conid,
    STATE(334), 1,
      sym__unboxed_open,
    STATE(8270), 1,
      sym_constructor,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8339), 1,
      sym_variable,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10694), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10688), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8536), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8585), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103406] = 27,
    ACTIONS(10686), 1,
      sym__varid,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    ACTIONS(10701), 1,
      anon_sym_LBRACK,
    ACTIONS(10705), 1,
      anon_sym_AT,
    ACTIONS(10707), 1,
      anon_sym__,
    ACTIONS(10709), 1,
      anon_sym_u27e6,
    ACTIONS(10711), 1,
      sym__splice_dollar,
    ACTIONS(10713), 1,
      sym_quasiquote_start,
    ACTIONS(10715), 1,
      sym__strict,
    ACTIONS(10717), 1,
      sym__lazy,
    ACTIONS(13205), 1,
      sym__conid,
    STATE(334), 1,
      sym__unboxed_open,
    STATE(8270), 1,
      sym_constructor,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8339), 1,
      sym_variable,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10694), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10688), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8536), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8558), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103514] = 27,
    ACTIONS(35), 1,
      anon_sym__,
    ACTIONS(77), 1,
      sym__strict,
    ACTIONS(79), 1,
      sym__lazy,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(5337), 1,
      anon_sym_AT,
    ACTIONS(15295), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(10340), 1,
      sym_constructor,
    STATE(10549), 1,
      sym_qualified_constructor,
    STATE(13397), 1,
      sym__pat_constructor,
    STATE(13809), 1,
      sym__qcon,
    STATE(13817), 1,
      sym_variable,
    STATE(14028), 1,
      sym_literal,
    STATE(17493), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5327), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4457), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10563), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13891), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103622] = 27,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(10587), 1,
      sym__varid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(10597), 1,
      anon_sym_LPAREN,
    ACTIONS(10602), 1,
      anon_sym_LBRACK,
    ACTIONS(10606), 1,
      anon_sym_AT,
    ACTIONS(10608), 1,
      anon_sym__,
    ACTIONS(10610), 1,
      anon_sym_u27e6,
    ACTIONS(10612), 1,
      sym__splice_dollar,
    ACTIONS(10614), 1,
      sym_quasiquote_start,
    ACTIONS(10616), 1,
      sym__strict,
    ACTIONS(10618), 1,
      sym__lazy,
    STATE(431), 1,
      sym__unboxed_open,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8295), 1,
      sym__pat_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(8376), 1,
      sym_variable,
    STATE(8592), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10595), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8537), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103730] = 27,
    ACTIONS(1410), 1,
      anon_sym__,
    ACTIONS(1428), 1,
      sym__strict,
    ACTIONS(1430), 1,
      sym__lazy,
    ACTIONS(13024), 1,
      sym__varid,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13040), 1,
      anon_sym_LBRACK,
    ACTIONS(13042), 1,
      anon_sym_AT,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    ACTIONS(15309), 1,
      anon_sym_LPAREN,
    ACTIONS(15311), 1,
      sym__conid,
    STATE(320), 1,
      sym__unboxed_open,
    STATE(13885), 1,
      sym_constructor,
    STATE(14088), 1,
      sym__pat_constructor,
    STATE(14135), 1,
      sym_variable,
    STATE(14182), 1,
      sym__qcon,
    STATE(14417), 1,
      sym_qualified_constructor,
    STATE(14895), 1,
      sym_literal,
    STATE(17314), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13032), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13026), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14805), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14744), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103838] = 27,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(10587), 1,
      sym__varid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(10597), 1,
      anon_sym_LPAREN,
    ACTIONS(10602), 1,
      anon_sym_LBRACK,
    ACTIONS(10606), 1,
      anon_sym_AT,
    ACTIONS(10608), 1,
      anon_sym__,
    ACTIONS(10610), 1,
      anon_sym_u27e6,
    ACTIONS(10612), 1,
      sym__splice_dollar,
    ACTIONS(10614), 1,
      sym_quasiquote_start,
    ACTIONS(10616), 1,
      sym__strict,
    ACTIONS(10618), 1,
      sym__lazy,
    STATE(431), 1,
      sym__unboxed_open,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8295), 1,
      sym__pat_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(8376), 1,
      sym_variable,
    STATE(8592), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10595), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8587), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103946] = 27,
    ACTIONS(1410), 1,
      anon_sym__,
    ACTIONS(1428), 1,
      sym__strict,
    ACTIONS(1430), 1,
      sym__lazy,
    ACTIONS(13024), 1,
      sym__varid,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13040), 1,
      anon_sym_LBRACK,
    ACTIONS(13042), 1,
      anon_sym_AT,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    ACTIONS(15309), 1,
      anon_sym_LPAREN,
    ACTIONS(15311), 1,
      sym__conid,
    STATE(320), 1,
      sym__unboxed_open,
    STATE(13885), 1,
      sym_constructor,
    STATE(14088), 1,
      sym__pat_constructor,
    STATE(14135), 1,
      sym_variable,
    STATE(14182), 1,
      sym__qcon,
    STATE(14417), 1,
      sym_qualified_constructor,
    STATE(14895), 1,
      sym_literal,
    STATE(17314), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13032), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13026), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14805), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14743), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104054] = 27,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_AT,
    ACTIONS(4917), 1,
      anon_sym__,
    ACTIONS(4923), 1,
      sym__strict,
    ACTIONS(4925), 1,
      sym__lazy,
    ACTIONS(15313), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym__unboxed_open,
    STATE(10325), 1,
      sym_constructor,
    STATE(10464), 1,
      sym_qualified_constructor,
    STATE(14551), 1,
      sym__pat_constructor,
    STATE(15163), 1,
      sym_variable,
    STATE(15600), 1,
      sym__qcon,
    STATE(16130), 1,
      sym_literal,
    STATE(16487), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4901), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4863), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10522), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15891), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104162] = 27,
    ACTIONS(10388), 1,
      sym__varid,
    ACTIONS(10394), 1,
      sym__integer_literal,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    ACTIONS(10405), 1,
      anon_sym_LBRACK,
    ACTIONS(10409), 1,
      anon_sym_AT,
    ACTIONS(10411), 1,
      anon_sym__,
    ACTIONS(10413), 1,
      anon_sym_u27e6,
    ACTIONS(10415), 1,
      sym__splice_dollar,
    ACTIONS(10417), 1,
      sym_quasiquote_start,
    ACTIONS(10419), 1,
      sym__strict,
    ACTIONS(10421), 1,
      sym__lazy,
    ACTIONS(11085), 1,
      sym__conid,
    STATE(302), 1,
      sym__unboxed_open,
    STATE(8191), 1,
      sym_constructor,
    STATE(8235), 1,
      sym__pat_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8271), 1,
      sym_variable,
    STATE(8306), 1,
      sym__qcon,
    STATE(8398), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10398), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10392), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8373), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8381), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104270] = 27,
    ACTIONS(12334), 1,
      sym__varid,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(12344), 1,
      anon_sym_LPAREN,
    ACTIONS(12349), 1,
      anon_sym_LBRACK,
    ACTIONS(12353), 1,
      anon_sym_AT,
    ACTIONS(12355), 1,
      anon_sym__,
    ACTIONS(12357), 1,
      anon_sym_u27e6,
    ACTIONS(12359), 1,
      sym__splice_dollar,
    ACTIONS(12361), 1,
      sym_quasiquote_start,
    ACTIONS(12363), 1,
      sym__strict,
    ACTIONS(12365), 1,
      sym__lazy,
    ACTIONS(13096), 1,
      sym__conid,
    STATE(357), 1,
      sym__unboxed_open,
    STATE(8734), 1,
      sym_constructor,
    STATE(8825), 1,
      sym__pat_constructor,
    STATE(8925), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(9152), 1,
      sym_variable,
    STATE(9642), 1,
      sym_literal,
    STATE(17585), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12342), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12336), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9565), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9582), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104378] = 27,
    ACTIONS(10388), 1,
      sym__varid,
    ACTIONS(10394), 1,
      sym__integer_literal,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    ACTIONS(10405), 1,
      anon_sym_LBRACK,
    ACTIONS(10409), 1,
      anon_sym_AT,
    ACTIONS(10411), 1,
      anon_sym__,
    ACTIONS(10413), 1,
      anon_sym_u27e6,
    ACTIONS(10415), 1,
      sym__splice_dollar,
    ACTIONS(10417), 1,
      sym_quasiquote_start,
    ACTIONS(10419), 1,
      sym__strict,
    ACTIONS(10421), 1,
      sym__lazy,
    ACTIONS(11085), 1,
      sym__conid,
    STATE(302), 1,
      sym__unboxed_open,
    STATE(8191), 1,
      sym_constructor,
    STATE(8235), 1,
      sym__pat_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(8271), 1,
      sym_variable,
    STATE(8306), 1,
      sym__qcon,
    STATE(8398), 1,
      sym_literal,
    STATE(17011), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10398), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10392), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8373), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8378), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104486] = 27,
    ACTIONS(10686), 1,
      sym__varid,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    ACTIONS(10701), 1,
      anon_sym_LBRACK,
    ACTIONS(10705), 1,
      anon_sym_AT,
    ACTIONS(10707), 1,
      anon_sym__,
    ACTIONS(10709), 1,
      anon_sym_u27e6,
    ACTIONS(10711), 1,
      sym__splice_dollar,
    ACTIONS(10713), 1,
      sym_quasiquote_start,
    ACTIONS(10715), 1,
      sym__strict,
    ACTIONS(10717), 1,
      sym__lazy,
    ACTIONS(13205), 1,
      sym__conid,
    STATE(334), 1,
      sym__unboxed_open,
    STATE(8270), 1,
      sym_constructor,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8339), 1,
      sym_variable,
    STATE(8343), 1,
      sym__qcon,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_literal,
    STATE(17023), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10694), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10688), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8536), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8646), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104594] = 27,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10318), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104702] = 27,
    ACTIONS(10945), 1,
      sym__varid,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(10955), 1,
      anon_sym_LPAREN,
    ACTIONS(10960), 1,
      anon_sym_LBRACK,
    ACTIONS(10964), 1,
      anon_sym_AT,
    ACTIONS(10966), 1,
      anon_sym__,
    ACTIONS(10968), 1,
      anon_sym_u27e6,
    ACTIONS(10970), 1,
      sym__splice_dollar,
    ACTIONS(10972), 1,
      sym_quasiquote_start,
    ACTIONS(10974), 1,
      sym__strict,
    ACTIONS(10976), 1,
      sym__lazy,
    ACTIONS(13064), 1,
      sym__conid,
    STATE(382), 1,
      sym__unboxed_open,
    STATE(8498), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8833), 1,
      sym_variable,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(9103), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10953), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10947), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9340), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9044), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104810] = 27,
    ACTIONS(1598), 1,
      anon_sym__,
    ACTIONS(1606), 1,
      sym__strict,
    ACTIONS(1608), 1,
      sym__lazy,
    ACTIONS(13290), 1,
      sym__varid,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13306), 1,
      anon_sym_LBRACK,
    ACTIONS(13308), 1,
      anon_sym_AT,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    ACTIONS(15315), 1,
      anon_sym_LPAREN,
    ACTIONS(15317), 1,
      sym__conid,
    STATE(407), 1,
      sym__unboxed_open,
    STATE(14011), 1,
      sym__pat_constructor,
    STATE(14115), 1,
      sym_constructor,
    STATE(14146), 1,
      sym_qualified_constructor,
    STATE(14273), 1,
      sym_variable,
    STATE(14317), 1,
      sym__qcon,
    STATE(14872), 1,
      sym_literal,
    STATE(16339), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13298), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13292), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14664), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104918] = 27,
    ACTIONS(1598), 1,
      anon_sym__,
    ACTIONS(1606), 1,
      sym__strict,
    ACTIONS(1608), 1,
      sym__lazy,
    ACTIONS(13290), 1,
      sym__varid,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13306), 1,
      anon_sym_LBRACK,
    ACTIONS(13308), 1,
      anon_sym_AT,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    ACTIONS(15315), 1,
      anon_sym_LPAREN,
    ACTIONS(15317), 1,
      sym__conid,
    STATE(407), 1,
      sym__unboxed_open,
    STATE(14011), 1,
      sym__pat_constructor,
    STATE(14115), 1,
      sym_constructor,
    STATE(14146), 1,
      sym_qualified_constructor,
    STATE(14273), 1,
      sym_variable,
    STATE(14317), 1,
      sym__qcon,
    STATE(14872), 1,
      sym_literal,
    STATE(16339), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13298), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13292), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14658), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105026] = 27,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10316), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105134] = 27,
    ACTIONS(11483), 1,
      sym__varid,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(11493), 1,
      anon_sym_LPAREN,
    ACTIONS(11498), 1,
      anon_sym_LBRACK,
    ACTIONS(11502), 1,
      anon_sym_AT,
    ACTIONS(11504), 1,
      anon_sym__,
    ACTIONS(11506), 1,
      anon_sym_u27e6,
    ACTIONS(11508), 1,
      sym__splice_dollar,
    ACTIONS(11510), 1,
      sym_quasiquote_start,
    ACTIONS(11512), 1,
      sym__strict,
    ACTIONS(11514), 1,
      sym__lazy,
    ACTIONS(13304), 1,
      sym__conid,
    STATE(418), 1,
      sym__unboxed_open,
    STATE(8490), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(8885), 1,
      sym_variable,
    STATE(9263), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11491), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11485), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9131), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8913), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105242] = 27,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    ACTIONS(15319), 1,
      anon_sym_LPAREN,
    ACTIONS(15321), 1,
      sym__conid,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(14298), 1,
      sym__pat_constructor,
    STATE(14303), 1,
      sym_constructor,
    STATE(14575), 1,
      sym__qcon,
    STATE(14598), 1,
      sym_variable,
    STATE(14603), 1,
      sym_qualified_constructor,
    STATE(15257), 1,
      sym_literal,
    STATE(16703), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15421), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105350] = 27,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    ACTIONS(15319), 1,
      anon_sym_LPAREN,
    ACTIONS(15321), 1,
      sym__conid,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(14298), 1,
      sym__pat_constructor,
    STATE(14303), 1,
      sym_constructor,
    STATE(14575), 1,
      sym__qcon,
    STATE(14598), 1,
      sym_variable,
    STATE(14603), 1,
      sym_qualified_constructor,
    STATE(15257), 1,
      sym_literal,
    STATE(16703), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15492), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105458] = 27,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    ACTIONS(15319), 1,
      anon_sym_LPAREN,
    ACTIONS(15321), 1,
      sym__conid,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(14298), 1,
      sym__pat_constructor,
    STATE(14303), 1,
      sym_constructor,
    STATE(14575), 1,
      sym__qcon,
    STATE(14598), 1,
      sym_variable,
    STATE(14603), 1,
      sym_qualified_constructor,
    STATE(15257), 1,
      sym_literal,
    STATE(16703), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15495), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105566] = 27,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(12611), 1,
      sym__varid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(12621), 1,
      anon_sym_LPAREN,
    ACTIONS(12626), 1,
      anon_sym_LBRACK,
    ACTIONS(12630), 1,
      anon_sym_AT,
    ACTIONS(12632), 1,
      anon_sym__,
    ACTIONS(12634), 1,
      anon_sym_u27e6,
    ACTIONS(12636), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    ACTIONS(12640), 1,
      sym__strict,
    ACTIONS(12642), 1,
      sym__lazy,
    STATE(353), 1,
      sym__unboxed_open,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9100), 1,
      sym__pat_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(9606), 1,
      sym_variable,
    STATE(9685), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12619), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12613), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9699), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105674] = 27,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    ACTIONS(15291), 1,
      anon_sym_LPAREN,
    ACTIONS(15293), 1,
      sym__conid,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(14355), 1,
      sym__pat_constructor,
    STATE(14451), 1,
      sym_constructor,
    STATE(14582), 1,
      sym__qcon,
    STATE(14620), 1,
      sym_qualified_constructor,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(17058), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15531), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105782] = 27,
    ACTIONS(11018), 1,
      sym__varid,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(11028), 1,
      anon_sym_LPAREN,
    ACTIONS(11033), 1,
      anon_sym_LBRACK,
    ACTIONS(11037), 1,
      anon_sym_AT,
    ACTIONS(11039), 1,
      anon_sym__,
    ACTIONS(11041), 1,
      anon_sym_u27e6,
    ACTIONS(11043), 1,
      sym__splice_dollar,
    ACTIONS(11045), 1,
      sym_quasiquote_start,
    ACTIONS(11047), 1,
      sym__strict,
    ACTIONS(11049), 1,
      sym__lazy,
    ACTIONS(13038), 1,
      sym__conid,
    STATE(282), 1,
      sym__unboxed_open,
    STATE(8500), 1,
      sym_constructor,
    STATE(8509), 1,
      sym__pat_constructor,
    STATE(8780), 1,
      sym_variable,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(9108), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11026), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9109), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105890] = 27,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    ACTIONS(15323), 1,
      anon_sym_LPAREN,
    ACTIONS(15325), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(14041), 1,
      sym_constructor,
    STATE(14059), 1,
      sym__pat_constructor,
    STATE(14160), 1,
      sym_qualified_constructor,
    STATE(14203), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(17196), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14715), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105998] = 27,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    ACTIONS(15327), 1,
      anon_sym_LPAREN,
    ACTIONS(15329), 1,
      sym__conid,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(13871), 1,
      sym__pat_constructor,
    STATE(14082), 1,
      sym_constructor,
    STATE(14201), 1,
      sym_qualified_constructor,
    STATE(14276), 1,
      sym__qcon,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(16511), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14787), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106106] = 27,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(15331), 1,
      anon_sym_LPAREN,
    ACTIONS(15333), 1,
      sym__conid,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(13873), 1,
      sym__pat_constructor,
    STATE(13919), 1,
      sym_constructor,
    STATE(14183), 1,
      sym_variable,
    STATE(14427), 1,
      sym_qualified_constructor,
    STATE(14439), 1,
      sym__qcon,
    STATE(14592), 1,
      sym_literal,
    STATE(16989), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14613), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106214] = 27,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(15331), 1,
      anon_sym_LPAREN,
    ACTIONS(15333), 1,
      sym__conid,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(13873), 1,
      sym__pat_constructor,
    STATE(13919), 1,
      sym_constructor,
    STATE(14183), 1,
      sym_variable,
    STATE(14427), 1,
      sym_qualified_constructor,
    STATE(14439), 1,
      sym__qcon,
    STATE(14592), 1,
      sym_literal,
    STATE(16989), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14614), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106322] = 27,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15297), 1,
      anon_sym_LPAREN,
    ACTIONS(15299), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(12879), 1,
      sym_constructor,
    STATE(12917), 1,
      sym__pat_constructor,
    STATE(13481), 1,
      sym__qcon,
    STATE(13521), 1,
      sym_qualified_constructor,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13568), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106430] = 27,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    ACTIONS(15323), 1,
      anon_sym_LPAREN,
    ACTIONS(15325), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(14041), 1,
      sym_constructor,
    STATE(14059), 1,
      sym__pat_constructor,
    STATE(14160), 1,
      sym_qualified_constructor,
    STATE(14203), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(17196), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14616), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106538] = 27,
    ACTIONS(573), 1,
      anon_sym__,
    ACTIONS(593), 1,
      sym__strict,
    ACTIONS(595), 1,
      sym__lazy,
    ACTIONS(12998), 1,
      sym__varid,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13014), 1,
      anon_sym_LBRACK,
    ACTIONS(13016), 1,
      anon_sym_AT,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    ACTIONS(15335), 1,
      anon_sym_LPAREN,
    ACTIONS(15337), 1,
      sym__conid,
    STATE(280), 1,
      sym__unboxed_open,
    STATE(13783), 1,
      sym_constructor,
    STATE(13799), 1,
      sym__pat_constructor,
    STATE(13922), 1,
      sym__qcon,
    STATE(14057), 1,
      sym_variable,
    STATE(14079), 1,
      sym_qualified_constructor,
    STATE(14243), 1,
      sym_literal,
    STATE(17327), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13006), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13000), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14368), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106646] = 27,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    ACTIONS(15305), 1,
      anon_sym_LPAREN,
    ACTIONS(15307), 1,
      sym__conid,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(14185), 1,
      sym_constructor,
    STATE(14279), 1,
      sym__pat_constructor,
    STATE(14585), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(14845), 1,
      sym__qcon,
    STATE(15329), 1,
      sym_literal,
    STATE(17328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15260), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106754] = 27,
    ACTIONS(10945), 1,
      sym__varid,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(10955), 1,
      anon_sym_LPAREN,
    ACTIONS(10960), 1,
      anon_sym_LBRACK,
    ACTIONS(10964), 1,
      anon_sym_AT,
    ACTIONS(10966), 1,
      anon_sym__,
    ACTIONS(10968), 1,
      anon_sym_u27e6,
    ACTIONS(10970), 1,
      sym__splice_dollar,
    ACTIONS(10972), 1,
      sym_quasiquote_start,
    ACTIONS(10974), 1,
      sym__strict,
    ACTIONS(10976), 1,
      sym__lazy,
    ACTIONS(13064), 1,
      sym__conid,
    STATE(382), 1,
      sym__unboxed_open,
    STATE(8498), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8833), 1,
      sym_variable,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(9103), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10953), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10947), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9340), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8923), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106862] = 27,
    ACTIONS(10945), 1,
      sym__varid,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(10955), 1,
      anon_sym_LPAREN,
    ACTIONS(10960), 1,
      anon_sym_LBRACK,
    ACTIONS(10964), 1,
      anon_sym_AT,
    ACTIONS(10966), 1,
      anon_sym__,
    ACTIONS(10968), 1,
      anon_sym_u27e6,
    ACTIONS(10970), 1,
      sym__splice_dollar,
    ACTIONS(10972), 1,
      sym_quasiquote_start,
    ACTIONS(10974), 1,
      sym__strict,
    ACTIONS(10976), 1,
      sym__lazy,
    ACTIONS(13064), 1,
      sym__conid,
    STATE(382), 1,
      sym__unboxed_open,
    STATE(8498), 1,
      sym__pat_constructor,
    STATE(8574), 1,
      sym_constructor,
    STATE(8731), 1,
      sym__qcon,
    STATE(8833), 1,
      sym_variable,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(9103), 1,
      sym_literal,
    STATE(17458), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10953), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10947), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9340), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9034), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106970] = 27,
    ACTIONS(10810), 1,
      sym__varid,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(10820), 1,
      anon_sym_LPAREN,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10829), 1,
      anon_sym_AT,
    ACTIONS(10831), 1,
      anon_sym__,
    ACTIONS(10833), 1,
      anon_sym_u27e6,
    ACTIONS(10835), 1,
      sym__splice_dollar,
    ACTIONS(10837), 1,
      sym_quasiquote_start,
    ACTIONS(10839), 1,
      sym__strict,
    ACTIONS(10841), 1,
      sym__lazy,
    ACTIONS(13012), 1,
      sym__conid,
    STATE(384), 1,
      sym__unboxed_open,
    STATE(8454), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8499), 1,
      sym_variable,
    STATE(8502), 1,
      sym__qcon,
    STATE(8809), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10818), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10812), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8840), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107078] = 27,
    ACTIONS(13159), 1,
      sym__varid,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13175), 1,
      anon_sym_LBRACK,
    ACTIONS(13177), 1,
      anon_sym_AT,
    ACTIONS(13179), 1,
      anon_sym__,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(13187), 1,
      sym__strict,
    ACTIONS(13189), 1,
      sym__lazy,
    ACTIONS(15291), 1,
      anon_sym_LPAREN,
    ACTIONS(15293), 1,
      sym__conid,
    STATE(435), 1,
      sym__unboxed_open,
    STATE(14355), 1,
      sym__pat_constructor,
    STATE(14451), 1,
      sym_constructor,
    STATE(14582), 1,
      sym__qcon,
    STATE(14620), 1,
      sym_qualified_constructor,
    STATE(14912), 1,
      sym_variable,
    STATE(15135), 1,
      sym_literal,
    STATE(17058), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13167), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13161), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14980), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15285), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107186] = 27,
    ACTIONS(573), 1,
      anon_sym__,
    ACTIONS(593), 1,
      sym__strict,
    ACTIONS(595), 1,
      sym__lazy,
    ACTIONS(12998), 1,
      sym__varid,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13014), 1,
      anon_sym_LBRACK,
    ACTIONS(13016), 1,
      anon_sym_AT,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    ACTIONS(15335), 1,
      anon_sym_LPAREN,
    ACTIONS(15337), 1,
      sym__conid,
    STATE(280), 1,
      sym__unboxed_open,
    STATE(13783), 1,
      sym_constructor,
    STATE(13799), 1,
      sym__pat_constructor,
    STATE(13922), 1,
      sym__qcon,
    STATE(14057), 1,
      sym_variable,
    STATE(14079), 1,
      sym_qualified_constructor,
    STATE(14243), 1,
      sym_literal,
    STATE(17327), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13006), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13000), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14409), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107294] = 27,
    ACTIONS(677), 1,
      anon_sym__,
    ACTIONS(689), 1,
      sym__strict,
    ACTIONS(691), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__varid,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11087), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_AT,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15297), 1,
      anon_sym_LPAREN,
    ACTIONS(15299), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(12879), 1,
      sym_constructor,
    STATE(12917), 1,
      sym__pat_constructor,
    STATE(13481), 1,
      sym__qcon,
    STATE(13521), 1,
      sym_qualified_constructor,
    STATE(13551), 1,
      sym_variable,
    STATE(13574), 1,
      sym_literal,
    STATE(17252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11079), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11073), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13810), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107402] = 27,
    ACTIONS(573), 1,
      anon_sym__,
    ACTIONS(593), 1,
      sym__strict,
    ACTIONS(595), 1,
      sym__lazy,
    ACTIONS(12998), 1,
      sym__varid,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13014), 1,
      anon_sym_LBRACK,
    ACTIONS(13016), 1,
      anon_sym_AT,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    ACTIONS(15335), 1,
      anon_sym_LPAREN,
    ACTIONS(15337), 1,
      sym__conid,
    STATE(280), 1,
      sym__unboxed_open,
    STATE(13783), 1,
      sym_constructor,
    STATE(13799), 1,
      sym__pat_constructor,
    STATE(13922), 1,
      sym__qcon,
    STATE(14057), 1,
      sym_variable,
    STATE(14079), 1,
      sym_qualified_constructor,
    STATE(14243), 1,
      sym_literal,
    STATE(17327), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13006), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13000), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14390), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107510] = 27,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    ACTIONS(15323), 1,
      anon_sym_LPAREN,
    ACTIONS(15325), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(14041), 1,
      sym_constructor,
    STATE(14059), 1,
      sym__pat_constructor,
    STATE(14160), 1,
      sym_qualified_constructor,
    STATE(14203), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(17196), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14792), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107618] = 27,
    ACTIONS(1598), 1,
      anon_sym__,
    ACTIONS(1606), 1,
      sym__strict,
    ACTIONS(1608), 1,
      sym__lazy,
    ACTIONS(13290), 1,
      sym__varid,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13306), 1,
      anon_sym_LBRACK,
    ACTIONS(13308), 1,
      anon_sym_AT,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    ACTIONS(15315), 1,
      anon_sym_LPAREN,
    ACTIONS(15317), 1,
      sym__conid,
    STATE(407), 1,
      sym__unboxed_open,
    STATE(14011), 1,
      sym__pat_constructor,
    STATE(14115), 1,
      sym_constructor,
    STATE(14146), 1,
      sym_qualified_constructor,
    STATE(14273), 1,
      sym_variable,
    STATE(14317), 1,
      sym__qcon,
    STATE(14872), 1,
      sym_literal,
    STATE(16339), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13298), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13292), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14645), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107726] = 27,
    ACTIONS(1598), 1,
      anon_sym__,
    ACTIONS(1606), 1,
      sym__strict,
    ACTIONS(1608), 1,
      sym__lazy,
    ACTIONS(13290), 1,
      sym__varid,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13306), 1,
      anon_sym_LBRACK,
    ACTIONS(13308), 1,
      anon_sym_AT,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    ACTIONS(15315), 1,
      anon_sym_LPAREN,
    ACTIONS(15317), 1,
      sym__conid,
    STATE(407), 1,
      sym__unboxed_open,
    STATE(14011), 1,
      sym__pat_constructor,
    STATE(14115), 1,
      sym_constructor,
    STATE(14146), 1,
      sym_qualified_constructor,
    STATE(14273), 1,
      sym_variable,
    STATE(14317), 1,
      sym__qcon,
    STATE(14872), 1,
      sym_literal,
    STATE(16339), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13298), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13292), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14887), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107834] = 27,
    ACTIONS(12243), 1,
      sym__varid,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12253), 1,
      anon_sym_LPAREN,
    ACTIONS(12258), 1,
      anon_sym_LBRACK,
    ACTIONS(12262), 1,
      anon_sym_AT,
    ACTIONS(12264), 1,
      anon_sym__,
    ACTIONS(12266), 1,
      anon_sym_u27e6,
    ACTIONS(12268), 1,
      sym__splice_dollar,
    ACTIONS(12270), 1,
      sym_quasiquote_start,
    ACTIONS(12272), 1,
      sym__strict,
    ACTIONS(12274), 1,
      sym__lazy,
    ACTIONS(12980), 1,
      sym__conid,
    STATE(355), 1,
      sym__unboxed_open,
    STATE(8724), 1,
      sym_constructor,
    STATE(8733), 1,
      sym__pat_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(9026), 1,
      sym_variable,
    STATE(9480), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12251), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12245), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9515), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9479), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107942] = 27,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    ACTIONS(15327), 1,
      anon_sym_LPAREN,
    ACTIONS(15329), 1,
      sym__conid,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(13871), 1,
      sym__pat_constructor,
    STATE(14082), 1,
      sym_constructor,
    STATE(14201), 1,
      sym_qualified_constructor,
    STATE(14276), 1,
      sym__qcon,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(16511), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14899), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108050] = 27,
    ACTIONS(12243), 1,
      sym__varid,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12253), 1,
      anon_sym_LPAREN,
    ACTIONS(12258), 1,
      anon_sym_LBRACK,
    ACTIONS(12262), 1,
      anon_sym_AT,
    ACTIONS(12264), 1,
      anon_sym__,
    ACTIONS(12266), 1,
      anon_sym_u27e6,
    ACTIONS(12268), 1,
      sym__splice_dollar,
    ACTIONS(12270), 1,
      sym_quasiquote_start,
    ACTIONS(12272), 1,
      sym__strict,
    ACTIONS(12274), 1,
      sym__lazy,
    ACTIONS(12980), 1,
      sym__conid,
    STATE(355), 1,
      sym__unboxed_open,
    STATE(8724), 1,
      sym_constructor,
    STATE(8733), 1,
      sym__pat_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(9026), 1,
      sym_variable,
    STATE(9480), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12251), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12245), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9515), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9491), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108158] = 27,
    ACTIONS(269), 1,
      anon_sym__,
    ACTIONS(293), 1,
      sym__strict,
    ACTIONS(295), 1,
      sym__lazy,
    ACTIONS(13191), 1,
      sym__varid,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13207), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    ACTIONS(15301), 1,
      anon_sym_LPAREN,
    ACTIONS(15303), 1,
      sym__conid,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(13275), 1,
      sym_constructor,
    STATE(13370), 1,
      sym__pat_constructor,
    STATE(13601), 1,
      sym_qualified_constructor,
    STATE(13740), 1,
      sym__qcon,
    STATE(13744), 1,
      sym_variable,
    STATE(14076), 1,
      sym_literal,
    STATE(16796), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14068), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108266] = 27,
    ACTIONS(11483), 1,
      sym__varid,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(11493), 1,
      anon_sym_LPAREN,
    ACTIONS(11498), 1,
      anon_sym_LBRACK,
    ACTIONS(11502), 1,
      anon_sym_AT,
    ACTIONS(11504), 1,
      anon_sym__,
    ACTIONS(11506), 1,
      anon_sym_u27e6,
    ACTIONS(11508), 1,
      sym__splice_dollar,
    ACTIONS(11510), 1,
      sym_quasiquote_start,
    ACTIONS(11512), 1,
      sym__strict,
    ACTIONS(11514), 1,
      sym__lazy,
    ACTIONS(13304), 1,
      sym__conid,
    STATE(418), 1,
      sym__unboxed_open,
    STATE(8490), 1,
      sym__pat_constructor,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(8862), 1,
      sym__qcon,
    STATE(8885), 1,
      sym_variable,
    STATE(9263), 1,
      sym_literal,
    STATE(16334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11491), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11485), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9131), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9282), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108374] = 27,
    ACTIONS(12931), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12947), 1,
      anon_sym_LBRACK,
    ACTIONS(12949), 1,
      anon_sym_AT,
    ACTIONS(12951), 1,
      anon_sym__,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(12959), 1,
      sym__strict,
    ACTIONS(12961), 1,
      sym__lazy,
    ACTIONS(15323), 1,
      anon_sym_LPAREN,
    ACTIONS(15325), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(14041), 1,
      sym_constructor,
    STATE(14059), 1,
      sym__pat_constructor,
    STATE(14160), 1,
      sym_qualified_constructor,
    STATE(14203), 1,
      sym__qcon,
    STATE(14495), 1,
      sym_variable,
    STATE(14822), 1,
      sym_literal,
    STATE(17196), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14559), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14791), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108482] = 27,
    ACTIONS(11583), 1,
      sym__varid,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    ACTIONS(11598), 1,
      anon_sym_LBRACK,
    ACTIONS(11602), 1,
      anon_sym_AT,
    ACTIONS(11604), 1,
      anon_sym__,
    ACTIONS(11606), 1,
      anon_sym_u27e6,
    ACTIONS(11608), 1,
      sym__splice_dollar,
    ACTIONS(11610), 1,
      sym_quasiquote_start,
    ACTIONS(11612), 1,
      sym__strict,
    ACTIONS(11614), 1,
      sym__lazy,
    ACTIONS(12945), 1,
      sym__conid,
    STATE(372), 1,
      sym__unboxed_open,
    STATE(8596), 1,
      sym_constructor,
    STATE(8624), 1,
      sym__pat_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8824), 1,
      sym_variable,
    STATE(8865), 1,
      sym__qcon,
    STATE(9201), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11591), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11585), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9134), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108590] = 27,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_AT,
    ACTIONS(4917), 1,
      anon_sym__,
    ACTIONS(4923), 1,
      sym__strict,
    ACTIONS(4925), 1,
      sym__lazy,
    ACTIONS(15313), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym__unboxed_open,
    STATE(10325), 1,
      sym_constructor,
    STATE(10464), 1,
      sym_qualified_constructor,
    STATE(14551), 1,
      sym__pat_constructor,
    STATE(15163), 1,
      sym_variable,
    STATE(15600), 1,
      sym__qcon,
    STATE(16130), 1,
      sym_literal,
    STATE(16487), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4901), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4863), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10522), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15734), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108698] = 27,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    ACTIONS(15327), 1,
      anon_sym_LPAREN,
    ACTIONS(15329), 1,
      sym__conid,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(13871), 1,
      sym__pat_constructor,
    STATE(14082), 1,
      sym_constructor,
    STATE(14201), 1,
      sym_qualified_constructor,
    STATE(14276), 1,
      sym__qcon,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(16511), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14896), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108806] = 27,
    ACTIONS(11018), 1,
      sym__varid,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(11028), 1,
      anon_sym_LPAREN,
    ACTIONS(11033), 1,
      anon_sym_LBRACK,
    ACTIONS(11037), 1,
      anon_sym_AT,
    ACTIONS(11039), 1,
      anon_sym__,
    ACTIONS(11041), 1,
      anon_sym_u27e6,
    ACTIONS(11043), 1,
      sym__splice_dollar,
    ACTIONS(11045), 1,
      sym_quasiquote_start,
    ACTIONS(11047), 1,
      sym__strict,
    ACTIONS(11049), 1,
      sym__lazy,
    ACTIONS(13038), 1,
      sym__conid,
    STATE(282), 1,
      sym__unboxed_open,
    STATE(8500), 1,
      sym_constructor,
    STATE(8509), 1,
      sym__pat_constructor,
    STATE(8780), 1,
      sym_variable,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(9108), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11026), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9173), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [108914] = 27,
    ACTIONS(13050), 1,
      sym__varid,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13066), 1,
      anon_sym_LBRACK,
    ACTIONS(13068), 1,
      anon_sym_AT,
    ACTIONS(13070), 1,
      anon_sym__,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(13078), 1,
      sym__strict,
    ACTIONS(13080), 1,
      sym__lazy,
    ACTIONS(15327), 1,
      anon_sym_LPAREN,
    ACTIONS(15329), 1,
      sym__conid,
    STATE(397), 1,
      sym__unboxed_open,
    STATE(13871), 1,
      sym__pat_constructor,
    STATE(14082), 1,
      sym_constructor,
    STATE(14201), 1,
      sym_qualified_constructor,
    STATE(14276), 1,
      sym__qcon,
    STATE(14518), 1,
      sym_variable,
    STATE(14807), 1,
      sym_literal,
    STATE(16511), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13058), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13052), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14945), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109022] = 27,
    ACTIONS(11018), 1,
      sym__varid,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(11028), 1,
      anon_sym_LPAREN,
    ACTIONS(11033), 1,
      anon_sym_LBRACK,
    ACTIONS(11037), 1,
      anon_sym_AT,
    ACTIONS(11039), 1,
      anon_sym__,
    ACTIONS(11041), 1,
      anon_sym_u27e6,
    ACTIONS(11043), 1,
      sym__splice_dollar,
    ACTIONS(11045), 1,
      sym_quasiquote_start,
    ACTIONS(11047), 1,
      sym__strict,
    ACTIONS(11049), 1,
      sym__lazy,
    ACTIONS(13038), 1,
      sym__conid,
    STATE(282), 1,
      sym__unboxed_open,
    STATE(8500), 1,
      sym_constructor,
    STATE(8509), 1,
      sym__pat_constructor,
    STATE(8780), 1,
      sym_variable,
    STATE(8781), 1,
      sym__qcon,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(9108), 1,
      sym_literal,
    STATE(17098), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11026), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9112), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109130] = 27,
    ACTIONS(11583), 1,
      sym__varid,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    ACTIONS(11598), 1,
      anon_sym_LBRACK,
    ACTIONS(11602), 1,
      anon_sym_AT,
    ACTIONS(11604), 1,
      anon_sym__,
    ACTIONS(11606), 1,
      anon_sym_u27e6,
    ACTIONS(11608), 1,
      sym__splice_dollar,
    ACTIONS(11610), 1,
      sym_quasiquote_start,
    ACTIONS(11612), 1,
      sym__strict,
    ACTIONS(11614), 1,
      sym__lazy,
    ACTIONS(12945), 1,
      sym__conid,
    STATE(372), 1,
      sym__unboxed_open,
    STATE(8596), 1,
      sym_constructor,
    STATE(8624), 1,
      sym__pat_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8824), 1,
      sym_variable,
    STATE(8865), 1,
      sym__qcon,
    STATE(9201), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11591), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11585), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9197), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109238] = 27,
    ACTIONS(1410), 1,
      anon_sym__,
    ACTIONS(1428), 1,
      sym__strict,
    ACTIONS(1430), 1,
      sym__lazy,
    ACTIONS(13024), 1,
      sym__varid,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13040), 1,
      anon_sym_LBRACK,
    ACTIONS(13042), 1,
      anon_sym_AT,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    ACTIONS(15309), 1,
      anon_sym_LPAREN,
    ACTIONS(15311), 1,
      sym__conid,
    STATE(320), 1,
      sym__unboxed_open,
    STATE(13885), 1,
      sym_constructor,
    STATE(14088), 1,
      sym__pat_constructor,
    STATE(14135), 1,
      sym_variable,
    STATE(14182), 1,
      sym__qcon,
    STATE(14417), 1,
      sym_qualified_constructor,
    STATE(14895), 1,
      sym_literal,
    STATE(17314), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13032), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13026), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14805), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14687), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109346] = 27,
    ACTIONS(11583), 1,
      sym__varid,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    ACTIONS(11598), 1,
      anon_sym_LBRACK,
    ACTIONS(11602), 1,
      anon_sym_AT,
    ACTIONS(11604), 1,
      anon_sym__,
    ACTIONS(11606), 1,
      anon_sym_u27e6,
    ACTIONS(11608), 1,
      sym__splice_dollar,
    ACTIONS(11610), 1,
      sym_quasiquote_start,
    ACTIONS(11612), 1,
      sym__strict,
    ACTIONS(11614), 1,
      sym__lazy,
    ACTIONS(12945), 1,
      sym__conid,
    STATE(372), 1,
      sym__unboxed_open,
    STATE(8596), 1,
      sym_constructor,
    STATE(8624), 1,
      sym__pat_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(8824), 1,
      sym_variable,
    STATE(8865), 1,
      sym__qcon,
    STATE(9201), 1,
      sym_literal,
    STATE(16778), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11591), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11585), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9198), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109454] = 27,
    ACTIONS(269), 1,
      anon_sym__,
    ACTIONS(293), 1,
      sym__strict,
    ACTIONS(295), 1,
      sym__lazy,
    ACTIONS(13191), 1,
      sym__varid,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13207), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    ACTIONS(15301), 1,
      anon_sym_LPAREN,
    ACTIONS(15303), 1,
      sym__conid,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(13275), 1,
      sym_constructor,
    STATE(13370), 1,
      sym__pat_constructor,
    STATE(13601), 1,
      sym_qualified_constructor,
    STATE(13740), 1,
      sym__qcon,
    STATE(13744), 1,
      sym_variable,
    STATE(14076), 1,
      sym_literal,
    STATE(16796), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14026), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109562] = 27,
    ACTIONS(269), 1,
      anon_sym__,
    ACTIONS(293), 1,
      sym__strict,
    ACTIONS(295), 1,
      sym__lazy,
    ACTIONS(13191), 1,
      sym__varid,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13207), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym_AT,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    ACTIONS(15301), 1,
      anon_sym_LPAREN,
    ACTIONS(15303), 1,
      sym__conid,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(13275), 1,
      sym_constructor,
    STATE(13370), 1,
      sym__pat_constructor,
    STATE(13601), 1,
      sym_qualified_constructor,
    STATE(13740), 1,
      sym__qcon,
    STATE(13744), 1,
      sym_variable,
    STATE(14076), 1,
      sym_literal,
    STATE(16796), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14034), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109670] = 27,
    ACTIONS(35), 1,
      anon_sym__,
    ACTIONS(77), 1,
      sym__strict,
    ACTIONS(79), 1,
      sym__lazy,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(5337), 1,
      anon_sym_AT,
    ACTIONS(15295), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(10340), 1,
      sym_constructor,
    STATE(10549), 1,
      sym_qualified_constructor,
    STATE(13397), 1,
      sym__pat_constructor,
    STATE(13809), 1,
      sym__qcon,
    STATE(13817), 1,
      sym_variable,
    STATE(14028), 1,
      sym_literal,
    STATE(17493), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5327), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4457), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10563), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14047), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109778] = 27,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9844), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109886] = 27,
    ACTIONS(35), 1,
      anon_sym__,
    ACTIONS(77), 1,
      sym__strict,
    ACTIONS(79), 1,
      sym__lazy,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(5337), 1,
      anon_sym_AT,
    ACTIONS(15295), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(10340), 1,
      sym_constructor,
    STATE(10549), 1,
      sym_qualified_constructor,
    STATE(13397), 1,
      sym__pat_constructor,
    STATE(13809), 1,
      sym__qcon,
    STATE(13817), 1,
      sym_variable,
    STATE(14028), 1,
      sym_literal,
    STATE(17493), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5327), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4457), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10563), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14054), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [109994] = 27,
    ACTIONS(12059), 1,
      sym__varid,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(12069), 1,
      anon_sym_LPAREN,
    ACTIONS(12074), 1,
      anon_sym_LBRACK,
    ACTIONS(12078), 1,
      anon_sym_AT,
    ACTIONS(12080), 1,
      anon_sym__,
    ACTIONS(12082), 1,
      anon_sym_u27e6,
    ACTIONS(12084), 1,
      sym__splice_dollar,
    ACTIONS(12086), 1,
      sym_quasiquote_start,
    ACTIONS(12088), 1,
      sym__strict,
    ACTIONS(12090), 1,
      sym__lazy,
    ACTIONS(13173), 1,
      sym__conid,
    STATE(387), 1,
      sym__unboxed_open,
    STATE(8797), 1,
      sym_constructor,
    STATE(8858), 1,
      sym__pat_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(9271), 1,
      sym_variable,
    STATE(9381), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12067), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9373), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110102] = 27,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_AT,
    ACTIONS(4917), 1,
      anon_sym__,
    ACTIONS(4923), 1,
      sym__strict,
    ACTIONS(4925), 1,
      sym__lazy,
    ACTIONS(15313), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym__unboxed_open,
    STATE(10325), 1,
      sym_constructor,
    STATE(10464), 1,
      sym_qualified_constructor,
    STATE(14551), 1,
      sym__pat_constructor,
    STATE(15163), 1,
      sym_variable,
    STATE(15600), 1,
      sym__qcon,
    STATE(16130), 1,
      sym_literal,
    STATE(16487), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4901), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4863), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10522), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15972), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110210] = 27,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_AT,
    ACTIONS(4917), 1,
      anon_sym__,
    ACTIONS(4923), 1,
      sym__strict,
    ACTIONS(4925), 1,
      sym__lazy,
    ACTIONS(15313), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym__unboxed_open,
    STATE(10325), 1,
      sym_constructor,
    STATE(10464), 1,
      sym_qualified_constructor,
    STATE(14551), 1,
      sym__pat_constructor,
    STATE(15163), 1,
      sym_variable,
    STATE(15600), 1,
      sym__qcon,
    STATE(16130), 1,
      sym_literal,
    STATE(16487), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4901), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4863), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10522), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15988), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110318] = 27,
    ACTIONS(12243), 1,
      sym__varid,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12253), 1,
      anon_sym_LPAREN,
    ACTIONS(12258), 1,
      anon_sym_LBRACK,
    ACTIONS(12262), 1,
      anon_sym_AT,
    ACTIONS(12264), 1,
      anon_sym__,
    ACTIONS(12266), 1,
      anon_sym_u27e6,
    ACTIONS(12268), 1,
      sym__splice_dollar,
    ACTIONS(12270), 1,
      sym_quasiquote_start,
    ACTIONS(12272), 1,
      sym__strict,
    ACTIONS(12274), 1,
      sym__lazy,
    ACTIONS(12980), 1,
      sym__conid,
    STATE(355), 1,
      sym__unboxed_open,
    STATE(8724), 1,
      sym_constructor,
    STATE(8733), 1,
      sym__pat_constructor,
    STATE(8901), 1,
      sym__qcon,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(9026), 1,
      sym_variable,
    STATE(9480), 1,
      sym_literal,
    STATE(16919), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12251), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12245), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9515), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9527), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110426] = 27,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(12611), 1,
      sym__varid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(12621), 1,
      anon_sym_LPAREN,
    ACTIONS(12626), 1,
      anon_sym_LBRACK,
    ACTIONS(12630), 1,
      anon_sym_AT,
    ACTIONS(12632), 1,
      anon_sym__,
    ACTIONS(12634), 1,
      anon_sym_u27e6,
    ACTIONS(12636), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    ACTIONS(12640), 1,
      sym__strict,
    ACTIONS(12642), 1,
      sym__lazy,
    STATE(353), 1,
      sym__unboxed_open,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9100), 1,
      sym__pat_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(9606), 1,
      sym_variable,
    STATE(9685), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12619), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12613), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9683), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110534] = 27,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    ACTIONS(15305), 1,
      anon_sym_LPAREN,
    ACTIONS(15307), 1,
      sym__conid,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(14185), 1,
      sym_constructor,
    STATE(14279), 1,
      sym__pat_constructor,
    STATE(14585), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(14845), 1,
      sym__qcon,
    STATE(15329), 1,
      sym_literal,
    STATE(17328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15326), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110642] = 27,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(12611), 1,
      sym__varid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(12621), 1,
      anon_sym_LPAREN,
    ACTIONS(12626), 1,
      anon_sym_LBRACK,
    ACTIONS(12630), 1,
      anon_sym_AT,
    ACTIONS(12632), 1,
      anon_sym__,
    ACTIONS(12634), 1,
      anon_sym_u27e6,
    ACTIONS(12636), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    ACTIONS(12640), 1,
      sym__strict,
    ACTIONS(12642), 1,
      sym__lazy,
    STATE(353), 1,
      sym__unboxed_open,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(9100), 1,
      sym__pat_constructor,
    STATE(9552), 1,
      sym__qcon,
    STATE(9606), 1,
      sym_variable,
    STATE(9685), 1,
      sym_literal,
    STATE(16840), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12619), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12613), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9679), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110750] = 27,
    ACTIONS(13664), 1,
      sym__varid,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13676), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13680), 1,
      anon_sym_LBRACK,
    ACTIONS(13682), 1,
      anon_sym_AT,
    ACTIONS(13684), 1,
      anon_sym__,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(13692), 1,
      sym__strict,
    ACTIONS(13694), 1,
      sym__lazy,
    STATE(389), 1,
      sym__unboxed_open,
    STATE(9760), 1,
      sym__pat_constructor,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(10118), 1,
      sym__qcon,
    STATE(10120), 1,
      sym_variable,
    STATE(10352), 1,
      sym_literal,
    STATE(17577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13672), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13666), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10313), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110858] = 27,
    ACTIONS(573), 1,
      anon_sym__,
    ACTIONS(593), 1,
      sym__strict,
    ACTIONS(595), 1,
      sym__lazy,
    ACTIONS(12998), 1,
      sym__varid,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13014), 1,
      anon_sym_LBRACK,
    ACTIONS(13016), 1,
      anon_sym_AT,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    ACTIONS(15335), 1,
      anon_sym_LPAREN,
    ACTIONS(15337), 1,
      sym__conid,
    STATE(280), 1,
      sym__unboxed_open,
    STATE(13783), 1,
      sym_constructor,
    STATE(13799), 1,
      sym__pat_constructor,
    STATE(13922), 1,
      sym__qcon,
    STATE(14057), 1,
      sym_variable,
    STATE(14079), 1,
      sym_qualified_constructor,
    STATE(14243), 1,
      sym_literal,
    STATE(17327), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13006), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13000), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14286), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14540), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [110966] = 27,
    ACTIONS(12059), 1,
      sym__varid,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(12069), 1,
      anon_sym_LPAREN,
    ACTIONS(12074), 1,
      anon_sym_LBRACK,
    ACTIONS(12078), 1,
      anon_sym_AT,
    ACTIONS(12080), 1,
      anon_sym__,
    ACTIONS(12082), 1,
      anon_sym_u27e6,
    ACTIONS(12084), 1,
      sym__splice_dollar,
    ACTIONS(12086), 1,
      sym_quasiquote_start,
    ACTIONS(12088), 1,
      sym__strict,
    ACTIONS(12090), 1,
      sym__lazy,
    ACTIONS(13173), 1,
      sym__conid,
    STATE(387), 1,
      sym__unboxed_open,
    STATE(8797), 1,
      sym_constructor,
    STATE(8858), 1,
      sym__pat_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(9271), 1,
      sym_variable,
    STATE(9381), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12067), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9378), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111074] = 27,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(11342), 1,
      sym__varid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(11352), 1,
      anon_sym_LPAREN,
    ACTIONS(11357), 1,
      anon_sym_LBRACK,
    ACTIONS(11361), 1,
      anon_sym_AT,
    ACTIONS(11363), 1,
      anon_sym__,
    ACTIONS(11365), 1,
      anon_sym_u27e6,
    ACTIONS(11367), 1,
      sym__splice_dollar,
    ACTIONS(11369), 1,
      sym_quasiquote_start,
    ACTIONS(11371), 1,
      sym__strict,
    ACTIONS(11373), 1,
      sym__lazy,
    STATE(311), 1,
      sym__unboxed_open,
    STATE(8555), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(8868), 1,
      sym__qcon,
    STATE(9208), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11350), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11344), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9046), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9225), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111182] = 27,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(11342), 1,
      sym__varid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(11352), 1,
      anon_sym_LPAREN,
    ACTIONS(11357), 1,
      anon_sym_LBRACK,
    ACTIONS(11361), 1,
      anon_sym_AT,
    ACTIONS(11363), 1,
      anon_sym__,
    ACTIONS(11365), 1,
      anon_sym_u27e6,
    ACTIONS(11367), 1,
      sym__splice_dollar,
    ACTIONS(11369), 1,
      sym_quasiquote_start,
    ACTIONS(11371), 1,
      sym__strict,
    ACTIONS(11373), 1,
      sym__lazy,
    STATE(311), 1,
      sym__unboxed_open,
    STATE(8555), 1,
      sym__pat_constructor,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(8868), 1,
      sym__qcon,
    STATE(9208), 1,
      sym_literal,
    STATE(17720), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11350), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11344), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9046), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9231), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111290] = 27,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9854), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111398] = 27,
    ACTIONS(10986), 1,
      sym__varid,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(10998), 1,
      anon_sym_LPAREN,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11002), 1,
      anon_sym_LBRACK,
    ACTIONS(11004), 1,
      anon_sym_AT,
    ACTIONS(11006), 1,
      anon_sym__,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(11014), 1,
      sym__strict,
    ACTIONS(11016), 1,
      sym__lazy,
    STATE(402), 1,
      sym__unboxed_open,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(9063), 1,
      sym__pat_constructor,
    STATE(9398), 1,
      sym__qcon,
    STATE(9403), 1,
      sym_variable,
    STATE(9805), 1,
      sym_literal,
    STATE(16482), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10994), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10988), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9855), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111506] = 27,
    ACTIONS(12059), 1,
      sym__varid,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(12069), 1,
      anon_sym_LPAREN,
    ACTIONS(12074), 1,
      anon_sym_LBRACK,
    ACTIONS(12078), 1,
      anon_sym_AT,
    ACTIONS(12080), 1,
      anon_sym__,
    ACTIONS(12082), 1,
      anon_sym_u27e6,
    ACTIONS(12084), 1,
      sym__splice_dollar,
    ACTIONS(12086), 1,
      sym_quasiquote_start,
    ACTIONS(12088), 1,
      sym__strict,
    ACTIONS(12090), 1,
      sym__lazy,
    ACTIONS(13173), 1,
      sym__conid,
    STATE(387), 1,
      sym__unboxed_open,
    STATE(8797), 1,
      sym_constructor,
    STATE(8858), 1,
      sym__pat_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(8946), 1,
      sym__qcon,
    STATE(9271), 1,
      sym_variable,
    STATE(9381), 1,
      sym_literal,
    STATE(16637), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12067), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9379), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111614] = 27,
    ACTIONS(12966), 1,
      sym__varid,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12982), 1,
      anon_sym_LBRACK,
    ACTIONS(12984), 1,
      anon_sym_AT,
    ACTIONS(12986), 1,
      anon_sym__,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(12994), 1,
      sym__strict,
    ACTIONS(12996), 1,
      sym__lazy,
    ACTIONS(15305), 1,
      anon_sym_LPAREN,
    ACTIONS(15307), 1,
      sym__conid,
    STATE(403), 1,
      sym__unboxed_open,
    STATE(14185), 1,
      sym_constructor,
    STATE(14279), 1,
      sym__pat_constructor,
    STATE(14585), 1,
      sym_qualified_constructor,
    STATE(14640), 1,
      sym_variable,
    STATE(14845), 1,
      sym__qcon,
    STATE(15329), 1,
      sym_literal,
    STATE(17328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15002), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15325), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111722] = 27,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(15331), 1,
      anon_sym_LPAREN,
    ACTIONS(15333), 1,
      sym__conid,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(13873), 1,
      sym__pat_constructor,
    STATE(13919), 1,
      sym_constructor,
    STATE(14183), 1,
      sym_variable,
    STATE(14427), 1,
      sym_qualified_constructor,
    STATE(14439), 1,
      sym__qcon,
    STATE(14592), 1,
      sym_literal,
    STATE(16989), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14941), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111830] = 27,
    ACTIONS(10810), 1,
      sym__varid,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(10820), 1,
      anon_sym_LPAREN,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10829), 1,
      anon_sym_AT,
    ACTIONS(10831), 1,
      anon_sym__,
    ACTIONS(10833), 1,
      anon_sym_u27e6,
    ACTIONS(10835), 1,
      sym__splice_dollar,
    ACTIONS(10837), 1,
      sym_quasiquote_start,
    ACTIONS(10839), 1,
      sym__strict,
    ACTIONS(10841), 1,
      sym__lazy,
    ACTIONS(13012), 1,
      sym__conid,
    STATE(384), 1,
      sym__unboxed_open,
    STATE(8454), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8499), 1,
      sym_variable,
    STATE(8502), 1,
      sym__qcon,
    STATE(8809), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10818), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10812), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8866), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [111938] = 27,
    ACTIONS(1410), 1,
      anon_sym__,
    ACTIONS(1428), 1,
      sym__strict,
    ACTIONS(1430), 1,
      sym__lazy,
    ACTIONS(13024), 1,
      sym__varid,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13040), 1,
      anon_sym_LBRACK,
    ACTIONS(13042), 1,
      anon_sym_AT,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    ACTIONS(15309), 1,
      anon_sym_LPAREN,
    ACTIONS(15311), 1,
      sym__conid,
    STATE(320), 1,
      sym__unboxed_open,
    STATE(13885), 1,
      sym_constructor,
    STATE(14088), 1,
      sym__pat_constructor,
    STATE(14135), 1,
      sym_variable,
    STATE(14182), 1,
      sym__qcon,
    STATE(14417), 1,
      sym_qualified_constructor,
    STATE(14895), 1,
      sym_literal,
    STATE(17314), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13032), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13026), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14805), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14819), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [112046] = 27,
    ACTIONS(13082), 1,
      sym__varid,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13098), 1,
      anon_sym_LBRACK,
    ACTIONS(13100), 1,
      anon_sym_AT,
    ACTIONS(13102), 1,
      anon_sym__,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(13110), 1,
      sym__strict,
    ACTIONS(13112), 1,
      sym__lazy,
    ACTIONS(15319), 1,
      anon_sym_LPAREN,
    ACTIONS(15321), 1,
      sym__conid,
    STATE(314), 1,
      sym__unboxed_open,
    STATE(14298), 1,
      sym__pat_constructor,
    STATE(14303), 1,
      sym_constructor,
    STATE(14575), 1,
      sym__qcon,
    STATE(14598), 1,
      sym_variable,
    STATE(14603), 1,
      sym_qualified_constructor,
    STATE(15257), 1,
      sym_literal,
    STATE(16703), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13090), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13084), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15501), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [112154] = 27,
    ACTIONS(10848), 1,
      sym__varid,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10870), 1,
      anon_sym_AT,
    ACTIONS(10872), 1,
      anon_sym__,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(10880), 1,
      sym__strict,
    ACTIONS(10882), 1,
      sym__lazy,
    ACTIONS(15331), 1,
      anon_sym_LPAREN,
    ACTIONS(15333), 1,
      sym__conid,
    STATE(312), 1,
      sym__unboxed_open,
    STATE(13873), 1,
      sym__pat_constructor,
    STATE(13919), 1,
      sym_constructor,
    STATE(14183), 1,
      sym_variable,
    STATE(14427), 1,
      sym_qualified_constructor,
    STATE(14439), 1,
      sym__qcon,
    STATE(14592), 1,
      sym_literal,
    STATE(16989), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10858), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10852), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14651), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14746), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [112262] = 27,
    ACTIONS(10810), 1,
      sym__varid,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(10820), 1,
      anon_sym_LPAREN,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10829), 1,
      anon_sym_AT,
    ACTIONS(10831), 1,
      anon_sym__,
    ACTIONS(10833), 1,
      anon_sym_u27e6,
    ACTIONS(10835), 1,
      sym__splice_dollar,
    ACTIONS(10837), 1,
      sym_quasiquote_start,
    ACTIONS(10839), 1,
      sym__strict,
    ACTIONS(10841), 1,
      sym__lazy,
    ACTIONS(13012), 1,
      sym__conid,
    STATE(384), 1,
      sym__unboxed_open,
    STATE(8454), 1,
      sym__pat_constructor,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(8499), 1,
      sym_variable,
    STATE(8502), 1,
      sym__qcon,
    STATE(8809), 1,
      sym_literal,
    STATE(17592), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10818), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10812), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8867), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [112370] = 27,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(10587), 1,
      sym__varid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(10597), 1,
      anon_sym_LPAREN,
    ACTIONS(10602), 1,
      anon_sym_LBRACK,
    ACTIONS(10606), 1,
      anon_sym_AT,
    ACTIONS(10608), 1,
      anon_sym__,
    ACTIONS(10610), 1,
      anon_sym_u27e6,
    ACTIONS(10612), 1,
      sym__splice_dollar,
    ACTIONS(10614), 1,
      sym_quasiquote_start,
    ACTIONS(10616), 1,
      sym__strict,
    ACTIONS(10618), 1,
      sym__lazy,
    STATE(431), 1,
      sym__unboxed_open,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(8295), 1,
      sym__pat_constructor,
    STATE(8371), 1,
      sym__qcon,
    STATE(8376), 1,
      sym_variable,
    STATE(8592), 1,
      sym_literal,
    STATE(16455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10595), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8675), 15,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_type_binder,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [112478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [112537] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [112598] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [112659] = 22,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(15351), 1,
      sym__integer_literal,
    ACTIONS(15357), 1,
      anon_sym_LPAREN,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(15361), 1,
      anon_sym_LBRACK,
    ACTIONS(15363), 1,
      anon_sym_SQUOTE,
    ACTIONS(15365), 1,
      anon_sym_LBRACE,
    ACTIONS(15369), 1,
      anon_sym_u27e6,
    ACTIONS(15371), 1,
      sym__splice_dollar,
    ACTIONS(15373), 1,
      sym_quasiquote_start,
    STATE(2089), 1,
      sym__unboxed_open,
    STATE(15918), 1,
      sym_constructor,
    STATE(17427), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15355), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15367), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15349), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15353), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17557), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(17580), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16993), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym__record_field,
      sym_splice,
      sym_quasiquote,
  [112756] = 22,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(15379), 1,
      sym__integer_literal,
    ACTIONS(15385), 1,
      anon_sym_LPAREN,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(15389), 1,
      anon_sym_LBRACK,
    ACTIONS(15391), 1,
      anon_sym_SQUOTE,
    ACTIONS(15393), 1,
      anon_sym_LBRACE,
    ACTIONS(15397), 1,
      anon_sym_u27e6,
    ACTIONS(15399), 1,
      sym__splice_dollar,
    ACTIONS(15401), 1,
      sym_quasiquote_start,
    STATE(2080), 1,
      sym__unboxed_open,
    STATE(14929), 1,
      sym_constructor,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15395), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15096), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15092), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(19284), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym__record_field,
      sym_splice,
      sym_quasiquote,
  [112853] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [112914] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [112975] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113036] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113097] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113158] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113219] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113280] = 22,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(15421), 1,
      sym__integer_literal,
    ACTIONS(15427), 1,
      anon_sym_LPAREN,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(15431), 1,
      anon_sym_LBRACK,
    ACTIONS(15433), 1,
      anon_sym_SQUOTE,
    ACTIONS(15435), 1,
      anon_sym_LBRACE,
    ACTIONS(15439), 1,
      anon_sym_u27e6,
    ACTIONS(15441), 1,
      sym__splice_dollar,
    ACTIONS(15443), 1,
      sym_quasiquote_start,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(14469), 1,
      sym_constructor,
    STATE(16910), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15425), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15437), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15419), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15423), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14675), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(17669), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym__record_field,
      sym_splice,
      sym_quasiquote,
  [113377] = 22,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    STATE(21873), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3550), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [113474] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113535] = 16,
    ACTIONS(15459), 1,
      sym__conid,
    ACTIONS(15468), 1,
      anon_sym__,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(15082), 1,
      aux_sym_signature_repeat1,
    STATE(20054), 1,
      sym__type_annotation,
    ACTIONS(15453), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15465), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15474), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(15456), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15463), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15450), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [113620] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 36,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113799] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [113860] = 16,
    ACTIONS(15459), 1,
      sym__conid,
    ACTIONS(15468), 1,
      anon_sym__,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2463), 1,
      sym__colon2,
    STATE(15593), 1,
      aux_sym_signature_repeat1,
    STATE(18064), 1,
      sym__type_annotation,
    ACTIONS(15465), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15474), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(15476), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(15456), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15463), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15450), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [113945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114003] = 6,
    ACTIONS(15487), 1,
      anon_sym_LBRACE,
    ACTIONS(15490), 1,
      sym__layout_start,
    STATE(4112), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 14,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114183] = 4,
    ACTIONS(237), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 23,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
      anon_sym_foreign,
    ACTIONS(15498), 23,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      sym_decl_special_fun_fixity,
      anon_sym_u27e6,
  [114243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114417] = 15,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(15526), 1,
      sym__conid,
    ACTIONS(15535), 1,
      anon_sym__,
    STATE(2453), 1,
      sym__colon2,
    STATE(14974), 1,
      aux_sym_signature_repeat1,
    STATE(20104), 1,
      sym__type_annotation,
    ACTIONS(15520), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15532), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15537), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(15512), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15530), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15517), 13,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [114499] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114731] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [114963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115021] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115311] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115543] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115659] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115717] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115775] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115833] = 4,
    ACTIONS(227), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 23,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
      anon_sym_foreign,
    ACTIONS(15498), 23,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      sym_decl_special_fun_fixity,
      anon_sym_u27e6,
  [115893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [115951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116241] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116415] = 16,
    ACTIONS(15459), 1,
      sym__conid,
    ACTIONS(15468), 1,
      anon_sym__,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(15571), 1,
      aux_sym_signature_repeat1,
    STATE(20848), 1,
      sym__type_annotation,
    ACTIONS(15465), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15474), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(15619), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(15456), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15448), 7,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15463), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15450), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [116499] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116731] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [116963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117021] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117137] = 15,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(15526), 1,
      sym__conid,
    ACTIONS(15535), 1,
      anon_sym__,
    STATE(2463), 1,
      sym__colon2,
    STATE(15229), 1,
      aux_sym_signature_repeat1,
    STATE(18497), 1,
      sym__type_annotation,
    ACTIONS(15532), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15537), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(15638), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15512), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15530), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15517), 13,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [117219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117393] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117509] = 4,
    ACTIONS(15641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 23,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
      anon_sym_foreign,
    ACTIONS(15498), 23,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      sym_decl_special_fun_fixity,
      anon_sym_u27e6,
  [117569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117801] = 4,
    ACTIONS(163), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 23,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
      anon_sym_foreign,
    ACTIONS(15498), 23,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      sym_decl_special_fun_fixity,
      anon_sym_u27e6,
  [117861] = 5,
    ACTIONS(15649), 1,
      anon_sym_SEMI,
    STATE(3810), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15652), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      sym_decl_special_fun_fixity,
      anon_sym_u27e6,
    ACTIONS(15647), 23,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
      anon_sym_foreign,
  [117923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [117981] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118213] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118271] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118329] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118619] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118735] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [118906] = 21,
    ACTIONS(6438), 1,
      sym__varid,
    ACTIONS(6442), 1,
      sym__integer_literal,
    ACTIONS(6448), 1,
      anon_sym_LPAREN,
    ACTIONS(6453), 1,
      anon_sym_LBRACK,
    ACTIONS(6462), 1,
      anon_sym_u27e6,
    ACTIONS(6464), 1,
      sym__splice_dollar,
    ACTIONS(6466), 1,
      sym_quasiquote_start,
    ACTIONS(8351), 1,
      sym__conid,
    ACTIONS(8353), 1,
      anon_sym_SQUOTE,
    STATE(2105), 1,
      sym__unboxed_open,
    STATE(6283), 1,
      sym_constructor,
    STATE(16697), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6458), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6334), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6336), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6477), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [118999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119113] = 21,
    ACTIONS(7419), 1,
      sym__integer_literal,
    ACTIONS(7429), 1,
      sym__conid,
    ACTIONS(7431), 1,
      anon_sym_LBRACK,
    ACTIONS(7433), 1,
      anon_sym_SQUOTE,
    ACTIONS(7437), 1,
      anon_sym_u27e6,
    ACTIONS(7439), 1,
      sym__splice_dollar,
    ACTIONS(7441), 1,
      sym_quasiquote_start,
    ACTIONS(10146), 1,
      sym__varid,
    ACTIONS(10148), 1,
      anon_sym_LPAREN,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7599), 1,
      sym_constructor,
    STATE(16252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7423), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7435), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7417), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7421), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8078), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8073), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7956), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [119206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119320] = 21,
    ACTIONS(4679), 1,
      sym__integer_literal,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(4703), 1,
      anon_sym_u27e6,
    ACTIONS(4705), 1,
      sym__splice_dollar,
    ACTIONS(4707), 1,
      sym_quasiquote_start,
    ACTIONS(15678), 1,
      sym__varid,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_SQUOTE,
    STATE(2078), 1,
      sym__unboxed_open,
    STATE(11201), 1,
      sym_constructor,
    STATE(17073), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15682), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15690), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4681), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15680), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12037), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12717), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [119413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119527] = 21,
    ACTIONS(4679), 1,
      sym__integer_literal,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(4703), 1,
      anon_sym_u27e6,
    ACTIONS(4705), 1,
      sym__splice_dollar,
    ACTIONS(4707), 1,
      sym_quasiquote_start,
    ACTIONS(15678), 1,
      sym__varid,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_SQUOTE,
    STATE(2078), 1,
      sym__unboxed_open,
    STATE(11201), 1,
      sym_constructor,
    STATE(17073), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15682), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15690), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4681), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15680), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12037), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11621), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [119620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119734] = 21,
    ACTIONS(243), 1,
      sym__integer_literal,
    ACTIONS(281), 1,
      anon_sym_u27e6,
    ACTIONS(283), 1,
      sym__splice_dollar,
    ACTIONS(291), 1,
      sym_quasiquote_start,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(15704), 1,
      sym__varid,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    ACTIONS(15712), 1,
      anon_sym_LBRACK,
    ACTIONS(15714), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(4121), 1,
      sym_constructor,
    STATE(17456), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15708), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15716), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(245), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15706), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4178), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4190), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4794), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [119827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [119998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120055] = 21,
    ACTIONS(15730), 1,
      sym__varid,
    ACTIONS(15734), 1,
      sym__integer_literal,
    ACTIONS(15740), 1,
      anon_sym_LPAREN,
    ACTIONS(15742), 1,
      sym__conid,
    ACTIONS(15744), 1,
      anon_sym_LBRACK,
    ACTIONS(15746), 1,
      anon_sym_SQUOTE,
    ACTIONS(15750), 1,
      anon_sym_u27e6,
    ACTIONS(15752), 1,
      sym__splice_dollar,
    ACTIONS(15754), 1,
      sym_quasiquote_start,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(15192), 1,
      sym_constructor,
    STATE(17823), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15738), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15748), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15732), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15736), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16009), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15757), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [120148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120205] = 21,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(15379), 1,
      sym__integer_literal,
    ACTIONS(15385), 1,
      anon_sym_LPAREN,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(15389), 1,
      anon_sym_LBRACK,
    ACTIONS(15391), 1,
      anon_sym_SQUOTE,
    ACTIONS(15397), 1,
      anon_sym_u27e6,
    ACTIONS(15399), 1,
      sym__splice_dollar,
    ACTIONS(15401), 1,
      sym_quasiquote_start,
    STATE(2080), 1,
      sym__unboxed_open,
    STATE(14929), 1,
      sym_constructor,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15395), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15096), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15092), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(21228), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [120298] = 21,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(71), 1,
      anon_sym_u27e6,
    ACTIONS(73), 1,
      sym__splice_dollar,
    ACTIONS(75), 1,
      sym_quasiquote_start,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(15760), 1,
      sym__varid,
    ACTIONS(15766), 1,
      anon_sym_LPAREN,
    ACTIONS(15768), 1,
      anon_sym_LBRACK,
    ACTIONS(15770), 1,
      anon_sym_SQUOTE,
    STATE(2111), 1,
      sym__unboxed_open,
    STATE(4690), 1,
      sym_constructor,
    STATE(17373), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15764), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15772), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5063), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5068), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5545), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [120391] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120562] = 21,
    ACTIONS(243), 1,
      sym__integer_literal,
    ACTIONS(281), 1,
      anon_sym_u27e6,
    ACTIONS(283), 1,
      sym__splice_dollar,
    ACTIONS(291), 1,
      sym_quasiquote_start,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(15704), 1,
      sym__varid,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    ACTIONS(15712), 1,
      anon_sym_LBRACK,
    ACTIONS(15714), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(4121), 1,
      sym_constructor,
    STATE(17456), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15708), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15716), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(245), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15706), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4178), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4190), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4560), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [120655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120712] = 21,
    ACTIONS(3095), 1,
      sym__integer_literal,
    ACTIONS(3113), 1,
      anon_sym_u27e6,
    ACTIONS(3115), 1,
      sym__splice_dollar,
    ACTIONS(3117), 1,
      sym_quasiquote_start,
    ACTIONS(4491), 1,
      sym__conid,
    ACTIONS(15786), 1,
      sym__varid,
    ACTIONS(15792), 1,
      anon_sym_LPAREN,
    ACTIONS(15794), 1,
      anon_sym_LBRACK,
    ACTIONS(15796), 1,
      anon_sym_SQUOTE,
    STATE(2100), 1,
      sym__unboxed_open,
    STATE(5509), 1,
      sym_constructor,
    STATE(17001), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15790), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15798), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3097), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6162), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6152), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6210), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [120805] = 21,
    ACTIONS(4543), 1,
      sym__integer_literal,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(4567), 1,
      anon_sym_u27e6,
    ACTIONS(4569), 1,
      sym__splice_dollar,
    ACTIONS(4571), 1,
      sym_quasiquote_start,
    ACTIONS(15800), 1,
      sym__varid,
    ACTIONS(15806), 1,
      anon_sym_LPAREN,
    ACTIONS(15808), 1,
      anon_sym_LBRACK,
    ACTIONS(15810), 1,
      anon_sym_SQUOTE,
    STATE(2066), 1,
      sym__unboxed_open,
    STATE(11736), 1,
      sym_constructor,
    STATE(16503), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15804), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15812), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4545), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15802), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12180), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12179), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12903), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [120898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [120955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [121012] = 21,
    ACTIONS(8792), 1,
      sym__integer_literal,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(8804), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_SQUOTE,
    ACTIONS(8810), 1,
      anon_sym_u27e6,
    ACTIONS(8812), 1,
      sym__splice_dollar,
    ACTIONS(8814), 1,
      sym_quasiquote_start,
    ACTIONS(9186), 1,
      sym__varid,
    ACTIONS(9188), 1,
      anon_sym_LPAREN,
    STATE(2131), 1,
      sym__unboxed_open,
    STATE(7510), 1,
      sym_constructor,
    STATE(16491), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8796), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8808), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8790), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8794), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7791), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7753), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7873), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [121162] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [121219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [121276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [121333] = 21,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(13104), 1,
      anon_sym_u27e6,
    ACTIONS(13106), 1,
      sym__splice_dollar,
    ACTIONS(13108), 1,
      sym_quasiquote_start,
    ACTIONS(15321), 1,
      sym__conid,
    ACTIONS(15834), 1,
      sym__varid,
    ACTIONS(15840), 1,
      anon_sym_LPAREN,
    ACTIONS(15842), 1,
      anon_sym_LBRACK,
    ACTIONS(15844), 1,
      anon_sym_SQUOTE,
    STATE(2108), 1,
      sym__unboxed_open,
    STATE(14812), 1,
      sym_constructor,
    STATE(16453), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15838), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15846), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15836), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15498), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15533), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15372), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121426] = 21,
    ACTIONS(1387), 1,
      sym__integer_literal,
    ACTIONS(1422), 1,
      anon_sym_u27e6,
    ACTIONS(1424), 1,
      sym__splice_dollar,
    ACTIONS(1426), 1,
      sym_quasiquote_start,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(15848), 1,
      sym__varid,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_SQUOTE,
    STATE(2176), 1,
      sym__unboxed_open,
    STATE(5231), 1,
      sym_constructor,
    STATE(16935), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15852), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15860), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1389), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15850), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5413), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5412), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6106), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121519] = 21,
    ACTIONS(9852), 1,
      sym__integer_literal,
    ACTIONS(9862), 1,
      sym__conid,
    ACTIONS(9876), 1,
      anon_sym_u27e6,
    ACTIONS(9878), 1,
      sym__splice_dollar,
    ACTIONS(9880), 1,
      sym_quasiquote_start,
    ACTIONS(15862), 1,
      sym__varid,
    ACTIONS(15868), 1,
      anon_sym_LPAREN,
    ACTIONS(15870), 1,
      anon_sym_LBRACK,
    ACTIONS(15872), 1,
      anon_sym_SQUOTE,
    STATE(2209), 1,
      sym__unboxed_open,
    STATE(11549), 1,
      sym_constructor,
    STATE(16590), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15866), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15874), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9854), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15864), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12346), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12341), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12328), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121612] = 21,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(15379), 1,
      sym__integer_literal,
    ACTIONS(15385), 1,
      anon_sym_LPAREN,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(15389), 1,
      anon_sym_LBRACK,
    ACTIONS(15391), 1,
      anon_sym_SQUOTE,
    ACTIONS(15397), 1,
      anon_sym_u27e6,
    ACTIONS(15399), 1,
      sym__splice_dollar,
    ACTIONS(15401), 1,
      sym_quasiquote_start,
    STATE(2080), 1,
      sym__unboxed_open,
    STATE(14929), 1,
      sym_constructor,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15395), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15096), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15092), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16060), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [121762] = 21,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(15379), 1,
      sym__integer_literal,
    ACTIONS(15385), 1,
      anon_sym_LPAREN,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(15389), 1,
      anon_sym_LBRACK,
    ACTIONS(15391), 1,
      anon_sym_SQUOTE,
    ACTIONS(15397), 1,
      anon_sym_u27e6,
    ACTIONS(15399), 1,
      sym__splice_dollar,
    ACTIONS(15401), 1,
      sym_quasiquote_start,
    STATE(2080), 1,
      sym__unboxed_open,
    STATE(14929), 1,
      sym_constructor,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15395), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15096), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15092), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16050), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121855] = 21,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(10874), 1,
      anon_sym_u27e6,
    ACTIONS(10876), 1,
      sym__splice_dollar,
    ACTIONS(10878), 1,
      sym_quasiquote_start,
    ACTIONS(15333), 1,
      sym__conid,
    ACTIONS(15880), 1,
      sym__varid,
    ACTIONS(15886), 1,
      anon_sym_LPAREN,
    ACTIONS(15888), 1,
      anon_sym_LBRACK,
    ACTIONS(15890), 1,
      anon_sym_SQUOTE,
    STATE(2064), 1,
      sym__unboxed_open,
    STATE(14517), 1,
      sym_constructor,
    STATE(16561), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15884), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15892), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15882), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14580), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14560), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14584), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [121948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [122005] = 21,
    ACTIONS(15730), 1,
      sym__varid,
    ACTIONS(15734), 1,
      sym__integer_literal,
    ACTIONS(15740), 1,
      anon_sym_LPAREN,
    ACTIONS(15742), 1,
      sym__conid,
    ACTIONS(15744), 1,
      anon_sym_LBRACK,
    ACTIONS(15746), 1,
      anon_sym_SQUOTE,
    ACTIONS(15750), 1,
      anon_sym_u27e6,
    ACTIONS(15752), 1,
      sym__splice_dollar,
    ACTIONS(15754), 1,
      sym_quasiquote_start,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(15192), 1,
      sym_constructor,
    STATE(17823), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15738), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15748), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15732), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15736), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16009), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15760), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122098] = 21,
    ACTIONS(4679), 1,
      sym__integer_literal,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(4703), 1,
      anon_sym_u27e6,
    ACTIONS(4705), 1,
      sym__splice_dollar,
    ACTIONS(4707), 1,
      sym_quasiquote_start,
    ACTIONS(15678), 1,
      sym__varid,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_SQUOTE,
    STATE(2078), 1,
      sym__unboxed_open,
    STATE(11201), 1,
      sym_constructor,
    STATE(17073), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15682), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15690), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4681), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15680), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12037), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12536), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122191] = 21,
    ACTIONS(1387), 1,
      sym__integer_literal,
    ACTIONS(1422), 1,
      anon_sym_u27e6,
    ACTIONS(1424), 1,
      sym__splice_dollar,
    ACTIONS(1426), 1,
      sym_quasiquote_start,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(15848), 1,
      sym__varid,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_SQUOTE,
    STATE(2176), 1,
      sym__unboxed_open,
    STATE(5231), 1,
      sym_constructor,
    STATE(16935), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15852), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15860), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1389), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15850), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5413), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5412), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5469), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [122341] = 4,
    ACTIONS(15906), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [122400] = 21,
    ACTIONS(9380), 1,
      sym__integer_literal,
    ACTIONS(9390), 1,
      sym__conid,
    ACTIONS(9404), 1,
      anon_sym_u27e6,
    ACTIONS(9406), 1,
      sym__splice_dollar,
    ACTIONS(9408), 1,
      sym_quasiquote_start,
    ACTIONS(15908), 1,
      sym__varid,
    ACTIONS(15914), 1,
      anon_sym_LPAREN,
    ACTIONS(15916), 1,
      anon_sym_LBRACK,
    ACTIONS(15918), 1,
      anon_sym_SQUOTE,
    STATE(2075), 1,
      sym__unboxed_open,
    STATE(11121), 1,
      sym_constructor,
    STATE(17722), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15912), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15920), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9382), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15910), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11316), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11389), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122493] = 21,
    ACTIONS(659), 1,
      sym__integer_literal,
    ACTIONS(683), 1,
      anon_sym_u27e6,
    ACTIONS(685), 1,
      sym__splice_dollar,
    ACTIONS(687), 1,
      sym_quasiquote_start,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(15922), 1,
      sym__varid,
    ACTIONS(15928), 1,
      anon_sym_LPAREN,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(15932), 1,
      anon_sym_SQUOTE,
    STATE(2103), 1,
      sym__unboxed_open,
    STATE(3731), 1,
      sym_constructor,
    STATE(16976), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15926), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15934), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(661), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15924), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3792), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(3763), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5915), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122586] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [122645] = 21,
    ACTIONS(6210), 1,
      sym__integer_literal,
    ACTIONS(6220), 1,
      sym__conid,
    ACTIONS(6222), 1,
      anon_sym_LBRACK,
    ACTIONS(6224), 1,
      anon_sym_SQUOTE,
    ACTIONS(6230), 1,
      anon_sym_u27e6,
    ACTIONS(6232), 1,
      sym__splice_dollar,
    ACTIONS(6234), 1,
      sym_quasiquote_start,
    ACTIONS(10507), 1,
      sym__varid,
    ACTIONS(10509), 1,
      anon_sym_LPAREN,
    STATE(2202), 1,
      sym__unboxed_open,
    STATE(7638), 1,
      sym_constructor,
    STATE(17453), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6214), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6208), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6212), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8165), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8053), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7951), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122738] = 21,
    ACTIONS(9614), 1,
      sym__integer_literal,
    ACTIONS(9622), 1,
      sym__conid,
    ACTIONS(9628), 1,
      anon_sym_u27e6,
    ACTIONS(9630), 1,
      sym__splice_dollar,
    ACTIONS(9632), 1,
      sym_quasiquote_start,
    ACTIONS(15936), 1,
      sym__varid,
    ACTIONS(15942), 1,
      anon_sym_LPAREN,
    ACTIONS(15944), 1,
      anon_sym_LBRACK,
    ACTIONS(15946), 1,
      anon_sym_SQUOTE,
    STATE(2190), 1,
      sym__unboxed_open,
    STATE(12173), 1,
      sym_constructor,
    STATE(17278), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15940), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15948), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9616), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15938), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12928), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(13056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13062), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122831] = 21,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(10968), 1,
      anon_sym_u27e6,
    ACTIONS(10970), 1,
      sym__splice_dollar,
    ACTIONS(10972), 1,
      sym_quasiquote_start,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(15950), 1,
      sym__varid,
    ACTIONS(15956), 1,
      anon_sym_LPAREN,
    ACTIONS(15958), 1,
      anon_sym_LBRACK,
    ACTIONS(15960), 1,
      anon_sym_SQUOTE,
    STATE(2165), 1,
      sym__unboxed_open,
    STATE(8720), 1,
      sym_constructor,
    STATE(16830), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15954), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15962), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15952), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8960), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8959), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9009), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [122924] = 21,
    ACTIONS(7337), 1,
      sym__varid,
    ACTIONS(7341), 1,
      sym__integer_literal,
    ACTIONS(7347), 1,
      anon_sym_LPAREN,
    ACTIONS(7352), 1,
      anon_sym_LBRACK,
    ACTIONS(7361), 1,
      anon_sym_u27e6,
    ACTIONS(7363), 1,
      sym__splice_dollar,
    ACTIONS(7365), 1,
      sym_quasiquote_start,
    ACTIONS(7901), 1,
      sym__conid,
    ACTIONS(7903), 1,
      anon_sym_SQUOTE,
    STATE(2062), 1,
      sym__unboxed_open,
    STATE(6304), 1,
      sym_constructor,
    STATE(17711), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7345), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7357), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7339), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7343), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6770), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6773), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6666), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123017] = 21,
    ACTIONS(2115), 1,
      sym__integer_literal,
    ACTIONS(2146), 1,
      anon_sym_u27e6,
    ACTIONS(2148), 1,
      sym__splice_dollar,
    ACTIONS(2150), 1,
      sym_quasiquote_start,
    ACTIONS(4617), 1,
      sym__conid,
    ACTIONS(15964), 1,
      sym__varid,
    ACTIONS(15970), 1,
      anon_sym_LPAREN,
    ACTIONS(15972), 1,
      anon_sym_LBRACK,
    ACTIONS(15974), 1,
      anon_sym_SQUOTE,
    STATE(2186), 1,
      sym__unboxed_open,
    STATE(4437), 1,
      sym_constructor,
    STATE(17605), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15968), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15976), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15966), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4614), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4598), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4846), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123110] = 21,
    ACTIONS(9380), 1,
      sym__integer_literal,
    ACTIONS(9390), 1,
      sym__conid,
    ACTIONS(9404), 1,
      anon_sym_u27e6,
    ACTIONS(9406), 1,
      sym__splice_dollar,
    ACTIONS(9408), 1,
      sym_quasiquote_start,
    ACTIONS(15908), 1,
      sym__varid,
    ACTIONS(15914), 1,
      anon_sym_LPAREN,
    ACTIONS(15916), 1,
      anon_sym_LBRACK,
    ACTIONS(15918), 1,
      anon_sym_SQUOTE,
    STATE(2075), 1,
      sym__unboxed_open,
    STATE(11121), 1,
      sym_constructor,
    STATE(17722), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15912), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15920), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9382), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15910), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11316), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11665), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123203] = 21,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(13044), 1,
      anon_sym_u27e6,
    ACTIONS(13046), 1,
      sym__splice_dollar,
    ACTIONS(13048), 1,
      sym_quasiquote_start,
    ACTIONS(15311), 1,
      sym__conid,
    ACTIONS(15978), 1,
      sym__varid,
    ACTIONS(15984), 1,
      anon_sym_LPAREN,
    ACTIONS(15986), 1,
      anon_sym_LBRACK,
    ACTIONS(15988), 1,
      anon_sym_SQUOTE,
    STATE(2071), 1,
      sym__unboxed_open,
    STATE(14511), 1,
      sym_constructor,
    STATE(16497), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15982), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15990), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15980), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14600), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14595), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14910), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123296] = 21,
    ACTIONS(15992), 1,
      sym__varid,
    ACTIONS(15996), 1,
      sym__integer_literal,
    ACTIONS(16002), 1,
      anon_sym_LPAREN,
    ACTIONS(16004), 1,
      sym__conid,
    ACTIONS(16006), 1,
      anon_sym_LBRACK,
    ACTIONS(16008), 1,
      anon_sym_SQUOTE,
    ACTIONS(16012), 1,
      anon_sym_u27e6,
    ACTIONS(16014), 1,
      sym__splice_dollar,
    ACTIONS(16016), 1,
      sym_quasiquote_start,
    STATE(2175), 1,
      sym__unboxed_open,
    STATE(15816), 1,
      sym_constructor,
    STATE(17826), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16000), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16010), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15994), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15998), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17696), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(17695), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16547), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123389] = 21,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(13686), 1,
      anon_sym_u27e6,
    ACTIONS(13688), 1,
      sym__splice_dollar,
    ACTIONS(13690), 1,
      sym_quasiquote_start,
    ACTIONS(16018), 1,
      sym__varid,
    ACTIONS(16024), 1,
      anon_sym_LPAREN,
    ACTIONS(16026), 1,
      anon_sym_LBRACK,
    ACTIONS(16028), 1,
      anon_sym_SQUOTE,
    STATE(2110), 1,
      sym__unboxed_open,
    STATE(10060), 1,
      sym_constructor,
    STATE(17088), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16022), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16030), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10407), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10334), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10402), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123482] = 21,
    ACTIONS(3567), 1,
      sym__integer_literal,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(3593), 1,
      anon_sym_u27e6,
    ACTIONS(3595), 1,
      sym__splice_dollar,
    ACTIONS(3597), 1,
      sym_quasiquote_start,
    ACTIONS(16032), 1,
      sym__varid,
    ACTIONS(16038), 1,
      anon_sym_LPAREN,
    ACTIONS(16040), 1,
      anon_sym_LBRACK,
    ACTIONS(16042), 1,
      anon_sym_SQUOTE,
    STATE(2200), 1,
      sym__unboxed_open,
    STATE(10629), 1,
      sym_constructor,
    STATE(16927), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16036), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16044), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16034), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10769), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11434), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123575] = 21,
    ACTIONS(6350), 1,
      sym__integer_literal,
    ACTIONS(6356), 1,
      anon_sym_LPAREN,
    ACTIONS(6361), 1,
      anon_sym_LBRACK,
    ACTIONS(6370), 1,
      anon_sym_u27e6,
    ACTIONS(6372), 1,
      sym__splice_dollar,
    ACTIONS(6374), 1,
      sym_quasiquote_start,
    ACTIONS(8293), 1,
      sym__conid,
    ACTIONS(8295), 1,
      anon_sym_SQUOTE,
    ACTIONS(15221), 1,
      sym__varid,
    STATE(2206), 1,
      sym__unboxed_open,
    STATE(6021), 1,
      sym_constructor,
    STATE(17709), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6354), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6366), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6348), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6352), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6534), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6530), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6639), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123668] = 21,
    ACTIONS(9346), 1,
      sym__integer_literal,
    ACTIONS(9356), 1,
      sym__conid,
    ACTIONS(9370), 1,
      anon_sym_u27e6,
    ACTIONS(9372), 1,
      sym__splice_dollar,
    ACTIONS(9374), 1,
      sym_quasiquote_start,
    ACTIONS(16046), 1,
      sym__varid,
    ACTIONS(16052), 1,
      anon_sym_LPAREN,
    ACTIONS(16054), 1,
      anon_sym_LBRACK,
    ACTIONS(16056), 1,
      anon_sym_SQUOTE,
    STATE(2140), 1,
      sym__unboxed_open,
    STATE(11364), 1,
      sym_constructor,
    STATE(17573), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16050), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16058), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16048), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11746), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11748), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12570), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123761] = 21,
    ACTIONS(9346), 1,
      sym__integer_literal,
    ACTIONS(9356), 1,
      sym__conid,
    ACTIONS(9370), 1,
      anon_sym_u27e6,
    ACTIONS(9372), 1,
      sym__splice_dollar,
    ACTIONS(9374), 1,
      sym_quasiquote_start,
    ACTIONS(16046), 1,
      sym__varid,
    ACTIONS(16052), 1,
      anon_sym_LPAREN,
    ACTIONS(16054), 1,
      anon_sym_LBRACK,
    ACTIONS(16056), 1,
      anon_sym_SQUOTE,
    STATE(2140), 1,
      sym__unboxed_open,
    STATE(11364), 1,
      sym_constructor,
    STATE(17573), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16050), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16058), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16048), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11746), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11748), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11977), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123854] = 21,
    ACTIONS(2849), 1,
      sym__integer_literal,
    ACTIONS(2881), 1,
      anon_sym_u27e6,
    ACTIONS(2883), 1,
      sym__splice_dollar,
    ACTIONS(2885), 1,
      sym_quasiquote_start,
    ACTIONS(4607), 1,
      sym__conid,
    ACTIONS(16060), 1,
      sym__varid,
    ACTIONS(16066), 1,
      anon_sym_LPAREN,
    ACTIONS(16068), 1,
      anon_sym_LBRACK,
    ACTIONS(16070), 1,
      anon_sym_SQUOTE,
    STATE(2115), 1,
      sym__unboxed_open,
    STATE(4937), 1,
      sym_constructor,
    STATE(16443), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16064), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16072), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2851), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16062), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5690), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5689), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5811), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [123947] = 21,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(16074), 1,
      sym__varid,
    ACTIONS(16080), 1,
      anon_sym_LPAREN,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(16084), 1,
      anon_sym_SQUOTE,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(10349), 1,
      sym_constructor,
    STATE(16807), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16078), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16086), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16076), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10516), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10574), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14043), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124040] = 21,
    ACTIONS(15992), 1,
      sym__varid,
    ACTIONS(15996), 1,
      sym__integer_literal,
    ACTIONS(16002), 1,
      anon_sym_LPAREN,
    ACTIONS(16004), 1,
      sym__conid,
    ACTIONS(16006), 1,
      anon_sym_LBRACK,
    ACTIONS(16008), 1,
      anon_sym_SQUOTE,
    ACTIONS(16012), 1,
      anon_sym_u27e6,
    ACTIONS(16014), 1,
      sym__splice_dollar,
    ACTIONS(16016), 1,
      sym_quasiquote_start,
    STATE(2175), 1,
      sym__unboxed_open,
    STATE(15816), 1,
      sym_constructor,
    STATE(17826), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16000), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16010), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15994), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15998), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17696), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(17695), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16578), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124133] = 21,
    ACTIONS(8524), 1,
      sym__integer_literal,
    ACTIONS(8534), 1,
      sym__conid,
    ACTIONS(8536), 1,
      anon_sym_LBRACK,
    ACTIONS(8538), 1,
      anon_sym_SQUOTE,
    ACTIONS(8542), 1,
      anon_sym_u27e6,
    ACTIONS(8544), 1,
      sym__splice_dollar,
    ACTIONS(8546), 1,
      sym_quasiquote_start,
    ACTIONS(10664), 1,
      anon_sym_LPAREN,
    ACTIONS(15281), 1,
      sym__varid,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(8160), 1,
      sym_constructor,
    STATE(16417), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8528), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8540), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8522), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8526), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8192), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8229), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124226] = 21,
    ACTIONS(2115), 1,
      sym__integer_literal,
    ACTIONS(2146), 1,
      anon_sym_u27e6,
    ACTIONS(2148), 1,
      sym__splice_dollar,
    ACTIONS(2150), 1,
      sym_quasiquote_start,
    ACTIONS(4617), 1,
      sym__conid,
    ACTIONS(15964), 1,
      sym__varid,
    ACTIONS(15970), 1,
      anon_sym_LPAREN,
    ACTIONS(15972), 1,
      anon_sym_LBRACK,
    ACTIONS(15974), 1,
      anon_sym_SQUOTE,
    STATE(2186), 1,
      sym__unboxed_open,
    STATE(4437), 1,
      sym_constructor,
    STATE(17605), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15968), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15976), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15966), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4614), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4598), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4613), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124319] = 21,
    ACTIONS(6947), 1,
      sym__varid,
    ACTIONS(6951), 1,
      sym__integer_literal,
    ACTIONS(6957), 1,
      anon_sym_LPAREN,
    ACTIONS(6962), 1,
      anon_sym_LBRACK,
    ACTIONS(6971), 1,
      anon_sym_u27e6,
    ACTIONS(6973), 1,
      sym__splice_dollar,
    ACTIONS(6975), 1,
      sym_quasiquote_start,
    ACTIONS(8676), 1,
      sym__conid,
    ACTIONS(8678), 1,
      anon_sym_SQUOTE,
    STATE(2166), 1,
      sym__unboxed_open,
    STATE(6515), 1,
      sym_constructor,
    STATE(17700), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6955), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6967), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6949), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6953), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6843), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6848), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6753), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124412] = 21,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8087), 1,
      anon_sym_LPAREN,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_u27e6,
    ACTIONS(8103), 1,
      sym__splice_dollar,
    ACTIONS(8105), 1,
      sym_quasiquote_start,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(8838), 1,
      anon_sym_SQUOTE,
    ACTIONS(13450), 1,
      sym__varid,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(7002), 1,
      sym_constructor,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8085), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7050), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7171), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124505] = 21,
    ACTIONS(3095), 1,
      sym__integer_literal,
    ACTIONS(3113), 1,
      anon_sym_u27e6,
    ACTIONS(3115), 1,
      sym__splice_dollar,
    ACTIONS(3117), 1,
      sym_quasiquote_start,
    ACTIONS(4491), 1,
      sym__conid,
    ACTIONS(15786), 1,
      sym__varid,
    ACTIONS(15792), 1,
      anon_sym_LPAREN,
    ACTIONS(15794), 1,
      anon_sym_LBRACK,
    ACTIONS(15796), 1,
      anon_sym_SQUOTE,
    STATE(2100), 1,
      sym__unboxed_open,
    STATE(5509), 1,
      sym_constructor,
    STATE(17001), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15790), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15798), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3097), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6162), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6152), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6565), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124598] = 21,
    ACTIONS(1097), 1,
      sym__integer_literal,
    ACTIONS(1117), 1,
      anon_sym_u27e6,
    ACTIONS(1119), 1,
      sym__splice_dollar,
    ACTIONS(1121), 1,
      sym_quasiquote_start,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(16088), 1,
      sym__varid,
    ACTIONS(16094), 1,
      anon_sym_LPAREN,
    ACTIONS(16096), 1,
      anon_sym_LBRACK,
    ACTIONS(16098), 1,
      anon_sym_SQUOTE,
    STATE(2179), 1,
      sym__unboxed_open,
    STATE(4703), 1,
      sym_constructor,
    STATE(16690), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16092), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16100), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1099), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16090), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5052), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5057), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5595), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124691] = 21,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(10833), 1,
      anon_sym_u27e6,
    ACTIONS(10835), 1,
      sym__splice_dollar,
    ACTIONS(10837), 1,
      sym_quasiquote_start,
    ACTIONS(13012), 1,
      sym__conid,
    ACTIONS(16102), 1,
      sym__varid,
    ACTIONS(16108), 1,
      anon_sym_LPAREN,
    ACTIONS(16110), 1,
      anon_sym_LBRACK,
    ACTIONS(16112), 1,
      anon_sym_SQUOTE,
    STATE(2101), 1,
      sym__unboxed_open,
    STATE(8501), 1,
      sym_constructor,
    STATE(16808), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16114), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16104), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8811), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8818), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124784] = 21,
    ACTIONS(9818), 1,
      sym__integer_literal,
    ACTIONS(9828), 1,
      sym__conid,
    ACTIONS(9842), 1,
      anon_sym_u27e6,
    ACTIONS(9844), 1,
      sym__splice_dollar,
    ACTIONS(9846), 1,
      sym_quasiquote_start,
    ACTIONS(16116), 1,
      sym__varid,
    ACTIONS(16122), 1,
      anon_sym_LPAREN,
    ACTIONS(16124), 1,
      anon_sym_LBRACK,
    ACTIONS(16126), 1,
      anon_sym_SQUOTE,
    STATE(2207), 1,
      sym__unboxed_open,
    STATE(11244), 1,
      sym_constructor,
    STATE(17551), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16120), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16128), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9820), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16118), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11958), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11962), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12218), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124877] = 21,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7047), 1,
      anon_sym_LPAREN,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7061), 1,
      anon_sym_u27e6,
    ACTIONS(7063), 1,
      sym__splice_dollar,
    ACTIONS(7065), 1,
      sym_quasiquote_start,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(7785), 1,
      anon_sym_SQUOTE,
    ACTIONS(13529), 1,
      sym__varid,
    STATE(2091), 1,
      sym__unboxed_open,
    STATE(6654), 1,
      sym_constructor,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7045), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7057), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6670), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6808), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [124970] = 21,
    ACTIONS(1097), 1,
      sym__integer_literal,
    ACTIONS(1117), 1,
      anon_sym_u27e6,
    ACTIONS(1119), 1,
      sym__splice_dollar,
    ACTIONS(1121), 1,
      sym_quasiquote_start,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(16088), 1,
      sym__varid,
    ACTIONS(16094), 1,
      anon_sym_LPAREN,
    ACTIONS(16096), 1,
      anon_sym_LBRACK,
    ACTIONS(16098), 1,
      anon_sym_SQUOTE,
    STATE(2179), 1,
      sym__unboxed_open,
    STATE(4703), 1,
      sym_constructor,
    STATE(16690), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16092), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16100), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1099), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16090), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5052), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5057), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6089), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125063] = 21,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15299), 1,
      sym__conid,
    ACTIONS(16130), 1,
      sym__varid,
    ACTIONS(16136), 1,
      anon_sym_LPAREN,
    ACTIONS(16138), 1,
      anon_sym_LBRACK,
    ACTIONS(16140), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      sym__unboxed_open,
    STATE(13541), 1,
      sym_constructor,
    STATE(16814), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16134), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16142), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16132), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13712), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(13771), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(20531), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125156] = 21,
    ACTIONS(9818), 1,
      sym__integer_literal,
    ACTIONS(9828), 1,
      sym__conid,
    ACTIONS(9842), 1,
      anon_sym_u27e6,
    ACTIONS(9844), 1,
      sym__splice_dollar,
    ACTIONS(9846), 1,
      sym_quasiquote_start,
    ACTIONS(16116), 1,
      sym__varid,
    ACTIONS(16122), 1,
      anon_sym_LPAREN,
    ACTIONS(16124), 1,
      anon_sym_LBRACK,
    ACTIONS(16126), 1,
      anon_sym_SQUOTE,
    STATE(2207), 1,
      sym__unboxed_open,
    STATE(11244), 1,
      sym_constructor,
    STATE(17551), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16120), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16128), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9820), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16118), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11958), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11962), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12022), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125249] = 21,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(13072), 1,
      anon_sym_u27e6,
    ACTIONS(13074), 1,
      sym__splice_dollar,
    ACTIONS(13076), 1,
      sym_quasiquote_start,
    ACTIONS(15329), 1,
      sym__conid,
    ACTIONS(16144), 1,
      sym__varid,
    ACTIONS(16150), 1,
      anon_sym_LPAREN,
    ACTIONS(16152), 1,
      anon_sym_LBRACK,
    ACTIONS(16154), 1,
      anon_sym_SQUOTE,
    STATE(2098), 1,
      sym__unboxed_open,
    STATE(14322), 1,
      sym_constructor,
    STATE(16470), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16148), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16156), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16146), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14928), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14880), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14820), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125342] = 21,
    ACTIONS(9614), 1,
      sym__integer_literal,
    ACTIONS(9622), 1,
      sym__conid,
    ACTIONS(9628), 1,
      anon_sym_u27e6,
    ACTIONS(9630), 1,
      sym__splice_dollar,
    ACTIONS(9632), 1,
      sym_quasiquote_start,
    ACTIONS(15936), 1,
      sym__varid,
    ACTIONS(15942), 1,
      anon_sym_LPAREN,
    ACTIONS(15944), 1,
      anon_sym_LBRACK,
    ACTIONS(15946), 1,
      anon_sym_SQUOTE,
    STATE(2190), 1,
      sym__unboxed_open,
    STATE(12173), 1,
      sym_constructor,
    STATE(17278), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15940), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15948), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9616), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15938), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12928), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(13056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13507), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125435] = 21,
    ACTIONS(2799), 1,
      sym__integer_literal,
    ACTIONS(2831), 1,
      anon_sym_u27e6,
    ACTIONS(2833), 1,
      sym__splice_dollar,
    ACTIONS(2835), 1,
      sym_quasiquote_start,
    ACTIONS(4435), 1,
      sym__conid,
    ACTIONS(16158), 1,
      sym__varid,
    ACTIONS(16164), 1,
      anon_sym_LPAREN,
    ACTIONS(16166), 1,
      anon_sym_LBRACK,
    ACTIONS(16168), 1,
      anon_sym_SQUOTE,
    STATE(2172), 1,
      sym__unboxed_open,
    STATE(4930), 1,
      sym_constructor,
    STATE(16344), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16162), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16170), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2801), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16160), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5759), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5755), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6250), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125528] = 21,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(13018), 1,
      anon_sym_u27e6,
    ACTIONS(13020), 1,
      sym__splice_dollar,
    ACTIONS(13022), 1,
      sym_quasiquote_start,
    ACTIONS(15337), 1,
      sym__conid,
    ACTIONS(16172), 1,
      sym__varid,
    ACTIONS(16178), 1,
      anon_sym_LPAREN,
    ACTIONS(16180), 1,
      anon_sym_LBRACK,
    ACTIONS(16182), 1,
      anon_sym_SQUOTE,
    STATE(2065), 1,
      sym__unboxed_open,
    STATE(13984), 1,
      sym_constructor,
    STATE(17189), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16176), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16184), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16174), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14338), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14292), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125621] = 21,
    ACTIONS(1922), 1,
      sym__integer_literal,
    ACTIONS(1954), 1,
      anon_sym_u27e6,
    ACTIONS(1956), 1,
      sym__splice_dollar,
    ACTIONS(1958), 1,
      sym_quasiquote_start,
    ACTIONS(4851), 1,
      sym__conid,
    ACTIONS(16186), 1,
      sym__varid,
    ACTIONS(16192), 1,
      anon_sym_LPAREN,
    ACTIONS(16194), 1,
      anon_sym_LBRACK,
    ACTIONS(16196), 1,
      anon_sym_SQUOTE,
    STATE(2079), 1,
      sym__unboxed_open,
    STATE(4204), 1,
      sym_constructor,
    STATE(16672), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16190), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16198), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1924), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16188), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4233), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4234), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4457), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125714] = 21,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11747), 1,
      anon_sym_LPAREN,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(11761), 1,
      anon_sym_u27e6,
    ACTIONS(11763), 1,
      sym__splice_dollar,
    ACTIONS(11765), 1,
      sym_quasiquote_start,
    ACTIONS(13412), 1,
      sym__varid,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(13416), 1,
      anon_sym_SQUOTE,
    STATE(2093), 1,
      sym__unboxed_open,
    STATE(8428), 1,
      sym_constructor,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6094), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11757), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8533), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8564), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125807] = 21,
    ACTIONS(8460), 1,
      sym__integer_literal,
    ACTIONS(8470), 1,
      sym__conid,
    ACTIONS(8472), 1,
      anon_sym_LBRACK,
    ACTIONS(8474), 1,
      anon_sym_SQUOTE,
    ACTIONS(8478), 1,
      anon_sym_u27e6,
    ACTIONS(8480), 1,
      sym__splice_dollar,
    ACTIONS(8482), 1,
      sym_quasiquote_start,
    ACTIONS(10222), 1,
      sym__varid,
    ACTIONS(10224), 1,
      anon_sym_LPAREN,
    STATE(2117), 1,
      sym__unboxed_open,
    STATE(7613), 1,
      sym_constructor,
    STATE(16751), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8476), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8458), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8462), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8184), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8189), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7912), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125900] = 21,
    ACTIONS(4829), 1,
      sym__integer_literal,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(4843), 1,
      anon_sym_u27e6,
    ACTIONS(4845), 1,
      sym__splice_dollar,
    ACTIONS(4847), 1,
      sym_quasiquote_start,
    ACTIONS(16200), 1,
      sym__varid,
    ACTIONS(16206), 1,
      anon_sym_LPAREN,
    ACTIONS(16208), 1,
      anon_sym_LBRACK,
    ACTIONS(16210), 1,
      anon_sym_SQUOTE,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(11315), 1,
      sym_constructor,
    STATE(17167), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16204), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16212), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4831), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16202), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11806), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11873), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12751), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [125993] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [126052] = 21,
    ACTIONS(4733), 1,
      sym__integer_literal,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(4747), 1,
      anon_sym_u27e6,
    ACTIONS(4749), 1,
      sym__splice_dollar,
    ACTIONS(4751), 1,
      sym_quasiquote_start,
    ACTIONS(16214), 1,
      sym__varid,
    ACTIONS(16220), 1,
      anon_sym_LPAREN,
    ACTIONS(16222), 1,
      anon_sym_LBRACK,
    ACTIONS(16224), 1,
      anon_sym_SQUOTE,
    STATE(2072), 1,
      sym__unboxed_open,
    STATE(12073), 1,
      sym_constructor,
    STATE(16485), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16218), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16226), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4735), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16216), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12145), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12150), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13708), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126145] = 21,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(16228), 1,
      sym__varid,
    ACTIONS(16234), 1,
      anon_sym_LPAREN,
    ACTIONS(16236), 1,
      anon_sym_LBRACK,
    ACTIONS(16238), 1,
      anon_sym_SQUOTE,
    STATE(2136), 1,
      sym__unboxed_open,
    STATE(10389), 1,
      sym_constructor,
    STATE(17691), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16232), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16240), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16230), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10501), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10535), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10688), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126238] = 21,
    ACTIONS(8047), 1,
      sym__varid,
    ACTIONS(8051), 1,
      sym__integer_literal,
    ACTIONS(8057), 1,
      anon_sym_LPAREN,
    ACTIONS(8062), 1,
      anon_sym_LBRACK,
    ACTIONS(8071), 1,
      anon_sym_u27e6,
    ACTIONS(8073), 1,
      sym__splice_dollar,
    ACTIONS(8075), 1,
      sym_quasiquote_start,
    ACTIONS(8335), 1,
      sym__conid,
    ACTIONS(8337), 1,
      anon_sym_SQUOTE,
    STATE(2141), 1,
      sym__unboxed_open,
    STATE(6849), 1,
      sym_constructor,
    STATE(16524), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8055), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8067), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8049), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8053), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7161), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7240), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126331] = 21,
    ACTIONS(2643), 1,
      sym__integer_literal,
    ACTIONS(2674), 1,
      anon_sym_u27e6,
    ACTIONS(2676), 1,
      sym__splice_dollar,
    ACTIONS(2678), 1,
      sym_quasiquote_start,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(16242), 1,
      sym__varid,
    ACTIONS(16248), 1,
      anon_sym_LPAREN,
    ACTIONS(16250), 1,
      anon_sym_LBRACK,
    ACTIONS(16252), 1,
      anon_sym_SQUOTE,
    STATE(2125), 1,
      sym__unboxed_open,
    STATE(4780), 1,
      sym_constructor,
    STATE(16789), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16246), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2645), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16244), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5374), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5371), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6022), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126424] = 21,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(16228), 1,
      sym__varid,
    ACTIONS(16234), 1,
      anon_sym_LPAREN,
    ACTIONS(16236), 1,
      anon_sym_LBRACK,
    ACTIONS(16238), 1,
      anon_sym_SQUOTE,
    STATE(2136), 1,
      sym__unboxed_open,
    STATE(10389), 1,
      sym_constructor,
    STATE(17691), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16232), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16240), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16230), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10501), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10535), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10758), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126517] = 21,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5461), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(5477), 1,
      anon_sym_u27e6,
    ACTIONS(5479), 1,
      sym__splice_dollar,
    ACTIONS(5481), 1,
      sym_quasiquote_start,
    ACTIONS(6100), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(9608), 1,
      sym__varid,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(4157), 1,
      sym_constructor,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5459), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5471), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4278), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4321), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126610] = 21,
    ACTIONS(7971), 1,
      sym__integer_literal,
    ACTIONS(7981), 1,
      sym__conid,
    ACTIONS(7983), 1,
      anon_sym_LBRACK,
    ACTIONS(7985), 1,
      anon_sym_SQUOTE,
    ACTIONS(7989), 1,
      anon_sym_u27e6,
    ACTIONS(7991), 1,
      sym__splice_dollar,
    ACTIONS(7993), 1,
      sym_quasiquote_start,
    ACTIONS(9122), 1,
      anon_sym_LPAREN,
    ACTIONS(15207), 1,
      sym__varid,
    STATE(2193), 1,
      sym__unboxed_open,
    STATE(7398), 1,
      sym_constructor,
    STATE(17581), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7975), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7987), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7969), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7973), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7737), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7739), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7807), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126703] = 21,
    ACTIONS(2246), 1,
      sym__integer_literal,
    ACTIONS(2277), 1,
      anon_sym_u27e6,
    ACTIONS(2279), 1,
      sym__splice_dollar,
    ACTIONS(2281), 1,
      sym_quasiquote_start,
    ACTIONS(4809), 1,
      sym__conid,
    ACTIONS(16256), 1,
      sym__varid,
    ACTIONS(16262), 1,
      anon_sym_LPAREN,
    ACTIONS(16264), 1,
      anon_sym_LBRACK,
    ACTIONS(16266), 1,
      anon_sym_SQUOTE,
    STATE(2096), 1,
      sym__unboxed_open,
    STATE(4700), 1,
      sym_constructor,
    STATE(17457), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16260), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16268), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2248), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16258), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5259), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5234), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5610), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126796] = 21,
    ACTIONS(6270), 1,
      sym__integer_literal,
    ACTIONS(6276), 1,
      anon_sym_LPAREN,
    ACTIONS(6281), 1,
      anon_sym_LBRACK,
    ACTIONS(6290), 1,
      anon_sym_u27e6,
    ACTIONS(6292), 1,
      sym__splice_dollar,
    ACTIONS(6294), 1,
      sym_quasiquote_start,
    ACTIONS(8201), 1,
      sym__conid,
    ACTIONS(8203), 1,
      anon_sym_SQUOTE,
    ACTIONS(15285), 1,
      sym__varid,
    STATE(2188), 1,
      sym__unboxed_open,
    STATE(5313), 1,
      sym_constructor,
    STATE(17800), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6274), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6286), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6268), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6272), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6297), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6275), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5940), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126889] = 21,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15299), 1,
      sym__conid,
    ACTIONS(16130), 1,
      sym__varid,
    ACTIONS(16136), 1,
      anon_sym_LPAREN,
    ACTIONS(16138), 1,
      anon_sym_LBRACK,
    ACTIONS(16140), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      sym__unboxed_open,
    STATE(13541), 1,
      sym_constructor,
    STATE(16814), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16134), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16142), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16132), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13712), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(13771), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(20536), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [126982] = 21,
    ACTIONS(2246), 1,
      sym__integer_literal,
    ACTIONS(2277), 1,
      anon_sym_u27e6,
    ACTIONS(2279), 1,
      sym__splice_dollar,
    ACTIONS(2281), 1,
      sym_quasiquote_start,
    ACTIONS(4809), 1,
      sym__conid,
    ACTIONS(16256), 1,
      sym__varid,
    ACTIONS(16262), 1,
      anon_sym_LPAREN,
    ACTIONS(16264), 1,
      anon_sym_LBRACK,
    ACTIONS(16266), 1,
      anon_sym_SQUOTE,
    STATE(2096), 1,
      sym__unboxed_open,
    STATE(4700), 1,
      sym_constructor,
    STATE(17457), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16260), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16268), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2248), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16258), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5259), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5234), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5012), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127075] = 21,
    ACTIONS(2204), 1,
      sym__integer_literal,
    ACTIONS(2236), 1,
      anon_sym_u27e6,
    ACTIONS(2238), 1,
      sym__splice_dollar,
    ACTIONS(2240), 1,
      sym_quasiquote_start,
    ACTIONS(4537), 1,
      sym__conid,
    ACTIONS(16270), 1,
      sym__varid,
    ACTIONS(16276), 1,
      anon_sym_LPAREN,
    ACTIONS(16278), 1,
      anon_sym_LBRACK,
    ACTIONS(16280), 1,
      anon_sym_SQUOTE,
    STATE(2084), 1,
      sym__unboxed_open,
    STATE(4651), 1,
      sym_constructor,
    STATE(16614), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16274), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16282), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2206), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16272), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4748), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4723), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5304), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127168] = 21,
    ACTIONS(4503), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(4527), 1,
      anon_sym_u27e6,
    ACTIONS(4529), 1,
      sym__splice_dollar,
    ACTIONS(4531), 1,
      sym_quasiquote_start,
    ACTIONS(16284), 1,
      sym__varid,
    ACTIONS(16290), 1,
      anon_sym_LPAREN,
    ACTIONS(16292), 1,
      anon_sym_LBRACK,
    ACTIONS(16294), 1,
      anon_sym_SQUOTE,
    STATE(2121), 1,
      sym__unboxed_open,
    STATE(10815), 1,
      sym_constructor,
    STATE(17204), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16288), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16296), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4505), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16286), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11090), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11409), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127261] = 21,
    ACTIONS(8432), 1,
      sym__integer_literal,
    ACTIONS(8442), 1,
      sym__conid,
    ACTIONS(8444), 1,
      anon_sym_LBRACK,
    ACTIONS(8446), 1,
      anon_sym_SQUOTE,
    ACTIONS(8450), 1,
      anon_sym_u27e6,
    ACTIONS(8452), 1,
      sym__splice_dollar,
    ACTIONS(8454), 1,
      sym_quasiquote_start,
    ACTIONS(8920), 1,
      anon_sym_LPAREN,
    ACTIONS(15289), 1,
      sym__varid,
    STATE(2102), 1,
      sym__unboxed_open,
    STATE(7203), 1,
      sym_constructor,
    STATE(17798), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8436), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8448), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8430), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8434), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7424), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7414), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127354] = 21,
    ACTIONS(551), 1,
      sym__integer_literal,
    ACTIONS(585), 1,
      anon_sym_u27e6,
    ACTIONS(587), 1,
      sym__splice_dollar,
    ACTIONS(591), 1,
      sym_quasiquote_start,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(16298), 1,
      sym__varid,
    ACTIONS(16304), 1,
      anon_sym_LPAREN,
    ACTIONS(16306), 1,
      anon_sym_LBRACK,
    ACTIONS(16308), 1,
      anon_sym_SQUOTE,
    STATE(2155), 1,
      sym__unboxed_open,
    STATE(4540), 1,
      sym_constructor,
    STATE(16328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16302), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16310), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(553), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16300), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5202), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4802), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127447] = 21,
    ACTIONS(4769), 1,
      sym__integer_literal,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(4793), 1,
      anon_sym_u27e6,
    ACTIONS(4795), 1,
      sym__splice_dollar,
    ACTIONS(4797), 1,
      sym_quasiquote_start,
    ACTIONS(16312), 1,
      sym__varid,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_LBRACK,
    ACTIONS(16322), 1,
      anon_sym_SQUOTE,
    STATE(2178), 1,
      sym__unboxed_open,
    STATE(11360), 1,
      sym_constructor,
    STATE(17037), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16324), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4771), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11894), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11531), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12618), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127540] = 21,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(71), 1,
      anon_sym_u27e6,
    ACTIONS(73), 1,
      sym__splice_dollar,
    ACTIONS(75), 1,
      sym_quasiquote_start,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(15760), 1,
      sym__varid,
    ACTIONS(15766), 1,
      anon_sym_LPAREN,
    ACTIONS(15768), 1,
      anon_sym_LBRACK,
    ACTIONS(15770), 1,
      anon_sym_SQUOTE,
    STATE(2111), 1,
      sym__unboxed_open,
    STATE(4690), 1,
      sym_constructor,
    STATE(17373), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15764), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15772), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5063), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5068), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5281), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127633] = 21,
    ACTIONS(1582), 1,
      sym__integer_literal,
    ACTIONS(1600), 1,
      anon_sym_u27e6,
    ACTIONS(1602), 1,
      sym__splice_dollar,
    ACTIONS(1604), 1,
      sym_quasiquote_start,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(16326), 1,
      sym__varid,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_LBRACK,
    ACTIONS(16336), 1,
      anon_sym_SQUOTE,
    STATE(2211), 1,
      sym__unboxed_open,
    STATE(5247), 1,
      sym_constructor,
    STATE(17292), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16330), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16338), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1584), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16328), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5272), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6262), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127726] = 21,
    ACTIONS(7863), 1,
      sym__integer_literal,
    ACTIONS(7873), 1,
      sym__conid,
    ACTIONS(7875), 1,
      anon_sym_LBRACK,
    ACTIONS(7877), 1,
      anon_sym_SQUOTE,
    ACTIONS(7881), 1,
      anon_sym_u27e6,
    ACTIONS(7883), 1,
      sym__splice_dollar,
    ACTIONS(7885), 1,
      sym_quasiquote_start,
    ACTIONS(7955), 1,
      sym__varid,
    ACTIONS(7957), 1,
      anon_sym_LPAREN,
    STATE(2081), 1,
      sym__unboxed_open,
    STATE(6986), 1,
      sym_constructor,
    STATE(17564), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7867), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7879), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7060), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7036), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7121), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127819] = 21,
    ACTIONS(9886), 1,
      sym__integer_literal,
    ACTIONS(9896), 1,
      sym__conid,
    ACTIONS(9910), 1,
      anon_sym_u27e6,
    ACTIONS(9912), 1,
      sym__splice_dollar,
    ACTIONS(9914), 1,
      sym_quasiquote_start,
    ACTIONS(16340), 1,
      sym__varid,
    ACTIONS(16346), 1,
      anon_sym_LPAREN,
    ACTIONS(16348), 1,
      anon_sym_LBRACK,
    ACTIONS(16350), 1,
      anon_sym_SQUOTE,
    STATE(2201), 1,
      sym__unboxed_open,
    STATE(11755), 1,
      sym_constructor,
    STATE(17449), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16344), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16352), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9888), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16342), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12236), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12296), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13111), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [127912] = 21,
    ACTIONS(9886), 1,
      sym__integer_literal,
    ACTIONS(9896), 1,
      sym__conid,
    ACTIONS(9910), 1,
      anon_sym_u27e6,
    ACTIONS(9912), 1,
      sym__splice_dollar,
    ACTIONS(9914), 1,
      sym_quasiquote_start,
    ACTIONS(16340), 1,
      sym__varid,
    ACTIONS(16346), 1,
      anon_sym_LPAREN,
    ACTIONS(16348), 1,
      anon_sym_LBRACK,
    ACTIONS(16350), 1,
      anon_sym_SQUOTE,
    STATE(2201), 1,
      sym__unboxed_open,
    STATE(11755), 1,
      sym_constructor,
    STATE(17449), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16344), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16352), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9888), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16342), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12236), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12296), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12300), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128005] = 21,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11010), 1,
      sym__splice_dollar,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(13278), 1,
      anon_sym_LPAREN,
    ACTIONS(13280), 1,
      anon_sym_LBRACK,
    ACTIONS(13282), 1,
      anon_sym_SQUOTE,
    ACTIONS(16354), 1,
      sym__varid,
    STATE(2068), 1,
      sym__unboxed_open,
    STATE(8222), 1,
      sym_constructor,
    STATE(16645), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13276), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13284), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13274), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8300), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9809), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128098] = 21,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(13278), 1,
      anon_sym_LPAREN,
    ACTIONS(13280), 1,
      anon_sym_LBRACK,
    ACTIONS(13282), 1,
      anon_sym_SQUOTE,
    ACTIONS(13286), 1,
      sym__splice_dollar,
    ACTIONS(16354), 1,
      sym__varid,
    STATE(2068), 1,
      sym__unboxed_open,
    STATE(8222), 1,
      sym_constructor,
    STATE(16645), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13276), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13284), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13274), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8300), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9389), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128191] = 21,
    ACTIONS(2204), 1,
      sym__integer_literal,
    ACTIONS(2236), 1,
      anon_sym_u27e6,
    ACTIONS(2238), 1,
      sym__splice_dollar,
    ACTIONS(2240), 1,
      sym_quasiquote_start,
    ACTIONS(4537), 1,
      sym__conid,
    ACTIONS(16270), 1,
      sym__varid,
    ACTIONS(16276), 1,
      anon_sym_LPAREN,
    ACTIONS(16278), 1,
      anon_sym_LBRACK,
    ACTIONS(16280), 1,
      anon_sym_SQUOTE,
    STATE(2084), 1,
      sym__unboxed_open,
    STATE(4651), 1,
      sym_constructor,
    STATE(16614), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16274), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16282), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2206), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16272), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4748), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4723), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5140), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128284] = 21,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(11008), 1,
      anon_sym_u27e6,
    ACTIONS(11012), 1,
      sym_quasiquote_start,
    ACTIONS(13278), 1,
      anon_sym_LPAREN,
    ACTIONS(13280), 1,
      anon_sym_LBRACK,
    ACTIONS(13282), 1,
      anon_sym_SQUOTE,
    ACTIONS(13286), 1,
      sym__splice_dollar,
    ACTIONS(16354), 1,
      sym__varid,
    STATE(2068), 1,
      sym__unboxed_open,
    STATE(8222), 1,
      sym_constructor,
    STATE(16645), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13276), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13284), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13274), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8300), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9387), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128377] = 21,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(13310), 1,
      anon_sym_u27e6,
    ACTIONS(13312), 1,
      sym__splice_dollar,
    ACTIONS(13314), 1,
      sym_quasiquote_start,
    ACTIONS(15317), 1,
      sym__conid,
    ACTIONS(16356), 1,
      sym__varid,
    ACTIONS(16362), 1,
      anon_sym_LPAREN,
    ACTIONS(16364), 1,
      anon_sym_LBRACK,
    ACTIONS(16366), 1,
      anon_sym_SQUOTE,
    STATE(2174), 1,
      sym__unboxed_open,
    STATE(14458), 1,
      sym_constructor,
    STATE(16951), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16360), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16368), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16358), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14892), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14834), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14851), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128470] = 21,
    ACTIONS(12442), 1,
      sym__integer_literal,
    ACTIONS(12448), 1,
      anon_sym_LPAREN,
    ACTIONS(12450), 1,
      sym__conid,
    ACTIONS(12452), 1,
      anon_sym_LBRACK,
    ACTIONS(12454), 1,
      anon_sym_SQUOTE,
    ACTIONS(12460), 1,
      anon_sym_u27e6,
    ACTIONS(12462), 1,
      sym__splice_dollar,
    ACTIONS(12464), 1,
      sym_quasiquote_start,
    ACTIONS(16370), 1,
      sym__varid,
    STATE(2077), 1,
      sym__unboxed_open,
    STATE(8749), 1,
      sym_constructor,
    STATE(16483), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12456), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9055), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9268), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128563] = 21,
    ACTIONS(12442), 1,
      sym__integer_literal,
    ACTIONS(12448), 1,
      anon_sym_LPAREN,
    ACTIONS(12450), 1,
      sym__conid,
    ACTIONS(12452), 1,
      anon_sym_LBRACK,
    ACTIONS(12454), 1,
      anon_sym_SQUOTE,
    ACTIONS(12460), 1,
      anon_sym_u27e6,
    ACTIONS(12462), 1,
      sym__splice_dollar,
    ACTIONS(12464), 1,
      sym_quasiquote_start,
    ACTIONS(16370), 1,
      sym__varid,
    STATE(2077), 1,
      sym__unboxed_open,
    STATE(8749), 1,
      sym_constructor,
    STATE(16483), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12456), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9055), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9250), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128656] = 21,
    ACTIONS(4829), 1,
      sym__integer_literal,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(4843), 1,
      anon_sym_u27e6,
    ACTIONS(4845), 1,
      sym__splice_dollar,
    ACTIONS(4847), 1,
      sym_quasiquote_start,
    ACTIONS(16200), 1,
      sym__varid,
    ACTIONS(16206), 1,
      anon_sym_LPAREN,
    ACTIONS(16208), 1,
      anon_sym_LBRACK,
    ACTIONS(16210), 1,
      anon_sym_SQUOTE,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(11315), 1,
      sym_constructor,
    STATE(17167), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16204), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16212), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4831), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16202), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11806), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11873), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12856), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128749] = 21,
    ACTIONS(9920), 1,
      sym__integer_literal,
    ACTIONS(9930), 1,
      sym__conid,
    ACTIONS(9944), 1,
      anon_sym_u27e6,
    ACTIONS(9946), 1,
      sym__splice_dollar,
    ACTIONS(9948), 1,
      sym_quasiquote_start,
    ACTIONS(16372), 1,
      sym__varid,
    ACTIONS(16378), 1,
      anon_sym_LPAREN,
    ACTIONS(16380), 1,
      anon_sym_LBRACK,
    ACTIONS(16382), 1,
      anon_sym_SQUOTE,
    STATE(2109), 1,
      sym__unboxed_open,
    STATE(11715), 1,
      sym_constructor,
    STATE(16706), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16376), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16384), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9922), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16374), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12545), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12543), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13060), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128842] = 21,
    ACTIONS(659), 1,
      sym__integer_literal,
    ACTIONS(683), 1,
      anon_sym_u27e6,
    ACTIONS(685), 1,
      sym__splice_dollar,
    ACTIONS(687), 1,
      sym_quasiquote_start,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(15922), 1,
      sym__varid,
    ACTIONS(15928), 1,
      anon_sym_LPAREN,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(15932), 1,
      anon_sym_SQUOTE,
    STATE(2103), 1,
      sym__unboxed_open,
    STATE(3731), 1,
      sym_constructor,
    STATE(16976), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15926), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15934), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(661), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15924), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3792), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(3763), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4079), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [128935] = 21,
    ACTIONS(5820), 1,
      sym__integer_literal,
    ACTIONS(5826), 1,
      anon_sym_LPAREN,
    ACTIONS(5831), 1,
      anon_sym_LBRACK,
    ACTIONS(5840), 1,
      anon_sym_u27e6,
    ACTIONS(5842), 1,
      sym__splice_dollar,
    ACTIONS(5844), 1,
      sym_quasiquote_start,
    ACTIONS(8111), 1,
      sym__conid,
    ACTIONS(8113), 1,
      anon_sym_SQUOTE,
    ACTIONS(15213), 1,
      sym__varid,
    STATE(2152), 1,
      sym__unboxed_open,
    STATE(4543), 1,
      sym_constructor,
    STATE(16817), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5824), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5836), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5818), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5822), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4807), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4804), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5176), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129028] = 21,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12193), 1,
      anon_sym_SQUOTE,
    ACTIONS(12205), 1,
      anon_sym_u27e6,
    ACTIONS(12207), 1,
      sym__splice_dollar,
    ACTIONS(12209), 1,
      sym_quasiquote_start,
    ACTIONS(14462), 1,
      anon_sym_LPAREN,
    ACTIONS(15055), 1,
      sym__varid,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(8937), 1,
      sym_constructor,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12185), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12195), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9551), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10470), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129121] = 21,
    ACTIONS(3567), 1,
      sym__integer_literal,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(3593), 1,
      anon_sym_u27e6,
    ACTIONS(3595), 1,
      sym__splice_dollar,
    ACTIONS(3597), 1,
      sym_quasiquote_start,
    ACTIONS(16032), 1,
      sym__varid,
    ACTIONS(16038), 1,
      anon_sym_LPAREN,
    ACTIONS(16040), 1,
      anon_sym_LBRACK,
    ACTIONS(16042), 1,
      anon_sym_SQUOTE,
    STATE(2200), 1,
      sym__unboxed_open,
    STATE(10629), 1,
      sym_constructor,
    STATE(16927), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16036), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16044), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16034), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10769), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12017), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129214] = 21,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(71), 1,
      anon_sym_u27e6,
    ACTIONS(73), 1,
      sym__splice_dollar,
    ACTIONS(75), 1,
      sym_quasiquote_start,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(15760), 1,
      sym__varid,
    ACTIONS(15766), 1,
      anon_sym_LPAREN,
    ACTIONS(15768), 1,
      anon_sym_LBRACK,
    ACTIONS(15770), 1,
      anon_sym_SQUOTE,
    STATE(2111), 1,
      sym__unboxed_open,
    STATE(4690), 1,
      sym_constructor,
    STATE(17373), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15764), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15772), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5063), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5068), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5900), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129307] = 21,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(13211), 1,
      anon_sym_u27e6,
    ACTIONS(13213), 1,
      sym__splice_dollar,
    ACTIONS(13215), 1,
      sym_quasiquote_start,
    ACTIONS(15303), 1,
      sym__conid,
    ACTIONS(16386), 1,
      sym__varid,
    ACTIONS(16392), 1,
      anon_sym_LPAREN,
    ACTIONS(16394), 1,
      anon_sym_LBRACK,
    ACTIONS(16396), 1,
      anon_sym_SQUOTE,
    STATE(2129), 1,
      sym__unboxed_open,
    STATE(13673), 1,
      sym_constructor,
    STATE(16786), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16390), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16398), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16388), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13906), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14048), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129400] = 21,
    ACTIONS(8131), 1,
      sym__integer_literal,
    ACTIONS(8141), 1,
      sym__conid,
    ACTIONS(8143), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_SQUOTE,
    ACTIONS(8149), 1,
      anon_sym_u27e6,
    ACTIONS(8151), 1,
      sym__splice_dollar,
    ACTIONS(8153), 1,
      sym_quasiquote_start,
    ACTIONS(9174), 1,
      sym__varid,
    ACTIONS(9176), 1,
      anon_sym_LPAREN,
    STATE(2067), 1,
      sym__unboxed_open,
    STATE(7344), 1,
      sym_constructor,
    STATE(17334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8135), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8147), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8129), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8133), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7741), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7649), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7731), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129493] = 21,
    ACTIONS(9698), 1,
      sym__integer_literal,
    ACTIONS(9708), 1,
      sym__conid,
    ACTIONS(9722), 1,
      anon_sym_u27e6,
    ACTIONS(9724), 1,
      sym__splice_dollar,
    ACTIONS(9726), 1,
      sym_quasiquote_start,
    ACTIONS(16400), 1,
      sym__varid,
    ACTIONS(16406), 1,
      anon_sym_LPAREN,
    ACTIONS(16408), 1,
      anon_sym_LBRACK,
    ACTIONS(16410), 1,
      anon_sym_SQUOTE,
    STATE(2183), 1,
      sym__unboxed_open,
    STATE(11441), 1,
      sym_constructor,
    STATE(17435), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16404), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16412), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9700), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16402), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11622), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12135), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129586] = 21,
    ACTIONS(9698), 1,
      sym__integer_literal,
    ACTIONS(9708), 1,
      sym__conid,
    ACTIONS(9722), 1,
      anon_sym_u27e6,
    ACTIONS(9724), 1,
      sym__splice_dollar,
    ACTIONS(9726), 1,
      sym_quasiquote_start,
    ACTIONS(16400), 1,
      sym__varid,
    ACTIONS(16406), 1,
      anon_sym_LPAREN,
    ACTIONS(16408), 1,
      anon_sym_LBRACK,
    ACTIONS(16410), 1,
      anon_sym_SQUOTE,
    STATE(2183), 1,
      sym__unboxed_open,
    STATE(11441), 1,
      sym_constructor,
    STATE(17435), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16404), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16412), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9700), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16402), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11622), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11940), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129679] = 21,
    ACTIONS(2849), 1,
      sym__integer_literal,
    ACTIONS(2881), 1,
      anon_sym_u27e6,
    ACTIONS(2883), 1,
      sym__splice_dollar,
    ACTIONS(2885), 1,
      sym_quasiquote_start,
    ACTIONS(4607), 1,
      sym__conid,
    ACTIONS(16060), 1,
      sym__varid,
    ACTIONS(16066), 1,
      anon_sym_LPAREN,
    ACTIONS(16068), 1,
      anon_sym_LBRACK,
    ACTIONS(16070), 1,
      anon_sym_SQUOTE,
    STATE(2115), 1,
      sym__unboxed_open,
    STATE(4937), 1,
      sym_constructor,
    STATE(16443), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16064), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16072), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2851), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16062), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5690), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5689), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6293), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129772] = 21,
    ACTIONS(6550), 1,
      sym__varid,
    ACTIONS(6554), 1,
      sym__integer_literal,
    ACTIONS(6560), 1,
      anon_sym_LPAREN,
    ACTIONS(6565), 1,
      anon_sym_LBRACK,
    ACTIONS(6574), 1,
      anon_sym_u27e6,
    ACTIONS(6576), 1,
      sym__splice_dollar,
    ACTIONS(6578), 1,
      sym_quasiquote_start,
    ACTIONS(7921), 1,
      sym__conid,
    ACTIONS(7923), 1,
      anon_sym_SQUOTE,
    STATE(2090), 1,
      sym__unboxed_open,
    STATE(6272), 1,
      sym_constructor,
    STATE(17534), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6558), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6570), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6552), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6556), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6385), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6380), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6443), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129865] = 21,
    ACTIONS(2344), 1,
      sym__integer_literal,
    ACTIONS(2375), 1,
      anon_sym_u27e6,
    ACTIONS(2377), 1,
      sym__splice_dollar,
    ACTIONS(2379), 1,
      sym_quasiquote_start,
    ACTIONS(4583), 1,
      sym__conid,
    ACTIONS(16414), 1,
      sym__varid,
    ACTIONS(16420), 1,
      anon_sym_LPAREN,
    ACTIONS(16422), 1,
      anon_sym_LBRACK,
    ACTIONS(16424), 1,
      anon_sym_SQUOTE,
    STATE(2157), 1,
      sym__unboxed_open,
    STATE(4544), 1,
      sym_constructor,
    STATE(17426), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16418), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16426), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2346), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16416), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5212), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5189), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5422), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [129958] = 21,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(11041), 1,
      anon_sym_u27e6,
    ACTIONS(11043), 1,
      sym__splice_dollar,
    ACTIONS(11045), 1,
      sym_quasiquote_start,
    ACTIONS(13038), 1,
      sym__conid,
    ACTIONS(16428), 1,
      sym__varid,
    ACTIONS(16434), 1,
      anon_sym_LPAREN,
    ACTIONS(16436), 1,
      anon_sym_LBRACK,
    ACTIONS(16438), 1,
      anon_sym_SQUOTE,
    STATE(2063), 1,
      sym__unboxed_open,
    STATE(8783), 1,
      sym_constructor,
    STATE(16509), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16432), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16440), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16430), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8926), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8927), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8888), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130051] = 21,
    ACTIONS(4639), 1,
      sym__integer_literal,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(4663), 1,
      anon_sym_u27e6,
    ACTIONS(4665), 1,
      sym__splice_dollar,
    ACTIONS(4667), 1,
      sym_quasiquote_start,
    ACTIONS(16442), 1,
      sym__varid,
    ACTIONS(16448), 1,
      anon_sym_LPAREN,
    ACTIONS(16450), 1,
      anon_sym_LBRACK,
    ACTIONS(16452), 1,
      anon_sym_SQUOTE,
    STATE(2153), 1,
      sym__unboxed_open,
    STATE(11399), 1,
      sym_constructor,
    STATE(16538), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16454), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16444), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11677), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12599), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130144] = 21,
    ACTIONS(2344), 1,
      sym__integer_literal,
    ACTIONS(2375), 1,
      anon_sym_u27e6,
    ACTIONS(2377), 1,
      sym__splice_dollar,
    ACTIONS(2379), 1,
      sym_quasiquote_start,
    ACTIONS(4583), 1,
      sym__conid,
    ACTIONS(16414), 1,
      sym__varid,
    ACTIONS(16420), 1,
      anon_sym_LPAREN,
    ACTIONS(16422), 1,
      anon_sym_LBRACK,
    ACTIONS(16424), 1,
      anon_sym_SQUOTE,
    STATE(2157), 1,
      sym__unboxed_open,
    STATE(4544), 1,
      sym_constructor,
    STATE(17426), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16418), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16426), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2346), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16416), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5212), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5189), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5236), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130237] = 21,
    ACTIONS(4503), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(4527), 1,
      anon_sym_u27e6,
    ACTIONS(4529), 1,
      sym__splice_dollar,
    ACTIONS(4531), 1,
      sym_quasiquote_start,
    ACTIONS(16284), 1,
      sym__varid,
    ACTIONS(16290), 1,
      anon_sym_LPAREN,
    ACTIONS(16292), 1,
      anon_sym_LBRACK,
    ACTIONS(16294), 1,
      anon_sym_SQUOTE,
    STATE(2121), 1,
      sym__unboxed_open,
    STATE(10815), 1,
      sym_constructor,
    STATE(17204), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16288), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16296), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4505), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16286), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11090), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11413), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130330] = 21,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_SQUOTE,
    ACTIONS(6256), 1,
      anon_sym_u27e6,
    ACTIONS(6258), 1,
      sym__splice_dollar,
    ACTIONS(6260), 1,
      sym_quasiquote_start,
    ACTIONS(9564), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_LPAREN,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(7796), 1,
      sym_constructor,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6244), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7974), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8106), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130423] = 21,
    ACTIONS(7067), 1,
      sym__varid,
    ACTIONS(7071), 1,
      sym__integer_literal,
    ACTIONS(7077), 1,
      anon_sym_LPAREN,
    ACTIONS(7082), 1,
      anon_sym_LBRACK,
    ACTIONS(7091), 1,
      anon_sym_u27e6,
    ACTIONS(7093), 1,
      sym__splice_dollar,
    ACTIONS(7095), 1,
      sym_quasiquote_start,
    ACTIONS(8756), 1,
      sym__conid,
    ACTIONS(8758), 1,
      anon_sym_SQUOTE,
    STATE(2073), 1,
      sym__unboxed_open,
    STATE(6342), 1,
      sym_constructor,
    STATE(17509), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7075), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7087), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7069), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7073), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6844), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6704), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6877), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130516] = 21,
    ACTIONS(7447), 1,
      sym__integer_literal,
    ACTIONS(7453), 1,
      anon_sym_LPAREN,
    ACTIONS(7458), 1,
      anon_sym_LBRACK,
    ACTIONS(7467), 1,
      anon_sym_u27e6,
    ACTIONS(7469), 1,
      sym__splice_dollar,
    ACTIONS(7471), 1,
      sym_quasiquote_start,
    ACTIONS(8622), 1,
      sym__conid,
    ACTIONS(8624), 1,
      anon_sym_SQUOTE,
    ACTIONS(15217), 1,
      sym__varid,
    STATE(2132), 1,
      sym__unboxed_open,
    STATE(6447), 1,
      sym_constructor,
    STATE(17559), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7451), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7463), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7445), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7449), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7015), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6966), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7004), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130609] = 21,
    ACTIONS(9312), 1,
      sym__integer_literal,
    ACTIONS(9322), 1,
      sym__conid,
    ACTIONS(9336), 1,
      anon_sym_u27e6,
    ACTIONS(9338), 1,
      sym__splice_dollar,
    ACTIONS(9340), 1,
      sym_quasiquote_start,
    ACTIONS(16456), 1,
      sym__varid,
    ACTIONS(16462), 1,
      anon_sym_LPAREN,
    ACTIONS(16464), 1,
      anon_sym_LBRACK,
    ACTIONS(16466), 1,
      anon_sym_SQUOTE,
    STATE(2137), 1,
      sym__unboxed_open,
    STATE(11554), 1,
      sym_constructor,
    STATE(17413), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16460), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16468), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16458), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12342), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12459), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130702] = 21,
    ACTIONS(8684), 1,
      sym__integer_literal,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(8696), 1,
      anon_sym_LBRACK,
    ACTIONS(8698), 1,
      anon_sym_SQUOTE,
    ACTIONS(8702), 1,
      anon_sym_u27e6,
    ACTIONS(8704), 1,
      sym__splice_dollar,
    ACTIONS(8706), 1,
      sym_quasiquote_start,
    ACTIONS(9500), 1,
      sym__varid,
    ACTIONS(9502), 1,
      anon_sym_LPAREN,
    STATE(2167), 1,
      sym__unboxed_open,
    STATE(7251), 1,
      sym_constructor,
    STATE(16860), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8688), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8700), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8682), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8686), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7644), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7854), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7658), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130795] = 21,
    ACTIONS(4639), 1,
      sym__integer_literal,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(4663), 1,
      anon_sym_u27e6,
    ACTIONS(4665), 1,
      sym__splice_dollar,
    ACTIONS(4667), 1,
      sym_quasiquote_start,
    ACTIONS(16442), 1,
      sym__varid,
    ACTIONS(16448), 1,
      anon_sym_LPAREN,
    ACTIONS(16450), 1,
      anon_sym_LBRACK,
    ACTIONS(16452), 1,
      anon_sym_SQUOTE,
    STATE(2153), 1,
      sym__unboxed_open,
    STATE(11399), 1,
      sym_constructor,
    STATE(16538), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16454), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16444), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11677), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13372), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130888] = 21,
    ACTIONS(10394), 1,
      sym__integer_literal,
    ACTIONS(10413), 1,
      anon_sym_u27e6,
    ACTIONS(10415), 1,
      sym__splice_dollar,
    ACTIONS(10417), 1,
      sym_quasiquote_start,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(16470), 1,
      sym__varid,
    ACTIONS(16476), 1,
      anon_sym_LPAREN,
    ACTIONS(16478), 1,
      anon_sym_LBRACK,
    ACTIONS(16480), 1,
      anon_sym_SQUOTE,
    STATE(2170), 1,
      sym__unboxed_open,
    STATE(8284), 1,
      sym_constructor,
    STATE(17805), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16474), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16482), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16472), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8458), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8438), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8358), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [130981] = 21,
    ACTIONS(1922), 1,
      sym__integer_literal,
    ACTIONS(1954), 1,
      anon_sym_u27e6,
    ACTIONS(1956), 1,
      sym__splice_dollar,
    ACTIONS(1958), 1,
      sym_quasiquote_start,
    ACTIONS(4851), 1,
      sym__conid,
    ACTIONS(16186), 1,
      sym__varid,
    ACTIONS(16192), 1,
      anon_sym_LPAREN,
    ACTIONS(16194), 1,
      anon_sym_LBRACK,
    ACTIONS(16196), 1,
      anon_sym_SQUOTE,
    STATE(2079), 1,
      sym__unboxed_open,
    STATE(4204), 1,
      sym_constructor,
    STATE(16672), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16190), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16198), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1924), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16188), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4233), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4234), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4239), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131074] = 21,
    ACTIONS(1387), 1,
      sym__integer_literal,
    ACTIONS(1422), 1,
      anon_sym_u27e6,
    ACTIONS(1424), 1,
      sym__splice_dollar,
    ACTIONS(1426), 1,
      sym_quasiquote_start,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(15848), 1,
      sym__varid,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_SQUOTE,
    STATE(2176), 1,
      sym__unboxed_open,
    STATE(5231), 1,
      sym_constructor,
    STATE(16935), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15852), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15860), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1389), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15850), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5413), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5412), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6080), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131167] = 21,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(11506), 1,
      anon_sym_u27e6,
    ACTIONS(11508), 1,
      sym__splice_dollar,
    ACTIONS(11510), 1,
      sym_quasiquote_start,
    ACTIONS(13304), 1,
      sym__conid,
    ACTIONS(16484), 1,
      sym__varid,
    ACTIONS(16490), 1,
      anon_sym_LPAREN,
    ACTIONS(16492), 1,
      anon_sym_LBRACK,
    ACTIONS(16494), 1,
      anon_sym_SQUOTE,
    STATE(2061), 1,
      sym__unboxed_open,
    STATE(8801), 1,
      sym_constructor,
    STATE(16970), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16488), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16496), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16486), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9184), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9025), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9311), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131260] = 21,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(13181), 1,
      anon_sym_u27e6,
    ACTIONS(13183), 1,
      sym__splice_dollar,
    ACTIONS(13185), 1,
      sym_quasiquote_start,
    ACTIONS(15293), 1,
      sym__conid,
    ACTIONS(16498), 1,
      sym__varid,
    ACTIONS(16504), 1,
      anon_sym_LPAREN,
    ACTIONS(16506), 1,
      anon_sym_LBRACK,
    ACTIONS(16508), 1,
      anon_sym_SQUOTE,
    STATE(2138), 1,
      sym__unboxed_open,
    STATE(14816), 1,
      sym_constructor,
    STATE(17631), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16502), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16510), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16500), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15490), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15486), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15012), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131353] = 21,
    ACTIONS(169), 1,
      sym__integer_literal,
    ACTIONS(225), 1,
      anon_sym_u27e6,
    ACTIONS(229), 1,
      sym__splice_dollar,
    ACTIONS(231), 1,
      sym_quasiquote_start,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(16512), 1,
      sym__varid,
    ACTIONS(16518), 1,
      anon_sym_LPAREN,
    ACTIONS(16520), 1,
      anon_sym_LBRACK,
    ACTIONS(16522), 1,
      anon_sym_SQUOTE,
    STATE(2169), 1,
      sym__unboxed_open,
    STATE(4557), 1,
      sym_constructor,
    STATE(16835), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16516), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16524), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(171), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16514), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4848), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4843), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5306), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131446] = 21,
    ACTIONS(551), 1,
      sym__integer_literal,
    ACTIONS(585), 1,
      anon_sym_u27e6,
    ACTIONS(587), 1,
      sym__splice_dollar,
    ACTIONS(591), 1,
      sym_quasiquote_start,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(16298), 1,
      sym__varid,
    ACTIONS(16304), 1,
      anon_sym_LPAREN,
    ACTIONS(16306), 1,
      anon_sym_LBRACK,
    ACTIONS(16308), 1,
      anon_sym_SQUOTE,
    STATE(2155), 1,
      sym__unboxed_open,
    STATE(4540), 1,
      sym_constructor,
    STATE(16328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16302), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16310), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(553), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16300), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5202), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5592), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131539] = 21,
    ACTIONS(4503), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(4527), 1,
      anon_sym_u27e6,
    ACTIONS(4529), 1,
      sym__splice_dollar,
    ACTIONS(4531), 1,
      sym_quasiquote_start,
    ACTIONS(16284), 1,
      sym__varid,
    ACTIONS(16290), 1,
      anon_sym_LPAREN,
    ACTIONS(16292), 1,
      anon_sym_LBRACK,
    ACTIONS(16294), 1,
      anon_sym_SQUOTE,
    STATE(2121), 1,
      sym__unboxed_open,
    STATE(10815), 1,
      sym_constructor,
    STATE(17204), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16288), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16296), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4505), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16286), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11090), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11076), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131632] = 21,
    ACTIONS(8219), 1,
      sym__integer_literal,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(8231), 1,
      anon_sym_LBRACK,
    ACTIONS(8233), 1,
      anon_sym_SQUOTE,
    ACTIONS(8237), 1,
      anon_sym_u27e6,
    ACTIONS(8239), 1,
      sym__splice_dollar,
    ACTIONS(8241), 1,
      sym_quasiquote_start,
    ACTIONS(10066), 1,
      sym__varid,
    ACTIONS(10068), 1,
      anon_sym_LPAREN,
    STATE(2195), 1,
      sym__unboxed_open,
    STATE(7746), 1,
      sym_constructor,
    STATE(16892), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8223), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8235), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8217), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8221), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7972), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8056), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131725] = 21,
    ACTIONS(169), 1,
      sym__integer_literal,
    ACTIONS(225), 1,
      anon_sym_u27e6,
    ACTIONS(229), 1,
      sym__splice_dollar,
    ACTIONS(231), 1,
      sym_quasiquote_start,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(16512), 1,
      sym__varid,
    ACTIONS(16518), 1,
      anon_sym_LPAREN,
    ACTIONS(16520), 1,
      anon_sym_LBRACK,
    ACTIONS(16522), 1,
      anon_sym_SQUOTE,
    STATE(2169), 1,
      sym__unboxed_open,
    STATE(4557), 1,
      sym_constructor,
    STATE(16835), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16516), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16524), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(171), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16514), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4848), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4843), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6301), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131818] = 21,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(12357), 1,
      anon_sym_u27e6,
    ACTIONS(12359), 1,
      sym__splice_dollar,
    ACTIONS(12361), 1,
      sym_quasiquote_start,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(16526), 1,
      sym__varid,
    ACTIONS(16532), 1,
      anon_sym_LPAREN,
    ACTIONS(16534), 1,
      anon_sym_LBRACK,
    ACTIONS(16536), 1,
      anon_sym_SQUOTE,
    STATE(2164), 1,
      sym__unboxed_open,
    STATE(8908), 1,
      sym_constructor,
    STATE(16826), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16530), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16538), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16528), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9525), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9523), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9632), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [131911] = 21,
    ACTIONS(6977), 1,
      sym__varid,
    ACTIONS(6981), 1,
      sym__integer_literal,
    ACTIONS(6987), 1,
      anon_sym_LPAREN,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(7001), 1,
      anon_sym_u27e6,
    ACTIONS(7003), 1,
      sym__splice_dollar,
    ACTIONS(7005), 1,
      sym_quasiquote_start,
    ACTIONS(8043), 1,
      sym__conid,
    ACTIONS(8045), 1,
      anon_sym_SQUOTE,
    STATE(2163), 1,
      sym__unboxed_open,
    STATE(6467), 1,
      sym_constructor,
    STATE(16822), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6985), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6997), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7012), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7030), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6894), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132004] = 21,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(16074), 1,
      sym__varid,
    ACTIONS(16080), 1,
      anon_sym_LPAREN,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(16084), 1,
      anon_sym_SQUOTE,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(10349), 1,
      sym_constructor,
    STATE(16807), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16078), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16086), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16076), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10516), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10574), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10602), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132097] = 21,
    ACTIONS(2799), 1,
      sym__integer_literal,
    ACTIONS(2831), 1,
      anon_sym_u27e6,
    ACTIONS(2833), 1,
      sym__splice_dollar,
    ACTIONS(2835), 1,
      sym_quasiquote_start,
    ACTIONS(4435), 1,
      sym__conid,
    ACTIONS(16158), 1,
      sym__varid,
    ACTIONS(16164), 1,
      anon_sym_LPAREN,
    ACTIONS(16166), 1,
      anon_sym_LBRACK,
    ACTIONS(16168), 1,
      anon_sym_SQUOTE,
    STATE(2172), 1,
      sym__unboxed_open,
    STATE(4930), 1,
      sym_constructor,
    STATE(16344), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16162), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16170), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2801), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16160), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5759), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5755), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5829), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132190] = 21,
    ACTIONS(8488), 1,
      sym__integer_literal,
    ACTIONS(8498), 1,
      sym__conid,
    ACTIONS(8500), 1,
      anon_sym_LBRACK,
    ACTIONS(8502), 1,
      anon_sym_SQUOTE,
    ACTIONS(8506), 1,
      anon_sym_u27e6,
    ACTIONS(8508), 1,
      sym__splice_dollar,
    ACTIONS(8510), 1,
      sym_quasiquote_start,
    ACTIONS(9676), 1,
      anon_sym_LPAREN,
    ACTIONS(15279), 1,
      sym__varid,
    STATE(2187), 1,
      sym__unboxed_open,
    STATE(7360), 1,
      sym_constructor,
    STATE(17439), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8492), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8504), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8486), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8490), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7844), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7774), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132283] = 21,
    ACTIONS(9312), 1,
      sym__integer_literal,
    ACTIONS(9322), 1,
      sym__conid,
    ACTIONS(9336), 1,
      anon_sym_u27e6,
    ACTIONS(9338), 1,
      sym__splice_dollar,
    ACTIONS(9340), 1,
      sym_quasiquote_start,
    ACTIONS(16456), 1,
      sym__varid,
    ACTIONS(16462), 1,
      anon_sym_LPAREN,
    ACTIONS(16464), 1,
      anon_sym_LBRACK,
    ACTIONS(16466), 1,
      anon_sym_SQUOTE,
    STATE(2137), 1,
      sym__unboxed_open,
    STATE(11554), 1,
      sym_constructor,
    STATE(17413), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16460), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16468), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16458), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12342), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12998), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132376] = 21,
    ACTIONS(243), 1,
      sym__integer_literal,
    ACTIONS(281), 1,
      anon_sym_u27e6,
    ACTIONS(283), 1,
      sym__splice_dollar,
    ACTIONS(291), 1,
      sym_quasiquote_start,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(15704), 1,
      sym__varid,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    ACTIONS(15712), 1,
      anon_sym_LBRACK,
    ACTIONS(15714), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(4121), 1,
      sym_constructor,
    STATE(17456), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15708), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15716), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(245), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15706), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4178), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4190), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6167), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132469] = 21,
    ACTIONS(2900), 1,
      sym__integer_literal,
    ACTIONS(2931), 1,
      anon_sym_u27e6,
    ACTIONS(2933), 1,
      sym__splice_dollar,
    ACTIONS(2935), 1,
      sym_quasiquote_start,
    ACTIONS(4453), 1,
      sym__conid,
    ACTIONS(16540), 1,
      sym__varid,
    ACTIONS(16546), 1,
      anon_sym_LPAREN,
    ACTIONS(16548), 1,
      anon_sym_LBRACK,
    ACTIONS(16550), 1,
      anon_sym_SQUOTE,
    STATE(2145), 1,
      sym__unboxed_open,
    STATE(5020), 1,
      sym_constructor,
    STATE(17082), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16544), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16552), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2902), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16542), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5609), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5671), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5378), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132562] = 21,
    ACTIONS(4679), 1,
      sym__integer_literal,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(4703), 1,
      anon_sym_u27e6,
    ACTIONS(4705), 1,
      sym__splice_dollar,
    ACTIONS(4707), 1,
      sym_quasiquote_start,
    ACTIONS(15678), 1,
      sym__varid,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_SQUOTE,
    STATE(2078), 1,
      sym__unboxed_open,
    STATE(11201), 1,
      sym_constructor,
    STATE(17073), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15682), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15690), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4681), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15680), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12037), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12164), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132655] = 21,
    ACTIONS(7187), 1,
      sym__varid,
    ACTIONS(7191), 1,
      sym__integer_literal,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7202), 1,
      anon_sym_LBRACK,
    ACTIONS(7211), 1,
      anon_sym_u27e6,
    ACTIONS(7213), 1,
      sym__splice_dollar,
    ACTIONS(7215), 1,
      sym_quasiquote_start,
    ACTIONS(8660), 1,
      sym__conid,
    ACTIONS(8662), 1,
      anon_sym_SQUOTE,
    STATE(2094), 1,
      sym__unboxed_open,
    STATE(6426), 1,
      sym_constructor,
    STATE(17409), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7195), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7207), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7189), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7193), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6876), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6961), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6967), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132748] = 21,
    ACTIONS(2900), 1,
      sym__integer_literal,
    ACTIONS(2931), 1,
      anon_sym_u27e6,
    ACTIONS(2933), 1,
      sym__splice_dollar,
    ACTIONS(2935), 1,
      sym_quasiquote_start,
    ACTIONS(4453), 1,
      sym__conid,
    ACTIONS(16540), 1,
      sym__varid,
    ACTIONS(16546), 1,
      anon_sym_LPAREN,
    ACTIONS(16548), 1,
      anon_sym_LBRACK,
    ACTIONS(16550), 1,
      anon_sym_SQUOTE,
    STATE(2145), 1,
      sym__unboxed_open,
    STATE(5020), 1,
      sym_constructor,
    STATE(17082), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16544), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16552), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2902), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16542), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5609), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5671), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6215), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132841] = 21,
    ACTIONS(10036), 1,
      sym__integer_literal,
    ACTIONS(10046), 1,
      sym__conid,
    ACTIONS(10060), 1,
      anon_sym_u27e6,
    ACTIONS(10062), 1,
      sym__splice_dollar,
    ACTIONS(10064), 1,
      sym_quasiquote_start,
    ACTIONS(16554), 1,
      sym__varid,
    ACTIONS(16560), 1,
      anon_sym_LPAREN,
    ACTIONS(16562), 1,
      anon_sym_LBRACK,
    ACTIONS(16564), 1,
      anon_sym_SQUOTE,
    STATE(2134), 1,
      sym__unboxed_open,
    STATE(12741), 1,
      sym_constructor,
    STATE(17079), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16558), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16566), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10038), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16556), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12905), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12994), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12946), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [132934] = 21,
    ACTIONS(4733), 1,
      sym__integer_literal,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(4747), 1,
      anon_sym_u27e6,
    ACTIONS(4749), 1,
      sym__splice_dollar,
    ACTIONS(4751), 1,
      sym_quasiquote_start,
    ACTIONS(16214), 1,
      sym__varid,
    ACTIONS(16220), 1,
      anon_sym_LPAREN,
    ACTIONS(16222), 1,
      anon_sym_LBRACK,
    ACTIONS(16224), 1,
      anon_sym_SQUOTE,
    STATE(2072), 1,
      sym__unboxed_open,
    STATE(12073), 1,
      sym_constructor,
    STATE(16485), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16218), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16226), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4735), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16216), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12145), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12150), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13522), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133027] = 21,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(15421), 1,
      sym__integer_literal,
    ACTIONS(15427), 1,
      anon_sym_LPAREN,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(15431), 1,
      anon_sym_LBRACK,
    ACTIONS(15433), 1,
      anon_sym_SQUOTE,
    ACTIONS(15439), 1,
      anon_sym_u27e6,
    ACTIONS(15441), 1,
      sym__splice_dollar,
    ACTIONS(15443), 1,
      sym_quasiquote_start,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(14469), 1,
      sym_constructor,
    STATE(16910), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15425), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15437), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15419), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15423), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14675), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15555), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133120] = 21,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(15421), 1,
      sym__integer_literal,
    ACTIONS(15427), 1,
      anon_sym_LPAREN,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(15431), 1,
      anon_sym_LBRACK,
    ACTIONS(15433), 1,
      anon_sym_SQUOTE,
    ACTIONS(15439), 1,
      anon_sym_u27e6,
    ACTIONS(15441), 1,
      sym__splice_dollar,
    ACTIONS(15443), 1,
      sym_quasiquote_start,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(14469), 1,
      sym_constructor,
    STATE(16910), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15425), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15437), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(15419), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15423), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14675), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15556), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133213] = 21,
    ACTIONS(3567), 1,
      sym__integer_literal,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(3593), 1,
      anon_sym_u27e6,
    ACTIONS(3595), 1,
      sym__splice_dollar,
    ACTIONS(3597), 1,
      sym_quasiquote_start,
    ACTIONS(16032), 1,
      sym__varid,
    ACTIONS(16038), 1,
      anon_sym_LPAREN,
    ACTIONS(16040), 1,
      anon_sym_LBRACK,
    ACTIONS(16042), 1,
      anon_sym_SQUOTE,
    STATE(2200), 1,
      sym__unboxed_open,
    STATE(10629), 1,
      sym_constructor,
    STATE(16927), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16036), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16044), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16034), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10769), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12929), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133306] = 21,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(16228), 1,
      sym__varid,
    ACTIONS(16234), 1,
      anon_sym_LPAREN,
    ACTIONS(16236), 1,
      anon_sym_LBRACK,
    ACTIONS(16238), 1,
      anon_sym_SQUOTE,
    STATE(2136), 1,
      sym__unboxed_open,
    STATE(10389), 1,
      sym_constructor,
    STATE(17691), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16232), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16240), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16230), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10501), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10535), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12877), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133399] = 21,
    ACTIONS(7307), 1,
      sym__varid,
    ACTIONS(7311), 1,
      sym__integer_literal,
    ACTIONS(7317), 1,
      anon_sym_LPAREN,
    ACTIONS(7322), 1,
      anon_sym_LBRACK,
    ACTIONS(7331), 1,
      anon_sym_u27e6,
    ACTIONS(7333), 1,
      sym__splice_dollar,
    ACTIONS(7335), 1,
      sym_quasiquote_start,
    ACTIONS(7911), 1,
      sym__conid,
    ACTIONS(7913), 1,
      anon_sym_SQUOTE,
    STATE(2168), 1,
      sym__unboxed_open,
    STATE(6439), 1,
      sym_constructor,
    STATE(17378), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7315), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7327), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7309), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7313), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6930), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7007), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6862), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133492] = 21,
    ACTIONS(551), 1,
      sym__integer_literal,
    ACTIONS(585), 1,
      anon_sym_u27e6,
    ACTIONS(587), 1,
      sym__splice_dollar,
    ACTIONS(591), 1,
      sym_quasiquote_start,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(16298), 1,
      sym__varid,
    ACTIONS(16304), 1,
      anon_sym_LPAREN,
    ACTIONS(16306), 1,
      anon_sym_LBRACK,
    ACTIONS(16308), 1,
      anon_sym_SQUOTE,
    STATE(2155), 1,
      sym__unboxed_open,
    STATE(4540), 1,
      sym_constructor,
    STATE(16328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16302), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16310), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(553), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16300), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5202), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5289), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133585] = 21,
    ACTIONS(9920), 1,
      sym__integer_literal,
    ACTIONS(9930), 1,
      sym__conid,
    ACTIONS(9944), 1,
      anon_sym_u27e6,
    ACTIONS(9946), 1,
      sym__splice_dollar,
    ACTIONS(9948), 1,
      sym_quasiquote_start,
    ACTIONS(16372), 1,
      sym__varid,
    ACTIONS(16378), 1,
      anon_sym_LPAREN,
    ACTIONS(16380), 1,
      anon_sym_LBRACK,
    ACTIONS(16382), 1,
      anon_sym_SQUOTE,
    STATE(2109), 1,
      sym__unboxed_open,
    STATE(11715), 1,
      sym_constructor,
    STATE(16706), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16376), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16384), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9922), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16374), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12545), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12543), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12416), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133678] = 21,
    ACTIONS(10036), 1,
      sym__integer_literal,
    ACTIONS(10046), 1,
      sym__conid,
    ACTIONS(10060), 1,
      anon_sym_u27e6,
    ACTIONS(10062), 1,
      sym__splice_dollar,
    ACTIONS(10064), 1,
      sym_quasiquote_start,
    ACTIONS(16554), 1,
      sym__varid,
    ACTIONS(16560), 1,
      anon_sym_LPAREN,
    ACTIONS(16562), 1,
      anon_sym_LBRACK,
    ACTIONS(16564), 1,
      anon_sym_SQUOTE,
    STATE(2134), 1,
      sym__unboxed_open,
    STATE(12741), 1,
      sym_constructor,
    STATE(17079), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16558), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16566), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10038), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16556), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12905), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12994), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13524), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133771] = 21,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(12634), 1,
      anon_sym_u27e6,
    ACTIONS(12636), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    ACTIONS(16568), 1,
      sym__varid,
    ACTIONS(16574), 1,
      anon_sym_LPAREN,
    ACTIONS(16576), 1,
      anon_sym_LBRACK,
    ACTIONS(16578), 1,
      anon_sym_SQUOTE,
    STATE(2192), 1,
      sym__unboxed_open,
    STATE(9353), 1,
      sym_constructor,
    STATE(16977), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16572), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16580), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16570), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9840), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9843), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9670), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133864] = 21,
    ACTIONS(2287), 1,
      sym__integer_literal,
    ACTIONS(2319), 1,
      anon_sym_u27e6,
    ACTIONS(2321), 1,
      sym__splice_dollar,
    ACTIONS(2323), 1,
      sym_quasiquote_start,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(16582), 1,
      sym__varid,
    ACTIONS(16588), 1,
      anon_sym_LPAREN,
    ACTIONS(16590), 1,
      anon_sym_LBRACK,
    ACTIONS(16592), 1,
      anon_sym_SQUOTE,
    STATE(2144), 1,
      sym__unboxed_open,
    STATE(4572), 1,
      sym_constructor,
    STATE(17051), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16586), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16594), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2289), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16584), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4991), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4950), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5061), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [133957] = 21,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(11365), 1,
      anon_sym_u27e6,
    ACTIONS(11367), 1,
      sym__splice_dollar,
    ACTIONS(11369), 1,
      sym_quasiquote_start,
    ACTIONS(16596), 1,
      sym__varid,
    ACTIONS(16602), 1,
      anon_sym_LPAREN,
    ACTIONS(16604), 1,
      anon_sym_LBRACK,
    ACTIONS(16606), 1,
      anon_sym_SQUOTE,
    STATE(2182), 1,
      sym__unboxed_open,
    STATE(8726), 1,
      sym_constructor,
    STATE(16565), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16600), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16608), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16598), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8951), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8949), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9214), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134050] = 21,
    ACTIONS(6805), 1,
      sym__integer_literal,
    ACTIONS(6811), 1,
      anon_sym_LPAREN,
    ACTIONS(6816), 1,
      anon_sym_LBRACK,
    ACTIONS(6825), 1,
      anon_sym_u27e6,
    ACTIONS(6827), 1,
      sym__splice_dollar,
    ACTIONS(6829), 1,
      sym_quasiquote_start,
    ACTIONS(8516), 1,
      sym__conid,
    ACTIONS(8518), 1,
      anon_sym_SQUOTE,
    ACTIONS(15287), 1,
      sym__varid,
    STATE(2076), 1,
      sym__unboxed_open,
    STATE(6256), 1,
      sym_constructor,
    STATE(17742), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6809), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6821), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6803), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6807), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6375), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6376), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6581), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134143] = 21,
    ACTIONS(243), 1,
      sym__integer_literal,
    ACTIONS(281), 1,
      anon_sym_u27e6,
    ACTIONS(283), 1,
      sym__splice_dollar,
    ACTIONS(291), 1,
      sym_quasiquote_start,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(15704), 1,
      sym__varid,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    ACTIONS(15712), 1,
      anon_sym_LBRACK,
    ACTIONS(15714), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(4121), 1,
      sym_constructor,
    STATE(17456), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15708), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15716), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(245), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15706), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4178), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4190), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4409), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134236] = 21,
    ACTIONS(12738), 1,
      sym__integer_literal,
    ACTIONS(12744), 1,
      anon_sym_LPAREN,
    ACTIONS(12746), 1,
      sym__conid,
    ACTIONS(12748), 1,
      anon_sym_LBRACK,
    ACTIONS(12750), 1,
      anon_sym_SQUOTE,
    ACTIONS(12754), 1,
      anon_sym_u27e6,
    ACTIONS(12756), 1,
      sym__splice_dollar,
    ACTIONS(12758), 1,
      sym_quasiquote_start,
    ACTIONS(16610), 1,
      sym__varid,
    STATE(2092), 1,
      sym__unboxed_open,
    STATE(8742), 1,
      sym_constructor,
    STATE(17545), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12742), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12752), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12736), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12740), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9038), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9037), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9122), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134329] = 21,
    ACTIONS(12738), 1,
      sym__integer_literal,
    ACTIONS(12744), 1,
      anon_sym_LPAREN,
    ACTIONS(12746), 1,
      sym__conid,
    ACTIONS(12748), 1,
      anon_sym_LBRACK,
    ACTIONS(12750), 1,
      anon_sym_SQUOTE,
    ACTIONS(12754), 1,
      anon_sym_u27e6,
    ACTIONS(12756), 1,
      sym__splice_dollar,
    ACTIONS(12758), 1,
      sym_quasiquote_start,
    ACTIONS(16610), 1,
      sym__varid,
    STATE(2092), 1,
      sym__unboxed_open,
    STATE(8742), 1,
      sym_constructor,
    STATE(17545), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12742), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12752), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12736), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12740), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9038), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9037), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9125), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134422] = 21,
    ACTIONS(8764), 1,
      sym__integer_literal,
    ACTIONS(8774), 1,
      sym__conid,
    ACTIONS(8776), 1,
      anon_sym_LBRACK,
    ACTIONS(8778), 1,
      anon_sym_SQUOTE,
    ACTIONS(8782), 1,
      anon_sym_u27e6,
    ACTIONS(8784), 1,
      sym__splice_dollar,
    ACTIONS(8786), 1,
      sym_quasiquote_start,
    ACTIONS(8840), 1,
      sym__varid,
    ACTIONS(8842), 1,
      anon_sym_LPAREN,
    STATE(2154), 1,
      sym__unboxed_open,
    STATE(6951), 1,
      sym_constructor,
    STATE(17346), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8768), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8766), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7095), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7033), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7199), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134515] = 21,
    ACTIONS(3162), 1,
      sym__integer_literal,
    ACTIONS(3193), 1,
      anon_sym_u27e6,
    ACTIONS(3195), 1,
      sym__splice_dollar,
    ACTIONS(3197), 1,
      sym_quasiquote_start,
    ACTIONS(4483), 1,
      sym__conid,
    ACTIONS(16612), 1,
      sym__varid,
    ACTIONS(16618), 1,
      anon_sym_LPAREN,
    ACTIONS(16620), 1,
      anon_sym_LBRACK,
    ACTIONS(16622), 1,
      anon_sym_SQUOTE,
    STATE(2139), 1,
      sym__unboxed_open,
    STATE(5410), 1,
      sym_constructor,
    STATE(16805), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16616), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16624), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3164), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16614), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6216), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6219), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6644), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134608] = 21,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11867), 1,
      anon_sym_LPAREN,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(11881), 1,
      anon_sym_u27e6,
    ACTIONS(11883), 1,
      sym__splice_dollar,
    ACTIONS(11885), 1,
      sym_quasiquote_start,
    ACTIONS(13519), 1,
      sym__varid,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(13523), 1,
      anon_sym_SQUOTE,
    STATE(2082), 1,
      sym__unboxed_open,
    STATE(8368), 1,
      sym_constructor,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6106), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11877), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8581), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134701] = 21,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(16074), 1,
      sym__varid,
    ACTIONS(16080), 1,
      anon_sym_LPAREN,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(16084), 1,
      anon_sym_SQUOTE,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(10349), 1,
      sym_constructor,
    STATE(16807), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16078), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16086), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16076), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10516), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10574), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10659), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134794] = 21,
    ACTIONS(3567), 1,
      sym__integer_literal,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(3593), 1,
      anon_sym_u27e6,
    ACTIONS(3595), 1,
      sym__splice_dollar,
    ACTIONS(3597), 1,
      sym_quasiquote_start,
    ACTIONS(16032), 1,
      sym__varid,
    ACTIONS(16038), 1,
      anon_sym_LPAREN,
    ACTIONS(16040), 1,
      anon_sym_LBRACK,
    ACTIONS(16042), 1,
      anon_sym_SQUOTE,
    STATE(2200), 1,
      sym__unboxed_open,
    STATE(10629), 1,
      sym_constructor,
    STATE(16927), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16036), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16044), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16034), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10769), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11522), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134887] = 21,
    ACTIONS(5696), 1,
      sym__integer_literal,
    ACTIONS(5706), 1,
      sym__conid,
    ACTIONS(5708), 1,
      anon_sym_LBRACK,
    ACTIONS(5710), 1,
      anon_sym_SQUOTE,
    ACTIONS(5716), 1,
      anon_sym_u27e6,
    ACTIONS(5718), 1,
      sym__splice_dollar,
    ACTIONS(5720), 1,
      sym_quasiquote_start,
    ACTIONS(9416), 1,
      sym__varid,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    STATE(2142), 1,
      sym__unboxed_open,
    STATE(7530), 1,
      sym_constructor,
    STATE(17716), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5700), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5714), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5694), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5698), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7799), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7869), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [134980] = 21,
    ACTIONS(9516), 1,
      sym__integer_literal,
    ACTIONS(9526), 1,
      sym__conid,
    ACTIONS(9540), 1,
      anon_sym_u27e6,
    ACTIONS(9542), 1,
      sym__splice_dollar,
    ACTIONS(9544), 1,
      sym_quasiquote_start,
    ACTIONS(16626), 1,
      sym__varid,
    ACTIONS(16632), 1,
      anon_sym_LPAREN,
    ACTIONS(16634), 1,
      anon_sym_LBRACK,
    ACTIONS(16636), 1,
      anon_sym_SQUOTE,
    STATE(2088), 1,
      sym__unboxed_open,
    STATE(11959), 1,
      sym_constructor,
    STATE(17052), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16630), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16638), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9518), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12645), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12450), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12753), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135073] = 21,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(11091), 1,
      anon_sym_u27e6,
    ACTIONS(11093), 1,
      sym__splice_dollar,
    ACTIONS(11095), 1,
      sym_quasiquote_start,
    ACTIONS(15299), 1,
      sym__conid,
    ACTIONS(16130), 1,
      sym__varid,
    ACTIONS(16136), 1,
      anon_sym_LPAREN,
    ACTIONS(16138), 1,
      anon_sym_LBRACK,
    ACTIONS(16140), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      sym__unboxed_open,
    STATE(13541), 1,
      sym_constructor,
    STATE(16814), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16134), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16142), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16132), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13712), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(13771), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13627), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135166] = 21,
    ACTIONS(1097), 1,
      sym__integer_literal,
    ACTIONS(1117), 1,
      anon_sym_u27e6,
    ACTIONS(1119), 1,
      sym__splice_dollar,
    ACTIONS(1121), 1,
      sym_quasiquote_start,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(16088), 1,
      sym__varid,
    ACTIONS(16094), 1,
      anon_sym_LPAREN,
    ACTIONS(16096), 1,
      anon_sym_LBRACK,
    ACTIONS(16098), 1,
      anon_sym_SQUOTE,
    STATE(2179), 1,
      sym__unboxed_open,
    STATE(4703), 1,
      sym_constructor,
    STATE(16690), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16092), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16100), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1099), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16090), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5052), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5057), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6626), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135259] = 21,
    ACTIONS(8255), 1,
      sym__integer_literal,
    ACTIONS(8265), 1,
      sym__conid,
    ACTIONS(8267), 1,
      anon_sym_LBRACK,
    ACTIONS(8269), 1,
      anon_sym_SQUOTE,
    ACTIONS(8273), 1,
      anon_sym_u27e6,
    ACTIONS(8275), 1,
      sym__splice_dollar,
    ACTIONS(8277), 1,
      sym_quasiquote_start,
    ACTIONS(8998), 1,
      sym__varid,
    ACTIONS(9000), 1,
      anon_sym_LPAREN,
    STATE(2069), 1,
      sym__unboxed_open,
    STATE(7041), 1,
      sym_constructor,
    STATE(17310), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8259), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8271), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8253), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8257), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7296), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7271), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7418), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135352] = 21,
    ACTIONS(9516), 1,
      sym__integer_literal,
    ACTIONS(9526), 1,
      sym__conid,
    ACTIONS(9540), 1,
      anon_sym_u27e6,
    ACTIONS(9542), 1,
      sym__splice_dollar,
    ACTIONS(9544), 1,
      sym_quasiquote_start,
    ACTIONS(16626), 1,
      sym__varid,
    ACTIONS(16632), 1,
      anon_sym_LPAREN,
    ACTIONS(16634), 1,
      anon_sym_LBRACK,
    ACTIONS(16636), 1,
      anon_sym_SQUOTE,
    STATE(2088), 1,
      sym__unboxed_open,
    STATE(11959), 1,
      sym_constructor,
    STATE(17052), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16630), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16638), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9518), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12645), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12450), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13103), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135445] = 21,
    ACTIONS(2754), 1,
      sym__integer_literal,
    ACTIONS(2786), 1,
      anon_sym_u27e6,
    ACTIONS(2788), 1,
      sym__splice_dollar,
    ACTIONS(2790), 1,
      sym_quasiquote_start,
    ACTIONS(4603), 1,
      sym__conid,
    ACTIONS(16640), 1,
      sym__varid,
    ACTIONS(16646), 1,
      anon_sym_LPAREN,
    ACTIONS(16648), 1,
      anon_sym_LBRACK,
    ACTIONS(16650), 1,
      anon_sym_SQUOTE,
    STATE(2128), 1,
      sym__unboxed_open,
    STATE(4923), 1,
      sym_constructor,
    STATE(17048), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16644), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16652), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2756), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16642), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5762), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5806), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5779), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135538] = 6,
    ACTIONS(16654), 1,
      anon_sym_LBRACE,
    ACTIONS(16657), 1,
      sym__layout_start,
    STATE(4200), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 14,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [135601] = 21,
    ACTIONS(8307), 1,
      sym__integer_literal,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_LBRACK,
    ACTIONS(8319), 1,
      anon_sym_SQUOTE,
    ACTIONS(8323), 1,
      anon_sym_u27e6,
    ACTIONS(8325), 1,
      sym__splice_dollar,
    ACTIONS(8327), 1,
      sym_quasiquote_start,
    ACTIONS(9112), 1,
      anon_sym_LPAREN,
    ACTIONS(13406), 1,
      sym__varid,
    STATE(2099), 1,
      sym__unboxed_open,
    STATE(7250), 1,
      sym_constructor,
    STATE(16496), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8321), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7626), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7589), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7678), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135694] = 21,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7017), 1,
      anon_sym_LPAREN,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(7031), 1,
      anon_sym_u27e6,
    ACTIONS(7033), 1,
      sym__splice_dollar,
    ACTIONS(7035), 1,
      sym_quasiquote_start,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(8249), 1,
      anon_sym_SQUOTE,
    ACTIONS(13531), 1,
      sym__varid,
    STATE(2085), 1,
      sym__unboxed_open,
    STATE(6430), 1,
      sym_constructor,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7015), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7027), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6974), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135787] = 21,
    ACTIONS(8404), 1,
      sym__integer_literal,
    ACTIONS(8414), 1,
      sym__conid,
    ACTIONS(8416), 1,
      anon_sym_LBRACK,
    ACTIONS(8418), 1,
      anon_sym_SQUOTE,
    ACTIONS(8422), 1,
      anon_sym_u27e6,
    ACTIONS(8424), 1,
      sym__splice_dollar,
    ACTIONS(8426), 1,
      sym_quasiquote_start,
    ACTIONS(8908), 1,
      sym__varid,
    ACTIONS(8910), 1,
      anon_sym_LPAREN,
    STATE(2074), 1,
      sym__unboxed_open,
    STATE(7035), 1,
      sym_constructor,
    STATE(17287), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8408), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8420), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8402), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8406), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7282), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7259), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7373), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135880] = 21,
    ACTIONS(2754), 1,
      sym__integer_literal,
    ACTIONS(2786), 1,
      anon_sym_u27e6,
    ACTIONS(2788), 1,
      sym__splice_dollar,
    ACTIONS(2790), 1,
      sym_quasiquote_start,
    ACTIONS(4603), 1,
      sym__conid,
    ACTIONS(16640), 1,
      sym__varid,
    ACTIONS(16646), 1,
      anon_sym_LPAREN,
    ACTIONS(16648), 1,
      anon_sym_LBRACK,
    ACTIONS(16650), 1,
      anon_sym_SQUOTE,
    STATE(2128), 1,
      sym__unboxed_open,
    STATE(4923), 1,
      sym_constructor,
    STATE(17048), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16644), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16652), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2756), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16642), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5762), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5806), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5895), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [135973] = 21,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12266), 1,
      anon_sym_u27e6,
    ACTIONS(12268), 1,
      sym__splice_dollar,
    ACTIONS(12270), 1,
      sym_quasiquote_start,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(16659), 1,
      sym__varid,
    ACTIONS(16665), 1,
      anon_sym_LPAREN,
    ACTIONS(16667), 1,
      anon_sym_LBRACK,
    ACTIONS(16669), 1,
      anon_sym_SQUOTE,
    STATE(2147), 1,
      sym__unboxed_open,
    STATE(9254), 1,
      sym_constructor,
    STATE(17821), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16663), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16671), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16661), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9569), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9571), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9507), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136066] = 21,
    ACTIONS(1448), 1,
      sym__integer_literal,
    ACTIONS(1480), 1,
      anon_sym_u27e6,
    ACTIONS(1482), 1,
      sym__splice_dollar,
    ACTIONS(1484), 1,
      sym_quasiquote_start,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(16673), 1,
      sym__varid,
    ACTIONS(16679), 1,
      anon_sym_LPAREN,
    ACTIONS(16681), 1,
      anon_sym_LBRACK,
    ACTIONS(16683), 1,
      anon_sym_SQUOTE,
    STATE(2181), 1,
      sym__unboxed_open,
    STATE(4350), 1,
      sym_constructor,
    STATE(17602), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16677), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16685), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1450), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4458), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4673), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136159] = 21,
    ACTIONS(9278), 1,
      sym__integer_literal,
    ACTIONS(9288), 1,
      sym__conid,
    ACTIONS(9302), 1,
      anon_sym_u27e6,
    ACTIONS(9304), 1,
      sym__splice_dollar,
    ACTIONS(9306), 1,
      sym_quasiquote_start,
    ACTIONS(16687), 1,
      sym__varid,
    ACTIONS(16693), 1,
      anon_sym_LPAREN,
    ACTIONS(16695), 1,
      anon_sym_LBRACK,
    ACTIONS(16697), 1,
      anon_sym_SQUOTE,
    STATE(2199), 1,
      sym__unboxed_open,
    STATE(10749), 1,
      sym_constructor,
    STATE(16996), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16691), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16699), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16689), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10835), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10787), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10816), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136252] = 21,
    ACTIONS(243), 1,
      sym__integer_literal,
    ACTIONS(281), 1,
      anon_sym_u27e6,
    ACTIONS(283), 1,
      sym__splice_dollar,
    ACTIONS(291), 1,
      sym_quasiquote_start,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(15704), 1,
      sym__varid,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    ACTIONS(15712), 1,
      anon_sym_LBRACK,
    ACTIONS(15714), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(4121), 1,
      sym_constructor,
    STATE(17456), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15708), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15716), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(245), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15706), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4178), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4190), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4636), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136345] = 21,
    ACTIONS(7793), 1,
      sym__integer_literal,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(7805), 1,
      anon_sym_LBRACK,
    ACTIONS(7807), 1,
      anon_sym_SQUOTE,
    ACTIONS(7811), 1,
      anon_sym_u27e6,
    ACTIONS(7813), 1,
      sym__splice_dollar,
    ACTIONS(7815), 1,
      sym_quasiquote_start,
    ACTIONS(10136), 1,
      anon_sym_LPAREN,
    ACTIONS(13932), 1,
      sym__varid,
    STATE(2113), 1,
      sym__unboxed_open,
    STATE(7673), 1,
      sym_constructor,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7797), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7809), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8101), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8026), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8116), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136438] = 21,
    ACTIONS(4543), 1,
      sym__integer_literal,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(4567), 1,
      anon_sym_u27e6,
    ACTIONS(4569), 1,
      sym__splice_dollar,
    ACTIONS(4571), 1,
      sym_quasiquote_start,
    ACTIONS(15800), 1,
      sym__varid,
    ACTIONS(15806), 1,
      anon_sym_LPAREN,
    ACTIONS(15808), 1,
      anon_sym_LBRACK,
    ACTIONS(15810), 1,
      anon_sym_SQUOTE,
    STATE(2066), 1,
      sym__unboxed_open,
    STATE(11736), 1,
      sym_constructor,
    STATE(16503), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15804), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15812), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4545), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15802), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12180), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12179), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13024), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136531] = 21,
    ACTIONS(6598), 1,
      sym__varid,
    ACTIONS(6602), 1,
      sym__integer_literal,
    ACTIONS(6608), 1,
      anon_sym_LPAREN,
    ACTIONS(6613), 1,
      anon_sym_LBRACK,
    ACTIONS(6622), 1,
      anon_sym_u27e6,
    ACTIONS(6624), 1,
      sym__splice_dollar,
    ACTIONS(6626), 1,
      sym_quasiquote_start,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_SQUOTE,
    STATE(2197), 1,
      sym__unboxed_open,
    STATE(5965), 1,
      sym_constructor,
    STATE(17828), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6606), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6618), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6600), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6604), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6545), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6546), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6591), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136624] = 21,
    ACTIONS(659), 1,
      sym__integer_literal,
    ACTIONS(683), 1,
      anon_sym_u27e6,
    ACTIONS(685), 1,
      sym__splice_dollar,
    ACTIONS(687), 1,
      sym_quasiquote_start,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(15922), 1,
      sym__varid,
    ACTIONS(15928), 1,
      anon_sym_LPAREN,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(15932), 1,
      anon_sym_SQUOTE,
    STATE(2103), 1,
      sym__unboxed_open,
    STATE(3731), 1,
      sym_constructor,
    STATE(16976), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15926), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15934), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(661), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15924), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3792), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(3763), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4172), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136717] = 21,
    ACTIONS(1582), 1,
      sym__integer_literal,
    ACTIONS(1600), 1,
      anon_sym_u27e6,
    ACTIONS(1602), 1,
      sym__splice_dollar,
    ACTIONS(1604), 1,
      sym_quasiquote_start,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(16326), 1,
      sym__varid,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_LBRACK,
    ACTIONS(16336), 1,
      anon_sym_SQUOTE,
    STATE(2211), 1,
      sym__unboxed_open,
    STATE(5247), 1,
      sym_constructor,
    STATE(17292), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16330), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16338), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1584), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16328), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5272), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6863), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136810] = 21,
    ACTIONS(2643), 1,
      sym__integer_literal,
    ACTIONS(2674), 1,
      anon_sym_u27e6,
    ACTIONS(2676), 1,
      sym__splice_dollar,
    ACTIONS(2678), 1,
      sym_quasiquote_start,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(16242), 1,
      sym__varid,
    ACTIONS(16248), 1,
      anon_sym_LPAREN,
    ACTIONS(16250), 1,
      anon_sym_LBRACK,
    ACTIONS(16252), 1,
      anon_sym_SQUOTE,
    STATE(2125), 1,
      sym__unboxed_open,
    STATE(4780), 1,
      sym_constructor,
    STATE(16789), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16246), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16254), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2645), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16244), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5374), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5371), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5804), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136903] = 21,
    ACTIONS(4639), 1,
      sym__integer_literal,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(4663), 1,
      anon_sym_u27e6,
    ACTIONS(4665), 1,
      sym__splice_dollar,
    ACTIONS(4667), 1,
      sym_quasiquote_start,
    ACTIONS(16442), 1,
      sym__varid,
    ACTIONS(16448), 1,
      anon_sym_LPAREN,
    ACTIONS(16450), 1,
      anon_sym_LBRACK,
    ACTIONS(16452), 1,
      anon_sym_SQUOTE,
    STATE(2153), 1,
      sym__unboxed_open,
    STATE(11399), 1,
      sym_constructor,
    STATE(16538), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16446), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16454), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16444), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11677), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12974), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [136996] = 21,
    ACTIONS(5648), 1,
      sym__integer_literal,
    ACTIONS(5654), 1,
      anon_sym_LPAREN,
    ACTIONS(5659), 1,
      anon_sym_LBRACK,
    ACTIONS(5668), 1,
      anon_sym_u27e6,
    ACTIONS(5670), 1,
      sym__splice_dollar,
    ACTIONS(5672), 1,
      sym_quasiquote_start,
    ACTIONS(7891), 1,
      sym__conid,
    ACTIONS(7893), 1,
      anon_sym_SQUOTE,
    ACTIONS(15197), 1,
      sym__varid,
    STATE(2205), 1,
      sym__unboxed_open,
    STATE(4375), 1,
      sym_constructor,
    STATE(17101), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5652), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5664), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(5646), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5650), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4539), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4704), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4677), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137089] = 21,
    ACTIONS(9278), 1,
      sym__integer_literal,
    ACTIONS(9288), 1,
      sym__conid,
    ACTIONS(9302), 1,
      anon_sym_u27e6,
    ACTIONS(9304), 1,
      sym__splice_dollar,
    ACTIONS(9306), 1,
      sym_quasiquote_start,
    ACTIONS(16687), 1,
      sym__varid,
    ACTIONS(16693), 1,
      anon_sym_LPAREN,
    ACTIONS(16695), 1,
      anon_sym_LBRACK,
    ACTIONS(16697), 1,
      anon_sym_SQUOTE,
    STATE(2199), 1,
      sym__unboxed_open,
    STATE(10749), 1,
      sym_constructor,
    STATE(16996), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16691), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16699), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16689), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10835), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10787), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10957), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137182] = 21,
    ACTIONS(89), 1,
      sym__integer_literal,
    ACTIONS(147), 1,
      anon_sym_u27e6,
    ACTIONS(149), 1,
      sym__splice_dollar,
    ACTIONS(151), 1,
      sym_quasiquote_start,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(16701), 1,
      sym__varid,
    ACTIONS(16707), 1,
      anon_sym_LPAREN,
    ACTIONS(16709), 1,
      anon_sym_LBRACK,
    ACTIONS(16711), 1,
      anon_sym_SQUOTE,
    STATE(2148), 1,
      sym__unboxed_open,
    STATE(3733), 1,
      sym_constructor,
    STATE(16815), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16705), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16713), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(91), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3762), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(3761), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4135), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137275] = 21,
    ACTIONS(7925), 1,
      sym__varid,
    ACTIONS(7929), 1,
      sym__integer_literal,
    ACTIONS(7935), 1,
      anon_sym_LPAREN,
    ACTIONS(7940), 1,
      anon_sym_LBRACK,
    ACTIONS(7949), 1,
      anon_sym_u27e6,
    ACTIONS(7951), 1,
      sym__splice_dollar,
    ACTIONS(7953), 1,
      sym_quasiquote_start,
    ACTIONS(8211), 1,
      sym__conid,
    ACTIONS(8213), 1,
      anon_sym_SQUOTE,
    STATE(2171), 1,
      sym__unboxed_open,
    STATE(6696), 1,
      sym_constructor,
    STATE(16943), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7933), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7945), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(7927), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7931), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7229), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7197), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7177), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137368] = 21,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(10610), 1,
      anon_sym_u27e6,
    ACTIONS(10612), 1,
      sym__splice_dollar,
    ACTIONS(10614), 1,
      sym_quasiquote_start,
    ACTIONS(16715), 1,
      sym__varid,
    ACTIONS(16721), 1,
      anon_sym_LPAREN,
    ACTIONS(16723), 1,
      anon_sym_LBRACK,
    ACTIONS(16725), 1,
      anon_sym_SQUOTE,
    STATE(2159), 1,
      sym__unboxed_open,
    STATE(8408), 1,
      sym_constructor,
    STATE(16343), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16719), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16727), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16717), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8695), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8631), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8614), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137461] = 21,
    ACTIONS(2287), 1,
      sym__integer_literal,
    ACTIONS(2319), 1,
      anon_sym_u27e6,
    ACTIONS(2321), 1,
      sym__splice_dollar,
    ACTIONS(2323), 1,
      sym_quasiquote_start,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(16582), 1,
      sym__varid,
    ACTIONS(16588), 1,
      anon_sym_LPAREN,
    ACTIONS(16590), 1,
      anon_sym_LBRACK,
    ACTIONS(16592), 1,
      anon_sym_SQUOTE,
    STATE(2144), 1,
      sym__unboxed_open,
    STATE(4572), 1,
      sym_constructor,
    STATE(17051), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16586), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16594), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2289), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16584), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4991), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4950), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5643), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137554] = 21,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_u27e6,
    ACTIONS(4881), 1,
      sym__splice_dollar,
    ACTIONS(4883), 1,
      sym_quasiquote_start,
    ACTIONS(16228), 1,
      sym__varid,
    ACTIONS(16234), 1,
      anon_sym_LPAREN,
    ACTIONS(16236), 1,
      anon_sym_LBRACK,
    ACTIONS(16238), 1,
      anon_sym_SQUOTE,
    STATE(2136), 1,
      sym__unboxed_open,
    STATE(10389), 1,
      sym_constructor,
    STATE(17691), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16232), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16240), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16230), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10501), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10535), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15925), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137647] = 21,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4473), 1,
      anon_sym_u27e6,
    ACTIONS(4475), 1,
      sym__splice_dollar,
    ACTIONS(4477), 1,
      sym_quasiquote_start,
    ACTIONS(16074), 1,
      sym__varid,
    ACTIONS(16080), 1,
      anon_sym_LPAREN,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(16084), 1,
      anon_sym_SQUOTE,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(10349), 1,
      sym_constructor,
    STATE(16807), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16078), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16086), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16076), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10516), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10574), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12775), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137740] = 21,
    ACTIONS(9202), 1,
      sym__integer_literal,
    ACTIONS(9212), 1,
      sym__conid,
    ACTIONS(9226), 1,
      anon_sym_u27e6,
    ACTIONS(9228), 1,
      sym__splice_dollar,
    ACTIONS(9230), 1,
      sym_quasiquote_start,
    ACTIONS(16729), 1,
      sym__varid,
    ACTIONS(16735), 1,
      anon_sym_LPAREN,
    ACTIONS(16737), 1,
      anon_sym_LBRACK,
    ACTIONS(16739), 1,
      anon_sym_SQUOTE,
    STATE(2184), 1,
      sym__unboxed_open,
    STATE(11158), 1,
      sym_constructor,
    STATE(16972), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16733), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9204), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16731), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12115), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12034), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11546), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137833] = 21,
    ACTIONS(1387), 1,
      sym__integer_literal,
    ACTIONS(1422), 1,
      anon_sym_u27e6,
    ACTIONS(1424), 1,
      sym__splice_dollar,
    ACTIONS(1426), 1,
      sym_quasiquote_start,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(15848), 1,
      sym__varid,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_SQUOTE,
    STATE(2176), 1,
      sym__unboxed_open,
    STATE(5231), 1,
      sym_constructor,
    STATE(16935), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15852), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15860), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1389), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15850), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5413), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5412), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5891), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [137926] = 21,
    ACTIONS(1448), 1,
      sym__integer_literal,
    ACTIONS(1480), 1,
      anon_sym_u27e6,
    ACTIONS(1482), 1,
      sym__splice_dollar,
    ACTIONS(1484), 1,
      sym_quasiquote_start,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(16673), 1,
      sym__varid,
    ACTIONS(16679), 1,
      anon_sym_LPAREN,
    ACTIONS(16681), 1,
      anon_sym_LBRACK,
    ACTIONS(16683), 1,
      anon_sym_SQUOTE,
    STATE(2181), 1,
      sym__unboxed_open,
    STATE(4350), 1,
      sym_constructor,
    STATE(17602), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16677), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16685), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1450), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4458), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4496), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138019] = 21,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_u27e6,
    ACTIONS(2045), 1,
      sym__splice_dollar,
    ACTIONS(2051), 1,
      sym_quasiquote_start,
    ACTIONS(8930), 1,
      sym__varid,
    ACTIONS(8932), 1,
      anon_sym_LPAREN,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(7057), 1,
      sym_constructor,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2021), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(2041), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7528), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7472), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138112] = 21,
    ACTIONS(4829), 1,
      sym__integer_literal,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(4843), 1,
      anon_sym_u27e6,
    ACTIONS(4845), 1,
      sym__splice_dollar,
    ACTIONS(4847), 1,
      sym_quasiquote_start,
    ACTIONS(16200), 1,
      sym__varid,
    ACTIONS(16206), 1,
      anon_sym_LPAREN,
    ACTIONS(16208), 1,
      anon_sym_LBRACK,
    ACTIONS(16210), 1,
      anon_sym_SQUOTE,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(11315), 1,
      sym_constructor,
    STATE(17167), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16204), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16212), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4831), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16202), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11806), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11873), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12515), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138205] = 21,
    ACTIONS(169), 1,
      sym__integer_literal,
    ACTIONS(225), 1,
      anon_sym_u27e6,
    ACTIONS(229), 1,
      sym__splice_dollar,
    ACTIONS(231), 1,
      sym_quasiquote_start,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(16512), 1,
      sym__varid,
    ACTIONS(16518), 1,
      anon_sym_LPAREN,
    ACTIONS(16520), 1,
      anon_sym_LBRACK,
    ACTIONS(16522), 1,
      anon_sym_SQUOTE,
    STATE(2169), 1,
      sym__unboxed_open,
    STATE(4557), 1,
      sym_constructor,
    STATE(16835), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16516), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16524), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(171), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16514), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4848), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4843), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5795), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138298] = 21,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(10709), 1,
      anon_sym_u27e6,
    ACTIONS(10711), 1,
      sym__splice_dollar,
    ACTIONS(10713), 1,
      sym_quasiquote_start,
    ACTIONS(13205), 1,
      sym__conid,
    ACTIONS(16743), 1,
      sym__varid,
    ACTIONS(16749), 1,
      anon_sym_LPAREN,
    ACTIONS(16751), 1,
      anon_sym_LBRACK,
    ACTIONS(16753), 1,
      anon_sym_SQUOTE,
    STATE(2191), 1,
      sym__unboxed_open,
    STATE(8403), 1,
      sym_constructor,
    STATE(17066), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16747), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16745), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8696), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8653), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8542), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138391] = 21,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(11606), 1,
      anon_sym_u27e6,
    ACTIONS(11608), 1,
      sym__splice_dollar,
    ACTIONS(11610), 1,
      sym_quasiquote_start,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(16757), 1,
      sym__varid,
    ACTIONS(16763), 1,
      anon_sym_LPAREN,
    ACTIONS(16765), 1,
      anon_sym_LBRACK,
    ACTIONS(16767), 1,
      anon_sym_SQUOTE,
    STATE(2126), 1,
      sym__unboxed_open,
    STATE(8877), 1,
      sym_constructor,
    STATE(17818), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16761), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16769), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16759), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9329), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9175), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138484] = 21,
    ACTIONS(8630), 1,
      sym__integer_literal,
    ACTIONS(8640), 1,
      sym__conid,
    ACTIONS(8642), 1,
      anon_sym_LBRACK,
    ACTIONS(8644), 1,
      anon_sym_SQUOTE,
    ACTIONS(8648), 1,
      anon_sym_u27e6,
    ACTIONS(8650), 1,
      sym__splice_dollar,
    ACTIONS(8652), 1,
      sym_quasiquote_start,
    ACTIONS(10158), 1,
      anon_sym_LPAREN,
    ACTIONS(15277), 1,
      sym__varid,
    STATE(2086), 1,
      sym__unboxed_open,
    STATE(7882), 1,
      sym_constructor,
    STATE(17086), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8634), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8646), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8632), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7902), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(8034), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8170), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138577] = 21,
    ACTIONS(16771), 1,
      sym__varid,
    ACTIONS(16775), 1,
      sym__integer_literal,
    ACTIONS(16781), 1,
      anon_sym_LPAREN,
    ACTIONS(16783), 1,
      sym__conid,
    ACTIONS(16785), 1,
      anon_sym_LBRACK,
    ACTIONS(16787), 1,
      anon_sym_SQUOTE,
    ACTIONS(16791), 1,
      anon_sym_u27e6,
    ACTIONS(16793), 1,
      sym__splice_dollar,
    ACTIONS(16795), 1,
      sym_quasiquote_start,
    STATE(2122), 1,
      sym__unboxed_open,
    STATE(15160), 1,
      sym_constructor,
    STATE(17284), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16789), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(16773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(16777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16051), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16216), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16195), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138670] = 21,
    ACTIONS(3162), 1,
      sym__integer_literal,
    ACTIONS(3193), 1,
      anon_sym_u27e6,
    ACTIONS(3195), 1,
      sym__splice_dollar,
    ACTIONS(3197), 1,
      sym_quasiquote_start,
    ACTIONS(4483), 1,
      sym__conid,
    ACTIONS(16612), 1,
      sym__varid,
    ACTIONS(16618), 1,
      anon_sym_LPAREN,
    ACTIONS(16620), 1,
      anon_sym_LBRACK,
    ACTIONS(16622), 1,
      anon_sym_SQUOTE,
    STATE(2139), 1,
      sym__unboxed_open,
    STATE(5410), 1,
      sym_constructor,
    STATE(16805), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16616), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16624), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3164), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16614), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6216), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6219), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6071), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138763] = 21,
    ACTIONS(16771), 1,
      sym__varid,
    ACTIONS(16775), 1,
      sym__integer_literal,
    ACTIONS(16781), 1,
      anon_sym_LPAREN,
    ACTIONS(16783), 1,
      sym__conid,
    ACTIONS(16785), 1,
      anon_sym_LBRACK,
    ACTIONS(16787), 1,
      anon_sym_SQUOTE,
    ACTIONS(16791), 1,
      anon_sym_u27e6,
    ACTIONS(16793), 1,
      sym__splice_dollar,
    ACTIONS(16795), 1,
      sym_quasiquote_start,
    STATE(2122), 1,
      sym__unboxed_open,
    STATE(15160), 1,
      sym_constructor,
    STATE(17284), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16789), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(16773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(16777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16051), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(16216), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16197), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138856] = 21,
    ACTIONS(9202), 1,
      sym__integer_literal,
    ACTIONS(9212), 1,
      sym__conid,
    ACTIONS(9226), 1,
      anon_sym_u27e6,
    ACTIONS(9228), 1,
      sym__splice_dollar,
    ACTIONS(9230), 1,
      sym_quasiquote_start,
    ACTIONS(16729), 1,
      sym__varid,
    ACTIONS(16735), 1,
      anon_sym_LPAREN,
    ACTIONS(16737), 1,
      anon_sym_LBRACK,
    ACTIONS(16739), 1,
      anon_sym_SQUOTE,
    STATE(2184), 1,
      sym__unboxed_open,
    STATE(11158), 1,
      sym_constructor,
    STATE(16972), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16733), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9204), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16731), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12115), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12034), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12498), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [138949] = 21,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(12082), 1,
      anon_sym_u27e6,
    ACTIONS(12084), 1,
      sym__splice_dollar,
    ACTIONS(12086), 1,
      sym_quasiquote_start,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(16797), 1,
      sym__varid,
    ACTIONS(16803), 1,
      anon_sym_LPAREN,
    ACTIONS(16805), 1,
      anon_sym_LBRACK,
    ACTIONS(16807), 1,
      anon_sym_SQUOTE,
    STATE(2116), 1,
      sym__unboxed_open,
    STATE(9240), 1,
      sym_constructor,
    STATE(17815), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16801), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16809), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16799), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9613), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(9614), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9358), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139042] = 21,
    ACTIONS(3567), 1,
      sym__integer_literal,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(3593), 1,
      anon_sym_u27e6,
    ACTIONS(3595), 1,
      sym__splice_dollar,
    ACTIONS(3597), 1,
      sym_quasiquote_start,
    ACTIONS(16032), 1,
      sym__varid,
    ACTIONS(16038), 1,
      anon_sym_LPAREN,
    ACTIONS(16040), 1,
      anon_sym_LBRACK,
    ACTIONS(16042), 1,
      anon_sym_SQUOTE,
    STATE(2200), 1,
      sym__unboxed_open,
    STATE(10629), 1,
      sym_constructor,
    STATE(16927), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16036), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16044), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16034), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10769), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(10691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11056), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139135] = 21,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(12953), 1,
      anon_sym_u27e6,
    ACTIONS(12955), 1,
      sym__splice_dollar,
    ACTIONS(12957), 1,
      sym_quasiquote_start,
    ACTIONS(15325), 1,
      sym__conid,
    ACTIONS(16811), 1,
      sym__varid,
    ACTIONS(16817), 1,
      anon_sym_LPAREN,
    ACTIONS(16819), 1,
      anon_sym_LBRACK,
    ACTIONS(16821), 1,
      anon_sym_SQUOTE,
    STATE(2133), 1,
      sym__unboxed_open,
    STATE(14163), 1,
      sym_constructor,
    STATE(17666), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16815), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16823), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16813), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14759), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(14768), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14779), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139228] = 21,
    ACTIONS(4769), 1,
      sym__integer_literal,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(4793), 1,
      anon_sym_u27e6,
    ACTIONS(4795), 1,
      sym__splice_dollar,
    ACTIONS(4797), 1,
      sym_quasiquote_start,
    ACTIONS(16312), 1,
      sym__varid,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_LBRACK,
    ACTIONS(16322), 1,
      anon_sym_SQUOTE,
    STATE(2178), 1,
      sym__unboxed_open,
    STATE(11360), 1,
      sym_constructor,
    STATE(17037), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16324), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4771), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11894), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11531), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12521), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139321] = 21,
    ACTIONS(4733), 1,
      sym__integer_literal,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(4747), 1,
      anon_sym_u27e6,
    ACTIONS(4749), 1,
      sym__splice_dollar,
    ACTIONS(4751), 1,
      sym_quasiquote_start,
    ACTIONS(16214), 1,
      sym__varid,
    ACTIONS(16220), 1,
      anon_sym_LPAREN,
    ACTIONS(16222), 1,
      anon_sym_LBRACK,
    ACTIONS(16224), 1,
      anon_sym_SQUOTE,
    STATE(2072), 1,
      sym__unboxed_open,
    STATE(12073), 1,
      sym_constructor,
    STATE(16485), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16218), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16226), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4735), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16216), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12145), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12150), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13214), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139414] = 21,
    ACTIONS(4543), 1,
      sym__integer_literal,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(4567), 1,
      anon_sym_u27e6,
    ACTIONS(4569), 1,
      sym__splice_dollar,
    ACTIONS(4571), 1,
      sym_quasiquote_start,
    ACTIONS(15800), 1,
      sym__varid,
    ACTIONS(15806), 1,
      anon_sym_LPAREN,
    ACTIONS(15808), 1,
      anon_sym_LBRACK,
    ACTIONS(15810), 1,
      anon_sym_SQUOTE,
    STATE(2066), 1,
      sym__unboxed_open,
    STATE(11736), 1,
      sym_constructor,
    STATE(16503), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15804), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15812), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4545), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15802), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12180), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12179), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12446), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139507] = 15,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(15526), 1,
      sym__conid,
    ACTIONS(15535), 1,
      anon_sym__,
    STATE(2467), 1,
      sym__colon2,
    STATE(15580), 1,
      aux_sym_signature_repeat1,
    STATE(20998), 1,
      sym__type_annotation,
    ACTIONS(15532), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15537), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(16825), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15512), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15515), 7,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15530), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15517), 13,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [139588] = 21,
    ACTIONS(8552), 1,
      sym__integer_literal,
    ACTIONS(8562), 1,
      sym__conid,
    ACTIONS(8564), 1,
      anon_sym_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_SQUOTE,
    ACTIONS(8570), 1,
      anon_sym_u27e6,
    ACTIONS(8572), 1,
      sym__splice_dollar,
    ACTIONS(8574), 1,
      sym_quasiquote_start,
    ACTIONS(10078), 1,
      anon_sym_LPAREN,
    ACTIONS(15271), 1,
      sym__varid,
    STATE(2112), 1,
      sym__unboxed_open,
    STATE(7629), 1,
      sym_constructor,
    STATE(17064), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8556), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(8568), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(8550), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8554), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8169), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(7922), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8171), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139681] = 21,
    ACTIONS(1448), 1,
      sym__integer_literal,
    ACTIONS(1480), 1,
      anon_sym_u27e6,
    ACTIONS(1482), 1,
      sym__splice_dollar,
    ACTIONS(1484), 1,
      sym_quasiquote_start,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(16673), 1,
      sym__varid,
    ACTIONS(16679), 1,
      anon_sym_LPAREN,
    ACTIONS(16681), 1,
      anon_sym_LBRACK,
    ACTIONS(16683), 1,
      anon_sym_SQUOTE,
    STATE(2181), 1,
      sym__unboxed_open,
    STATE(4350), 1,
      sym_constructor,
    STATE(17602), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16677), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16685), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1450), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4458), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(4423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4561), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139774] = 21,
    ACTIONS(1582), 1,
      sym__integer_literal,
    ACTIONS(1600), 1,
      anon_sym_u27e6,
    ACTIONS(1602), 1,
      sym__splice_dollar,
    ACTIONS(1604), 1,
      sym_quasiquote_start,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(16326), 1,
      sym__varid,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_LBRACK,
    ACTIONS(16336), 1,
      anon_sym_SQUOTE,
    STATE(2211), 1,
      sym__unboxed_open,
    STATE(5247), 1,
      sym_constructor,
    STATE(17292), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16330), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16338), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1584), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16328), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5272), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6473), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139867] = 21,
    ACTIONS(4769), 1,
      sym__integer_literal,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(4793), 1,
      anon_sym_u27e6,
    ACTIONS(4795), 1,
      sym__splice_dollar,
    ACTIONS(4797), 1,
      sym_quasiquote_start,
    ACTIONS(16312), 1,
      sym__varid,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_LBRACK,
    ACTIONS(16322), 1,
      anon_sym_SQUOTE,
    STATE(2178), 1,
      sym__unboxed_open,
    STATE(11360), 1,
      sym_constructor,
    STATE(17037), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16324), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4771), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11894), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(11531), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13213), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [139960] = 21,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(12988), 1,
      anon_sym_u27e6,
    ACTIONS(12990), 1,
      sym__splice_dollar,
    ACTIONS(12992), 1,
      sym_quasiquote_start,
    ACTIONS(15307), 1,
      sym__conid,
    ACTIONS(16828), 1,
      sym__varid,
    ACTIONS(16834), 1,
      anon_sym_LPAREN,
    ACTIONS(16836), 1,
      anon_sym_LBRACK,
    ACTIONS(16838), 1,
      anon_sym_SQUOTE,
    STATE(2123), 1,
      sym__unboxed_open,
    STATE(14698), 1,
      sym_constructor,
    STATE(17667), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16832), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16840), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16830), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15427), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(15470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15314), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140053] = 21,
    ACTIONS(89), 1,
      sym__integer_literal,
    ACTIONS(147), 1,
      anon_sym_u27e6,
    ACTIONS(149), 1,
      sym__splice_dollar,
    ACTIONS(151), 1,
      sym_quasiquote_start,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(16701), 1,
      sym__varid,
    ACTIONS(16707), 1,
      anon_sym_LPAREN,
    ACTIONS(16709), 1,
      anon_sym_LBRACK,
    ACTIONS(16711), 1,
      anon_sym_SQUOTE,
    STATE(2148), 1,
      sym__unboxed_open,
    STATE(3733), 1,
      sym_constructor,
    STATE(16815), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16705), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16713), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(91), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3762), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(3761), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3874), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140146] = 21,
    ACTIONS(6396), 1,
      sym__varid,
    ACTIONS(6400), 1,
      sym__integer_literal,
    ACTIONS(6406), 1,
      anon_sym_LPAREN,
    ACTIONS(6411), 1,
      anon_sym_LBRACK,
    ACTIONS(6420), 1,
      anon_sym_u27e6,
    ACTIONS(6422), 1,
      sym__splice_dollar,
    ACTIONS(6424), 1,
      sym_quasiquote_start,
    ACTIONS(8828), 1,
      sym__conid,
    ACTIONS(8830), 1,
      anon_sym_SQUOTE,
    STATE(2104), 1,
      sym__unboxed_open,
    STATE(6258), 1,
      sym_constructor,
    STATE(16681), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6404), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6416), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6398), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6402), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6369), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(6371), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6600), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140239] = 21,
    ACTIONS(551), 1,
      sym__integer_literal,
    ACTIONS(585), 1,
      anon_sym_u27e6,
    ACTIONS(587), 1,
      sym__splice_dollar,
    ACTIONS(591), 1,
      sym_quasiquote_start,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(16298), 1,
      sym__varid,
    ACTIONS(16304), 1,
      anon_sym_LPAREN,
    ACTIONS(16306), 1,
      anon_sym_LBRACK,
    ACTIONS(16308), 1,
      anon_sym_SQUOTE,
    STATE(2155), 1,
      sym__unboxed_open,
    STATE(4540), 1,
      sym_constructor,
    STATE(16328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16302), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16310), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(553), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16300), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5202), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5772), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140332] = 21,
    ACTIONS(89), 1,
      sym__integer_literal,
    ACTIONS(147), 1,
      anon_sym_u27e6,
    ACTIONS(149), 1,
      sym__splice_dollar,
    ACTIONS(151), 1,
      sym_quasiquote_start,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(16701), 1,
      sym__varid,
    ACTIONS(16707), 1,
      anon_sym_LPAREN,
    ACTIONS(16709), 1,
      anon_sym_LBRACK,
    ACTIONS(16711), 1,
      anon_sym_SQUOTE,
    STATE(2148), 1,
      sym__unboxed_open,
    STATE(3733), 1,
      sym_constructor,
    STATE(16815), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16705), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16713), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(91), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3762), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(3761), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6077), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140425] = 21,
    ACTIONS(9852), 1,
      sym__integer_literal,
    ACTIONS(9862), 1,
      sym__conid,
    ACTIONS(9876), 1,
      anon_sym_u27e6,
    ACTIONS(9878), 1,
      sym__splice_dollar,
    ACTIONS(9880), 1,
      sym_quasiquote_start,
    ACTIONS(15862), 1,
      sym__varid,
    ACTIONS(15868), 1,
      anon_sym_LPAREN,
    ACTIONS(15870), 1,
      anon_sym_LBRACK,
    ACTIONS(15872), 1,
      anon_sym_SQUOTE,
    STATE(2209), 1,
      sym__unboxed_open,
    STATE(11549), 1,
      sym_constructor,
    STATE(16590), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15866), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15874), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(9854), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15864), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12346), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12341), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13160), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140518] = 21,
    ACTIONS(16842), 1,
      sym__varid,
    ACTIONS(16846), 1,
      sym__integer_literal,
    ACTIONS(16852), 1,
      anon_sym_LPAREN,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(16856), 1,
      anon_sym_LBRACK,
    ACTIONS(16858), 1,
      anon_sym_SQUOTE,
    ACTIONS(16862), 1,
      anon_sym_u27e6,
    ACTIONS(16864), 1,
      sym__splice_dollar,
    ACTIONS(16866), 1,
      sym_quasiquote_start,
    STATE(2087), 1,
      sym__unboxed_open,
    STATE(16476), 1,
      aux_sym__qualifying_module,
    STATE(17852), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16850), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16860), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(16844), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(16848), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20190), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(20187), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(21131), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140611] = 21,
    ACTIONS(16842), 1,
      sym__varid,
    ACTIONS(16846), 1,
      sym__integer_literal,
    ACTIONS(16852), 1,
      anon_sym_LPAREN,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(16856), 1,
      anon_sym_LBRACK,
    ACTIONS(16858), 1,
      anon_sym_SQUOTE,
    ACTIONS(16862), 1,
      anon_sym_u27e6,
    ACTIONS(16864), 1,
      sym__splice_dollar,
    ACTIONS(16866), 1,
      sym_quasiquote_start,
    STATE(2087), 1,
      sym__unboxed_open,
    STATE(16476), 1,
      aux_sym__qualifying_module,
    STATE(17852), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16850), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(16860), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(16844), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(16848), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20190), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(20187), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(21138), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140704] = 21,
    ACTIONS(6118), 1,
      sym__varid,
    ACTIONS(6122), 1,
      sym__integer_literal,
    ACTIONS(6128), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym_LBRACK,
    ACTIONS(6142), 1,
      anon_sym_u27e6,
    ACTIONS(6144), 1,
      sym__splice_dollar,
    ACTIONS(6146), 1,
      sym_quasiquote_start,
    ACTIONS(8121), 1,
      sym__conid,
    ACTIONS(8123), 1,
      anon_sym_SQUOTE,
    STATE(2208), 1,
      sym__unboxed_open,
    STATE(5781), 1,
      sym_constructor,
    STATE(17028), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6126), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6138), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(6120), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6124), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5949), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(5908), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6010), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140797] = 21,
    ACTIONS(4543), 1,
      sym__integer_literal,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(4567), 1,
      anon_sym_u27e6,
    ACTIONS(4569), 1,
      sym__splice_dollar,
    ACTIONS(4571), 1,
      sym_quasiquote_start,
    ACTIONS(15800), 1,
      sym__varid,
    ACTIONS(15806), 1,
      anon_sym_LPAREN,
    ACTIONS(15808), 1,
      anon_sym_LBRACK,
    ACTIONS(15810), 1,
      anon_sym_SQUOTE,
    STATE(2066), 1,
      sym__unboxed_open,
    STATE(11736), 1,
      sym_constructor,
    STATE(16503), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15804), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(15812), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(4545), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15802), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12180), 4,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
    STATE(12179), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13100), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [140890] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [140946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 34,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141226] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141394] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141506] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 33,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [141730] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141788] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [141958] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142182] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142294] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 4,
      sym__strict,
      sym__lazy,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 11,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [142358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142526] = 4,
    ACTIONS(16934), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [142976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143088] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143146] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143260] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143428] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143654] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [143878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [143934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [143990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144158] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(16930), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 8,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 10,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 20,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [144222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144828] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144885] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [144997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145162] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145437] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(7506), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [145494] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 6,
      sym_comma,
      sym__strict,
      sym__lazy,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [145557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [145722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [145942] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [145999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146054] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146111] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146166] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146498] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146555] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146667] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146724] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146836] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [146946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147111] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147223] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147390] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15341), 33,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [147722] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15345), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [147779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [147889] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15409), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [147946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148056] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148223] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148555] = 6,
    ACTIONS(16952), 1,
      anon_sym_LBRACE,
    ACTIONS(16955), 1,
      sym__layout_start,
    STATE(4495), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148671] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15413), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [148728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15510), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [148782] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [148946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149162] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149324] = 4,
    ACTIONS(16957), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149380] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15645), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [149652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149706] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [149814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [149868] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 5,
      sym_comma,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [149930] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 4,
      sym__strict,
      sym__lazy,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(15463), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [149992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15448), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [150100] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15561), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [150154] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150372] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150590] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15494), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [150644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [150698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150806] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [150968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15557), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [151346] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151456] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151512] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151620] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16930), 6,
      sym__strict,
      sym__lazy,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15448), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [151682] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151790] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15553), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [151900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [151954] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15571), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152062] = 6,
    ACTIONS(16959), 1,
      anon_sym_LBRACE,
    ACTIONS(16962), 1,
      sym__layout_start,
    STATE(4670), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14273), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15515), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152230] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152286] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15502), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152396] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15575), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152506] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15545), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15579), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15607), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152668] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15595), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152722] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15587), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [152940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15656), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [152994] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15599), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [153050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153104] = 6,
    ACTIONS(16966), 1,
      anon_sym_LBRACE,
    ACTIONS(16969), 1,
      sym__layout_start,
    STATE(4568), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15481), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [153218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15565), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [153272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15603), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [153326] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15599), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [153434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153488] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153542] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16930), 6,
      sym__strict,
      sym__lazy,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15448), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [153604] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153712] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [153982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15506), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154144] = 6,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 23,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154258] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154312] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15583), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15624), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154474] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(16977), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15636), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14070), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154744] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154852] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [154906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15632), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [154960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155068] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15617), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [155176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15613), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [155284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15591), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [155392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(15628), 32,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [155446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155608] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155664] = 5,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(15463), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 22,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155830] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(16930), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [155892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [155946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156054] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156323] = 4,
    ACTIONS(16981), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156378] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(15530), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156645] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [156963] = 6,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157287] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(16930), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 20,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [157348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157401] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(7506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [157456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157668] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157774] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [157986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158092] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158463] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158516] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158675] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 4,
      sym__strict,
      sym__lazy,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(15463), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 9,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [158736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [158948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159213] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159584] = 5,
    ACTIONS(16983), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15341), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [159694] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [159959] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160065] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160171] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160330] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160438] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160597] = 5,
    ACTIONS(16985), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160654] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15409), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [160709] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160870] = 5,
    ACTIONS(16994), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160927] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [160980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161033] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161086] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161245] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161404] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161669] = 5,
    ACTIONS(10390), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161726] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(16930), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [161787] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [161946] = 6,
    ACTIONS(17002), 1,
      anon_sym_LBRACE,
    ACTIONS(17005), 1,
      sym__layout_start,
    STATE(4849), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162005] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(15662), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162060] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15413), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [162115] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162221] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [162276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162329] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 4,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [162390] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162445] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162553] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15345), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [162608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162767] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(16930), 4,
      sym_comma,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
    ACTIONS(15463), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 8,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [162828] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [162987] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163040] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(16990), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163095] = 4,
    ACTIONS(17007), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163203] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163258] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(16990), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163313] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163790] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [163949] = 7,
    ACTIONS(16932), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16924), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(15463), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16930), 6,
      sym__strict,
      sym__lazy,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15448), 7,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(16927), 18,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [164010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15603), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [164115] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15632), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [164167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164271] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164375] = 5,
    ACTIONS(17009), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164483] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164589] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164645] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15448), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [164801] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [164961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165013] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [165065] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165117] = 6,
    ACTIONS(17009), 1,
      anon_sym_AT2,
    ACTIONS(16971), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15599), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [165279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165331] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165383] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165435] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165643] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15409), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [165697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [165905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14070), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [165957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166113] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15345), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [166167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14273), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [166219] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166273] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166325] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166377] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(7506), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [166431] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166537] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166643] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15571), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [166695] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [166853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15553), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [166905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15510), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [166957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15591), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [167009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15561), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [167061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167113] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [167271] = 5,
    ACTIONS(17011), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 23,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167327] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167433] = 6,
    ACTIONS(17016), 1,
      anon_sym_LBRACE,
    ACTIONS(17019), 1,
      sym__layout_start,
    STATE(5420), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167491] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167545] = 6,
    ACTIONS(17021), 1,
      anon_sym_LBRACE,
    ACTIONS(17024), 1,
      sym__layout_start,
    STATE(5286), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [167811] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167867] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167921] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [167975] = 7,
    ACTIONS(15468), 1,
      anon_sym__,
    ACTIONS(15445), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15474), 4,
      sym__strict,
      sym__lazy,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15463), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15450), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [168035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168243] = 5,
    ACTIONS(17026), 1,
      anon_sym_SEMI,
    STATE(4578), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15647), 18,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_newtype,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15652), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15557), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [168351] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15502), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [168613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168665] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15494), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [168717] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168769] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168927] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [168981] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169295] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169347] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169401] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169455] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15599), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [169509] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169563] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169669] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169775] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15583), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [169827] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15628), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [169933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [169985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15613), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [170037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170089] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170245] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170297] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170349] = 4,
    ACTIONS(17029), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170455] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170663] = 6,
    ACTIONS(17031), 1,
      anon_sym_LBRACE,
    ACTIONS(17034), 1,
      sym__layout_start,
    STATE(5526), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170825] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15624), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [170877] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [170929] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15413), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [170983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171087] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15341), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [171193] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171351] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171509] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171563] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171669] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171723] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171829] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [171933] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [171987] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15587), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [172093] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172147] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172253] = 7,
    ACTIONS(15468), 1,
      anon_sym__,
    ACTIONS(15445), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15474), 4,
      sym__strict,
      sym__lazy,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15463), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15450), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [172313] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172365] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [172471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 30,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172575] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15575), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [172627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [172731] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15579), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [172783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172835] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [172943] = 6,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173053] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173209] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15617), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [173367] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173419] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(16977), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [173525] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173579] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173633] = 6,
    ACTIONS(17036), 1,
      anon_sym_LBRACE,
    ACTIONS(17039), 1,
      sym__layout_start,
    STATE(5604), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173795] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15595), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [173847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [173899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15515), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [173951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174003] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174159] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174213] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15607), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [174265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15636), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [174317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174369] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174423] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174477] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174529] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174633] = 6,
    ACTIONS(17041), 1,
      anon_sym_LBRACE,
    ACTIONS(17044), 1,
      sym__layout_start,
    STATE(5517), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174691] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174745] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15481), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [174797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15645), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [174849] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [174903] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15565), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [174955] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [175061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15545), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [175113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175521] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175623] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175725] = 6,
    ACTIONS(17046), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175833] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [175986] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176396] = 6,
    ACTIONS(17048), 1,
      anon_sym_LBRACE,
    ACTIONS(17051), 1,
      sym__layout_start,
    STATE(6260), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176453] = 5,
    ACTIONS(16994), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176559] = 5,
    ACTIONS(10390), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176665] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [176973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177177] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [177585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 29,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [177993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 29,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178758] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178809] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178913] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [178966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179017] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179070] = 5,
    ACTIONS(16985), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179125] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179229] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179333] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179386] = 6,
    ACTIONS(17053), 1,
      anon_sym_LBRACE,
    ACTIONS(17056), 1,
      sym__layout_start,
    STATE(5888), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179545] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179651] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179753] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [179957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15481), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15565), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180161] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14273), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15561), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15583), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180416] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180467] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15591), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14070), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15613), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15617), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15595), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180824] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15656), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [180875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [180977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181028] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181232] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15624), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [181283] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15628), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [181385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181436] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15632), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [181540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15636), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [181642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15579), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [181693] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181744] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181795] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181897] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [181948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15645), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [181999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182101] = 4,
    ACTIONS(17058), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182715] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182919] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [182970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183021] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183123] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16987), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183229] = 6,
    ACTIONS(17060), 1,
      anon_sym_LBRACE,
    ACTIONS(17063), 1,
      sym__layout_start,
    STATE(5974), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183439] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183541] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183592] = 5,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183647] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183700] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16999), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183755] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16996), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183861] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183912] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [183965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 29,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184067] = 6,
    ACTIONS(17065), 1,
      anon_sym_LBRACE,
    ACTIONS(17068), 1,
      sym__layout_start,
    STATE(5902), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184226] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184430] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184787] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184889] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184942] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [184995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15587), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15545), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15575), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15571), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15553), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185607] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15510), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15506), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15502), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15494), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [185862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [185964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186168] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186272] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186325] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186376] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186429] = 6,
    ACTIONS(17070), 1,
      anon_sym_LBRACE,
    ACTIONS(17073), 1,
      sym__layout_start,
    STATE(5979), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186537] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186590] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186692] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186745] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186898] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [186951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187053] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187308] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187461] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187565] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [187973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188177] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188381] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16987), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188538] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188844] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [188997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189048] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189101] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189152] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15448), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [189407] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189458] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189713] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15515), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [189817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15607), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [189868] = 5,
    ACTIONS(16985), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [189974] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190127] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190280] = 6,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190439] = 5,
    ACTIONS(10390), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190545] = 5,
    ACTIONS(16994), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190651] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190753] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15599), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [190906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [190957] = 4,
    ACTIONS(17075), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 29,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191112] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191163] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15603), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [191318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191624] = 5,
    ACTIONS(16983), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191730] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [191985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192087] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192293] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192344] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192395] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192599] = 6,
    ACTIONS(17077), 1,
      anon_sym_LBRACE,
    ACTIONS(17080), 1,
      sym__layout_start,
    STATE(6181), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192656] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192862] = 7,
    ACTIONS(15468), 1,
      anon_sym__,
    ACTIONS(15445), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15474), 4,
      sym__strict,
      sym__lazy,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15463), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 11,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(15450), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [192921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [192972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [193176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193227] = 4,
    ACTIONS(17082), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193331] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193435] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193588] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193794] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193898] = 5,
    ACTIONS(16983), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [193953] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194259] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194412] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194463] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194565] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [194973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195126] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195179] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195383] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195638] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195689] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195791] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [195995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196607] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [196964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197423] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197474] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197576] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197831] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197882] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [197984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [198035] = 4,
    ACTIONS(17084), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198088] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15557), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [198396] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 30,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198651] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198753] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [198957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199110] = 6,
    ACTIONS(17086), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(16977), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [199218] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199271] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199424] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199526] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199579] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199783] = 5,
    ACTIONS(17046), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(15463), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [199991] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200246] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200297] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200654] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200756] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200807] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [200960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201062] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15549), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [201419] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(15599), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [201472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201574] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201625] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201729] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201833] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201935] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16999), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [201990] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202043] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202349] = 4,
    ACTIONS(17088), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202453] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16996), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202508] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202561] = 6,
    ACTIONS(17090), 1,
      anon_sym_LBRACE,
    ACTIONS(17093), 1,
      sym__layout_start,
    STATE(6251), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202618] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202722] = 6,
    ACTIONS(17095), 1,
      anon_sym_LBRACE,
    ACTIONS(17098), 1,
      sym__layout_start,
    STATE(6264), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_u27e6,
  [202830] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [202985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203240] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203291] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203393] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203495] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203802] = 4,
    ACTIONS(17100), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203854] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [203954] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15341), 34,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [204254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204304] = 5,
    ACTIONS(16983), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204458] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204708] = 4,
    ACTIONS(17102), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [204960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205260] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [205960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206160] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [206212] = 4,
    ACTIONS(17104), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206264] = 5,
    ACTIONS(16994), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206468] = 5,
    ACTIONS(10390), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206772] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [206972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207472] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207574] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207626] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207726] = 5,
    ACTIONS(16985), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207930] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [207980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208430] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208530] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208580] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208680] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208730] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208930] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [208980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209180] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [209232] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209632] = 4,
    ACTIONS(17106), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [209984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210484] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210634] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15413), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [210686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210736] = 5,
    ACTIONS(16983), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210790] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210890] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [210990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211040] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211092] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15405), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [211144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211344] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211394] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211594] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211694] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211744] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211794] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211844] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [211994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212344] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212396] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212596] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [212998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213398] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213498] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213700] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 29,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213900] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [213952] = 4,
    ACTIONS(17108), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214054] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214156] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214406] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214458] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214760] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15345), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214912] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [214962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215012] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215214] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215364] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [215416] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215516] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215716] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215866] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [215966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216016] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(7506), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216068] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216368] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15409), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [216970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217370] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217472] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217574] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217774] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217824] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(17013), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [217978] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218028] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218378] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218628] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218778] = 6,
    ACTIONS(17110), 1,
      anon_sym_LBRACE,
    ACTIONS(17113), 1,
      sym__layout_start,
    STATE(6651), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [218984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219484] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [219984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220184] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220236] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220336] = 5,
    ACTIONS(17011), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220440] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220590] = 6,
    ACTIONS(17115), 1,
      anon_sym_LBRACE,
    ACTIONS(17118), 1,
      sym__layout_start,
    STATE(6506), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [220996] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221146] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16987), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221250] = 6,
    ACTIONS(17120), 1,
      anon_sym_LBRACE,
    ACTIONS(17123), 1,
      sym__layout_start,
    STATE(6455), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221406] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221506] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221606] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221706] = 5,
    ACTIONS(16983), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [221960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222260] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222310] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16999), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222364] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16996), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222568] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222668] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222768] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222818] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [222968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223068] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223368] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [223970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [224970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [225970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226470] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15409), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [226522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226772] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [226972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227772] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [227972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228772] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [228972] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [229024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229224] = 5,
    ACTIONS(17011), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229278] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [229330] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15345), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [229382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229632] = 5,
    ACTIONS(10390), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229686] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(7506), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [229738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229788] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229888] = 5,
    ACTIONS(16994), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [229992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230042] = 4,
    ACTIONS(17125), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230344] = 5,
    ACTIONS(10390), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230398] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(17013), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230602] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230852] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [230952] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231152] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231602] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231852] = 4,
    ACTIONS(17127), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [231904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [231954] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232204] = 4,
    ACTIONS(17129), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232256] = 5,
    ACTIONS(16985), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232710] = 5,
    ACTIONS(16994), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16990), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16992), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [232964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233214] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233364] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [233964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234064] = 5,
    ACTIONS(16985), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15341), 29,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234568] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15413), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [234970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235216] = 5,
    ACTIONS(17011), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235367] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235416] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [235955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15481), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236053] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15565), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236151] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236347] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236396] = 5,
    ACTIONS(17011), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236547] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15599), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15583), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236745] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 34,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236794] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [236843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15624), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15628), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15613), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [236990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15617), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15632), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237186] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237237] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15636), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15595), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15579), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 32,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237531] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [237680] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237876] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [237974] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238023] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [238074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14273), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238319] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15561), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15591), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14070), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15656), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238860] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [238911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [238960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15607), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239156] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [239207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239452] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [239503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239699] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15515), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [239993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240091] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [240142] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240240] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240338] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [240389] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240438] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240536] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [240587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240930] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [240979] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241028] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(16977), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [241126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241273] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241371] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [241422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15587), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [241520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241618] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [241669] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241767] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15603), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15545), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [241914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [241963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15575), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [242012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 34,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [242061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242159] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15571), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [242306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242355] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15553), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [242404] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242453] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242551] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15510), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [242698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [242992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15506), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15502), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243188] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243288] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15494), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243386] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243435] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243484] = 4,
    ACTIONS(17131), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243633] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243831] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [243880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15645), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243929] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15413), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [243980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244127] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [244178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244325] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244374] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(17013), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244476] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [244527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244576] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244674] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [244725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244774] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [244872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [244921] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [244972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245021] = 4,
    ACTIONS(17133), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [245366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245562] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [245613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [245662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [245711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245809] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [245958] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15571), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15553), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15510), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [246497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [246546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246693] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [246791] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246938] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [246987] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247085] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15341), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [247232] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15494), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [247477] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [247526] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247575] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 34,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [247673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15448), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [247820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15515), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [247869] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15607), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [247918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [247967] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248065] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248163] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15575), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [248261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15545), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248506] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248555] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248604] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [248653] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15603), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [248702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [248751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [248800] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248851] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248949] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [248998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249341] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249439] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [249488] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249586] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15624), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15549), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [249733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249831] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15599), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [249929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [249978] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250027] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15628), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15632), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15617), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15613), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15636), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14070), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15591), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15541), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15595), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [250713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15583), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15561), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15656), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15579), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [250958] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251007] = 6,
    ACTIONS(17135), 1,
      anon_sym_LBRACE,
    ACTIONS(17138), 1,
      sym__layout_start,
    STATE(6943), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15485), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251062] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15549), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251111] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15645), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14273), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251258] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15405), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [251356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15565), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251405] = 4,
    ACTIONS(17140), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15481), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15557), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15557), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [251701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251799] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251897] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [251995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252142] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [252191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252240] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15506), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252632] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [252683] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [252830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [252879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [252977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253026] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253173] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [253224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253273] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(7506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [253324] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253471] = 5,
    ACTIONS(17011), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16948), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15502), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253671] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15345), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [253722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [253771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [253820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253869] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [253918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [253967] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254067] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [254118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254363] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254463] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254512] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [254563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15587), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254857] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [254908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [254957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255006] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255153] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15448), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255449] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15409), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [255548] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255694] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255790] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15636), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15632), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [255982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [256222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15828), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [256270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256462] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256512] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15628), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15624), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15824), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [256848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [256944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [256992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [257040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15579), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [257136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [257232] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15820), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [257328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [257376] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [257474] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15816), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [257618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15595), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [257714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [257762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257810] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15617), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15613), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [257956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [258004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14070), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258100] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15591), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15782), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15784), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [258244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15583), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15561), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258340] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [258484] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [258582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15660), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [258630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14273), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258726] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15599), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15565), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258824] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15481), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15778), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15780), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [258920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [258968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259112] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15776), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [259160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259256] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [259306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [259354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15645), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259594] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259788] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259836] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [259980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [260028] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260124] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15549), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260270] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260416] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260512] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260800] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [260898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [260994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261282] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [261332] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261430] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [261480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261576] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261624] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15756), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15758), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [261818] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15830), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15832), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261866] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [261962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262010] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262060] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262158] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15728), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15724), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15718), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15720), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262398] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15702), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262446] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15664), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262688] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15698), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [262880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [262976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15694), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15676), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15672), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263312] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15668), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263408] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263458] = 4,
    ACTIONS(17142), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15902), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15904), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15878), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263556] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263606] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15894), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15896), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263654] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15898), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15900), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [263750] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 33,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [263944] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [263994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264042] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264092] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [264188] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [264236] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264286] = 12,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17154), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3562), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 19,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [264352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264544] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264594] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264642] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264788] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264836] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [264932] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [264982] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [265032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [265224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [265320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [265368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [265416] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [265562] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [265660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [265708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15557), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265756] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265806] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265856] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15405), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [265952] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [266098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [266146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [266194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [266242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266290] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266340] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266438] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266726] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266824] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [266968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [267016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [267064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267112] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [267160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15587), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15545), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [267544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15575), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267688] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15571), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15553), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15510), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [267976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [268216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [268312] = 10,
    ACTIONS(17159), 1,
      anon_sym_BQUOTE,
    ACTIONS(17162), 1,
      sym__consym,
    ACTIONS(17165), 1,
      sym__tyconsym,
    STATE(2467), 1,
      sym__colon2,
    STATE(20768), 1,
      sym__type_annotation,
    ACTIONS(17156), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18229), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 24,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15506), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15502), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268758] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268806] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268854] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15494), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268950] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [268998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [269046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [269094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269142] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269190] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [269286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [269382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 33,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269430] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269526] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269576] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269624] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [269722] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269772] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(16977), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269918] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [269968] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [270114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270162] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270258] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270308] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [270356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270404] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [270550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [270598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270646] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [270696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 33,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [270744] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [270888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [270984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [271032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [271080] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [271178] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271324] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [271374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [271518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [271662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 33,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271710] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271856] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [271952] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [272048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15448), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15603), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15599), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [272240] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [272288] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15515), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [272384] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15607), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272482] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [272580] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 33,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [272628] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272770] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272819] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272866] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [272960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273101] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273383] = 9,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(17170), 1,
      sym__varid,
    ACTIONS(17173), 1,
      anon_sym_LPAREN,
    ACTIONS(15415), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(17176), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(12995), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(7506), 21,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [273442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [273677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273771] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16936), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16938), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [273867] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15409), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [273963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274010] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274200] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274296] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [274392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274439] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274486] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [274958] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [275052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275099] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275240] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15341), 30,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275757] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275851] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275945] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [275994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [276182] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [276229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [276370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [276417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [276699] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 32,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276840] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [276936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [276983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [277030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277171] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277312] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [277406] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277453] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277547] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277594] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277643] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [277737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277831] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [277925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [277972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278395] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278538] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278728] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278824] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [278965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [279059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279341] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279435] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279482] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279719] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15413), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279768] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(16977), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [279956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280003] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280285] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280755] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [280990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 32,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281695] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281744] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281791] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281885] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [281981] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282028] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [282310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16948), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16950), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [282404] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282639] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282686] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282735] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [282782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [282829] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [282925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [282972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [283019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16920), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16922), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [283254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16916), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16918), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [283301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283395] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16940), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16942), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [283442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283536] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283632] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283726] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [283961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284149] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [284290] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [284431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [284525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284619] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [284713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284807] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284854] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [284901] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [284948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [284995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285089] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285324] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285371] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285418] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285467] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285843] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [285939] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [285988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286082] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286129] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16944), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16946), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [286176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286364] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 32,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286507] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286603] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286699] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [286793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286934] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [286983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [287030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [287124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287171] = 9,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(17178), 1,
      sym__varid,
    ACTIONS(17181), 1,
      anon_sym_LPAREN,
    ACTIONS(15415), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(17176), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(13211), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(7506), 21,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [287230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [287324] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287371] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16908), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16910), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [287512] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287606] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(16977), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287653] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16904), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16906), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [287700] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16900), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16902), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [287794] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287841] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [287982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288123] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288172] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288362] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288785] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288926] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(7506), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [288975] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289069] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289165] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16912), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16914), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289259] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289306] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15345), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289355] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16868), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16870), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16872), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16874), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289543] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289590] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289639] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16876), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16878), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16880), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16882), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16884), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16886), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [289921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16888), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16890), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [289968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16892), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16894), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [290015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290062] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290109] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290156] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16896), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(16898), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [290203] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290438] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290486] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290580] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290626] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15561), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290672] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290720] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290768] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(7506), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [290954] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291046] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15345), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14273), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291232] = 8,
    ACTIONS(17184), 1,
      sym__varid,
    ACTIONS(17189), 1,
      anon_sym_LPAREN,
    ACTIONS(15609), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(17192), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(13156), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(14070), 21,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [291288] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291518] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291566] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291706] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291754] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15591), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14070), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291938] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [291986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15579), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15595), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292216] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 32,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292262] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292308] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292492] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292538] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15636), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15632), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15617), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15613), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292768] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15628), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292860] = 8,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(17194), 1,
      sym__varid,
    ACTIONS(17197), 1,
      anon_sym_LPAREN,
    ACTIONS(17200), 1,
      anon_sym_RPAREN,
    ACTIONS(15415), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(13691), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [292962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15656), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293100] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15645), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293238] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293378] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293424] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293516] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15624), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15583), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293748] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15413), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [293980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294026] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294072] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15409), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294258] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15603), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294304] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294398] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15565), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15481), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294628] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294950] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [294996] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295180] = 9,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(17203), 1,
      sym__varid,
    ACTIONS(17206), 1,
      anon_sym_LPAREN,
    ACTIONS(15415), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(17176), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(13375), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(7506), 21,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [295238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295376] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295468] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 27,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295516] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295654] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295794] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [295978] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296070] = 7,
    ACTIONS(17209), 1,
      anon_sym_BQUOTE,
    ACTIONS(17212), 1,
      sym__consym,
    ACTIONS(17215), 1,
      sym__tyconsym,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(19368), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 26,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296262] = 8,
    ACTIONS(17218), 1,
      sym__varid,
    ACTIONS(17221), 1,
      anon_sym_LPAREN,
    ACTIONS(15609), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(17192), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(13245), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(14070), 21,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [296318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15341), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296364] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296594] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296686] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296780] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296828] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(16977), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15607), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [296966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15557), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15515), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15448), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297196] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297290] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297474] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [297934] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17233), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3545), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 17,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [297998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298182] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15587), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298274] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298320] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15545), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298506] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15575), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298644] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298738] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15571), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298924] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [298970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15553), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299016] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299156] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299340] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15510), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299386] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15549), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299526] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15506), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15502), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299756] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [299986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15494), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300124] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300171] = 4,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [300218] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15409), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300265] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300310] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300355] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300402] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15345), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300449] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300496] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(7506), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300543] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300590] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300637] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300682] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300729] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300774] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300819] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300864] = 6,
    STATE(2467), 1,
      sym__colon2,
    STATE(20768), 1,
      sym__type_annotation,
    ACTIONS(17156), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300915] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [300960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301185] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301275] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301320] = 8,
    ACTIONS(17235), 1,
      sym__varid,
    ACTIONS(17238), 1,
      anon_sym_LPAREN,
    ACTIONS(15609), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(17192), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(13474), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(14070), 21,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [301375] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15481), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15583), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301555] = 4,
    ACTIONS(1211), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [301602] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15624), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15628), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15613), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15617), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15632), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15636), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15595), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301917] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15579), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [301962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302007] = 4,
    ACTIONS(1327), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302099] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302191] = 4,
    ACTIONS(17241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302238] = 4,
    ACTIONS(1377), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302285] = 4,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302377] = 4,
    ACTIONS(1371), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302424] = 4,
    ACTIONS(17243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302516] = 4,
    ACTIONS(17245), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302563] = 4,
    ACTIONS(1361), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14273), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302655] = 4,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15561), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(15341), 28,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [302792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15591), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302837] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14070), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [302882] = 4,
    ACTIONS(17247), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302929] = 4,
    ACTIONS(1335), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [302976] = 4,
    ACTIONS(1329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15656), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303068] = 4,
    ACTIONS(17249), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303115] = 4,
    ACTIONS(1313), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303162] = 4,
    ACTIONS(1309), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303299] = 4,
    ACTIONS(1289), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303346] = 4,
    ACTIONS(17251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303393] = 4,
    ACTIONS(1287), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303440] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303485] = 4,
    ACTIONS(1283), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303577] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303667] = 4,
    ACTIONS(17253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303759] = 4,
    ACTIONS(1267), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [303806] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303851] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303943] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [303988] = 4,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15587), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15545), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15575), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15571), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304215] = 4,
    ACTIONS(17255), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304262] = 4,
    ACTIONS(17257), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304309] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15553), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304354] = 4,
    ACTIONS(1239), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15510), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304446] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17259), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3565), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 16,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [304509] = 4,
    ACTIONS(1235), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15506), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304601] = 4,
    ACTIONS(17261), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15502), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304693] = 4,
    ACTIONS(1221), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15494), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304785] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [304830] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [304877] = 4,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [304924] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [304971] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305061] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [305108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305153] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305198] = 4,
    ACTIONS(17263), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [305245] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15448), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305290] = 4,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [305337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15515), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15607), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305472] = 4,
    ACTIONS(1199), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [305519] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15645), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305564] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305656] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305703] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [305750] = 4,
    ACTIONS(17265), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [305797] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305844] = 4,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [305891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15603), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [305936] = 4,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [305983] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306028] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306075] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306122] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15413), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306214] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306259] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306349] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306396] = 4,
    ACTIONS(17267), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306443] = 4,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306490] = 4,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15599), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306582] = 4,
    ACTIONS(17269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306629] = 4,
    ACTIONS(1127), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306676] = 4,
    ACTIONS(1129), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306723] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306768] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306813] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 31,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [306858] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [306903] = 4,
    ACTIONS(17271), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306950] = 4,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [306997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307042] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307132] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307177] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15557), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307267] = 4,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [307314] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307361] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15341), 28,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307453] = 4,
    ACTIONS(17273), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [307500] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307547] = 4,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [307594] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307641] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307688] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 31,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307733] = 4,
    ACTIONS(1169), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [307780] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307825] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [307872] = 4,
    ACTIONS(17275), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [307919] = 4,
    ACTIONS(1177), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [307966] = 4,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308013] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [308060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308105] = 4,
    ACTIONS(17277), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308152] = 4,
    ACTIONS(1201), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(15341), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [308244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(16977), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308289] = 4,
    ACTIONS(1203), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308381] = 4,
    ACTIONS(17279), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308428] = 4,
    ACTIONS(1213), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308565] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308610] = 4,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308792] = 4,
    ACTIONS(17281), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308884] = 4,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [308931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [308976] = 4,
    ACTIONS(1229), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309068] = 4,
    ACTIONS(17283), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309115] = 4,
    ACTIONS(1233), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309162] = 4,
    ACTIONS(1243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309254] = 4,
    ACTIONS(17285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309301] = 4,
    ACTIONS(1265), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309348] = 4,
    ACTIONS(1269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309395] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309440] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309485] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309577] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309667] = 4,
    ACTIONS(17287), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309714] = 4,
    ACTIONS(1281), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309806] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309851] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15549), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [309943] = 4,
    ACTIONS(1285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [309990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 29,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310170] = 4,
    ACTIONS(17289), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310217] = 4,
    ACTIONS(1307), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310309] = 4,
    ACTIONS(1315), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310446] = 4,
    ACTIONS(17291), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310493] = 4,
    ACTIONS(1331), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310585] = 4,
    ACTIONS(1337), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310632] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310722] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310767] = 4,
    ACTIONS(17293), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [310904] = 4,
    ACTIONS(1359), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310951] = 4,
    ACTIONS(1363), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [310998] = 7,
    ACTIONS(17295), 1,
      sym__varid,
    ACTIONS(17298), 1,
      anon_sym_LPAREN,
    ACTIONS(17301), 1,
      anon_sym_RPAREN,
    ACTIONS(15609), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(13735), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311096] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311143] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311188] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311235] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 31,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311325] = 4,
    ACTIONS(17304), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311372] = 4,
    ACTIONS(1381), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311419] = 4,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311556] = 4,
    ACTIONS(17306), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311603] = 4,
    ACTIONS(1365), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311650] = 4,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311787] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [311832] = 4,
    ACTIONS(17308), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311879] = 4,
    ACTIONS(1345), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311926] = 4,
    ACTIONS(1343), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [311973] = 4,
    ACTIONS(1181), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312020] = 4,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312067] = 4,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312114] = 4,
    ACTIONS(17310), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312161] = 4,
    ACTIONS(1321), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312208] = 4,
    ACTIONS(1311), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312255] = 4,
    ACTIONS(17312), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312302] = 4,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312349] = 4,
    ACTIONS(17314), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312396] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312443] = 4,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312490] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312537] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312584] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312629] = 4,
    ACTIONS(1319), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312676] = 4,
    ACTIONS(17316), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312723] = 4,
    ACTIONS(1275), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312770] = 4,
    ACTIONS(17318), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312817] = 4,
    ACTIONS(1273), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [312864] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312909] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312954] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [312999] = 4,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313046] = 4,
    ACTIONS(17320), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313093] = 4,
    ACTIONS(1255), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313140] = 4,
    ACTIONS(1251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313187] = 4,
    ACTIONS(1353), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313234] = 4,
    ACTIONS(17322), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313281] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [313326] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [313371] = 4,
    ACTIONS(17324), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313418] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [313465] = 4,
    ACTIONS(1291), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313512] = 4,
    ACTIONS(1279), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313559] = 4,
    ACTIONS(17326), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313606] = 4,
    ACTIONS(1245), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313653] = 4,
    ACTIONS(1217), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313700] = 4,
    ACTIONS(1209), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313747] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [313792] = 4,
    ACTIONS(1237), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313839] = 4,
    ACTIONS(17328), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [313886] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [313931] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [313976] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314021] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314066] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314111] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314158] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314203] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314250] = 4,
    ACTIONS(1195), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314297] = 4,
    ACTIONS(1189), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314344] = 4,
    ACTIONS(17330), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314391] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314436] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314481] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314526] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [314571] = 4,
    ACTIONS(17332), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314618] = 4,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314665] = 4,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314712] = 4,
    ACTIONS(1139), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314759] = 4,
    ACTIONS(17334), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314806] = 4,
    ACTIONS(1183), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314853] = 4,
    ACTIONS(1301), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314900] = 4,
    ACTIONS(1341), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314947] = 4,
    ACTIONS(17336), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [314994] = 4,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315041] = 4,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315088] = 4,
    ACTIONS(17338), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315135] = 4,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315182] = 4,
    ACTIONS(1131), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315229] = 4,
    ACTIONS(17340), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315276] = 4,
    ACTIONS(1133), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315323] = 4,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315370] = 4,
    ACTIONS(17342), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315417] = 4,
    ACTIONS(17344), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315464] = 4,
    ACTIONS(1339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315511] = 4,
    ACTIONS(17346), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315558] = 4,
    ACTIONS(1297), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315605] = 4,
    ACTIONS(1261), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15498), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [315652] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [315696] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [315740] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [315784] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [315828] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [315872] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [315916] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [315960] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316004] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [316050] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [316094] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [316138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15565), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316182] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15481), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316226] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15561), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15645), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316314] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [316358] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 25,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316404] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316450] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316496] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316542] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [316586] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316632] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316676] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316720] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316764] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [316808] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316854] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(15341), 27,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [316898] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316942] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [316986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317030] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [317076] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317120] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317164] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317210] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [317256] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15413), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317302] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [317346] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317390] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [317434] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317480] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317524] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317568] = 11,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2488), 1,
      sym__colon2,
    STATE(15019), 1,
      aux_sym_signature_repeat1,
    STATE(18410), 1,
      sym__type_annotation,
    ACTIONS(17348), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15465), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15468), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15474), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [317628] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317716] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317760] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14273), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317848] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15587), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317936] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [317982] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318026] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [318070] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [318114] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [318158] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15448), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318246] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318290] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318334] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318424] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318558] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318604] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318736] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318780] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [318824] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [318868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318912] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [318956] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [319002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319046] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319090] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15515), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319224] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319268] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319312] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15607), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319488] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319576] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319708] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 30,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319796] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319884] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(7506), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [319930] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [319974] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320020] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [320064] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(16977), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15599), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320198] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320244] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320288] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15571), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320376] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [320420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15341), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15591), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320508] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320596] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320640] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320686] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320732] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320776] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15549), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320908] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [320952] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [320996] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321040] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321084] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321128] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15545), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321260] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321392] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321436] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [321480] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321526] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14070), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321570] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321658] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321702] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321792] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321836] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321882] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [321970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15583), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322014] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322060] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 30,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [322104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15624), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322148] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322236] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15494), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322324] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322412] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322456] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [322500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322544] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322590] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322634] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322678] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322768] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322856] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322902] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [322946] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [322992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323080] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15345), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323126] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323172] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323216] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323260] = 11,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(15571), 1,
      aux_sym_signature_repeat1,
    STATE(20848), 1,
      sym__type_annotation,
    ACTIONS(15619), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15465), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15468), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15474), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [323320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15575), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323364] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323408] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15409), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323454] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323498] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323586] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323632] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323676] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323720] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323764] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323808] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323852] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323896] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323942] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [323986] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324030] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324074] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324118] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324162] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 30,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324206] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324250] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324294] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [324338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324470] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324514] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15553), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324604] = 11,
    ACTIONS(15465), 1,
      sym__conid,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(17353), 1,
      anon_sym_AT2,
    STATE(2467), 1,
      sym__colon2,
    STATE(15571), 1,
      aux_sym_signature_repeat1,
    STATE(20848), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15468), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15474), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_u27e6,
  [324664] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15413), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324754] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15579), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15595), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15636), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15510), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324930] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [324974] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15409), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 28,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325064] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15345), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325110] = 11,
    ACTIONS(15465), 1,
      sym__conid,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(17353), 1,
      anon_sym_AT2,
    STATE(2453), 1,
      sym__colon2,
    STATE(15082), 1,
      aux_sym_signature_repeat1,
    STATE(20054), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15468), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15474), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_u27e6,
  [325170] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325214] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [325258] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15405), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325302] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [325346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325390] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(7506), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15632), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325480] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325524] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325568] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325612] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15603), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325700] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325744] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325788] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [325832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15557), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325876] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325920] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [325964] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326008] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326184] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15617), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326316] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326360] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326404] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326448] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326492] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326536] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326580] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15656), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326668] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326712] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326756] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326844] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15613), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [326976] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327064] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327108] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327152] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15341), 28,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327240] = 11,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2492), 1,
      sym__colon2,
    STATE(15197), 1,
      aux_sym_signature_repeat1,
    STATE(17081), 1,
      sym__type_annotation,
    ACTIONS(17357), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15465), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15468), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15474), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [327300] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15628), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327344] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327388] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327432] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327476] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327566] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327610] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327654] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327698] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 30,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15502), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327830] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [327874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [327962] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328006] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [328050] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328138] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [328182] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328226] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(15506), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328358] = 11,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(15082), 1,
      aux_sym_signature_repeat1,
    STATE(20054), 1,
      sym__type_annotation,
    ACTIONS(15453), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15465), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15468), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15474), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [328418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328462] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328506] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328550] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328596] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328640] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328684] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328772] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328816] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [328992] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329168] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [329214] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329260] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [329306] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15636), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329393] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329479] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329522] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329565] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329608] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329651] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15579), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329694] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329737] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329780] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15405), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [329825] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 27,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329870] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329913] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [329999] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330085] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330128] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330171] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330214] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [330257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330300] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330343] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330386] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [330429] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330472] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330515] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [330558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15636), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15632), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330730] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15617), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330773] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15613), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [330988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15628), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331031] = 10,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2492), 1,
      sym__colon2,
    STATE(15286), 1,
      aux_sym_signature_repeat1,
    STATE(17250), 1,
      sym__type_annotation,
    ACTIONS(17360), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15532), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15535), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15537), 15,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [331088] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331131] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331174] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331217] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331260] = 10,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(14974), 1,
      aux_sym_signature_repeat1,
    STATE(20104), 1,
      sym__type_annotation,
    ACTIONS(15520), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15532), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15535), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15537), 15,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [331317] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331403] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331489] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331532] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331575] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331661] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331747] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331792] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331835] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [331964] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332050] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332179] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332222] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332308] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [332351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332394] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332437] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332480] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332566] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332695] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [332738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15341), 25,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [332824] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332867] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [332910] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [332953] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [332996] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333082] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15481), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333125] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15565), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333211] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14273), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333254] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333297] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333340] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333383] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15561), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15583), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333469] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15624), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333512] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15583), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333555] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333598] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15603), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333684] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [333727] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15591), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14070), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333856] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 25,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333901] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15413), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [333946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [333989] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15645), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334118] = 10,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(15532), 1,
      sym__conid,
    STATE(2467), 1,
      sym__colon2,
    STATE(15580), 1,
      aux_sym_signature_repeat1,
    STATE(20998), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15535), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15537), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [334175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15595), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15613), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334347] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15617), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334476] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334519] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334562] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15595), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15656), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334734] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15645), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15515), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15607), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [334951] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [334994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15557), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335037] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [335080] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15603), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335166] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335209] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [335252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335295] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335338] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335424] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335467] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15565), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15481), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15624), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335596] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335639] = 10,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(15580), 1,
      aux_sym_signature_repeat1,
    STATE(20998), 1,
      sym__type_annotation,
    ACTIONS(16825), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15532), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15535), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15537), 15,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [335696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335739] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [335782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15587), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335825] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335911] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335954] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15409), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [335999] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 25,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15656), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15628), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336173] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15632), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336259] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17363), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3619), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [336320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336363] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336406] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14070), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15579), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336492] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15549), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336535] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336578] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [336621] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15591), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336664] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336707] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336793] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336836] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336922] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [336965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337008] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337053] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337096] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [337139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15549), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337182] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337225] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337268] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [337311] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337354] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337397] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337440] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15494), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337526] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15545), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15575), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337698] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337741] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15502), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337827] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [337870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15506), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [337913] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [337956] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 27,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [338001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15561), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338044] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 25,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338089] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15448), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338132] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338175] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338218] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338261] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338347] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338390] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17365), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(17150), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3594), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 13,
      sym__varsym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [338451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15510), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15553), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338580] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15571), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338623] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338709] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14273), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338795] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [338838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15571), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338924] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15553), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [338967] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(16977), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339053] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [339096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15575), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339139] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339182] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15545), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339268] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339311] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [339354] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(16977), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339440] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339483] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [339526] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339569] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339612] = 10,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2488), 1,
      sym__colon2,
    STATE(15098), 1,
      aux_sym_signature_repeat1,
    STATE(18086), 1,
      sym__type_annotation,
    ACTIONS(17367), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(15532), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15535), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15537), 15,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [339669] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339712] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339755] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339798] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339841] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339884] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 29,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339927] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15557), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [339970] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340013] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [340056] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340099] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340142] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [340185] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340228] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340271] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340357] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15345), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15587), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340445] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340488] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340531] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340574] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340617] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [340660] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [340703] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340746] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340789] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340875] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [340918] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [340961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15607), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15341), 27,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15515), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341090] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [341133] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15413), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15510), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341264] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341307] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(7506), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341352] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [341395] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [341438] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [341481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15448), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341524] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341653] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341825] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15506), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341954] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15502), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [341997] = 10,
    ACTIONS(15472), 1,
      sym_comma,
    ACTIONS(15532), 1,
      sym__conid,
    STATE(2453), 1,
      sym__colon2,
    STATE(14974), 1,
      aux_sym_signature_repeat1,
    STATE(20104), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15535), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(15537), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [342054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342097] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342140] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [342183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15494), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342226] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342269] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [342312] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342355] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [342398] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342441] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342484] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342529] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [342572] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_u27e6,
  [342615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15628), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342657] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [342701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15565), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15603), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342785] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17370), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3596), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [342845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15557), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14273), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [342929] = 7,
    ACTIONS(7530), 1,
      sym__dot,
    STATE(2463), 1,
      sym__colon2,
    STATE(18300), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [342979] = 5,
    ACTIONS(17378), 1,
      sym_comma,
    STATE(8198), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17374), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17376), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [343025] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17381), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3622), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [343085] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15561), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343127] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15583), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15607), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343211] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15515), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15591), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343295] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14070), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15613), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15617), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343421] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15549), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343463] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15448), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15595), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343547] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15656), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343589] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17383), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3548), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [343649] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15345), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [343693] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17385), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3587), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [343753] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17387), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3620), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_in,
  [343813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15481), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15624), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343897] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15557), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [343939] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15632), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [343981] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15636), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15579), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344065] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(7506), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344109] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15494), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344151] = 7,
    ACTIONS(7530), 1,
      sym__dot,
    STATE(2453), 1,
      sym__colon2,
    STATE(18190), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15502), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15506), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344285] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_AT,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15549), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_AT2,
      anon_sym_u27e6,
  [344327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15510), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(16977), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15553), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344453] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15571), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344495] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17389), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(17150), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3589), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__varsym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [344555] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15575), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15545), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344639] = 5,
    ACTIONS(17393), 1,
      anon_sym_LBRACE,
    STATE(8333), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344685] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15409), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15587), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15405), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15645), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [344855] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15405), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 26,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [344983] = 7,
    ACTIONS(7530), 1,
      sym__dot,
    STATE(2467), 1,
      sym__colon2,
    STATE(20859), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345033] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [345075] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(15599), 24,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_u27e6,
  [345119] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17395), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3608), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [345178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15510), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15624), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345260] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17397), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3625), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [345319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15583), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345401] = 12,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17399), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3567), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [345460] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [345503] = 6,
    STATE(2467), 1,
      sym__colon2,
    STATE(21201), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 25,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [345591] = 4,
    ACTIONS(5041), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [345634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15645), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345716] = 4,
    ACTIONS(5247), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [345759] = 4,
    ACTIONS(17401), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [345802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14070), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345843] = 4,
    ACTIONS(5233), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [345886] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2435), 1,
      sym__colon2,
    STATE(10772), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17405), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1847), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(17403), 11,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [345949] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15591), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [345990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15561), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346031] = 12,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17411), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3607), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [346090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15481), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346131] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346174] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17413), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3624), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__arith_dotdot,
      sym__varsym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [346233] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [346276] = 4,
    ACTIONS(17417), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15628), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15579), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15565), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15613), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15617), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346524] = 4,
    ACTIONS(5077), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [346567] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346610] = 6,
    STATE(2453), 1,
      sym__colon2,
    STATE(17970), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15632), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15545), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15599), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346780] = 6,
    STATE(2463), 1,
      sym__colon2,
    STATE(19660), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346827] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15587), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15636), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [346952] = 5,
    ACTIONS(17419), 1,
      anon_sym_LBRACE,
    STATE(8691), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [346997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15494), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347038] = 4,
    ACTIONS(5067), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [347081] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15502), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15575), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347163] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15515), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15506), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347245] = 4,
    ACTIONS(5055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [347288] = 5,
    ACTIONS(17421), 1,
      anon_sym_LBRACE,
    STATE(8700), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347333] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17423), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3578), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_in,
  [347392] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17425), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3572), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [347451] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17427), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3585), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [347510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15448), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347551] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14273), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15595), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347633] = 4,
    ACTIONS(17429), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [347676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15571), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347717] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17431), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3598), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 12,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [347776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_AT2,
      anon_sym_u27e6,
  [347817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347858] = 4,
    ACTIONS(17433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [347901] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15656), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15603), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [347983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15553), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348024] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [348067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(15607), 24,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348108] = 4,
    ACTIONS(16964), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [348151] = 4,
    ACTIONS(17439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348193] = 4,
    ACTIONS(17441), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348235] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348275] = 4,
    ACTIONS(17447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348317] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15409), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [348359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348399] = 4,
    ACTIONS(17449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348441] = 4,
    ACTIONS(17451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348483] = 4,
    ACTIONS(17453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348525] = 4,
    ACTIONS(17455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348607] = 4,
    ACTIONS(17459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348649] = 4,
    ACTIONS(17461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348691] = 4,
    ACTIONS(17463), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348813] = 4,
    ACTIONS(17465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348855] = 4,
    ACTIONS(17467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [348897] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [348977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15341), 25,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [349017] = 4,
    ACTIONS(17477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349099] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349179] = 4,
    ACTIONS(17479), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_u27e6,
  [349221] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349263] = 4,
    ACTIONS(17481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17483), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3577), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [349385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17485), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17487), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349465] = 4,
    ACTIONS(17489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349547] = 4,
    ACTIONS(17495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349629] = 4,
    ACTIONS(17497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349671] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2451), 1,
      sym__colon2,
    STATE(10845), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17499), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(17403), 10,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [349733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349773] = 4,
    ACTIONS(17501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349815] = 4,
    ACTIONS(17503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349857] = 4,
    ACTIONS(17505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [349939] = 4,
    ACTIONS(17509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [349981] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350021] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350061] = 4,
    ACTIONS(17513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350103] = 4,
    ACTIONS(17515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350145] = 4,
    ACTIONS(17517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350227] = 4,
    ACTIONS(17519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15341), 24,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [350309] = 4,
    ACTIONS(17521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350391] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(7506), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [350433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17527), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17529), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350553] = 4,
    ACTIONS(17531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [350675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350715] = 4,
    ACTIONS(17537), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350757] = 4,
    ACTIONS(17539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350799] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350879] = 4,
    ACTIONS(17549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [350921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [350961] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15345), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [351003] = 4,
    ACTIONS(17555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [351085] = 4,
    ACTIONS(17557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351127] = 4,
    ACTIONS(17559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [351209] = 4,
    ACTIONS(17561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351251] = 4,
    ACTIONS(17563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351293] = 4,
    ACTIONS(17565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351335] = 4,
    ACTIONS(17567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15341), 24,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [351417] = 4,
    ACTIONS(17569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351459] = 4,
    ACTIONS(17571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17573), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17575), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351541] = 4,
    ACTIONS(17577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [351623] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [351663] = 4,
    ACTIONS(17581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351705] = 4,
    ACTIONS(17583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
      anon_sym_u27e6,
  [351787] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17585), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3563), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym__layout_semicolon,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [351845] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [351887] = 4,
    ACTIONS(17587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351929] = 4,
    ACTIONS(17589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [351971] = 4,
    ACTIONS(17591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352013] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2467), 1,
      sym__colon2,
    STATE(13652), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(17403), 10,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [352075] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [352117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT2,
      anon_sym_u27e6,
  [352157] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15409), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [352199] = 4,
    ACTIONS(17593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352241] = 4,
    ACTIONS(17595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352283] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15345), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [352325] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [352365] = 4,
    ACTIONS(17601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352407] = 4,
    ACTIONS(17603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352449] = 4,
    ACTIONS(17605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352491] = 4,
    ACTIONS(17607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352533] = 4,
    ACTIONS(17609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352575] = 4,
    ACTIONS(17611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352617] = 4,
    ACTIONS(17613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352659] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17615), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3595), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym__varsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [352717] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [352757] = 4,
    ACTIONS(17617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352799] = 4,
    ACTIONS(17619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [352841] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [352881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [352921] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(7506), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [352963] = 4,
    ACTIONS(17629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353005] = 4,
    ACTIONS(17631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353047] = 4,
    ACTIONS(17633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353089] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [353131] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [353173] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353213] = 4,
    ACTIONS(17639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353255] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15413), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [353297] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353377] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353419] = 4,
    ACTIONS(17641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353461] = 4,
    ACTIONS(17643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353503] = 12,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17645), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3602), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [353561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353601] = 4,
    ACTIONS(17651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353643] = 4,
    ACTIONS(17653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 24,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [353725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353765] = 4,
    ACTIONS(17659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353807] = 4,
    ACTIONS(17661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [353889] = 4,
    ACTIONS(17663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17665), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17667), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [353971] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17669), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17671), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354011] = 5,
    ACTIONS(17673), 1,
      anon_sym_LBRACE,
    STATE(8835), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [354055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354135] = 4,
    ACTIONS(17675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354177] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354297] = 4,
    ACTIONS(17677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354379] = 9,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(17200), 1,
      anon_sym_EQ,
    ACTIONS(17679), 1,
      sym__varid,
    ACTIONS(17682), 1,
      anon_sym_LPAREN,
    ACTIONS(15415), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(13686), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(7506), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [354431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354471] = 4,
    ACTIONS(17685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354513] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [354555] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [354595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354635] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [354677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354717] = 4,
    ACTIONS(17687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354759] = 4,
    ACTIONS(17689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [354841] = 4,
    ACTIONS(17691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354883] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17693), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3568), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [354941] = 4,
    ACTIONS(17695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [354983] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [355065] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15413), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [355107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [355147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [355187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17697), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17699), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [355227] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17701), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3621), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [355285] = 4,
    ACTIONS(17703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17435), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17437), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [355327] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [355408] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355449] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17705), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17707), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(17709), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [355492] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 23,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [355531] = 5,
    ACTIONS(17713), 1,
      anon_sym_LBRACE,
    STATE(9337), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [355574] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355652] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [355693] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17707), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(5542), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [355736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14070), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [355775] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15557), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [355814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355853] = 5,
    ACTIONS(17715), 1,
      anon_sym_LBRACE,
    STATE(8978), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [355896] = 4,
    ACTIONS(17717), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_u27e6,
  [355937] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [355978] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15515), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [356175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356214] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [356253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15607), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356292] = 5,
    ACTIONS(17719), 1,
      anon_sym_LBRACE,
    STATE(9115), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15636), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15591), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356452] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17707), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(5542), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356495] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [356534] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17707), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(15565), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356577] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15557), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15549), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356655] = 8,
    ACTIONS(17301), 1,
      anon_sym_EQ,
    ACTIONS(17721), 1,
      sym__varid,
    ACTIONS(17724), 1,
      anon_sym_LPAREN,
    ACTIONS(15609), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(13639), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(14070), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [356743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15481), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15481), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [356938] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15565), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [356977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [357094] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17705), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17707), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(17709), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357176] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14273), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357295] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15565), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357412] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [357451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15656), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15561), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357529] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15583), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357568] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15494), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357607] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [357646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15591), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14070), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15613), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357763] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15617), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357841] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15595), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15656), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357919] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17707), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(15565), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [357962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15645), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [358040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358079] = 7,
    ACTIONS(17209), 1,
      anon_sym_BQUOTE,
    ACTIONS(17212), 1,
      sym__consym,
    ACTIONS(17727), 1,
      sym__tyconsym,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(17951), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358126] = 5,
    ACTIONS(17730), 1,
      anon_sym_LBRACE,
    STATE(9309), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [358169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358286] = 7,
    ACTIONS(17159), 1,
      anon_sym_BQUOTE,
    ACTIONS(17162), 1,
      sym__consym,
    ACTIONS(17732), 1,
      sym__tyconsym,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18044), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15561), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358411] = 7,
    ACTIONS(17159), 1,
      anon_sym_BQUOTE,
    ACTIONS(17162), 1,
      sym__consym,
    ACTIONS(17735), 1,
      sym__tyconsym,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(17902), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358458] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 23,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [358497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(16977), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358536] = 7,
    ACTIONS(17209), 1,
      anon_sym_BQUOTE,
    ACTIONS(17212), 1,
      sym__consym,
    ACTIONS(17738), 1,
      sym__tyconsym,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18088), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 23,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [358622] = 7,
    ACTIONS(17159), 1,
      anon_sym_BQUOTE,
    ACTIONS(17162), 1,
      sym__consym,
    ACTIONS(17741), 1,
      sym__tyconsym,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18250), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358669] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14273), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15583), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [358786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358825] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [358903] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [358944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [358983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359022] = 7,
    ACTIONS(17209), 1,
      anon_sym_BQUOTE,
    ACTIONS(17212), 1,
      sym__consym,
    ACTIONS(17744), 1,
      sym__tyconsym,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18282), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17747), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17749), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
  [359108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15448), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16975), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(16977), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15502), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [359381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15645), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [359576] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17751), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3617), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__varsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [359633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [359750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [359789] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [359830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15549), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359869] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15624), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15628), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359947] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15632), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [359986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15636), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15613), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360064] = 12,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17227), 1,
      sym__conid,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(17753), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3616), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__varsym,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [360121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15632), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15506), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15579), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15617), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360355] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360394] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15603), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15510), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15595), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [360550] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17755), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3575), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [360605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [360644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15624), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [360683] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 23,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [360917] = 5,
    ACTIONS(17757), 1,
      anon_sym_LBRACE,
    STATE(9178), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [360960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [360999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361038] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT2,
      anon_sym_u27e6,
  [361077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [361155] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [361196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361235] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361274] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [361315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15587), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15579), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361393] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15448), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361588] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [361627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15553), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15545), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [361744] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15575), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [361822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [361861] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15571), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [361941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [361980] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362021] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15571), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362099] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362177] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15553), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362255] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15575), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15515), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15607), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15510), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362606] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362645] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15506), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [362723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15502), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15494), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [362840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [362996] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363035] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17759), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3623), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [363090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363129] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363168] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15628), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [363248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15603), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [363287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15341), 24,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [363326] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363404] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [363445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363484] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15545), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [363562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363757] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363835] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [363952] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [363991] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15587), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [364030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364108] = 9,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(17194), 1,
      sym__varid,
    ACTIONS(17197), 1,
      anon_sym_LPAREN,
    ACTIONS(17200), 1,
      anon_sym_EQ,
    ACTIONS(15415), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(13691), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 4,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(7506), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [364159] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364237] = 4,
    ACTIONS(17761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [364277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [364315] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [364355] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2452), 1,
      sym__colon2,
    STATE(11265), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17763), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1824), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(17403), 8,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [364415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [364453] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [364493] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364533] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [364573] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [364613] = 4,
    ACTIONS(17765), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [364653] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15341), 22,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [364729] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [364769] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [364809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [364847] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [364887] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [364927] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [364967] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [365007] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15409), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [365047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365085] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365161] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365199] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 24,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [365237] = 5,
    ACTIONS(17767), 1,
      anon_sym_LBRACE,
    STATE(9502), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365279] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365395] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365435] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365587] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(7506), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [365627] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15345), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [365667] = 7,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17771), 1,
      sym__tyconsym,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(19368), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [365713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [365751] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15345), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [365791] = 7,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17773), 1,
      sym__tyconsym,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18229), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [365837] = 4,
    ACTIONS(17775), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365877] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(7506), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [365917] = 4,
    ACTIONS(17777), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365957] = 4,
    ACTIONS(5437), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [365997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366035] = 4,
    ACTIONS(17779), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366075] = 4,
    ACTIONS(17781), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366115] = 4,
    ACTIONS(17783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366155] = 4,
    ACTIONS(5433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366195] = 4,
    ACTIONS(17785), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366235] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15409), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [366275] = 4,
    ACTIONS(6048), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366353] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366391] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17787), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3559), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [366445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
      anon_sym_u27e6,
  [366483] = 4,
    ACTIONS(5447), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366523] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [366563] = 4,
    ACTIONS(17789), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366603] = 4,
    ACTIONS(17791), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366643] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17793), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3553), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [366697] = 4,
    ACTIONS(5924), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366737] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [366777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [366967] = 4,
    ACTIONS(5411), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367007] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367085] = 4,
    ACTIONS(5956), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367125] = 4,
    ACTIONS(17795), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_u27e6,
  [367165] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367203] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [367243] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367283] = 4,
    ACTIONS(6030), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367323] = 4,
    ACTIONS(5443), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367363] = 4,
    ACTIONS(17797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367403] = 4,
    ACTIONS(17799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367443] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367521] = 4,
    ACTIONS(17801), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367561] = 4,
    ACTIONS(17803), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367639] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367677] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367717] = 4,
    ACTIONS(5930), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367757] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 24,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [367795] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367835] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [367873] = 4,
    ACTIONS(5970), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367913] = 4,
    ACTIONS(5345), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367953] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [367993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368031] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15341), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [368107] = 4,
    ACTIONS(17805), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [368147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [368185] = 4,
    ACTIONS(17807), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_type,
      anon_sym__,
      anon_sym_newtype,
      anon_sym_data,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [368225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [368263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [368339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368377] = 4,
    ACTIONS(17809), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [368417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368455] = 4,
    ACTIONS(17811), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [368495] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368533] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368571] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368685] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17813), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3583), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [368739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368815] = 4,
    ACTIONS(17815), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_u27e6,
  [368855] = 4,
    ACTIONS(17817), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [368895] = 5,
    ACTIONS(17819), 1,
      anon_sym_LBRACE,
    STATE(9598), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [368937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [368975] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369013] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 22,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369089] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(17707), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(5542), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [369131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [369169] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17821), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3600), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [369223] = 4,
    ACTIONS(17823), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [369263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [369453] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369493] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369531] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(17707), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17705), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(17709), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [369573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [369649] = 5,
    ACTIONS(17711), 1,
      anon_sym_deriving,
    ACTIONS(17707), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(15565), 19,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [369691] = 7,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17825), 1,
      sym__tyconsym,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18375), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [369737] = 4,
    ACTIONS(5369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [369777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [369815] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [369855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT2,
      anon_sym_u27e6,
  [369893] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [369933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 22,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [369971] = 4,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370049] = 4,
    ACTIONS(17827), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370089] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370129] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15413), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [370169] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [370209] = 5,
    ACTIONS(17829), 1,
      anon_sym_LBRACE,
    STATE(9361), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370289] = 7,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17831), 1,
      sym__tyconsym,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(18329), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [370335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370411] = 8,
    ACTIONS(17295), 1,
      sym__varid,
    ACTIONS(17298), 1,
      anon_sym_LPAREN,
    ACTIONS(17301), 1,
      anon_sym_EQ,
    ACTIONS(15609), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(13735), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 4,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(14070), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [370459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [370497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [370649] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370689] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370727] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [370767] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17833), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3612), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [370821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [370897] = 12,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17835), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_deriving,
    STATE(3611), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [370953] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15413), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [370993] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371033] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [371073] = 4,
    ACTIONS(5435), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371113] = 4,
    ACTIONS(5445), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371153] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [371193] = 4,
    ACTIONS(17837), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    ACTIONS(15498), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371271] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [371311] = 4,
    ACTIONS(17839), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [371351] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17841), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3577), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(17144), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [371405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [371591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371628] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15557), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [371665] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371739] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [371778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371852] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [371926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [371963] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [372002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372076] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [372115] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372152] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [372189] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372376] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [372857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [372968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15645), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [373005] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373044] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17843), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
    STATE(3580), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [373097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373171] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373245] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373282] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(7506), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [373321] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [373358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [373395] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373432] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17845), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
    STATE(3588), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [373485] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [373522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15448), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [373596] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15413), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [373635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [373709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [373746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [373783] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [373820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [373857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373894] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [373931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [373968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374190] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15591), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [374301] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [374338] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [374375] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15515), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [374412] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15607), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [374523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374560] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374671] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [374784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [374969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [375006] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375043] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [375080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15579), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375154] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15636), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15632), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [375302] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17847), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3584), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [375355] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15628), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375392] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15624), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [375579] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [375616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375653] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [375690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375727] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [375764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [375801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375838] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17849), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(3555), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [375891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [375928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [375965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [376150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376372] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376411] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15656), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15595), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [376596] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376633] = 4,
    ACTIONS(17851), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_u27e6,
  [376672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376746] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2505), 1,
      sym__colon2,
    STATE(11550), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17853), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 7,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
    STATE(1959), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [376805] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15617), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15613), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14070), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [376953] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [376990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [377027] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15579), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15565), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377101] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14273), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15583), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [377212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [377249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15561), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [377323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [377360] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17855), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3599), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [377413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [377450] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377489] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377526] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [377563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15561), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377600] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377637] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15583), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [377711] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14273), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377785] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15565), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15591), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14070), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15613), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [377970] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15345), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [378009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [378046] = 5,
    ACTIONS(17857), 1,
      anon_sym_LBRACE,
    STATE(9853), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [378087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15617), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15595), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378161] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15656), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [378235] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [378272] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15409), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [378311] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [378348] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [378422] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378459] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [378533] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [378570] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17859), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
    STATE(3603), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [378623] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [378660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15624), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [378734] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [378808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15628), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [378882] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378919] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15632), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [378956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [378993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15636), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [379030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379215] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [379252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379326] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [379363] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379437] = 5,
    ACTIONS(17861), 1,
      anon_sym_LBRACE,
    STATE(9671), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379478] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [379515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379589] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [379628] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379665] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379702] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2479), 1,
      sym__colon2,
    STATE(11631), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17863), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    STATE(1822), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379835] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [379872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [379909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [379946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [379983] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [380057] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380094] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [380168] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [380242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17865), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(17867), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380316] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380353] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(17871), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15587), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380538] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380575] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380760] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [380945] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [380982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15545), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15575), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15571), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15553), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [381241] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15510), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381391] = 4,
    ACTIONS(17873), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [381430] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [381467] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17875), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
    STATE(3615), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [381520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15506), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15502), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381594] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381668] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15494), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381890] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [381929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [381966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15448), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382003] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [382040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [382077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382151] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382188] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [382225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382262] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT2,
      anon_sym_u27e6,
  [382336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15515), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [382484] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15607), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382521] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382558] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382634] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382671] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382710] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [382821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [382858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15599), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15645), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [382932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [382969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [383006] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383043] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 23,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [383191] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383302] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [383376] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [383413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15603), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [383524] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383561] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383598] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383635] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [383746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [383783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [383820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [383857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [383894] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [383931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [383968] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [384005] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [384042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15603), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [384079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [384153] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [384190] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384301] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [384340] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [384377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384488] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384636] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [384675] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384788] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384825] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [384899] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [384938] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [384977] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385014] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17865), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(17867), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385125] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385164] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385201] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [385240] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385277] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [385351] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385388] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [385499] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [385610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15587), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385684] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(17871), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385760] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385834] = 4,
    ACTIONS(17877), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [385873] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15545), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [385947] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15575), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [385984] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386021] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [386132] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15571), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386206] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 23,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15553), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386317] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386354] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386391] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [386428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15510), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386465] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386539] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386576] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [386613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15506), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15502), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [386724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386835] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386872] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [386983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15494), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387131] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [387205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [387279] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2455), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14883), 1,
      sym__type_annotation,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17879), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    STATE(1822), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [387338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387375] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15557), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387412] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [387449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387560] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15405), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [387599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387673] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387747] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387821] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [387895] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [387932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [387969] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388006] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388043] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [388191] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388228] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388265] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17881), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
    STATE(3610), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [388318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388355] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388394] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388468] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [388618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [388655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [388692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [388765] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388837] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388873] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388911] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [388949] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [388985] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389021] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389129] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389165] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389237] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389273] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389309] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389345] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15553), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [389417] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389453] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389489] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389561] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389669] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15575), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [389743] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389781] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [389817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [389997] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390071] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15571), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [390143] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(17871), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390179] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17865), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(17867), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390287] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2484), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15337), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17883), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1982), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [390345] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390381] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [390455] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15481), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [390527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15565), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [390563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [390599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390635] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15624), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [390707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15545), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [390743] = 4,
    ACTIONS(17887), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_u27e6,
  [390781] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390817] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390855] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390927] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [390963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [390999] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391035] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391071] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391107] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391143] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15628), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391179] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15613), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391215] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391251] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391287] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391323] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391359] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391395] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391431] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391467] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391503] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [391575] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [391611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [391647] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391683] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15617), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391719] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391757] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15632), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15636), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391829] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [391865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15595), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391901] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15579), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [391937] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [391973] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392009] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392045] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392081] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15510), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [392153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15603), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [392225] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392261] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392297] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392369] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392405] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392441] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392477] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392513] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392549] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392621] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392693] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392729] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392765] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392837] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392873] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392909] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [392945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [392981] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393017] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393053] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393089] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393125] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 22,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393161] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393197] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393233] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393269] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15583), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [393341] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15448), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [393377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [393413] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393449] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [393521] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [393557] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2457), 1,
      sym__colon2,
    STATE(12600), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17889), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1982), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [393615] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393651] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393687] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393723] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [393795] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393831] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393867] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393903] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [393939] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [393975] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [394047] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [394119] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17891), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
    STATE(3614), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [394171] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394207] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394243] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394279] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15561), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [394387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15506), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394423] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394459] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394495] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15591), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [394567] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15502), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394639] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [394675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15515), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394711] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [394749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15607), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394785] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14070), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [394857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15656), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [394893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [394929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [394965] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395001] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395073] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395109] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395217] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395325] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15645), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [395397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395433] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395469] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395505] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395541] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395577] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395685] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [395721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395757] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395829] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [395865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395901] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [395973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [396045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [396081] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [396117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14273), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [396153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [396189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396225] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [396263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396299] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [396337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396409] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [396445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [396661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396805] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [396841] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396877] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [396915] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [396951] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [396989] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397097] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [397135] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [397171] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [397207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397315] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [397353] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397389] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397461] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [397497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397533] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [397569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [397713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15494), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [397785] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397857] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [397893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [397929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15587), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [397965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398037] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [398073] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398109] = 4,
    ACTIONS(17893), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [398147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398255] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398291] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [398327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398363] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398435] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15557), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [398507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [398543] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15549), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [398579] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [398617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15405), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [398653] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398689] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [398725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [398833] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398869] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398905] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [398941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [398977] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [399013] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399085] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 22,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [399121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [399157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(15599), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [399193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [399229] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [399265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [399301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [399769] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [399807] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [399843] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [399881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [399917] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [399953] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [399989] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400025] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400061] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400133] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400241] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400277] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400313] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u27e6,
  [400421] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400526] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400561] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400596] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2443), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15699), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17895), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1948), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [400653] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2486), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15950), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17897), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1914), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [400710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400745] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400850] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400885] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [400920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [400990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401025] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401060] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401095] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401130] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401165] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401235] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401270] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401305] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401340] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401375] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401515] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401550] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401585] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401620] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401655] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401760] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401795] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [401865] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401900] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401935] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [401970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17697), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
    ACTIONS(17699), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_u27e6,
  [402040] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2447), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15824), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17899), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1854), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [402097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402132] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402167] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402237] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402272] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402307] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402342] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402377] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402412] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402447] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402517] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402552] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402587] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402622] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402657] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402692] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402727] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402762] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [402902] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402937] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [402972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [403007] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403042] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403077] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403112] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403147] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403184] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403219] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403256] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403291] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403326] = 3,
    ACTIONS(15339), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 21,
      sym__dot,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403361] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403396] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403431] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403466] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403501] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403536] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403571] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403606] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403641] = 5,
    ACTIONS(17901), 1,
      anon_sym_LBRACE,
    STATE(10284), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17391), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(10390), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [403680] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403715] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [403750] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2459), 1,
      sym__colon2,
    STATE(13092), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17903), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1854), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [403807] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [403842] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2440), 1,
      sym__colon2,
    STATE(13067), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17905), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1842), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [403899] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2469), 1,
      sym__colon2,
    STATE(12851), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17907), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1914), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [403956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [403991] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [404026] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2468), 1,
      sym__colon2,
    STATE(12867), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17909), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1881), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [404083] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2487), 1,
      sym__colon2,
    STATE(13256), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17911), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1948), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [404140] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404175] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404210] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404245] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404280] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404315] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404352] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404389] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404424] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404459] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404494] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404529] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404566] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404601] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404636] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404671] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404706] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2503), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15877), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17913), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1842), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [404763] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [404798] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404833] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404868] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404903] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404938] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [404973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [405008] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405043] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [405113] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405148] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405183] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405218] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405253] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405288] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [405323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15341), 19,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [405358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [405393] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405428] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405463] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [405533] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [405568] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [405638] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [405673] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405708] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405743] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405778] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405813] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405848] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [405918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [405953] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [405988] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [406023] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15411), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15413), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406095] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [406130] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [406165] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406235] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406412] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2499), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15678), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17915), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1881), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [406469] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406504] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406574] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406644] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [406679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406819] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406854] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [406924] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [406959] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [406994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [407029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [407099] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [407134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [407169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [407274] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [407309] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [407344] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [407379] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [407414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407484] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407519] = 4,
    ACTIONS(17917), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407555] = 3,
    ACTIONS(15551), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [407589] = 13,
    ACTIONS(8432), 1,
      sym__integer_literal,
    ACTIONS(8442), 1,
      sym__conid,
    ACTIONS(8444), 1,
      anon_sym_LBRACK,
    ACTIONS(17919), 1,
      anon_sym_LPAREN,
    STATE(7210), 1,
      sym_constructor,
    STATE(7425), 1,
      sym_qualified_type,
    STATE(17798), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8430), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8434), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7427), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [407643] = 4,
    ACTIONS(17921), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407679] = 13,
    ACTIONS(5696), 1,
      sym__integer_literal,
    ACTIONS(5706), 1,
      sym__conid,
    ACTIONS(5708), 1,
      anon_sym_LBRACK,
    ACTIONS(17923), 1,
      anon_sym_LPAREN,
    STATE(7511), 1,
      sym_constructor,
    STATE(7856), 1,
      sym_qualified_type,
    STATE(17716), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5694), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5698), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7809), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7799), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [407733] = 13,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(11346), 1,
      sym__integer_literal,
    ACTIONS(16604), 1,
      anon_sym_LBRACK,
    ACTIONS(17925), 1,
      anon_sym_LPAREN,
    STATE(8714), 1,
      sym_constructor,
    STATE(8961), 1,
      sym_qualified_type,
    STATE(16565), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16598), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8962), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8949), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [407787] = 13,
    ACTIONS(2204), 1,
      sym__integer_literal,
    ACTIONS(4537), 1,
      sym__conid,
    ACTIONS(16278), 1,
      anon_sym_LBRACK,
    ACTIONS(17927), 1,
      anon_sym_LPAREN,
    STATE(4656), 1,
      sym_constructor,
    STATE(4747), 1,
      sym_qualified_type,
    STATE(16614), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2206), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16272), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4746), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4723), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [407841] = 13,
    ACTIONS(10394), 1,
      sym__integer_literal,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(16478), 1,
      anon_sym_LBRACK,
    ACTIONS(17929), 1,
      anon_sym_LPAREN,
    STATE(8278), 1,
      sym_constructor,
    STATE(8387), 1,
      sym_qualified_type,
    STATE(17805), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16472), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8336), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8438), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [407895] = 4,
    ACTIONS(12292), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407931] = 4,
    ACTIONS(17931), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [407967] = 13,
    ACTIONS(7011), 1,
      sym__integer_literal,
    ACTIONS(7022), 1,
      anon_sym_LBRACK,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(17933), 1,
      anon_sym_LPAREN,
    STATE(6424), 1,
      sym_constructor,
    STATE(6875), 1,
      sym_qualified_type,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7009), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7013), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6865), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6886), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408021] = 4,
    ACTIONS(12375), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408057] = 13,
    ACTIONS(9852), 1,
      sym__integer_literal,
    ACTIONS(9862), 1,
      sym__conid,
    ACTIONS(15870), 1,
      anon_sym_LBRACK,
    ACTIONS(17935), 1,
      anon_sym_LPAREN,
    STATE(11530), 1,
      sym_constructor,
    STATE(12362), 1,
      sym_qualified_type,
    STATE(16590), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9854), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15864), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12386), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12341), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408111] = 13,
    ACTIONS(6240), 1,
      sym__integer_literal,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(6250), 1,
      anon_sym_LBRACK,
    ACTIONS(17937), 1,
      anon_sym_LPAREN,
    STATE(7789), 1,
      sym_constructor,
    STATE(7978), 1,
      sym_qualified_type,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6238), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6242), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7979), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7973), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408165] = 4,
    ACTIONS(12377), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408201] = 4,
    ACTIONS(12296), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408237] = 13,
    ACTIONS(9380), 1,
      sym__integer_literal,
    ACTIONS(9390), 1,
      sym__conid,
    ACTIONS(15916), 1,
      anon_sym_LBRACK,
    ACTIONS(17939), 1,
      anon_sym_LPAREN,
    STATE(11012), 1,
      sym_constructor,
    STATE(11310), 1,
      sym_qualified_type,
    STATE(17722), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9382), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15910), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11307), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408291] = 13,
    ACTIONS(1922), 1,
      sym__integer_literal,
    ACTIONS(4851), 1,
      sym__conid,
    ACTIONS(16194), 1,
      anon_sym_LBRACK,
    ACTIONS(17941), 1,
      anon_sym_LPAREN,
    STATE(4207), 1,
      sym_constructor,
    STATE(4231), 1,
      sym_qualified_type,
    STATE(16672), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1924), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16188), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4230), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4234), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408345] = 4,
    ACTIONS(12306), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408381] = 4,
    ACTIONS(12284), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408417] = 4,
    ACTIONS(12282), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408453] = 4,
    ACTIONS(17943), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408489] = 4,
    ACTIONS(17945), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408525] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2445), 1,
      sym__colon2,
    STATE(13532), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17947), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1931), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [408581] = 4,
    ACTIONS(12235), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408617] = 13,
    ACTIONS(7341), 1,
      sym__integer_literal,
    ACTIONS(7352), 1,
      anon_sym_LBRACK,
    ACTIONS(7901), 1,
      sym__conid,
    ACTIONS(17949), 1,
      anon_sym_LPAREN,
    STATE(6598), 1,
      sym_constructor,
    STATE(6768), 1,
      sym_qualified_type,
    STATE(17711), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7339), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7343), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6767), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6773), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408671] = 13,
    ACTIONS(4639), 1,
      sym__integer_literal,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(16450), 1,
      anon_sym_LBRACK,
    ACTIONS(17951), 1,
      anon_sym_LPAREN,
    STATE(11435), 1,
      sym_constructor,
    STATE(11627), 1,
      sym_qualified_type,
    STATE(16538), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16444), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11620), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11680), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408725] = 13,
    ACTIONS(8081), 1,
      sym__integer_literal,
    ACTIONS(8092), 1,
      anon_sym_LBRACK,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(17953), 1,
      anon_sym_LPAREN,
    STATE(7010), 1,
      sym_constructor,
    STATE(7038), 1,
      sym_qualified_type,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8079), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8083), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7104), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7119), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408779] = 13,
    ACTIONS(12063), 1,
      sym__integer_literal,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(16805), 1,
      anon_sym_LBRACK,
    ACTIONS(17955), 1,
      anon_sym_LPAREN,
    STATE(9338), 1,
      sym_constructor,
    STATE(9612), 1,
      sym_qualified_type,
    STATE(17815), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16799), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9610), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9614), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408833] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(17957), 1,
      anon_sym_LPAREN,
    STATE(7545), 1,
      sym_constructor,
    STATE(7776), 1,
      sym_qualified_type,
    STATE(16491), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [408887] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(1959), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [408943] = 4,
    ACTIONS(12308), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [408979] = 4,
    ACTIONS(12177), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [409015] = 13,
    ACTIONS(6350), 1,
      sym__integer_literal,
    ACTIONS(6361), 1,
      anon_sym_LBRACK,
    ACTIONS(8293), 1,
      sym__conid,
    ACTIONS(17961), 1,
      anon_sym_LPAREN,
    STATE(6016), 1,
      sym_constructor,
    STATE(6542), 1,
      sym_qualified_type,
    STATE(17709), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6348), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6352), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6553), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6530), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409069] = 13,
    ACTIONS(11587), 1,
      sym__integer_literal,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(16765), 1,
      anon_sym_LBRACK,
    ACTIONS(17963), 1,
      anon_sym_LPAREN,
    STATE(8871), 1,
      sym_constructor,
    STATE(9308), 1,
      sym_qualified_type,
    STATE(17818), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11589), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16759), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9305), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9329), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409123] = 13,
    ACTIONS(12247), 1,
      sym__integer_literal,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(16667), 1,
      anon_sym_LBRACK,
    ACTIONS(17965), 1,
      anon_sym_LPAREN,
    STATE(9247), 1,
      sym_constructor,
    STATE(9568), 1,
      sym_qualified_type,
    STATE(17821), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12249), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16661), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9567), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9571), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409177] = 4,
    ACTIONS(17967), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [409213] = 4,
    ACTIONS(12239), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [409249] = 13,
    ACTIONS(551), 1,
      sym__integer_literal,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(16306), 1,
      anon_sym_LBRACK,
    ACTIONS(17969), 1,
      anon_sym_LPAREN,
    STATE(4507), 1,
      sym_constructor,
    STATE(5190), 1,
      sym_qualified_type,
    STATE(16328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(553), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16300), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5065), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409303] = 13,
    ACTIONS(6951), 1,
      sym__integer_literal,
    ACTIONS(6962), 1,
      anon_sym_LBRACK,
    ACTIONS(8676), 1,
      sym__conid,
    ACTIONS(17971), 1,
      anon_sym_LPAREN,
    STATE(6519), 1,
      sym_constructor,
    STATE(6838), 1,
      sym_qualified_type,
    STATE(17700), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6949), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6953), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6836), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6848), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409357] = 13,
    ACTIONS(8051), 1,
      sym__integer_literal,
    ACTIONS(8062), 1,
      anon_sym_LBRACK,
    ACTIONS(8335), 1,
      sym__conid,
    ACTIONS(17973), 1,
      anon_sym_LPAREN,
    STATE(6853), 1,
      sym_constructor,
    STATE(7151), 1,
      sym_qualified_type,
    STATE(16524), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8049), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8053), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7149), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409411] = 13,
    ACTIONS(15734), 1,
      sym__integer_literal,
    ACTIONS(15742), 1,
      sym__conid,
    ACTIONS(15744), 1,
      anon_sym_LBRACK,
    ACTIONS(17975), 1,
      anon_sym_LPAREN,
    STATE(15380), 1,
      sym_constructor,
    STATE(15847), 1,
      sym_qualified_type,
    STATE(17823), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15732), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15736), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15829), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(16041), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409465] = 13,
    ACTIONS(15996), 1,
      sym__integer_literal,
    ACTIONS(16004), 1,
      sym__conid,
    ACTIONS(16006), 1,
      anon_sym_LBRACK,
    ACTIONS(17977), 1,
      anon_sym_LPAREN,
    STATE(15739), 1,
      sym_constructor,
    STATE(17738), 1,
      sym_qualified_type,
    STATE(17826), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15994), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15998), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17741), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(17695), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409519] = 13,
    ACTIONS(11743), 1,
      sym__integer_literal,
    ACTIONS(11752), 1,
      anon_sym_LBRACK,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(17979), 1,
      anon_sym_LPAREN,
    STATE(8413), 1,
      sym_constructor,
    STATE(8539), 1,
      sym_qualified_type,
    STATE(17687), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11741), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11745), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8540), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8525), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409573] = 13,
    ACTIONS(6400), 1,
      sym__integer_literal,
    ACTIONS(6411), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      sym__conid,
    ACTIONS(17981), 1,
      anon_sym_LPAREN,
    STATE(6266), 1,
      sym_constructor,
    STATE(6361), 1,
      sym_qualified_type,
    STATE(16681), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6398), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6402), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6360), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6371), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409627] = 3,
    ACTIONS(15601), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [409661] = 13,
    ACTIONS(16846), 1,
      sym__integer_literal,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(16856), 1,
      anon_sym_LBRACK,
    ACTIONS(17983), 1,
      anon_sym_LPAREN,
    STATE(16476), 1,
      aux_sym__qualifying_module,
    STATE(17853), 1,
      sym_constructor,
    STATE(20193), 1,
      sym_qualified_type,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16844), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(16848), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20194), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(20187), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409715] = 13,
    ACTIONS(6442), 1,
      sym__integer_literal,
    ACTIONS(6453), 1,
      anon_sym_LBRACK,
    ACTIONS(8351), 1,
      sym__conid,
    ACTIONS(17985), 1,
      anon_sym_LPAREN,
    STATE(5948), 1,
      sym_constructor,
    STATE(6327), 1,
      sym_qualified_type,
    STATE(16697), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6326), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6336), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409769] = 13,
    ACTIONS(6602), 1,
      sym__integer_literal,
    ACTIONS(6613), 1,
      anon_sym_LBRACK,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(17987), 1,
      anon_sym_LPAREN,
    STATE(5977), 1,
      sym_constructor,
    STATE(6533), 1,
      sym_qualified_type,
    STATE(17828), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6600), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6604), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6531), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6546), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15403), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15405), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [409857] = 13,
    ACTIONS(12970), 1,
      sym__integer_literal,
    ACTIONS(15307), 1,
      sym__conid,
    ACTIONS(16836), 1,
      anon_sym_LBRACK,
    ACTIONS(17989), 1,
      anon_sym_LPAREN,
    STATE(14604), 1,
      sym_constructor,
    STATE(15413), 1,
      sym_qualified_type,
    STATE(17667), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16830), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15410), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(15470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409911] = 13,
    ACTIONS(11022), 1,
      sym__integer_literal,
    ACTIONS(13038), 1,
      sym__conid,
    ACTIONS(16436), 1,
      anon_sym_LBRACK,
    ACTIONS(17991), 1,
      anon_sym_LPAREN,
    STATE(8794), 1,
      sym_constructor,
    STATE(8922), 1,
      sym_qualified_type,
    STATE(16509), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11024), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16430), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8921), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8927), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [409965] = 13,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(16236), 1,
      anon_sym_LBRACK,
    ACTIONS(17993), 1,
      anon_sym_LPAREN,
    STATE(10396), 1,
      sym_constructor,
    STATE(10495), 1,
      sym_qualified_type,
    STATE(17691), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16230), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10471), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10535), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410019] = 13,
    ACTIONS(4543), 1,
      sym__integer_literal,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(15808), 1,
      anon_sym_LBRACK,
    ACTIONS(17995), 1,
      anon_sym_LPAREN,
    STATE(11826), 1,
      sym_constructor,
    STATE(12148), 1,
      sym_qualified_type,
    STATE(16503), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4545), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15802), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12186), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12179), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410073] = 4,
    ACTIONS(17997), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410109] = 13,
    ACTIONS(13028), 1,
      sym__integer_literal,
    ACTIONS(15311), 1,
      sym__conid,
    ACTIONS(15986), 1,
      anon_sym_LBRACK,
    ACTIONS(17999), 1,
      anon_sym_LPAREN,
    STATE(14478), 1,
      sym_constructor,
    STATE(14665), 1,
      sym_qualified_type,
    STATE(16497), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13030), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15980), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14668), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14595), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410163] = 4,
    ACTIONS(12134), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410199] = 13,
    ACTIONS(13428), 1,
      sym__integer_literal,
    ACTIONS(13436), 1,
      sym__conid,
    ACTIONS(13438), 1,
      anon_sym_LBRACK,
    ACTIONS(18001), 1,
      anon_sym_LPAREN,
    STATE(8710), 1,
      sym_constructor,
    STATE(8998), 1,
      sym_qualified_type,
    STATE(16504), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13426), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13430), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9326), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9253), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410253] = 4,
    ACTIONS(12128), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410289] = 13,
    ACTIONS(6805), 1,
      sym__integer_literal,
    ACTIONS(6816), 1,
      anon_sym_LBRACK,
    ACTIONS(8516), 1,
      sym__conid,
    ACTIONS(18003), 1,
      anon_sym_LPAREN,
    STATE(6280), 1,
      sym_constructor,
    STATE(6339), 1,
      sym_qualified_type,
    STATE(17742), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6803), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6807), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6337), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6376), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410343] = 4,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410379] = 3,
    ACTIONS(15479), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [410413] = 4,
    ACTIONS(12094), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410449] = 13,
    ACTIONS(4733), 1,
      sym__integer_literal,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(16222), 1,
      anon_sym_LBRACK,
    ACTIONS(18005), 1,
      anon_sym_LPAREN,
    STATE(12109), 1,
      sym_constructor,
    STATE(12134), 1,
      sym_qualified_type,
    STATE(16485), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4735), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16216), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12187), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12150), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410503] = 13,
    ACTIONS(6270), 1,
      sym__integer_literal,
    ACTIONS(6281), 1,
      anon_sym_LBRACK,
    ACTIONS(8201), 1,
      sym__conid,
    ACTIONS(18007), 1,
      anon_sym_LPAREN,
    STATE(5373), 1,
      sym_constructor,
    STATE(6235), 1,
      sym_qualified_type,
    STATE(17800), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6268), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6272), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6205), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6275), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410557] = 13,
    ACTIONS(12442), 1,
      sym__integer_literal,
    ACTIONS(12450), 1,
      sym__conid,
    ACTIONS(12452), 1,
      anon_sym_LBRACK,
    ACTIONS(18009), 1,
      anon_sym_LPAREN,
    STATE(8743), 1,
      sym_constructor,
    STATE(9042), 1,
      sym_qualified_type,
    STATE(16483), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12440), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12444), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9039), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410611] = 3,
    ACTIONS(15643), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [410645] = 4,
    ACTIONS(12009), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410681] = 3,
    ACTIONS(15563), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [410715] = 4,
    ACTIONS(18011), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410751] = 13,
    ACTIONS(15351), 1,
      sym__integer_literal,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(15361), 1,
      anon_sym_LBRACK,
    ACTIONS(18013), 1,
      anon_sym_LPAREN,
    STATE(15916), 1,
      sym_constructor,
    STATE(17427), 1,
      aux_sym__qualifying_module,
    STATE(17586), 1,
      sym_qualified_type,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15349), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15353), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17587), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(17580), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410805] = 13,
    ACTIONS(12935), 1,
      sym__integer_literal,
    ACTIONS(15325), 1,
      sym__conid,
    ACTIONS(16819), 1,
      anon_sym_LBRACK,
    ACTIONS(18015), 1,
      anon_sym_LPAREN,
    STATE(14399), 1,
      sym_constructor,
    STATE(14757), 1,
      sym_qualified_type,
    STATE(17666), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16813), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14753), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14768), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410859] = 13,
    ACTIONS(14819), 1,
      sym__integer_literal,
    ACTIONS(14827), 1,
      sym__conid,
    ACTIONS(14829), 1,
      anon_sym_LBRACK,
    ACTIONS(18017), 1,
      anon_sym_LPAREN,
    STATE(9572), 1,
      sym_constructor,
    STATE(9717), 1,
      sym_qualified_type,
    STATE(17583), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14817), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14821), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9862), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9861), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [410913] = 4,
    ACTIONS(18019), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410949] = 4,
    ACTIONS(11729), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [410985] = 4,
    ACTIONS(12278), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411021] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1766), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [411077] = 4,
    ACTIONS(18021), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411113] = 13,
    ACTIONS(13054), 1,
      sym__integer_literal,
    ACTIONS(15329), 1,
      sym__conid,
    ACTIONS(16152), 1,
      anon_sym_LBRACK,
    ACTIONS(18023), 1,
      anon_sym_LPAREN,
    STATE(14222), 1,
      sym_constructor,
    STATE(14893), 1,
      sym_qualified_type,
    STATE(16470), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13056), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16146), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14906), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14880), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411167] = 13,
    ACTIONS(9920), 1,
      sym__integer_literal,
    ACTIONS(9930), 1,
      sym__conid,
    ACTIONS(16380), 1,
      anon_sym_LBRACK,
    ACTIONS(18025), 1,
      anon_sym_LPAREN,
    STATE(11720), 1,
      sym_constructor,
    STATE(12554), 1,
      sym_qualified_type,
    STATE(16706), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9922), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16374), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12557), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12543), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411221] = 13,
    ACTIONS(15175), 1,
      sym__integer_literal,
    ACTIONS(15183), 1,
      sym__conid,
    ACTIONS(15185), 1,
      anon_sym_LBRACK,
    ACTIONS(18027), 1,
      anon_sym_LPAREN,
    STATE(9748), 1,
      sym_constructor,
    STATE(10049), 1,
      sym_qualified_type,
    STATE(17572), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15173), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15177), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9967), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9934), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411275] = 13,
    ACTIONS(12181), 1,
      sym__integer_literal,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(18029), 1,
      anon_sym_LPAREN,
    STATE(9061), 1,
      sym_constructor,
    STATE(9501), 1,
      sym_qualified_type,
    STATE(17578), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12179), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12183), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9474), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411329] = 13,
    ACTIONS(13086), 1,
      sym__integer_literal,
    ACTIONS(15321), 1,
      sym__conid,
    ACTIONS(15842), 1,
      anon_sym_LBRACK,
    ACTIONS(18031), 1,
      anon_sym_LPAREN,
    STATE(14830), 1,
      sym_constructor,
    STATE(15445), 1,
      sym_qualified_type,
    STATE(16453), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13088), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15836), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15436), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(15533), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411383] = 4,
    ACTIONS(12300), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411419] = 13,
    ACTIONS(8524), 1,
      sym__integer_literal,
    ACTIONS(8534), 1,
      sym__conid,
    ACTIONS(8536), 1,
      anon_sym_LBRACK,
    ACTIONS(18033), 1,
      anon_sym_LPAREN,
    STATE(8138), 1,
      sym_constructor,
    STATE(8200), 1,
      sym_qualified_type,
    STATE(16417), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8522), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8526), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8201), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8192), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411473] = 4,
    ACTIONS(18035), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411509] = 13,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(18037), 1,
      anon_sym_LPAREN,
    STATE(7058), 1,
      sym_constructor,
    STATE(7527), 1,
      sym_qualified_type,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411563] = 4,
    ACTIONS(12369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411599] = 4,
    ACTIONS(11717), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411635] = 13,
    ACTIONS(8460), 1,
      sym__integer_literal,
    ACTIONS(8470), 1,
      sym__conid,
    ACTIONS(8472), 1,
      anon_sym_LBRACK,
    ACTIONS(18039), 1,
      anon_sym_LPAREN,
    STATE(7609), 1,
      sym_constructor,
    STATE(8133), 1,
      sym_qualified_type,
    STATE(16751), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8458), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8462), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8114), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8189), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411689] = 13,
    ACTIONS(7419), 1,
      sym__integer_literal,
    ACTIONS(7429), 1,
      sym__conid,
    ACTIONS(7431), 1,
      anon_sym_LBRACK,
    ACTIONS(18041), 1,
      anon_sym_LPAREN,
    STATE(7604), 1,
      sym_constructor,
    STATE(8119), 1,
      sym_qualified_type,
    STATE(16252), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7417), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7421), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8123), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8073), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18043), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(18045), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_u27e6,
  [411777] = 4,
    ACTIONS(12367), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411813] = 4,
    ACTIONS(18047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411849] = 13,
    ACTIONS(2643), 1,
      sym__integer_literal,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(16250), 1,
      anon_sym_LBRACK,
    ACTIONS(18049), 1,
      anon_sym_LPAREN,
    STATE(4782), 1,
      sym_constructor,
    STATE(5387), 1,
      sym_qualified_type,
    STATE(16789), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2645), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16244), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5393), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5371), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411903] = 4,
    ACTIONS(11703), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [411939] = 13,
    ACTIONS(3162), 1,
      sym__integer_literal,
    ACTIONS(4483), 1,
      sym__conid,
    ACTIONS(16620), 1,
      anon_sym_LBRACK,
    ACTIONS(18051), 1,
      anon_sym_LPAREN,
    STATE(5441), 1,
      sym_constructor,
    STATE(6207), 1,
      sym_qualified_type,
    STATE(16805), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3164), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16614), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6206), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6219), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [411993] = 4,
    ACTIONS(18053), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412029] = 13,
    ACTIONS(89), 1,
      sym__integer_literal,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(16709), 1,
      anon_sym_LBRACK,
    ACTIONS(18055), 1,
      anon_sym_LPAREN,
    STATE(3724), 1,
      sym_constructor,
    STATE(3766), 1,
      sym_qualified_type,
    STATE(16815), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(91), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3769), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(3761), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412083] = 13,
    ACTIONS(7793), 1,
      sym__integer_literal,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(7805), 1,
      anon_sym_LBRACK,
    ACTIONS(18057), 1,
      anon_sym_LPAREN,
    STATE(7745), 1,
      sym_constructor,
    STATE(8084), 1,
      sym_qualified_type,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7981), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8026), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412137] = 4,
    ACTIONS(11857), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412173] = 3,
    ACTIONS(15581), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [412207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15555), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(15557), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412241] = 4,
    ACTIONS(11855), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412277] = 13,
    ACTIONS(13163), 1,
      sym__integer_literal,
    ACTIONS(15293), 1,
      sym__conid,
    ACTIONS(16506), 1,
      anon_sym_LBRACK,
    ACTIONS(18059), 1,
      anon_sym_LPAREN,
    STATE(14811), 1,
      sym_constructor,
    STATE(15506), 1,
      sym_qualified_type,
    STATE(17631), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13165), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16500), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15507), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(15486), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412331] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15407), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15409), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412367] = 3,
    ACTIONS(15622), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [412401] = 13,
    ACTIONS(5820), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      anon_sym_LBRACK,
    ACTIONS(8111), 1,
      sym__conid,
    ACTIONS(18061), 1,
      anon_sym_LPAREN,
    STATE(4538), 1,
      sym_constructor,
    STATE(4809), 1,
      sym_qualified_type,
    STATE(16817), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5818), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5822), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4810), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4804), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412455] = 4,
    ACTIONS(12108), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412491] = 13,
    ACTIONS(2017), 1,
      sym__integer_literal,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(18063), 1,
      anon_sym_LPAREN,
    STATE(7058), 1,
      sym_constructor,
    STATE(7527), 1,
      sym_qualified_type,
    STATE(17837), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2015), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2019), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7552), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412545] = 4,
    ACTIONS(11713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412581] = 13,
    ACTIONS(6981), 1,
      sym__integer_literal,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(8043), 1,
      sym__conid,
    ACTIONS(18065), 1,
      anon_sym_LPAREN,
    STATE(6470), 1,
      sym_constructor,
    STATE(7003), 1,
      sym_qualified_type,
    STATE(16822), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6878), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7030), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412635] = 13,
    ACTIONS(15379), 1,
      sym__integer_literal,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(15389), 1,
      anon_sym_LBRACK,
    ACTIONS(18067), 1,
      anon_sym_LPAREN,
    STATE(14905), 1,
      sym_constructor,
    STATE(15195), 1,
      sym_qualified_type,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15203), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(15092), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412689] = 4,
    ACTIONS(18069), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412725] = 4,
    ACTIONS(11707), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412761] = 4,
    ACTIONS(18071), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412797] = 13,
    ACTIONS(2115), 1,
      sym__integer_literal,
    ACTIONS(4617), 1,
      sym__conid,
    ACTIONS(15972), 1,
      anon_sym_LBRACK,
    ACTIONS(18073), 1,
      anon_sym_LPAREN,
    STATE(4430), 1,
      sym_constructor,
    STATE(4628), 1,
      sym_qualified_type,
    STATE(17605), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15966), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4635), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4598), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412851] = 4,
    ACTIONS(11711), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412887] = 13,
    ACTIONS(12338), 1,
      sym__integer_literal,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(16534), 1,
      anon_sym_LBRACK,
    ACTIONS(18075), 1,
      anon_sym_LPAREN,
    STATE(8930), 1,
      sym_constructor,
    STATE(9535), 1,
      sym_qualified_type,
    STATE(16826), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12340), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16528), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9536), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9523), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [412941] = 4,
    ACTIONS(11701), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [412977] = 4,
    ACTIONS(12132), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413013] = 4,
    ACTIONS(18077), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413049] = 3,
    ACTIONS(15597), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [413083] = 13,
    ACTIONS(8792), 1,
      sym__integer_literal,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(8804), 1,
      anon_sym_LBRACK,
    ACTIONS(18079), 1,
      anon_sym_LPAREN,
    STATE(7545), 1,
      sym_constructor,
    STATE(7776), 1,
      sym_qualified_type,
    STATE(16491), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8790), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8794), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7840), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7753), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413137] = 4,
    ACTIONS(12316), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413173] = 13,
    ACTIONS(10949), 1,
      sym__integer_literal,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(15958), 1,
      anon_sym_LBRACK,
    ACTIONS(18081), 1,
      anon_sym_LPAREN,
    STATE(8723), 1,
      sym_constructor,
    STATE(8972), 1,
      sym_qualified_type,
    STATE(16830), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15952), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8973), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8959), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413227] = 4,
    ACTIONS(12118), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413263] = 4,
    ACTIONS(12126), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413299] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2460), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(17218), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18083), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    STATE(1910), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [413355] = 4,
    ACTIONS(18085), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413391] = 13,
    ACTIONS(6210), 1,
      sym__integer_literal,
    ACTIONS(6220), 1,
      sym__conid,
    ACTIONS(6222), 1,
      anon_sym_LBRACK,
    ACTIONS(18087), 1,
      anon_sym_LPAREN,
    STATE(7618), 1,
      sym_constructor,
    STATE(8178), 1,
      sym_qualified_type,
    STATE(17453), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6208), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6212), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7935), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8053), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413445] = 13,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(10591), 1,
      sym__integer_literal,
    ACTIONS(16723), 1,
      anon_sym_LBRACK,
    ACTIONS(18089), 1,
      anon_sym_LPAREN,
    STATE(8340), 1,
      sym_constructor,
    STATE(8637), 1,
      sym_qualified_type,
    STATE(16343), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16717), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8639), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8631), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413499] = 4,
    ACTIONS(18091), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413535] = 4,
    ACTIONS(12389), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413571] = 13,
    ACTIONS(169), 1,
      sym__integer_literal,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(16520), 1,
      anon_sym_LBRACK,
    ACTIONS(18093), 1,
      anon_sym_LPAREN,
    STATE(4564), 1,
      sym_constructor,
    STATE(4850), 1,
      sym_qualified_type,
    STATE(16835), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(171), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16514), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4851), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4843), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413625] = 4,
    ACTIONS(18095), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413661] = 13,
    ACTIONS(7041), 1,
      sym__integer_literal,
    ACTIONS(7052), 1,
      anon_sym_LBRACK,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(18097), 1,
      anon_sym_LPAREN,
    STATE(6627), 1,
      sym_constructor,
    STATE(6700), 1,
      sym_qualified_type,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7039), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7043), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6716), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413715] = 4,
    ACTIONS(12110), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413751] = 13,
    ACTIONS(2799), 1,
      sym__integer_literal,
    ACTIONS(4435), 1,
      sym__conid,
    ACTIONS(16166), 1,
      anon_sym_LBRACK,
    ACTIONS(18099), 1,
      anon_sym_LPAREN,
    STATE(4927), 1,
      sym_constructor,
    STATE(5775), 1,
      sym_qualified_type,
    STATE(16344), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2801), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16160), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5777), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5755), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413805] = 4,
    ACTIONS(12116), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413841] = 13,
    ACTIONS(7971), 1,
      sym__integer_literal,
    ACTIONS(7981), 1,
      sym__conid,
    ACTIONS(7983), 1,
      anon_sym_LBRACK,
    ACTIONS(18101), 1,
      anon_sym_LPAREN,
    STATE(7399), 1,
      sym_constructor,
    STATE(7734), 1,
      sym_qualified_type,
    STATE(17581), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7969), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7973), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7732), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7739), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [413895] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1775), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [413951] = 4,
    ACTIONS(18103), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [413987] = 13,
    ACTIONS(9346), 1,
      sym__integer_literal,
    ACTIONS(9356), 1,
      sym__conid,
    ACTIONS(16054), 1,
      anon_sym_LBRACK,
    ACTIONS(18105), 1,
      anon_sym_LPAREN,
    STATE(11374), 1,
      sym_constructor,
    STATE(11655), 1,
      sym_qualified_type,
    STATE(17573), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9348), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16048), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11731), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11748), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414041] = 4,
    ACTIONS(11895), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414077] = 4,
    ACTIONS(18107), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414113] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(18109), 1,
      anon_sym_LPAREN,
    STATE(4198), 1,
      sym_constructor,
    STATE(4241), 1,
      sym_qualified_type,
    STATE(16437), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414167] = 4,
    ACTIONS(18111), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414203] = 4,
    ACTIONS(11913), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414239] = 4,
    ACTIONS(18113), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414275] = 4,
    ACTIONS(11893), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414311] = 4,
    ACTIONS(18115), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414347] = 4,
    ACTIONS(18117), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414383] = 4,
    ACTIONS(11899), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414419] = 13,
    ACTIONS(7863), 1,
      sym__integer_literal,
    ACTIONS(7873), 1,
      sym__conid,
    ACTIONS(7875), 1,
      anon_sym_LBRACK,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    STATE(6985), 1,
      sym_constructor,
    STATE(7068), 1,
      sym_qualified_type,
    STATE(17564), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7070), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7036), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414473] = 13,
    ACTIONS(1582), 1,
      sym__integer_literal,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(16334), 1,
      anon_sym_LBRACK,
    ACTIONS(18121), 1,
      anon_sym_LPAREN,
    STATE(5177), 1,
      sym_constructor,
    STATE(5268), 1,
      sym_qualified_type,
    STATE(17292), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1584), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16328), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5267), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414527] = 13,
    ACTIONS(7447), 1,
      sym__integer_literal,
    ACTIONS(7458), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      sym__conid,
    ACTIONS(18123), 1,
      anon_sym_LPAREN,
    STATE(6474), 1,
      sym_constructor,
    STATE(6999), 1,
      sym_qualified_type,
    STATE(17559), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7445), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7449), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6791), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6966), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414581] = 13,
    ACTIONS(9818), 1,
      sym__integer_literal,
    ACTIONS(9828), 1,
      sym__conid,
    ACTIONS(16124), 1,
      anon_sym_LBRACK,
    ACTIONS(18125), 1,
      anon_sym_LPAREN,
    STATE(11254), 1,
      sym_constructor,
    STATE(11939), 1,
      sym_qualified_type,
    STATE(17551), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9820), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16118), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11933), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11962), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414635] = 4,
    ACTIONS(18127), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414671] = 4,
    ACTIONS(18129), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414707] = 13,
    ACTIONS(8131), 1,
      sym__integer_literal,
    ACTIONS(8141), 1,
      sym__conid,
    ACTIONS(8143), 1,
      anon_sym_LBRACK,
    ACTIONS(18131), 1,
      anon_sym_LPAREN,
    STATE(7363), 1,
      sym_constructor,
    STATE(7851), 1,
      sym_qualified_type,
    STATE(17334), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8129), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8133), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7674), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7649), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414761] = 4,
    ACTIONS(11956), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414797] = 4,
    ACTIONS(18133), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414833] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(18135), 1,
      anon_sym_LPAREN,
    STATE(6424), 1,
      sym_constructor,
    STATE(6875), 1,
      sym_qualified_type,
    STATE(16646), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [414887] = 4,
    ACTIONS(12276), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414923] = 3,
    ACTIONS(15567), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [414957] = 4,
    ACTIONS(11903), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [414993] = 3,
    ACTIONS(15492), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [415027] = 13,
    ACTIONS(4769), 1,
      sym__integer_literal,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(16320), 1,
      anon_sym_LBRACK,
    ACTIONS(18137), 1,
      anon_sym_LPAREN,
    STATE(11246), 1,
      sym_constructor,
    STATE(12003), 1,
      sym_qualified_type,
    STATE(17037), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4771), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11556), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11531), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415081] = 4,
    ACTIONS(12096), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415117] = 4,
    ACTIONS(12280), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415153] = 13,
    ACTIONS(12738), 1,
      sym__integer_literal,
    ACTIONS(12746), 1,
      sym__conid,
    ACTIONS(12748), 1,
      anon_sym_LBRACK,
    ACTIONS(18139), 1,
      anon_sym_LPAREN,
    STATE(8746), 1,
      sym_constructor,
    STATE(9050), 1,
      sym_qualified_type,
    STATE(17545), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12736), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12740), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9052), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9037), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415207] = 4,
    ACTIONS(11735), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415243] = 4,
    ACTIONS(11911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415279] = 4,
    ACTIONS(18141), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415315] = 4,
    ACTIONS(11907), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415351] = 4,
    ACTIONS(18143), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415387] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15343), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15345), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415423] = 4,
    ACTIONS(18145), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415459] = 13,
    ACTIONS(8307), 1,
      sym__integer_literal,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_LBRACK,
    ACTIONS(18147), 1,
      anon_sym_LPAREN,
    STATE(7248), 1,
      sym_constructor,
    STATE(7591), 1,
      sym_qualified_type,
    STATE(16496), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7720), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7589), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415513] = 13,
    ACTIONS(13771), 1,
      sym__integer_literal,
    ACTIONS(13779), 1,
      sym__conid,
    ACTIONS(13781), 1,
      anon_sym_LBRACK,
    ACTIONS(18149), 1,
      anon_sym_LPAREN,
    STATE(9104), 1,
      sym_constructor,
    STATE(9529), 1,
      sym_qualified_type,
    STATE(17296), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13769), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13773), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9439), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9437), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415567] = 13,
    ACTIONS(2849), 1,
      sym__integer_literal,
    ACTIONS(4607), 1,
      sym__conid,
    ACTIONS(16068), 1,
      anon_sym_LBRACK,
    ACTIONS(18151), 1,
      anon_sym_LPAREN,
    STATE(4933), 1,
      sym_constructor,
    STATE(5713), 1,
      sym_qualified_type,
    STATE(16443), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2851), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16062), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5714), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5689), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415621] = 4,
    ACTIONS(18153), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415657] = 3,
    ACTIONS(15559), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [415691] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(18155), 1,
      anon_sym_LPAREN,
    STATE(7249), 1,
      sym_constructor,
    STATE(7630), 1,
      sym_qualified_type,
    STATE(16860), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415745] = 4,
    ACTIONS(12005), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415781] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(18157), 1,
      anon_sym_LPAREN,
    STATE(7010), 1,
      sym_constructor,
    STATE(7038), 1,
      sym_qualified_type,
    STATE(17717), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415835] = 4,
    ACTIONS(12122), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [415871] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(18159), 1,
      anon_sym_LPAREN,
    STATE(7596), 1,
      sym_constructor,
    STATE(8023), 1,
      sym_qualified_type,
    STATE(16892), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [415925] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1801), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [415981] = 4,
    ACTIONS(11853), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [416017] = 13,
    ACTIONS(6554), 1,
      sym__integer_literal,
    ACTIONS(6565), 1,
      anon_sym_LBRACK,
    ACTIONS(7921), 1,
      sym__conid,
    ACTIONS(18161), 1,
      anon_sym_LPAREN,
    STATE(6296), 1,
      sym_constructor,
    STATE(6389), 1,
      sym_qualified_type,
    STATE(17534), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6552), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6556), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6392), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6380), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416071] = 4,
    ACTIONS(12130), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [416107] = 3,
    ACTIONS(15547), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [416141] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15415), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(7506), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [416177] = 4,
    ACTIONS(12175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [416213] = 13,
    ACTIONS(11863), 1,
      sym__integer_literal,
    ACTIONS(11872), 1,
      anon_sym_LBRACK,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(18163), 1,
      anon_sym_LPAREN,
    STATE(8382), 1,
      sym_constructor,
    STATE(8561), 1,
      sym_qualified_type,
    STATE(16934), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8570), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8534), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416267] = 13,
    ACTIONS(7929), 1,
      sym__integer_literal,
    ACTIONS(7940), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      sym__conid,
    ACTIONS(18165), 1,
      anon_sym_LPAREN,
    STATE(6686), 1,
      sym_constructor,
    STATE(7233), 1,
      sym_qualified_type,
    STATE(16943), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7927), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7931), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7209), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7197), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416321] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2485), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(16760), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18167), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    STATE(1993), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [416377] = 4,
    ACTIONS(12371), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [416413] = 13,
    ACTIONS(13294), 1,
      sym__integer_literal,
    ACTIONS(15317), 1,
      sym__conid,
    ACTIONS(16364), 1,
      anon_sym_LBRACK,
    ACTIONS(18169), 1,
      anon_sym_LPAREN,
    STATE(14153), 1,
      sym_constructor,
    STATE(14922), 1,
      sym_qualified_type,
    STATE(16951), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13296), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16358), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14785), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14834), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416467] = 4,
    ACTIONS(18171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [416503] = 13,
    ACTIONS(11487), 1,
      sym__integer_literal,
    ACTIONS(13304), 1,
      sym__conid,
    ACTIONS(16492), 1,
      anon_sym_LBRACK,
    ACTIONS(18173), 1,
      anon_sym_LPAREN,
    STATE(8855), 1,
      sym_constructor,
    STATE(9262), 1,
      sym_qualified_type,
    STATE(16970), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16486), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8957), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9025), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416557] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1815), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [416613] = 3,
    ACTIONS(15555), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [416647] = 13,
    ACTIONS(13002), 1,
      sym__integer_literal,
    ACTIONS(15337), 1,
      sym__conid,
    ACTIONS(16180), 1,
      anon_sym_LBRACK,
    ACTIONS(18175), 1,
      anon_sym_LPAREN,
    STATE(14038), 1,
      sym_constructor,
    STATE(14217), 1,
      sym_qualified_type,
    STATE(17189), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13004), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16174), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14209), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416701] = 13,
    ACTIONS(10854), 1,
      sym__integer_literal,
    ACTIONS(15333), 1,
      sym__conid,
    ACTIONS(15888), 1,
      anon_sym_LBRACK,
    ACTIONS(18177), 1,
      anon_sym_LPAREN,
    STATE(14319), 1,
      sym_constructor,
    STATE(14577), 1,
      sym_qualified_type,
    STATE(16561), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10856), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15882), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14571), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14560), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416755] = 13,
    ACTIONS(7071), 1,
      sym__integer_literal,
    ACTIONS(7082), 1,
      anon_sym_LBRACK,
    ACTIONS(8756), 1,
      sym__conid,
    ACTIONS(18179), 1,
      anon_sym_LPAREN,
    STATE(6365), 1,
      sym_constructor,
    STATE(6724), 1,
      sym_qualified_type,
    STATE(17509), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7069), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7073), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6725), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6704), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416809] = 13,
    ACTIONS(15421), 1,
      sym__integer_literal,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(15431), 1,
      anon_sym_LBRACK,
    ACTIONS(18181), 1,
      anon_sym_LPAREN,
    STATE(14479), 1,
      sym_constructor,
    STATE(14661), 1,
      sym_qualified_type,
    STATE(16910), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15419), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(15423), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14660), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14677), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [416863] = 3,
    ACTIONS(15589), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [416897] = 3,
    ACTIONS(15609), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [416931] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2464), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(16394), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(1973), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [416987] = 13,
    ACTIONS(4503), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(16292), 1,
      anon_sym_LBRACK,
    ACTIONS(18185), 1,
      anon_sym_LPAREN,
    STATE(10790), 1,
      sym_constructor,
    STATE(11124), 1,
      sym_qualified_type,
    STATE(17204), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4505), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16286), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10977), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417041] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(18187), 1,
      anon_sym_LPAREN,
    STATE(7745), 1,
      sym_constructor,
    STATE(8084), 1,
      sym_qualified_type,
    STATE(16693), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417095] = 4,
    ACTIONS(18189), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417131] = 13,
    ACTIONS(8684), 1,
      sym__integer_literal,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(8696), 1,
      anon_sym_LBRACK,
    ACTIONS(18191), 1,
      anon_sym_LPAREN,
    STATE(7249), 1,
      sym_constructor,
    STATE(7630), 1,
      sym_qualified_type,
    STATE(16860), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8682), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8686), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7846), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7854), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417185] = 4,
    ACTIONS(18193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417221] = 13,
    ACTIONS(9202), 1,
      sym__integer_literal,
    ACTIONS(9212), 1,
      sym__conid,
    ACTIONS(16737), 1,
      anon_sym_LBRACK,
    ACTIONS(18195), 1,
      anon_sym_LPAREN,
    STATE(11163), 1,
      sym_constructor,
    STATE(12111), 1,
      sym_qualified_type,
    STATE(16972), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9204), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16731), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12070), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12034), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417275] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1816), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [417331] = 4,
    ACTIONS(12379), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417367] = 4,
    ACTIONS(18197), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417403] = 4,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417439] = 13,
    ACTIONS(12225), 1,
      sym__conid,
    ACTIONS(14535), 1,
      sym__integer_literal,
    ACTIONS(14543), 1,
      anon_sym_LBRACK,
    ACTIONS(18199), 1,
      anon_sym_LPAREN,
    STATE(9556), 1,
      sym_constructor,
    STATE(9739), 1,
      sym_qualified_type,
    STATE(17486), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14533), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14537), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9749), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9752), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417493] = 4,
    ACTIONS(11737), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417529] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1778), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [417585] = 3,
    ACTIONS(15403), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [417619] = 4,
    ACTIONS(12288), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417655] = 4,
    ACTIONS(12385), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417691] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1793), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [417747] = 13,
    ACTIONS(2246), 1,
      sym__integer_literal,
    ACTIONS(4809), 1,
      sym__conid,
    ACTIONS(16264), 1,
      anon_sym_LBRACK,
    ACTIONS(18201), 1,
      anon_sym_LPAREN,
    STATE(4678), 1,
      sym_constructor,
    STATE(5257), 1,
      sym_qualified_type,
    STATE(17457), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2248), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16258), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4806), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5234), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417801] = 4,
    ACTIONS(11715), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417837] = 13,
    ACTIONS(8219), 1,
      sym__integer_literal,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(8231), 1,
      anon_sym_LBRACK,
    ACTIONS(18203), 1,
      anon_sym_LPAREN,
    STATE(7596), 1,
      sym_constructor,
    STATE(8023), 1,
      sym_qualified_type,
    STATE(16892), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8217), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8221), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7942), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417891] = 4,
    ACTIONS(11891), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [417927] = 13,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(12615), 1,
      sym__integer_literal,
    ACTIONS(16576), 1,
      anon_sym_LBRACK,
    ACTIONS(18205), 1,
      anon_sym_LPAREN,
    STATE(9374), 1,
      sym_constructor,
    STATE(9834), 1,
      sym_qualified_type,
    STATE(16977), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(12617), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16570), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9856), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9843), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [417981] = 4,
    ACTIONS(12120), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418017] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(18207), 1,
      anon_sym_LPAREN,
    STATE(6627), 1,
      sym_constructor,
    STATE(6700), 1,
      sym_qualified_type,
    STATE(17568), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418071] = 13,
    ACTIONS(9278), 1,
      sym__integer_literal,
    ACTIONS(9288), 1,
      sym__conid,
    ACTIONS(16695), 1,
      anon_sym_LBRACK,
    ACTIONS(18209), 1,
      anon_sym_LPAREN,
    STATE(10745), 1,
      sym_constructor,
    STATE(10842), 1,
      sym_qualified_type,
    STATE(16996), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16689), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10794), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10787), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418125] = 3,
    ACTIONS(15585), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [418159] = 4,
    ACTIONS(11889), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418195] = 3,
    ACTIONS(15463), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [418229] = 13,
    ACTIONS(9886), 1,
      sym__integer_literal,
    ACTIONS(9896), 1,
      sym__conid,
    ACTIONS(16348), 1,
      anon_sym_LBRACK,
    ACTIONS(18211), 1,
      anon_sym_LPAREN,
    STATE(11769), 1,
      sym_constructor,
    STATE(12229), 1,
      sym_qualified_type,
    STATE(17449), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9888), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16342), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12292), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12296), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418283] = 4,
    ACTIONS(12387), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418319] = 4,
    ACTIONS(18213), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418355] = 4,
    ACTIONS(18215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418391] = 13,
    ACTIONS(6122), 1,
      sym__integer_literal,
    ACTIONS(6133), 1,
      anon_sym_LBRACK,
    ACTIONS(8121), 1,
      sym__conid,
    ACTIONS(18217), 1,
      anon_sym_LPAREN,
    STATE(5774), 1,
      sym_constructor,
    STATE(5955), 1,
      sym_qualified_type,
    STATE(17028), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(6120), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6124), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5920), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5908), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418445] = 13,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(15768), 1,
      anon_sym_LBRACK,
    ACTIONS(18219), 1,
      anon_sym_LPAREN,
    STATE(4679), 1,
      sym_constructor,
    STATE(4924), 1,
      sym_qualified_type,
    STATE(17373), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4917), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5068), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418499] = 13,
    ACTIONS(4679), 1,
      sym__integer_literal,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    STATE(11248), 1,
      sym_constructor,
    STATE(11929), 1,
      sym_qualified_type,
    STATE(17073), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4681), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15680), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11897), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418553] = 3,
    ACTIONS(15626), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [418587] = 13,
    ACTIONS(10990), 1,
      sym__integer_literal,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(13280), 1,
      anon_sym_LBRACK,
    ACTIONS(18223), 1,
      anon_sym_LPAREN,
    STATE(8213), 1,
      sym_constructor,
    STATE(8265), 1,
      sym_qualified_type,
    STATE(16645), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10992), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13274), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8250), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418641] = 3,
    ACTIONS(15611), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [418675] = 13,
    ACTIONS(1448), 1,
      sym__integer_literal,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(16681), 1,
      anon_sym_LBRACK,
    ACTIONS(18225), 1,
      anon_sym_LPAREN,
    STATE(4246), 1,
      sym_constructor,
    STATE(4498), 1,
      sym_qualified_type,
    STATE(17602), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1450), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4470), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4423), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418729] = 4,
    ACTIONS(12302), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16932), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(16930), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418799] = 4,
    ACTIONS(11887), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [418835] = 4,
    ACTIONS(18227), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17415), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(16971), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u27e6,
  [418871] = 13,
    ACTIONS(8488), 1,
      sym__integer_literal,
    ACTIONS(8498), 1,
      sym__conid,
    ACTIONS(8500), 1,
      anon_sym_LBRACK,
    ACTIONS(18229), 1,
      anon_sym_LPAREN,
    STATE(7362), 1,
      sym_constructor,
    STATE(7847), 1,
      sym_qualified_type,
    STATE(17439), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8486), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8490), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7811), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7775), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418925] = 13,
    ACTIONS(2754), 1,
      sym__integer_literal,
    ACTIONS(4603), 1,
      sym__conid,
    ACTIONS(16648), 1,
      anon_sym_LBRACK,
    ACTIONS(18231), 1,
      anon_sym_LPAREN,
    STATE(4925), 1,
      sym_constructor,
    STATE(5757), 1,
      sym_qualified_type,
    STATE(17048), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2756), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16642), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5799), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5806), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [418979] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2489), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(17003), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18233), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1901), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [419035] = 3,
    ACTIONS(15615), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [419069] = 4,
    ACTIONS(12373), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419105] = 3,
    ACTIONS(15630), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [419139] = 3,
    ACTIONS(15634), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [419173] = 3,
    ACTIONS(15500), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [419207] = 13,
    ACTIONS(9516), 1,
      sym__integer_literal,
    ACTIONS(9526), 1,
      sym__conid,
    ACTIONS(16634), 1,
      anon_sym_LBRACK,
    ACTIONS(18235), 1,
      anon_sym_LPAREN,
    STATE(11976), 1,
      sym_constructor,
    STATE(12658), 1,
      sym_qualified_type,
    STATE(17052), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9518), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12506), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12450), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419261] = 13,
    ACTIONS(8552), 1,
      sym__integer_literal,
    ACTIONS(8562), 1,
      sym__conid,
    ACTIONS(8564), 1,
      anon_sym_LBRACK,
    ACTIONS(18237), 1,
      anon_sym_LPAREN,
    STATE(7597), 1,
      sym_constructor,
    STATE(8046), 1,
      sym_qualified_type,
    STATE(17064), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8550), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8554), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7939), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7922), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419315] = 4,
    ACTIONS(12312), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419351] = 4,
    ACTIONS(11767), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419387] = 13,
    ACTIONS(10690), 1,
      sym__integer_literal,
    ACTIONS(13205), 1,
      sym__conid,
    ACTIONS(16751), 1,
      anon_sym_LBRACK,
    ACTIONS(18239), 1,
      anon_sym_LPAREN,
    STATE(8432), 1,
      sym_constructor,
    STATE(8697), 1,
      sym_qualified_type,
    STATE(17066), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10692), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16745), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8527), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8653), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419441] = 4,
    ACTIONS(18241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419477] = 4,
    ACTIONS(18243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419513] = 13,
    ACTIONS(2287), 1,
      sym__integer_literal,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(16590), 1,
      anon_sym_LBRACK,
    ACTIONS(18245), 1,
      anon_sym_LPAREN,
    STATE(4600), 1,
      sym_constructor,
    STATE(4997), 1,
      sym_qualified_type,
    STATE(17051), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2289), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16584), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4955), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4950), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419567] = 4,
    ACTIONS(18247), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419603] = 3,
    ACTIONS(15654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [419637] = 3,
    ACTIONS(15504), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [419671] = 4,
    ACTIONS(12310), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419707] = 13,
    ACTIONS(13668), 1,
      sym__integer_literal,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(16026), 1,
      anon_sym_LBRACK,
    ACTIONS(18249), 1,
      anon_sym_LPAREN,
    STATE(10043), 1,
      sym_constructor,
    STATE(10434), 1,
      sym_qualified_type,
    STATE(17088), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13670), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16020), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10273), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10334), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419761] = 13,
    ACTIONS(10036), 1,
      sym__integer_literal,
    ACTIONS(10046), 1,
      sym__conid,
    ACTIONS(16562), 1,
      anon_sym_LBRACK,
    ACTIONS(18251), 1,
      anon_sym_LPAREN,
    STATE(12728), 1,
      sym_constructor,
    STATE(12936), 1,
      sym_qualified_type,
    STATE(17079), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10038), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16556), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12904), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12994), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419815] = 4,
    ACTIONS(18253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419851] = 13,
    ACTIONS(9614), 1,
      sym__integer_literal,
    ACTIONS(9622), 1,
      sym__conid,
    ACTIONS(15944), 1,
      anon_sym_LBRACK,
    ACTIONS(18255), 1,
      anon_sym_LPAREN,
    STATE(12205), 1,
      sym_constructor,
    STATE(12966), 1,
      sym_qualified_type,
    STATE(17278), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9616), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15938), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13006), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(13056), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419905] = 13,
    ACTIONS(2900), 1,
      sym__integer_literal,
    ACTIONS(4453), 1,
      sym__conid,
    ACTIONS(16548), 1,
      anon_sym_LBRACK,
    ACTIONS(18257), 1,
      anon_sym_LPAREN,
    STATE(5038), 1,
      sym_constructor,
    STATE(5583), 1,
      sym_qualified_type,
    STATE(17082), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2902), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16542), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5657), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5671), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [419959] = 4,
    ACTIONS(12304), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [419995] = 4,
    ACTIONS(12100), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [420031] = 13,
    ACTIONS(11075), 1,
      sym__integer_literal,
    ACTIONS(15299), 1,
      sym__conid,
    ACTIONS(16138), 1,
      anon_sym_LBRACK,
    ACTIONS(18259), 1,
      anon_sym_LPAREN,
    STATE(13409), 1,
      sym_constructor,
    STATE(13699), 1,
      sym_qualified_type,
    STATE(16814), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(11077), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16132), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13715), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(13771), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [420085] = 13,
    ACTIONS(9698), 1,
      sym__integer_literal,
    ACTIONS(9708), 1,
      sym__conid,
    ACTIONS(16408), 1,
      anon_sym_LBRACK,
    ACTIONS(18261), 1,
      anon_sym_LPAREN,
    STATE(11432), 1,
      sym_constructor,
    STATE(11634), 1,
      sym_qualified_type,
    STATE(17435), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9700), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16402), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11566), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11553), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [420139] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2436), 1,
      sym__colon2,
    STATE(13503), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18263), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    STATE(1910), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420195] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2472), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(17484), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18265), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1962), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420251] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2497), 1,
      sym__colon2,
    STATE(13466), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18267), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(1973), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420307] = 4,
    ACTIONS(11915), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [420343] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2491), 1,
      sym__colon2,
    STATE(13444), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18269), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1901), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420399] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2501), 1,
      sym__colon2,
    STATE(13268), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18271), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1960), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420455] = 4,
    ACTIONS(11897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [420491] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2495), 1,
      sym__colon2,
    STATE(13373), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18273), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    STATE(1993), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420547] = 13,
    ACTIONS(2344), 1,
      sym__integer_literal,
    ACTIONS(4583), 1,
      sym__conid,
    ACTIONS(16422), 1,
      anon_sym_LBRACK,
    ACTIONS(18275), 1,
      anon_sym_LPAREN,
    STATE(4546), 1,
      sym_constructor,
    STATE(5214), 1,
      sym_qualified_type,
    STATE(17426), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2346), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16416), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5192), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5189), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [420601] = 3,
    ACTIONS(15530), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [420635] = 4,
    ACTIONS(12098), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [420671] = 4,
    ACTIONS(12092), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [420707] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2437), 1,
      sym__colon2,
    STATE(13483), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18277), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1892), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [420763] = 13,
    ACTIONS(9312), 1,
      sym__integer_literal,
    ACTIONS(9322), 1,
      sym__conid,
    ACTIONS(16464), 1,
      anon_sym_LBRACK,
    ACTIONS(18279), 1,
      anon_sym_LPAREN,
    STATE(11564), 1,
      sym_constructor,
    STATE(12335), 1,
      sym_qualified_type,
    STATE(17413), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16458), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12403), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [420817] = 4,
    ACTIONS(11901), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [420853] = 13,
    ACTIONS(8630), 1,
      sym__integer_literal,
    ACTIONS(8640), 1,
      sym__conid,
    ACTIONS(8642), 1,
      anon_sym_LBRACK,
    ACTIONS(18281), 1,
      anon_sym_LPAREN,
    STATE(7867), 1,
      sym_constructor,
    STATE(7943), 1,
      sym_qualified_type,
    STATE(17086), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8628), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8632), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8031), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8034), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [420907] = 13,
    ACTIONS(7191), 1,
      sym__integer_literal,
    ACTIONS(7202), 1,
      anon_sym_LBRACK,
    ACTIONS(8660), 1,
      sym__conid,
    ACTIONS(18283), 1,
      anon_sym_LPAREN,
    STATE(6423), 1,
      sym_constructor,
    STATE(6874), 1,
      sym_qualified_type,
    STATE(17409), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7189), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7193), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6938), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6961), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [420961] = 13,
    ACTIONS(4459), 1,
      sym__integer_literal,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(18285), 1,
      anon_sym_LPAREN,
    STATE(10368), 1,
      sym_constructor,
    STATE(10523), 1,
      sym_qualified_type,
    STATE(16807), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4461), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16076), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10547), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10574), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421015] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2466), 1,
      sym__colon2,
    STATE(13512), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18287), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1962), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [421071] = 3,
    ACTIONS(15605), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [421105] = 4,
    ACTIONS(18289), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [421141] = 4,
    ACTIONS(12114), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [421177] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1817), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [421233] = 13,
    ACTIONS(7311), 1,
      sym__integer_literal,
    ACTIONS(7322), 1,
      anon_sym_LBRACK,
    ACTIONS(7911), 1,
      sym__conid,
    ACTIONS(18291), 1,
      anon_sym_LPAREN,
    STATE(6438), 1,
      sym_constructor,
    STATE(6929), 1,
      sym_qualified_type,
    STATE(17378), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(7309), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7313), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7018), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7007), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421287] = 13,
    ACTIONS(1097), 1,
      sym__integer_literal,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(16096), 1,
      anon_sym_LBRACK,
    ACTIONS(18293), 1,
      anon_sym_LPAREN,
    STATE(4641), 1,
      sym_constructor,
    STATE(5005), 1,
      sym_qualified_type,
    STATE(16690), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1099), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16090), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5047), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5057), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421341] = 4,
    ACTIONS(18295), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [421377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym__,
    ACTIONS(15549), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_u27e6,
  [421411] = 3,
    ACTIONS(15577), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [421445] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1814), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [421501] = 13,
    ACTIONS(8764), 1,
      sym__integer_literal,
    ACTIONS(8774), 1,
      sym__conid,
    ACTIONS(8776), 1,
      anon_sym_LBRACK,
    ACTIONS(18297), 1,
      anon_sym_LPAREN,
    STATE(6939), 1,
      sym_constructor,
    STATE(7098), 1,
      sym_qualified_type,
    STATE(17346), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8762), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8766), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7042), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7033), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421555] = 4,
    ACTIONS(18299), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [421591] = 3,
    ACTIONS(15543), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [421625] = 13,
    ACTIONS(3095), 1,
      sym__integer_literal,
    ACTIONS(4491), 1,
      sym__conid,
    ACTIONS(15794), 1,
      anon_sym_LBRACK,
    ACTIONS(18301), 1,
      anon_sym_LPAREN,
    STATE(5484), 1,
      sym_constructor,
    STATE(6182), 1,
      sym_qualified_type,
    STATE(17001), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3097), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6183), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6152), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421679] = 13,
    ACTIONS(1387), 1,
      sym__integer_literal,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(18303), 1,
      anon_sym_LPAREN,
    STATE(5226), 1,
      sym_constructor,
    STATE(5418), 1,
      sym_qualified_type,
    STATE(16935), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1389), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15850), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5419), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5412), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421733] = 13,
    ACTIONS(8255), 1,
      sym__integer_literal,
    ACTIONS(8265), 1,
      sym__conid,
    ACTIONS(8267), 1,
      anon_sym_LBRACK,
    ACTIONS(18305), 1,
      anon_sym_LPAREN,
    STATE(7047), 1,
      sym_constructor,
    STATE(7298), 1,
      sym_qualified_type,
    STATE(17310), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8253), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8257), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7272), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7271), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421787] = 4,
    ACTIONS(18307), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [421823] = 13,
    ACTIONS(8404), 1,
      sym__integer_literal,
    ACTIONS(8414), 1,
      sym__conid,
    ACTIONS(8416), 1,
      anon_sym_LBRACK,
    ACTIONS(18309), 1,
      anon_sym_LPAREN,
    STATE(7040), 1,
      sym_constructor,
    STATE(7284), 1,
      sym_qualified_type,
    STATE(17287), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(8402), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(8406), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7260), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7259), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [421877] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1788), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [421933] = 3,
    ACTIONS(15573), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [421967] = 4,
    ACTIONS(18311), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422003] = 3,
    ACTIONS(15593), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [422037] = 4,
    ACTIONS(18313), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422073] = 13,
    ACTIONS(5648), 1,
      sym__integer_literal,
    ACTIONS(5659), 1,
      anon_sym_LBRACK,
    ACTIONS(7891), 1,
      sym__conid,
    ACTIONS(18315), 1,
      anon_sym_LPAREN,
    STATE(4471), 1,
      sym_constructor,
    STATE(4555), 1,
      sym_qualified_type,
    STATE(17101), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5646), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5650), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4607), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4704), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [422127] = 13,
    ACTIONS(4829), 1,
      sym__integer_literal,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(16208), 1,
      anon_sym_LBRACK,
    ACTIONS(18317), 1,
      anon_sym_LPAREN,
    STATE(11322), 1,
      sym_constructor,
    STATE(11799), 1,
      sym_qualified_type,
    STATE(17167), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4831), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16202), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11869), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11873), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [422181] = 4,
    ACTIONS(12003), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422217] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1765), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [422273] = 4,
    ACTIONS(18319), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422309] = 4,
    ACTIONS(18321), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422345] = 13,
    ACTIONS(3567), 1,
      sym__integer_literal,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(16040), 1,
      anon_sym_LBRACK,
    ACTIONS(18323), 1,
      anon_sym_LPAREN,
    STATE(10634), 1,
      sym_constructor,
    STATE(10755), 1,
      sym_qualified_type,
    STATE(16927), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16034), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10693), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10691), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [422399] = 4,
    ACTIONS(12381), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422435] = 4,
    ACTIONS(18325), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422471] = 13,
    ACTIONS(13938), 1,
      sym__integer_literal,
    ACTIONS(13946), 1,
      sym__conid,
    ACTIONS(13948), 1,
      anon_sym_LBRACK,
    ACTIONS(18327), 1,
      anon_sym_LPAREN,
    STATE(9230), 1,
      sym_constructor,
    STATE(9416), 1,
      sym_qualified_type,
    STATE(17205), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13936), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13940), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9498), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9504), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [422525] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1802), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [422581] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1777), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [422637] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1787), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [422693] = 4,
    ACTIONS(18329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422729] = 4,
    ACTIONS(12213), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422765] = 4,
    ACTIONS(11905), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422801] = 3,
    ACTIONS(15508), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [422835] = 4,
    ACTIONS(12211), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422871] = 13,
    ACTIONS(16775), 1,
      sym__integer_literal,
    ACTIONS(16783), 1,
      sym__conid,
    ACTIONS(16785), 1,
      anon_sym_LBRACK,
    ACTIONS(18331), 1,
      anon_sym_LPAREN,
    STATE(15179), 1,
      sym_constructor,
    STATE(16028), 1,
      sym_qualified_type,
    STATE(17284), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(16773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(16777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16241), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(16216), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [422925] = 4,
    ACTIONS(12241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422961] = 4,
    ACTIONS(11958), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [422997] = 13,
    ACTIONS(5455), 1,
      sym__integer_literal,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(18333), 1,
      anon_sym_LPAREN,
    STATE(7789), 1,
      sym_constructor,
    STATE(7978), 1,
      sym_qualified_type,
    STATE(16539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(5453), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5457), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4319), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4298), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423051] = 4,
    ACTIONS(11909), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423087] = 4,
    ACTIONS(12286), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423123] = 4,
    ACTIONS(11705), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423159] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2429), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(17207), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17403), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1892), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [423215] = 4,
    ACTIONS(18337), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423251] = 4,
    ACTIONS(12383), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423287] = 4,
    ACTIONS(18339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423323] = 4,
    ACTIONS(12298), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423359] = 4,
    ACTIONS(18341), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423395] = 13,
    ACTIONS(13456), 1,
      sym__integer_literal,
    ACTIONS(13464), 1,
      sym__conid,
    ACTIONS(13466), 1,
      anon_sym_LBRACK,
    ACTIONS(18343), 1,
      anon_sym_LPAREN,
    STATE(8884), 1,
      sym_constructor,
    STATE(9335), 1,
      sym_qualified_type,
    STATE(17223), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13454), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13458), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9094), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9054), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423449] = 13,
    ACTIONS(659), 1,
      sym__integer_literal,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(18345), 1,
      anon_sym_LPAREN,
    STATE(3725), 1,
      sym_constructor,
    STATE(3760), 1,
      sym_qualified_type,
    STATE(16976), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(661), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15924), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3795), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(3763), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423503] = 4,
    ACTIONS(12237), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423539] = 13,
    ACTIONS(13195), 1,
      sym__integer_literal,
    ACTIONS(15303), 1,
      sym__conid,
    ACTIONS(16394), 1,
      anon_sym_LBRACK,
    ACTIONS(18347), 1,
      anon_sym_LPAREN,
    STATE(13623), 1,
      sym_constructor,
    STATE(13943), 1,
      sym_qualified_type,
    STATE(16786), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(13197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16388), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14114), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423593] = 4,
    ACTIONS(18349), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423629] = 4,
    ACTIONS(18351), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423665] = 13,
    ACTIONS(14932), 1,
      sym__integer_literal,
    ACTIONS(14940), 1,
      sym__conid,
    ACTIONS(14942), 1,
      anon_sym_LBRACK,
    ACTIONS(18353), 1,
      anon_sym_LPAREN,
    STATE(9383), 1,
      sym_constructor,
    STATE(9822), 1,
      sym_qualified_type,
    STATE(17253), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14930), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14934), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9795), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9791), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423719] = 13,
    ACTIONS(14162), 1,
      sym__integer_literal,
    ACTIONS(14170), 1,
      sym__conid,
    ACTIONS(14172), 1,
      anon_sym_LBRACK,
    ACTIONS(18355), 1,
      anon_sym_LPAREN,
    STATE(9246), 1,
      sym_constructor,
    STATE(9418), 1,
      sym_qualified_type,
    STATE(17266), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(14160), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14164), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9354), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9360), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423773] = 3,
    ACTIONS(15569), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [423807] = 13,
    ACTIONS(10814), 1,
      sym__integer_literal,
    ACTIONS(13012), 1,
      sym__conid,
    ACTIONS(16110), 1,
      anon_sym_LBRACK,
    ACTIONS(18357), 1,
      anon_sym_LPAREN,
    STATE(8487), 1,
      sym_constructor,
    STATE(8793), 1,
      sym_qualified_type,
    STATE(16808), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10816), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(16104), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8792), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8813), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423861] = 13,
    ACTIONS(243), 1,
      sym__integer_literal,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(15712), 1,
      anon_sym_LBRACK,
    ACTIONS(18359), 1,
      anon_sym_LPAREN,
    STATE(4092), 1,
      sym_constructor,
    STATE(4199), 1,
      sym_qualified_type,
    STATE(17456), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(245), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(15706), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4171), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4190), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [423915] = 4,
    ACTIONS(18361), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [423951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18365), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(18363), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [423984] = 4,
    ACTIONS(18367), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424019] = 4,
    ACTIONS(18369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424054] = 4,
    ACTIONS(14851), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424089] = 4,
    ACTIONS(18371), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424124] = 4,
    ACTIONS(18373), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424159] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 20,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [424192] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 20,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_AT2,
  [424225] = 4,
    ACTIONS(18375), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424260] = 4,
    ACTIONS(18377), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424295] = 4,
    ACTIONS(14807), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424330] = 4,
    ACTIONS(18379), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424365] = 4,
    ACTIONS(14865), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424400] = 4,
    ACTIONS(14630), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424435] = 4,
    ACTIONS(14857), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424470] = 4,
    ACTIONS(14809), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424505] = 4,
    ACTIONS(14869), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424540] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 20,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [424573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17621), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17623), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424606] = 4,
    ACTIONS(18381), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424641] = 4,
    ACTIONS(14875), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424676] = 4,
    ACTIONS(14555), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424711] = 4,
    ACTIONS(14729), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424746] = 4,
    ACTIONS(18383), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424781] = 4,
    ACTIONS(14733), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424816] = 4,
    ACTIONS(14795), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424851] = 4,
    ACTIONS(14799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17599), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424919] = 4,
    ACTIONS(18385), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424954] = 4,
    ACTIONS(14793), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [424989] = 4,
    ACTIONS(14727), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425024] = 4,
    ACTIONS(14683), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425059] = 4,
    ACTIONS(14735), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15622), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15624), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425127] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15547), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15549), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425160] = 4,
    ACTIONS(14960), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15626), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15628), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425228] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18389), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2641), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 15,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [425269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15581), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15583), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425302] = 4,
    ACTIONS(14757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425337] = 4,
    ACTIONS(14877), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425372] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [425407] = 4,
    ACTIONS(14759), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425442] = 4,
    ACTIONS(14926), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425477] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15611), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15613), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15585), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15587), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425543] = 4,
    ACTIONS(14879), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425578] = 4,
    ACTIONS(18395), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15615), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15617), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17473), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17475), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15630), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15632), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425712] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15634), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15636), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425745] = 4,
    ACTIONS(14561), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425780] = 4,
    ACTIONS(18397), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18401), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(18399), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [425848] = 4,
    ACTIONS(18403), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425883] = 4,
    ACTIONS(18405), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425918] = 4,
    ACTIONS(18407), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425953] = 4,
    ACTIONS(14480), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [425988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15605), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15607), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426021] = 4,
    ACTIONS(14853), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426056] = 4,
    ACTIONS(14845), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15530), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15515), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17469), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17471), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426157] = 4,
    ACTIONS(14472), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426192] = 4,
    ACTIONS(14771), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426227] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(18409), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
    STATE(3590), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [426276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17493), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426309] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2502), 1,
      sym__colon2,
    STATE(13566), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18411), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(17403), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1976), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [426364] = 4,
    ACTIONS(14962), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15539), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15541), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426432] = 4,
    ACTIONS(14922), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426467] = 4,
    ACTIONS(18413), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426502] = 4,
    ACTIONS(14867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15593), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15595), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426570] = 4,
    ACTIONS(14924), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426605] = 4,
    ACTIONS(14523), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15577), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15579), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17523), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17525), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426706] = 4,
    ACTIONS(14855), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426741] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2434), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(13679), 1,
      sym__type_annotation,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18415), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(17403), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1922), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [426796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17553), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426829] = 4,
    ACTIONS(18417), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17541), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17543), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426897] = 4,
    ACTIONS(18419), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426932] = 4,
    ACTIONS(14474), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [426967] = 4,
    ACTIONS(14476), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15543), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15545), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17647), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17649), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427068] = 4,
    ACTIONS(18421), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427103] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [427138] = 4,
    ACTIONS(18423), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427173] = 4,
    ACTIONS(14765), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427208] = 4,
    ACTIONS(14717), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427243] = 4,
    ACTIONS(15033), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427278] = 4,
    ACTIONS(18425), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427313] = 4,
    ACTIONS(14767), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427348] = 4,
    ACTIONS(14737), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427383] = 4,
    ACTIONS(18427), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15563), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15565), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427451] = 4,
    ACTIONS(18429), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427519] = 4,
    ACTIONS(14470), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17533), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17535), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427587] = 4,
    ACTIONS(14797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427622] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [427657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17545), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17547), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15575), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427723] = 4,
    ACTIONS(15023), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427758] = 4,
    ACTIONS(14573), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427793] = 4,
    ACTIONS(14725), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427828] = 4,
    ACTIONS(14723), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427863] = 4,
    ACTIONS(18431), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [427898] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2453), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(18685), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(17403), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1976), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [427953] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [427988] = 4,
    ACTIONS(14972), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16983), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17579), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16994), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428089] = 4,
    ACTIONS(15047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428124] = 4,
    ACTIONS(14791), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428159] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(18433), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
    STATE(3547), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [428208] = 4,
    ACTIONS(14575), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428243] = 4,
    ACTIONS(18435), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428278] = 4,
    ACTIONS(18437), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428313] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15468), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15474), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [428346] = 4,
    ACTIONS(18439), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15448), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428414] = 4,
    ACTIONS(18441), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428449] = 4,
    ACTIONS(14715), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428484] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [428519] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15569), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15571), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428552] = 4,
    ACTIONS(18443), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428587] = 4,
    ACTIONS(14529), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428622] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [428657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15551), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15553), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428690] = 4,
    ACTIONS(14863), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428725] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [428760] = 4,
    ACTIONS(15051), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428795] = 4,
    ACTIONS(14713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428830] = 4,
    ACTIONS(14873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428865] = 4,
    ACTIONS(14769), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428900] = 4,
    ACTIONS(14773), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15508), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15510), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [428968] = 4,
    ACTIONS(14801), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429003] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15492), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15494), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429036] = 4,
    ACTIONS(18445), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429071] = 4,
    ACTIONS(14482), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15643), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15645), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429139] = 4,
    ACTIONS(18447), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429174] = 4,
    ACTIONS(18449), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429209] = 4,
    ACTIONS(14777), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429244] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2477), 1,
      sym__colon2,
    STATE(13597), 1,
      sym__type_annotation,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18451), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(17403), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1986), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [429299] = 4,
    ACTIONS(18453), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429334] = 4,
    ACTIONS(18455), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429369] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [429404] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15597), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15599), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429437] = 4,
    ACTIONS(14871), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429472] = 4,
    ACTIONS(18457), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429507] = 4,
    ACTIONS(14954), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17655), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17657), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429575] = 4,
    ACTIONS(14881), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429610] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [429645] = 4,
    ACTIONS(14956), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429680] = 4,
    ACTIONS(14958), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429715] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2506), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(17845), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(17403), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1922), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [429770] = 4,
    ACTIONS(15013), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429805] = 4,
    ACTIONS(14685), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17011), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429873] = 4,
    ACTIONS(15049), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429908] = 4,
    ACTIONS(15045), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17507), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16985), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [429976] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [430011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15567), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14273), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430044] = 4,
    ACTIONS(14964), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430079] = 4,
    ACTIONS(15043), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430114] = 4,
    ACTIONS(14687), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430149] = 4,
    ACTIONS(18461), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430184] = 4,
    ACTIONS(14747), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430219] = 4,
    ACTIONS(18463), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15601), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15603), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15654), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15656), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18465), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(18467), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [430353] = 4,
    ACTIONS(18469), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430388] = 4,
    ACTIONS(14464), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430423] = 4,
    ACTIONS(14785), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430458] = 4,
    ACTIONS(18471), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430493] = 4,
    ACTIONS(14783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15609), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14070), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430561] = 4,
    ACTIONS(14739), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430596] = 4,
    ACTIONS(18473), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430631] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 20,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_AT2,
  [430664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15504), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15506), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430697] = 4,
    ACTIONS(18475), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17443), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17445), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430765] = 4,
    ACTIONS(18477), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430800] = 4,
    ACTIONS(15015), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430835] = 4,
    ACTIONS(14703), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430870] = 4,
    ACTIONS(15025), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430905] = 4,
    ACTIONS(15017), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15559), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15561), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [430973] = 4,
    ACTIONS(18479), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15589), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15591), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431041] = 4,
    ACTIONS(14701), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431076] = 4,
    ACTIONS(14731), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431111] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18483), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(18481), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [431144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15500), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15502), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431177] = 4,
    ACTIONS(14775), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431212] = 4,
    ACTIONS(14779), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17625), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17627), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17635), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17637), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431313] = 4,
    ACTIONS(18485), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431348] = 4,
    ACTIONS(14699), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431383] = 4,
    ACTIONS(14697), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431418] = 4,
    ACTIONS(14781), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431453] = 4,
    ACTIONS(15027), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431488] = 4,
    ACTIONS(18487), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431523] = 4,
    ACTIONS(18489), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15496), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [431558] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431590] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431622] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431654] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431686] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1794), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [431740] = 4,
    ACTIONS(18491), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [431774] = 4,
    ACTIONS(18493), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [431808] = 4,
    ACTIONS(18495), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [431842] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431874] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431906] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [431938] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1812), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [431992] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432024] = 4,
    ACTIONS(18497), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [432058] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1786), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [432112] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1791), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [432166] = 4,
    ACTIONS(18499), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [432200] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1799), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [432254] = 3,
    ACTIONS(16975), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16977), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_u27e6,
  [432286] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432318] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432350] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1798), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [432404] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432436] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1795), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [432490] = 4,
    ACTIONS(18501), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [432524] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432556] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432588] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432620] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432652] = 6,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18134), 1,
      sym_guards,
    STATE(10526), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432690] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432722] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432754] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17669), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17671), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [432786] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432818] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432850] = 5,
    ACTIONS(18510), 1,
      anon_sym_SEMI,
    STATE(10487), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(15647), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15652), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [432886] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432918] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432950] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [432982] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(18517), 1,
      anon_sym_LBRACE,
    ACTIONS(18519), 1,
      sym__layout_start,
    STATE(10773), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18521), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(18523), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [433052] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1789), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433106] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1803), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433160] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433192] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433224] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1807), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433278] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433310] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1810), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433364] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433396] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433428] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433460] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1796), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433514] = 3,
    ACTIONS(18527), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18525), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [433546] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433580] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433612] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433644] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433676] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18531), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(18533), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [433740] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18535), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2724), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 14,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433780] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1784), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433834] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1780), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [433888] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433920] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433952] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [433984] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434016] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434048] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1776), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434102] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434134] = 4,
    ACTIONS(18537), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [434168] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434200] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434232] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2508), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(20817), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(18539), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1840), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434286] = 4,
    ACTIONS(18541), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [434320] = 6,
    ACTIONS(18545), 1,
      anon_sym_DASH,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18134), 1,
      sym_guards,
    STATE(10526), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434358] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(18519), 1,
      sym__layout_start,
    ACTIONS(18550), 1,
      anon_sym_LBRACE,
    STATE(10671), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434396] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1771), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434450] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434482] = 4,
    ACTIONS(18553), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [434516] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434548] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434580] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434612] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1797), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434666] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434698] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434730] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434762] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1768), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434816] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1806), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434870] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1773), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [434924] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434956] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [434988] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 20,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435020] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435052] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1779), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [435106] = 4,
    ACTIONS(18559), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [435140] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18365), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_forall,
    ACTIONS(18363), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u2200,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [435204] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435236] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435268] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435300] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18527), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_forall,
    ACTIONS(18525), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_u2200,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [435332] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435364] = 4,
    ACTIONS(18561), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [435398] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435430] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1808), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [435484] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435516] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(3577), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [435580] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435612] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1767), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [435666] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435698] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435730] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1782), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [435784] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435816] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1774), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [435870] = 4,
    ACTIONS(18563), 1,
      anon_sym_RBRACE,
    ACTIONS(15496), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [435904] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1809), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [435958] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [435990] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1805), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17573), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(17575), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_u27e6,
  [436076] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2483), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14118), 1,
      sym__type_annotation,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(18565), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1840), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436130] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1785), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436184] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436216] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436248] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1769), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436302] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436334] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436366] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1790), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436420] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1772), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436474] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(2476), 1,
      sym__colon2,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15078), 1,
      sym__type_annotation,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(17403), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1792), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [436528] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436560] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    STATE(18134), 1,
      sym_guards,
    STATE(10526), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15339), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(15341), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [436629] = 3,
    ACTIONS(15778), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436660] = 4,
    ACTIONS(18567), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436693] = 3,
    ACTIONS(15774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436724] = 3,
    ACTIONS(15726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436755] = 3,
    ACTIONS(15830), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436786] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436817] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436848] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436879] = 4,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 17,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [436912] = 3,
    ACTIONS(15814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436943] = 3,
    ACTIONS(15818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [436974] = 3,
    ACTIONS(15876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437005] = 3,
    ACTIONS(15670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437036] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437067] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437098] = 3,
    ACTIONS(18557), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 19,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [437129] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437162] = 3,
    ACTIONS(15898), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437193] = 3,
    ACTIONS(15782), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437224] = 3,
    ACTIONS(15722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437255] = 3,
    ACTIONS(15756), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437286] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(18569), 1,
      anon_sym_LBRACE,
    ACTIONS(18572), 1,
      sym__layout_start,
    STATE(10696), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437323] = 3,
    ACTIONS(15718), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437354] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437385] = 3,
    ACTIONS(15894), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437416] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437447] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437478] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(18572), 1,
      sym__layout_start,
    ACTIONS(18574), 1,
      anon_sym_LBRACE,
    STATE(10869), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437515] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437546] = 3,
    ACTIONS(15696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437577] = 3,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437608] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437639] = 3,
    ACTIONS(15822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437670] = 3,
    ACTIONS(15692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437701] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437732] = 3,
    ACTIONS(15726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437762] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437792] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437822] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [437854] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437884] = 3,
    ACTIONS(15670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437914] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18576), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2634), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [437952] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [437982] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438012] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [438044] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438074] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438104] = 3,
    ACTIONS(17697), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17699), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [438134] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438164] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [438196] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18578), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2614), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [438234] = 3,
    ACTIONS(15692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438264] = 3,
    ACTIONS(18582), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18580), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [438294] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438324] = 3,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438354] = 3,
    ACTIONS(15696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438384] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438414] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438444] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(18588), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438476] = 3,
    ACTIONS(15718), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438506] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438536] = 3,
    ACTIONS(15722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438566] = 3,
    ACTIONS(15756), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438596] = 3,
    ACTIONS(18592), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18590), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [438626] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438656] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438686] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438716] = 3,
    ACTIONS(15774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438746] = 3,
    ACTIONS(18483), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18481), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [438776] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438806] = 3,
    ACTIONS(15778), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438836] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438866] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18594), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    STATE(1959), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [438912] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438942] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [438972] = 3,
    ACTIONS(17669), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17671), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [439002] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439032] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17224), 1,
      anon_sym_BQUOTE,
    ACTIONS(17230), 1,
      sym__consym,
    ACTIONS(18596), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(17144), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3546), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [439078] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 17,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_AT2,
  [439108] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439138] = 3,
    ACTIONS(15782), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439168] = 3,
    ACTIONS(15814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439198] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439228] = 3,
    ACTIONS(15818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439258] = 3,
    ACTIONS(15822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439288] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439318] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439348] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17407), 1,
      anon_sym_DASH,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18598), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    STATE(1959), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [439394] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439424] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [439456] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 17,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [439486] = 3,
    ACTIONS(18401), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18399), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [439516] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439546] = 3,
    ACTIONS(15894), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439576] = 3,
    ACTIONS(15876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439606] = 4,
    ACTIONS(18600), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439638] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439668] = 3,
    ACTIONS(18604), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18602), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [439698] = 3,
    ACTIONS(18608), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18606), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u27e6,
  [439728] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [439760] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439790] = 3,
    ACTIONS(15830), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439820] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18610), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2668), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 13,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [439856] = 3,
    ACTIONS(15898), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439886] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [439917] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [439946] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [439975] = 4,
    ACTIONS(17150), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [440006] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440035] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440064] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [440095] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440124] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440153] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440182] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 16,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [440211] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(18616), 1,
      anon_sym_LBRACE,
    ACTIONS(18618), 1,
      sym__layout_start,
    STATE(11261), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [440246] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [440277] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440306] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440335] = 3,
    ACTIONS(18622), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440364] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18624), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1976), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [440409] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440438] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18630), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2697), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [440475] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440504] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440533] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18632), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2646), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440570] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(18618), 1,
      sym__layout_start,
    ACTIONS(18634), 1,
      anon_sym_LBRACE,
    STATE(10924), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [440605] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440634] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    STATE(17875), 1,
      sym_guards,
    STATE(10734), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440669] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18637), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2651), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440706] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440735] = 3,
    ACTIONS(18557), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [440764] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440793] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440822] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18624), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1986), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [440867] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440896] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18643), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2625), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [440933] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [440962] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [440991] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18649), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2750), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441028] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18651), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2663), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441065] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441094] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441123] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441152] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441181] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441210] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441239] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441268] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441297] = 6,
    ACTIONS(18545), 1,
      anon_sym_DASH,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(17875), 1,
      sym_guards,
    STATE(10734), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441332] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 17,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [441361] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441390] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441419] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441448] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [441479] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441508] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441537] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441566] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441595] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441624] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [441655] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441684] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441713] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441742] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [441773] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441802] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441831] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441860] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441889] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441918] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [441947] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [441976] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442005] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442034] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442063] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(18681), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442094] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442123] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442152] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442181] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442210] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442239] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442268] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442297] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442326] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442355] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442384] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442413] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442442] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442471] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442500] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442529] = 6,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(17875), 1,
      sym_guards,
    STATE(10734), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442564] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442593] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442622] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442651] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [442680] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442709] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [442738] = 6,
    ACTIONS(18545), 1,
      anon_sym_DASH,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18016), 1,
      sym_guards,
    STATE(10783), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 12,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [442772] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17645), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3602), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [442814] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [442842] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [442870] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [442898] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 16,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [442926] = 3,
    ACTIONS(15782), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [442954] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [442984] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443012] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443040] = 3,
    ACTIONS(15778), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443068] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443096] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443124] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [443152] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 14,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [443182] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443210] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443238] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443266] = 4,
    ACTIONS(18707), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443296] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [443326] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443354] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443382] = 3,
    ACTIONS(15718), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443410] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443438] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443466] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443494] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443522] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443550] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443578] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(18709), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3736), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [443620] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [443648] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18711), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2707), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [443684] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [443714] = 3,
    ACTIONS(15898), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443742] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17154), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3562), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [443784] = 3,
    ACTIONS(15774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443812] = 3,
    ACTIONS(15818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443840] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [443868] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [443896] = 3,
    ACTIONS(15756), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [443924] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 14,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [443954] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18713), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2643), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443990] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444018] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444046] = 5,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(15463), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(15456), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [444078] = 3,
    ACTIONS(15726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444106] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444134] = 3,
    ACTIONS(15722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444162] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444190] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(18715), 1,
      anon_sym_LBRACE,
    ACTIONS(18718), 1,
      sym__layout_start,
    STATE(11277), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [444224] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444252] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444280] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444308] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444336] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444364] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444392] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 16,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [444420] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(18720), 1,
      anon_sym_LBRACE,
    ACTIONS(18723), 1,
      sym__layout_start,
    STATE(11238), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [444454] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [444484] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444512] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444540] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444568] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [444596] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444624] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444652] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444680] = 3,
    ACTIONS(18557), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [444708] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17821), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3600), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [444750] = 3,
    ACTIONS(15670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444778] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(18723), 1,
      sym__layout_start,
    ACTIONS(18725), 1,
      anon_sym_LBRACE,
    STATE(12110), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [444812] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [444840] = 6,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16971), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15448), 7,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [444874] = 3,
    ACTIONS(15339), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__dot,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [444902] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [444932] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18727), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2712), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [444968] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [444998] = 3,
    ACTIONS(15822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445026] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17843), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3580), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [445068] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445096] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 14,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [445126] = 3,
    ACTIONS(15692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445154] = 3,
    ACTIONS(15696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445182] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18729), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2752), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [445218] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445246] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 16,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [445274] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445302] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [445330] = 3,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445358] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [445386] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18731), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2745), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [445422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 17,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_via,
      anon_sym_deriving,
  [445448] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445476] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445504] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [445532] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [445560] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(18624), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [445604] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17875), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3615), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [445646] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445674] = 3,
    ACTIONS(15894), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445702] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445730] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445758] = 3,
    ACTIONS(15830), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [445786] = 4,
    ACTIONS(17150), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [445816] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17755), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3575), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [445858] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(18718), 1,
      sym__layout_start,
    ACTIONS(18733), 1,
      anon_sym_LBRACE,
    STATE(11782), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [445892] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17399), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3567), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [445934] = 3,
    ACTIONS(15547), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 14,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_AT2,
  [445962] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18735), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2687), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [445998] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446026] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [446056] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446084] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18737), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2696), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 10,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [446120] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446148] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17411), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3607), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [446190] = 3,
    ACTIONS(15876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446218] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 16,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [446246] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17841), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3577), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [446288] = 6,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18016), 1,
      sym_guards,
    STATE(10783), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 12,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [446322] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446350] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 16,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [446378] = 3,
    ACTIONS(15814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446406] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446434] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [446462] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [446490] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446518] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446546] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [446574] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17148), 1,
      anon_sym_SQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(17847), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3584), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [446616] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18739), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446659] = 3,
    ACTIONS(15822), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [446686] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18741), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446729] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18743), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446772] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18745), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446815] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18747), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446858] = 3,
    ACTIONS(15626), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [446885] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [446912] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18749), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446955] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18751), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [446998] = 4,
    ACTIONS(16990), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(16999), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [447027] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18753), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447070] = 3,
    ACTIONS(15718), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447097] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [447124] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18755), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447167] = 4,
    ACTIONS(15662), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(16987), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [447196] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18757), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447239] = 4,
    ACTIONS(16990), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(16996), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [447268] = 5,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(15463), 2,
      sym__immediate_dot,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(16927), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [447299] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(19395), 1,
      sym_guards,
    STATE(10991), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [447330] = 3,
    ACTIONS(15601), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447357] = 3,
    ACTIONS(15654), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447384] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18759), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447427] = 3,
    ACTIONS(15615), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447454] = 6,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16971), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [447487] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [447514] = 3,
    ACTIONS(15492), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447541] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18761), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447584] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18763), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447627] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18765), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447670] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18767), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447713] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18769), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447756] = 3,
    ACTIONS(15666), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447783] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18771), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447826] = 3,
    ACTIONS(15630), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447853] = 3,
    ACTIONS(15666), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447880] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [447907] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18773), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [447950] = 3,
    ACTIONS(15609), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [447977] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18775), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448020] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18777), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448063] = 3,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [448090] = 3,
    ACTIONS(15611), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448117] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18779), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2741), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 9,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448152] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18781), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448195] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18783), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448238] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [448265] = 3,
    ACTIONS(15500), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448292] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [448319] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [448348] = 3,
    ACTIONS(15504), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448375] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [448402] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18785), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448445] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [448472] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18787), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448515] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18789), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448558] = 3,
    ACTIONS(15670), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448585] = 3,
    ACTIONS(15674), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448612] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [448639] = 3,
    ACTIONS(15622), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448666] = 3,
    ACTIONS(15674), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448693] = 3,
    ACTIONS(15634), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448720] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18791), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448763] = 3,
    ACTIONS(15692), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448790] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18793), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448833] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18795), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [448876] = 3,
    ACTIONS(15581), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448903] = 3,
    ACTIONS(15696), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448930] = 3,
    ACTIONS(15700), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448957] = 3,
    ACTIONS(15830), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [448984] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [449011] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18797), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449054] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18799), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449097] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18801), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449140] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18803), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449183] = 3,
    ACTIONS(15700), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449210] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18805), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449253] = 3,
    ACTIONS(15722), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449280] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18807), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449323] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18809), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449366] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(19395), 1,
      sym_guards,
    STATE(10991), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [449397] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [449424] = 3,
    ACTIONS(15726), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449451] = 3,
    ACTIONS(15756), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449478] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18811), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449521] = 3,
    ACTIONS(15774), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449548] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18813), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449591] = 3,
    ACTIONS(15778), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449618] = 3,
    ACTIONS(15585), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449645] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18815), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449688] = 3,
    ACTIONS(15658), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449715] = 3,
    ACTIONS(15597), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449742] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [449769] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18817), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449812] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [449841] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18819), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449884] = 3,
    ACTIONS(15403), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [449911] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18821), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449954] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18823), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [449997] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18825), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450040] = 3,
    ACTIONS(15593), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450067] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [450096] = 3,
    ACTIONS(15577), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450123] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18827), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450166] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18829), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450209] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18831), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450252] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [450281] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [450308] = 3,
    ACTIONS(15658), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450335] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [450364] = 3,
    ACTIONS(15782), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450391] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18833), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450434] = 3,
    ACTIONS(15662), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450461] = 3,
    ACTIONS(15589), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450488] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18835), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450531] = 5,
    ACTIONS(18837), 1,
      anon_sym_LBRACE,
    ACTIONS(18840), 1,
      sym__layout_start,
    STATE(11669), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [450562] = 3,
    ACTIONS(15814), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450589] = 6,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(16930), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15448), 7,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [450622] = 3,
    ACTIONS(15818), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450649] = 4,
    ACTIONS(15530), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(15523), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [450678] = 3,
    ACTIONS(15563), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450705] = 3,
    ACTIONS(15479), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450732] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18842), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450775] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [450802] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [450831] = 4,
    ACTIONS(18844), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [450860] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18846), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450903] = 3,
    ACTIONS(15826), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [450930] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18848), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [450973] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16994), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16992), 7,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [451004] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18850), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451047] = 3,
    ACTIONS(15826), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [451074] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18852), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451117] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18854), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451160] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18856), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451203] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18858), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451246] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18860), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451289] = 5,
    ACTIONS(10390), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16992), 7,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [451320] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [451347] = 3,
    ACTIONS(15573), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [451374] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18862), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451417] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18864), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451460] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18866), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451503] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18868), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451546] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [451573] = 3,
    ACTIONS(15898), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [451600] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(19395), 1,
      sym_guards,
    STATE(10991), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [451631] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [451658] = 3,
    ACTIONS(15876), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [451685] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18870), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451728] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18872), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451771] = 3,
    ACTIONS(15543), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [451798] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18874), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451841] = 3,
    ACTIONS(15894), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [451868] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18876), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2722), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 9,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [451903] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18878), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [451946] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [451975] = 3,
    ACTIONS(15463), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [452002] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18880), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452045] = 3,
    ACTIONS(15894), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [452072] = 4,
    ACTIONS(18882), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [452101] = 3,
    ACTIONS(15876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [452128] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18884), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452171] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18886), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452214] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [452243] = 3,
    ACTIONS(15898), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [452270] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [452297] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [452324] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [452351] = 15,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(18890), 1,
      anon_sym_LPAREN,
    ACTIONS(18892), 1,
      anon_sym_RPAREN,
    ACTIONS(18896), 1,
      anon_sym_module,
    ACTIONS(18898), 1,
      sym_comma,
    STATE(15065), 1,
      sym_namespace,
    STATE(15110), 1,
      aux_sym__qualifying_module,
    STATE(15933), 1,
      sym_constructor,
    STATE(17824), 1,
      sym_qualified_type,
    STATE(18851), 1,
      sym_export,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(20935), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452402] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18900), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452445] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18902), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452488] = 3,
    ACTIONS(15830), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [452515] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [452542] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [452569] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18904), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452612] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18906), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452655] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18908), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452698] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18910), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452741] = 3,
    ACTIONS(15567), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [452768] = 3,
    ACTIONS(15569), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [452795] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [452822] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [452849] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18912), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452892] = 5,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16985), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15664), 7,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [452923] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18914), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [452966] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18916), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453009] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [453036] = 5,
    ACTIONS(18840), 1,
      sym__layout_start,
    ACTIONS(18918), 1,
      anon_sym_LBRACE,
    STATE(12595), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [453067] = 3,
    ACTIONS(15530), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [453094] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18920), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453137] = 3,
    ACTIONS(15822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453164] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18922), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453207] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18924), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453250] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18926), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453293] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18928), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453336] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [453365] = 3,
    ACTIONS(15818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453392] = 3,
    ACTIONS(15508), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [453419] = 5,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16983), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15515), 7,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [453450] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [453479] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 15,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [453506] = 3,
    ACTIONS(15814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453533] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [453560] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18930), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453603] = 3,
    ACTIONS(15782), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453630] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453657] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453684] = 3,
    ACTIONS(15778), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453711] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18932), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453754] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [453783] = 3,
    ACTIONS(15774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [453810] = 3,
    ACTIONS(15605), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [453837] = 3,
    ACTIONS(15559), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [453864] = 3,
    ACTIONS(15539), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [453891] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [453918] = 3,
    ACTIONS(15643), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [453945] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18934), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [453988] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(18936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454017] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454044] = 3,
    ACTIONS(15555), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [454071] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18938), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454114] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18940), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454157] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18942), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454200] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18944), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454243] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18946), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2682), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [454278] = 11,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    ACTIONS(18950), 1,
      sym__tyconsym,
    STATE(13394), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22604), 1,
      sym__modid,
    STATE(22382), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(22414), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [454321] = 3,
    ACTIONS(15551), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [454348] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [454377] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18952), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454420] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454447] = 3,
    ACTIONS(15756), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454474] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18954), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2591), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [454509] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18956), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454552] = 3,
    ACTIONS(15726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454579] = 3,
    ACTIONS(15722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454606] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454633] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454660] = 3,
    ACTIONS(15670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454687] = 3,
    ACTIONS(15718), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454714] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454741] = 11,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17409), 1,
      anon_sym_BQUOTE,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    ACTIONS(18958), 1,
      anon_sym_RPAREN,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1849), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [454784] = 3,
    ACTIONS(15696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454811] = 3,
    ACTIONS(15692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454838] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454865] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [454891] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__dot,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454917] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [454945] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [454971] = 11,
    ACTIONS(8516), 1,
      sym__conid,
    ACTIONS(18960), 1,
      sym__varid,
    ACTIONS(18964), 1,
      anon_sym_LPAREN,
    STATE(5990), 1,
      sym_constructor,
    STATE(6532), 1,
      sym_qualified_constructor,
    STATE(15117), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18962), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6390), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6391), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455013] = 11,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(18966), 1,
      sym__varid,
    ACTIONS(18970), 1,
      anon_sym_LPAREN,
    STATE(7377), 1,
      sym_constructor,
    STATE(7793), 1,
      sym_qualified_constructor,
    STATE(15339), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18968), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7635), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7703), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455055] = 11,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(18972), 1,
      sym__varid,
    ACTIONS(18974), 1,
      anon_sym_LPAREN,
    STATE(4694), 1,
      sym_constructor,
    STATE(4922), 1,
      sym_qualified_constructor,
    STATE(15328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(557), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4709), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5191), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455097] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [455125] = 3,
    ACTIONS(18622), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455151] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455177] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455203] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455229] = 11,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(18976), 1,
      sym__varid,
    ACTIONS(18980), 1,
      anon_sym_LPAREN,
    STATE(7756), 1,
      sym_constructor,
    STATE(8021), 1,
      sym_qualified_constructor,
    STATE(15330), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18978), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8074), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8086), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455271] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455297] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455323] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455349] = 10,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(2464), 1,
      sym__colon2,
    STATE(13449), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15417), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18982), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17911), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455389] = 11,
    ACTIONS(15333), 1,
      sym__conid,
    ACTIONS(18990), 1,
      sym__varid,
    ACTIONS(18994), 1,
      anon_sym_LPAREN,
    STATE(13919), 1,
      sym_constructor,
    STATE(14427), 1,
      sym_qualified_constructor,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18992), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14655), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14932), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455431] = 11,
    ACTIONS(13012), 1,
      sym__conid,
    ACTIONS(18996), 1,
      sym__varid,
    ACTIONS(19000), 1,
      anon_sym_LPAREN,
    STATE(8466), 1,
      sym_constructor,
    STATE(8491), 1,
      sym_qualified_constructor,
    STATE(15623), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18998), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8738), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8745), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455473] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455499] = 11,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(19002), 1,
      sym__varid,
    ACTIONS(19006), 1,
      anon_sym_LPAREN,
    STATE(5999), 1,
      sym_constructor,
    STATE(6525), 1,
      sym_qualified_constructor,
    STATE(14977), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19004), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6563), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6564), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455541] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455567] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455593] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455621] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455647] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455675] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [455703] = 11,
    ACTIONS(4607), 1,
      sym__conid,
    ACTIONS(19008), 1,
      sym__varid,
    ACTIONS(19010), 1,
      anon_sym_LPAREN,
    STATE(5155), 1,
      sym_constructor,
    STATE(5446), 1,
      sym_qualified_constructor,
    STATE(15201), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2855), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5285), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5460), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455745] = 11,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(19012), 1,
      sym__varid,
    ACTIONS(19014), 1,
      anon_sym_LPAREN,
    STATE(5071), 1,
      sym_constructor,
    STATE(5533), 1,
      sym_qualified_constructor,
    STATE(15164), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1393), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5644), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5783), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455787] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [455813] = 11,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(19016), 1,
      sym__varid,
    ACTIONS(19018), 1,
      anon_sym_LPAREN,
    STATE(4602), 1,
      sym_constructor,
    STATE(4779), 1,
      sym_qualified_constructor,
    STATE(15426), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(175), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5156), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5159), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455855] = 11,
    ACTIONS(16004), 1,
      sym__conid,
    ACTIONS(19020), 1,
      sym__varid,
    ACTIONS(19024), 1,
      anon_sym_LPAREN,
    STATE(15024), 1,
      aux_sym__qualifying_module,
    STATE(15718), 1,
      sym_constructor,
    STATE(17708), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19022), 2,
      sym_label,
      sym_implicit_parid,
    STATE(17677), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(17678), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455897] = 11,
    ACTIONS(8201), 1,
      sym__conid,
    ACTIONS(19026), 1,
      sym__varid,
    ACTIONS(19030), 1,
      anon_sym_LPAREN,
    STATE(5767), 1,
      sym_constructor,
    STATE(5959), 1,
      sym_qualified_constructor,
    STATE(15387), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19028), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6287), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6300), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455939] = 11,
    ACTIONS(15742), 1,
      sym__conid,
    ACTIONS(19032), 1,
      sym__varid,
    ACTIONS(19036), 1,
      anon_sym_LPAREN,
    STATE(15049), 1,
      aux_sym__qualifying_module,
    STATE(15425), 1,
      sym_constructor,
    STATE(15802), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19034), 2,
      sym_label,
      sym_implicit_parid,
    STATE(16169), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(16185), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455981] = 10,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(2464), 1,
      sym__colon2,
    STATE(13431), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15403), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19038), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17914), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456021] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456047] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [456075] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456101] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [456127] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456153] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456179] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456205] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [456231] = 11,
    ACTIONS(8141), 1,
      sym__conid,
    ACTIONS(19040), 1,
      sym__varid,
    ACTIONS(19044), 1,
      anon_sym_LPAREN,
    STATE(7349), 1,
      sym_constructor,
    STATE(7805), 1,
      sym_qualified_constructor,
    STATE(15307), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19042), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7582), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7633), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456273] = 11,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(19046), 1,
      sym__varid,
    ACTIONS(19048), 1,
      anon_sym_LPAREN,
    STATE(11390), 1,
      sym_constructor,
    STATE(11692), 1,
      sym_qualified_constructor,
    STATE(15069), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4685), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11644), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12090), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456315] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [456343] = 11,
    ACTIONS(8442), 1,
      sym__conid,
    ACTIONS(19050), 1,
      sym__varid,
    ACTIONS(19054), 1,
      anon_sym_LPAREN,
    STATE(7168), 1,
      sym_constructor,
    STATE(7488), 1,
      sym_qualified_constructor,
    STATE(15127), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19052), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7456), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7458), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456385] = 10,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(2464), 1,
      sym__colon2,
    STATE(13371), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15578), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19038), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17995), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456425] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 14,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [456451] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [456479] = 5,
    ACTIONS(19056), 1,
      anon_sym_LBRACE,
    ACTIONS(19059), 1,
      sym__layout_start,
    STATE(12222), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [456509] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456535] = 11,
    ACTIONS(7901), 1,
      sym__conid,
    ACTIONS(19061), 1,
      sym__varid,
    ACTIONS(19065), 1,
      anon_sym_LPAREN,
    STATE(6492), 1,
      sym_constructor,
    STATE(6909), 1,
      sym_qualified_constructor,
    STATE(15360), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19063), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6664), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6668), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456577] = 5,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16985), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [456607] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [456633] = 11,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(19067), 1,
      sym__varid,
    ACTIONS(19069), 1,
      anon_sym_LPAREN,
    STATE(10340), 1,
      sym_constructor,
    STATE(10549), 1,
      sym_qualified_constructor,
    STATE(15481), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9730), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10541), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10582), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456675] = 11,
    ACTIONS(4435), 1,
      sym__conid,
    ACTIONS(19071), 1,
      sym__varid,
    ACTIONS(19073), 1,
      anon_sym_LPAREN,
    STATE(5241), 1,
      sym_constructor,
    STATE(5383), 1,
      sym_qualified_constructor,
    STATE(15402), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2805), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5407), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5653), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456717] = 6,
    ACTIONS(17009), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16971), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [456749] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 13,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [456775] = 11,
    ACTIONS(15337), 1,
      sym__conid,
    ACTIONS(19075), 1,
      sym__varid,
    ACTIONS(19079), 1,
      anon_sym_LPAREN,
    STATE(13783), 1,
      sym_constructor,
    STATE(14079), 1,
      sym_qualified_constructor,
    STATE(15188), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19077), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14379), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14412), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456817] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [456845] = 11,
    ACTIONS(8293), 1,
      sym__conid,
    ACTIONS(19081), 1,
      sym__varid,
    ACTIONS(19085), 1,
      anon_sym_LPAREN,
    STATE(6083), 1,
      sym_constructor,
    STATE(6345), 1,
      sym_qualified_constructor,
    STATE(15271), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19083), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6615), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6629), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456887] = 11,
    ACTIONS(8676), 1,
      sym__conid,
    ACTIONS(19087), 1,
      sym__varid,
    ACTIONS(19091), 1,
      anon_sym_LPAREN,
    STATE(6323), 1,
      sym_constructor,
    STATE(6689), 1,
      sym_qualified_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19089), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6740), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6743), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456929] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [456959] = 14,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(1610), 1,
      sym__varid,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(4115), 1,
      sym_constructor,
    STATE(4214), 1,
      sym_variable,
    STATE(8453), 1,
      sym_constructor_operator,
    STATE(13811), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(8345), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457007] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16994), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [457037] = 6,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16930), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [457069] = 11,
    ACTIONS(7873), 1,
      sym__conid,
    ACTIONS(19095), 1,
      sym__varid,
    ACTIONS(19099), 1,
      anon_sym_LPAREN,
    STATE(6779), 1,
      sym_constructor,
    STATE(7188), 1,
      sym_qualified_constructor,
    STATE(15574), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19097), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7127), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7141), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457111] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [457137] = 11,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(19101), 1,
      sym__varid,
    ACTIONS(19105), 1,
      anon_sym_LPAREN,
    STATE(8433), 1,
      sym_constructor,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(15354), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19103), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8636), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8643), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457179] = 11,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(19107), 1,
      sym__varid,
    ACTIONS(19109), 1,
      anon_sym_LPAREN,
    STATE(4588), 1,
      sym_constructor,
    STATE(4869), 1,
      sym_qualified_constructor,
    STATE(14972), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2447), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4861), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5229), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457221] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [457247] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [457275] = 6,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16971), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15456), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457307] = 5,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16983), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [457337] = 10,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(2464), 1,
      sym__colon2,
    STATE(13528), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15133), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(18204), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457377] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 14,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [457403] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [457431] = 14,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(1899), 1,
      sym__varid,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(3742), 1,
      sym_constructor,
    STATE(3790), 1,
      sym_variable,
    STATE(13811), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(22112), 1,
      sym_constructor_operator,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(22525), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457479] = 5,
    ACTIONS(19113), 1,
      anon_sym_LBRACE,
    ACTIONS(19116), 1,
      sym__layout_start,
    STATE(12549), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [457509] = 14,
    ACTIONS(259), 1,
      sym__conid,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(1610), 1,
      sym__varid,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(3739), 1,
      sym_constructor,
    STATE(4214), 1,
      sym_variable,
    STATE(8453), 1,
      sym_constructor_operator,
    STATE(13811), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(8345), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457557] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [457583] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [457609] = 11,
    ACTIONS(6220), 1,
      sym__conid,
    ACTIONS(19118), 1,
      sym__varid,
    ACTIONS(19122), 1,
      anon_sym_LPAREN,
    STATE(7740), 1,
      sym_constructor,
    STATE(8050), 1,
      sym_qualified_constructor,
    STATE(15598), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19120), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8146), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8168), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457651] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457679] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(19124), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [457707] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18817), 1,
      sym_guards,
    STATE(11403), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [457737] = 11,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(19126), 1,
      sym__varid,
    ACTIONS(19128), 1,
      anon_sym_LPAREN,
    STATE(4831), 1,
      sym_constructor,
    STATE(5636), 1,
      sym_qualified_constructor,
    STATE(15311), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3268), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5293), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5351), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457779] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [457807] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(19182), 1,
      sym_guards,
    STATE(11275), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457837] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457865] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19132), 1,
      anon_sym_BQUOTE,
    ACTIONS(19134), 1,
      sym__consym,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3174), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 7,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [457903] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [457931] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457957] = 11,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(19136), 1,
      sym__varid,
    ACTIONS(19140), 1,
      anon_sym_LPAREN,
    STATE(4289), 1,
      sym_constructor,
    STATE(4476), 1,
      sym_qualified_constructor,
    STATE(15037), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19138), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8505), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8698), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457999] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458025] = 5,
    ACTIONS(19142), 1,
      anon_sym_LBRACE,
    ACTIONS(19145), 1,
      sym__layout_start,
    STATE(12143), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [458055] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458081] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458109] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458135] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(19147), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [458163] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458189] = 5,
    ACTIONS(19116), 1,
      sym__layout_start,
    ACTIONS(19149), 1,
      anon_sym_LBRACE,
    STATE(13104), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [458219] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [458247] = 6,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16971), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15456), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [458279] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458305] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458331] = 11,
    ACTIONS(15183), 1,
      sym__conid,
    ACTIONS(19151), 1,
      sym__varid,
    ACTIONS(19155), 1,
      anon_sym_LPAREN,
    STATE(9777), 1,
      sym_constructor,
    STATE(10091), 1,
      sym_qualified_constructor,
    STATE(15517), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19153), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10105), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(10181), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458373] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458399] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458425] = 11,
    ACTIONS(15299), 1,
      sym__conid,
    ACTIONS(19157), 1,
      sym__varid,
    ACTIONS(19161), 1,
      anon_sym_LPAREN,
    STATE(12879), 1,
      sym_constructor,
    STATE(13521), 1,
      sym_qualified_constructor,
    STATE(15428), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19159), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13721), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13850), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458467] = 11,
    ACTIONS(13436), 1,
      sym__conid,
    ACTIONS(19163), 1,
      sym__varid,
    ACTIONS(19167), 1,
      anon_sym_LPAREN,
    STATE(8782), 1,
      sym_constructor,
    STATE(9114), 1,
      sym_qualified_constructor,
    STATE(15439), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19165), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8965), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9269), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458509] = 11,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(19173), 1,
      anon_sym_LPAREN,
    STATE(15441), 1,
      aux_sym__qualifying_module,
    STATE(17854), 1,
      sym_constructor,
    STATE(20232), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19171), 2,
      sym_label,
      sym_implicit_parid,
    STATE(20214), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(20215), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458551] = 11,
    ACTIONS(15321), 1,
      sym__conid,
    ACTIONS(19175), 1,
      sym__varid,
    ACTIONS(19179), 1,
      anon_sym_LPAREN,
    STATE(14303), 1,
      sym_constructor,
    STATE(14603), 1,
      sym_qualified_constructor,
    STATE(15369), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19177), 2,
      sym_label,
      sym_implicit_parid,
    STATE(15080), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(15388), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458593] = 11,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(19181), 1,
      sym__varid,
    ACTIONS(19185), 1,
      anon_sym_LPAREN,
    STATE(6535), 1,
      sym_constructor,
    STATE(6805), 1,
      sym_qualified_constructor,
    STATE(15617), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19183), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6795), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6993), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458635] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458661] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458687] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458713] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458741] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(19182), 1,
      sym_guards,
    STATE(11275), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [458771] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458797] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [458823] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458849] = 11,
    ACTIONS(15329), 1,
      sym__conid,
    ACTIONS(19187), 1,
      sym__varid,
    ACTIONS(19191), 1,
      anon_sym_LPAREN,
    STATE(14082), 1,
      sym_constructor,
    STATE(14201), 1,
      sym_qualified_constructor,
    STATE(15263), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19189), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14553), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(14762), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458891] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458919] = 11,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(19193), 1,
      sym__varid,
    ACTIONS(19197), 1,
      anon_sym_LPAREN,
    STATE(8724), 1,
      sym_constructor,
    STATE(8990), 1,
      sym_qualified_constructor,
    STATE(15508), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19195), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9658), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9661), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458961] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [458987] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459013] = 11,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(19199), 1,
      sym__varid,
    ACTIONS(19201), 1,
      anon_sym_LPAREN,
    STATE(11426), 1,
      sym_constructor,
    STATE(11528), 1,
      sym_qualified_constructor,
    STATE(15128), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10000), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11697), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11952), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459055] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18494), 1,
      sym_guards,
    STATE(11285), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [459085] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459111] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459137] = 11,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(19203), 1,
      sym__varid,
    ACTIONS(19207), 1,
      anon_sym_LPAREN,
    STATE(8596), 1,
      sym_constructor,
    STATE(8752), 1,
      sym_qualified_constructor,
    STATE(15545), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19205), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9229), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9233), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459179] = 11,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(19209), 1,
      sym__varid,
    ACTIONS(19213), 1,
      anon_sym_LPAREN,
    STATE(8797), 1,
      sym_constructor,
    STATE(8924), 1,
      sym_qualified_constructor,
    STATE(15588), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19211), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9640), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9641), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459221] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459247] = 5,
    ACTIONS(19059), 1,
      sym__layout_start,
    ACTIONS(19215), 1,
      anon_sym_LBRACE,
    STATE(13014), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [459277] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [459303] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459329] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459355] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459381] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459407] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459433] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [459461] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459487] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459513] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [459539] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459565] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459591] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [459617] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459643] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459669] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459695] = 10,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(2429), 1,
      sym__colon2,
    STATE(13353), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15166), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18982), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(19415), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459735] = 11,
    ACTIONS(9390), 1,
      sym__conid,
    ACTIONS(19223), 1,
      sym__varid,
    ACTIONS(19225), 1,
      anon_sym_LPAREN,
    STATE(11035), 1,
      sym_constructor,
    STATE(11156), 1,
      sym_qualified_constructor,
    STATE(15624), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9386), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11210), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11457), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459777] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459803] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 15,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [459827] = 11,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(19227), 1,
      sym__varid,
    ACTIONS(19231), 1,
      anon_sym_LPAREN,
    STATE(8191), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(15430), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19229), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8319), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8456), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459869] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459895] = 11,
    ACTIONS(7981), 1,
      sym__conid,
    ACTIONS(19233), 1,
      sym__varid,
    ACTIONS(19237), 1,
      anon_sym_LPAREN,
    STATE(7480), 1,
      sym_constructor,
    STATE(7641), 1,
      sym_qualified_constructor,
    STATE(15591), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19235), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7653), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7670), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459937] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459965] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [459991] = 11,
    ACTIONS(8622), 1,
      sym__conid,
    ACTIONS(19239), 1,
      sym__varid,
    ACTIONS(19243), 1,
      anon_sym_LPAREN,
    STATE(6638), 1,
      sym_constructor,
    STATE(6703), 1,
      sym_qualified_constructor,
    STATE(15465), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19241), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6887), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6900), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460033] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [460059] = 11,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(19245), 1,
      sym__varid,
    ACTIONS(19249), 1,
      anon_sym_LPAREN,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(15414), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19247), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8281), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8299), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460101] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [460127] = 11,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(19249), 1,
      anon_sym_LPAREN,
    ACTIONS(19251), 1,
      sym__varid,
    STATE(7895), 1,
      sym_constructor,
    STATE(8241), 1,
      sym_qualified_constructor,
    STATE(15202), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19247), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8281), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8299), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460169] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [460197] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(19253), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2658), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 8,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [460231] = 11,
    ACTIONS(12746), 1,
      sym__conid,
    ACTIONS(19255), 1,
      sym__varid,
    ACTIONS(19259), 1,
      anon_sym_LPAREN,
    STATE(8848), 1,
      sym_constructor,
    STATE(9342), 1,
      sym_qualified_constructor,
    STATE(15280), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19257), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9143), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9167), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460273] = 11,
    ACTIONS(7921), 1,
      sym__conid,
    ACTIONS(19261), 1,
      sym__varid,
    ACTIONS(19265), 1,
      anon_sym_LPAREN,
    STATE(5954), 1,
      sym_constructor,
    STATE(6628), 1,
      sym_qualified_constructor,
    STATE(15183), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19263), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6487), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6497), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460315] = 11,
    ACTIONS(8756), 1,
      sym__conid,
    ACTIONS(19267), 1,
      sym__varid,
    ACTIONS(19271), 1,
      anon_sym_LPAREN,
    STATE(6602), 1,
      sym_constructor,
    STATE(6741), 1,
      sym_qualified_constructor,
    STATE(15152), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19269), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6936), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6958), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460357] = 10,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(2429), 1,
      sym__colon2,
    STATE(13456), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15595), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19111), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(18352), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460397] = 5,
    ACTIONS(19273), 1,
      anon_sym_LBRACE,
    ACTIONS(19275), 1,
      sym__layout_start,
    STATE(12840), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [460427] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [460455] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [460481] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [460507] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [460535] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [460561] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18494), 1,
      sym_guards,
    STATE(11285), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [460591] = 11,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(19277), 1,
      sym__varid,
    ACTIONS(19281), 1,
      anon_sym_LPAREN,
    STATE(14471), 1,
      sym_constructor,
    STATE(14788), 1,
      sym_qualified_constructor,
    STATE(15114), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19279), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14933), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(14956), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460633] = 11,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(19283), 1,
      sym__varid,
    ACTIONS(19285), 1,
      anon_sym_LPAREN,
    STATE(10325), 1,
      sym_constructor,
    STATE(10464), 1,
      sym_qualified_constructor,
    STATE(15321), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4393), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10462), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10558), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460675] = 11,
    ACTIONS(14827), 1,
      sym__conid,
    ACTIONS(19287), 1,
      sym__varid,
    ACTIONS(19291), 1,
      anon_sym_LPAREN,
    STATE(9352), 1,
      sym_constructor,
    STATE(9860), 1,
      sym_qualified_constructor,
    STATE(15030), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19289), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9726), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9750), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460717] = 11,
    ACTIONS(15307), 1,
      sym__conid,
    ACTIONS(19293), 1,
      sym__varid,
    ACTIONS(19297), 1,
      anon_sym_LPAREN,
    STATE(14185), 1,
      sym_constructor,
    STATE(14585), 1,
      sym_qualified_constructor,
    STATE(15035), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19295), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14997), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(15236), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460759] = 11,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(19299), 1,
      sym__varid,
    ACTIONS(19303), 1,
      anon_sym_LPAREN,
    STATE(7242), 1,
      sym_constructor,
    STATE(7627), 1,
      sym_qualified_constructor,
    STATE(15018), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19301), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7757), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7770), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460801] = 11,
    ACTIONS(12225), 1,
      sym__conid,
    ACTIONS(19305), 1,
      sym__varid,
    ACTIONS(19309), 1,
      anon_sym_LPAREN,
    STATE(9652), 1,
      sym_constructor,
    STATE(9674), 1,
      sym_qualified_constructor,
    STATE(15607), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19307), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9689), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9701), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460843] = 11,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(19311), 1,
      sym__varid,
    ACTIONS(19313), 1,
      anon_sym_LPAREN,
    STATE(3732), 1,
      sym_constructor,
    STATE(3756), 1,
      sym_qualified_constructor,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(95), 2,
      sym_label,
      sym_implicit_parid,
    STATE(3754), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(3814), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460885] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [460911] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [460937] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [460963] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [460989] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [461017] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [461043] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 15,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [461067] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 15,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [461091] = 11,
    ACTIONS(15325), 1,
      sym__conid,
    ACTIONS(19315), 1,
      sym__varid,
    ACTIONS(19319), 1,
      anon_sym_LPAREN,
    STATE(14041), 1,
      sym_constructor,
    STATE(14160), 1,
      sym_qualified_constructor,
    STATE(14985), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19317), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14588), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14662), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461133] = 11,
    ACTIONS(15303), 1,
      sym__conid,
    ACTIONS(19321), 1,
      sym__varid,
    ACTIONS(19325), 1,
      anon_sym_LPAREN,
    STATE(13275), 1,
      sym_constructor,
    STATE(13601), 1,
      sym_qualified_constructor,
    STATE(15363), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19323), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13966), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(13987), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461175] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [461203] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(19182), 1,
      sym_guards,
    STATE(11275), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [461233] = 7,
    ACTIONS(18391), 1,
      anon_sym_DASH,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(19327), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2671), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 8,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [461267] = 11,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(19329), 1,
      sym__varid,
    ACTIONS(19333), 1,
      anon_sym_LPAREN,
    STATE(7254), 1,
      sym_constructor,
    STATE(7620), 1,
      sym_qualified_constructor,
    STATE(14987), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19331), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7581), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7877), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461309] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [461335] = 11,
    ACTIONS(15293), 1,
      sym__conid,
    ACTIONS(19335), 1,
      sym__varid,
    ACTIONS(19339), 1,
      anon_sym_LPAREN,
    STATE(14451), 1,
      sym_constructor,
    STATE(14620), 1,
      sym_qualified_constructor,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19337), 2,
      sym_label,
      sym_implicit_parid,
    STATE(15200), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(15222), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461377] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [461403] = 11,
    ACTIONS(9622), 1,
      sym__conid,
    ACTIONS(19341), 1,
      sym__varid,
    ACTIONS(19343), 1,
      anon_sym_LPAREN,
    STATE(12771), 1,
      sym_constructor,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(15148), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4775), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12977), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12985), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461445] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [461473] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [461499] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [461525] = 11,
    ACTIONS(13779), 1,
      sym__conid,
    ACTIONS(19345), 1,
      sym__varid,
    ACTIONS(19349), 1,
      anon_sym_LPAREN,
    STATE(8896), 1,
      sym_constructor,
    STATE(9395), 1,
      sym_qualified_constructor,
    STATE(15155), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19347), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9604), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9611), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461567] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [461595] = 11,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(19351), 1,
      sym__varid,
    ACTIONS(19353), 1,
      anon_sym_LPAREN,
    STATE(11980), 1,
      sym_constructor,
    STATE(12433), 1,
      sym_qualified_constructor,
    STATE(15074), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9478), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12196), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(12590), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461637] = 11,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(19355), 1,
      sym__varid,
    ACTIONS(19359), 1,
      anon_sym_LPAREN,
    STATE(6782), 1,
      sym_constructor,
    STATE(7185), 1,
      sym_qualified_constructor,
    STATE(15125), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19357), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7178), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7206), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461679] = 11,
    ACTIONS(4617), 1,
      sym__conid,
    ACTIONS(19361), 1,
      sym__varid,
    ACTIONS(19363), 1,
      anon_sym_LPAREN,
    STATE(4469), 1,
      sym_constructor,
    STATE(4558), 1,
      sym_qualified_constructor,
    STATE(15050), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2121), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4622), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4666), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461721] = 11,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(19365), 1,
      sym__varid,
    ACTIONS(19367), 1,
      anon_sym_LPAREN,
    STATE(4116), 1,
      sym_constructor,
    STATE(4164), 1,
      sym_qualified_constructor,
    STATE(15440), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(249), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4142), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4153), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461763] = 11,
    ACTIONS(9356), 1,
      sym__conid,
    ACTIONS(19369), 1,
      sym__varid,
    ACTIONS(19371), 1,
      anon_sym_LPAREN,
    STATE(11482), 1,
      sym_constructor,
    STATE(11582), 1,
      sym_qualified_constructor,
    STATE(15067), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9352), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11615), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11824), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461805] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [461831] = 11,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(19373), 1,
      sym__varid,
    ACTIONS(19377), 1,
      anon_sym_LPAREN,
    STATE(7677), 1,
      sym_constructor,
    STATE(8098), 1,
      sym_qualified_constructor,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19375), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7897), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7955), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461873] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [461899] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [461925] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [461953] = 11,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(19379), 1,
      sym__varid,
    ACTIONS(19383), 1,
      anon_sym_LPAREN,
    STATE(9317), 1,
      sym_constructor,
    STATE(9620), 1,
      sym_qualified_constructor,
    STATE(15015), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19381), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9402), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9475), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461995] = 11,
    ACTIONS(15311), 1,
      sym__conid,
    ACTIONS(19385), 1,
      sym__varid,
    ACTIONS(19389), 1,
      anon_sym_LPAREN,
    STATE(13885), 1,
      sym_constructor,
    STATE(14417), 1,
      sym_qualified_constructor,
    STATE(15112), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19387), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14789), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14927), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462037] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [462063] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [462089] = 11,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(19391), 1,
      sym__varid,
    ACTIONS(19393), 1,
      anon_sym_LPAREN,
    STATE(11712), 1,
      sym_constructor,
    STATE(12598), 1,
      sym_qualified_constructor,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4549), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12314), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12709), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462131] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [462157] = 11,
    ACTIONS(13038), 1,
      sym__conid,
    ACTIONS(19395), 1,
      sym__varid,
    ACTIONS(19399), 1,
      anon_sym_LPAREN,
    STATE(8500), 1,
      sym_constructor,
    STATE(8802), 1,
      sym_qualified_constructor,
    STATE(15149), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19397), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8898), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9095), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462199] = 11,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(19401), 1,
      sym__varid,
    ACTIONS(19403), 1,
      anon_sym_LPAREN,
    STATE(11192), 1,
      sym_constructor,
    STATE(12069), 1,
      sym_qualified_constructor,
    STATE(15158), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4645), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11540), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(12001), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462241] = 11,
    ACTIONS(8498), 1,
      sym__conid,
    ACTIONS(19405), 1,
      sym__varid,
    ACTIONS(19409), 1,
      anon_sym_LPAREN,
    STATE(7404), 1,
      sym_constructor,
    STATE(7688), 1,
      sym_qualified_constructor,
    STATE(15089), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19407), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7861), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7868), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462283] = 14,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(18890), 1,
      anon_sym_LPAREN,
    ACTIONS(18896), 1,
      anon_sym_module,
    ACTIONS(19411), 1,
      anon_sym_RPAREN,
    STATE(15065), 1,
      sym_namespace,
    STATE(15110), 1,
      aux_sym__qualifying_module,
    STATE(15933), 1,
      sym_constructor,
    STATE(17824), 1,
      sym_qualified_type,
    STATE(21011), 1,
      sym_export,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(20935), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462331] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19413), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [462359] = 11,
    ACTIONS(9828), 1,
      sym__conid,
    ACTIONS(19415), 1,
      sym__varid,
    ACTIONS(19417), 1,
      anon_sym_LPAREN,
    STATE(11486), 1,
      sym_constructor,
    STATE(11570), 1,
      sym_qualified_constructor,
    STATE(15100), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9824), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11674), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(11789), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462401] = 11,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(19419), 1,
      sym__varid,
    ACTIONS(19423), 1,
      anon_sym_LPAREN,
    STATE(8681), 1,
      sym_constructor,
    STATE(8718), 1,
      sym_qualified_constructor,
    STATE(15167), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19421), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8939), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9015), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462443] = 11,
    ACTIONS(9862), 1,
      sym__conid,
    ACTIONS(19425), 1,
      sym__varid,
    ACTIONS(19427), 1,
      anon_sym_LPAREN,
    STATE(11803), 1,
      sym_constructor,
    STATE(12197), 1,
      sym_qualified_constructor,
    STATE(15177), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9858), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12123), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12542), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462485] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [462511] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462539] = 11,
    ACTIONS(4537), 1,
      sym__conid,
    ACTIONS(19429), 1,
      sym__varid,
    ACTIONS(19431), 1,
      anon_sym_LPAREN,
    STATE(4632), 1,
      sym_constructor,
    STATE(4761), 1,
      sym_qualified_constructor,
    STATE(15180), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2210), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4774), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4938), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462581] = 11,
    ACTIONS(8660), 1,
      sym__conid,
    ACTIONS(19433), 1,
      sym__varid,
    ACTIONS(19437), 1,
      anon_sym_LPAREN,
    STATE(6498), 1,
      sym_constructor,
    STATE(6908), 1,
      sym_qualified_constructor,
    STATE(15116), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19435), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6693), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6764), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462623] = 11,
    ACTIONS(4851), 1,
      sym__conid,
    ACTIONS(19439), 1,
      sym__varid,
    ACTIONS(19441), 1,
      anon_sym_LPAREN,
    STATE(4189), 1,
      sym_constructor,
    STATE(4245), 1,
      sym_qualified_constructor,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1928), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4256), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4327), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462665] = 11,
    ACTIONS(7911), 1,
      sym__conid,
    ACTIONS(19443), 1,
      sym__varid,
    ACTIONS(19447), 1,
      anon_sym_LPAREN,
    STATE(6508), 1,
      sym_constructor,
    STATE(6931), 1,
      sym_qualified_constructor,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19445), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6713), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6809), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462707] = 11,
    ACTIONS(9930), 1,
      sym__conid,
    ACTIONS(19449), 1,
      sym__varid,
    ACTIONS(19451), 1,
      anon_sym_LPAREN,
    STATE(11578), 1,
      sym_constructor,
    STATE(12329), 1,
      sym_qualified_constructor,
    STATE(15204), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9926), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12231), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12761), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462749] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19457), 1,
      anon_sym_LPAREN,
    STATE(14685), 1,
      sym_constructor,
    STATE(15419), 1,
      sym_qualified_constructor,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19455), 2,
      sym_label,
      sym_implicit_parid,
    STATE(15118), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(15599), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462791] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [462817] = 11,
    ACTIONS(7429), 1,
      sym__conid,
    ACTIONS(19459), 1,
      sym__varid,
    ACTIONS(19463), 1,
      anon_sym_LPAREN,
    STATE(7655), 1,
      sym_constructor,
    STATE(8122), 1,
      sym_qualified_constructor,
    STATE(15210), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19461), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7966), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8077), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462859] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [462887] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [462913] = 11,
    ACTIONS(5706), 1,
      sym__conid,
    ACTIONS(19465), 1,
      sym__varid,
    ACTIONS(19469), 1,
      anon_sym_LPAREN,
    STATE(7323), 1,
      sym_constructor,
    STATE(7713), 1,
      sym_qualified_constructor,
    STATE(15025), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19467), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7636), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7808), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462955] = 11,
    ACTIONS(8534), 1,
      sym__conid,
    ACTIONS(19471), 1,
      sym__varid,
    ACTIONS(19475), 1,
      anon_sym_LPAREN,
    STATE(8187), 1,
      sym_constructor,
    STATE(8238), 1,
      sym_qualified_constructor,
    STATE(15224), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19473), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8209), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8234), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462997] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18817), 1,
      sym_guards,
    STATE(11403), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [463027] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463053] = 11,
    ACTIONS(8774), 1,
      sym__conid,
    ACTIONS(19477), 1,
      sym__varid,
    ACTIONS(19481), 1,
      anon_sym_LPAREN,
    STATE(6960), 1,
      sym_constructor,
    STATE(7085), 1,
      sym_qualified_constructor,
    STATE(15151), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19479), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7148), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7207), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463095] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463121] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463147] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463173] = 4,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(17013), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [463201] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463227] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18494), 1,
      sym_guards,
    STATE(11285), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [463257] = 11,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(19483), 1,
      sym__varid,
    ACTIONS(19485), 1,
      anon_sym_LPAREN,
    STATE(4738), 1,
      sym_constructor,
    STATE(5513), 1,
      sym_qualified_constructor,
    STATE(15243), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2649), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5631), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5817), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463299] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [463325] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463351] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463377] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463403] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463429] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [463457] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463483] = 11,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(19487), 1,
      sym__varid,
    ACTIONS(19491), 1,
      anon_sym_LPAREN,
    STATE(9830), 1,
      sym_constructor,
    STATE(9915), 1,
      sym_qualified_constructor,
    STATE(15344), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19489), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10322), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10361), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463525] = 11,
    ACTIONS(4483), 1,
      sym__conid,
    ACTIONS(19493), 1,
      sym__varid,
    ACTIONS(19495), 1,
      anon_sym_LPAREN,
    STATE(5459), 1,
      sym_constructor,
    STATE(6190), 1,
      sym_qualified_constructor,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3168), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5941), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6084), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463567] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463593] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463619] = 11,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(19497), 1,
      sym__varid,
    ACTIONS(19499), 1,
      anon_sym_LPAREN,
    STATE(3737), 1,
      sym_constructor,
    STATE(3746), 1,
      sym_qualified_constructor,
    STATE(15288), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1862), 2,
      sym_label,
      sym_implicit_parid,
    STATE(3768), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(3783), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463661] = 11,
    ACTIONS(8265), 1,
      sym__conid,
    ACTIONS(19501), 1,
      sym__varid,
    ACTIONS(19505), 1,
      anon_sym_LPAREN,
    STATE(7039), 1,
      sym_constructor,
    STATE(7395), 1,
      sym_qualified_constructor,
    STATE(15178), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19503), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7328), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7353), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463703] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [463731] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463757] = 11,
    ACTIONS(7891), 1,
      sym__conid,
    ACTIONS(19507), 1,
      sym__varid,
    ACTIONS(19511), 1,
      anon_sym_LPAREN,
    STATE(4465), 1,
      sym_constructor,
    STATE(4569), 1,
      sym_qualified_constructor,
    STATE(15300), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19509), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4512), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4707), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463799] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463825] = 11,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(19513), 1,
      sym__varid,
    ACTIONS(19517), 1,
      anon_sym_LPAREN,
    STATE(8734), 1,
      sym_constructor,
    STATE(8979), 1,
      sym_qualified_constructor,
    STATE(15315), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19515), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9390), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9462), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463867] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463893] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [463921] = 11,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(19519), 1,
      sym__varid,
    ACTIONS(19521), 1,
      anon_sym_LPAREN,
    STATE(4228), 1,
      sym_constructor,
    STATE(4427), 1,
      sym_qualified_constructor,
    STATE(15275), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(1454), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4365), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4393), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463963] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [463989] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [464017] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(19523), 1,
      anon_sym_LBRACE,
    ACTIONS(19526), 1,
      sym__layout_start,
    STATE(12555), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [464049] = 11,
    ACTIONS(8414), 1,
      sym__conid,
    ACTIONS(19528), 1,
      sym__varid,
    ACTIONS(19532), 1,
      anon_sym_LPAREN,
    STATE(7094), 1,
      sym_constructor,
    STATE(7391), 1,
      sym_qualified_constructor,
    STATE(15214), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19530), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7310), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7347), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464091] = 11,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(19534), 1,
      sym__varid,
    ACTIONS(19538), 1,
      anon_sym_LPAREN,
    STATE(8574), 1,
      sym_constructor,
    STATE(8847), 1,
      sym_qualified_constructor,
    STATE(15342), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19536), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9149), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9172), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464133] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464159] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464185] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464213] = 11,
    ACTIONS(16783), 1,
      sym__conid,
    ACTIONS(19540), 1,
      sym__varid,
    ACTIONS(19544), 1,
      anon_sym_LPAREN,
    STATE(15230), 1,
      aux_sym__qualifying_module,
    STATE(15592), 1,
      sym_constructor,
    STATE(15639), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19542), 2,
      sym_label,
      sym_implicit_parid,
    STATE(15753), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(15826), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464255] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464281] = 11,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(19546), 1,
      sym__varid,
    ACTIONS(19548), 1,
      anon_sym_LPAREN,
    STATE(4649), 1,
      sym_constructor,
    STATE(4902), 1,
      sym_qualified_constructor,
    STATE(15353), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2570), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4713), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4820), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464323] = 10,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(2429), 1,
      sym__colon2,
    STATE(13412), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(14979), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19038), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(18656), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464363] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464389] = 11,
    ACTIONS(14170), 1,
      sym__conid,
    ACTIONS(19550), 1,
      sym__varid,
    ACTIONS(19554), 1,
      anon_sym_LPAREN,
    STATE(9019), 1,
      sym_constructor,
    STATE(9599), 1,
      sym_qualified_constructor,
    STATE(15242), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19552), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9452), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9477), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464431] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464457] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464483] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464509] = 11,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(19556), 1,
      sym__varid,
    ACTIONS(19560), 1,
      anon_sym_LPAREN,
    STATE(15365), 1,
      aux_sym__qualifying_module,
    STATE(16030), 1,
      sym_constructor,
    STATE(17440), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19558), 2,
      sym_label,
      sym_implicit_parid,
    STATE(16439), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(16694), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464551] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464577] = 11,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(19562), 1,
      sym__varid,
    ACTIONS(19566), 1,
      anon_sym_LPAREN,
    STATE(7218), 1,
      sym_constructor,
    STATE(7325), 1,
      sym_qualified_constructor,
    STATE(15206), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19564), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7253), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7394), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464619] = 11,
    ACTIONS(15317), 1,
      sym__conid,
    ACTIONS(19568), 1,
      sym__varid,
    ACTIONS(19572), 1,
      anon_sym_LPAREN,
    STATE(14115), 1,
      sym_constructor,
    STATE(14146), 1,
      sym_qualified_constructor,
    STATE(15401), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19570), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14561), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14683), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464661] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [464689] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464715] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464741] = 11,
    ACTIONS(13304), 1,
      sym__conid,
    ACTIONS(19574), 1,
      sym__varid,
    ACTIONS(19578), 1,
      anon_sym_LPAREN,
    STATE(8630), 1,
      sym_constructor,
    STATE(8740), 1,
      sym_qualified_constructor,
    STATE(15446), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19576), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9195), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9331), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464783] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464809] = 11,
    ACTIONS(14940), 1,
      sym__conid,
    ACTIONS(19580), 1,
      sym__varid,
    ACTIONS(19584), 1,
      anon_sym_LPAREN,
    STATE(9574), 1,
      sym_constructor,
    STATE(9710), 1,
      sym_qualified_constructor,
    STATE(15254), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19582), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9775), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9789), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464851] = 11,
    ACTIONS(13464), 1,
      sym__conid,
    ACTIONS(19586), 1,
      sym__varid,
    ACTIONS(19590), 1,
      anon_sym_LPAREN,
    STATE(8715), 1,
      sym_constructor,
    STATE(8938), 1,
      sym_qualified_constructor,
    STATE(15274), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19588), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9085), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9221), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464893] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464919] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464945] = 5,
    ACTIONS(19145), 1,
      sym__layout_start,
    ACTIONS(19592), 1,
      anon_sym_LBRACE,
    STATE(13164), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [464975] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465003] = 11,
    ACTIONS(8335), 1,
      sym__conid,
    ACTIONS(19594), 1,
      sym__varid,
    ACTIONS(19598), 1,
      anon_sym_LPAREN,
    STATE(6746), 1,
      sym_constructor,
    STATE(7201), 1,
      sym_qualified_constructor,
    STATE(15473), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19596), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7165), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7190), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465045] = 11,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(19600), 1,
      sym__varid,
    ACTIONS(19604), 1,
      anon_sym_LPAREN,
    STATE(7680), 1,
      sym_constructor,
    STATE(8095), 1,
      sym_qualified_constructor,
    STATE(15488), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19602), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8111), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8164), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465087] = 11,
    ACTIONS(13946), 1,
      sym__conid,
    ACTIONS(19606), 1,
      sym__varid,
    ACTIONS(19610), 1,
      anon_sym_LPAREN,
    STATE(8902), 1,
      sym_constructor,
    STATE(9520), 1,
      sym_qualified_constructor,
    STATE(15284), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19608), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9406), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9449), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465129] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [465157] = 11,
    ACTIONS(9212), 1,
      sym__conid,
    ACTIONS(19612), 1,
      sym__varid,
    ACTIONS(19614), 1,
      anon_sym_LPAREN,
    STATE(11280), 1,
      sym_constructor,
    STATE(11867), 1,
      sym_qualified_constructor,
    STATE(15516), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9208), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11562), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11810), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465199] = 11,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(19616), 1,
      sym__varid,
    ACTIONS(19620), 1,
      anon_sym_LPAREN,
    STATE(6527), 1,
      sym_constructor,
    STATE(6815), 1,
      sym_qualified_constructor,
    STATE(15525), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19618), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6697), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6917), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465241] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465269] = 11,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(19622), 1,
      sym__varid,
    ACTIONS(19626), 1,
      anon_sym_LPAREN,
    STATE(4342), 1,
      sym_constructor,
    STATE(4368), 1,
      sym_qualified_constructor,
    STATE(15539), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19624), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9738), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9794), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465311] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [465339] = 11,
    ACTIONS(9288), 1,
      sym__conid,
    ACTIONS(19628), 1,
      sym__varid,
    ACTIONS(19630), 1,
      anon_sym_LPAREN,
    STATE(10701), 1,
      sym_constructor,
    STATE(10874), 1,
      sym_qualified_constructor,
    STATE(15544), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9284), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10804), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(10880), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465381] = 11,
    ACTIONS(8828), 1,
      sym__conid,
    ACTIONS(19632), 1,
      sym__varid,
    ACTIONS(19636), 1,
      anon_sym_LPAREN,
    STATE(6062), 1,
      sym_constructor,
    STATE(6517), 1,
      sym_qualified_constructor,
    STATE(15559), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19634), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6550), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6645), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465423] = 11,
    ACTIONS(8351), 1,
      sym__conid,
    ACTIONS(19638), 1,
      sym__varid,
    ACTIONS(19642), 1,
      anon_sym_LPAREN,
    STATE(6072), 1,
      sym_constructor,
    STATE(6513), 1,
      sym_qualified_constructor,
    STATE(15576), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19640), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6587), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6656), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465465] = 11,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(19644), 1,
      sym__varid,
    ACTIONS(19646), 1,
      anon_sym_LPAREN,
    STATE(10858), 1,
      sym_constructor,
    STATE(11007), 1,
      sym_qualified_constructor,
    STATE(15383), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(4509), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11062), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(11068), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465507] = 11,
    ACTIONS(8211), 1,
      sym__conid,
    ACTIONS(19648), 1,
      sym__varid,
    ACTIONS(19652), 1,
      anon_sym_LPAREN,
    STATE(7005), 1,
      sym_constructor,
    STATE(7062), 1,
      sym_qualified_constructor,
    STATE(15461), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19650), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7118), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7189), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465549] = 6,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15448), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [465581] = 11,
    ACTIONS(8470), 1,
      sym__conid,
    ACTIONS(19654), 1,
      sym__varid,
    ACTIONS(19658), 1,
      anon_sym_LPAREN,
    STATE(7883), 1,
      sym_constructor,
    STATE(7909), 1,
      sym_qualified_constructor,
    STATE(15604), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19656), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8130), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8182), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465623] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [465651] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [465677] = 11,
    ACTIONS(4809), 1,
      sym__conid,
    ACTIONS(19660), 1,
      sym__varid,
    ACTIONS(19662), 1,
      anon_sym_LPAREN,
    STATE(4705), 1,
      sym_constructor,
    STATE(5141), 1,
      sym_qualified_constructor,
    STATE(15327), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2252), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4969), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5122), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465719] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [465745] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465773] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [465799] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [465825] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [465851] = 5,
    ACTIONS(19275), 1,
      sym__layout_start,
    ACTIONS(19664), 1,
      anon_sym_LBRACE,
    STATE(12256), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465881] = 11,
    ACTIONS(4491), 1,
      sym__conid,
    ACTIONS(19667), 1,
      sym__varid,
    ACTIONS(19669), 1,
      anon_sym_LPAREN,
    STATE(5341), 1,
      sym_constructor,
    STATE(6252), 1,
      sym_qualified_constructor,
    STATE(14986), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(15), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6160), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6298), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465923] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(19526), 1,
      sym__layout_start,
    ACTIONS(19671), 1,
      anon_sym_LBRACE,
    STATE(13173), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465955] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [465981] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [466007] = 6,
    ACTIONS(18545), 1,
      anon_sym_DASH,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18217), 1,
      sym_guards,
    STATE(11495), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [466039] = 11,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(19673), 1,
      sym__varid,
    ACTIONS(19677), 1,
      anon_sym_LPAREN,
    STATE(4166), 1,
      sym_constructor,
    STATE(4251), 1,
      sym_qualified_constructor,
    STATE(15062), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19675), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4240), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4285), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466081] = 11,
    ACTIONS(4603), 1,
      sym__conid,
    ACTIONS(19679), 1,
      sym__varid,
    ACTIONS(19681), 1,
      anon_sym_LPAREN,
    STATE(4874), 1,
      sym_constructor,
    STATE(5819), 1,
      sym_qualified_constructor,
    STATE(15620), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2760), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5353), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5871), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466123] = 11,
    ACTIONS(9526), 1,
      sym__conid,
    ACTIONS(19683), 1,
      sym__varid,
    ACTIONS(19685), 1,
      anon_sym_LPAREN,
    STATE(11972), 1,
      sym_constructor,
    STATE(12687), 1,
      sym_qualified_constructor,
    STATE(15608), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9522), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12534), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(12578), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466165] = 11,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(19687), 1,
      sym__varid,
    ACTIONS(19689), 1,
      anon_sym_LPAREN,
    STATE(10623), 1,
      sym_constructor,
    STATE(10748), 1,
      sym_qualified_constructor,
    STATE(15524), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3573), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10738), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10761), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466207] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [466233] = 11,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(19691), 1,
      sym__varid,
    ACTIONS(19693), 1,
      anon_sym_LPAREN,
    STATE(4637), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_qualified_constructor,
    STATE(15597), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2293), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4756), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4890), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466275] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [466301] = 11,
    ACTIONS(8640), 1,
      sym__conid,
    ACTIONS(19695), 1,
      sym__varid,
    ACTIONS(19699), 1,
      anon_sym_LPAREN,
    STATE(7733), 1,
      sym_constructor,
    STATE(8055), 1,
      sym_qualified_constructor,
    STATE(15368), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19697), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7994), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8107), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466343] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [466371] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [466397] = 11,
    ACTIONS(10046), 1,
      sym__conid,
    ACTIONS(19701), 1,
      sym__varid,
    ACTIONS(19703), 1,
      anon_sym_LPAREN,
    STATE(12279), 1,
      sym_constructor,
    STATE(13114), 1,
      sym_qualified_constructor,
    STATE(15581), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(10042), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12926), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13201), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466439] = 11,
    ACTIONS(9896), 1,
      sym__conid,
    ACTIONS(19705), 1,
      sym__varid,
    ACTIONS(19707), 1,
      anon_sym_LPAREN,
    STATE(11766), 1,
      sym_constructor,
    STATE(12622), 1,
      sym_qualified_constructor,
    STATE(15382), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9892), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12614), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(12678), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466481] = 11,
    ACTIONS(4453), 1,
      sym__conid,
    ACTIONS(19709), 1,
      sym__varid,
    ACTIONS(19711), 1,
      anon_sym_LPAREN,
    STATE(4898), 1,
      sym_constructor,
    STATE(5850), 1,
      sym_qualified_constructor,
    STATE(15569), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2906), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5403), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5840), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466523] = 11,
    ACTIONS(9708), 1,
      sym__conid,
    ACTIONS(19713), 1,
      sym__varid,
    ACTIONS(19715), 1,
      anon_sym_LPAREN,
    STATE(11329), 1,
      sym_constructor,
    STATE(11783), 1,
      sym_qualified_constructor,
    STATE(15397), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9704), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11853), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12041), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466565] = 11,
    ACTIONS(8562), 1,
      sym__conid,
    ACTIONS(19717), 1,
      sym__varid,
    ACTIONS(19721), 1,
      anon_sym_LPAREN,
    STATE(7717), 1,
      sym_constructor,
    STATE(8060), 1,
      sym_qualified_constructor,
    STATE(15404), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19719), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7908), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8137), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466607] = 11,
    ACTIONS(8111), 1,
      sym__conid,
    ACTIONS(19723), 1,
      sym__varid,
    ACTIONS(19727), 1,
      anon_sym_LPAREN,
    STATE(4648), 1,
      sym_constructor,
    STATE(5153), 1,
      sym_qualified_constructor,
    STATE(15560), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19725), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4907), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4985), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466649] = 11,
    ACTIONS(4583), 1,
      sym__conid,
    ACTIONS(19729), 1,
      sym__varid,
    ACTIONS(19731), 1,
      anon_sym_LPAREN,
    STATE(4599), 1,
      sym_constructor,
    STATE(5112), 1,
      sym_qualified_constructor,
    STATE(15415), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(2350), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4918), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5013), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466691] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18016), 1,
      sym_guards,
    STATE(10783), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [466721] = 6,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18217), 1,
      sym_guards,
    STATE(11495), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [466753] = 11,
    ACTIONS(8043), 1,
      sym__conid,
    ACTIONS(19733), 1,
      sym__varid,
    ACTIONS(19737), 1,
      anon_sym_LPAREN,
    STATE(6480), 1,
      sym_constructor,
    STATE(6992), 1,
      sym_qualified_constructor,
    STATE(15542), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19735), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6698), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6840), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466795] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18817), 1,
      sym_guards,
    STATE(11403), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [466825] = 11,
    ACTIONS(9322), 1,
      sym__conid,
    ACTIONS(19739), 1,
      sym__varid,
    ACTIONS(19741), 1,
      anon_sym_LPAREN,
    STATE(11854), 1,
      sym_constructor,
    STATE(12691), 1,
      sym_qualified_constructor,
    STATE(15424), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9318), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12358), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(12748), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466867] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 14,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [466893] = 5,
    ACTIONS(17009), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15456), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [466923] = 11,
    ACTIONS(8121), 1,
      sym__conid,
    ACTIONS(19743), 1,
      sym__varid,
    ACTIONS(19747), 1,
      anon_sym_LPAREN,
    STATE(5411), 1,
      sym_constructor,
    STATE(6218), 1,
      sym_qualified_constructor,
    STATE(15444), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19745), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6026), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6146), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466965] = 14,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(18890), 1,
      anon_sym_LPAREN,
    ACTIONS(18896), 1,
      anon_sym_module,
    ACTIONS(19749), 1,
      anon_sym_RPAREN,
    STATE(15065), 1,
      sym_namespace,
    STATE(15110), 1,
      aux_sym__qualifying_module,
    STATE(15933), 1,
      sym_constructor,
    STATE(17824), 1,
      sym_qualified_type,
    STATE(21011), 1,
      sym_export,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(20935), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467013] = 5,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(17011), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16950), 6,
      sym__varsym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [467043] = 11,
    ACTIONS(12450), 1,
      sym__conid,
    ACTIONS(19751), 1,
      sym__varid,
    ACTIONS(19755), 1,
      anon_sym_LPAREN,
    STATE(8878), 1,
      sym_constructor,
    STATE(8891), 1,
      sym_qualified_constructor,
    STATE(15377), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19753), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8944), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9272), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467085] = 11,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(19757), 1,
      sym__varid,
    ACTIONS(19759), 1,
      anon_sym_LPAREN,
    STATE(11179), 1,
      sym_constructor,
    STATE(12088), 1,
      sym_qualified_constructor,
    STATE(15523), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(9548), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11899), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(12040), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467127] = 11,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(19761), 1,
      sym__varid,
    ACTIONS(19765), 1,
      anon_sym_LPAREN,
    STATE(8469), 1,
      sym_constructor,
    STATE(8486), 1,
      sym_qualified_constructor,
    STATE(15484), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19763), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8580), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8690), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467169] = 10,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(2429), 1,
      sym__colon2,
    STATE(13473), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(15336), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19038), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(18952), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467209] = 11,
    ACTIONS(13205), 1,
      sym__conid,
    ACTIONS(19767), 1,
      sym__varid,
    ACTIONS(19771), 1,
      anon_sym_LPAREN,
    STATE(8270), 1,
      sym_constructor,
    STATE(8374), 1,
      sym_qualified_constructor,
    STATE(15577), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19769), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8530), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8699), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467251] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467276] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467301] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467328] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467353] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467378] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467403] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467428] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19773), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467455] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467480] = 6,
    ACTIONS(15483), 1,
      anon_sym_DASH,
    ACTIONS(19775), 1,
      anon_sym_LBRACE,
    ACTIONS(19778), 1,
      sym__layout_start,
    STATE(12931), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467511] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467536] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467561] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467586] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467611] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467636] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467663] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467688] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467713] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467738] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(17969), 1,
      sym_guards,
    STATE(11547), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467767] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [467794] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467821] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [467846] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467871] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467896] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467921] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [467948] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [467973] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467998] = 5,
    ACTIONS(19780), 1,
      anon_sym_LBRACE,
    ACTIONS(19782), 1,
      sym__layout_start,
    STATE(13460), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468027] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468052] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468077] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [468102] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468127] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468152] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468177] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468204] = 5,
    ACTIONS(19784), 1,
      anon_sym_LBRACE,
    ACTIONS(19786), 1,
      sym__layout_start,
    STATE(13549), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [468233] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468258] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18385), 1,
      sym_guards,
    STATE(11970), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468287] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [468312] = 5,
    ACTIONS(19788), 1,
      anon_sym_LBRACE,
    ACTIONS(19791), 1,
      sym__layout_start,
    STATE(13084), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468341] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468366] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468391] = 5,
    ACTIONS(17046), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15456), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468420] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468447] = 4,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15523), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468474] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468499] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468524] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468549] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [468576] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468601] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468626] = 5,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(16983), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15515), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [468655] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [468680] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468705] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468730] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468755] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468780] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [468805] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468830] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468855] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468880] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [468905] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [468930] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [468955] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [468980] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469005] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17146), 1,
      anon_sym_BQUOTE,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(19793), 1,
      sym__tyconsym,
    STATE(14622), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10648), 7,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
  [469042] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469067] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [469092] = 5,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16985), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16987), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469121] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469146] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469171] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469196] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [469221] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [469246] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469271] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469296] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469321] = 5,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16927), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469350] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469375] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [469400] = 4,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16996), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469427] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469452] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469477] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469502] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [469527] = 4,
    ACTIONS(19795), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469554] = 4,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469581] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469606] = 5,
    ACTIONS(19791), 1,
      sym__layout_start,
    ACTIONS(19797), 1,
      anon_sym_LBRACE,
    STATE(13361), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469635] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469660] = 3,
    ACTIONS(15898), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469685] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [469710] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469735] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(17969), 1,
      sym_guards,
    STATE(11547), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469764] = 4,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16987), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469791] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469816] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [469841] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469866] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469891] = 3,
    ACTIONS(15894), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469916] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [469941] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [469966] = 3,
    ACTIONS(15876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469991] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470016] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 12,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [470041] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470066] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470091] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470116] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470141] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470166] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470191] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470216] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470241] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470266] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470291] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470316] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470341] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [470368] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470393] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470418] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470443] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470468] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470493] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470518] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470543] = 5,
    ACTIONS(19799), 1,
      anon_sym_LBRACE,
    ACTIONS(19802), 1,
      sym__layout_start,
    STATE(13119), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [470572] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470597] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470622] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470647] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470672] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470697] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470722] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470747] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470772] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470797] = 5,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16983), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15523), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [470826] = 5,
    ACTIONS(19804), 1,
      anon_sym_LBRACE,
    ACTIONS(19807), 1,
      sym__layout_start,
    STATE(12818), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470855] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470880] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [470905] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470930] = 5,
    ACTIONS(19807), 1,
      sym__layout_start,
    ACTIONS(19809), 1,
      anon_sym_LBRACE,
    STATE(13281), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470959] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [470984] = 3,
    ACTIONS(15830), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471009] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471034] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471059] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471084] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471109] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471134] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471159] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471184] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [471209] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471234] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16999), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471263] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471288] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16994), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16996), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471317] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [471342] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471367] = 3,
    ACTIONS(15822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471392] = 5,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16930), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16927), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471421] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471446] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471471] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471496] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471521] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [471546] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [471571] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471596] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471621] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471646] = 3,
    ACTIONS(15818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471671] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [471698] = 3,
    ACTIONS(15814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471723] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [471748] = 3,
    ACTIONS(15782), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471773] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471798] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471823] = 3,
    ACTIONS(15778), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471848] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [471873] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [471898] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471923] = 3,
    ACTIONS(15339), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 12,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471948] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [471973] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472000] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [472025] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [472050] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [472077] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472102] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472127] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472152] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [472177] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [472204] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [472229] = 5,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(16930), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15448), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [472258] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [472283] = 3,
    ACTIONS(15756), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472308] = 3,
    ACTIONS(15726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472333] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472358] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(16994), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16992), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [472387] = 4,
    ACTIONS(17150), 1,
      anon_sym_DASH,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [472414] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [472439] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(10390), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(16992), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [472468] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [472493] = 3,
    ACTIONS(15722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472518] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472543] = 3,
    ACTIONS(15718), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472568] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472593] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472620] = 3,
    ACTIONS(15696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472645] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472670] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472695] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472720] = 3,
    ACTIONS(15692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472745] = 6,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(16971), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472776] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472801] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472826] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472851] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [472876] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472901] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [472926] = 3,
    ACTIONS(15670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472951] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [472976] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473001] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [473026] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [473053] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473078] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [473105] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473130] = 5,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(16985), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(15664), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [473159] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473184] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473209] = 3,
    ACTIONS(15774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473234] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 13,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [473259] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [473286] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473311] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [473336] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473361] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [473388] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 13,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [473413] = 13,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(18890), 1,
      anon_sym_LPAREN,
    ACTIONS(18896), 1,
      anon_sym_module,
    STATE(15065), 1,
      sym_namespace,
    STATE(15110), 1,
      aux_sym__qualifying_module,
    STATE(15933), 1,
      sym_constructor,
    STATE(17824), 1,
      sym_qualified_type,
    STATE(21011), 1,
      sym_export,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(20935), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473458] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [473485] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473510] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 12,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [473535] = 6,
    ACTIONS(18545), 1,
      anon_sym_DASH,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18302), 1,
      sym_guards,
    STATE(11772), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 9,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [473566] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473591] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473616] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473641] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [473668] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473693] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473718] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [473743] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473768] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473793] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [473818] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [473843] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473870] = 3,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [473895] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18997), 1,
      sym_guards,
    STATE(11786), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [473924] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [473949] = 5,
    ACTIONS(19811), 1,
      anon_sym_LBRACE,
    ACTIONS(19814), 1,
      sym__layout_start,
    STATE(12987), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [473978] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474003] = 3,
    ACTIONS(18622), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [474028] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [474053] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [474078] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [474103] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [474128] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [474153] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474178] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474203] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [474228] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [474253] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474278] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474303] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474328] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [474355] = 10,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    STATE(2506), 1,
      sym__colon2,
    STATE(13818), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(18982), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16149), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(21185), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474394] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474419] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [474444] = 5,
    ACTIONS(19782), 1,
      sym__layout_start,
    ACTIONS(19822), 1,
      anon_sym_LBRACE,
    STATE(12812), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474473] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474498] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 13,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [474523] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474548] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474573] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474598] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474623] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [474648] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474673] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [474698] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474723] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474748] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [474773] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474798] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474823] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [474848] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474873] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [474898] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [474923] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474950] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [474975] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475000] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475025] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [475050] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475075] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475100] = 6,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(15448), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15456), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [475131] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475156] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475181] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475206] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475231] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475256] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475281] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475306] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475331] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475356] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475381] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475406] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [475433] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475458] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [475483] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [475508] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475533] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [475560] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475585] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475610] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475635] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [475662] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [475687] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475712] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [475737] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [475762] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475787] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475812] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475837] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475862] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [475887] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475912] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [475937] = 5,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15456), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [475966] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [475991] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476016] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476041] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476066] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [476091] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476116] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476141] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476166] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476191] = 5,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16983), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15523), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [476220] = 5,
    ACTIONS(19825), 1,
      anon_sym_LBRACE,
    ACTIONS(19827), 1,
      sym__layout_start,
    STATE(13339), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [476249] = 3,
    ACTIONS(15547), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [476274] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [476301] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [476326] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476351] = 10,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    STATE(2506), 1,
      sym__colon2,
    STATE(13764), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(19038), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16035), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(21089), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476390] = 3,
    ACTIONS(15339), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 12,
      sym__dot,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [476415] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [476440] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476465] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476490] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476515] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476540] = 3,
    ACTIONS(18557), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [476565] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476590] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476615] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476640] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476665] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476690] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476715] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [476740] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [476765] = 10,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    STATE(2506), 1,
      sym__colon2,
    STATE(13762), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(19038), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(15937), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(21022), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476804] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476829] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [476854] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [476879] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [476904] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476929] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476954] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [476979] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477004] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477029] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [477054] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477079] = 6,
    ACTIONS(17046), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16971), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [477110] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477135] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477160] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [477185] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477210] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477235] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [477260] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [477285] = 10,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    STATE(2506), 1,
      sym__colon2,
    STATE(13700), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(19111), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(15927), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(20952), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477324] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477349] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477374] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(17969), 1,
      sym_guards,
    STATE(11547), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [477403] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477430] = 6,
    ACTIONS(18505), 1,
      anon_sym_DASH,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18302), 1,
      sym_guards,
    STATE(11772), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 9,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [477461] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477486] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477511] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477536] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [477561] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [477586] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477611] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19829), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [477638] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [477663] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [477688] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477713] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477738] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477763] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477788] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477813] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477838] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [477863] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [477888] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477913] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477938] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [477963] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [477988] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [478013] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478038] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478063] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478088] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478113] = 5,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16930), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16927), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478142] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16994), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16996), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478171] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [478196] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [478221] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(19831), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3157), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 6,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [478258] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18385), 1,
      sym_guards,
    STATE(11970), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478287] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478312] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [478337] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [478362] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478389] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [478414] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [478439] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [478464] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16992), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16999), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478493] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [478518] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478543] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478568] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [478593] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [478618] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [478643] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18385), 1,
      sym_guards,
    STATE(11970), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478672] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 13,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [478697] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478724] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [478749] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [478774] = 6,
    ACTIONS(18515), 1,
      anon_sym_DASH,
    ACTIONS(19778), 1,
      sym__layout_start,
    ACTIONS(19833), 1,
      anon_sym_LBRACE,
    STATE(13554), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [478805] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478832] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478857] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19835), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478884] = 5,
    ACTIONS(19814), 1,
      sym__layout_start,
    ACTIONS(19837), 1,
      anon_sym_LBRACE,
    STATE(13359), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [478913] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [478940] = 5,
    ACTIONS(19827), 1,
      sym__layout_start,
    ACTIONS(19839), 1,
      anon_sym_LBRACE,
    STATE(12935), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [478969] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [478994] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [479021] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [479046] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [479073] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479098] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479123] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479148] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479173] = 5,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(16985), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16987), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [479202] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [479227] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3179), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 7,
      sym__varsym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [479262] = 6,
    ACTIONS(17086), 1,
      anon_sym_AT2,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16971), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15456), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [479293] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479318] = 5,
    ACTIONS(18507), 1,
      anon_sym_PIPE,
    STATE(18997), 1,
      sym_guards,
    STATE(11786), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479347] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479372] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479397] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479422] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479447] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479472] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [479497] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [479522] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [479547] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479572] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [479597] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479622] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479647] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479672] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [479697] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19842), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479724] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479749] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479774] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [479799] = 3,
    ACTIONS(15643), 3,
      sym__varid,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 11,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_PERCENT,
      anon_sym_EQ,
  [479824] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [479849] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [479874] = 5,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [479903] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18997), 1,
      sym_guards,
    STATE(11786), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479932] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [479957] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [479982] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480007] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480032] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480057] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [480082] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [480107] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480132] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [480157] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [480182] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480207] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [480232] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [480257] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480282] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480307] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480332] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480357] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480382] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480407] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480432] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480457] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480482] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [480507] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480532] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [480557] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [480582] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [480607] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480632] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480657] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [480682] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480707] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480732] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480757] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480782] = 5,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16983), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [480811] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480836] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480861] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [480886] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [480911] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [480936] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [480961] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [480986] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [481011] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [481036] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481061] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481086] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [481111] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [481136] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481161] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481186] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [481211] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481236] = 3,
    ACTIONS(19844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [481261] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481286] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [481313] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481338] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481363] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [481388] = 5,
    ACTIONS(19786), 1,
      sym__layout_start,
    ACTIONS(19846), 1,
      anon_sym_LBRACE,
    STATE(13110), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [481417] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [481442] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [481467] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481492] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(10390), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [481521] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [481546] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [481571] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481596] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481621] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481646] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481671] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [481696] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481721] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481746] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [481771] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481796] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481821] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481846] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481871] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481896] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481921] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [481946] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16994), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [481975] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [482000] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [482025] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [482050] = 5,
    ACTIONS(19802), 1,
      sym__layout_start,
    ACTIONS(19849), 1,
      anon_sym_LBRACE,
    STATE(13450), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [482079] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482104] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482129] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482154] = 6,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(16930), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [482185] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [482210] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482237] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [482262] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482287] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [482312] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482337] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [482362] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482387] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482412] = 5,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16985), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [482441] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [482466] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [482490] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [482514] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [482538] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482562] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [482586] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [482612] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [482636] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [482660] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482684] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482708] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 13,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [482730] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482754] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482778] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482802] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482826] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [482850] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [482874] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482898] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [482922] = 4,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15523), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [482948] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [482972] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [482996] = 3,
    ACTIONS(18557), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [483020] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [483044] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [483068] = 3,
    ACTIONS(15774), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [483092] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483116] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483140] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483164] = 3,
    ACTIONS(15559), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483188] = 5,
    ACTIONS(19851), 1,
      anon_sym_LBRACE,
    ACTIONS(19854), 1,
      sym__layout_start,
    STATE(13547), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483216] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483240] = 3,
    ACTIONS(15778), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [483264] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483288] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483312] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483336] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483360] = 4,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [483386] = 3,
    ACTIONS(15658), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [483410] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483434] = 3,
    ACTIONS(15658), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [483458] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483482] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483506] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [483530] = 4,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16987), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483556] = 5,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(17011), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [483584] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483608] = 5,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16927), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [483636] = 4,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16996), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [483662] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483686] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483710] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483734] = 3,
    ACTIONS(15692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483758] = 3,
    ACTIONS(15782), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [483782] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [483808] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [483832] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [483856] = 4,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [483882] = 3,
    ACTIONS(15597), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [483906] = 3,
    ACTIONS(15479), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483930] = 3,
    ACTIONS(15563), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483954] = 3,
    ACTIONS(15567), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [483978] = 5,
    ACTIONS(19856), 1,
      anon_sym_LBRACE,
    ACTIONS(19859), 1,
      sym__layout_start,
    STATE(13400), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [484006] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [484030] = 3,
    ACTIONS(15814), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [484054] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [484078] = 3,
    ACTIONS(15593), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484102] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484126] = 3,
    ACTIONS(15581), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [484150] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [484174] = 3,
    ACTIONS(15589), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484198] = 3,
    ACTIONS(15818), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [484222] = 3,
    ACTIONS(15609), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484246] = 3,
    ACTIONS(15611), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484270] = 3,
    ACTIONS(15615), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484294] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [484318] = 3,
    ACTIONS(15654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484342] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [484366] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [484390] = 4,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16987), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [484416] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484440] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484464] = 5,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16983), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [484492] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484516] = 3,
    ACTIONS(18557), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [484540] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [484564] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [484590] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [484616] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [484640] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484664] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [484688] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [484712] = 5,
    ACTIONS(19854), 1,
      sym__layout_start,
    ACTIONS(19861), 1,
      anon_sym_LBRACE,
    STATE(13738), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [484740] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [484764] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [484788] = 3,
    ACTIONS(15622), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484812] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [484836] = 3,
    ACTIONS(15626), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484860] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [484884] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484908] = 3,
    ACTIONS(15630), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484932] = 3,
    ACTIONS(15634), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484956] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [484980] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485004] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485028] = 3,
    ACTIONS(15577), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485052] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [485076] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [485100] = 3,
    ACTIONS(15585), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485124] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [485148] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [485172] = 4,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485198] = 3,
    ACTIONS(15543), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485222] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485244] = 3,
    ACTIONS(15573), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485268] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485292] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [485316] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [485340] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485364] = 3,
    ACTIONS(15822), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485388] = 4,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16996), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485414] = 5,
    ACTIONS(19859), 1,
      sym__layout_start,
    ACTIONS(19863), 1,
      anon_sym_LBRACE,
    STATE(13624), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [485442] = 5,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16927), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485470] = 3,
    ACTIONS(15569), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485494] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485518] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485542] = 3,
    ACTIONS(15551), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485566] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485590] = 3,
    ACTIONS(15508), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485614] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18217), 1,
      sym_guards,
    STATE(11495), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18503), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [485642] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485664] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485688] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [485712] = 3,
    ACTIONS(15826), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485736] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485760] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485784] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [485808] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [485832] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485856] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485880] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [485904] = 3,
    ACTIONS(15504), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485928] = 3,
    ACTIONS(15826), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [485952] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [485976] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486000] = 3,
    ACTIONS(15666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486024] = 3,
    ACTIONS(15830), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [486048] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [486072] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [486096] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486120] = 3,
    ACTIONS(15670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486144] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [486168] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486192] = 3,
    ACTIONS(15674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486216] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486240] = 3,
    ACTIONS(15722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486264] = 3,
    ACTIONS(15500), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [486288] = 3,
    ACTIONS(15696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486312] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486336] = 3,
    ACTIONS(15492), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [486360] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [486386] = 3,
    ACTIONS(15539), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [486410] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486434] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486458] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [486482] = 3,
    ACTIONS(15718), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486506] = 3,
    ACTIONS(15700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486530] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486554] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486578] = 3,
    ACTIONS(15726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486602] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486626] = 3,
    ACTIONS(15876), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [486650] = 3,
    ACTIONS(15756), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486674] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486698] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486722] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486746] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486770] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486794] = 10,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(19865), 1,
      anon_sym_DASH,
    ACTIONS(19867), 1,
      anon_sym_BQUOTE,
    ACTIONS(19869), 1,
      sym__varsym,
    ACTIONS(19871), 1,
      sym__consym,
    STATE(14142), 1,
      sym_integer,
    STATE(15905), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16918), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486832] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486856] = 3,
    ACTIONS(15601), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [486880] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486904] = 3,
    ACTIONS(15539), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486928] = 3,
    ACTIONS(15774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [486952] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19873), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [486978] = 3,
    ACTIONS(15778), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487002] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487026] = 3,
    ACTIONS(15658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487050] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19875), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487076] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487100] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487124] = 3,
    ACTIONS(15782), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487148] = 3,
    ACTIONS(15643), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487172] = 3,
    ACTIONS(15814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487196] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487220] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487244] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487268] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487292] = 3,
    ACTIONS(15818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487316] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487340] = 4,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15523), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487366] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487390] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487414] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [487438] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 13,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [487460] = 3,
    ACTIONS(15822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487484] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487508] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487532] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487556] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487580] = 3,
    ACTIONS(15403), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [487604] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487628] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487652] = 3,
    ACTIONS(15555), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [487676] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [487700] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487724] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487748] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487772] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487796] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487820] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487844] = 4,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 10,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [487870] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487894] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487918] = 3,
    ACTIONS(15826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487942] = 3,
    ACTIONS(15830), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [487966] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [487990] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488014] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488038] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [488062] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488086] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488110] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [488134] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [488158] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [488182] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [488206] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488230] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488254] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488278] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488302] = 3,
    ACTIONS(15894), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [488326] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488350] = 10,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(19877), 1,
      anon_sym_DASH,
    ACTIONS(19879), 1,
      anon_sym_BQUOTE,
    ACTIONS(19881), 1,
      sym__varsym,
    ACTIONS(19883), 1,
      sym__consym,
    STATE(14156), 1,
      sym_integer,
    STATE(15658), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16940), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488388] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488412] = 5,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(15664), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16987), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488440] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488464] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488488] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488512] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488536] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488560] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488584] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(19885), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [488610] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [488632] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [488656] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [488678] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488702] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [488726] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488750] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488774] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488798] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [488822] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(16992), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16999), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488850] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(16992), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16996), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488878] = 5,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(15448), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(16927), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [488906] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_PERCENT,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_via,
      anon_sym_deriving,
  [488928] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [488952] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [488976] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489000] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489024] = 3,
    ACTIONS(15876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489048] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489072] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489096] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489120] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489144] = 3,
    ACTIONS(15894), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489168] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489192] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [489238] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489262] = 5,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16985), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [489290] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489314] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489338] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489362] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [489386] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489410] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489434] = 3,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489458] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489482] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489506] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489530] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489554] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489578] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489602] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [489626] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489650] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489674] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [489698] = 3,
    ACTIONS(15898), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [489722] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489746] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489770] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489794] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489818] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [489842] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489866] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489890] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489914] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489938] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489962] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [489986] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19887), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490012] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490036] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490060] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490084] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490108] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [490132] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490156] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490180] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490204] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 12,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
      anon_sym_via,
      anon_sym_deriving,
  [490228] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490252] = 3,
    ACTIONS(15605), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490276] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490300] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490324] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490348] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [490372] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490396] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490420] = 3,
    ACTIONS(15898), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490444] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490468] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [490492] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490516] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [490540] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490564] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490588] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490612] = 5,
    ACTIONS(19889), 1,
      anon_sym_LBRACE,
    ACTIONS(19891), 1,
      sym__layout_start,
    STATE(13609), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490640] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490664] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [490688] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [490712] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [490736] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490760] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490784] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490808] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [490832] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490856] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490880] = 3,
    ACTIONS(19893), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [490904] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490928] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490952] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [490976] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491000] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491024] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491048] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [491072] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491096] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491120] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [491144] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491168] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [491192] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491216] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(19895), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3142), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [491252] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491276] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [491300] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491324] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491348] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491372] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [491396] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491420] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491444] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491468] = 5,
    ACTIONS(10390), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [491496] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [491520] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [491544] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491568] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491592] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491616] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491640] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491666] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491690] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491714] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491738] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [491784] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491808] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491832] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491856] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491880] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [491904] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [491928] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [491952] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [491976] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19897), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [492002] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16994), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [492030] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492054] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492078] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [492102] = 5,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(17013), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492130] = 6,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(16930), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [492160] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492184] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492208] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492232] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492256] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [492280] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492304] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492328] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492352] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492376] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492400] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492424] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19899), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [492450] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492474] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492498] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492522] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [492546] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 12,
      sym__layout_semicolon,
      sym__dot,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492570] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492594] = 10,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(19901), 1,
      anon_sym_DASH,
    ACTIONS(19903), 1,
      anon_sym_BQUOTE,
    ACTIONS(19905), 1,
      sym__varsym,
    ACTIONS(19907), 1,
      sym__consym,
    STATE(14239), 1,
      sym_integer,
    STATE(15834), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(17469), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492632] = 4,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [492658] = 3,
    ACTIONS(15492), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [492682] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492706] = 3,
    ACTIONS(15479), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [492730] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492754] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492778] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492802] = 3,
    ACTIONS(15563), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [492826] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492850] = 3,
    ACTIONS(15567), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [492874] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492898] = 3,
    ACTIONS(15597), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [492922] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492946] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492970] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [492994] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [493018] = 3,
    ACTIONS(15666), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493042] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [493066] = 3,
    ACTIONS(15559), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493090] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493114] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [493138] = 3,
    ACTIONS(15581), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493162] = 3,
    ACTIONS(15500), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493186] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493210] = 3,
    ACTIONS(15589), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493234] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [493258] = 3,
    ACTIONS(15504), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493282] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493306] = 3,
    ACTIONS(15611), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493330] = 3,
    ACTIONS(15615), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493354] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 12,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [493378] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [493402] = 3,
    ACTIONS(15508), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493426] = 4,
    ACTIONS(19909), 1,
      sym__immediate_dot,
    ACTIONS(15902), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493452] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [493476] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [493500] = 3,
    ACTIONS(15555), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493524] = 3,
    ACTIONS(15551), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493548] = 3,
    ACTIONS(15593), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493572] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [493596] = 3,
    ACTIONS(15654), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493620] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493644] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [493668] = 3,
    ACTIONS(15569), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493692] = 3,
    ACTIONS(15622), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493716] = 3,
    ACTIONS(15609), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493740] = 3,
    ACTIONS(15626), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493764] = 3,
    ACTIONS(15630), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493788] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493812] = 3,
    ACTIONS(19911), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493836] = 3,
    ACTIONS(15634), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493860] = 3,
    ACTIONS(15573), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493884] = 3,
    ACTIONS(15577), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [493908] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [493930] = 3,
    ACTIONS(15543), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [493954] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [493978] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494002] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494026] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [494050] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [494072] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494096] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494120] = 3,
    ACTIONS(15403), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494144] = 5,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(17011), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_DASH,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [494172] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [494194] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [494218] = 3,
    ACTIONS(15756), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [494242] = 3,
    ACTIONS(15585), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [494266] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494290] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494314] = 3,
    ACTIONS(15547), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [494338] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [494362] = 3,
    ACTIONS(15726), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [494386] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [494410] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494434] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494458] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494482] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494506] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [494530] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494554] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494578] = 5,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16985), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [494606] = 5,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(17013), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [494634] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494658] = 3,
    ACTIONS(15722), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [494682] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [494704] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [494728] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [494750] = 5,
    ACTIONS(10390), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [494778] = 5,
    ACTIONS(16990), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16994), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [494806] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494830] = 10,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(19913), 1,
      anon_sym_DASH,
    ACTIONS(19915), 1,
      anon_sym_BQUOTE,
    ACTIONS(19917), 1,
      sym__varsym,
    ACTIONS(19919), 1,
      sym__consym,
    STATE(14193), 1,
      sym_integer,
    STATE(15385), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15832), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494868] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [494892] = 3,
    ACTIONS(15700), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [494916] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494940] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494964] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [494988] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495012] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495036] = 3,
    ACTIONS(15718), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [495060] = 3,
    ACTIONS(15700), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [495084] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495108] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495132] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495156] = 6,
    ACTIONS(15463), 1,
      anon_sym_DASH,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(16930), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [495186] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495210] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495234] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495258] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495282] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495306] = 3,
    ACTIONS(15643), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [495330] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495354] = 5,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(15515), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(15523), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495382] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495406] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495430] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495454] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495478] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495502] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495526] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495550] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495574] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495598] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495622] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495646] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495670] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495694] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495718] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495742] = 3,
    ACTIONS(15662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495766] = 3,
    ACTIONS(19921), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [495790] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495814] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [495838] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495862] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495886] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495910] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495934] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495958] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [495982] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496006] = 5,
    ACTIONS(19891), 1,
      sym__layout_start,
    ACTIONS(19923), 1,
      anon_sym_LBRACE,
    STATE(13384), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496034] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496058] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496082] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [496106] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496130] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496154] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496178] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496202] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496226] = 3,
    ACTIONS(15696), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [496250] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496274] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [496298] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496322] = 3,
    ACTIONS(15662), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [496346] = 3,
    ACTIONS(15692), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [496370] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496394] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496418] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496442] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496466] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496490] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496514] = 3,
    ACTIONS(15674), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [496538] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [496564] = 5,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(16983), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [496592] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496616] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496640] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496664] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496688] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496712] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496736] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496760] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [496784] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(10390), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(16999), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [496812] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496836] = 3,
    ACTIONS(15463), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [496860] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496884] = 5,
    ACTIONS(16924), 1,
      anon_sym_LBRACE,
    ACTIONS(16930), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(16927), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [496912] = 5,
    ACTIONS(16990), 1,
      anon_sym_LBRACE,
    ACTIONS(16994), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16992), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(16996), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [496940] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [496962] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [496986] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497010] = 3,
    ACTIONS(15674), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [497034] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497058] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497082] = 5,
    ACTIONS(15530), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16983), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(15523), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [497110] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497134] = 3,
    ACTIONS(15670), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [497158] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497182] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497206] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497230] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497254] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497278] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497302] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15343), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [497328] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [497350] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497374] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497398] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497422] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497446] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497470] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [497492] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497516] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497540] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497564] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497588] = 3,
    ACTIONS(15666), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [497612] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15415), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [497638] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497662] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19926), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497688] = 3,
    ACTIONS(19928), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497712] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497736] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497760] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497784] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497808] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [497832] = 3,
    ACTIONS(15601), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [497856] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497880] = 5,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(16985), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(16987), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [497908] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [497932] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497956] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [497980] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498004] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498028] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498052] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [498076] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [498100] = 3,
    ACTIONS(15463), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [498124] = 3,
    ACTIONS(15530), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [498148] = 3,
    ACTIONS(15605), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [498172] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498196] = 10,
    ACTIONS(4865), 1,
      sym__integer_literal,
    ACTIONS(19930), 1,
      anon_sym_DASH,
    ACTIONS(19932), 1,
      anon_sym_BQUOTE,
    ACTIONS(19934), 1,
      sym__varsym,
    ACTIONS(19936), 1,
      sym__consym,
    STATE(14414), 1,
      sym_integer,
    STATE(16917), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(20030), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4867), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498234] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498258] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [498280] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [498302] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498326] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [498348] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498374] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [498398] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [498420] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19938), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [498446] = 5,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(16950), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(17013), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498473] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [498496] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [498517] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498540] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498563] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [498586] = 12,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(19946), 1,
      sym__tyconsym,
    STATE(13751), 1,
      sym_constructor,
    STATE(13848), 1,
      sym_type_variable,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(22737), 1,
      sym__simpletype,
    STATE(22739), 1,
      sym_annotated_type_variable,
    STATE(22746), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498627] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498650] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19948), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498675] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [498696] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498719] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498742] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(19950), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2673), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [498771] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498794] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [498815] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [498838] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [498861] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23017), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22097), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498898] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [498921] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [498944] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [498967] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [498990] = 3,
    ACTIONS(18557), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 11,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [499013] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499036] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [499059] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499082] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499105] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499128] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [499151] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499195] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499218] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22901), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21899), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499255] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499278] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499299] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [499322] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499345] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499368] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23164), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22232), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499405] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499428] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499451] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [499474] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499497] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499520] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [499543] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499566] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499589] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [499612] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499635] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499656] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499679] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [499702] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499725] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [499748] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499771] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22362), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22353), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499808] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [499831] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499854] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [499877] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [499898] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [499921] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [499944] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23020), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22802), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499981] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [500004] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500027] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500048] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500071] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500094] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500115] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500159] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500180] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500203] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500226] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500249] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500272] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [500293] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500316] = 3,
    ACTIONS(15597), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [500339] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500362] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500385] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500408] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500431] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [500454] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500477] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500500] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [500521] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [500544] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [500565] = 4,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [500590] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500613] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500636] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500657] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [500678] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500701] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23418), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22512), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500738] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500761] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500784] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22612), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21713), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500821] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500844] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500867] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [500890] = 5,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(17011), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 4,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [500917] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [500940] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [500965] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [500988] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501009] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501032] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [501055] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23354), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22674), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501092] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [501115] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [501138] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [501161] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [501182] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [501205] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [501228] = 3,
    ACTIONS(19952), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [501251] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [501274] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501295] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501318] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22245), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23236), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501355] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22531), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21501), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501413] = 12,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(19954), 1,
      sym__tyconsym,
    STATE(13751), 1,
      sym_constructor,
    STATE(13848), 1,
      sym_type_variable,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(22991), 1,
      sym__simpletype,
    STATE(23191), 1,
      sym_annotated_type_variable,
    STATE(23201), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501454] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(19956), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3146), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [501489] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [501512] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23180), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22845), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501549] = 4,
    ACTIONS(18586), 1,
      anon_sym_DASH,
    ACTIONS(19958), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501574] = 4,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501599] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [501622] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [501645] = 3,
    ACTIONS(19960), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [501668] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [501691] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [501714] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501735] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501758] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501781] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [501802] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22451), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21306), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501839] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [501862] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501885] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [501908] = 4,
    ACTIONS(10407), 1,
      anon_sym_LBRACE,
    STATE(13595), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [501933] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22374), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21819), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501970] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [501993] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23039), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23006), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502030] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502053] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22294), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22805), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502090] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502113] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22021), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23420), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502150] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502173] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502196] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502219] = 3,
    ACTIONS(15567), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502242] = 4,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 7,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [502267] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [502290] = 3,
    ACTIONS(16944), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502313] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502336] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502359] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502382] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502405] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502428] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502451] = 3,
    ACTIONS(15577), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502474] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [502497] = 3,
    ACTIONS(15593), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502520] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19962), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502545] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502568] = 3,
    ACTIONS(19964), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502591] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502614] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502637] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502660] = 6,
    ACTIONS(17192), 1,
      anon_sym_deriving,
    ACTIONS(19966), 1,
      sym__varid,
    ACTIONS(19968), 1,
      anon_sym_LPAREN,
    STATE(13156), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [502689] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502712] = 3,
    ACTIONS(15634), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502735] = 3,
    ACTIONS(15569), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502758] = 3,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502781] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502804] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502827] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [502850] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [502873] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502894] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502915] = 3,
    ACTIONS(15615), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502938] = 3,
    ACTIONS(15611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [502961] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [502982] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503005] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [503028] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503051] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [503074] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [503097] = 3,
    ACTIONS(15559), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503120] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [503143] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503166] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503189] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503212] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [503233] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503256] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [503279] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503302] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503325] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503348] = 3,
    ACTIONS(15543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503371] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22951), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23147), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503408] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503431] = 3,
    ACTIONS(15551), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503454] = 3,
    ACTIONS(19970), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [503477] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503500] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22130), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23003), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503537] = 12,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(19972), 1,
      sym__tyconsym,
    STATE(13751), 1,
      sym_constructor,
    STATE(13848), 1,
      sym_type_variable,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(23195), 1,
      sym__simpletype,
    STATE(23205), 1,
      sym_annotated_type_variable,
    STATE(22993), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503578] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503601] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [503622] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [503645] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503668] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503691] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [503714] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [503737] = 5,
    ACTIONS(19974), 1,
      anon_sym_LBRACE,
    ACTIONS(19976), 1,
      sym__layout_start,
    STATE(13969), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18513), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503764] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [503785] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503808] = 6,
    ACTIONS(19980), 1,
      sym__varid,
    ACTIONS(19982), 1,
      anon_sym_LPAREN,
    ACTIONS(19984), 1,
      anon_sym_deriving,
    STATE(13099), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19978), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [503837] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [503858] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [503879] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503902] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503925] = 3,
    ACTIONS(15504), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503948] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [503971] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [503994] = 3,
    ACTIONS(15622), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504017] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504040] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21949), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22830), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504077] = 3,
    ACTIONS(15581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504100] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504121] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504142] = 3,
    ACTIONS(15500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504165] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504188] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504211] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [504232] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504255] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504276] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504299] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504320] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504343] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504366] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [504389] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504412] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504435] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504458] = 3,
    ACTIONS(15539), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504481] = 5,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(17011), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [504508] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504531] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504554] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504577] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(19986), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504602] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [504625] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [504648] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 11,
      sym__dot,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [504671] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [504694] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504717] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504740] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504763] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504786] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [504809] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21510), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22792), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504846] = 12,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(19988), 1,
      sym__tyconsym,
    STATE(13751), 1,
      sym_constructor,
    STATE(13848), 1,
      sym_type_variable,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(22800), 1,
      sym__simpletype,
    STATE(23216), 1,
      sym_annotated_type_variable,
    STATE(22801), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504887] = 5,
    ACTIONS(19976), 1,
      sym__layout_start,
    ACTIONS(19990), 1,
      anon_sym_LBRACE,
    STATE(13804), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [504914] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [504935] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [504958] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [504981] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21744), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21303), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505018] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [505041] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505062] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505083] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505106] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505129] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [505152] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [505175] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [505196] = 6,
    ACTIONS(17176), 1,
      anon_sym_deriving,
    ACTIONS(19966), 1,
      sym__varid,
    ACTIONS(19968), 1,
      anon_sym_LPAREN,
    STATE(13211), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [505225] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [505248] = 3,
    ACTIONS(15573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505271] = 3,
    ACTIONS(15563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505294] = 3,
    ACTIONS(15479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505317] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505340] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [505363] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [505386] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505409] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505432] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505455] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505476] = 3,
    ACTIONS(15589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505499] = 3,
    ACTIONS(15609), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505522] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505543] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [505566] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505589] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(19993), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3145), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 4,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [505624] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505647] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [505672] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [505695] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [505716] = 6,
    ACTIONS(17176), 1,
      anon_sym_deriving,
    ACTIONS(19980), 1,
      sym__varid,
    ACTIONS(19982), 1,
      anon_sym_LPAREN,
    STATE(12995), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [505745] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505766] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505789] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [505812] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [505835] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [505858] = 3,
    ACTIONS(16868), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505881] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21380), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21431), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505918] = 3,
    ACTIONS(16872), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [505941] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [505964] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22889), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22417), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506001] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(19995), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3173), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
  [506036] = 3,
    ACTIONS(16876), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506059] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [506082] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [506103] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [506124] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [506145] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506168] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [506189] = 3,
    ACTIONS(16880), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506212] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [506233] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22864), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23347), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506270] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21352), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21589), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506307] = 3,
    ACTIONS(16884), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506330] = 6,
    ACTIONS(19999), 1,
      sym__varid,
    ACTIONS(20002), 1,
      anon_sym_LPAREN,
    ACTIONS(20005), 1,
      anon_sym_deriving,
    STATE(13099), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19997), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [506359] = 3,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506382] = 3,
    ACTIONS(15654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [506405] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506426] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [506449] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [506470] = 10,
    ACTIONS(20009), 1,
      anon_sym_DASH,
    ACTIONS(20011), 1,
      anon_sym_BQUOTE,
    ACTIONS(20015), 1,
      sym__varsym,
    STATE(2475), 1,
      sym__colon2,
    STATE(3156), 1,
      sym_varop,
    STATE(20433), 1,
      sym__type_annotation,
    ACTIONS(20007), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20013), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(10510), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506507] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506530] = 3,
    ACTIONS(16888), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506553] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [506574] = 3,
    ACTIONS(16892), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506597] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [506620] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [506643] = 3,
    ACTIONS(16896), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506666] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [506689] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [506712] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [506735] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22096), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22684), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506772] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [506795] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506818] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [506841] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [506864] = 3,
    ACTIONS(16900), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506887] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [506910] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [506933] = 3,
    ACTIONS(16904), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [506956] = 12,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20017), 1,
      sym__tyconsym,
    STATE(13751), 1,
      sym_constructor,
    STATE(13848), 1,
      sym_type_variable,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(22547), 1,
      sym__simpletype,
    STATE(23224), 1,
      sym_annotated_type_variable,
    STATE(22671), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506997] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22808), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(23116), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507034] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [507057] = 3,
    ACTIONS(16908), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507080] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507103] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507126] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507149] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507172] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [507195] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507218] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(20019), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3139), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [507253] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21612), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21895), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507290] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507311] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507334] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507357] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507380] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507403] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507426] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507449] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [507470] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [507491] = 3,
    ACTIONS(15492), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507514] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [507537] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [507560] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22065), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21457), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507597] = 3,
    ACTIONS(16940), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507620] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [507643] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22763), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22561), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507680] = 12,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20021), 1,
      sym__tyconsym,
    STATE(13751), 1,
      sym_constructor,
    STATE(13848), 1,
      sym_type_variable,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(22670), 1,
      sym__simpletype,
    STATE(23231), 1,
      sym_annotated_type_variable,
    STATE(22553), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507721] = 3,
    ACTIONS(15601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [507744] = 3,
    ACTIONS(16912), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [507767] = 6,
    ACTIONS(19966), 1,
      sym__varid,
    ACTIONS(19968), 1,
      anon_sym_LPAREN,
    ACTIONS(20025), 1,
      anon_sym_deriving,
    STATE(13188), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20023), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [507796] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [507819] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [507842] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [507865] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507888] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [507911] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [507934] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21370), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22446), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507971] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [507992] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [508013] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [508036] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22442), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21460), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508073] = 3,
    ACTIONS(16916), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508096] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [508119] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508142] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508165] = 3,
    ACTIONS(16920), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508188] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508211] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23323), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22942), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508248] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508271] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508294] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508317] = 3,
    ACTIONS(18622), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508340] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508363] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [508386] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508409] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [508430] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [508453] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [508476] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [508499] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21350), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21760), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508536] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(20027), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3184), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19130), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [508571] = 6,
    ACTIONS(20005), 1,
      anon_sym_deriving,
    ACTIONS(20029), 1,
      sym__varid,
    ACTIONS(20032), 1,
      anon_sym_LPAREN,
    STATE(13188), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19997), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [508600] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20035), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2661), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 6,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [508629] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(21482), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22342), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508666] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23227), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22754), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508703] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [508724] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [508747] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23131), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21710), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508784] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [508807] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508830] = 3,
    ACTIONS(15585), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508853] = 3,
    ACTIONS(20037), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [508876] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22345), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22230), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508913] = 6,
    ACTIONS(17192), 1,
      anon_sym_deriving,
    ACTIONS(19980), 1,
      sym__varid,
    ACTIONS(19982), 1,
      anon_sym_LPAREN,
    STATE(13245), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [508942] = 3,
    ACTIONS(15463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [508965] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [508988] = 3,
    ACTIONS(20039), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509011] = 3,
    ACTIONS(15547), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509034] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509057] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22456), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22574), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509094] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509115] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23396), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21937), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509152] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509173] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509194] = 6,
    ACTIONS(19966), 1,
      sym__varid,
    ACTIONS(19968), 1,
      anon_sym_LPAREN,
    ACTIONS(19984), 1,
      anon_sym_deriving,
    STATE(13188), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19978), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [509223] = 3,
    ACTIONS(15508), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [509246] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509269] = 5,
    ACTIONS(16948), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(17011), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(16950), 3,
      sym__varsym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17013), 5,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [509296] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22654), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(21897), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509333] = 3,
    ACTIONS(15643), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509356] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509379] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509400] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20041), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2703), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [509429] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [509452] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509475] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509496] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509517] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509540] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509563] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [509584] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509607] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509628] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [509651] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509674] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22280), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22430), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509711] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [509732] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509753] = 3,
    ACTIONS(15530), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [509776] = 3,
    ACTIONS(15605), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [509799] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22161), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22053), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509836] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509859] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509882] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509903] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [509926] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509949] = 3,
    ACTIONS(16936), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [509972] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [509995] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22321), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22308), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510032] = 6,
    ACTIONS(19980), 1,
      sym__varid,
    ACTIONS(19982), 1,
      anon_sym_LPAREN,
    ACTIONS(20025), 1,
      anon_sym_deriving,
    STATE(13099), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20023), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [510061] = 3,
    ACTIONS(20043), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510084] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20045), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2685), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [510113] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510136] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [510159] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510182] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510205] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510228] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(22274), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22187), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510265] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13795), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(23114), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(22109), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510302] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [510325] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [510346] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [510367] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510390] = 3,
    ACTIONS(15643), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_PERCENT,
      anon_sym_EQ,
  [510413] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20047), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2728), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [510441] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510461] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510483] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20051), 1,
      anon_sym_RBRACE,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18330), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510521] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510543] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15668), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510565] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510585] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20055), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18174), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510623] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510643] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [510665] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [510685] = 3,
    ACTIONS(15670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15672), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510707] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510727] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510747] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510767] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [510791] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [510811] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510853] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20057), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19186), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510891] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510911] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [510931] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510951] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510971] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [510993] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511013] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [511033] = 12,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20059), 1,
      sym__varid,
    ACTIONS(20061), 1,
      anon_sym_family,
    ACTIONS(20063), 1,
      anon_sym_instance,
    ACTIONS(20065), 1,
      anon_sym_role,
    ACTIONS(20067), 1,
      anon_sym_data,
    STATE(13751), 1,
      sym_constructor,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15596), 1,
      sym_type_variable,
    STATE(15968), 1,
      sym__simpletype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511073] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511095] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511115] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511137] = 3,
    ACTIONS(15692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15694), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511159] = 3,
    ACTIONS(18701), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511181] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511201] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511221] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511241] = 3,
    ACTIONS(15696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15698), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511263] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20069), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2756), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [511291] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20071), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19642), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511329] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [511351] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511373] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511393] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [511415] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511435] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20073), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18535), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511473] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [511493] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [511515] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [511535] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511557] = 3,
    ACTIONS(20075), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [511579] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [511599] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511621] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [511643] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511663] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511685] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [511705] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511727] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511747] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511769] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511789] = 3,
    ACTIONS(15718), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15720), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511811] = 3,
    ACTIONS(15700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15702), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511833] = 3,
    ACTIONS(18628), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511855] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20077), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19811), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511893] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511913] = 3,
    ACTIONS(15894), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15896), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511935] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [511955] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [511975] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15724), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [511997] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512017] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512037] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512057] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512077] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [512099] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512121] = 3,
    ACTIONS(15726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15728), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512143] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [512163] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15758), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512185] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20079), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18434), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512223] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512243] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512265] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [512285] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20081), 1,
      sym__tyconsym,
    STATE(14901), 1,
      sym_constructor,
    STATE(14947), 1,
      aux_sym__qualifying_module,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(21914), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [512317] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512337] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512357] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512377] = 11,
    ACTIONS(259), 1,
      sym__conid,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3739), 1,
      sym_constructor,
    STATE(3790), 1,
      sym_variable,
    STATE(14408), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(22112), 1,
      sym_constructor_operator,
    STATE(23053), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512415] = 3,
    ACTIONS(18641), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512437] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20083), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19021), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512475] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20085), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19338), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512513] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [512533] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20087), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2714), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [512561] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [512581] = 7,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(15347), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20089), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(19967), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512611] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [512631] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [512653] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20091), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19477), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512691] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20093), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2607), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [512719] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512739] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [512759] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20095), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(17909), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512797] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512817] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [512837] = 3,
    ACTIONS(15674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15676), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512859] = 3,
    ACTIONS(18614), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [512881] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [512901] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [512923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [512943] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512965] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [512987] = 4,
    ACTIONS(10703), 1,
      anon_sym_LBRACE,
    STATE(14045), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [513011] = 7,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(15418), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20097), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17915), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513041] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513063] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [513083] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [513103] = 6,
    ACTIONS(19984), 1,
      anon_sym_deriving,
    ACTIONS(20099), 1,
      sym__varid,
    ACTIONS(20101), 1,
      anon_sym_LPAREN,
    STATE(13408), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19978), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [513131] = 3,
    ACTIONS(15876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15878), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513153] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [513173] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513195] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 10,
      sym__dot,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [513217] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [513239] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [513261] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [513281] = 8,
    ACTIONS(20105), 1,
      anon_sym_EQ,
    STATE(2429), 1,
      sym__colon2,
    STATE(15034), 1,
      sym_tyfam_result_type,
    STATE(17463), 1,
      sym__type_annotation,
    STATE(17464), 1,
      sym__tyfam_inj,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20103), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [513313] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513335] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513357] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [513377] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [513399] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [513421] = 6,
    ACTIONS(17192), 1,
      anon_sym_deriving,
    ACTIONS(20099), 1,
      sym__varid,
    ACTIONS(20101), 1,
      anon_sym_LPAREN,
    STATE(13474), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [513449] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513469] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513491] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20107), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18871), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513529] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513551] = 11,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    ACTIONS(20109), 1,
      sym__tyconsym,
    STATE(14230), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22112), 1,
      sym_constructor_operator,
    STATE(22604), 1,
      sym__modid,
    STATE(22525), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513589] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20111), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18657), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513627] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [513647] = 4,
    ACTIONS(10604), 1,
      anon_sym_LBRACE,
    STATE(14001), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [513671] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [513693] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20113), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18475), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513731] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [513753] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513775] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [513795] = 3,
    ACTIONS(20115), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513817] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513839] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513859] = 3,
    ACTIONS(15662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15664), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [513881] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20117), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19996), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513919] = 6,
    ACTIONS(20005), 1,
      anon_sym_deriving,
    ACTIONS(20119), 1,
      sym__varid,
    ACTIONS(20122), 1,
      anon_sym_LPAREN,
    STATE(13408), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19997), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [513947] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [513969] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [513989] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514009] = 7,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(15093), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20097), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(19431), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514039] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20125), 1,
      sym__tyconsym,
    STATE(14901), 1,
      sym_constructor,
    STATE(14947), 1,
      aux_sym__qualifying_module,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(22940), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [514071] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514093] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514113] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [514133] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514153] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514173] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20127), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2730), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [514201] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514221] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514243] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514265] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [514285] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [514305] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514327] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20129), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18734), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514365] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514385] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20131), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2719), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [514413] = 12,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20059), 1,
      sym__varid,
    ACTIONS(20133), 1,
      anon_sym_family,
    ACTIONS(20135), 1,
      anon_sym_instance,
    ACTIONS(20137), 1,
      anon_sym_role,
    ACTIONS(20139), 1,
      anon_sym_data,
    STATE(13751), 1,
      sym_constructor,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15596), 1,
      sym_type_variable,
    STATE(15742), 1,
      sym__simpletype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514453] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20141), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19272), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514491] = 7,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(15572), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20097), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17996), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514521] = 3,
    ACTIONS(18663), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514543] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514565] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514587] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514607] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [514627] = 3,
    ACTIONS(18667), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [514669] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20143), 1,
      sym__tyconsym,
    STATE(14901), 1,
      sym_constructor,
    STATE(14947), 1,
      aux_sym__qualifying_module,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(22233), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [514701] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514721] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20145), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2649), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [514749] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20147), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18482), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514787] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514807] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [514827] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15832), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514849] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [514869] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20149), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19520), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514907] = 3,
    ACTIONS(18622), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [514929] = 7,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(14996), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20089), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(18094), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514959] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [514979] = 3,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15828), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515001] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [515021] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515043] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515065] = 3,
    ACTIONS(20151), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515087] = 7,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(15606), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20153), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(19014), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515117] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20155), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18750), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515155] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(20157), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3152), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(19130), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515189] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [515209] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [515229] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 11,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [515249] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [515271] = 3,
    ACTIONS(18689), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [515293] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [515313] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(20159), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3151), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(19130), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515347] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515367] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515387] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20161), 1,
      sym__tyconsym,
    STATE(14901), 1,
      sym_constructor,
    STATE(14947), 1,
      aux_sym__qualifying_module,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(23143), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [515419] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [515439] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [515461] = 3,
    ACTIONS(15774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15776), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515483] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515503] = 7,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    ACTIONS(19221), 1,
      sym_where,
    STATE(15536), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20097), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(19888), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515533] = 6,
    ACTIONS(20025), 1,
      anon_sym_deriving,
    ACTIONS(20099), 1,
      sym__varid,
    ACTIONS(20101), 1,
      anon_sym_LPAREN,
    STATE(13408), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20023), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [515561] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20163), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18259), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515599] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20165), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19090), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515637] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20167), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(20142), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515675] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [515695] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20169), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18346), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515733] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515753] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [515775] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [515795] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515815] = 12,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20059), 1,
      sym__varid,
    ACTIONS(20171), 1,
      anon_sym_family,
    ACTIONS(20173), 1,
      anon_sym_instance,
    ACTIONS(20175), 1,
      anon_sym_role,
    ACTIONS(20177), 1,
      anon_sym_data,
    STATE(13751), 1,
      sym_constructor,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15596), 1,
      sym_type_variable,
    STATE(16056), 1,
      sym__simpletype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515855] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515875] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [515895] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [515915] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [515935] = 3,
    ACTIONS(18659), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [515957] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [515979] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 11,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_AT2,
  [515999] = 3,
    ACTIONS(18705), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516021] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [516043] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516063] = 8,
    ACTIONS(20179), 1,
      anon_sym_EQ,
    STATE(2464), 1,
      sym__colon2,
    STATE(15583), 1,
      sym_tyfam_result_type,
    STATE(16866), 1,
      sym__type_annotation,
    STATE(16868), 1,
      sym__tyfam_inj,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [516095] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516115] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [516135] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516155] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [516179] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20181), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18597), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516217] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516237] = 3,
    ACTIONS(18671), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516259] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [516279] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [516299] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [516321] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516341] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516363] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516383] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516403] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516423] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20183), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18062), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516461] = 3,
    ACTIONS(18693), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516483] = 3,
    ACTIONS(18655), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516505] = 3,
    ACTIONS(18675), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516527] = 3,
    ACTIONS(18679), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516549] = 3,
    ACTIONS(18647), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516571] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516591] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516611] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [516633] = 6,
    ACTIONS(17176), 1,
      anon_sym_deriving,
    ACTIONS(20099), 1,
      sym__varid,
    ACTIONS(20101), 1,
      anon_sym_LPAREN,
    STATE(13375), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [516661] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [516683] = 3,
    ACTIONS(15898), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15900), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516705] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516725] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [516747] = 3,
    ACTIONS(18685), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516769] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516791] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516813] = 7,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(18988), 1,
      sym_where,
    STATE(15003), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(20153), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17874), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516843] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516863] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [516883] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [516903] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516923] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(20185), 1,
      anon_sym_BQUOTE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3176), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(19130), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516957] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [516979] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [516999] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [517019] = 3,
    ACTIONS(15822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15824), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517041] = 4,
    ACTIONS(15902), 1,
      anon_sym_LBRACE,
    ACTIONS(20187), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15904), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517065] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517085] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [517107] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [517129] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15780), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517151] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517173] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [517193] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [517213] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517235] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517257] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20189), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18902), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517295] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [517315] = 3,
    ACTIONS(15658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15660), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517337] = 3,
    ACTIONS(16973), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [517359] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [517379] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517401] = 3,
    ACTIONS(18697), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [517423] = 11,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20191), 1,
      anon_sym_RBRACE,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19900), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517461] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517481] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [517501] = 3,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15784), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517523] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [517543] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15816), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517565] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517587] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517607] = 3,
    ACTIONS(15818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15820), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517629] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [517649] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20195), 1,
      anon_sym_RPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517684] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517703] = 9,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(19365), 1,
      sym__varid,
    ACTIONS(20199), 1,
      anon_sym_LPAREN,
    STATE(4116), 1,
      sym_constructor,
    STATE(4164), 1,
      sym_qualified_constructor,
    STATE(15440), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(4409), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517736] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [517755] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20201), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(17955), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517790] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [517809] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20203), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(19756), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517844] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [517865] = 3,
    ACTIONS(18557), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [517886] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [517905] = 3,
    ACTIONS(16936), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16938), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [517926] = 9,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(19046), 1,
      sym__varid,
    ACTIONS(20205), 1,
      anon_sym_LPAREN,
    STATE(11390), 1,
      sym_constructor,
    STATE(11692), 1,
      sym_qualified_constructor,
    STATE(15069), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11621), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517959] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18737), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 10,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT2,
  [518013] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20211), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2621), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [518040] = 3,
    ACTIONS(15643), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [518061] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518080] = 9,
    ACTIONS(10046), 1,
      sym__conid,
    ACTIONS(19701), 1,
      sym__varid,
    ACTIONS(20213), 1,
      anon_sym_LPAREN,
    STATE(12279), 1,
      sym_constructor,
    STATE(13114), 1,
      sym_qualified_constructor,
    STATE(15581), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12946), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518113] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18874), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518148] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20215), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2592), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [518175] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518194] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518213] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [518234] = 9,
    ACTIONS(9896), 1,
      sym__conid,
    ACTIONS(19705), 1,
      sym__varid,
    ACTIONS(20217), 1,
      anon_sym_LPAREN,
    STATE(11766), 1,
      sym_constructor,
    STATE(12622), 1,
      sym_qualified_constructor,
    STATE(15382), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12300), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518267] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20219), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2600), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [518294] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518313] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [518332] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518351] = 9,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(19012), 1,
      sym__varid,
    ACTIONS(20221), 1,
      anon_sym_LPAREN,
    STATE(5071), 1,
      sym_constructor,
    STATE(5533), 1,
      sym_qualified_constructor,
    STATE(15164), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5469), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518384] = 9,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(19401), 1,
      sym__varid,
    ACTIONS(20223), 1,
      anon_sym_LPAREN,
    STATE(11192), 1,
      sym_constructor,
    STATE(12069), 1,
      sym_qualified_constructor,
    STATE(15158), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12974), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518417] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518436] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18602), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518471] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518490] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20225), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2737), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [518517] = 3,
    ACTIONS(15643), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [518538] = 9,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(19497), 1,
      sym__varid,
    ACTIONS(20227), 1,
      anon_sym_LPAREN,
    STATE(3737), 1,
      sym_constructor,
    STATE(3746), 1,
      sym_qualified_constructor,
    STATE(15288), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(3874), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518571] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [518592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [518611] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [518630] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [518649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518668] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518687] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [518706] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 9,
      sym__dot,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [518727] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518746] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518765] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [518803] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20229), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(18076), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518838] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518857] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(17907), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518892] = 9,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20231), 1,
      anon_sym_LPAREN,
    STATE(15161), 1,
      sym_constructor,
    STATE(15534), 1,
      sym_deriving_strategy,
    STATE(16059), 1,
      sym_qualified_type,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(20233), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518925] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518960] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [518979] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20235), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2689), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [519006] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519025] = 7,
    ACTIONS(20239), 1,
      anon_sym_LBRACE,
    ACTIONS(20241), 1,
      anon_sym_in,
    ACTIONS(20243), 1,
      sym__layout_start,
    STATE(15743), 1,
      sym_decls,
    STATE(23090), 1,
      sym__let_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20237), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [519054] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [519073] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [519094] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [519113] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [519132] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519151] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519170] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519189] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519208] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [519227] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519246] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519265] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519284] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519303] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20245), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2721), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [519330] = 9,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(18972), 1,
      sym__varid,
    ACTIONS(20247), 1,
      anon_sym_LPAREN,
    STATE(4694), 1,
      sym_constructor,
    STATE(4922), 1,
      sym_qualified_constructor,
    STATE(15328), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(4802), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519363] = 6,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(20251), 1,
      anon_sym_LPAREN,
    ACTIONS(20253), 1,
      anon_sym_LBRACE,
    ACTIONS(20249), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13667), 4,
      sym_type_variable,
      sym_inferred_type_variable,
      sym__quantifier,
      aux_sym__forall_repeat1,
  [519390] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519409] = 5,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(20255), 1,
      anon_sym_LPAREN,
    STATE(13654), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20023), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [519434] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519453] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519472] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [519495] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19023), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519530] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18332), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519565] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20257), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2615), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [519592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519611] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [519630] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18457), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519665] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [519684] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519703] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519722] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 10,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [519741] = 9,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(19016), 1,
      sym__varid,
    ACTIONS(20261), 1,
      anon_sym_LPAREN,
    STATE(4602), 1,
      sym_constructor,
    STATE(4779), 1,
      sym_qualified_constructor,
    STATE(15426), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(6089), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519774] = 5,
    ACTIONS(20263), 1,
      sym__varid,
    ACTIONS(20266), 1,
      anon_sym_LPAREN,
    STATE(13654), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19997), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [519799] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519818] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18215), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519853] = 9,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(19126), 1,
      sym__varid,
    ACTIONS(20269), 1,
      anon_sym_LPAREN,
    STATE(4831), 1,
      sym_constructor,
    STATE(5636), 1,
      sym_qualified_constructor,
    STATE(15311), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(6473), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519886] = 3,
    ACTIONS(16940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16942), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519907] = 10,
    ACTIONS(285), 1,
      sym__varsym,
    ACTIONS(287), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17885), 1,
      anon_sym_DASH,
    STATE(8453), 1,
      sym_constructor_operator,
    STATE(13811), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    STATE(8345), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519942] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [519961] = 3,
    ACTIONS(15339), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [519982] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [520003] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20271), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(18092), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520038] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520057] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520076] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520095] = 6,
    ACTIONS(20273), 1,
      sym__varid,
    ACTIONS(20278), 1,
      anon_sym_LPAREN,
    ACTIONS(20281), 1,
      anon_sym_LBRACE,
    ACTIONS(20276), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13667), 4,
      sym_type_variable,
      sym_inferred_type_variable,
      sym__quantifier,
      aux_sym__forall_repeat1,
  [520122] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [520141] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520160] = 9,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(19199), 1,
      sym__varid,
    ACTIONS(20284), 1,
      anon_sym_LPAREN,
    STATE(11426), 1,
      sym_constructor,
    STATE(11528), 1,
      sym_qualified_constructor,
    STATE(15128), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12521), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520193] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(20200), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520228] = 9,
    ACTIONS(4453), 1,
      sym__conid,
    ACTIONS(19709), 1,
      sym__varid,
    ACTIONS(20286), 1,
      anon_sym_LPAREN,
    STATE(4898), 1,
      sym_constructor,
    STATE(5850), 1,
      sym_qualified_constructor,
    STATE(15569), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5378), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520261] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [520282] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    ACTIONS(20053), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(20201), 1,
      sym_pat_field,
    STATE(23316), 1,
      sym__modid,
    STATE(18473), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520317] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520336] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [520355] = 9,
    ACTIONS(4809), 1,
      sym__conid,
    ACTIONS(19660), 1,
      sym__varid,
    ACTIONS(20288), 1,
      anon_sym_LPAREN,
    STATE(4705), 1,
      sym_constructor,
    STATE(5141), 1,
      sym_qualified_constructor,
    STATE(15327), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5012), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520388] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19188), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520423] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [520442] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520461] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520480] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520518] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [520537] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [520556] = 5,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(20255), 1,
      anon_sym_LPAREN,
    STATE(13654), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19978), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [520581] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18117), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520616] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20290), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(18797), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520651] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [520670] = 9,
    ACTIONS(9322), 1,
      sym__conid,
    ACTIONS(19739), 1,
      sym__varid,
    ACTIONS(20292), 1,
      anon_sym_LPAREN,
    STATE(11854), 1,
      sym_constructor,
    STATE(12691), 1,
      sym_qualified_constructor,
    STATE(15424), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12459), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520703] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(20294), 1,
      anon_sym_LPAREN,
    STATE(13695), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19978), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520728] = 9,
    ACTIONS(4483), 1,
      sym__conid,
    ACTIONS(19493), 1,
      sym__varid,
    ACTIONS(20296), 1,
      anon_sym_LPAREN,
    STATE(5459), 1,
      sym_constructor,
    STATE(6190), 1,
      sym_qualified_constructor,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(6071), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520761] = 9,
    ACTIONS(9288), 1,
      sym__conid,
    ACTIONS(19628), 1,
      sym__varid,
    ACTIONS(20298), 1,
      anon_sym_LPAREN,
    STATE(10701), 1,
      sym_constructor,
    STATE(10874), 1,
      sym_qualified_constructor,
    STATE(15544), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(10816), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520794] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19339), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520829] = 5,
    ACTIONS(20300), 1,
      sym__varid,
    ACTIONS(20303), 1,
      anon_sym_LPAREN,
    STATE(13695), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19997), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520854] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [520873] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520892] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18056), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520927] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [520946] = 7,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(20153), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16061), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(21097), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520975] = 9,
    ACTIONS(9862), 1,
      sym__conid,
    ACTIONS(19425), 1,
      sym__varid,
    ACTIONS(20306), 1,
      anon_sym_LPAREN,
    STATE(11803), 1,
      sym_constructor,
    STATE(12197), 1,
      sym_qualified_constructor,
    STATE(15177), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12328), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521008] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [521027] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [521046] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [521065] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20308), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521100] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [521121] = 9,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(19691), 1,
      sym__varid,
    ACTIONS(20310), 1,
      anon_sym_LPAREN,
    STATE(4637), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_qualified_constructor,
    STATE(15597), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5061), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521154] = 3,
    ACTIONS(16948), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16950), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [521175] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19522), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521210] = 9,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(19757), 1,
      sym__varid,
    ACTIONS(20312), 1,
      anon_sym_LPAREN,
    STATE(11179), 1,
      sym_constructor,
    STATE(12088), 1,
      sym_qualified_constructor,
    STATE(15523), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12751), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521243] = 9,
    ACTIONS(9708), 1,
      sym__conid,
    ACTIONS(19713), 1,
      sym__varid,
    ACTIONS(20314), 1,
      anon_sym_LPAREN,
    STATE(11329), 1,
      sym_constructor,
    STATE(11783), 1,
      sym_qualified_constructor,
    STATE(15397), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11940), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521276] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [521295] = 9,
    ACTIONS(4603), 1,
      sym__conid,
    ACTIONS(19679), 1,
      sym__varid,
    ACTIONS(20316), 1,
      anon_sym_LPAREN,
    STATE(4874), 1,
      sym_constructor,
    STATE(5819), 1,
      sym_qualified_constructor,
    STATE(15620), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5779), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521328] = 9,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(19391), 1,
      sym__varid,
    ACTIONS(20318), 1,
      anon_sym_LPAREN,
    STATE(11712), 1,
      sym_constructor,
    STATE(12598), 1,
      sym_qualified_constructor,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12446), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521361] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [521380] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19397), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521415] = 9,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(20320), 1,
      anon_sym_LPAREN,
    STATE(14621), 1,
      sym_constructor,
    STATE(14981), 1,
      sym_qualified_type,
    STATE(15165), 1,
      sym_deriving_strategy,
    STATE(16910), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(20233), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521448] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [521467] = 3,
    ACTIONS(16920), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16922), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [521488] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18173), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521523] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [521542] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    STATE(14901), 1,
      sym_constructor,
    STATE(15499), 1,
      aux_sym__qualifying_module,
    STATE(23053), 1,
      sym__modid,
    STATE(3165), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(19130), 3,
      sym__varsym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521573] = 3,
    ACTIONS(16916), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16918), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [521594] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [521613] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(17929), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521648] = 9,
    ACTIONS(4607), 1,
      sym__conid,
    ACTIONS(19008), 1,
      sym__varid,
    ACTIONS(20322), 1,
      anon_sym_LPAREN,
    STATE(5155), 1,
      sym_constructor,
    STATE(5446), 1,
      sym_qualified_constructor,
    STATE(15201), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5811), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521681] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20324), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(17942), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521716] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19905), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521751] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20326), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521786] = 9,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(19483), 1,
      sym__varid,
    ACTIONS(20328), 1,
      anon_sym_LPAREN,
    STATE(4738), 1,
      sym_constructor,
    STATE(5513), 1,
      sym_qualified_constructor,
    STATE(15243), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5804), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521819] = 9,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(19546), 1,
      sym__varid,
    ACTIONS(20330), 1,
      anon_sym_LPAREN,
    STATE(4649), 1,
      sym_constructor,
    STATE(4902), 1,
      sym_qualified_constructor,
    STATE(15353), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5306), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 10,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [521871] = 3,
    ACTIONS(20332), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18584), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [521892] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [521913] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(20294), 1,
      anon_sym_LPAREN,
    STATE(13695), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20023), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [521938] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [521957] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19287), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521992] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [522011] = 9,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(20334), 1,
      anon_sym_LPAREN,
    STATE(14712), 1,
      sym_constructor,
    STATE(15466), 1,
      sym_qualified_type,
    STATE(15476), 1,
      sym_deriving_strategy,
    STATE(17427), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(20233), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522044] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [522065] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20336), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522100] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(20145), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522135] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [522154] = 3,
    ACTIONS(16979), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [522175] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522194] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(20294), 1,
      anon_sym_LPAREN,
    STATE(13735), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522219] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522238] = 9,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(19283), 1,
      sym__varid,
    ACTIONS(20338), 1,
      anon_sym_LPAREN,
    STATE(10325), 1,
      sym_constructor,
    STATE(10464), 1,
      sym_qualified_constructor,
    STATE(15321), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(10688), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522271] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19168), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522306] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [522327] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(20294), 1,
      anon_sym_LPAREN,
    STATE(13691), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522352] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522371] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [522390] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 10,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [522409] = 9,
    ACTIONS(9828), 1,
      sym__conid,
    ACTIONS(19415), 1,
      sym__varid,
    ACTIONS(20340), 1,
      anon_sym_LPAREN,
    STATE(11486), 1,
      sym_constructor,
    STATE(11570), 1,
      sym_qualified_constructor,
    STATE(15100), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12022), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522442] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [522461] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522480] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [522499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [522518] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20342), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522553] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522572] = 7,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(20097), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16151), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(21190), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522601] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18293), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522636] = 7,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(20097), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16193), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(21241), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522665] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [522684] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [522703] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [522722] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [522741] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(17910), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522776] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19993), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522811] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [522830] = 3,
    ACTIONS(16912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16914), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [522851] = 3,
    ACTIONS(20344), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20346), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [522872] = 9,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(19311), 1,
      sym__varid,
    ACTIONS(20348), 1,
      anon_sym_LPAREN,
    STATE(3732), 1,
      sym_constructor,
    STATE(3756), 1,
      sym_qualified_constructor,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(4079), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522905] = 9,
    ACTIONS(9622), 1,
      sym__conid,
    ACTIONS(19341), 1,
      sym__varid,
    ACTIONS(20350), 1,
      anon_sym_LPAREN,
    STATE(12771), 1,
      sym_constructor,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(15148), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(13062), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522938] = 9,
    ACTIONS(9930), 1,
      sym__conid,
    ACTIONS(19449), 1,
      sym__varid,
    ACTIONS(20352), 1,
      anon_sym_LPAREN,
    STATE(11578), 1,
      sym_constructor,
    STATE(12329), 1,
      sym_qualified_constructor,
    STATE(15204), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12416), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522971] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20354), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523006] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [523025] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [523044] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19049), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523079] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [523098] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18376), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523133] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [523156] = 9,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(19067), 1,
      sym__varid,
    ACTIONS(20356), 1,
      anon_sym_LPAREN,
    STATE(10340), 1,
      sym_constructor,
    STATE(10549), 1,
      sym_qualified_constructor,
    STATE(15481), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(10602), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523189] = 9,
    ACTIONS(4435), 1,
      sym__conid,
    ACTIONS(19071), 1,
      sym__varid,
    ACTIONS(20358), 1,
      anon_sym_LPAREN,
    STATE(5241), 1,
      sym_constructor,
    STATE(5383), 1,
      sym_qualified_constructor,
    STATE(15402), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5829), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523222] = 3,
    ACTIONS(15339), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [523243] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18433), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523278] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [523297] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 10,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [523316] = 3,
    ACTIONS(16904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16906), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [523337] = 9,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(19519), 1,
      sym__varid,
    ACTIONS(20360), 1,
      anon_sym_LPAREN,
    STATE(4228), 1,
      sym_constructor,
    STATE(4427), 1,
      sym_qualified_constructor,
    STATE(15275), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(4496), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523370] = 9,
    ACTIONS(9212), 1,
      sym__conid,
    ACTIONS(19612), 1,
      sym__varid,
    ACTIONS(20362), 1,
      anon_sym_LPAREN,
    STATE(11280), 1,
      sym_constructor,
    STATE(11867), 1,
      sym_qualified_constructor,
    STATE(15516), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11546), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523403] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [523422] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18532), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523457] = 10,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(13811), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22112), 1,
      sym_constructor_operator,
    STATE(23392), 1,
      sym__modid,
    STATE(22525), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523492] = 3,
    ACTIONS(16884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16886), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [523513] = 5,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(20255), 1,
      anon_sym_LPAREN,
    STATE(13639), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [523538] = 3,
    ACTIONS(16900), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16902), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [523559] = 4,
    ACTIONS(10827), 1,
      anon_sym_LBRACE,
    STATE(14460), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [523582] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20364), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2631), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18387), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [523609] = 9,
    ACTIONS(9356), 1,
      sym__conid,
    ACTIONS(19369), 1,
      sym__varid,
    ACTIONS(20366), 1,
      anon_sym_LPAREN,
    STATE(11482), 1,
      sym_constructor,
    STATE(11582), 1,
      sym_qualified_constructor,
    STATE(15067), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11977), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523642] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18654), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523677] = 9,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(19351), 1,
      sym__varid,
    ACTIONS(20368), 1,
      anon_sym_LPAREN,
    STATE(11980), 1,
      sym_constructor,
    STATE(12433), 1,
      sym_qualified_constructor,
    STATE(15074), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(13522), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523710] = 3,
    ACTIONS(16944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16946), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [523731] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [523750] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [523769] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18930), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523804] = 9,
    ACTIONS(4583), 1,
      sym__conid,
    ACTIONS(19729), 1,
      sym__varid,
    ACTIONS(20370), 1,
      anon_sym_LPAREN,
    STATE(4599), 1,
      sym_constructor,
    STATE(5112), 1,
      sym_qualified_constructor,
    STATE(15415), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5236), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523837] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [523858] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [523877] = 7,
    ACTIONS(20376), 1,
      sym__conid,
    STATE(13811), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23392), 1,
      sym__modid,
    ACTIONS(20372), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(20374), 3,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523906] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20379), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523941] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18811), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523976] = 9,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(19644), 1,
      sym__varid,
    ACTIONS(20381), 1,
      anon_sym_LPAREN,
    STATE(10858), 1,
      sym_constructor,
    STATE(11007), 1,
      sym_qualified_constructor,
    STATE(15383), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11076), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524009] = 3,
    ACTIONS(16896), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16898), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524030] = 3,
    ACTIONS(16892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16894), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524051] = 3,
    ACTIONS(15470), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [524072] = 7,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(20089), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16200), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(20185), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524101] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18692), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524136] = 3,
    ACTIONS(16888), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16890), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524157] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [524176] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524195] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18573), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524230] = 9,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(19687), 1,
      sym__varid,
    ACTIONS(20383), 1,
      anon_sym_LPAREN,
    STATE(10623), 1,
      sym_constructor,
    STATE(10748), 1,
      sym_qualified_constructor,
    STATE(15524), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11056), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524263] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524282] = 3,
    ACTIONS(16908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16910), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524303] = 9,
    ACTIONS(4491), 1,
      sym__conid,
    ACTIONS(19667), 1,
      sym__varid,
    ACTIONS(20385), 1,
      anon_sym_LPAREN,
    STATE(5341), 1,
      sym_constructor,
    STATE(6252), 1,
      sym_qualified_constructor,
    STATE(14986), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(6210), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524336] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19809), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524371] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18749), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524406] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20387), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524441] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18454), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524476] = 9,
    ACTIONS(9526), 1,
      sym__conid,
    ACTIONS(19683), 1,
      sym__varid,
    ACTIONS(20389), 1,
      anon_sym_LPAREN,
    STATE(11972), 1,
      sym_constructor,
    STATE(12687), 1,
      sym_qualified_constructor,
    STATE(15608), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(12753), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524509] = 3,
    ACTIONS(16880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16882), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524530] = 6,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(20251), 1,
      anon_sym_LPAREN,
    ACTIONS(20253), 1,
      anon_sym_LBRACE,
    ACTIONS(20391), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13637), 4,
      sym_type_variable,
      sym_inferred_type_variable,
      sym__quantifier,
      aux_sym__forall_repeat1,
  [524557] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(17859), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524592] = 3,
    ACTIONS(16876), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16878), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524613] = 3,
    ACTIONS(16872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16874), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524634] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524653] = 8,
    ACTIONS(20393), 1,
      anon_sym_EQ,
    STATE(2453), 1,
      sym__colon2,
    STATE(15850), 1,
      sym_tyfam_result_type,
    STATE(18033), 1,
      sym__tyfam_inj,
    STATE(18036), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20103), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524684] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [524705] = 3,
    ACTIONS(20344), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20346), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [524726] = 3,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16870), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [524747] = 9,
    ACTIONS(4537), 1,
      sym__conid,
    ACTIONS(19429), 1,
      sym__varid,
    ACTIONS(20395), 1,
      anon_sym_LPAREN,
    STATE(4632), 1,
      sym_constructor,
    STATE(4761), 1,
      sym_qualified_constructor,
    STATE(15180), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5140), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524780] = 8,
    ACTIONS(20397), 1,
      anon_sym_EQ,
    STATE(2506), 1,
      sym__colon2,
    STATE(15991), 1,
      sym_tyfam_result_type,
    STATE(19565), 1,
      sym__tyfam_inj,
    STATE(19566), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20103), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524811] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [524830] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18335), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524865] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18897), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524900] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17773), 1,
      sym__tyconsym,
    STATE(2467), 1,
      sym__colon2,
    STATE(20768), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(18229), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524931] = 9,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(19107), 1,
      sym__varid,
    ACTIONS(20399), 1,
      anon_sym_LPAREN,
    STATE(4588), 1,
      sym_constructor,
    STATE(4869), 1,
      sym_qualified_constructor,
    STATE(14972), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(5281), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524964] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [524983] = 9,
    ACTIONS(4851), 1,
      sym__conid,
    ACTIONS(19439), 1,
      sym__varid,
    ACTIONS(20401), 1,
      anon_sym_LPAREN,
    STATE(4189), 1,
      sym_constructor,
    STATE(4245), 1,
      sym_qualified_constructor,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(4239), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525016] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 10,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_via,
      anon_sym_deriving,
  [525035] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18216), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525070] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19088), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525105] = 9,
    ACTIONS(4617), 1,
      sym__conid,
    ACTIONS(19361), 1,
      sym__varid,
    ACTIONS(20403), 1,
      anon_sym_LPAREN,
    STATE(4469), 1,
      sym_constructor,
    STATE(4558), 1,
      sym_qualified_constructor,
    STATE(15050), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(4613), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [525157] = 10,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(20405), 1,
      anon_sym_RPAREN,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525192] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(18097), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525227] = 5,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(20255), 1,
      anon_sym_LPAREN,
    STATE(13686), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [525252] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19471), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525287] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [525306] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19640), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525341] = 9,
    ACTIONS(9390), 1,
      sym__conid,
    ACTIONS(19223), 1,
      sym__varid,
    ACTIONS(20407), 1,
      anon_sym_LPAREN,
    STATE(11035), 1,
      sym_constructor,
    STATE(11156), 1,
      sym_qualified_constructor,
    STATE(15624), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(11389), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525374] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(19267), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525409] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 8,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [525430] = 10,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20207), 1,
      anon_sym_LPAREN,
    ACTIONS(20209), 1,
      anon_sym_DOT_DOT,
    STATE(14901), 1,
      sym_constructor,
    STATE(15302), 1,
      aux_sym__qualifying_module,
    STATE(17978), 1,
      sym_exp_field,
    STATE(23316), 1,
      sym__modid,
    STATE(15860), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525465] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [525483] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__dot,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [525503] = 9,
    ACTIONS(20411), 1,
      anon_sym_RBRACK,
    ACTIONS(20413), 1,
      anon_sym_PIPE,
    ACTIONS(20415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20417), 1,
      sym__arith_dotdot,
    ACTIONS(20419), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(19227), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525535] = 9,
    ACTIONS(9376), 1,
      sym__varid,
    ACTIONS(9390), 1,
      sym__conid,
    STATE(11017), 1,
      sym_constructor,
    STATE(11207), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525567] = 4,
    ACTIONS(10962), 1,
      anon_sym_LBRACE,
    STATE(14907), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [525589] = 9,
    ACTIONS(2111), 1,
      sym__varid,
    ACTIONS(4617), 1,
      sym__conid,
    STATE(4468), 1,
      sym_constructor,
    STATE(4684), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525621] = 4,
    ACTIONS(11359), 1,
      anon_sym_LBRACE,
    STATE(14656), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [525643] = 9,
    ACTIONS(20421), 1,
      anon_sym_RBRACK,
    ACTIONS(20423), 1,
      anon_sym_PIPE,
    ACTIONS(20425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20427), 1,
      sym__arith_dotdot,
    ACTIONS(20429), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18031), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525675] = 4,
    STATE(14111), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20431), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20433), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [525697] = 10,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20435), 1,
      anon_sym_LPAREN,
    ACTIONS(20437), 1,
      sym__conid,
    STATE(13520), 1,
      sym_constructor,
    STATE(13844), 1,
      sym_tyfam_head,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(15014), 1,
      sym_type_variable,
    STATE(15351), 1,
      sym__simpletype,
    STATE(18755), 1,
      sym__tyfam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525731] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [525749] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [525767] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [525785] = 10,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20059), 1,
      sym__varid,
    ACTIONS(20439), 1,
      anon_sym_family,
    STATE(13751), 1,
      sym_constructor,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15422), 1,
      sym__simpletype,
    STATE(15596), 1,
      sym_type_variable,
    STATE(20485), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525819] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [525837] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [525855] = 9,
    ACTIONS(9342), 1,
      sym__varid,
    ACTIONS(9356), 1,
      sym__conid,
    STATE(11469), 1,
      sym_constructor,
    STATE(11651), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525887] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [525905] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [525927] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [525945] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [525963] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [525983] = 5,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(20441), 1,
      anon_sym_LPAREN,
    STATE(13974), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17168), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [526007] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526025] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [526043] = 9,
    ACTIONS(4499), 1,
      sym__varid,
    ACTIONS(4513), 1,
      sym__conid,
    STATE(10856), 1,
      sym_constructor,
    STATE(10931), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526075] = 9,
    ACTIONS(4635), 1,
      sym__varid,
    ACTIONS(4649), 1,
      sym__conid,
    STATE(11216), 1,
      sym_constructor,
    STATE(11702), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526107] = 9,
    ACTIONS(9848), 1,
      sym__varid,
    ACTIONS(9862), 1,
      sym__conid,
    STATE(11753), 1,
      sym_constructor,
    STATE(12357), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526139] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [526159] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [526181] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526199] = 7,
    ACTIONS(20447), 1,
      anon_sym_PIPE,
    ACTIONS(20449), 1,
      sym_where,
    STATE(15648), 1,
      sym_fundeps,
    STATE(18373), 1,
      sym_class_body,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(20443), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526227] = 9,
    ACTIONS(9274), 1,
      sym__varid,
    ACTIONS(9288), 1,
      sym__conid,
    STATE(10695), 1,
      sym_constructor,
    STATE(10792), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526259] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526277] = 9,
    ACTIONS(1856), 1,
      sym__varid,
    ACTIONS(4577), 1,
      sym__conid,
    STATE(3730), 1,
      sym_constructor,
    STATE(3777), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526309] = 9,
    ACTIONS(1976), 1,
      sym__varid,
    ACTIONS(3311), 1,
      sym__conid,
    STATE(4283), 1,
      sym_constructor,
    STATE(4463), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526341] = 5,
    STATE(2429), 1,
      sym__colon2,
    STATE(15785), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20451), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [526365] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526383] = 9,
    ACTIONS(9882), 1,
      sym__varid,
    ACTIONS(9896), 1,
      sym__conid,
    STATE(11762), 1,
      sym_constructor,
    STATE(12120), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526415] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526433] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [526455] = 4,
    STATE(14817), 1,
      sym_calling_convention,
    STATE(15469), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20453), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [526477] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(20457), 1,
      sym_where,
    STATE(22282), 1,
      sym_guards,
    STATE(14005), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20455), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [526503] = 9,
    ACTIONS(9814), 1,
      sym__varid,
    ACTIONS(9828), 1,
      sym__conid,
    STATE(11504), 1,
      sym_constructor,
    STATE(11745), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526535] = 4,
    STATE(14817), 1,
      sym_calling_convention,
    STATE(15456), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20453), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [526557] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 9,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [526575] = 9,
    ACTIONS(20459), 1,
      anon_sym_RBRACK,
    ACTIONS(20461), 1,
      anon_sym_PIPE,
    ACTIONS(20463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20465), 1,
      sym__arith_dotdot,
    ACTIONS(20467), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18618), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526607] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526625] = 10,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20469), 1,
      anon_sym_LPAREN,
    ACTIONS(20471), 1,
      sym__conid,
    STATE(13839), 1,
      sym_tyfam_head,
    STATE(13859), 1,
      sym_constructor,
    STATE(15028), 1,
      sym__simpletype_infix,
    STATE(15091), 1,
      sym_type_variable,
    STATE(15247), 1,
      sym__simpletype,
    STATE(19006), 1,
      sym__tyfam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526659] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [526677] = 4,
    STATE(13963), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20473), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20475), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [526699] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [526717] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [526739] = 8,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(14315), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22723), 1,
      sym__modid,
    STATE(21537), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526769] = 9,
    ACTIONS(2708), 1,
      sym__varid,
    ACTIONS(3296), 1,
      sym__conid,
    STATE(5049), 1,
      sym_constructor,
    STATE(5350), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526801] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [526821] = 9,
    ACTIONS(1107), 1,
      sym__conid,
    ACTIONS(3143), 1,
      sym__varid,
    STATE(4177), 1,
      sym_constructor,
    STATE(5124), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526853] = 9,
    ACTIONS(2443), 1,
      sym__varid,
    ACTIONS(4431), 1,
      sym__conid,
    STATE(4644), 1,
      sym_constructor,
    STATE(4900), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526885] = 9,
    ACTIONS(4729), 1,
      sym__varid,
    ACTIONS(4741), 1,
      sym__conid,
    STATE(11850), 1,
      sym_constructor,
    STATE(12750), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526917] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [526937] = 9,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    STATE(10565), 1,
      sym_variable,
    STATE(10674), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526969] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym__unboxed_close,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [526987] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527005] = 3,
    ACTIONS(15339), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [527025] = 5,
    STATE(2464), 1,
      sym__colon2,
    STATE(16186), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20477), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [527049] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [527067] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527085] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [527103] = 4,
    STATE(14817), 1,
      sym_calling_convention,
    STATE(15073), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20453), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [527125] = 9,
    ACTIONS(20479), 1,
      anon_sym_RBRACK,
    ACTIONS(20481), 1,
      anon_sym_PIPE,
    ACTIONS(20483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20485), 1,
      sym__arith_dotdot,
    ACTIONS(20487), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18417), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527157] = 4,
    STATE(13963), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20431), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20475), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [527179] = 4,
    STATE(14817), 1,
      sym_calling_convention,
    STATE(15076), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20453), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [527201] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527219] = 9,
    ACTIONS(3091), 1,
      sym__varid,
    ACTIONS(4491), 1,
      sym__conid,
    STATE(5878), 1,
      sym_constructor,
    STATE(6024), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527251] = 9,
    ACTIONS(1460), 1,
      sym__conid,
    ACTIONS(1976), 1,
      sym__varid,
    STATE(3878), 1,
      sym_constructor,
    STATE(4463), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527283] = 9,
    ACTIONS(2242), 1,
      sym__varid,
    ACTIONS(4809), 1,
      sym__conid,
    STATE(4549), 1,
      sym_constructor,
    STATE(5009), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527315] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527333] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18669), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [527351] = 9,
    ACTIONS(9916), 1,
      sym__varid,
    ACTIONS(9930), 1,
      sym__conid,
    STATE(11548), 1,
      sym_constructor,
    STATE(12299), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527383] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [527401] = 8,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(14315), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22723), 1,
      sym__modid,
    STATE(21481), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527431] = 9,
    ACTIONS(2845), 1,
      sym__varid,
    ACTIONS(4607), 1,
      sym__conid,
    STATE(5243), 1,
      sym_constructor,
    STATE(5776), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527463] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18673), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [527481] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18677), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [527499] = 9,
    ACTIONS(9198), 1,
      sym__varid,
    ACTIONS(9212), 1,
      sym__conid,
    STATE(11274), 1,
      sym_constructor,
    STATE(11605), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527531] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18683), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [527549] = 9,
    ACTIONS(3264), 1,
      sym__varid,
    ACTIONS(3305), 1,
      sym__conid,
    STATE(4786), 1,
      sym_constructor,
    STATE(5579), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527581] = 9,
    ACTIONS(20489), 1,
      anon_sym_RBRACK,
    ACTIONS(20491), 1,
      anon_sym_PIPE,
    ACTIONS(20493), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20495), 1,
      sym__arith_dotdot,
    ACTIONS(20497), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18158), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527613] = 3,
    ACTIONS(15643), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [527633] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [527651] = 10,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20499), 1,
      anon_sym_LPAREN,
    ACTIONS(20501), 1,
      sym__conid,
    STATE(13053), 1,
      sym_constructor,
    STATE(13495), 1,
      sym_tyfam_head,
    STATE(14505), 1,
      sym__simpletype_infix,
    STATE(14717), 1,
      sym__simpletype,
    STATE(15181), 1,
      sym_type_variable,
    STATE(17270), 1,
      sym__tyfam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527685] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527703] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [527721] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527739] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [527757] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [527775] = 4,
    STATE(13963), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20503), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20505), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [527797] = 9,
    ACTIONS(4861), 1,
      sym__varid,
    ACTIONS(4873), 1,
      sym__conid,
    STATE(10364), 1,
      sym_constructor,
    STATE(10565), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527829] = 9,
    ACTIONS(20508), 1,
      anon_sym_RBRACK,
    ACTIONS(20510), 1,
      anon_sym_PIPE,
    ACTIONS(20512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20514), 1,
      sym__arith_dotdot,
    ACTIONS(20516), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(19060), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527861] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [527879] = 9,
    ACTIONS(20518), 1,
      anon_sym_RBRACK,
    ACTIONS(20520), 1,
      anon_sym_PIPE,
    ACTIONS(20522), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20524), 1,
      sym__arith_dotdot,
    ACTIONS(20526), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(17892), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527911] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [527933] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18695), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [527951] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [527969] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [527989] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [528007] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(20528), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2759), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(18387), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528033] = 5,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(20441), 1,
      anon_sym_LPAREN,
    STATE(14060), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19978), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [528057] = 9,
    ACTIONS(20530), 1,
      anon_sym_RBRACK,
    ACTIONS(20532), 1,
      anon_sym_PIPE,
    ACTIONS(20534), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20536), 1,
      sym__arith_dotdot,
    ACTIONS(20538), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18236), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528089] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__dot,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [528109] = 4,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(20540), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [528131] = 9,
    ACTIONS(563), 1,
      sym__conid,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3790), 1,
      sym_variable,
    STATE(4170), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528163] = 9,
    ACTIONS(2200), 1,
      sym__varid,
    ACTIONS(4537), 1,
      sym__conid,
    STATE(4640), 1,
      sym_constructor,
    STATE(4863), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528195] = 9,
    ACTIONS(2750), 1,
      sym__varid,
    ACTIONS(4603), 1,
      sym__conid,
    STATE(4879), 1,
      sym_constructor,
    STATE(5303), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528227] = 9,
    ACTIONS(20543), 1,
      anon_sym_RBRACK,
    ACTIONS(20545), 1,
      anon_sym_PIPE,
    ACTIONS(20547), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20549), 1,
      sym__arith_dotdot,
    ACTIONS(20551), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(20158), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528259] = 3,
    ACTIONS(20344), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20346), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [528279] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [528297] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [528317] = 9,
    ACTIONS(1610), 1,
      sym__varid,
    ACTIONS(1618), 1,
      sym__conid,
    STATE(4115), 1,
      sym_constructor,
    STATE(4214), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528349] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [528369] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528387] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528405] = 8,
    ACTIONS(20553), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym__colon2,
    STATE(16628), 1,
      sym_tyfam_result_type,
    STATE(21006), 1,
      sym__type_annotation,
    STATE(21009), 1,
      sym__tyfam_inj,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20103), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528435] = 9,
    ACTIONS(4765), 1,
      sym__varid,
    ACTIONS(4779), 1,
      sym__conid,
    STATE(11455), 1,
      sym_constructor,
    STATE(11545), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528467] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528485] = 9,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3790), 1,
      sym_variable,
    STATE(4217), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528517] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528535] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528553] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [528575] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528593] = 9,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(9610), 1,
      sym__varid,
    STATE(11455), 1,
      sym_constructor,
    STATE(12825), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528625] = 9,
    ACTIONS(4675), 1,
      sym__varid,
    ACTIONS(4689), 1,
      sym__conid,
    STATE(11465), 1,
      sym_constructor,
    STATE(12067), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528657] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18645), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [528675] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528693] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [528711] = 9,
    ACTIONS(9694), 1,
      sym__varid,
    ACTIONS(9708), 1,
      sym__conid,
    STATE(11332), 1,
      sym_constructor,
    STATE(11960), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528743] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [528761] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18653), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [528779] = 5,
    ACTIONS(20557), 1,
      anon_sym_PIPE,
    STATE(22282), 1,
      sym_guards,
    STATE(14005), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20555), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [528803] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [528823] = 9,
    ACTIONS(18888), 1,
      sym__varid,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20197), 1,
      sym__conid,
    STATE(16072), 1,
      sym_namespace,
    STATE(17791), 1,
      sym_constructor,
    STATE(20841), 1,
      sym_import_item,
    STATE(20886), 1,
      sym_variable,
    ACTIONS(18894), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528855] = 9,
    ACTIONS(2639), 1,
      sym__varid,
    ACTIONS(4487), 1,
      sym__conid,
    STATE(4725), 1,
      sym_constructor,
    STATE(5768), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528887] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [528905] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [528923] = 4,
    ACTIONS(11500), 1,
      anon_sym_LBRACE,
    STATE(14652), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [528945] = 9,
    ACTIONS(4825), 1,
      sym__varid,
    ACTIONS(4837), 1,
      sym__conid,
    STATE(11181), 1,
      sym_constructor,
    STATE(11846), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528977] = 5,
    STATE(2429), 1,
      sym__colon2,
    STATE(15629), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20560), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [529001] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [529021] = 5,
    STATE(2464), 1,
      sym__colon2,
    STATE(16012), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20451), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [529045] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [529065] = 9,
    ACTIONS(2795), 1,
      sym__varid,
    ACTIONS(4435), 1,
      sym__conid,
    STATE(5260), 1,
      sym_constructor,
    STATE(5673), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529097] = 4,
    STATE(14817), 1,
      sym_calling_convention,
    STATE(15603), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20453), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [529119] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529137] = 9,
    ACTIONS(20562), 1,
      anon_sym_RBRACK,
    ACTIONS(20564), 1,
      anon_sym_PIPE,
    ACTIONS(20566), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20568), 1,
      sym__arith_dotdot,
    ACTIONS(20570), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18511), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529169] = 4,
    STATE(14817), 1,
      sym_calling_convention,
    STATE(15602), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20453), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [529191] = 9,
    ACTIONS(20572), 1,
      anon_sym_RBRACK,
    ACTIONS(20574), 1,
      anon_sym_PIPE,
    ACTIONS(20576), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20578), 1,
      sym__arith_dotdot,
    ACTIONS(20580), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18152), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529223] = 9,
    ACTIONS(2340), 1,
      sym__varid,
    ACTIONS(4583), 1,
      sym__conid,
    STATE(4603), 1,
      sym_constructor,
    STATE(4951), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529255] = 9,
    ACTIONS(9512), 1,
      sym__varid,
    ACTIONS(9526), 1,
      sym__conid,
    STATE(11983), 1,
      sym_constructor,
    STATE(12593), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529287] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [529307] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529325] = 9,
    ACTIONS(563), 1,
      sym__conid,
    ACTIONS(1995), 1,
      sym__varid,
    STATE(4170), 1,
      sym_constructor,
    STATE(5187), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529357] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529375] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [529393] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529411] = 9,
    ACTIONS(9610), 1,
      sym__varid,
    ACTIONS(9622), 1,
      sym__conid,
    STATE(12496), 1,
      sym_constructor,
    STATE(12825), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529443] = 9,
    ACTIONS(259), 1,
      sym__conid,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3739), 1,
      sym_constructor,
    STATE(3790), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529475] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529493] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529511] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529529] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529547] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_via,
      anon_sym_deriving,
  [529567] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [529587] = 4,
    STATE(14111), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20582), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20433), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [529609] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529627] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [529649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529667] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529685] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529703] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529721] = 4,
    STATE(14111), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20473), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20433), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [529743] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529761] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [529779] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [529799] = 9,
    ACTIONS(259), 1,
      sym__conid,
    ACTIONS(1610), 1,
      sym__varid,
    STATE(3739), 1,
      sym_constructor,
    STATE(4214), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529831] = 5,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(20441), 1,
      anon_sym_LPAREN,
    STATE(14105), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17187), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [529855] = 5,
    STATE(2429), 1,
      sym__colon2,
    STATE(16206), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20477), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [529879] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [529897] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [529915] = 9,
    ACTIONS(3158), 1,
      sym__varid,
    ACTIONS(4483), 1,
      sym__conid,
    STATE(5339), 1,
      sym_constructor,
    STATE(5966), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529947] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18657), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [529965] = 3,
    ACTIONS(17009), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [529985] = 9,
    ACTIONS(3143), 1,
      sym__varid,
    ACTIONS(4497), 1,
      sym__conid,
    STATE(4608), 1,
      sym_constructor,
    STATE(5124), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530017] = 4,
    ACTIONS(11600), 1,
      anon_sym_LBRACE,
    STATE(14780), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [530039] = 5,
    ACTIONS(20584), 1,
      sym__varid,
    ACTIONS(20587), 1,
      anon_sym_LPAREN,
    STATE(14060), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19997), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [530063] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [530081] = 9,
    ACTIONS(9308), 1,
      sym__varid,
    ACTIONS(9322), 1,
      sym__conid,
    STATE(11845), 1,
      sym_constructor,
    STATE(12556), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530113] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [530135] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__dot,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [530155] = 9,
    ACTIONS(1592), 1,
      sym__conid,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3790), 1,
      sym_variable,
    STATE(4264), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530187] = 10,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(13751), 1,
      sym_constructor,
    STATE(13989), 1,
      sym_tyfam_head,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15596), 1,
      sym_type_variable,
    STATE(15703), 1,
      sym__simpletype,
    STATE(20591), 1,
      sym__tyfam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530221] = 9,
    ACTIONS(20590), 1,
      anon_sym_RBRACK,
    ACTIONS(20592), 1,
      anon_sym_PIPE,
    ACTIONS(20594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20596), 1,
      sym__arith_dotdot,
    ACTIONS(20598), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(19940), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530253] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530271] = 9,
    ACTIONS(20600), 1,
      anon_sym_RBRACK,
    ACTIONS(20602), 1,
      anon_sym_PIPE,
    ACTIONS(20604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20606), 1,
      sym__arith_dotdot,
    ACTIONS(20608), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18850), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530303] = 9,
    ACTIONS(1399), 1,
      sym__conid,
    ACTIONS(2708), 1,
      sym__varid,
    STATE(4281), 1,
      sym_constructor,
    STATE(5350), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530335] = 9,
    ACTIONS(4539), 1,
      sym__varid,
    ACTIONS(4553), 1,
      sym__conid,
    STATE(11573), 1,
      sym_constructor,
    STATE(12336), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530367] = 9,
    ACTIONS(1399), 1,
      sym__conid,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3790), 1,
      sym_variable,
    STATE(4281), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530399] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530417] = 9,
    ACTIONS(2566), 1,
      sym__varid,
    ACTIONS(4423), 1,
      sym__conid,
    STATE(4652), 1,
      sym_constructor,
    STATE(4840), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530449] = 9,
    ACTIONS(1899), 1,
      sym__varid,
    ACTIONS(1965), 1,
      sym__conid,
    STATE(3742), 1,
      sym_constructor,
    STATE(3790), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530481] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 9,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [530517] = 9,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    STATE(10276), 1,
      sym_constructor,
    STATE(10565), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530549] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [530569] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530587] = 9,
    ACTIONS(2283), 1,
      sym__varid,
    ACTIONS(4427), 1,
      sym__conid,
    STATE(4643), 1,
      sym_constructor,
    STATE(4787), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530619] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [530641] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 7,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [530661] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18687), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [530679] = 9,
    ACTIONS(1918), 1,
      sym__varid,
    ACTIONS(4851), 1,
      sym__conid,
    STATE(4192), 1,
      sym_constructor,
    STATE(4270), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530711] = 9,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    STATE(10565), 1,
      sym_variable,
    STATE(11465), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530743] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 9,
      sym__varsym,
      sym__consym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [530761] = 4,
    ACTIONS(11035), 1,
      anon_sym_LBRACE,
    STATE(14728), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [530783] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530801] = 9,
    ACTIONS(20610), 1,
      anon_sym_RBRACK,
    ACTIONS(20612), 1,
      anon_sym_PIPE,
    ACTIONS(20614), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20616), 1,
      sym__arith_dotdot,
    ACTIONS(20618), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(18320), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530851] = 9,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(1899), 1,
      sym__varid,
    STATE(3790), 1,
      sym_variable,
    STATE(4272), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530883] = 9,
    ACTIONS(4635), 1,
      sym__varid,
    ACTIONS(4837), 1,
      sym__conid,
    STATE(11181), 1,
      sym_constructor,
    STATE(11702), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530915] = 4,
    STATE(13963), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20582), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20475), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [530937] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [530955] = 9,
    ACTIONS(10032), 1,
      sym__varid,
    ACTIONS(10046), 1,
      sym__conid,
    STATE(12124), 1,
      sym_constructor,
    STATE(13154), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530987] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531005] = 9,
    ACTIONS(1995), 1,
      sym__varid,
    ACTIONS(2003), 1,
      sym__conid,
    STATE(4571), 1,
      sym_constructor,
    STATE(5187), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531037] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [531057] = 7,
    ACTIONS(20620), 1,
      anon_sym_PIPE,
    ACTIONS(20622), 1,
      sym_where,
    STATE(16187), 1,
      sym_fundeps,
    STATE(18189), 1,
      sym_class_body,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(20443), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531085] = 9,
    ACTIONS(23), 1,
      sym__conid,
    ACTIONS(3091), 1,
      sym__varid,
    STATE(4176), 1,
      sym_constructor,
    STATE(6024), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531117] = 9,
    ACTIONS(183), 1,
      sym__conid,
    ACTIONS(3143), 1,
      sym__varid,
    STATE(4180), 1,
      sym_constructor,
    STATE(5124), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531149] = 9,
    ACTIONS(4455), 1,
      sym__varid,
    ACTIONS(4467), 1,
      sym__conid,
    STATE(10276), 1,
      sym_constructor,
    STATE(10500), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531181] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531199] = 5,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(20441), 1,
      anon_sym_LPAREN,
    STATE(14060), 2,
      sym_type_variable,
      aux_sym__simpletype_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20023), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [531223] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531241] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531259] = 9,
    ACTIONS(3563), 1,
      sym__varid,
    ACTIONS(3579), 1,
      sym__conid,
    STATE(10674), 1,
      sym_constructor,
    STATE(10765), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531291] = 10,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20624), 1,
      anon_sym_LPAREN,
    ACTIONS(20626), 1,
      sym__conid,
    STATE(13075), 1,
      sym_constructor,
    STATE(13383), 1,
      sym_tyfam_head,
    STATE(14488), 1,
      sym__simpletype_infix,
    STATE(14570), 1,
      sym__simpletype,
    STATE(15540), 1,
      sym_type_variable,
    STATE(16389), 1,
      sym__tyfam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531325] = 9,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    STATE(10565), 1,
      sym_variable,
    STATE(11573), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531357] = 4,
    STATE(14111), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(20503), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20628), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [531379] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [531397] = 9,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(4861), 1,
      sym__varid,
    STATE(10565), 1,
      sym_variable,
    STATE(11850), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531429] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531447] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [531469] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [531487] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [531505] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [531523] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531541] = 5,
    STATE(2464), 1,
      sym__colon2,
    STATE(16183), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20560), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [531565] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531583] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531601] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(17926), 1,
      sym_modifier,
    ACTIONS(20633), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(3131), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(20631), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531627] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 9,
      sym__consym,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [531645] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [531663] = 10,
    ACTIONS(20059), 1,
      sym__varid,
    ACTIONS(20469), 1,
      anon_sym_LPAREN,
    ACTIONS(20471), 1,
      sym__conid,
    ACTIONS(20635), 1,
      anon_sym_family,
    STATE(13859), 1,
      sym_constructor,
    STATE(14918), 1,
      sym__simpletype,
    STATE(15028), 1,
      sym__simpletype_infix,
    STATE(15091), 1,
      sym_type_variable,
    STATE(19293), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531697] = 9,
    ACTIONS(2896), 1,
      sym__varid,
    ACTIONS(4453), 1,
      sym__conid,
    STATE(4899), 1,
      sym_constructor,
    STATE(5561), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(20436), 1,
      sym__do_keyword,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(19093), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531729] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20637), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [531746] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [531765] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [531782] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 8,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [531799] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20346), 8,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [531816] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [531833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20639), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [531850] = 3,
    ACTIONS(17046), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [531869] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20643), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23127), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531898] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 7,
      sym__layout_semicolon,
      sym__dot,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [531917] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20645), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [531934] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20647), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531963] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20649), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [531980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [531997] = 7,
    ACTIONS(19865), 1,
      anon_sym_DASH,
    ACTIONS(19869), 1,
      sym__varsym,
    ACTIONS(19871), 1,
      sym__consym,
    ACTIONS(20651), 1,
      anon_sym_BQUOTE,
    STATE(16091), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16918), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532024] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20261), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23352), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532053] = 4,
    ACTIONS(20655), 1,
      sym__varid,
    STATE(14144), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20653), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [532074] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [532095] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [532114] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20293), 1,
      sym_constructor,
    STATE(23300), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532143] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20658), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23076), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532172] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [532189] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20660), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22300), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532218] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20259), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23355), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532247] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18606), 1,
      sym_guards,
    STATE(14358), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20662), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [532270] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [532289] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20645), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [532306] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20664), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22874), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532335] = 7,
    ACTIONS(19877), 1,
      anon_sym_DASH,
    ACTIONS(19881), 1,
      sym__varsym,
    ACTIONS(19883), 1,
      sym__consym,
    ACTIONS(20666), 1,
      anon_sym_BQUOTE,
    STATE(15702), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16940), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532362] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20264), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23346), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532391] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20668), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23079), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532420] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20670), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22705), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532449] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [532468] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20672), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23073), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532497] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20674), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22503), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532526] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [532545] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20287), 1,
      sym_constructor,
    STATE(23310), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532574] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [532593] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20265), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23343), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532622] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20676), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [532639] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 8,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [532656] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20680), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19907), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532685] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20283), 1,
      sym_constructor,
    STATE(23315), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532714] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [532733] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 8,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [532750] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [532767] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [532784] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20682), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23070), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532813] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20684), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22887), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532842] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20686), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22519), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532871] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20688), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22326), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532900] = 7,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(20696), 1,
      anon_sym_qualified,
    ACTIONS(20698), 1,
      anon_sym_as,
    STATE(18244), 1,
      sym_import_list,
    ACTIONS(20690), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532927] = 8,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(20700), 1,
      sym_string,
    ACTIONS(20702), 1,
      anon_sym_qualified,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(14179), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532956] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [532973] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [532992] = 3,
    ACTIONS(20704), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [533011] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20463), 1,
      sym_constructor,
    STATE(22843), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533040] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [533061] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20281), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23319), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533090] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20706), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22270), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533119] = 4,
    ACTIONS(20582), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14328), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20708), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [533140] = 5,
    STATE(2506), 1,
      sym__colon2,
    STATE(16942), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20560), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [533163] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20710), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23082), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533192] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20266), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23340), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533221] = 4,
    ACTIONS(20473), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14328), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20708), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [533242] = 7,
    ACTIONS(19913), 1,
      anon_sym_DASH,
    ACTIONS(19917), 1,
      sym__varsym,
    ACTIONS(19919), 1,
      sym__consym,
    ACTIONS(20712), 1,
      anon_sym_BQUOTE,
    STATE(15514), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15832), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533269] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20714), 1,
      anon_sym_SEMI,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    STATE(16162), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17276), 1,
      sym_constructor,
    STATE(21071), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533298] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20279), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23322), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533327] = 7,
    ACTIONS(19913), 1,
      anon_sym_DASH,
    ACTIONS(19917), 1,
      sym__varsym,
    ACTIONS(19919), 1,
      sym__consym,
    ACTIONS(20718), 1,
      anon_sym_BQUOTE,
    STATE(15632), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15832), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533354] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20720), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22535), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533383] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20722), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23067), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533412] = 5,
    ACTIONS(19217), 1,
      anon_sym_EQ,
    ACTIONS(19221), 1,
      sym_where,
    ACTIONS(20724), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(18939), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533435] = 9,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(13751), 1,
      sym_constructor,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15422), 1,
      sym__simpletype,
    STATE(15596), 1,
      sym_type_variable,
    STATE(20609), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533466] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [533485] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20298), 1,
      sym_constructor,
    STATE(23290), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533514] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [533533] = 9,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20469), 1,
      anon_sym_LPAREN,
    ACTIONS(20471), 1,
      sym__conid,
    STATE(13859), 1,
      sym_constructor,
    STATE(14918), 1,
      sym__simpletype,
    STATE(15028), 1,
      sym__simpletype_infix,
    STATE(15091), 1,
      sym_type_variable,
    STATE(19005), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533564] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20302), 1,
      sym_constructor,
    STATE(23285), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533593] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 7,
      sym__dot,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [533612] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20726), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22900), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533641] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 8,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [533658] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [533675] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20728), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23064), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533704] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20730), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18893), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533733] = 5,
    STATE(2506), 1,
      sym__colon2,
    STATE(16985), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20477), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [533756] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20732), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23085), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533785] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20734), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22346), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533814] = 7,
    ACTIONS(19877), 1,
      anon_sym_DASH,
    ACTIONS(19881), 1,
      sym__varsym,
    ACTIONS(19883), 1,
      sym__consym,
    ACTIONS(20736), 1,
      anon_sym_BQUOTE,
    STATE(16940), 2,
      sym_operator,
      sym__minus,
    STATE(17670), 2,
      sym_varop,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533841] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20738), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23184), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533870] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [533887] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20740), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18338), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533916] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20257), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23358), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533945] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20742), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23061), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533974] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20744), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23181), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534003] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [534022] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20676), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [534039] = 6,
    ACTIONS(20746), 1,
      anon_sym_instance,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(18441), 1,
      sym__instance,
    STATE(20252), 2,
      sym_via,
      sym_deriving_strategy,
    ACTIONS(20233), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534064] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 8,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [534081] = 4,
    ACTIONS(20750), 1,
      sym__varid,
    STATE(14226), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20653), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [534102] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20753), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23088), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534131] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20755), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23178), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534160] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20757), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23091), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534189] = 6,
    ACTIONS(20376), 1,
      sym__conid,
    STATE(14230), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22604), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20374), 4,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      anon_sym_DASH,
  [534214] = 7,
    ACTIONS(19901), 1,
      anon_sym_DASH,
    ACTIONS(19905), 1,
      sym__varsym,
    ACTIONS(19907), 1,
      sym__consym,
    ACTIONS(20759), 1,
      anon_sym_BQUOTE,
    STATE(17321), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(17469), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534241] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20761), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22236), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534270] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20763), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23124), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534299] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20637), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [534316] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20765), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22551), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534345] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20256), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23361), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534374] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20767), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22926), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534403] = 3,
    ACTIONS(15339), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [534422] = 7,
    ACTIONS(19901), 1,
      anon_sym_DASH,
    ACTIONS(19905), 1,
      sym__varsym,
    ACTIONS(19907), 1,
      sym__consym,
    ACTIONS(20769), 1,
      anon_sym_BQUOTE,
    STATE(15896), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(17469), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534449] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20771), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22366), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534478] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20773), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23175), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534507] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    ACTIONS(20775), 1,
      anon_sym_SEMI,
    ACTIONS(20777), 1,
      anon_sym_RBRACE,
    STATE(17276), 1,
      sym_constructor,
    STATE(16613), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534536] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [534553] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20332), 1,
      sym_constructor,
    STATE(23240), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534582] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20779), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23172), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534611] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20253), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23364), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534640] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 8,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [534657] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [534674] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20781), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18524), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534703] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20334), 1,
      sym_constructor,
    STATE(23235), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534732] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [534749] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20317), 1,
      sym_constructor,
    STATE(23265), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534778] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20783), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23094), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534807] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20785), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22911), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534836] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20787), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22567), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534865] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20789), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22861), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534894] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20791), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22718), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [534940] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [534957] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20793), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23097), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534986] = 5,
    ACTIONS(20557), 1,
      anon_sym_PIPE,
    STATE(22248), 1,
      sym_guards,
    STATE(14261), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20555), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [535009] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20307), 1,
      sym_constructor,
    STATE(23280), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535038] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20795), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22914), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535067] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20797), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23169), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535096] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535115] = 5,
    ACTIONS(20557), 1,
      anon_sym_PIPE,
    STATE(22919), 1,
      sym_guards,
    STATE(14266), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20555), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [535138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7530), 8,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [535155] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535172] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20312), 1,
      sym_constructor,
    STATE(23275), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535201] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(20799), 1,
      sym_where,
    STATE(22248), 1,
      sym_guards,
    STATE(14261), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(20455), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535226] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20801), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22917), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535255] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(20803), 1,
      sym_where,
    STATE(22919), 1,
      sym_guards,
    STATE(14266), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(20455), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535280] = 3,
    ACTIONS(17086), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [535299] = 7,
    ACTIONS(20241), 1,
      anon_sym_in,
    ACTIONS(20805), 1,
      anon_sym_LBRACE,
    ACTIONS(20807), 1,
      sym__layout_start,
    STATE(17966), 1,
      sym_decls,
    STATE(23090), 1,
      sym__let_decls,
    ACTIONS(20237), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535326] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20809), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [535345] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [535364] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20813), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22920), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535393] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20815), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22923), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535422] = 4,
    ACTIONS(12260), 1,
      anon_sym_LBRACE,
    STATE(15317), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [535443] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [535462] = 7,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(20819), 1,
      anon_sym_qualified,
    ACTIONS(20821), 1,
      anon_sym_as,
    STATE(17975), 1,
      sym_import_list,
    ACTIONS(20817), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535489] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20823), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22583), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535518] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20825), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22848), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535547] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535564] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20827), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23100), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535610] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [535631] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20829), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22692), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535660] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20831), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22929), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535689] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20833), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23058), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535718] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20835), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18257), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535747] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535764] = 7,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(20843), 1,
      anon_sym_qualified,
    ACTIONS(20845), 1,
      anon_sym_as,
    STATE(18769), 1,
      sym_import_list,
    ACTIONS(20837), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535791] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535808] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535825] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535842] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20340), 1,
      sym_constructor,
    STATE(23222), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535871] = 4,
    ACTIONS(12351), 1,
      anon_sym_LBRACE,
    STATE(15472), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [535892] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535909] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [535926] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15411), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [535947] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20847), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22932), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535976] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [535997] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20296), 1,
      sym_constructor,
    STATE(23295), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536026] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536043] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20849), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22386), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536072] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20851), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18170), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536101] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20853), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22182), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536130] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20274), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23334), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536159] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536176] = 5,
    STATE(2506), 1,
      sym__colon2,
    STATE(16878), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20451), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [536199] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536216] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20809), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [536235] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20855), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(20166), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536264] = 8,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(14901), 1,
      sym_constructor,
    STATE(15378), 1,
      aux_sym__qualifying_module,
    STATE(22723), 1,
      sym__modid,
    STATE(22525), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536293] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [536310] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [536329] = 7,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(20859), 1,
      anon_sym_qualified,
    ACTIONS(20861), 1,
      anon_sym_as,
    STATE(18763), 1,
      sym_import_list,
    ACTIONS(20857), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536356] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [536375] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536409] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [536428] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 8,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [536445] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536464] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    ACTIONS(20863), 1,
      anon_sym_SEMI,
    ACTIONS(20865), 1,
      anon_sym_RBRACE,
    STATE(17276), 1,
      sym_constructor,
    STATE(16713), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536493] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20345), 1,
      sym_constructor,
    STATE(23214), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536522] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20867), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22835), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536551] = 4,
    ACTIONS(20503), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14328), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20869), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [536572] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20353), 1,
      sym_constructor,
    STATE(23203), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536601] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20872), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23166), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536630] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20874), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22731), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536659] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20876), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22935), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536688] = 5,
    STATE(2476), 1,
      sym__colon2,
    STATE(17192), 1,
      sym__type_annotation,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20013), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [536711] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20364), 1,
      sym_constructor,
    STATE(23189), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536740] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20289), 1,
      sym_constructor,
    STATE(23305), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536769] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20878), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23163), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536798] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20880), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22938), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536827] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536844] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20882), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23266), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536873] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20884), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22941), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536902] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20886), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23121), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536931] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536948] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20709), 1,
      sym_constructor,
    STATE(22401), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22406), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536977] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [536994] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20888), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22944), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537023] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20890), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22599), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537052] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20892), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23130), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537081] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(17926), 1,
      sym_modifier,
    ACTIONS(20631), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(20894), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(3129), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537106] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20896), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22947), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537135] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20898), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22822), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537164] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20900), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23160), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537193] = 7,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(1415), 1,
      sym__arrow,
    STATE(17377), 1,
      sym__alt_variants,
    STATE(18606), 1,
      sym_guards,
    ACTIONS(11481), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14152), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537220] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [537239] = 5,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18988), 1,
      sym_where,
    ACTIONS(20902), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(19302), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537262] = 4,
    ACTIONS(12076), 1,
      anon_sym_LBRACE,
    STATE(15009), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [537283] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20248), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23370), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537312] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20904), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22679), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537341] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18606), 1,
      sym_guards,
    STATE(14358), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18543), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [537364] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20906), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22950), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537393] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [537410] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20908), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22953), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537439] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20247), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23373), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537468] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20263), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23349), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537497] = 4,
    ACTIONS(20910), 1,
      sym__varid,
    STATE(14226), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20912), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [537518] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20914), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22956), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537547] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20346), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [537564] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20916), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22959), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [537610] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [537629] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 8,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [537646] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20918), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22962), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537675] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20920), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22965), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537704] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [537721] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20922), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23154), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537750] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20246), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23376), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537779] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20924), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23133), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537808] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    ACTIONS(20926), 1,
      anon_sym_SEMI,
    ACTIONS(20928), 1,
      anon_sym_RBRACE,
    STATE(17276), 1,
      sym_constructor,
    STATE(16461), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537837] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20242), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23385), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537866] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [537883] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20930), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22666), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537912] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20932), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22809), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537941] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20934), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23118), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537970] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20936), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22968), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537999] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20938), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23103), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538028] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20940), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19086), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538057] = 5,
    ACTIONS(20557), 1,
      anon_sym_PIPE,
    STATE(22113), 1,
      sym_guards,
    STATE(14386), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20555), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [538080] = 7,
    ACTIONS(19865), 1,
      anon_sym_DASH,
    ACTIONS(19869), 1,
      sym__varsym,
    ACTIONS(19871), 1,
      sym__consym,
    ACTIONS(20942), 1,
      anon_sym_BQUOTE,
    STATE(16918), 2,
      sym_operator,
      sym__minus,
    STATE(17817), 2,
      sym_varop,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538107] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20944), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22971), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538136] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20946), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23106), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538165] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [538182] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20948), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23151), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538211] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    ACTIONS(20950), 1,
      anon_sym_SEMI,
    ACTIONS(20952), 1,
      anon_sym_RBRACE,
    STATE(17276), 1,
      sym_constructor,
    STATE(17193), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538240] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20954), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22796), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538269] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20250), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23367), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538298] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20956), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22974), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538327] = 7,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(20958), 1,
      anon_sym_qualified,
    ACTIONS(20960), 1,
      anon_sym_as,
    STATE(17941), 1,
      sym_import_list,
    ACTIONS(20857), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538354] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [538371] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20962), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22977), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538400] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [538419] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [538438] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20964), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22404), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538467] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20966), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22980), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538496] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20968), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18389), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538525] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20970), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22983), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538554] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20972), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22986), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538583] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(20974), 1,
      sym_where,
    STATE(22113), 1,
      sym_guards,
    STATE(14386), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(20455), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538608] = 6,
    STATE(2447), 1,
      sym__colon2,
    STATE(18047), 1,
      sym_kind,
    STATE(18049), 1,
      sym__type_annotation,
    ACTIONS(17899), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20976), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538633] = 7,
    ACTIONS(20374), 1,
      sym__consym,
    ACTIONS(20376), 1,
      sym__conid,
    STATE(14408), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23053), 1,
      sym__modid,
    ACTIONS(20372), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538660] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [538677] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20978), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22744), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538706] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20980), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22487), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538735] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [538752] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20982), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23148), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538781] = 7,
    ACTIONS(19930), 1,
      anon_sym_DASH,
    ACTIONS(19934), 1,
      sym__varsym,
    ACTIONS(19936), 1,
      sym__consym,
    ACTIONS(20984), 1,
      anon_sym_BQUOTE,
    STATE(16710), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(20030), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538808] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20277), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23328), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538837] = 3,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 6,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [538856] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [538875] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    ACTIONS(20986), 1,
      anon_sym_SEMI,
    ACTIONS(20988), 1,
      anon_sym_RBRACE,
    STATE(17276), 1,
      sym_constructor,
    STATE(17268), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538904] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [538923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7530), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [538940] = 6,
    ACTIONS(18393), 1,
      anon_sym_PERCENT,
    STATE(18539), 1,
      sym_modifier,
    ACTIONS(18387), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(20990), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(2603), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538965] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20992), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22783), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538994] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20994), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18644), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539023] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20996), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23109), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539052] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [539069] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(20998), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23145), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539098] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [539117] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [539134] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20245), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23379), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539163] = 7,
    ACTIONS(19930), 1,
      anon_sym_DASH,
    ACTIONS(19934), 1,
      sym__varsym,
    ACTIONS(19936), 1,
      sym__consym,
    ACTIONS(21000), 1,
      anon_sym_BQUOTE,
    STATE(19112), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(20030), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539190] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21002), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22421), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539219] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21004), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23142), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539248] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 8,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [539265] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21006), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22614), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539294] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [539311] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21008), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22653), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539340] = 5,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18988), 1,
      sym_where,
    ACTIONS(21010), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(18956), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539363] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21012), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22989), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539392] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [539411] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21014), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23157), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539440] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21016), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22093), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539469] = 7,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(21018), 1,
      anon_sym_qualified,
    ACTIONS(21020), 1,
      anon_sym_as,
    STATE(19691), 1,
      sym_import_list,
    ACTIONS(20817), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539496] = 7,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(1610), 1,
      sym__arrow,
    STATE(17916), 1,
      sym__alt_variants,
    STATE(18701), 1,
      sym_guards,
    ACTIONS(10996), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14695), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539523] = 6,
    STATE(2476), 1,
      sym__colon2,
    STATE(18551), 1,
      sym__type_annotation,
    STATE(18553), 1,
      sym_kind,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20976), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539548] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [539565] = 5,
    ACTIONS(18984), 1,
      anon_sym_EQ,
    ACTIONS(18988), 1,
      sym_where,
    ACTIONS(20724), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17917), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539588] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [539605] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21022), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22992), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539634] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21024), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22770), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539663] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21026), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22995), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539692] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [539713] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [539730] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(21028), 1,
      anon_sym_LPAREN,
    ACTIONS(21030), 1,
      anon_sym_RPAREN,
    ACTIONS(21032), 1,
      anon_sym_DOT_DOT,
    STATE(19726), 3,
      sym_variable,
      sym_constructor,
      sym__import_name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539757] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21034), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22998), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539786] = 7,
    ACTIONS(21036), 1,
      anon_sym_PIPE,
    ACTIONS(21038), 1,
      sym_where,
    STATE(16719), 1,
      sym_fundeps,
    STATE(20957), 1,
      sym_class_body,
    ACTIONS(20443), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539813] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21040), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23136), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539842] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21042), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23001), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539871] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [539890] = 3,
    ACTIONS(15643), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
  [539909] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [539926] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20270), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23337), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539955] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21044), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23004), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539984] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21046), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23007), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540013] = 7,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    ACTIONS(21048), 1,
      sym__tyconsym,
    STATE(22213), 2,
      sym_operator,
      sym__minus,
    STATE(22222), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540040] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [540059] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20276), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23331), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540088] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21050), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [540107] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [540124] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [540143] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [540160] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [540179] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21052), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23010), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540208] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [540225] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [540242] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20337), 1,
      sym_constructor,
    STATE(23229), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540271] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21054), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23013), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540300] = 8,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(21056), 1,
      sym_string,
    ACTIONS(21058), 1,
      anon_sym_qualified,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(14529), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540329] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [540348] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [540367] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21060), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23139), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540396] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21062), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22438), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540425] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21064), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23016), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540454] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21066), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23019), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540483] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21068), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23022), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540512] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20315), 1,
      sym_constructor,
    STATE(23270), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540541] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20649), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [540558] = 9,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(21070), 1,
      anon_sym_LPAREN,
    ACTIONS(21072), 1,
      sym__conid,
    STATE(13889), 1,
      sym_constructor,
    STATE(14754), 1,
      sym__simpletype,
    STATE(15022), 1,
      sym_type_variable,
    STATE(15859), 1,
      sym__simpletype_infix,
    STATE(18344), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540589] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21074), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [540606] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21076), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23025), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540635] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20243), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23382), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540664] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21078), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23028), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540693] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21080), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18051), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540722] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21082), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23031), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540751] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21084), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23034), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540780] = 3,
    ACTIONS(21086), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [540799] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21088), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22640), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540828] = 9,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(19942), 1,
      anon_sym_LPAREN,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(13751), 1,
      sym_constructor,
    STATE(15216), 1,
      sym__simpletype_infix,
    STATE(15422), 1,
      sym__simpletype,
    STATE(15596), 1,
      sym_type_variable,
    STATE(20949), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540859] = 8,
    ACTIONS(19221), 1,
      sym_where,
    ACTIONS(21090), 1,
      anon_sym_EQ,
    STATE(2506), 1,
      sym__colon2,
    STATE(18328), 1,
      sym__gadt_rhs,
    STATE(18333), 1,
      sym__newtype,
    STATE(20623), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540888] = 8,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(21092), 1,
      anon_sym_EQ,
    STATE(2506), 1,
      sym__colon2,
    STATE(20933), 1,
      sym__type_annotation,
    STATE(20943), 1,
      sym__gadt_rhs,
    STATE(20945), 1,
      sym__newtype,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540917] = 4,
    ACTIONS(20431), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14328), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20708), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [540938] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21094), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23037), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540967] = 7,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    ACTIONS(21096), 1,
      sym__tyconsym,
    STATE(22176), 2,
      sym_constructor_operator,
      sym__type_operator,
    STATE(22183), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540994] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(21098), 1,
      anon_sym_LPAREN,
    ACTIONS(21100), 1,
      anon_sym_RPAREN,
    ACTIONS(21102), 1,
      anon_sym_DOT_DOT,
    STATE(19607), 3,
      sym_variable,
      sym_constructor,
      sym__name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541021] = 8,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20716), 1,
      anon_sym_LPAREN,
    ACTIONS(21104), 1,
      anon_sym_SEMI,
    ACTIONS(21106), 1,
      anon_sym_RBRACE,
    STATE(17276), 1,
      sym_constructor,
    STATE(17010), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541050] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21074), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [541067] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [541086] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21108), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22757), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541115] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21110), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22455), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541144] = 8,
    ACTIONS(18988), 1,
      sym_where,
    ACTIONS(21112), 1,
      anon_sym_EQ,
    STATE(2506), 1,
      sym__colon2,
    STATE(18228), 1,
      sym__newtype,
    STATE(18231), 1,
      sym__gadt_rhs,
    STATE(20549), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541173] = 6,
    ACTIONS(20748), 1,
      anon_sym_via,
    ACTIONS(21114), 1,
      anon_sym_instance,
    STATE(18022), 1,
      sym__instance,
    STATE(20406), 2,
      sym_via,
      sym_deriving_strategy,
    ACTIONS(20233), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541198] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [541217] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20639), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [541234] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21116), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23040), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541263] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20330), 1,
      sym_constructor,
    STATE(23245), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541292] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20326), 1,
      sym_constructor,
    STATE(23250), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541321] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21118), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22471), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541350] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [541369] = 3,
    ACTIONS(21120), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [541388] = 9,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20469), 1,
      anon_sym_LPAREN,
    ACTIONS(20471), 1,
      sym__conid,
    STATE(13859), 1,
      sym_constructor,
    STATE(14918), 1,
      sym__simpletype,
    STATE(15028), 1,
      sym__simpletype_infix,
    STATE(15091), 1,
      sym_type_variable,
    STATE(18208), 1,
      sym__datafam,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541419] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21122), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23115), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541448] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21124), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23043), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541477] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [541494] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21126), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23046), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541523] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20322), 1,
      sym_constructor,
    STATE(23255), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541552] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20320), 1,
      sym_constructor,
    STATE(23260), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541581] = 4,
    ACTIONS(21128), 1,
      sym__varid,
    STATE(14144), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20912), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [541602] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21130), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23049), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541631] = 7,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(21132), 1,
      anon_sym_qualified,
    ACTIONS(21134), 1,
      anon_sym_as,
    STATE(17935), 1,
      sym_import_list,
    ACTIONS(20837), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541658] = 7,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(21136), 1,
      anon_sym_qualified,
    ACTIONS(21138), 1,
      anon_sym_as,
    STATE(18308), 1,
      sym_import_list,
    ACTIONS(20690), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541685] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21140), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(17904), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541714] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [541731] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21142), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19260), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541760] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [541777] = 8,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21144), 1,
      sym__unboxed_close,
    STATE(504), 1,
      sym__arrow,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18461), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541806] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21146), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23052), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541835] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21148), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(23055), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541864] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21050), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [541883] = 6,
    ACTIONS(20748), 1,
      anon_sym_via,
    ACTIONS(21150), 1,
      anon_sym_instance,
    STATE(20840), 1,
      sym__instance,
    STATE(20401), 2,
      sym_via,
      sym_deriving_strategy,
    ACTIONS(20233), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541908] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(21152), 1,
      sym_string,
    ACTIONS(21154), 1,
      anon_sym_qualified,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(14778), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541937] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [541954] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    ACTIONS(21156), 1,
      sym_quasiquote_bar,
    STATE(14901), 1,
      sym_constructor,
    STATE(14982), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    STATE(22627), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541983] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(15489), 1,
      aux_sym__qualifying_module,
    STATE(20278), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    STATE(23325), 1,
      sym_qualified_constructor,
    STATE(22850), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542012] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [542028] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542044] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542060] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [542076] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542092] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(20109), 1,
      sym__tyconsym,
    STATE(7034), 1,
      sym_constructor,
    STATE(15399), 1,
      aux_sym__qualifying_module,
    STATE(22112), 1,
      sym_constructor_operator,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542120] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542136] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [542152] = 4,
    ACTIONS(12628), 1,
      anon_sym_LBRACE,
    STATE(15677), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10390), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [542172] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [542188] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542204] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 7,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [542220] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542236] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542252] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542268] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542284] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542300] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542316] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542332] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542348] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [542364] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [542380] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542396] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542412] = 4,
    ACTIONS(21160), 1,
      sym__varid,
    STATE(14914), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20912), 4,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [542432] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542448] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542464] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21162), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [542480] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542496] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542512] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542528] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542544] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542562] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542578] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542594] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [542610] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542626] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542642] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [542658] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542676] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542692] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542708] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [542726] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [542742] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    ACTIONS(21166), 1,
      sym__layout_end,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542768] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542784] = 4,
    ACTIONS(21168), 1,
      sym__varid,
    STATE(14589), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20653), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [542804] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542820] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    STATE(14046), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20433), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [542840] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [542856] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [542874] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20624), 1,
      anon_sym_LPAREN,
    ACTIONS(20626), 1,
      sym__conid,
    STATE(11308), 1,
      sym__simpletype,
    STATE(13075), 1,
      sym_constructor,
    STATE(14488), 1,
      sym__simpletype_infix,
    STATE(15540), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542902] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [542918] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542936] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    ACTIONS(21171), 1,
      sym__layout_end,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542962] = 3,
    ACTIONS(21173), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [542996] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [543012] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    ACTIONS(21175), 1,
      sym__layout_end,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543038] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543056] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543074] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [543092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543108] = 7,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21181), 1,
      anon_sym_qualified,
    ACTIONS(21183), 1,
      anon_sym_as,
    STATE(21217), 1,
      sym_import_list,
    ACTIONS(20817), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543134] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [543150] = 6,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(21098), 1,
      anon_sym_LPAREN,
    ACTIONS(21185), 1,
      anon_sym_DOT_DOT,
    STATE(20913), 3,
      sym_variable,
      sym_constructor,
      sym__name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543190] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21106), 1,
      sym__layout_end,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    STATE(17036), 1,
      sym_constructor,
    STATE(17019), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543232] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543248] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543264] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543280] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543296] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543312] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [543328] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [543344] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543360] = 3,
    ACTIONS(15403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543378] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17500), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21187), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [543400] = 8,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(17152), 1,
      sym__consym,
    ACTIONS(21191), 1,
      sym__tyconsym,
    STATE(10660), 1,
      sym_constructor_operator,
    STATE(14901), 1,
      sym_constructor,
    STATE(15399), 1,
      aux_sym__qualifying_module,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543428] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543444] = 3,
    ACTIONS(15555), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [543462] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543478] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    ACTIONS(21193), 1,
      sym__layout_end,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543504] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543520] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [543536] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543552] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543568] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543584] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543600] = 5,
    ACTIONS(20557), 1,
      anon_sym_PIPE,
    STATE(22201), 1,
      sym_guards,
    STATE(14633), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(20555), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543622] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543638] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543654] = 4,
    ACTIONS(21197), 1,
      sym__varid,
    STATE(14680), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21195), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [543674] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [543690] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [543706] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543722] = 3,
    ACTIONS(21199), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [543740] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543756] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [543772] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543788] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 7,
      anon_sym_SEMI,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [543804] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543820] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [543836] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543868] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543884] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543900] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543916] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [543932] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [543948] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [543964] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [543996] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544012] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [544028] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544044] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544060] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544076] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544108] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [544124] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544140] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [544156] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544172] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544188] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544204] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [544220] = 6,
    ACTIONS(20376), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(20372), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544244] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544260] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544276] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544292] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544308] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544324] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544340] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544356] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544372] = 4,
    ACTIONS(21203), 1,
      sym__varid,
    STATE(14680), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20653), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [544392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544408] = 5,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(20724), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(21086), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544430] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [544446] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544462] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [544480] = 4,
    ACTIONS(17150), 1,
      anon_sym_EQ,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17144), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [544500] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544516] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544532] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544548] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544564] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544580] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [544596] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544612] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544628] = 5,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    STATE(18701), 1,
      sym_guards,
    STATE(14696), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(20662), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544650] = 5,
    ACTIONS(18547), 1,
      anon_sym_PIPE,
    STATE(18701), 1,
      sym_guards,
    STATE(14696), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(18543), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544672] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
  [544688] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [544706] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [544722] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544738] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544754] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [544770] = 7,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21206), 1,
      anon_sym_qualified,
    ACTIONS(21208), 1,
      anon_sym_as,
    STATE(21058), 1,
      sym_import_list,
    ACTIONS(20837), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544796] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544812] = 7,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21210), 1,
      anon_sym_qualified,
    ACTIONS(21212), 1,
      anon_sym_as,
    STATE(21053), 1,
      sym_import_list,
    ACTIONS(20857), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544838] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544854] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [544870] = 6,
    STATE(2508), 1,
      sym__colon2,
    STATE(20308), 1,
      sym__type_annotation,
    STATE(20310), 1,
      sym_kind,
    ACTIONS(18539), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20976), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544894] = 6,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(21216), 1,
      anon_sym_as,
    STATE(19700), 1,
      sym_import_list,
    ACTIONS(21214), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544918] = 7,
    ACTIONS(20241), 1,
      anon_sym_in,
    ACTIONS(21218), 1,
      anon_sym_LBRACE,
    ACTIONS(21220), 1,
      sym__layout_start,
    STATE(21034), 1,
      sym_decls,
    STATE(23090), 1,
      sym__let_decls,
    ACTIONS(20237), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544944] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [544960] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16955), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21187), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [544982] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
  [544998] = 6,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(21226), 1,
      anon_sym_as,
    STATE(19672), 1,
      sym_import_list,
    ACTIONS(21224), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545022] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545038] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545054] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21162), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [545070] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545086] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545102] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545118] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 7,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [545134] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545150] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545166] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545182] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545198] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 7,
      sym__varsym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545214] = 6,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(21228), 1,
      anon_sym_as,
    STATE(17977), 1,
      sym_import_list,
    ACTIONS(21214), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545238] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545254] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545270] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545286] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545302] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [545318] = 6,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(20845), 1,
      anon_sym_as,
    STATE(18769), 1,
      sym_import_list,
    ACTIONS(20837), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545358] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545374] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545390] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545406] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20865), 1,
      sym__layout_end,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    STATE(17036), 1,
      sym_constructor,
    STATE(16716), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545432] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545448] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545464] = 6,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(21230), 1,
      anon_sym_as,
    STATE(17972), 1,
      sym_import_list,
    ACTIONS(21224), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545488] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545506] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545522] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545538] = 6,
    STATE(2472), 1,
      sym__colon2,
    STATE(20999), 1,
      sym__type_annotation,
    STATE(21002), 1,
      sym_kind,
    ACTIONS(18265), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20976), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545562] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545578] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [545594] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [545610] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545626] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545642] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545658] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545674] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545690] = 5,
    STATE(2463), 1,
      sym__colon2,
    STATE(18937), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(21232), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545712] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [545728] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545744] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545760] = 6,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(21236), 1,
      anon_sym_as,
    STATE(18058), 1,
      sym_import_list,
    ACTIONS(21234), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545800] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545816] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 7,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_AT2,
  [545832] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545848] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21238), 1,
      sym_where,
    STATE(22201), 1,
      sym_guards,
    ACTIONS(20455), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14633), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545872] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [545888] = 4,
    ACTIONS(21240), 1,
      sym__varid,
    STATE(14765), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20653), 4,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
  [545908] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [545924] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20676), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [545940] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545956] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545972] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [545988] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20435), 1,
      anon_sym_LPAREN,
    ACTIONS(20437), 1,
      sym__conid,
    STATE(11804), 1,
      sym__simpletype,
    STATE(13520), 1,
      sym_constructor,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(15014), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546016] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546032] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546048] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    STATE(14192), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20708), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [546068] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [546084] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546100] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [546116] = 7,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21243), 1,
      anon_sym_qualified,
    ACTIONS(21245), 1,
      anon_sym_as,
    STATE(20931), 1,
      sym_import_list,
    ACTIONS(20690), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546142] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546158] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546190] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [546206] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [546222] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546238] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [546254] = 6,
    ACTIONS(20447), 1,
      anon_sym_PIPE,
    ACTIONS(20449), 1,
      sym_where,
    STATE(15667), 1,
      sym_fundeps,
    STATE(19068), 1,
      sym_class_body,
    ACTIONS(21247), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546278] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546294] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [546310] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546326] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16357), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21249), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [546348] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546364] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546380] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
  [546396] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20624), 1,
      anon_sym_LPAREN,
    ACTIONS(20626), 1,
      sym__conid,
    STATE(11526), 1,
      sym__simpletype,
    STATE(13075), 1,
      sym_constructor,
    STATE(14488), 1,
      sym__simpletype_infix,
    STATE(15540), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546424] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [546440] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20435), 1,
      anon_sym_LPAREN,
    ACTIONS(20437), 1,
      sym__conid,
    STATE(11882), 1,
      sym__simpletype,
    STATE(13520), 1,
      sym_constructor,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(15014), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546468] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546484] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(21251), 1,
      sym_string,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(14703), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546510] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [546526] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [546542] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546558] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [546574] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546590] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20435), 1,
      anon_sym_LPAREN,
    ACTIONS(20437), 1,
      sym__conid,
    STATE(13520), 1,
      sym_constructor,
    STATE(14860), 1,
      sym__simpletype_infix,
    STATE(15014), 1,
      sym_type_variable,
    STATE(16852), 1,
      sym__simpletype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546618] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546634] = 4,
    ACTIONS(21253), 1,
      sym__varid,
    STATE(14589), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21195), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [546654] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546670] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546686] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546702] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20346), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
  [546718] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546736] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546754] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546786] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546802] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546820] = 5,
    ACTIONS(21255), 1,
      sym__varid,
    STATE(19108), 1,
      sym_safety,
    ACTIONS(21257), 2,
      sym_string,
      anon_sym_LPAREN,
    ACTIONS(21259), 3,
      anon_sym_unsafe,
      anon_sym_safe,
      anon_sym_interruptible,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546842] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [546858] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546874] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546890] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546906] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546922] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546938] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546954] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [546970] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [546986] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547002] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17444), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21249), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [547024] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547040] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547058] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21261), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [547074] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547090] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547106] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547122] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [547138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547154] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [547170] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547186] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547202] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547218] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [547234] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547250] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21050), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [547268] = 7,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(21263), 1,
      sym_string,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(14293), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547294] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [547312] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [547328] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547344] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547360] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547376] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547408] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [547424] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [547440] = 5,
    STATE(2447), 1,
      sym__colon2,
    STATE(18605), 1,
      sym__type_annotation,
    ACTIONS(17899), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20013), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547462] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547478] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547494] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [547510] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547526] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    ACTIONS(21265), 1,
      sym__layout_end,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547552] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21074), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [547568] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547584] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [547600] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547618] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [547634] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20809), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [547652] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20637), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [547668] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547684] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [547700] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [547716] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [547732] = 6,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    ACTIONS(21267), 1,
      anon_sym_as,
    STATE(19765), 1,
      sym_import_list,
    ACTIONS(21234), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547756] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [547772] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    ACTIONS(21269), 1,
      sym__layout_end,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547798] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [547814] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547830] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [547846] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [547862] = 3,
    ACTIONS(20372), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20374), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      sym__conid,
  [547880] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547896] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [547912] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [547928] = 5,
    ACTIONS(21273), 1,
      anon_sym_LBRACE,
    ACTIONS(21275), 1,
      sym__layout_start,
    STATE(17325), 1,
      sym_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21271), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [547950] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [547966] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20645), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [547982] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [547998] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [548014] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [548030] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548046] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548062] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 7,
      sym__varsym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [548078] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548094] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [548110] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548126] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548142] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548158] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548190] = 5,
    ACTIONS(21273), 1,
      anon_sym_LBRACE,
    ACTIONS(21275), 1,
      sym__layout_start,
    STATE(17400), 1,
      sym_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [548212] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548228] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548244] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7530), 7,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [548260] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548276] = 5,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(20902), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(20544), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548298] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [548314] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548332] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548348] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548364] = 7,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(20988), 1,
      sym__layout_end,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    STATE(17036), 1,
      sym_constructor,
    STATE(17273), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548390] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548406] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548422] = 6,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    ACTIONS(21134), 1,
      anon_sym_as,
    STATE(17935), 1,
      sym_import_list,
    ACTIONS(20837), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548446] = 3,
    ACTIONS(21279), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548464] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548480] = 4,
    ACTIONS(21281), 1,
      sym__varid,
    STATE(14914), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20653), 4,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [548500] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548516] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548532] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [548548] = 5,
    STATE(2453), 1,
      sym__colon2,
    STATE(17920), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(21232), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548570] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548586] = 5,
    ACTIONS(19816), 1,
      anon_sym_EQ,
    ACTIONS(19820), 1,
      sym_where,
    ACTIONS(21010), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(20627), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548608] = 6,
    ACTIONS(20620), 1,
      anon_sym_PIPE,
    ACTIONS(20622), 1,
      sym_where,
    STATE(16089), 1,
      sym_fundeps,
    STATE(17849), 1,
      sym_class_body,
    ACTIONS(21247), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548632] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [548648] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 7,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548664] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548680] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548696] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [548712] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [548728] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548744] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [548778] = 7,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(21284), 1,
      sym_string,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(14528), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548804] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [548820] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548836] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548868] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548884] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548900] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [548916] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20499), 1,
      anon_sym_LPAREN,
    ACTIONS(20501), 1,
      sym__conid,
    STATE(11190), 1,
      sym__simpletype,
    STATE(13053), 1,
      sym_constructor,
    STATE(14505), 1,
      sym__simpletype_infix,
    STATE(15181), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548944] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [548960] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 7,
      sym__consym,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [548976] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20649), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [548992] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549008] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [549024] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549040] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [549056] = 8,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20109), 1,
      sym__tyconsym,
    STATE(14901), 1,
      sym_constructor,
    STATE(15399), 1,
      aux_sym__qualifying_module,
    STATE(22112), 1,
      sym_constructor_operator,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549084] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549100] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [549116] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [549132] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549148] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549164] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549180] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [549196] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549212] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [549228] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549244] = 8,
    ACTIONS(19940), 1,
      sym__varid,
    ACTIONS(20499), 1,
      anon_sym_LPAREN,
    ACTIONS(20501), 1,
      sym__conid,
    STATE(11172), 1,
      sym__simpletype,
    STATE(13053), 1,
      sym_constructor,
    STATE(14505), 1,
      sym__simpletype_infix,
    STATE(15181), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549272] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549288] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21261), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [549304] = 4,
    ACTIONS(7530), 1,
      sym__dot,
    STATE(13917), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20475), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [549324] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [549340] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [549356] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [549372] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549388] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20639), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [549404] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549420] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 7,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [549436] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [549453] = 7,
    ACTIONS(21286), 1,
      anon_sym_RBRACK,
    ACTIONS(21288), 1,
      anon_sym_PIPE,
    ACTIONS(21290), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21292), 1,
      sym__arith_dotdot,
    ACTIONS(21294), 1,
      sym_comma,
    STATE(19210), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549478] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21296), 1,
      anon_sym_EQ,
    STATE(18102), 1,
      sym__funrhs,
    STATE(22919), 1,
      sym_guards,
    STATE(14272), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549501] = 7,
    ACTIONS(4431), 1,
      sym__conid,
    ACTIONS(19107), 1,
      sym__varid,
    STATE(4644), 1,
      sym_constructor,
    STATE(4900), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549526] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549541] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(20014), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549564] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 6,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [549579] = 5,
    ACTIONS(21298), 1,
      anon_sym_LBRACE,
    ACTIONS(21300), 1,
      sym__layout_start,
    STATE(17848), 1,
      sym_decls,
    ACTIONS(21271), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549600] = 7,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(19002), 1,
      sym__varid,
    STATE(5995), 1,
      sym_constructor,
    STATE(6368), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549625] = 7,
    ACTIONS(21302), 1,
      anon_sym_RBRACK,
    ACTIONS(21304), 1,
      anon_sym_PIPE,
    ACTIONS(21306), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21308), 1,
      sym__arith_dotdot,
    ACTIONS(21310), 1,
      sym_comma,
    STATE(18912), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549650] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549669] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549684] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17619), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21314), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [549703] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(20641), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(22148), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549728] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21296), 1,
      anon_sym_EQ,
    STATE(18090), 1,
      sym__funrhs,
    STATE(22919), 1,
      sym_guards,
    STATE(14272), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549751] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 6,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [549766] = 7,
    ACTIONS(15325), 1,
      sym__conid,
    ACTIONS(19315), 1,
      sym__varid,
    STATE(13968), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14909), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549791] = 7,
    ACTIONS(4491), 1,
      sym__conid,
    ACTIONS(19667), 1,
      sym__varid,
    STATE(5878), 1,
      sym_constructor,
    STATE(6024), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549816] = 7,
    ACTIONS(8802), 1,
      sym__conid,
    ACTIONS(19329), 1,
      sym__varid,
    STATE(7252), 1,
      sym_constructor,
    STATE(7760), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549841] = 7,
    ACTIONS(21316), 1,
      anon_sym_RBRACK,
    ACTIONS(21318), 1,
      anon_sym_PIPE,
    ACTIONS(21320), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21322), 1,
      sym__arith_dotdot,
    ACTIONS(21324), 1,
      sym_comma,
    STATE(17932), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549866] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(19700), 1,
      sym_import_list,
    ACTIONS(21214), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549887] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(18268), 1,
      sym_import_list,
    ACTIONS(21326), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549908] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549923] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(18270), 1,
      sym_import_list,
    ACTIONS(21328), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549944] = 7,
    ACTIONS(21330), 1,
      anon_sym_RBRACK,
    ACTIONS(21332), 1,
      anon_sym_PIPE,
    ACTIONS(21334), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21336), 1,
      sym__arith_dotdot,
    ACTIONS(21338), 1,
      sym_comma,
    STATE(19618), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549969] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [549984] = 5,
    ACTIONS(21340), 1,
      anon_sym_LBRACE,
    ACTIONS(21342), 1,
      sym__layout_start,
    STATE(20144), 1,
      sym_decls,
    ACTIONS(21277), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550005] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21344), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550024] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [550039] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2463), 1,
      sym__colon2,
    STATE(15229), 1,
      aux_sym_signature_repeat1,
    STATE(18497), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550062] = 4,
    ACTIONS(21348), 1,
      sym_comma,
    STATE(14999), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21346), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [550081] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19435), 1,
      sym_via,
    ACTIONS(21249), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550102] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(18272), 1,
      sym_import_list,
    ACTIONS(21351), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550123] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [550138] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21353), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550157] = 7,
    ACTIONS(20590), 1,
      anon_sym_RBRACK,
    ACTIONS(20592), 1,
      anon_sym_PIPE,
    ACTIONS(20594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20596), 1,
      sym__arith_dotdot,
    ACTIONS(20598), 1,
      sym_comma,
    STATE(19940), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550182] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21355), 1,
      sym__tyconsym,
    STATE(17951), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550203] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(18100), 1,
      sym__arrow,
    ACTIONS(21357), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14765), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550224] = 7,
    ACTIONS(21359), 1,
      anon_sym_RBRACK,
    ACTIONS(21361), 1,
      anon_sym_PIPE,
    ACTIONS(21363), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21365), 1,
      sym__arith_dotdot,
    ACTIONS(21367), 1,
      sym_comma,
    STATE(19377), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550249] = 3,
    STATE(14094), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20475), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [550266] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [550281] = 4,
    ACTIONS(21371), 1,
      anon_sym_PIPE,
    STATE(15010), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21369), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [550300] = 4,
    ACTIONS(21376), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21374), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550319] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [550334] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [550349] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21379), 1,
      sym__tyconsym,
    STATE(17902), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550370] = 7,
    ACTIONS(12189), 1,
      sym__conid,
    ACTIONS(19379), 1,
      sym__varid,
    STATE(8945), 1,
      sym_constructor,
    STATE(9443), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550395] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [550410] = 7,
    ACTIONS(15293), 1,
      sym__conid,
    ACTIONS(19335), 1,
      sym__varid,
    STATE(14287), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15408), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550435] = 7,
    ACTIONS(8694), 1,
      sym__conid,
    ACTIONS(19299), 1,
      sym__varid,
    STATE(7409), 1,
      sym_constructor,
    STATE(7748), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550460] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2488), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(18145), 1,
      sym__type_annotation,
    ACTIONS(21381), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550483] = 6,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21383), 1,
      anon_sym_as,
    STATE(21225), 1,
      sym_import_list,
    ACTIONS(21234), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550506] = 6,
    ACTIONS(20009), 1,
      anon_sym_DASH,
    ACTIONS(20011), 1,
      anon_sym_BQUOTE,
    ACTIONS(20015), 1,
      sym__varsym,
    STATE(3156), 1,
      sym_varop,
    STATE(10510), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550529] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21385), 1,
      sym__tyconsym,
    STATE(18168), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550550] = 4,
    ACTIONS(21389), 1,
      sym_comma,
    STATE(15453), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21387), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [550569] = 7,
    ACTIONS(16004), 1,
      sym__conid,
    ACTIONS(19020), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15696), 1,
      sym_constructor,
    STATE(17812), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550594] = 7,
    ACTIONS(5706), 1,
      sym__conid,
    ACTIONS(19465), 1,
      sym__varid,
    STATE(7445), 1,
      sym_constructor,
    STATE(7687), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550619] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [550634] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
  [550649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21074), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [550664] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 6,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [550679] = 7,
    ACTIONS(14827), 1,
      sym__conid,
    ACTIONS(19287), 1,
      sym__varid,
    STATE(9405), 1,
      sym_constructor,
    STATE(9761), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550704] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 6,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [550719] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [550734] = 6,
    ACTIONS(16854), 1,
      sym__conid,
    STATE(16969), 1,
      aux_sym__qualifying_module,
    STATE(18670), 1,
      sym__modid,
    STATE(19912), 1,
      sym_constructor,
    STATE(20697), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550757] = 4,
    ACTIONS(21393), 1,
      anon_sym_PIPE,
    STATE(17446), 1,
      sym_tyfam_injectivity,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21391), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [550776] = 7,
    ACTIONS(15307), 1,
      sym__conid,
    ACTIONS(19293), 1,
      sym__varid,
    STATE(14145), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15235), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550801] = 3,
    ACTIONS(21397), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21395), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [550818] = 7,
    ACTIONS(103), 1,
      sym__conid,
    ACTIONS(19136), 1,
      sym__varid,
    STATE(4272), 1,
      sym_constructor,
    STATE(8666), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550843] = 7,
    ACTIONS(20421), 1,
      anon_sym_RBRACK,
    ACTIONS(20423), 1,
      anon_sym_PIPE,
    ACTIONS(20425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20427), 1,
      sym__arith_dotdot,
    ACTIONS(20429), 1,
      sym_comma,
    STATE(18031), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550868] = 4,
    ACTIONS(21401), 1,
      anon_sym_PIPE,
    STATE(15212), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21399), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [550887] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 6,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [550902] = 4,
    ACTIONS(21401), 1,
      anon_sym_PIPE,
    STATE(15055), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21399), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [550921] = 7,
    ACTIONS(20459), 1,
      anon_sym_RBRACK,
    ACTIONS(20461), 1,
      anon_sym_PIPE,
    ACTIONS(20463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20465), 1,
      sym__arith_dotdot,
    ACTIONS(20467), 1,
      sym_comma,
    STATE(18618), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550946] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [550961] = 7,
    ACTIONS(21403), 1,
      anon_sym_RBRACK,
    ACTIONS(21405), 1,
      anon_sym_PIPE,
    ACTIONS(21407), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21409), 1,
      sym__arith_dotdot,
    ACTIONS(21411), 1,
      sym_comma,
    STATE(19779), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550986] = 7,
    ACTIONS(21413), 1,
      anon_sym_RBRACK,
    ACTIONS(21415), 1,
      anon_sym_PIPE,
    ACTIONS(21417), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21419), 1,
      sym__arith_dotdot,
    ACTIONS(21421), 1,
      sym_comma,
    STATE(18073), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551011] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [551026] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [551041] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21423), 1,
      sym__tyconsym,
    STATE(18195), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551062] = 7,
    ACTIONS(15742), 1,
      sym__conid,
    ACTIONS(19032), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15458), 1,
      sym_constructor,
    STATE(15813), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551087] = 7,
    ACTIONS(4617), 1,
      sym__conid,
    ACTIONS(19361), 1,
      sym__varid,
    STATE(4468), 1,
      sym_constructor,
    STATE(4684), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551112] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [551127] = 7,
    ACTIONS(1965), 1,
      sym__conid,
    ACTIONS(19311), 1,
      sym__varid,
    STATE(3742), 1,
      sym_constructor,
    STATE(3790), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551152] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [551167] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20637), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [551182] = 4,
    ACTIONS(21425), 1,
      anon_sym_PIPE,
    STATE(15055), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21369), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [551201] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17302), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21428), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [551220] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [551235] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(14281), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551258] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17290), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [551277] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21432), 1,
      anon_sym_EQ,
    STATE(18882), 1,
      sym__funrhs,
    STATE(22248), 1,
      sym_guards,
    STATE(14270), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551300] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17771), 1,
      sym__tyconsym,
    STATE(19368), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551321] = 7,
    ACTIONS(6192), 1,
      sym__conid,
    ACTIONS(19673), 1,
      sym__varid,
    STATE(4215), 1,
      sym_constructor,
    STATE(4299), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551346] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(21434), 1,
      anon_sym_LPAREN,
    STATE(14774), 1,
      sym_constructor,
    STATE(15618), 1,
      sym_qualified_type,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551371] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16558), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21430), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [551390] = 7,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(21436), 1,
      anon_sym_LPAREN,
    STATE(15796), 1,
      sym_constructor,
    STATE(16476), 1,
      aux_sym__qualifying_module,
    STATE(16963), 1,
      sym_qualified_type,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551415] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(15467), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551438] = 7,
    ACTIONS(9356), 1,
      sym__conid,
    ACTIONS(19369), 1,
      sym__varid,
    STATE(11469), 1,
      sym_constructor,
    STATE(11651), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551463] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [551478] = 7,
    ACTIONS(4689), 1,
      sym__conid,
    ACTIONS(19046), 1,
      sym__varid,
    STATE(11465), 1,
      sym_constructor,
    STATE(12067), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551503] = 3,
    STATE(14500), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20708), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [551520] = 7,
    ACTIONS(15333), 1,
      sym__conid,
    ACTIONS(18990), 1,
      sym__varid,
    STATE(13995), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14782), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551545] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16552), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21428), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [551564] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21438), 1,
      sym_string,
    ACTIONS(21440), 1,
      anon_sym_LPAREN,
    STATE(15170), 1,
      sym_variable,
    STATE(17340), 1,
      sym_impent,
    STATE(17899), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551589] = 7,
    ACTIONS(4741), 1,
      sym__conid,
    ACTIONS(19351), 1,
      sym__varid,
    STATE(11850), 1,
      sym_constructor,
    STATE(12750), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551614] = 4,
    ACTIONS(21442), 1,
      sym__varid,
    STATE(15075), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(20653), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551633] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21440), 1,
      anon_sym_LPAREN,
    ACTIONS(21445), 1,
      sym_string,
    STATE(15170), 1,
      sym_variable,
    STATE(17339), 1,
      sym_expent,
    STATE(17873), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551658] = 3,
    STATE(13875), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20433), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [551675] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 6,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [551690] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [551705] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [551720] = 7,
    ACTIONS(8229), 1,
      sym__conid,
    ACTIONS(19373), 1,
      sym__varid,
    STATE(7675), 1,
      sym_constructor,
    STATE(7982), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551745] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(20126), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551768] = 7,
    ACTIONS(21447), 1,
      anon_sym_RBRACK,
    ACTIONS(21449), 1,
      anon_sym_PIPE,
    ACTIONS(21451), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21453), 1,
      sym__arith_dotdot,
    ACTIONS(21455), 1,
      sym_comma,
    STATE(18752), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551793] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [551808] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(18856), 1,
      sym_import_list,
    ACTIONS(21457), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551829] = 7,
    ACTIONS(21459), 1,
      anon_sym_RBRACK,
    ACTIONS(21461), 1,
      anon_sym_PIPE,
    ACTIONS(21463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21465), 1,
      sym__arith_dotdot,
    ACTIONS(21467), 1,
      sym_comma,
    STATE(19263), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551854] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [551869] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(21028), 1,
      anon_sym_LPAREN,
    STATE(20950), 3,
      sym_variable,
      sym_constructor,
      sym__import_name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551890] = 7,
    ACTIONS(8498), 1,
      sym__conid,
    ACTIONS(19405), 1,
      sym__varid,
    STATE(7405), 1,
      sym_constructor,
    STATE(7795), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551915] = 4,
    ACTIONS(21469), 1,
      sym__varid,
    STATE(15075), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(21195), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551934] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17831), 1,
      sym__tyconsym,
    STATE(18329), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551955] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [551970] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551989] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552004] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 6,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [552019] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [552034] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552049] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2488), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(17872), 1,
      sym__type_annotation,
    ACTIONS(21381), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552072] = 4,
    ACTIONS(21473), 1,
      anon_sym_PIPE,
    STATE(15010), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21399), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [552091] = 7,
    ACTIONS(9828), 1,
      sym__conid,
    ACTIONS(19415), 1,
      sym__varid,
    STATE(11504), 1,
      sym_constructor,
    STATE(11745), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552116] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [552131] = 4,
    ACTIONS(21473), 1,
      anon_sym_PIPE,
    STATE(15231), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21399), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [552150] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552165] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552180] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552195] = 4,
    ACTIONS(21475), 1,
      sym_comma,
    STATE(15106), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [552214] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(14396), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552237] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552252] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552267] = 7,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15685), 1,
      sym_variable,
    STATE(16066), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552292] = 7,
    ACTIONS(21478), 1,
      anon_sym_RBRACK,
    ACTIONS(21480), 1,
      anon_sym_PIPE,
    ACTIONS(21482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21484), 1,
      sym__arith_dotdot,
    ACTIONS(21486), 1,
      sym_comma,
    STATE(19954), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552317] = 7,
    ACTIONS(15311), 1,
      sym__conid,
    ACTIONS(19385), 1,
      sym__varid,
    STATE(13896), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14881), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [552357] = 7,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(19277), 1,
      sym__varid,
    STATE(14506), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14868), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552382] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552397] = 7,
    ACTIONS(8660), 1,
      sym__conid,
    ACTIONS(19433), 1,
      sym__varid,
    STATE(6499), 1,
      sym_constructor,
    STATE(6707), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552422] = 7,
    ACTIONS(8516), 1,
      sym__conid,
    ACTIONS(18960), 1,
      sym__varid,
    STATE(5971), 1,
      sym_constructor,
    STATE(6350), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552447] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [552462] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552477] = 3,
    ACTIONS(21490), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21488), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [552494] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552509] = 6,
    ACTIONS(21492), 1,
      sym__conid,
    STATE(17555), 1,
      aux_sym__qualifying_module,
    STATE(18444), 1,
      sym__modid,
    STATE(18491), 1,
      sym_constructor,
    STATE(18008), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552532] = 3,
    ACTIONS(21496), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21494), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [552549] = 7,
    ACTIONS(7911), 1,
      sym__conid,
    ACTIONS(19443), 1,
      sym__varid,
    STATE(6490), 1,
      sym_constructor,
    STATE(6675), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552574] = 7,
    ACTIONS(8836), 1,
      sym__conid,
    ACTIONS(19355), 1,
      sym__varid,
    STATE(6807), 1,
      sym_constructor,
    STATE(7116), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552599] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [552614] = 7,
    ACTIONS(8442), 1,
      sym__conid,
    ACTIONS(19050), 1,
      sym__varid,
    STATE(7170), 1,
      sym_constructor,
    STATE(7479), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552639] = 7,
    ACTIONS(4779), 1,
      sym__conid,
    ACTIONS(19199), 1,
      sym__varid,
    STATE(11455), 1,
      sym_constructor,
    STATE(11545), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552664] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [552679] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552694] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21432), 1,
      anon_sym_EQ,
    STATE(19976), 1,
      sym__funrhs,
    STATE(22248), 1,
      sym_guards,
    STATE(14270), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552717] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21498), 1,
      anon_sym_EQ,
    STATE(16731), 1,
      sym__funrhs,
    STATE(22282), 1,
      sym_guards,
    STATE(13909), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552740] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21500), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552759] = 7,
    ACTIONS(4553), 1,
      sym__conid,
    ACTIONS(19391), 1,
      sym__varid,
    STATE(11573), 1,
      sym_constructor,
    STATE(12336), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552799] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20676), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [552814] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [552829] = 7,
    ACTIONS(21502), 1,
      anon_sym_RBRACK,
    ACTIONS(21504), 1,
      anon_sym_PIPE,
    ACTIONS(21506), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21508), 1,
      sym__arith_dotdot,
    ACTIONS(21510), 1,
      sym_comma,
    STATE(18311), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552854] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552869] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552884] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [552899] = 7,
    ACTIONS(21512), 1,
      anon_sym_RBRACK,
    ACTIONS(21514), 1,
      anon_sym_PIPE,
    ACTIONS(21516), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21518), 1,
      sym__arith_dotdot,
    ACTIONS(21520), 1,
      sym_comma,
    STATE(19063), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552924] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552939] = 7,
    ACTIONS(21522), 1,
      anon_sym_RBRACK,
    ACTIONS(21524), 1,
      anon_sym_PIPE,
    ACTIONS(21526), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21528), 1,
      sym__arith_dotdot,
    ACTIONS(21530), 1,
      sym_comma,
    STATE(18032), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552964] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [552979] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21432), 1,
      anon_sym_EQ,
    STATE(19730), 1,
      sym__funrhs,
    STATE(22248), 1,
      sym_guards,
    STATE(14270), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553002] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21498), 1,
      anon_sym_EQ,
    STATE(17090), 1,
      sym__funrhs,
    STATE(22282), 1,
      sym_guards,
    STATE(13909), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553025] = 7,
    ACTIONS(9622), 1,
      sym__conid,
    ACTIONS(19341), 1,
      sym__varid,
    STATE(12496), 1,
      sym_constructor,
    STATE(12825), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553050] = 7,
    ACTIONS(13038), 1,
      sym__conid,
    ACTIONS(19395), 1,
      sym__varid,
    STATE(8531), 1,
      sym_constructor,
    STATE(9035), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553075] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553090] = 7,
    ACTIONS(8774), 1,
      sym__conid,
    ACTIONS(19477), 1,
      sym__varid,
    STATE(6953), 1,
      sym_constructor,
    STATE(7241), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553115] = 7,
    ACTIONS(8756), 1,
      sym__conid,
    ACTIONS(19267), 1,
      sym__varid,
    STATE(6608), 1,
      sym_constructor,
    STATE(6896), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553140] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553155] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(15579), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553178] = 7,
    ACTIONS(13779), 1,
      sym__conid,
    ACTIONS(19345), 1,
      sym__varid,
    STATE(9186), 1,
      sym_constructor,
    STATE(9367), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553203] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(15626), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553226] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17825), 1,
      sym__tyconsym,
    STATE(18375), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553247] = 7,
    ACTIONS(4649), 1,
      sym__conid,
    ACTIONS(19401), 1,
      sym__varid,
    STATE(11216), 1,
      sym_constructor,
    STATE(11702), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553272] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553287] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [553304] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19286), 1,
      sym_via,
    ACTIONS(21187), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553325] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [553340] = 3,
    ACTIONS(17353), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16971), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [553357] = 7,
    ACTIONS(3296), 1,
      sym__conid,
    ACTIONS(19012), 1,
      sym__varid,
    STATE(5049), 1,
      sym_constructor,
    STATE(5350), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553382] = 7,
    ACTIONS(15429), 1,
      sym__conid,
    ACTIONS(21532), 1,
      anon_sym_LPAREN,
    STATE(14828), 1,
      sym_constructor,
    STATE(15454), 1,
      sym_qualified_type,
    STATE(16910), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553407] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21534), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553426] = 7,
    ACTIONS(10864), 1,
      sym__conid,
    ACTIONS(19419), 1,
      sym__varid,
    STATE(8648), 1,
      sym_constructor,
    STATE(9076), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553451] = 5,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(21621), 3,
      sym_operator,
      sym__minus,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553472] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [553487] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(15082), 1,
      aux_sym_signature_repeat1,
    STATE(20054), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553510] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [553525] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [553540] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553555] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(18398), 1,
      sym_import_list,
    ACTIONS(21457), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553576] = 3,
    STATE(14039), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20433), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [553593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [553608] = 7,
    ACTIONS(9862), 1,
      sym__conid,
    ACTIONS(19425), 1,
      sym__varid,
    STATE(11753), 1,
      sym_constructor,
    STATE(12357), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553633] = 7,
    ACTIONS(8265), 1,
      sym__conid,
    ACTIONS(19501), 1,
      sym__varid,
    STATE(7105), 1,
      sym_constructor,
    STATE(7367), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553658] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [553675] = 7,
    ACTIONS(4537), 1,
      sym__conid,
    ACTIONS(19429), 1,
      sym__varid,
    STATE(4640), 1,
      sym_constructor,
    STATE(4863), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553700] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21536), 1,
      sym__tyconsym,
    STATE(18250), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553721] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553736] = 7,
    ACTIONS(7921), 1,
      sym__conid,
    ACTIONS(19261), 1,
      sym__varid,
    STATE(5938), 1,
      sym_constructor,
    STATE(6504), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553761] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [553776] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(21538), 1,
      anon_sym_LPAREN,
    STATE(14591), 1,
      sym_constructor,
    STATE(15175), 1,
      sym_qualified_type,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553801] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21540), 1,
      sym__tyconsym,
    STATE(18282), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553822] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553837] = 7,
    ACTIONS(15337), 1,
      sym__conid,
    ACTIONS(19075), 1,
      sym__varid,
    STATE(13642), 1,
      sym_constructor,
    STATE(14181), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553862] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553877] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21542), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [553892] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [553907] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [553924] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553939] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [553954] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [553969] = 7,
    ACTIONS(4851), 1,
      sym__conid,
    ACTIONS(19439), 1,
      sym__varid,
    STATE(4192), 1,
      sym_constructor,
    STATE(4270), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553994] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2492), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(17197), 1,
      sym__type_annotation,
    ACTIONS(21544), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554017] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554032] = 7,
    ACTIONS(20479), 1,
      anon_sym_RBRACK,
    ACTIONS(20481), 1,
      anon_sym_PIPE,
    ACTIONS(20483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20485), 1,
      sym__arith_dotdot,
    ACTIONS(20487), 1,
      sym_comma,
    STATE(18417), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554057] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554072] = 7,
    ACTIONS(4607), 1,
      sym__conid,
    ACTIONS(19008), 1,
      sym__varid,
    STATE(5243), 1,
      sym_constructor,
    STATE(5776), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554097] = 7,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(19251), 1,
      sym__varid,
    STATE(7990), 1,
      sym_constructor,
    STATE(8309), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554122] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [554137] = 7,
    ACTIONS(9930), 1,
      sym__conid,
    ACTIONS(19449), 1,
      sym__varid,
    STATE(11548), 1,
      sym_constructor,
    STATE(12299), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554162] = 5,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(21543), 3,
      sym_operator,
      sym__minus,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554183] = 7,
    ACTIONS(2031), 1,
      sym__conid,
    ACTIONS(19562), 1,
      sym__varid,
    STATE(7179), 1,
      sym_constructor,
    STATE(7408), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554208] = 7,
    ACTIONS(20600), 1,
      anon_sym_RBRACK,
    ACTIONS(20602), 1,
      anon_sym_PIPE,
    ACTIONS(20604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20606), 1,
      sym__arith_dotdot,
    ACTIONS(20608), 1,
      sym_comma,
    STATE(18850), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554233] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554248] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(19180), 1,
      sym_import_list,
    ACTIONS(21351), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554269] = 7,
    ACTIONS(7429), 1,
      sym__conid,
    ACTIONS(19459), 1,
      sym__varid,
    STATE(7643), 1,
      sym_constructor,
    STATE(8126), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554294] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554309] = 4,
    ACTIONS(21401), 1,
      anon_sym_PIPE,
    STATE(15055), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21546), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [554328] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(19183), 1,
      sym_import_list,
    ACTIONS(21328), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554349] = 7,
    ACTIONS(8414), 1,
      sym__conid,
    ACTIONS(19528), 1,
      sym__varid,
    STATE(7061), 1,
      sym_constructor,
    STATE(7361), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554374] = 7,
    ACTIONS(20489), 1,
      anon_sym_RBRACK,
    ACTIONS(20491), 1,
      anon_sym_PIPE,
    ACTIONS(20493), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20495), 1,
      sym__arith_dotdot,
    ACTIONS(20497), 1,
      sym_comma,
    STATE(18158), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554399] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21074), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [554414] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17182), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21548), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [554433] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [554448] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(15085), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554471] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17180), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21550), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [554490] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554505] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554520] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(19193), 1,
      sym_import_list,
    ACTIONS(21326), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554541] = 7,
    ACTIONS(8534), 1,
      sym__conid,
    ACTIONS(19471), 1,
      sym__varid,
    STATE(8156), 1,
      sym_constructor,
    STATE(8193), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554566] = 7,
    ACTIONS(21552), 1,
      anon_sym_RBRACK,
    ACTIONS(21554), 1,
      anon_sym_PIPE,
    ACTIONS(21556), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21558), 1,
      sym__arith_dotdot,
    ACTIONS(21560), 1,
      sym_comma,
    STATE(19144), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554591] = 6,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21562), 1,
      anon_sym_as,
    STATE(21219), 1,
      sym_import_list,
    ACTIONS(21214), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554614] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554629] = 5,
    ACTIONS(21566), 1,
      anon_sym_LBRACE,
    ACTIONS(21568), 1,
      sym__layout_start,
    STATE(19241), 1,
      sym_decls,
    ACTIONS(21564), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554650] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2463), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(19306), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554673] = 7,
    ACTIONS(16783), 1,
      sym__conid,
    ACTIONS(19540), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15394), 1,
      sym_constructor,
    STATE(15981), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554698] = 4,
    ACTIONS(21473), 1,
      anon_sym_PIPE,
    STATE(15010), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21546), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [554717] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554732] = 6,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21570), 1,
      anon_sym_as,
    STATE(21202), 1,
      sym_import_list,
    ACTIONS(21224), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554755] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [554770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [554785] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [554800] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 6,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [554815] = 7,
    ACTIONS(20610), 1,
      anon_sym_RBRACK,
    ACTIONS(20612), 1,
      anon_sym_PIPE,
    ACTIONS(20614), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20616), 1,
      sym__arith_dotdot,
    ACTIONS(20618), 1,
      sym_comma,
    STATE(18320), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554840] = 7,
    ACTIONS(21572), 1,
      anon_sym_RBRACK,
    ACTIONS(21574), 1,
      anon_sym_PIPE,
    ACTIONS(21576), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21578), 1,
      sym__arith_dotdot,
    ACTIONS(21580), 1,
      sym_comma,
    STATE(18620), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554865] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(14990), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554888] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(14992), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554911] = 7,
    ACTIONS(14170), 1,
      sym__conid,
    ACTIONS(19550), 1,
      sym__varid,
    STATE(9047), 1,
      sym_constructor,
    STATE(9500), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554936] = 7,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(19483), 1,
      sym__varid,
    STATE(4725), 1,
      sym_constructor,
    STATE(5768), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554961] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(15001), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554984] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16809), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21548), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [555003] = 3,
    ACTIONS(21584), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21582), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [555020] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21162), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [555035] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [555050] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555065] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [555080] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [555095] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555110] = 7,
    ACTIONS(21586), 1,
      anon_sym_RBRACK,
    ACTIONS(21588), 1,
      anon_sym_PIPE,
    ACTIONS(21590), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21592), 1,
      sym__arith_dotdot,
    ACTIONS(21594), 1,
      sym_comma,
    STATE(18430), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555135] = 7,
    ACTIONS(14940), 1,
      sym__conid,
    ACTIONS(19580), 1,
      sym__varid,
    STATE(9578), 1,
      sym_constructor,
    STATE(9762), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555160] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [555175] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16811), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21550), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [555194] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555209] = 5,
    ACTIONS(21340), 1,
      anon_sym_LBRACE,
    ACTIONS(21342), 1,
      sym__layout_start,
    STATE(19262), 1,
      sym_decls,
    ACTIONS(21271), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555230] = 3,
    ACTIONS(21598), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21596), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [555247] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555262] = 7,
    ACTIONS(21600), 1,
      anon_sym_RBRACK,
    ACTIONS(21602), 1,
      anon_sym_PIPE,
    ACTIONS(21604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21606), 1,
      sym__arith_dotdot,
    ACTIONS(21608), 1,
      sym_comma,
    STATE(18135), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555287] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21610), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [555304] = 7,
    ACTIONS(15329), 1,
      sym__conid,
    ACTIONS(19187), 1,
      sym__varid,
    STATE(13907), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14959), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555329] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555344] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15532), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21612), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555363] = 7,
    ACTIONS(4483), 1,
      sym__conid,
    ACTIONS(19493), 1,
      sym__varid,
    STATE(5339), 1,
      sym_constructor,
    STATE(5966), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555388] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [555403] = 4,
    ACTIONS(15417), 1,
      sym__varid,
    STATE(15443), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(21195), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [555437] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555452] = 7,
    ACTIONS(8293), 1,
      sym__conid,
    ACTIONS(19081), 1,
      sym__varid,
    STATE(6053), 1,
      sym_constructor,
    STATE(6657), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555477] = 7,
    ACTIONS(20518), 1,
      anon_sym_RBRACK,
    ACTIONS(20520), 1,
      anon_sym_PIPE,
    ACTIONS(20522), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20524), 1,
      sym__arith_dotdot,
    ACTIONS(20526), 1,
      sym_comma,
    STATE(17892), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555502] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(15580), 1,
      aux_sym_signature_repeat1,
    STATE(20998), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555525] = 7,
    ACTIONS(13464), 1,
      sym__conid,
    ACTIONS(19586), 1,
      sym__varid,
    STATE(8713), 1,
      sym_constructor,
    STATE(9020), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555550] = 7,
    ACTIONS(3311), 1,
      sym__conid,
    ACTIONS(19519), 1,
      sym__varid,
    STATE(4283), 1,
      sym_constructor,
    STATE(4463), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555575] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555590] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555605] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
  [555620] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555635] = 7,
    ACTIONS(12746), 1,
      sym__conid,
    ACTIONS(19255), 1,
      sym__varid,
    STATE(8876), 1,
      sym_constructor,
    STATE(9206), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555660] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21614), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [555677] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555692] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [555707] = 7,
    ACTIONS(13946), 1,
      sym__conid,
    ACTIONS(19606), 1,
      sym__varid,
    STATE(8905), 1,
      sym_constructor,
    STATE(9472), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555732] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555747] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2492), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(17198), 1,
      sym__type_annotation,
    ACTIONS(21544), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555785] = 7,
    ACTIONS(4577), 1,
      sym__conid,
    ACTIONS(19497), 1,
      sym__varid,
    STATE(3730), 1,
      sym_constructor,
    STATE(3777), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555810] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(15223), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555848] = 5,
    ACTIONS(21298), 1,
      anon_sym_LBRACE,
    ACTIONS(21300), 1,
      sym__layout_start,
    STATE(18060), 1,
      sym_decls,
    ACTIONS(21277), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555869] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555884] = 7,
    ACTIONS(8676), 1,
      sym__conid,
    ACTIONS(19087), 1,
      sym__varid,
    STATE(6351), 1,
      sym_constructor,
    STATE(6687), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555909] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [555924] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(16121), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555947] = 5,
    ACTIONS(21566), 1,
      anon_sym_LBRACE,
    ACTIONS(21568), 1,
      sym__layout_start,
    STATE(19237), 1,
      sym_decls,
    ACTIONS(21616), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555968] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [555983] = 3,
    ACTIONS(21620), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21618), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [556000] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [556015] = 7,
    ACTIONS(7891), 1,
      sym__conid,
    ACTIONS(19507), 1,
      sym__varid,
    STATE(4462), 1,
      sym_constructor,
    STATE(4499), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556040] = 6,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14467), 1,
      sym__modid,
    STATE(16411), 1,
      aux_sym__qualifying_module,
    STATE(15174), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556063] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(15685), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556088] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21261), 6,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [556103] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21622), 1,
      anon_sym_EQ,
    STATE(18383), 1,
      sym__funrhs,
    STATE(22113), 1,
      sym_guards,
    STATE(14406), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556126] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(19787), 1,
      sym_import_list,
    ACTIONS(21624), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556147] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [556162] = 7,
    ACTIONS(8141), 1,
      sym__conid,
    ACTIONS(19040), 1,
      sym__varid,
    STATE(7346), 1,
      sym_constructor,
    STATE(7684), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556187] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 6,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [556202] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [556217] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556232] = 7,
    ACTIONS(3305), 1,
      sym__conid,
    ACTIONS(19126), 1,
      sym__varid,
    STATE(4786), 1,
      sym_constructor,
    STATE(5579), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556257] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20637), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [556272] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [556287] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556302] = 7,
    ACTIONS(13096), 1,
      sym__conid,
    ACTIONS(19513), 1,
      sym__varid,
    STATE(8737), 1,
      sym_constructor,
    STATE(9486), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556327] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [556342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556357] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(15213), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556380] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17095), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21626), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [556399] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2453), 1,
      sym__colon2,
    STATE(14974), 1,
      aux_sym_signature_repeat1,
    STATE(20104), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556422] = 7,
    ACTIONS(4873), 1,
      sym__conid,
    ACTIONS(19283), 1,
      sym__varid,
    STATE(10364), 1,
      sym_constructor,
    STATE(10565), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556447] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [556462] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21622), 1,
      anon_sym_EQ,
    STATE(18271), 1,
      sym__funrhs,
    STATE(22113), 1,
      sym_guards,
    STATE(14406), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556485] = 5,
    STATE(2508), 1,
      sym__colon2,
    STATE(21282), 1,
      sym__type_annotation,
    ACTIONS(18539), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20013), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556506] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556521] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556536] = 7,
    ACTIONS(4809), 1,
      sym__conid,
    ACTIONS(19660), 1,
      sym__varid,
    STATE(4549), 1,
      sym_constructor,
    STATE(5009), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556561] = 7,
    ACTIONS(2003), 1,
      sym__conid,
    ACTIONS(18972), 1,
      sym__varid,
    STATE(4571), 1,
      sym_constructor,
    STATE(5187), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556586] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556601] = 7,
    ACTIONS(7803), 1,
      sym__conid,
    ACTIONS(18976), 1,
      sym__varid,
    STATE(7780), 1,
      sym_constructor,
    STATE(8018), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556626] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [556641] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20645), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [556656] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [556671] = 7,
    ACTIONS(21628), 1,
      anon_sym_RBRACK,
    ACTIONS(21630), 1,
      anon_sym_PIPE,
    ACTIONS(21632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21634), 1,
      sym__arith_dotdot,
    ACTIONS(21636), 1,
      sym_comma,
    STATE(18549), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556696] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(15209), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556719] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556738] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [556753] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [556768] = 7,
    ACTIONS(8315), 1,
      sym__conid,
    ACTIONS(18966), 1,
      sym__varid,
    STATE(7372), 1,
      sym_constructor,
    STATE(7802), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556793] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20676), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [556808] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(21638), 1,
      anon_sym_LPAREN,
    STATE(14961), 1,
      sym_constructor,
    STATE(15008), 1,
      sym_qualified_type,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556833] = 7,
    ACTIONS(13064), 1,
      sym__conid,
    ACTIONS(19534), 1,
      sym__varid,
    STATE(8687), 1,
      sym_constructor,
    STATE(8909), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556858] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21640), 1,
      anon_sym_EQ,
    STATE(20667), 1,
      sym__funrhs,
    STATE(22201), 1,
      sym_guards,
    STATE(14763), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556881] = 7,
    ACTIONS(13678), 1,
      sym__conid,
    ACTIONS(19487), 1,
      sym__varid,
    STATE(9824), 1,
      sym_constructor,
    STATE(10414), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556906] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20639), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [556921] = 7,
    ACTIONS(21642), 1,
      anon_sym_RBRACK,
    ACTIONS(21644), 1,
      anon_sym_PIPE,
    ACTIONS(21646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21648), 1,
      sym__arith_dotdot,
    ACTIONS(21650), 1,
      sym_comma,
    STATE(19025), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556946] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21344), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556965] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [556980] = 7,
    ACTIONS(21652), 1,
      anon_sym_RBRACK,
    ACTIONS(21654), 1,
      anon_sym_PIPE,
    ACTIONS(21656), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21658), 1,
      sym__arith_dotdot,
    ACTIONS(21660), 1,
      sym_comma,
    STATE(18248), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557005] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557020] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21162), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [557035] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557050] = 7,
    ACTIONS(4423), 1,
      sym__conid,
    ACTIONS(19546), 1,
      sym__varid,
    STATE(4652), 1,
      sym_constructor,
    STATE(4840), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557075] = 7,
    ACTIONS(13414), 1,
      sym__conid,
    ACTIONS(19101), 1,
      sym__varid,
    STATE(8436), 1,
      sym_constructor,
    STATE(8683), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557100] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [557115] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557130] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557145] = 3,
    ACTIONS(21664), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21662), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [557162] = 5,
    STATE(2467), 1,
      sym__colon2,
    STATE(20786), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20013), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557183] = 7,
    ACTIONS(7901), 1,
      sym__conid,
    ACTIONS(19061), 1,
      sym__varid,
    STATE(6516), 1,
      sym_constructor,
    STATE(6763), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557208] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [557223] = 7,
    ACTIONS(20530), 1,
      anon_sym_RBRACK,
    ACTIONS(20532), 1,
      anon_sym_PIPE,
    ACTIONS(20534), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20536), 1,
      sym__arith_dotdot,
    ACTIONS(20538), 1,
      sym_comma,
    STATE(18236), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557248] = 7,
    ACTIONS(15303), 1,
      sym__conid,
    ACTIONS(19321), 1,
      sym__varid,
    STATE(13499), 1,
      sym_constructor,
    STATE(14019), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557273] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15502), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21666), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557292] = 7,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(19556), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(16086), 1,
      sym_constructor,
    STATE(16824), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557317] = 7,
    ACTIONS(20543), 1,
      anon_sym_RBRACK,
    ACTIONS(20545), 1,
      anon_sym_PIPE,
    ACTIONS(20547), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20549), 1,
      sym__arith_dotdot,
    ACTIONS(20551), 1,
      sym_comma,
    STATE(20158), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557342] = 4,
    ACTIONS(21401), 1,
      anon_sym_PIPE,
    STATE(15503), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21668), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [557361] = 7,
    ACTIONS(8640), 1,
      sym__conid,
    ACTIONS(19695), 1,
      sym__varid,
    STATE(7742), 1,
      sym_constructor,
    STATE(8158), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557386] = 7,
    ACTIONS(15321), 1,
      sym__conid,
    ACTIONS(19175), 1,
      sym__varid,
    STATE(14301), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15457), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557411] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557426] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557441] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557456] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557471] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20649), 6,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [557486] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(14318), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557509] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [557524] = 7,
    ACTIONS(12450), 1,
      sym__conid,
    ACTIONS(19751), 1,
      sym__varid,
    STATE(8856), 1,
      sym_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557549] = 6,
    ACTIONS(20376), 1,
      sym__conid,
    STATE(14901), 1,
      sym_constructor,
    STATE(15378), 1,
      aux_sym__qualifying_module,
    STATE(22723), 1,
      sym__modid,
    ACTIONS(20374), 2,
      sym__varsym,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557572] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557587] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [557604] = 5,
    ACTIONS(20839), 1,
      anon_sym_LPAREN,
    ACTIONS(20841), 1,
      anon_sym_hiding,
    STATE(19757), 1,
      sym_import_list,
    ACTIONS(21670), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557625] = 7,
    ACTIONS(9896), 1,
      sym__conid,
    ACTIONS(19705), 1,
      sym__varid,
    STATE(11762), 1,
      sym_constructor,
    STATE(12120), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557650] = 7,
    ACTIONS(4513), 1,
      sym__conid,
    ACTIONS(19644), 1,
      sym__varid,
    STATE(10856), 1,
      sym_constructor,
    STATE(10931), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557675] = 4,
    ACTIONS(21473), 1,
      anon_sym_PIPE,
    STATE(15563), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21668), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [557694] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15515), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21672), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [557713] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [557728] = 7,
    ACTIONS(8201), 1,
      sym__conid,
    ACTIONS(19026), 1,
      sym__varid,
    STATE(5773), 1,
      sym_constructor,
    STATE(6054), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557753] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557768] = 6,
    ACTIONS(21036), 1,
      anon_sym_PIPE,
    ACTIONS(21038), 1,
      sym_where,
    STATE(16469), 1,
      sym_fundeps,
    STATE(21076), 1,
      sym_class_body,
    ACTIONS(21247), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557791] = 7,
    ACTIONS(21676), 1,
      anon_sym_RBRACK,
    ACTIONS(21678), 1,
      anon_sym_PIPE,
    ACTIONS(21680), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21682), 1,
      sym__arith_dotdot,
    ACTIONS(21684), 1,
      sym_comma,
    STATE(19437), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557816] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [557831] = 3,
    STATE(13937), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20475), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [557848] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(16189), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557871] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [557888] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(16190), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557911] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(16199), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557934] = 7,
    ACTIONS(9708), 1,
      sym__conid,
    ACTIONS(19713), 1,
      sym__varid,
    STATE(11332), 1,
      sym_constructor,
    STATE(11960), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557959] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [557974] = 6,
    ACTIONS(20376), 1,
      sym__conid,
    STATE(14901), 1,
      sym_constructor,
    STATE(15399), 1,
      aux_sym__qualifying_module,
    STATE(22863), 1,
      sym__modid,
    ACTIONS(20374), 2,
      sym__consym,
      sym__tyconsym,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557997] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558012] = 7,
    ACTIONS(15317), 1,
      sym__conid,
    ACTIONS(19568), 1,
      sym__varid,
    STATE(14063), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14800), 1,
      sym_variable,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558037] = 7,
    ACTIONS(4435), 1,
      sym__conid,
    ACTIONS(19071), 1,
      sym__varid,
    STATE(5260), 1,
      sym_constructor,
    STATE(5673), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558062] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558081] = 7,
    ACTIONS(8562), 1,
      sym__conid,
    ACTIONS(19717), 1,
      sym__varid,
    STATE(7721), 1,
      sym_constructor,
    STATE(8177), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558106] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [558121] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [558136] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [558151] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558166] = 7,
    ACTIONS(21686), 1,
      anon_sym_RBRACK,
    ACTIONS(21688), 1,
      anon_sym_PIPE,
    ACTIONS(21690), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21692), 1,
      sym__arith_dotdot,
    ACTIONS(21694), 1,
      sym_comma,
    STATE(17954), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558191] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [558206] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558221] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558236] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [558251] = 7,
    ACTIONS(11000), 1,
      sym__conid,
    ACTIONS(19245), 1,
      sym__varid,
    STATE(7990), 1,
      sym_constructor,
    STATE(8309), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558276] = 7,
    ACTIONS(4583), 1,
      sym__conid,
    ACTIONS(19729), 1,
      sym__varid,
    STATE(4603), 1,
      sym_constructor,
    STATE(4951), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558301] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [558318] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21534), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558337] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558356] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [558371] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558386] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558401] = 5,
    STATE(2467), 1,
      sym__colon2,
    STATE(21083), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(21232), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558437] = 7,
    ACTIONS(9322), 1,
      sym__conid,
    ACTIONS(19739), 1,
      sym__varid,
    STATE(11845), 1,
      sym_constructor,
    STATE(12556), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558462] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [558479] = 7,
    ACTIONS(4497), 1,
      sym__conid,
    ACTIONS(19016), 1,
      sym__varid,
    STATE(4608), 1,
      sym_constructor,
    STATE(5124), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558504] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [558519] = 7,
    ACTIONS(15299), 1,
      sym__conid,
    ACTIONS(19157), 1,
      sym__varid,
    STATE(13072), 1,
      sym_constructor,
    STATE(13845), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558544] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15564), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21666), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558563] = 7,
    ACTIONS(11085), 1,
      sym__conid,
    ACTIONS(19227), 1,
      sym__varid,
    STATE(8240), 1,
      sym_constructor,
    STATE(8328), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558588] = 6,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    ACTIONS(21208), 1,
      anon_sym_as,
    STATE(21058), 1,
      sym_import_list,
    ACTIONS(20837), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558611] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15601), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21612), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558630] = 7,
    ACTIONS(20411), 1,
      anon_sym_RBRACK,
    ACTIONS(20413), 1,
      anon_sym_PIPE,
    ACTIONS(20415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20417), 1,
      sym__arith_dotdot,
    ACTIONS(20419), 1,
      sym_comma,
    STATE(19227), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558655] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [558670] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [558685] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558700] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558715] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [558730] = 7,
    ACTIONS(13436), 1,
      sym__conid,
    ACTIONS(19163), 1,
      sym__varid,
    STATE(8857), 1,
      sym_constructor,
    STATE(8953), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558755] = 7,
    ACTIONS(1618), 1,
      sym__conid,
    ACTIONS(19365), 1,
      sym__varid,
    STATE(4115), 1,
      sym_constructor,
    STATE(4214), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558780] = 7,
    ACTIONS(16854), 1,
      sym__conid,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15685), 1,
      sym_variable,
    STATE(17856), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558805] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(15381), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558828] = 4,
    ACTIONS(21696), 1,
      sym__varid,
    STATE(15443), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(20653), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558847] = 7,
    ACTIONS(8121), 1,
      sym__conid,
    ACTIONS(19743), 1,
      sym__varid,
    STATE(5402), 1,
      sym_constructor,
    STATE(6164), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558872] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558887] = 7,
    ACTIONS(13304), 1,
      sym__conid,
    ACTIONS(19574), 1,
      sym__varid,
    STATE(8493), 1,
      sym_constructor,
    STATE(9238), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558912] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(15305), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558935] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [558950] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [558965] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [558980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [558995] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [559010] = 4,
    ACTIONS(21389), 1,
      sym_comma,
    STATE(15106), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21699), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [559029] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17441), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21701), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [559048] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559063] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21445), 1,
      sym_string,
    ACTIONS(21703), 1,
      anon_sym_LPAREN,
    STATE(15529), 1,
      sym_variable,
    STATE(17612), 1,
      sym_expent,
    STATE(19223), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559088] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559103] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [559120] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559135] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [559150] = 7,
    ACTIONS(8211), 1,
      sym__conid,
    ACTIONS(19648), 1,
      sym__varid,
    STATE(7016), 1,
      sym_constructor,
    STATE(7089), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559175] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21610), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [559192] = 7,
    ACTIONS(21705), 1,
      anon_sym_RBRACK,
    ACTIONS(21707), 1,
      anon_sym_PIPE,
    ACTIONS(21709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21711), 1,
      sym__arith_dotdot,
    ACTIONS(21713), 1,
      sym_comma,
    STATE(17877), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559217] = 7,
    ACTIONS(21715), 1,
      anon_sym_RBRACK,
    ACTIONS(21717), 1,
      anon_sym_PIPE,
    ACTIONS(21719), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21721), 1,
      sym__arith_dotdot,
    ACTIONS(21723), 1,
      sym_comma,
    STATE(18906), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559242] = 7,
    ACTIONS(8622), 1,
      sym__conid,
    ACTIONS(19239), 1,
      sym__varid,
    STATE(6595), 1,
      sym_constructor,
    STATE(6866), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559267] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16953), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21314), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [559286] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(17977), 1,
      sym_import_list,
    ACTIONS(21214), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559307] = 6,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    ACTIONS(19944), 1,
      sym__conid,
    ACTIONS(21164), 1,
      anon_sym_LPAREN,
    STATE(17036), 1,
      sym_constructor,
    STATE(19077), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559330] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21438), 1,
      sym_string,
    ACTIONS(21703), 1,
      anon_sym_LPAREN,
    STATE(15529), 1,
      sym_variable,
    STATE(17640), 1,
      sym_impent,
    STATE(19129), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559355] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [559370] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559385] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559400] = 7,
    ACTIONS(8335), 1,
      sym__conid,
    ACTIONS(19594), 1,
      sym__varid,
    STATE(6762), 1,
      sym_constructor,
    STATE(7230), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559425] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559440] = 4,
    ACTIONS(21189), 1,
      anon_sym_via,
    STATE(17452), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21725), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [559459] = 7,
    ACTIONS(15359), 1,
      sym__conid,
    ACTIONS(21727), 1,
      anon_sym_LPAREN,
    STATE(14790), 1,
      sym_constructor,
    STATE(15584), 1,
      sym_qualified_type,
    STATE(17427), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559484] = 3,
    ACTIONS(21731), 2,
      sym_string,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21729), 4,
      sym__varid,
      anon_sym_unsafe,
      anon_sym_safe,
      anon_sym_interruptible,
  [559501] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [559516] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21640), 1,
      anon_sym_EQ,
    STATE(20854), 1,
      sym__funrhs,
    STATE(22201), 1,
      sym_guards,
    STATE(14763), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559539] = 6,
    ACTIONS(2403), 1,
      anon_sym_PIPE,
    ACTIONS(21640), 1,
      anon_sym_EQ,
    STATE(20856), 1,
      sym__funrhs,
    STATE(22201), 1,
      sym_guards,
    STATE(14763), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559562] = 7,
    ACTIONS(4467), 1,
      sym__conid,
    ACTIONS(19067), 1,
      sym__varid,
    STATE(10276), 1,
      sym_constructor,
    STATE(10500), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559587] = 7,
    ACTIONS(21733), 1,
      anon_sym_RBRACK,
    ACTIONS(21735), 1,
      anon_sym_PIPE,
    ACTIONS(21737), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21739), 1,
      sym__arith_dotdot,
    ACTIONS(21741), 1,
      sym_comma,
    STATE(18668), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559612] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [559627] = 7,
    ACTIONS(13521), 1,
      sym__conid,
    ACTIONS(19761), 1,
      sym__varid,
    STATE(8479), 1,
      sym_constructor,
    STATE(8611), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559652] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559667] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559682] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559697] = 7,
    ACTIONS(6248), 1,
      sym__conid,
    ACTIONS(19600), 1,
      sym__varid,
    STATE(7614), 1,
      sym_constructor,
    STATE(7984), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559722] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(14165), 1,
      sym_constructor,
    STATE(14659), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559747] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [559777] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559792] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16936), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21626), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [559811] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20649), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [559826] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559841] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [559856] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [559871] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559886] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(19134), 1,
      sym__consym,
    STATE(10484), 1,
      sym_constructor_operator,
    STATE(14408), 1,
      aux_sym__qualifying_module,
    STATE(14901), 1,
      sym_constructor,
    STATE(23053), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559911] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20639), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [559926] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559941] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21743), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559960] = 4,
    ACTIONS(21401), 1,
      anon_sym_PIPE,
    STATE(15055), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21745), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [559979] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15541), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [559994] = 7,
    ACTIONS(21747), 1,
      anon_sym_RBRACK,
    ACTIONS(21749), 1,
      anon_sym_PIPE,
    ACTIONS(21751), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21753), 1,
      sym__arith_dotdot,
    ACTIONS(21755), 1,
      sym_comma,
    STATE(19375), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560019] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560034] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560049] = 7,
    ACTIONS(12980), 1,
      sym__conid,
    ACTIONS(19193), 1,
      sym__varid,
    STATE(8716), 1,
      sym_constructor,
    STATE(9625), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560074] = 7,
    ACTIONS(20562), 1,
      anon_sym_RBRACK,
    ACTIONS(20564), 1,
      anon_sym_PIPE,
    ACTIONS(20566), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20568), 1,
      sym__arith_dotdot,
    ACTIONS(20570), 1,
      sym_comma,
    STATE(18511), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560099] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(14442), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560122] = 4,
    ACTIONS(21401), 1,
      anon_sym_PIPE,
    STATE(15041), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21745), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [560141] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560156] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560171] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15625), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21757), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [560190] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15622), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21757), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [560209] = 7,
    ACTIONS(9212), 1,
      sym__conid,
    ACTIONS(19612), 1,
      sym__varid,
    STATE(11274), 1,
      sym_constructor,
    STATE(11605), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560234] = 7,
    ACTIONS(15183), 1,
      sym__conid,
    ACTIONS(19151), 1,
      sym__varid,
    STATE(9776), 1,
      sym_constructor,
    STATE(9911), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560259] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [560274] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560289] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560304] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [560319] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560334] = 7,
    ACTIONS(4837), 1,
      sym__conid,
    ACTIONS(19757), 1,
      sym__varid,
    STATE(11181), 1,
      sym_constructor,
    STATE(11846), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560359] = 7,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(19687), 1,
      sym__varid,
    STATE(10674), 1,
      sym_constructor,
    STATE(10765), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560384] = 7,
    ACTIONS(8247), 1,
      sym__conid,
    ACTIONS(19616), 1,
      sym__varid,
    STATE(6526), 1,
      sym_constructor,
    STATE(6667), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560409] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(15571), 1,
      aux_sym_signature_repeat1,
    STATE(20848), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560432] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560447] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15622), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21759), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [560466] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2463), 1,
      sym__colon2,
    STATE(15593), 1,
      aux_sym_signature_repeat1,
    STATE(18064), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560489] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560504] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560519] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21761), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560538] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560553] = 7,
    ACTIONS(15387), 1,
      sym__conid,
    ACTIONS(21763), 1,
      anon_sym_LPAREN,
    STATE(15000), 1,
      sym_constructor,
    STATE(16210), 1,
      sym_qualified_type,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560578] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [560593] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560612] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [560627] = 7,
    ACTIONS(21765), 1,
      anon_sym_RBRACK,
    ACTIONS(21767), 1,
      anon_sym_PIPE,
    ACTIONS(21769), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21771), 1,
      sym__arith_dotdot,
    ACTIONS(21773), 1,
      sym_comma,
    STATE(18313), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560652] = 7,
    ACTIONS(669), 1,
      sym__conid,
    ACTIONS(19622), 1,
      sym__varid,
    STATE(4217), 1,
      sym_constructor,
    STATE(9852), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560677] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21775), 1,
      sym__tyconsym,
    STATE(18044), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560698] = 4,
    ACTIONS(21777), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21374), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560717] = 7,
    ACTIONS(8043), 1,
      sym__conid,
    ACTIONS(19733), 1,
      sym__varid,
    STATE(6478), 1,
      sym_constructor,
    STATE(6915), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560742] = 6,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14537), 1,
      sym__modid,
    STATE(17025), 1,
      aux_sym__qualifying_module,
    STATE(14989), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560765] = 7,
    ACTIONS(9288), 1,
      sym__conid,
    ACTIONS(19628), 1,
      sym__varid,
    STATE(10695), 1,
      sym_constructor,
    STATE(10792), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560790] = 7,
    ACTIONS(12945), 1,
      sym__conid,
    ACTIONS(19203), 1,
      sym__varid,
    STATE(8633), 1,
      sym_constructor,
    STATE(9266), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560815] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15528), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21780), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [560834] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15622), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21780), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [560853] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [560868] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      sym__varid,
  [560883] = 5,
    STATE(2472), 1,
      sym__colon2,
    STATE(20352), 1,
      sym__type_annotation,
    ACTIONS(18265), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(20013), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560904] = 5,
    ACTIONS(21566), 1,
      anon_sym_LBRACE,
    ACTIONS(21568), 1,
      sym__layout_start,
    STATE(20018), 1,
      sym_decls,
    ACTIONS(21271), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560925] = 4,
    ACTIONS(21782), 1,
      sym_comma,
    STATE(15615), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21387), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [560944] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(20040), 1,
      sym__arrow,
    ACTIONS(21784), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14765), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560965] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(14705), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560988] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17867), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
  [561003] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
  [561018] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [561033] = 4,
    ACTIONS(21473), 1,
      anon_sym_PIPE,
    STATE(15099), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21745), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [561052] = 7,
    ACTIONS(8828), 1,
      sym__conid,
    ACTIONS(19632), 1,
      sym__varid,
    STATE(6068), 1,
      sym_constructor,
    STATE(6646), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561077] = 7,
    ACTIONS(8111), 1,
      sym__conid,
    ACTIONS(19723), 1,
      sym__varid,
    STATE(4629), 1,
      sym_constructor,
    STATE(5022), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561102] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(16176), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561125] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [561140] = 4,
    ACTIONS(21473), 1,
      anon_sym_PIPE,
    STATE(15010), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21745), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [561159] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21743), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561178] = 7,
    ACTIONS(21786), 1,
      anon_sym_RBRACK,
    ACTIONS(21788), 1,
      anon_sym_PIPE,
    ACTIONS(21790), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21792), 1,
      sym__arith_dotdot,
    ACTIONS(21794), 1,
      sym_comma,
    STATE(18502), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561203] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(16172), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561226] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [561241] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16398), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21725), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [561260] = 7,
    ACTIONS(4453), 1,
      sym__conid,
    ACTIONS(19709), 1,
      sym__varid,
    STATE(4899), 1,
      sym_constructor,
    STATE(5561), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561285] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [561300] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(20965), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561323] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 6,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__varid,
  [561357] = 7,
    ACTIONS(7873), 1,
      sym__conid,
    ACTIONS(19095), 1,
      sym__varid,
    STATE(6786), 1,
      sym_constructor,
    STATE(7157), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561382] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21614), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [561399] = 7,
    ACTIONS(8351), 1,
      sym__conid,
    ACTIONS(19638), 1,
      sym__varid,
    STATE(6088), 1,
      sym_constructor,
    STATE(6633), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561424] = 7,
    ACTIONS(13205), 1,
      sym__conid,
    ACTIONS(19767), 1,
      sym__varid,
    STATE(8311), 1,
      sym_constructor,
    STATE(8504), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561449] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561468] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(18121), 1,
      sym_import_list,
    ACTIONS(21624), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561489] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2467), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(21166), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561512] = 7,
    ACTIONS(10046), 1,
      sym__conid,
    ACTIONS(19701), 1,
      sym__varid,
    STATE(12124), 1,
      sym_constructor,
    STATE(13154), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561537] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [561552] = 4,
    ACTIONS(21796), 1,
      anon_sym_PIPE,
    STATE(16948), 1,
      sym_tyfam_injectivity,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21391), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [561571] = 4,
    ACTIONS(21222), 1,
      anon_sym_via,
    STATE(16350), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21701), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [561590] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20645), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [561605] = 7,
    ACTIONS(21798), 1,
      anon_sym_RBRACK,
    ACTIONS(21800), 1,
      anon_sym_PIPE,
    ACTIONS(21802), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21804), 1,
      sym__arith_dotdot,
    ACTIONS(21806), 1,
      sym_comma,
    STATE(18740), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561630] = 7,
    ACTIONS(21808), 1,
      anon_sym_RBRACK,
    ACTIONS(21810), 1,
      anon_sym_PIPE,
    ACTIONS(21812), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21814), 1,
      sym__arith_dotdot,
    ACTIONS(21816), 1,
      sym_comma,
    STATE(18192), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561655] = 7,
    ACTIONS(13173), 1,
      sym__conid,
    ACTIONS(19209), 1,
      sym__varid,
    STATE(8777), 1,
      sym_constructor,
    STATE(9668), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561680] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [561695] = 5,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17957), 1,
      sym__arrow,
    ACTIONS(21818), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(14765), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561716] = 7,
    ACTIONS(7981), 1,
      sym__conid,
    ACTIONS(19233), 1,
      sym__varid,
    STATE(7482), 1,
      sym_constructor,
    STATE(7639), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561741] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [561758] = 6,
    ACTIONS(15472), 1,
      sym_comma,
    STATE(2463), 1,
      sym__colon2,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    STATE(18427), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561781] = 7,
    ACTIONS(21820), 1,
      anon_sym_RBRACK,
    ACTIONS(21822), 1,
      anon_sym_PIPE,
    ACTIONS(21824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21826), 1,
      sym__arith_dotdot,
    ACTIONS(21828), 1,
      sym_comma,
    STATE(19580), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561806] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21500), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561825] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(17773), 1,
      sym__tyconsym,
    STATE(18229), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561846] = 7,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(19691), 1,
      sym__varid,
    STATE(4643), 1,
      sym_constructor,
    STATE(4787), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561871] = 7,
    ACTIONS(6220), 1,
      sym__conid,
    ACTIONS(19118), 1,
      sym__varid,
    STATE(7714), 1,
      sym_constructor,
    STATE(8017), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561896] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 6,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [561911] = 3,
    ACTIONS(16932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16930), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [561928] = 4,
    ACTIONS(18986), 1,
      anon_sym_deriving,
    STATE(15011), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21761), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561947] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21445), 1,
      sym_string,
    ACTIONS(21830), 1,
      anon_sym_LPAREN,
    STATE(15526), 1,
      sym_variable,
    STATE(16818), 1,
      sym_expent,
    STATE(21134), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561972] = 7,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21438), 1,
      sym_string,
    ACTIONS(21830), 1,
      anon_sym_LPAREN,
    STATE(15526), 1,
      sym_variable,
    STATE(16819), 1,
      sym_impent,
    STATE(21127), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561997] = 7,
    ACTIONS(8470), 1,
      sym__conid,
    ACTIONS(19654), 1,
      sym__varid,
    STATE(7881), 1,
      sym_constructor,
    STATE(8016), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562022] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(15996), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562045] = 4,
    ACTIONS(19219), 1,
      anon_sym_deriving,
    STATE(15541), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(21353), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562064] = 7,
    ACTIONS(12225), 1,
      sym__conid,
    ACTIONS(19305), 1,
      sym__varid,
    STATE(9654), 1,
      sym_constructor,
    STATE(9681), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562089] = 7,
    ACTIONS(9526), 1,
      sym__conid,
    ACTIONS(19683), 1,
      sym__varid,
    STATE(11983), 1,
      sym_constructor,
    STATE(12593), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562114] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14843), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    STATE(16508), 1,
      aux_sym__qualifying_module,
    STATE(14606), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562137] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15547), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21832), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [562156] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_via,
      anon_sym_deriving,
  [562173] = 7,
    ACTIONS(20572), 1,
      anon_sym_RBRACK,
    ACTIONS(20574), 1,
      anon_sym_PIPE,
    ACTIONS(20576), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20578), 1,
      sym__arith_dotdot,
    ACTIONS(20580), 1,
      sym_comma,
    STATE(18152), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562198] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [562213] = 5,
    ACTIONS(21566), 1,
      anon_sym_LBRACE,
    ACTIONS(21568), 1,
      sym__layout_start,
    STATE(19909), 1,
      sym_decls,
    ACTIONS(21277), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562234] = 4,
    ACTIONS(21782), 1,
      sym_comma,
    STATE(14999), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21699), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [562253] = 7,
    ACTIONS(21834), 1,
      anon_sym_RBRACK,
    ACTIONS(21836), 1,
      anon_sym_PIPE,
    ACTIONS(21838), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21840), 1,
      sym__arith_dotdot,
    ACTIONS(21842), 1,
      sym_comma,
    STATE(18787), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562278] = 7,
    ACTIONS(7783), 1,
      sym__conid,
    ACTIONS(19181), 1,
      sym__varid,
    STATE(6616), 1,
      sym_constructor,
    STATE(6883), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562303] = 3,
    STATE(14188), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20708), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [562320] = 7,
    ACTIONS(20508), 1,
      anon_sym_RBRACK,
    ACTIONS(20510), 1,
      anon_sym_PIPE,
    ACTIONS(20512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20514), 1,
      sym__arith_dotdot,
    ACTIONS(20516), 1,
      sym_comma,
    STATE(19060), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562345] = 7,
    ACTIONS(4603), 1,
      sym__conid,
    ACTIONS(19679), 1,
      sym__varid,
    STATE(4879), 1,
      sym_constructor,
    STATE(5303), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562370] = 5,
    ACTIONS(439), 1,
      sym__consym,
    ACTIONS(17769), 1,
      anon_sym_BQUOTE,
    ACTIONS(21844), 1,
      sym__tyconsym,
    STATE(18088), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562391] = 4,
    ACTIONS(21848), 1,
      sym_comma,
    STATE(15622), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21846), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [562410] = 7,
    ACTIONS(13012), 1,
      sym__conid,
    ACTIONS(18996), 1,
      sym__varid,
    STATE(8477), 1,
      sym_constructor,
    STATE(8803), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562435] = 7,
    ACTIONS(9390), 1,
      sym__conid,
    ACTIONS(19223), 1,
      sym__varid,
    STATE(11017), 1,
      sym_constructor,
    STATE(11207), 1,
      sym_variable,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562460] = 4,
    ACTIONS(21674), 1,
      sym_comma,
    STATE(15622), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21832), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [562479] = 5,
    ACTIONS(20692), 1,
      anon_sym_LPAREN,
    ACTIONS(20694), 1,
      anon_sym_hiding,
    STATE(18136), 1,
      sym_import_list,
    ACTIONS(21670), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562500] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [562514] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21851), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18688), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562536] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [562550] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21857), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20026), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562572] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 5,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_RBRACE,
  [562586] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21846), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [562600] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21542), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [562614] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21859), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19119), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562636] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20730), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18893), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562658] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21861), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19073), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562680] = 3,
    ACTIONS(20374), 2,
      sym__consym,
      sym__conid,
    ACTIONS(20372), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562696] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21863), 1,
      sym__unboxed_close,
    STATE(18072), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562718] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [562732] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15666), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562750] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21867), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [562764] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21869), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18702), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562786] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21080), 1,
      sym__unboxed_close,
    STATE(18051), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562808] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15666), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562826] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21871), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20050), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562848] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [562862] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [562876] = 4,
    ACTIONS(20449), 1,
      sym_where,
    STATE(19142), 1,
      sym_class_body,
    ACTIONS(21873), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562894] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15644), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562912] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(16215), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562930] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21875), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19999), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562952] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21879), 1,
      sym__unboxed_close,
    STATE(18402), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562974] = 3,
    ACTIONS(21881), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [562990] = 3,
    STATE(2725), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(21883), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563006] = 4,
    ACTIONS(21887), 1,
      anon_sym_LBRACE,
    ACTIONS(21889), 1,
      sym__layout_start,
    ACTIONS(21885), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563024] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21891), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19091), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563046] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21893), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18604), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563068] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15969), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21672), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563086] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21895), 1,
      sym__unboxed_close,
    STATE(18093), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563108] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563122] = 3,
    STATE(2644), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(21897), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563138] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21142), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19260), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563160] = 4,
    ACTIONS(21901), 1,
      sym_comma,
    STATE(15938), 1,
      aux_sym_guards_repeat1,
    ACTIONS(21899), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563178] = 5,
    ACTIONS(21903), 1,
      anon_sym_RPAREN,
    ACTIONS(21905), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563198] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21907), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19978), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563220] = 4,
    ACTIONS(21909), 1,
      sym_comma,
    STATE(15666), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21846), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563238] = 4,
    ACTIONS(20449), 1,
      sym_where,
    STATE(20046), 1,
      sym_class_body,
    ACTIONS(21912), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563256] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21914), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [563270] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20676), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [563284] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20740), 1,
      sym__unboxed_close,
    STATE(18338), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563306] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21916), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19110), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563328] = 3,
    STATE(2713), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(21918), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563344] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21920), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20025), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563366] = 3,
    STATE(2593), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(21922), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563382] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [563396] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20637), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [563410] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [563424] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [563438] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563452] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563466] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21924), 1,
      sym__unboxed_close,
    STATE(18357), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563488] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21926), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20071), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563510] = 4,
    ACTIONS(21930), 1,
      anon_sym_LBRACE,
    ACTIONS(21932), 1,
      sym__layout_start,
    ACTIONS(21928), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563528] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21934), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18747), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563550] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 5,
      sym_comma,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [563564] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21936), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19956), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563586] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563600] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20375), 1,
      sym_constructor,
    STATE(23162), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563622] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21938), 1,
      sym__unboxed_close,
    STATE(18054), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563644] = 3,
    STATE(2606), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(21940), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563660] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20855), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(20166), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563682] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21942), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18585), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563704] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21944), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20090), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563726] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21946), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19048), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563748] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21948), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19930), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563770] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563786] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563800] = 5,
    ACTIONS(20451), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym__colon2,
    STATE(21908), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563820] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [563834] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563848] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21950), 1,
      sym__unboxed_close,
    STATE(17988), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563870] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15640), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563888] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21162), 5,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [563902] = 4,
    STATE(15704), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(21952), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(21955), 2,
      sym__layout_end,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563920] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21957), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19989), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563942] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21959), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19914), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563964] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21961), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [563978] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [563992] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [564006] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21963), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20111), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564028] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21965), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18723), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564050] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21967), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19028), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564072] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564086] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21969), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(20164), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564108] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564122] = 3,
    STATE(2613), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(21971), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [564152] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564168] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564182] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [564196] = 5,
    ACTIONS(21975), 1,
      sym_comma,
    STATE(2416), 1,
      sym__colon2,
    STATE(15725), 1,
      aux_sym_field_repeat1,
    ACTIONS(21973), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564216] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21977), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20127), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564238] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20649), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [564252] = 5,
    ACTIONS(21979), 1,
      sym__immediate_dot,
    ACTIONS(21983), 1,
      anon_sym_EQ,
    STATE(16233), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(21981), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564272] = 5,
    ACTIONS(21975), 1,
      sym_comma,
    STATE(2410), 1,
      sym__colon2,
    STATE(16804), 1,
      aux_sym_field_repeat1,
    ACTIONS(21985), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564292] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20639), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [564306] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21987), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19890), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564328] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21989), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18480), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564350] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [564364] = 4,
    ACTIONS(21991), 1,
      sym__immediate_dot,
    STATE(15730), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(21994), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564382] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(21996), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18768), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564404] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(21998), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19087), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564426] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22000), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20154), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564448] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20259), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [564462] = 3,
    STATE(2587), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22002), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564478] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22004), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [564492] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22006), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18569), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564514] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20835), 1,
      sym__unboxed_close,
    STATE(18257), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564536] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564552] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22008), 1,
      sym__unboxed_close,
    STATE(18340), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564574] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22010), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20181), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564596] = 5,
    ACTIONS(22012), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym__colon2,
    STATE(20899), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564616] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22014), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [564630] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564644] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564658] = 3,
    STATE(2620), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22016), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564674] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22018), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20112), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564696] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20645), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [564710] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564724] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22020), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19865), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564746] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
  [564760] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17599), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [564774] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564788] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17623), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [564802] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22022), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564822] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22024), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19540), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564844] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17867), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564858] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22026), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20163), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564880] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22028), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564902] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564916] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22030), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19131), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564938] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564952] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21961), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564966] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22032), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22034), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [564994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22036), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565008] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22038), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20135), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565030] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17575), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [565044] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21610), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565060] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22040), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19704), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565082] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565096] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22042), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19847), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565118] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22044), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565152] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22046), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19636), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565188] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22048), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18821), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565210] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [565224] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22050), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18739), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565246] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565260] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565274] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22052), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18807), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565296] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22054), 1,
      sym__unboxed_close,
    STATE(17912), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565318] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17699), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [565332] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22056), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [565346] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22058), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565366] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22060), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20107), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565388] = 5,
    ACTIONS(20477), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym__colon2,
    STATE(21756), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565408] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565422] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22062), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19828), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565444] = 3,
    ACTIONS(22064), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [565460] = 3,
    STATE(2626), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22066), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565476] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22068), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18429), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565498] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22070), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18583), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565520] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22072), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19813), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565542] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(22074), 1,
      anon_sym_LPAREN,
    STATE(21007), 1,
      sym_export_names,
    ACTIONS(22076), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565562] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21140), 1,
      sym__unboxed_close,
    STATE(17904), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565584] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3577), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [565598] = 3,
    STATE(2630), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22078), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565614] = 4,
    STATE(502), 1,
      sym__arrow,
    ACTIONS(22080), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(22082), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565632] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565646] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565660] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [565674] = 3,
    STATE(2653), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22084), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565690] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22086), 1,
      sym__unboxed_close,
    STATE(18004), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565712] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22088), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19143), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565734] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565748] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22090), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18976), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565770] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21614), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565786] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22092), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19830), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565808] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22094), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20079), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565830] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22096), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19794), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565866] = 3,
    STATE(2690), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22098), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565882] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22100), 1,
      sym__unboxed_close,
    STATE(17900), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565904] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565920] = 4,
    ACTIONS(22104), 1,
      anon_sym_LBRACE,
    ACTIONS(22106), 1,
      sym__layout_start,
    ACTIONS(22102), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565938] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(21218), 1,
      sym_constructor,
    STATE(21424), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565960] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [565974] = 5,
    ACTIONS(5399), 1,
      sym__layout_end,
    ACTIONS(21598), 1,
      anon_sym_in,
    STATE(15909), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22108), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
  [566008] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22110), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19775), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566030] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566044] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [566058] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22112), 1,
      sym__unboxed_close,
    STATE(17855), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566080] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566094] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22114), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18479), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566116] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22116), 1,
      sym__unboxed_close,
    STATE(18455), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566152] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22118), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19758), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566174] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22120), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566194] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18533), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [566208] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566224] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(15900), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21672), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566242] = 4,
    ACTIONS(21901), 1,
      sym_comma,
    STATE(15663), 1,
      aux_sym_guards_repeat1,
    ACTIONS(22124), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566260] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(15945), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566278] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22128), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19806), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566300] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22130), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19738), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566322] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566336] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(16101), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566354] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [566368] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22132), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20051), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566390] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22134), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18746), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566412] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [566426] = 3,
    STATE(2726), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22136), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566442] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566456] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566470] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [566484] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22138), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19719), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566506] = 4,
    ACTIONS(22140), 1,
      anon_sym_PIPE,
    STATE(17898), 1,
      sym_tyfam_injectivity,
    ACTIONS(21391), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566524] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [566538] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(21085), 1,
      sym_constructor,
    STATE(21671), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566560] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21614), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566576] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566590] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22142), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18568), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566612] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
  [566626] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22144), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(20023), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566648] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22146), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18801), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566670] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21074), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [566684] = 5,
    ACTIONS(21979), 1,
      sym__immediate_dot,
    ACTIONS(22150), 1,
      anon_sym_EQ,
    STATE(16047), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(22148), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566704] = 3,
    STATE(2740), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22152), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566720] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16983), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [566734] = 3,
    STATE(2640), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22154), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566750] = 3,
    ACTIONS(21265), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [566766] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22156), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18862), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566788] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 5,
      sym__consym,
      sym__tyconsym,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
  [566802] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20979), 1,
      sym_constructor,
    STATE(21816), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566824] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21596), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [566838] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 5,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [566852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [566866] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21662), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [566880] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22158), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19638), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566902] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22160), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19994), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566924] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22162), 1,
      sym__unboxed_close,
    STATE(18460), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566946] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22164), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19906), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566968] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15341), 5,
      sym__dot,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [566982] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [566996] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22166), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18777), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567018] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22168), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567032] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567046] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22170), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18940), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567068] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17471), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567082] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17493), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567096] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22172), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18965), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567118] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567132] = 3,
    STATE(2657), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22174), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567148] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22176), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19964), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567170] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21610), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567186] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22178), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18926), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567208] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22180), 1,
      sym__unboxed_close,
    STATE(18341), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567230] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17525), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567244] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21614), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567260] = 5,
    ACTIONS(22182), 1,
      anon_sym_LBRACE,
    ACTIONS(22184), 1,
      sym__layout_start,
    STATE(21151), 1,
      sym_decls,
    ACTIONS(21271), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567280] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567294] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22186), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18450), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567316] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16016), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567334] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22188), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18876), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567356] = 3,
    STATE(2720), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22190), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567372] = 4,
    ACTIONS(22194), 1,
      anon_sym_LBRACE,
    ACTIONS(22196), 1,
      sym__layout_start,
    ACTIONS(22192), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567390] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16131), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567408] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22198), 1,
      sym__unboxed_close,
    STATE(18464), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567430] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22200), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19934), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567452] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22202), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19161), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567474] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22204), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19681), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567496] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(16107), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21672), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567514] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567528] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22032), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567542] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22206), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19875), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567564] = 5,
    ACTIONS(5411), 1,
      sym__layout_end,
    ACTIONS(21584), 1,
      anon_sym_in,
    STATE(15704), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22208), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567584] = 3,
    STATE(2635), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22210), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567600] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22034), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [567614] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16985), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567628] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21542), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [567642] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17649), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567656] = 3,
    ACTIONS(21269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [567672] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15345), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [567688] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22212), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19342), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567710] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7506), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [567726] = 4,
    ACTIONS(22214), 1,
      anon_sym_LBRACE,
    ACTIONS(22216), 1,
      sym__layout_start,
    ACTIONS(22192), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567744] = 5,
    ACTIONS(5369), 1,
      sym__layout_end,
    ACTIONS(21584), 1,
      anon_sym_in,
    STATE(15704), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22218), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567764] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [567778] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22220), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567798] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22222), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19904), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567820] = 3,
    ACTIONS(21193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [567836] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17011), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567850] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22224), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19663), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567872] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21500), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567890] = 3,
    STATE(2670), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22226), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567906] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22228), 1,
      sym__unboxed_close,
    STATE(18334), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567928] = 3,
    ACTIONS(22232), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22230), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [567944] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17535), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [567958] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22234), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19645), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567980] = 5,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(22074), 1,
      anon_sym_LPAREN,
    STATE(20676), 1,
      sym_export_names,
    ACTIONS(22236), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568000] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22238), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19874), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568022] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22240), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18941), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568044] = 3,
    STATE(2647), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22242), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568060] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21312), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568078] = 4,
    ACTIONS(22246), 1,
      sym_comma,
    STATE(15938), 1,
      aux_sym_guards_repeat1,
    ACTIONS(22244), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568096] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [568110] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22249), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19980), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568132] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [568146] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22251), 1,
      sym__unboxed_close,
    STATE(18317), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568168] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17547), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [568182] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [568196] = 4,
    ACTIONS(22253), 1,
      sym_comma,
    STATE(15945), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21846), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568214] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22256), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18905), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568236] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22258), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19661), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568258] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17455), 1,
      aux_sym__qualifying_module,
    STATE(20843), 1,
      sym_constructor,
    STATE(22164), 1,
      sym_qualified_type,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568280] = 3,
    STATE(2681), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22260), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568296] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [568310] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21582), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [568324] = 5,
    ACTIONS(5387), 1,
      sym__layout_end,
    ACTIONS(21584), 1,
      anon_sym_in,
    STATE(15704), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22262), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568344] = 3,
    STATE(10653), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22264), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568360] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22266), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19844), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568382] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22268), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19626), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568404] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22270), 1,
      sym__unboxed_close,
    STATE(18227), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568426] = 5,
    ACTIONS(21598), 1,
      anon_sym_in,
    ACTIONS(22274), 1,
      sym__layout_end,
    STATE(15952), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22272), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568446] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22276), 1,
      sym__unboxed_close,
    STATE(18331), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568468] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22278), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568488] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22280), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19603), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568510] = 3,
    STATE(2684), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22282), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568526] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22284), 1,
      sym__unboxed_close,
    STATE(18345), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568548] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22286), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18741), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568570] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20994), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18644), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568592] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20821), 1,
      sym_constructor,
    STATE(22200), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568614] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22288), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19586), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568636] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22290), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19059), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568658] = 5,
    ACTIONS(22292), 1,
      anon_sym_EQ,
    STATE(2463), 1,
      sym__colon2,
    STATE(18232), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568678] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15666), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568696] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22294), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18525), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568718] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22296), 1,
      sym__unboxed_close,
    STATE(17869), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568740] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17553), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [568754] = 5,
    ACTIONS(5421), 1,
      sym__layout_end,
    ACTIONS(21598), 1,
      anon_sym_in,
    STATE(15920), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22298), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568774] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22300), 1,
      sym__unboxed_close,
    STATE(18265), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568796] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21610), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568812] = 3,
    STATE(2695), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22302), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568828] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22304), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19569), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568850] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22306), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18991), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568872] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22308), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19814), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568894] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22310), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [568908] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [568922] = 5,
    ACTIONS(22314), 1,
      anon_sym_RPAREN,
    ACTIONS(22317), 1,
      sym_comma,
    STATE(18678), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(22312), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568942] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22320), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19045), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568964] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(15945), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568982] = 3,
    STATE(2702), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22322), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568998] = 3,
    STATE(2648), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22324), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569014] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569028] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17543), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [569042] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20765), 1,
      sym_constructor,
    STATE(22317), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569064] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569078] = 4,
    ACTIONS(22326), 1,
      anon_sym_PIPE,
    STATE(19536), 1,
      sym_tyfam_injectivity,
    ACTIONS(21391), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569096] = 3,
    STATE(2473), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22328), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569112] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22330), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19784), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569134] = 5,
    ACTIONS(21975), 1,
      sym_comma,
    STATE(2420), 1,
      sym__colon2,
    STATE(16804), 1,
      aux_sym_field_repeat1,
    ACTIONS(22332), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569154] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21346), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [569168] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(21219), 1,
      sym_import_list,
    ACTIONS(21214), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569188] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22168), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569202] = 3,
    STATE(2711), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22334), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569218] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22336), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19547), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569240] = 3,
    ACTIONS(21175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [569256] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569270] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20781), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18524), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569292] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22338), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19754), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569314] = 3,
    STATE(2608), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22340), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569330] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19810), 1,
      sym_via,
    ACTIONS(21626), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569348] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(15836), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569366] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20693), 1,
      sym_constructor,
    STATE(22426), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569388] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22342), 1,
      sym__unboxed_close,
    STATE(18552), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569410] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569424] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569438] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18523), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [569452] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22056), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [569466] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22344), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19024), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569488] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22036), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569502] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16070), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569520] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16131), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569538] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22346), 1,
      sym__unboxed_close,
    STATE(18258), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569560] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22348), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19724), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569582] = 3,
    ACTIONS(21171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [569598] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22350), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569618] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22352), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19458), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569640] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17627), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [569654] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21612), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16192), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569672] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22354), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19185), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569694] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22356), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19694), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569716] = 3,
    STATE(2729), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22358), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569732] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [569746] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [569760] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20635), 1,
      sym_constructor,
    STATE(22530), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569782] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [569798] = 3,
    STATE(2718), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22360), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569814] = 3,
    STATE(2665), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22362), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569830] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22364), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18948), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569852] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22366), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19664), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569874] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21312), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569892] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22368), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19526), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569914] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [569928] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22370), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19265), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569950] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22372), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18881), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569972] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17637), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [569986] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [570000] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [570014] = 5,
    ACTIONS(22374), 1,
      anon_sym_RBRACE,
    STATE(2467), 1,
      sym__colon2,
    STATE(20768), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570034] = 4,
    ACTIONS(22376), 1,
      anon_sym_PIPE,
    STATE(16201), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21668), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570052] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22378), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19634), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570074] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21666), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16202), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570092] = 5,
    ACTIONS(21979), 1,
      sym__immediate_dot,
    ACTIONS(22382), 1,
      anon_sym_EQ,
    STATE(15730), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(22380), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570112] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20968), 1,
      sym__unboxed_close,
    STATE(18389), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570134] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22384), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19527), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570156] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 5,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [570170] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [570184] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22386), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570204] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22388), 1,
      sym__unboxed_close,
    STATE(18107), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570226] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22390), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19604), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570248] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22392), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19205), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570270] = 5,
    ACTIONS(22394), 1,
      anon_sym_EQ,
    STATE(2453), 1,
      sym__colon2,
    STATE(18298), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570290] = 5,
    ACTIONS(20560), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym__colon2,
    STATE(22520), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570310] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [570324] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19298), 1,
      sym_via,
    ACTIONS(21314), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17867), 5,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_PERCENT,
  [570356] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21353), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570374] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22396), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19574), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570396] = 4,
    ACTIONS(22398), 1,
      sym_comma,
    STATE(16231), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(21387), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570414] = 4,
    ACTIONS(22400), 1,
      anon_sym_LBRACE,
    ACTIONS(22402), 1,
      sym__layout_start,
    ACTIONS(21928), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570432] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(21195), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14765), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570450] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15409), 4,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [570466] = 3,
    STATE(10439), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22404), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570482] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22406), 1,
      sym__unboxed_close,
    STATE(18202), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570504] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22408), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19494), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570526] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16131), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570544] = 3,
    STATE(2736), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22410), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570560] = 6,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(20197), 1,
      sym__conid,
    ACTIONS(22412), 1,
      anon_sym_LPAREN,
    STATE(17083), 1,
      sym_constructor,
    STATE(20783), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570582] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19734), 1,
      sym_via,
    ACTIONS(21550), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570600] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16108), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570618] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19732), 1,
      sym_via,
    ACTIONS(21548), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570636] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22414), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19544), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570658] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22416), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19503), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570680] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22418), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19192), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570702] = 3,
    ACTIONS(22420), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [570718] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22422), 1,
      sym__unboxed_close,
    STATE(18118), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570740] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20680), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19907), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570762] = 3,
    STATE(2599), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22424), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570778] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22426), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19224), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570800] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22428), 1,
      sym__unboxed_close,
    STATE(18226), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570822] = 4,
    ACTIONS(22430), 1,
      anon_sym_LBRACE,
    ACTIONS(22432), 1,
      sym__layout_start,
    ACTIONS(21885), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570840] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15413), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [570856] = 3,
    ACTIONS(21166), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15498), 4,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
  [570872] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [570886] = 4,
    ACTIONS(20622), 1,
      sym_where,
    STATE(18027), 1,
      sym_class_body,
    ACTIONS(21912), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570904] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20565), 1,
      sym_constructor,
    STATE(22655), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570926] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(15984), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570944] = 4,
    ACTIONS(22376), 1,
      anon_sym_PIPE,
    STATE(16171), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21546), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570962] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22434), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19514), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570984] = 5,
    ACTIONS(21975), 1,
      sym_comma,
    STATE(2409), 1,
      sym__colon2,
    STATE(15994), 1,
      aux_sym_field_repeat1,
    ACTIONS(22436), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571004] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22438), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18852), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571026] = 3,
    STATE(2676), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22440), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571042] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22310), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571056] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22442), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19482), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571078] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22444), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571098] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22446), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571112] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(15945), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21759), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571130] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22448), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19460), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571152] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22450), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19805), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571174] = 3,
    STATE(2792), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22452), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571190] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22454), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19178), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571212] = 3,
    STATE(2688), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22456), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571228] = 4,
    ACTIONS(22126), 1,
      sym_comma,
    STATE(15945), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571246] = 4,
    ACTIONS(22122), 1,
      sym_comma,
    STATE(16131), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21759), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571264] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22458), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19499), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571286] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17657), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [571300] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571314] = 5,
    ACTIONS(22182), 1,
      anon_sym_LBRACE,
    ACTIONS(22184), 1,
      sym__layout_start,
    STATE(21291), 1,
      sym_decls,
    ACTIONS(21277), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571334] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22460), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571348] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22462), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19481), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571370] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21369), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571384] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22464), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19441), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571406] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22466), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571426] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22468), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19164), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571448] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22470), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19416), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571470] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22472), 1,
      sym__unboxed_close,
    STATE(18171), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571492] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(20837), 1,
      sym_import_list,
    ACTIONS(21457), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571512] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22474), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18879), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571534] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [571548] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21542), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [571562] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22476), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19250), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571584] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22478), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19369), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571606] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22480), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19396), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571628] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22482), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19163), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571650] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [571664] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16994), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [571678] = 4,
    ACTIONS(22484), 1,
      sym_comma,
    STATE(16131), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21846), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571696] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22487), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19462), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571718] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22489), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19376), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571740] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21914), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [571754] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571768] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22491), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571788] = 3,
    STATE(2698), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22493), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571804] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [571818] = 3,
    STATE(2708), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22495), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571834] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [571848] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22497), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571868] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [571882] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22499), 1,
      sym__unboxed_close,
    STATE(17974), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571904] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22501), 1,
      sym__unboxed_close,
    STATE(18182), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571926] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22503), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18836), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571948] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [571962] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21369), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [571976] = 3,
    STATE(2744), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22505), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571992] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21534), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572010] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22460), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572024] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21471), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572042] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22507), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19353), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572064] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22509), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19190), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572086] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [572100] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20851), 1,
      sym__unboxed_close,
    STATE(18170), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572122] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(20940), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19086), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572144] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21395), 5,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [572158] = 4,
    ACTIONS(22511), 1,
      sym_comma,
    STATE(16158), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(21346), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572176] = 3,
    STATE(2742), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22514), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572192] = 3,
    STATE(2616), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22516), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572208] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22518), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18651), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572230] = 4,
    ACTIONS(22520), 1,
      anon_sym_SEMI,
    STATE(16162), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(15652), 3,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572248] = 4,
    ACTIONS(22523), 1,
      anon_sym_deriving,
    ACTIONS(21374), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572266] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19546), 1,
      sym_via,
    ACTIONS(21430), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572284] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17445), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [572298] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19475), 1,
      sym_via,
    ACTIONS(21428), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572316] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20495), 1,
      sym_constructor,
    STATE(22779), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572338] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22526), 1,
      sym__unboxed_close,
    STATE(17905), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572360] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572374] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22528), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(18895), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572396] = 4,
    ACTIONS(22530), 1,
      anon_sym_PIPE,
    STATE(16171), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21369), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572414] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(21235), 1,
      sym_import_list,
    ACTIONS(21624), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572434] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_deriving,
  [572448] = 4,
    ACTIONS(22533), 1,
      anon_sym_LBRACE,
    ACTIONS(22535), 1,
      sym__layout_start,
    ACTIONS(22102), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572466] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572480] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(21223), 1,
      sym_import_list,
    ACTIONS(21670), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572500] = 4,
    ACTIONS(22376), 1,
      anon_sym_PIPE,
    STATE(16171), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21399), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572518] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22537), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19297), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572540] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21867), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [572554] = 4,
    ACTIONS(22376), 1,
      anon_sym_PIPE,
    STATE(16092), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21399), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572572] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22539), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19273), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572594] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22446), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572608] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [572622] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20374), 5,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      anon_sym_DASH,
      sym__conid,
  [572636] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572650] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22541), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [572664] = 4,
    ACTIONS(20622), 1,
      sym_where,
    STATE(17851), 1,
      sym_class_body,
    ACTIONS(21873), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572682] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22543), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19283), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572704] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(21143), 1,
      sym_import_list,
    ACTIONS(21351), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572724] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(21263), 1,
      sym_import_list,
    ACTIONS(21328), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572744] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22545), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18818), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572766] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21761), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572784] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21471), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572802] = 3,
    STATE(2664), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22547), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572818] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572832] = 6,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(22549), 1,
      sym__unboxed_close,
    STATE(18409), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(19341), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572854] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17867), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [572868] = 4,
    ACTIONS(22376), 1,
      anon_sym_PIPE,
    STATE(16177), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21745), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572886] = 5,
    ACTIONS(21177), 1,
      anon_sym_LPAREN,
    ACTIONS(21179), 1,
      anon_sym_hiding,
    STATE(21177), 1,
      sym_import_list,
    ACTIONS(21326), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572906] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21344), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572924] = 4,
    ACTIONS(22376), 1,
      anon_sym_PIPE,
    STATE(16171), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(21745), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572942] = 4,
    ACTIONS(19818), 1,
      anon_sym_deriving,
    ACTIONS(21743), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(16163), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572960] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19430), 1,
      sym_via,
    ACTIONS(21725), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572978] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22551), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19296), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573000] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22553), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19393), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573022] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22541), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [573036] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22555), 1,
      sym__unboxed_close,
    STATE(18212), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573058] = 3,
    STATE(2732), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22557), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573074] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21346), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [573088] = 4,
    ACTIONS(20748), 1,
      anon_sym_via,
    STATE(19436), 1,
      sym_via,
    ACTIONS(21701), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573106] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22559), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19332), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573128] = 3,
    STATE(2749), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22561), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573144] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573158] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22563), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19405), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573180] = 4,
    ACTIONS(21865), 1,
      sym_comma,
    STATE(15666), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21759), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573198] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573212] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22565), 1,
      sym__unboxed_close,
    STATE(18574), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573234] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22567), 1,
      sym__unboxed_close,
    STATE(17936), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573256] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573270] = 3,
    STATE(2753), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22569), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573286] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22571), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(18665), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573308] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22573), 1,
      sym__unboxed_close,
    STATE(18108), 1,
      aux_sym_type_list_repeat1,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573330] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(21144), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(18461), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573352] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573366] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [573380] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573394] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573408] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [573422] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22575), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19327), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573444] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22577), 1,
      sym__unboxed_close,
    STATE(18017), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573466] = 4,
    ACTIONS(22398), 1,
      sym_comma,
    STATE(16158), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(21699), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573484] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573498] = 5,
    ACTIONS(21979), 1,
      sym__immediate_dot,
    ACTIONS(22581), 1,
      anon_sym_EQ,
    STATE(15730), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(22579), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573518] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573532] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573546] = 5,
    ACTIONS(22182), 1,
      anon_sym_LBRACE,
    ACTIONS(22184), 1,
      sym__layout_start,
    STATE(20556), 1,
      sym_decls,
    ACTIONS(21616), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573566] = 3,
    STATE(2669), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22583), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573582] = 6,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(22585), 1,
      sym__unboxed_close,
    STATE(18396), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(19027), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573604] = 3,
    STATE(2755), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(22587), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573620] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573634] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573648] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [573662] = 6,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(22589), 1,
      sym__unboxed_close,
    STATE(18576), 1,
      aux_sym__type_sum_repeat1,
    STATE(19316), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573684] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [573698] = 5,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22591), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573718] = 6,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(17830), 1,
      aux_sym__qualifying_module,
    STATE(20422), 1,
      sym_constructor,
    STATE(22957), 1,
      sym_qualified_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573740] = 5,
    ACTIONS(22182), 1,
      anon_sym_LBRACE,
    ACTIONS(22184), 1,
      sym__layout_start,
    STATE(20555), 1,
      sym_decls,
    ACTIONS(21564), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573760] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [573774] = 4,
    ACTIONS(22595), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22597), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573791] = 4,
    STATE(2452), 1,
      sym__colon2,
    STATE(11278), 1,
      sym__type_annotation,
    ACTIONS(17763), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573808] = 5,
    ACTIONS(1371), 1,
      anon_sym_RBRACE,
    ACTIONS(22599), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16583), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573827] = 5,
    ACTIONS(7429), 1,
      sym__conid,
    STATE(7690), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573846] = 5,
    ACTIONS(1371), 1,
      anon_sym_RBRACE,
    ACTIONS(22599), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573865] = 4,
    ACTIONS(22601), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22603), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573882] = 5,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    ACTIONS(22605), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573901] = 5,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    ACTIONS(22605), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16354), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573920] = 4,
    ACTIONS(5443), 1,
      sym__layout_end,
    STATE(16349), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22607), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573937] = 4,
    ACTIONS(1369), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22609), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573954] = 4,
    ACTIONS(1055), 1,
      sym__layout_end,
    STATE(16274), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22611), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573971] = 5,
    ACTIONS(1055), 1,
      anon_sym_RBRACE,
    ACTIONS(22613), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16277), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573990] = 5,
    ACTIONS(14871), 1,
      anon_sym_RBRACE,
    ACTIONS(22615), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574009] = 5,
    ACTIONS(11707), 1,
      anon_sym_RBRACE,
    ACTIONS(22617), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574028] = 5,
    ACTIONS(14245), 1,
      anon_sym_RBRACE,
    ACTIONS(22619), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16425), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574047] = 5,
    ACTIONS(5443), 1,
      anon_sym_RBRACE,
    ACTIONS(22621), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16635), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574066] = 5,
    ACTIONS(1361), 1,
      anon_sym_RBRACE,
    ACTIONS(22623), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574085] = 5,
    ACTIONS(14881), 1,
      anon_sym_RBRACE,
    ACTIONS(22625), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574104] = 4,
    ACTIONS(11389), 1,
      sym__layout_end,
    STATE(16283), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22627), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574121] = 5,
    ACTIONS(11389), 1,
      anon_sym_RBRACE,
    ACTIONS(22629), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16287), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574140] = 4,
    ACTIONS(14134), 1,
      sym__layout_end,
    STATE(16288), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22631), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574157] = 5,
    ACTIONS(14881), 1,
      anon_sym_RBRACE,
    ACTIONS(22625), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16261), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574176] = 5,
    ACTIONS(14134), 1,
      anon_sym_RBRACE,
    ACTIONS(22633), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16291), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574195] = 4,
    ACTIONS(14881), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22635), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574212] = 5,
    ACTIONS(5443), 1,
      anon_sym_RBRACE,
    ACTIONS(22621), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574231] = 4,
    ACTIONS(1355), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22637), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574248] = 5,
    ACTIONS(11711), 1,
      anon_sym_RBRACE,
    ACTIONS(22639), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574267] = 5,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    ACTIONS(22641), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16294), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574286] = 5,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    ACTIONS(22641), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574305] = 5,
    ACTIONS(11711), 1,
      anon_sym_RBRACE,
    ACTIONS(22639), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16262), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574324] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16355), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574341] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16449), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21780), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574358] = 4,
    ACTIONS(11711), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22645), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574375] = 4,
    ACTIONS(14245), 1,
      sym__layout_end,
    STATE(16324), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22647), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574392] = 4,
    ACTIONS(12132), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22649), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574409] = 5,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    ACTIONS(22651), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574428] = 5,
    ACTIONS(12132), 1,
      anon_sym_RBRACE,
    ACTIONS(22653), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16298), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574447] = 5,
    ACTIONS(11417), 1,
      anon_sym_RBRACE,
    ACTIONS(22655), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16312), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574466] = 5,
    ACTIONS(12132), 1,
      anon_sym_RBRACE,
    ACTIONS(22653), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574485] = 4,
    ACTIONS(14685), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22657), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574502] = 4,
    ACTIONS(11417), 1,
      sym__layout_end,
    STATE(16305), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22659), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574519] = 5,
    ACTIONS(14685), 1,
      anon_sym_RBRACE,
    ACTIONS(22661), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16300), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574538] = 5,
    ACTIONS(14685), 1,
      anon_sym_RBRACE,
    ACTIONS(22661), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574557] = 5,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    ACTIONS(22651), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16265), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574576] = 4,
    ACTIONS(1357), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22663), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574593] = 5,
    ACTIONS(1365), 1,
      anon_sym_RBRACE,
    ACTIONS(22665), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574612] = 4,
    ACTIONS(22667), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22669), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574629] = 5,
    ACTIONS(14442), 1,
      anon_sym_RBRACE,
    ACTIONS(22671), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16266), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574648] = 4,
    ACTIONS(14442), 1,
      sym__layout_end,
    STATE(16272), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22673), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574665] = 5,
    ACTIONS(12126), 1,
      anon_sym_RBRACE,
    ACTIONS(22675), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574684] = 5,
    ACTIONS(11695), 1,
      anon_sym_RBRACE,
    ACTIONS(22677), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16275), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574703] = 5,
    ACTIONS(14687), 1,
      anon_sym_RBRACE,
    ACTIONS(22679), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574722] = 4,
    ACTIONS(11695), 1,
      sym__layout_end,
    STATE(16281), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22681), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574739] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22004), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [574752] = 4,
    ACTIONS(1371), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22683), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574769] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [574782] = 4,
    ACTIONS(12239), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22685), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574799] = 5,
    ACTIONS(5233), 1,
      anon_sym_RBRACE,
    ACTIONS(22687), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574818] = 5,
    ACTIONS(939), 1,
      anon_sym_RBRACE,
    ACTIONS(22689), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16284), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574837] = 5,
    ACTIONS(12239), 1,
      anon_sym_RBRACE,
    ACTIONS(22691), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16366), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574856] = 5,
    ACTIONS(5233), 1,
      anon_sym_RBRACE,
    ACTIONS(22687), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16563), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574875] = 4,
    ACTIONS(951), 1,
      sym__layout_end,
    STATE(16320), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22693), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574892] = 5,
    ACTIONS(951), 1,
      anon_sym_RBRACE,
    ACTIONS(22695), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16323), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574911] = 5,
    ACTIONS(12239), 1,
      anon_sym_RBRACE,
    ACTIONS(22691), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574930] = 4,
    ACTIONS(11618), 1,
      sym__layout_end,
    STATE(16329), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22697), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574947] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21961), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [574960] = 4,
    ACTIONS(5233), 1,
      sym__layout_end,
    STATE(16560), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(22699), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574977] = 5,
    ACTIONS(11618), 1,
      anon_sym_RBRACE,
    ACTIONS(22701), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16337), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574996] = 4,
    ACTIONS(14253), 1,
      sym__layout_end,
    STATE(16345), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22703), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575013] = 5,
    ACTIONS(14253), 1,
      anon_sym_RBRACE,
    ACTIONS(22705), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16348), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575032] = 4,
    ACTIONS(939), 1,
      sym__layout_end,
    STATE(16293), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22707), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575049] = 4,
    ACTIONS(1375), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22709), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575066] = 5,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(22711), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16255), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575085] = 5,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    ACTIONS(22713), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16356), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575104] = 5,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    ACTIONS(22713), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575123] = 4,
    ACTIONS(14683), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22715), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575140] = 5,
    ACTIONS(6030), 1,
      anon_sym_RBRACE,
    ACTIONS(22717), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575159] = 5,
    ACTIONS(14683), 1,
      anon_sym_RBRACE,
    ACTIONS(22719), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16368), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575178] = 5,
    ACTIONS(22721), 1,
      anon_sym_SEMI,
    ACTIONS(22724), 1,
      anon_sym_RBRACE,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575197] = 5,
    ACTIONS(2003), 1,
      sym__conid,
    STATE(4591), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575216] = 4,
    ACTIONS(11855), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22726), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575233] = 5,
    ACTIONS(11855), 1,
      anon_sym_RBRACE,
    ACTIONS(22728), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16359), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575252] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [575265] = 4,
    STATE(2457), 1,
      sym__colon2,
    STATE(12735), 1,
      sym__type_annotation,
    ACTIONS(17889), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575282] = 5,
    ACTIONS(22730), 1,
      anon_sym_SEMI,
    ACTIONS(22732), 1,
      sym__layout_semicolon,
    ACTIONS(22734), 1,
      sym__layout_end,
    STATE(16670), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575301] = 5,
    ACTIONS(13304), 1,
      sym__conid,
    STATE(8493), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575320] = 4,
    ACTIONS(22736), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22738), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575337] = 4,
    ACTIONS(1051), 1,
      sym__layout_end,
    STATE(16258), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22740), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575354] = 5,
    ACTIONS(11855), 1,
      anon_sym_RBRACE,
    ACTIONS(22728), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575373] = 5,
    ACTIONS(22742), 1,
      anon_sym_SEMI,
    ACTIONS(22744), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16678), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575392] = 5,
    ACTIONS(15317), 1,
      sym__conid,
    STATE(14063), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575411] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22460), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [575424] = 5,
    ACTIONS(22746), 1,
      anon_sym_SEMI,
    ACTIONS(22748), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575443] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21369), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [575456] = 5,
    ACTIONS(103), 1,
      sym__conid,
    STATE(8439), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575475] = 5,
    ACTIONS(4435), 1,
      sym__conid,
    STATE(4788), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575494] = 4,
    ACTIONS(14873), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22750), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575511] = 5,
    ACTIONS(14873), 1,
      anon_sym_RBRACE,
    ACTIONS(22752), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16362), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575530] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(22754), 1,
      anon_sym_RBRACE,
    STATE(15721), 1,
      sym_variable,
    STATE(18197), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575549] = 5,
    ACTIONS(14873), 1,
      anon_sym_RBRACE,
    ACTIONS(22752), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575568] = 4,
    ACTIONS(21955), 1,
      sym__layout_end,
    STATE(16349), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22756), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575585] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21428), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [575598] = 4,
    ACTIONS(22759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22761), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575615] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21346), 4,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [575628] = 4,
    ACTIONS(22763), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22765), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575645] = 5,
    ACTIONS(1353), 1,
      anon_sym_RBRACE,
    ACTIONS(22767), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575664] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16449), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21759), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575681] = 5,
    ACTIONS(1377), 1,
      anon_sym_RBRACE,
    ACTIONS(22769), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575700] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22771), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [575713] = 4,
    ACTIONS(5421), 1,
      sym__layout_end,
    STATE(16373), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22773), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575730] = 5,
    ACTIONS(11857), 1,
      anon_sym_RBRACE,
    ACTIONS(22775), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575749] = 5,
    ACTIONS(5421), 1,
      anon_sym_RBRACE,
    ACTIONS(22777), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16378), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575768] = 5,
    ACTIONS(17789), 1,
      anon_sym_RBRACE,
    ACTIONS(22779), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575787] = 5,
    ACTIONS(14863), 1,
      anon_sym_RBRACE,
    ACTIONS(22781), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575806] = 4,
    STATE(2476), 1,
      sym__colon2,
    STATE(14172), 1,
      sym__type_annotation,
    ACTIONS(17959), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575823] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [575836] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [575849] = 5,
    ACTIONS(12282), 1,
      anon_sym_RBRACE,
    ACTIONS(22783), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575868] = 5,
    ACTIONS(15025), 1,
      anon_sym_RBRACE,
    ACTIONS(22785), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575887] = 5,
    ACTIONS(14630), 1,
      anon_sym_RBRACE,
    ACTIONS(22787), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575906] = 4,
    ACTIONS(22789), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22791), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [575936] = 5,
    ACTIONS(11893), 1,
      anon_sym_RBRACE,
    ACTIONS(22793), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575955] = 4,
    STATE(2475), 1,
      sym__colon2,
    STATE(20306), 1,
      sym__type_annotation,
    ACTIONS(20007), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575972] = 4,
    ACTIONS(5369), 1,
      sym__layout_end,
    STATE(16349), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(22795), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575989] = 4,
    ACTIONS(22797), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22799), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576006] = 5,
    ACTIONS(1335), 1,
      anon_sym_RBRACE,
    ACTIONS(22801), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576025] = 5,
    ACTIONS(14575), 1,
      anon_sym_RBRACE,
    ACTIONS(22803), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576044] = 5,
    ACTIONS(5369), 1,
      anon_sym_RBRACE,
    ACTIONS(22805), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16414), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576063] = 5,
    ACTIONS(5369), 1,
      anon_sym_RBRACE,
    ACTIONS(22805), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576082] = 5,
    ACTIONS(15027), 1,
      anon_sym_RBRACE,
    ACTIONS(22807), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576101] = 5,
    ACTIONS(12367), 1,
      anon_sym_RBRACE,
    ACTIONS(22809), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576120] = 4,
    STATE(2489), 1,
      sym__colon2,
    STATE(17068), 1,
      sym__type_annotation,
    ACTIONS(18233), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576137] = 5,
    ACTIONS(15027), 1,
      anon_sym_RBRACE,
    ACTIONS(22807), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16367), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576156] = 4,
    ACTIONS(15027), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22811), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576173] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [576186] = 4,
    ACTIONS(22813), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22815), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576203] = 5,
    ACTIONS(11899), 1,
      anon_sym_RBRACE,
    ACTIONS(22817), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576222] = 5,
    ACTIONS(1345), 1,
      anon_sym_RBRACE,
    ACTIONS(22819), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576241] = 5,
    ACTIONS(11899), 1,
      anon_sym_RBRACE,
    ACTIONS(22817), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16371), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576260] = 3,
    ACTIONS(22823), 1,
      sym_where,
    ACTIONS(22821), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576275] = 4,
    ACTIONS(11899), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22825), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576292] = 5,
    ACTIONS(22827), 1,
      anon_sym_SEMI,
    ACTIONS(22829), 1,
      sym__layout_semicolon,
    ACTIONS(22831), 1,
      sym__layout_end,
    STATE(16695), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576311] = 5,
    ACTIONS(22833), 1,
      anon_sym_SEMI,
    ACTIONS(22835), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16723), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576330] = 4,
    ACTIONS(22837), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22839), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576347] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [576360] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [576373] = 5,
    ACTIONS(14573), 1,
      anon_sym_RBRACE,
    ACTIONS(22841), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576392] = 5,
    ACTIONS(14573), 1,
      anon_sym_RBRACE,
    ACTIONS(22841), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16376), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576411] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21430), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [576424] = 5,
    ACTIONS(1329), 1,
      anon_sym_RBRACE,
    ACTIONS(22843), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576443] = 4,
    ACTIONS(14573), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22845), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576460] = 4,
    ACTIONS(1007), 1,
      sym__layout_end,
    STATE(16424), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22847), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576477] = 5,
    ACTIONS(1329), 1,
      anon_sym_RBRACE,
    ACTIONS(22843), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16375), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576496] = 5,
    ACTIONS(1007), 1,
      anon_sym_RBRACE,
    ACTIONS(22849), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16428), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576515] = 4,
    ACTIONS(1329), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22851), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576532] = 5,
    ACTIONS(12369), 1,
      anon_sym_RBRACE,
    ACTIONS(22853), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576551] = 5,
    ACTIONS(14374), 1,
      anon_sym_RBRACE,
    ACTIONS(22855), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16379), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576570] = 4,
    ACTIONS(14374), 1,
      sym__layout_end,
    STATE(16383), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22857), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576587] = 5,
    ACTIONS(11467), 1,
      anon_sym_RBRACE,
    ACTIONS(22859), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16386), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576606] = 4,
    ACTIONS(11467), 1,
      sym__layout_end,
    STATE(16390), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22861), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576623] = 5,
    ACTIONS(927), 1,
      anon_sym_RBRACE,
    ACTIONS(22863), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16399), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576642] = 5,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14313), 1,
      sym__modid,
    STATE(14420), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576661] = 4,
    ACTIONS(22868), 1,
      sym__layout_end,
    STATE(16412), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(22865), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576678] = 4,
    ACTIONS(927), 1,
      sym__layout_end,
    STATE(16404), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22870), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576695] = 5,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    ACTIONS(22872), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576714] = 5,
    ACTIONS(12369), 1,
      anon_sym_RBRACE,
    ACTIONS(22853), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16380), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576733] = 4,
    ACTIONS(11455), 1,
      sym__layout_end,
    STATE(16436), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22874), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576750] = 5,
    ACTIONS(8534), 1,
      sym__conid,
    STATE(8037), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576769] = 5,
    ACTIONS(11455), 1,
      anon_sym_RBRACE,
    ACTIONS(22876), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16440), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576788] = 4,
    ACTIONS(14323), 1,
      sym__layout_end,
    STATE(16442), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22878), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576805] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21542), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [576818] = 5,
    ACTIONS(14323), 1,
      anon_sym_RBRACE,
    ACTIONS(22880), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16446), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576837] = 4,
    ACTIONS(22882), 1,
      anon_sym_LPAREN,
    STATE(20937), 1,
      sym_import_con_names,
    ACTIONS(22884), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576854] = 4,
    ACTIONS(12369), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22886), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576871] = 4,
    ACTIONS(1367), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22888), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576888] = 5,
    ACTIONS(14683), 1,
      anon_sym_RBRACE,
    ACTIONS(22719), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576907] = 5,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    ACTIONS(22890), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16451), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576926] = 5,
    ACTIONS(1343), 1,
      anon_sym_RBRACE,
    ACTIONS(22892), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576945] = 5,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    ACTIONS(22890), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576964] = 5,
    ACTIONS(1343), 1,
      anon_sym_RBRACE,
    ACTIONS(22892), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16387), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576983] = 4,
    ACTIONS(22894), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22896), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577000] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18555), 4,
      sym__consym,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
  [577013] = 5,
    ACTIONS(1087), 1,
      anon_sym_RBRACE,
    ACTIONS(22898), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16427), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577032] = 4,
    ACTIONS(1343), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22900), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577049] = 4,
    STATE(2487), 1,
      sym__colon2,
    STATE(13192), 1,
      sym__type_annotation,
    ACTIONS(17911), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577066] = 5,
    ACTIONS(237), 1,
      anon_sym_RBRACE,
    ACTIONS(22902), 1,
      anon_sym_SEMI,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16441), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577085] = 4,
    ACTIONS(11911), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22904), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577102] = 5,
    ACTIONS(6192), 1,
      sym__conid,
    STATE(4201), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577121] = 5,
    ACTIONS(11911), 1,
      anon_sym_RBRACE,
    ACTIONS(22906), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16456), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577140] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [577153] = 5,
    ACTIONS(11911), 1,
      anon_sym_RBRACE,
    ACTIONS(22906), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577172] = 5,
    ACTIONS(22908), 1,
      anon_sym_SEMI,
    ACTIONS(22911), 1,
      anon_sym_RBRACE,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16441), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577191] = 4,
    ACTIONS(14701), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22913), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577208] = 5,
    ACTIONS(4607), 1,
      sym__conid,
    STATE(4784), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577227] = 5,
    ACTIONS(14701), 1,
      anon_sym_RBRACE,
    ACTIONS(22915), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16459), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577246] = 5,
    ACTIONS(14004), 1,
      anon_sym_RBRACE,
    ACTIONS(22917), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16396), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577265] = 5,
    ACTIONS(14701), 1,
      anon_sym_RBRACE,
    ACTIONS(22915), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577284] = 4,
    ACTIONS(22074), 1,
      anon_sym_LPAREN,
    STATE(20900), 1,
      sym_export_names,
    ACTIONS(22919), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577301] = 4,
    ACTIONS(14004), 1,
      sym__layout_end,
    STATE(16400), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(22921), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577318] = 4,
    ACTIONS(22923), 1,
      sym_comma,
    STATE(16449), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21846), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577335] = 5,
    ACTIONS(11200), 1,
      anon_sym_RBRACE,
    ACTIONS(22926), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16405), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577354] = 5,
    ACTIONS(1381), 1,
      anon_sym_RBRACE,
    ACTIONS(22928), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577373] = 4,
    ACTIONS(11200), 1,
      sym__layout_end,
    STATE(16423), 1,
      aux_sym_alts_repeat2,
    ACTIONS(22930), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577390] = 5,
    ACTIONS(15321), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14863), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577409] = 4,
    ACTIONS(237), 1,
      sym__layout_end,
    STATE(17419), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(22932), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577426] = 5,
    ACTIONS(103), 1,
      sym__conid,
    STATE(4272), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577445] = 5,
    ACTIONS(11907), 1,
      anon_sym_RBRACE,
    ACTIONS(22934), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577464] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16449), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577481] = 4,
    ACTIONS(22936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22938), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577498] = 5,
    ACTIONS(14703), 1,
      anon_sym_RBRACE,
    ACTIONS(22940), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577517] = 5,
    ACTIONS(21166), 1,
      anon_sym_RBRACE,
    ACTIONS(22942), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577536] = 5,
    ACTIONS(21166), 1,
      anon_sym_RBRACE,
    ACTIONS(22942), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16528), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577555] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [577568] = 4,
    ACTIONS(22944), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22946), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577585] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16280), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21832), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577602] = 5,
    ACTIONS(22948), 1,
      anon_sym_SEMI,
    ACTIONS(22950), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577621] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18523), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [577634] = 4,
    ACTIONS(1087), 1,
      sym__layout_end,
    STATE(16433), 1,
      aux_sym_rec_repeat2,
    ACTIONS(22952), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577651] = 4,
    ACTIONS(21166), 1,
      sym__layout_end,
    STATE(16517), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(22954), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577668] = 4,
    ACTIONS(21038), 1,
      sym_where,
    STATE(21256), 1,
      sym_class_body,
    ACTIONS(21912), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577685] = 5,
    ACTIONS(15329), 1,
      sym__conid,
    STATE(14465), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577704] = 5,
    ACTIONS(22956), 1,
      anon_sym_SEMI,
    ACTIONS(22958), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577723] = 4,
    ACTIONS(163), 1,
      sym__layout_end,
    STATE(16454), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(22960), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577740] = 5,
    ACTIONS(237), 1,
      anon_sym_RBRACE,
    ACTIONS(22902), 1,
      anon_sym_SEMI,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16795), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577759] = 5,
    ACTIONS(22962), 1,
      anon_sym_SEMI,
    ACTIONS(22964), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16465), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577778] = 4,
    STATE(2224), 1,
      sym__colon2,
    STATE(18799), 1,
      sym__gadt_constr_type,
    ACTIONS(22966), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577795] = 5,
    ACTIONS(16854), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(16066), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577814] = 5,
    ACTIONS(22968), 1,
      anon_sym_SEMI,
    ACTIONS(22970), 1,
      sym__layout_semicolon,
    ACTIONS(22972), 1,
      sym__layout_end,
    STATE(16922), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577833] = 5,
    ACTIONS(22974), 1,
      anon_sym_SEMI,
    ACTIONS(22976), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577852] = 4,
    STATE(2503), 1,
      sym__colon2,
    STATE(15717), 1,
      sym__type_annotation,
    ACTIONS(17913), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577869] = 5,
    ACTIONS(22978), 1,
      anon_sym_SEMI,
    ACTIONS(22980), 1,
      sym__layout_semicolon,
    ACTIONS(22982), 1,
      sym__layout_end,
    STATE(16670), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577888] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [577901] = 5,
    ACTIONS(11000), 1,
      sym__conid,
    STATE(7990), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577920] = 5,
    ACTIONS(12450), 1,
      sym__conid,
    STATE(8727), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577939] = 3,
    ACTIONS(17144), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(18529), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577954] = 5,
    ACTIONS(4741), 1,
      sym__conid,
    STATE(11985), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577973] = 4,
    ACTIONS(22984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(22986), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577990] = 5,
    ACTIONS(4873), 1,
      sym__conid,
    STATE(10364), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578009] = 5,
    ACTIONS(15043), 1,
      anon_sym_RBRACE,
    ACTIONS(22988), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578028] = 4,
    ACTIONS(22074), 1,
      anon_sym_LPAREN,
    STATE(21116), 1,
      sym_export_names,
    ACTIONS(22990), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578045] = 5,
    ACTIONS(5345), 1,
      anon_sym_RBRACE,
    ACTIONS(22992), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578064] = 5,
    ACTIONS(8802), 1,
      sym__conid,
    STATE(7547), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578083] = 5,
    ACTIONS(163), 1,
      anon_sym_RBRACE,
    ACTIONS(22994), 1,
      anon_sym_SEMI,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16441), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578102] = 5,
    ACTIONS(5041), 1,
      anon_sym_RBRACE,
    ACTIONS(22996), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578121] = 5,
    ACTIONS(12130), 1,
      anon_sym_RBRACE,
    ACTIONS(22998), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578140] = 5,
    ACTIONS(163), 1,
      anon_sym_RBRACE,
    ACTIONS(22994), 1,
      anon_sym_SEMI,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16435), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578159] = 5,
    ACTIONS(8315), 1,
      sym__conid,
    STATE(7244), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578178] = 5,
    ACTIONS(15311), 1,
      sym__conid,
    STATE(14324), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578197] = 5,
    ACTIONS(1313), 1,
      anon_sym_RBRACE,
    ACTIONS(23000), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578216] = 4,
    ACTIONS(163), 1,
      sym__layout_end,
    STATE(17419), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(22960), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578233] = 5,
    ACTIONS(17801), 1,
      anon_sym_RBRACE,
    ACTIONS(23002), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578252] = 5,
    ACTIONS(15045), 1,
      anon_sym_RBRACE,
    ACTIONS(23004), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578271] = 5,
    ACTIONS(21171), 1,
      anon_sym_RBRACE,
    ACTIONS(23006), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578290] = 5,
    ACTIONS(4553), 1,
      sym__conid,
    STATE(11784), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578309] = 5,
    ACTIONS(13436), 1,
      sym__conid,
    STATE(8725), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578328] = 5,
    ACTIONS(15045), 1,
      anon_sym_RBRACE,
    ACTIONS(23004), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16488), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578347] = 4,
    ACTIONS(15045), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23008), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578364] = 5,
    ACTIONS(12175), 1,
      anon_sym_RBRACE,
    ACTIONS(23010), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578383] = 5,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14865), 1,
      sym__modid,
    STATE(14901), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578402] = 5,
    ACTIONS(13038), 1,
      sym__conid,
    STATE(8839), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578421] = 5,
    ACTIONS(12175), 1,
      anon_sym_RBRACE,
    ACTIONS(23010), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16494), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578440] = 5,
    ACTIONS(15329), 1,
      sym__conid,
    STATE(13907), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578459] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22034), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [578472] = 5,
    ACTIONS(23012), 1,
      anon_sym_SEMI,
    ACTIONS(23014), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16471), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578491] = 4,
    ACTIONS(12175), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23016), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578508] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22032), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [578521] = 4,
    ACTIONS(22882), 1,
      anon_sym_LPAREN,
    STATE(21162), 1,
      sym_import_con_names,
    ACTIONS(23018), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578538] = 4,
    ACTIONS(23023), 1,
      sym__layout_end,
    STATE(16517), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(23020), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578555] = 5,
    ACTIONS(23025), 1,
      anon_sym_SEMI,
    ACTIONS(23027), 1,
      sym__layout_semicolon,
    ACTIONS(23029), 1,
      sym__layout_end,
    STATE(16477), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578574] = 5,
    ACTIONS(1309), 1,
      anon_sym_RBRACE,
    ACTIONS(23031), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578593] = 5,
    ACTIONS(17799), 1,
      anon_sym_RBRACE,
    ACTIONS(23033), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578612] = 5,
    ACTIONS(1309), 1,
      anon_sym_RBRACE,
    ACTIONS(23031), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16498), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578631] = 4,
    ACTIONS(1309), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23035), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578648] = 5,
    ACTIONS(23037), 1,
      anon_sym_SEMI,
    ACTIONS(23039), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578667] = 5,
    ACTIONS(8335), 1,
      sym__conid,
    STATE(6928), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578686] = 5,
    ACTIONS(14138), 1,
      anon_sym_RBRACE,
    ACTIONS(23041), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16501), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578705] = 5,
    ACTIONS(23043), 1,
      anon_sym_SEMI,
    ACTIONS(23045), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16478), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578724] = 4,
    ACTIONS(23047), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23049), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578741] = 5,
    ACTIONS(21175), 1,
      anon_sym_RBRACE,
    ACTIONS(23051), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578760] = 4,
    ACTIONS(23053), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23055), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578777] = 4,
    ACTIONS(14138), 1,
      sym__layout_end,
    STATE(16506), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23057), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578794] = 5,
    ACTIONS(11385), 1,
      anon_sym_RBRACE,
    ACTIONS(23059), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16507), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578813] = 4,
    ACTIONS(11385), 1,
      sym__layout_end,
    STATE(16514), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23061), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578830] = 5,
    ACTIONS(23063), 1,
      anon_sym_SEMI,
    ACTIONS(23066), 1,
      anon_sym_RBRACE,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578849] = 4,
    STATE(2492), 1,
      sym__colon2,
    STATE(17813), 1,
      sym__type_annotation,
    ACTIONS(21544), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578866] = 5,
    ACTIONS(907), 1,
      anon_sym_RBRACE,
    ACTIONS(23068), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16519), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578885] = 4,
    ACTIONS(23070), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23072), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578902] = 4,
    ACTIONS(907), 1,
      sym__layout_end,
    STATE(16522), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23074), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578919] = 5,
    ACTIONS(4649), 1,
      sym__conid,
    STATE(11474), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578938] = 5,
    ACTIONS(6248), 1,
      sym__conid,
    STATE(7752), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578957] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23076), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [578970] = 4,
    STATE(2455), 1,
      sym__colon2,
    STATE(14885), 1,
      sym__type_annotation,
    ACTIONS(17879), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578987] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(23078), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579002] = 5,
    ACTIONS(14561), 1,
      anon_sym_RBRACE,
    ACTIONS(23080), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579021] = 4,
    ACTIONS(23082), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23084), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579038] = 5,
    ACTIONS(12308), 1,
      anon_sym_RBRACE,
    ACTIONS(23086), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579057] = 5,
    ACTIONS(1321), 1,
      anon_sym_RBRACE,
    ACTIONS(23088), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579076] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17867), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [579089] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22168), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [579102] = 4,
    STATE(2468), 1,
      sym__colon2,
    STATE(12893), 1,
      sym__type_annotation,
    ACTIONS(17909), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579119] = 5,
    ACTIONS(17801), 1,
      anon_sym_RBRACE,
    ACTIONS(23002), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16361), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579138] = 5,
    ACTIONS(14555), 1,
      anon_sym_RBRACE,
    ACTIONS(23090), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579157] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23092), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [579170] = 5,
    ACTIONS(14555), 1,
      anon_sym_RBRACE,
    ACTIONS(23090), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16543), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579189] = 4,
    ACTIONS(995), 1,
      sym__layout_end,
    STATE(16577), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23094), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579206] = 4,
    ACTIONS(14555), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23096), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579223] = 5,
    ACTIONS(995), 1,
      anon_sym_RBRACE,
    ACTIONS(23098), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16581), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579242] = 5,
    ACTIONS(12306), 1,
      anon_sym_RBRACE,
    ACTIONS(23100), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579261] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23102), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [579274] = 4,
    ACTIONS(12306), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23104), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579291] = 4,
    ACTIONS(23109), 1,
      sym__layout_end,
    STATE(16560), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(23106), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579308] = 5,
    ACTIONS(15333), 1,
      sym__conid,
    STATE(14353), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579327] = 5,
    ACTIONS(4955), 1,
      anon_sym_RBRACE,
    ACTIONS(23111), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16588), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579346] = 5,
    ACTIONS(5247), 1,
      anon_sym_RBRACE,
    ACTIONS(23113), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579365] = 5,
    ACTIONS(12306), 1,
      anon_sym_RBRACE,
    ACTIONS(23100), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16545), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579384] = 5,
    ACTIONS(10864), 1,
      sym__conid,
    STATE(8721), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579403] = 4,
    ACTIONS(23115), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23117), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579420] = 5,
    ACTIONS(23119), 1,
      anon_sym_SEMI,
    ACTIONS(23122), 1,
      anon_sym_RBRACE,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579439] = 5,
    ACTIONS(1311), 1,
      anon_sym_RBRACE,
    ACTIONS(23124), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579458] = 4,
    ACTIONS(11687), 1,
      sym__layout_end,
    STATE(16589), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23126), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579475] = 5,
    ACTIONS(5956), 1,
      anon_sym_RBRACE,
    ACTIONS(23128), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579494] = 5,
    ACTIONS(11687), 1,
      anon_sym_RBRACE,
    ACTIONS(23130), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16593), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579513] = 4,
    ACTIONS(14446), 1,
      sym__layout_end,
    STATE(16595), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23132), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579530] = 4,
    ACTIONS(745), 1,
      sym__layout_end,
    STATE(16659), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23134), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579547] = 5,
    ACTIONS(14446), 1,
      anon_sym_RBRACE,
    ACTIONS(23136), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16599), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579566] = 5,
    ACTIONS(1311), 1,
      anon_sym_RBRACE,
    ACTIONS(23124), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16546), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579585] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23138), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [579598] = 4,
    ACTIONS(1363), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23140), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579615] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [579628] = 5,
    ACTIONS(1363), 1,
      anon_sym_RBRACE,
    ACTIONS(23142), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16604), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579647] = 5,
    ACTIONS(5411), 1,
      anon_sym_RBRACE,
    ACTIONS(23144), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579666] = 5,
    ACTIONS(1363), 1,
      anon_sym_RBRACE,
    ACTIONS(23142), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579685] = 4,
    ACTIONS(1311), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23146), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579702] = 5,
    ACTIONS(1289), 1,
      anon_sym_RBRACE,
    ACTIONS(23148), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579721] = 5,
    ACTIONS(5411), 1,
      anon_sym_RBRACE,
    ACTIONS(23144), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16490), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579740] = 4,
    ACTIONS(5411), 1,
      sym__layout_end,
    STATE(16349), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(23150), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579757] = 5,
    ACTIONS(23152), 1,
      anon_sym_SEMI,
    ACTIONS(23155), 1,
      anon_sym_RBRACE,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579776] = 5,
    ACTIONS(13888), 1,
      anon_sym_RBRACE,
    ACTIONS(23157), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16551), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579795] = 5,
    ACTIONS(5077), 1,
      anon_sym_RBRACE,
    ACTIONS(23159), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579814] = 4,
    ACTIONS(11709), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23161), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579831] = 5,
    ACTIONS(9862), 1,
      sym__conid,
    STATE(11543), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579850] = 5,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    ACTIONS(23163), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16609), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579869] = 5,
    ACTIONS(5077), 1,
      anon_sym_RBRACE,
    ACTIONS(23159), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16493), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579888] = 5,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    ACTIONS(23163), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579907] = 4,
    ACTIONS(13888), 1,
      sym__layout_end,
    STATE(16555), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23165), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579924] = 4,
    ACTIONS(14713), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23167), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579941] = 4,
    ACTIONS(5077), 1,
      sym__layout_end,
    STATE(16560), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(23169), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579958] = 5,
    ACTIONS(14713), 1,
      anon_sym_RBRACE,
    ACTIONS(23171), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16612), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579977] = 5,
    ACTIONS(11137), 1,
      anon_sym_RBRACE,
    ACTIONS(23173), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16557), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [579996] = 5,
    ACTIONS(14713), 1,
      anon_sym_RBRACE,
    ACTIONS(23171), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580015] = 5,
    ACTIONS(15051), 1,
      anon_sym_RBRACE,
    ACTIONS(23175), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580034] = 5,
    ACTIONS(745), 1,
      anon_sym_RBRACE,
    ACTIONS(23177), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16668), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580053] = 5,
    ACTIONS(12288), 1,
      anon_sym_RBRACE,
    ACTIONS(23179), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580072] = 4,
    ACTIONS(23181), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23183), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580089] = 5,
    ACTIONS(1359), 1,
      anon_sym_RBRACE,
    ACTIONS(23185), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580108] = 4,
    ACTIONS(11137), 1,
      sym__layout_end,
    STATE(16559), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23187), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580125] = 5,
    ACTIONS(1287), 1,
      anon_sym_RBRACE,
    ACTIONS(23189), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580144] = 5,
    ACTIONS(14851), 1,
      anon_sym_RBRACE,
    ACTIONS(23191), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580163] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21610), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [580176] = 5,
    ACTIONS(11715), 1,
      anon_sym_RBRACE,
    ACTIONS(23193), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580195] = 5,
    ACTIONS(21193), 1,
      anon_sym_RBRACE,
    ACTIONS(23195), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580214] = 4,
    ACTIONS(23200), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23197), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580231] = 5,
    ACTIONS(14715), 1,
      anon_sym_RBRACE,
    ACTIONS(23202), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580250] = 5,
    ACTIONS(21193), 1,
      anon_sym_RBRACE,
    ACTIONS(23195), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16502), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580269] = 5,
    ACTIONS(4537), 1,
      sym__conid,
    STATE(4672), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580288] = 5,
    ACTIONS(931), 1,
      anon_sym_RBRACE,
    ACTIONS(23204), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16568), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580307] = 4,
    ACTIONS(21193), 1,
      sym__layout_end,
    STATE(16517), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(23206), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580324] = 4,
    ACTIONS(23208), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23210), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580341] = 4,
    ACTIONS(931), 1,
      sym__layout_end,
    STATE(16582), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23212), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580358] = 5,
    ACTIONS(17791), 1,
      anon_sym_RBRACE,
    ACTIONS(23214), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580377] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [580390] = 5,
    ACTIONS(17791), 1,
      anon_sym_RBRACE,
    ACTIONS(23214), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16520), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580409] = 5,
    ACTIONS(23216), 1,
      anon_sym_SEMI,
    ACTIONS(23219), 1,
      anon_sym_RBRACE,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580428] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23221), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [580441] = 4,
    ACTIONS(10984), 1,
      sym__layout_end,
    STATE(16675), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23223), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580458] = 4,
    ACTIONS(23225), 1,
      anon_sym_LBRACE,
    ACTIONS(23227), 1,
      sym__layout_start,
    ACTIONS(22102), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580475] = 5,
    ACTIONS(15047), 1,
      anon_sym_RBRACE,
    ACTIONS(23229), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580494] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [580507] = 4,
    ACTIONS(23231), 1,
      anon_sym_PIPE,
    STATE(21170), 1,
      sym_tyfam_injectivity,
    ACTIONS(21391), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580524] = 5,
    ACTIONS(12292), 1,
      anon_sym_RBRACE,
    ACTIONS(23233), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580543] = 5,
    ACTIONS(15047), 1,
      anon_sym_RBRACE,
    ACTIONS(23229), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16600), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580562] = 5,
    ACTIONS(10984), 1,
      anon_sym_RBRACE,
    ACTIONS(23235), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16683), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580581] = 4,
    ACTIONS(15047), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23237), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580598] = 5,
    ACTIONS(14739), 1,
      anon_sym_RBRACE,
    ACTIONS(23239), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580617] = 5,
    ACTIONS(12005), 1,
      anon_sym_RBRACE,
    ACTIONS(23241), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580636] = 5,
    ACTIONS(5437), 1,
      anon_sym_RBRACE,
    ACTIONS(23243), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580655] = 5,
    ACTIONS(12302), 1,
      anon_sym_RBRACE,
    ACTIONS(23245), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580674] = 5,
    ACTIONS(13173), 1,
      sym__conid,
    STATE(8777), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580693] = 5,
    ACTIONS(23247), 1,
      anon_sym_SEMI,
    ACTIONS(23249), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16523), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580712] = 5,
    ACTIONS(23251), 1,
      anon_sym_SEMI,
    ACTIONS(23253), 1,
      sym__layout_semicolon,
    ACTIONS(23255), 1,
      sym__layout_end,
    STATE(16480), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580731] = 4,
    ACTIONS(23257), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23259), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580748] = 5,
    ACTIONS(12302), 1,
      anon_sym_RBRACE,
    ACTIONS(23245), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16602), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580767] = 4,
    ACTIONS(12302), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23261), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580784] = 5,
    ACTIONS(6048), 1,
      anon_sym_RBRACE,
    ACTIONS(23263), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580803] = 4,
    ACTIONS(13799), 1,
      sym__layout_end,
    STATE(16685), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23265), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580820] = 5,
    ACTIONS(11000), 1,
      sym__conid,
    STATE(8236), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580839] = 5,
    ACTIONS(8247), 1,
      sym__conid,
    STATE(6388), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580858] = 5,
    ACTIONS(1283), 1,
      anon_sym_RBRACE,
    ACTIONS(23267), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580877] = 5,
    ACTIONS(13799), 1,
      anon_sym_RBRACE,
    ACTIONS(23269), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16692), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580896] = 5,
    ACTIONS(1283), 1,
      anon_sym_RBRACE,
    ACTIONS(23267), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16606), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580915] = 5,
    ACTIONS(6048), 1,
      anon_sym_RBRACE,
    ACTIONS(23263), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16570), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580934] = 4,
    STATE(2459), 1,
      sym__colon2,
    STATE(12882), 1,
      sym__type_annotation,
    ACTIONS(17903), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580951] = 4,
    ACTIONS(1283), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23271), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [580968] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23273), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [580981] = 5,
    ACTIONS(14102), 1,
      anon_sym_RBRACE,
    ACTIONS(23275), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16626), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581000] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [581013] = 4,
    ACTIONS(23280), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23277), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581030] = 4,
    ACTIONS(6048), 1,
      sym__layout_end,
    STATE(16412), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(23282), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581047] = 4,
    ACTIONS(23284), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23286), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581064] = 4,
    ACTIONS(1291), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23288), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581081] = 4,
    ACTIONS(14102), 1,
      sym__layout_end,
    STATE(16632), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23290), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581098] = 5,
    ACTIONS(5399), 1,
      anon_sym_RBRACE,
    ACTIONS(23292), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16580), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581117] = 5,
    ACTIONS(11427), 1,
      anon_sym_RBRACE,
    ACTIONS(23294), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16636), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581136] = 4,
    ACTIONS(21598), 1,
      anon_sym_in,
    STATE(17629), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(23296), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581153] = 4,
    ACTIONS(11427), 1,
      sym__layout_end,
    STATE(16642), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23298), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581170] = 5,
    ACTIONS(895), 1,
      anon_sym_RBRACE,
    ACTIONS(23300), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16647), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581189] = 4,
    ACTIONS(895), 1,
      sym__layout_end,
    STATE(16652), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23302), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581206] = 5,
    ACTIONS(1291), 1,
      anon_sym_RBRACE,
    ACTIONS(23304), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16696), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581225] = 5,
    ACTIONS(1291), 1,
      anon_sym_RBRACE,
    ACTIONS(23304), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581244] = 4,
    ACTIONS(5399), 1,
      sym__layout_end,
    STATE(16585), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(23306), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581261] = 4,
    ACTIONS(23311), 1,
      sym__layout_end,
    STATE(16670), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(23308), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581278] = 5,
    ACTIONS(1319), 1,
      anon_sym_RBRACE,
    ACTIONS(23313), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581297] = 5,
    ACTIONS(4851), 1,
      sym__conid,
    STATE(4146), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581316] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18620), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [581329] = 5,
    ACTIONS(5365), 1,
      anon_sym_RBRACE,
    ACTIONS(23315), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17684), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581348] = 4,
    ACTIONS(12108), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23317), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581365] = 5,
    ACTIONS(12108), 1,
      anon_sym_RBRACE,
    ACTIONS(23319), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16711), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581384] = 4,
    STATE(2484), 1,
      sym__colon2,
    STATE(15449), 1,
      sym__type_annotation,
    ACTIONS(17883), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581401] = 5,
    ACTIONS(23321), 1,
      anon_sym_SEMI,
    ACTIONS(23323), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581420] = 5,
    ACTIONS(23325), 1,
      anon_sym_SEMI,
    ACTIONS(23327), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16341), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581439] = 4,
    STATE(2435), 1,
      sym__colon2,
    STATE(10706), 1,
      sym__type_annotation,
    ACTIONS(17405), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581456] = 5,
    ACTIONS(8828), 1,
      sym__conid,
    STATE(6302), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581475] = 5,
    ACTIONS(23329), 1,
      anon_sym_SEMI,
    ACTIONS(23332), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581494] = 5,
    ACTIONS(12108), 1,
      anon_sym_RBRACE,
    ACTIONS(23319), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581513] = 5,
    ACTIONS(23334), 1,
      anon_sym_SEMI,
    ACTIONS(23336), 1,
      sym__layout_semicolon,
    ACTIONS(23338), 1,
      sym__layout_end,
    STATE(16333), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581532] = 4,
    ACTIONS(14482), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23340), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581549] = 5,
    ACTIONS(5435), 1,
      anon_sym_RBRACE,
    ACTIONS(23342), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581568] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(16352), 1,
      sym_fundep,
    STATE(15006), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581585] = 5,
    ACTIONS(14482), 1,
      anon_sym_RBRACE,
    ACTIONS(23344), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16729), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581604] = 5,
    ACTIONS(14747), 1,
      anon_sym_RBRACE,
    ACTIONS(23346), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581623] = 5,
    ACTIONS(4497), 1,
      sym__conid,
    STATE(4676), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581642] = 4,
    ACTIONS(4955), 1,
      sym__layout_end,
    STATE(16596), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(23348), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581659] = 5,
    ACTIONS(14482), 1,
      anon_sym_RBRACE,
    ACTIONS(23344), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581678] = 5,
    ACTIONS(7803), 1,
      sym__conid,
    STATE(7787), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581697] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [581710] = 5,
    ACTIONS(23350), 1,
      anon_sym_SEMI,
    ACTIONS(23352), 1,
      sym__layout_semicolon,
    ACTIONS(23354), 1,
      sym__layout_end,
    STATE(16922), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581729] = 5,
    ACTIONS(1279), 1,
      anon_sym_RBRACE,
    ACTIONS(23356), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581748] = 5,
    ACTIONS(8351), 1,
      sym__conid,
    STATE(6274), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581767] = 4,
    ACTIONS(5377), 1,
      sym__layout_end,
    STATE(16732), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(23358), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [581797] = 4,
    ACTIONS(955), 1,
      sym__layout_end,
    STATE(16722), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23360), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581814] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16449), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581831] = 5,
    ACTIONS(955), 1,
      anon_sym_RBRACE,
    ACTIONS(23362), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16726), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581850] = 5,
    ACTIONS(15321), 1,
      sym__conid,
    STATE(14301), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581869] = 5,
    ACTIONS(5377), 1,
      anon_sym_RBRACE,
    ACTIONS(23364), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16686), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581888] = 5,
    ACTIONS(23366), 1,
      anon_sym_SEMI,
    ACTIONS(23368), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16928), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581907] = 5,
    ACTIONS(9930), 1,
      sym__conid,
    STATE(11776), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581926] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18598), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [581939] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(23370), 1,
      anon_sym_RBRACE,
    STATE(15721), 1,
      sym_variable,
    STATE(18106), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581958] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [581971] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16457), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21757), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [581988] = 5,
    ACTIONS(12118), 1,
      anon_sym_RBRACE,
    ACTIONS(23372), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582007] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [582020] = 5,
    ACTIONS(20777), 1,
      anon_sym_RBRACE,
    ACTIONS(23374), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16610), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582039] = 5,
    ACTIONS(14879), 1,
      anon_sym_RBRACE,
    ACTIONS(23376), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582058] = 4,
    ACTIONS(11518), 1,
      sym__layout_end,
    STATE(16734), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23378), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582075] = 4,
    ACTIONS(20777), 1,
      sym__layout_end,
    STATE(16616), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(23380), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582092] = 5,
    ACTIONS(11518), 1,
      anon_sym_RBRACE,
    ACTIONS(23382), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16738), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582111] = 4,
    ACTIONS(14396), 1,
      sym__layout_end,
    STATE(16740), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23384), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582128] = 4,
    ACTIONS(21038), 1,
      sym_where,
    STATE(21101), 1,
      sym_class_body,
    ACTIONS(21873), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582145] = 5,
    ACTIONS(14396), 1,
      anon_sym_RBRACE,
    ACTIONS(23386), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16744), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582164] = 4,
    ACTIONS(23388), 1,
      anon_sym_LBRACE,
    ACTIONS(23390), 1,
      sym__layout_start,
    ACTIONS(21885), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582181] = 4,
    ACTIONS(1337), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23392), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582198] = 5,
    ACTIONS(23394), 1,
      anon_sym_SEMI,
    ACTIONS(23396), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582217] = 5,
    ACTIONS(1337), 1,
      anon_sym_RBRACE,
    ACTIONS(23398), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16747), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582236] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [582249] = 5,
    ACTIONS(1337), 1,
      anon_sym_RBRACE,
    ACTIONS(23398), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582268] = 5,
    ACTIONS(12381), 1,
      anon_sym_RBRACE,
    ACTIONS(23400), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582287] = 4,
    ACTIONS(23402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23404), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582304] = 5,
    ACTIONS(14464), 1,
      anon_sym_RBRACE,
    ACTIONS(23406), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582323] = 5,
    ACTIONS(1267), 1,
      anon_sym_RBRACE,
    ACTIONS(23408), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23410), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [582355] = 4,
    ACTIONS(5435), 1,
      sym__layout_end,
    STATE(16349), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(23412), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582372] = 5,
    ACTIONS(14877), 1,
      anon_sym_RBRACE,
    ACTIONS(23414), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582391] = 4,
    ACTIONS(11905), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23416), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582408] = 5,
    ACTIONS(5435), 1,
      anon_sym_RBRACE,
    ACTIONS(23342), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16750), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582427] = 5,
    ACTIONS(11905), 1,
      anon_sym_RBRACE,
    ACTIONS(23418), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16752), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582446] = 3,
    ACTIONS(20374), 1,
      sym__conid,
    ACTIONS(20372), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582461] = 5,
    ACTIONS(11905), 1,
      anon_sym_RBRACE,
    ACTIONS(23418), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582480] = 5,
    ACTIONS(5335), 1,
      anon_sym_RBRACE,
    ACTIONS(23420), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16619), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582499] = 4,
    ACTIONS(14727), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23422), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582516] = 5,
    ACTIONS(14877), 1,
      anon_sym_RBRACE,
    ACTIONS(23414), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16714), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582535] = 5,
    ACTIONS(14727), 1,
      anon_sym_RBRACE,
    ACTIONS(23424), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16755), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582554] = 5,
    ACTIONS(773), 1,
      anon_sym_RBRACE,
    ACTIONS(23426), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16791), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582573] = 5,
    ACTIONS(14727), 1,
      anon_sym_RBRACE,
    ACTIONS(23424), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [582605] = 4,
    ACTIONS(23428), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23430), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582622] = 5,
    ACTIONS(1331), 1,
      anon_sym_RBRACE,
    ACTIONS(23432), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582641] = 4,
    ACTIONS(14877), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23434), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582658] = 5,
    ACTIONS(12383), 1,
      anon_sym_RBRACE,
    ACTIONS(23436), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582677] = 5,
    ACTIONS(5445), 1,
      anon_sym_RBRACE,
    ACTIONS(23438), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582696] = 5,
    ACTIONS(8470), 1,
      sym__conid,
    STATE(7586), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582715] = 5,
    ACTIONS(11909), 1,
      anon_sym_RBRACE,
    ACTIONS(23440), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582734] = 4,
    ACTIONS(1305), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23442), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582751] = 5,
    ACTIONS(14747), 1,
      anon_sym_RBRACE,
    ACTIONS(23346), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16633), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582770] = 5,
    ACTIONS(14733), 1,
      anon_sym_RBRACE,
    ACTIONS(23444), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582789] = 4,
    ACTIONS(14747), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23446), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582806] = 5,
    ACTIONS(14476), 1,
      anon_sym_RBRACE,
    ACTIONS(23448), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582825] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [582838] = 5,
    ACTIONS(12278), 1,
      anon_sym_RBRACE,
    ACTIONS(23450), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582857] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [582870] = 5,
    ACTIONS(12383), 1,
      anon_sym_RBRACE,
    ACTIONS(23436), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16727), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582889] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23452), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [582902] = 5,
    ACTIONS(12122), 1,
      anon_sym_RBRACE,
    ACTIONS(23454), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582921] = 4,
    ACTIONS(12383), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23456), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582938] = 5,
    ACTIONS(12122), 1,
      anon_sym_RBRACE,
    ACTIONS(23454), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16634), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582957] = 4,
    ACTIONS(12122), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23458), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582974] = 5,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(23460), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [582993] = 5,
    ACTIONS(5930), 1,
      anon_sym_RBRACE,
    ACTIONS(23462), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583012] = 4,
    ACTIONS(23464), 1,
      anon_sym_LBRACE,
    ACTIONS(23466), 1,
      sym__layout_start,
    ACTIONS(21928), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583029] = 5,
    ACTIONS(1275), 1,
      anon_sym_RBRACE,
    ACTIONS(23468), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583048] = 5,
    ACTIONS(14470), 1,
      anon_sym_RBRACE,
    ACTIONS(23470), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583067] = 5,
    ACTIONS(14470), 1,
      anon_sym_RBRACE,
    ACTIONS(23470), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16757), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583086] = 5,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(23460), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16730), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583105] = 4,
    ACTIONS(1263), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23472), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583122] = 5,
    ACTIONS(5930), 1,
      anon_sym_RBRACE,
    ACTIONS(23462), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16325), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583141] = 5,
    ACTIONS(13988), 1,
      anon_sym_RBRACE,
    ACTIONS(23474), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16733), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583160] = 4,
    ACTIONS(14470), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23476), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583177] = 5,
    ACTIONS(12945), 1,
      sym__conid,
    STATE(8633), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583196] = 5,
    ACTIONS(12300), 1,
      anon_sym_RBRACE,
    ACTIONS(23478), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583215] = 5,
    ACTIONS(12300), 1,
      anon_sym_RBRACE,
    ACTIONS(23478), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16759), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583234] = 4,
    ACTIONS(13988), 1,
      sym__layout_end,
    STATE(16748), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23480), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583251] = 5,
    ACTIONS(11169), 1,
      anon_sym_RBRACE,
    ACTIONS(23482), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16749), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583270] = 4,
    ACTIONS(11169), 1,
      sym__layout_end,
    STATE(16764), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23484), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583287] = 5,
    ACTIONS(887), 1,
      anon_sym_RBRACE,
    ACTIONS(23486), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16767), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583306] = 5,
    ACTIONS(5642), 1,
      anon_sym_RBRACE,
    ACTIONS(23488), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16643), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583325] = 5,
    ACTIONS(15303), 1,
      sym__conid,
    STATE(13750), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583344] = 4,
    ACTIONS(12300), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23490), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583361] = 4,
    ACTIONS(887), 1,
      sym__layout_end,
    STATE(16774), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23492), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583378] = 5,
    ACTIONS(4487), 1,
      sym__conid,
    STATE(4790), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583397] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21610), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [583410] = 5,
    ACTIONS(1273), 1,
      anon_sym_RBRACE,
    ACTIONS(23494), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583429] = 5,
    ACTIONS(1273), 1,
      anon_sym_RBRACE,
    ACTIONS(23494), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16770), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583448] = 4,
    ACTIONS(5930), 1,
      sym__layout_end,
    STATE(16412), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(23496), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583465] = 4,
    ACTIONS(1273), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23498), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583482] = 5,
    ACTIONS(227), 1,
      anon_sym_RBRACE,
    ACTIONS(23500), 1,
      anon_sym_SEMI,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16441), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583501] = 5,
    ACTIONS(15303), 1,
      sym__conid,
    STATE(13499), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583520] = 5,
    ACTIONS(13914), 1,
      anon_sym_RBRACE,
    ACTIONS(23502), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16771), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583539] = 4,
    ACTIONS(13914), 1,
      sym__layout_end,
    STATE(16777), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23504), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583556] = 4,
    STATE(2436), 1,
      sym__colon2,
    STATE(13350), 1,
      sym__type_annotation,
    ACTIONS(18263), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583573] = 4,
    ACTIONS(5642), 1,
      sym__layout_end,
    STATE(16657), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(23506), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583590] = 5,
    ACTIONS(10927), 1,
      anon_sym_RBRACE,
    ACTIONS(23508), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16779), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583609] = 4,
    ACTIONS(10927), 1,
      sym__layout_end,
    STATE(16787), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23510), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583626] = 4,
    ACTIONS(23512), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23514), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583643] = 4,
    ACTIONS(23518), 1,
      sym_comma,
    STATE(16804), 1,
      aux_sym_field_repeat1,
    ACTIONS(23516), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583660] = 5,
    ACTIONS(4483), 1,
      sym__conid,
    STATE(5516), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583679] = 5,
    ACTIONS(5373), 1,
      anon_sym_RBRACE,
    ACTIONS(23521), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16273), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583698] = 5,
    ACTIONS(4467), 1,
      sym__conid,
    STATE(10371), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583717] = 5,
    ACTIONS(13012), 1,
      sym__conid,
    STATE(8651), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583736] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23523), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [583749] = 5,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(23525), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583768] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23527), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [583781] = 4,
    ACTIONS(5373), 1,
      sym__layout_end,
    STATE(16257), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(23529), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583798] = 5,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(23525), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16671), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583817] = 5,
    ACTIONS(15299), 1,
      sym__conid,
    STATE(13366), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583836] = 5,
    ACTIONS(4577), 1,
      sym__conid,
    STATE(3734), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583855] = 4,
    ACTIONS(773), 1,
      sym__layout_end,
    STATE(16794), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23531), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583872] = 5,
    ACTIONS(8111), 1,
      sym__conid,
    STATE(4529), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583891] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21830), 1,
      anon_sym_LPAREN,
    STATE(15526), 1,
      sym_variable,
    STATE(21262), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583910] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21830), 1,
      anon_sym_LPAREN,
    STATE(15526), 1,
      sym_variable,
    STATE(21258), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583929] = 4,
    STATE(2445), 1,
      sym__colon2,
    STATE(13294), 1,
      sym__type_annotation,
    ACTIONS(17947), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583946] = 4,
    STATE(2483), 1,
      sym__colon2,
    STATE(14125), 1,
      sym__type_annotation,
    ACTIONS(18565), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583963] = 5,
    ACTIONS(8043), 1,
      sym__conid,
    STATE(6511), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583982] = 4,
    ACTIONS(23533), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23535), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [583999] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [584012] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23537), 4,
      sym_comma,
      sym__immediate_dot,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [584025] = 5,
    ACTIONS(13096), 1,
      sym__conid,
    STATE(8974), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584044] = 5,
    ACTIONS(23539), 1,
      anon_sym_SEMI,
    ACTIONS(23542), 1,
      anon_sym_RBRACE,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584063] = 5,
    ACTIONS(14795), 1,
      anon_sym_RBRACE,
    ACTIONS(23544), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584082] = 5,
    ACTIONS(1327), 1,
      anon_sym_RBRACE,
    ACTIONS(23546), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584101] = 5,
    ACTIONS(13064), 1,
      sym__conid,
    STATE(8770), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584120] = 4,
    ACTIONS(23551), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23548), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584137] = 4,
    ACTIONS(23553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23555), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584154] = 4,
    ACTIONS(911), 1,
      sym__layout_end,
    STATE(16915), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23557), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584171] = 5,
    ACTIONS(967), 1,
      anon_sym_RBRACE,
    ACTIONS(23559), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16253), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584190] = 5,
    ACTIONS(4423), 1,
      sym__conid,
    STATE(4592), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584209] = 3,
    ACTIONS(23561), 1,
      sym_where,
    ACTIONS(22230), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584224] = 4,
    STATE(2472), 1,
      sym__colon2,
    STATE(15095), 1,
      sym__type_annotation,
    ACTIONS(18265), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584241] = 4,
    ACTIONS(967), 1,
      sym__layout_end,
    STATE(16303), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23563), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584258] = 5,
    ACTIONS(12298), 1,
      anon_sym_RBRACE,
    ACTIONS(23565), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584277] = 5,
    ACTIONS(669), 1,
      sym__conid,
    STATE(4217), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584296] = 4,
    ACTIONS(915), 1,
      sym__layout_end,
    STATE(16863), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23567), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584313] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [584326] = 5,
    ACTIONS(915), 1,
      anon_sym_RBRACE,
    ACTIONS(23569), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16867), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584345] = 5,
    ACTIONS(1239), 1,
      anon_sym_RBRACE,
    ACTIONS(23571), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584364] = 5,
    ACTIONS(14120), 1,
      anon_sym_RBRACE,
    ACTIONS(23573), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16689), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584383] = 5,
    ACTIONS(14799), 1,
      anon_sym_RBRACE,
    ACTIONS(23575), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584402] = 4,
    ACTIONS(14120), 1,
      sym__layout_end,
    STATE(16756), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23577), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584419] = 5,
    ACTIONS(14799), 1,
      anon_sym_RBRACE,
    ACTIONS(23575), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16828), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584438] = 4,
    ACTIONS(14799), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23579), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584455] = 5,
    ACTIONS(12286), 1,
      anon_sym_RBRACE,
    ACTIONS(23581), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584474] = 5,
    ACTIONS(11295), 1,
      anon_sym_RBRACE,
    ACTIONS(23583), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16763), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584493] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23585), 4,
      sym_where,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [584506] = 4,
    ACTIONS(11295), 1,
      sym__layout_end,
    STATE(16766), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23587), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584523] = 5,
    ACTIONS(12286), 1,
      anon_sym_RBRACE,
    ACTIONS(23581), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16839), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584542] = 4,
    ACTIONS(12286), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23589), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584559] = 4,
    ACTIONS(11393), 1,
      sym__layout_end,
    STATE(16875), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23591), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584576] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [584589] = 5,
    ACTIONS(11393), 1,
      anon_sym_RBRACE,
    ACTIONS(23593), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16879), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584608] = 4,
    ACTIONS(14150), 1,
      sym__layout_end,
    STATE(16881), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23595), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584625] = 5,
    ACTIONS(8694), 1,
      sym__conid,
    STATE(7247), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584644] = 5,
    ACTIONS(14150), 1,
      anon_sym_RBRACE,
    ACTIONS(23597), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16885), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584663] = 4,
    ACTIONS(23599), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23601), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584680] = 4,
    ACTIONS(1315), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23603), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584697] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23452), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_deriving,
  [584710] = 5,
    ACTIONS(1315), 1,
      anon_sym_RBRACE,
    ACTIONS(23605), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16888), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584729] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23607), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [584742] = 5,
    ACTIONS(1315), 1,
      anon_sym_RBRACE,
    ACTIONS(23605), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584761] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23609), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [584774] = 5,
    ACTIONS(1235), 1,
      anon_sym_RBRACE,
    ACTIONS(23611), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584793] = 4,
    ACTIONS(923), 1,
      sym__layout_end,
    STATE(16909), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23613), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584810] = 5,
    ACTIONS(701), 1,
      anon_sym_RBRACE,
    ACTIONS(23615), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16810), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584829] = 4,
    ACTIONS(701), 1,
      sym__layout_end,
    STATE(16753), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23617), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584846] = 4,
    ACTIONS(23619), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23621), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584863] = 5,
    ACTIONS(14697), 1,
      anon_sym_RBRACE,
    ACTIONS(23623), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584882] = 4,
    ACTIONS(12211), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23625), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584899] = 5,
    ACTIONS(1235), 1,
      anon_sym_RBRACE,
    ACTIONS(23611), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16844), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584918] = 5,
    ACTIONS(12211), 1,
      anon_sym_RBRACE,
    ACTIONS(23627), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16893), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584937] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22056), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [584950] = 5,
    ACTIONS(12211), 1,
      anon_sym_RBRACE,
    ACTIONS(23627), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584969] = 4,
    ACTIONS(1235), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23629), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [584986] = 4,
    ACTIONS(14757), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23631), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585003] = 5,
    ACTIONS(13910), 1,
      anon_sym_RBRACE,
    ACTIONS(23633), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16846), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585022] = 5,
    ACTIONS(14757), 1,
      anon_sym_RBRACE,
    ACTIONS(23635), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16896), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585041] = 5,
    ACTIONS(11956), 1,
      anon_sym_RBRACE,
    ACTIONS(23637), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585060] = 5,
    ACTIONS(14757), 1,
      anon_sym_RBRACE,
    ACTIONS(23635), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585079] = 4,
    ACTIONS(23639), 1,
      anon_sym_LBRACE,
    ACTIONS(23641), 1,
      sym__layout_start,
    ACTIONS(22192), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585096] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(16063), 1,
      sym_fundep,
    STATE(15006), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585113] = 5,
    ACTIONS(1307), 1,
      anon_sym_RBRACE,
    ACTIONS(23643), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585132] = 4,
    ACTIONS(13910), 1,
      sym__layout_end,
    STATE(16849), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23645), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585149] = 5,
    ACTIONS(11145), 1,
      anon_sym_RBRACE,
    ACTIONS(23647), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16850), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585168] = 4,
    ACTIONS(11413), 1,
      sym__layout_end,
    STATE(16945), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23649), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585185] = 5,
    ACTIONS(8229), 1,
      sym__conid,
    STATE(7640), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585204] = 5,
    ACTIONS(12213), 1,
      anon_sym_RBRACE,
    ACTIONS(23651), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585223] = 5,
    ACTIONS(1255), 1,
      anon_sym_RBRACE,
    ACTIONS(23653), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585242] = 5,
    ACTIONS(11413), 1,
      anon_sym_RBRACE,
    ACTIONS(23655), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16949), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585261] = 5,
    ACTIONS(14759), 1,
      anon_sym_RBRACE,
    ACTIONS(23657), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585280] = 5,
    ACTIONS(14699), 1,
      anon_sym_RBRACE,
    ACTIONS(23659), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585299] = 4,
    ACTIONS(14388), 1,
      sym__layout_end,
    STATE(16956), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23661), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585316] = 4,
    ACTIONS(235), 1,
      ts_builtin_sym_end,
    STATE(17050), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(23663), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585333] = 5,
    ACTIONS(14699), 1,
      anon_sym_RBRACE,
    ACTIONS(23659), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16874), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585352] = 5,
    ACTIONS(14388), 1,
      anon_sym_RBRACE,
    ACTIONS(23665), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16958), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585371] = 4,
    ACTIONS(14699), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23667), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585388] = 4,
    ACTIONS(11145), 1,
      sym__layout_end,
    STATE(16855), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23669), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585405] = 5,
    ACTIONS(12096), 1,
      anon_sym_RBRACE,
    ACTIONS(23671), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585424] = 4,
    ACTIONS(23673), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23675), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585441] = 5,
    ACTIONS(12096), 1,
      anon_sym_RBRACE,
    ACTIONS(23671), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16884), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585460] = 5,
    ACTIONS(871), 1,
      anon_sym_RBRACE,
    ACTIONS(23677), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16869), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585479] = 4,
    ACTIONS(12096), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23679), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585496] = 4,
    ACTIONS(1245), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23681), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585513] = 5,
    ACTIONS(15429), 1,
      sym__conid,
    STATE(14037), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585532] = 4,
    ACTIONS(871), 1,
      sym__layout_end,
    STATE(16880), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23683), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585549] = 5,
    ACTIONS(1251), 1,
      anon_sym_RBRACE,
    ACTIONS(23685), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585568] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(15552), 1,
      sym_fundep,
    STATE(15553), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585585] = 5,
    ACTIONS(1251), 1,
      anon_sym_RBRACE,
    ACTIONS(23685), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16894), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585604] = 4,
    ACTIONS(1251), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23687), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585621] = 5,
    ACTIONS(1245), 1,
      anon_sym_RBRACE,
    ACTIONS(23689), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16971), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585640] = 4,
    ACTIONS(22643), 1,
      sym_comma,
    STATE(16701), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(21672), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585657] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18533), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [585670] = 5,
    ACTIONS(12980), 1,
      sym__conid,
    STATE(8716), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585689] = 5,
    ACTIONS(14315), 1,
      anon_sym_RBRACE,
    ACTIONS(23691), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16897), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585708] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22500), 1,
      sym_constructor,
    STATE(22502), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585727] = 4,
    ACTIONS(23696), 1,
      sym__layout_end,
    STATE(16922), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(23693), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585744] = 4,
    ACTIONS(14315), 1,
      sym__layout_end,
    STATE(16902), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23698), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585761] = 5,
    ACTIONS(11377), 1,
      anon_sym_RBRACE,
    ACTIONS(23700), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16904), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585780] = 4,
    ACTIONS(11377), 1,
      sym__layout_end,
    STATE(16908), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23702), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585797] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(16209), 1,
      sym_fundep,
    STATE(15553), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585814] = 5,
    ACTIONS(3579), 1,
      sym__conid,
    STATE(10684), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585833] = 5,
    ACTIONS(23704), 1,
      anon_sym_SEMI,
    ACTIONS(23706), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585852] = 4,
    STATE(2469), 1,
      sym__colon2,
    STATE(12912), 1,
      sym__type_annotation,
    ACTIONS(17907), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585869] = 5,
    ACTIONS(1245), 1,
      anon_sym_RBRACE,
    ACTIONS(23689), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585888] = 5,
    ACTIONS(5019), 1,
      anon_sym_RBRACE,
    ACTIONS(23708), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16306), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585907] = 4,
    ACTIONS(5019), 1,
      sym__layout_end,
    STATE(16315), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(23710), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585924] = 5,
    ACTIONS(23712), 1,
      anon_sym_SEMI,
    ACTIONS(23715), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585943] = 5,
    ACTIONS(13521), 1,
      sym__conid,
    STATE(8318), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585962] = 5,
    ACTIONS(3296), 1,
      sym__conid,
    STATE(4992), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [585981] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23717), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [585994] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21440), 1,
      anon_sym_LPAREN,
    STATE(15170), 1,
      sym_variable,
    STATE(19412), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586013] = 5,
    ACTIONS(911), 1,
      anon_sym_RBRACE,
    ACTIONS(23719), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16912), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586032] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [586045] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18533), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [586058] = 4,
    STATE(2463), 1,
      sym__colon2,
    STATE(18961), 1,
      sym__type_annotation,
    ACTIONS(17372), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586075] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21853), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [586088] = 5,
    ACTIONS(8211), 1,
      sym__conid,
    STATE(6660), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586107] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [586120] = 4,
    ACTIONS(11887), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23721), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586137] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3577), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [586150] = 5,
    ACTIONS(11887), 1,
      anon_sym_RBRACE,
    ACTIONS(23723), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16974), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586169] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23725), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [586182] = 5,
    ACTIONS(11887), 1,
      anon_sym_RBRACE,
    ACTIONS(23723), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586201] = 5,
    ACTIONS(14480), 1,
      anon_sym_RBRACE,
    ACTIONS(23727), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586220] = 5,
    ACTIONS(15317), 1,
      sym__conid,
    STATE(14280), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586239] = 4,
    STATE(2451), 1,
      sym__colon2,
    STATE(10820), 1,
      sym__type_annotation,
    ACTIONS(17499), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586256] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23729), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [586269] = 5,
    ACTIONS(12114), 1,
      anon_sym_RBRACE,
    ACTIONS(23731), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586288] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23733), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [586301] = 4,
    ACTIONS(14725), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23735), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586318] = 5,
    ACTIONS(14725), 1,
      anon_sym_RBRACE,
    ACTIONS(23737), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16983), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586337] = 5,
    ACTIONS(14725), 1,
      anon_sym_RBRACE,
    ACTIONS(23737), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586356] = 5,
    ACTIONS(1221), 1,
      anon_sym_RBRACE,
    ACTIONS(23739), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586375] = 4,
    STATE(2466), 1,
      sym__colon2,
    STATE(13322), 1,
      sym__type_annotation,
    ACTIONS(18287), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [586405] = 5,
    ACTIONS(14771), 1,
      anon_sym_RBRACE,
    ACTIONS(23741), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586424] = 4,
    ACTIONS(22074), 1,
      anon_sym_LPAREN,
    STATE(20927), 1,
      sym_export_names,
    ACTIONS(23743), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586441] = 5,
    ACTIONS(923), 1,
      anon_sym_RBRACE,
    ACTIONS(23745), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16930), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586460] = 5,
    ACTIONS(14771), 1,
      anon_sym_RBRACE,
    ACTIONS(23741), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16950), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586479] = 4,
    ACTIONS(14771), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23747), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586496] = 5,
    ACTIONS(12098), 1,
      anon_sym_RBRACE,
    ACTIONS(23749), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586515] = 4,
    ACTIONS(23751), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23753), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586532] = 5,
    ACTIONS(16854), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(18829), 1,
      sym__modid,
    STATE(19912), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586551] = 5,
    ACTIONS(13304), 1,
      sym__conid,
    STATE(8788), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586570] = 5,
    ACTIONS(1237), 1,
      anon_sym_RBRACE,
    ACTIONS(23755), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586589] = 5,
    ACTIONS(9212), 1,
      sym__conid,
    STATE(11182), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586608] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(23757), 1,
      anon_sym_RBRACE,
    STATE(15721), 1,
      sym_variable,
    STATE(19486), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586627] = 5,
    ACTIONS(11767), 1,
      anon_sym_RBRACE,
    ACTIONS(23759), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586646] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(21684), 1,
      sym_constructor,
    STATE(22502), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586665] = 5,
    ACTIONS(1965), 1,
      sym__conid,
    STATE(3729), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586684] = 5,
    ACTIONS(669), 1,
      sym__conid,
    STATE(9393), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586703] = 5,
    ACTIONS(12098), 1,
      anon_sym_RBRACE,
    ACTIONS(23749), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16954), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586722] = 4,
    ACTIONS(12098), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23761), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586739] = 4,
    ACTIONS(697), 1,
      sym__layout_end,
    STATE(17002), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23763), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586756] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23765), 4,
      sym_where,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [586769] = 5,
    ACTIONS(697), 1,
      anon_sym_RBRACE,
    ACTIONS(23767), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17006), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586788] = 5,
    ACTIONS(14737), 1,
      anon_sym_RBRACE,
    ACTIONS(23769), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586807] = 5,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    ACTIONS(23771), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586826] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22541), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
  [586839] = 5,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    ACTIONS(23771), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16959), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586858] = 4,
    ACTIONS(1219), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23773), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586875] = 5,
    ACTIONS(14028), 1,
      anon_sym_RBRACE,
    ACTIONS(23775), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16962), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586894] = 5,
    ACTIONS(15333), 1,
      sym__conid,
    STATE(13995), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586913] = 4,
    ACTIONS(14028), 1,
      sym__layout_end,
    STATE(16966), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23777), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586930] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22446), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [586943] = 5,
    ACTIONS(11105), 1,
      anon_sym_RBRACE,
    ACTIONS(23779), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16967), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586962] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23781), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [586975] = 4,
    ACTIONS(11105), 1,
      sym__layout_end,
    STATE(16979), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23783), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [586992] = 4,
    ACTIONS(10886), 1,
      sym__layout_end,
    STATE(17014), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23785), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587009] = 5,
    ACTIONS(9288), 1,
      sym__conid,
    STATE(10689), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587028] = 5,
    ACTIONS(10886), 1,
      anon_sym_RBRACE,
    ACTIONS(23787), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17018), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587047] = 4,
    ACTIONS(13747), 1,
      sym__layout_end,
    STATE(17020), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23789), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587064] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22310), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [587077] = 5,
    ACTIONS(13747), 1,
      anon_sym_RBRACE,
    ACTIONS(23791), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17024), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587096] = 5,
    ACTIONS(4491), 1,
      sym__conid,
    STATE(5478), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587115] = 4,
    ACTIONS(1285), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23793), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587132] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [587145] = 5,
    ACTIONS(1285), 1,
      anon_sym_RBRACE,
    ACTIONS(23795), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17027), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587164] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22036), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [587177] = 5,
    ACTIONS(1285), 1,
      anon_sym_RBRACE,
    ACTIONS(23795), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587196] = 5,
    ACTIONS(841), 1,
      anon_sym_RBRACE,
    ACTIONS(23797), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16984), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587215] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [587228] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [587241] = 5,
    ACTIONS(20928), 1,
      anon_sym_RBRACE,
    ACTIONS(23799), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16460), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587260] = 5,
    ACTIONS(11085), 1,
      sym__conid,
    STATE(8240), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587279] = 4,
    ACTIONS(841), 1,
      sym__layout_end,
    STATE(16987), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23801), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587296] = 5,
    ACTIONS(14801), 1,
      anon_sym_RBRACE,
    ACTIONS(23803), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587315] = 4,
    ACTIONS(12304), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23805), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587332] = 5,
    ACTIONS(11737), 1,
      anon_sym_RBRACE,
    ACTIONS(23807), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587351] = 5,
    ACTIONS(12304), 1,
      anon_sym_RBRACE,
    ACTIONS(23809), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17032), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587370] = 5,
    ACTIONS(1217), 1,
      anon_sym_RBRACE,
    ACTIONS(23811), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587389] = 5,
    ACTIONS(12304), 1,
      anon_sym_RBRACE,
    ACTIONS(23809), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587408] = 4,
    ACTIONS(20928), 1,
      sym__layout_end,
    STATE(16468), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(23813), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587425] = 4,
    ACTIONS(14765), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23815), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587442] = 5,
    ACTIONS(14769), 1,
      anon_sym_RBRACE,
    ACTIONS(23817), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587461] = 5,
    ACTIONS(14765), 1,
      anon_sym_RBRACE,
    ACTIONS(23819), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17035), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587480] = 5,
    ACTIONS(13205), 1,
      sym__conid,
    STATE(8311), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587499] = 5,
    ACTIONS(14765), 1,
      anon_sym_RBRACE,
    ACTIONS(23819), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587518] = 5,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14267), 1,
      sym_constructor,
    STATE(14275), 1,
      sym__modid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587537] = 5,
    ACTIONS(14769), 1,
      anon_sym_RBRACE,
    ACTIONS(23817), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17013), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587556] = 5,
    ACTIONS(1281), 1,
      anon_sym_RBRACE,
    ACTIONS(23821), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587575] = 5,
    ACTIONS(8121), 1,
      sym__conid,
    STATE(5717), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587594] = 4,
    ACTIONS(14769), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23823), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587611] = 5,
    ACTIONS(11891), 1,
      anon_sym_RBRACE,
    ACTIONS(23825), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587630] = 5,
    ACTIONS(11891), 1,
      anon_sym_RBRACE,
    ACTIONS(23825), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17015), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587649] = 5,
    ACTIONS(12310), 1,
      anon_sym_RBRACE,
    ACTIONS(23827), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587668] = 4,
    ACTIONS(11891), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23829), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587685] = 5,
    ACTIONS(5433), 1,
      anon_sym_RBRACE,
    ACTIONS(23831), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587704] = 5,
    ACTIONS(14767), 1,
      anon_sym_RBRACE,
    ACTIONS(23833), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587723] = 4,
    STATE(2224), 1,
      sym__colon2,
    STATE(19459), 1,
      sym__gadt_constr_type,
    ACTIONS(22966), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587740] = 5,
    ACTIONS(4779), 1,
      sym__conid,
    STATE(11240), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587759] = 5,
    ACTIONS(1209), 1,
      anon_sym_RBRACE,
    ACTIONS(23835), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587778] = 5,
    ACTIONS(1209), 1,
      anon_sym_RBRACE,
    ACTIONS(23835), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17017), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587797] = 4,
    ACTIONS(1209), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23837), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587814] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17575), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [587827] = 5,
    ACTIONS(13823), 1,
      anon_sym_RBRACE,
    ACTIONS(23839), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17021), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587846] = 4,
    ACTIONS(13823), 1,
      sym__layout_end,
    STATE(17029), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23841), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587863] = 5,
    ACTIONS(11117), 1,
      anon_sym_RBRACE,
    ACTIONS(23843), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17030), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587882] = 5,
    ACTIONS(23845), 1,
      anon_sym_SEMI,
    ACTIONS(23847), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587901] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15599), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [587914] = 4,
    ACTIONS(11117), 1,
      sym__layout_end,
    STATE(17033), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23849), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587931] = 5,
    ACTIONS(4603), 1,
      sym__conid,
    STATE(4979), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587950] = 4,
    ACTIONS(23851), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23853), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587967] = 4,
    ACTIONS(23855), 1,
      ts_builtin_sym_end,
    STATE(17050), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(23857), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [587984] = 5,
    ACTIONS(4427), 1,
      sym__conid,
    STATE(4695), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588003] = 5,
    ACTIONS(9526), 1,
      sym__conid,
    STATE(11922), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588022] = 3,
    ACTIONS(23862), 1,
      sym_where,
    ACTIONS(23860), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588037] = 5,
    ACTIONS(963), 1,
      anon_sym_RBRACE,
    ACTIONS(23864), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17038), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588056] = 4,
    ACTIONS(963), 1,
      sym__layout_end,
    STATE(17040), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23866), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588073] = 5,
    ACTIONS(23868), 1,
      anon_sym_SEMI,
    ACTIONS(23870), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16933), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588092] = 4,
    STATE(2497), 1,
      sym__colon2,
    STATE(13494), 1,
      sym__type_annotation,
    ACTIONS(18267), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588109] = 5,
    ACTIONS(15293), 1,
      sym__conid,
    STATE(14287), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588128] = 5,
    ACTIONS(23872), 1,
      anon_sym_SEMI,
    ACTIONS(23874), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17045), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588147] = 4,
    ACTIONS(23876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23878), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588164] = 4,
    ACTIONS(23880), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23882), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588181] = 5,
    ACTIONS(23884), 1,
      anon_sym_SEMI,
    ACTIONS(23886), 1,
      sym__layout_semicolon,
    ACTIONS(23888), 1,
      sym__layout_end,
    STATE(16922), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588200] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 4,
      sym_comma,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
  [588213] = 5,
    ACTIONS(8562), 1,
      sym__conid,
    STATE(7763), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588232] = 4,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(21572), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588249] = 5,
    ACTIONS(13205), 1,
      sym__conid,
    STATE(8485), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588268] = 4,
    STATE(2467), 1,
      sym__colon2,
    STATE(12129), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588285] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [588298] = 4,
    STATE(2485), 1,
      sym__colon2,
    STATE(17802), 1,
      sym__type_annotation,
    ACTIONS(18167), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588315] = 5,
    ACTIONS(23890), 1,
      anon_sym_SEMI,
    ACTIONS(23892), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588334] = 5,
    ACTIONS(11897), 1,
      anon_sym_RBRACE,
    ACTIONS(23894), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588353] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3577), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [588366] = 5,
    ACTIONS(4689), 1,
      sym__conid,
    STATE(11472), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588385] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17575), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [588398] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17699), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [588411] = 5,
    ACTIONS(109), 1,
      anon_sym_RBRACE,
    ACTIONS(23896), 1,
      anon_sym_SEMI,
    STATE(5), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16492), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588430] = 4,
    ACTIONS(23900), 1,
      sym_comma,
    STATE(17077), 1,
      aux_sym_signature_repeat1,
    ACTIONS(23898), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588447] = 4,
    ACTIONS(109), 1,
      sym__layout_end,
    STATE(16499), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(23903), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588464] = 5,
    ACTIONS(10046), 1,
      sym__conid,
    STATE(12697), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588483] = 5,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    ACTIONS(23905), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588502] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23907), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [588515] = 5,
    ACTIONS(4453), 1,
      sym__conid,
    STATE(5097), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588534] = 4,
    ACTIONS(22882), 1,
      anon_sym_LPAREN,
    STATE(20838), 1,
      sym_import_con_names,
    ACTIONS(23909), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588551] = 4,
    ACTIONS(23911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23913), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588568] = 4,
    ACTIONS(975), 1,
      sym__layout_end,
    STATE(17115), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23915), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588585] = 5,
    ACTIONS(8640), 1,
      sym__conid,
    STATE(7691), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588604] = 5,
    ACTIONS(5055), 1,
      anon_sym_RBRACE,
    ACTIONS(23917), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588623] = 5,
    ACTIONS(13678), 1,
      sym__conid,
    STATE(9971), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588642] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [588655] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23919), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [588668] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
  [588681] = 5,
    ACTIONS(14723), 1,
      anon_sym_RBRACE,
    ACTIONS(23921), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588700] = 5,
    ACTIONS(975), 1,
      anon_sym_RBRACE,
    ACTIONS(23923), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17117), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588719] = 5,
    ACTIONS(1083), 1,
      anon_sym_RBRACE,
    ACTIONS(23925), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17576), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588738] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23717), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [588751] = 5,
    ACTIONS(11889), 1,
      anon_sym_RBRACE,
    ACTIONS(23927), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588770] = 5,
    ACTIONS(21265), 1,
      anon_sym_RBRACE,
    ACTIONS(23929), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588789] = 5,
    ACTIONS(13038), 1,
      sym__conid,
    STATE(8531), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588808] = 4,
    STATE(2502), 1,
      sym__colon2,
    STATE(13767), 1,
      sym__type_annotation,
    ACTIONS(18411), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588825] = 5,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(23931), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588844] = 5,
    ACTIONS(7891), 1,
      sym__conid,
    STATE(4436), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588863] = 4,
    ACTIONS(11242), 1,
      sym__layout_end,
    STATE(17118), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23933), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588880] = 5,
    ACTIONS(14529), 1,
      anon_sym_RBRACE,
    ACTIONS(23935), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588899] = 5,
    ACTIONS(11242), 1,
      anon_sym_RBRACE,
    ACTIONS(23937), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17132), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588918] = 5,
    ACTIONS(14529), 1,
      anon_sym_RBRACE,
    ACTIONS(23935), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17092), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588937] = 4,
    ACTIONS(14529), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23939), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588954] = 4,
    ACTIONS(14110), 1,
      sym__layout_end,
    STATE(17140), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23941), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588971] = 5,
    ACTIONS(14110), 1,
      anon_sym_RBRACE,
    ACTIONS(23943), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17147), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [588990] = 5,
    ACTIONS(12120), 1,
      anon_sym_RBRACE,
    ACTIONS(23945), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589009] = 4,
    STATE(2220), 1,
      sym__colon2,
    STATE(20670), 1,
      sym__gadt_constr_type,
    ACTIONS(23947), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589026] = 5,
    ACTIONS(12120), 1,
      anon_sym_RBRACE,
    ACTIONS(23945), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17096), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589045] = 4,
    ACTIONS(12120), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23949), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589062] = 5,
    ACTIONS(23951), 1,
      anon_sym_SEMI,
    ACTIONS(23953), 1,
      anon_sym_RBRACE,
    STATE(2858), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17056), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589081] = 5,
    ACTIONS(23955), 1,
      anon_sym_SEMI,
    ACTIONS(23957), 1,
      sym__layout_semicolon,
    ACTIONS(23959), 1,
      sym__layout_end,
    STATE(17062), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589100] = 4,
    ACTIONS(1195), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23961), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589117] = 5,
    ACTIONS(1195), 1,
      anon_sym_RBRACE,
    ACTIONS(23963), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17179), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589136] = 5,
    ACTIONS(1195), 1,
      anon_sym_RBRACE,
    ACTIONS(23963), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589155] = 4,
    ACTIONS(12241), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23965), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589172] = 4,
    ACTIONS(713), 1,
      sym__layout_end,
    STATE(17141), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23967), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589189] = 5,
    ACTIONS(1199), 1,
      anon_sym_RBRACE,
    ACTIONS(23969), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589208] = 5,
    ACTIONS(713), 1,
      anon_sym_RBRACE,
    ACTIONS(23971), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17145), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589227] = 5,
    ACTIONS(17785), 1,
      anon_sym_RBRACE,
    ACTIONS(23973), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589246] = 5,
    ACTIONS(1199), 1,
      anon_sym_RBRACE,
    ACTIONS(23969), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17100), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589265] = 4,
    ACTIONS(1199), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23975), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589282] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18529), 4,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
  [589295] = 5,
    ACTIONS(13896), 1,
      anon_sym_RBRACE,
    ACTIONS(23977), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17103), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589314] = 4,
    ACTIONS(23979), 1,
      anon_sym_DOT_DOT,
    ACTIONS(23981), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589331] = 4,
    ACTIONS(13896), 1,
      sym__layout_end,
    STATE(17106), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23983), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589348] = 5,
    ACTIONS(10868), 1,
      anon_sym_RBRACE,
    ACTIONS(23985), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17109), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589367] = 4,
    ACTIONS(10868), 1,
      sym__layout_end,
    STATE(17112), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23987), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589384] = 5,
    ACTIONS(12241), 1,
      anon_sym_RBRACE,
    ACTIONS(23989), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17187), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589403] = 5,
    ACTIONS(12241), 1,
      anon_sym_RBRACE,
    ACTIONS(23989), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589422] = 5,
    ACTIONS(829), 1,
      anon_sym_RBRACE,
    ACTIONS(23991), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17120), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589441] = 4,
    ACTIONS(11204), 1,
      sym__layout_end,
    STATE(17153), 1,
      aux_sym_alts_repeat2,
    ACTIONS(23993), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589458] = 4,
    ACTIONS(829), 1,
      sym__layout_end,
    STATE(17124), 1,
      aux_sym_rec_repeat2,
    ACTIONS(23995), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589475] = 5,
    ACTIONS(11204), 1,
      anon_sym_RBRACE,
    ACTIONS(23997), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17157), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589494] = 4,
    ACTIONS(14000), 1,
      sym__layout_end,
    STATE(17159), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(23999), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589511] = 3,
    ACTIONS(21620), 1,
      anon_sym_in,
    ACTIONS(21618), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589526] = 5,
    ACTIONS(14000), 1,
      anon_sym_RBRACE,
    ACTIONS(24001), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17163), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589545] = 4,
    ACTIONS(14793), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24003), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589562] = 4,
    ACTIONS(1269), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24005), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589579] = 5,
    ACTIONS(14793), 1,
      anon_sym_RBRACE,
    ACTIONS(24007), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17195), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589598] = 5,
    ACTIONS(1269), 1,
      anon_sym_RBRACE,
    ACTIONS(24009), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17166), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589617] = 5,
    ACTIONS(14855), 1,
      anon_sym_RBRACE,
    ACTIONS(24011), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589636] = 5,
    ACTIONS(1269), 1,
      anon_sym_RBRACE,
    ACTIONS(24009), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589655] = 5,
    ACTIONS(24013), 1,
      anon_sym_SEMI,
    ACTIONS(24015), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16682), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589674] = 5,
    ACTIONS(14793), 1,
      anon_sym_RBRACE,
    ACTIONS(24007), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589693] = 5,
    ACTIONS(24017), 1,
      anon_sym_SEMI,
    ACTIONS(24019), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17070), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589712] = 5,
    ACTIONS(11915), 1,
      anon_sym_RBRACE,
    ACTIONS(24021), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589731] = 5,
    ACTIONS(24023), 1,
      anon_sym_SEMI,
    ACTIONS(24025), 1,
      sym__layout_semicolon,
    ACTIONS(24027), 1,
      sym__layout_end,
    STATE(16670), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589750] = 4,
    STATE(2443), 1,
      sym__colon2,
    STATE(16228), 1,
      sym__type_annotation,
    ACTIONS(17895), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589767] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [589780] = 4,
    ACTIONS(12385), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24029), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589797] = 4,
    ACTIONS(24033), 1,
      anon_sym_EQ,
    STATE(3166), 1,
      sym__larrow,
    ACTIONS(24031), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589814] = 5,
    ACTIONS(12385), 1,
      anon_sym_RBRACE,
    ACTIONS(24035), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17171), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589833] = 5,
    ACTIONS(5970), 1,
      anon_sym_RBRACE,
    ACTIONS(24037), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589852] = 5,
    ACTIONS(12385), 1,
      anon_sym_RBRACE,
    ACTIONS(24035), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589871] = 5,
    ACTIONS(5447), 1,
      anon_sym_RBRACE,
    ACTIONS(24039), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589890] = 4,
    ACTIONS(14773), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24041), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589907] = 5,
    ACTIONS(5447), 1,
      anon_sym_RBRACE,
    ACTIONS(24039), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17034), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589926] = 5,
    ACTIONS(14773), 1,
      anon_sym_RBRACE,
    ACTIONS(24043), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17174), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589945] = 5,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    ACTIONS(24045), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589964] = 5,
    ACTIONS(14773), 1,
      anon_sym_RBRACE,
    ACTIONS(24043), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [589983] = 4,
    ACTIONS(5447), 1,
      sym__layout_end,
    STATE(16349), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(24047), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590000] = 5,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    ACTIONS(24049), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590019] = 5,
    ACTIONS(1265), 1,
      anon_sym_RBRACE,
    ACTIONS(24051), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590038] = 5,
    ACTIONS(4837), 1,
      sym__conid,
    STATE(11352), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590057] = 5,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    ACTIONS(24049), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17080), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590076] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [590089] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [590102] = 5,
    ACTIONS(12379), 1,
      anon_sym_RBRACE,
    ACTIONS(24053), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590121] = 4,
    ACTIONS(1135), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24055), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [590151] = 5,
    ACTIONS(14777), 1,
      anon_sym_RBRACE,
    ACTIONS(24057), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590170] = 5,
    ACTIONS(14867), 1,
      anon_sym_RBRACE,
    ACTIONS(24059), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590189] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [590202] = 5,
    ACTIONS(5067), 1,
      anon_sym_RBRACE,
    ACTIONS(24061), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16567), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590221] = 5,
    ACTIONS(5067), 1,
      anon_sym_RBRACE,
    ACTIONS(24061), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17087), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590240] = 5,
    ACTIONS(1189), 1,
      anon_sym_RBRACE,
    ACTIONS(24063), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590259] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23527), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [590272] = 4,
    ACTIONS(5067), 1,
      sym__layout_end,
    STATE(16560), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(24065), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590289] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23523), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [590302] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [590315] = 5,
    ACTIONS(14867), 1,
      anon_sym_RBRACE,
    ACTIONS(24059), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17144), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590334] = 4,
    ACTIONS(14867), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24067), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590351] = 5,
    ACTIONS(1183), 1,
      anon_sym_RBRACE,
    ACTIONS(24069), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590370] = 5,
    ACTIONS(12237), 1,
      anon_sym_RBRACE,
    ACTIONS(24071), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590389] = 5,
    ACTIONS(21269), 1,
      anon_sym_RBRACE,
    ACTIONS(24073), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16533), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590408] = 5,
    ACTIONS(15337), 1,
      sym__conid,
    STATE(13895), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590427] = 5,
    ACTIONS(11897), 1,
      anon_sym_RBRACE,
    ACTIONS(23894), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17149), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590446] = 4,
    ACTIONS(11897), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24075), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590463] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24077), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [590476] = 5,
    ACTIONS(21269), 1,
      anon_sym_RBRACE,
    ACTIONS(24073), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17097), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590495] = 4,
    ACTIONS(21269), 1,
      sym__layout_end,
    STATE(16517), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(24079), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590512] = 5,
    ACTIONS(14809), 1,
      anon_sym_RBRACE,
    ACTIONS(24081), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590531] = 5,
    ACTIONS(15325), 1,
      sym__conid,
    STATE(13968), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590550] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24083), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [590563] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24085), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [590576] = 5,
    ACTIONS(1183), 1,
      anon_sym_RBRACE,
    ACTIONS(24069), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17162), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590595] = 5,
    ACTIONS(1181), 1,
      anon_sym_RBRACE,
    ACTIONS(24087), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590614] = 4,
    ACTIONS(1183), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24089), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590631] = 5,
    ACTIONS(17761), 1,
      anon_sym_RBRACE,
    ACTIONS(24091), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590650] = 5,
    ACTIONS(17761), 1,
      anon_sym_RBRACE,
    ACTIONS(24091), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17122), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590669] = 5,
    ACTIONS(4513), 1,
      sym__conid,
    STATE(10892), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590688] = 5,
    ACTIONS(13946), 1,
      sym__conid,
    STATE(9267), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590707] = 5,
    ACTIONS(14400), 1,
      anon_sym_RBRACE,
    ACTIONS(24093), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17175), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590726] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [590739] = 4,
    ACTIONS(14400), 1,
      sym__layout_end,
    STATE(17185), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24095), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590756] = 3,
    ACTIONS(21664), 1,
      anon_sym_in,
    ACTIONS(21662), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590771] = 5,
    ACTIONS(14962), 1,
      anon_sym_RBRACE,
    ACTIONS(24097), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590790] = 5,
    ACTIONS(11542), 1,
      anon_sym_RBRACE,
    ACTIONS(24099), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17071), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590809] = 5,
    ACTIONS(15013), 1,
      anon_sym_RBRACE,
    ACTIONS(24101), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590828] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [590841] = 4,
    ACTIONS(11542), 1,
      sym__layout_end,
    STATE(17191), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24103), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590858] = 5,
    ACTIONS(12371), 1,
      anon_sym_RBRACE,
    ACTIONS(24105), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590877] = 5,
    ACTIONS(11901), 1,
      anon_sym_RBRACE,
    ACTIONS(24107), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590896] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [590909] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [590922] = 5,
    ACTIONS(24109), 1,
      anon_sym_SEMI,
    ACTIONS(24111), 1,
      anon_sym_RBRACE,
    STATE(3491), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17146), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590941] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 4,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [590954] = 5,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    ACTIONS(24113), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590973] = 5,
    ACTIONS(24115), 1,
      anon_sym_SEMI,
    ACTIONS(24117), 1,
      sym__layout_semicolon,
    ACTIONS(24119), 1,
      sym__layout_end,
    STATE(17150), 1,
      aux_sym_decl_tyfam_repeat3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [590992] = 5,
    ACTIONS(13464), 1,
      sym__conid,
    STATE(8850), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591011] = 5,
    ACTIONS(15049), 1,
      anon_sym_RBRACE,
    ACTIONS(24121), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591030] = 5,
    ACTIONS(5924), 1,
      anon_sym_RBRACE,
    ACTIONS(24123), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16327), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591049] = 5,
    ACTIONS(15049), 1,
      anon_sym_RBRACE,
    ACTIONS(24121), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17212), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591068] = 4,
    ACTIONS(15049), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24125), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591085] = 5,
    ACTIONS(5924), 1,
      anon_sym_RBRACE,
    ACTIONS(24123), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17156), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591104] = 4,
    ACTIONS(1083), 1,
      sym__layout_end,
    STATE(17590), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24127), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591121] = 5,
    ACTIONS(11853), 1,
      anon_sym_RBRACE,
    ACTIONS(24129), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591140] = 4,
    ACTIONS(5924), 1,
      sym__layout_end,
    STATE(16412), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(24131), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591157] = 5,
    ACTIONS(11853), 1,
      anon_sym_RBRACE,
    ACTIONS(24129), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17215), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591176] = 4,
    ACTIONS(11853), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24133), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591193] = 5,
    ACTIONS(991), 1,
      anon_sym_RBRACE,
    ACTIONS(24135), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17186), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591212] = 4,
    ACTIONS(991), 1,
      sym__layout_end,
    STATE(17201), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24137), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591229] = 5,
    ACTIONS(5361), 1,
      anon_sym_RBRACE,
    ACTIONS(24139), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17158), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591248] = 4,
    STATE(2437), 1,
      sym__colon2,
    STATE(13467), 1,
      sym__type_annotation,
    ACTIONS(18277), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591265] = 4,
    ACTIONS(5361), 1,
      sym__layout_end,
    STATE(17164), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(24141), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591282] = 5,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    ACTIONS(24143), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591301] = 5,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    ACTIONS(24145), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591320] = 5,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    ACTIONS(24143), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17221), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591339] = 4,
    ACTIONS(1171), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24147), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591356] = 5,
    ACTIONS(14012), 1,
      anon_sym_RBRACE,
    ACTIONS(24149), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17224), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591375] = 5,
    ACTIONS(809), 1,
      anon_sym_RBRACE,
    ACTIONS(24151), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17165), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591394] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22244), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [591407] = 4,
    ACTIONS(14012), 1,
      sym__layout_end,
    STATE(17227), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24153), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591424] = 5,
    ACTIONS(11691), 1,
      anon_sym_RBRACE,
    ACTIONS(24155), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17230), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591443] = 4,
    ACTIONS(809), 1,
      sym__layout_end,
    STATE(17172), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24157), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591460] = 4,
    ACTIONS(24159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24161), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591477] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24163), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [591490] = 4,
    ACTIONS(11691), 1,
      sym__layout_end,
    STATE(17233), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24165), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591507] = 5,
    ACTIONS(15299), 1,
      sym__conid,
    STATE(13072), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591526] = 5,
    ACTIONS(14940), 1,
      sym__conid,
    STATE(9430), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591545] = 5,
    ACTIONS(5357), 1,
      anon_sym_RBRACE,
    ACTIONS(24167), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16500), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591564] = 5,
    ACTIONS(817), 1,
      anon_sym_RBRACE,
    ACTIONS(24169), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17239), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591583] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(15995), 1,
      sym_fundep,
    STATE(15590), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591600] = 4,
    ACTIONS(725), 1,
      sym__layout_end,
    STATE(17279), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24171), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591617] = 4,
    ACTIONS(817), 1,
      sym__layout_end,
    STATE(17242), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24173), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591634] = 5,
    ACTIONS(725), 1,
      anon_sym_RBRACE,
    ACTIONS(24175), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17283), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591653] = 3,
    ACTIONS(24177), 1,
      sym_where,
    ACTIONS(22230), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591668] = 4,
    STATE(2479), 1,
      sym__colon2,
    STATE(12056), 1,
      sym__type_annotation,
    ACTIONS(17863), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591685] = 5,
    ACTIONS(4911), 1,
      anon_sym_RBRACE,
    ACTIONS(24179), 1,
      anon_sym_SEMI,
    STATE(1800), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17177), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591704] = 4,
    ACTIONS(4911), 1,
      sym__layout_end,
    STATE(17181), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(24181), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591721] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21830), 1,
      anon_sym_LPAREN,
    STATE(15526), 1,
      sym_variable,
    STATE(20487), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591740] = 5,
    ACTIONS(11705), 1,
      anon_sym_RBRACE,
    ACTIONS(24183), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16629), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591759] = 5,
    ACTIONS(14170), 1,
      sym__conid,
    STATE(9148), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591778] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(24185), 1,
      anon_sym_RBRACE,
    STATE(15721), 1,
      sym_variable,
    STATE(17968), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591797] = 5,
    ACTIONS(20952), 1,
      anon_sym_RBRACE,
    ACTIONS(24187), 1,
      anon_sym_SEMI,
    STATE(14194), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17188), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591816] = 5,
    ACTIONS(24189), 1,
      anon_sym_SEMI,
    ACTIONS(24192), 1,
      anon_sym_RBRACE,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591835] = 3,
    ACTIONS(24194), 1,
      sym_where,
    ACTIONS(22821), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591850] = 4,
    STATE(2434), 1,
      sym__colon2,
    STATE(13765), 1,
      sym__type_annotation,
    ACTIONS(18415), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591867] = 4,
    ACTIONS(11149), 1,
      sym__layout_end,
    STATE(17291), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24196), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591884] = 4,
    ACTIONS(20952), 1,
      sym__layout_end,
    STATE(17194), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(24198), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591901] = 5,
    ACTIONS(11149), 1,
      anon_sym_RBRACE,
    ACTIONS(24200), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17295), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591920] = 4,
    ACTIONS(13918), 1,
      sym__layout_end,
    STATE(17297), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24202), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591937] = 4,
    STATE(2220), 1,
      sym__colon2,
    STATE(20477), 1,
      sym__gadt_constr_type,
    ACTIONS(23947), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591954] = 5,
    ACTIONS(13918), 1,
      anon_sym_RBRACE,
    ACTIONS(24204), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17301), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591973] = 5,
    ACTIONS(9622), 1,
      sym__conid,
    STATE(12206), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [591992] = 4,
    ACTIONS(1243), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24206), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592009] = 5,
    ACTIONS(17805), 1,
      anon_sym_RBRACE,
    ACTIONS(24208), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592028] = 5,
    ACTIONS(1243), 1,
      anon_sym_RBRACE,
    ACTIONS(24210), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17304), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592047] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17699), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [592060] = 5,
    ACTIONS(1243), 1,
      anon_sym_RBRACE,
    ACTIONS(24210), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592079] = 5,
    ACTIONS(16783), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14969), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592098] = 4,
    ACTIONS(21955), 1,
      anon_sym_in,
    STATE(17285), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(24212), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592115] = 5,
    ACTIONS(5349), 1,
      anon_sym_RBRACE,
    ACTIONS(24215), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17202), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592134] = 5,
    ACTIONS(8414), 1,
      sym__conid,
    STATE(7100), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592153] = 5,
    ACTIONS(14807), 1,
      anon_sym_RBRACE,
    ACTIONS(24217), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592172] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15645), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [592185] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23102), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [592198] = 4,
    ACTIONS(12280), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24219), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592215] = 5,
    ACTIONS(3305), 1,
      sym__conid,
    STATE(5224), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592234] = 5,
    ACTIONS(12280), 1,
      anon_sym_RBRACE,
    ACTIONS(24221), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17309), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592253] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24223), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [592266] = 5,
    ACTIONS(12280), 1,
      anon_sym_RBRACE,
    ACTIONS(24221), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592285] = 5,
    ACTIONS(13779), 1,
      sym__conid,
    STATE(9165), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592304] = 4,
    ACTIONS(14779), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24225), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592321] = 5,
    ACTIONS(15033), 1,
      anon_sym_RBRACE,
    ACTIONS(24227), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592340] = 5,
    ACTIONS(14779), 1,
      anon_sym_RBRACE,
    ACTIONS(24229), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17312), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592359] = 5,
    ACTIONS(15033), 1,
      anon_sym_RBRACE,
    ACTIONS(24227), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17210), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592378] = 5,
    ACTIONS(14779), 1,
      anon_sym_RBRACE,
    ACTIONS(24229), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592397] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23092), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [592410] = 4,
    ACTIONS(24233), 1,
      sym_comma,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(24231), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592427] = 5,
    ACTIONS(1233), 1,
      anon_sym_RBRACE,
    ACTIONS(24236), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592446] = 5,
    ACTIONS(14807), 1,
      anon_sym_RBRACE,
    ACTIONS(24217), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16607), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592465] = 4,
    ACTIONS(15033), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24238), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592482] = 4,
    STATE(2506), 1,
      sym__colon2,
    STATE(16154), 1,
      sym__type_annotation,
    ACTIONS(18459), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592499] = 5,
    ACTIONS(12312), 1,
      anon_sym_RBRACE,
    ACTIONS(24240), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592518] = 5,
    ACTIONS(12276), 1,
      anon_sym_RBRACE,
    ACTIONS(24242), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592537] = 5,
    ACTIONS(8265), 1,
      sym__conid,
    STATE(7112), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592556] = 4,
    ACTIONS(24244), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24246), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592573] = 5,
    ACTIONS(14781), 1,
      anon_sym_RBRACE,
    ACTIONS(24248), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592592] = 4,
    ACTIONS(24250), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24252), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592609] = 5,
    ACTIONS(15311), 1,
      sym__conid,
    STATE(13896), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592628] = 5,
    ACTIONS(12312), 1,
      anon_sym_RBRACE,
    ACTIONS(24240), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17216), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592647] = 4,
    ACTIONS(12312), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24254), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592664] = 4,
    ACTIONS(14807), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24256), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592681] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23076), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [592694] = 3,
    ACTIONS(24260), 1,
      sym_where,
    ACTIONS(24258), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592709] = 5,
    ACTIONS(5596), 1,
      anon_sym_RBRACE,
    ACTIONS(24262), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17225), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592728] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21846), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [592741] = 4,
    ACTIONS(5596), 1,
      sym__layout_end,
    STATE(17231), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(24264), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592758] = 4,
    ACTIONS(1015), 1,
      sym__layout_end,
    STATE(17349), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24266), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592775] = 5,
    ACTIONS(1015), 1,
      anon_sym_RBRACE,
    ACTIONS(24268), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17355), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592794] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24270), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [592807] = 5,
    ACTIONS(11705), 1,
      anon_sym_RBRACE,
    ACTIONS(24183), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592826] = 5,
    ACTIONS(15337), 1,
      sym__conid,
    STATE(13642), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592845] = 5,
    ACTIONS(15307), 1,
      sym__conid,
    STATE(14145), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592864] = 4,
    ACTIONS(24272), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24274), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592881] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21914), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [592894] = 4,
    ACTIONS(11447), 1,
      sym__layout_end,
    STATE(17404), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24276), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592911] = 5,
    ACTIONS(1181), 1,
      anon_sym_RBRACE,
    ACTIONS(24087), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17240), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592930] = 4,
    ACTIONS(1181), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24278), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592947] = 5,
    ACTIONS(8141), 1,
      sym__conid,
    STATE(7413), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592966] = 5,
    ACTIONS(11447), 1,
      anon_sym_RBRACE,
    ACTIONS(24280), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17407), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [592985] = 4,
    ACTIONS(14311), 1,
      sym__layout_end,
    STATE(17415), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24282), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593002] = 5,
    ACTIONS(14960), 1,
      anon_sym_RBRACE,
    ACTIONS(24284), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593021] = 5,
    ACTIONS(15017), 1,
      anon_sym_RBRACE,
    ACTIONS(24286), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593040] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21440), 1,
      anon_sym_LPAREN,
    STATE(15170), 1,
      sym_variable,
    STATE(18048), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593059] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21440), 1,
      anon_sym_LPAREN,
    STATE(15170), 1,
      sym_variable,
    STATE(18034), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593078] = 5,
    ACTIONS(14311), 1,
      anon_sym_RBRACE,
    ACTIONS(24288), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17428), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593097] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22975), 1,
      sym_variable,
    STATE(23111), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593116] = 5,
    ACTIONS(11913), 1,
      anon_sym_RBRACE,
    ACTIONS(24290), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593135] = 3,
    ACTIONS(21397), 1,
      anon_sym_in,
    ACTIONS(21395), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593150] = 5,
    ACTIONS(11958), 1,
      anon_sym_RBRACE,
    ACTIONS(24292), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593169] = 5,
    ACTIONS(8774), 1,
      sym__conid,
    STATE(6873), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593188] = 5,
    ACTIONS(1133), 1,
      anon_sym_RBRACE,
    ACTIONS(24294), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593207] = 5,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    ACTIONS(24296), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593226] = 4,
    ACTIONS(1125), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24298), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593243] = 5,
    ACTIONS(15015), 1,
      anon_sym_RBRACE,
    ACTIONS(24300), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593262] = 5,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    ACTIONS(24302), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17432), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593281] = 5,
    ACTIONS(15015), 1,
      anon_sym_RBRACE,
    ACTIONS(24300), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17338), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593300] = 4,
    ACTIONS(15015), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24304), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593317] = 5,
    ACTIONS(14926), 1,
      anon_sym_RBRACE,
    ACTIONS(24306), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593336] = 5,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    ACTIONS(24302), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593355] = 5,
    ACTIONS(11895), 1,
      anon_sym_RBRACE,
    ACTIONS(24308), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593374] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [593387] = 5,
    ACTIONS(14926), 1,
      anon_sym_RBRACE,
    ACTIONS(24306), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17337), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593406] = 5,
    ACTIONS(11895), 1,
      anon_sym_RBRACE,
    ACTIONS(24308), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17343), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593425] = 4,
    ACTIONS(11895), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24310), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593442] = 4,
    STATE(2464), 1,
      sym__colon2,
    STATE(15451), 1,
      sym__type_annotation,
    ACTIONS(18183), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593459] = 4,
    ACTIONS(14926), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24312), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593476] = 5,
    ACTIONS(12003), 1,
      anon_sym_RBRACE,
    ACTIONS(24314), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593495] = 4,
    ACTIONS(24316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24318), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593512] = 5,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(24320), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593531] = 5,
    ACTIONS(12003), 1,
      anon_sym_RBRACE,
    ACTIONS(24314), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17345), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593550] = 5,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(24320), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17348), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593569] = 4,
    ACTIONS(1137), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24322), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593586] = 4,
    ACTIONS(12003), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24324), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593603] = 5,
    ACTIONS(14380), 1,
      anon_sym_RBRACE,
    ACTIONS(24326), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17350), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593622] = 4,
    ACTIONS(14380), 1,
      sym__layout_end,
    STATE(17353), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24328), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593639] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21867), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [593652] = 5,
    ACTIONS(4431), 1,
      sym__conid,
    STATE(4634), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593671] = 5,
    ACTIONS(13807), 1,
      anon_sym_RBRACE,
    ACTIONS(24330), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17298), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593690] = 5,
    ACTIONS(11421), 1,
      anon_sym_RBRACE,
    ACTIONS(24332), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17356), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593709] = 4,
    ACTIONS(11421), 1,
      sym__layout_end,
    STATE(17360), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24334), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593726] = 3,
    ACTIONS(24338), 1,
      sym_where,
    ACTIONS(24336), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593741] = 5,
    ACTIONS(7911), 1,
      sym__conid,
    STATE(6413), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593760] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23452), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [593773] = 4,
    ACTIONS(741), 1,
      sym__layout_end,
    STATE(17401), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24340), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593790] = 5,
    ACTIONS(805), 1,
      anon_sym_RBRACE,
    ACTIONS(24342), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17365), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593809] = 5,
    ACTIONS(741), 1,
      anon_sym_RBRACE,
    ACTIONS(24344), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17405), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593828] = 5,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    ACTIONS(24346), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593847] = 4,
    ACTIONS(805), 1,
      sym__layout_end,
    STATE(17368), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24348), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593864] = 5,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    ACTIONS(24346), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17347), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593883] = 4,
    ACTIONS(11705), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24350), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593900] = 4,
    ACTIONS(13807), 1,
      sym__layout_end,
    STATE(17306), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24352), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593917] = 4,
    ACTIONS(1173), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24354), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593934] = 5,
    ACTIONS(14307), 1,
      anon_sym_RBRACE,
    ACTIONS(24356), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17354), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593953] = 5,
    ACTIONS(11113), 1,
      anon_sym_RBRACE,
    ACTIONS(24358), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17308), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [593972] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 4,
      sym__unboxed_close,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [593985] = 4,
    ACTIONS(14307), 1,
      sym__layout_end,
    STATE(17362), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24360), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594002] = 4,
    STATE(2491), 1,
      sym__colon2,
    STATE(13402), 1,
      sym__type_annotation,
    ACTIONS(18269), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594019] = 4,
    ACTIONS(11125), 1,
      sym__layout_end,
    STATE(17412), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24362), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594036] = 5,
    ACTIONS(11435), 1,
      anon_sym_RBRACE,
    ACTIONS(24364), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17363), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594055] = 5,
    ACTIONS(11125), 1,
      anon_sym_RBRACE,
    ACTIONS(24366), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17416), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594074] = 4,
    ACTIONS(13878), 1,
      sym__layout_end,
    STATE(17418), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24368), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594091] = 4,
    ACTIONS(11113), 1,
      sym__layout_end,
    STATE(17316), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24370), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594108] = 5,
    ACTIONS(13878), 1,
      anon_sym_RBRACE,
    ACTIONS(24372), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17422), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594127] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24374), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [594140] = 4,
    ACTIONS(1229), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24376), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594157] = 4,
    ACTIONS(11435), 1,
      sym__layout_end,
    STATE(17369), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24378), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594174] = 5,
    ACTIONS(1229), 1,
      anon_sym_RBRACE,
    ACTIONS(24380), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17425), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594193] = 4,
    ACTIONS(12092), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24382), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594210] = 5,
    ACTIONS(1229), 1,
      anon_sym_RBRACE,
    ACTIONS(24380), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594229] = 5,
    ACTIONS(12092), 1,
      anon_sym_RBRACE,
    ACTIONS(24384), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17436), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594248] = 5,
    ACTIONS(12092), 1,
      anon_sym_RBRACE,
    ACTIONS(24384), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594267] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22004), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [594280] = 5,
    ACTIONS(8660), 1,
      sym__conid,
    STATE(6381), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594299] = 5,
    ACTIONS(1019), 1,
      anon_sym_RBRACE,
    ACTIONS(24386), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17383), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594318] = 4,
    ACTIONS(1019), 1,
      sym__layout_end,
    STATE(17388), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24388), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594335] = 4,
    ACTIONS(12116), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24390), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594352] = 5,
    ACTIONS(9322), 1,
      sym__conid,
    STATE(11648), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594371] = 5,
    ACTIONS(12116), 1,
      anon_sym_RBRACE,
    ACTIONS(24392), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17430), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594390] = 4,
    ACTIONS(14523), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24394), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594407] = 5,
    ACTIONS(12116), 1,
      anon_sym_RBRACE,
    ACTIONS(24392), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594426] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22004), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [594439] = 4,
    ACTIONS(14783), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24396), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594456] = 4,
    ACTIONS(23855), 1,
      sym__layout_end,
    STATE(17419), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(24398), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594473] = 5,
    ACTIONS(14783), 1,
      anon_sym_RBRACE,
    ACTIONS(24401), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17433), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594492] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21867), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [594505] = 5,
    ACTIONS(14783), 1,
      anon_sym_RBRACE,
    ACTIONS(24401), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594524] = 5,
    ACTIONS(14523), 1,
      anon_sym_RBRACE,
    ACTIONS(24403), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17438), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594543] = 3,
    ACTIONS(24405), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(24407), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594558] = 5,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    ACTIONS(24409), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594577] = 5,
    ACTIONS(4583), 1,
      sym__conid,
    STATE(4580), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594596] = 5,
    ACTIONS(15359), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15611), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594615] = 5,
    ACTIONS(14523), 1,
      anon_sym_RBRACE,
    ACTIONS(24403), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594634] = 4,
    STATE(2505), 1,
      sym__colon2,
    STATE(11986), 1,
      sym__type_annotation,
    ACTIONS(17853), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594651] = 5,
    ACTIONS(12110), 1,
      anon_sym_RBRACE,
    ACTIONS(24411), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594670] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22540), 1,
      sym_variable,
    STATE(22661), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594689] = 5,
    ACTIONS(1139), 1,
      anon_sym_RBRACE,
    ACTIONS(24413), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594708] = 5,
    ACTIONS(14785), 1,
      anon_sym_RBRACE,
    ACTIONS(24415), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594727] = 5,
    ACTIONS(837), 1,
      anon_sym_RBRACE,
    ACTIONS(24417), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17200), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594746] = 5,
    ACTIONS(9708), 1,
      sym__conid,
    STATE(11346), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594765] = 5,
    ACTIONS(12100), 1,
      anon_sym_RBRACE,
    ACTIONS(24419), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594784] = 4,
    ACTIONS(837), 1,
      sym__layout_end,
    STATE(17333), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24421), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594801] = 5,
    ACTIONS(14717), 1,
      anon_sym_RBRACE,
    ACTIONS(24423), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594820] = 5,
    ACTIONS(8498), 1,
      sym__conid,
    STATE(7371), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594839] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [594852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21428), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [594865] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [594878] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22975), 1,
      sym_variable,
    STATE(23134), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594897] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(22771), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [594910] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21618), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [594923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23725), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [594936] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(15023), 1,
      sym_fundep,
    STATE(15590), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594953] = 4,
    ACTIONS(24425), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24427), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594970] = 5,
    ACTIONS(9896), 1,
      sym__conid,
    STATE(11879), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [594989] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22540), 1,
      sym_variable,
    STATE(22637), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595008] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22540), 1,
      sym_variable,
    STATE(22621), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595027] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [595040] = 5,
    ACTIONS(6220), 1,
      sym__conid,
    STATE(7709), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595059] = 5,
    ACTIONS(1301), 1,
      anon_sym_RBRACE,
    ACTIONS(24429), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595078] = 5,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(12437), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595097] = 5,
    ACTIONS(1618), 1,
      sym__conid,
    STATE(4091), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595116] = 5,
    ACTIONS(4809), 1,
      sym__conid,
    STATE(4605), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595135] = 5,
    ACTIONS(13064), 1,
      sym__conid,
    STATE(8687), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595154] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17699), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [595167] = 3,
    ACTIONS(24431), 1,
      sym_where,
    ACTIONS(23860), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595182] = 4,
    ACTIONS(24433), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24435), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595199] = 4,
    ACTIONS(24439), 1,
      sym_comma,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(24437), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23607), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [595229] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23609), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [595242] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22662), 1,
      sym_variable,
    STATE(22789), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595261] = 5,
    ACTIONS(14958), 1,
      anon_sym_RBRACE,
    ACTIONS(24442), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595280] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21614), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595295] = 5,
    ACTIONS(11701), 1,
      anon_sym_RBRACE,
    ACTIONS(24444), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595314] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18533), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [595327] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22662), 1,
      sym_variable,
    STATE(22741), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595346] = 5,
    ACTIONS(1127), 1,
      anon_sym_RBRACE,
    ACTIONS(24446), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595365] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22662), 1,
      sym_variable,
    STATE(22762), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595384] = 4,
    STATE(2429), 1,
      sym__colon2,
    STATE(15435), 1,
      sym__type_annotation,
    ACTIONS(18335), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595401] = 5,
    ACTIONS(15023), 1,
      anon_sym_RBRACE,
    ACTIONS(24448), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595420] = 5,
    ACTIONS(12373), 1,
      anon_sym_RBRACE,
    ACTIONS(24450), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595439] = 5,
    ACTIONS(14954), 1,
      anon_sym_RBRACE,
    ACTIONS(24452), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595458] = 4,
    ACTIONS(24454), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24456), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595475] = 5,
    ACTIONS(14954), 1,
      anon_sym_RBRACE,
    ACTIONS(24452), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17466), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595494] = 4,
    ACTIONS(14954), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24458), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595511] = 4,
    STATE(2495), 1,
      sym__colon2,
    STATE(13276), 1,
      sym__type_annotation,
    ACTIONS(18273), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595528] = 5,
    ACTIONS(11713), 1,
      anon_sym_RBRACE,
    ACTIONS(24460), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595547] = 4,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(22138), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595564] = 5,
    ACTIONS(11713), 1,
      anon_sym_RBRACE,
    ACTIONS(24460), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17468), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595583] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18691), 4,
      sym__unboxed_close,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [595596] = 4,
    ACTIONS(11713), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24462), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595613] = 5,
    ACTIONS(12225), 1,
      sym__conid,
    STATE(9584), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595632] = 5,
    ACTIONS(1297), 1,
      anon_sym_RBRACE,
    ACTIONS(24464), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595651] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [595664] = 5,
    ACTIONS(14972), 1,
      anon_sym_RBRACE,
    ACTIONS(24466), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595683] = 4,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(22224), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595700] = 5,
    ACTIONS(1129), 1,
      anon_sym_RBRACE,
    ACTIONS(24468), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595719] = 5,
    ACTIONS(14972), 1,
      anon_sym_RBRACE,
    ACTIONS(24466), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17474), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595738] = 5,
    ACTIONS(4467), 1,
      sym__conid,
    STATE(10276), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595757] = 3,
    ACTIONS(21584), 1,
      anon_sym_in,
    ACTIONS(21582), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595772] = 4,
    STATE(2447), 1,
      sym__colon2,
    STATE(14877), 1,
      sym__type_annotation,
    ACTIONS(17899), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595789] = 4,
    ACTIONS(14972), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24470), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595806] = 5,
    ACTIONS(12387), 1,
      anon_sym_RBRACE,
    ACTIONS(24472), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595825] = 5,
    ACTIONS(1129), 1,
      anon_sym_RBRACE,
    ACTIONS(24468), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17471), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595844] = 4,
    ACTIONS(753), 1,
      sym__layout_end,
    STATE(17520), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24474), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595861] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23733), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [595874] = 5,
    ACTIONS(753), 1,
      anon_sym_RBRACE,
    ACTIONS(24476), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17524), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595893] = 4,
    ACTIONS(1129), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24478), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595910] = 4,
    ACTIONS(1039), 1,
      sym__layout_end,
    STATE(17554), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24480), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595927] = 5,
    ACTIONS(14418), 1,
      anon_sym_RBRACE,
    ACTIONS(24482), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17476), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595946] = 5,
    ACTIONS(12387), 1,
      anon_sym_RBRACE,
    ACTIONS(24472), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17475), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595965] = 4,
    ACTIONS(14418), 1,
      sym__layout_end,
    STATE(17479), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24484), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [595982] = 5,
    ACTIONS(11622), 1,
      anon_sym_RBRACE,
    ACTIONS(24486), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17481), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596001] = 4,
    ACTIONS(12387), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24488), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596018] = 5,
    ACTIONS(8756), 1,
      sym__conid,
    STATE(6402), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596037] = 3,
    ACTIONS(24490), 1,
      sym_where,
    ACTIONS(22230), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596052] = 4,
    ACTIONS(11622), 1,
      sym__layout_end,
    STATE(17485), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24492), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596069] = 5,
    ACTIONS(1039), 1,
      anon_sym_RBRACE,
    ACTIONS(24494), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17454), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596088] = 4,
    ACTIONS(11065), 1,
      sym__layout_end,
    STATE(17531), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24496), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596105] = 5,
    ACTIONS(1339), 1,
      anon_sym_RBRACE,
    ACTIONS(24498), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596124] = 5,
    ACTIONS(11065), 1,
      anon_sym_RBRACE,
    ACTIONS(24500), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17535), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596143] = 4,
    ACTIONS(13698), 1,
      sym__layout_end,
    STATE(17537), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24502), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596160] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22790), 1,
      sym_variable,
    STATE(22973), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596179] = 5,
    ACTIONS(13698), 1,
      anon_sym_RBRACE,
    ACTIONS(24504), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17541), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596198] = 5,
    ACTIONS(1339), 1,
      anon_sym_RBRACE,
    ACTIONS(24498), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17487), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596217] = 4,
    ACTIONS(1215), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24506), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596234] = 5,
    ACTIONS(797), 1,
      anon_sym_RBRACE,
    ACTIONS(24508), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17491), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596253] = 5,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    ACTIONS(24510), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17544), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596272] = 4,
    ACTIONS(1339), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24512), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596289] = 5,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    ACTIONS(24510), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596308] = 4,
    STATE(2467), 1,
      sym__colon2,
    STATE(20768), 1,
      sym__type_annotation,
    ACTIONS(17351), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596325] = 5,
    ACTIONS(13976), 1,
      anon_sym_RBRACE,
    ACTIONS(24514), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17489), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596344] = 4,
    ACTIONS(13976), 1,
      sym__layout_end,
    STATE(17496), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24516), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596361] = 5,
    ACTIONS(11173), 1,
      anon_sym_RBRACE,
    ACTIONS(24518), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17497), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596380] = 4,
    ACTIONS(797), 1,
      sym__layout_end,
    STATE(17502), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24520), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596397] = 4,
    ACTIONS(24524), 1,
      anon_sym_EQ,
    STATE(3141), 1,
      sym__larrow,
    ACTIONS(24522), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596414] = 4,
    ACTIONS(11703), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24526), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596431] = 4,
    ACTIONS(11173), 1,
      sym__layout_end,
    STATE(17508), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24528), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596448] = 5,
    ACTIONS(11703), 1,
      anon_sym_RBRACE,
    ACTIONS(24530), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17549), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596467] = 5,
    ACTIONS(7921), 1,
      sym__conid,
    STATE(6245), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596486] = 5,
    ACTIONS(11703), 1,
      anon_sym_RBRACE,
    ACTIONS(24530), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596505] = 4,
    ACTIONS(11196), 1,
      sym__layout_end,
    STATE(17574), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24532), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596522] = 4,
    ACTIONS(14791), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24534), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596539] = 5,
    ACTIONS(11196), 1,
      anon_sym_RBRACE,
    ACTIONS(24536), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17562), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596558] = 5,
    ACTIONS(14791), 1,
      anon_sym_RBRACE,
    ACTIONS(24538), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17552), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596577] = 4,
    ACTIONS(13992), 1,
      sym__layout_end,
    STATE(17563), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24540), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596594] = 5,
    ACTIONS(14791), 1,
      anon_sym_RBRACE,
    ACTIONS(24538), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596613] = 5,
    ACTIONS(13992), 1,
      anon_sym_RBRACE,
    ACTIONS(24542), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17567), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596632] = 5,
    ACTIONS(5686), 1,
      anon_sym_RBRACE,
    ACTIONS(24544), 1,
      anon_sym_SEMI,
    STATE(2053), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16768), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596651] = 5,
    ACTIONS(1213), 1,
      anon_sym_RBRACE,
    ACTIONS(24546), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596670] = 5,
    ACTIONS(12746), 1,
      sym__conid,
    STATE(8758), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596689] = 4,
    ACTIONS(5686), 1,
      sym__layout_end,
    STATE(16793), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(24548), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596706] = 5,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(24550), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17514), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596725] = 4,
    ACTIONS(24552), 1,
      ts_builtin_sym_end,
    STATE(16899), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(24554), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596742] = 5,
    ACTIONS(11717), 1,
      anon_sym_RBRACE,
    ACTIONS(24556), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596761] = 4,
    ACTIONS(1043), 1,
      sym__layout_end,
    STATE(17523), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24558), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596778] = 5,
    ACTIONS(9828), 1,
      sym__conid,
    STATE(11298), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596797] = 5,
    ACTIONS(14797), 1,
      anon_sym_RBRACE,
    ACTIONS(24560), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596816] = 3,
    ACTIONS(20445), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(21610), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596831] = 4,
    ACTIONS(1301), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24562), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596848] = 5,
    ACTIONS(21492), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(18256), 1,
      sym__modid,
    STATE(18491), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596867] = 5,
    ACTIONS(1301), 1,
      anon_sym_RBRACE,
    ACTIONS(24429), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17569), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596886] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [596899] = 4,
    STATE(2453), 1,
      sym__colon2,
    STATE(17985), 1,
      sym__type_annotation,
    ACTIONS(17355), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596916] = 5,
    ACTIONS(8622), 1,
      sym__conid,
    STATE(6484), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596935] = 5,
    ACTIONS(20241), 1,
      anon_sym_in,
    ACTIONS(24564), 1,
      anon_sym_LBRACE,
    ACTIONS(24566), 1,
      sym__layout_start,
    STATE(23090), 1,
      sym__let_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596954] = 5,
    ACTIONS(12389), 1,
      anon_sym_RBRACE,
    ACTIONS(24568), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17685), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596973] = 5,
    ACTIONS(12389), 1,
      anon_sym_RBRACE,
    ACTIONS(24568), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [596992] = 4,
    ACTIONS(14964), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24570), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597009] = 5,
    ACTIONS(7873), 1,
      sym__conid,
    STATE(6948), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597028] = 5,
    ACTIONS(14964), 1,
      anon_sym_RBRACE,
    ACTIONS(24572), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17575), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597047] = 4,
    STATE(2499), 1,
      sym__colon2,
    STATE(15921), 1,
      sym__type_annotation,
    ACTIONS(17915), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597064] = 5,
    ACTIONS(14964), 1,
      anon_sym_RBRACE,
    ACTIONS(24572), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597083] = 5,
    ACTIONS(7783), 1,
      sym__conid,
    STATE(6625), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597102] = 5,
    ACTIONS(1341), 1,
      anon_sym_RBRACE,
    ACTIONS(24574), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597121] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21201), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
  [597134] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23138), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [597147] = 5,
    ACTIONS(15183), 1,
      sym__conid,
    STATE(9782), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597166] = 5,
    ACTIONS(9356), 1,
      sym__conid,
    STATE(11418), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597185] = 4,
    ACTIONS(12389), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24576), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597202] = 5,
    ACTIONS(14956), 1,
      anon_sym_RBRACE,
    ACTIONS(24578), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597221] = 5,
    ACTIONS(1211), 1,
      anon_sym_RBRACE,
    ACTIONS(24580), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597240] = 5,
    ACTIONS(13678), 1,
      sym__conid,
    STATE(9824), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597259] = 5,
    ACTIONS(12189), 1,
      sym__conid,
    STATE(9069), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597278] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597291] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597304] = 5,
    ACTIONS(7981), 1,
      sym__conid,
    STATE(7402), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597323] = 4,
    ACTIONS(1249), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24582), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597340] = 5,
    ACTIONS(14827), 1,
      sym__conid,
    STATE(9512), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597359] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15587), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [597372] = 5,
    ACTIONS(13096), 1,
      sym__conid,
    STATE(8737), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597391] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597404] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597417] = 5,
    ACTIONS(1211), 1,
      anon_sym_RBRACE,
    ACTIONS(24580), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16829), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597436] = 4,
    ACTIONS(11475), 1,
      sym__layout_end,
    STATE(17386), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24584), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597453] = 4,
    ACTIONS(1211), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24586), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597470] = 5,
    ACTIONS(11475), 1,
      anon_sym_RBRACE,
    ACTIONS(24588), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17326), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597489] = 5,
    ACTIONS(13012), 1,
      sym__conid,
    STATE(8477), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597508] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3577), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [597521] = 4,
    ACTIONS(14384), 1,
      sym__layout_end,
    STATE(17317), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24590), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597538] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18523), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [597551] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597564] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597577] = 5,
    ACTIONS(14384), 1,
      anon_sym_RBRACE,
    ACTIONS(24592), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17288), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597596] = 4,
    STATE(2486), 1,
      sym__colon2,
    STATE(16027), 1,
      sym__type_annotation,
    ACTIONS(17897), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597613] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22790), 1,
      sym_variable,
    STATE(22904), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597632] = 5,
    ACTIONS(14924), 1,
      anon_sym_RBRACE,
    ACTIONS(24594), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597651] = 5,
    ACTIONS(3311), 1,
      sym__conid,
    STATE(4280), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597670] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22790), 1,
      sym_variable,
    STATE(22931), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597689] = 5,
    ACTIONS(12009), 1,
      anon_sym_RBRACE,
    ACTIONS(24596), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597708] = 5,
    ACTIONS(4617), 1,
      sym__conid,
    STATE(4483), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597727] = 5,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    ACTIONS(24598), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597746] = 5,
    ACTIONS(14731), 1,
      anon_sym_RBRACE,
    ACTIONS(24600), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597765] = 5,
    ACTIONS(11735), 1,
      anon_sym_RBRACE,
    ACTIONS(24602), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597797] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15549), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [597810] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597823] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21703), 1,
      anon_sym_LPAREN,
    STATE(15529), 1,
      sym_variable,
    STATE(20082), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597842] = 5,
    ACTIONS(1261), 1,
      anon_sym_RBRACE,
    ACTIONS(24604), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597861] = 5,
    ACTIONS(14922), 1,
      anon_sym_RBRACE,
    ACTIONS(24606), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597880] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [597893] = 5,
    ACTIONS(14775), 1,
      anon_sym_RBRACE,
    ACTIONS(24608), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597912] = 5,
    ACTIONS(14775), 1,
      anon_sym_RBRACE,
    ACTIONS(24608), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17607), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597931] = 4,
    ACTIONS(761), 1,
      sym__layout_end,
    STATE(17639), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24610), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597948] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23729), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [597961] = 5,
    ACTIONS(761), 1,
      anon_sym_RBRACE,
    ACTIONS(24612), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17643), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597980] = 5,
    ACTIONS(14922), 1,
      anon_sym_RBRACE,
    ACTIONS(24606), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17601), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [597999] = 4,
    ACTIONS(14922), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24614), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598016] = 4,
    ACTIONS(14775), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24616), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598033] = 5,
    ACTIONS(12094), 1,
      anon_sym_RBRACE,
    ACTIONS(24618), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598052] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21158), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
  [598065] = 5,
    ACTIONS(12094), 1,
      anon_sym_RBRACE,
    ACTIONS(24618), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17604), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598084] = 4,
    ACTIONS(12094), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24620), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598101] = 5,
    ACTIONS(11903), 1,
      anon_sym_RBRACE,
    ACTIONS(24622), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598120] = 4,
    ACTIONS(21584), 1,
      anon_sym_in,
    STATE(17285), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(24624), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598137] = 5,
    ACTIONS(11903), 1,
      anon_sym_RBRACE,
    ACTIONS(24622), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17608), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598156] = 5,
    ACTIONS(15293), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(14742), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598175] = 4,
    ACTIONS(10939), 1,
      sym__layout_end,
    STATE(17650), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24626), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598192] = 4,
    ACTIONS(11903), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24628), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598209] = 5,
    ACTIONS(10939), 1,
      anon_sym_RBRACE,
    ACTIONS(24630), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17654), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598228] = 4,
    ACTIONS(13819), 1,
      sym__layout_end,
    STATE(17656), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24632), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598245] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21596), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [598258] = 5,
    ACTIONS(13819), 1,
      anon_sym_RBRACE,
    ACTIONS(24634), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17660), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598277] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17575), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [598290] = 4,
    ACTIONS(1203), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24636), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598307] = 5,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(21703), 1,
      anon_sym_LPAREN,
    STATE(15529), 1,
      sym_variable,
    STATE(20178), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598326] = 5,
    ACTIONS(1203), 1,
      anon_sym_RBRACE,
    ACTIONS(24638), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17663), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598345] = 5,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    ACTIONS(24640), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598364] = 5,
    ACTIONS(1203), 1,
      anon_sym_RBRACE,
    ACTIONS(24638), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598383] = 5,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    ACTIONS(24642), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598402] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [598415] = 5,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    ACTIONS(24640), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17613), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598434] = 4,
    ACTIONS(24646), 1,
      anon_sym_EQ,
    STATE(3148), 1,
      sym__larrow,
    ACTIONS(24644), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598451] = 5,
    ACTIONS(13815), 1,
      anon_sym_RBRACE,
    ACTIONS(24648), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17616), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598470] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21395), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [598483] = 4,
    ACTIONS(12128), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24650), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598500] = 5,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    ACTIONS(24642), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17606), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598519] = 5,
    ACTIONS(12128), 1,
      anon_sym_RBRACE,
    ACTIONS(24652), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17668), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598538] = 4,
    ACTIONS(13815), 1,
      sym__layout_end,
    STATE(17623), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24654), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598555] = 5,
    ACTIONS(12128), 1,
      anon_sym_RBRACE,
    ACTIONS(24652), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598574] = 5,
    ACTIONS(10931), 1,
      anon_sym_RBRACE,
    ACTIONS(24656), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17628), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598593] = 4,
    ACTIONS(14845), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24658), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598610] = 4,
    ACTIONS(1165), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24660), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598627] = 5,
    ACTIONS(14845), 1,
      anon_sym_RBRACE,
    ACTIONS(24662), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17671), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598646] = 5,
    ACTIONS(17797), 1,
      anon_sym_RBRACE,
    ACTIONS(24664), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17280), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598665] = 5,
    ACTIONS(14845), 1,
      anon_sym_RBRACE,
    ACTIONS(24662), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598684] = 5,
    ACTIONS(14241), 1,
      anon_sym_RBRACE,
    ACTIONS(24666), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17614), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598703] = 4,
    ACTIONS(10931), 1,
      sym__layout_end,
    STATE(17633), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24668), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598720] = 5,
    ACTIONS(1201), 1,
      anon_sym_RBRACE,
    ACTIONS(24670), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598739] = 4,
    ACTIONS(437), 1,
      sym__varsym,
    ACTIONS(18948), 1,
      anon_sym_DASH,
    STATE(23239), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598756] = 4,
    ACTIONS(14241), 1,
      sym__layout_end,
    STATE(17622), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24672), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598773] = 5,
    ACTIONS(15325), 1,
      sym__conid,
    STATE(14419), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598792] = 5,
    ACTIONS(15307), 1,
      sym__conid,
    STATE(14593), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598811] = 5,
    ACTIONS(12134), 1,
      anon_sym_RBRACE,
    ACTIONS(24674), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598830] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(23781), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [598843] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21846), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [598856] = 5,
    ACTIONS(14853), 1,
      anon_sym_RBRACE,
    ACTIONS(24676), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598875] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22502), 1,
      sym_variable,
    STATE(23234), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598894] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [598907] = 5,
    ACTIONS(1067), 1,
      anon_sym_RBRACE,
    ACTIONS(24678), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17642), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598926] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21662), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [598939] = 5,
    ACTIONS(11228), 1,
      anon_sym_RBRACE,
    ACTIONS(24680), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17624), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [598958] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15448), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [598971] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15545), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [598984] = 4,
    ACTIONS(1067), 1,
      sym__layout_end,
    STATE(17582), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24682), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599001] = 4,
    ACTIONS(24684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(24686), 1,
      sym__arith_dotdot,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599018] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15575), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599031] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599044] = 4,
    ACTIONS(11228), 1,
      sym__layout_end,
    STATE(17627), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24688), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599061] = 5,
    ACTIONS(17797), 1,
      anon_sym_RBRACE,
    ACTIONS(24664), 1,
      anon_sym_SEMI,
    STATE(2022), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17269), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599080] = 5,
    ACTIONS(12316), 1,
      anon_sym_RBRACE,
    ACTIONS(24690), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599099] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [599112] = 5,
    ACTIONS(13414), 1,
      sym__conid,
    STATE(8410), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599131] = 5,
    ACTIONS(789), 1,
      anon_sym_RBRACE,
    ACTIONS(24692), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17644), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599150] = 4,
    ACTIONS(789), 1,
      sym__layout_end,
    STATE(17657), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24694), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599167] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [599180] = 5,
    ACTIONS(4873), 1,
      sym__conid,
    STATE(10406), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599199] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18523), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [599212] = 4,
    STATE(2477), 1,
      sym__colon2,
    STATE(13638), 1,
      sym__type_annotation,
    ACTIONS(18451), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599229] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [599242] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15565), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599255] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14273), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599268] = 3,
    ACTIONS(21598), 1,
      anon_sym_in,
    ACTIONS(21596), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599283] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15571), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599296] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15557), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599309] = 5,
    ACTIONS(8676), 1,
      sym__conid,
    STATE(6611), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599328] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15595), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [599341] = 5,
    ACTIONS(19453), 1,
      sym__varid,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22975), 1,
      sym_variable,
    STATE(23173), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599360] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(24696), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [599373] = 4,
    STATE(2508), 1,
      sym__colon2,
    STATE(16725), 1,
      sym__type_annotation,
    ACTIONS(18539), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599390] = 4,
    STATE(2440), 1,
      sym__colon2,
    STATE(13207), 1,
      sym__type_annotation,
    ACTIONS(17905), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599407] = 3,
    ACTIONS(24700), 1,
      sym_where,
    ACTIONS(24698), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [599435] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15405), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599448] = 5,
    ACTIONS(8293), 1,
      sym__conid,
    STATE(6101), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599467] = 4,
    ACTIONS(12177), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24702), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599484] = 5,
    ACTIONS(7901), 1,
      sym__conid,
    STATE(6601), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599503] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [599516] = 4,
    ACTIONS(1063), 1,
      sym__layout_end,
    STATE(17726), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24704), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599533] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15656), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599546] = 5,
    ACTIONS(1063), 1,
      anon_sym_RBRACE,
    ACTIONS(24706), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17732), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599565] = 5,
    ACTIONS(5706), 1,
      sym__conid,
    STATE(7508), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599584] = 5,
    ACTIONS(8836), 1,
      sym__conid,
    STATE(6683), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599603] = 4,
    STATE(2460), 1,
      sym__colon2,
    STATE(17690), 1,
      sym__type_annotation,
    ACTIONS(18083), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599620] = 3,
    ACTIONS(24708), 1,
      sym_where,
    ACTIONS(24698), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599635] = 5,
    ACTIONS(10864), 1,
      sym__conid,
    STATE(8648), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599654] = 4,
    ACTIONS(10935), 1,
      sym__layout_end,
    STATE(17710), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24710), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599671] = 5,
    ACTIONS(9390), 1,
      sym__conid,
    STATE(11139), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599690] = 5,
    ACTIONS(10935), 1,
      anon_sym_RBRACE,
    ACTIONS(24712), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17778), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599709] = 4,
    ACTIONS(13827), 1,
      sym__layout_end,
    STATE(17780), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24714), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599726] = 5,
    ACTIONS(13827), 1,
      anon_sym_RBRACE,
    ACTIONS(24716), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17785), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599745] = 4,
    ACTIONS(1247), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24718), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15553), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599775] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15515), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599788] = 5,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(24720), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17788), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599807] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [599820] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15510), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599833] = 5,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(24720), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21582), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [599865] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [599878] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [599891] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [599904] = 4,
    ACTIONS(769), 1,
      sym__layout_end,
    STATE(17758), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24722), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599921] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15561), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599934] = 5,
    ACTIONS(769), 1,
      anon_sym_RBRACE,
    ACTIONS(24724), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17762), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599953] = 5,
    ACTIONS(14875), 1,
      anon_sym_RBRACE,
    ACTIONS(24726), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [599972] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15583), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [599985] = 5,
    ACTIONS(8516), 1,
      sym__conid,
    STATE(6290), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600004] = 5,
    ACTIONS(12284), 1,
      anon_sym_RBRACE,
    ACTIONS(24728), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600023] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15624), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600036] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [600049] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15506), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600062] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15502), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600075] = 5,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    ACTIONS(24730), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600094] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15591), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600107] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14070), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600120] = 4,
    ACTIONS(10907), 1,
      sym__layout_end,
    STATE(17769), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24732), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600137] = 5,
    ACTIONS(12177), 1,
      anon_sym_RBRACE,
    ACTIONS(24734), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17794), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600156] = 5,
    ACTIONS(10907), 1,
      anon_sym_RBRACE,
    ACTIONS(24736), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17773), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600175] = 4,
    ACTIONS(13980), 1,
      sym__layout_end,
    STATE(17775), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24738), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600192] = 5,
    ACTIONS(14869), 1,
      anon_sym_RBRACE,
    ACTIONS(24740), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600211] = 5,
    ACTIONS(13980), 1,
      anon_sym_RBRACE,
    ACTIONS(24742), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17779), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600230] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15628), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600243] = 4,
    ACTIONS(1185), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24744), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600260] = 5,
    ACTIONS(14869), 1,
      anon_sym_RBRACE,
    ACTIONS(24740), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17740), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600279] = 5,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    ACTIONS(24746), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17782), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600298] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15613), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600311] = 5,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    ACTIONS(24746), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600330] = 4,
    ACTIONS(14869), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24748), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600347] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15617), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600360] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21914), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [600373] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15632), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600386] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15636), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600399] = 5,
    ACTIONS(12296), 1,
      anon_sym_RBRACE,
    ACTIONS(24750), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600418] = 4,
    ACTIONS(12377), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24752), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600435] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15494), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600448] = 5,
    ACTIONS(12377), 1,
      anon_sym_RBRACE,
    ACTIONS(24754), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17787), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600467] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15607), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [600480] = 5,
    ACTIONS(12377), 1,
      anon_sym_RBRACE,
    ACTIONS(24754), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600499] = 5,
    ACTIONS(12296), 1,
      anon_sym_RBRACE,
    ACTIONS(24750), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17743), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600518] = 4,
    ACTIONS(14857), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24756), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600535] = 4,
    ACTIONS(12296), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24758), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600552] = 5,
    ACTIONS(14857), 1,
      anon_sym_RBRACE,
    ACTIONS(24760), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17790), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600571] = 5,
    ACTIONS(12177), 1,
      anon_sym_RBRACE,
    ACTIONS(24734), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600590] = 5,
    ACTIONS(14857), 1,
      anon_sym_RBRACE,
    ACTIONS(24760), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600609] = 4,
    ACTIONS(14735), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24762), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600626] = 5,
    ACTIONS(14474), 1,
      anon_sym_RBRACE,
    ACTIONS(24764), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600645] = 5,
    ACTIONS(1177), 1,
      anon_sym_RBRACE,
    ACTIONS(24766), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600664] = 5,
    ACTIONS(14735), 1,
      anon_sym_RBRACE,
    ACTIONS(24768), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17834), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600683] = 5,
    ACTIONS(11729), 1,
      anon_sym_RBRACE,
    ACTIONS(24770), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600702] = 5,
    ACTIONS(14735), 1,
      anon_sym_RBRACE,
    ACTIONS(24768), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600721] = 5,
    ACTIONS(1131), 1,
      anon_sym_RBRACE,
    ACTIONS(24772), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600740] = 5,
    ACTIONS(12375), 1,
      anon_sym_RBRACE,
    ACTIONS(24774), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600759] = 5,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(24776), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600778] = 5,
    ACTIONS(14472), 1,
      anon_sym_RBRACE,
    ACTIONS(24778), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600797] = 5,
    ACTIONS(14865), 1,
      anon_sym_RBRACE,
    ACTIONS(24780), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600816] = 4,
    ACTIONS(22882), 1,
      anon_sym_LPAREN,
    STATE(20808), 1,
      sym_import_con_names,
    ACTIONS(24782), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600833] = 5,
    ACTIONS(14472), 1,
      anon_sym_RBRACE,
    ACTIONS(24778), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17781), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600852] = 4,
    ACTIONS(14472), 1,
      sym__layout_end,
    STATE(16611), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24784), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600869] = 5,
    ACTIONS(12235), 1,
      anon_sym_RBRACE,
    ACTIONS(24786), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600888] = 5,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    ACTIONS(24788), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16622), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600907] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18612), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [600920] = 5,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    ACTIONS(24788), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17784), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600939] = 5,
    ACTIONS(8442), 1,
      sym__conid,
    STATE(7212), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600958] = 4,
    ACTIONS(11719), 1,
      sym__layout_end,
    STATE(16656), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24790), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600975] = 5,
    ACTIONS(8201), 1,
      sym__conid,
    STATE(5496), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [600994] = 5,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    ACTIONS(24792), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601013] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [601026] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18639), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [601039] = 5,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    ACTIONS(24792), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17786), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601058] = 5,
    ACTIONS(11085), 1,
      sym__conid,
    STATE(8268), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601077] = 4,
    ACTIONS(1123), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24794), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601094] = 5,
    ACTIONS(14436), 1,
      anon_sym_RBRACE,
    ACTIONS(24796), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17789), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601113] = 4,
    ACTIONS(14436), 1,
      sym__layout_end,
    STATE(17793), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24798), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601130] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [601143] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18665), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [601156] = 5,
    ACTIONS(11626), 1,
      anon_sym_RBRACE,
    ACTIONS(24800), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17795), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601175] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15603), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [601188] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18626), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [601201] = 4,
    ACTIONS(11626), 1,
      sym__layout_end,
    STATE(17799), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24802), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601218] = 5,
    ACTIONS(13173), 1,
      sym__conid,
    STATE(9341), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601237] = 4,
    STATE(2501), 1,
      sym__colon2,
    STATE(13343), 1,
      sym__type_annotation,
    ACTIONS(18271), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601254] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(21846), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [601267] = 5,
    ACTIONS(12945), 1,
      sym__conid,
    STATE(8869), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601286] = 5,
    ACTIONS(717), 1,
      anon_sym_RBRACE,
    ACTIONS(24804), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17801), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601305] = 4,
    ACTIONS(717), 1,
      sym__layout_end,
    STATE(17806), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24806), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601322] = 5,
    ACTIONS(12980), 1,
      sym__conid,
    STATE(9239), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601341] = 4,
    STATE(2488), 1,
      sym__colon2,
    STATE(18163), 1,
      sym__type_annotation,
    ACTIONS(21381), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601358] = 5,
    ACTIONS(15742), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15416), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601377] = 4,
    ACTIONS(22074), 1,
      anon_sym_LPAREN,
    STATE(20671), 1,
      sym_export_names,
    ACTIONS(24808), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601394] = 4,
    ACTIONS(781), 1,
      sym__layout_end,
    STATE(17835), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24810), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601411] = 5,
    ACTIONS(16004), 1,
      sym__conid,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(15833), 1,
      sym_constructor,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601430] = 5,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(24812), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17838), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601449] = 5,
    ACTIONS(8285), 1,
      sym__conid,
    STATE(6079), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601468] = 4,
    ACTIONS(10890), 1,
      sym__layout_end,
    STATE(17776), 1,
      aux_sym_alts_repeat2,
    ACTIONS(24814), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601485] = 5,
    ACTIONS(15387), 1,
      sym__conid,
    STATE(14165), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601504] = 5,
    ACTIONS(10890), 1,
      anon_sym_RBRACE,
    ACTIONS(24816), 1,
      anon_sym_SEMI,
    STATE(2852), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17768), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601523] = 4,
    ACTIONS(14050), 1,
      sym__layout_end,
    STATE(17763), 1,
      aux_sym_nalts_repeat2,
    ACTIONS(24818), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601540] = 5,
    ACTIONS(14050), 1,
      anon_sym_RBRACE,
    ACTIONS(24820), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17755), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601559] = 5,
    ACTIONS(14729), 1,
      anon_sym_RBRACE,
    ACTIONS(24822), 1,
      anon_sym_SEMI,
    STATE(3281), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16586), 1,
      aux_sym_nalts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601578] = 4,
    ACTIONS(1169), 1,
      sym__layout_end,
    STATE(16831), 1,
      aux_sym_rec_repeat2,
    ACTIONS(24824), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601595] = 5,
    ACTIONS(1169), 1,
      anon_sym_RBRACE,
    ACTIONS(24826), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(17748), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601614] = 5,
    ACTIONS(2031), 1,
      sym__conid,
    STATE(7034), 1,
      sym_constructor,
    STATE(14671), 1,
      aux_sym__qualifying_module,
    STATE(23316), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601633] = 5,
    ACTIONS(1169), 1,
      anon_sym_RBRACE,
    ACTIONS(24826), 1,
      anon_sym_SEMI,
    STATE(123), 1,
      aux_sym_decl_tyfam_repeat1,
    STATE(16827), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601652] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15579), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_deriving,
  [601665] = 4,
    ACTIONS(24828), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601681] = 4,
    ACTIONS(24832), 1,
      anon_sym_RBRACK,
    ACTIONS(24834), 1,
      sym_comma,
    STATE(18802), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601697] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24836), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601713] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24838), 1,
      anon_sym_RBRACK,
    STATE(17867), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601729] = 2,
    ACTIONS(15341), 3,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601741] = 2,
    ACTIONS(18691), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601753] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(24840), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601769] = 3,
    ACTIONS(24844), 1,
      sym_quasiquote_body,
    ACTIONS(24842), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601783] = 2,
    ACTIONS(24270), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601795] = 2,
    ACTIONS(21912), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601807] = 4,
    ACTIONS(24846), 1,
      anon_sym_LBRACE,
    ACTIONS(24848), 1,
      sym__layout_start,
    STATE(13398), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601823] = 2,
    ACTIONS(24850), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601835] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(7506), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601849] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15345), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601863] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15405), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601877] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(24852), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601893] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(15413), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601907] = 3,
    ACTIONS(24856), 1,
      sym_quasiquote_body,
    ACTIONS(24854), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601921] = 4,
    ACTIONS(24858), 1,
      anon_sym_RPAREN,
    ACTIONS(24860), 1,
      sym_comma,
    STATE(17891), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601937] = 4,
    ACTIONS(24862), 1,
      anon_sym_RBRACE,
    ACTIONS(24864), 1,
      sym_comma,
    STATE(17882), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601953] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(24866), 1,
      anon_sym_RBRACK,
    STATE(17895), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601969] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(24870), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601985] = 3,
    STATE(18291), 1,
      sym__carrow,
    ACTIONS(24872), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [601999] = 4,
    ACTIONS(24874), 1,
      anon_sym_RBRACK,
    ACTIONS(24876), 1,
      sym_comma,
    STATE(17886), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602015] = 2,
    ACTIONS(15341), 3,
      sym__dot,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602027] = 2,
    ACTIONS(24878), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602039] = 3,
    ACTIONS(24882), 1,
      sym_quasiquote_body,
    ACTIONS(24880), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602053] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24884), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602069] = 4,
    ACTIONS(24886), 1,
      anon_sym_LBRACE,
    ACTIONS(24888), 1,
      sym__layout_start,
    STATE(13385), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602085] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(24890), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602101] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(24892), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602117] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(24894), 1,
      anon_sym_RPAREN,
    STATE(17861), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602133] = 2,
    ACTIONS(24085), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602145] = 2,
    ACTIONS(24896), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602157] = 2,
    ACTIONS(21353), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602169] = 3,
    STATE(1641), 1,
      sym__arrow,
    ACTIONS(24898), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602183] = 3,
    ACTIONS(24902), 1,
      sym_quasiquote_body,
    ACTIONS(24900), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602197] = 4,
    ACTIONS(24904), 1,
      anon_sym_RBRACK,
    ACTIONS(24906), 1,
      sym_comma,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602213] = 2,
    ACTIONS(24908), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602225] = 3,
    ACTIONS(24912), 1,
      sym_quasiquote_body,
    ACTIONS(24910), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602239] = 2,
    ACTIONS(24914), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602251] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(24916), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602267] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(24918), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602283] = 3,
    ACTIONS(24922), 1,
      sym_quasiquote_body,
    ACTIONS(24920), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602297] = 3,
    ACTIONS(24926), 1,
      sym_quasiquote_body,
    ACTIONS(24924), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602311] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24928), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602327] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(24930), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602343] = 2,
    ACTIONS(23221), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602355] = 4,
    ACTIONS(3127), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602371] = 3,
    ACTIONS(24934), 1,
      sym_quasiquote_body,
    ACTIONS(24932), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602385] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(24936), 1,
      anon_sym_RPAREN,
    STATE(17918), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602401] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(24938), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602417] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(24940), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602433] = 4,
    ACTIONS(24437), 1,
      sym__unboxed_close,
    ACTIONS(24942), 1,
      sym_comma,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602449] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(24945), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602465] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(24947), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602481] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(24949), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602497] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24951), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602513] = 2,
    ACTIONS(23725), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602525] = 2,
    ACTIONS(24953), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602537] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(24955), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602553] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24957), 1,
      anon_sym_RBRACK,
    STATE(17927), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602569] = 4,
    ACTIONS(21469), 1,
      sym__varid,
    ACTIONS(24959), 1,
      anon_sym_LPAREN,
    STATE(14767), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602585] = 4,
    ACTIONS(24961), 1,
      sym__conid,
    STATE(3735), 1,
      sym_constructor,
    STATE(15432), 1,
      sym_newtype_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602601] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(24963), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602617] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(24965), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602633] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(24967), 1,
      anon_sym_RBRACK,
    STATE(17894), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602649] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(24969), 1,
      anon_sym_RBRACE,
    STATE(17944), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602665] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(24971), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602681] = 4,
    ACTIONS(24973), 1,
      anon_sym_RBRACE,
    ACTIONS(24975), 1,
      sym_comma,
    STATE(17945), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602697] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(24977), 1,
      anon_sym_RBRACE,
    STATE(17896), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602713] = 2,
    ACTIONS(21534), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602725] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(24979), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602741] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(24981), 1,
      anon_sym_RPAREN,
    STATE(18144), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602757] = 2,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602769] = 2,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602781] = 3,
    ACTIONS(24983), 1,
      sym_where,
    ACTIONS(24336), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602795] = 2,
    ACTIONS(24985), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602807] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(24987), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602823] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24989), 1,
      anon_sym_RBRACK,
    STATE(17885), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602839] = 2,
    ACTIONS(24991), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602851] = 3,
    ACTIONS(24995), 1,
      sym_quasiquote_body,
    ACTIONS(24993), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602865] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(24997), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602881] = 3,
    ACTIONS(25001), 1,
      sym_quasiquote_body,
    ACTIONS(24999), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602895] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25003), 1,
      anon_sym_RBRACK,
    STATE(17946), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602911] = 2,
    ACTIONS(25005), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602923] = 3,
    STATE(10504), 1,
      sym__arrow,
    ACTIONS(25007), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602937] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25009), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602953] = 2,
    ACTIONS(24985), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602965] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25011), 1,
      anon_sym_RBRACE,
    STATE(18002), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602981] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25013), 1,
      anon_sym_RBRACK,
    STATE(18166), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [602997] = 4,
    ACTIONS(25015), 1,
      anon_sym_LBRACE,
    ACTIONS(25017), 1,
      sym__layout_start,
    STATE(6253), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603013] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25019), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603029] = 3,
    ACTIONS(25021), 1,
      sym_where,
    ACTIONS(24258), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603043] = 2,
    ACTIONS(25023), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603055] = 2,
    ACTIONS(21214), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603067] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25025), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603083] = 4,
    ACTIONS(15730), 1,
      sym__varid,
    ACTIONS(25027), 1,
      anon_sym_LPAREN,
    STATE(17765), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603099] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25029), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603115] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25031), 1,
      anon_sym_RPAREN,
    STATE(17908), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603131] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25033), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603147] = 2,
    ACTIONS(21224), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603159] = 4,
    ACTIONS(20201), 1,
      anon_sym_RPAREN,
    ACTIONS(25035), 1,
      sym_comma,
    STATE(17952), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603175] = 4,
    ACTIONS(25037), 1,
      anon_sym_RPAREN,
    ACTIONS(25039), 1,
      sym_comma,
    STATE(17963), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603191] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25041), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603207] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25043), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603223] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25045), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603239] = 3,
    ACTIONS(25049), 1,
      sym_quasiquote_body,
    ACTIONS(25047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603253] = 4,
    ACTIONS(3262), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603269] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25051), 1,
      anon_sym_RPAREN,
    STATE(17980), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603285] = 3,
    ACTIONS(25055), 1,
      sym_quasiquote_body,
    ACTIONS(25053), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603299] = 4,
    ACTIONS(21469), 1,
      sym__varid,
    ACTIONS(25057), 1,
      anon_sym_LPAREN,
    STATE(14942), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603315] = 4,
    ACTIONS(20387), 1,
      anon_sym_RPAREN,
    ACTIONS(25059), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603331] = 2,
    ACTIONS(25061), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603343] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25063), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603359] = 4,
    ACTIONS(20387), 1,
      anon_sym_RPAREN,
    ACTIONS(25059), 1,
      sym_comma,
    STATE(17960), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603375] = 4,
    ACTIONS(25065), 1,
      anon_sym_RPAREN,
    ACTIONS(25067), 1,
      sym_comma,
    STATE(17971), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603391] = 3,
    ACTIONS(20910), 1,
      sym__varid,
    STATE(14364), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603405] = 2,
    ACTIONS(21158), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603417] = 3,
    STATE(10548), 1,
      sym__carrow,
    ACTIONS(25069), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603431] = 4,
    ACTIONS(20195), 1,
      anon_sym_RPAREN,
    ACTIONS(25071), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603447] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25073), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603463] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25075), 1,
      anon_sym_RBRACK,
    STATE(17986), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603479] = 4,
    ACTIONS(25039), 1,
      sym_comma,
    ACTIONS(25077), 1,
      anon_sym_RPAREN,
    STATE(19990), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603495] = 4,
    ACTIONS(25079), 1,
      anon_sym_LBRACE,
    ACTIONS(25081), 1,
      sym__layout_start,
    STATE(6623), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603511] = 2,
    ACTIONS(21596), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603523] = 2,
    ACTIONS(22014), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603535] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25083), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603551] = 4,
    ACTIONS(25085), 1,
      anon_sym_RBRACE,
    ACTIONS(25087), 1,
      sym_comma,
    STATE(17993), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603567] = 3,
    STATE(1310), 1,
      sym__arrow,
    ACTIONS(25089), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603581] = 2,
    ACTIONS(25091), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603593] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25093), 1,
      anon_sym_RPAREN,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603609] = 2,
    ACTIONS(21624), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603621] = 4,
    ACTIONS(25095), 1,
      anon_sym_LBRACE,
    ACTIONS(25097), 1,
      sym__layout_start,
    STATE(5515), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603637] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25099), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603653] = 2,
    ACTIONS(21234), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603665] = 2,
    ACTIONS(23138), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603677] = 2,
    ACTIONS(21670), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603689] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25101), 1,
      anon_sym_RBRACE,
    STATE(18001), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603705] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25103), 1,
      anon_sym_RPAREN,
    STATE(17997), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603721] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25105), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603737] = 3,
    ACTIONS(15417), 1,
      sym__varid,
    STATE(15268), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603751] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25107), 1,
      anon_sym_RBRACK,
    STATE(18005), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603767] = 2,
    ACTIONS(25109), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603779] = 2,
    ACTIONS(25111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603791] = 2,
    ACTIONS(18626), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603803] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25113), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603819] = 2,
    ACTIONS(25115), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603831] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25117), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603847] = 3,
    ACTIONS(25121), 1,
      sym_quasiquote_body,
    ACTIONS(25119), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603861] = 3,
    ACTIONS(25125), 1,
      sym_quasiquote_body,
    ACTIONS(25123), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603875] = 2,
    ACTIONS(25127), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603887] = 2,
    ACTIONS(25129), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603899] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(25131), 1,
      anon_sym_RBRACE,
    STATE(18766), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603915] = 2,
    ACTIONS(25133), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603927] = 2,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603939] = 2,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603951] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25135), 1,
      anon_sym_RPAREN,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603967] = 2,
    ACTIONS(21201), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603979] = 2,
    ACTIONS(18612), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [603991] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25137), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604007] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25139), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604023] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25141), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604039] = 3,
    ACTIONS(25145), 1,
      sym_quasiquote_body,
    ACTIONS(25143), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604053] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25147), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604069] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25149), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604085] = 3,
    ACTIONS(25153), 1,
      sym_quasiquote_body,
    ACTIONS(25151), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604099] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25155), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604115] = 4,
    ACTIONS(25157), 1,
      anon_sym_LPAREN,
    ACTIONS(25159), 1,
      sym_where,
    STATE(22566), 1,
      sym_exports,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604131] = 2,
    ACTIONS(25161), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604143] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25163), 1,
      anon_sym_RPAREN,
    STATE(18030), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604159] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25165), 1,
      anon_sym_RBRACK,
    STATE(18000), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604175] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25167), 1,
      anon_sym_RBRACK,
    STATE(18039), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604191] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25169), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604207] = 3,
    STATE(10235), 1,
      sym__carrow,
    ACTIONS(25171), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604221] = 4,
    ACTIONS(25173), 1,
      anon_sym_LBRACE,
    ACTIONS(25175), 1,
      sym__layout_start,
    STATE(4631), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604237] = 3,
    STATE(1578), 1,
      sym__arrow,
    ACTIONS(25177), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604251] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25179), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604267] = 2,
    ACTIONS(25181), 3,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604279] = 2,
    ACTIONS(25183), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604291] = 2,
    ACTIONS(25185), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604303] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25187), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604319] = 2,
    ACTIONS(25189), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604331] = 2,
    ACTIONS(25191), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604343] = 3,
    ACTIONS(25195), 1,
      sym_quasiquote_body,
    ACTIONS(25193), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604357] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25197), 1,
      anon_sym_RBRACK,
    STATE(18007), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604373] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25199), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604389] = 2,
    ACTIONS(25201), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604401] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25203), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604417] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25205), 1,
      anon_sym_RPAREN,
    STATE(18065), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604433] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25207), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604449] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25209), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604465] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25211), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604481] = 2,
    ACTIONS(23609), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604493] = 2,
    ACTIONS(25213), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604505] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25215), 1,
      anon_sym_RPAREN,
    STATE(18013), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604521] = 2,
    ACTIONS(23607), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604533] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25217), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604549] = 3,
    ACTIONS(25221), 1,
      sym_quasiquote_body,
    ACTIONS(25219), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604563] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25223), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604579] = 3,
    ACTIONS(25227), 1,
      sym_quasiquote_body,
    ACTIONS(25225), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604593] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25229), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604609] = 3,
    ACTIONS(25233), 1,
      sym_quasiquote_body,
    ACTIONS(25231), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604623] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25235), 1,
      anon_sym_RBRACK,
    STATE(18071), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604639] = 4,
    ACTIONS(21197), 1,
      sym__varid,
    ACTIONS(25237), 1,
      anon_sym_LPAREN,
    STATE(14167), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604655] = 4,
    ACTIONS(24961), 1,
      sym__conid,
    STATE(3727), 1,
      sym_constructor,
    STATE(16023), 1,
      sym_newtype_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604671] = 4,
    ACTIONS(25039), 1,
      sym_comma,
    ACTIONS(25239), 1,
      anon_sym_RPAREN,
    STATE(18077), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604687] = 2,
    ACTIONS(25241), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604699] = 2,
    ACTIONS(25243), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604711] = 2,
    ACTIONS(25245), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604723] = 4,
    ACTIONS(25247), 1,
      anon_sym_LBRACE,
    ACTIONS(25249), 1,
      sym__layout_start,
    STATE(10667), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604739] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25251), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604755] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25253), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604771] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25255), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604787] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25257), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604803] = 4,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(25259), 1,
      sym__unboxed_close,
    STATE(18413), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604819] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25261), 1,
      anon_sym_RBRACE,
    STATE(18078), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604835] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25263), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604851] = 2,
    ACTIONS(21328), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604863] = 4,
    ACTIONS(25265), 1,
      anon_sym_LBRACE,
    ACTIONS(25267), 1,
      sym__layout_start,
    STATE(12990), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604879] = 2,
    ACTIONS(24374), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604891] = 4,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(25269), 1,
      sym__unboxed_close,
    STATE(18416), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604907] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25271), 1,
      anon_sym_RBRACE,
    STATE(18082), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604923] = 4,
    ACTIONS(19169), 1,
      sym__varid,
    ACTIONS(25273), 1,
      anon_sym_LPAREN,
    STATE(18419), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604939] = 2,
    ACTIONS(23907), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604951] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25275), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604967] = 3,
    ACTIONS(25279), 1,
      sym_quasiquote_body,
    ACTIONS(25277), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604981] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25281), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [604997] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25283), 1,
      anon_sym_RPAREN,
    STATE(18099), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605013] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25285), 1,
      anon_sym_RBRACK,
    STATE(18087), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605029] = 4,
    ACTIONS(24231), 1,
      sym__unboxed_close,
    ACTIONS(25287), 1,
      sym_comma,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605045] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25290), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605061] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25292), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605077] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25294), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605093] = 4,
    ACTIONS(15992), 1,
      sym__varid,
    ACTIONS(25296), 1,
      anon_sym_LPAREN,
    STATE(19196), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605109] = 2,
    ACTIONS(25298), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605121] = 4,
    ACTIONS(20271), 1,
      anon_sym_RPAREN,
    ACTIONS(25300), 1,
      sym_comma,
    STATE(18091), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605137] = 4,
    ACTIONS(25039), 1,
      sym_comma,
    ACTIONS(25302), 1,
      anon_sym_RPAREN,
    STATE(19990), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605153] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25304), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605169] = 2,
    ACTIONS(24223), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605181] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25306), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605197] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25308), 1,
      anon_sym_RBRACK,
    STATE(18105), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605213] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25310), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605229] = 3,
    ACTIONS(25314), 1,
      sym_quasiquote_body,
    ACTIONS(25312), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605243] = 3,
    ACTIONS(25318), 1,
      sym_quasiquote_body,
    ACTIONS(25316), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605257] = 2,
    ACTIONS(25320), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605269] = 2,
    ACTIONS(24163), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605281] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25322), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605297] = 4,
    ACTIONS(21197), 1,
      sym__varid,
    ACTIONS(25324), 1,
      anon_sym_LPAREN,
    STATE(14486), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605313] = 2,
    ACTIONS(25320), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605325] = 2,
    ACTIONS(23410), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605337] = 4,
    ACTIONS(20308), 1,
      anon_sym_RPAREN,
    ACTIONS(25326), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605353] = 4,
    ACTIONS(20308), 1,
      anon_sym_RPAREN,
    ACTIONS(25326), 1,
      sym_comma,
    STATE(18103), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605369] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25328), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605385] = 2,
    ACTIONS(21344), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605397] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25330), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605413] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25332), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605429] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25334), 1,
      anon_sym_RBRACE,
    STATE(18120), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605445] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25336), 1,
      anon_sym_RPAREN,
    STATE(18109), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605461] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25338), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605477] = 3,
    ACTIONS(21160), 1,
      sym__varid,
    STATE(14567), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605491] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25340), 1,
      anon_sym_RBRACK,
    STATE(18124), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605507] = 2,
    ACTIONS(23919), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605519] = 4,
    ACTIONS(20336), 1,
      anon_sym_RPAREN,
    ACTIONS(25342), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605535] = 2,
    ACTIONS(23273), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605547] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25344), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605563] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(25346), 1,
      anon_sym_RBRACE,
    STATE(18116), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605579] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25348), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605595] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25350), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605611] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25352), 1,
      anon_sym_RPAREN,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605627] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25354), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605643] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25356), 1,
      anon_sym_RPAREN,
    STATE(18119), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605659] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25358), 1,
      anon_sym_RBRACK,
    STATE(18095), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605675] = 3,
    ACTIONS(25362), 1,
      sym_quasiquote_body,
    ACTIONS(25360), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605689] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25364), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605705] = 3,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(16065), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605719] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(25366), 1,
      anon_sym_RBRACE,
    STATE(18766), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605735] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25368), 1,
      anon_sym_RBRACE,
    STATE(18096), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605751] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25370), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605767] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(25372), 1,
      anon_sym_RPAREN,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605783] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25374), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605799] = 2,
    ACTIONS(21326), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605811] = 4,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605827] = 2,
    ACTIONS(21158), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605839] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25376), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605855] = 3,
    ACTIONS(25380), 1,
      sym_quasiquote_body,
    ACTIONS(25378), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605869] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25382), 1,
      anon_sym_RBRACK,
    STATE(18110), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605885] = 3,
    ACTIONS(25386), 1,
      sym_quasiquote_body,
    ACTIONS(25384), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605899] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25388), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605915] = 2,
    ACTIONS(18665), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605927] = 2,
    ACTIONS(18661), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605939] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25390), 1,
      anon_sym_RPAREN,
    STATE(18149), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605955] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25392), 1,
      anon_sym_RBRACK,
    STATE(18156), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605971] = 4,
    ACTIONS(25394), 1,
      anon_sym_LBRACE,
    ACTIONS(25396), 1,
      sym__layout_start,
    STATE(4671), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [605987] = 3,
    STATE(1377), 1,
      sym__arrow,
    ACTIONS(25398), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606001] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25400), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606017] = 2,
    ACTIONS(21351), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606029] = 2,
    ACTIONS(25402), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606041] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25404), 1,
      anon_sym_RPAREN,
    STATE(18114), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606057] = 4,
    ACTIONS(3260), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606073] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25406), 1,
      anon_sym_RPAREN,
    STATE(18496), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606089] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25408), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606105] = 3,
    ACTIONS(25412), 1,
      sym_quasiquote_body,
    ACTIONS(25410), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606119] = 3,
    ACTIONS(25416), 1,
      sym_quasiquote_body,
    ACTIONS(25414), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606133] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25418), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606149] = 2,
    ACTIONS(24083), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606161] = 4,
    ACTIONS(3238), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606177] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25420), 1,
      anon_sym_RPAREN,
    STATE(18177), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606193] = 2,
    ACTIONS(18639), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606205] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25422), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606221] = 2,
    ACTIONS(25424), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606233] = 2,
    ACTIONS(21582), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606245] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25426), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606261] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25428), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606277] = 4,
    ACTIONS(3244), 1,
      sym_comma,
    ACTIONS(25430), 1,
      anon_sym_RPAREN,
    STATE(18514), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606293] = 4,
    ACTIONS(25432), 1,
      anon_sym_RPAREN,
    ACTIONS(25434), 1,
      sym_comma,
    STATE(18155), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606309] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25437), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606325] = 4,
    ACTIONS(25439), 1,
      anon_sym_LBRACE,
    ACTIONS(25441), 1,
      sym__layout_start,
    STATE(6093), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606341] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25443), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606357] = 3,
    ACTIONS(25447), 1,
      sym_quasiquote_body,
    ACTIONS(25445), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606371] = 3,
    ACTIONS(25451), 1,
      sym_quasiquote_body,
    ACTIONS(25449), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606385] = 3,
    ACTIONS(25455), 1,
      sym_quasiquote_body,
    ACTIONS(25453), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606399] = 3,
    ACTIONS(25459), 1,
      sym_quasiquote_body,
    ACTIONS(25457), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606413] = 2,
    ACTIONS(18626), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606425] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25461), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606441] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25463), 1,
      anon_sym_RBRACK,
    STATE(18181), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606457] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25465), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606473] = 2,
    ACTIONS(25467), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606485] = 4,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(25469), 1,
      anon_sym_LPAREN,
    STATE(15669), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606501] = 4,
    ACTIONS(25471), 1,
      anon_sym_LBRACE,
    ACTIONS(25473), 1,
      sym__layout_start,
    STATE(6263), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606517] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25475), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606533] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25477), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606549] = 2,
    ACTIONS(25479), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606561] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25481), 1,
      anon_sym_RBRACE,
    STATE(18188), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606577] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25483), 1,
      anon_sym_RBRACE,
    STATE(18193), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606593] = 2,
    ACTIONS(21201), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606605] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25485), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606621] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25487), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606637] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25489), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606653] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25491), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606669] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25493), 1,
      anon_sym_RBRACK,
    STATE(18194), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606685] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25495), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606701] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25497), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606717] = 4,
    ACTIONS(25499), 1,
      sym__varid,
    ACTIONS(25501), 1,
      anon_sym_LPAREN,
    STATE(15668), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606733] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25503), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606749] = 3,
    ACTIONS(25507), 1,
      sym_quasiquote_body,
    ACTIONS(25505), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606763] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25509), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606779] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25511), 1,
      anon_sym_RPAREN,
    STATE(18218), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606795] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25513), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606811] = 2,
    ACTIONS(21873), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606823] = 2,
    ACTIONS(25515), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606835] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25517), 1,
      anon_sym_RBRACK,
    STATE(18558), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606851] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25519), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606867] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25521), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606883] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25523), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606899] = 4,
    ACTIONS(15347), 1,
      sym__varid,
    ACTIONS(25525), 1,
      anon_sym_LPAREN,
    STATE(15723), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606915] = 3,
    STATE(499), 1,
      sym__arrow,
    ACTIONS(20409), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606929] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(25527), 1,
      anon_sym_RBRACE,
    STATE(18203), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606945] = 2,
    ACTIONS(25529), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606957] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25531), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606973] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25533), 1,
      anon_sym_RBRACK,
    STATE(18224), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [606989] = 3,
    ACTIONS(21253), 1,
      sym__varid,
    STATE(14806), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607003] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25535), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607019] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(25537), 1,
      anon_sym_RBRACE,
    STATE(18766), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607035] = 2,
    ACTIONS(21500), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607047] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25539), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607063] = 2,
    ACTIONS(25541), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607075] = 3,
    ACTIONS(25545), 1,
      sym_quasiquote_body,
    ACTIONS(25543), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607089] = 2,
    ACTIONS(25547), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607101] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25549), 1,
      anon_sym_RPAREN,
    STATE(18235), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607117] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25551), 1,
      anon_sym_RBRACK,
    STATE(18178), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607133] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25553), 1,
      anon_sym_RBRACK,
    STATE(18241), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607149] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25555), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607165] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25557), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607181] = 4,
    ACTIONS(25559), 1,
      anon_sym_LBRACE,
    ACTIONS(25561), 1,
      sym__layout_start,
    STATE(4196), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607197] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25563), 1,
      anon_sym_RBRACE,
    STATE(18179), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607213] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25565), 1,
      anon_sym_RBRACE,
    STATE(18239), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607229] = 3,
    STATE(1558), 1,
      sym__arrow,
    ACTIONS(25567), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607243] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25569), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607259] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25571), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607275] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25573), 1,
      anon_sym_RBRACK,
    STATE(18243), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607291] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22193), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607307] = 2,
    ACTIONS(25575), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607319] = 3,
    ACTIONS(25579), 1,
      sym_quasiquote_body,
    ACTIONS(25577), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607333] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25581), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607349] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25583), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607365] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25585), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607381] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25587), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607397] = 2,
    ACTIONS(25589), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607409] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(25591), 1,
      anon_sym_LPAREN,
    STATE(15136), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607425] = 2,
    ACTIONS(25593), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607437] = 2,
    ACTIONS(25589), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607449] = 2,
    ACTIONS(25595), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607461] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25597), 1,
      anon_sym_RPAREN,
    STATE(18260), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607477] = 2,
    ACTIONS(25599), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607489] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25601), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607505] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25603), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607521] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25605), 1,
      anon_sym_RBRACK,
    STATE(18205), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607537] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25607), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607553] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25609), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607569] = 2,
    ACTIONS(25599), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607581] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25611), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607597] = 4,
    ACTIONS(25613), 1,
      anon_sym_RPAREN,
    ACTIONS(25615), 1,
      sym_comma,
    STATE(18678), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607613] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25617), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607629] = 2,
    ACTIONS(20837), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607641] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25619), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607657] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25621), 1,
      anon_sym_RBRACK,
    STATE(18262), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607673] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22170), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607689] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25623), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607705] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(16043), 1,
      sym_type_variable,
    STATE(22168), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607721] = 4,
    ACTIONS(21253), 1,
      sym__varid,
    ACTIONS(25625), 1,
      anon_sym_LPAREN,
    STATE(14223), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607737] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25627), 1,
      anon_sym_RPAREN,
    STATE(18213), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607753] = 2,
    ACTIONS(21158), 3,
      sym__varsym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607765] = 4,
    ACTIONS(3205), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607781] = 3,
    ACTIONS(25631), 1,
      sym_quasiquote_body,
    ACTIONS(25629), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607795] = 3,
    ACTIONS(25635), 1,
      sym_quasiquote_body,
    ACTIONS(25633), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607809] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(20809), 2,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607823] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25637), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607839] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25639), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607855] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25641), 1,
      anon_sym_RBRACE,
    STATE(18277), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607871] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25643), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607887] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25645), 1,
      anon_sym_RBRACK,
    STATE(18281), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607903] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25647), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607919] = 2,
    ACTIONS(21395), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607931] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25649), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607947] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25651), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607963] = 4,
    ACTIONS(25653), 1,
      sym__varid,
    ACTIONS(25655), 1,
      anon_sym_LPAREN,
    STATE(17330), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607979] = 2,
    ACTIONS(25657), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [607991] = 2,
    ACTIONS(25659), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608003] = 4,
    ACTIONS(25661), 1,
      anon_sym_LBRACE,
    ACTIONS(25663), 1,
      sym__layout_start,
    STATE(11084), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608019] = 2,
    ACTIONS(21457), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608031] = 2,
    ACTIONS(23410), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608043] = 2,
    ACTIONS(25665), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608055] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25667), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608071] = 2,
    ACTIONS(25669), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608083] = 3,
    ACTIONS(25673), 1,
      sym_quasiquote_body,
    ACTIONS(25671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608097] = 3,
    ACTIONS(25677), 1,
      sym_quasiquote_body,
    ACTIONS(25675), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608111] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25679), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608127] = 3,
    ACTIONS(25683), 1,
      sym_quasiquote_body,
    ACTIONS(25681), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608141] = 2,
    ACTIONS(25685), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608153] = 3,
    ACTIONS(25689), 1,
      sym_quasiquote_body,
    ACTIONS(25687), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608167] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25691), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608183] = 4,
    ACTIONS(21253), 1,
      sym__varid,
    ACTIONS(25693), 1,
      anon_sym_LPAREN,
    STATE(14140), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608199] = 4,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(25695), 1,
      sym__unboxed_close,
    STATE(18578), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608215] = 3,
    ACTIONS(21469), 1,
      sym__varid,
    STATE(15090), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608229] = 2,
    ACTIONS(21201), 3,
      sym__varsym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608241] = 3,
    STATE(1697), 1,
      sym__larrow,
    ACTIONS(25697), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608255] = 3,
    ACTIONS(25701), 1,
      sym_quasiquote_body,
    ACTIONS(25699), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608269] = 4,
    ACTIONS(25703), 1,
      anon_sym_LBRACE,
    ACTIONS(25705), 1,
      sym__layout_start,
    STATE(13048), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608285] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25707), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608301] = 2,
    ACTIONS(21610), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608313] = 2,
    ACTIONS(18363), 3,
      sym__varid,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608325] = 3,
    ACTIONS(25711), 1,
      sym_quasiquote_body,
    ACTIONS(25709), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608339] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25713), 1,
      anon_sym_RBRACE,
    STATE(18273), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608355] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25715), 1,
      anon_sym_RPAREN,
    STATE(18316), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608371] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25717), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608387] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25719), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608403] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25721), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608419] = 2,
    ACTIONS(25595), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608431] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25723), 1,
      anon_sym_RBRACK,
    STATE(18321), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608447] = 2,
    ACTIONS(25515), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608459] = 4,
    ACTIONS(25725), 1,
      anon_sym_LBRACE,
    ACTIONS(25727), 1,
      sym__layout_start,
    STATE(5288), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608475] = 3,
    STATE(1528), 1,
      sym__arrow,
    ACTIONS(25729), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608489] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25731), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608505] = 3,
    ACTIONS(25735), 1,
      sym_quasiquote_body,
    ACTIONS(25733), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608519] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25737), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608535] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25739), 1,
      anon_sym_RPAREN,
    STATE(18337), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608551] = 3,
    ACTIONS(25743), 1,
      sym_quasiquote_body,
    ACTIONS(25741), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608565] = 2,
    ACTIONS(20837), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608577] = 2,
    ACTIONS(25745), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608589] = 2,
    ACTIONS(25541), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608601] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25747), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608617] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25749), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608633] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25751), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608649] = 4,
    ACTIONS(25753), 1,
      ts_builtin_sym_end,
    ACTIONS(25755), 1,
      anon_sym_LBRACE,
    ACTIONS(25757), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608665] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25759), 1,
      anon_sym_RPAREN,
    STATE(18348), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608681] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25761), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608697] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25763), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608713] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25765), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608729] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25767), 1,
      anon_sym_RBRACK,
    STATE(18343), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608745] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25769), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608761] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25771), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608777] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25773), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608793] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25775), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608809] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25777), 1,
      anon_sym_RBRACK,
    STATE(18354), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608825] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25779), 1,
      anon_sym_RBRACK,
    STATE(18289), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608841] = 4,
    ACTIONS(24961), 1,
      sym__conid,
    STATE(3726), 1,
      sym_constructor,
    STATE(15265), 1,
      sym_newtype_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608857] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25781), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608873] = 2,
    ACTIONS(25589), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608885] = 4,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(25783), 1,
      anon_sym_LPAREN,
    STATE(15340), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608901] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25785), 1,
      anon_sym_RBRACE,
    STATE(18296), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608917] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25787), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608933] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25789), 1,
      anon_sym_RBRACE,
    STATE(18297), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608949] = 2,
    ACTIONS(25589), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608961] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25791), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608977] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25793), 1,
      anon_sym_RBRACE,
    STATE(18358), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [608993] = 2,
    ACTIONS(25575), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609005] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25795), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609021] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25797), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609037] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25799), 1,
      anon_sym_RBRACK,
    STATE(18362), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609053] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25801), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609069] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25803), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609085] = 4,
    ACTIONS(17376), 1,
      anon_sym_RPAREN,
    ACTIONS(25805), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609101] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25808), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609117] = 2,
    ACTIONS(25547), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609129] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25810), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609145] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25812), 1,
      anon_sym_RBRACE,
    STATE(18365), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609161] = 2,
    ACTIONS(25814), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609173] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25816), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609189] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609201] = 2,
    ACTIONS(25599), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609213] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25820), 1,
      anon_sym_RBRACK,
    STATE(18371), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609229] = 2,
    ACTIONS(21500), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609241] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25822), 1,
      anon_sym_RBRACK,
    STATE(18322), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609257] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25824), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609273] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25826), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609289] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609301] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(25828), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609317] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25830), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609333] = 2,
    ACTIONS(25529), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609345] = 4,
    ACTIONS(25039), 1,
      sym_comma,
    ACTIONS(25832), 1,
      anon_sym_RPAREN,
    STATE(19036), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609361] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25834), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609377] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25836), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609393] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25838), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609409] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609421] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25842), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609437] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609449] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609461] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25844), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609477] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609489] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25846), 1,
      anon_sym_RPAREN,
    STATE(18327), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609505] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25848), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609521] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25850), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609537] = 2,
    ACTIONS(21873), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609549] = 3,
    ACTIONS(25854), 1,
      sym_quasiquote_body,
    ACTIONS(25852), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609563] = 4,
    ACTIONS(15417), 1,
      sym__varid,
    ACTIONS(25856), 1,
      anon_sym_LPAREN,
    STATE(15494), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609579] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25858), 1,
      anon_sym_RBRACE,
    STATE(18361), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609595] = 3,
    ACTIONS(25862), 1,
      sym_quasiquote_body,
    ACTIONS(25860), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609609] = 3,
    ACTIONS(25866), 1,
      sym_quasiquote_body,
    ACTIONS(25864), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609623] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25868), 1,
      anon_sym_RPAREN,
    STATE(18415), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609639] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25870), 1,
      anon_sym_RBRACK,
    STATE(18418), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609655] = 4,
    ACTIONS(25872), 1,
      anon_sym_LBRACE,
    ACTIONS(25874), 1,
      sym__layout_start,
    STATE(11237), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609671] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609683] = 2,
    ACTIONS(23919), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609695] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25876), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609711] = 3,
    STATE(1337), 1,
      sym__arrow,
    ACTIONS(25878), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609725] = 2,
    ACTIONS(25479), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609737] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25880), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609753] = 2,
    ACTIONS(21662), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609765] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25882), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609781] = 4,
    ACTIONS(25884), 1,
      anon_sym_LBRACE,
    ACTIONS(25886), 1,
      sym__layout_start,
    STATE(12253), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609797] = 2,
    ACTIONS(25888), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609809] = 2,
    ACTIONS(25890), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609821] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25892), 1,
      anon_sym_RBRACK,
    STATE(18363), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609837] = 2,
    ACTIONS(25888), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609849] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25894), 1,
      anon_sym_RPAREN,
    STATE(18368), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609865] = 4,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(25896), 1,
      sym__unboxed_close,
    STATE(18413), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609881] = 3,
    ACTIONS(25900), 1,
      sym_quasiquote_body,
    ACTIONS(25898), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609895] = 2,
    ACTIONS(25902), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609907] = 3,
    ACTIONS(25906), 1,
      sym_quasiquote_body,
    ACTIONS(25904), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609921] = 2,
    ACTIONS(25908), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609933] = 3,
    ACTIONS(25912), 1,
      sym_quasiquote_body,
    ACTIONS(25910), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609947] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25914), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609963] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25916), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609979] = 2,
    ACTIONS(25918), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [609991] = 3,
    ACTIONS(25922), 1,
      sym_quasiquote_body,
    ACTIONS(25920), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610005] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25924), 1,
      anon_sym_RPAREN,
    STATE(18435), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610021] = 4,
    ACTIONS(25926), 1,
      anon_sym_LBRACE,
    ACTIONS(25928), 1,
      sym__layout_start,
    STATE(5421), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610037] = 3,
    ACTIONS(25932), 1,
      sym_quasiquote_body,
    ACTIONS(25930), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610051] = 4,
    ACTIONS(1149), 1,
      anon_sym_PIPE,
    ACTIONS(25934), 1,
      sym__unboxed_close,
    STATE(18416), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610067] = 2,
    ACTIONS(23907), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610079] = 2,
    ACTIONS(25936), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610091] = 4,
    ACTIONS(25432), 1,
      sym__unboxed_close,
    ACTIONS(25938), 1,
      sym_comma,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610107] = 4,
    ACTIONS(25941), 1,
      anon_sym_PIPE,
    ACTIONS(25944), 1,
      sym__unboxed_close,
    STATE(18413), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610123] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(25946), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610139] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25948), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610155] = 4,
    ACTIONS(25950), 1,
      anon_sym_PIPE,
    ACTIONS(25953), 1,
      sym__unboxed_close,
    STATE(18416), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610171] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25955), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610187] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(25957), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610203] = 2,
    ACTIONS(25959), 3,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610215] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25961), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610231] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25963), 1,
      anon_sym_RBRACK,
    STATE(18449), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610247] = 2,
    ACTIONS(18612), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610259] = 3,
    ACTIONS(25967), 1,
      sym_quasiquote_body,
    ACTIONS(25965), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610273] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(25969), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610289] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25971), 1,
      anon_sym_RPAREN,
    STATE(18456), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610305] = 2,
    ACTIONS(25973), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610317] = 2,
    ACTIONS(24083), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610329] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610341] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(25975), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610357] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(25977), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610373] = 2,
    ACTIONS(25979), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610385] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610397] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(25981), 1,
      anon_sym_RBRACE,
    STATE(18463), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610413] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25983), 1,
      anon_sym_RBRACE,
    STATE(18469), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610429] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(25985), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610445] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25987), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610461] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25989), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610477] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(25991), 1,
      anon_sym_RBRACK,
    STATE(18462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610493] = 2,
    ACTIONS(25993), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610505] = 3,
    STATE(1357), 1,
      sym__larrow,
    ACTIONS(25995), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610519] = 2,
    ACTIONS(25189), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610531] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610543] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(25997), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610559] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(21050), 2,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610573] = 2,
    ACTIONS(25133), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610585] = 2,
    ACTIONS(25115), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610597] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(25999), 1,
      anon_sym_RBRACK,
    STATE(18471), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610613] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26001), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610629] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26003), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610645] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26005), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610661] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610673] = 2,
    ACTIONS(25109), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610685] = 2,
    ACTIONS(26007), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610697] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26009), 1,
      anon_sym_RBRACE,
    STATE(18477), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610713] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26011), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610729] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26013), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610745] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26015), 1,
      anon_sym_RBRACE,
    STATE(19204), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610761] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26017), 1,
      anon_sym_RBRACK,
    STATE(18481), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610777] = 2,
    ACTIONS(18612), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610789] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26019), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610805] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26021), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610821] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26023), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610837] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26025), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610853] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26027), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610869] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26029), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610885] = 2,
    ACTIONS(18399), 3,
      sym__varid,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610897] = 2,
    ACTIONS(26007), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610909] = 2,
    ACTIONS(26031), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610921] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26033), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610937] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26035), 1,
      anon_sym_RBRACK,
    STATE(18436), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610953] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26037), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610969] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26039), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610985] = 3,
    ACTIONS(26043), 1,
      anon_sym_EQ,
    ACTIONS(26041), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [610999] = 3,
    ACTIONS(26047), 1,
      sym_quasiquote_body,
    ACTIONS(26045), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611013] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26049), 1,
      anon_sym_RBRACE,
    STATE(18443), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611029] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26051), 1,
      anon_sym_RBRACE,
    STATE(18448), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611045] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26053), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611061] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611073] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26055), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611089] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26057), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611105] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26059), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611121] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26061), 1,
      anon_sym_RBRACE,
    STATE(19331), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611137] = 2,
    ACTIONS(26063), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611149] = 3,
    ACTIONS(26067), 1,
      sym_quasiquote_body,
    ACTIONS(26065), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611163] = 2,
    ACTIONS(26007), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611175] = 2,
    ACTIONS(26031), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611187] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26069), 1,
      anon_sym_RPAREN,
    STATE(18510), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611203] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26071), 1,
      anon_sym_RBRACK,
    STATE(18513), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611219] = 2,
    ACTIONS(26073), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611231] = 4,
    ACTIONS(26075), 1,
      anon_sym_LBRACE,
    ACTIONS(26077), 1,
      sym__layout_start,
    STATE(11282), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611247] = 2,
    ACTIONS(7530), 3,
      sym__dot,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611259] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26079), 1,
      anon_sym_RBRACK,
    STATE(18465), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611275] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26081), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611291] = 3,
    STATE(1448), 1,
      sym__arrow,
    ACTIONS(26083), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611305] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26085), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611321] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26087), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611337] = 2,
    ACTIONS(24163), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611349] = 3,
    ACTIONS(26091), 1,
      sym_quasiquote_body,
    ACTIONS(26089), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611363] = 4,
    ACTIONS(3244), 1,
      sym_comma,
    ACTIONS(26093), 1,
      anon_sym_RPAREN,
    STATE(19311), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611379] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26095), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611395] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26097), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611411] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26099), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611427] = 2,
    ACTIONS(26101), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611439] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26103), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611455] = 4,
    ACTIONS(3244), 1,
      sym_comma,
    ACTIONS(26093), 1,
      anon_sym_RPAREN,
    STATE(18155), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611471] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26105), 1,
      anon_sym_RPAREN,
    STATE(18472), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611487] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26107), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611503] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26109), 1,
      anon_sym_RPAREN,
    STATE(18541), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611519] = 3,
    ACTIONS(26113), 1,
      sym_quasiquote_body,
    ACTIONS(26111), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611533] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26115), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611549] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26117), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611565] = 2,
    ACTIONS(24231), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611577] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26119), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611593] = 4,
    ACTIONS(3244), 1,
      sym_comma,
    ACTIONS(26121), 1,
      anon_sym_RPAREN,
    STATE(18155), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611609] = 2,
    ACTIONS(21618), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611621] = 3,
    ACTIONS(26125), 1,
      sym_quasiquote_body,
    ACTIONS(26123), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611635] = 2,
    ACTIONS(26127), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611647] = 3,
    ACTIONS(26131), 1,
      sym_quasiquote_body,
    ACTIONS(26129), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611661] = 2,
    ACTIONS(26133), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611673] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26135), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611689] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26137), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611705] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26139), 1,
      anon_sym_RBRACK,
    STATE(18550), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611721] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26141), 1,
      anon_sym_RBRACK,
    STATE(19326), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611737] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26143), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611753] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26145), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611769] = 4,
    ACTIONS(26147), 1,
      anon_sym_LBRACE,
    ACTIONS(26149), 1,
      sym__layout_start,
    STATE(12142), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611785] = 2,
    ACTIONS(26133), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611797] = 2,
    ACTIONS(26151), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611809] = 2,
    ACTIONS(26153), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611821] = 2,
    ACTIONS(26155), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611833] = 4,
    ACTIONS(26157), 1,
      anon_sym_RBRACK,
    ACTIONS(26159), 1,
      sym_comma,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611849] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26162), 1,
      anon_sym_RBRACE,
    STATE(18555), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611865] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26164), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611881] = 4,
    ACTIONS(26166), 1,
      anon_sym_LBRACE,
    ACTIONS(26168), 1,
      sym__layout_start,
    STATE(12790), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611897] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26170), 1,
      anon_sym_RBRACE,
    STATE(18566), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611913] = 2,
    ACTIONS(26172), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611925] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22494), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611941] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22507), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611957] = 3,
    STATE(10552), 1,
      sym__arrow,
    ACTIONS(26174), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611971] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22515), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [611987] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26176), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612003] = 3,
    ACTIONS(26180), 1,
      sym_quasiquote_body,
    ACTIONS(26178), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612017] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26182), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612033] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26184), 1,
      anon_sym_RPAREN,
    STATE(18575), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612049] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26186), 1,
      anon_sym_RBRACK,
    STATE(18501), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612065] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26188), 1,
      anon_sym_RBRACK,
    STATE(18567), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612081] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26190), 1,
      anon_sym_RPAREN,
    STATE(18504), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612097] = 2,
    ACTIONS(23221), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612109] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26192), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612125] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26194), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612141] = 2,
    ACTIONS(25245), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612153] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26196), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612169] = 2,
    ACTIONS(25241), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612181] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26198), 1,
      anon_sym_RPAREN,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612197] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26200), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612213] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26202), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612229] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26204), 1,
      anon_sym_RBRACK,
    STATE(18581), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612245] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26206), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612261] = 3,
    ACTIONS(26210), 1,
      sym_quasiquote_body,
    ACTIONS(26208), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612275] = 3,
    STATE(18284), 1,
      sym__arrow,
    ACTIONS(26212), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612289] = 3,
    ACTIONS(26216), 1,
      sym_quasiquote_body,
    ACTIONS(26214), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612303] = 3,
    ACTIONS(26218), 1,
      sym_where,
    ACTIONS(23860), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612317] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22611), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612333] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22617), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612349] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22630), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612365] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26220), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612381] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26222), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612397] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26224), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612413] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26226), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612429] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22642), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612445] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26228), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612461] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26230), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612477] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26232), 1,
      anon_sym_RBRACE,
    STATE(18596), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612493] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26234), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612509] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26236), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612525] = 4,
    ACTIONS(5712), 1,
      anon_sym_PIPE,
    ACTIONS(26238), 1,
      sym__unboxed_close,
    STATE(18578), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612541] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26240), 1,
      anon_sym_RBRACK,
    STATE(18600), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612557] = 4,
    ACTIONS(26242), 1,
      anon_sym_PIPE,
    ACTIONS(26245), 1,
      sym__unboxed_close,
    STATE(18578), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612573] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26247), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612589] = 2,
    ACTIONS(24908), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612601] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26249), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612617] = 3,
    ACTIONS(26253), 1,
      sym_quasiquote_body,
    ACTIONS(26251), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612631] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26255), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612647] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26257), 1,
      anon_sym_RPAREN,
    STATE(18617), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612663] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26259), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612679] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26261), 1,
      anon_sym_RBRACK,
    STATE(18625), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612695] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26263), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612711] = 2,
    ACTIONS(26133), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612723] = 4,
    ACTIONS(26265), 1,
      anon_sym_LBRACE,
    ACTIONS(26267), 1,
      sym__layout_start,
    STATE(10697), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612739] = 2,
    ACTIONS(26269), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612751] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26271), 1,
      anon_sym_RBRACK,
    STATE(18571), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612767] = 3,
    STATE(18201), 1,
      sym__arrow,
    ACTIONS(26273), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612781] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22730), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612797] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26275), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612813] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22736), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612829] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26277), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612845] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26279), 1,
      anon_sym_RBRACE,
    STATE(18572), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612861] = 2,
    ACTIONS(26172), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612873] = 2,
    ACTIONS(26281), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612885] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26283), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612901] = 4,
    ACTIONS(26285), 1,
      sym__varid,
    ACTIONS(26287), 1,
      anon_sym_LPAREN,
    STATE(16134), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612917] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26289), 1,
      anon_sym_RBRACE,
    STATE(18579), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612933] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22751), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612949] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26291), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612965] = 2,
    ACTIONS(24077), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612977] = 3,
    STATE(1614), 1,
      sym__arrow,
    ACTIONS(26293), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [612991] = 2,
    ACTIONS(26133), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613003] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22764), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613019] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26295), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613035] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26297), 1,
      anon_sym_RBRACK,
    STATE(18587), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613051] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26299), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613067] = 3,
    STATE(498), 1,
      sym__arrow,
    ACTIONS(26301), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613081] = 2,
    ACTIONS(26153), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613093] = 3,
    ACTIONS(26305), 1,
      sym_quasiquote_body,
    ACTIONS(26303), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613107] = 4,
    ACTIONS(3256), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613123] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26307), 1,
      anon_sym_RPAREN,
    STATE(18659), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613139] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26309), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613155] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26311), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613171] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26313), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613187] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26315), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613203] = 2,
    ACTIONS(26151), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613215] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26317), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613231] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26319), 1,
      anon_sym_RPAREN,
    STATE(18594), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613247] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26321), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613263] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26323), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613279] = 3,
    ACTIONS(26327), 1,
      sym_quasiquote_body,
    ACTIONS(26325), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613293] = 3,
    STATE(18115), 1,
      sym__arrow,
    ACTIONS(26329), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613307] = 2,
    ACTIONS(26133), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613319] = 2,
    ACTIONS(26133), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613331] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22877), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613347] = 2,
    ACTIONS(26127), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613359] = 4,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(16094), 1,
      sym_variable,
    STATE(22890), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613375] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22897), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613391] = 2,
    ACTIONS(21618), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613403] = 3,
    ACTIONS(26333), 1,
      sym_quasiquote_body,
    ACTIONS(26331), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613417] = 4,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(26335), 1,
      anon_sym_BQUOTE,
    STATE(3185), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613433] = 3,
    ACTIONS(26339), 1,
      sym_quasiquote_body,
    ACTIONS(26337), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613447] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26341), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613463] = 2,
    ACTIONS(26343), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613475] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26345), 1,
      anon_sym_RBRACK,
    STATE(18664), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613491] = 2,
    ACTIONS(26101), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613503] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26347), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613519] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22918), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613535] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26349), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613551] = 4,
    ACTIONS(26351), 1,
      anon_sym_LBRACE,
    ACTIONS(26353), 1,
      sym__layout_start,
    STATE(13113), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613567] = 2,
    ACTIONS(26073), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613579] = 2,
    ACTIONS(26355), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613591] = 2,
    ACTIONS(26357), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613603] = 3,
    STATE(3111), 1,
      sym__arrow,
    ACTIONS(26359), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613617] = 3,
    STATE(1305), 1,
      sym__larrow,
    ACTIONS(26361), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613631] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26363), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613647] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26365), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613663] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(22939), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613679] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26367), 1,
      anon_sym_RBRACE,
    STATE(18703), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613695] = 2,
    ACTIONS(26031), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613707] = 2,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613719] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26369), 1,
      anon_sym_RBRACE,
    STATE(18669), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613735] = 3,
    STATE(502), 1,
      sym__arrow,
    ACTIONS(22080), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613749] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26371), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613765] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26373), 1,
      anon_sym_RBRACK,
    STATE(18671), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613781] = 3,
    ACTIONS(26377), 1,
      sym_quasiquote_body,
    ACTIONS(26375), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613795] = 4,
    ACTIONS(3125), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613811] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26379), 1,
      anon_sym_RPAREN,
    STATE(18694), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613827] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26381), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613843] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26383), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613859] = 3,
    ACTIONS(26387), 1,
      sym_quasiquote_body,
    ACTIONS(26385), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613873] = 2,
    ACTIONS(26007), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613885] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26389), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613901] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26391), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613917] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(21050), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613931] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26393), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613947] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(21504), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613963] = 2,
    ACTIONS(25111), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613975] = 4,
    ACTIONS(26395), 1,
      anon_sym_LBRACE,
    ACTIONS(26397), 1,
      sym__layout_start,
    STATE(4111), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [613991] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26399), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614007] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26401), 1,
      anon_sym_RBRACK,
    STATE(18700), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614023] = 4,
    ACTIONS(25615), 1,
      sym_comma,
    ACTIONS(26403), 1,
      anon_sym_RPAREN,
    STATE(18678), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614039] = 4,
    ACTIONS(25615), 1,
      sym_comma,
    ACTIONS(26405), 1,
      anon_sym_RPAREN,
    STATE(19478), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614055] = 2,
    ACTIONS(26063), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614067] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26407), 1,
      anon_sym_RBRACK,
    STATE(18619), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614083] = 2,
    ACTIONS(26155), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614095] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26409), 1,
      anon_sym_RPAREN,
    STATE(18622), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614111] = 2,
    ACTIONS(26031), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614123] = 2,
    ACTIONS(26411), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614135] = 2,
    ACTIONS(18691), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614147] = 3,
    ACTIONS(26415), 1,
      sym_quasiquote_body,
    ACTIONS(26413), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614161] = 3,
    ACTIONS(26419), 1,
      sym_quasiquote_body,
    ACTIONS(26417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614175] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26421), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614191] = 3,
    ACTIONS(26425), 1,
      sym_quasiquote_body,
    ACTIONS(26423), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614205] = 2,
    ACTIONS(26007), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614217] = 3,
    ACTIONS(26429), 1,
      sym_quasiquote_body,
    ACTIONS(26427), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614231] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26431), 1,
      anon_sym_RBRACE,
    STATE(18715), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614247] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26433), 1,
      anon_sym_RPAREN,
    STATE(18738), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614263] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26435), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614279] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26437), 1,
      anon_sym_RBRACK,
    STATE(18742), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614295] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26439), 1,
      anon_sym_RBRACK,
    STATE(18719), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614311] = 4,
    ACTIONS(26441), 1,
      anon_sym_LBRACE,
    ACTIONS(26443), 1,
      sym__layout_start,
    STATE(6885), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614327] = 2,
    ACTIONS(26411), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614339] = 2,
    ACTIONS(26007), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614351] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26445), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614367] = 3,
    STATE(1466), 1,
      sym__arrow,
    ACTIONS(26447), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614381] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26449), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614397] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26451), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614413] = 3,
    STATE(3134), 1,
      sym__arrow,
    ACTIONS(26453), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614427] = 3,
    STATE(3125), 1,
      sym__arrow,
    ACTIONS(26455), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614441] = 3,
    STATE(3135), 1,
      sym__arrow,
    ACTIONS(26457), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614455] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614467] = 3,
    STATE(17981), 1,
      sym__arrow,
    ACTIONS(26459), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614481] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614493] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(23074), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614509] = 4,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(16094), 1,
      sym_variable,
    STATE(23092), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614525] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(23102), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614541] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26461), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614557] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26463), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614573] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26465), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614589] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26467), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614605] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26469), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614621] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614633] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26471), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614649] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614661] = 4,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(26473), 1,
      anon_sym_BQUOTE,
    STATE(3196), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614677] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(23125), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614693] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26475), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614709] = 3,
    ACTIONS(26479), 1,
      sym_quasiquote_body,
    ACTIONS(26477), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614723] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26481), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614739] = 2,
    ACTIONS(25840), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614751] = 3,
    STATE(1586), 1,
      sym__larrow,
    ACTIONS(26483), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614765] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(23141), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614781] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26485), 1,
      anon_sym_RBRACK,
    STATE(18714), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614797] = 4,
    ACTIONS(3133), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614813] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26487), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614829] = 2,
    ACTIONS(25973), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614841] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26489), 1,
      anon_sym_RPAREN,
    STATE(18759), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614857] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26491), 1,
      anon_sym_RBRACE,
    STATE(18716), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614873] = 2,
    ACTIONS(25191), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614885] = 3,
    STATE(504), 1,
      sym__arrow,
    ACTIONS(20678), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614899] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26493), 1,
      anon_sym_RBRACE,
    STATE(18717), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614915] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26495), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614931] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26497), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614947] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26499), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614963] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26501), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614979] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26503), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [614995] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26505), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615011] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26507), 1,
      anon_sym_RBRACK,
    STATE(18725), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615027] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26509), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615043] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26511), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615059] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26513), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615075] = 2,
    ACTIONS(26515), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615087] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26517), 1,
      anon_sym_RBRACE,
    STATE(18770), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615103] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26519), 1,
      anon_sym_RBRACE,
    STATE(18772), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615119] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26521), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615135] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26523), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615151] = 2,
    ACTIONS(25936), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615163] = 3,
    ACTIONS(26527), 1,
      sym_quasiquote_body,
    ACTIONS(26525), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615177] = 3,
    ACTIONS(26529), 1,
      sym_where,
    ACTIONS(22821), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615191] = 3,
    ACTIONS(26533), 1,
      sym_quasiquote_body,
    ACTIONS(26531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615205] = 2,
    ACTIONS(25061), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615217] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26535), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615233] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26537), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615249] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26539), 1,
      anon_sym_RPAREN,
    STATE(18731), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615265] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26541), 1,
      anon_sym_RBRACK,
    STATE(18773), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615281] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26543), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615297] = 2,
    ACTIONS(21224), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615309] = 4,
    ACTIONS(26545), 1,
      anon_sym_LBRACE,
    ACTIONS(26547), 1,
      sym__layout_start,
    STATE(5605), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615325] = 3,
    ACTIONS(26551), 1,
      sym_quasiquote_body,
    ACTIONS(26549), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615339] = 4,
    ACTIONS(26553), 1,
      anon_sym_RBRACE,
    ACTIONS(26555), 1,
      sym_comma,
    STATE(18766), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615355] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26558), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615371] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26560), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615387] = 2,
    ACTIONS(21214), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615399] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26562), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615415] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26564), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615431] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26566), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615447] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26568), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615463] = 2,
    ACTIONS(23516), 3,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615475] = 2,
    ACTIONS(25023), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615487] = 2,
    ACTIONS(26570), 3,
      sym__varid,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615499] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26572), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615515] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26574), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615531] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26576), 1,
      anon_sym_RBRACK,
    STATE(18778), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615547] = 3,
    ACTIONS(26580), 1,
      sym_quasiquote_body,
    ACTIONS(26578), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615561] = 4,
    ACTIONS(3230), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615577] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26582), 1,
      anon_sym_RPAREN,
    STATE(18813), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615593] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26584), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615609] = 3,
    STATE(3130), 1,
      sym__arrow,
    ACTIONS(26586), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615623] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26588), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615639] = 2,
    ACTIONS(25918), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615651] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26590), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615667] = 3,
    ACTIONS(26594), 1,
      sym_quasiquote_body,
    ACTIONS(26592), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615681] = 2,
    ACTIONS(21158), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615693] = 3,
    ACTIONS(26598), 1,
      sym_quasiquote_body,
    ACTIONS(26596), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615707] = 3,
    ACTIONS(26602), 1,
      sym_quasiquote_body,
    ACTIONS(26600), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615721] = 3,
    ACTIONS(26606), 1,
      sym_quasiquote_body,
    ACTIONS(26604), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615735] = 2,
    ACTIONS(26608), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615747] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26610), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615763] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26612), 1,
      anon_sym_RBRACK,
    STATE(18819), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615779] = 3,
    ACTIONS(26616), 1,
      sym_quasiquote_body,
    ACTIONS(26614), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615793] = 4,
    ACTIONS(20203), 1,
      anon_sym_RPAREN,
    ACTIONS(26618), 1,
      sym_comma,
    STATE(19755), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615809] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615821] = 2,
    ACTIONS(26620), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615833] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26622), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615849] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26624), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615865] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26626), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615881] = 4,
    ACTIONS(26628), 1,
      anon_sym_RPAREN,
    ACTIONS(26630), 1,
      sym_comma,
    STATE(18803), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615897] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26633), 1,
      anon_sym_RBRACK,
    STATE(18767), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615913] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26635), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615929] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26637), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615945] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26639), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615961] = 3,
    ACTIONS(26643), 1,
      sym_quasiquote_body,
    ACTIONS(26641), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615975] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26645), 1,
      anon_sym_RPAREN,
    STATE(18849), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [615991] = 4,
    ACTIONS(26647), 1,
      anon_sym_LBRACE,
    ACTIONS(26649), 1,
      sym__layout_start,
    STATE(6454), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616007] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26651), 1,
      anon_sym_RBRACE,
    STATE(18834), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616023] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26653), 1,
      anon_sym_RBRACK,
    STATE(18855), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616039] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26655), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616055] = 3,
    ACTIONS(26659), 1,
      sym_quasiquote_body,
    ACTIONS(26657), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616069] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26661), 1,
      anon_sym_RBRACK,
    STATE(18838), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616085] = 3,
    ACTIONS(26665), 1,
      sym_quasiquote_body,
    ACTIONS(26663), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616099] = 3,
    STATE(1468), 1,
      sym__arrow,
    ACTIONS(26667), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616113] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26669), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616129] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26671), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616145] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26673), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616161] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26675), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616177] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26677), 1,
      anon_sym_RBRACK,
    STATE(18751), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616193] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26679), 1,
      anon_sym_RBRACK,
    STATE(18820), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616209] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26681), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616225] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26683), 1,
      anon_sym_RPAREN,
    STATE(18758), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616241] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26685), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616257] = 3,
    ACTIONS(26689), 1,
      sym_quasiquote_body,
    ACTIONS(26687), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616271] = 2,
    ACTIONS(25908), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616283] = 3,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(20809), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616297] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26691), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616313] = 3,
    ACTIONS(26695), 1,
      sym_quasiquote_body,
    ACTIONS(26693), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616327] = 3,
    ACTIONS(26699), 1,
      sym_quasiquote_body,
    ACTIONS(26697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616341] = 3,
    ACTIONS(26703), 1,
      sym_quasiquote_body,
    ACTIONS(26701), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616355] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26705), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616371] = 3,
    ACTIONS(26709), 1,
      sym_quasiquote_body,
    ACTIONS(26707), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616385] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26711), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616401] = 4,
    ACTIONS(26713), 1,
      anon_sym_RPAREN,
    ACTIONS(26715), 1,
      sym_comma,
    STATE(18837), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616417] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26718), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616433] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26720), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616449] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26722), 1,
      anon_sym_RBRACK,
    STATE(18839), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616465] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26724), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616481] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26726), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616497] = 3,
    ACTIONS(26730), 1,
      sym_quasiquote_body,
    ACTIONS(26728), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616511] = 3,
    ACTIONS(26734), 1,
      sym_quasiquote_body,
    ACTIONS(26732), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616525] = 3,
    ACTIONS(26738), 1,
      sym_quasiquote_body,
    ACTIONS(26736), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616539] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26740), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616555] = 3,
    ACTIONS(26744), 1,
      sym_quasiquote_body,
    ACTIONS(26742), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616569] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26746), 1,
      anon_sym_RPAREN,
    STATE(18923), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616585] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26748), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616601] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26750), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616617] = 4,
    ACTIONS(26752), 1,
      anon_sym_RPAREN,
    ACTIONS(26754), 1,
      sym_comma,
    STATE(19827), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616633] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26756), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616649] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26758), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616665] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26760), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616681] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26762), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616697] = 2,
    ACTIONS(25902), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616709] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26764), 1,
      anon_sym_RBRACK,
    STATE(18854), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616725] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26766), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616741] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26768), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616757] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26770), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616773] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26772), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616789] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26774), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616805] = 3,
    ACTIONS(26778), 1,
      sym_quasiquote_body,
    ACTIONS(26776), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616819] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26780), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616835] = 4,
    ACTIONS(26782), 1,
      ts_builtin_sym_end,
    ACTIONS(26784), 1,
      anon_sym_LBRACE,
    ACTIONS(26786), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616851] = 2,
    ACTIONS(25888), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616863] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26788), 1,
      anon_sym_RBRACK,
    STATE(18853), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616879] = 3,
    ACTIONS(26792), 1,
      sym_quasiquote_body,
    ACTIONS(26790), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616893] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26794), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616909] = 3,
    ACTIONS(26798), 1,
      sym_quasiquote_body,
    ACTIONS(26796), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616923] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26800), 1,
      anon_sym_RBRACE,
    STATE(18858), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616939] = 2,
    ACTIONS(25890), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616951] = 3,
    ACTIONS(26804), 1,
      sym_quasiquote_body,
    ACTIONS(26802), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616965] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26806), 1,
      anon_sym_RBRACE,
    STATE(18859), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616981] = 3,
    ACTIONS(26810), 1,
      sym_quasiquote_body,
    ACTIONS(26808), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [616995] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26812), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617011] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26814), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617027] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26816), 1,
      anon_sym_RBRACK,
    STATE(18935), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617043] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26818), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617059] = 2,
    ACTIONS(25888), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617071] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26820), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617087] = 2,
    ACTIONS(26822), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617099] = 4,
    ACTIONS(26824), 1,
      anon_sym_LBRACE,
    ACTIONS(26826), 1,
      sym__layout_start,
    STATE(12788), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617115] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26828), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617131] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26830), 1,
      anon_sym_RBRACK,
    STATE(18884), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617147] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26832), 1,
      anon_sym_RBRACK,
    STATE(18864), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617163] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26834), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617179] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26836), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617195] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26838), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617211] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26840), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617227] = 3,
    ACTIONS(26844), 1,
      sym_quasiquote_body,
    ACTIONS(26842), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617241] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617253] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26846), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617269] = 3,
    ACTIONS(26850), 1,
      sym_quasiquote_body,
    ACTIONS(26848), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617283] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(26852), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617299] = 3,
    ACTIONS(26856), 1,
      sym_quasiquote_body,
    ACTIONS(26854), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617313] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26858), 1,
      anon_sym_RBRACE,
    STATE(18960), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617329] = 2,
    ACTIONS(24985), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617341] = 3,
    ACTIONS(26862), 1,
      sym_quasiquote_body,
    ACTIONS(26860), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617355] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26864), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617371] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26866), 1,
      anon_sym_RPAREN,
    STATE(18932), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617387] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26868), 1,
      anon_sym_RBRACE,
    STATE(18963), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617403] = 4,
    ACTIONS(26870), 1,
      anon_sym_LBRACE,
    ACTIONS(26872), 1,
      sym__layout_start,
    STATE(12559), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617419] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617431] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26874), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617447] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26876), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617463] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26878), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617479] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26880), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617495] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26882), 1,
      anon_sym_RBRACK,
    STATE(18907), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617511] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26884), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617527] = 4,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617543] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(26886), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617559] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26888), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617575] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26890), 1,
      anon_sym_RBRACK,
    STATE(18938), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617591] = 3,
    ACTIONS(26894), 1,
      sym_quasiquote_body,
    ACTIONS(26892), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617605] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26896), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617621] = 3,
    ACTIONS(26898), 1,
      sym_where,
    ACTIONS(22230), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617635] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617647] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26900), 1,
      anon_sym_RPAREN,
    STATE(18869), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617663] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617675] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617687] = 2,
    ACTIONS(26902), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617699] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26904), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617715] = 3,
    ACTIONS(26908), 1,
      sym_quasiquote_body,
    ACTIONS(26906), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617729] = 4,
    ACTIONS(3203), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617745] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26910), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617761] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26912), 1,
      anon_sym_RBRACK,
    STATE(18964), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617777] = 2,
    ACTIONS(25818), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617789] = 3,
    ACTIONS(26916), 1,
      sym_quasiquote_body,
    ACTIONS(26914), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617803] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26918), 1,
      anon_sym_RBRACE,
    STATE(18953), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617819] = 3,
    ACTIONS(26922), 1,
      sym_quasiquote_body,
    ACTIONS(26920), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617833] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(26924), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617849] = 2,
    ACTIONS(25005), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617861] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26926), 1,
      anon_sym_RBRACK,
    STATE(18957), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617877] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26928), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617893] = 2,
    ACTIONS(26930), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617905] = 2,
    ACTIONS(24991), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617917] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26932), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617933] = 2,
    ACTIONS(24985), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617945] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26934), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617961] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26936), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617977] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26938), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [617993] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26940), 1,
      anon_sym_RBRACK,
    STATE(18942), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618009] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26942), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618025] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26944), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618041] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(26946), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618057] = 3,
    ACTIONS(26950), 1,
      sym_quasiquote_body,
    ACTIONS(26948), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618071] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26952), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618087] = 2,
    ACTIONS(21201), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618099] = 3,
    ACTIONS(26956), 1,
      sym_quasiquote_body,
    ACTIONS(26954), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618113] = 3,
    ACTIONS(26960), 1,
      sym_quasiquote_body,
    ACTIONS(26958), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618127] = 2,
    ACTIONS(21312), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618139] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26962), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618155] = 4,
    ACTIONS(26964), 1,
      anon_sym_LBRACE,
    ACTIONS(26966), 1,
      sym__layout_start,
    STATE(5975), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618171] = 2,
    ACTIONS(25814), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618183] = 2,
    ACTIONS(26968), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618195] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26970), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618211] = 2,
    ACTIONS(26968), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618223] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26972), 1,
      anon_sym_RBRACK,
    STATE(18908), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618239] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(26974), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618255] = 2,
    ACTIONS(18626), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618267] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(26976), 1,
      anon_sym_RPAREN,
    STATE(18916), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618283] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(26978), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618299] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(26980), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618315] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(26982), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618331] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26984), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618347] = 3,
    ACTIONS(26988), 1,
      sym_quasiquote_body,
    ACTIONS(26986), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618361] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26990), 1,
      anon_sym_RBRACK,
    STATE(18966), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618377] = 3,
    ACTIONS(26994), 1,
      sym_quasiquote_body,
    ACTIONS(26992), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618391] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(26996), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618407] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(26998), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618423] = 3,
    ACTIONS(27002), 1,
      sym_quasiquote_body,
    ACTIONS(27000), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618437] = 3,
    ACTIONS(27006), 1,
      sym_quasiquote_body,
    ACTIONS(27004), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618451] = 3,
    ACTIONS(27010), 1,
      sym_quasiquote_body,
    ACTIONS(27008), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618465] = 4,
    ACTIONS(19134), 1,
      sym__consym,
    ACTIONS(27012), 1,
      anon_sym_BQUOTE,
    STATE(3191), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618481] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27014), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618497] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27016), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618513] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27018), 1,
      anon_sym_RBRACK,
    STATE(18977), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618529] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27020), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618545] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27022), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618561] = 3,
    ACTIONS(27026), 1,
      sym_quasiquote_body,
    ACTIONS(27024), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618575] = 3,
    ACTIONS(27030), 1,
      sym_quasiquote_body,
    ACTIONS(27028), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618589] = 3,
    ACTIONS(27034), 1,
      sym_quasiquote_body,
    ACTIONS(27032), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618603] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27036), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618619] = 3,
    ACTIONS(27040), 1,
      sym_quasiquote_body,
    ACTIONS(27038), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618633] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27042), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618649] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27044), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618665] = 2,
    ACTIONS(27046), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618677] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27048), 1,
      anon_sym_RPAREN,
    STATE(19052), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618693] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27050), 1,
      anon_sym_RBRACK,
    STATE(19061), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618709] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27052), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618725] = 3,
    ACTIONS(27056), 1,
      sym_quasiquote_body,
    ACTIONS(27054), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618739] = 4,
    ACTIONS(27058), 1,
      anon_sym_LBRACE,
    ACTIONS(27060), 1,
      sym__layout_start,
    STATE(6179), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618755] = 3,
    ACTIONS(27064), 1,
      sym_quasiquote_body,
    ACTIONS(27062), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618769] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27066), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618785] = 2,
    ACTIONS(17699), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618797] = 3,
    STATE(1638), 1,
      sym__arrow,
    ACTIONS(27068), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618811] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27070), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618827] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27072), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618843] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27074), 1,
      anon_sym_RBRACK,
    STATE(18984), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618859] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27076), 1,
      anon_sym_RBRACK,
    STATE(18999), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618875] = 4,
    ACTIONS(27078), 1,
      anon_sym_LBRACE,
    ACTIONS(27080), 1,
      sym__layout_start,
    STATE(12221), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618891] = 2,
    ACTIONS(27082), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618903] = 2,
    ACTIONS(25745), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618915] = 2,
    ACTIONS(27084), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618927] = 2,
    ACTIONS(27086), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618939] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27088), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618955] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27090), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618971] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27092), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [618987] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(27094), 1,
      anon_sym_RPAREN,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619003] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27096), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619019] = 3,
    ACTIONS(27100), 1,
      sym_quasiquote_body,
    ACTIONS(27098), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619033] = 3,
    ACTIONS(27104), 1,
      sym_quasiquote_body,
    ACTIONS(27102), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619047] = 2,
    ACTIONS(21353), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619059] = 3,
    ACTIONS(27108), 1,
      sym_quasiquote_body,
    ACTIONS(27106), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619073] = 3,
    ACTIONS(27112), 1,
      sym_quasiquote_body,
    ACTIONS(27110), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619087] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27114), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619103] = 3,
    ACTIONS(27118), 1,
      sym_quasiquote_body,
    ACTIONS(27116), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619117] = 4,
    ACTIONS(3213), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619133] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27120), 1,
      anon_sym_RPAREN,
    STATE(19051), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619149] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27122), 1,
      anon_sym_RBRACE,
    STATE(18986), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619165] = 4,
    ACTIONS(27124), 1,
      anon_sym_RPAREN,
    ACTIONS(27126), 1,
      sym_comma,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619181] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27129), 1,
      anon_sym_RBRACE,
    STATE(18987), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619197] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(27131), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619213] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27133), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619229] = 2,
    ACTIONS(24878), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619241] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27135), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619257] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27137), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619273] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27139), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619289] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27141), 1,
      anon_sym_RBRACK,
    STATE(19029), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619305] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27143), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619321] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27145), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619337] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27147), 1,
      anon_sym_RBRACK,
    STATE(19057), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619353] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27149), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619369] = 3,
    ACTIONS(27153), 1,
      sym_quasiquote_body,
    ACTIONS(27151), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619383] = 4,
    ACTIONS(25039), 1,
      sym_comma,
    ACTIONS(27155), 1,
      anon_sym_RPAREN,
    STATE(19990), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619399] = 3,
    ACTIONS(27157), 1,
      sym_where,
    ACTIONS(24698), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619413] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(27159), 1,
      anon_sym_RBRACE,
    STATE(18766), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619429] = 3,
    ACTIONS(27163), 1,
      sym_quasiquote_body,
    ACTIONS(27161), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619443] = 4,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(15721), 1,
      sym_variable,
    STATE(20881), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619459] = 3,
    ACTIONS(27167), 1,
      sym_quasiquote_body,
    ACTIONS(27165), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619473] = 3,
    ACTIONS(27171), 1,
      sym_quasiquote_body,
    ACTIONS(27169), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619487] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27173), 1,
      anon_sym_RBRACK,
    STATE(18995), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619503] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27175), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619519] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27177), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619535] = 4,
    ACTIONS(3121), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619551] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27179), 1,
      anon_sym_RPAREN,
    STATE(19102), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619567] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27181), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619583] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27183), 1,
      anon_sym_RBRACE,
    STATE(19072), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619599] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27185), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619615] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27187), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619631] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27189), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619647] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27191), 1,
      anon_sym_RBRACK,
    STATE(19076), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619663] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27193), 1,
      anon_sym_RBRACK,
    STATE(19050), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619679] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27195), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619695] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27197), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619711] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27199), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619727] = 3,
    ACTIONS(27203), 1,
      sym_quasiquote_body,
    ACTIONS(27201), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619741] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27205), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619757] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27207), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619773] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27209), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619789] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27211), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619805] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27213), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619821] = 3,
    ACTIONS(27217), 1,
      sym_quasiquote_body,
    ACTIONS(27215), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619835] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27219), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619851] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27221), 1,
      anon_sym_RPAREN,
    STATE(19011), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619867] = 3,
    ACTIONS(27225), 1,
      sym_quasiquote_body,
    ACTIONS(27223), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619881] = 2,
    ACTIONS(21912), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619893] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27227), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619909] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27229), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619925] = 3,
    ACTIONS(27233), 1,
      sym_quasiquote_body,
    ACTIONS(27231), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619939] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27235), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619955] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27237), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619971] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27239), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [619987] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27241), 1,
      anon_sym_RBRACK,
    STATE(19125), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620003] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27243), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620019] = 2,
    ACTIONS(27245), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620031] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27247), 1,
      anon_sym_RBRACK,
    STATE(19074), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620047] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27249), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620063] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27251), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620079] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27253), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620095] = 3,
    ACTIONS(27257), 1,
      sym_quasiquote_body,
    ACTIONS(27255), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620109] = 2,
    ACTIONS(25685), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620121] = 3,
    ACTIONS(27261), 1,
      sym_quasiquote_body,
    ACTIONS(27259), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620135] = 3,
    ACTIONS(27265), 1,
      sym_quasiquote_body,
    ACTIONS(27263), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620149] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27267), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620165] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(27269), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620181] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27271), 1,
      anon_sym_RBRACE,
    STATE(19126), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620197] = 2,
    ACTIONS(27273), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620209] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27275), 1,
      anon_sym_RBRACE,
    STATE(19127), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620225] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27277), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620241] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27279), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620257] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27281), 1,
      anon_sym_RBRACK,
    STATE(19092), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620273] = 3,
    STATE(3132), 1,
      sym__arrow,
    ACTIONS(27283), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620287] = 4,
    ACTIONS(27285), 1,
      anon_sym_LBRACE,
    ACTIONS(27287), 1,
      sym__layout_start,
    STATE(13202), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620303] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27289), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620319] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27291), 1,
      anon_sym_RBRACK,
    STATE(19062), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620335] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27293), 1,
      anon_sym_RPAREN,
    STATE(19065), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620351] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27295), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620367] = 3,
    ACTIONS(27299), 1,
      sym_quasiquote_body,
    ACTIONS(27297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620381] = 3,
    ACTIONS(27303), 1,
      sym_quasiquote_body,
    ACTIONS(27301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620395] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27305), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620411] = 3,
    ACTIONS(27309), 1,
      sym_quasiquote_body,
    ACTIONS(27307), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620425] = 3,
    ACTIONS(27313), 1,
      sym_quasiquote_body,
    ACTIONS(27311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620439] = 3,
    ACTIONS(27317), 1,
      sym_quasiquote_body,
    ACTIONS(27315), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620453] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27319), 1,
      anon_sym_RBRACK,
    STATE(19130), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620469] = 2,
    ACTIONS(27321), 3,
      sym_string,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620481] = 2,
    ACTIONS(27323), 3,
      sym_string,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620493] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27325), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620509] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27327), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620525] = 3,
    ACTIONS(27331), 1,
      sym_quasiquote_body,
    ACTIONS(27329), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620539] = 2,
    ACTIONS(21846), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620551] = 3,
    ACTIONS(27335), 1,
      sym_quasiquote_body,
    ACTIONS(27333), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620565] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27337), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620581] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27339), 1,
      anon_sym_RBRACK,
    STATE(19114), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620597] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27341), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620613] = 4,
    ACTIONS(3059), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620629] = 3,
    ACTIONS(27345), 1,
      sym_quasiquote_body,
    ACTIONS(27343), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620643] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27347), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620659] = 4,
    ACTIONS(27349), 1,
      anon_sym_RPAREN,
    ACTIONS(27351), 1,
      sym_comma,
    STATE(18803), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620675] = 4,
    ACTIONS(27353), 1,
      anon_sym_LBRACE,
    ACTIONS(27355), 1,
      sym__layout_start,
    STATE(12567), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620691] = 3,
    ACTIONS(27359), 1,
      sym_quasiquote_body,
    ACTIONS(27357), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620705] = 4,
    ACTIONS(27351), 1,
      sym_comma,
    ACTIONS(27361), 1,
      anon_sym_RPAREN,
    STATE(18803), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620721] = 3,
    ACTIONS(27365), 1,
      sym_quasiquote_body,
    ACTIONS(27363), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620735] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27367), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620751] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27369), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620767] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27371), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620783] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27373), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620799] = 2,
    ACTIONS(24953), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620811] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27375), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620827] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27377), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620843] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27379), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620859] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27381), 1,
      anon_sym_RBRACK,
    STATE(19132), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620875] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27383), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620891] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27385), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620907] = 3,
    ACTIONS(27389), 1,
      sym_quasiquote_body,
    ACTIONS(27387), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620921] = 3,
    ACTIONS(27393), 1,
      sym_quasiquote_body,
    ACTIONS(27391), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620935] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27395), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620951] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27397), 1,
      anon_sym_RPAREN,
    STATE(19170), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620967] = 3,
    ACTIONS(27401), 1,
      sym_quasiquote_body,
    ACTIONS(27399), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620981] = 3,
    ACTIONS(27405), 1,
      sym_quasiquote_body,
    ACTIONS(27403), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [620995] = 2,
    ACTIONS(24850), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621007] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27407), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621023] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27409), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621039] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27411), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621055] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27413), 1,
      anon_sym_RBRACK,
    STATE(19145), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621071] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27415), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621087] = 4,
    ACTIONS(3222), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621103] = 3,
    ACTIONS(27419), 1,
      sym_quasiquote_body,
    ACTIONS(27417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621117] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27421), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621133] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27423), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621149] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27425), 1,
      anon_sym_RBRACK,
    STATE(19176), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621165] = 3,
    ACTIONS(27429), 1,
      sym_quasiquote_body,
    ACTIONS(27427), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621179] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27431), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621195] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27433), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621211] = 2,
    ACTIONS(25669), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621223] = 3,
    ACTIONS(27437), 1,
      sym_quasiquote_body,
    ACTIONS(27435), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621237] = 4,
    ACTIONS(27439), 1,
      anon_sym_RPAREN,
    ACTIONS(27441), 1,
      sym_comma,
    STATE(18837), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621253] = 3,
    ACTIONS(27445), 1,
      sym_quasiquote_body,
    ACTIONS(27443), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621267] = 3,
    ACTIONS(27449), 1,
      sym_quasiquote_body,
    ACTIONS(27447), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621281] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27451), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621297] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27453), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621313] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27455), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621329] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27457), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621345] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27459), 1,
      anon_sym_RBRACK,
    STATE(19162), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621361] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27461), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621377] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27463), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621393] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27465), 1,
      anon_sym_RBRACE,
    STATE(19191), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621409] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27467), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621425] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27469), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621441] = 3,
    ACTIONS(27473), 1,
      sym_quasiquote_body,
    ACTIONS(27471), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621455] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27475), 1,
      anon_sym_RBRACK,
    STATE(19195), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621471] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27477), 1,
      anon_sym_RPAREN,
    STATE(19222), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621487] = 3,
    ACTIONS(27481), 1,
      sym_quasiquote_body,
    ACTIONS(27479), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621501] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27483), 1,
      anon_sym_RBRACK,
    STATE(19235), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621517] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27485), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621533] = 3,
    ACTIONS(27489), 1,
      sym_quasiquote_body,
    ACTIONS(27487), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621547] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27491), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621563] = 4,
    ACTIONS(27493), 1,
      anon_sym_LBRACE,
    ACTIONS(27495), 1,
      sym__layout_start,
    STATE(6507), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621579] = 2,
    ACTIONS(25665), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621591] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27497), 1,
      anon_sym_RBRACK,
    STATE(19150), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621607] = 3,
    STATE(1388), 1,
      sym__arrow,
    ACTIONS(27499), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621621] = 2,
    ACTIONS(21457), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621633] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27501), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621649] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27503), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621665] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27505), 1,
      anon_sym_RBRACE,
    STATE(19154), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621681] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27507), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621697] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27509), 1,
      anon_sym_RBRACE,
    STATE(19155), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621713] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27511), 1,
      anon_sym_RBRACK,
    STATE(19187), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621729] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(27513), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621745] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27515), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621761] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27517), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621777] = 2,
    ACTIONS(25659), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621789] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27519), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621805] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27521), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621821] = 2,
    ACTIONS(21914), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621833] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27523), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621849] = 3,
    ACTIONS(27527), 1,
      sym_quasiquote_body,
    ACTIONS(27525), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621863] = 3,
    ACTIONS(27531), 1,
      sym_quasiquote_body,
    ACTIONS(27529), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621877] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27533), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621893] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27535), 1,
      anon_sym_RBRACK,
    STATE(19166), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621909] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27537), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621925] = 3,
    ACTIONS(27541), 1,
      sym_quasiquote_body,
    ACTIONS(27539), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621939] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27543), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621955] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27545), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621971] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27547), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [621987] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27549), 1,
      anon_sym_RBRACK,
    STATE(19206), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622003] = 2,
    ACTIONS(25657), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622015] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27551), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622031] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27553), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622047] = 4,
    ACTIONS(3246), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622063] = 3,
    ACTIONS(27557), 1,
      sym_quasiquote_body,
    ACTIONS(27555), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622077] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27559), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622093] = 3,
    ACTIONS(27563), 1,
      sym_quasiquote_body,
    ACTIONS(27561), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622107] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27565), 1,
      anon_sym_RPAREN,
    STATE(19184), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622123] = 3,
    ACTIONS(27569), 1,
      sym_quasiquote_body,
    ACTIONS(27567), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622137] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27571), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622153] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27573), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622169] = 3,
    ACTIONS(27577), 1,
      sym_quasiquote_body,
    ACTIONS(27575), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622183] = 3,
    ACTIONS(27581), 1,
      sym_quasiquote_body,
    ACTIONS(27579), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622197] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27583), 1,
      anon_sym_RPAREN,
    STATE(19280), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622213] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27585), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622229] = 2,
    ACTIONS(24896), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622241] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27587), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622257] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27589), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622273] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27591), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622289] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27593), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622305] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27595), 1,
      anon_sym_RBRACK,
    STATE(19225), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622321] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27597), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622337] = 3,
    ACTIONS(27601), 1,
      sym_quasiquote_body,
    ACTIONS(27599), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622351] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27603), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622367] = 3,
    ACTIONS(27607), 1,
      sym_quasiquote_body,
    ACTIONS(27605), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622381] = 2,
    ACTIONS(24696), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622393] = 3,
    ACTIONS(27611), 1,
      sym_quasiquote_body,
    ACTIONS(27609), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622407] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27613), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622423] = 3,
    ACTIONS(21598), 1,
      anon_sym_in,
    ACTIONS(21596), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622437] = 2,
    ACTIONS(27615), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622449] = 4,
    ACTIONS(27617), 1,
      anon_sym_LBRACE,
    ACTIONS(27619), 1,
      sym__layout_start,
    STATE(4491), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622465] = 3,
    ACTIONS(27623), 1,
      sym_quasiquote_body,
    ACTIONS(27621), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622479] = 4,
    ACTIONS(27625), 1,
      anon_sym_LBRACE,
    ACTIONS(27627), 1,
      sym__layout_start,
    STATE(4847), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622495] = 2,
    ACTIONS(27629), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622507] = 3,
    ACTIONS(27633), 1,
      sym_quasiquote_body,
    ACTIONS(27631), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622521] = 2,
    ACTIONS(25599), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622533] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27635), 1,
      anon_sym_RBRACK,
    STATE(19109), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622549] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27637), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622565] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27639), 1,
      anon_sym_RBRACK,
    STATE(19290), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622581] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27641), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622597] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27643), 1,
      anon_sym_RPAREN,
    STATE(19213), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622613] = 2,
    ACTIONS(25599), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622625] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27645), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622641] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27647), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622657] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27649), 1,
      anon_sym_RBRACK,
    STATE(19251), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622673] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27651), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622689] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27653), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622705] = 3,
    ACTIONS(27657), 1,
      sym_quasiquote_body,
    ACTIONS(27655), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622719] = 3,
    ACTIONS(27661), 1,
      sym_quasiquote_body,
    ACTIONS(27659), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622733] = 4,
    ACTIONS(3141), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622749] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27663), 1,
      anon_sym_RPAREN,
    STATE(19289), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622765] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27665), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622781] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27667), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622797] = 2,
    ACTIONS(25599), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622809] = 2,
    ACTIONS(24270), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622821] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27669), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622837] = 3,
    ACTIONS(27673), 1,
      sym_quasiquote_body,
    ACTIONS(27671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622851] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(27675), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622867] = 3,
    ACTIONS(27679), 1,
      sym_quasiquote_body,
    ACTIONS(27677), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622881] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27681), 1,
      anon_sym_RBRACE,
    STATE(19309), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622897] = 2,
    ACTIONS(24914), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622909] = 3,
    ACTIONS(21197), 1,
      sym__varid,
    STATE(14636), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622923] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27683), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622939] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27685), 1,
      anon_sym_RBRACK,
    STATE(19295), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622955] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27687), 1,
      anon_sym_RBRACE,
    STATE(19313), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622971] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27689), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [622987] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27691), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623003] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27693), 1,
      anon_sym_RBRACK,
    STATE(19274), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623019] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27695), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623035] = 3,
    ACTIONS(27699), 1,
      sym_quasiquote_body,
    ACTIONS(27697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623049] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27701), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623065] = 3,
    ACTIONS(27705), 1,
      sym_quasiquote_body,
    ACTIONS(27703), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623079] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27707), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623095] = 3,
    ACTIONS(27711), 1,
      sym_quasiquote_body,
    ACTIONS(27709), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623109] = 3,
    ACTIONS(27715), 1,
      sym_quasiquote_body,
    ACTIONS(27713), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623123] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27717), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623139] = 2,
    ACTIONS(23781), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623151] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27719), 1,
      anon_sym_RBRACK,
    STATE(19321), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623167] = 2,
    ACTIONS(23733), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623179] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27721), 1,
      anon_sym_RBRACE,
    STATE(19310), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623195] = 3,
    ACTIONS(27725), 1,
      sym_quasiquote_body,
    ACTIONS(27723), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623209] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27727), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623225] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27729), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623241] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27731), 1,
      anon_sym_RBRACK,
    STATE(19314), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623257] = 4,
    ACTIONS(27733), 1,
      sym__immediate_dot,
    ACTIONS(27736), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623273] = 2,
    ACTIONS(27738), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623285] = 2,
    ACTIONS(27740), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623297] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27742), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623313] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27744), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623329] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27746), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623345] = 2,
    ACTIONS(23729), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623357] = 2,
    ACTIONS(25593), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623369] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27748), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623385] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27750), 1,
      anon_sym_RBRACK,
    STATE(19300), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623401] = 2,
    ACTIONS(27752), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623413] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27754), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623429] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27756), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623445] = 3,
    ACTIONS(27760), 1,
      sym_quasiquote_body,
    ACTIONS(27758), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623459] = 2,
    ACTIONS(24085), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623471] = 3,
    ACTIONS(27764), 1,
      sym_quasiquote_body,
    ACTIONS(27762), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623485] = 3,
    ACTIONS(27768), 1,
      sym_quasiquote_body,
    ACTIONS(27766), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623499] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27770), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623515] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27772), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623531] = 4,
    ACTIONS(3244), 1,
      sym_comma,
    ACTIONS(27774), 1,
      anon_sym_RPAREN,
    STATE(18155), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623547] = 2,
    ACTIONS(27752), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623559] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27776), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623575] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27778), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623591] = 2,
    ACTIONS(27780), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623603] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27782), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623619] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27784), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623635] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27786), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623651] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27788), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623667] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27790), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623683] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27792), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623699] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27794), 1,
      anon_sym_RBRACK,
    STATE(19317), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623715] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27796), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623731] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27798), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623747] = 3,
    ACTIONS(27802), 1,
      sym_quasiquote_body,
    ACTIONS(27800), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623761] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27804), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623777] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27806), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623793] = 3,
    ACTIONS(27810), 1,
      sym_quasiquote_body,
    ACTIONS(27808), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623807] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27812), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623823] = 3,
    ACTIONS(27816), 1,
      sym_quasiquote_body,
    ACTIONS(27814), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623837] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27818), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623853] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27820), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623869] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27822), 1,
      anon_sym_RBRACK,
    STATE(19318), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623885] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27824), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623901] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27826), 1,
      anon_sym_RBRACK,
    STATE(19334), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623917] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27828), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623933] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27830), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623949] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(27832), 1,
      anon_sym_RBRACE,
    STATE(19319), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623965] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27834), 1,
      anon_sym_RBRACE,
    STATE(19320), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623981] = 3,
    ACTIONS(27838), 1,
      sym_quasiquote_body,
    ACTIONS(27836), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [623995] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(27840), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624011] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27842), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624027] = 3,
    ACTIONS(27846), 1,
      sym_quasiquote_body,
    ACTIONS(27844), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624041] = 2,
    ACTIONS(3577), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624053] = 3,
    ACTIONS(27850), 1,
      sym_quasiquote_body,
    ACTIONS(27848), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624067] = 3,
    ACTIONS(27854), 1,
      sym_quasiquote_body,
    ACTIONS(27852), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624081] = 3,
    ACTIONS(27858), 1,
      sym_quasiquote_body,
    ACTIONS(27856), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624095] = 3,
    ACTIONS(27862), 1,
      sym_quasiquote_body,
    ACTIONS(27860), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624109] = 2,
    ACTIONS(24437), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624121] = 3,
    ACTIONS(27866), 1,
      sym_quasiquote_body,
    ACTIONS(27864), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624135] = 2,
    ACTIONS(17575), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624147] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27868), 1,
      anon_sym_RBRACK,
    STATE(19329), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624163] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27870), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624179] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27872), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624195] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27874), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624211] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27876), 1,
      anon_sym_RBRACK,
    STATE(19355), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624227] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27878), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624243] = 4,
    ACTIONS(27880), 1,
      anon_sym_LBRACE,
    ACTIONS(27882), 1,
      sym__layout_start,
    STATE(11668), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624259] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27884), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624275] = 3,
    ACTIONS(27888), 1,
      sym_quasiquote_body,
    ACTIONS(27886), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624289] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27890), 1,
      anon_sym_RPAREN,
    STATE(19429), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624305] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27892), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624321] = 3,
    ACTIONS(27896), 1,
      sym_quasiquote_body,
    ACTIONS(27894), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624335] = 2,
    ACTIONS(27898), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624347] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27900), 1,
      anon_sym_RBRACK,
    STATE(19439), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624363] = 3,
    ACTIONS(27904), 1,
      sym_quasiquote_body,
    ACTIONS(27902), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624377] = 4,
    ACTIONS(27906), 1,
      anon_sym_LBRACE,
    ACTIONS(27908), 1,
      sym__layout_start,
    STATE(5901), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624393] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    ACTIONS(27910), 1,
      anon_sym_LPAREN,
    STATE(15374), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624409] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27912), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624425] = 3,
    ACTIONS(27916), 1,
      sym_quasiquote_body,
    ACTIONS(27914), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624439] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27918), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624455] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27920), 1,
      anon_sym_RPAREN,
    STATE(19399), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624471] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(23093), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624487] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27922), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624503] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27924), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624519] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27926), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624535] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(27928), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624551] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27930), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624567] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27932), 1,
      anon_sym_RBRACK,
    STATE(19378), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624583] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27934), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624599] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27936), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624615] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27938), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624631] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27940), 1,
      anon_sym_RBRACK,
    STATE(19403), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624647] = 3,
    ACTIONS(27944), 1,
      sym_quasiquote_body,
    ACTIONS(27942), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624661] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(27946), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624677] = 3,
    ACTIONS(21584), 1,
      anon_sym_in,
    ACTIONS(21582), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624691] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27948), 1,
      anon_sym_RPAREN,
    STATE(19259), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624707] = 3,
    ACTIONS(27952), 1,
      sym_quasiquote_body,
    ACTIONS(27950), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624721] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27954), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624737] = 3,
    ACTIONS(27958), 1,
      sym_quasiquote_body,
    ACTIONS(27956), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624751] = 3,
    ACTIONS(27962), 1,
      sym_quasiquote_body,
    ACTIONS(27960), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624765] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27964), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624781] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(27966), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624797] = 2,
    ACTIONS(25161), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624809] = 3,
    STATE(1439), 1,
      sym__arrow,
    ACTIONS(27968), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624823] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27970), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624839] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(27972), 1,
      anon_sym_RBRACE,
    STATE(19418), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624855] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27974), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624871] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(27976), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624887] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27978), 1,
      anon_sym_RBRACK,
    STATE(19398), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624903] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(27980), 1,
      anon_sym_RBRACK,
    STATE(19422), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624919] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27982), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624935] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(27984), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624951] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(27986), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624967] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(27988), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624983] = 3,
    ACTIONS(27992), 1,
      sym_quasiquote_body,
    ACTIONS(27990), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [624997] = 3,
    ACTIONS(27996), 1,
      sym_quasiquote_body,
    ACTIONS(27994), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625011] = 3,
    ACTIONS(28000), 1,
      sym_quasiquote_body,
    ACTIONS(27998), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625025] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28002), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625041] = 2,
    ACTIONS(25467), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625053] = 3,
    ACTIONS(28006), 1,
      sym_quasiquote_body,
    ACTIONS(28004), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625067] = 2,
    ACTIONS(28008), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625079] = 4,
    ACTIONS(3207), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625095] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28010), 1,
      anon_sym_RPAREN,
    STATE(19480), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625111] = 2,
    ACTIONS(21534), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625123] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28012), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625139] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28014), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625155] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28016), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625171] = 2,
    ACTIONS(21662), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625183] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28018), 1,
      anon_sym_RBRACK,
    STATE(19417), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625199] = 4,
    ACTIONS(28020), 1,
      anon_sym_LBRACE,
    ACTIONS(28022), 1,
      sym__layout_start,
    STATE(5527), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625215] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28024), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625231] = 2,
    ACTIONS(28026), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625243] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28028), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625259] = 4,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625275] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28030), 1,
      anon_sym_RBRACK,
    STATE(19374), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625291] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28032), 1,
      anon_sym_RPAREN,
    STATE(19385), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625307] = 3,
    ACTIONS(28036), 1,
      sym_quasiquote_body,
    ACTIONS(28034), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625321] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28038), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625337] = 2,
    ACTIONS(21430), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625349] = 2,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625361] = 3,
    ACTIONS(28042), 1,
      sym_quasiquote_body,
    ACTIONS(28040), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625375] = 3,
    ACTIONS(28046), 1,
      sym_quasiquote_body,
    ACTIONS(28044), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625389] = 3,
    ACTIONS(28050), 1,
      sym_quasiquote_body,
    ACTIONS(28048), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625403] = 2,
    ACTIONS(22771), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625415] = 2,
    ACTIONS(21428), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625427] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(28052), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625443] = 3,
    ACTIONS(28056), 1,
      sym_quasiquote_body,
    ACTIONS(28054), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625457] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28058), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625473] = 2,
    ACTIONS(22004), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625485] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28060), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625501] = 2,
    ACTIONS(21867), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625513] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(28062), 1,
      anon_sym_RPAREN,
    STATE(19010), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625529] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28064), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625545] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28066), 1,
      anon_sym_RBRACK,
    STATE(19444), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625561] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28068), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625577] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28070), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625593] = 3,
    ACTIONS(21397), 1,
      anon_sym_in,
    ACTIONS(21395), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625607] = 3,
    ACTIONS(28074), 1,
      sym_quasiquote_body,
    ACTIONS(28072), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625621] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28076), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625637] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(28078), 1,
      anon_sym_RPAREN,
    STATE(19022), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625653] = 3,
    ACTIONS(28082), 1,
      sym_quasiquote_body,
    ACTIONS(28080), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625667] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28084), 1,
      anon_sym_RBRACK,
    STATE(19497), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625683] = 3,
    ACTIONS(28088), 1,
      sym_quasiquote_body,
    ACTIONS(28086), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625697] = 3,
    ACTIONS(28092), 1,
      sym_quasiquote_body,
    ACTIONS(28090), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625711] = 2,
    ACTIONS(21395), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625723] = 3,
    ACTIONS(28096), 1,
      sym_quasiquote_body,
    ACTIONS(28094), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625737] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28098), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625753] = 2,
    ACTIONS(28100), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625765] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28102), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625781] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28104), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625797] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(28106), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625813] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28108), 1,
      anon_sym_RBRACK,
    STATE(19461), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625829] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28110), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625845] = 4,
    ACTIONS(3224), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625861] = 3,
    ACTIONS(28114), 1,
      sym_quasiquote_body,
    ACTIONS(28112), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625875] = 3,
    ACTIONS(28118), 1,
      sym_quasiquote_body,
    ACTIONS(28116), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625889] = 4,
    ACTIONS(3234), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625905] = 2,
    ACTIONS(21582), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625917] = 3,
    ACTIONS(28122), 1,
      sym_quasiquote_body,
    ACTIONS(28120), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625931] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28124), 1,
      anon_sym_RBRACE,
    STATE(19502), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625947] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28126), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625963] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28128), 1,
      anon_sym_RBRACK,
    STATE(19479), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625979] = 3,
    ACTIONS(28132), 1,
      sym_quasiquote_body,
    ACTIONS(28130), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [625993] = 2,
    ACTIONS(23092), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626005] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28134), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626021] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28136), 1,
      anon_sym_RBRACE,
    STATE(19507), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626037] = 4,
    ACTIONS(28138), 1,
      anon_sym_RPAREN,
    ACTIONS(28140), 1,
      sym_comma,
    STATE(19478), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626053] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28143), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626069] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28145), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626085] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28147), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626101] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28149), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626117] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28151), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626133] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28153), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626149] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28155), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626165] = 4,
    ACTIONS(25087), 1,
      sym_comma,
    ACTIONS(28157), 1,
      anon_sym_RBRACE,
    STATE(19038), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626181] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28159), 1,
      anon_sym_RBRACK,
    STATE(19483), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626197] = 3,
    ACTIONS(28163), 1,
      sym_quasiquote_body,
    ACTIONS(28161), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626211] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28165), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626227] = 3,
    ACTIONS(28169), 1,
      sym_quasiquote_body,
    ACTIONS(28167), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626241] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28171), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626257] = 3,
    ACTIONS(28175), 1,
      sym_quasiquote_body,
    ACTIONS(28173), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626271] = 2,
    ACTIONS(23076), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626283] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28177), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626299] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28179), 1,
      anon_sym_RBRACK,
    STATE(19516), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626315] = 3,
    ACTIONS(28183), 1,
      sym_quasiquote_body,
    ACTIONS(28181), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626329] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28185), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626345] = 3,
    ACTIONS(28189), 1,
      sym_quasiquote_body,
    ACTIONS(28187), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626359] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28191), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626375] = 3,
    ACTIONS(28195), 1,
      sym_quasiquote_body,
    ACTIONS(28193), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626389] = 4,
    ACTIONS(3081), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626405] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28197), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626421] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28199), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626437] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28201), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626453] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28203), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626469] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28205), 1,
      anon_sym_RBRACK,
    STATE(19512), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626485] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28207), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626501] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28209), 1,
      anon_sym_RBRACK,
    STATE(19504), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626517] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28211), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626533] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28213), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626549] = 4,
    ACTIONS(3089), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626565] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28215), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626581] = 3,
    ACTIONS(28219), 1,
      sym_quasiquote_body,
    ACTIONS(28217), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626595] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28221), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626611] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28223), 1,
      anon_sym_RBRACK,
    STATE(19476), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626627] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28225), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626643] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28227), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626659] = 3,
    ACTIONS(28231), 1,
      sym_quasiquote_body,
    ACTIONS(28229), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626673] = 3,
    ACTIONS(28235), 1,
      sym_quasiquote_body,
    ACTIONS(28233), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626687] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28237), 1,
      anon_sym_RBRACE,
    STATE(19484), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626703] = 3,
    ACTIONS(28241), 1,
      sym_quasiquote_body,
    ACTIONS(28239), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626717] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28243), 1,
      anon_sym_RBRACE,
    STATE(19485), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626733] = 3,
    ACTIONS(28247), 1,
      sym_quasiquote_body,
    ACTIONS(28245), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626747] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28249), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626763] = 2,
    ACTIONS(25424), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626775] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(28251), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626791] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28253), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626807] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28255), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626823] = 2,
    ACTIONS(21596), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626835] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28257), 1,
      anon_sym_RBRACK,
    STATE(19528), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626851] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28259), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626867] = 3,
    ACTIONS(28263), 1,
      sym_quasiquote_body,
    ACTIONS(28261), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626881] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28265), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626897] = 4,
    ACTIONS(3215), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626913] = 3,
    ACTIONS(28269), 1,
      sym_quasiquote_body,
    ACTIONS(28267), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626927] = 2,
    ACTIONS(23725), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626939] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28271), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626955] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28273), 1,
      anon_sym_RBRACK,
    STATE(19542), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626971] = 3,
    ACTIONS(28277), 1,
      sym_quasiquote_body,
    ACTIONS(28275), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [626985] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28279), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627001] = 3,
    ACTIONS(28283), 1,
      sym_quasiquote_body,
    ACTIONS(28281), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627015] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28285), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627031] = 3,
    ACTIONS(28289), 1,
      sym_quasiquote_body,
    ACTIONS(28287), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627045] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28291), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627061] = 3,
    ACTIONS(28295), 1,
      sym_quasiquote_body,
    ACTIONS(28293), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627075] = 2,
    ACTIONS(23102), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627087] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28297), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627103] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28299), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627119] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28301), 1,
      anon_sym_RBRACK,
    STATE(19548), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627135] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28303), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627151] = 3,
    ACTIONS(28307), 1,
      sym_quasiquote_body,
    ACTIONS(28305), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627165] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28309), 1,
      anon_sym_RBRACK,
    STATE(19509), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627181] = 3,
    ACTIONS(28313), 1,
      sym_quasiquote_body,
    ACTIONS(28311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627195] = 4,
    ACTIONS(3065), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627211] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28315), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627227] = 3,
    ACTIONS(28319), 1,
      sym_quasiquote_body,
    ACTIONS(28317), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627241] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28321), 1,
      anon_sym_RPAREN,
    STATE(19606), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627257] = 3,
    ACTIONS(28325), 1,
      sym_quasiquote_body,
    ACTIONS(28323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627271] = 2,
    ACTIONS(23138), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627283] = 3,
    ACTIONS(28329), 1,
      sym_quasiquote_body,
    ACTIONS(28327), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627297] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28331), 1,
      anon_sym_RBRACK,
    STATE(19619), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627313] = 3,
    ACTIONS(28335), 1,
      sym_quasiquote_body,
    ACTIONS(28333), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627327] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28337), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627343] = 4,
    ACTIONS(28339), 1,
      anon_sym_LBRACE,
    ACTIONS(28341), 1,
      sym__layout_start,
    STATE(5970), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627359] = 2,
    ACTIONS(23609), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627371] = 2,
    ACTIONS(23607), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627383] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28343), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627399] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28345), 1,
      anon_sym_RBRACK,
    STATE(19572), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627415] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28347), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627431] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28349), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627447] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28351), 1,
      anon_sym_RBRACK,
    STATE(19570), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627463] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28353), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627479] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28355), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627495] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28357), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627511] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28359), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627527] = 4,
    ACTIONS(28361), 1,
      anon_sym_RPAREN,
    ACTIONS(28363), 1,
      sym_comma,
    STATE(19576), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627543] = 3,
    ACTIONS(28368), 1,
      sym_quasiquote_body,
    ACTIONS(28366), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627557] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28370), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627573] = 3,
    ACTIONS(28374), 1,
      sym_quasiquote_body,
    ACTIONS(28372), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627587] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(28376), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627603] = 3,
    ACTIONS(28380), 1,
      sym_quasiquote_body,
    ACTIONS(28378), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627617] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28382), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627633] = 3,
    ACTIONS(28386), 1,
      sym_quasiquote_body,
    ACTIONS(28384), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627647] = 3,
    ACTIONS(28390), 1,
      sym_quasiquote_body,
    ACTIONS(28388), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627661] = 2,
    ACTIONS(24696), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627673] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28392), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627689] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28394), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627705] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28396), 1,
      anon_sym_RBRACK,
    STATE(19587), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627721] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28398), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627737] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28400), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627753] = 3,
    ACTIONS(28404), 1,
      sym_quasiquote_body,
    ACTIONS(28402), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627767] = 3,
    ACTIONS(28408), 1,
      sym_quasiquote_body,
    ACTIONS(28406), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627781] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28410), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627797] = 3,
    ACTIONS(28414), 1,
      sym_quasiquote_body,
    ACTIONS(28412), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627811] = 3,
    ACTIONS(28418), 1,
      sym_quasiquote_body,
    ACTIONS(28416), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627825] = 3,
    ACTIONS(28422), 1,
      sym_quasiquote_body,
    ACTIONS(28420), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627839] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28424), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627855] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28426), 1,
      anon_sym_RBRACK,
    STATE(19602), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627871] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28428), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627887] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28430), 1,
      anon_sym_RPAREN,
    STATE(19524), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627903] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28432), 1,
      anon_sym_RPAREN,
    STATE(19644), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627919] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28434), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627935] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28436), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627951] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28438), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627967] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28440), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627983] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28442), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [627999] = 4,
    ACTIONS(27351), 1,
      sym_comma,
    ACTIONS(28444), 1,
      anon_sym_RPAREN,
    STATE(19120), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628015] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28446), 1,
      anon_sym_RPAREN,
    STATE(19517), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628031] = 4,
    ACTIONS(27351), 1,
      sym_comma,
    ACTIONS(28448), 1,
      anon_sym_RPAREN,
    STATE(19123), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628047] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28450), 1,
      anon_sym_RBRACK,
    STATE(19605), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628063] = 3,
    ACTIONS(28454), 1,
      sym_quasiquote_body,
    ACTIONS(28452), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628077] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28456), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628093] = 3,
    ACTIONS(28460), 1,
      sym_quasiquote_body,
    ACTIONS(28458), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628107] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28462), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628123] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28464), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628139] = 3,
    ACTIONS(28468), 1,
      sym_quasiquote_body,
    ACTIONS(28466), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628153] = 3,
    ACTIONS(28472), 1,
      sym_quasiquote_body,
    ACTIONS(28470), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628167] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(28474), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628183] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28476), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628199] = 3,
    ACTIONS(28480), 1,
      sym_quasiquote_body,
    ACTIONS(28478), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628213] = 3,
    ACTIONS(28484), 1,
      sym_quasiquote_body,
    ACTIONS(28482), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628227] = 3,
    ACTIONS(28488), 1,
      sym_quasiquote_body,
    ACTIONS(28486), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628241] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28490), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628257] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28492), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628273] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28494), 1,
      anon_sym_RBRACK,
    STATE(19659), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628289] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28496), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628305] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28498), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628321] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28500), 1,
      anon_sym_RBRACK,
    STATE(19632), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628337] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28502), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628353] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28504), 1,
      anon_sym_RBRACK,
    STATE(19629), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628369] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28506), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628385] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28508), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628401] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28510), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628417] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28512), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628433] = 3,
    ACTIONS(28516), 1,
      sym_quasiquote_body,
    ACTIONS(28514), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628447] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28518), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628463] = 3,
    ACTIONS(28522), 1,
      sym_quasiquote_body,
    ACTIONS(28520), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628477] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(28524), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628493] = 3,
    ACTIONS(28528), 1,
      sym_quasiquote_body,
    ACTIONS(28526), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628507] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28530), 1,
      anon_sym_RBRACE,
    STATE(19677), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628523] = 3,
    ACTIONS(28534), 1,
      sym_quasiquote_body,
    ACTIONS(28532), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628537] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28536), 1,
      anon_sym_RBRACE,
    STATE(19679), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628553] = 3,
    ACTIONS(28540), 1,
      sym_quasiquote_body,
    ACTIONS(28538), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628567] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28542), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628583] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28544), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628599] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28546), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628615] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28548), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628631] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28550), 1,
      anon_sym_RBRACK,
    STATE(19647), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628647] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28552), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628663] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28554), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628679] = 3,
    ACTIONS(28558), 1,
      sym_quasiquote_body,
    ACTIONS(28556), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628693] = 3,
    ACTIONS(28562), 1,
      sym_quasiquote_body,
    ACTIONS(28560), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628707] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28564), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628723] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28566), 1,
      anon_sym_RBRACK,
    STATE(19680), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628739] = 3,
    ACTIONS(28570), 1,
      sym_quasiquote_body,
    ACTIONS(28568), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628753] = 3,
    ACTIONS(28574), 1,
      sym_quasiquote_body,
    ACTIONS(28572), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628767] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28576), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628783] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28578), 1,
      anon_sym_RBRACK,
    STATE(19662), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628799] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28580), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628815] = 2,
    ACTIONS(25091), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628827] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28582), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628843] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28584), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628859] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28586), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628875] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28588), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628891] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28590), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628907] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28592), 1,
      anon_sym_RBRACK,
    STATE(19665), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628923] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28594), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628939] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28596), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628955] = 4,
    ACTIONS(20354), 1,
      anon_sym_RPAREN,
    ACTIONS(28598), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628971] = 3,
    ACTIONS(28602), 1,
      sym_quasiquote_body,
    ACTIONS(28600), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628985] = 3,
    ACTIONS(28606), 1,
      sym_quasiquote_body,
    ACTIONS(28604), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [628999] = 2,
    ACTIONS(21624), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629011] = 3,
    ACTIONS(28610), 1,
      sym_quasiquote_body,
    ACTIONS(28608), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629025] = 4,
    ACTIONS(28612), 1,
      anon_sym_RPAREN,
    ACTIONS(28614), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629041] = 3,
    ACTIONS(21664), 1,
      anon_sym_in,
    ACTIONS(21662), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629055] = 3,
    ACTIONS(28619), 1,
      sym_quasiquote_body,
    ACTIONS(28617), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629069] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28621), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629085] = 3,
    ACTIONS(28625), 1,
      sym_quasiquote_body,
    ACTIONS(28623), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629099] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28627), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629115] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28629), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629131] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28631), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629147] = 3,
    ACTIONS(28635), 1,
      sym_quasiquote_body,
    ACTIONS(28633), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629161] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28637), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629177] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28639), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629193] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28641), 1,
      anon_sym_RBRACK,
    STATE(19684), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629209] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28643), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629225] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28645), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629241] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28647), 1,
      anon_sym_RBRACK,
    STATE(19692), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629257] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28649), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629273] = 3,
    ACTIONS(28653), 1,
      sym_quasiquote_body,
    ACTIONS(28651), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629287] = 2,
    ACTIONS(21234), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629299] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28655), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629315] = 3,
    ACTIONS(28659), 1,
      sym_quasiquote_body,
    ACTIONS(28657), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629329] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28661), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629345] = 4,
    ACTIONS(28663), 1,
      anon_sym_LBRACE,
    ACTIONS(28665), 1,
      sym__layout_start,
    STATE(13077), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629361] = 3,
    ACTIONS(28669), 1,
      sym_quasiquote_body,
    ACTIONS(28667), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629375] = 2,
    ACTIONS(25402), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629387] = 2,
    ACTIONS(21610), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629399] = 3,
    ACTIONS(28673), 1,
      sym_quasiquote_body,
    ACTIONS(28671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629413] = 2,
    ACTIONS(21670), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629425] = 3,
    ACTIONS(28677), 1,
      sym_quasiquote_body,
    ACTIONS(28675), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629439] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28679), 1,
      anon_sym_RBRACK,
    STATE(19578), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629455] = 3,
    ACTIONS(28683), 1,
      sym_quasiquote_body,
    ACTIONS(28681), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629469] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28685), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629485] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28687), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629501] = 3,
    ACTIONS(28691), 1,
      sym_quasiquote_body,
    ACTIONS(28689), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629515] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28693), 1,
      anon_sym_RBRACK,
    STATE(19705), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629531] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28695), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629547] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28697), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629563] = 3,
    ACTIONS(28701), 1,
      sym_quasiquote_body,
    ACTIONS(28699), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629577] = 3,
    ACTIONS(28705), 1,
      sym_quasiquote_body,
    ACTIONS(28703), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629591] = 3,
    ACTIONS(28709), 1,
      sym_quasiquote_body,
    ACTIONS(28707), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629605] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28711), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629621] = 3,
    ACTIONS(28715), 1,
      sym_quasiquote_body,
    ACTIONS(28713), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629635] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28717), 1,
      anon_sym_RPAREN,
    STATE(19774), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629651] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28719), 1,
      anon_sym_RBRACK,
    STATE(19788), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629667] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28721), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629683] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28723), 1,
      anon_sym_RBRACK,
    STATE(19722), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629699] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28725), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629715] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28727), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629731] = 2,
    ACTIONS(20374), 3,
      sym__varsym,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629743] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28729), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629759] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28731), 1,
      anon_sym_RBRACK,
    STATE(19720), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629775] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28733), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629791] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28735), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629807] = 4,
    ACTIONS(27441), 1,
      sym_comma,
    ACTIONS(28737), 1,
      anon_sym_RPAREN,
    STATE(19158), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629823] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28739), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629839] = 3,
    ACTIONS(28743), 1,
      sym_quasiquote_body,
    ACTIONS(28741), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629853] = 4,
    ACTIONS(28745), 1,
      anon_sym_LBRACE,
    ACTIONS(28747), 1,
      sym__layout_start,
    STATE(6259), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629869] = 2,
    ACTIONS(23410), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629881] = 3,
    ACTIONS(28751), 1,
      sym_quasiquote_body,
    ACTIONS(28749), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629895] = 2,
    ACTIONS(23523), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629907] = 3,
    ACTIONS(28755), 1,
      sym_quasiquote_body,
    ACTIONS(28753), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629921] = 2,
    ACTIONS(23527), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629933] = 3,
    ACTIONS(28759), 1,
      sym_quasiquote_body,
    ACTIONS(28757), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629947] = 3,
    ACTIONS(28763), 1,
      sym_quasiquote_body,
    ACTIONS(28761), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629961] = 3,
    ACTIONS(28767), 1,
      sym_quasiquote_body,
    ACTIONS(28765), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629975] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28769), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [629991] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28771), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630007] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28773), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630023] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28775), 1,
      anon_sym_RBRACK,
    STATE(19739), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630039] = 3,
    ACTIONS(28779), 1,
      sym_quasiquote_body,
    ACTIONS(28777), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630053] = 4,
    ACTIONS(3209), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630069] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28781), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630085] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28783), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630101] = 3,
    ACTIONS(28787), 1,
      sym_quasiquote_body,
    ACTIONS(28785), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630115] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28789), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630131] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28791), 1,
      anon_sym_RBRACK,
    STATE(19752), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630147] = 2,
    ACTIONS(25127), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630159] = 3,
    ACTIONS(28795), 1,
      sym_quasiquote_body,
    ACTIONS(28793), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630173] = 3,
    ACTIONS(28799), 1,
      sym_quasiquote_body,
    ACTIONS(28797), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630187] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28801), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630203] = 3,
    ACTIONS(28805), 1,
      sym_quasiquote_body,
    ACTIONS(28803), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630217] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28807), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630233] = 4,
    ACTIONS(20405), 1,
      anon_sym_RPAREN,
    ACTIONS(28809), 1,
      sym_comma,
    STATE(19674), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630249] = 4,
    ACTIONS(20405), 1,
      anon_sym_RPAREN,
    ACTIONS(28809), 1,
      sym_comma,
    STATE(19669), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630265] = 2,
    ACTIONS(21351), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630277] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28811), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630293] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28813), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630309] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28815), 1,
      anon_sym_RBRACK,
    STATE(19759), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630325] = 3,
    ACTIONS(28819), 1,
      sym_quasiquote_body,
    ACTIONS(28817), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630339] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28821), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630355] = 3,
    ACTIONS(28825), 1,
      sym_quasiquote_body,
    ACTIONS(28823), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630369] = 4,
    ACTIONS(3199), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630385] = 2,
    ACTIONS(21328), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630397] = 3,
    ACTIONS(28829), 1,
      sym_quasiquote_body,
    ACTIONS(28827), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630411] = 3,
    ACTIONS(28833), 1,
      sym_quasiquote_body,
    ACTIONS(28831), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630425] = 3,
    ACTIONS(28837), 1,
      sym_quasiquote_body,
    ACTIONS(28835), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630439] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28839), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630455] = 3,
    ACTIONS(28843), 1,
      sym_quasiquote_body,
    ACTIONS(28841), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630469] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28845), 1,
      anon_sym_RPAREN,
    STATE(19820), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630485] = 3,
    ACTIONS(28849), 1,
      sym_quasiquote_body,
    ACTIONS(28847), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630499] = 4,
    ACTIONS(3067), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630515] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28851), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630531] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28853), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630547] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28855), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630563] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28857), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630579] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28859), 1,
      anon_sym_RBRACK,
    STATE(19782), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630595] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(28861), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630611] = 3,
    ACTIONS(21620), 1,
      anon_sym_in,
    ACTIONS(21618), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630625] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28863), 1,
      anon_sym_RBRACK,
    STATE(19776), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630641] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28865), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630657] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28867), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630673] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28869), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630689] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28871), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630705] = 3,
    ACTIONS(28875), 1,
      sym_quasiquote_body,
    ACTIONS(28873), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630719] = 2,
    ACTIONS(21326), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630731] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(28877), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630747] = 3,
    ACTIONS(28881), 1,
      sym_quasiquote_body,
    ACTIONS(28879), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630761] = 3,
    ACTIONS(28885), 1,
      sym_quasiquote_body,
    ACTIONS(28883), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630775] = 3,
    ACTIONS(28889), 1,
      sym_quasiquote_body,
    ACTIONS(28887), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630789] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28891), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630805] = 3,
    ACTIONS(28895), 1,
      sym_quasiquote_body,
    ACTIONS(28893), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630819] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28897), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630835] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28899), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630851] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28901), 1,
      anon_sym_RBRACK,
    STATE(19826), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630867] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28903), 1,
      anon_sym_RBRACK,
    STATE(19795), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630883] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28905), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630899] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28907), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630915] = 3,
    ACTIONS(28911), 1,
      sym_quasiquote_body,
    ACTIONS(28909), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630929] = 3,
    ACTIONS(28915), 1,
      sym_quasiquote_body,
    ACTIONS(28913), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630943] = 3,
    ACTIONS(28919), 1,
      sym_quasiquote_body,
    ACTIONS(28917), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630957] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28921), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630973] = 3,
    ACTIONS(28925), 1,
      sym_quasiquote_body,
    ACTIONS(28923), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [630987] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(28927), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631003] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(28929), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631019] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28931), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631035] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28933), 1,
      anon_sym_RBRACK,
    STATE(19812), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631051] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(28935), 1,
      anon_sym_RBRACE,
    STATE(19840), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631067] = 2,
    ACTIONS(23717), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631079] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(28937), 1,
      anon_sym_RBRACE,
    STATE(19933), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631095] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28939), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631111] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28941), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631127] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28943), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631143] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28945), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631159] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28947), 1,
      anon_sym_RBRACK,
    STATE(19815), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631175] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28949), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631191] = 4,
    ACTIONS(3201), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631207] = 3,
    ACTIONS(28953), 1,
      sym_quasiquote_body,
    ACTIONS(28951), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631221] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(28955), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631237] = 3,
    ACTIONS(28959), 1,
      sym_quasiquote_body,
    ACTIONS(28957), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631251] = 3,
    ACTIONS(28963), 1,
      sym_quasiquote_body,
    ACTIONS(28961), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631265] = 3,
    ACTIONS(28967), 1,
      sym_quasiquote_body,
    ACTIONS(28965), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631279] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(28969), 1,
      anon_sym_RBRACK,
    STATE(19845), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631295] = 3,
    ACTIONS(28973), 1,
      sym_quasiquote_body,
    ACTIONS(28971), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631309] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28975), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631325] = 4,
    ACTIONS(19749), 1,
      anon_sym_RPAREN,
    ACTIONS(28977), 1,
      sym_comma,
    STATE(19576), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631341] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28979), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631357] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28981), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631373] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(28983), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631389] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28985), 1,
      anon_sym_RBRACK,
    STATE(19829), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631405] = 3,
    ACTIONS(28989), 1,
      sym_quasiquote_body,
    ACTIONS(28987), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631419] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(28991), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631435] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28993), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631451] = 4,
    ACTIONS(3123), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631467] = 3,
    ACTIONS(28997), 1,
      sym_quasiquote_body,
    ACTIONS(28995), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631481] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(28999), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631497] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29001), 1,
      anon_sym_RBRACK,
    STATE(19842), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631513] = 3,
    ACTIONS(29005), 1,
      sym_quasiquote_body,
    ACTIONS(29003), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631527] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29007), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631543] = 3,
    ACTIONS(29011), 1,
      sym_quasiquote_body,
    ACTIONS(29009), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631557] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29013), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631573] = 2,
    ACTIONS(25129), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631585] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29015), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631601] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29017), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631617] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29019), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631633] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29021), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631649] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(29023), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631665] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29025), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631681] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29027), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631697] = 3,
    ACTIONS(29031), 1,
      sym_quasiquote_body,
    ACTIONS(29029), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631711] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29033), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631727] = 3,
    ACTIONS(29037), 1,
      sym_quasiquote_body,
    ACTIONS(29035), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631741] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29039), 1,
      anon_sym_RBRACK,
    STATE(19852), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631757] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29041), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631773] = 4,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631789] = 3,
    ACTIONS(29045), 1,
      sym_quasiquote_body,
    ACTIONS(29043), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631803] = 3,
    ACTIONS(29049), 1,
      sym_quasiquote_body,
    ACTIONS(29047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631817] = 3,
    ACTIONS(29053), 1,
      sym_quasiquote_body,
    ACTIONS(29051), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631831] = 2,
    ACTIONS(23221), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631843] = 2,
    ACTIONS(21618), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631855] = 3,
    ACTIONS(29057), 1,
      sym_quasiquote_body,
    ACTIONS(29055), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631869] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29059), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631885] = 2,
    ACTIONS(21662), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631897] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29061), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631913] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29063), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631929] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29065), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631945] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29067), 1,
      anon_sym_RBRACK,
    STATE(19872), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631961] = 3,
    ACTIONS(29071), 1,
      sym_quasiquote_body,
    ACTIONS(29069), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631975] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29073), 1,
      anon_sym_RBRACK,
    STATE(19866), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [631991] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29075), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632007] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29077), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632023] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29079), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632039] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29081), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632055] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29083), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632071] = 3,
    ACTIONS(29087), 1,
      sym_quasiquote_body,
    ACTIONS(29085), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632085] = 2,
    ACTIONS(21395), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632097] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29089), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632113] = 3,
    ACTIONS(29093), 1,
      sym_quasiquote_body,
    ACTIONS(29091), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632127] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29095), 1,
      anon_sym_RBRACK,
    STATE(19846), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632143] = 3,
    ACTIONS(29099), 1,
      sym_quasiquote_body,
    ACTIONS(29097), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632157] = 3,
    ACTIONS(29103), 1,
      sym_quasiquote_body,
    ACTIONS(29101), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632171] = 3,
    ACTIONS(29107), 1,
      sym_quasiquote_body,
    ACTIONS(29105), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632185] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(29109), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632201] = 2,
    ACTIONS(29111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632213] = 3,
    ACTIONS(29115), 1,
      sym_quasiquote_body,
    ACTIONS(29113), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632227] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29117), 1,
      anon_sym_RPAREN,
    STATE(20048), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632243] = 2,
    ACTIONS(21471), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632255] = 2,
    ACTIONS(21582), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632267] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29119), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632283] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29121), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632299] = 3,
    ACTIONS(29125), 1,
      sym_quasiquote_body,
    ACTIONS(29123), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632313] = 4,
    ACTIONS(3240), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632329] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29127), 1,
      anon_sym_RBRACK,
    STATE(19955), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632345] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29129), 1,
      anon_sym_RBRACK,
    STATE(19891), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632361] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29131), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632377] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29133), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632393] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29135), 1,
      anon_sym_RBRACK,
    STATE(19902), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632409] = 4,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632425] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29137), 1,
      anon_sym_RBRACE,
    STATE(19849), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632441] = 3,
    ACTIONS(29141), 1,
      sym_quasiquote_body,
    ACTIONS(29139), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632455] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29143), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632471] = 4,
    ACTIONS(29145), 1,
      anon_sym_LBRACE,
    ACTIONS(29147), 1,
      sym__layout_start,
    STATE(13658), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632487] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29149), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632503] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29151), 1,
      anon_sym_RBRACE,
    STATE(19850), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632519] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(29153), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632535] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(29155), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632551] = 3,
    ACTIONS(29159), 1,
      sym_quasiquote_body,
    ACTIONS(29157), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632565] = 2,
    ACTIONS(24374), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632577] = 3,
    ACTIONS(29163), 1,
      sym_quasiquote_body,
    ACTIONS(29161), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632591] = 3,
    ACTIONS(29167), 1,
      sym_quasiquote_body,
    ACTIONS(29165), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632605] = 2,
    ACTIONS(7530), 3,
      sym__dot,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632617] = 3,
    ACTIONS(29171), 1,
      sym_quasiquote_body,
    ACTIONS(29169), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632631] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29173), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632647] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29175), 1,
      anon_sym_RBRACK,
    STATE(19878), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632663] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29177), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632679] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29179), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632695] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(29181), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632711] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29183), 1,
      anon_sym_RBRACK,
    STATE(19917), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632727] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29185), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632743] = 4,
    ACTIONS(3063), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632759] = 3,
    ACTIONS(29189), 1,
      sym_quasiquote_body,
    ACTIONS(29187), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632773] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29191), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632789] = 3,
    ACTIONS(29195), 1,
      sym_quasiquote_body,
    ACTIONS(29193), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632803] = 3,
    ACTIONS(29199), 1,
      sym_quasiquote_body,
    ACTIONS(29197), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632817] = 3,
    ACTIONS(29203), 1,
      sym_quasiquote_body,
    ACTIONS(29201), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632831] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29205), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632847] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29207), 1,
      anon_sym_RBRACK,
    STATE(19932), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632863] = 3,
    ACTIONS(29211), 1,
      sym_quasiquote_body,
    ACTIONS(29209), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632877] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29213), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632893] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29215), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632909] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29217), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632925] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29219), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632941] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29221), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632957] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29223), 1,
      anon_sym_RBRACK,
    STATE(19931), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632973] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29225), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [632989] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29227), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633005] = 3,
    ACTIONS(29231), 1,
      sym_quasiquote_body,
    ACTIONS(29229), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633019] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29233), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633035] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(29235), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633051] = 3,
    ACTIONS(29239), 1,
      sym_quasiquote_body,
    ACTIONS(29237), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633065] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29241), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633081] = 3,
    ACTIONS(29245), 1,
      sym_quasiquote_body,
    ACTIONS(29243), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633095] = 2,
    ACTIONS(29247), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633107] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(29249), 1,
      anon_sym_RPAREN,
    STATE(19884), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633123] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(29251), 1,
      anon_sym_RPAREN,
    STATE(19998), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633139] = 3,
    ACTIONS(29255), 1,
      sym_quasiquote_body,
    ACTIONS(29253), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633153] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29257), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633169] = 3,
    ACTIONS(29261), 1,
      sym_quasiquote_body,
    ACTIONS(29259), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633183] = 2,
    ACTIONS(21596), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633195] = 4,
    ACTIONS(25067), 1,
      sym_comma,
    ACTIONS(29263), 1,
      anon_sym_RPAREN,
    STATE(19451), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633211] = 3,
    ACTIONS(29267), 1,
      sym_quasiquote_body,
    ACTIONS(29265), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633225] = 4,
    ACTIONS(3211), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633241] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(29269), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633257] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29271), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633273] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29273), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633289] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29275), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633305] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29277), 1,
      anon_sym_RBRACK,
    STATE(19962), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633321] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29279), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633337] = 4,
    ACTIONS(3248), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633353] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29281), 1,
      anon_sym_RBRACK,
    STATE(19959), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633369] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29283), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633385] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29285), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633401] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29287), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633417] = 4,
    ACTIONS(3232), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633433] = 3,
    ACTIONS(29291), 1,
      sym_quasiquote_body,
    ACTIONS(29289), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633447] = 2,
    ACTIONS(21344), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633459] = 3,
    ACTIONS(29295), 1,
      sym_quasiquote_body,
    ACTIONS(29293), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633473] = 3,
    ACTIONS(29299), 1,
      sym_quasiquote_body,
    ACTIONS(29297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633487] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29301), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633503] = 3,
    ACTIONS(29305), 1,
      sym_quasiquote_body,
    ACTIONS(29303), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633517] = 3,
    ACTIONS(29309), 1,
      sym_quasiquote_body,
    ACTIONS(29307), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633531] = 3,
    ACTIONS(29313), 1,
      sym_quasiquote_body,
    ACTIONS(29311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633545] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29315), 1,
      anon_sym_RBRACK,
    STATE(20022), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633561] = 2,
    ACTIONS(25320), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633573] = 2,
    ACTIONS(23919), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633585] = 4,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(16094), 1,
      sym_variable,
    STATE(21597), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633601] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29317), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633617] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29319), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633633] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(29321), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633649] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29323), 1,
      anon_sym_RBRACK,
    STATE(19979), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633665] = 3,
    ACTIONS(29327), 1,
      sym_quasiquote_body,
    ACTIONS(29325), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633679] = 4,
    ACTIONS(3135), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633695] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29329), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633711] = 4,
    ACTIONS(3258), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633727] = 3,
    ACTIONS(29333), 1,
      sym_quasiquote_body,
    ACTIONS(29331), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633741] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29335), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633757] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29337), 1,
      anon_sym_RBRACK,
    STATE(19992), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633773] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(29339), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633789] = 4,
    ACTIONS(29341), 1,
      anon_sym_RPAREN,
    ACTIONS(29343), 1,
      sym_comma,
    STATE(19990), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633805] = 3,
    ACTIONS(29348), 1,
      sym_quasiquote_body,
    ACTIONS(29346), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633819] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29350), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633835] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29352), 1,
      anon_sym_RBRACE,
    STATE(20028), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633851] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29354), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633867] = 3,
    ACTIONS(29358), 1,
      sym_quasiquote_body,
    ACTIONS(29356), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633881] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29360), 1,
      anon_sym_RBRACE,
    STATE(20038), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633897] = 2,
    ACTIONS(25185), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633909] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(29362), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633925] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29364), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633941] = 2,
    ACTIONS(17699), 3,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633953] = 3,
    ACTIONS(29368), 1,
      sym_quasiquote_body,
    ACTIONS(29366), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633967] = 4,
    ACTIONS(29370), 1,
      anon_sym_LBRACE,
    ACTIONS(29372), 1,
      sym__layout_start,
    STATE(13553), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633983] = 3,
    ACTIONS(29376), 1,
      sym_quasiquote_body,
    ACTIONS(29374), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [633997] = 2,
    ACTIONS(25320), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634009] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29378), 1,
      anon_sym_RBRACK,
    STATE(19939), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634025] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29380), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634041] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29382), 1,
      anon_sym_RBRACK,
    STATE(20042), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634057] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29384), 1,
      anon_sym_RBRACK,
    STATE(20006), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634073] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29386), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634089] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29388), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634105] = 3,
    ACTIONS(29392), 1,
      sym_quasiquote_body,
    ACTIONS(29390), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634119] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29394), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634135] = 3,
    ACTIONS(29398), 1,
      sym_quasiquote_body,
    ACTIONS(29396), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634149] = 2,
    ACTIONS(24085), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634161] = 3,
    ACTIONS(29402), 1,
      sym_quasiquote_body,
    ACTIONS(29400), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634175] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29404), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634191] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29406), 1,
      anon_sym_RBRACK,
    STATE(20021), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634207] = 2,
    ACTIONS(24270), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634219] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29408), 1,
      anon_sym_RPAREN,
    STATE(19942), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634235] = 3,
    ACTIONS(29412), 1,
      sym_quasiquote_body,
    ACTIONS(29410), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634249] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29414), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634265] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29416), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634281] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29418), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634297] = 3,
    STATE(19269), 1,
      sym__arrow,
    ACTIONS(29420), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634311] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29422), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634327] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29424), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634343] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29426), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634359] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29428), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634375] = 3,
    ACTIONS(29432), 1,
      sym_quasiquote_body,
    ACTIONS(29430), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634389] = 2,
    ACTIONS(18533), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634401] = 3,
    ACTIONS(29436), 1,
      sym_quasiquote_body,
    ACTIONS(29434), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634415] = 4,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(17525), 1,
      sym_type_variable,
    STATE(21417), 1,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634431] = 3,
    ACTIONS(29440), 1,
      sym_quasiquote_body,
    ACTIONS(29438), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634445] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29442), 1,
      anon_sym_RBRACK,
    STATE(20027), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634461] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29444), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634477] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29446), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634493] = 3,
    ACTIONS(29450), 1,
      sym_quasiquote_body,
    ACTIONS(29448), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634507] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29452), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634523] = 3,
    ACTIONS(29456), 1,
      sym_quasiquote_body,
    ACTIONS(29454), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634537] = 3,
    ACTIONS(21128), 1,
      sym__varid,
    STATE(14526), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634551] = 3,
    ACTIONS(29460), 1,
      sym_quasiquote_body,
    ACTIONS(29458), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634565] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29462), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634581] = 3,
    ACTIONS(29466), 1,
      sym_quasiquote_body,
    ACTIONS(29464), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634595] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29468), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634611] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29470), 1,
      anon_sym_RBRACK,
    STATE(20049), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634627] = 2,
    ACTIONS(25201), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634639] = 3,
    ACTIONS(29474), 1,
      sym_quasiquote_body,
    ACTIONS(29472), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634653] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29476), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634669] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29478), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634685] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29480), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634701] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29482), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634717] = 4,
    ACTIONS(29484), 1,
      anon_sym_RBRACK,
    ACTIONS(29486), 1,
      sym_comma,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634733] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29489), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634749] = 2,
    ACTIONS(23907), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634761] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29491), 1,
      anon_sym_RBRACK,
    STATE(20053), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634777] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29493), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634793] = 3,
    ACTIONS(29497), 1,
      sym_quasiquote_body,
    ACTIONS(29495), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634807] = 2,
    ACTIONS(20374), 3,
      sym__consym,
      sym__tyconsym,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634819] = 3,
    ACTIONS(29501), 1,
      sym_quasiquote_body,
    ACTIONS(29499), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634833] = 4,
    ACTIONS(3129), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634849] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29503), 1,
      anon_sym_RBRACE,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634865] = 3,
    ACTIONS(29507), 1,
      sym_quasiquote_body,
    ACTIONS(29505), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634879] = 2,
    ACTIONS(18523), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634891] = 3,
    ACTIONS(29511), 1,
      sym_quasiquote_body,
    ACTIONS(29509), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634905] = 3,
    ACTIONS(29515), 1,
      sym_quasiquote_body,
    ACTIONS(29513), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634919] = 2,
    ACTIONS(23138), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634931] = 3,
    ACTIONS(29519), 1,
      sym_quasiquote_body,
    ACTIONS(29517), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634945] = 4,
    ACTIONS(3083), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634961] = 3,
    ACTIONS(29523), 1,
      sym_quasiquote_body,
    ACTIONS(29521), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634975] = 2,
    ACTIONS(25183), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [634987] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29525), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635003] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29527), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635019] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29529), 1,
      anon_sym_RBRACK,
    STATE(20077), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635035] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29531), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635051] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29533), 1,
      anon_sym_RBRACK,
    STATE(20074), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635067] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29535), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635083] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29537), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635099] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29539), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635115] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29541), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635131] = 3,
    ACTIONS(29545), 1,
      sym_quasiquote_body,
    ACTIONS(29543), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635145] = 3,
    ACTIONS(29549), 1,
      sym_quasiquote_body,
    ACTIONS(29547), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635159] = 2,
    ACTIONS(25243), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635171] = 3,
    ACTIONS(29553), 1,
      sym_quasiquote_body,
    ACTIONS(29551), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635185] = 3,
    ACTIONS(29557), 1,
      sym_quasiquote_body,
    ACTIONS(29555), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635199] = 3,
    ACTIONS(29561), 1,
      sym_quasiquote_body,
    ACTIONS(29559), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635213] = 2,
    ACTIONS(29563), 3,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635225] = 3,
    ACTIONS(29567), 1,
      sym_quasiquote_body,
    ACTIONS(29565), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635239] = 2,
    ACTIONS(29569), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635251] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29571), 1,
      anon_sym_RBRACK,
    STATE(20052), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635267] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29573), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635283] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29575), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635299] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29577), 1,
      anon_sym_RBRACK,
    STATE(20091), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635315] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29579), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635331] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29581), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635347] = 3,
    ACTIONS(29585), 1,
      sym_quasiquote_body,
    ACTIONS(29583), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635361] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29587), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635377] = 3,
    ACTIONS(29591), 1,
      sym_quasiquote_body,
    ACTIONS(29589), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635391] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29593), 1,
      anon_sym_RPAREN,
    STATE(20153), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635407] = 3,
    ACTIONS(29597), 1,
      sym_quasiquote_body,
    ACTIONS(29595), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635421] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29599), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635437] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29601), 1,
      anon_sym_RBRACK,
    STATE(20105), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635453] = 3,
    ACTIONS(29605), 1,
      sym_quasiquote_body,
    ACTIONS(29603), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635467] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29607), 1,
      anon_sym_RBRACE,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635483] = 2,
    ACTIONS(24163), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635495] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29609), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635511] = 2,
    ACTIONS(29611), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635523] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29613), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635539] = 4,
    ACTIONS(29615), 1,
      anon_sym_LBRACE,
    ACTIONS(29617), 1,
      sym__layout_start,
    STATE(13150), 1,
      sym_nalts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635555] = 2,
    ACTIONS(25298), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635567] = 2,
    ACTIONS(29619), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635579] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29621), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635595] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29623), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635611] = 3,
    ACTIONS(29627), 1,
      sym_quasiquote_body,
    ACTIONS(29625), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635625] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29629), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635641] = 3,
    ACTIONS(29633), 1,
      sym_quasiquote_body,
    ACTIONS(29631), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635655] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29635), 1,
      anon_sym_RBRACK,
    STATE(20114), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635671] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29637), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635687] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29639), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635703] = 4,
    ACTIONS(3087), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635719] = 3,
    ACTIONS(29643), 1,
      sym_quasiquote_body,
    ACTIONS(29641), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635733] = 3,
    ACTIONS(29647), 1,
      sym_quasiquote_body,
    ACTIONS(29645), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635747] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(29649), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635763] = 3,
    ACTIONS(29653), 1,
      sym_quasiquote_body,
    ACTIONS(29651), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635777] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29655), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635793] = 3,
    ACTIONS(29659), 1,
      sym_quasiquote_body,
    ACTIONS(29657), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635807] = 2,
    ACTIONS(24083), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635819] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29661), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635835] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29663), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635851] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29665), 1,
      anon_sym_RBRACK,
    STATE(20133), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635867] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29667), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635883] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29669), 1,
      anon_sym_RBRACK,
    STATE(20172), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635899] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29671), 1,
      anon_sym_RBRACK,
    STATE(20130), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635915] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29673), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635931] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29675), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635947] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29677), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635963] = 2,
    ACTIONS(29679), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635975] = 4,
    ACTIONS(24876), 1,
      sym_comma,
    ACTIONS(29681), 1,
      anon_sym_RBRACK,
    STATE(20089), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [635991] = 4,
    ACTIONS(3236), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636007] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(29683), 1,
      anon_sym_RPAREN,
    STATE(19292), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636023] = 3,
    ACTIONS(29687), 1,
      sym_quasiquote_body,
    ACTIONS(29685), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636037] = 3,
    ACTIONS(29691), 1,
      sym_quasiquote_body,
    ACTIONS(29689), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636051] = 4,
    ACTIONS(24975), 1,
      sym_comma,
    ACTIONS(29693), 1,
      anon_sym_RBRACE,
    STATE(20103), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636067] = 3,
    ACTIONS(29697), 1,
      sym_quasiquote_body,
    ACTIONS(29695), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636081] = 2,
    ACTIONS(24374), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636093] = 4,
    ACTIONS(24864), 1,
      sym_comma,
    ACTIONS(29699), 1,
      anon_sym_RBRACE,
    STATE(20061), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636109] = 3,
    ACTIONS(29703), 1,
      sym_quasiquote_body,
    ACTIONS(29701), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636123] = 3,
    ACTIONS(29707), 1,
      sym_quasiquote_body,
    ACTIONS(29705), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636137] = 3,
    ACTIONS(29711), 1,
      sym_quasiquote_body,
    ACTIONS(29709), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636151] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29713), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636167] = 4,
    ACTIONS(24868), 1,
      sym__immediate_dot,
    ACTIONS(29715), 1,
      anon_sym_RPAREN,
    STATE(20139), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636183] = 3,
    ACTIONS(29719), 1,
      sym_quasiquote_body,
    ACTIONS(29717), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636197] = 4,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636213] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29721), 1,
      anon_sym_RPAREN,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636229] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29723), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636245] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29725), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636261] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29727), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636277] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29729), 1,
      anon_sym_RBRACK,
    STATE(20161), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636293] = 4,
    ACTIONS(24906), 1,
      sym_comma,
    ACTIONS(29731), 1,
      anon_sym_RBRACK,
    STATE(18531), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636309] = 2,
    ACTIONS(21610), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636321] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29733), 1,
      anon_sym_RBRACK,
    STATE(20155), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636337] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29735), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636353] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29737), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636369] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29739), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636385] = 4,
    ACTIONS(21877), 1,
      sym_comma,
    ACTIONS(29741), 1,
      sym__unboxed_close,
    STATE(18070), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636401] = 4,
    ACTIONS(29743), 1,
      anon_sym_RBRACE,
    ACTIONS(29745), 1,
      sym_comma,
    STATE(20165), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636417] = 4,
    ACTIONS(589), 1,
      sym_comma,
    ACTIONS(29748), 1,
      sym__unboxed_close,
    STATE(18412), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636433] = 4,
    ACTIONS(3217), 1,
      anon_sym_RPAREN,
    ACTIONS(24830), 1,
      sym_comma,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636449] = 3,
    ACTIONS(29752), 1,
      sym_quasiquote_body,
    ACTIONS(29750), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636463] = 3,
    ACTIONS(29756), 1,
      sym_quasiquote_body,
    ACTIONS(29754), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636477] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29758), 1,
      anon_sym_RBRACK,
    STATE(20117), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636493] = 3,
    ACTIONS(29762), 1,
      sym_quasiquote_body,
    ACTIONS(29760), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636507] = 4,
    ACTIONS(24860), 1,
      sym_comma,
    ACTIONS(29764), 1,
      anon_sym_RBRACK,
    STATE(17303), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636523] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29766), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636539] = 3,
    ACTIONS(29770), 1,
      sym_quasiquote_body,
    ACTIONS(29768), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636553] = 3,
    ACTIONS(29774), 1,
      sym_quasiquote_body,
    ACTIONS(29772), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636567] = 4,
    ACTIONS(29776), 1,
      anon_sym_RBRACE,
    ACTIONS(29778), 1,
      sym_comma,
    STATE(20176), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636583] = 3,
    ACTIONS(29783), 1,
      anon_sym_EQ,
    ACTIONS(29781), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636597] = 2,
    ACTIONS(25213), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636609] = 3,
    ACTIONS(29787), 1,
      sym_quasiquote_body,
    ACTIONS(29785), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636623] = 4,
    ACTIONS(24830), 1,
      sym_comma,
    ACTIONS(29789), 1,
      anon_sym_RPAREN,
    STATE(18342), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636639] = 4,
    ACTIONS(21855), 1,
      sym_comma,
    ACTIONS(29791), 1,
      sym__unboxed_close,
    STATE(17893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636655] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29793), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636671] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29795), 1,
      anon_sym_RBRACK,
    STATE(20182), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636687] = 4,
    ACTIONS(24834), 1,
      sym_comma,
    ACTIONS(29797), 1,
      anon_sym_RPAREN,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636703] = 2,
    ACTIONS(21344), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636714] = 2,
    ACTIONS(15599), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636725] = 2,
    ACTIONS(15565), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636736] = 2,
    ACTIONS(29799), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636747] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(29801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636760] = 2,
    ACTIONS(14273), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636771] = 3,
    ACTIONS(29803), 1,
      sym__immediate_varid,
    STATE(13120), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636784] = 2,
    ACTIONS(29805), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636795] = 2,
    ACTIONS(15561), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636806] = 2,
    ACTIONS(15583), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636817] = 2,
    ACTIONS(15591), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636828] = 2,
    ACTIONS(14070), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636839] = 2,
    ACTIONS(15613), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636850] = 2,
    ACTIONS(15617), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636861] = 2,
    ACTIONS(29760), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636872] = 2,
    ACTIONS(29776), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636883] = 2,
    ACTIONS(29743), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636894] = 2,
    ACTIONS(29768), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636905] = 2,
    ACTIONS(15595), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636916] = 2,
    ACTIONS(15656), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636927] = 2,
    ACTIONS(15624), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636938] = 2,
    ACTIONS(29807), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636949] = 2,
    ACTIONS(15628), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636960] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(29809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636973] = 2,
    ACTIONS(15632), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636984] = 2,
    ACTIONS(15636), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [636995] = 2,
    ACTIONS(15579), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637006] = 2,
    ACTIONS(15481), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637017] = 2,
    ACTIONS(29811), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637028] = 2,
    ACTIONS(15448), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637039] = 2,
    ACTIONS(15545), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637050] = 2,
    ACTIONS(29813), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637061] = 2,
    ACTIONS(15575), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637072] = 2,
    ACTIONS(15571), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637083] = 2,
    ACTIONS(15553), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637094] = 2,
    ACTIONS(15515), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637105] = 2,
    ACTIONS(29815), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637116] = 2,
    ACTIONS(29817), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637127] = 2,
    ACTIONS(15607), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637138] = 2,
    ACTIONS(15510), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637149] = 2,
    ACTIONS(15506), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637160] = 2,
    ACTIONS(15502), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637171] = 2,
    ACTIONS(15494), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637182] = 2,
    ACTIONS(29695), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637193] = 2,
    ACTIONS(29819), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637204] = 2,
    ACTIONS(29705), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637215] = 2,
    ACTIONS(15587), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637226] = 2,
    ACTIONS(15405), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637237] = 2,
    ACTIONS(15557), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637248] = 2,
    ACTIONS(29821), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637259] = 2,
    ACTIONS(29823), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637270] = 2,
    ACTIONS(15645), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637281] = 3,
    ACTIONS(29825), 1,
      anon_sym_in,
    STATE(11994), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637294] = 3,
    ACTIONS(29827), 1,
      anon_sym_case,
    ACTIONS(29829), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637307] = 2,
    ACTIONS(29831), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637318] = 2,
    ACTIONS(29833), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637329] = 2,
    ACTIONS(29835), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637340] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29837), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637353] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29839), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637366] = 2,
    ACTIONS(29841), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637377] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29843), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637390] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29845), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637403] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29847), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637416] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29849), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637429] = 2,
    ACTIONS(23542), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637440] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29851), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637453] = 3,
    ACTIONS(29853), 1,
      sym__immediate_varid,
    STATE(12324), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637466] = 3,
    ACTIONS(20746), 1,
      anon_sym_instance,
    STATE(18222), 1,
      sym__instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637479] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637492] = 2,
    ACTIONS(29857), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637503] = 2,
    ACTIONS(24854), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637514] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29859), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637527] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29861), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637540] = 2,
    ACTIONS(29645), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637551] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29863), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637564] = 3,
    ACTIONS(29865), 1,
      anon_sym_import,
    ACTIONS(29867), 1,
      anon_sym_export,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637577] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29869), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637590] = 2,
    ACTIONS(29871), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637601] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29873), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637614] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29875), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637627] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29877), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637640] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29879), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637653] = 3,
    ACTIONS(29881), 1,
      anon_sym_in,
    STATE(13641), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637666] = 2,
    ACTIONS(29631), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637677] = 3,
    ACTIONS(21112), 1,
      anon_sym_EQ,
    STATE(19312), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637690] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29883), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637703] = 2,
    ACTIONS(29547), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637714] = 2,
    ACTIONS(29885), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637725] = 3,
    ACTIONS(29887), 1,
      anon_sym_LBRACE,
    ACTIONS(29889), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637738] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29891), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637751] = 3,
    ACTIONS(29893), 1,
      anon_sym_SEMI,
    ACTIONS(29895), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637764] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29897), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637777] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29899), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637790] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29901), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637803] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29903), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637816] = 2,
    ACTIONS(29905), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637827] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29907), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637840] = 2,
    ACTIONS(24223), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637851] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29909), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637864] = 3,
    ACTIONS(29911), 1,
      anon_sym_SEMI,
    ACTIONS(29913), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637877] = 3,
    ACTIONS(29915), 1,
      sym__immediate_varid,
    STATE(13034), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637890] = 2,
    ACTIONS(29595), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637901] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29917), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637914] = 3,
    ACTIONS(29919), 1,
      anon_sym_SEMI,
    ACTIONS(29921), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637927] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29923), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637940] = 2,
    ACTIONS(29925), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637951] = 3,
    ACTIONS(29927), 1,
      anon_sym_SEMI,
    ACTIONS(29929), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637964] = 2,
    ACTIONS(29931), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637975] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29933), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [637988] = 3,
    ACTIONS(29935), 1,
      anon_sym_SEMI,
    ACTIONS(29937), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638001] = 2,
    ACTIONS(29939), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638012] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29941), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638025] = 3,
    ACTIONS(29943), 1,
      anon_sym_SEMI,
    ACTIONS(29945), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638038] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29947), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638051] = 3,
    ACTIONS(29949), 1,
      anon_sym_SEMI,
    ACTIONS(29951), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638064] = 2,
    ACTIONS(29953), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638075] = 2,
    ACTIONS(29955), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638086] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29957), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638099] = 2,
    ACTIONS(29565), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638110] = 3,
    ACTIONS(29959), 1,
      anon_sym_case,
    ACTIONS(29961), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638123] = 3,
    ACTIONS(29963), 1,
      anon_sym_SEMI,
    ACTIONS(29965), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638136] = 2,
    ACTIONS(18626), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638147] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29967), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638160] = 2,
    ACTIONS(25245), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638171] = 3,
    ACTIONS(29969), 1,
      anon_sym_SEMI,
    ACTIONS(29971), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638184] = 2,
    ACTIONS(25241), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638195] = 3,
    ACTIONS(29973), 1,
      anon_sym_SEMI,
    ACTIONS(29975), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638208] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29977), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638221] = 3,
    ACTIONS(29979), 1,
      anon_sym_SEMI,
    ACTIONS(29981), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638234] = 2,
    ACTIONS(29551), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638245] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29983), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638258] = 3,
    ACTIONS(29985), 1,
      anon_sym_SEMI,
    ACTIONS(29987), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638271] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29989), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638284] = 2,
    ACTIONS(29991), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638295] = 3,
    ACTIONS(29993), 1,
      anon_sym_SEMI,
    ACTIONS(29995), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638308] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(29997), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638321] = 3,
    ACTIONS(29999), 1,
      anon_sym_SEMI,
    ACTIONS(30001), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638334] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30003), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638347] = 3,
    ACTIONS(30005), 1,
      anon_sym_SEMI,
    ACTIONS(30007), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638360] = 2,
    ACTIONS(30009), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638371] = 2,
    ACTIONS(24437), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638382] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30011), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638395] = 3,
    ACTIONS(30013), 1,
      anon_sym_in,
    STATE(12993), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638408] = 2,
    ACTIONS(30015), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638419] = 3,
    ACTIONS(30017), 1,
      anon_sym_SEMI,
    ACTIONS(30019), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638432] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30021), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638445] = 3,
    ACTIONS(30023), 1,
      anon_sym_SEMI,
    ACTIONS(30025), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638458] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30027), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638471] = 3,
    ACTIONS(30029), 1,
      anon_sym_SEMI,
    ACTIONS(30031), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638484] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30033), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638497] = 3,
    ACTIONS(30035), 1,
      anon_sym_SEMI,
    ACTIONS(30037), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638510] = 2,
    ACTIONS(30039), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638521] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30041), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638534] = 3,
    ACTIONS(30043), 1,
      anon_sym_SEMI,
    ACTIONS(30045), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638547] = 3,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(18560), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638560] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30047), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638573] = 3,
    ACTIONS(30049), 1,
      anon_sym_SEMI,
    ACTIONS(30051), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638586] = 2,
    ACTIONS(29509), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638597] = 3,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(18592), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638610] = 3,
    ACTIONS(30053), 1,
      anon_sym_case,
    ACTIONS(30055), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638623] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30057), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638636] = 2,
    ACTIONS(30059), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638647] = 2,
    ACTIONS(29499), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638658] = 2,
    ACTIONS(29781), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638669] = 3,
    ACTIONS(30061), 1,
      anon_sym_SEMI,
    ACTIONS(30063), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638682] = 3,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22227), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638695] = 3,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(18627), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638708] = 2,
    ACTIONS(24077), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638719] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30065), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638732] = 3,
    ACTIONS(30067), 1,
      anon_sym_SEMI,
    ACTIONS(30069), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638745] = 3,
    ACTIONS(30071), 1,
      anon_sym_import,
    ACTIONS(30073), 1,
      anon_sym_export,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638758] = 2,
    ACTIONS(30075), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638769] = 2,
    ACTIONS(29484), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638780] = 3,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22145), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638793] = 3,
    ACTIONS(439), 1,
      sym__consym,
    STATE(22143), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638806] = 2,
    ACTIONS(30077), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638817] = 3,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(18708), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638830] = 3,
    ACTIONS(30079), 1,
      anon_sym_SEMI,
    ACTIONS(30081), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638843] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22022), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638856] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30083), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638869] = 3,
    ACTIONS(30085), 1,
      anon_sym_SEMI,
    ACTIONS(30087), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638882] = 3,
    ACTIONS(30089), 1,
      anon_sym_import,
    ACTIONS(30091), 1,
      anon_sym_export,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638895] = 3,
    ACTIONS(30093), 1,
      sym__immediate_varid,
    STATE(18140), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638908] = 3,
    ACTIONS(30095), 1,
      anon_sym_in,
    STATE(13497), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638921] = 2,
    ACTIONS(30097), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638932] = 2,
    ACTIONS(29458), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638943] = 3,
    ACTIONS(21112), 1,
      anon_sym_EQ,
    STATE(17928), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638956] = 2,
    ACTIONS(30099), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638967] = 2,
    ACTIONS(30101), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638978] = 2,
    ACTIONS(30103), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [638989] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30105), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639002] = 2,
    ACTIONS(30107), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639013] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639026] = 2,
    ACTIONS(24999), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639037] = 3,
    ACTIONS(30111), 1,
      anon_sym_SEMI,
    ACTIONS(30113), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639050] = 3,
    ACTIONS(30115), 1,
      sym__immediate_varid,
    STATE(5340), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639063] = 2,
    ACTIONS(29434), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639074] = 2,
    ACTIONS(30117), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639085] = 2,
    ACTIONS(30119), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639096] = 2,
    ACTIONS(30121), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639107] = 3,
    ACTIONS(30123), 1,
      anon_sym_case,
    ACTIONS(30125), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639120] = 3,
    ACTIONS(30127), 1,
      anon_sym_SEMI,
    ACTIONS(30129), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639133] = 3,
    ACTIONS(21092), 1,
      anon_sym_EQ,
    STATE(20520), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639146] = 3,
    ACTIONS(30131), 1,
      sym__immediate_varid,
    STATE(5083), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639159] = 3,
    ACTIONS(30133), 1,
      anon_sym_SEMI,
    ACTIONS(30135), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639172] = 2,
    ACTIONS(25119), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639183] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639196] = 3,
    ACTIONS(30139), 1,
      anon_sym_SEMI,
    ACTIONS(30141), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639209] = 2,
    ACTIONS(30143), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639220] = 2,
    ACTIONS(30145), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639231] = 3,
    ACTIONS(21092), 1,
      anon_sym_EQ,
    STATE(20618), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639244] = 3,
    ACTIONS(30147), 1,
      anon_sym_in,
    STATE(11916), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639257] = 3,
    ACTIONS(30149), 1,
      anon_sym_case,
    ACTIONS(30151), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639270] = 2,
    ACTIONS(29400), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639281] = 2,
    ACTIONS(30153), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639292] = 2,
    ACTIONS(29619), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639303] = 3,
    ACTIONS(21150), 1,
      anon_sym_instance,
    STATE(20946), 1,
      sym__instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639316] = 2,
    ACTIONS(30155), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639327] = 2,
    ACTIONS(25143), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639338] = 2,
    ACTIONS(30157), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639349] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639362] = 3,
    ACTIONS(21114), 1,
      anon_sym_instance,
    STATE(18336), 1,
      sym__instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639375] = 3,
    ACTIONS(30161), 1,
      sym__immediate_varid,
    STATE(4362), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639388] = 2,
    ACTIONS(30163), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639399] = 2,
    ACTIONS(30165), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639410] = 2,
    ACTIONS(24932), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639421] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639434] = 2,
    ACTIONS(30167), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639445] = 2,
    ACTIONS(29374), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639456] = 3,
    ACTIONS(21092), 1,
      anon_sym_EQ,
    STATE(21082), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639469] = 3,
    ACTIONS(30169), 1,
      sym__immediate_varid,
    STATE(12685), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639482] = 2,
    ACTIONS(29569), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639493] = 2,
    ACTIONS(25312), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639504] = 2,
    ACTIONS(30171), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639515] = 2,
    ACTIONS(25231), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639526] = 2,
    ACTIONS(29438), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639537] = 3,
    ACTIONS(30173), 1,
      sym__immediate_varid,
    STATE(10617), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639550] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30175), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639563] = 2,
    ACTIONS(30177), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639574] = 2,
    ACTIONS(30179), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639585] = 2,
    ACTIONS(30181), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639596] = 2,
    ACTIONS(29346), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639607] = 2,
    ACTIONS(29679), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639618] = 3,
    ACTIONS(30183), 1,
      sym__immediate_varid,
    STATE(5932), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639631] = 2,
    ACTIONS(24231), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639642] = 2,
    ACTIONS(30185), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639653] = 3,
    ACTIONS(30187), 1,
      anon_sym_SEMI,
    ACTIONS(30189), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639666] = 3,
    ACTIONS(19453), 1,
      sym__varid,
    STATE(23174), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639679] = 2,
    ACTIONS(24077), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639690] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639703] = 3,
    ACTIONS(30191), 1,
      anon_sym_SEMI,
    ACTIONS(30193), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639716] = 3,
    ACTIONS(30195), 1,
      anon_sym_LBRACE,
    ACTIONS(30197), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639729] = 2,
    ACTIONS(30199), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639740] = 2,
    ACTIONS(30201), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639751] = 3,
    ACTIONS(30203), 1,
      sym__immediate_varid,
    STATE(19372), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639764] = 2,
    ACTIONS(30205), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639775] = 3,
    ACTIONS(30207), 1,
      anon_sym_LBRACE,
    ACTIONS(30209), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639788] = 3,
    ACTIONS(30211), 1,
      sym__immediate_varid,
    STATE(19258), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639801] = 3,
    ACTIONS(30213), 1,
      anon_sym_LBRACE,
    ACTIONS(30215), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639814] = 2,
    ACTIONS(29311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639825] = 2,
    ACTIONS(29341), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639836] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639849] = 2,
    ACTIONS(30219), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639860] = 3,
    ACTIONS(30221), 1,
      sym__immediate_varid,
    STATE(12820), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639873] = 2,
    ACTIONS(30223), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639884] = 3,
    ACTIONS(30225), 1,
      sym__immediate_varid,
    STATE(19139), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639897] = 3,
    ACTIONS(30227), 1,
      anon_sym_LBRACE,
    ACTIONS(30229), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639910] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639923] = 2,
    ACTIONS(25993), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639934] = 2,
    ACTIONS(29297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639945] = 3,
    ACTIONS(30233), 1,
      anon_sym_in,
    STATE(10821), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639958] = 3,
    ACTIONS(30235), 1,
      sym__immediate_varid,
    STATE(19020), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639971] = 3,
    ACTIONS(30237), 1,
      anon_sym_LBRACE,
    ACTIONS(30239), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639984] = 2,
    ACTIONS(30241), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [639995] = 2,
    ACTIONS(30243), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640006] = 3,
    ACTIONS(30245), 1,
      anon_sym_case,
    ACTIONS(30247), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640019] = 2,
    ACTIONS(25979), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640030] = 3,
    ACTIONS(30249), 1,
      sym__immediate_varid,
    STATE(18901), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640043] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30251), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640056] = 3,
    ACTIONS(30253), 1,
      anon_sym_LBRACE,
    ACTIONS(30255), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640069] = 2,
    ACTIONS(30257), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640080] = 2,
    ACTIONS(25384), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640091] = 3,
    ACTIONS(30259), 1,
      sym__immediate_varid,
    STATE(4474), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640104] = 2,
    ACTIONS(30261), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640115] = 3,
    ACTIONS(30263), 1,
      sym__immediate_varid,
    STATE(18782), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640128] = 3,
    ACTIONS(30265), 1,
      anon_sym_LBRACE,
    ACTIONS(30267), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640141] = 2,
    ACTIONS(30269), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640152] = 2,
    ACTIONS(30271), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640163] = 3,
    ACTIONS(30273), 1,
      sym__immediate_varid,
    STATE(18663), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640176] = 3,
    ACTIONS(30275), 1,
      sym__immediate_varid,
    STATE(5745), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640189] = 2,
    ACTIONS(30277), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640200] = 3,
    ACTIONS(30279), 1,
      anon_sym_LBRACE,
    ACTIONS(30281), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640213] = 2,
    ACTIONS(28100), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640224] = 2,
    ACTIONS(18612), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640235] = 2,
    ACTIONS(29243), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640246] = 2,
    ACTIONS(25449), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640257] = 3,
    ACTIONS(30283), 1,
      sym__immediate_varid,
    STATE(18544), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640270] = 2,
    ACTIONS(29253), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640281] = 2,
    ACTIONS(28026), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640292] = 3,
    ACTIONS(30285), 1,
      anon_sym_LBRACE,
    ACTIONS(30287), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640305] = 2,
    ACTIONS(27738), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640316] = 2,
    ACTIONS(30289), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640327] = 2,
    ACTIONS(28008), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640338] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22058), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640351] = 3,
    ACTIONS(30291), 1,
      sym__immediate_varid,
    STATE(18425), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640364] = 3,
    ACTIONS(30293), 1,
      anon_sym_LBRACE,
    ACTIONS(30295), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640377] = 2,
    ACTIONS(30297), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640388] = 2,
    ACTIONS(25453), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640399] = 3,
    ACTIONS(30299), 1,
      sym__immediate_varid,
    STATE(18306), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640412] = 3,
    ACTIONS(30301), 1,
      anon_sym_LBRACE,
    ACTIONS(30303), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640425] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30305), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640438] = 2,
    ACTIONS(30307), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640449] = 2,
    ACTIONS(30309), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640460] = 2,
    ACTIONS(30311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640471] = 3,
    ACTIONS(30313), 1,
      sym__immediate_varid,
    STATE(5347), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640484] = 3,
    ACTIONS(30315), 1,
      sym__immediate_varid,
    STATE(18187), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640497] = 3,
    ACTIONS(30317), 1,
      anon_sym_LBRACE,
    ACTIONS(30319), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640510] = 2,
    ACTIONS(30321), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640521] = 3,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(21567), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640534] = 2,
    ACTIONS(30323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640545] = 3,
    ACTIONS(30325), 1,
      anon_sym_SEMI,
    ACTIONS(30327), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640558] = 2,
    ACTIONS(27898), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640569] = 3,
    ACTIONS(30329), 1,
      sym__immediate_varid,
    STATE(18068), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640582] = 3,
    ACTIONS(30331), 1,
      anon_sym_LBRACE,
    ACTIONS(30333), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640595] = 3,
    ACTIONS(30335), 1,
      sym__immediate_varid,
    STATE(13537), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640608] = 2,
    ACTIONS(29197), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640619] = 2,
    ACTIONS(27780), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640630] = 3,
    ACTIONS(30337), 1,
      anon_sym_SEMI,
    ACTIONS(30339), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640643] = 3,
    ACTIONS(30341), 1,
      sym__immediate_varid,
    STATE(17949), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640656] = 2,
    ACTIONS(30343), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640667] = 3,
    ACTIONS(30345), 1,
      anon_sym_LBRACE,
    ACTIONS(30347), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640680] = 2,
    ACTIONS(30349), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640691] = 3,
    ACTIONS(30351), 1,
      sym__immediate_varid,
    STATE(17871), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640704] = 3,
    ACTIONS(30353), 1,
      anon_sym_LBRACE,
    ACTIONS(30355), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640717] = 3,
    ACTIONS(30357), 1,
      anon_sym_in,
    STATE(13181), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640730] = 2,
    ACTIONS(27752), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640741] = 3,
    ACTIONS(30359), 1,
      anon_sym_case,
    ACTIONS(30361), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640754] = 3,
    ACTIONS(30363), 1,
      sym__immediate_varid,
    STATE(17939), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640767] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640780] = 2,
    ACTIONS(30367), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640791] = 2,
    ACTIONS(29169), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640802] = 3,
    ACTIONS(30369), 1,
      anon_sym_LBRACE,
    ACTIONS(30371), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640815] = 2,
    ACTIONS(30373), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640826] = 2,
    ACTIONS(30375), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640837] = 2,
    ACTIONS(25543), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640848] = 2,
    ACTIONS(29101), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640859] = 2,
    ACTIONS(17867), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640870] = 3,
    ACTIONS(30377), 1,
      sym__immediate_varid,
    STATE(4102), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640883] = 2,
    ACTIONS(26127), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640894] = 2,
    ACTIONS(23219), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640905] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640918] = 2,
    ACTIONS(17871), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640929] = 3,
    ACTIONS(30381), 1,
      sym__immediate_varid,
    STATE(18035), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640942] = 2,
    ACTIONS(29157), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640953] = 3,
    ACTIONS(30383), 1,
      anon_sym_LBRACE,
    ACTIONS(30385), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640966] = 2,
    ACTIONS(30387), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640977] = 3,
    ACTIONS(19944), 1,
      sym__conid,
    STATE(22184), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [640990] = 2,
    ACTIONS(30389), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641001] = 2,
    ACTIONS(30391), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641012] = 2,
    ACTIONS(27752), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641023] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641036] = 3,
    ACTIONS(30395), 1,
      sym__immediate_varid,
    STATE(18138), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641049] = 2,
    ACTIONS(22446), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641060] = 3,
    ACTIONS(30397), 1,
      anon_sym_LBRACE,
    ACTIONS(30399), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641073] = 3,
    ACTIONS(18988), 1,
      sym_where,
    STATE(17925), 1,
      sym__gadt_rhs,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641086] = 3,
    ACTIONS(30401), 1,
      sym__immediate_varid,
    STATE(18251), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641099] = 3,
    ACTIONS(30403), 1,
      anon_sym_LBRACE,
    ACTIONS(30405), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641112] = 2,
    ACTIONS(30407), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641123] = 2,
    ACTIONS(30409), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641134] = 2,
    ACTIONS(27046), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641145] = 2,
    ACTIONS(27629), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641156] = 2,
    ACTIONS(27615), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641167] = 3,
    ACTIONS(30411), 1,
      sym__immediate_varid,
    STATE(18370), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641180] = 2,
    ACTIONS(29105), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641191] = 2,
    ACTIONS(30413), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641202] = 3,
    ACTIONS(30415), 1,
      anon_sym_case,
    ACTIONS(30417), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641215] = 2,
    ACTIONS(30419), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641226] = 3,
    ACTIONS(30421), 1,
      anon_sym_LBRACE,
    ACTIONS(30423), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641239] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641252] = 3,
    ACTIONS(30425), 1,
      anon_sym_in,
    STATE(13319), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641265] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30427), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641278] = 2,
    ACTIONS(29091), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641289] = 3,
    ACTIONS(30429), 1,
      sym__immediate_varid,
    STATE(18506), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641302] = 2,
    ACTIONS(30431), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641313] = 3,
    ACTIONS(30433), 1,
      anon_sym_LBRACE,
    ACTIONS(30435), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641326] = 2,
    ACTIONS(30437), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641337] = 2,
    ACTIONS(23155), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641348] = 3,
    ACTIONS(30439), 1,
      sym__immediate_varid,
    STATE(10859), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641361] = 2,
    ACTIONS(25671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641372] = 3,
    ACTIONS(30441), 1,
      sym__immediate_varid,
    STATE(18623), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641385] = 3,
    ACTIONS(30443), 1,
      anon_sym_SEMI,
    ACTIONS(30445), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641398] = 2,
    ACTIONS(30447), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641409] = 2,
    ACTIONS(26172), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641420] = 3,
    ACTIONS(30449), 1,
      anon_sym_LBRACE,
    ACTIONS(30451), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641433] = 2,
    ACTIONS(27273), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641444] = 2,
    ACTIONS(30453), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641455] = 2,
    ACTIONS(22310), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641466] = 3,
    ACTIONS(30455), 1,
      sym__immediate_varid,
    STATE(18760), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641479] = 3,
    ACTIONS(21903), 1,
      anon_sym_RPAREN,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641492] = 3,
    ACTIONS(30457), 1,
      anon_sym_LBRACE,
    ACTIONS(30459), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641505] = 2,
    ACTIONS(30461), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641516] = 3,
    ACTIONS(30463), 1,
      anon_sym_SEMI,
    ACTIONS(30465), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641529] = 3,
    ACTIONS(30467), 1,
      sym__immediate_varid,
    STATE(18919), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641542] = 3,
    ACTIONS(30469), 1,
      anon_sym_LBRACE,
    ACTIONS(30471), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641555] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641568] = 3,
    ACTIONS(30473), 1,
      anon_sym_in,
    STATE(14056), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641581] = 2,
    ACTIONS(27086), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641592] = 2,
    ACTIONS(25687), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641603] = 3,
    ACTIONS(30475), 1,
      anon_sym_SEMI,
    ACTIONS(30477), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641616] = 2,
    ACTIONS(29047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641627] = 3,
    ACTIONS(30479), 1,
      sym__immediate_varid,
    STATE(19066), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641640] = 3,
    ACTIONS(30481), 1,
      anon_sym_LBRACE,
    ACTIONS(30483), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641653] = 3,
    ACTIONS(30485), 1,
      sym__immediate_varid,
    STATE(12679), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641666] = 2,
    ACTIONS(30487), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641677] = 2,
    ACTIONS(29035), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641688] = 3,
    ACTIONS(30489), 1,
      anon_sym_SEMI,
    ACTIONS(30491), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641701] = 2,
    ACTIONS(25709), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641712] = 2,
    ACTIONS(30493), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641723] = 3,
    ACTIONS(30495), 1,
      sym__immediate_varid,
    STATE(4915), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641736] = 2,
    ACTIONS(26133), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641747] = 3,
    ACTIONS(30497), 1,
      sym__immediate_varid,
    STATE(19215), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641760] = 3,
    ACTIONS(30499), 1,
      anon_sym_LBRACE,
    ACTIONS(30501), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641773] = 2,
    ACTIONS(30503), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641784] = 2,
    ACTIONS(30505), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641795] = 2,
    ACTIONS(27084), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641806] = 3,
    ACTIONS(30507), 1,
      sym__immediate_varid,
    STATE(19387), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641819] = 2,
    ACTIONS(26151), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641830] = 3,
    ACTIONS(30509), 1,
      anon_sym_LBRACE,
    ACTIONS(30511), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641843] = 3,
    ACTIONS(439), 1,
      sym__consym,
    STATE(21740), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641856] = 2,
    ACTIONS(26153), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641867] = 3,
    ACTIONS(21090), 1,
      anon_sym_EQ,
    STATE(18898), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641880] = 2,
    ACTIONS(30513), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641891] = 2,
    ACTIONS(30515), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641902] = 2,
    ACTIONS(26968), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641913] = 3,
    ACTIONS(30517), 1,
      sym__immediate_varid,
    STATE(19608), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641926] = 3,
    ACTIONS(30519), 1,
      anon_sym_LBRACE,
    ACTIONS(30521), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641939] = 3,
    ACTIONS(30523), 1,
      anon_sym_SEMI,
    ACTIONS(30525), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641952] = 2,
    ACTIONS(29003), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641963] = 3,
    ACTIONS(19221), 1,
      sym_where,
    STATE(18933), 1,
      sym__gadt_rhs,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641976] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [641989] = 2,
    ACTIONS(30529), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642000] = 2,
    ACTIONS(30531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642011] = 2,
    ACTIONS(26968), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642022] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642035] = 2,
    ACTIONS(30535), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642046] = 3,
    ACTIONS(30537), 1,
      anon_sym_case,
    ACTIONS(30539), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642059] = 3,
    ACTIONS(30541), 1,
      sym__immediate_varid,
    STATE(19945), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642072] = 3,
    ACTIONS(30543), 1,
      anon_sym_LBRACE,
    ACTIONS(30545), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642085] = 2,
    ACTIONS(30547), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642096] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642109] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30551), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642122] = 2,
    ACTIONS(30553), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642133] = 2,
    ACTIONS(30555), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642144] = 2,
    ACTIONS(26930), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642155] = 3,
    ACTIONS(30557), 1,
      sym__immediate_varid,
    STATE(20150), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642168] = 3,
    ACTIONS(30559), 1,
      anon_sym_LBRACE,
    ACTIONS(30561), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642181] = 2,
    ACTIONS(28965), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642192] = 3,
    ACTIONS(30563), 1,
      anon_sym_SEMI,
    ACTIONS(30565), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642205] = 2,
    ACTIONS(26133), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642216] = 2,
    ACTIONS(30567), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642227] = 3,
    ACTIONS(30569), 1,
      sym__immediate_varid,
    STATE(19946), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642240] = 3,
    ACTIONS(30571), 1,
      anon_sym_LBRACE,
    ACTIONS(30573), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642253] = 3,
    ACTIONS(30575), 1,
      anon_sym_SEMI,
    ACTIONS(30577), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642266] = 3,
    ACTIONS(30579), 1,
      anon_sym_SEMI,
    ACTIONS(30581), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642279] = 3,
    ACTIONS(30583), 1,
      anon_sym_in,
    STATE(13489), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642292] = 2,
    ACTIONS(28961), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642303] = 3,
    ACTIONS(30585), 1,
      anon_sym_case,
    ACTIONS(30587), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642316] = 3,
    ACTIONS(30589), 1,
      sym__immediate_varid,
    STATE(19771), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642329] = 3,
    ACTIONS(30591), 1,
      anon_sym_LBRACE,
    ACTIONS(30593), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642342] = 2,
    ACTIONS(30595), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642353] = 3,
    ACTIONS(30597), 1,
      sym__immediate_varid,
    STATE(11774), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642366] = 2,
    ACTIONS(25864), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642377] = 2,
    ACTIONS(30297), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642388] = 2,
    ACTIONS(25920), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642399] = 3,
    ACTIONS(30599), 1,
      sym__immediate_varid,
    STATE(11102), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642412] = 2,
    ACTIONS(21618), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642423] = 2,
    ACTIONS(26101), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642434] = 3,
    ACTIONS(30601), 1,
      sym__immediate_varid,
    STATE(19601), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642447] = 2,
    ACTIONS(30603), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642458] = 2,
    ACTIONS(30605), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642469] = 2,
    ACTIONS(25953), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642480] = 3,
    ACTIONS(30607), 1,
      anon_sym_LBRACE,
    ACTIONS(30609), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642493] = 2,
    ACTIONS(26822), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642504] = 2,
    ACTIONS(30611), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642515] = 2,
    ACTIONS(30613), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642526] = 2,
    ACTIONS(26620), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642537] = 2,
    ACTIONS(23743), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642548] = 2,
    ACTIONS(26608), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642559] = 2,
    ACTIONS(30615), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642570] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642583] = 2,
    ACTIONS(30617), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642594] = 2,
    ACTIONS(30619), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642605] = 2,
    ACTIONS(22036), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642616] = 2,
    ACTIONS(28913), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642627] = 3,
    ACTIONS(30621), 1,
      sym__immediate_varid,
    STATE(19414), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642640] = 2,
    ACTIONS(25904), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642651] = 3,
    ACTIONS(30623), 1,
      anon_sym_LBRACE,
    ACTIONS(30625), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642664] = 2,
    ACTIONS(30627), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642675] = 2,
    ACTIONS(26515), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642686] = 3,
    ACTIONS(30629), 1,
      sym__immediate_varid,
    STATE(5204), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642699] = 2,
    ACTIONS(30631), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642710] = 3,
    ACTIONS(30633), 1,
      sym__immediate_varid,
    STATE(19221), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642723] = 3,
    ACTIONS(30635), 1,
      anon_sym_LBRACE,
    ACTIONS(30637), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642736] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642749] = 2,
    ACTIONS(28893), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642760] = 3,
    ACTIONS(30641), 1,
      anon_sym_LBRACE,
    ACTIONS(30643), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642773] = 2,
    ACTIONS(26073), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642784] = 2,
    ACTIONS(30645), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642795] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30647), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642808] = 2,
    ACTIONS(30649), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642819] = 2,
    ACTIONS(26031), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642830] = 2,
    ACTIONS(26007), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642841] = 2,
    ACTIONS(30651), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642852] = 3,
    ACTIONS(30653), 1,
      sym__immediate_varid,
    STATE(19047), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642865] = 3,
    ACTIONS(30655), 1,
      anon_sym_LBRACE,
    ACTIONS(30657), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642878] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642891] = 2,
    ACTIONS(26063), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642902] = 2,
    ACTIONS(30661), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642913] = 2,
    ACTIONS(26155), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642924] = 2,
    ACTIONS(30663), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642935] = 2,
    ACTIONS(26031), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642946] = 2,
    ACTIONS(28879), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642957] = 3,
    ACTIONS(30665), 1,
      anon_sym_SEMI,
    ACTIONS(30667), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642970] = 3,
    ACTIONS(30669), 1,
      sym__immediate_varid,
    STATE(18848), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642983] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30671), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [642996] = 2,
    ACTIONS(30673), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643007] = 2,
    ACTIONS(26007), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643018] = 2,
    ACTIONS(26007), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643029] = 3,
    ACTIONS(30675), 1,
      anon_sym_LBRACE,
    ACTIONS(30677), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643042] = 3,
    ACTIONS(30679), 1,
      anon_sym_SEMI,
    ACTIONS(30681), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643055] = 2,
    ACTIONS(30683), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643066] = 2,
    ACTIONS(30685), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643077] = 2,
    ACTIONS(30687), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643088] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643101] = 3,
    ACTIONS(30691), 1,
      sym__immediate_varid,
    STATE(18733), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643114] = 2,
    ACTIONS(30693), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643125] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30695), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643138] = 3,
    ACTIONS(30697), 1,
      anon_sym_LBRACE,
    ACTIONS(30699), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643151] = 3,
    ACTIONS(30701), 1,
      anon_sym_in,
    STATE(13650), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643164] = 2,
    ACTIONS(30703), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643175] = 3,
    ACTIONS(30705), 1,
      anon_sym_case,
    ACTIONS(30707), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643188] = 2,
    ACTIONS(26357), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643199] = 2,
    ACTIONS(30709), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643210] = 2,
    ACTIONS(26355), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643221] = 2,
    ACTIONS(30711), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643232] = 2,
    ACTIONS(30713), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643243] = 3,
    ACTIONS(30715), 1,
      sym__immediate_varid,
    STATE(18616), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643256] = 3,
    ACTIONS(30717), 1,
      sym__immediate_varid,
    STATE(10912), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643269] = 2,
    ACTIONS(28823), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643280] = 2,
    ACTIONS(28835), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643291] = 3,
    ACTIONS(30719), 1,
      anon_sym_LBRACE,
    ACTIONS(30721), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643304] = 3,
    ACTIONS(30723), 1,
      sym__immediate_varid,
    STATE(21244), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643317] = 2,
    ACTIONS(30725), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643328] = 2,
    ACTIONS(30727), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643339] = 2,
    ACTIONS(25840), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643350] = 2,
    ACTIONS(25840), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643361] = 2,
    ACTIONS(26343), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643372] = 2,
    ACTIONS(30729), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643383] = 3,
    ACTIONS(30731), 1,
      sym__immediate_varid,
    STATE(18508), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643396] = 2,
    ACTIONS(25840), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643407] = 2,
    ACTIONS(25840), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643418] = 3,
    ACTIONS(30733), 1,
      anon_sym_LBRACE,
    ACTIONS(30735), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643431] = 3,
    ACTIONS(30737), 1,
      sym__immediate_varid,
    STATE(12488), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643444] = 2,
    ACTIONS(30739), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643455] = 2,
    ACTIONS(25840), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643466] = 2,
    ACTIONS(30741), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643477] = 2,
    ACTIONS(25973), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643488] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22044), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643501] = 2,
    ACTIONS(23018), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643512] = 2,
    ACTIONS(26208), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643523] = 2,
    ACTIONS(25936), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643534] = 2,
    ACTIONS(30743), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643545] = 3,
    ACTIONS(30745), 1,
      sym__immediate_varid,
    STATE(18406), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643558] = 3,
    ACTIONS(30747), 1,
      anon_sym_LBRACE,
    ACTIONS(30749), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643571] = 2,
    ACTIONS(30751), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643582] = 2,
    ACTIONS(26129), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643593] = 3,
    ACTIONS(30753), 1,
      sym__immediate_varid,
    STATE(5370), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643606] = 2,
    ACTIONS(28797), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643617] = 2,
    ACTIONS(26281), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643628] = 3,
    ACTIONS(30755), 1,
      sym__immediate_varid,
    STATE(12102), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643641] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30757), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643654] = 2,
    ACTIONS(30759), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643665] = 2,
    ACTIONS(30761), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643676] = 2,
    ACTIONS(30763), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643687] = 2,
    ACTIONS(30765), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643698] = 2,
    ACTIONS(26269), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643709] = 3,
    ACTIONS(30767), 1,
      anon_sym_SEMI,
    ACTIONS(30769), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643722] = 3,
    ACTIONS(30771), 1,
      sym__immediate_varid,
    STATE(18315), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643735] = 2,
    ACTIONS(30773), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643746] = 3,
    ACTIONS(30775), 1,
      anon_sym_LBRACE,
    ACTIONS(30777), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643759] = 2,
    ACTIONS(24908), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643770] = 2,
    ACTIONS(30779), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643781] = 2,
    ACTIONS(23221), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643792] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643805] = 3,
    ACTIONS(24834), 1,
      sym_comma,
    STATE(18554), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643818] = 2,
    ACTIONS(26245), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643829] = 2,
    ACTIONS(30783), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643840] = 2,
    ACTIONS(28689), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643851] = 2,
    ACTIONS(30785), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643862] = 2,
    ACTIONS(26065), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643873] = 2,
    ACTIONS(28753), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643884] = 2,
    ACTIONS(24077), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643895] = 3,
    ACTIONS(30787), 1,
      anon_sym_in,
    STATE(13285), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643908] = 3,
    ACTIONS(30789), 1,
      anon_sym_case,
    ACTIONS(30791), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643921] = 2,
    ACTIONS(30793), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643932] = 2,
    ACTIONS(28761), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643943] = 3,
    ACTIONS(30795), 1,
      anon_sym_SEMI,
    ACTIONS(30797), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643956] = 3,
    ACTIONS(30799), 1,
      anon_sym_in,
    STATE(13273), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643969] = 3,
    ACTIONS(30801), 1,
      sym__immediate_varid,
    STATE(18233), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643982] = 2,
    ACTIONS(30803), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [643993] = 2,
    ACTIONS(25918), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644004] = 3,
    ACTIONS(30805), 1,
      anon_sym_LBRACE,
    ACTIONS(30807), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644017] = 3,
    ACTIONS(30809), 1,
      anon_sym_case,
    ACTIONS(30811), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644030] = 2,
    ACTIONS(30813), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644041] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644054] = 2,
    ACTIONS(26251), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644065] = 3,
    ACTIONS(30817), 1,
      sym__immediate_varid,
    STATE(10669), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644078] = 2,
    ACTIONS(30819), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644089] = 2,
    ACTIONS(30821), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644100] = 2,
    ACTIONS(30823), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644111] = 2,
    ACTIONS(26133), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644122] = 3,
    ACTIONS(30825), 1,
      sym__immediate_varid,
    STATE(18147), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644135] = 3,
    ACTIONS(30827), 1,
      anon_sym_LBRACE,
    ACTIONS(30829), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644148] = 2,
    ACTIONS(30831), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644159] = 2,
    ACTIONS(30833), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644170] = 3,
    ACTIONS(30835), 1,
      anon_sym_LBRACE,
    ACTIONS(30837), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644183] = 3,
    ACTIONS(30839), 1,
      sym__immediate_varid,
    STATE(3859), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644196] = 2,
    ACTIONS(25109), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644207] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644220] = 3,
    ACTIONS(30843), 1,
      anon_sym_case,
    ACTIONS(30845), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644233] = 2,
    ACTIONS(30847), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644244] = 2,
    ACTIONS(26337), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644255] = 2,
    ACTIONS(18691), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644266] = 2,
    ACTIONS(28703), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644277] = 2,
    ACTIONS(26423), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644288] = 3,
    ACTIONS(30849), 1,
      sym__immediate_varid,
    STATE(12384), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644301] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30851), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644314] = 2,
    ACTIONS(30853), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644325] = 2,
    ACTIONS(30855), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644336] = 2,
    ACTIONS(30857), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644347] = 2,
    ACTIONS(25115), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644358] = 2,
    ACTIONS(25133), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644369] = 3,
    ACTIONS(30859), 1,
      anon_sym_SEMI,
    ACTIONS(30861), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644382] = 2,
    ACTIONS(30863), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644393] = 2,
    ACTIONS(28681), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644404] = 3,
    ACTIONS(30865), 1,
      sym__immediate_varid,
    STATE(18029), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644417] = 2,
    ACTIONS(25908), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644428] = 2,
    ACTIONS(30867), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644439] = 3,
    ACTIONS(30869), 1,
      anon_sym_LBRACE,
    ACTIONS(30871), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644452] = 3,
    ACTIONS(30873), 1,
      anon_sym_SEMI,
    ACTIONS(30875), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644465] = 2,
    ACTIONS(24405), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644476] = 3,
    ACTIONS(30877), 1,
      anon_sym_in,
    STATE(10740), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644489] = 2,
    ACTIONS(25902), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644500] = 2,
    ACTIONS(30879), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644511] = 2,
    ACTIONS(25888), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644522] = 2,
    ACTIONS(25189), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644533] = 2,
    ACTIONS(28612), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644544] = 2,
    ACTIONS(30881), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644555] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30883), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644568] = 2,
    ACTIONS(30885), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644579] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644592] = 2,
    ACTIONS(28657), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644603] = 3,
    ACTIONS(30889), 1,
      anon_sym_in,
    STATE(13486), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644616] = 2,
    ACTIONS(23907), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644627] = 3,
    ACTIONS(30891), 1,
      anon_sym_case,
    ACTIONS(30893), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644640] = 2,
    ACTIONS(30895), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644651] = 2,
    ACTIONS(25890), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644662] = 2,
    ACTIONS(30897), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644673] = 2,
    ACTIONS(26417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644684] = 2,
    ACTIONS(23410), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644695] = 3,
    ACTIONS(30899), 1,
      anon_sym_LBRACE,
    ACTIONS(30901), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644708] = 2,
    ACTIONS(23919), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644719] = 3,
    ACTIONS(30903), 1,
      sym__immediate_varid,
    STATE(6330), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644732] = 2,
    ACTIONS(30905), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644743] = 2,
    ACTIONS(25515), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644754] = 2,
    ACTIONS(30907), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644765] = 3,
    ACTIONS(30909), 1,
      anon_sym_LBRACE,
    ACTIONS(30911), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644778] = 2,
    ACTIONS(30913), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644789] = 2,
    ACTIONS(30915), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644800] = 3,
    ACTIONS(30917), 1,
      anon_sym_SEMI,
    ACTIONS(30919), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644813] = 2,
    ACTIONS(30921), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644824] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644837] = 3,
    ACTIONS(30925), 1,
      anon_sym_SEMI,
    ACTIONS(30927), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644850] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22278), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644863] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(30929), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644876] = 2,
    ACTIONS(28608), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644887] = 2,
    ACTIONS(25888), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644898] = 2,
    ACTIONS(21662), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644909] = 3,
    ACTIONS(30931), 1,
      sym__immediate_varid,
    STATE(17890), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644922] = 2,
    ACTIONS(28617), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644933] = 2,
    ACTIONS(25541), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644944] = 3,
    ACTIONS(30933), 1,
      anon_sym_LBRACE,
    ACTIONS(30935), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644957] = 2,
    ACTIONS(30937), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644968] = 2,
    ACTIONS(30939), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644979] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [644990] = 2,
    ACTIONS(30941), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645001] = 2,
    ACTIONS(26553), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645012] = 3,
    ACTIONS(30943), 1,
      anon_sym_SEMI,
    ACTIONS(30945), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645025] = 2,
    ACTIONS(26531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645036] = 3,
    ACTIONS(30947), 1,
      sym__immediate_varid,
    STATE(4983), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645049] = 2,
    ACTIONS(28757), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645060] = 2,
    ACTIONS(30949), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645071] = 3,
    ACTIONS(30951), 1,
      anon_sym_SEMI,
    ACTIONS(30953), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645084] = 2,
    ACTIONS(30955), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645095] = 3,
    ACTIONS(30957), 1,
      anon_sym_SEMI,
    ACTIONS(30959), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645108] = 2,
    ACTIONS(30961), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645119] = 2,
    ACTIONS(30963), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645130] = 2,
    ACTIONS(30965), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645141] = 3,
    ACTIONS(30967), 1,
      anon_sym_LBRACE,
    ACTIONS(30969), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645154] = 2,
    ACTIONS(30971), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645165] = 2,
    ACTIONS(26600), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645176] = 3,
    ACTIONS(30973), 1,
      sym__immediate_varid,
    STATE(6121), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645189] = 3,
    ACTIONS(30975), 1,
      anon_sym_in,
    STATE(13418), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645202] = 3,
    ACTIONS(30977), 1,
      anon_sym_case,
    ACTIONS(30979), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645215] = 2,
    ACTIONS(25595), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645226] = 2,
    ACTIONS(30981), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645237] = 2,
    ACTIONS(30983), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645248] = 2,
    ACTIONS(28568), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645259] = 2,
    ACTIONS(30985), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645270] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(30987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645283] = 2,
    ACTIONS(24900), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645294] = 2,
    ACTIONS(30989), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645305] = 2,
    ACTIONS(30991), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645316] = 2,
    ACTIONS(26697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645327] = 2,
    ACTIONS(30993), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645338] = 2,
    ACTIONS(26657), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645349] = 2,
    ACTIONS(30995), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645360] = 2,
    ACTIONS(30997), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645371] = 2,
    ACTIONS(26628), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645382] = 2,
    ACTIONS(26614), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645393] = 2,
    ACTIONS(30999), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645404] = 2,
    ACTIONS(31001), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645415] = 2,
    ACTIONS(28538), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645426] = 2,
    ACTIONS(31003), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645437] = 2,
    ACTIONS(31005), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645448] = 3,
    ACTIONS(31007), 1,
      anon_sym_SEMI,
    ACTIONS(31009), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645461] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645472] = 2,
    ACTIONS(31011), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645483] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645494] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645505] = 3,
    ACTIONS(31013), 1,
      sym__immediate_varid,
    STATE(12404), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645518] = 2,
    ACTIONS(31015), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645529] = 2,
    ACTIONS(22990), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645540] = 2,
    ACTIONS(26693), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645551] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22350), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645564] = 2,
    ACTIONS(28520), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645575] = 2,
    ACTIONS(20837), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645586] = 3,
    ACTIONS(31017), 1,
      sym__immediate_varid,
    STATE(11688), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645599] = 3,
    ACTIONS(19820), 1,
      sym_where,
    STATE(21099), 1,
      sym__gadt_rhs,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645612] = 2,
    ACTIONS(31019), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645623] = 2,
    ACTIONS(24808), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645634] = 2,
    ACTIONS(22082), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645645] = 2,
    ACTIONS(31021), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645656] = 2,
    ACTIONS(31023), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645667] = 2,
    ACTIONS(31025), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645678] = 2,
    ACTIONS(31027), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645689] = 2,
    ACTIONS(31029), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645700] = 2,
    ACTIONS(31031), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645711] = 2,
    ACTIONS(25589), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645722] = 2,
    ACTIONS(31033), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645733] = 2,
    ACTIONS(25589), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645744] = 2,
    ACTIONS(25575), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645755] = 2,
    ACTIONS(31035), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645766] = 2,
    ACTIONS(26736), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645777] = 2,
    ACTIONS(25547), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645788] = 2,
    ACTIONS(26713), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645799] = 2,
    ACTIONS(31037), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645810] = 2,
    ACTIONS(21500), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645821] = 2,
    ACTIONS(31039), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645832] = 2,
    ACTIONS(31041), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645843] = 2,
    ACTIONS(25529), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645854] = 2,
    ACTIONS(24223), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645865] = 2,
    ACTIONS(21873), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645876] = 2,
    ACTIONS(28478), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645887] = 2,
    ACTIONS(31043), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645898] = 2,
    ACTIONS(26790), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645909] = 2,
    ACTIONS(31045), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645920] = 2,
    ACTIONS(31047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645931] = 2,
    ACTIONS(28458), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645942] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22220), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645955] = 2,
    ACTIONS(24083), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645966] = 2,
    ACTIONS(31049), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645977] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [645990] = 2,
    ACTIONS(31051), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646001] = 2,
    ACTIONS(26808), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646012] = 2,
    ACTIONS(31053), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646023] = 2,
    ACTIONS(26848), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646034] = 2,
    ACTIONS(31055), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646045] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646056] = 3,
    ACTIONS(31057), 1,
      sym__immediate_varid,
    STATE(12746), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646069] = 2,
    ACTIONS(31059), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646080] = 2,
    ACTIONS(18639), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646091] = 2,
    ACTIONS(24192), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646102] = 2,
    ACTIONS(31061), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646113] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(31063), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646126] = 2,
    ACTIONS(23332), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646137] = 2,
    ACTIONS(31065), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646148] = 2,
    ACTIONS(31067), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646159] = 2,
    ACTIONS(31069), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646170] = 2,
    ACTIONS(26906), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646181] = 2,
    ACTIONS(31071), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646192] = 2,
    ACTIONS(28416), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646203] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646216] = 2,
    ACTIONS(31075), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646227] = 2,
    ACTIONS(31077), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646238] = 2,
    ACTIONS(31079), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646249] = 2,
    ACTIONS(31081), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646260] = 2,
    ACTIONS(31083), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646271] = 3,
    ACTIONS(31085), 1,
      sym__immediate_varid,
    STATE(5728), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646284] = 2,
    ACTIONS(31087), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646295] = 2,
    ACTIONS(26954), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646306] = 2,
    ACTIONS(26986), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646317] = 3,
    ACTIONS(31089), 1,
      anon_sym_SEMI,
    ACTIONS(31091), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646330] = 2,
    ACTIONS(24163), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646341] = 2,
    ACTIONS(25245), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646352] = 2,
    ACTIONS(31093), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646363] = 2,
    ACTIONS(28384), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646374] = 2,
    ACTIONS(25241), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646385] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646396] = 2,
    ACTIONS(31095), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646407] = 2,
    ACTIONS(18665), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646418] = 2,
    ACTIONS(23607), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646429] = 2,
    ACTIONS(31097), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646440] = 3,
    ACTIONS(31099), 1,
      sym__immediate_varid,
    STATE(5701), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646453] = 2,
    ACTIONS(23609), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646464] = 2,
    ACTIONS(25818), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646475] = 2,
    ACTIONS(28361), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646486] = 2,
    ACTIONS(25191), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646497] = 2,
    ACTIONS(31101), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646508] = 2,
    ACTIONS(28372), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646519] = 2,
    ACTIONS(27004), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646530] = 3,
    ACTIONS(31103), 1,
      anon_sym_SEMI,
    ACTIONS(31105), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646543] = 2,
    ACTIONS(31107), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646554] = 2,
    ACTIONS(31109), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646565] = 2,
    ACTIONS(31111), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646576] = 3,
    ACTIONS(31113), 1,
      anon_sym_in,
    STATE(13046), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646589] = 2,
    ACTIONS(31115), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646600] = 2,
    ACTIONS(21312), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646611] = 3,
    ACTIONS(31117), 1,
      anon_sym_SEMI,
    ACTIONS(31119), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646624] = 2,
    ACTIONS(31121), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646635] = 2,
    ACTIONS(31123), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646646] = 2,
    ACTIONS(27032), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646657] = 2,
    ACTIONS(28293), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646668] = 2,
    ACTIONS(31125), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646679] = 3,
    ACTIONS(31127), 1,
      sym__immediate_varid,
    STATE(12238), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646692] = 3,
    ACTIONS(31129), 1,
      anon_sym_case,
    ACTIONS(31131), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646705] = 2,
    ACTIONS(25111), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646716] = 3,
    ACTIONS(31133), 1,
      anon_sym_SEMI,
    ACTIONS(31135), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646729] = 2,
    ACTIONS(23122), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646740] = 2,
    ACTIONS(22014), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646751] = 2,
    ACTIONS(31137), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646762] = 2,
    ACTIONS(31139), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646773] = 2,
    ACTIONS(27062), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646784] = 2,
    ACTIONS(31141), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646795] = 2,
    ACTIONS(31143), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646806] = 2,
    ACTIONS(27106), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646817] = 2,
    ACTIONS(28311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646828] = 2,
    ACTIONS(28323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646839] = 3,
    ACTIONS(31145), 1,
      sym__immediate_varid,
    STATE(12052), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646852] = 2,
    ACTIONS(31147), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646863] = 3,
    ACTIONS(31149), 1,
      sym__immediate_varid,
    STATE(5505), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646876] = 2,
    ACTIONS(31151), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646887] = 2,
    ACTIONS(31153), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646898] = 2,
    ACTIONS(31155), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646909] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646922] = 2,
    ACTIONS(31159), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646933] = 2,
    ACTIONS(27161), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646944] = 2,
    ACTIONS(25061), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646955] = 2,
    ACTIONS(21224), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646966] = 2,
    ACTIONS(31161), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646977] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [646990] = 2,
    ACTIONS(31165), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647001] = 2,
    ACTIONS(25814), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647012] = 2,
    ACTIONS(21214), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647023] = 2,
    ACTIONS(25745), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647034] = 3,
    ACTIONS(31167), 1,
      anon_sym_case,
    ACTIONS(31169), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647047] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647060] = 3,
    ACTIONS(31173), 1,
      anon_sym_in,
    STATE(13758), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647073] = 2,
    ACTIONS(31175), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647084] = 2,
    ACTIONS(18661), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647095] = 2,
    ACTIONS(31177), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647106] = 2,
    ACTIONS(31179), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647117] = 3,
    ACTIONS(19169), 1,
      sym__varid,
    STATE(18774), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647130] = 2,
    ACTIONS(31181), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647141] = 2,
    ACTIONS(27215), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647152] = 2,
    ACTIONS(28275), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647163] = 2,
    ACTIONS(23066), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647174] = 2,
    ACTIONS(25023), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647185] = 2,
    ACTIONS(31183), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647196] = 2,
    ACTIONS(31185), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647207] = 2,
    ACTIONS(31187), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647218] = 2,
    ACTIONS(21912), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647229] = 2,
    ACTIONS(31189), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647240] = 2,
    ACTIONS(27259), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647251] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(22120), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647264] = 2,
    ACTIONS(31191), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647275] = 2,
    ACTIONS(27301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647286] = 2,
    ACTIONS(24985), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647297] = 2,
    ACTIONS(24991), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647308] = 2,
    ACTIONS(31193), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647319] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(31195), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647332] = 2,
    ACTIONS(24985), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647343] = 2,
    ACTIONS(28245), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647354] = 2,
    ACTIONS(31197), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647365] = 2,
    ACTIONS(21312), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647376] = 3,
    ACTIONS(31199), 1,
      anon_sym_case,
    ACTIONS(31201), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647389] = 2,
    ACTIONS(31203), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647400] = 3,
    ACTIONS(31205), 1,
      anon_sym_SEMI,
    ACTIONS(31207), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647413] = 2,
    ACTIONS(27311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647424] = 2,
    ACTIONS(31209), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647435] = 2,
    ACTIONS(31211), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647446] = 3,
    ACTIONS(31213), 1,
      anon_sym_in,
    STATE(12396), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647459] = 2,
    ACTIONS(21353), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647470] = 2,
    ACTIONS(28229), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647481] = 2,
    ACTIONS(25005), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647492] = 2,
    ACTIONS(24878), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647503] = 2,
    ACTIONS(24850), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647514] = 2,
    ACTIONS(31215), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647525] = 2,
    ACTIONS(31217), 2,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647536] = 2,
    ACTIONS(31219), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647547] = 2,
    ACTIONS(31221), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647558] = 2,
    ACTIONS(27028), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647569] = 2,
    ACTIONS(31223), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647580] = 2,
    ACTIONS(27357), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647591] = 3,
    ACTIONS(31225), 1,
      anon_sym_SEMI,
    ACTIONS(31227), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647604] = 2,
    ACTIONS(31229), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647615] = 3,
    ACTIONS(31231), 1,
      anon_sym_SEMI,
    ACTIONS(31233), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647628] = 2,
    ACTIONS(31235), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647639] = 2,
    ACTIONS(31237), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647650] = 2,
    ACTIONS(31239), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647661] = 2,
    ACTIONS(27333), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647672] = 2,
    ACTIONS(22919), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647683] = 3,
    ACTIONS(31241), 1,
      sym__immediate_varid,
    STATE(11943), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647696] = 3,
    ACTIONS(31243), 1,
      anon_sym_SEMI,
    ACTIONS(31245), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647709] = 2,
    ACTIONS(31247), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647720] = 2,
    ACTIONS(31249), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647731] = 2,
    ACTIONS(31251), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647742] = 2,
    ACTIONS(31253), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647753] = 2,
    ACTIONS(27399), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647764] = 2,
    ACTIONS(31255), 2,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647775] = 2,
    ACTIONS(28167), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647786] = 2,
    ACTIONS(28181), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647797] = 2,
    ACTIONS(24953), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647808] = 3,
    ACTIONS(31257), 1,
      anon_sym_SEMI,
    ACTIONS(31259), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647821] = 2,
    ACTIONS(22911), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647832] = 2,
    ACTIONS(31261), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647843] = 2,
    ACTIONS(17867), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647854] = 3,
    ACTIONS(31263), 1,
      anon_sym_SEMI,
    ACTIONS(31265), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647867] = 2,
    ACTIONS(31267), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647878] = 2,
    ACTIONS(24896), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647889] = 2,
    ACTIONS(31269), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647900] = 2,
    ACTIONS(25685), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647911] = 2,
    ACTIONS(27427), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647922] = 2,
    ACTIONS(17871), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647933] = 2,
    ACTIONS(21610), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647944] = 2,
    ACTIONS(31271), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647955] = 2,
    ACTIONS(25669), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647966] = 2,
    ACTIONS(23138), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647977] = 2,
    ACTIONS(25665), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647988] = 2,
    ACTIONS(31273), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [647999] = 2,
    ACTIONS(31275), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648010] = 2,
    ACTIONS(31277), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648021] = 2,
    ACTIONS(31279), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648032] = 3,
    ACTIONS(31281), 1,
      anon_sym_in,
    STATE(11287), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648045] = 3,
    ACTIONS(31283), 1,
      anon_sym_SEMI,
    ACTIONS(31285), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648058] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648071] = 2,
    ACTIONS(24270), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648082] = 2,
    ACTIONS(28138), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648093] = 2,
    ACTIONS(31289), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648104] = 2,
    ACTIONS(28120), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648115] = 3,
    ACTIONS(31291), 1,
      anon_sym_case,
    ACTIONS(31293), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648128] = 2,
    ACTIONS(24914), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648139] = 2,
    ACTIONS(31295), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648150] = 2,
    ACTIONS(31297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648161] = 2,
    ACTIONS(31299), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648172] = 2,
    ACTIONS(31301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648183] = 2,
    ACTIONS(27479), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648194] = 2,
    ACTIONS(22884), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648205] = 2,
    ACTIONS(27447), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648216] = 2,
    ACTIONS(31303), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648227] = 2,
    ACTIONS(31305), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648238] = 2,
    ACTIONS(24085), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648249] = 2,
    ACTIONS(28094), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648260] = 2,
    ACTIONS(31307), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648271] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648284] = 2,
    ACTIONS(23725), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648295] = 2,
    ACTIONS(31311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648306] = 3,
    ACTIONS(31313), 1,
      anon_sym_SEMI,
    ACTIONS(31315), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648319] = 2,
    ACTIONS(31317), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648330] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648343] = 2,
    ACTIONS(27529), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648354] = 3,
    ACTIONS(31321), 1,
      sym__immediate_varid,
    STATE(16825), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648367] = 2,
    ACTIONS(25659), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648378] = 2,
    ACTIONS(25161), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648389] = 2,
    ACTIONS(31323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648400] = 2,
    ACTIONS(31325), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648411] = 2,
    ACTIONS(25657), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648422] = 2,
    ACTIONS(28080), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648433] = 2,
    ACTIONS(31327), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648444] = 2,
    ACTIONS(27567), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648455] = 2,
    ACTIONS(21534), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648466] = 2,
    ACTIONS(31329), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648477] = 2,
    ACTIONS(31331), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648488] = 2,
    ACTIONS(21395), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648499] = 3,
    ACTIONS(31333), 1,
      sym__immediate_varid,
    STATE(4305), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648512] = 2,
    ACTIONS(21471), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648523] = 2,
    ACTIONS(31335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648534] = 2,
    ACTIONS(25599), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648545] = 2,
    ACTIONS(25599), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648556] = 2,
    ACTIONS(27697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648567] = 2,
    ACTIONS(31337), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648578] = 2,
    ACTIONS(31339), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648589] = 2,
    ACTIONS(25599), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648600] = 2,
    ACTIONS(27621), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648611] = 2,
    ACTIONS(25593), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648622] = 2,
    ACTIONS(31341), 2,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648633] = 2,
    ACTIONS(25091), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648644] = 2,
    ACTIONS(21624), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648655] = 3,
    ACTIONS(31343), 1,
      sym__immediate_varid,
    STATE(6074), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648668] = 2,
    ACTIONS(27605), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648679] = 3,
    ACTIONS(31345), 1,
      sym__immediate_varid,
    STATE(4506), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648692] = 2,
    ACTIONS(25467), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648703] = 3,
    ACTIONS(31347), 1,
      anon_sym_in,
    STATE(13233), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648716] = 2,
    ACTIONS(31349), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648727] = 3,
    ACTIONS(31351), 1,
      anon_sym_case,
    ACTIONS(31353), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648740] = 2,
    ACTIONS(28044), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648751] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648764] = 2,
    ACTIONS(31357), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648775] = 2,
    ACTIONS(31359), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648786] = 2,
    ACTIONS(31361), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648797] = 2,
    ACTIONS(27671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648808] = 3,
    ACTIONS(31363), 1,
      anon_sym_case,
    ACTIONS(31365), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648821] = 2,
    ACTIONS(21234), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648832] = 3,
    ACTIONS(7530), 1,
      sym__dot,
    ACTIONS(31367), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648845] = 2,
    ACTIONS(21670), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648856] = 2,
    ACTIONS(25424), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648867] = 2,
    ACTIONS(25402), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648878] = 2,
    ACTIONS(25127), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648889] = 2,
    ACTIONS(21351), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648900] = 2,
    ACTIONS(31369), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648911] = 2,
    ACTIONS(21328), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648922] = 2,
    ACTIONS(31371), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648933] = 2,
    ACTIONS(31373), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648944] = 2,
    ACTIONS(31375), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648955] = 2,
    ACTIONS(28040), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648966] = 2,
    ACTIONS(31377), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648977] = 2,
    ACTIONS(22724), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [648988] = 3,
    ACTIONS(31379), 1,
      anon_sym_in,
    STATE(12863), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649001] = 2,
    ACTIONS(31381), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649012] = 2,
    ACTIONS(27713), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649023] = 2,
    ACTIONS(21326), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649034] = 3,
    ACTIONS(31383), 1,
      sym__immediate_varid,
    STATE(5093), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649047] = 2,
    ACTIONS(31385), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649058] = 2,
    ACTIONS(27998), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649069] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649082] = 2,
    ACTIONS(25129), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649093] = 2,
    ACTIONS(21471), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649104] = 2,
    ACTIONS(31389), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649115] = 2,
    ACTIONS(31391), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649126] = 2,
    ACTIONS(31393), 2,
      sym__immediate_dot,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649137] = 2,
    ACTIONS(31395), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649148] = 2,
    ACTIONS(25183), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649159] = 2,
    ACTIONS(25185), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649170] = 2,
    ACTIONS(31397), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649181] = 2,
    ACTIONS(27762), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649192] = 3,
    ACTIONS(31399), 1,
      anon_sym_SEMI,
    ACTIONS(31401), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649205] = 3,
    ACTIONS(31403), 1,
      anon_sym_SEMI,
    ACTIONS(31405), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649218] = 2,
    ACTIONS(31407), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649229] = 2,
    ACTIONS(31409), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649240] = 3,
    ACTIONS(21112), 1,
      anon_sym_EQ,
    STATE(18958), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649253] = 2,
    ACTIONS(31411), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649264] = 2,
    ACTIONS(25201), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649275] = 2,
    ACTIONS(31413), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649286] = 2,
    ACTIONS(25213), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649297] = 3,
    ACTIONS(31415), 1,
      sym__immediate_varid,
    STATE(5859), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649310] = 2,
    ACTIONS(31417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649321] = 3,
    ACTIONS(31419), 1,
      anon_sym_SEMI,
    ACTIONS(31421), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649334] = 2,
    ACTIONS(25243), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649345] = 2,
    ACTIONS(21457), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649356] = 3,
    ACTIONS(15375), 1,
      sym__varid,
    STATE(20024), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649369] = 2,
    ACTIONS(31423), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649380] = 2,
    ACTIONS(27950), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649391] = 2,
    ACTIONS(27808), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649402] = 2,
    ACTIONS(29619), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649413] = 3,
    ACTIONS(31425), 1,
      anon_sym_SEMI,
    ACTIONS(31427), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649426] = 2,
    ACTIONS(31429), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649437] = 2,
    ACTIONS(22593), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649448] = 2,
    ACTIONS(25320), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649459] = 3,
    ACTIONS(31431), 1,
      anon_sym_in,
    STATE(13544), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649472] = 2,
    ACTIONS(31433), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649483] = 2,
    ACTIONS(27864), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649494] = 2,
    ACTIONS(25320), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649505] = 2,
    ACTIONS(25298), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649516] = 3,
    ACTIONS(21905), 1,
      sym_comma,
    ACTIONS(31435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649529] = 2,
    ACTIONS(27856), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649540] = 2,
    ACTIONS(31437), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649551] = 2,
    ACTIONS(31439), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649562] = 2,
    ACTIONS(24077), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649573] = 2,
    ACTIONS(21582), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649584] = 2,
    ACTIONS(31441), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649595] = 2,
    ACTIONS(27844), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649606] = 2,
    ACTIONS(31443), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649617] = 3,
    ACTIONS(31445), 1,
      anon_sym_case,
    ACTIONS(31447), 1,
      anon_sym_cases,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649630] = 2,
    ACTIONS(31449), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649641] = 2,
    ACTIONS(21596), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649652] = 3,
    ACTIONS(31451), 1,
      sym__immediate_varid,
    STATE(11410), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649665] = 2,
    ACTIONS(24374), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649676] = 2,
    ACTIONS(31453), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649687] = 2,
    ACTIONS(31455), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649698] = 2,
    ACTIONS(27894), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649709] = 2,
    ACTIONS(31457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649719] = 2,
    ACTIONS(31459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649729] = 2,
    ACTIONS(31461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649739] = 2,
    ACTIONS(31463), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649749] = 2,
    ACTIONS(31465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649759] = 2,
    ACTIONS(31467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649769] = 2,
    ACTIONS(31469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649779] = 2,
    ACTIONS(31471), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649789] = 2,
    ACTIONS(31473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649799] = 2,
    ACTIONS(31475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649809] = 2,
    ACTIONS(31477), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649819] = 2,
    ACTIONS(31479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649829] = 2,
    ACTIONS(31319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649839] = 2,
    ACTIONS(31481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649849] = 2,
    ACTIONS(17517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649859] = 2,
    ACTIONS(31483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649869] = 2,
    ACTIONS(31485), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649879] = 2,
    ACTIONS(31487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649889] = 2,
    ACTIONS(31489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649899] = 2,
    ACTIONS(31491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649909] = 2,
    ACTIONS(31287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649919] = 2,
    ACTIONS(1371), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649929] = 2,
    ACTIONS(31493), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649939] = 2,
    ACTIONS(31495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649949] = 2,
    ACTIONS(31497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649959] = 2,
    ACTIONS(31499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649969] = 2,
    ACTIONS(31501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649979] = 2,
    ACTIONS(31503), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649989] = 2,
    ACTIONS(31505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [649999] = 2,
    ACTIONS(31507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650009] = 2,
    ACTIONS(31509), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650019] = 2,
    ACTIONS(31511), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650029] = 2,
    ACTIONS(17651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650039] = 2,
    ACTIONS(31513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650049] = 2,
    ACTIONS(31515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650059] = 2,
    ACTIONS(31517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650069] = 2,
    ACTIONS(31519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650079] = 2,
    ACTIONS(31521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650089] = 2,
    ACTIONS(17689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650099] = 2,
    ACTIONS(5443), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650109] = 2,
    ACTIONS(31523), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650119] = 2,
    ACTIONS(31525), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650129] = 2,
    ACTIONS(31527), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650139] = 2,
    ACTIONS(31529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650149] = 2,
    ACTIONS(31531), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650159] = 2,
    ACTIONS(31533), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650169] = 2,
    ACTIONS(31535), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650179] = 2,
    ACTIONS(31537), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650189] = 2,
    ACTIONS(31539), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650199] = 2,
    ACTIONS(31541), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650209] = 2,
    ACTIONS(31543), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650219] = 2,
    ACTIONS(14972), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650229] = 2,
    ACTIONS(31545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650239] = 2,
    ACTIONS(31163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650249] = 2,
    ACTIONS(12387), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650259] = 2,
    ACTIONS(4753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650269] = 2,
    ACTIONS(31547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650279] = 2,
    ACTIONS(4755), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650289] = 2,
    ACTIONS(31549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650299] = 2,
    ACTIONS(31551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650309] = 2,
    ACTIONS(31553), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650319] = 2,
    ACTIONS(31555), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650329] = 2,
    ACTIONS(31557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650339] = 2,
    ACTIONS(31559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650349] = 2,
    ACTIONS(31561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650359] = 2,
    ACTIONS(14881), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650369] = 2,
    ACTIONS(31563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650379] = 2,
    ACTIONS(31565), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650389] = 2,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650399] = 2,
    ACTIONS(31567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650409] = 2,
    ACTIONS(11711), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650419] = 2,
    ACTIONS(31569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650429] = 2,
    ACTIONS(31571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650439] = 2,
    ACTIONS(5233), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650449] = 2,
    ACTIONS(31573), 1,
      anon_sym_using,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650459] = 2,
    ACTIONS(4763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650469] = 2,
    ACTIONS(12132), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650479] = 2,
    ACTIONS(14685), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650489] = 2,
    ACTIONS(31575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650499] = 2,
    ACTIONS(1339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650509] = 2,
    ACTIONS(31577), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650519] = 2,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650529] = 2,
    ACTIONS(22350), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650539] = 2,
    ACTIONS(31579), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650549] = 2,
    ACTIONS(31581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650559] = 2,
    ACTIONS(4761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650569] = 2,
    ACTIONS(31583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650579] = 2,
    ACTIONS(31585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650589] = 2,
    ACTIONS(31587), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650599] = 2,
    ACTIONS(31589), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650609] = 2,
    ACTIONS(31591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650619] = 2,
    ACTIONS(31593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650629] = 2,
    ACTIONS(31595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650639] = 2,
    ACTIONS(31597), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650649] = 2,
    ACTIONS(31599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650659] = 2,
    ACTIONS(31601), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650669] = 2,
    ACTIONS(31603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650679] = 2,
    ACTIONS(31605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650689] = 2,
    ACTIONS(31607), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650699] = 2,
    ACTIONS(31609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650709] = 2,
    ACTIONS(31611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650719] = 2,
    ACTIONS(31613), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650729] = 2,
    ACTIONS(31615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650739] = 2,
    ACTIONS(31617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650749] = 2,
    ACTIONS(31619), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650759] = 2,
    ACTIONS(31621), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650769] = 2,
    ACTIONS(31623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650779] = 2,
    ACTIONS(17583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650789] = 2,
    ACTIONS(31625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650799] = 2,
    ACTIONS(31627), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650809] = 2,
    ACTIONS(31629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650819] = 2,
    ACTIONS(31631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650829] = 2,
    ACTIONS(31633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650839] = 2,
    ACTIONS(31635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650849] = 2,
    ACTIONS(31637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650859] = 2,
    ACTIONS(31639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650869] = 2,
    ACTIONS(31641), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650879] = 2,
    ACTIONS(31643), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650889] = 2,
    ACTIONS(31645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650899] = 2,
    ACTIONS(31647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650909] = 2,
    ACTIONS(31649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650919] = 2,
    ACTIONS(17695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650929] = 2,
    ACTIONS(31651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650939] = 2,
    ACTIONS(31653), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650949] = 2,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650959] = 2,
    ACTIONS(31655), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650969] = 2,
    ACTIONS(31657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650979] = 2,
    ACTIONS(31659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650989] = 2,
    ACTIONS(31661), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [650999] = 2,
    ACTIONS(31367), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651009] = 2,
    ACTIONS(31663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651019] = 2,
    ACTIONS(31665), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651029] = 2,
    ACTIONS(31667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651039] = 2,
    ACTIONS(31669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651049] = 2,
    ACTIONS(31671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651059] = 2,
    ACTIONS(31673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651069] = 2,
    ACTIONS(31675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651079] = 2,
    ACTIONS(31677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651089] = 2,
    ACTIONS(31679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651099] = 2,
    ACTIONS(11855), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651109] = 2,
    ACTIONS(31681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651119] = 2,
    ACTIONS(31683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651129] = 2,
    ACTIONS(31685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651139] = 2,
    ACTIONS(31687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651149] = 2,
    ACTIONS(31689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651159] = 2,
    ACTIONS(31691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651169] = 2,
    ACTIONS(31693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651179] = 2,
    ACTIONS(31695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651189] = 2,
    ACTIONS(31697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651199] = 2,
    ACTIONS(31699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651209] = 2,
    ACTIONS(31701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651219] = 2,
    ACTIONS(31703), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651229] = 2,
    ACTIONS(31705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651239] = 2,
    ACTIONS(31707), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651249] = 2,
    ACTIONS(14873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651259] = 2,
    ACTIONS(31709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651269] = 2,
    ACTIONS(31711), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651279] = 2,
    ACTIONS(31713), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651289] = 2,
    ACTIONS(31715), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651299] = 2,
    ACTIONS(31717), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651309] = 2,
    ACTIONS(31719), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651319] = 2,
    ACTIONS(31721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651329] = 2,
    ACTIONS(31723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651339] = 2,
    ACTIONS(31725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651349] = 2,
    ACTIONS(31727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651359] = 2,
    ACTIONS(31729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651369] = 2,
    ACTIONS(31731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651379] = 2,
    ACTIONS(31733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651389] = 2,
    ACTIONS(31735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651399] = 2,
    ACTIONS(31737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651409] = 2,
    ACTIONS(31739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651419] = 2,
    ACTIONS(31741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651429] = 2,
    ACTIONS(21620), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651439] = 2,
    ACTIONS(31743), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651449] = 2,
    ACTIONS(31745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651459] = 2,
    ACTIONS(31747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651469] = 2,
    ACTIONS(31749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651479] = 2,
    ACTIONS(31751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651489] = 2,
    ACTIONS(31753), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651499] = 2,
    ACTIONS(31755), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651509] = 2,
    ACTIONS(31757), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651519] = 2,
    ACTIONS(31759), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651529] = 2,
    ACTIONS(31761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651539] = 2,
    ACTIONS(31763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651549] = 2,
    ACTIONS(31765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651559] = 2,
    ACTIONS(17633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651569] = 2,
    ACTIONS(31767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651579] = 2,
    ACTIONS(4805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651589] = 2,
    ACTIONS(31769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651599] = 2,
    ACTIONS(17447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651609] = 2,
    ACTIONS(31771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651619] = 2,
    ACTIONS(31773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651629] = 2,
    ACTIONS(17675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651639] = 2,
    ACTIONS(31775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651649] = 2,
    ACTIONS(31777), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651659] = 2,
    ACTIONS(31073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651669] = 2,
    ACTIONS(31779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651679] = 2,
    ACTIONS(31781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651689] = 2,
    ACTIONS(31783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651699] = 2,
    ACTIONS(31785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651709] = 2,
    ACTIONS(31787), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651719] = 2,
    ACTIONS(31789), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651729] = 2,
    ACTIONS(31791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651739] = 2,
    ACTIONS(31793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651749] = 2,
    ACTIONS(31795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651759] = 2,
    ACTIONS(31797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651769] = 2,
    ACTIONS(31799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651779] = 2,
    ACTIONS(31801), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651789] = 2,
    ACTIONS(31803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651799] = 2,
    ACTIONS(31805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651809] = 2,
    ACTIONS(31807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651819] = 2,
    ACTIONS(31809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651829] = 2,
    ACTIONS(31811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651839] = 2,
    ACTIONS(15027), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651849] = 2,
    ACTIONS(31813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651859] = 2,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651869] = 2,
    ACTIONS(17439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651879] = 2,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651889] = 2,
    ACTIONS(31815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651899] = 2,
    ACTIONS(31817), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651909] = 2,
    ACTIONS(31819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651919] = 2,
    ACTIONS(31821), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651929] = 2,
    ACTIONS(31823), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651939] = 2,
    ACTIONS(31825), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651949] = 2,
    ACTIONS(31827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651959] = 2,
    ACTIONS(31829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651969] = 2,
    ACTIONS(31831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651979] = 2,
    ACTIONS(31833), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651989] = 2,
    ACTIONS(11899), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [651999] = 2,
    ACTIONS(14573), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652009] = 2,
    ACTIONS(31835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652019] = 2,
    ACTIONS(31837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652029] = 2,
    ACTIONS(31839), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652039] = 2,
    ACTIONS(31841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652049] = 2,
    ACTIONS(12369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652059] = 2,
    ACTIONS(31843), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652069] = 2,
    ACTIONS(31845), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652079] = 2,
    ACTIONS(31847), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652089] = 2,
    ACTIONS(1329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652099] = 2,
    ACTIONS(31849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652109] = 2,
    ACTIONS(17509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652119] = 2,
    ACTIONS(31851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652129] = 2,
    ACTIONS(31853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652139] = 2,
    ACTIONS(31855), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652149] = 2,
    ACTIONS(31857), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652159] = 2,
    ACTIONS(31859), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652169] = 2,
    ACTIONS(31861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652179] = 2,
    ACTIONS(31863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652189] = 2,
    ACTIONS(31865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652199] = 2,
    ACTIONS(31867), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652209] = 2,
    ACTIONS(31869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652219] = 2,
    ACTIONS(31871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652229] = 2,
    ACTIONS(31873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652239] = 2,
    ACTIONS(31875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652249] = 2,
    ACTIONS(31877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652259] = 2,
    ACTIONS(31879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652269] = 2,
    ACTIONS(31881), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652279] = 2,
    ACTIONS(31883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652289] = 2,
    ACTIONS(31885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652299] = 2,
    ACTIONS(31887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652309] = 2,
    ACTIONS(31889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652319] = 2,
    ACTIONS(31891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652329] = 2,
    ACTIONS(31893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652339] = 2,
    ACTIONS(31895), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652349] = 2,
    ACTIONS(31897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652359] = 2,
    ACTIONS(31899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652369] = 2,
    ACTIONS(31901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652379] = 2,
    ACTIONS(31903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652389] = 2,
    ACTIONS(31905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652399] = 2,
    ACTIONS(31907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652409] = 2,
    ACTIONS(1211), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652419] = 2,
    ACTIONS(31909), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652429] = 2,
    ACTIONS(31911), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652439] = 2,
    ACTIONS(31913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652449] = 2,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652459] = 2,
    ACTIONS(31915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652469] = 2,
    ACTIONS(31917), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652479] = 2,
    ACTIONS(31919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652489] = 2,
    ACTIONS(31921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652499] = 2,
    ACTIONS(31923), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652509] = 2,
    ACTIONS(31925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652519] = 2,
    ACTIONS(31927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652529] = 2,
    ACTIONS(31929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652539] = 2,
    ACTIONS(1343), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652549] = 2,
    ACTIONS(31931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652559] = 2,
    ACTIONS(31933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652569] = 2,
    ACTIONS(31935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652579] = 2,
    ACTIONS(31937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652589] = 2,
    ACTIONS(31939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652599] = 2,
    ACTIONS(31941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652609] = 2,
    ACTIONS(31943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652619] = 2,
    ACTIONS(31945), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652629] = 2,
    ACTIONS(31947), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652639] = 2,
    ACTIONS(31949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652649] = 2,
    ACTIONS(31951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652659] = 2,
    ACTIONS(31953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652669] = 2,
    ACTIONS(31955), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652679] = 2,
    ACTIONS(31957), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652689] = 2,
    ACTIONS(31959), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652699] = 2,
    ACTIONS(31961), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652709] = 2,
    ACTIONS(11911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652719] = 2,
    ACTIONS(31963), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652729] = 2,
    ACTIONS(31965), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652739] = 2,
    ACTIONS(31967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652749] = 2,
    ACTIONS(31969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652759] = 2,
    ACTIONS(31971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652769] = 2,
    ACTIONS(14775), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652779] = 2,
    ACTIONS(31973), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652789] = 2,
    ACTIONS(31975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652799] = 2,
    ACTIONS(31977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652809] = 2,
    ACTIONS(31979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652819] = 2,
    ACTIONS(17495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652829] = 2,
    ACTIONS(31981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652839] = 2,
    ACTIONS(31983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652849] = 2,
    ACTIONS(31985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652859] = 2,
    ACTIONS(31987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652869] = 2,
    ACTIONS(31989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652879] = 2,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652889] = 2,
    ACTIONS(31991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652899] = 2,
    ACTIONS(31993), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652909] = 2,
    ACTIONS(11903), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652919] = 2,
    ACTIONS(22220), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652929] = 2,
    ACTIONS(31995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652939] = 2,
    ACTIONS(31997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652949] = 2,
    ACTIONS(14701), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652959] = 2,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652969] = 2,
    ACTIONS(31999), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652979] = 2,
    ACTIONS(32001), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652989] = 2,
    ACTIONS(32003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [652999] = 2,
    ACTIONS(32005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653009] = 2,
    ACTIONS(32007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653019] = 2,
    ACTIONS(32009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653029] = 2,
    ACTIONS(32011), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653039] = 2,
    ACTIONS(32013), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653049] = 2,
    ACTIONS(32015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653059] = 2,
    ACTIONS(32017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653069] = 2,
    ACTIONS(32019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653079] = 2,
    ACTIONS(32021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653089] = 2,
    ACTIONS(32023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653099] = 2,
    ACTIONS(32025), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653109] = 2,
    ACTIONS(32027), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653119] = 2,
    ACTIONS(32029), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653129] = 2,
    ACTIONS(32031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653139] = 2,
    ACTIONS(32033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653149] = 2,
    ACTIONS(32035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653159] = 2,
    ACTIONS(32037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653169] = 2,
    ACTIONS(32039), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653179] = 2,
    ACTIONS(32041), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653189] = 2,
    ACTIONS(32043), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653199] = 2,
    ACTIONS(32045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653209] = 2,
    ACTIONS(32047), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653219] = 2,
    ACTIONS(32049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653229] = 2,
    ACTIONS(32051), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653239] = 2,
    ACTIONS(32053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653249] = 2,
    ACTIONS(32055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653259] = 2,
    ACTIONS(32057), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653269] = 2,
    ACTIONS(237), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653279] = 2,
    ACTIONS(32059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653289] = 2,
    ACTIONS(32061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653299] = 2,
    ACTIONS(32063), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653309] = 2,
    ACTIONS(32065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653319] = 2,
    ACTIONS(32067), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653329] = 2,
    ACTIONS(12003), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653339] = 2,
    ACTIONS(14926), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653349] = 2,
    ACTIONS(32069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653359] = 2,
    ACTIONS(32071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653369] = 2,
    ACTIONS(31387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653379] = 2,
    ACTIONS(21166), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653389] = 2,
    ACTIONS(32073), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653399] = 2,
    ACTIONS(32075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653409] = 2,
    ACTIONS(32077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653419] = 2,
    ACTIONS(32079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653429] = 2,
    ACTIONS(32081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653439] = 2,
    ACTIONS(32083), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653449] = 2,
    ACTIONS(32085), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653459] = 2,
    ACTIONS(32087), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653469] = 2,
    ACTIONS(31195), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653479] = 2,
    ACTIONS(11705), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653489] = 2,
    ACTIONS(32089), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653499] = 2,
    ACTIONS(32091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653509] = 2,
    ACTIONS(32093), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653519] = 2,
    ACTIONS(32095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653529] = 2,
    ACTIONS(17607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653539] = 2,
    ACTIONS(32097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653549] = 2,
    ACTIONS(32099), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653559] = 2,
    ACTIONS(32101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653569] = 2,
    ACTIONS(15045), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653579] = 2,
    ACTIONS(32103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653589] = 2,
    ACTIONS(32105), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653599] = 2,
    ACTIONS(32107), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653609] = 2,
    ACTIONS(32109), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653619] = 2,
    ACTIONS(32111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653629] = 2,
    ACTIONS(32113), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653639] = 2,
    ACTIONS(32115), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653649] = 2,
    ACTIONS(32117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653659] = 2,
    ACTIONS(32119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653669] = 2,
    ACTIONS(32121), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653679] = 2,
    ACTIONS(32123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653689] = 2,
    ACTIONS(32125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653699] = 2,
    ACTIONS(32127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653709] = 2,
    ACTIONS(32129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653719] = 2,
    ACTIONS(12175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653729] = 2,
    ACTIONS(32131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653739] = 2,
    ACTIONS(32133), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653749] = 2,
    ACTIONS(32135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653759] = 2,
    ACTIONS(32137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653769] = 2,
    ACTIONS(22058), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653779] = 2,
    ACTIONS(32139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653789] = 2,
    ACTIONS(32141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653799] = 2,
    ACTIONS(32143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653809] = 2,
    ACTIONS(32145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653819] = 2,
    ACTIONS(32147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653829] = 2,
    ACTIONS(1309), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653839] = 2,
    ACTIONS(32149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653849] = 2,
    ACTIONS(17559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653859] = 2,
    ACTIONS(32151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653869] = 2,
    ACTIONS(32153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653879] = 2,
    ACTIONS(32155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653889] = 2,
    ACTIONS(32157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653899] = 2,
    ACTIONS(32159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653909] = 2,
    ACTIONS(32161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653919] = 2,
    ACTIONS(32163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653929] = 2,
    ACTIONS(32165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653939] = 2,
    ACTIONS(32167), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653949] = 2,
    ACTIONS(32169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653959] = 2,
    ACTIONS(32171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653969] = 2,
    ACTIONS(32173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653979] = 2,
    ACTIONS(32175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653989] = 2,
    ACTIONS(32177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [653999] = 2,
    ACTIONS(32179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654009] = 2,
    ACTIONS(32181), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654019] = 2,
    ACTIONS(32183), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654029] = 2,
    ACTIONS(32185), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654039] = 2,
    ACTIONS(32187), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654049] = 2,
    ACTIONS(32189), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654059] = 2,
    ACTIONS(32191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654069] = 2,
    ACTIONS(32193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654079] = 2,
    ACTIONS(32195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654089] = 2,
    ACTIONS(17513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654099] = 2,
    ACTIONS(32197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654109] = 2,
    ACTIONS(32199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654119] = 2,
    ACTIONS(32201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654129] = 2,
    ACTIONS(32203), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654139] = 2,
    ACTIONS(32205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654149] = 2,
    ACTIONS(32207), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654159] = 2,
    ACTIONS(32209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654169] = 2,
    ACTIONS(32211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654179] = 2,
    ACTIONS(32213), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654189] = 2,
    ACTIONS(32215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654199] = 2,
    ACTIONS(4799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654209] = 2,
    ACTIONS(32217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654219] = 2,
    ACTIONS(32219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654229] = 2,
    ACTIONS(32221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654239] = 2,
    ACTIONS(32223), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654249] = 2,
    ACTIONS(32225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654259] = 2,
    ACTIONS(32227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654269] = 2,
    ACTIONS(32229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654279] = 2,
    ACTIONS(32231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654289] = 2,
    ACTIONS(32233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654299] = 2,
    ACTIONS(32235), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654309] = 2,
    ACTIONS(32237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654319] = 2,
    ACTIONS(22541), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654329] = 2,
    ACTIONS(32239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654339] = 2,
    ACTIONS(32241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654349] = 2,
    ACTIONS(32243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654359] = 2,
    ACTIONS(32245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654369] = 2,
    ACTIONS(32247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654379] = 2,
    ACTIONS(32249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654389] = 2,
    ACTIONS(32251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654399] = 2,
    ACTIONS(32253), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654409] = 2,
    ACTIONS(32255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654419] = 2,
    ACTIONS(32257), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654429] = 2,
    ACTIONS(32259), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654439] = 2,
    ACTIONS(17441), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654449] = 2,
    ACTIONS(32261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654459] = 2,
    ACTIONS(32263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654469] = 2,
    ACTIONS(32265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654479] = 2,
    ACTIONS(32267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654489] = 2,
    ACTIONS(32269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654499] = 2,
    ACTIONS(14807), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654509] = 2,
    ACTIONS(32271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654519] = 2,
    ACTIONS(32273), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654529] = 2,
    ACTIONS(32275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654539] = 2,
    ACTIONS(32277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654549] = 2,
    ACTIONS(32279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654559] = 2,
    ACTIONS(32281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654569] = 2,
    ACTIONS(32283), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654579] = 2,
    ACTIONS(32285), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654589] = 2,
    ACTIONS(32287), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654599] = 2,
    ACTIONS(22497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654609] = 2,
    ACTIONS(32289), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654619] = 2,
    ACTIONS(32291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654629] = 2,
    ACTIONS(32293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654639] = 2,
    ACTIONS(32295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654649] = 2,
    ACTIONS(32297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654659] = 2,
    ACTIONS(32299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654669] = 2,
    ACTIONS(32301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654679] = 2,
    ACTIONS(1363), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654689] = 2,
    ACTIONS(32303), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654699] = 2,
    ACTIONS(32305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654709] = 2,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654719] = 2,
    ACTIONS(32307), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654729] = 2,
    ACTIONS(32309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654739] = 2,
    ACTIONS(32311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654749] = 2,
    ACTIONS(32313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654759] = 2,
    ACTIONS(32315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654769] = 2,
    ACTIONS(32317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654779] = 2,
    ACTIONS(32319), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654789] = 2,
    ACTIONS(32321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654799] = 2,
    ACTIONS(32323), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654809] = 2,
    ACTIONS(32325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654819] = 2,
    ACTIONS(32327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654829] = 2,
    ACTIONS(32329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654839] = 2,
    ACTIONS(32331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654849] = 2,
    ACTIONS(32333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654859] = 2,
    ACTIONS(32335), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654869] = 2,
    ACTIONS(32337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654879] = 2,
    ACTIONS(32339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654889] = 2,
    ACTIONS(32341), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654899] = 2,
    ACTIONS(32343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654909] = 2,
    ACTIONS(32345), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654919] = 2,
    ACTIONS(31063), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654929] = 2,
    ACTIONS(32347), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654939] = 2,
    ACTIONS(32349), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654949] = 2,
    ACTIONS(32351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654959] = 2,
    ACTIONS(32353), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654969] = 2,
    ACTIONS(32355), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654979] = 2,
    ACTIONS(32357), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654989] = 2,
    ACTIONS(32359), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [654999] = 2,
    ACTIONS(32361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655009] = 2,
    ACTIONS(14472), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655019] = 2,
    ACTIONS(32363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655029] = 2,
    ACTIONS(32365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655039] = 2,
    ACTIONS(32367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655049] = 2,
    ACTIONS(32369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655059] = 2,
    ACTIONS(32371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655069] = 2,
    ACTIONS(32373), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655079] = 2,
    ACTIONS(32375), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655089] = 2,
    ACTIONS(32377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655099] = 2,
    ACTIONS(32379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655109] = 2,
    ACTIONS(32381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655119] = 2,
    ACTIONS(32383), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655129] = 2,
    ACTIONS(32385), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655139] = 2,
    ACTIONS(32387), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655149] = 2,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655159] = 2,
    ACTIONS(17519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655169] = 2,
    ACTIONS(15047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655179] = 2,
    ACTIONS(32389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655189] = 2,
    ACTIONS(21397), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655199] = 2,
    ACTIONS(32391), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655209] = 2,
    ACTIONS(32393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655219] = 2,
    ACTIONS(12302), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655229] = 2,
    ACTIONS(14713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655239] = 2,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655249] = 2,
    ACTIONS(32395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655259] = 2,
    ACTIONS(32397), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655269] = 2,
    ACTIONS(32399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655279] = 2,
    ACTIONS(1283), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655289] = 2,
    ACTIONS(32401), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655299] = 2,
    ACTIONS(32403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655309] = 2,
    ACTIONS(32405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655319] = 2,
    ACTIONS(32407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655329] = 2,
    ACTIONS(32409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655339] = 2,
    ACTIONS(32411), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655349] = 2,
    ACTIONS(32413), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655359] = 2,
    ACTIONS(32415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655369] = 2,
    ACTIONS(32417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655379] = 2,
    ACTIONS(32419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655389] = 2,
    ACTIONS(32421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655399] = 2,
    ACTIONS(32423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655409] = 2,
    ACTIONS(32425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655419] = 2,
    ACTIONS(32427), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655429] = 2,
    ACTIONS(32429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655439] = 2,
    ACTIONS(32431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655449] = 2,
    ACTIONS(32433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655459] = 2,
    ACTIONS(32435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655469] = 2,
    ACTIONS(32437), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655479] = 2,
    ACTIONS(32439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655489] = 2,
    ACTIONS(32441), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655499] = 2,
    ACTIONS(32443), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655509] = 2,
    ACTIONS(32445), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655519] = 2,
    ACTIONS(32447), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655529] = 2,
    ACTIONS(32449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655539] = 2,
    ACTIONS(32451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655549] = 2,
    ACTIONS(17515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655559] = 2,
    ACTIONS(32453), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655569] = 2,
    ACTIONS(32455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655579] = 2,
    ACTIONS(32457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655589] = 2,
    ACTIONS(32459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655599] = 2,
    ACTIONS(32461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655609] = 2,
    ACTIONS(32463), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655619] = 2,
    ACTIONS(32465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655629] = 2,
    ACTIONS(32467), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655639] = 2,
    ACTIONS(32469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655649] = 2,
    ACTIONS(32471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655659] = 2,
    ACTIONS(32473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655669] = 2,
    ACTIONS(32475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655679] = 2,
    ACTIONS(32477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655689] = 2,
    ACTIONS(32479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655699] = 2,
    ACTIONS(32481), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655709] = 2,
    ACTIONS(32483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655719] = 2,
    ACTIONS(32485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655729] = 2,
    ACTIONS(32487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655739] = 2,
    ACTIONS(32489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655749] = 2,
    ACTIONS(32491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655759] = 2,
    ACTIONS(32493), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655769] = 2,
    ACTIONS(32495), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655779] = 2,
    ACTIONS(32497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655789] = 2,
    ACTIONS(17631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655799] = 2,
    ACTIONS(32499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655809] = 2,
    ACTIONS(4885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655819] = 2,
    ACTIONS(32501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655829] = 2,
    ACTIONS(32503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655839] = 2,
    ACTIONS(22056), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655849] = 2,
    ACTIONS(32505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655859] = 2,
    ACTIONS(32507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655869] = 2,
    ACTIONS(32509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655879] = 2,
    ACTIONS(32511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655889] = 2,
    ACTIONS(32513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655899] = 2,
    ACTIONS(32515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655909] = 2,
    ACTIONS(32517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655919] = 2,
    ACTIONS(32519), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655929] = 2,
    ACTIONS(32521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655939] = 2,
    ACTIONS(32523), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655949] = 2,
    ACTIONS(32525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655959] = 2,
    ACTIONS(32527), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655969] = 2,
    ACTIONS(32529), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655979] = 2,
    ACTIONS(32531), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655989] = 2,
    ACTIONS(17571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [655999] = 2,
    ACTIONS(32533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656009] = 2,
    ACTIONS(32535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656019] = 2,
    ACTIONS(32537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656029] = 2,
    ACTIONS(32539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656039] = 2,
    ACTIONS(32541), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656049] = 2,
    ACTIONS(32543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656059] = 2,
    ACTIONS(32545), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656069] = 2,
    ACTIONS(32547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656079] = 2,
    ACTIONS(32549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656089] = 2,
    ACTIONS(32551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656099] = 2,
    ACTIONS(32553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656109] = 2,
    ACTIONS(32555), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656119] = 2,
    ACTIONS(32557), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656129] = 2,
    ACTIONS(32559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656139] = 2,
    ACTIONS(32561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656149] = 2,
    ACTIONS(32563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656159] = 2,
    ACTIONS(32565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656169] = 2,
    ACTIONS(32567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656179] = 2,
    ACTIONS(32569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656189] = 2,
    ACTIONS(32571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656199] = 2,
    ACTIONS(32573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656209] = 2,
    ACTIONS(32575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656219] = 2,
    ACTIONS(32577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656229] = 2,
    ACTIONS(32579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656239] = 2,
    ACTIONS(32581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656249] = 2,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656259] = 2,
    ACTIONS(32583), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656269] = 2,
    ACTIONS(32585), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656279] = 2,
    ACTIONS(30217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656289] = 2,
    ACTIONS(32587), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656299] = 2,
    ACTIONS(32589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656309] = 2,
    ACTIONS(32591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656319] = 2,
    ACTIONS(32593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656329] = 2,
    ACTIONS(11905), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656339] = 2,
    ACTIONS(14727), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656349] = 2,
    ACTIONS(32595), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656359] = 2,
    ACTIONS(17703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656369] = 2,
    ACTIONS(14877), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656379] = 2,
    ACTIONS(32597), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656389] = 2,
    ACTIONS(32599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656399] = 2,
    ACTIONS(32601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656409] = 2,
    ACTIONS(32603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656419] = 2,
    ACTIONS(32605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656429] = 2,
    ACTIONS(32607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656439] = 2,
    ACTIONS(32609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656449] = 2,
    ACTIONS(32611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656459] = 2,
    ACTIONS(32613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656469] = 2,
    ACTIONS(32615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656479] = 2,
    ACTIONS(32617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656489] = 2,
    ACTIONS(32619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656499] = 2,
    ACTIONS(32621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656509] = 2,
    ACTIONS(32623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656519] = 2,
    ACTIONS(12383), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656529] = 2,
    ACTIONS(32625), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656539] = 2,
    ACTIONS(32627), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656549] = 2,
    ACTIONS(32629), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656559] = 2,
    ACTIONS(32631), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656569] = 2,
    ACTIONS(32633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656579] = 2,
    ACTIONS(32635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656589] = 2,
    ACTIONS(32637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656599] = 2,
    ACTIONS(32639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656609] = 2,
    ACTIONS(32641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656619] = 2,
    ACTIONS(22386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656629] = 2,
    ACTIONS(32643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656639] = 2,
    ACTIONS(17661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656649] = 2,
    ACTIONS(32645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656659] = 2,
    ACTIONS(32647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656669] = 2,
    ACTIONS(32649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656679] = 2,
    ACTIONS(32651), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656689] = 2,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656699] = 2,
    ACTIONS(17589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656709] = 2,
    ACTIONS(32653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656719] = 2,
    ACTIONS(32655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656729] = 2,
    ACTIONS(32657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656739] = 2,
    ACTIONS(32659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656749] = 2,
    ACTIONS(32661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656759] = 2,
    ACTIONS(32663), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656769] = 2,
    ACTIONS(32665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656779] = 2,
    ACTIONS(32667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656789] = 2,
    ACTIONS(32669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656799] = 2,
    ACTIONS(1337), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656809] = 2,
    ACTIONS(32671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656819] = 2,
    ACTIONS(32673), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656829] = 2,
    ACTIONS(32675), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656839] = 2,
    ACTIONS(163), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656849] = 2,
    ACTIONS(32677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656859] = 2,
    ACTIONS(32679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656869] = 2,
    ACTIONS(32681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656879] = 2,
    ACTIONS(32683), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656889] = 2,
    ACTIONS(26752), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656899] = 2,
    ACTIONS(32685), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656909] = 2,
    ACTIONS(32687), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656919] = 2,
    ACTIONS(32689), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656929] = 2,
    ACTIONS(32691), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656939] = 2,
    ACTIONS(32693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656949] = 2,
    ACTIONS(32695), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656959] = 2,
    ACTIONS(32697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656969] = 2,
    ACTIONS(4599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656979] = 2,
    ACTIONS(32699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656989] = 2,
    ACTIONS(32701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [656999] = 2,
    ACTIONS(32703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657009] = 2,
    ACTIONS(32705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657019] = 2,
    ACTIONS(32707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657029] = 2,
    ACTIONS(32709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657039] = 2,
    ACTIONS(32711), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657049] = 2,
    ACTIONS(32713), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657059] = 2,
    ACTIONS(32715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657069] = 2,
    ACTIONS(32717), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657079] = 2,
    ACTIONS(32719), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657089] = 2,
    ACTIONS(29809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657099] = 2,
    ACTIONS(32721), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657109] = 2,
    ACTIONS(32723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657119] = 2,
    ACTIONS(32725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657129] = 2,
    ACTIONS(17539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657139] = 2,
    ACTIONS(32727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657149] = 2,
    ACTIONS(32729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657159] = 2,
    ACTIONS(32731), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657169] = 2,
    ACTIONS(32733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657179] = 2,
    ACTIONS(32735), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657189] = 2,
    ACTIONS(32737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657199] = 2,
    ACTIONS(32739), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657209] = 2,
    ACTIONS(32741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657219] = 2,
    ACTIONS(32743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657229] = 2,
    ACTIONS(32745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657239] = 2,
    ACTIONS(32747), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657249] = 2,
    ACTIONS(32749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657259] = 2,
    ACTIONS(32751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657269] = 2,
    ACTIONS(32753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657279] = 2,
    ACTIONS(32755), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657289] = 2,
    ACTIONS(32757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657299] = 2,
    ACTIONS(32759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657309] = 2,
    ACTIONS(32761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657319] = 2,
    ACTIONS(32763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657329] = 2,
    ACTIONS(32765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657339] = 2,
    ACTIONS(32767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657349] = 2,
    ACTIONS(32769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657359] = 2,
    ACTIONS(32771), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657369] = 2,
    ACTIONS(32773), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657379] = 2,
    ACTIONS(32775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657389] = 2,
    ACTIONS(32777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657399] = 2,
    ACTIONS(32779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657409] = 2,
    ACTIONS(4823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657419] = 2,
    ACTIONS(32781), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657429] = 2,
    ACTIONS(32783), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657439] = 2,
    ACTIONS(32785), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657449] = 2,
    ACTIONS(32787), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657459] = 2,
    ACTIONS(32789), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657469] = 2,
    ACTIONS(14735), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657479] = 2,
    ACTIONS(17685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657489] = 2,
    ACTIONS(12177), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657499] = 2,
    ACTIONS(32791), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657509] = 2,
    ACTIONS(30615), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657519] = 2,
    ACTIONS(32793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657529] = 2,
    ACTIONS(32795), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657539] = 2,
    ACTIONS(32797), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657549] = 2,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657559] = 2,
    ACTIONS(32799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657569] = 2,
    ACTIONS(32801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657579] = 2,
    ACTIONS(32803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657589] = 2,
    ACTIONS(32805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657599] = 2,
    ACTIONS(32807), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657609] = 2,
    ACTIONS(32809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657619] = 2,
    ACTIONS(17501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657629] = 2,
    ACTIONS(32811), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657639] = 2,
    ACTIONS(32813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657649] = 2,
    ACTIONS(32815), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657659] = 2,
    ACTIONS(32817), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657669] = 2,
    ACTIONS(32819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657679] = 2,
    ACTIONS(30929), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657689] = 2,
    ACTIONS(32821), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657699] = 2,
    ACTIONS(32823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657709] = 2,
    ACTIONS(32825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657719] = 2,
    ACTIONS(4855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657729] = 2,
    ACTIONS(32827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657739] = 2,
    ACTIONS(32829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657749] = 2,
    ACTIONS(32831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657759] = 2,
    ACTIONS(32833), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657769] = 2,
    ACTIONS(32835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657779] = 2,
    ACTIONS(32837), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657789] = 2,
    ACTIONS(32839), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657799] = 2,
    ACTIONS(32841), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657809] = 2,
    ACTIONS(32843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657819] = 2,
    ACTIONS(32845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657829] = 2,
    ACTIONS(32847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657839] = 2,
    ACTIONS(32849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657849] = 2,
    ACTIONS(32851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657859] = 2,
    ACTIONS(30379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657869] = 2,
    ACTIONS(11897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657879] = 2,
    ACTIONS(17671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657889] = 2,
    ACTIONS(32853), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657899] = 2,
    ACTIONS(32855), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657909] = 2,
    ACTIONS(32857), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657919] = 2,
    ACTIONS(1183), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657929] = 2,
    ACTIONS(17531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657939] = 2,
    ACTIONS(32859), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657949] = 2,
    ACTIONS(14799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657959] = 2,
    ACTIONS(32861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657969] = 2,
    ACTIONS(32863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657979] = 2,
    ACTIONS(32865), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657989] = 2,
    ACTIONS(32867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [657999] = 2,
    ACTIONS(32869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658009] = 2,
    ACTIONS(32871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658019] = 2,
    ACTIONS(32873), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658029] = 2,
    ACTIONS(32875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658039] = 2,
    ACTIONS(12286), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658049] = 2,
    ACTIONS(32877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658059] = 2,
    ACTIONS(4449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658069] = 2,
    ACTIONS(17451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658079] = 2,
    ACTIONS(1315), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658089] = 2,
    ACTIONS(32879), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658099] = 2,
    ACTIONS(12211), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658109] = 2,
    ACTIONS(32881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658119] = 2,
    ACTIONS(32883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658129] = 2,
    ACTIONS(1235), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658139] = 2,
    ACTIONS(32885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658149] = 2,
    ACTIONS(21584), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658159] = 2,
    ACTIONS(14757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658169] = 2,
    ACTIONS(32887), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658179] = 2,
    ACTIONS(32889), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658189] = 2,
    ACTIONS(32891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658199] = 2,
    ACTIONS(32893), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658209] = 2,
    ACTIONS(32895), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658219] = 2,
    ACTIONS(32897), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658229] = 2,
    ACTIONS(32899), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658239] = 2,
    ACTIONS(15603), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658249] = 2,
    ACTIONS(32901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658259] = 2,
    ACTIONS(17797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658269] = 2,
    ACTIONS(32903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658279] = 2,
    ACTIONS(32905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658289] = 2,
    ACTIONS(32907), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658299] = 2,
    ACTIONS(32909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658309] = 2,
    ACTIONS(32911), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658319] = 2,
    ACTIONS(32913), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658329] = 2,
    ACTIONS(32915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658339] = 2,
    ACTIONS(32917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658349] = 2,
    ACTIONS(32919), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658359] = 2,
    ACTIONS(30887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658369] = 2,
    ACTIONS(4727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658379] = 2,
    ACTIONS(32921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658389] = 2,
    ACTIONS(32923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658399] = 2,
    ACTIONS(32925), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658409] = 2,
    ACTIONS(32927), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658419] = 2,
    ACTIONS(32929), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658429] = 2,
    ACTIONS(32931), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658439] = 2,
    ACTIONS(22374), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658449] = 2,
    ACTIONS(32933), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658459] = 2,
    ACTIONS(32935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658469] = 2,
    ACTIONS(32937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658479] = 2,
    ACTIONS(32939), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658489] = 2,
    ACTIONS(32941), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658499] = 2,
    ACTIONS(32943), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658509] = 2,
    ACTIONS(32945), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658519] = 2,
    ACTIONS(32947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658529] = 2,
    ACTIONS(32949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658539] = 2,
    ACTIONS(14964), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658549] = 2,
    ACTIONS(32951), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658559] = 2,
    ACTIONS(32953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658569] = 2,
    ACTIONS(32955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658579] = 2,
    ACTIONS(32957), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658589] = 2,
    ACTIONS(32959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658599] = 2,
    ACTIONS(32961), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658609] = 2,
    ACTIONS(12389), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658619] = 2,
    ACTIONS(32963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658629] = 2,
    ACTIONS(32965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658639] = 2,
    ACTIONS(32967), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658649] = 2,
    ACTIONS(1301), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658659] = 2,
    ACTIONS(32969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658669] = 2,
    ACTIONS(32971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658679] = 2,
    ACTIONS(32973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658689] = 2,
    ACTIONS(32975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658699] = 2,
    ACTIONS(32977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658709] = 2,
    ACTIONS(32979), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658719] = 2,
    ACTIONS(32981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658729] = 2,
    ACTIONS(32983), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658739] = 2,
    ACTIONS(32985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658749] = 2,
    ACTIONS(32987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658759] = 2,
    ACTIONS(30851), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658769] = 2,
    ACTIONS(32989), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658779] = 2,
    ACTIONS(32991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658789] = 2,
    ACTIONS(31171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658799] = 2,
    ACTIONS(17629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658809] = 2,
    ACTIONS(32993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658819] = 2,
    ACTIONS(32995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658829] = 2,
    ACTIONS(32997), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658839] = 2,
    ACTIONS(32999), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658849] = 2,
    ACTIONS(33001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658859] = 2,
    ACTIONS(33003), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658869] = 2,
    ACTIONS(17505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658879] = 2,
    ACTIONS(30711), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658889] = 2,
    ACTIONS(33005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658899] = 2,
    ACTIONS(33007), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658909] = 2,
    ACTIONS(33009), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658919] = 2,
    ACTIONS(33011), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658929] = 2,
    ACTIONS(33013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658939] = 2,
    ACTIONS(33015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658949] = 2,
    ACTIONS(33017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658959] = 2,
    ACTIONS(33019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658969] = 2,
    ACTIONS(33021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658979] = 2,
    ACTIONS(33023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658989] = 2,
    ACTIONS(33025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [658999] = 2,
    ACTIONS(33027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659009] = 2,
    ACTIONS(33029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659019] = 2,
    ACTIONS(33031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659029] = 2,
    ACTIONS(33033), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659039] = 2,
    ACTIONS(33035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659049] = 2,
    ACTIONS(33037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659059] = 2,
    ACTIONS(33039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659069] = 2,
    ACTIONS(33041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659079] = 2,
    ACTIONS(33043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659089] = 2,
    ACTIONS(33045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659099] = 2,
    ACTIONS(33047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659109] = 2,
    ACTIONS(33049), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659119] = 2,
    ACTIONS(33051), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659129] = 2,
    ACTIONS(33053), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659139] = 2,
    ACTIONS(33055), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659149] = 2,
    ACTIONS(17453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659159] = 2,
    ACTIONS(33057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659169] = 2,
    ACTIONS(33059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659179] = 2,
    ACTIONS(33061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659189] = 2,
    ACTIONS(33063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659199] = 2,
    ACTIONS(21903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659209] = 2,
    ACTIONS(4419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659219] = 2,
    ACTIONS(33065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659229] = 2,
    ACTIONS(33067), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659239] = 2,
    ACTIONS(33069), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659249] = 2,
    ACTIONS(33071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659259] = 2,
    ACTIONS(14771), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659269] = 2,
    ACTIONS(33073), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659279] = 2,
    ACTIONS(33075), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659289] = 2,
    ACTIONS(33077), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659299] = 2,
    ACTIONS(33079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659309] = 2,
    ACTIONS(33081), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659319] = 2,
    ACTIONS(33083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659329] = 2,
    ACTIONS(12098), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659339] = 2,
    ACTIONS(33085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659349] = 2,
    ACTIONS(33087), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659359] = 2,
    ACTIONS(33089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659369] = 2,
    ACTIONS(33091), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659379] = 2,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659389] = 2,
    ACTIONS(33093), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659399] = 2,
    ACTIONS(33095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659409] = 2,
    ACTIONS(1285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659419] = 2,
    ACTIONS(33097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659429] = 2,
    ACTIONS(33099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659439] = 2,
    ACTIONS(33101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659449] = 2,
    ACTIONS(33103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659459] = 2,
    ACTIONS(33105), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659469] = 2,
    ACTIONS(33107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659479] = 2,
    ACTIONS(33109), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659489] = 2,
    ACTIONS(30781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659499] = 2,
    ACTIONS(4725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659509] = 2,
    ACTIONS(33111), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659519] = 2,
    ACTIONS(33113), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659529] = 2,
    ACTIONS(33115), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659539] = 2,
    ACTIONS(33117), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659549] = 2,
    ACTIONS(33119), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659559] = 2,
    ACTIONS(4719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659569] = 2,
    ACTIONS(14523), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659579] = 2,
    ACTIONS(33121), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659589] = 2,
    ACTIONS(33123), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659599] = 2,
    ACTIONS(12092), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659609] = 2,
    ACTIONS(12304), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659619] = 2,
    ACTIONS(33125), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659629] = 2,
    ACTIONS(33127), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659639] = 2,
    ACTIONS(14765), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659649] = 2,
    ACTIONS(33129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659659] = 2,
    ACTIONS(33131), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659669] = 2,
    ACTIONS(33133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659679] = 2,
    ACTIONS(33135), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659689] = 2,
    ACTIONS(33137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659699] = 2,
    ACTIONS(4723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659709] = 2,
    ACTIONS(33139), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659719] = 2,
    ACTIONS(15549), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659729] = 2,
    ACTIONS(18580), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659739] = 2,
    ACTIONS(33141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659749] = 2,
    ACTIONS(33143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659759] = 2,
    ACTIONS(33145), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659769] = 2,
    ACTIONS(33147), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659779] = 2,
    ACTIONS(33149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659789] = 2,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659799] = 2,
    ACTIONS(33151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659809] = 2,
    ACTIONS(33153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659819] = 2,
    ACTIONS(33155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659829] = 2,
    ACTIONS(33157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659839] = 2,
    ACTIONS(33159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659849] = 2,
    ACTIONS(33161), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659859] = 2,
    ACTIONS(33163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659869] = 2,
    ACTIONS(33165), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659879] = 2,
    ACTIONS(33167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659889] = 2,
    ACTIONS(33169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659899] = 2,
    ACTIONS(33171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659909] = 2,
    ACTIONS(33173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659919] = 2,
    ACTIONS(33175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659929] = 2,
    ACTIONS(30757), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659939] = 2,
    ACTIONS(17557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659949] = 2,
    ACTIONS(33177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659959] = 2,
    ACTIONS(30659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659969] = 2,
    ACTIONS(4721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659979] = 2,
    ACTIONS(33179), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659989] = 2,
    ACTIONS(33181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [659999] = 2,
    ACTIONS(33183), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660009] = 2,
    ACTIONS(33185), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660019] = 2,
    ACTIONS(33187), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660029] = 2,
    ACTIONS(33189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660039] = 2,
    ACTIONS(33191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660049] = 2,
    ACTIONS(33193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660059] = 2,
    ACTIONS(33195), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660069] = 2,
    ACTIONS(33197), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660079] = 2,
    ACTIONS(22044), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660089] = 2,
    ACTIONS(33199), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660099] = 2,
    ACTIONS(33201), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660109] = 2,
    ACTIONS(33203), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660119] = 2,
    ACTIONS(33205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660129] = 2,
    ACTIONS(33207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660139] = 2,
    ACTIONS(33209), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660149] = 2,
    ACTIONS(33211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660159] = 2,
    ACTIONS(33213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660169] = 2,
    ACTIONS(33215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660179] = 2,
    ACTIONS(33217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660189] = 2,
    ACTIONS(17639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660199] = 2,
    ACTIONS(14867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660209] = 2,
    ACTIONS(4441), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660219] = 2,
    ACTIONS(33219), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660229] = 2,
    ACTIONS(33221), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660239] = 2,
    ACTIONS(30533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660249] = 2,
    ACTIONS(33223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660259] = 2,
    ACTIONS(33225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660269] = 2,
    ACTIONS(33227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660279] = 2,
    ACTIONS(17581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660289] = 2,
    ACTIONS(33229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660299] = 2,
    ACTIONS(33231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660309] = 2,
    ACTIONS(33233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660319] = 2,
    ACTIONS(33235), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660329] = 2,
    ACTIONS(33237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660339] = 2,
    ACTIONS(33239), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660349] = 2,
    ACTIONS(33241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660359] = 2,
    ACTIONS(33243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660369] = 2,
    ACTIONS(33245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660379] = 2,
    ACTIONS(4445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660389] = 2,
    ACTIONS(33247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660399] = 2,
    ACTIONS(33249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660409] = 2,
    ACTIONS(33251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660419] = 2,
    ACTIONS(33253), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660429] = 2,
    ACTIONS(33255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660439] = 2,
    ACTIONS(33257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660449] = 2,
    ACTIONS(33259), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660459] = 2,
    ACTIONS(33261), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660469] = 2,
    ACTIONS(17489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660479] = 2,
    ACTIONS(1195), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660489] = 2,
    ACTIONS(33263), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660499] = 2,
    ACTIONS(4813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660509] = 2,
    ACTIONS(14529), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660519] = 2,
    ACTIONS(33265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660529] = 2,
    ACTIONS(17687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660539] = 2,
    ACTIONS(33267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660549] = 2,
    ACTIONS(33269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660559] = 2,
    ACTIONS(33271), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660569] = 2,
    ACTIONS(12120), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660579] = 2,
    ACTIONS(33273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660589] = 2,
    ACTIONS(30695), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660599] = 2,
    ACTIONS(33275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660609] = 2,
    ACTIONS(33277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660619] = 2,
    ACTIONS(33279), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660629] = 2,
    ACTIONS(33281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660639] = 2,
    ACTIONS(33283), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660649] = 2,
    ACTIONS(33285), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660659] = 2,
    ACTIONS(33287), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660669] = 2,
    ACTIONS(33289), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660679] = 2,
    ACTIONS(33291), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660689] = 2,
    ACTIONS(1199), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660699] = 2,
    ACTIONS(33293), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660709] = 2,
    ACTIONS(33295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660719] = 2,
    ACTIONS(33297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660729] = 2,
    ACTIONS(14793), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660739] = 2,
    ACTIONS(12241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660749] = 2,
    ACTIONS(33299), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660759] = 2,
    ACTIONS(33301), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660769] = 2,
    ACTIONS(30671), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660779] = 2,
    ACTIONS(33303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660789] = 2,
    ACTIONS(33305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660799] = 2,
    ACTIONS(33307), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660809] = 2,
    ACTIONS(30527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660819] = 2,
    ACTIONS(33309), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660829] = 2,
    ACTIONS(33311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660839] = 2,
    ACTIONS(33313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660849] = 2,
    ACTIONS(33315), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660859] = 2,
    ACTIONS(33317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660869] = 2,
    ACTIONS(33319), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660879] = 2,
    ACTIONS(17481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660889] = 2,
    ACTIONS(33321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660899] = 2,
    ACTIONS(33323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660909] = 2,
    ACTIONS(1269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660919] = 2,
    ACTIONS(33325), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660929] = 2,
    ACTIONS(33327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660939] = 2,
    ACTIONS(33329), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660949] = 2,
    ACTIONS(33331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660959] = 2,
    ACTIONS(33333), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660969] = 2,
    ACTIONS(33335), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660979] = 2,
    ACTIONS(33337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660989] = 2,
    ACTIONS(33339), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [660999] = 2,
    ACTIONS(33341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661009] = 2,
    ACTIONS(33343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661019] = 2,
    ACTIONS(30647), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661029] = 2,
    ACTIONS(33345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661039] = 2,
    ACTIONS(33347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661049] = 2,
    ACTIONS(33349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661059] = 2,
    ACTIONS(33351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661069] = 2,
    ACTIONS(33353), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661079] = 2,
    ACTIONS(12385), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661089] = 2,
    ACTIONS(14725), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661099] = 2,
    ACTIONS(33355), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661109] = 2,
    ACTIONS(33357), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661119] = 2,
    ACTIONS(33359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661129] = 2,
    ACTIONS(14773), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661139] = 2,
    ACTIONS(33361), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661149] = 2,
    ACTIONS(33363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661159] = 2,
    ACTIONS(33365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661169] = 2,
    ACTIONS(30841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661179] = 2,
    ACTIONS(4801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661189] = 2,
    ACTIONS(33367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661199] = 2,
    ACTIONS(33369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661209] = 2,
    ACTIONS(33371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661219] = 2,
    ACTIONS(33373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661229] = 2,
    ACTIONS(33375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661239] = 2,
    ACTIONS(33377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661249] = 2,
    ACTIONS(33379), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661259] = 2,
    ACTIONS(33381), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661269] = 2,
    ACTIONS(4853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661279] = 2,
    ACTIONS(33383), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661289] = 2,
    ACTIONS(33385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661299] = 2,
    ACTIONS(30365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661309] = 2,
    ACTIONS(33387), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661319] = 2,
    ACTIONS(4709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661329] = 2,
    ACTIONS(33389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661339] = 2,
    ACTIONS(33391), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661349] = 2,
    ACTIONS(17567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661359] = 2,
    ACTIONS(33393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661369] = 2,
    ACTIONS(33395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661379] = 2,
    ACTIONS(33397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661389] = 2,
    ACTIONS(33399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661399] = 2,
    ACTIONS(33401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661409] = 2,
    ACTIONS(22466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661419] = 2,
    ACTIONS(33403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661429] = 2,
    ACTIONS(33405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661439] = 2,
    ACTIONS(33407), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661449] = 2,
    ACTIONS(33409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661459] = 2,
    ACTIONS(33411), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661469] = 2,
    ACTIONS(33413), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661479] = 2,
    ACTIONS(33415), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661489] = 2,
    ACTIONS(17653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661499] = 2,
    ACTIONS(33417), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661509] = 2,
    ACTIONS(33419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661519] = 2,
    ACTIONS(33421), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661529] = 2,
    ACTIONS(33423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661539] = 2,
    ACTIONS(33425), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661549] = 2,
    ACTIONS(33427), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661559] = 2,
    ACTIONS(33429), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661569] = 2,
    ACTIONS(33431), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661579] = 2,
    ACTIONS(33433), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661589] = 2,
    ACTIONS(33435), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661599] = 2,
    ACTIONS(17521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661609] = 2,
    ACTIONS(33437), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661619] = 2,
    ACTIONS(33439), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661629] = 2,
    ACTIONS(33441), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661639] = 2,
    ACTIONS(33443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661649] = 2,
    ACTIONS(33445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661659] = 2,
    ACTIONS(33447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661669] = 2,
    ACTIONS(33449), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661679] = 2,
    ACTIONS(33451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661689] = 2,
    ACTIONS(33453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661699] = 2,
    ACTIONS(33455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661709] = 2,
    ACTIONS(33457), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661719] = 2,
    ACTIONS(33459), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661729] = 2,
    ACTIONS(33461), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661739] = 2,
    ACTIONS(33463), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661749] = 2,
    ACTIONS(33465), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661759] = 2,
    ACTIONS(33467), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661769] = 2,
    ACTIONS(33469), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661779] = 2,
    ACTIONS(33471), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661789] = 2,
    ACTIONS(33473), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661799] = 2,
    ACTIONS(14555), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661809] = 2,
    ACTIONS(33475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661819] = 2,
    ACTIONS(11887), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661829] = 2,
    ACTIONS(33477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661839] = 2,
    ACTIONS(17801), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661849] = 2,
    ACTIONS(33479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661859] = 2,
    ACTIONS(15049), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661869] = 2,
    ACTIONS(11853), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661879] = 2,
    ACTIONS(33481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661889] = 2,
    ACTIONS(1245), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661899] = 2,
    ACTIONS(33483), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661909] = 2,
    ACTIONS(33485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661919] = 2,
    ACTIONS(33487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661929] = 2,
    ACTIONS(33489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661939] = 2,
    ACTIONS(33491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661949] = 2,
    ACTIONS(33493), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661959] = 2,
    ACTIONS(21853), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661969] = 2,
    ACTIONS(33495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661979] = 2,
    ACTIONS(33497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661989] = 2,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [661999] = 2,
    ACTIONS(33499), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662009] = 2,
    ACTIONS(17487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662019] = 2,
    ACTIONS(33501), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662029] = 2,
    ACTIONS(33503), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662039] = 2,
    ACTIONS(17659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662049] = 2,
    ACTIONS(33505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662059] = 2,
    ACTIONS(30551), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662069] = 2,
    ACTIONS(4887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662079] = 2,
    ACTIONS(31435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662089] = 2,
    ACTIONS(33507), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662099] = 2,
    ACTIONS(33509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662109] = 2,
    ACTIONS(33511), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662119] = 2,
    ACTIONS(33513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662129] = 2,
    ACTIONS(33515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662139] = 2,
    ACTIONS(33517), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662149] = 2,
    ACTIONS(33519), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662159] = 2,
    ACTIONS(33521), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662169] = 2,
    ACTIONS(33523), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662179] = 2,
    ACTIONS(33525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662189] = 2,
    ACTIONS(33527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662199] = 2,
    ACTIONS(33529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662209] = 2,
    ACTIONS(33531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662219] = 2,
    ACTIONS(33533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662229] = 2,
    ACTIONS(33535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662239] = 2,
    ACTIONS(33537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662249] = 2,
    ACTIONS(17477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662259] = 2,
    ACTIONS(33539), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662269] = 2,
    ACTIONS(33541), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662279] = 2,
    ACTIONS(1209), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662289] = 2,
    ACTIONS(33543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662299] = 2,
    ACTIONS(33545), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662309] = 2,
    ACTIONS(33547), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662319] = 2,
    ACTIONS(33549), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662329] = 2,
    ACTIONS(33551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662339] = 2,
    ACTIONS(33553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662349] = 2,
    ACTIONS(12306), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662359] = 2,
    ACTIONS(33555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662369] = 2,
    ACTIONS(33557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662379] = 2,
    ACTIONS(33559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662389] = 2,
    ACTIONS(33561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662399] = 2,
    ACTIONS(33563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662409] = 2,
    ACTIONS(33565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662419] = 2,
    ACTIONS(33567), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662429] = 2,
    ACTIONS(33569), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662439] = 2,
    ACTIONS(11891), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662449] = 2,
    ACTIONS(33571), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662459] = 2,
    ACTIONS(33573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662469] = 2,
    ACTIONS(33575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662479] = 2,
    ACTIONS(17663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662489] = 2,
    ACTIONS(33577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662499] = 2,
    ACTIONS(33579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662509] = 2,
    ACTIONS(33581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662519] = 2,
    ACTIONS(33583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662529] = 2,
    ACTIONS(1243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662539] = 2,
    ACTIONS(1311), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662549] = 2,
    ACTIONS(33585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662559] = 2,
    ACTIONS(33587), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662569] = 2,
    ACTIONS(14769), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662579] = 2,
    ACTIONS(4579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662589] = 2,
    ACTIONS(33589), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662599] = 2,
    ACTIONS(33591), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662609] = 2,
    ACTIONS(17555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662619] = 2,
    ACTIONS(21664), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662629] = 2,
    ACTIONS(33593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662639] = 2,
    ACTIONS(33595), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662649] = 2,
    ACTIONS(33597), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662659] = 2,
    ACTIONS(33599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662669] = 2,
    ACTIONS(33601), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662679] = 2,
    ACTIONS(33603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662689] = 2,
    ACTIONS(33605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662699] = 2,
    ACTIONS(33607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662709] = 2,
    ACTIONS(33609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662719] = 2,
    ACTIONS(33611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662729] = 2,
    ACTIONS(33613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662739] = 2,
    ACTIONS(33615), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662749] = 2,
    ACTIONS(33617), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662759] = 2,
    ACTIONS(33619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662769] = 2,
    ACTIONS(33621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662779] = 2,
    ACTIONS(17455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662789] = 2,
    ACTIONS(33623), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662799] = 2,
    ACTIONS(33625), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662809] = 2,
    ACTIONS(33627), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662819] = 2,
    ACTIONS(17641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662829] = 2,
    ACTIONS(12280), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662839] = 2,
    ACTIONS(14779), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662849] = 2,
    ACTIONS(33629), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662859] = 2,
    ACTIONS(33631), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662869] = 2,
    ACTIONS(33633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662879] = 2,
    ACTIONS(4859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662889] = 2,
    ACTIONS(5435), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662899] = 2,
    ACTIONS(33635), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662909] = 2,
    ACTIONS(33637), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662919] = 2,
    ACTIONS(33639), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662929] = 2,
    ACTIONS(33641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662939] = 2,
    ACTIONS(33643), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662949] = 2,
    ACTIONS(33645), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662959] = 2,
    ACTIONS(33647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662969] = 2,
    ACTIONS(33649), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662979] = 2,
    ACTIONS(33651), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662989] = 2,
    ACTIONS(33653), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [662999] = 2,
    ACTIONS(14482), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663009] = 2,
    ACTIONS(31309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663019] = 2,
    ACTIONS(33655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663029] = 2,
    ACTIONS(33657), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663039] = 2,
    ACTIONS(33659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663049] = 2,
    ACTIONS(12108), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663059] = 2,
    ACTIONS(33661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663069] = 2,
    ACTIONS(33663), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663079] = 2,
    ACTIONS(33665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663089] = 2,
    ACTIONS(21598), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663099] = 2,
    ACTIONS(33667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663109] = 2,
    ACTIONS(33669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663119] = 2,
    ACTIONS(1291), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663129] = 2,
    ACTIONS(33671), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663139] = 2,
    ACTIONS(33673), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663149] = 2,
    ACTIONS(33675), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663159] = 2,
    ACTIONS(33677), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663169] = 2,
    ACTIONS(33679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663179] = 2,
    ACTIONS(33681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663189] = 2,
    ACTIONS(33683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663199] = 2,
    ACTIONS(33685), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663209] = 2,
    ACTIONS(33687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663219] = 2,
    ACTIONS(33689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663229] = 2,
    ACTIONS(33691), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663239] = 2,
    ACTIONS(33693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663249] = 2,
    ACTIONS(33695), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663259] = 2,
    ACTIONS(33697), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663269] = 2,
    ACTIONS(33699), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663279] = 2,
    ACTIONS(30987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663289] = 2,
    ACTIONS(33701), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663299] = 2,
    ACTIONS(4673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663309] = 2,
    ACTIONS(30427), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663319] = 2,
    ACTIONS(17603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663329] = 2,
    ACTIONS(33703), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663339] = 2,
    ACTIONS(33705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663349] = 2,
    ACTIONS(33707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663359] = 2,
    ACTIONS(22491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663369] = 2,
    ACTIONS(33709), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663379] = 2,
    ACTIONS(33711), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663389] = 2,
    ACTIONS(33713), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663399] = 2,
    ACTIONS(33715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663409] = 2,
    ACTIONS(33717), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663419] = 2,
    ACTIONS(33719), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663429] = 2,
    ACTIONS(33721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663439] = 2,
    ACTIONS(15015), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663449] = 2,
    ACTIONS(33723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663459] = 2,
    ACTIONS(33725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663469] = 2,
    ACTIONS(33727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663479] = 2,
    ACTIONS(33729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663489] = 2,
    ACTIONS(33731), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663499] = 2,
    ACTIONS(33733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663509] = 2,
    ACTIONS(11895), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663519] = 2,
    ACTIONS(31157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663529] = 2,
    ACTIONS(33735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663539] = 2,
    ACTIONS(33737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663549] = 2,
    ACTIONS(33739), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663559] = 2,
    ACTIONS(33741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663569] = 2,
    ACTIONS(33743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663579] = 2,
    ACTIONS(33745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663589] = 2,
    ACTIONS(33747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663599] = 2,
    ACTIONS(33749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663609] = 2,
    ACTIONS(33751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663619] = 2,
    ACTIONS(33753), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663629] = 2,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663639] = 2,
    ACTIONS(33755), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663649] = 2,
    ACTIONS(17563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663659] = 2,
    ACTIONS(33757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663669] = 2,
    ACTIONS(33759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663679] = 2,
    ACTIONS(33761), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663689] = 2,
    ACTIONS(33763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663699] = 2,
    ACTIONS(33765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663709] = 2,
    ACTIONS(33767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663719] = 2,
    ACTIONS(33769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663729] = 2,
    ACTIONS(33771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663739] = 2,
    ACTIONS(33773), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663749] = 2,
    ACTIONS(33775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663759] = 2,
    ACTIONS(22444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663769] = 2,
    ACTIONS(33777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663779] = 2,
    ACTIONS(17677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663789] = 2,
    ACTIONS(33779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663799] = 2,
    ACTIONS(33781), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663809] = 2,
    ACTIONS(33783), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663819] = 2,
    ACTIONS(17503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663829] = 2,
    ACTIONS(33785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663839] = 2,
    ACTIONS(33787), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663849] = 2,
    ACTIONS(33789), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663859] = 2,
    ACTIONS(33791), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663869] = 2,
    ACTIONS(33793), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663879] = 2,
    ACTIONS(33795), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663889] = 2,
    ACTIONS(33797), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663899] = 2,
    ACTIONS(33799), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663909] = 2,
    ACTIONS(33801), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663919] = 2,
    ACTIONS(33803), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663929] = 2,
    ACTIONS(33805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663939] = 2,
    ACTIONS(33807), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663949] = 2,
    ACTIONS(33809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663959] = 2,
    ACTIONS(33811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663969] = 2,
    ACTIONS(33813), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663979] = 2,
    ACTIONS(33815), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663989] = 2,
    ACTIONS(33817), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [663999] = 2,
    ACTIONS(33819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664009] = 2,
    ACTIONS(33821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664019] = 2,
    ACTIONS(33823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664029] = 2,
    ACTIONS(33825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664039] = 2,
    ACTIONS(33827), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664049] = 2,
    ACTIONS(33829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664059] = 2,
    ACTIONS(33831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664069] = 2,
    ACTIONS(33833), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664079] = 2,
    ACTIONS(33835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664089] = 2,
    ACTIONS(5369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664099] = 2,
    ACTIONS(33837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664109] = 2,
    ACTIONS(33839), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664119] = 2,
    ACTIONS(33841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664129] = 2,
    ACTIONS(33843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664139] = 2,
    ACTIONS(33845), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664149] = 2,
    ACTIONS(33847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664159] = 2,
    ACTIONS(33849), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664169] = 2,
    ACTIONS(33851), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664179] = 2,
    ACTIONS(33853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664189] = 2,
    ACTIONS(33855), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664199] = 2,
    ACTIONS(33857), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664209] = 2,
    ACTIONS(33859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664219] = 2,
    ACTIONS(33861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664229] = 2,
    ACTIONS(33863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664239] = 2,
    ACTIONS(14683), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664249] = 2,
    ACTIONS(12239), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664259] = 2,
    ACTIONS(33865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664269] = 2,
    ACTIONS(33867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664279] = 2,
    ACTIONS(33869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664289] = 2,
    ACTIONS(33871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664299] = 2,
    ACTIONS(33873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664309] = 2,
    ACTIONS(17565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664319] = 2,
    ACTIONS(33875), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664329] = 2,
    ACTIONS(33877), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664339] = 2,
    ACTIONS(17601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664349] = 2,
    ACTIONS(33879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664359] = 2,
    ACTIONS(33881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664369] = 2,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664379] = 2,
    ACTIONS(33883), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664389] = 2,
    ACTIONS(4597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664399] = 2,
    ACTIONS(33885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664409] = 2,
    ACTIONS(33887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664419] = 2,
    ACTIONS(30639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664429] = 2,
    ACTIONS(33889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664439] = 2,
    ACTIONS(33891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664449] = 2,
    ACTIONS(33893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664459] = 2,
    ACTIONS(33895), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664469] = 2,
    ACTIONS(33897), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664479] = 2,
    ACTIONS(17461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664489] = 2,
    ACTIONS(33899), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664499] = 2,
    ACTIONS(33901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664509] = 2,
    ACTIONS(33903), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664519] = 2,
    ACTIONS(12116), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664529] = 2,
    ACTIONS(33905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664539] = 2,
    ACTIONS(33907), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664549] = 2,
    ACTIONS(30305), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664559] = 2,
    ACTIONS(33909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664569] = 2,
    ACTIONS(33911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664579] = 2,
    ACTIONS(33913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664589] = 2,
    ACTIONS(33915), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664599] = 2,
    ACTIONS(33917), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664609] = 2,
    ACTIONS(33919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664619] = 2,
    ACTIONS(14783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664629] = 2,
    ACTIONS(33921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664639] = 2,
    ACTIONS(33923), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664649] = 2,
    ACTIONS(33925), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664659] = 2,
    ACTIONS(33927), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664669] = 2,
    ACTIONS(33929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664679] = 2,
    ACTIONS(33931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664689] = 2,
    ACTIONS(33933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664699] = 2,
    ACTIONS(33935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664709] = 2,
    ACTIONS(33937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664719] = 2,
    ACTIONS(33939), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664729] = 2,
    ACTIONS(33941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664739] = 2,
    ACTIONS(33943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664749] = 2,
    ACTIONS(33945), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664759] = 2,
    ACTIONS(33947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664769] = 2,
    ACTIONS(33949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664779] = 2,
    ACTIONS(33951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664789] = 2,
    ACTIONS(33953), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664799] = 2,
    ACTIONS(33955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664809] = 2,
    ACTIONS(33957), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664819] = 2,
    ACTIONS(33959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664829] = 2,
    ACTIONS(30109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664839] = 2,
    ACTIONS(4631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664849] = 2,
    ACTIONS(33961), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664859] = 2,
    ACTIONS(33963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664869] = 2,
    ACTIONS(33965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664879] = 2,
    ACTIONS(33967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664889] = 2,
    ACTIONS(33969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664899] = 2,
    ACTIONS(33971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664909] = 2,
    ACTIONS(33973), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664919] = 2,
    ACTIONS(17577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664929] = 2,
    ACTIONS(33975), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664939] = 2,
    ACTIONS(17467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664949] = 2,
    ACTIONS(17587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664959] = 2,
    ACTIONS(33977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664969] = 2,
    ACTIONS(33979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664979] = 2,
    ACTIONS(33981), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664989] = 2,
    ACTIONS(33983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [664999] = 2,
    ACTIONS(33985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665009] = 2,
    ACTIONS(17619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665019] = 2,
    ACTIONS(33987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665029] = 2,
    ACTIONS(33989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665039] = 2,
    ACTIONS(22120), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665049] = 2,
    ACTIONS(33991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665059] = 2,
    ACTIONS(33993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665069] = 2,
    ACTIONS(22022), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665079] = 2,
    ACTIONS(33995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665089] = 2,
    ACTIONS(33997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665099] = 2,
    ACTIONS(17463), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665109] = 2,
    ACTIONS(33999), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665119] = 2,
    ACTIONS(34001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665129] = 2,
    ACTIONS(34003), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665139] = 2,
    ACTIONS(34005), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665149] = 2,
    ACTIONS(34007), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665159] = 2,
    ACTIONS(34009), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665169] = 2,
    ACTIONS(34011), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665179] = 2,
    ACTIONS(34013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665189] = 2,
    ACTIONS(30251), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665199] = 2,
    ACTIONS(34015), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665209] = 2,
    ACTIONS(34017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665219] = 2,
    ACTIONS(34019), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665229] = 2,
    ACTIONS(34021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665239] = 2,
    ACTIONS(34023), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665249] = 2,
    ACTIONS(34025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665259] = 2,
    ACTIONS(34027), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665269] = 2,
    ACTIONS(14954), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665279] = 2,
    ACTIONS(34029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665289] = 2,
    ACTIONS(34031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665299] = 2,
    ACTIONS(17643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665309] = 2,
    ACTIONS(34033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665319] = 2,
    ACTIONS(34035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665329] = 2,
    ACTIONS(34037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665339] = 2,
    ACTIONS(34039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665349] = 2,
    ACTIONS(34041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665359] = 2,
    ACTIONS(11713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665369] = 2,
    ACTIONS(34043), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665379] = 2,
    ACTIONS(30159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665389] = 2,
    ACTIONS(34045), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665399] = 2,
    ACTIONS(4627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665409] = 2,
    ACTIONS(34047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665419] = 2,
    ACTIONS(34049), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665429] = 2,
    ACTIONS(1229), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665439] = 2,
    ACTIONS(14747), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665449] = 2,
    ACTIONS(34051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665459] = 2,
    ACTIONS(1129), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665469] = 2,
    ACTIONS(34053), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665479] = 2,
    ACTIONS(34055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665489] = 2,
    ACTIONS(34057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665499] = 2,
    ACTIONS(34059), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665509] = 2,
    ACTIONS(34061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665519] = 2,
    ACTIONS(34063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665529] = 2,
    ACTIONS(34065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665539] = 2,
    ACTIONS(5411), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665549] = 2,
    ACTIONS(5077), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665559] = 2,
    ACTIONS(34067), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665569] = 2,
    ACTIONS(34069), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665579] = 2,
    ACTIONS(17613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665589] = 2,
    ACTIONS(34071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665599] = 2,
    ACTIONS(34073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665609] = 2,
    ACTIONS(34075), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665619] = 2,
    ACTIONS(31355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665629] = 2,
    ACTIONS(34077), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665639] = 2,
    ACTIONS(34079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665649] = 2,
    ACTIONS(4437), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665659] = 2,
    ACTIONS(34081), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665669] = 2,
    ACTIONS(21193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665679] = 2,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665689] = 2,
    ACTIONS(17611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665699] = 2,
    ACTIONS(34083), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665709] = 2,
    ACTIONS(34085), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665719] = 2,
    ACTIONS(17791), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665729] = 2,
    ACTIONS(34087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665739] = 2,
    ACTIONS(34089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665749] = 2,
    ACTIONS(34091), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665759] = 2,
    ACTIONS(34093), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665769] = 2,
    ACTIONS(4811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665779] = 2,
    ACTIONS(34095), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665789] = 2,
    ACTIONS(6048), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665799] = 2,
    ACTIONS(34097), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665809] = 2,
    ACTIONS(34099), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665819] = 2,
    ACTIONS(30137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665829] = 2,
    ACTIONS(34101), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665839] = 2,
    ACTIONS(11703), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665849] = 2,
    ACTIONS(14791), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665859] = 2,
    ACTIONS(34103), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665869] = 2,
    ACTIONS(34105), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665879] = 2,
    ACTIONS(34107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665889] = 2,
    ACTIONS(34109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665899] = 2,
    ACTIONS(34111), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665909] = 2,
    ACTIONS(34113), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665919] = 2,
    ACTIONS(12122), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665929] = 2,
    ACTIONS(34115), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665939] = 2,
    ACTIONS(34117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665949] = 2,
    ACTIONS(34119), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665959] = 2,
    ACTIONS(34121), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665969] = 2,
    ACTIONS(34123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665979] = 2,
    ACTIONS(34125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665989] = 2,
    ACTIONS(34127), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [665999] = 2,
    ACTIONS(34129), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666009] = 2,
    ACTIONS(34131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666019] = 2,
    ACTIONS(34133), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666029] = 2,
    ACTIONS(34135), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666039] = 2,
    ACTIONS(34137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666049] = 2,
    ACTIONS(34139), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666059] = 2,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666069] = 2,
    ACTIONS(34141), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666079] = 2,
    ACTIONS(34143), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666089] = 2,
    ACTIONS(34145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666099] = 2,
    ACTIONS(34147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666109] = 2,
    ACTIONS(34149), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666119] = 2,
    ACTIONS(34151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666129] = 2,
    ACTIONS(34153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666139] = 2,
    ACTIONS(34155), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666149] = 2,
    ACTIONS(34157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666159] = 2,
    ACTIONS(34159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666169] = 2,
    ACTIONS(34161), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666179] = 2,
    ACTIONS(34163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666189] = 2,
    ACTIONS(34165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666199] = 2,
    ACTIONS(34167), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666209] = 2,
    ACTIONS(34169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666219] = 2,
    ACTIONS(34171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666229] = 2,
    ACTIONS(34173), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666239] = 2,
    ACTIONS(34175), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666249] = 2,
    ACTIONS(30231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666259] = 2,
    ACTIONS(34177), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666269] = 2,
    ACTIONS(4625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666279] = 2,
    ACTIONS(34179), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666289] = 2,
    ACTIONS(34181), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666299] = 2,
    ACTIONS(34183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666309] = 2,
    ACTIONS(34185), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666319] = 2,
    ACTIONS(34187), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666329] = 2,
    ACTIONS(30175), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666339] = 2,
    ACTIONS(34189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666349] = 2,
    ACTIONS(34191), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666359] = 2,
    ACTIONS(34193), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666369] = 2,
    ACTIONS(34195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666379] = 2,
    ACTIONS(34197), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666389] = 2,
    ACTIONS(34199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666399] = 2,
    ACTIONS(34201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666409] = 2,
    ACTIONS(34203), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666419] = 2,
    ACTIONS(34205), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666429] = 2,
    ACTIONS(34207), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666439] = 2,
    ACTIONS(34209), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666449] = 2,
    ACTIONS(34211), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666459] = 2,
    ACTIONS(34213), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666469] = 2,
    ACTIONS(34215), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666479] = 2,
    ACTIONS(34217), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666489] = 2,
    ACTIONS(34219), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666499] = 2,
    ACTIONS(34221), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666509] = 2,
    ACTIONS(34223), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666519] = 2,
    ACTIONS(34225), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666529] = 2,
    ACTIONS(34227), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666539] = 2,
    ACTIONS(34229), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666549] = 2,
    ACTIONS(34231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666559] = 2,
    ACTIONS(34233), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666569] = 2,
    ACTIONS(17575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666579] = 2,
    ACTIONS(34235), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666589] = 2,
    ACTIONS(34237), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666599] = 2,
    ACTIONS(34239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666609] = 2,
    ACTIONS(34241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666619] = 2,
    ACTIONS(34243), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666629] = 2,
    ACTIONS(34245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666639] = 2,
    ACTIONS(17449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666649] = 2,
    ACTIONS(34247), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666659] = 2,
    ACTIONS(34249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666669] = 2,
    ACTIONS(34251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666679] = 2,
    ACTIONS(34253), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666689] = 2,
    ACTIONS(34255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666699] = 2,
    ACTIONS(34257), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666709] = 2,
    ACTIONS(34259), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666719] = 2,
    ACTIONS(34261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666729] = 2,
    ACTIONS(34263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666739] = 2,
    ACTIONS(34265), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666749] = 2,
    ACTIONS(17549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666759] = 2,
    ACTIONS(34267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666769] = 2,
    ACTIONS(34269), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666779] = 2,
    ACTIONS(34271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666789] = 2,
    ACTIONS(34273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666799] = 2,
    ACTIONS(34275), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666809] = 2,
    ACTIONS(34277), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666819] = 2,
    ACTIONS(34279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666829] = 2,
    ACTIONS(34281), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666839] = 2,
    ACTIONS(34283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666849] = 2,
    ACTIONS(34285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666859] = 2,
    ACTIONS(34287), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666869] = 2,
    ACTIONS(17591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666879] = 2,
    ACTIONS(34289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666889] = 2,
    ACTIONS(34291), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666899] = 2,
    ACTIONS(34293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666909] = 2,
    ACTIONS(34295), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666919] = 2,
    ACTIONS(34297), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666929] = 2,
    ACTIONS(4759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666939] = 2,
    ACTIONS(30923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666949] = 2,
    ACTIONS(34299), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666959] = 2,
    ACTIONS(4443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666969] = 2,
    ACTIONS(17691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666979] = 2,
    ACTIONS(34301), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666989] = 2,
    ACTIONS(34303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [666999] = 2,
    ACTIONS(34305), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667009] = 2,
    ACTIONS(34307), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667019] = 2,
    ACTIONS(34309), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667029] = 2,
    ACTIONS(34311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667039] = 2,
    ACTIONS(34313), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667049] = 2,
    ACTIONS(34315), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667059] = 2,
    ACTIONS(34317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667069] = 2,
    ACTIONS(34319), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667079] = 2,
    ACTIONS(34321), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667089] = 2,
    ACTIONS(34323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667099] = 2,
    ACTIONS(34325), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667109] = 2,
    ACTIONS(34327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667119] = 2,
    ACTIONS(34329), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667129] = 2,
    ACTIONS(34331), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667139] = 2,
    ACTIONS(30393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667149] = 2,
    ACTIONS(4613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667159] = 2,
    ACTIONS(34333), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667169] = 2,
    ACTIONS(14922), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667179] = 2,
    ACTIONS(34335), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667189] = 2,
    ACTIONS(34337), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667199] = 2,
    ACTIONS(34339), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667209] = 2,
    ACTIONS(12094), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667219] = 2,
    ACTIONS(34341), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667229] = 2,
    ACTIONS(34343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667239] = 2,
    ACTIONS(34345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667249] = 2,
    ACTIONS(34347), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667259] = 2,
    ACTIONS(30549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667269] = 2,
    ACTIONS(1203), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667279] = 2,
    ACTIONS(34349), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667289] = 2,
    ACTIONS(34351), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667299] = 2,
    ACTIONS(34353), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667309] = 2,
    ACTIONS(34355), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667319] = 2,
    ACTIONS(21269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667329] = 2,
    ACTIONS(34357), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667339] = 2,
    ACTIONS(34359), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667349] = 2,
    ACTIONS(12128), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667359] = 2,
    ACTIONS(14845), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667369] = 2,
    ACTIONS(34361), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667379] = 2,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667389] = 2,
    ACTIONS(34363), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667399] = 2,
    ACTIONS(34365), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667409] = 2,
    ACTIONS(34367), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667419] = 2,
    ACTIONS(34369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667429] = 2,
    ACTIONS(34371), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667439] = 2,
    ACTIONS(34373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667449] = 2,
    ACTIONS(34375), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667459] = 2,
    ACTIONS(34377), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667469] = 2,
    ACTIONS(34379), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667479] = 2,
    ACTIONS(34381), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667489] = 2,
    ACTIONS(34383), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667499] = 2,
    ACTIONS(34385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667509] = 2,
    ACTIONS(34387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667519] = 2,
    ACTIONS(34389), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667529] = 2,
    ACTIONS(5447), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667539] = 2,
    ACTIONS(34391), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667549] = 2,
    ACTIONS(34393), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667559] = 2,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667569] = 2,
    ACTIONS(5067), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667579] = 2,
    ACTIONS(34395), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667589] = 2,
    ACTIONS(34397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667599] = 2,
    ACTIONS(34399), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667609] = 2,
    ACTIONS(34401), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667619] = 2,
    ACTIONS(34403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667629] = 2,
    ACTIONS(34405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667639] = 2,
    ACTIONS(34407), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667649] = 2,
    ACTIONS(34409), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667659] = 2,
    ACTIONS(34411), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667669] = 2,
    ACTIONS(34413), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667679] = 2,
    ACTIONS(34415), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667689] = 2,
    ACTIONS(34417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667699] = 2,
    ACTIONS(34419), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667709] = 2,
    ACTIONS(34421), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667719] = 2,
    ACTIONS(17569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667729] = 2,
    ACTIONS(34423), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667739] = 2,
    ACTIONS(34425), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667749] = 2,
    ACTIONS(34427), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667759] = 2,
    ACTIONS(34429), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667769] = 2,
    ACTIONS(17761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667779] = 2,
    ACTIONS(34431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667789] = 2,
    ACTIONS(34433), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667799] = 2,
    ACTIONS(34435), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667809] = 2,
    ACTIONS(34437), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667819] = 2,
    ACTIONS(34439), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667829] = 2,
    ACTIONS(5924), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667839] = 2,
    ACTIONS(1251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667849] = 2,
    ACTIONS(34441), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667859] = 2,
    ACTIONS(34443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667869] = 2,
    ACTIONS(34445), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667879] = 2,
    ACTIONS(34447), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667889] = 2,
    ACTIONS(34449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667899] = 2,
    ACTIONS(4757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667909] = 2,
    ACTIONS(34451), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667919] = 2,
    ACTIONS(34453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667929] = 2,
    ACTIONS(34455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667939] = 2,
    ACTIONS(34457), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667949] = 2,
    ACTIONS(34459), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667959] = 2,
    ACTIONS(34461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667969] = 2,
    ACTIONS(34463), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667979] = 2,
    ACTIONS(15033), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667989] = 2,
    ACTIONS(12312), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [667999] = 2,
    ACTIONS(34465), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668009] = 2,
    ACTIONS(34467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668019] = 2,
    ACTIONS(34469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668029] = 2,
    ACTIONS(34471), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668039] = 2,
    ACTIONS(3577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668049] = 2,
    ACTIONS(34473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668059] = 2,
    ACTIONS(34475), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668069] = 2,
    ACTIONS(4479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668079] = 2,
    ACTIONS(1181), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668089] = 2,
    ACTIONS(34477), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668099] = 2,
    ACTIONS(34479), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668109] = 2,
    ACTIONS(34481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668119] = 2,
    ACTIONS(34483), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668129] = 2,
    ACTIONS(34485), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668139] = 2,
    ACTIONS(17497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668149] = 2,
    ACTIONS(34487), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668159] = 2,
    ACTIONS(34489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668169] = 2,
    ACTIONS(34491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668179] = 2,
    ACTIONS(34493), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668189] = 2,
    ACTIONS(34495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668199] = 2,
    ACTIONS(34497), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668209] = 2,
    ACTIONS(34499), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668219] = 2,
    ACTIONS(34501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668229] = 2,
    ACTIONS(34503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668239] = 2,
    ACTIONS(34505), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668249] = 2,
    ACTIONS(34507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668259] = 2,
    ACTIONS(34509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668269] = 2,
    ACTIONS(34511), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668279] = 2,
    ACTIONS(34513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668289] = 2,
    ACTIONS(34515), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668299] = 2,
    ACTIONS(34517), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668309] = 2,
    ACTIONS(34519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668319] = 2,
    ACTIONS(34521), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668329] = 2,
    ACTIONS(34523), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668339] = 2,
    ACTIONS(34525), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668349] = 2,
    ACTIONS(34527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668359] = 2,
    ACTIONS(34529), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668369] = 2,
    ACTIONS(34531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668379] = 2,
    ACTIONS(30105), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668389] = 2,
    ACTIONS(34533), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668399] = 2,
    ACTIONS(4669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668409] = 2,
    ACTIONS(34535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668419] = 2,
    ACTIONS(34537), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668429] = 2,
    ACTIONS(34539), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668439] = 2,
    ACTIONS(34541), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668449] = 2,
    ACTIONS(34543), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668459] = 2,
    ACTIONS(34545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668469] = 2,
    ACTIONS(34547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668479] = 2,
    ACTIONS(34549), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668489] = 2,
    ACTIONS(34551), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668499] = 2,
    ACTIONS(34553), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668509] = 2,
    ACTIONS(34555), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668519] = 2,
    ACTIONS(34557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668529] = 2,
    ACTIONS(17605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668539] = 2,
    ACTIONS(34559), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668549] = 2,
    ACTIONS(34561), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668559] = 2,
    ACTIONS(4595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668569] = 2,
    ACTIONS(34563), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668579] = 2,
    ACTIONS(34565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668589] = 2,
    ACTIONS(34567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668599] = 2,
    ACTIONS(34569), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668609] = 2,
    ACTIONS(34571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668619] = 2,
    ACTIONS(34573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668629] = 2,
    ACTIONS(34575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668639] = 2,
    ACTIONS(34577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668649] = 2,
    ACTIONS(30083), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668659] = 2,
    ACTIONS(12096), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668669] = 2,
    ACTIONS(34579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668679] = 2,
    ACTIONS(34581), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668689] = 2,
    ACTIONS(34583), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668699] = 2,
    ACTIONS(34585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668709] = 2,
    ACTIONS(34587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668719] = 2,
    ACTIONS(14699), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668729] = 2,
    ACTIONS(34589), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668739] = 2,
    ACTIONS(34591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668749] = 2,
    ACTIONS(34593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668759] = 2,
    ACTIONS(34595), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668769] = 2,
    ACTIONS(34597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668779] = 2,
    ACTIONS(34599), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668789] = 2,
    ACTIONS(30065), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668799] = 2,
    ACTIONS(34601), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668809] = 2,
    ACTIONS(34603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668819] = 2,
    ACTIONS(34605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668829] = 2,
    ACTIONS(34607), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668839] = 2,
    ACTIONS(34609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668849] = 2,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668859] = 2,
    ACTIONS(34611), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668869] = 2,
    ACTIONS(34613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668879] = 2,
    ACTIONS(34615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668889] = 2,
    ACTIONS(34617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668899] = 2,
    ACTIONS(30057), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668909] = 2,
    ACTIONS(34619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668919] = 2,
    ACTIONS(34621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668929] = 2,
    ACTIONS(34623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668939] = 2,
    ACTIONS(34625), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668949] = 2,
    ACTIONS(34627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668959] = 2,
    ACTIONS(34629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668969] = 2,
    ACTIONS(34631), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668979] = 2,
    ACTIONS(30047), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668989] = 2,
    ACTIONS(34633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [668999] = 2,
    ACTIONS(34635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669009] = 2,
    ACTIONS(34637), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669019] = 2,
    ACTIONS(17465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669029] = 2,
    ACTIONS(4857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669039] = 2,
    ACTIONS(34639), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669049] = 2,
    ACTIONS(30041), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669059] = 2,
    ACTIONS(34641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669069] = 2,
    ACTIONS(34643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669079] = 2,
    ACTIONS(34645), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669089] = 2,
    ACTIONS(34647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669099] = 2,
    ACTIONS(34649), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669109] = 2,
    ACTIONS(30033), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669119] = 2,
    ACTIONS(34651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669129] = 2,
    ACTIONS(34653), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669139] = 2,
    ACTIONS(34655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669149] = 2,
    ACTIONS(34657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669159] = 2,
    ACTIONS(30027), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669169] = 2,
    ACTIONS(14869), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669179] = 2,
    ACTIONS(34659), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669189] = 2,
    ACTIONS(34661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669199] = 2,
    ACTIONS(34663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669209] = 2,
    ACTIONS(30021), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669219] = 2,
    ACTIONS(12377), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669229] = 2,
    ACTIONS(34665), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669239] = 2,
    ACTIONS(34667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669249] = 2,
    ACTIONS(34669), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669259] = 2,
    ACTIONS(30011), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669269] = 2,
    ACTIONS(34671), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669279] = 2,
    ACTIONS(34673), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669289] = 2,
    ACTIONS(34675), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669299] = 2,
    ACTIONS(34677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669309] = 2,
    ACTIONS(30003), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669319] = 2,
    ACTIONS(14857), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669329] = 2,
    ACTIONS(34679), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669339] = 2,
    ACTIONS(34681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669349] = 2,
    ACTIONS(34683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669359] = 2,
    ACTIONS(29997), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669369] = 2,
    ACTIONS(17593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669379] = 2,
    ACTIONS(34685), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669389] = 2,
    ACTIONS(34687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669399] = 2,
    ACTIONS(34689), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669409] = 2,
    ACTIONS(29989), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669419] = 2,
    ACTIONS(34691), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669429] = 2,
    ACTIONS(34693), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669439] = 2,
    ACTIONS(34695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669449] = 2,
    ACTIONS(34697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669459] = 2,
    ACTIONS(29983), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669469] = 2,
    ACTIONS(12296), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669479] = 2,
    ACTIONS(34699), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669489] = 2,
    ACTIONS(34701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669499] = 2,
    ACTIONS(34703), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669509] = 2,
    ACTIONS(29977), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669519] = 2,
    ACTIONS(34705), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669529] = 2,
    ACTIONS(34707), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669539] = 2,
    ACTIONS(34709), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669549] = 2,
    ACTIONS(14470), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669559] = 2,
    ACTIONS(29967), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669569] = 2,
    ACTIONS(34711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669579] = 2,
    ACTIONS(34713), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669589] = 2,
    ACTIONS(12300), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669599] = 2,
    ACTIONS(5930), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669609] = 2,
    ACTIONS(29957), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669619] = 2,
    ACTIONS(34715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669629] = 2,
    ACTIONS(34717), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669639] = 2,
    ACTIONS(17617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669649] = 2,
    ACTIONS(34719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669659] = 2,
    ACTIONS(29947), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669669] = 2,
    ACTIONS(34721), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669679] = 2,
    ACTIONS(34723), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669689] = 2,
    ACTIONS(34725), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669699] = 2,
    ACTIONS(34727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669709] = 2,
    ACTIONS(29941), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669719] = 2,
    ACTIONS(34729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669729] = 2,
    ACTIONS(34731), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669739] = 2,
    ACTIONS(34733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669749] = 2,
    ACTIONS(34735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669759] = 2,
    ACTIONS(29933), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669769] = 2,
    ACTIONS(34737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669779] = 2,
    ACTIONS(34739), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669789] = 2,
    ACTIONS(34741), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669799] = 2,
    ACTIONS(34743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669809] = 2,
    ACTIONS(29923), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669819] = 2,
    ACTIONS(34745), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669829] = 2,
    ACTIONS(34747), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669839] = 2,
    ACTIONS(34749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669849] = 2,
    ACTIONS(34751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669859] = 2,
    ACTIONS(29917), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669869] = 2,
    ACTIONS(34753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669879] = 2,
    ACTIONS(34755), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669889] = 2,
    ACTIONS(34757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669899] = 2,
    ACTIONS(34759), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669909] = 2,
    ACTIONS(29909), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669919] = 2,
    ACTIONS(20811), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669929] = 2,
    ACTIONS(34761), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669939] = 2,
    ACTIONS(34763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669949] = 2,
    ACTIONS(29907), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669959] = 2,
    ACTIONS(29801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669969] = 2,
    ACTIONS(34765), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669979] = 2,
    ACTIONS(29903), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669989] = 2,
    ACTIONS(4633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [669999] = 2,
    ACTIONS(34767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670009] = 2,
    ACTIONS(29901), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670019] = 2,
    ACTIONS(17459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670029] = 2,
    ACTIONS(22278), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670039] = 2,
    ACTIONS(29899), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670049] = 2,
    ACTIONS(34769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670059] = 2,
    ACTIONS(34771), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670069] = 2,
    ACTIONS(29897), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670079] = 2,
    ACTIONS(34773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670089] = 2,
    ACTIONS(1273), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670099] = 2,
    ACTIONS(29891), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670109] = 2,
    ACTIONS(34775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670119] = 2,
    ACTIONS(34777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670129] = 2,
    ACTIONS(29883), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670139] = 2,
    ACTIONS(34779), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670149] = 2,
    ACTIONS(34781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670159] = 2,
    ACTIONS(29879), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670169] = 2,
    ACTIONS(34783), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670179] = 2,
    ACTIONS(34785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670189] = 2,
    ACTIONS(29877), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670199] = 2,
    ACTIONS(34787), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670209] = 2,
    ACTIONS(34789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670219] = 2,
    ACTIONS(29875), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670229] = 2,
    ACTIONS(34791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670239] = 2,
    ACTIONS(34793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670249] = 2,
    ACTIONS(29873), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670259] = 2,
    ACTIONS(1169), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670269] = 2,
    ACTIONS(34795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670279] = 2,
    ACTIONS(29869), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670289] = 2,
    ACTIONS(30689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670299] = 2,
    ACTIONS(4533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670309] = 2,
    ACTIONS(29863), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670319] = 2,
    ACTIONS(34797), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670329] = 2,
    ACTIONS(34799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670339] = 2,
    ACTIONS(29861), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670349] = 2,
    ACTIONS(34801), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670359] = 2,
    ACTIONS(34803), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670369] = 2,
    ACTIONS(29859), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670379] = 2,
    ACTIONS(34805), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670389] = 2,
    ACTIONS(34807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670399] = 2,
    ACTIONS(29855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670409] = 2,
    ACTIONS(34809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670419] = 2,
    ACTIONS(34811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670429] = 2,
    ACTIONS(29851), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670439] = 2,
    ACTIONS(34813), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670449] = 2,
    ACTIONS(34815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670459] = 2,
    ACTIONS(29849), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670469] = 2,
    ACTIONS(34817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670479] = 2,
    ACTIONS(34819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670489] = 2,
    ACTIONS(29847), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670499] = 2,
    ACTIONS(34821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670509] = 2,
    ACTIONS(34823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670519] = 2,
    ACTIONS(29845), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670529] = 2,
    ACTIONS(34825), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670539] = 2,
    ACTIONS(34827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670549] = 2,
    ACTIONS(29843), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670559] = 2,
    ACTIONS(34829), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670569] = 2,
    ACTIONS(34831), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670579] = 2,
    ACTIONS(29839), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670589] = 2,
    ACTIONS(24552), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670599] = 2,
    ACTIONS(34833), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670609] = 2,
    ACTIONS(29837), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670619] = 2,
    ACTIONS(34835), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670629] = 2,
    ACTIONS(34837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670639] = 2,
    ACTIONS(34839), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670649] = 2,
    ACTIONS(17609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670659] = 2,
    ACTIONS(34841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670669] = 2,
    ACTIONS(22591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670679] = 2,
    ACTIONS(34843), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670689] = 2,
    ACTIONS(34845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670699] = 2,
    ACTIONS(34847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670709] = 2,
    ACTIONS(34849), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670719] = 2,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670729] = 2,
    ACTIONS(34851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670739] = 2,
    ACTIONS(34853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670749] = 2,
    ACTIONS(34855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670759] = 2,
    ACTIONS(34857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670769] = 2,
    ACTIONS(34859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670779] = 2,
    ACTIONS(34861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670789] = 2,
    ACTIONS(34863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670799] = 2,
    ACTIONS(34865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670809] = 2,
    ACTIONS(17595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670819] = 2,
    ACTIONS(34867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670829] = 2,
    ACTIONS(34869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670839] = 2,
    ACTIONS(34871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670849] = 2,
    ACTIONS(34873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670859] = 2,
    ACTIONS(34875), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670869] = 2,
    ACTIONS(34877), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670879] = 2,
    ACTIONS(34879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670889] = 2,
    ACTIONS(34881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670899] = 2,
    ACTIONS(34883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670909] = 2,
    ACTIONS(34885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670919] = 2,
    ACTIONS(34887), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670929] = 2,
    ACTIONS(34889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670939] = 2,
    ACTIONS(4439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670949] = 2,
    ACTIONS(34891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670959] = 2,
    ACTIONS(34893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670969] = 2,
    ACTIONS(17561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670979] = 2,
    ACTIONS(34895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670989] = 2,
    ACTIONS(34897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [670999] = 2,
    ACTIONS(34899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671009] = 2,
    ACTIONS(30815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671019] = 2,
    ACTIONS(34901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671029] = 2,
    ACTIONS(34903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671039] = 2,
    ACTIONS(34905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671049] = 2,
    ACTIONS(34907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671059] = 2,
    ACTIONS(34909), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [671069] = 2,
    ACTIONS(34911), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2760)] = 0,
  [SMALL_STATE(2761)] = 113,
  [SMALL_STATE(2762)] = 244,
  [SMALL_STATE(2763)] = 357,
  [SMALL_STATE(2764)] = 482,
  [SMALL_STATE(2765)] = 595,
  [SMALL_STATE(2766)] = 728,
  [SMALL_STATE(2767)] = 841,
  [SMALL_STATE(2768)] = 974,
  [SMALL_STATE(2769)] = 1107,
  [SMALL_STATE(2770)] = 1240,
  [SMALL_STATE(2771)] = 1351,
  [SMALL_STATE(2772)] = 1482,
  [SMALL_STATE(2773)] = 1595,
  [SMALL_STATE(2774)] = 1726,
  [SMALL_STATE(2775)] = 1859,
  [SMALL_STATE(2776)] = 1992,
  [SMALL_STATE(2777)] = 2123,
  [SMALL_STATE(2778)] = 2236,
  [SMALL_STATE(2779)] = 2349,
  [SMALL_STATE(2780)] = 2480,
  [SMALL_STATE(2781)] = 2591,
  [SMALL_STATE(2782)] = 2716,
  [SMALL_STATE(2783)] = 2829,
  [SMALL_STATE(2784)] = 2962,
  [SMALL_STATE(2785)] = 3095,
  [SMALL_STATE(2786)] = 3228,
  [SMALL_STATE(2787)] = 3359,
  [SMALL_STATE(2788)] = 3492,
  [SMALL_STATE(2789)] = 3603,
  [SMALL_STATE(2790)] = 3714,
  [SMALL_STATE(2791)] = 3834,
  [SMALL_STATE(2792)] = 3958,
  [SMALL_STATE(2793)] = 4086,
  [SMALL_STATE(2794)] = 4214,
  [SMALL_STATE(2795)] = 4342,
  [SMALL_STATE(2796)] = 4462,
  [SMALL_STATE(2797)] = 4574,
  [SMALL_STATE(2798)] = 4701,
  [SMALL_STATE(2799)] = 4828,
  [SMALL_STATE(2800)] = 4955,
  [SMALL_STATE(2801)] = 5082,
  [SMALL_STATE(2802)] = 5203,
  [SMALL_STATE(2803)] = 5330,
  [SMALL_STATE(2804)] = 5459,
  [SMALL_STATE(2805)] = 5578,
  [SMALL_STATE(2806)] = 5705,
  [SMALL_STATE(2807)] = 5832,
  [SMALL_STATE(2808)] = 5959,
  [SMALL_STATE(2809)] = 6086,
  [SMALL_STATE(2810)] = 6213,
  [SMALL_STATE(2811)] = 6340,
  [SMALL_STATE(2812)] = 6467,
  [SMALL_STATE(2813)] = 6594,
  [SMALL_STATE(2814)] = 6721,
  [SMALL_STATE(2815)] = 6848,
  [SMALL_STATE(2816)] = 6971,
  [SMALL_STATE(2817)] = 7098,
  [SMALL_STATE(2818)] = 7225,
  [SMALL_STATE(2819)] = 7356,
  [SMALL_STATE(2820)] = 7479,
  [SMALL_STATE(2821)] = 7606,
  [SMALL_STATE(2822)] = 7735,
  [SMALL_STATE(2823)] = 7862,
  [SMALL_STATE(2824)] = 7989,
  [SMALL_STATE(2825)] = 8116,
  [SMALL_STATE(2826)] = 8243,
  [SMALL_STATE(2827)] = 8364,
  [SMALL_STATE(2828)] = 8491,
  [SMALL_STATE(2829)] = 8618,
  [SMALL_STATE(2830)] = 8745,
  [SMALL_STATE(2831)] = 8872,
  [SMALL_STATE(2832)] = 8999,
  [SMALL_STATE(2833)] = 9128,
  [SMALL_STATE(2834)] = 9255,
  [SMALL_STATE(2835)] = 9382,
  [SMALL_STATE(2836)] = 9509,
  [SMALL_STATE(2837)] = 9636,
  [SMALL_STATE(2838)] = 9763,
  [SMALL_STATE(2839)] = 9890,
  [SMALL_STATE(2840)] = 10017,
  [SMALL_STATE(2841)] = 10144,
  [SMALL_STATE(2842)] = 10271,
  [SMALL_STATE(2843)] = 10390,
  [SMALL_STATE(2844)] = 10517,
  [SMALL_STATE(2845)] = 10644,
  [SMALL_STATE(2846)] = 10771,
  [SMALL_STATE(2847)] = 10898,
  [SMALL_STATE(2848)] = 11025,
  [SMALL_STATE(2849)] = 11152,
  [SMALL_STATE(2850)] = 11281,
  [SMALL_STATE(2851)] = 11400,
  [SMALL_STATE(2852)] = 11527,
  [SMALL_STATE(2853)] = 11654,
  [SMALL_STATE(2854)] = 11781,
  [SMALL_STATE(2855)] = 11908,
  [SMALL_STATE(2856)] = 12035,
  [SMALL_STATE(2857)] = 12162,
  [SMALL_STATE(2858)] = 12283,
  [SMALL_STATE(2859)] = 12410,
  [SMALL_STATE(2860)] = 12537,
  [SMALL_STATE(2861)] = 12656,
  [SMALL_STATE(2862)] = 12783,
  [SMALL_STATE(2863)] = 12910,
  [SMALL_STATE(2864)] = 13037,
  [SMALL_STATE(2865)] = 13164,
  [SMALL_STATE(2866)] = 13291,
  [SMALL_STATE(2867)] = 13418,
  [SMALL_STATE(2868)] = 13545,
  [SMALL_STATE(2869)] = 13672,
  [SMALL_STATE(2870)] = 13799,
  [SMALL_STATE(2871)] = 13918,
  [SMALL_STATE(2872)] = 14045,
  [SMALL_STATE(2873)] = 14154,
  [SMALL_STATE(2874)] = 14275,
  [SMALL_STATE(2875)] = 14402,
  [SMALL_STATE(2876)] = 14523,
  [SMALL_STATE(2877)] = 14634,
  [SMALL_STATE(2878)] = 14757,
  [SMALL_STATE(2879)] = 14884,
  [SMALL_STATE(2880)] = 15011,
  [SMALL_STATE(2881)] = 15132,
  [SMALL_STATE(2882)] = 15259,
  [SMALL_STATE(2883)] = 15386,
  [SMALL_STATE(2884)] = 15505,
  [SMALL_STATE(2885)] = 15632,
  [SMALL_STATE(2886)] = 15759,
  [SMALL_STATE(2887)] = 15880,
  [SMALL_STATE(2888)] = 16007,
  [SMALL_STATE(2889)] = 16126,
  [SMALL_STATE(2890)] = 16253,
  [SMALL_STATE(2891)] = 16380,
  [SMALL_STATE(2892)] = 16507,
  [SMALL_STATE(2893)] = 16634,
  [SMALL_STATE(2894)] = 16761,
  [SMALL_STATE(2895)] = 16882,
  [SMALL_STATE(2896)] = 17009,
  [SMALL_STATE(2897)] = 17136,
  [SMALL_STATE(2898)] = 17263,
  [SMALL_STATE(2899)] = 17390,
  [SMALL_STATE(2900)] = 17517,
  [SMALL_STATE(2901)] = 17638,
  [SMALL_STATE(2902)] = 17765,
  [SMALL_STATE(2903)] = 17892,
  [SMALL_STATE(2904)] = 18019,
  [SMALL_STATE(2905)] = 18146,
  [SMALL_STATE(2906)] = 18275,
  [SMALL_STATE(2907)] = 18402,
  [SMALL_STATE(2908)] = 18529,
  [SMALL_STATE(2909)] = 18650,
  [SMALL_STATE(2910)] = 18777,
  [SMALL_STATE(2911)] = 18904,
  [SMALL_STATE(2912)] = 19031,
  [SMALL_STATE(2913)] = 19162,
  [SMALL_STATE(2914)] = 19285,
  [SMALL_STATE(2915)] = 19412,
  [SMALL_STATE(2916)] = 19539,
  [SMALL_STATE(2917)] = 19660,
  [SMALL_STATE(2918)] = 19787,
  [SMALL_STATE(2919)] = 19914,
  [SMALL_STATE(2920)] = 20041,
  [SMALL_STATE(2921)] = 20168,
  [SMALL_STATE(2922)] = 20295,
  [SMALL_STATE(2923)] = 20404,
  [SMALL_STATE(2924)] = 20527,
  [SMALL_STATE(2925)] = 20654,
  [SMALL_STATE(2926)] = 20781,
  [SMALL_STATE(2927)] = 20902,
  [SMALL_STATE(2928)] = 21029,
  [SMALL_STATE(2929)] = 21148,
  [SMALL_STATE(2930)] = 21275,
  [SMALL_STATE(2931)] = 21402,
  [SMALL_STATE(2932)] = 21531,
  [SMALL_STATE(2933)] = 21658,
  [SMALL_STATE(2934)] = 21785,
  [SMALL_STATE(2935)] = 21912,
  [SMALL_STATE(2936)] = 22039,
  [SMALL_STATE(2937)] = 22163,
  [SMALL_STATE(2938)] = 22287,
  [SMALL_STATE(2939)] = 22411,
  [SMALL_STATE(2940)] = 22535,
  [SMALL_STATE(2941)] = 22659,
  [SMALL_STATE(2942)] = 22783,
  [SMALL_STATE(2943)] = 22907,
  [SMALL_STATE(2944)] = 23031,
  [SMALL_STATE(2945)] = 23155,
  [SMALL_STATE(2946)] = 23279,
  [SMALL_STATE(2947)] = 23403,
  [SMALL_STATE(2948)] = 23527,
  [SMALL_STATE(2949)] = 23651,
  [SMALL_STATE(2950)] = 23775,
  [SMALL_STATE(2951)] = 23899,
  [SMALL_STATE(2952)] = 24023,
  [SMALL_STATE(2953)] = 24147,
  [SMALL_STATE(2954)] = 24271,
  [SMALL_STATE(2955)] = 24395,
  [SMALL_STATE(2956)] = 24519,
  [SMALL_STATE(2957)] = 24643,
  [SMALL_STATE(2958)] = 24767,
  [SMALL_STATE(2959)] = 24891,
  [SMALL_STATE(2960)] = 25015,
  [SMALL_STATE(2961)] = 25139,
  [SMALL_STATE(2962)] = 25265,
  [SMALL_STATE(2963)] = 25389,
  [SMALL_STATE(2964)] = 25513,
  [SMALL_STATE(2965)] = 25623,
  [SMALL_STATE(2966)] = 25747,
  [SMALL_STATE(2967)] = 25857,
  [SMALL_STATE(2968)] = 25967,
  [SMALL_STATE(2969)] = 26091,
  [SMALL_STATE(2970)] = 26215,
  [SMALL_STATE(2971)] = 26339,
  [SMALL_STATE(2972)] = 26463,
  [SMALL_STATE(2973)] = 26573,
  [SMALL_STATE(2974)] = 26697,
  [SMALL_STATE(2975)] = 26821,
  [SMALL_STATE(2976)] = 26945,
  [SMALL_STATE(2977)] = 27069,
  [SMALL_STATE(2978)] = 27193,
  [SMALL_STATE(2979)] = 27317,
  [SMALL_STATE(2980)] = 27441,
  [SMALL_STATE(2981)] = 27565,
  [SMALL_STATE(2982)] = 27689,
  [SMALL_STATE(2983)] = 27813,
  [SMALL_STATE(2984)] = 27937,
  [SMALL_STATE(2985)] = 28061,
  [SMALL_STATE(2986)] = 28185,
  [SMALL_STATE(2987)] = 28309,
  [SMALL_STATE(2988)] = 28433,
  [SMALL_STATE(2989)] = 28557,
  [SMALL_STATE(2990)] = 28681,
  [SMALL_STATE(2991)] = 28805,
  [SMALL_STATE(2992)] = 28929,
  [SMALL_STATE(2993)] = 29037,
  [SMALL_STATE(2994)] = 29161,
  [SMALL_STATE(2995)] = 29285,
  [SMALL_STATE(2996)] = 29409,
  [SMALL_STATE(2997)] = 29533,
  [SMALL_STATE(2998)] = 29659,
  [SMALL_STATE(2999)] = 29767,
  [SMALL_STATE(3000)] = 29891,
  [SMALL_STATE(3001)] = 30015,
  [SMALL_STATE(3002)] = 30139,
  [SMALL_STATE(3003)] = 30265,
  [SMALL_STATE(3004)] = 30389,
  [SMALL_STATE(3005)] = 30513,
  [SMALL_STATE(3006)] = 30631,
  [SMALL_STATE(3007)] = 30755,
  [SMALL_STATE(3008)] = 30879,
  [SMALL_STATE(3009)] = 31003,
  [SMALL_STATE(3010)] = 31121,
  [SMALL_STATE(3011)] = 31243,
  [SMALL_STATE(3012)] = 31367,
  [SMALL_STATE(3013)] = 31491,
  [SMALL_STATE(3014)] = 31615,
  [SMALL_STATE(3015)] = 31739,
  [SMALL_STATE(3016)] = 31863,
  [SMALL_STATE(3017)] = 31989,
  [SMALL_STATE(3018)] = 32113,
  [SMALL_STATE(3019)] = 32237,
  [SMALL_STATE(3020)] = 32361,
  [SMALL_STATE(3021)] = 32485,
  [SMALL_STATE(3022)] = 32609,
  [SMALL_STATE(3023)] = 32733,
  [SMALL_STATE(3024)] = 32857,
  [SMALL_STATE(3025)] = 32981,
  [SMALL_STATE(3026)] = 33105,
  [SMALL_STATE(3027)] = 33229,
  [SMALL_STATE(3028)] = 33353,
  [SMALL_STATE(3029)] = 33477,
  [SMALL_STATE(3030)] = 33601,
  [SMALL_STATE(3031)] = 33725,
  [SMALL_STATE(3032)] = 33849,
  [SMALL_STATE(3033)] = 33973,
  [SMALL_STATE(3034)] = 34097,
  [SMALL_STATE(3035)] = 34221,
  [SMALL_STATE(3036)] = 34345,
  [SMALL_STATE(3037)] = 34453,
  [SMALL_STATE(3038)] = 34577,
  [SMALL_STATE(3039)] = 34701,
  [SMALL_STATE(3040)] = 34825,
  [SMALL_STATE(3041)] = 34949,
  [SMALL_STATE(3042)] = 35073,
  [SMALL_STATE(3043)] = 35197,
  [SMALL_STATE(3044)] = 35321,
  [SMALL_STATE(3045)] = 35447,
  [SMALL_STATE(3046)] = 35571,
  [SMALL_STATE(3047)] = 35695,
  [SMALL_STATE(3048)] = 35819,
  [SMALL_STATE(3049)] = 35943,
  [SMALL_STATE(3050)] = 36067,
  [SMALL_STATE(3051)] = 36191,
  [SMALL_STATE(3052)] = 36315,
  [SMALL_STATE(3053)] = 36439,
  [SMALL_STATE(3054)] = 36561,
  [SMALL_STATE(3055)] = 36685,
  [SMALL_STATE(3056)] = 36809,
  [SMALL_STATE(3057)] = 36933,
  [SMALL_STATE(3058)] = 37057,
  [SMALL_STATE(3059)] = 37181,
  [SMALL_STATE(3060)] = 37305,
  [SMALL_STATE(3061)] = 37429,
  [SMALL_STATE(3062)] = 37553,
  [SMALL_STATE(3063)] = 37679,
  [SMALL_STATE(3064)] = 37803,
  [SMALL_STATE(3065)] = 37927,
  [SMALL_STATE(3066)] = 38051,
  [SMALL_STATE(3067)] = 38175,
  [SMALL_STATE(3068)] = 38299,
  [SMALL_STATE(3069)] = 38423,
  [SMALL_STATE(3070)] = 38547,
  [SMALL_STATE(3071)] = 38671,
  [SMALL_STATE(3072)] = 38795,
  [SMALL_STATE(3073)] = 38919,
  [SMALL_STATE(3074)] = 39043,
  [SMALL_STATE(3075)] = 39167,
  [SMALL_STATE(3076)] = 39291,
  [SMALL_STATE(3077)] = 39415,
  [SMALL_STATE(3078)] = 39539,
  [SMALL_STATE(3079)] = 39663,
  [SMALL_STATE(3080)] = 39787,
  [SMALL_STATE(3081)] = 39911,
  [SMALL_STATE(3082)] = 40035,
  [SMALL_STATE(3083)] = 40159,
  [SMALL_STATE(3084)] = 40283,
  [SMALL_STATE(3085)] = 40407,
  [SMALL_STATE(3086)] = 40531,
  [SMALL_STATE(3087)] = 40641,
  [SMALL_STATE(3088)] = 40765,
  [SMALL_STATE(3089)] = 40889,
  [SMALL_STATE(3090)] = 40999,
  [SMALL_STATE(3091)] = 41123,
  [SMALL_STATE(3092)] = 41247,
  [SMALL_STATE(3093)] = 41371,
  [SMALL_STATE(3094)] = 41495,
  [SMALL_STATE(3095)] = 41619,
  [SMALL_STATE(3096)] = 41741,
  [SMALL_STATE(3097)] = 41865,
  [SMALL_STATE(3098)] = 41989,
  [SMALL_STATE(3099)] = 42113,
  [SMALL_STATE(3100)] = 42237,
  [SMALL_STATE(3101)] = 42361,
  [SMALL_STATE(3102)] = 42485,
  [SMALL_STATE(3103)] = 42609,
  [SMALL_STATE(3104)] = 42733,
  [SMALL_STATE(3105)] = 42857,
  [SMALL_STATE(3106)] = 42981,
  [SMALL_STATE(3107)] = 43105,
  [SMALL_STATE(3108)] = 43229,
  [SMALL_STATE(3109)] = 43353,
  [SMALL_STATE(3110)] = 43477,
  [SMALL_STATE(3111)] = 43601,
  [SMALL_STATE(3112)] = 43714,
  [SMALL_STATE(3113)] = 43831,
  [SMALL_STATE(3114)] = 43952,
  [SMALL_STATE(3115)] = 44063,
  [SMALL_STATE(3116)] = 44180,
  [SMALL_STATE(3117)] = 44297,
  [SMALL_STATE(3118)] = 44408,
  [SMALL_STATE(3119)] = 44525,
  [SMALL_STATE(3120)] = 44636,
  [SMALL_STATE(3121)] = 44757,
  [SMALL_STATE(3122)] = 44874,
  [SMALL_STATE(3123)] = 44981,
  [SMALL_STATE(3124)] = 45102,
  [SMALL_STATE(3125)] = 45219,
  [SMALL_STATE(3126)] = 45332,
  [SMALL_STATE(3127)] = 45449,
  [SMALL_STATE(3128)] = 45560,
  [SMALL_STATE(3129)] = 45677,
  [SMALL_STATE(3130)] = 45790,
  [SMALL_STATE(3131)] = 45903,
  [SMALL_STATE(3132)] = 46016,
  [SMALL_STATE(3133)] = 46129,
  [SMALL_STATE(3134)] = 46246,
  [SMALL_STATE(3135)] = 46359,
  [SMALL_STATE(3136)] = 46472,
  [SMALL_STATE(3137)] = 46589,
  [SMALL_STATE(3138)] = 46696,
  [SMALL_STATE(3139)] = 46803,
  [SMALL_STATE(3140)] = 46921,
  [SMALL_STATE(3141)] = 47037,
  [SMALL_STATE(3142)] = 47155,
  [SMALL_STATE(3143)] = 47273,
  [SMALL_STATE(3144)] = 47391,
  [SMALL_STATE(3145)] = 47511,
  [SMALL_STATE(3146)] = 47629,
  [SMALL_STATE(3147)] = 47747,
  [SMALL_STATE(3148)] = 47865,
  [SMALL_STATE(3149)] = 47983,
  [SMALL_STATE(3150)] = 48099,
  [SMALL_STATE(3151)] = 48205,
  [SMALL_STATE(3152)] = 48323,
  [SMALL_STATE(3153)] = 48441,
  [SMALL_STATE(3154)] = 48559,
  [SMALL_STATE(3155)] = 48679,
  [SMALL_STATE(3156)] = 48797,
  [SMALL_STATE(3157)] = 48915,
  [SMALL_STATE(3158)] = 49033,
  [SMALL_STATE(3159)] = 49139,
  [SMALL_STATE(3160)] = 49257,
  [SMALL_STATE(3161)] = 49375,
  [SMALL_STATE(3162)] = 49485,
  [SMALL_STATE(3163)] = 49601,
  [SMALL_STATE(3164)] = 49719,
  [SMALL_STATE(3165)] = 49835,
  [SMALL_STATE(3166)] = 49953,
  [SMALL_STATE(3167)] = 50071,
  [SMALL_STATE(3168)] = 50189,
  [SMALL_STATE(3169)] = 50299,
  [SMALL_STATE(3170)] = 50417,
  [SMALL_STATE(3171)] = 50535,
  [SMALL_STATE(3172)] = 50653,
  [SMALL_STATE(3173)] = 50769,
  [SMALL_STATE(3174)] = 50887,
  [SMALL_STATE(3175)] = 51005,
  [SMALL_STATE(3176)] = 51123,
  [SMALL_STATE(3177)] = 51241,
  [SMALL_STATE(3178)] = 51359,
  [SMALL_STATE(3179)] = 51475,
  [SMALL_STATE(3180)] = 51593,
  [SMALL_STATE(3181)] = 51711,
  [SMALL_STATE(3182)] = 51829,
  [SMALL_STATE(3183)] = 51947,
  [SMALL_STATE(3184)] = 52067,
  [SMALL_STATE(3185)] = 52185,
  [SMALL_STATE(3186)] = 52294,
  [SMALL_STATE(3187)] = 52403,
  [SMALL_STATE(3188)] = 52506,
  [SMALL_STATE(3189)] = 52621,
  [SMALL_STATE(3190)] = 52724,
  [SMALL_STATE(3191)] = 52827,
  [SMALL_STATE(3192)] = 52936,
  [SMALL_STATE(3193)] = 53051,
  [SMALL_STATE(3194)] = 53166,
  [SMALL_STATE(3195)] = 53275,
  [SMALL_STATE(3196)] = 53390,
  [SMALL_STATE(3197)] = 53499,
  [SMALL_STATE(3198)] = 53608,
  [SMALL_STATE(3199)] = 53723,
  [SMALL_STATE(3200)] = 53832,
  [SMALL_STATE(3201)] = 53947,
  [SMALL_STATE(3202)] = 54050,
  [SMALL_STATE(3203)] = 54166,
  [SMALL_STATE(3204)] = 54286,
  [SMALL_STATE(3205)] = 54402,
  [SMALL_STATE(3206)] = 54522,
  [SMALL_STATE(3207)] = 54624,
  [SMALL_STATE(3208)] = 54744,
  [SMALL_STATE(3209)] = 54864,
  [SMALL_STATE(3210)] = 54980,
  [SMALL_STATE(3211)] = 55100,
  [SMALL_STATE(3212)] = 55220,
  [SMALL_STATE(3213)] = 55336,
  [SMALL_STATE(3214)] = 55452,
  [SMALL_STATE(3215)] = 55554,
  [SMALL_STATE(3216)] = 55668,
  [SMALL_STATE(3217)] = 55788,
  [SMALL_STATE(3218)] = 55908,
  [SMALL_STATE(3219)] = 56028,
  [SMALL_STATE(3220)] = 56148,
  [SMALL_STATE(3221)] = 56268,
  [SMALL_STATE(3222)] = 56382,
  [SMALL_STATE(3223)] = 56502,
  [SMALL_STATE(3224)] = 56622,
  [SMALL_STATE(3225)] = 56742,
  [SMALL_STATE(3226)] = 56844,
  [SMALL_STATE(3227)] = 56964,
  [SMALL_STATE(3228)] = 57084,
  [SMALL_STATE(3229)] = 57204,
  [SMALL_STATE(3230)] = 57320,
  [SMALL_STATE(3231)] = 57434,
  [SMALL_STATE(3232)] = 57554,
  [SMALL_STATE(3233)] = 57674,
  [SMALL_STATE(3234)] = 57794,
  [SMALL_STATE(3235)] = 57914,
  [SMALL_STATE(3236)] = 58030,
  [SMALL_STATE(3237)] = 58150,
  [SMALL_STATE(3238)] = 58270,
  [SMALL_STATE(3239)] = 58390,
  [SMALL_STATE(3240)] = 58510,
  [SMALL_STATE(3241)] = 58630,
  [SMALL_STATE(3242)] = 58750,
  [SMALL_STATE(3243)] = 58870,
  [SMALL_STATE(3244)] = 58984,
  [SMALL_STATE(3245)] = 59104,
  [SMALL_STATE(3246)] = 59218,
  [SMALL_STATE(3247)] = 59320,
  [SMALL_STATE(3248)] = 59440,
  [SMALL_STATE(3249)] = 59560,
  [SMALL_STATE(3250)] = 59680,
  [SMALL_STATE(3251)] = 59796,
  [SMALL_STATE(3252)] = 59916,
  [SMALL_STATE(3253)] = 60036,
  [SMALL_STATE(3254)] = 60156,
  [SMALL_STATE(3255)] = 60276,
  [SMALL_STATE(3256)] = 60396,
  [SMALL_STATE(3257)] = 60516,
  [SMALL_STATE(3258)] = 60636,
  [SMALL_STATE(3259)] = 60756,
  [SMALL_STATE(3260)] = 60876,
  [SMALL_STATE(3261)] = 60996,
  [SMALL_STATE(3262)] = 61112,
  [SMALL_STATE(3263)] = 61232,
  [SMALL_STATE(3264)] = 61348,
  [SMALL_STATE(3265)] = 61468,
  [SMALL_STATE(3266)] = 61588,
  [SMALL_STATE(3267)] = 61704,
  [SMALL_STATE(3268)] = 61824,
  [SMALL_STATE(3269)] = 61944,
  [SMALL_STATE(3270)] = 62064,
  [SMALL_STATE(3271)] = 62184,
  [SMALL_STATE(3272)] = 62304,
  [SMALL_STATE(3273)] = 62410,
  [SMALL_STATE(3274)] = 62526,
  [SMALL_STATE(3275)] = 62646,
  [SMALL_STATE(3276)] = 62766,
  [SMALL_STATE(3277)] = 62886,
  [SMALL_STATE(3278)] = 63002,
  [SMALL_STATE(3279)] = 63122,
  [SMALL_STATE(3280)] = 63242,
  [SMALL_STATE(3281)] = 63358,
  [SMALL_STATE(3282)] = 63478,
  [SMALL_STATE(3283)] = 63598,
  [SMALL_STATE(3284)] = 63718,
  [SMALL_STATE(3285)] = 63832,
  [SMALL_STATE(3286)] = 63952,
  [SMALL_STATE(3287)] = 64072,
  [SMALL_STATE(3288)] = 64186,
  [SMALL_STATE(3289)] = 64302,
  [SMALL_STATE(3290)] = 64418,
  [SMALL_STATE(3291)] = 64538,
  [SMALL_STATE(3292)] = 64654,
  [SMALL_STATE(3293)] = 64774,
  [SMALL_STATE(3294)] = 64876,
  [SMALL_STATE(3295)] = 64990,
  [SMALL_STATE(3296)] = 65110,
  [SMALL_STATE(3297)] = 65226,
  [SMALL_STATE(3298)] = 65346,
  [SMALL_STATE(3299)] = 65466,
  [SMALL_STATE(3300)] = 65586,
  [SMALL_STATE(3301)] = 65706,
  [SMALL_STATE(3302)] = 65812,
  [SMALL_STATE(3303)] = 65932,
  [SMALL_STATE(3304)] = 66052,
  [SMALL_STATE(3305)] = 66172,
  [SMALL_STATE(3306)] = 66292,
  [SMALL_STATE(3307)] = 66412,
  [SMALL_STATE(3308)] = 66532,
  [SMALL_STATE(3309)] = 66652,
  [SMALL_STATE(3310)] = 66772,
  [SMALL_STATE(3311)] = 66874,
  [SMALL_STATE(3312)] = 66994,
  [SMALL_STATE(3313)] = 67110,
  [SMALL_STATE(3314)] = 67230,
  [SMALL_STATE(3315)] = 67350,
  [SMALL_STATE(3316)] = 67470,
  [SMALL_STATE(3317)] = 67590,
  [SMALL_STATE(3318)] = 67710,
  [SMALL_STATE(3319)] = 67824,
  [SMALL_STATE(3320)] = 67944,
  [SMALL_STATE(3321)] = 68064,
  [SMALL_STATE(3322)] = 68184,
  [SMALL_STATE(3323)] = 68300,
  [SMALL_STATE(3324)] = 68420,
  [SMALL_STATE(3325)] = 68540,
  [SMALL_STATE(3326)] = 68656,
  [SMALL_STATE(3327)] = 68776,
  [SMALL_STATE(3328)] = 68892,
  [SMALL_STATE(3329)] = 69008,
  [SMALL_STATE(3330)] = 69128,
  [SMALL_STATE(3331)] = 69248,
  [SMALL_STATE(3332)] = 69364,
  [SMALL_STATE(3333)] = 69484,
  [SMALL_STATE(3334)] = 69604,
  [SMALL_STATE(3335)] = 69724,
  [SMALL_STATE(3336)] = 69844,
  [SMALL_STATE(3337)] = 69959,
  [SMALL_STATE(3338)] = 70066,
  [SMALL_STATE(3339)] = 70183,
  [SMALL_STATE(3340)] = 70300,
  [SMALL_STATE(3341)] = 70415,
  [SMALL_STATE(3342)] = 70532,
  [SMALL_STATE(3343)] = 70649,
  [SMALL_STATE(3344)] = 70766,
  [SMALL_STATE(3345)] = 70883,
  [SMALL_STATE(3346)] = 70998,
  [SMALL_STATE(3347)] = 71115,
  [SMALL_STATE(3348)] = 71232,
  [SMALL_STATE(3349)] = 71333,
  [SMALL_STATE(3350)] = 71450,
  [SMALL_STATE(3351)] = 71565,
  [SMALL_STATE(3352)] = 71682,
  [SMALL_STATE(3353)] = 71783,
  [SMALL_STATE(3354)] = 71900,
  [SMALL_STATE(3355)] = 72017,
  [SMALL_STATE(3356)] = 72134,
  [SMALL_STATE(3357)] = 72249,
  [SMALL_STATE(3358)] = 72366,
  [SMALL_STATE(3359)] = 72481,
  [SMALL_STATE(3360)] = 72596,
  [SMALL_STATE(3361)] = 72711,
  [SMALL_STATE(3362)] = 72828,
  [SMALL_STATE(3363)] = 72945,
  [SMALL_STATE(3364)] = 73062,
  [SMALL_STATE(3365)] = 73177,
  [SMALL_STATE(3366)] = 73294,
  [SMALL_STATE(3367)] = 73407,
  [SMALL_STATE(3368)] = 73522,
  [SMALL_STATE(3369)] = 73639,
  [SMALL_STATE(3370)] = 73754,
  [SMALL_STATE(3371)] = 73869,
  [SMALL_STATE(3372)] = 73986,
  [SMALL_STATE(3373)] = 74103,
  [SMALL_STATE(3374)] = 74220,
  [SMALL_STATE(3375)] = 74337,
  [SMALL_STATE(3376)] = 74454,
  [SMALL_STATE(3377)] = 74569,
  [SMALL_STATE(3378)] = 74686,
  [SMALL_STATE(3379)] = 74801,
  [SMALL_STATE(3380)] = 74918,
  [SMALL_STATE(3381)] = 75035,
  [SMALL_STATE(3382)] = 75152,
  [SMALL_STATE(3383)] = 75269,
  [SMALL_STATE(3384)] = 75386,
  [SMALL_STATE(3385)] = 75501,
  [SMALL_STATE(3386)] = 75618,
  [SMALL_STATE(3387)] = 75733,
  [SMALL_STATE(3388)] = 75850,
  [SMALL_STATE(3389)] = 75967,
  [SMALL_STATE(3390)] = 76084,
  [SMALL_STATE(3391)] = 76201,
  [SMALL_STATE(3392)] = 76318,
  [SMALL_STATE(3393)] = 76433,
  [SMALL_STATE(3394)] = 76550,
  [SMALL_STATE(3395)] = 76667,
  [SMALL_STATE(3396)] = 76784,
  [SMALL_STATE(3397)] = 76901,
  [SMALL_STATE(3398)] = 77018,
  [SMALL_STATE(3399)] = 77135,
  [SMALL_STATE(3400)] = 77252,
  [SMALL_STATE(3401)] = 77369,
  [SMALL_STATE(3402)] = 77486,
  [SMALL_STATE(3403)] = 77603,
  [SMALL_STATE(3404)] = 77720,
  [SMALL_STATE(3405)] = 77837,
  [SMALL_STATE(3406)] = 77948,
  [SMALL_STATE(3407)] = 78065,
  [SMALL_STATE(3408)] = 78176,
  [SMALL_STATE(3409)] = 78293,
  [SMALL_STATE(3410)] = 78410,
  [SMALL_STATE(3411)] = 78525,
  [SMALL_STATE(3412)] = 78642,
  [SMALL_STATE(3413)] = 78759,
  [SMALL_STATE(3414)] = 78874,
  [SMALL_STATE(3415)] = 78991,
  [SMALL_STATE(3416)] = 79108,
  [SMALL_STATE(3417)] = 79225,
  [SMALL_STATE(3418)] = 79342,
  [SMALL_STATE(3419)] = 79459,
  [SMALL_STATE(3420)] = 79576,
  [SMALL_STATE(3421)] = 79693,
  [SMALL_STATE(3422)] = 79810,
  [SMALL_STATE(3423)] = 79927,
  [SMALL_STATE(3424)] = 80044,
  [SMALL_STATE(3425)] = 80161,
  [SMALL_STATE(3426)] = 80278,
  [SMALL_STATE(3427)] = 80395,
  [SMALL_STATE(3428)] = 80512,
  [SMALL_STATE(3429)] = 80629,
  [SMALL_STATE(3430)] = 80746,
  [SMALL_STATE(3431)] = 80863,
  [SMALL_STATE(3432)] = 80980,
  [SMALL_STATE(3433)] = 81097,
  [SMALL_STATE(3434)] = 81214,
  [SMALL_STATE(3435)] = 81331,
  [SMALL_STATE(3436)] = 81448,
  [SMALL_STATE(3437)] = 81563,
  [SMALL_STATE(3438)] = 81680,
  [SMALL_STATE(3439)] = 81797,
  [SMALL_STATE(3440)] = 81914,
  [SMALL_STATE(3441)] = 82031,
  [SMALL_STATE(3442)] = 82148,
  [SMALL_STATE(3443)] = 82265,
  [SMALL_STATE(3444)] = 82376,
  [SMALL_STATE(3445)] = 82493,
  [SMALL_STATE(3446)] = 82610,
  [SMALL_STATE(3447)] = 82725,
  [SMALL_STATE(3448)] = 82842,
  [SMALL_STATE(3449)] = 82959,
  [SMALL_STATE(3450)] = 83060,
  [SMALL_STATE(3451)] = 83171,
  [SMALL_STATE(3452)] = 83288,
  [SMALL_STATE(3453)] = 83403,
  [SMALL_STATE(3454)] = 83520,
  [SMALL_STATE(3455)] = 83637,
  [SMALL_STATE(3456)] = 83754,
  [SMALL_STATE(3457)] = 83871,
  [SMALL_STATE(3458)] = 83988,
  [SMALL_STATE(3459)] = 84103,
  [SMALL_STATE(3460)] = 84220,
  [SMALL_STATE(3461)] = 84337,
  [SMALL_STATE(3462)] = 84454,
  [SMALL_STATE(3463)] = 84571,
  [SMALL_STATE(3464)] = 84688,
  [SMALL_STATE(3465)] = 84805,
  [SMALL_STATE(3466)] = 84922,
  [SMALL_STATE(3467)] = 85039,
  [SMALL_STATE(3468)] = 85156,
  [SMALL_STATE(3469)] = 85273,
  [SMALL_STATE(3470)] = 85390,
  [SMALL_STATE(3471)] = 85507,
  [SMALL_STATE(3472)] = 85624,
  [SMALL_STATE(3473)] = 85741,
  [SMALL_STATE(3474)] = 85858,
  [SMALL_STATE(3475)] = 85959,
  [SMALL_STATE(3476)] = 86076,
  [SMALL_STATE(3477)] = 86193,
  [SMALL_STATE(3478)] = 86310,
  [SMALL_STATE(3479)] = 86427,
  [SMALL_STATE(3480)] = 86544,
  [SMALL_STATE(3481)] = 86645,
  [SMALL_STATE(3482)] = 86762,
  [SMALL_STATE(3483)] = 86879,
  [SMALL_STATE(3484)] = 86996,
  [SMALL_STATE(3485)] = 87113,
  [SMALL_STATE(3486)] = 87230,
  [SMALL_STATE(3487)] = 87347,
  [SMALL_STATE(3488)] = 87464,
  [SMALL_STATE(3489)] = 87581,
  [SMALL_STATE(3490)] = 87698,
  [SMALL_STATE(3491)] = 87809,
  [SMALL_STATE(3492)] = 87920,
  [SMALL_STATE(3493)] = 88037,
  [SMALL_STATE(3494)] = 88138,
  [SMALL_STATE(3495)] = 88255,
  [SMALL_STATE(3496)] = 88372,
  [SMALL_STATE(3497)] = 88489,
  [SMALL_STATE(3498)] = 88606,
  [SMALL_STATE(3499)] = 88721,
  [SMALL_STATE(3500)] = 88838,
  [SMALL_STATE(3501)] = 88955,
  [SMALL_STATE(3502)] = 89072,
  [SMALL_STATE(3503)] = 89189,
  [SMALL_STATE(3504)] = 89306,
  [SMALL_STATE(3505)] = 89421,
  [SMALL_STATE(3506)] = 89538,
  [SMALL_STATE(3507)] = 89653,
  [SMALL_STATE(3508)] = 89770,
  [SMALL_STATE(3509)] = 89881,
  [SMALL_STATE(3510)] = 89998,
  [SMALL_STATE(3511)] = 90115,
  [SMALL_STATE(3512)] = 90232,
  [SMALL_STATE(3513)] = 90349,
  [SMALL_STATE(3514)] = 90456,
  [SMALL_STATE(3515)] = 90573,
  [SMALL_STATE(3516)] = 90690,
  [SMALL_STATE(3517)] = 90798,
  [SMALL_STATE(3518)] = 90898,
  [SMALL_STATE(3519)] = 91002,
  [SMALL_STATE(3520)] = 91106,
  [SMALL_STATE(3521)] = 91214,
  [SMALL_STATE(3522)] = 91328,
  [SMALL_STATE(3523)] = 91436,
  [SMALL_STATE(3524)] = 91544,
  [SMALL_STATE(3525)] = 91652,
  [SMALL_STATE(3526)] = 91760,
  [SMALL_STATE(3527)] = 91860,
  [SMALL_STATE(3528)] = 91968,
  [SMALL_STATE(3529)] = 92076,
  [SMALL_STATE(3530)] = 92180,
  [SMALL_STATE(3531)] = 92284,
  [SMALL_STATE(3532)] = 92392,
  [SMALL_STATE(3533)] = 92496,
  [SMALL_STATE(3534)] = 92600,
  [SMALL_STATE(3535)] = 92708,
  [SMALL_STATE(3536)] = 92816,
  [SMALL_STATE(3537)] = 92924,
  [SMALL_STATE(3538)] = 93032,
  [SMALL_STATE(3539)] = 93140,
  [SMALL_STATE(3540)] = 93248,
  [SMALL_STATE(3541)] = 93348,
  [SMALL_STATE(3542)] = 93452,
  [SMALL_STATE(3543)] = 93556,
  [SMALL_STATE(3544)] = 93656,
  [SMALL_STATE(3545)] = 93757,
  [SMALL_STATE(3546)] = 93858,
  [SMALL_STATE(3547)] = 93959,
  [SMALL_STATE(3548)] = 94060,
  [SMALL_STATE(3549)] = 94161,
  [SMALL_STATE(3550)] = 94262,
  [SMALL_STATE(3551)] = 94363,
  [SMALL_STATE(3552)] = 94468,
  [SMALL_STATE(3553)] = 94573,
  [SMALL_STATE(3554)] = 94674,
  [SMALL_STATE(3555)] = 94779,
  [SMALL_STATE(3556)] = 94880,
  [SMALL_STATE(3557)] = 94985,
  [SMALL_STATE(3558)] = 95086,
  [SMALL_STATE(3559)] = 95191,
  [SMALL_STATE(3560)] = 95292,
  [SMALL_STATE(3561)] = 95393,
  [SMALL_STATE(3562)] = 95498,
  [SMALL_STATE(3563)] = 95599,
  [SMALL_STATE(3564)] = 95700,
  [SMALL_STATE(3565)] = 95801,
  [SMALL_STATE(3566)] = 95902,
  [SMALL_STATE(3567)] = 96007,
  [SMALL_STATE(3568)] = 96108,
  [SMALL_STATE(3569)] = 96209,
  [SMALL_STATE(3570)] = 96310,
  [SMALL_STATE(3571)] = 96411,
  [SMALL_STATE(3572)] = 96516,
  [SMALL_STATE(3573)] = 96617,
  [SMALL_STATE(3574)] = 96718,
  [SMALL_STATE(3575)] = 96819,
  [SMALL_STATE(3576)] = 96920,
  [SMALL_STATE(3577)] = 97025,
  [SMALL_STATE(3578)] = 97126,
  [SMALL_STATE(3579)] = 97227,
  [SMALL_STATE(3580)] = 97332,
  [SMALL_STATE(3581)] = 97433,
  [SMALL_STATE(3582)] = 97538,
  [SMALL_STATE(3583)] = 97643,
  [SMALL_STATE(3584)] = 97744,
  [SMALL_STATE(3585)] = 97845,
  [SMALL_STATE(3586)] = 97946,
  [SMALL_STATE(3587)] = 98051,
  [SMALL_STATE(3588)] = 98152,
  [SMALL_STATE(3589)] = 98253,
  [SMALL_STATE(3590)] = 98354,
  [SMALL_STATE(3591)] = 98455,
  [SMALL_STATE(3592)] = 98556,
  [SMALL_STATE(3593)] = 98657,
  [SMALL_STATE(3594)] = 98758,
  [SMALL_STATE(3595)] = 98859,
  [SMALL_STATE(3596)] = 98960,
  [SMALL_STATE(3597)] = 99061,
  [SMALL_STATE(3598)] = 99162,
  [SMALL_STATE(3599)] = 99263,
  [SMALL_STATE(3600)] = 99364,
  [SMALL_STATE(3601)] = 99465,
  [SMALL_STATE(3602)] = 99570,
  [SMALL_STATE(3603)] = 99671,
  [SMALL_STATE(3604)] = 99772,
  [SMALL_STATE(3605)] = 99873,
  [SMALL_STATE(3606)] = 99978,
  [SMALL_STATE(3607)] = 100079,
  [SMALL_STATE(3608)] = 100180,
  [SMALL_STATE(3609)] = 100281,
  [SMALL_STATE(3610)] = 100386,
  [SMALL_STATE(3611)] = 100487,
  [SMALL_STATE(3612)] = 100588,
  [SMALL_STATE(3613)] = 100689,
  [SMALL_STATE(3614)] = 100790,
  [SMALL_STATE(3615)] = 100891,
  [SMALL_STATE(3616)] = 100992,
  [SMALL_STATE(3617)] = 101093,
  [SMALL_STATE(3618)] = 101194,
  [SMALL_STATE(3619)] = 101295,
  [SMALL_STATE(3620)] = 101396,
  [SMALL_STATE(3621)] = 101497,
  [SMALL_STATE(3622)] = 101598,
  [SMALL_STATE(3623)] = 101699,
  [SMALL_STATE(3624)] = 101800,
  [SMALL_STATE(3625)] = 101901,
  [SMALL_STATE(3626)] = 102002,
  [SMALL_STATE(3627)] = 102110,
  [SMALL_STATE(3628)] = 102218,
  [SMALL_STATE(3629)] = 102326,
  [SMALL_STATE(3630)] = 102434,
  [SMALL_STATE(3631)] = 102542,
  [SMALL_STATE(3632)] = 102650,
  [SMALL_STATE(3633)] = 102758,
  [SMALL_STATE(3634)] = 102866,
  [SMALL_STATE(3635)] = 102974,
  [SMALL_STATE(3636)] = 103082,
  [SMALL_STATE(3637)] = 103190,
  [SMALL_STATE(3638)] = 103298,
  [SMALL_STATE(3639)] = 103406,
  [SMALL_STATE(3640)] = 103514,
  [SMALL_STATE(3641)] = 103622,
  [SMALL_STATE(3642)] = 103730,
  [SMALL_STATE(3643)] = 103838,
  [SMALL_STATE(3644)] = 103946,
  [SMALL_STATE(3645)] = 104054,
  [SMALL_STATE(3646)] = 104162,
  [SMALL_STATE(3647)] = 104270,
  [SMALL_STATE(3648)] = 104378,
  [SMALL_STATE(3649)] = 104486,
  [SMALL_STATE(3650)] = 104594,
  [SMALL_STATE(3651)] = 104702,
  [SMALL_STATE(3652)] = 104810,
  [SMALL_STATE(3653)] = 104918,
  [SMALL_STATE(3654)] = 105026,
  [SMALL_STATE(3655)] = 105134,
  [SMALL_STATE(3656)] = 105242,
  [SMALL_STATE(3657)] = 105350,
  [SMALL_STATE(3658)] = 105458,
  [SMALL_STATE(3659)] = 105566,
  [SMALL_STATE(3660)] = 105674,
  [SMALL_STATE(3661)] = 105782,
  [SMALL_STATE(3662)] = 105890,
  [SMALL_STATE(3663)] = 105998,
  [SMALL_STATE(3664)] = 106106,
  [SMALL_STATE(3665)] = 106214,
  [SMALL_STATE(3666)] = 106322,
  [SMALL_STATE(3667)] = 106430,
  [SMALL_STATE(3668)] = 106538,
  [SMALL_STATE(3669)] = 106646,
  [SMALL_STATE(3670)] = 106754,
  [SMALL_STATE(3671)] = 106862,
  [SMALL_STATE(3672)] = 106970,
  [SMALL_STATE(3673)] = 107078,
  [SMALL_STATE(3674)] = 107186,
  [SMALL_STATE(3675)] = 107294,
  [SMALL_STATE(3676)] = 107402,
  [SMALL_STATE(3677)] = 107510,
  [SMALL_STATE(3678)] = 107618,
  [SMALL_STATE(3679)] = 107726,
  [SMALL_STATE(3680)] = 107834,
  [SMALL_STATE(3681)] = 107942,
  [SMALL_STATE(3682)] = 108050,
  [SMALL_STATE(3683)] = 108158,
  [SMALL_STATE(3684)] = 108266,
  [SMALL_STATE(3685)] = 108374,
  [SMALL_STATE(3686)] = 108482,
  [SMALL_STATE(3687)] = 108590,
  [SMALL_STATE(3688)] = 108698,
  [SMALL_STATE(3689)] = 108806,
  [SMALL_STATE(3690)] = 108914,
  [SMALL_STATE(3691)] = 109022,
  [SMALL_STATE(3692)] = 109130,
  [SMALL_STATE(3693)] = 109238,
  [SMALL_STATE(3694)] = 109346,
  [SMALL_STATE(3695)] = 109454,
  [SMALL_STATE(3696)] = 109562,
  [SMALL_STATE(3697)] = 109670,
  [SMALL_STATE(3698)] = 109778,
  [SMALL_STATE(3699)] = 109886,
  [SMALL_STATE(3700)] = 109994,
  [SMALL_STATE(3701)] = 110102,
  [SMALL_STATE(3702)] = 110210,
  [SMALL_STATE(3703)] = 110318,
  [SMALL_STATE(3704)] = 110426,
  [SMALL_STATE(3705)] = 110534,
  [SMALL_STATE(3706)] = 110642,
  [SMALL_STATE(3707)] = 110750,
  [SMALL_STATE(3708)] = 110858,
  [SMALL_STATE(3709)] = 110966,
  [SMALL_STATE(3710)] = 111074,
  [SMALL_STATE(3711)] = 111182,
  [SMALL_STATE(3712)] = 111290,
  [SMALL_STATE(3713)] = 111398,
  [SMALL_STATE(3714)] = 111506,
  [SMALL_STATE(3715)] = 111614,
  [SMALL_STATE(3716)] = 111722,
  [SMALL_STATE(3717)] = 111830,
  [SMALL_STATE(3718)] = 111938,
  [SMALL_STATE(3719)] = 112046,
  [SMALL_STATE(3720)] = 112154,
  [SMALL_STATE(3721)] = 112262,
  [SMALL_STATE(3722)] = 112370,
  [SMALL_STATE(3723)] = 112478,
  [SMALL_STATE(3724)] = 112537,
  [SMALL_STATE(3725)] = 112598,
  [SMALL_STATE(3726)] = 112659,
  [SMALL_STATE(3727)] = 112756,
  [SMALL_STATE(3728)] = 112853,
  [SMALL_STATE(3729)] = 112914,
  [SMALL_STATE(3730)] = 112975,
  [SMALL_STATE(3731)] = 113036,
  [SMALL_STATE(3732)] = 113097,
  [SMALL_STATE(3733)] = 113158,
  [SMALL_STATE(3734)] = 113219,
  [SMALL_STATE(3735)] = 113280,
  [SMALL_STATE(3736)] = 113377,
  [SMALL_STATE(3737)] = 113474,
  [SMALL_STATE(3738)] = 113535,
  [SMALL_STATE(3739)] = 113620,
  [SMALL_STATE(3740)] = 113681,
  [SMALL_STATE(3741)] = 113740,
  [SMALL_STATE(3742)] = 113799,
  [SMALL_STATE(3743)] = 113860,
  [SMALL_STATE(3744)] = 113945,
  [SMALL_STATE(3745)] = 114003,
  [SMALL_STATE(3746)] = 114067,
  [SMALL_STATE(3747)] = 114125,
  [SMALL_STATE(3748)] = 114183,
  [SMALL_STATE(3749)] = 114243,
  [SMALL_STATE(3750)] = 114301,
  [SMALL_STATE(3751)] = 114359,
  [SMALL_STATE(3752)] = 114417,
  [SMALL_STATE(3753)] = 114499,
  [SMALL_STATE(3754)] = 114557,
  [SMALL_STATE(3755)] = 114615,
  [SMALL_STATE(3756)] = 114673,
  [SMALL_STATE(3757)] = 114731,
  [SMALL_STATE(3758)] = 114789,
  [SMALL_STATE(3759)] = 114847,
  [SMALL_STATE(3760)] = 114905,
  [SMALL_STATE(3761)] = 114963,
  [SMALL_STATE(3762)] = 115021,
  [SMALL_STATE(3763)] = 115079,
  [SMALL_STATE(3764)] = 115137,
  [SMALL_STATE(3765)] = 115195,
  [SMALL_STATE(3766)] = 115253,
  [SMALL_STATE(3767)] = 115311,
  [SMALL_STATE(3768)] = 115369,
  [SMALL_STATE(3769)] = 115427,
  [SMALL_STATE(3770)] = 115485,
  [SMALL_STATE(3771)] = 115543,
  [SMALL_STATE(3772)] = 115601,
  [SMALL_STATE(3773)] = 115659,
  [SMALL_STATE(3774)] = 115717,
  [SMALL_STATE(3775)] = 115775,
  [SMALL_STATE(3776)] = 115833,
  [SMALL_STATE(3777)] = 115893,
  [SMALL_STATE(3778)] = 115951,
  [SMALL_STATE(3779)] = 116009,
  [SMALL_STATE(3780)] = 116067,
  [SMALL_STATE(3781)] = 116125,
  [SMALL_STATE(3782)] = 116183,
  [SMALL_STATE(3783)] = 116241,
  [SMALL_STATE(3784)] = 116299,
  [SMALL_STATE(3785)] = 116357,
  [SMALL_STATE(3786)] = 116415,
  [SMALL_STATE(3787)] = 116499,
  [SMALL_STATE(3788)] = 116557,
  [SMALL_STATE(3789)] = 116615,
  [SMALL_STATE(3790)] = 116673,
  [SMALL_STATE(3791)] = 116731,
  [SMALL_STATE(3792)] = 116789,
  [SMALL_STATE(3793)] = 116847,
  [SMALL_STATE(3794)] = 116905,
  [SMALL_STATE(3795)] = 116963,
  [SMALL_STATE(3796)] = 117021,
  [SMALL_STATE(3797)] = 117079,
  [SMALL_STATE(3798)] = 117137,
  [SMALL_STATE(3799)] = 117219,
  [SMALL_STATE(3800)] = 117277,
  [SMALL_STATE(3801)] = 117335,
  [SMALL_STATE(3802)] = 117393,
  [SMALL_STATE(3803)] = 117451,
  [SMALL_STATE(3804)] = 117509,
  [SMALL_STATE(3805)] = 117569,
  [SMALL_STATE(3806)] = 117627,
  [SMALL_STATE(3807)] = 117685,
  [SMALL_STATE(3808)] = 117743,
  [SMALL_STATE(3809)] = 117801,
  [SMALL_STATE(3810)] = 117861,
  [SMALL_STATE(3811)] = 117923,
  [SMALL_STATE(3812)] = 117981,
  [SMALL_STATE(3813)] = 118039,
  [SMALL_STATE(3814)] = 118097,
  [SMALL_STATE(3815)] = 118155,
  [SMALL_STATE(3816)] = 118213,
  [SMALL_STATE(3817)] = 118271,
  [SMALL_STATE(3818)] = 118329,
  [SMALL_STATE(3819)] = 118387,
  [SMALL_STATE(3820)] = 118445,
  [SMALL_STATE(3821)] = 118503,
  [SMALL_STATE(3822)] = 118561,
  [SMALL_STATE(3823)] = 118619,
  [SMALL_STATE(3824)] = 118677,
  [SMALL_STATE(3825)] = 118735,
  [SMALL_STATE(3826)] = 118792,
  [SMALL_STATE(3827)] = 118849,
  [SMALL_STATE(3828)] = 118906,
  [SMALL_STATE(3829)] = 118999,
  [SMALL_STATE(3830)] = 119056,
  [SMALL_STATE(3831)] = 119113,
  [SMALL_STATE(3832)] = 119206,
  [SMALL_STATE(3833)] = 119263,
  [SMALL_STATE(3834)] = 119320,
  [SMALL_STATE(3835)] = 119413,
  [SMALL_STATE(3836)] = 119470,
  [SMALL_STATE(3837)] = 119527,
  [SMALL_STATE(3838)] = 119620,
  [SMALL_STATE(3839)] = 119677,
  [SMALL_STATE(3840)] = 119734,
  [SMALL_STATE(3841)] = 119827,
  [SMALL_STATE(3842)] = 119884,
  [SMALL_STATE(3843)] = 119941,
  [SMALL_STATE(3844)] = 119998,
  [SMALL_STATE(3845)] = 120055,
  [SMALL_STATE(3846)] = 120148,
  [SMALL_STATE(3847)] = 120205,
  [SMALL_STATE(3848)] = 120298,
  [SMALL_STATE(3849)] = 120391,
  [SMALL_STATE(3850)] = 120448,
  [SMALL_STATE(3851)] = 120505,
  [SMALL_STATE(3852)] = 120562,
  [SMALL_STATE(3853)] = 120655,
  [SMALL_STATE(3854)] = 120712,
  [SMALL_STATE(3855)] = 120805,
  [SMALL_STATE(3856)] = 120898,
  [SMALL_STATE(3857)] = 120955,
  [SMALL_STATE(3858)] = 121012,
  [SMALL_STATE(3859)] = 121105,
  [SMALL_STATE(3860)] = 121162,
  [SMALL_STATE(3861)] = 121219,
  [SMALL_STATE(3862)] = 121276,
  [SMALL_STATE(3863)] = 121333,
  [SMALL_STATE(3864)] = 121426,
  [SMALL_STATE(3865)] = 121519,
  [SMALL_STATE(3866)] = 121612,
  [SMALL_STATE(3867)] = 121705,
  [SMALL_STATE(3868)] = 121762,
  [SMALL_STATE(3869)] = 121855,
  [SMALL_STATE(3870)] = 121948,
  [SMALL_STATE(3871)] = 122005,
  [SMALL_STATE(3872)] = 122098,
  [SMALL_STATE(3873)] = 122191,
  [SMALL_STATE(3874)] = 122284,
  [SMALL_STATE(3875)] = 122341,
  [SMALL_STATE(3876)] = 122400,
  [SMALL_STATE(3877)] = 122493,
  [SMALL_STATE(3878)] = 122586,
  [SMALL_STATE(3879)] = 122645,
  [SMALL_STATE(3880)] = 122738,
  [SMALL_STATE(3881)] = 122831,
  [SMALL_STATE(3882)] = 122924,
  [SMALL_STATE(3883)] = 123017,
  [SMALL_STATE(3884)] = 123110,
  [SMALL_STATE(3885)] = 123203,
  [SMALL_STATE(3886)] = 123296,
  [SMALL_STATE(3887)] = 123389,
  [SMALL_STATE(3888)] = 123482,
  [SMALL_STATE(3889)] = 123575,
  [SMALL_STATE(3890)] = 123668,
  [SMALL_STATE(3891)] = 123761,
  [SMALL_STATE(3892)] = 123854,
  [SMALL_STATE(3893)] = 123947,
  [SMALL_STATE(3894)] = 124040,
  [SMALL_STATE(3895)] = 124133,
  [SMALL_STATE(3896)] = 124226,
  [SMALL_STATE(3897)] = 124319,
  [SMALL_STATE(3898)] = 124412,
  [SMALL_STATE(3899)] = 124505,
  [SMALL_STATE(3900)] = 124598,
  [SMALL_STATE(3901)] = 124691,
  [SMALL_STATE(3902)] = 124784,
  [SMALL_STATE(3903)] = 124877,
  [SMALL_STATE(3904)] = 124970,
  [SMALL_STATE(3905)] = 125063,
  [SMALL_STATE(3906)] = 125156,
  [SMALL_STATE(3907)] = 125249,
  [SMALL_STATE(3908)] = 125342,
  [SMALL_STATE(3909)] = 125435,
  [SMALL_STATE(3910)] = 125528,
  [SMALL_STATE(3911)] = 125621,
  [SMALL_STATE(3912)] = 125714,
  [SMALL_STATE(3913)] = 125807,
  [SMALL_STATE(3914)] = 125900,
  [SMALL_STATE(3915)] = 125993,
  [SMALL_STATE(3916)] = 126052,
  [SMALL_STATE(3917)] = 126145,
  [SMALL_STATE(3918)] = 126238,
  [SMALL_STATE(3919)] = 126331,
  [SMALL_STATE(3920)] = 126424,
  [SMALL_STATE(3921)] = 126517,
  [SMALL_STATE(3922)] = 126610,
  [SMALL_STATE(3923)] = 126703,
  [SMALL_STATE(3924)] = 126796,
  [SMALL_STATE(3925)] = 126889,
  [SMALL_STATE(3926)] = 126982,
  [SMALL_STATE(3927)] = 127075,
  [SMALL_STATE(3928)] = 127168,
  [SMALL_STATE(3929)] = 127261,
  [SMALL_STATE(3930)] = 127354,
  [SMALL_STATE(3931)] = 127447,
  [SMALL_STATE(3932)] = 127540,
  [SMALL_STATE(3933)] = 127633,
  [SMALL_STATE(3934)] = 127726,
  [SMALL_STATE(3935)] = 127819,
  [SMALL_STATE(3936)] = 127912,
  [SMALL_STATE(3937)] = 128005,
  [SMALL_STATE(3938)] = 128098,
  [SMALL_STATE(3939)] = 128191,
  [SMALL_STATE(3940)] = 128284,
  [SMALL_STATE(3941)] = 128377,
  [SMALL_STATE(3942)] = 128470,
  [SMALL_STATE(3943)] = 128563,
  [SMALL_STATE(3944)] = 128656,
  [SMALL_STATE(3945)] = 128749,
  [SMALL_STATE(3946)] = 128842,
  [SMALL_STATE(3947)] = 128935,
  [SMALL_STATE(3948)] = 129028,
  [SMALL_STATE(3949)] = 129121,
  [SMALL_STATE(3950)] = 129214,
  [SMALL_STATE(3951)] = 129307,
  [SMALL_STATE(3952)] = 129400,
  [SMALL_STATE(3953)] = 129493,
  [SMALL_STATE(3954)] = 129586,
  [SMALL_STATE(3955)] = 129679,
  [SMALL_STATE(3956)] = 129772,
  [SMALL_STATE(3957)] = 129865,
  [SMALL_STATE(3958)] = 129958,
  [SMALL_STATE(3959)] = 130051,
  [SMALL_STATE(3960)] = 130144,
  [SMALL_STATE(3961)] = 130237,
  [SMALL_STATE(3962)] = 130330,
  [SMALL_STATE(3963)] = 130423,
  [SMALL_STATE(3964)] = 130516,
  [SMALL_STATE(3965)] = 130609,
  [SMALL_STATE(3966)] = 130702,
  [SMALL_STATE(3967)] = 130795,
  [SMALL_STATE(3968)] = 130888,
  [SMALL_STATE(3969)] = 130981,
  [SMALL_STATE(3970)] = 131074,
  [SMALL_STATE(3971)] = 131167,
  [SMALL_STATE(3972)] = 131260,
  [SMALL_STATE(3973)] = 131353,
  [SMALL_STATE(3974)] = 131446,
  [SMALL_STATE(3975)] = 131539,
  [SMALL_STATE(3976)] = 131632,
  [SMALL_STATE(3977)] = 131725,
  [SMALL_STATE(3978)] = 131818,
  [SMALL_STATE(3979)] = 131911,
  [SMALL_STATE(3980)] = 132004,
  [SMALL_STATE(3981)] = 132097,
  [SMALL_STATE(3982)] = 132190,
  [SMALL_STATE(3983)] = 132283,
  [SMALL_STATE(3984)] = 132376,
  [SMALL_STATE(3985)] = 132469,
  [SMALL_STATE(3986)] = 132562,
  [SMALL_STATE(3987)] = 132655,
  [SMALL_STATE(3988)] = 132748,
  [SMALL_STATE(3989)] = 132841,
  [SMALL_STATE(3990)] = 132934,
  [SMALL_STATE(3991)] = 133027,
  [SMALL_STATE(3992)] = 133120,
  [SMALL_STATE(3993)] = 133213,
  [SMALL_STATE(3994)] = 133306,
  [SMALL_STATE(3995)] = 133399,
  [SMALL_STATE(3996)] = 133492,
  [SMALL_STATE(3997)] = 133585,
  [SMALL_STATE(3998)] = 133678,
  [SMALL_STATE(3999)] = 133771,
  [SMALL_STATE(4000)] = 133864,
  [SMALL_STATE(4001)] = 133957,
  [SMALL_STATE(4002)] = 134050,
  [SMALL_STATE(4003)] = 134143,
  [SMALL_STATE(4004)] = 134236,
  [SMALL_STATE(4005)] = 134329,
  [SMALL_STATE(4006)] = 134422,
  [SMALL_STATE(4007)] = 134515,
  [SMALL_STATE(4008)] = 134608,
  [SMALL_STATE(4009)] = 134701,
  [SMALL_STATE(4010)] = 134794,
  [SMALL_STATE(4011)] = 134887,
  [SMALL_STATE(4012)] = 134980,
  [SMALL_STATE(4013)] = 135073,
  [SMALL_STATE(4014)] = 135166,
  [SMALL_STATE(4015)] = 135259,
  [SMALL_STATE(4016)] = 135352,
  [SMALL_STATE(4017)] = 135445,
  [SMALL_STATE(4018)] = 135538,
  [SMALL_STATE(4019)] = 135601,
  [SMALL_STATE(4020)] = 135694,
  [SMALL_STATE(4021)] = 135787,
  [SMALL_STATE(4022)] = 135880,
  [SMALL_STATE(4023)] = 135973,
  [SMALL_STATE(4024)] = 136066,
  [SMALL_STATE(4025)] = 136159,
  [SMALL_STATE(4026)] = 136252,
  [SMALL_STATE(4027)] = 136345,
  [SMALL_STATE(4028)] = 136438,
  [SMALL_STATE(4029)] = 136531,
  [SMALL_STATE(4030)] = 136624,
  [SMALL_STATE(4031)] = 136717,
  [SMALL_STATE(4032)] = 136810,
  [SMALL_STATE(4033)] = 136903,
  [SMALL_STATE(4034)] = 136996,
  [SMALL_STATE(4035)] = 137089,
  [SMALL_STATE(4036)] = 137182,
  [SMALL_STATE(4037)] = 137275,
  [SMALL_STATE(4038)] = 137368,
  [SMALL_STATE(4039)] = 137461,
  [SMALL_STATE(4040)] = 137554,
  [SMALL_STATE(4041)] = 137647,
  [SMALL_STATE(4042)] = 137740,
  [SMALL_STATE(4043)] = 137833,
  [SMALL_STATE(4044)] = 137926,
  [SMALL_STATE(4045)] = 138019,
  [SMALL_STATE(4046)] = 138112,
  [SMALL_STATE(4047)] = 138205,
  [SMALL_STATE(4048)] = 138298,
  [SMALL_STATE(4049)] = 138391,
  [SMALL_STATE(4050)] = 138484,
  [SMALL_STATE(4051)] = 138577,
  [SMALL_STATE(4052)] = 138670,
  [SMALL_STATE(4053)] = 138763,
  [SMALL_STATE(4054)] = 138856,
  [SMALL_STATE(4055)] = 138949,
  [SMALL_STATE(4056)] = 139042,
  [SMALL_STATE(4057)] = 139135,
  [SMALL_STATE(4058)] = 139228,
  [SMALL_STATE(4059)] = 139321,
  [SMALL_STATE(4060)] = 139414,
  [SMALL_STATE(4061)] = 139507,
  [SMALL_STATE(4062)] = 139588,
  [SMALL_STATE(4063)] = 139681,
  [SMALL_STATE(4064)] = 139774,
  [SMALL_STATE(4065)] = 139867,
  [SMALL_STATE(4066)] = 139960,
  [SMALL_STATE(4067)] = 140053,
  [SMALL_STATE(4068)] = 140146,
  [SMALL_STATE(4069)] = 140239,
  [SMALL_STATE(4070)] = 140332,
  [SMALL_STATE(4071)] = 140425,
  [SMALL_STATE(4072)] = 140518,
  [SMALL_STATE(4073)] = 140611,
  [SMALL_STATE(4074)] = 140704,
  [SMALL_STATE(4075)] = 140797,
  [SMALL_STATE(4076)] = 140890,
  [SMALL_STATE(4077)] = 140946,
  [SMALL_STATE(4078)] = 141002,
  [SMALL_STATE(4079)] = 141058,
  [SMALL_STATE(4080)] = 141114,
  [SMALL_STATE(4081)] = 141170,
  [SMALL_STATE(4082)] = 141226,
  [SMALL_STATE(4083)] = 141282,
  [SMALL_STATE(4084)] = 141338,
  [SMALL_STATE(4085)] = 141394,
  [SMALL_STATE(4086)] = 141450,
  [SMALL_STATE(4087)] = 141506,
  [SMALL_STATE(4088)] = 141562,
  [SMALL_STATE(4089)] = 141618,
  [SMALL_STATE(4090)] = 141674,
  [SMALL_STATE(4091)] = 141730,
  [SMALL_STATE(4092)] = 141788,
  [SMALL_STATE(4093)] = 141846,
  [SMALL_STATE(4094)] = 141902,
  [SMALL_STATE(4095)] = 141958,
  [SMALL_STATE(4096)] = 142014,
  [SMALL_STATE(4097)] = 142070,
  [SMALL_STATE(4098)] = 142126,
  [SMALL_STATE(4099)] = 142182,
  [SMALL_STATE(4100)] = 142238,
  [SMALL_STATE(4101)] = 142294,
  [SMALL_STATE(4102)] = 142358,
  [SMALL_STATE(4103)] = 142414,
  [SMALL_STATE(4104)] = 142470,
  [SMALL_STATE(4105)] = 142526,
  [SMALL_STATE(4106)] = 142584,
  [SMALL_STATE(4107)] = 142640,
  [SMALL_STATE(4108)] = 142696,
  [SMALL_STATE(4109)] = 142752,
  [SMALL_STATE(4110)] = 142808,
  [SMALL_STATE(4111)] = 142864,
  [SMALL_STATE(4112)] = 142920,
  [SMALL_STATE(4113)] = 142976,
  [SMALL_STATE(4114)] = 143032,
  [SMALL_STATE(4115)] = 143088,
  [SMALL_STATE(4116)] = 143146,
  [SMALL_STATE(4117)] = 143204,
  [SMALL_STATE(4118)] = 143260,
  [SMALL_STATE(4119)] = 143316,
  [SMALL_STATE(4120)] = 143372,
  [SMALL_STATE(4121)] = 143428,
  [SMALL_STATE(4122)] = 143486,
  [SMALL_STATE(4123)] = 143542,
  [SMALL_STATE(4124)] = 143598,
  [SMALL_STATE(4125)] = 143654,
  [SMALL_STATE(4126)] = 143710,
  [SMALL_STATE(4127)] = 143766,
  [SMALL_STATE(4128)] = 143822,
  [SMALL_STATE(4129)] = 143878,
  [SMALL_STATE(4130)] = 143934,
  [SMALL_STATE(4131)] = 143990,
  [SMALL_STATE(4132)] = 144046,
  [SMALL_STATE(4133)] = 144102,
  [SMALL_STATE(4134)] = 144158,
  [SMALL_STATE(4135)] = 144222,
  [SMALL_STATE(4136)] = 144278,
  [SMALL_STATE(4137)] = 144333,
  [SMALL_STATE(4138)] = 144388,
  [SMALL_STATE(4139)] = 144443,
  [SMALL_STATE(4140)] = 144498,
  [SMALL_STATE(4141)] = 144553,
  [SMALL_STATE(4142)] = 144608,
  [SMALL_STATE(4143)] = 144663,
  [SMALL_STATE(4144)] = 144718,
  [SMALL_STATE(4145)] = 144773,
  [SMALL_STATE(4146)] = 144828,
  [SMALL_STATE(4147)] = 144885,
  [SMALL_STATE(4148)] = 144942,
  [SMALL_STATE(4149)] = 144997,
  [SMALL_STATE(4150)] = 145052,
  [SMALL_STATE(4151)] = 145107,
  [SMALL_STATE(4152)] = 145162,
  [SMALL_STATE(4153)] = 145217,
  [SMALL_STATE(4154)] = 145272,
  [SMALL_STATE(4155)] = 145327,
  [SMALL_STATE(4156)] = 145382,
  [SMALL_STATE(4157)] = 145437,
  [SMALL_STATE(4158)] = 145494,
  [SMALL_STATE(4159)] = 145557,
  [SMALL_STATE(4160)] = 145612,
  [SMALL_STATE(4161)] = 145667,
  [SMALL_STATE(4162)] = 145722,
  [SMALL_STATE(4163)] = 145777,
  [SMALL_STATE(4164)] = 145832,
  [SMALL_STATE(4165)] = 145887,
  [SMALL_STATE(4166)] = 145942,
  [SMALL_STATE(4167)] = 145999,
  [SMALL_STATE(4168)] = 146054,
  [SMALL_STATE(4169)] = 146111,
  [SMALL_STATE(4170)] = 146166,
  [SMALL_STATE(4171)] = 146223,
  [SMALL_STATE(4172)] = 146278,
  [SMALL_STATE(4173)] = 146333,
  [SMALL_STATE(4174)] = 146388,
  [SMALL_STATE(4175)] = 146443,
  [SMALL_STATE(4176)] = 146498,
  [SMALL_STATE(4177)] = 146555,
  [SMALL_STATE(4178)] = 146612,
  [SMALL_STATE(4179)] = 146667,
  [SMALL_STATE(4180)] = 146724,
  [SMALL_STATE(4181)] = 146781,
  [SMALL_STATE(4182)] = 146836,
  [SMALL_STATE(4183)] = 146891,
  [SMALL_STATE(4184)] = 146946,
  [SMALL_STATE(4185)] = 147001,
  [SMALL_STATE(4186)] = 147056,
  [SMALL_STATE(4187)] = 147111,
  [SMALL_STATE(4188)] = 147168,
  [SMALL_STATE(4189)] = 147223,
  [SMALL_STATE(4190)] = 147280,
  [SMALL_STATE(4191)] = 147335,
  [SMALL_STATE(4192)] = 147390,
  [SMALL_STATE(4193)] = 147447,
  [SMALL_STATE(4194)] = 147502,
  [SMALL_STATE(4195)] = 147557,
  [SMALL_STATE(4196)] = 147612,
  [SMALL_STATE(4197)] = 147667,
  [SMALL_STATE(4198)] = 147722,
  [SMALL_STATE(4199)] = 147779,
  [SMALL_STATE(4200)] = 147834,
  [SMALL_STATE(4201)] = 147889,
  [SMALL_STATE(4202)] = 147946,
  [SMALL_STATE(4203)] = 148001,
  [SMALL_STATE(4204)] = 148056,
  [SMALL_STATE(4205)] = 148113,
  [SMALL_STATE(4206)] = 148168,
  [SMALL_STATE(4207)] = 148223,
  [SMALL_STATE(4208)] = 148280,
  [SMALL_STATE(4209)] = 148335,
  [SMALL_STATE(4210)] = 148390,
  [SMALL_STATE(4211)] = 148445,
  [SMALL_STATE(4212)] = 148500,
  [SMALL_STATE(4213)] = 148555,
  [SMALL_STATE(4214)] = 148616,
  [SMALL_STATE(4215)] = 148671,
  [SMALL_STATE(4216)] = 148728,
  [SMALL_STATE(4217)] = 148782,
  [SMALL_STATE(4218)] = 148838,
  [SMALL_STATE(4219)] = 148892,
  [SMALL_STATE(4220)] = 148946,
  [SMALL_STATE(4221)] = 149000,
  [SMALL_STATE(4222)] = 149054,
  [SMALL_STATE(4223)] = 149108,
  [SMALL_STATE(4224)] = 149162,
  [SMALL_STATE(4225)] = 149216,
  [SMALL_STATE(4226)] = 149270,
  [SMALL_STATE(4227)] = 149324,
  [SMALL_STATE(4228)] = 149380,
  [SMALL_STATE(4229)] = 149436,
  [SMALL_STATE(4230)] = 149490,
  [SMALL_STATE(4231)] = 149544,
  [SMALL_STATE(4232)] = 149598,
  [SMALL_STATE(4233)] = 149652,
  [SMALL_STATE(4234)] = 149706,
  [SMALL_STATE(4235)] = 149760,
  [SMALL_STATE(4236)] = 149814,
  [SMALL_STATE(4237)] = 149868,
  [SMALL_STATE(4238)] = 149930,
  [SMALL_STATE(4239)] = 149992,
  [SMALL_STATE(4240)] = 150046,
  [SMALL_STATE(4241)] = 150100,
  [SMALL_STATE(4242)] = 150154,
  [SMALL_STATE(4243)] = 150210,
  [SMALL_STATE(4244)] = 150264,
  [SMALL_STATE(4245)] = 150318,
  [SMALL_STATE(4246)] = 150372,
  [SMALL_STATE(4247)] = 150428,
  [SMALL_STATE(4248)] = 150482,
  [SMALL_STATE(4249)] = 150536,
  [SMALL_STATE(4250)] = 150590,
  [SMALL_STATE(4251)] = 150644,
  [SMALL_STATE(4252)] = 150698,
  [SMALL_STATE(4253)] = 150752,
  [SMALL_STATE(4254)] = 150806,
  [SMALL_STATE(4255)] = 150860,
  [SMALL_STATE(4256)] = 150914,
  [SMALL_STATE(4257)] = 150968,
  [SMALL_STATE(4258)] = 151022,
  [SMALL_STATE(4259)] = 151076,
  [SMALL_STATE(4260)] = 151130,
  [SMALL_STATE(4261)] = 151184,
  [SMALL_STATE(4262)] = 151238,
  [SMALL_STATE(4263)] = 151292,
  [SMALL_STATE(4264)] = 151346,
  [SMALL_STATE(4265)] = 151402,
  [SMALL_STATE(4266)] = 151456,
  [SMALL_STATE(4267)] = 151512,
  [SMALL_STATE(4268)] = 151566,
  [SMALL_STATE(4269)] = 151620,
  [SMALL_STATE(4270)] = 151682,
  [SMALL_STATE(4271)] = 151736,
  [SMALL_STATE(4272)] = 151790,
  [SMALL_STATE(4273)] = 151846,
  [SMALL_STATE(4274)] = 151900,
  [SMALL_STATE(4275)] = 151954,
  [SMALL_STATE(4276)] = 152008,
  [SMALL_STATE(4277)] = 152062,
  [SMALL_STATE(4278)] = 152122,
  [SMALL_STATE(4279)] = 152176,
  [SMALL_STATE(4280)] = 152230,
  [SMALL_STATE(4281)] = 152286,
  [SMALL_STATE(4282)] = 152342,
  [SMALL_STATE(4283)] = 152396,
  [SMALL_STATE(4284)] = 152452,
  [SMALL_STATE(4285)] = 152506,
  [SMALL_STATE(4286)] = 152560,
  [SMALL_STATE(4287)] = 152614,
  [SMALL_STATE(4288)] = 152668,
  [SMALL_STATE(4289)] = 152722,
  [SMALL_STATE(4290)] = 152778,
  [SMALL_STATE(4291)] = 152832,
  [SMALL_STATE(4292)] = 152886,
  [SMALL_STATE(4293)] = 152940,
  [SMALL_STATE(4294)] = 152994,
  [SMALL_STATE(4295)] = 153050,
  [SMALL_STATE(4296)] = 153104,
  [SMALL_STATE(4297)] = 153164,
  [SMALL_STATE(4298)] = 153218,
  [SMALL_STATE(4299)] = 153272,
  [SMALL_STATE(4300)] = 153326,
  [SMALL_STATE(4301)] = 153380,
  [SMALL_STATE(4302)] = 153434,
  [SMALL_STATE(4303)] = 153488,
  [SMALL_STATE(4304)] = 153542,
  [SMALL_STATE(4305)] = 153604,
  [SMALL_STATE(4306)] = 153658,
  [SMALL_STATE(4307)] = 153712,
  [SMALL_STATE(4308)] = 153766,
  [SMALL_STATE(4309)] = 153820,
  [SMALL_STATE(4310)] = 153874,
  [SMALL_STATE(4311)] = 153928,
  [SMALL_STATE(4312)] = 153982,
  [SMALL_STATE(4313)] = 154036,
  [SMALL_STATE(4314)] = 154090,
  [SMALL_STATE(4315)] = 154144,
  [SMALL_STATE(4316)] = 154204,
  [SMALL_STATE(4317)] = 154258,
  [SMALL_STATE(4318)] = 154312,
  [SMALL_STATE(4319)] = 154366,
  [SMALL_STATE(4320)] = 154420,
  [SMALL_STATE(4321)] = 154474,
  [SMALL_STATE(4322)] = 154528,
  [SMALL_STATE(4323)] = 154582,
  [SMALL_STATE(4324)] = 154636,
  [SMALL_STATE(4325)] = 154690,
  [SMALL_STATE(4326)] = 154744,
  [SMALL_STATE(4327)] = 154798,
  [SMALL_STATE(4328)] = 154852,
  [SMALL_STATE(4329)] = 154906,
  [SMALL_STATE(4330)] = 154960,
  [SMALL_STATE(4331)] = 155014,
  [SMALL_STATE(4332)] = 155068,
  [SMALL_STATE(4333)] = 155122,
  [SMALL_STATE(4334)] = 155176,
  [SMALL_STATE(4335)] = 155230,
  [SMALL_STATE(4336)] = 155284,
  [SMALL_STATE(4337)] = 155338,
  [SMALL_STATE(4338)] = 155392,
  [SMALL_STATE(4339)] = 155446,
  [SMALL_STATE(4340)] = 155500,
  [SMALL_STATE(4341)] = 155554,
  [SMALL_STATE(4342)] = 155608,
  [SMALL_STATE(4343)] = 155664,
  [SMALL_STATE(4344)] = 155722,
  [SMALL_STATE(4345)] = 155776,
  [SMALL_STATE(4346)] = 155830,
  [SMALL_STATE(4347)] = 155892,
  [SMALL_STATE(4348)] = 155946,
  [SMALL_STATE(4349)] = 156000,
  [SMALL_STATE(4350)] = 156054,
  [SMALL_STATE(4351)] = 156110,
  [SMALL_STATE(4352)] = 156164,
  [SMALL_STATE(4353)] = 156217,
  [SMALL_STATE(4354)] = 156270,
  [SMALL_STATE(4355)] = 156323,
  [SMALL_STATE(4356)] = 156378,
  [SMALL_STATE(4357)] = 156433,
  [SMALL_STATE(4358)] = 156486,
  [SMALL_STATE(4359)] = 156539,
  [SMALL_STATE(4360)] = 156592,
  [SMALL_STATE(4361)] = 156645,
  [SMALL_STATE(4362)] = 156698,
  [SMALL_STATE(4363)] = 156751,
  [SMALL_STATE(4364)] = 156804,
  [SMALL_STATE(4365)] = 156857,
  [SMALL_STATE(4366)] = 156910,
  [SMALL_STATE(4367)] = 156963,
  [SMALL_STATE(4368)] = 157022,
  [SMALL_STATE(4369)] = 157075,
  [SMALL_STATE(4370)] = 157128,
  [SMALL_STATE(4371)] = 157181,
  [SMALL_STATE(4372)] = 157234,
  [SMALL_STATE(4373)] = 157287,
  [SMALL_STATE(4374)] = 157348,
  [SMALL_STATE(4375)] = 157401,
  [SMALL_STATE(4376)] = 157456,
  [SMALL_STATE(4377)] = 157509,
  [SMALL_STATE(4378)] = 157562,
  [SMALL_STATE(4379)] = 157615,
  [SMALL_STATE(4380)] = 157668,
  [SMALL_STATE(4381)] = 157721,
  [SMALL_STATE(4382)] = 157774,
  [SMALL_STATE(4383)] = 157827,
  [SMALL_STATE(4384)] = 157880,
  [SMALL_STATE(4385)] = 157933,
  [SMALL_STATE(4386)] = 157986,
  [SMALL_STATE(4387)] = 158039,
  [SMALL_STATE(4388)] = 158092,
  [SMALL_STATE(4389)] = 158145,
  [SMALL_STATE(4390)] = 158198,
  [SMALL_STATE(4391)] = 158251,
  [SMALL_STATE(4392)] = 158304,
  [SMALL_STATE(4393)] = 158357,
  [SMALL_STATE(4394)] = 158410,
  [SMALL_STATE(4395)] = 158463,
  [SMALL_STATE(4396)] = 158516,
  [SMALL_STATE(4397)] = 158569,
  [SMALL_STATE(4398)] = 158622,
  [SMALL_STATE(4399)] = 158675,
  [SMALL_STATE(4400)] = 158736,
  [SMALL_STATE(4401)] = 158789,
  [SMALL_STATE(4402)] = 158842,
  [SMALL_STATE(4403)] = 158895,
  [SMALL_STATE(4404)] = 158948,
  [SMALL_STATE(4405)] = 159001,
  [SMALL_STATE(4406)] = 159054,
  [SMALL_STATE(4407)] = 159107,
  [SMALL_STATE(4408)] = 159160,
  [SMALL_STATE(4409)] = 159213,
  [SMALL_STATE(4410)] = 159266,
  [SMALL_STATE(4411)] = 159319,
  [SMALL_STATE(4412)] = 159372,
  [SMALL_STATE(4413)] = 159425,
  [SMALL_STATE(4414)] = 159478,
  [SMALL_STATE(4415)] = 159531,
  [SMALL_STATE(4416)] = 159584,
  [SMALL_STATE(4417)] = 159641,
  [SMALL_STATE(4418)] = 159694,
  [SMALL_STATE(4419)] = 159747,
  [SMALL_STATE(4420)] = 159800,
  [SMALL_STATE(4421)] = 159853,
  [SMALL_STATE(4422)] = 159906,
  [SMALL_STATE(4423)] = 159959,
  [SMALL_STATE(4424)] = 160012,
  [SMALL_STATE(4425)] = 160065,
  [SMALL_STATE(4426)] = 160118,
  [SMALL_STATE(4427)] = 160171,
  [SMALL_STATE(4428)] = 160224,
  [SMALL_STATE(4429)] = 160277,
  [SMALL_STATE(4430)] = 160330,
  [SMALL_STATE(4431)] = 160385,
  [SMALL_STATE(4432)] = 160438,
  [SMALL_STATE(4433)] = 160491,
  [SMALL_STATE(4434)] = 160544,
  [SMALL_STATE(4435)] = 160597,
  [SMALL_STATE(4436)] = 160654,
  [SMALL_STATE(4437)] = 160709,
  [SMALL_STATE(4438)] = 160764,
  [SMALL_STATE(4439)] = 160817,
  [SMALL_STATE(4440)] = 160870,
  [SMALL_STATE(4441)] = 160927,
  [SMALL_STATE(4442)] = 160980,
  [SMALL_STATE(4443)] = 161033,
  [SMALL_STATE(4444)] = 161086,
  [SMALL_STATE(4445)] = 161139,
  [SMALL_STATE(4446)] = 161192,
  [SMALL_STATE(4447)] = 161245,
  [SMALL_STATE(4448)] = 161298,
  [SMALL_STATE(4449)] = 161351,
  [SMALL_STATE(4450)] = 161404,
  [SMALL_STATE(4451)] = 161457,
  [SMALL_STATE(4452)] = 161510,
  [SMALL_STATE(4453)] = 161563,
  [SMALL_STATE(4454)] = 161616,
  [SMALL_STATE(4455)] = 161669,
  [SMALL_STATE(4456)] = 161726,
  [SMALL_STATE(4457)] = 161787,
  [SMALL_STATE(4458)] = 161840,
  [SMALL_STATE(4459)] = 161893,
  [SMALL_STATE(4460)] = 161946,
  [SMALL_STATE(4461)] = 162005,
  [SMALL_STATE(4462)] = 162060,
  [SMALL_STATE(4463)] = 162115,
  [SMALL_STATE(4464)] = 162168,
  [SMALL_STATE(4465)] = 162221,
  [SMALL_STATE(4466)] = 162276,
  [SMALL_STATE(4467)] = 162329,
  [SMALL_STATE(4468)] = 162390,
  [SMALL_STATE(4469)] = 162445,
  [SMALL_STATE(4470)] = 162500,
  [SMALL_STATE(4471)] = 162553,
  [SMALL_STATE(4472)] = 162608,
  [SMALL_STATE(4473)] = 162661,
  [SMALL_STATE(4474)] = 162714,
  [SMALL_STATE(4475)] = 162767,
  [SMALL_STATE(4476)] = 162828,
  [SMALL_STATE(4477)] = 162881,
  [SMALL_STATE(4478)] = 162934,
  [SMALL_STATE(4479)] = 162987,
  [SMALL_STATE(4480)] = 163040,
  [SMALL_STATE(4481)] = 163095,
  [SMALL_STATE(4482)] = 163150,
  [SMALL_STATE(4483)] = 163203,
  [SMALL_STATE(4484)] = 163258,
  [SMALL_STATE(4485)] = 163313,
  [SMALL_STATE(4486)] = 163366,
  [SMALL_STATE(4487)] = 163419,
  [SMALL_STATE(4488)] = 163472,
  [SMALL_STATE(4489)] = 163525,
  [SMALL_STATE(4490)] = 163578,
  [SMALL_STATE(4491)] = 163631,
  [SMALL_STATE(4492)] = 163684,
  [SMALL_STATE(4493)] = 163737,
  [SMALL_STATE(4494)] = 163790,
  [SMALL_STATE(4495)] = 163843,
  [SMALL_STATE(4496)] = 163896,
  [SMALL_STATE(4497)] = 163949,
  [SMALL_STATE(4498)] = 164010,
  [SMALL_STATE(4499)] = 164063,
  [SMALL_STATE(4500)] = 164115,
  [SMALL_STATE(4501)] = 164167,
  [SMALL_STATE(4502)] = 164219,
  [SMALL_STATE(4503)] = 164271,
  [SMALL_STATE(4504)] = 164323,
  [SMALL_STATE(4505)] = 164375,
  [SMALL_STATE(4506)] = 164431,
  [SMALL_STATE(4507)] = 164483,
  [SMALL_STATE(4508)] = 164537,
  [SMALL_STATE(4509)] = 164589,
  [SMALL_STATE(4510)] = 164645,
  [SMALL_STATE(4511)] = 164697,
  [SMALL_STATE(4512)] = 164749,
  [SMALL_STATE(4513)] = 164801,
  [SMALL_STATE(4514)] = 164857,
  [SMALL_STATE(4515)] = 164909,
  [SMALL_STATE(4516)] = 164961,
  [SMALL_STATE(4517)] = 165013,
  [SMALL_STATE(4518)] = 165065,
  [SMALL_STATE(4519)] = 165117,
  [SMALL_STATE(4520)] = 165175,
  [SMALL_STATE(4521)] = 165227,
  [SMALL_STATE(4522)] = 165279,
  [SMALL_STATE(4523)] = 165331,
  [SMALL_STATE(4524)] = 165383,
  [SMALL_STATE(4525)] = 165435,
  [SMALL_STATE(4526)] = 165487,
  [SMALL_STATE(4527)] = 165539,
  [SMALL_STATE(4528)] = 165591,
  [SMALL_STATE(4529)] = 165643,
  [SMALL_STATE(4530)] = 165697,
  [SMALL_STATE(4531)] = 165749,
  [SMALL_STATE(4532)] = 165801,
  [SMALL_STATE(4533)] = 165853,
  [SMALL_STATE(4534)] = 165905,
  [SMALL_STATE(4535)] = 165957,
  [SMALL_STATE(4536)] = 166009,
  [SMALL_STATE(4537)] = 166061,
  [SMALL_STATE(4538)] = 166113,
  [SMALL_STATE(4539)] = 166167,
  [SMALL_STATE(4540)] = 166219,
  [SMALL_STATE(4541)] = 166273,
  [SMALL_STATE(4542)] = 166325,
  [SMALL_STATE(4543)] = 166377,
  [SMALL_STATE(4544)] = 166431,
  [SMALL_STATE(4545)] = 166485,
  [SMALL_STATE(4546)] = 166537,
  [SMALL_STATE(4547)] = 166591,
  [SMALL_STATE(4548)] = 166643,
  [SMALL_STATE(4549)] = 166695,
  [SMALL_STATE(4550)] = 166749,
  [SMALL_STATE(4551)] = 166801,
  [SMALL_STATE(4552)] = 166853,
  [SMALL_STATE(4553)] = 166905,
  [SMALL_STATE(4554)] = 166957,
  [SMALL_STATE(4555)] = 167009,
  [SMALL_STATE(4556)] = 167061,
  [SMALL_STATE(4557)] = 167113,
  [SMALL_STATE(4558)] = 167167,
  [SMALL_STATE(4559)] = 167219,
  [SMALL_STATE(4560)] = 167271,
  [SMALL_STATE(4561)] = 167327,
  [SMALL_STATE(4562)] = 167381,
  [SMALL_STATE(4563)] = 167433,
  [SMALL_STATE(4564)] = 167491,
  [SMALL_STATE(4565)] = 167545,
  [SMALL_STATE(4566)] = 167603,
  [SMALL_STATE(4567)] = 167655,
  [SMALL_STATE(4568)] = 167707,
  [SMALL_STATE(4569)] = 167759,
  [SMALL_STATE(4570)] = 167811,
  [SMALL_STATE(4571)] = 167867,
  [SMALL_STATE(4572)] = 167921,
  [SMALL_STATE(4573)] = 167975,
  [SMALL_STATE(4574)] = 168035,
  [SMALL_STATE(4575)] = 168087,
  [SMALL_STATE(4576)] = 168139,
  [SMALL_STATE(4577)] = 168191,
  [SMALL_STATE(4578)] = 168243,
  [SMALL_STATE(4579)] = 168299,
  [SMALL_STATE(4580)] = 168351,
  [SMALL_STATE(4581)] = 168405,
  [SMALL_STATE(4582)] = 168457,
  [SMALL_STATE(4583)] = 168509,
  [SMALL_STATE(4584)] = 168561,
  [SMALL_STATE(4585)] = 168613,
  [SMALL_STATE(4586)] = 168665,
  [SMALL_STATE(4587)] = 168717,
  [SMALL_STATE(4588)] = 168769,
  [SMALL_STATE(4589)] = 168823,
  [SMALL_STATE(4590)] = 168875,
  [SMALL_STATE(4591)] = 168927,
  [SMALL_STATE(4592)] = 168981,
  [SMALL_STATE(4593)] = 169035,
  [SMALL_STATE(4594)] = 169087,
  [SMALL_STATE(4595)] = 169139,
  [SMALL_STATE(4596)] = 169191,
  [SMALL_STATE(4597)] = 169243,
  [SMALL_STATE(4598)] = 169295,
  [SMALL_STATE(4599)] = 169347,
  [SMALL_STATE(4600)] = 169401,
  [SMALL_STATE(4601)] = 169455,
  [SMALL_STATE(4602)] = 169509,
  [SMALL_STATE(4603)] = 169563,
  [SMALL_STATE(4604)] = 169617,
  [SMALL_STATE(4605)] = 169669,
  [SMALL_STATE(4606)] = 169723,
  [SMALL_STATE(4607)] = 169775,
  [SMALL_STATE(4608)] = 169827,
  [SMALL_STATE(4609)] = 169881,
  [SMALL_STATE(4610)] = 169933,
  [SMALL_STATE(4611)] = 169985,
  [SMALL_STATE(4612)] = 170037,
  [SMALL_STATE(4613)] = 170089,
  [SMALL_STATE(4614)] = 170141,
  [SMALL_STATE(4615)] = 170193,
  [SMALL_STATE(4616)] = 170245,
  [SMALL_STATE(4617)] = 170297,
  [SMALL_STATE(4618)] = 170349,
  [SMALL_STATE(4619)] = 170403,
  [SMALL_STATE(4620)] = 170455,
  [SMALL_STATE(4621)] = 170507,
  [SMALL_STATE(4622)] = 170559,
  [SMALL_STATE(4623)] = 170611,
  [SMALL_STATE(4624)] = 170663,
  [SMALL_STATE(4625)] = 170721,
  [SMALL_STATE(4626)] = 170773,
  [SMALL_STATE(4627)] = 170825,
  [SMALL_STATE(4628)] = 170877,
  [SMALL_STATE(4629)] = 170929,
  [SMALL_STATE(4630)] = 170983,
  [SMALL_STATE(4631)] = 171035,
  [SMALL_STATE(4632)] = 171087,
  [SMALL_STATE(4633)] = 171141,
  [SMALL_STATE(4634)] = 171193,
  [SMALL_STATE(4635)] = 171247,
  [SMALL_STATE(4636)] = 171299,
  [SMALL_STATE(4637)] = 171351,
  [SMALL_STATE(4638)] = 171405,
  [SMALL_STATE(4639)] = 171457,
  [SMALL_STATE(4640)] = 171509,
  [SMALL_STATE(4641)] = 171563,
  [SMALL_STATE(4642)] = 171617,
  [SMALL_STATE(4643)] = 171669,
  [SMALL_STATE(4644)] = 171723,
  [SMALL_STATE(4645)] = 171777,
  [SMALL_STATE(4646)] = 171829,
  [SMALL_STATE(4647)] = 171881,
  [SMALL_STATE(4648)] = 171933,
  [SMALL_STATE(4649)] = 171987,
  [SMALL_STATE(4650)] = 172041,
  [SMALL_STATE(4651)] = 172093,
  [SMALL_STATE(4652)] = 172147,
  [SMALL_STATE(4653)] = 172201,
  [SMALL_STATE(4654)] = 172253,
  [SMALL_STATE(4655)] = 172313,
  [SMALL_STATE(4656)] = 172365,
  [SMALL_STATE(4657)] = 172419,
  [SMALL_STATE(4658)] = 172471,
  [SMALL_STATE(4659)] = 172523,
  [SMALL_STATE(4660)] = 172575,
  [SMALL_STATE(4661)] = 172627,
  [SMALL_STATE(4662)] = 172679,
  [SMALL_STATE(4663)] = 172731,
  [SMALL_STATE(4664)] = 172783,
  [SMALL_STATE(4665)] = 172835,
  [SMALL_STATE(4666)] = 172891,
  [SMALL_STATE(4667)] = 172943,
  [SMALL_STATE(4668)] = 173001,
  [SMALL_STATE(4669)] = 173053,
  [SMALL_STATE(4670)] = 173105,
  [SMALL_STATE(4671)] = 173157,
  [SMALL_STATE(4672)] = 173209,
  [SMALL_STATE(4673)] = 173263,
  [SMALL_STATE(4674)] = 173315,
  [SMALL_STATE(4675)] = 173367,
  [SMALL_STATE(4676)] = 173419,
  [SMALL_STATE(4677)] = 173473,
  [SMALL_STATE(4678)] = 173525,
  [SMALL_STATE(4679)] = 173579,
  [SMALL_STATE(4680)] = 173633,
  [SMALL_STATE(4681)] = 173691,
  [SMALL_STATE(4682)] = 173743,
  [SMALL_STATE(4683)] = 173795,
  [SMALL_STATE(4684)] = 173847,
  [SMALL_STATE(4685)] = 173899,
  [SMALL_STATE(4686)] = 173951,
  [SMALL_STATE(4687)] = 174003,
  [SMALL_STATE(4688)] = 174055,
  [SMALL_STATE(4689)] = 174107,
  [SMALL_STATE(4690)] = 174159,
  [SMALL_STATE(4691)] = 174213,
  [SMALL_STATE(4692)] = 174265,
  [SMALL_STATE(4693)] = 174317,
  [SMALL_STATE(4694)] = 174369,
  [SMALL_STATE(4695)] = 174423,
  [SMALL_STATE(4696)] = 174477,
  [SMALL_STATE(4697)] = 174529,
  [SMALL_STATE(4698)] = 174581,
  [SMALL_STATE(4699)] = 174633,
  [SMALL_STATE(4700)] = 174691,
  [SMALL_STATE(4701)] = 174745,
  [SMALL_STATE(4702)] = 174797,
  [SMALL_STATE(4703)] = 174849,
  [SMALL_STATE(4704)] = 174903,
  [SMALL_STATE(4705)] = 174955,
  [SMALL_STATE(4706)] = 175009,
  [SMALL_STATE(4707)] = 175061,
  [SMALL_STATE(4708)] = 175113,
  [SMALL_STATE(4709)] = 175164,
  [SMALL_STATE(4710)] = 175215,
  [SMALL_STATE(4711)] = 175266,
  [SMALL_STATE(4712)] = 175317,
  [SMALL_STATE(4713)] = 175368,
  [SMALL_STATE(4714)] = 175419,
  [SMALL_STATE(4715)] = 175470,
  [SMALL_STATE(4716)] = 175521,
  [SMALL_STATE(4717)] = 175572,
  [SMALL_STATE(4718)] = 175623,
  [SMALL_STATE(4719)] = 175674,
  [SMALL_STATE(4720)] = 175725,
  [SMALL_STATE(4721)] = 175782,
  [SMALL_STATE(4722)] = 175833,
  [SMALL_STATE(4723)] = 175884,
  [SMALL_STATE(4724)] = 175935,
  [SMALL_STATE(4725)] = 175986,
  [SMALL_STATE(4726)] = 176039,
  [SMALL_STATE(4727)] = 176090,
  [SMALL_STATE(4728)] = 176141,
  [SMALL_STATE(4729)] = 176192,
  [SMALL_STATE(4730)] = 176243,
  [SMALL_STATE(4731)] = 176294,
  [SMALL_STATE(4732)] = 176345,
  [SMALL_STATE(4733)] = 176396,
  [SMALL_STATE(4734)] = 176453,
  [SMALL_STATE(4735)] = 176508,
  [SMALL_STATE(4736)] = 176559,
  [SMALL_STATE(4737)] = 176614,
  [SMALL_STATE(4738)] = 176665,
  [SMALL_STATE(4739)] = 176718,
  [SMALL_STATE(4740)] = 176769,
  [SMALL_STATE(4741)] = 176820,
  [SMALL_STATE(4742)] = 176871,
  [SMALL_STATE(4743)] = 176922,
  [SMALL_STATE(4744)] = 176973,
  [SMALL_STATE(4745)] = 177024,
  [SMALL_STATE(4746)] = 177075,
  [SMALL_STATE(4747)] = 177126,
  [SMALL_STATE(4748)] = 177177,
  [SMALL_STATE(4749)] = 177228,
  [SMALL_STATE(4750)] = 177279,
  [SMALL_STATE(4751)] = 177330,
  [SMALL_STATE(4752)] = 177381,
  [SMALL_STATE(4753)] = 177432,
  [SMALL_STATE(4754)] = 177483,
  [SMALL_STATE(4755)] = 177534,
  [SMALL_STATE(4756)] = 177585,
  [SMALL_STATE(4757)] = 177636,
  [SMALL_STATE(4758)] = 177687,
  [SMALL_STATE(4759)] = 177738,
  [SMALL_STATE(4760)] = 177789,
  [SMALL_STATE(4761)] = 177840,
  [SMALL_STATE(4762)] = 177891,
  [SMALL_STATE(4763)] = 177942,
  [SMALL_STATE(4764)] = 177993,
  [SMALL_STATE(4765)] = 178044,
  [SMALL_STATE(4766)] = 178095,
  [SMALL_STATE(4767)] = 178146,
  [SMALL_STATE(4768)] = 178197,
  [SMALL_STATE(4769)] = 178248,
  [SMALL_STATE(4770)] = 178299,
  [SMALL_STATE(4771)] = 178350,
  [SMALL_STATE(4772)] = 178401,
  [SMALL_STATE(4773)] = 178452,
  [SMALL_STATE(4774)] = 178503,
  [SMALL_STATE(4775)] = 178554,
  [SMALL_STATE(4776)] = 178605,
  [SMALL_STATE(4777)] = 178656,
  [SMALL_STATE(4778)] = 178707,
  [SMALL_STATE(4779)] = 178758,
  [SMALL_STATE(4780)] = 178809,
  [SMALL_STATE(4781)] = 178862,
  [SMALL_STATE(4782)] = 178913,
  [SMALL_STATE(4783)] = 178966,
  [SMALL_STATE(4784)] = 179017,
  [SMALL_STATE(4785)] = 179070,
  [SMALL_STATE(4786)] = 179125,
  [SMALL_STATE(4787)] = 179178,
  [SMALL_STATE(4788)] = 179229,
  [SMALL_STATE(4789)] = 179282,
  [SMALL_STATE(4790)] = 179333,
  [SMALL_STATE(4791)] = 179386,
  [SMALL_STATE(4792)] = 179443,
  [SMALL_STATE(4793)] = 179494,
  [SMALL_STATE(4794)] = 179545,
  [SMALL_STATE(4795)] = 179600,
  [SMALL_STATE(4796)] = 179651,
  [SMALL_STATE(4797)] = 179702,
  [SMALL_STATE(4798)] = 179753,
  [SMALL_STATE(4799)] = 179804,
  [SMALL_STATE(4800)] = 179855,
  [SMALL_STATE(4801)] = 179906,
  [SMALL_STATE(4802)] = 179957,
  [SMALL_STATE(4803)] = 180008,
  [SMALL_STATE(4804)] = 180059,
  [SMALL_STATE(4805)] = 180110,
  [SMALL_STATE(4806)] = 180161,
  [SMALL_STATE(4807)] = 180212,
  [SMALL_STATE(4808)] = 180263,
  [SMALL_STATE(4809)] = 180314,
  [SMALL_STATE(4810)] = 180365,
  [SMALL_STATE(4811)] = 180416,
  [SMALL_STATE(4812)] = 180467,
  [SMALL_STATE(4813)] = 180518,
  [SMALL_STATE(4814)] = 180569,
  [SMALL_STATE(4815)] = 180620,
  [SMALL_STATE(4816)] = 180671,
  [SMALL_STATE(4817)] = 180722,
  [SMALL_STATE(4818)] = 180773,
  [SMALL_STATE(4819)] = 180824,
  [SMALL_STATE(4820)] = 180875,
  [SMALL_STATE(4821)] = 180926,
  [SMALL_STATE(4822)] = 180977,
  [SMALL_STATE(4823)] = 181028,
  [SMALL_STATE(4824)] = 181079,
  [SMALL_STATE(4825)] = 181130,
  [SMALL_STATE(4826)] = 181181,
  [SMALL_STATE(4827)] = 181232,
  [SMALL_STATE(4828)] = 181283,
  [SMALL_STATE(4829)] = 181334,
  [SMALL_STATE(4830)] = 181385,
  [SMALL_STATE(4831)] = 181436,
  [SMALL_STATE(4832)] = 181489,
  [SMALL_STATE(4833)] = 181540,
  [SMALL_STATE(4834)] = 181591,
  [SMALL_STATE(4835)] = 181642,
  [SMALL_STATE(4836)] = 181693,
  [SMALL_STATE(4837)] = 181744,
  [SMALL_STATE(4838)] = 181795,
  [SMALL_STATE(4839)] = 181846,
  [SMALL_STATE(4840)] = 181897,
  [SMALL_STATE(4841)] = 181948,
  [SMALL_STATE(4842)] = 181999,
  [SMALL_STATE(4843)] = 182050,
  [SMALL_STATE(4844)] = 182101,
  [SMALL_STATE(4845)] = 182154,
  [SMALL_STATE(4846)] = 182205,
  [SMALL_STATE(4847)] = 182256,
  [SMALL_STATE(4848)] = 182307,
  [SMALL_STATE(4849)] = 182358,
  [SMALL_STATE(4850)] = 182409,
  [SMALL_STATE(4851)] = 182460,
  [SMALL_STATE(4852)] = 182511,
  [SMALL_STATE(4853)] = 182562,
  [SMALL_STATE(4854)] = 182613,
  [SMALL_STATE(4855)] = 182664,
  [SMALL_STATE(4856)] = 182715,
  [SMALL_STATE(4857)] = 182766,
  [SMALL_STATE(4858)] = 182817,
  [SMALL_STATE(4859)] = 182868,
  [SMALL_STATE(4860)] = 182919,
  [SMALL_STATE(4861)] = 182970,
  [SMALL_STATE(4862)] = 183021,
  [SMALL_STATE(4863)] = 183072,
  [SMALL_STATE(4864)] = 183123,
  [SMALL_STATE(4865)] = 183178,
  [SMALL_STATE(4866)] = 183229,
  [SMALL_STATE(4867)] = 183286,
  [SMALL_STATE(4868)] = 183337,
  [SMALL_STATE(4869)] = 183388,
  [SMALL_STATE(4870)] = 183439,
  [SMALL_STATE(4871)] = 183490,
  [SMALL_STATE(4872)] = 183541,
  [SMALL_STATE(4873)] = 183592,
  [SMALL_STATE(4874)] = 183647,
  [SMALL_STATE(4875)] = 183700,
  [SMALL_STATE(4876)] = 183755,
  [SMALL_STATE(4877)] = 183810,
  [SMALL_STATE(4878)] = 183861,
  [SMALL_STATE(4879)] = 183912,
  [SMALL_STATE(4880)] = 183965,
  [SMALL_STATE(4881)] = 184016,
  [SMALL_STATE(4882)] = 184067,
  [SMALL_STATE(4883)] = 184124,
  [SMALL_STATE(4884)] = 184175,
  [SMALL_STATE(4885)] = 184226,
  [SMALL_STATE(4886)] = 184277,
  [SMALL_STATE(4887)] = 184328,
  [SMALL_STATE(4888)] = 184379,
  [SMALL_STATE(4889)] = 184430,
  [SMALL_STATE(4890)] = 184481,
  [SMALL_STATE(4891)] = 184532,
  [SMALL_STATE(4892)] = 184583,
  [SMALL_STATE(4893)] = 184634,
  [SMALL_STATE(4894)] = 184685,
  [SMALL_STATE(4895)] = 184736,
  [SMALL_STATE(4896)] = 184787,
  [SMALL_STATE(4897)] = 184838,
  [SMALL_STATE(4898)] = 184889,
  [SMALL_STATE(4899)] = 184942,
  [SMALL_STATE(4900)] = 184995,
  [SMALL_STATE(4901)] = 185046,
  [SMALL_STATE(4902)] = 185097,
  [SMALL_STATE(4903)] = 185148,
  [SMALL_STATE(4904)] = 185199,
  [SMALL_STATE(4905)] = 185250,
  [SMALL_STATE(4906)] = 185301,
  [SMALL_STATE(4907)] = 185352,
  [SMALL_STATE(4908)] = 185403,
  [SMALL_STATE(4909)] = 185454,
  [SMALL_STATE(4910)] = 185505,
  [SMALL_STATE(4911)] = 185556,
  [SMALL_STATE(4912)] = 185607,
  [SMALL_STATE(4913)] = 185658,
  [SMALL_STATE(4914)] = 185709,
  [SMALL_STATE(4915)] = 185760,
  [SMALL_STATE(4916)] = 185811,
  [SMALL_STATE(4917)] = 185862,
  [SMALL_STATE(4918)] = 185913,
  [SMALL_STATE(4919)] = 185964,
  [SMALL_STATE(4920)] = 186015,
  [SMALL_STATE(4921)] = 186066,
  [SMALL_STATE(4922)] = 186117,
  [SMALL_STATE(4923)] = 186168,
  [SMALL_STATE(4924)] = 186221,
  [SMALL_STATE(4925)] = 186272,
  [SMALL_STATE(4926)] = 186325,
  [SMALL_STATE(4927)] = 186376,
  [SMALL_STATE(4928)] = 186429,
  [SMALL_STATE(4929)] = 186486,
  [SMALL_STATE(4930)] = 186537,
  [SMALL_STATE(4931)] = 186590,
  [SMALL_STATE(4932)] = 186641,
  [SMALL_STATE(4933)] = 186692,
  [SMALL_STATE(4934)] = 186745,
  [SMALL_STATE(4935)] = 186796,
  [SMALL_STATE(4936)] = 186847,
  [SMALL_STATE(4937)] = 186898,
  [SMALL_STATE(4938)] = 186951,
  [SMALL_STATE(4939)] = 187002,
  [SMALL_STATE(4940)] = 187053,
  [SMALL_STATE(4941)] = 187104,
  [SMALL_STATE(4942)] = 187155,
  [SMALL_STATE(4943)] = 187206,
  [SMALL_STATE(4944)] = 187257,
  [SMALL_STATE(4945)] = 187308,
  [SMALL_STATE(4946)] = 187359,
  [SMALL_STATE(4947)] = 187410,
  [SMALL_STATE(4948)] = 187461,
  [SMALL_STATE(4949)] = 187514,
  [SMALL_STATE(4950)] = 187565,
  [SMALL_STATE(4951)] = 187616,
  [SMALL_STATE(4952)] = 187667,
  [SMALL_STATE(4953)] = 187718,
  [SMALL_STATE(4954)] = 187769,
  [SMALL_STATE(4955)] = 187820,
  [SMALL_STATE(4956)] = 187871,
  [SMALL_STATE(4957)] = 187922,
  [SMALL_STATE(4958)] = 187973,
  [SMALL_STATE(4959)] = 188024,
  [SMALL_STATE(4960)] = 188075,
  [SMALL_STATE(4961)] = 188126,
  [SMALL_STATE(4962)] = 188177,
  [SMALL_STATE(4963)] = 188228,
  [SMALL_STATE(4964)] = 188279,
  [SMALL_STATE(4965)] = 188330,
  [SMALL_STATE(4966)] = 188381,
  [SMALL_STATE(4967)] = 188436,
  [SMALL_STATE(4968)] = 188487,
  [SMALL_STATE(4969)] = 188538,
  [SMALL_STATE(4970)] = 188589,
  [SMALL_STATE(4971)] = 188640,
  [SMALL_STATE(4972)] = 188691,
  [SMALL_STATE(4973)] = 188742,
  [SMALL_STATE(4974)] = 188793,
  [SMALL_STATE(4975)] = 188844,
  [SMALL_STATE(4976)] = 188895,
  [SMALL_STATE(4977)] = 188946,
  [SMALL_STATE(4978)] = 188997,
  [SMALL_STATE(4979)] = 189048,
  [SMALL_STATE(4980)] = 189101,
  [SMALL_STATE(4981)] = 189152,
  [SMALL_STATE(4982)] = 189203,
  [SMALL_STATE(4983)] = 189254,
  [SMALL_STATE(4984)] = 189305,
  [SMALL_STATE(4985)] = 189356,
  [SMALL_STATE(4986)] = 189407,
  [SMALL_STATE(4987)] = 189458,
  [SMALL_STATE(4988)] = 189509,
  [SMALL_STATE(4989)] = 189560,
  [SMALL_STATE(4990)] = 189611,
  [SMALL_STATE(4991)] = 189662,
  [SMALL_STATE(4992)] = 189713,
  [SMALL_STATE(4993)] = 189766,
  [SMALL_STATE(4994)] = 189817,
  [SMALL_STATE(4995)] = 189868,
  [SMALL_STATE(4996)] = 189923,
  [SMALL_STATE(4997)] = 189974,
  [SMALL_STATE(4998)] = 190025,
  [SMALL_STATE(4999)] = 190076,
  [SMALL_STATE(5000)] = 190127,
  [SMALL_STATE(5001)] = 190178,
  [SMALL_STATE(5002)] = 190229,
  [SMALL_STATE(5003)] = 190280,
  [SMALL_STATE(5004)] = 190337,
  [SMALL_STATE(5005)] = 190388,
  [SMALL_STATE(5006)] = 190439,
  [SMALL_STATE(5007)] = 190494,
  [SMALL_STATE(5008)] = 190545,
  [SMALL_STATE(5009)] = 190600,
  [SMALL_STATE(5010)] = 190651,
  [SMALL_STATE(5011)] = 190702,
  [SMALL_STATE(5012)] = 190753,
  [SMALL_STATE(5013)] = 190804,
  [SMALL_STATE(5014)] = 190855,
  [SMALL_STATE(5015)] = 190906,
  [SMALL_STATE(5016)] = 190957,
  [SMALL_STATE(5017)] = 191010,
  [SMALL_STATE(5018)] = 191061,
  [SMALL_STATE(5019)] = 191112,
  [SMALL_STATE(5020)] = 191163,
  [SMALL_STATE(5021)] = 191216,
  [SMALL_STATE(5022)] = 191267,
  [SMALL_STATE(5023)] = 191318,
  [SMALL_STATE(5024)] = 191369,
  [SMALL_STATE(5025)] = 191420,
  [SMALL_STATE(5026)] = 191471,
  [SMALL_STATE(5027)] = 191522,
  [SMALL_STATE(5028)] = 191573,
  [SMALL_STATE(5029)] = 191624,
  [SMALL_STATE(5030)] = 191679,
  [SMALL_STATE(5031)] = 191730,
  [SMALL_STATE(5032)] = 191781,
  [SMALL_STATE(5033)] = 191832,
  [SMALL_STATE(5034)] = 191883,
  [SMALL_STATE(5035)] = 191934,
  [SMALL_STATE(5036)] = 191985,
  [SMALL_STATE(5037)] = 192036,
  [SMALL_STATE(5038)] = 192087,
  [SMALL_STATE(5039)] = 192140,
  [SMALL_STATE(5040)] = 192191,
  [SMALL_STATE(5041)] = 192242,
  [SMALL_STATE(5042)] = 192293,
  [SMALL_STATE(5043)] = 192344,
  [SMALL_STATE(5044)] = 192395,
  [SMALL_STATE(5045)] = 192446,
  [SMALL_STATE(5046)] = 192497,
  [SMALL_STATE(5047)] = 192548,
  [SMALL_STATE(5048)] = 192599,
  [SMALL_STATE(5049)] = 192656,
  [SMALL_STATE(5050)] = 192709,
  [SMALL_STATE(5051)] = 192760,
  [SMALL_STATE(5052)] = 192811,
  [SMALL_STATE(5053)] = 192862,
  [SMALL_STATE(5054)] = 192921,
  [SMALL_STATE(5055)] = 192972,
  [SMALL_STATE(5056)] = 193023,
  [SMALL_STATE(5057)] = 193074,
  [SMALL_STATE(5058)] = 193125,
  [SMALL_STATE(5059)] = 193176,
  [SMALL_STATE(5060)] = 193227,
  [SMALL_STATE(5061)] = 193280,
  [SMALL_STATE(5062)] = 193331,
  [SMALL_STATE(5063)] = 193384,
  [SMALL_STATE(5064)] = 193435,
  [SMALL_STATE(5065)] = 193486,
  [SMALL_STATE(5066)] = 193537,
  [SMALL_STATE(5067)] = 193588,
  [SMALL_STATE(5068)] = 193641,
  [SMALL_STATE(5069)] = 193692,
  [SMALL_STATE(5070)] = 193743,
  [SMALL_STATE(5071)] = 193794,
  [SMALL_STATE(5072)] = 193847,
  [SMALL_STATE(5073)] = 193898,
  [SMALL_STATE(5074)] = 193953,
  [SMALL_STATE(5075)] = 194004,
  [SMALL_STATE(5076)] = 194055,
  [SMALL_STATE(5077)] = 194106,
  [SMALL_STATE(5078)] = 194157,
  [SMALL_STATE(5079)] = 194208,
  [SMALL_STATE(5080)] = 194259,
  [SMALL_STATE(5081)] = 194310,
  [SMALL_STATE(5082)] = 194361,
  [SMALL_STATE(5083)] = 194412,
  [SMALL_STATE(5084)] = 194463,
  [SMALL_STATE(5085)] = 194514,
  [SMALL_STATE(5086)] = 194565,
  [SMALL_STATE(5087)] = 194616,
  [SMALL_STATE(5088)] = 194667,
  [SMALL_STATE(5089)] = 194718,
  [SMALL_STATE(5090)] = 194769,
  [SMALL_STATE(5091)] = 194820,
  [SMALL_STATE(5092)] = 194871,
  [SMALL_STATE(5093)] = 194922,
  [SMALL_STATE(5094)] = 194973,
  [SMALL_STATE(5095)] = 195024,
  [SMALL_STATE(5096)] = 195075,
  [SMALL_STATE(5097)] = 195126,
  [SMALL_STATE(5098)] = 195179,
  [SMALL_STATE(5099)] = 195230,
  [SMALL_STATE(5100)] = 195281,
  [SMALL_STATE(5101)] = 195332,
  [SMALL_STATE(5102)] = 195383,
  [SMALL_STATE(5103)] = 195434,
  [SMALL_STATE(5104)] = 195485,
  [SMALL_STATE(5105)] = 195536,
  [SMALL_STATE(5106)] = 195587,
  [SMALL_STATE(5107)] = 195638,
  [SMALL_STATE(5108)] = 195689,
  [SMALL_STATE(5109)] = 195740,
  [SMALL_STATE(5110)] = 195791,
  [SMALL_STATE(5111)] = 195842,
  [SMALL_STATE(5112)] = 195893,
  [SMALL_STATE(5113)] = 195944,
  [SMALL_STATE(5114)] = 195995,
  [SMALL_STATE(5115)] = 196046,
  [SMALL_STATE(5116)] = 196097,
  [SMALL_STATE(5117)] = 196148,
  [SMALL_STATE(5118)] = 196199,
  [SMALL_STATE(5119)] = 196250,
  [SMALL_STATE(5120)] = 196301,
  [SMALL_STATE(5121)] = 196352,
  [SMALL_STATE(5122)] = 196403,
  [SMALL_STATE(5123)] = 196454,
  [SMALL_STATE(5124)] = 196505,
  [SMALL_STATE(5125)] = 196556,
  [SMALL_STATE(5126)] = 196607,
  [SMALL_STATE(5127)] = 196658,
  [SMALL_STATE(5128)] = 196709,
  [SMALL_STATE(5129)] = 196760,
  [SMALL_STATE(5130)] = 196811,
  [SMALL_STATE(5131)] = 196862,
  [SMALL_STATE(5132)] = 196913,
  [SMALL_STATE(5133)] = 196964,
  [SMALL_STATE(5134)] = 197015,
  [SMALL_STATE(5135)] = 197066,
  [SMALL_STATE(5136)] = 197117,
  [SMALL_STATE(5137)] = 197168,
  [SMALL_STATE(5138)] = 197219,
  [SMALL_STATE(5139)] = 197270,
  [SMALL_STATE(5140)] = 197321,
  [SMALL_STATE(5141)] = 197372,
  [SMALL_STATE(5142)] = 197423,
  [SMALL_STATE(5143)] = 197474,
  [SMALL_STATE(5144)] = 197525,
  [SMALL_STATE(5145)] = 197576,
  [SMALL_STATE(5146)] = 197627,
  [SMALL_STATE(5147)] = 197678,
  [SMALL_STATE(5148)] = 197729,
  [SMALL_STATE(5149)] = 197780,
  [SMALL_STATE(5150)] = 197831,
  [SMALL_STATE(5151)] = 197882,
  [SMALL_STATE(5152)] = 197933,
  [SMALL_STATE(5153)] = 197984,
  [SMALL_STATE(5154)] = 198035,
  [SMALL_STATE(5155)] = 198088,
  [SMALL_STATE(5156)] = 198141,
  [SMALL_STATE(5157)] = 198192,
  [SMALL_STATE(5158)] = 198243,
  [SMALL_STATE(5159)] = 198294,
  [SMALL_STATE(5160)] = 198345,
  [SMALL_STATE(5161)] = 198396,
  [SMALL_STATE(5162)] = 198447,
  [SMALL_STATE(5163)] = 198498,
  [SMALL_STATE(5164)] = 198549,
  [SMALL_STATE(5165)] = 198600,
  [SMALL_STATE(5166)] = 198651,
  [SMALL_STATE(5167)] = 198702,
  [SMALL_STATE(5168)] = 198753,
  [SMALL_STATE(5169)] = 198804,
  [SMALL_STATE(5170)] = 198855,
  [SMALL_STATE(5171)] = 198906,
  [SMALL_STATE(5172)] = 198957,
  [SMALL_STATE(5173)] = 199008,
  [SMALL_STATE(5174)] = 199059,
  [SMALL_STATE(5175)] = 199110,
  [SMALL_STATE(5176)] = 199167,
  [SMALL_STATE(5177)] = 199218,
  [SMALL_STATE(5178)] = 199271,
  [SMALL_STATE(5179)] = 199322,
  [SMALL_STATE(5180)] = 199373,
  [SMALL_STATE(5181)] = 199424,
  [SMALL_STATE(5182)] = 199475,
  [SMALL_STATE(5183)] = 199526,
  [SMALL_STATE(5184)] = 199579,
  [SMALL_STATE(5185)] = 199630,
  [SMALL_STATE(5186)] = 199681,
  [SMALL_STATE(5187)] = 199732,
  [SMALL_STATE(5188)] = 199783,
  [SMALL_STATE(5189)] = 199838,
  [SMALL_STATE(5190)] = 199889,
  [SMALL_STATE(5191)] = 199940,
  [SMALL_STATE(5192)] = 199991,
  [SMALL_STATE(5193)] = 200042,
  [SMALL_STATE(5194)] = 200093,
  [SMALL_STATE(5195)] = 200144,
  [SMALL_STATE(5196)] = 200195,
  [SMALL_STATE(5197)] = 200246,
  [SMALL_STATE(5198)] = 200297,
  [SMALL_STATE(5199)] = 200348,
  [SMALL_STATE(5200)] = 200399,
  [SMALL_STATE(5201)] = 200450,
  [SMALL_STATE(5202)] = 200501,
  [SMALL_STATE(5203)] = 200552,
  [SMALL_STATE(5204)] = 200603,
  [SMALL_STATE(5205)] = 200654,
  [SMALL_STATE(5206)] = 200705,
  [SMALL_STATE(5207)] = 200756,
  [SMALL_STATE(5208)] = 200807,
  [SMALL_STATE(5209)] = 200858,
  [SMALL_STATE(5210)] = 200909,
  [SMALL_STATE(5211)] = 200960,
  [SMALL_STATE(5212)] = 201011,
  [SMALL_STATE(5213)] = 201062,
  [SMALL_STATE(5214)] = 201113,
  [SMALL_STATE(5215)] = 201164,
  [SMALL_STATE(5216)] = 201215,
  [SMALL_STATE(5217)] = 201266,
  [SMALL_STATE(5218)] = 201317,
  [SMALL_STATE(5219)] = 201368,
  [SMALL_STATE(5220)] = 201419,
  [SMALL_STATE(5221)] = 201472,
  [SMALL_STATE(5222)] = 201523,
  [SMALL_STATE(5223)] = 201574,
  [SMALL_STATE(5224)] = 201625,
  [SMALL_STATE(5225)] = 201678,
  [SMALL_STATE(5226)] = 201729,
  [SMALL_STATE(5227)] = 201782,
  [SMALL_STATE(5228)] = 201833,
  [SMALL_STATE(5229)] = 201884,
  [SMALL_STATE(5230)] = 201935,
  [SMALL_STATE(5231)] = 201990,
  [SMALL_STATE(5232)] = 202043,
  [SMALL_STATE(5233)] = 202094,
  [SMALL_STATE(5234)] = 202145,
  [SMALL_STATE(5235)] = 202196,
  [SMALL_STATE(5236)] = 202247,
  [SMALL_STATE(5237)] = 202298,
  [SMALL_STATE(5238)] = 202349,
  [SMALL_STATE(5239)] = 202402,
  [SMALL_STATE(5240)] = 202453,
  [SMALL_STATE(5241)] = 202508,
  [SMALL_STATE(5242)] = 202561,
  [SMALL_STATE(5243)] = 202618,
  [SMALL_STATE(5244)] = 202671,
  [SMALL_STATE(5245)] = 202722,
  [SMALL_STATE(5246)] = 202779,
  [SMALL_STATE(5247)] = 202830,
  [SMALL_STATE(5248)] = 202883,
  [SMALL_STATE(5249)] = 202934,
  [SMALL_STATE(5250)] = 202985,
  [SMALL_STATE(5251)] = 203036,
  [SMALL_STATE(5252)] = 203087,
  [SMALL_STATE(5253)] = 203138,
  [SMALL_STATE(5254)] = 203189,
  [SMALL_STATE(5255)] = 203240,
  [SMALL_STATE(5256)] = 203291,
  [SMALL_STATE(5257)] = 203342,
  [SMALL_STATE(5258)] = 203393,
  [SMALL_STATE(5259)] = 203444,
  [SMALL_STATE(5260)] = 203495,
  [SMALL_STATE(5261)] = 203548,
  [SMALL_STATE(5262)] = 203599,
  [SMALL_STATE(5263)] = 203650,
  [SMALL_STATE(5264)] = 203701,
  [SMALL_STATE(5265)] = 203752,
  [SMALL_STATE(5266)] = 203802,
  [SMALL_STATE(5267)] = 203854,
  [SMALL_STATE(5268)] = 203904,
  [SMALL_STATE(5269)] = 203954,
  [SMALL_STATE(5270)] = 204004,
  [SMALL_STATE(5271)] = 204054,
  [SMALL_STATE(5272)] = 204104,
  [SMALL_STATE(5273)] = 204154,
  [SMALL_STATE(5274)] = 204204,
  [SMALL_STATE(5275)] = 204254,
  [SMALL_STATE(5276)] = 204304,
  [SMALL_STATE(5277)] = 204358,
  [SMALL_STATE(5278)] = 204408,
  [SMALL_STATE(5279)] = 204458,
  [SMALL_STATE(5280)] = 204508,
  [SMALL_STATE(5281)] = 204558,
  [SMALL_STATE(5282)] = 204608,
  [SMALL_STATE(5283)] = 204658,
  [SMALL_STATE(5284)] = 204708,
  [SMALL_STATE(5285)] = 204760,
  [SMALL_STATE(5286)] = 204810,
  [SMALL_STATE(5287)] = 204860,
  [SMALL_STATE(5288)] = 204910,
  [SMALL_STATE(5289)] = 204960,
  [SMALL_STATE(5290)] = 205010,
  [SMALL_STATE(5291)] = 205060,
  [SMALL_STATE(5292)] = 205110,
  [SMALL_STATE(5293)] = 205160,
  [SMALL_STATE(5294)] = 205210,
  [SMALL_STATE(5295)] = 205260,
  [SMALL_STATE(5296)] = 205310,
  [SMALL_STATE(5297)] = 205360,
  [SMALL_STATE(5298)] = 205410,
  [SMALL_STATE(5299)] = 205460,
  [SMALL_STATE(5300)] = 205510,
  [SMALL_STATE(5301)] = 205560,
  [SMALL_STATE(5302)] = 205610,
  [SMALL_STATE(5303)] = 205660,
  [SMALL_STATE(5304)] = 205710,
  [SMALL_STATE(5305)] = 205760,
  [SMALL_STATE(5306)] = 205810,
  [SMALL_STATE(5307)] = 205860,
  [SMALL_STATE(5308)] = 205910,
  [SMALL_STATE(5309)] = 205960,
  [SMALL_STATE(5310)] = 206010,
  [SMALL_STATE(5311)] = 206060,
  [SMALL_STATE(5312)] = 206110,
  [SMALL_STATE(5313)] = 206160,
  [SMALL_STATE(5314)] = 206212,
  [SMALL_STATE(5315)] = 206264,
  [SMALL_STATE(5316)] = 206318,
  [SMALL_STATE(5317)] = 206368,
  [SMALL_STATE(5318)] = 206418,
  [SMALL_STATE(5319)] = 206468,
  [SMALL_STATE(5320)] = 206522,
  [SMALL_STATE(5321)] = 206572,
  [SMALL_STATE(5322)] = 206622,
  [SMALL_STATE(5323)] = 206672,
  [SMALL_STATE(5324)] = 206722,
  [SMALL_STATE(5325)] = 206772,
  [SMALL_STATE(5326)] = 206822,
  [SMALL_STATE(5327)] = 206872,
  [SMALL_STATE(5328)] = 206922,
  [SMALL_STATE(5329)] = 206972,
  [SMALL_STATE(5330)] = 207022,
  [SMALL_STATE(5331)] = 207072,
  [SMALL_STATE(5332)] = 207122,
  [SMALL_STATE(5333)] = 207172,
  [SMALL_STATE(5334)] = 207222,
  [SMALL_STATE(5335)] = 207272,
  [SMALL_STATE(5336)] = 207322,
  [SMALL_STATE(5337)] = 207372,
  [SMALL_STATE(5338)] = 207422,
  [SMALL_STATE(5339)] = 207472,
  [SMALL_STATE(5340)] = 207524,
  [SMALL_STATE(5341)] = 207574,
  [SMALL_STATE(5342)] = 207626,
  [SMALL_STATE(5343)] = 207676,
  [SMALL_STATE(5344)] = 207726,
  [SMALL_STATE(5345)] = 207780,
  [SMALL_STATE(5346)] = 207830,
  [SMALL_STATE(5347)] = 207880,
  [SMALL_STATE(5348)] = 207930,
  [SMALL_STATE(5349)] = 207980,
  [SMALL_STATE(5350)] = 208030,
  [SMALL_STATE(5351)] = 208080,
  [SMALL_STATE(5352)] = 208130,
  [SMALL_STATE(5353)] = 208180,
  [SMALL_STATE(5354)] = 208230,
  [SMALL_STATE(5355)] = 208280,
  [SMALL_STATE(5356)] = 208330,
  [SMALL_STATE(5357)] = 208380,
  [SMALL_STATE(5358)] = 208430,
  [SMALL_STATE(5359)] = 208480,
  [SMALL_STATE(5360)] = 208530,
  [SMALL_STATE(5361)] = 208580,
  [SMALL_STATE(5362)] = 208630,
  [SMALL_STATE(5363)] = 208680,
  [SMALL_STATE(5364)] = 208730,
  [SMALL_STATE(5365)] = 208780,
  [SMALL_STATE(5366)] = 208830,
  [SMALL_STATE(5367)] = 208880,
  [SMALL_STATE(5368)] = 208930,
  [SMALL_STATE(5369)] = 208980,
  [SMALL_STATE(5370)] = 209030,
  [SMALL_STATE(5371)] = 209080,
  [SMALL_STATE(5372)] = 209130,
  [SMALL_STATE(5373)] = 209180,
  [SMALL_STATE(5374)] = 209232,
  [SMALL_STATE(5375)] = 209282,
  [SMALL_STATE(5376)] = 209332,
  [SMALL_STATE(5377)] = 209382,
  [SMALL_STATE(5378)] = 209432,
  [SMALL_STATE(5379)] = 209482,
  [SMALL_STATE(5380)] = 209532,
  [SMALL_STATE(5381)] = 209582,
  [SMALL_STATE(5382)] = 209632,
  [SMALL_STATE(5383)] = 209684,
  [SMALL_STATE(5384)] = 209734,
  [SMALL_STATE(5385)] = 209784,
  [SMALL_STATE(5386)] = 209834,
  [SMALL_STATE(5387)] = 209884,
  [SMALL_STATE(5388)] = 209934,
  [SMALL_STATE(5389)] = 209984,
  [SMALL_STATE(5390)] = 210034,
  [SMALL_STATE(5391)] = 210084,
  [SMALL_STATE(5392)] = 210134,
  [SMALL_STATE(5393)] = 210184,
  [SMALL_STATE(5394)] = 210234,
  [SMALL_STATE(5395)] = 210284,
  [SMALL_STATE(5396)] = 210334,
  [SMALL_STATE(5397)] = 210384,
  [SMALL_STATE(5398)] = 210434,
  [SMALL_STATE(5399)] = 210484,
  [SMALL_STATE(5400)] = 210534,
  [SMALL_STATE(5401)] = 210584,
  [SMALL_STATE(5402)] = 210634,
  [SMALL_STATE(5403)] = 210686,
  [SMALL_STATE(5404)] = 210736,
  [SMALL_STATE(5405)] = 210790,
  [SMALL_STATE(5406)] = 210840,
  [SMALL_STATE(5407)] = 210890,
  [SMALL_STATE(5408)] = 210940,
  [SMALL_STATE(5409)] = 210990,
  [SMALL_STATE(5410)] = 211040,
  [SMALL_STATE(5411)] = 211092,
  [SMALL_STATE(5412)] = 211144,
  [SMALL_STATE(5413)] = 211194,
  [SMALL_STATE(5414)] = 211244,
  [SMALL_STATE(5415)] = 211294,
  [SMALL_STATE(5416)] = 211344,
  [SMALL_STATE(5417)] = 211394,
  [SMALL_STATE(5418)] = 211444,
  [SMALL_STATE(5419)] = 211494,
  [SMALL_STATE(5420)] = 211544,
  [SMALL_STATE(5421)] = 211594,
  [SMALL_STATE(5422)] = 211644,
  [SMALL_STATE(5423)] = 211694,
  [SMALL_STATE(5424)] = 211744,
  [SMALL_STATE(5425)] = 211794,
  [SMALL_STATE(5426)] = 211844,
  [SMALL_STATE(5427)] = 211894,
  [SMALL_STATE(5428)] = 211944,
  [SMALL_STATE(5429)] = 211994,
  [SMALL_STATE(5430)] = 212044,
  [SMALL_STATE(5431)] = 212094,
  [SMALL_STATE(5432)] = 212144,
  [SMALL_STATE(5433)] = 212194,
  [SMALL_STATE(5434)] = 212244,
  [SMALL_STATE(5435)] = 212294,
  [SMALL_STATE(5436)] = 212344,
  [SMALL_STATE(5437)] = 212396,
  [SMALL_STATE(5438)] = 212446,
  [SMALL_STATE(5439)] = 212496,
  [SMALL_STATE(5440)] = 212546,
  [SMALL_STATE(5441)] = 212596,
  [SMALL_STATE(5442)] = 212648,
  [SMALL_STATE(5443)] = 212698,
  [SMALL_STATE(5444)] = 212748,
  [SMALL_STATE(5445)] = 212798,
  [SMALL_STATE(5446)] = 212848,
  [SMALL_STATE(5447)] = 212898,
  [SMALL_STATE(5448)] = 212948,
  [SMALL_STATE(5449)] = 212998,
  [SMALL_STATE(5450)] = 213048,
  [SMALL_STATE(5451)] = 213098,
  [SMALL_STATE(5452)] = 213148,
  [SMALL_STATE(5453)] = 213198,
  [SMALL_STATE(5454)] = 213248,
  [SMALL_STATE(5455)] = 213298,
  [SMALL_STATE(5456)] = 213348,
  [SMALL_STATE(5457)] = 213398,
  [SMALL_STATE(5458)] = 213448,
  [SMALL_STATE(5459)] = 213498,
  [SMALL_STATE(5460)] = 213550,
  [SMALL_STATE(5461)] = 213600,
  [SMALL_STATE(5462)] = 213650,
  [SMALL_STATE(5463)] = 213700,
  [SMALL_STATE(5464)] = 213750,
  [SMALL_STATE(5465)] = 213800,
  [SMALL_STATE(5466)] = 213850,
  [SMALL_STATE(5467)] = 213900,
  [SMALL_STATE(5468)] = 213952,
  [SMALL_STATE(5469)] = 214004,
  [SMALL_STATE(5470)] = 214054,
  [SMALL_STATE(5471)] = 214106,
  [SMALL_STATE(5472)] = 214156,
  [SMALL_STATE(5473)] = 214206,
  [SMALL_STATE(5474)] = 214256,
  [SMALL_STATE(5475)] = 214306,
  [SMALL_STATE(5476)] = 214356,
  [SMALL_STATE(5477)] = 214406,
  [SMALL_STATE(5478)] = 214458,
  [SMALL_STATE(5479)] = 214510,
  [SMALL_STATE(5480)] = 214560,
  [SMALL_STATE(5481)] = 214610,
  [SMALL_STATE(5482)] = 214660,
  [SMALL_STATE(5483)] = 214710,
  [SMALL_STATE(5484)] = 214760,
  [SMALL_STATE(5485)] = 214812,
  [SMALL_STATE(5486)] = 214862,
  [SMALL_STATE(5487)] = 214912,
  [SMALL_STATE(5488)] = 214962,
  [SMALL_STATE(5489)] = 215012,
  [SMALL_STATE(5490)] = 215064,
  [SMALL_STATE(5491)] = 215114,
  [SMALL_STATE(5492)] = 215164,
  [SMALL_STATE(5493)] = 215214,
  [SMALL_STATE(5494)] = 215264,
  [SMALL_STATE(5495)] = 215314,
  [SMALL_STATE(5496)] = 215364,
  [SMALL_STATE(5497)] = 215416,
  [SMALL_STATE(5498)] = 215466,
  [SMALL_STATE(5499)] = 215516,
  [SMALL_STATE(5500)] = 215566,
  [SMALL_STATE(5501)] = 215616,
  [SMALL_STATE(5502)] = 215666,
  [SMALL_STATE(5503)] = 215716,
  [SMALL_STATE(5504)] = 215766,
  [SMALL_STATE(5505)] = 215816,
  [SMALL_STATE(5506)] = 215866,
  [SMALL_STATE(5507)] = 215916,
  [SMALL_STATE(5508)] = 215966,
  [SMALL_STATE(5509)] = 216016,
  [SMALL_STATE(5510)] = 216068,
  [SMALL_STATE(5511)] = 216118,
  [SMALL_STATE(5512)] = 216168,
  [SMALL_STATE(5513)] = 216218,
  [SMALL_STATE(5514)] = 216268,
  [SMALL_STATE(5515)] = 216318,
  [SMALL_STATE(5516)] = 216368,
  [SMALL_STATE(5517)] = 216420,
  [SMALL_STATE(5518)] = 216470,
  [SMALL_STATE(5519)] = 216520,
  [SMALL_STATE(5520)] = 216570,
  [SMALL_STATE(5521)] = 216620,
  [SMALL_STATE(5522)] = 216670,
  [SMALL_STATE(5523)] = 216720,
  [SMALL_STATE(5524)] = 216770,
  [SMALL_STATE(5525)] = 216820,
  [SMALL_STATE(5526)] = 216870,
  [SMALL_STATE(5527)] = 216920,
  [SMALL_STATE(5528)] = 216970,
  [SMALL_STATE(5529)] = 217020,
  [SMALL_STATE(5530)] = 217070,
  [SMALL_STATE(5531)] = 217120,
  [SMALL_STATE(5532)] = 217170,
  [SMALL_STATE(5533)] = 217220,
  [SMALL_STATE(5534)] = 217270,
  [SMALL_STATE(5535)] = 217320,
  [SMALL_STATE(5536)] = 217370,
  [SMALL_STATE(5537)] = 217422,
  [SMALL_STATE(5538)] = 217472,
  [SMALL_STATE(5539)] = 217524,
  [SMALL_STATE(5540)] = 217574,
  [SMALL_STATE(5541)] = 217624,
  [SMALL_STATE(5542)] = 217674,
  [SMALL_STATE(5543)] = 217724,
  [SMALL_STATE(5544)] = 217774,
  [SMALL_STATE(5545)] = 217824,
  [SMALL_STATE(5546)] = 217878,
  [SMALL_STATE(5547)] = 217928,
  [SMALL_STATE(5548)] = 217978,
  [SMALL_STATE(5549)] = 218028,
  [SMALL_STATE(5550)] = 218078,
  [SMALL_STATE(5551)] = 218128,
  [SMALL_STATE(5552)] = 218178,
  [SMALL_STATE(5553)] = 218228,
  [SMALL_STATE(5554)] = 218278,
  [SMALL_STATE(5555)] = 218328,
  [SMALL_STATE(5556)] = 218378,
  [SMALL_STATE(5557)] = 218428,
  [SMALL_STATE(5558)] = 218478,
  [SMALL_STATE(5559)] = 218528,
  [SMALL_STATE(5560)] = 218578,
  [SMALL_STATE(5561)] = 218628,
  [SMALL_STATE(5562)] = 218678,
  [SMALL_STATE(5563)] = 218728,
  [SMALL_STATE(5564)] = 218778,
  [SMALL_STATE(5565)] = 218834,
  [SMALL_STATE(5566)] = 218884,
  [SMALL_STATE(5567)] = 218934,
  [SMALL_STATE(5568)] = 218984,
  [SMALL_STATE(5569)] = 219034,
  [SMALL_STATE(5570)] = 219084,
  [SMALL_STATE(5571)] = 219134,
  [SMALL_STATE(5572)] = 219184,
  [SMALL_STATE(5573)] = 219234,
  [SMALL_STATE(5574)] = 219284,
  [SMALL_STATE(5575)] = 219334,
  [SMALL_STATE(5576)] = 219384,
  [SMALL_STATE(5577)] = 219434,
  [SMALL_STATE(5578)] = 219484,
  [SMALL_STATE(5579)] = 219534,
  [SMALL_STATE(5580)] = 219584,
  [SMALL_STATE(5581)] = 219634,
  [SMALL_STATE(5582)] = 219684,
  [SMALL_STATE(5583)] = 219734,
  [SMALL_STATE(5584)] = 219784,
  [SMALL_STATE(5585)] = 219834,
  [SMALL_STATE(5586)] = 219884,
  [SMALL_STATE(5587)] = 219934,
  [SMALL_STATE(5588)] = 219984,
  [SMALL_STATE(5589)] = 220034,
  [SMALL_STATE(5590)] = 220084,
  [SMALL_STATE(5591)] = 220134,
  [SMALL_STATE(5592)] = 220184,
  [SMALL_STATE(5593)] = 220236,
  [SMALL_STATE(5594)] = 220286,
  [SMALL_STATE(5595)] = 220336,
  [SMALL_STATE(5596)] = 220390,
  [SMALL_STATE(5597)] = 220440,
  [SMALL_STATE(5598)] = 220490,
  [SMALL_STATE(5599)] = 220540,
  [SMALL_STATE(5600)] = 220590,
  [SMALL_STATE(5601)] = 220646,
  [SMALL_STATE(5602)] = 220696,
  [SMALL_STATE(5603)] = 220746,
  [SMALL_STATE(5604)] = 220796,
  [SMALL_STATE(5605)] = 220846,
  [SMALL_STATE(5606)] = 220896,
  [SMALL_STATE(5607)] = 220946,
  [SMALL_STATE(5608)] = 220996,
  [SMALL_STATE(5609)] = 221046,
  [SMALL_STATE(5610)] = 221096,
  [SMALL_STATE(5611)] = 221146,
  [SMALL_STATE(5612)] = 221200,
  [SMALL_STATE(5613)] = 221250,
  [SMALL_STATE(5614)] = 221306,
  [SMALL_STATE(5615)] = 221356,
  [SMALL_STATE(5616)] = 221406,
  [SMALL_STATE(5617)] = 221456,
  [SMALL_STATE(5618)] = 221506,
  [SMALL_STATE(5619)] = 221556,
  [SMALL_STATE(5620)] = 221606,
  [SMALL_STATE(5621)] = 221656,
  [SMALL_STATE(5622)] = 221706,
  [SMALL_STATE(5623)] = 221760,
  [SMALL_STATE(5624)] = 221810,
  [SMALL_STATE(5625)] = 221860,
  [SMALL_STATE(5626)] = 221910,
  [SMALL_STATE(5627)] = 221960,
  [SMALL_STATE(5628)] = 222010,
  [SMALL_STATE(5629)] = 222060,
  [SMALL_STATE(5630)] = 222110,
  [SMALL_STATE(5631)] = 222160,
  [SMALL_STATE(5632)] = 222210,
  [SMALL_STATE(5633)] = 222260,
  [SMALL_STATE(5634)] = 222310,
  [SMALL_STATE(5635)] = 222364,
  [SMALL_STATE(5636)] = 222418,
  [SMALL_STATE(5637)] = 222468,
  [SMALL_STATE(5638)] = 222518,
  [SMALL_STATE(5639)] = 222568,
  [SMALL_STATE(5640)] = 222618,
  [SMALL_STATE(5641)] = 222668,
  [SMALL_STATE(5642)] = 222718,
  [SMALL_STATE(5643)] = 222768,
  [SMALL_STATE(5644)] = 222818,
  [SMALL_STATE(5645)] = 222868,
  [SMALL_STATE(5646)] = 222918,
  [SMALL_STATE(5647)] = 222968,
  [SMALL_STATE(5648)] = 223018,
  [SMALL_STATE(5649)] = 223068,
  [SMALL_STATE(5650)] = 223118,
  [SMALL_STATE(5651)] = 223168,
  [SMALL_STATE(5652)] = 223218,
  [SMALL_STATE(5653)] = 223268,
  [SMALL_STATE(5654)] = 223318,
  [SMALL_STATE(5655)] = 223368,
  [SMALL_STATE(5656)] = 223420,
  [SMALL_STATE(5657)] = 223470,
  [SMALL_STATE(5658)] = 223520,
  [SMALL_STATE(5659)] = 223570,
  [SMALL_STATE(5660)] = 223620,
  [SMALL_STATE(5661)] = 223670,
  [SMALL_STATE(5662)] = 223720,
  [SMALL_STATE(5663)] = 223770,
  [SMALL_STATE(5664)] = 223820,
  [SMALL_STATE(5665)] = 223870,
  [SMALL_STATE(5666)] = 223920,
  [SMALL_STATE(5667)] = 223970,
  [SMALL_STATE(5668)] = 224020,
  [SMALL_STATE(5669)] = 224070,
  [SMALL_STATE(5670)] = 224120,
  [SMALL_STATE(5671)] = 224170,
  [SMALL_STATE(5672)] = 224220,
  [SMALL_STATE(5673)] = 224270,
  [SMALL_STATE(5674)] = 224320,
  [SMALL_STATE(5675)] = 224370,
  [SMALL_STATE(5676)] = 224420,
  [SMALL_STATE(5677)] = 224470,
  [SMALL_STATE(5678)] = 224520,
  [SMALL_STATE(5679)] = 224570,
  [SMALL_STATE(5680)] = 224620,
  [SMALL_STATE(5681)] = 224670,
  [SMALL_STATE(5682)] = 224720,
  [SMALL_STATE(5683)] = 224770,
  [SMALL_STATE(5684)] = 224820,
  [SMALL_STATE(5685)] = 224870,
  [SMALL_STATE(5686)] = 224920,
  [SMALL_STATE(5687)] = 224970,
  [SMALL_STATE(5688)] = 225020,
  [SMALL_STATE(5689)] = 225070,
  [SMALL_STATE(5690)] = 225120,
  [SMALL_STATE(5691)] = 225170,
  [SMALL_STATE(5692)] = 225220,
  [SMALL_STATE(5693)] = 225270,
  [SMALL_STATE(5694)] = 225320,
  [SMALL_STATE(5695)] = 225370,
  [SMALL_STATE(5696)] = 225420,
  [SMALL_STATE(5697)] = 225470,
  [SMALL_STATE(5698)] = 225520,
  [SMALL_STATE(5699)] = 225570,
  [SMALL_STATE(5700)] = 225620,
  [SMALL_STATE(5701)] = 225670,
  [SMALL_STATE(5702)] = 225720,
  [SMALL_STATE(5703)] = 225770,
  [SMALL_STATE(5704)] = 225820,
  [SMALL_STATE(5705)] = 225870,
  [SMALL_STATE(5706)] = 225920,
  [SMALL_STATE(5707)] = 225970,
  [SMALL_STATE(5708)] = 226020,
  [SMALL_STATE(5709)] = 226070,
  [SMALL_STATE(5710)] = 226120,
  [SMALL_STATE(5711)] = 226170,
  [SMALL_STATE(5712)] = 226220,
  [SMALL_STATE(5713)] = 226270,
  [SMALL_STATE(5714)] = 226320,
  [SMALL_STATE(5715)] = 226370,
  [SMALL_STATE(5716)] = 226420,
  [SMALL_STATE(5717)] = 226470,
  [SMALL_STATE(5718)] = 226522,
  [SMALL_STATE(5719)] = 226572,
  [SMALL_STATE(5720)] = 226622,
  [SMALL_STATE(5721)] = 226672,
  [SMALL_STATE(5722)] = 226722,
  [SMALL_STATE(5723)] = 226772,
  [SMALL_STATE(5724)] = 226822,
  [SMALL_STATE(5725)] = 226872,
  [SMALL_STATE(5726)] = 226922,
  [SMALL_STATE(5727)] = 226972,
  [SMALL_STATE(5728)] = 227022,
  [SMALL_STATE(5729)] = 227072,
  [SMALL_STATE(5730)] = 227122,
  [SMALL_STATE(5731)] = 227172,
  [SMALL_STATE(5732)] = 227222,
  [SMALL_STATE(5733)] = 227272,
  [SMALL_STATE(5734)] = 227322,
  [SMALL_STATE(5735)] = 227372,
  [SMALL_STATE(5736)] = 227422,
  [SMALL_STATE(5737)] = 227472,
  [SMALL_STATE(5738)] = 227522,
  [SMALL_STATE(5739)] = 227572,
  [SMALL_STATE(5740)] = 227622,
  [SMALL_STATE(5741)] = 227672,
  [SMALL_STATE(5742)] = 227722,
  [SMALL_STATE(5743)] = 227772,
  [SMALL_STATE(5744)] = 227822,
  [SMALL_STATE(5745)] = 227872,
  [SMALL_STATE(5746)] = 227922,
  [SMALL_STATE(5747)] = 227972,
  [SMALL_STATE(5748)] = 228022,
  [SMALL_STATE(5749)] = 228072,
  [SMALL_STATE(5750)] = 228122,
  [SMALL_STATE(5751)] = 228172,
  [SMALL_STATE(5752)] = 228222,
  [SMALL_STATE(5753)] = 228272,
  [SMALL_STATE(5754)] = 228322,
  [SMALL_STATE(5755)] = 228372,
  [SMALL_STATE(5756)] = 228422,
  [SMALL_STATE(5757)] = 228472,
  [SMALL_STATE(5758)] = 228522,
  [SMALL_STATE(5759)] = 228572,
  [SMALL_STATE(5760)] = 228622,
  [SMALL_STATE(5761)] = 228672,
  [SMALL_STATE(5762)] = 228722,
  [SMALL_STATE(5763)] = 228772,
  [SMALL_STATE(5764)] = 228822,
  [SMALL_STATE(5765)] = 228872,
  [SMALL_STATE(5766)] = 228922,
  [SMALL_STATE(5767)] = 228972,
  [SMALL_STATE(5768)] = 229024,
  [SMALL_STATE(5769)] = 229074,
  [SMALL_STATE(5770)] = 229124,
  [SMALL_STATE(5771)] = 229174,
  [SMALL_STATE(5772)] = 229224,
  [SMALL_STATE(5773)] = 229278,
  [SMALL_STATE(5774)] = 229330,
  [SMALL_STATE(5775)] = 229382,
  [SMALL_STATE(5776)] = 229432,
  [SMALL_STATE(5777)] = 229482,
  [SMALL_STATE(5778)] = 229532,
  [SMALL_STATE(5779)] = 229582,
  [SMALL_STATE(5780)] = 229632,
  [SMALL_STATE(5781)] = 229686,
  [SMALL_STATE(5782)] = 229738,
  [SMALL_STATE(5783)] = 229788,
  [SMALL_STATE(5784)] = 229838,
  [SMALL_STATE(5785)] = 229888,
  [SMALL_STATE(5786)] = 229942,
  [SMALL_STATE(5787)] = 229992,
  [SMALL_STATE(5788)] = 230042,
  [SMALL_STATE(5789)] = 230094,
  [SMALL_STATE(5790)] = 230144,
  [SMALL_STATE(5791)] = 230194,
  [SMALL_STATE(5792)] = 230244,
  [SMALL_STATE(5793)] = 230294,
  [SMALL_STATE(5794)] = 230344,
  [SMALL_STATE(5795)] = 230398,
  [SMALL_STATE(5796)] = 230452,
  [SMALL_STATE(5797)] = 230502,
  [SMALL_STATE(5798)] = 230552,
  [SMALL_STATE(5799)] = 230602,
  [SMALL_STATE(5800)] = 230652,
  [SMALL_STATE(5801)] = 230702,
  [SMALL_STATE(5802)] = 230752,
  [SMALL_STATE(5803)] = 230802,
  [SMALL_STATE(5804)] = 230852,
  [SMALL_STATE(5805)] = 230902,
  [SMALL_STATE(5806)] = 230952,
  [SMALL_STATE(5807)] = 231002,
  [SMALL_STATE(5808)] = 231052,
  [SMALL_STATE(5809)] = 231102,
  [SMALL_STATE(5810)] = 231152,
  [SMALL_STATE(5811)] = 231202,
  [SMALL_STATE(5812)] = 231252,
  [SMALL_STATE(5813)] = 231302,
  [SMALL_STATE(5814)] = 231352,
  [SMALL_STATE(5815)] = 231402,
  [SMALL_STATE(5816)] = 231452,
  [SMALL_STATE(5817)] = 231502,
  [SMALL_STATE(5818)] = 231552,
  [SMALL_STATE(5819)] = 231602,
  [SMALL_STATE(5820)] = 231652,
  [SMALL_STATE(5821)] = 231702,
  [SMALL_STATE(5822)] = 231752,
  [SMALL_STATE(5823)] = 231802,
  [SMALL_STATE(5824)] = 231852,
  [SMALL_STATE(5825)] = 231904,
  [SMALL_STATE(5826)] = 231954,
  [SMALL_STATE(5827)] = 232004,
  [SMALL_STATE(5828)] = 232054,
  [SMALL_STATE(5829)] = 232104,
  [SMALL_STATE(5830)] = 232154,
  [SMALL_STATE(5831)] = 232204,
  [SMALL_STATE(5832)] = 232256,
  [SMALL_STATE(5833)] = 232310,
  [SMALL_STATE(5834)] = 232360,
  [SMALL_STATE(5835)] = 232410,
  [SMALL_STATE(5836)] = 232460,
  [SMALL_STATE(5837)] = 232510,
  [SMALL_STATE(5838)] = 232560,
  [SMALL_STATE(5839)] = 232610,
  [SMALL_STATE(5840)] = 232660,
  [SMALL_STATE(5841)] = 232710,
  [SMALL_STATE(5842)] = 232764,
  [SMALL_STATE(5843)] = 232814,
  [SMALL_STATE(5844)] = 232864,
  [SMALL_STATE(5845)] = 232914,
  [SMALL_STATE(5846)] = 232964,
  [SMALL_STATE(5847)] = 233014,
  [SMALL_STATE(5848)] = 233064,
  [SMALL_STATE(5849)] = 233114,
  [SMALL_STATE(5850)] = 233164,
  [SMALL_STATE(5851)] = 233214,
  [SMALL_STATE(5852)] = 233264,
  [SMALL_STATE(5853)] = 233314,
  [SMALL_STATE(5854)] = 233364,
  [SMALL_STATE(5855)] = 233414,
  [SMALL_STATE(5856)] = 233464,
  [SMALL_STATE(5857)] = 233514,
  [SMALL_STATE(5858)] = 233564,
  [SMALL_STATE(5859)] = 233614,
  [SMALL_STATE(5860)] = 233664,
  [SMALL_STATE(5861)] = 233714,
  [SMALL_STATE(5862)] = 233764,
  [SMALL_STATE(5863)] = 233814,
  [SMALL_STATE(5864)] = 233864,
  [SMALL_STATE(5865)] = 233914,
  [SMALL_STATE(5866)] = 233964,
  [SMALL_STATE(5867)] = 234014,
  [SMALL_STATE(5868)] = 234064,
  [SMALL_STATE(5869)] = 234118,
  [SMALL_STATE(5870)] = 234168,
  [SMALL_STATE(5871)] = 234218,
  [SMALL_STATE(5872)] = 234268,
  [SMALL_STATE(5873)] = 234318,
  [SMALL_STATE(5874)] = 234368,
  [SMALL_STATE(5875)] = 234418,
  [SMALL_STATE(5876)] = 234468,
  [SMALL_STATE(5877)] = 234518,
  [SMALL_STATE(5878)] = 234568,
  [SMALL_STATE(5879)] = 234620,
  [SMALL_STATE(5880)] = 234670,
  [SMALL_STATE(5881)] = 234720,
  [SMALL_STATE(5882)] = 234770,
  [SMALL_STATE(5883)] = 234820,
  [SMALL_STATE(5884)] = 234870,
  [SMALL_STATE(5885)] = 234920,
  [SMALL_STATE(5886)] = 234970,
  [SMALL_STATE(5887)] = 235020,
  [SMALL_STATE(5888)] = 235069,
  [SMALL_STATE(5889)] = 235118,
  [SMALL_STATE(5890)] = 235167,
  [SMALL_STATE(5891)] = 235216,
  [SMALL_STATE(5892)] = 235269,
  [SMALL_STATE(5893)] = 235318,
  [SMALL_STATE(5894)] = 235367,
  [SMALL_STATE(5895)] = 235416,
  [SMALL_STATE(5896)] = 235465,
  [SMALL_STATE(5897)] = 235514,
  [SMALL_STATE(5898)] = 235563,
  [SMALL_STATE(5899)] = 235612,
  [SMALL_STATE(5900)] = 235661,
  [SMALL_STATE(5901)] = 235710,
  [SMALL_STATE(5902)] = 235759,
  [SMALL_STATE(5903)] = 235808,
  [SMALL_STATE(5904)] = 235857,
  [SMALL_STATE(5905)] = 235906,
  [SMALL_STATE(5906)] = 235955,
  [SMALL_STATE(5907)] = 236004,
  [SMALL_STATE(5908)] = 236053,
  [SMALL_STATE(5909)] = 236102,
  [SMALL_STATE(5910)] = 236151,
  [SMALL_STATE(5911)] = 236200,
  [SMALL_STATE(5912)] = 236249,
  [SMALL_STATE(5913)] = 236298,
  [SMALL_STATE(5914)] = 236347,
  [SMALL_STATE(5915)] = 236396,
  [SMALL_STATE(5916)] = 236449,
  [SMALL_STATE(5917)] = 236498,
  [SMALL_STATE(5918)] = 236547,
  [SMALL_STATE(5919)] = 236598,
  [SMALL_STATE(5920)] = 236647,
  [SMALL_STATE(5921)] = 236696,
  [SMALL_STATE(5922)] = 236745,
  [SMALL_STATE(5923)] = 236794,
  [SMALL_STATE(5924)] = 236843,
  [SMALL_STATE(5925)] = 236892,
  [SMALL_STATE(5926)] = 236941,
  [SMALL_STATE(5927)] = 236990,
  [SMALL_STATE(5928)] = 237039,
  [SMALL_STATE(5929)] = 237088,
  [SMALL_STATE(5930)] = 237137,
  [SMALL_STATE(5931)] = 237186,
  [SMALL_STATE(5932)] = 237237,
  [SMALL_STATE(5933)] = 237286,
  [SMALL_STATE(5934)] = 237335,
  [SMALL_STATE(5935)] = 237384,
  [SMALL_STATE(5936)] = 237433,
  [SMALL_STATE(5937)] = 237482,
  [SMALL_STATE(5938)] = 237531,
  [SMALL_STATE(5939)] = 237582,
  [SMALL_STATE(5940)] = 237631,
  [SMALL_STATE(5941)] = 237680,
  [SMALL_STATE(5942)] = 237729,
  [SMALL_STATE(5943)] = 237778,
  [SMALL_STATE(5944)] = 237827,
  [SMALL_STATE(5945)] = 237876,
  [SMALL_STATE(5946)] = 237925,
  [SMALL_STATE(5947)] = 237974,
  [SMALL_STATE(5948)] = 238023,
  [SMALL_STATE(5949)] = 238074,
  [SMALL_STATE(5950)] = 238123,
  [SMALL_STATE(5951)] = 238172,
  [SMALL_STATE(5952)] = 238221,
  [SMALL_STATE(5953)] = 238270,
  [SMALL_STATE(5954)] = 238319,
  [SMALL_STATE(5955)] = 238370,
  [SMALL_STATE(5956)] = 238419,
  [SMALL_STATE(5957)] = 238468,
  [SMALL_STATE(5958)] = 238517,
  [SMALL_STATE(5959)] = 238566,
  [SMALL_STATE(5960)] = 238615,
  [SMALL_STATE(5961)] = 238664,
  [SMALL_STATE(5962)] = 238713,
  [SMALL_STATE(5963)] = 238762,
  [SMALL_STATE(5964)] = 238811,
  [SMALL_STATE(5965)] = 238860,
  [SMALL_STATE(5966)] = 238911,
  [SMALL_STATE(5967)] = 238960,
  [SMALL_STATE(5968)] = 239009,
  [SMALL_STATE(5969)] = 239058,
  [SMALL_STATE(5970)] = 239107,
  [SMALL_STATE(5971)] = 239156,
  [SMALL_STATE(5972)] = 239207,
  [SMALL_STATE(5973)] = 239256,
  [SMALL_STATE(5974)] = 239305,
  [SMALL_STATE(5975)] = 239354,
  [SMALL_STATE(5976)] = 239403,
  [SMALL_STATE(5977)] = 239452,
  [SMALL_STATE(5978)] = 239503,
  [SMALL_STATE(5979)] = 239552,
  [SMALL_STATE(5980)] = 239601,
  [SMALL_STATE(5981)] = 239650,
  [SMALL_STATE(5982)] = 239699,
  [SMALL_STATE(5983)] = 239748,
  [SMALL_STATE(5984)] = 239797,
  [SMALL_STATE(5985)] = 239846,
  [SMALL_STATE(5986)] = 239895,
  [SMALL_STATE(5987)] = 239944,
  [SMALL_STATE(5988)] = 239993,
  [SMALL_STATE(5989)] = 240042,
  [SMALL_STATE(5990)] = 240091,
  [SMALL_STATE(5991)] = 240142,
  [SMALL_STATE(5992)] = 240191,
  [SMALL_STATE(5993)] = 240240,
  [SMALL_STATE(5994)] = 240289,
  [SMALL_STATE(5995)] = 240338,
  [SMALL_STATE(5996)] = 240389,
  [SMALL_STATE(5997)] = 240438,
  [SMALL_STATE(5998)] = 240487,
  [SMALL_STATE(5999)] = 240536,
  [SMALL_STATE(6000)] = 240587,
  [SMALL_STATE(6001)] = 240636,
  [SMALL_STATE(6002)] = 240685,
  [SMALL_STATE(6003)] = 240734,
  [SMALL_STATE(6004)] = 240783,
  [SMALL_STATE(6005)] = 240832,
  [SMALL_STATE(6006)] = 240881,
  [SMALL_STATE(6007)] = 240930,
  [SMALL_STATE(6008)] = 240979,
  [SMALL_STATE(6009)] = 241028,
  [SMALL_STATE(6010)] = 241077,
  [SMALL_STATE(6011)] = 241126,
  [SMALL_STATE(6012)] = 241175,
  [SMALL_STATE(6013)] = 241224,
  [SMALL_STATE(6014)] = 241273,
  [SMALL_STATE(6015)] = 241322,
  [SMALL_STATE(6016)] = 241371,
  [SMALL_STATE(6017)] = 241422,
  [SMALL_STATE(6018)] = 241471,
  [SMALL_STATE(6019)] = 241520,
  [SMALL_STATE(6020)] = 241569,
  [SMALL_STATE(6021)] = 241618,
  [SMALL_STATE(6022)] = 241669,
  [SMALL_STATE(6023)] = 241718,
  [SMALL_STATE(6024)] = 241767,
  [SMALL_STATE(6025)] = 241816,
  [SMALL_STATE(6026)] = 241865,
  [SMALL_STATE(6027)] = 241914,
  [SMALL_STATE(6028)] = 241963,
  [SMALL_STATE(6029)] = 242012,
  [SMALL_STATE(6030)] = 242061,
  [SMALL_STATE(6031)] = 242110,
  [SMALL_STATE(6032)] = 242159,
  [SMALL_STATE(6033)] = 242208,
  [SMALL_STATE(6034)] = 242257,
  [SMALL_STATE(6035)] = 242306,
  [SMALL_STATE(6036)] = 242355,
  [SMALL_STATE(6037)] = 242404,
  [SMALL_STATE(6038)] = 242453,
  [SMALL_STATE(6039)] = 242502,
  [SMALL_STATE(6040)] = 242551,
  [SMALL_STATE(6041)] = 242600,
  [SMALL_STATE(6042)] = 242649,
  [SMALL_STATE(6043)] = 242698,
  [SMALL_STATE(6044)] = 242747,
  [SMALL_STATE(6045)] = 242796,
  [SMALL_STATE(6046)] = 242845,
  [SMALL_STATE(6047)] = 242894,
  [SMALL_STATE(6048)] = 242943,
  [SMALL_STATE(6049)] = 242992,
  [SMALL_STATE(6050)] = 243041,
  [SMALL_STATE(6051)] = 243090,
  [SMALL_STATE(6052)] = 243139,
  [SMALL_STATE(6053)] = 243188,
  [SMALL_STATE(6054)] = 243239,
  [SMALL_STATE(6055)] = 243288,
  [SMALL_STATE(6056)] = 243337,
  [SMALL_STATE(6057)] = 243386,
  [SMALL_STATE(6058)] = 243435,
  [SMALL_STATE(6059)] = 243484,
  [SMALL_STATE(6060)] = 243535,
  [SMALL_STATE(6061)] = 243584,
  [SMALL_STATE(6062)] = 243633,
  [SMALL_STATE(6063)] = 243684,
  [SMALL_STATE(6064)] = 243733,
  [SMALL_STATE(6065)] = 243782,
  [SMALL_STATE(6066)] = 243831,
  [SMALL_STATE(6067)] = 243880,
  [SMALL_STATE(6068)] = 243929,
  [SMALL_STATE(6069)] = 243980,
  [SMALL_STATE(6070)] = 244029,
  [SMALL_STATE(6071)] = 244078,
  [SMALL_STATE(6072)] = 244127,
  [SMALL_STATE(6073)] = 244178,
  [SMALL_STATE(6074)] = 244227,
  [SMALL_STATE(6075)] = 244276,
  [SMALL_STATE(6076)] = 244325,
  [SMALL_STATE(6077)] = 244374,
  [SMALL_STATE(6078)] = 244427,
  [SMALL_STATE(6079)] = 244476,
  [SMALL_STATE(6080)] = 244527,
  [SMALL_STATE(6081)] = 244576,
  [SMALL_STATE(6082)] = 244625,
  [SMALL_STATE(6083)] = 244674,
  [SMALL_STATE(6084)] = 244725,
  [SMALL_STATE(6085)] = 244774,
  [SMALL_STATE(6086)] = 244823,
  [SMALL_STATE(6087)] = 244872,
  [SMALL_STATE(6088)] = 244921,
  [SMALL_STATE(6089)] = 244972,
  [SMALL_STATE(6090)] = 245021,
  [SMALL_STATE(6091)] = 245072,
  [SMALL_STATE(6092)] = 245121,
  [SMALL_STATE(6093)] = 245170,
  [SMALL_STATE(6094)] = 245219,
  [SMALL_STATE(6095)] = 245268,
  [SMALL_STATE(6096)] = 245317,
  [SMALL_STATE(6097)] = 245366,
  [SMALL_STATE(6098)] = 245415,
  [SMALL_STATE(6099)] = 245464,
  [SMALL_STATE(6100)] = 245513,
  [SMALL_STATE(6101)] = 245562,
  [SMALL_STATE(6102)] = 245613,
  [SMALL_STATE(6103)] = 245662,
  [SMALL_STATE(6104)] = 245711,
  [SMALL_STATE(6105)] = 245760,
  [SMALL_STATE(6106)] = 245809,
  [SMALL_STATE(6107)] = 245860,
  [SMALL_STATE(6108)] = 245909,
  [SMALL_STATE(6109)] = 245958,
  [SMALL_STATE(6110)] = 246007,
  [SMALL_STATE(6111)] = 246056,
  [SMALL_STATE(6112)] = 246105,
  [SMALL_STATE(6113)] = 246154,
  [SMALL_STATE(6114)] = 246203,
  [SMALL_STATE(6115)] = 246252,
  [SMALL_STATE(6116)] = 246301,
  [SMALL_STATE(6117)] = 246350,
  [SMALL_STATE(6118)] = 246399,
  [SMALL_STATE(6119)] = 246448,
  [SMALL_STATE(6120)] = 246497,
  [SMALL_STATE(6121)] = 246546,
  [SMALL_STATE(6122)] = 246595,
  [SMALL_STATE(6123)] = 246644,
  [SMALL_STATE(6124)] = 246693,
  [SMALL_STATE(6125)] = 246742,
  [SMALL_STATE(6126)] = 246791,
  [SMALL_STATE(6127)] = 246840,
  [SMALL_STATE(6128)] = 246889,
  [SMALL_STATE(6129)] = 246938,
  [SMALL_STATE(6130)] = 246987,
  [SMALL_STATE(6131)] = 247036,
  [SMALL_STATE(6132)] = 247085,
  [SMALL_STATE(6133)] = 247134,
  [SMALL_STATE(6134)] = 247183,
  [SMALL_STATE(6135)] = 247232,
  [SMALL_STATE(6136)] = 247281,
  [SMALL_STATE(6137)] = 247330,
  [SMALL_STATE(6138)] = 247379,
  [SMALL_STATE(6139)] = 247428,
  [SMALL_STATE(6140)] = 247477,
  [SMALL_STATE(6141)] = 247526,
  [SMALL_STATE(6142)] = 247575,
  [SMALL_STATE(6143)] = 247624,
  [SMALL_STATE(6144)] = 247673,
  [SMALL_STATE(6145)] = 247722,
  [SMALL_STATE(6146)] = 247771,
  [SMALL_STATE(6147)] = 247820,
  [SMALL_STATE(6148)] = 247869,
  [SMALL_STATE(6149)] = 247918,
  [SMALL_STATE(6150)] = 247967,
  [SMALL_STATE(6151)] = 248016,
  [SMALL_STATE(6152)] = 248065,
  [SMALL_STATE(6153)] = 248114,
  [SMALL_STATE(6154)] = 248163,
  [SMALL_STATE(6155)] = 248212,
  [SMALL_STATE(6156)] = 248261,
  [SMALL_STATE(6157)] = 248310,
  [SMALL_STATE(6158)] = 248359,
  [SMALL_STATE(6159)] = 248408,
  [SMALL_STATE(6160)] = 248457,
  [SMALL_STATE(6161)] = 248506,
  [SMALL_STATE(6162)] = 248555,
  [SMALL_STATE(6163)] = 248604,
  [SMALL_STATE(6164)] = 248653,
  [SMALL_STATE(6165)] = 248702,
  [SMALL_STATE(6166)] = 248751,
  [SMALL_STATE(6167)] = 248800,
  [SMALL_STATE(6168)] = 248851,
  [SMALL_STATE(6169)] = 248900,
  [SMALL_STATE(6170)] = 248949,
  [SMALL_STATE(6171)] = 248998,
  [SMALL_STATE(6172)] = 249047,
  [SMALL_STATE(6173)] = 249096,
  [SMALL_STATE(6174)] = 249145,
  [SMALL_STATE(6175)] = 249194,
  [SMALL_STATE(6176)] = 249243,
  [SMALL_STATE(6177)] = 249292,
  [SMALL_STATE(6178)] = 249341,
  [SMALL_STATE(6179)] = 249390,
  [SMALL_STATE(6180)] = 249439,
  [SMALL_STATE(6181)] = 249488,
  [SMALL_STATE(6182)] = 249537,
  [SMALL_STATE(6183)] = 249586,
  [SMALL_STATE(6184)] = 249635,
  [SMALL_STATE(6185)] = 249684,
  [SMALL_STATE(6186)] = 249733,
  [SMALL_STATE(6187)] = 249782,
  [SMALL_STATE(6188)] = 249831,
  [SMALL_STATE(6189)] = 249880,
  [SMALL_STATE(6190)] = 249929,
  [SMALL_STATE(6191)] = 249978,
  [SMALL_STATE(6192)] = 250027,
  [SMALL_STATE(6193)] = 250076,
  [SMALL_STATE(6194)] = 250125,
  [SMALL_STATE(6195)] = 250174,
  [SMALL_STATE(6196)] = 250223,
  [SMALL_STATE(6197)] = 250272,
  [SMALL_STATE(6198)] = 250321,
  [SMALL_STATE(6199)] = 250370,
  [SMALL_STATE(6200)] = 250419,
  [SMALL_STATE(6201)] = 250468,
  [SMALL_STATE(6202)] = 250517,
  [SMALL_STATE(6203)] = 250566,
  [SMALL_STATE(6204)] = 250615,
  [SMALL_STATE(6205)] = 250664,
  [SMALL_STATE(6206)] = 250713,
  [SMALL_STATE(6207)] = 250762,
  [SMALL_STATE(6208)] = 250811,
  [SMALL_STATE(6209)] = 250860,
  [SMALL_STATE(6210)] = 250909,
  [SMALL_STATE(6211)] = 250958,
  [SMALL_STATE(6212)] = 251007,
  [SMALL_STATE(6213)] = 251062,
  [SMALL_STATE(6214)] = 251111,
  [SMALL_STATE(6215)] = 251160,
  [SMALL_STATE(6216)] = 251209,
  [SMALL_STATE(6217)] = 251258,
  [SMALL_STATE(6218)] = 251307,
  [SMALL_STATE(6219)] = 251356,
  [SMALL_STATE(6220)] = 251405,
  [SMALL_STATE(6221)] = 251456,
  [SMALL_STATE(6222)] = 251505,
  [SMALL_STATE(6223)] = 251554,
  [SMALL_STATE(6224)] = 251603,
  [SMALL_STATE(6225)] = 251652,
  [SMALL_STATE(6226)] = 251701,
  [SMALL_STATE(6227)] = 251750,
  [SMALL_STATE(6228)] = 251799,
  [SMALL_STATE(6229)] = 251848,
  [SMALL_STATE(6230)] = 251897,
  [SMALL_STATE(6231)] = 251946,
  [SMALL_STATE(6232)] = 251995,
  [SMALL_STATE(6233)] = 252044,
  [SMALL_STATE(6234)] = 252093,
  [SMALL_STATE(6235)] = 252142,
  [SMALL_STATE(6236)] = 252191,
  [SMALL_STATE(6237)] = 252240,
  [SMALL_STATE(6238)] = 252289,
  [SMALL_STATE(6239)] = 252338,
  [SMALL_STATE(6240)] = 252387,
  [SMALL_STATE(6241)] = 252436,
  [SMALL_STATE(6242)] = 252485,
  [SMALL_STATE(6243)] = 252534,
  [SMALL_STATE(6244)] = 252583,
  [SMALL_STATE(6245)] = 252632,
  [SMALL_STATE(6246)] = 252683,
  [SMALL_STATE(6247)] = 252732,
  [SMALL_STATE(6248)] = 252781,
  [SMALL_STATE(6249)] = 252830,
  [SMALL_STATE(6250)] = 252879,
  [SMALL_STATE(6251)] = 252928,
  [SMALL_STATE(6252)] = 252977,
  [SMALL_STATE(6253)] = 253026,
  [SMALL_STATE(6254)] = 253075,
  [SMALL_STATE(6255)] = 253124,
  [SMALL_STATE(6256)] = 253173,
  [SMALL_STATE(6257)] = 253224,
  [SMALL_STATE(6258)] = 253273,
  [SMALL_STATE(6259)] = 253324,
  [SMALL_STATE(6260)] = 253373,
  [SMALL_STATE(6261)] = 253422,
  [SMALL_STATE(6262)] = 253471,
  [SMALL_STATE(6263)] = 253524,
  [SMALL_STATE(6264)] = 253573,
  [SMALL_STATE(6265)] = 253622,
  [SMALL_STATE(6266)] = 253671,
  [SMALL_STATE(6267)] = 253722,
  [SMALL_STATE(6268)] = 253771,
  [SMALL_STATE(6269)] = 253820,
  [SMALL_STATE(6270)] = 253869,
  [SMALL_STATE(6271)] = 253918,
  [SMALL_STATE(6272)] = 253967,
  [SMALL_STATE(6273)] = 254018,
  [SMALL_STATE(6274)] = 254067,
  [SMALL_STATE(6275)] = 254118,
  [SMALL_STATE(6276)] = 254167,
  [SMALL_STATE(6277)] = 254216,
  [SMALL_STATE(6278)] = 254265,
  [SMALL_STATE(6279)] = 254314,
  [SMALL_STATE(6280)] = 254363,
  [SMALL_STATE(6281)] = 254414,
  [SMALL_STATE(6282)] = 254463,
  [SMALL_STATE(6283)] = 254512,
  [SMALL_STATE(6284)] = 254563,
  [SMALL_STATE(6285)] = 254612,
  [SMALL_STATE(6286)] = 254661,
  [SMALL_STATE(6287)] = 254710,
  [SMALL_STATE(6288)] = 254759,
  [SMALL_STATE(6289)] = 254808,
  [SMALL_STATE(6290)] = 254857,
  [SMALL_STATE(6291)] = 254908,
  [SMALL_STATE(6292)] = 254957,
  [SMALL_STATE(6293)] = 255006,
  [SMALL_STATE(6294)] = 255055,
  [SMALL_STATE(6295)] = 255104,
  [SMALL_STATE(6296)] = 255153,
  [SMALL_STATE(6297)] = 255204,
  [SMALL_STATE(6298)] = 255253,
  [SMALL_STATE(6299)] = 255302,
  [SMALL_STATE(6300)] = 255351,
  [SMALL_STATE(6301)] = 255400,
  [SMALL_STATE(6302)] = 255449,
  [SMALL_STATE(6303)] = 255500,
  [SMALL_STATE(6304)] = 255548,
  [SMALL_STATE(6305)] = 255598,
  [SMALL_STATE(6306)] = 255646,
  [SMALL_STATE(6307)] = 255694,
  [SMALL_STATE(6308)] = 255742,
  [SMALL_STATE(6309)] = 255790,
  [SMALL_STATE(6310)] = 255838,
  [SMALL_STATE(6311)] = 255886,
  [SMALL_STATE(6312)] = 255934,
  [SMALL_STATE(6313)] = 255982,
  [SMALL_STATE(6314)] = 256030,
  [SMALL_STATE(6315)] = 256078,
  [SMALL_STATE(6316)] = 256126,
  [SMALL_STATE(6317)] = 256174,
  [SMALL_STATE(6318)] = 256222,
  [SMALL_STATE(6319)] = 256270,
  [SMALL_STATE(6320)] = 256318,
  [SMALL_STATE(6321)] = 256366,
  [SMALL_STATE(6322)] = 256414,
  [SMALL_STATE(6323)] = 256462,
  [SMALL_STATE(6324)] = 256512,
  [SMALL_STATE(6325)] = 256560,
  [SMALL_STATE(6326)] = 256608,
  [SMALL_STATE(6327)] = 256656,
  [SMALL_STATE(6328)] = 256704,
  [SMALL_STATE(6329)] = 256752,
  [SMALL_STATE(6330)] = 256800,
  [SMALL_STATE(6331)] = 256848,
  [SMALL_STATE(6332)] = 256896,
  [SMALL_STATE(6333)] = 256944,
  [SMALL_STATE(6334)] = 256992,
  [SMALL_STATE(6335)] = 257040,
  [SMALL_STATE(6336)] = 257088,
  [SMALL_STATE(6337)] = 257136,
  [SMALL_STATE(6338)] = 257184,
  [SMALL_STATE(6339)] = 257232,
  [SMALL_STATE(6340)] = 257280,
  [SMALL_STATE(6341)] = 257328,
  [SMALL_STATE(6342)] = 257376,
  [SMALL_STATE(6343)] = 257426,
  [SMALL_STATE(6344)] = 257474,
  [SMALL_STATE(6345)] = 257522,
  [SMALL_STATE(6346)] = 257570,
  [SMALL_STATE(6347)] = 257618,
  [SMALL_STATE(6348)] = 257666,
  [SMALL_STATE(6349)] = 257714,
  [SMALL_STATE(6350)] = 257762,
  [SMALL_STATE(6351)] = 257810,
  [SMALL_STATE(6352)] = 257860,
  [SMALL_STATE(6353)] = 257908,
  [SMALL_STATE(6354)] = 257956,
  [SMALL_STATE(6355)] = 258004,
  [SMALL_STATE(6356)] = 258052,
  [SMALL_STATE(6357)] = 258100,
  [SMALL_STATE(6358)] = 258148,
  [SMALL_STATE(6359)] = 258196,
  [SMALL_STATE(6360)] = 258244,
  [SMALL_STATE(6361)] = 258292,
  [SMALL_STATE(6362)] = 258340,
  [SMALL_STATE(6363)] = 258388,
  [SMALL_STATE(6364)] = 258436,
  [SMALL_STATE(6365)] = 258484,
  [SMALL_STATE(6366)] = 258534,
  [SMALL_STATE(6367)] = 258582,
  [SMALL_STATE(6368)] = 258630,
  [SMALL_STATE(6369)] = 258678,
  [SMALL_STATE(6370)] = 258726,
  [SMALL_STATE(6371)] = 258776,
  [SMALL_STATE(6372)] = 258824,
  [SMALL_STATE(6373)] = 258872,
  [SMALL_STATE(6374)] = 258920,
  [SMALL_STATE(6375)] = 258968,
  [SMALL_STATE(6376)] = 259016,
  [SMALL_STATE(6377)] = 259064,
  [SMALL_STATE(6378)] = 259112,
  [SMALL_STATE(6379)] = 259160,
  [SMALL_STATE(6380)] = 259208,
  [SMALL_STATE(6381)] = 259256,
  [SMALL_STATE(6382)] = 259306,
  [SMALL_STATE(6383)] = 259354,
  [SMALL_STATE(6384)] = 259402,
  [SMALL_STATE(6385)] = 259450,
  [SMALL_STATE(6386)] = 259498,
  [SMALL_STATE(6387)] = 259546,
  [SMALL_STATE(6388)] = 259594,
  [SMALL_STATE(6389)] = 259644,
  [SMALL_STATE(6390)] = 259692,
  [SMALL_STATE(6391)] = 259740,
  [SMALL_STATE(6392)] = 259788,
  [SMALL_STATE(6393)] = 259836,
  [SMALL_STATE(6394)] = 259884,
  [SMALL_STATE(6395)] = 259932,
  [SMALL_STATE(6396)] = 259980,
  [SMALL_STATE(6397)] = 260028,
  [SMALL_STATE(6398)] = 260076,
  [SMALL_STATE(6399)] = 260124,
  [SMALL_STATE(6400)] = 260174,
  [SMALL_STATE(6401)] = 260222,
  [SMALL_STATE(6402)] = 260270,
  [SMALL_STATE(6403)] = 260320,
  [SMALL_STATE(6404)] = 260368,
  [SMALL_STATE(6405)] = 260416,
  [SMALL_STATE(6406)] = 260464,
  [SMALL_STATE(6407)] = 260512,
  [SMALL_STATE(6408)] = 260560,
  [SMALL_STATE(6409)] = 260608,
  [SMALL_STATE(6410)] = 260656,
  [SMALL_STATE(6411)] = 260704,
  [SMALL_STATE(6412)] = 260752,
  [SMALL_STATE(6413)] = 260800,
  [SMALL_STATE(6414)] = 260850,
  [SMALL_STATE(6415)] = 260898,
  [SMALL_STATE(6416)] = 260946,
  [SMALL_STATE(6417)] = 260994,
  [SMALL_STATE(6418)] = 261042,
  [SMALL_STATE(6419)] = 261090,
  [SMALL_STATE(6420)] = 261138,
  [SMALL_STATE(6421)] = 261186,
  [SMALL_STATE(6422)] = 261234,
  [SMALL_STATE(6423)] = 261282,
  [SMALL_STATE(6424)] = 261332,
  [SMALL_STATE(6425)] = 261382,
  [SMALL_STATE(6426)] = 261430,
  [SMALL_STATE(6427)] = 261480,
  [SMALL_STATE(6428)] = 261528,
  [SMALL_STATE(6429)] = 261576,
  [SMALL_STATE(6430)] = 261624,
  [SMALL_STATE(6431)] = 261674,
  [SMALL_STATE(6432)] = 261722,
  [SMALL_STATE(6433)] = 261770,
  [SMALL_STATE(6434)] = 261818,
  [SMALL_STATE(6435)] = 261866,
  [SMALL_STATE(6436)] = 261914,
  [SMALL_STATE(6437)] = 261962,
  [SMALL_STATE(6438)] = 262010,
  [SMALL_STATE(6439)] = 262060,
  [SMALL_STATE(6440)] = 262110,
  [SMALL_STATE(6441)] = 262158,
  [SMALL_STATE(6442)] = 262206,
  [SMALL_STATE(6443)] = 262254,
  [SMALL_STATE(6444)] = 262302,
  [SMALL_STATE(6445)] = 262350,
  [SMALL_STATE(6446)] = 262398,
  [SMALL_STATE(6447)] = 262446,
  [SMALL_STATE(6448)] = 262496,
  [SMALL_STATE(6449)] = 262544,
  [SMALL_STATE(6450)] = 262592,
  [SMALL_STATE(6451)] = 262640,
  [SMALL_STATE(6452)] = 262688,
  [SMALL_STATE(6453)] = 262736,
  [SMALL_STATE(6454)] = 262784,
  [SMALL_STATE(6455)] = 262832,
  [SMALL_STATE(6456)] = 262880,
  [SMALL_STATE(6457)] = 262928,
  [SMALL_STATE(6458)] = 262976,
  [SMALL_STATE(6459)] = 263024,
  [SMALL_STATE(6460)] = 263072,
  [SMALL_STATE(6461)] = 263120,
  [SMALL_STATE(6462)] = 263168,
  [SMALL_STATE(6463)] = 263216,
  [SMALL_STATE(6464)] = 263264,
  [SMALL_STATE(6465)] = 263312,
  [SMALL_STATE(6466)] = 263360,
  [SMALL_STATE(6467)] = 263408,
  [SMALL_STATE(6468)] = 263458,
  [SMALL_STATE(6469)] = 263508,
  [SMALL_STATE(6470)] = 263556,
  [SMALL_STATE(6471)] = 263606,
  [SMALL_STATE(6472)] = 263654,
  [SMALL_STATE(6473)] = 263702,
  [SMALL_STATE(6474)] = 263750,
  [SMALL_STATE(6475)] = 263800,
  [SMALL_STATE(6476)] = 263848,
  [SMALL_STATE(6477)] = 263896,
  [SMALL_STATE(6478)] = 263944,
  [SMALL_STATE(6479)] = 263994,
  [SMALL_STATE(6480)] = 264042,
  [SMALL_STATE(6481)] = 264092,
  [SMALL_STATE(6482)] = 264140,
  [SMALL_STATE(6483)] = 264188,
  [SMALL_STATE(6484)] = 264236,
  [SMALL_STATE(6485)] = 264286,
  [SMALL_STATE(6486)] = 264352,
  [SMALL_STATE(6487)] = 264400,
  [SMALL_STATE(6488)] = 264448,
  [SMALL_STATE(6489)] = 264496,
  [SMALL_STATE(6490)] = 264544,
  [SMALL_STATE(6491)] = 264594,
  [SMALL_STATE(6492)] = 264642,
  [SMALL_STATE(6493)] = 264692,
  [SMALL_STATE(6494)] = 264740,
  [SMALL_STATE(6495)] = 264788,
  [SMALL_STATE(6496)] = 264836,
  [SMALL_STATE(6497)] = 264884,
  [SMALL_STATE(6498)] = 264932,
  [SMALL_STATE(6499)] = 264982,
  [SMALL_STATE(6500)] = 265032,
  [SMALL_STATE(6501)] = 265080,
  [SMALL_STATE(6502)] = 265128,
  [SMALL_STATE(6503)] = 265176,
  [SMALL_STATE(6504)] = 265224,
  [SMALL_STATE(6505)] = 265272,
  [SMALL_STATE(6506)] = 265320,
  [SMALL_STATE(6507)] = 265368,
  [SMALL_STATE(6508)] = 265416,
  [SMALL_STATE(6509)] = 265466,
  [SMALL_STATE(6510)] = 265514,
  [SMALL_STATE(6511)] = 265562,
  [SMALL_STATE(6512)] = 265612,
  [SMALL_STATE(6513)] = 265660,
  [SMALL_STATE(6514)] = 265708,
  [SMALL_STATE(6515)] = 265756,
  [SMALL_STATE(6516)] = 265806,
  [SMALL_STATE(6517)] = 265856,
  [SMALL_STATE(6518)] = 265904,
  [SMALL_STATE(6519)] = 265952,
  [SMALL_STATE(6520)] = 266002,
  [SMALL_STATE(6521)] = 266050,
  [SMALL_STATE(6522)] = 266098,
  [SMALL_STATE(6523)] = 266146,
  [SMALL_STATE(6524)] = 266194,
  [SMALL_STATE(6525)] = 266242,
  [SMALL_STATE(6526)] = 266290,
  [SMALL_STATE(6527)] = 266340,
  [SMALL_STATE(6528)] = 266390,
  [SMALL_STATE(6529)] = 266438,
  [SMALL_STATE(6530)] = 266486,
  [SMALL_STATE(6531)] = 266534,
  [SMALL_STATE(6532)] = 266582,
  [SMALL_STATE(6533)] = 266630,
  [SMALL_STATE(6534)] = 266678,
  [SMALL_STATE(6535)] = 266726,
  [SMALL_STATE(6536)] = 266776,
  [SMALL_STATE(6537)] = 266824,
  [SMALL_STATE(6538)] = 266872,
  [SMALL_STATE(6539)] = 266920,
  [SMALL_STATE(6540)] = 266968,
  [SMALL_STATE(6541)] = 267016,
  [SMALL_STATE(6542)] = 267064,
  [SMALL_STATE(6543)] = 267112,
  [SMALL_STATE(6544)] = 267160,
  [SMALL_STATE(6545)] = 267208,
  [SMALL_STATE(6546)] = 267256,
  [SMALL_STATE(6547)] = 267304,
  [SMALL_STATE(6548)] = 267352,
  [SMALL_STATE(6549)] = 267400,
  [SMALL_STATE(6550)] = 267448,
  [SMALL_STATE(6551)] = 267496,
  [SMALL_STATE(6552)] = 267544,
  [SMALL_STATE(6553)] = 267592,
  [SMALL_STATE(6554)] = 267640,
  [SMALL_STATE(6555)] = 267688,
  [SMALL_STATE(6556)] = 267736,
  [SMALL_STATE(6557)] = 267784,
  [SMALL_STATE(6558)] = 267832,
  [SMALL_STATE(6559)] = 267880,
  [SMALL_STATE(6560)] = 267928,
  [SMALL_STATE(6561)] = 267976,
  [SMALL_STATE(6562)] = 268024,
  [SMALL_STATE(6563)] = 268072,
  [SMALL_STATE(6564)] = 268120,
  [SMALL_STATE(6565)] = 268168,
  [SMALL_STATE(6566)] = 268216,
  [SMALL_STATE(6567)] = 268264,
  [SMALL_STATE(6568)] = 268312,
  [SMALL_STATE(6569)] = 268374,
  [SMALL_STATE(6570)] = 268422,
  [SMALL_STATE(6571)] = 268470,
  [SMALL_STATE(6572)] = 268518,
  [SMALL_STATE(6573)] = 268566,
  [SMALL_STATE(6574)] = 268614,
  [SMALL_STATE(6575)] = 268662,
  [SMALL_STATE(6576)] = 268710,
  [SMALL_STATE(6577)] = 268758,
  [SMALL_STATE(6578)] = 268806,
  [SMALL_STATE(6579)] = 268854,
  [SMALL_STATE(6580)] = 268902,
  [SMALL_STATE(6581)] = 268950,
  [SMALL_STATE(6582)] = 268998,
  [SMALL_STATE(6583)] = 269046,
  [SMALL_STATE(6584)] = 269094,
  [SMALL_STATE(6585)] = 269142,
  [SMALL_STATE(6586)] = 269190,
  [SMALL_STATE(6587)] = 269238,
  [SMALL_STATE(6588)] = 269286,
  [SMALL_STATE(6589)] = 269334,
  [SMALL_STATE(6590)] = 269382,
  [SMALL_STATE(6591)] = 269430,
  [SMALL_STATE(6592)] = 269478,
  [SMALL_STATE(6593)] = 269526,
  [SMALL_STATE(6594)] = 269576,
  [SMALL_STATE(6595)] = 269624,
  [SMALL_STATE(6596)] = 269674,
  [SMALL_STATE(6597)] = 269722,
  [SMALL_STATE(6598)] = 269772,
  [SMALL_STATE(6599)] = 269822,
  [SMALL_STATE(6600)] = 269870,
  [SMALL_STATE(6601)] = 269918,
  [SMALL_STATE(6602)] = 269968,
  [SMALL_STATE(6603)] = 270018,
  [SMALL_STATE(6604)] = 270066,
  [SMALL_STATE(6605)] = 270114,
  [SMALL_STATE(6606)] = 270162,
  [SMALL_STATE(6607)] = 270210,
  [SMALL_STATE(6608)] = 270258,
  [SMALL_STATE(6609)] = 270308,
  [SMALL_STATE(6610)] = 270356,
  [SMALL_STATE(6611)] = 270404,
  [SMALL_STATE(6612)] = 270454,
  [SMALL_STATE(6613)] = 270502,
  [SMALL_STATE(6614)] = 270550,
  [SMALL_STATE(6615)] = 270598,
  [SMALL_STATE(6616)] = 270646,
  [SMALL_STATE(6617)] = 270696,
  [SMALL_STATE(6618)] = 270744,
  [SMALL_STATE(6619)] = 270792,
  [SMALL_STATE(6620)] = 270840,
  [SMALL_STATE(6621)] = 270888,
  [SMALL_STATE(6622)] = 270936,
  [SMALL_STATE(6623)] = 270984,
  [SMALL_STATE(6624)] = 271032,
  [SMALL_STATE(6625)] = 271080,
  [SMALL_STATE(6626)] = 271130,
  [SMALL_STATE(6627)] = 271178,
  [SMALL_STATE(6628)] = 271228,
  [SMALL_STATE(6629)] = 271276,
  [SMALL_STATE(6630)] = 271324,
  [SMALL_STATE(6631)] = 271374,
  [SMALL_STATE(6632)] = 271422,
  [SMALL_STATE(6633)] = 271470,
  [SMALL_STATE(6634)] = 271518,
  [SMALL_STATE(6635)] = 271566,
  [SMALL_STATE(6636)] = 271614,
  [SMALL_STATE(6637)] = 271662,
  [SMALL_STATE(6638)] = 271710,
  [SMALL_STATE(6639)] = 271760,
  [SMALL_STATE(6640)] = 271808,
  [SMALL_STATE(6641)] = 271856,
  [SMALL_STATE(6642)] = 271904,
  [SMALL_STATE(6643)] = 271952,
  [SMALL_STATE(6644)] = 272000,
  [SMALL_STATE(6645)] = 272048,
  [SMALL_STATE(6646)] = 272096,
  [SMALL_STATE(6647)] = 272144,
  [SMALL_STATE(6648)] = 272192,
  [SMALL_STATE(6649)] = 272240,
  [SMALL_STATE(6650)] = 272288,
  [SMALL_STATE(6651)] = 272336,
  [SMALL_STATE(6652)] = 272384,
  [SMALL_STATE(6653)] = 272434,
  [SMALL_STATE(6654)] = 272482,
  [SMALL_STATE(6655)] = 272532,
  [SMALL_STATE(6656)] = 272580,
  [SMALL_STATE(6657)] = 272628,
  [SMALL_STATE(6658)] = 272676,
  [SMALL_STATE(6659)] = 272723,
  [SMALL_STATE(6660)] = 272770,
  [SMALL_STATE(6661)] = 272819,
  [SMALL_STATE(6662)] = 272866,
  [SMALL_STATE(6663)] = 272913,
  [SMALL_STATE(6664)] = 272960,
  [SMALL_STATE(6665)] = 273007,
  [SMALL_STATE(6666)] = 273054,
  [SMALL_STATE(6667)] = 273101,
  [SMALL_STATE(6668)] = 273148,
  [SMALL_STATE(6669)] = 273195,
  [SMALL_STATE(6670)] = 273242,
  [SMALL_STATE(6671)] = 273289,
  [SMALL_STATE(6672)] = 273336,
  [SMALL_STATE(6673)] = 273383,
  [SMALL_STATE(6674)] = 273442,
  [SMALL_STATE(6675)] = 273489,
  [SMALL_STATE(6676)] = 273536,
  [SMALL_STATE(6677)] = 273583,
  [SMALL_STATE(6678)] = 273630,
  [SMALL_STATE(6679)] = 273677,
  [SMALL_STATE(6680)] = 273724,
  [SMALL_STATE(6681)] = 273771,
  [SMALL_STATE(6682)] = 273820,
  [SMALL_STATE(6683)] = 273867,
  [SMALL_STATE(6684)] = 273916,
  [SMALL_STATE(6685)] = 273963,
  [SMALL_STATE(6686)] = 274010,
  [SMALL_STATE(6687)] = 274059,
  [SMALL_STATE(6688)] = 274106,
  [SMALL_STATE(6689)] = 274153,
  [SMALL_STATE(6690)] = 274200,
  [SMALL_STATE(6691)] = 274249,
  [SMALL_STATE(6692)] = 274296,
  [SMALL_STATE(6693)] = 274345,
  [SMALL_STATE(6694)] = 274392,
  [SMALL_STATE(6695)] = 274439,
  [SMALL_STATE(6696)] = 274486,
  [SMALL_STATE(6697)] = 274535,
  [SMALL_STATE(6698)] = 274582,
  [SMALL_STATE(6699)] = 274629,
  [SMALL_STATE(6700)] = 274676,
  [SMALL_STATE(6701)] = 274723,
  [SMALL_STATE(6702)] = 274770,
  [SMALL_STATE(6703)] = 274817,
  [SMALL_STATE(6704)] = 274864,
  [SMALL_STATE(6705)] = 274911,
  [SMALL_STATE(6706)] = 274958,
  [SMALL_STATE(6707)] = 275005,
  [SMALL_STATE(6708)] = 275052,
  [SMALL_STATE(6709)] = 275099,
  [SMALL_STATE(6710)] = 275146,
  [SMALL_STATE(6711)] = 275193,
  [SMALL_STATE(6712)] = 275240,
  [SMALL_STATE(6713)] = 275287,
  [SMALL_STATE(6714)] = 275334,
  [SMALL_STATE(6715)] = 275381,
  [SMALL_STATE(6716)] = 275428,
  [SMALL_STATE(6717)] = 275475,
  [SMALL_STATE(6718)] = 275522,
  [SMALL_STATE(6719)] = 275569,
  [SMALL_STATE(6720)] = 275616,
  [SMALL_STATE(6721)] = 275663,
  [SMALL_STATE(6722)] = 275710,
  [SMALL_STATE(6723)] = 275757,
  [SMALL_STATE(6724)] = 275804,
  [SMALL_STATE(6725)] = 275851,
  [SMALL_STATE(6726)] = 275898,
  [SMALL_STATE(6727)] = 275945,
  [SMALL_STATE(6728)] = 275994,
  [SMALL_STATE(6729)] = 276041,
  [SMALL_STATE(6730)] = 276088,
  [SMALL_STATE(6731)] = 276135,
  [SMALL_STATE(6732)] = 276182,
  [SMALL_STATE(6733)] = 276229,
  [SMALL_STATE(6734)] = 276276,
  [SMALL_STATE(6735)] = 276323,
  [SMALL_STATE(6736)] = 276370,
  [SMALL_STATE(6737)] = 276417,
  [SMALL_STATE(6738)] = 276464,
  [SMALL_STATE(6739)] = 276511,
  [SMALL_STATE(6740)] = 276558,
  [SMALL_STATE(6741)] = 276605,
  [SMALL_STATE(6742)] = 276652,
  [SMALL_STATE(6743)] = 276699,
  [SMALL_STATE(6744)] = 276746,
  [SMALL_STATE(6745)] = 276793,
  [SMALL_STATE(6746)] = 276840,
  [SMALL_STATE(6747)] = 276889,
  [SMALL_STATE(6748)] = 276936,
  [SMALL_STATE(6749)] = 276983,
  [SMALL_STATE(6750)] = 277030,
  [SMALL_STATE(6751)] = 277077,
  [SMALL_STATE(6752)] = 277124,
  [SMALL_STATE(6753)] = 277171,
  [SMALL_STATE(6754)] = 277218,
  [SMALL_STATE(6755)] = 277265,
  [SMALL_STATE(6756)] = 277312,
  [SMALL_STATE(6757)] = 277359,
  [SMALL_STATE(6758)] = 277406,
  [SMALL_STATE(6759)] = 277453,
  [SMALL_STATE(6760)] = 277500,
  [SMALL_STATE(6761)] = 277547,
  [SMALL_STATE(6762)] = 277594,
  [SMALL_STATE(6763)] = 277643,
  [SMALL_STATE(6764)] = 277690,
  [SMALL_STATE(6765)] = 277737,
  [SMALL_STATE(6766)] = 277784,
  [SMALL_STATE(6767)] = 277831,
  [SMALL_STATE(6768)] = 277878,
  [SMALL_STATE(6769)] = 277925,
  [SMALL_STATE(6770)] = 277972,
  [SMALL_STATE(6771)] = 278019,
  [SMALL_STATE(6772)] = 278066,
  [SMALL_STATE(6773)] = 278113,
  [SMALL_STATE(6774)] = 278160,
  [SMALL_STATE(6775)] = 278207,
  [SMALL_STATE(6776)] = 278254,
  [SMALL_STATE(6777)] = 278301,
  [SMALL_STATE(6778)] = 278348,
  [SMALL_STATE(6779)] = 278395,
  [SMALL_STATE(6780)] = 278444,
  [SMALL_STATE(6781)] = 278491,
  [SMALL_STATE(6782)] = 278538,
  [SMALL_STATE(6783)] = 278587,
  [SMALL_STATE(6784)] = 278634,
  [SMALL_STATE(6785)] = 278681,
  [SMALL_STATE(6786)] = 278728,
  [SMALL_STATE(6787)] = 278777,
  [SMALL_STATE(6788)] = 278824,
  [SMALL_STATE(6789)] = 278871,
  [SMALL_STATE(6790)] = 278918,
  [SMALL_STATE(6791)] = 278965,
  [SMALL_STATE(6792)] = 279012,
  [SMALL_STATE(6793)] = 279059,
  [SMALL_STATE(6794)] = 279106,
  [SMALL_STATE(6795)] = 279153,
  [SMALL_STATE(6796)] = 279200,
  [SMALL_STATE(6797)] = 279247,
  [SMALL_STATE(6798)] = 279294,
  [SMALL_STATE(6799)] = 279341,
  [SMALL_STATE(6800)] = 279388,
  [SMALL_STATE(6801)] = 279435,
  [SMALL_STATE(6802)] = 279482,
  [SMALL_STATE(6803)] = 279531,
  [SMALL_STATE(6804)] = 279578,
  [SMALL_STATE(6805)] = 279625,
  [SMALL_STATE(6806)] = 279672,
  [SMALL_STATE(6807)] = 279719,
  [SMALL_STATE(6808)] = 279768,
  [SMALL_STATE(6809)] = 279815,
  [SMALL_STATE(6810)] = 279862,
  [SMALL_STATE(6811)] = 279909,
  [SMALL_STATE(6812)] = 279956,
  [SMALL_STATE(6813)] = 280003,
  [SMALL_STATE(6814)] = 280050,
  [SMALL_STATE(6815)] = 280097,
  [SMALL_STATE(6816)] = 280144,
  [SMALL_STATE(6817)] = 280191,
  [SMALL_STATE(6818)] = 280238,
  [SMALL_STATE(6819)] = 280285,
  [SMALL_STATE(6820)] = 280332,
  [SMALL_STATE(6821)] = 280379,
  [SMALL_STATE(6822)] = 280426,
  [SMALL_STATE(6823)] = 280473,
  [SMALL_STATE(6824)] = 280520,
  [SMALL_STATE(6825)] = 280567,
  [SMALL_STATE(6826)] = 280614,
  [SMALL_STATE(6827)] = 280661,
  [SMALL_STATE(6828)] = 280708,
  [SMALL_STATE(6829)] = 280755,
  [SMALL_STATE(6830)] = 280802,
  [SMALL_STATE(6831)] = 280849,
  [SMALL_STATE(6832)] = 280896,
  [SMALL_STATE(6833)] = 280943,
  [SMALL_STATE(6834)] = 280990,
  [SMALL_STATE(6835)] = 281037,
  [SMALL_STATE(6836)] = 281084,
  [SMALL_STATE(6837)] = 281131,
  [SMALL_STATE(6838)] = 281178,
  [SMALL_STATE(6839)] = 281225,
  [SMALL_STATE(6840)] = 281272,
  [SMALL_STATE(6841)] = 281319,
  [SMALL_STATE(6842)] = 281366,
  [SMALL_STATE(6843)] = 281413,
  [SMALL_STATE(6844)] = 281460,
  [SMALL_STATE(6845)] = 281507,
  [SMALL_STATE(6846)] = 281554,
  [SMALL_STATE(6847)] = 281601,
  [SMALL_STATE(6848)] = 281648,
  [SMALL_STATE(6849)] = 281695,
  [SMALL_STATE(6850)] = 281744,
  [SMALL_STATE(6851)] = 281791,
  [SMALL_STATE(6852)] = 281838,
  [SMALL_STATE(6853)] = 281885,
  [SMALL_STATE(6854)] = 281934,
  [SMALL_STATE(6855)] = 281981,
  [SMALL_STATE(6856)] = 282028,
  [SMALL_STATE(6857)] = 282075,
  [SMALL_STATE(6858)] = 282122,
  [SMALL_STATE(6859)] = 282169,
  [SMALL_STATE(6860)] = 282216,
  [SMALL_STATE(6861)] = 282263,
  [SMALL_STATE(6862)] = 282310,
  [SMALL_STATE(6863)] = 282357,
  [SMALL_STATE(6864)] = 282404,
  [SMALL_STATE(6865)] = 282451,
  [SMALL_STATE(6866)] = 282498,
  [SMALL_STATE(6867)] = 282545,
  [SMALL_STATE(6868)] = 282592,
  [SMALL_STATE(6869)] = 282639,
  [SMALL_STATE(6870)] = 282686,
  [SMALL_STATE(6871)] = 282735,
  [SMALL_STATE(6872)] = 282782,
  [SMALL_STATE(6873)] = 282829,
  [SMALL_STATE(6874)] = 282878,
  [SMALL_STATE(6875)] = 282925,
  [SMALL_STATE(6876)] = 282972,
  [SMALL_STATE(6877)] = 283019,
  [SMALL_STATE(6878)] = 283066,
  [SMALL_STATE(6879)] = 283113,
  [SMALL_STATE(6880)] = 283160,
  [SMALL_STATE(6881)] = 283207,
  [SMALL_STATE(6882)] = 283254,
  [SMALL_STATE(6883)] = 283301,
  [SMALL_STATE(6884)] = 283348,
  [SMALL_STATE(6885)] = 283395,
  [SMALL_STATE(6886)] = 283442,
  [SMALL_STATE(6887)] = 283489,
  [SMALL_STATE(6888)] = 283536,
  [SMALL_STATE(6889)] = 283585,
  [SMALL_STATE(6890)] = 283632,
  [SMALL_STATE(6891)] = 283679,
  [SMALL_STATE(6892)] = 283726,
  [SMALL_STATE(6893)] = 283773,
  [SMALL_STATE(6894)] = 283820,
  [SMALL_STATE(6895)] = 283867,
  [SMALL_STATE(6896)] = 283914,
  [SMALL_STATE(6897)] = 283961,
  [SMALL_STATE(6898)] = 284008,
  [SMALL_STATE(6899)] = 284055,
  [SMALL_STATE(6900)] = 284102,
  [SMALL_STATE(6901)] = 284149,
  [SMALL_STATE(6902)] = 284196,
  [SMALL_STATE(6903)] = 284243,
  [SMALL_STATE(6904)] = 284290,
  [SMALL_STATE(6905)] = 284337,
  [SMALL_STATE(6906)] = 284384,
  [SMALL_STATE(6907)] = 284431,
  [SMALL_STATE(6908)] = 284478,
  [SMALL_STATE(6909)] = 284525,
  [SMALL_STATE(6910)] = 284572,
  [SMALL_STATE(6911)] = 284619,
  [SMALL_STATE(6912)] = 284666,
  [SMALL_STATE(6913)] = 284713,
  [SMALL_STATE(6914)] = 284760,
  [SMALL_STATE(6915)] = 284807,
  [SMALL_STATE(6916)] = 284854,
  [SMALL_STATE(6917)] = 284901,
  [SMALL_STATE(6918)] = 284948,
  [SMALL_STATE(6919)] = 284995,
  [SMALL_STATE(6920)] = 285042,
  [SMALL_STATE(6921)] = 285089,
  [SMALL_STATE(6922)] = 285136,
  [SMALL_STATE(6923)] = 285183,
  [SMALL_STATE(6924)] = 285230,
  [SMALL_STATE(6925)] = 285277,
  [SMALL_STATE(6926)] = 285324,
  [SMALL_STATE(6927)] = 285371,
  [SMALL_STATE(6928)] = 285418,
  [SMALL_STATE(6929)] = 285467,
  [SMALL_STATE(6930)] = 285514,
  [SMALL_STATE(6931)] = 285561,
  [SMALL_STATE(6932)] = 285608,
  [SMALL_STATE(6933)] = 285655,
  [SMALL_STATE(6934)] = 285702,
  [SMALL_STATE(6935)] = 285749,
  [SMALL_STATE(6936)] = 285796,
  [SMALL_STATE(6937)] = 285843,
  [SMALL_STATE(6938)] = 285892,
  [SMALL_STATE(6939)] = 285939,
  [SMALL_STATE(6940)] = 285988,
  [SMALL_STATE(6941)] = 286035,
  [SMALL_STATE(6942)] = 286082,
  [SMALL_STATE(6943)] = 286129,
  [SMALL_STATE(6944)] = 286176,
  [SMALL_STATE(6945)] = 286223,
  [SMALL_STATE(6946)] = 286270,
  [SMALL_STATE(6947)] = 286317,
  [SMALL_STATE(6948)] = 286364,
  [SMALL_STATE(6949)] = 286413,
  [SMALL_STATE(6950)] = 286460,
  [SMALL_STATE(6951)] = 286507,
  [SMALL_STATE(6952)] = 286556,
  [SMALL_STATE(6953)] = 286603,
  [SMALL_STATE(6954)] = 286652,
  [SMALL_STATE(6955)] = 286699,
  [SMALL_STATE(6956)] = 286746,
  [SMALL_STATE(6957)] = 286793,
  [SMALL_STATE(6958)] = 286840,
  [SMALL_STATE(6959)] = 286887,
  [SMALL_STATE(6960)] = 286934,
  [SMALL_STATE(6961)] = 286983,
  [SMALL_STATE(6962)] = 287030,
  [SMALL_STATE(6963)] = 287077,
  [SMALL_STATE(6964)] = 287124,
  [SMALL_STATE(6965)] = 287171,
  [SMALL_STATE(6966)] = 287230,
  [SMALL_STATE(6967)] = 287277,
  [SMALL_STATE(6968)] = 287324,
  [SMALL_STATE(6969)] = 287371,
  [SMALL_STATE(6970)] = 287418,
  [SMALL_STATE(6971)] = 287465,
  [SMALL_STATE(6972)] = 287512,
  [SMALL_STATE(6973)] = 287559,
  [SMALL_STATE(6974)] = 287606,
  [SMALL_STATE(6975)] = 287653,
  [SMALL_STATE(6976)] = 287700,
  [SMALL_STATE(6977)] = 287747,
  [SMALL_STATE(6978)] = 287794,
  [SMALL_STATE(6979)] = 287841,
  [SMALL_STATE(6980)] = 287888,
  [SMALL_STATE(6981)] = 287935,
  [SMALL_STATE(6982)] = 287982,
  [SMALL_STATE(6983)] = 288029,
  [SMALL_STATE(6984)] = 288076,
  [SMALL_STATE(6985)] = 288123,
  [SMALL_STATE(6986)] = 288172,
  [SMALL_STATE(6987)] = 288221,
  [SMALL_STATE(6988)] = 288268,
  [SMALL_STATE(6989)] = 288315,
  [SMALL_STATE(6990)] = 288362,
  [SMALL_STATE(6991)] = 288409,
  [SMALL_STATE(6992)] = 288456,
  [SMALL_STATE(6993)] = 288503,
  [SMALL_STATE(6994)] = 288550,
  [SMALL_STATE(6995)] = 288597,
  [SMALL_STATE(6996)] = 288644,
  [SMALL_STATE(6997)] = 288691,
  [SMALL_STATE(6998)] = 288738,
  [SMALL_STATE(6999)] = 288785,
  [SMALL_STATE(7000)] = 288832,
  [SMALL_STATE(7001)] = 288879,
  [SMALL_STATE(7002)] = 288926,
  [SMALL_STATE(7003)] = 288975,
  [SMALL_STATE(7004)] = 289022,
  [SMALL_STATE(7005)] = 289069,
  [SMALL_STATE(7006)] = 289118,
  [SMALL_STATE(7007)] = 289165,
  [SMALL_STATE(7008)] = 289212,
  [SMALL_STATE(7009)] = 289259,
  [SMALL_STATE(7010)] = 289306,
  [SMALL_STATE(7011)] = 289355,
  [SMALL_STATE(7012)] = 289402,
  [SMALL_STATE(7013)] = 289449,
  [SMALL_STATE(7014)] = 289496,
  [SMALL_STATE(7015)] = 289543,
  [SMALL_STATE(7016)] = 289590,
  [SMALL_STATE(7017)] = 289639,
  [SMALL_STATE(7018)] = 289686,
  [SMALL_STATE(7019)] = 289733,
  [SMALL_STATE(7020)] = 289780,
  [SMALL_STATE(7021)] = 289827,
  [SMALL_STATE(7022)] = 289874,
  [SMALL_STATE(7023)] = 289921,
  [SMALL_STATE(7024)] = 289968,
  [SMALL_STATE(7025)] = 290015,
  [SMALL_STATE(7026)] = 290062,
  [SMALL_STATE(7027)] = 290109,
  [SMALL_STATE(7028)] = 290156,
  [SMALL_STATE(7029)] = 290203,
  [SMALL_STATE(7030)] = 290252,
  [SMALL_STATE(7031)] = 290299,
  [SMALL_STATE(7032)] = 290346,
  [SMALL_STATE(7033)] = 290392,
  [SMALL_STATE(7034)] = 290438,
  [SMALL_STATE(7035)] = 290486,
  [SMALL_STATE(7036)] = 290534,
  [SMALL_STATE(7037)] = 290580,
  [SMALL_STATE(7038)] = 290626,
  [SMALL_STATE(7039)] = 290672,
  [SMALL_STATE(7040)] = 290720,
  [SMALL_STATE(7041)] = 290768,
  [SMALL_STATE(7042)] = 290816,
  [SMALL_STATE(7043)] = 290862,
  [SMALL_STATE(7044)] = 290908,
  [SMALL_STATE(7045)] = 290954,
  [SMALL_STATE(7046)] = 291000,
  [SMALL_STATE(7047)] = 291046,
  [SMALL_STATE(7048)] = 291094,
  [SMALL_STATE(7049)] = 291140,
  [SMALL_STATE(7050)] = 291186,
  [SMALL_STATE(7051)] = 291232,
  [SMALL_STATE(7052)] = 291288,
  [SMALL_STATE(7053)] = 291334,
  [SMALL_STATE(7054)] = 291380,
  [SMALL_STATE(7055)] = 291426,
  [SMALL_STATE(7056)] = 291472,
  [SMALL_STATE(7057)] = 291518,
  [SMALL_STATE(7058)] = 291566,
  [SMALL_STATE(7059)] = 291614,
  [SMALL_STATE(7060)] = 291660,
  [SMALL_STATE(7061)] = 291706,
  [SMALL_STATE(7062)] = 291754,
  [SMALL_STATE(7063)] = 291800,
  [SMALL_STATE(7064)] = 291846,
  [SMALL_STATE(7065)] = 291892,
  [SMALL_STATE(7066)] = 291938,
  [SMALL_STATE(7067)] = 291986,
  [SMALL_STATE(7068)] = 292032,
  [SMALL_STATE(7069)] = 292078,
  [SMALL_STATE(7070)] = 292124,
  [SMALL_STATE(7071)] = 292170,
  [SMALL_STATE(7072)] = 292216,
  [SMALL_STATE(7073)] = 292262,
  [SMALL_STATE(7074)] = 292308,
  [SMALL_STATE(7075)] = 292354,
  [SMALL_STATE(7076)] = 292400,
  [SMALL_STATE(7077)] = 292446,
  [SMALL_STATE(7078)] = 292492,
  [SMALL_STATE(7079)] = 292538,
  [SMALL_STATE(7080)] = 292584,
  [SMALL_STATE(7081)] = 292630,
  [SMALL_STATE(7082)] = 292676,
  [SMALL_STATE(7083)] = 292722,
  [SMALL_STATE(7084)] = 292768,
  [SMALL_STATE(7085)] = 292814,
  [SMALL_STATE(7086)] = 292860,
  [SMALL_STATE(7087)] = 292916,
  [SMALL_STATE(7088)] = 292962,
  [SMALL_STATE(7089)] = 293008,
  [SMALL_STATE(7090)] = 293054,
  [SMALL_STATE(7091)] = 293100,
  [SMALL_STATE(7092)] = 293146,
  [SMALL_STATE(7093)] = 293192,
  [SMALL_STATE(7094)] = 293238,
  [SMALL_STATE(7095)] = 293286,
  [SMALL_STATE(7096)] = 293332,
  [SMALL_STATE(7097)] = 293378,
  [SMALL_STATE(7098)] = 293424,
  [SMALL_STATE(7099)] = 293470,
  [SMALL_STATE(7100)] = 293516,
  [SMALL_STATE(7101)] = 293564,
  [SMALL_STATE(7102)] = 293610,
  [SMALL_STATE(7103)] = 293656,
  [SMALL_STATE(7104)] = 293702,
  [SMALL_STATE(7105)] = 293748,
  [SMALL_STATE(7106)] = 293796,
  [SMALL_STATE(7107)] = 293842,
  [SMALL_STATE(7108)] = 293888,
  [SMALL_STATE(7109)] = 293934,
  [SMALL_STATE(7110)] = 293980,
  [SMALL_STATE(7111)] = 294026,
  [SMALL_STATE(7112)] = 294072,
  [SMALL_STATE(7113)] = 294120,
  [SMALL_STATE(7114)] = 294166,
  [SMALL_STATE(7115)] = 294212,
  [SMALL_STATE(7116)] = 294258,
  [SMALL_STATE(7117)] = 294304,
  [SMALL_STATE(7118)] = 294352,
  [SMALL_STATE(7119)] = 294398,
  [SMALL_STATE(7120)] = 294444,
  [SMALL_STATE(7121)] = 294490,
  [SMALL_STATE(7122)] = 294536,
  [SMALL_STATE(7123)] = 294582,
  [SMALL_STATE(7124)] = 294628,
  [SMALL_STATE(7125)] = 294674,
  [SMALL_STATE(7126)] = 294720,
  [SMALL_STATE(7127)] = 294766,
  [SMALL_STATE(7128)] = 294812,
  [SMALL_STATE(7129)] = 294858,
  [SMALL_STATE(7130)] = 294904,
  [SMALL_STATE(7131)] = 294950,
  [SMALL_STATE(7132)] = 294996,
  [SMALL_STATE(7133)] = 295042,
  [SMALL_STATE(7134)] = 295088,
  [SMALL_STATE(7135)] = 295134,
  [SMALL_STATE(7136)] = 295180,
  [SMALL_STATE(7137)] = 295238,
  [SMALL_STATE(7138)] = 295284,
  [SMALL_STATE(7139)] = 295330,
  [SMALL_STATE(7140)] = 295376,
  [SMALL_STATE(7141)] = 295422,
  [SMALL_STATE(7142)] = 295468,
  [SMALL_STATE(7143)] = 295516,
  [SMALL_STATE(7144)] = 295562,
  [SMALL_STATE(7145)] = 295608,
  [SMALL_STATE(7146)] = 295654,
  [SMALL_STATE(7147)] = 295702,
  [SMALL_STATE(7148)] = 295748,
  [SMALL_STATE(7149)] = 295794,
  [SMALL_STATE(7150)] = 295840,
  [SMALL_STATE(7151)] = 295886,
  [SMALL_STATE(7152)] = 295932,
  [SMALL_STATE(7153)] = 295978,
  [SMALL_STATE(7154)] = 296024,
  [SMALL_STATE(7155)] = 296070,
  [SMALL_STATE(7156)] = 296124,
  [SMALL_STATE(7157)] = 296170,
  [SMALL_STATE(7158)] = 296216,
  [SMALL_STATE(7159)] = 296262,
  [SMALL_STATE(7160)] = 296318,
  [SMALL_STATE(7161)] = 296364,
  [SMALL_STATE(7162)] = 296410,
  [SMALL_STATE(7163)] = 296456,
  [SMALL_STATE(7164)] = 296502,
  [SMALL_STATE(7165)] = 296548,
  [SMALL_STATE(7166)] = 296594,
  [SMALL_STATE(7167)] = 296640,
  [SMALL_STATE(7168)] = 296686,
  [SMALL_STATE(7169)] = 296734,
  [SMALL_STATE(7170)] = 296780,
  [SMALL_STATE(7171)] = 296828,
  [SMALL_STATE(7172)] = 296874,
  [SMALL_STATE(7173)] = 296920,
  [SMALL_STATE(7174)] = 296966,
  [SMALL_STATE(7175)] = 297012,
  [SMALL_STATE(7176)] = 297058,
  [SMALL_STATE(7177)] = 297104,
  [SMALL_STATE(7178)] = 297150,
  [SMALL_STATE(7179)] = 297196,
  [SMALL_STATE(7180)] = 297244,
  [SMALL_STATE(7181)] = 297290,
  [SMALL_STATE(7182)] = 297336,
  [SMALL_STATE(7183)] = 297382,
  [SMALL_STATE(7184)] = 297428,
  [SMALL_STATE(7185)] = 297474,
  [SMALL_STATE(7186)] = 297520,
  [SMALL_STATE(7187)] = 297566,
  [SMALL_STATE(7188)] = 297612,
  [SMALL_STATE(7189)] = 297658,
  [SMALL_STATE(7190)] = 297704,
  [SMALL_STATE(7191)] = 297750,
  [SMALL_STATE(7192)] = 297796,
  [SMALL_STATE(7193)] = 297842,
  [SMALL_STATE(7194)] = 297888,
  [SMALL_STATE(7195)] = 297934,
  [SMALL_STATE(7196)] = 297998,
  [SMALL_STATE(7197)] = 298044,
  [SMALL_STATE(7198)] = 298090,
  [SMALL_STATE(7199)] = 298136,
  [SMALL_STATE(7200)] = 298182,
  [SMALL_STATE(7201)] = 298228,
  [SMALL_STATE(7202)] = 298274,
  [SMALL_STATE(7203)] = 298320,
  [SMALL_STATE(7204)] = 298368,
  [SMALL_STATE(7205)] = 298414,
  [SMALL_STATE(7206)] = 298460,
  [SMALL_STATE(7207)] = 298506,
  [SMALL_STATE(7208)] = 298552,
  [SMALL_STATE(7209)] = 298598,
  [SMALL_STATE(7210)] = 298644,
  [SMALL_STATE(7211)] = 298692,
  [SMALL_STATE(7212)] = 298738,
  [SMALL_STATE(7213)] = 298786,
  [SMALL_STATE(7214)] = 298832,
  [SMALL_STATE(7215)] = 298878,
  [SMALL_STATE(7216)] = 298924,
  [SMALL_STATE(7217)] = 298970,
  [SMALL_STATE(7218)] = 299016,
  [SMALL_STATE(7219)] = 299064,
  [SMALL_STATE(7220)] = 299110,
  [SMALL_STATE(7221)] = 299156,
  [SMALL_STATE(7222)] = 299202,
  [SMALL_STATE(7223)] = 299248,
  [SMALL_STATE(7224)] = 299294,
  [SMALL_STATE(7225)] = 299340,
  [SMALL_STATE(7226)] = 299386,
  [SMALL_STATE(7227)] = 299434,
  [SMALL_STATE(7228)] = 299480,
  [SMALL_STATE(7229)] = 299526,
  [SMALL_STATE(7230)] = 299572,
  [SMALL_STATE(7231)] = 299618,
  [SMALL_STATE(7232)] = 299664,
  [SMALL_STATE(7233)] = 299710,
  [SMALL_STATE(7234)] = 299756,
  [SMALL_STATE(7235)] = 299802,
  [SMALL_STATE(7236)] = 299848,
  [SMALL_STATE(7237)] = 299894,
  [SMALL_STATE(7238)] = 299940,
  [SMALL_STATE(7239)] = 299986,
  [SMALL_STATE(7240)] = 300032,
  [SMALL_STATE(7241)] = 300078,
  [SMALL_STATE(7242)] = 300124,
  [SMALL_STATE(7243)] = 300171,
  [SMALL_STATE(7244)] = 300218,
  [SMALL_STATE(7245)] = 300265,
  [SMALL_STATE(7246)] = 300310,
  [SMALL_STATE(7247)] = 300355,
  [SMALL_STATE(7248)] = 300402,
  [SMALL_STATE(7249)] = 300449,
  [SMALL_STATE(7250)] = 300496,
  [SMALL_STATE(7251)] = 300543,
  [SMALL_STATE(7252)] = 300590,
  [SMALL_STATE(7253)] = 300637,
  [SMALL_STATE(7254)] = 300682,
  [SMALL_STATE(7255)] = 300729,
  [SMALL_STATE(7256)] = 300774,
  [SMALL_STATE(7257)] = 300819,
  [SMALL_STATE(7258)] = 300864,
  [SMALL_STATE(7259)] = 300915,
  [SMALL_STATE(7260)] = 300960,
  [SMALL_STATE(7261)] = 301005,
  [SMALL_STATE(7262)] = 301050,
  [SMALL_STATE(7263)] = 301095,
  [SMALL_STATE(7264)] = 301140,
  [SMALL_STATE(7265)] = 301185,
  [SMALL_STATE(7266)] = 301230,
  [SMALL_STATE(7267)] = 301275,
  [SMALL_STATE(7268)] = 301320,
  [SMALL_STATE(7269)] = 301375,
  [SMALL_STATE(7270)] = 301420,
  [SMALL_STATE(7271)] = 301465,
  [SMALL_STATE(7272)] = 301510,
  [SMALL_STATE(7273)] = 301555,
  [SMALL_STATE(7274)] = 301602,
  [SMALL_STATE(7275)] = 301647,
  [SMALL_STATE(7276)] = 301692,
  [SMALL_STATE(7277)] = 301737,
  [SMALL_STATE(7278)] = 301782,
  [SMALL_STATE(7279)] = 301827,
  [SMALL_STATE(7280)] = 301872,
  [SMALL_STATE(7281)] = 301917,
  [SMALL_STATE(7282)] = 301962,
  [SMALL_STATE(7283)] = 302007,
  [SMALL_STATE(7284)] = 302054,
  [SMALL_STATE(7285)] = 302099,
  [SMALL_STATE(7286)] = 302146,
  [SMALL_STATE(7287)] = 302191,
  [SMALL_STATE(7288)] = 302238,
  [SMALL_STATE(7289)] = 302285,
  [SMALL_STATE(7290)] = 302332,
  [SMALL_STATE(7291)] = 302377,
  [SMALL_STATE(7292)] = 302424,
  [SMALL_STATE(7293)] = 302471,
  [SMALL_STATE(7294)] = 302516,
  [SMALL_STATE(7295)] = 302563,
  [SMALL_STATE(7296)] = 302610,
  [SMALL_STATE(7297)] = 302655,
  [SMALL_STATE(7298)] = 302702,
  [SMALL_STATE(7299)] = 302747,
  [SMALL_STATE(7300)] = 302792,
  [SMALL_STATE(7301)] = 302837,
  [SMALL_STATE(7302)] = 302882,
  [SMALL_STATE(7303)] = 302929,
  [SMALL_STATE(7304)] = 302976,
  [SMALL_STATE(7305)] = 303023,
  [SMALL_STATE(7306)] = 303068,
  [SMALL_STATE(7307)] = 303115,
  [SMALL_STATE(7308)] = 303162,
  [SMALL_STATE(7309)] = 303209,
  [SMALL_STATE(7310)] = 303254,
  [SMALL_STATE(7311)] = 303299,
  [SMALL_STATE(7312)] = 303346,
  [SMALL_STATE(7313)] = 303393,
  [SMALL_STATE(7314)] = 303440,
  [SMALL_STATE(7315)] = 303485,
  [SMALL_STATE(7316)] = 303532,
  [SMALL_STATE(7317)] = 303577,
  [SMALL_STATE(7318)] = 303622,
  [SMALL_STATE(7319)] = 303667,
  [SMALL_STATE(7320)] = 303714,
  [SMALL_STATE(7321)] = 303759,
  [SMALL_STATE(7322)] = 303806,
  [SMALL_STATE(7323)] = 303851,
  [SMALL_STATE(7324)] = 303898,
  [SMALL_STATE(7325)] = 303943,
  [SMALL_STATE(7326)] = 303988,
  [SMALL_STATE(7327)] = 304035,
  [SMALL_STATE(7328)] = 304080,
  [SMALL_STATE(7329)] = 304125,
  [SMALL_STATE(7330)] = 304170,
  [SMALL_STATE(7331)] = 304215,
  [SMALL_STATE(7332)] = 304262,
  [SMALL_STATE(7333)] = 304309,
  [SMALL_STATE(7334)] = 304354,
  [SMALL_STATE(7335)] = 304401,
  [SMALL_STATE(7336)] = 304446,
  [SMALL_STATE(7337)] = 304509,
  [SMALL_STATE(7338)] = 304556,
  [SMALL_STATE(7339)] = 304601,
  [SMALL_STATE(7340)] = 304648,
  [SMALL_STATE(7341)] = 304693,
  [SMALL_STATE(7342)] = 304740,
  [SMALL_STATE(7343)] = 304785,
  [SMALL_STATE(7344)] = 304830,
  [SMALL_STATE(7345)] = 304877,
  [SMALL_STATE(7346)] = 304924,
  [SMALL_STATE(7347)] = 304971,
  [SMALL_STATE(7348)] = 305016,
  [SMALL_STATE(7349)] = 305061,
  [SMALL_STATE(7350)] = 305108,
  [SMALL_STATE(7351)] = 305153,
  [SMALL_STATE(7352)] = 305198,
  [SMALL_STATE(7353)] = 305245,
  [SMALL_STATE(7354)] = 305290,
  [SMALL_STATE(7355)] = 305337,
  [SMALL_STATE(7356)] = 305382,
  [SMALL_STATE(7357)] = 305427,
  [SMALL_STATE(7358)] = 305472,
  [SMALL_STATE(7359)] = 305519,
  [SMALL_STATE(7360)] = 305564,
  [SMALL_STATE(7361)] = 305611,
  [SMALL_STATE(7362)] = 305656,
  [SMALL_STATE(7363)] = 305703,
  [SMALL_STATE(7364)] = 305750,
  [SMALL_STATE(7365)] = 305797,
  [SMALL_STATE(7366)] = 305844,
  [SMALL_STATE(7367)] = 305891,
  [SMALL_STATE(7368)] = 305936,
  [SMALL_STATE(7369)] = 305983,
  [SMALL_STATE(7370)] = 306028,
  [SMALL_STATE(7371)] = 306075,
  [SMALL_STATE(7372)] = 306122,
  [SMALL_STATE(7373)] = 306169,
  [SMALL_STATE(7374)] = 306214,
  [SMALL_STATE(7375)] = 306259,
  [SMALL_STATE(7376)] = 306304,
  [SMALL_STATE(7377)] = 306349,
  [SMALL_STATE(7378)] = 306396,
  [SMALL_STATE(7379)] = 306443,
  [SMALL_STATE(7380)] = 306490,
  [SMALL_STATE(7381)] = 306537,
  [SMALL_STATE(7382)] = 306582,
  [SMALL_STATE(7383)] = 306629,
  [SMALL_STATE(7384)] = 306676,
  [SMALL_STATE(7385)] = 306723,
  [SMALL_STATE(7386)] = 306768,
  [SMALL_STATE(7387)] = 306813,
  [SMALL_STATE(7388)] = 306858,
  [SMALL_STATE(7389)] = 306903,
  [SMALL_STATE(7390)] = 306950,
  [SMALL_STATE(7391)] = 306997,
  [SMALL_STATE(7392)] = 307042,
  [SMALL_STATE(7393)] = 307087,
  [SMALL_STATE(7394)] = 307132,
  [SMALL_STATE(7395)] = 307177,
  [SMALL_STATE(7396)] = 307222,
  [SMALL_STATE(7397)] = 307267,
  [SMALL_STATE(7398)] = 307314,
  [SMALL_STATE(7399)] = 307361,
  [SMALL_STATE(7400)] = 307408,
  [SMALL_STATE(7401)] = 307453,
  [SMALL_STATE(7402)] = 307500,
  [SMALL_STATE(7403)] = 307547,
  [SMALL_STATE(7404)] = 307594,
  [SMALL_STATE(7405)] = 307641,
  [SMALL_STATE(7406)] = 307688,
  [SMALL_STATE(7407)] = 307733,
  [SMALL_STATE(7408)] = 307780,
  [SMALL_STATE(7409)] = 307825,
  [SMALL_STATE(7410)] = 307872,
  [SMALL_STATE(7411)] = 307919,
  [SMALL_STATE(7412)] = 307966,
  [SMALL_STATE(7413)] = 308013,
  [SMALL_STATE(7414)] = 308060,
  [SMALL_STATE(7415)] = 308105,
  [SMALL_STATE(7416)] = 308152,
  [SMALL_STATE(7417)] = 308199,
  [SMALL_STATE(7418)] = 308244,
  [SMALL_STATE(7419)] = 308289,
  [SMALL_STATE(7420)] = 308336,
  [SMALL_STATE(7421)] = 308381,
  [SMALL_STATE(7422)] = 308428,
  [SMALL_STATE(7423)] = 308475,
  [SMALL_STATE(7424)] = 308520,
  [SMALL_STATE(7425)] = 308565,
  [SMALL_STATE(7426)] = 308610,
  [SMALL_STATE(7427)] = 308657,
  [SMALL_STATE(7428)] = 308702,
  [SMALL_STATE(7429)] = 308747,
  [SMALL_STATE(7430)] = 308792,
  [SMALL_STATE(7431)] = 308839,
  [SMALL_STATE(7432)] = 308884,
  [SMALL_STATE(7433)] = 308931,
  [SMALL_STATE(7434)] = 308976,
  [SMALL_STATE(7435)] = 309023,
  [SMALL_STATE(7436)] = 309068,
  [SMALL_STATE(7437)] = 309115,
  [SMALL_STATE(7438)] = 309162,
  [SMALL_STATE(7439)] = 309209,
  [SMALL_STATE(7440)] = 309254,
  [SMALL_STATE(7441)] = 309301,
  [SMALL_STATE(7442)] = 309348,
  [SMALL_STATE(7443)] = 309395,
  [SMALL_STATE(7444)] = 309440,
  [SMALL_STATE(7445)] = 309485,
  [SMALL_STATE(7446)] = 309532,
  [SMALL_STATE(7447)] = 309577,
  [SMALL_STATE(7448)] = 309622,
  [SMALL_STATE(7449)] = 309667,
  [SMALL_STATE(7450)] = 309714,
  [SMALL_STATE(7451)] = 309761,
  [SMALL_STATE(7452)] = 309806,
  [SMALL_STATE(7453)] = 309851,
  [SMALL_STATE(7454)] = 309898,
  [SMALL_STATE(7455)] = 309943,
  [SMALL_STATE(7456)] = 309990,
  [SMALL_STATE(7457)] = 310035,
  [SMALL_STATE(7458)] = 310080,
  [SMALL_STATE(7459)] = 310125,
  [SMALL_STATE(7460)] = 310170,
  [SMALL_STATE(7461)] = 310217,
  [SMALL_STATE(7462)] = 310264,
  [SMALL_STATE(7463)] = 310309,
  [SMALL_STATE(7464)] = 310356,
  [SMALL_STATE(7465)] = 310401,
  [SMALL_STATE(7466)] = 310446,
  [SMALL_STATE(7467)] = 310493,
  [SMALL_STATE(7468)] = 310540,
  [SMALL_STATE(7469)] = 310585,
  [SMALL_STATE(7470)] = 310632,
  [SMALL_STATE(7471)] = 310677,
  [SMALL_STATE(7472)] = 310722,
  [SMALL_STATE(7473)] = 310767,
  [SMALL_STATE(7474)] = 310814,
  [SMALL_STATE(7475)] = 310859,
  [SMALL_STATE(7476)] = 310904,
  [SMALL_STATE(7477)] = 310951,
  [SMALL_STATE(7478)] = 310998,
  [SMALL_STATE(7479)] = 311051,
  [SMALL_STATE(7480)] = 311096,
  [SMALL_STATE(7481)] = 311143,
  [SMALL_STATE(7482)] = 311188,
  [SMALL_STATE(7483)] = 311235,
  [SMALL_STATE(7484)] = 311280,
  [SMALL_STATE(7485)] = 311325,
  [SMALL_STATE(7486)] = 311372,
  [SMALL_STATE(7487)] = 311419,
  [SMALL_STATE(7488)] = 311466,
  [SMALL_STATE(7489)] = 311511,
  [SMALL_STATE(7490)] = 311556,
  [SMALL_STATE(7491)] = 311603,
  [SMALL_STATE(7492)] = 311650,
  [SMALL_STATE(7493)] = 311697,
  [SMALL_STATE(7494)] = 311742,
  [SMALL_STATE(7495)] = 311787,
  [SMALL_STATE(7496)] = 311832,
  [SMALL_STATE(7497)] = 311879,
  [SMALL_STATE(7498)] = 311926,
  [SMALL_STATE(7499)] = 311973,
  [SMALL_STATE(7500)] = 312020,
  [SMALL_STATE(7501)] = 312067,
  [SMALL_STATE(7502)] = 312114,
  [SMALL_STATE(7503)] = 312161,
  [SMALL_STATE(7504)] = 312208,
  [SMALL_STATE(7505)] = 312255,
  [SMALL_STATE(7506)] = 312302,
  [SMALL_STATE(7507)] = 312349,
  [SMALL_STATE(7508)] = 312396,
  [SMALL_STATE(7509)] = 312443,
  [SMALL_STATE(7510)] = 312490,
  [SMALL_STATE(7511)] = 312537,
  [SMALL_STATE(7512)] = 312584,
  [SMALL_STATE(7513)] = 312629,
  [SMALL_STATE(7514)] = 312676,
  [SMALL_STATE(7515)] = 312723,
  [SMALL_STATE(7516)] = 312770,
  [SMALL_STATE(7517)] = 312817,
  [SMALL_STATE(7518)] = 312864,
  [SMALL_STATE(7519)] = 312909,
  [SMALL_STATE(7520)] = 312954,
  [SMALL_STATE(7521)] = 312999,
  [SMALL_STATE(7522)] = 313046,
  [SMALL_STATE(7523)] = 313093,
  [SMALL_STATE(7524)] = 313140,
  [SMALL_STATE(7525)] = 313187,
  [SMALL_STATE(7526)] = 313234,
  [SMALL_STATE(7527)] = 313281,
  [SMALL_STATE(7528)] = 313326,
  [SMALL_STATE(7529)] = 313371,
  [SMALL_STATE(7530)] = 313418,
  [SMALL_STATE(7531)] = 313465,
  [SMALL_STATE(7532)] = 313512,
  [SMALL_STATE(7533)] = 313559,
  [SMALL_STATE(7534)] = 313606,
  [SMALL_STATE(7535)] = 313653,
  [SMALL_STATE(7536)] = 313700,
  [SMALL_STATE(7537)] = 313747,
  [SMALL_STATE(7538)] = 313792,
  [SMALL_STATE(7539)] = 313839,
  [SMALL_STATE(7540)] = 313886,
  [SMALL_STATE(7541)] = 313931,
  [SMALL_STATE(7542)] = 313976,
  [SMALL_STATE(7543)] = 314021,
  [SMALL_STATE(7544)] = 314066,
  [SMALL_STATE(7545)] = 314111,
  [SMALL_STATE(7546)] = 314158,
  [SMALL_STATE(7547)] = 314203,
  [SMALL_STATE(7548)] = 314250,
  [SMALL_STATE(7549)] = 314297,
  [SMALL_STATE(7550)] = 314344,
  [SMALL_STATE(7551)] = 314391,
  [SMALL_STATE(7552)] = 314436,
  [SMALL_STATE(7553)] = 314481,
  [SMALL_STATE(7554)] = 314526,
  [SMALL_STATE(7555)] = 314571,
  [SMALL_STATE(7556)] = 314618,
  [SMALL_STATE(7557)] = 314665,
  [SMALL_STATE(7558)] = 314712,
  [SMALL_STATE(7559)] = 314759,
  [SMALL_STATE(7560)] = 314806,
  [SMALL_STATE(7561)] = 314853,
  [SMALL_STATE(7562)] = 314900,
  [SMALL_STATE(7563)] = 314947,
  [SMALL_STATE(7564)] = 314994,
  [SMALL_STATE(7565)] = 315041,
  [SMALL_STATE(7566)] = 315088,
  [SMALL_STATE(7567)] = 315135,
  [SMALL_STATE(7568)] = 315182,
  [SMALL_STATE(7569)] = 315229,
  [SMALL_STATE(7570)] = 315276,
  [SMALL_STATE(7571)] = 315323,
  [SMALL_STATE(7572)] = 315370,
  [SMALL_STATE(7573)] = 315417,
  [SMALL_STATE(7574)] = 315464,
  [SMALL_STATE(7575)] = 315511,
  [SMALL_STATE(7576)] = 315558,
  [SMALL_STATE(7577)] = 315605,
  [SMALL_STATE(7578)] = 315652,
  [SMALL_STATE(7579)] = 315696,
  [SMALL_STATE(7580)] = 315740,
  [SMALL_STATE(7581)] = 315784,
  [SMALL_STATE(7582)] = 315828,
  [SMALL_STATE(7583)] = 315872,
  [SMALL_STATE(7584)] = 315916,
  [SMALL_STATE(7585)] = 315960,
  [SMALL_STATE(7586)] = 316004,
  [SMALL_STATE(7587)] = 316050,
  [SMALL_STATE(7588)] = 316094,
  [SMALL_STATE(7589)] = 316138,
  [SMALL_STATE(7590)] = 316182,
  [SMALL_STATE(7591)] = 316226,
  [SMALL_STATE(7592)] = 316270,
  [SMALL_STATE(7593)] = 316314,
  [SMALL_STATE(7594)] = 316358,
  [SMALL_STATE(7595)] = 316404,
  [SMALL_STATE(7596)] = 316450,
  [SMALL_STATE(7597)] = 316496,
  [SMALL_STATE(7598)] = 316542,
  [SMALL_STATE(7599)] = 316586,
  [SMALL_STATE(7600)] = 316632,
  [SMALL_STATE(7601)] = 316676,
  [SMALL_STATE(7602)] = 316720,
  [SMALL_STATE(7603)] = 316764,
  [SMALL_STATE(7604)] = 316808,
  [SMALL_STATE(7605)] = 316854,
  [SMALL_STATE(7606)] = 316898,
  [SMALL_STATE(7607)] = 316942,
  [SMALL_STATE(7608)] = 316986,
  [SMALL_STATE(7609)] = 317030,
  [SMALL_STATE(7610)] = 317076,
  [SMALL_STATE(7611)] = 317120,
  [SMALL_STATE(7612)] = 317164,
  [SMALL_STATE(7613)] = 317210,
  [SMALL_STATE(7614)] = 317256,
  [SMALL_STATE(7615)] = 317302,
  [SMALL_STATE(7616)] = 317346,
  [SMALL_STATE(7617)] = 317390,
  [SMALL_STATE(7618)] = 317434,
  [SMALL_STATE(7619)] = 317480,
  [SMALL_STATE(7620)] = 317524,
  [SMALL_STATE(7621)] = 317568,
  [SMALL_STATE(7622)] = 317628,
  [SMALL_STATE(7623)] = 317672,
  [SMALL_STATE(7624)] = 317716,
  [SMALL_STATE(7625)] = 317760,
  [SMALL_STATE(7626)] = 317804,
  [SMALL_STATE(7627)] = 317848,
  [SMALL_STATE(7628)] = 317892,
  [SMALL_STATE(7629)] = 317936,
  [SMALL_STATE(7630)] = 317982,
  [SMALL_STATE(7631)] = 318026,
  [SMALL_STATE(7632)] = 318070,
  [SMALL_STATE(7633)] = 318114,
  [SMALL_STATE(7634)] = 318158,
  [SMALL_STATE(7635)] = 318202,
  [SMALL_STATE(7636)] = 318246,
  [SMALL_STATE(7637)] = 318290,
  [SMALL_STATE(7638)] = 318334,
  [SMALL_STATE(7639)] = 318380,
  [SMALL_STATE(7640)] = 318424,
  [SMALL_STATE(7641)] = 318470,
  [SMALL_STATE(7642)] = 318514,
  [SMALL_STATE(7643)] = 318558,
  [SMALL_STATE(7644)] = 318604,
  [SMALL_STATE(7645)] = 318648,
  [SMALL_STATE(7646)] = 318692,
  [SMALL_STATE(7647)] = 318736,
  [SMALL_STATE(7648)] = 318780,
  [SMALL_STATE(7649)] = 318824,
  [SMALL_STATE(7650)] = 318868,
  [SMALL_STATE(7651)] = 318912,
  [SMALL_STATE(7652)] = 318956,
  [SMALL_STATE(7653)] = 319002,
  [SMALL_STATE(7654)] = 319046,
  [SMALL_STATE(7655)] = 319090,
  [SMALL_STATE(7656)] = 319136,
  [SMALL_STATE(7657)] = 319180,
  [SMALL_STATE(7658)] = 319224,
  [SMALL_STATE(7659)] = 319268,
  [SMALL_STATE(7660)] = 319312,
  [SMALL_STATE(7661)] = 319356,
  [SMALL_STATE(7662)] = 319400,
  [SMALL_STATE(7663)] = 319444,
  [SMALL_STATE(7664)] = 319488,
  [SMALL_STATE(7665)] = 319532,
  [SMALL_STATE(7666)] = 319576,
  [SMALL_STATE(7667)] = 319620,
  [SMALL_STATE(7668)] = 319664,
  [SMALL_STATE(7669)] = 319708,
  [SMALL_STATE(7670)] = 319752,
  [SMALL_STATE(7671)] = 319796,
  [SMALL_STATE(7672)] = 319840,
  [SMALL_STATE(7673)] = 319884,
  [SMALL_STATE(7674)] = 319930,
  [SMALL_STATE(7675)] = 319974,
  [SMALL_STATE(7676)] = 320020,
  [SMALL_STATE(7677)] = 320064,
  [SMALL_STATE(7678)] = 320110,
  [SMALL_STATE(7679)] = 320154,
  [SMALL_STATE(7680)] = 320198,
  [SMALL_STATE(7681)] = 320244,
  [SMALL_STATE(7682)] = 320288,
  [SMALL_STATE(7683)] = 320332,
  [SMALL_STATE(7684)] = 320376,
  [SMALL_STATE(7685)] = 320420,
  [SMALL_STATE(7686)] = 320464,
  [SMALL_STATE(7687)] = 320508,
  [SMALL_STATE(7688)] = 320552,
  [SMALL_STATE(7689)] = 320596,
  [SMALL_STATE(7690)] = 320640,
  [SMALL_STATE(7691)] = 320686,
  [SMALL_STATE(7692)] = 320732,
  [SMALL_STATE(7693)] = 320776,
  [SMALL_STATE(7694)] = 320820,
  [SMALL_STATE(7695)] = 320864,
  [SMALL_STATE(7696)] = 320908,
  [SMALL_STATE(7697)] = 320952,
  [SMALL_STATE(7698)] = 320996,
  [SMALL_STATE(7699)] = 321040,
  [SMALL_STATE(7700)] = 321084,
  [SMALL_STATE(7701)] = 321128,
  [SMALL_STATE(7702)] = 321172,
  [SMALL_STATE(7703)] = 321216,
  [SMALL_STATE(7704)] = 321260,
  [SMALL_STATE(7705)] = 321304,
  [SMALL_STATE(7706)] = 321348,
  [SMALL_STATE(7707)] = 321392,
  [SMALL_STATE(7708)] = 321436,
  [SMALL_STATE(7709)] = 321480,
  [SMALL_STATE(7710)] = 321526,
  [SMALL_STATE(7711)] = 321570,
  [SMALL_STATE(7712)] = 321614,
  [SMALL_STATE(7713)] = 321658,
  [SMALL_STATE(7714)] = 321702,
  [SMALL_STATE(7715)] = 321748,
  [SMALL_STATE(7716)] = 321792,
  [SMALL_STATE(7717)] = 321836,
  [SMALL_STATE(7718)] = 321882,
  [SMALL_STATE(7719)] = 321926,
  [SMALL_STATE(7720)] = 321970,
  [SMALL_STATE(7721)] = 322014,
  [SMALL_STATE(7722)] = 322060,
  [SMALL_STATE(7723)] = 322104,
  [SMALL_STATE(7724)] = 322148,
  [SMALL_STATE(7725)] = 322192,
  [SMALL_STATE(7726)] = 322236,
  [SMALL_STATE(7727)] = 322280,
  [SMALL_STATE(7728)] = 322324,
  [SMALL_STATE(7729)] = 322368,
  [SMALL_STATE(7730)] = 322412,
  [SMALL_STATE(7731)] = 322456,
  [SMALL_STATE(7732)] = 322500,
  [SMALL_STATE(7733)] = 322544,
  [SMALL_STATE(7734)] = 322590,
  [SMALL_STATE(7735)] = 322634,
  [SMALL_STATE(7736)] = 322678,
  [SMALL_STATE(7737)] = 322724,
  [SMALL_STATE(7738)] = 322768,
  [SMALL_STATE(7739)] = 322812,
  [SMALL_STATE(7740)] = 322856,
  [SMALL_STATE(7741)] = 322902,
  [SMALL_STATE(7742)] = 322946,
  [SMALL_STATE(7743)] = 322992,
  [SMALL_STATE(7744)] = 323036,
  [SMALL_STATE(7745)] = 323080,
  [SMALL_STATE(7746)] = 323126,
  [SMALL_STATE(7747)] = 323172,
  [SMALL_STATE(7748)] = 323216,
  [SMALL_STATE(7749)] = 323260,
  [SMALL_STATE(7750)] = 323320,
  [SMALL_STATE(7751)] = 323364,
  [SMALL_STATE(7752)] = 323408,
  [SMALL_STATE(7753)] = 323454,
  [SMALL_STATE(7754)] = 323498,
  [SMALL_STATE(7755)] = 323542,
  [SMALL_STATE(7756)] = 323586,
  [SMALL_STATE(7757)] = 323632,
  [SMALL_STATE(7758)] = 323676,
  [SMALL_STATE(7759)] = 323720,
  [SMALL_STATE(7760)] = 323764,
  [SMALL_STATE(7761)] = 323808,
  [SMALL_STATE(7762)] = 323852,
  [SMALL_STATE(7763)] = 323896,
  [SMALL_STATE(7764)] = 323942,
  [SMALL_STATE(7765)] = 323986,
  [SMALL_STATE(7766)] = 324030,
  [SMALL_STATE(7767)] = 324074,
  [SMALL_STATE(7768)] = 324118,
  [SMALL_STATE(7769)] = 324162,
  [SMALL_STATE(7770)] = 324206,
  [SMALL_STATE(7771)] = 324250,
  [SMALL_STATE(7772)] = 324294,
  [SMALL_STATE(7773)] = 324338,
  [SMALL_STATE(7774)] = 324382,
  [SMALL_STATE(7775)] = 324426,
  [SMALL_STATE(7776)] = 324470,
  [SMALL_STATE(7777)] = 324514,
  [SMALL_STATE(7778)] = 324560,
  [SMALL_STATE(7779)] = 324604,
  [SMALL_STATE(7780)] = 324664,
  [SMALL_STATE(7781)] = 324710,
  [SMALL_STATE(7782)] = 324754,
  [SMALL_STATE(7783)] = 324798,
  [SMALL_STATE(7784)] = 324842,
  [SMALL_STATE(7785)] = 324886,
  [SMALL_STATE(7786)] = 324930,
  [SMALL_STATE(7787)] = 324974,
  [SMALL_STATE(7788)] = 325020,
  [SMALL_STATE(7789)] = 325064,
  [SMALL_STATE(7790)] = 325110,
  [SMALL_STATE(7791)] = 325170,
  [SMALL_STATE(7792)] = 325214,
  [SMALL_STATE(7793)] = 325258,
  [SMALL_STATE(7794)] = 325302,
  [SMALL_STATE(7795)] = 325346,
  [SMALL_STATE(7796)] = 325390,
  [SMALL_STATE(7797)] = 325436,
  [SMALL_STATE(7798)] = 325480,
  [SMALL_STATE(7799)] = 325524,
  [SMALL_STATE(7800)] = 325568,
  [SMALL_STATE(7801)] = 325612,
  [SMALL_STATE(7802)] = 325656,
  [SMALL_STATE(7803)] = 325700,
  [SMALL_STATE(7804)] = 325744,
  [SMALL_STATE(7805)] = 325788,
  [SMALL_STATE(7806)] = 325832,
  [SMALL_STATE(7807)] = 325876,
  [SMALL_STATE(7808)] = 325920,
  [SMALL_STATE(7809)] = 325964,
  [SMALL_STATE(7810)] = 326008,
  [SMALL_STATE(7811)] = 326052,
  [SMALL_STATE(7812)] = 326096,
  [SMALL_STATE(7813)] = 326140,
  [SMALL_STATE(7814)] = 326184,
  [SMALL_STATE(7815)] = 326228,
  [SMALL_STATE(7816)] = 326272,
  [SMALL_STATE(7817)] = 326316,
  [SMALL_STATE(7818)] = 326360,
  [SMALL_STATE(7819)] = 326404,
  [SMALL_STATE(7820)] = 326448,
  [SMALL_STATE(7821)] = 326492,
  [SMALL_STATE(7822)] = 326536,
  [SMALL_STATE(7823)] = 326580,
  [SMALL_STATE(7824)] = 326624,
  [SMALL_STATE(7825)] = 326668,
  [SMALL_STATE(7826)] = 326712,
  [SMALL_STATE(7827)] = 326756,
  [SMALL_STATE(7828)] = 326800,
  [SMALL_STATE(7829)] = 326844,
  [SMALL_STATE(7830)] = 326888,
  [SMALL_STATE(7831)] = 326932,
  [SMALL_STATE(7832)] = 326976,
  [SMALL_STATE(7833)] = 327020,
  [SMALL_STATE(7834)] = 327064,
  [SMALL_STATE(7835)] = 327108,
  [SMALL_STATE(7836)] = 327152,
  [SMALL_STATE(7837)] = 327196,
  [SMALL_STATE(7838)] = 327240,
  [SMALL_STATE(7839)] = 327300,
  [SMALL_STATE(7840)] = 327344,
  [SMALL_STATE(7841)] = 327388,
  [SMALL_STATE(7842)] = 327432,
  [SMALL_STATE(7843)] = 327476,
  [SMALL_STATE(7844)] = 327522,
  [SMALL_STATE(7845)] = 327566,
  [SMALL_STATE(7846)] = 327610,
  [SMALL_STATE(7847)] = 327654,
  [SMALL_STATE(7848)] = 327698,
  [SMALL_STATE(7849)] = 327742,
  [SMALL_STATE(7850)] = 327786,
  [SMALL_STATE(7851)] = 327830,
  [SMALL_STATE(7852)] = 327874,
  [SMALL_STATE(7853)] = 327918,
  [SMALL_STATE(7854)] = 327962,
  [SMALL_STATE(7855)] = 328006,
  [SMALL_STATE(7856)] = 328050,
  [SMALL_STATE(7857)] = 328094,
  [SMALL_STATE(7858)] = 328138,
  [SMALL_STATE(7859)] = 328182,
  [SMALL_STATE(7860)] = 328226,
  [SMALL_STATE(7861)] = 328270,
  [SMALL_STATE(7862)] = 328314,
  [SMALL_STATE(7863)] = 328358,
  [SMALL_STATE(7864)] = 328418,
  [SMALL_STATE(7865)] = 328462,
  [SMALL_STATE(7866)] = 328506,
  [SMALL_STATE(7867)] = 328550,
  [SMALL_STATE(7868)] = 328596,
  [SMALL_STATE(7869)] = 328640,
  [SMALL_STATE(7870)] = 328684,
  [SMALL_STATE(7871)] = 328728,
  [SMALL_STATE(7872)] = 328772,
  [SMALL_STATE(7873)] = 328816,
  [SMALL_STATE(7874)] = 328860,
  [SMALL_STATE(7875)] = 328904,
  [SMALL_STATE(7876)] = 328948,
  [SMALL_STATE(7877)] = 328992,
  [SMALL_STATE(7878)] = 329036,
  [SMALL_STATE(7879)] = 329080,
  [SMALL_STATE(7880)] = 329124,
  [SMALL_STATE(7881)] = 329168,
  [SMALL_STATE(7882)] = 329214,
  [SMALL_STATE(7883)] = 329260,
  [SMALL_STATE(7884)] = 329306,
  [SMALL_STATE(7885)] = 329350,
  [SMALL_STATE(7886)] = 329393,
  [SMALL_STATE(7887)] = 329436,
  [SMALL_STATE(7888)] = 329479,
  [SMALL_STATE(7889)] = 329522,
  [SMALL_STATE(7890)] = 329565,
  [SMALL_STATE(7891)] = 329608,
  [SMALL_STATE(7892)] = 329651,
  [SMALL_STATE(7893)] = 329694,
  [SMALL_STATE(7894)] = 329737,
  [SMALL_STATE(7895)] = 329780,
  [SMALL_STATE(7896)] = 329825,
  [SMALL_STATE(7897)] = 329870,
  [SMALL_STATE(7898)] = 329913,
  [SMALL_STATE(7899)] = 329956,
  [SMALL_STATE(7900)] = 329999,
  [SMALL_STATE(7901)] = 330042,
  [SMALL_STATE(7902)] = 330085,
  [SMALL_STATE(7903)] = 330128,
  [SMALL_STATE(7904)] = 330171,
  [SMALL_STATE(7905)] = 330214,
  [SMALL_STATE(7906)] = 330257,
  [SMALL_STATE(7907)] = 330300,
  [SMALL_STATE(7908)] = 330343,
  [SMALL_STATE(7909)] = 330386,
  [SMALL_STATE(7910)] = 330429,
  [SMALL_STATE(7911)] = 330472,
  [SMALL_STATE(7912)] = 330515,
  [SMALL_STATE(7913)] = 330558,
  [SMALL_STATE(7914)] = 330601,
  [SMALL_STATE(7915)] = 330644,
  [SMALL_STATE(7916)] = 330687,
  [SMALL_STATE(7917)] = 330730,
  [SMALL_STATE(7918)] = 330773,
  [SMALL_STATE(7919)] = 330816,
  [SMALL_STATE(7920)] = 330859,
  [SMALL_STATE(7921)] = 330902,
  [SMALL_STATE(7922)] = 330945,
  [SMALL_STATE(7923)] = 330988,
  [SMALL_STATE(7924)] = 331031,
  [SMALL_STATE(7925)] = 331088,
  [SMALL_STATE(7926)] = 331131,
  [SMALL_STATE(7927)] = 331174,
  [SMALL_STATE(7928)] = 331217,
  [SMALL_STATE(7929)] = 331260,
  [SMALL_STATE(7930)] = 331317,
  [SMALL_STATE(7931)] = 331360,
  [SMALL_STATE(7932)] = 331403,
  [SMALL_STATE(7933)] = 331446,
  [SMALL_STATE(7934)] = 331489,
  [SMALL_STATE(7935)] = 331532,
  [SMALL_STATE(7936)] = 331575,
  [SMALL_STATE(7937)] = 331618,
  [SMALL_STATE(7938)] = 331661,
  [SMALL_STATE(7939)] = 331704,
  [SMALL_STATE(7940)] = 331747,
  [SMALL_STATE(7941)] = 331792,
  [SMALL_STATE(7942)] = 331835,
  [SMALL_STATE(7943)] = 331878,
  [SMALL_STATE(7944)] = 331921,
  [SMALL_STATE(7945)] = 331964,
  [SMALL_STATE(7946)] = 332007,
  [SMALL_STATE(7947)] = 332050,
  [SMALL_STATE(7948)] = 332093,
  [SMALL_STATE(7949)] = 332136,
  [SMALL_STATE(7950)] = 332179,
  [SMALL_STATE(7951)] = 332222,
  [SMALL_STATE(7952)] = 332265,
  [SMALL_STATE(7953)] = 332308,
  [SMALL_STATE(7954)] = 332351,
  [SMALL_STATE(7955)] = 332394,
  [SMALL_STATE(7956)] = 332437,
  [SMALL_STATE(7957)] = 332480,
  [SMALL_STATE(7958)] = 332523,
  [SMALL_STATE(7959)] = 332566,
  [SMALL_STATE(7960)] = 332609,
  [SMALL_STATE(7961)] = 332652,
  [SMALL_STATE(7962)] = 332695,
  [SMALL_STATE(7963)] = 332738,
  [SMALL_STATE(7964)] = 332781,
  [SMALL_STATE(7965)] = 332824,
  [SMALL_STATE(7966)] = 332867,
  [SMALL_STATE(7967)] = 332910,
  [SMALL_STATE(7968)] = 332953,
  [SMALL_STATE(7969)] = 332996,
  [SMALL_STATE(7970)] = 333039,
  [SMALL_STATE(7971)] = 333082,
  [SMALL_STATE(7972)] = 333125,
  [SMALL_STATE(7973)] = 333168,
  [SMALL_STATE(7974)] = 333211,
  [SMALL_STATE(7975)] = 333254,
  [SMALL_STATE(7976)] = 333297,
  [SMALL_STATE(7977)] = 333340,
  [SMALL_STATE(7978)] = 333383,
  [SMALL_STATE(7979)] = 333426,
  [SMALL_STATE(7980)] = 333469,
  [SMALL_STATE(7981)] = 333512,
  [SMALL_STATE(7982)] = 333555,
  [SMALL_STATE(7983)] = 333598,
  [SMALL_STATE(7984)] = 333641,
  [SMALL_STATE(7985)] = 333684,
  [SMALL_STATE(7986)] = 333727,
  [SMALL_STATE(7987)] = 333770,
  [SMALL_STATE(7988)] = 333813,
  [SMALL_STATE(7989)] = 333856,
  [SMALL_STATE(7990)] = 333901,
  [SMALL_STATE(7991)] = 333946,
  [SMALL_STATE(7992)] = 333989,
  [SMALL_STATE(7993)] = 334032,
  [SMALL_STATE(7994)] = 334075,
  [SMALL_STATE(7995)] = 334118,
  [SMALL_STATE(7996)] = 334175,
  [SMALL_STATE(7997)] = 334218,
  [SMALL_STATE(7998)] = 334261,
  [SMALL_STATE(7999)] = 334304,
  [SMALL_STATE(8000)] = 334347,
  [SMALL_STATE(8001)] = 334390,
  [SMALL_STATE(8002)] = 334433,
  [SMALL_STATE(8003)] = 334476,
  [SMALL_STATE(8004)] = 334519,
  [SMALL_STATE(8005)] = 334562,
  [SMALL_STATE(8006)] = 334605,
  [SMALL_STATE(8007)] = 334648,
  [SMALL_STATE(8008)] = 334691,
  [SMALL_STATE(8009)] = 334734,
  [SMALL_STATE(8010)] = 334779,
  [SMALL_STATE(8011)] = 334822,
  [SMALL_STATE(8012)] = 334865,
  [SMALL_STATE(8013)] = 334908,
  [SMALL_STATE(8014)] = 334951,
  [SMALL_STATE(8015)] = 334994,
  [SMALL_STATE(8016)] = 335037,
  [SMALL_STATE(8017)] = 335080,
  [SMALL_STATE(8018)] = 335123,
  [SMALL_STATE(8019)] = 335166,
  [SMALL_STATE(8020)] = 335209,
  [SMALL_STATE(8021)] = 335252,
  [SMALL_STATE(8022)] = 335295,
  [SMALL_STATE(8023)] = 335338,
  [SMALL_STATE(8024)] = 335381,
  [SMALL_STATE(8025)] = 335424,
  [SMALL_STATE(8026)] = 335467,
  [SMALL_STATE(8027)] = 335510,
  [SMALL_STATE(8028)] = 335553,
  [SMALL_STATE(8029)] = 335596,
  [SMALL_STATE(8030)] = 335639,
  [SMALL_STATE(8031)] = 335696,
  [SMALL_STATE(8032)] = 335739,
  [SMALL_STATE(8033)] = 335782,
  [SMALL_STATE(8034)] = 335825,
  [SMALL_STATE(8035)] = 335868,
  [SMALL_STATE(8036)] = 335911,
  [SMALL_STATE(8037)] = 335954,
  [SMALL_STATE(8038)] = 335999,
  [SMALL_STATE(8039)] = 336044,
  [SMALL_STATE(8040)] = 336087,
  [SMALL_STATE(8041)] = 336130,
  [SMALL_STATE(8042)] = 336173,
  [SMALL_STATE(8043)] = 336216,
  [SMALL_STATE(8044)] = 336259,
  [SMALL_STATE(8045)] = 336320,
  [SMALL_STATE(8046)] = 336363,
  [SMALL_STATE(8047)] = 336406,
  [SMALL_STATE(8048)] = 336449,
  [SMALL_STATE(8049)] = 336492,
  [SMALL_STATE(8050)] = 336535,
  [SMALL_STATE(8051)] = 336578,
  [SMALL_STATE(8052)] = 336621,
  [SMALL_STATE(8053)] = 336664,
  [SMALL_STATE(8054)] = 336707,
  [SMALL_STATE(8055)] = 336750,
  [SMALL_STATE(8056)] = 336793,
  [SMALL_STATE(8057)] = 336836,
  [SMALL_STATE(8058)] = 336879,
  [SMALL_STATE(8059)] = 336922,
  [SMALL_STATE(8060)] = 336965,
  [SMALL_STATE(8061)] = 337008,
  [SMALL_STATE(8062)] = 337053,
  [SMALL_STATE(8063)] = 337096,
  [SMALL_STATE(8064)] = 337139,
  [SMALL_STATE(8065)] = 337182,
  [SMALL_STATE(8066)] = 337225,
  [SMALL_STATE(8067)] = 337268,
  [SMALL_STATE(8068)] = 337311,
  [SMALL_STATE(8069)] = 337354,
  [SMALL_STATE(8070)] = 337397,
  [SMALL_STATE(8071)] = 337440,
  [SMALL_STATE(8072)] = 337483,
  [SMALL_STATE(8073)] = 337526,
  [SMALL_STATE(8074)] = 337569,
  [SMALL_STATE(8075)] = 337612,
  [SMALL_STATE(8076)] = 337655,
  [SMALL_STATE(8077)] = 337698,
  [SMALL_STATE(8078)] = 337741,
  [SMALL_STATE(8079)] = 337784,
  [SMALL_STATE(8080)] = 337827,
  [SMALL_STATE(8081)] = 337870,
  [SMALL_STATE(8082)] = 337913,
  [SMALL_STATE(8083)] = 337956,
  [SMALL_STATE(8084)] = 338001,
  [SMALL_STATE(8085)] = 338044,
  [SMALL_STATE(8086)] = 338089,
  [SMALL_STATE(8087)] = 338132,
  [SMALL_STATE(8088)] = 338175,
  [SMALL_STATE(8089)] = 338218,
  [SMALL_STATE(8090)] = 338261,
  [SMALL_STATE(8091)] = 338304,
  [SMALL_STATE(8092)] = 338347,
  [SMALL_STATE(8093)] = 338390,
  [SMALL_STATE(8094)] = 338451,
  [SMALL_STATE(8095)] = 338494,
  [SMALL_STATE(8096)] = 338537,
  [SMALL_STATE(8097)] = 338580,
  [SMALL_STATE(8098)] = 338623,
  [SMALL_STATE(8099)] = 338666,
  [SMALL_STATE(8100)] = 338709,
  [SMALL_STATE(8101)] = 338752,
  [SMALL_STATE(8102)] = 338795,
  [SMALL_STATE(8103)] = 338838,
  [SMALL_STATE(8104)] = 338881,
  [SMALL_STATE(8105)] = 338924,
  [SMALL_STATE(8106)] = 338967,
  [SMALL_STATE(8107)] = 339010,
  [SMALL_STATE(8108)] = 339053,
  [SMALL_STATE(8109)] = 339096,
  [SMALL_STATE(8110)] = 339139,
  [SMALL_STATE(8111)] = 339182,
  [SMALL_STATE(8112)] = 339225,
  [SMALL_STATE(8113)] = 339268,
  [SMALL_STATE(8114)] = 339311,
  [SMALL_STATE(8115)] = 339354,
  [SMALL_STATE(8116)] = 339397,
  [SMALL_STATE(8117)] = 339440,
  [SMALL_STATE(8118)] = 339483,
  [SMALL_STATE(8119)] = 339526,
  [SMALL_STATE(8120)] = 339569,
  [SMALL_STATE(8121)] = 339612,
  [SMALL_STATE(8122)] = 339669,
  [SMALL_STATE(8123)] = 339712,
  [SMALL_STATE(8124)] = 339755,
  [SMALL_STATE(8125)] = 339798,
  [SMALL_STATE(8126)] = 339841,
  [SMALL_STATE(8127)] = 339884,
  [SMALL_STATE(8128)] = 339927,
  [SMALL_STATE(8129)] = 339970,
  [SMALL_STATE(8130)] = 340013,
  [SMALL_STATE(8131)] = 340056,
  [SMALL_STATE(8132)] = 340099,
  [SMALL_STATE(8133)] = 340142,
  [SMALL_STATE(8134)] = 340185,
  [SMALL_STATE(8135)] = 340228,
  [SMALL_STATE(8136)] = 340271,
  [SMALL_STATE(8137)] = 340314,
  [SMALL_STATE(8138)] = 340357,
  [SMALL_STATE(8139)] = 340402,
  [SMALL_STATE(8140)] = 340445,
  [SMALL_STATE(8141)] = 340488,
  [SMALL_STATE(8142)] = 340531,
  [SMALL_STATE(8143)] = 340574,
  [SMALL_STATE(8144)] = 340617,
  [SMALL_STATE(8145)] = 340660,
  [SMALL_STATE(8146)] = 340703,
  [SMALL_STATE(8147)] = 340746,
  [SMALL_STATE(8148)] = 340789,
  [SMALL_STATE(8149)] = 340832,
  [SMALL_STATE(8150)] = 340875,
  [SMALL_STATE(8151)] = 340918,
  [SMALL_STATE(8152)] = 340961,
  [SMALL_STATE(8153)] = 341004,
  [SMALL_STATE(8154)] = 341047,
  [SMALL_STATE(8155)] = 341090,
  [SMALL_STATE(8156)] = 341133,
  [SMALL_STATE(8157)] = 341178,
  [SMALL_STATE(8158)] = 341221,
  [SMALL_STATE(8159)] = 341264,
  [SMALL_STATE(8160)] = 341307,
  [SMALL_STATE(8161)] = 341352,
  [SMALL_STATE(8162)] = 341395,
  [SMALL_STATE(8163)] = 341438,
  [SMALL_STATE(8164)] = 341481,
  [SMALL_STATE(8165)] = 341524,
  [SMALL_STATE(8166)] = 341567,
  [SMALL_STATE(8167)] = 341610,
  [SMALL_STATE(8168)] = 341653,
  [SMALL_STATE(8169)] = 341696,
  [SMALL_STATE(8170)] = 341739,
  [SMALL_STATE(8171)] = 341782,
  [SMALL_STATE(8172)] = 341825,
  [SMALL_STATE(8173)] = 341868,
  [SMALL_STATE(8174)] = 341911,
  [SMALL_STATE(8175)] = 341954,
  [SMALL_STATE(8176)] = 341997,
  [SMALL_STATE(8177)] = 342054,
  [SMALL_STATE(8178)] = 342097,
  [SMALL_STATE(8179)] = 342140,
  [SMALL_STATE(8180)] = 342183,
  [SMALL_STATE(8181)] = 342226,
  [SMALL_STATE(8182)] = 342269,
  [SMALL_STATE(8183)] = 342312,
  [SMALL_STATE(8184)] = 342355,
  [SMALL_STATE(8185)] = 342398,
  [SMALL_STATE(8186)] = 342441,
  [SMALL_STATE(8187)] = 342484,
  [SMALL_STATE(8188)] = 342529,
  [SMALL_STATE(8189)] = 342572,
  [SMALL_STATE(8190)] = 342615,
  [SMALL_STATE(8191)] = 342657,
  [SMALL_STATE(8192)] = 342701,
  [SMALL_STATE(8193)] = 342743,
  [SMALL_STATE(8194)] = 342785,
  [SMALL_STATE(8195)] = 342845,
  [SMALL_STATE(8196)] = 342887,
  [SMALL_STATE(8197)] = 342929,
  [SMALL_STATE(8198)] = 342979,
  [SMALL_STATE(8199)] = 343025,
  [SMALL_STATE(8200)] = 343085,
  [SMALL_STATE(8201)] = 343127,
  [SMALL_STATE(8202)] = 343169,
  [SMALL_STATE(8203)] = 343211,
  [SMALL_STATE(8204)] = 343253,
  [SMALL_STATE(8205)] = 343295,
  [SMALL_STATE(8206)] = 343337,
  [SMALL_STATE(8207)] = 343379,
  [SMALL_STATE(8208)] = 343421,
  [SMALL_STATE(8209)] = 343463,
  [SMALL_STATE(8210)] = 343505,
  [SMALL_STATE(8211)] = 343547,
  [SMALL_STATE(8212)] = 343589,
  [SMALL_STATE(8213)] = 343649,
  [SMALL_STATE(8214)] = 343693,
  [SMALL_STATE(8215)] = 343753,
  [SMALL_STATE(8216)] = 343813,
  [SMALL_STATE(8217)] = 343855,
  [SMALL_STATE(8218)] = 343897,
  [SMALL_STATE(8219)] = 343939,
  [SMALL_STATE(8220)] = 343981,
  [SMALL_STATE(8221)] = 344023,
  [SMALL_STATE(8222)] = 344065,
  [SMALL_STATE(8223)] = 344109,
  [SMALL_STATE(8224)] = 344151,
  [SMALL_STATE(8225)] = 344201,
  [SMALL_STATE(8226)] = 344243,
  [SMALL_STATE(8227)] = 344285,
  [SMALL_STATE(8228)] = 344327,
  [SMALL_STATE(8229)] = 344369,
  [SMALL_STATE(8230)] = 344411,
  [SMALL_STATE(8231)] = 344453,
  [SMALL_STATE(8232)] = 344495,
  [SMALL_STATE(8233)] = 344555,
  [SMALL_STATE(8234)] = 344597,
  [SMALL_STATE(8235)] = 344639,
  [SMALL_STATE(8236)] = 344685,
  [SMALL_STATE(8237)] = 344729,
  [SMALL_STATE(8238)] = 344771,
  [SMALL_STATE(8239)] = 344813,
  [SMALL_STATE(8240)] = 344855,
  [SMALL_STATE(8241)] = 344899,
  [SMALL_STATE(8242)] = 344941,
  [SMALL_STATE(8243)] = 344983,
  [SMALL_STATE(8244)] = 345033,
  [SMALL_STATE(8245)] = 345075,
  [SMALL_STATE(8246)] = 345119,
  [SMALL_STATE(8247)] = 345178,
  [SMALL_STATE(8248)] = 345219,
  [SMALL_STATE(8249)] = 345260,
  [SMALL_STATE(8250)] = 345319,
  [SMALL_STATE(8251)] = 345360,
  [SMALL_STATE(8252)] = 345401,
  [SMALL_STATE(8253)] = 345460,
  [SMALL_STATE(8254)] = 345503,
  [SMALL_STATE(8255)] = 345550,
  [SMALL_STATE(8256)] = 345591,
  [SMALL_STATE(8257)] = 345634,
  [SMALL_STATE(8258)] = 345675,
  [SMALL_STATE(8259)] = 345716,
  [SMALL_STATE(8260)] = 345759,
  [SMALL_STATE(8261)] = 345802,
  [SMALL_STATE(8262)] = 345843,
  [SMALL_STATE(8263)] = 345886,
  [SMALL_STATE(8264)] = 345949,
  [SMALL_STATE(8265)] = 345990,
  [SMALL_STATE(8266)] = 346031,
  [SMALL_STATE(8267)] = 346090,
  [SMALL_STATE(8268)] = 346131,
  [SMALL_STATE(8269)] = 346174,
  [SMALL_STATE(8270)] = 346233,
  [SMALL_STATE(8271)] = 346276,
  [SMALL_STATE(8272)] = 346319,
  [SMALL_STATE(8273)] = 346360,
  [SMALL_STATE(8274)] = 346401,
  [SMALL_STATE(8275)] = 346442,
  [SMALL_STATE(8276)] = 346483,
  [SMALL_STATE(8277)] = 346524,
  [SMALL_STATE(8278)] = 346567,
  [SMALL_STATE(8279)] = 346610,
  [SMALL_STATE(8280)] = 346657,
  [SMALL_STATE(8281)] = 346698,
  [SMALL_STATE(8282)] = 346739,
  [SMALL_STATE(8283)] = 346780,
  [SMALL_STATE(8284)] = 346827,
  [SMALL_STATE(8285)] = 346870,
  [SMALL_STATE(8286)] = 346911,
  [SMALL_STATE(8287)] = 346952,
  [SMALL_STATE(8288)] = 346997,
  [SMALL_STATE(8289)] = 347038,
  [SMALL_STATE(8290)] = 347081,
  [SMALL_STATE(8291)] = 347122,
  [SMALL_STATE(8292)] = 347163,
  [SMALL_STATE(8293)] = 347204,
  [SMALL_STATE(8294)] = 347245,
  [SMALL_STATE(8295)] = 347288,
  [SMALL_STATE(8296)] = 347333,
  [SMALL_STATE(8297)] = 347392,
  [SMALL_STATE(8298)] = 347451,
  [SMALL_STATE(8299)] = 347510,
  [SMALL_STATE(8300)] = 347551,
  [SMALL_STATE(8301)] = 347592,
  [SMALL_STATE(8302)] = 347633,
  [SMALL_STATE(8303)] = 347676,
  [SMALL_STATE(8304)] = 347717,
  [SMALL_STATE(8305)] = 347776,
  [SMALL_STATE(8306)] = 347817,
  [SMALL_STATE(8307)] = 347858,
  [SMALL_STATE(8308)] = 347901,
  [SMALL_STATE(8309)] = 347942,
  [SMALL_STATE(8310)] = 347983,
  [SMALL_STATE(8311)] = 348024,
  [SMALL_STATE(8312)] = 348067,
  [SMALL_STATE(8313)] = 348108,
  [SMALL_STATE(8314)] = 348151,
  [SMALL_STATE(8315)] = 348193,
  [SMALL_STATE(8316)] = 348235,
  [SMALL_STATE(8317)] = 348275,
  [SMALL_STATE(8318)] = 348317,
  [SMALL_STATE(8319)] = 348359,
  [SMALL_STATE(8320)] = 348399,
  [SMALL_STATE(8321)] = 348441,
  [SMALL_STATE(8322)] = 348483,
  [SMALL_STATE(8323)] = 348525,
  [SMALL_STATE(8324)] = 348567,
  [SMALL_STATE(8325)] = 348607,
  [SMALL_STATE(8326)] = 348649,
  [SMALL_STATE(8327)] = 348691,
  [SMALL_STATE(8328)] = 348733,
  [SMALL_STATE(8329)] = 348773,
  [SMALL_STATE(8330)] = 348813,
  [SMALL_STATE(8331)] = 348855,
  [SMALL_STATE(8332)] = 348897,
  [SMALL_STATE(8333)] = 348937,
  [SMALL_STATE(8334)] = 348977,
  [SMALL_STATE(8335)] = 349017,
  [SMALL_STATE(8336)] = 349059,
  [SMALL_STATE(8337)] = 349099,
  [SMALL_STATE(8338)] = 349139,
  [SMALL_STATE(8339)] = 349179,
  [SMALL_STATE(8340)] = 349221,
  [SMALL_STATE(8341)] = 349263,
  [SMALL_STATE(8342)] = 349305,
  [SMALL_STATE(8343)] = 349345,
  [SMALL_STATE(8344)] = 349385,
  [SMALL_STATE(8345)] = 349425,
  [SMALL_STATE(8346)] = 349465,
  [SMALL_STATE(8347)] = 349507,
  [SMALL_STATE(8348)] = 349547,
  [SMALL_STATE(8349)] = 349589,
  [SMALL_STATE(8350)] = 349629,
  [SMALL_STATE(8351)] = 349671,
  [SMALL_STATE(8352)] = 349733,
  [SMALL_STATE(8353)] = 349773,
  [SMALL_STATE(8354)] = 349815,
  [SMALL_STATE(8355)] = 349857,
  [SMALL_STATE(8356)] = 349899,
  [SMALL_STATE(8357)] = 349939,
  [SMALL_STATE(8358)] = 349981,
  [SMALL_STATE(8359)] = 350021,
  [SMALL_STATE(8360)] = 350061,
  [SMALL_STATE(8361)] = 350103,
  [SMALL_STATE(8362)] = 350145,
  [SMALL_STATE(8363)] = 350187,
  [SMALL_STATE(8364)] = 350227,
  [SMALL_STATE(8365)] = 350269,
  [SMALL_STATE(8366)] = 350309,
  [SMALL_STATE(8367)] = 350351,
  [SMALL_STATE(8368)] = 350391,
  [SMALL_STATE(8369)] = 350433,
  [SMALL_STATE(8370)] = 350473,
  [SMALL_STATE(8371)] = 350513,
  [SMALL_STATE(8372)] = 350553,
  [SMALL_STATE(8373)] = 350595,
  [SMALL_STATE(8374)] = 350635,
  [SMALL_STATE(8375)] = 350675,
  [SMALL_STATE(8376)] = 350715,
  [SMALL_STATE(8377)] = 350757,
  [SMALL_STATE(8378)] = 350799,
  [SMALL_STATE(8379)] = 350839,
  [SMALL_STATE(8380)] = 350879,
  [SMALL_STATE(8381)] = 350921,
  [SMALL_STATE(8382)] = 350961,
  [SMALL_STATE(8383)] = 351003,
  [SMALL_STATE(8384)] = 351045,
  [SMALL_STATE(8385)] = 351085,
  [SMALL_STATE(8386)] = 351127,
  [SMALL_STATE(8387)] = 351169,
  [SMALL_STATE(8388)] = 351209,
  [SMALL_STATE(8389)] = 351251,
  [SMALL_STATE(8390)] = 351293,
  [SMALL_STATE(8391)] = 351335,
  [SMALL_STATE(8392)] = 351377,
  [SMALL_STATE(8393)] = 351417,
  [SMALL_STATE(8394)] = 351459,
  [SMALL_STATE(8395)] = 351501,
  [SMALL_STATE(8396)] = 351541,
  [SMALL_STATE(8397)] = 351583,
  [SMALL_STATE(8398)] = 351623,
  [SMALL_STATE(8399)] = 351663,
  [SMALL_STATE(8400)] = 351705,
  [SMALL_STATE(8401)] = 351747,
  [SMALL_STATE(8402)] = 351787,
  [SMALL_STATE(8403)] = 351845,
  [SMALL_STATE(8404)] = 351887,
  [SMALL_STATE(8405)] = 351929,
  [SMALL_STATE(8406)] = 351971,
  [SMALL_STATE(8407)] = 352013,
  [SMALL_STATE(8408)] = 352075,
  [SMALL_STATE(8409)] = 352117,
  [SMALL_STATE(8410)] = 352157,
  [SMALL_STATE(8411)] = 352199,
  [SMALL_STATE(8412)] = 352241,
  [SMALL_STATE(8413)] = 352283,
  [SMALL_STATE(8414)] = 352325,
  [SMALL_STATE(8415)] = 352365,
  [SMALL_STATE(8416)] = 352407,
  [SMALL_STATE(8417)] = 352449,
  [SMALL_STATE(8418)] = 352491,
  [SMALL_STATE(8419)] = 352533,
  [SMALL_STATE(8420)] = 352575,
  [SMALL_STATE(8421)] = 352617,
  [SMALL_STATE(8422)] = 352659,
  [SMALL_STATE(8423)] = 352717,
  [SMALL_STATE(8424)] = 352757,
  [SMALL_STATE(8425)] = 352799,
  [SMALL_STATE(8426)] = 352841,
  [SMALL_STATE(8427)] = 352881,
  [SMALL_STATE(8428)] = 352921,
  [SMALL_STATE(8429)] = 352963,
  [SMALL_STATE(8430)] = 353005,
  [SMALL_STATE(8431)] = 353047,
  [SMALL_STATE(8432)] = 353089,
  [SMALL_STATE(8433)] = 353131,
  [SMALL_STATE(8434)] = 353173,
  [SMALL_STATE(8435)] = 353213,
  [SMALL_STATE(8436)] = 353255,
  [SMALL_STATE(8437)] = 353297,
  [SMALL_STATE(8438)] = 353337,
  [SMALL_STATE(8439)] = 353377,
  [SMALL_STATE(8440)] = 353419,
  [SMALL_STATE(8441)] = 353461,
  [SMALL_STATE(8442)] = 353503,
  [SMALL_STATE(8443)] = 353561,
  [SMALL_STATE(8444)] = 353601,
  [SMALL_STATE(8445)] = 353643,
  [SMALL_STATE(8446)] = 353685,
  [SMALL_STATE(8447)] = 353725,
  [SMALL_STATE(8448)] = 353765,
  [SMALL_STATE(8449)] = 353807,
  [SMALL_STATE(8450)] = 353849,
  [SMALL_STATE(8451)] = 353889,
  [SMALL_STATE(8452)] = 353931,
  [SMALL_STATE(8453)] = 353971,
  [SMALL_STATE(8454)] = 354011,
  [SMALL_STATE(8455)] = 354055,
  [SMALL_STATE(8456)] = 354095,
  [SMALL_STATE(8457)] = 354135,
  [SMALL_STATE(8458)] = 354177,
  [SMALL_STATE(8459)] = 354217,
  [SMALL_STATE(8460)] = 354257,
  [SMALL_STATE(8461)] = 354297,
  [SMALL_STATE(8462)] = 354339,
  [SMALL_STATE(8463)] = 354379,
  [SMALL_STATE(8464)] = 354431,
  [SMALL_STATE(8465)] = 354471,
  [SMALL_STATE(8466)] = 354513,
  [SMALL_STATE(8467)] = 354555,
  [SMALL_STATE(8468)] = 354595,
  [SMALL_STATE(8469)] = 354635,
  [SMALL_STATE(8470)] = 354677,
  [SMALL_STATE(8471)] = 354717,
  [SMALL_STATE(8472)] = 354759,
  [SMALL_STATE(8473)] = 354801,
  [SMALL_STATE(8474)] = 354841,
  [SMALL_STATE(8475)] = 354883,
  [SMALL_STATE(8476)] = 354941,
  [SMALL_STATE(8477)] = 354983,
  [SMALL_STATE(8478)] = 355025,
  [SMALL_STATE(8479)] = 355065,
  [SMALL_STATE(8480)] = 355107,
  [SMALL_STATE(8481)] = 355147,
  [SMALL_STATE(8482)] = 355187,
  [SMALL_STATE(8483)] = 355227,
  [SMALL_STATE(8484)] = 355285,
  [SMALL_STATE(8485)] = 355327,
  [SMALL_STATE(8486)] = 355369,
  [SMALL_STATE(8487)] = 355408,
  [SMALL_STATE(8488)] = 355449,
  [SMALL_STATE(8489)] = 355492,
  [SMALL_STATE(8490)] = 355531,
  [SMALL_STATE(8491)] = 355574,
  [SMALL_STATE(8492)] = 355613,
  [SMALL_STATE(8493)] = 355652,
  [SMALL_STATE(8494)] = 355693,
  [SMALL_STATE(8495)] = 355736,
  [SMALL_STATE(8496)] = 355775,
  [SMALL_STATE(8497)] = 355814,
  [SMALL_STATE(8498)] = 355853,
  [SMALL_STATE(8499)] = 355896,
  [SMALL_STATE(8500)] = 355937,
  [SMALL_STATE(8501)] = 355978,
  [SMALL_STATE(8502)] = 356019,
  [SMALL_STATE(8503)] = 356058,
  [SMALL_STATE(8504)] = 356097,
  [SMALL_STATE(8505)] = 356136,
  [SMALL_STATE(8506)] = 356175,
  [SMALL_STATE(8507)] = 356214,
  [SMALL_STATE(8508)] = 356253,
  [SMALL_STATE(8509)] = 356292,
  [SMALL_STATE(8510)] = 356335,
  [SMALL_STATE(8511)] = 356374,
  [SMALL_STATE(8512)] = 356413,
  [SMALL_STATE(8513)] = 356452,
  [SMALL_STATE(8514)] = 356495,
  [SMALL_STATE(8515)] = 356534,
  [SMALL_STATE(8516)] = 356577,
  [SMALL_STATE(8517)] = 356616,
  [SMALL_STATE(8518)] = 356655,
  [SMALL_STATE(8519)] = 356704,
  [SMALL_STATE(8520)] = 356743,
  [SMALL_STATE(8521)] = 356782,
  [SMALL_STATE(8522)] = 356821,
  [SMALL_STATE(8523)] = 356860,
  [SMALL_STATE(8524)] = 356899,
  [SMALL_STATE(8525)] = 356938,
  [SMALL_STATE(8526)] = 356977,
  [SMALL_STATE(8527)] = 357016,
  [SMALL_STATE(8528)] = 357055,
  [SMALL_STATE(8529)] = 357094,
  [SMALL_STATE(8530)] = 357137,
  [SMALL_STATE(8531)] = 357176,
  [SMALL_STATE(8532)] = 357217,
  [SMALL_STATE(8533)] = 357256,
  [SMALL_STATE(8534)] = 357295,
  [SMALL_STATE(8535)] = 357334,
  [SMALL_STATE(8536)] = 357373,
  [SMALL_STATE(8537)] = 357412,
  [SMALL_STATE(8538)] = 357451,
  [SMALL_STATE(8539)] = 357490,
  [SMALL_STATE(8540)] = 357529,
  [SMALL_STATE(8541)] = 357568,
  [SMALL_STATE(8542)] = 357607,
  [SMALL_STATE(8543)] = 357646,
  [SMALL_STATE(8544)] = 357685,
  [SMALL_STATE(8545)] = 357724,
  [SMALL_STATE(8546)] = 357763,
  [SMALL_STATE(8547)] = 357802,
  [SMALL_STATE(8548)] = 357841,
  [SMALL_STATE(8549)] = 357880,
  [SMALL_STATE(8550)] = 357919,
  [SMALL_STATE(8551)] = 357962,
  [SMALL_STATE(8552)] = 358001,
  [SMALL_STATE(8553)] = 358040,
  [SMALL_STATE(8554)] = 358079,
  [SMALL_STATE(8555)] = 358126,
  [SMALL_STATE(8556)] = 358169,
  [SMALL_STATE(8557)] = 358208,
  [SMALL_STATE(8558)] = 358247,
  [SMALL_STATE(8559)] = 358286,
  [SMALL_STATE(8560)] = 358333,
  [SMALL_STATE(8561)] = 358372,
  [SMALL_STATE(8562)] = 358411,
  [SMALL_STATE(8563)] = 358458,
  [SMALL_STATE(8564)] = 358497,
  [SMALL_STATE(8565)] = 358536,
  [SMALL_STATE(8566)] = 358583,
  [SMALL_STATE(8567)] = 358622,
  [SMALL_STATE(8568)] = 358669,
  [SMALL_STATE(8569)] = 358708,
  [SMALL_STATE(8570)] = 358747,
  [SMALL_STATE(8571)] = 358786,
  [SMALL_STATE(8572)] = 358825,
  [SMALL_STATE(8573)] = 358864,
  [SMALL_STATE(8574)] = 358903,
  [SMALL_STATE(8575)] = 358944,
  [SMALL_STATE(8576)] = 358983,
  [SMALL_STATE(8577)] = 359022,
  [SMALL_STATE(8578)] = 359069,
  [SMALL_STATE(8579)] = 359108,
  [SMALL_STATE(8580)] = 359147,
  [SMALL_STATE(8581)] = 359186,
  [SMALL_STATE(8582)] = 359225,
  [SMALL_STATE(8583)] = 359264,
  [SMALL_STATE(8584)] = 359303,
  [SMALL_STATE(8585)] = 359342,
  [SMALL_STATE(8586)] = 359381,
  [SMALL_STATE(8587)] = 359420,
  [SMALL_STATE(8588)] = 359459,
  [SMALL_STATE(8589)] = 359498,
  [SMALL_STATE(8590)] = 359537,
  [SMALL_STATE(8591)] = 359576,
  [SMALL_STATE(8592)] = 359633,
  [SMALL_STATE(8593)] = 359672,
  [SMALL_STATE(8594)] = 359711,
  [SMALL_STATE(8595)] = 359750,
  [SMALL_STATE(8596)] = 359789,
  [SMALL_STATE(8597)] = 359830,
  [SMALL_STATE(8598)] = 359869,
  [SMALL_STATE(8599)] = 359908,
  [SMALL_STATE(8600)] = 359947,
  [SMALL_STATE(8601)] = 359986,
  [SMALL_STATE(8602)] = 360025,
  [SMALL_STATE(8603)] = 360064,
  [SMALL_STATE(8604)] = 360121,
  [SMALL_STATE(8605)] = 360160,
  [SMALL_STATE(8606)] = 360199,
  [SMALL_STATE(8607)] = 360238,
  [SMALL_STATE(8608)] = 360277,
  [SMALL_STATE(8609)] = 360316,
  [SMALL_STATE(8610)] = 360355,
  [SMALL_STATE(8611)] = 360394,
  [SMALL_STATE(8612)] = 360433,
  [SMALL_STATE(8613)] = 360472,
  [SMALL_STATE(8614)] = 360511,
  [SMALL_STATE(8615)] = 360550,
  [SMALL_STATE(8616)] = 360605,
  [SMALL_STATE(8617)] = 360644,
  [SMALL_STATE(8618)] = 360683,
  [SMALL_STATE(8619)] = 360722,
  [SMALL_STATE(8620)] = 360761,
  [SMALL_STATE(8621)] = 360800,
  [SMALL_STATE(8622)] = 360839,
  [SMALL_STATE(8623)] = 360878,
  [SMALL_STATE(8624)] = 360917,
  [SMALL_STATE(8625)] = 360960,
  [SMALL_STATE(8626)] = 360999,
  [SMALL_STATE(8627)] = 361038,
  [SMALL_STATE(8628)] = 361077,
  [SMALL_STATE(8629)] = 361116,
  [SMALL_STATE(8630)] = 361155,
  [SMALL_STATE(8631)] = 361196,
  [SMALL_STATE(8632)] = 361235,
  [SMALL_STATE(8633)] = 361274,
  [SMALL_STATE(8634)] = 361315,
  [SMALL_STATE(8635)] = 361354,
  [SMALL_STATE(8636)] = 361393,
  [SMALL_STATE(8637)] = 361432,
  [SMALL_STATE(8638)] = 361471,
  [SMALL_STATE(8639)] = 361510,
  [SMALL_STATE(8640)] = 361549,
  [SMALL_STATE(8641)] = 361588,
  [SMALL_STATE(8642)] = 361627,
  [SMALL_STATE(8643)] = 361666,
  [SMALL_STATE(8644)] = 361705,
  [SMALL_STATE(8645)] = 361744,
  [SMALL_STATE(8646)] = 361783,
  [SMALL_STATE(8647)] = 361822,
  [SMALL_STATE(8648)] = 361861,
  [SMALL_STATE(8649)] = 361902,
  [SMALL_STATE(8650)] = 361941,
  [SMALL_STATE(8651)] = 361980,
  [SMALL_STATE(8652)] = 362021,
  [SMALL_STATE(8653)] = 362060,
  [SMALL_STATE(8654)] = 362099,
  [SMALL_STATE(8655)] = 362138,
  [SMALL_STATE(8656)] = 362177,
  [SMALL_STATE(8657)] = 362216,
  [SMALL_STATE(8658)] = 362255,
  [SMALL_STATE(8659)] = 362294,
  [SMALL_STATE(8660)] = 362333,
  [SMALL_STATE(8661)] = 362372,
  [SMALL_STATE(8662)] = 362411,
  [SMALL_STATE(8663)] = 362450,
  [SMALL_STATE(8664)] = 362489,
  [SMALL_STATE(8665)] = 362528,
  [SMALL_STATE(8666)] = 362567,
  [SMALL_STATE(8667)] = 362606,
  [SMALL_STATE(8668)] = 362645,
  [SMALL_STATE(8669)] = 362684,
  [SMALL_STATE(8670)] = 362723,
  [SMALL_STATE(8671)] = 362762,
  [SMALL_STATE(8672)] = 362801,
  [SMALL_STATE(8673)] = 362840,
  [SMALL_STATE(8674)] = 362879,
  [SMALL_STATE(8675)] = 362918,
  [SMALL_STATE(8676)] = 362957,
  [SMALL_STATE(8677)] = 362996,
  [SMALL_STATE(8678)] = 363035,
  [SMALL_STATE(8679)] = 363090,
  [SMALL_STATE(8680)] = 363129,
  [SMALL_STATE(8681)] = 363168,
  [SMALL_STATE(8682)] = 363209,
  [SMALL_STATE(8683)] = 363248,
  [SMALL_STATE(8684)] = 363287,
  [SMALL_STATE(8685)] = 363326,
  [SMALL_STATE(8686)] = 363365,
  [SMALL_STATE(8687)] = 363404,
  [SMALL_STATE(8688)] = 363445,
  [SMALL_STATE(8689)] = 363484,
  [SMALL_STATE(8690)] = 363523,
  [SMALL_STATE(8691)] = 363562,
  [SMALL_STATE(8692)] = 363601,
  [SMALL_STATE(8693)] = 363640,
  [SMALL_STATE(8694)] = 363679,
  [SMALL_STATE(8695)] = 363718,
  [SMALL_STATE(8696)] = 363757,
  [SMALL_STATE(8697)] = 363796,
  [SMALL_STATE(8698)] = 363835,
  [SMALL_STATE(8699)] = 363874,
  [SMALL_STATE(8700)] = 363913,
  [SMALL_STATE(8701)] = 363952,
  [SMALL_STATE(8702)] = 363991,
  [SMALL_STATE(8703)] = 364030,
  [SMALL_STATE(8704)] = 364069,
  [SMALL_STATE(8705)] = 364108,
  [SMALL_STATE(8706)] = 364159,
  [SMALL_STATE(8707)] = 364198,
  [SMALL_STATE(8708)] = 364237,
  [SMALL_STATE(8709)] = 364277,
  [SMALL_STATE(8710)] = 364315,
  [SMALL_STATE(8711)] = 364355,
  [SMALL_STATE(8712)] = 364415,
  [SMALL_STATE(8713)] = 364453,
  [SMALL_STATE(8714)] = 364493,
  [SMALL_STATE(8715)] = 364533,
  [SMALL_STATE(8716)] = 364573,
  [SMALL_STATE(8717)] = 364613,
  [SMALL_STATE(8718)] = 364653,
  [SMALL_STATE(8719)] = 364691,
  [SMALL_STATE(8720)] = 364729,
  [SMALL_STATE(8721)] = 364769,
  [SMALL_STATE(8722)] = 364809,
  [SMALL_STATE(8723)] = 364847,
  [SMALL_STATE(8724)] = 364887,
  [SMALL_STATE(8725)] = 364927,
  [SMALL_STATE(8726)] = 364967,
  [SMALL_STATE(8727)] = 365007,
  [SMALL_STATE(8728)] = 365047,
  [SMALL_STATE(8729)] = 365085,
  [SMALL_STATE(8730)] = 365123,
  [SMALL_STATE(8731)] = 365161,
  [SMALL_STATE(8732)] = 365199,
  [SMALL_STATE(8733)] = 365237,
  [SMALL_STATE(8734)] = 365279,
  [SMALL_STATE(8735)] = 365319,
  [SMALL_STATE(8736)] = 365357,
  [SMALL_STATE(8737)] = 365395,
  [SMALL_STATE(8738)] = 365435,
  [SMALL_STATE(8739)] = 365473,
  [SMALL_STATE(8740)] = 365511,
  [SMALL_STATE(8741)] = 365549,
  [SMALL_STATE(8742)] = 365587,
  [SMALL_STATE(8743)] = 365627,
  [SMALL_STATE(8744)] = 365667,
  [SMALL_STATE(8745)] = 365713,
  [SMALL_STATE(8746)] = 365751,
  [SMALL_STATE(8747)] = 365791,
  [SMALL_STATE(8748)] = 365837,
  [SMALL_STATE(8749)] = 365877,
  [SMALL_STATE(8750)] = 365917,
  [SMALL_STATE(8751)] = 365957,
  [SMALL_STATE(8752)] = 365997,
  [SMALL_STATE(8753)] = 366035,
  [SMALL_STATE(8754)] = 366075,
  [SMALL_STATE(8755)] = 366115,
  [SMALL_STATE(8756)] = 366155,
  [SMALL_STATE(8757)] = 366195,
  [SMALL_STATE(8758)] = 366235,
  [SMALL_STATE(8759)] = 366275,
  [SMALL_STATE(8760)] = 366315,
  [SMALL_STATE(8761)] = 366353,
  [SMALL_STATE(8762)] = 366391,
  [SMALL_STATE(8763)] = 366445,
  [SMALL_STATE(8764)] = 366483,
  [SMALL_STATE(8765)] = 366523,
  [SMALL_STATE(8766)] = 366563,
  [SMALL_STATE(8767)] = 366603,
  [SMALL_STATE(8768)] = 366643,
  [SMALL_STATE(8769)] = 366697,
  [SMALL_STATE(8770)] = 366737,
  [SMALL_STATE(8771)] = 366777,
  [SMALL_STATE(8772)] = 366815,
  [SMALL_STATE(8773)] = 366853,
  [SMALL_STATE(8774)] = 366891,
  [SMALL_STATE(8775)] = 366929,
  [SMALL_STATE(8776)] = 366967,
  [SMALL_STATE(8777)] = 367007,
  [SMALL_STATE(8778)] = 367047,
  [SMALL_STATE(8779)] = 367085,
  [SMALL_STATE(8780)] = 367125,
  [SMALL_STATE(8781)] = 367165,
  [SMALL_STATE(8782)] = 367203,
  [SMALL_STATE(8783)] = 367243,
  [SMALL_STATE(8784)] = 367283,
  [SMALL_STATE(8785)] = 367323,
  [SMALL_STATE(8786)] = 367363,
  [SMALL_STATE(8787)] = 367403,
  [SMALL_STATE(8788)] = 367443,
  [SMALL_STATE(8789)] = 367483,
  [SMALL_STATE(8790)] = 367521,
  [SMALL_STATE(8791)] = 367561,
  [SMALL_STATE(8792)] = 367601,
  [SMALL_STATE(8793)] = 367639,
  [SMALL_STATE(8794)] = 367677,
  [SMALL_STATE(8795)] = 367717,
  [SMALL_STATE(8796)] = 367757,
  [SMALL_STATE(8797)] = 367795,
  [SMALL_STATE(8798)] = 367835,
  [SMALL_STATE(8799)] = 367873,
  [SMALL_STATE(8800)] = 367913,
  [SMALL_STATE(8801)] = 367953,
  [SMALL_STATE(8802)] = 367993,
  [SMALL_STATE(8803)] = 368031,
  [SMALL_STATE(8804)] = 368069,
  [SMALL_STATE(8805)] = 368107,
  [SMALL_STATE(8806)] = 368147,
  [SMALL_STATE(8807)] = 368185,
  [SMALL_STATE(8808)] = 368225,
  [SMALL_STATE(8809)] = 368263,
  [SMALL_STATE(8810)] = 368301,
  [SMALL_STATE(8811)] = 368339,
  [SMALL_STATE(8812)] = 368377,
  [SMALL_STATE(8813)] = 368417,
  [SMALL_STATE(8814)] = 368455,
  [SMALL_STATE(8815)] = 368495,
  [SMALL_STATE(8816)] = 368533,
  [SMALL_STATE(8817)] = 368571,
  [SMALL_STATE(8818)] = 368609,
  [SMALL_STATE(8819)] = 368647,
  [SMALL_STATE(8820)] = 368685,
  [SMALL_STATE(8821)] = 368739,
  [SMALL_STATE(8822)] = 368777,
  [SMALL_STATE(8823)] = 368815,
  [SMALL_STATE(8824)] = 368855,
  [SMALL_STATE(8825)] = 368895,
  [SMALL_STATE(8826)] = 368937,
  [SMALL_STATE(8827)] = 368975,
  [SMALL_STATE(8828)] = 369013,
  [SMALL_STATE(8829)] = 369051,
  [SMALL_STATE(8830)] = 369089,
  [SMALL_STATE(8831)] = 369131,
  [SMALL_STATE(8832)] = 369169,
  [SMALL_STATE(8833)] = 369223,
  [SMALL_STATE(8834)] = 369263,
  [SMALL_STATE(8835)] = 369301,
  [SMALL_STATE(8836)] = 369339,
  [SMALL_STATE(8837)] = 369377,
  [SMALL_STATE(8838)] = 369415,
  [SMALL_STATE(8839)] = 369453,
  [SMALL_STATE(8840)] = 369493,
  [SMALL_STATE(8841)] = 369531,
  [SMALL_STATE(8842)] = 369573,
  [SMALL_STATE(8843)] = 369611,
  [SMALL_STATE(8844)] = 369649,
  [SMALL_STATE(8845)] = 369691,
  [SMALL_STATE(8846)] = 369737,
  [SMALL_STATE(8847)] = 369777,
  [SMALL_STATE(8848)] = 369815,
  [SMALL_STATE(8849)] = 369855,
  [SMALL_STATE(8850)] = 369893,
  [SMALL_STATE(8851)] = 369933,
  [SMALL_STATE(8852)] = 369971,
  [SMALL_STATE(8853)] = 370011,
  [SMALL_STATE(8854)] = 370049,
  [SMALL_STATE(8855)] = 370089,
  [SMALL_STATE(8856)] = 370129,
  [SMALL_STATE(8857)] = 370169,
  [SMALL_STATE(8858)] = 370209,
  [SMALL_STATE(8859)] = 370251,
  [SMALL_STATE(8860)] = 370289,
  [SMALL_STATE(8861)] = 370335,
  [SMALL_STATE(8862)] = 370373,
  [SMALL_STATE(8863)] = 370411,
  [SMALL_STATE(8864)] = 370459,
  [SMALL_STATE(8865)] = 370497,
  [SMALL_STATE(8866)] = 370535,
  [SMALL_STATE(8867)] = 370573,
  [SMALL_STATE(8868)] = 370611,
  [SMALL_STATE(8869)] = 370649,
  [SMALL_STATE(8870)] = 370689,
  [SMALL_STATE(8871)] = 370727,
  [SMALL_STATE(8872)] = 370767,
  [SMALL_STATE(8873)] = 370821,
  [SMALL_STATE(8874)] = 370859,
  [SMALL_STATE(8875)] = 370897,
  [SMALL_STATE(8876)] = 370953,
  [SMALL_STATE(8877)] = 370993,
  [SMALL_STATE(8878)] = 371033,
  [SMALL_STATE(8879)] = 371073,
  [SMALL_STATE(8880)] = 371113,
  [SMALL_STATE(8881)] = 371153,
  [SMALL_STATE(8882)] = 371193,
  [SMALL_STATE(8883)] = 371233,
  [SMALL_STATE(8884)] = 371271,
  [SMALL_STATE(8885)] = 371311,
  [SMALL_STATE(8886)] = 371351,
  [SMALL_STATE(8887)] = 371405,
  [SMALL_STATE(8888)] = 371443,
  [SMALL_STATE(8889)] = 371480,
  [SMALL_STATE(8890)] = 371517,
  [SMALL_STATE(8891)] = 371554,
  [SMALL_STATE(8892)] = 371591,
  [SMALL_STATE(8893)] = 371628,
  [SMALL_STATE(8894)] = 371665,
  [SMALL_STATE(8895)] = 371702,
  [SMALL_STATE(8896)] = 371739,
  [SMALL_STATE(8897)] = 371778,
  [SMALL_STATE(8898)] = 371815,
  [SMALL_STATE(8899)] = 371852,
  [SMALL_STATE(8900)] = 371889,
  [SMALL_STATE(8901)] = 371926,
  [SMALL_STATE(8902)] = 371963,
  [SMALL_STATE(8903)] = 372002,
  [SMALL_STATE(8904)] = 372039,
  [SMALL_STATE(8905)] = 372076,
  [SMALL_STATE(8906)] = 372115,
  [SMALL_STATE(8907)] = 372152,
  [SMALL_STATE(8908)] = 372189,
  [SMALL_STATE(8909)] = 372228,
  [SMALL_STATE(8910)] = 372265,
  [SMALL_STATE(8911)] = 372302,
  [SMALL_STATE(8912)] = 372339,
  [SMALL_STATE(8913)] = 372376,
  [SMALL_STATE(8914)] = 372413,
  [SMALL_STATE(8915)] = 372450,
  [SMALL_STATE(8916)] = 372487,
  [SMALL_STATE(8917)] = 372524,
  [SMALL_STATE(8918)] = 372561,
  [SMALL_STATE(8919)] = 372598,
  [SMALL_STATE(8920)] = 372635,
  [SMALL_STATE(8921)] = 372672,
  [SMALL_STATE(8922)] = 372709,
  [SMALL_STATE(8923)] = 372746,
  [SMALL_STATE(8924)] = 372783,
  [SMALL_STATE(8925)] = 372820,
  [SMALL_STATE(8926)] = 372857,
  [SMALL_STATE(8927)] = 372894,
  [SMALL_STATE(8928)] = 372931,
  [SMALL_STATE(8929)] = 372968,
  [SMALL_STATE(8930)] = 373005,
  [SMALL_STATE(8931)] = 373044,
  [SMALL_STATE(8932)] = 373097,
  [SMALL_STATE(8933)] = 373134,
  [SMALL_STATE(8934)] = 373171,
  [SMALL_STATE(8935)] = 373208,
  [SMALL_STATE(8936)] = 373245,
  [SMALL_STATE(8937)] = 373282,
  [SMALL_STATE(8938)] = 373321,
  [SMALL_STATE(8939)] = 373358,
  [SMALL_STATE(8940)] = 373395,
  [SMALL_STATE(8941)] = 373432,
  [SMALL_STATE(8942)] = 373485,
  [SMALL_STATE(8943)] = 373522,
  [SMALL_STATE(8944)] = 373559,
  [SMALL_STATE(8945)] = 373596,
  [SMALL_STATE(8946)] = 373635,
  [SMALL_STATE(8947)] = 373672,
  [SMALL_STATE(8948)] = 373709,
  [SMALL_STATE(8949)] = 373746,
  [SMALL_STATE(8950)] = 373783,
  [SMALL_STATE(8951)] = 373820,
  [SMALL_STATE(8952)] = 373857,
  [SMALL_STATE(8953)] = 373894,
  [SMALL_STATE(8954)] = 373931,
  [SMALL_STATE(8955)] = 373968,
  [SMALL_STATE(8956)] = 374005,
  [SMALL_STATE(8957)] = 374042,
  [SMALL_STATE(8958)] = 374079,
  [SMALL_STATE(8959)] = 374116,
  [SMALL_STATE(8960)] = 374153,
  [SMALL_STATE(8961)] = 374190,
  [SMALL_STATE(8962)] = 374227,
  [SMALL_STATE(8963)] = 374264,
  [SMALL_STATE(8964)] = 374301,
  [SMALL_STATE(8965)] = 374338,
  [SMALL_STATE(8966)] = 374375,
  [SMALL_STATE(8967)] = 374412,
  [SMALL_STATE(8968)] = 374449,
  [SMALL_STATE(8969)] = 374486,
  [SMALL_STATE(8970)] = 374523,
  [SMALL_STATE(8971)] = 374560,
  [SMALL_STATE(8972)] = 374597,
  [SMALL_STATE(8973)] = 374634,
  [SMALL_STATE(8974)] = 374671,
  [SMALL_STATE(8975)] = 374710,
  [SMALL_STATE(8976)] = 374747,
  [SMALL_STATE(8977)] = 374784,
  [SMALL_STATE(8978)] = 374821,
  [SMALL_STATE(8979)] = 374858,
  [SMALL_STATE(8980)] = 374895,
  [SMALL_STATE(8981)] = 374932,
  [SMALL_STATE(8982)] = 374969,
  [SMALL_STATE(8983)] = 375006,
  [SMALL_STATE(8984)] = 375043,
  [SMALL_STATE(8985)] = 375080,
  [SMALL_STATE(8986)] = 375117,
  [SMALL_STATE(8987)] = 375154,
  [SMALL_STATE(8988)] = 375191,
  [SMALL_STATE(8989)] = 375228,
  [SMALL_STATE(8990)] = 375265,
  [SMALL_STATE(8991)] = 375302,
  [SMALL_STATE(8992)] = 375355,
  [SMALL_STATE(8993)] = 375392,
  [SMALL_STATE(8994)] = 375431,
  [SMALL_STATE(8995)] = 375468,
  [SMALL_STATE(8996)] = 375505,
  [SMALL_STATE(8997)] = 375542,
  [SMALL_STATE(8998)] = 375579,
  [SMALL_STATE(8999)] = 375616,
  [SMALL_STATE(9000)] = 375653,
  [SMALL_STATE(9001)] = 375690,
  [SMALL_STATE(9002)] = 375727,
  [SMALL_STATE(9003)] = 375764,
  [SMALL_STATE(9004)] = 375801,
  [SMALL_STATE(9005)] = 375838,
  [SMALL_STATE(9006)] = 375891,
  [SMALL_STATE(9007)] = 375928,
  [SMALL_STATE(9008)] = 375965,
  [SMALL_STATE(9009)] = 376002,
  [SMALL_STATE(9010)] = 376039,
  [SMALL_STATE(9011)] = 376076,
  [SMALL_STATE(9012)] = 376113,
  [SMALL_STATE(9013)] = 376150,
  [SMALL_STATE(9014)] = 376187,
  [SMALL_STATE(9015)] = 376224,
  [SMALL_STATE(9016)] = 376261,
  [SMALL_STATE(9017)] = 376298,
  [SMALL_STATE(9018)] = 376335,
  [SMALL_STATE(9019)] = 376372,
  [SMALL_STATE(9020)] = 376411,
  [SMALL_STATE(9021)] = 376448,
  [SMALL_STATE(9022)] = 376485,
  [SMALL_STATE(9023)] = 376522,
  [SMALL_STATE(9024)] = 376559,
  [SMALL_STATE(9025)] = 376596,
  [SMALL_STATE(9026)] = 376633,
  [SMALL_STATE(9027)] = 376672,
  [SMALL_STATE(9028)] = 376709,
  [SMALL_STATE(9029)] = 376746,
  [SMALL_STATE(9030)] = 376805,
  [SMALL_STATE(9031)] = 376842,
  [SMALL_STATE(9032)] = 376879,
  [SMALL_STATE(9033)] = 376916,
  [SMALL_STATE(9034)] = 376953,
  [SMALL_STATE(9035)] = 376990,
  [SMALL_STATE(9036)] = 377027,
  [SMALL_STATE(9037)] = 377064,
  [SMALL_STATE(9038)] = 377101,
  [SMALL_STATE(9039)] = 377138,
  [SMALL_STATE(9040)] = 377175,
  [SMALL_STATE(9041)] = 377212,
  [SMALL_STATE(9042)] = 377249,
  [SMALL_STATE(9043)] = 377286,
  [SMALL_STATE(9044)] = 377323,
  [SMALL_STATE(9045)] = 377360,
  [SMALL_STATE(9046)] = 377413,
  [SMALL_STATE(9047)] = 377450,
  [SMALL_STATE(9048)] = 377489,
  [SMALL_STATE(9049)] = 377526,
  [SMALL_STATE(9050)] = 377563,
  [SMALL_STATE(9051)] = 377600,
  [SMALL_STATE(9052)] = 377637,
  [SMALL_STATE(9053)] = 377674,
  [SMALL_STATE(9054)] = 377711,
  [SMALL_STATE(9055)] = 377748,
  [SMALL_STATE(9056)] = 377785,
  [SMALL_STATE(9057)] = 377822,
  [SMALL_STATE(9058)] = 377859,
  [SMALL_STATE(9059)] = 377896,
  [SMALL_STATE(9060)] = 377933,
  [SMALL_STATE(9061)] = 377970,
  [SMALL_STATE(9062)] = 378009,
  [SMALL_STATE(9063)] = 378046,
  [SMALL_STATE(9064)] = 378087,
  [SMALL_STATE(9065)] = 378124,
  [SMALL_STATE(9066)] = 378161,
  [SMALL_STATE(9067)] = 378198,
  [SMALL_STATE(9068)] = 378235,
  [SMALL_STATE(9069)] = 378272,
  [SMALL_STATE(9070)] = 378311,
  [SMALL_STATE(9071)] = 378348,
  [SMALL_STATE(9072)] = 378385,
  [SMALL_STATE(9073)] = 378422,
  [SMALL_STATE(9074)] = 378459,
  [SMALL_STATE(9075)] = 378496,
  [SMALL_STATE(9076)] = 378533,
  [SMALL_STATE(9077)] = 378570,
  [SMALL_STATE(9078)] = 378623,
  [SMALL_STATE(9079)] = 378660,
  [SMALL_STATE(9080)] = 378697,
  [SMALL_STATE(9081)] = 378734,
  [SMALL_STATE(9082)] = 378771,
  [SMALL_STATE(9083)] = 378808,
  [SMALL_STATE(9084)] = 378845,
  [SMALL_STATE(9085)] = 378882,
  [SMALL_STATE(9086)] = 378919,
  [SMALL_STATE(9087)] = 378956,
  [SMALL_STATE(9088)] = 378993,
  [SMALL_STATE(9089)] = 379030,
  [SMALL_STATE(9090)] = 379067,
  [SMALL_STATE(9091)] = 379104,
  [SMALL_STATE(9092)] = 379141,
  [SMALL_STATE(9093)] = 379178,
  [SMALL_STATE(9094)] = 379215,
  [SMALL_STATE(9095)] = 379252,
  [SMALL_STATE(9096)] = 379289,
  [SMALL_STATE(9097)] = 379326,
  [SMALL_STATE(9098)] = 379363,
  [SMALL_STATE(9099)] = 379400,
  [SMALL_STATE(9100)] = 379437,
  [SMALL_STATE(9101)] = 379478,
  [SMALL_STATE(9102)] = 379515,
  [SMALL_STATE(9103)] = 379552,
  [SMALL_STATE(9104)] = 379589,
  [SMALL_STATE(9105)] = 379628,
  [SMALL_STATE(9106)] = 379665,
  [SMALL_STATE(9107)] = 379702,
  [SMALL_STATE(9108)] = 379761,
  [SMALL_STATE(9109)] = 379798,
  [SMALL_STATE(9110)] = 379835,
  [SMALL_STATE(9111)] = 379872,
  [SMALL_STATE(9112)] = 379909,
  [SMALL_STATE(9113)] = 379946,
  [SMALL_STATE(9114)] = 379983,
  [SMALL_STATE(9115)] = 380020,
  [SMALL_STATE(9116)] = 380057,
  [SMALL_STATE(9117)] = 380094,
  [SMALL_STATE(9118)] = 380131,
  [SMALL_STATE(9119)] = 380168,
  [SMALL_STATE(9120)] = 380205,
  [SMALL_STATE(9121)] = 380242,
  [SMALL_STATE(9122)] = 380279,
  [SMALL_STATE(9123)] = 380316,
  [SMALL_STATE(9124)] = 380353,
  [SMALL_STATE(9125)] = 380390,
  [SMALL_STATE(9126)] = 380427,
  [SMALL_STATE(9127)] = 380464,
  [SMALL_STATE(9128)] = 380501,
  [SMALL_STATE(9129)] = 380538,
  [SMALL_STATE(9130)] = 380575,
  [SMALL_STATE(9131)] = 380612,
  [SMALL_STATE(9132)] = 380649,
  [SMALL_STATE(9133)] = 380686,
  [SMALL_STATE(9134)] = 380723,
  [SMALL_STATE(9135)] = 380760,
  [SMALL_STATE(9136)] = 380797,
  [SMALL_STATE(9137)] = 380834,
  [SMALL_STATE(9138)] = 380871,
  [SMALL_STATE(9139)] = 380908,
  [SMALL_STATE(9140)] = 380945,
  [SMALL_STATE(9141)] = 380982,
  [SMALL_STATE(9142)] = 381019,
  [SMALL_STATE(9143)] = 381056,
  [SMALL_STATE(9144)] = 381093,
  [SMALL_STATE(9145)] = 381130,
  [SMALL_STATE(9146)] = 381167,
  [SMALL_STATE(9147)] = 381204,
  [SMALL_STATE(9148)] = 381241,
  [SMALL_STATE(9149)] = 381280,
  [SMALL_STATE(9150)] = 381317,
  [SMALL_STATE(9151)] = 381354,
  [SMALL_STATE(9152)] = 381391,
  [SMALL_STATE(9153)] = 381430,
  [SMALL_STATE(9154)] = 381467,
  [SMALL_STATE(9155)] = 381520,
  [SMALL_STATE(9156)] = 381557,
  [SMALL_STATE(9157)] = 381594,
  [SMALL_STATE(9158)] = 381631,
  [SMALL_STATE(9159)] = 381668,
  [SMALL_STATE(9160)] = 381705,
  [SMALL_STATE(9161)] = 381742,
  [SMALL_STATE(9162)] = 381779,
  [SMALL_STATE(9163)] = 381816,
  [SMALL_STATE(9164)] = 381853,
  [SMALL_STATE(9165)] = 381890,
  [SMALL_STATE(9166)] = 381929,
  [SMALL_STATE(9167)] = 381966,
  [SMALL_STATE(9168)] = 382003,
  [SMALL_STATE(9169)] = 382040,
  [SMALL_STATE(9170)] = 382077,
  [SMALL_STATE(9171)] = 382114,
  [SMALL_STATE(9172)] = 382151,
  [SMALL_STATE(9173)] = 382188,
  [SMALL_STATE(9174)] = 382225,
  [SMALL_STATE(9175)] = 382262,
  [SMALL_STATE(9176)] = 382299,
  [SMALL_STATE(9177)] = 382336,
  [SMALL_STATE(9178)] = 382373,
  [SMALL_STATE(9179)] = 382410,
  [SMALL_STATE(9180)] = 382447,
  [SMALL_STATE(9181)] = 382484,
  [SMALL_STATE(9182)] = 382521,
  [SMALL_STATE(9183)] = 382558,
  [SMALL_STATE(9184)] = 382597,
  [SMALL_STATE(9185)] = 382634,
  [SMALL_STATE(9186)] = 382671,
  [SMALL_STATE(9187)] = 382710,
  [SMALL_STATE(9188)] = 382747,
  [SMALL_STATE(9189)] = 382784,
  [SMALL_STATE(9190)] = 382821,
  [SMALL_STATE(9191)] = 382858,
  [SMALL_STATE(9192)] = 382895,
  [SMALL_STATE(9193)] = 382932,
  [SMALL_STATE(9194)] = 382969,
  [SMALL_STATE(9195)] = 383006,
  [SMALL_STATE(9196)] = 383043,
  [SMALL_STATE(9197)] = 383080,
  [SMALL_STATE(9198)] = 383117,
  [SMALL_STATE(9199)] = 383154,
  [SMALL_STATE(9200)] = 383191,
  [SMALL_STATE(9201)] = 383228,
  [SMALL_STATE(9202)] = 383265,
  [SMALL_STATE(9203)] = 383302,
  [SMALL_STATE(9204)] = 383339,
  [SMALL_STATE(9205)] = 383376,
  [SMALL_STATE(9206)] = 383413,
  [SMALL_STATE(9207)] = 383450,
  [SMALL_STATE(9208)] = 383487,
  [SMALL_STATE(9209)] = 383524,
  [SMALL_STATE(9210)] = 383561,
  [SMALL_STATE(9211)] = 383598,
  [SMALL_STATE(9212)] = 383635,
  [SMALL_STATE(9213)] = 383672,
  [SMALL_STATE(9214)] = 383709,
  [SMALL_STATE(9215)] = 383746,
  [SMALL_STATE(9216)] = 383783,
  [SMALL_STATE(9217)] = 383820,
  [SMALL_STATE(9218)] = 383857,
  [SMALL_STATE(9219)] = 383894,
  [SMALL_STATE(9220)] = 383931,
  [SMALL_STATE(9221)] = 383968,
  [SMALL_STATE(9222)] = 384005,
  [SMALL_STATE(9223)] = 384042,
  [SMALL_STATE(9224)] = 384079,
  [SMALL_STATE(9225)] = 384116,
  [SMALL_STATE(9226)] = 384153,
  [SMALL_STATE(9227)] = 384190,
  [SMALL_STATE(9228)] = 384227,
  [SMALL_STATE(9229)] = 384264,
  [SMALL_STATE(9230)] = 384301,
  [SMALL_STATE(9231)] = 384340,
  [SMALL_STATE(9232)] = 384377,
  [SMALL_STATE(9233)] = 384414,
  [SMALL_STATE(9234)] = 384451,
  [SMALL_STATE(9235)] = 384488,
  [SMALL_STATE(9236)] = 384525,
  [SMALL_STATE(9237)] = 384562,
  [SMALL_STATE(9238)] = 384599,
  [SMALL_STATE(9239)] = 384636,
  [SMALL_STATE(9240)] = 384675,
  [SMALL_STATE(9241)] = 384714,
  [SMALL_STATE(9242)] = 384751,
  [SMALL_STATE(9243)] = 384788,
  [SMALL_STATE(9244)] = 384825,
  [SMALL_STATE(9245)] = 384862,
  [SMALL_STATE(9246)] = 384899,
  [SMALL_STATE(9247)] = 384938,
  [SMALL_STATE(9248)] = 384977,
  [SMALL_STATE(9249)] = 385014,
  [SMALL_STATE(9250)] = 385051,
  [SMALL_STATE(9251)] = 385088,
  [SMALL_STATE(9252)] = 385125,
  [SMALL_STATE(9253)] = 385164,
  [SMALL_STATE(9254)] = 385201,
  [SMALL_STATE(9255)] = 385240,
  [SMALL_STATE(9256)] = 385277,
  [SMALL_STATE(9257)] = 385314,
  [SMALL_STATE(9258)] = 385351,
  [SMALL_STATE(9259)] = 385388,
  [SMALL_STATE(9260)] = 385425,
  [SMALL_STATE(9261)] = 385462,
  [SMALL_STATE(9262)] = 385499,
  [SMALL_STATE(9263)] = 385536,
  [SMALL_STATE(9264)] = 385573,
  [SMALL_STATE(9265)] = 385610,
  [SMALL_STATE(9266)] = 385647,
  [SMALL_STATE(9267)] = 385684,
  [SMALL_STATE(9268)] = 385723,
  [SMALL_STATE(9269)] = 385760,
  [SMALL_STATE(9270)] = 385797,
  [SMALL_STATE(9271)] = 385834,
  [SMALL_STATE(9272)] = 385873,
  [SMALL_STATE(9273)] = 385910,
  [SMALL_STATE(9274)] = 385947,
  [SMALL_STATE(9275)] = 385984,
  [SMALL_STATE(9276)] = 386021,
  [SMALL_STATE(9277)] = 386058,
  [SMALL_STATE(9278)] = 386095,
  [SMALL_STATE(9279)] = 386132,
  [SMALL_STATE(9280)] = 386169,
  [SMALL_STATE(9281)] = 386206,
  [SMALL_STATE(9282)] = 386243,
  [SMALL_STATE(9283)] = 386280,
  [SMALL_STATE(9284)] = 386317,
  [SMALL_STATE(9285)] = 386354,
  [SMALL_STATE(9286)] = 386391,
  [SMALL_STATE(9287)] = 386428,
  [SMALL_STATE(9288)] = 386465,
  [SMALL_STATE(9289)] = 386502,
  [SMALL_STATE(9290)] = 386539,
  [SMALL_STATE(9291)] = 386576,
  [SMALL_STATE(9292)] = 386613,
  [SMALL_STATE(9293)] = 386650,
  [SMALL_STATE(9294)] = 386687,
  [SMALL_STATE(9295)] = 386724,
  [SMALL_STATE(9296)] = 386761,
  [SMALL_STATE(9297)] = 386798,
  [SMALL_STATE(9298)] = 386835,
  [SMALL_STATE(9299)] = 386872,
  [SMALL_STATE(9300)] = 386909,
  [SMALL_STATE(9301)] = 386946,
  [SMALL_STATE(9302)] = 386983,
  [SMALL_STATE(9303)] = 387020,
  [SMALL_STATE(9304)] = 387057,
  [SMALL_STATE(9305)] = 387094,
  [SMALL_STATE(9306)] = 387131,
  [SMALL_STATE(9307)] = 387168,
  [SMALL_STATE(9308)] = 387205,
  [SMALL_STATE(9309)] = 387242,
  [SMALL_STATE(9310)] = 387279,
  [SMALL_STATE(9311)] = 387338,
  [SMALL_STATE(9312)] = 387375,
  [SMALL_STATE(9313)] = 387412,
  [SMALL_STATE(9314)] = 387449,
  [SMALL_STATE(9315)] = 387486,
  [SMALL_STATE(9316)] = 387523,
  [SMALL_STATE(9317)] = 387560,
  [SMALL_STATE(9318)] = 387599,
  [SMALL_STATE(9319)] = 387636,
  [SMALL_STATE(9320)] = 387673,
  [SMALL_STATE(9321)] = 387710,
  [SMALL_STATE(9322)] = 387747,
  [SMALL_STATE(9323)] = 387784,
  [SMALL_STATE(9324)] = 387821,
  [SMALL_STATE(9325)] = 387858,
  [SMALL_STATE(9326)] = 387895,
  [SMALL_STATE(9327)] = 387932,
  [SMALL_STATE(9328)] = 387969,
  [SMALL_STATE(9329)] = 388006,
  [SMALL_STATE(9330)] = 388043,
  [SMALL_STATE(9331)] = 388080,
  [SMALL_STATE(9332)] = 388117,
  [SMALL_STATE(9333)] = 388154,
  [SMALL_STATE(9334)] = 388191,
  [SMALL_STATE(9335)] = 388228,
  [SMALL_STATE(9336)] = 388265,
  [SMALL_STATE(9337)] = 388318,
  [SMALL_STATE(9338)] = 388355,
  [SMALL_STATE(9339)] = 388394,
  [SMALL_STATE(9340)] = 388431,
  [SMALL_STATE(9341)] = 388468,
  [SMALL_STATE(9342)] = 388507,
  [SMALL_STATE(9343)] = 388544,
  [SMALL_STATE(9344)] = 388581,
  [SMALL_STATE(9345)] = 388618,
  [SMALL_STATE(9346)] = 388655,
  [SMALL_STATE(9347)] = 388692,
  [SMALL_STATE(9348)] = 388729,
  [SMALL_STATE(9349)] = 388765,
  [SMALL_STATE(9350)] = 388801,
  [SMALL_STATE(9351)] = 388837,
  [SMALL_STATE(9352)] = 388873,
  [SMALL_STATE(9353)] = 388911,
  [SMALL_STATE(9354)] = 388949,
  [SMALL_STATE(9355)] = 388985,
  [SMALL_STATE(9356)] = 389021,
  [SMALL_STATE(9357)] = 389057,
  [SMALL_STATE(9358)] = 389093,
  [SMALL_STATE(9359)] = 389129,
  [SMALL_STATE(9360)] = 389165,
  [SMALL_STATE(9361)] = 389201,
  [SMALL_STATE(9362)] = 389237,
  [SMALL_STATE(9363)] = 389273,
  [SMALL_STATE(9364)] = 389309,
  [SMALL_STATE(9365)] = 389345,
  [SMALL_STATE(9366)] = 389381,
  [SMALL_STATE(9367)] = 389417,
  [SMALL_STATE(9368)] = 389453,
  [SMALL_STATE(9369)] = 389489,
  [SMALL_STATE(9370)] = 389525,
  [SMALL_STATE(9371)] = 389561,
  [SMALL_STATE(9372)] = 389597,
  [SMALL_STATE(9373)] = 389633,
  [SMALL_STATE(9374)] = 389669,
  [SMALL_STATE(9375)] = 389707,
  [SMALL_STATE(9376)] = 389743,
  [SMALL_STATE(9377)] = 389781,
  [SMALL_STATE(9378)] = 389817,
  [SMALL_STATE(9379)] = 389853,
  [SMALL_STATE(9380)] = 389889,
  [SMALL_STATE(9381)] = 389925,
  [SMALL_STATE(9382)] = 389961,
  [SMALL_STATE(9383)] = 389997,
  [SMALL_STATE(9384)] = 390035,
  [SMALL_STATE(9385)] = 390071,
  [SMALL_STATE(9386)] = 390107,
  [SMALL_STATE(9387)] = 390143,
  [SMALL_STATE(9388)] = 390179,
  [SMALL_STATE(9389)] = 390215,
  [SMALL_STATE(9390)] = 390251,
  [SMALL_STATE(9391)] = 390287,
  [SMALL_STATE(9392)] = 390345,
  [SMALL_STATE(9393)] = 390381,
  [SMALL_STATE(9394)] = 390419,
  [SMALL_STATE(9395)] = 390455,
  [SMALL_STATE(9396)] = 390491,
  [SMALL_STATE(9397)] = 390527,
  [SMALL_STATE(9398)] = 390563,
  [SMALL_STATE(9399)] = 390599,
  [SMALL_STATE(9400)] = 390635,
  [SMALL_STATE(9401)] = 390671,
  [SMALL_STATE(9402)] = 390707,
  [SMALL_STATE(9403)] = 390743,
  [SMALL_STATE(9404)] = 390781,
  [SMALL_STATE(9405)] = 390817,
  [SMALL_STATE(9406)] = 390855,
  [SMALL_STATE(9407)] = 390891,
  [SMALL_STATE(9408)] = 390927,
  [SMALL_STATE(9409)] = 390963,
  [SMALL_STATE(9410)] = 390999,
  [SMALL_STATE(9411)] = 391035,
  [SMALL_STATE(9412)] = 391071,
  [SMALL_STATE(9413)] = 391107,
  [SMALL_STATE(9414)] = 391143,
  [SMALL_STATE(9415)] = 391179,
  [SMALL_STATE(9416)] = 391215,
  [SMALL_STATE(9417)] = 391251,
  [SMALL_STATE(9418)] = 391287,
  [SMALL_STATE(9419)] = 391323,
  [SMALL_STATE(9420)] = 391359,
  [SMALL_STATE(9421)] = 391395,
  [SMALL_STATE(9422)] = 391431,
  [SMALL_STATE(9423)] = 391467,
  [SMALL_STATE(9424)] = 391503,
  [SMALL_STATE(9425)] = 391539,
  [SMALL_STATE(9426)] = 391575,
  [SMALL_STATE(9427)] = 391611,
  [SMALL_STATE(9428)] = 391647,
  [SMALL_STATE(9429)] = 391683,
  [SMALL_STATE(9430)] = 391719,
  [SMALL_STATE(9431)] = 391757,
  [SMALL_STATE(9432)] = 391793,
  [SMALL_STATE(9433)] = 391829,
  [SMALL_STATE(9434)] = 391865,
  [SMALL_STATE(9435)] = 391901,
  [SMALL_STATE(9436)] = 391937,
  [SMALL_STATE(9437)] = 391973,
  [SMALL_STATE(9438)] = 392009,
  [SMALL_STATE(9439)] = 392045,
  [SMALL_STATE(9440)] = 392081,
  [SMALL_STATE(9441)] = 392117,
  [SMALL_STATE(9442)] = 392153,
  [SMALL_STATE(9443)] = 392189,
  [SMALL_STATE(9444)] = 392225,
  [SMALL_STATE(9445)] = 392261,
  [SMALL_STATE(9446)] = 392297,
  [SMALL_STATE(9447)] = 392333,
  [SMALL_STATE(9448)] = 392369,
  [SMALL_STATE(9449)] = 392405,
  [SMALL_STATE(9450)] = 392441,
  [SMALL_STATE(9451)] = 392477,
  [SMALL_STATE(9452)] = 392513,
  [SMALL_STATE(9453)] = 392549,
  [SMALL_STATE(9454)] = 392585,
  [SMALL_STATE(9455)] = 392621,
  [SMALL_STATE(9456)] = 392657,
  [SMALL_STATE(9457)] = 392693,
  [SMALL_STATE(9458)] = 392729,
  [SMALL_STATE(9459)] = 392765,
  [SMALL_STATE(9460)] = 392801,
  [SMALL_STATE(9461)] = 392837,
  [SMALL_STATE(9462)] = 392873,
  [SMALL_STATE(9463)] = 392909,
  [SMALL_STATE(9464)] = 392945,
  [SMALL_STATE(9465)] = 392981,
  [SMALL_STATE(9466)] = 393017,
  [SMALL_STATE(9467)] = 393053,
  [SMALL_STATE(9468)] = 393089,
  [SMALL_STATE(9469)] = 393125,
  [SMALL_STATE(9470)] = 393161,
  [SMALL_STATE(9471)] = 393197,
  [SMALL_STATE(9472)] = 393233,
  [SMALL_STATE(9473)] = 393269,
  [SMALL_STATE(9474)] = 393305,
  [SMALL_STATE(9475)] = 393341,
  [SMALL_STATE(9476)] = 393377,
  [SMALL_STATE(9477)] = 393413,
  [SMALL_STATE(9478)] = 393449,
  [SMALL_STATE(9479)] = 393485,
  [SMALL_STATE(9480)] = 393521,
  [SMALL_STATE(9481)] = 393557,
  [SMALL_STATE(9482)] = 393615,
  [SMALL_STATE(9483)] = 393651,
  [SMALL_STATE(9484)] = 393687,
  [SMALL_STATE(9485)] = 393723,
  [SMALL_STATE(9486)] = 393759,
  [SMALL_STATE(9487)] = 393795,
  [SMALL_STATE(9488)] = 393831,
  [SMALL_STATE(9489)] = 393867,
  [SMALL_STATE(9490)] = 393903,
  [SMALL_STATE(9491)] = 393939,
  [SMALL_STATE(9492)] = 393975,
  [SMALL_STATE(9493)] = 394011,
  [SMALL_STATE(9494)] = 394047,
  [SMALL_STATE(9495)] = 394083,
  [SMALL_STATE(9496)] = 394119,
  [SMALL_STATE(9497)] = 394171,
  [SMALL_STATE(9498)] = 394207,
  [SMALL_STATE(9499)] = 394243,
  [SMALL_STATE(9500)] = 394279,
  [SMALL_STATE(9501)] = 394315,
  [SMALL_STATE(9502)] = 394351,
  [SMALL_STATE(9503)] = 394387,
  [SMALL_STATE(9504)] = 394423,
  [SMALL_STATE(9505)] = 394459,
  [SMALL_STATE(9506)] = 394495,
  [SMALL_STATE(9507)] = 394531,
  [SMALL_STATE(9508)] = 394567,
  [SMALL_STATE(9509)] = 394603,
  [SMALL_STATE(9510)] = 394639,
  [SMALL_STATE(9511)] = 394675,
  [SMALL_STATE(9512)] = 394711,
  [SMALL_STATE(9513)] = 394749,
  [SMALL_STATE(9514)] = 394785,
  [SMALL_STATE(9515)] = 394821,
  [SMALL_STATE(9516)] = 394857,
  [SMALL_STATE(9517)] = 394893,
  [SMALL_STATE(9518)] = 394929,
  [SMALL_STATE(9519)] = 394965,
  [SMALL_STATE(9520)] = 395001,
  [SMALL_STATE(9521)] = 395037,
  [SMALL_STATE(9522)] = 395073,
  [SMALL_STATE(9523)] = 395109,
  [SMALL_STATE(9524)] = 395145,
  [SMALL_STATE(9525)] = 395181,
  [SMALL_STATE(9526)] = 395217,
  [SMALL_STATE(9527)] = 395253,
  [SMALL_STATE(9528)] = 395289,
  [SMALL_STATE(9529)] = 395325,
  [SMALL_STATE(9530)] = 395361,
  [SMALL_STATE(9531)] = 395397,
  [SMALL_STATE(9532)] = 395433,
  [SMALL_STATE(9533)] = 395469,
  [SMALL_STATE(9534)] = 395505,
  [SMALL_STATE(9535)] = 395541,
  [SMALL_STATE(9536)] = 395577,
  [SMALL_STATE(9537)] = 395613,
  [SMALL_STATE(9538)] = 395649,
  [SMALL_STATE(9539)] = 395685,
  [SMALL_STATE(9540)] = 395721,
  [SMALL_STATE(9541)] = 395757,
  [SMALL_STATE(9542)] = 395793,
  [SMALL_STATE(9543)] = 395829,
  [SMALL_STATE(9544)] = 395865,
  [SMALL_STATE(9545)] = 395901,
  [SMALL_STATE(9546)] = 395937,
  [SMALL_STATE(9547)] = 395973,
  [SMALL_STATE(9548)] = 396009,
  [SMALL_STATE(9549)] = 396045,
  [SMALL_STATE(9550)] = 396081,
  [SMALL_STATE(9551)] = 396117,
  [SMALL_STATE(9552)] = 396153,
  [SMALL_STATE(9553)] = 396189,
  [SMALL_STATE(9554)] = 396225,
  [SMALL_STATE(9555)] = 396263,
  [SMALL_STATE(9556)] = 396299,
  [SMALL_STATE(9557)] = 396337,
  [SMALL_STATE(9558)] = 396373,
  [SMALL_STATE(9559)] = 396409,
  [SMALL_STATE(9560)] = 396445,
  [SMALL_STATE(9561)] = 396481,
  [SMALL_STATE(9562)] = 396517,
  [SMALL_STATE(9563)] = 396553,
  [SMALL_STATE(9564)] = 396589,
  [SMALL_STATE(9565)] = 396625,
  [SMALL_STATE(9566)] = 396661,
  [SMALL_STATE(9567)] = 396697,
  [SMALL_STATE(9568)] = 396733,
  [SMALL_STATE(9569)] = 396769,
  [SMALL_STATE(9570)] = 396805,
  [SMALL_STATE(9571)] = 396841,
  [SMALL_STATE(9572)] = 396877,
  [SMALL_STATE(9573)] = 396915,
  [SMALL_STATE(9574)] = 396951,
  [SMALL_STATE(9575)] = 396989,
  [SMALL_STATE(9576)] = 397025,
  [SMALL_STATE(9577)] = 397061,
  [SMALL_STATE(9578)] = 397097,
  [SMALL_STATE(9579)] = 397135,
  [SMALL_STATE(9580)] = 397171,
  [SMALL_STATE(9581)] = 397207,
  [SMALL_STATE(9582)] = 397243,
  [SMALL_STATE(9583)] = 397279,
  [SMALL_STATE(9584)] = 397315,
  [SMALL_STATE(9585)] = 397353,
  [SMALL_STATE(9586)] = 397389,
  [SMALL_STATE(9587)] = 397425,
  [SMALL_STATE(9588)] = 397461,
  [SMALL_STATE(9589)] = 397497,
  [SMALL_STATE(9590)] = 397533,
  [SMALL_STATE(9591)] = 397569,
  [SMALL_STATE(9592)] = 397605,
  [SMALL_STATE(9593)] = 397641,
  [SMALL_STATE(9594)] = 397677,
  [SMALL_STATE(9595)] = 397713,
  [SMALL_STATE(9596)] = 397749,
  [SMALL_STATE(9597)] = 397785,
  [SMALL_STATE(9598)] = 397821,
  [SMALL_STATE(9599)] = 397857,
  [SMALL_STATE(9600)] = 397893,
  [SMALL_STATE(9601)] = 397929,
  [SMALL_STATE(9602)] = 397965,
  [SMALL_STATE(9603)] = 398001,
  [SMALL_STATE(9604)] = 398037,
  [SMALL_STATE(9605)] = 398073,
  [SMALL_STATE(9606)] = 398109,
  [SMALL_STATE(9607)] = 398147,
  [SMALL_STATE(9608)] = 398183,
  [SMALL_STATE(9609)] = 398219,
  [SMALL_STATE(9610)] = 398255,
  [SMALL_STATE(9611)] = 398291,
  [SMALL_STATE(9612)] = 398327,
  [SMALL_STATE(9613)] = 398363,
  [SMALL_STATE(9614)] = 398399,
  [SMALL_STATE(9615)] = 398435,
  [SMALL_STATE(9616)] = 398471,
  [SMALL_STATE(9617)] = 398507,
  [SMALL_STATE(9618)] = 398543,
  [SMALL_STATE(9619)] = 398579,
  [SMALL_STATE(9620)] = 398617,
  [SMALL_STATE(9621)] = 398653,
  [SMALL_STATE(9622)] = 398689,
  [SMALL_STATE(9623)] = 398725,
  [SMALL_STATE(9624)] = 398761,
  [SMALL_STATE(9625)] = 398797,
  [SMALL_STATE(9626)] = 398833,
  [SMALL_STATE(9627)] = 398869,
  [SMALL_STATE(9628)] = 398905,
  [SMALL_STATE(9629)] = 398941,
  [SMALL_STATE(9630)] = 398977,
  [SMALL_STATE(9631)] = 399013,
  [SMALL_STATE(9632)] = 399049,
  [SMALL_STATE(9633)] = 399085,
  [SMALL_STATE(9634)] = 399121,
  [SMALL_STATE(9635)] = 399157,
  [SMALL_STATE(9636)] = 399193,
  [SMALL_STATE(9637)] = 399229,
  [SMALL_STATE(9638)] = 399265,
  [SMALL_STATE(9639)] = 399301,
  [SMALL_STATE(9640)] = 399337,
  [SMALL_STATE(9641)] = 399373,
  [SMALL_STATE(9642)] = 399409,
  [SMALL_STATE(9643)] = 399445,
  [SMALL_STATE(9644)] = 399481,
  [SMALL_STATE(9645)] = 399517,
  [SMALL_STATE(9646)] = 399553,
  [SMALL_STATE(9647)] = 399589,
  [SMALL_STATE(9648)] = 399625,
  [SMALL_STATE(9649)] = 399661,
  [SMALL_STATE(9650)] = 399697,
  [SMALL_STATE(9651)] = 399733,
  [SMALL_STATE(9652)] = 399769,
  [SMALL_STATE(9653)] = 399807,
  [SMALL_STATE(9654)] = 399843,
  [SMALL_STATE(9655)] = 399881,
  [SMALL_STATE(9656)] = 399917,
  [SMALL_STATE(9657)] = 399953,
  [SMALL_STATE(9658)] = 399989,
  [SMALL_STATE(9659)] = 400025,
  [SMALL_STATE(9660)] = 400061,
  [SMALL_STATE(9661)] = 400097,
  [SMALL_STATE(9662)] = 400133,
  [SMALL_STATE(9663)] = 400169,
  [SMALL_STATE(9664)] = 400205,
  [SMALL_STATE(9665)] = 400241,
  [SMALL_STATE(9666)] = 400277,
  [SMALL_STATE(9667)] = 400313,
  [SMALL_STATE(9668)] = 400349,
  [SMALL_STATE(9669)] = 400385,
  [SMALL_STATE(9670)] = 400421,
  [SMALL_STATE(9671)] = 400456,
  [SMALL_STATE(9672)] = 400491,
  [SMALL_STATE(9673)] = 400526,
  [SMALL_STATE(9674)] = 400561,
  [SMALL_STATE(9675)] = 400596,
  [SMALL_STATE(9676)] = 400653,
  [SMALL_STATE(9677)] = 400710,
  [SMALL_STATE(9678)] = 400745,
  [SMALL_STATE(9679)] = 400780,
  [SMALL_STATE(9680)] = 400815,
  [SMALL_STATE(9681)] = 400850,
  [SMALL_STATE(9682)] = 400885,
  [SMALL_STATE(9683)] = 400920,
  [SMALL_STATE(9684)] = 400955,
  [SMALL_STATE(9685)] = 400990,
  [SMALL_STATE(9686)] = 401025,
  [SMALL_STATE(9687)] = 401060,
  [SMALL_STATE(9688)] = 401095,
  [SMALL_STATE(9689)] = 401130,
  [SMALL_STATE(9690)] = 401165,
  [SMALL_STATE(9691)] = 401200,
  [SMALL_STATE(9692)] = 401235,
  [SMALL_STATE(9693)] = 401270,
  [SMALL_STATE(9694)] = 401305,
  [SMALL_STATE(9695)] = 401340,
  [SMALL_STATE(9696)] = 401375,
  [SMALL_STATE(9697)] = 401410,
  [SMALL_STATE(9698)] = 401445,
  [SMALL_STATE(9699)] = 401480,
  [SMALL_STATE(9700)] = 401515,
  [SMALL_STATE(9701)] = 401550,
  [SMALL_STATE(9702)] = 401585,
  [SMALL_STATE(9703)] = 401620,
  [SMALL_STATE(9704)] = 401655,
  [SMALL_STATE(9705)] = 401690,
  [SMALL_STATE(9706)] = 401725,
  [SMALL_STATE(9707)] = 401760,
  [SMALL_STATE(9708)] = 401795,
  [SMALL_STATE(9709)] = 401830,
  [SMALL_STATE(9710)] = 401865,
  [SMALL_STATE(9711)] = 401900,
  [SMALL_STATE(9712)] = 401935,
  [SMALL_STATE(9713)] = 401970,
  [SMALL_STATE(9714)] = 402005,
  [SMALL_STATE(9715)] = 402040,
  [SMALL_STATE(9716)] = 402097,
  [SMALL_STATE(9717)] = 402132,
  [SMALL_STATE(9718)] = 402167,
  [SMALL_STATE(9719)] = 402202,
  [SMALL_STATE(9720)] = 402237,
  [SMALL_STATE(9721)] = 402272,
  [SMALL_STATE(9722)] = 402307,
  [SMALL_STATE(9723)] = 402342,
  [SMALL_STATE(9724)] = 402377,
  [SMALL_STATE(9725)] = 402412,
  [SMALL_STATE(9726)] = 402447,
  [SMALL_STATE(9727)] = 402482,
  [SMALL_STATE(9728)] = 402517,
  [SMALL_STATE(9729)] = 402552,
  [SMALL_STATE(9730)] = 402587,
  [SMALL_STATE(9731)] = 402622,
  [SMALL_STATE(9732)] = 402657,
  [SMALL_STATE(9733)] = 402692,
  [SMALL_STATE(9734)] = 402727,
  [SMALL_STATE(9735)] = 402762,
  [SMALL_STATE(9736)] = 402797,
  [SMALL_STATE(9737)] = 402832,
  [SMALL_STATE(9738)] = 402867,
  [SMALL_STATE(9739)] = 402902,
  [SMALL_STATE(9740)] = 402937,
  [SMALL_STATE(9741)] = 402972,
  [SMALL_STATE(9742)] = 403007,
  [SMALL_STATE(9743)] = 403042,
  [SMALL_STATE(9744)] = 403077,
  [SMALL_STATE(9745)] = 403112,
  [SMALL_STATE(9746)] = 403147,
  [SMALL_STATE(9747)] = 403184,
  [SMALL_STATE(9748)] = 403219,
  [SMALL_STATE(9749)] = 403256,
  [SMALL_STATE(9750)] = 403291,
  [SMALL_STATE(9751)] = 403326,
  [SMALL_STATE(9752)] = 403361,
  [SMALL_STATE(9753)] = 403396,
  [SMALL_STATE(9754)] = 403431,
  [SMALL_STATE(9755)] = 403466,
  [SMALL_STATE(9756)] = 403501,
  [SMALL_STATE(9757)] = 403536,
  [SMALL_STATE(9758)] = 403571,
  [SMALL_STATE(9759)] = 403606,
  [SMALL_STATE(9760)] = 403641,
  [SMALL_STATE(9761)] = 403680,
  [SMALL_STATE(9762)] = 403715,
  [SMALL_STATE(9763)] = 403750,
  [SMALL_STATE(9764)] = 403807,
  [SMALL_STATE(9765)] = 403842,
  [SMALL_STATE(9766)] = 403899,
  [SMALL_STATE(9767)] = 403956,
  [SMALL_STATE(9768)] = 403991,
  [SMALL_STATE(9769)] = 404026,
  [SMALL_STATE(9770)] = 404083,
  [SMALL_STATE(9771)] = 404140,
  [SMALL_STATE(9772)] = 404175,
  [SMALL_STATE(9773)] = 404210,
  [SMALL_STATE(9774)] = 404245,
  [SMALL_STATE(9775)] = 404280,
  [SMALL_STATE(9776)] = 404315,
  [SMALL_STATE(9777)] = 404352,
  [SMALL_STATE(9778)] = 404389,
  [SMALL_STATE(9779)] = 404424,
  [SMALL_STATE(9780)] = 404459,
  [SMALL_STATE(9781)] = 404494,
  [SMALL_STATE(9782)] = 404529,
  [SMALL_STATE(9783)] = 404566,
  [SMALL_STATE(9784)] = 404601,
  [SMALL_STATE(9785)] = 404636,
  [SMALL_STATE(9786)] = 404671,
  [SMALL_STATE(9787)] = 404706,
  [SMALL_STATE(9788)] = 404763,
  [SMALL_STATE(9789)] = 404798,
  [SMALL_STATE(9790)] = 404833,
  [SMALL_STATE(9791)] = 404868,
  [SMALL_STATE(9792)] = 404903,
  [SMALL_STATE(9793)] = 404938,
  [SMALL_STATE(9794)] = 404973,
  [SMALL_STATE(9795)] = 405008,
  [SMALL_STATE(9796)] = 405043,
  [SMALL_STATE(9797)] = 405078,
  [SMALL_STATE(9798)] = 405113,
  [SMALL_STATE(9799)] = 405148,
  [SMALL_STATE(9800)] = 405183,
  [SMALL_STATE(9801)] = 405218,
  [SMALL_STATE(9802)] = 405253,
  [SMALL_STATE(9803)] = 405288,
  [SMALL_STATE(9804)] = 405323,
  [SMALL_STATE(9805)] = 405358,
  [SMALL_STATE(9806)] = 405393,
  [SMALL_STATE(9807)] = 405428,
  [SMALL_STATE(9808)] = 405463,
  [SMALL_STATE(9809)] = 405498,
  [SMALL_STATE(9810)] = 405533,
  [SMALL_STATE(9811)] = 405568,
  [SMALL_STATE(9812)] = 405603,
  [SMALL_STATE(9813)] = 405638,
  [SMALL_STATE(9814)] = 405673,
  [SMALL_STATE(9815)] = 405708,
  [SMALL_STATE(9816)] = 405743,
  [SMALL_STATE(9817)] = 405778,
  [SMALL_STATE(9818)] = 405813,
  [SMALL_STATE(9819)] = 405848,
  [SMALL_STATE(9820)] = 405883,
  [SMALL_STATE(9821)] = 405918,
  [SMALL_STATE(9822)] = 405953,
  [SMALL_STATE(9823)] = 405988,
  [SMALL_STATE(9824)] = 406023,
  [SMALL_STATE(9825)] = 406060,
  [SMALL_STATE(9826)] = 406095,
  [SMALL_STATE(9827)] = 406130,
  [SMALL_STATE(9828)] = 406165,
  [SMALL_STATE(9829)] = 406200,
  [SMALL_STATE(9830)] = 406235,
  [SMALL_STATE(9831)] = 406272,
  [SMALL_STATE(9832)] = 406307,
  [SMALL_STATE(9833)] = 406342,
  [SMALL_STATE(9834)] = 406377,
  [SMALL_STATE(9835)] = 406412,
  [SMALL_STATE(9836)] = 406469,
  [SMALL_STATE(9837)] = 406504,
  [SMALL_STATE(9838)] = 406539,
  [SMALL_STATE(9839)] = 406574,
  [SMALL_STATE(9840)] = 406609,
  [SMALL_STATE(9841)] = 406644,
  [SMALL_STATE(9842)] = 406679,
  [SMALL_STATE(9843)] = 406714,
  [SMALL_STATE(9844)] = 406749,
  [SMALL_STATE(9845)] = 406784,
  [SMALL_STATE(9846)] = 406819,
  [SMALL_STATE(9847)] = 406854,
  [SMALL_STATE(9848)] = 406889,
  [SMALL_STATE(9849)] = 406924,
  [SMALL_STATE(9850)] = 406959,
  [SMALL_STATE(9851)] = 406994,
  [SMALL_STATE(9852)] = 407029,
  [SMALL_STATE(9853)] = 407064,
  [SMALL_STATE(9854)] = 407099,
  [SMALL_STATE(9855)] = 407134,
  [SMALL_STATE(9856)] = 407169,
  [SMALL_STATE(9857)] = 407204,
  [SMALL_STATE(9858)] = 407239,
  [SMALL_STATE(9859)] = 407274,
  [SMALL_STATE(9860)] = 407309,
  [SMALL_STATE(9861)] = 407344,
  [SMALL_STATE(9862)] = 407379,
  [SMALL_STATE(9863)] = 407414,
  [SMALL_STATE(9864)] = 407449,
  [SMALL_STATE(9865)] = 407484,
  [SMALL_STATE(9866)] = 407519,
  [SMALL_STATE(9867)] = 407555,
  [SMALL_STATE(9868)] = 407589,
  [SMALL_STATE(9869)] = 407643,
  [SMALL_STATE(9870)] = 407679,
  [SMALL_STATE(9871)] = 407733,
  [SMALL_STATE(9872)] = 407787,
  [SMALL_STATE(9873)] = 407841,
  [SMALL_STATE(9874)] = 407895,
  [SMALL_STATE(9875)] = 407931,
  [SMALL_STATE(9876)] = 407967,
  [SMALL_STATE(9877)] = 408021,
  [SMALL_STATE(9878)] = 408057,
  [SMALL_STATE(9879)] = 408111,
  [SMALL_STATE(9880)] = 408165,
  [SMALL_STATE(9881)] = 408201,
  [SMALL_STATE(9882)] = 408237,
  [SMALL_STATE(9883)] = 408291,
  [SMALL_STATE(9884)] = 408345,
  [SMALL_STATE(9885)] = 408381,
  [SMALL_STATE(9886)] = 408417,
  [SMALL_STATE(9887)] = 408453,
  [SMALL_STATE(9888)] = 408489,
  [SMALL_STATE(9889)] = 408525,
  [SMALL_STATE(9890)] = 408581,
  [SMALL_STATE(9891)] = 408617,
  [SMALL_STATE(9892)] = 408671,
  [SMALL_STATE(9893)] = 408725,
  [SMALL_STATE(9894)] = 408779,
  [SMALL_STATE(9895)] = 408833,
  [SMALL_STATE(9896)] = 408887,
  [SMALL_STATE(9897)] = 408943,
  [SMALL_STATE(9898)] = 408979,
  [SMALL_STATE(9899)] = 409015,
  [SMALL_STATE(9900)] = 409069,
  [SMALL_STATE(9901)] = 409123,
  [SMALL_STATE(9902)] = 409177,
  [SMALL_STATE(9903)] = 409213,
  [SMALL_STATE(9904)] = 409249,
  [SMALL_STATE(9905)] = 409303,
  [SMALL_STATE(9906)] = 409357,
  [SMALL_STATE(9907)] = 409411,
  [SMALL_STATE(9908)] = 409465,
  [SMALL_STATE(9909)] = 409519,
  [SMALL_STATE(9910)] = 409573,
  [SMALL_STATE(9911)] = 409627,
  [SMALL_STATE(9912)] = 409661,
  [SMALL_STATE(9913)] = 409715,
  [SMALL_STATE(9914)] = 409769,
  [SMALL_STATE(9915)] = 409823,
  [SMALL_STATE(9916)] = 409857,
  [SMALL_STATE(9917)] = 409911,
  [SMALL_STATE(9918)] = 409965,
  [SMALL_STATE(9919)] = 410019,
  [SMALL_STATE(9920)] = 410073,
  [SMALL_STATE(9921)] = 410109,
  [SMALL_STATE(9922)] = 410163,
  [SMALL_STATE(9923)] = 410199,
  [SMALL_STATE(9924)] = 410253,
  [SMALL_STATE(9925)] = 410289,
  [SMALL_STATE(9926)] = 410343,
  [SMALL_STATE(9927)] = 410379,
  [SMALL_STATE(9928)] = 410413,
  [SMALL_STATE(9929)] = 410449,
  [SMALL_STATE(9930)] = 410503,
  [SMALL_STATE(9931)] = 410557,
  [SMALL_STATE(9932)] = 410611,
  [SMALL_STATE(9933)] = 410645,
  [SMALL_STATE(9934)] = 410681,
  [SMALL_STATE(9935)] = 410715,
  [SMALL_STATE(9936)] = 410751,
  [SMALL_STATE(9937)] = 410805,
  [SMALL_STATE(9938)] = 410859,
  [SMALL_STATE(9939)] = 410913,
  [SMALL_STATE(9940)] = 410949,
  [SMALL_STATE(9941)] = 410985,
  [SMALL_STATE(9942)] = 411021,
  [SMALL_STATE(9943)] = 411077,
  [SMALL_STATE(9944)] = 411113,
  [SMALL_STATE(9945)] = 411167,
  [SMALL_STATE(9946)] = 411221,
  [SMALL_STATE(9947)] = 411275,
  [SMALL_STATE(9948)] = 411329,
  [SMALL_STATE(9949)] = 411383,
  [SMALL_STATE(9950)] = 411419,
  [SMALL_STATE(9951)] = 411473,
  [SMALL_STATE(9952)] = 411509,
  [SMALL_STATE(9953)] = 411563,
  [SMALL_STATE(9954)] = 411599,
  [SMALL_STATE(9955)] = 411635,
  [SMALL_STATE(9956)] = 411689,
  [SMALL_STATE(9957)] = 411743,
  [SMALL_STATE(9958)] = 411777,
  [SMALL_STATE(9959)] = 411813,
  [SMALL_STATE(9960)] = 411849,
  [SMALL_STATE(9961)] = 411903,
  [SMALL_STATE(9962)] = 411939,
  [SMALL_STATE(9963)] = 411993,
  [SMALL_STATE(9964)] = 412029,
  [SMALL_STATE(9965)] = 412083,
  [SMALL_STATE(9966)] = 412137,
  [SMALL_STATE(9967)] = 412173,
  [SMALL_STATE(9968)] = 412207,
  [SMALL_STATE(9969)] = 412241,
  [SMALL_STATE(9970)] = 412277,
  [SMALL_STATE(9971)] = 412331,
  [SMALL_STATE(9972)] = 412367,
  [SMALL_STATE(9973)] = 412401,
  [SMALL_STATE(9974)] = 412455,
  [SMALL_STATE(9975)] = 412491,
  [SMALL_STATE(9976)] = 412545,
  [SMALL_STATE(9977)] = 412581,
  [SMALL_STATE(9978)] = 412635,
  [SMALL_STATE(9979)] = 412689,
  [SMALL_STATE(9980)] = 412725,
  [SMALL_STATE(9981)] = 412761,
  [SMALL_STATE(9982)] = 412797,
  [SMALL_STATE(9983)] = 412851,
  [SMALL_STATE(9984)] = 412887,
  [SMALL_STATE(9985)] = 412941,
  [SMALL_STATE(9986)] = 412977,
  [SMALL_STATE(9987)] = 413013,
  [SMALL_STATE(9988)] = 413049,
  [SMALL_STATE(9989)] = 413083,
  [SMALL_STATE(9990)] = 413137,
  [SMALL_STATE(9991)] = 413173,
  [SMALL_STATE(9992)] = 413227,
  [SMALL_STATE(9993)] = 413263,
  [SMALL_STATE(9994)] = 413299,
  [SMALL_STATE(9995)] = 413355,
  [SMALL_STATE(9996)] = 413391,
  [SMALL_STATE(9997)] = 413445,
  [SMALL_STATE(9998)] = 413499,
  [SMALL_STATE(9999)] = 413535,
  [SMALL_STATE(10000)] = 413571,
  [SMALL_STATE(10001)] = 413625,
  [SMALL_STATE(10002)] = 413661,
  [SMALL_STATE(10003)] = 413715,
  [SMALL_STATE(10004)] = 413751,
  [SMALL_STATE(10005)] = 413805,
  [SMALL_STATE(10006)] = 413841,
  [SMALL_STATE(10007)] = 413895,
  [SMALL_STATE(10008)] = 413951,
  [SMALL_STATE(10009)] = 413987,
  [SMALL_STATE(10010)] = 414041,
  [SMALL_STATE(10011)] = 414077,
  [SMALL_STATE(10012)] = 414113,
  [SMALL_STATE(10013)] = 414167,
  [SMALL_STATE(10014)] = 414203,
  [SMALL_STATE(10015)] = 414239,
  [SMALL_STATE(10016)] = 414275,
  [SMALL_STATE(10017)] = 414311,
  [SMALL_STATE(10018)] = 414347,
  [SMALL_STATE(10019)] = 414383,
  [SMALL_STATE(10020)] = 414419,
  [SMALL_STATE(10021)] = 414473,
  [SMALL_STATE(10022)] = 414527,
  [SMALL_STATE(10023)] = 414581,
  [SMALL_STATE(10024)] = 414635,
  [SMALL_STATE(10025)] = 414671,
  [SMALL_STATE(10026)] = 414707,
  [SMALL_STATE(10027)] = 414761,
  [SMALL_STATE(10028)] = 414797,
  [SMALL_STATE(10029)] = 414833,
  [SMALL_STATE(10030)] = 414887,
  [SMALL_STATE(10031)] = 414923,
  [SMALL_STATE(10032)] = 414957,
  [SMALL_STATE(10033)] = 414993,
  [SMALL_STATE(10034)] = 415027,
  [SMALL_STATE(10035)] = 415081,
  [SMALL_STATE(10036)] = 415117,
  [SMALL_STATE(10037)] = 415153,
  [SMALL_STATE(10038)] = 415207,
  [SMALL_STATE(10039)] = 415243,
  [SMALL_STATE(10040)] = 415279,
  [SMALL_STATE(10041)] = 415315,
  [SMALL_STATE(10042)] = 415351,
  [SMALL_STATE(10043)] = 415387,
  [SMALL_STATE(10044)] = 415423,
  [SMALL_STATE(10045)] = 415459,
  [SMALL_STATE(10046)] = 415513,
  [SMALL_STATE(10047)] = 415567,
  [SMALL_STATE(10048)] = 415621,
  [SMALL_STATE(10049)] = 415657,
  [SMALL_STATE(10050)] = 415691,
  [SMALL_STATE(10051)] = 415745,
  [SMALL_STATE(10052)] = 415781,
  [SMALL_STATE(10053)] = 415835,
  [SMALL_STATE(10054)] = 415871,
  [SMALL_STATE(10055)] = 415925,
  [SMALL_STATE(10056)] = 415981,
  [SMALL_STATE(10057)] = 416017,
  [SMALL_STATE(10058)] = 416071,
  [SMALL_STATE(10059)] = 416107,
  [SMALL_STATE(10060)] = 416141,
  [SMALL_STATE(10061)] = 416177,
  [SMALL_STATE(10062)] = 416213,
  [SMALL_STATE(10063)] = 416267,
  [SMALL_STATE(10064)] = 416321,
  [SMALL_STATE(10065)] = 416377,
  [SMALL_STATE(10066)] = 416413,
  [SMALL_STATE(10067)] = 416467,
  [SMALL_STATE(10068)] = 416503,
  [SMALL_STATE(10069)] = 416557,
  [SMALL_STATE(10070)] = 416613,
  [SMALL_STATE(10071)] = 416647,
  [SMALL_STATE(10072)] = 416701,
  [SMALL_STATE(10073)] = 416755,
  [SMALL_STATE(10074)] = 416809,
  [SMALL_STATE(10075)] = 416863,
  [SMALL_STATE(10076)] = 416897,
  [SMALL_STATE(10077)] = 416931,
  [SMALL_STATE(10078)] = 416987,
  [SMALL_STATE(10079)] = 417041,
  [SMALL_STATE(10080)] = 417095,
  [SMALL_STATE(10081)] = 417131,
  [SMALL_STATE(10082)] = 417185,
  [SMALL_STATE(10083)] = 417221,
  [SMALL_STATE(10084)] = 417275,
  [SMALL_STATE(10085)] = 417331,
  [SMALL_STATE(10086)] = 417367,
  [SMALL_STATE(10087)] = 417403,
  [SMALL_STATE(10088)] = 417439,
  [SMALL_STATE(10089)] = 417493,
  [SMALL_STATE(10090)] = 417529,
  [SMALL_STATE(10091)] = 417585,
  [SMALL_STATE(10092)] = 417619,
  [SMALL_STATE(10093)] = 417655,
  [SMALL_STATE(10094)] = 417691,
  [SMALL_STATE(10095)] = 417747,
  [SMALL_STATE(10096)] = 417801,
  [SMALL_STATE(10097)] = 417837,
  [SMALL_STATE(10098)] = 417891,
  [SMALL_STATE(10099)] = 417927,
  [SMALL_STATE(10100)] = 417981,
  [SMALL_STATE(10101)] = 418017,
  [SMALL_STATE(10102)] = 418071,
  [SMALL_STATE(10103)] = 418125,
  [SMALL_STATE(10104)] = 418159,
  [SMALL_STATE(10105)] = 418195,
  [SMALL_STATE(10106)] = 418229,
  [SMALL_STATE(10107)] = 418283,
  [SMALL_STATE(10108)] = 418319,
  [SMALL_STATE(10109)] = 418355,
  [SMALL_STATE(10110)] = 418391,
  [SMALL_STATE(10111)] = 418445,
  [SMALL_STATE(10112)] = 418499,
  [SMALL_STATE(10113)] = 418553,
  [SMALL_STATE(10114)] = 418587,
  [SMALL_STATE(10115)] = 418641,
  [SMALL_STATE(10116)] = 418675,
  [SMALL_STATE(10117)] = 418729,
  [SMALL_STATE(10118)] = 418765,
  [SMALL_STATE(10119)] = 418799,
  [SMALL_STATE(10120)] = 418835,
  [SMALL_STATE(10121)] = 418871,
  [SMALL_STATE(10122)] = 418925,
  [SMALL_STATE(10123)] = 418979,
  [SMALL_STATE(10124)] = 419035,
  [SMALL_STATE(10125)] = 419069,
  [SMALL_STATE(10126)] = 419105,
  [SMALL_STATE(10127)] = 419139,
  [SMALL_STATE(10128)] = 419173,
  [SMALL_STATE(10129)] = 419207,
  [SMALL_STATE(10130)] = 419261,
  [SMALL_STATE(10131)] = 419315,
  [SMALL_STATE(10132)] = 419351,
  [SMALL_STATE(10133)] = 419387,
  [SMALL_STATE(10134)] = 419441,
  [SMALL_STATE(10135)] = 419477,
  [SMALL_STATE(10136)] = 419513,
  [SMALL_STATE(10137)] = 419567,
  [SMALL_STATE(10138)] = 419603,
  [SMALL_STATE(10139)] = 419637,
  [SMALL_STATE(10140)] = 419671,
  [SMALL_STATE(10141)] = 419707,
  [SMALL_STATE(10142)] = 419761,
  [SMALL_STATE(10143)] = 419815,
  [SMALL_STATE(10144)] = 419851,
  [SMALL_STATE(10145)] = 419905,
  [SMALL_STATE(10146)] = 419959,
  [SMALL_STATE(10147)] = 419995,
  [SMALL_STATE(10148)] = 420031,
  [SMALL_STATE(10149)] = 420085,
  [SMALL_STATE(10150)] = 420139,
  [SMALL_STATE(10151)] = 420195,
  [SMALL_STATE(10152)] = 420251,
  [SMALL_STATE(10153)] = 420307,
  [SMALL_STATE(10154)] = 420343,
  [SMALL_STATE(10155)] = 420399,
  [SMALL_STATE(10156)] = 420455,
  [SMALL_STATE(10157)] = 420491,
  [SMALL_STATE(10158)] = 420547,
  [SMALL_STATE(10159)] = 420601,
  [SMALL_STATE(10160)] = 420635,
  [SMALL_STATE(10161)] = 420671,
  [SMALL_STATE(10162)] = 420707,
  [SMALL_STATE(10163)] = 420763,
  [SMALL_STATE(10164)] = 420817,
  [SMALL_STATE(10165)] = 420853,
  [SMALL_STATE(10166)] = 420907,
  [SMALL_STATE(10167)] = 420961,
  [SMALL_STATE(10168)] = 421015,
  [SMALL_STATE(10169)] = 421071,
  [SMALL_STATE(10170)] = 421105,
  [SMALL_STATE(10171)] = 421141,
  [SMALL_STATE(10172)] = 421177,
  [SMALL_STATE(10173)] = 421233,
  [SMALL_STATE(10174)] = 421287,
  [SMALL_STATE(10175)] = 421341,
  [SMALL_STATE(10176)] = 421377,
  [SMALL_STATE(10177)] = 421411,
  [SMALL_STATE(10178)] = 421445,
  [SMALL_STATE(10179)] = 421501,
  [SMALL_STATE(10180)] = 421555,
  [SMALL_STATE(10181)] = 421591,
  [SMALL_STATE(10182)] = 421625,
  [SMALL_STATE(10183)] = 421679,
  [SMALL_STATE(10184)] = 421733,
  [SMALL_STATE(10185)] = 421787,
  [SMALL_STATE(10186)] = 421823,
  [SMALL_STATE(10187)] = 421877,
  [SMALL_STATE(10188)] = 421933,
  [SMALL_STATE(10189)] = 421967,
  [SMALL_STATE(10190)] = 422003,
  [SMALL_STATE(10191)] = 422037,
  [SMALL_STATE(10192)] = 422073,
  [SMALL_STATE(10193)] = 422127,
  [SMALL_STATE(10194)] = 422181,
  [SMALL_STATE(10195)] = 422217,
  [SMALL_STATE(10196)] = 422273,
  [SMALL_STATE(10197)] = 422309,
  [SMALL_STATE(10198)] = 422345,
  [SMALL_STATE(10199)] = 422399,
  [SMALL_STATE(10200)] = 422435,
  [SMALL_STATE(10201)] = 422471,
  [SMALL_STATE(10202)] = 422525,
  [SMALL_STATE(10203)] = 422581,
  [SMALL_STATE(10204)] = 422637,
  [SMALL_STATE(10205)] = 422693,
  [SMALL_STATE(10206)] = 422729,
  [SMALL_STATE(10207)] = 422765,
  [SMALL_STATE(10208)] = 422801,
  [SMALL_STATE(10209)] = 422835,
  [SMALL_STATE(10210)] = 422871,
  [SMALL_STATE(10211)] = 422925,
  [SMALL_STATE(10212)] = 422961,
  [SMALL_STATE(10213)] = 422997,
  [SMALL_STATE(10214)] = 423051,
  [SMALL_STATE(10215)] = 423087,
  [SMALL_STATE(10216)] = 423123,
  [SMALL_STATE(10217)] = 423159,
  [SMALL_STATE(10218)] = 423215,
  [SMALL_STATE(10219)] = 423251,
  [SMALL_STATE(10220)] = 423287,
  [SMALL_STATE(10221)] = 423323,
  [SMALL_STATE(10222)] = 423359,
  [SMALL_STATE(10223)] = 423395,
  [SMALL_STATE(10224)] = 423449,
  [SMALL_STATE(10225)] = 423503,
  [SMALL_STATE(10226)] = 423539,
  [SMALL_STATE(10227)] = 423593,
  [SMALL_STATE(10228)] = 423629,
  [SMALL_STATE(10229)] = 423665,
  [SMALL_STATE(10230)] = 423719,
  [SMALL_STATE(10231)] = 423773,
  [SMALL_STATE(10232)] = 423807,
  [SMALL_STATE(10233)] = 423861,
  [SMALL_STATE(10234)] = 423915,
  [SMALL_STATE(10235)] = 423951,
  [SMALL_STATE(10236)] = 423984,
  [SMALL_STATE(10237)] = 424019,
  [SMALL_STATE(10238)] = 424054,
  [SMALL_STATE(10239)] = 424089,
  [SMALL_STATE(10240)] = 424124,
  [SMALL_STATE(10241)] = 424159,
  [SMALL_STATE(10242)] = 424192,
  [SMALL_STATE(10243)] = 424225,
  [SMALL_STATE(10244)] = 424260,
  [SMALL_STATE(10245)] = 424295,
  [SMALL_STATE(10246)] = 424330,
  [SMALL_STATE(10247)] = 424365,
  [SMALL_STATE(10248)] = 424400,
  [SMALL_STATE(10249)] = 424435,
  [SMALL_STATE(10250)] = 424470,
  [SMALL_STATE(10251)] = 424505,
  [SMALL_STATE(10252)] = 424540,
  [SMALL_STATE(10253)] = 424573,
  [SMALL_STATE(10254)] = 424606,
  [SMALL_STATE(10255)] = 424641,
  [SMALL_STATE(10256)] = 424676,
  [SMALL_STATE(10257)] = 424711,
  [SMALL_STATE(10258)] = 424746,
  [SMALL_STATE(10259)] = 424781,
  [SMALL_STATE(10260)] = 424816,
  [SMALL_STATE(10261)] = 424851,
  [SMALL_STATE(10262)] = 424886,
  [SMALL_STATE(10263)] = 424919,
  [SMALL_STATE(10264)] = 424954,
  [SMALL_STATE(10265)] = 424989,
  [SMALL_STATE(10266)] = 425024,
  [SMALL_STATE(10267)] = 425059,
  [SMALL_STATE(10268)] = 425094,
  [SMALL_STATE(10269)] = 425127,
  [SMALL_STATE(10270)] = 425160,
  [SMALL_STATE(10271)] = 425195,
  [SMALL_STATE(10272)] = 425228,
  [SMALL_STATE(10273)] = 425269,
  [SMALL_STATE(10274)] = 425302,
  [SMALL_STATE(10275)] = 425337,
  [SMALL_STATE(10276)] = 425372,
  [SMALL_STATE(10277)] = 425407,
  [SMALL_STATE(10278)] = 425442,
  [SMALL_STATE(10279)] = 425477,
  [SMALL_STATE(10280)] = 425510,
  [SMALL_STATE(10281)] = 425543,
  [SMALL_STATE(10282)] = 425578,
  [SMALL_STATE(10283)] = 425613,
  [SMALL_STATE(10284)] = 425646,
  [SMALL_STATE(10285)] = 425679,
  [SMALL_STATE(10286)] = 425712,
  [SMALL_STATE(10287)] = 425745,
  [SMALL_STATE(10288)] = 425780,
  [SMALL_STATE(10289)] = 425815,
  [SMALL_STATE(10290)] = 425848,
  [SMALL_STATE(10291)] = 425883,
  [SMALL_STATE(10292)] = 425918,
  [SMALL_STATE(10293)] = 425953,
  [SMALL_STATE(10294)] = 425988,
  [SMALL_STATE(10295)] = 426021,
  [SMALL_STATE(10296)] = 426056,
  [SMALL_STATE(10297)] = 426091,
  [SMALL_STATE(10298)] = 426124,
  [SMALL_STATE(10299)] = 426157,
  [SMALL_STATE(10300)] = 426192,
  [SMALL_STATE(10301)] = 426227,
  [SMALL_STATE(10302)] = 426276,
  [SMALL_STATE(10303)] = 426309,
  [SMALL_STATE(10304)] = 426364,
  [SMALL_STATE(10305)] = 426399,
  [SMALL_STATE(10306)] = 426432,
  [SMALL_STATE(10307)] = 426467,
  [SMALL_STATE(10308)] = 426502,
  [SMALL_STATE(10309)] = 426537,
  [SMALL_STATE(10310)] = 426570,
  [SMALL_STATE(10311)] = 426605,
  [SMALL_STATE(10312)] = 426640,
  [SMALL_STATE(10313)] = 426673,
  [SMALL_STATE(10314)] = 426706,
  [SMALL_STATE(10315)] = 426741,
  [SMALL_STATE(10316)] = 426796,
  [SMALL_STATE(10317)] = 426829,
  [SMALL_STATE(10318)] = 426864,
  [SMALL_STATE(10319)] = 426897,
  [SMALL_STATE(10320)] = 426932,
  [SMALL_STATE(10321)] = 426967,
  [SMALL_STATE(10322)] = 427002,
  [SMALL_STATE(10323)] = 427035,
  [SMALL_STATE(10324)] = 427068,
  [SMALL_STATE(10325)] = 427103,
  [SMALL_STATE(10326)] = 427138,
  [SMALL_STATE(10327)] = 427173,
  [SMALL_STATE(10328)] = 427208,
  [SMALL_STATE(10329)] = 427243,
  [SMALL_STATE(10330)] = 427278,
  [SMALL_STATE(10331)] = 427313,
  [SMALL_STATE(10332)] = 427348,
  [SMALL_STATE(10333)] = 427383,
  [SMALL_STATE(10334)] = 427418,
  [SMALL_STATE(10335)] = 427451,
  [SMALL_STATE(10336)] = 427486,
  [SMALL_STATE(10337)] = 427519,
  [SMALL_STATE(10338)] = 427554,
  [SMALL_STATE(10339)] = 427587,
  [SMALL_STATE(10340)] = 427622,
  [SMALL_STATE(10341)] = 427657,
  [SMALL_STATE(10342)] = 427690,
  [SMALL_STATE(10343)] = 427723,
  [SMALL_STATE(10344)] = 427758,
  [SMALL_STATE(10345)] = 427793,
  [SMALL_STATE(10346)] = 427828,
  [SMALL_STATE(10347)] = 427863,
  [SMALL_STATE(10348)] = 427898,
  [SMALL_STATE(10349)] = 427953,
  [SMALL_STATE(10350)] = 427988,
  [SMALL_STATE(10351)] = 428023,
  [SMALL_STATE(10352)] = 428056,
  [SMALL_STATE(10353)] = 428089,
  [SMALL_STATE(10354)] = 428124,
  [SMALL_STATE(10355)] = 428159,
  [SMALL_STATE(10356)] = 428208,
  [SMALL_STATE(10357)] = 428243,
  [SMALL_STATE(10358)] = 428278,
  [SMALL_STATE(10359)] = 428313,
  [SMALL_STATE(10360)] = 428346,
  [SMALL_STATE(10361)] = 428381,
  [SMALL_STATE(10362)] = 428414,
  [SMALL_STATE(10363)] = 428449,
  [SMALL_STATE(10364)] = 428484,
  [SMALL_STATE(10365)] = 428519,
  [SMALL_STATE(10366)] = 428552,
  [SMALL_STATE(10367)] = 428587,
  [SMALL_STATE(10368)] = 428622,
  [SMALL_STATE(10369)] = 428657,
  [SMALL_STATE(10370)] = 428690,
  [SMALL_STATE(10371)] = 428725,
  [SMALL_STATE(10372)] = 428760,
  [SMALL_STATE(10373)] = 428795,
  [SMALL_STATE(10374)] = 428830,
  [SMALL_STATE(10375)] = 428865,
  [SMALL_STATE(10376)] = 428900,
  [SMALL_STATE(10377)] = 428935,
  [SMALL_STATE(10378)] = 428968,
  [SMALL_STATE(10379)] = 429003,
  [SMALL_STATE(10380)] = 429036,
  [SMALL_STATE(10381)] = 429071,
  [SMALL_STATE(10382)] = 429106,
  [SMALL_STATE(10383)] = 429139,
  [SMALL_STATE(10384)] = 429174,
  [SMALL_STATE(10385)] = 429209,
  [SMALL_STATE(10386)] = 429244,
  [SMALL_STATE(10387)] = 429299,
  [SMALL_STATE(10388)] = 429334,
  [SMALL_STATE(10389)] = 429369,
  [SMALL_STATE(10390)] = 429404,
  [SMALL_STATE(10391)] = 429437,
  [SMALL_STATE(10392)] = 429472,
  [SMALL_STATE(10393)] = 429507,
  [SMALL_STATE(10394)] = 429542,
  [SMALL_STATE(10395)] = 429575,
  [SMALL_STATE(10396)] = 429610,
  [SMALL_STATE(10397)] = 429645,
  [SMALL_STATE(10398)] = 429680,
  [SMALL_STATE(10399)] = 429715,
  [SMALL_STATE(10400)] = 429770,
  [SMALL_STATE(10401)] = 429805,
  [SMALL_STATE(10402)] = 429840,
  [SMALL_STATE(10403)] = 429873,
  [SMALL_STATE(10404)] = 429908,
  [SMALL_STATE(10405)] = 429943,
  [SMALL_STATE(10406)] = 429976,
  [SMALL_STATE(10407)] = 430011,
  [SMALL_STATE(10408)] = 430044,
  [SMALL_STATE(10409)] = 430079,
  [SMALL_STATE(10410)] = 430114,
  [SMALL_STATE(10411)] = 430149,
  [SMALL_STATE(10412)] = 430184,
  [SMALL_STATE(10413)] = 430219,
  [SMALL_STATE(10414)] = 430254,
  [SMALL_STATE(10415)] = 430287,
  [SMALL_STATE(10416)] = 430320,
  [SMALL_STATE(10417)] = 430353,
  [SMALL_STATE(10418)] = 430388,
  [SMALL_STATE(10419)] = 430423,
  [SMALL_STATE(10420)] = 430458,
  [SMALL_STATE(10421)] = 430493,
  [SMALL_STATE(10422)] = 430528,
  [SMALL_STATE(10423)] = 430561,
  [SMALL_STATE(10424)] = 430596,
  [SMALL_STATE(10425)] = 430631,
  [SMALL_STATE(10426)] = 430664,
  [SMALL_STATE(10427)] = 430697,
  [SMALL_STATE(10428)] = 430732,
  [SMALL_STATE(10429)] = 430765,
  [SMALL_STATE(10430)] = 430800,
  [SMALL_STATE(10431)] = 430835,
  [SMALL_STATE(10432)] = 430870,
  [SMALL_STATE(10433)] = 430905,
  [SMALL_STATE(10434)] = 430940,
  [SMALL_STATE(10435)] = 430973,
  [SMALL_STATE(10436)] = 431008,
  [SMALL_STATE(10437)] = 431041,
  [SMALL_STATE(10438)] = 431076,
  [SMALL_STATE(10439)] = 431111,
  [SMALL_STATE(10440)] = 431144,
  [SMALL_STATE(10441)] = 431177,
  [SMALL_STATE(10442)] = 431212,
  [SMALL_STATE(10443)] = 431247,
  [SMALL_STATE(10444)] = 431280,
  [SMALL_STATE(10445)] = 431313,
  [SMALL_STATE(10446)] = 431348,
  [SMALL_STATE(10447)] = 431383,
  [SMALL_STATE(10448)] = 431418,
  [SMALL_STATE(10449)] = 431453,
  [SMALL_STATE(10450)] = 431488,
  [SMALL_STATE(10451)] = 431523,
  [SMALL_STATE(10452)] = 431558,
  [SMALL_STATE(10453)] = 431590,
  [SMALL_STATE(10454)] = 431622,
  [SMALL_STATE(10455)] = 431654,
  [SMALL_STATE(10456)] = 431686,
  [SMALL_STATE(10457)] = 431740,
  [SMALL_STATE(10458)] = 431774,
  [SMALL_STATE(10459)] = 431808,
  [SMALL_STATE(10460)] = 431842,
  [SMALL_STATE(10461)] = 431874,
  [SMALL_STATE(10462)] = 431906,
  [SMALL_STATE(10463)] = 431938,
  [SMALL_STATE(10464)] = 431992,
  [SMALL_STATE(10465)] = 432024,
  [SMALL_STATE(10466)] = 432058,
  [SMALL_STATE(10467)] = 432112,
  [SMALL_STATE(10468)] = 432166,
  [SMALL_STATE(10469)] = 432200,
  [SMALL_STATE(10470)] = 432254,
  [SMALL_STATE(10471)] = 432286,
  [SMALL_STATE(10472)] = 432318,
  [SMALL_STATE(10473)] = 432350,
  [SMALL_STATE(10474)] = 432404,
  [SMALL_STATE(10475)] = 432436,
  [SMALL_STATE(10476)] = 432490,
  [SMALL_STATE(10477)] = 432524,
  [SMALL_STATE(10478)] = 432556,
  [SMALL_STATE(10479)] = 432588,
  [SMALL_STATE(10480)] = 432620,
  [SMALL_STATE(10481)] = 432652,
  [SMALL_STATE(10482)] = 432690,
  [SMALL_STATE(10483)] = 432722,
  [SMALL_STATE(10484)] = 432754,
  [SMALL_STATE(10485)] = 432786,
  [SMALL_STATE(10486)] = 432818,
  [SMALL_STATE(10487)] = 432850,
  [SMALL_STATE(10488)] = 432886,
  [SMALL_STATE(10489)] = 432918,
  [SMALL_STATE(10490)] = 432950,
  [SMALL_STATE(10491)] = 432982,
  [SMALL_STATE(10492)] = 433020,
  [SMALL_STATE(10493)] = 433052,
  [SMALL_STATE(10494)] = 433106,
  [SMALL_STATE(10495)] = 433160,
  [SMALL_STATE(10496)] = 433192,
  [SMALL_STATE(10497)] = 433224,
  [SMALL_STATE(10498)] = 433278,
  [SMALL_STATE(10499)] = 433310,
  [SMALL_STATE(10500)] = 433364,
  [SMALL_STATE(10501)] = 433396,
  [SMALL_STATE(10502)] = 433428,
  [SMALL_STATE(10503)] = 433460,
  [SMALL_STATE(10504)] = 433514,
  [SMALL_STATE(10505)] = 433546,
  [SMALL_STATE(10506)] = 433580,
  [SMALL_STATE(10507)] = 433612,
  [SMALL_STATE(10508)] = 433644,
  [SMALL_STATE(10509)] = 433676,
  [SMALL_STATE(10510)] = 433708,
  [SMALL_STATE(10511)] = 433740,
  [SMALL_STATE(10512)] = 433780,
  [SMALL_STATE(10513)] = 433834,
  [SMALL_STATE(10514)] = 433888,
  [SMALL_STATE(10515)] = 433920,
  [SMALL_STATE(10516)] = 433952,
  [SMALL_STATE(10517)] = 433984,
  [SMALL_STATE(10518)] = 434016,
  [SMALL_STATE(10519)] = 434048,
  [SMALL_STATE(10520)] = 434102,
  [SMALL_STATE(10521)] = 434134,
  [SMALL_STATE(10522)] = 434168,
  [SMALL_STATE(10523)] = 434200,
  [SMALL_STATE(10524)] = 434232,
  [SMALL_STATE(10525)] = 434286,
  [SMALL_STATE(10526)] = 434320,
  [SMALL_STATE(10527)] = 434358,
  [SMALL_STATE(10528)] = 434396,
  [SMALL_STATE(10529)] = 434450,
  [SMALL_STATE(10530)] = 434482,
  [SMALL_STATE(10531)] = 434516,
  [SMALL_STATE(10532)] = 434548,
  [SMALL_STATE(10533)] = 434580,
  [SMALL_STATE(10534)] = 434612,
  [SMALL_STATE(10535)] = 434666,
  [SMALL_STATE(10536)] = 434698,
  [SMALL_STATE(10537)] = 434730,
  [SMALL_STATE(10538)] = 434762,
  [SMALL_STATE(10539)] = 434816,
  [SMALL_STATE(10540)] = 434870,
  [SMALL_STATE(10541)] = 434924,
  [SMALL_STATE(10542)] = 434956,
  [SMALL_STATE(10543)] = 434988,
  [SMALL_STATE(10544)] = 435020,
  [SMALL_STATE(10545)] = 435052,
  [SMALL_STATE(10546)] = 435106,
  [SMALL_STATE(10547)] = 435140,
  [SMALL_STATE(10548)] = 435172,
  [SMALL_STATE(10549)] = 435204,
  [SMALL_STATE(10550)] = 435236,
  [SMALL_STATE(10551)] = 435268,
  [SMALL_STATE(10552)] = 435300,
  [SMALL_STATE(10553)] = 435332,
  [SMALL_STATE(10554)] = 435364,
  [SMALL_STATE(10555)] = 435398,
  [SMALL_STATE(10556)] = 435430,
  [SMALL_STATE(10557)] = 435484,
  [SMALL_STATE(10558)] = 435516,
  [SMALL_STATE(10559)] = 435548,
  [SMALL_STATE(10560)] = 435580,
  [SMALL_STATE(10561)] = 435612,
  [SMALL_STATE(10562)] = 435666,
  [SMALL_STATE(10563)] = 435698,
  [SMALL_STATE(10564)] = 435730,
  [SMALL_STATE(10565)] = 435784,
  [SMALL_STATE(10566)] = 435816,
  [SMALL_STATE(10567)] = 435870,
  [SMALL_STATE(10568)] = 435904,
  [SMALL_STATE(10569)] = 435958,
  [SMALL_STATE(10570)] = 435990,
  [SMALL_STATE(10571)] = 436044,
  [SMALL_STATE(10572)] = 436076,
  [SMALL_STATE(10573)] = 436130,
  [SMALL_STATE(10574)] = 436184,
  [SMALL_STATE(10575)] = 436216,
  [SMALL_STATE(10576)] = 436248,
  [SMALL_STATE(10577)] = 436302,
  [SMALL_STATE(10578)] = 436334,
  [SMALL_STATE(10579)] = 436366,
  [SMALL_STATE(10580)] = 436420,
  [SMALL_STATE(10581)] = 436474,
  [SMALL_STATE(10582)] = 436528,
  [SMALL_STATE(10583)] = 436560,
  [SMALL_STATE(10584)] = 436598,
  [SMALL_STATE(10585)] = 436629,
  [SMALL_STATE(10586)] = 436660,
  [SMALL_STATE(10587)] = 436693,
  [SMALL_STATE(10588)] = 436724,
  [SMALL_STATE(10589)] = 436755,
  [SMALL_STATE(10590)] = 436786,
  [SMALL_STATE(10591)] = 436817,
  [SMALL_STATE(10592)] = 436848,
  [SMALL_STATE(10593)] = 436879,
  [SMALL_STATE(10594)] = 436912,
  [SMALL_STATE(10595)] = 436943,
  [SMALL_STATE(10596)] = 436974,
  [SMALL_STATE(10597)] = 437005,
  [SMALL_STATE(10598)] = 437036,
  [SMALL_STATE(10599)] = 437067,
  [SMALL_STATE(10600)] = 437098,
  [SMALL_STATE(10601)] = 437129,
  [SMALL_STATE(10602)] = 437162,
  [SMALL_STATE(10603)] = 437193,
  [SMALL_STATE(10604)] = 437224,
  [SMALL_STATE(10605)] = 437255,
  [SMALL_STATE(10606)] = 437286,
  [SMALL_STATE(10607)] = 437323,
  [SMALL_STATE(10608)] = 437354,
  [SMALL_STATE(10609)] = 437385,
  [SMALL_STATE(10610)] = 437416,
  [SMALL_STATE(10611)] = 437447,
  [SMALL_STATE(10612)] = 437478,
  [SMALL_STATE(10613)] = 437515,
  [SMALL_STATE(10614)] = 437546,
  [SMALL_STATE(10615)] = 437577,
  [SMALL_STATE(10616)] = 437608,
  [SMALL_STATE(10617)] = 437639,
  [SMALL_STATE(10618)] = 437670,
  [SMALL_STATE(10619)] = 437701,
  [SMALL_STATE(10620)] = 437732,
  [SMALL_STATE(10621)] = 437762,
  [SMALL_STATE(10622)] = 437792,
  [SMALL_STATE(10623)] = 437822,
  [SMALL_STATE(10624)] = 437854,
  [SMALL_STATE(10625)] = 437884,
  [SMALL_STATE(10626)] = 437914,
  [SMALL_STATE(10627)] = 437952,
  [SMALL_STATE(10628)] = 437982,
  [SMALL_STATE(10629)] = 438012,
  [SMALL_STATE(10630)] = 438044,
  [SMALL_STATE(10631)] = 438074,
  [SMALL_STATE(10632)] = 438104,
  [SMALL_STATE(10633)] = 438134,
  [SMALL_STATE(10634)] = 438164,
  [SMALL_STATE(10635)] = 438196,
  [SMALL_STATE(10636)] = 438234,
  [SMALL_STATE(10637)] = 438264,
  [SMALL_STATE(10638)] = 438294,
  [SMALL_STATE(10639)] = 438324,
  [SMALL_STATE(10640)] = 438354,
  [SMALL_STATE(10641)] = 438384,
  [SMALL_STATE(10642)] = 438414,
  [SMALL_STATE(10643)] = 438444,
  [SMALL_STATE(10644)] = 438476,
  [SMALL_STATE(10645)] = 438506,
  [SMALL_STATE(10646)] = 438536,
  [SMALL_STATE(10647)] = 438566,
  [SMALL_STATE(10648)] = 438596,
  [SMALL_STATE(10649)] = 438626,
  [SMALL_STATE(10650)] = 438656,
  [SMALL_STATE(10651)] = 438686,
  [SMALL_STATE(10652)] = 438716,
  [SMALL_STATE(10653)] = 438746,
  [SMALL_STATE(10654)] = 438776,
  [SMALL_STATE(10655)] = 438806,
  [SMALL_STATE(10656)] = 438836,
  [SMALL_STATE(10657)] = 438866,
  [SMALL_STATE(10658)] = 438912,
  [SMALL_STATE(10659)] = 438942,
  [SMALL_STATE(10660)] = 438972,
  [SMALL_STATE(10661)] = 439002,
  [SMALL_STATE(10662)] = 439032,
  [SMALL_STATE(10663)] = 439078,
  [SMALL_STATE(10664)] = 439108,
  [SMALL_STATE(10665)] = 439138,
  [SMALL_STATE(10666)] = 439168,
  [SMALL_STATE(10667)] = 439198,
  [SMALL_STATE(10668)] = 439228,
  [SMALL_STATE(10669)] = 439258,
  [SMALL_STATE(10670)] = 439288,
  [SMALL_STATE(10671)] = 439318,
  [SMALL_STATE(10672)] = 439348,
  [SMALL_STATE(10673)] = 439394,
  [SMALL_STATE(10674)] = 439424,
  [SMALL_STATE(10675)] = 439456,
  [SMALL_STATE(10676)] = 439486,
  [SMALL_STATE(10677)] = 439516,
  [SMALL_STATE(10678)] = 439546,
  [SMALL_STATE(10679)] = 439576,
  [SMALL_STATE(10680)] = 439606,
  [SMALL_STATE(10681)] = 439638,
  [SMALL_STATE(10682)] = 439668,
  [SMALL_STATE(10683)] = 439698,
  [SMALL_STATE(10684)] = 439728,
  [SMALL_STATE(10685)] = 439760,
  [SMALL_STATE(10686)] = 439790,
  [SMALL_STATE(10687)] = 439820,
  [SMALL_STATE(10688)] = 439856,
  [SMALL_STATE(10689)] = 439886,
  [SMALL_STATE(10690)] = 439917,
  [SMALL_STATE(10691)] = 439946,
  [SMALL_STATE(10692)] = 439975,
  [SMALL_STATE(10693)] = 440006,
  [SMALL_STATE(10694)] = 440035,
  [SMALL_STATE(10695)] = 440064,
  [SMALL_STATE(10696)] = 440095,
  [SMALL_STATE(10697)] = 440124,
  [SMALL_STATE(10698)] = 440153,
  [SMALL_STATE(10699)] = 440182,
  [SMALL_STATE(10700)] = 440211,
  [SMALL_STATE(10701)] = 440246,
  [SMALL_STATE(10702)] = 440277,
  [SMALL_STATE(10703)] = 440306,
  [SMALL_STATE(10704)] = 440335,
  [SMALL_STATE(10705)] = 440364,
  [SMALL_STATE(10706)] = 440409,
  [SMALL_STATE(10707)] = 440438,
  [SMALL_STATE(10708)] = 440475,
  [SMALL_STATE(10709)] = 440504,
  [SMALL_STATE(10710)] = 440533,
  [SMALL_STATE(10711)] = 440570,
  [SMALL_STATE(10712)] = 440605,
  [SMALL_STATE(10713)] = 440634,
  [SMALL_STATE(10714)] = 440669,
  [SMALL_STATE(10715)] = 440706,
  [SMALL_STATE(10716)] = 440735,
  [SMALL_STATE(10717)] = 440764,
  [SMALL_STATE(10718)] = 440793,
  [SMALL_STATE(10719)] = 440822,
  [SMALL_STATE(10720)] = 440867,
  [SMALL_STATE(10721)] = 440896,
  [SMALL_STATE(10722)] = 440933,
  [SMALL_STATE(10723)] = 440962,
  [SMALL_STATE(10724)] = 440991,
  [SMALL_STATE(10725)] = 441028,
  [SMALL_STATE(10726)] = 441065,
  [SMALL_STATE(10727)] = 441094,
  [SMALL_STATE(10728)] = 441123,
  [SMALL_STATE(10729)] = 441152,
  [SMALL_STATE(10730)] = 441181,
  [SMALL_STATE(10731)] = 441210,
  [SMALL_STATE(10732)] = 441239,
  [SMALL_STATE(10733)] = 441268,
  [SMALL_STATE(10734)] = 441297,
  [SMALL_STATE(10735)] = 441332,
  [SMALL_STATE(10736)] = 441361,
  [SMALL_STATE(10737)] = 441390,
  [SMALL_STATE(10738)] = 441419,
  [SMALL_STATE(10739)] = 441448,
  [SMALL_STATE(10740)] = 441479,
  [SMALL_STATE(10741)] = 441508,
  [SMALL_STATE(10742)] = 441537,
  [SMALL_STATE(10743)] = 441566,
  [SMALL_STATE(10744)] = 441595,
  [SMALL_STATE(10745)] = 441624,
  [SMALL_STATE(10746)] = 441655,
  [SMALL_STATE(10747)] = 441684,
  [SMALL_STATE(10748)] = 441713,
  [SMALL_STATE(10749)] = 441742,
  [SMALL_STATE(10750)] = 441773,
  [SMALL_STATE(10751)] = 441802,
  [SMALL_STATE(10752)] = 441831,
  [SMALL_STATE(10753)] = 441860,
  [SMALL_STATE(10754)] = 441889,
  [SMALL_STATE(10755)] = 441918,
  [SMALL_STATE(10756)] = 441947,
  [SMALL_STATE(10757)] = 441976,
  [SMALL_STATE(10758)] = 442005,
  [SMALL_STATE(10759)] = 442034,
  [SMALL_STATE(10760)] = 442063,
  [SMALL_STATE(10761)] = 442094,
  [SMALL_STATE(10762)] = 442123,
  [SMALL_STATE(10763)] = 442152,
  [SMALL_STATE(10764)] = 442181,
  [SMALL_STATE(10765)] = 442210,
  [SMALL_STATE(10766)] = 442239,
  [SMALL_STATE(10767)] = 442268,
  [SMALL_STATE(10768)] = 442297,
  [SMALL_STATE(10769)] = 442326,
  [SMALL_STATE(10770)] = 442355,
  [SMALL_STATE(10771)] = 442384,
  [SMALL_STATE(10772)] = 442413,
  [SMALL_STATE(10773)] = 442442,
  [SMALL_STATE(10774)] = 442471,
  [SMALL_STATE(10775)] = 442500,
  [SMALL_STATE(10776)] = 442529,
  [SMALL_STATE(10777)] = 442564,
  [SMALL_STATE(10778)] = 442593,
  [SMALL_STATE(10779)] = 442622,
  [SMALL_STATE(10780)] = 442651,
  [SMALL_STATE(10781)] = 442680,
  [SMALL_STATE(10782)] = 442709,
  [SMALL_STATE(10783)] = 442738,
  [SMALL_STATE(10784)] = 442772,
  [SMALL_STATE(10785)] = 442814,
  [SMALL_STATE(10786)] = 442842,
  [SMALL_STATE(10787)] = 442870,
  [SMALL_STATE(10788)] = 442898,
  [SMALL_STATE(10789)] = 442926,
  [SMALL_STATE(10790)] = 442954,
  [SMALL_STATE(10791)] = 442984,
  [SMALL_STATE(10792)] = 443012,
  [SMALL_STATE(10793)] = 443040,
  [SMALL_STATE(10794)] = 443068,
  [SMALL_STATE(10795)] = 443096,
  [SMALL_STATE(10796)] = 443124,
  [SMALL_STATE(10797)] = 443152,
  [SMALL_STATE(10798)] = 443182,
  [SMALL_STATE(10799)] = 443210,
  [SMALL_STATE(10800)] = 443238,
  [SMALL_STATE(10801)] = 443266,
  [SMALL_STATE(10802)] = 443296,
  [SMALL_STATE(10803)] = 443326,
  [SMALL_STATE(10804)] = 443354,
  [SMALL_STATE(10805)] = 443382,
  [SMALL_STATE(10806)] = 443410,
  [SMALL_STATE(10807)] = 443438,
  [SMALL_STATE(10808)] = 443466,
  [SMALL_STATE(10809)] = 443494,
  [SMALL_STATE(10810)] = 443522,
  [SMALL_STATE(10811)] = 443550,
  [SMALL_STATE(10812)] = 443578,
  [SMALL_STATE(10813)] = 443620,
  [SMALL_STATE(10814)] = 443648,
  [SMALL_STATE(10815)] = 443684,
  [SMALL_STATE(10816)] = 443714,
  [SMALL_STATE(10817)] = 443742,
  [SMALL_STATE(10818)] = 443784,
  [SMALL_STATE(10819)] = 443812,
  [SMALL_STATE(10820)] = 443840,
  [SMALL_STATE(10821)] = 443868,
  [SMALL_STATE(10822)] = 443896,
  [SMALL_STATE(10823)] = 443924,
  [SMALL_STATE(10824)] = 443954,
  [SMALL_STATE(10825)] = 443990,
  [SMALL_STATE(10826)] = 444018,
  [SMALL_STATE(10827)] = 444046,
  [SMALL_STATE(10828)] = 444078,
  [SMALL_STATE(10829)] = 444106,
  [SMALL_STATE(10830)] = 444134,
  [SMALL_STATE(10831)] = 444162,
  [SMALL_STATE(10832)] = 444190,
  [SMALL_STATE(10833)] = 444224,
  [SMALL_STATE(10834)] = 444252,
  [SMALL_STATE(10835)] = 444280,
  [SMALL_STATE(10836)] = 444308,
  [SMALL_STATE(10837)] = 444336,
  [SMALL_STATE(10838)] = 444364,
  [SMALL_STATE(10839)] = 444392,
  [SMALL_STATE(10840)] = 444420,
  [SMALL_STATE(10841)] = 444454,
  [SMALL_STATE(10842)] = 444484,
  [SMALL_STATE(10843)] = 444512,
  [SMALL_STATE(10844)] = 444540,
  [SMALL_STATE(10845)] = 444568,
  [SMALL_STATE(10846)] = 444596,
  [SMALL_STATE(10847)] = 444624,
  [SMALL_STATE(10848)] = 444652,
  [SMALL_STATE(10849)] = 444680,
  [SMALL_STATE(10850)] = 444708,
  [SMALL_STATE(10851)] = 444750,
  [SMALL_STATE(10852)] = 444778,
  [SMALL_STATE(10853)] = 444812,
  [SMALL_STATE(10854)] = 444840,
  [SMALL_STATE(10855)] = 444874,
  [SMALL_STATE(10856)] = 444902,
  [SMALL_STATE(10857)] = 444932,
  [SMALL_STATE(10858)] = 444968,
  [SMALL_STATE(10859)] = 444998,
  [SMALL_STATE(10860)] = 445026,
  [SMALL_STATE(10861)] = 445068,
  [SMALL_STATE(10862)] = 445096,
  [SMALL_STATE(10863)] = 445126,
  [SMALL_STATE(10864)] = 445154,
  [SMALL_STATE(10865)] = 445182,
  [SMALL_STATE(10866)] = 445218,
  [SMALL_STATE(10867)] = 445246,
  [SMALL_STATE(10868)] = 445274,
  [SMALL_STATE(10869)] = 445302,
  [SMALL_STATE(10870)] = 445330,
  [SMALL_STATE(10871)] = 445358,
  [SMALL_STATE(10872)] = 445386,
  [SMALL_STATE(10873)] = 445422,
  [SMALL_STATE(10874)] = 445448,
  [SMALL_STATE(10875)] = 445476,
  [SMALL_STATE(10876)] = 445504,
  [SMALL_STATE(10877)] = 445532,
  [SMALL_STATE(10878)] = 445560,
  [SMALL_STATE(10879)] = 445604,
  [SMALL_STATE(10880)] = 445646,
  [SMALL_STATE(10881)] = 445674,
  [SMALL_STATE(10882)] = 445702,
  [SMALL_STATE(10883)] = 445730,
  [SMALL_STATE(10884)] = 445758,
  [SMALL_STATE(10885)] = 445786,
  [SMALL_STATE(10886)] = 445816,
  [SMALL_STATE(10887)] = 445858,
  [SMALL_STATE(10888)] = 445892,
  [SMALL_STATE(10889)] = 445934,
  [SMALL_STATE(10890)] = 445962,
  [SMALL_STATE(10891)] = 445998,
  [SMALL_STATE(10892)] = 446026,
  [SMALL_STATE(10893)] = 446056,
  [SMALL_STATE(10894)] = 446084,
  [SMALL_STATE(10895)] = 446120,
  [SMALL_STATE(10896)] = 446148,
  [SMALL_STATE(10897)] = 446190,
  [SMALL_STATE(10898)] = 446218,
  [SMALL_STATE(10899)] = 446246,
  [SMALL_STATE(10900)] = 446288,
  [SMALL_STATE(10901)] = 446322,
  [SMALL_STATE(10902)] = 446350,
  [SMALL_STATE(10903)] = 446378,
  [SMALL_STATE(10904)] = 446406,
  [SMALL_STATE(10905)] = 446434,
  [SMALL_STATE(10906)] = 446462,
  [SMALL_STATE(10907)] = 446490,
  [SMALL_STATE(10908)] = 446518,
  [SMALL_STATE(10909)] = 446546,
  [SMALL_STATE(10910)] = 446574,
  [SMALL_STATE(10911)] = 446616,
  [SMALL_STATE(10912)] = 446659,
  [SMALL_STATE(10913)] = 446686,
  [SMALL_STATE(10914)] = 446729,
  [SMALL_STATE(10915)] = 446772,
  [SMALL_STATE(10916)] = 446815,
  [SMALL_STATE(10917)] = 446858,
  [SMALL_STATE(10918)] = 446885,
  [SMALL_STATE(10919)] = 446912,
  [SMALL_STATE(10920)] = 446955,
  [SMALL_STATE(10921)] = 446998,
  [SMALL_STATE(10922)] = 447027,
  [SMALL_STATE(10923)] = 447070,
  [SMALL_STATE(10924)] = 447097,
  [SMALL_STATE(10925)] = 447124,
  [SMALL_STATE(10926)] = 447167,
  [SMALL_STATE(10927)] = 447196,
  [SMALL_STATE(10928)] = 447239,
  [SMALL_STATE(10929)] = 447268,
  [SMALL_STATE(10930)] = 447299,
  [SMALL_STATE(10931)] = 447330,
  [SMALL_STATE(10932)] = 447357,
  [SMALL_STATE(10933)] = 447384,
  [SMALL_STATE(10934)] = 447427,
  [SMALL_STATE(10935)] = 447454,
  [SMALL_STATE(10936)] = 447487,
  [SMALL_STATE(10937)] = 447514,
  [SMALL_STATE(10938)] = 447541,
  [SMALL_STATE(10939)] = 447584,
  [SMALL_STATE(10940)] = 447627,
  [SMALL_STATE(10941)] = 447670,
  [SMALL_STATE(10942)] = 447713,
  [SMALL_STATE(10943)] = 447756,
  [SMALL_STATE(10944)] = 447783,
  [SMALL_STATE(10945)] = 447826,
  [SMALL_STATE(10946)] = 447853,
  [SMALL_STATE(10947)] = 447880,
  [SMALL_STATE(10948)] = 447907,
  [SMALL_STATE(10949)] = 447950,
  [SMALL_STATE(10950)] = 447977,
  [SMALL_STATE(10951)] = 448020,
  [SMALL_STATE(10952)] = 448063,
  [SMALL_STATE(10953)] = 448090,
  [SMALL_STATE(10954)] = 448117,
  [SMALL_STATE(10955)] = 448152,
  [SMALL_STATE(10956)] = 448195,
  [SMALL_STATE(10957)] = 448238,
  [SMALL_STATE(10958)] = 448265,
  [SMALL_STATE(10959)] = 448292,
  [SMALL_STATE(10960)] = 448319,
  [SMALL_STATE(10961)] = 448348,
  [SMALL_STATE(10962)] = 448375,
  [SMALL_STATE(10963)] = 448402,
  [SMALL_STATE(10964)] = 448445,
  [SMALL_STATE(10965)] = 448472,
  [SMALL_STATE(10966)] = 448515,
  [SMALL_STATE(10967)] = 448558,
  [SMALL_STATE(10968)] = 448585,
  [SMALL_STATE(10969)] = 448612,
  [SMALL_STATE(10970)] = 448639,
  [SMALL_STATE(10971)] = 448666,
  [SMALL_STATE(10972)] = 448693,
  [SMALL_STATE(10973)] = 448720,
  [SMALL_STATE(10974)] = 448763,
  [SMALL_STATE(10975)] = 448790,
  [SMALL_STATE(10976)] = 448833,
  [SMALL_STATE(10977)] = 448876,
  [SMALL_STATE(10978)] = 448903,
  [SMALL_STATE(10979)] = 448930,
  [SMALL_STATE(10980)] = 448957,
  [SMALL_STATE(10981)] = 448984,
  [SMALL_STATE(10982)] = 449011,
  [SMALL_STATE(10983)] = 449054,
  [SMALL_STATE(10984)] = 449097,
  [SMALL_STATE(10985)] = 449140,
  [SMALL_STATE(10986)] = 449183,
  [SMALL_STATE(10987)] = 449210,
  [SMALL_STATE(10988)] = 449253,
  [SMALL_STATE(10989)] = 449280,
  [SMALL_STATE(10990)] = 449323,
  [SMALL_STATE(10991)] = 449366,
  [SMALL_STATE(10992)] = 449397,
  [SMALL_STATE(10993)] = 449424,
  [SMALL_STATE(10994)] = 449451,
  [SMALL_STATE(10995)] = 449478,
  [SMALL_STATE(10996)] = 449521,
  [SMALL_STATE(10997)] = 449548,
  [SMALL_STATE(10998)] = 449591,
  [SMALL_STATE(10999)] = 449618,
  [SMALL_STATE(11000)] = 449645,
  [SMALL_STATE(11001)] = 449688,
  [SMALL_STATE(11002)] = 449715,
  [SMALL_STATE(11003)] = 449742,
  [SMALL_STATE(11004)] = 449769,
  [SMALL_STATE(11005)] = 449812,
  [SMALL_STATE(11006)] = 449841,
  [SMALL_STATE(11007)] = 449884,
  [SMALL_STATE(11008)] = 449911,
  [SMALL_STATE(11009)] = 449954,
  [SMALL_STATE(11010)] = 449997,
  [SMALL_STATE(11011)] = 450040,
  [SMALL_STATE(11012)] = 450067,
  [SMALL_STATE(11013)] = 450096,
  [SMALL_STATE(11014)] = 450123,
  [SMALL_STATE(11015)] = 450166,
  [SMALL_STATE(11016)] = 450209,
  [SMALL_STATE(11017)] = 450252,
  [SMALL_STATE(11018)] = 450281,
  [SMALL_STATE(11019)] = 450308,
  [SMALL_STATE(11020)] = 450335,
  [SMALL_STATE(11021)] = 450364,
  [SMALL_STATE(11022)] = 450391,
  [SMALL_STATE(11023)] = 450434,
  [SMALL_STATE(11024)] = 450461,
  [SMALL_STATE(11025)] = 450488,
  [SMALL_STATE(11026)] = 450531,
  [SMALL_STATE(11027)] = 450562,
  [SMALL_STATE(11028)] = 450589,
  [SMALL_STATE(11029)] = 450622,
  [SMALL_STATE(11030)] = 450649,
  [SMALL_STATE(11031)] = 450678,
  [SMALL_STATE(11032)] = 450705,
  [SMALL_STATE(11033)] = 450732,
  [SMALL_STATE(11034)] = 450775,
  [SMALL_STATE(11035)] = 450802,
  [SMALL_STATE(11036)] = 450831,
  [SMALL_STATE(11037)] = 450860,
  [SMALL_STATE(11038)] = 450903,
  [SMALL_STATE(11039)] = 450930,
  [SMALL_STATE(11040)] = 450973,
  [SMALL_STATE(11041)] = 451004,
  [SMALL_STATE(11042)] = 451047,
  [SMALL_STATE(11043)] = 451074,
  [SMALL_STATE(11044)] = 451117,
  [SMALL_STATE(11045)] = 451160,
  [SMALL_STATE(11046)] = 451203,
  [SMALL_STATE(11047)] = 451246,
  [SMALL_STATE(11048)] = 451289,
  [SMALL_STATE(11049)] = 451320,
  [SMALL_STATE(11050)] = 451347,
  [SMALL_STATE(11051)] = 451374,
  [SMALL_STATE(11052)] = 451417,
  [SMALL_STATE(11053)] = 451460,
  [SMALL_STATE(11054)] = 451503,
  [SMALL_STATE(11055)] = 451546,
  [SMALL_STATE(11056)] = 451573,
  [SMALL_STATE(11057)] = 451600,
  [SMALL_STATE(11058)] = 451631,
  [SMALL_STATE(11059)] = 451658,
  [SMALL_STATE(11060)] = 451685,
  [SMALL_STATE(11061)] = 451728,
  [SMALL_STATE(11062)] = 451771,
  [SMALL_STATE(11063)] = 451798,
  [SMALL_STATE(11064)] = 451841,
  [SMALL_STATE(11065)] = 451868,
  [SMALL_STATE(11066)] = 451903,
  [SMALL_STATE(11067)] = 451946,
  [SMALL_STATE(11068)] = 451975,
  [SMALL_STATE(11069)] = 452002,
  [SMALL_STATE(11070)] = 452045,
  [SMALL_STATE(11071)] = 452072,
  [SMALL_STATE(11072)] = 452101,
  [SMALL_STATE(11073)] = 452128,
  [SMALL_STATE(11074)] = 452171,
  [SMALL_STATE(11075)] = 452214,
  [SMALL_STATE(11076)] = 452243,
  [SMALL_STATE(11077)] = 452270,
  [SMALL_STATE(11078)] = 452297,
  [SMALL_STATE(11079)] = 452324,
  [SMALL_STATE(11080)] = 452351,
  [SMALL_STATE(11081)] = 452402,
  [SMALL_STATE(11082)] = 452445,
  [SMALL_STATE(11083)] = 452488,
  [SMALL_STATE(11084)] = 452515,
  [SMALL_STATE(11085)] = 452542,
  [SMALL_STATE(11086)] = 452569,
  [SMALL_STATE(11087)] = 452612,
  [SMALL_STATE(11088)] = 452655,
  [SMALL_STATE(11089)] = 452698,
  [SMALL_STATE(11090)] = 452741,
  [SMALL_STATE(11091)] = 452768,
  [SMALL_STATE(11092)] = 452795,
  [SMALL_STATE(11093)] = 452822,
  [SMALL_STATE(11094)] = 452849,
  [SMALL_STATE(11095)] = 452892,
  [SMALL_STATE(11096)] = 452923,
  [SMALL_STATE(11097)] = 452966,
  [SMALL_STATE(11098)] = 453009,
  [SMALL_STATE(11099)] = 453036,
  [SMALL_STATE(11100)] = 453067,
  [SMALL_STATE(11101)] = 453094,
  [SMALL_STATE(11102)] = 453137,
  [SMALL_STATE(11103)] = 453164,
  [SMALL_STATE(11104)] = 453207,
  [SMALL_STATE(11105)] = 453250,
  [SMALL_STATE(11106)] = 453293,
  [SMALL_STATE(11107)] = 453336,
  [SMALL_STATE(11108)] = 453365,
  [SMALL_STATE(11109)] = 453392,
  [SMALL_STATE(11110)] = 453419,
  [SMALL_STATE(11111)] = 453450,
  [SMALL_STATE(11112)] = 453479,
  [SMALL_STATE(11113)] = 453506,
  [SMALL_STATE(11114)] = 453533,
  [SMALL_STATE(11115)] = 453560,
  [SMALL_STATE(11116)] = 453603,
  [SMALL_STATE(11117)] = 453630,
  [SMALL_STATE(11118)] = 453657,
  [SMALL_STATE(11119)] = 453684,
  [SMALL_STATE(11120)] = 453711,
  [SMALL_STATE(11121)] = 453754,
  [SMALL_STATE(11122)] = 453783,
  [SMALL_STATE(11123)] = 453810,
  [SMALL_STATE(11124)] = 453837,
  [SMALL_STATE(11125)] = 453864,
  [SMALL_STATE(11126)] = 453891,
  [SMALL_STATE(11127)] = 453918,
  [SMALL_STATE(11128)] = 453945,
  [SMALL_STATE(11129)] = 453988,
  [SMALL_STATE(11130)] = 454017,
  [SMALL_STATE(11131)] = 454044,
  [SMALL_STATE(11132)] = 454071,
  [SMALL_STATE(11133)] = 454114,
  [SMALL_STATE(11134)] = 454157,
  [SMALL_STATE(11135)] = 454200,
  [SMALL_STATE(11136)] = 454243,
  [SMALL_STATE(11137)] = 454278,
  [SMALL_STATE(11138)] = 454321,
  [SMALL_STATE(11139)] = 454348,
  [SMALL_STATE(11140)] = 454377,
  [SMALL_STATE(11141)] = 454420,
  [SMALL_STATE(11142)] = 454447,
  [SMALL_STATE(11143)] = 454474,
  [SMALL_STATE(11144)] = 454509,
  [SMALL_STATE(11145)] = 454552,
  [SMALL_STATE(11146)] = 454579,
  [SMALL_STATE(11147)] = 454606,
  [SMALL_STATE(11148)] = 454633,
  [SMALL_STATE(11149)] = 454660,
  [SMALL_STATE(11150)] = 454687,
  [SMALL_STATE(11151)] = 454714,
  [SMALL_STATE(11152)] = 454741,
  [SMALL_STATE(11153)] = 454784,
  [SMALL_STATE(11154)] = 454811,
  [SMALL_STATE(11155)] = 454838,
  [SMALL_STATE(11156)] = 454865,
  [SMALL_STATE(11157)] = 454891,
  [SMALL_STATE(11158)] = 454917,
  [SMALL_STATE(11159)] = 454945,
  [SMALL_STATE(11160)] = 454971,
  [SMALL_STATE(11161)] = 455013,
  [SMALL_STATE(11162)] = 455055,
  [SMALL_STATE(11163)] = 455097,
  [SMALL_STATE(11164)] = 455125,
  [SMALL_STATE(11165)] = 455151,
  [SMALL_STATE(11166)] = 455177,
  [SMALL_STATE(11167)] = 455203,
  [SMALL_STATE(11168)] = 455229,
  [SMALL_STATE(11169)] = 455271,
  [SMALL_STATE(11170)] = 455297,
  [SMALL_STATE(11171)] = 455323,
  [SMALL_STATE(11172)] = 455349,
  [SMALL_STATE(11173)] = 455389,
  [SMALL_STATE(11174)] = 455431,
  [SMALL_STATE(11175)] = 455473,
  [SMALL_STATE(11176)] = 455499,
  [SMALL_STATE(11177)] = 455541,
  [SMALL_STATE(11178)] = 455567,
  [SMALL_STATE(11179)] = 455593,
  [SMALL_STATE(11180)] = 455621,
  [SMALL_STATE(11181)] = 455647,
  [SMALL_STATE(11182)] = 455675,
  [SMALL_STATE(11183)] = 455703,
  [SMALL_STATE(11184)] = 455745,
  [SMALL_STATE(11185)] = 455787,
  [SMALL_STATE(11186)] = 455813,
  [SMALL_STATE(11187)] = 455855,
  [SMALL_STATE(11188)] = 455897,
  [SMALL_STATE(11189)] = 455939,
  [SMALL_STATE(11190)] = 455981,
  [SMALL_STATE(11191)] = 456021,
  [SMALL_STATE(11192)] = 456047,
  [SMALL_STATE(11193)] = 456075,
  [SMALL_STATE(11194)] = 456101,
  [SMALL_STATE(11195)] = 456127,
  [SMALL_STATE(11196)] = 456153,
  [SMALL_STATE(11197)] = 456179,
  [SMALL_STATE(11198)] = 456205,
  [SMALL_STATE(11199)] = 456231,
  [SMALL_STATE(11200)] = 456273,
  [SMALL_STATE(11201)] = 456315,
  [SMALL_STATE(11202)] = 456343,
  [SMALL_STATE(11203)] = 456385,
  [SMALL_STATE(11204)] = 456425,
  [SMALL_STATE(11205)] = 456451,
  [SMALL_STATE(11206)] = 456479,
  [SMALL_STATE(11207)] = 456509,
  [SMALL_STATE(11208)] = 456535,
  [SMALL_STATE(11209)] = 456577,
  [SMALL_STATE(11210)] = 456607,
  [SMALL_STATE(11211)] = 456633,
  [SMALL_STATE(11212)] = 456675,
  [SMALL_STATE(11213)] = 456717,
  [SMALL_STATE(11214)] = 456749,
  [SMALL_STATE(11215)] = 456775,
  [SMALL_STATE(11216)] = 456817,
  [SMALL_STATE(11217)] = 456845,
  [SMALL_STATE(11218)] = 456887,
  [SMALL_STATE(11219)] = 456929,
  [SMALL_STATE(11220)] = 456959,
  [SMALL_STATE(11221)] = 457007,
  [SMALL_STATE(11222)] = 457037,
  [SMALL_STATE(11223)] = 457069,
  [SMALL_STATE(11224)] = 457111,
  [SMALL_STATE(11225)] = 457137,
  [SMALL_STATE(11226)] = 457179,
  [SMALL_STATE(11227)] = 457221,
  [SMALL_STATE(11228)] = 457247,
  [SMALL_STATE(11229)] = 457275,
  [SMALL_STATE(11230)] = 457307,
  [SMALL_STATE(11231)] = 457337,
  [SMALL_STATE(11232)] = 457377,
  [SMALL_STATE(11233)] = 457403,
  [SMALL_STATE(11234)] = 457431,
  [SMALL_STATE(11235)] = 457479,
  [SMALL_STATE(11236)] = 457509,
  [SMALL_STATE(11237)] = 457557,
  [SMALL_STATE(11238)] = 457583,
  [SMALL_STATE(11239)] = 457609,
  [SMALL_STATE(11240)] = 457651,
  [SMALL_STATE(11241)] = 457679,
  [SMALL_STATE(11242)] = 457707,
  [SMALL_STATE(11243)] = 457737,
  [SMALL_STATE(11244)] = 457779,
  [SMALL_STATE(11245)] = 457807,
  [SMALL_STATE(11246)] = 457837,
  [SMALL_STATE(11247)] = 457865,
  [SMALL_STATE(11248)] = 457903,
  [SMALL_STATE(11249)] = 457931,
  [SMALL_STATE(11250)] = 457957,
  [SMALL_STATE(11251)] = 457999,
  [SMALL_STATE(11252)] = 458025,
  [SMALL_STATE(11253)] = 458055,
  [SMALL_STATE(11254)] = 458081,
  [SMALL_STATE(11255)] = 458109,
  [SMALL_STATE(11256)] = 458135,
  [SMALL_STATE(11257)] = 458163,
  [SMALL_STATE(11258)] = 458189,
  [SMALL_STATE(11259)] = 458219,
  [SMALL_STATE(11260)] = 458247,
  [SMALL_STATE(11261)] = 458279,
  [SMALL_STATE(11262)] = 458305,
  [SMALL_STATE(11263)] = 458331,
  [SMALL_STATE(11264)] = 458373,
  [SMALL_STATE(11265)] = 458399,
  [SMALL_STATE(11266)] = 458425,
  [SMALL_STATE(11267)] = 458467,
  [SMALL_STATE(11268)] = 458509,
  [SMALL_STATE(11269)] = 458551,
  [SMALL_STATE(11270)] = 458593,
  [SMALL_STATE(11271)] = 458635,
  [SMALL_STATE(11272)] = 458661,
  [SMALL_STATE(11273)] = 458687,
  [SMALL_STATE(11274)] = 458713,
  [SMALL_STATE(11275)] = 458741,
  [SMALL_STATE(11276)] = 458771,
  [SMALL_STATE(11277)] = 458797,
  [SMALL_STATE(11278)] = 458823,
  [SMALL_STATE(11279)] = 458849,
  [SMALL_STATE(11280)] = 458891,
  [SMALL_STATE(11281)] = 458919,
  [SMALL_STATE(11282)] = 458961,
  [SMALL_STATE(11283)] = 458987,
  [SMALL_STATE(11284)] = 459013,
  [SMALL_STATE(11285)] = 459055,
  [SMALL_STATE(11286)] = 459085,
  [SMALL_STATE(11287)] = 459111,
  [SMALL_STATE(11288)] = 459137,
  [SMALL_STATE(11289)] = 459179,
  [SMALL_STATE(11290)] = 459221,
  [SMALL_STATE(11291)] = 459247,
  [SMALL_STATE(11292)] = 459277,
  [SMALL_STATE(11293)] = 459303,
  [SMALL_STATE(11294)] = 459329,
  [SMALL_STATE(11295)] = 459355,
  [SMALL_STATE(11296)] = 459381,
  [SMALL_STATE(11297)] = 459407,
  [SMALL_STATE(11298)] = 459433,
  [SMALL_STATE(11299)] = 459461,
  [SMALL_STATE(11300)] = 459487,
  [SMALL_STATE(11301)] = 459513,
  [SMALL_STATE(11302)] = 459539,
  [SMALL_STATE(11303)] = 459565,
  [SMALL_STATE(11304)] = 459591,
  [SMALL_STATE(11305)] = 459617,
  [SMALL_STATE(11306)] = 459643,
  [SMALL_STATE(11307)] = 459669,
  [SMALL_STATE(11308)] = 459695,
  [SMALL_STATE(11309)] = 459735,
  [SMALL_STATE(11310)] = 459777,
  [SMALL_STATE(11311)] = 459803,
  [SMALL_STATE(11312)] = 459827,
  [SMALL_STATE(11313)] = 459869,
  [SMALL_STATE(11314)] = 459895,
  [SMALL_STATE(11315)] = 459937,
  [SMALL_STATE(11316)] = 459965,
  [SMALL_STATE(11317)] = 459991,
  [SMALL_STATE(11318)] = 460033,
  [SMALL_STATE(11319)] = 460059,
  [SMALL_STATE(11320)] = 460101,
  [SMALL_STATE(11321)] = 460127,
  [SMALL_STATE(11322)] = 460169,
  [SMALL_STATE(11323)] = 460197,
  [SMALL_STATE(11324)] = 460231,
  [SMALL_STATE(11325)] = 460273,
  [SMALL_STATE(11326)] = 460315,
  [SMALL_STATE(11327)] = 460357,
  [SMALL_STATE(11328)] = 460397,
  [SMALL_STATE(11329)] = 460427,
  [SMALL_STATE(11330)] = 460455,
  [SMALL_STATE(11331)] = 460481,
  [SMALL_STATE(11332)] = 460507,
  [SMALL_STATE(11333)] = 460535,
  [SMALL_STATE(11334)] = 460561,
  [SMALL_STATE(11335)] = 460591,
  [SMALL_STATE(11336)] = 460633,
  [SMALL_STATE(11337)] = 460675,
  [SMALL_STATE(11338)] = 460717,
  [SMALL_STATE(11339)] = 460759,
  [SMALL_STATE(11340)] = 460801,
  [SMALL_STATE(11341)] = 460843,
  [SMALL_STATE(11342)] = 460885,
  [SMALL_STATE(11343)] = 460911,
  [SMALL_STATE(11344)] = 460937,
  [SMALL_STATE(11345)] = 460963,
  [SMALL_STATE(11346)] = 460989,
  [SMALL_STATE(11347)] = 461017,
  [SMALL_STATE(11348)] = 461043,
  [SMALL_STATE(11349)] = 461067,
  [SMALL_STATE(11350)] = 461091,
  [SMALL_STATE(11351)] = 461133,
  [SMALL_STATE(11352)] = 461175,
  [SMALL_STATE(11353)] = 461203,
  [SMALL_STATE(11354)] = 461233,
  [SMALL_STATE(11355)] = 461267,
  [SMALL_STATE(11356)] = 461309,
  [SMALL_STATE(11357)] = 461335,
  [SMALL_STATE(11358)] = 461377,
  [SMALL_STATE(11359)] = 461403,
  [SMALL_STATE(11360)] = 461445,
  [SMALL_STATE(11361)] = 461473,
  [SMALL_STATE(11362)] = 461499,
  [SMALL_STATE(11363)] = 461525,
  [SMALL_STATE(11364)] = 461567,
  [SMALL_STATE(11365)] = 461595,
  [SMALL_STATE(11366)] = 461637,
  [SMALL_STATE(11367)] = 461679,
  [SMALL_STATE(11368)] = 461721,
  [SMALL_STATE(11369)] = 461763,
  [SMALL_STATE(11370)] = 461805,
  [SMALL_STATE(11371)] = 461831,
  [SMALL_STATE(11372)] = 461873,
  [SMALL_STATE(11373)] = 461899,
  [SMALL_STATE(11374)] = 461925,
  [SMALL_STATE(11375)] = 461953,
  [SMALL_STATE(11376)] = 461995,
  [SMALL_STATE(11377)] = 462037,
  [SMALL_STATE(11378)] = 462063,
  [SMALL_STATE(11379)] = 462089,
  [SMALL_STATE(11380)] = 462131,
  [SMALL_STATE(11381)] = 462157,
  [SMALL_STATE(11382)] = 462199,
  [SMALL_STATE(11383)] = 462241,
  [SMALL_STATE(11384)] = 462283,
  [SMALL_STATE(11385)] = 462331,
  [SMALL_STATE(11386)] = 462359,
  [SMALL_STATE(11387)] = 462401,
  [SMALL_STATE(11388)] = 462443,
  [SMALL_STATE(11389)] = 462485,
  [SMALL_STATE(11390)] = 462511,
  [SMALL_STATE(11391)] = 462539,
  [SMALL_STATE(11392)] = 462581,
  [SMALL_STATE(11393)] = 462623,
  [SMALL_STATE(11394)] = 462665,
  [SMALL_STATE(11395)] = 462707,
  [SMALL_STATE(11396)] = 462749,
  [SMALL_STATE(11397)] = 462791,
  [SMALL_STATE(11398)] = 462817,
  [SMALL_STATE(11399)] = 462859,
  [SMALL_STATE(11400)] = 462887,
  [SMALL_STATE(11401)] = 462913,
  [SMALL_STATE(11402)] = 462955,
  [SMALL_STATE(11403)] = 462997,
  [SMALL_STATE(11404)] = 463027,
  [SMALL_STATE(11405)] = 463053,
  [SMALL_STATE(11406)] = 463095,
  [SMALL_STATE(11407)] = 463121,
  [SMALL_STATE(11408)] = 463147,
  [SMALL_STATE(11409)] = 463173,
  [SMALL_STATE(11410)] = 463201,
  [SMALL_STATE(11411)] = 463227,
  [SMALL_STATE(11412)] = 463257,
  [SMALL_STATE(11413)] = 463299,
  [SMALL_STATE(11414)] = 463325,
  [SMALL_STATE(11415)] = 463351,
  [SMALL_STATE(11416)] = 463377,
  [SMALL_STATE(11417)] = 463403,
  [SMALL_STATE(11418)] = 463429,
  [SMALL_STATE(11419)] = 463457,
  [SMALL_STATE(11420)] = 463483,
  [SMALL_STATE(11421)] = 463525,
  [SMALL_STATE(11422)] = 463567,
  [SMALL_STATE(11423)] = 463593,
  [SMALL_STATE(11424)] = 463619,
  [SMALL_STATE(11425)] = 463661,
  [SMALL_STATE(11426)] = 463703,
  [SMALL_STATE(11427)] = 463731,
  [SMALL_STATE(11428)] = 463757,
  [SMALL_STATE(11429)] = 463799,
  [SMALL_STATE(11430)] = 463825,
  [SMALL_STATE(11431)] = 463867,
  [SMALL_STATE(11432)] = 463893,
  [SMALL_STATE(11433)] = 463921,
  [SMALL_STATE(11434)] = 463963,
  [SMALL_STATE(11435)] = 463989,
  [SMALL_STATE(11436)] = 464017,
  [SMALL_STATE(11437)] = 464049,
  [SMALL_STATE(11438)] = 464091,
  [SMALL_STATE(11439)] = 464133,
  [SMALL_STATE(11440)] = 464159,
  [SMALL_STATE(11441)] = 464185,
  [SMALL_STATE(11442)] = 464213,
  [SMALL_STATE(11443)] = 464255,
  [SMALL_STATE(11444)] = 464281,
  [SMALL_STATE(11445)] = 464323,
  [SMALL_STATE(11446)] = 464363,
  [SMALL_STATE(11447)] = 464389,
  [SMALL_STATE(11448)] = 464431,
  [SMALL_STATE(11449)] = 464457,
  [SMALL_STATE(11450)] = 464483,
  [SMALL_STATE(11451)] = 464509,
  [SMALL_STATE(11452)] = 464551,
  [SMALL_STATE(11453)] = 464577,
  [SMALL_STATE(11454)] = 464619,
  [SMALL_STATE(11455)] = 464661,
  [SMALL_STATE(11456)] = 464689,
  [SMALL_STATE(11457)] = 464715,
  [SMALL_STATE(11458)] = 464741,
  [SMALL_STATE(11459)] = 464783,
  [SMALL_STATE(11460)] = 464809,
  [SMALL_STATE(11461)] = 464851,
  [SMALL_STATE(11462)] = 464893,
  [SMALL_STATE(11463)] = 464919,
  [SMALL_STATE(11464)] = 464945,
  [SMALL_STATE(11465)] = 464975,
  [SMALL_STATE(11466)] = 465003,
  [SMALL_STATE(11467)] = 465045,
  [SMALL_STATE(11468)] = 465087,
  [SMALL_STATE(11469)] = 465129,
  [SMALL_STATE(11470)] = 465157,
  [SMALL_STATE(11471)] = 465199,
  [SMALL_STATE(11472)] = 465241,
  [SMALL_STATE(11473)] = 465269,
  [SMALL_STATE(11474)] = 465311,
  [SMALL_STATE(11475)] = 465339,
  [SMALL_STATE(11476)] = 465381,
  [SMALL_STATE(11477)] = 465423,
  [SMALL_STATE(11478)] = 465465,
  [SMALL_STATE(11479)] = 465507,
  [SMALL_STATE(11480)] = 465549,
  [SMALL_STATE(11481)] = 465581,
  [SMALL_STATE(11482)] = 465623,
  [SMALL_STATE(11483)] = 465651,
  [SMALL_STATE(11484)] = 465677,
  [SMALL_STATE(11485)] = 465719,
  [SMALL_STATE(11486)] = 465745,
  [SMALL_STATE(11487)] = 465773,
  [SMALL_STATE(11488)] = 465799,
  [SMALL_STATE(11489)] = 465825,
  [SMALL_STATE(11490)] = 465851,
  [SMALL_STATE(11491)] = 465881,
  [SMALL_STATE(11492)] = 465923,
  [SMALL_STATE(11493)] = 465955,
  [SMALL_STATE(11494)] = 465981,
  [SMALL_STATE(11495)] = 466007,
  [SMALL_STATE(11496)] = 466039,
  [SMALL_STATE(11497)] = 466081,
  [SMALL_STATE(11498)] = 466123,
  [SMALL_STATE(11499)] = 466165,
  [SMALL_STATE(11500)] = 466207,
  [SMALL_STATE(11501)] = 466233,
  [SMALL_STATE(11502)] = 466275,
  [SMALL_STATE(11503)] = 466301,
  [SMALL_STATE(11504)] = 466343,
  [SMALL_STATE(11505)] = 466371,
  [SMALL_STATE(11506)] = 466397,
  [SMALL_STATE(11507)] = 466439,
  [SMALL_STATE(11508)] = 466481,
  [SMALL_STATE(11509)] = 466523,
  [SMALL_STATE(11510)] = 466565,
  [SMALL_STATE(11511)] = 466607,
  [SMALL_STATE(11512)] = 466649,
  [SMALL_STATE(11513)] = 466691,
  [SMALL_STATE(11514)] = 466721,
  [SMALL_STATE(11515)] = 466753,
  [SMALL_STATE(11516)] = 466795,
  [SMALL_STATE(11517)] = 466825,
  [SMALL_STATE(11518)] = 466867,
  [SMALL_STATE(11519)] = 466893,
  [SMALL_STATE(11520)] = 466923,
  [SMALL_STATE(11521)] = 466965,
  [SMALL_STATE(11522)] = 467013,
  [SMALL_STATE(11523)] = 467043,
  [SMALL_STATE(11524)] = 467085,
  [SMALL_STATE(11525)] = 467127,
  [SMALL_STATE(11526)] = 467169,
  [SMALL_STATE(11527)] = 467209,
  [SMALL_STATE(11528)] = 467251,
  [SMALL_STATE(11529)] = 467276,
  [SMALL_STATE(11530)] = 467301,
  [SMALL_STATE(11531)] = 467328,
  [SMALL_STATE(11532)] = 467353,
  [SMALL_STATE(11533)] = 467378,
  [SMALL_STATE(11534)] = 467403,
  [SMALL_STATE(11535)] = 467428,
  [SMALL_STATE(11536)] = 467455,
  [SMALL_STATE(11537)] = 467480,
  [SMALL_STATE(11538)] = 467511,
  [SMALL_STATE(11539)] = 467536,
  [SMALL_STATE(11540)] = 467561,
  [SMALL_STATE(11541)] = 467586,
  [SMALL_STATE(11542)] = 467611,
  [SMALL_STATE(11543)] = 467636,
  [SMALL_STATE(11544)] = 467663,
  [SMALL_STATE(11545)] = 467688,
  [SMALL_STATE(11546)] = 467713,
  [SMALL_STATE(11547)] = 467738,
  [SMALL_STATE(11548)] = 467767,
  [SMALL_STATE(11549)] = 467794,
  [SMALL_STATE(11550)] = 467821,
  [SMALL_STATE(11551)] = 467846,
  [SMALL_STATE(11552)] = 467871,
  [SMALL_STATE(11553)] = 467896,
  [SMALL_STATE(11554)] = 467921,
  [SMALL_STATE(11555)] = 467948,
  [SMALL_STATE(11556)] = 467973,
  [SMALL_STATE(11557)] = 467998,
  [SMALL_STATE(11558)] = 468027,
  [SMALL_STATE(11559)] = 468052,
  [SMALL_STATE(11560)] = 468077,
  [SMALL_STATE(11561)] = 468102,
  [SMALL_STATE(11562)] = 468127,
  [SMALL_STATE(11563)] = 468152,
  [SMALL_STATE(11564)] = 468177,
  [SMALL_STATE(11565)] = 468204,
  [SMALL_STATE(11566)] = 468233,
  [SMALL_STATE(11567)] = 468258,
  [SMALL_STATE(11568)] = 468287,
  [SMALL_STATE(11569)] = 468312,
  [SMALL_STATE(11570)] = 468341,
  [SMALL_STATE(11571)] = 468366,
  [SMALL_STATE(11572)] = 468391,
  [SMALL_STATE(11573)] = 468420,
  [SMALL_STATE(11574)] = 468447,
  [SMALL_STATE(11575)] = 468474,
  [SMALL_STATE(11576)] = 468499,
  [SMALL_STATE(11577)] = 468524,
  [SMALL_STATE(11578)] = 468549,
  [SMALL_STATE(11579)] = 468576,
  [SMALL_STATE(11580)] = 468601,
  [SMALL_STATE(11581)] = 468626,
  [SMALL_STATE(11582)] = 468655,
  [SMALL_STATE(11583)] = 468680,
  [SMALL_STATE(11584)] = 468705,
  [SMALL_STATE(11585)] = 468730,
  [SMALL_STATE(11586)] = 468755,
  [SMALL_STATE(11587)] = 468780,
  [SMALL_STATE(11588)] = 468805,
  [SMALL_STATE(11589)] = 468830,
  [SMALL_STATE(11590)] = 468855,
  [SMALL_STATE(11591)] = 468880,
  [SMALL_STATE(11592)] = 468905,
  [SMALL_STATE(11593)] = 468930,
  [SMALL_STATE(11594)] = 468955,
  [SMALL_STATE(11595)] = 468980,
  [SMALL_STATE(11596)] = 469005,
  [SMALL_STATE(11597)] = 469042,
  [SMALL_STATE(11598)] = 469067,
  [SMALL_STATE(11599)] = 469092,
  [SMALL_STATE(11600)] = 469121,
  [SMALL_STATE(11601)] = 469146,
  [SMALL_STATE(11602)] = 469171,
  [SMALL_STATE(11603)] = 469196,
  [SMALL_STATE(11604)] = 469221,
  [SMALL_STATE(11605)] = 469246,
  [SMALL_STATE(11606)] = 469271,
  [SMALL_STATE(11607)] = 469296,
  [SMALL_STATE(11608)] = 469321,
  [SMALL_STATE(11609)] = 469350,
  [SMALL_STATE(11610)] = 469375,
  [SMALL_STATE(11611)] = 469400,
  [SMALL_STATE(11612)] = 469427,
  [SMALL_STATE(11613)] = 469452,
  [SMALL_STATE(11614)] = 469477,
  [SMALL_STATE(11615)] = 469502,
  [SMALL_STATE(11616)] = 469527,
  [SMALL_STATE(11617)] = 469554,
  [SMALL_STATE(11618)] = 469581,
  [SMALL_STATE(11619)] = 469606,
  [SMALL_STATE(11620)] = 469635,
  [SMALL_STATE(11621)] = 469660,
  [SMALL_STATE(11622)] = 469685,
  [SMALL_STATE(11623)] = 469710,
  [SMALL_STATE(11624)] = 469735,
  [SMALL_STATE(11625)] = 469764,
  [SMALL_STATE(11626)] = 469791,
  [SMALL_STATE(11627)] = 469816,
  [SMALL_STATE(11628)] = 469841,
  [SMALL_STATE(11629)] = 469866,
  [SMALL_STATE(11630)] = 469891,
  [SMALL_STATE(11631)] = 469916,
  [SMALL_STATE(11632)] = 469941,
  [SMALL_STATE(11633)] = 469966,
  [SMALL_STATE(11634)] = 469991,
  [SMALL_STATE(11635)] = 470016,
  [SMALL_STATE(11636)] = 470041,
  [SMALL_STATE(11637)] = 470066,
  [SMALL_STATE(11638)] = 470091,
  [SMALL_STATE(11639)] = 470116,
  [SMALL_STATE(11640)] = 470141,
  [SMALL_STATE(11641)] = 470166,
  [SMALL_STATE(11642)] = 470191,
  [SMALL_STATE(11643)] = 470216,
  [SMALL_STATE(11644)] = 470241,
  [SMALL_STATE(11645)] = 470266,
  [SMALL_STATE(11646)] = 470291,
  [SMALL_STATE(11647)] = 470316,
  [SMALL_STATE(11648)] = 470341,
  [SMALL_STATE(11649)] = 470368,
  [SMALL_STATE(11650)] = 470393,
  [SMALL_STATE(11651)] = 470418,
  [SMALL_STATE(11652)] = 470443,
  [SMALL_STATE(11653)] = 470468,
  [SMALL_STATE(11654)] = 470493,
  [SMALL_STATE(11655)] = 470518,
  [SMALL_STATE(11656)] = 470543,
  [SMALL_STATE(11657)] = 470572,
  [SMALL_STATE(11658)] = 470597,
  [SMALL_STATE(11659)] = 470622,
  [SMALL_STATE(11660)] = 470647,
  [SMALL_STATE(11661)] = 470672,
  [SMALL_STATE(11662)] = 470697,
  [SMALL_STATE(11663)] = 470722,
  [SMALL_STATE(11664)] = 470747,
  [SMALL_STATE(11665)] = 470772,
  [SMALL_STATE(11666)] = 470797,
  [SMALL_STATE(11667)] = 470826,
  [SMALL_STATE(11668)] = 470855,
  [SMALL_STATE(11669)] = 470880,
  [SMALL_STATE(11670)] = 470905,
  [SMALL_STATE(11671)] = 470930,
  [SMALL_STATE(11672)] = 470959,
  [SMALL_STATE(11673)] = 470984,
  [SMALL_STATE(11674)] = 471009,
  [SMALL_STATE(11675)] = 471034,
  [SMALL_STATE(11676)] = 471059,
  [SMALL_STATE(11677)] = 471084,
  [SMALL_STATE(11678)] = 471109,
  [SMALL_STATE(11679)] = 471134,
  [SMALL_STATE(11680)] = 471159,
  [SMALL_STATE(11681)] = 471184,
  [SMALL_STATE(11682)] = 471209,
  [SMALL_STATE(11683)] = 471234,
  [SMALL_STATE(11684)] = 471263,
  [SMALL_STATE(11685)] = 471288,
  [SMALL_STATE(11686)] = 471317,
  [SMALL_STATE(11687)] = 471342,
  [SMALL_STATE(11688)] = 471367,
  [SMALL_STATE(11689)] = 471392,
  [SMALL_STATE(11690)] = 471421,
  [SMALL_STATE(11691)] = 471446,
  [SMALL_STATE(11692)] = 471471,
  [SMALL_STATE(11693)] = 471496,
  [SMALL_STATE(11694)] = 471521,
  [SMALL_STATE(11695)] = 471546,
  [SMALL_STATE(11696)] = 471571,
  [SMALL_STATE(11697)] = 471596,
  [SMALL_STATE(11698)] = 471621,
  [SMALL_STATE(11699)] = 471646,
  [SMALL_STATE(11700)] = 471671,
  [SMALL_STATE(11701)] = 471698,
  [SMALL_STATE(11702)] = 471723,
  [SMALL_STATE(11703)] = 471748,
  [SMALL_STATE(11704)] = 471773,
  [SMALL_STATE(11705)] = 471798,
  [SMALL_STATE(11706)] = 471823,
  [SMALL_STATE(11707)] = 471848,
  [SMALL_STATE(11708)] = 471873,
  [SMALL_STATE(11709)] = 471898,
  [SMALL_STATE(11710)] = 471923,
  [SMALL_STATE(11711)] = 471948,
  [SMALL_STATE(11712)] = 471973,
  [SMALL_STATE(11713)] = 472000,
  [SMALL_STATE(11714)] = 472025,
  [SMALL_STATE(11715)] = 472050,
  [SMALL_STATE(11716)] = 472077,
  [SMALL_STATE(11717)] = 472102,
  [SMALL_STATE(11718)] = 472127,
  [SMALL_STATE(11719)] = 472152,
  [SMALL_STATE(11720)] = 472177,
  [SMALL_STATE(11721)] = 472204,
  [SMALL_STATE(11722)] = 472229,
  [SMALL_STATE(11723)] = 472258,
  [SMALL_STATE(11724)] = 472283,
  [SMALL_STATE(11725)] = 472308,
  [SMALL_STATE(11726)] = 472333,
  [SMALL_STATE(11727)] = 472358,
  [SMALL_STATE(11728)] = 472387,
  [SMALL_STATE(11729)] = 472414,
  [SMALL_STATE(11730)] = 472439,
  [SMALL_STATE(11731)] = 472468,
  [SMALL_STATE(11732)] = 472493,
  [SMALL_STATE(11733)] = 472518,
  [SMALL_STATE(11734)] = 472543,
  [SMALL_STATE(11735)] = 472568,
  [SMALL_STATE(11736)] = 472593,
  [SMALL_STATE(11737)] = 472620,
  [SMALL_STATE(11738)] = 472645,
  [SMALL_STATE(11739)] = 472670,
  [SMALL_STATE(11740)] = 472695,
  [SMALL_STATE(11741)] = 472720,
  [SMALL_STATE(11742)] = 472745,
  [SMALL_STATE(11743)] = 472776,
  [SMALL_STATE(11744)] = 472801,
  [SMALL_STATE(11745)] = 472826,
  [SMALL_STATE(11746)] = 472851,
  [SMALL_STATE(11747)] = 472876,
  [SMALL_STATE(11748)] = 472901,
  [SMALL_STATE(11749)] = 472926,
  [SMALL_STATE(11750)] = 472951,
  [SMALL_STATE(11751)] = 472976,
  [SMALL_STATE(11752)] = 473001,
  [SMALL_STATE(11753)] = 473026,
  [SMALL_STATE(11754)] = 473053,
  [SMALL_STATE(11755)] = 473078,
  [SMALL_STATE(11756)] = 473105,
  [SMALL_STATE(11757)] = 473130,
  [SMALL_STATE(11758)] = 473159,
  [SMALL_STATE(11759)] = 473184,
  [SMALL_STATE(11760)] = 473209,
  [SMALL_STATE(11761)] = 473234,
  [SMALL_STATE(11762)] = 473259,
  [SMALL_STATE(11763)] = 473286,
  [SMALL_STATE(11764)] = 473311,
  [SMALL_STATE(11765)] = 473336,
  [SMALL_STATE(11766)] = 473361,
  [SMALL_STATE(11767)] = 473388,
  [SMALL_STATE(11768)] = 473413,
  [SMALL_STATE(11769)] = 473458,
  [SMALL_STATE(11770)] = 473485,
  [SMALL_STATE(11771)] = 473510,
  [SMALL_STATE(11772)] = 473535,
  [SMALL_STATE(11773)] = 473566,
  [SMALL_STATE(11774)] = 473591,
  [SMALL_STATE(11775)] = 473616,
  [SMALL_STATE(11776)] = 473641,
  [SMALL_STATE(11777)] = 473668,
  [SMALL_STATE(11778)] = 473693,
  [SMALL_STATE(11779)] = 473718,
  [SMALL_STATE(11780)] = 473743,
  [SMALL_STATE(11781)] = 473768,
  [SMALL_STATE(11782)] = 473793,
  [SMALL_STATE(11783)] = 473818,
  [SMALL_STATE(11784)] = 473843,
  [SMALL_STATE(11785)] = 473870,
  [SMALL_STATE(11786)] = 473895,
  [SMALL_STATE(11787)] = 473924,
  [SMALL_STATE(11788)] = 473949,
  [SMALL_STATE(11789)] = 473978,
  [SMALL_STATE(11790)] = 474003,
  [SMALL_STATE(11791)] = 474028,
  [SMALL_STATE(11792)] = 474053,
  [SMALL_STATE(11793)] = 474078,
  [SMALL_STATE(11794)] = 474103,
  [SMALL_STATE(11795)] = 474128,
  [SMALL_STATE(11796)] = 474153,
  [SMALL_STATE(11797)] = 474178,
  [SMALL_STATE(11798)] = 474203,
  [SMALL_STATE(11799)] = 474228,
  [SMALL_STATE(11800)] = 474253,
  [SMALL_STATE(11801)] = 474278,
  [SMALL_STATE(11802)] = 474303,
  [SMALL_STATE(11803)] = 474328,
  [SMALL_STATE(11804)] = 474355,
  [SMALL_STATE(11805)] = 474394,
  [SMALL_STATE(11806)] = 474419,
  [SMALL_STATE(11807)] = 474444,
  [SMALL_STATE(11808)] = 474473,
  [SMALL_STATE(11809)] = 474498,
  [SMALL_STATE(11810)] = 474523,
  [SMALL_STATE(11811)] = 474548,
  [SMALL_STATE(11812)] = 474573,
  [SMALL_STATE(11813)] = 474598,
  [SMALL_STATE(11814)] = 474623,
  [SMALL_STATE(11815)] = 474648,
  [SMALL_STATE(11816)] = 474673,
  [SMALL_STATE(11817)] = 474698,
  [SMALL_STATE(11818)] = 474723,
  [SMALL_STATE(11819)] = 474748,
  [SMALL_STATE(11820)] = 474773,
  [SMALL_STATE(11821)] = 474798,
  [SMALL_STATE(11822)] = 474823,
  [SMALL_STATE(11823)] = 474848,
  [SMALL_STATE(11824)] = 474873,
  [SMALL_STATE(11825)] = 474898,
  [SMALL_STATE(11826)] = 474923,
  [SMALL_STATE(11827)] = 474950,
  [SMALL_STATE(11828)] = 474975,
  [SMALL_STATE(11829)] = 475000,
  [SMALL_STATE(11830)] = 475025,
  [SMALL_STATE(11831)] = 475050,
  [SMALL_STATE(11832)] = 475075,
  [SMALL_STATE(11833)] = 475100,
  [SMALL_STATE(11834)] = 475131,
  [SMALL_STATE(11835)] = 475156,
  [SMALL_STATE(11836)] = 475181,
  [SMALL_STATE(11837)] = 475206,
  [SMALL_STATE(11838)] = 475231,
  [SMALL_STATE(11839)] = 475256,
  [SMALL_STATE(11840)] = 475281,
  [SMALL_STATE(11841)] = 475306,
  [SMALL_STATE(11842)] = 475331,
  [SMALL_STATE(11843)] = 475356,
  [SMALL_STATE(11844)] = 475381,
  [SMALL_STATE(11845)] = 475406,
  [SMALL_STATE(11846)] = 475433,
  [SMALL_STATE(11847)] = 475458,
  [SMALL_STATE(11848)] = 475483,
  [SMALL_STATE(11849)] = 475508,
  [SMALL_STATE(11850)] = 475533,
  [SMALL_STATE(11851)] = 475560,
  [SMALL_STATE(11852)] = 475585,
  [SMALL_STATE(11853)] = 475610,
  [SMALL_STATE(11854)] = 475635,
  [SMALL_STATE(11855)] = 475662,
  [SMALL_STATE(11856)] = 475687,
  [SMALL_STATE(11857)] = 475712,
  [SMALL_STATE(11858)] = 475737,
  [SMALL_STATE(11859)] = 475762,
  [SMALL_STATE(11860)] = 475787,
  [SMALL_STATE(11861)] = 475812,
  [SMALL_STATE(11862)] = 475837,
  [SMALL_STATE(11863)] = 475862,
  [SMALL_STATE(11864)] = 475887,
  [SMALL_STATE(11865)] = 475912,
  [SMALL_STATE(11866)] = 475937,
  [SMALL_STATE(11867)] = 475966,
  [SMALL_STATE(11868)] = 475991,
  [SMALL_STATE(11869)] = 476016,
  [SMALL_STATE(11870)] = 476041,
  [SMALL_STATE(11871)] = 476066,
  [SMALL_STATE(11872)] = 476091,
  [SMALL_STATE(11873)] = 476116,
  [SMALL_STATE(11874)] = 476141,
  [SMALL_STATE(11875)] = 476166,
  [SMALL_STATE(11876)] = 476191,
  [SMALL_STATE(11877)] = 476220,
  [SMALL_STATE(11878)] = 476249,
  [SMALL_STATE(11879)] = 476274,
  [SMALL_STATE(11880)] = 476301,
  [SMALL_STATE(11881)] = 476326,
  [SMALL_STATE(11882)] = 476351,
  [SMALL_STATE(11883)] = 476390,
  [SMALL_STATE(11884)] = 476415,
  [SMALL_STATE(11885)] = 476440,
  [SMALL_STATE(11886)] = 476465,
  [SMALL_STATE(11887)] = 476490,
  [SMALL_STATE(11888)] = 476515,
  [SMALL_STATE(11889)] = 476540,
  [SMALL_STATE(11890)] = 476565,
  [SMALL_STATE(11891)] = 476590,
  [SMALL_STATE(11892)] = 476615,
  [SMALL_STATE(11893)] = 476640,
  [SMALL_STATE(11894)] = 476665,
  [SMALL_STATE(11895)] = 476690,
  [SMALL_STATE(11896)] = 476715,
  [SMALL_STATE(11897)] = 476740,
  [SMALL_STATE(11898)] = 476765,
  [SMALL_STATE(11899)] = 476804,
  [SMALL_STATE(11900)] = 476829,
  [SMALL_STATE(11901)] = 476854,
  [SMALL_STATE(11902)] = 476879,
  [SMALL_STATE(11903)] = 476904,
  [SMALL_STATE(11904)] = 476929,
  [SMALL_STATE(11905)] = 476954,
  [SMALL_STATE(11906)] = 476979,
  [SMALL_STATE(11907)] = 477004,
  [SMALL_STATE(11908)] = 477029,
  [SMALL_STATE(11909)] = 477054,
  [SMALL_STATE(11910)] = 477079,
  [SMALL_STATE(11911)] = 477110,
  [SMALL_STATE(11912)] = 477135,
  [SMALL_STATE(11913)] = 477160,
  [SMALL_STATE(11914)] = 477185,
  [SMALL_STATE(11915)] = 477210,
  [SMALL_STATE(11916)] = 477235,
  [SMALL_STATE(11917)] = 477260,
  [SMALL_STATE(11918)] = 477285,
  [SMALL_STATE(11919)] = 477324,
  [SMALL_STATE(11920)] = 477349,
  [SMALL_STATE(11921)] = 477374,
  [SMALL_STATE(11922)] = 477403,
  [SMALL_STATE(11923)] = 477430,
  [SMALL_STATE(11924)] = 477461,
  [SMALL_STATE(11925)] = 477486,
  [SMALL_STATE(11926)] = 477511,
  [SMALL_STATE(11927)] = 477536,
  [SMALL_STATE(11928)] = 477561,
  [SMALL_STATE(11929)] = 477586,
  [SMALL_STATE(11930)] = 477611,
  [SMALL_STATE(11931)] = 477638,
  [SMALL_STATE(11932)] = 477663,
  [SMALL_STATE(11933)] = 477688,
  [SMALL_STATE(11934)] = 477713,
  [SMALL_STATE(11935)] = 477738,
  [SMALL_STATE(11936)] = 477763,
  [SMALL_STATE(11937)] = 477788,
  [SMALL_STATE(11938)] = 477813,
  [SMALL_STATE(11939)] = 477838,
  [SMALL_STATE(11940)] = 477863,
  [SMALL_STATE(11941)] = 477888,
  [SMALL_STATE(11942)] = 477913,
  [SMALL_STATE(11943)] = 477938,
  [SMALL_STATE(11944)] = 477963,
  [SMALL_STATE(11945)] = 477988,
  [SMALL_STATE(11946)] = 478013,
  [SMALL_STATE(11947)] = 478038,
  [SMALL_STATE(11948)] = 478063,
  [SMALL_STATE(11949)] = 478088,
  [SMALL_STATE(11950)] = 478113,
  [SMALL_STATE(11951)] = 478142,
  [SMALL_STATE(11952)] = 478171,
  [SMALL_STATE(11953)] = 478196,
  [SMALL_STATE(11954)] = 478221,
  [SMALL_STATE(11955)] = 478258,
  [SMALL_STATE(11956)] = 478287,
  [SMALL_STATE(11957)] = 478312,
  [SMALL_STATE(11958)] = 478337,
  [SMALL_STATE(11959)] = 478362,
  [SMALL_STATE(11960)] = 478389,
  [SMALL_STATE(11961)] = 478414,
  [SMALL_STATE(11962)] = 478439,
  [SMALL_STATE(11963)] = 478464,
  [SMALL_STATE(11964)] = 478493,
  [SMALL_STATE(11965)] = 478518,
  [SMALL_STATE(11966)] = 478543,
  [SMALL_STATE(11967)] = 478568,
  [SMALL_STATE(11968)] = 478593,
  [SMALL_STATE(11969)] = 478618,
  [SMALL_STATE(11970)] = 478643,
  [SMALL_STATE(11971)] = 478672,
  [SMALL_STATE(11972)] = 478697,
  [SMALL_STATE(11973)] = 478724,
  [SMALL_STATE(11974)] = 478749,
  [SMALL_STATE(11975)] = 478774,
  [SMALL_STATE(11976)] = 478805,
  [SMALL_STATE(11977)] = 478832,
  [SMALL_STATE(11978)] = 478857,
  [SMALL_STATE(11979)] = 478884,
  [SMALL_STATE(11980)] = 478913,
  [SMALL_STATE(11981)] = 478940,
  [SMALL_STATE(11982)] = 478969,
  [SMALL_STATE(11983)] = 478994,
  [SMALL_STATE(11984)] = 479021,
  [SMALL_STATE(11985)] = 479046,
  [SMALL_STATE(11986)] = 479073,
  [SMALL_STATE(11987)] = 479098,
  [SMALL_STATE(11988)] = 479123,
  [SMALL_STATE(11989)] = 479148,
  [SMALL_STATE(11990)] = 479173,
  [SMALL_STATE(11991)] = 479202,
  [SMALL_STATE(11992)] = 479227,
  [SMALL_STATE(11993)] = 479262,
  [SMALL_STATE(11994)] = 479293,
  [SMALL_STATE(11995)] = 479318,
  [SMALL_STATE(11996)] = 479347,
  [SMALL_STATE(11997)] = 479372,
  [SMALL_STATE(11998)] = 479397,
  [SMALL_STATE(11999)] = 479422,
  [SMALL_STATE(12000)] = 479447,
  [SMALL_STATE(12001)] = 479472,
  [SMALL_STATE(12002)] = 479497,
  [SMALL_STATE(12003)] = 479522,
  [SMALL_STATE(12004)] = 479547,
  [SMALL_STATE(12005)] = 479572,
  [SMALL_STATE(12006)] = 479597,
  [SMALL_STATE(12007)] = 479622,
  [SMALL_STATE(12008)] = 479647,
  [SMALL_STATE(12009)] = 479672,
  [SMALL_STATE(12010)] = 479697,
  [SMALL_STATE(12011)] = 479724,
  [SMALL_STATE(12012)] = 479749,
  [SMALL_STATE(12013)] = 479774,
  [SMALL_STATE(12014)] = 479799,
  [SMALL_STATE(12015)] = 479824,
  [SMALL_STATE(12016)] = 479849,
  [SMALL_STATE(12017)] = 479874,
  [SMALL_STATE(12018)] = 479903,
  [SMALL_STATE(12019)] = 479932,
  [SMALL_STATE(12020)] = 479957,
  [SMALL_STATE(12021)] = 479982,
  [SMALL_STATE(12022)] = 480007,
  [SMALL_STATE(12023)] = 480032,
  [SMALL_STATE(12024)] = 480057,
  [SMALL_STATE(12025)] = 480082,
  [SMALL_STATE(12026)] = 480107,
  [SMALL_STATE(12027)] = 480132,
  [SMALL_STATE(12028)] = 480157,
  [SMALL_STATE(12029)] = 480182,
  [SMALL_STATE(12030)] = 480207,
  [SMALL_STATE(12031)] = 480232,
  [SMALL_STATE(12032)] = 480257,
  [SMALL_STATE(12033)] = 480282,
  [SMALL_STATE(12034)] = 480307,
  [SMALL_STATE(12035)] = 480332,
  [SMALL_STATE(12036)] = 480357,
  [SMALL_STATE(12037)] = 480382,
  [SMALL_STATE(12038)] = 480407,
  [SMALL_STATE(12039)] = 480432,
  [SMALL_STATE(12040)] = 480457,
  [SMALL_STATE(12041)] = 480482,
  [SMALL_STATE(12042)] = 480507,
  [SMALL_STATE(12043)] = 480532,
  [SMALL_STATE(12044)] = 480557,
  [SMALL_STATE(12045)] = 480582,
  [SMALL_STATE(12046)] = 480607,
  [SMALL_STATE(12047)] = 480632,
  [SMALL_STATE(12048)] = 480657,
  [SMALL_STATE(12049)] = 480682,
  [SMALL_STATE(12050)] = 480707,
  [SMALL_STATE(12051)] = 480732,
  [SMALL_STATE(12052)] = 480757,
  [SMALL_STATE(12053)] = 480782,
  [SMALL_STATE(12054)] = 480811,
  [SMALL_STATE(12055)] = 480836,
  [SMALL_STATE(12056)] = 480861,
  [SMALL_STATE(12057)] = 480886,
  [SMALL_STATE(12058)] = 480911,
  [SMALL_STATE(12059)] = 480936,
  [SMALL_STATE(12060)] = 480961,
  [SMALL_STATE(12061)] = 480986,
  [SMALL_STATE(12062)] = 481011,
  [SMALL_STATE(12063)] = 481036,
  [SMALL_STATE(12064)] = 481061,
  [SMALL_STATE(12065)] = 481086,
  [SMALL_STATE(12066)] = 481111,
  [SMALL_STATE(12067)] = 481136,
  [SMALL_STATE(12068)] = 481161,
  [SMALL_STATE(12069)] = 481186,
  [SMALL_STATE(12070)] = 481211,
  [SMALL_STATE(12071)] = 481236,
  [SMALL_STATE(12072)] = 481261,
  [SMALL_STATE(12073)] = 481286,
  [SMALL_STATE(12074)] = 481313,
  [SMALL_STATE(12075)] = 481338,
  [SMALL_STATE(12076)] = 481363,
  [SMALL_STATE(12077)] = 481388,
  [SMALL_STATE(12078)] = 481417,
  [SMALL_STATE(12079)] = 481442,
  [SMALL_STATE(12080)] = 481467,
  [SMALL_STATE(12081)] = 481492,
  [SMALL_STATE(12082)] = 481521,
  [SMALL_STATE(12083)] = 481546,
  [SMALL_STATE(12084)] = 481571,
  [SMALL_STATE(12085)] = 481596,
  [SMALL_STATE(12086)] = 481621,
  [SMALL_STATE(12087)] = 481646,
  [SMALL_STATE(12088)] = 481671,
  [SMALL_STATE(12089)] = 481696,
  [SMALL_STATE(12090)] = 481721,
  [SMALL_STATE(12091)] = 481746,
  [SMALL_STATE(12092)] = 481771,
  [SMALL_STATE(12093)] = 481796,
  [SMALL_STATE(12094)] = 481821,
  [SMALL_STATE(12095)] = 481846,
  [SMALL_STATE(12096)] = 481871,
  [SMALL_STATE(12097)] = 481896,
  [SMALL_STATE(12098)] = 481921,
  [SMALL_STATE(12099)] = 481946,
  [SMALL_STATE(12100)] = 481975,
  [SMALL_STATE(12101)] = 482000,
  [SMALL_STATE(12102)] = 482025,
  [SMALL_STATE(12103)] = 482050,
  [SMALL_STATE(12104)] = 482079,
  [SMALL_STATE(12105)] = 482104,
  [SMALL_STATE(12106)] = 482129,
  [SMALL_STATE(12107)] = 482154,
  [SMALL_STATE(12108)] = 482185,
  [SMALL_STATE(12109)] = 482210,
  [SMALL_STATE(12110)] = 482237,
  [SMALL_STATE(12111)] = 482262,
  [SMALL_STATE(12112)] = 482287,
  [SMALL_STATE(12113)] = 482312,
  [SMALL_STATE(12114)] = 482337,
  [SMALL_STATE(12115)] = 482362,
  [SMALL_STATE(12116)] = 482387,
  [SMALL_STATE(12117)] = 482412,
  [SMALL_STATE(12118)] = 482441,
  [SMALL_STATE(12119)] = 482466,
  [SMALL_STATE(12120)] = 482490,
  [SMALL_STATE(12121)] = 482514,
  [SMALL_STATE(12122)] = 482538,
  [SMALL_STATE(12123)] = 482562,
  [SMALL_STATE(12124)] = 482586,
  [SMALL_STATE(12125)] = 482612,
  [SMALL_STATE(12126)] = 482636,
  [SMALL_STATE(12127)] = 482660,
  [SMALL_STATE(12128)] = 482684,
  [SMALL_STATE(12129)] = 482708,
  [SMALL_STATE(12130)] = 482730,
  [SMALL_STATE(12131)] = 482754,
  [SMALL_STATE(12132)] = 482778,
  [SMALL_STATE(12133)] = 482802,
  [SMALL_STATE(12134)] = 482826,
  [SMALL_STATE(12135)] = 482850,
  [SMALL_STATE(12136)] = 482874,
  [SMALL_STATE(12137)] = 482898,
  [SMALL_STATE(12138)] = 482922,
  [SMALL_STATE(12139)] = 482948,
  [SMALL_STATE(12140)] = 482972,
  [SMALL_STATE(12141)] = 482996,
  [SMALL_STATE(12142)] = 483020,
  [SMALL_STATE(12143)] = 483044,
  [SMALL_STATE(12144)] = 483068,
  [SMALL_STATE(12145)] = 483092,
  [SMALL_STATE(12146)] = 483116,
  [SMALL_STATE(12147)] = 483140,
  [SMALL_STATE(12148)] = 483164,
  [SMALL_STATE(12149)] = 483188,
  [SMALL_STATE(12150)] = 483216,
  [SMALL_STATE(12151)] = 483240,
  [SMALL_STATE(12152)] = 483264,
  [SMALL_STATE(12153)] = 483288,
  [SMALL_STATE(12154)] = 483312,
  [SMALL_STATE(12155)] = 483336,
  [SMALL_STATE(12156)] = 483360,
  [SMALL_STATE(12157)] = 483386,
  [SMALL_STATE(12158)] = 483410,
  [SMALL_STATE(12159)] = 483434,
  [SMALL_STATE(12160)] = 483458,
  [SMALL_STATE(12161)] = 483482,
  [SMALL_STATE(12162)] = 483506,
  [SMALL_STATE(12163)] = 483530,
  [SMALL_STATE(12164)] = 483556,
  [SMALL_STATE(12165)] = 483584,
  [SMALL_STATE(12166)] = 483608,
  [SMALL_STATE(12167)] = 483636,
  [SMALL_STATE(12168)] = 483662,
  [SMALL_STATE(12169)] = 483686,
  [SMALL_STATE(12170)] = 483710,
  [SMALL_STATE(12171)] = 483734,
  [SMALL_STATE(12172)] = 483758,
  [SMALL_STATE(12173)] = 483782,
  [SMALL_STATE(12174)] = 483808,
  [SMALL_STATE(12175)] = 483832,
  [SMALL_STATE(12176)] = 483856,
  [SMALL_STATE(12177)] = 483882,
  [SMALL_STATE(12178)] = 483906,
  [SMALL_STATE(12179)] = 483930,
  [SMALL_STATE(12180)] = 483954,
  [SMALL_STATE(12181)] = 483978,
  [SMALL_STATE(12182)] = 484006,
  [SMALL_STATE(12183)] = 484030,
  [SMALL_STATE(12184)] = 484054,
  [SMALL_STATE(12185)] = 484078,
  [SMALL_STATE(12186)] = 484102,
  [SMALL_STATE(12187)] = 484126,
  [SMALL_STATE(12188)] = 484150,
  [SMALL_STATE(12189)] = 484174,
  [SMALL_STATE(12190)] = 484198,
  [SMALL_STATE(12191)] = 484222,
  [SMALL_STATE(12192)] = 484246,
  [SMALL_STATE(12193)] = 484270,
  [SMALL_STATE(12194)] = 484294,
  [SMALL_STATE(12195)] = 484318,
  [SMALL_STATE(12196)] = 484342,
  [SMALL_STATE(12197)] = 484366,
  [SMALL_STATE(12198)] = 484390,
  [SMALL_STATE(12199)] = 484416,
  [SMALL_STATE(12200)] = 484440,
  [SMALL_STATE(12201)] = 484464,
  [SMALL_STATE(12202)] = 484492,
  [SMALL_STATE(12203)] = 484516,
  [SMALL_STATE(12204)] = 484540,
  [SMALL_STATE(12205)] = 484564,
  [SMALL_STATE(12206)] = 484590,
  [SMALL_STATE(12207)] = 484616,
  [SMALL_STATE(12208)] = 484640,
  [SMALL_STATE(12209)] = 484664,
  [SMALL_STATE(12210)] = 484688,
  [SMALL_STATE(12211)] = 484712,
  [SMALL_STATE(12212)] = 484740,
  [SMALL_STATE(12213)] = 484764,
  [SMALL_STATE(12214)] = 484788,
  [SMALL_STATE(12215)] = 484812,
  [SMALL_STATE(12216)] = 484836,
  [SMALL_STATE(12217)] = 484860,
  [SMALL_STATE(12218)] = 484884,
  [SMALL_STATE(12219)] = 484908,
  [SMALL_STATE(12220)] = 484932,
  [SMALL_STATE(12221)] = 484956,
  [SMALL_STATE(12222)] = 484980,
  [SMALL_STATE(12223)] = 485004,
  [SMALL_STATE(12224)] = 485028,
  [SMALL_STATE(12225)] = 485052,
  [SMALL_STATE(12226)] = 485076,
  [SMALL_STATE(12227)] = 485100,
  [SMALL_STATE(12228)] = 485124,
  [SMALL_STATE(12229)] = 485148,
  [SMALL_STATE(12230)] = 485172,
  [SMALL_STATE(12231)] = 485198,
  [SMALL_STATE(12232)] = 485222,
  [SMALL_STATE(12233)] = 485244,
  [SMALL_STATE(12234)] = 485268,
  [SMALL_STATE(12235)] = 485292,
  [SMALL_STATE(12236)] = 485316,
  [SMALL_STATE(12237)] = 485340,
  [SMALL_STATE(12238)] = 485364,
  [SMALL_STATE(12239)] = 485388,
  [SMALL_STATE(12240)] = 485414,
  [SMALL_STATE(12241)] = 485442,
  [SMALL_STATE(12242)] = 485470,
  [SMALL_STATE(12243)] = 485494,
  [SMALL_STATE(12244)] = 485518,
  [SMALL_STATE(12245)] = 485542,
  [SMALL_STATE(12246)] = 485566,
  [SMALL_STATE(12247)] = 485590,
  [SMALL_STATE(12248)] = 485614,
  [SMALL_STATE(12249)] = 485642,
  [SMALL_STATE(12250)] = 485664,
  [SMALL_STATE(12251)] = 485688,
  [SMALL_STATE(12252)] = 485712,
  [SMALL_STATE(12253)] = 485736,
  [SMALL_STATE(12254)] = 485760,
  [SMALL_STATE(12255)] = 485784,
  [SMALL_STATE(12256)] = 485808,
  [SMALL_STATE(12257)] = 485832,
  [SMALL_STATE(12258)] = 485856,
  [SMALL_STATE(12259)] = 485880,
  [SMALL_STATE(12260)] = 485904,
  [SMALL_STATE(12261)] = 485928,
  [SMALL_STATE(12262)] = 485952,
  [SMALL_STATE(12263)] = 485976,
  [SMALL_STATE(12264)] = 486000,
  [SMALL_STATE(12265)] = 486024,
  [SMALL_STATE(12266)] = 486048,
  [SMALL_STATE(12267)] = 486072,
  [SMALL_STATE(12268)] = 486096,
  [SMALL_STATE(12269)] = 486120,
  [SMALL_STATE(12270)] = 486144,
  [SMALL_STATE(12271)] = 486168,
  [SMALL_STATE(12272)] = 486192,
  [SMALL_STATE(12273)] = 486216,
  [SMALL_STATE(12274)] = 486240,
  [SMALL_STATE(12275)] = 486264,
  [SMALL_STATE(12276)] = 486288,
  [SMALL_STATE(12277)] = 486312,
  [SMALL_STATE(12278)] = 486336,
  [SMALL_STATE(12279)] = 486360,
  [SMALL_STATE(12280)] = 486386,
  [SMALL_STATE(12281)] = 486410,
  [SMALL_STATE(12282)] = 486434,
  [SMALL_STATE(12283)] = 486458,
  [SMALL_STATE(12284)] = 486482,
  [SMALL_STATE(12285)] = 486506,
  [SMALL_STATE(12286)] = 486530,
  [SMALL_STATE(12287)] = 486554,
  [SMALL_STATE(12288)] = 486578,
  [SMALL_STATE(12289)] = 486602,
  [SMALL_STATE(12290)] = 486626,
  [SMALL_STATE(12291)] = 486650,
  [SMALL_STATE(12292)] = 486674,
  [SMALL_STATE(12293)] = 486698,
  [SMALL_STATE(12294)] = 486722,
  [SMALL_STATE(12295)] = 486746,
  [SMALL_STATE(12296)] = 486770,
  [SMALL_STATE(12297)] = 486794,
  [SMALL_STATE(12298)] = 486832,
  [SMALL_STATE(12299)] = 486856,
  [SMALL_STATE(12300)] = 486880,
  [SMALL_STATE(12301)] = 486904,
  [SMALL_STATE(12302)] = 486928,
  [SMALL_STATE(12303)] = 486952,
  [SMALL_STATE(12304)] = 486978,
  [SMALL_STATE(12305)] = 487002,
  [SMALL_STATE(12306)] = 487026,
  [SMALL_STATE(12307)] = 487050,
  [SMALL_STATE(12308)] = 487076,
  [SMALL_STATE(12309)] = 487100,
  [SMALL_STATE(12310)] = 487124,
  [SMALL_STATE(12311)] = 487148,
  [SMALL_STATE(12312)] = 487172,
  [SMALL_STATE(12313)] = 487196,
  [SMALL_STATE(12314)] = 487220,
  [SMALL_STATE(12315)] = 487244,
  [SMALL_STATE(12316)] = 487268,
  [SMALL_STATE(12317)] = 487292,
  [SMALL_STATE(12318)] = 487316,
  [SMALL_STATE(12319)] = 487340,
  [SMALL_STATE(12320)] = 487366,
  [SMALL_STATE(12321)] = 487390,
  [SMALL_STATE(12322)] = 487414,
  [SMALL_STATE(12323)] = 487438,
  [SMALL_STATE(12324)] = 487460,
  [SMALL_STATE(12325)] = 487484,
  [SMALL_STATE(12326)] = 487508,
  [SMALL_STATE(12327)] = 487532,
  [SMALL_STATE(12328)] = 487556,
  [SMALL_STATE(12329)] = 487580,
  [SMALL_STATE(12330)] = 487604,
  [SMALL_STATE(12331)] = 487628,
  [SMALL_STATE(12332)] = 487652,
  [SMALL_STATE(12333)] = 487676,
  [SMALL_STATE(12334)] = 487700,
  [SMALL_STATE(12335)] = 487724,
  [SMALL_STATE(12336)] = 487748,
  [SMALL_STATE(12337)] = 487772,
  [SMALL_STATE(12338)] = 487796,
  [SMALL_STATE(12339)] = 487820,
  [SMALL_STATE(12340)] = 487844,
  [SMALL_STATE(12341)] = 487870,
  [SMALL_STATE(12342)] = 487894,
  [SMALL_STATE(12343)] = 487918,
  [SMALL_STATE(12344)] = 487942,
  [SMALL_STATE(12345)] = 487966,
  [SMALL_STATE(12346)] = 487990,
  [SMALL_STATE(12347)] = 488014,
  [SMALL_STATE(12348)] = 488038,
  [SMALL_STATE(12349)] = 488062,
  [SMALL_STATE(12350)] = 488086,
  [SMALL_STATE(12351)] = 488110,
  [SMALL_STATE(12352)] = 488134,
  [SMALL_STATE(12353)] = 488158,
  [SMALL_STATE(12354)] = 488182,
  [SMALL_STATE(12355)] = 488206,
  [SMALL_STATE(12356)] = 488230,
  [SMALL_STATE(12357)] = 488254,
  [SMALL_STATE(12358)] = 488278,
  [SMALL_STATE(12359)] = 488302,
  [SMALL_STATE(12360)] = 488326,
  [SMALL_STATE(12361)] = 488350,
  [SMALL_STATE(12362)] = 488388,
  [SMALL_STATE(12363)] = 488412,
  [SMALL_STATE(12364)] = 488440,
  [SMALL_STATE(12365)] = 488464,
  [SMALL_STATE(12366)] = 488488,
  [SMALL_STATE(12367)] = 488512,
  [SMALL_STATE(12368)] = 488536,
  [SMALL_STATE(12369)] = 488560,
  [SMALL_STATE(12370)] = 488584,
  [SMALL_STATE(12371)] = 488610,
  [SMALL_STATE(12372)] = 488632,
  [SMALL_STATE(12373)] = 488656,
  [SMALL_STATE(12374)] = 488678,
  [SMALL_STATE(12375)] = 488702,
  [SMALL_STATE(12376)] = 488726,
  [SMALL_STATE(12377)] = 488750,
  [SMALL_STATE(12378)] = 488774,
  [SMALL_STATE(12379)] = 488798,
  [SMALL_STATE(12380)] = 488822,
  [SMALL_STATE(12381)] = 488850,
  [SMALL_STATE(12382)] = 488878,
  [SMALL_STATE(12383)] = 488906,
  [SMALL_STATE(12384)] = 488928,
  [SMALL_STATE(12385)] = 488952,
  [SMALL_STATE(12386)] = 488976,
  [SMALL_STATE(12387)] = 489000,
  [SMALL_STATE(12388)] = 489024,
  [SMALL_STATE(12389)] = 489048,
  [SMALL_STATE(12390)] = 489072,
  [SMALL_STATE(12391)] = 489096,
  [SMALL_STATE(12392)] = 489120,
  [SMALL_STATE(12393)] = 489144,
  [SMALL_STATE(12394)] = 489168,
  [SMALL_STATE(12395)] = 489192,
  [SMALL_STATE(12396)] = 489216,
  [SMALL_STATE(12397)] = 489238,
  [SMALL_STATE(12398)] = 489262,
  [SMALL_STATE(12399)] = 489290,
  [SMALL_STATE(12400)] = 489314,
  [SMALL_STATE(12401)] = 489338,
  [SMALL_STATE(12402)] = 489362,
  [SMALL_STATE(12403)] = 489386,
  [SMALL_STATE(12404)] = 489410,
  [SMALL_STATE(12405)] = 489434,
  [SMALL_STATE(12406)] = 489458,
  [SMALL_STATE(12407)] = 489482,
  [SMALL_STATE(12408)] = 489506,
  [SMALL_STATE(12409)] = 489530,
  [SMALL_STATE(12410)] = 489554,
  [SMALL_STATE(12411)] = 489578,
  [SMALL_STATE(12412)] = 489602,
  [SMALL_STATE(12413)] = 489626,
  [SMALL_STATE(12414)] = 489650,
  [SMALL_STATE(12415)] = 489674,
  [SMALL_STATE(12416)] = 489698,
  [SMALL_STATE(12417)] = 489722,
  [SMALL_STATE(12418)] = 489746,
  [SMALL_STATE(12419)] = 489770,
  [SMALL_STATE(12420)] = 489794,
  [SMALL_STATE(12421)] = 489818,
  [SMALL_STATE(12422)] = 489842,
  [SMALL_STATE(12423)] = 489866,
  [SMALL_STATE(12424)] = 489890,
  [SMALL_STATE(12425)] = 489914,
  [SMALL_STATE(12426)] = 489938,
  [SMALL_STATE(12427)] = 489962,
  [SMALL_STATE(12428)] = 489986,
  [SMALL_STATE(12429)] = 490012,
  [SMALL_STATE(12430)] = 490036,
  [SMALL_STATE(12431)] = 490060,
  [SMALL_STATE(12432)] = 490084,
  [SMALL_STATE(12433)] = 490108,
  [SMALL_STATE(12434)] = 490132,
  [SMALL_STATE(12435)] = 490156,
  [SMALL_STATE(12436)] = 490180,
  [SMALL_STATE(12437)] = 490204,
  [SMALL_STATE(12438)] = 490228,
  [SMALL_STATE(12439)] = 490252,
  [SMALL_STATE(12440)] = 490276,
  [SMALL_STATE(12441)] = 490300,
  [SMALL_STATE(12442)] = 490324,
  [SMALL_STATE(12443)] = 490348,
  [SMALL_STATE(12444)] = 490372,
  [SMALL_STATE(12445)] = 490396,
  [SMALL_STATE(12446)] = 490420,
  [SMALL_STATE(12447)] = 490444,
  [SMALL_STATE(12448)] = 490468,
  [SMALL_STATE(12449)] = 490492,
  [SMALL_STATE(12450)] = 490516,
  [SMALL_STATE(12451)] = 490540,
  [SMALL_STATE(12452)] = 490564,
  [SMALL_STATE(12453)] = 490588,
  [SMALL_STATE(12454)] = 490612,
  [SMALL_STATE(12455)] = 490640,
  [SMALL_STATE(12456)] = 490664,
  [SMALL_STATE(12457)] = 490688,
  [SMALL_STATE(12458)] = 490712,
  [SMALL_STATE(12459)] = 490736,
  [SMALL_STATE(12460)] = 490760,
  [SMALL_STATE(12461)] = 490784,
  [SMALL_STATE(12462)] = 490808,
  [SMALL_STATE(12463)] = 490832,
  [SMALL_STATE(12464)] = 490856,
  [SMALL_STATE(12465)] = 490880,
  [SMALL_STATE(12466)] = 490904,
  [SMALL_STATE(12467)] = 490928,
  [SMALL_STATE(12468)] = 490952,
  [SMALL_STATE(12469)] = 490976,
  [SMALL_STATE(12470)] = 491000,
  [SMALL_STATE(12471)] = 491024,
  [SMALL_STATE(12472)] = 491048,
  [SMALL_STATE(12473)] = 491072,
  [SMALL_STATE(12474)] = 491096,
  [SMALL_STATE(12475)] = 491120,
  [SMALL_STATE(12476)] = 491144,
  [SMALL_STATE(12477)] = 491168,
  [SMALL_STATE(12478)] = 491192,
  [SMALL_STATE(12479)] = 491216,
  [SMALL_STATE(12480)] = 491252,
  [SMALL_STATE(12481)] = 491276,
  [SMALL_STATE(12482)] = 491300,
  [SMALL_STATE(12483)] = 491324,
  [SMALL_STATE(12484)] = 491348,
  [SMALL_STATE(12485)] = 491372,
  [SMALL_STATE(12486)] = 491396,
  [SMALL_STATE(12487)] = 491420,
  [SMALL_STATE(12488)] = 491444,
  [SMALL_STATE(12489)] = 491468,
  [SMALL_STATE(12490)] = 491496,
  [SMALL_STATE(12491)] = 491520,
  [SMALL_STATE(12492)] = 491544,
  [SMALL_STATE(12493)] = 491568,
  [SMALL_STATE(12494)] = 491592,
  [SMALL_STATE(12495)] = 491616,
  [SMALL_STATE(12496)] = 491640,
  [SMALL_STATE(12497)] = 491666,
  [SMALL_STATE(12498)] = 491690,
  [SMALL_STATE(12499)] = 491714,
  [SMALL_STATE(12500)] = 491738,
  [SMALL_STATE(12501)] = 491762,
  [SMALL_STATE(12502)] = 491784,
  [SMALL_STATE(12503)] = 491808,
  [SMALL_STATE(12504)] = 491832,
  [SMALL_STATE(12505)] = 491856,
  [SMALL_STATE(12506)] = 491880,
  [SMALL_STATE(12507)] = 491904,
  [SMALL_STATE(12508)] = 491928,
  [SMALL_STATE(12509)] = 491952,
  [SMALL_STATE(12510)] = 491976,
  [SMALL_STATE(12511)] = 492002,
  [SMALL_STATE(12512)] = 492030,
  [SMALL_STATE(12513)] = 492054,
  [SMALL_STATE(12514)] = 492078,
  [SMALL_STATE(12515)] = 492102,
  [SMALL_STATE(12516)] = 492130,
  [SMALL_STATE(12517)] = 492160,
  [SMALL_STATE(12518)] = 492184,
  [SMALL_STATE(12519)] = 492208,
  [SMALL_STATE(12520)] = 492232,
  [SMALL_STATE(12521)] = 492256,
  [SMALL_STATE(12522)] = 492280,
  [SMALL_STATE(12523)] = 492304,
  [SMALL_STATE(12524)] = 492328,
  [SMALL_STATE(12525)] = 492352,
  [SMALL_STATE(12526)] = 492376,
  [SMALL_STATE(12527)] = 492400,
  [SMALL_STATE(12528)] = 492424,
  [SMALL_STATE(12529)] = 492450,
  [SMALL_STATE(12530)] = 492474,
  [SMALL_STATE(12531)] = 492498,
  [SMALL_STATE(12532)] = 492522,
  [SMALL_STATE(12533)] = 492546,
  [SMALL_STATE(12534)] = 492570,
  [SMALL_STATE(12535)] = 492594,
  [SMALL_STATE(12536)] = 492632,
  [SMALL_STATE(12537)] = 492658,
  [SMALL_STATE(12538)] = 492682,
  [SMALL_STATE(12539)] = 492706,
  [SMALL_STATE(12540)] = 492730,
  [SMALL_STATE(12541)] = 492754,
  [SMALL_STATE(12542)] = 492778,
  [SMALL_STATE(12543)] = 492802,
  [SMALL_STATE(12544)] = 492826,
  [SMALL_STATE(12545)] = 492850,
  [SMALL_STATE(12546)] = 492874,
  [SMALL_STATE(12547)] = 492898,
  [SMALL_STATE(12548)] = 492922,
  [SMALL_STATE(12549)] = 492946,
  [SMALL_STATE(12550)] = 492970,
  [SMALL_STATE(12551)] = 492994,
  [SMALL_STATE(12552)] = 493018,
  [SMALL_STATE(12553)] = 493042,
  [SMALL_STATE(12554)] = 493066,
  [SMALL_STATE(12555)] = 493090,
  [SMALL_STATE(12556)] = 493114,
  [SMALL_STATE(12557)] = 493138,
  [SMALL_STATE(12558)] = 493162,
  [SMALL_STATE(12559)] = 493186,
  [SMALL_STATE(12560)] = 493210,
  [SMALL_STATE(12561)] = 493234,
  [SMALL_STATE(12562)] = 493258,
  [SMALL_STATE(12563)] = 493282,
  [SMALL_STATE(12564)] = 493306,
  [SMALL_STATE(12565)] = 493330,
  [SMALL_STATE(12566)] = 493354,
  [SMALL_STATE(12567)] = 493378,
  [SMALL_STATE(12568)] = 493402,
  [SMALL_STATE(12569)] = 493426,
  [SMALL_STATE(12570)] = 493452,
  [SMALL_STATE(12571)] = 493476,
  [SMALL_STATE(12572)] = 493500,
  [SMALL_STATE(12573)] = 493524,
  [SMALL_STATE(12574)] = 493548,
  [SMALL_STATE(12575)] = 493572,
  [SMALL_STATE(12576)] = 493596,
  [SMALL_STATE(12577)] = 493620,
  [SMALL_STATE(12578)] = 493644,
  [SMALL_STATE(12579)] = 493668,
  [SMALL_STATE(12580)] = 493692,
  [SMALL_STATE(12581)] = 493716,
  [SMALL_STATE(12582)] = 493740,
  [SMALL_STATE(12583)] = 493764,
  [SMALL_STATE(12584)] = 493788,
  [SMALL_STATE(12585)] = 493812,
  [SMALL_STATE(12586)] = 493836,
  [SMALL_STATE(12587)] = 493860,
  [SMALL_STATE(12588)] = 493884,
  [SMALL_STATE(12589)] = 493908,
  [SMALL_STATE(12590)] = 493930,
  [SMALL_STATE(12591)] = 493954,
  [SMALL_STATE(12592)] = 493978,
  [SMALL_STATE(12593)] = 494002,
  [SMALL_STATE(12594)] = 494026,
  [SMALL_STATE(12595)] = 494050,
  [SMALL_STATE(12596)] = 494072,
  [SMALL_STATE(12597)] = 494096,
  [SMALL_STATE(12598)] = 494120,
  [SMALL_STATE(12599)] = 494144,
  [SMALL_STATE(12600)] = 494172,
  [SMALL_STATE(12601)] = 494194,
  [SMALL_STATE(12602)] = 494218,
  [SMALL_STATE(12603)] = 494242,
  [SMALL_STATE(12604)] = 494266,
  [SMALL_STATE(12605)] = 494290,
  [SMALL_STATE(12606)] = 494314,
  [SMALL_STATE(12607)] = 494338,
  [SMALL_STATE(12608)] = 494362,
  [SMALL_STATE(12609)] = 494386,
  [SMALL_STATE(12610)] = 494410,
  [SMALL_STATE(12611)] = 494434,
  [SMALL_STATE(12612)] = 494458,
  [SMALL_STATE(12613)] = 494482,
  [SMALL_STATE(12614)] = 494506,
  [SMALL_STATE(12615)] = 494530,
  [SMALL_STATE(12616)] = 494554,
  [SMALL_STATE(12617)] = 494578,
  [SMALL_STATE(12618)] = 494606,
  [SMALL_STATE(12619)] = 494634,
  [SMALL_STATE(12620)] = 494658,
  [SMALL_STATE(12621)] = 494682,
  [SMALL_STATE(12622)] = 494704,
  [SMALL_STATE(12623)] = 494728,
  [SMALL_STATE(12624)] = 494750,
  [SMALL_STATE(12625)] = 494778,
  [SMALL_STATE(12626)] = 494806,
  [SMALL_STATE(12627)] = 494830,
  [SMALL_STATE(12628)] = 494868,
  [SMALL_STATE(12629)] = 494892,
  [SMALL_STATE(12630)] = 494916,
  [SMALL_STATE(12631)] = 494940,
  [SMALL_STATE(12632)] = 494964,
  [SMALL_STATE(12633)] = 494988,
  [SMALL_STATE(12634)] = 495012,
  [SMALL_STATE(12635)] = 495036,
  [SMALL_STATE(12636)] = 495060,
  [SMALL_STATE(12637)] = 495084,
  [SMALL_STATE(12638)] = 495108,
  [SMALL_STATE(12639)] = 495132,
  [SMALL_STATE(12640)] = 495156,
  [SMALL_STATE(12641)] = 495186,
  [SMALL_STATE(12642)] = 495210,
  [SMALL_STATE(12643)] = 495234,
  [SMALL_STATE(12644)] = 495258,
  [SMALL_STATE(12645)] = 495282,
  [SMALL_STATE(12646)] = 495306,
  [SMALL_STATE(12647)] = 495330,
  [SMALL_STATE(12648)] = 495354,
  [SMALL_STATE(12649)] = 495382,
  [SMALL_STATE(12650)] = 495406,
  [SMALL_STATE(12651)] = 495430,
  [SMALL_STATE(12652)] = 495454,
  [SMALL_STATE(12653)] = 495478,
  [SMALL_STATE(12654)] = 495502,
  [SMALL_STATE(12655)] = 495526,
  [SMALL_STATE(12656)] = 495550,
  [SMALL_STATE(12657)] = 495574,
  [SMALL_STATE(12658)] = 495598,
  [SMALL_STATE(12659)] = 495622,
  [SMALL_STATE(12660)] = 495646,
  [SMALL_STATE(12661)] = 495670,
  [SMALL_STATE(12662)] = 495694,
  [SMALL_STATE(12663)] = 495718,
  [SMALL_STATE(12664)] = 495742,
  [SMALL_STATE(12665)] = 495766,
  [SMALL_STATE(12666)] = 495790,
  [SMALL_STATE(12667)] = 495814,
  [SMALL_STATE(12668)] = 495838,
  [SMALL_STATE(12669)] = 495862,
  [SMALL_STATE(12670)] = 495886,
  [SMALL_STATE(12671)] = 495910,
  [SMALL_STATE(12672)] = 495934,
  [SMALL_STATE(12673)] = 495958,
  [SMALL_STATE(12674)] = 495982,
  [SMALL_STATE(12675)] = 496006,
  [SMALL_STATE(12676)] = 496034,
  [SMALL_STATE(12677)] = 496058,
  [SMALL_STATE(12678)] = 496082,
  [SMALL_STATE(12679)] = 496106,
  [SMALL_STATE(12680)] = 496130,
  [SMALL_STATE(12681)] = 496154,
  [SMALL_STATE(12682)] = 496178,
  [SMALL_STATE(12683)] = 496202,
  [SMALL_STATE(12684)] = 496226,
  [SMALL_STATE(12685)] = 496250,
  [SMALL_STATE(12686)] = 496274,
  [SMALL_STATE(12687)] = 496298,
  [SMALL_STATE(12688)] = 496322,
  [SMALL_STATE(12689)] = 496346,
  [SMALL_STATE(12690)] = 496370,
  [SMALL_STATE(12691)] = 496394,
  [SMALL_STATE(12692)] = 496418,
  [SMALL_STATE(12693)] = 496442,
  [SMALL_STATE(12694)] = 496466,
  [SMALL_STATE(12695)] = 496490,
  [SMALL_STATE(12696)] = 496514,
  [SMALL_STATE(12697)] = 496538,
  [SMALL_STATE(12698)] = 496564,
  [SMALL_STATE(12699)] = 496592,
  [SMALL_STATE(12700)] = 496616,
  [SMALL_STATE(12701)] = 496640,
  [SMALL_STATE(12702)] = 496664,
  [SMALL_STATE(12703)] = 496688,
  [SMALL_STATE(12704)] = 496712,
  [SMALL_STATE(12705)] = 496736,
  [SMALL_STATE(12706)] = 496760,
  [SMALL_STATE(12707)] = 496784,
  [SMALL_STATE(12708)] = 496812,
  [SMALL_STATE(12709)] = 496836,
  [SMALL_STATE(12710)] = 496860,
  [SMALL_STATE(12711)] = 496884,
  [SMALL_STATE(12712)] = 496912,
  [SMALL_STATE(12713)] = 496940,
  [SMALL_STATE(12714)] = 496962,
  [SMALL_STATE(12715)] = 496986,
  [SMALL_STATE(12716)] = 497010,
  [SMALL_STATE(12717)] = 497034,
  [SMALL_STATE(12718)] = 497058,
  [SMALL_STATE(12719)] = 497082,
  [SMALL_STATE(12720)] = 497110,
  [SMALL_STATE(12721)] = 497134,
  [SMALL_STATE(12722)] = 497158,
  [SMALL_STATE(12723)] = 497182,
  [SMALL_STATE(12724)] = 497206,
  [SMALL_STATE(12725)] = 497230,
  [SMALL_STATE(12726)] = 497254,
  [SMALL_STATE(12727)] = 497278,
  [SMALL_STATE(12728)] = 497302,
  [SMALL_STATE(12729)] = 497328,
  [SMALL_STATE(12730)] = 497350,
  [SMALL_STATE(12731)] = 497374,
  [SMALL_STATE(12732)] = 497398,
  [SMALL_STATE(12733)] = 497422,
  [SMALL_STATE(12734)] = 497446,
  [SMALL_STATE(12735)] = 497470,
  [SMALL_STATE(12736)] = 497492,
  [SMALL_STATE(12737)] = 497516,
  [SMALL_STATE(12738)] = 497540,
  [SMALL_STATE(12739)] = 497564,
  [SMALL_STATE(12740)] = 497588,
  [SMALL_STATE(12741)] = 497612,
  [SMALL_STATE(12742)] = 497638,
  [SMALL_STATE(12743)] = 497662,
  [SMALL_STATE(12744)] = 497688,
  [SMALL_STATE(12745)] = 497712,
  [SMALL_STATE(12746)] = 497736,
  [SMALL_STATE(12747)] = 497760,
  [SMALL_STATE(12748)] = 497784,
  [SMALL_STATE(12749)] = 497808,
  [SMALL_STATE(12750)] = 497832,
  [SMALL_STATE(12751)] = 497856,
  [SMALL_STATE(12752)] = 497880,
  [SMALL_STATE(12753)] = 497908,
  [SMALL_STATE(12754)] = 497932,
  [SMALL_STATE(12755)] = 497956,
  [SMALL_STATE(12756)] = 497980,
  [SMALL_STATE(12757)] = 498004,
  [SMALL_STATE(12758)] = 498028,
  [SMALL_STATE(12759)] = 498052,
  [SMALL_STATE(12760)] = 498076,
  [SMALL_STATE(12761)] = 498100,
  [SMALL_STATE(12762)] = 498124,
  [SMALL_STATE(12763)] = 498148,
  [SMALL_STATE(12764)] = 498172,
  [SMALL_STATE(12765)] = 498196,
  [SMALL_STATE(12766)] = 498234,
  [SMALL_STATE(12767)] = 498258,
  [SMALL_STATE(12768)] = 498280,
  [SMALL_STATE(12769)] = 498302,
  [SMALL_STATE(12770)] = 498326,
  [SMALL_STATE(12771)] = 498348,
  [SMALL_STATE(12772)] = 498374,
  [SMALL_STATE(12773)] = 498398,
  [SMALL_STATE(12774)] = 498420,
  [SMALL_STATE(12775)] = 498446,
  [SMALL_STATE(12776)] = 498473,
  [SMALL_STATE(12777)] = 498496,
  [SMALL_STATE(12778)] = 498517,
  [SMALL_STATE(12779)] = 498540,
  [SMALL_STATE(12780)] = 498563,
  [SMALL_STATE(12781)] = 498586,
  [SMALL_STATE(12782)] = 498627,
  [SMALL_STATE(12783)] = 498650,
  [SMALL_STATE(12784)] = 498675,
  [SMALL_STATE(12785)] = 498696,
  [SMALL_STATE(12786)] = 498719,
  [SMALL_STATE(12787)] = 498742,
  [SMALL_STATE(12788)] = 498771,
  [SMALL_STATE(12789)] = 498794,
  [SMALL_STATE(12790)] = 498815,
  [SMALL_STATE(12791)] = 498838,
  [SMALL_STATE(12792)] = 498861,
  [SMALL_STATE(12793)] = 498898,
  [SMALL_STATE(12794)] = 498921,
  [SMALL_STATE(12795)] = 498944,
  [SMALL_STATE(12796)] = 498967,
  [SMALL_STATE(12797)] = 498990,
  [SMALL_STATE(12798)] = 499013,
  [SMALL_STATE(12799)] = 499036,
  [SMALL_STATE(12800)] = 499059,
  [SMALL_STATE(12801)] = 499082,
  [SMALL_STATE(12802)] = 499105,
  [SMALL_STATE(12803)] = 499128,
  [SMALL_STATE(12804)] = 499151,
  [SMALL_STATE(12805)] = 499174,
  [SMALL_STATE(12806)] = 499195,
  [SMALL_STATE(12807)] = 499218,
  [SMALL_STATE(12808)] = 499255,
  [SMALL_STATE(12809)] = 499278,
  [SMALL_STATE(12810)] = 499299,
  [SMALL_STATE(12811)] = 499322,
  [SMALL_STATE(12812)] = 499345,
  [SMALL_STATE(12813)] = 499368,
  [SMALL_STATE(12814)] = 499405,
  [SMALL_STATE(12815)] = 499428,
  [SMALL_STATE(12816)] = 499451,
  [SMALL_STATE(12817)] = 499474,
  [SMALL_STATE(12818)] = 499497,
  [SMALL_STATE(12819)] = 499520,
  [SMALL_STATE(12820)] = 499543,
  [SMALL_STATE(12821)] = 499566,
  [SMALL_STATE(12822)] = 499589,
  [SMALL_STATE(12823)] = 499612,
  [SMALL_STATE(12824)] = 499635,
  [SMALL_STATE(12825)] = 499656,
  [SMALL_STATE(12826)] = 499679,
  [SMALL_STATE(12827)] = 499702,
  [SMALL_STATE(12828)] = 499725,
  [SMALL_STATE(12829)] = 499748,
  [SMALL_STATE(12830)] = 499771,
  [SMALL_STATE(12831)] = 499808,
  [SMALL_STATE(12832)] = 499831,
  [SMALL_STATE(12833)] = 499854,
  [SMALL_STATE(12834)] = 499877,
  [SMALL_STATE(12835)] = 499898,
  [SMALL_STATE(12836)] = 499921,
  [SMALL_STATE(12837)] = 499944,
  [SMALL_STATE(12838)] = 499981,
  [SMALL_STATE(12839)] = 500004,
  [SMALL_STATE(12840)] = 500027,
  [SMALL_STATE(12841)] = 500048,
  [SMALL_STATE(12842)] = 500071,
  [SMALL_STATE(12843)] = 500094,
  [SMALL_STATE(12844)] = 500115,
  [SMALL_STATE(12845)] = 500138,
  [SMALL_STATE(12846)] = 500159,
  [SMALL_STATE(12847)] = 500180,
  [SMALL_STATE(12848)] = 500203,
  [SMALL_STATE(12849)] = 500226,
  [SMALL_STATE(12850)] = 500249,
  [SMALL_STATE(12851)] = 500272,
  [SMALL_STATE(12852)] = 500293,
  [SMALL_STATE(12853)] = 500316,
  [SMALL_STATE(12854)] = 500339,
  [SMALL_STATE(12855)] = 500362,
  [SMALL_STATE(12856)] = 500385,
  [SMALL_STATE(12857)] = 500408,
  [SMALL_STATE(12858)] = 500431,
  [SMALL_STATE(12859)] = 500454,
  [SMALL_STATE(12860)] = 500477,
  [SMALL_STATE(12861)] = 500500,
  [SMALL_STATE(12862)] = 500521,
  [SMALL_STATE(12863)] = 500544,
  [SMALL_STATE(12864)] = 500565,
  [SMALL_STATE(12865)] = 500590,
  [SMALL_STATE(12866)] = 500613,
  [SMALL_STATE(12867)] = 500636,
  [SMALL_STATE(12868)] = 500657,
  [SMALL_STATE(12869)] = 500678,
  [SMALL_STATE(12870)] = 500701,
  [SMALL_STATE(12871)] = 500738,
  [SMALL_STATE(12872)] = 500761,
  [SMALL_STATE(12873)] = 500784,
  [SMALL_STATE(12874)] = 500821,
  [SMALL_STATE(12875)] = 500844,
  [SMALL_STATE(12876)] = 500867,
  [SMALL_STATE(12877)] = 500890,
  [SMALL_STATE(12878)] = 500917,
  [SMALL_STATE(12879)] = 500940,
  [SMALL_STATE(12880)] = 500965,
  [SMALL_STATE(12881)] = 500988,
  [SMALL_STATE(12882)] = 501009,
  [SMALL_STATE(12883)] = 501032,
  [SMALL_STATE(12884)] = 501055,
  [SMALL_STATE(12885)] = 501092,
  [SMALL_STATE(12886)] = 501115,
  [SMALL_STATE(12887)] = 501138,
  [SMALL_STATE(12888)] = 501161,
  [SMALL_STATE(12889)] = 501182,
  [SMALL_STATE(12890)] = 501205,
  [SMALL_STATE(12891)] = 501228,
  [SMALL_STATE(12892)] = 501251,
  [SMALL_STATE(12893)] = 501274,
  [SMALL_STATE(12894)] = 501295,
  [SMALL_STATE(12895)] = 501318,
  [SMALL_STATE(12896)] = 501355,
  [SMALL_STATE(12897)] = 501392,
  [SMALL_STATE(12898)] = 501413,
  [SMALL_STATE(12899)] = 501454,
  [SMALL_STATE(12900)] = 501489,
  [SMALL_STATE(12901)] = 501512,
  [SMALL_STATE(12902)] = 501549,
  [SMALL_STATE(12903)] = 501574,
  [SMALL_STATE(12904)] = 501599,
  [SMALL_STATE(12905)] = 501622,
  [SMALL_STATE(12906)] = 501645,
  [SMALL_STATE(12907)] = 501668,
  [SMALL_STATE(12908)] = 501691,
  [SMALL_STATE(12909)] = 501714,
  [SMALL_STATE(12910)] = 501735,
  [SMALL_STATE(12911)] = 501758,
  [SMALL_STATE(12912)] = 501781,
  [SMALL_STATE(12913)] = 501802,
  [SMALL_STATE(12914)] = 501839,
  [SMALL_STATE(12915)] = 501862,
  [SMALL_STATE(12916)] = 501885,
  [SMALL_STATE(12917)] = 501908,
  [SMALL_STATE(12918)] = 501933,
  [SMALL_STATE(12919)] = 501970,
  [SMALL_STATE(12920)] = 501993,
  [SMALL_STATE(12921)] = 502030,
  [SMALL_STATE(12922)] = 502053,
  [SMALL_STATE(12923)] = 502090,
  [SMALL_STATE(12924)] = 502113,
  [SMALL_STATE(12925)] = 502150,
  [SMALL_STATE(12926)] = 502173,
  [SMALL_STATE(12927)] = 502196,
  [SMALL_STATE(12928)] = 502219,
  [SMALL_STATE(12929)] = 502242,
  [SMALL_STATE(12930)] = 502267,
  [SMALL_STATE(12931)] = 502290,
  [SMALL_STATE(12932)] = 502313,
  [SMALL_STATE(12933)] = 502336,
  [SMALL_STATE(12934)] = 502359,
  [SMALL_STATE(12935)] = 502382,
  [SMALL_STATE(12936)] = 502405,
  [SMALL_STATE(12937)] = 502428,
  [SMALL_STATE(12938)] = 502451,
  [SMALL_STATE(12939)] = 502474,
  [SMALL_STATE(12940)] = 502497,
  [SMALL_STATE(12941)] = 502520,
  [SMALL_STATE(12942)] = 502545,
  [SMALL_STATE(12943)] = 502568,
  [SMALL_STATE(12944)] = 502591,
  [SMALL_STATE(12945)] = 502614,
  [SMALL_STATE(12946)] = 502637,
  [SMALL_STATE(12947)] = 502660,
  [SMALL_STATE(12948)] = 502689,
  [SMALL_STATE(12949)] = 502712,
  [SMALL_STATE(12950)] = 502735,
  [SMALL_STATE(12951)] = 502758,
  [SMALL_STATE(12952)] = 502781,
  [SMALL_STATE(12953)] = 502804,
  [SMALL_STATE(12954)] = 502827,
  [SMALL_STATE(12955)] = 502850,
  [SMALL_STATE(12956)] = 502873,
  [SMALL_STATE(12957)] = 502894,
  [SMALL_STATE(12958)] = 502915,
  [SMALL_STATE(12959)] = 502938,
  [SMALL_STATE(12960)] = 502961,
  [SMALL_STATE(12961)] = 502982,
  [SMALL_STATE(12962)] = 503005,
  [SMALL_STATE(12963)] = 503028,
  [SMALL_STATE(12964)] = 503051,
  [SMALL_STATE(12965)] = 503074,
  [SMALL_STATE(12966)] = 503097,
  [SMALL_STATE(12967)] = 503120,
  [SMALL_STATE(12968)] = 503143,
  [SMALL_STATE(12969)] = 503166,
  [SMALL_STATE(12970)] = 503189,
  [SMALL_STATE(12971)] = 503212,
  [SMALL_STATE(12972)] = 503233,
  [SMALL_STATE(12973)] = 503256,
  [SMALL_STATE(12974)] = 503279,
  [SMALL_STATE(12975)] = 503302,
  [SMALL_STATE(12976)] = 503325,
  [SMALL_STATE(12977)] = 503348,
  [SMALL_STATE(12978)] = 503371,
  [SMALL_STATE(12979)] = 503408,
  [SMALL_STATE(12980)] = 503431,
  [SMALL_STATE(12981)] = 503454,
  [SMALL_STATE(12982)] = 503477,
  [SMALL_STATE(12983)] = 503500,
  [SMALL_STATE(12984)] = 503537,
  [SMALL_STATE(12985)] = 503578,
  [SMALL_STATE(12986)] = 503601,
  [SMALL_STATE(12987)] = 503622,
  [SMALL_STATE(12988)] = 503645,
  [SMALL_STATE(12989)] = 503668,
  [SMALL_STATE(12990)] = 503691,
  [SMALL_STATE(12991)] = 503714,
  [SMALL_STATE(12992)] = 503737,
  [SMALL_STATE(12993)] = 503764,
  [SMALL_STATE(12994)] = 503785,
  [SMALL_STATE(12995)] = 503808,
  [SMALL_STATE(12996)] = 503837,
  [SMALL_STATE(12997)] = 503858,
  [SMALL_STATE(12998)] = 503879,
  [SMALL_STATE(12999)] = 503902,
  [SMALL_STATE(13000)] = 503925,
  [SMALL_STATE(13001)] = 503948,
  [SMALL_STATE(13002)] = 503971,
  [SMALL_STATE(13003)] = 503994,
  [SMALL_STATE(13004)] = 504017,
  [SMALL_STATE(13005)] = 504040,
  [SMALL_STATE(13006)] = 504077,
  [SMALL_STATE(13007)] = 504100,
  [SMALL_STATE(13008)] = 504121,
  [SMALL_STATE(13009)] = 504142,
  [SMALL_STATE(13010)] = 504165,
  [SMALL_STATE(13011)] = 504188,
  [SMALL_STATE(13012)] = 504211,
  [SMALL_STATE(13013)] = 504232,
  [SMALL_STATE(13014)] = 504255,
  [SMALL_STATE(13015)] = 504276,
  [SMALL_STATE(13016)] = 504299,
  [SMALL_STATE(13017)] = 504320,
  [SMALL_STATE(13018)] = 504343,
  [SMALL_STATE(13019)] = 504366,
  [SMALL_STATE(13020)] = 504389,
  [SMALL_STATE(13021)] = 504412,
  [SMALL_STATE(13022)] = 504435,
  [SMALL_STATE(13023)] = 504458,
  [SMALL_STATE(13024)] = 504481,
  [SMALL_STATE(13025)] = 504508,
  [SMALL_STATE(13026)] = 504531,
  [SMALL_STATE(13027)] = 504554,
  [SMALL_STATE(13028)] = 504577,
  [SMALL_STATE(13029)] = 504602,
  [SMALL_STATE(13030)] = 504625,
  [SMALL_STATE(13031)] = 504648,
  [SMALL_STATE(13032)] = 504671,
  [SMALL_STATE(13033)] = 504694,
  [SMALL_STATE(13034)] = 504717,
  [SMALL_STATE(13035)] = 504740,
  [SMALL_STATE(13036)] = 504763,
  [SMALL_STATE(13037)] = 504786,
  [SMALL_STATE(13038)] = 504809,
  [SMALL_STATE(13039)] = 504846,
  [SMALL_STATE(13040)] = 504887,
  [SMALL_STATE(13041)] = 504914,
  [SMALL_STATE(13042)] = 504935,
  [SMALL_STATE(13043)] = 504958,
  [SMALL_STATE(13044)] = 504981,
  [SMALL_STATE(13045)] = 505018,
  [SMALL_STATE(13046)] = 505041,
  [SMALL_STATE(13047)] = 505062,
  [SMALL_STATE(13048)] = 505083,
  [SMALL_STATE(13049)] = 505106,
  [SMALL_STATE(13050)] = 505129,
  [SMALL_STATE(13051)] = 505152,
  [SMALL_STATE(13052)] = 505175,
  [SMALL_STATE(13053)] = 505196,
  [SMALL_STATE(13054)] = 505225,
  [SMALL_STATE(13055)] = 505248,
  [SMALL_STATE(13056)] = 505271,
  [SMALL_STATE(13057)] = 505294,
  [SMALL_STATE(13058)] = 505317,
  [SMALL_STATE(13059)] = 505340,
  [SMALL_STATE(13060)] = 505363,
  [SMALL_STATE(13061)] = 505386,
  [SMALL_STATE(13062)] = 505409,
  [SMALL_STATE(13063)] = 505432,
  [SMALL_STATE(13064)] = 505455,
  [SMALL_STATE(13065)] = 505476,
  [SMALL_STATE(13066)] = 505499,
  [SMALL_STATE(13067)] = 505522,
  [SMALL_STATE(13068)] = 505543,
  [SMALL_STATE(13069)] = 505566,
  [SMALL_STATE(13070)] = 505589,
  [SMALL_STATE(13071)] = 505624,
  [SMALL_STATE(13072)] = 505647,
  [SMALL_STATE(13073)] = 505672,
  [SMALL_STATE(13074)] = 505695,
  [SMALL_STATE(13075)] = 505716,
  [SMALL_STATE(13076)] = 505745,
  [SMALL_STATE(13077)] = 505766,
  [SMALL_STATE(13078)] = 505789,
  [SMALL_STATE(13079)] = 505812,
  [SMALL_STATE(13080)] = 505835,
  [SMALL_STATE(13081)] = 505858,
  [SMALL_STATE(13082)] = 505881,
  [SMALL_STATE(13083)] = 505918,
  [SMALL_STATE(13084)] = 505941,
  [SMALL_STATE(13085)] = 505964,
  [SMALL_STATE(13086)] = 506001,
  [SMALL_STATE(13087)] = 506036,
  [SMALL_STATE(13088)] = 506059,
  [SMALL_STATE(13089)] = 506082,
  [SMALL_STATE(13090)] = 506103,
  [SMALL_STATE(13091)] = 506124,
  [SMALL_STATE(13092)] = 506145,
  [SMALL_STATE(13093)] = 506168,
  [SMALL_STATE(13094)] = 506189,
  [SMALL_STATE(13095)] = 506212,
  [SMALL_STATE(13096)] = 506233,
  [SMALL_STATE(13097)] = 506270,
  [SMALL_STATE(13098)] = 506307,
  [SMALL_STATE(13099)] = 506330,
  [SMALL_STATE(13100)] = 506359,
  [SMALL_STATE(13101)] = 506382,
  [SMALL_STATE(13102)] = 506405,
  [SMALL_STATE(13103)] = 506426,
  [SMALL_STATE(13104)] = 506449,
  [SMALL_STATE(13105)] = 506470,
  [SMALL_STATE(13106)] = 506507,
  [SMALL_STATE(13107)] = 506530,
  [SMALL_STATE(13108)] = 506553,
  [SMALL_STATE(13109)] = 506574,
  [SMALL_STATE(13110)] = 506597,
  [SMALL_STATE(13111)] = 506620,
  [SMALL_STATE(13112)] = 506643,
  [SMALL_STATE(13113)] = 506666,
  [SMALL_STATE(13114)] = 506689,
  [SMALL_STATE(13115)] = 506712,
  [SMALL_STATE(13116)] = 506735,
  [SMALL_STATE(13117)] = 506772,
  [SMALL_STATE(13118)] = 506795,
  [SMALL_STATE(13119)] = 506818,
  [SMALL_STATE(13120)] = 506841,
  [SMALL_STATE(13121)] = 506864,
  [SMALL_STATE(13122)] = 506887,
  [SMALL_STATE(13123)] = 506910,
  [SMALL_STATE(13124)] = 506933,
  [SMALL_STATE(13125)] = 506956,
  [SMALL_STATE(13126)] = 506997,
  [SMALL_STATE(13127)] = 507034,
  [SMALL_STATE(13128)] = 507057,
  [SMALL_STATE(13129)] = 507080,
  [SMALL_STATE(13130)] = 507103,
  [SMALL_STATE(13131)] = 507126,
  [SMALL_STATE(13132)] = 507149,
  [SMALL_STATE(13133)] = 507172,
  [SMALL_STATE(13134)] = 507195,
  [SMALL_STATE(13135)] = 507218,
  [SMALL_STATE(13136)] = 507253,
  [SMALL_STATE(13137)] = 507290,
  [SMALL_STATE(13138)] = 507311,
  [SMALL_STATE(13139)] = 507334,
  [SMALL_STATE(13140)] = 507357,
  [SMALL_STATE(13141)] = 507380,
  [SMALL_STATE(13142)] = 507403,
  [SMALL_STATE(13143)] = 507426,
  [SMALL_STATE(13144)] = 507449,
  [SMALL_STATE(13145)] = 507470,
  [SMALL_STATE(13146)] = 507491,
  [SMALL_STATE(13147)] = 507514,
  [SMALL_STATE(13148)] = 507537,
  [SMALL_STATE(13149)] = 507560,
  [SMALL_STATE(13150)] = 507597,
  [SMALL_STATE(13151)] = 507620,
  [SMALL_STATE(13152)] = 507643,
  [SMALL_STATE(13153)] = 507680,
  [SMALL_STATE(13154)] = 507721,
  [SMALL_STATE(13155)] = 507744,
  [SMALL_STATE(13156)] = 507767,
  [SMALL_STATE(13157)] = 507796,
  [SMALL_STATE(13158)] = 507819,
  [SMALL_STATE(13159)] = 507842,
  [SMALL_STATE(13160)] = 507865,
  [SMALL_STATE(13161)] = 507888,
  [SMALL_STATE(13162)] = 507911,
  [SMALL_STATE(13163)] = 507934,
  [SMALL_STATE(13164)] = 507971,
  [SMALL_STATE(13165)] = 507992,
  [SMALL_STATE(13166)] = 508013,
  [SMALL_STATE(13167)] = 508036,
  [SMALL_STATE(13168)] = 508073,
  [SMALL_STATE(13169)] = 508096,
  [SMALL_STATE(13170)] = 508119,
  [SMALL_STATE(13171)] = 508142,
  [SMALL_STATE(13172)] = 508165,
  [SMALL_STATE(13173)] = 508188,
  [SMALL_STATE(13174)] = 508211,
  [SMALL_STATE(13175)] = 508248,
  [SMALL_STATE(13176)] = 508271,
  [SMALL_STATE(13177)] = 508294,
  [SMALL_STATE(13178)] = 508317,
  [SMALL_STATE(13179)] = 508340,
  [SMALL_STATE(13180)] = 508363,
  [SMALL_STATE(13181)] = 508386,
  [SMALL_STATE(13182)] = 508409,
  [SMALL_STATE(13183)] = 508430,
  [SMALL_STATE(13184)] = 508453,
  [SMALL_STATE(13185)] = 508476,
  [SMALL_STATE(13186)] = 508499,
  [SMALL_STATE(13187)] = 508536,
  [SMALL_STATE(13188)] = 508571,
  [SMALL_STATE(13189)] = 508600,
  [SMALL_STATE(13190)] = 508629,
  [SMALL_STATE(13191)] = 508666,
  [SMALL_STATE(13192)] = 508703,
  [SMALL_STATE(13193)] = 508724,
  [SMALL_STATE(13194)] = 508747,
  [SMALL_STATE(13195)] = 508784,
  [SMALL_STATE(13196)] = 508807,
  [SMALL_STATE(13197)] = 508830,
  [SMALL_STATE(13198)] = 508853,
  [SMALL_STATE(13199)] = 508876,
  [SMALL_STATE(13200)] = 508913,
  [SMALL_STATE(13201)] = 508942,
  [SMALL_STATE(13202)] = 508965,
  [SMALL_STATE(13203)] = 508988,
  [SMALL_STATE(13204)] = 509011,
  [SMALL_STATE(13205)] = 509034,
  [SMALL_STATE(13206)] = 509057,
  [SMALL_STATE(13207)] = 509094,
  [SMALL_STATE(13208)] = 509115,
  [SMALL_STATE(13209)] = 509152,
  [SMALL_STATE(13210)] = 509173,
  [SMALL_STATE(13211)] = 509194,
  [SMALL_STATE(13212)] = 509223,
  [SMALL_STATE(13213)] = 509246,
  [SMALL_STATE(13214)] = 509269,
  [SMALL_STATE(13215)] = 509296,
  [SMALL_STATE(13216)] = 509333,
  [SMALL_STATE(13217)] = 509356,
  [SMALL_STATE(13218)] = 509379,
  [SMALL_STATE(13219)] = 509400,
  [SMALL_STATE(13220)] = 509429,
  [SMALL_STATE(13221)] = 509452,
  [SMALL_STATE(13222)] = 509475,
  [SMALL_STATE(13223)] = 509496,
  [SMALL_STATE(13224)] = 509517,
  [SMALL_STATE(13225)] = 509540,
  [SMALL_STATE(13226)] = 509563,
  [SMALL_STATE(13227)] = 509584,
  [SMALL_STATE(13228)] = 509607,
  [SMALL_STATE(13229)] = 509628,
  [SMALL_STATE(13230)] = 509651,
  [SMALL_STATE(13231)] = 509674,
  [SMALL_STATE(13232)] = 509711,
  [SMALL_STATE(13233)] = 509732,
  [SMALL_STATE(13234)] = 509753,
  [SMALL_STATE(13235)] = 509776,
  [SMALL_STATE(13236)] = 509799,
  [SMALL_STATE(13237)] = 509836,
  [SMALL_STATE(13238)] = 509859,
  [SMALL_STATE(13239)] = 509882,
  [SMALL_STATE(13240)] = 509903,
  [SMALL_STATE(13241)] = 509926,
  [SMALL_STATE(13242)] = 509949,
  [SMALL_STATE(13243)] = 509972,
  [SMALL_STATE(13244)] = 509995,
  [SMALL_STATE(13245)] = 510032,
  [SMALL_STATE(13246)] = 510061,
  [SMALL_STATE(13247)] = 510084,
  [SMALL_STATE(13248)] = 510113,
  [SMALL_STATE(13249)] = 510136,
  [SMALL_STATE(13250)] = 510159,
  [SMALL_STATE(13251)] = 510182,
  [SMALL_STATE(13252)] = 510205,
  [SMALL_STATE(13253)] = 510228,
  [SMALL_STATE(13254)] = 510265,
  [SMALL_STATE(13255)] = 510302,
  [SMALL_STATE(13256)] = 510325,
  [SMALL_STATE(13257)] = 510346,
  [SMALL_STATE(13258)] = 510367,
  [SMALL_STATE(13259)] = 510390,
  [SMALL_STATE(13260)] = 510413,
  [SMALL_STATE(13261)] = 510441,
  [SMALL_STATE(13262)] = 510461,
  [SMALL_STATE(13263)] = 510483,
  [SMALL_STATE(13264)] = 510521,
  [SMALL_STATE(13265)] = 510543,
  [SMALL_STATE(13266)] = 510565,
  [SMALL_STATE(13267)] = 510585,
  [SMALL_STATE(13268)] = 510623,
  [SMALL_STATE(13269)] = 510643,
  [SMALL_STATE(13270)] = 510665,
  [SMALL_STATE(13271)] = 510685,
  [SMALL_STATE(13272)] = 510707,
  [SMALL_STATE(13273)] = 510727,
  [SMALL_STATE(13274)] = 510747,
  [SMALL_STATE(13275)] = 510767,
  [SMALL_STATE(13276)] = 510791,
  [SMALL_STATE(13277)] = 510811,
  [SMALL_STATE(13278)] = 510833,
  [SMALL_STATE(13279)] = 510853,
  [SMALL_STATE(13280)] = 510891,
  [SMALL_STATE(13281)] = 510911,
  [SMALL_STATE(13282)] = 510931,
  [SMALL_STATE(13283)] = 510951,
  [SMALL_STATE(13284)] = 510971,
  [SMALL_STATE(13285)] = 510993,
  [SMALL_STATE(13286)] = 511013,
  [SMALL_STATE(13287)] = 511033,
  [SMALL_STATE(13288)] = 511073,
  [SMALL_STATE(13289)] = 511095,
  [SMALL_STATE(13290)] = 511115,
  [SMALL_STATE(13291)] = 511137,
  [SMALL_STATE(13292)] = 511159,
  [SMALL_STATE(13293)] = 511181,
  [SMALL_STATE(13294)] = 511201,
  [SMALL_STATE(13295)] = 511221,
  [SMALL_STATE(13296)] = 511241,
  [SMALL_STATE(13297)] = 511263,
  [SMALL_STATE(13298)] = 511291,
  [SMALL_STATE(13299)] = 511329,
  [SMALL_STATE(13300)] = 511351,
  [SMALL_STATE(13301)] = 511373,
  [SMALL_STATE(13302)] = 511393,
  [SMALL_STATE(13303)] = 511415,
  [SMALL_STATE(13304)] = 511435,
  [SMALL_STATE(13305)] = 511473,
  [SMALL_STATE(13306)] = 511493,
  [SMALL_STATE(13307)] = 511515,
  [SMALL_STATE(13308)] = 511535,
  [SMALL_STATE(13309)] = 511557,
  [SMALL_STATE(13310)] = 511579,
  [SMALL_STATE(13311)] = 511599,
  [SMALL_STATE(13312)] = 511621,
  [SMALL_STATE(13313)] = 511643,
  [SMALL_STATE(13314)] = 511663,
  [SMALL_STATE(13315)] = 511685,
  [SMALL_STATE(13316)] = 511705,
  [SMALL_STATE(13317)] = 511727,
  [SMALL_STATE(13318)] = 511747,
  [SMALL_STATE(13319)] = 511769,
  [SMALL_STATE(13320)] = 511789,
  [SMALL_STATE(13321)] = 511811,
  [SMALL_STATE(13322)] = 511833,
  [SMALL_STATE(13323)] = 511855,
  [SMALL_STATE(13324)] = 511893,
  [SMALL_STATE(13325)] = 511913,
  [SMALL_STATE(13326)] = 511935,
  [SMALL_STATE(13327)] = 511955,
  [SMALL_STATE(13328)] = 511975,
  [SMALL_STATE(13329)] = 511997,
  [SMALL_STATE(13330)] = 512017,
  [SMALL_STATE(13331)] = 512037,
  [SMALL_STATE(13332)] = 512057,
  [SMALL_STATE(13333)] = 512077,
  [SMALL_STATE(13334)] = 512099,
  [SMALL_STATE(13335)] = 512121,
  [SMALL_STATE(13336)] = 512143,
  [SMALL_STATE(13337)] = 512163,
  [SMALL_STATE(13338)] = 512185,
  [SMALL_STATE(13339)] = 512223,
  [SMALL_STATE(13340)] = 512243,
  [SMALL_STATE(13341)] = 512265,
  [SMALL_STATE(13342)] = 512285,
  [SMALL_STATE(13343)] = 512317,
  [SMALL_STATE(13344)] = 512337,
  [SMALL_STATE(13345)] = 512357,
  [SMALL_STATE(13346)] = 512377,
  [SMALL_STATE(13347)] = 512415,
  [SMALL_STATE(13348)] = 512437,
  [SMALL_STATE(13349)] = 512475,
  [SMALL_STATE(13350)] = 512513,
  [SMALL_STATE(13351)] = 512533,
  [SMALL_STATE(13352)] = 512561,
  [SMALL_STATE(13353)] = 512581,
  [SMALL_STATE(13354)] = 512611,
  [SMALL_STATE(13355)] = 512631,
  [SMALL_STATE(13356)] = 512653,
  [SMALL_STATE(13357)] = 512691,
  [SMALL_STATE(13358)] = 512719,
  [SMALL_STATE(13359)] = 512739,
  [SMALL_STATE(13360)] = 512759,
  [SMALL_STATE(13361)] = 512797,
  [SMALL_STATE(13362)] = 512817,
  [SMALL_STATE(13363)] = 512837,
  [SMALL_STATE(13364)] = 512859,
  [SMALL_STATE(13365)] = 512881,
  [SMALL_STATE(13366)] = 512901,
  [SMALL_STATE(13367)] = 512923,
  [SMALL_STATE(13368)] = 512943,
  [SMALL_STATE(13369)] = 512965,
  [SMALL_STATE(13370)] = 512987,
  [SMALL_STATE(13371)] = 513011,
  [SMALL_STATE(13372)] = 513041,
  [SMALL_STATE(13373)] = 513063,
  [SMALL_STATE(13374)] = 513083,
  [SMALL_STATE(13375)] = 513103,
  [SMALL_STATE(13376)] = 513131,
  [SMALL_STATE(13377)] = 513153,
  [SMALL_STATE(13378)] = 513173,
  [SMALL_STATE(13379)] = 513195,
  [SMALL_STATE(13380)] = 513217,
  [SMALL_STATE(13381)] = 513239,
  [SMALL_STATE(13382)] = 513261,
  [SMALL_STATE(13383)] = 513281,
  [SMALL_STATE(13384)] = 513313,
  [SMALL_STATE(13385)] = 513335,
  [SMALL_STATE(13386)] = 513357,
  [SMALL_STATE(13387)] = 513377,
  [SMALL_STATE(13388)] = 513399,
  [SMALL_STATE(13389)] = 513421,
  [SMALL_STATE(13390)] = 513449,
  [SMALL_STATE(13391)] = 513469,
  [SMALL_STATE(13392)] = 513491,
  [SMALL_STATE(13393)] = 513529,
  [SMALL_STATE(13394)] = 513551,
  [SMALL_STATE(13395)] = 513589,
  [SMALL_STATE(13396)] = 513627,
  [SMALL_STATE(13397)] = 513647,
  [SMALL_STATE(13398)] = 513671,
  [SMALL_STATE(13399)] = 513693,
  [SMALL_STATE(13400)] = 513731,
  [SMALL_STATE(13401)] = 513753,
  [SMALL_STATE(13402)] = 513775,
  [SMALL_STATE(13403)] = 513795,
  [SMALL_STATE(13404)] = 513817,
  [SMALL_STATE(13405)] = 513839,
  [SMALL_STATE(13406)] = 513859,
  [SMALL_STATE(13407)] = 513881,
  [SMALL_STATE(13408)] = 513919,
  [SMALL_STATE(13409)] = 513947,
  [SMALL_STATE(13410)] = 513969,
  [SMALL_STATE(13411)] = 513989,
  [SMALL_STATE(13412)] = 514009,
  [SMALL_STATE(13413)] = 514039,
  [SMALL_STATE(13414)] = 514071,
  [SMALL_STATE(13415)] = 514093,
  [SMALL_STATE(13416)] = 514113,
  [SMALL_STATE(13417)] = 514133,
  [SMALL_STATE(13418)] = 514153,
  [SMALL_STATE(13419)] = 514173,
  [SMALL_STATE(13420)] = 514201,
  [SMALL_STATE(13421)] = 514221,
  [SMALL_STATE(13422)] = 514243,
  [SMALL_STATE(13423)] = 514265,
  [SMALL_STATE(13424)] = 514285,
  [SMALL_STATE(13425)] = 514305,
  [SMALL_STATE(13426)] = 514327,
  [SMALL_STATE(13427)] = 514365,
  [SMALL_STATE(13428)] = 514385,
  [SMALL_STATE(13429)] = 514413,
  [SMALL_STATE(13430)] = 514453,
  [SMALL_STATE(13431)] = 514491,
  [SMALL_STATE(13432)] = 514521,
  [SMALL_STATE(13433)] = 514543,
  [SMALL_STATE(13434)] = 514565,
  [SMALL_STATE(13435)] = 514587,
  [SMALL_STATE(13436)] = 514607,
  [SMALL_STATE(13437)] = 514627,
  [SMALL_STATE(13438)] = 514649,
  [SMALL_STATE(13439)] = 514669,
  [SMALL_STATE(13440)] = 514701,
  [SMALL_STATE(13441)] = 514721,
  [SMALL_STATE(13442)] = 514749,
  [SMALL_STATE(13443)] = 514787,
  [SMALL_STATE(13444)] = 514807,
  [SMALL_STATE(13445)] = 514827,
  [SMALL_STATE(13446)] = 514849,
  [SMALL_STATE(13447)] = 514869,
  [SMALL_STATE(13448)] = 514907,
  [SMALL_STATE(13449)] = 514929,
  [SMALL_STATE(13450)] = 514959,
  [SMALL_STATE(13451)] = 514979,
  [SMALL_STATE(13452)] = 515001,
  [SMALL_STATE(13453)] = 515021,
  [SMALL_STATE(13454)] = 515043,
  [SMALL_STATE(13455)] = 515065,
  [SMALL_STATE(13456)] = 515087,
  [SMALL_STATE(13457)] = 515117,
  [SMALL_STATE(13458)] = 515155,
  [SMALL_STATE(13459)] = 515189,
  [SMALL_STATE(13460)] = 515209,
  [SMALL_STATE(13461)] = 515229,
  [SMALL_STATE(13462)] = 515249,
  [SMALL_STATE(13463)] = 515271,
  [SMALL_STATE(13464)] = 515293,
  [SMALL_STATE(13465)] = 515313,
  [SMALL_STATE(13466)] = 515347,
  [SMALL_STATE(13467)] = 515367,
  [SMALL_STATE(13468)] = 515387,
  [SMALL_STATE(13469)] = 515419,
  [SMALL_STATE(13470)] = 515439,
  [SMALL_STATE(13471)] = 515461,
  [SMALL_STATE(13472)] = 515483,
  [SMALL_STATE(13473)] = 515503,
  [SMALL_STATE(13474)] = 515533,
  [SMALL_STATE(13475)] = 515561,
  [SMALL_STATE(13476)] = 515599,
  [SMALL_STATE(13477)] = 515637,
  [SMALL_STATE(13478)] = 515675,
  [SMALL_STATE(13479)] = 515695,
  [SMALL_STATE(13480)] = 515733,
  [SMALL_STATE(13481)] = 515753,
  [SMALL_STATE(13482)] = 515775,
  [SMALL_STATE(13483)] = 515795,
  [SMALL_STATE(13484)] = 515815,
  [SMALL_STATE(13485)] = 515855,
  [SMALL_STATE(13486)] = 515875,
  [SMALL_STATE(13487)] = 515895,
  [SMALL_STATE(13488)] = 515915,
  [SMALL_STATE(13489)] = 515935,
  [SMALL_STATE(13490)] = 515957,
  [SMALL_STATE(13491)] = 515979,
  [SMALL_STATE(13492)] = 515999,
  [SMALL_STATE(13493)] = 516021,
  [SMALL_STATE(13494)] = 516043,
  [SMALL_STATE(13495)] = 516063,
  [SMALL_STATE(13496)] = 516095,
  [SMALL_STATE(13497)] = 516115,
  [SMALL_STATE(13498)] = 516135,
  [SMALL_STATE(13499)] = 516155,
  [SMALL_STATE(13500)] = 516179,
  [SMALL_STATE(13501)] = 516217,
  [SMALL_STATE(13502)] = 516237,
  [SMALL_STATE(13503)] = 516259,
  [SMALL_STATE(13504)] = 516279,
  [SMALL_STATE(13505)] = 516299,
  [SMALL_STATE(13506)] = 516321,
  [SMALL_STATE(13507)] = 516341,
  [SMALL_STATE(13508)] = 516363,
  [SMALL_STATE(13509)] = 516383,
  [SMALL_STATE(13510)] = 516403,
  [SMALL_STATE(13511)] = 516423,
  [SMALL_STATE(13512)] = 516461,
  [SMALL_STATE(13513)] = 516483,
  [SMALL_STATE(13514)] = 516505,
  [SMALL_STATE(13515)] = 516527,
  [SMALL_STATE(13516)] = 516549,
  [SMALL_STATE(13517)] = 516571,
  [SMALL_STATE(13518)] = 516591,
  [SMALL_STATE(13519)] = 516611,
  [SMALL_STATE(13520)] = 516633,
  [SMALL_STATE(13521)] = 516661,
  [SMALL_STATE(13522)] = 516683,
  [SMALL_STATE(13523)] = 516705,
  [SMALL_STATE(13524)] = 516725,
  [SMALL_STATE(13525)] = 516747,
  [SMALL_STATE(13526)] = 516769,
  [SMALL_STATE(13527)] = 516791,
  [SMALL_STATE(13528)] = 516813,
  [SMALL_STATE(13529)] = 516843,
  [SMALL_STATE(13530)] = 516863,
  [SMALL_STATE(13531)] = 516883,
  [SMALL_STATE(13532)] = 516903,
  [SMALL_STATE(13533)] = 516923,
  [SMALL_STATE(13534)] = 516957,
  [SMALL_STATE(13535)] = 516979,
  [SMALL_STATE(13536)] = 516999,
  [SMALL_STATE(13537)] = 517019,
  [SMALL_STATE(13538)] = 517041,
  [SMALL_STATE(13539)] = 517065,
  [SMALL_STATE(13540)] = 517085,
  [SMALL_STATE(13541)] = 517107,
  [SMALL_STATE(13542)] = 517129,
  [SMALL_STATE(13543)] = 517151,
  [SMALL_STATE(13544)] = 517173,
  [SMALL_STATE(13545)] = 517193,
  [SMALL_STATE(13546)] = 517213,
  [SMALL_STATE(13547)] = 517235,
  [SMALL_STATE(13548)] = 517257,
  [SMALL_STATE(13549)] = 517295,
  [SMALL_STATE(13550)] = 517315,
  [SMALL_STATE(13551)] = 517337,
  [SMALL_STATE(13552)] = 517359,
  [SMALL_STATE(13553)] = 517379,
  [SMALL_STATE(13554)] = 517401,
  [SMALL_STATE(13555)] = 517423,
  [SMALL_STATE(13556)] = 517461,
  [SMALL_STATE(13557)] = 517481,
  [SMALL_STATE(13558)] = 517501,
  [SMALL_STATE(13559)] = 517523,
  [SMALL_STATE(13560)] = 517543,
  [SMALL_STATE(13561)] = 517565,
  [SMALL_STATE(13562)] = 517587,
  [SMALL_STATE(13563)] = 517607,
  [SMALL_STATE(13564)] = 517629,
  [SMALL_STATE(13565)] = 517649,
  [SMALL_STATE(13566)] = 517684,
  [SMALL_STATE(13567)] = 517703,
  [SMALL_STATE(13568)] = 517736,
  [SMALL_STATE(13569)] = 517755,
  [SMALL_STATE(13570)] = 517790,
  [SMALL_STATE(13571)] = 517809,
  [SMALL_STATE(13572)] = 517844,
  [SMALL_STATE(13573)] = 517865,
  [SMALL_STATE(13574)] = 517886,
  [SMALL_STATE(13575)] = 517905,
  [SMALL_STATE(13576)] = 517926,
  [SMALL_STATE(13577)] = 517959,
  [SMALL_STATE(13578)] = 517994,
  [SMALL_STATE(13579)] = 518013,
  [SMALL_STATE(13580)] = 518040,
  [SMALL_STATE(13581)] = 518061,
  [SMALL_STATE(13582)] = 518080,
  [SMALL_STATE(13583)] = 518113,
  [SMALL_STATE(13584)] = 518148,
  [SMALL_STATE(13585)] = 518175,
  [SMALL_STATE(13586)] = 518194,
  [SMALL_STATE(13587)] = 518213,
  [SMALL_STATE(13588)] = 518234,
  [SMALL_STATE(13589)] = 518267,
  [SMALL_STATE(13590)] = 518294,
  [SMALL_STATE(13591)] = 518313,
  [SMALL_STATE(13592)] = 518332,
  [SMALL_STATE(13593)] = 518351,
  [SMALL_STATE(13594)] = 518384,
  [SMALL_STATE(13595)] = 518417,
  [SMALL_STATE(13596)] = 518436,
  [SMALL_STATE(13597)] = 518471,
  [SMALL_STATE(13598)] = 518490,
  [SMALL_STATE(13599)] = 518517,
  [SMALL_STATE(13600)] = 518538,
  [SMALL_STATE(13601)] = 518571,
  [SMALL_STATE(13602)] = 518592,
  [SMALL_STATE(13603)] = 518611,
  [SMALL_STATE(13604)] = 518630,
  [SMALL_STATE(13605)] = 518649,
  [SMALL_STATE(13606)] = 518668,
  [SMALL_STATE(13607)] = 518687,
  [SMALL_STATE(13608)] = 518706,
  [SMALL_STATE(13609)] = 518727,
  [SMALL_STATE(13610)] = 518746,
  [SMALL_STATE(13611)] = 518765,
  [SMALL_STATE(13612)] = 518784,
  [SMALL_STATE(13613)] = 518803,
  [SMALL_STATE(13614)] = 518838,
  [SMALL_STATE(13615)] = 518857,
  [SMALL_STATE(13616)] = 518892,
  [SMALL_STATE(13617)] = 518925,
  [SMALL_STATE(13618)] = 518960,
  [SMALL_STATE(13619)] = 518979,
  [SMALL_STATE(13620)] = 519006,
  [SMALL_STATE(13621)] = 519025,
  [SMALL_STATE(13622)] = 519054,
  [SMALL_STATE(13623)] = 519073,
  [SMALL_STATE(13624)] = 519094,
  [SMALL_STATE(13625)] = 519113,
  [SMALL_STATE(13626)] = 519132,
  [SMALL_STATE(13627)] = 519151,
  [SMALL_STATE(13628)] = 519170,
  [SMALL_STATE(13629)] = 519189,
  [SMALL_STATE(13630)] = 519208,
  [SMALL_STATE(13631)] = 519227,
  [SMALL_STATE(13632)] = 519246,
  [SMALL_STATE(13633)] = 519265,
  [SMALL_STATE(13634)] = 519284,
  [SMALL_STATE(13635)] = 519303,
  [SMALL_STATE(13636)] = 519330,
  [SMALL_STATE(13637)] = 519363,
  [SMALL_STATE(13638)] = 519390,
  [SMALL_STATE(13639)] = 519409,
  [SMALL_STATE(13640)] = 519434,
  [SMALL_STATE(13641)] = 519453,
  [SMALL_STATE(13642)] = 519472,
  [SMALL_STATE(13643)] = 519495,
  [SMALL_STATE(13644)] = 519530,
  [SMALL_STATE(13645)] = 519565,
  [SMALL_STATE(13646)] = 519592,
  [SMALL_STATE(13647)] = 519611,
  [SMALL_STATE(13648)] = 519630,
  [SMALL_STATE(13649)] = 519665,
  [SMALL_STATE(13650)] = 519684,
  [SMALL_STATE(13651)] = 519703,
  [SMALL_STATE(13652)] = 519722,
  [SMALL_STATE(13653)] = 519741,
  [SMALL_STATE(13654)] = 519774,
  [SMALL_STATE(13655)] = 519799,
  [SMALL_STATE(13656)] = 519818,
  [SMALL_STATE(13657)] = 519853,
  [SMALL_STATE(13658)] = 519886,
  [SMALL_STATE(13659)] = 519907,
  [SMALL_STATE(13660)] = 519942,
  [SMALL_STATE(13661)] = 519961,
  [SMALL_STATE(13662)] = 519982,
  [SMALL_STATE(13663)] = 520003,
  [SMALL_STATE(13664)] = 520038,
  [SMALL_STATE(13665)] = 520057,
  [SMALL_STATE(13666)] = 520076,
  [SMALL_STATE(13667)] = 520095,
  [SMALL_STATE(13668)] = 520122,
  [SMALL_STATE(13669)] = 520141,
  [SMALL_STATE(13670)] = 520160,
  [SMALL_STATE(13671)] = 520193,
  [SMALL_STATE(13672)] = 520228,
  [SMALL_STATE(13673)] = 520261,
  [SMALL_STATE(13674)] = 520282,
  [SMALL_STATE(13675)] = 520317,
  [SMALL_STATE(13676)] = 520336,
  [SMALL_STATE(13677)] = 520355,
  [SMALL_STATE(13678)] = 520388,
  [SMALL_STATE(13679)] = 520423,
  [SMALL_STATE(13680)] = 520442,
  [SMALL_STATE(13681)] = 520461,
  [SMALL_STATE(13682)] = 520480,
  [SMALL_STATE(13683)] = 520499,
  [SMALL_STATE(13684)] = 520518,
  [SMALL_STATE(13685)] = 520537,
  [SMALL_STATE(13686)] = 520556,
  [SMALL_STATE(13687)] = 520581,
  [SMALL_STATE(13688)] = 520616,
  [SMALL_STATE(13689)] = 520651,
  [SMALL_STATE(13690)] = 520670,
  [SMALL_STATE(13691)] = 520703,
  [SMALL_STATE(13692)] = 520728,
  [SMALL_STATE(13693)] = 520761,
  [SMALL_STATE(13694)] = 520794,
  [SMALL_STATE(13695)] = 520829,
  [SMALL_STATE(13696)] = 520854,
  [SMALL_STATE(13697)] = 520873,
  [SMALL_STATE(13698)] = 520892,
  [SMALL_STATE(13699)] = 520927,
  [SMALL_STATE(13700)] = 520946,
  [SMALL_STATE(13701)] = 520975,
  [SMALL_STATE(13702)] = 521008,
  [SMALL_STATE(13703)] = 521027,
  [SMALL_STATE(13704)] = 521046,
  [SMALL_STATE(13705)] = 521065,
  [SMALL_STATE(13706)] = 521100,
  [SMALL_STATE(13707)] = 521121,
  [SMALL_STATE(13708)] = 521154,
  [SMALL_STATE(13709)] = 521175,
  [SMALL_STATE(13710)] = 521210,
  [SMALL_STATE(13711)] = 521243,
  [SMALL_STATE(13712)] = 521276,
  [SMALL_STATE(13713)] = 521295,
  [SMALL_STATE(13714)] = 521328,
  [SMALL_STATE(13715)] = 521361,
  [SMALL_STATE(13716)] = 521380,
  [SMALL_STATE(13717)] = 521415,
  [SMALL_STATE(13718)] = 521448,
  [SMALL_STATE(13719)] = 521467,
  [SMALL_STATE(13720)] = 521488,
  [SMALL_STATE(13721)] = 521523,
  [SMALL_STATE(13722)] = 521542,
  [SMALL_STATE(13723)] = 521573,
  [SMALL_STATE(13724)] = 521594,
  [SMALL_STATE(13725)] = 521613,
  [SMALL_STATE(13726)] = 521648,
  [SMALL_STATE(13727)] = 521681,
  [SMALL_STATE(13728)] = 521716,
  [SMALL_STATE(13729)] = 521751,
  [SMALL_STATE(13730)] = 521786,
  [SMALL_STATE(13731)] = 521819,
  [SMALL_STATE(13732)] = 521852,
  [SMALL_STATE(13733)] = 521871,
  [SMALL_STATE(13734)] = 521892,
  [SMALL_STATE(13735)] = 521913,
  [SMALL_STATE(13736)] = 521938,
  [SMALL_STATE(13737)] = 521957,
  [SMALL_STATE(13738)] = 521992,
  [SMALL_STATE(13739)] = 522011,
  [SMALL_STATE(13740)] = 522044,
  [SMALL_STATE(13741)] = 522065,
  [SMALL_STATE(13742)] = 522100,
  [SMALL_STATE(13743)] = 522135,
  [SMALL_STATE(13744)] = 522154,
  [SMALL_STATE(13745)] = 522175,
  [SMALL_STATE(13746)] = 522194,
  [SMALL_STATE(13747)] = 522219,
  [SMALL_STATE(13748)] = 522238,
  [SMALL_STATE(13749)] = 522271,
  [SMALL_STATE(13750)] = 522306,
  [SMALL_STATE(13751)] = 522327,
  [SMALL_STATE(13752)] = 522352,
  [SMALL_STATE(13753)] = 522371,
  [SMALL_STATE(13754)] = 522390,
  [SMALL_STATE(13755)] = 522409,
  [SMALL_STATE(13756)] = 522442,
  [SMALL_STATE(13757)] = 522461,
  [SMALL_STATE(13758)] = 522480,
  [SMALL_STATE(13759)] = 522499,
  [SMALL_STATE(13760)] = 522518,
  [SMALL_STATE(13761)] = 522553,
  [SMALL_STATE(13762)] = 522572,
  [SMALL_STATE(13763)] = 522601,
  [SMALL_STATE(13764)] = 522636,
  [SMALL_STATE(13765)] = 522665,
  [SMALL_STATE(13766)] = 522684,
  [SMALL_STATE(13767)] = 522703,
  [SMALL_STATE(13768)] = 522722,
  [SMALL_STATE(13769)] = 522741,
  [SMALL_STATE(13770)] = 522776,
  [SMALL_STATE(13771)] = 522811,
  [SMALL_STATE(13772)] = 522830,
  [SMALL_STATE(13773)] = 522851,
  [SMALL_STATE(13774)] = 522872,
  [SMALL_STATE(13775)] = 522905,
  [SMALL_STATE(13776)] = 522938,
  [SMALL_STATE(13777)] = 522971,
  [SMALL_STATE(13778)] = 523006,
  [SMALL_STATE(13779)] = 523025,
  [SMALL_STATE(13780)] = 523044,
  [SMALL_STATE(13781)] = 523079,
  [SMALL_STATE(13782)] = 523098,
  [SMALL_STATE(13783)] = 523133,
  [SMALL_STATE(13784)] = 523156,
  [SMALL_STATE(13785)] = 523189,
  [SMALL_STATE(13786)] = 523222,
  [SMALL_STATE(13787)] = 523243,
  [SMALL_STATE(13788)] = 523278,
  [SMALL_STATE(13789)] = 523297,
  [SMALL_STATE(13790)] = 523316,
  [SMALL_STATE(13791)] = 523337,
  [SMALL_STATE(13792)] = 523370,
  [SMALL_STATE(13793)] = 523403,
  [SMALL_STATE(13794)] = 523422,
  [SMALL_STATE(13795)] = 523457,
  [SMALL_STATE(13796)] = 523492,
  [SMALL_STATE(13797)] = 523513,
  [SMALL_STATE(13798)] = 523538,
  [SMALL_STATE(13799)] = 523559,
  [SMALL_STATE(13800)] = 523582,
  [SMALL_STATE(13801)] = 523609,
  [SMALL_STATE(13802)] = 523642,
  [SMALL_STATE(13803)] = 523677,
  [SMALL_STATE(13804)] = 523710,
  [SMALL_STATE(13805)] = 523731,
  [SMALL_STATE(13806)] = 523750,
  [SMALL_STATE(13807)] = 523769,
  [SMALL_STATE(13808)] = 523804,
  [SMALL_STATE(13809)] = 523837,
  [SMALL_STATE(13810)] = 523858,
  [SMALL_STATE(13811)] = 523877,
  [SMALL_STATE(13812)] = 523906,
  [SMALL_STATE(13813)] = 523941,
  [SMALL_STATE(13814)] = 523976,
  [SMALL_STATE(13815)] = 524009,
  [SMALL_STATE(13816)] = 524030,
  [SMALL_STATE(13817)] = 524051,
  [SMALL_STATE(13818)] = 524072,
  [SMALL_STATE(13819)] = 524101,
  [SMALL_STATE(13820)] = 524136,
  [SMALL_STATE(13821)] = 524157,
  [SMALL_STATE(13822)] = 524176,
  [SMALL_STATE(13823)] = 524195,
  [SMALL_STATE(13824)] = 524230,
  [SMALL_STATE(13825)] = 524263,
  [SMALL_STATE(13826)] = 524282,
  [SMALL_STATE(13827)] = 524303,
  [SMALL_STATE(13828)] = 524336,
  [SMALL_STATE(13829)] = 524371,
  [SMALL_STATE(13830)] = 524406,
  [SMALL_STATE(13831)] = 524441,
  [SMALL_STATE(13832)] = 524476,
  [SMALL_STATE(13833)] = 524509,
  [SMALL_STATE(13834)] = 524530,
  [SMALL_STATE(13835)] = 524557,
  [SMALL_STATE(13836)] = 524592,
  [SMALL_STATE(13837)] = 524613,
  [SMALL_STATE(13838)] = 524634,
  [SMALL_STATE(13839)] = 524653,
  [SMALL_STATE(13840)] = 524684,
  [SMALL_STATE(13841)] = 524705,
  [SMALL_STATE(13842)] = 524726,
  [SMALL_STATE(13843)] = 524747,
  [SMALL_STATE(13844)] = 524780,
  [SMALL_STATE(13845)] = 524811,
  [SMALL_STATE(13846)] = 524830,
  [SMALL_STATE(13847)] = 524865,
  [SMALL_STATE(13848)] = 524900,
  [SMALL_STATE(13849)] = 524931,
  [SMALL_STATE(13850)] = 524964,
  [SMALL_STATE(13851)] = 524983,
  [SMALL_STATE(13852)] = 525016,
  [SMALL_STATE(13853)] = 525035,
  [SMALL_STATE(13854)] = 525070,
  [SMALL_STATE(13855)] = 525105,
  [SMALL_STATE(13856)] = 525138,
  [SMALL_STATE(13857)] = 525157,
  [SMALL_STATE(13858)] = 525192,
  [SMALL_STATE(13859)] = 525227,
  [SMALL_STATE(13860)] = 525252,
  [SMALL_STATE(13861)] = 525287,
  [SMALL_STATE(13862)] = 525306,
  [SMALL_STATE(13863)] = 525341,
  [SMALL_STATE(13864)] = 525374,
  [SMALL_STATE(13865)] = 525409,
  [SMALL_STATE(13866)] = 525430,
  [SMALL_STATE(13867)] = 525465,
  [SMALL_STATE(13868)] = 525483,
  [SMALL_STATE(13869)] = 525503,
  [SMALL_STATE(13870)] = 525535,
  [SMALL_STATE(13871)] = 525567,
  [SMALL_STATE(13872)] = 525589,
  [SMALL_STATE(13873)] = 525621,
  [SMALL_STATE(13874)] = 525643,
  [SMALL_STATE(13875)] = 525675,
  [SMALL_STATE(13876)] = 525697,
  [SMALL_STATE(13877)] = 525731,
  [SMALL_STATE(13878)] = 525749,
  [SMALL_STATE(13879)] = 525767,
  [SMALL_STATE(13880)] = 525785,
  [SMALL_STATE(13881)] = 525819,
  [SMALL_STATE(13882)] = 525837,
  [SMALL_STATE(13883)] = 525855,
  [SMALL_STATE(13884)] = 525887,
  [SMALL_STATE(13885)] = 525905,
  [SMALL_STATE(13886)] = 525927,
  [SMALL_STATE(13887)] = 525945,
  [SMALL_STATE(13888)] = 525963,
  [SMALL_STATE(13889)] = 525983,
  [SMALL_STATE(13890)] = 526007,
  [SMALL_STATE(13891)] = 526025,
  [SMALL_STATE(13892)] = 526043,
  [SMALL_STATE(13893)] = 526075,
  [SMALL_STATE(13894)] = 526107,
  [SMALL_STATE(13895)] = 526139,
  [SMALL_STATE(13896)] = 526159,
  [SMALL_STATE(13897)] = 526181,
  [SMALL_STATE(13898)] = 526199,
  [SMALL_STATE(13899)] = 526227,
  [SMALL_STATE(13900)] = 526259,
  [SMALL_STATE(13901)] = 526277,
  [SMALL_STATE(13902)] = 526309,
  [SMALL_STATE(13903)] = 526341,
  [SMALL_STATE(13904)] = 526365,
  [SMALL_STATE(13905)] = 526383,
  [SMALL_STATE(13906)] = 526415,
  [SMALL_STATE(13907)] = 526433,
  [SMALL_STATE(13908)] = 526455,
  [SMALL_STATE(13909)] = 526477,
  [SMALL_STATE(13910)] = 526503,
  [SMALL_STATE(13911)] = 526535,
  [SMALL_STATE(13912)] = 526557,
  [SMALL_STATE(13913)] = 526575,
  [SMALL_STATE(13914)] = 526607,
  [SMALL_STATE(13915)] = 526625,
  [SMALL_STATE(13916)] = 526659,
  [SMALL_STATE(13917)] = 526677,
  [SMALL_STATE(13918)] = 526699,
  [SMALL_STATE(13919)] = 526717,
  [SMALL_STATE(13920)] = 526739,
  [SMALL_STATE(13921)] = 526769,
  [SMALL_STATE(13922)] = 526801,
  [SMALL_STATE(13923)] = 526821,
  [SMALL_STATE(13924)] = 526853,
  [SMALL_STATE(13925)] = 526885,
  [SMALL_STATE(13926)] = 526917,
  [SMALL_STATE(13927)] = 526937,
  [SMALL_STATE(13928)] = 526969,
  [SMALL_STATE(13929)] = 526987,
  [SMALL_STATE(13930)] = 527005,
  [SMALL_STATE(13931)] = 527025,
  [SMALL_STATE(13932)] = 527049,
  [SMALL_STATE(13933)] = 527067,
  [SMALL_STATE(13934)] = 527085,
  [SMALL_STATE(13935)] = 527103,
  [SMALL_STATE(13936)] = 527125,
  [SMALL_STATE(13937)] = 527157,
  [SMALL_STATE(13938)] = 527179,
  [SMALL_STATE(13939)] = 527201,
  [SMALL_STATE(13940)] = 527219,
  [SMALL_STATE(13941)] = 527251,
  [SMALL_STATE(13942)] = 527283,
  [SMALL_STATE(13943)] = 527315,
  [SMALL_STATE(13944)] = 527333,
  [SMALL_STATE(13945)] = 527351,
  [SMALL_STATE(13946)] = 527383,
  [SMALL_STATE(13947)] = 527401,
  [SMALL_STATE(13948)] = 527431,
  [SMALL_STATE(13949)] = 527463,
  [SMALL_STATE(13950)] = 527481,
  [SMALL_STATE(13951)] = 527499,
  [SMALL_STATE(13952)] = 527531,
  [SMALL_STATE(13953)] = 527549,
  [SMALL_STATE(13954)] = 527581,
  [SMALL_STATE(13955)] = 527613,
  [SMALL_STATE(13956)] = 527633,
  [SMALL_STATE(13957)] = 527651,
  [SMALL_STATE(13958)] = 527685,
  [SMALL_STATE(13959)] = 527703,
  [SMALL_STATE(13960)] = 527721,
  [SMALL_STATE(13961)] = 527739,
  [SMALL_STATE(13962)] = 527757,
  [SMALL_STATE(13963)] = 527775,
  [SMALL_STATE(13964)] = 527797,
  [SMALL_STATE(13965)] = 527829,
  [SMALL_STATE(13966)] = 527861,
  [SMALL_STATE(13967)] = 527879,
  [SMALL_STATE(13968)] = 527911,
  [SMALL_STATE(13969)] = 527933,
  [SMALL_STATE(13970)] = 527951,
  [SMALL_STATE(13971)] = 527969,
  [SMALL_STATE(13972)] = 527989,
  [SMALL_STATE(13973)] = 528007,
  [SMALL_STATE(13974)] = 528033,
  [SMALL_STATE(13975)] = 528057,
  [SMALL_STATE(13976)] = 528089,
  [SMALL_STATE(13977)] = 528109,
  [SMALL_STATE(13978)] = 528131,
  [SMALL_STATE(13979)] = 528163,
  [SMALL_STATE(13980)] = 528195,
  [SMALL_STATE(13981)] = 528227,
  [SMALL_STATE(13982)] = 528259,
  [SMALL_STATE(13983)] = 528279,
  [SMALL_STATE(13984)] = 528297,
  [SMALL_STATE(13985)] = 528317,
  [SMALL_STATE(13986)] = 528349,
  [SMALL_STATE(13987)] = 528369,
  [SMALL_STATE(13988)] = 528387,
  [SMALL_STATE(13989)] = 528405,
  [SMALL_STATE(13990)] = 528435,
  [SMALL_STATE(13991)] = 528467,
  [SMALL_STATE(13992)] = 528485,
  [SMALL_STATE(13993)] = 528517,
  [SMALL_STATE(13994)] = 528535,
  [SMALL_STATE(13995)] = 528553,
  [SMALL_STATE(13996)] = 528575,
  [SMALL_STATE(13997)] = 528593,
  [SMALL_STATE(13998)] = 528625,
  [SMALL_STATE(13999)] = 528657,
  [SMALL_STATE(14000)] = 528675,
  [SMALL_STATE(14001)] = 528693,
  [SMALL_STATE(14002)] = 528711,
  [SMALL_STATE(14003)] = 528743,
  [SMALL_STATE(14004)] = 528761,
  [SMALL_STATE(14005)] = 528779,
  [SMALL_STATE(14006)] = 528803,
  [SMALL_STATE(14007)] = 528823,
  [SMALL_STATE(14008)] = 528855,
  [SMALL_STATE(14009)] = 528887,
  [SMALL_STATE(14010)] = 528905,
  [SMALL_STATE(14011)] = 528923,
  [SMALL_STATE(14012)] = 528945,
  [SMALL_STATE(14013)] = 528977,
  [SMALL_STATE(14014)] = 529001,
  [SMALL_STATE(14015)] = 529021,
  [SMALL_STATE(14016)] = 529045,
  [SMALL_STATE(14017)] = 529065,
  [SMALL_STATE(14018)] = 529097,
  [SMALL_STATE(14019)] = 529119,
  [SMALL_STATE(14020)] = 529137,
  [SMALL_STATE(14021)] = 529169,
  [SMALL_STATE(14022)] = 529191,
  [SMALL_STATE(14023)] = 529223,
  [SMALL_STATE(14024)] = 529255,
  [SMALL_STATE(14025)] = 529287,
  [SMALL_STATE(14026)] = 529307,
  [SMALL_STATE(14027)] = 529325,
  [SMALL_STATE(14028)] = 529357,
  [SMALL_STATE(14029)] = 529375,
  [SMALL_STATE(14030)] = 529393,
  [SMALL_STATE(14031)] = 529411,
  [SMALL_STATE(14032)] = 529443,
  [SMALL_STATE(14033)] = 529475,
  [SMALL_STATE(14034)] = 529493,
  [SMALL_STATE(14035)] = 529511,
  [SMALL_STATE(14036)] = 529529,
  [SMALL_STATE(14037)] = 529547,
  [SMALL_STATE(14038)] = 529567,
  [SMALL_STATE(14039)] = 529587,
  [SMALL_STATE(14040)] = 529609,
  [SMALL_STATE(14041)] = 529627,
  [SMALL_STATE(14042)] = 529649,
  [SMALL_STATE(14043)] = 529667,
  [SMALL_STATE(14044)] = 529685,
  [SMALL_STATE(14045)] = 529703,
  [SMALL_STATE(14046)] = 529721,
  [SMALL_STATE(14047)] = 529743,
  [SMALL_STATE(14048)] = 529761,
  [SMALL_STATE(14049)] = 529779,
  [SMALL_STATE(14050)] = 529799,
  [SMALL_STATE(14051)] = 529831,
  [SMALL_STATE(14052)] = 529855,
  [SMALL_STATE(14053)] = 529879,
  [SMALL_STATE(14054)] = 529897,
  [SMALL_STATE(14055)] = 529915,
  [SMALL_STATE(14056)] = 529947,
  [SMALL_STATE(14057)] = 529965,
  [SMALL_STATE(14058)] = 529985,
  [SMALL_STATE(14059)] = 530017,
  [SMALL_STATE(14060)] = 530039,
  [SMALL_STATE(14061)] = 530063,
  [SMALL_STATE(14062)] = 530081,
  [SMALL_STATE(14063)] = 530113,
  [SMALL_STATE(14064)] = 530135,
  [SMALL_STATE(14065)] = 530155,
  [SMALL_STATE(14066)] = 530187,
  [SMALL_STATE(14067)] = 530221,
  [SMALL_STATE(14068)] = 530253,
  [SMALL_STATE(14069)] = 530271,
  [SMALL_STATE(14070)] = 530303,
  [SMALL_STATE(14071)] = 530335,
  [SMALL_STATE(14072)] = 530367,
  [SMALL_STATE(14073)] = 530399,
  [SMALL_STATE(14074)] = 530417,
  [SMALL_STATE(14075)] = 530449,
  [SMALL_STATE(14076)] = 530481,
  [SMALL_STATE(14077)] = 530499,
  [SMALL_STATE(14078)] = 530517,
  [SMALL_STATE(14079)] = 530549,
  [SMALL_STATE(14080)] = 530569,
  [SMALL_STATE(14081)] = 530587,
  [SMALL_STATE(14082)] = 530619,
  [SMALL_STATE(14083)] = 530641,
  [SMALL_STATE(14084)] = 530661,
  [SMALL_STATE(14085)] = 530679,
  [SMALL_STATE(14086)] = 530711,
  [SMALL_STATE(14087)] = 530743,
  [SMALL_STATE(14088)] = 530761,
  [SMALL_STATE(14089)] = 530783,
  [SMALL_STATE(14090)] = 530801,
  [SMALL_STATE(14091)] = 530833,
  [SMALL_STATE(14092)] = 530851,
  [SMALL_STATE(14093)] = 530883,
  [SMALL_STATE(14094)] = 530915,
  [SMALL_STATE(14095)] = 530937,
  [SMALL_STATE(14096)] = 530955,
  [SMALL_STATE(14097)] = 530987,
  [SMALL_STATE(14098)] = 531005,
  [SMALL_STATE(14099)] = 531037,
  [SMALL_STATE(14100)] = 531057,
  [SMALL_STATE(14101)] = 531085,
  [SMALL_STATE(14102)] = 531117,
  [SMALL_STATE(14103)] = 531149,
  [SMALL_STATE(14104)] = 531181,
  [SMALL_STATE(14105)] = 531199,
  [SMALL_STATE(14106)] = 531223,
  [SMALL_STATE(14107)] = 531241,
  [SMALL_STATE(14108)] = 531259,
  [SMALL_STATE(14109)] = 531291,
  [SMALL_STATE(14110)] = 531325,
  [SMALL_STATE(14111)] = 531357,
  [SMALL_STATE(14112)] = 531379,
  [SMALL_STATE(14113)] = 531397,
  [SMALL_STATE(14114)] = 531429,
  [SMALL_STATE(14115)] = 531447,
  [SMALL_STATE(14116)] = 531469,
  [SMALL_STATE(14117)] = 531487,
  [SMALL_STATE(14118)] = 531505,
  [SMALL_STATE(14119)] = 531523,
  [SMALL_STATE(14120)] = 531541,
  [SMALL_STATE(14121)] = 531565,
  [SMALL_STATE(14122)] = 531583,
  [SMALL_STATE(14123)] = 531601,
  [SMALL_STATE(14124)] = 531627,
  [SMALL_STATE(14125)] = 531645,
  [SMALL_STATE(14126)] = 531663,
  [SMALL_STATE(14127)] = 531697,
  [SMALL_STATE(14128)] = 531729,
  [SMALL_STATE(14129)] = 531746,
  [SMALL_STATE(14130)] = 531765,
  [SMALL_STATE(14131)] = 531782,
  [SMALL_STATE(14132)] = 531799,
  [SMALL_STATE(14133)] = 531816,
  [SMALL_STATE(14134)] = 531833,
  [SMALL_STATE(14135)] = 531850,
  [SMALL_STATE(14136)] = 531869,
  [SMALL_STATE(14137)] = 531898,
  [SMALL_STATE(14138)] = 531917,
  [SMALL_STATE(14139)] = 531934,
  [SMALL_STATE(14140)] = 531963,
  [SMALL_STATE(14141)] = 531980,
  [SMALL_STATE(14142)] = 531997,
  [SMALL_STATE(14143)] = 532024,
  [SMALL_STATE(14144)] = 532053,
  [SMALL_STATE(14145)] = 532074,
  [SMALL_STATE(14146)] = 532095,
  [SMALL_STATE(14147)] = 532114,
  [SMALL_STATE(14148)] = 532143,
  [SMALL_STATE(14149)] = 532172,
  [SMALL_STATE(14150)] = 532189,
  [SMALL_STATE(14151)] = 532218,
  [SMALL_STATE(14152)] = 532247,
  [SMALL_STATE(14153)] = 532270,
  [SMALL_STATE(14154)] = 532289,
  [SMALL_STATE(14155)] = 532306,
  [SMALL_STATE(14156)] = 532335,
  [SMALL_STATE(14157)] = 532362,
  [SMALL_STATE(14158)] = 532391,
  [SMALL_STATE(14159)] = 532420,
  [SMALL_STATE(14160)] = 532449,
  [SMALL_STATE(14161)] = 532468,
  [SMALL_STATE(14162)] = 532497,
  [SMALL_STATE(14163)] = 532526,
  [SMALL_STATE(14164)] = 532545,
  [SMALL_STATE(14165)] = 532574,
  [SMALL_STATE(14166)] = 532593,
  [SMALL_STATE(14167)] = 532622,
  [SMALL_STATE(14168)] = 532639,
  [SMALL_STATE(14169)] = 532656,
  [SMALL_STATE(14170)] = 532685,
  [SMALL_STATE(14171)] = 532714,
  [SMALL_STATE(14172)] = 532733,
  [SMALL_STATE(14173)] = 532750,
  [SMALL_STATE(14174)] = 532767,
  [SMALL_STATE(14175)] = 532784,
  [SMALL_STATE(14176)] = 532813,
  [SMALL_STATE(14177)] = 532842,
  [SMALL_STATE(14178)] = 532871,
  [SMALL_STATE(14179)] = 532900,
  [SMALL_STATE(14180)] = 532927,
  [SMALL_STATE(14181)] = 532956,
  [SMALL_STATE(14182)] = 532973,
  [SMALL_STATE(14183)] = 532992,
  [SMALL_STATE(14184)] = 533011,
  [SMALL_STATE(14185)] = 533040,
  [SMALL_STATE(14186)] = 533061,
  [SMALL_STATE(14187)] = 533090,
  [SMALL_STATE(14188)] = 533119,
  [SMALL_STATE(14189)] = 533140,
  [SMALL_STATE(14190)] = 533163,
  [SMALL_STATE(14191)] = 533192,
  [SMALL_STATE(14192)] = 533221,
  [SMALL_STATE(14193)] = 533242,
  [SMALL_STATE(14194)] = 533269,
  [SMALL_STATE(14195)] = 533298,
  [SMALL_STATE(14196)] = 533327,
  [SMALL_STATE(14197)] = 533354,
  [SMALL_STATE(14198)] = 533383,
  [SMALL_STATE(14199)] = 533412,
  [SMALL_STATE(14200)] = 533435,
  [SMALL_STATE(14201)] = 533466,
  [SMALL_STATE(14202)] = 533485,
  [SMALL_STATE(14203)] = 533514,
  [SMALL_STATE(14204)] = 533533,
  [SMALL_STATE(14205)] = 533564,
  [SMALL_STATE(14206)] = 533593,
  [SMALL_STATE(14207)] = 533612,
  [SMALL_STATE(14208)] = 533641,
  [SMALL_STATE(14209)] = 533658,
  [SMALL_STATE(14210)] = 533675,
  [SMALL_STATE(14211)] = 533704,
  [SMALL_STATE(14212)] = 533733,
  [SMALL_STATE(14213)] = 533756,
  [SMALL_STATE(14214)] = 533785,
  [SMALL_STATE(14215)] = 533814,
  [SMALL_STATE(14216)] = 533841,
  [SMALL_STATE(14217)] = 533870,
  [SMALL_STATE(14218)] = 533887,
  [SMALL_STATE(14219)] = 533916,
  [SMALL_STATE(14220)] = 533945,
  [SMALL_STATE(14221)] = 533974,
  [SMALL_STATE(14222)] = 534003,
  [SMALL_STATE(14223)] = 534022,
  [SMALL_STATE(14224)] = 534039,
  [SMALL_STATE(14225)] = 534064,
  [SMALL_STATE(14226)] = 534081,
  [SMALL_STATE(14227)] = 534102,
  [SMALL_STATE(14228)] = 534131,
  [SMALL_STATE(14229)] = 534160,
  [SMALL_STATE(14230)] = 534189,
  [SMALL_STATE(14231)] = 534214,
  [SMALL_STATE(14232)] = 534241,
  [SMALL_STATE(14233)] = 534270,
  [SMALL_STATE(14234)] = 534299,
  [SMALL_STATE(14235)] = 534316,
  [SMALL_STATE(14236)] = 534345,
  [SMALL_STATE(14237)] = 534374,
  [SMALL_STATE(14238)] = 534403,
  [SMALL_STATE(14239)] = 534422,
  [SMALL_STATE(14240)] = 534449,
  [SMALL_STATE(14241)] = 534478,
  [SMALL_STATE(14242)] = 534507,
  [SMALL_STATE(14243)] = 534536,
  [SMALL_STATE(14244)] = 534553,
  [SMALL_STATE(14245)] = 534582,
  [SMALL_STATE(14246)] = 534611,
  [SMALL_STATE(14247)] = 534640,
  [SMALL_STATE(14248)] = 534657,
  [SMALL_STATE(14249)] = 534674,
  [SMALL_STATE(14250)] = 534703,
  [SMALL_STATE(14251)] = 534732,
  [SMALL_STATE(14252)] = 534749,
  [SMALL_STATE(14253)] = 534778,
  [SMALL_STATE(14254)] = 534807,
  [SMALL_STATE(14255)] = 534836,
  [SMALL_STATE(14256)] = 534865,
  [SMALL_STATE(14257)] = 534894,
  [SMALL_STATE(14258)] = 534923,
  [SMALL_STATE(14259)] = 534940,
  [SMALL_STATE(14260)] = 534957,
  [SMALL_STATE(14261)] = 534986,
  [SMALL_STATE(14262)] = 535009,
  [SMALL_STATE(14263)] = 535038,
  [SMALL_STATE(14264)] = 535067,
  [SMALL_STATE(14265)] = 535096,
  [SMALL_STATE(14266)] = 535115,
  [SMALL_STATE(14267)] = 535138,
  [SMALL_STATE(14268)] = 535155,
  [SMALL_STATE(14269)] = 535172,
  [SMALL_STATE(14270)] = 535201,
  [SMALL_STATE(14271)] = 535226,
  [SMALL_STATE(14272)] = 535255,
  [SMALL_STATE(14273)] = 535280,
  [SMALL_STATE(14274)] = 535299,
  [SMALL_STATE(14275)] = 535326,
  [SMALL_STATE(14276)] = 535345,
  [SMALL_STATE(14277)] = 535364,
  [SMALL_STATE(14278)] = 535393,
  [SMALL_STATE(14279)] = 535422,
  [SMALL_STATE(14280)] = 535443,
  [SMALL_STATE(14281)] = 535462,
  [SMALL_STATE(14282)] = 535489,
  [SMALL_STATE(14283)] = 535518,
  [SMALL_STATE(14284)] = 535547,
  [SMALL_STATE(14285)] = 535564,
  [SMALL_STATE(14286)] = 535593,
  [SMALL_STATE(14287)] = 535610,
  [SMALL_STATE(14288)] = 535631,
  [SMALL_STATE(14289)] = 535660,
  [SMALL_STATE(14290)] = 535689,
  [SMALL_STATE(14291)] = 535718,
  [SMALL_STATE(14292)] = 535747,
  [SMALL_STATE(14293)] = 535764,
  [SMALL_STATE(14294)] = 535791,
  [SMALL_STATE(14295)] = 535808,
  [SMALL_STATE(14296)] = 535825,
  [SMALL_STATE(14297)] = 535842,
  [SMALL_STATE(14298)] = 535871,
  [SMALL_STATE(14299)] = 535892,
  [SMALL_STATE(14300)] = 535909,
  [SMALL_STATE(14301)] = 535926,
  [SMALL_STATE(14302)] = 535947,
  [SMALL_STATE(14303)] = 535976,
  [SMALL_STATE(14304)] = 535997,
  [SMALL_STATE(14305)] = 536026,
  [SMALL_STATE(14306)] = 536043,
  [SMALL_STATE(14307)] = 536072,
  [SMALL_STATE(14308)] = 536101,
  [SMALL_STATE(14309)] = 536130,
  [SMALL_STATE(14310)] = 536159,
  [SMALL_STATE(14311)] = 536176,
  [SMALL_STATE(14312)] = 536199,
  [SMALL_STATE(14313)] = 536216,
  [SMALL_STATE(14314)] = 536235,
  [SMALL_STATE(14315)] = 536264,
  [SMALL_STATE(14316)] = 536293,
  [SMALL_STATE(14317)] = 536310,
  [SMALL_STATE(14318)] = 536329,
  [SMALL_STATE(14319)] = 536356,
  [SMALL_STATE(14320)] = 536375,
  [SMALL_STATE(14321)] = 536392,
  [SMALL_STATE(14322)] = 536409,
  [SMALL_STATE(14323)] = 536428,
  [SMALL_STATE(14324)] = 536445,
  [SMALL_STATE(14325)] = 536464,
  [SMALL_STATE(14326)] = 536493,
  [SMALL_STATE(14327)] = 536522,
  [SMALL_STATE(14328)] = 536551,
  [SMALL_STATE(14329)] = 536572,
  [SMALL_STATE(14330)] = 536601,
  [SMALL_STATE(14331)] = 536630,
  [SMALL_STATE(14332)] = 536659,
  [SMALL_STATE(14333)] = 536688,
  [SMALL_STATE(14334)] = 536711,
  [SMALL_STATE(14335)] = 536740,
  [SMALL_STATE(14336)] = 536769,
  [SMALL_STATE(14337)] = 536798,
  [SMALL_STATE(14338)] = 536827,
  [SMALL_STATE(14339)] = 536844,
  [SMALL_STATE(14340)] = 536873,
  [SMALL_STATE(14341)] = 536902,
  [SMALL_STATE(14342)] = 536931,
  [SMALL_STATE(14343)] = 536948,
  [SMALL_STATE(14344)] = 536977,
  [SMALL_STATE(14345)] = 536994,
  [SMALL_STATE(14346)] = 537023,
  [SMALL_STATE(14347)] = 537052,
  [SMALL_STATE(14348)] = 537081,
  [SMALL_STATE(14349)] = 537106,
  [SMALL_STATE(14350)] = 537135,
  [SMALL_STATE(14351)] = 537164,
  [SMALL_STATE(14352)] = 537193,
  [SMALL_STATE(14353)] = 537220,
  [SMALL_STATE(14354)] = 537239,
  [SMALL_STATE(14355)] = 537262,
  [SMALL_STATE(14356)] = 537283,
  [SMALL_STATE(14357)] = 537312,
  [SMALL_STATE(14358)] = 537341,
  [SMALL_STATE(14359)] = 537364,
  [SMALL_STATE(14360)] = 537393,
  [SMALL_STATE(14361)] = 537410,
  [SMALL_STATE(14362)] = 537439,
  [SMALL_STATE(14363)] = 537468,
  [SMALL_STATE(14364)] = 537497,
  [SMALL_STATE(14365)] = 537518,
  [SMALL_STATE(14366)] = 537547,
  [SMALL_STATE(14367)] = 537564,
  [SMALL_STATE(14368)] = 537593,
  [SMALL_STATE(14369)] = 537610,
  [SMALL_STATE(14370)] = 537629,
  [SMALL_STATE(14371)] = 537646,
  [SMALL_STATE(14372)] = 537675,
  [SMALL_STATE(14373)] = 537704,
  [SMALL_STATE(14374)] = 537721,
  [SMALL_STATE(14375)] = 537750,
  [SMALL_STATE(14376)] = 537779,
  [SMALL_STATE(14377)] = 537808,
  [SMALL_STATE(14378)] = 537837,
  [SMALL_STATE(14379)] = 537866,
  [SMALL_STATE(14380)] = 537883,
  [SMALL_STATE(14381)] = 537912,
  [SMALL_STATE(14382)] = 537941,
  [SMALL_STATE(14383)] = 537970,
  [SMALL_STATE(14384)] = 537999,
  [SMALL_STATE(14385)] = 538028,
  [SMALL_STATE(14386)] = 538057,
  [SMALL_STATE(14387)] = 538080,
  [SMALL_STATE(14388)] = 538107,
  [SMALL_STATE(14389)] = 538136,
  [SMALL_STATE(14390)] = 538165,
  [SMALL_STATE(14391)] = 538182,
  [SMALL_STATE(14392)] = 538211,
  [SMALL_STATE(14393)] = 538240,
  [SMALL_STATE(14394)] = 538269,
  [SMALL_STATE(14395)] = 538298,
  [SMALL_STATE(14396)] = 538327,
  [SMALL_STATE(14397)] = 538354,
  [SMALL_STATE(14398)] = 538371,
  [SMALL_STATE(14399)] = 538400,
  [SMALL_STATE(14400)] = 538419,
  [SMALL_STATE(14401)] = 538438,
  [SMALL_STATE(14402)] = 538467,
  [SMALL_STATE(14403)] = 538496,
  [SMALL_STATE(14404)] = 538525,
  [SMALL_STATE(14405)] = 538554,
  [SMALL_STATE(14406)] = 538583,
  [SMALL_STATE(14407)] = 538608,
  [SMALL_STATE(14408)] = 538633,
  [SMALL_STATE(14409)] = 538660,
  [SMALL_STATE(14410)] = 538677,
  [SMALL_STATE(14411)] = 538706,
  [SMALL_STATE(14412)] = 538735,
  [SMALL_STATE(14413)] = 538752,
  [SMALL_STATE(14414)] = 538781,
  [SMALL_STATE(14415)] = 538808,
  [SMALL_STATE(14416)] = 538837,
  [SMALL_STATE(14417)] = 538856,
  [SMALL_STATE(14418)] = 538875,
  [SMALL_STATE(14419)] = 538904,
  [SMALL_STATE(14420)] = 538923,
  [SMALL_STATE(14421)] = 538940,
  [SMALL_STATE(14422)] = 538965,
  [SMALL_STATE(14423)] = 538994,
  [SMALL_STATE(14424)] = 539023,
  [SMALL_STATE(14425)] = 539052,
  [SMALL_STATE(14426)] = 539069,
  [SMALL_STATE(14427)] = 539098,
  [SMALL_STATE(14428)] = 539117,
  [SMALL_STATE(14429)] = 539134,
  [SMALL_STATE(14430)] = 539163,
  [SMALL_STATE(14431)] = 539190,
  [SMALL_STATE(14432)] = 539219,
  [SMALL_STATE(14433)] = 539248,
  [SMALL_STATE(14434)] = 539265,
  [SMALL_STATE(14435)] = 539294,
  [SMALL_STATE(14436)] = 539311,
  [SMALL_STATE(14437)] = 539340,
  [SMALL_STATE(14438)] = 539363,
  [SMALL_STATE(14439)] = 539392,
  [SMALL_STATE(14440)] = 539411,
  [SMALL_STATE(14441)] = 539440,
  [SMALL_STATE(14442)] = 539469,
  [SMALL_STATE(14443)] = 539496,
  [SMALL_STATE(14444)] = 539523,
  [SMALL_STATE(14445)] = 539548,
  [SMALL_STATE(14446)] = 539565,
  [SMALL_STATE(14447)] = 539588,
  [SMALL_STATE(14448)] = 539605,
  [SMALL_STATE(14449)] = 539634,
  [SMALL_STATE(14450)] = 539663,
  [SMALL_STATE(14451)] = 539692,
  [SMALL_STATE(14452)] = 539713,
  [SMALL_STATE(14453)] = 539730,
  [SMALL_STATE(14454)] = 539757,
  [SMALL_STATE(14455)] = 539786,
  [SMALL_STATE(14456)] = 539813,
  [SMALL_STATE(14457)] = 539842,
  [SMALL_STATE(14458)] = 539871,
  [SMALL_STATE(14459)] = 539890,
  [SMALL_STATE(14460)] = 539909,
  [SMALL_STATE(14461)] = 539926,
  [SMALL_STATE(14462)] = 539955,
  [SMALL_STATE(14463)] = 539984,
  [SMALL_STATE(14464)] = 540013,
  [SMALL_STATE(14465)] = 540040,
  [SMALL_STATE(14466)] = 540059,
  [SMALL_STATE(14467)] = 540088,
  [SMALL_STATE(14468)] = 540107,
  [SMALL_STATE(14469)] = 540124,
  [SMALL_STATE(14470)] = 540143,
  [SMALL_STATE(14471)] = 540160,
  [SMALL_STATE(14472)] = 540179,
  [SMALL_STATE(14473)] = 540208,
  [SMALL_STATE(14474)] = 540225,
  [SMALL_STATE(14475)] = 540242,
  [SMALL_STATE(14476)] = 540271,
  [SMALL_STATE(14477)] = 540300,
  [SMALL_STATE(14478)] = 540329,
  [SMALL_STATE(14479)] = 540348,
  [SMALL_STATE(14480)] = 540367,
  [SMALL_STATE(14481)] = 540396,
  [SMALL_STATE(14482)] = 540425,
  [SMALL_STATE(14483)] = 540454,
  [SMALL_STATE(14484)] = 540483,
  [SMALL_STATE(14485)] = 540512,
  [SMALL_STATE(14486)] = 540541,
  [SMALL_STATE(14487)] = 540558,
  [SMALL_STATE(14488)] = 540589,
  [SMALL_STATE(14489)] = 540606,
  [SMALL_STATE(14490)] = 540635,
  [SMALL_STATE(14491)] = 540664,
  [SMALL_STATE(14492)] = 540693,
  [SMALL_STATE(14493)] = 540722,
  [SMALL_STATE(14494)] = 540751,
  [SMALL_STATE(14495)] = 540780,
  [SMALL_STATE(14496)] = 540799,
  [SMALL_STATE(14497)] = 540828,
  [SMALL_STATE(14498)] = 540859,
  [SMALL_STATE(14499)] = 540888,
  [SMALL_STATE(14500)] = 540917,
  [SMALL_STATE(14501)] = 540938,
  [SMALL_STATE(14502)] = 540967,
  [SMALL_STATE(14503)] = 540994,
  [SMALL_STATE(14504)] = 541021,
  [SMALL_STATE(14505)] = 541050,
  [SMALL_STATE(14506)] = 541067,
  [SMALL_STATE(14507)] = 541086,
  [SMALL_STATE(14508)] = 541115,
  [SMALL_STATE(14509)] = 541144,
  [SMALL_STATE(14510)] = 541173,
  [SMALL_STATE(14511)] = 541198,
  [SMALL_STATE(14512)] = 541217,
  [SMALL_STATE(14513)] = 541234,
  [SMALL_STATE(14514)] = 541263,
  [SMALL_STATE(14515)] = 541292,
  [SMALL_STATE(14516)] = 541321,
  [SMALL_STATE(14517)] = 541350,
  [SMALL_STATE(14518)] = 541369,
  [SMALL_STATE(14519)] = 541388,
  [SMALL_STATE(14520)] = 541419,
  [SMALL_STATE(14521)] = 541448,
  [SMALL_STATE(14522)] = 541477,
  [SMALL_STATE(14523)] = 541494,
  [SMALL_STATE(14524)] = 541523,
  [SMALL_STATE(14525)] = 541552,
  [SMALL_STATE(14526)] = 541581,
  [SMALL_STATE(14527)] = 541602,
  [SMALL_STATE(14528)] = 541631,
  [SMALL_STATE(14529)] = 541658,
  [SMALL_STATE(14530)] = 541685,
  [SMALL_STATE(14531)] = 541714,
  [SMALL_STATE(14532)] = 541731,
  [SMALL_STATE(14533)] = 541760,
  [SMALL_STATE(14534)] = 541777,
  [SMALL_STATE(14535)] = 541806,
  [SMALL_STATE(14536)] = 541835,
  [SMALL_STATE(14537)] = 541864,
  [SMALL_STATE(14538)] = 541883,
  [SMALL_STATE(14539)] = 541908,
  [SMALL_STATE(14540)] = 541937,
  [SMALL_STATE(14541)] = 541954,
  [SMALL_STATE(14542)] = 541983,
  [SMALL_STATE(14543)] = 542012,
  [SMALL_STATE(14544)] = 542028,
  [SMALL_STATE(14545)] = 542044,
  [SMALL_STATE(14546)] = 542060,
  [SMALL_STATE(14547)] = 542076,
  [SMALL_STATE(14548)] = 542092,
  [SMALL_STATE(14549)] = 542120,
  [SMALL_STATE(14550)] = 542136,
  [SMALL_STATE(14551)] = 542152,
  [SMALL_STATE(14552)] = 542172,
  [SMALL_STATE(14553)] = 542188,
  [SMALL_STATE(14554)] = 542204,
  [SMALL_STATE(14555)] = 542220,
  [SMALL_STATE(14556)] = 542236,
  [SMALL_STATE(14557)] = 542252,
  [SMALL_STATE(14558)] = 542268,
  [SMALL_STATE(14559)] = 542284,
  [SMALL_STATE(14560)] = 542300,
  [SMALL_STATE(14561)] = 542316,
  [SMALL_STATE(14562)] = 542332,
  [SMALL_STATE(14563)] = 542348,
  [SMALL_STATE(14564)] = 542364,
  [SMALL_STATE(14565)] = 542380,
  [SMALL_STATE(14566)] = 542396,
  [SMALL_STATE(14567)] = 542412,
  [SMALL_STATE(14568)] = 542432,
  [SMALL_STATE(14569)] = 542448,
  [SMALL_STATE(14570)] = 542464,
  [SMALL_STATE(14571)] = 542480,
  [SMALL_STATE(14572)] = 542496,
  [SMALL_STATE(14573)] = 542512,
  [SMALL_STATE(14574)] = 542528,
  [SMALL_STATE(14575)] = 542544,
  [SMALL_STATE(14576)] = 542562,
  [SMALL_STATE(14577)] = 542578,
  [SMALL_STATE(14578)] = 542594,
  [SMALL_STATE(14579)] = 542610,
  [SMALL_STATE(14580)] = 542626,
  [SMALL_STATE(14581)] = 542642,
  [SMALL_STATE(14582)] = 542658,
  [SMALL_STATE(14583)] = 542676,
  [SMALL_STATE(14584)] = 542692,
  [SMALL_STATE(14585)] = 542708,
  [SMALL_STATE(14586)] = 542726,
  [SMALL_STATE(14587)] = 542742,
  [SMALL_STATE(14588)] = 542768,
  [SMALL_STATE(14589)] = 542784,
  [SMALL_STATE(14590)] = 542804,
  [SMALL_STATE(14591)] = 542820,
  [SMALL_STATE(14592)] = 542840,
  [SMALL_STATE(14593)] = 542856,
  [SMALL_STATE(14594)] = 542874,
  [SMALL_STATE(14595)] = 542902,
  [SMALL_STATE(14596)] = 542918,
  [SMALL_STATE(14597)] = 542936,
  [SMALL_STATE(14598)] = 542962,
  [SMALL_STATE(14599)] = 542980,
  [SMALL_STATE(14600)] = 542996,
  [SMALL_STATE(14601)] = 543012,
  [SMALL_STATE(14602)] = 543038,
  [SMALL_STATE(14603)] = 543056,
  [SMALL_STATE(14604)] = 543074,
  [SMALL_STATE(14605)] = 543092,
  [SMALL_STATE(14606)] = 543108,
  [SMALL_STATE(14607)] = 543134,
  [SMALL_STATE(14608)] = 543150,
  [SMALL_STATE(14609)] = 543174,
  [SMALL_STATE(14610)] = 543190,
  [SMALL_STATE(14611)] = 543216,
  [SMALL_STATE(14612)] = 543232,
  [SMALL_STATE(14613)] = 543248,
  [SMALL_STATE(14614)] = 543264,
  [SMALL_STATE(14615)] = 543280,
  [SMALL_STATE(14616)] = 543296,
  [SMALL_STATE(14617)] = 543312,
  [SMALL_STATE(14618)] = 543328,
  [SMALL_STATE(14619)] = 543344,
  [SMALL_STATE(14620)] = 543360,
  [SMALL_STATE(14621)] = 543378,
  [SMALL_STATE(14622)] = 543400,
  [SMALL_STATE(14623)] = 543428,
  [SMALL_STATE(14624)] = 543444,
  [SMALL_STATE(14625)] = 543462,
  [SMALL_STATE(14626)] = 543478,
  [SMALL_STATE(14627)] = 543504,
  [SMALL_STATE(14628)] = 543520,
  [SMALL_STATE(14629)] = 543536,
  [SMALL_STATE(14630)] = 543552,
  [SMALL_STATE(14631)] = 543568,
  [SMALL_STATE(14632)] = 543584,
  [SMALL_STATE(14633)] = 543600,
  [SMALL_STATE(14634)] = 543622,
  [SMALL_STATE(14635)] = 543638,
  [SMALL_STATE(14636)] = 543654,
  [SMALL_STATE(14637)] = 543674,
  [SMALL_STATE(14638)] = 543690,
  [SMALL_STATE(14639)] = 543706,
  [SMALL_STATE(14640)] = 543722,
  [SMALL_STATE(14641)] = 543740,
  [SMALL_STATE(14642)] = 543756,
  [SMALL_STATE(14643)] = 543772,
  [SMALL_STATE(14644)] = 543788,
  [SMALL_STATE(14645)] = 543804,
  [SMALL_STATE(14646)] = 543820,
  [SMALL_STATE(14647)] = 543836,
  [SMALL_STATE(14648)] = 543852,
  [SMALL_STATE(14649)] = 543868,
  [SMALL_STATE(14650)] = 543884,
  [SMALL_STATE(14651)] = 543900,
  [SMALL_STATE(14652)] = 543916,
  [SMALL_STATE(14653)] = 543932,
  [SMALL_STATE(14654)] = 543948,
  [SMALL_STATE(14655)] = 543964,
  [SMALL_STATE(14656)] = 543980,
  [SMALL_STATE(14657)] = 543996,
  [SMALL_STATE(14658)] = 544012,
  [SMALL_STATE(14659)] = 544028,
  [SMALL_STATE(14660)] = 544044,
  [SMALL_STATE(14661)] = 544060,
  [SMALL_STATE(14662)] = 544076,
  [SMALL_STATE(14663)] = 544092,
  [SMALL_STATE(14664)] = 544108,
  [SMALL_STATE(14665)] = 544124,
  [SMALL_STATE(14666)] = 544140,
  [SMALL_STATE(14667)] = 544156,
  [SMALL_STATE(14668)] = 544172,
  [SMALL_STATE(14669)] = 544188,
  [SMALL_STATE(14670)] = 544204,
  [SMALL_STATE(14671)] = 544220,
  [SMALL_STATE(14672)] = 544244,
  [SMALL_STATE(14673)] = 544260,
  [SMALL_STATE(14674)] = 544276,
  [SMALL_STATE(14675)] = 544292,
  [SMALL_STATE(14676)] = 544308,
  [SMALL_STATE(14677)] = 544324,
  [SMALL_STATE(14678)] = 544340,
  [SMALL_STATE(14679)] = 544356,
  [SMALL_STATE(14680)] = 544372,
  [SMALL_STATE(14681)] = 544392,
  [SMALL_STATE(14682)] = 544408,
  [SMALL_STATE(14683)] = 544430,
  [SMALL_STATE(14684)] = 544446,
  [SMALL_STATE(14685)] = 544462,
  [SMALL_STATE(14686)] = 544480,
  [SMALL_STATE(14687)] = 544500,
  [SMALL_STATE(14688)] = 544516,
  [SMALL_STATE(14689)] = 544532,
  [SMALL_STATE(14690)] = 544548,
  [SMALL_STATE(14691)] = 544564,
  [SMALL_STATE(14692)] = 544580,
  [SMALL_STATE(14693)] = 544596,
  [SMALL_STATE(14694)] = 544612,
  [SMALL_STATE(14695)] = 544628,
  [SMALL_STATE(14696)] = 544650,
  [SMALL_STATE(14697)] = 544672,
  [SMALL_STATE(14698)] = 544688,
  [SMALL_STATE(14699)] = 544706,
  [SMALL_STATE(14700)] = 544722,
  [SMALL_STATE(14701)] = 544738,
  [SMALL_STATE(14702)] = 544754,
  [SMALL_STATE(14703)] = 544770,
  [SMALL_STATE(14704)] = 544796,
  [SMALL_STATE(14705)] = 544812,
  [SMALL_STATE(14706)] = 544838,
  [SMALL_STATE(14707)] = 544854,
  [SMALL_STATE(14708)] = 544870,
  [SMALL_STATE(14709)] = 544894,
  [SMALL_STATE(14710)] = 544918,
  [SMALL_STATE(14711)] = 544944,
  [SMALL_STATE(14712)] = 544960,
  [SMALL_STATE(14713)] = 544982,
  [SMALL_STATE(14714)] = 544998,
  [SMALL_STATE(14715)] = 545022,
  [SMALL_STATE(14716)] = 545038,
  [SMALL_STATE(14717)] = 545054,
  [SMALL_STATE(14718)] = 545070,
  [SMALL_STATE(14719)] = 545086,
  [SMALL_STATE(14720)] = 545102,
  [SMALL_STATE(14721)] = 545118,
  [SMALL_STATE(14722)] = 545134,
  [SMALL_STATE(14723)] = 545150,
  [SMALL_STATE(14724)] = 545166,
  [SMALL_STATE(14725)] = 545182,
  [SMALL_STATE(14726)] = 545198,
  [SMALL_STATE(14727)] = 545214,
  [SMALL_STATE(14728)] = 545238,
  [SMALL_STATE(14729)] = 545254,
  [SMALL_STATE(14730)] = 545270,
  [SMALL_STATE(14731)] = 545286,
  [SMALL_STATE(14732)] = 545302,
  [SMALL_STATE(14733)] = 545318,
  [SMALL_STATE(14734)] = 545342,
  [SMALL_STATE(14735)] = 545358,
  [SMALL_STATE(14736)] = 545374,
  [SMALL_STATE(14737)] = 545390,
  [SMALL_STATE(14738)] = 545406,
  [SMALL_STATE(14739)] = 545432,
  [SMALL_STATE(14740)] = 545448,
  [SMALL_STATE(14741)] = 545464,
  [SMALL_STATE(14742)] = 545488,
  [SMALL_STATE(14743)] = 545506,
  [SMALL_STATE(14744)] = 545522,
  [SMALL_STATE(14745)] = 545538,
  [SMALL_STATE(14746)] = 545562,
  [SMALL_STATE(14747)] = 545578,
  [SMALL_STATE(14748)] = 545594,
  [SMALL_STATE(14749)] = 545610,
  [SMALL_STATE(14750)] = 545626,
  [SMALL_STATE(14751)] = 545642,
  [SMALL_STATE(14752)] = 545658,
  [SMALL_STATE(14753)] = 545674,
  [SMALL_STATE(14754)] = 545690,
  [SMALL_STATE(14755)] = 545712,
  [SMALL_STATE(14756)] = 545728,
  [SMALL_STATE(14757)] = 545744,
  [SMALL_STATE(14758)] = 545760,
  [SMALL_STATE(14759)] = 545784,
  [SMALL_STATE(14760)] = 545800,
  [SMALL_STATE(14761)] = 545816,
  [SMALL_STATE(14762)] = 545832,
  [SMALL_STATE(14763)] = 545848,
  [SMALL_STATE(14764)] = 545872,
  [SMALL_STATE(14765)] = 545888,
  [SMALL_STATE(14766)] = 545908,
  [SMALL_STATE(14767)] = 545924,
  [SMALL_STATE(14768)] = 545940,
  [SMALL_STATE(14769)] = 545956,
  [SMALL_STATE(14770)] = 545972,
  [SMALL_STATE(14771)] = 545988,
  [SMALL_STATE(14772)] = 546016,
  [SMALL_STATE(14773)] = 546032,
  [SMALL_STATE(14774)] = 546048,
  [SMALL_STATE(14775)] = 546068,
  [SMALL_STATE(14776)] = 546084,
  [SMALL_STATE(14777)] = 546100,
  [SMALL_STATE(14778)] = 546116,
  [SMALL_STATE(14779)] = 546142,
  [SMALL_STATE(14780)] = 546158,
  [SMALL_STATE(14781)] = 546174,
  [SMALL_STATE(14782)] = 546190,
  [SMALL_STATE(14783)] = 546206,
  [SMALL_STATE(14784)] = 546222,
  [SMALL_STATE(14785)] = 546238,
  [SMALL_STATE(14786)] = 546254,
  [SMALL_STATE(14787)] = 546278,
  [SMALL_STATE(14788)] = 546294,
  [SMALL_STATE(14789)] = 546310,
  [SMALL_STATE(14790)] = 546326,
  [SMALL_STATE(14791)] = 546348,
  [SMALL_STATE(14792)] = 546364,
  [SMALL_STATE(14793)] = 546380,
  [SMALL_STATE(14794)] = 546396,
  [SMALL_STATE(14795)] = 546424,
  [SMALL_STATE(14796)] = 546440,
  [SMALL_STATE(14797)] = 546468,
  [SMALL_STATE(14798)] = 546484,
  [SMALL_STATE(14799)] = 546510,
  [SMALL_STATE(14800)] = 546526,
  [SMALL_STATE(14801)] = 546542,
  [SMALL_STATE(14802)] = 546558,
  [SMALL_STATE(14803)] = 546574,
  [SMALL_STATE(14804)] = 546590,
  [SMALL_STATE(14805)] = 546618,
  [SMALL_STATE(14806)] = 546634,
  [SMALL_STATE(14807)] = 546654,
  [SMALL_STATE(14808)] = 546670,
  [SMALL_STATE(14809)] = 546686,
  [SMALL_STATE(14810)] = 546702,
  [SMALL_STATE(14811)] = 546718,
  [SMALL_STATE(14812)] = 546736,
  [SMALL_STATE(14813)] = 546754,
  [SMALL_STATE(14814)] = 546770,
  [SMALL_STATE(14815)] = 546786,
  [SMALL_STATE(14816)] = 546802,
  [SMALL_STATE(14817)] = 546820,
  [SMALL_STATE(14818)] = 546842,
  [SMALL_STATE(14819)] = 546858,
  [SMALL_STATE(14820)] = 546874,
  [SMALL_STATE(14821)] = 546890,
  [SMALL_STATE(14822)] = 546906,
  [SMALL_STATE(14823)] = 546922,
  [SMALL_STATE(14824)] = 546938,
  [SMALL_STATE(14825)] = 546954,
  [SMALL_STATE(14826)] = 546970,
  [SMALL_STATE(14827)] = 546986,
  [SMALL_STATE(14828)] = 547002,
  [SMALL_STATE(14829)] = 547024,
  [SMALL_STATE(14830)] = 547040,
  [SMALL_STATE(14831)] = 547058,
  [SMALL_STATE(14832)] = 547074,
  [SMALL_STATE(14833)] = 547090,
  [SMALL_STATE(14834)] = 547106,
  [SMALL_STATE(14835)] = 547122,
  [SMALL_STATE(14836)] = 547138,
  [SMALL_STATE(14837)] = 547154,
  [SMALL_STATE(14838)] = 547170,
  [SMALL_STATE(14839)] = 547186,
  [SMALL_STATE(14840)] = 547202,
  [SMALL_STATE(14841)] = 547218,
  [SMALL_STATE(14842)] = 547234,
  [SMALL_STATE(14843)] = 547250,
  [SMALL_STATE(14844)] = 547268,
  [SMALL_STATE(14845)] = 547294,
  [SMALL_STATE(14846)] = 547312,
  [SMALL_STATE(14847)] = 547328,
  [SMALL_STATE(14848)] = 547344,
  [SMALL_STATE(14849)] = 547360,
  [SMALL_STATE(14850)] = 547376,
  [SMALL_STATE(14851)] = 547392,
  [SMALL_STATE(14852)] = 547408,
  [SMALL_STATE(14853)] = 547424,
  [SMALL_STATE(14854)] = 547440,
  [SMALL_STATE(14855)] = 547462,
  [SMALL_STATE(14856)] = 547478,
  [SMALL_STATE(14857)] = 547494,
  [SMALL_STATE(14858)] = 547510,
  [SMALL_STATE(14859)] = 547526,
  [SMALL_STATE(14860)] = 547552,
  [SMALL_STATE(14861)] = 547568,
  [SMALL_STATE(14862)] = 547584,
  [SMALL_STATE(14863)] = 547600,
  [SMALL_STATE(14864)] = 547618,
  [SMALL_STATE(14865)] = 547634,
  [SMALL_STATE(14866)] = 547652,
  [SMALL_STATE(14867)] = 547668,
  [SMALL_STATE(14868)] = 547684,
  [SMALL_STATE(14869)] = 547700,
  [SMALL_STATE(14870)] = 547716,
  [SMALL_STATE(14871)] = 547732,
  [SMALL_STATE(14872)] = 547756,
  [SMALL_STATE(14873)] = 547772,
  [SMALL_STATE(14874)] = 547798,
  [SMALL_STATE(14875)] = 547814,
  [SMALL_STATE(14876)] = 547830,
  [SMALL_STATE(14877)] = 547846,
  [SMALL_STATE(14878)] = 547862,
  [SMALL_STATE(14879)] = 547880,
  [SMALL_STATE(14880)] = 547896,
  [SMALL_STATE(14881)] = 547912,
  [SMALL_STATE(14882)] = 547928,
  [SMALL_STATE(14883)] = 547950,
  [SMALL_STATE(14884)] = 547966,
  [SMALL_STATE(14885)] = 547982,
  [SMALL_STATE(14886)] = 547998,
  [SMALL_STATE(14887)] = 548014,
  [SMALL_STATE(14888)] = 548030,
  [SMALL_STATE(14889)] = 548046,
  [SMALL_STATE(14890)] = 548062,
  [SMALL_STATE(14891)] = 548078,
  [SMALL_STATE(14892)] = 548094,
  [SMALL_STATE(14893)] = 548110,
  [SMALL_STATE(14894)] = 548126,
  [SMALL_STATE(14895)] = 548142,
  [SMALL_STATE(14896)] = 548158,
  [SMALL_STATE(14897)] = 548174,
  [SMALL_STATE(14898)] = 548190,
  [SMALL_STATE(14899)] = 548212,
  [SMALL_STATE(14900)] = 548228,
  [SMALL_STATE(14901)] = 548244,
  [SMALL_STATE(14902)] = 548260,
  [SMALL_STATE(14903)] = 548276,
  [SMALL_STATE(14904)] = 548298,
  [SMALL_STATE(14905)] = 548314,
  [SMALL_STATE(14906)] = 548332,
  [SMALL_STATE(14907)] = 548348,
  [SMALL_STATE(14908)] = 548364,
  [SMALL_STATE(14909)] = 548390,
  [SMALL_STATE(14910)] = 548406,
  [SMALL_STATE(14911)] = 548422,
  [SMALL_STATE(14912)] = 548446,
  [SMALL_STATE(14913)] = 548464,
  [SMALL_STATE(14914)] = 548480,
  [SMALL_STATE(14915)] = 548500,
  [SMALL_STATE(14916)] = 548516,
  [SMALL_STATE(14917)] = 548532,
  [SMALL_STATE(14918)] = 548548,
  [SMALL_STATE(14919)] = 548570,
  [SMALL_STATE(14920)] = 548586,
  [SMALL_STATE(14921)] = 548608,
  [SMALL_STATE(14922)] = 548632,
  [SMALL_STATE(14923)] = 548648,
  [SMALL_STATE(14924)] = 548664,
  [SMALL_STATE(14925)] = 548680,
  [SMALL_STATE(14926)] = 548696,
  [SMALL_STATE(14927)] = 548712,
  [SMALL_STATE(14928)] = 548728,
  [SMALL_STATE(14929)] = 548744,
  [SMALL_STATE(14930)] = 548762,
  [SMALL_STATE(14931)] = 548778,
  [SMALL_STATE(14932)] = 548804,
  [SMALL_STATE(14933)] = 548820,
  [SMALL_STATE(14934)] = 548836,
  [SMALL_STATE(14935)] = 548852,
  [SMALL_STATE(14936)] = 548868,
  [SMALL_STATE(14937)] = 548884,
  [SMALL_STATE(14938)] = 548900,
  [SMALL_STATE(14939)] = 548916,
  [SMALL_STATE(14940)] = 548944,
  [SMALL_STATE(14941)] = 548960,
  [SMALL_STATE(14942)] = 548976,
  [SMALL_STATE(14943)] = 548992,
  [SMALL_STATE(14944)] = 549008,
  [SMALL_STATE(14945)] = 549024,
  [SMALL_STATE(14946)] = 549040,
  [SMALL_STATE(14947)] = 549056,
  [SMALL_STATE(14948)] = 549084,
  [SMALL_STATE(14949)] = 549100,
  [SMALL_STATE(14950)] = 549116,
  [SMALL_STATE(14951)] = 549132,
  [SMALL_STATE(14952)] = 549148,
  [SMALL_STATE(14953)] = 549164,
  [SMALL_STATE(14954)] = 549180,
  [SMALL_STATE(14955)] = 549196,
  [SMALL_STATE(14956)] = 549212,
  [SMALL_STATE(14957)] = 549228,
  [SMALL_STATE(14958)] = 549244,
  [SMALL_STATE(14959)] = 549272,
  [SMALL_STATE(14960)] = 549288,
  [SMALL_STATE(14961)] = 549304,
  [SMALL_STATE(14962)] = 549324,
  [SMALL_STATE(14963)] = 549340,
  [SMALL_STATE(14964)] = 549356,
  [SMALL_STATE(14965)] = 549372,
  [SMALL_STATE(14966)] = 549388,
  [SMALL_STATE(14967)] = 549404,
  [SMALL_STATE(14968)] = 549420,
  [SMALL_STATE(14969)] = 549436,
  [SMALL_STATE(14970)] = 549453,
  [SMALL_STATE(14971)] = 549478,
  [SMALL_STATE(14972)] = 549501,
  [SMALL_STATE(14973)] = 549526,
  [SMALL_STATE(14974)] = 549541,
  [SMALL_STATE(14975)] = 549564,
  [SMALL_STATE(14976)] = 549579,
  [SMALL_STATE(14977)] = 549600,
  [SMALL_STATE(14978)] = 549625,
  [SMALL_STATE(14979)] = 549650,
  [SMALL_STATE(14980)] = 549669,
  [SMALL_STATE(14981)] = 549684,
  [SMALL_STATE(14982)] = 549703,
  [SMALL_STATE(14983)] = 549728,
  [SMALL_STATE(14984)] = 549751,
  [SMALL_STATE(14985)] = 549766,
  [SMALL_STATE(14986)] = 549791,
  [SMALL_STATE(14987)] = 549816,
  [SMALL_STATE(14988)] = 549841,
  [SMALL_STATE(14989)] = 549866,
  [SMALL_STATE(14990)] = 549887,
  [SMALL_STATE(14991)] = 549908,
  [SMALL_STATE(14992)] = 549923,
  [SMALL_STATE(14993)] = 549944,
  [SMALL_STATE(14994)] = 549969,
  [SMALL_STATE(14995)] = 549984,
  [SMALL_STATE(14996)] = 550005,
  [SMALL_STATE(14997)] = 550024,
  [SMALL_STATE(14998)] = 550039,
  [SMALL_STATE(14999)] = 550062,
  [SMALL_STATE(15000)] = 550081,
  [SMALL_STATE(15001)] = 550102,
  [SMALL_STATE(15002)] = 550123,
  [SMALL_STATE(15003)] = 550138,
  [SMALL_STATE(15004)] = 550157,
  [SMALL_STATE(15005)] = 550182,
  [SMALL_STATE(15006)] = 550203,
  [SMALL_STATE(15007)] = 550224,
  [SMALL_STATE(15008)] = 550249,
  [SMALL_STATE(15009)] = 550266,
  [SMALL_STATE(15010)] = 550281,
  [SMALL_STATE(15011)] = 550300,
  [SMALL_STATE(15012)] = 550319,
  [SMALL_STATE(15013)] = 550334,
  [SMALL_STATE(15014)] = 550349,
  [SMALL_STATE(15015)] = 550370,
  [SMALL_STATE(15016)] = 550395,
  [SMALL_STATE(15017)] = 550410,
  [SMALL_STATE(15018)] = 550435,
  [SMALL_STATE(15019)] = 550460,
  [SMALL_STATE(15020)] = 550483,
  [SMALL_STATE(15021)] = 550506,
  [SMALL_STATE(15022)] = 550529,
  [SMALL_STATE(15023)] = 550550,
  [SMALL_STATE(15024)] = 550569,
  [SMALL_STATE(15025)] = 550594,
  [SMALL_STATE(15026)] = 550619,
  [SMALL_STATE(15027)] = 550634,
  [SMALL_STATE(15028)] = 550649,
  [SMALL_STATE(15029)] = 550664,
  [SMALL_STATE(15030)] = 550679,
  [SMALL_STATE(15031)] = 550704,
  [SMALL_STATE(15032)] = 550719,
  [SMALL_STATE(15033)] = 550734,
  [SMALL_STATE(15034)] = 550757,
  [SMALL_STATE(15035)] = 550776,
  [SMALL_STATE(15036)] = 550801,
  [SMALL_STATE(15037)] = 550818,
  [SMALL_STATE(15038)] = 550843,
  [SMALL_STATE(15039)] = 550868,
  [SMALL_STATE(15040)] = 550887,
  [SMALL_STATE(15041)] = 550902,
  [SMALL_STATE(15042)] = 550921,
  [SMALL_STATE(15043)] = 550946,
  [SMALL_STATE(15044)] = 550961,
  [SMALL_STATE(15045)] = 550986,
  [SMALL_STATE(15046)] = 551011,
  [SMALL_STATE(15047)] = 551026,
  [SMALL_STATE(15048)] = 551041,
  [SMALL_STATE(15049)] = 551062,
  [SMALL_STATE(15050)] = 551087,
  [SMALL_STATE(15051)] = 551112,
  [SMALL_STATE(15052)] = 551127,
  [SMALL_STATE(15053)] = 551152,
  [SMALL_STATE(15054)] = 551167,
  [SMALL_STATE(15055)] = 551182,
  [SMALL_STATE(15056)] = 551201,
  [SMALL_STATE(15057)] = 551220,
  [SMALL_STATE(15058)] = 551235,
  [SMALL_STATE(15059)] = 551258,
  [SMALL_STATE(15060)] = 551277,
  [SMALL_STATE(15061)] = 551300,
  [SMALL_STATE(15062)] = 551321,
  [SMALL_STATE(15063)] = 551346,
  [SMALL_STATE(15064)] = 551371,
  [SMALL_STATE(15065)] = 551390,
  [SMALL_STATE(15066)] = 551415,
  [SMALL_STATE(15067)] = 551438,
  [SMALL_STATE(15068)] = 551463,
  [SMALL_STATE(15069)] = 551478,
  [SMALL_STATE(15070)] = 551503,
  [SMALL_STATE(15071)] = 551520,
  [SMALL_STATE(15072)] = 551545,
  [SMALL_STATE(15073)] = 551564,
  [SMALL_STATE(15074)] = 551589,
  [SMALL_STATE(15075)] = 551614,
  [SMALL_STATE(15076)] = 551633,
  [SMALL_STATE(15077)] = 551658,
  [SMALL_STATE(15078)] = 551675,
  [SMALL_STATE(15079)] = 551690,
  [SMALL_STATE(15080)] = 551705,
  [SMALL_STATE(15081)] = 551720,
  [SMALL_STATE(15082)] = 551745,
  [SMALL_STATE(15083)] = 551768,
  [SMALL_STATE(15084)] = 551793,
  [SMALL_STATE(15085)] = 551808,
  [SMALL_STATE(15086)] = 551829,
  [SMALL_STATE(15087)] = 551854,
  [SMALL_STATE(15088)] = 551869,
  [SMALL_STATE(15089)] = 551890,
  [SMALL_STATE(15090)] = 551915,
  [SMALL_STATE(15091)] = 551934,
  [SMALL_STATE(15092)] = 551955,
  [SMALL_STATE(15093)] = 551970,
  [SMALL_STATE(15094)] = 551989,
  [SMALL_STATE(15095)] = 552004,
  [SMALL_STATE(15096)] = 552019,
  [SMALL_STATE(15097)] = 552034,
  [SMALL_STATE(15098)] = 552049,
  [SMALL_STATE(15099)] = 552072,
  [SMALL_STATE(15100)] = 552091,
  [SMALL_STATE(15101)] = 552116,
  [SMALL_STATE(15102)] = 552131,
  [SMALL_STATE(15103)] = 552150,
  [SMALL_STATE(15104)] = 552165,
  [SMALL_STATE(15105)] = 552180,
  [SMALL_STATE(15106)] = 552195,
  [SMALL_STATE(15107)] = 552214,
  [SMALL_STATE(15108)] = 552237,
  [SMALL_STATE(15109)] = 552252,
  [SMALL_STATE(15110)] = 552267,
  [SMALL_STATE(15111)] = 552292,
  [SMALL_STATE(15112)] = 552317,
  [SMALL_STATE(15113)] = 552342,
  [SMALL_STATE(15114)] = 552357,
  [SMALL_STATE(15115)] = 552382,
  [SMALL_STATE(15116)] = 552397,
  [SMALL_STATE(15117)] = 552422,
  [SMALL_STATE(15118)] = 552447,
  [SMALL_STATE(15119)] = 552462,
  [SMALL_STATE(15120)] = 552477,
  [SMALL_STATE(15121)] = 552494,
  [SMALL_STATE(15122)] = 552509,
  [SMALL_STATE(15123)] = 552532,
  [SMALL_STATE(15124)] = 552549,
  [SMALL_STATE(15125)] = 552574,
  [SMALL_STATE(15126)] = 552599,
  [SMALL_STATE(15127)] = 552614,
  [SMALL_STATE(15128)] = 552639,
  [SMALL_STATE(15129)] = 552664,
  [SMALL_STATE(15130)] = 552679,
  [SMALL_STATE(15131)] = 552694,
  [SMALL_STATE(15132)] = 552717,
  [SMALL_STATE(15133)] = 552740,
  [SMALL_STATE(15134)] = 552759,
  [SMALL_STATE(15135)] = 552784,
  [SMALL_STATE(15136)] = 552799,
  [SMALL_STATE(15137)] = 552814,
  [SMALL_STATE(15138)] = 552829,
  [SMALL_STATE(15139)] = 552854,
  [SMALL_STATE(15140)] = 552869,
  [SMALL_STATE(15141)] = 552884,
  [SMALL_STATE(15142)] = 552899,
  [SMALL_STATE(15143)] = 552924,
  [SMALL_STATE(15144)] = 552939,
  [SMALL_STATE(15145)] = 552964,
  [SMALL_STATE(15146)] = 552979,
  [SMALL_STATE(15147)] = 553002,
  [SMALL_STATE(15148)] = 553025,
  [SMALL_STATE(15149)] = 553050,
  [SMALL_STATE(15150)] = 553075,
  [SMALL_STATE(15151)] = 553090,
  [SMALL_STATE(15152)] = 553115,
  [SMALL_STATE(15153)] = 553140,
  [SMALL_STATE(15154)] = 553155,
  [SMALL_STATE(15155)] = 553178,
  [SMALL_STATE(15156)] = 553203,
  [SMALL_STATE(15157)] = 553226,
  [SMALL_STATE(15158)] = 553247,
  [SMALL_STATE(15159)] = 553272,
  [SMALL_STATE(15160)] = 553287,
  [SMALL_STATE(15161)] = 553304,
  [SMALL_STATE(15162)] = 553325,
  [SMALL_STATE(15163)] = 553340,
  [SMALL_STATE(15164)] = 553357,
  [SMALL_STATE(15165)] = 553382,
  [SMALL_STATE(15166)] = 553407,
  [SMALL_STATE(15167)] = 553426,
  [SMALL_STATE(15168)] = 553451,
  [SMALL_STATE(15169)] = 553472,
  [SMALL_STATE(15170)] = 553487,
  [SMALL_STATE(15171)] = 553510,
  [SMALL_STATE(15172)] = 553525,
  [SMALL_STATE(15173)] = 553540,
  [SMALL_STATE(15174)] = 553555,
  [SMALL_STATE(15175)] = 553576,
  [SMALL_STATE(15176)] = 553593,
  [SMALL_STATE(15177)] = 553608,
  [SMALL_STATE(15178)] = 553633,
  [SMALL_STATE(15179)] = 553658,
  [SMALL_STATE(15180)] = 553675,
  [SMALL_STATE(15181)] = 553700,
  [SMALL_STATE(15182)] = 553721,
  [SMALL_STATE(15183)] = 553736,
  [SMALL_STATE(15184)] = 553761,
  [SMALL_STATE(15185)] = 553776,
  [SMALL_STATE(15186)] = 553801,
  [SMALL_STATE(15187)] = 553822,
  [SMALL_STATE(15188)] = 553837,
  [SMALL_STATE(15189)] = 553862,
  [SMALL_STATE(15190)] = 553877,
  [SMALL_STATE(15191)] = 553892,
  [SMALL_STATE(15192)] = 553907,
  [SMALL_STATE(15193)] = 553924,
  [SMALL_STATE(15194)] = 553939,
  [SMALL_STATE(15195)] = 553954,
  [SMALL_STATE(15196)] = 553969,
  [SMALL_STATE(15197)] = 553994,
  [SMALL_STATE(15198)] = 554017,
  [SMALL_STATE(15199)] = 554032,
  [SMALL_STATE(15200)] = 554057,
  [SMALL_STATE(15201)] = 554072,
  [SMALL_STATE(15202)] = 554097,
  [SMALL_STATE(15203)] = 554122,
  [SMALL_STATE(15204)] = 554137,
  [SMALL_STATE(15205)] = 554162,
  [SMALL_STATE(15206)] = 554183,
  [SMALL_STATE(15207)] = 554208,
  [SMALL_STATE(15208)] = 554233,
  [SMALL_STATE(15209)] = 554248,
  [SMALL_STATE(15210)] = 554269,
  [SMALL_STATE(15211)] = 554294,
  [SMALL_STATE(15212)] = 554309,
  [SMALL_STATE(15213)] = 554328,
  [SMALL_STATE(15214)] = 554349,
  [SMALL_STATE(15215)] = 554374,
  [SMALL_STATE(15216)] = 554399,
  [SMALL_STATE(15217)] = 554414,
  [SMALL_STATE(15218)] = 554433,
  [SMALL_STATE(15219)] = 554448,
  [SMALL_STATE(15220)] = 554471,
  [SMALL_STATE(15221)] = 554490,
  [SMALL_STATE(15222)] = 554505,
  [SMALL_STATE(15223)] = 554520,
  [SMALL_STATE(15224)] = 554541,
  [SMALL_STATE(15225)] = 554566,
  [SMALL_STATE(15226)] = 554591,
  [SMALL_STATE(15227)] = 554614,
  [SMALL_STATE(15228)] = 554629,
  [SMALL_STATE(15229)] = 554650,
  [SMALL_STATE(15230)] = 554673,
  [SMALL_STATE(15231)] = 554698,
  [SMALL_STATE(15232)] = 554717,
  [SMALL_STATE(15233)] = 554732,
  [SMALL_STATE(15234)] = 554755,
  [SMALL_STATE(15235)] = 554770,
  [SMALL_STATE(15236)] = 554785,
  [SMALL_STATE(15237)] = 554800,
  [SMALL_STATE(15238)] = 554815,
  [SMALL_STATE(15239)] = 554840,
  [SMALL_STATE(15240)] = 554865,
  [SMALL_STATE(15241)] = 554888,
  [SMALL_STATE(15242)] = 554911,
  [SMALL_STATE(15243)] = 554936,
  [SMALL_STATE(15244)] = 554961,
  [SMALL_STATE(15245)] = 554984,
  [SMALL_STATE(15246)] = 555003,
  [SMALL_STATE(15247)] = 555020,
  [SMALL_STATE(15248)] = 555035,
  [SMALL_STATE(15249)] = 555050,
  [SMALL_STATE(15250)] = 555065,
  [SMALL_STATE(15251)] = 555080,
  [SMALL_STATE(15252)] = 555095,
  [SMALL_STATE(15253)] = 555110,
  [SMALL_STATE(15254)] = 555135,
  [SMALL_STATE(15255)] = 555160,
  [SMALL_STATE(15256)] = 555175,
  [SMALL_STATE(15257)] = 555194,
  [SMALL_STATE(15258)] = 555209,
  [SMALL_STATE(15259)] = 555230,
  [SMALL_STATE(15260)] = 555247,
  [SMALL_STATE(15261)] = 555262,
  [SMALL_STATE(15262)] = 555287,
  [SMALL_STATE(15263)] = 555304,
  [SMALL_STATE(15264)] = 555329,
  [SMALL_STATE(15265)] = 555344,
  [SMALL_STATE(15266)] = 555363,
  [SMALL_STATE(15267)] = 555388,
  [SMALL_STATE(15268)] = 555403,
  [SMALL_STATE(15269)] = 555422,
  [SMALL_STATE(15270)] = 555437,
  [SMALL_STATE(15271)] = 555452,
  [SMALL_STATE(15272)] = 555477,
  [SMALL_STATE(15273)] = 555502,
  [SMALL_STATE(15274)] = 555525,
  [SMALL_STATE(15275)] = 555550,
  [SMALL_STATE(15276)] = 555575,
  [SMALL_STATE(15277)] = 555590,
  [SMALL_STATE(15278)] = 555605,
  [SMALL_STATE(15279)] = 555620,
  [SMALL_STATE(15280)] = 555635,
  [SMALL_STATE(15281)] = 555660,
  [SMALL_STATE(15282)] = 555677,
  [SMALL_STATE(15283)] = 555692,
  [SMALL_STATE(15284)] = 555707,
  [SMALL_STATE(15285)] = 555732,
  [SMALL_STATE(15286)] = 555747,
  [SMALL_STATE(15287)] = 555770,
  [SMALL_STATE(15288)] = 555785,
  [SMALL_STATE(15289)] = 555810,
  [SMALL_STATE(15290)] = 555833,
  [SMALL_STATE(15291)] = 555848,
  [SMALL_STATE(15292)] = 555869,
  [SMALL_STATE(15293)] = 555884,
  [SMALL_STATE(15294)] = 555909,
  [SMALL_STATE(15295)] = 555924,
  [SMALL_STATE(15296)] = 555947,
  [SMALL_STATE(15297)] = 555968,
  [SMALL_STATE(15298)] = 555983,
  [SMALL_STATE(15299)] = 556000,
  [SMALL_STATE(15300)] = 556015,
  [SMALL_STATE(15301)] = 556040,
  [SMALL_STATE(15302)] = 556063,
  [SMALL_STATE(15303)] = 556088,
  [SMALL_STATE(15304)] = 556103,
  [SMALL_STATE(15305)] = 556126,
  [SMALL_STATE(15306)] = 556147,
  [SMALL_STATE(15307)] = 556162,
  [SMALL_STATE(15308)] = 556187,
  [SMALL_STATE(15309)] = 556202,
  [SMALL_STATE(15310)] = 556217,
  [SMALL_STATE(15311)] = 556232,
  [SMALL_STATE(15312)] = 556257,
  [SMALL_STATE(15313)] = 556272,
  [SMALL_STATE(15314)] = 556287,
  [SMALL_STATE(15315)] = 556302,
  [SMALL_STATE(15316)] = 556327,
  [SMALL_STATE(15317)] = 556342,
  [SMALL_STATE(15318)] = 556357,
  [SMALL_STATE(15319)] = 556380,
  [SMALL_STATE(15320)] = 556399,
  [SMALL_STATE(15321)] = 556422,
  [SMALL_STATE(15322)] = 556447,
  [SMALL_STATE(15323)] = 556462,
  [SMALL_STATE(15324)] = 556485,
  [SMALL_STATE(15325)] = 556506,
  [SMALL_STATE(15326)] = 556521,
  [SMALL_STATE(15327)] = 556536,
  [SMALL_STATE(15328)] = 556561,
  [SMALL_STATE(15329)] = 556586,
  [SMALL_STATE(15330)] = 556601,
  [SMALL_STATE(15331)] = 556626,
  [SMALL_STATE(15332)] = 556641,
  [SMALL_STATE(15333)] = 556656,
  [SMALL_STATE(15334)] = 556671,
  [SMALL_STATE(15335)] = 556696,
  [SMALL_STATE(15336)] = 556719,
  [SMALL_STATE(15337)] = 556738,
  [SMALL_STATE(15338)] = 556753,
  [SMALL_STATE(15339)] = 556768,
  [SMALL_STATE(15340)] = 556793,
  [SMALL_STATE(15341)] = 556808,
  [SMALL_STATE(15342)] = 556833,
  [SMALL_STATE(15343)] = 556858,
  [SMALL_STATE(15344)] = 556881,
  [SMALL_STATE(15345)] = 556906,
  [SMALL_STATE(15346)] = 556921,
  [SMALL_STATE(15347)] = 556946,
  [SMALL_STATE(15348)] = 556965,
  [SMALL_STATE(15349)] = 556980,
  [SMALL_STATE(15350)] = 557005,
  [SMALL_STATE(15351)] = 557020,
  [SMALL_STATE(15352)] = 557035,
  [SMALL_STATE(15353)] = 557050,
  [SMALL_STATE(15354)] = 557075,
  [SMALL_STATE(15355)] = 557100,
  [SMALL_STATE(15356)] = 557115,
  [SMALL_STATE(15357)] = 557130,
  [SMALL_STATE(15358)] = 557145,
  [SMALL_STATE(15359)] = 557162,
  [SMALL_STATE(15360)] = 557183,
  [SMALL_STATE(15361)] = 557208,
  [SMALL_STATE(15362)] = 557223,
  [SMALL_STATE(15363)] = 557248,
  [SMALL_STATE(15364)] = 557273,
  [SMALL_STATE(15365)] = 557292,
  [SMALL_STATE(15366)] = 557317,
  [SMALL_STATE(15367)] = 557342,
  [SMALL_STATE(15368)] = 557361,
  [SMALL_STATE(15369)] = 557386,
  [SMALL_STATE(15370)] = 557411,
  [SMALL_STATE(15371)] = 557426,
  [SMALL_STATE(15372)] = 557441,
  [SMALL_STATE(15373)] = 557456,
  [SMALL_STATE(15374)] = 557471,
  [SMALL_STATE(15375)] = 557486,
  [SMALL_STATE(15376)] = 557509,
  [SMALL_STATE(15377)] = 557524,
  [SMALL_STATE(15378)] = 557549,
  [SMALL_STATE(15379)] = 557572,
  [SMALL_STATE(15380)] = 557587,
  [SMALL_STATE(15381)] = 557604,
  [SMALL_STATE(15382)] = 557625,
  [SMALL_STATE(15383)] = 557650,
  [SMALL_STATE(15384)] = 557675,
  [SMALL_STATE(15385)] = 557694,
  [SMALL_STATE(15386)] = 557713,
  [SMALL_STATE(15387)] = 557728,
  [SMALL_STATE(15388)] = 557753,
  [SMALL_STATE(15389)] = 557768,
  [SMALL_STATE(15390)] = 557791,
  [SMALL_STATE(15391)] = 557816,
  [SMALL_STATE(15392)] = 557831,
  [SMALL_STATE(15393)] = 557848,
  [SMALL_STATE(15394)] = 557871,
  [SMALL_STATE(15395)] = 557888,
  [SMALL_STATE(15396)] = 557911,
  [SMALL_STATE(15397)] = 557934,
  [SMALL_STATE(15398)] = 557959,
  [SMALL_STATE(15399)] = 557974,
  [SMALL_STATE(15400)] = 557997,
  [SMALL_STATE(15401)] = 558012,
  [SMALL_STATE(15402)] = 558037,
  [SMALL_STATE(15403)] = 558062,
  [SMALL_STATE(15404)] = 558081,
  [SMALL_STATE(15405)] = 558106,
  [SMALL_STATE(15406)] = 558121,
  [SMALL_STATE(15407)] = 558136,
  [SMALL_STATE(15408)] = 558151,
  [SMALL_STATE(15409)] = 558166,
  [SMALL_STATE(15410)] = 558191,
  [SMALL_STATE(15411)] = 558206,
  [SMALL_STATE(15412)] = 558221,
  [SMALL_STATE(15413)] = 558236,
  [SMALL_STATE(15414)] = 558251,
  [SMALL_STATE(15415)] = 558276,
  [SMALL_STATE(15416)] = 558301,
  [SMALL_STATE(15417)] = 558318,
  [SMALL_STATE(15418)] = 558337,
  [SMALL_STATE(15419)] = 558356,
  [SMALL_STATE(15420)] = 558371,
  [SMALL_STATE(15421)] = 558386,
  [SMALL_STATE(15422)] = 558401,
  [SMALL_STATE(15423)] = 558422,
  [SMALL_STATE(15424)] = 558437,
  [SMALL_STATE(15425)] = 558462,
  [SMALL_STATE(15426)] = 558479,
  [SMALL_STATE(15427)] = 558504,
  [SMALL_STATE(15428)] = 558519,
  [SMALL_STATE(15429)] = 558544,
  [SMALL_STATE(15430)] = 558563,
  [SMALL_STATE(15431)] = 558588,
  [SMALL_STATE(15432)] = 558611,
  [SMALL_STATE(15433)] = 558630,
  [SMALL_STATE(15434)] = 558655,
  [SMALL_STATE(15435)] = 558670,
  [SMALL_STATE(15436)] = 558685,
  [SMALL_STATE(15437)] = 558700,
  [SMALL_STATE(15438)] = 558715,
  [SMALL_STATE(15439)] = 558730,
  [SMALL_STATE(15440)] = 558755,
  [SMALL_STATE(15441)] = 558780,
  [SMALL_STATE(15442)] = 558805,
  [SMALL_STATE(15443)] = 558828,
  [SMALL_STATE(15444)] = 558847,
  [SMALL_STATE(15445)] = 558872,
  [SMALL_STATE(15446)] = 558887,
  [SMALL_STATE(15447)] = 558912,
  [SMALL_STATE(15448)] = 558935,
  [SMALL_STATE(15449)] = 558950,
  [SMALL_STATE(15450)] = 558965,
  [SMALL_STATE(15451)] = 558980,
  [SMALL_STATE(15452)] = 558995,
  [SMALL_STATE(15453)] = 559010,
  [SMALL_STATE(15454)] = 559029,
  [SMALL_STATE(15455)] = 559048,
  [SMALL_STATE(15456)] = 559063,
  [SMALL_STATE(15457)] = 559088,
  [SMALL_STATE(15458)] = 559103,
  [SMALL_STATE(15459)] = 559120,
  [SMALL_STATE(15460)] = 559135,
  [SMALL_STATE(15461)] = 559150,
  [SMALL_STATE(15462)] = 559175,
  [SMALL_STATE(15463)] = 559192,
  [SMALL_STATE(15464)] = 559217,
  [SMALL_STATE(15465)] = 559242,
  [SMALL_STATE(15466)] = 559267,
  [SMALL_STATE(15467)] = 559286,
  [SMALL_STATE(15468)] = 559307,
  [SMALL_STATE(15469)] = 559330,
  [SMALL_STATE(15470)] = 559355,
  [SMALL_STATE(15471)] = 559370,
  [SMALL_STATE(15472)] = 559385,
  [SMALL_STATE(15473)] = 559400,
  [SMALL_STATE(15474)] = 559425,
  [SMALL_STATE(15475)] = 559440,
  [SMALL_STATE(15476)] = 559459,
  [SMALL_STATE(15477)] = 559484,
  [SMALL_STATE(15478)] = 559501,
  [SMALL_STATE(15479)] = 559516,
  [SMALL_STATE(15480)] = 559539,
  [SMALL_STATE(15481)] = 559562,
  [SMALL_STATE(15482)] = 559587,
  [SMALL_STATE(15483)] = 559612,
  [SMALL_STATE(15484)] = 559627,
  [SMALL_STATE(15485)] = 559652,
  [SMALL_STATE(15486)] = 559667,
  [SMALL_STATE(15487)] = 559682,
  [SMALL_STATE(15488)] = 559697,
  [SMALL_STATE(15489)] = 559722,
  [SMALL_STATE(15490)] = 559747,
  [SMALL_STATE(15491)] = 559762,
  [SMALL_STATE(15492)] = 559777,
  [SMALL_STATE(15493)] = 559792,
  [SMALL_STATE(15494)] = 559811,
  [SMALL_STATE(15495)] = 559826,
  [SMALL_STATE(15496)] = 559841,
  [SMALL_STATE(15497)] = 559856,
  [SMALL_STATE(15498)] = 559871,
  [SMALL_STATE(15499)] = 559886,
  [SMALL_STATE(15500)] = 559911,
  [SMALL_STATE(15501)] = 559926,
  [SMALL_STATE(15502)] = 559941,
  [SMALL_STATE(15503)] = 559960,
  [SMALL_STATE(15504)] = 559979,
  [SMALL_STATE(15505)] = 559994,
  [SMALL_STATE(15506)] = 560019,
  [SMALL_STATE(15507)] = 560034,
  [SMALL_STATE(15508)] = 560049,
  [SMALL_STATE(15509)] = 560074,
  [SMALL_STATE(15510)] = 560099,
  [SMALL_STATE(15511)] = 560122,
  [SMALL_STATE(15512)] = 560141,
  [SMALL_STATE(15513)] = 560156,
  [SMALL_STATE(15514)] = 560171,
  [SMALL_STATE(15515)] = 560190,
  [SMALL_STATE(15516)] = 560209,
  [SMALL_STATE(15517)] = 560234,
  [SMALL_STATE(15518)] = 560259,
  [SMALL_STATE(15519)] = 560274,
  [SMALL_STATE(15520)] = 560289,
  [SMALL_STATE(15521)] = 560304,
  [SMALL_STATE(15522)] = 560319,
  [SMALL_STATE(15523)] = 560334,
  [SMALL_STATE(15524)] = 560359,
  [SMALL_STATE(15525)] = 560384,
  [SMALL_STATE(15526)] = 560409,
  [SMALL_STATE(15527)] = 560432,
  [SMALL_STATE(15528)] = 560447,
  [SMALL_STATE(15529)] = 560466,
  [SMALL_STATE(15530)] = 560489,
  [SMALL_STATE(15531)] = 560504,
  [SMALL_STATE(15532)] = 560519,
  [SMALL_STATE(15533)] = 560538,
  [SMALL_STATE(15534)] = 560553,
  [SMALL_STATE(15535)] = 560578,
  [SMALL_STATE(15536)] = 560593,
  [SMALL_STATE(15537)] = 560612,
  [SMALL_STATE(15538)] = 560627,
  [SMALL_STATE(15539)] = 560652,
  [SMALL_STATE(15540)] = 560677,
  [SMALL_STATE(15541)] = 560698,
  [SMALL_STATE(15542)] = 560717,
  [SMALL_STATE(15543)] = 560742,
  [SMALL_STATE(15544)] = 560765,
  [SMALL_STATE(15545)] = 560790,
  [SMALL_STATE(15546)] = 560815,
  [SMALL_STATE(15547)] = 560834,
  [SMALL_STATE(15548)] = 560853,
  [SMALL_STATE(15549)] = 560868,
  [SMALL_STATE(15550)] = 560883,
  [SMALL_STATE(15551)] = 560904,
  [SMALL_STATE(15552)] = 560925,
  [SMALL_STATE(15553)] = 560944,
  [SMALL_STATE(15554)] = 560965,
  [SMALL_STATE(15555)] = 560988,
  [SMALL_STATE(15556)] = 561003,
  [SMALL_STATE(15557)] = 561018,
  [SMALL_STATE(15558)] = 561033,
  [SMALL_STATE(15559)] = 561052,
  [SMALL_STATE(15560)] = 561077,
  [SMALL_STATE(15561)] = 561102,
  [SMALL_STATE(15562)] = 561125,
  [SMALL_STATE(15563)] = 561140,
  [SMALL_STATE(15564)] = 561159,
  [SMALL_STATE(15565)] = 561178,
  [SMALL_STATE(15566)] = 561203,
  [SMALL_STATE(15567)] = 561226,
  [SMALL_STATE(15568)] = 561241,
  [SMALL_STATE(15569)] = 561260,
  [SMALL_STATE(15570)] = 561285,
  [SMALL_STATE(15571)] = 561300,
  [SMALL_STATE(15572)] = 561323,
  [SMALL_STATE(15573)] = 561342,
  [SMALL_STATE(15574)] = 561357,
  [SMALL_STATE(15575)] = 561382,
  [SMALL_STATE(15576)] = 561399,
  [SMALL_STATE(15577)] = 561424,
  [SMALL_STATE(15578)] = 561449,
  [SMALL_STATE(15579)] = 561468,
  [SMALL_STATE(15580)] = 561489,
  [SMALL_STATE(15581)] = 561512,
  [SMALL_STATE(15582)] = 561537,
  [SMALL_STATE(15583)] = 561552,
  [SMALL_STATE(15584)] = 561571,
  [SMALL_STATE(15585)] = 561590,
  [SMALL_STATE(15586)] = 561605,
  [SMALL_STATE(15587)] = 561630,
  [SMALL_STATE(15588)] = 561655,
  [SMALL_STATE(15589)] = 561680,
  [SMALL_STATE(15590)] = 561695,
  [SMALL_STATE(15591)] = 561716,
  [SMALL_STATE(15592)] = 561741,
  [SMALL_STATE(15593)] = 561758,
  [SMALL_STATE(15594)] = 561781,
  [SMALL_STATE(15595)] = 561806,
  [SMALL_STATE(15596)] = 561825,
  [SMALL_STATE(15597)] = 561846,
  [SMALL_STATE(15598)] = 561871,
  [SMALL_STATE(15599)] = 561896,
  [SMALL_STATE(15600)] = 561911,
  [SMALL_STATE(15601)] = 561928,
  [SMALL_STATE(15602)] = 561947,
  [SMALL_STATE(15603)] = 561972,
  [SMALL_STATE(15604)] = 561997,
  [SMALL_STATE(15605)] = 562022,
  [SMALL_STATE(15606)] = 562045,
  [SMALL_STATE(15607)] = 562064,
  [SMALL_STATE(15608)] = 562089,
  [SMALL_STATE(15609)] = 562114,
  [SMALL_STATE(15610)] = 562137,
  [SMALL_STATE(15611)] = 562156,
  [SMALL_STATE(15612)] = 562173,
  [SMALL_STATE(15613)] = 562198,
  [SMALL_STATE(15614)] = 562213,
  [SMALL_STATE(15615)] = 562234,
  [SMALL_STATE(15616)] = 562253,
  [SMALL_STATE(15617)] = 562278,
  [SMALL_STATE(15618)] = 562303,
  [SMALL_STATE(15619)] = 562320,
  [SMALL_STATE(15620)] = 562345,
  [SMALL_STATE(15621)] = 562370,
  [SMALL_STATE(15622)] = 562391,
  [SMALL_STATE(15623)] = 562410,
  [SMALL_STATE(15624)] = 562435,
  [SMALL_STATE(15625)] = 562460,
  [SMALL_STATE(15626)] = 562479,
  [SMALL_STATE(15627)] = 562500,
  [SMALL_STATE(15628)] = 562514,
  [SMALL_STATE(15629)] = 562536,
  [SMALL_STATE(15630)] = 562550,
  [SMALL_STATE(15631)] = 562572,
  [SMALL_STATE(15632)] = 562586,
  [SMALL_STATE(15633)] = 562600,
  [SMALL_STATE(15634)] = 562614,
  [SMALL_STATE(15635)] = 562636,
  [SMALL_STATE(15636)] = 562658,
  [SMALL_STATE(15637)] = 562680,
  [SMALL_STATE(15638)] = 562696,
  [SMALL_STATE(15639)] = 562718,
  [SMALL_STATE(15640)] = 562732,
  [SMALL_STATE(15641)] = 562750,
  [SMALL_STATE(15642)] = 562764,
  [SMALL_STATE(15643)] = 562786,
  [SMALL_STATE(15644)] = 562808,
  [SMALL_STATE(15645)] = 562826,
  [SMALL_STATE(15646)] = 562848,
  [SMALL_STATE(15647)] = 562862,
  [SMALL_STATE(15648)] = 562876,
  [SMALL_STATE(15649)] = 562894,
  [SMALL_STATE(15650)] = 562912,
  [SMALL_STATE(15651)] = 562930,
  [SMALL_STATE(15652)] = 562952,
  [SMALL_STATE(15653)] = 562974,
  [SMALL_STATE(15654)] = 562990,
  [SMALL_STATE(15655)] = 563006,
  [SMALL_STATE(15656)] = 563024,
  [SMALL_STATE(15657)] = 563046,
  [SMALL_STATE(15658)] = 563068,
  [SMALL_STATE(15659)] = 563086,
  [SMALL_STATE(15660)] = 563108,
  [SMALL_STATE(15661)] = 563122,
  [SMALL_STATE(15662)] = 563138,
  [SMALL_STATE(15663)] = 563160,
  [SMALL_STATE(15664)] = 563178,
  [SMALL_STATE(15665)] = 563198,
  [SMALL_STATE(15666)] = 563220,
  [SMALL_STATE(15667)] = 563238,
  [SMALL_STATE(15668)] = 563256,
  [SMALL_STATE(15669)] = 563270,
  [SMALL_STATE(15670)] = 563284,
  [SMALL_STATE(15671)] = 563306,
  [SMALL_STATE(15672)] = 563328,
  [SMALL_STATE(15673)] = 563344,
  [SMALL_STATE(15674)] = 563366,
  [SMALL_STATE(15675)] = 563382,
  [SMALL_STATE(15676)] = 563396,
  [SMALL_STATE(15677)] = 563410,
  [SMALL_STATE(15678)] = 563424,
  [SMALL_STATE(15679)] = 563438,
  [SMALL_STATE(15680)] = 563452,
  [SMALL_STATE(15681)] = 563466,
  [SMALL_STATE(15682)] = 563488,
  [SMALL_STATE(15683)] = 563510,
  [SMALL_STATE(15684)] = 563528,
  [SMALL_STATE(15685)] = 563550,
  [SMALL_STATE(15686)] = 563564,
  [SMALL_STATE(15687)] = 563586,
  [SMALL_STATE(15688)] = 563600,
  [SMALL_STATE(15689)] = 563622,
  [SMALL_STATE(15690)] = 563644,
  [SMALL_STATE(15691)] = 563660,
  [SMALL_STATE(15692)] = 563682,
  [SMALL_STATE(15693)] = 563704,
  [SMALL_STATE(15694)] = 563726,
  [SMALL_STATE(15695)] = 563748,
  [SMALL_STATE(15696)] = 563770,
  [SMALL_STATE(15697)] = 563786,
  [SMALL_STATE(15698)] = 563800,
  [SMALL_STATE(15699)] = 563820,
  [SMALL_STATE(15700)] = 563834,
  [SMALL_STATE(15701)] = 563848,
  [SMALL_STATE(15702)] = 563870,
  [SMALL_STATE(15703)] = 563888,
  [SMALL_STATE(15704)] = 563902,
  [SMALL_STATE(15705)] = 563920,
  [SMALL_STATE(15706)] = 563942,
  [SMALL_STATE(15707)] = 563964,
  [SMALL_STATE(15708)] = 563978,
  [SMALL_STATE(15709)] = 563992,
  [SMALL_STATE(15710)] = 564006,
  [SMALL_STATE(15711)] = 564028,
  [SMALL_STATE(15712)] = 564050,
  [SMALL_STATE(15713)] = 564072,
  [SMALL_STATE(15714)] = 564086,
  [SMALL_STATE(15715)] = 564108,
  [SMALL_STATE(15716)] = 564122,
  [SMALL_STATE(15717)] = 564138,
  [SMALL_STATE(15718)] = 564152,
  [SMALL_STATE(15719)] = 564168,
  [SMALL_STATE(15720)] = 564182,
  [SMALL_STATE(15721)] = 564196,
  [SMALL_STATE(15722)] = 564216,
  [SMALL_STATE(15723)] = 564238,
  [SMALL_STATE(15724)] = 564252,
  [SMALL_STATE(15725)] = 564272,
  [SMALL_STATE(15726)] = 564292,
  [SMALL_STATE(15727)] = 564306,
  [SMALL_STATE(15728)] = 564328,
  [SMALL_STATE(15729)] = 564350,
  [SMALL_STATE(15730)] = 564364,
  [SMALL_STATE(15731)] = 564382,
  [SMALL_STATE(15732)] = 564404,
  [SMALL_STATE(15733)] = 564426,
  [SMALL_STATE(15734)] = 564448,
  [SMALL_STATE(15735)] = 564462,
  [SMALL_STATE(15736)] = 564478,
  [SMALL_STATE(15737)] = 564492,
  [SMALL_STATE(15738)] = 564514,
  [SMALL_STATE(15739)] = 564536,
  [SMALL_STATE(15740)] = 564552,
  [SMALL_STATE(15741)] = 564574,
  [SMALL_STATE(15742)] = 564596,
  [SMALL_STATE(15743)] = 564616,
  [SMALL_STATE(15744)] = 564630,
  [SMALL_STATE(15745)] = 564644,
  [SMALL_STATE(15746)] = 564658,
  [SMALL_STATE(15747)] = 564674,
  [SMALL_STATE(15748)] = 564696,
  [SMALL_STATE(15749)] = 564710,
  [SMALL_STATE(15750)] = 564724,
  [SMALL_STATE(15751)] = 564746,
  [SMALL_STATE(15752)] = 564760,
  [SMALL_STATE(15753)] = 564774,
  [SMALL_STATE(15754)] = 564788,
  [SMALL_STATE(15755)] = 564802,
  [SMALL_STATE(15756)] = 564822,
  [SMALL_STATE(15757)] = 564844,
  [SMALL_STATE(15758)] = 564858,
  [SMALL_STATE(15759)] = 564880,
  [SMALL_STATE(15760)] = 564902,
  [SMALL_STATE(15761)] = 564916,
  [SMALL_STATE(15762)] = 564938,
  [SMALL_STATE(15763)] = 564952,
  [SMALL_STATE(15764)] = 564966,
  [SMALL_STATE(15765)] = 564980,
  [SMALL_STATE(15766)] = 564994,
  [SMALL_STATE(15767)] = 565008,
  [SMALL_STATE(15768)] = 565030,
  [SMALL_STATE(15769)] = 565044,
  [SMALL_STATE(15770)] = 565060,
  [SMALL_STATE(15771)] = 565082,
  [SMALL_STATE(15772)] = 565096,
  [SMALL_STATE(15773)] = 565118,
  [SMALL_STATE(15774)] = 565138,
  [SMALL_STATE(15775)] = 565152,
  [SMALL_STATE(15776)] = 565174,
  [SMALL_STATE(15777)] = 565188,
  [SMALL_STATE(15778)] = 565210,
  [SMALL_STATE(15779)] = 565224,
  [SMALL_STATE(15780)] = 565246,
  [SMALL_STATE(15781)] = 565260,
  [SMALL_STATE(15782)] = 565274,
  [SMALL_STATE(15783)] = 565296,
  [SMALL_STATE(15784)] = 565318,
  [SMALL_STATE(15785)] = 565332,
  [SMALL_STATE(15786)] = 565346,
  [SMALL_STATE(15787)] = 565366,
  [SMALL_STATE(15788)] = 565388,
  [SMALL_STATE(15789)] = 565408,
  [SMALL_STATE(15790)] = 565422,
  [SMALL_STATE(15791)] = 565444,
  [SMALL_STATE(15792)] = 565460,
  [SMALL_STATE(15793)] = 565476,
  [SMALL_STATE(15794)] = 565498,
  [SMALL_STATE(15795)] = 565520,
  [SMALL_STATE(15796)] = 565542,
  [SMALL_STATE(15797)] = 565562,
  [SMALL_STATE(15798)] = 565584,
  [SMALL_STATE(15799)] = 565598,
  [SMALL_STATE(15800)] = 565614,
  [SMALL_STATE(15801)] = 565632,
  [SMALL_STATE(15802)] = 565646,
  [SMALL_STATE(15803)] = 565660,
  [SMALL_STATE(15804)] = 565674,
  [SMALL_STATE(15805)] = 565690,
  [SMALL_STATE(15806)] = 565712,
  [SMALL_STATE(15807)] = 565734,
  [SMALL_STATE(15808)] = 565748,
  [SMALL_STATE(15809)] = 565770,
  [SMALL_STATE(15810)] = 565786,
  [SMALL_STATE(15811)] = 565808,
  [SMALL_STATE(15812)] = 565830,
  [SMALL_STATE(15813)] = 565852,
  [SMALL_STATE(15814)] = 565866,
  [SMALL_STATE(15815)] = 565882,
  [SMALL_STATE(15816)] = 565904,
  [SMALL_STATE(15817)] = 565920,
  [SMALL_STATE(15818)] = 565938,
  [SMALL_STATE(15819)] = 565960,
  [SMALL_STATE(15820)] = 565974,
  [SMALL_STATE(15821)] = 565994,
  [SMALL_STATE(15822)] = 566008,
  [SMALL_STATE(15823)] = 566030,
  [SMALL_STATE(15824)] = 566044,
  [SMALL_STATE(15825)] = 566058,
  [SMALL_STATE(15826)] = 566080,
  [SMALL_STATE(15827)] = 566094,
  [SMALL_STATE(15828)] = 566116,
  [SMALL_STATE(15829)] = 566138,
  [SMALL_STATE(15830)] = 566152,
  [SMALL_STATE(15831)] = 566174,
  [SMALL_STATE(15832)] = 566194,
  [SMALL_STATE(15833)] = 566208,
  [SMALL_STATE(15834)] = 566224,
  [SMALL_STATE(15835)] = 566242,
  [SMALL_STATE(15836)] = 566260,
  [SMALL_STATE(15837)] = 566278,
  [SMALL_STATE(15838)] = 566300,
  [SMALL_STATE(15839)] = 566322,
  [SMALL_STATE(15840)] = 566336,
  [SMALL_STATE(15841)] = 566354,
  [SMALL_STATE(15842)] = 566368,
  [SMALL_STATE(15843)] = 566390,
  [SMALL_STATE(15844)] = 566412,
  [SMALL_STATE(15845)] = 566426,
  [SMALL_STATE(15846)] = 566442,
  [SMALL_STATE(15847)] = 566456,
  [SMALL_STATE(15848)] = 566470,
  [SMALL_STATE(15849)] = 566484,
  [SMALL_STATE(15850)] = 566506,
  [SMALL_STATE(15851)] = 566524,
  [SMALL_STATE(15852)] = 566538,
  [SMALL_STATE(15853)] = 566560,
  [SMALL_STATE(15854)] = 566576,
  [SMALL_STATE(15855)] = 566590,
  [SMALL_STATE(15856)] = 566612,
  [SMALL_STATE(15857)] = 566626,
  [SMALL_STATE(15858)] = 566648,
  [SMALL_STATE(15859)] = 566670,
  [SMALL_STATE(15860)] = 566684,
  [SMALL_STATE(15861)] = 566704,
  [SMALL_STATE(15862)] = 566720,
  [SMALL_STATE(15863)] = 566734,
  [SMALL_STATE(15864)] = 566750,
  [SMALL_STATE(15865)] = 566766,
  [SMALL_STATE(15866)] = 566788,
  [SMALL_STATE(15867)] = 566802,
  [SMALL_STATE(15868)] = 566824,
  [SMALL_STATE(15869)] = 566838,
  [SMALL_STATE(15870)] = 566852,
  [SMALL_STATE(15871)] = 566866,
  [SMALL_STATE(15872)] = 566880,
  [SMALL_STATE(15873)] = 566902,
  [SMALL_STATE(15874)] = 566924,
  [SMALL_STATE(15875)] = 566946,
  [SMALL_STATE(15876)] = 566968,
  [SMALL_STATE(15877)] = 566982,
  [SMALL_STATE(15878)] = 566996,
  [SMALL_STATE(15879)] = 567018,
  [SMALL_STATE(15880)] = 567032,
  [SMALL_STATE(15881)] = 567046,
  [SMALL_STATE(15882)] = 567068,
  [SMALL_STATE(15883)] = 567082,
  [SMALL_STATE(15884)] = 567096,
  [SMALL_STATE(15885)] = 567118,
  [SMALL_STATE(15886)] = 567132,
  [SMALL_STATE(15887)] = 567148,
  [SMALL_STATE(15888)] = 567170,
  [SMALL_STATE(15889)] = 567186,
  [SMALL_STATE(15890)] = 567208,
  [SMALL_STATE(15891)] = 567230,
  [SMALL_STATE(15892)] = 567244,
  [SMALL_STATE(15893)] = 567260,
  [SMALL_STATE(15894)] = 567280,
  [SMALL_STATE(15895)] = 567294,
  [SMALL_STATE(15896)] = 567316,
  [SMALL_STATE(15897)] = 567334,
  [SMALL_STATE(15898)] = 567356,
  [SMALL_STATE(15899)] = 567372,
  [SMALL_STATE(15900)] = 567390,
  [SMALL_STATE(15901)] = 567408,
  [SMALL_STATE(15902)] = 567430,
  [SMALL_STATE(15903)] = 567452,
  [SMALL_STATE(15904)] = 567474,
  [SMALL_STATE(15905)] = 567496,
  [SMALL_STATE(15906)] = 567514,
  [SMALL_STATE(15907)] = 567528,
  [SMALL_STATE(15908)] = 567542,
  [SMALL_STATE(15909)] = 567564,
  [SMALL_STATE(15910)] = 567584,
  [SMALL_STATE(15911)] = 567600,
  [SMALL_STATE(15912)] = 567614,
  [SMALL_STATE(15913)] = 567628,
  [SMALL_STATE(15914)] = 567642,
  [SMALL_STATE(15915)] = 567656,
  [SMALL_STATE(15916)] = 567672,
  [SMALL_STATE(15917)] = 567688,
  [SMALL_STATE(15918)] = 567710,
  [SMALL_STATE(15919)] = 567726,
  [SMALL_STATE(15920)] = 567744,
  [SMALL_STATE(15921)] = 567764,
  [SMALL_STATE(15922)] = 567778,
  [SMALL_STATE(15923)] = 567798,
  [SMALL_STATE(15924)] = 567820,
  [SMALL_STATE(15925)] = 567836,
  [SMALL_STATE(15926)] = 567850,
  [SMALL_STATE(15927)] = 567872,
  [SMALL_STATE(15928)] = 567890,
  [SMALL_STATE(15929)] = 567906,
  [SMALL_STATE(15930)] = 567928,
  [SMALL_STATE(15931)] = 567944,
  [SMALL_STATE(15932)] = 567958,
  [SMALL_STATE(15933)] = 567980,
  [SMALL_STATE(15934)] = 568000,
  [SMALL_STATE(15935)] = 568022,
  [SMALL_STATE(15936)] = 568044,
  [SMALL_STATE(15937)] = 568060,
  [SMALL_STATE(15938)] = 568078,
  [SMALL_STATE(15939)] = 568096,
  [SMALL_STATE(15940)] = 568110,
  [SMALL_STATE(15941)] = 568132,
  [SMALL_STATE(15942)] = 568146,
  [SMALL_STATE(15943)] = 568168,
  [SMALL_STATE(15944)] = 568182,
  [SMALL_STATE(15945)] = 568196,
  [SMALL_STATE(15946)] = 568214,
  [SMALL_STATE(15947)] = 568236,
  [SMALL_STATE(15948)] = 568258,
  [SMALL_STATE(15949)] = 568280,
  [SMALL_STATE(15950)] = 568296,
  [SMALL_STATE(15951)] = 568310,
  [SMALL_STATE(15952)] = 568324,
  [SMALL_STATE(15953)] = 568344,
  [SMALL_STATE(15954)] = 568360,
  [SMALL_STATE(15955)] = 568382,
  [SMALL_STATE(15956)] = 568404,
  [SMALL_STATE(15957)] = 568426,
  [SMALL_STATE(15958)] = 568446,
  [SMALL_STATE(15959)] = 568468,
  [SMALL_STATE(15960)] = 568488,
  [SMALL_STATE(15961)] = 568510,
  [SMALL_STATE(15962)] = 568526,
  [SMALL_STATE(15963)] = 568548,
  [SMALL_STATE(15964)] = 568570,
  [SMALL_STATE(15965)] = 568592,
  [SMALL_STATE(15966)] = 568614,
  [SMALL_STATE(15967)] = 568636,
  [SMALL_STATE(15968)] = 568658,
  [SMALL_STATE(15969)] = 568678,
  [SMALL_STATE(15970)] = 568696,
  [SMALL_STATE(15971)] = 568718,
  [SMALL_STATE(15972)] = 568740,
  [SMALL_STATE(15973)] = 568754,
  [SMALL_STATE(15974)] = 568774,
  [SMALL_STATE(15975)] = 568796,
  [SMALL_STATE(15976)] = 568812,
  [SMALL_STATE(15977)] = 568828,
  [SMALL_STATE(15978)] = 568850,
  [SMALL_STATE(15979)] = 568872,
  [SMALL_STATE(15980)] = 568894,
  [SMALL_STATE(15981)] = 568908,
  [SMALL_STATE(15982)] = 568922,
  [SMALL_STATE(15983)] = 568942,
  [SMALL_STATE(15984)] = 568964,
  [SMALL_STATE(15985)] = 568982,
  [SMALL_STATE(15986)] = 568998,
  [SMALL_STATE(15987)] = 569014,
  [SMALL_STATE(15988)] = 569028,
  [SMALL_STATE(15989)] = 569042,
  [SMALL_STATE(15990)] = 569064,
  [SMALL_STATE(15991)] = 569078,
  [SMALL_STATE(15992)] = 569096,
  [SMALL_STATE(15993)] = 569112,
  [SMALL_STATE(15994)] = 569134,
  [SMALL_STATE(15995)] = 569154,
  [SMALL_STATE(15996)] = 569168,
  [SMALL_STATE(15997)] = 569188,
  [SMALL_STATE(15998)] = 569202,
  [SMALL_STATE(15999)] = 569218,
  [SMALL_STATE(16000)] = 569240,
  [SMALL_STATE(16001)] = 569256,
  [SMALL_STATE(16002)] = 569270,
  [SMALL_STATE(16003)] = 569292,
  [SMALL_STATE(16004)] = 569314,
  [SMALL_STATE(16005)] = 569330,
  [SMALL_STATE(16006)] = 569348,
  [SMALL_STATE(16007)] = 569366,
  [SMALL_STATE(16008)] = 569388,
  [SMALL_STATE(16009)] = 569410,
  [SMALL_STATE(16010)] = 569424,
  [SMALL_STATE(16011)] = 569438,
  [SMALL_STATE(16012)] = 569452,
  [SMALL_STATE(16013)] = 569466,
  [SMALL_STATE(16014)] = 569488,
  [SMALL_STATE(16015)] = 569502,
  [SMALL_STATE(16016)] = 569520,
  [SMALL_STATE(16017)] = 569538,
  [SMALL_STATE(16018)] = 569560,
  [SMALL_STATE(16019)] = 569582,
  [SMALL_STATE(16020)] = 569598,
  [SMALL_STATE(16021)] = 569618,
  [SMALL_STATE(16022)] = 569640,
  [SMALL_STATE(16023)] = 569654,
  [SMALL_STATE(16024)] = 569672,
  [SMALL_STATE(16025)] = 569694,
  [SMALL_STATE(16026)] = 569716,
  [SMALL_STATE(16027)] = 569732,
  [SMALL_STATE(16028)] = 569746,
  [SMALL_STATE(16029)] = 569760,
  [SMALL_STATE(16030)] = 569782,
  [SMALL_STATE(16031)] = 569798,
  [SMALL_STATE(16032)] = 569814,
  [SMALL_STATE(16033)] = 569830,
  [SMALL_STATE(16034)] = 569852,
  [SMALL_STATE(16035)] = 569874,
  [SMALL_STATE(16036)] = 569892,
  [SMALL_STATE(16037)] = 569914,
  [SMALL_STATE(16038)] = 569928,
  [SMALL_STATE(16039)] = 569950,
  [SMALL_STATE(16040)] = 569972,
  [SMALL_STATE(16041)] = 569986,
  [SMALL_STATE(16042)] = 570000,
  [SMALL_STATE(16043)] = 570014,
  [SMALL_STATE(16044)] = 570034,
  [SMALL_STATE(16045)] = 570052,
  [SMALL_STATE(16046)] = 570074,
  [SMALL_STATE(16047)] = 570092,
  [SMALL_STATE(16048)] = 570112,
  [SMALL_STATE(16049)] = 570134,
  [SMALL_STATE(16050)] = 570156,
  [SMALL_STATE(16051)] = 570170,
  [SMALL_STATE(16052)] = 570184,
  [SMALL_STATE(16053)] = 570204,
  [SMALL_STATE(16054)] = 570226,
  [SMALL_STATE(16055)] = 570248,
  [SMALL_STATE(16056)] = 570270,
  [SMALL_STATE(16057)] = 570290,
  [SMALL_STATE(16058)] = 570310,
  [SMALL_STATE(16059)] = 570324,
  [SMALL_STATE(16060)] = 570342,
  [SMALL_STATE(16061)] = 570356,
  [SMALL_STATE(16062)] = 570374,
  [SMALL_STATE(16063)] = 570396,
  [SMALL_STATE(16064)] = 570414,
  [SMALL_STATE(16065)] = 570432,
  [SMALL_STATE(16066)] = 570450,
  [SMALL_STATE(16067)] = 570466,
  [SMALL_STATE(16068)] = 570482,
  [SMALL_STATE(16069)] = 570504,
  [SMALL_STATE(16070)] = 570526,
  [SMALL_STATE(16071)] = 570544,
  [SMALL_STATE(16072)] = 570560,
  [SMALL_STATE(16073)] = 570582,
  [SMALL_STATE(16074)] = 570600,
  [SMALL_STATE(16075)] = 570618,
  [SMALL_STATE(16076)] = 570636,
  [SMALL_STATE(16077)] = 570658,
  [SMALL_STATE(16078)] = 570680,
  [SMALL_STATE(16079)] = 570702,
  [SMALL_STATE(16080)] = 570718,
  [SMALL_STATE(16081)] = 570740,
  [SMALL_STATE(16082)] = 570762,
  [SMALL_STATE(16083)] = 570778,
  [SMALL_STATE(16084)] = 570800,
  [SMALL_STATE(16085)] = 570822,
  [SMALL_STATE(16086)] = 570840,
  [SMALL_STATE(16087)] = 570856,
  [SMALL_STATE(16088)] = 570872,
  [SMALL_STATE(16089)] = 570886,
  [SMALL_STATE(16090)] = 570904,
  [SMALL_STATE(16091)] = 570926,
  [SMALL_STATE(16092)] = 570944,
  [SMALL_STATE(16093)] = 570962,
  [SMALL_STATE(16094)] = 570984,
  [SMALL_STATE(16095)] = 571004,
  [SMALL_STATE(16096)] = 571026,
  [SMALL_STATE(16097)] = 571042,
  [SMALL_STATE(16098)] = 571056,
  [SMALL_STATE(16099)] = 571078,
  [SMALL_STATE(16100)] = 571098,
  [SMALL_STATE(16101)] = 571112,
  [SMALL_STATE(16102)] = 571130,
  [SMALL_STATE(16103)] = 571152,
  [SMALL_STATE(16104)] = 571174,
  [SMALL_STATE(16105)] = 571190,
  [SMALL_STATE(16106)] = 571212,
  [SMALL_STATE(16107)] = 571228,
  [SMALL_STATE(16108)] = 571246,
  [SMALL_STATE(16109)] = 571264,
  [SMALL_STATE(16110)] = 571286,
  [SMALL_STATE(16111)] = 571300,
  [SMALL_STATE(16112)] = 571314,
  [SMALL_STATE(16113)] = 571334,
  [SMALL_STATE(16114)] = 571348,
  [SMALL_STATE(16115)] = 571370,
  [SMALL_STATE(16116)] = 571384,
  [SMALL_STATE(16117)] = 571406,
  [SMALL_STATE(16118)] = 571426,
  [SMALL_STATE(16119)] = 571448,
  [SMALL_STATE(16120)] = 571470,
  [SMALL_STATE(16121)] = 571492,
  [SMALL_STATE(16122)] = 571512,
  [SMALL_STATE(16123)] = 571534,
  [SMALL_STATE(16124)] = 571548,
  [SMALL_STATE(16125)] = 571562,
  [SMALL_STATE(16126)] = 571584,
  [SMALL_STATE(16127)] = 571606,
  [SMALL_STATE(16128)] = 571628,
  [SMALL_STATE(16129)] = 571650,
  [SMALL_STATE(16130)] = 571664,
  [SMALL_STATE(16131)] = 571678,
  [SMALL_STATE(16132)] = 571696,
  [SMALL_STATE(16133)] = 571718,
  [SMALL_STATE(16134)] = 571740,
  [SMALL_STATE(16135)] = 571754,
  [SMALL_STATE(16136)] = 571768,
  [SMALL_STATE(16137)] = 571788,
  [SMALL_STATE(16138)] = 571804,
  [SMALL_STATE(16139)] = 571818,
  [SMALL_STATE(16140)] = 571834,
  [SMALL_STATE(16141)] = 571848,
  [SMALL_STATE(16142)] = 571868,
  [SMALL_STATE(16143)] = 571882,
  [SMALL_STATE(16144)] = 571904,
  [SMALL_STATE(16145)] = 571926,
  [SMALL_STATE(16146)] = 571948,
  [SMALL_STATE(16147)] = 571962,
  [SMALL_STATE(16148)] = 571976,
  [SMALL_STATE(16149)] = 571992,
  [SMALL_STATE(16150)] = 572010,
  [SMALL_STATE(16151)] = 572024,
  [SMALL_STATE(16152)] = 572042,
  [SMALL_STATE(16153)] = 572064,
  [SMALL_STATE(16154)] = 572086,
  [SMALL_STATE(16155)] = 572100,
  [SMALL_STATE(16156)] = 572122,
  [SMALL_STATE(16157)] = 572144,
  [SMALL_STATE(16158)] = 572158,
  [SMALL_STATE(16159)] = 572176,
  [SMALL_STATE(16160)] = 572192,
  [SMALL_STATE(16161)] = 572208,
  [SMALL_STATE(16162)] = 572230,
  [SMALL_STATE(16163)] = 572248,
  [SMALL_STATE(16164)] = 572266,
  [SMALL_STATE(16165)] = 572284,
  [SMALL_STATE(16166)] = 572298,
  [SMALL_STATE(16167)] = 572316,
  [SMALL_STATE(16168)] = 572338,
  [SMALL_STATE(16169)] = 572360,
  [SMALL_STATE(16170)] = 572374,
  [SMALL_STATE(16171)] = 572396,
  [SMALL_STATE(16172)] = 572414,
  [SMALL_STATE(16173)] = 572434,
  [SMALL_STATE(16174)] = 572448,
  [SMALL_STATE(16175)] = 572466,
  [SMALL_STATE(16176)] = 572480,
  [SMALL_STATE(16177)] = 572500,
  [SMALL_STATE(16178)] = 572518,
  [SMALL_STATE(16179)] = 572540,
  [SMALL_STATE(16180)] = 572554,
  [SMALL_STATE(16181)] = 572572,
  [SMALL_STATE(16182)] = 572594,
  [SMALL_STATE(16183)] = 572608,
  [SMALL_STATE(16184)] = 572622,
  [SMALL_STATE(16185)] = 572636,
  [SMALL_STATE(16186)] = 572650,
  [SMALL_STATE(16187)] = 572664,
  [SMALL_STATE(16188)] = 572682,
  [SMALL_STATE(16189)] = 572704,
  [SMALL_STATE(16190)] = 572724,
  [SMALL_STATE(16191)] = 572744,
  [SMALL_STATE(16192)] = 572766,
  [SMALL_STATE(16193)] = 572784,
  [SMALL_STATE(16194)] = 572802,
  [SMALL_STATE(16195)] = 572818,
  [SMALL_STATE(16196)] = 572832,
  [SMALL_STATE(16197)] = 572854,
  [SMALL_STATE(16198)] = 572868,
  [SMALL_STATE(16199)] = 572886,
  [SMALL_STATE(16200)] = 572906,
  [SMALL_STATE(16201)] = 572924,
  [SMALL_STATE(16202)] = 572942,
  [SMALL_STATE(16203)] = 572960,
  [SMALL_STATE(16204)] = 572978,
  [SMALL_STATE(16205)] = 573000,
  [SMALL_STATE(16206)] = 573022,
  [SMALL_STATE(16207)] = 573036,
  [SMALL_STATE(16208)] = 573058,
  [SMALL_STATE(16209)] = 573074,
  [SMALL_STATE(16210)] = 573088,
  [SMALL_STATE(16211)] = 573106,
  [SMALL_STATE(16212)] = 573128,
  [SMALL_STATE(16213)] = 573144,
  [SMALL_STATE(16214)] = 573158,
  [SMALL_STATE(16215)] = 573180,
  [SMALL_STATE(16216)] = 573198,
  [SMALL_STATE(16217)] = 573212,
  [SMALL_STATE(16218)] = 573234,
  [SMALL_STATE(16219)] = 573256,
  [SMALL_STATE(16220)] = 573270,
  [SMALL_STATE(16221)] = 573286,
  [SMALL_STATE(16222)] = 573308,
  [SMALL_STATE(16223)] = 573330,
  [SMALL_STATE(16224)] = 573352,
  [SMALL_STATE(16225)] = 573366,
  [SMALL_STATE(16226)] = 573380,
  [SMALL_STATE(16227)] = 573394,
  [SMALL_STATE(16228)] = 573408,
  [SMALL_STATE(16229)] = 573422,
  [SMALL_STATE(16230)] = 573444,
  [SMALL_STATE(16231)] = 573466,
  [SMALL_STATE(16232)] = 573484,
  [SMALL_STATE(16233)] = 573498,
  [SMALL_STATE(16234)] = 573518,
  [SMALL_STATE(16235)] = 573532,
  [SMALL_STATE(16236)] = 573546,
  [SMALL_STATE(16237)] = 573566,
  [SMALL_STATE(16238)] = 573582,
  [SMALL_STATE(16239)] = 573604,
  [SMALL_STATE(16240)] = 573620,
  [SMALL_STATE(16241)] = 573634,
  [SMALL_STATE(16242)] = 573648,
  [SMALL_STATE(16243)] = 573662,
  [SMALL_STATE(16244)] = 573684,
  [SMALL_STATE(16245)] = 573698,
  [SMALL_STATE(16246)] = 573718,
  [SMALL_STATE(16247)] = 573740,
  [SMALL_STATE(16248)] = 573760,
  [SMALL_STATE(16249)] = 573774,
  [SMALL_STATE(16250)] = 573791,
  [SMALL_STATE(16251)] = 573808,
  [SMALL_STATE(16252)] = 573827,
  [SMALL_STATE(16253)] = 573846,
  [SMALL_STATE(16254)] = 573865,
  [SMALL_STATE(16255)] = 573882,
  [SMALL_STATE(16256)] = 573901,
  [SMALL_STATE(16257)] = 573920,
  [SMALL_STATE(16258)] = 573937,
  [SMALL_STATE(16259)] = 573954,
  [SMALL_STATE(16260)] = 573971,
  [SMALL_STATE(16261)] = 573990,
  [SMALL_STATE(16262)] = 574009,
  [SMALL_STATE(16263)] = 574028,
  [SMALL_STATE(16264)] = 574047,
  [SMALL_STATE(16265)] = 574066,
  [SMALL_STATE(16266)] = 574085,
  [SMALL_STATE(16267)] = 574104,
  [SMALL_STATE(16268)] = 574121,
  [SMALL_STATE(16269)] = 574140,
  [SMALL_STATE(16270)] = 574157,
  [SMALL_STATE(16271)] = 574176,
  [SMALL_STATE(16272)] = 574195,
  [SMALL_STATE(16273)] = 574212,
  [SMALL_STATE(16274)] = 574231,
  [SMALL_STATE(16275)] = 574248,
  [SMALL_STATE(16276)] = 574267,
  [SMALL_STATE(16277)] = 574286,
  [SMALL_STATE(16278)] = 574305,
  [SMALL_STATE(16279)] = 574324,
  [SMALL_STATE(16280)] = 574341,
  [SMALL_STATE(16281)] = 574358,
  [SMALL_STATE(16282)] = 574375,
  [SMALL_STATE(16283)] = 574392,
  [SMALL_STATE(16284)] = 574409,
  [SMALL_STATE(16285)] = 574428,
  [SMALL_STATE(16286)] = 574447,
  [SMALL_STATE(16287)] = 574466,
  [SMALL_STATE(16288)] = 574485,
  [SMALL_STATE(16289)] = 574502,
  [SMALL_STATE(16290)] = 574519,
  [SMALL_STATE(16291)] = 574538,
  [SMALL_STATE(16292)] = 574557,
  [SMALL_STATE(16293)] = 574576,
  [SMALL_STATE(16294)] = 574593,
  [SMALL_STATE(16295)] = 574612,
  [SMALL_STATE(16296)] = 574629,
  [SMALL_STATE(16297)] = 574648,
  [SMALL_STATE(16298)] = 574665,
  [SMALL_STATE(16299)] = 574684,
  [SMALL_STATE(16300)] = 574703,
  [SMALL_STATE(16301)] = 574722,
  [SMALL_STATE(16302)] = 574739,
  [SMALL_STATE(16303)] = 574752,
  [SMALL_STATE(16304)] = 574769,
  [SMALL_STATE(16305)] = 574782,
  [SMALL_STATE(16306)] = 574799,
  [SMALL_STATE(16307)] = 574818,
  [SMALL_STATE(16308)] = 574837,
  [SMALL_STATE(16309)] = 574856,
  [SMALL_STATE(16310)] = 574875,
  [SMALL_STATE(16311)] = 574892,
  [SMALL_STATE(16312)] = 574911,
  [SMALL_STATE(16313)] = 574930,
  [SMALL_STATE(16314)] = 574947,
  [SMALL_STATE(16315)] = 574960,
  [SMALL_STATE(16316)] = 574977,
  [SMALL_STATE(16317)] = 574996,
  [SMALL_STATE(16318)] = 575013,
  [SMALL_STATE(16319)] = 575032,
  [SMALL_STATE(16320)] = 575049,
  [SMALL_STATE(16321)] = 575066,
  [SMALL_STATE(16322)] = 575085,
  [SMALL_STATE(16323)] = 575104,
  [SMALL_STATE(16324)] = 575123,
  [SMALL_STATE(16325)] = 575140,
  [SMALL_STATE(16326)] = 575159,
  [SMALL_STATE(16327)] = 575178,
  [SMALL_STATE(16328)] = 575197,
  [SMALL_STATE(16329)] = 575216,
  [SMALL_STATE(16330)] = 575233,
  [SMALL_STATE(16331)] = 575252,
  [SMALL_STATE(16332)] = 575265,
  [SMALL_STATE(16333)] = 575282,
  [SMALL_STATE(16334)] = 575301,
  [SMALL_STATE(16335)] = 575320,
  [SMALL_STATE(16336)] = 575337,
  [SMALL_STATE(16337)] = 575354,
  [SMALL_STATE(16338)] = 575373,
  [SMALL_STATE(16339)] = 575392,
  [SMALL_STATE(16340)] = 575411,
  [SMALL_STATE(16341)] = 575424,
  [SMALL_STATE(16342)] = 575443,
  [SMALL_STATE(16343)] = 575456,
  [SMALL_STATE(16344)] = 575475,
  [SMALL_STATE(16345)] = 575494,
  [SMALL_STATE(16346)] = 575511,
  [SMALL_STATE(16347)] = 575530,
  [SMALL_STATE(16348)] = 575549,
  [SMALL_STATE(16349)] = 575568,
  [SMALL_STATE(16350)] = 575585,
  [SMALL_STATE(16351)] = 575598,
  [SMALL_STATE(16352)] = 575615,
  [SMALL_STATE(16353)] = 575628,
  [SMALL_STATE(16354)] = 575645,
  [SMALL_STATE(16355)] = 575664,
  [SMALL_STATE(16356)] = 575681,
  [SMALL_STATE(16357)] = 575700,
  [SMALL_STATE(16358)] = 575713,
  [SMALL_STATE(16359)] = 575730,
  [SMALL_STATE(16360)] = 575749,
  [SMALL_STATE(16361)] = 575768,
  [SMALL_STATE(16362)] = 575787,
  [SMALL_STATE(16363)] = 575806,
  [SMALL_STATE(16364)] = 575823,
  [SMALL_STATE(16365)] = 575836,
  [SMALL_STATE(16366)] = 575849,
  [SMALL_STATE(16367)] = 575868,
  [SMALL_STATE(16368)] = 575887,
  [SMALL_STATE(16369)] = 575906,
  [SMALL_STATE(16370)] = 575923,
  [SMALL_STATE(16371)] = 575936,
  [SMALL_STATE(16372)] = 575955,
  [SMALL_STATE(16373)] = 575972,
  [SMALL_STATE(16374)] = 575989,
  [SMALL_STATE(16375)] = 576006,
  [SMALL_STATE(16376)] = 576025,
  [SMALL_STATE(16377)] = 576044,
  [SMALL_STATE(16378)] = 576063,
  [SMALL_STATE(16379)] = 576082,
  [SMALL_STATE(16380)] = 576101,
  [SMALL_STATE(16381)] = 576120,
  [SMALL_STATE(16382)] = 576137,
  [SMALL_STATE(16383)] = 576156,
  [SMALL_STATE(16384)] = 576173,
  [SMALL_STATE(16385)] = 576186,
  [SMALL_STATE(16386)] = 576203,
  [SMALL_STATE(16387)] = 576222,
  [SMALL_STATE(16388)] = 576241,
  [SMALL_STATE(16389)] = 576260,
  [SMALL_STATE(16390)] = 576275,
  [SMALL_STATE(16391)] = 576292,
  [SMALL_STATE(16392)] = 576311,
  [SMALL_STATE(16393)] = 576330,
  [SMALL_STATE(16394)] = 576347,
  [SMALL_STATE(16395)] = 576360,
  [SMALL_STATE(16396)] = 576373,
  [SMALL_STATE(16397)] = 576392,
  [SMALL_STATE(16398)] = 576411,
  [SMALL_STATE(16399)] = 576424,
  [SMALL_STATE(16400)] = 576443,
  [SMALL_STATE(16401)] = 576460,
  [SMALL_STATE(16402)] = 576477,
  [SMALL_STATE(16403)] = 576496,
  [SMALL_STATE(16404)] = 576515,
  [SMALL_STATE(16405)] = 576532,
  [SMALL_STATE(16406)] = 576551,
  [SMALL_STATE(16407)] = 576570,
  [SMALL_STATE(16408)] = 576587,
  [SMALL_STATE(16409)] = 576606,
  [SMALL_STATE(16410)] = 576623,
  [SMALL_STATE(16411)] = 576642,
  [SMALL_STATE(16412)] = 576661,
  [SMALL_STATE(16413)] = 576678,
  [SMALL_STATE(16414)] = 576695,
  [SMALL_STATE(16415)] = 576714,
  [SMALL_STATE(16416)] = 576733,
  [SMALL_STATE(16417)] = 576750,
  [SMALL_STATE(16418)] = 576769,
  [SMALL_STATE(16419)] = 576788,
  [SMALL_STATE(16420)] = 576805,
  [SMALL_STATE(16421)] = 576818,
  [SMALL_STATE(16422)] = 576837,
  [SMALL_STATE(16423)] = 576854,
  [SMALL_STATE(16424)] = 576871,
  [SMALL_STATE(16425)] = 576888,
  [SMALL_STATE(16426)] = 576907,
  [SMALL_STATE(16427)] = 576926,
  [SMALL_STATE(16428)] = 576945,
  [SMALL_STATE(16429)] = 576964,
  [SMALL_STATE(16430)] = 576983,
  [SMALL_STATE(16431)] = 577000,
  [SMALL_STATE(16432)] = 577013,
  [SMALL_STATE(16433)] = 577032,
  [SMALL_STATE(16434)] = 577049,
  [SMALL_STATE(16435)] = 577066,
  [SMALL_STATE(16436)] = 577085,
  [SMALL_STATE(16437)] = 577102,
  [SMALL_STATE(16438)] = 577121,
  [SMALL_STATE(16439)] = 577140,
  [SMALL_STATE(16440)] = 577153,
  [SMALL_STATE(16441)] = 577172,
  [SMALL_STATE(16442)] = 577191,
  [SMALL_STATE(16443)] = 577208,
  [SMALL_STATE(16444)] = 577227,
  [SMALL_STATE(16445)] = 577246,
  [SMALL_STATE(16446)] = 577265,
  [SMALL_STATE(16447)] = 577284,
  [SMALL_STATE(16448)] = 577301,
  [SMALL_STATE(16449)] = 577318,
  [SMALL_STATE(16450)] = 577335,
  [SMALL_STATE(16451)] = 577354,
  [SMALL_STATE(16452)] = 577373,
  [SMALL_STATE(16453)] = 577390,
  [SMALL_STATE(16454)] = 577409,
  [SMALL_STATE(16455)] = 577426,
  [SMALL_STATE(16456)] = 577445,
  [SMALL_STATE(16457)] = 577464,
  [SMALL_STATE(16458)] = 577481,
  [SMALL_STATE(16459)] = 577498,
  [SMALL_STATE(16460)] = 577517,
  [SMALL_STATE(16461)] = 577536,
  [SMALL_STATE(16462)] = 577555,
  [SMALL_STATE(16463)] = 577568,
  [SMALL_STATE(16464)] = 577585,
  [SMALL_STATE(16465)] = 577602,
  [SMALL_STATE(16466)] = 577621,
  [SMALL_STATE(16467)] = 577634,
  [SMALL_STATE(16468)] = 577651,
  [SMALL_STATE(16469)] = 577668,
  [SMALL_STATE(16470)] = 577685,
  [SMALL_STATE(16471)] = 577704,
  [SMALL_STATE(16472)] = 577723,
  [SMALL_STATE(16473)] = 577740,
  [SMALL_STATE(16474)] = 577759,
  [SMALL_STATE(16475)] = 577778,
  [SMALL_STATE(16476)] = 577795,
  [SMALL_STATE(16477)] = 577814,
  [SMALL_STATE(16478)] = 577833,
  [SMALL_STATE(16479)] = 577852,
  [SMALL_STATE(16480)] = 577869,
  [SMALL_STATE(16481)] = 577888,
  [SMALL_STATE(16482)] = 577901,
  [SMALL_STATE(16483)] = 577920,
  [SMALL_STATE(16484)] = 577939,
  [SMALL_STATE(16485)] = 577954,
  [SMALL_STATE(16486)] = 577973,
  [SMALL_STATE(16487)] = 577990,
  [SMALL_STATE(16488)] = 578009,
  [SMALL_STATE(16489)] = 578028,
  [SMALL_STATE(16490)] = 578045,
  [SMALL_STATE(16491)] = 578064,
  [SMALL_STATE(16492)] = 578083,
  [SMALL_STATE(16493)] = 578102,
  [SMALL_STATE(16494)] = 578121,
  [SMALL_STATE(16495)] = 578140,
  [SMALL_STATE(16496)] = 578159,
  [SMALL_STATE(16497)] = 578178,
  [SMALL_STATE(16498)] = 578197,
  [SMALL_STATE(16499)] = 578216,
  [SMALL_STATE(16500)] = 578233,
  [SMALL_STATE(16501)] = 578252,
  [SMALL_STATE(16502)] = 578271,
  [SMALL_STATE(16503)] = 578290,
  [SMALL_STATE(16504)] = 578309,
  [SMALL_STATE(16505)] = 578328,
  [SMALL_STATE(16506)] = 578347,
  [SMALL_STATE(16507)] = 578364,
  [SMALL_STATE(16508)] = 578383,
  [SMALL_STATE(16509)] = 578402,
  [SMALL_STATE(16510)] = 578421,
  [SMALL_STATE(16511)] = 578440,
  [SMALL_STATE(16512)] = 578459,
  [SMALL_STATE(16513)] = 578472,
  [SMALL_STATE(16514)] = 578491,
  [SMALL_STATE(16515)] = 578508,
  [SMALL_STATE(16516)] = 578521,
  [SMALL_STATE(16517)] = 578538,
  [SMALL_STATE(16518)] = 578555,
  [SMALL_STATE(16519)] = 578574,
  [SMALL_STATE(16520)] = 578593,
  [SMALL_STATE(16521)] = 578612,
  [SMALL_STATE(16522)] = 578631,
  [SMALL_STATE(16523)] = 578648,
  [SMALL_STATE(16524)] = 578667,
  [SMALL_STATE(16525)] = 578686,
  [SMALL_STATE(16526)] = 578705,
  [SMALL_STATE(16527)] = 578724,
  [SMALL_STATE(16528)] = 578741,
  [SMALL_STATE(16529)] = 578760,
  [SMALL_STATE(16530)] = 578777,
  [SMALL_STATE(16531)] = 578794,
  [SMALL_STATE(16532)] = 578813,
  [SMALL_STATE(16533)] = 578830,
  [SMALL_STATE(16534)] = 578849,
  [SMALL_STATE(16535)] = 578866,
  [SMALL_STATE(16536)] = 578885,
  [SMALL_STATE(16537)] = 578902,
  [SMALL_STATE(16538)] = 578919,
  [SMALL_STATE(16539)] = 578938,
  [SMALL_STATE(16540)] = 578957,
  [SMALL_STATE(16541)] = 578970,
  [SMALL_STATE(16542)] = 578987,
  [SMALL_STATE(16543)] = 579002,
  [SMALL_STATE(16544)] = 579021,
  [SMALL_STATE(16545)] = 579038,
  [SMALL_STATE(16546)] = 579057,
  [SMALL_STATE(16547)] = 579076,
  [SMALL_STATE(16548)] = 579089,
  [SMALL_STATE(16549)] = 579102,
  [SMALL_STATE(16550)] = 579119,
  [SMALL_STATE(16551)] = 579138,
  [SMALL_STATE(16552)] = 579157,
  [SMALL_STATE(16553)] = 579170,
  [SMALL_STATE(16554)] = 579189,
  [SMALL_STATE(16555)] = 579206,
  [SMALL_STATE(16556)] = 579223,
  [SMALL_STATE(16557)] = 579242,
  [SMALL_STATE(16558)] = 579261,
  [SMALL_STATE(16559)] = 579274,
  [SMALL_STATE(16560)] = 579291,
  [SMALL_STATE(16561)] = 579308,
  [SMALL_STATE(16562)] = 579327,
  [SMALL_STATE(16563)] = 579346,
  [SMALL_STATE(16564)] = 579365,
  [SMALL_STATE(16565)] = 579384,
  [SMALL_STATE(16566)] = 579403,
  [SMALL_STATE(16567)] = 579420,
  [SMALL_STATE(16568)] = 579439,
  [SMALL_STATE(16569)] = 579458,
  [SMALL_STATE(16570)] = 579475,
  [SMALL_STATE(16571)] = 579494,
  [SMALL_STATE(16572)] = 579513,
  [SMALL_STATE(16573)] = 579530,
  [SMALL_STATE(16574)] = 579547,
  [SMALL_STATE(16575)] = 579566,
  [SMALL_STATE(16576)] = 579585,
  [SMALL_STATE(16577)] = 579598,
  [SMALL_STATE(16578)] = 579615,
  [SMALL_STATE(16579)] = 579628,
  [SMALL_STATE(16580)] = 579647,
  [SMALL_STATE(16581)] = 579666,
  [SMALL_STATE(16582)] = 579685,
  [SMALL_STATE(16583)] = 579702,
  [SMALL_STATE(16584)] = 579721,
  [SMALL_STATE(16585)] = 579740,
  [SMALL_STATE(16586)] = 579757,
  [SMALL_STATE(16587)] = 579776,
  [SMALL_STATE(16588)] = 579795,
  [SMALL_STATE(16589)] = 579814,
  [SMALL_STATE(16590)] = 579831,
  [SMALL_STATE(16591)] = 579850,
  [SMALL_STATE(16592)] = 579869,
  [SMALL_STATE(16593)] = 579888,
  [SMALL_STATE(16594)] = 579907,
  [SMALL_STATE(16595)] = 579924,
  [SMALL_STATE(16596)] = 579941,
  [SMALL_STATE(16597)] = 579958,
  [SMALL_STATE(16598)] = 579977,
  [SMALL_STATE(16599)] = 579996,
  [SMALL_STATE(16600)] = 580015,
  [SMALL_STATE(16601)] = 580034,
  [SMALL_STATE(16602)] = 580053,
  [SMALL_STATE(16603)] = 580072,
  [SMALL_STATE(16604)] = 580089,
  [SMALL_STATE(16605)] = 580108,
  [SMALL_STATE(16606)] = 580125,
  [SMALL_STATE(16607)] = 580144,
  [SMALL_STATE(16608)] = 580163,
  [SMALL_STATE(16609)] = 580176,
  [SMALL_STATE(16610)] = 580195,
  [SMALL_STATE(16611)] = 580214,
  [SMALL_STATE(16612)] = 580231,
  [SMALL_STATE(16613)] = 580250,
  [SMALL_STATE(16614)] = 580269,
  [SMALL_STATE(16615)] = 580288,
  [SMALL_STATE(16616)] = 580307,
  [SMALL_STATE(16617)] = 580324,
  [SMALL_STATE(16618)] = 580341,
  [SMALL_STATE(16619)] = 580358,
  [SMALL_STATE(16620)] = 580377,
  [SMALL_STATE(16621)] = 580390,
  [SMALL_STATE(16622)] = 580409,
  [SMALL_STATE(16623)] = 580428,
  [SMALL_STATE(16624)] = 580441,
  [SMALL_STATE(16625)] = 580458,
  [SMALL_STATE(16626)] = 580475,
  [SMALL_STATE(16627)] = 580494,
  [SMALL_STATE(16628)] = 580507,
  [SMALL_STATE(16629)] = 580524,
  [SMALL_STATE(16630)] = 580543,
  [SMALL_STATE(16631)] = 580562,
  [SMALL_STATE(16632)] = 580581,
  [SMALL_STATE(16633)] = 580598,
  [SMALL_STATE(16634)] = 580617,
  [SMALL_STATE(16635)] = 580636,
  [SMALL_STATE(16636)] = 580655,
  [SMALL_STATE(16637)] = 580674,
  [SMALL_STATE(16638)] = 580693,
  [SMALL_STATE(16639)] = 580712,
  [SMALL_STATE(16640)] = 580731,
  [SMALL_STATE(16641)] = 580748,
  [SMALL_STATE(16642)] = 580767,
  [SMALL_STATE(16643)] = 580784,
  [SMALL_STATE(16644)] = 580803,
  [SMALL_STATE(16645)] = 580820,
  [SMALL_STATE(16646)] = 580839,
  [SMALL_STATE(16647)] = 580858,
  [SMALL_STATE(16648)] = 580877,
  [SMALL_STATE(16649)] = 580896,
  [SMALL_STATE(16650)] = 580915,
  [SMALL_STATE(16651)] = 580934,
  [SMALL_STATE(16652)] = 580951,
  [SMALL_STATE(16653)] = 580968,
  [SMALL_STATE(16654)] = 580981,
  [SMALL_STATE(16655)] = 581000,
  [SMALL_STATE(16656)] = 581013,
  [SMALL_STATE(16657)] = 581030,
  [SMALL_STATE(16658)] = 581047,
  [SMALL_STATE(16659)] = 581064,
  [SMALL_STATE(16660)] = 581081,
  [SMALL_STATE(16661)] = 581098,
  [SMALL_STATE(16662)] = 581117,
  [SMALL_STATE(16663)] = 581136,
  [SMALL_STATE(16664)] = 581153,
  [SMALL_STATE(16665)] = 581170,
  [SMALL_STATE(16666)] = 581189,
  [SMALL_STATE(16667)] = 581206,
  [SMALL_STATE(16668)] = 581225,
  [SMALL_STATE(16669)] = 581244,
  [SMALL_STATE(16670)] = 581261,
  [SMALL_STATE(16671)] = 581278,
  [SMALL_STATE(16672)] = 581297,
  [SMALL_STATE(16673)] = 581316,
  [SMALL_STATE(16674)] = 581329,
  [SMALL_STATE(16675)] = 581348,
  [SMALL_STATE(16676)] = 581365,
  [SMALL_STATE(16677)] = 581384,
  [SMALL_STATE(16678)] = 581401,
  [SMALL_STATE(16679)] = 581420,
  [SMALL_STATE(16680)] = 581439,
  [SMALL_STATE(16681)] = 581456,
  [SMALL_STATE(16682)] = 581475,
  [SMALL_STATE(16683)] = 581494,
  [SMALL_STATE(16684)] = 581513,
  [SMALL_STATE(16685)] = 581532,
  [SMALL_STATE(16686)] = 581549,
  [SMALL_STATE(16687)] = 581568,
  [SMALL_STATE(16688)] = 581585,
  [SMALL_STATE(16689)] = 581604,
  [SMALL_STATE(16690)] = 581623,
  [SMALL_STATE(16691)] = 581642,
  [SMALL_STATE(16692)] = 581659,
  [SMALL_STATE(16693)] = 581678,
  [SMALL_STATE(16694)] = 581697,
  [SMALL_STATE(16695)] = 581710,
  [SMALL_STATE(16696)] = 581729,
  [SMALL_STATE(16697)] = 581748,
  [SMALL_STATE(16698)] = 581767,
  [SMALL_STATE(16699)] = 581784,
  [SMALL_STATE(16700)] = 581797,
  [SMALL_STATE(16701)] = 581814,
  [SMALL_STATE(16702)] = 581831,
  [SMALL_STATE(16703)] = 581850,
  [SMALL_STATE(16704)] = 581869,
  [SMALL_STATE(16705)] = 581888,
  [SMALL_STATE(16706)] = 581907,
  [SMALL_STATE(16707)] = 581926,
  [SMALL_STATE(16708)] = 581939,
  [SMALL_STATE(16709)] = 581958,
  [SMALL_STATE(16710)] = 581971,
  [SMALL_STATE(16711)] = 581988,
  [SMALL_STATE(16712)] = 582007,
  [SMALL_STATE(16713)] = 582020,
  [SMALL_STATE(16714)] = 582039,
  [SMALL_STATE(16715)] = 582058,
  [SMALL_STATE(16716)] = 582075,
  [SMALL_STATE(16717)] = 582092,
  [SMALL_STATE(16718)] = 582111,
  [SMALL_STATE(16719)] = 582128,
  [SMALL_STATE(16720)] = 582145,
  [SMALL_STATE(16721)] = 582164,
  [SMALL_STATE(16722)] = 582181,
  [SMALL_STATE(16723)] = 582198,
  [SMALL_STATE(16724)] = 582217,
  [SMALL_STATE(16725)] = 582236,
  [SMALL_STATE(16726)] = 582249,
  [SMALL_STATE(16727)] = 582268,
  [SMALL_STATE(16728)] = 582287,
  [SMALL_STATE(16729)] = 582304,
  [SMALL_STATE(16730)] = 582323,
  [SMALL_STATE(16731)] = 582342,
  [SMALL_STATE(16732)] = 582355,
  [SMALL_STATE(16733)] = 582372,
  [SMALL_STATE(16734)] = 582391,
  [SMALL_STATE(16735)] = 582408,
  [SMALL_STATE(16736)] = 582427,
  [SMALL_STATE(16737)] = 582446,
  [SMALL_STATE(16738)] = 582461,
  [SMALL_STATE(16739)] = 582480,
  [SMALL_STATE(16740)] = 582499,
  [SMALL_STATE(16741)] = 582516,
  [SMALL_STATE(16742)] = 582535,
  [SMALL_STATE(16743)] = 582554,
  [SMALL_STATE(16744)] = 582573,
  [SMALL_STATE(16745)] = 582592,
  [SMALL_STATE(16746)] = 582605,
  [SMALL_STATE(16747)] = 582622,
  [SMALL_STATE(16748)] = 582641,
  [SMALL_STATE(16749)] = 582658,
  [SMALL_STATE(16750)] = 582677,
  [SMALL_STATE(16751)] = 582696,
  [SMALL_STATE(16752)] = 582715,
  [SMALL_STATE(16753)] = 582734,
  [SMALL_STATE(16754)] = 582751,
  [SMALL_STATE(16755)] = 582770,
  [SMALL_STATE(16756)] = 582789,
  [SMALL_STATE(16757)] = 582806,
  [SMALL_STATE(16758)] = 582825,
  [SMALL_STATE(16759)] = 582838,
  [SMALL_STATE(16760)] = 582857,
  [SMALL_STATE(16761)] = 582870,
  [SMALL_STATE(16762)] = 582889,
  [SMALL_STATE(16763)] = 582902,
  [SMALL_STATE(16764)] = 582921,
  [SMALL_STATE(16765)] = 582938,
  [SMALL_STATE(16766)] = 582957,
  [SMALL_STATE(16767)] = 582974,
  [SMALL_STATE(16768)] = 582993,
  [SMALL_STATE(16769)] = 583012,
  [SMALL_STATE(16770)] = 583029,
  [SMALL_STATE(16771)] = 583048,
  [SMALL_STATE(16772)] = 583067,
  [SMALL_STATE(16773)] = 583086,
  [SMALL_STATE(16774)] = 583105,
  [SMALL_STATE(16775)] = 583122,
  [SMALL_STATE(16776)] = 583141,
  [SMALL_STATE(16777)] = 583160,
  [SMALL_STATE(16778)] = 583177,
  [SMALL_STATE(16779)] = 583196,
  [SMALL_STATE(16780)] = 583215,
  [SMALL_STATE(16781)] = 583234,
  [SMALL_STATE(16782)] = 583251,
  [SMALL_STATE(16783)] = 583270,
  [SMALL_STATE(16784)] = 583287,
  [SMALL_STATE(16785)] = 583306,
  [SMALL_STATE(16786)] = 583325,
  [SMALL_STATE(16787)] = 583344,
  [SMALL_STATE(16788)] = 583361,
  [SMALL_STATE(16789)] = 583378,
  [SMALL_STATE(16790)] = 583397,
  [SMALL_STATE(16791)] = 583410,
  [SMALL_STATE(16792)] = 583429,
  [SMALL_STATE(16793)] = 583448,
  [SMALL_STATE(16794)] = 583465,
  [SMALL_STATE(16795)] = 583482,
  [SMALL_STATE(16796)] = 583501,
  [SMALL_STATE(16797)] = 583520,
  [SMALL_STATE(16798)] = 583539,
  [SMALL_STATE(16799)] = 583556,
  [SMALL_STATE(16800)] = 583573,
  [SMALL_STATE(16801)] = 583590,
  [SMALL_STATE(16802)] = 583609,
  [SMALL_STATE(16803)] = 583626,
  [SMALL_STATE(16804)] = 583643,
  [SMALL_STATE(16805)] = 583660,
  [SMALL_STATE(16806)] = 583679,
  [SMALL_STATE(16807)] = 583698,
  [SMALL_STATE(16808)] = 583717,
  [SMALL_STATE(16809)] = 583736,
  [SMALL_STATE(16810)] = 583749,
  [SMALL_STATE(16811)] = 583768,
  [SMALL_STATE(16812)] = 583781,
  [SMALL_STATE(16813)] = 583798,
  [SMALL_STATE(16814)] = 583817,
  [SMALL_STATE(16815)] = 583836,
  [SMALL_STATE(16816)] = 583855,
  [SMALL_STATE(16817)] = 583872,
  [SMALL_STATE(16818)] = 583891,
  [SMALL_STATE(16819)] = 583910,
  [SMALL_STATE(16820)] = 583929,
  [SMALL_STATE(16821)] = 583946,
  [SMALL_STATE(16822)] = 583963,
  [SMALL_STATE(16823)] = 583982,
  [SMALL_STATE(16824)] = 583999,
  [SMALL_STATE(16825)] = 584012,
  [SMALL_STATE(16826)] = 584025,
  [SMALL_STATE(16827)] = 584044,
  [SMALL_STATE(16828)] = 584063,
  [SMALL_STATE(16829)] = 584082,
  [SMALL_STATE(16830)] = 584101,
  [SMALL_STATE(16831)] = 584120,
  [SMALL_STATE(16832)] = 584137,
  [SMALL_STATE(16833)] = 584154,
  [SMALL_STATE(16834)] = 584171,
  [SMALL_STATE(16835)] = 584190,
  [SMALL_STATE(16836)] = 584209,
  [SMALL_STATE(16837)] = 584224,
  [SMALL_STATE(16838)] = 584241,
  [SMALL_STATE(16839)] = 584258,
  [SMALL_STATE(16840)] = 584277,
  [SMALL_STATE(16841)] = 584296,
  [SMALL_STATE(16842)] = 584313,
  [SMALL_STATE(16843)] = 584326,
  [SMALL_STATE(16844)] = 584345,
  [SMALL_STATE(16845)] = 584364,
  [SMALL_STATE(16846)] = 584383,
  [SMALL_STATE(16847)] = 584402,
  [SMALL_STATE(16848)] = 584419,
  [SMALL_STATE(16849)] = 584438,
  [SMALL_STATE(16850)] = 584455,
  [SMALL_STATE(16851)] = 584474,
  [SMALL_STATE(16852)] = 584493,
  [SMALL_STATE(16853)] = 584506,
  [SMALL_STATE(16854)] = 584523,
  [SMALL_STATE(16855)] = 584542,
  [SMALL_STATE(16856)] = 584559,
  [SMALL_STATE(16857)] = 584576,
  [SMALL_STATE(16858)] = 584589,
  [SMALL_STATE(16859)] = 584608,
  [SMALL_STATE(16860)] = 584625,
  [SMALL_STATE(16861)] = 584644,
  [SMALL_STATE(16862)] = 584663,
  [SMALL_STATE(16863)] = 584680,
  [SMALL_STATE(16864)] = 584697,
  [SMALL_STATE(16865)] = 584710,
  [SMALL_STATE(16866)] = 584729,
  [SMALL_STATE(16867)] = 584742,
  [SMALL_STATE(16868)] = 584761,
  [SMALL_STATE(16869)] = 584774,
  [SMALL_STATE(16870)] = 584793,
  [SMALL_STATE(16871)] = 584810,
  [SMALL_STATE(16872)] = 584829,
  [SMALL_STATE(16873)] = 584846,
  [SMALL_STATE(16874)] = 584863,
  [SMALL_STATE(16875)] = 584882,
  [SMALL_STATE(16876)] = 584899,
  [SMALL_STATE(16877)] = 584918,
  [SMALL_STATE(16878)] = 584937,
  [SMALL_STATE(16879)] = 584950,
  [SMALL_STATE(16880)] = 584969,
  [SMALL_STATE(16881)] = 584986,
  [SMALL_STATE(16882)] = 585003,
  [SMALL_STATE(16883)] = 585022,
  [SMALL_STATE(16884)] = 585041,
  [SMALL_STATE(16885)] = 585060,
  [SMALL_STATE(16886)] = 585079,
  [SMALL_STATE(16887)] = 585096,
  [SMALL_STATE(16888)] = 585113,
  [SMALL_STATE(16889)] = 585132,
  [SMALL_STATE(16890)] = 585149,
  [SMALL_STATE(16891)] = 585168,
  [SMALL_STATE(16892)] = 585185,
  [SMALL_STATE(16893)] = 585204,
  [SMALL_STATE(16894)] = 585223,
  [SMALL_STATE(16895)] = 585242,
  [SMALL_STATE(16896)] = 585261,
  [SMALL_STATE(16897)] = 585280,
  [SMALL_STATE(16898)] = 585299,
  [SMALL_STATE(16899)] = 585316,
  [SMALL_STATE(16900)] = 585333,
  [SMALL_STATE(16901)] = 585352,
  [SMALL_STATE(16902)] = 585371,
  [SMALL_STATE(16903)] = 585388,
  [SMALL_STATE(16904)] = 585405,
  [SMALL_STATE(16905)] = 585424,
  [SMALL_STATE(16906)] = 585441,
  [SMALL_STATE(16907)] = 585460,
  [SMALL_STATE(16908)] = 585479,
  [SMALL_STATE(16909)] = 585496,
  [SMALL_STATE(16910)] = 585513,
  [SMALL_STATE(16911)] = 585532,
  [SMALL_STATE(16912)] = 585549,
  [SMALL_STATE(16913)] = 585568,
  [SMALL_STATE(16914)] = 585585,
  [SMALL_STATE(16915)] = 585604,
  [SMALL_STATE(16916)] = 585621,
  [SMALL_STATE(16917)] = 585640,
  [SMALL_STATE(16918)] = 585657,
  [SMALL_STATE(16919)] = 585670,
  [SMALL_STATE(16920)] = 585689,
  [SMALL_STATE(16921)] = 585708,
  [SMALL_STATE(16922)] = 585727,
  [SMALL_STATE(16923)] = 585744,
  [SMALL_STATE(16924)] = 585761,
  [SMALL_STATE(16925)] = 585780,
  [SMALL_STATE(16926)] = 585797,
  [SMALL_STATE(16927)] = 585814,
  [SMALL_STATE(16928)] = 585833,
  [SMALL_STATE(16929)] = 585852,
  [SMALL_STATE(16930)] = 585869,
  [SMALL_STATE(16931)] = 585888,
  [SMALL_STATE(16932)] = 585907,
  [SMALL_STATE(16933)] = 585924,
  [SMALL_STATE(16934)] = 585943,
  [SMALL_STATE(16935)] = 585962,
  [SMALL_STATE(16936)] = 585981,
  [SMALL_STATE(16937)] = 585994,
  [SMALL_STATE(16938)] = 586013,
  [SMALL_STATE(16939)] = 586032,
  [SMALL_STATE(16940)] = 586045,
  [SMALL_STATE(16941)] = 586058,
  [SMALL_STATE(16942)] = 586075,
  [SMALL_STATE(16943)] = 586088,
  [SMALL_STATE(16944)] = 586107,
  [SMALL_STATE(16945)] = 586120,
  [SMALL_STATE(16946)] = 586137,
  [SMALL_STATE(16947)] = 586150,
  [SMALL_STATE(16948)] = 586169,
  [SMALL_STATE(16949)] = 586182,
  [SMALL_STATE(16950)] = 586201,
  [SMALL_STATE(16951)] = 586220,
  [SMALL_STATE(16952)] = 586239,
  [SMALL_STATE(16953)] = 586256,
  [SMALL_STATE(16954)] = 586269,
  [SMALL_STATE(16955)] = 586288,
  [SMALL_STATE(16956)] = 586301,
  [SMALL_STATE(16957)] = 586318,
  [SMALL_STATE(16958)] = 586337,
  [SMALL_STATE(16959)] = 586356,
  [SMALL_STATE(16960)] = 586375,
  [SMALL_STATE(16961)] = 586392,
  [SMALL_STATE(16962)] = 586405,
  [SMALL_STATE(16963)] = 586424,
  [SMALL_STATE(16964)] = 586441,
  [SMALL_STATE(16965)] = 586460,
  [SMALL_STATE(16966)] = 586479,
  [SMALL_STATE(16967)] = 586496,
  [SMALL_STATE(16968)] = 586515,
  [SMALL_STATE(16969)] = 586532,
  [SMALL_STATE(16970)] = 586551,
  [SMALL_STATE(16971)] = 586570,
  [SMALL_STATE(16972)] = 586589,
  [SMALL_STATE(16973)] = 586608,
  [SMALL_STATE(16974)] = 586627,
  [SMALL_STATE(16975)] = 586646,
  [SMALL_STATE(16976)] = 586665,
  [SMALL_STATE(16977)] = 586684,
  [SMALL_STATE(16978)] = 586703,
  [SMALL_STATE(16979)] = 586722,
  [SMALL_STATE(16980)] = 586739,
  [SMALL_STATE(16981)] = 586756,
  [SMALL_STATE(16982)] = 586769,
  [SMALL_STATE(16983)] = 586788,
  [SMALL_STATE(16984)] = 586807,
  [SMALL_STATE(16985)] = 586826,
  [SMALL_STATE(16986)] = 586839,
  [SMALL_STATE(16987)] = 586858,
  [SMALL_STATE(16988)] = 586875,
  [SMALL_STATE(16989)] = 586894,
  [SMALL_STATE(16990)] = 586913,
  [SMALL_STATE(16991)] = 586930,
  [SMALL_STATE(16992)] = 586943,
  [SMALL_STATE(16993)] = 586962,
  [SMALL_STATE(16994)] = 586975,
  [SMALL_STATE(16995)] = 586992,
  [SMALL_STATE(16996)] = 587009,
  [SMALL_STATE(16997)] = 587028,
  [SMALL_STATE(16998)] = 587047,
  [SMALL_STATE(16999)] = 587064,
  [SMALL_STATE(17000)] = 587077,
  [SMALL_STATE(17001)] = 587096,
  [SMALL_STATE(17002)] = 587115,
  [SMALL_STATE(17003)] = 587132,
  [SMALL_STATE(17004)] = 587145,
  [SMALL_STATE(17005)] = 587164,
  [SMALL_STATE(17006)] = 587177,
  [SMALL_STATE(17007)] = 587196,
  [SMALL_STATE(17008)] = 587215,
  [SMALL_STATE(17009)] = 587228,
  [SMALL_STATE(17010)] = 587241,
  [SMALL_STATE(17011)] = 587260,
  [SMALL_STATE(17012)] = 587279,
  [SMALL_STATE(17013)] = 587296,
  [SMALL_STATE(17014)] = 587315,
  [SMALL_STATE(17015)] = 587332,
  [SMALL_STATE(17016)] = 587351,
  [SMALL_STATE(17017)] = 587370,
  [SMALL_STATE(17018)] = 587389,
  [SMALL_STATE(17019)] = 587408,
  [SMALL_STATE(17020)] = 587425,
  [SMALL_STATE(17021)] = 587442,
  [SMALL_STATE(17022)] = 587461,
  [SMALL_STATE(17023)] = 587480,
  [SMALL_STATE(17024)] = 587499,
  [SMALL_STATE(17025)] = 587518,
  [SMALL_STATE(17026)] = 587537,
  [SMALL_STATE(17027)] = 587556,
  [SMALL_STATE(17028)] = 587575,
  [SMALL_STATE(17029)] = 587594,
  [SMALL_STATE(17030)] = 587611,
  [SMALL_STATE(17031)] = 587630,
  [SMALL_STATE(17032)] = 587649,
  [SMALL_STATE(17033)] = 587668,
  [SMALL_STATE(17034)] = 587685,
  [SMALL_STATE(17035)] = 587704,
  [SMALL_STATE(17036)] = 587723,
  [SMALL_STATE(17037)] = 587740,
  [SMALL_STATE(17038)] = 587759,
  [SMALL_STATE(17039)] = 587778,
  [SMALL_STATE(17040)] = 587797,
  [SMALL_STATE(17041)] = 587814,
  [SMALL_STATE(17042)] = 587827,
  [SMALL_STATE(17043)] = 587846,
  [SMALL_STATE(17044)] = 587863,
  [SMALL_STATE(17045)] = 587882,
  [SMALL_STATE(17046)] = 587901,
  [SMALL_STATE(17047)] = 587914,
  [SMALL_STATE(17048)] = 587931,
  [SMALL_STATE(17049)] = 587950,
  [SMALL_STATE(17050)] = 587967,
  [SMALL_STATE(17051)] = 587984,
  [SMALL_STATE(17052)] = 588003,
  [SMALL_STATE(17053)] = 588022,
  [SMALL_STATE(17054)] = 588037,
  [SMALL_STATE(17055)] = 588056,
  [SMALL_STATE(17056)] = 588073,
  [SMALL_STATE(17057)] = 588092,
  [SMALL_STATE(17058)] = 588109,
  [SMALL_STATE(17059)] = 588128,
  [SMALL_STATE(17060)] = 588147,
  [SMALL_STATE(17061)] = 588164,
  [SMALL_STATE(17062)] = 588181,
  [SMALL_STATE(17063)] = 588200,
  [SMALL_STATE(17064)] = 588213,
  [SMALL_STATE(17065)] = 588232,
  [SMALL_STATE(17066)] = 588249,
  [SMALL_STATE(17067)] = 588268,
  [SMALL_STATE(17068)] = 588285,
  [SMALL_STATE(17069)] = 588298,
  [SMALL_STATE(17070)] = 588315,
  [SMALL_STATE(17071)] = 588334,
  [SMALL_STATE(17072)] = 588353,
  [SMALL_STATE(17073)] = 588366,
  [SMALL_STATE(17074)] = 588385,
  [SMALL_STATE(17075)] = 588398,
  [SMALL_STATE(17076)] = 588411,
  [SMALL_STATE(17077)] = 588430,
  [SMALL_STATE(17078)] = 588447,
  [SMALL_STATE(17079)] = 588464,
  [SMALL_STATE(17080)] = 588483,
  [SMALL_STATE(17081)] = 588502,
  [SMALL_STATE(17082)] = 588515,
  [SMALL_STATE(17083)] = 588534,
  [SMALL_STATE(17084)] = 588551,
  [SMALL_STATE(17085)] = 588568,
  [SMALL_STATE(17086)] = 588585,
  [SMALL_STATE(17087)] = 588604,
  [SMALL_STATE(17088)] = 588623,
  [SMALL_STATE(17089)] = 588642,
  [SMALL_STATE(17090)] = 588655,
  [SMALL_STATE(17091)] = 588668,
  [SMALL_STATE(17092)] = 588681,
  [SMALL_STATE(17093)] = 588700,
  [SMALL_STATE(17094)] = 588719,
  [SMALL_STATE(17095)] = 588738,
  [SMALL_STATE(17096)] = 588751,
  [SMALL_STATE(17097)] = 588770,
  [SMALL_STATE(17098)] = 588789,
  [SMALL_STATE(17099)] = 588808,
  [SMALL_STATE(17100)] = 588825,
  [SMALL_STATE(17101)] = 588844,
  [SMALL_STATE(17102)] = 588863,
  [SMALL_STATE(17103)] = 588880,
  [SMALL_STATE(17104)] = 588899,
  [SMALL_STATE(17105)] = 588918,
  [SMALL_STATE(17106)] = 588937,
  [SMALL_STATE(17107)] = 588954,
  [SMALL_STATE(17108)] = 588971,
  [SMALL_STATE(17109)] = 588990,
  [SMALL_STATE(17110)] = 589009,
  [SMALL_STATE(17111)] = 589026,
  [SMALL_STATE(17112)] = 589045,
  [SMALL_STATE(17113)] = 589062,
  [SMALL_STATE(17114)] = 589081,
  [SMALL_STATE(17115)] = 589100,
  [SMALL_STATE(17116)] = 589117,
  [SMALL_STATE(17117)] = 589136,
  [SMALL_STATE(17118)] = 589155,
  [SMALL_STATE(17119)] = 589172,
  [SMALL_STATE(17120)] = 589189,
  [SMALL_STATE(17121)] = 589208,
  [SMALL_STATE(17122)] = 589227,
  [SMALL_STATE(17123)] = 589246,
  [SMALL_STATE(17124)] = 589265,
  [SMALL_STATE(17125)] = 589282,
  [SMALL_STATE(17126)] = 589295,
  [SMALL_STATE(17127)] = 589314,
  [SMALL_STATE(17128)] = 589331,
  [SMALL_STATE(17129)] = 589348,
  [SMALL_STATE(17130)] = 589367,
  [SMALL_STATE(17131)] = 589384,
  [SMALL_STATE(17132)] = 589403,
  [SMALL_STATE(17133)] = 589422,
  [SMALL_STATE(17134)] = 589441,
  [SMALL_STATE(17135)] = 589458,
  [SMALL_STATE(17136)] = 589475,
  [SMALL_STATE(17137)] = 589494,
  [SMALL_STATE(17138)] = 589511,
  [SMALL_STATE(17139)] = 589526,
  [SMALL_STATE(17140)] = 589545,
  [SMALL_STATE(17141)] = 589562,
  [SMALL_STATE(17142)] = 589579,
  [SMALL_STATE(17143)] = 589598,
  [SMALL_STATE(17144)] = 589617,
  [SMALL_STATE(17145)] = 589636,
  [SMALL_STATE(17146)] = 589655,
  [SMALL_STATE(17147)] = 589674,
  [SMALL_STATE(17148)] = 589693,
  [SMALL_STATE(17149)] = 589712,
  [SMALL_STATE(17150)] = 589731,
  [SMALL_STATE(17151)] = 589750,
  [SMALL_STATE(17152)] = 589767,
  [SMALL_STATE(17153)] = 589780,
  [SMALL_STATE(17154)] = 589797,
  [SMALL_STATE(17155)] = 589814,
  [SMALL_STATE(17156)] = 589833,
  [SMALL_STATE(17157)] = 589852,
  [SMALL_STATE(17158)] = 589871,
  [SMALL_STATE(17159)] = 589890,
  [SMALL_STATE(17160)] = 589907,
  [SMALL_STATE(17161)] = 589926,
  [SMALL_STATE(17162)] = 589945,
  [SMALL_STATE(17163)] = 589964,
  [SMALL_STATE(17164)] = 589983,
  [SMALL_STATE(17165)] = 590000,
  [SMALL_STATE(17166)] = 590019,
  [SMALL_STATE(17167)] = 590038,
  [SMALL_STATE(17168)] = 590057,
  [SMALL_STATE(17169)] = 590076,
  [SMALL_STATE(17170)] = 590089,
  [SMALL_STATE(17171)] = 590102,
  [SMALL_STATE(17172)] = 590121,
  [SMALL_STATE(17173)] = 590138,
  [SMALL_STATE(17174)] = 590151,
  [SMALL_STATE(17175)] = 590170,
  [SMALL_STATE(17176)] = 590189,
  [SMALL_STATE(17177)] = 590202,
  [SMALL_STATE(17178)] = 590221,
  [SMALL_STATE(17179)] = 590240,
  [SMALL_STATE(17180)] = 590259,
  [SMALL_STATE(17181)] = 590272,
  [SMALL_STATE(17182)] = 590289,
  [SMALL_STATE(17183)] = 590302,
  [SMALL_STATE(17184)] = 590315,
  [SMALL_STATE(17185)] = 590334,
  [SMALL_STATE(17186)] = 590351,
  [SMALL_STATE(17187)] = 590370,
  [SMALL_STATE(17188)] = 590389,
  [SMALL_STATE(17189)] = 590408,
  [SMALL_STATE(17190)] = 590427,
  [SMALL_STATE(17191)] = 590446,
  [SMALL_STATE(17192)] = 590463,
  [SMALL_STATE(17193)] = 590476,
  [SMALL_STATE(17194)] = 590495,
  [SMALL_STATE(17195)] = 590512,
  [SMALL_STATE(17196)] = 590531,
  [SMALL_STATE(17197)] = 590550,
  [SMALL_STATE(17198)] = 590563,
  [SMALL_STATE(17199)] = 590576,
  [SMALL_STATE(17200)] = 590595,
  [SMALL_STATE(17201)] = 590614,
  [SMALL_STATE(17202)] = 590631,
  [SMALL_STATE(17203)] = 590650,
  [SMALL_STATE(17204)] = 590669,
  [SMALL_STATE(17205)] = 590688,
  [SMALL_STATE(17206)] = 590707,
  [SMALL_STATE(17207)] = 590726,
  [SMALL_STATE(17208)] = 590739,
  [SMALL_STATE(17209)] = 590756,
  [SMALL_STATE(17210)] = 590771,
  [SMALL_STATE(17211)] = 590790,
  [SMALL_STATE(17212)] = 590809,
  [SMALL_STATE(17213)] = 590828,
  [SMALL_STATE(17214)] = 590841,
  [SMALL_STATE(17215)] = 590858,
  [SMALL_STATE(17216)] = 590877,
  [SMALL_STATE(17217)] = 590896,
  [SMALL_STATE(17218)] = 590909,
  [SMALL_STATE(17219)] = 590922,
  [SMALL_STATE(17220)] = 590941,
  [SMALL_STATE(17221)] = 590954,
  [SMALL_STATE(17222)] = 590973,
  [SMALL_STATE(17223)] = 590992,
  [SMALL_STATE(17224)] = 591011,
  [SMALL_STATE(17225)] = 591030,
  [SMALL_STATE(17226)] = 591049,
  [SMALL_STATE(17227)] = 591068,
  [SMALL_STATE(17228)] = 591085,
  [SMALL_STATE(17229)] = 591104,
  [SMALL_STATE(17230)] = 591121,
  [SMALL_STATE(17231)] = 591140,
  [SMALL_STATE(17232)] = 591157,
  [SMALL_STATE(17233)] = 591176,
  [SMALL_STATE(17234)] = 591193,
  [SMALL_STATE(17235)] = 591212,
  [SMALL_STATE(17236)] = 591229,
  [SMALL_STATE(17237)] = 591248,
  [SMALL_STATE(17238)] = 591265,
  [SMALL_STATE(17239)] = 591282,
  [SMALL_STATE(17240)] = 591301,
  [SMALL_STATE(17241)] = 591320,
  [SMALL_STATE(17242)] = 591339,
  [SMALL_STATE(17243)] = 591356,
  [SMALL_STATE(17244)] = 591375,
  [SMALL_STATE(17245)] = 591394,
  [SMALL_STATE(17246)] = 591407,
  [SMALL_STATE(17247)] = 591424,
  [SMALL_STATE(17248)] = 591443,
  [SMALL_STATE(17249)] = 591460,
  [SMALL_STATE(17250)] = 591477,
  [SMALL_STATE(17251)] = 591490,
  [SMALL_STATE(17252)] = 591507,
  [SMALL_STATE(17253)] = 591526,
  [SMALL_STATE(17254)] = 591545,
  [SMALL_STATE(17255)] = 591564,
  [SMALL_STATE(17256)] = 591583,
  [SMALL_STATE(17257)] = 591600,
  [SMALL_STATE(17258)] = 591617,
  [SMALL_STATE(17259)] = 591634,
  [SMALL_STATE(17260)] = 591653,
  [SMALL_STATE(17261)] = 591668,
  [SMALL_STATE(17262)] = 591685,
  [SMALL_STATE(17263)] = 591704,
  [SMALL_STATE(17264)] = 591721,
  [SMALL_STATE(17265)] = 591740,
  [SMALL_STATE(17266)] = 591759,
  [SMALL_STATE(17267)] = 591778,
  [SMALL_STATE(17268)] = 591797,
  [SMALL_STATE(17269)] = 591816,
  [SMALL_STATE(17270)] = 591835,
  [SMALL_STATE(17271)] = 591850,
  [SMALL_STATE(17272)] = 591867,
  [SMALL_STATE(17273)] = 591884,
  [SMALL_STATE(17274)] = 591901,
  [SMALL_STATE(17275)] = 591920,
  [SMALL_STATE(17276)] = 591937,
  [SMALL_STATE(17277)] = 591954,
  [SMALL_STATE(17278)] = 591973,
  [SMALL_STATE(17279)] = 591992,
  [SMALL_STATE(17280)] = 592009,
  [SMALL_STATE(17281)] = 592028,
  [SMALL_STATE(17282)] = 592047,
  [SMALL_STATE(17283)] = 592060,
  [SMALL_STATE(17284)] = 592079,
  [SMALL_STATE(17285)] = 592098,
  [SMALL_STATE(17286)] = 592115,
  [SMALL_STATE(17287)] = 592134,
  [SMALL_STATE(17288)] = 592153,
  [SMALL_STATE(17289)] = 592172,
  [SMALL_STATE(17290)] = 592185,
  [SMALL_STATE(17291)] = 592198,
  [SMALL_STATE(17292)] = 592215,
  [SMALL_STATE(17293)] = 592234,
  [SMALL_STATE(17294)] = 592253,
  [SMALL_STATE(17295)] = 592266,
  [SMALL_STATE(17296)] = 592285,
  [SMALL_STATE(17297)] = 592304,
  [SMALL_STATE(17298)] = 592321,
  [SMALL_STATE(17299)] = 592340,
  [SMALL_STATE(17300)] = 592359,
  [SMALL_STATE(17301)] = 592378,
  [SMALL_STATE(17302)] = 592397,
  [SMALL_STATE(17303)] = 592410,
  [SMALL_STATE(17304)] = 592427,
  [SMALL_STATE(17305)] = 592446,
  [SMALL_STATE(17306)] = 592465,
  [SMALL_STATE(17307)] = 592482,
  [SMALL_STATE(17308)] = 592499,
  [SMALL_STATE(17309)] = 592518,
  [SMALL_STATE(17310)] = 592537,
  [SMALL_STATE(17311)] = 592556,
  [SMALL_STATE(17312)] = 592573,
  [SMALL_STATE(17313)] = 592592,
  [SMALL_STATE(17314)] = 592609,
  [SMALL_STATE(17315)] = 592628,
  [SMALL_STATE(17316)] = 592647,
  [SMALL_STATE(17317)] = 592664,
  [SMALL_STATE(17318)] = 592681,
  [SMALL_STATE(17319)] = 592694,
  [SMALL_STATE(17320)] = 592709,
  [SMALL_STATE(17321)] = 592728,
  [SMALL_STATE(17322)] = 592741,
  [SMALL_STATE(17323)] = 592758,
  [SMALL_STATE(17324)] = 592775,
  [SMALL_STATE(17325)] = 592794,
  [SMALL_STATE(17326)] = 592807,
  [SMALL_STATE(17327)] = 592826,
  [SMALL_STATE(17328)] = 592845,
  [SMALL_STATE(17329)] = 592864,
  [SMALL_STATE(17330)] = 592881,
  [SMALL_STATE(17331)] = 592894,
  [SMALL_STATE(17332)] = 592911,
  [SMALL_STATE(17333)] = 592930,
  [SMALL_STATE(17334)] = 592947,
  [SMALL_STATE(17335)] = 592966,
  [SMALL_STATE(17336)] = 592985,
  [SMALL_STATE(17337)] = 593002,
  [SMALL_STATE(17338)] = 593021,
  [SMALL_STATE(17339)] = 593040,
  [SMALL_STATE(17340)] = 593059,
  [SMALL_STATE(17341)] = 593078,
  [SMALL_STATE(17342)] = 593097,
  [SMALL_STATE(17343)] = 593116,
  [SMALL_STATE(17344)] = 593135,
  [SMALL_STATE(17345)] = 593150,
  [SMALL_STATE(17346)] = 593169,
  [SMALL_STATE(17347)] = 593188,
  [SMALL_STATE(17348)] = 593207,
  [SMALL_STATE(17349)] = 593226,
  [SMALL_STATE(17350)] = 593243,
  [SMALL_STATE(17351)] = 593262,
  [SMALL_STATE(17352)] = 593281,
  [SMALL_STATE(17353)] = 593300,
  [SMALL_STATE(17354)] = 593317,
  [SMALL_STATE(17355)] = 593336,
  [SMALL_STATE(17356)] = 593355,
  [SMALL_STATE(17357)] = 593374,
  [SMALL_STATE(17358)] = 593387,
  [SMALL_STATE(17359)] = 593406,
  [SMALL_STATE(17360)] = 593425,
  [SMALL_STATE(17361)] = 593442,
  [SMALL_STATE(17362)] = 593459,
  [SMALL_STATE(17363)] = 593476,
  [SMALL_STATE(17364)] = 593495,
  [SMALL_STATE(17365)] = 593512,
  [SMALL_STATE(17366)] = 593531,
  [SMALL_STATE(17367)] = 593550,
  [SMALL_STATE(17368)] = 593569,
  [SMALL_STATE(17369)] = 593586,
  [SMALL_STATE(17370)] = 593603,
  [SMALL_STATE(17371)] = 593622,
  [SMALL_STATE(17372)] = 593639,
  [SMALL_STATE(17373)] = 593652,
  [SMALL_STATE(17374)] = 593671,
  [SMALL_STATE(17375)] = 593690,
  [SMALL_STATE(17376)] = 593709,
  [SMALL_STATE(17377)] = 593726,
  [SMALL_STATE(17378)] = 593741,
  [SMALL_STATE(17379)] = 593760,
  [SMALL_STATE(17380)] = 593773,
  [SMALL_STATE(17381)] = 593790,
  [SMALL_STATE(17382)] = 593809,
  [SMALL_STATE(17383)] = 593828,
  [SMALL_STATE(17384)] = 593847,
  [SMALL_STATE(17385)] = 593864,
  [SMALL_STATE(17386)] = 593883,
  [SMALL_STATE(17387)] = 593900,
  [SMALL_STATE(17388)] = 593917,
  [SMALL_STATE(17389)] = 593934,
  [SMALL_STATE(17390)] = 593953,
  [SMALL_STATE(17391)] = 593972,
  [SMALL_STATE(17392)] = 593985,
  [SMALL_STATE(17393)] = 594002,
  [SMALL_STATE(17394)] = 594019,
  [SMALL_STATE(17395)] = 594036,
  [SMALL_STATE(17396)] = 594055,
  [SMALL_STATE(17397)] = 594074,
  [SMALL_STATE(17398)] = 594091,
  [SMALL_STATE(17399)] = 594108,
  [SMALL_STATE(17400)] = 594127,
  [SMALL_STATE(17401)] = 594140,
  [SMALL_STATE(17402)] = 594157,
  [SMALL_STATE(17403)] = 594174,
  [SMALL_STATE(17404)] = 594193,
  [SMALL_STATE(17405)] = 594210,
  [SMALL_STATE(17406)] = 594229,
  [SMALL_STATE(17407)] = 594248,
  [SMALL_STATE(17408)] = 594267,
  [SMALL_STATE(17409)] = 594280,
  [SMALL_STATE(17410)] = 594299,
  [SMALL_STATE(17411)] = 594318,
  [SMALL_STATE(17412)] = 594335,
  [SMALL_STATE(17413)] = 594352,
  [SMALL_STATE(17414)] = 594371,
  [SMALL_STATE(17415)] = 594390,
  [SMALL_STATE(17416)] = 594407,
  [SMALL_STATE(17417)] = 594426,
  [SMALL_STATE(17418)] = 594439,
  [SMALL_STATE(17419)] = 594456,
  [SMALL_STATE(17420)] = 594473,
  [SMALL_STATE(17421)] = 594492,
  [SMALL_STATE(17422)] = 594505,
  [SMALL_STATE(17423)] = 594524,
  [SMALL_STATE(17424)] = 594543,
  [SMALL_STATE(17425)] = 594558,
  [SMALL_STATE(17426)] = 594577,
  [SMALL_STATE(17427)] = 594596,
  [SMALL_STATE(17428)] = 594615,
  [SMALL_STATE(17429)] = 594634,
  [SMALL_STATE(17430)] = 594651,
  [SMALL_STATE(17431)] = 594670,
  [SMALL_STATE(17432)] = 594689,
  [SMALL_STATE(17433)] = 594708,
  [SMALL_STATE(17434)] = 594727,
  [SMALL_STATE(17435)] = 594746,
  [SMALL_STATE(17436)] = 594765,
  [SMALL_STATE(17437)] = 594784,
  [SMALL_STATE(17438)] = 594801,
  [SMALL_STATE(17439)] = 594820,
  [SMALL_STATE(17440)] = 594839,
  [SMALL_STATE(17441)] = 594852,
  [SMALL_STATE(17442)] = 594865,
  [SMALL_STATE(17443)] = 594878,
  [SMALL_STATE(17444)] = 594897,
  [SMALL_STATE(17445)] = 594910,
  [SMALL_STATE(17446)] = 594923,
  [SMALL_STATE(17447)] = 594936,
  [SMALL_STATE(17448)] = 594953,
  [SMALL_STATE(17449)] = 594970,
  [SMALL_STATE(17450)] = 594989,
  [SMALL_STATE(17451)] = 595008,
  [SMALL_STATE(17452)] = 595027,
  [SMALL_STATE(17453)] = 595040,
  [SMALL_STATE(17454)] = 595059,
  [SMALL_STATE(17455)] = 595078,
  [SMALL_STATE(17456)] = 595097,
  [SMALL_STATE(17457)] = 595116,
  [SMALL_STATE(17458)] = 595135,
  [SMALL_STATE(17459)] = 595154,
  [SMALL_STATE(17460)] = 595167,
  [SMALL_STATE(17461)] = 595182,
  [SMALL_STATE(17462)] = 595199,
  [SMALL_STATE(17463)] = 595216,
  [SMALL_STATE(17464)] = 595229,
  [SMALL_STATE(17465)] = 595242,
  [SMALL_STATE(17466)] = 595261,
  [SMALL_STATE(17467)] = 595280,
  [SMALL_STATE(17468)] = 595295,
  [SMALL_STATE(17469)] = 595314,
  [SMALL_STATE(17470)] = 595327,
  [SMALL_STATE(17471)] = 595346,
  [SMALL_STATE(17472)] = 595365,
  [SMALL_STATE(17473)] = 595384,
  [SMALL_STATE(17474)] = 595401,
  [SMALL_STATE(17475)] = 595420,
  [SMALL_STATE(17476)] = 595439,
  [SMALL_STATE(17477)] = 595458,
  [SMALL_STATE(17478)] = 595475,
  [SMALL_STATE(17479)] = 595494,
  [SMALL_STATE(17480)] = 595511,
  [SMALL_STATE(17481)] = 595528,
  [SMALL_STATE(17482)] = 595547,
  [SMALL_STATE(17483)] = 595564,
  [SMALL_STATE(17484)] = 595583,
  [SMALL_STATE(17485)] = 595596,
  [SMALL_STATE(17486)] = 595613,
  [SMALL_STATE(17487)] = 595632,
  [SMALL_STATE(17488)] = 595651,
  [SMALL_STATE(17489)] = 595664,
  [SMALL_STATE(17490)] = 595683,
  [SMALL_STATE(17491)] = 595700,
  [SMALL_STATE(17492)] = 595719,
  [SMALL_STATE(17493)] = 595738,
  [SMALL_STATE(17494)] = 595757,
  [SMALL_STATE(17495)] = 595772,
  [SMALL_STATE(17496)] = 595789,
  [SMALL_STATE(17497)] = 595806,
  [SMALL_STATE(17498)] = 595825,
  [SMALL_STATE(17499)] = 595844,
  [SMALL_STATE(17500)] = 595861,
  [SMALL_STATE(17501)] = 595874,
  [SMALL_STATE(17502)] = 595893,
  [SMALL_STATE(17503)] = 595910,
  [SMALL_STATE(17504)] = 595927,
  [SMALL_STATE(17505)] = 595946,
  [SMALL_STATE(17506)] = 595965,
  [SMALL_STATE(17507)] = 595982,
  [SMALL_STATE(17508)] = 596001,
  [SMALL_STATE(17509)] = 596018,
  [SMALL_STATE(17510)] = 596037,
  [SMALL_STATE(17511)] = 596052,
  [SMALL_STATE(17512)] = 596069,
  [SMALL_STATE(17513)] = 596088,
  [SMALL_STATE(17514)] = 596105,
  [SMALL_STATE(17515)] = 596124,
  [SMALL_STATE(17516)] = 596143,
  [SMALL_STATE(17517)] = 596160,
  [SMALL_STATE(17518)] = 596179,
  [SMALL_STATE(17519)] = 596198,
  [SMALL_STATE(17520)] = 596217,
  [SMALL_STATE(17521)] = 596234,
  [SMALL_STATE(17522)] = 596253,
  [SMALL_STATE(17523)] = 596272,
  [SMALL_STATE(17524)] = 596289,
  [SMALL_STATE(17525)] = 596308,
  [SMALL_STATE(17526)] = 596325,
  [SMALL_STATE(17527)] = 596344,
  [SMALL_STATE(17528)] = 596361,
  [SMALL_STATE(17529)] = 596380,
  [SMALL_STATE(17530)] = 596397,
  [SMALL_STATE(17531)] = 596414,
  [SMALL_STATE(17532)] = 596431,
  [SMALL_STATE(17533)] = 596448,
  [SMALL_STATE(17534)] = 596467,
  [SMALL_STATE(17535)] = 596486,
  [SMALL_STATE(17536)] = 596505,
  [SMALL_STATE(17537)] = 596522,
  [SMALL_STATE(17538)] = 596539,
  [SMALL_STATE(17539)] = 596558,
  [SMALL_STATE(17540)] = 596577,
  [SMALL_STATE(17541)] = 596594,
  [SMALL_STATE(17542)] = 596613,
  [SMALL_STATE(17543)] = 596632,
  [SMALL_STATE(17544)] = 596651,
  [SMALL_STATE(17545)] = 596670,
  [SMALL_STATE(17546)] = 596689,
  [SMALL_STATE(17547)] = 596706,
  [SMALL_STATE(17548)] = 596725,
  [SMALL_STATE(17549)] = 596742,
  [SMALL_STATE(17550)] = 596761,
  [SMALL_STATE(17551)] = 596778,
  [SMALL_STATE(17552)] = 596797,
  [SMALL_STATE(17553)] = 596816,
  [SMALL_STATE(17554)] = 596831,
  [SMALL_STATE(17555)] = 596848,
  [SMALL_STATE(17556)] = 596867,
  [SMALL_STATE(17557)] = 596886,
  [SMALL_STATE(17558)] = 596899,
  [SMALL_STATE(17559)] = 596916,
  [SMALL_STATE(17560)] = 596935,
  [SMALL_STATE(17561)] = 596954,
  [SMALL_STATE(17562)] = 596973,
  [SMALL_STATE(17563)] = 596992,
  [SMALL_STATE(17564)] = 597009,
  [SMALL_STATE(17565)] = 597028,
  [SMALL_STATE(17566)] = 597047,
  [SMALL_STATE(17567)] = 597064,
  [SMALL_STATE(17568)] = 597083,
  [SMALL_STATE(17569)] = 597102,
  [SMALL_STATE(17570)] = 597121,
  [SMALL_STATE(17571)] = 597134,
  [SMALL_STATE(17572)] = 597147,
  [SMALL_STATE(17573)] = 597166,
  [SMALL_STATE(17574)] = 597185,
  [SMALL_STATE(17575)] = 597202,
  [SMALL_STATE(17576)] = 597221,
  [SMALL_STATE(17577)] = 597240,
  [SMALL_STATE(17578)] = 597259,
  [SMALL_STATE(17579)] = 597278,
  [SMALL_STATE(17580)] = 597291,
  [SMALL_STATE(17581)] = 597304,
  [SMALL_STATE(17582)] = 597323,
  [SMALL_STATE(17583)] = 597340,
  [SMALL_STATE(17584)] = 597359,
  [SMALL_STATE(17585)] = 597372,
  [SMALL_STATE(17586)] = 597391,
  [SMALL_STATE(17587)] = 597404,
  [SMALL_STATE(17588)] = 597417,
  [SMALL_STATE(17589)] = 597436,
  [SMALL_STATE(17590)] = 597453,
  [SMALL_STATE(17591)] = 597470,
  [SMALL_STATE(17592)] = 597489,
  [SMALL_STATE(17593)] = 597508,
  [SMALL_STATE(17594)] = 597521,
  [SMALL_STATE(17595)] = 597538,
  [SMALL_STATE(17596)] = 597551,
  [SMALL_STATE(17597)] = 597564,
  [SMALL_STATE(17598)] = 597577,
  [SMALL_STATE(17599)] = 597596,
  [SMALL_STATE(17600)] = 597613,
  [SMALL_STATE(17601)] = 597632,
  [SMALL_STATE(17602)] = 597651,
  [SMALL_STATE(17603)] = 597670,
  [SMALL_STATE(17604)] = 597689,
  [SMALL_STATE(17605)] = 597708,
  [SMALL_STATE(17606)] = 597727,
  [SMALL_STATE(17607)] = 597746,
  [SMALL_STATE(17608)] = 597765,
  [SMALL_STATE(17609)] = 597784,
  [SMALL_STATE(17610)] = 597797,
  [SMALL_STATE(17611)] = 597810,
  [SMALL_STATE(17612)] = 597823,
  [SMALL_STATE(17613)] = 597842,
  [SMALL_STATE(17614)] = 597861,
  [SMALL_STATE(17615)] = 597880,
  [SMALL_STATE(17616)] = 597893,
  [SMALL_STATE(17617)] = 597912,
  [SMALL_STATE(17618)] = 597931,
  [SMALL_STATE(17619)] = 597948,
  [SMALL_STATE(17620)] = 597961,
  [SMALL_STATE(17621)] = 597980,
  [SMALL_STATE(17622)] = 597999,
  [SMALL_STATE(17623)] = 598016,
  [SMALL_STATE(17624)] = 598033,
  [SMALL_STATE(17625)] = 598052,
  [SMALL_STATE(17626)] = 598065,
  [SMALL_STATE(17627)] = 598084,
  [SMALL_STATE(17628)] = 598101,
  [SMALL_STATE(17629)] = 598120,
  [SMALL_STATE(17630)] = 598137,
  [SMALL_STATE(17631)] = 598156,
  [SMALL_STATE(17632)] = 598175,
  [SMALL_STATE(17633)] = 598192,
  [SMALL_STATE(17634)] = 598209,
  [SMALL_STATE(17635)] = 598228,
  [SMALL_STATE(17636)] = 598245,
  [SMALL_STATE(17637)] = 598258,
  [SMALL_STATE(17638)] = 598277,
  [SMALL_STATE(17639)] = 598290,
  [SMALL_STATE(17640)] = 598307,
  [SMALL_STATE(17641)] = 598326,
  [SMALL_STATE(17642)] = 598345,
  [SMALL_STATE(17643)] = 598364,
  [SMALL_STATE(17644)] = 598383,
  [SMALL_STATE(17645)] = 598402,
  [SMALL_STATE(17646)] = 598415,
  [SMALL_STATE(17647)] = 598434,
  [SMALL_STATE(17648)] = 598451,
  [SMALL_STATE(17649)] = 598470,
  [SMALL_STATE(17650)] = 598483,
  [SMALL_STATE(17651)] = 598500,
  [SMALL_STATE(17652)] = 598519,
  [SMALL_STATE(17653)] = 598538,
  [SMALL_STATE(17654)] = 598555,
  [SMALL_STATE(17655)] = 598574,
  [SMALL_STATE(17656)] = 598593,
  [SMALL_STATE(17657)] = 598610,
  [SMALL_STATE(17658)] = 598627,
  [SMALL_STATE(17659)] = 598646,
  [SMALL_STATE(17660)] = 598665,
  [SMALL_STATE(17661)] = 598684,
  [SMALL_STATE(17662)] = 598703,
  [SMALL_STATE(17663)] = 598720,
  [SMALL_STATE(17664)] = 598739,
  [SMALL_STATE(17665)] = 598756,
  [SMALL_STATE(17666)] = 598773,
  [SMALL_STATE(17667)] = 598792,
  [SMALL_STATE(17668)] = 598811,
  [SMALL_STATE(17669)] = 598830,
  [SMALL_STATE(17670)] = 598843,
  [SMALL_STATE(17671)] = 598856,
  [SMALL_STATE(17672)] = 598875,
  [SMALL_STATE(17673)] = 598894,
  [SMALL_STATE(17674)] = 598907,
  [SMALL_STATE(17675)] = 598926,
  [SMALL_STATE(17676)] = 598939,
  [SMALL_STATE(17677)] = 598958,
  [SMALL_STATE(17678)] = 598971,
  [SMALL_STATE(17679)] = 598984,
  [SMALL_STATE(17680)] = 599001,
  [SMALL_STATE(17681)] = 599018,
  [SMALL_STATE(17682)] = 599031,
  [SMALL_STATE(17683)] = 599044,
  [SMALL_STATE(17684)] = 599061,
  [SMALL_STATE(17685)] = 599080,
  [SMALL_STATE(17686)] = 599099,
  [SMALL_STATE(17687)] = 599112,
  [SMALL_STATE(17688)] = 599131,
  [SMALL_STATE(17689)] = 599150,
  [SMALL_STATE(17690)] = 599167,
  [SMALL_STATE(17691)] = 599180,
  [SMALL_STATE(17692)] = 599199,
  [SMALL_STATE(17693)] = 599212,
  [SMALL_STATE(17694)] = 599229,
  [SMALL_STATE(17695)] = 599242,
  [SMALL_STATE(17696)] = 599255,
  [SMALL_STATE(17697)] = 599268,
  [SMALL_STATE(17698)] = 599283,
  [SMALL_STATE(17699)] = 599296,
  [SMALL_STATE(17700)] = 599309,
  [SMALL_STATE(17701)] = 599328,
  [SMALL_STATE(17702)] = 599341,
  [SMALL_STATE(17703)] = 599360,
  [SMALL_STATE(17704)] = 599373,
  [SMALL_STATE(17705)] = 599390,
  [SMALL_STATE(17706)] = 599407,
  [SMALL_STATE(17707)] = 599422,
  [SMALL_STATE(17708)] = 599435,
  [SMALL_STATE(17709)] = 599448,
  [SMALL_STATE(17710)] = 599467,
  [SMALL_STATE(17711)] = 599484,
  [SMALL_STATE(17712)] = 599503,
  [SMALL_STATE(17713)] = 599516,
  [SMALL_STATE(17714)] = 599533,
  [SMALL_STATE(17715)] = 599546,
  [SMALL_STATE(17716)] = 599565,
  [SMALL_STATE(17717)] = 599584,
  [SMALL_STATE(17718)] = 599603,
  [SMALL_STATE(17719)] = 599620,
  [SMALL_STATE(17720)] = 599635,
  [SMALL_STATE(17721)] = 599654,
  [SMALL_STATE(17722)] = 599671,
  [SMALL_STATE(17723)] = 599690,
  [SMALL_STATE(17724)] = 599709,
  [SMALL_STATE(17725)] = 599726,
  [SMALL_STATE(17726)] = 599745,
  [SMALL_STATE(17727)] = 599762,
  [SMALL_STATE(17728)] = 599775,
  [SMALL_STATE(17729)] = 599788,
  [SMALL_STATE(17730)] = 599807,
  [SMALL_STATE(17731)] = 599820,
  [SMALL_STATE(17732)] = 599833,
  [SMALL_STATE(17733)] = 599852,
  [SMALL_STATE(17734)] = 599865,
  [SMALL_STATE(17735)] = 599878,
  [SMALL_STATE(17736)] = 599891,
  [SMALL_STATE(17737)] = 599904,
  [SMALL_STATE(17738)] = 599921,
  [SMALL_STATE(17739)] = 599934,
  [SMALL_STATE(17740)] = 599953,
  [SMALL_STATE(17741)] = 599972,
  [SMALL_STATE(17742)] = 599985,
  [SMALL_STATE(17743)] = 600004,
  [SMALL_STATE(17744)] = 600023,
  [SMALL_STATE(17745)] = 600036,
  [SMALL_STATE(17746)] = 600049,
  [SMALL_STATE(17747)] = 600062,
  [SMALL_STATE(17748)] = 600075,
  [SMALL_STATE(17749)] = 600094,
  [SMALL_STATE(17750)] = 600107,
  [SMALL_STATE(17751)] = 600120,
  [SMALL_STATE(17752)] = 600137,
  [SMALL_STATE(17753)] = 600156,
  [SMALL_STATE(17754)] = 600175,
  [SMALL_STATE(17755)] = 600192,
  [SMALL_STATE(17756)] = 600211,
  [SMALL_STATE(17757)] = 600230,
  [SMALL_STATE(17758)] = 600243,
  [SMALL_STATE(17759)] = 600260,
  [SMALL_STATE(17760)] = 600279,
  [SMALL_STATE(17761)] = 600298,
  [SMALL_STATE(17762)] = 600311,
  [SMALL_STATE(17763)] = 600330,
  [SMALL_STATE(17764)] = 600347,
  [SMALL_STATE(17765)] = 600360,
  [SMALL_STATE(17766)] = 600373,
  [SMALL_STATE(17767)] = 600386,
  [SMALL_STATE(17768)] = 600399,
  [SMALL_STATE(17769)] = 600418,
  [SMALL_STATE(17770)] = 600435,
  [SMALL_STATE(17771)] = 600448,
  [SMALL_STATE(17772)] = 600467,
  [SMALL_STATE(17773)] = 600480,
  [SMALL_STATE(17774)] = 600499,
  [SMALL_STATE(17775)] = 600518,
  [SMALL_STATE(17776)] = 600535,
  [SMALL_STATE(17777)] = 600552,
  [SMALL_STATE(17778)] = 600571,
  [SMALL_STATE(17779)] = 600590,
  [SMALL_STATE(17780)] = 600609,
  [SMALL_STATE(17781)] = 600626,
  [SMALL_STATE(17782)] = 600645,
  [SMALL_STATE(17783)] = 600664,
  [SMALL_STATE(17784)] = 600683,
  [SMALL_STATE(17785)] = 600702,
  [SMALL_STATE(17786)] = 600721,
  [SMALL_STATE(17787)] = 600740,
  [SMALL_STATE(17788)] = 600759,
  [SMALL_STATE(17789)] = 600778,
  [SMALL_STATE(17790)] = 600797,
  [SMALL_STATE(17791)] = 600816,
  [SMALL_STATE(17792)] = 600833,
  [SMALL_STATE(17793)] = 600852,
  [SMALL_STATE(17794)] = 600869,
  [SMALL_STATE(17795)] = 600888,
  [SMALL_STATE(17796)] = 600907,
  [SMALL_STATE(17797)] = 600920,
  [SMALL_STATE(17798)] = 600939,
  [SMALL_STATE(17799)] = 600958,
  [SMALL_STATE(17800)] = 600975,
  [SMALL_STATE(17801)] = 600994,
  [SMALL_STATE(17802)] = 601013,
  [SMALL_STATE(17803)] = 601026,
  [SMALL_STATE(17804)] = 601039,
  [SMALL_STATE(17805)] = 601058,
  [SMALL_STATE(17806)] = 601077,
  [SMALL_STATE(17807)] = 601094,
  [SMALL_STATE(17808)] = 601113,
  [SMALL_STATE(17809)] = 601130,
  [SMALL_STATE(17810)] = 601143,
  [SMALL_STATE(17811)] = 601156,
  [SMALL_STATE(17812)] = 601175,
  [SMALL_STATE(17813)] = 601188,
  [SMALL_STATE(17814)] = 601201,
  [SMALL_STATE(17815)] = 601218,
  [SMALL_STATE(17816)] = 601237,
  [SMALL_STATE(17817)] = 601254,
  [SMALL_STATE(17818)] = 601267,
  [SMALL_STATE(17819)] = 601286,
  [SMALL_STATE(17820)] = 601305,
  [SMALL_STATE(17821)] = 601322,
  [SMALL_STATE(17822)] = 601341,
  [SMALL_STATE(17823)] = 601358,
  [SMALL_STATE(17824)] = 601377,
  [SMALL_STATE(17825)] = 601394,
  [SMALL_STATE(17826)] = 601411,
  [SMALL_STATE(17827)] = 601430,
  [SMALL_STATE(17828)] = 601449,
  [SMALL_STATE(17829)] = 601468,
  [SMALL_STATE(17830)] = 601485,
  [SMALL_STATE(17831)] = 601504,
  [SMALL_STATE(17832)] = 601523,
  [SMALL_STATE(17833)] = 601540,
  [SMALL_STATE(17834)] = 601559,
  [SMALL_STATE(17835)] = 601578,
  [SMALL_STATE(17836)] = 601595,
  [SMALL_STATE(17837)] = 601614,
  [SMALL_STATE(17838)] = 601633,
  [SMALL_STATE(17839)] = 601652,
  [SMALL_STATE(17840)] = 601665,
  [SMALL_STATE(17841)] = 601681,
  [SMALL_STATE(17842)] = 601697,
  [SMALL_STATE(17843)] = 601713,
  [SMALL_STATE(17844)] = 601729,
  [SMALL_STATE(17845)] = 601741,
  [SMALL_STATE(17846)] = 601753,
  [SMALL_STATE(17847)] = 601769,
  [SMALL_STATE(17848)] = 601783,
  [SMALL_STATE(17849)] = 601795,
  [SMALL_STATE(17850)] = 601807,
  [SMALL_STATE(17851)] = 601823,
  [SMALL_STATE(17852)] = 601835,
  [SMALL_STATE(17853)] = 601849,
  [SMALL_STATE(17854)] = 601863,
  [SMALL_STATE(17855)] = 601877,
  [SMALL_STATE(17856)] = 601893,
  [SMALL_STATE(17857)] = 601907,
  [SMALL_STATE(17858)] = 601921,
  [SMALL_STATE(17859)] = 601937,
  [SMALL_STATE(17860)] = 601953,
  [SMALL_STATE(17861)] = 601969,
  [SMALL_STATE(17862)] = 601985,
  [SMALL_STATE(17863)] = 601999,
  [SMALL_STATE(17864)] = 602015,
  [SMALL_STATE(17865)] = 602027,
  [SMALL_STATE(17866)] = 602039,
  [SMALL_STATE(17867)] = 602053,
  [SMALL_STATE(17868)] = 602069,
  [SMALL_STATE(17869)] = 602085,
  [SMALL_STATE(17870)] = 602101,
  [SMALL_STATE(17871)] = 602117,
  [SMALL_STATE(17872)] = 602133,
  [SMALL_STATE(17873)] = 602145,
  [SMALL_STATE(17874)] = 602157,
  [SMALL_STATE(17875)] = 602169,
  [SMALL_STATE(17876)] = 602183,
  [SMALL_STATE(17877)] = 602197,
  [SMALL_STATE(17878)] = 602213,
  [SMALL_STATE(17879)] = 602225,
  [SMALL_STATE(17880)] = 602239,
  [SMALL_STATE(17881)] = 602251,
  [SMALL_STATE(17882)] = 602267,
  [SMALL_STATE(17883)] = 602283,
  [SMALL_STATE(17884)] = 602297,
  [SMALL_STATE(17885)] = 602311,
  [SMALL_STATE(17886)] = 602327,
  [SMALL_STATE(17887)] = 602343,
  [SMALL_STATE(17888)] = 602355,
  [SMALL_STATE(17889)] = 602371,
  [SMALL_STATE(17890)] = 602385,
  [SMALL_STATE(17891)] = 602401,
  [SMALL_STATE(17892)] = 602417,
  [SMALL_STATE(17893)] = 602433,
  [SMALL_STATE(17894)] = 602449,
  [SMALL_STATE(17895)] = 602465,
  [SMALL_STATE(17896)] = 602481,
  [SMALL_STATE(17897)] = 602497,
  [SMALL_STATE(17898)] = 602513,
  [SMALL_STATE(17899)] = 602525,
  [SMALL_STATE(17900)] = 602537,
  [SMALL_STATE(17901)] = 602553,
  [SMALL_STATE(17902)] = 602569,
  [SMALL_STATE(17903)] = 602585,
  [SMALL_STATE(17904)] = 602601,
  [SMALL_STATE(17905)] = 602617,
  [SMALL_STATE(17906)] = 602633,
  [SMALL_STATE(17907)] = 602649,
  [SMALL_STATE(17908)] = 602665,
  [SMALL_STATE(17909)] = 602681,
  [SMALL_STATE(17910)] = 602697,
  [SMALL_STATE(17911)] = 602713,
  [SMALL_STATE(17912)] = 602725,
  [SMALL_STATE(17913)] = 602741,
  [SMALL_STATE(17914)] = 602757,
  [SMALL_STATE(17915)] = 602769,
  [SMALL_STATE(17916)] = 602781,
  [SMALL_STATE(17917)] = 602795,
  [SMALL_STATE(17918)] = 602807,
  [SMALL_STATE(17919)] = 602823,
  [SMALL_STATE(17920)] = 602839,
  [SMALL_STATE(17921)] = 602851,
  [SMALL_STATE(17922)] = 602865,
  [SMALL_STATE(17923)] = 602881,
  [SMALL_STATE(17924)] = 602895,
  [SMALL_STATE(17925)] = 602911,
  [SMALL_STATE(17926)] = 602923,
  [SMALL_STATE(17927)] = 602937,
  [SMALL_STATE(17928)] = 602953,
  [SMALL_STATE(17929)] = 602965,
  [SMALL_STATE(17930)] = 602981,
  [SMALL_STATE(17931)] = 602997,
  [SMALL_STATE(17932)] = 603013,
  [SMALL_STATE(17933)] = 603029,
  [SMALL_STATE(17934)] = 603043,
  [SMALL_STATE(17935)] = 603055,
  [SMALL_STATE(17936)] = 603067,
  [SMALL_STATE(17937)] = 603083,
  [SMALL_STATE(17938)] = 603099,
  [SMALL_STATE(17939)] = 603115,
  [SMALL_STATE(17940)] = 603131,
  [SMALL_STATE(17941)] = 603147,
  [SMALL_STATE(17942)] = 603159,
  [SMALL_STATE(17943)] = 603175,
  [SMALL_STATE(17944)] = 603191,
  [SMALL_STATE(17945)] = 603207,
  [SMALL_STATE(17946)] = 603223,
  [SMALL_STATE(17947)] = 603239,
  [SMALL_STATE(17948)] = 603253,
  [SMALL_STATE(17949)] = 603269,
  [SMALL_STATE(17950)] = 603285,
  [SMALL_STATE(17951)] = 603299,
  [SMALL_STATE(17952)] = 603315,
  [SMALL_STATE(17953)] = 603331,
  [SMALL_STATE(17954)] = 603343,
  [SMALL_STATE(17955)] = 603359,
  [SMALL_STATE(17956)] = 603375,
  [SMALL_STATE(17957)] = 603391,
  [SMALL_STATE(17958)] = 603405,
  [SMALL_STATE(17959)] = 603417,
  [SMALL_STATE(17960)] = 603431,
  [SMALL_STATE(17961)] = 603447,
  [SMALL_STATE(17962)] = 603463,
  [SMALL_STATE(17963)] = 603479,
  [SMALL_STATE(17964)] = 603495,
  [SMALL_STATE(17965)] = 603511,
  [SMALL_STATE(17966)] = 603523,
  [SMALL_STATE(17967)] = 603535,
  [SMALL_STATE(17968)] = 603551,
  [SMALL_STATE(17969)] = 603567,
  [SMALL_STATE(17970)] = 603581,
  [SMALL_STATE(17971)] = 603593,
  [SMALL_STATE(17972)] = 603609,
  [SMALL_STATE(17973)] = 603621,
  [SMALL_STATE(17974)] = 603637,
  [SMALL_STATE(17975)] = 603653,
  [SMALL_STATE(17976)] = 603665,
  [SMALL_STATE(17977)] = 603677,
  [SMALL_STATE(17978)] = 603689,
  [SMALL_STATE(17979)] = 603705,
  [SMALL_STATE(17980)] = 603721,
  [SMALL_STATE(17981)] = 603737,
  [SMALL_STATE(17982)] = 603751,
  [SMALL_STATE(17983)] = 603767,
  [SMALL_STATE(17984)] = 603779,
  [SMALL_STATE(17985)] = 603791,
  [SMALL_STATE(17986)] = 603803,
  [SMALL_STATE(17987)] = 603819,
  [SMALL_STATE(17988)] = 603831,
  [SMALL_STATE(17989)] = 603847,
  [SMALL_STATE(17990)] = 603861,
  [SMALL_STATE(17991)] = 603875,
  [SMALL_STATE(17992)] = 603887,
  [SMALL_STATE(17993)] = 603899,
  [SMALL_STATE(17994)] = 603915,
  [SMALL_STATE(17995)] = 603927,
  [SMALL_STATE(17996)] = 603939,
  [SMALL_STATE(17997)] = 603951,
  [SMALL_STATE(17998)] = 603967,
  [SMALL_STATE(17999)] = 603979,
  [SMALL_STATE(18000)] = 603991,
  [SMALL_STATE(18001)] = 604007,
  [SMALL_STATE(18002)] = 604023,
  [SMALL_STATE(18003)] = 604039,
  [SMALL_STATE(18004)] = 604053,
  [SMALL_STATE(18005)] = 604069,
  [SMALL_STATE(18006)] = 604085,
  [SMALL_STATE(18007)] = 604099,
  [SMALL_STATE(18008)] = 604115,
  [SMALL_STATE(18009)] = 604131,
  [SMALL_STATE(18010)] = 604143,
  [SMALL_STATE(18011)] = 604159,
  [SMALL_STATE(18012)] = 604175,
  [SMALL_STATE(18013)] = 604191,
  [SMALL_STATE(18014)] = 604207,
  [SMALL_STATE(18015)] = 604221,
  [SMALL_STATE(18016)] = 604237,
  [SMALL_STATE(18017)] = 604251,
  [SMALL_STATE(18018)] = 604267,
  [SMALL_STATE(18019)] = 604279,
  [SMALL_STATE(18020)] = 604291,
  [SMALL_STATE(18021)] = 604303,
  [SMALL_STATE(18022)] = 604319,
  [SMALL_STATE(18023)] = 604331,
  [SMALL_STATE(18024)] = 604343,
  [SMALL_STATE(18025)] = 604357,
  [SMALL_STATE(18026)] = 604373,
  [SMALL_STATE(18027)] = 604389,
  [SMALL_STATE(18028)] = 604401,
  [SMALL_STATE(18029)] = 604417,
  [SMALL_STATE(18030)] = 604433,
  [SMALL_STATE(18031)] = 604449,
  [SMALL_STATE(18032)] = 604465,
  [SMALL_STATE(18033)] = 604481,
  [SMALL_STATE(18034)] = 604493,
  [SMALL_STATE(18035)] = 604505,
  [SMALL_STATE(18036)] = 604521,
  [SMALL_STATE(18037)] = 604533,
  [SMALL_STATE(18038)] = 604549,
  [SMALL_STATE(18039)] = 604563,
  [SMALL_STATE(18040)] = 604579,
  [SMALL_STATE(18041)] = 604593,
  [SMALL_STATE(18042)] = 604609,
  [SMALL_STATE(18043)] = 604623,
  [SMALL_STATE(18044)] = 604639,
  [SMALL_STATE(18045)] = 604655,
  [SMALL_STATE(18046)] = 604671,
  [SMALL_STATE(18047)] = 604687,
  [SMALL_STATE(18048)] = 604699,
  [SMALL_STATE(18049)] = 604711,
  [SMALL_STATE(18050)] = 604723,
  [SMALL_STATE(18051)] = 604739,
  [SMALL_STATE(18052)] = 604755,
  [SMALL_STATE(18053)] = 604771,
  [SMALL_STATE(18054)] = 604787,
  [SMALL_STATE(18055)] = 604803,
  [SMALL_STATE(18056)] = 604819,
  [SMALL_STATE(18057)] = 604835,
  [SMALL_STATE(18058)] = 604851,
  [SMALL_STATE(18059)] = 604863,
  [SMALL_STATE(18060)] = 604879,
  [SMALL_STATE(18061)] = 604891,
  [SMALL_STATE(18062)] = 604907,
  [SMALL_STATE(18063)] = 604923,
  [SMALL_STATE(18064)] = 604939,
  [SMALL_STATE(18065)] = 604951,
  [SMALL_STATE(18066)] = 604967,
  [SMALL_STATE(18067)] = 604981,
  [SMALL_STATE(18068)] = 604997,
  [SMALL_STATE(18069)] = 605013,
  [SMALL_STATE(18070)] = 605029,
  [SMALL_STATE(18071)] = 605045,
  [SMALL_STATE(18072)] = 605061,
  [SMALL_STATE(18073)] = 605077,
  [SMALL_STATE(18074)] = 605093,
  [SMALL_STATE(18075)] = 605109,
  [SMALL_STATE(18076)] = 605121,
  [SMALL_STATE(18077)] = 605137,
  [SMALL_STATE(18078)] = 605153,
  [SMALL_STATE(18079)] = 605169,
  [SMALL_STATE(18080)] = 605181,
  [SMALL_STATE(18081)] = 605197,
  [SMALL_STATE(18082)] = 605213,
  [SMALL_STATE(18083)] = 605229,
  [SMALL_STATE(18084)] = 605243,
  [SMALL_STATE(18085)] = 605257,
  [SMALL_STATE(18086)] = 605269,
  [SMALL_STATE(18087)] = 605281,
  [SMALL_STATE(18088)] = 605297,
  [SMALL_STATE(18089)] = 605313,
  [SMALL_STATE(18090)] = 605325,
  [SMALL_STATE(18091)] = 605337,
  [SMALL_STATE(18092)] = 605353,
  [SMALL_STATE(18093)] = 605369,
  [SMALL_STATE(18094)] = 605385,
  [SMALL_STATE(18095)] = 605397,
  [SMALL_STATE(18096)] = 605413,
  [SMALL_STATE(18097)] = 605429,
  [SMALL_STATE(18098)] = 605445,
  [SMALL_STATE(18099)] = 605461,
  [SMALL_STATE(18100)] = 605477,
  [SMALL_STATE(18101)] = 605491,
  [SMALL_STATE(18102)] = 605507,
  [SMALL_STATE(18103)] = 605519,
  [SMALL_STATE(18104)] = 605535,
  [SMALL_STATE(18105)] = 605547,
  [SMALL_STATE(18106)] = 605563,
  [SMALL_STATE(18107)] = 605579,
  [SMALL_STATE(18108)] = 605595,
  [SMALL_STATE(18109)] = 605611,
  [SMALL_STATE(18110)] = 605627,
  [SMALL_STATE(18111)] = 605643,
  [SMALL_STATE(18112)] = 605659,
  [SMALL_STATE(18113)] = 605675,
  [SMALL_STATE(18114)] = 605689,
  [SMALL_STATE(18115)] = 605705,
  [SMALL_STATE(18116)] = 605719,
  [SMALL_STATE(18117)] = 605735,
  [SMALL_STATE(18118)] = 605751,
  [SMALL_STATE(18119)] = 605767,
  [SMALL_STATE(18120)] = 605783,
  [SMALL_STATE(18121)] = 605799,
  [SMALL_STATE(18122)] = 605811,
  [SMALL_STATE(18123)] = 605827,
  [SMALL_STATE(18124)] = 605839,
  [SMALL_STATE(18125)] = 605855,
  [SMALL_STATE(18126)] = 605869,
  [SMALL_STATE(18127)] = 605885,
  [SMALL_STATE(18128)] = 605899,
  [SMALL_STATE(18129)] = 605915,
  [SMALL_STATE(18130)] = 605927,
  [SMALL_STATE(18131)] = 605939,
  [SMALL_STATE(18132)] = 605955,
  [SMALL_STATE(18133)] = 605971,
  [SMALL_STATE(18134)] = 605987,
  [SMALL_STATE(18135)] = 606001,
  [SMALL_STATE(18136)] = 606017,
  [SMALL_STATE(18137)] = 606029,
  [SMALL_STATE(18138)] = 606041,
  [SMALL_STATE(18139)] = 606057,
  [SMALL_STATE(18140)] = 606073,
  [SMALL_STATE(18141)] = 606089,
  [SMALL_STATE(18142)] = 606105,
  [SMALL_STATE(18143)] = 606119,
  [SMALL_STATE(18144)] = 606133,
  [SMALL_STATE(18145)] = 606149,
  [SMALL_STATE(18146)] = 606161,
  [SMALL_STATE(18147)] = 606177,
  [SMALL_STATE(18148)] = 606193,
  [SMALL_STATE(18149)] = 606205,
  [SMALL_STATE(18150)] = 606221,
  [SMALL_STATE(18151)] = 606233,
  [SMALL_STATE(18152)] = 606245,
  [SMALL_STATE(18153)] = 606261,
  [SMALL_STATE(18154)] = 606277,
  [SMALL_STATE(18155)] = 606293,
  [SMALL_STATE(18156)] = 606309,
  [SMALL_STATE(18157)] = 606325,
  [SMALL_STATE(18158)] = 606341,
  [SMALL_STATE(18159)] = 606357,
  [SMALL_STATE(18160)] = 606371,
  [SMALL_STATE(18161)] = 606385,
  [SMALL_STATE(18162)] = 606399,
  [SMALL_STATE(18163)] = 606413,
  [SMALL_STATE(18164)] = 606425,
  [SMALL_STATE(18165)] = 606441,
  [SMALL_STATE(18166)] = 606457,
  [SMALL_STATE(18167)] = 606473,
  [SMALL_STATE(18168)] = 606485,
  [SMALL_STATE(18169)] = 606501,
  [SMALL_STATE(18170)] = 606517,
  [SMALL_STATE(18171)] = 606533,
  [SMALL_STATE(18172)] = 606549,
  [SMALL_STATE(18173)] = 606561,
  [SMALL_STATE(18174)] = 606577,
  [SMALL_STATE(18175)] = 606593,
  [SMALL_STATE(18176)] = 606605,
  [SMALL_STATE(18177)] = 606621,
  [SMALL_STATE(18178)] = 606637,
  [SMALL_STATE(18179)] = 606653,
  [SMALL_STATE(18180)] = 606669,
  [SMALL_STATE(18181)] = 606685,
  [SMALL_STATE(18182)] = 606701,
  [SMALL_STATE(18183)] = 606717,
  [SMALL_STATE(18184)] = 606733,
  [SMALL_STATE(18185)] = 606749,
  [SMALL_STATE(18186)] = 606763,
  [SMALL_STATE(18187)] = 606779,
  [SMALL_STATE(18188)] = 606795,
  [SMALL_STATE(18189)] = 606811,
  [SMALL_STATE(18190)] = 606823,
  [SMALL_STATE(18191)] = 606835,
  [SMALL_STATE(18192)] = 606851,
  [SMALL_STATE(18193)] = 606867,
  [SMALL_STATE(18194)] = 606883,
  [SMALL_STATE(18195)] = 606899,
  [SMALL_STATE(18196)] = 606915,
  [SMALL_STATE(18197)] = 606929,
  [SMALL_STATE(18198)] = 606945,
  [SMALL_STATE(18199)] = 606957,
  [SMALL_STATE(18200)] = 606973,
  [SMALL_STATE(18201)] = 606989,
  [SMALL_STATE(18202)] = 607003,
  [SMALL_STATE(18203)] = 607019,
  [SMALL_STATE(18204)] = 607035,
  [SMALL_STATE(18205)] = 607047,
  [SMALL_STATE(18206)] = 607063,
  [SMALL_STATE(18207)] = 607075,
  [SMALL_STATE(18208)] = 607089,
  [SMALL_STATE(18209)] = 607101,
  [SMALL_STATE(18210)] = 607117,
  [SMALL_STATE(18211)] = 607133,
  [SMALL_STATE(18212)] = 607149,
  [SMALL_STATE(18213)] = 607165,
  [SMALL_STATE(18214)] = 607181,
  [SMALL_STATE(18215)] = 607197,
  [SMALL_STATE(18216)] = 607213,
  [SMALL_STATE(18217)] = 607229,
  [SMALL_STATE(18218)] = 607243,
  [SMALL_STATE(18219)] = 607259,
  [SMALL_STATE(18220)] = 607275,
  [SMALL_STATE(18221)] = 607291,
  [SMALL_STATE(18222)] = 607307,
  [SMALL_STATE(18223)] = 607319,
  [SMALL_STATE(18224)] = 607333,
  [SMALL_STATE(18225)] = 607349,
  [SMALL_STATE(18226)] = 607365,
  [SMALL_STATE(18227)] = 607381,
  [SMALL_STATE(18228)] = 607397,
  [SMALL_STATE(18229)] = 607409,
  [SMALL_STATE(18230)] = 607425,
  [SMALL_STATE(18231)] = 607437,
  [SMALL_STATE(18232)] = 607449,
  [SMALL_STATE(18233)] = 607461,
  [SMALL_STATE(18234)] = 607477,
  [SMALL_STATE(18235)] = 607489,
  [SMALL_STATE(18236)] = 607505,
  [SMALL_STATE(18237)] = 607521,
  [SMALL_STATE(18238)] = 607537,
  [SMALL_STATE(18239)] = 607553,
  [SMALL_STATE(18240)] = 607569,
  [SMALL_STATE(18241)] = 607581,
  [SMALL_STATE(18242)] = 607597,
  [SMALL_STATE(18243)] = 607613,
  [SMALL_STATE(18244)] = 607629,
  [SMALL_STATE(18245)] = 607641,
  [SMALL_STATE(18246)] = 607657,
  [SMALL_STATE(18247)] = 607673,
  [SMALL_STATE(18248)] = 607689,
  [SMALL_STATE(18249)] = 607705,
  [SMALL_STATE(18250)] = 607721,
  [SMALL_STATE(18251)] = 607737,
  [SMALL_STATE(18252)] = 607753,
  [SMALL_STATE(18253)] = 607765,
  [SMALL_STATE(18254)] = 607781,
  [SMALL_STATE(18255)] = 607795,
  [SMALL_STATE(18256)] = 607809,
  [SMALL_STATE(18257)] = 607823,
  [SMALL_STATE(18258)] = 607839,
  [SMALL_STATE(18259)] = 607855,
  [SMALL_STATE(18260)] = 607871,
  [SMALL_STATE(18261)] = 607887,
  [SMALL_STATE(18262)] = 607903,
  [SMALL_STATE(18263)] = 607919,
  [SMALL_STATE(18264)] = 607931,
  [SMALL_STATE(18265)] = 607947,
  [SMALL_STATE(18266)] = 607963,
  [SMALL_STATE(18267)] = 607979,
  [SMALL_STATE(18268)] = 607991,
  [SMALL_STATE(18269)] = 608003,
  [SMALL_STATE(18270)] = 608019,
  [SMALL_STATE(18271)] = 608031,
  [SMALL_STATE(18272)] = 608043,
  [SMALL_STATE(18273)] = 608055,
  [SMALL_STATE(18274)] = 608071,
  [SMALL_STATE(18275)] = 608083,
  [SMALL_STATE(18276)] = 608097,
  [SMALL_STATE(18277)] = 608111,
  [SMALL_STATE(18278)] = 608127,
  [SMALL_STATE(18279)] = 608141,
  [SMALL_STATE(18280)] = 608153,
  [SMALL_STATE(18281)] = 608167,
  [SMALL_STATE(18282)] = 608183,
  [SMALL_STATE(18283)] = 608199,
  [SMALL_STATE(18284)] = 608215,
  [SMALL_STATE(18285)] = 608229,
  [SMALL_STATE(18286)] = 608241,
  [SMALL_STATE(18287)] = 608255,
  [SMALL_STATE(18288)] = 608269,
  [SMALL_STATE(18289)] = 608285,
  [SMALL_STATE(18290)] = 608301,
  [SMALL_STATE(18291)] = 608313,
  [SMALL_STATE(18292)] = 608325,
  [SMALL_STATE(18293)] = 608339,
  [SMALL_STATE(18294)] = 608355,
  [SMALL_STATE(18295)] = 608371,
  [SMALL_STATE(18296)] = 608387,
  [SMALL_STATE(18297)] = 608403,
  [SMALL_STATE(18298)] = 608419,
  [SMALL_STATE(18299)] = 608431,
  [SMALL_STATE(18300)] = 608447,
  [SMALL_STATE(18301)] = 608459,
  [SMALL_STATE(18302)] = 608475,
  [SMALL_STATE(18303)] = 608489,
  [SMALL_STATE(18304)] = 608505,
  [SMALL_STATE(18305)] = 608519,
  [SMALL_STATE(18306)] = 608535,
  [SMALL_STATE(18307)] = 608551,
  [SMALL_STATE(18308)] = 608565,
  [SMALL_STATE(18309)] = 608577,
  [SMALL_STATE(18310)] = 608589,
  [SMALL_STATE(18311)] = 608601,
  [SMALL_STATE(18312)] = 608617,
  [SMALL_STATE(18313)] = 608633,
  [SMALL_STATE(18314)] = 608649,
  [SMALL_STATE(18315)] = 608665,
  [SMALL_STATE(18316)] = 608681,
  [SMALL_STATE(18317)] = 608697,
  [SMALL_STATE(18318)] = 608713,
  [SMALL_STATE(18319)] = 608729,
  [SMALL_STATE(18320)] = 608745,
  [SMALL_STATE(18321)] = 608761,
  [SMALL_STATE(18322)] = 608777,
  [SMALL_STATE(18323)] = 608793,
  [SMALL_STATE(18324)] = 608809,
  [SMALL_STATE(18325)] = 608825,
  [SMALL_STATE(18326)] = 608841,
  [SMALL_STATE(18327)] = 608857,
  [SMALL_STATE(18328)] = 608873,
  [SMALL_STATE(18329)] = 608885,
  [SMALL_STATE(18330)] = 608901,
  [SMALL_STATE(18331)] = 608917,
  [SMALL_STATE(18332)] = 608933,
  [SMALL_STATE(18333)] = 608949,
  [SMALL_STATE(18334)] = 608961,
  [SMALL_STATE(18335)] = 608977,
  [SMALL_STATE(18336)] = 608993,
  [SMALL_STATE(18337)] = 609005,
  [SMALL_STATE(18338)] = 609021,
  [SMALL_STATE(18339)] = 609037,
  [SMALL_STATE(18340)] = 609053,
  [SMALL_STATE(18341)] = 609069,
  [SMALL_STATE(18342)] = 609085,
  [SMALL_STATE(18343)] = 609101,
  [SMALL_STATE(18344)] = 609117,
  [SMALL_STATE(18345)] = 609129,
  [SMALL_STATE(18346)] = 609145,
  [SMALL_STATE(18347)] = 609161,
  [SMALL_STATE(18348)] = 609173,
  [SMALL_STATE(18349)] = 609189,
  [SMALL_STATE(18350)] = 609201,
  [SMALL_STATE(18351)] = 609213,
  [SMALL_STATE(18352)] = 609229,
  [SMALL_STATE(18353)] = 609241,
  [SMALL_STATE(18354)] = 609257,
  [SMALL_STATE(18355)] = 609273,
  [SMALL_STATE(18356)] = 609289,
  [SMALL_STATE(18357)] = 609301,
  [SMALL_STATE(18358)] = 609317,
  [SMALL_STATE(18359)] = 609333,
  [SMALL_STATE(18360)] = 609345,
  [SMALL_STATE(18361)] = 609361,
  [SMALL_STATE(18362)] = 609377,
  [SMALL_STATE(18363)] = 609393,
  [SMALL_STATE(18364)] = 609409,
  [SMALL_STATE(18365)] = 609421,
  [SMALL_STATE(18366)] = 609437,
  [SMALL_STATE(18367)] = 609449,
  [SMALL_STATE(18368)] = 609461,
  [SMALL_STATE(18369)] = 609477,
  [SMALL_STATE(18370)] = 609489,
  [SMALL_STATE(18371)] = 609505,
  [SMALL_STATE(18372)] = 609521,
  [SMALL_STATE(18373)] = 609537,
  [SMALL_STATE(18374)] = 609549,
  [SMALL_STATE(18375)] = 609563,
  [SMALL_STATE(18376)] = 609579,
  [SMALL_STATE(18377)] = 609595,
  [SMALL_STATE(18378)] = 609609,
  [SMALL_STATE(18379)] = 609623,
  [SMALL_STATE(18380)] = 609639,
  [SMALL_STATE(18381)] = 609655,
  [SMALL_STATE(18382)] = 609671,
  [SMALL_STATE(18383)] = 609683,
  [SMALL_STATE(18384)] = 609695,
  [SMALL_STATE(18385)] = 609711,
  [SMALL_STATE(18386)] = 609725,
  [SMALL_STATE(18387)] = 609737,
  [SMALL_STATE(18388)] = 609753,
  [SMALL_STATE(18389)] = 609765,
  [SMALL_STATE(18390)] = 609781,
  [SMALL_STATE(18391)] = 609797,
  [SMALL_STATE(18392)] = 609809,
  [SMALL_STATE(18393)] = 609821,
  [SMALL_STATE(18394)] = 609837,
  [SMALL_STATE(18395)] = 609849,
  [SMALL_STATE(18396)] = 609865,
  [SMALL_STATE(18397)] = 609881,
  [SMALL_STATE(18398)] = 609895,
  [SMALL_STATE(18399)] = 609907,
  [SMALL_STATE(18400)] = 609921,
  [SMALL_STATE(18401)] = 609933,
  [SMALL_STATE(18402)] = 609947,
  [SMALL_STATE(18403)] = 609963,
  [SMALL_STATE(18404)] = 609979,
  [SMALL_STATE(18405)] = 609991,
  [SMALL_STATE(18406)] = 610005,
  [SMALL_STATE(18407)] = 610021,
  [SMALL_STATE(18408)] = 610037,
  [SMALL_STATE(18409)] = 610051,
  [SMALL_STATE(18410)] = 610067,
  [SMALL_STATE(18411)] = 610079,
  [SMALL_STATE(18412)] = 610091,
  [SMALL_STATE(18413)] = 610107,
  [SMALL_STATE(18414)] = 610123,
  [SMALL_STATE(18415)] = 610139,
  [SMALL_STATE(18416)] = 610155,
  [SMALL_STATE(18417)] = 610171,
  [SMALL_STATE(18418)] = 610187,
  [SMALL_STATE(18419)] = 610203,
  [SMALL_STATE(18420)] = 610215,
  [SMALL_STATE(18421)] = 610231,
  [SMALL_STATE(18422)] = 610247,
  [SMALL_STATE(18423)] = 610259,
  [SMALL_STATE(18424)] = 610273,
  [SMALL_STATE(18425)] = 610289,
  [SMALL_STATE(18426)] = 610305,
  [SMALL_STATE(18427)] = 610317,
  [SMALL_STATE(18428)] = 610329,
  [SMALL_STATE(18429)] = 610341,
  [SMALL_STATE(18430)] = 610357,
  [SMALL_STATE(18431)] = 610373,
  [SMALL_STATE(18432)] = 610385,
  [SMALL_STATE(18433)] = 610397,
  [SMALL_STATE(18434)] = 610413,
  [SMALL_STATE(18435)] = 610429,
  [SMALL_STATE(18436)] = 610445,
  [SMALL_STATE(18437)] = 610461,
  [SMALL_STATE(18438)] = 610477,
  [SMALL_STATE(18439)] = 610493,
  [SMALL_STATE(18440)] = 610505,
  [SMALL_STATE(18441)] = 610519,
  [SMALL_STATE(18442)] = 610531,
  [SMALL_STATE(18443)] = 610543,
  [SMALL_STATE(18444)] = 610559,
  [SMALL_STATE(18445)] = 610573,
  [SMALL_STATE(18446)] = 610585,
  [SMALL_STATE(18447)] = 610597,
  [SMALL_STATE(18448)] = 610613,
  [SMALL_STATE(18449)] = 610629,
  [SMALL_STATE(18450)] = 610645,
  [SMALL_STATE(18451)] = 610661,
  [SMALL_STATE(18452)] = 610673,
  [SMALL_STATE(18453)] = 610685,
  [SMALL_STATE(18454)] = 610697,
  [SMALL_STATE(18455)] = 610713,
  [SMALL_STATE(18456)] = 610729,
  [SMALL_STATE(18457)] = 610745,
  [SMALL_STATE(18458)] = 610761,
  [SMALL_STATE(18459)] = 610777,
  [SMALL_STATE(18460)] = 610789,
  [SMALL_STATE(18461)] = 610805,
  [SMALL_STATE(18462)] = 610821,
  [SMALL_STATE(18463)] = 610837,
  [SMALL_STATE(18464)] = 610853,
  [SMALL_STATE(18465)] = 610869,
  [SMALL_STATE(18466)] = 610885,
  [SMALL_STATE(18467)] = 610897,
  [SMALL_STATE(18468)] = 610909,
  [SMALL_STATE(18469)] = 610921,
  [SMALL_STATE(18470)] = 610937,
  [SMALL_STATE(18471)] = 610953,
  [SMALL_STATE(18472)] = 610969,
  [SMALL_STATE(18473)] = 610985,
  [SMALL_STATE(18474)] = 610999,
  [SMALL_STATE(18475)] = 611013,
  [SMALL_STATE(18476)] = 611029,
  [SMALL_STATE(18477)] = 611045,
  [SMALL_STATE(18478)] = 611061,
  [SMALL_STATE(18479)] = 611073,
  [SMALL_STATE(18480)] = 611089,
  [SMALL_STATE(18481)] = 611105,
  [SMALL_STATE(18482)] = 611121,
  [SMALL_STATE(18483)] = 611137,
  [SMALL_STATE(18484)] = 611149,
  [SMALL_STATE(18485)] = 611163,
  [SMALL_STATE(18486)] = 611175,
  [SMALL_STATE(18487)] = 611187,
  [SMALL_STATE(18488)] = 611203,
  [SMALL_STATE(18489)] = 611219,
  [SMALL_STATE(18490)] = 611231,
  [SMALL_STATE(18491)] = 611247,
  [SMALL_STATE(18492)] = 611259,
  [SMALL_STATE(18493)] = 611275,
  [SMALL_STATE(18494)] = 611291,
  [SMALL_STATE(18495)] = 611305,
  [SMALL_STATE(18496)] = 611321,
  [SMALL_STATE(18497)] = 611337,
  [SMALL_STATE(18498)] = 611349,
  [SMALL_STATE(18499)] = 611363,
  [SMALL_STATE(18500)] = 611379,
  [SMALL_STATE(18501)] = 611395,
  [SMALL_STATE(18502)] = 611411,
  [SMALL_STATE(18503)] = 611427,
  [SMALL_STATE(18504)] = 611439,
  [SMALL_STATE(18505)] = 611455,
  [SMALL_STATE(18506)] = 611471,
  [SMALL_STATE(18507)] = 611487,
  [SMALL_STATE(18508)] = 611503,
  [SMALL_STATE(18509)] = 611519,
  [SMALL_STATE(18510)] = 611533,
  [SMALL_STATE(18511)] = 611549,
  [SMALL_STATE(18512)] = 611565,
  [SMALL_STATE(18513)] = 611577,
  [SMALL_STATE(18514)] = 611593,
  [SMALL_STATE(18515)] = 611609,
  [SMALL_STATE(18516)] = 611621,
  [SMALL_STATE(18517)] = 611635,
  [SMALL_STATE(18518)] = 611647,
  [SMALL_STATE(18519)] = 611661,
  [SMALL_STATE(18520)] = 611673,
  [SMALL_STATE(18521)] = 611689,
  [SMALL_STATE(18522)] = 611705,
  [SMALL_STATE(18523)] = 611721,
  [SMALL_STATE(18524)] = 611737,
  [SMALL_STATE(18525)] = 611753,
  [SMALL_STATE(18526)] = 611769,
  [SMALL_STATE(18527)] = 611785,
  [SMALL_STATE(18528)] = 611797,
  [SMALL_STATE(18529)] = 611809,
  [SMALL_STATE(18530)] = 611821,
  [SMALL_STATE(18531)] = 611833,
  [SMALL_STATE(18532)] = 611849,
  [SMALL_STATE(18533)] = 611865,
  [SMALL_STATE(18534)] = 611881,
  [SMALL_STATE(18535)] = 611897,
  [SMALL_STATE(18536)] = 611913,
  [SMALL_STATE(18537)] = 611925,
  [SMALL_STATE(18538)] = 611941,
  [SMALL_STATE(18539)] = 611957,
  [SMALL_STATE(18540)] = 611971,
  [SMALL_STATE(18541)] = 611987,
  [SMALL_STATE(18542)] = 612003,
  [SMALL_STATE(18543)] = 612017,
  [SMALL_STATE(18544)] = 612033,
  [SMALL_STATE(18545)] = 612049,
  [SMALL_STATE(18546)] = 612065,
  [SMALL_STATE(18547)] = 612081,
  [SMALL_STATE(18548)] = 612097,
  [SMALL_STATE(18549)] = 612109,
  [SMALL_STATE(18550)] = 612125,
  [SMALL_STATE(18551)] = 612141,
  [SMALL_STATE(18552)] = 612153,
  [SMALL_STATE(18553)] = 612169,
  [SMALL_STATE(18554)] = 612181,
  [SMALL_STATE(18555)] = 612197,
  [SMALL_STATE(18556)] = 612213,
  [SMALL_STATE(18557)] = 612229,
  [SMALL_STATE(18558)] = 612245,
  [SMALL_STATE(18559)] = 612261,
  [SMALL_STATE(18560)] = 612275,
  [SMALL_STATE(18561)] = 612289,
  [SMALL_STATE(18562)] = 612303,
  [SMALL_STATE(18563)] = 612317,
  [SMALL_STATE(18564)] = 612333,
  [SMALL_STATE(18565)] = 612349,
  [SMALL_STATE(18566)] = 612365,
  [SMALL_STATE(18567)] = 612381,
  [SMALL_STATE(18568)] = 612397,
  [SMALL_STATE(18569)] = 612413,
  [SMALL_STATE(18570)] = 612429,
  [SMALL_STATE(18571)] = 612445,
  [SMALL_STATE(18572)] = 612461,
  [SMALL_STATE(18573)] = 612477,
  [SMALL_STATE(18574)] = 612493,
  [SMALL_STATE(18575)] = 612509,
  [SMALL_STATE(18576)] = 612525,
  [SMALL_STATE(18577)] = 612541,
  [SMALL_STATE(18578)] = 612557,
  [SMALL_STATE(18579)] = 612573,
  [SMALL_STATE(18580)] = 612589,
  [SMALL_STATE(18581)] = 612601,
  [SMALL_STATE(18582)] = 612617,
  [SMALL_STATE(18583)] = 612631,
  [SMALL_STATE(18584)] = 612647,
  [SMALL_STATE(18585)] = 612663,
  [SMALL_STATE(18586)] = 612679,
  [SMALL_STATE(18587)] = 612695,
  [SMALL_STATE(18588)] = 612711,
  [SMALL_STATE(18589)] = 612723,
  [SMALL_STATE(18590)] = 612739,
  [SMALL_STATE(18591)] = 612751,
  [SMALL_STATE(18592)] = 612767,
  [SMALL_STATE(18593)] = 612781,
  [SMALL_STATE(18594)] = 612797,
  [SMALL_STATE(18595)] = 612813,
  [SMALL_STATE(18596)] = 612829,
  [SMALL_STATE(18597)] = 612845,
  [SMALL_STATE(18598)] = 612861,
  [SMALL_STATE(18599)] = 612873,
  [SMALL_STATE(18600)] = 612885,
  [SMALL_STATE(18601)] = 612901,
  [SMALL_STATE(18602)] = 612917,
  [SMALL_STATE(18603)] = 612933,
  [SMALL_STATE(18604)] = 612949,
  [SMALL_STATE(18605)] = 612965,
  [SMALL_STATE(18606)] = 612977,
  [SMALL_STATE(18607)] = 612991,
  [SMALL_STATE(18608)] = 613003,
  [SMALL_STATE(18609)] = 613019,
  [SMALL_STATE(18610)] = 613035,
  [SMALL_STATE(18611)] = 613051,
  [SMALL_STATE(18612)] = 613067,
  [SMALL_STATE(18613)] = 613081,
  [SMALL_STATE(18614)] = 613093,
  [SMALL_STATE(18615)] = 613107,
  [SMALL_STATE(18616)] = 613123,
  [SMALL_STATE(18617)] = 613139,
  [SMALL_STATE(18618)] = 613155,
  [SMALL_STATE(18619)] = 613171,
  [SMALL_STATE(18620)] = 613187,
  [SMALL_STATE(18621)] = 613203,
  [SMALL_STATE(18622)] = 613215,
  [SMALL_STATE(18623)] = 613231,
  [SMALL_STATE(18624)] = 613247,
  [SMALL_STATE(18625)] = 613263,
  [SMALL_STATE(18626)] = 613279,
  [SMALL_STATE(18627)] = 613293,
  [SMALL_STATE(18628)] = 613307,
  [SMALL_STATE(18629)] = 613319,
  [SMALL_STATE(18630)] = 613331,
  [SMALL_STATE(18631)] = 613347,
  [SMALL_STATE(18632)] = 613359,
  [SMALL_STATE(18633)] = 613375,
  [SMALL_STATE(18634)] = 613391,
  [SMALL_STATE(18635)] = 613403,
  [SMALL_STATE(18636)] = 613417,
  [SMALL_STATE(18637)] = 613433,
  [SMALL_STATE(18638)] = 613447,
  [SMALL_STATE(18639)] = 613463,
  [SMALL_STATE(18640)] = 613475,
  [SMALL_STATE(18641)] = 613491,
  [SMALL_STATE(18642)] = 613503,
  [SMALL_STATE(18643)] = 613519,
  [SMALL_STATE(18644)] = 613535,
  [SMALL_STATE(18645)] = 613551,
  [SMALL_STATE(18646)] = 613567,
  [SMALL_STATE(18647)] = 613579,
  [SMALL_STATE(18648)] = 613591,
  [SMALL_STATE(18649)] = 613603,
  [SMALL_STATE(18650)] = 613617,
  [SMALL_STATE(18651)] = 613631,
  [SMALL_STATE(18652)] = 613647,
  [SMALL_STATE(18653)] = 613663,
  [SMALL_STATE(18654)] = 613679,
  [SMALL_STATE(18655)] = 613695,
  [SMALL_STATE(18656)] = 613707,
  [SMALL_STATE(18657)] = 613719,
  [SMALL_STATE(18658)] = 613735,
  [SMALL_STATE(18659)] = 613749,
  [SMALL_STATE(18660)] = 613765,
  [SMALL_STATE(18661)] = 613781,
  [SMALL_STATE(18662)] = 613795,
  [SMALL_STATE(18663)] = 613811,
  [SMALL_STATE(18664)] = 613827,
  [SMALL_STATE(18665)] = 613843,
  [SMALL_STATE(18666)] = 613859,
  [SMALL_STATE(18667)] = 613873,
  [SMALL_STATE(18668)] = 613885,
  [SMALL_STATE(18669)] = 613901,
  [SMALL_STATE(18670)] = 613917,
  [SMALL_STATE(18671)] = 613931,
  [SMALL_STATE(18672)] = 613947,
  [SMALL_STATE(18673)] = 613963,
  [SMALL_STATE(18674)] = 613975,
  [SMALL_STATE(18675)] = 613991,
  [SMALL_STATE(18676)] = 614007,
  [SMALL_STATE(18677)] = 614023,
  [SMALL_STATE(18678)] = 614039,
  [SMALL_STATE(18679)] = 614055,
  [SMALL_STATE(18680)] = 614067,
  [SMALL_STATE(18681)] = 614083,
  [SMALL_STATE(18682)] = 614095,
  [SMALL_STATE(18683)] = 614111,
  [SMALL_STATE(18684)] = 614123,
  [SMALL_STATE(18685)] = 614135,
  [SMALL_STATE(18686)] = 614147,
  [SMALL_STATE(18687)] = 614161,
  [SMALL_STATE(18688)] = 614175,
  [SMALL_STATE(18689)] = 614191,
  [SMALL_STATE(18690)] = 614205,
  [SMALL_STATE(18691)] = 614217,
  [SMALL_STATE(18692)] = 614231,
  [SMALL_STATE(18693)] = 614247,
  [SMALL_STATE(18694)] = 614263,
  [SMALL_STATE(18695)] = 614279,
  [SMALL_STATE(18696)] = 614295,
  [SMALL_STATE(18697)] = 614311,
  [SMALL_STATE(18698)] = 614327,
  [SMALL_STATE(18699)] = 614339,
  [SMALL_STATE(18700)] = 614351,
  [SMALL_STATE(18701)] = 614367,
  [SMALL_STATE(18702)] = 614381,
  [SMALL_STATE(18703)] = 614397,
  [SMALL_STATE(18704)] = 614413,
  [SMALL_STATE(18705)] = 614427,
  [SMALL_STATE(18706)] = 614441,
  [SMALL_STATE(18707)] = 614455,
  [SMALL_STATE(18708)] = 614467,
  [SMALL_STATE(18709)] = 614481,
  [SMALL_STATE(18710)] = 614493,
  [SMALL_STATE(18711)] = 614509,
  [SMALL_STATE(18712)] = 614525,
  [SMALL_STATE(18713)] = 614541,
  [SMALL_STATE(18714)] = 614557,
  [SMALL_STATE(18715)] = 614573,
  [SMALL_STATE(18716)] = 614589,
  [SMALL_STATE(18717)] = 614605,
  [SMALL_STATE(18718)] = 614621,
  [SMALL_STATE(18719)] = 614633,
  [SMALL_STATE(18720)] = 614649,
  [SMALL_STATE(18721)] = 614661,
  [SMALL_STATE(18722)] = 614677,
  [SMALL_STATE(18723)] = 614693,
  [SMALL_STATE(18724)] = 614709,
  [SMALL_STATE(18725)] = 614723,
  [SMALL_STATE(18726)] = 614739,
  [SMALL_STATE(18727)] = 614751,
  [SMALL_STATE(18728)] = 614765,
  [SMALL_STATE(18729)] = 614781,
  [SMALL_STATE(18730)] = 614797,
  [SMALL_STATE(18731)] = 614813,
  [SMALL_STATE(18732)] = 614829,
  [SMALL_STATE(18733)] = 614841,
  [SMALL_STATE(18734)] = 614857,
  [SMALL_STATE(18735)] = 614873,
  [SMALL_STATE(18736)] = 614885,
  [SMALL_STATE(18737)] = 614899,
  [SMALL_STATE(18738)] = 614915,
  [SMALL_STATE(18739)] = 614931,
  [SMALL_STATE(18740)] = 614947,
  [SMALL_STATE(18741)] = 614963,
  [SMALL_STATE(18742)] = 614979,
  [SMALL_STATE(18743)] = 614995,
  [SMALL_STATE(18744)] = 615011,
  [SMALL_STATE(18745)] = 615027,
  [SMALL_STATE(18746)] = 615043,
  [SMALL_STATE(18747)] = 615059,
  [SMALL_STATE(18748)] = 615075,
  [SMALL_STATE(18749)] = 615087,
  [SMALL_STATE(18750)] = 615103,
  [SMALL_STATE(18751)] = 615119,
  [SMALL_STATE(18752)] = 615135,
  [SMALL_STATE(18753)] = 615151,
  [SMALL_STATE(18754)] = 615163,
  [SMALL_STATE(18755)] = 615177,
  [SMALL_STATE(18756)] = 615191,
  [SMALL_STATE(18757)] = 615205,
  [SMALL_STATE(18758)] = 615217,
  [SMALL_STATE(18759)] = 615233,
  [SMALL_STATE(18760)] = 615249,
  [SMALL_STATE(18761)] = 615265,
  [SMALL_STATE(18762)] = 615281,
  [SMALL_STATE(18763)] = 615297,
  [SMALL_STATE(18764)] = 615309,
  [SMALL_STATE(18765)] = 615325,
  [SMALL_STATE(18766)] = 615339,
  [SMALL_STATE(18767)] = 615355,
  [SMALL_STATE(18768)] = 615371,
  [SMALL_STATE(18769)] = 615387,
  [SMALL_STATE(18770)] = 615399,
  [SMALL_STATE(18771)] = 615415,
  [SMALL_STATE(18772)] = 615431,
  [SMALL_STATE(18773)] = 615447,
  [SMALL_STATE(18774)] = 615463,
  [SMALL_STATE(18775)] = 615475,
  [SMALL_STATE(18776)] = 615487,
  [SMALL_STATE(18777)] = 615499,
  [SMALL_STATE(18778)] = 615515,
  [SMALL_STATE(18779)] = 615531,
  [SMALL_STATE(18780)] = 615547,
  [SMALL_STATE(18781)] = 615561,
  [SMALL_STATE(18782)] = 615577,
  [SMALL_STATE(18783)] = 615593,
  [SMALL_STATE(18784)] = 615609,
  [SMALL_STATE(18785)] = 615623,
  [SMALL_STATE(18786)] = 615639,
  [SMALL_STATE(18787)] = 615651,
  [SMALL_STATE(18788)] = 615667,
  [SMALL_STATE(18789)] = 615681,
  [SMALL_STATE(18790)] = 615693,
  [SMALL_STATE(18791)] = 615707,
  [SMALL_STATE(18792)] = 615721,
  [SMALL_STATE(18793)] = 615735,
  [SMALL_STATE(18794)] = 615747,
  [SMALL_STATE(18795)] = 615763,
  [SMALL_STATE(18796)] = 615779,
  [SMALL_STATE(18797)] = 615793,
  [SMALL_STATE(18798)] = 615809,
  [SMALL_STATE(18799)] = 615821,
  [SMALL_STATE(18800)] = 615833,
  [SMALL_STATE(18801)] = 615849,
  [SMALL_STATE(18802)] = 615865,
  [SMALL_STATE(18803)] = 615881,
  [SMALL_STATE(18804)] = 615897,
  [SMALL_STATE(18805)] = 615913,
  [SMALL_STATE(18806)] = 615929,
  [SMALL_STATE(18807)] = 615945,
  [SMALL_STATE(18808)] = 615961,
  [SMALL_STATE(18809)] = 615975,
  [SMALL_STATE(18810)] = 615991,
  [SMALL_STATE(18811)] = 616007,
  [SMALL_STATE(18812)] = 616023,
  [SMALL_STATE(18813)] = 616039,
  [SMALL_STATE(18814)] = 616055,
  [SMALL_STATE(18815)] = 616069,
  [SMALL_STATE(18816)] = 616085,
  [SMALL_STATE(18817)] = 616099,
  [SMALL_STATE(18818)] = 616113,
  [SMALL_STATE(18819)] = 616129,
  [SMALL_STATE(18820)] = 616145,
  [SMALL_STATE(18821)] = 616161,
  [SMALL_STATE(18822)] = 616177,
  [SMALL_STATE(18823)] = 616193,
  [SMALL_STATE(18824)] = 616209,
  [SMALL_STATE(18825)] = 616225,
  [SMALL_STATE(18826)] = 616241,
  [SMALL_STATE(18827)] = 616257,
  [SMALL_STATE(18828)] = 616271,
  [SMALL_STATE(18829)] = 616283,
  [SMALL_STATE(18830)] = 616297,
  [SMALL_STATE(18831)] = 616313,
  [SMALL_STATE(18832)] = 616327,
  [SMALL_STATE(18833)] = 616341,
  [SMALL_STATE(18834)] = 616355,
  [SMALL_STATE(18835)] = 616371,
  [SMALL_STATE(18836)] = 616385,
  [SMALL_STATE(18837)] = 616401,
  [SMALL_STATE(18838)] = 616417,
  [SMALL_STATE(18839)] = 616433,
  [SMALL_STATE(18840)] = 616449,
  [SMALL_STATE(18841)] = 616465,
  [SMALL_STATE(18842)] = 616481,
  [SMALL_STATE(18843)] = 616497,
  [SMALL_STATE(18844)] = 616511,
  [SMALL_STATE(18845)] = 616525,
  [SMALL_STATE(18846)] = 616539,
  [SMALL_STATE(18847)] = 616555,
  [SMALL_STATE(18848)] = 616569,
  [SMALL_STATE(18849)] = 616585,
  [SMALL_STATE(18850)] = 616601,
  [SMALL_STATE(18851)] = 616617,
  [SMALL_STATE(18852)] = 616633,
  [SMALL_STATE(18853)] = 616649,
  [SMALL_STATE(18854)] = 616665,
  [SMALL_STATE(18855)] = 616681,
  [SMALL_STATE(18856)] = 616697,
  [SMALL_STATE(18857)] = 616709,
  [SMALL_STATE(18858)] = 616725,
  [SMALL_STATE(18859)] = 616741,
  [SMALL_STATE(18860)] = 616757,
  [SMALL_STATE(18861)] = 616773,
  [SMALL_STATE(18862)] = 616789,
  [SMALL_STATE(18863)] = 616805,
  [SMALL_STATE(18864)] = 616819,
  [SMALL_STATE(18865)] = 616835,
  [SMALL_STATE(18866)] = 616851,
  [SMALL_STATE(18867)] = 616863,
  [SMALL_STATE(18868)] = 616879,
  [SMALL_STATE(18869)] = 616893,
  [SMALL_STATE(18870)] = 616909,
  [SMALL_STATE(18871)] = 616923,
  [SMALL_STATE(18872)] = 616939,
  [SMALL_STATE(18873)] = 616951,
  [SMALL_STATE(18874)] = 616965,
  [SMALL_STATE(18875)] = 616981,
  [SMALL_STATE(18876)] = 616995,
  [SMALL_STATE(18877)] = 617011,
  [SMALL_STATE(18878)] = 617027,
  [SMALL_STATE(18879)] = 617043,
  [SMALL_STATE(18880)] = 617059,
  [SMALL_STATE(18881)] = 617071,
  [SMALL_STATE(18882)] = 617087,
  [SMALL_STATE(18883)] = 617099,
  [SMALL_STATE(18884)] = 617115,
  [SMALL_STATE(18885)] = 617131,
  [SMALL_STATE(18886)] = 617147,
  [SMALL_STATE(18887)] = 617163,
  [SMALL_STATE(18888)] = 617179,
  [SMALL_STATE(18889)] = 617195,
  [SMALL_STATE(18890)] = 617211,
  [SMALL_STATE(18891)] = 617227,
  [SMALL_STATE(18892)] = 617241,
  [SMALL_STATE(18893)] = 617253,
  [SMALL_STATE(18894)] = 617269,
  [SMALL_STATE(18895)] = 617283,
  [SMALL_STATE(18896)] = 617299,
  [SMALL_STATE(18897)] = 617313,
  [SMALL_STATE(18898)] = 617329,
  [SMALL_STATE(18899)] = 617341,
  [SMALL_STATE(18900)] = 617355,
  [SMALL_STATE(18901)] = 617371,
  [SMALL_STATE(18902)] = 617387,
  [SMALL_STATE(18903)] = 617403,
  [SMALL_STATE(18904)] = 617419,
  [SMALL_STATE(18905)] = 617431,
  [SMALL_STATE(18906)] = 617447,
  [SMALL_STATE(18907)] = 617463,
  [SMALL_STATE(18908)] = 617479,
  [SMALL_STATE(18909)] = 617495,
  [SMALL_STATE(18910)] = 617511,
  [SMALL_STATE(18911)] = 617527,
  [SMALL_STATE(18912)] = 617543,
  [SMALL_STATE(18913)] = 617559,
  [SMALL_STATE(18914)] = 617575,
  [SMALL_STATE(18915)] = 617591,
  [SMALL_STATE(18916)] = 617605,
  [SMALL_STATE(18917)] = 617621,
  [SMALL_STATE(18918)] = 617635,
  [SMALL_STATE(18919)] = 617647,
  [SMALL_STATE(18920)] = 617663,
  [SMALL_STATE(18921)] = 617675,
  [SMALL_STATE(18922)] = 617687,
  [SMALL_STATE(18923)] = 617699,
  [SMALL_STATE(18924)] = 617715,
  [SMALL_STATE(18925)] = 617729,
  [SMALL_STATE(18926)] = 617745,
  [SMALL_STATE(18927)] = 617761,
  [SMALL_STATE(18928)] = 617777,
  [SMALL_STATE(18929)] = 617789,
  [SMALL_STATE(18930)] = 617803,
  [SMALL_STATE(18931)] = 617819,
  [SMALL_STATE(18932)] = 617833,
  [SMALL_STATE(18933)] = 617849,
  [SMALL_STATE(18934)] = 617861,
  [SMALL_STATE(18935)] = 617877,
  [SMALL_STATE(18936)] = 617893,
  [SMALL_STATE(18937)] = 617905,
  [SMALL_STATE(18938)] = 617917,
  [SMALL_STATE(18939)] = 617933,
  [SMALL_STATE(18940)] = 617945,
  [SMALL_STATE(18941)] = 617961,
  [SMALL_STATE(18942)] = 617977,
  [SMALL_STATE(18943)] = 617993,
  [SMALL_STATE(18944)] = 618009,
  [SMALL_STATE(18945)] = 618025,
  [SMALL_STATE(18946)] = 618041,
  [SMALL_STATE(18947)] = 618057,
  [SMALL_STATE(18948)] = 618071,
  [SMALL_STATE(18949)] = 618087,
  [SMALL_STATE(18950)] = 618099,
  [SMALL_STATE(18951)] = 618113,
  [SMALL_STATE(18952)] = 618127,
  [SMALL_STATE(18953)] = 618139,
  [SMALL_STATE(18954)] = 618155,
  [SMALL_STATE(18955)] = 618171,
  [SMALL_STATE(18956)] = 618183,
  [SMALL_STATE(18957)] = 618195,
  [SMALL_STATE(18958)] = 618211,
  [SMALL_STATE(18959)] = 618223,
  [SMALL_STATE(18960)] = 618239,
  [SMALL_STATE(18961)] = 618255,
  [SMALL_STATE(18962)] = 618267,
  [SMALL_STATE(18963)] = 618283,
  [SMALL_STATE(18964)] = 618299,
  [SMALL_STATE(18965)] = 618315,
  [SMALL_STATE(18966)] = 618331,
  [SMALL_STATE(18967)] = 618347,
  [SMALL_STATE(18968)] = 618361,
  [SMALL_STATE(18969)] = 618377,
  [SMALL_STATE(18970)] = 618391,
  [SMALL_STATE(18971)] = 618407,
  [SMALL_STATE(18972)] = 618423,
  [SMALL_STATE(18973)] = 618437,
  [SMALL_STATE(18974)] = 618451,
  [SMALL_STATE(18975)] = 618465,
  [SMALL_STATE(18976)] = 618481,
  [SMALL_STATE(18977)] = 618497,
  [SMALL_STATE(18978)] = 618513,
  [SMALL_STATE(18979)] = 618529,
  [SMALL_STATE(18980)] = 618545,
  [SMALL_STATE(18981)] = 618561,
  [SMALL_STATE(18982)] = 618575,
  [SMALL_STATE(18983)] = 618589,
  [SMALL_STATE(18984)] = 618603,
  [SMALL_STATE(18985)] = 618619,
  [SMALL_STATE(18986)] = 618633,
  [SMALL_STATE(18987)] = 618649,
  [SMALL_STATE(18988)] = 618665,
  [SMALL_STATE(18989)] = 618677,
  [SMALL_STATE(18990)] = 618693,
  [SMALL_STATE(18991)] = 618709,
  [SMALL_STATE(18992)] = 618725,
  [SMALL_STATE(18993)] = 618739,
  [SMALL_STATE(18994)] = 618755,
  [SMALL_STATE(18995)] = 618769,
  [SMALL_STATE(18996)] = 618785,
  [SMALL_STATE(18997)] = 618797,
  [SMALL_STATE(18998)] = 618811,
  [SMALL_STATE(18999)] = 618827,
  [SMALL_STATE(19000)] = 618843,
  [SMALL_STATE(19001)] = 618859,
  [SMALL_STATE(19002)] = 618875,
  [SMALL_STATE(19003)] = 618891,
  [SMALL_STATE(19004)] = 618903,
  [SMALL_STATE(19005)] = 618915,
  [SMALL_STATE(19006)] = 618927,
  [SMALL_STATE(19007)] = 618939,
  [SMALL_STATE(19008)] = 618955,
  [SMALL_STATE(19009)] = 618971,
  [SMALL_STATE(19010)] = 618987,
  [SMALL_STATE(19011)] = 619003,
  [SMALL_STATE(19012)] = 619019,
  [SMALL_STATE(19013)] = 619033,
  [SMALL_STATE(19014)] = 619047,
  [SMALL_STATE(19015)] = 619059,
  [SMALL_STATE(19016)] = 619073,
  [SMALL_STATE(19017)] = 619087,
  [SMALL_STATE(19018)] = 619103,
  [SMALL_STATE(19019)] = 619117,
  [SMALL_STATE(19020)] = 619133,
  [SMALL_STATE(19021)] = 619149,
  [SMALL_STATE(19022)] = 619165,
  [SMALL_STATE(19023)] = 619181,
  [SMALL_STATE(19024)] = 619197,
  [SMALL_STATE(19025)] = 619213,
  [SMALL_STATE(19026)] = 619229,
  [SMALL_STATE(19027)] = 619241,
  [SMALL_STATE(19028)] = 619257,
  [SMALL_STATE(19029)] = 619273,
  [SMALL_STATE(19030)] = 619289,
  [SMALL_STATE(19031)] = 619305,
  [SMALL_STATE(19032)] = 619321,
  [SMALL_STATE(19033)] = 619337,
  [SMALL_STATE(19034)] = 619353,
  [SMALL_STATE(19035)] = 619369,
  [SMALL_STATE(19036)] = 619383,
  [SMALL_STATE(19037)] = 619399,
  [SMALL_STATE(19038)] = 619413,
  [SMALL_STATE(19039)] = 619429,
  [SMALL_STATE(19040)] = 619443,
  [SMALL_STATE(19041)] = 619459,
  [SMALL_STATE(19042)] = 619473,
  [SMALL_STATE(19043)] = 619487,
  [SMALL_STATE(19044)] = 619503,
  [SMALL_STATE(19045)] = 619519,
  [SMALL_STATE(19046)] = 619535,
  [SMALL_STATE(19047)] = 619551,
  [SMALL_STATE(19048)] = 619567,
  [SMALL_STATE(19049)] = 619583,
  [SMALL_STATE(19050)] = 619599,
  [SMALL_STATE(19051)] = 619615,
  [SMALL_STATE(19052)] = 619631,
  [SMALL_STATE(19053)] = 619647,
  [SMALL_STATE(19054)] = 619663,
  [SMALL_STATE(19055)] = 619679,
  [SMALL_STATE(19056)] = 619695,
  [SMALL_STATE(19057)] = 619711,
  [SMALL_STATE(19058)] = 619727,
  [SMALL_STATE(19059)] = 619741,
  [SMALL_STATE(19060)] = 619757,
  [SMALL_STATE(19061)] = 619773,
  [SMALL_STATE(19062)] = 619789,
  [SMALL_STATE(19063)] = 619805,
  [SMALL_STATE(19064)] = 619821,
  [SMALL_STATE(19065)] = 619835,
  [SMALL_STATE(19066)] = 619851,
  [SMALL_STATE(19067)] = 619867,
  [SMALL_STATE(19068)] = 619881,
  [SMALL_STATE(19069)] = 619893,
  [SMALL_STATE(19070)] = 619909,
  [SMALL_STATE(19071)] = 619925,
  [SMALL_STATE(19072)] = 619939,
  [SMALL_STATE(19073)] = 619955,
  [SMALL_STATE(19074)] = 619971,
  [SMALL_STATE(19075)] = 619987,
  [SMALL_STATE(19076)] = 620003,
  [SMALL_STATE(19077)] = 620019,
  [SMALL_STATE(19078)] = 620031,
  [SMALL_STATE(19079)] = 620047,
  [SMALL_STATE(19080)] = 620063,
  [SMALL_STATE(19081)] = 620079,
  [SMALL_STATE(19082)] = 620095,
  [SMALL_STATE(19083)] = 620109,
  [SMALL_STATE(19084)] = 620121,
  [SMALL_STATE(19085)] = 620135,
  [SMALL_STATE(19086)] = 620149,
  [SMALL_STATE(19087)] = 620165,
  [SMALL_STATE(19088)] = 620181,
  [SMALL_STATE(19089)] = 620197,
  [SMALL_STATE(19090)] = 620209,
  [SMALL_STATE(19091)] = 620225,
  [SMALL_STATE(19092)] = 620241,
  [SMALL_STATE(19093)] = 620257,
  [SMALL_STATE(19094)] = 620273,
  [SMALL_STATE(19095)] = 620287,
  [SMALL_STATE(19096)] = 620303,
  [SMALL_STATE(19097)] = 620319,
  [SMALL_STATE(19098)] = 620335,
  [SMALL_STATE(19099)] = 620351,
  [SMALL_STATE(19100)] = 620367,
  [SMALL_STATE(19101)] = 620381,
  [SMALL_STATE(19102)] = 620395,
  [SMALL_STATE(19103)] = 620411,
  [SMALL_STATE(19104)] = 620425,
  [SMALL_STATE(19105)] = 620439,
  [SMALL_STATE(19106)] = 620453,
  [SMALL_STATE(19107)] = 620469,
  [SMALL_STATE(19108)] = 620481,
  [SMALL_STATE(19109)] = 620493,
  [SMALL_STATE(19110)] = 620509,
  [SMALL_STATE(19111)] = 620525,
  [SMALL_STATE(19112)] = 620539,
  [SMALL_STATE(19113)] = 620551,
  [SMALL_STATE(19114)] = 620565,
  [SMALL_STATE(19115)] = 620581,
  [SMALL_STATE(19116)] = 620597,
  [SMALL_STATE(19117)] = 620613,
  [SMALL_STATE(19118)] = 620629,
  [SMALL_STATE(19119)] = 620643,
  [SMALL_STATE(19120)] = 620659,
  [SMALL_STATE(19121)] = 620675,
  [SMALL_STATE(19122)] = 620691,
  [SMALL_STATE(19123)] = 620705,
  [SMALL_STATE(19124)] = 620721,
  [SMALL_STATE(19125)] = 620735,
  [SMALL_STATE(19126)] = 620751,
  [SMALL_STATE(19127)] = 620767,
  [SMALL_STATE(19128)] = 620783,
  [SMALL_STATE(19129)] = 620799,
  [SMALL_STATE(19130)] = 620811,
  [SMALL_STATE(19131)] = 620827,
  [SMALL_STATE(19132)] = 620843,
  [SMALL_STATE(19133)] = 620859,
  [SMALL_STATE(19134)] = 620875,
  [SMALL_STATE(19135)] = 620891,
  [SMALL_STATE(19136)] = 620907,
  [SMALL_STATE(19137)] = 620921,
  [SMALL_STATE(19138)] = 620935,
  [SMALL_STATE(19139)] = 620951,
  [SMALL_STATE(19140)] = 620967,
  [SMALL_STATE(19141)] = 620981,
  [SMALL_STATE(19142)] = 620995,
  [SMALL_STATE(19143)] = 621007,
  [SMALL_STATE(19144)] = 621023,
  [SMALL_STATE(19145)] = 621039,
  [SMALL_STATE(19146)] = 621055,
  [SMALL_STATE(19147)] = 621071,
  [SMALL_STATE(19148)] = 621087,
  [SMALL_STATE(19149)] = 621103,
  [SMALL_STATE(19150)] = 621117,
  [SMALL_STATE(19151)] = 621133,
  [SMALL_STATE(19152)] = 621149,
  [SMALL_STATE(19153)] = 621165,
  [SMALL_STATE(19154)] = 621179,
  [SMALL_STATE(19155)] = 621195,
  [SMALL_STATE(19156)] = 621211,
  [SMALL_STATE(19157)] = 621223,
  [SMALL_STATE(19158)] = 621237,
  [SMALL_STATE(19159)] = 621253,
  [SMALL_STATE(19160)] = 621267,
  [SMALL_STATE(19161)] = 621281,
  [SMALL_STATE(19162)] = 621297,
  [SMALL_STATE(19163)] = 621313,
  [SMALL_STATE(19164)] = 621329,
  [SMALL_STATE(19165)] = 621345,
  [SMALL_STATE(19166)] = 621361,
  [SMALL_STATE(19167)] = 621377,
  [SMALL_STATE(19168)] = 621393,
  [SMALL_STATE(19169)] = 621409,
  [SMALL_STATE(19170)] = 621425,
  [SMALL_STATE(19171)] = 621441,
  [SMALL_STATE(19172)] = 621455,
  [SMALL_STATE(19173)] = 621471,
  [SMALL_STATE(19174)] = 621487,
  [SMALL_STATE(19175)] = 621501,
  [SMALL_STATE(19176)] = 621517,
  [SMALL_STATE(19177)] = 621533,
  [SMALL_STATE(19178)] = 621547,
  [SMALL_STATE(19179)] = 621563,
  [SMALL_STATE(19180)] = 621579,
  [SMALL_STATE(19181)] = 621591,
  [SMALL_STATE(19182)] = 621607,
  [SMALL_STATE(19183)] = 621621,
  [SMALL_STATE(19184)] = 621633,
  [SMALL_STATE(19185)] = 621649,
  [SMALL_STATE(19186)] = 621665,
  [SMALL_STATE(19187)] = 621681,
  [SMALL_STATE(19188)] = 621697,
  [SMALL_STATE(19189)] = 621713,
  [SMALL_STATE(19190)] = 621729,
  [SMALL_STATE(19191)] = 621745,
  [SMALL_STATE(19192)] = 621761,
  [SMALL_STATE(19193)] = 621777,
  [SMALL_STATE(19194)] = 621789,
  [SMALL_STATE(19195)] = 621805,
  [SMALL_STATE(19196)] = 621821,
  [SMALL_STATE(19197)] = 621833,
  [SMALL_STATE(19198)] = 621849,
  [SMALL_STATE(19199)] = 621863,
  [SMALL_STATE(19200)] = 621877,
  [SMALL_STATE(19201)] = 621893,
  [SMALL_STATE(19202)] = 621909,
  [SMALL_STATE(19203)] = 621925,
  [SMALL_STATE(19204)] = 621939,
  [SMALL_STATE(19205)] = 621955,
  [SMALL_STATE(19206)] = 621971,
  [SMALL_STATE(19207)] = 621987,
  [SMALL_STATE(19208)] = 622003,
  [SMALL_STATE(19209)] = 622015,
  [SMALL_STATE(19210)] = 622031,
  [SMALL_STATE(19211)] = 622047,
  [SMALL_STATE(19212)] = 622063,
  [SMALL_STATE(19213)] = 622077,
  [SMALL_STATE(19214)] = 622093,
  [SMALL_STATE(19215)] = 622107,
  [SMALL_STATE(19216)] = 622123,
  [SMALL_STATE(19217)] = 622137,
  [SMALL_STATE(19218)] = 622153,
  [SMALL_STATE(19219)] = 622169,
  [SMALL_STATE(19220)] = 622183,
  [SMALL_STATE(19221)] = 622197,
  [SMALL_STATE(19222)] = 622213,
  [SMALL_STATE(19223)] = 622229,
  [SMALL_STATE(19224)] = 622241,
  [SMALL_STATE(19225)] = 622257,
  [SMALL_STATE(19226)] = 622273,
  [SMALL_STATE(19227)] = 622289,
  [SMALL_STATE(19228)] = 622305,
  [SMALL_STATE(19229)] = 622321,
  [SMALL_STATE(19230)] = 622337,
  [SMALL_STATE(19231)] = 622351,
  [SMALL_STATE(19232)] = 622367,
  [SMALL_STATE(19233)] = 622381,
  [SMALL_STATE(19234)] = 622393,
  [SMALL_STATE(19235)] = 622407,
  [SMALL_STATE(19236)] = 622423,
  [SMALL_STATE(19237)] = 622437,
  [SMALL_STATE(19238)] = 622449,
  [SMALL_STATE(19239)] = 622465,
  [SMALL_STATE(19240)] = 622479,
  [SMALL_STATE(19241)] = 622495,
  [SMALL_STATE(19242)] = 622507,
  [SMALL_STATE(19243)] = 622521,
  [SMALL_STATE(19244)] = 622533,
  [SMALL_STATE(19245)] = 622549,
  [SMALL_STATE(19246)] = 622565,
  [SMALL_STATE(19247)] = 622581,
  [SMALL_STATE(19248)] = 622597,
  [SMALL_STATE(19249)] = 622613,
  [SMALL_STATE(19250)] = 622625,
  [SMALL_STATE(19251)] = 622641,
  [SMALL_STATE(19252)] = 622657,
  [SMALL_STATE(19253)] = 622673,
  [SMALL_STATE(19254)] = 622689,
  [SMALL_STATE(19255)] = 622705,
  [SMALL_STATE(19256)] = 622719,
  [SMALL_STATE(19257)] = 622733,
  [SMALL_STATE(19258)] = 622749,
  [SMALL_STATE(19259)] = 622765,
  [SMALL_STATE(19260)] = 622781,
  [SMALL_STATE(19261)] = 622797,
  [SMALL_STATE(19262)] = 622809,
  [SMALL_STATE(19263)] = 622821,
  [SMALL_STATE(19264)] = 622837,
  [SMALL_STATE(19265)] = 622851,
  [SMALL_STATE(19266)] = 622867,
  [SMALL_STATE(19267)] = 622881,
  [SMALL_STATE(19268)] = 622897,
  [SMALL_STATE(19269)] = 622909,
  [SMALL_STATE(19270)] = 622923,
  [SMALL_STATE(19271)] = 622939,
  [SMALL_STATE(19272)] = 622955,
  [SMALL_STATE(19273)] = 622971,
  [SMALL_STATE(19274)] = 622987,
  [SMALL_STATE(19275)] = 623003,
  [SMALL_STATE(19276)] = 623019,
  [SMALL_STATE(19277)] = 623035,
  [SMALL_STATE(19278)] = 623049,
  [SMALL_STATE(19279)] = 623065,
  [SMALL_STATE(19280)] = 623079,
  [SMALL_STATE(19281)] = 623095,
  [SMALL_STATE(19282)] = 623109,
  [SMALL_STATE(19283)] = 623123,
  [SMALL_STATE(19284)] = 623139,
  [SMALL_STATE(19285)] = 623151,
  [SMALL_STATE(19286)] = 623167,
  [SMALL_STATE(19287)] = 623179,
  [SMALL_STATE(19288)] = 623195,
  [SMALL_STATE(19289)] = 623209,
  [SMALL_STATE(19290)] = 623225,
  [SMALL_STATE(19291)] = 623241,
  [SMALL_STATE(19292)] = 623257,
  [SMALL_STATE(19293)] = 623273,
  [SMALL_STATE(19294)] = 623285,
  [SMALL_STATE(19295)] = 623297,
  [SMALL_STATE(19296)] = 623313,
  [SMALL_STATE(19297)] = 623329,
  [SMALL_STATE(19298)] = 623345,
  [SMALL_STATE(19299)] = 623357,
  [SMALL_STATE(19300)] = 623369,
  [SMALL_STATE(19301)] = 623385,
  [SMALL_STATE(19302)] = 623401,
  [SMALL_STATE(19303)] = 623413,
  [SMALL_STATE(19304)] = 623429,
  [SMALL_STATE(19305)] = 623445,
  [SMALL_STATE(19306)] = 623459,
  [SMALL_STATE(19307)] = 623471,
  [SMALL_STATE(19308)] = 623485,
  [SMALL_STATE(19309)] = 623499,
  [SMALL_STATE(19310)] = 623515,
  [SMALL_STATE(19311)] = 623531,
  [SMALL_STATE(19312)] = 623547,
  [SMALL_STATE(19313)] = 623559,
  [SMALL_STATE(19314)] = 623575,
  [SMALL_STATE(19315)] = 623591,
  [SMALL_STATE(19316)] = 623603,
  [SMALL_STATE(19317)] = 623619,
  [SMALL_STATE(19318)] = 623635,
  [SMALL_STATE(19319)] = 623651,
  [SMALL_STATE(19320)] = 623667,
  [SMALL_STATE(19321)] = 623683,
  [SMALL_STATE(19322)] = 623699,
  [SMALL_STATE(19323)] = 623715,
  [SMALL_STATE(19324)] = 623731,
  [SMALL_STATE(19325)] = 623747,
  [SMALL_STATE(19326)] = 623761,
  [SMALL_STATE(19327)] = 623777,
  [SMALL_STATE(19328)] = 623793,
  [SMALL_STATE(19329)] = 623807,
  [SMALL_STATE(19330)] = 623823,
  [SMALL_STATE(19331)] = 623837,
  [SMALL_STATE(19332)] = 623853,
  [SMALL_STATE(19333)] = 623869,
  [SMALL_STATE(19334)] = 623885,
  [SMALL_STATE(19335)] = 623901,
  [SMALL_STATE(19336)] = 623917,
  [SMALL_STATE(19337)] = 623933,
  [SMALL_STATE(19338)] = 623949,
  [SMALL_STATE(19339)] = 623965,
  [SMALL_STATE(19340)] = 623981,
  [SMALL_STATE(19341)] = 623995,
  [SMALL_STATE(19342)] = 624011,
  [SMALL_STATE(19343)] = 624027,
  [SMALL_STATE(19344)] = 624041,
  [SMALL_STATE(19345)] = 624053,
  [SMALL_STATE(19346)] = 624067,
  [SMALL_STATE(19347)] = 624081,
  [SMALL_STATE(19348)] = 624095,
  [SMALL_STATE(19349)] = 624109,
  [SMALL_STATE(19350)] = 624121,
  [SMALL_STATE(19351)] = 624135,
  [SMALL_STATE(19352)] = 624147,
  [SMALL_STATE(19353)] = 624163,
  [SMALL_STATE(19354)] = 624179,
  [SMALL_STATE(19355)] = 624195,
  [SMALL_STATE(19356)] = 624211,
  [SMALL_STATE(19357)] = 624227,
  [SMALL_STATE(19358)] = 624243,
  [SMALL_STATE(19359)] = 624259,
  [SMALL_STATE(19360)] = 624275,
  [SMALL_STATE(19361)] = 624289,
  [SMALL_STATE(19362)] = 624305,
  [SMALL_STATE(19363)] = 624321,
  [SMALL_STATE(19364)] = 624335,
  [SMALL_STATE(19365)] = 624347,
  [SMALL_STATE(19366)] = 624363,
  [SMALL_STATE(19367)] = 624377,
  [SMALL_STATE(19368)] = 624393,
  [SMALL_STATE(19369)] = 624409,
  [SMALL_STATE(19370)] = 624425,
  [SMALL_STATE(19371)] = 624439,
  [SMALL_STATE(19372)] = 624455,
  [SMALL_STATE(19373)] = 624471,
  [SMALL_STATE(19374)] = 624487,
  [SMALL_STATE(19375)] = 624503,
  [SMALL_STATE(19376)] = 624519,
  [SMALL_STATE(19377)] = 624535,
  [SMALL_STATE(19378)] = 624551,
  [SMALL_STATE(19379)] = 624567,
  [SMALL_STATE(19380)] = 624583,
  [SMALL_STATE(19381)] = 624599,
  [SMALL_STATE(19382)] = 624615,
  [SMALL_STATE(19383)] = 624631,
  [SMALL_STATE(19384)] = 624647,
  [SMALL_STATE(19385)] = 624661,
  [SMALL_STATE(19386)] = 624677,
  [SMALL_STATE(19387)] = 624691,
  [SMALL_STATE(19388)] = 624707,
  [SMALL_STATE(19389)] = 624721,
  [SMALL_STATE(19390)] = 624737,
  [SMALL_STATE(19391)] = 624751,
  [SMALL_STATE(19392)] = 624765,
  [SMALL_STATE(19393)] = 624781,
  [SMALL_STATE(19394)] = 624797,
  [SMALL_STATE(19395)] = 624809,
  [SMALL_STATE(19396)] = 624823,
  [SMALL_STATE(19397)] = 624839,
  [SMALL_STATE(19398)] = 624855,
  [SMALL_STATE(19399)] = 624871,
  [SMALL_STATE(19400)] = 624887,
  [SMALL_STATE(19401)] = 624903,
  [SMALL_STATE(19402)] = 624919,
  [SMALL_STATE(19403)] = 624935,
  [SMALL_STATE(19404)] = 624951,
  [SMALL_STATE(19405)] = 624967,
  [SMALL_STATE(19406)] = 624983,
  [SMALL_STATE(19407)] = 624997,
  [SMALL_STATE(19408)] = 625011,
  [SMALL_STATE(19409)] = 625025,
  [SMALL_STATE(19410)] = 625041,
  [SMALL_STATE(19411)] = 625053,
  [SMALL_STATE(19412)] = 625067,
  [SMALL_STATE(19413)] = 625079,
  [SMALL_STATE(19414)] = 625095,
  [SMALL_STATE(19415)] = 625111,
  [SMALL_STATE(19416)] = 625123,
  [SMALL_STATE(19417)] = 625139,
  [SMALL_STATE(19418)] = 625155,
  [SMALL_STATE(19419)] = 625171,
  [SMALL_STATE(19420)] = 625183,
  [SMALL_STATE(19421)] = 625199,
  [SMALL_STATE(19422)] = 625215,
  [SMALL_STATE(19423)] = 625231,
  [SMALL_STATE(19424)] = 625243,
  [SMALL_STATE(19425)] = 625259,
  [SMALL_STATE(19426)] = 625275,
  [SMALL_STATE(19427)] = 625291,
  [SMALL_STATE(19428)] = 625307,
  [SMALL_STATE(19429)] = 625321,
  [SMALL_STATE(19430)] = 625337,
  [SMALL_STATE(19431)] = 625349,
  [SMALL_STATE(19432)] = 625361,
  [SMALL_STATE(19433)] = 625375,
  [SMALL_STATE(19434)] = 625389,
  [SMALL_STATE(19435)] = 625403,
  [SMALL_STATE(19436)] = 625415,
  [SMALL_STATE(19437)] = 625427,
  [SMALL_STATE(19438)] = 625443,
  [SMALL_STATE(19439)] = 625457,
  [SMALL_STATE(19440)] = 625473,
  [SMALL_STATE(19441)] = 625485,
  [SMALL_STATE(19442)] = 625501,
  [SMALL_STATE(19443)] = 625513,
  [SMALL_STATE(19444)] = 625529,
  [SMALL_STATE(19445)] = 625545,
  [SMALL_STATE(19446)] = 625561,
  [SMALL_STATE(19447)] = 625577,
  [SMALL_STATE(19448)] = 625593,
  [SMALL_STATE(19449)] = 625607,
  [SMALL_STATE(19450)] = 625621,
  [SMALL_STATE(19451)] = 625637,
  [SMALL_STATE(19452)] = 625653,
  [SMALL_STATE(19453)] = 625667,
  [SMALL_STATE(19454)] = 625683,
  [SMALL_STATE(19455)] = 625697,
  [SMALL_STATE(19456)] = 625711,
  [SMALL_STATE(19457)] = 625723,
  [SMALL_STATE(19458)] = 625737,
  [SMALL_STATE(19459)] = 625753,
  [SMALL_STATE(19460)] = 625765,
  [SMALL_STATE(19461)] = 625781,
  [SMALL_STATE(19462)] = 625797,
  [SMALL_STATE(19463)] = 625813,
  [SMALL_STATE(19464)] = 625829,
  [SMALL_STATE(19465)] = 625845,
  [SMALL_STATE(19466)] = 625861,
  [SMALL_STATE(19467)] = 625875,
  [SMALL_STATE(19468)] = 625889,
  [SMALL_STATE(19469)] = 625905,
  [SMALL_STATE(19470)] = 625917,
  [SMALL_STATE(19471)] = 625931,
  [SMALL_STATE(19472)] = 625947,
  [SMALL_STATE(19473)] = 625963,
  [SMALL_STATE(19474)] = 625979,
  [SMALL_STATE(19475)] = 625993,
  [SMALL_STATE(19476)] = 626005,
  [SMALL_STATE(19477)] = 626021,
  [SMALL_STATE(19478)] = 626037,
  [SMALL_STATE(19479)] = 626053,
  [SMALL_STATE(19480)] = 626069,
  [SMALL_STATE(19481)] = 626085,
  [SMALL_STATE(19482)] = 626101,
  [SMALL_STATE(19483)] = 626117,
  [SMALL_STATE(19484)] = 626133,
  [SMALL_STATE(19485)] = 626149,
  [SMALL_STATE(19486)] = 626165,
  [SMALL_STATE(19487)] = 626181,
  [SMALL_STATE(19488)] = 626197,
  [SMALL_STATE(19489)] = 626211,
  [SMALL_STATE(19490)] = 626227,
  [SMALL_STATE(19491)] = 626241,
  [SMALL_STATE(19492)] = 626257,
  [SMALL_STATE(19493)] = 626271,
  [SMALL_STATE(19494)] = 626283,
  [SMALL_STATE(19495)] = 626299,
  [SMALL_STATE(19496)] = 626315,
  [SMALL_STATE(19497)] = 626329,
  [SMALL_STATE(19498)] = 626345,
  [SMALL_STATE(19499)] = 626359,
  [SMALL_STATE(19500)] = 626375,
  [SMALL_STATE(19501)] = 626389,
  [SMALL_STATE(19502)] = 626405,
  [SMALL_STATE(19503)] = 626421,
  [SMALL_STATE(19504)] = 626437,
  [SMALL_STATE(19505)] = 626453,
  [SMALL_STATE(19506)] = 626469,
  [SMALL_STATE(19507)] = 626485,
  [SMALL_STATE(19508)] = 626501,
  [SMALL_STATE(19509)] = 626517,
  [SMALL_STATE(19510)] = 626533,
  [SMALL_STATE(19511)] = 626549,
  [SMALL_STATE(19512)] = 626565,
  [SMALL_STATE(19513)] = 626581,
  [SMALL_STATE(19514)] = 626595,
  [SMALL_STATE(19515)] = 626611,
  [SMALL_STATE(19516)] = 626627,
  [SMALL_STATE(19517)] = 626643,
  [SMALL_STATE(19518)] = 626659,
  [SMALL_STATE(19519)] = 626673,
  [SMALL_STATE(19520)] = 626687,
  [SMALL_STATE(19521)] = 626703,
  [SMALL_STATE(19522)] = 626717,
  [SMALL_STATE(19523)] = 626733,
  [SMALL_STATE(19524)] = 626747,
  [SMALL_STATE(19525)] = 626763,
  [SMALL_STATE(19526)] = 626775,
  [SMALL_STATE(19527)] = 626791,
  [SMALL_STATE(19528)] = 626807,
  [SMALL_STATE(19529)] = 626823,
  [SMALL_STATE(19530)] = 626835,
  [SMALL_STATE(19531)] = 626851,
  [SMALL_STATE(19532)] = 626867,
  [SMALL_STATE(19533)] = 626881,
  [SMALL_STATE(19534)] = 626897,
  [SMALL_STATE(19535)] = 626913,
  [SMALL_STATE(19536)] = 626927,
  [SMALL_STATE(19537)] = 626939,
  [SMALL_STATE(19538)] = 626955,
  [SMALL_STATE(19539)] = 626971,
  [SMALL_STATE(19540)] = 626985,
  [SMALL_STATE(19541)] = 627001,
  [SMALL_STATE(19542)] = 627015,
  [SMALL_STATE(19543)] = 627031,
  [SMALL_STATE(19544)] = 627045,
  [SMALL_STATE(19545)] = 627061,
  [SMALL_STATE(19546)] = 627075,
  [SMALL_STATE(19547)] = 627087,
  [SMALL_STATE(19548)] = 627103,
  [SMALL_STATE(19549)] = 627119,
  [SMALL_STATE(19550)] = 627135,
  [SMALL_STATE(19551)] = 627151,
  [SMALL_STATE(19552)] = 627165,
  [SMALL_STATE(19553)] = 627181,
  [SMALL_STATE(19554)] = 627195,
  [SMALL_STATE(19555)] = 627211,
  [SMALL_STATE(19556)] = 627227,
  [SMALL_STATE(19557)] = 627241,
  [SMALL_STATE(19558)] = 627257,
  [SMALL_STATE(19559)] = 627271,
  [SMALL_STATE(19560)] = 627283,
  [SMALL_STATE(19561)] = 627297,
  [SMALL_STATE(19562)] = 627313,
  [SMALL_STATE(19563)] = 627327,
  [SMALL_STATE(19564)] = 627343,
  [SMALL_STATE(19565)] = 627359,
  [SMALL_STATE(19566)] = 627371,
  [SMALL_STATE(19567)] = 627383,
  [SMALL_STATE(19568)] = 627399,
  [SMALL_STATE(19569)] = 627415,
  [SMALL_STATE(19570)] = 627431,
  [SMALL_STATE(19571)] = 627447,
  [SMALL_STATE(19572)] = 627463,
  [SMALL_STATE(19573)] = 627479,
  [SMALL_STATE(19574)] = 627495,
  [SMALL_STATE(19575)] = 627511,
  [SMALL_STATE(19576)] = 627527,
  [SMALL_STATE(19577)] = 627543,
  [SMALL_STATE(19578)] = 627557,
  [SMALL_STATE(19579)] = 627573,
  [SMALL_STATE(19580)] = 627587,
  [SMALL_STATE(19581)] = 627603,
  [SMALL_STATE(19582)] = 627617,
  [SMALL_STATE(19583)] = 627633,
  [SMALL_STATE(19584)] = 627647,
  [SMALL_STATE(19585)] = 627661,
  [SMALL_STATE(19586)] = 627673,
  [SMALL_STATE(19587)] = 627689,
  [SMALL_STATE(19588)] = 627705,
  [SMALL_STATE(19589)] = 627721,
  [SMALL_STATE(19590)] = 627737,
  [SMALL_STATE(19591)] = 627753,
  [SMALL_STATE(19592)] = 627767,
  [SMALL_STATE(19593)] = 627781,
  [SMALL_STATE(19594)] = 627797,
  [SMALL_STATE(19595)] = 627811,
  [SMALL_STATE(19596)] = 627825,
  [SMALL_STATE(19597)] = 627839,
  [SMALL_STATE(19598)] = 627855,
  [SMALL_STATE(19599)] = 627871,
  [SMALL_STATE(19600)] = 627887,
  [SMALL_STATE(19601)] = 627903,
  [SMALL_STATE(19602)] = 627919,
  [SMALL_STATE(19603)] = 627935,
  [SMALL_STATE(19604)] = 627951,
  [SMALL_STATE(19605)] = 627967,
  [SMALL_STATE(19606)] = 627983,
  [SMALL_STATE(19607)] = 627999,
  [SMALL_STATE(19608)] = 628015,
  [SMALL_STATE(19609)] = 628031,
  [SMALL_STATE(19610)] = 628047,
  [SMALL_STATE(19611)] = 628063,
  [SMALL_STATE(19612)] = 628077,
  [SMALL_STATE(19613)] = 628093,
  [SMALL_STATE(19614)] = 628107,
  [SMALL_STATE(19615)] = 628123,
  [SMALL_STATE(19616)] = 628139,
  [SMALL_STATE(19617)] = 628153,
  [SMALL_STATE(19618)] = 628167,
  [SMALL_STATE(19619)] = 628183,
  [SMALL_STATE(19620)] = 628199,
  [SMALL_STATE(19621)] = 628213,
  [SMALL_STATE(19622)] = 628227,
  [SMALL_STATE(19623)] = 628241,
  [SMALL_STATE(19624)] = 628257,
  [SMALL_STATE(19625)] = 628273,
  [SMALL_STATE(19626)] = 628289,
  [SMALL_STATE(19627)] = 628305,
  [SMALL_STATE(19628)] = 628321,
  [SMALL_STATE(19629)] = 628337,
  [SMALL_STATE(19630)] = 628353,
  [SMALL_STATE(19631)] = 628369,
  [SMALL_STATE(19632)] = 628385,
  [SMALL_STATE(19633)] = 628401,
  [SMALL_STATE(19634)] = 628417,
  [SMALL_STATE(19635)] = 628433,
  [SMALL_STATE(19636)] = 628447,
  [SMALL_STATE(19637)] = 628463,
  [SMALL_STATE(19638)] = 628477,
  [SMALL_STATE(19639)] = 628493,
  [SMALL_STATE(19640)] = 628507,
  [SMALL_STATE(19641)] = 628523,
  [SMALL_STATE(19642)] = 628537,
  [SMALL_STATE(19643)] = 628553,
  [SMALL_STATE(19644)] = 628567,
  [SMALL_STATE(19645)] = 628583,
  [SMALL_STATE(19646)] = 628599,
  [SMALL_STATE(19647)] = 628615,
  [SMALL_STATE(19648)] = 628631,
  [SMALL_STATE(19649)] = 628647,
  [SMALL_STATE(19650)] = 628663,
  [SMALL_STATE(19651)] = 628679,
  [SMALL_STATE(19652)] = 628693,
  [SMALL_STATE(19653)] = 628707,
  [SMALL_STATE(19654)] = 628723,
  [SMALL_STATE(19655)] = 628739,
  [SMALL_STATE(19656)] = 628753,
  [SMALL_STATE(19657)] = 628767,
  [SMALL_STATE(19658)] = 628783,
  [SMALL_STATE(19659)] = 628799,
  [SMALL_STATE(19660)] = 628815,
  [SMALL_STATE(19661)] = 628827,
  [SMALL_STATE(19662)] = 628843,
  [SMALL_STATE(19663)] = 628859,
  [SMALL_STATE(19664)] = 628875,
  [SMALL_STATE(19665)] = 628891,
  [SMALL_STATE(19666)] = 628907,
  [SMALL_STATE(19667)] = 628923,
  [SMALL_STATE(19668)] = 628939,
  [SMALL_STATE(19669)] = 628955,
  [SMALL_STATE(19670)] = 628971,
  [SMALL_STATE(19671)] = 628985,
  [SMALL_STATE(19672)] = 628999,
  [SMALL_STATE(19673)] = 629011,
  [SMALL_STATE(19674)] = 629025,
  [SMALL_STATE(19675)] = 629041,
  [SMALL_STATE(19676)] = 629055,
  [SMALL_STATE(19677)] = 629069,
  [SMALL_STATE(19678)] = 629085,
  [SMALL_STATE(19679)] = 629099,
  [SMALL_STATE(19680)] = 629115,
  [SMALL_STATE(19681)] = 629131,
  [SMALL_STATE(19682)] = 629147,
  [SMALL_STATE(19683)] = 629161,
  [SMALL_STATE(19684)] = 629177,
  [SMALL_STATE(19685)] = 629193,
  [SMALL_STATE(19686)] = 629209,
  [SMALL_STATE(19687)] = 629225,
  [SMALL_STATE(19688)] = 629241,
  [SMALL_STATE(19689)] = 629257,
  [SMALL_STATE(19690)] = 629273,
  [SMALL_STATE(19691)] = 629287,
  [SMALL_STATE(19692)] = 629299,
  [SMALL_STATE(19693)] = 629315,
  [SMALL_STATE(19694)] = 629329,
  [SMALL_STATE(19695)] = 629345,
  [SMALL_STATE(19696)] = 629361,
  [SMALL_STATE(19697)] = 629375,
  [SMALL_STATE(19698)] = 629387,
  [SMALL_STATE(19699)] = 629399,
  [SMALL_STATE(19700)] = 629413,
  [SMALL_STATE(19701)] = 629425,
  [SMALL_STATE(19702)] = 629439,
  [SMALL_STATE(19703)] = 629455,
  [SMALL_STATE(19704)] = 629469,
  [SMALL_STATE(19705)] = 629485,
  [SMALL_STATE(19706)] = 629501,
  [SMALL_STATE(19707)] = 629515,
  [SMALL_STATE(19708)] = 629531,
  [SMALL_STATE(19709)] = 629547,
  [SMALL_STATE(19710)] = 629563,
  [SMALL_STATE(19711)] = 629577,
  [SMALL_STATE(19712)] = 629591,
  [SMALL_STATE(19713)] = 629605,
  [SMALL_STATE(19714)] = 629621,
  [SMALL_STATE(19715)] = 629635,
  [SMALL_STATE(19716)] = 629651,
  [SMALL_STATE(19717)] = 629667,
  [SMALL_STATE(19718)] = 629683,
  [SMALL_STATE(19719)] = 629699,
  [SMALL_STATE(19720)] = 629715,
  [SMALL_STATE(19721)] = 629731,
  [SMALL_STATE(19722)] = 629743,
  [SMALL_STATE(19723)] = 629759,
  [SMALL_STATE(19724)] = 629775,
  [SMALL_STATE(19725)] = 629791,
  [SMALL_STATE(19726)] = 629807,
  [SMALL_STATE(19727)] = 629823,
  [SMALL_STATE(19728)] = 629839,
  [SMALL_STATE(19729)] = 629853,
  [SMALL_STATE(19730)] = 629869,
  [SMALL_STATE(19731)] = 629881,
  [SMALL_STATE(19732)] = 629895,
  [SMALL_STATE(19733)] = 629907,
  [SMALL_STATE(19734)] = 629921,
  [SMALL_STATE(19735)] = 629933,
  [SMALL_STATE(19736)] = 629947,
  [SMALL_STATE(19737)] = 629961,
  [SMALL_STATE(19738)] = 629975,
  [SMALL_STATE(19739)] = 629991,
  [SMALL_STATE(19740)] = 630007,
  [SMALL_STATE(19741)] = 630023,
  [SMALL_STATE(19742)] = 630039,
  [SMALL_STATE(19743)] = 630053,
  [SMALL_STATE(19744)] = 630069,
  [SMALL_STATE(19745)] = 630085,
  [SMALL_STATE(19746)] = 630101,
  [SMALL_STATE(19747)] = 630115,
  [SMALL_STATE(19748)] = 630131,
  [SMALL_STATE(19749)] = 630147,
  [SMALL_STATE(19750)] = 630159,
  [SMALL_STATE(19751)] = 630173,
  [SMALL_STATE(19752)] = 630187,
  [SMALL_STATE(19753)] = 630203,
  [SMALL_STATE(19754)] = 630217,
  [SMALL_STATE(19755)] = 630233,
  [SMALL_STATE(19756)] = 630249,
  [SMALL_STATE(19757)] = 630265,
  [SMALL_STATE(19758)] = 630277,
  [SMALL_STATE(19759)] = 630293,
  [SMALL_STATE(19760)] = 630309,
  [SMALL_STATE(19761)] = 630325,
  [SMALL_STATE(19762)] = 630339,
  [SMALL_STATE(19763)] = 630355,
  [SMALL_STATE(19764)] = 630369,
  [SMALL_STATE(19765)] = 630385,
  [SMALL_STATE(19766)] = 630397,
  [SMALL_STATE(19767)] = 630411,
  [SMALL_STATE(19768)] = 630425,
  [SMALL_STATE(19769)] = 630439,
  [SMALL_STATE(19770)] = 630455,
  [SMALL_STATE(19771)] = 630469,
  [SMALL_STATE(19772)] = 630485,
  [SMALL_STATE(19773)] = 630499,
  [SMALL_STATE(19774)] = 630515,
  [SMALL_STATE(19775)] = 630531,
  [SMALL_STATE(19776)] = 630547,
  [SMALL_STATE(19777)] = 630563,
  [SMALL_STATE(19778)] = 630579,
  [SMALL_STATE(19779)] = 630595,
  [SMALL_STATE(19780)] = 630611,
  [SMALL_STATE(19781)] = 630625,
  [SMALL_STATE(19782)] = 630641,
  [SMALL_STATE(19783)] = 630657,
  [SMALL_STATE(19784)] = 630673,
  [SMALL_STATE(19785)] = 630689,
  [SMALL_STATE(19786)] = 630705,
  [SMALL_STATE(19787)] = 630719,
  [SMALL_STATE(19788)] = 630731,
  [SMALL_STATE(19789)] = 630747,
  [SMALL_STATE(19790)] = 630761,
  [SMALL_STATE(19791)] = 630775,
  [SMALL_STATE(19792)] = 630789,
  [SMALL_STATE(19793)] = 630805,
  [SMALL_STATE(19794)] = 630819,
  [SMALL_STATE(19795)] = 630835,
  [SMALL_STATE(19796)] = 630851,
  [SMALL_STATE(19797)] = 630867,
  [SMALL_STATE(19798)] = 630883,
  [SMALL_STATE(19799)] = 630899,
  [SMALL_STATE(19800)] = 630915,
  [SMALL_STATE(19801)] = 630929,
  [SMALL_STATE(19802)] = 630943,
  [SMALL_STATE(19803)] = 630957,
  [SMALL_STATE(19804)] = 630973,
  [SMALL_STATE(19805)] = 630987,
  [SMALL_STATE(19806)] = 631003,
  [SMALL_STATE(19807)] = 631019,
  [SMALL_STATE(19808)] = 631035,
  [SMALL_STATE(19809)] = 631051,
  [SMALL_STATE(19810)] = 631067,
  [SMALL_STATE(19811)] = 631079,
  [SMALL_STATE(19812)] = 631095,
  [SMALL_STATE(19813)] = 631111,
  [SMALL_STATE(19814)] = 631127,
  [SMALL_STATE(19815)] = 631143,
  [SMALL_STATE(19816)] = 631159,
  [SMALL_STATE(19817)] = 631175,
  [SMALL_STATE(19818)] = 631191,
  [SMALL_STATE(19819)] = 631207,
  [SMALL_STATE(19820)] = 631221,
  [SMALL_STATE(19821)] = 631237,
  [SMALL_STATE(19822)] = 631251,
  [SMALL_STATE(19823)] = 631265,
  [SMALL_STATE(19824)] = 631279,
  [SMALL_STATE(19825)] = 631295,
  [SMALL_STATE(19826)] = 631309,
  [SMALL_STATE(19827)] = 631325,
  [SMALL_STATE(19828)] = 631341,
  [SMALL_STATE(19829)] = 631357,
  [SMALL_STATE(19830)] = 631373,
  [SMALL_STATE(19831)] = 631389,
  [SMALL_STATE(19832)] = 631405,
  [SMALL_STATE(19833)] = 631419,
  [SMALL_STATE(19834)] = 631435,
  [SMALL_STATE(19835)] = 631451,
  [SMALL_STATE(19836)] = 631467,
  [SMALL_STATE(19837)] = 631481,
  [SMALL_STATE(19838)] = 631497,
  [SMALL_STATE(19839)] = 631513,
  [SMALL_STATE(19840)] = 631527,
  [SMALL_STATE(19841)] = 631543,
  [SMALL_STATE(19842)] = 631557,
  [SMALL_STATE(19843)] = 631573,
  [SMALL_STATE(19844)] = 631585,
  [SMALL_STATE(19845)] = 631601,
  [SMALL_STATE(19846)] = 631617,
  [SMALL_STATE(19847)] = 631633,
  [SMALL_STATE(19848)] = 631649,
  [SMALL_STATE(19849)] = 631665,
  [SMALL_STATE(19850)] = 631681,
  [SMALL_STATE(19851)] = 631697,
  [SMALL_STATE(19852)] = 631711,
  [SMALL_STATE(19853)] = 631727,
  [SMALL_STATE(19854)] = 631741,
  [SMALL_STATE(19855)] = 631757,
  [SMALL_STATE(19856)] = 631773,
  [SMALL_STATE(19857)] = 631789,
  [SMALL_STATE(19858)] = 631803,
  [SMALL_STATE(19859)] = 631817,
  [SMALL_STATE(19860)] = 631831,
  [SMALL_STATE(19861)] = 631843,
  [SMALL_STATE(19862)] = 631855,
  [SMALL_STATE(19863)] = 631869,
  [SMALL_STATE(19864)] = 631885,
  [SMALL_STATE(19865)] = 631897,
  [SMALL_STATE(19866)] = 631913,
  [SMALL_STATE(19867)] = 631929,
  [SMALL_STATE(19868)] = 631945,
  [SMALL_STATE(19869)] = 631961,
  [SMALL_STATE(19870)] = 631975,
  [SMALL_STATE(19871)] = 631991,
  [SMALL_STATE(19872)] = 632007,
  [SMALL_STATE(19873)] = 632023,
  [SMALL_STATE(19874)] = 632039,
  [SMALL_STATE(19875)] = 632055,
  [SMALL_STATE(19876)] = 632071,
  [SMALL_STATE(19877)] = 632085,
  [SMALL_STATE(19878)] = 632097,
  [SMALL_STATE(19879)] = 632113,
  [SMALL_STATE(19880)] = 632127,
  [SMALL_STATE(19881)] = 632143,
  [SMALL_STATE(19882)] = 632157,
  [SMALL_STATE(19883)] = 632171,
  [SMALL_STATE(19884)] = 632185,
  [SMALL_STATE(19885)] = 632201,
  [SMALL_STATE(19886)] = 632213,
  [SMALL_STATE(19887)] = 632227,
  [SMALL_STATE(19888)] = 632243,
  [SMALL_STATE(19889)] = 632255,
  [SMALL_STATE(19890)] = 632267,
  [SMALL_STATE(19891)] = 632283,
  [SMALL_STATE(19892)] = 632299,
  [SMALL_STATE(19893)] = 632313,
  [SMALL_STATE(19894)] = 632329,
  [SMALL_STATE(19895)] = 632345,
  [SMALL_STATE(19896)] = 632361,
  [SMALL_STATE(19897)] = 632377,
  [SMALL_STATE(19898)] = 632393,
  [SMALL_STATE(19899)] = 632409,
  [SMALL_STATE(19900)] = 632425,
  [SMALL_STATE(19901)] = 632441,
  [SMALL_STATE(19902)] = 632455,
  [SMALL_STATE(19903)] = 632471,
  [SMALL_STATE(19904)] = 632487,
  [SMALL_STATE(19905)] = 632503,
  [SMALL_STATE(19906)] = 632519,
  [SMALL_STATE(19907)] = 632535,
  [SMALL_STATE(19908)] = 632551,
  [SMALL_STATE(19909)] = 632565,
  [SMALL_STATE(19910)] = 632577,
  [SMALL_STATE(19911)] = 632591,
  [SMALL_STATE(19912)] = 632605,
  [SMALL_STATE(19913)] = 632617,
  [SMALL_STATE(19914)] = 632631,
  [SMALL_STATE(19915)] = 632647,
  [SMALL_STATE(19916)] = 632663,
  [SMALL_STATE(19917)] = 632679,
  [SMALL_STATE(19918)] = 632695,
  [SMALL_STATE(19919)] = 632711,
  [SMALL_STATE(19920)] = 632727,
  [SMALL_STATE(19921)] = 632743,
  [SMALL_STATE(19922)] = 632759,
  [SMALL_STATE(19923)] = 632773,
  [SMALL_STATE(19924)] = 632789,
  [SMALL_STATE(19925)] = 632803,
  [SMALL_STATE(19926)] = 632817,
  [SMALL_STATE(19927)] = 632831,
  [SMALL_STATE(19928)] = 632847,
  [SMALL_STATE(19929)] = 632863,
  [SMALL_STATE(19930)] = 632877,
  [SMALL_STATE(19931)] = 632893,
  [SMALL_STATE(19932)] = 632909,
  [SMALL_STATE(19933)] = 632925,
  [SMALL_STATE(19934)] = 632941,
  [SMALL_STATE(19935)] = 632957,
  [SMALL_STATE(19936)] = 632973,
  [SMALL_STATE(19937)] = 632989,
  [SMALL_STATE(19938)] = 633005,
  [SMALL_STATE(19939)] = 633019,
  [SMALL_STATE(19940)] = 633035,
  [SMALL_STATE(19941)] = 633051,
  [SMALL_STATE(19942)] = 633065,
  [SMALL_STATE(19943)] = 633081,
  [SMALL_STATE(19944)] = 633095,
  [SMALL_STATE(19945)] = 633107,
  [SMALL_STATE(19946)] = 633123,
  [SMALL_STATE(19947)] = 633139,
  [SMALL_STATE(19948)] = 633153,
  [SMALL_STATE(19949)] = 633169,
  [SMALL_STATE(19950)] = 633183,
  [SMALL_STATE(19951)] = 633195,
  [SMALL_STATE(19952)] = 633211,
  [SMALL_STATE(19953)] = 633225,
  [SMALL_STATE(19954)] = 633241,
  [SMALL_STATE(19955)] = 633257,
  [SMALL_STATE(19956)] = 633273,
  [SMALL_STATE(19957)] = 633289,
  [SMALL_STATE(19958)] = 633305,
  [SMALL_STATE(19959)] = 633321,
  [SMALL_STATE(19960)] = 633337,
  [SMALL_STATE(19961)] = 633353,
  [SMALL_STATE(19962)] = 633369,
  [SMALL_STATE(19963)] = 633385,
  [SMALL_STATE(19964)] = 633401,
  [SMALL_STATE(19965)] = 633417,
  [SMALL_STATE(19966)] = 633433,
  [SMALL_STATE(19967)] = 633447,
  [SMALL_STATE(19968)] = 633459,
  [SMALL_STATE(19969)] = 633473,
  [SMALL_STATE(19970)] = 633487,
  [SMALL_STATE(19971)] = 633503,
  [SMALL_STATE(19972)] = 633517,
  [SMALL_STATE(19973)] = 633531,
  [SMALL_STATE(19974)] = 633545,
  [SMALL_STATE(19975)] = 633561,
  [SMALL_STATE(19976)] = 633573,
  [SMALL_STATE(19977)] = 633585,
  [SMALL_STATE(19978)] = 633601,
  [SMALL_STATE(19979)] = 633617,
  [SMALL_STATE(19980)] = 633633,
  [SMALL_STATE(19981)] = 633649,
  [SMALL_STATE(19982)] = 633665,
  [SMALL_STATE(19983)] = 633679,
  [SMALL_STATE(19984)] = 633695,
  [SMALL_STATE(19985)] = 633711,
  [SMALL_STATE(19986)] = 633727,
  [SMALL_STATE(19987)] = 633741,
  [SMALL_STATE(19988)] = 633757,
  [SMALL_STATE(19989)] = 633773,
  [SMALL_STATE(19990)] = 633789,
  [SMALL_STATE(19991)] = 633805,
  [SMALL_STATE(19992)] = 633819,
  [SMALL_STATE(19993)] = 633835,
  [SMALL_STATE(19994)] = 633851,
  [SMALL_STATE(19995)] = 633867,
  [SMALL_STATE(19996)] = 633881,
  [SMALL_STATE(19997)] = 633897,
  [SMALL_STATE(19998)] = 633909,
  [SMALL_STATE(19999)] = 633925,
  [SMALL_STATE(20000)] = 633941,
  [SMALL_STATE(20001)] = 633953,
  [SMALL_STATE(20002)] = 633967,
  [SMALL_STATE(20003)] = 633983,
  [SMALL_STATE(20004)] = 633997,
  [SMALL_STATE(20005)] = 634009,
  [SMALL_STATE(20006)] = 634025,
  [SMALL_STATE(20007)] = 634041,
  [SMALL_STATE(20008)] = 634057,
  [SMALL_STATE(20009)] = 634073,
  [SMALL_STATE(20010)] = 634089,
  [SMALL_STATE(20011)] = 634105,
  [SMALL_STATE(20012)] = 634119,
  [SMALL_STATE(20013)] = 634135,
  [SMALL_STATE(20014)] = 634149,
  [SMALL_STATE(20015)] = 634161,
  [SMALL_STATE(20016)] = 634175,
  [SMALL_STATE(20017)] = 634191,
  [SMALL_STATE(20018)] = 634207,
  [SMALL_STATE(20019)] = 634219,
  [SMALL_STATE(20020)] = 634235,
  [SMALL_STATE(20021)] = 634249,
  [SMALL_STATE(20022)] = 634265,
  [SMALL_STATE(20023)] = 634281,
  [SMALL_STATE(20024)] = 634297,
  [SMALL_STATE(20025)] = 634311,
  [SMALL_STATE(20026)] = 634327,
  [SMALL_STATE(20027)] = 634343,
  [SMALL_STATE(20028)] = 634359,
  [SMALL_STATE(20029)] = 634375,
  [SMALL_STATE(20030)] = 634389,
  [SMALL_STATE(20031)] = 634401,
  [SMALL_STATE(20032)] = 634415,
  [SMALL_STATE(20033)] = 634431,
  [SMALL_STATE(20034)] = 634445,
  [SMALL_STATE(20035)] = 634461,
  [SMALL_STATE(20036)] = 634477,
  [SMALL_STATE(20037)] = 634493,
  [SMALL_STATE(20038)] = 634507,
  [SMALL_STATE(20039)] = 634523,
  [SMALL_STATE(20040)] = 634537,
  [SMALL_STATE(20041)] = 634551,
  [SMALL_STATE(20042)] = 634565,
  [SMALL_STATE(20043)] = 634581,
  [SMALL_STATE(20044)] = 634595,
  [SMALL_STATE(20045)] = 634611,
  [SMALL_STATE(20046)] = 634627,
  [SMALL_STATE(20047)] = 634639,
  [SMALL_STATE(20048)] = 634653,
  [SMALL_STATE(20049)] = 634669,
  [SMALL_STATE(20050)] = 634685,
  [SMALL_STATE(20051)] = 634701,
  [SMALL_STATE(20052)] = 634717,
  [SMALL_STATE(20053)] = 634733,
  [SMALL_STATE(20054)] = 634749,
  [SMALL_STATE(20055)] = 634761,
  [SMALL_STATE(20056)] = 634777,
  [SMALL_STATE(20057)] = 634793,
  [SMALL_STATE(20058)] = 634807,
  [SMALL_STATE(20059)] = 634819,
  [SMALL_STATE(20060)] = 634833,
  [SMALL_STATE(20061)] = 634849,
  [SMALL_STATE(20062)] = 634865,
  [SMALL_STATE(20063)] = 634879,
  [SMALL_STATE(20064)] = 634891,
  [SMALL_STATE(20065)] = 634905,
  [SMALL_STATE(20066)] = 634919,
  [SMALL_STATE(20067)] = 634931,
  [SMALL_STATE(20068)] = 634945,
  [SMALL_STATE(20069)] = 634961,
  [SMALL_STATE(20070)] = 634975,
  [SMALL_STATE(20071)] = 634987,
  [SMALL_STATE(20072)] = 635003,
  [SMALL_STATE(20073)] = 635019,
  [SMALL_STATE(20074)] = 635035,
  [SMALL_STATE(20075)] = 635051,
  [SMALL_STATE(20076)] = 635067,
  [SMALL_STATE(20077)] = 635083,
  [SMALL_STATE(20078)] = 635099,
  [SMALL_STATE(20079)] = 635115,
  [SMALL_STATE(20080)] = 635131,
  [SMALL_STATE(20081)] = 635145,
  [SMALL_STATE(20082)] = 635159,
  [SMALL_STATE(20083)] = 635171,
  [SMALL_STATE(20084)] = 635185,
  [SMALL_STATE(20085)] = 635199,
  [SMALL_STATE(20086)] = 635213,
  [SMALL_STATE(20087)] = 635225,
  [SMALL_STATE(20088)] = 635239,
  [SMALL_STATE(20089)] = 635251,
  [SMALL_STATE(20090)] = 635267,
  [SMALL_STATE(20091)] = 635283,
  [SMALL_STATE(20092)] = 635299,
  [SMALL_STATE(20093)] = 635315,
  [SMALL_STATE(20094)] = 635331,
  [SMALL_STATE(20095)] = 635347,
  [SMALL_STATE(20096)] = 635361,
  [SMALL_STATE(20097)] = 635377,
  [SMALL_STATE(20098)] = 635391,
  [SMALL_STATE(20099)] = 635407,
  [SMALL_STATE(20100)] = 635421,
  [SMALL_STATE(20101)] = 635437,
  [SMALL_STATE(20102)] = 635453,
  [SMALL_STATE(20103)] = 635467,
  [SMALL_STATE(20104)] = 635483,
  [SMALL_STATE(20105)] = 635495,
  [SMALL_STATE(20106)] = 635511,
  [SMALL_STATE(20107)] = 635523,
  [SMALL_STATE(20108)] = 635539,
  [SMALL_STATE(20109)] = 635555,
  [SMALL_STATE(20110)] = 635567,
  [SMALL_STATE(20111)] = 635579,
  [SMALL_STATE(20112)] = 635595,
  [SMALL_STATE(20113)] = 635611,
  [SMALL_STATE(20114)] = 635625,
  [SMALL_STATE(20115)] = 635641,
  [SMALL_STATE(20116)] = 635655,
  [SMALL_STATE(20117)] = 635671,
  [SMALL_STATE(20118)] = 635687,
  [SMALL_STATE(20119)] = 635703,
  [SMALL_STATE(20120)] = 635719,
  [SMALL_STATE(20121)] = 635733,
  [SMALL_STATE(20122)] = 635747,
  [SMALL_STATE(20123)] = 635763,
  [SMALL_STATE(20124)] = 635777,
  [SMALL_STATE(20125)] = 635793,
  [SMALL_STATE(20126)] = 635807,
  [SMALL_STATE(20127)] = 635819,
  [SMALL_STATE(20128)] = 635835,
  [SMALL_STATE(20129)] = 635851,
  [SMALL_STATE(20130)] = 635867,
  [SMALL_STATE(20131)] = 635883,
  [SMALL_STATE(20132)] = 635899,
  [SMALL_STATE(20133)] = 635915,
  [SMALL_STATE(20134)] = 635931,
  [SMALL_STATE(20135)] = 635947,
  [SMALL_STATE(20136)] = 635963,
  [SMALL_STATE(20137)] = 635975,
  [SMALL_STATE(20138)] = 635991,
  [SMALL_STATE(20139)] = 636007,
  [SMALL_STATE(20140)] = 636023,
  [SMALL_STATE(20141)] = 636037,
  [SMALL_STATE(20142)] = 636051,
  [SMALL_STATE(20143)] = 636067,
  [SMALL_STATE(20144)] = 636081,
  [SMALL_STATE(20145)] = 636093,
  [SMALL_STATE(20146)] = 636109,
  [SMALL_STATE(20147)] = 636123,
  [SMALL_STATE(20148)] = 636137,
  [SMALL_STATE(20149)] = 636151,
  [SMALL_STATE(20150)] = 636167,
  [SMALL_STATE(20151)] = 636183,
  [SMALL_STATE(20152)] = 636197,
  [SMALL_STATE(20153)] = 636213,
  [SMALL_STATE(20154)] = 636229,
  [SMALL_STATE(20155)] = 636245,
  [SMALL_STATE(20156)] = 636261,
  [SMALL_STATE(20157)] = 636277,
  [SMALL_STATE(20158)] = 636293,
  [SMALL_STATE(20159)] = 636309,
  [SMALL_STATE(20160)] = 636321,
  [SMALL_STATE(20161)] = 636337,
  [SMALL_STATE(20162)] = 636353,
  [SMALL_STATE(20163)] = 636369,
  [SMALL_STATE(20164)] = 636385,
  [SMALL_STATE(20165)] = 636401,
  [SMALL_STATE(20166)] = 636417,
  [SMALL_STATE(20167)] = 636433,
  [SMALL_STATE(20168)] = 636449,
  [SMALL_STATE(20169)] = 636463,
  [SMALL_STATE(20170)] = 636477,
  [SMALL_STATE(20171)] = 636493,
  [SMALL_STATE(20172)] = 636507,
  [SMALL_STATE(20173)] = 636523,
  [SMALL_STATE(20174)] = 636539,
  [SMALL_STATE(20175)] = 636553,
  [SMALL_STATE(20176)] = 636567,
  [SMALL_STATE(20177)] = 636583,
  [SMALL_STATE(20178)] = 636597,
  [SMALL_STATE(20179)] = 636609,
  [SMALL_STATE(20180)] = 636623,
  [SMALL_STATE(20181)] = 636639,
  [SMALL_STATE(20182)] = 636655,
  [SMALL_STATE(20183)] = 636671,
  [SMALL_STATE(20184)] = 636687,
  [SMALL_STATE(20185)] = 636703,
  [SMALL_STATE(20186)] = 636714,
  [SMALL_STATE(20187)] = 636725,
  [SMALL_STATE(20188)] = 636736,
  [SMALL_STATE(20189)] = 636747,
  [SMALL_STATE(20190)] = 636760,
  [SMALL_STATE(20191)] = 636771,
  [SMALL_STATE(20192)] = 636784,
  [SMALL_STATE(20193)] = 636795,
  [SMALL_STATE(20194)] = 636806,
  [SMALL_STATE(20195)] = 636817,
  [SMALL_STATE(20196)] = 636828,
  [SMALL_STATE(20197)] = 636839,
  [SMALL_STATE(20198)] = 636850,
  [SMALL_STATE(20199)] = 636861,
  [SMALL_STATE(20200)] = 636872,
  [SMALL_STATE(20201)] = 636883,
  [SMALL_STATE(20202)] = 636894,
  [SMALL_STATE(20203)] = 636905,
  [SMALL_STATE(20204)] = 636916,
  [SMALL_STATE(20205)] = 636927,
  [SMALL_STATE(20206)] = 636938,
  [SMALL_STATE(20207)] = 636949,
  [SMALL_STATE(20208)] = 636960,
  [SMALL_STATE(20209)] = 636973,
  [SMALL_STATE(20210)] = 636984,
  [SMALL_STATE(20211)] = 636995,
  [SMALL_STATE(20212)] = 637006,
  [SMALL_STATE(20213)] = 637017,
  [SMALL_STATE(20214)] = 637028,
  [SMALL_STATE(20215)] = 637039,
  [SMALL_STATE(20216)] = 637050,
  [SMALL_STATE(20217)] = 637061,
  [SMALL_STATE(20218)] = 637072,
  [SMALL_STATE(20219)] = 637083,
  [SMALL_STATE(20220)] = 637094,
  [SMALL_STATE(20221)] = 637105,
  [SMALL_STATE(20222)] = 637116,
  [SMALL_STATE(20223)] = 637127,
  [SMALL_STATE(20224)] = 637138,
  [SMALL_STATE(20225)] = 637149,
  [SMALL_STATE(20226)] = 637160,
  [SMALL_STATE(20227)] = 637171,
  [SMALL_STATE(20228)] = 637182,
  [SMALL_STATE(20229)] = 637193,
  [SMALL_STATE(20230)] = 637204,
  [SMALL_STATE(20231)] = 637215,
  [SMALL_STATE(20232)] = 637226,
  [SMALL_STATE(20233)] = 637237,
  [SMALL_STATE(20234)] = 637248,
  [SMALL_STATE(20235)] = 637259,
  [SMALL_STATE(20236)] = 637270,
  [SMALL_STATE(20237)] = 637281,
  [SMALL_STATE(20238)] = 637294,
  [SMALL_STATE(20239)] = 637307,
  [SMALL_STATE(20240)] = 637318,
  [SMALL_STATE(20241)] = 637329,
  [SMALL_STATE(20242)] = 637340,
  [SMALL_STATE(20243)] = 637353,
  [SMALL_STATE(20244)] = 637366,
  [SMALL_STATE(20245)] = 637377,
  [SMALL_STATE(20246)] = 637390,
  [SMALL_STATE(20247)] = 637403,
  [SMALL_STATE(20248)] = 637416,
  [SMALL_STATE(20249)] = 637429,
  [SMALL_STATE(20250)] = 637440,
  [SMALL_STATE(20251)] = 637453,
  [SMALL_STATE(20252)] = 637466,
  [SMALL_STATE(20253)] = 637479,
  [SMALL_STATE(20254)] = 637492,
  [SMALL_STATE(20255)] = 637503,
  [SMALL_STATE(20256)] = 637514,
  [SMALL_STATE(20257)] = 637527,
  [SMALL_STATE(20258)] = 637540,
  [SMALL_STATE(20259)] = 637551,
  [SMALL_STATE(20260)] = 637564,
  [SMALL_STATE(20261)] = 637577,
  [SMALL_STATE(20262)] = 637590,
  [SMALL_STATE(20263)] = 637601,
  [SMALL_STATE(20264)] = 637614,
  [SMALL_STATE(20265)] = 637627,
  [SMALL_STATE(20266)] = 637640,
  [SMALL_STATE(20267)] = 637653,
  [SMALL_STATE(20268)] = 637666,
  [SMALL_STATE(20269)] = 637677,
  [SMALL_STATE(20270)] = 637690,
  [SMALL_STATE(20271)] = 637703,
  [SMALL_STATE(20272)] = 637714,
  [SMALL_STATE(20273)] = 637725,
  [SMALL_STATE(20274)] = 637738,
  [SMALL_STATE(20275)] = 637751,
  [SMALL_STATE(20276)] = 637764,
  [SMALL_STATE(20277)] = 637777,
  [SMALL_STATE(20278)] = 637790,
  [SMALL_STATE(20279)] = 637803,
  [SMALL_STATE(20280)] = 637816,
  [SMALL_STATE(20281)] = 637827,
  [SMALL_STATE(20282)] = 637840,
  [SMALL_STATE(20283)] = 637851,
  [SMALL_STATE(20284)] = 637864,
  [SMALL_STATE(20285)] = 637877,
  [SMALL_STATE(20286)] = 637890,
  [SMALL_STATE(20287)] = 637901,
  [SMALL_STATE(20288)] = 637914,
  [SMALL_STATE(20289)] = 637927,
  [SMALL_STATE(20290)] = 637940,
  [SMALL_STATE(20291)] = 637951,
  [SMALL_STATE(20292)] = 637964,
  [SMALL_STATE(20293)] = 637975,
  [SMALL_STATE(20294)] = 637988,
  [SMALL_STATE(20295)] = 638001,
  [SMALL_STATE(20296)] = 638012,
  [SMALL_STATE(20297)] = 638025,
  [SMALL_STATE(20298)] = 638038,
  [SMALL_STATE(20299)] = 638051,
  [SMALL_STATE(20300)] = 638064,
  [SMALL_STATE(20301)] = 638075,
  [SMALL_STATE(20302)] = 638086,
  [SMALL_STATE(20303)] = 638099,
  [SMALL_STATE(20304)] = 638110,
  [SMALL_STATE(20305)] = 638123,
  [SMALL_STATE(20306)] = 638136,
  [SMALL_STATE(20307)] = 638147,
  [SMALL_STATE(20308)] = 638160,
  [SMALL_STATE(20309)] = 638171,
  [SMALL_STATE(20310)] = 638184,
  [SMALL_STATE(20311)] = 638195,
  [SMALL_STATE(20312)] = 638208,
  [SMALL_STATE(20313)] = 638221,
  [SMALL_STATE(20314)] = 638234,
  [SMALL_STATE(20315)] = 638245,
  [SMALL_STATE(20316)] = 638258,
  [SMALL_STATE(20317)] = 638271,
  [SMALL_STATE(20318)] = 638284,
  [SMALL_STATE(20319)] = 638295,
  [SMALL_STATE(20320)] = 638308,
  [SMALL_STATE(20321)] = 638321,
  [SMALL_STATE(20322)] = 638334,
  [SMALL_STATE(20323)] = 638347,
  [SMALL_STATE(20324)] = 638360,
  [SMALL_STATE(20325)] = 638371,
  [SMALL_STATE(20326)] = 638382,
  [SMALL_STATE(20327)] = 638395,
  [SMALL_STATE(20328)] = 638408,
  [SMALL_STATE(20329)] = 638419,
  [SMALL_STATE(20330)] = 638432,
  [SMALL_STATE(20331)] = 638445,
  [SMALL_STATE(20332)] = 638458,
  [SMALL_STATE(20333)] = 638471,
  [SMALL_STATE(20334)] = 638484,
  [SMALL_STATE(20335)] = 638497,
  [SMALL_STATE(20336)] = 638510,
  [SMALL_STATE(20337)] = 638521,
  [SMALL_STATE(20338)] = 638534,
  [SMALL_STATE(20339)] = 638547,
  [SMALL_STATE(20340)] = 638560,
  [SMALL_STATE(20341)] = 638573,
  [SMALL_STATE(20342)] = 638586,
  [SMALL_STATE(20343)] = 638597,
  [SMALL_STATE(20344)] = 638610,
  [SMALL_STATE(20345)] = 638623,
  [SMALL_STATE(20346)] = 638636,
  [SMALL_STATE(20347)] = 638647,
  [SMALL_STATE(20348)] = 638658,
  [SMALL_STATE(20349)] = 638669,
  [SMALL_STATE(20350)] = 638682,
  [SMALL_STATE(20351)] = 638695,
  [SMALL_STATE(20352)] = 638708,
  [SMALL_STATE(20353)] = 638719,
  [SMALL_STATE(20354)] = 638732,
  [SMALL_STATE(20355)] = 638745,
  [SMALL_STATE(20356)] = 638758,
  [SMALL_STATE(20357)] = 638769,
  [SMALL_STATE(20358)] = 638780,
  [SMALL_STATE(20359)] = 638793,
  [SMALL_STATE(20360)] = 638806,
  [SMALL_STATE(20361)] = 638817,
  [SMALL_STATE(20362)] = 638830,
  [SMALL_STATE(20363)] = 638843,
  [SMALL_STATE(20364)] = 638856,
  [SMALL_STATE(20365)] = 638869,
  [SMALL_STATE(20366)] = 638882,
  [SMALL_STATE(20367)] = 638895,
  [SMALL_STATE(20368)] = 638908,
  [SMALL_STATE(20369)] = 638921,
  [SMALL_STATE(20370)] = 638932,
  [SMALL_STATE(20371)] = 638943,
  [SMALL_STATE(20372)] = 638956,
  [SMALL_STATE(20373)] = 638967,
  [SMALL_STATE(20374)] = 638978,
  [SMALL_STATE(20375)] = 638989,
  [SMALL_STATE(20376)] = 639002,
  [SMALL_STATE(20377)] = 639013,
  [SMALL_STATE(20378)] = 639026,
  [SMALL_STATE(20379)] = 639037,
  [SMALL_STATE(20380)] = 639050,
  [SMALL_STATE(20381)] = 639063,
  [SMALL_STATE(20382)] = 639074,
  [SMALL_STATE(20383)] = 639085,
  [SMALL_STATE(20384)] = 639096,
  [SMALL_STATE(20385)] = 639107,
  [SMALL_STATE(20386)] = 639120,
  [SMALL_STATE(20387)] = 639133,
  [SMALL_STATE(20388)] = 639146,
  [SMALL_STATE(20389)] = 639159,
  [SMALL_STATE(20390)] = 639172,
  [SMALL_STATE(20391)] = 639183,
  [SMALL_STATE(20392)] = 639196,
  [SMALL_STATE(20393)] = 639209,
  [SMALL_STATE(20394)] = 639220,
  [SMALL_STATE(20395)] = 639231,
  [SMALL_STATE(20396)] = 639244,
  [SMALL_STATE(20397)] = 639257,
  [SMALL_STATE(20398)] = 639270,
  [SMALL_STATE(20399)] = 639281,
  [SMALL_STATE(20400)] = 639292,
  [SMALL_STATE(20401)] = 639303,
  [SMALL_STATE(20402)] = 639316,
  [SMALL_STATE(20403)] = 639327,
  [SMALL_STATE(20404)] = 639338,
  [SMALL_STATE(20405)] = 639349,
  [SMALL_STATE(20406)] = 639362,
  [SMALL_STATE(20407)] = 639375,
  [SMALL_STATE(20408)] = 639388,
  [SMALL_STATE(20409)] = 639399,
  [SMALL_STATE(20410)] = 639410,
  [SMALL_STATE(20411)] = 639421,
  [SMALL_STATE(20412)] = 639434,
  [SMALL_STATE(20413)] = 639445,
  [SMALL_STATE(20414)] = 639456,
  [SMALL_STATE(20415)] = 639469,
  [SMALL_STATE(20416)] = 639482,
  [SMALL_STATE(20417)] = 639493,
  [SMALL_STATE(20418)] = 639504,
  [SMALL_STATE(20419)] = 639515,
  [SMALL_STATE(20420)] = 639526,
  [SMALL_STATE(20421)] = 639537,
  [SMALL_STATE(20422)] = 639550,
  [SMALL_STATE(20423)] = 639563,
  [SMALL_STATE(20424)] = 639574,
  [SMALL_STATE(20425)] = 639585,
  [SMALL_STATE(20426)] = 639596,
  [SMALL_STATE(20427)] = 639607,
  [SMALL_STATE(20428)] = 639618,
  [SMALL_STATE(20429)] = 639631,
  [SMALL_STATE(20430)] = 639642,
  [SMALL_STATE(20431)] = 639653,
  [SMALL_STATE(20432)] = 639666,
  [SMALL_STATE(20433)] = 639679,
  [SMALL_STATE(20434)] = 639690,
  [SMALL_STATE(20435)] = 639703,
  [SMALL_STATE(20436)] = 639716,
  [SMALL_STATE(20437)] = 639729,
  [SMALL_STATE(20438)] = 639740,
  [SMALL_STATE(20439)] = 639751,
  [SMALL_STATE(20440)] = 639764,
  [SMALL_STATE(20441)] = 639775,
  [SMALL_STATE(20442)] = 639788,
  [SMALL_STATE(20443)] = 639801,
  [SMALL_STATE(20444)] = 639814,
  [SMALL_STATE(20445)] = 639825,
  [SMALL_STATE(20446)] = 639836,
  [SMALL_STATE(20447)] = 639849,
  [SMALL_STATE(20448)] = 639860,
  [SMALL_STATE(20449)] = 639873,
  [SMALL_STATE(20450)] = 639884,
  [SMALL_STATE(20451)] = 639897,
  [SMALL_STATE(20452)] = 639910,
  [SMALL_STATE(20453)] = 639923,
  [SMALL_STATE(20454)] = 639934,
  [SMALL_STATE(20455)] = 639945,
  [SMALL_STATE(20456)] = 639958,
  [SMALL_STATE(20457)] = 639971,
  [SMALL_STATE(20458)] = 639984,
  [SMALL_STATE(20459)] = 639995,
  [SMALL_STATE(20460)] = 640006,
  [SMALL_STATE(20461)] = 640019,
  [SMALL_STATE(20462)] = 640030,
  [SMALL_STATE(20463)] = 640043,
  [SMALL_STATE(20464)] = 640056,
  [SMALL_STATE(20465)] = 640069,
  [SMALL_STATE(20466)] = 640080,
  [SMALL_STATE(20467)] = 640091,
  [SMALL_STATE(20468)] = 640104,
  [SMALL_STATE(20469)] = 640115,
  [SMALL_STATE(20470)] = 640128,
  [SMALL_STATE(20471)] = 640141,
  [SMALL_STATE(20472)] = 640152,
  [SMALL_STATE(20473)] = 640163,
  [SMALL_STATE(20474)] = 640176,
  [SMALL_STATE(20475)] = 640189,
  [SMALL_STATE(20476)] = 640200,
  [SMALL_STATE(20477)] = 640213,
  [SMALL_STATE(20478)] = 640224,
  [SMALL_STATE(20479)] = 640235,
  [SMALL_STATE(20480)] = 640246,
  [SMALL_STATE(20481)] = 640257,
  [SMALL_STATE(20482)] = 640270,
  [SMALL_STATE(20483)] = 640281,
  [SMALL_STATE(20484)] = 640292,
  [SMALL_STATE(20485)] = 640305,
  [SMALL_STATE(20486)] = 640316,
  [SMALL_STATE(20487)] = 640327,
  [SMALL_STATE(20488)] = 640338,
  [SMALL_STATE(20489)] = 640351,
  [SMALL_STATE(20490)] = 640364,
  [SMALL_STATE(20491)] = 640377,
  [SMALL_STATE(20492)] = 640388,
  [SMALL_STATE(20493)] = 640399,
  [SMALL_STATE(20494)] = 640412,
  [SMALL_STATE(20495)] = 640425,
  [SMALL_STATE(20496)] = 640438,
  [SMALL_STATE(20497)] = 640449,
  [SMALL_STATE(20498)] = 640460,
  [SMALL_STATE(20499)] = 640471,
  [SMALL_STATE(20500)] = 640484,
  [SMALL_STATE(20501)] = 640497,
  [SMALL_STATE(20502)] = 640510,
  [SMALL_STATE(20503)] = 640521,
  [SMALL_STATE(20504)] = 640534,
  [SMALL_STATE(20505)] = 640545,
  [SMALL_STATE(20506)] = 640558,
  [SMALL_STATE(20507)] = 640569,
  [SMALL_STATE(20508)] = 640582,
  [SMALL_STATE(20509)] = 640595,
  [SMALL_STATE(20510)] = 640608,
  [SMALL_STATE(20511)] = 640619,
  [SMALL_STATE(20512)] = 640630,
  [SMALL_STATE(20513)] = 640643,
  [SMALL_STATE(20514)] = 640656,
  [SMALL_STATE(20515)] = 640667,
  [SMALL_STATE(20516)] = 640680,
  [SMALL_STATE(20517)] = 640691,
  [SMALL_STATE(20518)] = 640704,
  [SMALL_STATE(20519)] = 640717,
  [SMALL_STATE(20520)] = 640730,
  [SMALL_STATE(20521)] = 640741,
  [SMALL_STATE(20522)] = 640754,
  [SMALL_STATE(20523)] = 640767,
  [SMALL_STATE(20524)] = 640780,
  [SMALL_STATE(20525)] = 640791,
  [SMALL_STATE(20526)] = 640802,
  [SMALL_STATE(20527)] = 640815,
  [SMALL_STATE(20528)] = 640826,
  [SMALL_STATE(20529)] = 640837,
  [SMALL_STATE(20530)] = 640848,
  [SMALL_STATE(20531)] = 640859,
  [SMALL_STATE(20532)] = 640870,
  [SMALL_STATE(20533)] = 640883,
  [SMALL_STATE(20534)] = 640894,
  [SMALL_STATE(20535)] = 640905,
  [SMALL_STATE(20536)] = 640918,
  [SMALL_STATE(20537)] = 640929,
  [SMALL_STATE(20538)] = 640942,
  [SMALL_STATE(20539)] = 640953,
  [SMALL_STATE(20540)] = 640966,
  [SMALL_STATE(20541)] = 640977,
  [SMALL_STATE(20542)] = 640990,
  [SMALL_STATE(20543)] = 641001,
  [SMALL_STATE(20544)] = 641012,
  [SMALL_STATE(20545)] = 641023,
  [SMALL_STATE(20546)] = 641036,
  [SMALL_STATE(20547)] = 641049,
  [SMALL_STATE(20548)] = 641060,
  [SMALL_STATE(20549)] = 641073,
  [SMALL_STATE(20550)] = 641086,
  [SMALL_STATE(20551)] = 641099,
  [SMALL_STATE(20552)] = 641112,
  [SMALL_STATE(20553)] = 641123,
  [SMALL_STATE(20554)] = 641134,
  [SMALL_STATE(20555)] = 641145,
  [SMALL_STATE(20556)] = 641156,
  [SMALL_STATE(20557)] = 641167,
  [SMALL_STATE(20558)] = 641180,
  [SMALL_STATE(20559)] = 641191,
  [SMALL_STATE(20560)] = 641202,
  [SMALL_STATE(20561)] = 641215,
  [SMALL_STATE(20562)] = 641226,
  [SMALL_STATE(20563)] = 641239,
  [SMALL_STATE(20564)] = 641252,
  [SMALL_STATE(20565)] = 641265,
  [SMALL_STATE(20566)] = 641278,
  [SMALL_STATE(20567)] = 641289,
  [SMALL_STATE(20568)] = 641302,
  [SMALL_STATE(20569)] = 641313,
  [SMALL_STATE(20570)] = 641326,
  [SMALL_STATE(20571)] = 641337,
  [SMALL_STATE(20572)] = 641348,
  [SMALL_STATE(20573)] = 641361,
  [SMALL_STATE(20574)] = 641372,
  [SMALL_STATE(20575)] = 641385,
  [SMALL_STATE(20576)] = 641398,
  [SMALL_STATE(20577)] = 641409,
  [SMALL_STATE(20578)] = 641420,
  [SMALL_STATE(20579)] = 641433,
  [SMALL_STATE(20580)] = 641444,
  [SMALL_STATE(20581)] = 641455,
  [SMALL_STATE(20582)] = 641466,
  [SMALL_STATE(20583)] = 641479,
  [SMALL_STATE(20584)] = 641492,
  [SMALL_STATE(20585)] = 641505,
  [SMALL_STATE(20586)] = 641516,
  [SMALL_STATE(20587)] = 641529,
  [SMALL_STATE(20588)] = 641542,
  [SMALL_STATE(20589)] = 641555,
  [SMALL_STATE(20590)] = 641568,
  [SMALL_STATE(20591)] = 641581,
  [SMALL_STATE(20592)] = 641592,
  [SMALL_STATE(20593)] = 641603,
  [SMALL_STATE(20594)] = 641616,
  [SMALL_STATE(20595)] = 641627,
  [SMALL_STATE(20596)] = 641640,
  [SMALL_STATE(20597)] = 641653,
  [SMALL_STATE(20598)] = 641666,
  [SMALL_STATE(20599)] = 641677,
  [SMALL_STATE(20600)] = 641688,
  [SMALL_STATE(20601)] = 641701,
  [SMALL_STATE(20602)] = 641712,
  [SMALL_STATE(20603)] = 641723,
  [SMALL_STATE(20604)] = 641736,
  [SMALL_STATE(20605)] = 641747,
  [SMALL_STATE(20606)] = 641760,
  [SMALL_STATE(20607)] = 641773,
  [SMALL_STATE(20608)] = 641784,
  [SMALL_STATE(20609)] = 641795,
  [SMALL_STATE(20610)] = 641806,
  [SMALL_STATE(20611)] = 641819,
  [SMALL_STATE(20612)] = 641830,
  [SMALL_STATE(20613)] = 641843,
  [SMALL_STATE(20614)] = 641856,
  [SMALL_STATE(20615)] = 641867,
  [SMALL_STATE(20616)] = 641880,
  [SMALL_STATE(20617)] = 641891,
  [SMALL_STATE(20618)] = 641902,
  [SMALL_STATE(20619)] = 641913,
  [SMALL_STATE(20620)] = 641926,
  [SMALL_STATE(20621)] = 641939,
  [SMALL_STATE(20622)] = 641952,
  [SMALL_STATE(20623)] = 641963,
  [SMALL_STATE(20624)] = 641976,
  [SMALL_STATE(20625)] = 641989,
  [SMALL_STATE(20626)] = 642000,
  [SMALL_STATE(20627)] = 642011,
  [SMALL_STATE(20628)] = 642022,
  [SMALL_STATE(20629)] = 642035,
  [SMALL_STATE(20630)] = 642046,
  [SMALL_STATE(20631)] = 642059,
  [SMALL_STATE(20632)] = 642072,
  [SMALL_STATE(20633)] = 642085,
  [SMALL_STATE(20634)] = 642096,
  [SMALL_STATE(20635)] = 642109,
  [SMALL_STATE(20636)] = 642122,
  [SMALL_STATE(20637)] = 642133,
  [SMALL_STATE(20638)] = 642144,
  [SMALL_STATE(20639)] = 642155,
  [SMALL_STATE(20640)] = 642168,
  [SMALL_STATE(20641)] = 642181,
  [SMALL_STATE(20642)] = 642192,
  [SMALL_STATE(20643)] = 642205,
  [SMALL_STATE(20644)] = 642216,
  [SMALL_STATE(20645)] = 642227,
  [SMALL_STATE(20646)] = 642240,
  [SMALL_STATE(20647)] = 642253,
  [SMALL_STATE(20648)] = 642266,
  [SMALL_STATE(20649)] = 642279,
  [SMALL_STATE(20650)] = 642292,
  [SMALL_STATE(20651)] = 642303,
  [SMALL_STATE(20652)] = 642316,
  [SMALL_STATE(20653)] = 642329,
  [SMALL_STATE(20654)] = 642342,
  [SMALL_STATE(20655)] = 642353,
  [SMALL_STATE(20656)] = 642366,
  [SMALL_STATE(20657)] = 642377,
  [SMALL_STATE(20658)] = 642388,
  [SMALL_STATE(20659)] = 642399,
  [SMALL_STATE(20660)] = 642412,
  [SMALL_STATE(20661)] = 642423,
  [SMALL_STATE(20662)] = 642434,
  [SMALL_STATE(20663)] = 642447,
  [SMALL_STATE(20664)] = 642458,
  [SMALL_STATE(20665)] = 642469,
  [SMALL_STATE(20666)] = 642480,
  [SMALL_STATE(20667)] = 642493,
  [SMALL_STATE(20668)] = 642504,
  [SMALL_STATE(20669)] = 642515,
  [SMALL_STATE(20670)] = 642526,
  [SMALL_STATE(20671)] = 642537,
  [SMALL_STATE(20672)] = 642548,
  [SMALL_STATE(20673)] = 642559,
  [SMALL_STATE(20674)] = 642570,
  [SMALL_STATE(20675)] = 642583,
  [SMALL_STATE(20676)] = 642594,
  [SMALL_STATE(20677)] = 642605,
  [SMALL_STATE(20678)] = 642616,
  [SMALL_STATE(20679)] = 642627,
  [SMALL_STATE(20680)] = 642640,
  [SMALL_STATE(20681)] = 642651,
  [SMALL_STATE(20682)] = 642664,
  [SMALL_STATE(20683)] = 642675,
  [SMALL_STATE(20684)] = 642686,
  [SMALL_STATE(20685)] = 642699,
  [SMALL_STATE(20686)] = 642710,
  [SMALL_STATE(20687)] = 642723,
  [SMALL_STATE(20688)] = 642736,
  [SMALL_STATE(20689)] = 642749,
  [SMALL_STATE(20690)] = 642760,
  [SMALL_STATE(20691)] = 642773,
  [SMALL_STATE(20692)] = 642784,
  [SMALL_STATE(20693)] = 642795,
  [SMALL_STATE(20694)] = 642808,
  [SMALL_STATE(20695)] = 642819,
  [SMALL_STATE(20696)] = 642830,
  [SMALL_STATE(20697)] = 642841,
  [SMALL_STATE(20698)] = 642852,
  [SMALL_STATE(20699)] = 642865,
  [SMALL_STATE(20700)] = 642878,
  [SMALL_STATE(20701)] = 642891,
  [SMALL_STATE(20702)] = 642902,
  [SMALL_STATE(20703)] = 642913,
  [SMALL_STATE(20704)] = 642924,
  [SMALL_STATE(20705)] = 642935,
  [SMALL_STATE(20706)] = 642946,
  [SMALL_STATE(20707)] = 642957,
  [SMALL_STATE(20708)] = 642970,
  [SMALL_STATE(20709)] = 642983,
  [SMALL_STATE(20710)] = 642996,
  [SMALL_STATE(20711)] = 643007,
  [SMALL_STATE(20712)] = 643018,
  [SMALL_STATE(20713)] = 643029,
  [SMALL_STATE(20714)] = 643042,
  [SMALL_STATE(20715)] = 643055,
  [SMALL_STATE(20716)] = 643066,
  [SMALL_STATE(20717)] = 643077,
  [SMALL_STATE(20718)] = 643088,
  [SMALL_STATE(20719)] = 643101,
  [SMALL_STATE(20720)] = 643114,
  [SMALL_STATE(20721)] = 643125,
  [SMALL_STATE(20722)] = 643138,
  [SMALL_STATE(20723)] = 643151,
  [SMALL_STATE(20724)] = 643164,
  [SMALL_STATE(20725)] = 643175,
  [SMALL_STATE(20726)] = 643188,
  [SMALL_STATE(20727)] = 643199,
  [SMALL_STATE(20728)] = 643210,
  [SMALL_STATE(20729)] = 643221,
  [SMALL_STATE(20730)] = 643232,
  [SMALL_STATE(20731)] = 643243,
  [SMALL_STATE(20732)] = 643256,
  [SMALL_STATE(20733)] = 643269,
  [SMALL_STATE(20734)] = 643280,
  [SMALL_STATE(20735)] = 643291,
  [SMALL_STATE(20736)] = 643304,
  [SMALL_STATE(20737)] = 643317,
  [SMALL_STATE(20738)] = 643328,
  [SMALL_STATE(20739)] = 643339,
  [SMALL_STATE(20740)] = 643350,
  [SMALL_STATE(20741)] = 643361,
  [SMALL_STATE(20742)] = 643372,
  [SMALL_STATE(20743)] = 643383,
  [SMALL_STATE(20744)] = 643396,
  [SMALL_STATE(20745)] = 643407,
  [SMALL_STATE(20746)] = 643418,
  [SMALL_STATE(20747)] = 643431,
  [SMALL_STATE(20748)] = 643444,
  [SMALL_STATE(20749)] = 643455,
  [SMALL_STATE(20750)] = 643466,
  [SMALL_STATE(20751)] = 643477,
  [SMALL_STATE(20752)] = 643488,
  [SMALL_STATE(20753)] = 643501,
  [SMALL_STATE(20754)] = 643512,
  [SMALL_STATE(20755)] = 643523,
  [SMALL_STATE(20756)] = 643534,
  [SMALL_STATE(20757)] = 643545,
  [SMALL_STATE(20758)] = 643558,
  [SMALL_STATE(20759)] = 643571,
  [SMALL_STATE(20760)] = 643582,
  [SMALL_STATE(20761)] = 643593,
  [SMALL_STATE(20762)] = 643606,
  [SMALL_STATE(20763)] = 643617,
  [SMALL_STATE(20764)] = 643628,
  [SMALL_STATE(20765)] = 643641,
  [SMALL_STATE(20766)] = 643654,
  [SMALL_STATE(20767)] = 643665,
  [SMALL_STATE(20768)] = 643676,
  [SMALL_STATE(20769)] = 643687,
  [SMALL_STATE(20770)] = 643698,
  [SMALL_STATE(20771)] = 643709,
  [SMALL_STATE(20772)] = 643722,
  [SMALL_STATE(20773)] = 643735,
  [SMALL_STATE(20774)] = 643746,
  [SMALL_STATE(20775)] = 643759,
  [SMALL_STATE(20776)] = 643770,
  [SMALL_STATE(20777)] = 643781,
  [SMALL_STATE(20778)] = 643792,
  [SMALL_STATE(20779)] = 643805,
  [SMALL_STATE(20780)] = 643818,
  [SMALL_STATE(20781)] = 643829,
  [SMALL_STATE(20782)] = 643840,
  [SMALL_STATE(20783)] = 643851,
  [SMALL_STATE(20784)] = 643862,
  [SMALL_STATE(20785)] = 643873,
  [SMALL_STATE(20786)] = 643884,
  [SMALL_STATE(20787)] = 643895,
  [SMALL_STATE(20788)] = 643908,
  [SMALL_STATE(20789)] = 643921,
  [SMALL_STATE(20790)] = 643932,
  [SMALL_STATE(20791)] = 643943,
  [SMALL_STATE(20792)] = 643956,
  [SMALL_STATE(20793)] = 643969,
  [SMALL_STATE(20794)] = 643982,
  [SMALL_STATE(20795)] = 643993,
  [SMALL_STATE(20796)] = 644004,
  [SMALL_STATE(20797)] = 644017,
  [SMALL_STATE(20798)] = 644030,
  [SMALL_STATE(20799)] = 644041,
  [SMALL_STATE(20800)] = 644054,
  [SMALL_STATE(20801)] = 644065,
  [SMALL_STATE(20802)] = 644078,
  [SMALL_STATE(20803)] = 644089,
  [SMALL_STATE(20804)] = 644100,
  [SMALL_STATE(20805)] = 644111,
  [SMALL_STATE(20806)] = 644122,
  [SMALL_STATE(20807)] = 644135,
  [SMALL_STATE(20808)] = 644148,
  [SMALL_STATE(20809)] = 644159,
  [SMALL_STATE(20810)] = 644170,
  [SMALL_STATE(20811)] = 644183,
  [SMALL_STATE(20812)] = 644196,
  [SMALL_STATE(20813)] = 644207,
  [SMALL_STATE(20814)] = 644220,
  [SMALL_STATE(20815)] = 644233,
  [SMALL_STATE(20816)] = 644244,
  [SMALL_STATE(20817)] = 644255,
  [SMALL_STATE(20818)] = 644266,
  [SMALL_STATE(20819)] = 644277,
  [SMALL_STATE(20820)] = 644288,
  [SMALL_STATE(20821)] = 644301,
  [SMALL_STATE(20822)] = 644314,
  [SMALL_STATE(20823)] = 644325,
  [SMALL_STATE(20824)] = 644336,
  [SMALL_STATE(20825)] = 644347,
  [SMALL_STATE(20826)] = 644358,
  [SMALL_STATE(20827)] = 644369,
  [SMALL_STATE(20828)] = 644382,
  [SMALL_STATE(20829)] = 644393,
  [SMALL_STATE(20830)] = 644404,
  [SMALL_STATE(20831)] = 644417,
  [SMALL_STATE(20832)] = 644428,
  [SMALL_STATE(20833)] = 644439,
  [SMALL_STATE(20834)] = 644452,
  [SMALL_STATE(20835)] = 644465,
  [SMALL_STATE(20836)] = 644476,
  [SMALL_STATE(20837)] = 644489,
  [SMALL_STATE(20838)] = 644500,
  [SMALL_STATE(20839)] = 644511,
  [SMALL_STATE(20840)] = 644522,
  [SMALL_STATE(20841)] = 644533,
  [SMALL_STATE(20842)] = 644544,
  [SMALL_STATE(20843)] = 644555,
  [SMALL_STATE(20844)] = 644568,
  [SMALL_STATE(20845)] = 644579,
  [SMALL_STATE(20846)] = 644592,
  [SMALL_STATE(20847)] = 644603,
  [SMALL_STATE(20848)] = 644616,
  [SMALL_STATE(20849)] = 644627,
  [SMALL_STATE(20850)] = 644640,
  [SMALL_STATE(20851)] = 644651,
  [SMALL_STATE(20852)] = 644662,
  [SMALL_STATE(20853)] = 644673,
  [SMALL_STATE(20854)] = 644684,
  [SMALL_STATE(20855)] = 644695,
  [SMALL_STATE(20856)] = 644708,
  [SMALL_STATE(20857)] = 644719,
  [SMALL_STATE(20858)] = 644732,
  [SMALL_STATE(20859)] = 644743,
  [SMALL_STATE(20860)] = 644754,
  [SMALL_STATE(20861)] = 644765,
  [SMALL_STATE(20862)] = 644778,
  [SMALL_STATE(20863)] = 644789,
  [SMALL_STATE(20864)] = 644800,
  [SMALL_STATE(20865)] = 644813,
  [SMALL_STATE(20866)] = 644824,
  [SMALL_STATE(20867)] = 644837,
  [SMALL_STATE(20868)] = 644850,
  [SMALL_STATE(20869)] = 644863,
  [SMALL_STATE(20870)] = 644876,
  [SMALL_STATE(20871)] = 644887,
  [SMALL_STATE(20872)] = 644898,
  [SMALL_STATE(20873)] = 644909,
  [SMALL_STATE(20874)] = 644922,
  [SMALL_STATE(20875)] = 644933,
  [SMALL_STATE(20876)] = 644944,
  [SMALL_STATE(20877)] = 644957,
  [SMALL_STATE(20878)] = 644968,
  [SMALL_STATE(20879)] = 644979,
  [SMALL_STATE(20880)] = 644990,
  [SMALL_STATE(20881)] = 645001,
  [SMALL_STATE(20882)] = 645012,
  [SMALL_STATE(20883)] = 645025,
  [SMALL_STATE(20884)] = 645036,
  [SMALL_STATE(20885)] = 645049,
  [SMALL_STATE(20886)] = 645060,
  [SMALL_STATE(20887)] = 645071,
  [SMALL_STATE(20888)] = 645084,
  [SMALL_STATE(20889)] = 645095,
  [SMALL_STATE(20890)] = 645108,
  [SMALL_STATE(20891)] = 645119,
  [SMALL_STATE(20892)] = 645130,
  [SMALL_STATE(20893)] = 645141,
  [SMALL_STATE(20894)] = 645154,
  [SMALL_STATE(20895)] = 645165,
  [SMALL_STATE(20896)] = 645176,
  [SMALL_STATE(20897)] = 645189,
  [SMALL_STATE(20898)] = 645202,
  [SMALL_STATE(20899)] = 645215,
  [SMALL_STATE(20900)] = 645226,
  [SMALL_STATE(20901)] = 645237,
  [SMALL_STATE(20902)] = 645248,
  [SMALL_STATE(20903)] = 645259,
  [SMALL_STATE(20904)] = 645270,
  [SMALL_STATE(20905)] = 645283,
  [SMALL_STATE(20906)] = 645294,
  [SMALL_STATE(20907)] = 645305,
  [SMALL_STATE(20908)] = 645316,
  [SMALL_STATE(20909)] = 645327,
  [SMALL_STATE(20910)] = 645338,
  [SMALL_STATE(20911)] = 645349,
  [SMALL_STATE(20912)] = 645360,
  [SMALL_STATE(20913)] = 645371,
  [SMALL_STATE(20914)] = 645382,
  [SMALL_STATE(20915)] = 645393,
  [SMALL_STATE(20916)] = 645404,
  [SMALL_STATE(20917)] = 645415,
  [SMALL_STATE(20918)] = 645426,
  [SMALL_STATE(20919)] = 645437,
  [SMALL_STATE(20920)] = 645448,
  [SMALL_STATE(20921)] = 645461,
  [SMALL_STATE(20922)] = 645472,
  [SMALL_STATE(20923)] = 645483,
  [SMALL_STATE(20924)] = 645494,
  [SMALL_STATE(20925)] = 645505,
  [SMALL_STATE(20926)] = 645518,
  [SMALL_STATE(20927)] = 645529,
  [SMALL_STATE(20928)] = 645540,
  [SMALL_STATE(20929)] = 645551,
  [SMALL_STATE(20930)] = 645564,
  [SMALL_STATE(20931)] = 645575,
  [SMALL_STATE(20932)] = 645586,
  [SMALL_STATE(20933)] = 645599,
  [SMALL_STATE(20934)] = 645612,
  [SMALL_STATE(20935)] = 645623,
  [SMALL_STATE(20936)] = 645634,
  [SMALL_STATE(20937)] = 645645,
  [SMALL_STATE(20938)] = 645656,
  [SMALL_STATE(20939)] = 645667,
  [SMALL_STATE(20940)] = 645678,
  [SMALL_STATE(20941)] = 645689,
  [SMALL_STATE(20942)] = 645700,
  [SMALL_STATE(20943)] = 645711,
  [SMALL_STATE(20944)] = 645722,
  [SMALL_STATE(20945)] = 645733,
  [SMALL_STATE(20946)] = 645744,
  [SMALL_STATE(20947)] = 645755,
  [SMALL_STATE(20948)] = 645766,
  [SMALL_STATE(20949)] = 645777,
  [SMALL_STATE(20950)] = 645788,
  [SMALL_STATE(20951)] = 645799,
  [SMALL_STATE(20952)] = 645810,
  [SMALL_STATE(20953)] = 645821,
  [SMALL_STATE(20954)] = 645832,
  [SMALL_STATE(20955)] = 645843,
  [SMALL_STATE(20956)] = 645854,
  [SMALL_STATE(20957)] = 645865,
  [SMALL_STATE(20958)] = 645876,
  [SMALL_STATE(20959)] = 645887,
  [SMALL_STATE(20960)] = 645898,
  [SMALL_STATE(20961)] = 645909,
  [SMALL_STATE(20962)] = 645920,
  [SMALL_STATE(20963)] = 645931,
  [SMALL_STATE(20964)] = 645942,
  [SMALL_STATE(20965)] = 645955,
  [SMALL_STATE(20966)] = 645966,
  [SMALL_STATE(20967)] = 645977,
  [SMALL_STATE(20968)] = 645990,
  [SMALL_STATE(20969)] = 646001,
  [SMALL_STATE(20970)] = 646012,
  [SMALL_STATE(20971)] = 646023,
  [SMALL_STATE(20972)] = 646034,
  [SMALL_STATE(20973)] = 646045,
  [SMALL_STATE(20974)] = 646056,
  [SMALL_STATE(20975)] = 646069,
  [SMALL_STATE(20976)] = 646080,
  [SMALL_STATE(20977)] = 646091,
  [SMALL_STATE(20978)] = 646102,
  [SMALL_STATE(20979)] = 646113,
  [SMALL_STATE(20980)] = 646126,
  [SMALL_STATE(20981)] = 646137,
  [SMALL_STATE(20982)] = 646148,
  [SMALL_STATE(20983)] = 646159,
  [SMALL_STATE(20984)] = 646170,
  [SMALL_STATE(20985)] = 646181,
  [SMALL_STATE(20986)] = 646192,
  [SMALL_STATE(20987)] = 646203,
  [SMALL_STATE(20988)] = 646216,
  [SMALL_STATE(20989)] = 646227,
  [SMALL_STATE(20990)] = 646238,
  [SMALL_STATE(20991)] = 646249,
  [SMALL_STATE(20992)] = 646260,
  [SMALL_STATE(20993)] = 646271,
  [SMALL_STATE(20994)] = 646284,
  [SMALL_STATE(20995)] = 646295,
  [SMALL_STATE(20996)] = 646306,
  [SMALL_STATE(20997)] = 646317,
  [SMALL_STATE(20998)] = 646330,
  [SMALL_STATE(20999)] = 646341,
  [SMALL_STATE(21000)] = 646352,
  [SMALL_STATE(21001)] = 646363,
  [SMALL_STATE(21002)] = 646374,
  [SMALL_STATE(21003)] = 646385,
  [SMALL_STATE(21004)] = 646396,
  [SMALL_STATE(21005)] = 646407,
  [SMALL_STATE(21006)] = 646418,
  [SMALL_STATE(21007)] = 646429,
  [SMALL_STATE(21008)] = 646440,
  [SMALL_STATE(21009)] = 646453,
  [SMALL_STATE(21010)] = 646464,
  [SMALL_STATE(21011)] = 646475,
  [SMALL_STATE(21012)] = 646486,
  [SMALL_STATE(21013)] = 646497,
  [SMALL_STATE(21014)] = 646508,
  [SMALL_STATE(21015)] = 646519,
  [SMALL_STATE(21016)] = 646530,
  [SMALL_STATE(21017)] = 646543,
  [SMALL_STATE(21018)] = 646554,
  [SMALL_STATE(21019)] = 646565,
  [SMALL_STATE(21020)] = 646576,
  [SMALL_STATE(21021)] = 646589,
  [SMALL_STATE(21022)] = 646600,
  [SMALL_STATE(21023)] = 646611,
  [SMALL_STATE(21024)] = 646624,
  [SMALL_STATE(21025)] = 646635,
  [SMALL_STATE(21026)] = 646646,
  [SMALL_STATE(21027)] = 646657,
  [SMALL_STATE(21028)] = 646668,
  [SMALL_STATE(21029)] = 646679,
  [SMALL_STATE(21030)] = 646692,
  [SMALL_STATE(21031)] = 646705,
  [SMALL_STATE(21032)] = 646716,
  [SMALL_STATE(21033)] = 646729,
  [SMALL_STATE(21034)] = 646740,
  [SMALL_STATE(21035)] = 646751,
  [SMALL_STATE(21036)] = 646762,
  [SMALL_STATE(21037)] = 646773,
  [SMALL_STATE(21038)] = 646784,
  [SMALL_STATE(21039)] = 646795,
  [SMALL_STATE(21040)] = 646806,
  [SMALL_STATE(21041)] = 646817,
  [SMALL_STATE(21042)] = 646828,
  [SMALL_STATE(21043)] = 646839,
  [SMALL_STATE(21044)] = 646852,
  [SMALL_STATE(21045)] = 646863,
  [SMALL_STATE(21046)] = 646876,
  [SMALL_STATE(21047)] = 646887,
  [SMALL_STATE(21048)] = 646898,
  [SMALL_STATE(21049)] = 646909,
  [SMALL_STATE(21050)] = 646922,
  [SMALL_STATE(21051)] = 646933,
  [SMALL_STATE(21052)] = 646944,
  [SMALL_STATE(21053)] = 646955,
  [SMALL_STATE(21054)] = 646966,
  [SMALL_STATE(21055)] = 646977,
  [SMALL_STATE(21056)] = 646990,
  [SMALL_STATE(21057)] = 647001,
  [SMALL_STATE(21058)] = 647012,
  [SMALL_STATE(21059)] = 647023,
  [SMALL_STATE(21060)] = 647034,
  [SMALL_STATE(21061)] = 647047,
  [SMALL_STATE(21062)] = 647060,
  [SMALL_STATE(21063)] = 647073,
  [SMALL_STATE(21064)] = 647084,
  [SMALL_STATE(21065)] = 647095,
  [SMALL_STATE(21066)] = 647106,
  [SMALL_STATE(21067)] = 647117,
  [SMALL_STATE(21068)] = 647130,
  [SMALL_STATE(21069)] = 647141,
  [SMALL_STATE(21070)] = 647152,
  [SMALL_STATE(21071)] = 647163,
  [SMALL_STATE(21072)] = 647174,
  [SMALL_STATE(21073)] = 647185,
  [SMALL_STATE(21074)] = 647196,
  [SMALL_STATE(21075)] = 647207,
  [SMALL_STATE(21076)] = 647218,
  [SMALL_STATE(21077)] = 647229,
  [SMALL_STATE(21078)] = 647240,
  [SMALL_STATE(21079)] = 647251,
  [SMALL_STATE(21080)] = 647264,
  [SMALL_STATE(21081)] = 647275,
  [SMALL_STATE(21082)] = 647286,
  [SMALL_STATE(21083)] = 647297,
  [SMALL_STATE(21084)] = 647308,
  [SMALL_STATE(21085)] = 647319,
  [SMALL_STATE(21086)] = 647332,
  [SMALL_STATE(21087)] = 647343,
  [SMALL_STATE(21088)] = 647354,
  [SMALL_STATE(21089)] = 647365,
  [SMALL_STATE(21090)] = 647376,
  [SMALL_STATE(21091)] = 647389,
  [SMALL_STATE(21092)] = 647400,
  [SMALL_STATE(21093)] = 647413,
  [SMALL_STATE(21094)] = 647424,
  [SMALL_STATE(21095)] = 647435,
  [SMALL_STATE(21096)] = 647446,
  [SMALL_STATE(21097)] = 647459,
  [SMALL_STATE(21098)] = 647470,
  [SMALL_STATE(21099)] = 647481,
  [SMALL_STATE(21100)] = 647492,
  [SMALL_STATE(21101)] = 647503,
  [SMALL_STATE(21102)] = 647514,
  [SMALL_STATE(21103)] = 647525,
  [SMALL_STATE(21104)] = 647536,
  [SMALL_STATE(21105)] = 647547,
  [SMALL_STATE(21106)] = 647558,
  [SMALL_STATE(21107)] = 647569,
  [SMALL_STATE(21108)] = 647580,
  [SMALL_STATE(21109)] = 647591,
  [SMALL_STATE(21110)] = 647604,
  [SMALL_STATE(21111)] = 647615,
  [SMALL_STATE(21112)] = 647628,
  [SMALL_STATE(21113)] = 647639,
  [SMALL_STATE(21114)] = 647650,
  [SMALL_STATE(21115)] = 647661,
  [SMALL_STATE(21116)] = 647672,
  [SMALL_STATE(21117)] = 647683,
  [SMALL_STATE(21118)] = 647696,
  [SMALL_STATE(21119)] = 647709,
  [SMALL_STATE(21120)] = 647720,
  [SMALL_STATE(21121)] = 647731,
  [SMALL_STATE(21122)] = 647742,
  [SMALL_STATE(21123)] = 647753,
  [SMALL_STATE(21124)] = 647764,
  [SMALL_STATE(21125)] = 647775,
  [SMALL_STATE(21126)] = 647786,
  [SMALL_STATE(21127)] = 647797,
  [SMALL_STATE(21128)] = 647808,
  [SMALL_STATE(21129)] = 647821,
  [SMALL_STATE(21130)] = 647832,
  [SMALL_STATE(21131)] = 647843,
  [SMALL_STATE(21132)] = 647854,
  [SMALL_STATE(21133)] = 647867,
  [SMALL_STATE(21134)] = 647878,
  [SMALL_STATE(21135)] = 647889,
  [SMALL_STATE(21136)] = 647900,
  [SMALL_STATE(21137)] = 647911,
  [SMALL_STATE(21138)] = 647922,
  [SMALL_STATE(21139)] = 647933,
  [SMALL_STATE(21140)] = 647944,
  [SMALL_STATE(21141)] = 647955,
  [SMALL_STATE(21142)] = 647966,
  [SMALL_STATE(21143)] = 647977,
  [SMALL_STATE(21144)] = 647988,
  [SMALL_STATE(21145)] = 647999,
  [SMALL_STATE(21146)] = 648010,
  [SMALL_STATE(21147)] = 648021,
  [SMALL_STATE(21148)] = 648032,
  [SMALL_STATE(21149)] = 648045,
  [SMALL_STATE(21150)] = 648058,
  [SMALL_STATE(21151)] = 648071,
  [SMALL_STATE(21152)] = 648082,
  [SMALL_STATE(21153)] = 648093,
  [SMALL_STATE(21154)] = 648104,
  [SMALL_STATE(21155)] = 648115,
  [SMALL_STATE(21156)] = 648128,
  [SMALL_STATE(21157)] = 648139,
  [SMALL_STATE(21158)] = 648150,
  [SMALL_STATE(21159)] = 648161,
  [SMALL_STATE(21160)] = 648172,
  [SMALL_STATE(21161)] = 648183,
  [SMALL_STATE(21162)] = 648194,
  [SMALL_STATE(21163)] = 648205,
  [SMALL_STATE(21164)] = 648216,
  [SMALL_STATE(21165)] = 648227,
  [SMALL_STATE(21166)] = 648238,
  [SMALL_STATE(21167)] = 648249,
  [SMALL_STATE(21168)] = 648260,
  [SMALL_STATE(21169)] = 648271,
  [SMALL_STATE(21170)] = 648284,
  [SMALL_STATE(21171)] = 648295,
  [SMALL_STATE(21172)] = 648306,
  [SMALL_STATE(21173)] = 648319,
  [SMALL_STATE(21174)] = 648330,
  [SMALL_STATE(21175)] = 648343,
  [SMALL_STATE(21176)] = 648354,
  [SMALL_STATE(21177)] = 648367,
  [SMALL_STATE(21178)] = 648378,
  [SMALL_STATE(21179)] = 648389,
  [SMALL_STATE(21180)] = 648400,
  [SMALL_STATE(21181)] = 648411,
  [SMALL_STATE(21182)] = 648422,
  [SMALL_STATE(21183)] = 648433,
  [SMALL_STATE(21184)] = 648444,
  [SMALL_STATE(21185)] = 648455,
  [SMALL_STATE(21186)] = 648466,
  [SMALL_STATE(21187)] = 648477,
  [SMALL_STATE(21188)] = 648488,
  [SMALL_STATE(21189)] = 648499,
  [SMALL_STATE(21190)] = 648512,
  [SMALL_STATE(21191)] = 648523,
  [SMALL_STATE(21192)] = 648534,
  [SMALL_STATE(21193)] = 648545,
  [SMALL_STATE(21194)] = 648556,
  [SMALL_STATE(21195)] = 648567,
  [SMALL_STATE(21196)] = 648578,
  [SMALL_STATE(21197)] = 648589,
  [SMALL_STATE(21198)] = 648600,
  [SMALL_STATE(21199)] = 648611,
  [SMALL_STATE(21200)] = 648622,
  [SMALL_STATE(21201)] = 648633,
  [SMALL_STATE(21202)] = 648644,
  [SMALL_STATE(21203)] = 648655,
  [SMALL_STATE(21204)] = 648668,
  [SMALL_STATE(21205)] = 648679,
  [SMALL_STATE(21206)] = 648692,
  [SMALL_STATE(21207)] = 648703,
  [SMALL_STATE(21208)] = 648716,
  [SMALL_STATE(21209)] = 648727,
  [SMALL_STATE(21210)] = 648740,
  [SMALL_STATE(21211)] = 648751,
  [SMALL_STATE(21212)] = 648764,
  [SMALL_STATE(21213)] = 648775,
  [SMALL_STATE(21214)] = 648786,
  [SMALL_STATE(21215)] = 648797,
  [SMALL_STATE(21216)] = 648808,
  [SMALL_STATE(21217)] = 648821,
  [SMALL_STATE(21218)] = 648832,
  [SMALL_STATE(21219)] = 648845,
  [SMALL_STATE(21220)] = 648856,
  [SMALL_STATE(21221)] = 648867,
  [SMALL_STATE(21222)] = 648878,
  [SMALL_STATE(21223)] = 648889,
  [SMALL_STATE(21224)] = 648900,
  [SMALL_STATE(21225)] = 648911,
  [SMALL_STATE(21226)] = 648922,
  [SMALL_STATE(21227)] = 648933,
  [SMALL_STATE(21228)] = 648944,
  [SMALL_STATE(21229)] = 648955,
  [SMALL_STATE(21230)] = 648966,
  [SMALL_STATE(21231)] = 648977,
  [SMALL_STATE(21232)] = 648988,
  [SMALL_STATE(21233)] = 649001,
  [SMALL_STATE(21234)] = 649012,
  [SMALL_STATE(21235)] = 649023,
  [SMALL_STATE(21236)] = 649034,
  [SMALL_STATE(21237)] = 649047,
  [SMALL_STATE(21238)] = 649058,
  [SMALL_STATE(21239)] = 649069,
  [SMALL_STATE(21240)] = 649082,
  [SMALL_STATE(21241)] = 649093,
  [SMALL_STATE(21242)] = 649104,
  [SMALL_STATE(21243)] = 649115,
  [SMALL_STATE(21244)] = 649126,
  [SMALL_STATE(21245)] = 649137,
  [SMALL_STATE(21246)] = 649148,
  [SMALL_STATE(21247)] = 649159,
  [SMALL_STATE(21248)] = 649170,
  [SMALL_STATE(21249)] = 649181,
  [SMALL_STATE(21250)] = 649192,
  [SMALL_STATE(21251)] = 649205,
  [SMALL_STATE(21252)] = 649218,
  [SMALL_STATE(21253)] = 649229,
  [SMALL_STATE(21254)] = 649240,
  [SMALL_STATE(21255)] = 649253,
  [SMALL_STATE(21256)] = 649264,
  [SMALL_STATE(21257)] = 649275,
  [SMALL_STATE(21258)] = 649286,
  [SMALL_STATE(21259)] = 649297,
  [SMALL_STATE(21260)] = 649310,
  [SMALL_STATE(21261)] = 649321,
  [SMALL_STATE(21262)] = 649334,
  [SMALL_STATE(21263)] = 649345,
  [SMALL_STATE(21264)] = 649356,
  [SMALL_STATE(21265)] = 649369,
  [SMALL_STATE(21266)] = 649380,
  [SMALL_STATE(21267)] = 649391,
  [SMALL_STATE(21268)] = 649402,
  [SMALL_STATE(21269)] = 649413,
  [SMALL_STATE(21270)] = 649426,
  [SMALL_STATE(21271)] = 649437,
  [SMALL_STATE(21272)] = 649448,
  [SMALL_STATE(21273)] = 649459,
  [SMALL_STATE(21274)] = 649472,
  [SMALL_STATE(21275)] = 649483,
  [SMALL_STATE(21276)] = 649494,
  [SMALL_STATE(21277)] = 649505,
  [SMALL_STATE(21278)] = 649516,
  [SMALL_STATE(21279)] = 649529,
  [SMALL_STATE(21280)] = 649540,
  [SMALL_STATE(21281)] = 649551,
  [SMALL_STATE(21282)] = 649562,
  [SMALL_STATE(21283)] = 649573,
  [SMALL_STATE(21284)] = 649584,
  [SMALL_STATE(21285)] = 649595,
  [SMALL_STATE(21286)] = 649606,
  [SMALL_STATE(21287)] = 649617,
  [SMALL_STATE(21288)] = 649630,
  [SMALL_STATE(21289)] = 649641,
  [SMALL_STATE(21290)] = 649652,
  [SMALL_STATE(21291)] = 649665,
  [SMALL_STATE(21292)] = 649676,
  [SMALL_STATE(21293)] = 649687,
  [SMALL_STATE(21294)] = 649698,
  [SMALL_STATE(21295)] = 649709,
  [SMALL_STATE(21296)] = 649719,
  [SMALL_STATE(21297)] = 649729,
  [SMALL_STATE(21298)] = 649739,
  [SMALL_STATE(21299)] = 649749,
  [SMALL_STATE(21300)] = 649759,
  [SMALL_STATE(21301)] = 649769,
  [SMALL_STATE(21302)] = 649779,
  [SMALL_STATE(21303)] = 649789,
  [SMALL_STATE(21304)] = 649799,
  [SMALL_STATE(21305)] = 649809,
  [SMALL_STATE(21306)] = 649819,
  [SMALL_STATE(21307)] = 649829,
  [SMALL_STATE(21308)] = 649839,
  [SMALL_STATE(21309)] = 649849,
  [SMALL_STATE(21310)] = 649859,
  [SMALL_STATE(21311)] = 649869,
  [SMALL_STATE(21312)] = 649879,
  [SMALL_STATE(21313)] = 649889,
  [SMALL_STATE(21314)] = 649899,
  [SMALL_STATE(21315)] = 649909,
  [SMALL_STATE(21316)] = 649919,
  [SMALL_STATE(21317)] = 649929,
  [SMALL_STATE(21318)] = 649939,
  [SMALL_STATE(21319)] = 649949,
  [SMALL_STATE(21320)] = 649959,
  [SMALL_STATE(21321)] = 649969,
  [SMALL_STATE(21322)] = 649979,
  [SMALL_STATE(21323)] = 649989,
  [SMALL_STATE(21324)] = 649999,
  [SMALL_STATE(21325)] = 650009,
  [SMALL_STATE(21326)] = 650019,
  [SMALL_STATE(21327)] = 650029,
  [SMALL_STATE(21328)] = 650039,
  [SMALL_STATE(21329)] = 650049,
  [SMALL_STATE(21330)] = 650059,
  [SMALL_STATE(21331)] = 650069,
  [SMALL_STATE(21332)] = 650079,
  [SMALL_STATE(21333)] = 650089,
  [SMALL_STATE(21334)] = 650099,
  [SMALL_STATE(21335)] = 650109,
  [SMALL_STATE(21336)] = 650119,
  [SMALL_STATE(21337)] = 650129,
  [SMALL_STATE(21338)] = 650139,
  [SMALL_STATE(21339)] = 650149,
  [SMALL_STATE(21340)] = 650159,
  [SMALL_STATE(21341)] = 650169,
  [SMALL_STATE(21342)] = 650179,
  [SMALL_STATE(21343)] = 650189,
  [SMALL_STATE(21344)] = 650199,
  [SMALL_STATE(21345)] = 650209,
  [SMALL_STATE(21346)] = 650219,
  [SMALL_STATE(21347)] = 650229,
  [SMALL_STATE(21348)] = 650239,
  [SMALL_STATE(21349)] = 650249,
  [SMALL_STATE(21350)] = 650259,
  [SMALL_STATE(21351)] = 650269,
  [SMALL_STATE(21352)] = 650279,
  [SMALL_STATE(21353)] = 650289,
  [SMALL_STATE(21354)] = 650299,
  [SMALL_STATE(21355)] = 650309,
  [SMALL_STATE(21356)] = 650319,
  [SMALL_STATE(21357)] = 650329,
  [SMALL_STATE(21358)] = 650339,
  [SMALL_STATE(21359)] = 650349,
  [SMALL_STATE(21360)] = 650359,
  [SMALL_STATE(21361)] = 650369,
  [SMALL_STATE(21362)] = 650379,
  [SMALL_STATE(21363)] = 650389,
  [SMALL_STATE(21364)] = 650399,
  [SMALL_STATE(21365)] = 650409,
  [SMALL_STATE(21366)] = 650419,
  [SMALL_STATE(21367)] = 650429,
  [SMALL_STATE(21368)] = 650439,
  [SMALL_STATE(21369)] = 650449,
  [SMALL_STATE(21370)] = 650459,
  [SMALL_STATE(21371)] = 650469,
  [SMALL_STATE(21372)] = 650479,
  [SMALL_STATE(21373)] = 650489,
  [SMALL_STATE(21374)] = 650499,
  [SMALL_STATE(21375)] = 650509,
  [SMALL_STATE(21376)] = 650519,
  [SMALL_STATE(21377)] = 650529,
  [SMALL_STATE(21378)] = 650539,
  [SMALL_STATE(21379)] = 650549,
  [SMALL_STATE(21380)] = 650559,
  [SMALL_STATE(21381)] = 650569,
  [SMALL_STATE(21382)] = 650579,
  [SMALL_STATE(21383)] = 650589,
  [SMALL_STATE(21384)] = 650599,
  [SMALL_STATE(21385)] = 650609,
  [SMALL_STATE(21386)] = 650619,
  [SMALL_STATE(21387)] = 650629,
  [SMALL_STATE(21388)] = 650639,
  [SMALL_STATE(21389)] = 650649,
  [SMALL_STATE(21390)] = 650659,
  [SMALL_STATE(21391)] = 650669,
  [SMALL_STATE(21392)] = 650679,
  [SMALL_STATE(21393)] = 650689,
  [SMALL_STATE(21394)] = 650699,
  [SMALL_STATE(21395)] = 650709,
  [SMALL_STATE(21396)] = 650719,
  [SMALL_STATE(21397)] = 650729,
  [SMALL_STATE(21398)] = 650739,
  [SMALL_STATE(21399)] = 650749,
  [SMALL_STATE(21400)] = 650759,
  [SMALL_STATE(21401)] = 650769,
  [SMALL_STATE(21402)] = 650779,
  [SMALL_STATE(21403)] = 650789,
  [SMALL_STATE(21404)] = 650799,
  [SMALL_STATE(21405)] = 650809,
  [SMALL_STATE(21406)] = 650819,
  [SMALL_STATE(21407)] = 650829,
  [SMALL_STATE(21408)] = 650839,
  [SMALL_STATE(21409)] = 650849,
  [SMALL_STATE(21410)] = 650859,
  [SMALL_STATE(21411)] = 650869,
  [SMALL_STATE(21412)] = 650879,
  [SMALL_STATE(21413)] = 650889,
  [SMALL_STATE(21414)] = 650899,
  [SMALL_STATE(21415)] = 650909,
  [SMALL_STATE(21416)] = 650919,
  [SMALL_STATE(21417)] = 650929,
  [SMALL_STATE(21418)] = 650939,
  [SMALL_STATE(21419)] = 650949,
  [SMALL_STATE(21420)] = 650959,
  [SMALL_STATE(21421)] = 650969,
  [SMALL_STATE(21422)] = 650979,
  [SMALL_STATE(21423)] = 650989,
  [SMALL_STATE(21424)] = 650999,
  [SMALL_STATE(21425)] = 651009,
  [SMALL_STATE(21426)] = 651019,
  [SMALL_STATE(21427)] = 651029,
  [SMALL_STATE(21428)] = 651039,
  [SMALL_STATE(21429)] = 651049,
  [SMALL_STATE(21430)] = 651059,
  [SMALL_STATE(21431)] = 651069,
  [SMALL_STATE(21432)] = 651079,
  [SMALL_STATE(21433)] = 651089,
  [SMALL_STATE(21434)] = 651099,
  [SMALL_STATE(21435)] = 651109,
  [SMALL_STATE(21436)] = 651119,
  [SMALL_STATE(21437)] = 651129,
  [SMALL_STATE(21438)] = 651139,
  [SMALL_STATE(21439)] = 651149,
  [SMALL_STATE(21440)] = 651159,
  [SMALL_STATE(21441)] = 651169,
  [SMALL_STATE(21442)] = 651179,
  [SMALL_STATE(21443)] = 651189,
  [SMALL_STATE(21444)] = 651199,
  [SMALL_STATE(21445)] = 651209,
  [SMALL_STATE(21446)] = 651219,
  [SMALL_STATE(21447)] = 651229,
  [SMALL_STATE(21448)] = 651239,
  [SMALL_STATE(21449)] = 651249,
  [SMALL_STATE(21450)] = 651259,
  [SMALL_STATE(21451)] = 651269,
  [SMALL_STATE(21452)] = 651279,
  [SMALL_STATE(21453)] = 651289,
  [SMALL_STATE(21454)] = 651299,
  [SMALL_STATE(21455)] = 651309,
  [SMALL_STATE(21456)] = 651319,
  [SMALL_STATE(21457)] = 651329,
  [SMALL_STATE(21458)] = 651339,
  [SMALL_STATE(21459)] = 651349,
  [SMALL_STATE(21460)] = 651359,
  [SMALL_STATE(21461)] = 651369,
  [SMALL_STATE(21462)] = 651379,
  [SMALL_STATE(21463)] = 651389,
  [SMALL_STATE(21464)] = 651399,
  [SMALL_STATE(21465)] = 651409,
  [SMALL_STATE(21466)] = 651419,
  [SMALL_STATE(21467)] = 651429,
  [SMALL_STATE(21468)] = 651439,
  [SMALL_STATE(21469)] = 651449,
  [SMALL_STATE(21470)] = 651459,
  [SMALL_STATE(21471)] = 651469,
  [SMALL_STATE(21472)] = 651479,
  [SMALL_STATE(21473)] = 651489,
  [SMALL_STATE(21474)] = 651499,
  [SMALL_STATE(21475)] = 651509,
  [SMALL_STATE(21476)] = 651519,
  [SMALL_STATE(21477)] = 651529,
  [SMALL_STATE(21478)] = 651539,
  [SMALL_STATE(21479)] = 651549,
  [SMALL_STATE(21480)] = 651559,
  [SMALL_STATE(21481)] = 651569,
  [SMALL_STATE(21482)] = 651579,
  [SMALL_STATE(21483)] = 651589,
  [SMALL_STATE(21484)] = 651599,
  [SMALL_STATE(21485)] = 651609,
  [SMALL_STATE(21486)] = 651619,
  [SMALL_STATE(21487)] = 651629,
  [SMALL_STATE(21488)] = 651639,
  [SMALL_STATE(21489)] = 651649,
  [SMALL_STATE(21490)] = 651659,
  [SMALL_STATE(21491)] = 651669,
  [SMALL_STATE(21492)] = 651679,
  [SMALL_STATE(21493)] = 651689,
  [SMALL_STATE(21494)] = 651699,
  [SMALL_STATE(21495)] = 651709,
  [SMALL_STATE(21496)] = 651719,
  [SMALL_STATE(21497)] = 651729,
  [SMALL_STATE(21498)] = 651739,
  [SMALL_STATE(21499)] = 651749,
  [SMALL_STATE(21500)] = 651759,
  [SMALL_STATE(21501)] = 651769,
  [SMALL_STATE(21502)] = 651779,
  [SMALL_STATE(21503)] = 651789,
  [SMALL_STATE(21504)] = 651799,
  [SMALL_STATE(21505)] = 651809,
  [SMALL_STATE(21506)] = 651819,
  [SMALL_STATE(21507)] = 651829,
  [SMALL_STATE(21508)] = 651839,
  [SMALL_STATE(21509)] = 651849,
  [SMALL_STATE(21510)] = 651859,
  [SMALL_STATE(21511)] = 651869,
  [SMALL_STATE(21512)] = 651879,
  [SMALL_STATE(21513)] = 651889,
  [SMALL_STATE(21514)] = 651899,
  [SMALL_STATE(21515)] = 651909,
  [SMALL_STATE(21516)] = 651919,
  [SMALL_STATE(21517)] = 651929,
  [SMALL_STATE(21518)] = 651939,
  [SMALL_STATE(21519)] = 651949,
  [SMALL_STATE(21520)] = 651959,
  [SMALL_STATE(21521)] = 651969,
  [SMALL_STATE(21522)] = 651979,
  [SMALL_STATE(21523)] = 651989,
  [SMALL_STATE(21524)] = 651999,
  [SMALL_STATE(21525)] = 652009,
  [SMALL_STATE(21526)] = 652019,
  [SMALL_STATE(21527)] = 652029,
  [SMALL_STATE(21528)] = 652039,
  [SMALL_STATE(21529)] = 652049,
  [SMALL_STATE(21530)] = 652059,
  [SMALL_STATE(21531)] = 652069,
  [SMALL_STATE(21532)] = 652079,
  [SMALL_STATE(21533)] = 652089,
  [SMALL_STATE(21534)] = 652099,
  [SMALL_STATE(21535)] = 652109,
  [SMALL_STATE(21536)] = 652119,
  [SMALL_STATE(21537)] = 652129,
  [SMALL_STATE(21538)] = 652139,
  [SMALL_STATE(21539)] = 652149,
  [SMALL_STATE(21540)] = 652159,
  [SMALL_STATE(21541)] = 652169,
  [SMALL_STATE(21542)] = 652179,
  [SMALL_STATE(21543)] = 652189,
  [SMALL_STATE(21544)] = 652199,
  [SMALL_STATE(21545)] = 652209,
  [SMALL_STATE(21546)] = 652219,
  [SMALL_STATE(21547)] = 652229,
  [SMALL_STATE(21548)] = 652239,
  [SMALL_STATE(21549)] = 652249,
  [SMALL_STATE(21550)] = 652259,
  [SMALL_STATE(21551)] = 652269,
  [SMALL_STATE(21552)] = 652279,
  [SMALL_STATE(21553)] = 652289,
  [SMALL_STATE(21554)] = 652299,
  [SMALL_STATE(21555)] = 652309,
  [SMALL_STATE(21556)] = 652319,
  [SMALL_STATE(21557)] = 652329,
  [SMALL_STATE(21558)] = 652339,
  [SMALL_STATE(21559)] = 652349,
  [SMALL_STATE(21560)] = 652359,
  [SMALL_STATE(21561)] = 652369,
  [SMALL_STATE(21562)] = 652379,
  [SMALL_STATE(21563)] = 652389,
  [SMALL_STATE(21564)] = 652399,
  [SMALL_STATE(21565)] = 652409,
  [SMALL_STATE(21566)] = 652419,
  [SMALL_STATE(21567)] = 652429,
  [SMALL_STATE(21568)] = 652439,
  [SMALL_STATE(21569)] = 652449,
  [SMALL_STATE(21570)] = 652459,
  [SMALL_STATE(21571)] = 652469,
  [SMALL_STATE(21572)] = 652479,
  [SMALL_STATE(21573)] = 652489,
  [SMALL_STATE(21574)] = 652499,
  [SMALL_STATE(21575)] = 652509,
  [SMALL_STATE(21576)] = 652519,
  [SMALL_STATE(21577)] = 652529,
  [SMALL_STATE(21578)] = 652539,
  [SMALL_STATE(21579)] = 652549,
  [SMALL_STATE(21580)] = 652559,
  [SMALL_STATE(21581)] = 652569,
  [SMALL_STATE(21582)] = 652579,
  [SMALL_STATE(21583)] = 652589,
  [SMALL_STATE(21584)] = 652599,
  [SMALL_STATE(21585)] = 652609,
  [SMALL_STATE(21586)] = 652619,
  [SMALL_STATE(21587)] = 652629,
  [SMALL_STATE(21588)] = 652639,
  [SMALL_STATE(21589)] = 652649,
  [SMALL_STATE(21590)] = 652659,
  [SMALL_STATE(21591)] = 652669,
  [SMALL_STATE(21592)] = 652679,
  [SMALL_STATE(21593)] = 652689,
  [SMALL_STATE(21594)] = 652699,
  [SMALL_STATE(21595)] = 652709,
  [SMALL_STATE(21596)] = 652719,
  [SMALL_STATE(21597)] = 652729,
  [SMALL_STATE(21598)] = 652739,
  [SMALL_STATE(21599)] = 652749,
  [SMALL_STATE(21600)] = 652759,
  [SMALL_STATE(21601)] = 652769,
  [SMALL_STATE(21602)] = 652779,
  [SMALL_STATE(21603)] = 652789,
  [SMALL_STATE(21604)] = 652799,
  [SMALL_STATE(21605)] = 652809,
  [SMALL_STATE(21606)] = 652819,
  [SMALL_STATE(21607)] = 652829,
  [SMALL_STATE(21608)] = 652839,
  [SMALL_STATE(21609)] = 652849,
  [SMALL_STATE(21610)] = 652859,
  [SMALL_STATE(21611)] = 652869,
  [SMALL_STATE(21612)] = 652879,
  [SMALL_STATE(21613)] = 652889,
  [SMALL_STATE(21614)] = 652899,
  [SMALL_STATE(21615)] = 652909,
  [SMALL_STATE(21616)] = 652919,
  [SMALL_STATE(21617)] = 652929,
  [SMALL_STATE(21618)] = 652939,
  [SMALL_STATE(21619)] = 652949,
  [SMALL_STATE(21620)] = 652959,
  [SMALL_STATE(21621)] = 652969,
  [SMALL_STATE(21622)] = 652979,
  [SMALL_STATE(21623)] = 652989,
  [SMALL_STATE(21624)] = 652999,
  [SMALL_STATE(21625)] = 653009,
  [SMALL_STATE(21626)] = 653019,
  [SMALL_STATE(21627)] = 653029,
  [SMALL_STATE(21628)] = 653039,
  [SMALL_STATE(21629)] = 653049,
  [SMALL_STATE(21630)] = 653059,
  [SMALL_STATE(21631)] = 653069,
  [SMALL_STATE(21632)] = 653079,
  [SMALL_STATE(21633)] = 653089,
  [SMALL_STATE(21634)] = 653099,
  [SMALL_STATE(21635)] = 653109,
  [SMALL_STATE(21636)] = 653119,
  [SMALL_STATE(21637)] = 653129,
  [SMALL_STATE(21638)] = 653139,
  [SMALL_STATE(21639)] = 653149,
  [SMALL_STATE(21640)] = 653159,
  [SMALL_STATE(21641)] = 653169,
  [SMALL_STATE(21642)] = 653179,
  [SMALL_STATE(21643)] = 653189,
  [SMALL_STATE(21644)] = 653199,
  [SMALL_STATE(21645)] = 653209,
  [SMALL_STATE(21646)] = 653219,
  [SMALL_STATE(21647)] = 653229,
  [SMALL_STATE(21648)] = 653239,
  [SMALL_STATE(21649)] = 653249,
  [SMALL_STATE(21650)] = 653259,
  [SMALL_STATE(21651)] = 653269,
  [SMALL_STATE(21652)] = 653279,
  [SMALL_STATE(21653)] = 653289,
  [SMALL_STATE(21654)] = 653299,
  [SMALL_STATE(21655)] = 653309,
  [SMALL_STATE(21656)] = 653319,
  [SMALL_STATE(21657)] = 653329,
  [SMALL_STATE(21658)] = 653339,
  [SMALL_STATE(21659)] = 653349,
  [SMALL_STATE(21660)] = 653359,
  [SMALL_STATE(21661)] = 653369,
  [SMALL_STATE(21662)] = 653379,
  [SMALL_STATE(21663)] = 653389,
  [SMALL_STATE(21664)] = 653399,
  [SMALL_STATE(21665)] = 653409,
  [SMALL_STATE(21666)] = 653419,
  [SMALL_STATE(21667)] = 653429,
  [SMALL_STATE(21668)] = 653439,
  [SMALL_STATE(21669)] = 653449,
  [SMALL_STATE(21670)] = 653459,
  [SMALL_STATE(21671)] = 653469,
  [SMALL_STATE(21672)] = 653479,
  [SMALL_STATE(21673)] = 653489,
  [SMALL_STATE(21674)] = 653499,
  [SMALL_STATE(21675)] = 653509,
  [SMALL_STATE(21676)] = 653519,
  [SMALL_STATE(21677)] = 653529,
  [SMALL_STATE(21678)] = 653539,
  [SMALL_STATE(21679)] = 653549,
  [SMALL_STATE(21680)] = 653559,
  [SMALL_STATE(21681)] = 653569,
  [SMALL_STATE(21682)] = 653579,
  [SMALL_STATE(21683)] = 653589,
  [SMALL_STATE(21684)] = 653599,
  [SMALL_STATE(21685)] = 653609,
  [SMALL_STATE(21686)] = 653619,
  [SMALL_STATE(21687)] = 653629,
  [SMALL_STATE(21688)] = 653639,
  [SMALL_STATE(21689)] = 653649,
  [SMALL_STATE(21690)] = 653659,
  [SMALL_STATE(21691)] = 653669,
  [SMALL_STATE(21692)] = 653679,
  [SMALL_STATE(21693)] = 653689,
  [SMALL_STATE(21694)] = 653699,
  [SMALL_STATE(21695)] = 653709,
  [SMALL_STATE(21696)] = 653719,
  [SMALL_STATE(21697)] = 653729,
  [SMALL_STATE(21698)] = 653739,
  [SMALL_STATE(21699)] = 653749,
  [SMALL_STATE(21700)] = 653759,
  [SMALL_STATE(21701)] = 653769,
  [SMALL_STATE(21702)] = 653779,
  [SMALL_STATE(21703)] = 653789,
  [SMALL_STATE(21704)] = 653799,
  [SMALL_STATE(21705)] = 653809,
  [SMALL_STATE(21706)] = 653819,
  [SMALL_STATE(21707)] = 653829,
  [SMALL_STATE(21708)] = 653839,
  [SMALL_STATE(21709)] = 653849,
  [SMALL_STATE(21710)] = 653859,
  [SMALL_STATE(21711)] = 653869,
  [SMALL_STATE(21712)] = 653879,
  [SMALL_STATE(21713)] = 653889,
  [SMALL_STATE(21714)] = 653899,
  [SMALL_STATE(21715)] = 653909,
  [SMALL_STATE(21716)] = 653919,
  [SMALL_STATE(21717)] = 653929,
  [SMALL_STATE(21718)] = 653939,
  [SMALL_STATE(21719)] = 653949,
  [SMALL_STATE(21720)] = 653959,
  [SMALL_STATE(21721)] = 653969,
  [SMALL_STATE(21722)] = 653979,
  [SMALL_STATE(21723)] = 653989,
  [SMALL_STATE(21724)] = 653999,
  [SMALL_STATE(21725)] = 654009,
  [SMALL_STATE(21726)] = 654019,
  [SMALL_STATE(21727)] = 654029,
  [SMALL_STATE(21728)] = 654039,
  [SMALL_STATE(21729)] = 654049,
  [SMALL_STATE(21730)] = 654059,
  [SMALL_STATE(21731)] = 654069,
  [SMALL_STATE(21732)] = 654079,
  [SMALL_STATE(21733)] = 654089,
  [SMALL_STATE(21734)] = 654099,
  [SMALL_STATE(21735)] = 654109,
  [SMALL_STATE(21736)] = 654119,
  [SMALL_STATE(21737)] = 654129,
  [SMALL_STATE(21738)] = 654139,
  [SMALL_STATE(21739)] = 654149,
  [SMALL_STATE(21740)] = 654159,
  [SMALL_STATE(21741)] = 654169,
  [SMALL_STATE(21742)] = 654179,
  [SMALL_STATE(21743)] = 654189,
  [SMALL_STATE(21744)] = 654199,
  [SMALL_STATE(21745)] = 654209,
  [SMALL_STATE(21746)] = 654219,
  [SMALL_STATE(21747)] = 654229,
  [SMALL_STATE(21748)] = 654239,
  [SMALL_STATE(21749)] = 654249,
  [SMALL_STATE(21750)] = 654259,
  [SMALL_STATE(21751)] = 654269,
  [SMALL_STATE(21752)] = 654279,
  [SMALL_STATE(21753)] = 654289,
  [SMALL_STATE(21754)] = 654299,
  [SMALL_STATE(21755)] = 654309,
  [SMALL_STATE(21756)] = 654319,
  [SMALL_STATE(21757)] = 654329,
  [SMALL_STATE(21758)] = 654339,
  [SMALL_STATE(21759)] = 654349,
  [SMALL_STATE(21760)] = 654359,
  [SMALL_STATE(21761)] = 654369,
  [SMALL_STATE(21762)] = 654379,
  [SMALL_STATE(21763)] = 654389,
  [SMALL_STATE(21764)] = 654399,
  [SMALL_STATE(21765)] = 654409,
  [SMALL_STATE(21766)] = 654419,
  [SMALL_STATE(21767)] = 654429,
  [SMALL_STATE(21768)] = 654439,
  [SMALL_STATE(21769)] = 654449,
  [SMALL_STATE(21770)] = 654459,
  [SMALL_STATE(21771)] = 654469,
  [SMALL_STATE(21772)] = 654479,
  [SMALL_STATE(21773)] = 654489,
  [SMALL_STATE(21774)] = 654499,
  [SMALL_STATE(21775)] = 654509,
  [SMALL_STATE(21776)] = 654519,
  [SMALL_STATE(21777)] = 654529,
  [SMALL_STATE(21778)] = 654539,
  [SMALL_STATE(21779)] = 654549,
  [SMALL_STATE(21780)] = 654559,
  [SMALL_STATE(21781)] = 654569,
  [SMALL_STATE(21782)] = 654579,
  [SMALL_STATE(21783)] = 654589,
  [SMALL_STATE(21784)] = 654599,
  [SMALL_STATE(21785)] = 654609,
  [SMALL_STATE(21786)] = 654619,
  [SMALL_STATE(21787)] = 654629,
  [SMALL_STATE(21788)] = 654639,
  [SMALL_STATE(21789)] = 654649,
  [SMALL_STATE(21790)] = 654659,
  [SMALL_STATE(21791)] = 654669,
  [SMALL_STATE(21792)] = 654679,
  [SMALL_STATE(21793)] = 654689,
  [SMALL_STATE(21794)] = 654699,
  [SMALL_STATE(21795)] = 654709,
  [SMALL_STATE(21796)] = 654719,
  [SMALL_STATE(21797)] = 654729,
  [SMALL_STATE(21798)] = 654739,
  [SMALL_STATE(21799)] = 654749,
  [SMALL_STATE(21800)] = 654759,
  [SMALL_STATE(21801)] = 654769,
  [SMALL_STATE(21802)] = 654779,
  [SMALL_STATE(21803)] = 654789,
  [SMALL_STATE(21804)] = 654799,
  [SMALL_STATE(21805)] = 654809,
  [SMALL_STATE(21806)] = 654819,
  [SMALL_STATE(21807)] = 654829,
  [SMALL_STATE(21808)] = 654839,
  [SMALL_STATE(21809)] = 654849,
  [SMALL_STATE(21810)] = 654859,
  [SMALL_STATE(21811)] = 654869,
  [SMALL_STATE(21812)] = 654879,
  [SMALL_STATE(21813)] = 654889,
  [SMALL_STATE(21814)] = 654899,
  [SMALL_STATE(21815)] = 654909,
  [SMALL_STATE(21816)] = 654919,
  [SMALL_STATE(21817)] = 654929,
  [SMALL_STATE(21818)] = 654939,
  [SMALL_STATE(21819)] = 654949,
  [SMALL_STATE(21820)] = 654959,
  [SMALL_STATE(21821)] = 654969,
  [SMALL_STATE(21822)] = 654979,
  [SMALL_STATE(21823)] = 654989,
  [SMALL_STATE(21824)] = 654999,
  [SMALL_STATE(21825)] = 655009,
  [SMALL_STATE(21826)] = 655019,
  [SMALL_STATE(21827)] = 655029,
  [SMALL_STATE(21828)] = 655039,
  [SMALL_STATE(21829)] = 655049,
  [SMALL_STATE(21830)] = 655059,
  [SMALL_STATE(21831)] = 655069,
  [SMALL_STATE(21832)] = 655079,
  [SMALL_STATE(21833)] = 655089,
  [SMALL_STATE(21834)] = 655099,
  [SMALL_STATE(21835)] = 655109,
  [SMALL_STATE(21836)] = 655119,
  [SMALL_STATE(21837)] = 655129,
  [SMALL_STATE(21838)] = 655139,
  [SMALL_STATE(21839)] = 655149,
  [SMALL_STATE(21840)] = 655159,
  [SMALL_STATE(21841)] = 655169,
  [SMALL_STATE(21842)] = 655179,
  [SMALL_STATE(21843)] = 655189,
  [SMALL_STATE(21844)] = 655199,
  [SMALL_STATE(21845)] = 655209,
  [SMALL_STATE(21846)] = 655219,
  [SMALL_STATE(21847)] = 655229,
  [SMALL_STATE(21848)] = 655239,
  [SMALL_STATE(21849)] = 655249,
  [SMALL_STATE(21850)] = 655259,
  [SMALL_STATE(21851)] = 655269,
  [SMALL_STATE(21852)] = 655279,
  [SMALL_STATE(21853)] = 655289,
  [SMALL_STATE(21854)] = 655299,
  [SMALL_STATE(21855)] = 655309,
  [SMALL_STATE(21856)] = 655319,
  [SMALL_STATE(21857)] = 655329,
  [SMALL_STATE(21858)] = 655339,
  [SMALL_STATE(21859)] = 655349,
  [SMALL_STATE(21860)] = 655359,
  [SMALL_STATE(21861)] = 655369,
  [SMALL_STATE(21862)] = 655379,
  [SMALL_STATE(21863)] = 655389,
  [SMALL_STATE(21864)] = 655399,
  [SMALL_STATE(21865)] = 655409,
  [SMALL_STATE(21866)] = 655419,
  [SMALL_STATE(21867)] = 655429,
  [SMALL_STATE(21868)] = 655439,
  [SMALL_STATE(21869)] = 655449,
  [SMALL_STATE(21870)] = 655459,
  [SMALL_STATE(21871)] = 655469,
  [SMALL_STATE(21872)] = 655479,
  [SMALL_STATE(21873)] = 655489,
  [SMALL_STATE(21874)] = 655499,
  [SMALL_STATE(21875)] = 655509,
  [SMALL_STATE(21876)] = 655519,
  [SMALL_STATE(21877)] = 655529,
  [SMALL_STATE(21878)] = 655539,
  [SMALL_STATE(21879)] = 655549,
  [SMALL_STATE(21880)] = 655559,
  [SMALL_STATE(21881)] = 655569,
  [SMALL_STATE(21882)] = 655579,
  [SMALL_STATE(21883)] = 655589,
  [SMALL_STATE(21884)] = 655599,
  [SMALL_STATE(21885)] = 655609,
  [SMALL_STATE(21886)] = 655619,
  [SMALL_STATE(21887)] = 655629,
  [SMALL_STATE(21888)] = 655639,
  [SMALL_STATE(21889)] = 655649,
  [SMALL_STATE(21890)] = 655659,
  [SMALL_STATE(21891)] = 655669,
  [SMALL_STATE(21892)] = 655679,
  [SMALL_STATE(21893)] = 655689,
  [SMALL_STATE(21894)] = 655699,
  [SMALL_STATE(21895)] = 655709,
  [SMALL_STATE(21896)] = 655719,
  [SMALL_STATE(21897)] = 655729,
  [SMALL_STATE(21898)] = 655739,
  [SMALL_STATE(21899)] = 655749,
  [SMALL_STATE(21900)] = 655759,
  [SMALL_STATE(21901)] = 655769,
  [SMALL_STATE(21902)] = 655779,
  [SMALL_STATE(21903)] = 655789,
  [SMALL_STATE(21904)] = 655799,
  [SMALL_STATE(21905)] = 655809,
  [SMALL_STATE(21906)] = 655819,
  [SMALL_STATE(21907)] = 655829,
  [SMALL_STATE(21908)] = 655839,
  [SMALL_STATE(21909)] = 655849,
  [SMALL_STATE(21910)] = 655859,
  [SMALL_STATE(21911)] = 655869,
  [SMALL_STATE(21912)] = 655879,
  [SMALL_STATE(21913)] = 655889,
  [SMALL_STATE(21914)] = 655899,
  [SMALL_STATE(21915)] = 655909,
  [SMALL_STATE(21916)] = 655919,
  [SMALL_STATE(21917)] = 655929,
  [SMALL_STATE(21918)] = 655939,
  [SMALL_STATE(21919)] = 655949,
  [SMALL_STATE(21920)] = 655959,
  [SMALL_STATE(21921)] = 655969,
  [SMALL_STATE(21922)] = 655979,
  [SMALL_STATE(21923)] = 655989,
  [SMALL_STATE(21924)] = 655999,
  [SMALL_STATE(21925)] = 656009,
  [SMALL_STATE(21926)] = 656019,
  [SMALL_STATE(21927)] = 656029,
  [SMALL_STATE(21928)] = 656039,
  [SMALL_STATE(21929)] = 656049,
  [SMALL_STATE(21930)] = 656059,
  [SMALL_STATE(21931)] = 656069,
  [SMALL_STATE(21932)] = 656079,
  [SMALL_STATE(21933)] = 656089,
  [SMALL_STATE(21934)] = 656099,
  [SMALL_STATE(21935)] = 656109,
  [SMALL_STATE(21936)] = 656119,
  [SMALL_STATE(21937)] = 656129,
  [SMALL_STATE(21938)] = 656139,
  [SMALL_STATE(21939)] = 656149,
  [SMALL_STATE(21940)] = 656159,
  [SMALL_STATE(21941)] = 656169,
  [SMALL_STATE(21942)] = 656179,
  [SMALL_STATE(21943)] = 656189,
  [SMALL_STATE(21944)] = 656199,
  [SMALL_STATE(21945)] = 656209,
  [SMALL_STATE(21946)] = 656219,
  [SMALL_STATE(21947)] = 656229,
  [SMALL_STATE(21948)] = 656239,
  [SMALL_STATE(21949)] = 656249,
  [SMALL_STATE(21950)] = 656259,
  [SMALL_STATE(21951)] = 656269,
  [SMALL_STATE(21952)] = 656279,
  [SMALL_STATE(21953)] = 656289,
  [SMALL_STATE(21954)] = 656299,
  [SMALL_STATE(21955)] = 656309,
  [SMALL_STATE(21956)] = 656319,
  [SMALL_STATE(21957)] = 656329,
  [SMALL_STATE(21958)] = 656339,
  [SMALL_STATE(21959)] = 656349,
  [SMALL_STATE(21960)] = 656359,
  [SMALL_STATE(21961)] = 656369,
  [SMALL_STATE(21962)] = 656379,
  [SMALL_STATE(21963)] = 656389,
  [SMALL_STATE(21964)] = 656399,
  [SMALL_STATE(21965)] = 656409,
  [SMALL_STATE(21966)] = 656419,
  [SMALL_STATE(21967)] = 656429,
  [SMALL_STATE(21968)] = 656439,
  [SMALL_STATE(21969)] = 656449,
  [SMALL_STATE(21970)] = 656459,
  [SMALL_STATE(21971)] = 656469,
  [SMALL_STATE(21972)] = 656479,
  [SMALL_STATE(21973)] = 656489,
  [SMALL_STATE(21974)] = 656499,
  [SMALL_STATE(21975)] = 656509,
  [SMALL_STATE(21976)] = 656519,
  [SMALL_STATE(21977)] = 656529,
  [SMALL_STATE(21978)] = 656539,
  [SMALL_STATE(21979)] = 656549,
  [SMALL_STATE(21980)] = 656559,
  [SMALL_STATE(21981)] = 656569,
  [SMALL_STATE(21982)] = 656579,
  [SMALL_STATE(21983)] = 656589,
  [SMALL_STATE(21984)] = 656599,
  [SMALL_STATE(21985)] = 656609,
  [SMALL_STATE(21986)] = 656619,
  [SMALL_STATE(21987)] = 656629,
  [SMALL_STATE(21988)] = 656639,
  [SMALL_STATE(21989)] = 656649,
  [SMALL_STATE(21990)] = 656659,
  [SMALL_STATE(21991)] = 656669,
  [SMALL_STATE(21992)] = 656679,
  [SMALL_STATE(21993)] = 656689,
  [SMALL_STATE(21994)] = 656699,
  [SMALL_STATE(21995)] = 656709,
  [SMALL_STATE(21996)] = 656719,
  [SMALL_STATE(21997)] = 656729,
  [SMALL_STATE(21998)] = 656739,
  [SMALL_STATE(21999)] = 656749,
  [SMALL_STATE(22000)] = 656759,
  [SMALL_STATE(22001)] = 656769,
  [SMALL_STATE(22002)] = 656779,
  [SMALL_STATE(22003)] = 656789,
  [SMALL_STATE(22004)] = 656799,
  [SMALL_STATE(22005)] = 656809,
  [SMALL_STATE(22006)] = 656819,
  [SMALL_STATE(22007)] = 656829,
  [SMALL_STATE(22008)] = 656839,
  [SMALL_STATE(22009)] = 656849,
  [SMALL_STATE(22010)] = 656859,
  [SMALL_STATE(22011)] = 656869,
  [SMALL_STATE(22012)] = 656879,
  [SMALL_STATE(22013)] = 656889,
  [SMALL_STATE(22014)] = 656899,
  [SMALL_STATE(22015)] = 656909,
  [SMALL_STATE(22016)] = 656919,
  [SMALL_STATE(22017)] = 656929,
  [SMALL_STATE(22018)] = 656939,
  [SMALL_STATE(22019)] = 656949,
  [SMALL_STATE(22020)] = 656959,
  [SMALL_STATE(22021)] = 656969,
  [SMALL_STATE(22022)] = 656979,
  [SMALL_STATE(22023)] = 656989,
  [SMALL_STATE(22024)] = 656999,
  [SMALL_STATE(22025)] = 657009,
  [SMALL_STATE(22026)] = 657019,
  [SMALL_STATE(22027)] = 657029,
  [SMALL_STATE(22028)] = 657039,
  [SMALL_STATE(22029)] = 657049,
  [SMALL_STATE(22030)] = 657059,
  [SMALL_STATE(22031)] = 657069,
  [SMALL_STATE(22032)] = 657079,
  [SMALL_STATE(22033)] = 657089,
  [SMALL_STATE(22034)] = 657099,
  [SMALL_STATE(22035)] = 657109,
  [SMALL_STATE(22036)] = 657119,
  [SMALL_STATE(22037)] = 657129,
  [SMALL_STATE(22038)] = 657139,
  [SMALL_STATE(22039)] = 657149,
  [SMALL_STATE(22040)] = 657159,
  [SMALL_STATE(22041)] = 657169,
  [SMALL_STATE(22042)] = 657179,
  [SMALL_STATE(22043)] = 657189,
  [SMALL_STATE(22044)] = 657199,
  [SMALL_STATE(22045)] = 657209,
  [SMALL_STATE(22046)] = 657219,
  [SMALL_STATE(22047)] = 657229,
  [SMALL_STATE(22048)] = 657239,
  [SMALL_STATE(22049)] = 657249,
  [SMALL_STATE(22050)] = 657259,
  [SMALL_STATE(22051)] = 657269,
  [SMALL_STATE(22052)] = 657279,
  [SMALL_STATE(22053)] = 657289,
  [SMALL_STATE(22054)] = 657299,
  [SMALL_STATE(22055)] = 657309,
  [SMALL_STATE(22056)] = 657319,
  [SMALL_STATE(22057)] = 657329,
  [SMALL_STATE(22058)] = 657339,
  [SMALL_STATE(22059)] = 657349,
  [SMALL_STATE(22060)] = 657359,
  [SMALL_STATE(22061)] = 657369,
  [SMALL_STATE(22062)] = 657379,
  [SMALL_STATE(22063)] = 657389,
  [SMALL_STATE(22064)] = 657399,
  [SMALL_STATE(22065)] = 657409,
  [SMALL_STATE(22066)] = 657419,
  [SMALL_STATE(22067)] = 657429,
  [SMALL_STATE(22068)] = 657439,
  [SMALL_STATE(22069)] = 657449,
  [SMALL_STATE(22070)] = 657459,
  [SMALL_STATE(22071)] = 657469,
  [SMALL_STATE(22072)] = 657479,
  [SMALL_STATE(22073)] = 657489,
  [SMALL_STATE(22074)] = 657499,
  [SMALL_STATE(22075)] = 657509,
  [SMALL_STATE(22076)] = 657519,
  [SMALL_STATE(22077)] = 657529,
  [SMALL_STATE(22078)] = 657539,
  [SMALL_STATE(22079)] = 657549,
  [SMALL_STATE(22080)] = 657559,
  [SMALL_STATE(22081)] = 657569,
  [SMALL_STATE(22082)] = 657579,
  [SMALL_STATE(22083)] = 657589,
  [SMALL_STATE(22084)] = 657599,
  [SMALL_STATE(22085)] = 657609,
  [SMALL_STATE(22086)] = 657619,
  [SMALL_STATE(22087)] = 657629,
  [SMALL_STATE(22088)] = 657639,
  [SMALL_STATE(22089)] = 657649,
  [SMALL_STATE(22090)] = 657659,
  [SMALL_STATE(22091)] = 657669,
  [SMALL_STATE(22092)] = 657679,
  [SMALL_STATE(22093)] = 657689,
  [SMALL_STATE(22094)] = 657699,
  [SMALL_STATE(22095)] = 657709,
  [SMALL_STATE(22096)] = 657719,
  [SMALL_STATE(22097)] = 657729,
  [SMALL_STATE(22098)] = 657739,
  [SMALL_STATE(22099)] = 657749,
  [SMALL_STATE(22100)] = 657759,
  [SMALL_STATE(22101)] = 657769,
  [SMALL_STATE(22102)] = 657779,
  [SMALL_STATE(22103)] = 657789,
  [SMALL_STATE(22104)] = 657799,
  [SMALL_STATE(22105)] = 657809,
  [SMALL_STATE(22106)] = 657819,
  [SMALL_STATE(22107)] = 657829,
  [SMALL_STATE(22108)] = 657839,
  [SMALL_STATE(22109)] = 657849,
  [SMALL_STATE(22110)] = 657859,
  [SMALL_STATE(22111)] = 657869,
  [SMALL_STATE(22112)] = 657879,
  [SMALL_STATE(22113)] = 657889,
  [SMALL_STATE(22114)] = 657899,
  [SMALL_STATE(22115)] = 657909,
  [SMALL_STATE(22116)] = 657919,
  [SMALL_STATE(22117)] = 657929,
  [SMALL_STATE(22118)] = 657939,
  [SMALL_STATE(22119)] = 657949,
  [SMALL_STATE(22120)] = 657959,
  [SMALL_STATE(22121)] = 657969,
  [SMALL_STATE(22122)] = 657979,
  [SMALL_STATE(22123)] = 657989,
  [SMALL_STATE(22124)] = 657999,
  [SMALL_STATE(22125)] = 658009,
  [SMALL_STATE(22126)] = 658019,
  [SMALL_STATE(22127)] = 658029,
  [SMALL_STATE(22128)] = 658039,
  [SMALL_STATE(22129)] = 658049,
  [SMALL_STATE(22130)] = 658059,
  [SMALL_STATE(22131)] = 658069,
  [SMALL_STATE(22132)] = 658079,
  [SMALL_STATE(22133)] = 658089,
  [SMALL_STATE(22134)] = 658099,
  [SMALL_STATE(22135)] = 658109,
  [SMALL_STATE(22136)] = 658119,
  [SMALL_STATE(22137)] = 658129,
  [SMALL_STATE(22138)] = 658139,
  [SMALL_STATE(22139)] = 658149,
  [SMALL_STATE(22140)] = 658159,
  [SMALL_STATE(22141)] = 658169,
  [SMALL_STATE(22142)] = 658179,
  [SMALL_STATE(22143)] = 658189,
  [SMALL_STATE(22144)] = 658199,
  [SMALL_STATE(22145)] = 658209,
  [SMALL_STATE(22146)] = 658219,
  [SMALL_STATE(22147)] = 658229,
  [SMALL_STATE(22148)] = 658239,
  [SMALL_STATE(22149)] = 658249,
  [SMALL_STATE(22150)] = 658259,
  [SMALL_STATE(22151)] = 658269,
  [SMALL_STATE(22152)] = 658279,
  [SMALL_STATE(22153)] = 658289,
  [SMALL_STATE(22154)] = 658299,
  [SMALL_STATE(22155)] = 658309,
  [SMALL_STATE(22156)] = 658319,
  [SMALL_STATE(22157)] = 658329,
  [SMALL_STATE(22158)] = 658339,
  [SMALL_STATE(22159)] = 658349,
  [SMALL_STATE(22160)] = 658359,
  [SMALL_STATE(22161)] = 658369,
  [SMALL_STATE(22162)] = 658379,
  [SMALL_STATE(22163)] = 658389,
  [SMALL_STATE(22164)] = 658399,
  [SMALL_STATE(22165)] = 658409,
  [SMALL_STATE(22166)] = 658419,
  [SMALL_STATE(22167)] = 658429,
  [SMALL_STATE(22168)] = 658439,
  [SMALL_STATE(22169)] = 658449,
  [SMALL_STATE(22170)] = 658459,
  [SMALL_STATE(22171)] = 658469,
  [SMALL_STATE(22172)] = 658479,
  [SMALL_STATE(22173)] = 658489,
  [SMALL_STATE(22174)] = 658499,
  [SMALL_STATE(22175)] = 658509,
  [SMALL_STATE(22176)] = 658519,
  [SMALL_STATE(22177)] = 658529,
  [SMALL_STATE(22178)] = 658539,
  [SMALL_STATE(22179)] = 658549,
  [SMALL_STATE(22180)] = 658559,
  [SMALL_STATE(22181)] = 658569,
  [SMALL_STATE(22182)] = 658579,
  [SMALL_STATE(22183)] = 658589,
  [SMALL_STATE(22184)] = 658599,
  [SMALL_STATE(22185)] = 658609,
  [SMALL_STATE(22186)] = 658619,
  [SMALL_STATE(22187)] = 658629,
  [SMALL_STATE(22188)] = 658639,
  [SMALL_STATE(22189)] = 658649,
  [SMALL_STATE(22190)] = 658659,
  [SMALL_STATE(22191)] = 658669,
  [SMALL_STATE(22192)] = 658679,
  [SMALL_STATE(22193)] = 658689,
  [SMALL_STATE(22194)] = 658699,
  [SMALL_STATE(22195)] = 658709,
  [SMALL_STATE(22196)] = 658719,
  [SMALL_STATE(22197)] = 658729,
  [SMALL_STATE(22198)] = 658739,
  [SMALL_STATE(22199)] = 658749,
  [SMALL_STATE(22200)] = 658759,
  [SMALL_STATE(22201)] = 658769,
  [SMALL_STATE(22202)] = 658779,
  [SMALL_STATE(22203)] = 658789,
  [SMALL_STATE(22204)] = 658799,
  [SMALL_STATE(22205)] = 658809,
  [SMALL_STATE(22206)] = 658819,
  [SMALL_STATE(22207)] = 658829,
  [SMALL_STATE(22208)] = 658839,
  [SMALL_STATE(22209)] = 658849,
  [SMALL_STATE(22210)] = 658859,
  [SMALL_STATE(22211)] = 658869,
  [SMALL_STATE(22212)] = 658879,
  [SMALL_STATE(22213)] = 658889,
  [SMALL_STATE(22214)] = 658899,
  [SMALL_STATE(22215)] = 658909,
  [SMALL_STATE(22216)] = 658919,
  [SMALL_STATE(22217)] = 658929,
  [SMALL_STATE(22218)] = 658939,
  [SMALL_STATE(22219)] = 658949,
  [SMALL_STATE(22220)] = 658959,
  [SMALL_STATE(22221)] = 658969,
  [SMALL_STATE(22222)] = 658979,
  [SMALL_STATE(22223)] = 658989,
  [SMALL_STATE(22224)] = 658999,
  [SMALL_STATE(22225)] = 659009,
  [SMALL_STATE(22226)] = 659019,
  [SMALL_STATE(22227)] = 659029,
  [SMALL_STATE(22228)] = 659039,
  [SMALL_STATE(22229)] = 659049,
  [SMALL_STATE(22230)] = 659059,
  [SMALL_STATE(22231)] = 659069,
  [SMALL_STATE(22232)] = 659079,
  [SMALL_STATE(22233)] = 659089,
  [SMALL_STATE(22234)] = 659099,
  [SMALL_STATE(22235)] = 659109,
  [SMALL_STATE(22236)] = 659119,
  [SMALL_STATE(22237)] = 659129,
  [SMALL_STATE(22238)] = 659139,
  [SMALL_STATE(22239)] = 659149,
  [SMALL_STATE(22240)] = 659159,
  [SMALL_STATE(22241)] = 659169,
  [SMALL_STATE(22242)] = 659179,
  [SMALL_STATE(22243)] = 659189,
  [SMALL_STATE(22244)] = 659199,
  [SMALL_STATE(22245)] = 659209,
  [SMALL_STATE(22246)] = 659219,
  [SMALL_STATE(22247)] = 659229,
  [SMALL_STATE(22248)] = 659239,
  [SMALL_STATE(22249)] = 659249,
  [SMALL_STATE(22250)] = 659259,
  [SMALL_STATE(22251)] = 659269,
  [SMALL_STATE(22252)] = 659279,
  [SMALL_STATE(22253)] = 659289,
  [SMALL_STATE(22254)] = 659299,
  [SMALL_STATE(22255)] = 659309,
  [SMALL_STATE(22256)] = 659319,
  [SMALL_STATE(22257)] = 659329,
  [SMALL_STATE(22258)] = 659339,
  [SMALL_STATE(22259)] = 659349,
  [SMALL_STATE(22260)] = 659359,
  [SMALL_STATE(22261)] = 659369,
  [SMALL_STATE(22262)] = 659379,
  [SMALL_STATE(22263)] = 659389,
  [SMALL_STATE(22264)] = 659399,
  [SMALL_STATE(22265)] = 659409,
  [SMALL_STATE(22266)] = 659419,
  [SMALL_STATE(22267)] = 659429,
  [SMALL_STATE(22268)] = 659439,
  [SMALL_STATE(22269)] = 659449,
  [SMALL_STATE(22270)] = 659459,
  [SMALL_STATE(22271)] = 659469,
  [SMALL_STATE(22272)] = 659479,
  [SMALL_STATE(22273)] = 659489,
  [SMALL_STATE(22274)] = 659499,
  [SMALL_STATE(22275)] = 659509,
  [SMALL_STATE(22276)] = 659519,
  [SMALL_STATE(22277)] = 659529,
  [SMALL_STATE(22278)] = 659539,
  [SMALL_STATE(22279)] = 659549,
  [SMALL_STATE(22280)] = 659559,
  [SMALL_STATE(22281)] = 659569,
  [SMALL_STATE(22282)] = 659579,
  [SMALL_STATE(22283)] = 659589,
  [SMALL_STATE(22284)] = 659599,
  [SMALL_STATE(22285)] = 659609,
  [SMALL_STATE(22286)] = 659619,
  [SMALL_STATE(22287)] = 659629,
  [SMALL_STATE(22288)] = 659639,
  [SMALL_STATE(22289)] = 659649,
  [SMALL_STATE(22290)] = 659659,
  [SMALL_STATE(22291)] = 659669,
  [SMALL_STATE(22292)] = 659679,
  [SMALL_STATE(22293)] = 659689,
  [SMALL_STATE(22294)] = 659699,
  [SMALL_STATE(22295)] = 659709,
  [SMALL_STATE(22296)] = 659719,
  [SMALL_STATE(22297)] = 659729,
  [SMALL_STATE(22298)] = 659739,
  [SMALL_STATE(22299)] = 659749,
  [SMALL_STATE(22300)] = 659759,
  [SMALL_STATE(22301)] = 659769,
  [SMALL_STATE(22302)] = 659779,
  [SMALL_STATE(22303)] = 659789,
  [SMALL_STATE(22304)] = 659799,
  [SMALL_STATE(22305)] = 659809,
  [SMALL_STATE(22306)] = 659819,
  [SMALL_STATE(22307)] = 659829,
  [SMALL_STATE(22308)] = 659839,
  [SMALL_STATE(22309)] = 659849,
  [SMALL_STATE(22310)] = 659859,
  [SMALL_STATE(22311)] = 659869,
  [SMALL_STATE(22312)] = 659879,
  [SMALL_STATE(22313)] = 659889,
  [SMALL_STATE(22314)] = 659899,
  [SMALL_STATE(22315)] = 659909,
  [SMALL_STATE(22316)] = 659919,
  [SMALL_STATE(22317)] = 659929,
  [SMALL_STATE(22318)] = 659939,
  [SMALL_STATE(22319)] = 659949,
  [SMALL_STATE(22320)] = 659959,
  [SMALL_STATE(22321)] = 659969,
  [SMALL_STATE(22322)] = 659979,
  [SMALL_STATE(22323)] = 659989,
  [SMALL_STATE(22324)] = 659999,
  [SMALL_STATE(22325)] = 660009,
  [SMALL_STATE(22326)] = 660019,
  [SMALL_STATE(22327)] = 660029,
  [SMALL_STATE(22328)] = 660039,
  [SMALL_STATE(22329)] = 660049,
  [SMALL_STATE(22330)] = 660059,
  [SMALL_STATE(22331)] = 660069,
  [SMALL_STATE(22332)] = 660079,
  [SMALL_STATE(22333)] = 660089,
  [SMALL_STATE(22334)] = 660099,
  [SMALL_STATE(22335)] = 660109,
  [SMALL_STATE(22336)] = 660119,
  [SMALL_STATE(22337)] = 660129,
  [SMALL_STATE(22338)] = 660139,
  [SMALL_STATE(22339)] = 660149,
  [SMALL_STATE(22340)] = 660159,
  [SMALL_STATE(22341)] = 660169,
  [SMALL_STATE(22342)] = 660179,
  [SMALL_STATE(22343)] = 660189,
  [SMALL_STATE(22344)] = 660199,
  [SMALL_STATE(22345)] = 660209,
  [SMALL_STATE(22346)] = 660219,
  [SMALL_STATE(22347)] = 660229,
  [SMALL_STATE(22348)] = 660239,
  [SMALL_STATE(22349)] = 660249,
  [SMALL_STATE(22350)] = 660259,
  [SMALL_STATE(22351)] = 660269,
  [SMALL_STATE(22352)] = 660279,
  [SMALL_STATE(22353)] = 660289,
  [SMALL_STATE(22354)] = 660299,
  [SMALL_STATE(22355)] = 660309,
  [SMALL_STATE(22356)] = 660319,
  [SMALL_STATE(22357)] = 660329,
  [SMALL_STATE(22358)] = 660339,
  [SMALL_STATE(22359)] = 660349,
  [SMALL_STATE(22360)] = 660359,
  [SMALL_STATE(22361)] = 660369,
  [SMALL_STATE(22362)] = 660379,
  [SMALL_STATE(22363)] = 660389,
  [SMALL_STATE(22364)] = 660399,
  [SMALL_STATE(22365)] = 660409,
  [SMALL_STATE(22366)] = 660419,
  [SMALL_STATE(22367)] = 660429,
  [SMALL_STATE(22368)] = 660439,
  [SMALL_STATE(22369)] = 660449,
  [SMALL_STATE(22370)] = 660459,
  [SMALL_STATE(22371)] = 660469,
  [SMALL_STATE(22372)] = 660479,
  [SMALL_STATE(22373)] = 660489,
  [SMALL_STATE(22374)] = 660499,
  [SMALL_STATE(22375)] = 660509,
  [SMALL_STATE(22376)] = 660519,
  [SMALL_STATE(22377)] = 660529,
  [SMALL_STATE(22378)] = 660539,
  [SMALL_STATE(22379)] = 660549,
  [SMALL_STATE(22380)] = 660559,
  [SMALL_STATE(22381)] = 660569,
  [SMALL_STATE(22382)] = 660579,
  [SMALL_STATE(22383)] = 660589,
  [SMALL_STATE(22384)] = 660599,
  [SMALL_STATE(22385)] = 660609,
  [SMALL_STATE(22386)] = 660619,
  [SMALL_STATE(22387)] = 660629,
  [SMALL_STATE(22388)] = 660639,
  [SMALL_STATE(22389)] = 660649,
  [SMALL_STATE(22390)] = 660659,
  [SMALL_STATE(22391)] = 660669,
  [SMALL_STATE(22392)] = 660679,
  [SMALL_STATE(22393)] = 660689,
  [SMALL_STATE(22394)] = 660699,
  [SMALL_STATE(22395)] = 660709,
  [SMALL_STATE(22396)] = 660719,
  [SMALL_STATE(22397)] = 660729,
  [SMALL_STATE(22398)] = 660739,
  [SMALL_STATE(22399)] = 660749,
  [SMALL_STATE(22400)] = 660759,
  [SMALL_STATE(22401)] = 660769,
  [SMALL_STATE(22402)] = 660779,
  [SMALL_STATE(22403)] = 660789,
  [SMALL_STATE(22404)] = 660799,
  [SMALL_STATE(22405)] = 660809,
  [SMALL_STATE(22406)] = 660819,
  [SMALL_STATE(22407)] = 660829,
  [SMALL_STATE(22408)] = 660839,
  [SMALL_STATE(22409)] = 660849,
  [SMALL_STATE(22410)] = 660859,
  [SMALL_STATE(22411)] = 660869,
  [SMALL_STATE(22412)] = 660879,
  [SMALL_STATE(22413)] = 660889,
  [SMALL_STATE(22414)] = 660899,
  [SMALL_STATE(22415)] = 660909,
  [SMALL_STATE(22416)] = 660919,
  [SMALL_STATE(22417)] = 660929,
  [SMALL_STATE(22418)] = 660939,
  [SMALL_STATE(22419)] = 660949,
  [SMALL_STATE(22420)] = 660959,
  [SMALL_STATE(22421)] = 660969,
  [SMALL_STATE(22422)] = 660979,
  [SMALL_STATE(22423)] = 660989,
  [SMALL_STATE(22424)] = 660999,
  [SMALL_STATE(22425)] = 661009,
  [SMALL_STATE(22426)] = 661019,
  [SMALL_STATE(22427)] = 661029,
  [SMALL_STATE(22428)] = 661039,
  [SMALL_STATE(22429)] = 661049,
  [SMALL_STATE(22430)] = 661059,
  [SMALL_STATE(22431)] = 661069,
  [SMALL_STATE(22432)] = 661079,
  [SMALL_STATE(22433)] = 661089,
  [SMALL_STATE(22434)] = 661099,
  [SMALL_STATE(22435)] = 661109,
  [SMALL_STATE(22436)] = 661119,
  [SMALL_STATE(22437)] = 661129,
  [SMALL_STATE(22438)] = 661139,
  [SMALL_STATE(22439)] = 661149,
  [SMALL_STATE(22440)] = 661159,
  [SMALL_STATE(22441)] = 661169,
  [SMALL_STATE(22442)] = 661179,
  [SMALL_STATE(22443)] = 661189,
  [SMALL_STATE(22444)] = 661199,
  [SMALL_STATE(22445)] = 661209,
  [SMALL_STATE(22446)] = 661219,
  [SMALL_STATE(22447)] = 661229,
  [SMALL_STATE(22448)] = 661239,
  [SMALL_STATE(22449)] = 661249,
  [SMALL_STATE(22450)] = 661259,
  [SMALL_STATE(22451)] = 661269,
  [SMALL_STATE(22452)] = 661279,
  [SMALL_STATE(22453)] = 661289,
  [SMALL_STATE(22454)] = 661299,
  [SMALL_STATE(22455)] = 661309,
  [SMALL_STATE(22456)] = 661319,
  [SMALL_STATE(22457)] = 661329,
  [SMALL_STATE(22458)] = 661339,
  [SMALL_STATE(22459)] = 661349,
  [SMALL_STATE(22460)] = 661359,
  [SMALL_STATE(22461)] = 661369,
  [SMALL_STATE(22462)] = 661379,
  [SMALL_STATE(22463)] = 661389,
  [SMALL_STATE(22464)] = 661399,
  [SMALL_STATE(22465)] = 661409,
  [SMALL_STATE(22466)] = 661419,
  [SMALL_STATE(22467)] = 661429,
  [SMALL_STATE(22468)] = 661439,
  [SMALL_STATE(22469)] = 661449,
  [SMALL_STATE(22470)] = 661459,
  [SMALL_STATE(22471)] = 661469,
  [SMALL_STATE(22472)] = 661479,
  [SMALL_STATE(22473)] = 661489,
  [SMALL_STATE(22474)] = 661499,
  [SMALL_STATE(22475)] = 661509,
  [SMALL_STATE(22476)] = 661519,
  [SMALL_STATE(22477)] = 661529,
  [SMALL_STATE(22478)] = 661539,
  [SMALL_STATE(22479)] = 661549,
  [SMALL_STATE(22480)] = 661559,
  [SMALL_STATE(22481)] = 661569,
  [SMALL_STATE(22482)] = 661579,
  [SMALL_STATE(22483)] = 661589,
  [SMALL_STATE(22484)] = 661599,
  [SMALL_STATE(22485)] = 661609,
  [SMALL_STATE(22486)] = 661619,
  [SMALL_STATE(22487)] = 661629,
  [SMALL_STATE(22488)] = 661639,
  [SMALL_STATE(22489)] = 661649,
  [SMALL_STATE(22490)] = 661659,
  [SMALL_STATE(22491)] = 661669,
  [SMALL_STATE(22492)] = 661679,
  [SMALL_STATE(22493)] = 661689,
  [SMALL_STATE(22494)] = 661699,
  [SMALL_STATE(22495)] = 661709,
  [SMALL_STATE(22496)] = 661719,
  [SMALL_STATE(22497)] = 661729,
  [SMALL_STATE(22498)] = 661739,
  [SMALL_STATE(22499)] = 661749,
  [SMALL_STATE(22500)] = 661759,
  [SMALL_STATE(22501)] = 661769,
  [SMALL_STATE(22502)] = 661779,
  [SMALL_STATE(22503)] = 661789,
  [SMALL_STATE(22504)] = 661799,
  [SMALL_STATE(22505)] = 661809,
  [SMALL_STATE(22506)] = 661819,
  [SMALL_STATE(22507)] = 661829,
  [SMALL_STATE(22508)] = 661839,
  [SMALL_STATE(22509)] = 661849,
  [SMALL_STATE(22510)] = 661859,
  [SMALL_STATE(22511)] = 661869,
  [SMALL_STATE(22512)] = 661879,
  [SMALL_STATE(22513)] = 661889,
  [SMALL_STATE(22514)] = 661899,
  [SMALL_STATE(22515)] = 661909,
  [SMALL_STATE(22516)] = 661919,
  [SMALL_STATE(22517)] = 661929,
  [SMALL_STATE(22518)] = 661939,
  [SMALL_STATE(22519)] = 661949,
  [SMALL_STATE(22520)] = 661959,
  [SMALL_STATE(22521)] = 661969,
  [SMALL_STATE(22522)] = 661979,
  [SMALL_STATE(22523)] = 661989,
  [SMALL_STATE(22524)] = 661999,
  [SMALL_STATE(22525)] = 662009,
  [SMALL_STATE(22526)] = 662019,
  [SMALL_STATE(22527)] = 662029,
  [SMALL_STATE(22528)] = 662039,
  [SMALL_STATE(22529)] = 662049,
  [SMALL_STATE(22530)] = 662059,
  [SMALL_STATE(22531)] = 662069,
  [SMALL_STATE(22532)] = 662079,
  [SMALL_STATE(22533)] = 662089,
  [SMALL_STATE(22534)] = 662099,
  [SMALL_STATE(22535)] = 662109,
  [SMALL_STATE(22536)] = 662119,
  [SMALL_STATE(22537)] = 662129,
  [SMALL_STATE(22538)] = 662139,
  [SMALL_STATE(22539)] = 662149,
  [SMALL_STATE(22540)] = 662159,
  [SMALL_STATE(22541)] = 662169,
  [SMALL_STATE(22542)] = 662179,
  [SMALL_STATE(22543)] = 662189,
  [SMALL_STATE(22544)] = 662199,
  [SMALL_STATE(22545)] = 662209,
  [SMALL_STATE(22546)] = 662219,
  [SMALL_STATE(22547)] = 662229,
  [SMALL_STATE(22548)] = 662239,
  [SMALL_STATE(22549)] = 662249,
  [SMALL_STATE(22550)] = 662259,
  [SMALL_STATE(22551)] = 662269,
  [SMALL_STATE(22552)] = 662279,
  [SMALL_STATE(22553)] = 662289,
  [SMALL_STATE(22554)] = 662299,
  [SMALL_STATE(22555)] = 662309,
  [SMALL_STATE(22556)] = 662319,
  [SMALL_STATE(22557)] = 662329,
  [SMALL_STATE(22558)] = 662339,
  [SMALL_STATE(22559)] = 662349,
  [SMALL_STATE(22560)] = 662359,
  [SMALL_STATE(22561)] = 662369,
  [SMALL_STATE(22562)] = 662379,
  [SMALL_STATE(22563)] = 662389,
  [SMALL_STATE(22564)] = 662399,
  [SMALL_STATE(22565)] = 662409,
  [SMALL_STATE(22566)] = 662419,
  [SMALL_STATE(22567)] = 662429,
  [SMALL_STATE(22568)] = 662439,
  [SMALL_STATE(22569)] = 662449,
  [SMALL_STATE(22570)] = 662459,
  [SMALL_STATE(22571)] = 662469,
  [SMALL_STATE(22572)] = 662479,
  [SMALL_STATE(22573)] = 662489,
  [SMALL_STATE(22574)] = 662499,
  [SMALL_STATE(22575)] = 662509,
  [SMALL_STATE(22576)] = 662519,
  [SMALL_STATE(22577)] = 662529,
  [SMALL_STATE(22578)] = 662539,
  [SMALL_STATE(22579)] = 662549,
  [SMALL_STATE(22580)] = 662559,
  [SMALL_STATE(22581)] = 662569,
  [SMALL_STATE(22582)] = 662579,
  [SMALL_STATE(22583)] = 662589,
  [SMALL_STATE(22584)] = 662599,
  [SMALL_STATE(22585)] = 662609,
  [SMALL_STATE(22586)] = 662619,
  [SMALL_STATE(22587)] = 662629,
  [SMALL_STATE(22588)] = 662639,
  [SMALL_STATE(22589)] = 662649,
  [SMALL_STATE(22590)] = 662659,
  [SMALL_STATE(22591)] = 662669,
  [SMALL_STATE(22592)] = 662679,
  [SMALL_STATE(22593)] = 662689,
  [SMALL_STATE(22594)] = 662699,
  [SMALL_STATE(22595)] = 662709,
  [SMALL_STATE(22596)] = 662719,
  [SMALL_STATE(22597)] = 662729,
  [SMALL_STATE(22598)] = 662739,
  [SMALL_STATE(22599)] = 662749,
  [SMALL_STATE(22600)] = 662759,
  [SMALL_STATE(22601)] = 662769,
  [SMALL_STATE(22602)] = 662779,
  [SMALL_STATE(22603)] = 662789,
  [SMALL_STATE(22604)] = 662799,
  [SMALL_STATE(22605)] = 662809,
  [SMALL_STATE(22606)] = 662819,
  [SMALL_STATE(22607)] = 662829,
  [SMALL_STATE(22608)] = 662839,
  [SMALL_STATE(22609)] = 662849,
  [SMALL_STATE(22610)] = 662859,
  [SMALL_STATE(22611)] = 662869,
  [SMALL_STATE(22612)] = 662879,
  [SMALL_STATE(22613)] = 662889,
  [SMALL_STATE(22614)] = 662899,
  [SMALL_STATE(22615)] = 662909,
  [SMALL_STATE(22616)] = 662919,
  [SMALL_STATE(22617)] = 662929,
  [SMALL_STATE(22618)] = 662939,
  [SMALL_STATE(22619)] = 662949,
  [SMALL_STATE(22620)] = 662959,
  [SMALL_STATE(22621)] = 662969,
  [SMALL_STATE(22622)] = 662979,
  [SMALL_STATE(22623)] = 662989,
  [SMALL_STATE(22624)] = 662999,
  [SMALL_STATE(22625)] = 663009,
  [SMALL_STATE(22626)] = 663019,
  [SMALL_STATE(22627)] = 663029,
  [SMALL_STATE(22628)] = 663039,
  [SMALL_STATE(22629)] = 663049,
  [SMALL_STATE(22630)] = 663059,
  [SMALL_STATE(22631)] = 663069,
  [SMALL_STATE(22632)] = 663079,
  [SMALL_STATE(22633)] = 663089,
  [SMALL_STATE(22634)] = 663099,
  [SMALL_STATE(22635)] = 663109,
  [SMALL_STATE(22636)] = 663119,
  [SMALL_STATE(22637)] = 663129,
  [SMALL_STATE(22638)] = 663139,
  [SMALL_STATE(22639)] = 663149,
  [SMALL_STATE(22640)] = 663159,
  [SMALL_STATE(22641)] = 663169,
  [SMALL_STATE(22642)] = 663179,
  [SMALL_STATE(22643)] = 663189,
  [SMALL_STATE(22644)] = 663199,
  [SMALL_STATE(22645)] = 663209,
  [SMALL_STATE(22646)] = 663219,
  [SMALL_STATE(22647)] = 663229,
  [SMALL_STATE(22648)] = 663239,
  [SMALL_STATE(22649)] = 663249,
  [SMALL_STATE(22650)] = 663259,
  [SMALL_STATE(22651)] = 663269,
  [SMALL_STATE(22652)] = 663279,
  [SMALL_STATE(22653)] = 663289,
  [SMALL_STATE(22654)] = 663299,
  [SMALL_STATE(22655)] = 663309,
  [SMALL_STATE(22656)] = 663319,
  [SMALL_STATE(22657)] = 663329,
  [SMALL_STATE(22658)] = 663339,
  [SMALL_STATE(22659)] = 663349,
  [SMALL_STATE(22660)] = 663359,
  [SMALL_STATE(22661)] = 663369,
  [SMALL_STATE(22662)] = 663379,
  [SMALL_STATE(22663)] = 663389,
  [SMALL_STATE(22664)] = 663399,
  [SMALL_STATE(22665)] = 663409,
  [SMALL_STATE(22666)] = 663419,
  [SMALL_STATE(22667)] = 663429,
  [SMALL_STATE(22668)] = 663439,
  [SMALL_STATE(22669)] = 663449,
  [SMALL_STATE(22670)] = 663459,
  [SMALL_STATE(22671)] = 663469,
  [SMALL_STATE(22672)] = 663479,
  [SMALL_STATE(22673)] = 663489,
  [SMALL_STATE(22674)] = 663499,
  [SMALL_STATE(22675)] = 663509,
  [SMALL_STATE(22676)] = 663519,
  [SMALL_STATE(22677)] = 663529,
  [SMALL_STATE(22678)] = 663539,
  [SMALL_STATE(22679)] = 663549,
  [SMALL_STATE(22680)] = 663559,
  [SMALL_STATE(22681)] = 663569,
  [SMALL_STATE(22682)] = 663579,
  [SMALL_STATE(22683)] = 663589,
  [SMALL_STATE(22684)] = 663599,
  [SMALL_STATE(22685)] = 663609,
  [SMALL_STATE(22686)] = 663619,
  [SMALL_STATE(22687)] = 663629,
  [SMALL_STATE(22688)] = 663639,
  [SMALL_STATE(22689)] = 663649,
  [SMALL_STATE(22690)] = 663659,
  [SMALL_STATE(22691)] = 663669,
  [SMALL_STATE(22692)] = 663679,
  [SMALL_STATE(22693)] = 663689,
  [SMALL_STATE(22694)] = 663699,
  [SMALL_STATE(22695)] = 663709,
  [SMALL_STATE(22696)] = 663719,
  [SMALL_STATE(22697)] = 663729,
  [SMALL_STATE(22698)] = 663739,
  [SMALL_STATE(22699)] = 663749,
  [SMALL_STATE(22700)] = 663759,
  [SMALL_STATE(22701)] = 663769,
  [SMALL_STATE(22702)] = 663779,
  [SMALL_STATE(22703)] = 663789,
  [SMALL_STATE(22704)] = 663799,
  [SMALL_STATE(22705)] = 663809,
  [SMALL_STATE(22706)] = 663819,
  [SMALL_STATE(22707)] = 663829,
  [SMALL_STATE(22708)] = 663839,
  [SMALL_STATE(22709)] = 663849,
  [SMALL_STATE(22710)] = 663859,
  [SMALL_STATE(22711)] = 663869,
  [SMALL_STATE(22712)] = 663879,
  [SMALL_STATE(22713)] = 663889,
  [SMALL_STATE(22714)] = 663899,
  [SMALL_STATE(22715)] = 663909,
  [SMALL_STATE(22716)] = 663919,
  [SMALL_STATE(22717)] = 663929,
  [SMALL_STATE(22718)] = 663939,
  [SMALL_STATE(22719)] = 663949,
  [SMALL_STATE(22720)] = 663959,
  [SMALL_STATE(22721)] = 663969,
  [SMALL_STATE(22722)] = 663979,
  [SMALL_STATE(22723)] = 663989,
  [SMALL_STATE(22724)] = 663999,
  [SMALL_STATE(22725)] = 664009,
  [SMALL_STATE(22726)] = 664019,
  [SMALL_STATE(22727)] = 664029,
  [SMALL_STATE(22728)] = 664039,
  [SMALL_STATE(22729)] = 664049,
  [SMALL_STATE(22730)] = 664059,
  [SMALL_STATE(22731)] = 664069,
  [SMALL_STATE(22732)] = 664079,
  [SMALL_STATE(22733)] = 664089,
  [SMALL_STATE(22734)] = 664099,
  [SMALL_STATE(22735)] = 664109,
  [SMALL_STATE(22736)] = 664119,
  [SMALL_STATE(22737)] = 664129,
  [SMALL_STATE(22738)] = 664139,
  [SMALL_STATE(22739)] = 664149,
  [SMALL_STATE(22740)] = 664159,
  [SMALL_STATE(22741)] = 664169,
  [SMALL_STATE(22742)] = 664179,
  [SMALL_STATE(22743)] = 664189,
  [SMALL_STATE(22744)] = 664199,
  [SMALL_STATE(22745)] = 664209,
  [SMALL_STATE(22746)] = 664219,
  [SMALL_STATE(22747)] = 664229,
  [SMALL_STATE(22748)] = 664239,
  [SMALL_STATE(22749)] = 664249,
  [SMALL_STATE(22750)] = 664259,
  [SMALL_STATE(22751)] = 664269,
  [SMALL_STATE(22752)] = 664279,
  [SMALL_STATE(22753)] = 664289,
  [SMALL_STATE(22754)] = 664299,
  [SMALL_STATE(22755)] = 664309,
  [SMALL_STATE(22756)] = 664319,
  [SMALL_STATE(22757)] = 664329,
  [SMALL_STATE(22758)] = 664339,
  [SMALL_STATE(22759)] = 664349,
  [SMALL_STATE(22760)] = 664359,
  [SMALL_STATE(22761)] = 664369,
  [SMALL_STATE(22762)] = 664379,
  [SMALL_STATE(22763)] = 664389,
  [SMALL_STATE(22764)] = 664399,
  [SMALL_STATE(22765)] = 664409,
  [SMALL_STATE(22766)] = 664419,
  [SMALL_STATE(22767)] = 664429,
  [SMALL_STATE(22768)] = 664439,
  [SMALL_STATE(22769)] = 664449,
  [SMALL_STATE(22770)] = 664459,
  [SMALL_STATE(22771)] = 664469,
  [SMALL_STATE(22772)] = 664479,
  [SMALL_STATE(22773)] = 664489,
  [SMALL_STATE(22774)] = 664499,
  [SMALL_STATE(22775)] = 664509,
  [SMALL_STATE(22776)] = 664519,
  [SMALL_STATE(22777)] = 664529,
  [SMALL_STATE(22778)] = 664539,
  [SMALL_STATE(22779)] = 664549,
  [SMALL_STATE(22780)] = 664559,
  [SMALL_STATE(22781)] = 664569,
  [SMALL_STATE(22782)] = 664579,
  [SMALL_STATE(22783)] = 664589,
  [SMALL_STATE(22784)] = 664599,
  [SMALL_STATE(22785)] = 664609,
  [SMALL_STATE(22786)] = 664619,
  [SMALL_STATE(22787)] = 664629,
  [SMALL_STATE(22788)] = 664639,
  [SMALL_STATE(22789)] = 664649,
  [SMALL_STATE(22790)] = 664659,
  [SMALL_STATE(22791)] = 664669,
  [SMALL_STATE(22792)] = 664679,
  [SMALL_STATE(22793)] = 664689,
  [SMALL_STATE(22794)] = 664699,
  [SMALL_STATE(22795)] = 664709,
  [SMALL_STATE(22796)] = 664719,
  [SMALL_STATE(22797)] = 664729,
  [SMALL_STATE(22798)] = 664739,
  [SMALL_STATE(22799)] = 664749,
  [SMALL_STATE(22800)] = 664759,
  [SMALL_STATE(22801)] = 664769,
  [SMALL_STATE(22802)] = 664779,
  [SMALL_STATE(22803)] = 664789,
  [SMALL_STATE(22804)] = 664799,
  [SMALL_STATE(22805)] = 664809,
  [SMALL_STATE(22806)] = 664819,
  [SMALL_STATE(22807)] = 664829,
  [SMALL_STATE(22808)] = 664839,
  [SMALL_STATE(22809)] = 664849,
  [SMALL_STATE(22810)] = 664859,
  [SMALL_STATE(22811)] = 664869,
  [SMALL_STATE(22812)] = 664879,
  [SMALL_STATE(22813)] = 664889,
  [SMALL_STATE(22814)] = 664899,
  [SMALL_STATE(22815)] = 664909,
  [SMALL_STATE(22816)] = 664919,
  [SMALL_STATE(22817)] = 664929,
  [SMALL_STATE(22818)] = 664939,
  [SMALL_STATE(22819)] = 664949,
  [SMALL_STATE(22820)] = 664959,
  [SMALL_STATE(22821)] = 664969,
  [SMALL_STATE(22822)] = 664979,
  [SMALL_STATE(22823)] = 664989,
  [SMALL_STATE(22824)] = 664999,
  [SMALL_STATE(22825)] = 665009,
  [SMALL_STATE(22826)] = 665019,
  [SMALL_STATE(22827)] = 665029,
  [SMALL_STATE(22828)] = 665039,
  [SMALL_STATE(22829)] = 665049,
  [SMALL_STATE(22830)] = 665059,
  [SMALL_STATE(22831)] = 665069,
  [SMALL_STATE(22832)] = 665079,
  [SMALL_STATE(22833)] = 665089,
  [SMALL_STATE(22834)] = 665099,
  [SMALL_STATE(22835)] = 665109,
  [SMALL_STATE(22836)] = 665119,
  [SMALL_STATE(22837)] = 665129,
  [SMALL_STATE(22838)] = 665139,
  [SMALL_STATE(22839)] = 665149,
  [SMALL_STATE(22840)] = 665159,
  [SMALL_STATE(22841)] = 665169,
  [SMALL_STATE(22842)] = 665179,
  [SMALL_STATE(22843)] = 665189,
  [SMALL_STATE(22844)] = 665199,
  [SMALL_STATE(22845)] = 665209,
  [SMALL_STATE(22846)] = 665219,
  [SMALL_STATE(22847)] = 665229,
  [SMALL_STATE(22848)] = 665239,
  [SMALL_STATE(22849)] = 665249,
  [SMALL_STATE(22850)] = 665259,
  [SMALL_STATE(22851)] = 665269,
  [SMALL_STATE(22852)] = 665279,
  [SMALL_STATE(22853)] = 665289,
  [SMALL_STATE(22854)] = 665299,
  [SMALL_STATE(22855)] = 665309,
  [SMALL_STATE(22856)] = 665319,
  [SMALL_STATE(22857)] = 665329,
  [SMALL_STATE(22858)] = 665339,
  [SMALL_STATE(22859)] = 665349,
  [SMALL_STATE(22860)] = 665359,
  [SMALL_STATE(22861)] = 665369,
  [SMALL_STATE(22862)] = 665379,
  [SMALL_STATE(22863)] = 665389,
  [SMALL_STATE(22864)] = 665399,
  [SMALL_STATE(22865)] = 665409,
  [SMALL_STATE(22866)] = 665419,
  [SMALL_STATE(22867)] = 665429,
  [SMALL_STATE(22868)] = 665439,
  [SMALL_STATE(22869)] = 665449,
  [SMALL_STATE(22870)] = 665459,
  [SMALL_STATE(22871)] = 665469,
  [SMALL_STATE(22872)] = 665479,
  [SMALL_STATE(22873)] = 665489,
  [SMALL_STATE(22874)] = 665499,
  [SMALL_STATE(22875)] = 665509,
  [SMALL_STATE(22876)] = 665519,
  [SMALL_STATE(22877)] = 665529,
  [SMALL_STATE(22878)] = 665539,
  [SMALL_STATE(22879)] = 665549,
  [SMALL_STATE(22880)] = 665559,
  [SMALL_STATE(22881)] = 665569,
  [SMALL_STATE(22882)] = 665579,
  [SMALL_STATE(22883)] = 665589,
  [SMALL_STATE(22884)] = 665599,
  [SMALL_STATE(22885)] = 665609,
  [SMALL_STATE(22886)] = 665619,
  [SMALL_STATE(22887)] = 665629,
  [SMALL_STATE(22888)] = 665639,
  [SMALL_STATE(22889)] = 665649,
  [SMALL_STATE(22890)] = 665659,
  [SMALL_STATE(22891)] = 665669,
  [SMALL_STATE(22892)] = 665679,
  [SMALL_STATE(22893)] = 665689,
  [SMALL_STATE(22894)] = 665699,
  [SMALL_STATE(22895)] = 665709,
  [SMALL_STATE(22896)] = 665719,
  [SMALL_STATE(22897)] = 665729,
  [SMALL_STATE(22898)] = 665739,
  [SMALL_STATE(22899)] = 665749,
  [SMALL_STATE(22900)] = 665759,
  [SMALL_STATE(22901)] = 665769,
  [SMALL_STATE(22902)] = 665779,
  [SMALL_STATE(22903)] = 665789,
  [SMALL_STATE(22904)] = 665799,
  [SMALL_STATE(22905)] = 665809,
  [SMALL_STATE(22906)] = 665819,
  [SMALL_STATE(22907)] = 665829,
  [SMALL_STATE(22908)] = 665839,
  [SMALL_STATE(22909)] = 665849,
  [SMALL_STATE(22910)] = 665859,
  [SMALL_STATE(22911)] = 665869,
  [SMALL_STATE(22912)] = 665879,
  [SMALL_STATE(22913)] = 665889,
  [SMALL_STATE(22914)] = 665899,
  [SMALL_STATE(22915)] = 665909,
  [SMALL_STATE(22916)] = 665919,
  [SMALL_STATE(22917)] = 665929,
  [SMALL_STATE(22918)] = 665939,
  [SMALL_STATE(22919)] = 665949,
  [SMALL_STATE(22920)] = 665959,
  [SMALL_STATE(22921)] = 665969,
  [SMALL_STATE(22922)] = 665979,
  [SMALL_STATE(22923)] = 665989,
  [SMALL_STATE(22924)] = 665999,
  [SMALL_STATE(22925)] = 666009,
  [SMALL_STATE(22926)] = 666019,
  [SMALL_STATE(22927)] = 666029,
  [SMALL_STATE(22928)] = 666039,
  [SMALL_STATE(22929)] = 666049,
  [SMALL_STATE(22930)] = 666059,
  [SMALL_STATE(22931)] = 666069,
  [SMALL_STATE(22932)] = 666079,
  [SMALL_STATE(22933)] = 666089,
  [SMALL_STATE(22934)] = 666099,
  [SMALL_STATE(22935)] = 666109,
  [SMALL_STATE(22936)] = 666119,
  [SMALL_STATE(22937)] = 666129,
  [SMALL_STATE(22938)] = 666139,
  [SMALL_STATE(22939)] = 666149,
  [SMALL_STATE(22940)] = 666159,
  [SMALL_STATE(22941)] = 666169,
  [SMALL_STATE(22942)] = 666179,
  [SMALL_STATE(22943)] = 666189,
  [SMALL_STATE(22944)] = 666199,
  [SMALL_STATE(22945)] = 666209,
  [SMALL_STATE(22946)] = 666219,
  [SMALL_STATE(22947)] = 666229,
  [SMALL_STATE(22948)] = 666239,
  [SMALL_STATE(22949)] = 666249,
  [SMALL_STATE(22950)] = 666259,
  [SMALL_STATE(22951)] = 666269,
  [SMALL_STATE(22952)] = 666279,
  [SMALL_STATE(22953)] = 666289,
  [SMALL_STATE(22954)] = 666299,
  [SMALL_STATE(22955)] = 666309,
  [SMALL_STATE(22956)] = 666319,
  [SMALL_STATE(22957)] = 666329,
  [SMALL_STATE(22958)] = 666339,
  [SMALL_STATE(22959)] = 666349,
  [SMALL_STATE(22960)] = 666359,
  [SMALL_STATE(22961)] = 666369,
  [SMALL_STATE(22962)] = 666379,
  [SMALL_STATE(22963)] = 666389,
  [SMALL_STATE(22964)] = 666399,
  [SMALL_STATE(22965)] = 666409,
  [SMALL_STATE(22966)] = 666419,
  [SMALL_STATE(22967)] = 666429,
  [SMALL_STATE(22968)] = 666439,
  [SMALL_STATE(22969)] = 666449,
  [SMALL_STATE(22970)] = 666459,
  [SMALL_STATE(22971)] = 666469,
  [SMALL_STATE(22972)] = 666479,
  [SMALL_STATE(22973)] = 666489,
  [SMALL_STATE(22974)] = 666499,
  [SMALL_STATE(22975)] = 666509,
  [SMALL_STATE(22976)] = 666519,
  [SMALL_STATE(22977)] = 666529,
  [SMALL_STATE(22978)] = 666539,
  [SMALL_STATE(22979)] = 666549,
  [SMALL_STATE(22980)] = 666559,
  [SMALL_STATE(22981)] = 666569,
  [SMALL_STATE(22982)] = 666579,
  [SMALL_STATE(22983)] = 666589,
  [SMALL_STATE(22984)] = 666599,
  [SMALL_STATE(22985)] = 666609,
  [SMALL_STATE(22986)] = 666619,
  [SMALL_STATE(22987)] = 666629,
  [SMALL_STATE(22988)] = 666639,
  [SMALL_STATE(22989)] = 666649,
  [SMALL_STATE(22990)] = 666659,
  [SMALL_STATE(22991)] = 666669,
  [SMALL_STATE(22992)] = 666679,
  [SMALL_STATE(22993)] = 666689,
  [SMALL_STATE(22994)] = 666699,
  [SMALL_STATE(22995)] = 666709,
  [SMALL_STATE(22996)] = 666719,
  [SMALL_STATE(22997)] = 666729,
  [SMALL_STATE(22998)] = 666739,
  [SMALL_STATE(22999)] = 666749,
  [SMALL_STATE(23000)] = 666759,
  [SMALL_STATE(23001)] = 666769,
  [SMALL_STATE(23002)] = 666779,
  [SMALL_STATE(23003)] = 666789,
  [SMALL_STATE(23004)] = 666799,
  [SMALL_STATE(23005)] = 666809,
  [SMALL_STATE(23006)] = 666819,
  [SMALL_STATE(23007)] = 666829,
  [SMALL_STATE(23008)] = 666839,
  [SMALL_STATE(23009)] = 666849,
  [SMALL_STATE(23010)] = 666859,
  [SMALL_STATE(23011)] = 666869,
  [SMALL_STATE(23012)] = 666879,
  [SMALL_STATE(23013)] = 666889,
  [SMALL_STATE(23014)] = 666899,
  [SMALL_STATE(23015)] = 666909,
  [SMALL_STATE(23016)] = 666919,
  [SMALL_STATE(23017)] = 666929,
  [SMALL_STATE(23018)] = 666939,
  [SMALL_STATE(23019)] = 666949,
  [SMALL_STATE(23020)] = 666959,
  [SMALL_STATE(23021)] = 666969,
  [SMALL_STATE(23022)] = 666979,
  [SMALL_STATE(23023)] = 666989,
  [SMALL_STATE(23024)] = 666999,
  [SMALL_STATE(23025)] = 667009,
  [SMALL_STATE(23026)] = 667019,
  [SMALL_STATE(23027)] = 667029,
  [SMALL_STATE(23028)] = 667039,
  [SMALL_STATE(23029)] = 667049,
  [SMALL_STATE(23030)] = 667059,
  [SMALL_STATE(23031)] = 667069,
  [SMALL_STATE(23032)] = 667079,
  [SMALL_STATE(23033)] = 667089,
  [SMALL_STATE(23034)] = 667099,
  [SMALL_STATE(23035)] = 667109,
  [SMALL_STATE(23036)] = 667119,
  [SMALL_STATE(23037)] = 667129,
  [SMALL_STATE(23038)] = 667139,
  [SMALL_STATE(23039)] = 667149,
  [SMALL_STATE(23040)] = 667159,
  [SMALL_STATE(23041)] = 667169,
  [SMALL_STATE(23042)] = 667179,
  [SMALL_STATE(23043)] = 667189,
  [SMALL_STATE(23044)] = 667199,
  [SMALL_STATE(23045)] = 667209,
  [SMALL_STATE(23046)] = 667219,
  [SMALL_STATE(23047)] = 667229,
  [SMALL_STATE(23048)] = 667239,
  [SMALL_STATE(23049)] = 667249,
  [SMALL_STATE(23050)] = 667259,
  [SMALL_STATE(23051)] = 667269,
  [SMALL_STATE(23052)] = 667279,
  [SMALL_STATE(23053)] = 667289,
  [SMALL_STATE(23054)] = 667299,
  [SMALL_STATE(23055)] = 667309,
  [SMALL_STATE(23056)] = 667319,
  [SMALL_STATE(23057)] = 667329,
  [SMALL_STATE(23058)] = 667339,
  [SMALL_STATE(23059)] = 667349,
  [SMALL_STATE(23060)] = 667359,
  [SMALL_STATE(23061)] = 667369,
  [SMALL_STATE(23062)] = 667379,
  [SMALL_STATE(23063)] = 667389,
  [SMALL_STATE(23064)] = 667399,
  [SMALL_STATE(23065)] = 667409,
  [SMALL_STATE(23066)] = 667419,
  [SMALL_STATE(23067)] = 667429,
  [SMALL_STATE(23068)] = 667439,
  [SMALL_STATE(23069)] = 667449,
  [SMALL_STATE(23070)] = 667459,
  [SMALL_STATE(23071)] = 667469,
  [SMALL_STATE(23072)] = 667479,
  [SMALL_STATE(23073)] = 667489,
  [SMALL_STATE(23074)] = 667499,
  [SMALL_STATE(23075)] = 667509,
  [SMALL_STATE(23076)] = 667519,
  [SMALL_STATE(23077)] = 667529,
  [SMALL_STATE(23078)] = 667539,
  [SMALL_STATE(23079)] = 667549,
  [SMALL_STATE(23080)] = 667559,
  [SMALL_STATE(23081)] = 667569,
  [SMALL_STATE(23082)] = 667579,
  [SMALL_STATE(23083)] = 667589,
  [SMALL_STATE(23084)] = 667599,
  [SMALL_STATE(23085)] = 667609,
  [SMALL_STATE(23086)] = 667619,
  [SMALL_STATE(23087)] = 667629,
  [SMALL_STATE(23088)] = 667639,
  [SMALL_STATE(23089)] = 667649,
  [SMALL_STATE(23090)] = 667659,
  [SMALL_STATE(23091)] = 667669,
  [SMALL_STATE(23092)] = 667679,
  [SMALL_STATE(23093)] = 667689,
  [SMALL_STATE(23094)] = 667699,
  [SMALL_STATE(23095)] = 667709,
  [SMALL_STATE(23096)] = 667719,
  [SMALL_STATE(23097)] = 667729,
  [SMALL_STATE(23098)] = 667739,
  [SMALL_STATE(23099)] = 667749,
  [SMALL_STATE(23100)] = 667759,
  [SMALL_STATE(23101)] = 667769,
  [SMALL_STATE(23102)] = 667779,
  [SMALL_STATE(23103)] = 667789,
  [SMALL_STATE(23104)] = 667799,
  [SMALL_STATE(23105)] = 667809,
  [SMALL_STATE(23106)] = 667819,
  [SMALL_STATE(23107)] = 667829,
  [SMALL_STATE(23108)] = 667839,
  [SMALL_STATE(23109)] = 667849,
  [SMALL_STATE(23110)] = 667859,
  [SMALL_STATE(23111)] = 667869,
  [SMALL_STATE(23112)] = 667879,
  [SMALL_STATE(23113)] = 667889,
  [SMALL_STATE(23114)] = 667899,
  [SMALL_STATE(23115)] = 667909,
  [SMALL_STATE(23116)] = 667919,
  [SMALL_STATE(23117)] = 667929,
  [SMALL_STATE(23118)] = 667939,
  [SMALL_STATE(23119)] = 667949,
  [SMALL_STATE(23120)] = 667959,
  [SMALL_STATE(23121)] = 667969,
  [SMALL_STATE(23122)] = 667979,
  [SMALL_STATE(23123)] = 667989,
  [SMALL_STATE(23124)] = 667999,
  [SMALL_STATE(23125)] = 668009,
  [SMALL_STATE(23126)] = 668019,
  [SMALL_STATE(23127)] = 668029,
  [SMALL_STATE(23128)] = 668039,
  [SMALL_STATE(23129)] = 668049,
  [SMALL_STATE(23130)] = 668059,
  [SMALL_STATE(23131)] = 668069,
  [SMALL_STATE(23132)] = 668079,
  [SMALL_STATE(23133)] = 668089,
  [SMALL_STATE(23134)] = 668099,
  [SMALL_STATE(23135)] = 668109,
  [SMALL_STATE(23136)] = 668119,
  [SMALL_STATE(23137)] = 668129,
  [SMALL_STATE(23138)] = 668139,
  [SMALL_STATE(23139)] = 668149,
  [SMALL_STATE(23140)] = 668159,
  [SMALL_STATE(23141)] = 668169,
  [SMALL_STATE(23142)] = 668179,
  [SMALL_STATE(23143)] = 668189,
  [SMALL_STATE(23144)] = 668199,
  [SMALL_STATE(23145)] = 668209,
  [SMALL_STATE(23146)] = 668219,
  [SMALL_STATE(23147)] = 668229,
  [SMALL_STATE(23148)] = 668239,
  [SMALL_STATE(23149)] = 668249,
  [SMALL_STATE(23150)] = 668259,
  [SMALL_STATE(23151)] = 668269,
  [SMALL_STATE(23152)] = 668279,
  [SMALL_STATE(23153)] = 668289,
  [SMALL_STATE(23154)] = 668299,
  [SMALL_STATE(23155)] = 668309,
  [SMALL_STATE(23156)] = 668319,
  [SMALL_STATE(23157)] = 668329,
  [SMALL_STATE(23158)] = 668339,
  [SMALL_STATE(23159)] = 668349,
  [SMALL_STATE(23160)] = 668359,
  [SMALL_STATE(23161)] = 668369,
  [SMALL_STATE(23162)] = 668379,
  [SMALL_STATE(23163)] = 668389,
  [SMALL_STATE(23164)] = 668399,
  [SMALL_STATE(23165)] = 668409,
  [SMALL_STATE(23166)] = 668419,
  [SMALL_STATE(23167)] = 668429,
  [SMALL_STATE(23168)] = 668439,
  [SMALL_STATE(23169)] = 668449,
  [SMALL_STATE(23170)] = 668459,
  [SMALL_STATE(23171)] = 668469,
  [SMALL_STATE(23172)] = 668479,
  [SMALL_STATE(23173)] = 668489,
  [SMALL_STATE(23174)] = 668499,
  [SMALL_STATE(23175)] = 668509,
  [SMALL_STATE(23176)] = 668519,
  [SMALL_STATE(23177)] = 668529,
  [SMALL_STATE(23178)] = 668539,
  [SMALL_STATE(23179)] = 668549,
  [SMALL_STATE(23180)] = 668559,
  [SMALL_STATE(23181)] = 668569,
  [SMALL_STATE(23182)] = 668579,
  [SMALL_STATE(23183)] = 668589,
  [SMALL_STATE(23184)] = 668599,
  [SMALL_STATE(23185)] = 668609,
  [SMALL_STATE(23186)] = 668619,
  [SMALL_STATE(23187)] = 668629,
  [SMALL_STATE(23188)] = 668639,
  [SMALL_STATE(23189)] = 668649,
  [SMALL_STATE(23190)] = 668659,
  [SMALL_STATE(23191)] = 668669,
  [SMALL_STATE(23192)] = 668679,
  [SMALL_STATE(23193)] = 668689,
  [SMALL_STATE(23194)] = 668699,
  [SMALL_STATE(23195)] = 668709,
  [SMALL_STATE(23196)] = 668719,
  [SMALL_STATE(23197)] = 668729,
  [SMALL_STATE(23198)] = 668739,
  [SMALL_STATE(23199)] = 668749,
  [SMALL_STATE(23200)] = 668759,
  [SMALL_STATE(23201)] = 668769,
  [SMALL_STATE(23202)] = 668779,
  [SMALL_STATE(23203)] = 668789,
  [SMALL_STATE(23204)] = 668799,
  [SMALL_STATE(23205)] = 668809,
  [SMALL_STATE(23206)] = 668819,
  [SMALL_STATE(23207)] = 668829,
  [SMALL_STATE(23208)] = 668839,
  [SMALL_STATE(23209)] = 668849,
  [SMALL_STATE(23210)] = 668859,
  [SMALL_STATE(23211)] = 668869,
  [SMALL_STATE(23212)] = 668879,
  [SMALL_STATE(23213)] = 668889,
  [SMALL_STATE(23214)] = 668899,
  [SMALL_STATE(23215)] = 668909,
  [SMALL_STATE(23216)] = 668919,
  [SMALL_STATE(23217)] = 668929,
  [SMALL_STATE(23218)] = 668939,
  [SMALL_STATE(23219)] = 668949,
  [SMALL_STATE(23220)] = 668959,
  [SMALL_STATE(23221)] = 668969,
  [SMALL_STATE(23222)] = 668979,
  [SMALL_STATE(23223)] = 668989,
  [SMALL_STATE(23224)] = 668999,
  [SMALL_STATE(23225)] = 669009,
  [SMALL_STATE(23226)] = 669019,
  [SMALL_STATE(23227)] = 669029,
  [SMALL_STATE(23228)] = 669039,
  [SMALL_STATE(23229)] = 669049,
  [SMALL_STATE(23230)] = 669059,
  [SMALL_STATE(23231)] = 669069,
  [SMALL_STATE(23232)] = 669079,
  [SMALL_STATE(23233)] = 669089,
  [SMALL_STATE(23234)] = 669099,
  [SMALL_STATE(23235)] = 669109,
  [SMALL_STATE(23236)] = 669119,
  [SMALL_STATE(23237)] = 669129,
  [SMALL_STATE(23238)] = 669139,
  [SMALL_STATE(23239)] = 669149,
  [SMALL_STATE(23240)] = 669159,
  [SMALL_STATE(23241)] = 669169,
  [SMALL_STATE(23242)] = 669179,
  [SMALL_STATE(23243)] = 669189,
  [SMALL_STATE(23244)] = 669199,
  [SMALL_STATE(23245)] = 669209,
  [SMALL_STATE(23246)] = 669219,
  [SMALL_STATE(23247)] = 669229,
  [SMALL_STATE(23248)] = 669239,
  [SMALL_STATE(23249)] = 669249,
  [SMALL_STATE(23250)] = 669259,
  [SMALL_STATE(23251)] = 669269,
  [SMALL_STATE(23252)] = 669279,
  [SMALL_STATE(23253)] = 669289,
  [SMALL_STATE(23254)] = 669299,
  [SMALL_STATE(23255)] = 669309,
  [SMALL_STATE(23256)] = 669319,
  [SMALL_STATE(23257)] = 669329,
  [SMALL_STATE(23258)] = 669339,
  [SMALL_STATE(23259)] = 669349,
  [SMALL_STATE(23260)] = 669359,
  [SMALL_STATE(23261)] = 669369,
  [SMALL_STATE(23262)] = 669379,
  [SMALL_STATE(23263)] = 669389,
  [SMALL_STATE(23264)] = 669399,
  [SMALL_STATE(23265)] = 669409,
  [SMALL_STATE(23266)] = 669419,
  [SMALL_STATE(23267)] = 669429,
  [SMALL_STATE(23268)] = 669439,
  [SMALL_STATE(23269)] = 669449,
  [SMALL_STATE(23270)] = 669459,
  [SMALL_STATE(23271)] = 669469,
  [SMALL_STATE(23272)] = 669479,
  [SMALL_STATE(23273)] = 669489,
  [SMALL_STATE(23274)] = 669499,
  [SMALL_STATE(23275)] = 669509,
  [SMALL_STATE(23276)] = 669519,
  [SMALL_STATE(23277)] = 669529,
  [SMALL_STATE(23278)] = 669539,
  [SMALL_STATE(23279)] = 669549,
  [SMALL_STATE(23280)] = 669559,
  [SMALL_STATE(23281)] = 669569,
  [SMALL_STATE(23282)] = 669579,
  [SMALL_STATE(23283)] = 669589,
  [SMALL_STATE(23284)] = 669599,
  [SMALL_STATE(23285)] = 669609,
  [SMALL_STATE(23286)] = 669619,
  [SMALL_STATE(23287)] = 669629,
  [SMALL_STATE(23288)] = 669639,
  [SMALL_STATE(23289)] = 669649,
  [SMALL_STATE(23290)] = 669659,
  [SMALL_STATE(23291)] = 669669,
  [SMALL_STATE(23292)] = 669679,
  [SMALL_STATE(23293)] = 669689,
  [SMALL_STATE(23294)] = 669699,
  [SMALL_STATE(23295)] = 669709,
  [SMALL_STATE(23296)] = 669719,
  [SMALL_STATE(23297)] = 669729,
  [SMALL_STATE(23298)] = 669739,
  [SMALL_STATE(23299)] = 669749,
  [SMALL_STATE(23300)] = 669759,
  [SMALL_STATE(23301)] = 669769,
  [SMALL_STATE(23302)] = 669779,
  [SMALL_STATE(23303)] = 669789,
  [SMALL_STATE(23304)] = 669799,
  [SMALL_STATE(23305)] = 669809,
  [SMALL_STATE(23306)] = 669819,
  [SMALL_STATE(23307)] = 669829,
  [SMALL_STATE(23308)] = 669839,
  [SMALL_STATE(23309)] = 669849,
  [SMALL_STATE(23310)] = 669859,
  [SMALL_STATE(23311)] = 669869,
  [SMALL_STATE(23312)] = 669879,
  [SMALL_STATE(23313)] = 669889,
  [SMALL_STATE(23314)] = 669899,
  [SMALL_STATE(23315)] = 669909,
  [SMALL_STATE(23316)] = 669919,
  [SMALL_STATE(23317)] = 669929,
  [SMALL_STATE(23318)] = 669939,
  [SMALL_STATE(23319)] = 669949,
  [SMALL_STATE(23320)] = 669959,
  [SMALL_STATE(23321)] = 669969,
  [SMALL_STATE(23322)] = 669979,
  [SMALL_STATE(23323)] = 669989,
  [SMALL_STATE(23324)] = 669999,
  [SMALL_STATE(23325)] = 670009,
  [SMALL_STATE(23326)] = 670019,
  [SMALL_STATE(23327)] = 670029,
  [SMALL_STATE(23328)] = 670039,
  [SMALL_STATE(23329)] = 670049,
  [SMALL_STATE(23330)] = 670059,
  [SMALL_STATE(23331)] = 670069,
  [SMALL_STATE(23332)] = 670079,
  [SMALL_STATE(23333)] = 670089,
  [SMALL_STATE(23334)] = 670099,
  [SMALL_STATE(23335)] = 670109,
  [SMALL_STATE(23336)] = 670119,
  [SMALL_STATE(23337)] = 670129,
  [SMALL_STATE(23338)] = 670139,
  [SMALL_STATE(23339)] = 670149,
  [SMALL_STATE(23340)] = 670159,
  [SMALL_STATE(23341)] = 670169,
  [SMALL_STATE(23342)] = 670179,
  [SMALL_STATE(23343)] = 670189,
  [SMALL_STATE(23344)] = 670199,
  [SMALL_STATE(23345)] = 670209,
  [SMALL_STATE(23346)] = 670219,
  [SMALL_STATE(23347)] = 670229,
  [SMALL_STATE(23348)] = 670239,
  [SMALL_STATE(23349)] = 670249,
  [SMALL_STATE(23350)] = 670259,
  [SMALL_STATE(23351)] = 670269,
  [SMALL_STATE(23352)] = 670279,
  [SMALL_STATE(23353)] = 670289,
  [SMALL_STATE(23354)] = 670299,
  [SMALL_STATE(23355)] = 670309,
  [SMALL_STATE(23356)] = 670319,
  [SMALL_STATE(23357)] = 670329,
  [SMALL_STATE(23358)] = 670339,
  [SMALL_STATE(23359)] = 670349,
  [SMALL_STATE(23360)] = 670359,
  [SMALL_STATE(23361)] = 670369,
  [SMALL_STATE(23362)] = 670379,
  [SMALL_STATE(23363)] = 670389,
  [SMALL_STATE(23364)] = 670399,
  [SMALL_STATE(23365)] = 670409,
  [SMALL_STATE(23366)] = 670419,
  [SMALL_STATE(23367)] = 670429,
  [SMALL_STATE(23368)] = 670439,
  [SMALL_STATE(23369)] = 670449,
  [SMALL_STATE(23370)] = 670459,
  [SMALL_STATE(23371)] = 670469,
  [SMALL_STATE(23372)] = 670479,
  [SMALL_STATE(23373)] = 670489,
  [SMALL_STATE(23374)] = 670499,
  [SMALL_STATE(23375)] = 670509,
  [SMALL_STATE(23376)] = 670519,
  [SMALL_STATE(23377)] = 670529,
  [SMALL_STATE(23378)] = 670539,
  [SMALL_STATE(23379)] = 670549,
  [SMALL_STATE(23380)] = 670559,
  [SMALL_STATE(23381)] = 670569,
  [SMALL_STATE(23382)] = 670579,
  [SMALL_STATE(23383)] = 670589,
  [SMALL_STATE(23384)] = 670599,
  [SMALL_STATE(23385)] = 670609,
  [SMALL_STATE(23386)] = 670619,
  [SMALL_STATE(23387)] = 670629,
  [SMALL_STATE(23388)] = 670639,
  [SMALL_STATE(23389)] = 670649,
  [SMALL_STATE(23390)] = 670659,
  [SMALL_STATE(23391)] = 670669,
  [SMALL_STATE(23392)] = 670679,
  [SMALL_STATE(23393)] = 670689,
  [SMALL_STATE(23394)] = 670699,
  [SMALL_STATE(23395)] = 670709,
  [SMALL_STATE(23396)] = 670719,
  [SMALL_STATE(23397)] = 670729,
  [SMALL_STATE(23398)] = 670739,
  [SMALL_STATE(23399)] = 670749,
  [SMALL_STATE(23400)] = 670759,
  [SMALL_STATE(23401)] = 670769,
  [SMALL_STATE(23402)] = 670779,
  [SMALL_STATE(23403)] = 670789,
  [SMALL_STATE(23404)] = 670799,
  [SMALL_STATE(23405)] = 670809,
  [SMALL_STATE(23406)] = 670819,
  [SMALL_STATE(23407)] = 670829,
  [SMALL_STATE(23408)] = 670839,
  [SMALL_STATE(23409)] = 670849,
  [SMALL_STATE(23410)] = 670859,
  [SMALL_STATE(23411)] = 670869,
  [SMALL_STATE(23412)] = 670879,
  [SMALL_STATE(23413)] = 670889,
  [SMALL_STATE(23414)] = 670899,
  [SMALL_STATE(23415)] = 670909,
  [SMALL_STATE(23416)] = 670919,
  [SMALL_STATE(23417)] = 670929,
  [SMALL_STATE(23418)] = 670939,
  [SMALL_STATE(23419)] = 670949,
  [SMALL_STATE(23420)] = 670959,
  [SMALL_STATE(23421)] = 670969,
  [SMALL_STATE(23422)] = 670979,
  [SMALL_STATE(23423)] = 670989,
  [SMALL_STATE(23424)] = 670999,
  [SMALL_STATE(23425)] = 671009,
  [SMALL_STATE(23426)] = 671019,
  [SMALL_STATE(23427)] = 671029,
  [SMALL_STATE(23428)] = 671039,
  [SMALL_STATE(23429)] = 671049,
  [SMALL_STATE(23430)] = 671059,
  [SMALL_STATE(23431)] = 671069,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5258),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13827),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13287),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13932),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17560),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20273),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14477),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15122),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14510),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23359),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12361),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20260),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17878),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17879),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11226),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14339),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23383),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22008),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3771),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13774),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22078),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13429),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20796),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14539),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14538),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22179),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12765),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20355),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20775),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19881),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11424),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14361),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22335),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21651),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21591),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13653),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13484),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20687),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14180),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14224),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22090),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12535),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20366),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18580),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19971),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22331),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11444),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14371),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 3),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 2),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22000),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4143),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14184),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13567),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20367),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13877),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20833),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18125),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11368),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8482),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14232),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11675),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14524),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20708),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11002),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14244),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20743),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12547),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14514),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20731),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12273),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14202),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20639),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14329),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20830),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14252),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20686),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10720),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11928),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14334),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20873),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14297),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20793),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14326),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20806),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11974),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14304),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20631),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14250),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20757),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10569),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11698),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14525),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20698),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10486),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14475),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20772),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14799),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22981),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20000),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18372),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8674),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18403),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18122),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8473),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19612),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14766),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18900),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17948),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13958),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18846),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13806),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18312),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14259),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19069),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14823),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18186),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9118),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19371),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17840),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18225),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15208),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18067),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19623),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18762),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19218),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14547),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19803),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9220),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19138),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19653),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15309),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19404),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19056),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9190),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19080),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14889),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19381),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15145),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19324),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8282),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18500),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9629),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19099),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9314),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19833),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13636),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14268),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20774),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18790),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11162),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14401),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11599),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11625),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11757),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12752),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10926),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11209),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12398),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12198),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12117),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11990),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11095),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12617),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12363),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12163),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5246),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13575),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13605),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14710),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20861),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18666),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11341),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14240),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22265),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22930),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12782),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22415),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12876),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21848),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12613),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12223),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22577),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12139),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10981),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13534),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22867),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10992),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22636),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22892),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13050),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23051),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13193),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23209),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23333),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13155),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13381),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23350),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13312),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23062),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6273),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10658),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22870),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10681),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22687),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23080),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20506),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13061),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22523),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13063),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20416),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22393),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12121),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23132),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13527),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22262),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12243),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13242),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13621),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13073),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22137),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12838),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13021),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13414),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21993),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12894),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21852),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13170),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12208),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21707),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12146),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23108),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13772),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22132),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6435),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12575),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22513),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21533),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12661),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22578),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13434),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21376),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11659),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21419),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11638),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22004),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11167),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22552),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21316),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19364),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22372),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11175),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20088),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22116),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21792),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13255),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13029),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21569),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11301),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22303),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11333),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21620),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10709),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22189),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10742),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21374),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22761),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21363),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22079),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21512),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6142),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21565),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21578),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12871),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12577),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4657),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5149),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14274),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20690),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17847),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11186),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14331),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12632),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11344),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10641),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10670),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12638),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5906),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20554),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11361),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14312),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13526),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20683),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13388),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13333),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13171),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12914),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8356),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13277),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6211),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11171),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9215),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14583),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11159),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15613),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13133),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13042),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14913),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12212),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12246),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8560),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11078),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13634),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10962),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15912),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12309),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12889),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12967),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12202),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6977),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13798),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9672),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13820),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9510),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9631),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12962),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12919),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14042),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13121),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13107),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9174),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12854),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13071),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18748),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9008),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8821),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9357),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10753),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10405),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6414),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12605),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13391),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12391),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14825),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13334),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9813),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15292),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12703),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14847),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12718),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10774),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12802),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12836),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14035),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14776),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12930),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13078),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18988),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11579),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11555),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15013),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5058),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5797),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13593),
  [1405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 1), REDUCE(aux_sym__pat_unboxed_sum_repeat1, 1),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14756),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20699),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18162),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11184),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14288),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_unboxed_sum_repeat1, 1),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4453),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12313),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13791),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20807),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18255),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11433),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14187),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9662),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12039),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10747),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11670),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15184),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12587),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8552),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10529),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14522),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9325),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14590),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8352),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15046),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14562),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11927),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8291),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15218),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9011),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14549),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10342),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14784),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9643),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8709),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14797),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9151),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13683),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8556),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9234),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11050),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12002),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10488),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14091),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5279),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14670),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18561),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11243),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14436),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4210),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14262),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20652),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12204),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14147),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20619),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14335),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20610),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10843),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14309),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20550),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12694),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14191),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20537),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14269),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20662),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14356),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20469),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14515),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20719),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11568),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14429),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20450),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14166),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20522),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12853),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14157),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20517),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12772),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14394),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20473),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11765),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14466),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20557),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14164),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20605),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11663),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14375),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20456),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14363),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20513),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12551),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14219),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20493),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14415),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20567),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14195),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20582),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11439),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14378),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20439),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12177),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14170),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20595),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11964),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14246),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20481),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12798),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14143),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20507),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14205),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20645),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14151),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20500),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14542),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20574),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14485),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20679),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14236),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20489),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14186),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20587),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14362),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20462),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14461),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20546),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14490),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20442),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3805),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 1),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 1),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [1868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(3740),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13600),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13596),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20578),
  [1889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1),
  [1892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1),
  [1895] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(3740),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [1905] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(3723),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13763),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [1915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(3723),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1932] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4160),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13851),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13678),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20606),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19671),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11393),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14302),
  [1960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4160),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [1967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4080),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13698),
  [1972] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4080),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4448),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4275),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13720),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [1991] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4275),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7512),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21934),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16363),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9975),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13834),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13834),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20047),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11453),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22985),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19599),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14197),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13115),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10639),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12664),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12688),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10870),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12706),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10615),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12345),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12430),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12046),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11785),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22814),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22793),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18028),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12591),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4669),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [2125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4445),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13855),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13737),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20443),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19366),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11367),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14384),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12859),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11023),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11404),
  [2162] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4445),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12757),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11629),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12916),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12044),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23187),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10952),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13406),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12270),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22564),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11949),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4775),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2214] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4515),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13843),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13694),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20612),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19641),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11391),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14289),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5237),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [2256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4623),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13677),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13813),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20470),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19696),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11484),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14536),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4889),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [2297] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4688),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13707),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13769),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20526),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19995),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11501),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14472),
  [2325] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4623),
  [2329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4515),
  [2332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4658),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13782),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4688),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [2354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4581),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13808),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13831),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20490),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19790),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11512),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14513),
  [2381] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4658),
  [2385] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4581),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21692),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21690),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19575),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22813),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21525),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7777),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21526),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19135),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21932),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21752),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21747),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19590),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21330),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21331),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19278),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23259),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23258),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22680),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22690),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20012),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4858),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [2451] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4577),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13849),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13828),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20653),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23422),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23424),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18624),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22760),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22678),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17940),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21749),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21750),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18971),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22516),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22518),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18037),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21811),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21809),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19615),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22315),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22312),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19785),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23426),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23428),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20078),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22379),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22384),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19923),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [2539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4577),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21777),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21778),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18945),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21441),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21442),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19197),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22357),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22351),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19799),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [2574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4621),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13731),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13853),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20501),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23273),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23299),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22683),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22682),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21301),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21300),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19593),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22218),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22226),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19863),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23161),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23159),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20010),
  [2627] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4621),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22912),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22936),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20124),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5594),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5632),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4880),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13730),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13583),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20588),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19821),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11412),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14349),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21833),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21834),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18889),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19447),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21357),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21358),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19254),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21927),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7285),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21925),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19650),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5821),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [2714] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4762),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13854),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22543),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7989),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22541),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19873),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21868),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21860),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19633),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21485),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21479),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19491),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7594),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5685),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [2764] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5117),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13713),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13687),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20548),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20043),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11497),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14462),
  [2792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5117),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5682),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5406),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [2809] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4776),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13785),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13862),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20666),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18397),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11212),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14393),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23406),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23407),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20094),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5283),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [2859] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4781),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13726),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13860),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20681),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18159),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11183),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14449),
  [2887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4762),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18543),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5844),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [2910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5164),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13672),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13866),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20515),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19949),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11508),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14482),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22001),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22002),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18826),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23332),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23329),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21721),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21722),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18980),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23230),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23223),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23185),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8083),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23186),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20180),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19337),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7142),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18305),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21469),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21470),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19169),
  [2985] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4880),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22697),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22694),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19937),
  [2997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4781),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22055),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22056),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18785),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22823),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22829),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20096),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21708),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7736),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21706),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19769),
  [3024] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5164),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21429),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21428),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19563),
  [3036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4776),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19389),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22029),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22030),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18806),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21505),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21507),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18507),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8198),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12730),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12293),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21458),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9635),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22663),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19948),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11840),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6213),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [3103] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5464),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13648),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18377),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11491),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14178),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11446),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13212),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10472),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12850),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12508),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12247),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4751),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [3149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4589),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13864),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [3172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5870),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13692),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13577),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20584),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19851),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11421),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14359),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12023),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10751),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12568),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12153),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [3219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5464),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11870),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12668),
  [3226] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4589),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11726),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10904),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12027),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 2, .production_id = 21),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11693),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [3250] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5870),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22542),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11901),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11828),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11109),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10557),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5818),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [3270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [3272] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5017),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13657),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13829),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [3288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20722),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 1),
  [3300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5017),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 1),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22268),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22267),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19764),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11743),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22305),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22302),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11747),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10616),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10619),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11705),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22403),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22402),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19818),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22419),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22422),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19960),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10590),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22448),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22440),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19835),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22479),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22477),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19856),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10591),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22083),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9785),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22081),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19709),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12865),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22595),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22590),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19899),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12866),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22646),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22643),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19921),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22196),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9508),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22151),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19745),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7949),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5864),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22429),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22428),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19019),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13138),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13140),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10661),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21902),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21909),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22742),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22732),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19965),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22798),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22797),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12657),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10622),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12656),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22856),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22853),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19985),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22573),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22571),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18781),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12908),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13162),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8104),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5993),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12776),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13157),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21720),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21731),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22157),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22022),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19727),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12233),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22925),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22898),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12469),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22108),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22107),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19413),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23033),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23030),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12467),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12441),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12442),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12271),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23213),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23212),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20036),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13205),
  [3563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10663),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10754),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10754),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10761),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minus, 1, .production_id = 11),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10675),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13824),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20238),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20758),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19699),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11499),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14411),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13225),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12500),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12502),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12272),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23345),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23342),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20060),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10968),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22098),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22099),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18253),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23394),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23393),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22186),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22181),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19257),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22752),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22750),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10971),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11852),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23415),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23414),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22804),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9255),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22785),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19217),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11001),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23365),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23366),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20119),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21432),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11019),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23304),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23313),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20138),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22934),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22933),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18662),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12457),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12458),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23238),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23243),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20167),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23002),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23000),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18146),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12674),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12676),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12673),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22229),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22228),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19046),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22027),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9371),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22026),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19689),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23035),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23075),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20152),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12948),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22745),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22759),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20068),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11945),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12076),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22626),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22628),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19983),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22240),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22242),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21973),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17046),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21974),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18842),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21945),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15771),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21946),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18861),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21917),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21918),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22425),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22544),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19953),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21889),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21890),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22460),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22463),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12305),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12306),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22304),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22316),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19893),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21861),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21862),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13055),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6063),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22124),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22135),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21805),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21295),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18911),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11829),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11825),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22039),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22041),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19773),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10656),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21984),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16175),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21983),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19668),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7056),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21966),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21970),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22046),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22045),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10853),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10882),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21886),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21769),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19743),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21693),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21694),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19008),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22445),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22444),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18615),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10799),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21787),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9191),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21789),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19713),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12431),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12432),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10664),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10786),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12561),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22355),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22360),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18139),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21700),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16745),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21703),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19683),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21648),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21644),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19554),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23113),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9849),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23110),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18424),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12571),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21592),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21588),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19534),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13251),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12529),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13252),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21956),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21963),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6462),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21623),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21624),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11645),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21893),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21892),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19468),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11831),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6461),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11808),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11494),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11493),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21550),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21546),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19511),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12096),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21665),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20186),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21666),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19034),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21637),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21638),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12159),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12157),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11419),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11417),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21433),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21430),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19465),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11079),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21310),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21320),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11155),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21609),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21610),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21581),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21582),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23170),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23150),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21561),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21563),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13363),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22842),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22869),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12696),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12716),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21397),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21392),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19425),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13284),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12423),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12401),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21553),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21554),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19117),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7794),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12509),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12483),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21497),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21498),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19148),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21297),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9758),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21298),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19359),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13543),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11679),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7744),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11118),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11117),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22341),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22339),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18730),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13550),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21413),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21414),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19211),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11456),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10868),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12731),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7870),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12126),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21456),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12724),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6956),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22795),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22791),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17888),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21317),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14681),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21318),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19304),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11886),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11887),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23008),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23009),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22852),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9988),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22857),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17870),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12434),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12422),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22560),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22558),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11936),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11937),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21759),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21757),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19501),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21812),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21798),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18925),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11830),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11812),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12742),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21459),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9499),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21462),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20149),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21385),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21386),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19231),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12063),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21584),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15267),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21580),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19533),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12064),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10558),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13748),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20460),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20735),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6904),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11999),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12007),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12817),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11871),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11601),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12477),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [4455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10242),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10563),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10453),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10453),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10241),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17883),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11211),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14441),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [4499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10889),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11125),
  [4503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10999),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10999),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11068),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10855),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13814),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20397),
  [4525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20746),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20069),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11478),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14177),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10875),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11771),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12301),
  [4543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12321),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12321),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12709),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11710),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13714),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20651),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20640),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19488),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11379),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14263),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [4587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11657),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12572),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12642),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12831),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10496),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11483),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11902),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11863),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11863),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11540),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11347),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13594),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20725),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20632),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19551),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11382),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14277),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12082),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11292),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11709),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11589),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11589),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12090),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11214),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13576),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20521),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20713),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18276),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11200),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14357),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12690),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11779),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12100),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12607),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11878),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12228),
  [4733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12603),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12603),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11635),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19348),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11365),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14207),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11551),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11591),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10703),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11518),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11890),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11961),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11961),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12985),
  [4777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11157),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13775),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20344),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20876),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18006),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11284),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14308),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11488),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11131),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12213),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11373),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11592),
  [4829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12042),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12042),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [4835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11485),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19886),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11524),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14489),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12332),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10425),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10522),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10578),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10578),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10252),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19103),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11336),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14346),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13141),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12609),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11802),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23081),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10359),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18167),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16165),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13880),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17264),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12481),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12484),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12733),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10665),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12310),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12058),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21247),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22879),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21206),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10603),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11938),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11703),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11021),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13151),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11416),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12114),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12677),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12172),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19997),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13558),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12435),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18020),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21368),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19410),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11116),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12860),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22658),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22563),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [5035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14126),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16937),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20755),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21401),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21797),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22565),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22328),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22529),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21985),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18411),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22645),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21562),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23286),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22727),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22575),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18309),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22069),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22470),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21617),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22769),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21059),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23149),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22632),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21304),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22408),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22064),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22536),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23066),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22192),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21590),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21373),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22413),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22123),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22677),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22883),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21676),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21366),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22011),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23248),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22269),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22717),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22945),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21618),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22038),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22780),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22082),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23087),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22395),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21421),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21506),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22154),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22264),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22836),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22059),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21557),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21394),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22794),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21395),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22987),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22010),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22522),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21646),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23126),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23374),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21323),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23199),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21629),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23335),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23336),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21982),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23378),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21719),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22517),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21972),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21478),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21466),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21630),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21568),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23408),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21867),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21450),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23427),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22534),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21625),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22062),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22385),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21534),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21814),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22340),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21674),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21954),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21528),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23412),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21910),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22707),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21338),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23206),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22180),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19004),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21570),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23387),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21926),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21702),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21649),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22009),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18753),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21422),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21898),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22125),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21541),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22243),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21734),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21790),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23324),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23263),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21786),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23198),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22306),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23086),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21803),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21730),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21870),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21907),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22964),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22884),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23048),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21844),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21347),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22695),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22847),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22427),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22293),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22254),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22291),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22781),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22469),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21943),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21872),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21758),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22171),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21398),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21736),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21842),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22407),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22896),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19386),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [5339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [5341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 4),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12627),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20872),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23101),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17494),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 1),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21289),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22508),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15246),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23077),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19469),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22150),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22139),
  [5367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 3),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18263),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21334),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19889),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22613),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17733),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18388),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17636),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16157),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19236),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22633),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22878),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21283),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19950),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17965),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17697),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21188),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19529),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22733),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18151),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15868),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15259),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15871),
  [5431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19419),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17649),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19864),
  [5439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [5441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12297),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19877),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17675),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19456),
  [5449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [5451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_apply, 2),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [5461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [5463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4197),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10012),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [5475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_apply, 2),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18287),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11496),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14150),
  [5483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__btype, 1),
  [5485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4197),
  [5488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10012),
  [5491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__btype, 1),
  [5493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4232),
  [5496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2),
  [5498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4298),
  [5501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4291),
  [5504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4291),
  [5507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2106),
  [5510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(994),
  [5513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4197),
  [5516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2262),
  [5519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10012),
  [5522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4297),
  [5525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3921),
  [5528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2),
  [5530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18287),
  [5533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11496),
  [5536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14150),
  [5539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9530),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atype, 1),
  [5544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9397),
  [5547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9601),
  [5550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9601),
  [5553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2194),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, .production_id = 14),
  [5558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1242),
  [5561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8684),
  [5564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2357),
  [5567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9947),
  [5570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9396),
  [5573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atype, 1),
  [5575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19434),
  [5578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11375),
  [5581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14255),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17880),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23107),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18075),
  [5598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4702),
  [5601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4704),
  [5604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4650),
  [5607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4650),
  [5610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2205),
  [5613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1212),
  [5616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4417),
  [5619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2370),
  [5622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10192),
  [5625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4701),
  [5628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4034),
  [5631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19678),
  [5634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11428),
  [5637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14290),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22903),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21277),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4702),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4650),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [5656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4417),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [5661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10192),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19678),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11428),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14290),
  [5674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4417),
  [5677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10192),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21156),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23284),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20109),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19268),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7786),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7634),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7634),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17495),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9870),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19750),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11401),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14235),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8890),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14818),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14447),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12214),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7676),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [5740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14773),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12155),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11306),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8996),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11600),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15478),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9827),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20205),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12507),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17730),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6425),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9972),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14867),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7723),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6184),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8772),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6343),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4841),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [5828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4633),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9973),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19926),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11511),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14483),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15221),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12580),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10268),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7980),
  [5858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4841),
  [5861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4804),
  [5864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4905),
  [5867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4905),
  [5870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2152),
  [5873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(932),
  [5876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4633),
  [5879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2306),
  [5882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9973),
  [5885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4803),
  [5888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3947),
  [5891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19926),
  [5894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11511),
  [5897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14483),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9609),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7985),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10544),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10970),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16234),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15193),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9440),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18230),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14119),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19299),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14679),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12883),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10474),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12364),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15570),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11652),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21057),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8134),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9566),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9117),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18347),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11590),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7043),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9355),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8638),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8028),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9735),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15823),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9577),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8338),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7213),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11868),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14838),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17744),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [6020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4633),
  [6023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9973),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11560),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18955),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9004),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11594),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12074),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9796),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7827),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21199),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13003),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9857),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7706),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9401),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9497),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10795),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10694),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12281),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13590),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11827),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12377),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14564),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10012),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7605),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [6130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5274),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [6135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10110),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19825),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11520),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14494),
  [6148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6067),
  [6151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5908),
  [6154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6018),
  [6157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6018),
  [6160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2208),
  [6163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1134),
  [6166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5274),
  [6169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2259),
  [6172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10110),
  [6175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5907),
  [6178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4074),
  [6181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19825),
  [6184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11520),
  [6187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14494),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17267),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [6200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5274),
  [6203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10110),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8136),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8159),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8159),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [6216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16837),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [6224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9996),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_sum_repeat1, 1),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8054),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18516),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14381),
  [6236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7993),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8139),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8139),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9879),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7971),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20141),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11467),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14402),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5951),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [6270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6299),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [6278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5825),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [6283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9930),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18792),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11188),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14216),
  [6296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5951),
  [6299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6275),
  [6302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6299),
  [6305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6299),
  [6308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2188),
  [6311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1058),
  [6314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5825),
  [6317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2247),
  [6320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9930),
  [6323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6277),
  [6326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3924),
  [6329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18792),
  [6332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11188),
  [6335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14216),
  [6338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5825),
  [6341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9930),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [6346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [6358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5937),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [6363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9899),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18951),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11217),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14336),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14954),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9786),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7906),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7580),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7768),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9470),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9144),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9700),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9725),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [6400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6549),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [6406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [6408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6134),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [6413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9910),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6372),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20102),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11476),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14450),
  [6426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6134),
  [6429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9910),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9408),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6583),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [6448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [6450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6143),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [6455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9913),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20084),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11477),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14454),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6384),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9219),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15745),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [6482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6143),
  [6485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9913),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7969),
  [6490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6386),
  [6493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6371),
  [6496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6549),
  [6499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6549),
  [6502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2104),
  [6505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(966),
  [6508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6134),
  [6511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2344),
  [6514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9910),
  [6517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6372),
  [6520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4068),
  [6523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20102),
  [6526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11476),
  [6529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14450),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8075),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17681),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7871),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [6562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6029),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [6567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10057),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6379),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19203),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11325),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14136),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8233),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20217),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16135),
  [6590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6029),
  [6593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10057),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6573),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [6610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5922),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [6615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9914),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18835),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11176),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14228),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9351),
  [6630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9530),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8645),
  [6637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5922),
  [6640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9914),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8179),
  [6647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6396),
  [6650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6336),
  [6653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6583),
  [6656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6583),
  [6659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2105),
  [6662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(961),
  [6665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6143),
  [6668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2311),
  [6671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9913),
  [6674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6338),
  [6677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3828),
  [6680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20084),
  [6683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11477),
  [6686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14454),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16304),
  [6691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6552),
  [6694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6546),
  [6697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6573),
  [6700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6573),
  [6703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2197),
  [6706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1063),
  [6709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5922),
  [6712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2277),
  [6715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9914),
  [6718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6547),
  [6721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4029),
  [6724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18835),
  [6727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11176),
  [6730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14228),
  [6733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6383),
  [6736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6530),
  [6739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6612),
  [6742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6612),
  [6745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2206),
  [6748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1076),
  [6751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5937),
  [6754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2337),
  [6757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9899),
  [6760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6529),
  [6763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3889),
  [6766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18951),
  [6769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11217),
  [6772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14336),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15129),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9306),
  [6783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5937),
  [6786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9899),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8112),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6899),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [6801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6559),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [6805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6393),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [6813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5921),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [6818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9925),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18816),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11160),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14221),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9375),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8135),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8109),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7459),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [6855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6559),
  [6858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6376),
  [6861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6393),
  [6864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6393),
  [6867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2076),
  [6870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1059),
  [6873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5921),
  [6876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2265),
  [6879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9925),
  [6882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6377),
  [6885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4002),
  [6888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18816),
  [6891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11160),
  [6894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14221),
  [6897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6502),
  [6900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6380),
  [6903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6486),
  [6906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6486),
  [6909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2090),
  [6912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1143),
  [6915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6029),
  [6918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2375),
  [6921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10057),
  [6924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6379),
  [6927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3956),
  [6930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19203),
  [6933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11325),
  [6936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14136),
  [6939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5921),
  [6942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9925),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10188),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6799),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [6951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6744),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [6957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [6959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6572),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [6964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9905),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18974),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11218),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14351),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6797),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7030),
  [6981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6695),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [6989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6472),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [6994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9977),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19910),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11515),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14484),
  [7007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6712),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [7011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6920),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6920),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [7017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [7019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6518),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [7024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9876),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20175),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11471),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14405),
  [7037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7001),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [7049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6476),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [7054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10002),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6679),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18833),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11270),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14541),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6962),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6962),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [7077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [7079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6460),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [7084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10073),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19220),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11326),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14233),
  [7097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6518),
  [7100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9876),
  [7103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6799),
  [7106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6848),
  [7109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6744),
  [7112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6744),
  [7115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2166),
  [7118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1081),
  [7121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6572),
  [7124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2324),
  [7127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9905),
  [7130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6850),
  [7133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3897),
  [7136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18974),
  [7139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11218),
  [7142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14351),
  [7145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6942),
  [7148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6677),
  [7151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7001),
  [7154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7001),
  [7157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2091),
  [7160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1302),
  [7163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6476),
  [7166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2229),
  [7169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10002),
  [7172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6679),
  [7175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3903),
  [7178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18833),
  [7181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11270),
  [7184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14541),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [7191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6769),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6769),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [7197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [7199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6617),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [7204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10166),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19474),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11392),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14227),
  [7217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6678),
  [7220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6961),
  [7223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6769),
  [7226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6769),
  [7229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2094),
  [7232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1249),
  [7235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6617),
  [7238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2379),
  [7241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10166),
  [7244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6963),
  [7247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3987),
  [7250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19474),
  [7253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11392),
  [7256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14227),
  [7259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6712),
  [7262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6886),
  [7265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6920),
  [7268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6920),
  [7271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2085),
  [7274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(978),
  [7277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6518),
  [7280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2359),
  [7283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9876),
  [7286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6893),
  [7289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4020),
  [7292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20175),
  [7295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11471),
  [7298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14405),
  [7301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6476),
  [7304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10002),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [7311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6839),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [7317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [7319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6590),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [7324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10173),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7006),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19498),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11394),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14213),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6669),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [7349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6475),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [7354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9891),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [7359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18931),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11208),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14330),
  [7367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6572),
  [7370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9905),
  [7373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6694),
  [7376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6773),
  [7379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6669),
  [7382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6669),
  [7385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2062),
  [7388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1072),
  [7391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6475),
  [7394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2355),
  [7397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9891),
  [7400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6774),
  [7403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3882),
  [7406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18931),
  [7409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11208),
  [7412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14330),
  [7415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8019),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [7419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7965),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7965),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [7425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17704),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7669),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9956),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19761),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11398),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14340),
  [7443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6966),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6901),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [7455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6520),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [7460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10022),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19157),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11317),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14376),
  [7473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6590),
  [7476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10173),
  [7479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6460),
  [7482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10073),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [7489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9192),
  [7492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1),
  [7494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9037),
  [7497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9126),
  [7500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9126),
  [7503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2092),
  [7506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12),
  [7508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(1290),
  [7511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8804),
  [7514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2251),
  [7517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(10037),
  [7520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16708),
  [7522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9032),
  [7525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_constructor, 1),
  [7527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(19177),
  [7530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modid, 1, .production_id = 2),
  [7532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(11324),
  [7535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(14347),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [7542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6797),
  [7545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7030),
  [7548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6695),
  [7551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6695),
  [7554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2163),
  [7557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(928),
  [7560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6472),
  [7563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2296),
  [7566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9977),
  [7569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6984),
  [7572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3979),
  [7575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19910),
  [7578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11515),
  [7581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14484),
  [7584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8929),
  [7587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9056),
  [7590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9265),
  [7593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9265),
  [7596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2077),
  [7599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(1133),
  [7602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8719),
  [7605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2339),
  [7608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9931),
  [7611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16973),
  [7613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9057),
  [7616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(20029),
  [7619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(11523),
  [7622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(14383),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [7629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6520),
  [7632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10022),
  [7635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6475),
  [7638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9891),
  [7641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6867),
  [7644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6966),
  [7647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6901),
  [7650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6901),
  [7653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2132),
  [7656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1123),
  [7659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6520),
  [7662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2348),
  [7665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10022),
  [7668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6945),
  [7671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3964),
  [7674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19157),
  [7677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11317),
  [7680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14376),
  [7683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6684),
  [7686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7007),
  [7689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6839),
  [7692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6839),
  [7695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2168),
  [7698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1298),
  [7701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6590),
  [7704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2371),
  [7707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10173),
  [7710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7006),
  [7713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3995),
  [7716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19498),
  [7719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11394),
  [7722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14213),
  [7725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6472),
  [7728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9977),
  [7731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6907),
  [7734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6704),
  [7737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6962),
  [7740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6962),
  [7743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2073),
  [7746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1163),
  [7749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6460),
  [7752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2295),
  [7755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10073),
  [7758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6705),
  [7761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3963),
  [7764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19220),
  [7767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11326),
  [7770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14233),
  [7773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6617),
  [7776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10166),
  [7779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17473),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [7785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10002),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17067),
  [7789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8010),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [7793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8033),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [7799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16941),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7837),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9965),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8027),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17990),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11168),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14257),
  [7817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7093),
  [7820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7119),
  [7823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7200),
  [7826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7200),
  [7829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2204),
  [7832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1138),
  [7835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6720),
  [7838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2285),
  [7841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9893),
  [7844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7120),
  [7847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3898),
  [7850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18992),
  [7853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11366),
  [7856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14256),
  [7859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7156),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [7863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7126),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17271),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6837),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [7877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10020),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19141),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14456),
  [7887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16680),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10192),
  [7895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6694),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16799),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [7903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9891),
  [7905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6684),
  [7907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17237),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [7913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10173),
  [7915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [7917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17705),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10057),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [7929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7192),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [7935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [7937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6685),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [7942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10063),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19841),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11479),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14493),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [7957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [7959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6837),
  [7962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10020),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [7967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7623),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [7971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7672),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7672),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [7977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17151),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [7985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10006),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7743),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19124),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11314),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14480),
  [7995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7156),
  [7998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7036),
  [8001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7126),
  [8004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7126),
  [8007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2081),
  [8010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1120),
  [8013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6837),
  [8016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2287),
  [8019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10020),
  [8022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7037),
  [8025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3934),
  [8028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19141),
  [8031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11223),
  [8034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14456),
  [8037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [8039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16820),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [8045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9977),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7059),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [8051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7169),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [8057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [8059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6745),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [8064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9906),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7167),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20113),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11466),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14398),
  [8077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7093),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7200),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [8087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [8089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6720),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [8094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9893),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18992),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11366),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14256),
  [8107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16952),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [8113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9973),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6067),
  [8117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16250),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10110),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17558),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7701),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7649),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7603),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [8137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16541),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10026),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7648),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18278),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11199),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14422),
  [8155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7221),
  [8158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7033),
  [8161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7147),
  [8164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7147),
  [8167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2154),
  [8170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1287),
  [8173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6813),
  [8176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2366),
  [8179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10179),
  [8182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7063),
  [8185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4006),
  [8188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19519),
  [8191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11405),
  [8194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14190),
  [8197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16332),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [8203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9930),
  [8205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7234),
  [8207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16651),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [8213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10063),
  [8215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8110),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7945),
  [8219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7894),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [8225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17718),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [8233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10097),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19411),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11371),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14260),
  [8243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17361),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [8249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9876),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7359),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [8255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7327),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [8261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16960),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7160),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [8269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10184),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19541),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14158),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6552),
  [8281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16549),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [8287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9914),
  [8289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16929),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5937),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9899),
  [8297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6685),
  [8300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10063),
  [8303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7592),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [8307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7628),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [8311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16372),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [8319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10045),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17921),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11161),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14410),
  [8329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7059),
  [8331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17693),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [8337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9906),
  [8339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6837),
  [8342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10020),
  [8345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6396),
  [8347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17261),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [8353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9913),
  [8355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8258),
  [8358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8274),
  [8361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8285),
  [8364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8285),
  [8367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2068),
  [8370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(996),
  [8373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(7964),
  [8376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2318),
  [8379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(10114),
  [8382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16347),
  [8384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8267),
  [8387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(19159),
  [8390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(11319),
  [8393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(14481),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [8400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7355),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [8410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16821),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [8418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10186),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19560),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14148),
  [8428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7484),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [8432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [8438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16677),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [8446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9868),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7420),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18896),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11202),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14264),
  [8456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8108),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [8460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [8466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17069),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7722),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [8474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9955),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20065),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11481),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14457),
  [8484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7781),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7775),
  [8488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7864),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7864),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [8494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17599),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7457),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [8502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10121),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19438),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11383),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14253),
  [8512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16434),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [8518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9925),
  [8520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8239),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8192),
  [8524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8237),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [8530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17822),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8153),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [8538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9950),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19791),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11402),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14345),
  [8548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7963),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [8552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7919),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [8558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16381),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7788),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [8566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10130),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19770),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11510),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14521),
  [8576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7059),
  [8579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7163),
  [8582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7169),
  [8585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7169),
  [8588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2141),
  [8591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(993),
  [8594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6745),
  [8597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2367),
  [8600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9906),
  [8603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7167),
  [8606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3918),
  [8609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20113),
  [8612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11466),
  [8615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14398),
  [8618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17393),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [8624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10022),
  [8626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8013),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8034),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8099),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8099),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16534),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [8644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10165),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19714),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11503),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14535),
  [8654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6678),
  [8656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17480),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [8662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10166),
  [8664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6745),
  [8667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9906),
  [8670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [8672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17057),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [8678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9905),
  [8680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7836),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [8684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [8690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17566),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [8698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10081),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19288),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11339),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14520),
  [8708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7234),
  [8711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7197),
  [8714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7192),
  [8717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7192),
  [8720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2171),
  [8723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1115),
  [8726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6685),
  [8729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2286),
  [8732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10063),
  [8735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7196),
  [8738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4037),
  [8741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19841),
  [8744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11479),
  [8747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14493),
  [8750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6907),
  [8752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17816),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6460),
  [8758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10073),
  [8760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7221),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [8764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7147),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [8770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17099),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [8778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10179),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19519),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11405),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14190),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7583),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [8792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7585),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7585),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [8798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16479),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [8806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9989),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19230),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11355),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14176),
  [8816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6720),
  [8819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9893),
  [8822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6386),
  [8824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17429),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [8830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9910),
  [8832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17307),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [8838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9893),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [8842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [8844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6813),
  [8847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10179),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [8852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6813),
  [8855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10179),
  [8858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7484),
  [8861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7423),
  [8864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7452),
  [8867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7452),
  [8870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2102),
  [8873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1068),
  [8876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7187),
  [8879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2372),
  [8882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9868),
  [8885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7420),
  [8888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3929),
  [8891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18896),
  [8894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11202),
  [8897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14264),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [8902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [8910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [8912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7145),
  [8915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10186),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [8920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [8922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7187),
  [8925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9868),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [8932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [8934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7072),
  [8937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9975),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [8944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [8950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7355),
  [8953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7259),
  [8956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7309),
  [8959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7309),
  [8962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2074),
  [8965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1265),
  [8968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7145),
  [8971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2303),
  [8974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10186),
  [8977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7257),
  [8980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4021),
  [8983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19560),
  [8986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11437),
  [8989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14148),
  [8992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7145),
  [8995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10186),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [9000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [9002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7160),
  [9005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10184),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [9010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7512),
  [9013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7553),
  [9016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7351),
  [9019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7351),
  [9022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2120),
  [9025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(929),
  [9028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7072),
  [9031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2378),
  [9034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9975),
  [9037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7554),
  [9040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4045),
  [9043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20047),
  [9046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11453),
  [9049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14197),
  [9052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7072),
  [9055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9975),
  [9058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7359),
  [9061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7271),
  [9064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7327),
  [9067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7327),
  [9070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2069),
  [9073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1278),
  [9076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7160),
  [9079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2351),
  [9082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10184),
  [9085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7270),
  [9088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4015),
  [9091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19541),
  [9094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11425),
  [9097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14158),
  [9100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7160),
  [9103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10184),
  [9106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7187),
  [9109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9868),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [9114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7400),
  [9117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10045),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [9122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [9124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7493),
  [9127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10006),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [9132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7623),
  [9135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7739),
  [9138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7672),
  [9141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7672),
  [9144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2193),
  [9147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1112),
  [9150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7493),
  [9153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2354),
  [9156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10006),
  [9159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7743),
  [9162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3922),
  [9165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19124),
  [9168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11314),
  [9171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14480),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [9176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [9178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7387),
  [9181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10026),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7583),
  [9188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [9190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7483),
  [9193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9989),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [9198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12075),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11880),
  [9202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11801),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11801),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11562),
  [9210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11257),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [9216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13792),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21030),
  [9224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20562),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20169),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11470),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14404),
  [9232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7786),
  [9235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7799),
  [9238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7634),
  [9241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7634),
  [9244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2142),
  [9247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1207),
  [9250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7406),
  [9253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2275),
  [9256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9870),
  [9259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7798),
  [9262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4011),
  [9265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19750),
  [9268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11401),
  [9271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14235),
  [9274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10861),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10791),
  [9278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10893),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10893),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10804),
  [9286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10699),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [9292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13693),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21155),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20551),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20125),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11475),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14448),
  [9308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12251),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12326),
  [9312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12749),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12749),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12358),
  [9320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11956),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [9326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13690),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [9332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20560),
  [9334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20494),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19804),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14501),
  [9342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11587),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11672),
  [9346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11814),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11814),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11615),
  [9354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [9356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11224),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [9360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13801),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21216),
  [9368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20451),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19390),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11369),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14285),
  [9376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11191),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [9380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11463),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11463),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [9388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [9390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10969),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [9394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13863),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21090),
  [9402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20441),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19105),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11309),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14432),
  [9410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7387),
  [9413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10026),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [9420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7406),
  [9423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9870),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [9428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7483),
  [9431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9989),
  [9434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7592),
  [9437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7589),
  [9440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7628),
  [9443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7628),
  [9446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2099),
  [9449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1050),
  [9452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7400),
  [9455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2269),
  [9458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10045),
  [9461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7590),
  [9464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4019),
  [9467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17921),
  [9470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11161),
  [9473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14410),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12196),
  [9480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [9484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13803),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20630),
  [9492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20646),
  [9494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7400),
  [9497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10045),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [9502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [9504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7343),
  [9507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10081),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [9512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12714),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12175),
  [9516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12597),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12597),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [9522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12534),
  [9524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11767),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [9530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13832),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21287),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20539),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20020),
  [9542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11498),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14463),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11899),
  [9550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [9552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [9554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13710),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20788),
  [9562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20464),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [9566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7781),
  [9569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7775),
  [9572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7864),
  [9575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7864),
  [9578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2187),
  [9581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1226),
  [9584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7457),
  [9587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2294),
  [9590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10121),
  [9593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7773),
  [9596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3982),
  [9599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19438),
  [9602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11383),
  [9605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14253),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [9610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13204),
  [9612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12927),
  [9614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13197),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13197),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [9620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [9622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12533),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19346),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11359),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14508),
  [9634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7836),
  [9637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7854),
  [9640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7771),
  [9643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7771),
  [9646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2167),
  [9649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1240),
  [9652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7343),
  [9655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2243),
  [9658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10081),
  [9661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7859),
  [9664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3966),
  [9667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19288),
  [9670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11339),
  [9673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14520),
  [9676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [9678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7457),
  [9681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10121),
  [9684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [9686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [9688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [9694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11816),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11533),
  [9698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11858),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11858),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12041),
  [9706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11195),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [9712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13711),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20304),
  [9720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20484),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19753),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11509),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14523),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10582),
  [9732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [9736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13784),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [9742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20814),
  [9744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20508),
  [9746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7406),
  [9749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9870),
  [9752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7457),
  [9755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10121),
  [9758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7493),
  [9761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10006),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [9766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [9772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7583),
  [9775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7753),
  [9778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7585),
  [9781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7585),
  [9784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2131),
  [9787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1083),
  [9790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7483),
  [9793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2242),
  [9796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9989),
  [9799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7751),
  [9802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3858),
  [9805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19230),
  [9808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11355),
  [9811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14176),
  [9814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11756),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11636),
  [9818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11664),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11664),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11789),
  [9826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11264),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [9832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13755),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21209),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20457),
  [9842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19454),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11386),
  [9846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14229),
  [9848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12518),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12378),
  [9852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12125),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12125),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12542),
  [9860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11809),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [9866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13701),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20797),
  [9874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20620),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19611),
  [9878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11388),
  [9880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14237),
  [9882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12162),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12421),
  [9886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12686),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12686),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12614),
  [9894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11971),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [9900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13588),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [9906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20385),
  [9908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20476),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19737),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11507),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14527),
  [9916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12606),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12280),
  [9920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12227),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12227),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [9926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12761),
  [9928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [9930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11883),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [9934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13776),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20849),
  [9942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20596),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19701),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11395),
  [9948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14332),
  [9950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7701),
  [9953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7649),
  [9956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7603),
  [9959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7603),
  [9962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2067),
  [9965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1211),
  [9968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7387),
  [9971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2299),
  [9974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10026),
  [9977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7648),
  [9980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3952),
  [9983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18278),
  [9986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11199),
  [9989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14422),
  [9992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7343),
  [9995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10081),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11697),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [10006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13670),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20898),
  [10014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20569),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [10018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [10020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [10022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [10024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [10026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [10030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [10032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13037),
  [10034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13023),
  [10036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12878),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12878),
  [10040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [10042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13201),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [10046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12566),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [10050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13582),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [10054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21060),
  [10058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20518),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19972),
  [10062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11506),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14476),
  [10066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8110),
  [10068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [10070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7769),
  [10073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10097),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [10078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [10080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7788),
  [10083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10130),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [10088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8136),
  [10091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8053),
  [10094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8159),
  [10097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8159),
  [10100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2202),
  [10103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1250),
  [10106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7848),
  [10109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2364),
  [10112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9996),
  [10115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8054),
  [10118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3879),
  [10121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18516),
  [10124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11239),
  [10127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14381),
  [10130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7788),
  [10133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10130),
  [10136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [10138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7837),
  [10141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9965),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [10148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [10150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7669),
  [10153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9956),
  [10156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [10158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [10160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7755),
  [10163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10165),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [10168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8108),
  [10171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8189),
  [10174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8162),
  [10177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8162),
  [10180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2117),
  [10183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(956),
  [10186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7722),
  [10189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2325),
  [10192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9955),
  [10195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8188),
  [10198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3913),
  [10201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20065),
  [10204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11481),
  [10207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14457),
  [10210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7669),
  [10213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9956),
  [10216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7837),
  [10219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9965),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8108),
  [10224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [10226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7722),
  [10229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9955),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [10234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7755),
  [10237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10165),
  [10240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7722),
  [10243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9955),
  [10246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7963),
  [10249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7922),
  [10252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7919),
  [10255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7919),
  [10258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2112),
  [10261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1157),
  [10264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7788),
  [10267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2240),
  [10270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10130),
  [10273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7952),
  [10276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4062),
  [10279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19770),
  [10282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11510),
  [10285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14521),
  [10288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [10290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9952),
  [10292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7769),
  [10295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10097),
  [10298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7993),
  [10301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7973),
  [10304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8139),
  [10307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8139),
  [10310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2160),
  [10313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(989),
  [10316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7685),
  [10319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2369),
  [10322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9879),
  [10325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7971),
  [10328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3962),
  [10331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(20141),
  [10334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11467),
  [10337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14402),
  [10340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [10342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8013),
  [10345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8034),
  [10348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8099),
  [10351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8099),
  [10354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2086),
  [10357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1188),
  [10360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7755),
  [10363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2347),
  [10366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10165),
  [10369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8035),
  [10372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4050),
  [10375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19714),
  [10378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11503),
  [10381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14535),
  [10384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [10386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [10388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8305),
  [10390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__apat, 1),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [10394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8450),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8450),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [10400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [10402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8242),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [10407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13267),
  [10409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [10411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8316),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18969),
  [10415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11312),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14434),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [10423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8019),
  [10426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8073),
  [10429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7965),
  [10432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7965),
  [10435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2146),
  [10438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1060),
  [10441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7669),
  [10444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2280),
  [10447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9956),
  [10450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8071),
  [10453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3831),
  [10456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19761),
  [10459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11398),
  [10462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14340),
  [10465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8010),
  [10468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8026),
  [10471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8033),
  [10474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8033),
  [10477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2113),
  [10480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(957),
  [10483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7837),
  [10486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2283),
  [10489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9965),
  [10492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8027),
  [10495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4027),
  [10498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17990),
  [10501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11168),
  [10504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14257),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [10509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [10511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7848),
  [10514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9996),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [10519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [10521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7848),
  [10524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9996),
  [10527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [10529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7685),
  [10532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9879),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [10537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8110),
  [10540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7945),
  [10543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7894),
  [10546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7894),
  [10549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2195),
  [10552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1243),
  [10555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7769),
  [10558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2260),
  [10561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10097),
  [10564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7947),
  [10567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3976),
  [10570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19411),
  [10573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11371),
  [10576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14260),
  [10579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7685),
  [10582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9879),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15064),
  [10587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8401),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8680),
  [10591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8689),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [10597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [10599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(4274),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13442),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [10608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8706),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19013),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11250),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14431),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [10620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8239),
  [10623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8192),
  [10626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8237),
  [10629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8237),
  [10632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2119),
  [10635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1055),
  [10638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8153),
  [10641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2298),
  [10644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9950),
  [10647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8216),
  [10650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3895),
  [10653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19791),
  [10656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11402),
  [10659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14345),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15568),
  [10664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [10666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(8153),
  [10669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9950),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16164),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16203),
  [10678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(8153),
  [10681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9950),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15475),
  [10686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8409),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8536),
  [10690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8573),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8573),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [10696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [10698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8255),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13360),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [10707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8524),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19869),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11527),
  [10713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14162),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [10719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9932),
  [10722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9934),
  [10725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10103),
  [10728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10103),
  [10731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2097),
  [10734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1261),
  [10737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), REDUCE(sym_constraint, 1, .production_id = 14),
  [10740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9751),
  [10743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2386),
  [10746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9946),
  [10749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9927),
  [10752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(18635),
  [10755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11263),
  [10758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14350),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15059),
  [10763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8305),
  [10766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2),
  [10768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8373),
  [10771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8450),
  [10774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8450),
  [10777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(302),
  [10780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(47),
  [10783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8242),
  [10786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(464),
  [10789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3968),
  [10792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8316),
  [10795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(18969),
  [10798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11312),
  [10801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14434),
  [10804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3648),
  [10807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3646),
  [10810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8627),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [10814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8789),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [10820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [10822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8446),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [10827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13475),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [10831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8870),
  [10833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18084),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11174),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14159),
  [10839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [10841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [10843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_apply, 2),
  [10845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8242),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14323),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22381),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14651),
  [10854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14725),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14725),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [10862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [10872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14579),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18040),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11173),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14507),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22285),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23271),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13355),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13299),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18267),
  [10902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8255),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23246),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [10911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [10913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13172),
  [10917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23283),
  [10927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13128),
  [10929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21615),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22073),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23059),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13045),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [10943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13158),
  [10945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8810),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9340),
  [10949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9142),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9142),
  [10953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [10955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [10957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8566),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [10962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13356),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [10966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8892),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19941),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11438),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14367),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22629),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [10986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8227),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9788),
  [10990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8285),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [10998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7964),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [11006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9858),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19159),
  [11010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11321),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14481),
  [11014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [11018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8849),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9286),
  [11022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9096),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9096),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [11028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [11030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8623),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [11035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13457),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9106),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19521),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11381),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14271),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [11055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10029),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12182),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22908),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [11071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13491),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13592),
  [11075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13745),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13745),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [11083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [11089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18686),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11266),
  [11095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14306),
  [11097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [11099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22257),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12207),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13454),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23123),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13433),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22568),
  [11117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [11119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [11121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10101),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22776),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10947),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13421),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11126),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22559),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13404),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12862),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22128),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12799),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22607),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12199),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12136),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21976),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21349),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12611),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11227),
  [11183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [11185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10213),
  [11187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(4274),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12887),
  [11194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22185),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10750),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21529),
  [11200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12872),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22432),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12910),
  [11206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [11208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10690),
  [11210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [11212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12839),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13118),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23045),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6276),
  [11230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13139),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [11238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [11240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22398),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11165),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [11248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8401),
  [11251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8680),
  [11254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8689),
  [11257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8689),
  [11260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(431),
  [11263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(45),
  [11266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4274),
  [11269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(451),
  [11272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4038),
  [11275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8706),
  [11278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19013),
  [11281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11250),
  [11284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14431),
  [11287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3641),
  [11290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3643),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22916),
  [11295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [11297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8987),
  [11300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9253),
  [11303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9256),
  [11306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9256),
  [11309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2150),
  [11312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1030),
  [11315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8732),
  [11318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2341),
  [11321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9923),
  [11324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9249),
  [11327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(18691),
  [11330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11267),
  [11333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14496),
  [11336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [11342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8763),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9046),
  [11346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9021),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9021),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [11352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [11354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8563),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [11359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13476),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [11363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9218),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19581),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11387),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14278),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23190),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13826),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12154),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21696),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12237),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21371),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22134),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19208),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23057),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18392),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22506),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22749),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22675),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [11423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21846),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12815),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21657),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10638),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22284),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11342),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12653),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21595),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [11457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [11459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10079),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21181),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21523),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12692),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11330),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21672),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21930),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18872),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [11483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8864),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [11487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9347),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9347),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [11493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [11495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8489),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [11500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13323),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [11504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9224),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20085),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11458),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14395),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21957),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13719),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22815),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20851),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22111),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [11544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9081),
  [11547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9054),
  [11550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9226),
  [11553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9226),
  [11556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2196),
  [11559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(997),
  [11562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8796),
  [11565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2272),
  [11568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10223),
  [11571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9051),
  [11574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19639),
  [11577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11461),
  [11580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14210),
  [11583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8808),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9041),
  [11587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9228),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9228),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [11593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [11595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8528),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [11600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13392),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [11604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9213),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19067),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14413),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21434),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11588),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22860),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10685),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21839),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12630),
  [11628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8409),
  [11631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8536),
  [11634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8573),
  [11637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8573),
  [11640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(334),
  [11643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(65),
  [11646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8255),
  [11649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(487),
  [11652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4048),
  [11655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8524),
  [11658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19869),
  [11661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11527),
  [11664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14162),
  [11667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3639),
  [11670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3638),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6107),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11642),
  [11681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [11683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10052),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21795),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13127),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22511),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12800),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21365),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13166),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10633),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12965),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10651),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12828),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6003),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12634),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20805),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20643),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20711),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20712),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12639),
  [11731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [11733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [11739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8551),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [11743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8634),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [11747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [11749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(8365),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [11754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9909),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8523),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18985),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11225),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14440),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [11769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8551),
  [11772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8525),
  [11775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8634),
  [11778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8634),
  [11781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2093),
  [11784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1130),
  [11787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8365),
  [11790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2313),
  [11793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9909),
  [11796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8523),
  [11799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3912),
  [11802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(18985),
  [11805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11225),
  [11808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14440),
  [11811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8588),
  [11814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8534),
  [11817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8702),
  [11820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8702),
  [11823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2082),
  [11826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1008),
  [11829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8392),
  [11832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2288),
  [11835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10062),
  [11838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8522),
  [11841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4008),
  [11844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19859),
  [11847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11525),
  [11850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14491),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12934),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11559),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11646),
  [11859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8588),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [11863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8702),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [11867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [11869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(8392),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [11874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(10062),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8522),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19859),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11525),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14491),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12739),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12708),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13561),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [11917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9438),
  [11920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9504),
  [11923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9400),
  [11926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9400),
  [11929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2198),
  [11932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(954),
  [11935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9135),
  [11938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2308),
  [11941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10201),
  [11944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9505),
  [11947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19656),
  [11950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11468),
  [11953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14220),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13796),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [11960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14497),
  [11962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [11964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9559),
  [11967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9437),
  [11970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9377),
  [11973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9377),
  [11976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2124),
  [11979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1289),
  [11982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9281),
  [11985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2248),
  [11988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10046),
  [11991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9436),
  [11994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19281),
  [11997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11363),
  [12000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14282),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5904),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [12007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [12011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8627),
  [12014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8775),
  [12017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8789),
  [12020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8789),
  [12023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(384),
  [12026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(63),
  [12029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8446),
  [12032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(479),
  [12035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3901),
  [12038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8870),
  [12041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(18084),
  [12044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11174),
  [12047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14159),
  [12050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3721),
  [12053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3717),
  [12056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8446),
  [12059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9199),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9433),
  [12063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9639),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9639),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [12069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [12071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8838),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [12076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13348),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [12080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9399),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19085),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11289),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14426),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11356),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13815),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12234),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11370),
  [12102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [12104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14519),
  [12106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11049),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18453),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12257),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18467),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12890),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12400),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12900),
  [12136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9478),
  [12139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9360),
  [12142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9448),
  [12145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9448),
  [12148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2156),
  [12151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1066),
  [12154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9196),
  [12157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2258),
  [12160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10230),
  [12163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9363),
  [12166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19596),
  [12169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11447),
  [12172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14175),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12385),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9397),
  [12181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9601),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9601),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [12187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [12193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9947),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [12201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14066),
  [12203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19434),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11375),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14255),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [12215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [12217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14487),
  [12219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18628),
  [12223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8334),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [12229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13915),
  [12231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18629),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11177),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11169),
  [12243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9176),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [12247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9656),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [12253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [12255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8829),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [12260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13426),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [12264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9476),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19041),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14391),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12316),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13098),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12294),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13269),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12939),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13221),
  [12290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18519),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13380),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12973),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13112),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13049),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13393),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13316),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13369),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18527),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10770),
  [12318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(8365),
  [12321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9909),
  [12324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(8392),
  [12327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(10062),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18699),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18690),
  [12334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9012),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9565),
  [12338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9464),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9464),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [12344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [12346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8851),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [12351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13430),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [12355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9626),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19911),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11430),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14365),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12848),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12823),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12933),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13013),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12945),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10780),
  [12391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8810),
  [12394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9340),
  [12397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9142),
  [12400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9142),
  [12403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(382),
  [12406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(70),
  [12409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8566),
  [12412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(484),
  [12415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3881),
  [12418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8892),
  [12421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19941),
  [12424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11438),
  [12427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14367),
  [12430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3670),
  [12433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3671),
  [12436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2),
  [12438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8929),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9056),
  [12442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9265),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [12448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8719),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [12454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9931),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9057),
  [12458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_constructor, 2),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20029),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11523),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14383),
  [12466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8489),
  [12469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8763),
  [12472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9046),
  [12475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9021),
  [12478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9021),
  [12481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(311),
  [12484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(55),
  [12487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8563),
  [12490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(473),
  [12493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4001),
  [12496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9218),
  [12499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19581),
  [12502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11387),
  [12505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14278),
  [12508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3710),
  [12511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3711),
  [12514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2),
  [12516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8929),
  [12519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9056),
  [12522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9265),
  [12525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9265),
  [12528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2077),
  [12531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(1133),
  [12534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8719),
  [12537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2339),
  [12540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9931),
  [12543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9057),
  [12546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2),
  [12548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(20029),
  [12551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(11523),
  [12554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(14383),
  [12557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3942),
  [12560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3943),
  [12563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8563),
  [12566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9192),
  [12569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9037),
  [12572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9126),
  [12575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9126),
  [12578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2092),
  [12581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(1290),
  [12584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8804),
  [12587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2251),
  [12590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(10037),
  [12593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9032),
  [12596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(19177),
  [12599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(11324),
  [12602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(14347),
  [12605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(4005),
  [12608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(4004),
  [12611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9394),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [12615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9741),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9741),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [12621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [12623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(4267),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [12628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13477),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [12632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9698),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20148),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11473),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14438),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [12644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8864),
  [12647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9131),
  [12650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9347),
  [12653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9347),
  [12656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(418),
  [12659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(92),
  [12662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8489),
  [12665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(457),
  [12668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3971),
  [12671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9224),
  [12674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(20085),
  [12677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11458),
  [12680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14395),
  [12683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3684),
  [12686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3627),
  [12689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9774),
  [12692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9791),
  [12695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9792),
  [12698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9792),
  [12701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2185),
  [12704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(945),
  [12707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9633),
  [12710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2239),
  [12713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10229),
  [12716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9790),
  [12719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19621),
  [12722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11460),
  [12725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14198),
  [12728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8623),
  [12731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8528),
  [12734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9192),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9037),
  [12738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9126),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [12744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8804),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [12750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10037),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9032),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19177),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11324),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14347),
  [12760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8849),
  [12763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9286),
  [12766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9096),
  [12769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9096),
  [12772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(282),
  [12775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(69),
  [12778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8623),
  [12781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(452),
  [12784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3958),
  [12787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9106),
  [12790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19521),
  [12793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11381),
  [12796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14271),
  [12799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3661),
  [12802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3691),
  [12805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8808),
  [12808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9041),
  [12811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9228),
  [12814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9228),
  [12817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(372),
  [12820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(75),
  [12823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8528),
  [12826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(488),
  [12829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4049),
  [12832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9213),
  [12835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19067),
  [12838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11288),
  [12841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14413),
  [12844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3694),
  [12847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3692),
  [12850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8566),
  [12853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9807),
  [12856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9861),
  [12859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9729),
  [12862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9729),
  [12865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2083),
  [12868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1149),
  [12871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9469),
  [12874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2253),
  [12877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9938),
  [12880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9859),
  [12883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19111),
  [12886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11337),
  [12889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14155),
  [12892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9682),
  [12895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9752),
  [12898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9703),
  [12901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9703),
  [12904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2161),
  [12907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1219),
  [12910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8334),
  [12913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2252),
  [12916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(10088),
  [12919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9754),
  [12922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(19308),
  [12925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(11340),
  [12928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(14139),
  [12931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14533),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14559),
  [12935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14566),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14566),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [12943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [12951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14801),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19330),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11350),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14424),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [12963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8851),
  [12966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14761),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15002),
  [12970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15297),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15297),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [12978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8829),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [12986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15355),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19266),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11338),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14382),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [12998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13912),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14286),
  [13002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14251),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14251),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [13010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18408),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11215),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14380),
  [13024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14370),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14805),
  [13028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14781),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14781),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [13036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19455),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11376),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14254),
  [13050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14433),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14813),
  [13054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14760),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14760),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [13062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [13070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14891),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18873),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11279),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14283),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [13082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14968),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15504),
  [13086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15097),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15097),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [13094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [13102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15530),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18754),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11269),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14327),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [13114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9199),
  [13117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9433),
  [13120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9639),
  [13123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9639),
  [13126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(387),
  [13129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(91),
  [13132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8838),
  [13135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(478),
  [13138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4055),
  [13141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9399),
  [13144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19085),
  [13147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11289),
  [13150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14426),
  [13153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3714),
  [13156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3709),
  [13159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14578),
  [13161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14980),
  [13163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15277),
  [13165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15277),
  [13167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [13169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [13171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [13173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [13175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [13177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [13179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15211),
  [13181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19345),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [13185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14389),
  [13187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [13189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [13191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13578),
  [13193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13879),
  [13195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13914),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13914),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [13201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [13203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19543),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11351),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14516),
  [13217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [13219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [13221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8258),
  [13224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8274),
  [13227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8285),
  [13230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8285),
  [13233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2068),
  [13236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(996),
  [13239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(7964),
  [13242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2318),
  [13245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(10114),
  [13248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8267),
  [13251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(19159),
  [13254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(11319),
  [13257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(14481),
  [13260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3940),
  [13263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3938),
  [13266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8838),
  [13269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8829),
  [13272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8258),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8274),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [13278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [13282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10114),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11319),
  [13288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [13290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14445),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14783),
  [13294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14556),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14556),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [13302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20057),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11454),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14388),
  [13316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9012),
  [13319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9565),
  [13322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9464),
  [13325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9464),
  [13328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(357),
  [13331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(62),
  [13334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8851),
  [13337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(496),
  [13340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3978),
  [13343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9626),
  [13346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19911),
  [13349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11430),
  [13352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14365),
  [13355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3632),
  [13358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3633),
  [13361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9176),
  [13364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9515),
  [13367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9656),
  [13370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9656),
  [13373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(355),
  [13376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(74),
  [13379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8829),
  [13382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(442),
  [13385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4023),
  [13388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9476),
  [13391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(19041),
  [13394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11281),
  [13397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14391),
  [13400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3682),
  [13403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3680),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7592),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8551),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [13416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9909),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [13422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2, .production_id = 14),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9253),
  [13428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9256),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9256),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [13434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8732),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [13440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9923),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9249),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18691),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11267),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14496),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9081),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9054),
  [13456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9226),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9226),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [13462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8796),
  [13466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [13468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10223),
  [13470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9051),
  [13472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19639),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11461),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14210),
  [13478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9081),
  [13481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2),
  [13483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9054),
  [13486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9226),
  [13489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9226),
  [13492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2196),
  [13495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(997),
  [13498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(8796),
  [13501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2272),
  [13504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10223),
  [13507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9051),
  [13510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19639),
  [13513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11461),
  [13516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14210),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [13521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [13523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10062),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [13529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [13533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(4267),
  [13536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9394),
  [13539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9691),
  [13542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9741),
  [13545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9741),
  [13548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(353),
  [13551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(57),
  [13554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4267),
  [13557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(448),
  [13560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3999),
  [13563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9698),
  [13566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(20148),
  [13569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11473),
  [13572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14438),
  [13575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3704),
  [13578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3706),
  [13581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9530),
  [13584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9397),
  [13587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9601),
  [13590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9601),
  [13593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2194),
  [13596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(1242),
  [13599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(8684),
  [13602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(2357),
  [13605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9947),
  [13608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(9396),
  [13611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(3948),
  [13614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 1, .production_id = 13),
  [13616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(19434),
  [13619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(11375),
  [13622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(14255),
  [13625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(8987),
  [13628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9253),
  [13631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9256),
  [13634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9256),
  [13637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2150),
  [13640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1030),
  [13643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(8732),
  [13646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2341),
  [13649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9923),
  [13652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9249),
  [13655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(18691),
  [13658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11267),
  [13661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14496),
  [13664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10176),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10305),
  [13668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10280),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10280),
  [13672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [13676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9804),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [13684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10428),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18474),
  [13688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11420),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14214),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [13696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22909),
  [13698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [13704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12184),
  [13706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9478),
  [13709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9360),
  [13712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9448),
  [13715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9448),
  [13718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2156),
  [13721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1066),
  [13724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9196),
  [13727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2258),
  [13730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10230),
  [13733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9363),
  [13736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19596),
  [13739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11447),
  [13742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14175),
  [13745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22288),
  [13747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [13749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [13751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [13753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [13755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [13757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [13759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [13761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [13763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [13765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [13767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [13769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9437),
  [13771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9377),
  [13773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9377),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [13777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9281),
  [13781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [13783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10046),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19281),
  [13789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11363),
  [13791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14282),
  [13793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [13795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10054),
  [13797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22624),
  [13799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [13801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [13805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23122),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13425),
  [13809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13159),
  [13813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21601),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [13817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23060),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13043),
  [13821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22581),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [13825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22071),
  [13827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [13829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9438),
  [13832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9504),
  [13835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9400),
  [13838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9400),
  [13841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2198),
  [13844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(954),
  [13847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9135),
  [13850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2308),
  [13853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10201),
  [13856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9505),
  [13859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19656),
  [13862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11468),
  [13865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14220),
  [13868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13422),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13453),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22786),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10959),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [13884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11114),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22504),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13401),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22375),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12858),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22119),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12826),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23279),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13124),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22608),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12200),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12122),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13168),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9438),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9504),
  [13938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9400),
  [13940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [13942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [13944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [13950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10201),
  [13952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9505),
  [13954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19656),
  [13956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11468),
  [13958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14220),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [13972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [13974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21346),
  [13976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [13978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23256),
  [13980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [13982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [13984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12880),
  [13986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21961),
  [13988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [13990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22178),
  [13992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10752),
  [13994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [13996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [13998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22437),
  [14000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12915),
  [14002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21524),
  [14004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12791),
  [14006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [14008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12844),
  [14010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22510),
  [14012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12778),
  [14014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [14016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [14018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10737),
  [14020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [14022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [14024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13010),
  [14026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22250),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12210),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13302),
  [14040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [14042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12961),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [14048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23241),
  [14050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13470),
  [14052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(9530),
  [14055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(9397),
  [14058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(9601),
  [14061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(9601),
  [14064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(2194),
  [14067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(1242),
  [14070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3),
  [14072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(8684),
  [14075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(2357),
  [14078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(9947),
  [14081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(9396),
  [14084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(3948),
  [14087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 3, .production_id = 28),
  [14089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(19434),
  [14092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(11375),
  [14095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(14255),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21841),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12779),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [14106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13184),
  [14108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22397),
  [14110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11166),
  [14112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [14114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [14116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22868),
  [14120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [14122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [14124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [14128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [14130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12147),
  [14132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21372),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21681),
  [14138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12244),
  [14140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [14142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9895),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [14148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22140),
  [14150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [14158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9478),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9360),
  [14162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9448),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9448),
  [14166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [14168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [14170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9196),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [14174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10230),
  [14176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9363),
  [14178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19596),
  [14180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [14182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14175),
  [14184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [14186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10050),
  [14188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [14190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [14192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(8227),
  [14195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(9788),
  [14198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(8285),
  [14201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(8285),
  [14204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(402),
  [14207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2),
  [14209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(89),
  [14212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(7964),
  [14215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(469),
  [14218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(3937),
  [14221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(9858),
  [14224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(19159),
  [14227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(11321),
  [14230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(14481),
  [14233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(3713),
  [14236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 2), SHIFT_REPEAT(3712),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23041),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22748),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21449),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11580),
  [14255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(9530),
  [14258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(9397),
  [14261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), SHIFT(9601),
  [14264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(9601),
  [14267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(2194),
  [14270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), SHIFT(1242),
  [14273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1),
  [14275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(8684),
  [14278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(2357),
  [14281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), SHIFT(9947),
  [14284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(9396),
  [14287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(3948),
  [14290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 1, .production_id = 1),
  [14292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(19434),
  [14295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(11375),
  [14298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(14255),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21658),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22281),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11343),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23196),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13790),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21619),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12660),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11331),
  [14333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9559),
  [14336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9437),
  [14339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9377),
  [14342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9377),
  [14345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2124),
  [14348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1289),
  [14351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9281),
  [14354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2248),
  [14357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10046),
  [14360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9436),
  [14363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19281),
  [14366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11363),
  [14369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14282),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21508),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12700),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22668),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6095),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21774),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22433),
  [14388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21958),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [14398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22344),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [14402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10624),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6112),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22851),
  [14418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10654),
  [14420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [14422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11640),
  [14426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [14430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [14434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21825),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12631),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21360),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [14444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21847),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13079),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13723),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12612),
  [14456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5600),
  [14458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19179),
  [14460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9530),
  [14462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [14466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5564),
  [14468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17964),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13109),
  [14472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12637),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12641),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13094),
  [14478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funvar, 1, .production_id = 9),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12258),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [14484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9682),
  [14487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9752),
  [14490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9703),
  [14493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9703),
  [14496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2161),
  [14499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1219),
  [14502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(8334),
  [14505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2252),
  [14508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10088),
  [14511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9754),
  [14514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19308),
  [14517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11340),
  [14520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14139),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11358),
  [14525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5242),
  [14527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17931),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9682),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9752),
  [14535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9703),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9703),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [14541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [14545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10088),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9754),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19308),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11340),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14139),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13340),
  [14557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6212),
  [14559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18697),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13308),
  [14563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funvar, 2, .production_id = 26),
  [14565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5245),
  [14567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18169),
  [14569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [14571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18301),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12827),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12852),
  [14577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [14579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19421),
  [14581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10176),
  [14584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10305),
  [14587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10280),
  [14590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10280),
  [14593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(389),
  [14596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(58),
  [14599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9804),
  [14602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(476),
  [14605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3887),
  [14608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10428),
  [14611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(18474),
  [14614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(11420),
  [14617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(14214),
  [14620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3650),
  [14623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3654),
  [14626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4563),
  [14628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18407),
  [14630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [14632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [14634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17973),
  [14636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(8227),
  [14639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(9788),
  [14642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(8285),
  [14645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(8285),
  [14648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(402),
  [14651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(89),
  [14654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(7964),
  [14657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(469),
  [14660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2),
  [14662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(3937),
  [14665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(9858),
  [14668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(19159),
  [14671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(11321),
  [14674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(14481),
  [14677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(3713),
  [14680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(3712),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [14687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [14689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4680),
  [14691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18764),
  [14693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4733),
  [14695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19729),
  [14697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13833),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13816),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [14705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [14707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19240),
  [14709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [14711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18214),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12954),
  [14715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12835),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11372),
  [14719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [14721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19367),
  [14723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [14725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [14727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6040),
  [14729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [14731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [14735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [14737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [14739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [14741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22871),
  [14743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [14745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21193),
  [14747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [14751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21272),
  [14753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [14755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18157),
  [14757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6417),
  [14759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [14761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [14763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18993),
  [14765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12283),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12952),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13015),
  [14779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12308),
  [14781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12318),
  [14783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11130),
  [14785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11055),
  [14787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [14789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18133),
  [14791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [14793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11170),
  [14795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12991),
  [14797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [14799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12964),
  [14801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [14803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [14805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19975),
  [14807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [14809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11178),
  [14811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [14813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18674),
  [14815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9807),
  [14817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9861),
  [14819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9729),
  [14821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [14823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [14825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [14827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9469),
  [14829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [14831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9938),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9859),
  [14835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19111),
  [14837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11337),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14155),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21451),
  [14843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19249),
  [14845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12892),
  [14847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [14849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19238),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13243),
  [14855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [14857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [14859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4791),
  [14861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19564),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11541),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [14869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13387),
  [14871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11558),
  [14875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13462),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [14883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9774),
  [14886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9791),
  [14889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9792),
  [14892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9792),
  [14895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2185),
  [14898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(945),
  [14901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9633),
  [14904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2239),
  [14907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10229),
  [14910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9790),
  [14913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19621),
  [14916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11460),
  [14919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14198),
  [14922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [14924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [14926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [14928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9774),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9791),
  [14932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9792),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9792),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [14938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9633),
  [14942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [14944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10229),
  [14946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9790),
  [14948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19621),
  [14950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11460),
  [14952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14198),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10649),
  [14956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [14958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10631),
  [14960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13546),
  [14964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10779),
  [14966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23071),
  [14968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18234),
  [14970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10487),
  [14972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [14974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9807),
  [14977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9861),
  [14980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9729),
  [14983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9729),
  [14986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2083),
  [14989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1149),
  [14992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9469),
  [14995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2253),
  [14998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9938),
  [15001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9859),
  [15004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19111),
  [15007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11337),
  [15010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14155),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13035),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [15019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5613),
  [15021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18810),
  [15023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6619),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12745),
  [15027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12715),
  [15029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4866),
  [15031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18954),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13378),
  [15035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4296),
  [15037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18015),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18089),
  [15043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12407),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12387),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13058),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12907),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13227),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18085),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9530),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18720),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18921),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18928),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18349),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18478),
  [15067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9530),
  [15070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9397),
  [15073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9601),
  [15076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9601),
  [15079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2194),
  [15082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1242),
  [15085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(8684),
  [15088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2357),
  [15091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9947),
  [15094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9396),
  [15097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(19434),
  [15100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11375),
  [15103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14255),
  [15106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18428),
  [15108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18432),
  [15110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18198),
  [15112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20004),
  [15114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20955),
  [15116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18726),
  [15118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21276),
  [15120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21010),
  [15122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21003),
  [15124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20749),
  [15126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20745),
  [15128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9932),
  [15131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9934),
  [15134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10103),
  [15137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(10103),
  [15140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2097),
  [15143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(1261),
  [15146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9751),
  [15149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(2386),
  [15152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9946),
  [15155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(9927),
  [15158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(18635),
  [15161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(11263),
  [15164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraint_repeat1, 2), SHIFT_REPEAT(14350),
  [15167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18359),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [15171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [15173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9934),
  [15175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10103),
  [15177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10103),
  [15179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [15181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [15187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9946),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [15191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18635),
  [15193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11263),
  [15195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14350),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [15199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [15201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [15203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [15205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 4, .production_id = 28),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7623),
  [15209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [15211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [15213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [15215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [15219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [15223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9530),
  [15226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9397),
  [15229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9601),
  [15232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9601),
  [15235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2194),
  [15238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1242),
  [15241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8684),
  [15244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2357),
  [15247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9947),
  [15250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9396),
  [15253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3948),
  [15256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(19434),
  [15259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(11375),
  [15262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(14255),
  [15265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [15267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [15269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [15271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7963),
  [15273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [15275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 2, .production_id = 13),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [15281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [15283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 2, .production_id = 1),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [15287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [15289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7484),
  [15291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14238),
  [15295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [15297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13031),
  [15301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [15303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13379),
  [15305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [15307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14206),
  [15309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13976),
  [15313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [15315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14064),
  [15319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [15321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14137),
  [15323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [15325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14099),
  [15327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [15329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13926),
  [15331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [15333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13868),
  [15335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [15337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13608),
  [15339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 1),
  [15341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 1),
  [15343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycon, 2, .production_id = 29),
  [15345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycon, 2, .production_id = 29),
  [15347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14459),
  [15349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17580),
  [15351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16481),
  [15353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16481),
  [15355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [15357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [15359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13852),
  [15361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [15363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9936),
  [15365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19977),
  [15367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17579),
  [15369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20001),
  [15371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11451),
  [15373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14372),
  [15375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12014),
  [15377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15092),
  [15379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15101),
  [15381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15101),
  [15383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [15385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10873),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [15391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9978),
  [15393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18632),
  [15395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15079),
  [15397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19731),
  [15399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11396),
  [15401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14337),
  [15403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qcon, 1),
  [15405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qcon, 1),
  [15407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 2, .production_id = 29),
  [15409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 2, .production_id = 29),
  [15411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_constructor, 2),
  [15413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_constructor, 2),
  [15415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12),
  [15417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13259),
  [15419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14677),
  [15421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14964),
  [15423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14964),
  [15425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [15427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [15429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12383),
  [15431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [15433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10074),
  [15435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18711),
  [15437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14678),
  [15439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19242),
  [15441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11335),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14341),
  [15445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [15448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_name, 1),
  [15450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [15453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2453),
  [15456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym_pat_name, 1),
  [15459] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym_pat_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [15463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_name, 1),
  [15465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [15468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_name, 1, .production_id = 1),
  [15470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18063),
  [15474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_name, 1, .production_id = 1),
  [15476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2463),
  [15479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_star, 1),
  [15481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_star, 1),
  [15483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2),
  [15485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda_case, 2),
  [15487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2869),
  [15490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [15492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 5, .production_id = 49),
  [15494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 5, .production_id = 49),
  [15496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_decl_tyfam_repeat1, 1),
  [15498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 1),
  [15500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4, .production_id = 49),
  [15502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4, .production_id = 49),
  [15504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4),
  [15506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4),
  [15508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_con_tuple, 3),
  [15510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_con_tuple, 3),
  [15512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [15515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_name, 3),
  [15517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [15520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2453),
  [15523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 3), REDUCE(sym_pat_name, 3),
  [15526] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_exp_name, 3), REDUCE(sym_pat_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [15530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_name, 3),
  [15532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [15535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_name, 3, .production_id = 28),
  [15537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_name, 3, .production_id = 28),
  [15539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [15541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [15543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 2),
  [15545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 2),
  [15547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1),
  [15549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1),
  [15551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 3),
  [15553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 3),
  [15555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qcon, 3),
  [15557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qcon, 3),
  [15559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycon, 2),
  [15561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycon, 2),
  [15563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_literal, 1),
  [15565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_literal, 1),
  [15567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1),
  [15569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 2),
  [15571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 2),
  [15573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_con_list, 2),
  [15575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_con_list, 2),
  [15577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_tuple, 4),
  [15579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_tuple, 4),
  [15581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_promoted_literal, 2),
  [15583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_promoted_literal, 2),
  [15585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1),
  [15587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1),
  [15589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tycon_arrow, 3),
  [15591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tycon_arrow, 3),
  [15593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_list, 4),
  [15595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 4),
  [15597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_con_unit, 2),
  [15599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_con_unit, 2),
  [15601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_variable, 2),
  [15603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_variable, 2),
  [15605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_parens, 3, .production_id = 16),
  [15607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_parens, 3, .production_id = 16),
  [15609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 3),
  [15611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parens, 3),
  [15613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parens, 3),
  [15615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_list, 3),
  [15617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 3),
  [15619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2467),
  [15622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_tuple, 2),
  [15624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_tuple, 2),
  [15626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_tuple, 3),
  [15628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_tuple, 3),
  [15630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_sum, 3),
  [15632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_sum, 3),
  [15634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_tuple, 3),
  [15636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_tuple, 3),
  [15638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2463),
  [15641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22259),
  [15643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variable, 1),
  [15645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 1),
  [15647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2),
  [15649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2), SHIFT_REPEAT(3810),
  [15652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2),
  [15654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycon, 4),
  [15656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycon, 4),
  [15658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 4, .production_id = 53),
  [15660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 4, .production_id = 53),
  [15662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_tuple, 2),
  [15664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 2),
  [15666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 7, .production_id = 88),
  [15668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 7, .production_id = 88),
  [15670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list_comprehension, 6, .production_id = 16),
  [15672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list_comprehension, 6, .production_id = 16),
  [15674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 6, .production_id = 82),
  [15676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 6, .production_id = 82),
  [15678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11796),
  [15680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12008),
  [15682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [15684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [15686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [15688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10112),
  [15690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12051),
  [15692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_right, 6),
  [15694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_right, 6),
  [15696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_record, 5),
  [15698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_record, 5),
  [15700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 5, .production_id = 72),
  [15702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 5, .production_id = 72),
  [15704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [15706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [15708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [15710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [15714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10233),
  [15716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [15718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list_comprehension, 5, .production_id = 16),
  [15720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list_comprehension, 5, .production_id = 16),
  [15722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_projection_selector, 5, .production_id = 68),
  [15724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_projection_selector, 5, .production_id = 68),
  [15726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_record, 4),
  [15728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_record, 4),
  [15730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16111),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16041),
  [15734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16248),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16248),
  [15738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [15740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15491),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [15746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9907),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16042),
  [15750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18870),
  [15752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11189),
  [15754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14245),
  [15756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_tuple, 4, .production_id = 52),
  [15758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 4, .production_id = 52),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [15762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [15766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [15768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [15770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10111),
  [15772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [15774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_th_quoted_name, 4),
  [15776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_th_quoted_name, 4),
  [15778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list, 4, .production_id = 52),
  [15780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list, 4, .production_id = 52),
  [15782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_left, 4),
  [15784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_left, 4),
  [15786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6214),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [15790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [15792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [15794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [15796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10182),
  [15798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [15800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12311),
  [15802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12179),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [15806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [15808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [15810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9919),
  [15812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12178),
  [15814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_right, 4),
  [15816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_right, 4),
  [15818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_projection_selector, 4, .production_id = 44),
  [15820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_projection_selector, 4, .production_id = 44),
  [15822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_projection, 3, .production_id = 44),
  [15824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_projection, 3, .production_id = 44),
  [15826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_tuple, 3, .production_id = 16),
  [15828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 3, .production_id = 16),
  [15830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_sum, 3, .production_id = 16),
  [15832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_sum, 3, .production_id = 16),
  [15834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15108),
  [15836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15533),
  [15838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [15840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [15844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9948),
  [15846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15412),
  [15848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [15852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [15854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [15856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [15858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10183),
  [15860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [15862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12504),
  [15864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12341),
  [15866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [15868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [15870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [15872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9878),
  [15874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12338),
  [15876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list, 3, .production_id = 16),
  [15878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list, 3, .production_id = 16),
  [15880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14555),
  [15882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14560),
  [15884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [15886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [15888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [15890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10072),
  [15892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14565),
  [15894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_tuple, 3, .production_id = 16),
  [15896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_tuple, 3, .production_id = 16),
  [15898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_th_quoted_name, 2),
  [15900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_th_quoted_name, 2),
  [15902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__aexp, 1),
  [15904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__aexp, 1),
  [15906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20811),
  [15908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11196),
  [15910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11318),
  [15912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [15914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [15918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9882),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11320),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [15926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [15928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [15932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10224),
  [15934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [15936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13216),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13056),
  [15940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [15942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [15944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [15946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10144),
  [15948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13057),
  [15950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9251),
  [15952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8959),
  [15954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [15956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [15958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [15960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9991),
  [15962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [15964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [15966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [15968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [15970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [15972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [15974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9982),
  [15976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [15978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14919),
  [15980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14595),
  [15982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [15984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [15986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [15988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9921),
  [15990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14581),
  [15992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17289),
  [15994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17695),
  [15996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17584),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17584),
  [16000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [16002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [16004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15869),
  [16006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [16008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9908),
  [16010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17682),
  [16012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18847),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11187),
  [16016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14241),
  [16018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10382),
  [16020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10334),
  [16022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [16024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [16026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [16028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10141),
  [16030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10336),
  [16032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10732),
  [16034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10691),
  [16036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [16038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [16040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [16042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10198),
  [16044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10736),
  [16046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11681),
  [16048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11748),
  [16050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [16052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [16054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [16056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10009),
  [16058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11752),
  [16060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [16062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [16064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [16066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [16068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [16070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10047),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [16074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10514),
  [16076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10574),
  [16078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [16080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [16082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [16084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10167),
  [16086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10551),
  [16088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [16090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [16092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [16094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [16096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [16098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10174),
  [16100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [16102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8853),
  [16104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8813),
  [16106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [16108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [16110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [16112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10232),
  [16114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8819),
  [16116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11561),
  [16118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11962),
  [16120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [16122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [16124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [16126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10023),
  [16128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11967),
  [16130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13665),
  [16132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13771),
  [16134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [16136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [16138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [16140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10148),
  [16142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13779),
  [16144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14736),
  [16146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14880),
  [16148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [16150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [16152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [16154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9944),
  [16156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14875),
  [16158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [16160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [16162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [16164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [16166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [16168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10004),
  [16170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [16172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14473),
  [16174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14321),
  [16176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [16178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [16180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [16182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10071),
  [16184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14300),
  [16186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [16188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [16190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [16192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [16194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [16196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9883),
  [16198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [16200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11696),
  [16202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11873),
  [16204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [16206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [16208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [16210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10193),
  [16212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11875),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12235),
  [16216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12150),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [16220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [16224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9929),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12131),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10507),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10535),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [16234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [16236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [16238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9918),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10454),
  [16242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [16244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [16246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [16248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [16250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [16252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9960),
  [16254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [16256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [16258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [16260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [16262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [16266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10095),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [16270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [16276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [16278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [16280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9872),
  [16282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [16284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11127),
  [16286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11031),
  [16288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [16290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [16292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [16294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10078),
  [16296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11032),
  [16298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [16300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [16302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [16304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [16308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9904),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [16312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11968),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11531),
  [16316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [16318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [16322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10034),
  [16324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11532),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [16330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [16332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [16334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [16336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10021),
  [16338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12194),
  [16342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12296),
  [16344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [16346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [16350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10106),
  [16352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12298),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [16356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14930),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14834),
  [16360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [16362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [16364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [16366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10066),
  [16368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14833),
  [16370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [16372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12646),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12543),
  [16376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [16378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [16380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [16382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9945),
  [16384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12539),
  [16386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13897),
  [16388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14106),
  [16390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [16392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [16394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [16396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10226),
  [16398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14121),
  [16400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12118),
  [16402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11553),
  [16404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [16406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [16408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [16410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10149),
  [16412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11552),
  [16414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [16416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [16418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [16420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [16422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [16424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10158),
  [16426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [16428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [16430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8927),
  [16432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [16434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [16436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [16438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9917),
  [16440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [16442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11534),
  [16444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11680),
  [16446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [16448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [16450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [16452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9892),
  [16454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11682),
  [16456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12158),
  [16458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12413),
  [16460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [16462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [16464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [16466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10163),
  [16468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12414),
  [16470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [16472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [16474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [16476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [16478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [16480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9873),
  [16482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8423),
  [16484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [16486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9025),
  [16488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [16490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [16492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [16494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10068),
  [16496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9049),
  [16498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15474),
  [16500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15486),
  [16502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [16504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [16506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [16508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9970),
  [16510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15485),
  [16512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [16514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [16516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [16518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [16520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [16522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10000),
  [16524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [16526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [16528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9523),
  [16530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [16532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [16534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [16536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9984),
  [16538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9522),
  [16540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [16542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [16544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [16546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [16548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [16550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10145),
  [16552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [16554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13117),
  [16556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12994),
  [16558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [16560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [16562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [16564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10142),
  [16566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13001),
  [16568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [16570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9843),
  [16572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [16574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [16576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [16578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10099),
  [16580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [16582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [16584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [16586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [16588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [16590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [16592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10136),
  [16594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [16596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [16598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [16600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [16602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [16604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [16606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9871),
  [16608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8948),
  [16610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9192),
  [16612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [16614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6219),
  [16616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [16618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [16620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [16622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9962),
  [16624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [16626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12701),
  [16628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12450),
  [16630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [16632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [16634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [16636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10129),
  [16638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12448),
  [16640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [16642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [16644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [16646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [16648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [16650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10122),
  [16652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [16654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2820),
  [16657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [16659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9547),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9571),
  [16663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [16665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [16667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [16669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9901),
  [16671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [16673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [16675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [16677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [16679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [16681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [16683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10116),
  [16685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [16687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10891),
  [16689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10787),
  [16691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [16693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [16695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [16697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10102),
  [16699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [16701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [16703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [16705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [16707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [16709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [16711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9964),
  [16713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [16715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8670),
  [16717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [16719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [16721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [16723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [16725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9997),
  [16727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [16729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11997),
  [16731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12034),
  [16733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [16735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [16737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [16739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10083),
  [16741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12033),
  [16743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [16745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [16747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [16749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [16751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [16753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10133),
  [16755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [16757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9202),
  [16759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9329),
  [16761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [16763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [16765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [16767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9900),
  [16769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9343),
  [16771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15846),
  [16773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16216),
  [16775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15780),
  [16777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15780),
  [16779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [16781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [16783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15308),
  [16785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [16787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10210),
  [16789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16224),
  [16791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19584),
  [16793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11442),
  [16795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14161),
  [16797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9548),
  [16799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9614),
  [16801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [16803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [16805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [16807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9894),
  [16809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [16811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14832),
  [16813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14768),
  [16815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [16817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [16819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [16821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9937),
  [16823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14769),
  [16825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2467),
  [16828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15187),
  [16830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15470),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [16834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [16836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [16838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9916),
  [16840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15448),
  [16842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20236),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20187),
  [16846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20231),
  [16848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20231),
  [16850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [16852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15876),
  [16856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [16858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9912),
  [16860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20212),
  [16862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19016),
  [16864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11268),
  [16866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14374),
  [16868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nalts, 6),
  [16870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalts, 6),
  [16872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 6),
  [16874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 6),
  [16876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 7),
  [16878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 7),
  [16880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nalts, 5),
  [16882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalts, 5),
  [16884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 5),
  [16886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 5),
  [16888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 6),
  [16890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 6),
  [16892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nalts, 4),
  [16894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalts, 4),
  [16896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 4),
  [16898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 4),
  [16900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 5),
  [16902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 5),
  [16904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nalts, 3),
  [16906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalts, 3),
  [16908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 3),
  [16910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 3),
  [16912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 4),
  [16914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 4),
  [16916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nalts, 2),
  [16918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalts, 2),
  [16920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 2),
  [16922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 2),
  [16924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 1), REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [16927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [16930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [16932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [16934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20532),
  [16936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 3),
  [16938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 3),
  [16940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda_cases, 3),
  [16942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda_cases, 3),
  [16944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda_case, 3),
  [16946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda_case, 3),
  [16948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_type_application, 2),
  [16950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_type_application, 2),
  [16952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2901),
  [16955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [16957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21189),
  [16959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2897),
  [16962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [16964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 2),
  [16966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2863),
  [16969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [16971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_name, 1),
  [16973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [16975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_invisible, 2),
  [16977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_invisible, 2),
  [16979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [16981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20407),
  [16983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_name, 3),
  [16985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_tuple, 2),
  [16987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 2), REDUCE(sym_pat_unboxed_tuple, 2),
  [16990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__aexp_projection, 1),
  [16992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__aexp_projection, 1),
  [16994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__apat, 1, .production_id = 4),
  [16996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__aexp_projection, 1), REDUCE(sym__apat, 1, .production_id = 4),
  [16999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__aexp_projection, 1), REDUCE(sym__apat, 1),
  [17002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2917),
  [17005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [17007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20467),
  [17009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [17011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_type_binder, 2),
  [17013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_type_application, 2), REDUCE(sym_pat_type_binder, 2),
  [17016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2808),
  [17019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [17021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2867),
  [17024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [17026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2), SHIFT_REPEAT(4578),
  [17029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21205),
  [17031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2874),
  [17034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [17036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2843),
  [17039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [17041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2806),
  [17044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [17046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [17048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2841),
  [17051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [17053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2929),
  [17056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [17058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20603),
  [17060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2919),
  [17063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [17065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2889),
  [17068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [17070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2827),
  [17073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [17075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20884),
  [17077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2809),
  [17080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [17082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20388),
  [17084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21236),
  [17086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [17088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20684),
  [17090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2861),
  [17093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [17095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2915),
  [17098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [17100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20474),
  [17102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20499),
  [17104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20761),
  [17106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20380),
  [17108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21045),
  [17110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2824),
  [17113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [17115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2844),
  [17118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [17120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2885),
  [17123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [17125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21259),
  [17127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20993),
  [17129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21008),
  [17131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20896),
  [17133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21203),
  [17135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2816),
  [17138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [17140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20428),
  [17142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20857),
  [17144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_infix, 1),
  [17146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15948),
  [17148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [17150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_infix, 1),
  [17152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10632),
  [17154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [17156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(2467),
  [17159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(20541),
  [17162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(20000),
  [17165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(18229),
  [17168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 1, .production_id = 13),
  [17170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(13599),
  [17173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(18653),
  [17176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 1, .production_id = 13),
  [17178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(13580),
  [17181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(18570),
  [17184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(13580),
  [17187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 3, .production_id = 28),
  [17189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18570),
  [17192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 3, .production_id = 28),
  [17194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(12014),
  [17197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(18221),
  [17200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), REDUCE(sym__simpletype, 1, .production_id = 13),
  [17203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(13955),
  [17206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(18728),
  [17209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(20541),
  [17212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(20000),
  [17215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(19368),
  [17218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(13599),
  [17221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18653),
  [17224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), SHIFT(15948),
  [17227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), SHIFT(10873),
  [17230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), SHIFT(10632),
  [17233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [17235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(13955),
  [17238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18728),
  [17241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11539),
  [17243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6605),
  [17245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [17247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12747),
  [17249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12411),
  [17251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13258),
  [17253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [17255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18639),
  [17257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13019),
  [17259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [17261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12259),
  [17263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [17265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12970),
  [17267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6227),
  [17269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [17271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [17273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13493),
  [17275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [17277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13249),
  [17279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [17281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11058),
  [17283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12320),
  [17285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13018),
  [17287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [17289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [17291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [17293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12816),
  [17295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(12014),
  [17298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18221),
  [17301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), REDUCE(sym__simpletype, 3, .production_id = 28),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [17306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [17308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12923),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13300),
  [17312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13368),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20741),
  [17316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13087),
  [17318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [17320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13836),
  [17322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [17324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [17326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [17328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [17330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11185),
  [17332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [17334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11377),
  [17336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10766),
  [17338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [17340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [17342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12643),
  [17344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [17346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [17348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2488),
  [17351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [17353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [17355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [17357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2492),
  [17360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2492),
  [17363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [17365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [17367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2488),
  [17370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [17372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [17374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_con_tuple_repeat1, 2),
  [17376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_con_tuple_repeat1, 2),
  [17378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_con_tuple_repeat1, 2), SHIFT_REPEAT(8198),
  [17381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [17383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [17385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [17387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [17389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [17391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__apat, 1),
  [17393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13395),
  [17395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [17397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [17399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [17401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20661),
  [17403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 1),
  [17405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [17407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [17409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14343),
  [17411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [17413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [17415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_name, 1),
  [17417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [17419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13304),
  [17421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13479),
  [17423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [17425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [17427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [17429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18641),
  [17431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [17433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18503),
  [17435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarop_nominus, 1),
  [17437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarop_nominus, 1),
  [17439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [17441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12762),
  [17443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_wildcard, 1),
  [17445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_wildcard, 1),
  [17447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [17449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12548),
  [17451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10452),
  [17453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [17455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12649),
  [17457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_name, 3),
  [17459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [17461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [17463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10520),
  [17465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13234),
  [17467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [17469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_sum, 3),
  [17471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_sum, 3),
  [17473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_record, 2, .production_id = 23),
  [17475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_record, 2, .production_id = 23),
  [17477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [17479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [17481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11895),
  [17483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__minus, 1, .production_id = 11),
  [17485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_operator, 2),
  [17487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator, 2),
  [17489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11563),
  [17491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_tuple, 3),
  [17493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_tuple, 3),
  [17495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [17497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [17499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [17501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12648),
  [17503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [17505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11780),
  [17507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_tuple, 2),
  [17509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [17511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_type_binder, 2),
  [17513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [17515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11876),
  [17517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [17519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [17521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [17523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_as, 3, .production_id = 40),
  [17525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_as, 3, .production_id = 40),
  [17527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarop, 3),
  [17529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarop, 3),
  [17531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11574),
  [17533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_tuple, 4),
  [17535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_tuple, 4),
  [17537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [17539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11723),
  [17541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_strict, 2),
  [17543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_strict, 2),
  [17545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_list, 4),
  [17547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_list, 4),
  [17549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [17551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_irrefutable, 2),
  [17553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_irrefutable, 2),
  [17555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [17557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12594),
  [17559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12201),
  [17561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [17563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [17565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12376),
  [17567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12138),
  [17569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12209),
  [17571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11581),
  [17573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1),
  [17575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1),
  [17577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11110),
  [17579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__apat, 1, .production_id = 4),
  [17581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11030),
  [17583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11100),
  [17585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [17587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [17589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [17591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [17593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [17595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12319),
  [17597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_parens, 3),
  [17599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_parens, 3),
  [17601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12937),
  [17603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12025),
  [17605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [17607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12405),
  [17609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [17611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [17613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10731),
  [17615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [17617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [17619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [17621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_list, 3),
  [17623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_list, 3),
  [17625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_tuple, 4),
  [17627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_tuple, 4),
  [17629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [17631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12053),
  [17633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [17635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 3),
  [17637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 3),
  [17639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11920),
  [17641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10847),
  [17643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11666),
  [17645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [17647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 2),
  [17649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 2),
  [17651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11197),
  [17653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [17655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 4),
  [17657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 4),
  [17659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11544),
  [17661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [17663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [17665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qop, 3),
  [17667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qop, 3),
  [17669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_constructor_operator, 2),
  [17671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_constructor_operator, 2),
  [17673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13548),
  [17675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12719),
  [17677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11654),
  [17679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(13259),
  [17682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 12), SHIFT(18540),
  [17685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [17687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [17689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12698),
  [17691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [17693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [17695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [17697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_operator, 1),
  [17699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_operator, 1),
  [17701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [17703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [17705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_promotable_literal, 1),
  [17707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_special, 1),
  [17709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_promotable_literal, 1),
  [17711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_constructor_special, 1),
  [17713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13349),
  [17715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13447),
  [17717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [17719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13298),
  [17721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(13259),
  [17724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18540),
  [17727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(17951),
  [17730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13407),
  [17732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(18044),
  [17735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(17902),
  [17738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(18088),
  [17741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(18250),
  [17744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(18282),
  [17747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarop_nominus, 3),
  [17749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarop_nominus, 3),
  [17751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [17753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [17755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [17757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13399),
  [17759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [17761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17344),
  [17763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [17765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18634),
  [17767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13263),
  [17769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20541),
  [17771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19368),
  [17773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18229),
  [17775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15298),
  [17777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18732),
  [17779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18515),
  [17781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17138),
  [17783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18426),
  [17785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17209),
  [17787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [17789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15358),
  [17791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19448),
  [17793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [17795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [17797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21843),
  [17799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19675),
  [17801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15036),
  [17803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21467),
  [17805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22586),
  [17807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20751),
  [17809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19780),
  [17811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20660),
  [17813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [17815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [17817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [17819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13555),
  [17821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [17823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [17825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18375),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19861),
  [17829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13500),
  [17831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18329),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [17835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [17837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17445),
  [17839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [17841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [17843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [17845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [17847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [17849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [17851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [17853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [17855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [17857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13338),
  [17859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [17861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13279),
  [17863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [17865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lazy_type, 2),
  [17867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lazy_type, 2),
  [17869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_strict_type, 2),
  [17871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_strict_type, 2),
  [17873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [17875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [17877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [17879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [17881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [17883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [17885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8342),
  [17887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [17889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [17891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [17893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [17895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [17897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [17899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [17901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13511),
  [17903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [17905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [17907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [17909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [17911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [17913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [17915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [17917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [17919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [17921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [17923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [17925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [17927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [17929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [17931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [17933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [17939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [17941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [17943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13505),
  [17945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [17947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [17949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [17951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [17953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [17955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [17957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [17959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [17961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [17963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [17965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [17967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13290),
  [17969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [17971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [17973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [17975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [17977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [17979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [17981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [17983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [17985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [17987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [17989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [17991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [17993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [17995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [17997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13224),
  [17999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [18001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [18003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [18005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [18007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [18009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [18011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [18013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [18015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [18017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [18019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13083),
  [18021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12644),
  [18023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [18025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [18027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [18029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [18031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [18033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [18035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [18037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [18039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [18041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [18043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__nalt_patterns, 1),
  [18045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__nalt_patterns, 1),
  [18047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12932),
  [18049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [18051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [18053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11538),
  [18055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [18057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [18059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [18061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [18063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [18065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [18067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [18069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [18071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10764),
  [18073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [18075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [18077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10628),
  [18079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [18081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [18083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [18085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [18087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [18089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [18091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [18093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [18095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11077),
  [18097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [18099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [18101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [18103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13837),
  [18105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [18107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12759),
  [18109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [18111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20577),
  [18113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20604),
  [18115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [18117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [18119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [18121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [18123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [18125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [18127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20611),
  [18129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20696),
  [18131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [18133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12337),
  [18135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [18137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [18139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [18141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [18143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [18145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [18147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [18149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [18151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [18153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12419),
  [18155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [18157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [18159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [18161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [18163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [18165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [18167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [18169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [18171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13022),
  [18173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [18175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [18177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [18179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [18181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [18183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [18185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [18187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [18189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13027),
  [18191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [18193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [18195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [18197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13250),
  [18199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [18201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [18203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [18205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [18207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [18209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [18211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [18213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [18215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12819),
  [18217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [18219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [18221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [18223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [18225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [18227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [18229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [18231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [18233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [18235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [18237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [18239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [18241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6622),
  [18243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11378),
  [18245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [18247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [18249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [18251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [18253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [18255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [18257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [18259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [18261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [18263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [18265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [18267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [18269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [18271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [18273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [18275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [18277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [18279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [18281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [18283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [18285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [18287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [18289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18598),
  [18291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [18293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [18295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18667),
  [18297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [18299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12266),
  [18301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [18303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [18305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [18307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [18309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [18311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18607),
  [18313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18621),
  [18315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [18317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [18319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18536),
  [18321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18588),
  [18323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [18325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [18327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [18329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18528),
  [18331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [18333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [18335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [18337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [18339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18485),
  [18341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [18343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [18345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [18347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [18349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11194),
  [18351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13030),
  [18353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [18355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [18357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [18359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [18361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13311),
  [18363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context, 2),
  [18365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__context, 2),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [18369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13264),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [18373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11198),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [18377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13032),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [18381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [18383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [18385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13519),
  [18387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [18389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [18391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [18393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [18395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [18397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [18399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context, 1),
  [18401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context, 1),
  [18403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12267),
  [18405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13288),
  [18407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13217),
  [18409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [18411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [18413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13081),
  [18415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [18417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [18419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [18421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12647),
  [18423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [18425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [18427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [18429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [18431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11380),
  [18433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [18435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11536),
  [18437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12822),
  [18439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12942),
  [18441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [18443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11098),
  [18445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10763),
  [18447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [18449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12911),
  [18451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [18453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13036),
  [18455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [18457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13175),
  [18459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [18461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10627),
  [18463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [18465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 1),
  [18467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 1),
  [18469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [18471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12427),
  [18473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13842),
  [18475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [18477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12760),
  [18479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [18481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall, 2),
  [18483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall, 2),
  [18485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [18487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [18489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12339),
  [18491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20739),
  [18493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20744),
  [18495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18369),
  [18497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20921),
  [18499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20533),
  [18501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18904),
  [18503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_if_guard, 2),
  [18505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_if_guard, 2),
  [18507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_if_guard, 2), SHIFT(506),
  [18510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2), SHIFT_REPEAT(10487),
  [18513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_case, 3, .production_id = 16),
  [18515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_case, 3, .production_id = 16),
  [18517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [18519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [18521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varop, 3),
  [18523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varop, 3),
  [18525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_arrow, 2),
  [18527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_arrow, 2),
  [18529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1),
  [18531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varop, 1),
  [18533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varop, 1),
  [18535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [18537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18364),
  [18539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [18541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18451),
  [18543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_if_guard_repeat1, 2),
  [18545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exp_if_guard_repeat1, 2),
  [18547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_if_guard_repeat1, 2), SHIFT_REPEAT(506),
  [18550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2899),
  [18553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18631),
  [18555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_infix, 3, .production_id = 58),
  [18557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_infix, 3, .production_id = 58),
  [18559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18517),
  [18561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18718),
  [18563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18707),
  [18565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [18567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20421),
  [18569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2856),
  [18572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [18574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2856),
  [18576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [18578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [18580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_operator, 2),
  [18582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_operator, 2),
  [18584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_negation, 2),
  [18586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_negation, 2),
  [18588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13858),
  [18590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tyconop, 2),
  [18592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tyconop, 2),
  [18594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_guard, 3),
  [18596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [18598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1),
  [18600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20801),
  [18602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ticked_qtycon, 3, .production_id = 29),
  [18604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ticked_qtycon, 3, .production_id = 29),
  [18606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ticked_qtycon, 3),
  [18608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ticked_qtycon, 3),
  [18610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [18612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_annotation, 2, .production_id = 41),
  [18614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_annotation, 2, .production_id = 41),
  [18616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [18618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [18620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gdpat, 3, .production_id = 60),
  [18622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gdpat, 3, .production_id = 60),
  [18624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_splice, 1),
  [18626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_param, 2, .production_id = 16),
  [18628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_param, 2, .production_id = 16),
  [18630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [18632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [18634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2835),
  [18637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [18639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_context, 2),
  [18641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_context, 2),
  [18643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [18645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_infix, 3),
  [18647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_infix, 3),
  [18649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [18651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [18653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_in, 2, .production_id = 16),
  [18655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_in, 2, .production_id = 16),
  [18657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let_in, 2),
  [18659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let_in, 2),
  [18661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_quantifiers, 3),
  [18663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_quantifiers, 3),
  [18665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_fun, 3),
  [18667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_fun, 3),
  [18669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 8, .production_id = 98),
  [18671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 8, .production_id = 98),
  [18673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 7, .production_id = 91),
  [18675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 7, .production_id = 91),
  [18677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 7, .production_id = 90),
  [18679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 7, .production_id = 90),
  [18681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13802),
  [18683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 6, .production_id = 84),
  [18685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 6, .production_id = 84),
  [18687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fexp, 1, .production_id = 5),
  [18689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fexp, 1, .production_id = 5),
  [18691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 2, .production_id = 16),
  [18693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 2, .production_id = 16),
  [18695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_case, 4, .production_id = 16),
  [18697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_case, 4, .production_id = 16),
  [18699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda, 4, .production_id = 59),
  [18701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda, 4, .production_id = 59),
  [18703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 2),
  [18705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 2),
  [18707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20572),
  [18709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [18711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [18713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [18715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2909),
  [18718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [18720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2848),
  [18723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [18725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [18727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [18729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [18731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [18733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [18735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [18737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [18739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11991),
  [18741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [18743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [18745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [18747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [18749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12412),
  [18751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11027),
  [18753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12523),
  [18755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11489),
  [18757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12312),
  [18759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [18761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [18763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [18765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10974),
  [18767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [18769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [18771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [18773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [18775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11832),
  [18777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [18779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [18781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [18783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [18785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13240),
  [18787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [18789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [18791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11154),
  [18793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [18795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12486),
  [18797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [18799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [18801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12499),
  [18803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [18805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12425),
  [18807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12171),
  [18809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [18811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [18813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13123),
  [18815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [18817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [18819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11892),
  [18821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12426),
  [18823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11800),
  [18825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12471),
  [18827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10666),
  [18829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11941),
  [18831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12669),
  [18833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11834),
  [18835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [18837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2930),
  [18840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [18842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13291),
  [18844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20659),
  [18846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10903),
  [18848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10636),
  [18850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [18852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [18854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [18856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10863),
  [18858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12833),
  [18860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [18862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [18864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [18866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11113),
  [18868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13560),
  [18870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12035),
  [18872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12183),
  [18874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10618),
  [18876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [18878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12055),
  [18880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [18882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20732),
  [18884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [18886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [18888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14721),
  [18890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11137),
  [18892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21992),
  [18894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18776),
  [18896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15033),
  [18898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22013),
  [18900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [18902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [18904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12689),
  [18906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11415),
  [18908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12736),
  [18910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10594),
  [18912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [18914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12874),
  [18916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12680),
  [18918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [18920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [18922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11741),
  [18924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12490),
  [18926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [18928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [18930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [18932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [18934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11701),
  [18936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13656),
  [18938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [18940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [18942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [18944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12315),
  [18946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [18948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23128),
  [18950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22414),
  [18952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [18954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [18956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13134),
  [18958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13147),
  [18960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [18962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [18964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [18966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [18968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [18970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [18972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [18974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [18976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8049),
  [18978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [18980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [18982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 55),
  [18984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [18986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13717),
  [18988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16064),
  [18990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14323),
  [18992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14932),
  [18994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [18996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8887),
  [18998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [19000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [19002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [19004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [19006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [19008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [19010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [19012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [19014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [19016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [19018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [19020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17610),
  [19022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17677),
  [19024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [19026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [19028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [19030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [19032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15781),
  [19034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16185),
  [19036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [19038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 3, .production_id = 31),
  [19040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7593),
  [19042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7633),
  [19044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [19046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11292),
  [19048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [19050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [19052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [19054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [19056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2879),
  [19059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [19061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [19063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [19065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [19067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10242),
  [19069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [19071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [19073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [19075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13912),
  [19077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14412),
  [19079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [19081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [19083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [19085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [19087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [19089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [19091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [19093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20436),
  [19095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [19097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [19099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [19101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [19103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [19105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [19107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [19109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [19111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 2, .production_id = 19),
  [19113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2903),
  [19116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [19118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [19120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8168),
  [19122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [19124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13787),
  [19126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [19128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [19130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat, 1),
  [19132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16246),
  [19134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [19136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8679),
  [19138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8698),
  [19140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [19142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2822),
  [19145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [19147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13794),
  [19149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [19151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10059),
  [19153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10105),
  [19155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [19157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13491),
  [19159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13850),
  [19161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [19163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [19165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8965),
  [19167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [19169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14721),
  [19171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20214),
  [19173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [19175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14968),
  [19177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15388),
  [19179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [19181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [19183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [19185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [19187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14433),
  [19189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14553),
  [19191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [19193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9540),
  [19195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9658),
  [19197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [19199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11518),
  [19201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [19203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9139),
  [19205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9229),
  [19207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [19209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9546),
  [19211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9640),
  [19213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [19215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [19217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [19219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13739),
  [19221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15683),
  [19223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11191),
  [19225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [19227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [19229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [19231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [19233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [19235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7653),
  [19237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [19239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [19241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [19243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [19245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [19247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8299),
  [19249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [19251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9820),
  [19253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [19255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9158),
  [19257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9167),
  [19259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [19261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [19263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [19265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [19267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [19269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [19271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [19273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [19275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [19277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14764),
  [19279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14933),
  [19281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [19283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10425),
  [19285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [19287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9753),
  [19289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [19291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [19293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14761),
  [19295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14997),
  [19297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [19299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7681),
  [19301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [19303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [19305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [19307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [19309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [19311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [19313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [19315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14533),
  [19317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14662),
  [19319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [19321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13578),
  [19323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13966),
  [19325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [19327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [19329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [19331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [19333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [19335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14578),
  [19337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15222),
  [19339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [19341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13204),
  [19343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [19345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9657),
  [19347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [19349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [19351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11878),
  [19353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [19355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [19357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [19359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [19361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [19363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [19365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [19367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [19369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11587),
  [19371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [19373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [19375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7955),
  [19377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [19379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9618),
  [19381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9475),
  [19383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [19385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14370),
  [19387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14927),
  [19389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [19391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11771),
  [19393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [19395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9147),
  [19397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8898),
  [19399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [19401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11483),
  [19403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [19405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7645),
  [19407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7861),
  [19409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [19411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21636),
  [19413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21290),
  [19415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11756),
  [19417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [19419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9024),
  [19421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [19423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [19425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12518),
  [19427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [19429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [19431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [19433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [19435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [19437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [19439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [19441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [19443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [19445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [19447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [19449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12606),
  [19451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [19453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14923),
  [19455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15599),
  [19457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [19459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [19461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [19463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [19465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [19467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [19469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [19471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8208),
  [19473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [19475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [19477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [19479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [19481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [19483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [19485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [19487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [19489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10361),
  [19491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [19493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [19495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [19497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [19499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [19501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [19503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7353),
  [19505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [19507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [19509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [19511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [19513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9442),
  [19515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9390),
  [19517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [19519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [19521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [19523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2847),
  [19526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [19528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7451),
  [19530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [19532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [19534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9273),
  [19536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9172),
  [19538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [19540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15789),
  [19542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15826),
  [19544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [19546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [19548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [19550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9622),
  [19552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9477),
  [19554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [19556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16462),
  [19558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16694),
  [19560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [19562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [19564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [19566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [19568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14445),
  [19570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14683),
  [19572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [19574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9133),
  [19576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9195),
  [19578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [19580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9678),
  [19582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [19584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [19586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [19588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9085),
  [19590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [19592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2822),
  [19594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [19596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7190),
  [19598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [19600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [19602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [19604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [19606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9637),
  [19608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9449),
  [19610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [19612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12075),
  [19614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [19616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [19618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [19620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [19622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [19624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [19626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [19628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10861),
  [19630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [19632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6401),
  [19634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [19636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [19638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [19640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [19642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [19644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10889),
  [19646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [19648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [19650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [19652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [19654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [19656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8130),
  [19658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [19660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [19662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [19664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2840),
  [19667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [19669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [19671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [19673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [19675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [19677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [19679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [19681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [19683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12714),
  [19685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [19687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [19689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [19691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [19693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [19695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8062),
  [19697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [19699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [19701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13037),
  [19703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [19705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12162),
  [19707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [19709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [19711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [19713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11816),
  [19715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [19717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8043),
  [19719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8137),
  [19721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [19723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [19725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [19727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [19729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [19731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [19733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [19735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [19737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [19739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12251),
  [19741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [19743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [19745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [19747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [19749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21837),
  [19751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9182),
  [19753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8944),
  [19755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [19757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11373),
  [19759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [19761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [19763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [19765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [19767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [19769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8699),
  [19771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [19773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20655),
  [19775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2807),
  [19778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [19780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [19782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [19784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [19786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [19788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2851),
  [19791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [19793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10648),
  [19795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20932),
  [19797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [19799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2837),
  [19802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [19804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2859),
  [19807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [19809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [19811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2814),
  [19814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [19816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [19818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13616),
  [19820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16769),
  [19822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2862),
  [19825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [19827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [19829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20764),
  [19831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15688),
  [19833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [19835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21117),
  [19837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [19839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2866),
  [19842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21043),
  [19844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13716),
  [19846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2935),
  [19849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [19851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2829),
  [19854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [19856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2800),
  [19859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [19861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [19863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [19865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17072),
  [19867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17702),
  [19869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17041),
  [19871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17459),
  [19873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20820),
  [19875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20925),
  [19877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16946),
  [19879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16921),
  [19881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17074),
  [19883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17075),
  [19885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13847),
  [19887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20597),
  [19889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [19891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [19893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13823),
  [19895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16167),
  [19897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21029),
  [19899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20747),
  [19901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17593),
  [19903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17431),
  [19905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17638),
  [19907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17282),
  [19909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20251),
  [19911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13780),
  [19913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15798),
  [19915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17465),
  [19917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15768),
  [19919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15784),
  [19921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13644),
  [19923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2834),
  [19926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20974),
  [19928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13749),
  [19930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19344),
  [19932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17517),
  [19934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19351),
  [19936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18996),
  [19938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20415),
  [19940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15866),
  [19942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12781),
  [19944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14077),
  [19946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22746),
  [19948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20285),
  [19950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [19952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13725),
  [19954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23201),
  [19956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15989),
  [19958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13742),
  [19960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13643),
  [19962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20191),
  [19964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13617),
  [19966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13580),
  [19968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18570),
  [19970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13819),
  [19972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22993),
  [19974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [19976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [19978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 2, .production_id = 13),
  [19980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13599),
  [19982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18653),
  [19984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 2, .production_id = 13),
  [19986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20448),
  [19988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22801),
  [19990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2918),
  [19993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16090),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16029),
  [19997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2),
  [19999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(13599),
  [20002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(18653),
  [20005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__simpletype_repeat1, 2),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10559),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20432),
  [20013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typed_pat, 1),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10571),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22671),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15852),
  [20021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22553),
  [20023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 4, .production_id = 28),
  [20025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 4, .production_id = 28),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15965),
  [20029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(13580),
  [20032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(18570),
  [20035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [20037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13846),
  [20039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13709),
  [20041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [20043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13807),
  [20045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [20047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [20049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13947),
  [20051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9543),
  [20053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20715),
  [20055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13697),
  [20057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9705),
  [20059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15866),
  [20061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14109),
  [20063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [20065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15185),
  [20067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [20069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [20071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9180),
  [20073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [20075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13835),
  [20077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14643),
  [20079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9836),
  [20081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21914),
  [20083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15420),
  [20085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8904),
  [20087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [20089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 5, .production_id = 73),
  [20091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14948),
  [20093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [20095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13988),
  [20097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 56),
  [20099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13955),
  [20101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18728),
  [20103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 1),
  [20105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18601),
  [20107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14663),
  [20109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22297),
  [20111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [20113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [20115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13615),
  [20117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9313),
  [20119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(13955),
  [20122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(18728),
  [20125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22940),
  [20127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [20129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15109),
  [20131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [20133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13876),
  [20135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [20137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15063),
  [20139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [20141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15379),
  [20143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22233),
  [20145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [20147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13956),
  [20149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [20151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13728),
  [20153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 3, .production_id = 32),
  [20155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14684),
  [20157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15867),
  [20159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16007),
  [20161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23143),
  [20163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14320),
  [20165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14751),
  [20167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15914),
  [20169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8673),
  [20171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13957),
  [20173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [20175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15341),
  [20177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [20179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18183),
  [20181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9380),
  [20183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10323),
  [20185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15818),
  [20187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20509),
  [20189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [20191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [20193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14464),
  [20195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18274),
  [20197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17844),
  [20199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12983),
  [20201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17991),
  [20203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19749),
  [20205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13208),
  [20207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13920),
  [20209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20702),
  [20211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [20213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13096),
  [20215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [20217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13253),
  [20219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [20221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13194),
  [20223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12922),
  [20225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [20227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12813),
  [20229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21072),
  [20231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [20233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18018),
  [20235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [20237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 1),
  [20239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [20241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 1),
  [20243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [20245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [20247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13152),
  [20249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall, 2),
  [20251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18247),
  [20253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18249),
  [20255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18540),
  [20257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [20259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_negation, 2),
  [20261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13167),
  [20263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(13259),
  [20266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(18540),
  [20269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13254),
  [20271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21222),
  [20273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(12014),
  [20276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2),
  [20278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18247),
  [20281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18249),
  [20284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12830),
  [20286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13126),
  [20288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13236),
  [20290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18775),
  [20292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13206),
  [20294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18221),
  [20296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12792),
  [20298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12884),
  [20300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(12014),
  [20303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(18221),
  [20306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12918),
  [20308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21221),
  [20310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12978),
  [20312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13215),
  [20314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13244),
  [20316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12901),
  [20318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12924),
  [20320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [20322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13149),
  [20324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17934),
  [20326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18400),
  [20328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12807),
  [20330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13191),
  [20332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13770),
  [20334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [20336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21141),
  [20338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13199),
  [20340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13186),
  [20342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20831),
  [20344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__simpletype_repeat1, 3),
  [20346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 3),
  [20348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13116),
  [20350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12895),
  [20352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12873),
  [20354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19156),
  [20356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13174),
  [20358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13136),
  [20360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13038),
  [20362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12870),
  [20364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [20366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13097),
  [20368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13005),
  [20370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13231),
  [20372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__qualifying_module, 2),
  [20374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2),
  [20376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2), SHIFT_REPEAT(10873),
  [20379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18828),
  [20381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13190),
  [20383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13163),
  [20385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12837),
  [20387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18137),
  [20389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12920),
  [20391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall, 1),
  [20393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17937),
  [20395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12913),
  [20397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18266),
  [20399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13085),
  [20401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12896),
  [20403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13082),
  [20405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19697),
  [20407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13044),
  [20409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [20411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [20413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [20415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [20417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [20419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [20421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [20423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [20425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [20427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [20429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [20431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_role, 6),
  [20433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14960),
  [20435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12984),
  [20437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13930),
  [20439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14200),
  [20441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18608),
  [20443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 2, .production_id = 20),
  [20445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 1),
  [20447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16913),
  [20449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15655),
  [20451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 1),
  [20453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15477),
  [20455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 1),
  [20457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14882),
  [20459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [20461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [20463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [20465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [20467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [20469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13125),
  [20471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14316),
  [20473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_role, 4, .production_id = 54),
  [20475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14831),
  [20477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 3),
  [20479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11072),
  [20481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [20483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [20485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [20487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [20489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [20491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [20493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [20495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [20497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [20499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13153),
  [20501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13786),
  [20503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2),
  [20505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2), SHIFT_REPEAT(14831),
  [20508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [20510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [20512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [20514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [20516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [20518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13177),
  [20520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [20522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [20524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [20526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [20528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [20530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [20532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [20534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [20536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [20538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [20540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), REDUCE(sym_constraint, 1),
  [20543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12388),
  [20545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [20547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [20549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [20551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [20553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18074),
  [20555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_guards, 2),
  [20557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_guards, 2), SHIFT_REPEAT(506),
  [20560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 2),
  [20562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11059),
  [20564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [20566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [20568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [20570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [20572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [20574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [20576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [20578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [20580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [20582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_role, 4),
  [20584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(14459),
  [20587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simpletype_repeat1, 2), SHIFT_REPEAT(18608),
  [20590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12841),
  [20592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [20594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [20596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [20598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [20600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11633),
  [20602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [20604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [20606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [20608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [20610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [20612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [20614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [20616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [20618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [20620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17447),
  [20622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16085),
  [20624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12898),
  [20626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13661),
  [20628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2), SHIFT_REPEAT(14960),
  [20631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_sig, 1),
  [20633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [20635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14204),
  [20637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 3, .production_id = 19),
  [20639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype_infix, 5, .production_id = 39),
  [20641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22296),
  [20643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19199),
  [20645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype_infix, 7, .production_id = 83),
  [20647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19307),
  [20649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype_infix, 5, .production_id = 83),
  [20651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17443),
  [20653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2),
  [20655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(15573),
  [20658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19558),
  [20660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18292),
  [20662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alt_variants, 1),
  [20664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19113),
  [20666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16975),
  [20668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19539),
  [20670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18083),
  [20672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19579),
  [20674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19882),
  [20676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype_infix, 3, .production_id = 39),
  [20678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [20680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12785),
  [20682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19595),
  [20684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19232),
  [20686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20081),
  [20688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18378),
  [20690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 2),
  [20692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13727),
  [20694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22122),
  [20696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14911),
  [20698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15066),
  [20700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15107),
  [20702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14931),
  [20704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [20706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18207),
  [20708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15303),
  [20710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19518),
  [20712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17472),
  [20714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16162),
  [20716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20359),
  [20718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17470),
  [20720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20033),
  [20722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19620),
  [20724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datainst, 3, .production_id = 30),
  [20726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19350),
  [20728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19637),
  [20730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11678),
  [20732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19496),
  [20734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18484),
  [20736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17672),
  [20738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18791),
  [20740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [20742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19655),
  [20744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18814),
  [20746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [20748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [20750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(15549),
  [20753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19470),
  [20755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18831),
  [20757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19452),
  [20759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17451),
  [20761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18127),
  [20763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19216),
  [20765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19735),
  [20767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19613),
  [20769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17450),
  [20771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18582),
  [20773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18845),
  [20775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22891),
  [20777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21220),
  [20779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18868),
  [20781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11042),
  [20783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19433),
  [20785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19457),
  [20787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19432),
  [20789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18994),
  [20791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17989),
  [20793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19408),
  [20795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19490),
  [20797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18894),
  [20799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15551),
  [20801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19523),
  [20803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15258),
  [20805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [20807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [20809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_module, 2),
  [20811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16737),
  [20813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19553),
  [20815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19583),
  [20817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4, .production_id = 62),
  [20819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14758),
  [20821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15241),
  [20823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19277),
  [20825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18875),
  [20827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19388),
  [20829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18160),
  [20831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19643),
  [20833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19676),
  [20835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [20837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 3),
  [20839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13688),
  [20841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22580),
  [20843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14709),
  [20845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15442),
  [20847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19673),
  [20849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18687),
  [20851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [20853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18003),
  [20855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12343),
  [20857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 3, .production_id = 34),
  [20859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14714),
  [20861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15447),
  [20863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14242),
  [20865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21240),
  [20867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18756),
  [20869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2), SHIFT_REPEAT(15303),
  [20872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18924),
  [20874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17876),
  [20876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19703),
  [20878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18950),
  [20880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19733),
  [20882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17889),
  [20884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19763),
  [20886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19239),
  [20888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19793),
  [20890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19101),
  [20892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19174),
  [20894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [20896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19823),
  [20898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18637),
  [20900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18973),
  [20902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 2, .production_id = 16),
  [20904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18275),
  [20906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19853),
  [20908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19883),
  [20910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15549),
  [20912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundep, 3),
  [20914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19913),
  [20916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19943),
  [20918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19973),
  [20920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20003),
  [20922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19015),
  [20924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19153),
  [20926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21662),
  [20928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19525),
  [20930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18405),
  [20932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18518),
  [20934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19264),
  [20936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20031),
  [20938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19363),
  [20940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [20942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17342),
  [20944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20059),
  [20946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19343),
  [20948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19039),
  [20950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23056),
  [20952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18150),
  [20954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18399),
  [20956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20087),
  [20958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14741),
  [20960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15154),
  [20962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20115),
  [20964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18796),
  [20966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20143),
  [20968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [20970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20171),
  [20972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20174),
  [20974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14976),
  [20976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_with_kind, 1),
  [20978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17923),
  [20980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19706),
  [20982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19064),
  [20984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17603),
  [20986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14392),
  [20988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17992),
  [20990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [20992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18280),
  [20994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10621),
  [20996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19328),
  [20998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19084),
  [21000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17600),
  [21002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18982),
  [21004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19104),
  [21006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18967),
  [21008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18559),
  [21010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 3, .production_id = 30),
  [21012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20147),
  [21014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18983),
  [21016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17857),
  [21018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14871),
  [21020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15318),
  [21022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20121),
  [21024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18161),
  [21026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20099),
  [21028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15205),
  [21030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20789),
  [21032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22271),
  [21034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20083),
  [21036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16887),
  [21038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16721),
  [21040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19140),
  [21042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20064),
  [21044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20041),
  [21046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20015),
  [21048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22222),
  [21050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qmodid, 1),
  [21052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19991),
  [21054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19969),
  [21056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15375),
  [21058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14844),
  [21060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19122),
  [21062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19160),
  [21064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19947),
  [21066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19925),
  [21068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19908),
  [21070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13039),
  [21072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14697),
  [21074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 1, .production_id = 9),
  [21076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19879),
  [21078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19858),
  [21080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [21082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19839),
  [21084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19822),
  [21086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [21088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18689),
  [21090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18326),
  [21092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18045),
  [21094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19801),
  [21096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22176),
  [21098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15168),
  [21100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20968),
  [21102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19609),
  [21104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14377),
  [21106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19843),
  [21108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18042),
  [21110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19347),
  [21112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17903),
  [21114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [21116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19789),
  [21118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19545),
  [21120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [21122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19282),
  [21124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19768),
  [21126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19751),
  [21128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15573),
  [21130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19736),
  [21132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14727),
  [21134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15156),
  [21136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14733),
  [21138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15543),
  [21140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12886),
  [21142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [21144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11085),
  [21146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19711),
  [21148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19693),
  [21150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [21152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15554),
  [21154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14798),
  [21156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18832),
  [21158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_infix, 5),
  [21160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15631),
  [21162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_head, 1, .production_id = 9),
  [21164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20613),
  [21166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19083),
  [21168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(13580),
  [21171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20795),
  [21173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [21175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18786),
  [21177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13613),
  [21179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22210),
  [21181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15020),
  [21183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15395),
  [21185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20915),
  [21187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 2, .production_id = 64),
  [21189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [21191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10637),
  [21193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21136),
  [21195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_injectivity, 4),
  [21197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13599),
  [21199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [21201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_infix, 3),
  [21203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(13599),
  [21206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15226),
  [21208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15561),
  [21210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15233),
  [21212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15566),
  [21214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4),
  [21216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15335),
  [21218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [21220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [21222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [21224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4, .production_id = 34),
  [21226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15289),
  [21228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15244),
  [21230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15240),
  [21232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 1, .production_id = 9),
  [21234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5, .production_id = 62),
  [21236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15301),
  [21238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15893),
  [21240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(12014),
  [21243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15431),
  [21245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15605),
  [21247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 3, .production_id = 37),
  [21249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 75),
  [21251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15609),
  [21253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13580),
  [21255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__foreign_pre, 1),
  [21257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreign_pre, 1),
  [21259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19107),
  [21261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_role, 1),
  [21263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15510),
  [21265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18404),
  [21267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15219),
  [21269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18279),
  [21271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 2),
  [21273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [21275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [21277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 3, .production_id = 48),
  [21279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [21281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(15631),
  [21284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15058),
  [21286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [21288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [21290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [21292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [21294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [21296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [21298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [21300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [21302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [21304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [21306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [21308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [21310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [21312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 31),
  [21314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 2, .production_id = 65),
  [21316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [21318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [21320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [21322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [21324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [21326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6, .production_id = 34),
  [21328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6, .production_id = 62),
  [21330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [21332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [21334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [21336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [21338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [21340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [21342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [21344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 6, .production_id = 73),
  [21346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2),
  [21348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(16926),
  [21351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6),
  [21353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 32),
  [21355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17951),
  [21357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18100),
  [21359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11400),
  [21361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [21363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [21365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [21367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [21369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2),
  [21371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2), SHIFT_REPEAT(2219),
  [21374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2),
  [21376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2), SHIFT_REPEAT(13717),
  [21379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17902),
  [21381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [21383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15295),
  [21385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18168),
  [21387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 2),
  [21389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17256),
  [21391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_inj, 1),
  [21393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21264),
  [21395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 4),
  [21397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 4),
  [21399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 3),
  [21401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [21403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [21405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [21407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [21409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [21411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [21413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10596),
  [21415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [21417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [21419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [21421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [21423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18195),
  [21425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2), SHIFT_REPEAT(2226),
  [21428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, .production_id = 76),
  [21430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4),
  [21432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [21434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13413),
  [21436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13342),
  [21438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21103),
  [21440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17482),
  [21442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(13955),
  [21445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21124),
  [21447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [21449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [21451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [21453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [21455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [21457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 7, .production_id = 62),
  [21459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [21461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [21463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [21465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [21467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [21469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13955),
  [21471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 5, .production_id = 56),
  [21473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [21475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(17256),
  [21478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13376),
  [21480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [21482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [21484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [21486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [21488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quantifier, 3),
  [21490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quantifier, 3),
  [21492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17864),
  [21494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_type_variable, 3),
  [21496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inferred_type_variable, 3),
  [21498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [21500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 3, .production_id = 19),
  [21502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12764),
  [21504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [21506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [21508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [21510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [21512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12290),
  [21514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [21516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [21518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [21520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [21522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12727),
  [21524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [21526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [21528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [21530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [21532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [21534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 5, .production_id = 55),
  [21536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18250),
  [21538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13439),
  [21540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18282),
  [21542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard_equation, 3, .production_id = 30),
  [21544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [21546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 4),
  [21548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, .production_id = 93),
  [21550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, .production_id = 95),
  [21552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11965),
  [21554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [21556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [21558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [21560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [21562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15393),
  [21564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 3, .production_id = 25),
  [21566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [21568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [21570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15396),
  [21572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [21574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [21576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [21578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [21580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [21582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 3),
  [21584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 3),
  [21586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [21588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [21590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [21592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [21594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [21596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 2),
  [21598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 2),
  [21600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [21602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [21604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [21606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [21608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [21610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 3, .production_id = 33),
  [21612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 2),
  [21614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 2, .production_id = 15),
  [21616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalt, 3, .production_id = 74),
  [21618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 6),
  [21620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 6),
  [21622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [21624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5, .production_id = 34),
  [21626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 6, .production_id = 101),
  [21628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11984),
  [21630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [21632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [21634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [21636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [21638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13468),
  [21640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [21642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12038),
  [21644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [21646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [21648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [21650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [21652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10897),
  [21654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [21656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [21658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [21660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [21662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 5),
  [21664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 5),
  [21666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__adt_rhs, 2),
  [21668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 1),
  [21670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5),
  [21672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 2),
  [21674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14196),
  [21676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [21678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [21680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [21682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [21684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [21686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [21688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [21690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [21692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [21694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [21696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(13259),
  [21699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 3),
  [21701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 76),
  [21703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17664),
  [21705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13020),
  [21707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [21709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [21711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [21713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [21715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12766),
  [21717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [21719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [21721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [21723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [21725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3),
  [21727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [21729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_convention, 1),
  [21731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 1),
  [21733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12333),
  [21735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [21737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [21739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [21741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [21743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__adt_rhs, 3),
  [21745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 2),
  [21747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [21749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [21751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [21753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [21755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [21757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 3),
  [21759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 6),
  [21761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 3),
  [21763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [21765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11690),
  [21767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [21769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [21771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [21773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [21775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18044),
  [21777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2), SHIFT_REPEAT(13739),
  [21780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 5),
  [21782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16926),
  [21784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20040),
  [21786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12563),
  [21788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [21790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [21792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [21794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [21796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20343),
  [21798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [21800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [21802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [21804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [21806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [21808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [21810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [21812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [21814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [21816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [21818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17957),
  [21820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12360),
  [21822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [21824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [21826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [21828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [21830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17490),
  [21832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 4),
  [21834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [21836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [21838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [21840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [21842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [21844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18088),
  [21846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2),
  [21848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(14196),
  [21851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12375),
  [21853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 3, .production_id = 30),
  [21855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [21857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8910),
  [21859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9468),
  [21861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20210),
  [21863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [21865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14215),
  [21867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_result_type, 4),
  [21869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8828),
  [21871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14849),
  [21873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 3, .production_id = 20),
  [21875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12095),
  [21877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [21879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13882),
  [21881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18646),
  [21883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [21885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 1),
  [21887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [21889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [21891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15130),
  [21893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9372),
  [21895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10592),
  [21897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [21899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 3),
  [21901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [21903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [21905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [21907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9838),
  [21909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(14215),
  [21912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 4, .production_id = 37),
  [21914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_result_type, 2),
  [21916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14641),
  [21918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [21920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9275),
  [21922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [21924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12949),
  [21926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [21928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 1),
  [21930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14504),
  [21932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14610),
  [21934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14690),
  [21936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10807),
  [21938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10302),
  [21940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [21942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10972),
  [21944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [21946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [21948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [21950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [21952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2), SHIFT_REPEAT(2048),
  [21955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2),
  [21957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9345),
  [21959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [21961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_record, 2),
  [21963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9162),
  [21965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [21967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [21969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15883),
  [21971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [21973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [21975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21067),
  [21977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [21979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21176),
  [21981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 3, .production_id = 78),
  [21983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [21985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [21987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12527),
  [21989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12493),
  [21991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_field_repeat1, 2, .production_id = 81), SHIFT_REPEAT(21176),
  [21994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_field_repeat1, 2, .production_id = 81),
  [21996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [21998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14737),
  [22000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [22002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [22004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 4),
  [22006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12078),
  [22008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8676),
  [22010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [22012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [22014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 2),
  [22016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [22018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [22020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [22022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [22024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12390),
  [22026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [22028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6754),
  [22030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15471),
  [22032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 4),
  [22034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_infix, 5),
  [22036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 4),
  [22038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6137),
  [22040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9806),
  [22042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [22044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10728),
  [22046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [22048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [22050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15264),
  [22052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [22054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [22056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 2, .production_id = 16),
  [22058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10555),
  [22060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [22062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12796),
  [22064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18489),
  [22066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [22068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9845),
  [22070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [22072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [22074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14503),
  [22076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 29),
  [22078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [22080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [22082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, .production_id = 16),
  [22084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [22086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [22088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [22090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11296),
  [22092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [22094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [22096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [22098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [22100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [22102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 4, .production_id = 30),
  [22104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [22106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [22108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [22110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [22112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13059),
  [22114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [22116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [22118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11861),
  [22120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [22122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14231),
  [22124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 2),
  [22126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14387),
  [22128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14586),
  [22130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9485),
  [22132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12586),
  [22134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [22136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [22138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9124),
  [22140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20361),
  [22142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [22144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [22146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [22148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 1, .production_id = 46),
  [22150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [22152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [22154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [22156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10733),
  [22158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9169),
  [22160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [22162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [22164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9585),
  [22166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [22168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 3),
  [22170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14862),
  [22172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [22174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [22176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [22178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12755),
  [22180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11811),
  [22182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [22184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [22186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [22188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14719),
  [22190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [22192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 2),
  [22194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [22196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [22198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11797),
  [22200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [22202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7694),
  [22204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9365),
  [22206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [22208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [22210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [22212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [22214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [22216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [22218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [22220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12439),
  [22222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [22224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16226),
  [22226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [22228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9524),
  [22230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 2, .production_id = 48),
  [22232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14898),
  [22234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [22236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 1, .production_id = 12),
  [22238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12417),
  [22240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9595),
  [22242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [22244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2),
  [22246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2), SHIFT_REPEAT(505),
  [22249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13451),
  [22251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [22253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(14387),
  [22256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9289),
  [22258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13628),
  [22260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [22262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [22264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10653),
  [22266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9014),
  [22268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7279),
  [22270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10883),
  [22272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [22274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15951),
  [22276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12702),
  [22278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11123),
  [22280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7053),
  [22282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [22284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14425),
  [22286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [22288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [22290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [22292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [22294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8644),
  [22296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [22298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [22300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11623),
  [22302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [22304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [22306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14107),
  [22308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7885),
  [22310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 3),
  [22312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_or_implicit, 1),
  [22314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_or_implicit, 1), SHIFT(20835),
  [22317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_or_implicit, 1), SHIFT(2632),
  [22320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12049),
  [22322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [22324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [22326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20339),
  [22328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [22330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11584),
  [22332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [22334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [22336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [22338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [22340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [22342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [22344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15567),
  [22346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14373),
  [22348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8889),
  [22350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12953),
  [22352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [22354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11641),
  [22356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12220),
  [22358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [22360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [22362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [22364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9432),
  [22366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14826),
  [22368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9043),
  [22370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15423),
  [22372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9588),
  [22374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15123),
  [22376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [22378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12169),
  [22380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 2, .production_id = 66),
  [22382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [22384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12350),
  [22386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [22388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7654),
  [22390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [22392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [22394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [22396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17736),
  [22398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16687),
  [22400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14418),
  [22402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14908),
  [22404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10439),
  [22406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [22408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8575),
  [22410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [22412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14502),
  [22414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14750),
  [22416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [22418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [22420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20691),
  [22422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [22424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [22426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [22428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [22430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [22432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [22434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15084),
  [22436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [22438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15713),
  [22440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [22442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11604),
  [22444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [22446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 2),
  [22448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [22450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [22452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [22454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [22456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [22458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [22460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_infix, 3),
  [22462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [22464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12262),
  [22466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [22468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11947),
  [22470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7891),
  [22472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13681),
  [22474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [22476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11817),
  [22478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10286),
  [22480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [22482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8286),
  [22484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(14231),
  [22487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14943),
  [22489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [22491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11912),
  [22493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [22495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [22497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11576),
  [22499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [22501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10477),
  [22503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17767),
  [22505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [22507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [22509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [22511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(16687),
  [22514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [22516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [22518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [22520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2), SHIFT_REPEAT(16162),
  [22523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2), SHIFT_REPEAT(13616),
  [22526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14036),
  [22528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8842),
  [22530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2), SHIFT_REPEAT(2221),
  [22533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [22535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [22537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15434),
  [22539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9088),
  [22541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 4, .production_id = 59),
  [22543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [22545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [22547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [22549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [22551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6432),
  [22553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11407),
  [22555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [22557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [22559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14546),
  [22561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [22563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8124),
  [22565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [22567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [22569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [22571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [22573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10562),
  [22575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7784),
  [22577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12704),
  [22579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 4, .production_id = 86),
  [22581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [22583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [22585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12261),
  [22587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [22589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [22591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [22593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2, .production_id = 16),
  [22595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [22597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [22599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [22601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [22603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [22605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7525),
  [22607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [22609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [22611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [22613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [22615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10388),
  [22617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [22619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10266),
  [22621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8751),
  [22623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [22625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10391),
  [22627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [22629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9986),
  [22631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [22633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10401),
  [22635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [22637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [22639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9980),
  [22641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [22643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14430),
  [22645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [22647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [22649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [22651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7295),
  [22653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9993),
  [22655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9903),
  [22657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [22659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [22661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10410),
  [22663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [22665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [22667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [22669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [22671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10395),
  [22673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [22675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9995),
  [22677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9983),
  [22679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10413),
  [22681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [22683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [22685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [22687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [22689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [22691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9886),
  [22693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [22695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [22697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [22699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [22701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [22703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [22705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10374),
  [22707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [22709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [22711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [22713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [22715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [22717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8750),
  [22719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10248),
  [22721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat1, 2), SHIFT_REPEAT(2053),
  [22724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat1, 2),
  [22726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [22728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9966),
  [22730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [22732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [22734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18920),
  [22736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [22738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [22740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [22742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10554),
  [22744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18798),
  [22746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10567),
  [22748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18892),
  [22750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [22752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10370),
  [22754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16991),
  [22756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2), SHIFT_REPEAT(2045),
  [22759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [22761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [22763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [22765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [22767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [22769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [22771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, .production_id = 75),
  [22773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [22775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [22777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8846),
  [22779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [22781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10357),
  [22783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9869),
  [22785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10429),
  [22787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [22789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [22791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [22793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10011),
  [22795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [22797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [22799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [22801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [22803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10360),
  [22805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8852),
  [22807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10432),
  [22809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9959),
  [22811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [22813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [22815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [22817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10016),
  [22819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [22821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 3, .production_id = 30),
  [22823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16174),
  [22825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [22827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [22829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [22831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18880),
  [22833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10175),
  [22835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18866),
  [22837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [22839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [22841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10356),
  [22843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7303),
  [22845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [22847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [22849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [22851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [22853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9958),
  [22855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10449),
  [22857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [22859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10019),
  [22861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [22863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [22865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat2, 2), SHIFT_REPEAT(2215),
  [22868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat2, 2),
  [22870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [22872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [22874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [22876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10039),
  [22878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [22880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10437),
  [22882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14453),
  [22884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 4),
  [22886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [22888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [22890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [22892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [22894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [22896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [22898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [22900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [22902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [22904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [22906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10041),
  [22908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__module_repeat1, 2), SHIFT_REPEAT(5),
  [22911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__module_repeat1, 2),
  [22913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [22915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10431),
  [22917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10344),
  [22919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 4),
  [22921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [22923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(14430),
  [22926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9953),
  [22928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [22930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [22932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [22934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10044),
  [22936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [22938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [22940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [22942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16000),
  [22944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [22946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [22948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [22950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20614),
  [22952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [22954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14601),
  [22956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10015),
  [22958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20695),
  [22960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [22962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [22964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20701),
  [22966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [22968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [22970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [22972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20705),
  [22974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10468),
  [22976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20740),
  [22978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [22980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [22982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20973),
  [22984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [22986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [22988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10420),
  [22990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 3),
  [22992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [22994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [22996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [22998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10048),
  [23000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [23002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [23004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10409),
  [23006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16079),
  [23008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [23010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10058),
  [23012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10025),
  [23014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20839),
  [23016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [23018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 3),
  [23020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat2, 2), SHIFT_REPEAT(15468),
  [23023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat2, 2),
  [23025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [23027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [23029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20871),
  [23031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [23033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [23035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [23037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10457),
  [23039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20879),
  [23041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10404),
  [23043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10458),
  [23045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20923),
  [23047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [23049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [23051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15653),
  [23053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [23055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [23057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [23059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10061),
  [23061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [23063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat1, 2), SHIFT_REPEAT(14194),
  [23066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat1, 2),
  [23068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7308),
  [23070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [23072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [23074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [23076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_field, 3),
  [23078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint, 1),
  [23080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10291),
  [23082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [23084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [23086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [23088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [23090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [23092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, .production_id = 76),
  [23094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [23096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [23098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [23100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9897),
  [23102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5),
  [23104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [23106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat2, 2), SHIFT_REPEAT(1997),
  [23109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat2, 2),
  [23111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8277),
  [23113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8302),
  [23115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [23117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [23119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1800),
  [23122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [23124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [23126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [23128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8807),
  [23130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10087),
  [23132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [23134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [23136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10373),
  [23138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, .production_id = 57),
  [23140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [23142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [23144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8800),
  [23146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [23148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7331),
  [23150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [23152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_nalts_repeat1, 2), SHIFT_REPEAT(3281),
  [23155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nalts_repeat1, 2),
  [23157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10256),
  [23159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [23161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [23163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10096),
  [23165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [23167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [23169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [23171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10363),
  [23173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [23175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10384),
  [23177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7531),
  [23179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10086),
  [23181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [23183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [23185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7473),
  [23187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [23189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [23191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10417),
  [23193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10109),
  [23195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16019),
  [23197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_nalts_repeat2, 2), SHIFT_REPEAT(3521),
  [23200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nalts_repeat2, 2),
  [23202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [23204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [23206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14597),
  [23208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [23210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [23212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [23214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8787),
  [23216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2), SHIFT_REPEAT(2852),
  [23219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2),
  [23221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_fun, 1, .dynamic_precedence = 1, .production_id = 8),
  [23223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [23225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [23227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [23229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10372),
  [23231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20351),
  [23233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9998),
  [23235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9974),
  [23237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [23239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10435),
  [23241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10040),
  [23243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8717),
  [23245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10092),
  [23247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [23249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21192),
  [23251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [23253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [23255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21197),
  [23257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [23259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [23261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [23263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [23265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [23267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [23269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10381),
  [23271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [23273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alt_variants, 2, .production_id = 48),
  [23275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10353),
  [23277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alts_repeat2, 2), SHIFT_REPEAT(3113),
  [23280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat2, 2),
  [23282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [23284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [23286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [23288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [23290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [23292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8776),
  [23294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10117),
  [23296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [23298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [23300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [23302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [23304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [23306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [23308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat3, 2), SHIFT_REPEAT(3558),
  [23311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat3, 2),
  [23313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [23315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8786),
  [23317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [23319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9992),
  [23321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10530),
  [23323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18709),
  [23325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [23327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19243),
  [23329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat2, 2), SHIFT_REPEAT(3491),
  [23332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat2, 2),
  [23334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [23336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [23338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19261),
  [23340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [23342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8880),
  [23344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10418),
  [23346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10423),
  [23348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [23350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [23352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [23354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18683),
  [23356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [23358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [23360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [23362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [23364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [23366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10191),
  [23368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18679),
  [23370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16182),
  [23372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10017),
  [23374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15924),
  [23376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10288),
  [23378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [23380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14626),
  [23382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10207),
  [23384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [23386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10265),
  [23388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [23390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [23392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [23394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10189),
  [23396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18655),
  [23398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [23400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10185),
  [23402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [23404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [23406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10450),
  [23408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [23410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funpat, 2, .production_id = 25),
  [23412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [23414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10281),
  [23416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [23418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10214),
  [23420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8767),
  [23422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [23424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10259),
  [23426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7517),
  [23428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [23430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [23432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [23434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [23436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10199),
  [23438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8882),
  [23440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10222),
  [23442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [23444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10254),
  [23446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [23448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10307),
  [23450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [23452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_via, 2),
  [23454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10051),
  [23456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [23458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [23460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7321),
  [23462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [23464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14325),
  [23466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14738),
  [23468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [23470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10321),
  [23472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [23474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [23476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [23478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9941),
  [23480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [23482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10219),
  [23484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [23486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [23488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8759),
  [23490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [23492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [23494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [23496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [23498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [23500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [23502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10337),
  [23504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [23506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [23508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [23510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [23512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [23514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [23516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2),
  [23518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2), SHIFT_REPEAT(21067),
  [23521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8785),
  [23523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 6, .production_id = 93),
  [23525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [23527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 6, .production_id = 95),
  [23529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [23531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [23533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [23535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [23537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_field_repeat1, 2, .production_id = 79),
  [23539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rec_repeat1, 2), SHIFT_REPEAT(123),
  [23542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rec_repeat1, 2),
  [23544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10244),
  [23546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [23548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rec_repeat2, 2), SHIFT_REPEAT(438),
  [23551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rec_repeat2, 2),
  [23553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [23555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [23557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [23559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [23561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15614),
  [23563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [23565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10228),
  [23567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [23569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7463),
  [23571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7332),
  [23573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10412),
  [23575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10260),
  [23577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [23579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [23581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10221),
  [23583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10053),
  [23585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_newtype, 2, .production_id = 19),
  [23587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [23589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [23591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [23593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10209),
  [23595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [23597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10274),
  [23599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [23601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [23603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [23605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [23607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 2, .production_id = 16),
  [23609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 2),
  [23611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [23613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [23615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [23617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [23619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [23621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [23623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10424),
  [23625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [23627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10206),
  [23629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [23631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [23633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10261),
  [23635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10277),
  [23637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10008),
  [23639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [23641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [23643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7460),
  [23645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [23647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10215),
  [23649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [23651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10200),
  [23653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [23655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10119),
  [23657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10282),
  [23659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [23661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [23663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [23665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10345),
  [23667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [23669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [23671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [23673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [23675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [23677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [23679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [23681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [23683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [23685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [23687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [23689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [23691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10446),
  [23693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat2, 2, .production_id = 104), SHIFT_REPEAT(3123),
  [23696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat2, 2, .production_id = 104),
  [23698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [23700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10035),
  [23702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [23704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10170),
  [23706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18613),
  [23708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8262),
  [23710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [23712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 104), SHIFT_REPEAT(2858),
  [23715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 104),
  [23717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 7, .production_id = 101),
  [23719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [23721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [23723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [23725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_inj, 2),
  [23727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10290),
  [23729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 65),
  [23731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10180),
  [23733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 64),
  [23735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [23737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10332),
  [23739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [23741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10293),
  [23743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2),
  [23745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [23747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [23749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10171),
  [23751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [23753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [23755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [23757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16100),
  [23759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10143),
  [23761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [23763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [23765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_newtype, 1, .production_id = 9),
  [23767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [23769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10326),
  [23771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7341),
  [23773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [23775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10300),
  [23777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [23779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10160),
  [23781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2),
  [23783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [23785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [23787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10146),
  [23789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [23791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10327),
  [23793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [23795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [23797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [23799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16087),
  [23801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [23803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10383),
  [23805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [23807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10082),
  [23809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10140),
  [23811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [23813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14587),
  [23815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [23817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10378),
  [23819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10331),
  [23821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [23823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [23825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10089),
  [23827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10137),
  [23829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [23831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8753),
  [23833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10335),
  [23835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7535),
  [23837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [23839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10375),
  [23841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [23843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10098),
  [23845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10196),
  [23847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18529),
  [23849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [23851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [23853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [23855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2),
  [23857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2), SHIFT_REPEAT(14),
  [23860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 1),
  [23862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15919),
  [23864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [23866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [23868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10197),
  [23870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18486),
  [23872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10205),
  [23874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18483),
  [23876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [23878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [23880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [23882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [23884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [23886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [23888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18468),
  [23890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10546),
  [23892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18442),
  [23894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10153),
  [23896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [23898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2, .production_id = 43),
  [23900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2, .production_id = 43), SHIFT_REPEAT(18063),
  [23903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [23905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [23907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2, .production_id = 22),
  [23909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 2, .production_id = 29),
  [23911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [23913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [23915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [23917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8307),
  [23919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 2, .production_id = 27),
  [23921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10362),
  [23923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [23925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [23927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10108),
  [23929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15791),
  [23931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7352),
  [23933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [23935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10346),
  [23937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10211),
  [23939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [23941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [23943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10264),
  [23945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10104),
  [23947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [23949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [23951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [23953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18394),
  [23955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [23957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [23959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18391),
  [23961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [23963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [23965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [23967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [23969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [23971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [23973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8754),
  [23975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [23977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10367),
  [23979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [23981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [23983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [23985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10100),
  [23987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [23989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10225),
  [23991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [23993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [23995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [23997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10093),
  [23999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [24001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10376),
  [24003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [24005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [24007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10250),
  [24009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7441),
  [24011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10319),
  [24013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10525),
  [24015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18382),
  [24017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10521),
  [24019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18367),
  [24021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9866),
  [24023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [24025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [24027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18356),
  [24029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [24031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [24033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [24035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10085),
  [24037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8755),
  [24039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8756),
  [24041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [24043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10385),
  [24045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [24047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [24049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [24051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7440),
  [24053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10080),
  [24055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [24057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10387),
  [24059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10314),
  [24061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [24063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [24065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [24067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [24069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7556),
  [24071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10227),
  [24073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15864),
  [24075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [24077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_typed, 2, .production_id = 24),
  [24079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14859),
  [24081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [24083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3, .production_id = 42),
  [24085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 5, .production_id = 70),
  [24087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7500),
  [24089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [24091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8757),
  [24093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10308),
  [24095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [24097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10237),
  [24099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [24101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10392),
  [24103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [24105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10067),
  [24107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10234),
  [24109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10459),
  [24111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18240),
  [24113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [24115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [24117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [24119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18350),
  [24121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10400),
  [24123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8799),
  [24125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [24127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [24129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10065),
  [24131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [24133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [24135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [24137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [24139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8764),
  [24141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [24143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [24145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [24147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [24149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10403),
  [24151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [24153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [24155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10056),
  [24157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [24159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [24161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [24163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 4, .production_id = 50),
  [24165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [24167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8790),
  [24169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [24171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [24173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [24175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7438),
  [24177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14995),
  [24179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8289),
  [24181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [24183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9874),
  [24185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20547),
  [24187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15915),
  [24189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2), SHIFT_REPEAT(2022),
  [24192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2),
  [24194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15817),
  [24196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [24198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14873),
  [24200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [24202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [24204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10442),
  [24206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [24208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [24210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [24212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2), SHIFT_REPEAT(2047),
  [24215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [24217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10238),
  [24219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [24221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10030),
  [24223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_view, 3, .production_id = 21),
  [24225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [24227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10304),
  [24229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [24231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pat_tuple_repeat1, 2),
  [24233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_tuple_repeat1, 2), SHIFT_REPEAT(501),
  [24236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7436),
  [24238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [24240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10164),
  [24242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10028),
  [24244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [24246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [24248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10451),
  [24250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [24252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [24254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [24256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [24258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalt, 2, .production_id = 74),
  [24260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15296),
  [24262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8769),
  [24264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [24266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [24268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [24270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 3),
  [24272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [24274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [24276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [24278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [24280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [24282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [24284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10258),
  [24286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10445),
  [24288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10311),
  [24290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10018),
  [24292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10218),
  [24294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7569),
  [24296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [24298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [24300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10433),
  [24302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [24304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [24306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10270),
  [24308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10014),
  [24310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [24312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [24314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10212),
  [24316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [24318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [24320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [24322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [24324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [24326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10430),
  [24328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [24330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10329),
  [24332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10010),
  [24334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [24336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 2, .production_id = 25),
  [24338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15228),
  [24340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [24342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [24344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [24346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7570),
  [24348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [24350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [24352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [24354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [24356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10278),
  [24358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10131),
  [24360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [24362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [24364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10194),
  [24366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10005),
  [24368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [24370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [24372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10421),
  [24374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 4, .production_id = 48),
  [24376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [24378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [24380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [24382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [24384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10147),
  [24386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [24388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [24390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [24392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10003),
  [24394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [24396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [24398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2), SHIFT_REPEAT(15),
  [24401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10419),
  [24403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10328),
  [24405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 3),
  [24407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint, 3),
  [24409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [24411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10001),
  [24413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [24415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10366),
  [24417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [24419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10135),
  [24421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [24423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10347),
  [24425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [24427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [24429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [24431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15899),
  [24433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [24435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [24437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [24439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(2407),
  [24442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10411),
  [24444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [24446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [24448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10330),
  [24450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10134),
  [24452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [24454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [24456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [24458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [24460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9985),
  [24462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [24464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [24466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10343),
  [24468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [24470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [24472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [24474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [24476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7426),
  [24478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [24480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [24482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10393),
  [24484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [24486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [24488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [24490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15291),
  [24492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [24494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7561),
  [24496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [24498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [24500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9961),
  [24502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [24504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10354),
  [24506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [24508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [24510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [24512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [24514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10350),
  [24516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [24518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10107),
  [24520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [24522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [24524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [24526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [24528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [24530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [24532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [24534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [24536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9999),
  [24538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [24540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [24542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [24544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [24546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [24548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [24550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [24552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 1),
  [24554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [24556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [24558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [24560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10333),
  [24562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [24564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [24566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [24568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9990),
  [24570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [24572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10397),
  [24574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [24576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [24578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10380),
  [24580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [24582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [24584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [24586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [24588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10216),
  [24590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [24592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10245),
  [24594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10317),
  [24596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9935),
  [24598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7389),
  [24600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10236),
  [24602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10042),
  [24604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [24606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10310),
  [24608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10438),
  [24610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [24612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [24614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [24616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [24618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [24620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [24622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10038),
  [24624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [24626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [24628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [24630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [24632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [24634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [24636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [24638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [24640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [24642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [24644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [24646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [24648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10441),
  [24650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [24652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [24654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [24656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10032),
  [24658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [24660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [24662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10295),
  [24664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [24666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10306),
  [24668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [24670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [24672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [24674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [24676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10292),
  [24678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [24680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [24682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [24684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [24686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [24688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [24690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9981),
  [24692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [24694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [24696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2, .dynamic_precedence = 1),
  [24698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 3, .production_id = 61),
  [24700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20855),
  [24702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [24704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [24706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7564),
  [24708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20893),
  [24710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [24712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [24714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [24716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10267),
  [24718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [24720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [24722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [24724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7412),
  [24726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10263),
  [24728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9887),
  [24730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [24732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [24734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [24736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9880),
  [24738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [24740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10255),
  [24742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10249),
  [24744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [24746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [24748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [24750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9885),
  [24752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [24754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9877),
  [24756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [24758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [24760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10247),
  [24762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [24764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10324),
  [24766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7410),
  [24768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10257),
  [24770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [24772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7572),
  [24774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [24776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [24778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10320),
  [24780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10246),
  [24782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 1, .production_id = 12),
  [24784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [24786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9888),
  [24788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [24790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [24792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [24794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [24796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10299),
  [24798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [24800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [24802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [24804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [24806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [24808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 1),
  [24810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [24812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7407),
  [24814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [24816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [24818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [24820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10251),
  [24822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10239),
  [24824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [24826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [24828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [24830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18342),
  [24832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [24834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [24836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [24838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9818),
  [24840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13068),
  [24842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [24844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20905),
  [24846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [24848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [24850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 4, .production_id = 20),
  [24852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13195),
  [24854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10490),
  [24856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20372),
  [24858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13916),
  [24860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [24862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13185),
  [24864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13671),
  [24866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13900),
  [24868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20736),
  [24870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13229),
  [24872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18291),
  [24874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13148),
  [24876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [24878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_default, 4),
  [24880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [24882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20240),
  [24884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9704),
  [24886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [24888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [24890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9744),
  [24892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10208),
  [24894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13033),
  [24896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_export, 4),
  [24898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [24900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [24902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20239),
  [24904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13180),
  [24906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [24908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_special, 1),
  [24910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [24912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20410),
  [24914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 4),
  [24916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12921),
  [24918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12989),
  [24920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [24922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20255),
  [24924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10533),
  [24926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20376),
  [24928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7069),
  [24930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13080),
  [24932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [24934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20447),
  [24936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13122),
  [24938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13960),
  [24940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13238),
  [24942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(2403),
  [24945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [24947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14000),
  [24949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [24951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [24953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_import, 4),
  [24955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [24957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [24959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18722),
  [24961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10584),
  [24963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12808),
  [24965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13878),
  [24967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [24969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12829),
  [24971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [24973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13886),
  [24975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13674),
  [24977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [24979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [24981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13983),
  [24983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16247),
  [24985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datainst, 4, .production_id = 30),
  [24987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12832),
  [24989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [24991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 2, .production_id = 63),
  [24993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [24995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20378),
  [24997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [24999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7778),
  [25001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20382),
  [25003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12847),
  [25005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_newtype, 4, .production_id = 32),
  [25007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10504),
  [25009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [25011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12667),
  [25013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13959),
  [25015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [25017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [25019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [25021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16236),
  [25023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 2),
  [25025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [25027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18712),
  [25029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [25031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [25033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [25035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13830),
  [25037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17865),
  [25039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [25041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13237),
  [25043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13994),
  [25045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13176),
  [25047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [25049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20394),
  [25051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [25053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [25055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20373),
  [25057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18710),
  [25059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13565),
  [25061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_equals, 3, .production_id = 61),
  [25063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [25065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15056),
  [25067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [25069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10548),
  [25071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13729),
  [25073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [25075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [25077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18019),
  [25079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [25081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [25083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [25085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20581),
  [25087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19040),
  [25089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [25091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_type, 4, .production_id = 59),
  [25093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15217),
  [25095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [25097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [25099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [25101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [25103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15220),
  [25105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [25107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [25109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 16),
  [25111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_type, 4, .production_id = 19),
  [25113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7726),
  [25115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 17),
  [25117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [25119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [25121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20383),
  [25123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8103),
  [25125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20390),
  [25127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 3),
  [25129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 3),
  [25131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20677),
  [25133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 18),
  [25135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15319),
  [25137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12456),
  [25139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [25141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12491),
  [25143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11908),
  [25145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20408),
  [25147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8384),
  [25149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [25151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11917),
  [25153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20403),
  [25155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8397),
  [25157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11080),
  [25159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18314),
  [25161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyinst, 3),
  [25163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10262),
  [25165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12619),
  [25167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10253),
  [25169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12626),
  [25171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10235),
  [25173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [25175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [25177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [25179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12633),
  [25181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_strategy, 1),
  [25183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_default, 5),
  [25185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [25187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [25189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_deriving, 2),
  [25191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyinst, 2),
  [25193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11841),
  [25195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20424),
  [25197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [25199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [25201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 5, .production_id = 37),
  [25203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [25205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [25207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10338),
  [25209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [25211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12663),
  [25213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_import, 5),
  [25215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12682),
  [25217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7598),
  [25219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8761),
  [25221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20399),
  [25223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10341),
  [25225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14917),
  [25227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20419),
  [25229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6194),
  [25231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14870),
  [25233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20425),
  [25235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [25237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18643),
  [25239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21100),
  [25241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_with_kind, 2),
  [25243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_export, 5),
  [25245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind, 1, .production_id = 21),
  [25247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [25249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [25251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [25253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12695),
  [25255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [25257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10443),
  [25259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 1, .production_id = 21),
  [25261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [25263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10598),
  [25265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [25267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [25269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 1),
  [25271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10444),
  [25273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17065),
  [25275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [25277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14777),
  [25279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20438),
  [25281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15051),
  [25283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10595),
  [25285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [25287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_tuple_repeat1, 2), SHIFT_REPEAT(497),
  [25290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [25292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [25294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10585),
  [25296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18633),
  [25298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 5),
  [25300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13705),
  [25302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21246),
  [25304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [25306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [25308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [25310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10394),
  [25312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [25314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20409),
  [25316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8728),
  [25318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20417),
  [25320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 6, .production_id = 30),
  [25322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [25324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18630),
  [25326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13741),
  [25328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10605),
  [25330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [25332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [25334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10588),
  [25336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16166),
  [25338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10604),
  [25340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10607),
  [25342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13760),
  [25344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [25346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16097),
  [25348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [25350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10553),
  [25352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16075),
  [25354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10560),
  [25356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16073),
  [25358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [25360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [25362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20730),
  [25364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [25366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16014),
  [25368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [25370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [25372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16005),
  [25374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10614),
  [25376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10597),
  [25378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [25380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20466),
  [25382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10461),
  [25384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [25386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20471),
  [25388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10517),
  [25390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13610),
  [25392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13626),
  [25394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [25396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [25398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [25400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [25402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 4),
  [25404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [25406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [25408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [25410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [25412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20449),
  [25414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [25416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20498),
  [25418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14061),
  [25420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [25422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13704),
  [25424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 4),
  [25426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [25428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [25430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 2, .production_id = 16),
  [25432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 38),
  [25434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 38), SHIFT_REPEAT(920),
  [25437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13778),
  [25439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [25441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [25443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [25445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [25447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20492),
  [25449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [25451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20472),
  [25453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [25455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20504),
  [25457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [25459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20480),
  [25461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10480),
  [25463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10479),
  [25465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14087),
  [25467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 4),
  [25469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18603),
  [25471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [25473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [25475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [25477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13757),
  [25479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2, .dynamic_precedence = 1),
  [25481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [25483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13761),
  [25485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [25487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [25489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10851),
  [25491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10864),
  [25493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [25495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10482),
  [25497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10483),
  [25499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15675),
  [25501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18595),
  [25503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [25505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [25507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20528),
  [25509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14809),
  [25511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [25513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [25515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_type, 2, .production_id = 16),
  [25517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [25519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [25521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13793),
  [25523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [25525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18593),
  [25527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16999),
  [25529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_default, 3),
  [25531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14130),
  [25533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14360),
  [25535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10177),
  [25537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17005),
  [25539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10190),
  [25541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyinst, 3),
  [25543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [25545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20540),
  [25547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datafam, 3, .production_id = 36),
  [25549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14435),
  [25551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10805),
  [25553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14428),
  [25555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [25557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10830),
  [25559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [25561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [25563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10828),
  [25565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [25567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [25569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [25571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [25573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [25575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_deriving, 3),
  [25577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [25579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20568),
  [25581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14342),
  [25583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10377),
  [25585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [25587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10822),
  [25589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_newtype, 3, .production_id = 19),
  [25591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18672),
  [25593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 6),
  [25595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_type, 3, .production_id = 32),
  [25597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [25599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 7, .production_id = 30),
  [25601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14295),
  [25603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [25605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10124),
  [25607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10115),
  [25609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [25611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14294),
  [25613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20835),
  [25615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [25617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [25619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11628),
  [25621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11614),
  [25623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10793),
  [25625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18565),
  [25627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10819),
  [25629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11778),
  [25631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20527),
  [25633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [25635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20529),
  [25637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [25639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14174),
  [25641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14173),
  [25643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [25645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [25647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11650),
  [25649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10866),
  [25651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11607),
  [25653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17183),
  [25655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18564),
  [25657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 6, .production_id = 61),
  [25659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 7, .production_id = 34),
  [25661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [25663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [25665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 7),
  [25667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [25669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 5),
  [25671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11718),
  [25673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20559),
  [25675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11717),
  [25677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20573),
  [25679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14141),
  [25681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7587),
  [25683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20592),
  [25685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 5),
  [25687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [25689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20602),
  [25691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [25693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18563),
  [25695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_sum, 1),
  [25697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [25699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [25701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20601),
  [25703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [25705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [25707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11676),
  [25709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [25711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20607),
  [25713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [25715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [25717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12699),
  [25719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [25721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11914),
  [25723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [25725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [25727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [25729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [25731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [25733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [25735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20629),
  [25737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [25739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12672),
  [25741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [25743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20637),
  [25745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 5),
  [25747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12652),
  [25749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13640),
  [25751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11813),
  [25753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 3, .production_id = 35),
  [25755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [25757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [25759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [25761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8654),
  [25763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [25765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11744),
  [25767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11754),
  [25769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [25771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8650),
  [25773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [25775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12959),
  [25777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12958),
  [25779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12011),
  [25781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12020),
  [25783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18538),
  [25785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [25787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12553),
  [25789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12085),
  [25791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [25793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12538),
  [25795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12497),
  [25797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [25799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12517),
  [25801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [25803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11740),
  [25805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_con_tuple_repeat1, 2), SHIFT_REPEAT(18342),
  [25808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [25810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14531),
  [25812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8628),
  [25814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 7),
  [25816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [25818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 8, .production_id = 30),
  [25820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [25822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7936),
  [25824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12940),
  [25826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [25828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12938),
  [25830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12473),
  [25832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19026),
  [25834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [25836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12466),
  [25838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [25840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 9, .production_id = 30),
  [25842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [25844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9538),
  [25846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11661),
  [25848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [25850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14926),
  [25852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14305),
  [25854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20625),
  [25856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18537),
  [25858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [25860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [25862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20656),
  [25864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [25866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20669),
  [25868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9851),
  [25870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [25872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [25874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [25876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11759),
  [25878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [25880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11092),
  [25882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [25884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [25886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [25888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 7, .production_id = 100),
  [25890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 7, .production_id = 61),
  [25892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9517),
  [25894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9493),
  [25896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 2, .production_id = 38),
  [25898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [25900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20680),
  [25902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 8, .production_id = 62),
  [25904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [25906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20685),
  [25908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 6),
  [25910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [25912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20694),
  [25914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13962),
  [25916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8595),
  [25918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 6),
  [25920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14284),
  [25922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20644),
  [25924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11108),
  [25926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [25928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [25930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14296),
  [25932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20658),
  [25934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 2),
  [25936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 6),
  [25938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 38), SHIFT_REPEAT(919),
  [25941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, .production_id = 38), SHIFT_REPEAT(917),
  [25944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, .production_id = 38),
  [25946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [25948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9839),
  [25950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pat_unboxed_sum_repeat1, 2), SHIFT_REPEAT(440),
  [25953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_unboxed_sum_repeat1, 2),
  [25955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11119),
  [25957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9837),
  [25959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2, .production_id = 39),
  [25961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [25963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [25965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [25967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20704),
  [25969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [25971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [25973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 8),
  [25975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [25977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [25979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 1),
  [25981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11145),
  [25983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9832),
  [25985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11146),
  [25987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12420),
  [25989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [25991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [25993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 1, .production_id = 21),
  [25995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [25997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [25999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11150),
  [26001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12438),
  [26003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [26005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [26007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 100),
  [26009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [26011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [26013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [26015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [26017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [26019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7708),
  [26021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11142),
  [26023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [26025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11153),
  [26027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11805),
  [26029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7707),
  [26031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 103),
  [26033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9831),
  [26035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12451),
  [26037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11149),
  [26039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12453),
  [26041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 1),
  [26043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [26045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10365),
  [26047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20784),
  [26049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [26051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12460),
  [26053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [26055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [26057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12462),
  [26059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [26061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14009),
  [26063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 105),
  [26065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10369),
  [26067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20737),
  [26069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [26071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [26073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 7),
  [26075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [26077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [26079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7699),
  [26081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7698),
  [26083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [26085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11038),
  [26087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [26089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10440),
  [26091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20767),
  [26093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 3, .production_id = 51),
  [26095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [26097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [26099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12478),
  [26101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 7),
  [26103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [26105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12487),
  [26107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [26109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11029),
  [26111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [26113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20716),
  [26115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [26117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10998),
  [26119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8657),
  [26121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 3, .production_id = 52),
  [26123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [26125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20760),
  [26127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 10, .production_id = 30),
  [26129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [26131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20769),
  [26133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 9, .production_id = 103),
  [26135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12492),
  [26137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [26139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [26141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [26143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10994),
  [26145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [26147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [26149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [26151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 9, .production_id = 105),
  [26153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 9, .production_id = 106),
  [26155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 61),
  [26157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2, .production_id = 38),
  [26159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1671),
  [26162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10993),
  [26164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12091),
  [26166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3259),
  [26168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [26170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8665),
  [26172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 10, .production_id = 106),
  [26174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10552),
  [26176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10988),
  [26178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8088),
  [26180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20781),
  [26182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [26184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11637),
  [26186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9163),
  [26188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10923),
  [26190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9166),
  [26192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12028),
  [26194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [26196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [26198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_tuple, 2),
  [26200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10978),
  [26202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [26204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8771),
  [26206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [26208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [26210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20742),
  [26212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18284),
  [26214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [26216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20754),
  [26218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16886),
  [26220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8669),
  [26222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10967),
  [26224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [26226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11973),
  [26228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [26230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9427),
  [26232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11944),
  [26234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [26236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11932),
  [26238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_sum, 2),
  [26240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11896),
  [26242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_sum_repeat1, 2), SHIFT_REPEAT(2223),
  [26245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_sum_repeat1, 2),
  [26247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [26249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [26251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [26253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20802),
  [26255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [26257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [26259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11013),
  [26261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [26263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11011),
  [26265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [26267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [26269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 6),
  [26271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [26273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18201),
  [26275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [26277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11844),
  [26279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [26281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 5),
  [26283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11822),
  [26285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15803),
  [26287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19373),
  [26289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [26291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [26293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [26295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10673),
  [26297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10934),
  [26299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10953),
  [26301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [26303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [26305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20823),
  [26307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10668),
  [26309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8375),
  [26311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10655),
  [26313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [26315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [26317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9384),
  [26319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [26321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8157),
  [26323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [26325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9284),
  [26327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20798),
  [26329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18115),
  [26331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10231),
  [26333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20816),
  [26335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20350),
  [26337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9867),
  [26339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20824),
  [26341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [26343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 7),
  [26345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [26347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [26349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10647),
  [26351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [26353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [26355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_fun, 3),
  [26357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 4),
  [26359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [26361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [26363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8427),
  [26365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12379),
  [26367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10620),
  [26369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [26371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10646),
  [26373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [26375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10128),
  [26377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20852),
  [26379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12402),
  [26381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [26383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [26385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [26387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20800),
  [26389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12436),
  [26391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [26393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10625),
  [26395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [26397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [26399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [26401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [26403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17424),
  [26405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21147),
  [26407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9608),
  [26409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9350),
  [26411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat2, 2, .dynamic_precedence = 1, .production_id = 99),
  [26413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13669),
  [26415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20853),
  [26417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13611),
  [26419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20858),
  [26421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12463),
  [26423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9324),
  [26425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20809),
  [26427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9322),
  [26429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20819),
  [26431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12468),
  [26433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14704),
  [26435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12472),
  [26437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14700),
  [26439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12524),
  [26441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [26443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [26445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [26447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [26449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [26451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10640),
  [26453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [26455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [26457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [26459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17981),
  [26461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6318),
  [26463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [26465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12520),
  [26467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15150),
  [26469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [26471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12530),
  [26473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20358),
  [26475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [26477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13618),
  [26479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20877),
  [26481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [26483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [26485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [26487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [26489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [26491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15159),
  [26493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [26495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14707),
  [26497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15173),
  [26499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [26501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [26503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14672),
  [26505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [26507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8506),
  [26509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [26511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [26513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14628),
  [26515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 6),
  [26517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [26519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14543),
  [26521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15182),
  [26523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [26525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14973),
  [26527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20883),
  [26529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16625),
  [26531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15043),
  [26533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20891),
  [26535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15194),
  [26537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [26539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [26541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [26543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8730),
  [26545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [26547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [26549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [26551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20862),
  [26553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2),
  [26555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2), SHIFT_REPEAT(19040),
  [26558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [26560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7825),
  [26562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [26564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [26566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14607),
  [26568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [26570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 1),
  [26572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [26574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [26576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [26578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15176),
  [26580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20912),
  [26582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [26584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [26586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [26588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [26590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [26592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [26594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20890),
  [26596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [26598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20914),
  [26600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6268),
  [26602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20894),
  [26604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6270),
  [26606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20895),
  [26608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 3),
  [26610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14615),
  [26612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14749),
  [26614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [26616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20942),
  [26618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13857),
  [26620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4),
  [26622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [26624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [26626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [26628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2),
  [26630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2), SHIFT_REPEAT(14608),
  [26633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [26635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [26637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [26639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [26641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [26643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20903),
  [26645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [26647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [26649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [26651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [26653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [26655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [26657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6363),
  [26659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20909),
  [26661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [26663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [26665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20910),
  [26667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [26669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [26671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14702),
  [26673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6400),
  [26675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [26677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15279),
  [26679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6450),
  [26681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [26683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15290),
  [26685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [26687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [26689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20918),
  [26691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11687),
  [26693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [26695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20926),
  [26697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [26699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20880),
  [26701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [26703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20908),
  [26705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [26707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [26709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20928),
  [26711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17839),
  [26713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_con_names_repeat1, 2),
  [26715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_con_names_repeat1, 2), SHIFT_REPEAT(15088),
  [26718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [26720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16655),
  [26722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17764),
  [26724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17761),
  [26726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17731),
  [26728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17747),
  [26730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20939),
  [26732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [26734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20982),
  [26736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17727),
  [26738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20947),
  [26740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14073),
  [26742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17698),
  [26744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20948),
  [26746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11699),
  [26748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8836),
  [26750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [26752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22380),
  [26754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11521),
  [26756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15647),
  [26758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [26760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15687),
  [26762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8834),
  [26764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15749),
  [26766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14654),
  [26768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [26770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15762),
  [26772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15854),
  [26774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10746),
  [26776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15807),
  [26778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20954),
  [26780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10744),
  [26782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 4, .production_id = 35),
  [26784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [26786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [26788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [26790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15941),
  [26792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20959),
  [26794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [26796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15944),
  [26798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20960),
  [26800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14609),
  [26802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14850),
  [26804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20969),
  [26806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [26808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14803),
  [26810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20975),
  [26812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14667),
  [26814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9415),
  [26816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [26818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [26820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9555),
  [26822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_decl, 2, .production_id = 99),
  [26824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [26826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [26828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9558),
  [26830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [26832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10718),
  [26834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [26836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9561),
  [26838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7470),
  [26840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12754),
  [26842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7474),
  [26844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20966),
  [26846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11724),
  [26848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [26850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20970),
  [26852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [26854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [26856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20971),
  [26858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11725),
  [26860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14829),
  [26862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20988),
  [26864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14821),
  [26866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12738),
  [26868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [26870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [26872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [26874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9260),
  [26876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12723),
  [26878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9319),
  [26880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14673),
  [26882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9296),
  [26884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9297),
  [26886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [26888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [26890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [26892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [26894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20981),
  [26896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14676),
  [26898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16112),
  [26900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [26902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat3, 2, .dynamic_precedence = 1),
  [26904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11732),
  [26906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [26908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20983),
  [26910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12650),
  [26912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11734),
  [26914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8470),
  [26916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20961),
  [26918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12615),
  [26920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [26922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20984),
  [26924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12610),
  [26926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12592),
  [26928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [26930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_eq, 3),
  [26932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [26934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14904),
  [26936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [26938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9664),
  [26940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9600),
  [26942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9602),
  [26944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [26946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [26948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6643),
  [26950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20992),
  [26952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9435),
  [26954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [26956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20994),
  [26958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [26960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20995),
  [26962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12455),
  [26964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [26966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [26968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 4, .production_id = 30),
  [26970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12406),
  [26972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14770),
  [26974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11737),
  [26976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14772),
  [26978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [26980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11749),
  [26982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7448),
  [26984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7446),
  [26986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [26988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20989),
  [26990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7439),
  [26992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [26994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20996),
  [26996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7435),
  [26998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6641),
  [27000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [27002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21004),
  [27004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [27006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21013),
  [27008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [27010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21015),
  [27012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20503),
  [27014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [27016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11295),
  [27018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11299),
  [27020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [27022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [27024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8671),
  [27026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21019),
  [27028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [27030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21054),
  [27032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [27034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21024),
  [27036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12721),
  [27038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [27040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21026),
  [27042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15370),
  [27044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12684),
  [27046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 5),
  [27048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14692),
  [27050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14699),
  [27052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13884),
  [27054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [27056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21037),
  [27058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [27060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [27062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [27064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21044),
  [27066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14095),
  [27068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [27070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [27072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [27074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12635),
  [27076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [27078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [27080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [27082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat2, 2, .dynamic_precedence = 1),
  [27084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_datafam, 3, .production_id = 36),
  [27086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_tyfam, 3, .production_id = 30),
  [27088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [27090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8664),
  [27092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12050),
  [27094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15493),
  [27096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12620),
  [27098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20226),
  [27100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21035),
  [27102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [27104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21106),
  [27106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20219),
  [27108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21039),
  [27110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20218),
  [27112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21040),
  [27114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [27116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [27118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21063),
  [27120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12054),
  [27122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15294),
  [27124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_deriving_repeat1, 2, .production_id = 94),
  [27126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_deriving_repeat1, 2, .production_id = 94), SHIFT_REPEAT(2794),
  [27129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12608),
  [27131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15287),
  [27133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12072),
  [27135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12602),
  [27137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [27139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [27141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [27143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6576),
  [27145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [27147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [27149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20224),
  [27151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9638),
  [27153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21047),
  [27155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20070),
  [27157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20810),
  [27159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15766),
  [27161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9669),
  [27163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21050),
  [27165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9665),
  [27167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21051),
  [27169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8703),
  [27171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21094),
  [27173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14097),
  [27175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13904),
  [27177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12116),
  [27179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [27181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6816),
  [27183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12113),
  [27185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [27187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12089),
  [27189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14752),
  [27191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12084),
  [27193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [27195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [27197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [27199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [27201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9244),
  [27203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21066),
  [27205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [27207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [27209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14755),
  [27211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15350),
  [27213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12151),
  [27215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9236),
  [27217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21068),
  [27219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15356),
  [27221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12190),
  [27223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9235),
  [27225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21069),
  [27227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14149),
  [27229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9445),
  [27231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10531),
  [27233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21038),
  [27235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12036),
  [27237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20211),
  [27239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [27241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9446),
  [27243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11996),
  [27245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat2, 2, .dynamic_precedence = 1),
  [27247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8546),
  [27249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8545),
  [27251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9242),
  [27253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12252),
  [27255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9650),
  [27257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21075),
  [27259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [27261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21077),
  [27263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9644),
  [27265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21078),
  [27267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [27269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14731),
  [27271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [27273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 2),
  [27275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14775),
  [27277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15121),
  [27279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20203),
  [27281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20198),
  [27283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [27285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [27287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [27289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20197),
  [27291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15141),
  [27293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15140),
  [27295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9648),
  [27297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11440),
  [27299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21088),
  [27301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10532),
  [27303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21073),
  [27305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [27307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10509),
  [27309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21081),
  [27311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11450),
  [27313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21091),
  [27315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11452),
  [27317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21093),
  [27319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [27321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_safety, 1),
  [27323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreign_pre, 2),
  [27325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [27327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14627),
  [27329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [27331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21115),
  [27333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [27335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21121),
  [27337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15348),
  [27339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15361),
  [27341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15386),
  [27343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [27345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21105),
  [27347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9473),
  [27349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20901),
  [27351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14608),
  [27353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [27355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [27357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [27359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21107),
  [27361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20911),
  [27363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [27365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21108),
  [27367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9471),
  [27369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [27371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14795),
  [27373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11946),
  [27375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [27377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15450),
  [27379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14722),
  [27381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14729),
  [27383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14730),
  [27385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7664),
  [27387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [27389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21120),
  [27391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9711),
  [27393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21157),
  [27395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [27397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11942),
  [27399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [27401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21122),
  [27403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [27405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21123),
  [27407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [27409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11935),
  [27411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15548),
  [27413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15520),
  [27415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15519),
  [27417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [27419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21133),
  [27421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [27423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15313),
  [27425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15407),
  [27427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [27429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21135),
  [27431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [27433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [27435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [27437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21137),
  [27439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20938),
  [27441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15088),
  [27443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8303),
  [27445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21163),
  [27447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8310),
  [27449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21180),
  [27451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [27453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [27455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [27457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11909),
  [27459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [27461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8301),
  [27463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [27465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11907),
  [27467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [27469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11906),
  [27471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9156),
  [27473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21153),
  [27475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11904),
  [27477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15459),
  [27479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9146),
  [27481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21160),
  [27483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15455),
  [27485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15331),
  [27487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9145),
  [27489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21161),
  [27491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [27493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [27495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [27497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [27499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [27501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [27503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [27505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9767),
  [27507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [27509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [27511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7718),
  [27513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9764),
  [27515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11893),
  [27517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [27519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [27521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11885),
  [27523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [27525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6495),
  [27527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21165),
  [27529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [27531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21171),
  [27533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [27535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [27537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8275),
  [27539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [27541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21175),
  [27543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6169),
  [27545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [27547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11695),
  [27549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11707),
  [27551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11708),
  [27553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [27555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6946),
  [27557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21179),
  [27559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9719),
  [27561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [27563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21227),
  [27565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [27567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [27569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21183),
  [27571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9339),
  [27573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8701),
  [27575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9579),
  [27577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21164),
  [27579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [27581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21184),
  [27583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [27585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15357),
  [27587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [27589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7078),
  [27591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [27593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [27595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [27597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7075),
  [27599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [27601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21204),
  [27603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9150),
  [27605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7601),
  [27607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21212),
  [27609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14935),
  [27611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21191),
  [27613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15352),
  [27615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nalt, 4, .production_id = 74),
  [27617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [27619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [27621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14944),
  [27623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21195),
  [27625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [27627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [27629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 4, .production_id = 25),
  [27631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14946),
  [27633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21198),
  [27635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9680),
  [27637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10279),
  [27639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10283),
  [27641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [27643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9677),
  [27645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11815),
  [27647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [27649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [27651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [27653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [27655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15032),
  [27657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21208),
  [27659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [27661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21243),
  [27663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [27665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [27667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [27669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [27671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15115),
  [27673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21213),
  [27675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15299),
  [27677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15189),
  [27679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21215),
  [27681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [27683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8148),
  [27685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8150),
  [27687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15171),
  [27689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9036),
  [27691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11911),
  [27693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11915),
  [27695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11919),
  [27697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9666),
  [27699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21187),
  [27701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [27703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [27705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21226),
  [27707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [27709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9660),
  [27711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21194),
  [27713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7765),
  [27715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21233),
  [27717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [27719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [27721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [27723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7767),
  [27725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21234),
  [27727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [27729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10309),
  [27731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [27733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_projection_selector_repeat1, 2, .production_id = 69), SHIFT_REPEAT(20736),
  [27736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_projection_selector_repeat1, 2, .production_id = 69),
  [27738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_datafam, 2, .production_id = 85),
  [27740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat2, 2, .dynamic_precedence = 1),
  [27742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [27744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [27746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15113),
  [27748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [27750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [27752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 3, .production_id = 16),
  [27754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9060),
  [27756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14938),
  [27758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9694),
  [27760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21245),
  [27762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9740),
  [27764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21248),
  [27766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9695),
  [27768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21249),
  [27770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [27772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [27774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 4, .production_id = 71),
  [27776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15276),
  [27778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [27780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_tyinst, 3),
  [27782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [27784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6415),
  [27786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [27788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [27790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [27792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [27794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [27796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6406),
  [27798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15105),
  [27800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14634),
  [27802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21257),
  [27804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [27806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [27808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14605),
  [27810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21265),
  [27812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [27814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14599),
  [27816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21267),
  [27818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14010),
  [27820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14563),
  [27822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [27824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [27826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [27828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [27830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [27832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9017),
  [27834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [27836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14991),
  [27838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21293),
  [27840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9016),
  [27842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [27844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15103),
  [27846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21284),
  [27848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15139),
  [27850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21285),
  [27852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12811),
  [27854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21279),
  [27856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12804),
  [27858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21237),
  [27860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12579),
  [27862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21275),
  [27864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12573),
  [27866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21286),
  [27868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [27870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [27872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7831),
  [27874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14618),
  [27876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14637),
  [27878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14638),
  [27880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [27882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [27884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9693),
  [27886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [27888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21288),
  [27890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14924),
  [27892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11408),
  [27894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [27896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21274),
  [27898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 4),
  [27900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14925),
  [27902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [27904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21294),
  [27906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [27908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [27910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20032),
  [27912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10312),
  [27914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12558),
  [27916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21253),
  [27918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8999),
  [27920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11414),
  [27922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8900),
  [27924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [27926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [27928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11422),
  [27930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7832),
  [27932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [27934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [27936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14619),
  [27938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8206),
  [27940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8207),
  [27942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11888),
  [27944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21280),
  [27946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [27948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [27950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11848),
  [27952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21270),
  [27954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [27956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11847),
  [27958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21266),
  [27960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9509),
  [27962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21292),
  [27964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [27966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11427),
  [27968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [27970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [27972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [27974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [27976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11448),
  [27978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9743),
  [27980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11459),
  [27982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [27984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8210),
  [27986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15057),
  [27988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8113),
  [27990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [27992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21252),
  [27994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12979),
  [27996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21146),
  [27998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [28000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21242),
  [28002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [28004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [28006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21238),
  [28008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_signature, 2),
  [28010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [28012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7893),
  [28014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [28016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11487),
  [28018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [28020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [28022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [28024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11500),
  [28026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_tyfam, 2, .production_id = 16),
  [28028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [28030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9093),
  [28032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9216),
  [28034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7879),
  [28036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21224),
  [28038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14544),
  [28040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9366),
  [28042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21260),
  [28044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [28046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21214),
  [28048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9386),
  [28050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21229),
  [28052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [28054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7874),
  [28056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21210),
  [28058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14965),
  [28060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12255),
  [28062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15256),
  [28064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [28066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [28068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [28070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [28072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11738),
  [28074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21196),
  [28076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [28078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15245),
  [28080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11691),
  [28082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21186),
  [28084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [28086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11684),
  [28088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21182),
  [28090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14814),
  [28092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21167),
  [28094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14815),
  [28096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21159),
  [28098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [28100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 2),
  [28102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [28104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12286),
  [28106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14955),
  [28108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12287),
  [28110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12289),
  [28112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [28114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21168),
  [28116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14841),
  [28118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21145),
  [28120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [28122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21158),
  [28124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [28126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15398),
  [28128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15371),
  [28130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [28132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21154),
  [28134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12503),
  [28136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14952),
  [28138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__context_constraints_repeat1, 2),
  [28140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__context_constraints_repeat1, 2), SHIFT_REPEAT(2632),
  [28143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15316),
  [28145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [28147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8221),
  [28149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11610),
  [28151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [28153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9141),
  [28155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12495),
  [28157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15980),
  [28159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7813),
  [28161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12352),
  [28163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21125),
  [28165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [28167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12295),
  [28169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21119),
  [28171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7876),
  [28173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6784),
  [28175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21140),
  [28177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8514),
  [28179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [28181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [28183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21130),
  [28185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [28187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [28189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21126),
  [28191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [28193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12250),
  [28195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21104),
  [28197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [28199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [28201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11577),
  [28203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14957),
  [28205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14967),
  [28207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14937),
  [28209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11575),
  [28211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8519),
  [28213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11571),
  [28215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14897),
  [28217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [28219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21112),
  [28221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15232),
  [28223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12480),
  [28225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [28227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12470),
  [28229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [28231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21102),
  [28233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [28235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21098),
  [28237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9099),
  [28239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9084),
  [28241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21087),
  [28243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12464),
  [28245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9082),
  [28247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21080),
  [28249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [28251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9089),
  [28253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12347),
  [28255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [28257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [28259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [28261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9075),
  [28263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21065),
  [28265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15191),
  [28267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [28269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21084),
  [28271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17609),
  [28273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17611),
  [28275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [28277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21074),
  [28279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12461),
  [28281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [28283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21070),
  [28285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17701),
  [28287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14124),
  [28289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21027),
  [28291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14734),
  [28293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14104),
  [28295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20985),
  [28297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [28299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12392),
  [28301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12394),
  [28303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12397),
  [28305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12005),
  [28307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21041),
  [28309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [28311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12009),
  [28313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21036),
  [28315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [28317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [28319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21056),
  [28321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9091),
  [28323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [28325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21046),
  [28327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [28329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21042),
  [28331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9153),
  [28333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12031),
  [28335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21025),
  [28337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [28339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [28341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [28343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9031),
  [28345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [28347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [28349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [28351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6933),
  [28353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9023),
  [28355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [28357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17745),
  [28359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [28361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2),
  [28363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2), SHIFT_REPEAT(11768),
  [28366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15679),
  [28368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21028),
  [28370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9072),
  [28372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15715),
  [28374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21018),
  [28376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12444),
  [28378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9006),
  [28380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21001),
  [28382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [28384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9001),
  [28386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20991),
  [28388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15719),
  [28390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21014),
  [28392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [28394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [28396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [28398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [28400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [28402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9466),
  [28404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21000),
  [28406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8994),
  [28408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20978),
  [28410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [28412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13996),
  [28414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20922),
  [28416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9458),
  [28418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20990),
  [28420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [28422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20986),
  [28424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12188),
  [28426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12130),
  [28428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [28430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8997),
  [28432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [28434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12128),
  [28436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [28438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8985),
  [28440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [28442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [28444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21110),
  [28446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12424),
  [28448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21113),
  [28450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [28452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12137),
  [28454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20963),
  [28456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8462),
  [28458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12140),
  [28460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20953),
  [28462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [28464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [28466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7711),
  [28468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21095),
  [28470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9779),
  [28472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20972),
  [28474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [28476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9194),
  [28478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9783),
  [28480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20962),
  [28482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9784),
  [28484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20958),
  [28486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12161),
  [28488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20940),
  [28490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9454),
  [28492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13633),
  [28494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13632),
  [28496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [28498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14701),
  [28500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14706),
  [28502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [28504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [28506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [28508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14716),
  [28510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [28512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12174),
  [28514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9200),
  [28516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20944),
  [28518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [28520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9210),
  [28522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20934),
  [28524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [28526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9212),
  [28528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20930),
  [28530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [28532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [28534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20917),
  [28536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9204),
  [28538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [28540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20907),
  [28542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [28544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [28546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12399),
  [28548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [28550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [28552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [28554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [28556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9420),
  [28558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20916),
  [28560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [28562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20892),
  [28564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9164),
  [28566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [28568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9413),
  [28570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20906),
  [28572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9412),
  [28574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20902),
  [28576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12192),
  [28578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12193),
  [28580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13614),
  [28582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13680),
  [28584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12185),
  [28586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16213),
  [28588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14837),
  [28590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16219),
  [28592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16232),
  [28594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16235),
  [28596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15700),
  [28598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13812),
  [28600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [28602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20888),
  [28604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [28606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20870),
  [28608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [28610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20863),
  [28612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2),
  [28614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2), SHIFT_REPEAT(14007),
  [28617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [28619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20878),
  [28621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [28623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [28625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20874),
  [28627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9205),
  [28629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [28631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9369),
  [28633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [28635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20844),
  [28637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16370),
  [28639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9368),
  [28641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9362),
  [28643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9359),
  [28645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [28647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8916),
  [28649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9463),
  [28651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [28653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20860),
  [28655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8914),
  [28657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [28659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20850),
  [28661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12224),
  [28663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3253),
  [28665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [28667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [28669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20846),
  [28671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10702),
  [28673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20782),
  [28675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12242),
  [28677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20829),
  [28679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9002),
  [28681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12245),
  [28683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20815),
  [28685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9823),
  [28687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [28689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10777),
  [28691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20663),
  [28693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9801),
  [28695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9799),
  [28697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9781),
  [28699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8173),
  [28701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20832),
  [28703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8166),
  [28705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20822),
  [28707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12275),
  [28709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20803),
  [28711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [28713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [28715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20818),
  [28717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14649),
  [28719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14648),
  [28721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [28723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [28725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [28727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9130),
  [28729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [28731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [28733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [28735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9116),
  [28737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21144),
  [28739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9209),
  [28741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12659),
  [28743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20804),
  [28745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [28747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [28749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15162),
  [28751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20785),
  [28753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15169),
  [28755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20773),
  [28757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [28759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20941),
  [28761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12670),
  [28763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20794),
  [28765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12671),
  [28767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20790),
  [28769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9483),
  [28771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [28773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [28775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9488),
  [28777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15251),
  [28779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20759),
  [28781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9489),
  [28783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [28785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11835),
  [28787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20776),
  [28789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11542),
  [28791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11606),
  [28793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [28795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20885),
  [28797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11843),
  [28799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20766),
  [28801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11597),
  [28803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11849),
  [28805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20762),
  [28807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [28809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13777),
  [28811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11859),
  [28813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11860),
  [28815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11793),
  [28817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [28819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20733),
  [28821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11864),
  [28823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [28825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20727),
  [28827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [28829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20748),
  [28831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10781),
  [28833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20616),
  [28835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [28837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20738),
  [28839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [28841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [28843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20734),
  [28845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [28847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [28849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20717),
  [28851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14639),
  [28853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [28855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [28857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [28859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8002),
  [28861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [28863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [28865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8007),
  [28867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [28869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11583),
  [28871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [28873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [28875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20720),
  [28877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14635),
  [28879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [28881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20710),
  [28883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [28885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20706),
  [28887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [28889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20689),
  [28891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [28893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [28895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20675),
  [28897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [28899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [28901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [28903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8001),
  [28905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8004),
  [28907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [28909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12725),
  [28911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20692),
  [28913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12732),
  [28915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20682),
  [28917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8225),
  [28919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20668),
  [28921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14572),
  [28923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12737),
  [28925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20678),
  [28927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5562),
  [28929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14631),
  [28931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [28933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [28935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [28937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14625),
  [28939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [28941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [28943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8048),
  [28945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [28947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [28949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [28951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [28953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20664),
  [28955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [28957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [28959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20641),
  [28961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [28963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20654),
  [28965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [28967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20633),
  [28969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [28971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [28973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20650),
  [28975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [28977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [28979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12810),
  [28981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12803),
  [28983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [28985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12794),
  [28987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [28989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20617),
  [28991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9316),
  [28993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12793),
  [28995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [28997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20636),
  [28999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12367),
  [29001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12368),
  [29003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [29005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20626),
  [29007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [29009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [29011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20622),
  [29013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12369),
  [29015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9018),
  [29017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [29019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13142),
  [29021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [29023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12801),
  [29025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9518),
  [29027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13129),
  [29029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [29031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20599),
  [29033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [29035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [29037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20585),
  [29039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [29041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [29043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [29045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20608),
  [29047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [29049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20598),
  [29051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [29053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20594),
  [29055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [29057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20576),
  [29059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [29061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7948),
  [29063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [29065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [29067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [29069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [29071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20530),
  [29073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [29075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [29077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [29079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [29081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12418),
  [29083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7892),
  [29085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12016),
  [29087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20580),
  [29089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7996),
  [29091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12026),
  [29093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20570),
  [29095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12999),
  [29097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [29099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20558),
  [29101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [29103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20502),
  [29105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [29107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20553),
  [29109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12982),
  [29111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nalts_repeat2, 2, .dynamic_precedence = 1),
  [29113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12032),
  [29115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20566),
  [29117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9344),
  [29119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12541),
  [29121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12540),
  [29123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [29125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20543),
  [29127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9333),
  [29129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12522),
  [29131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12519),
  [29133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [29135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [29137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9531),
  [29139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [29141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20552),
  [29143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [29145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [29147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [29149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [29151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12972),
  [29153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9537),
  [29155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12944),
  [29157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6702),
  [29159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20542),
  [29161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [29163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20538),
  [29165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [29167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20525),
  [29169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9455),
  [29171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20516),
  [29173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [29175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [29177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [29179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [29181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13314),
  [29183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [29185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [29187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [29189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20497),
  [29191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [29193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [29195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20524),
  [29197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [29199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20514),
  [29201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [29203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20510),
  [29205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [29207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [29209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8686),
  [29211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20418),
  [29213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [29215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [29217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [29219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14623),
  [29221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [29223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [29225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [29227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [29229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [29231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20496),
  [29233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9528),
  [29235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12869),
  [29237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [29239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20479),
  [29241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9570),
  [29243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9160),
  [29245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20475),
  [29247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat2, 2, .dynamic_precedence = 1),
  [29249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12855),
  [29251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13563),
  [29253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5830),
  [29255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20486),
  [29257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9441),
  [29259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [29261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20482),
  [29263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15072),
  [29265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9171),
  [29267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20465),
  [29269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13542),
  [29271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9291),
  [29273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10810),
  [29275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [29277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [29279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10808),
  [29281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10803),
  [29283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [29285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10800),
  [29287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [29289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [29291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20561),
  [29293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13009),
  [29295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20468),
  [29297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12980),
  [29299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20458),
  [29301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9288),
  [29303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [29305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20444),
  [29307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12950),
  [29309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20454),
  [29311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [29313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20437),
  [29315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9279),
  [29317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9850),
  [29319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9846),
  [29321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13337),
  [29323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9865),
  [29325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [29327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20423),
  [29329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [29331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [29333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20440),
  [29335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6314),
  [29337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [29339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9264),
  [29341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_default_repeat1, 2),
  [29343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_default_repeat1, 2), SHIFT_REPEAT(3613),
  [29346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [29348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20430),
  [29350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [29352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13335),
  [29354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [29356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [29358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20426),
  [29360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9261),
  [29362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13328),
  [29364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12098),
  [29366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16395),
  [29368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20413),
  [29370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [29372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [29374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16384),
  [29376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20404),
  [29378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9592),
  [29380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12097),
  [29382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13320),
  [29384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12093),
  [29386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12092),
  [29388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [29390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16364),
  [29392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20393),
  [29394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [29396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12415),
  [29398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20412),
  [29400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12544),
  [29402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20402),
  [29404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12564),
  [29406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12565),
  [29408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9593),
  [29410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12546),
  [29412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20398),
  [29414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12574),
  [29416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9259),
  [29418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [29420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19269),
  [29422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9258),
  [29424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [29426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8906),
  [29428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13296),
  [29430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9280),
  [29432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20381),
  [29434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9283),
  [29436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20369),
  [29438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [29440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20459),
  [29442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8935),
  [29444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8936),
  [29446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [29448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [29450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20384),
  [29452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9257),
  [29454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9294),
  [29456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20360),
  [29458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [29460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20374),
  [29462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13271),
  [29464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [29466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20370),
  [29468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [29470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [29472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [29474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20420),
  [29476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9307),
  [29478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [29480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14856),
  [29482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12588),
  [29484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_comprehension_repeat1, 2),
  [29486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_comprehension_repeat1, 2), SHIFT_REPEAT(192),
  [29489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14855),
  [29491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14836),
  [29493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14842),
  [29495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14568),
  [29497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20347),
  [29499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14569),
  [29501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20336),
  [29503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12276),
  [29505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [29507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20356),
  [29509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [29511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20346),
  [29513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [29515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20342),
  [29517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14574),
  [29519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20324),
  [29521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11091),
  [29523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20271),
  [29525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [29527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [29529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [29531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [29533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [29535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [29537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [29539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [29541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8118),
  [29543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [29545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20328),
  [29547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11138),
  [29549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20229),
  [29551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [29553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20318),
  [29555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [29557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20314),
  [29559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9323),
  [29561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20303),
  [29563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 4, .production_id = 77),
  [29565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9321),
  [29567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20292),
  [29569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 3),
  [29571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12269),
  [29573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [29575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [29577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [29579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8602),
  [29581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [29583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9300),
  [29585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20280),
  [29587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [29589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [29591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20300),
  [29593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15752),
  [29595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [29597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20290),
  [29599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6199),
  [29601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6198),
  [29603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [29605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20286),
  [29607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16110),
  [29609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [29611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rec_repeat2, 2, .dynamic_precedence = 1),
  [29613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [29615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [29617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [29619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind_pattern, 3, .production_id = 30),
  [29621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9188),
  [29623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [29625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [29627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20268),
  [29629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [29631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [29633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20254),
  [29635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [29637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [29639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [29641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10908),
  [29643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20272),
  [29645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10901),
  [29647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20262),
  [29649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12334),
  [29651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [29653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20241),
  [29655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [29657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10895),
  [29659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20258),
  [29661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9591),
  [29663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [29665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [29667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9003),
  [29669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15754),
  [29671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [29673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [29675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8982),
  [29677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [29679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_tyinst, 2),
  [29681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12284),
  [29683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12274),
  [29685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [29687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20244),
  [29689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [29691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20228),
  [29693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16040),
  [29695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8096),
  [29697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20222),
  [29699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12288),
  [29701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10958),
  [29703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20235),
  [29705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [29707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20234),
  [29709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9727),
  [29711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20230),
  [29713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9630),
  [29715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12317),
  [29717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8079),
  [29719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20213),
  [29721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15931),
  [29723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [29725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9549),
  [29727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [29729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [29731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12304),
  [29733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9545),
  [29735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [29737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [29739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [29741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16022),
  [29743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pat_fields_repeat1, 2),
  [29745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_fields_repeat1, 2), SHIFT_REPEAT(13674),
  [29748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12291),
  [29750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6828),
  [29752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20216),
  [29754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11818),
  [29756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20199),
  [29758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [29760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11820),
  [29762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20192),
  [29764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15943),
  [29766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [29768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [29770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20206),
  [29772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [29774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20202),
  [29776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_record_repeat1, 2),
  [29778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_record_repeat1, 2), SHIFT_REPEAT(13671),
  [29781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 3),
  [29783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [29785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11838),
  [29787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20188),
  [29789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [29791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [29793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [29795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [29797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [29799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11851),
  [29801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10515),
  [29803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13120),
  [29805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11837),
  [29807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [29809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [29811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [29813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [29815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 3, .production_id = 80),
  [29817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [29819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10961),
  [29821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [29823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10937),
  [29825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [29827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10840),
  [29829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18381),
  [29831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [29833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [29835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [29837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [29839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [29841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9706),
  [29843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [29845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [29847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [29849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [29851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [29853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12324),
  [29855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [29857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [29859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [29861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [29863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [29865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13908),
  [29867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13911),
  [29869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [29871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10907),
  [29873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [29875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [29877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [29879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [29881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [29883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [29885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10909),
  [29887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [29889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [29891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [29893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23278),
  [29895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [29897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [29899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [29901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [29903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [29905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9270),
  [29907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [29909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [29911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23317),
  [29913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [29915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13034),
  [29917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [29919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23312),
  [29921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [29923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [29925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [29927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23307),
  [29929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [29931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9301),
  [29933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [29935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23302),
  [29937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [29939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funlhs, 1, .dynamic_precedence = 1, .production_id = 7),
  [29941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [29943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23297),
  [29945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [29947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [29949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23292),
  [29951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [29953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [29955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funlhs, 1, .dynamic_precedence = 2, .production_id = 10),
  [29957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [29959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11252),
  [29961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18526),
  [29963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23287),
  [29965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [29967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [29969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23282),
  [29971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [29973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23253),
  [29975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [29977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [29979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23277),
  [29981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [29983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [29985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23272),
  [29987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [29989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [29991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [29993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23267),
  [29995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [29997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [29999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23262),
  [30001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [30003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [30005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23257),
  [30007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [30009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14576),
  [30011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [30013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [30015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [30017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23252),
  [30019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [30021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [30023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23247),
  [30025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [30027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [30029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23242),
  [30031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [30033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [30035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23237),
  [30037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [30039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14573),
  [30041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [30043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23232),
  [30045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [30047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [30049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23225),
  [30051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [30053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12675),
  [30055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17868),
  [30057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [30059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8145),
  [30061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23218),
  [30063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [30065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [30067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23207),
  [30069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [30071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14018),
  [30073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14021),
  [30075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [30077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [30079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23228),
  [30081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [30083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [30085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23193),
  [30087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [30089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13935),
  [30091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13938),
  [30093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18140),
  [30095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [30097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9293),
  [30099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [30101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [30103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [30105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [30107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10455),
  [30109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [30111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23119),
  [30113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [30115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [30117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [30119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8174),
  [30121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [30123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11656),
  [30125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18645),
  [30127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23098),
  [30129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [30131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [30133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23314),
  [30135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [30137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [30139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22605),
  [30141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [30143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16331),
  [30145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [30147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [30149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10832),
  [30151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18490),
  [30153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [30155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12443),
  [30157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16365),
  [30159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13235),
  [30161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [30163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11842),
  [30165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8760),
  [30167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12322),
  [30169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12685),
  [30171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [30173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10617),
  [30175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [30177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [30179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11764),
  [30181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14718),
  [30183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [30185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [30187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22910),
  [30189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [30191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22894),
  [30193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [30195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_module, 2),
  [30197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_module, 2),
  [30199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [30201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14557),
  [30203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19372),
  [30205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [30207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [30209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [30211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19258),
  [30213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [30215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [30217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12601),
  [30219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [30221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12820),
  [30223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [30225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19139),
  [30227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [30229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [30231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [30233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [30235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19020),
  [30237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [30239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [30241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13000),
  [30243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [30245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10606),
  [30247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18589),
  [30249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18901),
  [30251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [30253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [30255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [30257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9179),
  [30259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [30261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13011),
  [30263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18782),
  [30265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [30267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [30269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [30271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [30273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18663),
  [30275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [30277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9170),
  [30279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [30281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [30283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18544),
  [30285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [30287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [30289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [30291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18425),
  [30293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [30295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [30297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 16),
  [30299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18306),
  [30301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [30303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [30305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [30307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [30309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [30311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [30313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [30315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18187),
  [30317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [30319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [30321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8688),
  [30323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [30325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22743),
  [30327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [30329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18068),
  [30331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [30333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [30335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13537),
  [30337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22735),
  [30339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [30341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17949),
  [30343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [30345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [30347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [30349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9451),
  [30351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17871),
  [30353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [30355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [30357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [30359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11436),
  [30361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18903),
  [30363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17939),
  [30365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12395),
  [30367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [30369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [30371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [30373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11856),
  [30375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [30377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [30379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [30381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18035),
  [30383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [30385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [30387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [30389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6708),
  [30391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [30393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12550),
  [30395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18138),
  [30397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [30399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [30401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18251),
  [30403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [30405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [30407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6717),
  [30409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [30411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18370),
  [30413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11763),
  [30415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11981),
  [30417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18288),
  [30419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [30421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [30423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [30425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [30427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [30429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18506),
  [30431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [30433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [30435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [30437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12021),
  [30439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10859),
  [30441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18623),
  [30443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22622),
  [30445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [30447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [30449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [30451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [30453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12015),
  [30455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18760),
  [30457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [30459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [30461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [30463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22616),
  [30465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [30467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18919),
  [30469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [30471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [30473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [30475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22623),
  [30477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [30479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19066),
  [30481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [30483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [30485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12679),
  [30487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8606),
  [30489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22499),
  [30491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [30493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [30495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [30497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19215),
  [30499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [30501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [30503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [30505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8541),
  [30507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19387),
  [30509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [30511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [30513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10771),
  [30515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [30517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19608),
  [30519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [30521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [30523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22603),
  [30525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [30527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [30529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14474),
  [30531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [30533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [30535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7579),
  [30537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13040),
  [30539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19903),
  [30541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19945),
  [30543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [30545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [30547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [30549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [30551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [30553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [30555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [30557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20150),
  [30559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [30561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [30563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22498),
  [30565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [30567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14299),
  [30569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19946),
  [30571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [30573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [30575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22472),
  [30577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [30579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22495),
  [30581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [30583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [30585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11537),
  [30587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20108),
  [30589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19771),
  [30591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [30593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [30595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [30597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11774),
  [30599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11102),
  [30601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19601),
  [30603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10782),
  [30605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6055),
  [30607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [30609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [30611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8223),
  [30613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [30615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3),
  [30617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [30619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 12),
  [30621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19414),
  [30623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [30625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [30627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12726),
  [30629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [30631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [30633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19221),
  [30635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [30637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [30639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [30641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [30643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [30645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12720),
  [30647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [30649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [30651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 35),
  [30653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19047),
  [30655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [30657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [30659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12024),
  [30661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 1, .production_id = 45),
  [30663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [30665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22394),
  [30667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [30669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18848),
  [30671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [30673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [30675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [30677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [30679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22390),
  [30681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [30683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 1, .production_id = 45),
  [30685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [30687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8005),
  [30689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10826),
  [30691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18733),
  [30693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [30695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [30697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [30699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [30701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [30703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funpat_infix, 3, .production_id = 47),
  [30705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12149),
  [30707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20002),
  [30709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7983),
  [30711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 4),
  [30713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [30715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18616),
  [30717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10912),
  [30719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [30721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [30723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21244),
  [30725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10426),
  [30727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7944),
  [30729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [30731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18508),
  [30733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [30735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [30737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12488),
  [30739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7960),
  [30741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qual, 1),
  [30743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qual, 1, .production_id = 21),
  [30745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18406),
  [30747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [30749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [30751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15255),
  [30753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [30755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12102),
  [30757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [30759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11836),
  [30761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10379),
  [30763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotated_type_variable, 2, .production_id = 16),
  [30765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [30767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22279),
  [30769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [30771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18315),
  [30773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15248),
  [30775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [30777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [30779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11819),
  [30781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12654),
  [30783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [30785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 2),
  [30787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [30789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11807),
  [30791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18883),
  [30793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 2),
  [30795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22275),
  [30797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [30799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [30801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18233),
  [30803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12666),
  [30805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [30807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [30809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11569),
  [30811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19695),
  [30813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9222),
  [30815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11823),
  [30817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10669),
  [30819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [30821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12278),
  [30823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12662),
  [30825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18147),
  [30827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [30829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [30831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 2, .production_id = 12),
  [30833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9285),
  [30835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [30837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [30839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [30841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [30843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10527),
  [30845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18050),
  [30847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12260),
  [30849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12384),
  [30851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [30853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [30855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [30857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10139),
  [30859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22175),
  [30861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [30863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 99),
  [30865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18029),
  [30867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8181),
  [30869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [30871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [30873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22166),
  [30875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [30877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [30879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 3, .production_id = 29),
  [30881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint_context, 2),
  [30883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10682),
  [30885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [30887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [30889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [30891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12077),
  [30893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19095),
  [30895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [30897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10033),
  [30899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [30901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [30903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [30905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13620),
  [30907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [30909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [30911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [30913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6902),
  [30915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [30917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22173),
  [30919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [30921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 6, .production_id = 102),
  [30923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11649),
  [30925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22040),
  [30927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [30929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [30931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17890),
  [30933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [30935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [30937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13570),
  [30939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [30941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [30943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22068),
  [30945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [30947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [30949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 1),
  [30951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22126),
  [30953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [30955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [30957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22061),
  [30959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [30961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [30963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15172),
  [30965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [30967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [30969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [30971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [30973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [30975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [30977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11667),
  [30979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18534),
  [30981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 5),
  [30983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 4),
  [30985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [30987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11891),
  [30989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9419),
  [30991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [30993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [30995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 4, .production_id = 92),
  [30997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15322),
  [30999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2, .production_id = 92),
  [31001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9423),
  [31003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6404),
  [31005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 3),
  [31007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22431),
  [31009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [31011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13939),
  [31013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12404),
  [31015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [31017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11688),
  [31019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9203),
  [31021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 5),
  [31023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 4),
  [31025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17770),
  [31027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12170),
  [31029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [31031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [31033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9187),
  [31035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17746),
  [31037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_name, 3),
  [31039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12160),
  [31041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15697),
  [31043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15819),
  [31045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8367),
  [31047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [31049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [31051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 2),
  [31053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7471),
  [31055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9778),
  [31057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12746),
  [31059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14827),
  [31061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8986),
  [31063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [31065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6680),
  [31067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [31069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [31071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14003),
  [31073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11777),
  [31075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14879),
  [31077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8468),
  [31079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9465),
  [31081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [31083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [31085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [31087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [31089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21822),
  [31091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [31093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [31095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6721),
  [31097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 3, .production_id = 29),
  [31099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [31101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6723),
  [31103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21817),
  [31105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [31107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 5),
  [31109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15680),
  [31111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [31113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [31115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 5, .production_id = 96),
  [31117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21831),
  [31119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [31121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8668),
  [31123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12048),
  [31125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15660),
  [31127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12238),
  [31129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11490),
  [31131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18390),
  [31133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21804),
  [31135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [31137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20227),
  [31139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12030),
  [31141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10502),
  [31143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20225),
  [31145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12052),
  [31147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7231),
  [31149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [31151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [31153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9634),
  [31155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_deriving_repeat1, 2, .production_id = 65),
  [31157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [31159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9653),
  [31161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [31163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11721),
  [31165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [31167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12181),
  [31169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17850),
  [31171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12763),
  [31173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [31175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [31177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9070),
  [31179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9245),
  [31181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9243),
  [31183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10537),
  [31185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [31187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [31189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [31191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [31193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [31195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [31197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11431),
  [31199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11026),
  [31201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19358),
  [31203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11443),
  [31205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21718),
  [31207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [31209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8693),
  [31211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [31213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [31215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7158),
  [31217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impent, 1),
  [31219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12152),
  [31221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7656),
  [31223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7663),
  [31225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21647),
  [31227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [31229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 3),
  [31231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21596),
  [31233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [31235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [31237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 3, .production_id = 92),
  [31239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 3, .production_id = 92),
  [31241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11943),
  [31243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21663),
  [31245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [31247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12254),
  [31249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [31251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9712),
  [31253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [31255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expent, 1),
  [31257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21587),
  [31259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [31261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [31263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21522),
  [31265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [31267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [31269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [31271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [31273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 3),
  [31275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14864),
  [31277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13146),
  [31279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 4),
  [31281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [31283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21635),
  [31285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [31287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [31289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9161),
  [31291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10711),
  [31293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18269),
  [31295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [31297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [31299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14835),
  [31301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9155),
  [31303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9494),
  [31305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6496),
  [31307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [31309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [31311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [31313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21489),
  [31315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [31317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quantified_constraint, 3),
  [31319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12215),
  [31321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16825),
  [31323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [31325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8293),
  [31327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [31329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [31331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9580),
  [31333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [31335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14934),
  [31337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14936),
  [31339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11739),
  [31341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ticked_tycon, 3, .production_id = 29),
  [31343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [31345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [31347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [31349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15119),
  [31351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11206),
  [31353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19002),
  [31355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [31357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7606),
  [31359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15068),
  [31361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [31363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11235),
  [31365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19121),
  [31367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [31369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [31371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [31373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [31375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 2),
  [31377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform, 4, .production_id = 89),
  [31379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [31381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [31383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [31385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12975),
  [31387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11193),
  [31389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [31391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [31393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_projection_selector_repeat1, 2, .production_id = 67),
  [31395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9690),
  [31397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9692),
  [31399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21342),
  [31401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [31403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21393),
  [31405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [31407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [31409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12537),
  [31411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform, 2, .production_id = 16),
  [31413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14657),
  [31415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5859),
  [31417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9503),
  [31419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21375),
  [31421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [31423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14630),
  [31425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21326),
  [31427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [31429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11881),
  [31431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [31433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [31435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [31437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11926),
  [31439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 4, .production_id = 87),
  [31441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14994),
  [31443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12562),
  [31445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11788),
  [31447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18059),
  [31449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [31451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [31453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9596),
  [31455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15198),
  [31457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11303),
  [31459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [31461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9733),
  [31463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9732),
  [31465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [31467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8205),
  [31469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8204),
  [31471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9730),
  [31473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11423),
  [31475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [31477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11979),
  [31479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [31481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10070),
  [31483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [31485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11406),
  [31487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [31489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7957),
  [31491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [31493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14646),
  [31495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14642),
  [31497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [31499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8704),
  [31501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [31503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [31505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14617),
  [31507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11397),
  [31509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7797),
  [31511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [31513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8100),
  [31515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15249),
  [31517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [31519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [31521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14552),
  [31523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14550),
  [31525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [31527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [31529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [31531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [31533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [31535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [31537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [31539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11449),
  [31541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [31543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [31545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [31547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15227),
  [31549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14691),
  [31551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7853),
  [31553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [31555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14940),
  [31557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [31559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [31561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [31563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15862),
  [31565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [31567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [31569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6416),
  [31571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9513),
  [31573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [31575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [31577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [31579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [31581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14689),
  [31583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9687),
  [31585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [31587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [31589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [31591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9058),
  [31593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9059),
  [31595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [31597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11462),
  [31599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [31601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [31603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [31605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [31607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [31609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9066),
  [31611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [31613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [31615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [31617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9516),
  [31619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [31621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [31623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [31625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [31627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [31629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [31631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [31633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9688),
  [31635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14602),
  [31637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [31639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14949),
  [31641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [31643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [31645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11925),
  [31647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11924),
  [31649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9083),
  [31651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15332),
  [31653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9086),
  [31655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11291),
  [31657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12217),
  [31659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11900),
  [31661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7890),
  [31663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [31665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15452),
  [31667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15535),
  [31669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [31671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8140),
  [31673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12225),
  [31675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [31677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [31679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12226),
  [31681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [31683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14369),
  [31685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15053),
  [31687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [31689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [31691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7865),
  [31693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [31695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [31697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11529),
  [31699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [31701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10159),
  [31703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11821),
  [31705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [31707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12512),
  [31709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [31711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18918),
  [31713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10285),
  [31715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [31717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11502),
  [31719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11505),
  [31721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9514),
  [31723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [31725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9506),
  [31727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9532),
  [31729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [31731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [31733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9534),
  [31735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15047),
  [31737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9673),
  [31739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14915),
  [31741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [31743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11258),
  [31745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7073),
  [31747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [31749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [31751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [31753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [31755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [31757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9696),
  [31759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12268),
  [31761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12277),
  [31763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7079),
  [31765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7857),
  [31767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20177),
  [31769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9628),
  [31771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [31773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9713),
  [31775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14858),
  [31777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [31779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14916),
  [31781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7616),
  [31783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [31785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [31787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11872),
  [31789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11874),
  [31791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [31793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11711),
  [31795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [31797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [31799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [31801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [31803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [31805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15345),
  [31807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7686),
  [31809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11694),
  [31811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [31813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8312),
  [31815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8272),
  [31817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8280),
  [31819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [31821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12505),
  [31823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15437),
  [31825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [31827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [31829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14624),
  [31831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [31833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [31835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [31837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7725),
  [31839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11647),
  [31841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11662),
  [31843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11643),
  [31845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [31847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [31849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7712),
  [31851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14596),
  [31853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15724),
  [31855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10700),
  [31857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [31859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [31861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15333),
  [31863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [31865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20951),
  [31867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11903),
  [31869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [31871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11660),
  [31873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [31875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14802),
  [31877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9181),
  [31879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11658),
  [31881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11905),
  [31883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14900),
  [31885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [31887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [31889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7702),
  [31891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [31893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7824),
  [31895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7697),
  [31897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [31899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7356),
  [31901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15373),
  [31903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [31905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15400),
  [31907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [31909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [31911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [31913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15306),
  [31915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [31917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [31919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20086),
  [31921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [31923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11603),
  [31925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [31927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [31929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [31931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [31933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15589),
  [31935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15512),
  [31937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15513),
  [31939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [31941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15126),
  [31943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11598),
  [31945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [31947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [31949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [31951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11934),
  [31953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15557),
  [31955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 7, .production_id = 35),
  [31957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [31959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [31961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [31963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [31965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16540),
  [31967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [31969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7393),
  [31971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7348),
  [31973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [31975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6880),
  [31977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [31979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [31981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14129),
  [31983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [31985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14740),
  [31987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14739),
  [31989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15527),
  [31991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [31993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15487),
  [31995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9539),
  [31997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14711),
  [31999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20919),
  [32001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11948),
  [32003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14951),
  [32005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14953),
  [32007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12327),
  [32009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15016),
  [32011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15026),
  [32013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [32015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [32017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [32019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [32021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9312),
  [32023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7646),
  [32025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12482),
  [32027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [32029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 5),
  [32031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15405),
  [32033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15391),
  [32035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14669),
  [32037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11966),
  [32039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [32041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14650),
  [32043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12355),
  [32045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12330),
  [32047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [32049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15310),
  [32051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [32053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12331),
  [32055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14894),
  [32057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [32059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [32061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15990),
  [32063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [32065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15880),
  [32067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12476),
  [32069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [32071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [32073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [32075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12359),
  [32077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20195),
  [32079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20196),
  [32081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15153),
  [32083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [32085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11987),
  [32087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15143),
  [32089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11988),
  [32091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20204),
  [32093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [32095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [32097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [32099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11099),
  [32101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9000),
  [32103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8917),
  [32105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12265),
  [32107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15650),
  [32109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [32111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12356),
  [32113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [32115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [32117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9647),
  [32119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [32121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15522),
  [32123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [32125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8543),
  [32127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8544),
  [32129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20207),
  [32131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [32133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20209),
  [32135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [32137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17596),
  [32139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8549),
  [32141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17597),
  [32143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15411),
  [32145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9444),
  [32147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [32149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7845),
  [32151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [32153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7357),
  [32155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9349),
  [32157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12144),
  [32159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [32161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9237),
  [32163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7642),
  [32165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9241),
  [32167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [32169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [32171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [32173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [32175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [32177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [32179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14840),
  [32181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12080),
  [32183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [32185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12086),
  [32187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14888),
  [32189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [32191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [32193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8261),
  [32195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13929),
  [32197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17707),
  [32199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15582),
  [32201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6911),
  [32203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14122),
  [32205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [32207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [32209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16475),
  [32211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8659),
  [32213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8576),
  [32215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9667),
  [32217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9663),
  [32219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [32221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [32223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [32225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [32227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [32229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6575),
  [32231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [32233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [32235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [32237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8467),
  [32239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [32241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [32243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [32245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12068),
  [32247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13752),
  [32249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8589),
  [32251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7350),
  [32253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14735),
  [32255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [32257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [32259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [32261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12132),
  [32263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9773),
  [32265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20220),
  [32267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20233),
  [32269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20223),
  [32271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15282),
  [32273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12047),
  [32275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [32277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6760),
  [32279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [32281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9841),
  [32283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12629),
  [32285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [32287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11328),
  [32289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12636),
  [32291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [32293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8963),
  [32295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12029),
  [32297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9033),
  [32299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8308),
  [32301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17734),
  [32303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12240),
  [32305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [32307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17735),
  [32309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [32311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [32313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8660),
  [32315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8516),
  [32317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [32319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8600),
  [32321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9022),
  [32323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [32325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11305),
  [32327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [32329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11302),
  [32331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [32333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [32335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11297),
  [32337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [32339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [32341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12740),
  [32343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [32345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12552),
  [32347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [32349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11751),
  [32351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12447),
  [32353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11750),
  [32355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12348),
  [32357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [32359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12354),
  [32361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15885),
  [32363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9707),
  [32365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [32367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [32369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [32371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9073),
  [32373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [32375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [32377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7429),
  [32379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [32381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [32383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [32385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4),
  [32387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [32389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [32391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [32393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [32395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13890),
  [32397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [32399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14632),
  [32401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [32403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7622),
  [32405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [32407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [32409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [32411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [32413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14724),
  [32415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [32417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9607),
  [32419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9605),
  [32421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9603),
  [32423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [32425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [32427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9597),
  [32429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [32431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [32433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8481),
  [32435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [32437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [32439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [32441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 3, .production_id = 97),
  [32443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12584),
  [32445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12596),
  [32447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11735),
  [32449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9490),
  [32451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14674),
  [32453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11733),
  [32455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8964),
  [32457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9459),
  [32459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6665),
  [32461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [32463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [32465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12133),
  [32467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14857),
  [32469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14846),
  [32471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9303),
  [32473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9299),
  [32475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9298),
  [32477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [32479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [32481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9295),
  [32483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [32485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9189),
  [32487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12722),
  [32489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9277),
  [32491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [32493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8992),
  [32495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8989),
  [32497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14030),
  [32499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14545),
  [32501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [32503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12127),
  [32505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14033),
  [32507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [32509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [32511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [32513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [32515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16447),
  [32517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10712),
  [32519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12756),
  [32521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9564),
  [32523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9563),
  [32525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9562),
  [32527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7052),
  [32529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10726),
  [32531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9348),
  [32533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7044),
  [32535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [32537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [32539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [32541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9431),
  [32543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12769),
  [32545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18681),
  [32547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [32549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [32551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9062),
  [32553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [32555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [32557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [32559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11760),
  [32561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9772),
  [32563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15939),
  [32565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15646),
  [32567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15894),
  [32569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8736),
  [32571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14089),
  [32573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [32575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15801),
  [32577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15776),
  [32579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15774),
  [32581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [32583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15744),
  [32585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [32587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [32589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15627),
  [32591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [32593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10436),
  [32595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [32597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [32599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [32601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14558),
  [32603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13647),
  [32605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14688),
  [32607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17728),
  [32609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17699),
  [32611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17772),
  [32613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14694),
  [32615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12165),
  [32617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15987),
  [32619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17749),
  [32621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17750),
  [32623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17757),
  [32625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12168),
  [32627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17766),
  [32629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13629),
  [32631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [32633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [32635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17714),
  [32637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16001),
  [32639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16010),
  [32641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14720),
  [32643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13587),
  [32645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7666),
  [32647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9071),
  [32649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [32651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 2),
  [32653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [32655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [32657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [32659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8806),
  [32661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6092),
  [32663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 8, .production_id = 35),
  [32665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [32667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [32669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [32671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8535),
  [32673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [32675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8843),
  [32677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14723),
  [32679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6395),
  [32681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9424),
  [32683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11673),
  [32685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [32687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11671),
  [32689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [32691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [32693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11630),
  [32695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [32697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9755),
  [32699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9328),
  [32701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [32703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [32705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [32707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9422),
  [32709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9421),
  [32711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [32713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [32715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [32717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [32719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15270),
  [32721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [32723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9461),
  [32725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9526),
  [32727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [32729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12189),
  [32731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [32733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12191),
  [32735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [32737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [32739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [32741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14612),
  [32743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14611),
  [32745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14808),
  [32747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14824),
  [32749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [32751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [32753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6249),
  [32755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9040),
  [32757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [32759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [32761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [32763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [32765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [32767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [32769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10415),
  [32771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [32773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [32775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12195),
  [32777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15234),
  [32779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [32781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6466),
  [32783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [32785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [32787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9808),
  [32789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12389),
  [32791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16227),
  [32793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [32795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [32797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 6, .production_id = 35),
  [32799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16240),
  [32801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9811),
  [32803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [32805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [32807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [32809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15252),
  [32811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [32813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [32815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11557),
  [32817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [32819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [32821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17884),
  [32823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [32825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [32827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [32829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10729),
  [32831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10727),
  [32833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8553),
  [32835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [32837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7821),
  [32839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11565),
  [32841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [32843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14171),
  [32845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7817),
  [32847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [32849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [32851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [32853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [32855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12532),
  [32857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12531),
  [32859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [32861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [32863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [32865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13569),
  [32867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9320),
  [32869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8920),
  [32871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10722),
  [32873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [32875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13747),
  [32877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8030),
  [32879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9364),
  [32881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8919),
  [32883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12216),
  [32885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15320),
  [32887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [32889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [32891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17110),
  [32893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14693),
  [32895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [32897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [32899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [32901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9356),
  [32903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9404),
  [32905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [32907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [32909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [32911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12485),
  [32913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12475),
  [32915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9330),
  [32917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [32919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12219),
  [32921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [32923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7970),
  [32925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10683),
  [32927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [32929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [32931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10630),
  [32933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10650),
  [32935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15120),
  [32937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [32939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [32941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [32943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [32945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [32947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16422),
  [32949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8816),
  [32951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [32953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9388),
  [32955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [32957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18024),
  [32959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21162),
  [32961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21200),
  [32963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [32965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12440),
  [32967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9802),
  [32969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14902),
  [32971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9798),
  [32973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [32975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14132),
  [32977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [32979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10642),
  [32981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9410),
  [32983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10645),
  [32985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10169),
  [32987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8712),
  [32989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [32991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14400),
  [32993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [32995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8022),
  [32997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [32999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12372),
  [33001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8254),
  [33003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13663),
  [33005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20753),
  [33007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [33009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9370),
  [33011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [33013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12119),
  [33015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [33017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [33019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [33021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9659),
  [33023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16516),
  [33025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9392),
  [33027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15273),
  [33029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9211),
  [33031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [33033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [33035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [33037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [33039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10652),
  [33041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [33043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [33045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15077),
  [33047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8894),
  [33049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11787),
  [33051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18143),
  [33053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8897),
  [33055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11798),
  [33057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [33059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14468),
  [33061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [33063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11791),
  [33065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10297),
  [33067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9123),
  [33069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [33071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10917),
  [33073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [33075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10945),
  [33077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [33079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [33081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11619),
  [33083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12349),
  [33085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [33087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 10, .production_id = 35),
  [33089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [33091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [33093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [33095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [33097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10678),
  [33099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11794),
  [33101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11795),
  [33103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8739),
  [33105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18223),
  [33107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21114),
  [33109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11884),
  [33111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [33113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10943),
  [33115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11931),
  [33117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10946),
  [33119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [33121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [33123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10491),
  [33125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [33127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14647),
  [33129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8915),
  [33131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [33133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [33135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [33137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [33139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [33141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15518),
  [33143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [33145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18307),
  [33147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [33149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8774),
  [33151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11612),
  [33153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8778),
  [33155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13101),
  [33157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12514),
  [33159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12019),
  [33161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [33163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [33165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10986),
  [33167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [33169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8142),
  [33171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7806),
  [33173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [33175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11609),
  [33177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [33179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12062),
  [33181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7115),
  [33183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7110),
  [33185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5942),
  [33187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18401),
  [33189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [33191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11593),
  [33193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13490),
  [33195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12494),
  [33197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 9, .production_id = 35),
  [33199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [33201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9137),
  [33203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 5, .production_id = 35),
  [33205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11969),
  [33207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [33209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [33211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13066),
  [33213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [33215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13065),
  [33217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [33219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18498),
  [33221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11862),
  [33223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11865),
  [33225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [33227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [33229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12474),
  [33231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8324),
  [33233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11024),
  [33235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [33237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7954),
  [33239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [33241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10294),
  [33243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10949),
  [33245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7937),
  [33247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [33249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [33251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8503),
  [33253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18614),
  [33255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9217),
  [33257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7696),
  [33259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8641),
  [33261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10980),
  [33263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12211),
  [33265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [33267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11064),
  [33269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7987),
  [33271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 3),
  [33273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20927),
  [33275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [33277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [33279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18724),
  [33281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11586),
  [33283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11585),
  [33285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [33287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [33289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11141),
  [33291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11147),
  [33293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [33295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [33297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [33299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12452),
  [33301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12449),
  [33303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [33305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [33307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18844),
  [33309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [33311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [33313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10932),
  [33315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [33317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [33319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [33321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12112),
  [33323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16489),
  [33325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11151),
  [33327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [33329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11148),
  [33331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [33333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [33335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19042),
  [33337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [33339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11781),
  [33341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11770),
  [33343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12365),
  [33345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12969),
  [33347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [33349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [33351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [33353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [33355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7998),
  [33357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [33359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8956),
  [33361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19214),
  [33363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [33365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12963),
  [33367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [33369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12061),
  [33371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12045),
  [33373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11122),
  [33375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14874),
  [33377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12955),
  [33379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12409),
  [33381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12325),
  [33383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [33385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [33387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19407),
  [33389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [33391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [33393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [33395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [33397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8497),
  [33399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [33401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8041),
  [33403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11613),
  [33405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [33407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8042),
  [33409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [33411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [33413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19594),
  [33415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [33417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [33419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [33421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9847),
  [33423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [33425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11083),
  [33427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [33429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11758),
  [33431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11975),
  [33433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9521),
  [33435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13143),
  [33437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13161),
  [33439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12429),
  [33441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19767),
  [33443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [33445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11070),
  [33447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6225),
  [33449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12445),
  [33451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [33453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8952),
  [33455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15585),
  [33457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [33459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [33461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [33463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [33465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [33467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15649),
  [33469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [33471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17692),
  [33473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19929),
  [33475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14452),
  [33477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15500),
  [33479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9533),
  [33481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11839),
  [33483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [33485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14366),
  [33487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7858),
  [33489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [33491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7855),
  [33493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20146),
  [33495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [33497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10536),
  [33499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [33501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [33503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [33505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [33507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12795),
  [33509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11626),
  [33511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19966),
  [33513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [33515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12780),
  [33517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12513),
  [33519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12526),
  [33521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17595),
  [33523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [33525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [33527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [33529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12366),
  [33531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [33533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [33535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15312),
  [33537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7046),
  [33539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12012),
  [33541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19616),
  [33543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12947),
  [33545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12951),
  [33547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12004),
  [33549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [33551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12968),
  [33553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10485),
  [33555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10498),
  [33557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [33559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8554),
  [33561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7772),
  [33563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [33565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12374),
  [33567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18865),
  [33569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19391),
  [33571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14310),
  [33573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14248),
  [33575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11773),
  [33577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11775),
  [33579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12651),
  [33581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12693),
  [33583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13993),
  [33585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [33587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13571),
  [33589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19219),
  [33591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [33593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [33595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [33597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [33599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12683),
  [33601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12992),
  [33603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7615),
  [33605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8015),
  [33607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [33609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12681),
  [33611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [33613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [33615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12705),
  [33617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19071),
  [33619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [33621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [33623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [33625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16184),
  [33627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [33629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11653),
  [33631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [33633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14138),
  [33635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18929),
  [33637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [33639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [33641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17421),
  [33643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [33645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [33647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12758),
  [33649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17417),
  [33651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [33653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [33655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [33657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18765),
  [33659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [33661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14134),
  [33663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11639),
  [33665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [33667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12408),
  [33669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10881),
  [33671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16074),
  [33673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12410),
  [33675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7931),
  [33677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18626),
  [33679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [33681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13773),
  [33683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [33685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10884),
  [33687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7671),
  [33689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [33691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [33693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8478),
  [33695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [33697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [33699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13002),
  [33701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18509),
  [33703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [33705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [33707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8831),
  [33709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16015),
  [33711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16011),
  [33713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [33715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [33717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12988),
  [33719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18374),
  [33721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13325),
  [33723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15537),
  [33725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14234),
  [33727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13797),
  [33729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15562),
  [33731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11618),
  [33733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10818),
  [33735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [33737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [33739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18254),
  [33741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [33743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11602),
  [33745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [33747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [33749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [33751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10113),
  [33753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10126),
  [33755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12525),
  [33757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [33759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [33761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18142),
  [33763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12616),
  [33765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [33767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14344),
  [33769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9821),
  [33771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [33773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [33775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [33777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8251),
  [33779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6995),
  [33781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [33783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18038),
  [33785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [33787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [33789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14258),
  [33791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [33793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11877),
  [33795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11492),
  [33797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13445),
  [33799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9346),
  [33801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10836),
  [33803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [33805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10848),
  [33807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17950),
  [33809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [33811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [33813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [33815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10838),
  [33817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19721),
  [33819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8141),
  [33821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [33823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8744),
  [33825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8070),
  [33827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [33829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [33831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15748),
  [33833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17866),
  [33835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10846),
  [33837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [33839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [33841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15641),
  [33843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15054),
  [33845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [33847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15061),
  [33849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [33851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15736),
  [33853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [33855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [33857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17947),
  [33859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [33861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13746),
  [33863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [33865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14470),
  [33867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15726),
  [33869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14397),
  [33871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [33873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [33875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [33877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18066),
  [33879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [33881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8132),
  [33883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15546),
  [33885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14810),
  [33887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [33889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [33891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8521),
  [33893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [33895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18185),
  [33897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [33899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [33901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9621),
  [33903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [33905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [33907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [33909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9825),
  [33911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [33913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [33915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18304),
  [33917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [33919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [33921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10811),
  [33923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [33925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15610),
  [33927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20063),
  [33929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [33931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [33933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [33935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [33937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [33939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18423),
  [33941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9828),
  [33943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9829),
  [33945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10809),
  [33947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15676),
  [33949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14051),
  [33951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [33953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10478),
  [33955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8950),
  [33957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12875),
  [33959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [33961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18542),
  [33963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [33965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [33967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [33969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [33971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [33973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20703),
  [33975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [33977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [33979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9129),
  [33981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18661),
  [33983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [33985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [33987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [33989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8507),
  [33991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [33993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13471),
  [33995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9968),
  [33997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [33999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18780),
  [34001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12104),
  [34003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [34005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [34007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13675),
  [34009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [34011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10611),
  [34013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13664),
  [34015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10612),
  [34017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [34019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10806),
  [34021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [34023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18899),
  [34025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10798),
  [34027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [34029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10075),
  [34031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12105),
  [34033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [34035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12106),
  [34037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10076),
  [34039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10542),
  [34041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14629),
  [34043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19018),
  [34045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20058),
  [34047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [34049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10506),
  [34051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13666),
  [34053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20924),
  [34055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9290),
  [34057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14044),
  [34059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19137),
  [34061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [34063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [34065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14154),
  [34067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [34069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [34071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10138),
  [34073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [34075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [34077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19256),
  [34079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8203),
  [34081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19493),
  [34083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [34085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10608),
  [34087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19442),
  [34089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9332),
  [34091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [34093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19370),
  [34095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [34097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19440),
  [34099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10613),
  [34101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9684),
  [34103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [34105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19467),
  [34107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [34109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9863),
  [34111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19500),
  [34113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [34115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19532),
  [34117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14512),
  [34119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [34121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19562),
  [34123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [34125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [34127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19592),
  [34129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [34131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [34133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19622),
  [34135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [34137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7647),
  [34139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19652),
  [34141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16279),
  [34143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19682),
  [34145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [34147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [34149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19712),
  [34151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [34153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7995),
  [34155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19742),
  [34157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13841),
  [34159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15070),
  [34161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19772),
  [34163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10587),
  [34165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [34167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19802),
  [34169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [34171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12734),
  [34173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19832),
  [34175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [34177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19862),
  [34179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [34181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19892),
  [34183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [34185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [34187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19922),
  [34189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14869),
  [34191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19952),
  [34193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9589),
  [34195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14265),
  [34197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19982),
  [34199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8011),
  [34201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [34203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20011),
  [34205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10589),
  [34207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12786),
  [34209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20039),
  [34211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [34213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12710),
  [34215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20067),
  [34217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12103),
  [34219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16464),
  [34221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20095),
  [34223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16466),
  [34225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13881),
  [34227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20123),
  [34229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13321),
  [34231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10609),
  [34233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20151),
  [34235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [34237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20179),
  [34239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [34241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [34243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20168),
  [34245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14861),
  [34247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20140),
  [34249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9185),
  [34251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14128),
  [34253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20120),
  [34255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13389),
  [34257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [34259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20097),
  [34261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9159),
  [34263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8722),
  [34265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20080),
  [34267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6188),
  [34269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20062),
  [34271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [34273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [34275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20037),
  [34277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12094),
  [34279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12655),
  [34281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20013),
  [34283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10460),
  [34285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10550),
  [34287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19986),
  [34289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [34291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19968),
  [34293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13724),
  [34295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [34297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19938),
  [34299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19924),
  [34301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19901),
  [34303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16712),
  [34305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [34307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19876),
  [34309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [34311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12087),
  [34313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19857),
  [34315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10298),
  [34317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14963),
  [34319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19836),
  [34321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [34323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14962),
  [34325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19819),
  [34327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12560),
  [34329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10887),
  [34331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19800),
  [34333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19786),
  [34335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12628),
  [34337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19766),
  [34339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12604),
  [34341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19746),
  [34343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [34345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10577),
  [34347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19728),
  [34349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19710),
  [34351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15637),
  [34353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13318),
  [34355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19690),
  [34357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18530),
  [34359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19670),
  [34361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19651),
  [34363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12353),
  [34365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19635),
  [34367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12351),
  [34369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9771),
  [34371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19617),
  [34373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [34375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [34377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19591),
  [34379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18366),
  [34381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [34383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19577),
  [34385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14884),
  [34387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12581),
  [34389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19556),
  [34391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12454),
  [34393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19535),
  [34395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19513),
  [34397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [34399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [34401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19492),
  [34403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12576),
  [34405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13788),
  [34407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19466),
  [34409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [34411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 2),
  [34413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19449),
  [34415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17318),
  [34417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16179),
  [34419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19428),
  [34421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8605),
  [34423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19406),
  [34425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [34427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8682),
  [34429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19384),
  [34431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17372),
  [34433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19360),
  [34435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12814),
  [34437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12821),
  [34439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19340),
  [34441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19325),
  [34443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [34445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17408),
  [34447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19305),
  [34449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [34451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19279),
  [34453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [34455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [34457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19255),
  [34459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [34461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12857),
  [34463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19234),
  [34465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19212),
  [34467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14966),
  [34469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [34471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19198),
  [34473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [34475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19171),
  [34477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19149),
  [34479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15840),
  [34481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [34483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19136),
  [34485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8934),
  [34487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19118),
  [34489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8176),
  [34491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13982),
  [34493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19100),
  [34495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15392),
  [34497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [34499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19082),
  [34501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [34503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [34505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19058),
  [34507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6869),
  [34509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8344),
  [34511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19035),
  [34513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [34515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12849),
  [34517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19012),
  [34519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [34521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12842),
  [34523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18981),
  [34525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [34527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [34529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18972),
  [34531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [34533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18947),
  [34535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8969),
  [34537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18915),
  [34539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [34541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [34543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18891),
  [34545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8349),
  [34547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [34549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18863),
  [34551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16006),
  [34553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [34555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18843),
  [34557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [34559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18827),
  [34561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13026),
  [34563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18808),
  [34565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [34567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [34569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18788),
  [34571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8082),
  [34573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [34575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [34577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12582),
  [34579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15621),
  [34581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13051),
  [34583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [34585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [34587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14866),
  [34589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12583),
  [34591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8014),
  [34593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8538),
  [34595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13262),
  [34597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13200),
  [34599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14848),
  [34601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [34603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15005),
  [34605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8337),
  [34607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [34609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [34611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [34613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14839),
  [34615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8495),
  [34617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [34619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8102),
  [34621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15048),
  [34623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [34625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [34627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [34629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8154),
  [34631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13265),
  [34633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [34635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15157),
  [34637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [34639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [34641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [34643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15186),
  [34645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [34647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14748),
  [34649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16302),
  [34651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13230),
  [34653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [34655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [34657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14998),
  [34659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [34661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [34663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7968),
  [34665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [34667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [34669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [34671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [34673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [34675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [34677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [34679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [34681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [34683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8029),
  [34685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [34687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [34689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12263),
  [34691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18113),
  [34693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [34695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6648),
  [34697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [34699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [34701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7625),
  [34703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12264),
  [34705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [34707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [34709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [34711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10351),
  [34713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [34715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7611),
  [34717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [34719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12393),
  [34721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [34723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [34725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [34727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17357),
  [34729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9232),
  [34731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [34733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [34735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [34737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9800),
  [34739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [34741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [34743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [34745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 1, .production_id = 6),
  [34747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [34749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [34751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [34753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9227),
  [34755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [34757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [34759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [34761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [34763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [34765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [34767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [34769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7065),
  [34771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11464),
  [34773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [34775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [34777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8040),
  [34779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9105),
  [34781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [34783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13991),
  [34785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [34787] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [34789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [34791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13220),
  [34793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9407),
  [34795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [34797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12885),
  [34799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14747),
  [34801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [34803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12344),
  [34805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15882),
  [34807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [34809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [34811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [34813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10852),
  [34815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13933),
  [34817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12976),
  [34819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14006),
  [34821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [34823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [34825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13088),
  [34827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9007),
  [34829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13169),
  [34831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [34833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12282),
  [34835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [34837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [34839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13196),
  [34841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9583),
  [34843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14878),
  [34845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8980),
  [34847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [34849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12285),
  [34851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9812),
  [34853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14133),
  [34855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [34857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8966),
  [34859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [34861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9138),
  [34863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [34865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [34867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [34869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [34871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9550),
  [34873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [34875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [34877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [34879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [34881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6826),
  [34883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [34885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9541),
  [34887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [34889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [34891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16709),
  [34893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12302),
  [34895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [34897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [34899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8047),
  [34901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [34903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [34905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [34907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [34909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13054),
  [34911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9816),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__layout_semicolon = 0,
  ts_external_token__layout_start = 1,
  ts_external_token__layout_end = 2,
  ts_external_token__dot = 3,
  ts_external_token__arith_dotdot = 4,
  ts_external_token_where = 5,
  ts_external_token__splice_dollar = 6,
  ts_external_token__varsym = 7,
  ts_external_token__consym = 8,
  ts_external_token__tyconsym = 9,
  ts_external_token_comment = 10,
  ts_external_token_cpp = 11,
  ts_external_token_comma = 12,
  ts_external_token_quasiquote_start = 13,
  ts_external_token_quasiquote_bar = 14,
  ts_external_token_quasiquote_body = 15,
  ts_external_token__strict = 16,
  ts_external_token__lazy = 17,
  ts_external_token__unboxed_close = 18,
  ts_external_token_PIPE = 19,
  ts_external_token_in = 20,
  ts_external_token__token1 = 21,
  ts_external_token_empty_file = 22,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__layout_semicolon] = sym__layout_semicolon,
  [ts_external_token__layout_start] = sym__layout_start,
  [ts_external_token__layout_end] = sym__layout_end,
  [ts_external_token__dot] = sym__dot,
  [ts_external_token__arith_dotdot] = sym__arith_dotdot,
  [ts_external_token_where] = sym_where,
  [ts_external_token__splice_dollar] = sym__splice_dollar,
  [ts_external_token__varsym] = sym__varsym,
  [ts_external_token__consym] = sym__consym,
  [ts_external_token__tyconsym] = sym__tyconsym,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_cpp] = sym_cpp,
  [ts_external_token_comma] = sym_comma,
  [ts_external_token_quasiquote_start] = sym_quasiquote_start,
  [ts_external_token_quasiquote_bar] = sym_quasiquote_bar,
  [ts_external_token_quasiquote_body] = sym_quasiquote_body,
  [ts_external_token__strict] = sym__strict,
  [ts_external_token__lazy] = sym__lazy,
  [ts_external_token__unboxed_close] = sym__unboxed_close,
  [ts_external_token_PIPE] = anon_sym_PIPE,
  [ts_external_token_in] = anon_sym_in,
  [ts_external_token__token1] = aux_sym__token1,
  [ts_external_token_empty_file] = sym_empty_file,
};

static const bool ts_external_scanner_states[444][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_quasiquote_bar] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
    [ts_external_token_empty_file] = true,
  },
  [2] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
    [ts_external_token_empty_file] = true,
  },
  [3] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [4] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [5] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [6] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [7] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [8] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [9] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [10] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [11] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [12] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [13] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [14] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [15] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [16] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [17] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [18] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [19] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [20] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [21] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [22] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [23] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [24] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [25] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [26] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [27] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [28] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [29] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [30] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [31] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [32] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [33] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [34] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [35] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [36] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [37] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [38] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [39] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [40] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [41] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [42] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [43] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [44] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [45] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [46] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [47] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [48] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [49] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [50] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [51] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [52] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [53] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [54] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [55] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [56] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [57] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [58] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [59] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [60] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [61] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [62] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [63] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [64] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [65] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [66] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [67] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [68] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [69] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [70] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [71] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [72] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [73] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [74] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [75] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [76] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [77] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [78] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [79] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [80] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [81] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [82] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [83] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [84] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [85] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [86] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [87] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [88] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [89] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [90] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [91] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [92] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [93] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [94] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [95] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [96] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [97] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [98] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [99] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [100] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [101] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [102] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [103] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [104] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [105] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [106] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [107] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [108] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [109] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [110] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [111] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [112] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [113] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [114] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [115] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [116] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [117] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [118] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [119] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [120] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [121] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [122] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [123] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [124] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [125] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [126] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [127] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [128] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [129] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [130] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [131] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [132] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [133] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [134] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [135] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [136] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [137] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [138] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [139] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [140] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [141] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [142] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [143] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [144] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [145] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [146] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [147] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [148] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [149] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [150] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [151] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [152] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [153] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [154] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [155] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [156] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [157] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [158] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [159] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [160] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [161] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [162] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [163] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [164] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [165] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [166] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [167] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [168] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [169] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [170] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [171] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [172] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [173] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [174] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [175] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [176] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [177] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [178] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [179] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [180] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [181] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [182] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [183] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [184] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [185] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [186] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [187] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [188] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [189] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [190] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [191] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [192] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [193] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [194] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [195] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [196] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [197] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [198] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [199] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [200] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [201] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [202] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [203] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [204] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [205] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [206] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [207] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [208] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [209] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [210] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [211] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [212] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [213] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [214] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [215] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [216] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [217] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [218] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [219] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [220] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [221] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [222] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [223] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [224] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [225] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [226] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [227] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [228] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [229] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [230] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [231] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [232] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [233] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [234] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [235] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [236] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [237] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [238] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [239] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [240] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [241] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [242] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [243] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [244] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [245] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [246] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [247] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [248] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [249] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [250] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [251] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [252] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [253] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [254] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [255] = {
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [256] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [257] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [258] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [259] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [260] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [261] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [262] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [263] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [264] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [265] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [266] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [267] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [268] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [269] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [270] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [271] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [272] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [273] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [274] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [275] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [276] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [277] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [278] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [279] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [280] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [281] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [282] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [283] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [284] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [285] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [286] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [287] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [288] = {
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [289] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [290] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [291] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [292] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [293] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [294] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [295] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [296] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [297] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [298] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [299] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [300] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [301] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [302] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [303] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [304] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [305] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [306] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [307] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [308] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [309] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [310] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [311] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [312] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [313] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [314] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [315] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [316] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [317] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [318] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [319] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [320] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [321] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [322] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [323] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [324] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [325] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [326] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [327] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [328] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [329] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [330] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [331] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [332] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [333] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [334] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [335] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [336] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [337] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [338] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [339] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [340] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [341] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [342] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [343] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [344] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [345] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [346] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [347] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [348] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [349] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [350] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [351] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [352] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [353] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [354] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [355] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [356] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [357] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [358] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [359] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [360] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [361] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [362] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [363] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [364] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [365] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [366] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [367] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [368] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [369] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [370] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [371] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [372] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [373] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [374] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [375] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [376] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [377] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [378] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [379] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [380] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [381] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [382] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [383] = {
    [ts_external_token__varsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [384] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [385] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [386] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [387] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [388] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [389] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [390] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [391] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [392] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [393] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [394] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [395] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [396] = {
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [397] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [398] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [399] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [400] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [401] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [402] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [403] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [404] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [405] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [406] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [407] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [408] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [409] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [410] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [411] = {
    [ts_external_token__varsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [412] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [413] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [414] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [415] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_bar] = true,
    [ts_external_token__token1] = true,
  },
  [416] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [417] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [418] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [419] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [420] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [421] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [422] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [423] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [424] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [425] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [426] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [427] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [428] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [429] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [430] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [431] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [432] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [433] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [434] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [435] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [436] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [437] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [438] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [439] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [440] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__token1] = true,
  },
  [441] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [442] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [443] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_haskell_external_scanner_create(void);
void tree_sitter_haskell_external_scanner_destroy(void *);
bool tree_sitter_haskell_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_haskell_external_scanner_serialize(void *, char *);
void tree_sitter_haskell_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_haskell(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__varid,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_haskell_external_scanner_create,
      tree_sitter_haskell_external_scanner_destroy,
      tree_sitter_haskell_external_scanner_scan,
      tree_sitter_haskell_external_scanner_serialize,
      tree_sitter_haskell_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
